Weeds
=====

What is Weeds?
--------------

Weeds is a package for the Gildas radioastronomy software which is
intented to ease the data reduction of spectral surveys or spectral
lines observations with large bandwidths. Weeds provides a command to
identify lines on a spectrum using VO-compliant spectrocopic
databases, which are accessed on-line using the SLAP protocol. In
addition, Weeds provides a command to perform a simple modelling of
the observed spectra, under the assumption of local thermodynamic
equilibrium. Together with the catalog query command, the modelling
tool allows to efficiently identify line on crowded spectrum, where
the line overlap can be important. Weeds development was inspired by
other packages, such as XCLASS and CASSIS. Both Weeds and XCLASS are
extensions of the widely used CLASS spectra reduction software, which
is part of GILDAS; this allows to reduce and analyze spectral surveys
within the same environment. However, unlike XCLASS, Weeds is
distributed with GILDAS as a contributed package, and it uses the most
recent CLASS version (CLASS90). Another difference between Weeds and
both XCLASS and CASSIS is that Weeds access to spectral catalogs
on-line. Consequently any changes in these catalogs (e.g. line
additions) are readily available in Weeds. Nevertheless, Weeds can
make a local copy of a spectral line catalog, for offline
searches. This is useful when you want to use Weeds with no (or a
slow) internet connection. All this make Weeds a lightweight,
easy-to-install and efficient alternative to other spectral line
analysis packages.

Installation
------------

Weeds is included in the standard Gildas distribution. It is installed
automatically if you have Python 2.6 and Numpy installed on your
computer.

Documentation
-------------

Weeds comes with a documentation manual. The LaTeX source of the
manual can be found in the doc/ directory.

Reporting bugs
--------------

A list of known bugs can be found in the BUGS file. If you find a bug
which is not listed in these files please report it to
<gildas@iram.fr>

module cubeadm_opened_types
  use cubetools_parameters
  use cubelist_types
  use cubedag_node_class
  use cubedag_link_type
  use cubeadm_messaging
  !---------------------------------------------------------------------
  ! Support types registering cubes opened (in/out) opened by a command
  !---------------------------------------------------------------------
  !
  public :: cubeadm_opened_t
  public :: cubeadm_opened_ptr
  public :: cubeadm_opened_list_t
  private
  !
  type, extends(list_object_t) :: cubeadm_opened_t
    integer(kind=code_k)                  :: status
    integer(kind=code_k)                  :: action
    character(len=argu_l)                 :: userid
    class(cubedag_node_object_t), pointer :: dno
    class(list_object_t),         pointer :: arg_or_prod
  contains
    procedure, public :: final => cubeadm_opened_final
  end type cubeadm_opened_t

  type, extends(list_t) :: cubeadm_opened_list_t
  contains
    procedure, public :: unlink  => cubeadm_opened_list_pop
    procedure, public :: to_link => cubeadm_opened_list_to_link
  end type cubeadm_opened_list_t

contains

  function cubeadm_opened_ptr(lot,error)
    !-------------------------------------------------------------------
    ! Check if the input type is a 'cubeadm_opened_t', and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    type(cubeadm_opened_t), pointer :: cubeadm_opened_ptr  ! Function value on return
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPENED>PTR'
    !
    select type(lot)
    type is (cubeadm_opened_t)
      cubeadm_opened_ptr => lot
    class default
      cubeadm_opened_ptr => null()
      call cubeadm_message(seve%e,rname,'Internal error: object is not a cubeadm_opened_t')
      error = .true.
      return
    end select
  end function cubeadm_opened_ptr

  subroutine cubeadm_opened_final(obj,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(cubeadm_opened_t), intent(inout) :: obj
    logical,                 intent(inout) :: error
    !
  end subroutine cubeadm_opened_final

  subroutine cubeadm_opened_list_pop(op,dno,error)
    !-------------------------------------------------------------------
    ! Pop-out from the list the cubeadm_opened_t referencing the given
    ! dno
    !-------------------------------------------------------------------
    class(cubeadm_opened_list_t), intent(inout) :: op
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    !
    integer(kind=list_k) :: iopen,ipop
    type(cubeadm_opened_t), pointer :: obj
    !
    ipop = 0
    do iopen=1,op%n
      obj => cubeadm_opened_ptr(op%list(iopen)%p,error)
      if (error)  return
      if (associated(obj%dno,dno)) then
        ipop = iopen
        exit
      endif
    enddo
    !
    if (ipop.gt.0) then
      call op%pop(ipop,error)
      if (error)  return
    endif
  end subroutine cubeadm_opened_list_pop

  subroutine cubeadm_opened_list_to_link(op,optx,error)
    !-------------------------------------------------------------------
    ! Convert a cubeadm_opened_list_t to a cubedag_link_t
    !-------------------------------------------------------------------
    class(cubeadm_opened_list_t), intent(in)    :: op
    type(cubedag_link_t),         intent(inout) :: optx
    logical,                      intent(inout) :: error
    !
    type(cubeadm_opened_t), pointer :: opened
    integer(kind=list_k) :: iopen
    !
    call optx%reallocate(op%n,error)
    if (error)  return
    do iopen=1,op%n
      opened => cubeadm_opened_ptr(op%list(iopen)%p,error)
      if (error)  return
      call optx%associate(opened%dno,error)
      if (error)  return
    enddo
    optx%n = op%n
  end subroutine cubeadm_opened_list_to_link

end module cubeadm_opened_types

!c**********************************************************************
!       Takes the file  wk%%%%v%.dat  and makes the plot of the
!       projects  schedule  of two weeks and produces   output files
!       wk%%%%v%.out that contains the number of hours for each
!       project and a postscript file wk%%%%v%%.ps
!       Unix version Dec-96  M.Ruiz
!       Modified Nov-97  M.Ruiz (requested by MG)
!       Modified Mar-98  M.Ruiz (requested by CT)
!       Modified Apr-98  M.Ruiz (requested by CT)
!       /mrt-ux1_users/mrt/ruiz/biweek/biweek.f is this file
!       /thum/sched/progs/bw_01.f        ct modifications 08-apr-1998
!       bw_02.f version No. in fn; LST lines fixed.       mr 20-apr-1998
!       bw_04.f includind four-week option                mr 24-oct-1998
!       different file name for four-week.ps              ct 04-nov-1998
!       new information: sun rise and sun set             mr 02-aug-1999
!       new information: comments of projects             mr 28-aug-1999
!       modifed hsidnew: LST lines do not cross frame     ct 16-oct-1999
!       modification to reset comments                    mr 29-dec-1999
!       small modification to reset comments              mr 20-feb-2000
!       comments written left justified                   ct 20-feb-2000
!       increase no of projects 40->50                    ct 01-mar-2000
!       introduced a space before each / in greg commands ct 14-apr-2000
!       and remove .out file before creating a new one
!       new mappinf features                              mr aug-00
!       keyword=kw001 gifcoor get coordinates             mr aug-00
!       keyword=kw002 makehtml1 make page html            mr aug-00
!       keyword=kw003 makemap   make map for gif          mr aug-00
!       keyword=kw004 makehtml2 make page html            mr aug-00
!       keyword=kw005 convert file ps to gif              mr aug-00
!       comments coordinates in day, hour
!       (now again in x(0..24) y(1..15)                   mr jul-01
!       option to create only some of the html files      mr jul-01
!       compatible with linux                             mr aug-01
!       test to create html files                         mr apr-02
!       correction in version number                      mr may-02
!       error in second file name (4-week)                ct jun-02
!       change in lines width                             mr oct-02
!       change in the name of projects html files         mr oct-02
!       add copy to web page (failed)                     ct jan-03
!       ALL BACKSLASHES-> CHAR(XY)                        hw apr-03
!       reorganization of output to .out file             mr may-03
!       J.Pety version, linked to DELL GILDAS by AWS      as 10-may-04
! sched_03 master on laptop, pety/thum, exec mved to progs   08-jun-04
!       change in coord. when changing dev ps to dev eps  mr 11-jun-04
!       href to DB written html files,mod. yoff           ct 24-Jun-04
!***********************************************************************
!       change of .dat format: proposal part as second column  CT Nov-03
!       moved to RedHat 9 Gildas lib, Fort compiler            jp Feb-05
!       moved directory of html bg files                       ct Feb-05
!       added sched unit to html file names                    ct Jul 05
!       link to HTL files: year No. if sched starts in Dec     ct Nov 05
!       sched_units now have 2 digits                          ct Dec 05
!       removed hardcopy/plot                                  ct Jul 06
!       back to ps file (can now be generated again by GILDAS  ct Jul 06
!       copy to ps file to  thum/www/sched/07                  ct Aug 07
!       some modification for leap year                        mr Nov 08
!       mow copy ps files to www/sched/09                      ct Nov 08
!c**********************************************************************
!
module sched30m_common
  !---------------------------------------------------------------------
  ! Support module for commands SCHEDULE and HARDCOPY
  ! Quick solution for variables shared by both commands.
  !---------------------------------------------------------------------
  character(len=20) :: fil,fil3,fil4,fil5,fil6
  logical :: four
  !
end module sched30m_common
!
subroutine sched30m_schedule_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use sched30m_interfaces, except_this=>sched30m_schedule_command
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    SCHEDULE File1 [File2]
  ! Decode the command line
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SCHEDULE'
  logical :: four
  character(len=36) :: file1,file2
  integer(kind=4) :: nc
  !
  four = sic_present(0,2)
  !
  call sic_ch(line,0,1,file1,nc,.true.,error)
  if (error)  return
  !
  call sic_ch(line,0,2,file2,nc,four,error)
  if (error)  return
  !
  call sched30m_schedule(four,file1,file2,error)
  if (error)  return
  !
end subroutine sched30m_schedule_command
!
subroutine sched30m_schedule(infour,file1,file2,error)
  use gildas_def
  use gbl_message
  use sched30m_interfaces, except_this=>sched30m_schedule
  use sched30m_common
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    SCHEDULE File1 [File2]
  ! Do the actual work
  !---------------------------------------------------------------------
  logical,          intent(in)    :: infour
  character(len=*), intent(in)    :: file1
  character(len=*), intent(in)    :: file2
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SCHEDULE'
  logical    recmark(15,6), found(6), prueba, lsummer,  &
              first, second, fy, algunos, splitblock
  character  name*2,upline*30,mres1*7,p(50)*15,  &
              weeks*5,texto*38,proj(50)*15,dat*11,fil2*20,  &
              author(50)*22, day(16)*2, texto1*20, ans*1,mres2*7,  &
              month(12)*3, cfyear*4,clyear*4,input*80,rxline*20,  &
              cfmes*3,clmes*3,ftuesday*11,ltuesday*11,lupline*30,  &
              cfday*2, clday*2, cdia(16)*2,filefirst*20,crise*3,  &
!                  project_a*8,author_a*22,aut(50)*22,filesecond*20,
              project_a*6,author_a*22,aut(50)*22,filesecond*20,  &
              clst1_a*4,clst2_a*4,cdia_a*2,pro(50)*15,  &
              rx(50)*20,resp*1,chain*132,summer*1,cset*3,  &
              part_a*2,part(50)*2,par(50)*2,part_id*1  !ct 10-11-03
  character  com(22)*60,comm*60,cpx(22)*5,cpy(22)*5,cfact(22)*4
  character  rmtext*60
  character  ficheros(50)*20,su*2
  character(len=commandline_length) :: command
  character(len=filename_length) :: basename
!        real       px(22),pyy(22),fact(22)
!        integer    py(22)
  real       px(22),py(22),fact(22)
  character(len=1), parameter :: blocksepar='-'  ! Block separator

  integer    i,j,t,n,fmes, lmes, fday, lday, daymax(12),jjj,  &
              fyear, lyear ,diamax, dia(16), tt, c(50),no_proj, &
              ho, lastt, m, ancho,dia_a,diap(50,15), &  !CT: (40,8)
              no_ba,no_bla,ii,jj,kk,k,modfyear,version,wk1,wk2
  real       x,y,lst1_a,lst2_a,tim_st(50,15),n_hour(50),  &
              tim_end(50,15),ultdia,n_tot,limtim,yx,yy,yz
  real       rise1,rise2,set1,set2
  real       cpolix(100), cpoliy(100)

  data day   /'  ','TU','WE','TH','FR','SA','SU','MO',  &
              'TU','WE','TH','FR','SA','SU','MO','TU'/
  data month /'JAN','FEB','MAR','APR','MAY','JUN','JUL',  &
              'AUG','SEP','OCT','NOV','DEC'/
  data daymax  /31,28,31,30,31,30,31,31,30,31,30,31/
  data cpolix     /100*0.0/
  data cpoliy     /100*0.0/
  !
        mres1 = ' '
        mres2 = ' '
        !
        if (infour) then
           call gr_exec('set plot_page landsc') !aqui porque hace clear plot
           four   = .true.
           first  = .true.
           second = .false.
        else
           call gr_exec('set plot_page port')
           four   = .false.
           first  = .true.
           second = .false.
        endif

8888    continue
        do i=1,50
           author(i) = '  '
           aut(i) = '  '
           par(i) = '  '
           proj(i) = '  '
           part(i) = '  '                    !CT 08-Dec-2010
           pro(i) = '  '
           rx(i) = '  '
           c(i) = 1
           n_hour(i)=0.0
           do j=1,15  ! antes 8
             diap(i,j)=0.0
             tim_st(i,j)=0.0
             tim_end(i,j)=0.0
           enddo
        enddo

!        do i=1,100
!         write(6,*) i, cpolix(i),cpoliy(i)
!        enddo

        limtim=10.5 ! a partir de esa hora el ultimo dia
        do i=1,15
                do j=1,6
                        recmark(i,j)=.false.
                        found(j)=.false.
                enddo
        enddo
        project_a='  '
        author_a='  '
        n_tot = 0
        no_proj = 0

        if (.not.first) goto 7777
        !
        ! Decode week number and version from file name e.g. wk12v3.dat
        call parse_file_name(file1,basename,wk1,version,error)
        if (error)  return
        fil = trim(basename)//'.dat'
        filefirst = fil
        prueba=.false.
        write (6,*) '  '

7777    continue
        if (first) goto 6666
        if (.not.four) goto 6666
        if (.not.second) goto 6666

        ! Decode week number and version from file name e.g. wk12v3.dat
        call parse_file_name(file2,basename,wk2,version,error)
        if (error)  return
        fil = trim(basename)//'.dat'
        filesecond = fil
        prueba=.false.
6666    continue

!       write (6,1850)
!1850   format(1x,' Enter P (Preview) or D (definitive) > ',$)
!       read (5,'(a)') resp
!       call sic_upper(resp)
        resp='D'
        if(resp.ne.'P') prueba=.false.

        fil = filesecond
        if (first) fil = filefirst

        open (unit=91,file=fil,status='old',err=366)
        print *,'** file opened: ', fil
        goto 469
366     print *, ' - cannot read file name:',fil,' try again.-'
        goto 8888
469     continue
        rewind(unit=91)
!       call gr_exec('set /def')
        call gr_exec('penc /def')
        call gtclal  ! CLEAR ALPHA
!       call gr_exec('clea plot')
!1011    format(a8,2x,a22,3x,a2,2x,a4,5x,a4,2x,a20)
1011    format(a6,1x,a2,1x,a22,3x,a2,2x,a4,5x,a4,2x,a20)
1013    format(a5,3x,a5,3x,a4,4x,a60)
!***********************************************************************
!c      Reading the file
!***********************************************************************
        read (91,'(a2)') name
        call sic_upper(name)
        read (91,'(a1)') summer
        call sic_upper(summer)
                if(summer.eq.'Y') then
                  lsummer=.true.
                  texto1='MEST = UT + 2 hours'
                  ho=6
                else
                  lsummer=.false.
                  texto1='MET = UT + 1 hour'
                  ho=7
                endif
        read (91,'(a11)') dat
        call sic_upper(dat)
        read (91,'(a5)') weeks
        read (91,'(i4)') fyear
        write(cfyear,'(i4)')  fyear
        modfyear = mod(fyear,4)
        read (91,'(i4)') fmes
        if(fmes.gt.12) then
          write(6,*) 'Error in month number, correct the file'
          error = .true.
          return
        endif
        read (91,'(i4)') fday
!       fyear=fyear+1900
!        if(modfyear.eq.0) daymax(2)=29        !leap year
!        if(mod(fyear,4).eq.0) daymax(2)=29              !leap year
!       fyear=fyear-1900
        write(cfday,'(i2.2)')   fday
!
      daymax(2)=28
      do i=1,12
           if (fmes.eq.i) then
             jjj=i
             if(modfyear.eq.0) daymax(2)=29        !leap year
             diamax=daymax(i)
             cfmes=month(i)
           endif
!       write (6,*) i,daymax(i),diamax, fil, fyear, modfyear
        enddo
!
!       write (6,*) 'hola'
!       write (6,*) jjj,daymax(jjj),diamax, fil, fyear, modfyear

!        pause
        if(fday.gt.diamax) then
          write(6,*) 'Error in day number, correct the file'
          error = .true.
          return
        endif
        lday=fday+14
        if(lday.gt.diamax) lday=lday-diamax
        lmes=fmes
        lyear=fyear
        if(lday.le.14) lmes = fmes+1
        if(lmes.eq.13) then
           lmes = 1
           lyear = fyear+1
        endif
        do i=1,12
           if (lmes.eq.i) clmes=month(i)
        enddo
        write(clday,'(i2.2)')   lday
        write(clyear,'(i4)')  lyear
        ftuesday=cfday//'-'//cfmes//'-'//cfyear
        ltuesday=clday//'-'//clmes//'-'//clyear
        dia(2)=fday
        dia(1)=fday-1
        write(cdia(2),'(i2.2)')  dia(2)
        write(cdia(1),'(i2.2)')  dia(1)
        do i=3,16
           dia(i)=dia(i-1)+1
           if(dia(i).eq.diamax+1) dia(i)=1
           write(cdia(i),'(i2.2)')  dia(i)
        enddo
        cdia(1) = ' '
!       write(ifyear,'(i4)') fyear
!******************************************************************
!************  getting info of set sun and set rise
!******************************************************************
        call sunpos (fyear,fmes,fday,rise1,set1)
        call sunpos (lyear,lmes,lday,rise2,set2)

        rise1=rise1+1.0         ! ut+1 winter time
        rise2=rise2+1.0
        set1=set1+1.0
        set2=set2+1.0
        if(lsummer) then
         rise1=rise1+1.0        ! ut+2 summer time
         rise2=rise2+1.0
         set1=set1+1.0
         set2=set2+1.0
        end if
!
!       print*,'fecha, rise1, set1',fyear,fmes,fday,rise1,set1
!       print*,'fecha, rise2, set2',lyear,lmes,lday,rise2,set2
!       pause
!******************************************************************
        read (91,'(a)') input ! 3 comments lines
        read (91,'(a)') input
        read (91,'(a)') input
        i = 0
        ancho  =0
        ultdia =0
        splitblock = .false.
!40      read (91,1011,END=11)  project_a,author_a,cdia_a,clst1_a,
!     1                          clst2_a,rxline
40      read (91,1011,END=11)  project_a,part_a,author_a,cdia_a,clst1_a,  &
                                clst2_a,rxline

        px(:) = 0.
        py(:) = 0.
        fact(:) = 0.
        if(project_a(1:1).eq.'!') goto 40
        if(project_a(1:1).eq.blocksepar) then
          splitblock = .true.
          goto 40
        endif
        if(project_a(1:2).eq.'**') then
           read (91,'(a)') input ! jump next 3 comm. lines !mod. CT 06-09-99
           read (91,'(a)') input
           read (91,'(a)') input
           do j=1,22
             com(j)='  '  ! new mr
           enddo
           do j=1,22
!c             read (91,1013,END=11)  cpy(j),cpx(j),cfact(j),com(j)
              read (91,1013,END=11)  cpx(j),cpy(j),cfact(j),com(j)
!             call sic_upper(cpy(j))
!             if(cpy(j)(1:4).eq.'STOP') then
              call sic_upper(cpx(j))
             if(cpx(j)(1:4).eq.'STOP') then
                com(j)=' '
                goto 11
             endif
             no_ba=0
             do t=1,60
               if(com(j)(t:t+1).eq.'  ') no_ba=no_ba+1
! !mod. CT 19-02-00
             enddo
             no_bla = int(float(no_ba)/2.)
             comm='  '
!            comm(no_bla+1:60)=com(j)
!            com(j)=comm
             comm(1:no_ba)=com(j)
!       if(cpy(j)(1:4).eq.'STOP') goto 11        !mod. CT 06-09-99
             read (cpx(j),'(f5.2)') px(j)
             read (cpy(j),'(f5.2)') py(j)

!       px is now in hours (0..24), py is in day of the date
!
             if (abs(py(j)-98.).le.0.1) then
                py(j) = fday+22.8                 !remark above left bottom
                px(j) = -1.5
             elseif (abs(py(j)-99.).le.0.1) then
                py(j) = fday+22.8                 !remark above right bottom
                px(j) = 11.8
             elseif(py(j).lt.fday) then
                py(j) = py(j) + diamax            !when py after end of month
             endif
             px(j) = (px(j)-1)/24*0.89+0.10
             py(j) = - 0.83*1./15.*(py(j)-fday+0.5) + 0.89
             read (cfact(j),'(f4.2)') fact(j)
!            print *, ' ** px,py: ', px(j), py(j)
           enddo
        endif            !end if(project_a(1:2).eq.'**') then

        i=i+1
        read (cdia_a,'(i2.2)')  dia_a
!       print *, ' dia_a:', dia_a
        read (clst1_a,'(f9.1)') lst1_a
        read (clst2_a,'(f9.1)') lst2_a
        proj(i)=project_a
        part(i)=part_a
        if (i.gt.1) then
           if (splitblock) then
              ! Force split project in a new block
              splitblock = .false.
           elseif (proj(i).eq.proj(i-1)) then
              ! Same project
              i=i-1
              c(i)=c(i)+1
              proj(i+1)= ' '
              par(i+1) = ' '
          endif
        endif
        proj(i)=project_a
        pro(i)=proj(i)
        part(i)=part_a
        par(i) =part(i)
        author(i)=author_a
        aut(i)=author(i)
        rx(i)=rxline
        diap(i,c(i))=dia_a
        tim_st(i,c(i)) =lst1_a
        tim_end(i,c(i))=lst2_a
        no_proj=i
!**********************************************************************
! MR modif. jan-94
        do k=1,no_proj-1
                if(proj(i).eq.proj(k)) then
                      n_hour(k)=n_hour(k)-lst1_a+lst2_a
                      goto 3131
                endif
        enddo
        if(diap(i,c(i)).ne.diap(i,c(i)-1)) then !do not repeat account of hours
           n_hour(i)=n_hour(i)-lst1_a+lst2_a
        endif

3131    continue
        if(dia_a.eq.float(fday)) then
                if((lst1_a.le.limtim).and.(lst2_a.le.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-lst1_a)
                else if((lst1_a.le.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(limtim-lst1_a)
                endif
        endif
        if(dia_a.eq.float(lday)) then
                if((lst1_a.ge.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-lst1_a)
                else if((lst1_a.le.limtim).and.(lst2_a.ge.limtim)) then
                        n_hour(k)=n_hour(k)-(lst2_a-limtim)
                endif
        endif
!**********************************************************************
        call sic_upper(rxline)
        upline=rxline
        do t=1,15
           if(dia(t+1).eq.dia_a) then
             lastt=t
             if(rxline.ne.'  ') then
                do m=1,6
                   found(m)=.false.
                enddo
             do j=1,20
                if(upline(j:j+3).eq.'3MM1') found(1)=.true.
                if(upline(j:j+4).eq.'230G1') found(2)=.true.
                if(upline(j:j+3).eq.'2MM1') found(3)=.true.
                if(upline(j:j+2).eq.'CON') found(4)=.true.
                if(mres1(1:5).eq.'230G2') then
                 if(upline(j:j+4).eq.mres1(1:5)) found(5)=.true.
                else if(mres1(1:3).eq.'0.8') then
                 if(upline(j:j+2).eq.mres1(1:3)) found(5)=.true.
                else if(mres1(1:3).eq.'BOL') then
                 if(upline(j:j+2).eq.mres1(1:3)) found(5)=.true.
                else
                 if(upline(j:j+3).eq.mres2(1:4)) found(5)=.true.
                endif

                if(mres2(1:5).eq.'230G2') then
                 if(upline(j:j+4).eq.mres2(1:5)) found(6)=.true.
                else if(mres2(1:3).eq.'0.8') then
                 if(upline(j:j+2).eq.mres2(1:3)) found(6)=.true.
                else if(mres2(1:3).eq.'BOL') then
                 if(upline(j:j+2).eq.mres2(1:3)) found(6)=.true.
                else
                 if(upline(j:j+3).eq.mres2(1:4)) found(6)=.true.
                endif

             enddo
                do m=1,6
                   if(found(m)) recmark(t,m)=.true.
                enddo

             endif
             if(rxline.eq.'  ') then
              if(c(i).ge.2) then
                ancho=int(dia_a-ultdia+1)
                do j=2, ancho
                   do n=1,6
                      if(found(n)) then
                        if (.not.recmark(t-ancho+j,n)) then
                           recmark(t-ancho+j,n)=recmark(t+1-ancho,n)
                        endif
                      endif
                   enddo
                enddo
              else
                do j=1,6
                   found(j)=.false.
                enddo
              endif
            endif
           endif
        enddo
        lupline=upline
        ultdia=dia_a

        goto 40        !loop reading the .dat file

11      continue       !jump to here after reading STOP in .dat file
        do i=1,no_proj
          p(i)=pro(i)
          call sic_upper(p(i))
          do j=1,4
              if((p(i)(j:j+3).eq.'mtn').or.  &
                 (p(i)(j:j+2).eq.'ptg').or.  &
                 (p(i)(j:j+2).eq.'TBA').or.  &
!                (p(i)(j:j+1).eq.'TT').or.   &
!                (p(i)(j:j+3).eq.'TECH').or. &
                 (p(i)(j:j+3).eq.'RESE').or. &
                 (p(i)(j:j+3).eq.'RX S').or. &
                 (p(i)(j:j+3).eq.'BOLO').or. &
                 (p(i)(j:j+2).eq.'mon')) then
                        pro(i)='    '
                        aut(i)='    '
                        rx(i)='    '
                        par(i)='  '
                endif
          enddo
        enddo
        do i=no_proj,1,-1
           do j=1,i-1
                if(pro(i).eq.pro(j)) then
                   pro(i)='  '
                   par(i)='  '
                   aut(i)='  '
                   rx(i)='  '
                endif
           enddo
        enddo
        do i=1,no_proj
           if(pro(i).eq.'  ') then
                do j=i+1,no_proj
                   if(pro(j).ne.'  ') then
                        pro(i) = pro(j)
                        par(i) = par(j)
                        aut(i) = aut(j)
                        rx(i)  = rx(j)
                        pro(j) = '  '
                        par(j) = '  '
                        aut(j) = '  '
                        rx(j)  = '  '
                        goto 111
                   endif
                enddo
111             continue
           endif
        enddo

        if (.not.four) then
           call gr_exec('set box 0.5 20.5 9.0 25.0 ')
        endif

        if (four) then
           if (first) then
            call gr_exec('set box 0.30 14.8 5.5 17.75 ')
           else
             call gr_exec('set box 15.40 29.9 5.5 17.75 ')
           endif
        endif

        write (6,*) '  '
        texto='OBSERVING SCHEDULE IRAM 30m TELESCOPE'
!       goto 9999 !para saltar graficas durante tests
        call gtclal

!       +++++++++++++++++++++++++++++++++++++++++++++++++++++++
!       +++                  Using Greg                     +++
!       +++++++++++++++++++++++++++++++++++++++++++++++++++++++

        call gr_exec('box n n n')
        call gr_exec('set expand 1.20')

        if (four) call gr_exec('set expand 0.90')

        call gr_exec('set font dupl')
        if(prueba) call gr_exec('set font simpl')
!       if(four) call gr_exec('set font simpl')
        call gr_exec('pencil 1')
        call gr_exec('draw text 0.50 1.18 "'//Texto//'" 8 /USER')
        call gr_exec('set expand 1.00')

        if (four) call gr_exec('set expand 0.77')
        call gr_exec('draw text 0.45 1.14 "'//ftuesday//'" 4 /USER')
        call gr_exec('draw text 0.50 1.14 " to " 5 /USER')
        call gr_exec('draw text 0.55 1.14 "'//ltuesday//'" 6 /USER')
        call gr_exec('set expand 0.85')

        if (four) call gr_exec('set expand 0.58')
        call gr_exec('draw text 0.00 1.09 "Weeks: " 6 /USER')
        call gr_exec('draw text 0.10 1.09 "'//Weeks//'" 6  /USER')
        call gr_exec('draw text 0.00 1.04 "Version:" 6 /USER')
        write(command,'(A,I0,A)') 'draw text 0.11 1.04 "',version,'" 6 /USER'
        call gr_exec(command)
        call gr_exec('draw text 0.94 1.09 "By:" 4 /USER')
        call gr_exec('draw text 1.00 1.09 "'//name//'" 4 /USER')
        call gr_exec('draw text 0.80 1.04 "Date:" 4 /USER')
        call gr_exec('draw text 1.00 1.04 "'//Dat//'" 4 /USER')

        call gr_exec('set expand 0.65')

        if (four) call gr_exec('set expand 0.50')
        call gr_exec('pencil /defa')

        call gr_exec('draw text 0.500 0.955 "'//Texto1//'" 5 /USER')
        call gr_exec('draw text 0.0390 0.94 "DAY" 5 /USER')

!c
!c      new format to write projects, authors and receiver information (CT)
!c
!c      line to separate projects

        call gr_exec('draw relocate 0.500 0.00 /USER')
        call gr_exec('draw line 0.500 -0.420 /USER')
        call gr_exec('draw relocate 0.497 0.00 /USER')
        call gr_exec('draw line 0.497 -0.420 /USER')

        call gr_exec('draw relocate 0.00 0.00 /USER')
        call gr_exec('draw line 0.00 -0.420 /USER')

        call gr_exec('draw relocate 1.00 0.00 /USER')
        call gr_exec('draw line 1.00 -0.420 /USER')

        call gr_exec('draw relocate 0.00 -0.420 /USER')
        call gr_exec('draw line 1.00 -0.420 /USER')

!       do i=13,20
!          pro(i)='999-99'
!          aut(i)='clemens thum'
!          rx(i)='2m 3m1 g2'
!          enddo

        if (four) call gr_exec('set expand 0.47250') !antes 0.475

        do i=1,19, 2
           y=-0.03-(i-1)*0.02

           x=0.005
           write(chain,1022) x,y,Pro(i)
!1022      format ('draw text' ,2(1x,f5.3),' " ',a6,' " 3 /USER')
1022       format ('draw text' ,2(1x,f5.3),' " ',a8,' " 3 /USER')  !CT 11-12-98
           call gr_exec (chain)

           x=0.090           !0.115             !0.135
           write(chain,1023) x,y,Aut(i)
1023       format ('draw text' ,2(1x,f5.3),' " ',a22,' " 3 /USER')
           call gr_exec (chain)

           x=0.280
           write(chain,1024) x,y,Rx(i)
1024       format ('draw text' ,2(1x,f5.3),' " ',a20,' " 3 /USER')
           call gr_exec (chain)
        enddo

        do i=2,20, 2
           y=-0.03-(i-2)*0.02
           x=0.510
           write(chain,1025) x,y,Pro(i)
!1025      format ('draw text' ,2(1x,f5.3),' " ',a6,' " 3 /USER')
1025       format ('draw text' ,2(1x,f5.3),' " ',a8,' " 3 /USER')   !CT 11-12-98
           call gr_exec (chain)

           x=0.595
           write(chain,1026) x,y,Aut(i)
1026       format ('draw text' ,2(1x,f5.3),' " ',a22,' " 3 /USER')
           call gr_exec (chain)

           x=0.785
           write(chain,1027) x,y,Rx(i)
1027       format ('draw text' ,2(1x,f5.3),' " ',a20,' " 3 /USER')
           call gr_exec (chain)
        enddo

!       call gr_exec('draw text 0.04 3.7E-02 "LST" 5 /USER')
!       call gr_exec('draw relocate 0.07 3.6E-02 /USER')
!       call gr_exec('draw arrow 0.09 3.7E-02 /USER')
        call gr_exec('draw text 0.03 3.7E-02 "LST" 5 /USER')
        call gr_exec('draw relocate 0.06 3.6E-02 /USER')
        call gr_exec('draw arrow 0.08 3.7E-02 /USER')

        call hsidnew(fyear,fmes,fday,0,0,-3.,-23.,-58.1,lsummer)
        call hsidnew(fyear,fmes,fday,8,0,-3.,-23.,-58.1,lsummer)
        call hsidnew(fyear,fmes,fday,16,0,-3.,-23.,-58.1,lsummer)

!******** lines of sun rise and sunset ***********
        yz=0.888
        yy=0.015
        yx=0.130
        rise1=rise1*0.037037+0.095 ! change to user coord.
        rise2=rise2*0.037037+0.095
        set1=set1*0.037037+0.095
        set2=set2*0.037037+0.095
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c
!c      new line of the sun
!c
        call gr_exec('pencil /dash 3 /weig 1')
        write (chain,2236) rise2,yy
2236    format ('draw relo',2(1x,f7.4),' /CLIP')
        call gr_exec (chain)
        write (chain,2246) set2,yy
2246    format ('draw lin',2(1x,f7.4),' /CLIP')
        call gr_exec (chain)

        call gr_exec('pencil /dash 1 /weig 1')

!***********************************************************************
!c      sun symbol instead of characters
!        crise='0'
!        cset='0'
        crise=char(92)//'g0'  ! sun symbol
        cset =char(92)//'g0'
!        pause !ya no es necesaria la pausa, se ha arreglado al poner
!        la linea del sol antes que los simbolos
        write (chain,2247) rise2,yy,crise
2247    format ('draw text',2(1x,f7.4),' " ',a3,' " 5 /USER /CLIP')
        call gr_exec (chain)
        write (chain,2248) set2,yy,cset
2248    format ('draw text',2(1x,f7.4),' " ',a3,' " 5 /USER /CLIP')
        call gr_exec (chain)
!***********************************************************************
        call gr_exec('pencil /dash 3 /weig 1')
        do i=2,17
                x  = 1.0-(float(i)/18.0)
                t  = i-1
                tt = i-1
                call horizline(x,day(t),cdia(tt),prueba,four)
        enddo
        do i=1,25
                x = 0.095+(i-1)*0.0370834
                t = i
                call vertline(x,t,prueba,four)
        enddo
        call gr_exec('pencil /dash 1 /weig 1')
!***********************************************************************
!cc        pause !p3
!55     continue
        write(fil5,'(A,I0,A)')  's'//fil(3:4)//'v',version,'.html'  !nuevo fichero mr
        write(fil6,'(A,I0,A)')  's'//fil(3:4)//'v',version,'.gif'   !nuevo fichero mr
!        fil5='test.html'
!        print*, fil5,fil6
!        pause
!cccccccccccccccc
!        do i=1,no_proj
!c        ficheros(i)='p'//proj(i)(1:index(proj(i),' ')-1)//'.html'
!        if(proj(i)(1:3).eq.char(92)//'gD') then
!          ficheros(i)=fil5(1:5)//'_d'//proj(i)(4:5)//'.html'
!         else
!           ficheros(i)=fil5(1:5)//'_'//proj(i)(1:3)//'.html'
!        endif
!c         print*, ficheros(i)
!c         pause
!        enddo
!cccccccccccccc a continuacion cambio las lineas anteriores para
!cccccccccccccc modificar el nombre de ficheros html de cada proyecto
!cccccccccccccc para que no incluya la version
        do i=1,no_proj
!        ficheros(i)='p'//proj(i)(1:index(proj(i),' ')-1)//'.html'
!        if(proj(i)(1:3).eq.char(92)//'gD') then
!          ficheros(i)=fil5(1:3)//'_d'//proj(i)(4:5)//'.html'
!         else
!           ficheros(i)=fil5(1:3)//'_'//proj(i)(1:3)//'.html'
!        endif

!     19-Jul-2005 added scheduling unit No. to html file name
!
!        print *,proj(i),' part(i)=', part(i),'===='
!        print *,'par(i)(1:2)=', par(i)(1:2),'===='
        if (part(i)(1:1).eq.' ') then
          su = '0'//part(i)(2:2)
          if (part(i)(2:2).eq.' ') then
             su = '00'
          endif
        else
          su = part(i)(1:2)
        endif

        ficheros(i) = fil5(1:3)//'_'//trim(proj(i))//'_su'//su//'.html'

!        print*,part(i), ' - ', ficheros(i)
!         pause
        enddo

!cc     call to graphic subroutine
        do i=1,no_proj
        j=c(i)
        ii=i
        jj=j
        kk=j
        call displ_proj(proj(i),diap,tim_st,tim_end,i,j,dia,prueba,four)
        enddo  !hoy

!c**********************************************************************
!c          new comments part
!c**********************************************************************
        call gr_exec('set ori 0')
        do j=1,21
!          print*, px(j),py(j),fact(j),com(j)
!          pause 33
!          call gr_exec('set expand 1.0')
           if (four) fact(j)=0.75*fact(j)
           write (chain,2347) fact(j)
2347       format ('set expand',(1x,f4.2))
           call gr_exec (chain)
           call gr_exec('pencil /dash 1 /weig 2')
           write (chain,2348) px(j),py(j),com(j)
!           write (chain,2348) px(j),pyy(j),com(j)
!2348      format ('draw text',2(1x,f5.3),' " ',a60,' " 5 /USER')
2348       format ('draw text',2(1x,f5.3),' " ',a60,' " 6 /USER')   !CT 2-11-99
           call gr_exec (chain)
           call gr_exec ('penc /defa')
        enddo
!***********************************************************************
! file *.out with info of number of hours
!***********************************************************************
        part_id = '='          !identifies the part number in .out file
        fil2=fil(1:index(fil,'.')-1)//'.out'
!       open (unit=92,file=fil2,defaultfile='[thum.sched.planning].dat',
!     1        status='unknown')
        rmtext = 'rm -f fil2'
        call system(rmtext)
        open (unit=92,file=fil2,status='unknown')
        write (92,1318) fil2
        write (92,1314)
        write (92,1315)
        do i=1,no_proj
                n_tot=n_tot+n_hour(i)
        enddo
        write (92,1316) proj(1),part(1),part_id,n_hour(1)
        print *,proj(1),part(1),n_hour(1)
        do i=2,no_proj
                do j=1,i-1
                        if(proj(j).eq.proj(i)) then
                           goto 1322
                        else

                        endif
                enddo
                if(n_hour(i).ne.0) then
                   write (92,1316) proj(i),part(i),part_id,n_hour(i)
                   print *,proj(i),part(i),n_hour(i)
                endif
1322            continue
        enddo
        write (92,1317) n_tot,n_tot*100./336.
1314    format('!',10x,'Project ',10x,'Part',5x,'Hours ')
1315    format('!',10x,'------- ',10x,'----',5x,'----- ')
1316    format(7x,a15,7x,a2,a,7x,f5.1)
1317    format('!',10x,'Total:  ',10x,f5.1,'  Hours (=',f5.1,'%)')
1318    format('!',10x,'File:  ',a20)
        close(unit=92)

        do i=1,no_proj
        j=c(i)
        ii=i
        jj=j
        kk=j

! kw001 gifcoor
        call gifcoor(proj(i),diap,tim_st,tim_end,ii,jj,dia,cpolix,cpoliy)

! kw002 makehtml1
        if(i.eq.1) call makehtml1(i,fil5,fil6)

! kw003 makemapq
3232    continue
!        if(i.eq.1) then
!          write(6,'(1x,a,$)') 'create html file (y/n), some(s)? > '
!          we only write the main html file here; the project files
!          are now written from the DB (Jan 2005)
!          write(6,'(1x,a,$)') 'create html file (y/n) ? > '
!          read (5,'(a1)') ans
!          if (ans.eq.' ') ans = 'n'
!           write(6,*) rmtext2
!           call system(rmtext2)

!          if (ans.eq.'y') then
!            write(6,'(1x,a,$)') 'are you sure you typed y? (y/n)> '
!            read (5,'(a1)') ans
            ans = 'y'
            if (ans.ne.'y') goto 3232
!          endif
!          fy=.false.
!          algunos=.false.
!          if((ans.eq.'y').or.(ans.eq.'Y')) fy=.true.
!          if((ans.eq.'s').or.(ans.eq.'S')) algunos=.true.
!        endif
!        print *,'cfyear=',cfyear
        fy=.true.
!        print *, 'fyear=',fyear,' fmes= ',fmes
        algunos = .false.                           !CT 08-dec-2010
        call makemap(fy,algunos,i,ficheros,proj,kk,cpolix,cpoliy,fyear,fmes)

!kw004 makehtml2
        if(i.eq.no_proj) call makehtml2(i,fil5)
        enddo
        close(96)

        call gr_exec('pencil /dash 1 /weig 1')

        fil3=fil(1:index(fil,'.')-1)//'.ps '

!***********************************************************************
        close(unit=91)
        if ((four).and.(second)) goto 5151
        if (four) then
           first  = .false.
           second  = .true.
           goto 8888
        endif
5151    continue
        write(fil4,'(A,I2.2,I2.2,A)') 'tmp',wk1,wk2,'.ps'

        call gr_exec('set expand 0.90')
        call gr_exec('pencil /dash 1 /weig 2')
        call gtclal  ! CLEAR ALPHA

end subroutine sched30m_schedule
!
subroutine sched30m_hardcopy_command(line,error)
  use sched30m_interfaces, except_this=>sched30m_hardcopy_command
  !---------------------------------------------------------------------
  ! @ private
  !  Support subroutine for command
  !    HARDCOPY
  ! Decode the command line
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  !
  ! Nothing to be decoded
  call sched30m_hardcopy(error)
  if (error)  return
  !
end subroutine sched30m_hardcopy_command
!
subroutine sched30m_hardcopy(error)
  use sched30m_common
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=60) :: cptext
  character(len=27) :: defdir
  character(len=160) :: rmtext2
  character(len=36) :: webdir
  !
  if (four) then
    call gr_exec('hard "'//fil4//'" /dev eps fast /overwrite')
    !
  else
    print *, 'fil3: ', fil3
    call gr_exec('hard "'//fil3//'" /dev ps fast /overwrite')
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!          para crear fichero gif, ya funciona en Granada
!kw005 convert
!           write(6,*) fil3,fil6
!           rmtext2= 'convert '//fil3//' '//fil6
    rmtext2= 'convert +antialias -density 300 '//fil3//  &
    ' -type trueColor -resample 72 -contrast '//fil6
    write(6,*) rmtext2
    call system(rmtext2)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
  endif

!  Jan 03 modification: cp files to new web page
  webdir = '/netapp1/www/html/IRAMFR/PV/sche/03/'
  defdir = '/users/astro/thum/sched/03/'

! write(6,'(1x,a,$)') 'copy html,gif files to web? (y/n) > '
! read (5,'(a1)') ans
! if (ans.eq.' ') ans = 'n'
  if (.false.) then
!  cptext = 'newgrp web; ls'
!  write(6,*)  '- execute: ', cptext
!  call system(cptext)
!  cptext = 'cd '//webdir//'; pwd'
!  write(6,*)  '- execute: ', cptext
!  call system(cptext)
    cptext = 'cp '//defdir//fil5//' '//webdir//'.'
    write(6,*) cptext
    call system(cptext)
    cptext = 'cp '//defdir//fil6//' '//webdir//'.'
    write(6,*) cptext
    call system(cptext)
    cptext = 'ls '//webdir//' | pwd'
    write(6,*) cptext
    call system(cptext)
  endif

!  copy ps file to publicly reachable dir (for Juan) CT 22-08-07
!  This action is not required anymore so I comment it out (NB Dec. 2011)
!        webdir = '/users/astro/thum/www/sched/09/'
!        cptext = 'cp '//fil3//' '//webdir//'.'
!C       print *, 'copying:', cptext
!        write(6,*) cptext
!        call system(cptext)

end subroutine sched30m_hardcopy
!
!***********************************************************************

        subroutine horizline(t,nom,ddia,pr,ff)
        real      x, t
        character chain*80, nom*2, ddia*2
        logical   pr,ff

        t=t+0.025
        x= -0.0055

        write(chain,225) x,t,nom
225     format ('draw text',2(1x,f7.4),' "',1(1x,a2),'" 6 /USER')
        call gr_exec('set exp 0.85')
        if (ff) call gr_exec('set expand 0.635') !antes 0.65

        call gr_exec (chain)
        x=0.0780
        write(chain,226) x,t,ddia
226     format ('draw text',2(1x,f7.4),' "',1(1x,a2),'" 4 /USER')
!       call gr_exec('set exp 0.85')
        call gr_exec (chain)
        x= 0.0
        t=t-0.025
        if(pr) goto 2223
        write(chain,222) x,t
222     format ('draw rel ',2(1x,f7.4))
        call gr_exec (chain)
        x=1.0
        write(chain,223) x,t
223     format ('draw lin',2(1x,f7.4))
        call gr_exec (chain)
2223    x=0.0
        return
        end subroutine horizline

!***********************************************************************

        subroutine vertline(z,hora,pru,ff)
        real      y, z
        character chain*80, chora*2
        integer   hora
        logical   pru,ff

        hora=hora-1
!       write(chora,'(i2.2)') hora
        write(chora,'(i2)') hora
        y=0.058
        if(pru) goto 2222
        write(chain,222) z,y
222     format ('draw rel ',2(1x,f7.4))
        call gr_exec (chain)
        y= 0.91
        write(chain,223) z,y
223     format ('draw lin',2(1x,f7.4))
        call gr_exec (chain)
2222    y= 0.91
        y=y+0.005
        call gr_exec('set exp 0.50')
        if (ff) call gr_exec('set expand 0.38') !antest 0.4
        if(hora.lt.10) z=z-0.002
        write(chain,323) z,y,chora
323     format ('draw text',2(1x,f7.4),' "',a2,'" 8 /USER')
        call gr_exec (chain)
        return
        end subroutine vertline
!***********************************************************************

        subroutine displ_proj(proje,diap,tim_st,tim_end,s,t,diaa,prueba,ff)
        character  proje*15, chain*80, pr*15
        integer    i, j, s, t, p, u, diaa(16), no_b, no_bl,a1,a2
!       integer    diap(40,8)
        integer    diap(50,15)
!       real       tim_st(40,8),tim_end(40,8),corr
        real       tim_st(50,15),tim_end(50,15),corr
!        real       x(400), y(400), xave, yave, height, width,z
        real       x(100), y(100), xave, yave, height, width,z

        logical    anga,prueba,ff
!        data x     /400*0.0/
!        data y     /400*0.0/
        data x     /100*0.0/
        data y     /100*0.0/

        anga   = .false.
        corr   = 0.0033
        a1     = 0.0
        a2     = 0.0
        xave   = 0.0
        yave   = 0.0
        height = 0.0
        width  = 0.0
        u=t

!        write(6,*) t,proje
!        pause

        do j=1,t
        p = j-1
          do i=1,16
            if(diap(s,j).eq.float(diaa(i))) then
                if(j.eq.1) a1=diaa(i)
                if(j.eq.t) a2=diaa(i)
                x(2*p+1) = (tim_st(s,j))*0.0370834 + 0.095
                x(2*p+2) = x(2*p+1)
                x(4*u-2*p-1) = (tim_end(s,j))*0.0370834 + 0.095
                x(4*u-2*p) = x(4*u-2*p-1)
                y(2*p+1) = 1-(float(i)/18.)
                y(2*p+2) = 1-(float((i+1))/18.)
                y(4*u-2*p-1) = y(2*p+2)
                y(4*u-2*p) = y(2*p+1)
                p = p+1
            endif
          enddo
          width=width+tim_end(s,j)-tim_st(s,j)
        enddo
        height=float(t)
        width=width/float(t)
        do i=1,4*u
           xave=xave+x(i)
           yave=yave+y(i)
        enddo
        xave=xave/(4.*u)
        yave=yave/(4.*u)
!       print *,u
        x(4*u+1)=x(1)
        y(4*u+1)=y(1)
        call gr_exec('set ori 0')
        call gr4_give ('X',4*u+1,x) !to plot project borders
        call gr4_give ('Y',4*u+1,y)
        call gr_exec('pencil /dash 1 /weig 3')
!       habia weig 2 pero CT quiere mas gruesas para html
        if(prueba) call gr_exec('pencil /dash 1 /weig 1')
        call gr_exec('connect')
        call gr_exec('pencil /dash 1 /weig 2')
        if(prueba) call gr_exec('pencil /dash 1 /weig 1')
        no_b=0
        do i=1,15
           if(proje(i:i).eq.' ') no_b=no_b+1
        enddo
        no_bl = int(float(no_b)/2.)
        pr='  '
        pr(no_bl+1:15)=proje
        proje=pr
!       if(height.ge.1.2*width) then
        if(height.ge.1.3*width) then
           call gr_exec('set ori 90')
           z=height
           height=width
           width=z
           t=int(height)
           if(mod(no_b,2).ne.0) anga=.true.
        endif
        if(t.eq.1) then
                if(width.ge.4) then
                        call gr_exec('set exp 0.85')
                        if (ff) call gr_exec('set expand 0.63')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.6')
                        if (ff) call gr_exec('set expand 0.45')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.5')
                        if (ff) call gr_exec('set expand 0.385') !0.37 antes

                else
                        call gr_exec('set exp 0.43')
                        if (ff) call gr_exec('set expand 0.35') !antes 0.33

                endif
        else if(t.eq.2) then
                if(width.ge.4) then
                        call gr_exec('set exp 1.0')
                        if (ff) call gr_exec('set expand 0.75')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.9')
                        if (ff) call gr_exec('set expand 0.67')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.8')
                        if (ff) call gr_exec('set expand 0.6')

                else
                        call gr_exec('set exp 0.7')
                        if (ff) call gr_exec('set expand 0.55') !0.53 antes

                endif
        else if(t.eq.3) then
                if(width.ge.4) then
                        call gr_exec('set exp 1.1')
                        if (ff) call gr_exec('set expand 0.82')

                else if(width.eq.3) then
                        call gr_exec('set exp 0.8')
                        if (ff) call gr_exec('set expand 0.6')

                else if(width.eq.2) then
                        call gr_exec('set exp 0.7')
                        if (ff) call gr_exec('set expand 0.53')

                else
                        call gr_exec('set exp 0.6')
                        if (ff) call gr_exec('set expand 0.45')

                endif
        else
                if(width.ge.4) then
                        call gr_exec('set exp 1.2')
                        if (ff) call gr_exec('set expand 0.9')

                else if(width.eq.3) then
                        call gr_exec('set exp 1.1')
                        if (ff) call gr_exec('set expand 0.825')

                else if(width.eq.2) then
                        call gr_exec('set exp 1.0')
                        if (ff) call gr_exec('set expand 0.75')

                else
                        call gr_exec('set exp 0.9')
                        if (ff) call gr_exec('set expand 0.68')

                endif
        endif

        if(anga) then
!         xave = xave - 2 * corr
          xave = xave - 1 * corr
          yave = yave + 1.9 * 2 * corr
        endif
        if(mod(no_b,2).ne.0) xave = xave + corr
        write(chain,1015) xave,yave,proje
1015    format ('draw text',2(1x,f7.4),' " ',a15,' " 5 /USER')
        call gr_exec (chain)
        call gr_exec('pencil /dash 1 /weig 1')
        call gtclal  ! CLEAR ALPHA
        return
        end subroutine displ_proj

!***********************************************************************
! kw001
        subroutine gifcoor(proje,diap,tim_st,tim_end,s,t,diaa,cpolix,cpoliy)
        character  proje*15
        integer    i, j, s, p, u, t, diaa(16),a1,a2
        integer    diap(50,15)
        real       tim_st(50,15),tim_end(50,15)
        real       x(100), y(100), xave, yave, height, width
        real       centrox,centroy,ancho,alto
        real       xoff,yoff,deltax,deltay
        real       cpolix(100), cpoliy(100)
        data x     /100*0.0/
        data y     /100*0.0/
!c*************************************
!     para coordenadas esquina superior izda.
!     SB 08-apr-2011: values compatible with Greg older than january 2011
!       xoff=  64.0
!       yoff=  129.6
!       deltax=19.5
!       deltay=23.7
!
!      SB 08-apr-2011: values compatible with Greg equal or newer to january 2011
        xoff=  58.0
        yoff=  121.7
        deltax=17.8
        deltay=21.3
!
!     corrijo coordenadas al cambiar dev ps por eps
!     CT 17-Jun-04 adapt gif to the 3 day upshift of eps
!        xoff=xoff-11.75
!        yoff=yoff+38.0-3*deltay
!     back to ps 15-07-06 CT
        xoff=xoff
        yoff=yoff
!cccccccccccccccccccccccccccccccccccccc
        a1     = 0.0
        a2     = 0.0
        xave   = 0.0
        yave   = 0.0
        height = 0.0
        width  = 0.0
        ancho=0.0
        alto=0.0
        centrox=0.0
        centroy=0.0
        u=t

!        write(6,*) t,proje
!        pause

        do j=1,t
        p = j-1
          do i=1,16
            if(diap(s,j).eq.float(diaa(i))) then
                if(j.eq.1) a1=diaa(i)
                if(j.eq.t) a2=diaa(i)

                x(2*p+1) = (tim_st(s,j))*1
                x(2*p+2) = x(2*p+1)
                x(4*u-2*p-1) = (tim_end(s,j))*1
                x(4*u-2*p) = x(4*u-2*p-1)
                y(2*p+1) = (float(i)/1.)
                y(2*p+2) = (float((i+1))/1.)
                y(4*u-2*p-1) = y(2*p+2)
                y(4*u-2*p) = y(2*p+1)
                p = p+1
            endif
          enddo
          width=width+tim_end(s,j)-tim_st(s,j)
        enddo
        height=float(t)
        width=width/float(t)
        do i=1,4*u
           xave=xave+x(i)
           yave=yave+y(i)
        enddo
        xave=xave/(4.*u)
        yave=yave/(4.*u)

        centrox=xave
        centroy=yave-2.0
        ancho=width
        alto=height
!        ancho=6.0
!        alto=1.0
        ancho=ancho/2.0
        alto=alto/2.0

!c         coordenadas para poligono en vez de rectangulo

        do i=1,4*u
          cpolix(i)=xoff+deltax*x(i)
          cpoliy(i)=yoff+deltay*(y(i))
!         cpoliy(i)=yoff+deltay*(y(i)-2
        enddo
        return
        end subroutine gifcoor
!***********************************************************************
! kw002
        subroutine makehtml1(s,fichero,fichero2)
        character    fichero*20,fichero2*20
        integer      s

!        fichero2='test.gif'

        if(s.eq.1) open(unit=96,file=fichero,status='unknown')

!        write (96,1800)
!1800    format('<html>'/'<head>'/'<title>Imagen map test MR </title>')
!1800    format('<html>'/'<head>'/'<title>30m schedule MR </title>')
!        write (96,1801)
!1801    format('</head>'/'<body><center>')
        write (96,1802) fichero2
1802    format('<img src="',a10,' " usemap="#bwmap">')
!        write (96,1803)
!1803    format('</body>')

        write (96,1804)
1804    format('<map name="bwmap">')

        return
        end subroutine makehtml1
!***********************************************************************
! kw004
        subroutine makehtml2(s,fichero)
        character    fichero*20
        integer      s

!        write (96,1801)
!1801    format('</center>') !el center debe incluir el mapa

        write (96,1803)
1803    format('</map>')

!        write (96,1808)
!1808    format('</html>')

        return
        end subroutine makehtml2
!********************************************************************
! kw003
        subroutine  makemap(an,an2,s,fi,proyecto,v,cpolix,cpoliy,yy,mm)

        character(len=*), intent(in) :: fi(50)
        character    fii*20,proyecto(50)*15,bgyear*2
        character    aux*4,poolID*2
        character    href_dir*37
        character*60 text1,text2,text3,text4*50,ans*1
        integer      i,v,s,con_0,con_1,con_2,con_3,con_4,mm,yy,ww
        integer      yydir
        real         cpolix(100), cpoliy(100)
        logical      an, an2

        fii=fi(s)
!        fii='p114-99.html '  !para test
        con_0 = len_trim(fii)

!ccccccccccc elegir opcion cccccccccccccccccccccccccccccccccccc

!        text1='#" onclick="window.open('''
!        text1='#" onmouseout="window.open('''
!        text1='#" onmouseover="window.open('''
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!        text2=fii(1:con_0)//',''mr'',''height=200,'
!        text2=fii(1:con_0)//',''height=200,'
!        text3='width=200,top=200,left=500'');">'
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        text1=fii(1:con_0)//'">'
        text2=' '
        text3=' '

        con_1 = len_trim(text1)
        con_2 = len_trim(text2)
        con_3 = len_trim(text3)

!        text4=text1(1:con_1)//text2(1:con_2)//text3(1:con_3)
        text4=text1(1:con_1)

        write (96,1805) cpolix(1),cpoliy(1)
1805    format('<area shape="poly" coords="',f5.1,',',f5.1)

        do i=2,4*v-1
         write (96,1806) cpolix(i),cpoliy(i)
1806     format(' ',2(',',f5.1))
        enddo

!       special case: the first schedule of next year starts already in Dec
        if (fii(2:3).eq.'00'.and.mm.eq.12) then
           yydir = yy + 1
        else
           yydir = yy
        endif
        write(aux,'(i4)') yydir
        bgyear = aux(3:4)
        read(fii(2:3),'(i2)') ww
!        print *, 'yy= ', yy
!        print *, 'aux:',aux,' yydir= ',yydir,' bgyear:',bgyear

        poolID = text4(5:6)
        href_dir= 'bgfiles/'//bgyear//'/'
!       here poolID represents the first 2 digit of the pool project ID (as defined in the .dat file)
!       for summer semester 400-yy and 300-yy are for heterodyne and bolometer pool, respectively
!       for winter semester 440-yy and 330-yy are for heterodyne and bolometer pool, respectively
!        if (poolID.eq.'30'.or.poolID.eq.'33') then
!           text4 = 'bolopool.html">'
!        elseif (poolID.eq.'40'.or.poolID.eq.'44') then
!           text4 = 'hetepool.html">'
!        endif
!         if (poolID.eq.'30') then
!            text4 = 'bolopool-S11.html">'
!         elseif (poolID.eq.'33') then
!            text4 = 'bolopool-W11.html">'
!         elseif (poolID.eq.'40') then
!            text4 = 'hetepool-S11.html">'
!         elseif (poolID.eq.'44') then
!            text4 = 'hetepool-W11.html">'
!         endif
        con_4 = len_trim(text4)

!        print *, href_dir, text4, poolID
        write (96,1807) cpolix(4*v),cpoliy(4*v),trim(href_dir),trim(text4)
!1807    format(' ,',f5.1,',',f5.1,'" href="',a20)             !CT 24-Jun-04
!1807    format(' ,',f5.1,',',f5.1,
!     1             '" href="../../../../php/schedule/html',a20)    !CT 04-feb-2005
1807    format(' ,',f5.1,',',f5.1,'" href="',a,a)

        if (an) then
!          these files are not used anymore (CT Jan 2005)
!          individual project files are now written by DB
!          open (97,file=fii,status='unknown')
!          close(97,status='delete') !hay que borrar antes de crear otra
!          open (unit=97,file=fii,status='unknown')

!c         files html for each project

          write (97,1820)
1820      format('<html>'/'<head>'/'<title> schedule </title>')
          write (97,1821)
1821      format('</head>'/'<body>')
!          print*, proyecto(s)(4:6), fii
!          pause
          if(proyecto(s)(4:6).eq.char(92)//'gD') then
            proyecto(s)='d'//proyecto(s)(7:15)
!          endif
!          print*, proyecto(s), fii
!          pause
          endif
!          write (97,1831)
1831      format('<p> ')
          write (97,1822) proyecto(s)
1822      format('project: ',a20)
          write (97,1831)
          write (97,1823)
1823      format('PC letter: ')
          write (97,1831)
          write (97,1824)
1824      format('Observer: ')
          write (97,1831)
          write (97,1825)
1825      format('Observing mode:  PV/service/remote')
          write (97,1831)
          write (97,1833)
1833      format('</body>')
          close (unit=97)
        endif
!       option to create only some of the html files
        if(an2) then
          write(6,'(1x,a,$)') 'create ',fii(1:con_0),' (y/n)? > '
          read (5,'(a1)') ans
          if (ans.eq.' ') ans = 'n'
            if((ans.eq.'y').or.(ans.eq.'Y')) then
                open (97,file=fii,status='unknown')
                close(97,status='delete') !hay que borrar antes de crear otra
                open (unit=97,file=fii,status='unknown')
                write (97,1820)
                write (97,1821)

          if(proyecto(s)(4:6).eq.char(92)//'gD') then
            proyecto(s)='d'//proyecto(s)(7:15)
!          endif
!          print*, proyecto(s), fii
!          pause
          endif
                write (97,1822) proyecto(s)
                write (97,1831)
                write (97,1823)
                write (97,1831)
                write (97,1824)
                write (97,1831)
                write (97,1825)
                write (97,1831)
                write (97,1833)

                close (unit=97)
            endif
          endif
        return
        end subroutine makemap
!***********************************************************************

        subroutine hsidnew(ye,mo,da,sid_ho,sid_min,lon_de,lon_mi,lon_se,lsummer)

        integer*4 ye,mo,da,ho,mi,ho0,mi0,sid_ho,sid_min,k
        real*4 lon_de,lon_mi,lon_se,aa,x1,x2,x4,y1,y2,y3,y4
        real*8 dt,hs0,sec,sidtime,sidtime0,factor,sec1
        character chain*80,csid_ho*4
        logical   lsummer

        k=1
        if (mo.le.2) k=0
        aa=ye+k-1
        factor=0.997268519     ! 3m56s less every day

! *** CALCULATING NUMBER OF DAYS :
        dt=float((ye-1)*365-723910+int(aa/4.)-int(aa/100.)  &
           +int(aa/400.)+(mo-1)*31+da-1-k*int(.4*float(mo)+2.3))+1.0
!c      !+1.0day works better MR
!
! *** SIDEREAL TIME :
        hs0=.27800846065+1.002737909315*dt+((lon_se/60.+lon_mi)/60.+  &
            lon_de)/360.0

        hs0= dmod(hs0,1.0d0)*24.
        if (hs0.lt.0.) hs0=hs0+24.      ! sid time at 00:00 UT

        sidtime0=24.0-hs0*factor        ! UT at 00:00 sid time
        sec=sidtime0
        ho0=int(sec)                    ! HOURS
        sec=(sec-int(sec))*60.
        mi0=int(sec)                    ! MINUTES

        sidtime=sidtime0+(sid_ho+sid_min/60.)*factor ! UT at si.d time asked
!        CT: don't draw outside of the box
        if (sidtime.lt.0.) sidtime=sidtime+24.
        if (sidtime.gt.23.) sidtime=sidtime-24.+0.0655555    !
!       if (sidtime.lt.0.8) sidtime=sidtime+24.
!       if (sidtime.gt.23.2) sidtime=sidtime-24.+0.0655555
!cc     0.06555 is +3m56s =+1day
        sec1=sidtime
        sec=sidtime
        ho=int(sec)                     ! SIDEREAL HOURS
        sec=(sec-int(sec))*60.
        mi=int(sec)                     ! SIDEREAL MINUTES

        y1=0.888888
        y2=0.058
        y3=0.037
        write(csid_ho,'(i2.2,a)')   sid_ho,' h'

        call gr_exec('pencil /dash 2 /weig 1')
!       x1=0.095+0.037083*sec1
!       x2=0.095+0.037083*(sec1-1)
        if (lsummer) then
         x1=0.095+0.037083*(sec1+2)
         x2=0.095+0.037083*(sec1+1)
        else
         x1=0.095+0.037083*(sec1+1)
         x2=0.095+0.037083*(sec1+0)
        endif
        if (x1.le.0.115) then      !LST line goes left of UT 0 h
            x4 = 0.096
            y4 = 0.5*(y1-y2)
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x4,y4
            call gr_exec (chain)
            x1 = 0.9836
            y1 = y4
            x4 = x1-0.0185
            y4 = y2
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x4,y4
            call gr_exec (chain)
            call gr_exec('pencil  /dash 1 /weig 1')
            write (chain,2227) x4,y3,csid_ho
            call gr_exec (chain)
            goto 2230
         else                           !LST lines fully within UT frame
            write (chain,2225) x1,y1
            call gr_exec (chain)
            write (chain,2226) x2,y2
            call gr_exec (chain)
            call gr_exec('pencil  /dash 1 /weig 1')
            write (chain,2227) x2,y3,csid_ho
            call gr_exec (chain)
        endif

2227    format ('draw text',2(1x,f7.4),' " ',a4,'" 5 /USER /CLIP')
2226    format ('draw lin',2(1x,f7.4),' /CLIP')
2225    format ('draw relo',2(1x,f7.4))

2230    continue
        return
        end subroutine hsidnew

!***********************************************************************

        subroutine rx_mark(n,m)    ! (dia=n; receptor=m) MR FEB-91

        integer    n,m
        real       a1,b1,ia,ib,x,y
        character  chain*80

325     format ('draw mark',2(1x,f8.6),' 5 /USER')

        a1=0.814668                             ! origin x
        b1=0.91745                              ! origin y
        ia=0.028518                             ! x increment
        ib=0.05555                              ! y increment

        x=a1+m*ia
        y=b1-n*ib
        write(chain,325) x,y
        call gr_exec (chain)
        return
        end subroutine rx_mark

!       program test
!       program possol
!       integer*4   aano,ames,adia
!       real*8      horasal,horapues
!       aano=1999
!       ames=8
!       adia=1
!       call sunposi (aano,ames,adia,horasal,horapues)
!       print*, 'hora UTC salida del sol= ',horasal
!       print*, 'hora UTC puesta del sol= ',horapues
!       print*, 'del dia = ',adia,ames,aano
!       end
!
!******************POSITION OF THE SUN ****************
        subroutine sunpos (tim1,tim2,tim3,salida,puesta)
!
        integer         time(7)
        integer         tim1,tim2,tim3
        integer         ig,imi,is,iy,im,id,idt,jj
        real*8          ra,de,frday,alst,dt,gst,lst
        real*8          ajd,al_s,elev,azim,errpos,alat,sila,cola,ha
        real*8          eps,pi,ome,e,err,d,ei,am_a,t_a
        real            salida,puesta
! *** parameters :
        pi = 3.14159265359
        eps = 278.833540/180.*pi        ! ecliptic longitude at epoch 1980.0
        ome = 282.596403/180.*pi        ! ecliptic longitude of perigee
        e = 0.016718                    ! eccentricity of orbit
        errpos = 0.25                   ! error allowed in elev
!
        time(1)= tim1           ! year
        time(2)= tim2           ! month
        time(3)= tim3           ! day
        time(4)= 0              ! hour UTC
        time(5)= 0              ! min
        time(6)= 0              ! sec
        time(7)= 0              ! tenth of sec.
! *** getting days since year 1, month 1 and day 1 :
        iy=time(1)
        im=time(2)
        id=time(3)
!       do i =1,7
!         print*,i,time(i),iy,im,id
!       end do
!********************************************
!***********loop to get elev zero************
!********************************************
        call ditra (iy,im,id,idt,ajd) !dias transcurridos
        DO jj= 240,1440 !1440 !  1440min/day=24h*60min/h
!        frday=float(jj/1440.)
        frday=jj/1440.
        dt=float(idt)+frday
!       print*,'fraccion de dia transcurrida : ',frday
!       do i =1,7
!         print*,i,time(i),iy,im,id
!       end do
!       print*,'total dias transcurridos : ',dt,idt
!
!
! *** getting sidereal time :
!       dt=dt-1./24.            ! because computer time
        call getst (dt,gst,lst) ! funciona bien el tiempo sidereo
!       print*,'lst = ',lst
        alst=lst*2.*pi
        call cgms (alst,ig,imi,is,3)
!       print*,'lst = ',lst
!       print*,'doble. time : ',iy,im,id,2*iy,2*im,2*id
!       pause

! *** getting ecliptic coordinates :
!       print*,'total dias transcurridos : ',dt
        de=dt-722813.
        d=de
!       print*,de,d
        am_a = mod((2.*pi/365.2422*d+eps-ome),(2.*pi))  ! mean anomaly
        ei = am_a                                       ! eccentric anomaly
        err=1.
        do while (err.gt.1.e-10)
         err = ei-e*sin(ei)-am_a
         de = err/(1.-e*cos(ei))
         ei = ei-de
        end do
        t_a = 2.*atan(sqrt((1.+e)/(1.-e))*tan(ei/2.))   ! true anomaly
        al_s = mod((t_a+ome),(2.*pi))                   ! longitude of the sun
!

! *** getting equatorial coordinates :
        call eecc (al_s,0.d0,ra,de)       ! right ascension and declination
        call cgms (ra,ig,imi,is,3)
!       print*,'ra => ',ra,ig,imi,is
        call cgms (de,ig,imi,is,2)
!       print*,'de => ',de,ig,imi,is
!
!
! *** getting horizon coordinates :
        alat=.646962526         ! 30m radiot. latitude (37deg. 4' 5.6")
        sila=sin(alat)
        cola=cos(alat)
        ha=lst*2.*pi-ra                 ! hour angle (radians)
!       print*,'hour angle = ',ha
        elev=asin(sin(de)*sila+cos(de)*cola*cos(ha))
        azim=acos((sin(de)-sila*sin(elev))/(cola*cos(elev)))
        if ((sin(ha)).gt.0.) azim=2.*pi-azim
!       print*,'az and el = ',azim,elev
        call cgms (azim,ig,imi,is,1)
!       print*,'azimuth = ',azim,ig,imi,is
        call cgms (elev,ig,imi,is,1)
!       print*,'elevat. = ',elev,ig,imi,is
        azim=azim/pi*180.
        elev=elev/pi*180.
!       print*, azim
!       print*, elev
        if((-errpos.le.elev).and.(elev.le.errpos)) then
!          print*, 'az,el',jj,azim,elev,frday,idt
           if((240.le.jj).and.(jj.le.540))   salida=24.*frday
           if((960.le.jj).and.(jj.le.1440))  puesta=24.*frday
        end if
        END DO
!       print*,'jj,fracc de dia ,elev= ', jj,frday,elev
!       end do
        return ! end sunpos
        end subroutine sunpos
!c
        subroutine eecc (elo,ela,ra,de)
!   subroutine to make the ecliptic to equatorial coordinate conversion
!   elo = ecliptic longitude (radians)
!   ela = ecliptic latitude (radians)
!   ra = riht ascension (radians)
!   de = declination (radians)
        real*8 elo,ela,ra,de,pi,ep
        real*8 anum,den
        pi = 3.14159265359
        ep=23.441884/180.*pi    ! obliquity of the ecliptic
!
! *** calculation of the right ascension ra:
        anum=sin(elo)*cos(ep)-tan(ela)*sin(ep)
        den=cos(elo)
        ra=atan(anum/den)
        if (den.lt.0.) ra=ra+pi
        ra=mod(ra,(2.*pi))
!
! *** calculation of the declination de:
        de=asin(sin(ela)*cos(ep)+cos(ela)*sin(ep)*sin(elo))
        de=mod(de,(2*pi))
        return
        end subroutine eecc
!
!
        subroutine cgms (angi,gra,min,sec,k)
!   subroutine to make the conversion of the angle ang with the following
!   options:
!   k=1, 0 <= output angle < 360
!   k=2, -180 < output angle <= 180
!   k=3, 0 h <= output angle < 24 h
        integer gra,sec,min,k
        real*8  pi,ang,angi,amin
        pi = 3.14159265359
        ang=angi*180./pi
        ang=mod(ang,360.d00)
        if ((k.eq.3).and.(ang.lt.0.)) ang=ang+360.
        if (k.eq.2.and.ang.gt.180.) ang=ang-360.
        if (k.eq.3) ang=ang/15.
        gra=int(ang)
        amin=60.*(ang-float(gra))
        min=int(amin)
        sec=nint(60.*(amin-float(min)))
        return
        end subroutine cgms
!
!
        subroutine ditra (an,me,di,dt,jd)
!
!   subrutina para calcular los dias transcurridos desde el comienzo de nuestra
!   era. ano 1, mes 1 y dia 1 dara 0 dias transcurridos.
!
!       an = ano                        (input integer*4)
!       me = mes                        (input integer*4)
!       di = dia                        (input integer*4)
!       dt = dias transcurridos         (output integer*4)
!       jd = julian date                (output real*4)
!
        integer         k,ab,an,me,di,dt
        real*8          jd
!
        k=1
        if (me.le.2) k=0
        ab=an+k-1
        dt=(an-1)*365+int(ab/4.)-int(ab/100.)+int(ab/400.)  &
           +(me-1)*31+di-1-k*int(.4*float(me)+2.3)
        jd=float(dt)+1721425.5
        return
        end subroutine ditra
!
!
        subroutine getst (dt,gst,lst)
!
!   subrutina para obtener gst (greenwich sidereal time) y lst (local sidereal
!   time) conociendo los dt (dias transcurridos) desde el comienzo de nuestra
!   era.
!
!       dt  = dias transcurridos desde comienzo era     (input real*8)
!       gst = greenwich sidereal time (fraction of day) (output real*8)
!       lst = loca sidereal time at 30m radiotelescope  (output real*8)
!
        real*8  dt,gst,lst,dtb
!
        dtb=dt-723910.          ! dias transcurridos desde comienzo 1983
        gst=.27800846065+1.002737909315*dtb
        if (gst.lt.0.) gst=gst-int(gst)+1.
        gst=gst-int(gst)
        lst=gst-0.009442978     ! local sidereal time
        return
        end subroutine getst
!
subroutine parse_file_name(file,basename,wk,vers,error)
  !---------------------------------------------------------------------
  ! @ private
  ! Decode the file version from file name. File name must have the form
  !   wk12v3.dat  (1 or more digits for the version).
  ! Return version as an integer
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file      !
  character(len=*), intent(out)   :: basename  !
  integer(kind=4),  intent(out)   :: wk        ! Week number
  integer(kind=4),  intent(out)   :: vers      ! Version
  logical,          intent(inout) :: error     !
  ! Local
  integer :: vpos,dpos,ier
  !
  vpos = index(file,'v')+1
  dpos = index(file,'.')-1
  basename = file(1:dpos)
  !
  read(file(3:4),*,iostat=ier)  wk
  if (ier.ne.0) then
    write(6,*) 'Error getting week number from file name '//trim(file)
    error = .true.
    return
  endif
  !
  read(file(vpos:dpos),*,iostat=ier)  vers
  if (ier.ne.0) then
    write(6,*) 'Error getting version from file name '//trim(file)
    error = .true.
    return
  endif
  !
end subroutine parse_file_name

subroutine clic_header(line,error)
  use gkernel_interfaces
  use astro_interfaces_public
  use clic_title
  use classic_api
  use astro_types
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local copies of astro global variables
  ! From aline.inc
  real*8 :: flo1
  integer :: plot_mode
  integer :: sky
  logical :: narrow_def
  integer :: narrow_input(6)
  integer :: nunit
  parameter (nunit=12)
  logical :: unit_def(nunit)
  integer :: unit_band(nunit)
  real :: unit_cent(nunit)
  integer :: unit_wind(nunit)
  character(len=132) :: label
  type(astro_noemasetup_t) :: clic
  ! From astro.inc
  real*8 :: fshift
  integer :: i, quarter, isb, icorrmode(mrlband)
  character(len=4) :: lock
  character(len=3) :: band
  character(len=12) :: arg
  integer :: harm, irec, mult, narg, mvocab, nkey
  real*8 :: fcent, vsys, eps,hh, fmin, fmax
  parameter(mvocab=3)
  character(len=6) :: vocab(mvocab), keyword
  data vocab/'LINE','NARROW','WIDEX'/
  !------------------------------------------------------------------------
  ! Code
  call out0('Terminal',0,0,error)
  call titout('Full',error)
  call out1(error)
  !
  ! HEADER /PLOT
  !
  if ((sic_present(1,0).or.sic_present(2,0)).and.(.not.error)) then
    if (title%kind.ne.5) then
      call message(2,2,'HEADER',   &
        ' /PLOT option invalid for old receivers (<2007)')
    else
      if (r_lnch(1).eq.2032) then   ! Polyfix
        isb = (3-r_isb)/2
        call astro_noemasetup_receiver('CLIC',clic%rec,r_flo1,r_fif1,isb,&
              r_line,r_sourc,real(r_doppl,kind=8),error)
        !
        ! Astro needs matching corrmode for spw pertaining to a bb
        icorrmode = 1
        if (r_nbb.lt.r_lband) then 
          do i=r_nbb+1, r_lband
            if (abs(r_lfres(i)).eq.0.250) then
              icorrmode(i) = 3
              icorrmode(r_bb(i)) = 3
            endif
          enddo
        endif
        do i=1, r_lband
          fmin = r_lfcen(i)+(1-r_lcench(i))*r_lfres(i)
          fmax = r_lfcen(i)+(r_lnch(i)-r_lcench(i))*r_lfres(i)
          fmax = min(fmax,3870d0)
          call astro_noemasetup_spw('CLIC',clic%spw,fmin,fmax, &
              real(r_lfres(i),kind=8), r_bbname(r_bb(i)),r_lnam(1,i),&
              icorrmode(i),error)
        enddo
        if (sic_present(1,0)) then
          call astro_noemasetup_plot('CLIC',clic,pm_receiver,freqax_if1, &
                .true.,error)
        elseif (sic_present(2,0)) then
          call astro_noemasetup_list('CLIC',clic,.true.,error)
        endif
      else
        ! 
        ! plot narrow or plot widex
       !
        plot_mode = 2 ! default is NARROW plot
        if (sic_present(1,1)) then
          call sic_ke(line,1,1,arg,narg,.true.,error)
           if (error) return
           call sic_ambigs('HEADER',arg,keyword,nkey,vocab,mvocab,error)
           if (error) return
           plot_mode = nkey
        endif
        !
        ! Define parameters needed by ASTRO commands
        !
        call pdbi_plot_def(error)
        if (error) return
        !
        ! Frequency
        !
        !            FLO1 = R_FLO1-R_DOPPL*R_RESTF ! Also correct
        flo1 = r_restf-r_isb*r_fif1
        sky = r_isb
        fshift = 1.
        !
        ! Spectral units
        !
        narrow_def = .true.
        do i = 1,r_lband
          unit_def(i) = .true.
          unit_band(i) = r_lnch(i)*abs(r_lfres(i))
          unit_cent(i) = r_lfcen(i)
          unit_wind(i) = r_bb(i)
          narrow_input(unit_wind(i)) =   &
            quarter(r_flo2(i),r_flo2bis(i))
        enddo
        !
        ! Plot label (LINE command)
        !
        if (r_isb.gt.0) then
          band = 'USB'
        else
          band = 'LSB'
        endif
        if (r_lock.gt.0) then
          lock = 'HIGH'
        else
          lock = 'LOW'
        endif
        fcent = r_fif1
        irec = r_nrec
        mult = r_nrec
        eps = 100.25d0
        hh = (flo1/mult+r_lock*eps)/r_flo1_ref
        harm = int(hh)
        if (hh.ne.harm) then
          call message(2,2,'HEADER',' Non-integer HARM number?')
        endif
        vsys = r_veloc
        write(label,1000)   &
          r_line(1:lenc(r_line)),   &
          r_restf*1d-3/fshift, band, lock, fcent, harm,   &
          '  /RECEIVER',irec,'   [V= ',vsys,' km/s]'
        !
        ! Synchronize local with astro-global variables
        !
        call pdbi_plot_sync(flo1,plot_mode,sky,narrow_def,   &
          narrow_input,unit_def,unit_band,unit_cent,   &
          unit_wind,fshift,label)
        !
        ! Now do the plot
        !
        call pdbi_plot_line(error)
        if (error) return
        !
      endif
    endif
  endif
1000 format('LINE ',a,1x,f11.6,1x,a,1x,a,1x,f7.2,1x,i2,a,i2,a,f6.1,a)
!
end subroutine clic_header

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_spectral
  use cubetools_parameters
  use cubetools_structure
  use cubetopology_speline_types
  use cubetopology_spevsys_types
  use cubetopology_sperange_types
  use cubeset_messaging
  !
  public :: spectral
  public :: userspe
  private
  !
  type :: spectral_comm_t
     type(option_t), pointer :: comm
     type(option_t), pointer :: defaults 
     type(speline_opt_t)     :: freq     
     type(spevsys_opt_t)     :: vsys
     type(sperange_opt_t)    :: range
   contains
     procedure, public  :: register => cubeset_spectral_register
     procedure, private :: parse    => cubeset_spectral_parse
  end type spectral_comm_t
  type(spectral_comm_t) :: spectral 
  !
  type spectral_user_t
     logical               :: dolist = .false.
     logical               :: dodefaults = .false.
     type(speline_user_t)  :: freq
     type(spevsys_user_t)  :: vsys
     type(sperange_user_t) :: range
   contains
     procedure :: init   => cubeset_spectral_user_init
     procedure :: toprog => cubeset_spectral_user_toprog
     procedure :: list   => cubeset_spectral_user_list
  end type spectral_user_t
  type(spectral_user_t) :: userspe
  !
contains
  !
  subroutine cubeset_spectral_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call spectral%parse(line,error)
    if (error) return
    if (userspe%dodefaults) then
       call userspe%init(error)
       if (error) return
    else
       ! Do nothing
    endif
    if (userspe%dolist) then
       call userspe%list(error)
       if (error) return
    else
       ! Do nothing
    endif
  end subroutine cubeset_spectral_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_spectral_register(spectral,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(spectral_comm_t), intent(inout) :: spectral
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'SPECTRAL','',&
         'Set the spectral region of interest',&
         'Without options, SPECTRAL lists the current spectral defaults.'//strg_cr//&
         'Use /DEFAULT to reset all spectral defaults. If /DEFAULT is&
         & combined with other keys on the same command line, reset takes&
         precedence.'//strg_cr//&
         'Use /FREQUENCY, /VSYS, and /RANGE to tune the line rest frequency,'//strg_cr//&
         'source systemic velocity, and spectral range settings for the spectral'//strg_cr//&
         'region of interest.'//strg_bl//&
         'Associated commands: SET\SPATIAL.',&
         cubeset_spectral_command,&
         spectral%comm,&
         error)
    if (error) return
    call spectral%range%register(&
         'RANGE',&
         'Set the spectral-axis range',&
         error)
    if (error) return
    call spectral%freq%register(&
         'Set the line name, rest frequency, and its unit',&
         error)
    if (error) return
    call spectral%vsys%register(&
         'Set the source systemic velocity',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEFAULT','',&
         'Reset spectral settings',&
         'Reset SPECTRAL settings. If /DEFAULT is combined with other keys&
         & on the same command line, reset takes precedence.',&
         spectral%defaults,&
         error)
    if (error) return
  end subroutine cubeset_spectral_register
  !
  subroutine cubeset_spectral_parse(spectral,line,error)
    !-------------------------------------------------------------------
    ! SPECTRAL 
    ! /FREQUENCY line freq [unit]
    ! /VELOCITY vsys [unit]
    ! /RANGE first last [unit]
    ! /DEFAULT
    !-------------------------------------------------------------------
    class(spectral_comm_t), intent(in)    :: spectral
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (cubetools_nopt().eq.0) then
       userspe%dolist = .true.
    else
       userspe%dolist = .false.
       call spectral%defaults%present(line,userspe%dodefaults,error)
       if (error) return
       call spectral%freq%parse(line,userspe%freq,error)
       if (error) return
       call spectral%vsys%parse(line,userspe%vsys,error)
       if (error) return
       call spectral%range%parse(line,userspe%range,error)
       if (error) return
    endif
  end subroutine cubeset_spectral_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeset_spectral_user_init(user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(spectral_user_t), intent(inout) :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>USER>INIT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%freq%init(error)
    if (error) return
    call user%vsys%init(error)
    if (error) return
    call user%range%init(error)
    if (error) return
  end subroutine cubeset_spectral_user_init
  !
  subroutine cubeset_spectral_user_toprog(user,cube,truncate_mode,freq,vsys,range,error)
    use cube_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(spectral_user_t), intent(inout) :: user
    type(cube_t), pointer,  intent(in)    :: cube
    integer(kind=code_k),   intent(in)    :: truncate_mode
    type(speline_prog_t),   intent(out)   :: freq
    type(spevsys_prog_t),   intent(out)   :: vsys
    type(sperange_prog_t),  intent(out)   :: range
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>USER>TOPROG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%freq%toprog(cube,freq,error)
    if (error) return
    call user%vsys%toprog(cube,vsys,error)
    if (error) return
    call user%range%toprog(cube,truncate_mode,range,error)
    if (error) return
  end subroutine cubeset_spectral_user_toprog
  !
  subroutine cubeset_spectral_user_list(user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(spectral_user_t), intent(in)    :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>USER>LIST'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubeset_message(seve%r,rname,blankstr)
    call user%freq%list(error)
    if (error) return
    call user%vsys%list(error)
    if (error) return
    call user%range%list(error)
    if (error) return
    call cubeset_message(seve%r,rname,blankstr)
  end subroutine cubeset_spectral_user_list
end module cubeset_spectral
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK GAMI
      FUNCTION GAMI (A, X)
C***BEGIN PROLOGUE  GAMI
C***PURPOSE  Evaluate the incomplete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      SINGLE PRECISION (GAMI-S, DGAMI-D)
C***KEYWORDS  FNLIB, INCOMPLETE GAMMA FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Evaluate the incomplete gamma function defined by
C
C GAMI = integral from T = 0 to X of EXP(-T) * T**(A-1.0) .
C
C GAMI is evaluated for positive values of A and non-negative values
C of X.  A slight deterioration of 2 or 3 digits accuracy will occur
C when GAMI is very large or very small, because logarithmic variables
C are used.  GAMI, A, and X are single precision.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ALNGAM, GAMIT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  GAMI
C***FIRST EXECUTABLE STATEMENT  GAMI
      IF (A .LE. 0.0) CALL XERMSG ('SLATEC', 'GAMI',
     +   'A MUST BE GT ZERO', 1, 2)
      IF (X .LT. 0.0) CALL XERMSG ('SLATEC', 'GAMI',
     +   'X MUST BE GE ZERO', 2, 2)
C
      GAMI = 0.0
      IF (X.EQ.0.0) RETURN
C
C THE ONLY ERROR POSSIBLE IN THE EXPRESSION BELOW IS A FATAL OVERFLOW.
      FACTOR = EXP (ALNGAM(A) + A*LOG(X) )
C
      GAMI = FACTOR * GAMIT(A, X)
C
      RETURN
      END
*DECK GAMIC
      REAL FUNCTION GAMIC (A, X)
C***BEGIN PROLOGUE  GAMIC
C***PURPOSE  Calculate the complementary incomplete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      SINGLE PRECISION (GAMIC-S, DGAMIC-D)
C***KEYWORDS  COMPLEMENTARY INCOMPLETE GAMMA FUNCTION, FNLIB,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C   Evaluate the complementary incomplete gamma function
C
C   GAMIC = integral from X to infinity of EXP(-T) * T**(A-1.)  .
C
C   GAMIC is evaluated for arbitrary real values of A and for non-
C   negative values of X (even though GAMIC is defined for X .LT.
C   0.0), except that for X = 0 and A .LE. 0.0, GAMIC is undefined.
C
C   GAMIC, A, and X are REAL.
C
C   A slight deterioration of 2 or 3 digits accuracy will occur when
C   GAMIC is very large or very small in absolute value, because log-
C   arithmic variables are used.  Also, if the parameter A is very close
C   to a negative integer (but not a negative integer), there is a loss
C   of accuracy, which is reported if the result is less than half
C   machine precision.
C
C***REFERENCES  W. Gautschi, A computational procedure for incomplete
C                 gamma functions, ACM Transactions on Mathematical
C                 Software 5, 4 (December 1979), pp. 466-481.
C               W. Gautschi, Incomplete gamma functions, Algorithm 542,
C                 ACM Transactions on Mathematical Software 5, 4
C                 (December 1979), pp. 482-489.
C***ROUTINES CALLED  ALGAMS, ALNGAM, R1MACH, R9GMIC, R9GMIT, R9LGIC,
C                    R9LGIT, XERCLR, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920528  DESCRIPTION and REFERENCES sections revised.  (WRB)
C***END PROLOGUE  GAMIC
      LOGICAL FIRST
      SAVE EPS, SQEPS, ALNEPS, BOT, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  GAMIC
      IF (FIRST) THEN
         EPS = 0.5*R1MACH(3)
         SQEPS = SQRT(R1MACH(4))
         ALNEPS = -LOG(R1MACH(3))
         BOT = LOG(R1MACH(1))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 0.0) CALL XERMSG ('SLATEC', 'GAMIC', 'X IS NEGATIVE',
     +   2, 2)
C
      IF (X.GT.0.0) GO TO 20
      IF (A .LE. 0.0) CALL XERMSG ('SLATEC', 'GAMIC',
     +   'X = 0 AND A LE 0 SO GAMIC IS UNDEFINED', 3, 2)
C
      GAMIC = EXP (ALNGAM(A+1.0) - LOG(A))
      RETURN
C
 20   ALX = LOG(X)
      SGA = 1.0
      IF (A.NE.0.0) SGA = SIGN (1.0, A)
      MA = A + 0.5*SGA
      AEPS = A - MA
C
      IZERO = 0
      IF (X.GE.1.0) GO TO 60
C
      IF (A.GT.0.5 .OR. ABS(AEPS).GT.0.001) GO TO 50
      FM = -MA
      E = 2.0
      IF (FM.GT.1.0) E = 2.0*(FM+2.0)/(FM*FM-1.0)
      E = E - ALX*X**(-0.001)
      IF (E*ABS(AEPS).GT.EPS) GO TO 50
C
      GAMIC = R9GMIC (A, X, ALX)
      RETURN
C
 50   CALL ALGAMS (A+1.0, ALGAP1, SGNGAM)
      GSTAR = R9GMIT (A, X, ALGAP1, SGNGAM, ALX)
      IF (GSTAR.EQ.0.0) IZERO = 1
      IF (GSTAR.NE.0.0) ALNGS = LOG (ABS(GSTAR))
      IF (GSTAR.NE.0.0) SGNGS = SIGN (1.0, GSTAR)
      GO TO 70
C
 60   IF (A.LT.X) GAMIC = EXP (R9LGIC(A, X, ALX))
      IF (A.LT.X) RETURN
C
      SGNGAM = 1.0
      ALGAP1 = ALNGAM (A+1.0)
      SGNGS = 1.0
      ALNGS = R9LGIT (A, X, ALGAP1)
C
C EVALUATION OF GAMIC(A,X) IN TERMS OF TRICOMI-S INCOMPLETE GAMMA FN.
C
 70   H = 1.0
      IF (IZERO.EQ.1) GO TO 80
C
      T = A*ALX + ALNGS
      IF (T.GT.ALNEPS) GO TO 90
      IF (T.GT.(-ALNEPS)) H = 1.0 - SGNGS*EXP(T)
C
      IF (ABS(H).LT.SQEPS) CALL XERCLR
      IF (ABS(H) .LT. SQEPS) CALL XERMSG ('SLATEC', 'GAMIC',
     +   'RESULT LT HALF PRECISION', 1, 1)
C
 80   SGNG = SIGN (1.0, H) * SGA * SGNGAM
      T = LOG(ABS(H)) + ALGAP1 - LOG(ABS(A))
      IF (T.LT.BOT) CALL XERCLR
      GAMIC = SGNG * EXP(T)
      RETURN
C
 90   SGNG = -SGNGS * SGA * SGNGAM
      T = T + ALGAP1 - LOG(ABS(A))
      IF (T.LT.BOT) CALL XERCLR
      GAMIC = SGNG * EXP(T)
      RETURN
C
      END
*DECK GAMIT
      REAL FUNCTION GAMIT (A, X)
C***BEGIN PROLOGUE  GAMIT
C***PURPOSE  Calculate Tricomi's form of the incomplete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      SINGLE PRECISION (GAMIT-S, DGAMIT-D)
C***KEYWORDS  COMPLEMENTARY INCOMPLETE GAMMA FUNCTION, FNLIB,
C             SPECIAL FUNCTIONS, TRICOMI
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C   Evaluate Tricomi's incomplete gamma function defined by
C
C   GAMIT = X**(-A)/GAMMA(A) * integral from 0 to X of EXP(-T) *
C             T**(A-1.)
C
C   for A .GT. 0.0 and by analytic continuation for A .LE. 0.0.
C   GAMMA(X) is the complete gamma function of X.
C
C   GAMIT is evaluated for arbitrary real values of A and for non-
C   negative values of X (even though GAMIT is defined for X .LT.
C   0.0), except that for X = 0 and A .LE. 0.0, GAMIT is infinite,
C   which is a fatal error.
C
C   The function and both arguments are REAL.
C
C   A slight deterioration of 2 or 3 digits accuracy will occur when
C   GAMIT is very large or very small in absolute value, because log-
C   arithmic variables are used.  Also, if the parameter  A  is very
C   close to a negative integer (but not a negative integer), there is
C   a loss of accuracy, which is reported if the result is less than
C   half machine precision.
C
C***REFERENCES  W. Gautschi, A computational procedure for incomplete
C                 gamma functions, ACM Transactions on Mathematical
C                 Software 5, 4 (December 1979), pp. 466-481.
C               W. Gautschi, Incomplete gamma functions, Algorithm 542,
C                 ACM Transactions on Mathematical Software 5, 4
C                 (December 1979), pp. 482-489.
C***ROUTINES CALLED  ALGAMS, ALNGAM, GAMR, R1MACH, R9GMIT, R9LGIC,
C                    R9LGIT, XERCLR, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920528  DESCRIPTION and REFERENCES sections revised.  (WRB)
C***END PROLOGUE  GAMIT
      LOGICAL FIRST
      SAVE ALNEPS, SQEPS, BOT, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  GAMIT
      IF (FIRST) THEN
         ALNEPS = -LOG(R1MACH(3))
         SQEPS = SQRT(R1MACH(4))
         BOT = LOG(R1MACH(1))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 0.0) CALL XERMSG ('SLATEC', 'GAMIT', 'X IS NEGATIVE',
     +   2, 2)
C
      IF (X.NE.0.0) ALX = LOG(X)
      SGA = 1.0
      IF (A.NE.0.0) SGA = SIGN (1.0, A)
      AINTA = AINT (A+0.5*SGA)
      AEPS = A - AINTA
C
      IF (X.GT.0.0) GO TO 20
      GAMIT = 0.0
      IF (AINTA.GT.0.0 .OR. AEPS.NE.0.0) GAMIT = GAMR(A+1.0)
      RETURN
C
 20   IF (X.GT.1.0) GO TO 40
      IF (A.GE.(-0.5) .OR. AEPS.NE.0.0) CALL ALGAMS (A+1.0, ALGAP1,
     1  SGNGAM)
      GAMIT = R9GMIT (A, X, ALGAP1, SGNGAM, ALX)
      RETURN
C
 40   IF (A.LT.X) GO TO 50
      T = R9LGIT (A, X, ALNGAM(A+1.0))
      IF (T.LT.BOT) CALL XERCLR
      GAMIT = EXP(T)
      RETURN
C
 50   ALNG = R9LGIC (A, X, ALX)
C
C EVALUATE GAMIT IN TERMS OF LOG(GAMIC(A,X))
C
      H = 1.0
      IF (AEPS.EQ.0.0 .AND. AINTA.LE.0.0) GO TO 60
      CALL ALGAMS (A+1.0, ALGAP1, SGNGAM)
      T = LOG(ABS(A)) + ALNG - ALGAP1
      IF (T.GT.ALNEPS) GO TO 70
      IF (T.GT.(-ALNEPS)) H = 1.0 - SGA*SGNGAM*EXP(T)
      IF (ABS(H).GT.SQEPS) GO TO 60
      CALL XERCLR
      CALL XERMSG ('SLATEC', 'GAMIT', 'RESULT LT HALF PRECISION', 1, 1)
C
 60   T = -A*ALX + LOG(ABS(H))
      IF (T.LT.BOT) CALL XERCLR
      GAMIT = SIGN (EXP(T), H)
      RETURN
C
 70   T = T - A*ALX
      IF (T.LT.BOT) CALL XERCLR
      GAMIT = -SGA*SGNGAM*EXP(T)
      RETURN
C
      END
*DECK GAMLIM
      SUBROUTINE GAMLIM (XMIN, XMAX)
C***BEGIN PROLOGUE  GAMLIM
C***PURPOSE  Compute the minimum and maximum bounds for the argument in
C            the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A, R2
C***TYPE      SINGLE PRECISION (GAMLIM-S, DGAMLM-D)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, LIMITS, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Calculate the minimum and maximum legal bounds for X in GAMMA(X).
C XMIN and XMAX are not the only bounds, but they are the only non-
C trivial ones to calculate.
C
C             Output Arguments --
C XMIN   minimum legal value of X in GAMMA(X).  Any smaller value of
C        X might result in underflow.
C XMAX   maximum legal value of X in GAMMA(X).  Any larger value will
C        cause overflow.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  GAMLIM
C***FIRST EXECUTABLE STATEMENT  GAMLIM
      ALNSML = LOG(R1MACH(1))
      XMIN = -ALNSML
      DO 10 I=1,10
        XOLD = XMIN
        XLN = LOG(XMIN)
        XMIN = XMIN - XMIN*((XMIN+0.5)*XLN - XMIN - 0.2258 + ALNSML)
     1    / (XMIN*XLN + 0.5)
        IF (ABS(XMIN-XOLD).LT.0.005) GO TO 20
 10   CONTINUE
      CALL XERMSG ('SLATEC', 'GAMLIM', 'UNABLE TO FIND XMIN', 1, 2)
C
 20   XMIN = -XMIN + 0.01
C
      ALNBIG = LOG(R1MACH(2))
      XMAX = ALNBIG
      DO 30 I=1,10
        XOLD = XMAX
        XLN = LOG(XMAX)
        XMAX = XMAX - XMAX*((XMAX-0.5)*XLN - XMAX + 0.9189 - ALNBIG)
     1    / (XMAX*XLN - 0.5)
        IF (ABS(XMAX-XOLD).LT.0.005) GO TO 40
 30   CONTINUE
      CALL XERMSG ('SLATEC', 'GAMLIM', 'UNABLE TO FIND XMAX', 2, 2)
C
 40   XMAX = XMAX - 0.01
      XMIN = MAX (XMIN, -XMAX+1.)
C
      RETURN
      END
*DECK GAMLN
      REAL FUNCTION GAMLN (Z, IERR)
C***BEGIN PROLOGUE  GAMLN
C***SUBSIDIARY
C***PURPOSE  Compute the logarithm of the Gamma function
C***LIBRARY   SLATEC
C***CATEGORY  C7A
C***TYPE      SINGLE PRECISION (GAMLN-S, DGAMLN-D)
C***KEYWORDS  LOGARITHM OF GAMMA FUNCTION
C***AUTHOR  Amos, D. E., (SNL)
C***DESCRIPTION
C
C         GAMLN COMPUTES THE NATURAL LOG OF THE GAMMA FUNCTION FOR
C         Z.GT.0.  THE ASYMPTOTIC EXPANSION IS USED TO GENERATE VALUES
C         GREATER THAN ZMIN WHICH ARE ADJUSTED BY THE RECURSION
C         G(Z+1)=Z*G(Z) FOR Z.LE.ZMIN.  THE FUNCTION WAS MADE AS
C         PORTABLE AS POSSIBLE BY COMPUTING ZMIN FROM THE NUMBER OF BASE
C         10 DIGITS IN A WORD, RLN=MAX(-ALOG10(R1MACH(4)),0.5E-18)
C         LIMITED TO 18 DIGITS OF (RELATIVE) ACCURACY.
C
C         SINCE INTEGER ARGUMENTS ARE COMMON, A TABLE LOOK UP ON 100
C         VALUES IS USED FOR SPEED OF EXECUTION.
C
C     DESCRIPTION OF ARGUMENTS
C
C         INPUT
C           Z      - REAL ARGUMENT, Z.GT.0.0E0
C
C         OUTPUT
C           GAMLN  - NATURAL LOG OF THE GAMMA FUNCTION AT Z
C           IERR   - ERROR FLAG
C                    IERR=0, NORMAL RETURN, COMPUTATION COMPLETED
C                    IERR=1, Z.LE.0.0E0,    NO COMPUTATION
C
C***REFERENCES  COMPUTATION OF BESSEL FUNCTIONS OF COMPLEX ARGUMENT
C                 BY D. E. AMOS, SAND83-0083, MAY, 1983.
C***ROUTINES CALLED  I1MACH, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   830501  REVISION DATE from Version 3.2
C   910415  Prologue converted to Version 4.0 format.  (BAB)
C   920128  Category corrected.  (WRB)
C   921215  GAMLN defined for Z negative.  (WRB)
C***END PROLOGUE  GAMLN
C
      INTEGER I, I1M, K, MZ, NZ, IERR, I1MACH
      REAL CF, CON, FLN, FZ, GLN, RLN, S, TLG, TRM, TST, T1, WDTOL, Z,
     * ZDMY, ZINC, ZM, ZMIN, ZP, ZSQ
      REAL R1MACH
      DIMENSION CF(22), GLN(100)
C           LNGAMMA(N), N=1,100
      DATA GLN(1), GLN(2), GLN(3), GLN(4), GLN(5), GLN(6), GLN(7),
     1     GLN(8), GLN(9), GLN(10), GLN(11), GLN(12), GLN(13), GLN(14),
     2     GLN(15), GLN(16), GLN(17), GLN(18), GLN(19), GLN(20),
     3     GLN(21), GLN(22)/
     4     0.00000000000000000E+00,     0.00000000000000000E+00,
     5     6.93147180559945309E-01,     1.79175946922805500E+00,
     6     3.17805383034794562E+00,     4.78749174278204599E+00,
     7     6.57925121201010100E+00,     8.52516136106541430E+00,
     8     1.06046029027452502E+01,     1.28018274800814696E+01,
     9     1.51044125730755153E+01,     1.75023078458738858E+01,
     A     1.99872144956618861E+01,     2.25521638531234229E+01,
     B     2.51912211827386815E+01,     2.78992713838408916E+01,
     C     3.06718601060806728E+01,     3.35050734501368889E+01,
     D     3.63954452080330536E+01,     3.93398841871994940E+01,
     E     4.23356164607534850E+01,     4.53801388984769080E+01/
      DATA GLN(23), GLN(24), GLN(25), GLN(26), GLN(27), GLN(28),
     1     GLN(29), GLN(30), GLN(31), GLN(32), GLN(33), GLN(34),
     2     GLN(35), GLN(36), GLN(37), GLN(38), GLN(39), GLN(40),
     3     GLN(41), GLN(42), GLN(43), GLN(44)/
     4     4.84711813518352239E+01,     5.16066755677643736E+01,
     5     5.47847293981123192E+01,     5.80036052229805199E+01,
     6     6.12617017610020020E+01,     6.45575386270063311E+01,
     7     6.78897431371815350E+01,     7.12570389671680090E+01,
     8     7.46582363488301644E+01,     7.80922235533153106E+01,
     9     8.15579594561150372E+01,     8.50544670175815174E+01,
     A     8.85808275421976788E+01,     9.21361756036870925E+01,
     B     9.57196945421432025E+01,     9.93306124547874269E+01,
     C     1.02968198614513813E+02,     1.06631760260643459E+02,
     D     1.10320639714757395E+02,     1.14034211781461703E+02,
     E     1.17771881399745072E+02,     1.21533081515438634E+02/
      DATA GLN(45), GLN(46), GLN(47), GLN(48), GLN(49), GLN(50),
     1     GLN(51), GLN(52), GLN(53), GLN(54), GLN(55), GLN(56),
     2     GLN(57), GLN(58), GLN(59), GLN(60), GLN(61), GLN(62),
     3     GLN(63), GLN(64), GLN(65), GLN(66)/
     4     1.25317271149356895E+02,     1.29123933639127215E+02,
     5     1.32952575035616310E+02,     1.36802722637326368E+02,
     6     1.40673923648234259E+02,     1.44565743946344886E+02,
     7     1.48477766951773032E+02,     1.52409592584497358E+02,
     8     1.56360836303078785E+02,     1.60331128216630907E+02,
     9     1.64320112263195181E+02,     1.68327445448427652E+02,
     A     1.72352797139162802E+02,     1.76395848406997352E+02,
     B     1.80456291417543771E+02,     1.84533828861449491E+02,
     C     1.88628173423671591E+02,     1.92739047287844902E+02,
     D     1.96866181672889994E+02,     2.01009316399281527E+02,
     E     2.05168199482641199E+02,     2.09342586752536836E+02/
      DATA GLN(67), GLN(68), GLN(69), GLN(70), GLN(71), GLN(72),
     1     GLN(73), GLN(74), GLN(75), GLN(76), GLN(77), GLN(78),
     2     GLN(79), GLN(80), GLN(81), GLN(82), GLN(83), GLN(84),
     3     GLN(85), GLN(86), GLN(87), GLN(88)/
     4     2.13532241494563261E+02,     2.17736934113954227E+02,
     5     2.21956441819130334E+02,     2.26190548323727593E+02,
     6     2.30439043565776952E+02,     2.34701723442818268E+02,
     7     2.38978389561834323E+02,     2.43268849002982714E+02,
     8     2.47572914096186884E+02,     2.51890402209723194E+02,
     9     2.56221135550009525E+02,     2.60564940971863209E+02,
     A     2.64921649798552801E+02,     2.69291097651019823E+02,
     B     2.73673124285693704E+02,     2.78067573440366143E+02,
     C     2.82474292687630396E+02,     2.86893133295426994E+02,
     D     2.91323950094270308E+02,     2.95766601350760624E+02,
     E     3.00220948647014132E+02,     3.04686856765668715E+02/
      DATA GLN(89), GLN(90), GLN(91), GLN(92), GLN(93), GLN(94),
     1     GLN(95), GLN(96), GLN(97), GLN(98), GLN(99), GLN(100)/
     2     3.09164193580146922E+02,     3.13652829949879062E+02,
     3     3.18152639620209327E+02,     3.22663499126726177E+02,
     4     3.27185287703775217E+02,     3.31717887196928473E+02,
     5     3.36261181979198477E+02,     3.40815058870799018E+02,
     6     3.45379407062266854E+02,     3.49954118040770237E+02,
     7     3.54539085519440809E+02,     3.59134205369575399E+02/
C             COEFFICIENTS OF ASYMPTOTIC EXPANSION
      DATA CF(1), CF(2), CF(3), CF(4), CF(5), CF(6), CF(7), CF(8),
     1     CF(9), CF(10), CF(11), CF(12), CF(13), CF(14), CF(15),
     2     CF(16), CF(17), CF(18), CF(19), CF(20), CF(21), CF(22)/
     3     8.33333333333333333E-02,    -2.77777777777777778E-03,
     4     7.93650793650793651E-04,    -5.95238095238095238E-04,
     5     8.41750841750841751E-04,    -1.91752691752691753E-03,
     6     6.41025641025641026E-03,    -2.95506535947712418E-02,
     7     1.79644372368830573E-01,    -1.39243221690590112E+00,
     8     1.34028640441683920E+01,    -1.56848284626002017E+02,
     9     2.19310333333333333E+03,    -3.61087712537249894E+04,
     A     6.91472268851313067E+05,    -1.52382215394074162E+07,
     B     3.82900751391414141E+08,    -1.08822660357843911E+10,
     C     3.47320283765002252E+11,    -1.23696021422692745E+13,
     D     4.88788064793079335E+14,    -2.13203339609193739E+16/
C
C             LN(2*PI)
      DATA CON                    /     1.83787706640934548E+00/
C
C***FIRST EXECUTABLE STATEMENT  GAMLN
      IERR=0
      IF (Z.LE.0.0E0) GO TO 70
      IF (Z.GT.101.0E0) GO TO 10
      NZ = Z
      FZ = Z - NZ
      IF (FZ.GT.0.0E0) GO TO 10
      IF (NZ.GT.100) GO TO 10
      GAMLN = GLN(NZ)
      RETURN
   10 CONTINUE
      WDTOL = R1MACH(4)
      WDTOL = MAX(WDTOL,0.5E-18)
      I1M = I1MACH(11)
      RLN = R1MACH(5)*I1M
      FLN = MIN(RLN,20.0E0)
      FLN = MAX(FLN,3.0E0)
      FLN = FLN - 3.0E0
      ZM = 1.8000E0 + 0.3875E0*FLN
      MZ = ZM + 1
      ZMIN = MZ
      ZDMY = Z
      ZINC = 0.0E0
      IF (Z.GE.ZMIN) GO TO 20
      ZINC = ZMIN - NZ
      ZDMY = Z + ZINC
   20 CONTINUE
      ZP = 1.0E0/ZDMY
      T1 = CF(1)*ZP
      S = T1
      IF (ZP.LT.WDTOL) GO TO 40
      ZSQ = ZP*ZP
      TST = T1*WDTOL
      DO 30 K=2,22
        ZP = ZP*ZSQ
        TRM = CF(K)*ZP
        IF (ABS(TRM).LT.TST) GO TO 40
        S = S + TRM
   30 CONTINUE
   40 CONTINUE
      IF (ZINC.NE.0.0E0) GO TO 50
      TLG = ALOG(Z)
      GAMLN = Z*(TLG-1.0E0) + 0.5E0*(CON-TLG) + S
      RETURN
   50 CONTINUE
      ZP = 1.0E0
      NZ = ZINC
      DO 60 I=1,NZ
        ZP = ZP*(Z+(I-1))
   60 CONTINUE
      TLG = ALOG(ZDMY)
      GAMLN = ZDMY*(TLG-1.0E0) - ALOG(ZP) + 0.5E0*(CON-TLG) + S
      RETURN
C
C
   70 CONTINUE
      GAMLN = R1MACH(2)
      IERR=1
      RETURN
      END
*DECK GAMMA
      FUNCTION GAMMA (X)
C***BEGIN PROLOGUE  GAMMA
C***PURPOSE  Compute the complete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      SINGLE PRECISION (GAMMA-S, DGAMMA-D, CGAMMA-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C GAMMA computes the gamma function at X, where X is not 0, -1, -2, ....
C GAMMA and X are single precision.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, GAMLIM, INITS, R1MACH, R9LGMC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  GAMMA
      DIMENSION GCS(23)
      LOGICAL FIRST
      SAVE GCS, PI, SQ2PIL, NGCS, XMIN, XMAX, DXREL, FIRST
      DATA GCS   ( 1) / .0085711955 90989331E0/
      DATA GCS   ( 2) / .0044153813 24841007E0/
      DATA GCS   ( 3) / .0568504368 1599363E0/
      DATA GCS   ( 4) /-.0042198353 96418561E0/
      DATA GCS   ( 5) / .0013268081 81212460E0/
      DATA GCS   ( 6) /-.0001893024 529798880E0/
      DATA GCS   ( 7) / .0000360692 532744124E0/
      DATA GCS   ( 8) /-.0000060567 619044608E0/
      DATA GCS   ( 9) / .0000010558 295463022E0/
      DATA GCS   (10) /-.0000001811 967365542E0/
      DATA GCS   (11) / .0000000311 772496471E0/
      DATA GCS   (12) /-.0000000053 542196390E0/
      DATA GCS   (13) / .0000000009 193275519E0/
      DATA GCS   (14) /-.0000000001 577941280E0/
      DATA GCS   (15) / .0000000000 270798062E0/
      DATA GCS   (16) /-.0000000000 046468186E0/
      DATA GCS   (17) / .0000000000 007973350E0/
      DATA GCS   (18) /-.0000000000 001368078E0/
      DATA GCS   (19) / .0000000000 000234731E0/
      DATA GCS   (20) /-.0000000000 000040274E0/
      DATA GCS   (21) / .0000000000 000006910E0/
      DATA GCS   (22) /-.0000000000 000001185E0/
      DATA GCS   (23) / .0000000000 000000203E0/
      DATA PI /3.14159 26535 89793 24E0/
C SQ2PIL IS LOG (SQRT (2.*PI) )
      DATA SQ2PIL /0.91893 85332 04672 74E0/
      DATA FIRST /.TRUE./
C
C LANL DEPENDENT CODE REMOVED 81.02.04
C
C***FIRST EXECUTABLE STATEMENT  GAMMA
      IF (FIRST) THEN
C
C ---------------------------------------------------------------------
C INITIALIZE.  FIND LEGAL BOUNDS FOR X, AND DETERMINE THE NUMBER OF
C TERMS IN THE SERIES REQUIRED TO ATTAIN AN ACCURACY TEN TIMES BETTER
C THAN MACHINE PRECISION.
C
         NGCS = INITS (GCS, 23, 0.1*R1MACH(3))
C
         CALL GAMLIM (XMIN, XMAX)
         DXREL = SQRT (R1MACH(4))
C
C ---------------------------------------------------------------------
C FINISH INITIALIZATION.  START EVALUATING GAMMA(X).
C
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.10.0) GO TO 50
C
C COMPUTE GAMMA(X) FOR ABS(X) .LE. 10.0.  REDUCE INTERVAL AND
C FIND GAMMA(1+Y) FOR 0. .LE. Y .LT. 1. FIRST OF ALL.
C
      N = X
      IF (X.LT.0.) N = N - 1
      Y = X - N
      N = N - 1
      GAMMA = 0.9375 + CSEVL(2.*Y-1., GCS, NGCS)
      IF (N.EQ.0) RETURN
C
      IF (N.GT.0) GO TO 30
C
C COMPUTE GAMMA(X) FOR X .LT. 1.
C
      N = -N
      IF (X .EQ. 0.) CALL XERMSG ('SLATEC', 'GAMMA', 'X IS 0', 4, 2)
      IF (X .LT. 0. .AND. X+N-2 .EQ. 0.) CALL XERMSG ('SLATEC', 'GAMMA'
     1, 'X IS A NEGATIVE INTEGER', 4, 2)
      IF (X .LT. (-0.5) .AND. ABS((X-AINT(X-0.5))/X) .LT. DXREL) CALL
     1XERMSG ( 'SLATEC', 'GAMMA',
     2'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER'
     3, 1, 1)
C
      DO 20 I=1,N
        GAMMA = GAMMA / (X+I-1)
 20   CONTINUE
      RETURN
C
C GAMMA(X) FOR X .GE. 2.
C
 30   DO 40 I=1,N
        GAMMA = (Y+I)*GAMMA
 40   CONTINUE
      RETURN
C
C COMPUTE GAMMA(X) FOR ABS(X) .GT. 10.0.  RECALL Y = ABS(X).
C
 50   IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'GAMMA',
     +   'X SO BIG GAMMA OVERFLOWS', 3, 2)
C
      GAMMA = 0.
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'GAMMA',
     +   'X SO SMALL GAMMA UNDERFLOWS', 2, 1)
      IF (X.LT.XMIN) RETURN
C
      GAMMA = EXP((Y-0.5)*LOG(Y) - Y + SQ2PIL + R9LGMC(Y) )
      IF (X.GT.0.) RETURN
C
      IF (ABS((X-AINT(X-0.5))/X) .LT. DXREL) CALL XERMSG ('SLATEC',
     +   'GAMMA',
     +   'ANSWER LT HALF PRECISION, X TOO NEAR NEGATIVE INTEGER', 1, 1)
C
      SINPIY = SIN (PI*Y)
      IF (SINPIY .EQ. 0.) CALL XERMSG ('SLATEC', 'GAMMA',
     +   'X IS A NEGATIVE INTEGER', 4, 2)
C
      GAMMA = -PI / (Y*SINPIY*GAMMA)
C
      RETURN
      END
*DECK GAMR
      FUNCTION GAMR (X)
C***BEGIN PROLOGUE  GAMR
C***PURPOSE  Compute the reciprocal of the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      SINGLE PRECISION (GAMR-S, DGAMR-D, CGAMR-C)
C***KEYWORDS  FNLIB, RECIPROCAL GAMMA FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C GAMR is a single precision function that evaluates the reciprocal
C of the gamma function for single precision argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ALGAMS, GAMMA, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  GAMR
      EXTERNAL GAMMA
C***FIRST EXECUTABLE STATEMENT  GAMR
      GAMR = 0.0
      IF (X.LE.0.0 .AND. AINT(X).EQ.X) RETURN
C
      CALL XGETF (IROLD)
      CALL XSETF (1)
      IF (ABS(X).GT.10.0) GO TO 10
      GAMR = 1.0/GAMMA(X)
      CALL XERCLR
      CALL XSETF (IROLD)
      RETURN
C
 10   CALL ALGAMS (X, ALNGX, SGNGX)
      CALL XERCLR
      CALL XSETF (IROLD)
      GAMR = SGNGX * EXP(-ALNGX)
      RETURN
C
      END
*DECK GAMRN
      REAL FUNCTION GAMRN (X)
C***BEGIN PROLOGUE  GAMRN
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BSKIN
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (GAMRN-S, DGAMRN-D)
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C         GAMRN computes the GAMMA function ratio GAMMA(X)/GAMMA(X+0.5)
C         for real X.gt.0. If X.ge.XMIN, an asymptotic expansion is
C         evaluated. If X.lt.XMIN, an integer is added to X to form a
C         new value of X.ge.XMIN and the asymptotic expansion is eval-
C         uated for this new value of X. Successive application of the
C         recurrence relation
C
C                      W(X)=W(X+1)*(1+0.5/X)
C
C         reduces the argument to its original value. XMIN and comp-
C         utational tolerances are computed as a function of the number
C         of digits carried in a word by calls to I1MACH and R1MACH.
C         However, the computational accuracy is limited to the max-
C         imum of unit roundoff (=R1MACH(4)) and 1.0E-18 since critical
C         constants are given to only 18 digits.
C
C         Input
C           X      - Argument, X.gt.0.0
C
C         OUTPUT
C           GAMRN  - Ratio  GAMMA(X)/GAMMA(X+0.5)
C
C***SEE ALSO  BSKIN
C***REFERENCES  Y. L. Luke, The Special Functions and Their
C                 Approximations, Vol. 1, Math In Sci. And
C                 Eng. Series 53, Academic Press, New York, 1969,
C                 pp. 34-35.
C***ROUTINES CALLED  I1MACH, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C   920520  Added REFERENCES section.  (WRB)
C***END PROLOGUE  GAMRN
      INTEGER I, I1M11, K, MX, NX
      INTEGER I1MACH
      REAL FLN, GR, RLN, S, TOL, TRM, X, XDMY, XINC, XM, XMIN, XP, XSQ
      REAL R1MACH
      DIMENSION GR(12)
      SAVE GR
C
      DATA GR(1), GR(2), GR(3), GR(4), GR(5), GR(6), GR(7), GR(8),
     * GR(9), GR(10), GR(11), GR(12) /1.00000000000000000E+00,
     * -1.56250000000000000E-02,2.56347656250000000E-03,
     * -1.27983093261718750E-03,1.34351104497909546E-03,
     * -2.43289663922041655E-03,6.75423753364157164E-03,
     * -2.66369606131178216E-02,1.41527455519564332E-01,
     * -9.74384543032201613E-01,8.43686251229783675E+00,
     * -8.97258321640552515E+01/
C
C***FIRST EXECUTABLE STATEMENT  GAMRN
      NX = INT(X)
      TOL = MAX(R1MACH(4),1.0E-18)
      I1M11 = I1MACH(11)
      RLN = R1MACH(5)*I1M11
      FLN = MIN(RLN,20.0E0)
      FLN = MAX(FLN,3.0E0)
      FLN = FLN - 3.0E0
      XM = 2.0E0 + FLN*(0.2366E0+0.01723E0*FLN)
      MX = INT(XM) + 1
      XMIN = MX
      XDMY = X - 0.25E0
      XINC = 0.0E0
      IF (X.GE.XMIN) GO TO 10
      XINC = XMIN - NX
      XDMY = XDMY + XINC
   10 CONTINUE
      S = 1.0E0
      IF (XDMY*TOL.GT.1.0E0) GO TO 30
      XSQ = 1.0E0/(XDMY*XDMY)
      XP = XSQ
      DO 20 K=2,12
        TRM = GR(K)*XP
        IF (ABS(TRM).LT.TOL) GO TO 30
        S = S + TRM
        XP = XP*XSQ
   20 CONTINUE
   30 CONTINUE
      S = S/SQRT(XDMY)
      IF (XINC.NE.0.0E0) GO TO 40
      GAMRN = S
      RETURN
   40 CONTINUE
      NX = INT(XINC)
      XP = 0.0E0
      DO 50 I=1,NX
        S = S*(1.0E0+0.5E0/(X+XP))
        XP = XP + 1.0E0
   50 CONTINUE
      GAMRN = S
      RETURN
      END
*DECK GAUS8
      SUBROUTINE GAUS8 (FUN, A, B, ERR, ANS, IERR)
C***BEGIN PROLOGUE  GAUS8
C***PURPOSE  Integrate a real function of one variable over a finite
C            interval using an adaptive 8-point Legendre-Gauss
C            algorithm.  Intended primarily for high accuracy
C            integration or integration of smooth functions.
C***LIBRARY   SLATEC
C***CATEGORY  H2A1A1
C***TYPE      SINGLE PRECISION (GAUS8-S, DGAUS8-D)
C***KEYWORDS  ADAPTIVE QUADRATURE, AUTOMATIC INTEGRATOR,
C             GAUSS QUADRATURE, NUMERICAL INTEGRATION
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        GAUS8 integrates real functions of one variable over finite
C        intervals using an adaptive 8-point Legendre-Gauss algorithm.
C        GAUS8 is intended primarily for high accuracy integration
C        or integration of smooth functions.
C
C     Description of Arguments
C
C        Input--
C        FUN - name of external function to be integrated.  This name
C              must be in an EXTERNAL statement in the calling program.
C              FUN must be a REAL function of one REAL argument.  The
C              value of the argument to FUN is the variable of
C              integration which ranges from A to B.
C        A   - lower limit of integration
C        B   - upper limit of integration (may be less than A)
C        ERR - is a requested pseudorelative error tolerance.  Normally
C              pick a value of ABS(ERR) so that STOL .LT. ABS(ERR) .LE.
C              1.0E-3 where STOL is the single precision unit roundoff
C              R1MACH(4).  ANS will normally have no more error than
C              ABS(ERR) times the integral of the absolute value of
C              FUN(X).  Usually, smaller values for ERR yield more
C              accuracy and require more function evaluations.
C
C              A negative value for ERR causes an estimate of the
C              absolute error in ANS to be returned in ERR.  Note that
C              ERR must be a variable (not a constant) in this case.
C              Note also that the user must reset the value of ERR
C              before making any more calls that use the variable ERR.
C
C        Output--
C        ERR - will be an estimate of the absolute error in ANS if the
C              input value of ERR was negative.  (ERR is unchanged if
C              the input value of ERR was non-negative.)  The estimated
C              error is solely for information to the user and should
C              not be used as a correction to the computed integral.
C        ANS - computed value of integral
C        IERR- a status code
C            --Normal codes
C               1 ANS most likely meets requested error tolerance,
C                 or A=B.
C              -1 A and B are too nearly equal to allow normal
C                 integration.  ANS is set to zero.
C            --Abnormal code
C               2 ANS probably does not meet requested error tolerance.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  I1MACH, R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810223  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  GAUS8
      INTEGER IERR, K, KML, KMX, L, LMN, LMX, LR, MXL, NBITS,
     1 NIB, NLMN, NLMX
      INTEGER I1MACH
      REAL A, AA, AE, ANIB, ANS, AREA, B, C, CE, EE, EF, EPS, ERR, EST,
     1 GL, GLR, GR, HH, SQ2, TOL, VL, VR, W1, W2, W3, W4, X1, X2, X3,
     2 X4, X, H
      REAL R1MACH, G8, FUN
      DIMENSION AA(30), HH(30), LR(30), VL(30), GR(30)
      SAVE X1, X2, X3, X4, W1, W2, W3, W4, SQ2,
     1 NLMN, KMX, KML
      DATA X1, X2, X3, X4/
     1     1.83434642495649805E-01,     5.25532409916328986E-01,
     2     7.96666477413626740E-01,     9.60289856497536232E-01/
      DATA W1, W2, W3, W4/
     1     3.62683783378361983E-01,     3.13706645877887287E-01,
     2     2.22381034453374471E-01,     1.01228536290376259E-01/
      DATA SQ2/1.41421356E0/
      DATA NLMN/1/,KMX/5000/,KML/6/
      G8(X,H)=H*((W1*(FUN(X-X1*H) + FUN(X+X1*H))
     1           +W2*(FUN(X-X2*H) + FUN(X+X2*H)))
     2          +(W3*(FUN(X-X3*H) + FUN(X+X3*H))
     3           +W4*(FUN(X-X4*H) + FUN(X+X4*H))))
C***FIRST EXECUTABLE STATEMENT  GAUS8
C
C     Initialize
C
      K = I1MACH(11)
      ANIB = R1MACH(5)*K/0.30102000E0
      NBITS = ANIB
      NLMX = MIN(30,(NBITS*5)/8)
      ANS = 0.0E0
      IERR = 1
      CE = 0.0E0
      IF (A .EQ. B) GO TO 140
      LMX = NLMX
      LMN = NLMN
      IF (B .EQ. 0.0E0) GO TO 10
      IF (SIGN(1.0E0,B)*A .LE. 0.0E0) GO TO 10
      C = ABS(1.0E0-A/B)
      IF (C .GT. 0.1E0) GO TO 10
      IF (C .LE. 0.0E0) GO TO 140
      ANIB = 0.5E0 - LOG(C)/0.69314718E0
      NIB = ANIB
      LMX = MIN(NLMX,NBITS-NIB-7)
      IF (LMX .LT. 1) GO TO 130
      LMN = MIN(LMN,LMX)
   10 TOL = MAX(ABS(ERR),2.0E0**(5-NBITS))/2.0E0
      IF (ERR .EQ. 0.0E0) TOL = SQRT(R1MACH(4))
      EPS = TOL
      HH(1) = (B-A)/4.0E0
      AA(1) = A
      LR(1) = 1
      L = 1
      EST = G8(AA(L)+2.0E0*HH(L),2.0E0*HH(L))
      K = 8
      AREA = ABS(EST)
      EF = 0.5E0
      MXL = 0
C
C     Compute refined estimates, estimate the error, etc.
C
   20 GL = G8(AA(L)+HH(L),HH(L))
      GR(L) = G8(AA(L)+3.0E0*HH(L),HH(L))
      K = K + 16
      AREA = AREA + (ABS(GL)+ABS(GR(L))-ABS(EST))
C     IF (L .LT. LMN) GO TO 11
      GLR = GL + GR(L)
      EE = ABS(EST-GLR)*EF
      AE = MAX(EPS*AREA,TOL*ABS(GLR))
      IF (EE-AE) 40, 40, 50
   30 MXL = 1
   40 CE = CE + (EST-GLR)
      IF (LR(L)) 60, 60, 80
C
C     Consider the left half of this level
C
   50 IF (K .GT. KMX) LMX = KML
      IF (L .GE. LMX) GO TO 30
      L = L + 1
      EPS = EPS*0.5E0
      EF = EF/SQ2
      HH(L) = HH(L-1)*0.5E0
      LR(L) = -1
      AA(L) = AA(L-1)
      EST = GL
      GO TO 20
C
C     Proceed to right half at this level
C
   60 VL(L) = GLR
   70 EST = GR(L-1)
      LR(L) = 1
      AA(L) = AA(L) + 4.0E0*HH(L)
      GO TO 20
C
C     Return one level
C
   80 VR = GLR
   90 IF (L .LE. 1) GO TO 120
      L = L - 1
      EPS = EPS*2.0E0
      EF = EF*SQ2
      IF (LR(L)) 100, 100, 110
  100 VL(L) = VL(L+1) + VR
      GO TO 70
  110 VR = VL(L+1) + VR
      GO TO 90
C
C     Exit
C
  120 ANS = VR
      IF ((MXL.EQ.0) .OR. (ABS(CE).LE.2.0E0*TOL*AREA)) GO TO 140
      IERR = 2
      CALL XERMSG ('SLATEC', 'GAUS8',
     +   'ANS is probably insufficiently accurate.', 3, 1)
      GO TO 140
  130 IERR = -1
      CALL XERMSG ('SLATEC', 'GAUS8',
     +   'A and B are too nearly equal to allow normal integration. $$'
     +   // 'ANS is set to zero and IERR to -1.', 1, -1)
  140 IF (ERR .LT. 0.0E0) ERR = CE
      RETURN
      END
*DECK GENBUN
      SUBROUTINE GENBUN (NPEROD, N, MPEROD, M, A, B, C, IDIMY, Y,
     +   IERROR, W)
C***BEGIN PROLOGUE  GENBUN
C***PURPOSE  Solve by a cyclic reduction algorithm the linear system
C            of equations that results from a finite difference
C            approximation to certain 2-d elliptic PDE's on a centered
C            grid .
C***LIBRARY   SLATEC (FISHPACK)
C***CATEGORY  I2B4B
C***TYPE      SINGLE PRECISION (GENBUN-S, CMGNBN-C)
C***KEYWORDS  ELLIPTIC, FISHPACK, PDE, TRIDIAGONAL
C***AUTHOR  Adams, J., (NCAR)
C           Swarztrauber, P. N., (NCAR)
C           Sweet, R., (NCAR)
C***DESCRIPTION
C
C     Subroutine GENBUN solves the linear system of equations
C
C          A(I)*X(I-1,J) + B(I)*X(I,J) + C(I)*X(I+1,J)
C
C          + X(I,J-1) - 2.*X(I,J) + X(I,J+1) = Y(I,J)
C
C               for I = 1,2,...,M  and  J = 1,2,...,N.
C
C     The indices I+1 and I-1 are evaluated modulo M, i.e.,
C     X(0,J) = X(M,J) and X(M+1,J) = X(1,J), and X(I,0) may be equal to
C     0, X(I,2), or X(I,N) and X(I,N+1) may be equal to 0, X(I,N-1), or
C     X(I,1) depending on an input parameter.
C
C
C     * * * * * * * *    Parameter Description     * * * * * * * * * *
C
C             * * * * * *   On Input    * * * * * *
C
C     NPEROD
C       Indicates the values that X(I,0) and X(I,N+1) are assumed to
C       have.
C
C       = 0  If X(I,0) = X(I,N) and X(I,N+1) = X(I,1).
C       = 1  If X(I,0) = X(I,N+1) = 0  .
C       = 2  If X(I,0) = 0 and X(I,N+1) = X(I,N-1).
C       = 3  If X(I,0) = X(I,2) and X(I,N+1) = X(I,N-1).
C       = 4  If X(I,0) = X(I,2) and X(I,N+1) = 0.
C
C     N
C       The number of unknowns in the J-direction.  N must be greater
C       than 2.
C
C     MPEROD
C       = 0 if A(1) and C(M) are not zero.
C       = 1 if A(1) = C(M) = 0.
C
C     M
C       The number of unknowns in the I-direction.  M must be greater
C       than 2.
C
C     A,B,C
C       One-dimensional arrays of length M that specify the
C       coefficients in the linear equations given above.  If MPEROD = 0
C       the array elements must not depend upon the index I, but must be
C       constant.  Specifically, the subroutine checks the following
C       condition
C
C             A(I) = C(1)
C             C(I) = C(1)
C             B(I) = B(1)
C
C       for I=1,2,...,M.
C
C     IDIMY
C       The row (or first) dimension of the two-dimensional array Y as
C       it appears in the program calling GENBUN.  This parameter is
C       used to specify the variable dimension of Y.  IDIMY must be at
C       least M.
C
C     Y
C       A two-dimensional array that specifies the values of the right
C       side of the linear system of equations given above.  Y must be
C       dimensioned at least M*N.
C
C     W
C       A one-dimensional array that must be provided by the user for
C       work space.  W may require up to 4*N + (10 + INT(log2(N)))*M
C       locations.  The actual number of locations used is computed by
C       GENBUN and is returned in location W(1).
C
C
C             * * * * * *   On Output     * * * * * *
C
C     Y
C       Contains the solution X.
C
C     IERROR
C       An error flag that indicates invalid input parameters.  Except
C       for number zero, a solution is not attempted.
C
C       = 0  No error.
C       = 1  M .LE. 2
C       = 2  N .LE. 2
C       = 3  IDIMY .LT. M
C       = 4  NPEROD .LT. 0 or NPEROD .GT. 4
C       = 5  MPEROD .LT. 0 or MPEROD .GT. 1
C       = 6  A(I) .NE. C(1) or C(I) .NE. C(1) or B(I) .NE. B(1) for
C            some I=1,2,...,M.
C       = 7  A(1) .NE. 0 or C(M) .NE. 0 and MPEROD = 1
C
C     W
C       W(1) contains the required length of W.
C
C *Long Description:
C
C     * * * * * * *   Program Specifications    * * * * * * * * * * * *
C
C     Dimension of   A(M),B(M),C(M),Y(IDIMY,N),W(see parameter list)
C     Arguments
C
C     Latest         June 1, 1976
C     Revision
C
C     Subprograms    GENBUN,POISD2,POISN2,POISP2,COSGEN,MERGE,TRIX,TRI3,
C     Required       PIMACH
C
C     Special        NONE
C     Conditions
C
C     Common         NONE
C     Blocks
C
C     I/O            NONE
C
C     Precision      Single
C
C     Specialist     Roland Sweet
C
C     Language       FORTRAN
C
C     History        Standardized April 1, 1973
C                    Revised August 20,1973
C                    Revised January 1, 1976
C
C     Algorithm      The linear system is solved by a cyclic reduction
C                    algorithm described in the reference.
C
C     Space          4944(decimal) = 11520(octal) locations on the NCAR
C     Required       Control Data 7600.
C
C     Timing and        The execution time T on the NCAR Control Data
C     Accuracy       7600 for subroutine GENBUN is roughly proportional
C                    to M*N*log2(N), but also depends on the input
C                    parameter NPEROD.  Some typical values are listed
C                    in the table below.  More comprehensive timing
C                    charts may be found in the reference.
C                       To measure the accuracy of the algorithm a
C                    uniform random number generator was used to create
C                    a solution array X for the system given in the
C                    'PURPOSE' with
C
C                       A(I) = C(I) = -0.5*B(I) = 1,       I=1,2,...,M
C
C                    and, when MPEROD = 1
C
C                       A(1) = C(M) = 0
C                       A(M) = C(1) = 2.
C
C                    The solution X was substituted into the given sys-
C                    tem and, using double precision, a right side Y was
C                    computed.  Using this array Y subroutine GENBUN was
C                    called to produce an approximate solution Z.  Then
C                    the relative error, defined as
C
C                       E = MAX(ABS(Z(I,J)-X(I,J)))/MAX(ABS(X(I,J)))
C
C                    where the two maxima are taken over all I=1,2,...,M
C                    and J=1,2,...,N, was computed.  The value of E is
C                    given in the table below for some typical values of
C                    M and N.
C
C
C                       M (=N)    MPEROD    NPEROD    T(MSECS)    E
C                       ------    ------    ------    --------  ------
C
C                         31        0         0          36     6.E-14
C                         31        1         1          21     4.E-13
C                         31        1         3          41     3.E-13
C                         32        0         0          29     9.E-14
C                         32        1         1          32     3.E-13
C                         32        1         3          48     1.E-13
C                         33        0         0          36     9.E-14
C                         33        1         1          30     4.E-13
C                         33        1         3          34     1.E-13
C                         63        0         0         150     1.E-13
C                         63        1         1          91     1.E-12
C                         63        1         3         173     2.E-13
C                         64        0         0         122     1.E-13
C                         64        1         1         128     1.E-12
C                         64        1         3         199     6.E-13
C                         65        0         0         143     2.E-13
C                         65        1         1         120     1.E-12
C                         65        1         3         138     4.E-13
C
C     Portability    American National Standards Institute Fortran.
C                    The machine dependent constant PI is defined in
C                    function PIMACH.
C
C     Required       COS
C     Resident
C     Routines
C
C     Reference      Sweet, R., 'A Cyclic Reduction Algorithm For
C                    Solving Block Tridiagonal Systems Of Arbitrary
C                    Dimensions,' SIAM J. on Numer. Anal.,
C                    14(Sept., 1977), PP. 706-720.
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C***REFERENCES  R. Sweet, A cyclic reduction algorithm for solving
C                 block tridiagonal systems of arbitrary dimensions,
C                 SIAM Journal on Numerical Analysis 14, (September
C                 1977), pp. 706-720.
C***ROUTINES CALLED  POISD2, POISN2, POISP2
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  GENBUN
C
C
      DIMENSION       Y(IDIMY,*)
      DIMENSION       W(*)       ,B(*)       ,A(*)       ,C(*)
C***FIRST EXECUTABLE STATEMENT  GENBUN
      IERROR = 0
      IF (M .LE. 2) IERROR = 1
      IF (N .LE. 2) IERROR = 2
      IF (IDIMY .LT. M) IERROR = 3
      IF (NPEROD.LT.0 .OR. NPEROD.GT.4) IERROR = 4
      IF (MPEROD.LT.0 .OR. MPEROD.GT.1) IERROR = 5
      IF (MPEROD .EQ. 1) GO TO 102
      DO 101 I=2,M
         IF (A(I) .NE. C(1)) GO TO 103
         IF (C(I) .NE. C(1)) GO TO 103
         IF (B(I) .NE. B(1)) GO TO 103
  101 CONTINUE
      GO TO 104
  102 IF (A(1).NE.0. .OR. C(M).NE.0.) IERROR = 7
      GO TO 104
  103 IERROR = 6
  104 IF (IERROR .NE. 0) RETURN
      MP1 = M+1
      IWBA = MP1
      IWBB = IWBA+M
      IWBC = IWBB+M
      IWB2 = IWBC+M
      IWB3 = IWB2+M
      IWW1 = IWB3+M
      IWW2 = IWW1+M
      IWW3 = IWW2+M
      IWD = IWW3+M
      IWTCOS = IWD+M
      IWP = IWTCOS+4*N
      DO 106 I=1,M
         K = IWBA+I-1
         W(K) = -A(I)
         K = IWBC+I-1
         W(K) = -C(I)
         K = IWBB+I-1
         W(K) = 2.-B(I)
         DO 105 J=1,N
            Y(I,J) = -Y(I,J)
  105    CONTINUE
  106 CONTINUE
      MP = MPEROD+1
      NP = NPEROD+1
      GO TO (114,107),MP
  107 GO TO (108,109,110,111,123),NP
  108 CALL POISP2 (M,N,W(IWBA),W(IWBB),W(IWBC),Y,IDIMY,W,W(IWB2),
     1             W(IWB3),W(IWW1),W(IWW2),W(IWW3),W(IWD),W(IWTCOS),
     2             W(IWP))
      GO TO 112
  109 CALL POISD2 (M,N,1,W(IWBA),W(IWBB),W(IWBC),Y,IDIMY,W,W(IWW1),
     1             W(IWD),W(IWTCOS),W(IWP))
      GO TO 112
  110 CALL POISN2 (M,N,1,2,W(IWBA),W(IWBB),W(IWBC),Y,IDIMY,W,W(IWB2),
     1             W(IWB3),W(IWW1),W(IWW2),W(IWW3),W(IWD),W(IWTCOS),
     2             W(IWP))
      GO TO 112
  111 CALL POISN2 (M,N,1,1,W(IWBA),W(IWBB),W(IWBC),Y,IDIMY,W,W(IWB2),
     1             W(IWB3),W(IWW1),W(IWW2),W(IWW3),W(IWD),W(IWTCOS),
     2             W(IWP))
  112 IPSTOR = W(IWW1)
      IREV = 2
      IF (NPEROD .EQ. 4) GO TO 124
  113 GO TO (127,133),MP
  114 CONTINUE
C
C     REORDER UNKNOWNS WHEN MP =0
C
      MH = (M+1)/2
      MHM1 = MH-1
      MODD = 1
      IF (MH*2 .EQ. M) MODD = 2
      DO 119 J=1,N
         DO 115 I=1,MHM1
            MHPI = MH+I
            MHMI = MH-I
            W(I) = Y(MHMI,J)-Y(MHPI,J)
            W(MHPI) = Y(MHMI,J)+Y(MHPI,J)
  115    CONTINUE
         W(MH) = 2.*Y(MH,J)
         GO TO (117,116),MODD
  116    W(M) = 2.*Y(M,J)
  117    CONTINUE
         DO 118 I=1,M
            Y(I,J) = W(I)
  118    CONTINUE
  119 CONTINUE
      K = IWBC+MHM1-1
      I = IWBA+MHM1
      W(K) = 0.
      W(I) = 0.
      W(K+1) = 2.*W(K+1)
      GO TO (120,121),MODD
  120 CONTINUE
      K = IWBB+MHM1-1
      W(K) = W(K)-W(I-1)
      W(IWBC-1) = W(IWBC-1)+W(IWBB-1)
      GO TO 122
  121 W(IWBB-1) = W(K+1)
  122 CONTINUE
      GO TO 107
C
C     REVERSE COLUMNS WHEN NPEROD = 4.
C
  123 IREV = 1
      NBY2 = N/2
  124 DO 126 J=1,NBY2
         MSKIP = N+1-J
         DO 125 I=1,M
            A1 = Y(I,J)
            Y(I,J) = Y(I,MSKIP)
            Y(I,MSKIP) = A1
  125    CONTINUE
  126 CONTINUE
      GO TO (110,113),IREV
  127 CONTINUE
      DO 132 J=1,N
         DO 128 I=1,MHM1
            MHMI = MH-I
            MHPI = MH+I
            W(MHMI) = .5*(Y(MHPI,J)+Y(I,J))
            W(MHPI) = .5*(Y(MHPI,J)-Y(I,J))
  128    CONTINUE
         W(MH) = .5*Y(MH,J)
         GO TO (130,129),MODD
  129    W(M) = .5*Y(M,J)
  130    CONTINUE
         DO 131 I=1,M
            Y(I,J) = W(I)
  131    CONTINUE
  132 CONTINUE
  133 CONTINUE
C
C     RETURN STORAGE REQUIREMENTS FOR W ARRAY.
C
      W(1) = IPSTOR+IWP-1
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! The following routines are independent of the kind of wavelets.
! 
subroutine gwavelet_subtract(iorder,wavelets,vec,error)
  use gmath_interfaces, except_this=>gwavelet_subtract
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Subtract the ith order when asked
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: iorder 
  real(kind=4),    intent(in)    :: wavelets(:,:)
  real(kind=4),    intent(inout) :: vec(:)
  logical,         intent(inout) :: error
  ! Local
  integer(kind=4) :: nvec,nwav
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='GWAVELET/SUBTRACT'
  !
  nvec = size(wavelets,1)
  nwav = size(wavelets,2)
  if (iorder.gt.nwav) then
    write(mess,'(A,I0,A)') 'Order ',iorder,' is not available for option /BASE'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  elseif (iorder.gt.0) then
     if (size(vec).ne.nvec) then
        write(mess,'(A,I0,A,I0)') 'Size mismatch: ',nvec,',',size(vec)
        call gmath_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     vec(:) = vec(:)-wavelets(:,iorder)
  else
     ! Do not modify input spectrum
  endif
  !
end subroutine gwavelet_subtract
!
subroutine gwavelet_mirror(nvec,vec1,vec2,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_mirror
  !---------------------------------------------------------------------
  ! @ private
  ! Double the size of a vector, fill the central part with the initial
  ! vector and fill the left and right part with mirror versions of the
  ! initial vector.
  ! On return the vec2 array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: nvec       ! Data size
  real(kind=4),              intent(in)    :: vec1(nvec) ! Data
  real(kind=4), allocatable, intent(inout) :: vec2(:)    ! Results
  logical,                   intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: ivec,nhalf,ier
  character(len=*), parameter :: rname='GWAVELET/MIRROR'
  !
  allocate(vec2(2*nvec),stat=ier)
  if (failed_allocate(rname,'vec2',ier,error)) return
  nhalf = nvec/2   ! Remember nvec may be odd
  do ivec=1,nhalf  ! First half of the input spectrum (mirrored)
    vec2(nhalf+1-ivec) = vec1(ivec)
  enddo
  do ivec=1,nvec  ! Full input spectrum
    vec2(nhalf+ivec) = vec1(ivec)
  enddo
  do ivec=nhalf+1,nvec  ! 2nd half of the input spectrum (mirrored)
    vec2(2*nvec+nhalf+1-ivec) = vec1(ivec)
  enddo
end subroutine gwavelet_mirror
!
subroutine gwavelet_extract(nvec,nwav,wavelets2,wavelets1,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_extract
  !---------------------------------------------------------------------
  ! @ private
  ! Extract the central part of a wavelet array
  ! On return the wavelet1 array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: nvec                   ! Data size
  integer(kind=4),           intent(in)    :: nwav                   ! Number of wavelets
  real(kind=4),              intent(in)    :: wavelets2(2*nvec,nwav) ! Data
  real(kind=4), allocatable, intent(inout) :: wavelets1(:,:)         ! Results
  logical,                   intent(inout) :: error                  ! Logical error flag
  ! Local
  logical :: alloc
  integer(kind=4) :: nhalf,iwav,ier
  character(len=*), parameter :: rname='GWAVELET/EXTRACT'
  !
  nhalf = nvec/2 ! Remember nvec may be odd
  if (.not.allocated(wavelets1)) then
    alloc = .true.
  elseif (size(wavelets1,1).ne.nvec .or. size(wavelets1,2).ne.nwav) then
    deallocate(wavelets1)
    alloc = .true.
  else
    alloc = .false.
  endif
  if (alloc) then
    allocate(wavelets1(nvec,nwav),stat=ier)
    if (failed_allocate(rname,'wavelets',ier,error))  return
  endif
  ! Fill the values
  do iwav=1,nwav
    wavelets1(:,iwav) = wavelets2(nhalf+1:nhalf+nvec,iwav)
  enddo
end subroutine gwavelet_extract
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! The following routines assume gaps wavelets.
!
subroutine gwavelet_gaps(vec1,wavelets1,error)
  use gmath_interfaces, except_this=>gwavelet_gaps
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the wavelets for an input 1D data
  ! Take care of edge effects by mirroring the vector at each edge
  ! On return the input 'wavelets' array has been allocated and filled
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: vec1(:)        ! Data
  real(kind=4), allocatable, intent(inout) :: wavelets1(:,:) ! Results
  logical,                   intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=4) :: nvec,nwav
  real(kind=4), allocatable :: vec2(:),wavelets2(:,:)
  character(len=*), parameter :: rname='GWAVELET/GAPS'
  !
  nvec = size(vec1)
  call gwavelet_mirror(nvec,vec1,vec2,error)
  if (error) goto 10
  call gwavelet_gaps_sub(vec2,2*nvec,wavelets2,nwav,error)
  if (error)  goto 10
  call gwavelet_extract(nvec,nwav,wavelets2,wavelets1,error)
  if (error) goto 10
  !
10 continue
  if (allocated(vec2))  deallocate(vec2)
  if (allocated(wavelets2))  deallocate(wavelets2)
  !
end subroutine gwavelet_gaps
!
subroutine gwavelet_gaps_sub(vec,vsize,wavelets,nwav,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_gaps_sub
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ private
  ! Compute and modify inplace the wavelets for input 1D data
  ! On return the input wavelets array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: vsize          ! Vector size
  real(kind=4),              intent(inout) :: vec(vsize)     ! Data / working buffer
  real(kind=4), allocatable, intent(inout) :: wavelets(:,:)  ! Results
  integer(kind=4),           intent(out)   :: nwav           ! Number of wavelets in working buffer
  logical,                   intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GWAVELET/GAPS/SUB'
  integer(kind=4), parameter :: fwidth=5  ! Filter width
  real(kind=4), parameter :: filter(fwidth) =  &
    (/ 1./16., 1./4., 3./8., 1./4., 1./16. /)
  integer(kind=4) :: ier
  !
  call gwavelet_gaps_prepare(vsize,fwidth,nwav)
  if (nwav.le.0) then
    call gmath_message(seve%e,rname,'Number of wavelets lower or equal to 0')
    error = .true.
    return
  endif
  !
  allocate(wavelets(vsize,nwav),stat=ier)
  if (failed_allocate(rname,'wavelets',ier,error))  return
  !
  ! Compute
  call gwavelet_gaps_compute(vec,vsize,filter,fwidth,nwav,wavelets,error)
  if (error)  return
  !
end subroutine gwavelet_gaps_sub
!
subroutine gwavelet_gaps_prepare(vsize,fw,nwav)
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the number of wavelets which will be needed
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: vsize  ! Data size
  integer(kind=4), intent(in)  :: fw     ! Filter width
  integer(kind=4), intent(out) :: nwav   ! Number of wavelets
  !
  nwav = int(log(real(vsize,kind=4)/real(fw,kind=4))/log(2.))
  !
end subroutine gwavelet_gaps_prepare
!
subroutine gwavelet_gaps_compute(vec,vsize,f1,fw1,nwav,wav,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_gaps_compute
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the wavelets
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: vsize            ! Data size
  real(kind=4),    intent(inout) :: vec(vsize)       ! Data / working buffer
  integer(kind=4), intent(in)    :: fw1              ! Original filter width
  real(kind=4),    intent(in)    :: f1(fw1)          ! Original filter
  integer(kind=4), intent(in)    :: nwav             ! Number of wavelets
  real(kind=4),    intent(out)   :: wav(vsize,nwav)  ! Wavelets on return
  logical,         intent(inout) :: error            ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GWAVELET'
  integer(kind=4) :: fwn,fwmax,ier,ifv,iwav
  real(kind=4), allocatable :: fn(:)
  !
  ! Filter width grows iteratively for each wavelet order:
  !   fw(n) = 2*fw(n-1)-1
  ! We compute the maximum size we will have to work with and allocate
  ! it once. We can prove that:
  !   fw(n) = 2**(n-1) * (fw(1)-1) + 1
  fwmax = 2**(nwav-1) * (fw1-1) + 1
  allocate(fn(fwmax),stat=ier)
  if (failed_allocate(rname,'fn',ier,error))  return
  !
  ! 1st order
  fwn = fw1
  fn(1:fwn) = f1(:)
  call gwavelet_convolve(vec,wav(1,nwav),vsize,fn,fwn)
  vec(:) = vec(:)-wav(:,1)
  !
  ! Higher orders
  do iwav=2,nwav
    !
    ! Compute next filter by interleaving 0 values. Start from the end
    ! to allow working in the same array.
    fn(2*fwn-1) = fn(fwn)
    do ifv=fwn-1,1,-1
      fn(2*ifv) = 0.
      fn(2*ifv-1) = fn(ifv)
    enddo
    fwn = 2*fwn-1
    !
    ! Convolve
    call gwavelet_convolve(wav(1,nwav-iwav+2),wav(1,nwav-iwav+1),vsize,fn,fwn)
    ! Subtract
    vec(:) = vec(:)-wav(:,nwav-iwav+1)
    !
  enddo
  !
  if (allocated(fn)) deallocate(fn)
  !
end subroutine gwavelet_gaps_compute
!
subroutine gwavelet_convolve(din,dout,dsize,kern,ksize)
  !---------------------------------------------------------------------
  ! @ private
  ! 1D convolution
  ! This version is optimized for convolution kernels which have
  ! 0-valued elements.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: dsize        ! Data size
  real(kind=4),    intent(in)  :: din(dsize)   ! Data in
  real(kind=4),    intent(out) :: dout(dsize)  ! Data out
  integer(kind=4), intent(in)  :: ksize        ! Kernel size
  real(kind=4),    intent(in)  :: kern(ksize)  ! Kernel
  ! Local
  integer(kind=4) :: i,k,koff
  !
  ! There are many zeros in 'kern' in the wavelet context: loops are
  ! inverted (possible because they are independant) and ignored when
  ! the kernel value is 0.
  koff = (ksize+1)/2
  dout(:) = 0.
  do k=1,ksize
    if (kern(k).eq.0.)  cycle
    do i=1,dsize
      if (i+k-koff.le.0 .or. i+k-koff.gt.dsize)  cycle
      dout(i) = dout(i) + din(i+k-koff)*kern(k)
    enddo
  enddo
  !
  ! Should we ensure that the convolution kernel is normalized?
  ! norm = 1./sum(kern)
  !
end subroutine gwavelet_convolve
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubefitsio_image_write
  use cfitsio_api
  use cubetools_checksum
  use cubefitsio_header
  use cubefitsio_messaging
  !---------------------------------------------------------------------
  ! Support module to write FITS 'images' (e.g. 2D images or 3D cubes)
  !---------------------------------------------------------------------

  public :: cubefitsio_image_create,cubefitsio_image_datawrite
  public :: cubefitsio_image_header_update
  private

contains

  subroutine cubefitsio_image_create(hfits,filename,dochecksum,error)
    use gkernel_interfaces
    use cubetools_parameters
    !-------------------------------------------------------------------
    ! Create a new IMAGE-FITS file on disk.
    !-------------------------------------------------------------------
    type(fitsio_header_t), intent(inout) :: hfits
    character(len=*),      intent(in)    :: filename
    logical,               intent(in)    :: dochecksum
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>CREATE'
    integer(kind=4) :: idime,status
    integer(kind=4) :: bitpix,naxis,naxes(maxdim)
    !
    if (gag_inquire(filename,len_trim(filename)).eq.0)  &
      call gag_filrm(filename(1:len_trim(filename)))
    !
    call hfits%init(filename,dochecksum,error)
    if (error)  goto 10
    !
    ! Put the primary header
    status = 0
    bitpix = -32
    naxis = hfits%ndim
    do idime=1,hfits%ndim
      naxes(idime) = hfits%dim(idime)
    enddo
    call ftphps(hfits%unit,bitpix,naxis,naxes,status)
    if (cubefitsio_error(rname,status,error))  goto 10
    !
    ! Flush (is this useless?)
    call ftflus(hfits%unit,status)
    if (cubefitsio_error(rname,status,error))  goto 10
    !
    return
    !
  10 continue
    ! In case of error at init time, the unit is unusable by any
    ! of the CFITSIO entry point => free it.
    call hfits%close(error)
    !
  end subroutine cubefitsio_image_create

  subroutine cubefitsio_image_header_update(hfits,error)
    use cubefitsio_header_write
    !-------------------------------------------------------------------
    ! Update the header in the current FITS file
    !-------------------------------------------------------------------
    type(fitsio_header_t), intent(in)    :: hfits
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>HEADER>UPDATE'
    integer(kind=4) :: icard
    !
    do icard=1,hfits%dict%ncard
      call cubefitsio_header_write_card(hfits%unit,hfits%dict%card(icard),error)
      if (error)  return
    enddo
    !
  end subroutine cubefitsio_image_header_update

#if defined(CFITSIO420)
  subroutine cubefitsio_image_datawrite(hfits,data,iblc,itrc,error)
    use iso_c_binding, only: c_loc
    use gkernel_interfaces
    use cubetools_parameters
    use cubefitsio_image_utils
    !-------------------------------------------------------------------
    ! Write a contiguous piece of data to the output file
    !-------------------------------------------------------------------
    type(fitsio_header_t),      intent(in)    :: hfits
    real(kind=4), target,       intent(in)    :: data(:,:,:)
    integer(kind=index_length), intent(in)    :: iblc(maxdim)
    integer(kind=index_length), intent(in)    :: itrc(maxdim)
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>DATAWRITE'
    integer(kind=4) :: status,group,idime,laxisval,ier
    integer(kind=8) :: nbytes
    character(len=6) :: laxisname
    character(len=80) :: comment
    character(len=mess_l) :: mess
    integer(kind=size_length) :: fpixel,nelements
    integer(kind=index_length) :: blc(maxdim),trc(maxdim)
    !
    call cubefitsio_image_dataoffset(hfits,iblc,itrc,blc,trc,  &
                                     fpixel,nelements,error)
    if (error)  return
    !
    ! Sanity check
    if (size(data,kind=size_length).lt.nelements) then
      ! Note that it is OK to receive a buffer which is too large. It is
      ! the responsibility of the caller to know that not all the buffer
      ! is written (thanks to blc/trc). This is the case in particular when
      ! reading by blocks: the last block is not shrinked before writing.
      write(mess,'(2(a,i0))')  'Internal error: trying to write ',nelements,  &
        ' values in a buffer of size ',size(data,kind=size_length)
      call cubefitsio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    call cubefitsio_message(fitsioseve%others,rname,'Writing data with CFITSIO')
    group = 1
    status = 0
    call ftpprell(hfits%unit,group,fpixel,nelements,data,status)
    if (cubefitsio_error(rname,status,error))  return
    !
    if (hfits%checksum) then
      if (fpixel.eq.1) then
        ! Start or restart writing from the beginning (this can happen
        ! because we usually write a fake 1st image when creating the
        ! header).
        ier = cubetools_sha1sum_init()
        if (ier.ne.0) then
          error = .true.
          return
        endif
      endif
      nbytes = nelements*4
      ier = cubetools_sha1sum_update(c_loc(data),nbytes)
      if (ier.ne.0) then
        call cubefitsio_message(seve%e,rname,'Could not checksum data')
        error = .true.
        return
      endif
    endif
    !
    ! Update proper NAXIS* accordingly
    do idime=1,hfits%ndim
      write(laxisname,'(A5,I0)')  'NAXIS',idime
      call ftgkyj(hfits%unit,laxisname,laxisval,comment,status)
      if (cubefitsio_error(rname,status,error))  return
      if (laxisval.lt.trc(idime)) then
        laxisval = trc(idime)
        call ftukyj(hfits%unit,laxisname,laxisval,comment,status)
        if (cubefitsio_error(rname,status,error))  return
      endif
    enddo
    !
    ! Flush
    call ftflus(hfits%unit,status)
    if (cubefitsio_error(rname,status,error))  return
    !
  end subroutine cubefitsio_image_datawrite
#else /* CFITSIO420 */
  subroutine cubefitsio_image_datawrite(hfits,data,iblc,itrc,error)
    use iso_c_binding, only: c_loc
    use gkernel_interfaces
    use cubetools_parameters
    use cubefitsio_image_utils
    !-------------------------------------------------------------------
    ! OBSOLESCENT IMPLEMENTATION WITH INCORRECT USE OF BINTABLE API TO
    ! WRITE LARGE (>2GB) IMAGE HDUS.
    !-------------------------------------------------------------------
    type(fitsio_header_t),      intent(in)    :: hfits
    real(kind=4), target,       intent(in)    :: data(*)
    integer(kind=index_length), intent(in)    :: iblc(maxdim)
    integer(kind=index_length), intent(in)    :: itrc(maxdim)
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>DATAWRITE'
    integer(kind=4) :: status,group,idime,laxisval
    integer(kind=8) :: nbytes
    character(len=6) :: laxisname
    character(len=80) :: comment
    integer(kind=size_length) :: nelements
    integer(kind=4) :: ier,naxis,naxes(maxdim),fpixels(maxdim),  &
                       lpixels(maxdim),incs(maxdim)
    !
    call cubefitsio_image_subset(hfits,iblc,itrc,  &
      naxis,naxes,fpixels,lpixels,incs,nelements,error)
    if (error)  return
    !
    status = 0
    group = 1
    !
    ! ---
    ! PROBLEM: FTPPRE needs fpixel and nelements to be be I*4, i.e. limited
    ! to 2**31-1
    ! call ftppre(hfits%unit,group,fpixel,nelements,data,status)
    ! if (cubefitsio_error(rname,status,error))  return
    !
    ! ---
    ! Use FTPSSE which is able to deal with more than 2**31 elements to
    ! read, as long as the individual dimensions are below this limit (i.e. I*4)
    call ftpsse(hfits%unit,group,naxis,naxes,fpixels,lpixels,data,status)
    if (cubefitsio_error(rname,status,error))  return
    !
    if (hfits%checksum) then
      if (all(fpixels(1:naxis).eq.1)) then
        ! Start or restart writing from the beginning (this can happen
        ! because we usually write a fake 1st image when creating the
        ! header).
        ier = cubetools_sha1sum_init()
        if (ier.ne.0) then
          error = .true.
          return
        endif
      endif
      nbytes = nelements*4
      ier = cubetools_sha1sum_update(c_loc(data),nbytes)
      if (ier.ne.0) then
        call cubefitsio_message(seve%e,rname,'Could not checksum data')
        error = .true.
        return
      endif
    endif
    !
    ! Update proper NAXIS* accordingly
    do idime=1,hfits%ndim
      write(laxisname,'(A5,I0)')  'NAXIS',idime
      call ftgkyj(hfits%unit,laxisname,laxisval,comment,status)
      if (cubefitsio_error(rname,status,error))  return
      if (laxisval.lt.lpixels(idime)) then
        laxisval = lpixels(idime)
        call ftukyj(hfits%unit,laxisname,laxisval,comment,status)
        if (cubefitsio_error(rname,status,error))  return
      endif
    enddo
    !
    ! Flush
    call ftflus(hfits%unit,status)
    if (cubefitsio_error(rname,status,error))  return
    !
  end subroutine cubefitsio_image_datawrite
#endif /* CFITSIO420 */
end module cubefitsio_image_write

subroutine solve(line,error)
!
! Called by subroutine run_mira (MIRA command "solve"). 
! Calls the appropriate subroutines and plotting procedures
! for solving cross-scan pointings, focus measurements (axial or lateral ones)
! and skydips.
!
! Input: command line from interactive MIRA session or ODP script.
! Output: error flag.
!
   use mira
   !
   implicit none
   !
   integer                :: i,idir, ifb,ibase,ipix,nbin,nc,nrecords
   integer                :: ifb1, ifb2
   integer ,dimension(2,1) :: idummy
   real*8, dimension(2,1) :: dummy
   character(len = *)     :: line
   character              :: string*17
   character(len=20)      :: tmpstring
   character(len=40)      :: string2
   character(len=80)      :: option
   character(len=200)     :: command
   logical                :: error, sic_present
   !
   command = line
   !
   tmpstring = scan%header%scantype
   call sic_upper(tmpstring)
   !
   ifb1 = 0
   ifb2 = 0
   !
   if (index(tmpstring,'POINT').ne.0) then
      option = 'POINTING'
   else if (index(tmpstring,'FOCUS').ne.0) then
      option = 'FOCUS'
   else if (index(tmpstring,'TIP').ne.0) then
      option = 'SKYDIP'
   else
      call gagout('E-SOLVE, works only for POINTING, FOCUS or TIP.')
      error = .true.
      return
   endif
   !
   call sic_upper(option)
   !
   if (.not.sic_present(0,1)) then
      ifb = 0
      do i = 1, scan%header%nfebe
         tmpstring = scan%data%febe(i)
         call sic_upper(tmpstring)
         if (index(tmpstring,'BBC').ne.0 .or. &
             index(tmpstring,'NBC').ne.0 .or. &
             index(tmpstring,'CONT').ne.0) then
            ifb = i
            exit
         endif
      enddo
      if (ifb.eq.0) then
         ifb = 1
         call gagout('W-SOLVE: using first backend in Fe/Be list.')
      endif
   else
      call sic_i4(line,0,1,ifb,.false.,error)
      if (ifb.gt.scan%header%nfebe.or.ifb.le.0) then
         call gagout('E-PLOT: Invalid backend specification.')
         error = .true.
         return
      endif
      if (sic_present(0,2)) then
         ifb1 = ifb
         call sic_i4(line,0,2,ifb2,.false.,error)
         if (ifb2.gt.scan%header%nfebe.or.ifb2.le.0) then
            call gagout('E-PLOT: Invalid backend specification.')
            error = .true.
            return
         endif
      endif
   endif
   !
   if (sic_present(1,0)) then
      call sic_i4(line,1,1,ipix,.false.,error)
   else
      ipix = febe(ifb)%data%reffeed
   endif
   if (ipix.gt.febe(ifb)%header%febefeed) then
      write(string,'(A14,I3)') 'No such pixel ',ipix
      call gagout('E-SOLVE: '//string)
      error = .true.
      return
   endif
   !
   if (.not.reduce(ifb)%calibration_done(3)) then
      nrecords = maxval(data(ifb)%data%integnum)
      if (febe(ifb)%header%febe(1:1).eq.'E') then
! No. of arguments have changed AS 11.10.2010
!         call subtract_offE(ifb,nrecords,'NONE',dummy,1,error)
         call subtract_offE(ifb,nrecords,'NONE',dummy,1,idummy,1,error)
      else
!         call subtract_off(ifb,nrecords,'NONE',dummy,1,error)
         call subtract_off(ifb,nrecords,'NONE',dummy,1,idummy,1,error)
      endif
   endif
   !
   if (.not.reduce(ifb)%calibration_done(2))   &
     call gagout('I-SOLVE: data are uncalibrated.')
   !
   tmpstring = scan%data%febe(ifb)
   call sic_upper(tmpstring)
   if (index(option,'POIN').ne.0) then
      if (reduce(ifb)%pointing_done)   &
        call gagout('I-SOLVE: Pointing already solved.')
      nbin = 0
      if (sic_present(2,0)) call sic_i4(line,2,1,nbin,.false.,error)
      if (index(tmpstring,'CONT').eq.0.and.   &
          index(tmpstring,'BBC').eq.0.and.   &
          index(tmpstring,'NBC').eq.0.and.   &
          index(tmpstring,'ABBA').eq.0) then
         call gagout('E-SOLVE: Not yet ready for line pointing.')
         error = .true.
         return
      endif
      if (sic_present(3,1)) then
         call sic_i4(line,3,1,ibase,.false.,error)
      else
         ibase = 1
      endif
      if (ibase.lt.0) then
         ibase = 0
         call gagout('W-SOLVE: baseline order has to be >= 0, '//   &
                     'reset to 0.')
      else if (ibase.gt.1) then
         ibase = 1
         call gagout('W-SOLVE: baseline order reset to 1 (maximum).')
      endif
      call solve_pointing_mira(ifb,ipix,nbin,ibase,line)
      if (ifb1.ne.0.and.ifb2.ne.0) then
         call sic_get_logi('doPause',dopause,error)
         if (dopause) call exec_program('pause')
         write(string2,'(A30,I4,I4)')   &
           '@gag_pro:p_alignment.mira yes ', ifb1, ifb2
         call exec_program(string2(1:39))
         if (.not.reduce(ifb2)%calibration_done(3)) then
            nrecords = maxval(data(ifb2)%data%integnum)
            if (febe(ifb2)%header%febe(1:1).eq.'E') then
!               call subtract_offE(ifb2,nrecords,'NONE',dummy,1,error)
               call subtract_offE(ifb2,nrecords,'NONE',dummy,1,idummy,1,error)
            else
!               call subtract_off(ifb2,nrecords,'NONE',dummy,1,error)
               call subtract_off(ifb2,nrecords,'NONE',dummy,1,idummy,1,error)
            endif
         endif
         call solve_pointing_mira(ifb2,ipix,nbin,ibase,line)
         if (dopause) call exec_program('pause')
         write(string2,'(A29,I4,I4)')   &
           '@gag_pro:p_alignment.mira no ', ifb1, ifb2
         call exec_program(string2(1:38))
      endif
   else if (index(option,'FOCUS').ne.0) then
      if (reduce(ifb)%focus_done)   &
        call gagout('I-SOLVE: Focus already solved.')
      if (index(tmpstring,'BBC').eq.0 .and.  &
          index(tmpstring,'NBC').eq.0 .and.  &
          index(tmpstring,'CONT').eq.0) then
         call gagout('E-SOLVE: Please select a continuum backend'   &
                     //' for focus.')
         error = .true.
         return
      endif
      if (raw(1)%subref(ifb)%focustransl.eq.'X') then
         idir = 1
      else if (raw(1)%subref(ifb)%focustransl.eq.'Y') then
         idir = 2
      else if (raw(1)%subref(ifb)%focustransl.eq.'Z') then
         idir = 3
      else
         call gagout('E-SOLVE: unknown focus translation direction.')
         error = .true.
         return
      endif
      call solve_xyzfocus(ifb,ipix,idir)
   else if (index(option,'SKYDIP').ne.0) then
      call solve_tip(ifb,ipix)
   else
      call gagout   &
        ('E-SOLVE: procedure either unknown or not yet done.')
      error = .true.
   endif
   !
   call sic_insert(command)
   !
   return
!
end subroutine solve
!
!
subroutine solve_pointing_mira(ifb,ipix,nbin,ibase,line)
!
! Called by subroutine SOLVE.
! solve_pointing_mira prepares (subscan or coadded Az- and
! El-subscan, after removal of linear baselines) data for
! subsequent call of telcal's subroutine fit_1d, writes
! the results into the corresponding MIRA and SIC structures,
! and calls subroutines protoResultsPointing to write an XML
! file with the results.
!
   use mira
   use fit
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use pcross_definitions
   use fit_definitions
   use linearregression
   !
   implicit none
   character(len = *) :: line
   !
   integer   :: i,ibase,idir,iend,ier,ifb,ilast,ipix,istart,isub,   &
                isub1,isub2,i1,i2,i3,i4,j,k,nbet,nbin,ndir,ndump,   &
                nlam,npar,npts,nrecords,nsubscans,nx,subscan_id
   type(sic_descriptor_t) :: desc
   integer, dimension(1)  :: imax
   real*4    :: azcorr, elcorr, data1, data2, yscale
   real*8    :: bval, dazm, delv, dx, slope, var, x1, x2, x3, x4
   real*8    :: dxmean
   real*8    :: xmaxval, xminval
   real*8    :: xend, xstart, yend, ystart
   logical   :: exist, error
   !
   integer, dimension(:), allocatable  :: indx
   real*8, dimension(:), allocatable   :: chi, xall, yall, xtmp, ytmp
   logical, dimension(:), allocatable  :: flagmask, mask, tmpmask
   logical, dimension(2)               :: overlapflag
   character(len=3)                    :: dir_string
   character(len=12)                   :: ptype
   character(len=20)                   :: tmpswtchmod
   character(len=32)                   :: tmpfebe, varname
   character(len=100)                  :: string
   !
   integer                             :: n, naver
   real*8                              :: xmax, xmin, ytest
   real*8, dimension(:), allocatable   :: ymax, ymin
   !
   type(simple_1d), dimension(2)       :: dat
   type(simple_1d), dimension(2)       :: profile
   !
   type tmppoint
      integer :: integnum
      integer :: subscan
      real*4  :: data
      real*8  :: latoff
      real*8  :: longoff
      real*8  :: lst
      real*8  :: elevatio
      real*8  :: parangle
   end type tmppoint
   !
   type(tmppoint), dimension(:), allocatable :: tmpdata
   !
   !
   tmpfebe = febe(ifb)%header%febe
   call sic_get_logi('flagBSwSpikes',flagBSwSpikes,error)
   call sic_upper(tmpfebe)
   !
   !
   tmpswtchmod = febe(ifb)%header%swtchmod
   call sic_upper(tmpswtchmod)
   if (index(tmpswtchmod,'WOB').ne.0) then
      ptype = 'DUAL'
   else
      ptype = 'SIMPLE'
   endif
   !
   !
   if (.not.reduce(ifb)%calibration_done(1).and.   &
       .not.reduce(ifb)%calibration_done(3)) then
      bval = blankingraw
   else
      bval = blankingred
   endif
   !
   !
   nrecords  = maxval(data(ifb)%data%integnum)
   nsubscans = scan%header%nobs
   !
   allocate(flagmask(nrecords),stat=ier)
   flagmask   &
     = data(ifb)%data%otfdata(ipix,1,1:nrecords).eq.bval
   !
   if (nbin.eq.0) then
      if (allocated(tmpdata)) deallocate(tmpdata,stat=ier)
      allocate(tmpdata(nrecords),stat=ier)
      if (allocated(chi)) deallocate(chi,stat=ier)
      allocate(chi(nrecords),stat=ier)
      tmpdata(1:nrecords)%integnum = data(ifb)%data%integnum
      tmpdata(1:nrecords)%subscan  = data(ifb)%data%subscan
      tmpdata(1:nrecords)%longoff  = data(ifb)%data%longoff
      tmpdata(1:nrecords)%latoff   = data(ifb)%data%latoff
      tmpdata(1:nrecords)%lst      = data(ifb)%data%lst
      tmpdata(1:nrecords)%elevatio = data(ifb)%data%elevatio
      tmpdata(1:nrecords)%parangle = data(ifb)%data%parangle
      tmpdata(1:nrecords)%data   &
        = data(ifb)%data%otfdata(ipix,1,1:nrecords)
   else
      !
      if (allocated(mask)) deallocate(mask,stat=ier)
      allocate(mask(nrecords),stat=ier)
      nrecords = 0
      do isub = 1, nsubscans
         mask = data(ifb)%data%subscan.eq.isub
         nrecords = nrecords+count(mask)/nbin
      enddo
      if (allocated(tmpdata)) deallocate(tmpdata,stat=ier)
      allocate(tmpdata(nrecords),stat=ier)
      if (allocated(chi)) deallocate(chi,stat=ier)
      allocate(chi(nrecords),stat=ier)
      iend = 0
      k = 0
      do isub = 1, nsubscans
         mask = data(ifb)%data%subscan.eq.isub
         ndump = count(mask)/nbin
         istart = iend+1
         ilast = iend+ndump*nbin
         iend = iend+count(mask)
         do j = istart, ilast, nbin
            k = k+1
            tmpdata(k)%subscan = isub
            tmpdata(k)%integnum = k
            tmpdata(k)%longoff   &
              = sum(data(ifb)%data%longoff(j:j+nbin-1))/nbin
            tmpdata(k)%latoff   &
              = sum(data(ifb)%data%latoff(j:j+nbin-1))/nbin
            tmpdata(k)%lst   &
              = sum(data(ifb)%data%lst(j:j+nbin-1))/nbin
            tmpdata(k)%elevatio   &
              = sum(data(ifb)%data%elevatio(j:j+nbin-1))/nbin
            tmpdata(k)%parangle   &
              = sum(data(ifb)%data%parangle(j:j+nbin-1))/nbin
            if (count(.not.flagmask(j:j+nbin-1)).eq.0) then
               tmpdata(k)%data = bval
            else
               tmpdata(k)%data   &
                 = sum(data(ifb)%data%otfdata(ipix,1,j:j+nbin-1),   &
                 1,.not.flagmask(j:j+nbin-1))   &
                 /count(.not.flagmask(j:j+nbin-1))
            endif
         enddo
      enddo
   !
   endif
   !
   !
   ! The following is if you want to point with the central pixel, but if
   ! the signal is in an off-center pixel.
   !      IF (INDEX(tmpFeBe,'HERA').NE.0) THEN
   !         IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'HORIZ').NE.0) THEN
   !            CHI = FEBE(IFB)%HEADER%DEWANG/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        -FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData%LATOFF = tmpData(:)%LATOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                        +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ELSE IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'CABIN').NE.0) THEN
   !            CHI = (FEBE(IFB)%HEADER%DEWANG-tmpData(:)%ELEVATIO)/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        -FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData%LATOFF = tmpData(:)%LATOFF
   !     &                       +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                       +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ELSE IF (INDEX(FEBE(IFB)%HEADER%DEWRTMOD,'EQUA').NE.0) THEN
   !            CHI = (FEBE(IFB)%HEADER%DEWANG+tmpData(:)%PARANGLE)/RAD2DEG
   !            tmpData%LONGOFF = tmpData(:)%LONGOFF
   !     &                        -FEBE(IFB)%DATA%FEEDOFFX(IPIX)*COS(CHI(:))
   !     &                        +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*SIN(CHI(:))
   !            tmpData(:)%LATOFF = tmpData(:)%LATOFF
   !     &                       +FEBE(IFB)%DATA%FEEDOFFX(IPIX)*SIN(CHI(:))
   !     &                       +FEBE(IFB)%DATA%FEEDOFFY(IPIX)*COS(CHI(:))
   !         ENDIF
   !      ENDIF
   !
   nrecords  = maxval(tmpdata%integnum)
   nsubscans = maxval(tmpdata%subscan)
   if (allocated(ymin)) deallocate(ymin,stat=ier)
   if (allocated(ymax)) deallocate(ymax,stat=ier)
   allocate(ymin(nsubscans),ymax(nsubscans),stat=ier)
   ymax(:) = blankingraw
   ymin(:) = -ymax(:)
! changed by hw, 2010-05-06
!   if (nsubscans.gt.7) then
!      ndir = 8
!   else if (nsubscans.gt.3) then
!      ndir = 4
!   else
!      ndir = nsubscans
!   endif
! end of change
   if (mod(nsubscans,4).eq.0) then
      ndir = 4
   else
      ndir = nsubscans
   endif
!
! Normalize in order to avoid numerical problems with telCal's fitting routine
!
   yscale = maxval(abs(tmpdata(1:nrecords)%data),1,.not.flagmask)
   where (.not.flagmask)   &
     tmpdata(1:nrecords)%data = tmpdata(1:nrecords)%data/yscale
   !
   !
   i2 = 0
   dx = 0.
   dxmean = 0.
   subscan_loop: do i = 1, nsubscans
      xstart = raw(i)%antenna(ifb)%segmentxstart
      xend = raw(i)%antenna(ifb)%segmentxend
      ystart = raw(i)%antenna(ifb)%segmentystart
      yend = raw(i)%antenna(ifb)%segmentyend
      pcross(i)%sys = 0
      if (xend.gt.xstart) pcross(i)%dir = '+LAM'
      if (xend.lt.xstart) pcross(i)%dir = '-LAM'
      if (yend.gt.ystart) pcross(i)%dir = '+BET'
      if (yend.lt.ystart) pcross(i)%dir = '-BET'
      if (allocated(mask)) deallocate(mask,stat=ier)
      allocate(mask(nrecords),stat=ier)
      mask = tmpdata(1:nrecords)%subscan.eq.i
      call null_simple_1d(pcross(i)%dat)
      ndump = count(mask,1)
      allocate(pcross(i)%dat%x(ndump),stat=ier)
      allocate(pcross(i)%dat%y(ndump),stat=ier)
      allocate(pcross(i)%dat%w(ndump),stat=ier)
      allocate(pcross(i)%dat%d(ndump),stat=ier)
      pcross(i)%dat%n = ndump
      pcross(i)%dat%x = 0.
      pcross(i)%dat%y = 0.
      pcross(i)%dat%w = 1.
      pcross(i)%dat%d = 0.
      call null_simple_1d(pcross(i)%sol)
      npts = pcross(i)%dat%n
      pcross(i)%sol%n = npts
      allocate(pcross(i)%sol%x(npts),pcross(i)%sol%y(npts),   &
               pcross(i)%sol%w(npts),pcross(i)%sol%d(npts),   &
               stat=ier)
      pcross(i)%sol%x = 0.
      pcross(i)%sol%y = 0.
      pcross(i)%sol%w = 1.
      pcross(i)%sol%d = 0.
      i1 = i2+1
      i2 = i2+pcross(i)%dat%n
      allocate(indx(pcross(i)%dat%n),xtmp(pcross(i)%dat%n),   &
               ytmp(pcross(i)%dat%n),tmpmask(pcross(i)%dat%n),   &
               stat=ier)
      ytmp(:) = tmpdata(i1:i2)%data
      tmpmask(:) = flagmask(i1:i2)
      if (index(pcross(i)%dir,'LAM').ne.0) then
         xtmp(:) = tmpdata(i1:i2)%longoff*3600.
         if (index(pcross(i)%dir,'+').ne.0) then
            call indexx(pcross(i)%dat%n,xtmp,indx)
         else
            call indexx(pcross(i)%dat%n,-xtmp,indx)
         endif
      else if (index(pcross(i)%dir,'BET').ne.0) then
         xtmp(:) = tmpdata(i1:i2)%latoff*3600.
         if (index(pcross(i)%dir,'+').ne.0) then
            call indexx(pcross(i)%dat%n,xtmp,indx)
         else
            call indexx(pcross(i)%dat%n,-xtmp,indx)
         endif
      endif
      do j = 1, pcross(i)%dat%n
         pcross(i)%dat%x(j) = xtmp(indx(j))
      enddo
      !
      do j = 1, pcross(i)%dat%n
         if (.not.tmpmask(indx(j))) then
            pcross(i)%dat%y(j) = ytmp(indx(j))
         else
            pcross(i)%dat%y(j) = bval
            pcross(i)%dat%w = 0.0
         endif
      enddo
      deallocate(indx,xtmp,ytmp,tmpmask,stat=ier)
      !
      dx = max(dx,abs(maxval(pcross(i)%dat%x(2:npts)   &
                            -pcross(i)%dat%x(1:npts-1))))
      dxmean = dxmean+abs(sum(pcross(i)%dat%x(2:npts)   &
                             -pcross(i)%dat%x(1:npts-1)))   &
                      /(npts-1)
      !
      call null_function(pcross(i)%fun)
      pcross(i)%fun%method = 'SLATEC'
      if (ptype.eq.'SIMPLE'.or.index(pcross(i)%dir,'BET').ne.0) then
         pcross(i)%fun%name = 'GAUSSIAN+BASE'
         pcross(i)%fun%npar = 5
         npar = pcross(i)%fun%npar
         allocate (pcross(i)%fun%par(npar),stat=ier)
         do j = 1, npar
            call null_parameter(pcross(i)%fun%par(j))
         enddo
         pcross(i)%fun%par(5)%guess = 0.
         pcross(i)%fun%par(1)%guess = 1.-pcross(i)%fun%par(4)%guess
         if (array(ifb)%header(1)%restfreq.lt.1.2d11) then
            pcross(i)%fun%par(3)%guess   &
              = 27.5*0.88d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.1.9d11) then
            pcross(i)%fun%par(3)%guess   &
              = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.4.0d11) then
            pcross(i)%fun%par(3)%guess   &
              = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
         endif
         pcross(i)%fun%par(1)%guess =pcross(i)%fun%par(3)%guess  &
                                     *sqrt(pi/log(2.d0))/2.
         !
         ! MINI, MAXI not yet used by telCal
         !
       ! PCROSS(I)%FUN%PAR(1)%MINI = 0.
       ! PCROSS(I)%FUN%PAR(1)%MAXI = 1.E23
         pcross(i)%fun%flag = 2
         pcross(i)%fun%par(1)%name = 'AREA1'
         pcross(i)%fun%par(2)%name = 'POSITION1'
         pcross(i)%fun%par(3)%name = 'WIDTH1'
         pcross(i)%fun%par(4)%name = 'OFFSET'
         pcross(i)%fun%par(5)%name = 'SLOPE'
         if (ibase.eq.1) then
            pcross(i)%fun%par(1:5)%fixed = .false.
         else if (ibase.eq.0) then
            pcross(i)%fun%par(1:4)%fixed = .false.
            pcross(i)%fun%par(5)%fixed = .true.
         endif
         naver = pcross(i)%fun%par(3)%guess/dx
         xmax = maxval(pcross(i)%dat%x)
         xmin = minval(pcross(i)%dat%x)
         n = 0
         if (index(pcross(i)%dir,'+').ne.0) then
            do j = 1, pcross(i)%dat%n
               if (pcross(i)%dat%x(j)+pcross(i)%fun%par(3)%guess   &
                 .gt.xmax) exit
               n = n+1
            enddo
         else if (index(pcross(i)%dir,'-').ne.0) then
            do j = pcross(i)%dat%n,1,-1
               if (pcross(i)%dat%x(j)+pcross(i)%fun%par(3)%guess   &
                 .gt.xmax) exit
               n = n+1
            enddo
         endif
         if (n.eq.0) then
            naver = pcross(i)%dat%n
            n = 1
         endif
         i3 = 0
         do j = 1, n
            i4 = i3+naver
            i3 = i3+1
            ytest = sum(pcross(i)%dat%y(i3:i4))/(i4-i3+1)
            if (ytest.le.ymin(i)) then
               pcross(i)%fun%par(4)%guess = ytest
               ymin(i) = ytest
            endif
         enddo
         i3 = 0
         do j = 1, n
            i4 = i3+naver
            i3 = i3+1
            ytest = sum(pcross(i)%dat%y(i3:i4))/(i4-i3+1)-ymin(i)
            if (ytest.ge.ymax(i)) then
               pcross(i)%fun%par(2)%guess   &
                 = sum(pcross(i)%dat%x(i3:i4))/(i4-i3+1)
               ymax(i) = ytest
            endif
         enddo
      !
      else if (ptype.eq.'DUAL') then
         pcross(i)%fun%name = '2*GAUSSIAN+BASE'
         pcross(i)%fun%npar = 8
         npar = pcross(i)%fun%npar
         allocate (pcross(i)%fun%par(npar),stat=ier)
         do j = 1, npar
            call null_parameter(pcross(i)%fun%par(j))
         enddo
         pcross(i)%fun%par(7)%guess = 0.5*(minval(pcross(i)%dat%y)   &
                                          +maxval(pcross(i)%dat%y))
         pcross(i)%fun%par(8)%guess = 0.
         pcross(i)%fun%par(1)%guess = 1.-pcross(i)%fun%par(7)%guess
         imax = maxloc(pcross(i)%dat%y)
         pcross(i)%fun%par(2)%guess = pcross(i)%dat%x(imax(1))
         if (array(ifb)%header(1)%restfreq.lt.1.2d11) then
            pcross(i)%fun%par(3)%guess   &
              = 27.5*0.88d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.1.9d11) then
            pcross(i)%fun%par(3)%guess   &
              = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
         else if (array(ifb)%header(1)%restfreq.lt.4.0d11) then
            pcross(i)%fun%par(3)%guess   &
              = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
         endif
         pcross(i)%fun%par(1)%guess =pcross(i)%fun%par(3)%guess   &
                                    *sqrt(pi/log(2.d0))/2.
         pcross(i)%fun%par(4)%guess = -1
         pcross(i)%fun%par(5)%guess =scan%header%wobthrow*3600.
         pcross(i)%fun%par(6)%guess = 1
         pcross(i)%fun%flag = 2
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            PCROSS(I)%FUN%PAR(1)%MINI = 0.
         !            PCROSS(I)%FUN%PAR(1)%MAXI = 1.E23
         pcross(i)%fun%par(1)%name = 'AREA1'
         pcross(i)%fun%par(2)%name = 'POSITION1'
         pcross(i)%fun%par(3)%name = 'WIDTH1'
         pcross(i)%fun%par(4)%name = 'AREA2/AREA1'
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            PCROSS(I)%FUN%PAR(4)%MINI = -10.
         !            PCROSS(I)%FUN%PAR(4)%MAXI = 10.
         pcross(i)%fun%par(5)%name = 'POSITION2-POSITION1'
         pcross(i)%fun%par(6)%name = 'WIDTH2/WIDTH1'
         pcross(i)%fun%par(7)%name = 'OFFSET'
         pcross(i)%fun%par(8)%name = 'SLOPE'
         if (ibase.eq.1) then
            pcross(i)%fun%par(1:8)%fixed = .false.
         else if (ibase.eq.0) then
            pcross(i)%fun%par(1:7)%fixed = .false.
            pcross(i)%fun%par(8)%fixed = .true.
         endif
      endif
   enddo subscan_loop
   !
   dxmean = dxmean/nsubscans
   if (dx/dxmean.gt.3) dx = dxmean
   !
   !if (ndir.ge.2) then
      call sic_descriptor('PCROSS',desc,exist)
      if (.not.exist) call sic_defstructure('PCROSS',.true.,error)
      do i = 1, nsubscans
         write(varname,'(A10,I0)') 'PCROSS%SUB',i
         call define_sic_pointing(pcross(i),trim(varname),error)
         call fit_1d(pcross(i)%dat,pcross(i)%fun,.false.)
         pcross(i)%sol%x = pcross(i)%dat%x(:)
         call get_profile(pcross(i)%fun,pcross(i)%sol)
         npar = pcross(i)%fun%npar
         where (pcross(i)%dat%y.ne.bval)   &
           pcross(i)%dat%y = pcross(i)%dat%y*yscale
         pcross(i)%sol%y = pcross(i)%sol%y*yscale
         pcross(i)%fun%par(1)%value   &
           = pcross(i)%fun%par(1)%value*yscale
         pcross(i)%fun%par(1)%error   &
           = pcross(i)%fun%par(1)%error*yscale
         pcross(i)%fun%par(npar-1)%value   &
           = pcross(i)%fun%par(npar-1)%value*yscale
         pcross(i)%fun%par(npar-1)%error   &
           = pcross(i)%fun%par(npar-1)%error*yscale
         pcross(i)%fun%par(npar)%value   &
           = pcross(i)%fun%par(npar)%value*yscale
         pcross(i)%fun%par(npar)%error   &
           = pcross(i)%fun%par(npar)%error*yscale
         pcross(i)%fun%par(1)%guess   &
           = pcross(i)%fun%par(1)%guess*yscale
         pcross(i)%fun%par(npar-1)%guess   &
           = pcross(i)%fun%par(npar-1)%guess*yscale
         pcross(i)%fun%par(npar)%guess   &
           = pcross(i)%fun%par(npar)%guess*yscale
         ymin(i) = ymin(i)*yscale
         ymax(i) = ymax(i)*yscale
      enddo
      !
      !
      do i = 1, nsubscans, 4
         write(varname,'(A10,I0)') 'PCROSS%SUB',i
         write(string,'(A36,1X,I2,1X,I2)')   &
           '@ gag_pro:p_plot_pointBySubscan.mira', ifb, i
         call exec_program(string(1:43))
         do j = 1, ndir
            k = j+i-1
            if (k.gt.nsubscans) then
               call gagout('W-SOLVE: incomplete pointing')
               return
            endif
            npar = pcross(k)%fun%npar
            if (ptype.ne.'DUAL'.and.                   &
                (pcross(k)%fun%par(npar-1)%value.lt.   &
                 ymin(k)-abs(ymax(k)).or.              &
                 pcross(k)%fun%par(npar-1)%value.gt.   &
                 ymin(k)+2*abs(ymax(k))                &
                )) then
               if (j.le.2) then
                  write(string,'(A20,F4.1,A7)')'g\draw relocate -13 ',   &
                    -1.7-(j-1)*0.5, ' /box 1'
               else
                  write(string,'(A20,F4.1,A7)') 'g\draw relocate 0 ',   &
                    -1.7-(j-3)*0.5, ' /box 1'
               endif
               call exec_program(string)
               call exec_program('g\pen /col 1')
               write(string,'(A41,I0,A47)')   &
                 'label "Ambigeous baseline fit in subscan ',k,   &
                 '" /center 6'
               call exec_program(string)
               call exec_program('g\pen /def')
               write(string,'(A43,I0,A35)')   &
                 'W-SOLVE: Ambigeous baseline fit in subscan ',k,   &
                 ', only 0 order baseline subtracted.'
               call gagout(string)
            endif
            if (mod(k,4).eq.0) then
               call sic_get_logi('doPause',dopause,error)
               if (dopause) then
                  call exec_program('pause')
               else
                  call exec_program('sic wait 1')
               endif
               if (trim(line).eq.'SIC\QUIT') return
            endif
            if (mod(k,4).eq.0.) call exec_program('clear')
         enddo
      enddo
      !
      if (nsubscans.lt.scan%header%nobstotal) then
         call gagout('W-SOLVE: incomplete pointing')
         if (mod(nsubscans,4).ne.0) return
      endif
      !
      ! now remove fitted baseline before proceeding to final fit
      !
      do i = 1, nsubscans
         npar = pcross(i)%fun%npar
         if (ptype.ne.'DUAL'.and.                   &
             (pcross(i)%fun%par(npar-1)%value.lt.   &
              ymin(i)-abs(ymax(i)).or.              &
              pcross(i)%fun%par(npar-1)%value.gt.   &
              ymin(i)+2*abs(ymax(i))                &
             )) then
            pcross(i)%dat%y = pcross(i)%dat%y   &
              -pcross(i)%fun%par(npar-1)%guess
         else
            where (pcross(i)%dat%y.ne.bval)   &
              pcross(i)%dat%y = pcross(i)%dat%y   &
                               -pcross(i)%fun%par(npar-1)%value   &
                               -pcross(i)%fun%par(npar)%value*pcross(i)%dat%x
         endif
      enddo
   !
   !endif
   !
   !
   overlapflag(:) = .true.
   ndir = 2
   az_el_loop: do idir = 1, 2
      if (idir.eq.1) then
         dir_string = 'LAM'
      else
         dir_string = 'BET'
      endif
      x1 = +1.d23
      x2 = -1.d23
      x3 = -1.d23
      x4 = +1.d23
      nx = 0
      do i = 1, nsubscans
         if (index(pcross(i)%dir,dir_string).ne.0) then
            xminval = minval(pcross(i)%dat%x)
            xmaxval = maxval(pcross(i)%dat%x)
            x1 = min(x1,xminval)
            x2 = max(x2,xmaxval)
            x3 = max(x3,xminval)
            x4 = min(x4,xmaxval)
            nx = nx+pcross(i)%dat%n
         endif
      enddo
      !
      if (abs(x1).lt.1.d23.and.abs(x2).lt.1.d23.and.abs(x3).lt.1.d23   &
        .and.abs(x4).lt.1.d23) then
         if ((x4-x3)/(x2-x1).lt.0.5) then
            if (dir_string.eq.'LAM') then
               overlapflag(1) = .false.
            else if (dir_string.eq.'BET') then
               overlapflag(2) = .false.
            endif
         endif
      endif
      !
      if (allocated(mask)) deallocate(mask,stat=ier)
      if (allocated(xall)) deallocate(xall,stat=ier)
      if (allocated(yall)) deallocate(yall,stat=ier)
      !
      allocate(mask(nx),xall(nx),yall(nx),stat=ier)
      i2 = 0
      do i = 1, nsubscans
         if (index(pcross(i)%dir,dir_string).ne.0) then
            i1 = i2+1
            i2 = i2+pcross(i)%dat%n
            xall(i1:i2) = pcross(i)%dat%x
            if (abs(xall(i2)-xall(i1))/(x2-x1).lt.0.5.or.   &
              pcross(i)%fun%flag.ne.0) then
               yall(i1:i2) = bval
            else
               yall(i1:i2) = pcross(i)%dat%y
            endif
         endif
      enddo
      call null_simple_1d(dat(idir))
      dat(idir)%n = nint(abs(x2-x1)/dx)+1
      allocate(dat(idir)%x(dat(idir)%n),   &
               dat(idir)%y(dat(idir)%n),   &
               dat(idir)%w(dat(idir)%n),   &
               stat=ier)
      do i = 1, dat(idir)%n
         dat(idir)%x(i) = x1+(i-1)*dx
         mask = .false.
         where(abs(xall-dat(idir)%x(i)).lt.dx) mask = .true.
         where(yall.eq.bval) mask = .false.
         if (count(mask).ne.0) then
            dat(idir)%y(i) = sum(yall,1,mask)/count(mask)
            dat(idir)%w(i) = 1.d0
         else
            dat(idir)%y(i) = bval
            dat(idir)%w(i) = 0.
         endif
      enddo
      !
      ! normalize to maximum in order to avoid numerical problems in telCal's
      ! fitting routine
      !
      yscale = maxval(abs(dat(idir)%y),1,dat(idir)%y.ne.bval)
      where (dat(idir)%y.ne.bval)   &
             dat(idir)%y = dat(idir)%y/yscale
      !
      call null_function(fun(idir))
      fun(idir)%method = 'SLATEC'
      if (ptype.eq.'SIMPLE'.or.dir_string.eq.'BET') then
         fun(idir)%npar   = 5
      else if (ptype.eq.'DUAL') then
         fun(idir)%npar   = 8
      endif
      allocate (fun(idir)%par(fun(idir)%npar),stat=ier)
      call null_parameter(fun(idir)%par(1))
      fun(idir)%par(1)%name = 'AREA1'
      call null_parameter(fun(idir)%par(2))
      fun(idir)%par(2)%name = 'POSITION1'
      call null_parameter(fun(idir)%par(3))
      fun(idir)%par(3)%name = 'WIDTH1'
      !
      if (array(ifb)%header(1)%restfreq.lt.1.2d+11) then
         fun(idir)%par(3)%guess   &
           = 27.5*.88d+11/array(ifb)%header(1)%restfreq
      else if (array(ifb)%header(1)%restfreq.lt.1.9d+11) then
         fun(idir)%par(3)%guess   &
           = 16.0*1.5d+11/array(ifb)%header(1)%restfreq
      else if (array(ifb)%header(1)%restfreq.lt.4.0d+11) then
         fun(idir)%par(3)%guess   &
           = 10.5*2.3d+11/array(ifb)%header(1)%restfreq
      endif
      fun(idir)%par(1)%guess = fun(idir)%par(3)%guess   &
        *sqrt(pi/log(2.d0))/2.
      !
      ! MINI, MAXI not yet used by telCal
      !
      !         FUN(IDIR)%PAR(1)%MINI = 0.
      !         FUN(IDIR)%PAR(1)%MAXI = 1.E23
      if (ptype.eq.'SIMPLE'.or.dir_string.eq.'BET') then
         fun(idir)%name   = 'GAUSSIAN+BASE'
         call null_parameter(fun(idir)%par(4))
         fun(idir)%par(4)%name = 'OFFSET'
         call null_parameter(fun(idir)%par(5))
         fun(idir)%par(5)%name = 'SLOPE'
         fun(idir)%par(4)%guess = 0.
         fun(idir)%par(5)%guess = 0.
         if (ibase.eq.1) then
            fun(idir)%par(1:5)%fixed = .false.
         else if (ibase.eq.0) then
            fun(idir)%par(1:4)%fixed = .false.
            fun(idir)%par(5)%fixed = .true.
         endif
         naver = fun(idir)%par(3)%guess/dx
         xmax = maxval(dat(idir)%x)
         n = 0
         do j = 1, dat(idir)%n
            if (dat(idir)%x(j)+fun(idir)%par(3)%guess.gt.xmax) exit
            n = n+1
         enddo
         if (n.eq.0) then
            naver = dat(idir)%n
            n = 1
         endif
         ymax(idir) = blankingraw
         ymin(idir) = -blankingraw
         i1 = 0
         do j = 1, n
            i2 = i1+naver
            i1 = i1+1
            ytest = sum(dat(idir)%y(i1:i2))/(i2-i1+1)
            if (ytest.le.ymin(idir)) then
               fun(idir)%par(4)%guess = ytest
               ymin(idir) = ytest
            endif
         enddo
         i1 = 0
         do j = 1, n
            i2 = i1+naver
            i1 = i1+1
            ytest = sum(dat(idir)%y(i1:i2))/(i2-i1+1)-ymin(idir)
            if (ytest.ge.ymax(idir)) then
               !
               ! MINI, MAXI not yet used by telCal
               !
               !                  FUN(IDIR)%PAR(2)%MINI = MIN(DAT(IDIR)%X(I1),
               !     &                                        DAT(IDIR)%X(I2))
               !                  FUN(IDIR)%PAR(2)%MAXI = MAX(DAT(IDIR)%X(I1),
               !     &                                        DAT(IDIR)%X(I2))
               fun(idir)%par(2)%guess   &
                 = sum(dat(idir)%x(i1:i2))/(i2-i1+1)
               ymax(idir) = ytest
            endif
         enddo
      !
      else if (ptype.eq.'DUAL') then
         fun(idir)%name   = '2*GAUSSIAN+BASE'
         call null_parameter(fun(idir)%par(4))
         fun(idir)%par(4)%name = 'AREA2/AREA1'
         !
         ! MINI, MAXI not yet used by telCal
         !
         !            FUN(IDIR)%PAR(4)%MINI = -10.
         !            FUN(IDIR)%PAR(4)%MAXI = +10.
         call null_parameter(fun(idir)%par(5))
         fun(idir)%par(5)%name = 'POSITION2-POSITION1'
         call null_parameter(fun(idir)%par(6))
         fun(idir)%par(6)%name = 'WIDTH2/WIDTH1'
         call null_parameter(fun(idir)%par(7))
         fun(idir)%par(7)%name = 'OFFSET'
         call null_parameter(fun(idir)%par(8))
         fun(idir)%par(8)%name = 'SLOPE'
         fun(idir)%par(4)%guess = -1
         fun(idir)%par(5)%guess = scan%header%wobthrow*3600.
         fun(idir)%par(6)%guess = 1
         fun(idir)%par(7)%guess = 0.
         fun(idir)%par(8)%guess = 0.
         fun(idir)%par(2)%guess = -scan%header%wobthrow*1800.
         if (ibase.eq.1) then
            fun(idir)%par(1:8)%fixed = .false.
         else
            fun(idir)%par(1:7)%fixed = .false.
            fun(idir)%par(8)%fixed = .true.
         endif
      endif
      !
      call fit_1d(dat(idir),fun(idir),.false.)
      !         IF (ABS(FUN(IDIR)%PAR(5)%VALUE).GT.0.01) THEN
      !            FUN(IDIR)%PAR(5)%GUESS = 0.
      !            FUN(IDIR)%PAR(5)%FIXED = .true.
      !            CALL FIT_1D(DAT(IDIR),FUN(IDIR),.FALSE.)
      !            CALL GAGOUT(' ')
      !            IF (IDIR.EQ.1) THEN
      !               CALL GAGOUT('W-SOLVE: Baseline order for coadded azimuth'
      !     &                     //' data reset to 0.')
      !            ELSE IF (IDIR.EQ.2) THEN
      !               CALL GAGOUT('W-SOLVE: Baseline order for coadded'
      !     &                     //' elevation data reset to 0.')
      !            ENDIF
      !            CALL GAGOUT(' ')
      !         ENDIF
      !
      ! remove normalization
      !
      where (dat(idir)%y.ne.bval)   &
        dat(idir)%y = dat(idir)%y*yscale
      npar = fun(idir)%npar
      fun(idir)%par(1)%value = fun(idir)%par(1)%value*yscale
      fun(idir)%par(1)%error = fun(idir)%par(1)%error*yscale
      fun(idir)%par(1)%guess = fun(idir)%par(1)%guess*yscale
      fun(idir)%par(npar-1)%value =fun(idir)%par(npar-1)%value*yscale
      fun(idir)%par(npar-1)%error =fun(idir)%par(npar-1)%error*yscale
      fun(idir)%par(npar-1)%guess =fun(idir)%par(npar-1)%guess*yscale
      fun(idir)%par(npar)%value = fun(idir)%par(npar)%value*yscale
      fun(idir)%par(npar)%error = fun(idir)%par(npar)%error*yscale
      fun(idir)%par(npar)%guess = fun(idir)%par(npar)%guess*yscale
      ymin(idir) = ymin(idir)*yscale
      ymax(idir) = ymax(idir)*yscale
   enddo az_el_loop
   !
   do idir = 1, ndir
      call null_simple_1d(profile(idir))
      allocate(profile(idir)%x(dat(idir)%n),   &
               profile(idir)%y(dat(idir)%n),   &
               profile(idir)%w(dat(idir)%n),   &
               profile(idir)%d(dat(idir)%n),   &
               stat=ier)
      profile(idir)%n = dat(idir)%n
      profile(idir)%x = dat(idir)%x
      call get_profile(fun(idir),profile(idir))
      var = 0.
      do j = 1, dat(idir)%n
         var = var+(dat(idir)%y(j)-profile(idir)%y(j))**2
      enddo
      var = var/(dat(idir)%n-1)
      fun(idir)%rms = sqrt(var)
   !
   enddo
   if (ptype.eq.'DUAL') fun(1)%par(2)%value    &
                        =fun(1)%par(2)%value+scan%header%wobthrow*1.8d+3
   !
   ! remove baseline for plotting
   !
   do idir = 1, ndir
      if (fun(idir)%flag.ne.0) cycle
      npar = fun(idir)%npar
      if (ptype.ne.'DUAL'.and.           &
          (fun(idir)%par(npar-1)%value.lt.   &
           ymin(idir)-abs(ymax(idir)).or.   &
           fun(idir)%par(npar-1)%value.gt.   &
           ymin(idir)+2*abs(ymax(idir)))) then
         profile(idir)%y = profile(idir)%y   &
                          -fun(idir)%par(npar-1)%guess

         where (dat(idir)%y.ne.bval)   &
           dat(idir)%y = dat(idir)%y-fun(idir)%par(npar-1)%guess
         if (idir.eq.1) then
            call gagout('W-SOLVE: ambigeous baseline fit in azimuth,'   &
                        //' only 0 order baseline subtracted.')
         else if (idir.eq.2) then
            call gagout('W-SOLVE: ambigeous baseline fit in elevation,'   &
                        //' only 0 order baseline subtracted.')
         endif
      else
         profile(idir)%y = profile(idir)%y   &
                          -fun(idir)%par(npar-1)%value   &
                          -fun(idir)%par(npar)%value*profile(idir)%x
         where (dat(idir)%y.ne.bval)   &
           dat(idir)%y = dat(idir)%y-fun(idir)%par(npar-1)%value   &
                        -fun(idir)%par(npar)%value*profile(idir)%x
      endif
   enddo

   call pointing_to_sic(dat,fun,profile,error)
   write(string,'(A30,1X,I2)') '@ gag_pro:p_plot_pointing.mira',   &
                               ifb
   call exec_program(string(1:34))
   call sic_get_logi('writeXML',writexml,error)
   if (writexml) then
      call protoresultspointing(ifb,ipix,error)
      if (error) call gagout('E-SOLVE: Error in XML file writing.')
   endif
   !
   call gagout(' ')
   call gagout(' Corrections to be entered in PaKo (for angleUnit '//   &
               'arcsec):')
   azcorr = nint((mon(ifb)%header%iaobs_caobs_ieobs(2)*3.6d+3   &
                  +fun(1)%par(2)%value)*10)/10.
   elcorr = nint((mon(ifb)%header%iaobs_caobs_ieobs(3)*3.6d+3   &
                  +fun(2)%par(2)%value)*10)/10.
   write (string,'(A14,2(F6.1,1X))') ' SET POINTING ',azcorr, elcorr
   call gagout(' ')
   call gagout(string)
   call gagout(' ')
   do idir = 1, ndir
      npar = fun(idir)%npar
      if (ptype.ne.'DUAL'.and.                                         &
          (fun(idir)%par(npar-1)%value.lt.ymin(idir)-abs(ymax(idir))   &
           .or.fun(idir)%par(npar-1)%value.gt.                         &
           ymin(idir)+2*abs(ymax(idir))                                &
          )) then
         call exec_program('g\pen /col 1')
         if (idir.eq.1) then
            call exec_program('g\draw relocate -13 -2 /box 1')
            string ='label "Ambigeous baseline fit in azimuth, only'   &
                  //' 0 order baseline subtracted." /center 6'
            call exec_program(string)
         else if (idir.eq.2) then
            call exec_program('g\draw relocate -13 -3 /box 1')
            string ='label "Ambigeous baseline fit in elevation,'   &
                  //' only 0 order baseline subtracted." /center 6'
            call exec_program(string)
         endif
         call exec_program('g\pen /default')
      endif
   enddo
   if (.not.overlapflag(1)) then
      call gagout(' W-SOLVE: overlap of azimuth subscans < 60%')
      if (ibase.eq.1) then
         call gagout('          In case of doubts consider repeat '//   &
                     'or try SOLVE /BASE 0.')
      else
         call gagout('          In case of doubts consider repeat.')
      endif
      call gagout(' ')
      call exec_program('g\pen /col 1')
      call exec_program('g\draw relocate -13 -4 /box 1')
      string ='label "Overlap of azimuth subscans < 60%, " /center 6'
      call exec_program(string)
      string = 'label "in case of doubts consider repeat." /center 6'
      call exec_program(string)
      call exec_program('g\pen /def')
   endif
   if (.not.overlapflag(2)) then
      call gagout(' W-SOLVE: overlap of elevation subscans < 60%')
      if (ibase.eq.1) then
         call gagout('          In case of doubts consider repeat '//   &
                     'or try SOLVE /BASE 0.')
      else
         call gagout('          In case of doubts consider repeat.')
      endif
      call gagout(' ')
      call exec_program('g\pen /col 1')
      call exec_program('g\draw relocate -13 -5 /box 1')
      string   &
        = 'label "Overlap of elevation subscans < 60%, " /center 6'
      call exec_program(string)
      string = 'label "in case of doubts consider repeat." /center 6'
      call exec_program(string)
      call exec_program('g\pen /def')
   endif
   !
   reduce(ifb)%pointing_done = .true.
   !
   ! Cleaning
   call null_simple_1d(profile(1))
   call null_simple_1d(profile(2))
   call null_simple_1d(dat(1))
   call null_simple_1d(dat(2))
   !
   return
end subroutine solve_pointing_mira
!
!
!
subroutine pointing_to_sic(dat,fun,profile,error)
!
! Creates a SIC copy of Mira structure PNT (pointing results for
! co-added azimuth and elevation data). Results from individual
! pointing subscans are in telcal/sic structure PCROSS.
!
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use fit_definitions
   !
   implicit none
   !
   type(simple_1d), dimension(2) :: dat
   type(simple_1d), dimension(2) :: profile
   type(fit_fun), dimension(2)   :: fun
   !
   type(sic_descriptor_t) :: desc
   logical error, exist
   !
   call sic_descriptor('PNT',desc,exist)
   if (exist) call sic_delvariable('PNT',.false.,error)
   !
   call sic_defstructure('PNT',.true.,error)
   call sic_defstructure('PNT%AZM',.true.,error)
   call sic_defstructure('PNT%AZM%DATA',.true.,error)
   call sic_defstructure('PNT%AZM%FIT',.true.,error)
   call sic_defstructure('PNT%AZM%PROFILE',.true.,error)
   call sic_defstructure('PNT%ELV',.true.,error)
   call sic_defstructure('PNT%ELV%DATA',.true.,error)
   call sic_defstructure('PNT%ELV%GUESS',.true.,error)
   call sic_defstructure('PNT%ELV%FIT',.true.,error)
   call sic_defstructure('PNT%ELV%PROFILE',.true.,error)
   !
   call sic_defstructure('PNT%AZM%ERROR',.true.,error)
   call sic_defstructure('PNT%ELV%ERROR',.true.,error)
   !
   call sic_def_inte('PNT%AZM%DATA%N',dat(1)%n,0,0,.true.,error)
   call sic_def_dble('PNT%AZM%DATA%X',dat(1)%x,1,dat(1)%n,   &
                    .true.,error)
   call sic_def_dble('PNT%AZM%DATA%Y',dat(1)%y,1,dat(1)%n,   &
                     .true.,error)
   call sic_def_inte('PNT%ELV%DATA%N',dat(2)%n,0,0,.true.,error)
   call sic_def_dble('PNT%ELV%DATA%X',dat(2)%x,1,dat(2)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%DATA%Y',dat(2)%y,1,dat(2)%n,   &
                     .true.,error)
   !
   call sic_def_inte('PNT%AZM%FIT%FLAG',fun(1)%flag,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%AREA',fun(1)%par(1)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%POSITION',fun(1)%par(2)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%WIDTH',fun(1)%par(3)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%OFFSET',fun(1)%par(4)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%FIT%SLOPE',fun(1)%par(5)%value,   &
                     0,0,.true.,error)
   call sic_def_inte('PNT%ELV%FIT%FLAG',fun(2)%flag,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%AREA',fun(2)%par(1)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%POSITION',fun(2)%par(2)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%WIDTH',fun(2)%par(3)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%OFFSET',fun(2)%par(4)%value,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%FIT%SLOPE',fun(2)%par(5)%value,   &
                     0,0,.true.,error)
   !
   call sic_def_dble('PNT%AZM%GUESS%AREA',fun(1)%par(1)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%POSITION',fun(1)%par(2)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%WIDTH',fun(1)%par(3)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%OFFSET',fun(1)%par(4)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%GUESS%SLOPE',fun(1)%par(5)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%AREA',fun(2)%par(1)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%POSITION',fun(2)%par(2)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%WIDTH',fun(2)%par(3)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%OFFSET',fun(2)%par(4)%guess,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%GUESS%SLOPE',fun(2)%par(5)%guess,   &
                     0,0,.true.,error)
   !
   call sic_def_dble('PNT%AZM%PROFILE%X',profile(1)%x,1,profile(1)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%AZM%PROFILE%Y',profile(1)%y,1,profile(1)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%PROFILE%X',profile(2)%x,1,profile(2)%n,   &
                     .true.,error)
   call sic_def_dble('PNT%ELV%PROFILE%Y',profile(2)%y,1,profile(2)%n,   &
                     .true.,error)
   !
   call sic_def_dble('PNT%AZM%ERROR%AREA',fun(1)%par(1)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%POSITION',fun(1)%par(2)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%WIDTH',fun(1)%par(3)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%OFFSET',fun(1)%par(4)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%AZM%ERROR%SLOPE',fun(1)%par(5)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%AREA',fun(2)%par(1)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%POSITION',fun(2)%par(2)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%WIDTH',fun(2)%par(3)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%OFFSET',fun(2)%par(4)%error,   &
                     0,0,.true.,error)
   call sic_def_dble('PNT%ELV%ERROR%SLOPE',fun(2)%par(5)%error,   &
                     0,0,.true.,error)
   !
   return
end subroutine pointing_to_sic

subroutine solve_xyzfocus(ifb,ipix,idir)
!
! Called by subroutine SOLVE.
! solve_xyzfocus prepares the data of a focus scan
! subsequent call of telcal's subroutine fit_1d, writes
! the results into the corresponding MIRA and SIC structures,
! and calls subroutines protoResultsFocus to write an XML
! file with the results.
!
   use mira
   use gildas_def
   use gkernel_types
   use gkernel_interfaces
   use telcal_interfaces
   use fit_definitions
   use focus_definitions
   !
   implicit none
   !
   character(len=40)                  :: string
   integer                            :: i,idir,ier,ifb,ipix,j,n,   &
                                         npar,nrecords,nsol,nsubscans
   type(sic_descriptor_t)             :: desc
   real*4                             :: dz,focusnew,min,max
   real*8                             :: val,var
   real*8, dimension(:), allocatable  :: offset
   logical                            :: error,exist
   logical, dimension(:), allocatable :: mask,offsetflag
   !
   type (focus)                       :: tmp
   !
   nrecords = maxval(data(ifb)%data%integnum)
   nsubscans = maxval(data(ifb)%data%subscan )
   !
   npar = 3   ! Parabola, Lorentzian or Gaussian fitting
   nsol = 100
   !
   if (allocated(mask)) deallocate(mask,stat=ier)
   allocate(mask(nrecords),stat=ier)
   if (allocated(offsetflag)) deallocate(offsetflag,stat=ier)
   allocate(offsetflag(nrecords),stat=ier)
   !
   n = 0
   offsetflag = .false.
   mask = .true.
   do i = 1, nsubscans
      mask = .not.offsetflag.and.mask
      if (count(mask).eq.0) exit
      n = n+1
      val =minval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),   &
        1,mask)
      offsetflag = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.val
   enddo
   !
   if (allocated(offset)) deallocate(offset,stat=ier)
   allocate(offset(n),stat=ier)
   !
   n = 0
   offsetflag = .false.
   mask = .true.
   do i = 1, nsubscans
      mask = .not.offsetflag.and.mask
      if (count(mask).eq.0) exit
      n = n+1
      offset(n) =minval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),   &
        1,mask)
      offsetflag = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.offset(n)
   enddo
   !
   !
   zfocus%sys = 0
   !
   call null_simple_1d(zfocus%dat(1))
   zfocus%dat(1)%n = n
   allocate(zfocus%dat(1)%x(zfocus%dat(1)%n),   &
            zfocus%dat(1)%y(zfocus%dat(1)%n),   &
            zfocus%dat(1)%w(zfocus%dat(1)%n),   &
            stat=ier)
   zfocus%dat(1)%x = 0.d0
   zfocus%dat(1)%x = 0.d0
   zfocus%dat(1)%w = 1.d0
   !
   call null_simple_1d(zfocus%sol(1))
   zfocus%sol(1)%n = nsol
   allocate(zfocus%sol(1)%x(nsol),zfocus%sol(1)%y(nsol),   &
            zfocus%sol(1)%w(nsol),zfocus%sol(1)%d(nsol),   &
            stat=ier)
   zfocus%sol(1)%x = 0.
   zfocus%sol(1)%y = 0.
   zfocus%sol(1)%w = 1.
   zfocus%sol(1)%d = 0.
   !
   call null_function(zfocus%fun(1))
   zfocus%fun(1)%name = 'POLYNOMIAL'
   zfocus%fun(1)%method = 'SLATEC'
   zfocus%fun(1)%npar = npar
   zfocus%fun(1)%flag = 0
   allocate(zfocus%fun(1)%par(npar),stat=ier)
   do i = 1, npar
      call null_parameter(zfocus%fun(1)%par(i))
      write(string,'(a12,i2)') 'COEFFICIENT ', i-1
      zfocus%fun(1)%par(i)%name = string
   enddo
   !
   mask = .false.
   do i = 1, zfocus%dat(1)%n
      mask = data(ifb)%data%dfocus_x_y_z(1:nrecords,idir)   &
        .eq.offset(i)
      zfocus%dat(1)%x(i) =   &
        maxval(data(ifb)%data%dfocus_x_y_z(1:nrecords,idir),mask)
      zfocus%dat(1)%y(i) =   &
        sum(data(ifb)%data%otfdata(ipix,1,1:nrecords),mask)   &
        /count(mask)
   enddo
   !
   if (idir.eq.1) then
      zfocus%dir(1) = '+FCX'
   else if (idir.eq.2) then
      zfocus%dir(1) = '+FCY'
   else if (idir.eq.3) then
      zfocus%dir(1) = '+FCZ'
   endif
   !
   call sic_descriptor('ZFOCUS',desc,exist)
   if (exist) call sic_delvariable('ZFOCUS',.false.,error)
   call define_sic_focus
   !
   min = minval(zfocus%dat(1)%x)
   max = maxval(zfocus%dat(1)%x)
   dz = max-min
   min = min-0.1*dz
   max = max+0.1*dz
   do i = 1, zfocus%sol(1)%n
      zfocus%sol(1)%x(i) = min+(max-min)*(i-1)/(zfocus%sol(1)%n-1)
   enddo
   !
   call exec_program('clear')
   !
   tmp%dat(1)%n = zfocus%dat(1)%n
   allocate(tmp%dat(1)%x(tmp%dat(1)%n),tmp%dat(1)%y(tmp%dat(1)%n),   &
            tmp%dat(1)%w(tmp%dat(1)%n),stat=ier)
   tmp%dat(1)%x = zfocus%dat(1)%x
   tmp%dat(1)%w = zfocus%dat(1)%w
   tmp%dat(1)%y = zfocus%dat(1)%y
   tmp%dat(1)%y = zfocus%dat(1)%y
   !
   call fit_1d(tmp%dat(1),zfocus%fun(1),.false.)
   call get_profile(zfocus%fun(1),zfocus%sol(1))
   !
   var = 0.d0
   do i = 1, 3
      val= zfocus%fun(1)%par(1)%value   &
          +zfocus%dat(1)%x(i)*(zfocus%fun(1)%par(2)%value   &
                              +zfocus%dat(1)%x(i)   &
                              *zfocus%fun(1)%par(3)%value)
      zfocus%fun(1)%rms = var+(val-zfocus%dat(1)%y(i))**2
   enddo
   zfocus%fun(1)%rms = sqrt(zfocus%fun(1)%rms)/2.d0
   call sic_get_logi('writeXML',writexml,error)
   if (writexml) then
      call protoresultsfocus(ifb,ipix,zfocus%fun,error)
      if (error) call gagout('E-SOLVE: Error in XML file writing.')
   endif
   !
   write(string,'(A28,I2,I3)') '@gag_pro:p_plot_focus.mira ',ifb,   &
     ipix
   call exec_program(string(1:34))
   !
   if (error) call gagout('E-SOLVE: Error in XML file writing.')
   !
   if (idir.eq.3) then
      call gagout(' ')
      call gagout(' Corrections to be entered in PaKo [mm]: ')
      focusnew = nint((-zfocus%fun(1)%par(2)%value   &
                       /(2.*zfocus%fun(1)%par(3)%value))*100)/100.
      write (string,'(A11,F6.2)') ' SET FOCUS ',focusnew
      call gagout(' ')
      call gagout(string)
      call gagout(' ')
   endif
   !
   reduce(ifb)%focus_done = .true.
   return
end subroutine solve_xyzfocus
!
!
!
subroutine solve_tip(ifb,ipix)
!
! Called from run_mira (MIRA command SOLVE if current scan is a 
! skytip). This subroutine is merely an interface to SIC routine
! where the skydip is solved (in mira/pro/p_plot_tip.mira).
!
!
   integer           :: ifb, ipix
   character(len=40) :: string
   !
   write(string,'(A25,I0,I3)') '@gag_pro:p_plot_tip.mira ',ifb, ipix
   call exec_program(string)
   !
   return
end subroutine solve_tip
!
subroutine linregress(basedata,basepar,bval)
   !
   use linearregression
   !
   implicit none
   !
   type(lg)                         :: basepar
   type(base), dimension(basepar%n) :: basedata
   real*8                           :: bval
   !
   real*8                           :: sumx, sumxx, sumxy, sumy,sumyy
   integer                          :: n
   type(base), dimension(basepar%n) :: squareddata
   logical, dimension(basepar%n)    :: mask
   !
   n = basepar%n
   squareddata(1:n)%x = basedata(1:n)%x*basedata(1:n)%x
   squareddata(1:n)%y = basedata(1:n)%y*basedata(1:n)%y
   mask = basedata(1:n)%y.ne.bval
   sumx = sum(basedata(1:n)%x,mask)
   sumy = sum(basedata(1:n)%y,mask)
   sumxx = sum(squareddata(1:n)%x,mask)
   sumyy = sum(squareddata(1:n)%y,mask)
   sumxy = sum(basedata(1:n)%x*basedata(1:n)%y,mask)
   !
   basepar%det = count(mask)*sumxx-sumx*sumx
   basepar%a = (sumxx*sumy-sumx*sumxy)/basepar%det
   basepar%b = (count(mask)*sumxy-sumx*sumy)/basepar%det
!
end subroutine linregress

subroutine gfits_open(file,status,error,overwrite)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_open
  use gfits_buf
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! FITS API routine
  !       Connect with a FITS file on disk.
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: file       ! FITS file name
  character(len=*),  intent(in)    :: status     ! Read (IN) or Write (OUT) status
  logical,           intent(inout) :: error      ! Error flag
  logical, optional, intent(in)    :: overwrite  ! Overwrite in case of OUT status?
  ! Local
  character(len=*), parameter :: rname='OPEN'
  character(len=8), parameter :: defext='.fits'
  character(len=filename_length) :: name
  integer(kind=4) :: ier,recl,nc
  character(len=message_length) :: mess
  character(len=1) :: key
  !
  key = status(1:1)
  call sic_upper(key)
  !
  if (file(1:1).eq.'!') then  ! ???
    name = file(2:)
  else
    call sic_parse_file(file,' ',defext,name)
  endif
  !
  if (key.eq.'O' .and. present(overwrite) .and. overwrite) then
    nc = len_trim(name)
    if (gag_inquire(name,nc).eq.0)  call gag_filrm(name(1:nc))
  endif
  !
  if (dev_type.eq.disk) then
    ier = sic_getlun(unit)
    if (ier.ne.1) then
      error = .true.
      return
    endif
    !
    ! Open file with apropriate options
    recl = 720                 ! 2880 bytes = 720 words
    if (key.eq.'I') then
      open(unit=unit,file=name,status='OLD',recl=recl*facunf,  &
           form='UNFORMATTED',access='DIRECT',action='READ',iostat=ier)
    elseif (key.eq.'O') then
      open(unit=unit,file=name,status='NEW',recl=recl*facunf,  &
           form='UNFORMATTED',access='DIRECT',action='READWRITE',iostat=ier)
    else
      call gfits_message(seve%e,rname,'Programming error')
      error = .true.
      return
    endif
    if (ier.eq.0) then
      stdio = .true.
    else
      ! Try to recover
      call sic_frelun (unit)
      unit = 0
      call gfits_message(seve%e,rname,'Error opening '//name)
      call putios('E-OPEN,  ',ier)
      error = .true.
    endif
    !
  else
    write(mess,*) 'Unsupported device type ',dev_type
    call gfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Read-write status?
  read = key.eq.'I'
  !
  ! Rewind the pointers to start of file
  call gfits_rewind_file(error)
  ! Current extension is Primary: starts at record 1
  hdurec = 1
  !
end subroutine gfits_open
!
subroutine gfits_close(error)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_close
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS API routine
  !       Disconnect from a FITS file, after flushing the data if needed
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  logical :: error2
  !
  ! Ensure the following operations are correctly performed even in case
  ! of error recovery (i.e. entering here with error=.true.)
  error2 = .false.
  !
  ! First, dump current buffer
  if (.not.read) then
    call gfits_flush_data(error2)
    if (error2)  error = .true.
    if (error)  return
  endif
  !
  if (dev_type.eq.disk) then
    if (stdio) then
      close(unit=unit)
      call sic_frelun (unit)
    endif
    unit = 0
  endif
  !
end subroutine gfits_close
!
subroutine gfits_putrec(buff,error)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_putrec
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Write one logical FITS record
  !---------------------------------------------------------------------
  integer(kind=1), intent(in)    :: buff(2880)  ! I/O buffer
  logical,         intent(inout) :: error       ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer :: ier
  character(len=message_length) :: mess
  !
  if (dev_type.eq.disk) then
    write(unit=unit,iostat=ier,rec=irec) buff
    if (ier.ne.0) then
      call putios('E-FPUTREC  ',ier)
      error = .true.
      return
    endif
    irec = irec+1
  else
    write(mess,*) 'Unsupported device type ',dev_type
    call gfits_message(seve%e,rname,mess)
  endif
  !
end subroutine gfits_putrec
!
subroutine gfits_getrec(buff,error)
  use gfits_interfaces, except_this=>gfits_getrec
  !---------------------------------------------------------------------
  ! @ private
  ! Read one logical FITS record (verbose mode)
  !---------------------------------------------------------------------
  integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
  logical,         intent(inout) :: error       ! Error flag
  ! Local
  logical :: eof  ! Unused
  !
  call fgetrec_sub(buff,error,eof,.false.)
  !
end subroutine gfits_getrec
!
subroutine fgetrecquiet(buff,error,eof)
  use gfits_interfaces, except_this=>fgetrecquiet
  !---------------------------------------------------------------------
  ! @ private
  ! Read one logical FITS record (quiet mode)
  !---------------------------------------------------------------------
  integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
  logical,         intent(inout) :: error       ! Error flag
  logical,         intent(out)   :: eof         ! End of file flag
  !
  call fgetrec_sub(buff,error,eof,.true.)
  !
end subroutine fgetrecquiet
!
subroutine fgetrec_sub(buff,error,eof,quiet)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>fgetrec_sub
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! FITS  Internal routine
  !       Read one logical FITS record
  !---------------------------------------------------------------------
  integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
  logical,         intent(inout) :: error       ! Error flag
  logical,         intent(out)   :: eof         ! End of file flag
  logical,         intent(in)    :: quiet       ! Verbosity flag
  ! Local
  integer :: ier
  character(len=message_length) :: mess
  !
  eof = .false.
  if (dev_type.eq.disk) then
    if (stdio) then            ! Normal fortran IO
      read(unit=unit,iostat=ier,rec=irec) buff
      ! Now Fortran-90 norm says IER < 0 is EOF.  
      if (ier.lt.0) then
        eof = .true.
        return
      elseif (ier.gt.0) then
        ! IF Quiet, Silently ignore the error and treat as EOF 
        if (quiet) then
          eof = .true.
        else
          write(mess,*) 'Irec ',irec
          call gfits_message(seve%e,'FGETREC',mess)
          call putios('E-FGETREC, IO error:  ',ier)
          error = .true.
        endif
        return
      endif
      irec = irec+1
    endif
  else
    write(mess,*) 'Unsupported device type: ',dev_type
    call gfits_message(seve%e,'FITS',mess)
  endif
end subroutine fgetrec_sub
!
subroutine gfits_skirec(nrec,error)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_skirec
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API routine
  !       Skips a (positive or negative) number of FITS logical records
  !---------------------------------------------------------------------
  integer(kind=record_length), intent(in)    :: nrec   ! Number of records to skip
  logical,                     intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=record_length) :: i
  !
  if (.not.read) then
    call gfits_message(seve%e,'SKIP','Programming error. Not supported for '//  &
    'output')
    error = .true.
    return
  endif
  if (dev_type.eq.disk.and.stdio) then
    irec = irec+nrec
  else                         ! Should be optimised one day...
    do i=1,nrec
      call gfits_getrec(buffer,error)
    enddo
  endif
  return
  !
end subroutine gfits_skirec
!
subroutine gfits_getrecnum(irecnum)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_getrecnum
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API routine
  !       Returns the number of the present FITS 2880-bytes record.
  !---------------------------------------------------------------------
  integer(kind=record_length), intent(out) :: irecnum  ! Current record number
  irecnum = irec
end subroutine gfits_getrecnum
!
subroutine gfits_setrecnum(irecnum)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_setrecnum
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API Routine
  !       Sets the number of the FITS 2880-bytes record.
  !---------------------------------------------------------------------
  integer(kind=record_length), intent(in) :: irecnum  ! Current record number
  irec = irecnum
end subroutine gfits_setrecnum
!
subroutine gfits_getrecoffset(ioffset)
  use gfits_interfaces, except_this=>gfits_getrecoffset
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API routine
  !       Returns the offset (in bytes) of the next data to be read
  !       inside the present 2880-bytes record.
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: ioffset        ! Offset in current record
  ioffset = ib
end subroutine gfits_getrecoffset
!
subroutine gfits_setrecoffset(ioffset)
  use gfits_interfaces, except_this=>gfits_setrecoffset
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API routine
  !       Sets the offset (in bytes) of the next data to be read inside
  !       the present 2880-bytes record.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: ioffset          ! Offset in current record
  ib = ioffset
end subroutine gfits_setrecoffset
!
subroutine gfits_getstdrec(error)
  use gfits_interfaces, except_this=>gfits_getstdrec
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS  API routine
  !     Get the next buffer internally
  !     Only used by CLASS 3dfits.f90
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  call gfits_getrec(buffer,error)
end subroutine gfits_getstdrec
!
subroutine fseefilepos()
  use gildas_def
  use gfits_interfaces, except_this=>fseefilepos
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Used while debugging.
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='FSEEFILEPOS'
  integer(kind=record_length) :: nextrec
  character(len=message_length) :: mess
  !
  inquire(unit=unit,nextrec=nextrec)
  write(mess,*) 'Nextrec = ',nextrec
  call gfits_message(seve%d,rname,mess)
  write(mess,*) 'IREC    = ',irec
  call gfits_message(seve%d,rname,mess)
  if (irec.eq.nextrec) then
    call gfits_message(seve%d,rname,'OK !')
  else
    call gfits_message(seve%d,rname,'There is a problem')
  endif
end subroutine fseefilepos
!
function gfits_iseof()
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! FITS API routine
  !     Tells if the FITS file has reached EOF
  !---------------------------------------------------------------------
  logical :: gfits_iseof                 ! intent(out)
  ! Local
  integer :: ier
  integer (kind=1) :: buff(2880)
  !
  ! call fSeeFilePos
  !
  ! Try to read the next buffer from the file.
  ! IREC contains the number of the next record to read.
  read(unit = unit,rec = irec,iostat = ier) buff
  if (ier.eq.0) then
    gfits_iseof = .false.
  else
    gfits_iseof = .true.
  endif
  !  call fSeeFilePos
end function gfits_iseof
!
subroutine gfits_rewind_file(error)
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Rewind the pointers to start of file
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  irec = 1
  if (read) then
    ib = 2880   ! Nothing left for read
  else
    ib = 0      ! Buffer is empty
  endif
  !
end subroutine gfits_rewind_file
!
subroutine gfits_rewind_hdu(error)
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Rewind the pointers to start of current HDU
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  irec = hdurec
  if (read) then
    ib = 2880   ! Nothing left for read
  else
    ib = 0      ! Buffer is empty
  endif
  !
end subroutine gfits_rewind_hdu

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtindex_open_one(indexfile,directory,ix,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_open_one
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Open the index file and append IX accordingly
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: indexfile  !
  character(len=*),          intent(in)    :: directory  !
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error      !
  ! Local
  integer(kind=4) :: fileid
  !
  ! Now fill the IX optimize buffer
  call mrtindex_file_old(indexfile,directory,.false.,fileid,error)
  if (error)  return
  !
  call mrtindex_index_read(ix_files(fileid),fileid,ix,error)
  if (error)  return
  !
end subroutine mrtindex_open_one
!
subroutine mrtindex_index_read(file,idir,optx,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use imbfits_parameters
  use mrtindex_interfaces, except_this=>mrtindex_index_read
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !   Read all entries in one index file, and append them to the given
  ! index.
  !---------------------------------------------------------------------
  type(classic_file_t),    intent(in)    :: file    !
  integer(kind=4),         intent(in)    :: idir    ! Directory identifier
  type(mrtindex_optimize_t), intent(inout) :: optx    !
  logical,                 intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>READ'
  type(mrtindex_indx_t) :: indx
  integer(kind=entry_length) :: nent,ient
  integer(kind=entry_length), parameter :: zero=0
  logical, parameter :: islast=.false.
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  nent = optx%next-1 + file%desc%xnext-1
  !
  call reallocate_mrtoptimize(optx,nent,.true.,error)
  if (error)  return
  !
  do ient=1,file%desc%xnext-1
    call mrtindex_entry_rindx(file,ient,indx,error)
    if (error)  return
    !
    ! "Observation" number is not known at this stage. Use 0 instead. It is
    ! up to the caller to do something! Same for is-last-version flag.
    call mrtindex_index_to_optimize_inplace(indx,idir,ient,optx%next,zero,  &
      optx%next,islast,optx,optx%next,error)
    if (error)  return
    !
    optx%next = optx%next+1
  enddo
  !
end subroutine mrtindex_index_read
!
subroutine mrtindex_entry_read(filein,ient,entry,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_read
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Read the ient-th entry in the output file
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: filein   !
  integer(kind=entry_length), intent(in)    :: ient     !
  type(mrtindex_entry_t),       intent(inout) :: entry    !
  logical,                    intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>READ>ONE'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  call mrtindex_entry_rindx(filein,ient,entry%indx,error)
  if (error)  return
  !
  call mrtindex_entry_rheader(filein,ient,entry%indx,entry%desc,entry%head,error)
  if (error)  return
  !
end subroutine mrtindex_entry_read
!
subroutine mrtindex_entry_rheader_byoptx(optx,ient,edesc,head,error)
  use gildas_def
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_entry_rheader_byoptx
  use mrtindex_vars
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_entry_rheader
  !  Read the header of the ient-th entry in the given index
  !  Also return the entry descriptor as a side product, which is
  ! useful in some cases
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx    !
  integer(kind=entry_length), intent(in)    :: ient    ! Position in index
  type(classic_entrydesc_t),  intent(out)   :: edesc   !
  type(mrtindex_header_t),      intent(inout) :: head    !
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='RHEADER'
  integer(kind=4) :: fileid
  character(len=message_length) :: mess
  !
  ! Find the associated index file
  fileid = optx%idir(ient)
  call mrtindex_file_old(fileid,.false.,error)
  if (error)  return
  !
  call mrtindex_entry_rheader_sub(ix_files(fileid),optx%fnum(ient),  &
    optx%bloc(ient),optx%word(ient),edesc,head,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  &
      'Error reading entry #',optx%fnum(ient),' from file ',ix_files(fileid)%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
  ! Do not forget the key!
  call mrtindex_optimize_to_key(optx,ient,head%key,error)
  if (error)  return
  !
end subroutine mrtindex_entry_rheader_byoptx
!
subroutine mrtindex_entry_rheader_byindx(filein,ient,indx,edesc,head,error)
  use gildas_def
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_entry_rheader_byindx
  use mrtindex_vars
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_entry_rheader
  !  Read the header of the ient-th entry in the file + indx
  !  Also return the entry descriptor as a side product, which is
  ! useful in some cases
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: filein  !
  integer(kind=entry_length), intent(in)    :: ient    ! Position in file
  type(mrtindex_indx_t),        intent(in)    :: indx    ! Associated indx
  type(classic_entrydesc_t),  intent(out)   :: edesc   !
  type(mrtindex_header_t),      intent(inout) :: head    !
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='RHEADER'
  character(len=message_length) :: mess
  !
  call mrtindex_entry_rheader_sub(filein,ient,indx%bloc,indx%word,edesc,head,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  &
      'Error reading entry #',ient,' from file ',filein%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
  ! Do not forget the key!
  call mrtindex_index_to_key(indx,head%key,error)
  if (error)  return
  !
end subroutine mrtindex_entry_rheader_byindx
!
subroutine mrtindex_entry_rheader_sub(filein,ient,bloc,word,edesc,head,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rheader_sub
  use mrtindex_vars
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the header of the ient-th entry in file.
  !  Also return the entry descriptor as a side product, which is
  ! useful in some cases
  ! ---
  !   DO NOT CALL DIRECTLY!!! Use generic entry point
  ! 'mrtindex_entry_rheader' instead
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: filein  !
  integer(kind=entry_length), intent(in)    :: ient    ! Position in file
  integer(kind=8),            intent(in)    :: bloc    ! In which record?
  integer(kind=4),            intent(in)    :: word    ! Which word in this record?
  type(classic_entrydesc_t),  intent(out)   :: edesc   !
  type(mrtindex_header_t),    intent(inout) :: head    !
  logical,                    intent(inout) :: error   !
  !
  call classic_recordbuf_open(filein,bloc,word,ibufobs,error)
  if (error)  return
  !
  call classic_entrydesc_read(filein,ibufobs,edesc,error)
  if (error)  return
  !
  ! Fill the 'presec' array
  call classic_entrydesc_secfind_all(edesc,head%presec,1,error)
  if (error)  return
  !
  if (head%presec(sec_prim_id)) then
    call mrtindex_entry_rprim(filein,edesc,head%pri,error)
    if (error)  return
  else
    call mrtindex_entry_zprim(head%pri,error)
    if (error)  return
  endif
  !
  if (head%presec(sec_calib_id)) then
    call mrtindex_entry_rcalib(filein,edesc,head%cal,error)
    if (error)  return
  else
    call mrtindex_entry_zcalib(head%cal,error)
    if (error)  return
  endif
  !
  if (head%presec(sec_science_id)) then
    call mrtindex_entry_rscience(filein,edesc,head%sci,error)
    if (error)  return
  else
    call mrtindex_entry_zscience(head%sci,error)
    if (error)  return
  endif
  !
  if (head%presec(sec_pointing_id)) then
    call mrtindex_entry_rpointing(filein,edesc,head%poi,error)
    if (error)  return
  else
    call head%poi%zero(error)
    if (error)  return
  endif
end subroutine mrtindex_entry_rheader_sub
!
subroutine mrtindex_entry_rprim(filein,edesc,prim,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rprim
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: filein  !
  type(classic_entrydesc_t), intent(in)    :: edesc   ! Entry Descriptor
  type(sec_primary_t),       intent(out)   :: prim    !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='INDEX>RPRIM'
  integer(kind=data_length) :: lsec
  integer(kind=4) :: iwork(sec_prim_len)
  !
  lsec = sec_prim_len
  call classic_entry_section_read(sec_prim_id,lsec,iwork,edesc,ibufobs,error)
  if (error) return
  !
  call filein%conv%read%r4 (iwork(1),prim%imbfvers,1)
! call filein%conv%read%r8 (iwork(),prim%lam,     1)
! call filein%conv%read%r8 (iwork(),prim%bet,     1)
! call filein%conv%read%r8 (iwork(),prim%timegoal,1)
! call filein%conv%read%i4 (iwork(),prim%nsubgoal,1)
! call filein%conv%read%i4 (iwork(),prim%nsub,    1)
  !
end subroutine mrtindex_entry_rprim
!
subroutine mrtindex_entry_rcalib(filein,edesc,calib,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rcalib
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: filein  !
  type(classic_entrydesc_t), intent(in)    :: edesc   ! Entry Descriptor
  type(sec_calib_t),         intent(inout) :: calib   !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='INDEX>RCALIB'
  integer(kind=4) :: jsec,ndata,nfreq,nset,npix,iset
  integer(kind=data_length) :: lsec,addr
  integer(kind=4), allocatable :: iwork(:)
  logical :: found
  character(len=message_length) :: mess
  !
  call classic_entrydesc_secfind_one(edesc,sec_calib_id,found,jsec)
  if (.not.found) then
    call mrtindex_message(seve%e,rname,'No calibration section')
    error = .true.
    return
  endif
  lsec = edesc%secleng(jsec)
  !
  allocate(iwork(lsec))  ! zzz failed_allocate
  call classic_entry_section_read(sec_calib_id,lsec,iwork,edesc,ibufobs,error)
  if (error) return
  !
  call filein%conv%read%i4(iwork(1),nfreq,1)
  call filein%conv%read%i4(iwork(2),nset, 1)
  call filein%conv%read%i4(iwork(3),npix, 1)
  !
  ndata = nfreq*nset*npix
  if (lsec.ne.3+2*nset+4*ndata) then
    write(mess,'(5(A,I0))')  &
      'Invalid number of points: expected ',3+2*nset+4*ndata, &
      ' (nfreq=',nfreq, &
      ', nset=',nset,  &
      ', npix=',npix,  &
      '), got ',lsec
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  call reallocate_calib_section(nfreq,nset,npix,calib,error)
  if (error)  return
  !
  addr = 4
  do iset=1,nset
    call filein%conv%read%cc(iwork(addr),calib%frontend(iset),2)
    addr = addr+2
  enddo
  call filein%conv%read%r8(iwork(addr),calib%freq,ndata)
  addr = addr+2*ndata
  call filein%conv%read%r4(iwork(addr),calib%atsys,ndata)
  addr = addr+ndata
  call filein%conv%read%r4(iwork(addr),calib%ztau,ndata)
  !
end subroutine mrtindex_entry_rcalib
!
subroutine mrtindex_entry_rscience(filein,edesc,sci,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rscience
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: filein  !
  type(classic_entrydesc_t), intent(in)    :: edesc   ! Entry Descriptor
  type(sec_science_t),       intent(out)   :: sci     !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='INDEX>RSCIENCE'
  integer(kind=data_length) :: lsec
  integer(kind=4) :: iwork(sec_science_len)
  !
  lsec = sec_science_len
  call classic_entry_section_read(sec_science_id,lsec,iwork,edesc,ibufobs,error)
  if (error) return
  !
  call filein%conv%read%i4(iwork(1),sci%caldobs,1)
  call filein%conv%read%i4(iwork(2),sci%calscan,1)
  call filein%conv%read%i4(iwork(3),sci%calback,1)
  call filein%conv%read%i4(iwork(4),sci%calvers,1)
  !
end subroutine mrtindex_entry_rscience
!
subroutine mrtindex_entry_rpointing(filein,edesc,poi,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rpointing
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t),      intent(in)    :: filein  !
  type(classic_entrydesc_t), intent(in)    :: edesc   ! Entry Descriptor
  type(sec_pointing_t),      intent(out)   :: poi     !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='INDEX>RPOINTING'
  logical :: found
  integer(kind=4) :: jsec
  integer(kind=data_length) :: lsec
  integer(kind=4), allocatable :: iwork(:)
  !
  call classic_entrydesc_secfind_one(edesc,sec_pointing_id,found,jsec)
  if (.not.found) then
    call mrtindex_message(seve%e,rname,'No pointing section')
    error = .true.
    return
  endif
  lsec = edesc%secleng(jsec)
  !
  allocate(iwork(lsec))  ! zzz failed_allocate
  call classic_entry_section_read(sec_pointing_id,lsec,iwork,edesc,ibufobs,error)
  if (error) return
  call poi%read(filein,iwork,error)
  if (error) return
end subroutine mrtindex_entry_rpointing
!
subroutine mrtindex_entry_rindx(filein,ient,indx,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_entry_rindx
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(classic_file_t),       intent(in)    :: filein  !
  integer(kind=entry_length), intent(in)    :: ient    ! Entry position in file
  type(mrtindex_indx_t),        intent(out)   :: indx    !
  logical,                    intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ENTRY>RINDX'
  integer(kind=4) :: idatabi(mrtindex_indx_length)
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Read the block index of entry_num in idatabi(:)
  call classic_entryindex_read(filein,ient,idatabi,ibufbi,error)
  if (error)  return
  !
  ! Fill ind% from idatabi(:), convert bytes if needed
  call mrtindex_index_frombuf(idatabi,indx,filein%desc%vind,filein%conv,error)
  if (error)  return
  !
end subroutine mrtindex_entry_rindx
!
subroutine mrtindex_index_frombuf(data,indx,vind,conv,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_index_frombuf
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !   Copy the Block Index into the given buffer
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  type(mrtindex_indx_t),    intent(out)   :: indx     !
  integer(kind=4),          intent(in)    :: vind     ! Index version
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='INDEX>FROMBUF'
  character(len=message_length) :: mess
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  call conv%read%i8(data(1), indx%bloc,        1)
  call conv%read%i4(data(3), indx%word,        3)
  call conv%read%cc(data(6), indx%source,      3)
  call conv%read%cc(data(9), indx%projid,      2)
  call conv%read%r8(data(11),indx%ut,          2)
  call conv%read%r4(data(15),indx%az,          2)
  call conv%read%r8(data(17),indx%lon,         2)
  call conv%read%i4(data(21),indx%system,      1)
  call conv%read%r8(data(22),indx%equinox,     1)
  call conv%read%cc(data(23),indx%frontend(1), 2)
  call conv%read%cc(data(25),indx%frontend(2), 2)
  call conv%read%cc(data(27),indx%frontend(3), 2)
  call conv%read%cc(data(29),indx%frontend(4), 2)
  select case (vind)
  case (2)
    call conv%read%i4(data(31),indx%dobs,        8)
    indx%solstatus = solstatus_none
    call conv%read%cc(data(39),indx%filename,   10)
    call conv%read%i8(data(49),indx%itime,       1)
  case (3)
    call conv%read%i4(data(31),indx%dobs,        9)
    call conv%read%cc(data(40),indx%filename,   10)
    call conv%read%i8(data(50),indx%itime,       1)
  case default
    write(mess,'(a,i0)') 'Unexpected index version ',vind
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  end select
  !
end subroutine mrtindex_index_frombuf
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     
!  Id: modulePakoStart.f90,v 1.2.4 2015-06-08 Hans Ungerechts
!  Id: modulePakoStart.f90,v 1.2.4 2015-06-01 Hans Ungerechts
!  Id: modulePakoStart.f90,v 1.2.3 2014-10-23 Hans Ungerechts
!  Id: modulePakoStart.f90,v 1.2.3 2014-10-17 Hans Ungerechts
!  Id: modulePakoStart.f90,v 1.2.3 2014-05-13 Hans Ungerechts
!                                  patch for check # of backends
!                                  2014-04-29 Hans Ungerechts
!                                  comment debug write(6,*)
!  Id: modulePakoStart.f90,v 1.2.2 2013-02-06 Hans Ungerechts
!  Id: modulePakoStart.f90,v 1.2.1 2012-08-20 Hans Ungerechts
!    
! <DOCUMENTATION name="moduleStart">
!
! handle Start command.
!
! </DOCUMENTATION>
!
! <DEV> 
! TBD: - more documentation
! TBD: put file backup mechanism in utility SR
! TBD: put file operations like cp in utility SR
! <\DEV> 
!
Module modulePakoStart
  !
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoUtilities
  Use modulePakoGlobalVariables
  Use modulePakoReceiver
!!$  Use modulePakoReceiver, Only: listRX, varReceiver, queryReceiver
  Use modulePakoCalibrate
  Use modulePakoFocus
  Use modulePakoOnOff
  Use modulePakoLissajous
  Use modulePakoOtfMap
  Use modulePakoPointing
  Use modulePakoDIYlist
  Use modulePakoSubscanList
  Use modulePakoTip
  Use modulePakoTrack
  Use modulePakoVlbi
  !
  Use gbl_message
  !
  Implicit None
  Save
!!$  Private
!!$  !
!!$  !
  ! *** Subroutines
  !
  Public :: pakoStart
  !
!!!
!!!
Contains
!!!
!!!
  Subroutine pakoStart(programName,LINE,COMMAND,ERROR)
    !
    !**   arguments:   ***
    Character(len=lenPro),        Intent(in)    ::  programName
    Character(len=lenLineDouble), Intent(in)    ::  LINE
    Character(len=lenCo),         Intent(in)    ::  COMMAND
    Logical,                      Intent(out)   ::  ERROR
    !
    !**   specific local variables:    ***
    Character(len=lenCh)          ::  commandToStart
    Character(len=lenVar)         ::  baseFileName
    Character(len=lenVar)         ::  startFile, startFileOLD
    Character(len=lenVar)         ::  queueFile, queueFileOLD
    Character(len=lenVar)         ::  htmlFile,  htmlFileOLD
    Character(len=lenVAr)         ::  htmlQFile, htmlQFileOLD
    Character(len=lenLineDouble)  ::  shellCommand
    Integer                       ::  ier, priorityIlocal
    !
    !**   functions called:   ***
    Integer  ::  SIC_NARG
    Integer  ::  Rename
    Integer  ::  System
    !
    Logical  ::  receiverIsHolo
    Logical  ::  isConnected, errorS
    !
    Integer  ::  iUnit2
    Integer  ::  Job
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Start, v 1.2.4 2015-06-08---> SR: Start ")                  ! this allows to trace execution
    !
    priorityIlocal  = 1
    !
    errorL = .False.
    errorS = .False.
    !
    commandToStart = GV%observingModePako
    !
    !**   read Parameters, Options   ***
    !
    Include 'inc/parameters/parametersCommandToStart.inc'
    !
    !! Call SIC_LOWER(commandToStart)
    !
    Call pakoUmatchKey (                                                         &
         &              keys=OMChoicesPako,                                      &
         &              key=commandToStart,                                      &
         &              command='START',                                         &
         &              howto='Start Upper',                                     &
         &              iMatch=iMatch,                                           &
         &              nMatch=nMatch,                                           &
         &              error=errorC,                                            &
         &              errorCode=errorCode                                      &
         &             )                                                         !
    !
    If (.Not. errorC) Then
       commandToStart = OMChoicesPako(iMatch)
    End If
    !
    !D     Write (6,*) '      commandToStart:         ',  commandToStart   , '<'
    !D     Write (6,*) "      gv%observingMode:       ",  gv%observingMode    
    !D     Write (6,*) "      gv%observingModePako:   ",  gv%observingModePako
    !
    If ( .Not. commandToStart.Eq.gv%observingModePako ) Then
       errorL = .True.
       messageText =                                                             &
            &        "can not start "//commandToStart                            !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &   "use START [ "//gv%observingModePako//" ]"                       !
       Call pakoMessage(priorityI,severityI,command,messageText)
    End If
    !
    ERROR = ERROR .Or. errorC .Or. errorL
    !
    If (ERROR) Then
       messageText =                                                             &
            &        "NO OBSERVATIONS STARTED"                                   !
       Call pakoMessage(priorityE,severityE,command,messageText)
       RETURN                                                                    !  !!  ERROR --> do not START 
    End If
    !
    baseFileName = commandToStart(1:lenc(commandToStart))
    Call sic_lower(baseFileName)
    !
    startFile    = baseFileName(1:lenc(baseFileName))//".xml"
    startFileOLD = startFile(1:lenc(startFile))//"~"
    !
    htmlFile     = baseFileName(1:lenc(baseFileName))//".html"
    htmlFileOLD  = htmlFile(1:lenc(htmlFile))//"~"
    !
    queueFile    = "XML/"//startFile(1:lenc(startFile))
    queueFileOLD = queueFile(1:lenc(queueFile))//"~"
    !
    htmlQFile    = "XML/"//htmlFile(1:lenc(htmlFile))
    htmlQFileOLD = htmlQFile(1:lenc(htmlQFile))//"~"
    !
    !D     Write (6,*) "  startFile    ->", startFile(1:lenc(startFile)),"<-"
    !D     Write (6,*) "  startFileOld ->", startFileOld(1:lenc(startFileOld)),"<-"
    !D     Write (6,*) "  htmlFile     ->", htmlFile(1:lenc(htmlFile)),"<-"
    !D     Write (6,*) "  htmlFileOld  ->", htmlFileOld(1:lenc(htmlFileOld)),"<-"
    !D     Write (6,*) "  queueFile    ->", queueFile(1:lenc(queueFile)),"<-"
    !D     Write (6,*) "  queueFileOld ->", queueFileOld(1:lenc(queueFileOld)),"<-"
    !D     Write (6,*) "  htmlQFile    ->", htmlQFile(1:lenc(htmlQFile)),"<-"
    !D     Write (6,*) "  htmlQFileOld ->", htmlQFileOld(1:lenc(htmlQFileOld)),"<-"
    !
    ier = 0
    !
!!$!!OLD    ier = Rename(startFile, startFileOLD)
!!$!!OLD    If (ier.Eq.0) Then
!!$!!OLD       Write (messageText,*)                                                     &
!!$!!OLD            &           'renamed previous start file: "',                        &
!!$!!OLD            &           startFile(1:lenc(startFile)),                            &
!!$!!OLD            &           '"'
!!$!!OLD       Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD       Write (messageText,*)                                                     &
!!$!!OLD            &           '   to: "',                                              &
!!$!!OLD            &           startFileOLD(1:lenc(startFileOLD)),                      &
!!$!!OLD            &           '"'
!!$!!OLD       Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD    Else
!!$!!OLD       ier = 0
!!$!!OLD    End If
!!$!!OLD    !
    !
    If (GV%privilege.Eq.setPrivilege%VLBI .And.                                  &
         &   GV%sessionMode.Eq.om%vlbi .And. GV%doSubmit ) Then                  !
       !
       !! for VLBI sessions: send "done" for running VLBI scan
       shellCommand =                                                            &
            &  'ncsMessageSend.py sync operator:scan:done > /dev/null  2>&1 '    !  ! to work
!!OLD       &  'ncsMessageSend.py sync     test:scan:done > /dev/null  2>&1 '    !  ! for tests
       ier = system(shellCommand)                                                
       If (ier.Eq.0) Then
          Write (messageText,*)                                                  &
               &           'any running VLBI scan will be stopped.'              !
          Call pakoMessage(priorityW,severityW,command,messageText)
       Else
          Write (messageText,*)                                                  &
               &           'ERROR', ier,                                         &
               &           '  shellCommand: ', shellCommand                      !
          Call pakoMessage(priorityE,severityE,command,messageText)
       End If
       !
    End If
    !
    iunit =  ioUnit%start
    !
    !D     Write (6,*) "         unit: iunit = ", iunit
    !
    ! !!  unix convention ier.Eq.0 --> OK !!
    If (ier.Eq.0) Then  !!  If OK ...
       !
       Open (unit=iUnit,file=startFile,recl=512,status='unknown')
       !
       ! *** call the requested start method:   ***
       !
       If (.False.) Then
       Else If (commandToStart .Eq. OMpako%Cal) Then
          Call startCalibrate(programName,LINE,commandToStart,                   &
               &            iUnit, errorL)                                       !
       Else If (commandToStart .Eq. OMpako%Focus) Then
          Call startFocus(programName,LINE,commandToStart,                       &
               &            iUnit, errorL)                                       !
          !
!!$!!OLD       Else If (commandToStart .Eq. 'OTFCIRCLE') Then
!!$!!OLD          Call startOtfCircle(programName,LINE,commandToStart,                &
!!$!!OLD               &            iUnit, errorL)
!!$!!OLD       Else If (commandToStart .Eq. 'OTFLINEAR') Then
!!$!!OLD          Call startOtfLinear(programName,LINE,commandToStart,                &
!!$!!OLD               &            iUnit, errorL)
          !
       Else If (commandToStart .Eq. OMpako%LISSAJOUS) Then
          Call startLISSAJOUS(programName,LINE,commandToStart,                   &
               &             iUnit, errorL)                                      !
       Else If (commandToStart .Eq. OMpako%otfmap) Then
          Call startOtfMap(programName,LINE,commandToStart,                      &
               &             iUnit, errorL)                                      !
       Else If (commandToStart .Eq. OMpako%onoff) Then
          Call startOnOff(programName,LINE,commandToStart,                       &
               &           iUnit, errorL)
       Else If (commandToStart .Eq. OMpako%Pointing) Then
          Call startPointing(programName,LINE,commandToStart,                    &
               &           iUnit, errorL)                                        !
          !
!!$!!TBD       Else If (commandToStart .Eq. 'SEGMENT') Then
!!$!!TBD          Write (messageText,*)'START SEGMENT is not possible'
!!$!!TBD          Call pakoMessage(priorityW,severityW,command,messageText)
!!$!!TBD          Write (messageText,*)'try: START subscanList'
!!$!!TBD          Call pakoMessage(priorityI,severityI,command,messageText)
!!$!!TBD          errorL = .True.
          !
       Else If (commandToStart .Eq. OM%DIY) Then
          !D           Write (6,*) " --> modulePakoStart: Calling startDIYlist"
          Call startDIYlist(programName,LINE,commandToStart,iUnit, errorL)                              
       Else If (commandToStart .Eq. OM%subscanList) Then
          !D           Write (6,*) " --> modulePakoStart: Calling startSubscanList"
          Call startSubscanList(programName,LINE,commandToStart,iUnit, errorL)                              
       Else If (commandToStart .Eq. OMpako%tip) Then
          Call startTip(programName,LINE,commandToStart,                         &
               &             iUnit, errorL)                                      !
       Else If (commandToStart .Eq. OMpako%track) Then
          Call startTrack(programName,LINE,commandToStart,                       &
               &             iUnit, errorL)                                      !
       Else If (commandToStart .Eq. OMpako%vlbi ) Then
          If (GV%privilege.Eq.setPrivilege%VLBI ) Then
             Call startVlbi(programName,LINE,commandToStart,iUnit, errorL)         
          Else
             errorL = .True.
             messageText =                                                       &
                  &   " NOT privileged to start and submit VLBI"                 !
             Call pakoMessage(priorityE,severityE,command,messageText)
          End If
       Else
          errorL = .True.
          errorS = .True. 
       End If
       !
       Close(unit=iunit)
       !
    Else
       errorL = .True.
    End If
    !
    ERROR = ERROR .Or. errorL
    !
    ! *** Enforce rules about command interaction:
    !
    ! **  Source must be specified 
    !
    If     (.Not. GV%sourceSet) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify SOURCE "                                  !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  At least one receiver must be specified 
    !
    If     (.Not. GV%receiverSet) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify at least 1 RECEIVER "                     !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  
    !
    Call queryReceiver(RxHolography, receiverIsHolo)
    Call queryReceiver(rec%bolo, isConnected)
    If     (GV%observingModePako.Ne.OMpako%VLBI                                  &
         &        .And. .Not.receiverIsHolo                                      &
         &        .And. .Not.isConnected ) Then                                  !                                                                   
       ! **  At least one backend must be specified 
       !
       If (.Not. GV%backendSet) Then
          messageText =                                                          &
               &           " CAN NOT start and submit "//commandToStart          !
          Call pakoMessage(priorityE,severityE,command,messageText)
          messageText =                                                          &
               &           " at least 1 BACKEND must be connected "              !
          Call pakoMessage(priorityE,severityE,command,messageText)
          ERROR = .True.
       End If
    End If
    !
!!$!!OLD    Call queryReceiver(rec%bolo, isConnected)
!!$!!OLD    If     (GV%observingModePako.Ne.OMpako%VLBI .And. .Not.isConnected ) Then
!!$!!OLD       ! **  At least one backend must be specified 
!!$!!OLD       !
!!$!!OLD       If (.Not. GV%backendSet) Then
!!$!!OLD          messageText =                                                          &
!!$!!OLD               &           " CAN NOT start and submit "//commandToStart          !
!!$!!OLD          Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD          messageText =                                                          &
!!$!!OLD               &           " at least 1 BACKEND must be connected "              !
!!$!!OLD          Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD          ERROR = .True.
!!$!!OLD       End If
!!$!!OLD    End If
    !
    ! **  Backends must be specified after Receivers
    !
    If     (GV%notReadyRXafterBE) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify BACKENDs after RECEIVERs "                !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  OM Tip must be specified after Receivers
    !
    If     ( GV%observingMode.Eq.OM%tip .And. GV%notReadyRXafterTip ) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify observing mode TIP after RECEIVERs "      !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  2ndary Rotation must be specified after Receivers
    !
    If     ( GV%secondaryRotation.Ne.0.0 .And. GV%notReadyRXafterSecondary ) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify SET 2ndRotation after RECEIVERs "         !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  observing mode must be specified after 2ndary Rotation
    !
    If     ( GV%notReadySecondaryRafterOM ) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify observing mode "//commandToStart//        &
            &           " after SET 2ndRotation "                                !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  observing mode must be specified after switching mode:
    !
    If     ( GV%notReadySWafterOM .And.(      commandToStart.Eq.OMpako%Focus     &
         &                               .Or. commandToStart.Eq.OMpako%OnOff     &
         &                               .Or. commandToStart.Eq.OMpako%OtfMap    &
         &                               .Or. commandToStart.Eq.OMpako%Pointing  &
         &                               .Or. commandToStart.Eq.OMpako%Track  )  &
         & )    Then                                                             !
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " MUST specify observing mode "//commandToStart//        &
            &           " after switching mode "                                 !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  observing mode must be specified after OFFSETS:
    !
    If (GV%notReadyOffsetsAfterOnOff .And. commandToStart.Eq.OMpako%OnOff) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " Observing mode "//commandToStart//                     &
            &           " has to be specified AFTER OFFSETS"                     !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  OFFSETS /System Nasmyth and RX Array offsets must be consistent
    !
    If (GV%notReadyReceiverOffsets) Then
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText = "OFFSETS /SYSTEM Nasmyth and "//                            &
            &        "RX Array offsets are inconsistent"                         !
       Call pakoMessage(priorityE,severityE,command,messageText)
       ERROR = .True.
    End If
    !
    ! **  other conditions:
    !
    If     (commandToStart .Ne. GV%observingModePako .And.                       & 
         &    ( GV%notReadyFocus    .And. commandToStart.Eq.OMpako%Focus         &
         & .Or. GV%notReadyOnOff    .And. commandToStart.Eq.OMpako%OnOff         &
         & .Or. GV%notReadyOtfMap   .And. commandToStart.Eq.OMpako%OtfMap        &
         & .Or. GV%notReadyPointing .And. commandToStart.Eq.OMpako%Pointing      &
         & .Or. GV%notReadyTrack    .And. commandToStart.Eq.OMpako%Track         &
         &    )                                                                  &
         & )    Then                                                             !
       messageText =                                                             &
            &           " CAN NOT start and submit "//commandToStart             !
       Call pakoMessage(priorityE,severityE,command,messageText)
       messageText =                                                             &
            &           " CHECK switching and observing modes "                  !
       Call pakoMessage(priorityI,severityI,command,messageText)
       ERROR = .True.
    End If
    !
!!$!!OLD    ! **  other and more specific rules: (de-activated 2006-10-16)
!!$!!OLD    !
!!$!!OLD    If     (GV%switchingMode.Eq.swMode%Freq .And.                                &
!!$!!OLD         &    ( GV%notReadyOtfMap   .And. commandToStart.Eq.OMpako%OtfMap )      &
!!$!!OLD         & )    Then
!!$!!OLD       messageText =                                                             &
!!$!!OLD            &           " CAN NOT start and submit "//commandToStart
!!$!!OLD       Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       messageText =                                                             &
!!$!!OLD            &           " Observing mode "//commandToStart//                     &
!!$!!OLD            &           " has to be specified AFTER SWFREQUENCY "
!!$!!OLD       Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       ERROR = .True.
!!$!!OLD    End If
!!$!!OLD    !
!!$!!OLD    If     (GV%switchingMode.Eq.swMode%Wobb .And.                                &
!!$!!OLD         &    ( GV%notReadyFocus    .And. commandToStart.Eq.OMpako%Focus         &
!!$!!OLD         & .Or. GV%notReadyPointing .And. commandToStart.Eq.OMpako%Pointing      &
!!$!!OLD         & .Or. GV%notReadyOnOff    .And. commandToStart.Eq.OMpako%OnOff         &
!!$!!OLD         & .Or. GV%notReadyOtfMap   .And. commandToStart.Eq.OMpako%OtfMap )      &
!!$!!OLD         & )    Then
!!$!!OLD       messageText =                                                             &
!!$!!OLD            &           " CAN NOT start and submit "//commandToStart
!!$!!OLD       Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       messageText =                                                             &
!!$!!OLD            &           " Observing mode "//commandToStart//                     &
!!$!!OLD            &           " has to be specified AFTER SWWOBBLER"
!!$!!OLD       Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       ERROR = .True.
!!$!!OLD    End If
    !
    !D     Write (6,*) "      ERROR:   ", ERROR
    !
    If (.Not. ERROR) Then
       !     
       messageText =                                                             &
            &           " OK. wrote "//                                          &
            &           commandToStart(1:lenc(commandToStart))//                 &
            &           " to file "//startFile(1:lenc(startFile))                !
       Call pakoMessage(priorityIlocal,severityI,command,messageText)
       !
       ier = Rename(queueFile, queueFileOLD)
       If (ier.Eq.0) Then
          Write (messageText,*)                                                  &
               &           'renamed previous queue file: "',                     &
               &           queueFile(1:lenc(queueFile)),                         &
               &           '"'                                                   !
          !D      Call pakoMessage(priorityIlocal,severityI,command,messageText)
          Write (messageText,*)                                                  &
               &           '   to: "',                                           &
               &           queueFileOLD(1:lenc(queueFileOLD)),                   &
               &           '"'                                                   !
          !D      Call pakoMessage(priorityIlocal,severityI,command,messageText)
       End If
       !
!!$!!OLD       ier = Rename(htmlFile, htmlFileOLD)
!!$!!OLD       If (ier.Eq.0) Then
!!$!!OLD          Write (messageText,*)                                                    &
!!$!!OLD               &           'renamed previous html file: "',                        &
!!$!!OLD               &           htmlFile(1:lenc(htmlFile)),                             &
!!$!!OLD               &           '"'
!!$!!OLD          Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD          Write (messageText,*)                                                    &
!!$!!OLD               &           '   to: "',                                             &
!!$!!OLD               &           htmlFileOLD(1:lenc(htmlFileOLD)),                       &
!!$!!OLD               &           '"'
!!$!!OLD          Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD       End If
!!$!!OLD       !
       !!
       !!
       !!  *** SUBMIT to Observing Queue
       !!
       shellCommand = "submitObservingBlock "//startFile(1:lenc(startFile))      &
            &       //" 2>/dev/null"                                             !
       shellCommand = "submitObservingBlock "//startFile(1:lenc(startFile))      &
            &       //" > .submitResult"                                         !
       ier =  0                                                                  !   0 to run
       !ier = -1                                                                 !  -1 to test
       !
       If (ier.Eq.0 .And. GV%doSubmit) Then
          !
          ier = system(shellCommand)
          !D          Write (6,*) "   after System(shellCommand): iostat=ier: ", ier
          !
!!OLD       Write (6,*) "   cat .submitResult:   "
!!OLD       shellCommand2 = "cat .submitResult"    
!!OLD       ier2 = system(shellCommand2)
          !
          iUnit2 = ioUnit%Read
          !
          If (ier.Eq.0) Then
             Open (unit=iUnit2,file=".submitResult",status='unknown',iostat=ier)
             !D             Write (6,*) "   after Open: iostat=ier: ", ier
          End If
          !
          If (ier.Eq.0) Then       
             Read (iUnit2,*,iostat=ier)  Job
             !D             Write (6,*) "   after Read: iostat=ier: ", ier
          End If
          !
          Close (unit=iUnit2)
          !
          If (ier.Eq.0) Then
             Write (messageText,*)                                               &
                  & ' Observation submitted to observing queue with job number ',&
                  & Job                                                          !
             Call pakoMessage(priorityI,severityI,command,messageText)
          End If
          !
          If (ier.Ne.0) Then
             Error = .True.
             Write (messageText,*)                                               &
                  &           'ERROR', ier,                                      &
                  &           " Couldn't submit observation to Queue "           !
             Call pakoMessage(priorityE,severityE,command,messageText)
          End If
          !
       End If
       !
       If (.Not.GV%doSubmit) Then
          Write (messageText,*)                                                  &
               & 'doSubmit to observation queue is NO / .False.'                 !
          Call pakoMessage(priorityW,severityW,command,messageText)
          Write (messageText,*)                                                  &
               & 'Observation would be submitted to queue with command:'         !
          Call pakoMessage(priorityI,severityI,command,messageText)
          Call pakoMessage(priorityI,severityI,command,shellcommand)
       End If
       !
       !!  *** MOVE to XML directory
       !!
       !! TBD: shellCommand = 'mv '//                                            &
       shellCommand = 'cp '//                                                    &
            &        startFile(1:lenc(startFile))//                              &
            &        ' '//                                                       &
            &        queueFile(1:lenc(queueFile))                                !
       ier = system(shellCommand)
       If (ier.Eq.0) Then
          Write (messageText,*)                                                  &
               &           'saved start file: "',                                &
               &           startFile(1:lenc(startFile)),                         &
               &           '"'                                                   !
          !D          Call pakoMessage(priorityI,severityI,command,messageText)
       Else
          Write (messageText,*)                                                  &
               &           'ERROR', ier,                                         &
               &           ' on save of start file: "',                          &
               &           startFile(1:lenc(startFile))                          !
          !D          Call pakoMessage(priorityE,severityE,command,messageText)
       End If
       Write (messageText,*)                                                     &
            &        '   in directory: "',                                       &
            &        queueFile(1:lenc(queueFile)),                               &
            &        '"'                                                         !
       !D       Call pakoMessage(priorityI,severityI,command,messageText)
       !
       !!
!!$!!OLD       shellCommand = 'obsXMLtoHTML.py < '//                                    &
!!$!!OLD            &        startFile(1:lenc(startFile))//                             &
!!$!!OLD            &        ' > '//                                                    &
!!$!!OLD            &        htmlFile(1:lenc(htmlFile))
!!$!!OLD       ier = 1
!!$!!OLD       ier = system(shellCommand)
!!$!!OLD       If (ier.Eq.0) Then
!!$!!OLD          Write (messageText,*)                                                 &
!!$!!OLD               &           'transformed XML file: "',                           &
!!$!!OLD               &           startFile(1:lenc(startFile)),                        &
!!$!!OLD               &           '"'
!!$!!OLD          Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD       Else
!!$!!OLD          Write (messageText,*)                                                 &
!!$!!OLD               &           'ERROR', ier,                                        &
!!$!!OLD               &           ' on transform of XML file: "',                      &
!!$!!OLD               &           startFile(1:lenc(startFile))
!!$!!OLD          Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       End If
!!$!!OLD       Write (messageText,*)                                                    &
!!$!!OLD            &        '   to HTML file: "',                                      &
!!$!!OLD            &        htmlFile(1:lenc(htmlFile)),                                &
!!$!!OLD            &        '"'
!!$!!OLD       Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD       !
!!$!!OLD       shellCommand = 'cp '//                                                   &
!!$!!OLD            &        htmlFile(1:lenc(htmlFile))//                               &
!!$!!OLD            &        ' '//                                                      &
!!$!!OLD            &        htmlQFile(1:lenc(htmlQFile))
!!$!!OLD       ier = system(shellCommand)
!!$!!OLD       If (ier.Eq.0) Then
!!$!!OLD          Write (messageText,*)                                                 &
!!$!!OLD               &           'copied html file: "',                               &
!!$!!OLD               &           htmlFile(1:lenc(htmlFile)),                          &
!!$!!OLD               &           '"'
!!$!!OLD          Call pakoMessage(priorityIlocal,severityI,command,messageText)
!!$!!OLD       Else
!!$!!OLD          Write (messageText,*)                                                 &
!!$!!OLD               &           'ERROR', ier,                                        &
!!$!!OLD               &           ' on copy of html file: "',                          &
!!$!!OLD               &           htmlFile(1:lenc(htmlFile))
!!$!!OLD          Call pakoMessage(priorityE,severityE,command,messageText)
!!$!!OLD       End If
!!$!!OLD       Write (messageText,*)                                                    &
!!$!!OLD            &        '   to: "',                                                &
!!$!!OLD            &        htmlQFile(1:lenc(htmlQFile)),                              &
!!$!!OLD            &        '"'
!!$!!OLD       Call pakoMessage(priorityIlocal,severityI,command,messageText)
       !
    Else If (errorS) Then
       !     
       messageText =                                                             &
            &          programName(1:lenc(programName))//                        &
            &        " does not know (yet) how to  start "//                     &
            &          commandToStart(1:lenc(commandToStart))
       Call pakoMessage(priorityE,severityE,command,messageText)
       !
    Else If (ERROR) Then
       !     
       messageText =                                                             &
            &          programName(1:lenc(programName))//                        &
            &        " could not start "//                                       &
            &          commandToStart(1:lenc(commandToStart))//                  &
            &        " to file "//startFile(1:lenc(startFile))
       Call pakoMessage(priorityE,severityE,command,messageText)
       !
    End If   !!   If (.Not. ERROR) Then
    !
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Start, <--- SR: Start ")                                    ! this allows to trace execution
    !
    Return
    !
  End Subroutine pakoStart
!!!
!!!
End Module modulePakoStart

module cubedag_undo
  use cubetools_structure
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_dag_buffer
  use cubedag_history_buffer
  !
  public :: undo
  private
  !
  type :: undo_comm_t
    type(option_t), pointer :: comm
  contains
    procedure, public  :: register => cubedag_undo_register
    procedure, private :: parse    => cubedag_undo_parse
    procedure, private :: main     => cubedag_undo_main
  end type undo_comm_t
  type(undo_comm_t) :: undo
  !
  type undo_user_t
    integer(kind=iden_l) :: firstid
    integer(kind=iden_l) :: lastid
  contains
    procedure, private :: toprog => cubedag_undo_user_toprog
  end type undo_user_t
  !
  type undo_prog_t
    integer(kind=iden_l) :: firstid
    integer(kind=iden_l) :: lastid
  contains
    procedure, public :: do => cubedag_undo_do
  end type undo_prog_t
  !
contains
  !
  subroutine cubedag_undo_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command UNDO
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(undo_user_t) :: user
    character(len=*), parameter :: rname='UNDO>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call undo%parse(line,user,error)
    if (error) return
    call undo%main(user,error)
    if (error) return
  end subroutine cubedag_undo_command
  !
  !---------------------------------------------------------------------
  !
  subroutine cubedag_undo_register(undo,error)
    !-------------------------------------------------------------------
    ! Register ADM\UNDO command and its options
    !-------------------------------------------------------------------
    class(undo_comm_t), intent(inout) :: undo
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='UNDO>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    ! Command
    call cubetools_register_command(&
         'UNDO','[FirstCommandID] [LastCommandID]',&
         'Undo a command and remove it from history',&
         'Without argument, undo the last command (i.e. remove the command &
         &from the history and delete the products which were created).'&
         //strg_bl//&
         'With a positive identifier as argument, undo the command &
         &according to its ID. With a range of identifiers as arguments, &
         &undo the commands from last to first.'&
         //strg_bl//&
         'With a negative position as argument, undo the command &
         &according to its position from the end (0=last, -1=before last, &
         &etc).'&
         //strg_bl//&
         'Examples:'&
         //strg_cr//&
         '  CUBE> UNDO      ! Undo last command in HISTORY'&
         //strg_cr//&
         '  CUBE> UNDO 10   ! Undo command #10 in HISTORY'&
         //strg_cr//&
         '  CUBE> UNDO 7 10 ! Undo commands #10 #9 #8 #7 in HISTORY'&
         //strg_cr//&
         '  CUBE> UNDO 0    ! Undo last command in HISTORY'&
         //strg_cr//&
         '  CUBE> UNDO -1   ! Undo before last command in HISTORY'&
         //strg_bl//&
         'It is not possible to undo a command whose output products &
         &where used as inputs to other commands.',&
         cubedag_undo_command,&
         undo%comm,error)
    if (error) return
    call stdarg%register( &
         'COMMAND', &
         '[FirstCommandID]',  &
         strg_emp,&
         code_arg_optional, &
         error)
    if (error) return
    call stdarg%register( &
         'COMMAND', &
         '[LastCommandID]',  &
         strg_emp,&
         code_arg_optional, &
         error)
    if (error) return
    !
  end subroutine cubedag_undo_register
  !
  subroutine cubedag_undo_parse(undo,line,user,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   UNDO
    !-------------------------------------------------------------------
    class(undo_comm_t), intent(inout) :: undo
    character(len=*),   intent(in)    :: line
    type(undo_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNDO>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    user%firstid = 0  ! 0=last (same as CubeID)
    call cubetools_getarg(line,undo%comm,1,user%firstid,.not.mandatory,error)
    if (error) return
    !
    user%lastid = user%firstid  ! Default is no range
    call cubetools_getarg(line,undo%comm,2,user%lastid,.not.mandatory,error)
    if (error) return
  end subroutine cubedag_undo_parse
  !
  subroutine cubedag_undo_main(undo,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(undo_comm_t), intent(in)    :: undo
    type(undo_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(undo_prog_t) :: prog
    character(len=*), parameter :: rname='UNDO>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubedag_undo_main
  !
  subroutine cubedag_undo_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(undo_user_t), intent(in)    :: user
    type(undo_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='UNDO>USER2PROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    ! Convert id's to their actual values (in particular negative
    ! ones, i.e. counted from the end)
    prog%firstid = cubedag_history_entrynum_hx(user%firstid,error)
    if (error)  return
    prog%lastid  = cubedag_history_entrynum_hx(user%lastid,error)
    if (error)  return
  end subroutine cubedag_undo_user_toprog
  !
  subroutine cubedag_undo_do(prog,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(undo_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    integer(kind=iden_l) :: iid
    !
    ! Only valid with >0 id's
    do iid=prog%lastid,prog%firstid,-1
      call cubedag_history_removecommand(iid,error)
      if (error) return
    enddo
    call cubedag_dag_updatecounter(error)
    if (error) return
  end subroutine cubedag_undo_do
end module cubedag_undo

!-----------------------------------------------------------------------
! The following transposition engine is based on the idea that many
! transpositions can be re-written as permutation of the 2nd and 4th
! dimensions of a 5D array. The most "difficult" part is to find how
! to remap the input array on such a 5D array, by repacking contiguous
! dimensions and inserting others which are degenerated.
!
! Examples:
! - 21:       a(n1,n2) <= b(1, n1, 1, n2, 1)
!             tr(a) = tr(b) = c(1,n2,1,n1,1)
! - 321:      a(n1,n2,n3) <= b(1, n1, n2, n3, 1)
!             tr(a) = tr(b) = c(1,n3,n2,n1,1)
! - 312:      a(n1,n2,n3) <= b(1, n1*n2, 1, n3, 1)
!             tr(a) = tr(b) = c(1,n3,1,n1*n2,1)
! - 1567423:  a(n1,n2,n3,n4,n5,n6,n7) <= b(n1, n2*n3, n4, n5*n6*n7, 1)
!             tr(a) = tr(b) = c(n1,n5*n6*n7,n4,n2*n3,1)
!
! Pros:
!  - since we always swap the 2nd and 4th dimension of the 5D array,
!    there is no need of a permutation array in the transposition loop.
!  - up to now all the transpositions needed in the Gildas context are
!    supported in a single pass.
!  - such an approach allows the calling programs to loop on the 5th
!    dimension of the 5D array, i.e. allocate only a working buffer
!    of dimensions m1*m2*m3*m4. This is particularly useful when
!    transposing disk images.
! Cons:
!  - all the transpositions are not supported. Some of them imply
!    executing several times the 5D transposition loop to achieve a
!    goal. If the problem fits in memory, a general (7D) transposition
!    loop with a permutation array should be prefered since the result
!    is achieved in a single pass.
!-----------------------------------------------------------------------
module gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  No need to share the code 'tr_maxdims': the transposition engine
  ! is able to deal with a number of dimensions lower or equal, or
  ! to complain for larger numbers.
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: tr_maxdims=7
end module gmath_transpose
!
subroutine transpose_getcode(strin,strout,code,error)
  use gmath_interfaces, except_this=>transpose_getcode
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Convert a dimension string into a transposition code, e.g.
  !   'VLM' transposed to 'LMV'  <=>  transposition code '231'
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: strin   !
  character(len=*), intent(in)    :: strout  !
  character(len=*), intent(out)   :: code    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: ni,no,nc,i
  character(len=tr_maxdims) :: in,out
  !
  ni = len_trim(strin)
  no = len_trim(strout)
  nc = len(code)
  !
  ! Sanity check
  if (ni.ne.no)  goto 100
  if (no.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Transposition supported up to 7 dimensions')
    goto 100
  endif
  if (no.gt.nc) then
    call gmath_message(seve%e,rname,'Programming error, string for code too short')
    goto 100
  endif
  !
  ! Case-insensitive work
  in = strin
  call sic_upper(in)
  out = strout
  call sic_upper(out)
  !
  code = ''
  do i=1,no
    code(i:i) = char(ichar('0')+index(in,out(i:i)))
  enddo
  !
  call transpose_check(code,error)
  if (error)  goto 100
  return
  !
  ! Error
100 continue
  call gmath_message(seve%e,rname,  &
    'Could not transpose '//trim(strin)//' to '//strout)
  error = .true.
  return
  !
end subroutine transpose_getcode
!
subroutine transpose_getorder(code,itr,mdims,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>transpose_getorder
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  ! Decode transposition code into an index of axis orders
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code        ! Transposition code
  integer(kind=4),  intent(in)    :: mdims       ! Maximum number of dimensions
  integer(kind=4),  intent(out)   :: itr(mdims)  ! Transposition index array
  logical,          intent(inout) :: error       ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: n
  !
  if (mdims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  call transpose_check(code,error)
  if (error)  return
  !
  ! Find transposition code
  itr(:) = 0
  read (code,'(7I1)',iostat=n) itr(1:len_trim(code))
  if (n.ne.0) then
    call gmath_message(seve%e,rname,'Invalid transposition '//code)
    call putios('E-TRANSPOSE,  ',n)
    error = .true.
    return
  endif
  !
end subroutine transpose_getorder
!
subroutine transpose_check(code,error)
  use gmath_interfaces, except_this=>transpose_check
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  ! Check that the input code is correct, i.e. check:
  !  - code too large (unsupported number of dimensions)
  !  - illegal characters (e.g. letters)
  !  - correct numbering (each dimension must be present once and only
  !    once)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: nc,ic,p1,p2
  !
  nc = len_trim(code)
  if (nc.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Too many dimensions in transposition code '//code)
    error = .true.
    return
  endif
  !
  p1 = 1
  p2 = 1
  do ic=1,nc
    p1 = p1*ic
    p2 = p2*index(code,char(ic+ichar('0')))
  enddo
  !
  if (p1.ne.p2) then
    call gmath_message(seve%e,rname,'Invalid transposition code '//code)
    error = .true.
    return
  endif
  !
end subroutine transpose_check
!
subroutine transpose_getblock(idim,ndims,code,block,error)
  use gildas_def
  use gmath_interfaces, except_this=>transpose_getblock
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Repack the transposition order into a general case of the following form:
  !      unchanged, swap1,  unchanged, swap2,   unchanged
  !      Nelems,    Nfirst, Nmiddle,   Nsecond, Nlast
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndims        ! Effective or maximum number of dimensions
  integer(kind=index_length), intent(in)    :: idim(ndims)  ! Array dimensions
  character(len=*),           intent(in)    :: code         ! Transposition code
  integer(kind=index_length), intent(out)   :: block(5)     ! Resulting transposition pack
  logical,                    intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: repack(5),id,fd
  integer(kind=index_length) :: dims(tr_maxdims)
  integer(kind=index_length) :: nelems,nfirst,nmiddle,nsecon,nlast
  character(len=tr_maxdims) :: start,goal
  !
  if (ndims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  do id=1,ndims
    dims(id) = max(1,idim(id))
  enddo
  do id = ndims+1,tr_maxdims
    dims(id) = 1
  enddo
  !
  start = '1234567'
  goal  = start
  goal(1:len_trim(code)) = trim(code)
  if (start.eq.goal) then
    ! The subsequent optimizations will only perform a r4tor4
    call gmath_message(seve%w,rname,'No transposition here: '//code)
  endif
  !
  call transpose_repack(start,goal,repack)
  !
  if (start.ne.goal) then
    ! 'start' has been updated on return but does not yet match the goal
    ! Several permutations are not yet implemented
    call gmath_message(seve%e,rname,  &
      'Not implemented: more than 1 permutation needed for '//code)
    call transpose_guess(code)
    error = .true.
    return
  endif
  !
  nelems = 1
  fd = 1
  do id=fd,fd+repack(1)-1
    nelems = nelems*dims(id)
  enddo
  !
  nfirst = 1
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    nfirst = nfirst*dims(id)
  enddo
  !
  nmiddle = 1
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    nmiddle = nmiddle*dims(id)
  enddo
  !
  nsecon = 1
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    nsecon = nsecon*dims(id)
  enddo
  !
  nlast = 1
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    nlast = nlast*dims(id)
  enddo
  !
  block(1) = nelems
  block(2) = nfirst
  block(3) = nmiddle
  block(4) = nsecon
  block(5) = nlast
  !
end subroutine transpose_getblock
!
subroutine transpose_repack(start,goal,repack)
  use gmath_interfaces, except_this=>transpose_repack
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !   Compute the repack array for the 'goal' starting from 'start'
  !   Note that there is no assumption on the order of the start code
  ! (in particular you can not assume it is '1234567'). This is a
  ! desired feature to call consecutively this subroutine to achieve the
  ! goal in several steps.
  !   Note also that there no assumption on the characters it contains,
  ! e.g. if you plan to modify this code, think on what should be done
  ! if start='baefdcg' and goal='bedgafc'
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: start      ! Updated on return
  character(len=*), intent(in)    :: goal       !
  integer(kind=4),  intent(out)   :: repack(5)  ! How the dimensions should be packed
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  integer(kind=4) :: poss,posg,l1,l2
  character(len=message_length) :: mess
  !
  ! If no permutation, repack everything in the 1st (unchanged) group
  repack(:) = (/ tr_maxdims,0,0,0,0 /)
  !
  ! Find where the difference starts
  do posg=1,tr_maxdims
    if (goal(posg:posg).ne.start(posg:posg))  exit
  enddo
  if (posg.ge.tr_maxdims)  return  ! start == goal, nothing to do
  !
  ! Find the pattern to swap (swap2), its length, and its position in 'start'
  swap2 = goal(posg:)
  do
    l2 = len_trim(swap2)
    poss = index(start,swap2(1:l2))
    if (poss.ne.0)  exit
    swap2(l2:l2) = ' '
  enddo
  !
  ! Find swap1 and middle
  swap1  = start(posg:poss-1)  ! This is swap1+middle: we have to separate them cleverly...
  middle = ''
  do
    l1 = len_trim(swap1)
    if (index(goal(posg+l2:),swap1(1:l1)).ne.0)  exit
    middle = swap1(l1:l1)//middle
    swap1(l1:l1) = ' '
  enddo
  !
  ! And finally find the boundaries
  before = start(1:posg-1)
  after  = start(poss+l2:)
  !
  write(mess,100)  &
    trim(before),trim(swap1),trim(middle),trim(swap2),trim(after),  &
    ' -> ',                                                         &
    trim(before),trim(swap2),trim(middle),trim(swap1),trim(after)
  call gmath_message(seve%d,rname,mess)
  !
  start = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
  ! Set the repack array
  repack(1) = len_trim(before)
  repack(2) = len_trim(swap1)
  repack(3) = len_trim(middle)
  repack(4) = len_trim(swap2)
  repack(5) = len_trim(after)
  ! write(*,'(5(I2))')  repack(:)
  !
100 format( 2 ('(',A,')', '[',A,']', '(',A,')', '[',A,']', '(',A,')', A))
end subroutine transpose_repack
!
subroutine transpose_guess(code)
  use gmath_interfaces, except_this=>transpose_guess
  use gmath_messaging
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Give users the serie of permutations needed to achieve the goal.
  ! Note that each user permutation must be given from '1234567' to
  ! 'intermediate-goal', e.g. 2143 = 2134 + 1243
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: code
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: start,goal,interm
  integer(kind=4) :: nt,nd,repack(5)
  character(len=message_length) :: mess
  !
  nd = len_trim(code)
  start = '1234567'
  goal  = start
  goal(1:nd) = trim(code)
  nt = 0
  !
  call gmath_message(seve%i,rname,'Transpositions needed to achieve '//trim(code)//':')
  do while (start.ne.goal)
    nt = nt+1
    call transpose_repack(start,goal,repack)
    !
    call transposition_repack_to_code(repack,interm)
    write(mess,'(A,I0,A,A)')  '  #',nt,': ',interm(1:nd)
    call gmath_message(seve%r,rname,mess)
  enddo
  !
end subroutine transpose_guess
!
subroutine transposition_repack_to_code(repack,code)
  use gmath_interfaces, except_this=>transposition_repack_to_code
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Generate the transposition code from the repack array
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: repack(5)  !
  character(len=*), intent(out) :: code       !
  ! Local
  integer(kind=4) :: id,fd
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  !
  before = ''
  fd = 1
  do id=fd,fd+repack(1)-1
    before = trim(before)//char(id+ichar('0'))
  enddo
  !
  swap1 = ''
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    swap1 = trim(swap1)//char(id+ichar('0'))
  enddo
  !
  middle = ''
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    middle = trim(middle)//char(id+ichar('0'))
  enddo
  !
  swap2 = ''
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    swap2 = trim(swap2)//char(id+ichar('0'))
  enddo
  !
  after = ''
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    after = trim(after)//char(id+ichar('0'))
  enddo
  !
  code = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
end subroutine transposition_repack_to_code
!
subroutine trans4all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=4),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=4),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans4all
!
subroutine trans4(in,ou,nelems,nx,nm,ny)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems               !
  integer(kind=index_length), intent(in)  :: nx                   !
  integer(kind=index_length), intent(in)  :: nm                   !
  integer(kind=index_length), intent(in)  :: ny                   !
  real(kind=4),               intent(in)  :: in(nelems,nx,nm,ny)  !
  real(kind=4),               intent(out) :: ou(nelems,ny,nm,nx)  !
  ! Local
  integer(kind=index_length) :: i,j,l,m
  !
  do j=1,ny
    do m=1,nm
      do i=1,nx
        do l=1,nelems
          ou(l,j,m,i) = in(l,i,m,j)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4
!
subroutine trans4slice(nelems,nfirst,nmiddl,nsecon,in,kin,lin,ou,kou,lou)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones, for the slices
  ! [kin:lin] in 'nsecon' and [kou:lou] in 'nfirst'.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems                      !
  integer(kind=index_length), intent(in)  :: nfirst                      !
  integer(kind=index_length), intent(in)  :: nmiddl                      !
  integer(kind=index_length), intent(in)  :: nsecon                      !
  integer(kind=index_length), intent(in)  :: kin,lin                     !
  integer(kind=index_length), intent(in)  :: kou,lou                     !
  real(kind=4),               intent(in)  :: in(nelems,nfirst,nmiddl,*)  !
  real(kind=4),               intent(out) :: ou(nelems,nsecon,nmiddl,*)  !
  ! Local
  integer(kind=index_length) :: ibig,jbig,iou,jin,l,m
  !
  do iou=1,lou-kou+1           ! Size of output array
    ibig = iou+kou-1
    do jin=1,lin-kin+1         ! Size of input array
      jbig = jin+kin-1
      do m=1,nmiddl
        do l=1,nelems
          ou(l,jbig,m,iou) = in(l,ibig,m,jin)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4slice
!
subroutine trans8all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 8-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=8),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=8),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans8all

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_parameters
  !--- Type lengths ---------------------------------------------------
  use gildas_def
  use gbl_message
  integer(kind=4), parameter :: inte_k=4            ! [integer] Generic integer*4
  integer(kind=4), parameter :: long_k=8            ! [integer] Generic integer*8
  integer(kind=4), parameter :: argu_k=4            ! [integer] Argument
  integer(kind=4), parameter :: code_k=4            ! [integer] Codes
  integer(kind=4), parameter :: ndim_k=4            ! [integer] Number of dimensions
  integer(kind=4), parameter :: wind_k=4            ! [integer] Number of windows
  integer(kind=4), parameter :: rang_k=4            ! [integer] Number of ranges
  integer(kind=4), parameter :: indx_k=index_length ! [integer] Index (either pixel or channel)
  integer(kind=4), parameter :: entr_k=indx_k       ! [integer] Entry
  integer(kind=4), parameter :: chan_k=indx_k       ! [integer] Channel
  integer(kind=4), parameter :: pixe_k=indx_k       ! [integer] Pixel
  integer(kind=4), parameter :: data_k=size_length  ! [integer] Data
  !
  integer(kind=4), parameter :: real_k=4 ! [real] Generic real*4
  integer(kind=4), parameter :: dble_k=8 ! [real] Generic real*8
  integer(kind=4), parameter :: sign_k=4 ! [real] Signal
  integer(kind=4), parameter :: equi_k=4 ! [real] Equinox
  integer(kind=4), parameter :: beam_k=4 ! [real] Resolution
  integer(kind=4), parameter :: coor_k=8 ! [real] Coordinate
  integer(kind=4), parameter :: tole_k=8 ! [real] Consistency tolerance
  !
  integer(kind=4), parameter :: strg_l=64                 ! [character] For string arrays
  integer(kind=4), parameter :: clin_l=commandline_length ! [character] Command line
  integer(kind=4), parameter :: varn_l=varname_length     ! [character] Variable name
  integer(kind=4), parameter :: mess_l=message_length     ! [character] Message
  integer(kind=4), parameter :: file_l=filename_length    ! [character] Directory or full path to files
  integer(kind=4), parameter :: base_l=128                ! [character] File base name or name+extension (w/o path)
  integer(kind=4), parameter :: exte_l=32                 ! [character] File name extension
  integer(kind=4), parameter :: argu_l=64                 ! [character] Argument
  integer(kind=4), parameter :: unit_l=12                 ! [character] Unit 
  integer(kind=4), parameter :: line_l=12                 ! [character] Line 
  integer(kind=4), parameter :: fram_l=12                 ! [character] Spatial or spectral Frame 
  integer(kind=4), parameter :: sour_l=12                 ! [character] Source
  integer(kind=4), parameter :: tele_l=12                 ! [character] Telescope name
  integer(kind=4), parameter :: sexa_l=12                 ! [character] Sexagesimal length
  integer(kind=4), parameter :: conv_l=12                 ! [character] Convention length
  integer(kind=4), parameter :: tagn_l=12                 ! [character] tagname length
  integer(kind=4), parameter :: name_l=16                 ! [character] array name
  integer(kind=4), parameter :: trop_l=3                  ! [character] Transposition operator
  !
  ! --- unknown -------------------------------------------------------
  character(len=*), parameter :: blankstr = ''
  character(len=*), parameter :: strg_unk = 'Unknown'
  character(len=*), parameter :: strg_emp = 'Empty'
  character(len=1), parameter :: strg_cr = char(10)  ! ASCII carriage return
  character(len=*), parameter :: strg_bl = strg_cr//strg_cr  ! Blank line helper
  integer(kind=code_k),  parameter :: code_unk = 0
  integer(kind=code_k),  parameter :: code_abs = -1
  !
  ! --- Velocity convention ------------------------------------------
  integer(kind=code_k), parameter :: code_rad = 1
  integer(kind=code_k), parameter :: code_opt = 2  
  !
  ! --- Dimensions ----------------------------------------------------
  integer(kind=ndim_k), parameter :: maxdim = 7
  integer(kind=indx_k), parameter :: code_indx_auto = huge(0_indx_k)  ! Flag for uninitialized/automatic index
  !
  ! --- Convert orders ------------------------------------------------
  integer(kind=code_k), parameter :: code_ref = 1
  integer(kind=code_k), parameter :: code_val = 2
  integer(kind=code_k), parameter :: code_inc = 3
  !
  ! --- Axis types -----------------------------------------------------
  integer(kind=code_k), parameter :: code_spa = 1
  integer(kind=code_k), parameter :: code_vel = 2
  integer(kind=code_k), parameter :: code_fre = 3
  !
  ! --- Cube orders (intrinsic data order) -----------------------------
  integer(code_k), parameter :: code_cube_unkset=100   ! Unknown cube set
  integer(code_k), parameter :: code_cube_imaset=101   ! e.g. .lmv
  integer(code_k), parameter :: code_cube_speset=102   ! e.g. .vlm
  integer(code_k), parameter :: code_table_imaset=103  ! e.g. .bat
  integer(code_k), parameter :: code_table_speset=104  ! e.g. .tab
  !
  ! --- Access modes (programmer requested accesses) -------------------
  integer(code_k), parameter :: code_access_imaset=code_cube_imaset
  integer(code_k), parameter :: code_access_speset=code_cube_speset
  integer(code_k), parameter :: code_access_subset=203            ! Sub-cubes (order does not matter)
  integer(code_k), parameter :: code_access_blobset=204           ! Collection of bits (order does not matter)
  integer(code_k), parameter :: code_access_fullset=205           ! Full cubes (order does not matter)
  ! Aliases resolved depending on the cube or user at runtime:
  integer(code_k), parameter :: code_access_imaset_or_speset=206  ! Any of the 2 unambiguous orders (imaset/speset)
  integer(code_k), parameter :: code_access_any=207               ! Any of the 3 basic orders (imaset/speset/unkset)
  integer(code_k), parameter :: code_access_user=208              ! Access resolved from context e.g. user inputs
  !
  ! --- Actions --------------------------------------------------------
  ! Read codes (for old cubes). Order matters.
  integer(code_k), parameter :: code_read_none = 10  ! Nothing needed
  integer(code_k), parameter :: code_read_head = 11  ! Header only
  integer(code_k), parameter :: code_read      = 12  ! Header + data
  integer(code_k), parameter :: code_update    = 13  ! Header + data in read-write
  ! Write codes (for new cubes)
  integer(code_k), parameter :: code_write     = 20  ! Header + data
  !
  ! --- Data buffering -------------------------------------------------
  integer(kind=4), parameter :: mbuffering = 4
  character(len=*), parameter :: buffering(mbuffering) =  &
    (/ 'AUTO  ','NONE  ','MEMORY','DISK  ' /)
  integer(code_k), parameter :: code_buffer_auto   = 1
  integer(code_k), parameter :: code_buffer_none   = 2
  integer(code_k), parameter :: code_buffer_memory = 3
  integer(code_k), parameter :: code_buffer_disk   = 4
  !
  ! --- Patch Bval/Eval to NaN -----------------------------------------
  integer(kind=4), parameter :: mpatchblank=2
  character(len=*), parameter :: patchblank(mpatchblank) =  &
    (/ 'ERROR     ','ONTHEFLY  ' /)
  integer(code_k), parameter :: code_patchblank_err = 1
  integer(code_k), parameter :: code_patchblank_otf = 2
  !
  ! --- Default index --------------------------------------------------
  integer(kind=4), parameter :: mindex=2
  character(len=*), parameter :: indexname(mindex) =  &
    (/ 'DAG    ','CURRENT' /)
  integer(code_k), parameter :: code_index_dag     = 1
  integer(code_k), parameter :: code_index_current = 2
  !
  ! --- Arguments ------------------------------------------------------
  logical, parameter ::   flexible = .true.
  logical, parameter :: inflexible = .false.
  logical, parameter :: mandatory = .true.
  logical, parameter :: optional  = .false.
  integer(kind=code_k), parameter :: code_arg_mandatory = 1  ! Argument must appear 1 time
  integer(kind=code_k), parameter :: code_arg_optional  = 2  ! Argument can appear 0 or 1 time
  integer(kind=code_k), parameter :: code_arg_unlimited = 3  ! Argument can appear 0 or more times
                                               ! We could add: Argument can appear 1 or more times
  character(len=*), parameter :: arg_status(3) =  &
    (/ 'mandatory','optional ','unlimited' /)
  !
  ! --- Flag modes -----------------------------------------------------
  integer(kind=code_k), parameter :: keep_none=1
  integer(kind=code_k), parameter :: keep_prod=2
  integer(kind=code_k), parameter :: keep_acti=3
  integer(kind=code_k), parameter :: keep_all =4
  !
  ! --- Parsing utility ------------------------------------------------
  logical, parameter :: verbose = .true.
  logical, parameter :: quiet = .true.
  logical, parameter :: overwrite = .true.
  logical, parameter :: global = .true.
  logical, parameter :: local = .true.
  logical, parameter :: readonly = .true.
  integer(kind=4), parameter :: icomm = 0
  character(len=*), parameter :: strg_star  = '*'  ! smart choice
  character(len=*), parameter :: strg_equal = '='  ! Keep previous value
  integer(kind=code_k), parameter :: code_unresolved = -1
  character(len=*), parameter :: strg_unresolved = "UNRESOLVED"
  !
  ! --- Help utility ---------------------------------------------------
  character(len=*), parameter :: strg_id  = 'idem'
  integer(kind=4), parameter :: stdout=6
  !
  integer(kind=code_k), parameter :: help_format_term =0
  integer(kind=code_k), parameter :: help_format_tex  =1
  integer(kind=code_k), parameter :: help_format_flags=2
  integer(kind=4),  parameter :: help_nformats=2
  character(len=*), parameter :: help_formats(help_nformats) = (/ 'TEX  ','FLAGS' /)
  character(len=*), parameter :: help_extensions(help_nformats) = (/ '.tex','.flg' /)
  !
contains
  !
  function access_status(iaccess)
    !-------------------------------------------------------------------
    ! Translate an access code to string
    !-------------------------------------------------------------------
    character(len=13) :: access_status
    integer(kind=code_k), intent(in) :: iaccess
    !
    select case (iaccess)
    case (code_access_imaset)
      access_status = 'imaset'
    case (code_access_speset)
      access_status = 'speset'
    case (code_access_subset)
      access_status = 'subset'
    case (code_access_blobset)
      access_status = 'blobset'
    case (code_access_fullset)
      access_status = 'fullset'
    case (code_access_imaset_or_speset)
      access_status = 'imaset/speset'
    case (code_access_any)
      access_status = 'anyset'
    case (code_access_user)
      ! Most likely it will be solved as imaset or speset at runtime
      access_status = 'imaset/speset'
    case default
      access_status = '???'
    end select
  end function access_status
  !
  function action_status(iaction)
    !-------------------------------------------------------------------
    ! Translate an action code to string
    !-------------------------------------------------------------------
    character(len=6) :: action_status
    integer(kind=code_k), intent(in) :: iaction
    !
    select case (iaction)
    case (code_read_none)
      action_status = 'none'
    case (code_read_head)
      action_status = 'header'
    case (code_read)
      action_status = 'read'
    case (code_write)
      action_status = 'write'
    case (code_update)
      action_status = 'update'
    case default
      action_status = '???'
    end select
  end function action_status
  !
  function cube_dev_mode()
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Return .true. if CUBE is dev mode. Dynamic check as this is not a
    ! compilation-time constant.
    !-------------------------------------------------------------------
    logical :: cube_dev_mode
    character(len=12) :: status
    !
    call sic_getenv('GAG_CUBE_DEV',status)
    cube_dev_mode = status.eq."YES" .or. status.eq."yes"
    !
    ! Could also check for a command-line option or a user variable?
  end function cube_dev_mode
end module cubetools_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module classmap_interfaces_private
  interface
    subroutine dosmoo(raw,gwe,nc,nx,ny,map,mapx,mapy,sup,cell)
      !---------------------------------------------------------------------
      ! @ private
      ! Smooth an input data cube in VLM along L and M by convolution
      ! with a gaussian...
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: nc,nx,ny       ! Cube size
      real(kind=4),    intent(in)  :: raw(nc,nx,ny)  ! Raw cube
      real(kind=4),    intent(in)  :: gwe(nx,ny)     ! Gridded weights Not used ???? JP
      real(kind=4),    intent(out) :: map(nc,nx,ny)  ! Smoothed cube
      real(kind=4),    intent(in)  :: mapx(nx)       ! Arrays of gridded coordinates
      real(kind=4),    intent(in)  :: mapy(ny)       ! Arrays of gridded coordinates
      real(kind=4),    intent(in)  :: sup(2)         ! Convolving function support size in user unit
      real(kind=4),    intent(in)  :: cell(2)        ! Pixel size in user unit
    end subroutine dosmoo
  end interface
  !
  interface
    subroutine doapod(xmin,xmax,ymin,ymax,tole,beam, &
         nc,nx,ny,map,raw,mapx,mapy,gweight,wmin)
      !---------------------------------------------------------------------
      ! @ private
      ! Replace the original (RAW) data by an apodized version
      !   - outside of the sampled region (map edges to smoothly go to zero)
      !   - and where the weight is below the minimum value (bad data points)
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)    :: xmin,xmax       ! Boundary of sampled region
      real(kind=4),    intent(in)    :: ymin,ymax       ! Boundary of sampled region
      real(kind=4),    intent(in)    :: tole            ! X-Y position tolerance
      real(kind=4),    intent(in)    :: beam            ! Beam size
      integer(kind=4), intent(in)    :: nc,nx,ny        ! Cube size
      real(kind=4),    intent(in)    :: map(nc,nx,ny)   ! Smoothed cube
      real(kind=4),    intent(inout) :: raw(nc,nx,ny)   ! Original cube
      real(kind=4),    intent(in)    :: mapx(nx)        ! Arrays of gridded coordinates
      real(kind=4),    intent(in)    :: mapy(ny)        ! Arrays of gridded coordinates
      real(kind=4),    intent(in)    :: gweight(nx,ny)  ! Gridded weights
      real(kind=4),    intent(in)    :: wmin            ! Minimum weight
    end subroutine doapod
  end interface
  !
  interface
    function nearest_power_of_two(n)
      !---------------------------------------------------------------------
      ! @ private
      !
      !---------------------------------------------------------------------
      integer(kind=4) :: nearest_power_of_two  ! Function value on return
      integer(kind=4), intent(in) :: n          !
    end function nearest_power_of_two
  end interface
  !
  interface
    subroutine dosdft(hout,beam,diam,f,nx,ny,dx,dy)
      use gildas_def
      use image_def
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      ! Computes Inverse of FT of single-dish beam
      ! (uses a Gaussian truncated at dish size)
      ! Not used in this version, since we have the explicit convolution
      ! kernel in a sampled way
      !---------------------------------------------------------------------
      type (gildas)                  :: hout      ! Header of output cube
      real(kind=4),    intent(in)    :: beam      ! Beam size in radian
      real(kind=4),    intent(in)    :: diam      ! Diameter in meter
      integer(kind=4), intent(in)    :: nx,ny     ! Map size
      real(kind=4),    intent(out)   :: f(nx,ny)  ! Multiplication factor
      real(kind=8),    intent(inout) :: dx,dy     !
    end subroutine dosdft
  end interface
  !
  interface
    subroutine sdcorr(z,f,nxy)
      !---------------------------------------------------------------------
      ! @ private
      ! Correct for single dish beam
      !---------------------------------------------------------------------
      complex,         intent(inout) :: z(*)  !
      real(kind=4),    intent(in)    :: f(*)  !
      integer(kind=4), intent(in)    :: nxy   ! Problem size
    end subroutine sdcorr
  end interface
  !
  interface
    subroutine retocm(r,z,nx,ny)
      !---------------------------------------------------------------------
      ! @ private
      ! Real to complex conversion
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: nx,ny     !
      real(kind=4),    intent(in)  :: r(nx,ny)  !
      complex,         intent(out) :: z(nx,ny)  !
    end subroutine retocm
  end interface
  !
  interface
    subroutine cmtore(z,r,nx,ny)
      !---------------------------------------------------------------------
      ! @ private
      ! Complex to real conversion
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: nx,ny     !
      complex,         intent(in)  :: z(nx,ny)  !
      real(kind=4),    intent(out) :: r(nx,ny)  !
    end subroutine cmtore
  end interface
  !
  interface
    subroutine grdtab(n,buff,bias,corr)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      ! Compute fourier transform of gridding function
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: n        ! Number of pixels, assuming center on N/2+1
      real(kind=4),    intent(in)  :: buff(*)  ! Gridding function, tabulated every 1/100th of a pixel
      real(kind=4),    intent(in)  :: bias     ! Center of gridding function
      real(kind=4),    intent(out) :: corr(n)  ! Gridding correction FT
    end subroutine grdtab
  end interface
  !
  interface
    subroutine dogrid(corr,corx,cory,nx,ny,beam)
      !---------------------------------------------------------------------
      ! @ private
      ! Compute grid correction array, with normalisation of beam to 1.0 at
      ! maximum pixel
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: nx,ny        ! Map size
      real(kind=4),    intent(out) :: corr(nx,ny)  ! Final grid correction and beam normalization
      real(kind=4),    intent(in)  :: corx(nx)     ! X Grid correction
      real(kind=4),    intent(in)  :: cory(ny)     ! Y Grid correction
      real(kind=4),    intent(in)  :: beam(nx,ny)  ! Denormalized Beam
    end subroutine dogrid
  end interface
  !
  interface
    subroutine docorr(map,corr,nd)
      !---------------------------------------------------------------------
      ! @ private
      ! Apply grid correction to map
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: nd        ! Map size
      real(kind=4),    intent(inout) :: map(nd)   ! Map to be corrected
      real(kind=4),    intent(in)    :: corr(nd)  ! Grid correction
    end subroutine docorr
  end interface
  !
  interface
    subroutine dotrunc(hout,diam,f,nx,ny)
      use gildas_def
      use image_def
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      ! Truncate the Fourier Transform beyond the physical disk size
      !---------------------------------------------------------------------
      type (gildas)                :: hout      ! Header of output data cube
      real(kind=4),    intent(in)  :: diam      ! Diameter in meter
      integer(kind=4), intent(in)  :: nx,ny     ! Map size
      real(kind=4),    intent(out) :: f(nx,ny)  ! Multiplication factor
    end subroutine dotrunc
  end interface
  !
  interface
    subroutine run_map(line,comm,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! MAP Main library entry point
      !     Call appropriate subroutine according to COMM
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      character(len=*), intent(in)  :: comm   ! Command name
      logical,          intent(out) :: error  ! Error status
    end subroutine run_map
  end interface
  !
  interface
    subroutine doconv(ncol,nlin,table,xp,yp,we,gwe,nx,ny,map,mapx,mapy,sup,  &
      cell,conv,time,error)
      use gildas_def
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !   Grid (i.e. convolve data from input table columns by a gridding
      ! function)
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: ncol      ! Number of table column / Nchan
      integer(kind=index_length), intent(in)  :: nlin      ! Number of table line
      real(kind=4),         intent(in)    :: table(ncol,nlin)  ! The table array
      real(kind=4),         intent(in)    :: xp(nlin)          ! X coordinates
      real(kind=4),         intent(in)    :: yp(nlin)          ! Y coordinates
      real(kind=4),         intent(in)    :: we(nlin)          ! The table weights
      integer(kind=index_length), intent(in)  :: nx,ny         ! Map size
      real(kind=4),         intent(out)   :: gwe(nx,ny)        ! Gridded weights
      real(kind=4),         intent(out)   :: map(ncol,nx,ny)   ! Gridded cube
      real(kind=4),         intent(in)    :: mapx(nx)          ! Arrays of gridded coordinates
      real(kind=4),         intent(in)    :: mapy(ny)          ! Arrays of gridded coordinates
      real(kind=4),         intent(in)    :: sup(2)            ! Convolving function support size in user unit
      real(kind=4),         intent(in)    :: cell(2)           ! Pixel size in user unit
      type(xymap_conv2d_t), intent(in)    :: conv              ! Buffer for the convolution kernel
      type(time_t),         intent(inout) :: time              ! Timer
      logical,              intent(inout) :: error             !
    end subroutine doconv
  end interface
  !
  interface
    subroutine findr(xx,nv,xlim,nlim)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !  Find nlim such as
      !    xx(nlim-1) < xlim < xx(nlim)
      !  for input data ordered, retrieved from memory
      !  Assume that nlim is already preset so that xx(ic,nlim-1) < xlim
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)    :: nv
      real(kind=4),               intent(in)    :: xx(nv)
      real(kind=4),               intent(in)    :: xlim
      integer(kind=index_length), intent(inout) :: nlim
    end subroutine findr
  end interface
  !
  interface
    subroutine convol(conv,dx,dy,resu)
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute value of bi-dimensional convolving function in (dx,dy) point
      ! Takes into account the fact that the 1-D convolving functions are
      ! tabulated every 1/100th of pixel
      !---------------------------------------------------------------------
      type(xymap_conv2d_t), intent(in)  :: conv   !
      real(kind=4),         intent(in)  :: dx,dy  ! Point where to compute the convolving function
      real(kind=4),         intent(out) :: resu   ! Resulting value
    end subroutine convol
  end interface
  !
  interface
    subroutine conv_fn_computation(conv,error)
      use phys_const
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! CONVFN computes the convolving functions and stores them in the
      ! supplied buffer. Values are tabulated every 1/100th of pixel
      ! CONV%PARM(1) = radius of support in pixel unit
      !---------------------------------------------------------------------
      type(xymap_conv1d_t), intent(inout) :: conv   ! Convolution description
      logical,              intent(out)   :: error  !
    end subroutine conv_fn_computation
  end interface
  !
  interface
    subroutine sphfn(ialf,im,iflag,eta,psi,ier)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  SPHFN is a subroutine to evaluate rational approximations to selected
      !  zero-order spheroidal functions, psi(c,eta), which are, in a
      !  sense defined in VLA Scientific Memorandum No. 132, optimal for
      !  gridding interferometer data.  The approximations are taken from
      !  VLA Computer Memorandum No. 156.  The parameter c is related to the
      !  support width, m, of the convoluting function according to c=
      !  pi*m/2.  The parameter alpha determines a weight function in the
      !  definition of the criterion by which the function is optimal.
      !  SPHFN incorporates approximations to 25 of the spheroidal functions,
      !  corresponding to 5 choices of m (4, 5, 6, 7, or 8 cells)
      !  and 5 choices of the weighting exponent (0, 1/2, 1, 3/2, or 2).
      !
      !  Input:
      !    IALF    I*4   Selects the weighting exponent, alpha.  IALF =
      !                  1, 2, 3, 4, and 5 correspond, respectively, to
      !                  alpha = 0, 1/2, 1, 3/2, and 2.
      !    IM      I*4   Selects the support width m, (=IM) and, correspond-
      !                  ingly, the parameter c of the spheroidal function.
      !                  Only the choices 4, 5, 6, 7, and 8 are allowed.
      !    IFLAG   I*4   Chooses whether the spheroidal function itself, or
      !                  its Fourier transform, is to be approximated.  The
      !                  latter is appropriate for gridding, and the former
      !                  for the u-v plane convolution.  The two differ on-
      !                  by a factor (1-eta**2)**alpha.  IFLAG less than or
      !                  equal to zero chooses the function appropriate for
      !                  gridding, and IFLAG positive chooses its F.T.
      !    ETA     R*4   Eta, as the argument of the spheroidal function, is
      !                  a variable which ranges from 0 at the center of the
      !                  convoluting function to 1 at its edge (also from 0
      !                  at the center of the gridding correction function
      !                  to unity at the edge of the map).
      !
      !  Output:
      !    PSI      R*4  The function value which, on entry to the subrou-
      !                  tine, was to have been computed.
      !    IER      I*4  An error flag whose meaning is as follows:
      !                     IER = 0  =>  No evident problem.
      !                           1  =>  IALF is outside the allowed range.
      !                           2  =>  IM is outside of the allowed range.
      !                           3  =>  ETA is larger than 1 in absolute
      !                                     value.
      !                          12  =>  IALF and IM are out of bounds.
      !                          13  =>  IALF and ETA are both illegal.
      !                          23  =>  IM and ETA are both illegal.
      !                         123  =>  IALF, IM, and ETA all are illegal.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: ialf   !
      integer(kind=4), intent(in)  :: im     !
      integer(kind=4), intent(in)  :: iflag  !
      real(kind=4)                 :: eta    !
      real(kind=4),    intent(out) :: psi    !
      integer(kind=4), intent(out) :: ier    !
    end subroutine sphfn
  end interface
  !
  interface
    subroutine conv_fn_default(ctypx,ctypy,xparm,yparm)
      !---------------------------------------------------------------------
      ! @ private
      !   Determine default parameters for the convolution functions when
      ! they are not specified. Default convolving type is a spheroidal
      ! function. Any other unspecified values (= 0.0) will be set to
      ! some value.
      !---------------------------------------------------------------------
      integer(kind=4), intent(inout) :: ctypx      ! Convolution types for X direction
      integer(kind=4), intent(inout) :: ctypy      ! Convolution types for Y direction
      real(kind=4),    intent(inout) :: xparm(10)  ! Parameters for the convolution fns (1) = support radius (cells)
      real(kind=4),    intent(inout) :: yparm(10)  ! Parameters for the convolution fns (1) = support radius (cells)
    end subroutine conv_fn_default
  end interface
  !
  interface
    subroutine doplace(map,table,cube,gweight,time,error)
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(xymap_prog_t), intent(in)    :: map ! Gridding description
      real(kind=4),       intent(in)    :: table(map%tab%nchan,map%tab%nposi)
      real(kind=4),       intent(inout) :: cube(map%cub%nchan,map%cub%nx,map%cub%ny)
      real(kind=4),       intent(inout) :: gweight(map%cub%nx,map%cub%ny)
      type(time_t),       intent(inout) :: time
      logical,            intent(inout) :: error
    end subroutine doplace
  end interface
  !
  interface
    subroutine docoor(n,xref,xval,xinc,x)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Compute coordinate array from conversion formula
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: n     ! Number of pixel
      real(kind=8),               intent(in)  :: xref  ! Reference pixel
      real(kind=8),               intent(in)  :: xval  ! Value at reference pixel
      real(kind=8),               intent(in)  :: xinc  ! Pixel size
      real(kind=4),               intent(out) :: x(n)  ! Axis coordinate
    end subroutine docoor
  end interface
  !
  interface
    subroutine gag_cputime_add(sum,last)
      use gkernel_types
      !---------------------------------------------------------------------
      ! @ private
      !   Get the times since last call for 'last', and add the times to
      ! the structure 'sum'. Note that the reference times in 'sum' have
      ! not much meaning in this context.
      ! ---
      !   This subroutine is helpful to add non-contiguous time counts,
      ! while the official cputime_t is made to count times from a reference
      ! or from last call. Should this be merged in gsys?
      !---------------------------------------------------------------------
      type(cputime_t), intent(inout) :: sum
      type(cputime_t), intent(inout) :: last
    end subroutine gag_cputime_add
  end interface
  !
  interface
    subroutine print_cputime_feedback(time)
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(xymap_time_t), intent(in) :: time
    end subroutine print_cputime_feedback
  end interface
  !
  interface
    subroutine reallocate_tab(array,n1,n2,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Reallocate a 2D table
      !---------------------------------------------------------------------
      real(kind=4),               allocatable   :: array(:,:)
      integer(kind=index_length), intent(in)    :: n1,n2
      logical,                    intent(inout) :: error
    end subroutine reallocate_tab
  end interface
  !
  interface
    subroutine reallocate_cub(array,n1,n2,n3,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Reallocate a 3D cube
      !---------------------------------------------------------------------
      real(kind=4),               allocatable   :: array(:,:,:)
      integer(kind=index_length), intent(in)    :: n1,n2,n3
      logical,                    intent(inout) :: error
    end subroutine reallocate_cub
  end interface
  !
  interface
    function pretty_size(nwords)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !  Return a string describing the input size (words) in a bytes
      ! multiple
      !---------------------------------------------------------------------
      character(len=20) :: pretty_size     ! Function value on return
      integer(kind=size_length) :: nwords  ! [words]
    end function pretty_size
  end interface
  !
  interface
    subroutine sort_xyw(tab,error)
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Sort the X Y W buffers by ascending Y, and fill the sorting array
      !---------------------------------------------------------------------
      type(xymap_tab_t), intent(inout) :: tab
      logical,           intent(inout) :: error
    end subroutine sort_xyw
  end interface
  !
  interface
    subroutine sort_tab(table,ncol,nlin,key,work,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Sort the input table according to the sorting array
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)    :: ncol              ! Table column number
      integer(kind=index_length), intent(in)    :: nlin              ! Table line number
      real(kind=4),               intent(inout) :: table(ncol,nlin)  ! Table to be sorted
      integer(kind=4),            intent(in)    :: key(nlin)         ! Sorting array
      real(kind=4),               allocatable   :: work(:,:)         ! Working buffer
      logical,                    intent(inout) :: error             ! Returned status
    end subroutine sort_tab
  end interface
  !
  interface
    subroutine gr4_sort2d(x,xwork,key,nc,nl)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !  Reorder a real*4 2D array by increasing order using the sorted
      ! indexes computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)    :: nl,nc         ! N lines and N columns
      real(kind=4),               intent(inout) :: x(nc,nl)      ! The data to be sorted
      real(kind=4)                              :: xwork(nc,nl)  ! Working buffer
      integer(kind=4),            intent(in)    :: key(nl)       ! Sorting array
    end subroutine gr4_sort2d
  end interface
  !
  interface
    function trione(x,nd,n,ix,work)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! 	Sorting an input table (i.e. 2D array) according to column ix in
      !     increasing order. The quicksort algorithm is used.
      !---------------------------------------------------------------------
      integer(kind=4) :: trione                   !
      integer(kind=4), intent(in)    :: nd        ! Table column number
      integer(kind=4), intent(in)    :: n         ! Table line number
      real(kind=4),    intent(inout) :: x(nd,n)   ! Unsorted table
      integer(kind=4), intent(in)    :: ix        ! Column serving as key for sorting
      real(kind=4),    intent(inout) :: work(nd)  ! Work space for exchange
    end function trione
  end interface
  !
  interface
    subroutine define_sic_xymap(error)
      use gildas_def
      use xymap_def
      !---------------------------------------------------------------------
      ! @ private
      ! MAP Internal routine
      !---------------------------------------------------------------------
      logical, intent(out) :: error     ! Error status
    end subroutine define_sic_xymap
  end interface
  !
  interface
    subroutine init_xymap_struct(xymap)
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! MAP Internal routine
      !---------------------------------------------------------------------
      type(xymap_user_t), intent(out) :: xymap  !
    end subroutine init_xymap_struct
  end interface
  !
  interface
    subroutine xymap(line,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! MAP Support routine for command
      !     XY_MAP [TableName]
      ! 1          [/NOGRID]
      ! 2          [/TYPE LMV|VLM|...]
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine xymap
  end interface
  !
  interface
    subroutine sub_xymap(tablename,cubename,nogrid,lmvcode,error)
      use gbl_message
      use gildas_def
      use image_def
      use xymap_def
      !---------------------------------------------------------------------
      ! @ private
      ! Do the job
      !------------------------------------------------------------------------
      character(len=*), intent(in)  :: tablename  ! Name of input table
      character(len=*), intent(in)  :: cubename   ! Name of output cube
      logical,          intent(in)  :: nogrid     ! Do not convolve, just place
      character(len=*), intent(in)  :: lmvcode    ! LMV or VLM or any...
      logical,          intent(out) :: error      ! Logical error flag
    end subroutine sub_xymap
  end interface
  !
  interface
    subroutine table_open(tablename,prefixname,tab,error)
      use image_def
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the table header
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: tablename   ! Table name e.g. 'foo.tab'
      character(len=*),  intent(out)   :: prefixname  ! Prefix shared with the cube e.g. 'foo'
      type(xymap_tab_t), intent(inout) :: tab         !
      logical,           intent(inout) :: error       !
    end subroutine table_open
  end interface
  !
  interface
    subroutine table_read_xyw(tab,time,error)
      use gbl_message
      use gkernel_types
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the X, Y, and weights arrays
      !---------------------------------------------------------------------
      type(xymap_tab_t), intent(inout) :: tab
      type(cputime_t),   intent(inout) :: time
      logical,           intent(inout) :: error
    end subroutine table_read_xyw
  end interface
  !
  interface
    subroutine table_read_data(tab,v1,v2,time,error)
      use gbl_message
      use gkernel_types
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the data in order VELOCITY - POSITION
      !---------------------------------------------------------------------
      type(xymap_tab_t),          intent(inout) :: tab
      integer(kind=index_length), intent(in)    :: v1,v2  ! [chan] Range to read
      type(xymap_time_t),         intent(inout) :: time   !
      logical,                    intent(inout) :: error
    end subroutine table_read_data
  end interface
  !
  interface
    subroutine my_close_image(h,error)
      use image_def
      !---------------------------------------------------------------------
      ! @ private
      !  GDF-close the input GDF image, if it is opened
      !  Input error status is also preserved on output
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: h
      logical,      intent(inout) :: error
    end subroutine my_close_image
  end interface
  !
  interface
    subroutine check_table_format(xymap_user,map,error)
      use gbl_message
      use image_def
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! MAP internal routine
      !---------------------------------------------------------------------
      type(xymap_user_t), intent(in)    :: xymap_user  ! Input user parameters
      type(xymap_prog_t), intent(inout) :: map         ! Gridding parameters
      logical,            intent(out)   :: error       ! Return status
    end subroutine check_table_format
  end interface
  !
  interface
    subroutine reproject_table(tab,system,                        &
                               oldproj,olda0,oldd0,oldangle,      &
                               newproj,newa0,newd0,newangle,error)
      use phys_const
      use gbl_constant
      use gbl_message
      use gkernel_types
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! Shift-rotate-reproject the table coordinates with a new projection
      ! type and/or new projection center and/or new projection angle.
      !---------------------------------------------------------------------
      type(xymap_tab_t), intent(inout) :: tab          !
      character(len=*),  intent(in)    :: system       ! Coordinate system (for feedback)
      integer(kind=4),   intent(in)    :: oldproj      ! Table projection code
      real(kind=8),      intent(in)    :: olda0,oldd0  ! Table projection center
      real(kind=8),      intent(in)    :: oldangle     ! Table projection angle
      integer(kind=4),   intent(in)    :: newproj      ! Map projection code
      real(kind=8),      intent(in)    :: newa0,newd0  ! Map projection center
      real(kind=8),      intent(in)    :: newangle     ! Map projection angle
      logical,           intent(inout) :: error        ! Returned status
    end subroutine reproject_table
  end interface
  !
  interface
    subroutine define_gridding_parameters(xymap_user,map,hin,nogrid,error)
      use phys_const
      use image_def
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! MAP internal routine
      ! Compute the map characterictics:
      !  - resolution
      !  - position angle
      !  - pixel size
      !  - gridding function (if not placing)
      !  - map size
      !  - axes
      ! either from (in priority order):
      !  - xymap_user% (i.e. elements of SIC structure map% customized by user)
      !  - xymap_user%like (another map used as reference)
      !  - data positions (if placing is used)
      !  - defaults
      !---------------------------------------------------------------------
      type(xymap_user_t), intent(inout) :: xymap_user  ! Input user parameters
      type(xymap_prog_t), intent(inout) :: map         ! Gridding parameters
      type(gildas),       intent(in)    :: hin         ! Input table header
      logical,            intent(in)    :: nogrid      ! Use placing instead of gridding
      logical,            intent(out)   :: error       ! Return status
    end subroutine define_gridding_parameters
  end interface
  !
  interface
    subroutine find_xy_range(tab,xmin,xmax,ymin,ymax,error)
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !     Search for the limits of the x and y coordinates.
      !     The algorithm assumes that the input table is sorted in increasing
      !     order according to the Y coordinate.
      !---------------------------------------------------------------------
      type(xymap_tab_t), intent(in)    :: tab    !
      real(kind=4),      intent(out)   :: xmin   ! Minimum of X coordinates
      real(kind=4),      intent(out)   :: xmax   ! Maximum of X coordinates
      real(kind=4),      intent(out)   :: ymin   ! Minimum of Y coordinates
      real(kind=4),      intent(out)   :: ymax   ! Maximum of Y coordinates
      logical,           intent(inout) :: error  !
    end subroutine find_xy_range
  end interface
  !
  interface
    subroutine find_xy_increment(tab,xinc,yinc,tole)
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! Find minimum increment in the X and Y coordinates.
      ! If this minimum is lower than the X-Y position tolerance, then send
      ! back this tolerance instead.
      ! Warning: xinc and yinc are assumed to be initialized outside this
      !          subroutine.
      ! *** JP ***
      ! The current algorithm takes forever when the number of table lines
      ! increases. A better way would be to assume that the data coordinates
      ! are indeed already on a grid (this is the use case in which to call
      ! this subroutine!). In this case, finding first the equivalent classes
      ! of the x offsets will be extremely fast because there is not so many
      ! different x offsets! We can then sort them and find the minimum
      ! distance between them. Once this is done, we use exactly the same
      ! algorithm but for the y offsets. To be fully generic, we can use the
      ! same positioning tolerance as used in other parts of this code. Hence,
      ! if the data offsets are not already positioned on a grid, we still
      ! limit the number of equivalence classes and the algorithm should stay fast.
      ! *** JP ***
      !---------------------------------------------------------------------
      type(xymap_tab_t), intent(in)    :: tab   !
      real(kind=4),      intent(inout) :: xinc  ! X minimum increment (initialized to xmax-xmin)
      real(kind=4),      intent(inout) :: yinc  ! Y minimum increment (initialized to ymax-ymin)
      real(kind=4),      intent(in)    :: tole  ! X-Y position tolerance
    end subroutine find_xy_increment
  end interface
  !
  interface
    subroutine print_gridding_parameters(map)
      use gbl_message
      use phys_const
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! MAP internal routine
      !---------------------------------------------------------------------
      type(xymap_prog_t), intent(inout) :: map  ! Cube description
    end subroutine print_gridding_parameters
  end interface
  !
  interface
    subroutine table_to_cube_headers(map,basename,lmvcode,error)
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      ! Set up the headers for the output data cube and weight image
      !---------------------------------------------------------------------
      type(xymap_prog_t), intent(inout) :: map
      character(len=*),   intent(in)    :: basename
      character(len=*),   intent(in)    :: lmvcode
      logical,            intent(inout) :: error
    end subroutine table_to_cube_headers
  end interface
  !
  interface
    subroutine table_to_cube_header(filename,hin,map,trcode,hout,error)
      use image_def
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the output cube (header part)
      !---------------------------------------------------------------------
      character(len=*),   intent(in)    :: filename  !
      type(gildas),       intent(in)    :: hin       !
      type(xymap_prog_t), intent(in)    :: map       !
      character(len=*),   intent(in)    :: trcode    ! Transposition code e.g. '231'
      type(gildas),       intent(inout) :: hout      !
      logical,            intent(inout) :: error     !
    end subroutine table_to_cube_header
  end interface
  !
  interface
    subroutine table_to_cube_data(map,nogrid,error)
      use gbl_message
      use gildas_def
      use gkernel_types
      use image_def
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the output cube and weight (data part)
      !---------------------------------------------------------------------
      type(xymap_prog_t), intent(inout) :: map     ! Gridding parameters
      logical,            intent(in)    :: nogrid  ! Do not convolve, just place
      logical,            intent(out)   :: error   ! Return status
    end subroutine table_to_cube_data
  end interface
  !
  interface
    subroutine table_to_cube_datasub(map,firstblock,fc,lc,nogrid,xcoord,ycoord,  &
      time,error)
      use gildas_def
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Process 1 block of channels
      !---------------------------------------------------------------------
      type(xymap_prog_t),         intent(inout) :: map             !
      logical,                    intent(in)    :: firstblock      ! First block written?
      integer(kind=index_length), intent(in)    :: fc,lc           ! First and last channels
      logical,                    intent(in)    :: nogrid          !
      real(kind=4)                              :: xcoord(map%cub%nx)  ! Working buffer
      real(kind=4)                              :: ycoord(map%cub%ny)  ! Working buffer
      type(time_t),               intent(inout) :: time            !
      logical,                    intent(inout) :: error           !
    end subroutine table_to_cube_datasub
  end interface
  !
  interface
    subroutine cube_write_data(cub,firstblock,fc,lc,time,error)
      use gbl_message
      use xymap_types
      !---------------------------------------------------------------------
      ! @ private
      !  Write the block of data, either directly on disk, either in memory
      ! depending on the cube order and memory size.
      !---------------------------------------------------------------------
      type(xymap_cub_t),          intent(inout) :: cub         !
      logical,                    intent(in)    :: firstblock  ! First block written?
      integer(kind=index_length), intent(in)    :: fc,lc       ! First and last channels
      type(xymap_time_t),         intent(inout) :: time        !
      logical,                    intent(inout) :: error       !
    end subroutine cube_write_data
  end interface
  !
end module classmap_interfaces_private

subroutine conpdv (xd,yd,zd,ndp,gwrite)
  !---------------------------------------------------------------------
  ! @ private
  !	Plot the data values on the contour map
  !	currently up to 10 characters for each value are displayed
  ! Arguments :
  !	XD	R*4 (*)	Array of X coordinates		Input
  !	YD	R*4 (*)	Array of Y coordinates		Input
  !	ZD	R*4 (*)	Array of values			Input
  !	NDP	I	Number of values		Input
  !	GWRITE	Ext	Label drawing routine		Input
  ! Subroutines :
  !	GWRITE
  !---------------------------------------------------------------------
  real :: xd(1)                     !
  real :: yd(1)                     !
  real :: zd(1)                     !
  integer :: ndp                    !
  external :: gwrite                !
  ! Local
  integer :: k
  !
  !  Loop and plot all values
  do k=1,ndp
    call gwrite(zd(k),xd(k),yd(k))
  enddo
end subroutine conpdv

subroutine set_attributs(output,attr_v)
  use gtv_interfaces, except_this=>set_attributs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Mise en place des differents attributs de trace.
  !---------------------------------------------------------------------
  type(gt_display),      intent(inout) :: output  ! Output instance
  type(gt_segment_attr), intent(in)    :: attr_v  !
  call set_dash (output,attr_v%dash)
  call set_weigh(output,attr_v%weight)
  call set_color(output,attr_v%colour)
end subroutine set_attributs
!
subroutine set_dash(output,z_dash)
  use gtv_interfaces, except_this=>set_dash
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Fixe le parametre de pointille, pour les protocoles capables de le
  ! faire tous seuls.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Output instance
  integer*4,        intent(in)    :: z_dash  !
  ! Local
  logical :: z_flag_dash
  real*4 :: z_xy_scale
  integer(kind=4) :: z_pix_dash_style(4)
  integer :: i
  real*4 :: z_ps_dash_style(4),sizex,sizey,gsclx,gscly
  !
  output%idashe=z_dash
  !
  if (output%dev%protocol.eq.p_x) then
    ! je calcule un rapport valable en x et y pour les longueurs
    ! des piti traits diagonaux. Ce n'est utile que lorsqu'une
    ! diagonale de pixels m'est pas exactement a 45' sur l'ecran,
    ! sinon gsclx et gscly etant egaux, l'un des deux suffit.
    !
    sizex = cw_directory%phys_size(1)
    sizey = cw_directory%phys_size(2)
    call get_scale_awd(output,gsclx,gscly)
    z_xy_scale = (abs(gsclx)*sizex+abs(gscly)*sizey) / (sizex+sizey)
    !
    ! calcul du dash_style, les piti points sont au moins de longueur 1
    ! ds le cas ou HARDW_LINE_DASH est .FALSE., on CONSERVE IDASH  (ce qui
    ! force GTX_CHOPPE a travailler, mais on FORCE le dash hardware a
    ! "pas de dash pattern".
    if (output%idashe.eq.1 .or.  &
        .not.(user_hardw_line.and.output%dev%hardw_line_dash)) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_pix_dash_style(i)=z_xy_scale*onoff(i,output%idashe)
        if (z_pix_dash_style(i).lt.1) then
          z_pix_dash_style(i)=1
        endif
      enddo
    endif
    call x_dash(output%x%graph_env,z_flag_dash,z_pix_dash_style)
    !
  elseif (output%dev%protocol.eq.p_postscript) then
    if (output%idashe.eq.1) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_ps_dash_style(i)=onoff(i,output%idashe)
      enddo
    endif
    call ps_dash(z_flag_dash,z_ps_dash_style)
    !
  elseif (output%dev%protocol.eq.p_svg) then
    if (output%idashe.eq.1) then
      z_flag_dash=.false.
    else
      z_flag_dash=.true.
      do i=1,4
        z_ps_dash_style(i)=onoff(i,output%idashe)
      enddo
    endif
    call svg_dash(output,z_flag_dash,z_ps_dash_style)
  endif
  !
end subroutine set_dash
!
subroutine set_weigh(output,z_weigh)
  use gtv_interfaces, except_this=>set_weigh
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! fixe le parametre de graisse, pour les protocoles capables de le
  ! faire tous seuls.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output   ! Output instance
  real(kind=4),     intent(in)    :: z_weigh  !
  !
  output%iweigh = z_weigh
  !
  if (output%dev%protocol.eq.p_x) then
    call x_weigh(output%x%graph_env,set_weight_pixel(output))
    !
  elseif (output%dev%protocol.eq.p_postscript) then
    call ps_weigh(output%iweigh)
    !
  elseif (output%dev%protocol.eq.p_svg) then
    call svg_weigh(output,output%iweigh)
    !
  elseif (output%dev%protocol.eq.p_png) then
    call png_weigh(output,set_weight_pixel(output))
  endif
  !
end subroutine set_weigh
!
function set_weight_pixel(output)
  use gtv_interfaces, except_this=>set_weight_pixel
  use gtv_buffers
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Convert the line width from physical size (cm) to pixel
  !---------------------------------------------------------------------
  integer(kind=4) :: set_weight_pixel  ! Function value on return
  type(gt_display), intent(in) :: output  ! Output instance
  ! Local
  real(kind=4) :: z_xy_scale,sizex,sizey,gsclx,gscly
  !
  ! If weigh is 0 ou 1, we do not enlarge the line, else zooms won't
  ! help! Note that 0 ("hairline") gives better result than 1 on X
  ! devices (!!!)
  if (output%iweigh.le.graisse(1)) then
    set_weight_pixel = 0
    return
  endif
  !
  ! je calcule un rapport valable en x et y pour les longueurs
  ! des piti traits diagonaux. Ce n'est utile que lorsqu'une
  ! diagonale de pixels n'est pas exactement a 45' sur l'ecran,
  ! sinon gsclx et gscly etant egaux, l'un des deux suffit.
  sizex = cw_directory%phys_size(1)  ! Global dependency here!!!
  sizey = cw_directory%phys_size(2)  ! Global dependency here!!!
  call get_scale_awd(output,gsclx,gscly)
  z_xy_scale = (abs(gsclx)*sizex+abs(gscly)*sizey) / (sizex+sizey)
  !
  ! Calcul de l'epaisseur en pixel, limite au moins a 1
  set_weight_pixel = output%iweigh*z_xy_scale
  if (set_weight_pixel.lt.2)  set_weight_pixel = 0
  !
end function set_weight_pixel
!
subroutine set_color(output,z_color)
  use gtv_interfaces, except_this=>set_color
  use gtv_types
  use gtv_graphic
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  ! fixe le parametre de couleur
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output   ! Output instance
  integer*4,        intent(in)    :: z_color  !
  !
  output%icolou = z_color
  call gtx_pen(output,output%icolou,gbl_pen)
end subroutine set_color

module astro_register_type
  use astro_types
  !
  public
  private :: register_reallocate,register_free,register_add_febe
  !
  integer(kind=4), parameter :: m_register_alloc=16
  !
  type noema_febe_register_t
    !
    integer(kind=4) :: m_saved=0
    integer(kind=4) :: n_saved=0
    integer(kind=4) :: n_index=0
    type(noema_febe_t), allocatable :: saved_febe(:) 
    !
    contains
      procedure, public :: free => register_free
      procedure, public :: reallocate => register_reallocate
      procedure, public :: add => register_add_febe
      procedure, public :: save => register_save_febe
      procedure, public :: clear => register_clear
      procedure, public :: list => register_list
      procedure, public :: load => register_load_febe
      procedure, public :: remove => register_remove_febe
  end type noema_febe_register_t
  !
contains
  subroutine register_reallocate(register,m_febe,error)
    use gkernel_interfaces
    ! Reallocate register%n_saved_febe if needed
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: m_febe
    logical, intent(inout)      :: error
    !
    character(len=*), parameter :: rname='REGISTER>REALLOCATE'
    integer(kind=4) :: ier
    logical :: alloc
    !
    alloc=.true.
    ! First check if alloc already
    if (allocated(register%saved_febe)) then
      if (register%m_saved.eq.m_febe) then
        ! Already allocated at the right size
        alloc = .false.
      else
        ! Not the right size: deallocate
        call register%free(error)
        if (error) return
        alloc=.true.
      endif
    endif
    if (alloc) then
      ! Allocate to right size
      allocate(register%saved_febe(m_febe),stat=ier)
      if (failed_allocate(rname,'REGISTER saved FEBE',ier,error))  return
      register%m_saved=m_febe
    endif
    !
  end subroutine register_reallocate
  !
  subroutine register_free(register,error)
    ! Deallocate pfx%unit
    class(noema_febe_register_t), intent(inout) :: register
    logical, intent(inout)      :: error
    !
    if (allocated(register%saved_febe)) deallocate(register%saved_febe)
    !
  end subroutine register_free
  !
  subroutine register_add_febe(register,lfebe,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! add current freq setup to the multifreq list
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(noema_febe_t), intent(inout) :: lfebe
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>ADD'
    integer(kind=4) :: i,idx,inum
    character(len=256) :: mess
    !
    ! Check that there is at least 1 spectral window
    if (lfebe%spw%out%n_spw.eq.0) then
      call astro_message(seve%e,rname,'Current FEBE does not contain any SPW, nothing done')
      error=.true.
      return
    endif
    ! Get the first free slot
    idx=-1
    do i=1,register%m_saved
      if (.not.register%saved_febe(i)%defined) then
        idx=i
        exit
      endif
    enddo
    ! 
    if (idx.eq.-1) then
      call astro_message(seve%e,rname, &
           'No space left in register, remove some FEBE before trying to add new ones')
      error=.true.
      return
    endif
    ! Get the number -  always increase to keep a kind of history, even if some FEBE are removed in between
    inum=register%n_index+1
    call register%saved_febe(idx)%pfx%reallocate(lfebe%pfx%n_units,error)
    if (error) return
    register%saved_febe(idx)=lfebe
    register%saved_febe(idx)%id=inum
    register%saved_febe(idx)%defined=.true.
    register%saved_febe(idx)%loaded=.false.
    ! 
    register%n_saved=register%n_saved+1
    register%n_index=inum
    !
    write (mess,'(a,1x,i0.0)') 'Current frontend-backend settings saved to register under number',inum
    call astro_message(seve%i,rname,mess)
    !
    lfebe%loaded=.false.
    !
  end subroutine register_add_febe
  !
  subroutine register_save_febe(register,lfebe,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! save current freq setup to the multifreq list (at the place of the loaded febe)
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(noema_febe_t), intent(inout) :: lfebe
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>SAVE'
    integer(kind=4) :: i,idx
    character(len=256) :: mess
    !
    ! Get the slot of the loaded FEBE
    idx=-1
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.lfebe%id) cycle
      idx=i
    enddo
    ! 
    if (idx.eq.-1) then
      call astro_message(seve%e,rname, &
           'Index of the loaded FEBE is not found')
      error=.true.
      return
    endif
    if (.not.lfebe%loaded) then
      call astro_message(seve%e,rname, &
           'Need to load a FEBE before saving')
      error=.true.
      return
    endif
    call register%saved_febe(idx)%pfx%reallocate(lfebe%pfx%n_units,error)
    if (error) return
    register%saved_febe(idx)=lfebe
    register%saved_febe(idx)%defined=.true.
    register%saved_febe(idx)%loaded=.false.
    !
    write (mess,'(a,1x,i0.0)') 'Current frontend-backend saved in number',lfebe%id
    call astro_message(seve%i,rname,mess)
    !
    lfebe%loaded=.false.
    !
  end subroutine register_save_febe
  !
  subroutine register_clear(register,error)
    !-----------------------------------------------------------------------
    ! reset the register to 0
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>CLEAR'
    integer(kind=4) :: i
    !
    do i=1,register%m_saved
      register%saved_febe(i)%defined=.false.
      register%saved_febe(i)%id=0
      register%saved_febe(i)%name=''
    enddo
    register%n_saved=0
    register%n_index=0
    !
  end subroutine register_clear
  !
  subroutine register_list(register,recdesc,error)
    use gbl_message
    use ast_astro
    !-----------------------------------------------------------------------
    ! list current freq setups in the register
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    type(receiver_desc_t), intent(in) :: recdesc
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>LIST'
    integer(kind=4) :: i,j,dband,imode
    character(len=256) :: mess,vmess
    real(kind=8) :: dfreq
    character(len=32) :: dbandname,dmodename,vtype
    logical :: found
    !
    if (register%n_saved.eq.0) then
      call astro_message(seve%r,rname,'The register does not contain any FEBE')
      return
    endif
    if (soukind.ne.soukind_none) then
      if (source_invtype(1:2).eq.'LS') then
        vtype='LSR'
        write (vmess,'(a,1x,f0.3,1x,a)') trim(vtype),source_vlsr,'km/s'
      else if (source_invtype(1:2).eq.'RE') then
        vtype='REDSHIFT'
        write (vmess,'(a,1x,f0.3)') trim(vtype),source_redshift
      else
        vtype=''
        vmess=''
      endif
      if (soukind.eq.soukind_full) then
        write (mess,'(a,1x,a,1x,a)')  'List of tunings defined for current source:', &
                                            trim(astro_source_name),trim(vmess)
      else if (soukind.eq.soukind_vlsr.or.soukind.eq.soukind_red) then
        write (mess,'(a,1x,a)')  'List of tunings defined for',trim(vmess)
      endif
      call astro_message(seve%r,rname,mess)
    endif
    !
    do i=1,register%n_index ! loop on the idx numbers
      found=.false.
      do j=1,register%m_saved ! Find the corresponding saved FEBE in the register
        if (.not.register%saved_febe(j)%defined) cycle
        if (register%saved_febe(j)%id.ne.i) cycle
        dband=register%saved_febe(j)%rectune%iband
        dbandname=recdesc%bandname(dband)
        call register%saved_febe(j)%pfx%getmode(dmodename,error)
        if (error) return
        dfreq=register%saved_febe(j)%rectune%frest*ghzpermhz ! displayed freq in GHz
        found=.true.
        exit ! quit loop when found
      enddo
      if (found) then
        write (mess,'(a,i0.0,1x,a,1x,f0.3,1x,a,1x,a)') &
            'Saved #',i,trim(dbandname),dfreq,'GHz - PFX Mode:',trim(dmodename)
      else
        write (mess,'(a,i0.0,1x,a)')  'Saved #',i,'not defined'
      endif
      call astro_message(seve%r,rname,mess)
    enddo
    !
  end subroutine register_list
  !
  subroutine register_load_febe(register,il,setup,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! copy one setup from the register to the current one
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: il
    type(noema_febe_t), intent(inout) :: setup
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>LOAD'
    character(len=256) :: mess
    integer(kind=4) :: i,idx,isel,iu
    !
    ! Get the idx
    idx=0
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.il) cycle
      idx=i
      exit
    enddo
    if (idx.eq.0) then
      call astro_message(seve%e,rname,'The setup to load is not found')
      error=.true.
      return
    endif
    if (.not.register%saved_febe(idx)%defined) then
      call astro_message(seve%e,rname,'The setup to load is not defined')
      error=.true.
      return
    endif
    setup=register%saved_febe(idx)
    setup%id=register%saved_febe(idx)%id
    setup%name='LOADED'
    setup%loaded=.true.
    !
    ! After load, do a baseband selection (take all) so that user can define SPW
    isel=0
    do iu=1,setup%pfx%n_units
      isel=isel+1
      setup%i_f%selunit%usel(isel)=iu
    enddo
    setup%i_f%selunit%n_ifsel=isel
    setup%i_f%selunit%polmode='B'
    !
    write (mess,'(a,1x,i0.0,1x,a)') 'Setup',il,'loaded to current'
    call astro_message(seve%i,rname,mess)
    !
  end subroutine register_load_febe
  !
  subroutine register_remove_febe(register,ir,error)
    use gbl_message
    !-----------------------------------------------------------------------
    ! remove 1 tuning from the register
    !-----------------------------------------------------------------------
    class(noema_febe_register_t), intent(inout) :: register
    integer(kind=4), intent(in) :: ir  ! febe to remove
    logical, intent(inout) :: error
    ! local
    character(len=*), parameter :: rname='FEBE>REMOVE'
    character(len=256) :: mess
    integer(kind=4) :: i,idx
    !
    ! Get the idx
    idx=0
    do i=1,register%m_saved
      if (register%saved_febe(i)%id.ne.ir) cycle
      idx=i
      exit
    enddo
    if (idx.eq.0) then
      call astro_message(seve%e,rname,'The setup to remove is not found')
      error=.true.
      return
    endif
    register%saved_febe(idx)%defined=.false.
    register%saved_febe(idx)%name='DELETED'
    register%n_saved=register%n_saved-1 ! n_saved is changed, N_index not to get a kind of history
    !
    write (mess,'(a,1x,i0.0,1x,a)') 'Setup',ir,'removed from saved list'
    call astro_message(seve%i,rname,mess)
    !
  end subroutine register_remove_febe
  !
end module astro_register_type

!
!--------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoDIYlist.f90">
!   <VERSION>
!                Id: modulePakoDIYlist.f90,v 1.3.0  2017-10-05    Hans Ungerechts  !! obsolete setPrivilege%GISMO
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-12-15    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-10-21    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-09-29    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-07-11    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2014-05-19    Hans Ungerechts  
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-11-06    Hans Ungerechts  !!  allow Lissajous segment without ramp
!                                                                                  !!  depending variable %doNextSubscan
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-10-29    Hans Ungerechts  !!  make next (new)subscan optional
!                                                                                  !!  depending variable %doNextSubscan
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-09-05    Hans Ungerechts  !!  internal ramp
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-25,26 Hans Ungerechts  !!  internal ramp
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-24,25 Hans Ungerechts  !!  ramp down
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-06-20,24 Hans Ungerechts  !!  very loose
!                Id: modulePakoDIYlist.f90,v 1.2.3  2013-05-02 Hans Ungerechts
!                Id: modulePakoDIYlist.f90,v 1.2.2  2013-02-08 Hans Ungerechts
!                Id: modulePakoDIYlist.f90,v 1.2.2  2013-01-24 Hans Ungerechts
!                based on:
!                Id: modulePakoDIYlist.f90,v 1.1.14 2012-11-20 Hans Ungerechts
!   </VERSION>
!   <HISTORY>
!                2010-04-08 HU: force safe limit on maximum elevation
!                          for GISMO run, based on TT-NCS           
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>

!   </SIBLINGS>        
!
!   Pako module for command: DIY SUBSCAN
!
! </DOCUMENTATION> <!-- name="modulePakoDIYlist.f90" -->
!
!--------------------------------------------------------------------------------
!
Module modulePakoDIYlist
  !
  Use modulePakoMessages
  Use modulePakoTypes
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
!!$  Use modulePakoSwBeam
!!$  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  !
  Public :: DIYlist
  Public :: Subscan
  Public :: saveSubscan
  Public :: saveDIYlist
  Public :: startDIYlist
  Public :: displayDIYlist
  Public :: listDIYlist
  Public :: plotDIYlist
  !     
  ! *** Variables for DIYlist ***
  Include 'inc/variables/variablesDIYlist.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine DIYlist(programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
!!OLD
!!OLD    Logical               :: isConnected   = .False.
!!OLD    Character (len=lenCh) :: bolometerName
!!OLD
!!OLD    Integer                :: iQuery
!!OLD    Character(len=lenCh)   :: nameQuery
!!OLD    Logical                :: isSet
!!OLD    Type(xyPointType)      :: pointResult
    !
    Include 'inc/ranges/rangesDIYlist.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module DIYlist, 1.2.3 2013-07-11 ---> SR: DIYlist ")             ! trace execution
    !
    !D    Write (6,*) " module DIYlist ---> SR: DIYlist "
    !D    Write (6,*) "                          "
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 0,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    Call queryReceiver(rec%Bolo, isConnected, bolometerName = bolometerName)
    !
    !D     Write (6,*) "      rec%Bolo, isConnected: ", rec%Bolo, isConnected
    !D     Write (6,*) "      bolometerName:         ", bolometerName
    !D     Write (6,*) "      bolo%NIKA:             ", bolo%NIKA
    !
    If (   .Not.                                                                 &
         & (                                                                     &
!!$         &       GV%privilege.Eq.setPrivilege%GISMO                              &
         &       GV%privilege.Eq.setPrivilege%ncsTeam                            &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%GISMO                     &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%NIKA                      &
         & )    ) Then                                                           !
       ERROR = .True.
       Write (messageText, *) " requires privilege"
       Call pakoMessage(priorityE,severityE,command,                             &
            &           messageText)                                             !
    End If
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/options/readOptionsDIYlist.inc'
    End If
    !
    ! *** set defaults ***
    Include 'inc/options/optionDefaults.inc'
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/options/readOptionsDIYlist.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    !D     Write (6,*) "      vars(iIn)%hasPurpose:   ", vars(iIn)%hasPurpose
    !D     Write (6,*) "      vars(iIn)%purpose:    ->", vars(iIn)%purpose,     "<-"
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then
       !
       errorInconsistent = .False.
       !
    End If
    !
    If (.Not. errorInconsistent) Then
       vars(iTemp) = vars(iIn)
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)    = vars(iTemp)
    End If
    !
    !D     Write (6,*) "      vars(iValue)%hasPurpose:   ", vars(iValue)%hasPurpose
    !D     Write (6,*) "      vars(iValue)%purpose:    ->", vars(iValue)%purpose,     "<-"
    !
    If (.Not.error) Then
       GV%observingMode     = OM%DIY
       GV%observingModePako = OMpako%DIY
       GV%purpose           = vars(iValue)%purpose
       GV%purposeIsSet      = vars(iValue)%hasPurpose
       !D        Write (6,*) "   GV%observingMode:     ", GV%observingMode
       !D        Write (6,*) "   GV%observingModePako: ", GV%observingModePako
       !D        Write (6,*) "   GV%purposeIsSet:   ", GV%purposeIsSet
       !D        Write (6,*) "   GV%purpose:      ->", GV%purpose, "<-"
    End If
    !
!!$!!OLD    !
!!$!!OLD    ! *** set "selected" observing mode & plot ***
!!$!!OLD    If (.Not.error) Then
!!$!!OLD       GV%observingMode     = OM%DIYlist
!!$!!OLD       GV%observingModePako = OMpako%DIYlist
!!$!!OLD       GV%omSystemName      = vars(iValue)%systemName 
!!$!!OLD       GV%notReadySWafterOM = .False.
!!$!!OLD       GV%notReadySecondaryRafterOM = .False.
!!$!!OLD       !D       Write (6,*) '      GV%notReadySecondaryRafterOM: ',                       &
!!$!!OLD       !D            &             GV%notReadySecondaryRafterOM
!!$!!OLD       GV%notReadyOffsetsAfterDIYlist  = .False.
!!$!!OLD       GV%notReadyDIYlist     = .False.
!!$!!OLD       DIYlistCommand         = line(1:lenc(line))
!!$!!OLD       Call analyzeDIYlist (errorA)
!!$!!OLD       Call listSegmentList (errorA)
!!$!!OLD       Call plotOMDIYlist (errorP)
!!$!!OLD    End If
!!$    !
!!$!!OLD    Call printSegmentList (error)
    !
    Call getCountSegments(nSegments)
    !
    ! *** display values ***
    ! 
    If (.Not. ERROR) Then
       Call displayDIYlist
       Call listDIYlist (error)
       Call plotDIYlist (error)
    End If
    !
    Return
  End Subroutine DIYlist
!!!
!!!
  Subroutine Subscan(programName, line, command, error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    ! *** special working variables:   ***
    Logical               :: optionSpeedIsPresent, optionTotfIsPresent
    Logical, Dimension(3) :: alternative
    Real                  :: vIn, vStdMin, vStdMax, vLimitMin, vLimitMax
    !
    Real                  :: vLissMaxX,   vLissMaxY,   aLissMaxX,   aLissMaxY,   vLissLimit, aLissLimit
    Real                  :: vLissFacX,   vLissFacY,   aLissFacX,   aLissFacY
    Real                  :: vLissMaxXel, vLissMaxYel, aLissMaxXel, aLissMaxYel, lissMaxEl
    !
    Real                  :: vMaxX,   vMaxY,   vLimit
    Real                  ::                                     vLimitAz, vLimitEl
    Real                  :: vMaxXel, vMaxYel, MaxEl
    !
    Character(len=lenCh)   ::  sysName  = GPnone
    !
!!OLD    Type(conditionMinMax)  ::  condElevation                                         &
!!OLD         &                     = conditionMinMax("elevation",                        &
!!OLD         &                                        0.0, Pi/2.0,                       &
!!OLD         &                                       "rad",                              &
!!OLD         &                                       .False.         )                   ! 
    !
    Integer               :: iErr
    !
    optionSpeedIsPresent = .False.
    optionTotfIsPresent  = .False.
    alternative          = .False.
    !
    Include 'inc/ranges/rangesDIYlist.inc'
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module DIYlist, 1.2.3 2013-06-25 ---> SR: Subscan ")             ! trace execution
    !
    !D     Write (6,*) " module DIYlist ---> SR: Subscan "
    !D     Write (6,*) "                          "
    !
    ! *** initialize ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    !     read Parameters, Options (to detect errors)            
    !     and check for validity and ranges                      
    Call checkNofParameters(command,                                             &
         &     0, 8,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    Call queryReceiver(rec%Bolo, isConnected, bolometerName = bolometerName)
    !
    If (   .Not.                                                                 &
         & (                                                                     &
!!$         &       GV%privilege.Eq.setPrivilege%GISMO                              &
         &       GV%privilege.Eq.setPrivilege%ncsTeam                            &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%GISMO                     &
         &  .Or. isConnected.And.bolometerName.Eq.bolo%NIKA                      &
         & )    ) Then                                                           !
       ERROR = .True.
       Write (messageText, *) " requires privilege"
       Call pakoMessage(priorityE,severityE,command,                             &
            &           messageText)                                             !
    End If
    !
    ! *** check for alternative Options   ***
    If (.Not. ERROR) Then
       Include 'inc/options/alternativeSpeedTotf.inc'
    End If
    !
    Include 'inc/options/optionSubscanType.inc'
    !
    !D     Write (6,*) "   after optionSubscanType: "
    !D     Write (6,*) "         vars(iIn)%doTrack         ", vars(iIn)%doTrack        
    !D     Write (6,*) "         vars(iIn)%doLinearOtf     ", vars(iIn)%doLinearOtf    
    !D     Write (6,*) "         vars(iIn)%doLissajousOtf  ", vars(iIn)%doLissajousOtf 
    !D     Write (6,*) "         vars(iIn)%segType         ", vars(iIn)%segType
    !D     !
    !D     Write (6,*) "      nArguments: ", nArguments
    !D     Write (6,*) " "
    !
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersSegment.inc'
       Include 'inc/options/readOptionsSubscan.inc'
    End If
    !
    ! *** set defaults ***
    Include 'inc/options/optionDefaults.inc'
    !
    ! *** read Parameters, Options (again, after defaults!) ***
    !     and check for validity and ranges 
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersSegment.inc'
       Include 'inc/options/readOptionsSubscan.inc'
       Include 'inc/options/alternativeSpeedTotfSet.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    !D     Write (6,*) "        -> vars(iIn)%doTune:   ", vars(iIn)%doTune
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.error) Then                                                           !! check consistency
       !
       !! condition for linear OTF, compare POINTING, OTFAMP. <-- 2012-10-30
       !
       errorInconsistent = .False.
       !
       !D        Write (6,*) "              vars(iIn)%doTrack:         ", vars(iIn)%doTrack
       !D        Write (6,*) "              vars(iIn)%doLinearOtf:     ", vars(iIn)%doLinearOtf
       !D        Write (6,*) "              vars(iIn)%doLissajousOtf:  ", vars(iIn)%doLissajousOtf
       !D        Write (6,*) "              vars(iIn)%doTune:          ", vars(iIn)%doTune
       !
       If      (      (vars(iIn)%doLinearOtf .Or. vars(iIn)%doLissajousOtf)      &
            &    .And. vars(iIn)%doTune                                          &
            &  ) Then                                                            !
          !
          errorInconsistent = .True.
          !
          Write (messageText, *) "/Tune only works with track subscans "
          Call pakoMESSAGE(priorityE,severityE,command,messageText)
          !
       End If
       !
       If (vars(iIn)%doLissajousOtf) Then
          !
          vLissMaxX  =   vars(iIn)%xAmplitude*GV%angleUnit * vars(iIn)%omegaX
          vLissMaxY  =   vars(iIn)%yAmplitude*GV%angleUnit * vars(iIn)%omegay
          !
          aLissMaxX  =   vars(iIn)%xAmplitude*GV%angleUnit * vars(iIn)%omegaX**2
          aLissMaxY  =   vars(iIn)%yAmplitude*GV%angleUnit * vars(iIn)%omegay**2
          !
          vLissLimit = 300.0*arcsec
          aLissLimit = 108.0*arcsec
          !
          !D           Write (6,*) "      vLissMaxX:  ", vLissMaxX
          !D           Write (6,*) "      vLissMaxY:  ", vLissMaxY
          !D           Write (6,*) "      aLissMaxX:  ", aLissMaxX
          !D           Write (6,*) "      aLissMaxY:  ", aLissMaxY
          !D           Write (6,*) "      vLissLimit: ", vLissLimit
          !D           Write (6,*) "      aLissLimit: ", aLissLimit
          !
          vLissFacX  = vLissMaxX/vLissLimit
          vLissFacY  = vLissMaxY/vLissLimit
          aLissFacX  = aLissMaxX/aLissLimit
          aLissFacY  = aLissMaxY/aLissLimit
          !
          !!          vLissLimit = Min(vLissLimit,300.0*arcsec)
          !!          aLissLimit = Min(aLissLimit,108.0*arcsec)
          !
          If (vLissMaxX.Gt.vLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("x max. speed = xAmplitude [",    F12.1,                  &
                  &    " ] * frequencyX [",            F12.4,                    &
                  &    " ] is too large by factor: ",  F12.3 )' )                &
                  & vars(iIn)%xAmplitude,                                        &
                  & vars(iIn)%frequencyX,                                        &
                  & vLissFacX                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyX  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyX/(vLissFacX)                       !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (vLissMaxY.Gt.vLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("y max. speed = yAmplitude [",    F12.1,                  &
                  &    " ] * frequencyY [",            F12.4,                    &
                  &    " ] is too large by factor: ",  F12.3 )' )                &
                  & vars(iIn)%yAmplitude,                                        &
                  & vars(iIn)%frequencyY,                                        &
                  & vLissFacY                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyY  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyY/(vLissFacY)                       !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (aLissMaxX.Gt.aLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("x max. acceleration = xAmplitude [",  F12.1,             &
                  &    " ] * frequencyX [",                 F12.4,               &
                  &    " ] ^2 is too large by factor: ",    F12.3 )' )           &
                  & vars(iIn)%xAmplitude,                                        &
                  & vars(iIn)%frequencyX,                                        &
                  & aLissFacX                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyX  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyX/sqrt(aLissFacX)                   !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          If (aLissMaxY.Gt.aLissLimit) Then
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("y max. acceleration = yAmplitude [",  F12.1,             &
                  &    " ] * frequencyY [",                 F12.4,               &
                  &    " ] ^2 is too large by factor ",     F12.3 )' )           &
                  & vars(iIn)%yAmplitude,                                        &
                  & vars(iIn)%frequencyY,                                        &
                  & aLissFacY                                                    !
             Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("to correct his, try: frequencyY  ", F12.4                &
                  &                                          )' )                &
                  & 0.999*vars(iIn)%frequencyY/sqrt(aLissFacY)                   !
             Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
             errorInconsistent = .True.
          End If
          !
          !D   Write (6,*) "   vars(iIn)%doRampUp   ", vars(iIn)%doRampUp
          !D   Write (6,*) "   vars(iIn)%doRampDown ", vars(iIn)%doRampDown
          !
          If (.Not.vars(iIn)%doRampUp) Then
             Write (messageText,*) "/ramp up [tRamp] is RECOMMENDED for Lissajous"
             Call pakoMESSAGE(priorityW,severityW,"SUBSCAN",messageText)
!!$             errorInconsistent = .True.
          End If
!!$          If (.Not.vars(iIn)%doRampUp) Then
!!$             Write (messageText,*) "/ramp up [tRamp] is REQUIRED for Lissajous"
!!$             Call pakoMESSAGE(priorityE,severityE,"SUBSCAN",messageText)
!!$             errorInconsistent = .True.
!!$          End If
          !
          !  ** calculate maximum allowed elevation:
          !
          If (.Not.errorInconsistent) Then
             !
             vLissMaxXel = Acos(vLissMaxX/(2*vLissLimit))
             vLissMaxYel = Acos(vLissMaxY/(2*vLissLimit))
             !
             aLissMaxXel = Acos(aLissMaxX/(2*aLissLimit))  
             aLissMaxYel = Acos(aLissMaxY/(2*aLissLimit))  
             !
             If (         vars(iIn)%systemName.Eq.offsPako%tru                   &
                  &  .Or. vars(iIn)%systemName.Eq.offsPako%hor) Then             !
                lissMaxEl   = min(vLissMaxXel,aLissMaxXel)                         !! use only "x" offsets (Azimuth) for el. condition
             Else
                lissMaxEl   = min(vLissMaxXel,vLissMaxYel,                       &
                     &            aLissMaxXel,aLissMaxYel)                       !
             End If
             !
             !D              Write (6,*) " max el vLissMaxXel: ", vLissMaxXel/deg
             !D              Write (6,*) " max el vLissMaxYel: ", vLissMaxYel/deg
             !D              Write (6,*) " max el aLissMaxXel: ", aLissMaxXel/deg
             !D              Write (6,*) " max el aLissMaxYel: ", aLissMaxYel/deg
             !                                                                            
             !D              Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
             !
             ! 2010-04-08 HU: force safe limit on maximum elevation
             !                for GISMO run, based on TT-NCS
!!OLD             If      (GV%limitCheck.eq.setLimitCheck%loose) Then                 !! loose:   beyond limits for good tracking
!!OLD                lissMaxEl = lissMaxEl+5.0*deg
!!OLD             Else 
!!OLD             If (GV%limitCheck.eq.setLimitCheck%relaxed) Then                    !! relaxed: limits for good tracking
!!OLD                lissMaxEl = lissMaxEl
!!OLD             Else                                                                !! strict:  safe
             lissMaxEl = lissMaxEl-2.0*deg
!!OLD             End If
             !
             lissMaxEl   = min(lissMaxEl,85.0*deg)
             !D              Write (6,*) "  "
             !D              Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
             !
             !!             If (lissMaxEl.Ge.60.0*deg) Then
             !
             If (condElevation%isSet) Then                                         !! maximum elevation: minimum over subsans
                condElevation%maximum   = min(condElevation%maximum,lissMaxEl)
             Else
                condElevation%isSet     = .True.
                condElevation%maximum   = lissMaxEl
             End If
             !
             !D  Write (6,*) " condElevation%isSet:   ", condElevation%isSet
             !D  Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
             !
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("WARNING--CONDITION: Elevation must be less than ",       &
                  &     F10.2,                                                   &
                  &    " [deg] ")' )                                             &
                  & condElevation%maximum/deg                                    !
             Call pakoMESSAGE(priorityE+4,severityW,"DIY-SUBSCAN",messageText)
             !
          End If
             !
       End If   !!   vars(iIn)%doLissajousOtf
       !
       !
    End If   !!   .Not.error
    !
    If (.Not. errorInconsistent) Then
       vars(iTemp) = vars(iIn)
    End If
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** conclude alternative options   ***
    If (.Not.error) Then
       Include 'inc/options/alternativeSpeedTotfEnd.inc'
    End If
    !
    !D     Write (6,*) "   after alternativeSpeedTotfEnd.inc: "
    !D     Write (6,*) "         vars(iTemp)%doTrack         ", vars(iTemp)%doTrack        
    !D     Write (6,*) "         vars(iTemp)%doLinearOtf     ", vars(iTemp)%doLinearOtf    
    !D     Write (6,*) "         vars(iTemp)%doLissajousOtf  ", vars(iTemp)%doLissajousOtf 
    !D     Write (6,*) "         vars(iTemp)%segType         ", vars(iTemp)%segType
    !
    If (.Not. error) Then
       !
       errorInconsistent = .False.
       !
       If (vars(iIn)%doLinearOtf) Then
          !
          !D Write (6,*) "         -> will determine conditions for Linear OTF "
          !
          !! --> 2012-03-25:
          !
          If (         vars(iTemp)%systemName.Eq.offsPako%tru                    &
               &  .Or. vars(iTemp)%systemName.Eq.offsPako%hor) Then              !
             !
             vMaxX  =   Abs(vars(iTemp)%pEnd%x-vars(iTemp)%pStart%x)             &
                  &        /vars(iTemp)%tOtf                                     !
             vMaxY  =   Abs(vars(iTemp)%pEnd%y-vars(iTemp)%pStart%y)             &
                  &        /vars(iTemp)%tOtf                                     !
             !
          Else
             vMaxX  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
             vMaxY  =   max(vars(iTemp)%speedStart, vars(iTemp)%speedEnd)
          End If
          !
          !! NOTE:  code from here --> copied on 2012-05-30 from OTFMAP (2012-03-28)
          !! TBD:   extract this code, also use in OTFMAP, SUBSCAN OTF LINEAR
          !!        --> define / use local variable sysName in OTFMAP, SUBSCAN OTF LINEAR
          !! TBD:   long-term: ramp-up!
          !                        !!  speed limit az. axis, el. axis
          vLimit   = 200.0         !!  based on tests 2012-03-15 to -20
          !                                 
          !
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     &
               &  .Or.  GV%userLevel.Eq.setUserLevel%experienced                 &
               &  ) Then                                                         !
             If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit = 220.0
          End If
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     &
               &  ) Then                                                         !
             If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit = 1200.0           !!  for tests 2013
!!normal:    If (GV%limitCheck.Eq.setLimitCheck%loose)   vLimit =  300.0           !!  normal
             If (GV%limitCheck.Eq.setLimitCheck%relaxed) vLimit =  220.0
          End If
          !
          vLimitAz = vLimit        !!  speed limit az axis
          vLimitEl = vLimit        !!  speed limit el axis
          !
          !! aLimit = 108.0*arcsec
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " vMaxX:     ", vMaxX
             Write (6,*) " vMaxY:     ", vMaxY
             Write (6,*) " vLimit:    ", vLimit
             Write (6,*) " vLimitAz:  ", vLimitAz
             Write (6,*) " vLimitEl:  ", vLimitEl
          End If
          !
          sysName = vars(iTemp)%systemName
          !
          !! NOTE: using local variable sysName instead of vars(iTemp)%systemName:
          If (         sysName.Eq.offsPako%tru                                   &  
               &  .Or. sysName.Eq.offsPako%hor) Then                             !
             !
             If (vMaxX.Le.vLimitAz) Then
                vMaxXel = Acos(vMaxX/(vLimitAz))
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Azimuth speed ", vMaxX,                   &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
             If (vMaxY.Le.vLimitEl) Then
                vMaxYel = 90.0*deg
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Elevation speed ", vMaxY,                 &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
          Else
             !
             If (vMaxX.Le.vLimit .And. vMaxY.Le.vLimit) Then
                vMaxXel = Acos(vMaxX/(vLimit))
                vMaxYel = Acos(vMaxY/(vLimit))
             Else
                errorInconsistent = .true.
                Write (messageText,*) "Speed ", max(vMaxX,vMaxY),                &
                     &                " too large for safe tracking"             !
                Call PakoMessage(priorityE,severityE,command,messageText)
             End If
             !
          End If
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " max el vMaxXel: ", vMaxXel/deg
             Write (6,*) " max el vMaxYel: ", vMaxYel/deg
          End If
          !
          !! <<-- 2012-03-25
          !
          !! aMaxXel = Acos(aMaxX/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
          !! aMaxYel = Acos(aMaxY/(2*aLimit))  ! <-- corrected aLimit on 2010-03-18 
          !
          !D           Write (6,*) " max el  MaxEl:  ", MaxEl/deg
          !
          ! 2010-04-08 HU: force safe limit on maximum elevation
          !                for GISMO run, based on TT-NCS
          !
          If      (     GV%privilege.Eq.setPrivilege%ncsTeam                     & !! very loose for tests 2013
               &   .And.                                                         &
               &        GV%limitCheck.Eq.setLimitCheck%loose) Then               !
             !
             MaxEl  =  min(vMaxXel,vMaxYel)
             MaxEl  =  MaxEl-0.0*deg
             MaxEl  =  max(0.0*deg,MaxEl) 
             MaxEl  =  min(MaxEl,89.0*deg)
             !
          Else                                                                     !! normal limits
             !
             MaxEl = min(vMaxXel,vMaxYel)
             MaxEl  =  MaxEl-2.0*deg
             MaxEl  =  max(0.0*deg,MaxEl) 
             MaxEl  =  min(MaxEl,85.0*deg)
             !
          End If
          !
          Write (6,*) " max el  MaxEl:  ", MaxEl/deg
          !
          !
          !!             If (MaxEl.Ge.60.0*deg) Then
          !
          If (condElevation%isSet) Then                                            !! maximum elevation: minimum over subsans
             condElevation%maximum   = min(condElevation%maximum,MaxEl)
          Else
             condElevation%isSet     = .True.
             condElevation%maximum   = MaxEl
          End If
          !
          If (GV%doDebugMessages) Then
             Write (6,*) " condElevation%isSet:   ", condElevation%isSet
             Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
          End If
          !
          !! NOTE =: <-- copied on 2012-05-30 from OTFMAP (2012-03-28)
          !
          Write (messageText, fmt =                                              &
               &  '("WARNING--CONDITION: Elevation must be less than ",          &
               &     F10.2,                                                      &
               &    " [deg] ")' )                                                &
               & condElevation%maximum/deg                                       !
          Call pakoMESSAGE(priorityE+4,severityW,"POINTING",messageText)
          !
       End If   !!   vars(iIn)%doLinearOtf
       !
    End If   !!   .Not. error
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)    = vars(iTemp)
    End If
    !
    !D     Write (6,*) "        -> vars(iValue)%doTune:   ", vars(iValue)%doTune
    !
    ! *** display values ***
    ! 
    ! *** 
    If (.Not.error) Then
       !
       If (vars(iValue)%doLinearOtf) Then
          If (vars(iValue)%doRampUp) Then
             Write (messageText,*)  "Up ", vars(iValue)%tRampUp, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (vars(iValue)%doRampDown) Then
             Write (messageText,*)  "Down ", vars(iValue)%tRampDown, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (.Not.(vars(iValue)%doRampUp.Or.vars(iValue)%doRampDown)) Then
             Write (messageText,*)  ramp%none
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
       End If
       !
       If (vars(iValue)%doLissajousOtf) Then
          If (vars(iValue)%doRampUp) Then
             Write (messageText,*)  "Up ", vars(iValue)%tRampUp, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (vars(iValue)%doRampDown) Then
             Write (messageText,*)  "Down ", vars(iValue)%tRampDown, " [sec]"
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
          If (.Not.(vars(iValue)%doRampUp.Or.vars(iValue)%doRampDown)) Then
             Write (messageText,*)  ramp%none
             Call pakoMessage(priorityI,severityI,command//"/"//"RAMP",messageText)    
          End If
       End If
       !
       GV%condElevation     = condElevation
       !D        Write (6,*) "GV%condElevation: ", GV%condElevation
       !
       GV%omSystemName      = vars(iValue)%systemName 
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       SubscanCommand         = line(1:lenc(line))
       Call analyzeSubscan (errorA)
       error = error.Or.errorA
    End If
    !
    If (.Not. error) Then
       Call displaySubscan
    End If
    !
    Return
  End Subroutine Subscan
!!!
!!!
  Subroutine analyzeSubscan (errorA)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: nScan 
    Character (len=lenCh)  :: aUnit, sUnit
    Integer                :: iSS           = 0     ! counts subcans/segment
    !
    Integer                :: iQuery
    Character(len=lenCh)   :: nameQuery
    Logical                :: isSet
    Type(xyPointType)      :: pointResult
    !
    Real                   :: delta = 0.1499850     !!
    !
    Integer                :: nSub, nSeg
    !
    errorA    = .False.
    !
!!$    Call pako_message(seve%t,'paKo',                                             &
!!$         &    " module DIYlist, 1.2.2 2013-01-22 ---> SR: analyzeSubscan ")      ! trace execution
!!$    Call pako_message(seve%t,'paKo',                                             &
!!$         &    " module DIYlist, 1.2.3 2013-04-29 ---> SR: analyzeSubscan ")      ! trace execution
    Call pako_message(seve%t,'paKo',                                             &
         &    " module DIYlist, 1.2.3 2013-10-29 ---> SR: analyzeSubscan ")      ! trace execution
    !
    ii        = 0
    jj        = 0
    iSS       = 1
    nScan     = 1111
    aUnit     = GV%angleUnitC                        ! 
    sUnit     = GV%speedUnitC                        ! 
    !
    Call getCountSubscans(nSub)
    !D     Write (6,*) "     nSub:   ", nSub
    If (nSub.Ge.99) Then
       errorA    = .True.
       Write (messageText,*)  " too many subscans. maximum: ", 99
       Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
    End If
    !
    !D     Write (6,*) "     nLissajous:   ", nLissajous
    !
    Call getCountSegments(nSeg)
    !D     Write (6,*) "     nSeg:   ", nSeg
    !
    If (vars(iValue)%segType.Eq.seg%lissajous) Then
       !
       If (   .Not.                                                              &
            &      (     .False.                                                 &
!! Test     &       .Or. GV%privilege.Eq.setPrivilege%GISMO                      &
            &       .Or. GV%privilege.Eq.setPrivilege%ncsTeam                    &
            &      )                                                             &
            & .And.                                                              &
            &      nLissajous.Ge.1 ) Then                                        !
          errorA = .True.
          Write (messageText, *)                                                 &
               &       "more than 1 Lissajous subscan requires privilege"        !
          Call pakoMessage(priorityE,severityE,"Subscan",messageText)
          Write (messageText, *)                                                 &
               &       "enter DIY /CLEAR first "                                 !
          Call pakoMessage(priorityI,severityI,"Subscan",messageText)
       End If
       !
       If (nSegments.Ge.99-1) Then   !!  99-1 because Lissajous makes 2 segments
          errorA    = .True.
          Write (messageText,*)  " too many segments. maximum: ", 99
          Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
       End If
       !
    Else
       ! 
       If (nSegments.Ge.99) Then
          errorA    = .True.
          Write (messageText,*)  " too many segments. maximum: ", 99
          Call pakoMESSAGE(priorityE,severityE,"Subscan",messageText)
       End If
       !
    End If
    !
    If (vars(iValue)%segType.Eq.seg%linear) Then
       !
       If (   .Not.                                                              &
            &      (     .False.                                                 &
!!OLD       &       .Or. GV%privilege.Eq.setPrivilege%GISMO                      &
            &       .Or. GV%privilege.Eq.setPrivilege%ncsTeam                    &
            &       .Or. isConnected.And.bolometerName.Eq.bolo%NIKA              &
!!OLD       &       .Or. GV%privilege.Eq.setPrivilege%staff                      &
            &      )                                                             &
            &      ) Then                                                        !
          errorA = .True.
          Write (messageText, *)                                                 &
               &       ss%otf , " ", seg%linear, " subscan requires privilege"   !
          Call pakoMessage(priorityE,severityE,"Subscan",messageText)
       End If
       !
    End If
    !
    If (.Not. errorA) Then
       !
       !!  ** 
       Call countSubscans(ii)
!!$       Call countSegments(jj)
       !
       !D        Write (6,*) "       ii: ", ii
       !D        Write (6,*) "       jj: ", jj
       !D        Write (6,*) "  segType: ", vars(iValue)%segType
       !
       ! TBD: calibrate subscans 
       !
       ! TBD: segment parameters to defaults
       !
       If (vars(iValue)%segType.Eq.seg%track) Then
          !
          Call countSegments(jj)
          !
          segList(jj)%newSubscan =  .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%track
          segList(jj)%segType    =  seg%track
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%flagTune      =  vars(iIn)%doTune
          !
          segList(jj)%pStart     =  vars(iValue)%offset
          segList(jj)%pEnd       =  segList(jj)%pStart
          segList(jj)%speedStart =  0.0
          segList(jj)%speedEnd   =  0.0
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'tSegment'
          segList(jj)%tSegment   =  vars(iValue)%tSubscan
          segList(jj)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
          If (jj.Eq.1) Then
             segList(jj)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(jj)%pDoppler      = vars(iValue)%offset
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)        !  TBD: this is only a quick fix
             Else
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(jj)%pDoppler      = pointResult
             End If
          Else If (GV%doDopplerUpdates) Then
             segList(jj)%updateDoppler = .True.
             If (vars(iValue)%systemName.Eq.offs%pro) Then
                segList(jj)%pDoppler      = vars(iValue)%offset
             Else
                segList(jj)%pDoppler      = xyPointType(0.0,0.0)
             End If
             If (isSet .And. vars(iValue)%systemName.Ne.offs%pro) Then  !  OFFSETS /SYS PROJ
                segList(jj)%pDoppler      = pointResult
             End If
          End If
          !
          !D       Write (6,*) "jj, GV%doDopplerUpdates:  ", jj, GV%doDopplerUpdates
          !D       Write (6,*) "jj, segList(jj)%pDoppler: ", jj, segList(jj)%pDoppler
          !
       Else If (vars(iValue)%segType.Eq.seg%linear) Then
          !
          !D           Write (6,*) "      -> OTF linear "
          !
          If (vars(ivalue)%doRampUp) Then     !!     determine details for RampUp
             !
             !D              Write (6,*) " "
             !D              Write (6,*) "            doRampUp                  ", vars(ivalue)%doRampUp  
             !D              Write (6,*) "            tRampUp                   ", vars(ivalue)%tRampUp
             !D              Write (6,*) "            doInternal                ", vars(ivalue)%doInternal
             !D              !
             !D              Write (6,*) "            vars(iValue)%pStart       ", vars(iValue)%pStart 
             !D              Write (6,*) "            vars(iValue)%pEnd         ", vars(iValue)%pEnd      
             !D              Write (6,*) "            vars(iValue)%lengthOtf    ", vars(iValue)%lengthOtf
             !D              Write (6,*) "            vars(iValue)%speedStart   ", vars(iValue)%speedStart 
             !
             pStart = vars(iValue)%pStart
             vStart%x = vars(iValue)%speedStart                                  &
                  &        * (vars(iValue)%pEnd%x-vars(iValue)%pStart%x)         &
                  &        / vars(iValue)%lengthOtf                              !
             vStart%y = vars(iValue)%speedStart                                  &
                  &        * (vars(iValue)%pEnd%y-vars(iValue)%pStart%y)         &
                  &        / vars(iValue)%lengthOtf                              !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             !D              Write (6,*) "            pStart    ", pStart
             !D              Write (6,*) "            vStart    ", vStart
             !
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D                 Write (6,*) "             tAccel:    ", tAccel,                  &
                !D                      &      " will be increased to ", vars(ivalue)%tRampUp       !
                tAccel = vars(ivalue)%tRampUp
             End If
             !
!!$             If (tAccel.Lt.5) Then
!!$                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
!!$                tAccel = 5
!!$             End If
             !
             If (vars(ivalue)%doInternal) Then 
                pAccel%x = pStart%x +0.5*vstart%x*tAccel
                pAccel%y = pStart%y +0.5*vstart%y*tAccel
             Else
                pAccel%x = pStart%x -0.5*vstart%x*tAccel
                pAccel%y = pStart%y -0.5*vstart%y*tAccel
             End If
             !
             !D              Write (6,*) "            tAccel   ", tAccel
             !D              Write (6,*) "            pAccel   ", pAccel
             !
             lAccel = sqrt((pStart%x-pAccel%x)**2 + (pStart%y-pAccel%y)**2 )
             !
             !D              Write (6,*) "            lAccel   ", lAccel
             !
          End If     !!     (vars(ivalue)%doRampUp) 
          !
          If (vars(ivalue)%doRampDown) Then     !!     determine details for RampDown
             !
             !D              Write (6,*) " "
             !D              Write (6,*) "            doRampDown                ", vars(ivalue)%doRampDown  
             !D              Write (6,*) "            tRampDown                 ", vars(ivalue)%tRampDown
             !D              Write (6,*) "            doInternal                ", vars(ivalue)%doInternal
             !D              !
             !D              Write (6,*) "            vars(iValue)%pStart       ", vars(iValue)%pStart 
             !D              Write (6,*) "            vars(iValue)%pEnd         ", vars(iValue)%pEnd      
             !D              Write (6,*) "            vars(iValue)%lengthOtf    ", vars(iValue)%lengthOtf
             !D              Write (6,*) "            vars(iValue)%speedEnd     ", vars(iValue)%speedEnd 
             !
             pEnd = vars(iValue)%pEnd
             vEnd%x = vars(iValue)%speedEnd                                      &
                  &        * (vars(iValue)%pEnd%x-vars(iValue)%pStart%x)         &
                  &        / vars(iValue)%lengthOtf                              !
             vEnd%y = vars(iValue)%speedEnd                                      &
                  &        * (vars(iValue)%pEnd%y-vars(iValue)%pStart%y)         &
                  &        / vars(iValue)%lengthOtf                              !
             vEnd%speed = sqrt(vEnd%x**2+vEnd%y**2)
             !
             !D              Write (6,*) "            pEnd    ", pEnd
             !D              Write (6,*) "            vEnd    ", vEnd
             !
             !
             accelMax = 0.03*degree                                      !  maximum aceleration in [rad/s^2]
             tStop   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tStop.Lt.vars(ivalue)%tRampDown) Then
                !D                 Write (6,*) "             tStop:    ", tStop,                    &
                !D                      &      " will be increased to ", vars(ivalue)%tRampDown     !
                tStop = vars(ivalue)%tRampDown
             End If
             !
!!$             If (tStop.Lt.5) Then
!!$                !D              Write (6,*) "             tStop:    ", tStop, " will be increased to 5 [sec]"
!!$                tStop = 5
!!$             End If
             !
             If (vars(ivalue)%doInternal) Then 
                pStop%x = pEnd%x -0.5*vEnd%x*tStop
                pStop%y = pEnd%y -0.5*vEnd%y*tStop
             Else
                pStop%x = pEnd%x +0.5*vEnd%x*tStop
                pStop%y = pEnd%y +0.5*vEnd%y*tStop
             End If
             !
             !D              Write (6,*) "            tStop   ", tStop
             !D              Write (6,*) "            pStop   ", pStop
             !
             lStop = sqrt((pEnd%x-pStop%x)**2 + (pEnd%y-pStop%y)**2 )
             !
             !D              Write (6,*) "            lStop   ", lStop
             !
          End If     !!     vars(ivalue)%doRampDown)
          !
          !
          If (vars(ivalue)%doRampUp) Then     !!     add RampUp to segment list
             !
             Call countSegments(jj)
             !
             If (jj.Eq.1) Then
                segList(jj)%newSubscan =  .True.                                 
             Else 
                If (vars(ivalue)%doNextSubscan) Then
                   segList(jj)%newSubscan =  .True.                              
                Else
                   segList(jj)%newSubscan =  .False.                             
                End If
             End If
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      "
                Write (6,*) "      jj :                         ", jj
                Write (6,*) "      vars(ivalue)%doRampUp :      ", vars(ivalue)%doRampUp
                Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
                Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
                Write (6,*) "      "
             End If
             !
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  lAccel
             !
             If (vars(ivalue)%doInternal) Then
                segList(jj)%pStart     =  vars(iValue)%pStart
                segList(jj)%pEnd       =  pAccel 
             Else
                segList(jj)%pStart     =  pAccel
                segList(jj)%pEnd       =  vars(iValue)%pStart
             End If
             !
             segList(jj)%speedStart =  0.0
             segList(jj)%speedEnd   =  1.0001*vStart%speed      !!  IMPORTANT: needed to get smoothly "into" linear OTF ??
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tAccel
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    (vars(ivalue)%doRampUp)
          !
          !                              !!     add OTF segment to list
          Call countSegments(jj)
          !
          If (vars(ivalue)%doRampUp) Then                                        
             segList(jj)%newSubscan =  .False.                                   
          Else                                                                   
             If (vars(ivalue)%doNextSubscan) Then
                segList(jj)%newSubscan =  .True.                              
             Else
                segList(jj)%newSubscan =  .False.                             
             End If
          End If                                                                 
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "      "
             Write (6,*) "      jj :                         ", jj
             Write (6,*) "      vars(ivalue)%doRampUp :      ", vars(ivalue)%doRampUp
             Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
             Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
             Write (6,*) "      "
          End If
          !
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%otf
          segList(jj)%segType    =  seg%linear
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%pStart     =  vars(iValue)%pStart
          segList(jj)%pEnd       =  vars(iValue)%pEnd
          !
          segList(jj)%tSegment   =  vars(iValue)%tOtf
          !
          If ( vars(ivalue)%doRampUp .And. vars(ivalue)%doInternal ) Then
             segList(jj)%pStart     =  pAccel
!!$             segList(jj)%tSegment   =  segList(jj)%tSegment-tAccel
          End If
          !
          If ( vars(ivalue)%doRampDown .And. vars(ivalue)%doInternal ) Then
             segList(jj)%pEnd       =  pStop
!!$             segList(jj)%tSegment   =  segList(jj)%tSegment-tStop
          End If
          !
          segList(jj)%lengthOtf  =  sqrt(                                        &
               &                 (segList(jj)%pEnd%x-segList(jj)%pStart%x)**2    &
               &               + (segList(jj)%pEnd%y-segList(jj)%pStart%y)**2    &
               &                        )                                        !
          segList(jj)%speedStart =  vars(iValue)%speedStart
          segList(jj)%speedEnd   =  vars(iValue)%speedEnd
          segList(jj)%tSegment   =  segList(jj)%lengthOtf /                      &
               &         (0.5 * (segList(jj)%speedStart+segList(jj)%speedEnd) )  !
          !
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'TOTF'
          segList(jj)%tRecord    =  0.1
          !
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
          !
          If (vars(ivalue)%doRampDown) Then     !!     add RampDown to segment list
             !
             Call countSegments(jj)
             !
             segList(jj)%newSubscan =  .False.
             !
             If (GV%doDebugMessages) Then
                Write (6,*) "      "
                Write (6,*) "      jj :                         ", jj
                Write (6,*) "      vars(ivalue)%doRampDown :    ", vars(ivalue)%doRampDown
                Write (6,*) "      vars(ivalue)%doNextSubscan : ", vars(ivalue)%doNextSubscan
                Write (6,*) "      segList(jj)%newSubscan :     ", segList(jj)%newSubscan
                Write (6,*) "      "
             End If
             !
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  lStop
             !
             If (vars(ivalue)%doInternal) Then
                segList(jj)%pStart     =  pStop
                segList(jj)%pEnd       =  vars(iValue)%pEnd
             Else
                segList(jj)%pStart     =  vars(iValue)%pEnd
                segList(jj)%pEnd       =  pStop
             End If
             !
             segList(jj)%speedStart =  0.9999*vEnd%Speed        !!  IMPORTANT: needed to get smoothly "into" linear OTF ?? GUESS ??
             segList(jj)%speedEnd   =  0.0+delta                !!  do NOT slow down to 0.0 to avoid bug in antennaMD 
             !                                                  !!  cp TT NCS 2013-08-09 scans 167 168 169
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName  
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tStop
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    (vars(ivalue)%doRampDown)
          !
          !
       Else If (vars(iValue)%segType.Eq.seg%lissajous) Then
          !
          !D        Write (6,*) "      -> OTF Lissajous "
          !
          ! derived parameters positions in GV%angleUnit, speeds in GV%angleUnit/[s]
          ! derived parameters all other in [s], [rad], [rad/s], [rad/s^2]
          !
          !D        Write (6,*) "            doRampUp   ", vars(ivalue)%doRampUp
          !D        Write (6,*) "            doRampDown ", vars(ivalue)%doRampDown
          !
          If (vars(ivalue)%doRampUp) Then
             !
             !D           Write (6,*) "            tRampUp   ", vars(ivalue)%tRampUp
             !D           Write (6,*) "            tRampDown ", vars(ivalue)%tRampDown
             !
             pStart%x = vars(iValue)%pCenter%x + vars(iValue)%xAmplitude * sin(vars(iValue)%phiX)
             pStart%y = vars(iValue)%pCenter%y + vars(iValue)%yAmplitude * sin(vars(iValue)%phiY)
             vStart%x = vars(iValue)%omegaX    * vars(iValue)%xAmplitude * cos(vars(iValue)%phiX)
             vStart%y = vars(iValue)%omegaY    * vars(iValue)%yAmplitude * cos(vars(iValue)%phiY)
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to ", vars(ivalue)%tRampUp
                tAccel = vars(ivalue)%tRampUp
             End If
             !
             If (tAccel.Lt.5) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
                tAccel = 5
             End If
             !
             pAccel%x = pStart%x -0.5*vstart%x*tAccel
             pAccel%y = pStart%y -0.5*vstart%y*tAccel
             !
             Call countSegments(jj)
             !
             segList(jj)%newSubscan =  .True.
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             If      (vars(iValue)%croFlag.Eq."O") Then
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             Else If (vars(iValue)%croFlag.Eq."R") Then
                segList(jj)%flagOn     =  .False.
                segList(jj)%flagRef    =  .True.
             Else
                segList(jj)%flagOn     =  .True.
                segList(jj)%flagRef    =  .False.
             End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%lengthOtf  =  vars(iValue)%lengthOtf    !!! FIX ME !!!
             segList(jj)%pStart     =  pAccel
             segList(jj)%pEnd       =  pStart
             segList(jj)%speedStart =  0.0
             segList(jj)%speedEnd   =  1.0001*vStart%speed      !!  IMPORTANT: needed to get smoothly "into" Lissajous
             !                                                  !!  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName
             segList(jj)%altOption  =  'SPEED'                  !!  TBD:       debug/generalize
             segList(jj)%tSegment   =  tAccel
             segList(jj)%tRecord    =  0.1
             !
          End If     !!    If (vars(ivalue)%doRampUp) Then
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !D       Write (6,*) "       jj: ", jj
          !
          !D       Write (6,*) "             Lissajous Segment"
          !
          Call countSegments(jj)
          !
          segList(jj)%newSubscan =  .False.                      !!  TBD: handle case no ramp --> newSubscan .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  2
          segList(jj)%ssType     =  ss%otf
          segList(jj)%segType    =  seg%lissajous
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          Else If (vars(iValue)%croFlag.Eq."R") Then
             segList(jj)%flagOn     =  .False.
             segList(jj)%flagRef    =  .True.
          Else
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
          End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%pCenter    =  vars(iValue)%pCenter
          segList(jj)%xAmplitude =  vars(iValue)%xAmplitude
          segList(jj)%yAmplitude =  vars(iValue)%yAmplitude
          segList(jj)%omegaX     =  vars(iValue)%omegaX    
          segList(jj)%omegaY     =  vars(iValue)%omegaY    
          segList(jj)%phiX       =  vars(iValue)%phiX      
          segList(jj)%phiY       =  vars(iValue)%phiY      
          !
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'TOTF'
          segList(jj)%tSegment   =  vars(iValue)%tOtf
          segList(jj)%tRecord    =  0.1
          !
          nLissajous = nLissajous+1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !
       End If
       !
    End If
    !
    Call getCountSegments(nSegments)
    !
    !D     Write (6,*) "         nSegments:   ", nSegments
    !D     Write (6,*) "         segList(jj): "
    !D     Write (6,*)                          segList(jj)
    !
    Return 
    !
  End Subroutine analyzeSubscan
!!!
!!!
  Subroutine displayDIYlist
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplayDIYlist.inc'
    !
  End Subroutine displayDIYlist
!!!
!!!
  Subroutine displaySubscan
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Include 'inc/display/commandDisplaySubscan.inc'
    !
  End Subroutine displaySubscan
!!!
!!!
  Subroutine listDIYlist(error)
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Logical            :: error
    Integer            :: ierr
    !
    Real               :: fX, fY
    ! 
    Call getCountSegments(nSegments)
    !
    Call pako_message(seve%t,'paKo',                                             &
         &    " module DIYlist, 1.2.3.2 2014-12-04 ---> SR: listDIYlist ")       ! !! Trace execution
    !
    If (nSegments.Ge.1) Then
       Write (messageText,*)  "  segments #: 1 to ", nSegments
       l = Len_trim(GV%observingMode)    
       !! Call pakoMESSAGE(priorityI,severityI,GV%observingMode(1:l),messageText)  !!  TBD: recover!
       Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
    End If
    !
    If (nSegments.Ge.1) Then
       !
       Do ii = 1, nSegments, 1
          !
          If (segList(ii)%ssType .Eq. ss%otf                                     &
               &   .And. segList(ii)%segType .Eq. seg%lissajous) Then            ! !!  Lissajous
             !
             ierr = 1
             If (segList(ii)%flagOn) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3, " ",A, " ",A, " Amplitude ",2F12.1, " ",2A)' )     &
                     &  ii,                                                      &
                     &  segList(ii)%segType,     traceflag%on,                   &
                     &  segList(ii)%xAmplitude,                                  &  
                     &  segList(ii)%yAmplitude,                                  &  
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
             Else If (segList(ii)%flagRef) Then
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3, " ",A, " ",A, " Amplitude ",2F12.1, " ",2A)' )     &
                     &  ii,                                                      &
                     &  segList(ii)%segType,     traceflag%ref,                  &
                     &  segList(ii)%xAmplitude,                                  &  
                     &  segList(ii)%yAmplitude,                                  &  
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
             End If
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             fX = segList(ii)%omegaX/(2*Pi)
             fY = segList(ii)%omegaY/(2*Pi)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",  " Frequency ", 2F12.5, " [Hz] ",                  &
                  &            " Omega ",     2F12.5, " [rad/s] ",               &
                  &                            F12.5, " [s] " ) ' )              &
                  &  fX, fY,                                                     &
                  &  segList(ii)%omegaX    ,                                     &  
                  &  segList(ii)%omegaY    ,                                     &  
                  &  segList(ii)%tsegment                                        !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",  " Center ", 2F12.1, " ", A, " Phi ",              &
                  &                        2F12.5, " [rad] " ) ' )               &
                  &  segList(ii)%pCenter%x/GV%angleFactorR,                      &
                  &  segList(ii)%pCenter%y/GV%angleFactorR,                      &
                  &  GV%angleUnitSetC   ,                                        &
                  &  segList(ii)%phiX   ,                                        &  
                  &  segList(ii)%phiY                                            !
             Call pakoMESSAGE(max(1,priorityI-1),severityI,'DIY',messageText)
             !
          Else If (segList(ii)%ssType .Eq. ss%otf) Then                          !  !!  OTF 
             !
!!$             Write (6,*) " ii :                     ", ii
!!$             Write (6,*) " segList(ii)%newSubscan : ", segList(ii)%newSubscan
             If (segList(ii)%newSubscan) Then
                !                                                                 
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '( A                                                     &
                     &  )'  )                                                    &
                     &  "new SUBSCAN : "                                         !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                !                
             End If
             !
             If (.Not.segList(ii)%flagDropin) Then
                !
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ",  A, 2F12.1," to ", 2F12.1, " ", A," ", A       &
                     &  )'  )                                                    &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
                !
             Else
                !
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ",  A, 2F12.1," to ", 2F12.1, " ", A," ", A       &
                     &       " drop-in "                                         &
                     &  )'  )                                                    &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName                                   !
                !
             End If
             !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             Write (messageText, iostat=ierr, fmt =                              &
                  &  '("___",                                                    &
                  &    " tOtf ",   F12.5, " [s]",                                &
                  &    " speed ", 2F12.5, " [", A, "/s]"                         &
                  &  )'  )                                                       &
                  &  segList(ii)%tsegment,                                       &
                  &  segList(ii)%speedStart,                                     &
                  &  segList(ii)%speedEnd,                                       &
                  &  GV%angleUnitSetC                                            !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
             If (ierr.Ne.0) Then
                Write (messageText, *)                                           &
                     &  ii,                                                      &
                     &  segList(ii)%ssType,                                      &
                     &  segList(ii)%pStart%x/GV%angleFactorR,                    &
                     &  segList(ii)%pStart%y/GV%angleFactorR,                    &
                     &  segList(ii)%pEnd%x/GV%angleFactorR,                      &
                     &  segList(ii)%pEnd%y/GV%angleFactorR,                      &
                     &  GV%angleUnitSetC,                                        &
                     &  segList(ii)%systemName,                                  &
                     &  segList(ii)%tsegment                                     !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             End If                                        !
             !
          Else If (segList(ii)%ssType .Eq. ss%cs) Then                           !  !!  CS
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType," ",                                     &
                  &  "at ",   segList(ii)%pStart%x/GV%angleFactorR," ",          &
                  &           segList(ii)%pStart%y/GV%angleFactorR," ",          &
                  &  GV%angleUnitSetC                                            !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
          Else If (segList(ii)%ssType.Eq.ss%ca .Or.                              & !!  CA, CC
               &   segList(ii)%ssType .Eq. ss%cc) Then                           !
             If (segList(ii)%sideBand.Ne.GPnone) Then
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType," ",                                  &
                     &  segList(ii)%sideBand                                     !
             Else
                Write (messageText,*)  "  subscan #:   ", ii," ",                &
                     &  segList(ii)%ssType                                       !
             End If
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
             !
!!$          Else If (segList(ii)%ssType .Eq. ss%track) Then                     
          Else If (     segList(ii)%ssType .Eq. ss%track                         &   !!  TRACK
               &   .Or. segList(ii)%ssType .Eq. ss%ref                           &   !!  REF
               &   .Or. segList(ii)%ssType .Eq. ss%tune                          &   !!  TUNE
               &  ) Then                                                         !   
             !
             If (segList(ii)%flagTune) Then                                      !   !!     -> NIKA tune
                Write (messageText, iostat=ierr, fmt =                           &
                     &  '(I3," ", A,A, "at ", 2F12.1, " [", A,"] ",              &
                     &   A, F12.5," [s] ", A)   '                                &
                     &  )                                                        &
                     &           ii,                                             &
                     &           segList(ii)%ssType,traceflag%on,                &
                     &           segList(ii)%pStart%x/GV%angleFactorR,           &
                     &           segList(ii)%pStart%y/GV%angleFactorR,           &
                     &           GV%angleUnitSetC,                               &
                     &           segList(ii)%systemName,                         &
                     &           segList(ii)%tsegment,                           &
                     &           " /Tune "                                       !
                Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                !
             Else If (.Not.segList(ii)%flagTune) Then                            !  !!     -> not NIKA tune
                !
                If (segList(ii)%flagOn) Then                                     !  !!     -> ON
                   Write (messageText, iostat=ierr, fmt =                        &
                        &  '(I3," ", A,A, "at ", 2F12.1," [", A,"] ",            &
                        &   A, F12.5," [s]")   '                                 &
                        &  )                                                     &
                        &           ii,                                          &
                        &           segList(ii)%ssType,traceflag%on,             &
                        &           segList(ii)%pStart%x/GV%angleFactorR,        &
                        &           segList(ii)%pStart%y/GV%angleFactorR,        &
                        &           GV%angleUnitSetC,                            &
                        &           segList(ii)%systemName,                      &
                        &           segList(ii)%tsegment                         !
                   Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                Else If (segList(ii)%flagRef) Then                               !  !!       -> REF
                   Write (messageText, iostat=ierr, fmt =                        &
                        &  '(I3," ", A,A, "at ", 2F12.1," [", A,"] ",            &
                        &   A, F12.5," [s]")   '                                 &
                        &  )                                                     &
                        &           ii,                                          &
                        &           segList(ii)%ssType,traceflag%ref,            &
                        &           segList(ii)%pStart%x/GV%angleFactorR,        &
                        &           segList(ii)%pStart%y/GV%angleFactorR,        &
                        &           GV%angleUnitSetC,                            &
                        &           segList(ii)%systemName,                      &
                        &           segList(ii)%tsegment                         !
                   Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
                End If
                !
             End If                                                              ! !!     <- flagTune or else
             !
          Else                                                                   ! !!  <-- TRACK  
             !
             Write (messageText,*)  "  subscan #:   ", ii," ",                   &
                  &  segList(ii)%ssType                                          !
             !
             Call pakoMESSAGE(priorityI,severityI,'DIY',messageText)
          End If
          !
       End Do  !!  loop over segments
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'DIY',messageText)
       !
    End If     !!  nSegments.Ge.1 or else
    !
    Return
    !
  End Subroutine listDIYlist
!!!
!!!
  Subroutine plotDIYlist (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    errorP = .False.
    !
    Call pako_message(seve%t,"DIY",                                              &
         &    " module DIYlist, 1.2.3 2014-12-15 ---> SR: plotDIYlist ")         ! trace execution
    !
    Call configurePlots
    !
    Call getCountSegments(nSegments)
    !
    !D     Write (6,*) '        nSegments: ',  nSegments
    !D     Write (messageText,*)  "  subscans #: 1 to ", nSegments
    !
    If (nSegments.Ge.1) Then
       !
       Do ii = 1, nSegments, 1
          !
          !D           Write (6,*) ii, segList(ii)%ssType, segList(ii)%segType,               &
          !D                &          segList(ii)%flagOn, segList(ii)%flagRef,               &
          !D                &          segList(ii)%flagTune                                   !
          !
          If      (segList(ii)%ssType.Eq.ss%otf                                  &
               &   .And. segList(ii)%segType.Eq.seg%linear) Then                 !  !!  OTF linear
             !
             If (segList(ii)%flagDropin) Then                                       !!  drop-in
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii,                                          &
                     &  Type      = "dropin"                                     &
                     &  )                                                        !
             Else
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii)                                          !
             End If
             !
          Else If      (segList(ii)%ssType.Eq.ss%otf                             &
               &   .And. segList(ii)%segType.Eq.seg%lissajous) Then              !  !!  OTF Lisajous
             !
             !D              Write (6,*) "   --> plotDIYlist: about to call plotOtfLissajous"
             !D              Write (6,*) "                GV%slowRateAMD: ", GV%slowRateAMD
             !
             Call plotOtfLissajousP(                                             &
                  &  segList(ii)%pCenter,                                        &
                  &  segList(ii)%xAmplitude,                                     &
                  &  segList(ii)%yAmplitude,                                     &
                  &  segList(ii)%omegaX,                                         &
                  &  segList(ii)%omegaY,                                         &
                  &  segList(ii)%phiX,                                           &
                  &  segList(ii)%phiY,                                           &
                  &  segList(ii)%tSegment,                                       &
                  &  errorP,                                                     &
                  &  tSample=1/GV%slowRateAMD,                                   &
                  &  number=ii)                                                  !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagTune) Then                              !  !!  TRACK tune
             !!D  Write (6,*) "      ii: ", ii, " -> plot Track /Tune "
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%tune)                                      !
             !
          Else If (segList(ii)%ssType .Eq.ss%tune                                &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagTune) Then                              !  !!  TRACK tune
             !!D  Write (6,*) "      ii: ", ii, " -> plot Track /Tune "
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%tune)                                      !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagOn) Then                                !  !!  TRACK On
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%on)                                        !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagRef) Then                               !  !!  TRACK Reference
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%ref)                                       !
             !
          End If
          !
       End Do
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'DIY',messageText)
       !
    End If
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'DIYlist',' could not plot ')                                  !
    !
    Return
  End Subroutine plotDIYlist
!!!
!!!
  Subroutine saveDIYlist(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !      
    Character(len=lenLine)             ::  messageText
    !
    ERROR = .False.
    !
    !D     Write (6,*) '      ---> modulePakoDIYlist SR: saveDIYlist '
    !
    Include 'inc/commands/saveDIYlist.inc'
    !
    Return
  End Subroutine saveDIYlist
!!!
!!!
  Subroutine saveSubscan(programName,LINE,commandToSave,iUnit, ERROR)
    !
    !**   Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !      
    Character(len=lenLine)             ::  messageText
    !
    ERROR = .False.
    !
    !D     Write (6,*) '      ---> modulePakoDIYlist SR: saveSubscan '
    !
    Include 'inc/commands/saveSubscan.inc'
    !
    Return
  End Subroutine saveSubscan
!!!
!!!
  Subroutine startDIYlist(programName,LINE,commandToSave, iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    ERROR = .False.
    !
    !D     Write (6,*) " ---> modulePakoDIYlist: SR startDIYlist "
    !
    Call startSubscanList(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Return
  End Subroutine startDIYlist
!!!
!!!
  Subroutine writeXMLDIYlist(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    ERROR = .False.
    !
    Return
  End Subroutine writeXMLDIYlist
!!!
!!!
End Module modulePakoDIYlist
!!!
!!!

subroutine write_sdm_execblock(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Write the Source ExecBlock  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_ExecBlock
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ExecBlockKey) :: ebKey
  type (ExecBlockRow) :: ebRow
  real*8 :: releaseDays, lonlat(2), altitude
  integer :: numObservingLog, numSchedulerMode, ia, l
  character, parameter :: sdmTable*12 = 'ExecBlock'
  save ebRow
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ebRow%numAntenna = r_nant
  numObservingLog = 1
  !numSchedulerMode = 1
!!!   call allocExecBlockRow(ebRow, ebRow%numAntenna, numObservingLog,   &
!!!     numSchedulerMode, error)
  call allocExecBlockRow(ebRow, error)
  if (error) return
  do ia=1, r_nant
    ebRow%antennaId(ia) = antenna_Id(ia)
  enddo
  !!!!! TEMPORARY !!!!! MUST HANDLE THE SB SUMMARY
  ebRow%sbSummaryId = sbsummary_Id
  ebRow%startTime = eb_startTime
  ebRow%endTime = eb_endTime
  ebRow%sessionReference = 'Plateau de Bure ObservingSession'

  
  !
  ! This has to be IRAM_PDB for casa.
  !ebRow%telescopeName = r_teles
  ebRow%telescopeName = 'IRAM_PDB'
  if (r_nant.gt.1) then
    ebRow%configName = r_config(1:lenc(r_config))
    call get_config(ebRow%baseRangeMin, ebRow%baseRangeMax,   &
      ebRow%baseRmsMinor,ebRow%baseRmsMajor, ebRow%basePa)
  else
    ebRow%configName = 'Single Dish'
    ebRow%baseRangeMin = 0
    ebRow%baseRangeMax = 0
    ebRow%baseRmsMinor = 0
    ebRow%baseRmsMajor = 0
    ebRow%basePa = 0
  endif
  ebRow%observerName = 'N.N., Astronomer.'
!  ebRow%observingLog(1) = 'nn.log'
  ebRow%observingLog = 'nn.log'
  ebRow%schedulerMode = 'testMe'
  l = lenc(project_uid)
  ebRow%projectId= '<EntityRef '// 'entityId="' //   &
    project_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="ObsProject" '//   &
    'documentVersion="1"/>'//char(0)
  l = lenc(execBlock_uid)
  ebRow%execBlockUID = '<EntityRef entityId="' //   &
    execBlock_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="ExecBlock" '//   &
    'documentVersion="1"/>'//char(0)
  ebRow%sbSummary = '<EntityRef entityId="' //   &
    execBlock_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="SchedBlock" '//   &
    'documentVersion="1"/>'//char(0)
  !
  ! Make this into a subroutine ?
  if (r_teles.eq.'VTX-ALMATI') then
    call sic_sexa ('-107:37:10.02',10,lonlat(1),error)
    call sic_sexa ('34:04:29.8',8,lonlat(2),error)
    altitude = 2.13542d0*1000d0
  elseif (r_teles.eq.'AEC-ALMATI') then
    call sic_sexa ('-107:37:10.02',10,lonlat(1),error)
    call sic_sexa ('34:04:29.8',8,lonlat(2),error)
    altitude = 2.13542d0*1000.d0
  else
    call sic_sexa ('05:54:28.5',10,lonlat(1),error)
    call sic_sexa ('44:38:02.0',10,lonlat(2),error)
    altitude = 2.560d0*1000.d0
  endif
  !
  ebRow%siteLongitude = lonlat(1)*pi/180d0
  ebRow%siteLatitude = lonlat(2)*pi/180d0
  ebRow%siteAltitude = altitude
  !
  ! OPTIONAL in SS2 ... releaseDays = time_interval(1)/1.d9/84600.+365.*1.5
  ! OPTIONAL in SS2 ... ebRow%releaseDate = int(releaseDays)
  ! OPTIONAL in SS2 ... ebRow%releaseDate = ebRow%releaseDate *84600 *1000000000
!!!   ebRow%flagRow = .false.
  !
  call addExecBlockRow(ebKey, ebRow, error)
  if (error) return
  !
  ExecBlock_Id = ebKey%execBlockId
  deallocate(ebRow%antennaId)
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_execblock
!---------------------------------------------------------------------
subroutine get_sdm_execblock(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Read  the ExecBlock  table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_ExecBlock
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_pi.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ExecBlockKey) :: ebKey
  type (ExecBlockRow) :: ebRow
  real*8 :: releaseDays
  integer :: numObservingLog, numSchedulerMode, ia, lenz, l1,   &
    l2, l
  character, parameter :: sdmTable*12 = 'ExecBlock'
  integer, parameter :: maxObservingLog = 10, maxSchedulerMode = 10
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  numObservingLog = maxObservingLog
  !numSchedulerMode = maxSchedulerMode
  call allocExecBlockRow(ebRow, error)
  if (error) return
  ebKey%execBlockId = execBlock_Id
  call getExecBlockRow(ebKey, ebRow, error)
  if (error) return
  r_alti = ebRow%siteAltitude/1000.
  r_config = ebRow%configName
  r_teles = ebRow%telescopeName
  l = lenz(ebRow%execBlockUID)
  l1 = index(ebRow%execBlockUID,'"uid://')
  l2 = index(ebRow%execBlockUID(l1+1:),'"')
  r_execBlock = ebRow%execBlockUID(l1+1:l1+l2-1)
  ExecBlock_uid = r_execBlock
  call unslash(r_execBlock,'/')
  call unslash(r_execBlock,':')
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_execblock
!---------------------------------------------------------------------
subroutine unslash(chain,c)
  use gkernel_interfaces
  character*(*) chain, c
  integer l
  l = index(chain,c)
  do while (l.ne.0)
    chain(l:l) = '_'
    l = index(chain,c)
  enddo
  l = lenc(chain)
end subroutine unslash
!---------------------------------------------------------------------
subroutine  get_config(baseRangeMin, baseRangeMax, baseRmsMinor,   &
    baseRmsMajor, basePa)
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Dummy
  real*8 baseRangeMin, baseRangeMax, baseRmsMinor, baseRmsMajor,   &
    basePa
  ! Local
  real*8 length, lat, sx2, sxy, sy2, s, xx, yy
  parameter (lat=44.63389D0*pi/180d0)
  integer ib, k
  baseRangeMin = 1d10
  baseRangeMax = 0
  sx2 = 0
  sy2 = 0
  sxy = 0
  s = 0
  if (r_nbas.gt.1) then
    do ib = 1, r_nbas
      length = 0
      do k = 1, 3
        length = length + r_bas(k,ib)**2
      enddo
      length = sqrt(length)
      !     horizontal component
      xx = r_bas(1,ib)*sin(lat)-r_bas(3,ib)*cos(lat)
      yy = r_bas(2,ib)
      sx2 = sx2 + xx**2
      sxy = sy2 + yy**2
      sxy = sxy + xx*yy
      s = s + 1
      baseRangeMin = min(baseRangeMin, length)
      baseRangeMax = max(baseRangeMax, length)
    enddo
    sx2 = sx2 / s
    sy2 = sy2 / s
    sxy = sxy / s
  else
    baseRangeMin = 0
    baseRangeMax = 1
  endif
! compute rms values and pa using TBD formula
end subroutine get_config
!---------------------------------------------------------------------
!!! subroutine allocExecBlockRow(row, numAntenna, numObservingLog,   &
!!!     numSchedulerMode, error)
!!!   !---------------------------------------------------------------------
!!!   !     integer, allocatable :: antennaId(:)
!!!   !     character*256, allocatable :: observingLog(:)
!!!   !     character*256, allocatable :: schedulerMode(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_ExecBlock
!!!   type(ExecBlockRow) :: row
!!!   integer :: ier, numAntenna, numObservingLog, numSchedulerMode
!!!   logical :: error
!!!   character, parameter :: sdmTable*12 = 'ExecBlock'
!!!   !
!!!   ! antennaId(numAntenna)
!!!   if (allocated(row%antennaId)) then
!!!     deallocate(row%antennaId, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%antennaId(numAntenna), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! ObservingLog(numObservingLog)
!!!   if (allocated(row%ObservingLog)) then
!!!     deallocate(row%ObservingLog, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%ObservingLog(numObservingLog), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! SchedulerMode(numSchedulerMode)
!!!   if (allocated(row%SchedulerMode)) then
!!!     deallocate(row%SchedulerMode, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%SchedulerMode(numSchedulerMode), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !---------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_coverage
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubesimulate_messaging
  use cubesimulate_configuration
  use cubesimulate_observatory
  use cubesimulate_tuning
  !
  public :: coverage
  private
  !
  type :: coverage_comm_t
     type(option_t),    pointer :: comm
     type(cube_prod_t), pointer :: cover
     type(tuning_comm_t),        pointer :: tuning => null()
     type(observatory_comm_t),   pointer :: observ => null()
     type(configuration_comm_t), pointer :: config => null()
   contains
     procedure, private :: init     => cubesimulate_coverage_comm_init
     procedure, public  :: register => cubesimulate_coverage_comm_register
     procedure, private :: parse    => cubesimulate_coverage_comm_parse
     procedure, private :: main     => cubesimulate_coverage_comm_main
  end type coverage_comm_t
  type(coverage_comm_t) :: coverage
  !
  type coverage_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubesimulate_coverage_user_toprog
  end type coverage_user_t
  !
  type coverage_prog_t
     type(tuning_prog_t),        pointer :: tuning => null()
     type(observatory_prog_t),   pointer :: observ => null()
     type(configuration_prog_t), pointer :: config => null()
     type(cube_t),               pointer :: cover
   contains
     procedure, private :: init   => cubesimulate_coverage_prog_init
     procedure, private :: header => cubesimulate_coverage_prog_header
     procedure, private :: data   => cubesimulate_coverage_prog_data
     procedure, private :: loop   => cubesimulate_coverage_prog_loop
     procedure, private :: act    => cubesimulate_coverage_prog_act
  end type coverage_prog_t
  !
contains
  !
  subroutine cubesimulate_coverage_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(coverage_user_t) :: user
    character(len=*), parameter :: rname='COVERAGE>COMMAND'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call coverage%parse(line,user,error)
    if (error) return
    call coverage%main(user,error)
    if (error) continue
  end subroutine cubesimulate_coverage_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_comm_init(comm,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>COMM>INIT'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    comm%tuning => tuning_comm
    comm%observ => observatory_comm
    comm%config => configuration_comm
  end subroutine cubesimulate_coverage_comm_init
  !
  subroutine cubesimulate_coverage_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='COVERAGE>COMM>REGISTER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Initialize pointers
    call comm%init(error)
    if (error) return
    !
    ! Syntax
    call cubetools_register_command(&
         'COVERAGE','',&
         'Report the current coverage-simulation setup',&
         'Report the current tuning, observatory, and configuration setup&
         & used for coverage simulation. The COVERAGE product remains&
         & declared in help, but the synthesis path is currently disabled&
         & and no coverage cube is written yet.',&
         cubesimulate_coverage_command,&
         comm%comm,&
         error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'COVERAGE',&
         'Coverage product placeholder',&
         strg_emp,&
         [flag_coverage],&
         comm%cover,&
         error)
    if (error)  return
  end subroutine cubesimulate_coverage_comm_register
  !
  subroutine cubesimulate_coverage_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COVERAGE
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(coverage_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>COMM>PARSE'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Nothing to do right now.
  end subroutine cubesimulate_coverage_comm_parse
  !
  subroutine cubesimulate_coverage_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_comm_t), intent(in)    :: comm
    type(coverage_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(coverage_prog_t) :: prog
    character(len=*), parameter :: rname='COVERAGE>COMM>MAIN'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
!!$    call prog%header(comm,error)
!!$    if (error) return
!!$    call cubeadm_timing_prepro2process()
!!$    call prog%data(error)
!!$    if (error) return
!!$    call cubeadm_timing_process2postpro()
  end subroutine cubesimulate_coverage_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_user_t), intent(in)    :: user
    type(coverage_comm_t),  intent(in)    :: comm    
    type(coverage_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>USER>TOPROG'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Initialize pointers
    call prog%init(error)
    if (error) return
    !
    ! User feedback
    call prog%tuning%list(comm%tuning,error)
    if (error) return
    call prog%observ%list(comm%observ,error)
    if (error) return
    call prog%config%list(comm%config,error)
    if (error) return
  end subroutine cubesimulate_coverage_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_coverage_prog_init(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>PROG>INIT'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    prog%tuning => tuning_prog
    prog%observ => observatory_prog
    prog%config => configuration_prog
  end subroutine cubesimulate_coverage_prog_init
  !
  subroutine cubesimulate_coverage_prog_header(prog,comm,error)
    use cubedag_allflags
    use cubeadm_create
    !----------------------------------------------------------------------
    ! Create a cube header from scratch and initialize it
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    type(coverage_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COVERAGE>PROG>HEADER'
    !
    integer(kind=ndim_k) :: ndim
    integer(kind=data_k) :: dims(maxdim)
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ndim = 3
    dims(1:3) = [7,1,1]
    dims(4:maxdim) = 0
    call cubeadm_create_header(&
         [flag_uv,flag_coverage],code_access_speset,ndim,dims,prog%cover,error)
    if (error) return
    !***JP: Why the family name is not an input of the
    !***JP: cubeadm_create_header subroutine?
    !***SB: Because there are many properties we would like to set
    call prog%cover%set_value('FAMILY','coucou',error)
    if (error) return
    ! Prepare extrema processing. Assume no parallel put involved (1 pseudo-task)
!    call cover%proc%allocate_extrema(buffer%cube%head,1,error)
!    if (error)  return
  end subroutine cubesimulate_coverage_prog_header
  !
  subroutine cubesimulate_coverage_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='COVERAGE>PROG>DATA'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubesimulate_coverage_prog_data
  !   
  subroutine cubesimulate_coverage_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: cover
    character(len=*), parameter :: rname='COVERAGE>PROG>LOOP'
    !
    call cover%allocate('cover',prog%cover,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,cover,error)
      if (error) return
    enddo ! ie
  end subroutine cubesimulate_coverage_prog_loop
  !   
  subroutine cubesimulate_coverage_prog_act(prog,ie,cover,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(coverage_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(spectrum_t),       intent(inout) :: cover
    logical,                intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='COVERAGE>PROG>ACT'
    !
    do ic=1,cover%n
       cover%y%val(ic) = 1.0
    enddo ! ic
    call cover%put(ie,error)
    if (error) return
  end subroutine cubesimulate_coverage_prog_act
end module cubesimulate_coverage
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubetools_realpath
  use gkernel_interfaces
  use cubetools_parameters
  !---------------------------------------------------------------------
  ! This module offers the possibility to
  ! 1) convert a relative path and symlinks to absolute real path,
  ! 2) compute the relative path from one absolute path to another
  !---------------------------------------------------------------------

  public :: cubetools_realpath_t
  private

  character(len=1), parameter :: dirsep='/'       ! ZZZ Should use subroutine gag_separ
  integer(kind=4),  parameter :: notyetparsed=-1  !

  type :: cubetools_realpath_t
    character(len=file_l), private :: path      ! Original path
    integer(kind=4),       private :: np        ! Useful size of path
    character(len=file_l), private :: realpath  ! Resolved path
    integer(kind=4),       private :: nrp       ! Useful size of realpath
    integer(kind=4),       private :: sep(32)   ! Position of directory separators
    integer(kind=4),       private :: nsep      ! Number of separators
  contains
    procedure, public  :: resolve      => path_resolve
    procedure, private :: parse        => path_parse
    procedure, public  :: relativeto   => path_relativeto
    procedure, public  :: absolutefrom => path_absolutefrom
  end type cubetools_realpath_t

contains
  subroutine path_resolve(a,path)
    use, intrinsic :: iso_c_binding
    !-------------------------------------------------------------------
    ! Invoke C realpath on the given path
    ! Note that files (or directories?) do not need to exist to resolve
    ! them as full paths.
    !-------------------------------------------------------------------
    class(cubetools_realpath_t), intent(inout) :: a
    character(len=*),            intent(in)    :: path

    type(c_ptr) :: ptr

    ! Fortran interface to C function, realpath()
    interface
      function realpath(path,resolved_path) bind(c)
      use, intrinsic :: iso_c_binding
      type(c_ptr) :: realpath
      character(len=1,kind=c_char), intent(in)  :: path(*)
      character(len=1,kind=c_char), intent(out) :: resolved_path(*)
      end function realpath
    end interface

    a%np       = len_trim(path)
    a%path     = path(1:a%np)//char(0)
    a%realpath = ''  ! Pre-fill output with blanks
    ptr        = realpath(a%path,a%realpath)  ! Pass long scalars to a len=1 arrays (ok in standard)
    a%nrp      = lenc(a%realpath)
    a%nsep     = notyetparsed
    ! print *,a%realpath(1:a%nrp)
  end subroutine path_resolve

  subroutine path_parse(a)
    !-------------------------------------------------------------------
    ! Compute where the directory separators are located and save this
    ! in the type.
    !-------------------------------------------------------------------
    class(cubetools_realpath_t), intent(inout) :: a
    !
    integer(kind=4) :: i
    !
    if (a%nsep.ne.notyetparsed)  return
    !
    a%nsep = 0
    do i=1,a%nrp
      if (a%realpath(i:i).eq.dirsep) then
        a%nsep = a%nsep+1
        a%sep(a%nsep) = i
      endif
    enddo
    !
    ! Assume a pseudo-separator at the end if path is directory. This
    ! will ensure that path_relativeto works properly, relatively from
    ! files or from directories
    if (gag_isdir(a%realpath).eq.0) then
      a%nsep = a%nsep+1
      a%sep(a%nsep) = a%nrp+1
    endif
  end subroutine path_parse

  function path_relativeto(a,b)
    !-------------------------------------------------------------------
    ! Compute the path of a relative to b
    !-------------------------------------------------------------------
    character(len=file_l) :: path_relativeto  ! Function value on return
    class(cubetools_realpath_t), intent(inout) :: a
    type(cubetools_realpath_t),  intent(inout) :: b
    !
    integer(kind=4) :: commonsep,isep,nc
    !
    ! Leave absolute paths as absolute
    if (a%path(1:1).eq.dirsep) then
      path_relativeto = a%path(1:a%np)
      return
    endif
    !
    ! Parse separators
    call a%parse()
    call b%parse()
    !
    ! Find common separator
    commonsep = 1
    do isep=2,a%nsep
      if (isep.gt.b%nsep)  exit
      if (a%realpath(a%sep(isep-1)+1:a%sep(isep)-1).ne. &
          b%realpath(b%sep(isep-1)+1:b%sep(isep)-1)) then
        exit
      endif
      commonsep = isep
    enddo
    ! print *,"Common separator is ",commonsep,' at position ',a%sep(commonsep)
    !
    if (commonsep.le.3) then
      ! Most likely only /home/user/ in common: makes poor sense to
      ! produce a relative path
      path_relativeto = a%realpath(1:a%nrp)
    else
      path_relativeto = ''
      nc = 0
      do isep=commonsep+1,b%nsep
        path_relativeto(nc+1:nc+3) = '..'//dirsep
        nc = nc+3
      enddo
      path_relativeto(nc+1:) = a%realpath(a%sep(commonsep)+1:a%nrp)
    endif
    ! print *,"Relative path is ",trim(relpath)
  end function path_relativeto

  subroutine path_absolutefrom(a,file,path)
    !-------------------------------------------------------------------
    ! Set up the absolute realpath of file 'file' hosted in directory
    ! 'path'. The file name can be a simple file name, a file name with
    ! a relative path, or an absolute path (in this latter case, 'path'
    ! is obviously not relevant.
    !-------------------------------------------------------------------
    class(cubetools_realpath_t), intent(inout) :: a
    character(len=*),            intent(in)    :: file,path
    !
    if (file(1:1).eq.dirsep) then
      ! Leave absolute paths as absolute
      call a%resolve(file)
    else
      ! File has no path, or a relative path from 'path'
      call a%resolve(trim(path)//dirsep//file)
    endif
  end subroutine path_absolutefrom
end module cubetools_realpath

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_load
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetools_userspace
  use cubeadm_cubeid_types
  use cubego_messaging
  use cubeedit_getdata
  use cubeedit_getheader_tool
  !
  public :: load
  private
  !
  type :: load_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(userspace_opt_t)       :: into
     type(getheader_comm_t)      :: head
     type(getdata_comm_t)        :: data
   contains
     procedure, public  :: register => cubego_load_comm_register
     procedure, private :: parse    => cubego_load_comm_parse
     procedure, private :: main     => cubego_load_comm_main
  end type load_comm_t
  type(load_comm_t) :: load
  !
  type :: load_user_t
     logical :: dolist = .false.
     type(cubeid_user_t)    :: cubeids
     type(userspace_user_t) :: into
     type(getheader_user_t) :: head
     type(getdata_user_t)   :: data
   contains
     procedure, private :: toprog => cubego_load_user_toprog
  end type load_user_t
  !
  type :: load_prog_t
     type(cube_t), pointer    :: cube
     !type(userspace_prog_t)  :: into
     type(getheader_prog_t)   :: head
     !type(getdata_prog_t)    :: data
   contains
     procedure, private :: list => cubego_load_prog_act_list
     procedure, private :: load => cubego_load_prog_act_load
  end type load_prog_t
  !
contains
  !
  subroutine cubego_load_command(line,error)
    !----------------------------------------------------------------------
    ! Support routine for command LOAD
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(load_user_t) :: user
    character(len=*), parameter :: rname='LOAD>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call load%parse(line,user,error)
    if (error) return
    call load%main(user,error)
    if (error) return
  end subroutine cubego_load_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_load_comm_register(comm,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! Register GO\LOAD command and its keys
    !-------------------------------------------------------------------
    class(load_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    logical, parameter :: noiterator = .false.
    character(len=*), parameter :: rname='LOAD>COMM>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'LOAD','[cubeid]',&
         'Load array or header information from a cube',&
         'Map cube header or data information into SIC variables for&
         & inspection.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- With no option, the command lists available header and data&
         & information extracted in SIC variables.'//strg_cr//&
         '- Else, the command resolves the input cubeid, variable name,&
         & and delegated header/data loaders.'//strg_cr//&
         '- Data selectors are mutually exclusive in one call (/FIRST,&
         & /LAST, /ENTRY, /PIXEL, /CHANNEL, /CUBE).'//strg_bl//&
         'Notes:'//strg_cr//&
         '- Mapped values are informational and do not modify cube&
         & content.'//strg_cr//&
         '- Use EDIT commands when cube values or headers must be&
         & modified.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> LOAD c1 /SHAPE /INTO n'//strg_cr//&
         '  CUBE> LOAD c1 /PIXEL 10 20 relative /INTO spec'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         '  CUBE> LOAD'//strg_cr//&
         '  CUBE> LOAD c1 /AXIS VELOCITY RELATIVE km/s /INTO axis'//strg_cr//&
         '  CUBE> LOAD c1 /ENTRY 12 IMAGE /INTO slice',&
         cubego_load_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'CUBEID',&
         'Identity of the source cube used for loading',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset_or_speset,&
         comm%cube,&
         error)
    if (error) return
    !
    call comm%into%register(error)
    if (error) return
    call comm%head%register('GOLOAD',load%into,error)
    if (error) return
    call comm%data%register(load%into,access_not_fixed,noiterator,error)
    if (error) return
  end subroutine cubego_load_comm_register
  !
  subroutine cubego_load_comm_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(load_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(load_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LOAD>COMM>PARSE'
    !
    if (cubetools_nopt().eq.0) then
       user%dolist = .true.
    else
       user%dolist = .false.
       call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
       if (error) return
       call comm%into%parse(line,user%into,error)
       if (error) return
       call comm%head%parse(line,user%into,user%head,error)
       if (error) return
       call comm%data%parse(line,user%into,user%data,error)
       if (error) return
    endif
  end subroutine cubego_load_comm_parse
  !
  subroutine cubego_load_comm_main(comm,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(load_comm_t), intent(in)    :: comm
    type(load_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(load_prog_t) :: prog
    character(len=*), parameter :: rname='LOAD>COMM>MAIN'
    !
    if (user%dolist) then
       call prog%list(error)
       if (error) return
       !***JP: The following one should be transfered to cubego_load_prog_list after standardization of cubedit_getdata
       call comm%data%list(error)
       if (error) return
    else
       call user%toprog(comm,prog,error)
       if (error) return
       call prog%load(comm,user,error)
       if (error) return
    endif
  end subroutine cubego_load_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubego_load_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(load_user_t), intent(in)    :: user
    type(load_comm_t),  intent(in)    :: comm    
    type(load_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LOAD>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    ! As of today, data access can only be done on a cube_t
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    ! But header access can be done on any format_t    
    call cubeadm_get_fheader(comm%cube,user%cubeids,prog%head%cube,error)
    if (error) return
    call user%head%toprog(comm%head,'LOADEDIT',user%data%do,prog%head,error)
    if (error) return
  end subroutine cubego_load_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubego_load_prog_act_list(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(load_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LOAD>PROG>ACT>LIST'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%head%list(error)
    if (error) return
    !call prog%data%list(error)
    !if (error) return
  end subroutine cubego_load_prog_act_list
  !
  subroutine cubego_load_prog_act_load(prog,comm,user,error)
    use cube_types
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(load_prog_t), intent(inout) :: prog
    type(load_comm_t),  intent(in)    :: comm
    type(load_user_t),  intent(in)    :: user !***JP: Should be removed
    logical,            intent(inout) :: error
    !
    integer(kind=entr_k) :: ie
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='LOAD>PROG>ACT>LOAD'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (user%data%do) then
       ! Do not forget to prepare the internal iterator so that
       ! getting image/channel/etc... works properly.
       call cubeadm_datainit_all(iter,error)
       if (error) return
       ie = entr_unk
       call comm%data%get(user%data,prog%cube,'GOLOAD',user%head%present,ie,error)
       if (error) return
    endif
    call prog%head%get(error)
    if (error) return
  end subroutine cubego_load_prog_act_load
end module cubego_load
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_baseline
  use gbl_message
  !
  public :: uv_baseline_comm
  private
  !
contains
  !
  subroutine uv_baseline_comm(line,error)
    use gildas_def
    use uv_filter
    !----------------------------------------------------------
    ! Command line interaction for UV_BASELINE command
    !----------------------------------------------------------
    character(len=*), intent(inout) :: line 
    logical,          intent(inout) :: error
    !
    integer                    :: degree           ! degree of the baseline to subtract
    integer, allocatable       :: channellist(:,:) ! list of ranges of channels to exclude
    integer(kind=size_length)  :: nelem            ! Number of excluded ranges
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    degree = 0
    call sic_i4(line,0,1,degree,.false.,error)
    if (error) return
    if (degree.ne.0 .and. degree.ne.1) then
       call map_message(seve%e,rname,'Only degree 0 or 1 supported')
       error = .true.
       return
    endif
    !
    ! Call UV Filter to do the parsing
    call uv_filter_channel_parsing(rname,line,channellist,nelem,error)
    if (error) return
    !
    ! Now do the work
    call uv_baseline_sub(degree,channellist,nelem,error)
  end subroutine uv_baseline_comm
  !
  subroutine uv_baseline_sub(degree,channellist,nelem,error)
    use gildas_def
    use gkernel_interfaces
    use uv_buffers
    !----------------------------------------------------------
    ! Coordinates baseline fitting and subtraction
    !----------------------------------------------------------
    integer, intent(in)                   :: degree           ! Polynomial degree of baseline
    integer, allocatable,intent(in)       :: channellist(:,:) ! list of ranges of channels to exclude
    integer(kind=size_length),intent(in)  :: nelem            ! Number of excluded ranges
    logical, intent(out)                  :: error            ! Error flag
    !
    integer(kind=size_length)              :: nvisi         ! Number of visibilities
    integer(kind=index_length)             :: ivisi         ! visibility index
    integer(kind=index_length)             :: iranges       ! spectral ranges index
    integer(kind=index_length)             :: ichan         ! channel index
    integer(kind=index_length)             :: ivalid        ! valid channel index
    integer(kind=index_length),allocatable :: rindexes(:)   ! indexes for valid real channels
    integer(kind=index_length),allocatable :: iindexes(:)   ! indexes for valid imaginary channels
    integer(kind=index_length),allocatable :: cnumbers(:)   ! valid channels
    real,allocatable                       :: rdata(:)      ! valid real channels
    real,allocatable                       :: idata(:)      ! valid imaginary channels
    integer(kind=4),allocatable            :: notflagged(:)
    integer(kind=size_length)              :: nchan         ! number of channels
    integer                                :: ier
    integer                                :: nvalid        ! NUmber of valid channels
    integer                                :: fchan, lchan  ! First and last channels in a range of channels
    character(len=50)                      :: warning       ! Warning message
    integer(kind=index_length)             :: cols(3)       ! Columns for a specific channel
    integer(kind=1), parameter             :: bit=1         ! 1 in i1
    real                                   :: areal,breal   ! Fit parameters for real part
    real                                   :: aimag,bimag   ! Fit parameters for imaginary part
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    nchan = huv%gil%nchan
    nvisi = huv%gil%nvisi
    allocate(notflagged(nchan),stat=ier)
    if (failed_allocate(rname,'Flagged list',ier,error))  return
    notflagged(:) = 1
    !
    ! Getting the flagged ranges
    do iranges=1, nelem
       fchan = channellist(1,iranges)
       lchan = channellist(2,iranges)
       if (lchan.lt.1.or.fchan.gt.huv%gil%nchan) then
          write(warning,1000) iranges,"-th spectral range is outside UV table"
          call map_message(seve%w,rname, trim(warning))
       else
          if (lchan.gt.nchan) lchan = nchan
          if (fchan.lt.1)     fchan = 1
          notflagged(fchan:lchan) = 0
       endif
    enddo
    nvalid = sum(notflagged)
    allocate(rindexes(nvalid),iindexes(nvalid),rdata(nvalid),idata(nvalid),cnumbers(nvalid),stat=ier)
    if (failed_allocate(rname,'Real and imaginary arrays',ier,error))  return
    ivalid=1
    do ichan=1,nchan
       if (notflagged(ichan).eq.bit) then
          call uv_spectral_getcols(ichan,cols)
          rindexes(ivalid) = cols(1)
          iindexes(ivalid) = cols(2)
          cnumbers(ivalid) = ichan
          ivalid = ivalid+1
       endif
    end do
    deallocate(notflagged)
    do ivisi=1, nvisi
       do ivalid=1,nvalid
          rdata(ivalid) = duv(rindexes(ivalid),ivisi)
          idata(ivalid) = duv(iindexes(ivalid),ivisi)
       enddo
       call uv_baseline_baseline(cnumbers,rdata,nvalid,degree,areal,breal,error)
       call uv_baseline_baseline(cnumbers,idata,nvalid,degree,aimag,bimag,error)
       do ichan=1,nchan
          call uv_spectral_getcols(ichan,cols)
          duv(cols(1),ivisi) =  duv(cols(1),ivisi)-(areal*ichan+breal)
          duv(cols(2),ivisi) =  duv(cols(2),ivisi)-(aimag*ichan+bimag)
       enddo
    enddo
1000 format(i4,a38) 
  end subroutine uv_baseline_sub
  !
  subroutine uv_baseline_baseline(xdata,ydata,npoints,degree,acoeff,bcoeff,error)
    use gkernel_interfaces
    use gildas_def
    !----------------------------------------------------------
    ! Computes baseline from input arrays
    !----------------------------------------------------------
    integer(kind=index_length), allocatable, intent(in)  :: xdata(:)
    real,                       allocatable, intent(in)  :: ydata(:)
    integer,                                 intent(in)  :: npoints
    integer,                                 intent(in)  :: degree
    real,                                    intent(out) :: acoeff
    real,                                    intent(out) :: bcoeff
    logical,                                 intent(out) :: error
    !
    real              :: sumx  ! Sum of xdata
    real              :: sumy  ! Sum of y data
    real              :: sumxy ! Sum of x*y
    real              :: sumxx ! Sum of x^2
    real              :: delta ! midway coefficient
    real, allocatable :: warr(:) ! allocatable workhorse array
    integer           :: ier   ! error flag
    character(len=*), parameter :: rname='UV_BASELINE'
    !
    if (degree.eq.0) then
       acoeff = 0.0
       bcoeff = sum(ydata)/npoints
    else if (degree.eq.1)then
       allocate(warr(npoints),stat=ier)
       if (failed_allocate(rname,'Work array',ier,error))  return
       sumx = sum(xdata)
       sumy = sum(ydata)
       warr = xdata**2
       sumxx = sum(warr)
       warr = xdata*ydata
       sumxy = sum(warr)
       delta = (npoints*sumxx-sumx**2)
       bcoeff = (sumxx*sumy-sumx*sumxy)/delta
       acoeff = (npoints*sumxy-sumx*sumy)/delta
       deallocate(warr)
    endif
  end subroutine uv_baseline_baseline
end module uv_baseline
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
subroutine gdf_read_uvonly(huv,uv,error)
  use gio_interfaces, except_this=>gdf_read_uvonly
  use image_def
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Read the UV data of a GILDAS UV structure
  !       UVT and TUV order are allowed...
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: huv               ! UV table descriptor
  real(kind=4), intent(out) :: uv(huv%gil%nvisi,2)  ! Return U,V coordinates
  logical, intent(out) :: error                     ! Flag
  !
  integer(kind=size_length) :: mydims(gdf_maxdims)
  integer :: i
  integer :: is,ms,jcode,codes(2), form, ier
  real(kind=4), allocatable :: work(:,:)
  character(len=*), parameter :: rname = 'GDF_READ_UVONLY'
  !
  huv%status = code_read_image
  !
  is = huv%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such UV data')
    error = .true.
    return
  endif
  !
  huv%blc = 0
  huv%trc = 0
  !
  if (huv%gil%type_gdf.eq.code_gdf_tuv) then
    huv%status = code_read_image
    !
    ! Reshape slot to current image shape
    mydims = huv%gil%dim
    call gio_cdim(is,huv%gil%ndim,mydims)
    !
    ! Compute the BLC, TRC
    codes = (/code_uvt_u,code_uvt_v/)
    do i = 1, 2
      jcode = codes(i)
      huv%blc(2) = huv%gil%column_pointer(jcode)
      huv%trc(2) = huv%gil%column_pointer(jcode)+huv%gil%column_size(jcode)-1
      !
      ! Now test the type of data
      form = fmt_r4
      if (iconv(is).ne.0 .and. huv%gil%column_size(jcode).eq.2) then
        allocate (work(2,huv%gil%nvisi),stat=ier)
        call gio_dams(ms,is,huv%blc,huv%trc,work,form,error)
        call gio_swap4to8 (work,huv%gil%nvisi)
        call r8tor4(work,uv(1,i),huv%gil%nvisi)
        deallocate (work,stat=ier)
      else
        call gio_dams(ms,is,huv%blc,huv%trc,uv(:,i),form,error)
      endif
      call gio_frms(ms,error)
    enddo
    huv%status = 0
  !
  else if (huv%gil%type_gdf.eq.code_gdf_uvt) then
    !
    ! Compute the BLC, TRC
    codes = (/code_uvt_u,code_uvt_v/)
    allocate (work(2,huv%gil%nvisi),stat=ier)
    call gdf_read_uvonly_codes(huv,work,codes,2,error)
    uv = transpose(work)
    deallocate (work,stat=ier)
  else
    call gio_message(seve%e,rname,'Data set is not a UV data')
    error = .true.
    return
  endif
end subroutine gdf_read_uvonly
!
subroutine gdf_read_uvonly_codes(huv,uv,codes,ncode,error)
  use gio_interfaces, except_this=>gdf_read_uvonly_codes
  use image_def
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Read the Time-Baseline data of a GILDAS UV structure
  !       UVT and TUV order are allowed...
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: huv               ! UV table descriptor
  integer(4), intent(in) :: ncode                   ! Number of codes
  integer(4), intent(in) :: codes(ncode)            ! Desired codes
  real(kind=4), intent(out) :: uv(ncode,huv%gil%nvisi)  ! Return Values
  logical, intent(out) :: error                     ! Flag
  !
  real, allocatable :: duvin(:,:)
  integer(kind=index_length) :: nleft, nblock, next, kblock, iv, kv, jv, i
  integer(kind=4) :: ipin, ipou, isin, isou, l
  real :: next_percentage, percentage_step
  character(len=80) :: mess
  !
  integer(kind=size_length) :: mydims(gdf_maxdims)
  integer(kind=index_length) :: j
  integer :: is,ms,jcode, form, ier
  real, allocatable :: work(:,:)
  character(len=*), parameter :: rname = 'GDF_READ_UVONLY_CODES'
  logical :: warn
  !
  huv%status = code_read_image
  form = fmt_r4
  !
  is = huv%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such UV data')
    error = .true.
    return
  endif
  !
  ! Check if Code is present
  do i = 1, ncode
    jcode = codes(i)
    ipin = huv%gil%column_pointer(jcode)
    isin = huv%gil%column_size(jcode)
    !!Print *,l,'Ipin ',ipin,isin,'Ipou ',ipou,isou
    if (isin.eq.0) then
      write(mess,'(A,I6,A,I6,I6)') 'Column ',jcode,' not found in UV table'
      warn = .true.
    else if (ipin+isin-1 .gt. huv%gil%dim(1)) then
      write(mess,'(A,I6,A,I6,I6)') '#1 Inconsistent input UV Table: Column ',jcode,' out of bound ', &
      huv%gil%dim(1),jcode
      warn = .true.
    else
      warn = .false.
    endif
    if (warn) then
      error = .true.
      call gio_message(seve%w,rname,mess)
    endif
  enddo
  if (error) return
  !
  huv%blc = 0
  huv%trc = 0
  !
  if (huv%gil%type_gdf.eq.code_gdf_tuv) then
    ! Read a TUV order table.  Simply get the right columns then,
    ! and put in place by a transposition
    mydims = huv%gil%dim
    call gio_cdim(is,huv%gil%ndim,mydims)
    allocate (work(huv%gil%nvisi,2),stat=ier)
    !
    do i = 1, ncode
      jcode = codes(i)
      huv%blc(2) = huv%gil%column_pointer(jcode)
      huv%trc(2) = huv%gil%column_pointer(jcode)+huv%gil%column_size(jcode)-1
      !
      ! Now test the type of data
      form = fmt_r4
      call gio_dams(ms,is,huv%blc,huv%trc,work,form,error)
      if (iconv(is).ne.0 .and. huv%gil%column_size(jcode).eq.2) then
        call gio_swap4to8 (work,huv%gil%nvisi)
        do j=1,huv%gil%nvisi
          call r8tor4(work(j,1),uv(i,j),1)
        enddo
      else
        do j=1,huv%gil%nvisi
          uv(i,j) = work(j,1)
        enddo
      endif
      !
      call gio_frms(ms,error)
    enddo
    deallocate (work)
    !
  else if (huv%gil%type_gdf.eq.code_gdf_uvt) then
    !
    ! Reshape slot to current image shape
    mydims = huv%gil%dim
    call gio_cdim(is,huv%gil%ndim,mydims)
    !
    ! Doing this visibility by visibility is a catastrophy.
    ! We need to do that by reading by blocks...
    !
    ! Read and extract by block
    nblock = 1024
    kblock = huv%gil%dim(2)/nblock
    if (kblock.lt.10) then
       percentage_step = 100.
    else if (kblock.lt.100) then
       percentage_step = 25.
    else
       percentage_step = 10.
    endif
    !
    ! We do not use the "non-contiguous" subset mode of gdf_read_data
    ! as it would allocate the minimally contiguous subset anyway.
    !
    huv%blc = 0
    huv%trc = 0
    allocate (duvin(huv%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
    next_percentage = percentage_step
    next = next_percentage*(huv%gil%dim(2)/100)
    write(*,'(A)',ADVANCE="NO") 'Read % '
    do iv =1, huv%gil%dim(2), nblock
      huv%blc(2) = iv
      nleft = min (nblock,huv%gil%dim(2)-iv+1)
      huv%trc(2) = iv+nleft-1
      call gdf_read_data (huv,duvin,error)
      if (error) then
        deallocate(duvin)
        return
      endif
      if (iv.lt.next.and.iv+nleft.gt.next) then
        write(*,'(F6.0)',ADVANCE="NO") next_percentage
        next_percentage = next_percentage+percentage_step
        next = next_percentage*(huv%gil%dim(2)/100)
      endif
      !
      ! The required columns ...
      do i = 1, ncode
        jcode = codes(i)
        ipin = huv%gil%column_pointer(jcode)
        isin = huv%gil%column_size(jcode)
        if (ipin+isin-1 .gt. huv%gil%dim(1)) then
          write(mess,'(A,I6,A,I6,I6)') '#2 Inconsistent input UV Table: Column ',l,' out of bound ', &
          huv%gil%dim(1),jcode
          call gio_message(seve%w,rname,mess)
          Print *,l,'Ipin ',ipin,isin,'Ipou ',ipou,isou
          cycle
        endif
        !
        jv = iv
        do kv = 1,nleft
          if (isin.eq.2) then
            call r8tor4 (duvin(ipin,kv), uv(i,jv), 1)
          else
            uv(i,jv) = duvin(ipin,kv)
          endif
          jv = jv+1
        enddo
      enddo
      !
    enddo
    write(*,'(A)') '  ... Done '
    deallocate(duvin)
    !
  else
    call gio_message(seve%e,rname,'Data set is not a UV data')
    error = .true.
    return
  endif
  !
  huv%status = 0
  huv%loca%getvm = .false.
  !!write(99,*) 'Tested gdf_read_uvonly_codes ',huv%loca%size
end subroutine gdf_read_uvonly_codes
!
subroutine gio_swap4to8 (work,n)
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  integer(kind=4) :: n
  integer(kind=4) :: work(2,n)
  ! Local
  integer(kind=4) :: l
  integer(kind=4) :: itmp
  !
  do l=1,n
    itmp = work(1,l)
    work(1,l) = work(2,l)
    work(2,l) = itmp
  enddo
  !
end subroutine gio_swap4to8
!
subroutine gdf_read_uvall (huv,array,error)
  use gio_interfaces
  use image_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !       Read data from a GILDAS UV structure and
  !       place it in the specified array
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huv       ! Image descriptor
  real(kind=4), intent(inout) :: array(*)  ! Data
  logical,      intent(out)   :: error     ! Flag
  ! Local
  integer(kind=4) :: is,ms,form
  integer(kind=size_length) :: mydims(gdf_maxdims), ip, l, i, istart
  character(len=*), parameter :: rname = 'GDF_READ_UVDATA'
  logical :: do_conv
  !
  huv%status = code_read_data
  is = huv%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such UV data')
    error = .true.
    return
  endif
  !
  ! Only valid for a full array
  if (any(huv%blc.ne.0) .or. any(huv%trc.ne.0)) then
    call gio_message(seve%e,rname,'Only valid for all channels')
    error = .true.
    return
  endif
  !
  ! Case  UVT
  if (huv%gil%type_gdf.eq.code_gdf_uvt) then
    mydims = huv%gil%dim
      !!  call gdf_print_header(huv)
    call gio_cdim(is,huv%gil%ndim,mydims)
    form = fmt_r4
    ! Read data
    !!Print *,'DAMS ', huv%blc,huv%trc
    call gio_dams(ms,is,huv%blc,huv%trc,array,form,error)
    !!Print *,'DAMS ', huv%gil%ndim,huv%gil%dim
    if (error) return
    !
    ! Free it
    call gio_frms(ms,error)
    huv%loca%mslo = ms
    huv%status = 0
    !
    ! Check if any conversion must be applied
    if (iconv(is).lt.0) return
    !
    ! Convert the extra values
    do_conv = maxval(huv%gil%column_size).gt.1
    !
    if (do_conv) then
      ip = 0
      do l=1,huv%gil%nvisi
        do i=1,code_uvt_last
          if (huv%gil%column_size(i).eq.2) then
            istart = huv%gil%column_pointer(i)
            call gio_swap4to8 (array(ip+istart),1)
          endif
        enddo
        ip = ip+huv%gil%dim(1)
      enddo
    endif
    !
    ! Case  TUV
  else if (huv%gil%type_gdf.eq.code_gdf_tuv) then
    mydims = huv%gil%dim
    call gio_cdim(is,huv%gil%ndim,mydims)
    form = fmt_r4
    ! Read data
    !!Print *,'DAMS ', huv%blc,huv%trc
    call gio_dams(ms,is,huv%blc,huv%trc,array,form,error)
    !!Print *,'DAMS ', huv%gil%ndim,huv%gil%dim
    if (error) return
    !
    ! Free it
    call gio_frms(ms,error)
    huv%loca%mslo = ms
    huv%status = 0
    !
    ! Check if any conversion must be applied
    if (iconv(is).lt.0) return
    !
    ! Convert the extra columns
    do i=1,code_uvt_last
      if (huv%gil%column_size(i).eq.2) then
        istart = (huv%gil%column_pointer(i)-1)*huv%gil%nvisi + 1
        call gio_swap4to8 (array(istart),huv%gil%nvisi)
      endif
    enddo
    !
  else
    call gio_message(seve%e,rname,'Data set is not a UV data')
    error = .true.
    return
  endif
end subroutine gdf_read_uvall
!
subroutine gdf_write_uvall(huv,array,error)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces
  use gio_image
  !---------------------------------------------------------------------
  ! @ no-interface  (Yet...)
  !       Write UV data to an image file specified
  !       by its image structure. The image must have been
  !       opened for write before
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huv        ! Image descriptor
  real, intent(inout) :: array(*)           ! Data
  logical, intent(out) :: error             ! Flag
  ! Local
  integer :: ms, is, form
  integer(kind=size_length) :: mydims(gdf_maxdims), i, l, ip, istart
  character(len=*), parameter :: rname = 'GDF_WRITE_UVDATA'
  logical :: do_conv
  !
  huv%status = code_write_data
  is = huv%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such UV data set')
    error = .true.
    return
  endif
  ! Reshape slot to current image shape
  mydims = huv%gil%dim
  call gio_cdim(is,huv%gil%ndim,mydims)
  !
  ! Only valid for a full array
  if (any(huv%blc.ne.0) .or. any(huv%trc.ne.0)) then
    call gio_message(seve%e,rname,'Only valid for all channels')
    error = .true.
    return
  endif
  !
  ! Check if any conversion
  do_conv = .false.
  if (iconv(is).ge.0) then
    do i=1,code_uvt_last
      if (huv%gil%column_size(i).eq.2) then
        do_conv =.true.
        exit
      endif
    enddo
  endif
  !
  mydims = huv%gil%dim
  call gio_cdim(is,huv%gil%ndim,mydims)
  form = fmt_r4
  !
  ! Case  UVT
  if (huv%gil%type_gdf.eq.code_gdf_uvt) then
    if (do_conv) then
      ip = 0
      do l=1,huv%gil%nvisi
        do i=1,code_uvt_last
          if (huv%gil%column_size(i).eq.2) then
            istart = huv%gil%column_pointer(i)
            call gio_swap4to8 (array(ip+istart),1)
          endif
        enddo
        ip = ip+huv%gil%dim(1)
      enddo
    endif
    !
    ! Associate pre-defined memory area to image
    huv%loca%addr = locwrd(array)
    call gio_pums (ms,is,huv%blc,huv%trc,huv%loca%addr,huv%gil%form,error)
    if (error) return
    !
    ! Dump to disk
    call gio_frms(ms,error)
    !
    ! Re-establish the proper Word order if needed
    if (do_conv) then
      ip = 0
      do l=1,huv%gil%nvisi
        do i=1,code_uvt_last
          if (huv%gil%column_size(i).eq.2) then
            istart = huv%gil%column_pointer(i)
            call gio_swap4to8 (array(ip+istart),1)
          endif
        enddo
        ip = ip+huv%gil%dim(1)
      enddo
    endif
    !
    ! Case  TUV
  else if (huv%gil%type_gdf.eq.code_gdf_tuv) then
    !
    ! Convert the extra columns
    if (do_conv) then
      do i=1,code_uvt_last
        if (huv%gil%column_size(i).eq.2) then
          istart = (huv%gil%column_pointer(i)-1)*huv%gil%nvisi + 1
          call gio_swap4to8 (array(istart),huv%gil%nvisi)
        endif
      enddo
    endif
    !
    ! Associate pre-defined memory area to image
    huv%loca%addr = locwrd(array)
    call gio_pums (ms,is,huv%blc,huv%trc,huv%loca%addr,huv%gil%form,error)
    if (error) return
    !
    ! Dump to disk
    call gio_frms(ms,error)
    !
    ! Re-establish the proper Word order if needed
    if (do_conv) then
      do i=1,code_uvt_last
        if (huv%gil%column_size(i).eq.2) then
          istart = (huv%gil%column_pointer(i)-1)*huv%gil%nvisi + 1
          call gio_swap4to8 (array(istart),huv%gil%nvisi)
        endif
      enddo
    endif
    !
  else
    call gio_message(seve%e,rname,'Data set is not a UV data')
    error = .true.
    return
  endif
  !
  huv%loca%mslo = ms
  huv%status = 0
end subroutine gdf_write_uvall
!
subroutine gdf_read_uvdataset(huvin,huvou,nc,duvou,error)
  use gio_interfaces, except_this=>gdf_read_uvdataset
  use image_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  !       Read UV data and Associated parameters from a GILDAS UV
  !       structure and place it in the specified array
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huvin     ! Input UV header (data file)
  type(gildas), intent(inout) :: huvou     ! Output UV header (program used)
  integer(kind=4), intent(in) :: nc(2)     ! Selected channels
  real(kind=4), intent(inout) :: duvou(huvou%gil%dim(1),huvou%gil%dim(2))  ! Data
  logical,      intent(out)   :: error     ! Flag
  !
  ! Local
  character(len=*), parameter :: rname = 'GDF_READ_UVDATASET'
  real, allocatable :: duvin(:,:)
  integer(kind=index_length) :: nleft, nblock, next, kblock, iv, kv, jv, i
  integer(kind=4) :: ipin, ipou, isin, isou, l, is, local_nc(2)
  real :: next_percentage, percentage_step
  integer :: ier, imiss, imore, nstok
  integer :: ifcol, ofcol, ilcol, olcol, nchan
  integer :: istart, iend
  character(len=80) :: mess
  !
  huvin%status = code_read_data
  is = huvin%loca%islo
  if (gdf_stis(is).eq.-1) then
    call gio_message(seve%e,rname,'No such UV data')
    error = .true.
    return
  endif
  !
  if (any(huvin%gil%dim(1:2).eq.0)) then
    call gio_message(seve%e,rname,'Empty UV data set')
    error = .true.
    return
  endif
  !
  local_nc = nc
  ier = gdf_range(local_nc, huvin%gil%nchan)
  if (ier.ne.0) then
    call gio_message(seve%e,rname,'Invalid channel range')
    error = .true.
    return
  endif
  !
  ! Get the subset boundaries
  nchan = local_nc(2)-local_nc(1)+1
  ofcol = huvou%gil%fcol
  olcol = huvou%gil%fcol+huvin%gil%natom*huvou%gil%nstokes*nchan-1  ! Or huvou%gil%natom
  huvou%gil%lcol = olcol  ! Precaution ?...
  ifcol = huvin%gil%fcol+huvin%gil%natom*huvin%gil%nstokes*(local_nc(1)-1)
  ilcol = huvin%gil%fcol+huvin%gil%natom*huvin%gil%nstokes*local_nc(2)-1
  !!Print *,'Range ',ifcol,ilcol, ofcol,olcol
  !!Print *,'OUT ',huvou%gil%dim
  ! Shift the trailing columns of the output table by the right amount
  do l=1,code_uvt_last
    if (huvou%gil%column_pointer(l).gt.huvin%gil%lcol) then
      !!Print *,'Shifting ',l,' by ',-huvin%gil%lcol+huvou%gil%lcol
      huvou%gil%column_pointer(l) = &
      huvou%gil%column_pointer(l)-huvin%gil%lcol+huvou%gil%lcol
    endif
  enddo
  !
  ! Shift the Frequency & Stokes arrays if present
  if (huvin%gil%nfreq.ne.0) then
    nstok = max(1,huvin%gil%nstokes)
    huvou%gil%nfreq = nchan * nstok
    if (associated(huvou%gil%freqs)) then
      deallocate(huvou%gil%freqs,huvou%gil%stokes,stat=ier)
      if (ier.ne.0) then
        call gio_message(seve%w,rname,'Frequency array deallocation error')
      endif
    endif
    allocate(huvou%gil%freqs(huvou%gil%nfreq),huvou%gil%stokes(huvou%gil%nfreq),stat=ier)
    if (ier.ne.0) then
      call gio_message(seve%e,rname,'Frequency array allocation error')
      error = .true.
      return
    endif
    !
    ! Each channel counts for NSTOK 
    istart = (local_nc(1)-1)*nstok + 1
    iend   = local_nc(2)*nstok
    huvou%gil%freqs(:) = huvin%gil%freqs(istart:iend)
    huvou%gil%stokes(:) = huvin%gil%stokes(istart:iend)
    !  Squeeze it if possible
    call gio_setuv_freq(huvou%gil,error)
    call gio_message(seve%i,rname,'Frequency array has been shifted')
  endif
  !
  imiss = 0
  imore = 0
  if (huvou%gil%type_gdf.eq.code_gdf_tuv) then
    call gio_message(seve%d,rname,'Producing a TUV order')
    if (huvin%gil%type_gdf.eq.code_gdf_tuv) then
      !
      ! Case  TUV in --> TUV out
      !
      ! Test "conforming" UV tables...
      if (local_nc(1).eq.1 .and. local_nc(2).eq.huvin%gil%nchan .and. &
       &  huvin%gil%dim(2).eq.huvou%gil%dim(2)) then
        call gdf_read_uvall(huvin,duvou,error)
        return
      endif
      !
      ! The associated stuff is also read Entity by Entity
      allocate (duvin(huvin%gil%nvisi,2), stat=ier)   ! Large enough to handle a Real*8 array
      if (ier.ne.0) then
        call gio_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      do l=1,code_uvt_last
        ipou = huvou%gil%column_pointer(l)
        isou = huvou%gil%column_size(l)
        ipin = huvin%gil%column_pointer(l)
        isin = huvin%gil%column_size(l)
        if (ipou.ne.0) then
          if (ipin.eq.0) then
            write(mess,'(A,I6,A)') 'Missing column of type ',l,' in input UV table'
            call gio_message(seve%w,rname,mess)
            imiss = code_gio_miscol
          else
            huvin%blc(2) = ipin
            huvin%trc(2) = ipin+isin-1
            call gdf_read_data(huvin,duvin,error)
            if (error) return
            !
            ! Swap converted Real*8 if needed
            if (isin.eq.2 .and. iconv(is).ne.0) call gio_swap4to8 (duvin, huvin%gil%nvisi)
            !
            ! Put in place and transform according to desired Format
            if (isin.eq.2) then
              if (isou.eq.2) then
                call r8tor8 (duvin, duvou(1,ipou), huvin%gil%nvisi)
              else
                call r8tor4 (duvin, duvou(1,ipou), huvin%gil%nvisi)
              endif
            else
              if (isou.eq.2) then
                call r4tor8 (duvin, duvou(1, ipou), huvin%gil%nvisi)
              else
                call r4tor4 (duvin, duvou(1, ipou), huvin%gil%nvisi)
              endif
            endif
          endif
        else if (ipin.ne.0) then
          imore = code_gio_extcol   ! Input column ignored...
        endif
      enddo
      deallocate (duvin, stat=ier)
      !
      ! The data block is read plane by plane...
      nblock = local_nc(2)-local_nc(1)+1
      huvin%blc(1) = 0
      huvin%trc(1) = 0
      !
      do i=1,nblock
        huvin%blc(2) = huvin%gil%natom*(local_nc(1)+i-2)+huvin%gil%fcol
        huvin%trc(2) = huvin%blc(2)+huvin%gil%natom-1
        call gdf_read_data(huvin,duvou(1,huvou%gil%fcol+huvou%gil%natom*(i-1)),error)
        if (error) return
      enddo
      !
    else
      ! Case  UVT in --> TUV out
      call gio_message(seve%w,rname,'Input UV data is not in TUV order')
      !
      ! Read and extract by block
      nblock = 1024
      kblock = huvin%gil%dim(2)/nblock
      if (kblock.lt.10) then
        percentage_step = 100.
      else if (kblock.lt.100) then
        percentage_step = 25.
      else
        percentage_step = 10.
      endif
      write(*,'(A)',ADVANCE="NO") 'Read % '
      !
      ! We do not use the "non-contiguous" subset mode of gdf_read_data
      ! as it would allocate the minimimally contiguous subset anyway.
      !
      huvin%blc = 0
      huvin%trc = 0
      allocate (duvin(huvin%gil%dim(1),nblock), stat=ier)
      if (ier.ne.0) then
        call gio_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      next_percentage = percentage_step
      next = next_percentage*(huvin%gil%dim(2)/100)
      do iv =1, huvin%gil%dim(2), nblock
        huvin%blc(2) = iv
        nleft = min (nblock,huvin%gil%dim(2)-iv+1)
        huvin%trc(2) = iv+nleft-1
        call gdf_read_data (huvin,duvin,error)
        if (error) then
          deallocate(duvin)
          return
        endif
        if (iv.lt.next.and.iv+nleft.gt.next) then
          write(*,'(F6.0)',ADVANCE="NO") next_percentage
          next_percentage = next_percentage+percentage_step
          next = next_percentage*(huvin%gil%dim(2)/100)
        endif
        !
        ! Now put it in place... Loop ordering inefficient as duvou is the
        ! biggest array ?... Will change later ?...
        jv = iv
        do kv = 1,nleft
          ! Channel data
          duvou(jv, ofcol:olcol) =  duvin (ifcol:ilcol, kv)
          jv = jv+1
        enddo
        !
        ! Associated stuff.
        do l=1,code_uvt_last
          ipou = huvou%gil%column_pointer(l)
          isou = huvou%gil%column_size(l)
          ipin = huvin%gil%column_pointer(l)
          isin = huvin%gil%column_size(l)
          if (isou.ne.0) then
            if (ipin.eq.0) then
              write(mess,'(A,I6,A)') 'Missing column of type ',l,' in input UV table'
              call gio_message(seve%w,rname,mess)
              imiss = code_gio_miscol
            else
              if (isin.eq.2 .and. iconv(is).ne.0) call gio_swap4to8 (duvin, 1)
              jv = iv
              do kv = 1,nleft
                if (isin.eq.2) then
                  if (isou.eq.2) then
                    call r8tor8 (duvin(ipin, kv), duvou(jv,ipou), 1)
                  else if (isou.eq.1) then
                    call r8tor4 (duvin(ipin, kv), duvou(jv,ipou), 1)
                  endif
                else if (isin.eq.1) then
                  if (isou.eq.2) then
                    call r4tor8 (duvin (ipin, kv), duvou(jv,ipou), 1)
                  else if (isou.eq.1) then
                    duvou(jv,ipou) = duvin(ipin,kv)
                  endif
                endif
                jv = jv+1
              enddo
            endif
          else if (isin.ne.0) then
            imore = code_gio_extcol
          endif              ! isou
        enddo                ! l
      enddo                  ! block
      !
      write(*,'(A)') ' ...Done'
      deallocate(duvin)
    endif
  else if (huvou%gil%type_gdf.eq.code_gdf_uvt) then
    call gio_message(seve%d,rname,'Producing a UVT order')
    !
    if (huvin%gil%type_gdf.eq.code_gdf_uvt) then
      ! Case  UVT --> UVT
      if (local_nc(1).eq.1 .and. local_nc(2).eq.huvin%gil%nchan .and. &
       &  huvin%gil%dim(1).eq.huvou%gil%dim(1)) then
        call gdf_read_uvall(huvin,duvou,error)
        return
      endif
      !
      ! Read and extract by block
      nblock = 1024
      kblock = huvin%gil%dim(2)/nblock
      if (kblock.lt.10) then
         percentage_step = 100.
      else if (kblock.lt.100) then
         percentage_step = 25.
      else
         percentage_step = 10.
      endif
      !
      ! We do not use the "non-contiguous" subset mode of gdf_read_data
      ! as it would allocate the minimally contiguous subset anyway.
      !
      huvin%blc = 0
      huvin%trc = 0
      allocate (duvin(huvin%gil%dim(1),nblock), stat=ier)
      if (ier.ne.0) then
        error = .true.
        return
      endif
      next_percentage = percentage_step
      next = next_percentage*(huvin%gil%dim(2)/100)
      do iv =1, huvin%gil%dim(2), nblock
        huvin%blc(2) = iv
        nleft = min (nblock,huvin%gil%dim(2)-iv+1)
        huvin%trc(2) = iv+nleft-1
        call gdf_read_data (huvin,duvin,error)
        if (error) then
          deallocate(duvin)
          return
        endif
        if (iv.lt.next.and.iv+nleft.gt.next) then
          if (next_percentage.eq.percentage_step) then
            write(*,'(A,F6.0)',ADVANCE="NO") 'Read % ',next_percentage
          else
            write(*,'(F6.0)',ADVANCE="NO") next_percentage
          endif
          next_percentage = next_percentage+percentage_step
          next = next_percentage*(huvin%gil%dim(2)/100)
        endif
        !
        ! Now put it in place...
        ! Channel data
        !!Print *, 'OFCOL ', ofcol, olcol, huvou%gil%dim(1)
        !!Print *, 'IFCOL ', ifcol, ilcol, huvin%gil%dim(1)
        !!Print *,'IV ',iv,iv+nleft-1,huvou%gil%dim(2)
        duvou(ofcol:olcol, iv:iv+nleft-1) =  duvin (ifcol:ilcol, 1:nleft)
        !
        ! Associated stuff
        do l=1,code_uvt_last
          ipou = huvou%gil%column_pointer(l)
          isou = huvou%gil%column_size(l)
          ipin = huvin%gil%column_pointer(l)
          isin = huvin%gil%column_size(l)
          !!Print *,l,'Ipin ',ipin,isin,'Ipou ',ipou,isou
          if (ipin+isin-1 .gt. huvin%gil%dim(1)) then
            write(mess,'(A,I6,A,I6)') '#3 Inconsistent input UV Table: Column ',l,' out of bound ', &
            huvin%gil%dim(1)
            call gio_message(seve%w,rname,mess)
            Print *,l,'Ipin ',ipin,isin,'Ipou ',ipou,isou
            cycle
          endif
          if (ipou+isou-1 .gt. huvou%gil%dim(1)) then
            write(mess,'(A,I6,A,I6)') 'Inconsistent output UV Table: Column ',l,' out of bound ', &
            huvou%gil%dim(1)
            call gio_message(seve%w,rname,mess)
            Print *,l,'Ipin ',ipin,isin,'Ipou ',ipou,isou
            cycle
          endif
          if (isou.ne.0) then
            if (ipin.eq.0) then
              write(mess,'(A,I6,A)') 'Missing column of type ',l,' in input UV table'
              call gio_message(seve%w,rname,mess)
              imiss = code_gio_miscol
            else
              jv = iv
              do kv = 1,nleft
                if (isin.eq.2) then
                  if (isou.eq.2) then
                    if (iconv(is).ne.0) call gio_swap4to8 (duvin(ipin,kv), 1)
                    call r8tor8 (duvin (ipin, kv), duvou(ipou,jv), 1)
                  else if (isou.eq.1) then
                    call r8tor4 (duvin(ipin, kv), duvou(ipou, jv), 1)
                  endif
                else if (isin.eq.1) then
                  if (isou.eq.2) then
                    call r4tor8 (duvin (ipin, kv), duvou(ipou,jv), 1)
                  else if (isou.eq.1) then
                    duvou(ipou, jv) = duvin(ipin, kv)
                  endif
                endif
                jv = jv+1
              enddo
            endif
          else if (isin.ne.0) then
            imore = code_gio_extcol
          endif
        enddo
      enddo
      !
      write(*,'(A)') ' ...Done'
      deallocate(duvin)
      !
    else if (huvin%gil%type_gdf.eq.code_gdf_tuv) then
      !
      ! Case  TUV --> UVT
      call gio_message(seve%w,rname,'Input data is in TUV order')
      !
      ! The data block is read plane by plane...
      allocate (duvin(huvin%gil%dim(1),max(huvin%gil%natom,2)), stat=ier)  ! Large enough to handle a Real*8
      if (ier.ne.0) then
        error = .true.
        return
      endif
      !
      nblock = local_nc(2)-local_nc(1)+1
      huvin%blc = 0
      huvin%trc = 0
      !
      do i=1,nblock
        huvin%blc(2) = huvin%gil%natom*(local_nc(1)+i-2)+huvin%gil%fcol
        huvin%trc(2) = huvin%blc(2)+huvin%gil%natom-1
        call gdf_read_data(huvin,duvin,error)
        if (error) return
        do iv = 1,huvou%gil%nvisi
           duvou(ofcol+huvou%gil%natom*(i-1):ofcol+huvou%gil%natom*i-1,iv) = duvin(iv,1:huvin%gil%natom)
        enddo
      enddo
      !
      ! The associated stuff is also read Entity by Entity
      do l=1,code_uvt_last
        ipou = huvou%gil%column_pointer(l)
        isou = huvou%gil%column_size(l)
        ipin = huvin%gil%column_pointer(l)
        isin = huvin%gil%column_size(l)
        if (ipou.ne.0) then
          if (ipin.eq.0) then
            write(mess,'(A,I6,A)') 'Missing column of type ',l,' in input UV table'
            call gio_message(seve%w,rname,mess)
            imiss = code_gio_miscol
          else
            huvin%blc(2) = ipin
            huvin%trc(2) = ipin+isin-1
            call gdf_read_data(huvin,duvin,error)
            if (error) return
            !
            ! Swap converted Real*8 if needed
            if (isin.eq.2 .and. iconv(is).ne.0) call gio_swap4to8 (duvin, huvin%gil%nvisi)
            !
            ! Put in place and transform according to desired Format
            if (isin.eq.2) then
              if (isou.eq.2) then
                do iv = 1,huvin%gil%nvisi
                  call r8tor8 (duvin(iv,1), duvou(ipou, iv), 1)
                enddo
              else
                do iv = 1,huvin%gil%nvisi
                  call r8tor4 (duvin(iv,1), duvou(ipou, iv), 1)
                enddo
              endif
            else
              if (isou.eq.2) then
                do iv = 1,huvin%gil%nvisi
                  call r4tor8 (duvin(iv,1), duvou(ipou, iv), 1)
                enddo
              else
                do iv = 1,huvin%gil%nvisi
                  duvou(ipou, iv) = duvin(iv,1)
                enddo
              endif
            endif
          endif
        else if (isin.ne.0) then
          imore = code_gio_extcol
        endif
      enddo
      deallocate (duvin,stat=ier)
      !
    else
      call gio_message(seve%e,rname,'Input Data set is not a UV data')
      error = .true.
      return
    endif
  else
    call gio_message(seve%e,rname,'Output Data set is not a UV data')
    error = .true.
    return
  endif
  if (imiss.ne.0) error = .true.
  huvou%status = imiss + imore
end subroutine gdf_read_uvdataset

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_spasamp_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_unit
  use cubetopology_messaging
  !
  public :: spasamp_opt_t,spasamp_user_t,spasamp_prog_t
  private
  !
  type spasamp_opt_t
     type(option_t),   pointer :: opt
     type(unit_arg_t), pointer :: unit
   contains
     procedure :: register  => cubetopology_spasamp_register
     procedure :: parse     => cubetopology_spasamp_parse
  end type spasamp_opt_t
  !
  type spasamp_user_t
     logical               :: do = .false.
     character(len=argu_l) :: x = strg_star
     character(len=argu_l) :: y = strg_star
     character(len=argu_l) :: unit = strg_star
   contains
     procedure :: init   => cubetopology_spasamp_user_init
     procedure :: toprog => cubetopology_spasamp_user_toprog 
     procedure :: list   => cubetopology_spasamp_user_list
  end type spasamp_user_t
  !
  type spasamp_prog_t
     real(kind=coor_k) :: x = 0d0
     real(kind=coor_k) :: y = 0d0
     integer(kind=code_k) :: unit = code_unit_unk
  end type spasamp_prog_t
  !
contains
  !
  subroutine cubetopology_spasamp_register(samp,name,abstract,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_opt_t), intent(out)   :: samp
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: abstract
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(unit_arg_t) :: unitarg
    character(len=*), parameter :: rname='SAMPLING>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'xsampling [ysampling [unit]]',&
         abstract,&
         strg_emp,&
         samp%opt,&
         error)
    if (error) return
    call stdarg%register(&
         'xsampling','Sampling along the X coordinate',&
         'Depending on the unit, sampling step or number of samples across&
         & the active range along the X axis. "*" uses the default&
         & sampling along this axis.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'ysampling','Sampling along the Y coordinate',&
         'Depending on the unit, sampling step or number of samples across&
         & the active range along the Y axis. If omitted or "*", use the&
         & default sampling along this axis.',&
         & code_arg_optional,&
         error)
    if (error) return
    call unitarg%register(&
         'unit',&
         'Sampling unit',&
         '"*" or "=" uses current FOV unit. "BOX" changes the&
         & interpretation of xsampling and ysampling to the number&
         & of samples along the active range of the axis. The default&
         & is to sample every beam width for FOV unit and to get 10 boxes&
         & along the axis when the BOX token is used.',&
         code_arg_optional,&
         code_unit_fov,&
         samp%unit,&
         error)
    if (error) return
  end subroutine cubetopology_spasamp_register
  !
  subroutine cubetopology_spasamp_parse(samp,line,user,error)
    !----------------------------------------------------------------------
    ! /SAMPLING x y [unit]
    !----------------------------------------------------------------------
    class(spasamp_opt_t), intent(in)    :: samp  
    character(len=*),     intent(in)    :: line
    type(spasamp_user_t), intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPASAMP>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    user%x = strg_star
    user%y = strg_star
    user%unit = strg_star
    !
    call samp%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,samp%opt,1,user%x,mandatory,error)
       if (error) return
       call cubetools_getarg(line,samp%opt,2,user%y,.not.mandatory,error)
       if (error) return
       call cubetools_getarg(line,samp%opt,3,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetopology_spasamp_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_spasamp_user_init(sampling,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of sampling to out
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(out)   :: sampling 
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPASAMP>USER>INIT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
  end subroutine cubetopology_spasamp_user_init
  !
  subroutine cubetopology_spasamp_user_toprog(user,cube,prog,error)
    use cubetools_user2prog
    use cubetools_header_methods
    use cube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(in)    :: user
    type(cube_t),          intent(in)    :: cube
    type(spasamp_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    type(unit_user_t) :: unit
    real(kind=beam_k) :: radius
    real(kind=coor_k) :: default
    character(len=*), parameter :: rname='SPASAMP>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    ! *** JP Some disambiguization would be needed here
    call sic_upper(user%unit)
    if (user%unit.eq.'BOX') then
       prog%unit = code_unit_pixe
       call unit%get_from_code(code_unit_pixe,error)
       if (error) return
       default = 10 ! boxes
       prog%x = 10
       prog%y = 10
    else
       prog%unit = code_unit_fov
       call unit%get_from_name_for_code(user%unit,code_unit_fov,error)
       if (error) return
       call cubetools_header_beamradius(cube%head,radius,error)
       if (error) return
       default = radius
       prog%x = radius
       prog%y = radius
    endif
    call cubetools_user2prog_resolve_star(user%x,unit,default,prog%x,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%y,unit,default,prog%y,error)
    if (error) return
  end subroutine cubetopology_spasamp_user_toprog
  !
  subroutine cubetopology_spasamp_user_list(samp,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spasamp_user_t), intent(in)    :: samp 
    logical,               intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPASAMP>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    write(mess,'(6a)') &
         'Sampling  : (',trim(samp%x),',',trim(samp%y),') ',samp%unit
    call cubetopology_message(seve%r,rname,mess)
  end subroutine cubetopology_spasamp_user_list
end module cubetopology_spasamp_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_package
  use cubetools_parameters
  use cubesyntax_messaging
  use cubelist_types
  use cubetools_terminal_tool
  use cubetools_language
  !
  public :: lang_k
  public :: package_t
  private
  !
  integer(kind=4), parameter :: lang_k =  4 ! [integer] Languages
  integer(kind=4), parameter :: pack_l = 16
  integer(kind=4), parameter :: help_l = 80
  !
  type package_t
     character(len=pack_l) :: name = strg_unk
     character(len=help_l) :: help = strg_emp
     type(list_t)          :: lang
   contains
     ! General
     procedure :: init             => cubetools_package_init
     procedure :: final            => cubetools_package_final
     procedure :: free             => cubetools_package_free
     !
     ! Registering
     procedure :: put              => cubetools_package_put
     !
     ! Execution
     procedure :: get_language_id  => cubetools_package_get_language_id
     !
     ! Print and Help
     procedure :: abstract         => cubetools_package_abstract
     procedure :: list             => cubetools_package_list
     procedure :: help_iterate     => cubetools_package_help_iterate
  end type package_t
  !
contains
  !
  !---General------------------------------------------------------------
  !
  subroutine cubetools_package_init(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(out)   :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_package_init
  !
  subroutine cubetools_package_final(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_package_free(pack,error)
    if (error) return
  end subroutine cubetools_package_final
  !
  subroutine cubetools_package_free(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>FREE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%lang%final(error)
    if (error) return
  end subroutine cubetools_package_free
  !
  !---Registering--------------------------------------------------------
  !
  subroutine cubetools_package_put(pack,name,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t),     intent(inout) :: pack
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: help
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%final(error)
    if (error) return
    call pack%init(error)
    if (error) return
    pack%name = name
    pack%help = help
    pack%lang%n = 0
  end subroutine cubetools_package_put
  !
  !---Execution----------------------------------------------------------
  !
  subroutine cubetools_package_get_language_id(pack,langname,langid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t),     intent(in)    :: pack
    character(len=*),     intent(in)    :: langname
    integer(kind=lang_k), intent(out)   :: langid
    logical,              intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>GET>LANGUAGE>ID'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do ilang = 1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      if (lang%name.eq.langname) then
        langid = ilang
        return
      endif
    enddo ! ilang
    !
    ! Not found
    langid = 0
    call cubesyntax_message(seve%e,rname,'Unknown language '//trim(langname)//' in package '//trim(pack%name))
    error = .true.
    return
  end subroutine cubetools_package_get_language_id
  !
  !---Print-and-Help-------------------------------------------------------
  !
  subroutine cubetools_package_help_iterate(pack,forma,error)
    use cubetools_parameters
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(package_t),     intent(in)    :: pack
    integer(kind=code_k), intent(in)    :: forma
    logical,              intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>HELP>ITERATE'
    !
    select case (forma)
    case (help_format_tex)
      call cubetools_package_help_iterate_tex(pack,error)
      if (error)  return
    case default
      call cubesyntax_message(seve%e,rname,'Help format not implemented')
      error = .true.
      return
    end select
    !
    do ilang=1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      call lang%help_iterate(forma,error)
      if (error) return
    enddo
  end subroutine cubetools_package_help_iterate
  !
  subroutine cubetools_package_help_iterate_tex(pack,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(package_t), intent(in)    :: pack
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='PACKAGE>HELP>ITERATE>TEX'
    !
    call cubesyntax_message(syntaxseve%help,rname,'\chapter{'//trim(pack%name)//' On-Line Help}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(pack%name)//':package}')
    call cubesyntax_message(syntaxseve%help,rname,'\section{List of '//trim(pack%name)//' languages}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(pack%name)//':languages}')
    call cubesyntax_message(syntaxseve%help,rname,'\index{Language list}')
    !
    call cubesyntax_message(syntaxseve%help,rname,'\begin{PlusVerbatim}')
    call pack%list(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,'\end{PlusVerbatim}')
    call cubesyntax_message(syntaxseve%help,rname,'\newpage{}')
  end subroutine cubetools_package_help_iterate_tex
  !
  subroutine cubetools_package_abstract(pack,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(inout) :: pack
    logical,          intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PACKAGE>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(pack%name,pack%help,terminal%width())
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubetools_package_abstract
  !
  subroutine cubetools_package_list(pack,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(package_t), intent(in)    :: pack
    logical,          intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='PACKAGE>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do ilang = 1,pack%lang%n
      lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      call lang%print_abstract(error)
      if (error) return
    enddo ! ilang
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_package_list
  !
end module cubetools_package
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine cmplx_mul (out,in,n)
  use gildas_def
  !----------------------------------------------
  ! @ no-interface
  !   Complex multiplication
  !-----------------------------------------------
  integer(kind=size_length), intent(in) :: n     !
  real, intent(out) :: out(2,n)                  !
  real, intent(in) :: in(2,n)                    !
  ! Local
  integer(kind=size_length) :: i
  real ar,ai
  do i=1,n
    ar = in(1,i)*out(1,i)-in(2,i)*out(2,i)
    ai = in(1,i)*out(2,i)+in(2,i)*out(1,i)
    out(1,i) = ar
    out(2,i) = ai
  enddo
end subroutine cmplx_mul

subroutine mx_uvsort (x,y,uvtable,new,shift,uvmax,uvmin,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_format
  use image_def
  use uv_shift, only: uv_shift_header
  use uv_rotate_shift_and_sort_tool, only: uvsort_uv
  !---------------------------------------------------------------------
  ! GILDAS
  !   Sort an input UV table
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x            ! Unsorted UV table
  type(gildas), intent(inout) :: y            ! Sorted UV table
  character(len=*), intent(in) :: uvtable     ! Table name
  real(8), intent(inout) :: new(3)            ! New phase center
  logical, intent(inout) :: shift             ! Shift phase center ?
  real(4), intent(inout) :: uvmax             !
  real(4), intent(inout) :: uvmin             !
  logical, intent(out) :: error               ! Error flag
  !
  ! Local
  real(8) :: freq, off(3), dcol
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  real :: cs(2),pos(2)
  integer :: ier, nx, ny
  !
  error = .false.
  Print *,'MX_UVSORT shift ',shift
  !
  ! Set parameters
  call gildas_null(x, type = 'UVT')
  call gdf_copy_header (y, x, error)
  call sic_parse_file (uvtable, ' ', '.uvt-mx', x%file)
  !
  ! Correct for new phase center if required
  if (shift) then
    if (x%gil%ptyp.ne.p_azimuthal) then
      x%gil%a0 = x%gil%ra
      x%gil%d0 = x%gil%dec
      x%gil%pang = 0.
      x%gil%ptyp = p_azimuthal
    endif
    call uv_shift_header(new,x%gil%a0,x%gil%d0,x%gil%pang,off,shift)
    x%gil%posi_words = 12
    x%gil%proj_words = 9
    if (shift) then
      x%gil%a0 = new(1)
      x%gil%d0 = new(2)
      x%gil%pang = new(3)
    endif
  endif
  call gdf_create_image(x, error)
  if (error) return
  !
  ! Get visibilities
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), &
    & y%r2d(y%gil%dim(1),y%gil%dim(2)), stat=ier)
  Print *,'MX_UVSORT Allocate ',ier
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  call gdf_read_uvall(y,y%r2d,error)
  Print *,'MX_UVSORT Readall ',error
  !
  ! Compute observing frequency, and new phase center in wavelengths
  if (shift) then
    dcol = (x%gil%nchan+1)*0.5d0
    freq = gdf_uv_frequency(x,dcol)
    cs(1)  =  cos(off(3))
    cs(2)  = -sin(off(3))
    ! Note that the new phase center is counter-rotated because rotations
    ! are applied before phase shift.
    ! Corrected sign 4-Apr-1993
    pos(1) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
    pos(2) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
  else
    pos(1) = 0.0
    pos(2) = 0.0
    cs(1) = 1.0
    cs(2) = 0.0
  endif
  !
  nx = x%gil%dim(1)
  ny = x%gil%dim(2)
  call uvsort_uv (nx,ny,x%gil%ntrail, &
     &    y%r2d, x%r2d, pos,cs,uvmax,uvmin,error)
     Print *,'Done uvsortuv'
  if (.not.error) then
    call gdf_close_image(y, error)
    call gdf_write_uvall(x, x%r2d, error)
  endif
end subroutine mx_uvsort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
program uvshort_program
  use image_def
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! Task  UV_SHORT
  !
  !   Compute a short spacings uv table from a single-dish table
  !   by gridding, extending to 0, filtering in uv plane, multiplication
  !   by interferometer primary beam, and sampling in uv plane.
  !
  ! input:  a single-dish table or image, and optionally a mosaic UV Table
  ! output: a UV table
  !------------------------------------------------------------------------
  !
  type uvshort_user_t
     character(len=12)              :: action = "all"
     character(len=filename_length) :: name
     !
     real(kind=4)      :: postol = 0.10         ! [---|sec] Pointing tolerance (fraction of beam on input, arcsec on output)
     real(kind=8)      :: spetol = 0.01         ! [-------] Spectral tolerance (fraction of channel, velocity, frequency)
     !
     real(kind=4)      :: ipfac = 1.0           ! [-------] Multiplicative factor for interferometric data. Normally 1
     !
     character(len=12) :: sdunit = "*"          ! [-------] * means to try "K (Tmb) to Jy/Beam" or "Jy/Beam to Jy/Beam".
     real(kind=4)      :: sdfac = 1.0           ! [-------] Multiplicative factor for single dish data. Normally 1
     real(kind=4)      :: sdwei = 1.0           ! [-------] Single dish  weight factor. Normally 1
     !
     real(kind=4)      :: uvtrunc  = 0.0        ! [      m] Truncation radius. If zero, it will be set to sd_beam - ip_beam
     real(kind=4)      :: sdbeamin = 0.0        ! [sec|rad] Single dish beam of the input table of cube (sec on input, rad internally)
     real(kind=4)      :: sdbeamou = 0.0        ! [sec|rad] Single dish beam of the output cube         (sec on input, rad internally)
     real(kind=4)      :: sddiam   = 0.0        ! [      m] Single dish diameter
     real(kind=4)      :: ipbeam   = 0.0        ! [sec|rad] Interf. primary beam (sec on input, rad internally)
     real(kind=4)      :: ipdiam   = 0.0        ! [      m] Interf. primary diameter
     real(kind=4)      :: uvstep   = 0.0        ! [      m] Step in the UV plane for weight density bins
  end type uvshort_user_t
  !
  type uvshort_sdwei_state_t
     real(kind=4)              :: user = 1.0   ! Raw SDWEI$ user input; zero means automatic
     real(kind=4), allocatable :: field(:)  ! Automatic short-spacing weight estimate per field
     real(kind=4), allocatable :: factor(:) ! Effective factor per field after user correction
     real(kind=4)              :: min = 1.0
     real(kind=4)              :: med = 1.0
     real(kind=4)              :: max = 1.0
  end type uvshort_sdwei_state_t
  !
  type uvshort_prog_t
     character(len=12)              :: action = "all"
     character(len=filename_length) :: name
     !
     real(kind=4)      :: postol = 0.10         ! [---|sec] Pointing tolerance (fraction of beam on input, arcsec on output)
     real(kind=8)      :: spetol = 0.01         ! [-------] Spectral tolerance (fraction of channel, velocity, frequency)
     !
     real(kind=4)      :: ipfac = 1.0           ! [-------] Multiplicative factor for interferometric data. Normally 1
     !
     character(len=12) :: sdunit = "*"          ! [-------] * means to try "K (Tmb) to Jy/Beam" or "Jy/Beam to Jy/Beam".
     real(kind=4)      :: sdfac = 1.0           ! [-------] Multiplicative factor for single dish data. Normally 1
     type(uvshort_sdwei_state_t) :: sdwei       ! [-------] Automatic short-spacing weight state
     !
     real(kind=4)      :: uvtrunc  = 0.0        ! [      m] Truncation radius. If zero, it will be set to sd_beam - ip_beam
     real(kind=4)      :: sdbeamin = 0.0        ! [sec|rad] Single dish beam of the input table of cube (sec on input, rad internally)
     real(kind=4)      :: sdbeamou = 0.0        ! [sec|rad] Single dish beam of the output cube         (sec on input, rad internally)
     real(kind=4)      :: sddiam   = 0.0        ! [      m] Single dish diameter
     real(kind=4)      :: ipbeam   = 0.0        ! [sec|rad] Interf. primary beam (sec on input, rad internally)
     real(kind=4)      :: ipdiam   = 0.0        ! [      m] Interf. primary diameter
     real(kind=4)      :: uvstep   = 0.0        ! [      m] Step in the UV plane for weight density bins
  end type uvshort_prog_t
  !
  type uvshort_action_t
     logical           :: break  = .true.       ! Break running flow on error
     logical           :: all    = .false.      !
     logical           :: setup  = .false.      !
     logical           :: grid   = .false.      ! Grid single dish data
     logical           :: pseudo = .false.      !
     logical           :: merge  = .false.      !
     character(len=12) :: wei = 'natural'       ! Normally UN or NA, but little effect
     logical           :: zero = .false.        ! Zero or short-spacings?
     logical           :: deconv_sd = .true.    ! Deconvolve single dish beam
     logical           :: apply_ip = .true.     ! Apply interferometer primary beam
     logical           :: write_sdou = .true.   ! 
     logical           :: write_uvps = .true.   ! 
  end type uvshort_action_t
  !
  type uvshort_sddata_t
     type(gildas) :: in ! Input single dish table
     type(gildas) :: ou ! (Output) single dish data cube in LMV order
     type(gildas) :: we ! (Output) gridded weights in LM plane
     !
     logical :: islmv = .false. ! TAB or LMV input file?
     real(kind=4)    :: xmin = 0.0
     real(kind=4)    :: xmax = 0.0
     real(kind=4)    :: ymin = 0.0
     real(kind=4)    :: ymax = 0.0
     integer(kind=4) :: xcol = 1
     integer(kind=4) :: ycol = 2
     integer(kind=4) :: wcol = 3
     integer(kind=4) :: mcol(2) = (4,0)
     integer(kind=4) :: nchan = 0
  end type uvshort_sddata_t
  !
  type uvshort_uvdata_t
     type(gildas) :: in ! Input  uv table when used to append
     type(gildas) :: ou ! Output uv table
     type(gildas) :: ps ! Computed pseudo visibilities
     !
     type(gildas) :: inbeam
     type(gildas) :: oubeam
     !
     logical                   :: ismos = .true.      ! Mosaic or single field?
     logical                   :: islm  = .true.      ! LM or XY type UV table?
     integer(kind=4)           :: ocol(2) = 0         ! Table columns where field offsets are stored
     integer(kind=4)           :: wcol = 0            ! Table column where the weights will be taken
     integer(kind=4)           :: ivisi = 0           ! Current number of visibility copied or written
     integer(kind=4)           :: nvisi_per_field = 0 ! Number of pseudo-visibility per field
     integer(kind=4)           :: ifield = 0          ! 
     integer(kind=4)           :: nfield = 0          ! Number of fields
     real(kind=4), allocatable :: raoff(:)            ! Field RA  offsets
     real(kind=4), allocatable :: deoff(:)            ! Field Dec offsets
     real(kind=4)              :: ipdatfac = 1.0      ! User correction to Interferometer calibration
     real(kind=4)              :: sddatfac = 1.0 ! = user%sdfac * prog%sdfac (ie, user correction * unit conversion)
     real(kind=4)              :: sdweifac = 1.0 ! Non-authoritative summary of field-dependent SD weight factors
  end type uvshort_uvdata_t
  !
  type uvshort_buffer_t
     integer(kind=4) :: ndim = 2
     integer(kind=4) :: dim(2) = 0
     integer(kind=4) :: nx = 0
     integer(kind=4) :: ny = 0
     integer(kind=4) :: nf = 0
     real(kind=8),    allocatable :: xy(:,:)        ! [ 2,nf] Position shift per channel
     real(kind=4),    allocatable :: uvwei(:,:)     ! [nx,ny] Gridded weights in UV plane
     real(kind=4),    allocatable :: sdlobe_uv(:,:) ! [nx,ny] Single dish beam in UV plane
     real(kind=4),    allocatable :: iplobe_lm(:,:) ! [nx,ny] Interferometer primary beam in LM plane
     complex(kind=4), allocatable :: iplobe_uv(:,:) ! [nx,ny] Interferometer beam in UV plane
     complex(kind=4), allocatable :: visi(:,:,:)    ! [nx,ny,nf] Cube of pseudo visilibities
     real(kind=4),    allocatable :: fftws(:)       ! [2*max(nx,ny)] FFT work space
  end type uvshort_buffer_t
  !
  logical :: break,error
  real(kind=4) :: ubias,vbias,ubuff(8192),vbuff(8192)
  !
  call uvshort_main(break,error)
  if (error.and.break) call sysexi(fatale)
  !
contains
  !
  subroutine uvshort_main(break,error)
    !------------------------------------------------------------------------
    ! Main subroutine
    !------------------------------------------------------------------------
    logical, intent(out) :: break
    logical, intent(out) :: error
    !
    type(uvshort_user_t) :: user
    type(uvshort_prog_t) :: prog
    type(uvshort_action_t) :: do
    type(uvshort_sddata_t) :: sd
    type(uvshort_uvdata_t) :: uv
    character(len=*), parameter :: rname='UV_SHORT'
    !
    break = .true.
    error = .false.
    call uvshort_user_get(user)
    call uvshort_user_toprog(user,prog)
    call uvshort_check_action(rname,user,prog,do,error)
    if (error) return
    break = do%break
    if (do%all.or.do%setup) then
       call uvshort_check_sd(rname,user,prog,do,sd,error)
       if (error) goto 10
       call uvshort_check_uv(rname,user,prog,do,uv,error)
       if (error) goto 10
       call uvshort_check_spectral_consistency(rname,prog,uv,sd,error)
       if (error) goto 10
       call uvshort_check_uvtrunc(rname,user,uv,sd,prog,do,error)    
       if (error) goto 10
       call uvshort_check_uvstep(rname,user,prog,error)
       if(error) goto 10
       call uvshort_user_feedback(rname,user,prog,do,sd,uv,error)
       if (error) goto 10
    endif
    if (do%all.or.do%pseudo) then
       call uvshort_sd_get(rname,prog,uv,sd,error)
       if (error) goto 10
       call uvshort_pseudo(rname,prog,do,sd,uv,error)
       if (error) goto 10
       !!$    if (do_zero) then
!!$       call uvshort_uvzero(rname,user,uvdat%in,error)
!!$       if (error) return
!!$    endif
    endif
!!$ Logic needs to be refined if we want to separate gridding from
!!$ computation of pseudo-visibilities
!!$    if (do%all.or.do%grid) then
!!$       call uvshort_sd_get(rname,prog,uv,sd,error)
!!$       if (error) return
!!$    endif
!!$    if (do%all.or.do%pseudo) then
!!$       call uvshort_pseudo(rname,prog,do,sd,uv,error)
!!$       if (error) return
!!$    endif
    if (do%all.or.do%merge) then
       if (.not.do%all) then
          !load uv%ps%gil
       endif
       call uvshort_merge(rname,prog,uv,error)
       if (error) return
    endif
    !
    ! Cleaning
10  continue
    call uvshort_sd_free(sd)
    call uvshort_uv_free(uv)
    !
  end subroutine uvshort_main
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Routines to get an analysis input parameters
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! 
  subroutine uvshort_user_get(user)
    !------------------------------------------------------------------------
    ! Put task inputs into user structure
    !------------------------------------------------------------------------
    type(uvshort_user_t), intent(inout) :: user
    !
    call gildas_open
    call gildas_char('ACTION$',user%action)
    call gildas_char('NAME$',user%name)
    !
    call gildas_dble('SPETOL$',user%spetol,1)
    call gildas_real('POSTOL$',user%postol,1)
    !
    call gildas_real('IPFAC$',user%ipfac,1)
    !
    call gildas_char('SDUNIT$',user%sdunit)
    call gildas_real('SDFAC$',user%sdfac,1)
    call gildas_real('SDWEI$',user%sdwei,1)
    !
    call gildas_real('UVTRUNC$',user%uvtrunc,1)
    call gildas_real('SDBEAM$',user%sdbeamin,1)         
    call gildas_real('SDDIAM$',user%sddiam,1)         
    call gildas_real('IPBEAM$',user%ipbeam,1)         
    call gildas_real('IPDIAM$',user%ipdiam,1)
    call gildas_real('UVSTEP$',user%uvstep,1)
    call gildas_close
    !
  end subroutine uvshort_user_get
  !
  subroutine uvshort_user_toprog(user,prog)
    !------------------------------------------------------------------------
    ! Initialize the internal program state from task inputs.
    !
    ! This routine only copies safe pass-through values whose meaning is the
    ! same in user and prog at initialization time. It must not validate
    ! inputs, derive internal values, allocate field-dependent arrays, or copy
    ! user scale/sentinel values whose prog counterpart has a different
    ! meaning.
    !------------------------------------------------------------------------
    type(uvshort_user_t), intent(in)    :: user
    type(uvshort_prog_t), intent(inout) :: prog
    !
    prog%action = user%action
    prog%name   = user%name
    prog%spetol = user%spetol
    prog%ipfac  = user%ipfac
    prog%sdunit = user%sdunit
    prog%sdwei%user = user%sdwei
    !
    ! Do not copy:
    !   user%sdfac -> prog%sdfac, because prog%sdfac is a unit conversion.
    !   user%sdwei -> prog%sdwei%field/factor/min/med/max, because those are derived per-field state.
    !   user%postol -> prog%postol, because prog%postol is derived later.
    !   user%uvtrunc -> prog%uvtrunc, because zero means automatic until checked.
    !   user%uvstep -> prog%uvstep, because zero means automatic until checked.
    !   user%sddiam/user%sdbeamin/user%sdbeamou -> prog, because beam
    !     values are validated or derived by the check routines.
    !   user%ipdiam/user%ipbeam -> prog, because beam values are validated
    !     or derived by the check routines.
  end subroutine uvshort_user_toprog
  !    
  subroutine uvshort_check_action(rname,user,prog,do,error)
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Analysis action input
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    logical,                intent(inout) :: error
    !
    integer(kind=4), parameter :: maction=5
    integer :: iaction
    character(len=12) :: actions(maction),myaction
    data actions /'ALL','SETUP','GRID','PSEUDO','MERGE'/
    !
    prog%action = user%action
    call sic_upper(prog%action)
    call sic_ambigs(rname,prog%action,myaction,iaction,actions,maction,error)
    if (error)  return
    !
    do%break  = .true. ! Default is to break running flow on error
    do%all    = .false.
    do%setup  = .true. ! Setup is required in all cases
    do%grid   = .false.
    do%pseudo = .false.
    do%merge  = .false.
    if (myaction.eq.'ALL') then
       do%all = .true.
    else if (myaction.eq.'SETUP') then
       do%setup = .true.
       do%break = .false. ! When the action is only setup an error is considered just a warning
    else if (myaction.eq.'GRID') then
       do%grid = .true.
    else if (myaction.eq.'PSEUDO') then
       do%pseudo = .true.
    else if (myaction.eq.'MERGE') then
       do%merge = .true.
    else
       call map_message(seve%e,rname,'Unknown action'''//trim(myaction))
       error = .true.
       return
    endif
    !
  end subroutine uvshort_check_action
  !
  subroutine uvshort_check_sd(rname,user,prog,do,sd,error)
    use phys_const
    use image_def
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Analysis single-dish input
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: iaxis
    character(len=12) :: unit
    character(len=filename_length) :: filename,name,dir,ext
    !
    ! Initialization
    call gildas_null(sd%in)
    call gildas_null(sd%ou)
    !
    ! Does the .tab or .lmv corresponding file exist?
    filename = trim(user%name)
    call sic_parse_file(filename,' ','.tab',sd%in%file)
    call gdf_read_header(sd%in,error)
    if (error) then
       call map_message(seve%w,rname,'Input single dish table '//trim(sd%in%file)//' not found')
       error = .false.
       call sic_parse_file(filename,' ','-short.lmv',sd%in%file)
       call gdf_read_header(sd%in,error)
       if (error) then
          call map_message(seve%e,rname,'Input single dish cube '//trim(sd%in%file)//' not found either')
          return
       endif
       call uvshort_check_sd_reproject(sd%in,error)
       if (error)  return
    endif
    !
    ! Is it a TAB or LMV file?
    if (sd%in%gil%ndim.eq.2) then
       ! *** JP: The table command should set the code code_gdf_xyt
       ! *** JP: and that's what we should check here.
       ! *** JP: How can a user change the code_gdf_xyt for backward compatibility?
       !
       ! Check existence of xcol, ycol, and wcol columns
       if ((sd%xcol.lt.1).or.(sd%in%gil%dim(1).lt.sd%xcol)) then
          call map_message(seve%e,rname,'X column does not exist')
          error = .true.
          return
       endif
       if ((sd%ycol.lt.1).or.(sd%in%gil%dim(1).lt.sd%ycol)) then
          call map_message(seve%e,rname,'Y column does not exist')
          error = .true.
          return
       endif
       if ((sd%wcol.lt.1).or.(sd%in%gil%dim(1).lt.sd%wcol)) then
          call map_message(seve%e,rname,'W column does not exist')
          error = .true.
          return
       endif
       sd%islmv=.false.
       do%grid=.true.
       sd%nchan = sd%in%gil%dim(1)-3
       sd%mcol(1) = 4
       sd%mcol(2) = sd%in%gil%dim(1)
    else if (sd%in%gil%ndim.eq.3) then
       if ((sd%in%gil%xaxi.ne.1).or.(sd%in%gil%yaxi.ne.2).or.(sd%in%gil%faxi.ne.3)) then
          call map_message(seve%e,rname,'Input single dish '//trim(sd%in%file)//' is not an LMV cube')
          error = .true.
          return
       else
          sd%islmv=.true.
          do%grid=.false.
          sd%nchan = sd%in%gil%dim(3)
          sd%mcol(1) = 1
          sd%mcol(2) = sd%in%gil%dim(3)
       endif
    else
       call map_message(seve%e,rname,'Input single dish '//trim(sd%in%file)//' dimension is neither 2 (table) or 3 (cube)')
       error = .true.
       return
    endif
    call gdf_copy_header(sd%in,sd%ou,error)
    if (error) return
    if (do%grid) then
       call sic_parse_name(filename,name,ext,dir)
       if (dir.ne."") then
          filename = trim(dir)//'/'//trim(name)//'-short'
       else
          filename = trim(name)//'-short'
       endif
       call sic_parse_file(filename,' ','.lmv',sd%ou%file)
    else
       sd%ou%file = trim(sd%in%file)
       do iaxis = 1,2
          call uvshort_check_sd_new_axis(sd%in%gil%ref(iaxis),sd%in%gil%dim(iaxis),  &
                                         sd%ou%gil%ref(iaxis),sd%ou%gil%dim(iaxis),  &
                                         error)
          if (error)  return
       enddo ! iaxis
    endif
    !
    ! Get telescope diameter and beam
    call uvshort_check_diambeam(rname,sd%in,&
         user%sddiam,user%sdbeamin,&
         prog%sddiam,prog%sdbeamin,error)
    if (error) return
    if (do%grid) then
       ! Takes into account beam smoothing by gridding
       ! 9.0 assumes a Gaussian gridding kernel of 1/3 the single-dish natural HPBW
       prog%sdbeamou = prog%sdbeamin*sqrt(1.0+1.0/9.0)
    else
       prog%sdbeamou = prog%sdbeamin
    endif
    !
    ! Get the unit conversion factor to go to Jy/Beam
    if (user%sdunit.eq."*") then
       ! Searched for recognized units in header
       prog%sdunit = sd%in%char%unit
       unit = prog%sdunit
       call sic_lower(unit)
       if (unit.eq."jy/beam") then
          ! Right unit => Nothing to do!
          prog%sdfac = 1.0
       else if ((unit.eq."k (tmb)").or.(unit.eq."k (ta*)")) then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
          if ((unit.eq."k (ta*)").and.(user%sdfac.eq.1.0)) then
             call map_message(seve%e,rname,'Unit is K (Ta*) and not K (Tmb)')
             call map_message(seve%e,rname,&
                  'Please set the unit conversion factor from K (Ta*) to K (Tmb) into the sdfac factor')
             error = .true.
             return
          endif
       else
          call map_message(seve%e,rname,'Unknown file unit: '//sd%in%char%unit)
          call map_message(seve%e,rname,&
               'Convert to K (Tmb), or Jy/Beam or enforce the right unit in input')
          error = .true.
          return
       endif
    else
       ! User defined unit
       prog%sdunit = user%sdunit
       unit = prog%sdunit
       call sic_lower(unit)
       if (unit.eq."jy/beam") then
          prog%sdfac = 1.0
       else if (unit.eq."k") then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
       else if ((unit.eq."k (tmb)").or.(unit.eq."k (ta*)")) then
          prog%sdfac = 2.0*kbolt*1d26*pi*prog%sdbeamou**2/(4.d0*log(2.d0))*(sd%in%gil%freq/clight_mhz)**2
          if ((unit.eq."k (ta*)").and.(user%sdfac.eq.1.0)) then
             call map_message(seve%e,rname,'Unit is K (Ta*) and not K (Tmb)')
             call map_message(seve%e,rname,&
                  'Please set the unit conversion factor from K (Ta*) to K (Tmb) into the sdfac factor')
             error = .true.
             return
          endif
       else
          call map_message(seve%e,rname,'Unknown input unit: '//user%sdunit)
          call map_message(seve%e,rname,' Only K or Jy/Beam is recognised')
          error = .true.
          return
       endif
    endif
    !
    ! Get gridding position tolerance
    prog%postol = prog%sdbeamin*user%postol   
  end subroutine uvshort_check_sd  
  !
  subroutine uvshort_check_sd_reproject(in,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Check if the spatial axes are well-formed, so that the data can
    ! be plunged into a power-of-two surset without resampling in the
    ! uvshort_sd_read_lmv subroutine. In practice this implies the
    ! reference should be at the center of a pixel. If not, propose to
    ! the user a reprojection with proper inputs.
    !-------------------------------------------------------------------
    type(gildas), intent(in)    :: in
    logical,      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='UV_SHORT'
    real(kind=8), parameter :: tole=1.d-2  ! [pixel] Alignment tolerance
    integer(kind=index_length) :: ref1,ref2,dim1,dim2
    real(kind=8) :: conv1(3),conv2(3)
    logical :: good1,good2
    character(len=message_length) :: mess
    !
    ref1 = nint(in%gil%ref(1))
    ref2 = nint(in%gil%ref(2))
    good1 = abs(in%gil%ref(1)-ref1).lt.tole
    good2 = abs(in%gil%ref(2)-ref2).lt.tole
    if (good1 .and. good2)  return   ! Below the tolerance => leave
    !
    call map_message(seve%e,rname,  'The reference pixel of the SD map ('//  &
      trim(in%file)//') must be at the center of a pixel.')
    !
    write(mess,'(3(A,F0.2))')  &
      'Current center is at (',in%gil%ref(1),',',in%gil%ref(2),') (pixel unit)'
    call map_message(seve%e,rname,mess)
    !
    call map_message(seve%e,rname,  &
      'Use the RUN REPROJECT task to reproject the SD map with everything unchanged except:')
    !
    if (good1) then
      dim1 = in%gil%dim(1)
      conv1(:) = 0.d0  ! Means unchanged
    else
      dim1 = in%gil%dim(1)+1  ! No loss of data at boundaries
      conv1(1) = ceiling(in%gil%ref(1))
      conv1(2) = in%gil%val(1)
      conv1(3) = in%gil%inc(1)
    endif
    !
    if (good2) then
      dim2 = in%gil%dim(2)
      conv2(:) = 0.d0  ! Means unchanged
    else
      dim2 = in%gil%dim(2)+1  ! No loss of data at boundaries
      conv2(1) = ceiling(in%gil%ref(2))
      conv2(2) = in%gil%val(2)
      conv2(3) = in%gil%inc(2)
    endif
    !
    write(mess,'(A,I0,1X,I0)')  &
      'Dimensions of output image: ',dim1,dim2
    call map_message(seve%e,rname,mess)
    !
    write(mess,'(A,3(1X,1PG25.18))')  &
      'First axis conversion formula: ',conv1(1),conv1(2),conv1(3)
    call map_message(seve%e,rname,mess)
    !
    write(mess,'(A,3(1X,1PG25.18))')  &
      'Second axis conversion formula: ',conv2(1),conv2(2),conv2(3)
    call map_message(seve%e,rname,mess)
    !
    error = .true.
    return
    !
  end subroutine uvshort_check_sd_reproject
  !
  subroutine uvshort_check_sd_new_axis(iref,inpix,oref,onpix,error)
    !-------------------------------------------------------------------
    ! Compute the new output axis from the input axis, so that:
    !  - the number of pixels is a power of 2,
    !  - the reference pixel is at the "middle" (npix/2+1) of the axis
    ! The input reference pixel must be at the middle of a pixel, but
    ! not necessarily the central one.
    !-------------------------------------------------------------------
    real(kind=8),               intent(in)    :: iref
    integer(kind=index_length), intent(in)    :: inpix
    real(kind=8),               intent(out)   :: oref
    integer(kind=index_length), intent(out)   :: onpix
    logical,                    intent(inout) :: error
    ! Local
    integer(kind=index_length) :: intref,nleft,nright,nmax
    !
    ! Nota: the algorithm below preserves ref and npix if they already
    ! meet the requirements.
    !
    intref = nint(iref)         ! Already checked: should be very near a pixel center
    nleft  = intref-1           ! Number of pixels to the left of iref (excluded)
    nright = inpix-intref+1     ! Number of pixels to the right of iref (included)
    nmax   = max(nleft,nright)  ! Largest one
    onpix  = 2**ceiling(log(real(nmax))/log(2.0))  ! Ceiling() troubles if nmax is already a power of 2?
    onpix  = onpix*2            ! As we considered only one half of the axis
    oref   = real(onpix/2+1,kind=8)
  end subroutine uvshort_check_sd_new_axis
  !
  subroutine uvshort_check_uv(rname,user,prog,do,uv,error)
    use image_def
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    use mapping_read, only: mosaic_getfields
    !------------------------------------------------------------------------
    ! Analysis user inputs
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: xoff,yoff,loff,moff,nvis,ncol
    real(kind=4), allocatable :: duv(:,:),offxy(:,:)
    character(len=filename_length) :: filename,name,ext,dir
    !
    call gildas_null(uv%in,type='UVT')
    call gildas_null(uv%ps,type='UVT')
    call gildas_null(uv%ou,type='UVT')
    !
    ! Does the .uvt corresponding file exist?
    filename  = trim(user%name)
    call sic_parse_file(filename,' ','.uvt',uv%in%file)
    ! Yes => Read the corresponding header
    call gdf_read_header(uv%in,error)
    if (error) return
    ! Create the associated uv table used to compute the beam
    call gdf_copy_header(uv%in,uv%inbeam,error)
    if (error) return
    filename = trim(user%name)//'-beam'
    call sic_parse_file(filename,' ','.uvt',uv%inbeam%file)
    ! Create the pseudo-visibility header
    call gdf_copy_header(uv%in,uv%ps,error)
    if (error) return
    filename  = trim(user%name)
    call sic_parse_name(filename,name,ext,dir)
    if (dir.ne."") then
       filename = trim(dir)//'/'//trim(name)//'-short'
    else
       filename = trim(name)//'-short'
    endif
    call sic_parse_file(filename,' ','.uvt',uv%ps%file)
    ! Create the merged header
    call gdf_copy_header(uv%in,uv%ou,error)
    if (error) return
    filename  = trim(user%name)
    call sic_parse_name(filename,name,ext,dir)
    if (dir.ne."") then
       filename = trim(dir)//'/'//trim(name)//'-merged'
    else
       filename = trim(name)//'-merged'
    endif
    call sic_parse_file(filename,' ','.uvt',uv%ou%file)
    ! Create the associated uv table used to compute the beam
    call gdf_copy_header(uv%ou,uv%oubeam,error)
    if (error) return
    filename = trim(filename)//'-beam'
    call sic_parse_file(filename,' ','.uvt',uv%oubeam%file)
    ! Is it a mosaic?
    ! Do we find phase offsets?
    loff = uv%in%gil%column_pointer(code_uvt_loff)
    moff = uv%in%gil%column_pointer(code_uvt_moff)
    if ((loff.ne.0).or.(moff.ne.0)) then
       ! Yes.
       if (moff.ne.loff+1) then
          call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
          error = .true.
          return
       endif
       uv%in%blc(1:2) = [loff,0]
       uv%in%trc(1:2) = [moff,0]
       uv%ocol(1) = loff
       uv%ocol(2) = moff 
       uv%islm = .true.
       uv%ismos = .true.
    else
       ! No => Do we find pointing offsets?
       xoff = uv%in%gil%column_pointer(code_uvt_xoff)
       yoff = uv%in%gil%column_pointer(code_uvt_yoff)
       if ((xoff.ne.0).or.(yoff.ne.0)) then
          ! Yes.
          if (yoff.ne.xoff+1) then
             call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
             error = .true.
             return
          endif
          uv%in%blc(1:2) = [xoff,0]
          uv%in%trc(1:2) = [yoff,0]
          uv%ocol(1) = xoff
          uv%ocol(2) = yoff
          uv%islm = .false.
          uv%ismos = .true.
       else
          ! No
          uv%ismos = .false.
          uv%islm  = .true.  ! Programming convention to simplify things later on
          uv%ocol(1) = 0
          uv%ocol(2) = 0
       endif
    endif
    !
    ! Get field offsets
    if (uv%ismos) then
       ! Read the corresponding columns only
       ncol = 2
       nvis = uv%in%gil%nvisi
       allocate(duv(ncol,nvis),stat=ier)
       if (failed_allocate(rname,'Field columns',ier,error)) return
       call gdf_read_data(uv%in,duv,error)
       if (error) return
       ! Sort offsets into equivalence classes
       !   => nf: number of fields
       !   => offxy(2,nf): field offsets
       call mosaic_getfields(duv,ncol,nvis,1,2,uv%nfield,offxy)
       deallocate(duv)
       ! Keep memory of offset information
       uv%nfield = max(uv%nfield,1)
       allocate(uv%raoff(uv%nfield),uv%deoff(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field offsets',ier,error)) return
       uv%raoff(:) = offxy(1,:)
       uv%deoff(:) = offxy(2,:)
    else
       uv%nfield = 1
       allocate(uv%raoff(uv%nfield),uv%deoff(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field offsets',ier,error)) return
       uv%raoff = 0.0
       uv%deoff = 0.0
    endif
    !
    ! Get telescope diameter and beam
    call uvshort_check_diambeam(rname,uv%in,&
         user%ipdiam,user%ipbeam,&
         prog%ipdiam,prog%ipbeam,error)
    if (error) return
    !
    ! Multiply unit conversion factor with user multiplicative correction
    uv%sddatfac = user%sdfac*prog%sdfac
    !
    ! Initialize per-field automatic short-spacing weight state.  The
    ! prog%sdwei%user scalar stores the SDWEI$ input: zero means automatic,
    ! non-zero means a multiplicative correction to the automatic estimate.
    if (allocated(prog%sdwei%field))  deallocate(prog%sdwei%field)
    if (allocated(prog%sdwei%factor)) deallocate(prog%sdwei%factor)
    allocate(prog%sdwei%field(uv%nfield),prog%sdwei%factor(uv%nfield),stat=ier)
    if (failed_allocate(rname,'Field SD weight state',ier,error)) return
    prog%sdwei%field(:)  = 1.0
    prog%sdwei%factor(:) = 1.0
    prog%sdwei%min = 1.0
    prog%sdwei%med = 1.0
    prog%sdwei%max = 1.0
    uv%sdweifac = 1.0
    ! Get uv table weight column
    uv%wcol = (uv%in%gil%nchan+2)/3
    uv%wcol = uv%in%gil%fcol+3*uv%wcol-1
    !
    if (user%ipfac.ge.1e-7) then
       prog%ipfac = user%ipfac
    else
       call map_message(seve%e,rname,"Interferometer calibration factor cannot be zero or negative")
       error = .true.
       return
    endif
    !
    uv%ipdatfac = prog%ipfac
    !
  end subroutine uvshort_check_uv
  !
  subroutine uvshort_check_uvstep(rname,user,prog,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Analysis of uvstep
    !------------------------------------------------------------------------
    character(len=*),      intent(in)    :: rname
    type(uvshort_user_t),  intent(in)    :: user
    type(uvshort_prog_t),  intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    if (user%uvstep.eq.0) then
       prog%uvstep = 1.25*prog%ipdiam
    else if (user%uvstep.le.0) then
       call map_message(seve%e,rname,"UVSTEP cannot be negative")
       error = .true.
       return
    else if (user%uvstep.le.prog%uvtrunc) then
       call map_message(seve%e,rname,"UVSTEP cannot be smaller than the UV truncation Radius")
       error = .true.
       return
    else
       prog%uvstep = user%uvstep
    endif
    !
  end subroutine uvshort_check_uvstep
  !
  subroutine uvshort_check_diambeam(rname,head,userdiam,userbeam,progdiam,progbeam,error)
    use phys_const
    use image_def
    use gbl_message
    use mapping_primary
    !------------------------------------------------------------------------
    ! Analysis antenna diameter and associated beamwidth
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    type(gildas),     intent(in)    :: head
    real(kind=4),     intent(in)    :: userdiam
    real(kind=4),     intent(in)    :: userbeam
    real(kind=4),     intent(inout) :: progdiam
    real(kind=4),     intent(inout) :: progbeam
    logical,          intent(inout) :: error
    !
    character(len=message_length) :: mess
    logical, parameter :: fromressection=.true.
    !
    ! Diameter
    if (userdiam.eq.0) then
       ! It should be automatically defined from the input file.
       if (head%gil%nteles.eq.1) then
          progdiam = head%gil%teles(1)%diam          
       else if(head%gil%nteles.eq.0) then
          write(mess,'(A,A)') 'No telescope section in ',trim(head%file)
          error = .true.
       else
          write(mess,'(A,A)') 'More than 1 telescope defined in ',trim(head%file)
          error = .true.
          return
       endif
       if (error) then
          call map_message(seve%e,rname,mess)
          return
       endif
    else
       ! User defined => No more checks...
       progdiam = userdiam
    endif
    !
    ! Beam
    if (userbeam.eq.0.0) then
       ! It should be automatically defined from the input file.
       progbeam = primary_beam(rname,head,fromressection)
    else
       progbeam = userbeam*rad_per_sec
    endif    
  end subroutine uvshort_check_diambeam
  !
  subroutine uvshort_check_spectral_consistency(rname,prog,uv,sd,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Check spectral axis consistency
    ! On purpose, return only when all checks are done
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(in)    :: sd
    logical,                intent(inout) :: error
    !
    real(kind=8) :: velo
    real(kind=8) :: freq
    character(len=message_length) :: mess
    !
    ! Number of channels
    if (uv%in%gil%nchan.ne.sd%nchan) then
       write(mess,'(A,I0,A,I0,A)') 'Inconsistent number of channels (UVT: ',uv%in%gil%nchan,', SD: ',sd%nchan,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Velocity resolution
    if (abs(uv%in%gil%vres-sd%in%gil%vres).gt.abs(uv%in%gil%vres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsitent velocity resolution (UVT: ',uv%in%gil%vres,', SD: ',sd%in%gil%vres,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Frequency resolution
    if (abs(uv%in%gil%fres-sd%in%gil%fres).gt.abs(uv%in%gil%fres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsitent velocity resolution (UVT: ',uv%in%gil%fres,', SD: ',sd%in%gil%fres,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    ! Systemic velocity and rest frequency
    if (sd%islmv) then
       velo = (uv%in%gil%ref(1) - sd%in%gil%ref(3))*sd%in%gil%vres + sd%in%gil%voff
       freq = (uv%in%gil%ref(1) - sd%in%gil%ref(3))*sd%in%gil%fres + sd%in%gil%freq
    else
       velo = (uv%in%gil%ref(1) - sd%in%gil%ref(1) + 3)*sd%in%gil%vres + sd%in%gil%voff
       freq = (uv%in%gil%ref(1) - sd%in%gil%ref(1) + 3)*sd%in%gil%fres + sd%in%gil%freq
    endif
    if (abs(uv%in%gil%voff-velo).gt.abs(uv%in%gil%vres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsistent velocity axis (UVT: ',uv%in%gil%voff,', SD: ',velo,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
    if (abs(uv%in%gil%freq-freq).gt.abs(uv%in%gil%fres*prog%spetol)) then
       write(mess,'(A,F0.8,A,F0.8,A)') 'Inconsistent frequency axis (UVT: ',uv%in%gil%freq,', SD: ',freq,')'
       call map_message(seve%e,rname,mess)
       error = .true.
    endif
  end subroutine uvshort_check_spectral_consistency
  !
  subroutine uvshort_check_uvtrunc(rname,user,uv,sd,prog,do,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Check UV truncation radius
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_action_t), intent(inout) :: do
    logical,                intent(inout) :: error
    !
    real(kind=4), parameter :: tol=0.001
    !
    ! Zero or short-spacings?
    if (abs(prog%sddiam-prog%ipdiam).le.tol*prog%ipdiam) then
       do%zero = .true.
       prog%uvtrunc = 0
    else if (prog%sddiam.gt.prog%ipdiam) then
       do%zero = .false.
       if (user%uvtrunc.eq.0.0) then
          ! Automatic
          prog%uvtrunc = prog%sddiam-prog%ipdiam
       else
          ! User defined
          prog%uvtrunc = user%uvtrunc
       endif
    else  
       call map_message(seve%e,rname,'Single dish diameter smaller than interferometer diameter')
       error = .true.
       return
    endif
    !
  end subroutine uvshort_check_uvtrunc
  !
  subroutine uvshort_user_feedback(rname,user,prog,do,sd,uv,error)
    use phys_const
    use image_def
    use gbl_message
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! User feedback
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_user_t),   intent(in)    :: user
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(in)    :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: if
    character(len=message_length) :: mess,kind
    !
    ! Interferometric data
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    write(mess,'(A,A)') 'Interferometer - Input         file: ',trim(uv%in%file)
    call map_message(seve%r,rname,mess)
!!$    write(mess,'(A,A)') '               - Input beam    file: ',trim(uv%inbeam%file)
!!$    call map_message(seve%r,rname,mess)
    if (do%all.or.do%pseudo) then
       write(mess,'(A,A,x,A)') '               - Short-spacing file: ',trim(uv%ps%file)
       call map_message(seve%r,rname,mess)
    endif
    if (do%all.or.do%merge) then
       write(mess,'(A,A,x,A)') '               - Merged        file: ',trim(uv%ou%file)
       call map_message(seve%r,rname,mess)
!!$       write(mess,'(A,A,x,A)') '               - Merged beam   file: ',trim(uv%oubeam%file)
!!$       call map_message(seve%r,rname,mess)
    endif
    call map_message(seve%r,rname,"")
    ! Mosaic or single-field
    if (uv%islm) then
       write(mess,'(I0,A,I0,A,I0,A)') &
            uv%nfield,'-field mosaic with phase offset columns at (Lcol,Mcol) = (',uv%ocol(1),',',uv%ocol(2),')'
    else
       write(mess,'(I0,A,I0,A,I0,A)') &
            uv%nfield,'-field mosaic with pointing offset columns at (Xcol,Ycol) = (',uv%ocol(1),',',uv%ocol(2),')'
    endif
    call map_message(seve%r,rname,mess)
    do if = 1,uv%nfield
       write(mess,'(A,f8.2,a,F8.2,A)') ' &
            [',uv%raoff(if)*sec_per_rad,',',uv%deoff(if)*sec_per_rad,'] '
       call map_message(seve%r,rname,mess)
    enddo ! if
    call map_message(seve%r,rname,"")
    ! Frequency, diameter, and HPBW
    write(mess,'(A30,F11.6,A)') 'Observed frequency ',uv%in%gil%freq/1d3,' GHz'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Diameter ',prog%ipdiam,' m'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Half primary beam width ',prog%ipbeam*sec_per_rad,'"'
    call map_message(seve%r,rname,mess)
    !
    ! Single dish data
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    if (sd%islmv) then
       kind = 'LMV'
    else
       kind = 'TAB'
    endif
    write(mess,'(A,A,x,A,A,A)') 'Single dish - Input  file: ',trim(sd%in%file),'(',trim(kind),')'
    call map_message(seve%r,rname,mess)
    if (do%all.or.do%grid) then
       write(mess,'(A,A,x,A)') '            - Output file: ',trim(sd%ou%file),'(LMV)'
       call map_message(seve%r,rname,mess)
    endif
    call map_message(seve%r,rname,"")
    ! Frequency, diameter, and HPBW
    write(mess,'(A30,F11.6,A)') 'Observed frequency ',sd%in%gil%freq/1d3,' GHz'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Diameter ',prog%sddiam,' m'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Half primary beam width (LMV)',prog%sdbeamou*sec_per_rad,'"'
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1)') 'Interferometer Data factor ',uv%ipdatfac
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1,A)') 'Single Dish Data conversion factor ',prog%sdfac,' (from '//trim(prog%sdunit)//' to Jy/Beam)'
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1)') 'Single Dish Data user factor ',user%sdfac
    call map_message(seve%r,rname,mess)
    write(mess,'(A30,F6.1,A)') 'Single Dish Data final factor ',uv%sddatfac,' (= conversion * user)'
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F6.1,A)') 'Single Dish Weight user factor ',user%sdwei
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"")
    if (.not.sd%islmv) then
       write(mess,'(A30,F6.1,A,F7.4,A)') 'Gridding position tolerance ',prog%postol*sec_per_rad,'" (HPBW * ',user%postol,')'
       call map_message(seve%r,rname,mess)
    else
       write(mess,'(A30,I0,A,I0,A)') 'Image cube lmv with ',sd%in%gil%dim(1),' by ',sd%in%gil%dim(2),' pixels'
       call map_message(seve%i,rname,mess)
       write(mess,'(A30,F0.2,A,F0.2,A)') 'Pixel size is ',sd%in%gil%inc(1)*sec_per_rad,' x ', sd%in%gil%inc(2)*sec_per_rad,'"'
       call map_message(seve%i,rname,mess)
    endif
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    call map_message(seve%r,rname,'Interferometer and Single-dish data have consistent spectral axes')
    call map_message(seve%r,rname,"")
    write(mess,'(A30,F7.2,A,F6.2,A)') 'UV truncation radius: ',prog%uvtrunc,' m (Useful range = [0.00,',prog%sddiam-prog%ipdiam,'])'
    call map_message(seve%r,rname,mess)
    write(mess,'(a,f8.3,a)') 'UV step: ',prog%uvstep,' m '
    call map_message(seve%r,rname,mess)
    call map_message(seve%r,rname,"---------------------------------------------------------------------------")
    !
  end subroutine uvshort_user_feedback
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Routines to read or make single LMV cube
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_get(rname,prog,uv,sd,error)
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Reads Single dish data into sd data structure
    ! If SD already in lmv format: reads file.
    ! Else: Create and fill lmv file from info in .tab file.
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    if (sd%islmv) then
       call uvshort_sd_read_lmv(rname,sd%in,sd%ou,sd%we,error)
       if (error) return
       ! *** JP: Is the beam resolution section filled and up-to-date?
    else
       call uvshort_sd_create_lmv(rname,prog,uv,sd,error)
       if (error) return
       call gdf_create_image(sd%ou,error)
       if (error) return
       call gdf_write_data(sd%ou,sd%ou%r3d,error)
       if (error) return
       call gdf_close_image(sd%ou,error)
       if (error) return
    endif
  end subroutine uvshort_sd_get
  !
  subroutine uvshort_sd_read_lmv(rname,lmvin,lmvou,wei,error)
    use gbl_message
    use image_def
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Read an existing LMV data cube to be used to compute the short spacings
    !------------------------------------------------------------------------
    character(len=*),  intent(in)    :: rname
    type(gildas),      intent(inout) :: lmvin
    type(gildas),      intent(inout) :: lmvou
    type(gildas),      intent(inout) :: wei
    logical,           intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: ix,iy,if,idx,idy
    integer(kind=4) :: jx,jy
    real(kind=4) :: val
    !
    allocate(lmvin%r3d(lmvin%gil%dim(1),lmvin%gil%dim(2),lmvin%gil%dim(3)),stat=ier)
    if (failed_allocate(rname,'Input LMV cube',ier,error)) return
    call gdf_read_data(lmvin,lmvin%r3d,error)
    if (error) return
    allocate(lmvou%r3d(lmvou%gil%dim(1),lmvou%gil%dim(2),lmvou%gil%dim(3)),stat=ier)
    if (failed_allocate(rname,'Output LMV cube',ier,error)) return
    allocate(wei%r2d(lmvou%gil%dim(1),lmvou%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Weight of LMV cube',ier,error)) return
    lmvou%r3d = 0.0
    ! Compute shifts in number of pixels (integer). The ref values have
    ! checked for (in), and made as (out), integers
    idx = nint(lmvou%gil%ref(1)-lmvin%gil%ref(1))
    idy = nint(lmvou%gil%ref(2)-lmvin%gil%ref(2))
    do if = 1, lmvin%gil%dim(3)
       do iy = 1, lmvin%gil%dim(2)
          jy = iy+idy
          do ix = 1, lmvin%gil%dim(1)
             val = lmvin%r3d(ix,iy,if)
             if (abs(val-lmvin%gil%bval).gt.lmvin%gil%eval) then
                jx = ix+idx
                lmvou%r3d(jx,jy,if) = val
             endif
          enddo ! ix
       enddo ! iy
    enddo ! if
    wei%r2d = 1.0
  end subroutine uvshort_sd_read_lmv
  !
  subroutine uvshort_sd_create_lmv(rname,prog,uv,sd,error)
    use phys_const
    use gbl_message
    use image_def
    use gkernel_interfaces
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! Creates a "well behaved" Single Dish map from a Single Dish table
    ! for derivation of the short spacings of an interferometer mosaic
    !
    ! Use convolution by a fraction of the beam, and smooth extrapolation
    ! to zero beyond the mosaic edge
    !------------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc,nd,nf,nx,ny
    integer(kind=4) :: ier
    real(kind=8) :: xconv(3),yconv(3)
    real(kind=4), allocatable :: sdwei(:)       ! weights table
    real(kind=4), allocatable :: vlmcube(:,:,:) ! work space for sdin gridded values
    !
    nc = sd%in%gil%dim(1)
    nd = sd%in%gil%dim(2)
    allocate(sd%in%r2d(nc,nd),stat=ier)
    if (failed_allocate(rname,'Input single-dish table',ier,error)) return
    call gdf_read_data(sd%in,sd%in%r2d,error)
    call uvshort_define_lmv(rname,prog,uv,nc,nd,sd,sdwei,nf,nx,ny,xconv,yconv,error)
    if (error) return
    !
    allocate(sd%ou%r3d(nx,ny,nf),stat=ier)
    if (failed_allocate(rname,'Output LMV cube',ier,error)) return
    allocate(vlmcube(nf,nx,ny),stat=ier)
    if (failed_allocate(rname,'Output VLM cube',ier,error)) return
    allocate(sd%we%r2d(nx,ny),stat=ier)
    if (failed_allocate(rname,'Output LM weights',ier,error)) return
    !
    call uvshort_sd_grid(rname,prog,nc,nd,nf,nx,ny,xconv,yconv,sdwei,sd,vlmcube)
    call map_message(seve%i,rname,'Done Single Dish table gridding')
    call uvshort_sd_apodize(rname,prog,nf,nx,ny,xconv,yconv,sd,vlmcube)
    call map_message(seve%i,rname,'Done Single Dish apodisation')
    call uvshort_sd_transpose(vlmcube,sd%ou%r3d,nf,nx*ny)
    call map_message(seve%i,rname,'Done transposition to lmv order')
    !
    deallocate(sdwei,vlmcube)
  end subroutine uvshort_sd_create_lmv
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_define_lmv(rname,prog,uv,nc,nd,sd,sdwei,nf,nx,ny,&
       xconv,yconv,error)
    use phys_const
    use gbl_message
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Creates the lmv file to be used to store single image
    !------------------------------------------------------------------------
    character(len=*),          intent(in)    :: rname
    type(uvshort_prog_t),      intent(in)    :: prog
    type(uvshort_uvdata_t),    intent(in)    :: uv
    integer(kind=4),           intent(in)    :: nc,nd
    integer(kind=4),           intent(out)   :: nf,nx,ny
    type(uvshort_sddata_t),    intent(inout) :: sd
    real(kind=4), allocatable, intent(inout) :: sdwei(:)
    real(kind=8),              intent(inout) :: xconv(3),yconv(3)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) ::nxmore,nymore,i
    character(len=message_length) :: mess
    !
    call uvshort_reproject_offsets(rname,uv,nd,sd,error)
    if (error) return
    call uvshort_sort_by_increasing_y(rname,sd%in%r2d,nc,nd,sd%ycol,error)
    if (error) return
    call uvshort_get_weight_column(rname,sd%in%r2d,nc,nd,sdwei,sd%wcol,error)
    if (error) return
    !
    ! Field of view and pixel size
    call uvshort_find_size(sd%in%r2d,nc,nd,sd%xcol,sd%ycol,sdwei,sd%xmin,sd%xmax,sd%ymin,sd%ymax)
    xconv(3) = -prog%sdbeamin/4.0
    yconv(3) = +prog%sdbeamin/4.0
    !
    ! Number of pixels
    nx = 2 * max ( nint(abs(sd%xmax/xconv(3))+1),nint(abs(sd%xmin/xconv(3))+1) )
    ny = 2 * max ( nint(abs(sd%ymax/yconv(3))+1),nint(abs(sd%ymin/yconv(3))+1) )
    nxmore = nint(4*prog%sdbeamin/abs(xconv(3)))+1
    nymore = nint(4*prog%sdbeamin/abs(yconv(3)))+1
    nx = nx+2*nxmore
    ny = ny+2*nymore
    !
    ! Extend nx,ny to nearest power of two
    i = 32
    do while(i.lt.nx)
       i = i*2
    enddo
    nx = i
    i = 32
    do while(i.lt.ny)
       i = i*2
    enddo
    ny = i
    !
    ! Reference position for lmv cube header
    xconv(1) = nx/2+1
    xconv(2) = 0.0
    yconv(1) = ny/2+1
    yconv(2) = 0.0
    !
    ! User feedback
    write(mess,'(A,I0,A,I0,A)') 'Creating a cube with ',nx,' by ',ny,' pixels'
    call map_message(seve%i,rname,mess)
    write(mess,'(A,F8.3,A)') 'Pixel size: ',0.1*nint(yconv(3)*10*sec_per_rad),' arcsec'
    call map_message(seve%i,rname,mess)
    !
    ! Warn for big images
    if (nx.gt.512 .or. ny.gt.512) then
       if (nx.gt.8192 .or. ny.gt.8192) then
          call map_message(seve%e,rname,'More than 8192 pixels in X or Y')
          error = .true.
       else
          call map_message(seve%w,rname,'More than 512 pixels in X or Y')
       endif
       write(mess,*) 'Offset extrema are: ',sd%xmin,sd%xmax,sd%ymin,sd%ymax
       call map_message(seve%i,rname,mess)
       write(mess,*) 'Pixel sizes are',xconv(3),yconv(3)
       call map_message(seve%i,rname,mess)
       if (error) return
    endif
    !
    ! Number of channels
    nf = sd%mcol(2)-sd%mcol(1)+1
    write(mess,'(A,I0,A,I0,A,I0,A)') 'Creating ',nf,' channels from [',sd%mcol(1),',',sd%mcol(2),']'
    call map_message(seve%i,rname,mess)
    !
    ! Fill output cube header in LMV order
    call map_message(seve%i,rname,'Creating map file '//trim(sd%ou%file))
    sd%ou%gil%ndim = 3
    sd%ou%gil%dim(1) = nx
    sd%ou%gil%dim(2) = ny
    sd%ou%gil%dim(3) = nf
    sd%ou%gil%dim(4) = 1
    sd%ou%loca%size = nx*ny*nf
    sd%ou%gil%ref(3) = sd%in%gil%ref(1)-sd%mcol(1)+1
    sd%ou%gil%val(3) = sd%ou%gil%voff
    sd%ou%gil%inc(3) = sd%ou%gil%vres
    sd%ou%gil%convert(:,1) = xconv
    sd%ou%gil%convert(:,2) = yconv
    sd%ou%char%code(1) = sd%in%char%code(2)
    sd%ou%char%code(2) = sd%in%char%code(3)
    ! Patch a bug in Header transmission: the table has only 2 dimensions,so the 3rd axis is undefined
    if (len_trim(sd%ou%char%code(2)).eq.0) sd%ou%char%code(2)='DEC'
    sd%ou%char%code(3) = sd%in%char%code(1)
    sd%ou%gil%coor_words = 6*gdf_maxdims       ! not a table
    sd%ou%gil%extr_words = 0                   ! extrema not computed
    sd%ou%gil%xaxi = 1
    sd%ou%gil%yaxi = 2
    sd%ou%gil%faxi = 3
    sd%ou%gil%form = fmt_r4
    ! Take into account gridding kernel
    sd%ou%gil%reso_words = 3
    sd%ou%gil%majo = prog%sdbeamou
    sd%ou%gil%mino = prog%sdbeamou
    sd%ou%gil%posa = 0.0
  end subroutine uvshort_define_lmv
  !
  subroutine uvshort_reproject_offsets(rname,uv,nd,sd,error)
    use gbl_message
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Reproject the single-dish table offsets to the UV table reference
    ! position. SD offsets are replaced in-place. SD header is also
    ! updated to ensure consistency.
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_uvdata_t), intent(in)    :: uv
    integer(kind=4),        intent(in)    :: nd
    type(uvshort_sddata_t), intent(inout) :: sd
    logical,                intent(inout) :: error
    !
    type(projection_t) :: uvproj,sdproj
    integer(kind=4) :: ioff
    real(kind=8) :: rxoff,ryoff,axoff,ayoff
    !
    ! Setup the projections
    call gwcs_projec(uv%in%gil%a0,uv%in%gil%d0,&
                     uv%in%gil%pang,uv%in%gil%ptyp,&
                     uvproj,error)
    if (error) return
    call gwcs_projec(sd%in%gil%a0,sd%in%gil%d0,&
                     sd%in%gil%pang,sd%in%gil%ptyp,&
                     sdproj,error)
    if (error) return
    !
    if (uv%in%gil%a0.eq.sd%in%gil%a0 .and.  &
        uv%in%gil%d0.eq.sd%in%gil%d0 .and.  &
        uv%in%gil%pang.eq.sd%in%gil%pang .and.  &
        uv%in%gil%ptyp.eq.sd%in%gil%ptyp)  return
    !
    call map_message(seve%i,rname,  &
      'Reprojecting single-dish offsets to UV table projection')
    !
    ! New header (for table AND lmv)
    sd%in%gil%a0 = uv%in%gil%a0
    sd%in%gil%d0 = uv%in%gil%d0
    sd%in%gil%pang = uv%in%gil%pang
    sd%in%gil%ptyp = uv%in%gil%ptyp
    !
    sd%ou%gil%a0 = uv%in%gil%a0
    sd%ou%gil%d0 = uv%in%gil%d0
    sd%ou%gil%pang = uv%in%gil%pang
    sd%ou%gil%ptyp = uv%in%gil%ptyp
    !
    ! New offsets
    do ioff=1,nd
       rxoff = sd%in%r2d(sd%xcol,ioff)
       ryoff = sd%in%r2d(sd%ycol,ioff)
       call rel_to_abs(sdproj,rxoff,ryoff,axoff,ayoff,1)
       call abs_to_rel(uvproj,axoff,ayoff,rxoff,ryoff,1)
       sd%in%r2d(sd%xcol,ioff) = rxoff
       sd%in%r2d(sd%ycol,ioff) = ryoff
    enddo
    !
  end subroutine uvshort_reproject_offsets
  !
  subroutine uvshort_sort_by_increasing_y(rname,data,nc,nd,iy,error)
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    !------------------------------------------------------------------------
    ! Output visi(nc,nd) will contain iy column values in increasing order
    ! In other words, data(iy,*) is the sorting key
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer(kind=4),  intent(in)    :: nc,nd
    integer(kind=4),  intent(in)    :: iy
    real(kind=4),     intent(inout) :: data(nc,nd)
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: i,ier
    real(kind=4), allocatable :: ws(:) ! Work space
    !
    do i=1,nd-1
       if (data(iy,i).gt.data(iy,i+1)) then
          call map_message(seve%i,rname,'Sorting input table')
          allocate(ws(nc),stat=ier)
          if (failed_allocate(rname,'Sorting work space',ier,error)) return
          ier = trione (data,nc,nd,iy,ws)
          if (ier.ne.1) then
             call map_message(seve%e,rname,'Insufficient sorting space')
             error = .true.
          endif
          deallocate(ws)
          return
       endif
    enddo
    call map_message(seve%i,rname,'Input table is sorted')
  end subroutine uvshort_sort_by_increasing_y
  !
  function trione(x,nd,n,ix,work)
    !------------------------------------------------------------------------
    ! sorting program that uses a quicksort algorithm.
    ! sort on one row
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nd,n
    real(kind=4),    intent(inout) :: x(nd,n)   ! Array to be sorted
    integer(kind=4), intent(in)    :: ix        ! x(ix,*) is the sorting key
    real(kind=4),    intent(inout) :: work(nd)  ! Work space for exchange
    !
    integer(kind=4), parameter :: maxstack=1000
    integer(kind=4), parameter :: nstop=15
    integer(kind=4) :: trione
    integer(kind=4) :: i,j,k,l1,r1,l,r,m
    integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
    real(kind=4) :: key
    logical :: mgtl,lgtr,rgtm
    !
    trione = 1
    if (n.le.nstop) goto 50
    sp = 0
    sp = sp + 1
    lstack(sp) = 1
    rstack(sp) = n
    !
    ! Sort a subrecord off the stack
    ! set key = median of x(l),x(m),x(r)
    ! no! this is not reasonable,as systematic very inequal partitioning will
    ! occur in some cases (especially for nearly already sorted files)
    ! to fix this problem,i found (but i cannot prove it) that it is best to
    ! select the estimation of the median value from intermediate records. p.v.
    !
1   l = lstack(sp)
    r = rstack(sp)
    sp = sp - 1
    m = (l + r) / 2
    l1=(2*l+r)/3
    r1=(l+2*r)/3
    !
    mgtl = x(ix,m) .gt. x(ix,l)
    rgtm = x(ix,r) .gt. x(ix,m)
    !
    ! Algorithm to select the median key. the original one from mongo
    ! was completely wrong. p. valiron,24-jan-84 .
    !
    !       mgtl  rgtm  lgtr  mgtl.eqv.lgtr median_key
    !
    ! kl < km < kr  t t * *   km
    ! kl > km > kr  f f * *   km
    !
    ! kl < km > kr  t f f f   kr
    ! kl < km > kr  t f t t   kl
    !
    ! kl > km < kr  f t f t   kl
    ! kl > km < kr  f t t f   kr
    !
    if (mgtl .eqv. rgtm) then
       key = x(ix,m)
    else
       lgtr = x(ix,l) .gt. x(ix,r)
       if (mgtl .eqv. lgtr) then
          key = x(ix,l)
       else
          key = x(ix,r)
       endif
    endif
    i = l
    j = r
    !
    ! Find a big record on the left
    !
10  if (x(ix,i).ge.key) goto 11
    i = i + 1
    goto 10
11  continue
    !
    ! Find a small record on the right
    !
20  if (x(ix,j).le.key) goto 21
    j = j - 1
    goto 20
21  continue
    if (i.ge.j) goto 2
    !
    ! Exchange records
    !
    call r4tor4 (x(1,i),work,nd)
    call r4tor4 (x(1,j),x(1,i),nd)
    call r4tor4 (work,x(1,j),nd)
    i = i + 1
    j = j - 1
    goto 10
    !
    ! Subfile is partitioned into two halves,left .le. right
    ! push the two halves on the stack
    !
2   continue
    if (j-l+1 .gt. nstop) then
       sp = sp + 1
       if (sp.gt.maxstack) then
          write(6,*) 'E-UV_SHORT,Stack overflow ',sp
          trione = 0
          return
       endif
       lstack(sp) = l
       rstack(sp) = j
    endif
    if (r-j .gt. nstop) then
       sp = sp + 1
       if (sp.gt.maxstack) then
          write(6,*) 'E-UV_SHORT,Stack overflow ',sp
          trione = 0
          return
       endif
       lstack(sp) = j+1
       rstack(sp) = r
    endif
    !
    ! anything left to process?
    !
    if (sp.gt.0) goto 1
    !
50  continue
    !
    do 110 j = n-1,1,-1
       k = j
       do i = j+1,n
          if (x(ix,j).le.x(ix,i)) goto 121
          k = i
       enddo
121    continue
       if (k.eq.j) goto 110
       call r4tor4 (x(1,j),work,nd)
       do i = j+1,k
          call r4tor4 (x(1,i),x(1,i-1),nd)
       enddo
       call r4tor4 (work,x(1,k),nd)
110 continue
    !
  end function trione
  !
  subroutine uvshort_get_weight_column(rname,data,nc,nd,we,iw,error)
    !------------------------------------------------------------------------
    ! Fill in weights array from the input table
    !------------------------------------------------------------------------    
    character(len=*),          intent(in)    :: rname
    integer(kind=4),           intent(in)    :: nc
    integer(kind=4),           intent(in)    :: nd
    integer(kind=4),           intent(in)    :: iw          ! Weight column
    real(kind=4),              intent(in)    :: data(nc,nd)
    real(kind=4), allocatable, intent(inout) :: we(:)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    allocate(we(nd),stat=ier)
    if (failed_allocate(rname,'Single-dish weights',ier,error)) return
    !
    if (iw.le.0 .or. iw.gt.nc) then
       ! Weight column does not exist...
       we(1:nd) = 1.0
    else
       ! Weight colum do exist
       we(1:nd) = data(iw,1:nd)
    endif
  end subroutine uvshort_get_weight_column
  !
  subroutine uvshort_find_size(x,nc,nd,ix,iy,we,xmin,xmax,ymin,ymax)
    !------------------------------------------------------------------------
    ! Find extrema xmin,xmax in ix column values
    !          and ymin,ymax in iy column values,
    ! in table x(nd,nd) for points where weight is not null
    ! taking in account that table x is ordered on iy column values.
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)  :: nc,nd       ! Table size
    integer(kind=4), intent(in)  :: ix,iy       ! X and Y column pointers
    real(kind=4),    intent(in)  :: x(nc,nd)    ! Table data
    real(kind=4),    intent(in)  :: we(nd)      ! Weights
    real(kind=4),    intent(out) :: xmin,xmax,ymin,ymax  ! Min-Max
    !
    integer(kind=4) :: i,j
    !
    i = 1
    ! Loop to start after null weights measurements
    do while (we(i).eq.0)
       i = i+1
    enddo
    ! ymin is first y value with weight not null
    ymin = x(iy,i)
    ! initialize xmin and xmax for searching loop
    xmin = x(ix,i)
    xmax = x(ix,i)
    ! Loop on table lines to find xmin and xmax
    i = i+1
    do j=i,nd
       if (we(j).ne.0) then
          if (x(ix,j).lt.xmin) then
             xmin = x(ix,j)
          elseif (x(ix,j).gt.xmax) then
             xmax = x(ix,j)
          endif
       endif
    enddo
    ! Loop to find ymax = last y values with weight not null
    i = nd
    do while (we(i).eq.0)
       i = i-1
    enddo
    ymax = x(iy,i)
  end subroutine uvshort_find_size
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_grid(rname,prog,nc,nd,nf,nx,ny,xconv,yconv,sdwei,sd,vlmcube)
    use mapping_interfaces
    !-----------------------------------------------------------------------
    ! Grid the SD data: Resample in space of the original spectra on a
    ! regular grid, using a convolution kernel
    !
    ! Compute gridding function: a small (1/3 of SD beam) gaussian
    ! Note: since xconv and yconv depends on SD beam, all gridding
    ! parameters do depend on SD beam value...
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    integer(kind=4),        intent(in)    :: nc,nd,nf,nx,ny
    real(kind=8),           intent(in)    :: xconv(3),yconv(3)
    real(kind=4),           intent(in)    :: sdwei(nd)
    type(uvshort_sddata_t), intent(inout) :: sd
    real(kind=4),           intent(inout) :: vlmcube(nf,nx,ny)
    !
    integer(kind=4) :: ctypx,ctypy,ix,iy,ier
    real(kind=4) :: smooth,xparm(10),yparm(10),support(2),cell(2)
    real(kind=4), allocatable :: xcoord(:),ycoord(:)
    !
    ! Define X and Y convolution functions
    smooth = prog%sdbeamin/3.0
    ctypx = 2
    ctypy = 2
    support(1) = 5*smooth
    support(2) = 5*smooth
    xparm(1) = support(1)/abs(xconv(3))
    yparm(1) = support(2)/abs(yconv(3))
    xparm(2) = smooth/(2*sqrt(log(2.0)))/abs(xconv(3))
    yparm(2) = smooth/(2*sqrt(log(2.0)))/abs(yconv(3))
    xparm(3) = 2
    yparm(3) = 2
    call convfn(ctypx,xparm,ubuff,ubias)
    call convfn(ctypy,yparm,vbuff,vbias)
    cell(1) = xconv(3)
    cell(2) = yconv(3)
    ! Grid coordinates
    allocate(xcoord(nx),ycoord(ny),stat=ier)
    if (failed_allocate(rname,'L or M axis',ier,error)) return
    xcoord(:) = (/(real((dble(ix)-sd%ou%gil%ref(1))*sd%ou%gil%inc(1)+sd%ou%gil%val(1)),ix=1,nx)/)
    ycoord(:) = (/(real((dble(iy)-sd%ou%gil%ref(2))*sd%ou%gil%inc(2)+sd%ou%gil%val(2)),iy=1,ny)/)
    ! Do the actual work
    call uvshort_sd_conv(nc,nd,sd%in%r2d,sd%xcol,sd%ycol,sd%mcol(1),&
         sdwei,sd%we%r2d,nf,nx,ny,vlmcube,xcoord,ycoord,support,cell)
    deallocate(xcoord,ycoord)
  end subroutine uvshort_sd_grid
  !
  subroutine uvshort_sd_conv(nd,np,visi,jx,jy,jo,we,gwe,&
      nf,nx,ny,map,mapx,mapy,sup,cell)
    !------------------------------------------------------------------------
    ! Convolution of 'map' by function defined by vbuff & vbias
    ! (via subroutine uvshort_convol, available by CONTAIN association).
    !------------------------------------------------------------------------
    integer(kind=4), intent(in)  :: np                ! number of visibilities
    integer(kind=4), intent(in)  :: nd                ! visibility size
    integer(kind=4), intent(in)  :: nf                ! number of channels
    integer(kind=4), intent(in)  :: nx,ny             ! map size
    integer(kind=4), intent(in)  :: jx,jy             ! x and y columns in visi
    real(kind=4),    intent(in)  :: we(np)            ! weights
    integer(kind=4), intent(in)  :: jo                ! offset for data in visi
    real(kind=4),    intent(in)  :: visi(nd,np)       ! values
    real(kind=4),    intent(out) :: gwe(nx,ny)        ! gridded weights
    real(kind=4),    intent(out) :: map(nf,nx,ny)     ! gridded values
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny) ! coordinates of grid
    real(kind=4),    intent(in)  :: sup(2)            ! support of convolving function in user units
    real(kind=4),    intent(in)  :: cell(2)           ! cell size in user units
    !
    integer(kind=4) :: ifirs,ilast ! range to be considered
    integer(kind=4) :: ix,iy,i
    real(kind=4) :: result,weight
    real(kind=4) :: u,v,du,dv,um,up,vm,vp
    !
    gwe = 0.0
    ! Loop on Y
    ifirs = 1
    do iy=1,ny
       v = mapy(iy)
       ! sup is the support of the gridding function
       vm = v-sup(2)
       vp = v+sup(2)
       ! Find points to be considered
       call uvshort_find_point(np,nd,jy,visi,vm,ifirs)
       ilast = ifirs
       call uvshort_find_point(np,nd,jy,visi,vp,ilast)
       ilast = ilast-1
       ! Initialize x column
       map(1:nf,1:nx,iy) = 0.0
       if (ilast.ge.ifirs) then
          ! Loop on x cells
          do ix=1,nx
             u = mapx(ix)
             um = u-sup(1)
             up = u+sup(1)
             weight = 0.0
             ! Loop on relevant data points
             do i=ifirs,ilast
                ! Test if X position is within the range to be
                ! considered
                if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
                   ! Compute convolving factor
                   du = (u-visi(jx,i))/cell(1)
                   dv = (v-visi(jy,i))/cell(2)
                   call uvshort_convol(du,dv,result)
                   if (result.ne.0.0) then
                      ! Do the convolution: map(pixel) = sum of
                      ! relevant values * convolving factor * weight
                      result = result*we(i)
                      weight = weight + result
                      map (1:nf,ix,iy) = map (1:nf,ix,iy) + visi((jo):(nf+jo-1),i)*result
                   endif
                endif
             enddo
             ! gwe is the sum of the (convolving factor * weight) ie
             ! the sum of the weighting factors applied to the data
             gwe(ix,iy) = weight
             ! Normalization (only in cells where some data exists)
             if (weight.ne.0) then
                map (1:nf,ix,iy) = map(1:nf,ix,iy)/weight
             endif
          enddo
       endif
    enddo
  end subroutine uvshort_sd_conv
  !
  subroutine uvshort_find_point(nv,nc,ic,xx,xlim,nlim)
    !-----------------------------------------------------------------------
    ! Optimized dichotomic search of nlim such as
    !   xx(ic,nlim-1) < xlim < xx(ic,nlim)
    ! It assumes that the input data is ordered, and that nlim is already
    ! preset so that xx(ic,nlim-1) < xlim
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nv       ! Number of visibilities
    integer(kind=4), intent(in)    :: nc       ! Size of a visibility
    integer(kind=4), intent(in)    :: ic       ! Column to be tested
    integer(kind=4), intent(inout) :: nlim
    real(kind=4),    intent(in)    :: xx(nc,nv),xlim
    !
    integer(kind=4) :: ninf,nsup,nmid
    !
    if (nlim.gt.nv) return
    ! Define limits of searching area in the table
    if (xx(ic,nlim).gt.xlim) then
       return
    elseif (xx(ic,nv).lt.xlim) then
       nlim = nv+1
       return
    endif
    ninf = nlim
    nsup = nv
    ! Dichotomic search for input data ordered
    do while(nsup.gt.ninf+1)
       ! Define middle of the searching area on the table
       nmid = (nsup + ninf)/2
       ! If it's not in the last part,it's in the first one...
       ! then defined new searching limits area
       if (xx(ic,nmid).lt.xlim) then
          ninf = nmid
       else
          nsup = nmid
       endif
    enddo
    ! Output
    nlim = nsup
  end subroutine uvshort_find_point
  !
  subroutine uvshort_convol(du,dv,resu)
    !-----------------------------------------------------------------------
    ! Compute convolving factor resu
    ! resu is the result of the multiplication of the convolution functions,
    ! for u and v axes,at point (du,dv)
    !
    ! Convolution function is defined in ubuff ubias and in vbuff & vbias,
    ! by CONTAIN association in the main program
    !-----------------------------------------------------------------------
    real(kind=4), intent(in)  :: du,dv
    real(kind=4), intent(out) :: resu
    !
    integer(kind=4) :: iu,iv
    !
    ! convolving functions values are tabulated every 1/100 cell
    iu = nint(100.0*du+ubias)
    iv = nint(100.0*dv+vbias)
    !
    ! Participation of u and v axes convolution functions
    resu = ubuff(iu)*vbuff(iv)
    if (resu.lt.1e-20) resu = 0.0
  end subroutine uvshort_convol
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_sd_apodize(rname,prog,nf,nx,ny,xconv,yconv,sd,vlmcube)
    use gbl_message
    use mapping_interfaces
    !-----------------------------------------------------------------------  
    ! Extrapolate to zero outside the convex hull of the mapped region
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    integer(kind=4),        intent(in)    :: nf,nx,ny
    real(kind=8),           intent(in)    :: xconv(3),yconv(3)
    type(uvshort_sddata_t), intent(inout) :: sd
    real(kind=4),           intent(inout) :: vlmcube(nf,nx,ny)
    !
    integer(kind=4) :: ctypx,ctypy,ix,iy,ier
    real(kind=4) :: xparm(10),yparm(10),support(2),cell(2),minwei
    real(kind=4), allocatable :: xcoord(:),ycoord(:)
    !
    ! Define X and Y convolution functions = SD primary beam
    ctypx = 2
    ctypy = 2
    support(1) = 3*prog%sdbeamin
    support(2) = 3*prog%sdbeamin
    xparm(1) = support(1)/abs(xconv(3))
    yparm(1) = support(2)/abs(yconv(3))
    xparm(2) = prog%sdbeamin/(2*sqrt(log(2.0)))/abs(xconv(3))
    yparm(2) = prog%sdbeamin/(2*sqrt(log(2.0)))/abs(yconv(3))
    xparm(3) = 2
    yparm(3) = 2
    call convfn(ctypx,xparm,ubuff,ubias)
    call convfn(ctypy,yparm,vbuff,vbias)
    cell(1) = xconv(3)
    cell(2) = yconv(3)
    ! Grid coordinates
    allocate(xcoord(nx),ycoord(ny),stat=ier)
    if (failed_allocate(rname,'L or M axis',ier,error)) return
    xcoord(:) = (/(real((dble(ix)-sd%ou%gil%ref(1))*sd%ou%gil%inc(1)+sd%ou%gil%val(1)),ix=1,nx)/)
    ycoord(:) = (/(real((dble(iy)-sd%ou%gil%ref(2))*sd%ou%gil%inc(2)+sd%ou%gil%val(2)),iy=1,ny)/)
    !
    call uvshort_sd_analyze_wei(rname,sd%we%r2d,nx,ny,(/sd%we%gil%bval,sd%we%gil%eval/),minwei,error)
    if (error) return
    ! Actual work...
    ! in: vlmcube, out: sd%ou%r3d
    call uvshort_sd_smooth(vlmcube,sd%we%r2d,nf,nx,ny,sd%ou%r3d,&
      xcoord,ycoord,support,cell)
    call map_message(seve%i,rname,'Done image smoothing')
    ! in: sd%ou%r3d, out: vlmcube
!!$ *** JP
!!$    call uvshort_sd_extrapolate(sd%xmin,sd%xmax,sd%ymin,sd%ymax,prog%postol,prog%sdbeam,&
!!$      nf,nx,ny,sd%ou%r3d,vlmcube,xcoord,ycoord,sd%we%r2d,minwei)
!!$ *** JP
    call uvshort_sd_extrapolate(sd%xmin,sd%xmax,sd%ymin,sd%ymax,prog%postol,prog%sdbeamin,&
      nf,nx,ny,sd%ou%r3d,vlmcube,xcoord,ycoord)
    call map_message(seve%i,rname,'Done image extrapolation')
    !
    deallocate(xcoord,ycoord)
  end subroutine uvshort_sd_apodize
  !
  subroutine uvshort_sd_analyze_wei(rname,weiimg,nx,ny,blank,minwei,error)
    use gkernel_interfaces
    use gbl_message
    !-----------------------------------------------------------------------
    ! Analyze a weight image and determine a lower weight cutoff.
    ! MINWEI is the low-percentile cutoff of the valid weight distribution.
    ! Blank, zero, and negative weights are ignored.
    !-----------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    integer(kind=4),  intent(in)    :: nx,ny
    real(kind=4),     intent(in)    :: blank(2)
    real(kind=4),     intent(in)    :: weiimg(nx,ny)
    real(kind=4),     intent(out)   :: minwei
    logical,          intent(inout) :: error
    !
    real(kind=4), parameter :: cutoff_fraction = 0.01
    !
    integer(kind=4), allocatable :: nind(:)
    real(kind=4), allocatable :: locwei(:)
    !
    integer(kind=4) :: nw,ier,ix,iy
    integer(kind=4) :: nvalid,irank
    real(kind=4) :: w
    !
    ! Default returned value in case of failure
    minwei = -1.0
    ! Allocate work arrays
    if (nx.gt.huge(nw)/ny) then
       ! => Overflows
       call map_message(seve%e,rname,'Weight image is too large')
       error = .true.
       return
    endif
    nw = nx*ny
    allocate(locwei(nw),nind(nw),stat=ier)
    if (failed_allocate(rname,'Sorted weight arrays',ier,error)) then
       if (allocated(locwei)) deallocate(locwei)
       if (allocated(nind))   deallocate(nind)
       return
    endif
    ! Compact list of usable weights: only strictly positive, non-blank
    ! weights are retained
    nvalid = 0
    do iy=1,ny
       do ix=1,nx
          w = weiimg(ix,iy)
          if (abs(w-blank(1)).lt.blank(2)) cycle
          if (w.le.0.0) cycle
          nvalid = nvalid + 1
          locwei(nvalid) = w
       enddo ! ix
    enddo ! iy
    if (nvalid.le.0) then
       call map_message(seve%e,rname,'No valid positive weights found')
       deallocate(locwei,nind)
       error = .true.
       return
    endif
    ! Sort the valid weights only.
    call gr4_trie(locwei,nind,nvalid,error)
    if (error) then
       call map_message(seve%e,rname,'Sorting of weights has failed')
       deallocate(locwei,nind)
       return
    endif
    ! Select the low percentile of the valid positive weights.
    !
    ! Since LOCWEI is sorted in increasing order, this is a direct rank
    ! selection.  With CUTOFF_FRACTION = 0.01, the selected rank is the
    ! first one strictly above the 1 percent cumulative fraction.
    irank = int(cutoff_fraction*real(nvalid,kind=4))+1
    if (irank.lt.1) irank = 1
    if (irank.gt.nvalid) irank = nvalid
    minwei = locwei(irank)
    !
    deallocate(locwei,nind)
  end subroutine uvshort_sd_analyze_wei
  !
  subroutine uvshort_sd_smooth(raw,we,nf,nx,ny,map,mapx,mapy,sup,cell)
    !-----------------------------------------------------------------------
    ! Smooth an input data cube raw in vlm along l and m by convolution
    ! by a gaussian function defined in vbuff & vbias via subroutine
    ! uvshort_convol (available by CONTAIN association)
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)  :: nf,nx,ny          ! map size
    real(kind=4),    intent(in)  :: we(nx,ny)         ! weights
    real(kind=4),    intent(in)  :: raw(nf,nx,ny)     ! raw map
    real(kind=4),    intent(out) :: map(nf,nx,ny)     ! smoothed map
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny) ! coordinates of grid
    real(kind=4),    intent(in)  :: sup(2)            ! support of convolving function in user units
    real(kind=4),    intent(in)  :: cell(2)           ! cell size in user units
    !
    integer(kind=4) :: yfirs,ylast ! range to be considered
    integer(kind=4) :: xfirs,xlast ! range to be considered
    integer(kind=4) :: ix,iy
    integer(kind=4) :: jx,jy       ! x coord, y coord location in raw
    real(kind=4) :: result,weight
    real(kind=4) :: u,v,du,dv,um,up,vm,vp,dx,dy
    !
    dx = abs(mapx(2)-mapx(1))
    dy = abs(mapy(2)-mapy(1))
    ! Loop on y rows
    do iy=1,ny
       ! Compute extrema positions on axe y
       ! of gaussian function centered on map(1:nf,ix,iy)
       v = mapy(iy)
       vm = v-sup(2)
       vp = v+sup(2)
       ! Compute extrema positions on axe y
       ! of relevant data points for map(1:nf,ix,iy) convolution
       yfirs = max(1,nint((iy-sup(2)/dy)))
       ylast = min(ny,nint((iy+sup(2)/dy)))
       ! Initialize x colum
       map(1:nf,1:nx,iy) = 0.0
       ! Loop on x cells
       if (yfirs.le.ylast) then
          do ix=1,nx
             ! Compute extrema positions on axe x,idem y
             u = mapx(ix)
             um = u-sup(1)
             up = u+sup(1)
             weight = 0.0
             xfirs = max(1,nint(ix-sup(1)/dx))
             xlast = min(nx,nint(ix+sup(1)/dx))
             ! Loop on relevant data points
             if (xfirs.le.xlast) then
                do jy=yfirs,ylast
                   dv = (v-mapy(jy))/cell(2)
                   do jx=xfirs,xlast
                      du = (u-mapx(jx))/cell(1)
                      ! Compute convolving factor
                      call uvshort_convol (du,dv,result)
                      if (result.ne.0.0) then
                         ! Do the convolution: map(pixel) = sum of
                         ! relevant values * convolving factor
                         weight = weight + result
                         map (1:nf,ix,iy) = map (1:nf,ix,iy) + raw(1:nf,jx,jy)*result
                      endif
                   enddo
                enddo
                ! Normalize weight only in cells where some data exists...
                if (weight.ne.0) then
                   map (1:nf,ix,iy) = map(1:nf,ix,iy)/weight
                endif
             endif
          enddo
       endif
    enddo
  end subroutine uvshort_sd_smooth
  !
  subroutine uvshort_sd_extrapolate(xmin,xmax,ymin,ymax,tole,beam,&
       nf,nx,ny,map,raw,mapx,mapy)
    !-----------------------------------------------------------------------
    ! Replace map edges of raw input data cube with smoothed values
    ! contains in mapx data cube
    !
    ! Map edges corresponding to the part of the map between
    ! max SD observations locations xmin,xmax,ymin,ymax, and map size nx,ny
    !-----------------------------------------------------------------------
    real(kind=4),    intent(in)  :: xmin,xmax,ymin,ymax,tole,beam
    integer(kind=4), intent(in)  :: nf,nx,ny
    real(kind=4),    intent(in)  :: mapx(nx),mapy(ny)
    real(kind=4),    intent(in)  :: map(nf,nx,ny)
    real(kind=4),    intent(out) :: raw(nf,nx,ny)
    !
    integer(kind=4) :: ix,iy
    real(kind=4) :: lobe,apod,disty,distx
    !
    ! Apodisation by a gaussian, twice as large than the SD beam
    lobe = log(2.0)/beam**2
    ! Loop on pixels
    do iy=1,ny
       ! Compute disty: distance between map size ny
       ! and ymin or ymax SD observations limits
       if (mapy(iy).le.ymin-tole) then
          disty = ymin-mapy(iy)
       elseif (mapy(iy).ge.ymax+tole) then
          disty = mapy(iy)-ymax
       else
          disty = 0.0
       endif
       do ix=1,nx
          ! Idem on X, compute distx
          if (mapx(ix).le.xmin-tole) then
             distx = xmin-mapx(ix)
          elseif (mapx(ix).ge.xmax+tole) then
             distx = mapx(ix)-xmax
          else
             distx = 0.0
          endif
          ! Apodisation factor
          apod = (distx**2+disty**2)*lobe
          ! 'raw' is replaced by something else only in two cases
          if (apod.gt.80) then
             ! Map edges
             raw(1:nf,ix,iy) = 0.0
          elseif (apod.ne.0.0) then
             ! Map edges
             apod = exp(-apod)
             raw(1:nf,ix,iy) = map(1:nf,ix,iy)*apod
          endif
       enddo ! ix
    enddo ! iy
    !
  end subroutine uvshort_sd_extrapolate
  !
  subroutine uvshort_sd_transpose(a,b,n,m)
    !-----------------------------------------------------------------------
    ! Output table "b" is table "a" transposed in line/column order
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)  :: n,m
    real(kind=4),    intent(in)  :: a(n,m)
    real(kind=4),    intent(out) :: b(m,n)
    !
    integer(kind=4) :: i,j
    !
    do i=1,m
       do j=1,n
          b(i,j) = a(j,i)
       enddo
    enddo
  end subroutine uvshort_sd_transpose
  !
  subroutine uvshort_sd_free(sd)
    !-------------------------------------------------------------------
    ! Clean up a 'uvshort_sddata_t' structure
    !-------------------------------------------------------------------
    type(uvshort_sddata_t), intent(inout) :: sd
    !
    if (associated(sd%in%r2d))  deallocate(sd%in%r2d)
    if (associated(sd%in%r3d))  deallocate(sd%in%r3d)
    if (associated(sd%we%r2d))  deallocate(sd%we%r2d)
    if (associated(sd%ou%r3d))  deallocate(sd%ou%r3d)
    !
  end subroutine uvshort_sd_free
  !
  subroutine uvshort_uv_free(uv)
    !-------------------------------------------------------------------
    ! Clean up a 'uvshort_uvdata_t' structure
    !-------------------------------------------------------------------
    type(uvshort_uvdata_t), intent(inout) :: uv
    !
    if (associated(uv%ps%r2d))  deallocate(uv%ps%r2d)
    if (associated(uv%inbeam%r2d))  deallocate(uv%inbeam%r2d)
    if (associated(uv%oubeam%r2d))  deallocate(uv%oubeam%r2d)
    !
  end subroutine uvshort_uv_free
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_pseudo(rname,prog,do,sd,uv,error)
    use gbl_message
    !$ use omp_lib
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ifield
    type(uvshort_buffer_t) :: buf
    character(len=message_length) :: mess
    !
    !$ integer(kind=4) :: ompkind, dochunksize, ompcounter, threadid
    !
    call uvshort_pseudo_header(rname,prog,sd,uv)
    call map_message(seve%i,rname,'Done definition of pseudo-visibility header')
    !
    !$OMP PARALLEL &
    !$OMP DEFAULT(none) &
    !$OMP SHARED(rname,do,prog,uv,sd,error,ompkind,ompcounter,dochunksize) &
    !$OMP FIRSTPRIVATE(buf) &
    !$OMP PRIVATE(ifield,mess,threadid)
    !$ ompcounter = 0
    call uvshort_pseudo_buffer_allocate(rname,&
         sd%ou%gil%dim(1),sd%ou%gil%dim(2),sd%ou%gil%dim(3),&
         buf,error)
    if (.not.error) then
       call map_message(seve%i,rname,'Done buffer memory allocation')
       call uvshort_pseudo_get_sdlobe_uv(prog%sddiam,sd%ou,buf,error)
       if (.not.error) then
          call map_message(seve%i,rname,'Done single-dish lobe definition')
          !
          ! Loop on mosaic field
          !$OMP DO
          do ifield=1,uv%nfield
             if (error)  cycle
             !$ threadid = omp_get_thread_num();
             !$ if (threadid.eq.0) then
             !$    call OMP_GET_SCHEDULE(ompkind, dochunksize)
             !$    if (OMP_IN_PARALLEL()) then
             !$       ompcounter = ompcounter +1
             !$       write(mess,'(A,i0,A,i0)') 'Computing chunk: ',ompcounter,' / ',dochunksize
             !$    else
                      write(mess,'(A,i0,A,i0)') 'Computing field ',ifield,' / ',uv%nfield
             !$    end if
                   call map_message(seve%i,rname,mess)
             !$ end if          
             call uvshort_pseudo_get_iplobe(prog%ipdiam,prog%ipbeam,uv,sd%ou,ifield,buf)
             call uvshort_pseudo_compute_visi(do,sd,buf)
             call uvshort_pseudo_compute_wei(do,sd,buf)
             call uvshort_pseudo_fill_uvt(rname,prog%uvtrunc,sd%ou,ifield,buf,uv,error)
          enddo ! ifield
          !$OMP END DO
       endif
    endif
    call uvshort_pseudo_buffer_deallocate(rname,buf,error)
    !$OMP END PARALLEL
    if (error) return ! This is not allowed inside parallel session, moved out
    !
    ! Write pseudo-visibility table
    call gdf_create_image(uv%ps,error)
    if (error) return
    call gdf_write_data(uv%ps,uv%ps%r2d,error)
    if (error) return
    call gdf_close_image(uv%ps,error)
    if (error) return
    ! *** JP => Should clean up memory
  end subroutine uvshort_pseudo
  !
  subroutine uvshort_pseudo_header(rname,prog,sd,uv)
    use gbl_message
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(in)    :: prog
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_uvdata_t), intent(inout) :: uv
    !
    integer(kind=4) :: nvis,ncol,ier
    !
    call map_message(seve%i,rname,'Creating UV table '//trim(uv%ps%file))
    call uvshort_pseudo_count_visi(sd%ou,prog%uvtrunc,uv%nvisi_per_field)
    nvis = uv%nvisi_per_field*uv%nfield
    ! Initialize the header
    uv%ps%gil%nvisi = nvis
    uv%ps%gil%dim(2) = nvis
    uv%ps%blc(2) = 1
    uv%ps%trc(2) = nvis
    ncol = uv%ps%gil%dim(1)
    allocate(uv%ps%r2d(ncol,nvis),stat=ier)
    if (failed_allocate(rname,'pseudo visibility table',ier,error)) return
  end subroutine uvshort_pseudo_header
  !
  subroutine uvshort_pseudo_count_visi(lmv,uvmax,nvisi)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Compute number of visibilities nvisi sampled on a regular grid of
    ! steps dx, dy inside the disk of radius uvmax for one mosaic field
    ! -----------------------------------------------------------------------
    type(gildas),    intent(in)  :: lmv
    real(kind=4),    intent(in)  :: uvmax
    integer(kind=4), intent(out) :: nvisi
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: uu,vv,uvmax2
    real(kind=8) :: dx,dy
    !
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    uvmax2 = uvmax**2
    ! Count number of visilibity for one mosaic field
    nx = lmv%gil%dim(1)
    ny = lmv%gil%dim(2)
    nvisi = 0
    do j = 1,ny
       jj = mod(j-1+ny/2,ny)-ny/2
       vv = jj*dy
       do i = 1,nx/2
          ii = mod(i-1+nx/2,nx)-nx/2
          uu = ii*dx
          if (uu*uu+vv*vv.le.uvmax2) then
             nvisi = nvisi + 1
          endif
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_count_visi
  !
  subroutine uvshort_pseudo_buffer_allocate(rname,nx,ny,nf,buf,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    !
    !-----------------------------------------------------------------------
    character(len=*),           intent(in)    :: rname
    integer(kind=index_length), intent(in)    :: nx,ny,nf
    type(uvshort_buffer_t),     intent(inout) :: buf
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    allocate(buf%xy(2,nf),stat=ier)
    if (failed_allocate(rname,'phase shift memory',ier,error)) return
    allocate(buf%sdlobe_uv(nx,ny),stat=ier)
    if (failed_allocate(rname,'single dish beam',ier,error)) return
    allocate(buf%iplobe_uv(nx,ny),stat=ier)
    if (failed_allocate(rname,'interferometer primary beam',ier,error)) return
    allocate(buf%iplobe_lm(nx,ny),stat=ier)
    if (failed_allocate(rname,'interferometer primary beam',ier,error)) return
    allocate(buf%visi(nx,ny,nf),stat=ier)
    if (failed_allocate(rname,'work space',ier,error)) return
    allocate(buf%uvwei(nx,ny),stat=ier)
    if (failed_allocate(rname,'uv weights',ier,error)) return
    allocate(buf%fftws(2*max(nx,ny)),stat=ier)
    if (failed_allocate(rname,'FFT work space',ier,error)) return
    ! Successful allocation
    buf%nx = nx
    buf%ny = ny
    buf%nf = nf
    buf%ndim = 2
    buf%dim(1) = nx
    buf%dim(2) = ny
  end subroutine uvshort_pseudo_buffer_allocate
  !
  subroutine uvshort_pseudo_buffer_deallocate(rname,buf,error)
    use gkernel_interfaces
    use gbl_message
    !-----------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_buffer_t), intent(inout) :: buf
    logical,                intent(inout) :: error
    !
    buf%nx = 0
    buf%ny = 0
    buf%nf = 0
    buf%ndim = 0
    buf%dim(1) = 0
    buf%dim(2) = 0
    !
    if (allocated(buf%xy)) deallocate(buf%xy)
    if (allocated(buf%sdlobe_uv)) deallocate(buf%sdlobe_uv)
    if (allocated(buf%iplobe_uv)) deallocate(buf%iplobe_uv)
    if (allocated(buf%iplobe_lm)) deallocate(buf%iplobe_lm)
    if (allocated(buf%visi)) deallocate(buf%visi)
    if (allocated(buf%uvwei)) deallocate(buf%uvwei)
    if (allocated(buf%fftws)) deallocate(buf%fftws)
  end subroutine uvshort_pseudo_buffer_deallocate
  !
  subroutine uvshort_pseudo_get_sdlobe_uv(diam,lmv,buf,error)
    use gbl_message
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Compute the single-dish beam directly in the uv plane, i.e., a
    ! Gaussian truncated at dish size
    !-----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: diam
    type(gildas),           intent(in)    :: lmv
    type(uvshort_buffer_t), intent(inout) :: buf
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='UV_SHORT'
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: a,b,xx,yy
    real(kind=4) :: beam
    real(kind=8) :: dx,dy
    !
    ! Sanity check
    if (lmv%gil%majo.le.0. .or.  &
        lmv%gil%majo.ne.lmv%gil%majo) then  ! 0 or NaN
      ! ZZZ Shouldn't we use the telescope diameter as fallback (as other
      ! ZZZ parts of the code)? See where the function primary_beam() is
      ! ZZZ used.
      call map_message(seve%e,rname,'Single dish beam is not defined')
      error = .true.
      return
    endif
    !
    ! Equivalent beam area in square pixels
    beam = lmv%gil%majo ! *** JP is it what we actually want?
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    a = abs(4*alog(2.)/pi/beam**2*lmv%gil%inc(2)*lmv%gil%inc(1))
    b = (pi*beam/2/clight_mhz*lmv%gil%freq)**2/alog(2.)
! *** JP
!    print *,'sdlobe',beam,a,b
!    print *,'sdlobe: freq,dx,dy',lmv%gil%freq,dx,dy
! *** JP
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y, pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = ( jj*dy )**2
       do i = 1,nx
          ! Loop on X, pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ( ii*dx )**2
          ! Truncation of the gaussian at diam
          if (xx+yy.le.diam**2) then
             buf%sdlobe_uv(i,j) = exp(b*(xx+yy))*a
          else
             buf%sdlobe_uv(i,j) = 0.0
          endif
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_get_sdlobe_uv
  !
  subroutine uvshort_pseudo_get_iplobe(diam,beam,uv,lmv,ifield,buf)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! 1. Compute the interferometric primary beam directly in the uv plane, i.e.,
    !    Gaussian truncated at dish size
    ! 2. UV shift the beam at (uv%raoff(ifield),uv%deoff(ifield)) in the uv plane
    ! 3. And inverse Fourier Transform it to get the interferometric primary
    !    beam in the LM plane
    !----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: diam
    real(kind=4),           intent(in)    :: beam
    type(uvshort_uvdata_t), intent(in)    :: uv
    type(gildas),           intent(in)    :: lmv
    integer(kind=4),        intent(in)    :: ifield
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: a,b,xx,yy
    real(kind=8) :: dx,dy
    !
    ! Equivalent beam area in square pixels...
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    a = abs(4*alog(2.)/pi/beam**2*lmv%gil%inc(2)*lmv%gil%inc(1))
    b = (pi*beam/2/clight_mhz*lmv%gil%freq)**2/alog(2.)
! *** JP
!    print *,'iplobe: beam,a,b',beam,a,b
!    print *,'iplobe: freq,dx,dy',lmv%gil%freq,dx,dy
! *** JP
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y, pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = ( jj*dy )**2
       do i = 1,nx
          ! Loop on X, pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ( ii*dx )**2
          ! Truncation of the gaussian at diam
          if (xx+yy.le.diam**2) then
             buf%iplobe_uv(i,j) = cmplx(exp(-b*(xx+yy))*a)
          else
             buf%iplobe_uv(i,j) = cmplx(0.0)
          endif
       enddo ! i
    enddo ! j
    ! UV shift
    call uvshort_pseudo_uvshift_iplobe(&
         uv%raoff(ifield),uv%deoff(ifield),lmv,buf)
    ! Inverse Fourier Transform
    call fourt(buf%iplobe_uv,buf%dim,buf%ndim,1,1,buf%fftws)
    call cmtore(buf%iplobe_uv,buf%iplobe_lm,buf%nx,buf%ny)
    ! Normalize peak to 1
    buf%iplobe_lm(:,:) = buf%iplobe_lm/maxval(buf%iplobe_lm)
  end subroutine uvshort_pseudo_get_iplobe
  !
  subroutine uvshort_pseudo_uvshift_iplobe(offra,offde,lmv,buf)
    use phys_const
    use image_def
    !-----------------------------------------------------------------------
    ! Center in uv plane interferometer beam of a mosaic field
    ! at its right position (offra,offdec)
    !-----------------------------------------------------------------------
    real(kind=4),           intent(in)    :: offra,offde
    type(gildas),           intent(in)    :: lmv
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: i,j,ii,jj,nx,ny
    real(kind=4) :: phi,sp,cp,xx,yy,re,im
    real(kind=8) :: du,dv
    !
    du = 1.d0/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dv = 1.d0/(lmv%gil%inc(2)*lmv%gil%dim(2))
    ! Loop on pixels
    nx = buf%nx
    ny = buf%ny
    do j = 1,ny
       ! Loop on Y,pixels locations on Fourier plane
       jj = mod(j-1+ny/2,ny)-ny/2
       yy = jj*dv
       do i = 1,nx
          ! Loop on X,pixels locations on Fourier plane
          ii = mod(i-1+nx/2,nx)-nx/2
          xx = ii*du
          !
          phi = -2.d0*pi*(offra*xx + offde*yy)
          cp = cos(phi)
          sp = sin(phi)
          !
          re = real(buf%iplobe_uv(i,j))*cp - imag(buf%iplobe_uv(i,j))*sp
          im = real(buf%iplobe_uv(i,j))*sp + imag(buf%iplobe_uv(i,j))*cp
          buf%iplobe_uv(i,j) = cmplx(re,im)
       enddo ! i
    enddo ! j
  end subroutine uvshort_pseudo_uvshift_iplobe
  !
  subroutine uvshort_pseudo_compute_visi(do,sd,buf)
    !-----------------------------------------------------------------------
    ! 1 - Computes the direct fourrier transform of the SD data onto the UV plane
    ! 2 - Deconvolves it from the SD beam.
    ! 3 - Convolves it with the Interferometer primary beam uv shifted to the
    ! current offset.
    !-----------------------------------------------------------------------
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    integer(kind=4) :: if
    !
    ! Loop on frequencies
    do if=1,buf%nf
       ! DFT of SD data
       call retocm(sd%ou%r3d(:,:,if),buf%visi(:,:,if),buf%nx,buf%ny)
       call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,1,1,buf%fftws)
       if (do%deconv_sd) then
          ! Deconvolve SD beam in uv plane
          buf%visi(:,:,if) = buf%visi(:,:,if)*buf%sdlobe_uv
       endif
       if (do%apply_ip) then
          ! Apply interferometer primary beam in image plane
          call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,-1,1,buf%fftws)
          call uvshort_pseudo_multiply_by_iplobe_lm(buf%nx,buf%ny,buf%iplobe_lm,buf%visi(:,:,if))
          call fourt(buf%visi(:,:,if),buf%dim,buf%ndim,1,1,buf%fftws)
          buf%visi(:,:,if) = buf%visi(:,:,if)/(buf%nx*buf%ny)
       endif
    enddo ! if
  end subroutine uvshort_pseudo_compute_visi
  !
  subroutine uvshort_pseudo_multiply_by_iplobe_lm(nx,ny,f,z)
    !-----------------------------------------------------------------------
    ! z = z*f => used to multiply by interferometer primary beam in image plane
    !-----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nx,ny    ! Problem size
    real(kind=4),    intent(in)    :: f(nx,ny) ! Multiplication function
    complex(kind=4), intent(inout) :: z(nx,ny) ! Complex values
    !
    integer(kind=4) :: i,j,ii,jj
    !
    do j = 1,ny
       jj = mod(j+ny/2-1,ny)+1
       do i = 1,nx
          ii = mod(i+nx/2-1,nx)+1
          z(ii,jj) = z(ii,jj) * f(i,j)
       enddo
    enddo
  end subroutine uvshort_pseudo_multiply_by_iplobe_lm
  !
  subroutine uvshort_pseudo_compute_wei(do,sd,buf)
    !-----------------------------------------------------------------------
    ! Computes weights for single dish data in the UV plane
    !-----------------------------------------------------------------------
    type(uvshort_action_t), intent(in)    :: do
    type(uvshort_sddata_t), intent(in)    :: sd
    type(uvshort_buffer_t), intent(inout) :: buf
    !
    if (do%wei.eq.'natural') then
       ! *** JP Something to be done here.
       buf%uvwei = 1.
    else
       buf%uvwei = 1.
    endif
    if (do%deconv_sd) then
       where (buf%sdlobe_uv.ne.0)
          buf%uvwei = 1.0/buf%sdlobe_uv**2
       else where
          buf%uvwei = 0.0
       end where
    endif
  end subroutine uvshort_pseudo_compute_wei
  !  
  subroutine uvshort_pseudo_fill_uvt(rname,uvmax,lmv,ifield,buf,uv,error)
    use phys_const
    use image_def
    use gbl_message
    use uv_shift, only: uv_shift_data
    !-----------------------------------------------------------------------    
    ! Tabulate the visibilities
    !-----------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    real(kind=4),           intent(in)    :: uvmax
    type(gildas),           intent(in)    :: lmv
    integer(kind=4),        intent(in)    :: ifield
    type(uvshort_buffer_t), intent(inout) :: buf
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: i,j,k,kk,ii,jj,kvis,kstart,if
    integer(kind=4) :: nc,nv,nf,nx,ny,ifirst,ilast,mv
    integer(kind=4) :: gdate
    real(kind=4) :: sddatfac,sdweifac,offra,offde
    real(kind=4) :: uu,vv,weisum,we,duv,uvmax2
    real(kind=8) :: dx,dy,freq
    real(kind=4) :: cs(2)
    !
    dx = clight_mhz/lmv%gil%freq/(lmv%gil%inc(1)*lmv%gil%dim(1))
    dy = clight_mhz/lmv%gil%freq/(lmv%gil%inc(2)*lmv%gil%dim(2))
    uvmax2 = uvmax**2
    !
    sddatfac = uv%sddatfac
    sdweifac = 1/(sddatfac**2) ! *** JP probably could be done before...
    !
    call sic_gagdate(gdate)
    !
    nc = uv%ps%gil%dim(1)
    nv = uv%ps%gil%dim(2)
    nf = buf%nf
    nx = buf%nx
    ny = buf%ny
    !
    ! Loop on pixels of the visibility map
    kstart = (ifield-1)*uv%nvisi_per_field
    kvis = kstart
    weisum = 0.0
    do j = 1,ny
       jj = mod(j-1+ny/2,ny)-ny/2
       vv = jj*dy
       do i = 1,nx/2
          ii = mod(i-1+nx/2,nx)-nx/2
          uu = ii*dx
          duv = uu**2+vv**2
          ! Keep only points inside circle defined by uvmax
          if (duv.le.uvmax2) then
             kvis = kvis + 1
             if (kvis.gt.nv) then
                call map_message(seve%e,rname,'Try to write outside space allocated for short-spacing table')
                error = .true.
                return
             endif
             uv%ps%r2d(1,kvis) = uu
             uv%ps%r2d(2,kvis) = vv
             uv%ps%r2d(3,kvis) = 0
             uv%ps%r2d(4,kvis) = gdate   ! Current date
             uv%ps%r2d(5,kvis) = 0
             uv%ps%r2d(6:7,kvis) = -1.0  ! Convention: Antenna # -1 for Short spacings
             kk = 7
             ! Weight
             we = buf%uvwei(i,j)*sdweifac
             if (i.eq.1 .and. j.ne.1) then
                we = we*0.5
             endif
!!$             if (we.lt.0) we = -we   ! *** JP
!!$             ! u=0 v=0 point
!!$             if (duv.eq.0) k00 = kvis
             ! Extract visibilities
             do k=1,nf
                uv%ps%r2d(kk+1,kvis) = real(buf%visi(i,j,k))*sddatfac
                uv%ps%r2d(kk+2,kvis) = imag(buf%visi(i,j,k))*sddatfac
                uv%ps%r2d(kk+3,kvis) = we
                kk = kk + 3
             enddo
             weisum = weisum+we
          endif
       enddo ! i
    enddo ! j
    ! Sanity check
    if ((kvis-kstart).ne.uv%nvisi_per_field) then
       call map_message(seve%e,rname,'Inconsistent number of visibilities')
       error = .true.
       return
    endif
    ifirst = kstart+1
    ilast = kvis
    mv = ilast-ifirst+1
!!$    ! Normalize the weights *** JP ***
!!$    if (weisum.ne.0.) then
!!$       weisum = 1/weisum
!!$       do i=1,nvis
!!$          do k=1,nf
!!$             uv%ps%r2d(7+k*3,i) = uv%ps%r2d(7+k*3,i)*weisum
!!$          enddo ! k
!!$       enddo ! i 
!!$    endif
    !
    if (uv%ismos) then
       offra = uv%raoff(ifield)
       offde = uv%deoff(ifield)
       if (uv%islm) then
          ! Unshift phase center to current pointing center
          ! => Hence the minus sign when computing buf%xy
          cs = [1.0,0.0] ! cos/sin of rotation
                         ! Rotation has already been taken care of before => 1.0,0.0
          do if=1,buf%nf
             freq = gdf_uv_frequency(uv%ps,dble(if))
             buf%xy(1,if) = - freq * f_to_k * offra
             buf%xy(2,if) = - freq * f_to_k * offde
          enddo
          ! Initialize the loff & moff columns to 0 (no shift yet!)
          uv%ps%r2d(uv%ocol(1),ifirst:ilast) = 0
          uv%ps%r2d(uv%ocol(2),ifirst:ilast) = 0
          ! Then shift the UV data set
          call uv_shift_data(uv%ps,nc,mv,uv%ps%r2d(:,ifirst:ilast),&
               cs,buf%nf,buf%xy)
          ! And only ultimately put the final loff & moff values
       endif
       uv%ps%r2d(uv%ocol(1),ifirst:ilast) = offra
       uv%ps%r2d(uv%ocol(2),ifirst:ilast) = offde
    endif
  end subroutine uvshort_pseudo_fill_uvt
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_merge(rname,prog,uv,error)
    use gbl_message
    use gkernel_interfaces
    use mapping_interfaces
    !-------------------------------------------------------------------
    ! Merge interferometric (uv%in) and short-spacing uv (uv%ps) tables
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    ! If uv%ps is not loaded load it here before it is used that is
    ! why it is the first thing done here
    if (.not.associated(uv%ps%r2d)) then
      ! Read all pseudo-visibilities at once from disk
      call gdf_read_header(uv%ps,error)
      if (error)  goto 10
      allocate(uv%ps%r2d(uv%ps%gil%dim(1),uv%ps%gil%dim(2)),stat=ier)
      if (failed_allocate(rname,'pseudo-visibility table',ier,error)) goto 10
      call gdf_read_data(uv%ps,uv%ps%r2d,error)
      if (error)  goto 10
      call gdf_close_image(uv%ps,error)
      if (error)  goto 10
    endif
    ! Header set and written to its final size
    uv%ou%gil%dim(2) = uv%in%gil%nvisi+uv%ps%gil%nvisi
    uv%ou%gil%nvisi  = uv%ou%gil%dim(2)
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    call gdf_create_image(uv%ou,error)
    if (error) return
    ! Prepare weight adjustment
    allocate(uv%inbeam%r2d(4,uv%in%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Input weight table',ier,error)) return
    allocate(uv%oubeam%r2d(4,uv%ou%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'Output weight table',ier,error)) return
    !
    uv%ivisi = 0
    call map_message(seve%i,rname,'Copying interferometric data to output table')
    call uvshort_merge_copy_uvin_fromdisk(rname,uv,error)
    if (error)  goto 10
    call gag_message(seve%i,rname,'Appending short-spacing data to output table')
    
    call uvshort_merge_append_uvps(rname,prog,uv,error)
    if (error)  goto 10
    !
    ! Clean up
10  continue
    call gdf_close_image(uv%ou,error)
    if (error)  return
    !
  end subroutine uvshort_merge
  !
  subroutine uvshort_merge_copy_uvin_fromdisk(rname,uv,error)
    !-------------------------------------------------------------------
    ! Copy the uv%in table into the uv%ou table (both must be already
    ! GDF-opened). Input data is read from disk.
    !-------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nvisiperblock,ier,ivisi,jvisi,kvisi,ichan,icol
    real(kind=4), allocatable :: din(:,:)
    real(kind=4) :: uvdist
    !
    ! Copy input table by blocks of SPACE_GILDAS
    call gdf_nitems('SPACE_GILDAS',nvisiperblock,uv%in%gil%dim(1))
    nvisiperblock = min(nvisiperblock,uv%in%gil%nvisi)
    !
    allocate(din(uv%in%gil%dim(1),nvisiperblock),stat=ier)
    if (failed_allocate(rname,'UV reading buffer',ier,error))  return
    !
    uv%in%blc(:) = 0
    uv%in%trc(:) = 0
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    do ivisi=1,uv%in%gil%nvisi,nvisiperblock
       uv%in%blc(2) = ivisi
       uv%in%trc(2) = min(ivisi+nvisiperblock-1,uv%in%gil%nvisi)
       call gdf_read_data(uv%in,din,error)
       if (error)  return
       do jvisi=uv%in%blc(2),uv%in%trc(2)
          kvisi = jvisi-ivisi+1
          if (uv%ismos) then
             uv%inbeam%r2d(1:2,jvisi) = din(uv%ocol(1):uv%ocol(2),kvisi)
          else
             uv%inbeam%r2d(1:2,jvisi) = 0.0
          endif
          uvdist = sqrt(din(1,kvisi)**2+din(2,kvisi)**2)
          uv%inbeam%r2d(3,jvisi) = uvdist
          uv%inbeam%r2d(4,jvisi) = din(uv%wcol,kvisi)
          ! Multiplication by the interferometer calibration factor
          do ichan=1,uv%in%gil%nchan
             icol = 7+(ichan-1)*3+1
             din(icol,kvisi) = din(icol,kvisi)*uv%ipdatfac
             icol = icol+1
             din(icol,kvisi) = din(icol,kvisi)*uv%ipdatfac
             icol = icol+1
             din(icol,kvisi) = din(icol,kvisi)*(1/uv%ipdatfac**2)
          enddo
       enddo ! jvisi
       uv%ou%blc(2) = uv%ivisi+ivisi
       uv%ou%trc(2) = uv%ivisi+uv%in%trc(2)
       call gdf_write_data(uv%ou,din,error)
       if (error)  return
    enddo ! ivisi
    uv%in%blc(:) = 0
    uv%in%trc(:) = 0
    deallocate(din)
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ivisi = uv%ivisi+uv%in%gil%nvisi
    !
  end subroutine uvshort_merge_copy_uvin_fromdisk
  !
  subroutine uvshort_merge_append_uvps(rname,prog,uv,error)
    use phys_const
    use gbl_message
    use mapping_interfaces
    !-------------------------------------------------------------------
    ! Append the pseudo-visibility table to the output table. The
    ! pseudo-visibility table is already loaded in memory and the output
    ! table is already GDF-opened.
    ! -------------------------------------------------------------------
    character(len=*),       intent(in)    :: rname
    type(uvshort_prog_t),   intent(inout) :: prog
    type(uvshort_uvdata_t), intent(inout) :: uv
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ivisi,jvisi,icol,ibin,nbin,ier
    integer(kind=4) :: ifield,ips,ips_first,ips_last,jps
    real(kind=4) :: uvdist,uvmin,uvmax,alpha,beta,pseudo_density,ip_density
    real(kind=4), allocatable :: psdens(:),ipdens(:)
    character(len=message_length) :: mess
    !
    uv%oubeam%r2d(:,1:uv%ivisi) = uv%inbeam%r2d(:,1:uv%ivisi)
    uvmax = maxval(uv%oubeam%r2d(3,1:uv%ivisi))
    jvisi = uv%ivisi
    do ivisi=1,uv%ps%gil%nvisi
       jvisi = jvisi+1
       if (uv%ismos) then
          uv%oubeam%r2d(1:2,jvisi) = uv%ps%r2d(uv%ocol(1):uv%ocol(2),ivisi)
       else
          uv%oubeam%r2d(1:2,jvisi) = 0.0
       endif
       uvdist = sqrt(uv%ps%r2d(1,ivisi)**2+uv%ps%r2d(2,ivisi)**2)
       uv%oubeam%r2d(3,jvisi) = uvdist
       uv%oubeam%r2d(4,jvisi) = uv%ps%r2d(uv%wcol,ivisi)
    enddo ! ivisi
    uv%oubeam%gil%dim(2) = jvisi
    !
    uvmax = maxval(uv%oubeam%r2d(3,1:jvisi))
    uvmin = minval(uv%oubeam%r2d(3,1:uv%ivisi))
    nbin = ceiling(uvmax/prog%uvstep)
    if (nbin.lt.2) then
       call map_message(seve%e,rname,'Not enough UV bins to compute short-spacing weight density')
       error = .true.
       return
    endif
    allocate(psdens(nbin),ipdens(nbin),stat=ier)
    if (failed_allocate(rname,'Field weight densities',ier,error))  return
    if (.not.allocated(prog%sdwei%field)) then
       allocate(prog%sdwei%field(uv%nfield),prog%sdwei%factor(uv%nfield),stat=ier)
       if (failed_allocate(rname,'Field SD weight state',ier,error))  return
    endif
    if (size(prog%sdwei%field).ne.uv%nfield) then
       call map_message(seve%e,rname,'Inconsistent field SD weight state size')
       error = .true.
       return
    endif
    alpha = (nbin-0.5)/uvmax
    beta = 0.5
    !
    do ifield=1,uv%nfield
       psdens = 0.0
       ipdens = 0.0
       !
       ! Interferometric density for this field.  The field offsets stored
       ! in uv%inbeam are the same columns that were previously classified
       ! by mosaic_getfields in uvshort_check_uv; no new tolerance matcher is
       ! introduced here.
       do ivisi=1,uv%ivisi
          if (.not.uvshort_visibility_in_field(uv,ivisi,ifield)) cycle
          call uvshort_weight_density_bin(rname,uv%oubeam%r2d(3,ivisi),alpha,beta,nbin,ibin,error)
          if (error) return
          ipdens(ibin) = ipdens(ibin)+uv%oubeam%r2d(4,ivisi)
       enddo ! ivisi
       !
       ! Pseudo-visibility density for this field.  Pseudo-visibilities are
       ! produced field by field, with uv%nvisi_per_field entries per field.
       ips_first = (ifield-1)*uv%nvisi_per_field+1
       ips_last  = ifield*uv%nvisi_per_field
       do ips=ips_first,ips_last
          jps = uv%ivisi+ips
          call uvshort_weight_density_bin(rname,uv%oubeam%r2d(3,jps),alpha,beta,nbin,ibin,error)
          if (error) return
          psdens(ibin) = psdens(ibin)+uv%oubeam%r2d(4,jps)
       enddo ! ips
       !
       psdens(1) = psdens(1)/(pi*prog%uvstep**2)
       ipdens(2:nbin) = ipdens(2:nbin)/(3.0*pi*prog%uvstep**2*uv%ipdatfac**2)
       pseudo_density = psdens(1)
       ip_density = ipdens(2)
       !
       if (uvshort_invalid_density(pseudo_density)) then
          write(mess,'(a,i0,a)') 'Invalid pseudo-visibility weight density for field ',ifield,'.'
          call map_message(seve%e,rname,mess)
          error = .true.
          return
       endif
       if (uvshort_invalid_density(ip_density)) then
          if (uvmin.ge.2*prog%uvstep) then
             write(mess,'(a,i0,a)') 'No matching between single-dish and interferometric visibilities for field ',ifield,'.'
             call map_message(seve%e,rname,mess)
             call map_message(seve%e,rname,'Increase UV step to make matching possible')
             write (mess,'(a,f8.3,a,f8.3)') 'UV step should be in the range ',uvmin/2.,':',uvmin
             call map_message(seve%e,rname,mess)
          else
             write(mess,'(a,i0,a)') 'Invalid interferometric weight density for field ',ifield,'.'
             call map_message(seve%e,rname,mess)
          endif
          error = .true.
          return
       endif
       !
       prog%sdwei%field(ifield) = ip_density/pseudo_density
       if (prog%sdwei%user.eq.0.0) then
          prog%sdwei%factor(ifield) = prog%sdwei%field(ifield)
       else
          prog%sdwei%factor(ifield) = prog%sdwei%user*prog%sdwei%field(ifield)
       endif
       !
       write(mess,'(a,i0,a,i0,a,1pe12.4,a,1pe12.4)') &
            'Field ',ifield,' / ',uv%nfield,': weight density pseudo=',pseudo_density, &
            ' interferometer=',ip_density
       call map_message(seve%i,rname,mess)
       write(mess,'(a,1pe12.4,a,1pe12.4,a,1pe12.4)') &
            'Weight factors: applied=',prog%sdwei%factor(ifield), &
            ' user=',prog%sdwei%user,' auto=',prog%sdwei%field(ifield)
       call map_message(seve%i,rname,mess)
    enddo ! ifield
    !
    prog%sdwei%min = minval(prog%sdwei%field(:))
    prog%sdwei%med = uvshort_median_real4(prog%sdwei%field)
    prog%sdwei%max = maxval(prog%sdwei%field(:))
    uv%sdweifac = uvshort_median_real4(prog%sdwei%factor)
    write(mess,'(a,1pe12.4,a,1pe12.4,a,1pe12.4)') &
         'Automatic SD weight summary: min=',prog%sdwei%min, &
         ' median=',prog%sdwei%med,' max=',prog%sdwei%max
    call map_message(seve%i,rname,mess)
    !
    do ifield=1,uv%nfield
       ips_first = (ifield-1)*uv%nvisi_per_field+1
       ips_last  = ifield*uv%nvisi_per_field
       do ivisi=ips_first,ips_last
          do icol=uv%ps%gil%fcol+2,uv%ps%gil%lcol,3
             uv%ps%r2d(icol,ivisi) = uv%ps%r2d(icol,ivisi)*prog%sdwei%factor(ifield)
          enddo ! icol
       enddo ! ivisi
    enddo ! ifield
    !
    ! Input table is entirely in memory => copy all at once
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ou%blc(2) = uv%ivisi+1
    uv%ou%trc(2) = uv%ivisi+uv%ps%gil%nvisi
    call gdf_write_data(uv%ou,uv%ps%r2d,error)
    if (error)  return
    uv%ou%blc(:) = 0
    uv%ou%trc(:) = 0
    uv%ivisi = uv%ivisi+uv%ps%gil%nvisi
    !
  end subroutine uvshort_merge_append_uvps
  !
  logical function uvshort_visibility_in_field(uv,ivisi,ifield)
    !------------------------------------------------------------------------
    ! Tell whether a visibility belongs to a field, using the field columns
    ! already classified by mosaic_getfields.  This deliberately uses exact
    ! stored field values and introduces no new tolerance-based matcher.
    !------------------------------------------------------------------------
    type(uvshort_uvdata_t), intent(in) :: uv
    integer(kind=4),        intent(in) :: ivisi,ifield
    !
    if (.not.uv%ismos) then
       uvshort_visibility_in_field = .true.
    else
       uvshort_visibility_in_field = &
            uv%inbeam%r2d(1,ivisi).eq.uv%raoff(ifield) .and. &
            uv%inbeam%r2d(2,ivisi).eq.uv%deoff(ifield)
    endif
    !
  end function uvshort_visibility_in_field
  !
  subroutine uvshort_weight_density_bin(rname,uvdist,alpha,beta,nbin,ibin,error)
    use gbl_message
    !------------------------------------------------------------------------
    ! Existing bin-numbering logic factored out so the same computation can
    ! be applied independently to pseudo and interferometric densities.
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    real(kind=4),     intent(in)    :: uvdist,alpha,beta
    integer(kind=4),  intent(in)    :: nbin
    integer(kind=4),  intent(out)   :: ibin
    logical,          intent(inout) :: error
    !
    ibin = nint(uvdist*alpha+beta)
    if (ibin.eq.0) then
       ibin = 1
    else if ((ibin.lt.0).or.(ibin.gt.nbin)) then
       call map_message(seve%e,rname,'Problem when computing weight density')
       error = .true.
       return
    endif
    !
  end subroutine uvshort_weight_density_bin
  !
  logical function uvshort_invalid_density(value)
    !------------------------------------------------------------------------
    ! Invalid means not finite enough for safe division in this code path.
    ! The value.ne.value test catches NaNs without introducing dependencies.
    !------------------------------------------------------------------------
    real(kind=4), intent(in) :: value
    !
    uvshort_invalid_density = (value.ne.value).or.(value.le.0.0)
    !
  end function uvshort_invalid_density
  !
  real(kind=4) function uvshort_median_real4(values)
    !------------------------------------------------------------------------
    ! Small local median helper for the SD-weight summary only.
    !------------------------------------------------------------------------
    real(kind=4), intent(in) :: values(:)
    !
    real(kind=4), allocatable :: work(:)
    real(kind=4) :: tmp
    integer(kind=4) :: i,j,n,ier
    !
    n = size(values)
    if (n.le.0) then
       uvshort_median_real4 = 1.0
       return
    endif
    allocate(work(n),stat=ier)
    if (ier.ne.0) then
       uvshort_median_real4 = 1.0
       return
    endif
    work(:) = values(:)
    do i=2,n
       tmp = work(i)
       j = i-1
       do while (j.ge.1.and.work(j).gt.tmp)
          work(j+1) = work(j)
          j = j-1
       enddo
       work(j+1) = tmp
    enddo
    if (mod(n,2).eq.1) then
       uvshort_median_real4 = work((n+1)/2)
    else
       uvshort_median_real4 = 0.5*(work(n/2)+work(n/2+1))
    endif
    deallocate(work)
    !
  end function uvshort_median_real4
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine uvshort_uvzero(rname,user,uvin,error)
    character(*),          intent(in)    :: rname
    type(uvshort_user_t),  intent(in)    :: user
    type(gildas),          intent(inout) :: uvin
    logical,               intent(inout) :: error
    !------------------------------------------------------------------------
    ! Does nothing anymore for the moment...
    !------------------------------------------------------------------------
!!$    type(projection_t) :: uv_proj,lm_proj  
!!$    real(8) :: alpha,delta,dx,dy
!!$    integer :: ix,iy,is,icol,ocol,jf
!!$    integer :: gdate,last,ixcol,iycol
!!$    real, allocatable :: zero_uvdata(:,:)
!!$    real, allocatable :: sddat%in%r2d(:,:)
!!$    real, allocatable :: spectrum(:)
!!$    real :: ws,dist,dmin,total_weight
!!$    !
!!$    ! We already have the reference UV table header here
!!$    ! Allocate some work space
!!$    !
!!$    call gwcs_projec(uvin%gil%a0,uvin%gil%d0,-uvin%gil%pang,uvin%gil%ptyp,uv_proj,error)
!!$    call sic_gagdate(gdate)
!!$    ! ...
!!$    last = uvin%gil%fcol + uvin%gil%natom * uvin%gil%nchan - 1
!!$    ixcol = last+1
!!$    iycol = last+2
!!$    !
!!$    if (sddat%islmv) then
!!$       ! Read LMV file
!!$       ! Input file is a lmv cube
!!$       call uvshort_sd_read_lmv(rname,user%sdin_name,lmv,sddat%ou%r3d,buf%imwei,error)
!!$       !
!!$       ! We can get the weight from the Noise in the map
!!$       weight = user%sdfac*max(sddat%ou%gil%rms,sddat%ou%gil%noise)
!!$       if (weight.ne.0.0) then
!!$          weight = 1d-6/weight**2
!!$          ! weight = user%sdwei * weight ! Is that useful ?...
!!$       else
!!$          call map_message(seve%w,rname,'No weight in LMV file')
!!$          weight = 1.0
!!$       endif
!!$       !
!!$       nc=sddat%ou%gil%dim(3)
!!$       call uvshort_consistency(rname,nc,uvin,lmv,user%postol,error)
!!$       if (error) return
!!$       !
!!$       allocate(zero_uvdata(uvin%gil%dim(1),nf),spectrum(nc),stat=ier)
!!$       if (ier.ne.0) then
!!$          call map_message(seve%e,rname,'Zero spacing Memory allocation failure')
!!$          error = .true.
!!$          return
!!$       endif
!!$       !
!!$       ! Extract appropriate directions from it: loop on fields
!!$       call gwcs_projec(sddat%ou%gil%a0,sddat%ou%gil%d0,-sddat%ou%gil%pang,sddat%ou%gil%ptyp,lm_proj,error)
!!$       do if=1,nf
!!$          call rel_to_abs(uv_proj,dble(raoff(if)),dble(deoff(if)),alpha,delta,1)
!!$          call abs_to_rel(lm_proj,alpha,delta,dx,dy,1)
!!$          ix = nint((dx-sddat%ou%gil%val(1))/sddat%ou%gil%inc(1)+sddat%ou%gil%ref(1))
!!$          iy = nint((dy-sddat%ou%gil%val(2))/sddat%ou%gil%inc(2)+sddat%ou%gil%ref(2))
!!$          if (ix.lt.1 .or. ix.gt.nx .or. iy.lt.1 .or. iy.gt.ny) then
!!$             write(mess,*) 'Field ',if,' is out of map ',ix,iy
!!$             call map_message(seve%e,rname,mess)
!!$             error = .true.
!!$             return
!!$          endif
!!$          !
!!$          ! Put it in place...
!!$          spectrum(:) = user%sdfac * sddat%ou%r3d(ix,iy,:) 
!!$          call spectrum_to_zero(nc,spectrum,zero_uvdata(:,if),gdate,weight)
!!$          zero_uvdata(ixcol,if) = raoff(if)
!!$          zero_uvdata(iycol,if) = deoff(if)        
!!$       enddo
!!$       !
!!$       total_weight = nf*weight
!!$    else
!!$       !
!!$       nc = uvin%gil%nchan
!!$       !
!!$       call uvshort_read_class_table(rname,user%sdin_name,sddat%in,sddat%in%r2d,error)
!!$       if (error) return
!!$       !      
!!$       ! Set valid defaults for Class Tables
!!$       if (sddat%xcol.eq.0) sddat%xcol = 1
!!$       if (sddat%ycol.eq.0) sddat%ycol = 2
!!$       if (sddat%wcol.eq.0) sddat%wcol = 3
!!$       if (sddat%mcol(1).eq.0) sddat%mcol(1) = 4
!!$       icol = sddat%mcol(1)
!!$       if (sddat%mcol(2).ne.0) then
!!$          ocol = sddat%mcol(2)
!!$          if (ocol-icol+1.ne.nc) then
!!$             print *,'MCOL ',sddat%mcol,' ICOL OCOL ',icol,ocol,' NC ',nc
!!$             call map_message(seve%e,rname,'Number of channels mismatch')
!!$             error = .true.
!!$             return
!!$          endif
!!$       else
!!$          ocol = icol+nc-1
!!$          if (ocol.gt.sddat%in%gil%dim(1)) then
!!$             print *,'MCOL ',sddat%mcol,' ICOL OCOL ',icol,ocol,' Sddat%In ',sddat%in%gil%dim(1)
!!$             call map_message(seve%e,rname,'Number of channels mismatch')
!!$             error = .true.
!!$             return
!!$          endif
!!$       endif
!!$       !
!!$       allocate(zero_uvdata(uvin%gil%dim(1),nf),spectrum(nc),stat=ier)
!!$       if (ier.ne.0) then
!!$          call map_message(seve%e,rname,'Zero spacing Memory allocation failure')
!!$          error = .true.
!!$          return
!!$       endif!
!!$       !
!!$       ! Find all spectra towards the appropriate directions,
!!$       ! with the specified tolerance
!!$       total_weight =0.0
!!$       call gwcs_projec(sddat%in%gil%a0,sddat%in%gil%d0,-sddat%in%gil%pang,sddat%in%gil%ptyp,lm_proj,error)
!!$       do if=1,nf
!!$          spectrum(:) = 0.0
!!$          weight = 0.0
!!$          jf = 0
!!$          dmin = 1e36
!!$          !
!!$          call rel_to_abs(uv_proj,dble(raoff(if)),dble(deoff(if)),alpha,delta,1)
!!$          call abs_to_rel(lm_proj,alpha,delta,dx,dy,1)
!!$          !
!!$          do is=1,sddat%in%gil%nvisi
!!$             dist = (sddat%in%r2d(sddat%xcol,is)-dx)**2+(sddat%in%r2d(sddat%ycol,is)-dy)**2
!!$             if (dist .le. user%postol**2) then
!!$                jf = jf+1
!!$                !         print *,'Field ',if,' X',(sddat%in%r2d(sddat%xcol,is)-dx)*sec_per_rad,  
!!$                !         '  Y',(sddat%in%r2d(ycol,is)-dy)*sec_per_rad,     &
!!$                !         ' user%Postol ',user%postol*sec_per_rad
!!$                ws = sddat%in%r2d(sddat%wcol,is)
!!$                weight = weight + ws
!!$                spectrum(:) = spectrum(:) + ws * sddat%in%r2d(icol:ocol,is)
!!$                dmin = min(dmin,dist)
!!$             endif
!!$          enddo
!!$          dmin = sqrt(dmin)*sec_per_rad
!!$          if (weight.eq.0) then
!!$             write(mess,'(A,I0,A,1PG10.2)') 'Field ',if,' has no Zero spacing' &
!!$                  //' Min distance ',dmin
!!$             call map_message(seve%e,rname,mess)
!!$             error = .true.
!!$          else
!!$             write(mess,'(I0,A,I0,A,1PG10.2)') jf,' spectra added to Field ',if &
!!$                  ,'; Min distance ',dmin
!!$             call map_message(seve%i,rname,mess)
!!$             total_weight = total_weight + weight
!!$          endif
!!$          !
!!$          ! Put it in place...
!!$          spectrum = spectrum/weight
!!$          call spectrum_to_zero(nc,spectrum,zero_uvdata(:,if),gdate,weight)
!!$          zero_uvdata(ixcol,if) = raoff(if)
!!$          zero_uvdata(iycol,if) = deoff(if)        
!!$       enddo
!!$    endif
!!$    if (error) return
!!$    !
!!$    ! Now concatenate the Zero spacing data to the Mosaic UV Table
!!$    ! or Create a Zero spacing UV table
!!$    if (do%detect.lt.0) then
!!$       ! short_mode < 0
!!$       !   Here we create a single UV table containing only
!!$       !   the short spacings  for all fields
!!$       name = trim(user%uvin_name)//"-short"
!!$       call sic_parsef(name,uvin%file,' ','.uvt')
!!$       call map_message(seve%i,rname,'Creating UV table '//trim(uvin%file))
!!$       uvin%gil%nvisi = nf
!!$       uvin%gil%nvisi = nf
!!$       call gdf_create_image(uvin,error)
!!$       uvin%blc = 0
!!$       uvin%trc = 0
!!$    else
!!$       ! short_mode > 0
!!$       !   Here we create a UV table containing the short spacings
!!$       !   for all fields appended to the previous UV table
!!$       call gildas_null(uvdat%in)
!!$       name = trim(user%uvin_name)
!!$       call sic_parsef(name,uvdat%in%file,' ','.uvt')
!!$       call gdf_read_header(uvdat%in,error)
!!$       if (error) return
!!$       !
!!$       name = trim(user%uvin_name)//"-merged"
!!$       call sic_parsef(name,uvin%file,' ','.uvt')
!!$       call map_message(seve%i,rname,'UV Table to be appended is '//trim(uvin%file))
!!$       wcol = (nc+2)/3
!!$       ! Copy UV table and get Total weight up to UMAX
!!$       umax = 2.0*user%sddiam  ! Here user%sddiam = user%ipdiam
!!$       call uvshort_copy_uvtable(rname,uvdat%in,uvt,umax,wcol,weight,error)
!!$       if (error) return
!!$       !
!!$       ! Scaling factor for Weights
!!$       call map_message(seve%i,rname,'Appending UV table '//trim(uvin%file))
!!$       string = 'appended'
!!$       uvin%blc(2) = uvin%gil%nvisi+1
!!$       mvis = uvin%gil%nvisi+nf      ! Add NF visibilities
!!$       uvin%trc(2) = mvis
!!$       call gdf_extend_image(uvt,mvis,error)
!!$       uvin%gil%nvisi = uvin%gil%nvisi
!!$       !
!!$       ! Re-normalize the Weight to have a nice beam,including
!!$       ! User-specified Weight factor USER%SDWEI
!!$       scale_weight = weight*user%sdwei/4.0/total_weight
!!$       do if=1,nf
!!$          do is = 10,7+3*nc,3
!!$             zero_uvdata(is,if) = zero_uvdata(is,if) * scale_weight
!!$          enddo
!!$       enddo
!!$    endif
!!$    !
!!$    ! Write the Zero spacings in place now
!!$    call gdf_write_data(uvt,zero_uvdata,error)
!!$    if (error) then
!!$       call map_message(seve%e,rname,'Error writing UV data ')
!!$       return
!!$    endif
!!$    write(mess,'(I0,A)') nf,' Zero spacings added'
!!$    call map_message(seve%i,rname,mess)
!!$    !
!!$    ! Finish the job. Update the number of visibilities
!!$    call gdf_update_header(uvt,error)
!!$    call gdf_close_image(uvt,error)
  end subroutine uvshort_uvzero
  !
  subroutine spectrum_to_zero(nc,spectrum,uvdata,date,weight)
    !
    ! Convert a spectrum into a Zero spacing
    integer,intent(in) :: nc
    real,intent(in) :: spectrum(nc) 
    real,intent(out) :: uvdata(:)
    integer,intent(in) :: date
    real,intent(in) :: weight
    !
    integer :: ic
    !
    uvdata = 0
    uvdata(4) = date
    uvdata(6:7) = -1.0      ! Conventional antenna number
    do ic=1,nc
       uvdata(5+3*ic) = spectrum(ic)
       uvdata(7+3*ic) = weight
    enddo
  end subroutine spectrum_to_zero
  !
end program uvshort_program
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtindex_sort_types
  use gmath_dicho_types
  use gmath_quicksort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting an optimized index
  type, extends(gi8_quicksort_t) :: mrtindex_setsort_t
    type(mrtindex_optimize_t), pointer :: optx
  contains
    procedure, public :: compare => mrtindex_compare_entries
  end type mrtindex_setsort_t
  !
  ! Type for searching in an optimized index by observation number
  type, extends(gi8_dicho_t) :: mrtindex_num_dicho_t
    type(mrtindex_optimize_t), pointer :: optx
    integer(kind=8) :: searched_num = 0
  contains
    procedure, public :: compare       => mrtindex_compare_nums
    procedure, public :: compare_value => mrtindex_compare_entry_to_num
  end type mrtindex_num_dicho_t
  !
contains
  !
  function mrtindex_compare_entries(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by DOBS then by UT. Then by SCAN for safety, then by
    ! BACKEND for cosmetics, then by VERSION.
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_entries
    class(mrtindex_setsort_t), intent(in) :: self
    integer(kind=8),           intent(in) :: m,l
    if (self%optx%dobs(m).ne.self%optx%dobs(l)) then
      if (self%optx%dobs(m).gt.self%optx%dobs(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%ut(m).ne.self%optx%ut(l)) then
      ! If one is NaN, skip this test
      if (self%optx%ut(m).eq.self%optx%ut(m) .and.  &
          self%optx%ut(l).eq.self%optx%ut(l)) then
        if (self%optx%ut(m).gt.self%optx%ut(l)) then
          mrtindex_compare_entries = 1
        else
          mrtindex_compare_entries = -1
        endif
        return
      endif
    endif
    if (self%optx%scan(m).ne.self%optx%scan(l)) then
      if (self%optx%scan(m).gt.self%optx%scan(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%backend(m).ne.self%optx%backend(l)) then
      if (self%optx%backend(m).gt.self%optx%backend(l)) then
        mrtindex_compare_entries = 1
      else
        mrtindex_compare_entries = -1
      endif
      return
    endif
    if (self%optx%version(m).eq.self%optx%version(l)) then
      mrtindex_compare_entries = 0
    elseif (self%optx%version(m).gt.self%optx%version(l)) then
      mrtindex_compare_entries = 1
    else
      mrtindex_compare_entries = -1
    endif
  end function mrtindex_compare_entries
  !
  function mrtindex_compare_nums(self,m,l)
    !-------------------------------------------------------------------
    ! Compare the observation numbers of the m-th and l-th entries
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_nums
    class(mrtindex_num_dicho_t), intent(in) :: self
    integer(kind=8),             intent(in) :: m,l
    if (self%optx%num(m).eq.self%optx%num(l)) then
      mrtindex_compare_nums = 0
    elseif (self%optx%num(m).gt.self%optx%num(l)) then
      mrtindex_compare_nums = 1
    else
      mrtindex_compare_nums = -1
    endif
  end function mrtindex_compare_nums
  !
  function mrtindex_compare_entry_to_num(self,m)
    !-------------------------------------------------------------------
    ! Compare the m-th entry number to the searched number
    !-------------------------------------------------------------------
    integer(kind=4) :: mrtindex_compare_entry_to_num
    class(mrtindex_num_dicho_t), intent(in) :: self
    integer(kind=8),             intent(in) :: m
    if (self%optx%num(m).eq.self%searched_num) then
      mrtindex_compare_entry_to_num = 0
    elseif (self%optx%num(m).gt.self%searched_num) then
      mrtindex_compare_entry_to_num = 1
    else
      mrtindex_compare_entry_to_num = -1
    endif
  end function mrtindex_compare_entry_to_num
end module mrtindex_sort_types
!
subroutine mrtindex_code2sic(error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_parameters
  use mrtindex_interfaces, except_this=>mrtindex_code2sic
  !---------------------------------------------------------------------
  ! @ public
  ! Create the MRT% Sic structure mapping the index codes.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='INDEX>CODE2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mrt')) then
     call sic_defstructure('mrt%',.true.,error)
     if (error) return
  endif
  !
  ! *** JP why UNKNOWN is not a kind of obstypes as any other? This calls for troubles...
  call sic_def_charn('mrt%backend',   backends_mrtcal,   1,nbackends_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%obstype',   obstypes_mrtcal,   1,nobstypes_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%switchmode',switchmodes_mrtcal,1,nswitchmodes+1,    .false.,error)
  call sic_def_charn('mrt%filstatus', completenesses,    1,ncompleteness,     .false.,error)
  call sic_def_charn('mrt%calstatus', calstatus,         1,ncalstatus,        .false.,error)
  call sic_def_charn('mrt%solstatus', solstatus,         1,nsolstatus,        .false.,error)
  ! If there is an error, the user/developer wants to know... => no resetting
  !
end subroutine mrtindex_code2sic
!
subroutine mrtindex_cx2sic(cx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_cx2sic
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create the MDX% Sic structure mapping the CX arrays (always available)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=index_length) :: dim(4)
  character(len=*), parameter :: rname='INDEX>CX2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mdx')) then
     call sic_defstructure('mdx%',.true.,error)
     if (error) return
  endif
  !
  ! Removed previously defined structure variable
  call sic_delvariable('mdx%curr',        .false.,error)
  call sic_delvariable('mdx%mnum',        .false.,error)
  call sic_delvariable('mdx%fnum',        .false.,error)
  call sic_delvariable('mdx%num',         .false.,error)
  call sic_delvariable('mdx%ver',         .false.,error)
  call sic_delvariable('mdx%telescope',   .false.,error)
  call sic_delvariable('mdx%projid',      .false.,error)
  call sic_delvariable('mdx%source',      .false.,error)
  call sic_delvariable('mdx%dobs',        .false.,error)
  call sic_delvariable('mdx%ut',          .false.,error)
  call sic_delvariable('mdx%lst',         .false.,error)
  call sic_delvariable('mdx%scan',        .false.,error)
  call sic_delvariable('mdx%backend',     .false.,error)
  call sic_delvariable('mdx%obstype',     .false.,error)
  call sic_delvariable('mdx%switchmode',  .false.,error)
  call sic_delvariable('mdx%polarimetry', .false.,error)
  call sic_delvariable('mdx%filstatus',   .false.,error)
  call sic_delvariable('mdx%calstatus',   .false.,error)
  call sic_delvariable('mdx%solstatus',   .false.,error)
  call sic_delvariable('mdx%filename',    .false.,error)
  error = .false.
  !
  if (cx%next.gt.1) then
     dim(1) = cx%next-1
     call sic_def_long ('mdx%mnum',        cx%mnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%fnum',        cx%fnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%num',         cx%num,         1,dim,.false.,error)
     call sic_def_inte ('mdx%ver',         cx%version,     1,dim,.false.,error)
     call sic_def_inte ('mdx%telescope',   cx%telescope,   1,dim,.false.,error)
     call sic_def_charn('mdx%projid',      cx%projid,      1,dim,.false.,error)
     call sic_def_charn('mdx%source',      cx%source,      1,dim,.false.,error)
     call sic_def_inte ('mdx%dobs',        cx%dobs,        1,dim,.false.,error)
     call sic_def_dble ('mdx%ut',          cx%ut,          1,dim,.false.,error)
     call sic_def_dble ('mdx%lst',         cx%lst,         1,dim,.false.,error)
     call sic_def_inte ('mdx%scan',        cx%scan,        1,dim,.false.,error)
     call sic_def_inte ('mdx%backend',     cx%backend,     1,dim,.false.,error)
     call sic_def_inte ('mdx%obstype',     cx%obstype,     1,dim,.false.,error)
     call sic_def_inte ('mdx%switchmode',  cx%switchmode,  1,dim,.false.,error)
     call sic_def_inte ('mdx%polarimetry', cx%polstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%filstatus',   cx%filstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%calstatus',   cx%calstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%solstatus',   cx%solstatus,   1,dim,.false.,error)
     call sic_def_charn('mdx%filename',    cx%filename,    1,dim,.false.,error)
     error = .false.
  endif
  !
end subroutine mrtindex_cx2sic
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtindex_index_to_optimize_inplace(indx,fileid,fnum,mnum,num,  &
  sort,islast,optx,ioptx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Write the indx at the given position, overwriting the previous
  ! element, if any
  !---------------------------------------------------------------------
  type(mrtindex_indx_t),        intent(in)    :: indx    ! The entry index on disk
  integer(kind=4),            intent(in)    :: fileid  ! Index file associated to the entry
  integer(kind=entry_length), intent(in)    :: fnum    ! Position in associated file
  integer(kind=entry_length), intent(in)    :: mnum    ! Position in memory (IX)
  integer(kind=entry_length), intent(in)    :: num     ! "Observation" number
  integer(kind=entry_length), intent(in)    :: sort    ! Position in the sorted index
  logical,                    intent(in)    :: islast  ! "is-last-version" status
  type(mrtindex_optimize_t),  intent(inout) :: optx    !
  integer(kind=entry_length), intent(in)    :: ioptx   ! Position in output optx
  logical,                    intent(inout) :: error   !
  !
  ! Memory only elements
  optx%idir(ioptx)         = fileid
  optx%fnum(ioptx)         = fnum
  optx%mnum(ioptx)         = mnum
  optx%num(ioptx)          = num
  optx%sort(ioptx)         = sort
  optx%islast(ioptx)       = islast
  ! Disk elements
  optx%bloc(ioptx)         = indx%bloc
  optx%word(ioptx)         = indx%word
  optx%version(ioptx)      = indx%version
  optx%telescope(ioptx)    = indx%telescope
  optx%source(ioptx)       = indx%source
  optx%projid(ioptx)       = indx%projid
  optx%ut(ioptx)           = indx%ut
  optx%lst(ioptx)          = indx%lst
  optx%az(ioptx)           = indx%az
  optx%el(ioptx)           = indx%el
  optx%lon(ioptx)          = indx%lon
  optx%lat(ioptx)          = indx%lat
  optx%system(ioptx)       = indx%system
  optx%equinox(ioptx)      = indx%equinox
  optx%frontend(:,ioptx)   = indx%frontend(:)
  optx%dobs(ioptx)         = indx%dobs
  optx%scan(ioptx)         = indx%scan
  optx%backend(ioptx)      = indx%backend
  optx%obstype(ioptx)      = indx%obstype
  optx%switchmode(ioptx)   = indx%switchmode
  optx%polstatus(ioptx)    = indx%polstatus
  optx%filstatus(ioptx)    = indx%filstatus
  optx%calstatus(ioptx)    = indx%calstatus
  optx%solstatus(ioptx)    = indx%solstatus
  optx%filename(ioptx)     = indx%filename
  optx%itime(ioptx)        = indx%itime
  !
end subroutine mrtindex_index_to_optimize_inplace
!
subroutine mrtindex_index_to_key(indx,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(in)    :: indx   !
  type(mrtindex_key_t),  intent(inout) :: key    !
  logical,             intent(inout) :: error  !
  !
  key%version      = indx%version
  key%telescope    = indx%telescope
  key%projid       = indx%projid
  key%source       = indx%source
  key%dobs         = indx%dobs
  key%ut           = indx%ut
  key%lst          = indx%lst
  key%az           = indx%az
  key%el           = indx%el
  key%lon          = indx%lon
  key%lat          = indx%lat
  key%system       = indx%system
  key%equinox      = indx%equinox
  key%frontend(:)  = indx%frontend(:)
  key%scan         = indx%scan
  key%backend      = indx%backend
  key%obstype      = indx%obstype
  key%switchmode   = indx%switchmode
  key%polstatus    = indx%polstatus
  key%filstatus    = indx%filstatus
  key%calstatus    = indx%calstatus
  key%solstatus    = indx%solstatus
  key%filename     = indx%filename
  !
end subroutine mrtindex_index_to_key
!
subroutine mrtindex_key_to_index(key,indx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_key_t),  intent(in)    :: key    !
  type(mrtindex_indx_t), intent(inout) :: indx   !
  logical,             intent(inout) :: error  !
  !
  ! indx%bloc = not relevant in key
  ! indx%word = not relevant in key
  indx%version     = key%version
  indx%telescope   = key%telescope
  indx%projid      = key%projid
  indx%source      = key%source
  indx%dobs        = key%dobs
  indx%ut          = key%ut
  indx%lst         = key%lst
  indx%az          = key%az
  indx%el          = key%el
  indx%lon         = key%lon
  indx%lat         = key%lat
  indx%system      = key%system
  indx%equinox     = key%equinox
  indx%frontend(:) = key%frontend(:)
  indx%scan        = key%scan
  indx%backend     = key%backend
  indx%obstype     = key%obstype
  indx%switchmode  = key%switchmode
  indx%polstatus   = key%polstatus
  indx%filstatus   = key%filstatus
  indx%calstatus   = key%calstatus
  indx%solstatus   = key%solstatus
  indx%filename    = key%filename
  ! indx%itime = not relevant in key
  !
end subroutine mrtindex_key_to_index
!
subroutine mrtindex_optimize_to_key(optx,ient,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_key_t),         intent(out)   :: key    !
  logical,                    intent(inout) :: error  !
  !
  key%version      = optx%version(ient)
  key%telescope    = optx%telescope(ient)
  key%projid       = optx%projid(ient)
  key%source       = optx%source(ient)
  key%dobs         = optx%dobs(ient)
  key%ut           = optx%ut(ient)
  key%lst          = optx%lst(ient)
  key%az           = optx%az(ient)
  key%el           = optx%el(ient)
  key%lon          = optx%lon(ient)
  key%lat          = optx%lat(ient)
  key%system       = optx%system(ient)
  key%equinox      = optx%equinox(ient)
  key%frontend(:)  = optx%frontend(:,ient)
  key%scan         = optx%scan(ient)
  key%backend      = optx%backend(ient)
  key%obstype      = optx%obstype(ient)
  key%switchmode   = optx%switchmode(ient)
  key%polstatus    = optx%polstatus(ient)
  key%filstatus    = optx%filstatus(ient)
  key%calstatus    = optx%calstatus(ient)
  key%solstatus    = optx%solstatus(ient)
  key%filename     = optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_key
!
subroutine mrtindex_optimize_to_entry(optx,ient,entry,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  "GET" the full entry (header+sections), read from disk
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_entry_t),       intent(inout) :: entry  !
  logical,                    intent(inout) :: error  !
  ! Local
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: jent
  !
  ! Open file if not already opened:
  fileid = optx%idir(ient)
  call mrtindex_file_old(fileid,.false.,error)
  if (error)  return
  !
  ! Read the whole entry from disk
  jent = optx%fnum(ient)
  call mrtindex_entry_read(ix_files(fileid),jent,entry,error)
  if (error)  return
  !
end subroutine mrtindex_optimize_to_entry
!
subroutine mrtindex_optimize_to_optimize_1d(in,out,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_1d
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: in
  type(mrtindex_optimize_t), intent(inout) :: out
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: ient,nent
  character(len=*), parameter :: rname='OPTIMIZE>TO>OPTIMIZE>1D'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Reallocate without keeping the data
  nent = in%next-1
  call reallocate_mrtoptimize(out,nent,.false.,error)
  if (error)  return
  ! Copy
  out%next = 1
  do ient=1,nent
    call mrtindex_optimize_to_optimize(in,ient,out,error)
    if (error)  return
  enddo ! ient
  !
end subroutine mrtindex_optimize_to_optimize_1d
!
subroutine mrtindex_optimize_to_optimize_next(in,i,out,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_next
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the next available
  ! position in output optimize. It does not check if the optimize
  ! index is correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  logical,                    intent(inout) :: error
  !
  call mrtindex_optimize_to_optimize_inplace(in,i,out,out%next,error)
  if (error)  return
  out%next = out%next+1
  !
end subroutine mrtindex_optimize_to_optimize_next
!
subroutine mrtindex_optimize_to_optimize_inplace(in,i,out,j,error)
  use classic_api
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the j-th position
  ! in output optimize. It does not check if the optimize index is
  ! correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  integer(kind=entry_length), intent(in)    :: j
  logical,                    intent(inout) :: error
  !
  out%bloc(j)         = in%bloc(i)
  out%word(j)         = in%word(i)
  out%version(j)      = in%version(i)
  out%telescope(j)    = in%telescope(i)
  out%projid(j)       = in%projid(i)
  out%source(j)       = in%source(i)
  out%dobs(j)         = in%dobs(i)
  out%ut(j)           = in%ut(i)
  out%lst(j)          = in%lst(i)
  out%az(j)           = in%az(i)
  out%el(j)           = in%el(i)
  out%lon(j)          = in%lon(i)
  out%lat(j)          = in%lat(i)
  out%system(j)       = in%system(i)
  out%equinox(j)      = in%equinox(i)
  out%frontend(:,j)   = in%frontend(:,i)
  out%scan(j)         = in%scan(i)
  out%backend(j)      = in%backend(i)
  out%obstype(j)      = in%obstype(i)
  out%switchmode(j)   = in%switchmode(i)
  out%polstatus(j)    = in%polstatus(i)
  out%filstatus(j)    = in%filstatus(i)
  out%calstatus(j)    = in%calstatus(i)
  out%solstatus(j)    = in%solstatus(i)
  out%filename(j)     = in%filename(i)
  out%itime(j)        = in%itime(i)
  out%num(j)          = in%num(i)
  out%mnum(j)         = in%mnum(i)
  out%fnum(j)         = in%fnum(i)
  out%sort(j)         = j  ! Yes!
  out%idir(j)         = in%idir(i)
  out%islast(j)       = in%islast(i)
  !
end subroutine mrtindex_optimize_to_optimize_inplace
!
subroutine mrtindex_optimize_to_filename(optx,ient,filename,error)
  use mrtindex_types
  use mrtindex_vars
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_filename
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx
  integer(kind=entry_length), intent(in)    :: ient
  character(len=*),           intent(out)   :: filename
  logical,                    intent(inout) :: error
  !
  filename = trim(ix_dirs(optx%idir(ient)))//'/'//optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_filename
!
subroutine mrtindex_optimize_setsort(in,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_setsort
  use mrtindex_sort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the sorting list of the input index (in%sort)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), target, intent(inout) :: in     !
  logical,                           intent(inout) :: error  !
  ! Local
  integer(kind=entry_length) :: nelem
  type(mrtindex_setsort_t) :: setsort
  !
  ! Remark: in%sort() must contain the unsorted element before
  ! entering setsort%sort()
  nelem = in%next-1
  setsort%optx => in
  call setsort%sort(in%sort,nelem,error)
  if (error)  return
end subroutine mrtindex_optimize_setsort
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_zindx(indx,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_indx_t' structure. Default can not be in
  ! in the structure definition because of the 'sequence' statement
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(out)   :: indx
  logical,             intent(inout) :: error
  !
  indx%bloc = 0
  indx%word = 0
  indx%version = 0
  indx%telescope = telescope_unknown
  indx%source = ''
  indx%projid = ''
  call gag_notanum(indx%ut)
  call gag_notanum(indx%lst)
  call gag_notanum(indx%az)
  call gag_notanum(indx%el)
  call gag_notanum(indx%lon)
  call gag_notanum(indx%lat)
  indx%system = type_un
  indx%equinox = equinox_null
  indx%frontend(:) = ''
  indx%dobs = -32768
  indx%scan = 0
  indx%backend = backend_unknown
  indx%obstype = obstype_unknown
  indx%switchmode = switchmode_unk
  indx%polstatus = 0
  indx%filstatus = complete_unreadable
  indx%calstatus = calstatus_none
  indx%solstatus = solstatus_none
  indx%filename = ''
  indx%itime = 0
  !
end subroutine mrtindex_entry_zindx
!
subroutine mrtindex_entry_zkey(key,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_key_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_key_t), intent(out)   :: key
  logical,            intent(inout) :: error
  !
  key%version = 0
  key%telescope = telescope_unknown
  key%projid = ''
  key%source = ''
  key%dobs = -32768
  call gag_notanum(key%ut)
  call gag_notanum(key%lst)
  call gag_notanum(key%az)
  call gag_notanum(key%el)
  call gag_notanum(key%lon)
  call gag_notanum(key%lat)
  key%system = type_un
  key%equinox = equinox_null
  key%frontend(:) = ''
  key%scan = 0
  key%backend = backend_unknown
  key%obstype = obstype_unknown
  key%switchmode = switchmode_unk
  key%polstatus = 0
  key%filstatus = complete_unreadable
  key%calstatus = calstatus_none
  key%solstatus = solstatus_none
  key%filename = ''
  !
end subroutine mrtindex_entry_zkey
!
subroutine mrtindex_entry_zprim(prim,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_primary_t' structure
  !---------------------------------------------------------------------
  type(sec_primary_t), intent(out)   :: prim
  logical,             intent(inout) :: error
  !
  prim%imbfvers = 0.0
! prim%lam      = 0.d0
! prim%bet      = 0.d0
! prim%timegoal = 0.d0
! prim%nsubgoal = 0
! prim%nsub     = 0
  !
end subroutine mrtindex_entry_zprim
!
subroutine mrtindex_entry_zcalib(calib,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_calib_t' structure
  !---------------------------------------------------------------------
  type(sec_calib_t), intent(inout) :: calib
  logical,           intent(inout) :: error
  !
  calib%nfreq = 0
  calib%nset  = 0
  calib%npix  = 0
  if (allocated(calib%frontend))  deallocate(calib%frontend)
  if (allocated(calib%freq))      deallocate(calib%freq)
  if (allocated(calib%atsys))     deallocate(calib%atsys)
  if (allocated(calib%ztau))      deallocate(calib%ztau)
  !
end subroutine mrtindex_entry_zcalib
!
subroutine mrtindex_entry_zscience(sci,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'sec_science_t' structure
  !---------------------------------------------------------------------
  type(sec_science_t), intent(out)   :: sci
  logical,             intent(inout) :: error
  !
  sci%caldobs = -32768
  sci%calscan = 0
  sci%calback = backend_unknown
  sci%calvers = 0
  !
end subroutine mrtindex_entry_zscience
!
subroutine mrtindex_entry_zheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_zheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  head%presec(:) = .false.
  !
  call mrtindex_entry_zkey(head%key,error)
  if (error)  return
  call mrtindex_entry_zprim(head%pri,error)
  if (error)  return
  call mrtindex_entry_zcalib(head%cal,error)
  if (error)  return
  call mrtindex_entry_zscience(head%sci,error)
  if (error)  return
  call head%poi%zero(error)
  if (error)  return
end subroutine mrtindex_entry_zheader
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_fheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_fheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  ! key: nothing to destroy
  !
  ! pri: nothing to destroy
  !
  ! cal:
  call free_calib_section(head%cal,error)
  if (error)  continue
  !
  ! sci: nothing to destroy
  !
  ! poi:
  call head%poi%free(error)
  if (error)  continue
  !
end subroutine mrtindex_entry_fheader
!
subroutine mrtindex_entry_free(entry,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_free
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_entry_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_entry_t), intent(inout) :: entry
  logical,              intent(inout) :: error
  !
  ! indx: nothing to destroy
  !
  ! desc: nothing to destroy
  !
  ! head:
  call mrtindex_entry_fheader(entry%head,error)
  if (error)  continue
  !
end subroutine mrtindex_entry_free
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_lcalib(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use class_parameter
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the calibration section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ENTRY>LCALIB'
  integer(kind=size_length) :: ndata
  real(kind=4) :: medval
  integer(kind=4) :: ier,ifreq,iset,ipix,nc
  real(kind=4), allocatable :: atsys(:,:)
  character(len=64) :: tmpstring
  !
  string = ''
  if (.not.head%presec(sec_calib_id))  return
  !
  allocate(atsys(head%cal%nfreq,head%cal%npix),stat=ier)
  if (failed_allocate(rname,'atsys',ier,error))  return
  !
  nc = 1
  ndata = head%cal%nfreq * head%cal%npix
  do iset=1,head%cal%nset
    ! Fill temporary (contiguous) buffer
    do ipix=1,head%cal%npix
      do ifreq=1,head%cal%nfreq
        atsys(ifreq,ipix) = head%cal%atsys(ifreq,iset,ipix)
      enddo
    enddo
    ! Compute the median along the Freq and Pix dimensions
    call gr4_median(atsys,ndata,0.,-1.,medval,error)
    if (error)  return
    !
    ! Write in temporary string
    if (medval.eq.class_bad) then
      write(tmpstring,'(A,A,A)')   trim(head%cal%frontend(iset)),':','--'
    else
      write(tmpstring,'(A,A,I0)')  trim(head%cal%frontend(iset)),':',nint(medval)
    endif
    !
    if (truncate_and_return(nc,string))  return  ! Detect if at least 1 char available at 'nc'
    string(nc:) = tmpstring                      ! Possibly truncated
    nc = nc+len_trim(tmpstring)-1                ! Trimmed length
    if (truncate_and_return(nc,string))  return  ! Detect if truncation happened
    nc = nc+2  ! Room for a blank space (not evaluated in truncate_and_return if last loop)
  enddo
  !
  deallocate(atsys)
  !
contains
  !
  function truncate_and_return(nc,string)
    logical :: truncate_and_return
    integer(kind=4),  intent(in)    :: nc
    character(len=*), intent(inout) :: string
    ! Local
    integer(kind=4) :: mc
    !
    truncate_and_return = nc.gt.len(string)
    if (truncate_and_return) then
      mc = len(string)
      string(mc-2:mc) = '...'
    endif
  end function truncate_and_return
  !
end subroutine mrtindex_entry_lcalib
!
subroutine mrtindex_entry_lpointing(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the pointing section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: nc,isol
  !
  string = ''
  if (.not.head%presec(sec_pointing_id))  return
  !
  nc = 0
  do isol=1,head%poi%nsol
    ! Produce some mean result for the user
!     write(string(nc+2:),'(A,A,F4.1)')  &
!           head%poi%sol(isol)%val(1),':',  &
!           head%poi%sol(isol)%nfit(2)
!     nc = len_trim(string)
  enddo
  !
  ! ZZZ Dummy results for the time being (the section needs to be redefined)
  write(string,'(A)')  'Az:N/A  El:N/A'
end subroutine mrtindex_entry_lpointing
!
subroutine mrtindex_entry_lscience(head,string,nc,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the science section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),      intent(out)   :: string
  integer(kind=4),       intent(out)   :: nc
  logical,               intent(inout) :: error
  !
  string = ''
  nc = 19+backname_length  ! 11+1 + 3+1 + backname_length+1 + 2
  !
  if (.not.head%presec(sec_science_id))  return
  !
  call gag_todate(head%sci%caldobs,string,error)
  if (error)  return
  !
  write(string(13:),'(I3,1X,A,1X,I2)')  &
    head%sci%calscan,                   &
    backends_mrtcal(head%sci%calback),  &
    head%sci%calvers
  !
end subroutine mrtindex_entry_lscience
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_append_entry(entry,ient,oent,ix,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_append_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Append a NEW entry, with a new version number (automatically set
  ! to a new available value) in the file (on disk) and in IX (in
  ! memory). CX is NOT updated (this is a feature)
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Old entry position in IX
  integer(kind=entry_length), intent(out)   :: oent   ! New entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>APPEND>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: over,fileid
  integer(kind=entry_length) :: ifound,onum,osort
  logical :: dupl,olast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Set the new version value
  onum = ix%num(ient)  ! Keep same observation number
  over = 0             ! i.e. find the last version
  call mrtindex_numver2ent(rname,ix,onum,over,ifound,dupl,error)
  if (error)  return
  entry%indx%version = ix%version(ifound)+1  ! New available version
  !
  ! In which file?
  if (ox_fileid.ne.0) then
    ! Use a custom output file (INDEX OUTPUT)
    fileid = ox_fileid
    ! For safety, check if the directory associated to the output index is
    ! the same as the input index. Else, this means the user is mixing
    ! several directories and this becomes very complicated...
    if (ix_dirs(ox_fileid).ne.ix_dirs(ix%idir(ient))) then
      call mrtindex_message(seve%e,rname,  &
        'Directories mismatch for input and output indexes')
      error = .true.
      return
    endif
  else
    ! Use the original index file
    fileid = ix%idir(ient)
  endif
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_write(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%xnext)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Also append IX
  ! Make room for 1 more entry
  call reallocate_mrtoptimize(ix,ix%next,.true.,error)
  if (error)  return
  !
  oent = ix%next
  onum = ix%num(ient)  ! Keep same observation number
  osort = oent  ! Declare it at last position in the sorted index, the
                ! re-sorting is done just after
  olast = .true.  ! Is-last-version
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    oent,onum,osort,olast,ix,oent,error)
  if (error)  return
  ix%next = ix%next+1
  !
  ! And keep the sort array sorted!
  call mrtindex_optimize_setsort(ix,error)
  if (error)  return
  !
  ix%islast(ifound) = .false.  ! This is not the last version anymore
  !
end subroutine mrtindex_append_entry
!
subroutine mrtindex_update_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_update_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Update an old entry in the file (on disk) and in IX (in memory).
  ! CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UPDATE>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_update,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not update entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_update_entry
!
subroutine mrtindex_extend_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_extend_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Extend the LAST entry in the file (on disk, in particular, add the
  ! new sections) and update in IX (in memory).
  !  CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXTEND>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_extend,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not extend entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_extend_entry
!
subroutine mrtindex_modify_entry(mrtindex_entry_modify,entry,ient,ix,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_modify_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  UPDATE or EXTEND an old entry in the file (on disk) and update in
  ! IX (in memory). CX is NOT updated, this is a feature.
  !  To be called by mrtindex_update_entry or mrtindex_extend_entry only!!!
  !---------------------------------------------------------------------
  interface
    subroutine mrtindex_entry_modify(fileout,entry,error)
    use classic_api
    use mrtindex_types
    type(classic_file_t),   intent(inout) :: fileout
    type(mrtindex_entry_t), intent(inout) :: entry
    logical,                intent(inout) :: error
    end subroutine mrtindex_entry_modify
  end interface
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>MODIFY>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: inum,isort
  logical :: ilast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! In which file? Always in the same file as before
  fileid = ix%idir(ient)
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_modify(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%next because
  ! EXTEND mode may enlarge the file)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  call classic_file_fflush(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Update the entry in IX
  inum = ix%num(ient)
  isort = ix%sort(ient)  ! Its position in the sorted index does not change
  ilast = ix%islast(ient)
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    ient,inum,isort,ilast,ix,ient,error)
  if (error)  return
  !
end subroutine mrtindex_modify_entry
!
subroutine mrtindex_numver2ent(rname,ix,num,ver,ient,dupl,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_numver2ent
  use mrtindex_sort_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Convert an observation number and version to the entry position
  ! in IX. ver<0 means to choose the newest version.
  !---------------------------------------------------------------------
  character(len=*),                  intent(in)    :: rname  ! Calling routine name
  type(mrtindex_optimize_t), target, intent(in)    :: ix     !
  integer(kind=entry_length),        intent(in)    :: num    ! Observation number
  integer(kind=4),                   intent(in)    :: ver    ! Version number
  integer(kind=entry_length),        intent(out)   :: ient   ! Entry found
  logical,                           intent(inout) :: dupl   ! Error because of multiple match?
  logical,                           intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  character(len=message_length) :: mess
  integer(kind=entry_length) :: jent,kent,lent
  integer(kind=4) :: iver
  type(mrtindex_num_dicho_t) :: dicho
  !
  found = .false.
  dupl = .false.
  ient = 0
  !
  dicho%optx => ix
  dicho%searched_num = num
  call dicho%dicho(ix%sort,ix%next-1,.true.,jent)
  if (jent.eq.0)  goto 100  ! Not found
  ! In return jent is the observation lower or equal to the request
  ! in the sorted array (ix%sort)
  !
  if (ver.le.0) then
    iver = 0
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (found .and. ix%version(lent).eq.iver)  goto 101
        found = .true.
        ient = lent
        iver = ix%version(lent)
        ! Continue until we reach the last version
      else
        exit
      endif
    enddo
  else
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (ix%version(lent).eq.ver) then
          if (found)  goto 101
          found = .true.
          ient = lent
          ! Continue until we reach last version, in order to check
          ! if there are multiple match
        endif
      else
        exit
      endif
    enddo
  endif
  if (found)  return
  !
100 continue
  if (ver.le.0) then
    write(mess,'(A,I0)') 'No such observation #',num
  else
    write(mess,'(A,I0,A,I0)') 'No such observation #',num,'.',ver
  endif
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
  !
101 continue
  dupl = .true.
  write(mess,'(A,4(I0,A))') 'Multiple match for observation ',  &
    num,'.',ver,' (entries ',ient,' and ',lent,')'
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
end subroutine mrtindex_numver2ent
!
subroutine mrtindex_mjd2gagut(scandate,mjd,dobs,ut,error)
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_mjd2gagut
  !---------------------------------------------------------------------
  ! @ public
  ! Split MJD into DATE + UT, but taking care to respect the scan date
  ! which could have been set before midnight. In such a case, UT will
  ! go beyond 2*pi
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: scandate  ! [gag]
  real(kind=8),    intent(in)    :: mjd       ! [day]
  integer(kind=4), intent(out)   :: dobs      ! [gag]
  real(kind=8),    intent(out)   :: ut        ! [rad]
  logical,         intent(inout) :: error     !
  !
  character(len=*), parameter :: rname='MJD2GAGUT'
  character(len=message_length) :: mess
  character(len=8) :: datestring
  !
  call gag_mjd2gagut(mjd,dobs,ut,error)
  if (error)  return
  !
  if (scandate.eq.-32768) then
    call mrtindex_message(seve%w,rname,'Scan date is not set')
    return
  endif
  if (dobs.eq.scandate)  return  ! No midnight overlap
  !
  ! Tolerate 2h=pi/6 forward on next day (1h = max scan length)
  if (dobs.eq.scandate+1 .and. ut.lt.pi/6.d0) then
    ! Keep DOBS as scan date, set UT beyond 24h
    dobs = scandate
    ut = ut+2.d0*pi
  else
    call gag_toyyyymmdd(scandate,datestring,error)
    write(mess,'(a,a8,a,1pg25.16)')  &
      'Inconsistent date in filename (',datestring,') and MJD ',mjd
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
end subroutine mrtindex_mjd2gagut
!
subroutine datelist_decode(line,optdate,string,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>datelist_decode
  !---------------------------------------------------------------------
  ! @ private
  !  Re-encode a Sic-list of dates for the CURRENT line as known and
  ! parsed by Sic, into a string of GAG dates (much easier to parse
  ! afterwards).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  integer(kind=4),  intent(in)    :: optdate  ! Option /DATE identifier
  character(len=*), intent(out)   :: string   ! Decoded as GAG dates
  logical,          intent(inout) :: error    !
  ! Local
  integer(kind=4) :: oc,iarg,nc,gagdate
  character(len=32) :: argum
  !
  string = ''
  oc = 1
  do iarg=1,sic_narg(optdate)
    call sic_ke(line,optdate,iarg,argum,nc,.true.,error)
    if (error)  return
    !
    if (argum.eq.'TO') then
      ! Date1 TO Date2 (keep "TO" as is)
      ! NB: "BY" not yet recognized, probably useless in this context
      write(string(oc:),'(A)')  'TO'
      oc = oc+3
    else
      call date_decode(argum,gagdate,error)
      if (error)  return
      write(string(oc:),'(I0)')  gagdate
      oc = len_trim(string)+2
    endif
  enddo
  !
end subroutine datelist_decode
!
subroutine date_decode(string,dobs,error)
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>date_decode
  !---------------------------------------------------------------------
  ! @ private
  ! Decode a string date in any supported format into a gag date.
  ! Supported formats are:
  !  - DD-MMM-YYYY
  !  - YYYYMMDD
  !  - Keywords "TODAY" and "YESTERDAY"
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: string  !
  integer(kind=4),  intent(out)   :: dobs    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='DATE>DECODE'
  integer(kind=4) :: ikey
  integer(kind=4), parameter :: mkeys=2
  character(len=11) :: date
  character(len=9) :: datekeys(mkeys),keyword
  ! Data
  data datekeys / 'TODAY','YESTERDAY' /
  !
  ! Search for a keyword
  date = string
  call sic_upper(date)
  call sic_ambigs_sub(rname,date,keyword,ikey,datekeys,mkeys,error)
  if (error)  return
  !
  if (ikey.ne.0) then
    call sic_gagdate(dobs)  ! Today
    if (ikey.eq.2)  dobs = dobs-1  ! Yesterday
    return
  endif
  !
  ! Not TODAY or YESTERDAY, try other formats
  if (index(string,'-').gt.0) then  ! DD-MMM-YYYY
    call gag_fromdate(date,dobs,error)
  else                              ! YYYYMMDD
    call gag_fromyyyymmdd(date,dobs,error)
  endif
  if (error) then
    call mrtindex_message(seve%e,rname,'Could not decode date '//string)
    return
  endif
  !
end subroutine date_decode
!
function imbfits_name(date)
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !   Build an IMB-FITS file name according to the IRAM 30m standard.
  ! This function factorizes this standard at a unique place
  !---------------------------------------------------------------------
  character(len=imbfits_pattern_length) :: imbfits_name  ! Function value on return
  character(len=*), intent(in) :: date   ! The date string, can be '*'
  !
  imbfits_name = 'iram30m-*-'//trim(date)//'s*-imb.fits'
  !
end function imbfits_name
!
!-----------------------------------------------------------------------
!
function mrtindex_telescope(itel)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the telescope name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=telescope_length) :: mrtindex_telescope
  integer(kind=4), intent(in) :: itel
  !
  mrtindex_telescope = telescopes(itel)
  !
end function mrtindex_telescope
!
function mrtindex_backend(iback)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the backend name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=backname_length) :: mrtindex_backend
  integer(kind=4), intent(in) :: iback
  !
  mrtindex_backend = backends_mrtcal(iback)
  !
end function mrtindex_backend
!
function mrtindex_obstype_decode(name,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_obstype_decode
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the IMBFIST obstype name and return the corresponding
  ! MRTCAL code
  !---------------------------------------------------------------------
  integer(kind=4) :: mrtindex_obstype_decode
  character(len=*), intent(in)    :: name
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OBSTYPE>DECODE'
  character(len=obstype_length) :: obsin,obsfound
  !
  obsin = name
  call sic_upper(obsin)
  call sic_ambigs_sub(rname,obsin,obsfound,mrtindex_obstype_decode,obstypes_imbfits,  &
    nobstypes_imbfits+1,error)
  mrtindex_obstype_decode = mrtindex_obstype_decode-1  ! Because obstypes_imbfits numbering starts at 0
  if (mrtindex_obstype_decode.eq.-1) then
    call mrtindex_message(seve%w,rname,'Observation type '''//trim(obsin)//  &
      ''' not supported')
    mrtindex_obstype_decode = obstype_unknown
    ! Not an error, continue
  elseif (mrtindex_obstype_decode.eq.obstype_onoff) then
    mrtindex_obstype_decode = obstype_tracked
  endif
  !
end function mrtindex_obstype_decode
!
function mrtindex_obstype_imbfits(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (IMBFITS) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype_imbfits
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype_imbfits = obstypes_imbfits(itype)
  !
end function mrtindex_obstype_imbfits
!
function mrtindex_obstype(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (MRTCAL) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype = obstypes_mrtcal(itype)
  !
end function mrtindex_obstype
!
function mrtindex_swmode_imbfits(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_imbfits
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_imbfits = switchmodes_imbfits(imode)
  !
end function mrtindex_swmode_imbfits
!
function mrtindex_swmode(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode = switchmodes_mrtcal(imode)
  !
end function mrtindex_swmode
!
function mrtindex_swmode_voxml(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_voxml
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_voxml = switchmodes_voxml(imode)
  !
end function mrtindex_swmode_voxml

module sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  !  Support variables for the SIC interpreter. Variables local to this
  ! file only.
  !---------------------------------------------------------------------
  !
  logical :: freelet           ! Is a free syntax assignment suspected?
  logical :: sic_quiet_proced  !
  logical :: do_log            !
  integer :: ifllev(mcloop)    !
  integer :: lire              !
  integer :: liro              !
  integer(kind=4) :: nliro     !
  character(len=commandline_length) :: oline  !
  integer(kind=4) :: nolin                    !
  logical, save :: ignore_if = .false.  ! Default at startup
  logical, save :: lenter = .false.  ! Default at startup
  !
end module sic_interpreter
!
subroutine sic_run(line,lang,command,error,icode,ocode)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_interpreter
  use sic_interfaces, except_this=>sic_run
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public (but private in the context of new language initialization)
  !       Read next command and interprets it, then return
  !       control to the caller.
  !
  ! Arguments:
  ! LINE:  Command line. On input: text to be stored in stack and log
  !        file. On output: new command line
  ! ERROR: Logical error flag, indicating whether last command was
  !        successfully executed.
  !
  ! Note on labels in the code
  !       10      Error handling after command execution
  !       20      Read new command
  !       30      Check for error in command reading and level changes
  !       40      Substitute symbols and analyse line
  !       50      Log file after command execution
  !       70      DO WHILE in QUIT ALL
  !       80      DO WHILE in RETURN BASE
  !       90      DO WHILE in EXIT
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     ! Input/output command line
  character(len=*), intent(out)   :: lang     ! Language found
  character(len=*), intent(out)   :: command  ! Command found
  logical,          intent(inout) :: error    ! Logical error flag
  integer,          intent(in)    :: icode    ! Input code
  integer,          intent(out)   :: ocode    ! Output code
  ! Local
  integer(kind=4) :: nline,ier,n,goto_code,recall,ntmp
  logical :: err,suite,nolog
  character(len=4) :: ans
  character(len=message_length) :: mess,tmp
  !
  ! Output code: get next command.
  ocode = code_next
  !
  ! SIC_ENTER
  if (icode.eq.code_enter) then
    !----------------------------------------------------------------------
    !       Enter SIC
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    if (lenter) then
      call sic_message(seve%f,'SIC','Programming error: recursive call to SIC')
      call sysexi(fatale)
    endif
    nlire = 1
    nliro = 1
    mlire(nlire)=0
    lenter = .true.
    error = .false.
    goto 20
    !
    ! SIC_PLAY
  elseif (icode.eq.code_play) then
    !----------------------------------------------------------------------
    !       Enter SIC and Execute a first SIC command, which may be @.
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    if (lenter) then
      call sic_message(seve%f,'SIC','Programming error: recursive call to SIC')
      call sysexi(fatale)
    endif
    lenter = .true.
    nlire = 1
    mlire(nlire) = 0
    error = .false.
    nline = lenc(line)
    suite = .false.
    call sblanc(line,nline,suite,ier)
    if (ier.ne.1) then
      error = .true.
    else
      call aroba(line,nline,error)
    endif
    goto 30
    !
    ! SIC_EXEC
  elseif (icode.eq.code_exec) then
    !----------------------------------------------------------------------
    !       Execute a single SIC command, which may be @.
    !       Upon completion return to the caller.
    !----------------------------------------------------------------------
    if (.not.loaded) then
      call sic_message(seve%f,'SIC','SIC is not loaded')
      call sysexi(fatale)
    endif
    !
    ! Increment execution depth
    nlire = nlire+1
    mlire(nlire) = -1
    lire = -1
    if_depth(nlire) = if_current+1
    error = .false.
    nline = lenc(line)
    suite = .false.
    call sblanc(line,nline,suite,ier)
    if (ier.ne.1) then
      error = .true.
    else
      call aroba(line,nline,error)
    endif
    goto 30
  endif
  !
  ! Restore interactive mode: moved to label 20...
  !      LIBRARY_MODE = .FALSE.
  !
  ! Store in log file
50 nline=lenc(line)
  if (nline.eq.0) goto 10
  if (.not.error .and. vocab(ccomm%icom)(1:1).ne.'*') then
    call sic_log (line,nline,lire)
    if (do_log) then
      if (nlire.ge.1 .and. liro.eq.0    .and.  &  ! LIRO here
          vocab(ccomm%icom)(1:1).ne.'#' .and.  &
          vocab(ccomm%icom)(1:1).ne.'$')  &
         call insert(oline,nolin)
      !  call insert(line,nline)
    endif
    do_log = logbuf
  endif
  !
  ! Handle errors and Control_C trapping
10 continue
  call ctrlc_check(error)
  !
  ! Get the original command line again
  line = oline
  nline = nolin
  !
  call erreur(error,line,nline,lire,err)
  if (err) then
    ! SYSTEM call or SIC call?
    if (sic_format_system_token(line,nline)) then
      goto 31
    else
      suite = .false.
      call sblanc(line,nline,suite,ier)
      if (ier.ne.1) then
        error = .true.
        goto 30                  ! Yes, not 40 in this case
      else
        call aroba(line,nline,error)
        goto 40
      endif
    endif
  endif
  !
  if (nlire.eq.0) then
    ! If NLIRE=0, exit from SIC. This happens in not-interactive mode, e.g.
    ! shell> sic < foo.sic
    call gmaster_on_exit(error)
    lenter = .false.
    ocode  = code_exit
    return
    !
  elseif (mlire(nlire).eq.-1) then
    ! Decrease the level and stop execution of the current one (code_end)
    nlire = nlire-1
    if (nlire.ne.0) then
      lire = mlire(nlire)
    else
      lire = 0
    endif
    call reset_if (err)
    ocode = code_end           ! End CODE_EXEC loop
    return
  endif
  !
  ! Read a new command
20 error = .false.
  library_mode = .false.       ! Restore interactive mode
  lire=mlire(nlire)
  !
  call bldprt(nlire)           ! Build prompt
  !D print *,'TEST Calling GETCOM ',error
  call getcom(line,nline,lire,gprompt,lgprompt,error)
  !D print *,'TEST GetCom error ',error,line(1:nline)
  ! Save command line
  !      OLINE = LINE(1:NLINE)
  !      NOLIN = NLINE
  !
  ! Command processing
30 continue
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! System call
31 continue
  !
  ! The $ is only allowed interactively. Use SYSTEM command otherwise
  if (line(1:1).eq.'$' .and. .not.compil) then
    if (mlire(nlire).eq.0) then
      ier = gag_system (line(2:nline))
      if (do_log) call insert (line,nline)
      goto 20
    else
      call sic_message(seve%e,'SIC','$ is only valid at the interactive prompt')
      call sic_translate_system_token(line,nline,tmp,ntmp)
      call sic_message(seve%e,'SIC','Use instead: '//tmp(1:ntmp))
      error = .true.
      ! Save line for proper error prompt
      oline = line(1:nline)
      nolin = nline
      goto 10
    endif
  endif
  !
  ! End of level execution
  if (nline.eq.0) then
    if (compil) then
      call sic_message(seve%e,'SIC','Incorrect nesting of loops and macros')
      error = .true.
      goto 10
    endif
    nlire=nlire-1
    call reset_if (error)
    if (error) then
      call sic_message(seve%e,'SIC','Incorrect nesting of IF blocks')
    endif
    if (lire.gt.0) then
      call endmac
    elseif (lire.eq.-1) then
      if (nlire.ne.0) then
        lire = mlire(nlire)
      else
        lire = 0
      endif
      ocode = code_end         ! End CODE_EXEC loop
      return
      !
      ! This can happen if an ENDIF command is missing...
    elseif (lire.eq.-2) then
      mess = 'Invalid nesting of loop # and IF blocks'
      mess(25:25) = char(cloop+ichar('0'))
      call sic_message(seve%e,'SIC',mess)
      call finloo
      error = .true.
    endif
    goto 10
  endif
  !
40 continue
  ! Save command line
  oline = line(1:nline)
  nolin = nline
  !
  ! Translate symbols
  call replace_symbol(line,nline,error)
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! Translate Logical Names
  call replace_logical(line,nline,error)
  if (error) then
    if (sic_quiet) goto 20
    goto 10
  endif
  !
  ! Check for alternate syntax A = Something
100 continue
  freelet = .false.
  if (lsynt.gt.1) then
    call setlet(line,nline,freelet,error)
    if (error) then
      if (sic_quiet) goto 20
      goto 10
    endif
  endif
  !
  ! Find the command
  if (line(1:1).eq.' ')  goto 10
  !
  if (line(1:nline).eq.'C '.or.line(1:nline).eq.'c ') then
    ! Single letter 'C' assumed to be unambiguous reference to 'CONTINUE'.
    line = 'CONTINUE'
    nline= 8
  endif
  !
  if (proced .or. compil) then
    continue  ! Do nothing at this stage
    !
  else
    !
    ! Debug macros if requested
    if (lire.gt.0) then
      if (sic_stepin.gt.0 .and. nline.gt.1) then
        if (.not.lverif) call sic_wprn(line(1:nline)//' ? ',ans,n)
      endif
    endif
    !
    ! Interpret
    call sic_find(command,line,nline,error)
    if (error) then
      if (sic_quiet) goto 20
      goto 10
    endif
    lang = ccomm%lang
    !
    ! Patch for user commands
    if (languages(ccomm%ilang)%user) then
      if (logbuf .and. nlire.ge.1 .and. lire.eq.0)  call insert(line,nline)
      do_log = .false.
      call replace_usercom(languages(ccomm%ilang),command,line,nline,error)
      ! Reprocess the command by GETCOM: it may contain several
      ! commands in one line:
      ! print *,'TEST PUTCOM ',Line(1:nline)
      call putcom(line,nline,error)
      ! print *,'TEST ',Line(1:nline)
      goto 100
    endif
  endif
  !
  liro=lire
  !
  ! Procedure definition
  if (proced) then
    call sic_proced(line,nline,error)
    goto 10
  endif
  !
  if (compil) then
    ! Compilation of loop
    call sic_compil(line,nline,goto_code,error)
    !
    select case (goto_code)
    case(20)
      goto 20
    case(40)
      goto 40
    case default
      goto 10
    end select
    !
  elseif (nlire.gt.0 .and. if_current.ge.if_depth(nlire)) then
    ! Exploration of an IF block
    call sic_ifblock(line,nline,command,goto_code,error)
    !
    select case (goto_code)
    case(10)
      goto 10
    case(20)
      goto 20
    case(50)
      goto 50
    end select
    ! Default => continue
  endif
  !
  ! Execution : User commands
  if (ccomm%icom.gt.mbuilt_sic_inter) return  ! Command is not a basic SIC\ one.
  ! This assumes that SIC\ is the first language loaded and that the
  ! commands below are the first in this language.
  call sic_run_comm(command,line,nline,ocode,recall,nolog,error)
  ! Take care of some commands which can return with ERROR true AND
  ! OCODE.NE.0  (QUIT [ALL], RETURN ERROR). OCODE has precedence in this
  ! case (we should not retrieve more command lines before leaving
  ! 'sic_run', else they could be ignored by caller).
  if (ocode.ne.0)  return
  if (error)  goto 10
  if (recall.eq.1)  goto 40  ! Sic call
  if (nolog) goto 10
  !
  ! Handle log file and stack
  goto 50
  !
end subroutine sic_run
!
subroutine sic_if(case)
  use sic_interpreter
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(in) :: case  !
  ignore_if = case
end subroutine sic_if
!
subroutine sic_run_comm(command,line,nline,ocode,recall,nolog,error)
  use sic_dependencies_interfaces
  use gbl_message
  use sic_interfaces, except_this=>sic_run_comm
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Execute a basic SIC\ command. A "basic" SIC command is one of these
  ! SIC\ commands which is deeply bound with the SIC interpreter, i.e.
  ! which can not be executed out of it.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: command  ! Command
  character(len=*), intent(inout) :: line     ! Command line
  integer(kind=4),  intent(inout) :: nline    ! Length of command line
  integer(kind=4),  intent(out)   :: ocode    ! Output code
  integer(kind=4),  intent(out)   :: recall   ! Execute a new command?
  logical,          intent(out)   :: nolog    ! Log it or not on return?
  logical,          intent(inout) :: error    ! Logical error flag (intent(out)?)
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: goto_code,nc
  character(len=132) :: comarg
  logical :: all,err,logi,ifconstruct
  integer(kind=4) :: lstart,lend
  character(len=message_length) :: mess
  !
  ! Do not log all these commands: control-flow like IF ENDIF would
  ! fill up the message file:
  ! call sic_message(seve%c,rname,line(1:nline))
  !
  recall = 0       ! No command to execute on return
  nolog = .false.  ! By default, log the command on return
  !
  ! SIC Commands
  select case (command)
  !
  ! IF logical test processing
  case('IF')
    if (ignore_if) then
      nolog = .true.
      return
    endif
    !
    if (if_current.ge.mcif) then
      call sic_message(seve%e,rname,'Too many IF blocks')
      error = .true.
      return
    elseif (lire.eq.0) then
      mess = 'Command '//trim(command)//' is invalid in this context'
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    else
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
    endif
    !
    ! Evaluate logical expression
    call sic_l4 (line,0,1,logi,.true.,error)
    if (error)  return
    if (ifconstruct) then
      ! IF block construst
      if_current = if_current + 1
      if_last = if_current
      if (logi) then
        if_active(if_current) = .true.
        if_elsefound(if_current) = .false.
        if_finished(if_current) = .false.
      elseif (.not.error) then
        sic_quiet = .true.
        if_active(if_current) = .false.
        if_elsefound(if_current) = .false.
        if_finished(if_current) = .false.
      endif
    else
      ! Logical IF statement (single line)
      if (logi) then
        lstart = sic_start(0,2)
        lend = sic_end(0,sic_narg(0))
        line = line(lstart:lend)
        nline = lend-lstart+1
        recall = 1
      endif
    endif
  !
  ! @ Start procedure execution
  case('@')
    call sic_message(seve%c,rname,line(1:nline))
    if (nliro.ne.-42) nliro = nlire
    liro  = lire
    call exemac (line,error)
    if (error)  return
    if_depth(nlire) = if_current+1 ! Set start depth level
    call sic_log (line,nline,liro)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    nolog = .true.
  !
  ! BEGIN Procedure/Data/Help
  case('BEGIN')
    sic_quiet_proced = sic_quiet
    call begin_area (line,error)
    nolog = .true.
  !
  ! EDIT : Calls stack or file editor
  case('EDIT')
    if (.not.sic_present(0,1)) then
      call edit_stack(error,.true.)
      nolog = .true.
    else
      call sic_ch (line,0,1,comarg,nc,.true.,error)
      if (error)  return
      call sic_parsef(comarg,mess,' ',sicext(1))
      call editor (mess,error)
    endif
  !
  ! EXIT : end SIC keyboard execution (not necessarily program execution)
  case('EXIT')
    call sic_message(seve%c,rname,line(1:nline))
    if (gmaster_get_ismaster().eq.1) then  ! SIC master
      call sic_run_exit(line,ocode,error)
      if (error)  return
#if defined(GAG_USE_PYTHON)
    else  ! Python master
      ! In this case (EXIT or CTRL-D), we only go back to Python prompt.
      ! This seems however a poor man solution, we should probably leave
      ! properly the current execution levels.
      call gpy_interact()
#endif
    endif
  !
  ! FOR : Start Loop execution or compilation
  case('FOR')
    call iniloo (line,nline,error)
    if (error)  return
    gprompt_nlire_old = -10
    if (compil) then
      ifllev (cloop) =  if_last
    else
      call exeloo (error)
      if (error)  return
      call sic_log (line,nline,liro)
      nolog = .true.
    endif
  !
  ! HELP : Display HELP text
  case('HELP')
    call sic_help(line,error)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    nolog = .true.
  !
  ! NEXT : Loop on FOR command
  case('NEXT')
    if (sic_narg(0).gt.1) then
       call sic_message(seve%e,'NEXT','Invalid number of arguments')
       error = .true.
       return
    endif
    if (nlire.eq.1) then
      nolog = .true.
      return
    endif
    if (mlire(nlire).eq.0) then
      if (mlire(nlire-1).eq.-2) then
        nlire=nlire-1
      else
        nolog = .true.
        return
      endif
    elseif (mlire(nlire).ne.-2) then
      nolog = .true.
      return
    endif
    call exeloo (error)
    if (error)  return
    call sic_log (line,nline,liro)
    nolog = .true.
  !
  ! ON : Handle error recovery command
  case('ON')
    call sic_message(seve%c,rname,line(1:nline))
    call sic_on(line,error)
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(oline,nolin)
    endif
    call sic_log (line,nline,lire)
    nolog = .true.
  !
  ! PAUSE : Interrupt procedure or loop execution
  case('PAUSE')
    if ((lire.lt.0 .or. lire.gt.0).and..not.lverif) then
      mess = ''
      call sic_ch(line,0,1,mess,nc,.false.,error)
      if (error)  continue
      mess = gprompt(1:lgprompt)//trim(command)//"  "//mess(1:nc)
      write (*,'(A)') trim(mess)
    endif
    nliro = nlire
    call break
    if (do_log .and. nliro.ge.1 .and. liro.eq.0) then
      call insert(line,nline)
    endif
    call sic_log (line,nline,lire)
    nolog = .true.
  !
  ! QUIT : Abort (with error) Loop or Procedure execution
  case('QUIT')
    if (nlire.lt.2) then
      nolog = .true.
      return
    endif
    comarg = ' '
    call sic_ke (line,0,1,comarg,nc,.false.,error)
    if (error)  return
    all = comarg.eq.'ALL'
    if (mlire(nlire).ne.0) then
      ! This is probably wrong
      nolog = .true.
      return
    endif
    nlire = nlire-1            ! Leave error processing level
    ! DO ... UNTIL (NLIRE.EQ.1 .OR. .NOT.ALL)
70  error = .true.
    ! Loop
    if (mlire(nlire).le.-2) then
      call finloo
      ! Program
    elseif (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end         ! End CODE_EXEC loop
      write(mess,'(A,L)') 'Quitting with error ',error
      call sic_message(seve%i,'QUIT',mess)
      return
      ! Procedure
    elseif (mlire(nlire).ne.0) then
      call endmac
      nlire = nlire-1
      call reset_if (err)
      ! Interactive input
    else
      ! The following line is ABSOLUTELY necessary. It MUST be executed
      ! when one has called interactively a procedure from a PAUSE level, to
      ! ensure that QUIT ALL returns at this interactive level. If this
      ! line is not present, SIC loops forever...
      return
    endif
    ! DO 70 UNTIL (NLIRE.EQ.1 .OR. .NOT.ALL)
    if (all.and.nlire.gt.1) goto 70
  !
  ! BREAK : Abort (without error) Loop execution
  case('BREAK')
    if (mlire(nlire).le.-2) then
      call finloo
    else
      nolog = .true.
    endif
  !
  ! RETURN : Abort (without error) current procedure execution, unless argument
  ! BASE is present. In the latter case, abort all nested procedures.
  case('RETURN')
    call sic_message(seve%c,rname,line(1:nline))
    comarg = ' '
    call sic_ke (line,0,1,comarg,nc,.false.,error)
    if (error)  return
    all = comarg.eq.'BASE'
    error = comarg.eq.'ERROR'
    !
    ! First abort loops from this level if the previous one is a macro
    ! DO 80 ... UNTIL .NOT.(ALL.AND.NLIRE.GT.1)
80  continue
    if (mlire(nlire).eq.0) then
      nolog = .true.
      return
    elseif (mlire(nlire).eq.-2 .and. nlire.gt.2) then
      if (mlire(nlire-1).eq.0) then
        nolog = .true.
        return
      else
        do while (mlire(nlire).eq.-2)
          call finloo
        enddo
      endif
    endif
    if (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end         ! End CODE_EXEC loop
      write(mess,'(A,L)') 'Returning with error ',error
      call sic_message(seve%i,'RETURN',mess)
      return
    else
      call endmac
    endif
    nlire = nlire-1
    call reset_if (err)
    ! DO 80 ... UNTIL .NOT.(ALL.AND.NLIRE.GT.1)
    if (all.and.nlire.gt.1) goto 80
  !
  ! TYPE : List stack or file
  case('TYPE')
    call sic_type(line,.true.,goto_code,error)
    if (goto_code.ne.50) then
      ! Do not put in stack
      nolog = .true.
    endif
  !
  ! CONTINUE : Resume interrupted execution
  case('CONTINUE')
    nolog = .true.
    if (lire.ne.0)  return
    if (nlire.eq.1)  return
    nlire = nlire-1
    lire = mlire(nlire)
    call sic_log (line,nline,lire)
  !
  ! PYTHON
  case('PYTHON')
    call sic_message(seve%c,rname,line(1:nline))
    call sic_run_python(line,.true.,error)
    !
  case default
    !
    if (ignore_if) then
      if (command.eq.'ELSE' .or. command.eq.'END') then
        nolog = .true.
        return
      endif
    endif
    call sic_message(seve%e,rname,'Command '//trim(command)//' is invalid in this context')
    error = .true.
    !
  end select
  !
end subroutine sic_run_comm
!
function sic_format_system_token(line,nline)
  use sic_interfaces, except_this=>sic_format_system_token
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Detect $ token and reformat the line properly before execution.
  !---------------------------------------------------------------------
  logical :: sic_format_system_token
  character(len=*), intent(inout) :: line
  integer(kind=4),  intent(inout) :: nline
  !
  integer(kind=4) :: idollar
  !
  sic_format_system_token = .false.
  if (compil)  return
  idollar = index(line,'$')
  if (idollar.le.0)  return
  !
  if (idollar.eq.1) then
    sic_format_system_token = .true.
  elseif (line(1:idollar-1).eq.' ') then
    sic_format_system_token = .true.
    line(1:nline) = line(idollar:nline)
    nline = nline-idollar+1
  else
    ! There are other characters before the $ token, so it is not a
    ! system token. Do nothing.
  endif
end function sic_format_system_token
!
subroutine sic_run_exit(line,ocode,error)
  use sic_interfaces, except_this=>sic_run_exit
  use sic_interactions
  use sic_interpreter
  !---------------------------------------------------------------------
  ! @ private
  ! Perform proper actions for the EXIT command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(inout) :: ocode
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: exit_code,i
  logical :: all,err
  !
  ! Command line parsing
  ! Set the 'noprompt' flag according to EXIT /NOPROMPT:
  call gmaster_set_exitnoprompt(sic_present(1,0))
  ! Set the exit code
  exit_code = 0
  call sic_i4(line,0,1,exit_code,.false.,error)
  if (error)  continue  ! ?
  call gmaster_set_exitcode(exit_code)
  !
  all = .false.
  do i=1,nlire
    if (mlire(i).eq.-1) all = .true.
  enddo
  if (.not.all) then
    call gmaster_on_exit(error)
    if (error)  return
    lenter = .false.
    ocode = code_exit        ! Final EXIT for program
    return
  else
90  continue
    ! Loop
    if (mlire(nlire).le.-2) then
      call finloo
      ! Program : return
    elseif (mlire(nlire).eq.-1) then
      nlire = nlire-1
      lire = mlire(nlire)
      call reset_if (err)
      ocode = code_end       ! End CODE_EXEC loop
      return
      ! Procedure
    elseif (mlire(nlire).ne.0) then
      call endmac
      nlire = nlire-1
      call reset_if (err)
    else
      nlire = nlire-1
    endif
    if (nlire.gt.1) goto 90
    lire = 0
    nlire = 0
    call reset_if (err)
    ocode = code_end         ! End CODE_EXEC loop
    return
  endif
  !
end subroutine sic_run_exit
!
subroutine sic_proced(line,nline,error)
  use sic_interfaces, except_this=>sic_proced
  use sic_dependencies_interfaces
  use sic_dictionaries
  use sic_interpreter
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compilation mode for BEGIN PROC/END PROC blocks
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  integer,          intent(inout) :: nline  ! Line length
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=command_length) :: command
  character(len=132) :: comarg
  integer :: nc
  integer, parameter :: mvoc_end=4
  character(len=16) :: vocab_end(mvoc_end),keyword
  ! Data
  data vocab_end /'IF','PROCEDURE','HELP','DATA'/
  !
  if (freelet) then
    ! If 'freelet' is .true., we suspect the command line to be a
    ! FREE SYNTAX assignment. This implies to skip the BEGIN/END
    ! recognition hereafter. The command line written in the
    ! procedure in not translated.
    command = ' '
    !
  else
    call sic_find(command,line,nline,error)
    if (error) then
      call sic_message(seve%d,'SIC','Ignoring error in procedure definition')
      error = .false.
    endif
    !
    if (command.eq.'BEGIN') then
      call sic_message(seve%e,'END','Invalid nested BEGIN/END block')
      error = .true.
      return
      !
    elseif (command.eq.'END') then
      call sic_ke(line,0,1,comarg,nc,.true.,error)
      if (error)  return
      call sic_ambigs('END',comarg,keyword,nc,vocab_end,mvoc_end,error)
      if (error)  return
      !
      if (keyword.eq.'PROCEDURE') then
        call close_procedure(command,line,nline,error)
        sic_quiet = sic_quiet_proced
        return
      elseif (keyword.ne.'IF') then
        call sic_message(seve%e,'END','Invalid END '//trim(keyword)//  &
        ' statement in procedure definition')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! Any command, including END IF
  call write_procedure(command,line,nline,error)
  if (error) then
    call close_procedure(command,line,nline,error)
    sic_quiet = sic_quiet_proced
  endif
  !
end subroutine sic_proced
!
subroutine sic_compil(line,nline,goto_code,error)
  use sic_dependencies_interfaces
  use sic_interpreter
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces, except_this=>sic_compil
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compilation mode for FOR/NEXT blocks
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line       ! Input command line
  integer,          intent(inout) :: nline      ! Line length
  integer,          intent(out)   :: goto_code  ! Where to go on return?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=command_length) :: command
  character(len=132) :: comarg
  integer :: nc
  character(len=message_length) :: mess
  logical :: ifconstruct
  !
  goto_code = 10
  !
  if (freelet) then
    command = ' '
  else
    call sic_find(command,line,nline,error)
    if (error) then
      command = ' '
      error = .false.
      if (mlire(nlire).eq.0) then
        call sic_message(seve%e,'SIC','Ignoring error in FOR block')
        return  ! Interactive level 0: do not save erroneous command in
                ! the FOR/NEXT block
      endif  ! Else, save it and raise an error at execution for safety
    endif
  endif
  !
  if (command.eq.'BEGIN' ) then
    call sic_message(seve%e,'SIC','Command '//trim(command)//' is invalid in this context')
    error = .true.
    return
  elseif (command.eq.'END') then
    call sic_ke(line,0,1,comarg,nc,.true.,error)
    if (error) then
      return
    elseif  (comarg.ne.'IF') then
      call sic_message(seve%e,'END','Command '//trim(command)//' is invalid in this context')
      error = .true.
      return
    endif
  elseif (command.eq.'QUIT') then
    call aboloo
    gprompt_nlire_old = -10
    mess = 'SIC'//backslash//'QUIT'
    if (do_log) call sic_insert(mess)
    call sic_log(mess,8,liro)
    return
  elseif (command.eq.'HELP'.and.mlire(nlire).eq.0) then
    call sic_help(line,error)
    goto 20
  elseif (command.eq.'TYPE'.and.mlire(nlire).eq.0) then
    call sic_type(line,.false.,goto_code,error)
    goto 20
  endif
  !
  if (ccomm%icom.gt.0 .and. vocab(ccomm%icom)(1:1).eq.'#') then
    call sic_message(seve%w,'FOR','Line not valid in this context, ignored')
    return
  elseif (command.eq.'NEXT') then
    if (ifllev(cloop).ne.if_last) then
      call sic_message(seve%e,'SIC','Invalid nesting of loops and IF')
      error = .true.
      return
    endif
  endif
  !
  if (command.eq.'FOR') then
    call iniloo(line,nline,error)
    if (error) return
    ifllev (cloop) = if_last
  else
    call insloo(line,nline,error)
    if (error) return
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
    elseif (command.eq.'END') then   ! END IF checked before
  ! elseif (command.eq.'ENDIF') then
      if_last = if_last-1
    endif
  endif
  !
  call sic_log (line,nline,liro)
  if (do_log) then
    if (nlire.ge.1 .and. lire.eq.0 .and. vocab(ccomm%icom)(1:1).ne.'#')  &
      call insert(line,nline)
  endif
  if (error) return
  !
  if (command.eq.'NEXT') then
    if (sic_narg(0).eq.1) then
      call verify_loop_variable (cloop,line,error)
      if (error) return
    else if (sic_narg(0).gt.1) then
      call gag_message(seve%e,'NEXT','Wrong number of arguments')
      error = .true.
      return
    endif
    if (cloop.eq.ifloop(nlire+1)+1) then
      indice(cloop) = 0.0
      nlire = nlire + 1
      mlire(nlire) = -2
      if_depth(nlire) = if_current+1
      compil = .false.
      lasllo (cloop) = loolen
      lasblo (cloop) = bulend
      call exeloo (error)
      gprompt_nlire_old = -10
    else
      call delete_loop_variable (cloop)
      lasllo (cloop) = loolen
      lasblo (cloop) = bulend
      cloop = ploop(cloop)
    endif
  endif
  !
  return
  !
20 goto_code = 20
  return
end subroutine sic_compil
!
subroutine sic_ifblock(line,nline,command,goto_code,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_ifblock
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! IF block exploration
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Command line
  integer(kind=4),  intent(in)    :: nline      ! Length of command line
  character(len=*), intent(in)    :: command    !
  integer(kind=4),  intent(out)   :: goto_code  !
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=32) :: comarg
  integer(kind=4) :: nc
  logical :: ifconstruct,dolog
  !
  goto_code = 10  ! Default: error handling
  !
  ! If exploring an IF block, look for special commands
  if (command.eq.'BEGIN') then
    call sic_message(seve%e,'SIC','Command '//trim(command)//' is invalid in this context')
    error = .true.
    return
  elseif (command.eq.'END') then
    call sic_ke(line,0,1,comarg,nc,.true.,error)
    if (error) then
      return
    elseif (comarg.ne.'IF') then
      call sic_message(seve%e,'END','Command '//trim(command)//' is invalid in this context')
      error = .true.
      return
    endif
  endif
  !
  if (.not.if_active(if_current)) then
    ! The active part of the IF block was not yet found. Check for IF,
    ! ELSE[IF] or ENDIF, and activate the coming part if relevant.
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
    elseif (if_last.eq.if_current) then
      call sic_ifblock_elseend(line,nline,command,dolog,error)
      if (error)  return
      if (dolog)  goto 50
    elseif (command.eq.'END') then
      if_last = if_last-1
    endif
    ! Skip all other commands
    goto 20
    !
  elseif (.not.if_finished(if_current)) then
    ! The active part of the IF block was already found (if_active(if_current)
    ! == .true.) but it is not yet finished (if_finished(if_current) ==
    ! .false.). In other words, we are currently executing it. Check for ELSE[IF]
    ! or ENDIF, and deactivate the current part if relevant. Otherwise execute
    ! the command since we are in the active block.
    !
    ! Looking for ELSE, ELSE IF, or ENDIF
    call sic_ifblock_elseend(line,nline,command,dolog,error)
    if (error)  return
    if (dolog)  goto 50
    ! Execute all other commands
    !
  else
    ! The active part of the IF block was already found (if_active(if_current)
    ! == .true.) and it is already finished (if_finished(if_current) ==
    ! .true.). Check for new IF subblock (inactive since this part is inactive),
    ! ELSE[IF] or ENDIF, and leave the current IF block if relevant.
    !
    if (command.eq.'IF') then
      call sic_ifconstruct('IF',line,2,.true.,ifconstruct,error)
      if (error)  return
      ! Increment the IF deepness only in case of IF block construct
      ! (as opposed to single-line logical IF statement)
      if (ifconstruct)  if_last = if_last+1
      !
    elseif (if_last.eq.if_current) then
      call sic_ifblock_elseend(line,nline,command,dolog,error)
      if (error)  return
      if (dolog)  goto 50
      !
  ! elseif (command.eq.'ENDIF') then
    elseif (command.eq.'END') then
      if_last = if_last-1
    endif
    ! Skip all other commands. Skip in particular ELSE and ELSE IF statements
    ! in non active IF subblocks.
    goto 20
  endif
  goto_code = 0
  return
  !
20 goto_code = 20
  return
50 goto_code = 50  ! Same as goto_code 0 except command line is logged
  return
  !
end subroutine sic_ifblock
!
subroutine sic_ifblock_elseend(line,nline,command,dolog,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_ifblock_elseend
  use sic_interactions
  use sic_interpreter
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Parsing of END or ELSE [IF] in an IF block
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: nline
  character(len=*), intent(in)    :: command
  logical,          intent(out)   :: dolog
  logical,          intent(inout) :: error
  ! Local
  character(len=32) :: comarg
  integer(kind=4) :: nc
  logical :: ifconstruct,logi
  !
  ! NB: THIS MAKES SENSE ONLY IF if_last == if_current
  !
  dolog = .false.
  if (command.eq.'END') then  ! Caller checked this is a END IF
    sic_quiet = .false.
    if_active(if_current) = .false.
    if_elsefound(if_current) = .false.
    if_finished(if_current) = .true.
    if_current = if_current-1
    if_last = if_current
    if (lverif .and. lire.ne.0)  &
      call sic_echo (gprompt,lgprompt,line,nline)
    dolog = .true.
    !
  elseif (command.eq.'ELSE') then
    !
    comarg = ' '
    call sic_ke(line,0,1,comarg,nc,.false.,error)
    if (error) return
    !
    if (comarg.eq.' ') then
      ! ELSE (no argument)
      if (if_elsefound(if_current)) then
        call sic_message(seve%e,'ELSE','Duplicate ELSE statements in IF-ENDIF block')
        error = .true.
        return
      endif
      if_elsefound(if_current) = .true.
      if (.not.if_active(if_current)) then
        ! The active part of the IF block was not yet found. This ELSE part
        ! becomes the active one:
        sic_quiet = .false.
        if_active(if_current) = .true.
        if_finished(if_current) = .false.
      else
        ! The active part of the IF block was already found. Finish it (may be
        ! it was already finished earlier, harmless doing it twice)
        sic_quiet = .true.
        if_finished (if_current) = .true.
      endif
      !
    elseif (comarg.eq.'IF') then
      ! ELSE IF: check syntax
      if (if_elsefound(if_current)) then
        call sic_message(seve%e,'ELSE','ELSE IF statement cannot follow ELSE statement')
        error = .true.
        return
      endif
      call sic_ifconstruct('ELSEIF',line,3,.false.,ifconstruct,error)
      if (error)  return
      if (.not.ifconstruct) then
        call sic_message(seve%e,'ELSEIF','Invalid IF statement for an ELSEIF')
        error = .true.
        return
      endif
      if (.not.if_active(if_current)) then
        ! The active part of the IF block was not yet found. Is this ELSEIF active?
        call sic_l4 (line,0,2,logi,.true.,error)
        if (error)  return
        if (logi) then
          sic_quiet = .false.
          if_active(if_current) = .true.
          if_finished(if_current) = .false.
        endif
      else
        ! The active part of the IF block was already found. Finish it (may be
        ! it was already finished earlier, harmless doing it twice)
        sic_quiet = .true.
        if_finished (if_current) = .true.
      endif
      !
    else
      call sic_message(seve%e,'ELSE','Invalid argument '//comarg(1:12))
      error = .true.
      return
    endif
    if (lverif .and. lire.ne.0)  &
      call sic_echo (gprompt,lgprompt,line,nline)
    !
    dolog = .true.
  endif
  ! Do nothing here for all other commands
  !
end subroutine sic_ifblock_elseend
!
subroutine reset_if(error)
  use sic_interfaces, except_this=>reset_if
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(out) :: error  !
  ! Local
  integer :: i,ifgood
  !
  ! New corrected logic
  ifgood = if_depth(nlire+1)-1
  !
  if (if_current.gt.ifgood) then
    error = .true.
    do i=ifgood+1,if_current
      if_active(i) = .false.
      if_elsefound(i) = .false.
      if_finished(i) = .true.
    enddo
    if_current = ifgood
    if_last = ifgood
  else
    error = .false.
  endif
  sic_quiet = .false.
end subroutine reset_if
!
subroutine sic_ifconstruct(rname,iline,iarg,allowed,ifconstruct,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_ifconstruct
  use sic_structures
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Detect if command line "[ELSE] IF (Logi) ..." is an IF statement
  ! or an IF construct
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname        ! Calling routine name
  character(len=*), intent(in)    :: iline        ! Input command line
  integer(kind=4),  intent(in)    :: iarg         !
  logical,          intent(in)    :: allowed      ! IF statement allowed or not?
  logical,          intent(out)   :: ifconstruct  ! Is an IF construct or not?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=5) :: cthen  ! Length 5 on purpose (i.e. typo THENN would be a syntax error)
  integer(kind=4) :: nc
  character(len=commandline_length) :: line,buff
  type(sic_command_t), save :: command  ! Save'd to enable the optimization in sic_parse_line
  !
  cthen = 'THEN'
  call sic_ke(iline,0,iarg,cthen,nc,.false.,error)
  if (error)  return
  ifconstruct = cthen.eq.'THEN'
  if (ifconstruct) then
    if (sic_narg(0).gt.iarg) then
      call sic_message(seve%e,rname,'Trailing arguments after THEN')
      error = .true.
    endif
    return
  endif
  !
  ! Found a candidate IF statement
  if (allowed) then
    ! Check if it is a valid command line
    line = iline(sic_start(0,iarg):)
    nc = len_trim(line)
    call replace_symbol(line,nc,error)
    if (error) return
    call sic_parse_line(line,nc,.true.,sic_quiet,command,buff,error)
    if (error)  return
  else
    ! Forbidden => syntax error
    call sic_message(seve%e,rname,'Invalid syntax')
    error = .true.
    return
  endif
  !
end subroutine sic_ifconstruct
!
subroutine setlet(line,nline,freelet,error)
  use sic_interfaces, except_this=>setlet
  use sic_interactions
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Check if input line is a free syntax assignment (e.g "A = 1"). If
  ! yes, add a "SIC\LET" command at the beginning of the line.
  ! If not in execution mode (i.e. COMPIL and PROCED), we cannot check
  ! if variable really exists.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     ! Modified on return
  integer,          intent(inout) :: nline    !
  logical,          intent(inout) :: freelet  ! Can possibly be a free syntax assignment?
  logical,          intent(inout) :: error    !
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=256) :: var
  character(len=2048) :: line1
  integer :: i,j,k,mcom,jline
  logical :: found
  !
  i = index(line(1:nline),' ')
  if ((i.eq.0).or.(i+2.ge.nline)) return
  if (line(i:i+2).ne.' = ') return
  !
  ! \ is present, must be a command
  if (index(line(1:i),backslash).ne.0) return
  !
  ! In procedure mode and compilation of loop, we can not rely on
  ! variable existence test. The line must be translated later on.
  if (proced .or. compil) then
    freelet = .true.
    return
  endif
  !
  ! Check if it is a known variable. Do not bother checking
  ! validity of subarrays.
  var = line(1:i-1)
  jline = index(var,'[')
  if (jline.eq.0) then
    jline = i-1
  else
    jline = jline-1
  endif
  !
  ! Check if variable exist
  found = sic_level(var(1:jline)).ge.0
  if (.not.found) return
  !
  ! Known variable
  !
  ! Check if it is a known command
  if (jline.lt.len(vocab(1))) then
    do k=1,nlang
      if (.not. (languages(k)%asleep.or.languages(k)%libmod) ) then
        j = mbuilt(k-1)
        mcom = mbuilt(k)
        do while (j.lt.mcom)
          j = j+1
          !
          ! Return an error if exact match: syntax is ambigous
          if (sic_eqchain(var(1:jline),vocab(j)(2:))) then
            call sic_message(seve%e,'INTER',var(1:jline)//' is ambiguous: '//  &
            'command or variable ?')
            error = .true.
            return
          endif
          j = j+nopt(j)
        enddo
      endif
    enddo
  endif
  !
  ! A true variable: assume assignment...
  line1 = 'SIC'//backslash//'LET '//line
  nline = min(len(line),nline+8)
  line = line1
end subroutine setlet

module mapping_interfaces_none
  interface
    subroutine big_wait(n,b)
      real, intent(inout) :: b
      integer, intent(in) :: n
    end subroutine big_wait
  end interface
  !
  interface
    subroutine map_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine map_message_set_id
  end interface
  !
  interface
    subroutine mapping_pack_set(pack)
      use gpack_def
      !----------------------------------------------------------------------
      ! Can not be in a module as it is called by mapping-pyimport.c and
      ! mapping-sicimport.c
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine mapping_pack_set
  end interface
  !
end module mapping_interfaces_none

module sumlin_mod_first
  use class_types
  !---------------------------------------------------------------------
  !  Support variables for first run through index, in order to find
  ! what should be the new header (in particular axis parameters)
  !---------------------------------------------------------------------
  !
  ! Input observations: variables for statistics displayed to user (just
  !                    for feedback).
  real(kind=8) :: allrdopplermin,allrdopplermax
  real(kind=8) :: allrresomin,allrresomax
  !
  ! Output sum: values to be exported in header
  real(kind=8)      :: sxmin     ! Minimum abscissa of the X axis (i.e. left side of 1st channel if res>0)
  real(kind=8)      :: sxmax     ! Maximum abscissa of the X axis (i.e. right side of last channel if res>0)
  integer(kind=4)   :: smod         ! Output switching mode
  real(kind=8)      :: sdoppler     ! Doppler factor              for the output sum
  real(kind=8)      :: stime        ! Integration time            for the output sum
  real(kind=8)      :: sweight      ! Output sum weight (sum of input weights)
  character(len=12) :: sline        ! Line name                   for the output sum
  logical           :: sline_l      ! Are all line names the same?
  character(len=12) :: stele        ! Telescope name              for the output sum
  logical           :: stele_c(12)  ! Characters to be compared
  real(kind=8)      :: smjd         ! MJD                         for the output sum
  real(kind=4)      :: selevation   ! Elevation                   for the output sum
  ! Azimuth: beware of the 2 pi discontinuity...
  type(class_calib_t) :: scal       ! Calibration section         for the output sum
  !
end module sumlin_mod_first
!
subroutine sumlin_header(set,aver,refer,cons,sumio,error,user_function)
  use gbl_constant
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sumlin_header
  use class_averaging
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Run through the index to set the sum header. If required,
  ! automatically define the X axis resampling.
  ! 'sumlin_init' must have been called before.
  ! ---
  !  WARNING: this subroutine is duplicated in 'accumulate_generic'
  !  in order to loop on R & T instead of CX. Please duplicate there
  !  any modification made here!
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(average_t),     intent(inout) :: aver      !
  type(header),        intent(in)    :: refer     ! Reference header
  type(consistency_t), intent(inout) :: cons      !
  type(observation),   intent(inout) :: sumio     ! The sum. Header set on return
  logical,             intent(inout) :: error     ! Logical error flag
  logical,             external      :: user_function
  ! Local
  type(observation) :: obs
  integer(kind=entry_length) :: iobs,nobs
  integer(kind=4) :: nchan
  type(time_t) :: time
  !
  ! 1) Parse the inputs parameters
  call sumlin_init(set,cons,aver,error)
  if (error)  return
  !
  ! 2) Set the header of the output sum, using reference observation and
  ! user's axis (if any)
  call sumlin_header_init(aver,refer,sumio,error)
  if (error)  return
  !
  ! 3) Prepare the new 'axis', prepare internal (global) variables for the addition
  call sumlin_init_variables(aver,refer,sumio%head,error)
  if (error)  return
  !
  ! 4) Loop on the observations to store their axis parameters. Include
  !    also some checks.
  nobs = cx%next-1
  aver%done%nchanmax = 0
  call init_obs(obs)
  call gtime_init(time,nobs,error)
  if (error)  return
  do iobs = 1,nobs
    call gtime_current(time)
    !
    ! Exit when asked by user
    call class_controlc(aver%do%rname,error)
    if (error)  exit
    !
    ! Fill header structure from buffer. Data not needed at this stage.
    call rheader(set,obs,cx%ind(iobs),user_function,error)
    if (error)  exit
    !
    ! Apply MODIFY FREQUENCY if requested
    if (aver%do%modfreq) then
      call modify_frequency(obs,aver%do%restf,error)
      if (error)  exit
    endif
    ! Apply MODIFY VELOCITY if requested
    if (aver%do%modvelo) then
      call modify_velocity(obs,aver%do%voff,error)
      if (error)  exit
    endif
    !
    ! Check consistency. NB: on the difference of the command CONSISTENCY,
    ! we keep running on checking all observations (i.e. to check if
    ! resampling is needed in mode AUTO) even if one is inconsistent
    ! On return of the current subroutine, 'cons' is just the consistency
    ! of the last observation against the reference one.
    call observation_consistency_check(set,refer,obs%head,cons)
    if (aver%done%kind_is_spec) then
      if ((cons%gen%check.and.cons%gen%prob) .or.  &
          (cons%sou%check.and.cons%sou%prob) .or.  &
          (cons%pos%check.and.cons%pos%prob) .or.  &
          (cons%off%check.and.cons%off%prob) .or.  &
          (cons%lin%check.and.cons%lin%prob) .or.  &
          (cons%cal%check.and.cons%cal%prob) .or.  &
          (cons%swi%check.and.cons%swi%prob)) then
        error = .true.
      endif
      if (cons%spe%check.and.cons%spe%prob) then
        if (aver%do%resampling.eq.resample_no) then
          call class_message(seve%e,aver%do%rname,'Inconsistent spectroscopic '//  &
            'axes, use option /RESAMPLE to enforce resampling')
          error = .true.
        elseif (aver%do%resampling.eq.resample_auto) then
          aver%done%resample = .true.
        endif
      endif
    else
      if ((cons%gen%check.and.cons%gen%prob) .or.  &
          (cons%sou%check.and.cons%sou%prob) .or.  &
          (cons%pos%check.and.cons%pos%prob) .or.  &
          (cons%off%check.and.cons%off%prob)) then
        error = .true.
      endif
      if (cons%dri%check.and.cons%dri%prob) then
        if (aver%do%resampling.eq.resample_no) then
          call class_message(seve%e,aver%do%rname,'Inconsistent drift '//  &
            'axes, use option /RESAMPLE to enforce resampling')
          error = .true.
        elseif (aver%do%resampling.eq.resample_auto) then
          aver%done%resample = .true.
        endif
      endif
    endif
    if (error) then
      call class_message(seve%e,aver%do%rname,'Index is inconsistent')
      exit
    endif
    !
    call sumlin_header_register(obs,sumio,aver,error)
    if (error)  exit
    !
    if (aver%done%kind_is_spec) then
      nchan = obs%head%spe%nchan
    else
      nchan = obs%head%dri%npoin
    endif
    if (nchan.gt.aver%done%nchanmax)  aver%done%nchanmax = nchan
    !
  enddo
  call free_obs(obs)
  if (error)  return
  !
  ! 5) Set the sum header and X axis description
  call sumlin_header_xaxis(set,aver,sumio,nobs,error)
  if (error)  return
  !
end subroutine sumlin_header
!
subroutine sumlin_init(set,cons,aver,error)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_init
  use class_averaging
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set some shared variables, ruled by SET methods, which we do not
  ! want to test each time in the addition loop for efficiency reasons.
  ! Should be called once, out the addition loop, i.e. not in
  ! sumlin_wadd.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(consistency_t), intent(in)    :: cons   !
  type(average_t),     intent(inout) :: aver   !
  logical,             intent(inout) :: error  ! Logical error flag
  !
  select case (aver%do%weight)
  case ('E')
    aver%done%weight = weight_equal
  case ('T')
    aver%done%weight = weight_time
  case ('S')
    aver%done%weight = weight_sigma
  case ('A')
    aver%done%weight = weight_assoc
  case default
    call class_message(seve%e,aver%do%rname, &
      aver%do%weight//' weighting is not understood')
    error = .true.
    return
  end select
  !
  aver%done%composite =  &
     aver%do%composition.eq.composite_union .or.  &
    (aver%do%composition.eq.composite_user .and. set%alig2.eq.'C')
  aver%done%kind_is_spec = aver%do%kind.eq.kind_spec
  !
  select case (aver%do%resampling)
  case (resample_user)
    ! User-defined X axis (/RESAMPLE Nx Ref Val Inc Unit)
    ! Well, ok, input X axis may match or not, but the user wants its own
    ! resampling. So, we change nothing of what he requested, and
    ! resampling is enforced.
    aver%done%resample = .true.
    if (aver%do%axis%unit.eq.'V') then
      aver%done%align = align_velo
    elseif (aver%do%axis%unit.eq.'F') then
      aver%done%align = align_freq
    elseif (aver%do%axis%unit.eq.'I') then
      aver%done%align = align_imag
    elseif (aver%do%axis%unit.eq.'P') then
      aver%done%align = align_posi
    else
      call class_message(seve%e,aver%do%rname,  &
        'Resampling in '//aver%do%axis%unit//' is not supported')
      error = .true.
      return
    endif
    !
  case (resample_auto)
    ! Automatic mode: code decides by itself if resampling is needed or not
    if (cons%spe%check) then
      ! Default is to disable the resampling. It will be enabled if needed
      ! when checking all the observation headers during the first pass.
      aver%done%resample = .false.
    else
      ! e.g. AVERAGE /RESAMPLE /NOCHECK SPECTRO: user does not want we check
      ! the spectrocopy consistency. Resampling is decided once for all,
      ! according to user's SET ALIGN.
      if (set%align.eq.'C') then
        ! Non-sense: user asks for resampling (/RESAMPLE) but channel
        ! alignment (SET ALIGN C)
        call class_message(seve%e,aver%do%rname,  &
          'Invalid combination of /NOCHECK SPECTRO + /RESAMPLE + SET ALIGN CHANNEL')
        call class_message(seve%e,aver%do%rname,  &
          'Reenable checking the spectroscopic axes (automatic detection, best choice), or')
        call class_message(seve%e,aver%do%rname,  &
          'do not use /RESAMPLE if you know the spectra are aligned, or')
        call class_message(seve%e,aver%do%rname,  &
          'choose another SET ALIGN unit if you know the spectra are misaligned.')
        error = .true.
        return
      else
        aver%done%resample = .true.
      endif
    endif
    !
    if (aver%do%alignment.eq.align_auto) then
      ! In which unit should the consistency be checked (if not disabled),
      ! and the resampling be performed if we find it is really needed?
      if (set%align.eq.'V') then
        aver%done%align = align_velo
      elseif (set%align.eq.'F') then
        aver%done%align = align_freq
      elseif (set%align.eq.'P') then
        aver%done%align = align_posi
      elseif (set%align.eq.'C') then
        ! SET ALIGN CHANNEL makes no sense for consistency check, neither
        ! for resampling if it is actually needed: implicitly switch to a
        ! cleverer alignment
        if (aver%done%kind_is_spec) then
          aver%done%align = align_freq
        else
          aver%done%align = align_posi
        endif
      endif
    else
      ! Alignment was decided at input time
      aver%done%align = aver%do%alignment
    endif
    !
  case (resample_no)
    ! No resampling
    aver%done%resample = .false.  ! Strictly
    !
    ! In the "No resampling" case, the alignment makes sense only for
    ! the spectroscopic axes consistency checks (if not disabled by /NOCHECK)
    if (aver%do%alignment.eq.align_auto) then
      ! In which unit should the consistency be performed?
      if (set%align.eq.'V') then
        aver%done%align = align_velo
      elseif (set%align.eq.'F') then
        aver%done%align = align_freq
      elseif (set%align.eq.'P') then
        aver%done%align = align_posi
      elseif (set%align.eq.'C') then
        ! SET ALIGN CHANNEL makes no sense for consistency check: implicitly
        ! switch to a cleverer alignment
        if (aver%done%kind_is_spec) then
          aver%done%align = align_freq
        else
          aver%done%align = align_posi
        endif
      endif
    else
      ! Alignment was decided at input time
      aver%done%align = aver%do%alignment
    endif
    !
  end select
  !
  if (aver%done%kind_is_spec) then
    if (aver%do%resampling.eq.resample_user .or.  &
        aver%do%resampling.eq.resample_auto) then
      if (aver%done%align.ne.align_velo .and.  &
          aver%done%align.ne.align_freq .and.  &
          aver%done%align.ne.align_imag) then
        call class_message(seve%e,aver%do%rname,  &
          'Unsupported align mode for spectra.')
        error = .true.
        return
      endif
    endif
    !
  else
    if (aver%do%resampling.eq.resample_user .or.  &
        aver%do%resampling.eq.resample_auto) then
      if (aver%done%align.ne.align_posi) then
        call class_message(seve%e,aver%do%rname,  &
          'Unsupported align mode for continuum.')
        error = .true.
        return
      endif
    endif
  endif
  !
end subroutine sumlin_init
!
subroutine sumlin_header_init(aver,refer,sumio,error)
  use phys_const
  use gkernel_interfaces
  use classcore_interfaces, except_this=>sumlin_header_init
  use class_parameter
  use class_averaging
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize the header of the output sum
  !---------------------------------------------------------------------
  type(average_t),   intent(in)    :: aver   !
  type(header),      intent(in)    :: refer  ! Spectrum to add
  type(observation), intent(inout) :: sumio  ! Future sum
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  real*8 :: Dv,Df
  !
  sumio%head = refer    ! Inherit all from 1st observation
  sumio%head%xnum = -1  ! Program-generated
  !
  ! General
  sumio%head%gen%num  = 0  ! Automatically set to an unused number at write time.
  sumio%head%gen%ver  = 0  ! Automatically incremented to 1 at write time.
  sumio%head%gen%time = 0.
  sumio%head%gen%az   = 0.
  sumio%head%gen%el   = 0.
! sumio%head%gen%scan =
  call sic_gagdate(sumio%head%gen%dred)  ! '0' date has no sense (-32768 = 10-DEC-1934)
  if (error)  return
  !
  ! Spectro. 'restf' of the sum is set here. Must be set definitely before
  ! the registration loop.
  if (aver%do%resampling.eq.resample_user) then
    !
    select case (aver%done%align)
    case(align_velo)  ! ALIGN VELOCITY
      sumio%head%spe%vres  = aver%do%axis%inc
      sumio%head%spe%voff  = aver%do%axis%val
      sumio%head%spe%rchan = aver%do%axis%ref
      sumio%head%spe%nchan = aver%do%axis%nchan
      ! Looking for corresponding 'restf' and 'fres'
      Dv = sumio%head%spe%voff-refer%spe%voff
      Df = -Dv/clight_kms*refer%spe%restf
      sumio%head%spe%restf = refer%spe%restf+Df
      sumio%head%spe%fres  = -sumio%head%spe%restf*sumio%head%spe%vres/clight_kms
      sumio%head%spe%doppler = 0.d0 ! We perform the resamplings in the rest frame,
                                    ! and the output spectrum is in the rest frame.
      !
    case(align_freq)  ! ALIGN FREQUENCY
      sumio%head%spe%fres  = aver%do%axis%inc/(1.d0+refer%spe%doppler)  ! In the rest frame
      sumio%head%spe%restf = aver%do%axis%val
      sumio%head%spe%rchan = aver%do%axis%ref
      sumio%head%spe%nchan = aver%do%axis%nchan
      ! Looking for corresponding 'voff' and 'vres'
      Df = sumio%head%spe%restf - refer%spe%restf
      Dv = -clight_kms*Df/sumio%head%spe%restf
      sumio%head%spe%voff = refer%spe%voff+Dv
      sumio%head%spe%vres = -clight_kms*sumio%head%spe%fres/sumio%head%spe%restf
      sumio%head%spe%doppler = 0.d0 ! We perform the resamplings in the rest frame,
                                    ! and the output spectrum is in the rest frame.
      !
    case(align_imag)  ! ALIGN IMAGE
      sumio%head%spe%fres  = -aver%do%axis%inc/(1.d0+refer%spe%doppler)  ! In the rest frame
      sumio%head%spe%image = aver%do%axis%val
      sumio%head%spe%rchan = aver%do%axis%ref
      sumio%head%spe%nchan = aver%do%axis%nchan
      ! Looking for corresponding 'voff' and 'vres'
      Df = sumio%head%spe%image - refer%spe%image
      Dv = -clight_kms*Df/sumio%head%spe%restf
      sumio%head%spe%voff = refer%spe%voff+Dv
      sumio%head%spe%vres = -clight_kms*sumio%head%spe%fres/sumio%head%spe%restf
      sumio%head%spe%doppler = 0.d0 ! We perform the resamplings in the rest frame,
                                    ! and the output spectrum is in the rest frame.
      !
    case(align_posi)  ! ALIGN POSITION
      sumio%head%dri%ares  = aver%do%axis%inc
      sumio%head%dri%aref  = aver%do%axis%val
      sumio%head%dri%rpoin = aver%do%axis%ref
      sumio%head%dri%npoin = aver%do%axis%nchan
      !
    end select
    !
  else
    ! Use the X axis of the 1st spectrum:
    ! sumio%head%spe = refer%spe  (already done)
    continue
  endif
  !
  ! Switching mode:
  ! Is duplicated from the first observation. If the full set is
  ! consistent in terms of switching mode, it will be kept. If not,
  ! it will be emptied with proper switching code.
  !
  ! Calibration. Will keep identical values and nullify otherwise.
  !
  ! History will be used to keep list of summed spectra
  sumio%head%presec(class_sec_his_id) = .false.  ! Not yet reimplemented
  !
  ! Disable the plot section since new limits will be probably
  ! very different
  sumio%head%presec(class_sec_plo_id) = .false.
  sumio%head%plo%amin = 0.  ! In addition of disabling the section,
  sumio%head%plo%amax = 0.  ! also reset the values since subroutine
  sumio%head%plo%vmin = 0.  ! newlimy looks at those values instead of
  sumio%head%plo%vmax = 0.  ! section present/not-present status.
  !
  ! Disable the Associated Array. We are far from being able to average them...
  sumio%head%presec(class_sec_assoc_id) = .false.
  call rzero_assoc(sumio)
  !
  ! Deactivate sections which have no meaning for the average
  if (aver%done%kind_is_spec) then
    sumio%head%presec(class_sec_dri_id) = .false.
  else
    sumio%head%presec(class_sec_spe_id) = .false.
  endif
  sumio%head%presec(class_sec_bas_id) = .false.  ! Sigma has no sense, windows may or not
  sumio%head%presec(class_sec_gau_id) = .false.
  sumio%head%presec(class_sec_she_id) = .false.
  sumio%head%presec(class_sec_hfs_id) = .false.
  sumio%head%presec(class_sec_abs_id) = .false.
  !
end subroutine sumlin_header_init
!
subroutine sumlin_init_variables(aver,refer,sumio,error)
  use gkernel_interfaces
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_init_variables
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize some global variables related to the output sum: running
  ! means, some extrema, and so on. Must be called *after* the
  ! I/O sum header is set.
  !---------------------------------------------------------------------
  type(average_t), intent(inout) :: aver   !
  type(header),    intent(in)    :: refer  ! Reference header
  type(header),    intent(in)    :: sumio  ! Future sum header
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  real(8) :: xs1,xs2
  !
  ! Doppler (running mean)
  if (aver%done%kind_is_spec)  sdoppler = 0.d0
  !
  ! Switching mode (running sum)
  smod = refer%swi%swmod
  !
  ! Integration time (running sum)
  stime = 0.d0
  !
  ! time*res/Tsys**2 (running sum)
  sweight = 0.d0
  !
  ! Elevation (running sum)
  selevation = 0.
  !
  ! Telescope name (running name)
  stele = sumio%gen%teles
  stele_c(:) = .true.  ! At start, compare the 12 characters
  !
  if (aver%done%kind_is_spec) then
    aver%done%axis%nchan = sumio%spe%nchan
    !
    ! Line name (running name)
    sline = sumio%spe%line
    sline_l = .true.
  else
    aver%done%axis%nchan = sumio%dri%npoin
  endif
  !
  ! Observation date-time
  call gag_gagut2mjd(sumio%gen%dobs,sumio%gen%ut,smjd,error)
  !
  ! Calibration section
  scal = refer%cal
  !
  ! X axis extrema
  select case (aver%done%align)
  case (align_freq)  ! SET ALIGN FREQUENCY. NB: work in single precision so
                     ! the sumio 'restf' is removed in the offset quantity.
    ! Doppler-corrected signal frequency axis
    aver%done%axis%unit = 'F'
    aver%done%axis%inc = sumio%spe%fres/(1.d0+sumio%spe%doppler)
    aver%done%axis%ref = 0.d0
    call abscissa_chan2sigoff(sumio,aver%done%axis%ref,aver%done%axis%val)
    call abscissa_sigoff_left(sumio,xs1)
    call abscissa_sigoff_right(sumio,xs2)
    sxmin = min(xs1,xs2)
    sxmax = max(xs1,xs2)
    !
    allrdopplermin = refer%spe%doppler
    allrdopplermax = refer%spe%doppler
    allrresomin = refer%spe%fres
    allrresomax = refer%spe%fres
    !
  case (align_imag)  ! SET ALIGN IMAGE. NB: work in single precision so
                     ! the sumio 'image' is removed in the offset quantity.
    ! Doppler-corrected image frequency axis
    aver%done%axis%unit = 'I'
    aver%done%axis%inc = -sumio%spe%fres/(1.d0+sumio%spe%doppler)
    aver%done%axis%ref = 0.d0
    call abscissa_chan2imaoff(sumio,aver%done%axis%ref,aver%done%axis%val)
    call abscissa_imaoff_left(sumio,xs1)
    call abscissa_imaoff_right(sumio,xs2)
    sxmin = min(xs1,xs2)
    sxmax = max(xs1,xs2)
    !
    allrdopplermin = refer%spe%doppler
    allrdopplermax = refer%spe%doppler
    allrresomin = - refer%spe%fres
    allrresomax = - refer%spe%fres
    !
  case (align_velo)  ! SET ALIGN VELOCITY
    aver%done%axis%unit = 'V'
    aver%done%axis%inc = sumio%spe%vres
    aver%done%axis%ref = 0.d0
    call abscissa_chan2velo(sumio,aver%done%axis%ref,aver%done%axis%val)
    call abscissa_velo_left(sumio,xs1)
    call abscissa_velo_right(sumio,xs2)
    sxmin = min(xs1,xs2)
    sxmax = max(xs1,xs2)
    !
    allrdopplermin = refer%spe%doppler
    allrdopplermax = refer%spe%doppler
    allrresomin = refer%spe%vres
    allrresomax = refer%spe%vres
    !
  case (align_posi)  ! SET ALIGN POSITION
    aver%done%axis%unit = 'P'
    aver%done%axis%inc = sumio%dri%ares
    aver%done%axis%ref = 0.d0
    call abscissa_chan2angl(sumio,aver%done%axis%ref,aver%done%axis%val)
    call abscissa_angl_left(sumio,xs1)
    call abscissa_angl_right(sumio,xs2)
    sxmin = min(xs1,xs2)
    sxmax = max(xs1,xs2)
    !
    allrresomin = refer%dri%ares
    allrresomax = refer%dri%ares
    !
  case default
    call class_message(seve%e,aver%do%rname,  &
      'Internal error, unsupported alignment')
    error = .true.
    return
  end select
  !
end subroutine sumlin_init_variables
!
subroutine sumlin_header_register(obs,refer,aver,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sumlin_header_register
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs    ! Spectrum to add
  type(observation), intent(in)    :: refer  ! The reference spectrum
  type(average_t),   intent(inout) :: aver   ! The new axis resolution may be updated on return
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=8) :: xr1,xr2,dfreq,rxmin,rxmax,rreso,omjd
  integer(kind=4) :: rnchan
  real(kind=4) :: weight
  logical :: error2
  !
  call sumlin_header_check(aver,obs,refer,error)
  if (error)  return
  !
  ! Keep track of important parameters
  if (aver%done%kind_is_spec) then
    rnchan = obs%head%spe%nchan
  else
    rnchan = obs%head%dri%npoin
  endif
  !
  ! Compute the resolution and increments of 'obs' according to the
  ! SET ALIGN method.
  select case(aver%done%align)
  case (align_freq)  ! SET ALIGN FREQUENCY. NB: work in single precision so the
                     ! refer 'restf' is removed in the offset quantity.
                     ! => This looks like a MODIFY FREQUENCY! (SB, 28-oct-2011)
    dfreq = obs%head%spe%restf - refer%head%spe%restf
    !
    ! Doppler-corrected signal frequency axis
    rreso = obs%head%spe%fres/(1.d0+obs%head%spe%doppler)
    xr1 = (                   .5d0-obs%head%spe%rchan)*rreso + dfreq
    xr2 = (obs%head%spe%nchan+.5d0-obs%head%spe%rchan)*rreso + dfreq
    rxmin = min(xr1,xr2)
    rxmax = max(xr1,xr2)
    !
    allrdopplermin = min(allrdopplermin,obs%head%spe%doppler)
    allrdopplermax = max(allrdopplermax,obs%head%spe%doppler)
    allrresomin = min(allrresomin,obs%head%spe%fres)
    allrresomax = max(allrresomax,obs%head%spe%fres)
    !
  case (align_imag)  ! SET ALIGN IMAGE. NB: work in single precision so the
                     ! refer 'image' is removed in the offset quantity.
                     ! => This looks like a MODIFY FREQUENCY! (SB, 28-oct-2011)
    dfreq = obs%head%spe%image - refer%head%spe%image
    !
    ! Doppler-corrected image frequency axis
    rreso = -obs%head%spe%fres/(1.d0+obs%head%spe%doppler)
    xr1 = (                   .5d0-obs%head%spe%rchan)*rreso + dfreq
    xr2 = (obs%head%spe%nchan+.5d0-obs%head%spe%rchan)*rreso + dfreq
    rxmin = min(xr1,xr2)
    rxmax = max(xr1,xr2)
    !
    allrdopplermin = min(allrdopplermin,obs%head%spe%doppler)
    allrdopplermax = max(allrdopplermax,obs%head%spe%doppler)
    allrresomin = min(allrresomin,-obs%head%spe%fres)
    allrresomax = max(allrresomax,-obs%head%spe%fres)
    !
  case (align_velo)  ! SET ALIGN VELOCITY
    rreso = obs%head%spe%vres
    call abscissa_velo_left(obs%head,xr1)
    call abscissa_velo_right(obs%head,xr2)
    rxmin = min(xr1,xr2)
    rxmax = max(xr1,xr2)
    !
    allrdopplermin = min(allrdopplermin,obs%head%spe%doppler)
    allrdopplermax = max(allrdopplermax,obs%head%spe%doppler)
    allrresomin = min(allrresomin,obs%head%spe%vres)
    allrresomax = max(allrresomax,obs%head%spe%vres)
    !
  case (align_posi)  ! SET ALIGN POSITION
    rreso = dble(obs%head%dri%ares)
    call abscissa_angl_left(obs%head,xr1)
    call abscissa_angl_right(obs%head,xr2)
    rxmin = min(xr1,xr2)
    rxmax = max(xr1,xr2)
    !
    allrresomin = min(allrresomin,obs%head%dri%ares)
    allrresomax = max(allrresomax,obs%head%dri%ares)
    !
  case default
    call class_message(seve%e,aver%do%rname,  &
      'Internal error, unsupported alignment')
    error = .true.
    return
  end select
  !
  ! Compute the new X range
  if (aver%done%composite) then  ! COMPOSITE
    sxmin = min(rxmin,sxmin)
    sxmax = max(rxmax,sxmax)
  else                 ! INTERSECT
    sxmin = max(rxmin,sxmin)
    sxmax = min(rxmax,sxmax)
    if (sxmin.ge.sxmax) then
      call class_message(seve%e,aver%do%rname,  &
        trim(align_name(aver%done%align))//' ranges do not intersect')
      error = .true.
      return
    endif
  endif
  !
  ! Compute the new resolution (can be positive or negative)
  if (abs(aver%done%axis%inc).lt.abs(rreso)) then
    if (aver%do%resampling.eq.resample_user) then
      ! User has made his choice: nothing to be done
    elseif (aver%do%resampling.eq.resample_auto) then
      aver%done%axis%inc = rreso
    elseif (aver%do%resampling.eq.resample_no) then
      ! Can not happen, X axes compatibility has been tested above.
    endif
  endif
  !
  ! Check for the output switching mode
  if (obs%head%swi%swmod.ne.smod)  smod = mod_mix
  !
  ! Compute the new integration time
  stime = stime + obs%head%gen%time
  !
  ! Compute the new elevation
  selevation = selevation + obs%head%gen%el
  !
  ! Compute the new telescope name
  call sumlin_header_telescope(obs%head%gen%teles,stele_c,stele)
  !
  ! Compute the new sum of time*res/tsys^2 (and new Doppler factor if spectro)
  error2 = .false.
  call obs_weight_time(aver%do%rname,obs,weight,error2,verbose=.false.)
  if (.not.error2)  sweight = sweight + weight  ! Not a fatal error
  if (aver%done%kind_is_spec) then
    sdoppler = sdoppler + obs%head%spe%doppler
    ! Compute the new line name
    if (sline_l) then
      if (obs%head%spe%line.ne.sline) then
        sline = 'Unknown'
        sline_l = .false.
      endif
    endif
  endif
  !
  ! Observation date-time: use the greatest of all observations, because
  ! 1) there is no '0' gag_date
  ! 2) today is not really useful, some information is lost. One value chosen
  !    in the real observation dates is more relevant
  ! 3) the greatest one has the advantage to indicate when the average was last
  !    done, in particular when observing over several days.
  call gag_gagut2mjd(obs%head%gen%dobs,obs%head%gen%ut,omjd,error)
  smjd = max(smjd,omjd)
  !
  ! Calibration section. Note that the consistency of beeff, foeff and
  ! gaini is checked by default.
  call compare_and_set_r4(obs%head%cal%beeff,   scal%beeff)
  call compare_and_set_r4(obs%head%cal%foeff,   scal%foeff)
  call compare_and_set_r4(obs%head%cal%gaini,   scal%gaini)
  call compare_and_set_r4(obs%head%cal%h2omm,   scal%h2omm)
  call compare_and_set_r4(obs%head%cal%pamb,    scal%pamb)
  call compare_and_set_r4(obs%head%cal%tamb,    scal%tamb)
  call compare_and_set_r4(obs%head%cal%tatms,   scal%tatms)
  call compare_and_set_r4(obs%head%cal%tchop,   scal%tchop)
  call compare_and_set_r4(obs%head%cal%tcold,   scal%tcold)
  call compare_and_set_r4(obs%head%cal%taus,    scal%taus)
  call compare_and_set_r4(obs%head%cal%taui,    scal%taui)
  call compare_and_set_r4(obs%head%cal%tatmi,   scal%tatmi)
  call compare_and_set_r4(obs%head%cal%trec,    scal%trec)
  call compare_and_set_i4(obs%head%cal%cmode,   scal%cmode)
  call compare_and_set_r4(obs%head%cal%atfac,   scal%atfac)
  call compare_and_set_r4(obs%head%cal%alti,    scal%alti)
  call compare_and_set_r4(obs%head%cal%count(1),scal%count(1))
  call compare_and_set_r4(obs%head%cal%count(2),scal%count(2))
  call compare_and_set_r4(obs%head%cal%count(3),scal%count(3))
  call compare_and_set_r4(obs%head%cal%lcalof,  scal%lcalof)
  call compare_and_set_r4(obs%head%cal%bcalof,  scal%bcalof)
  call compare_and_set_r8(obs%head%cal%geolong, scal%geolong)
  call compare_and_set_r8(obs%head%cal%geolat,  scal%geolat)
  !
  ! New History
  ! call add_history_new(obs,sumin,sumout)  ZZZ
  !
contains
  subroutine compare_and_set_r4(in,out)
    !-------------------------------------------------------------------
    ! If in and out are not equal, nullify the out value.
    ! R*4 version.
    !-------------------------------------------------------------------
    real(kind=4), intent(in)    :: in
    real(kind=4), intent(inout) :: out
    if (out.eq.0.)                  return  ! Already nullified
    if (nearly_equal(in,out,1e-6))  return  ! They are equal
    out = 0.                                ! They are not equal
  end subroutine compare_and_set_r4
  subroutine compare_and_set_r8(in,out)
    !-------------------------------------------------------------------
    ! If in and out are not equal, nullify the out value.
    ! R*8 version.
    !-------------------------------------------------------------------
    real(kind=8), intent(in)    :: in
    real(kind=8), intent(inout) :: out
    if (out.eq.0.d0)                return  ! Already nullified
    if (nearly_equal(in,out,1d-6))  return  ! They are equal
    out = 0.d0                              ! They are not equal
  end subroutine compare_and_set_r8
  subroutine compare_and_set_i4(in,out)
    !-------------------------------------------------------------------
    ! If in and out are not equal, nullify the out value.
    ! I*4 version.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: in
    integer(kind=4), intent(inout) :: out
    if (out.eq.0)   return  ! Already nullified
    if (in.eq.out)  return  ! They are equal
    out = 0                 ! They are not equal
  end subroutine compare_and_set_i4
end subroutine sumlin_header_register
!
subroutine sumlin_header_check(aver,obs,refer,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>sumlin_header_check
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(average_t),   intent(in)    :: aver   !
  type(observation), intent(in)    :: obs    ! The new spectrum
  type(observation), intent(in)    :: refer  ! The reference spectrum
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  real(kind=4) :: weight
  !
  ! The test below is disabled since because of all the optimizations
  ! we are not able to check xnum at this stage (header has been read but
  ! not the data).
  ! if (obs%head%xnum.eq.0) then
  !   call class_message(seve%e,aver%do%rname,'No spectrum in input observation')
  !   error = .true.
  !   goto 100
  ! endif
  !
  ! Irregularly sampled data
  if (obs%head%presec(class_sec_xcoo_id)) then
    call class_message(seve%e,aver%do%rname,  &
      'Irregularly sampled data not yet supported')
    error = .true.
    goto 100
  endif
  !
  if (aver%done%kind_is_spec) then
    ! Doppler
    if (obs%head%spe%doppler.eq.-1.d0) then
      ! This should never happen
      call class_message(seve%e,aver%do%rname,'No Doppler factor defined')
      error = .true.
      goto 100
    endif
    ! Frequency compatibility
    if (obs%head%spe%vtype.ne.refer%head%spe%vtype) then
      mess = 'Input spectra have different velocity definitions'
      call class_message(seve%w,aver%do%rname,mess)
    endif
  endif
  !
  ! Check the header values for the future observation weight. At this stage this
  ! is needed only for the sanity checks. We will compute them again when actually
  ! needed when averaging data, but we keep this here in order to raise the error
  ! asap, in the header loop.
  select case (aver%done%weight)
  case (weight_sigma)  ! Sigma weighting
    call obs_weight_sigma(aver%do%rname,obs,weight,error)
    !
  case (weight_time)  ! Time weighting
    call obs_weight_time(aver%do%rname,obs,weight,error)
    !
  case (weight_equal)  ! Equal weighting
    continue  ! Nothing to check
    !
  case (weight_assoc)  ! From 'W' Associated Array
    if (.not.class_assoc_exists(obs,'W')) then
      call class_message(seve%e,aver%do%rname,  &
        'No Associated Array ''W'' while SET WEIGHT is ASSOC')
      error = .true.
    endif
    !
  case default
    call class_message(seve%e,aver%do%rname,'Internal error, unknown weighting')
    error = .true.
  end select
  if (error)  goto 100
  return
  !
100 continue
  write(mess,'(A,I0)')  'Invalid header for observation #',obs%head%gen%num
  call class_message(seve%e,aver%do%rname,mess)
  !
end subroutine sumlin_header_check
!
subroutine sumlin_header_xaxis(set,aver,sumio,nobs,error)
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_header_xaxis
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !  Set the global variables defining the X axis of the output sum.
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set    !
  type(average_t),            intent(inout) :: aver   !
  type(observation),          intent(inout) :: sumio  ! I/O sum
  integer(kind=entry_length), intent(in)    :: nobs   ! Number of observations averaged
  logical,                    intent(inout) :: error  ! Logical error flag
  !
  if (nobs.le.0) then
    error = .true.
    call class_message(seve%e,aver%do%rname,'Internal error, Nobs<=0')
    return
  endif
  !
  if (aver%do%resampling.eq.resample_auto .and. .not.aver%done%resample) then
    ! Resampling is still disabled after consistency checks in sumlin_header
    call class_message(seve%i,aver%do%rname,   &
      trim(align_name(aver%done%align))//  &
      ' axes match, no resampling will be performed')
  endif
  !
  call sumlin_header_xaxis_compute(aver,sumio,nobs,error)
  if (error)  return
  !
  call sumlin_header_xaxis_feedback(set,aver,sumio)
  !
end subroutine sumlin_header_xaxis
!
subroutine sumlin_header_xaxis_compute(aver,sumio,nobs,error)
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_header_xaxis_compute
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(average_t),            intent(inout) :: aver   !
  type(observation),          intent(inout) :: sumio  ! I/O sum
  integer(kind=entry_length), intent(in)    :: nobs   ! Number of observations averaged
  logical,                    intent(inout) :: error  ! Logical error flag
  !
  ! Axis redefinition, if any
  if (aver%do%resampling.eq.resample_auto .and. aver%done%resample) then
    ! AUTOMATIC resampling to the coarsest resolution
    call sumlin_header_xaxis_resample(aver,sumio,error)
    if (error)  return
  endif
  ! If USER resampling: Nothing to do: all has been set before.
  ! if NO resampling: Channel alignment. Only 'aver%done%axis%nchan' is
  !                   required in 'simple_waverage'. It is already set.
  !
  ! Update the output header
  !
  ! Switching
  if (smod.eq.mod_mix) then
    call class_message(seve%w,aver%do%rname,'Mixed switching modes')
    sumio%head%swi%swmod = mod_mix
    sumio%head%swi%nphas = 0
    sumio%head%swi%decal = 0.d0
    sumio%head%swi%duree = 0.
    sumio%head%swi%poids = 0.
    sumio%head%swi%ldecal = 0.
    sumio%head%swi%bdecal = 0.
  endif
  !
  ! General
  sumio%head%gen%el = selevation/nobs
  sumio%head%gen%time = stime
  sumio%head%gen%teles = stele
  call gag_mjd2gagut(smjd,sumio%head%gen%dobs,sumio%head%gen%ut,error)
  if (error)  return
  ! Recompute Tsys (after time and swmod are set)
  if (aver%done%kind_is_spec) then
    call obs_tsys_time(aver%do%rname,sumio,sweight,error)
    if (error)  return
  else
    call obs_tsys_time(aver%do%rname,sumio,sweight,error)
    if (error)  return
  endif
  !
  ! Spectro
  if (aver%done%kind_is_spec) then
    if (.not.aver%done%resample) then
      ! X axes match
      ! In these cases the input Doppler factors were not taken into
      ! account in the input resolutions. On return the output
      ! spectrum must have a non-zero Doppler factor.
      sdoppler = sdoppler/nobs
    else
      sdoppler = 0.d0
    endif
    sumio%head%spe%doppler = sdoppler
    sumio%head%spe%nchan = aver%done%axis%nchan
    sumio%head%spe%line = sline
  else
    sumio%head%dri%npoin = aver%done%axis%nchan
  endif
  if (aver%do%range) then
    ! Now that the spectroscopic axis is fully set (including Doppler),
    ! apply range cut
    call sumlin_header_xaxis_range(aver,sumio,error)
    if (error)  return
  endif
  !
  ! Calibration
  sumio%head%cal = scal
end subroutine sumlin_header_xaxis_compute
!
subroutine sumlin_header_xaxis_resample(aver,sumio,error)
  use phys_const
  use classcore_interfaces, except_this=>sumlin_header_xaxis_resample
  use class_types
  use class_averaging
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !  AUTOMATIC resampling of the header to the coarsest resolution <=>
  ! all but channel alignment.
  !---------------------------------------------------------------------
  type(average_t),   intent(inout) :: aver   !
  type(observation), intent(inout) :: sumio  ! I/O sum
  logical,           intent(inout) :: error  ! Logical error flag
  !
  ! Output number of channels. NB: sxmin is the left side of the 1st channel,
  ! and sxmax the right side of the last channel
  aver%done%axis%nchan = ceiling((sxmax-sxmin)/abs(aver%done%axis%inc))
  !
  aver%done%axis%ref = 0.d0
  if (aver%done%axis%inc.lt.0.d0) then
    aver%done%axis%val = sxmax - aver%done%axis%inc/2.d0  ! Value at center of channel #0
  else
    aver%done%axis%val = sxmin - aver%done%axis%inc/2.d0  ! Value at center of channel #0
  endif
  !
  select case(aver%done%align)
  case(align_velo)  ! ALIGN VELOCITY
    sumio%head%spe%vres  = aver%done%axis%inc
    sumio%head%spe%rchan = (sumio%head%spe%voff-aver%done%axis%val)/aver%done%axis%inc
    sumio%head%spe%fres  = -sumio%head%spe%restf*sumio%head%spe%vres/clight_kms
    sumio%head%spe%nchan = aver%done%axis%nchan
    !
  case(align_freq)  ! ALIGN FREQUENCY
    sumio%head%spe%fres  = aver%done%axis%inc
    sumio%head%spe%rchan = -aver%done%axis%val/aver%done%axis%inc
    sumio%head%spe%vres  = -clight_kms*sumio%head%spe%fres/sumio%head%spe%restf
    sumio%head%spe%nchan = aver%done%axis%nchan
    !
  case(align_imag)  ! ALIGN IMAGE
    sumio%head%spe%fres  = -aver%done%axis%inc  ! Warning: fres has the _signal_ frequency sign!
    sumio%head%spe%rchan = -aver%done%axis%val/aver%done%axis%inc
    sumio%head%spe%vres  = -clight_kms*sumio%head%spe%fres/sumio%head%spe%restf  ! Velocity
    sumio%head%spe%nchan = aver%done%axis%nchan
    ! resolution is always in the signal band in Class.
    !
  case(align_posi)  ! ALIGN POSITION
    sumio%head%dri%ares = aver%done%axis%inc
    sumio%head%dri%rpoin = (sumio%head%dri%aref-aver%done%axis%val)/aver%done%axis%inc
    sumio%head%dri%npoin = aver%done%axis%nchan
    !
  end select
  !
end subroutine sumlin_header_xaxis_resample
!
subroutine sumlin_header_xaxis_range(aver,sumio,error)
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_header_xaxis_range
  use class_averaging
  use class_types
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !  Apply a range cut. The range unit can be in any unit (i.e. other
  ! than aver%done%align)
  !  NB: the sumio spectroscopic axis must have been fully set
  ! (resolution, Doppler, etc) so that it is usable with the abscissa
  ! routines
  !---------------------------------------------------------------------
  type(average_t),   intent(inout) :: aver   !
  type(observation), intent(inout) :: sumio  ! I/O sum
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=8) :: ch1,ch2,uchmin,uchmax,schmin,schmax,ux1,ux2
  character(len=message_length) :: mess
  !
  ! Convert user range to channels
  select case(aver%do%rangeval%unit)
  case('C')
    ch1 = aver%do%rangeval%xmin
    ch2 = aver%do%rangeval%xmax
  case('V')
    call abscissa_velo2chan(sumio%head,aver%do%rangeval%xmin,ch1)
    call abscissa_velo2chan(sumio%head,aver%do%rangeval%xmax,ch2)
  case('F')
    call abscissa_sigabs2chan(sumio%head,aver%do%rangeval%xmin,ch1)
    call abscissa_sigabs2chan(sumio%head,aver%do%rangeval%xmax,ch2)
  case('I')
    call abscissa_imaabs2chan(sumio%head,aver%do%rangeval%xmin,ch1)
    call abscissa_imaabs2chan(sumio%head,aver%do%rangeval%xmax,ch2)
  case('P')
    call abscissa_angl2chan(sumio%head,aver%do%rangeval%xmin,ch1)
    call abscissa_angl2chan(sumio%head,aver%do%rangeval%xmax,ch2)
  case default
    call class_message(seve%e,aver%do%rname,'Range unit not supported here')
    error = .true.
    return
  end select
  uchmin = min(ch1,ch2)
  uchmax = max(ch1,ch2)
  !
  ! Convert sum range to channels, and convert user range to working unit
  select case(aver%done%align)
  case(align_velo)  ! ALIGN VELOCITY
    call abscissa_velo2chan(sumio%head,sxmin,ch1)
    call abscissa_velo2chan(sumio%head,sxmax,ch2)
    call abscissa_chan2velo(sumio%head,uchmin,ux1)
    call abscissa_chan2velo(sumio%head,uchmax,ux2)
  case(align_freq)  ! ALIGN FREQUENCY
    call abscissa_sigoff2chan(sumio%head,sxmin,ch1)
    call abscissa_sigoff2chan(sumio%head,sxmax,ch2)
    call abscissa_chan2sigoff(sumio%head,uchmin,ux1)
    call abscissa_chan2sigoff(sumio%head,uchmax,ux2)
  case(align_imag)  ! ALIGN IMAGE
    call abscissa_imaoff2chan(sumio%head,sxmin,ch1)
    call abscissa_imaoff2chan(sumio%head,sxmax,ch2)
    call abscissa_chan2imaoff(sumio%head,uchmin,ux1)
    call abscissa_chan2imaoff(sumio%head,uchmax,ux2)
  case(align_posi)  ! ALIGN POSITION
    call abscissa_angl2chan(sumio%head,sxmin,ch1)
    call abscissa_angl2chan(sumio%head,sxmax,ch2)
    call abscissa_chan2angl(sumio%head,uchmin,ux1)
    call abscissa_chan2angl(sumio%head,uchmax,ux2)
  end select
  schmin = min(ch1,ch2)
  schmax = max(ch1,ch2)
  !
  if (uchmax.lt.schmin .or. uchmin.gt.schmax) then
    ! ZZZ can this check be moved in 'sumlin_header_register'? i.e. can
    ! we reject the whole index as soon we know nothing will intersect
    ! with user's range? Probably yes if intersection mode, no if
    ! composition.
    write(mess,'(A,2(F0.4,1X),A,A)')  &
      'Requested range (',aver%do%rangeval%xmin,aver%do%rangeval%xmax,  &
      aver%do%rangeval%unit,') does not intersect the whole spectra range'
    call class_message(seve%e,aver%do%rname,mess)
    error = .true.
    return
  endif
  !
  if (aver%done%resample) then
    ! Resampling is needed. Let sumlin_header_xaxis_resample recompute
    ! the axis with the new limits
    sxmin = min(ux1,ux2)
    sxmax = max(ux1,ux2)
    call sumlin_header_xaxis_resample(aver,sumio,error)
    if (error)  return
  else
    ! No resampling needed. Just "extract" (ceiling/floor in order
    ! to keep the grids ligned - same as do_extract-)
    aver%done%axis%nchan = ceiling(uchmax)-floor(uchmin)+1
    if (aver%done%kind_is_spec) then
      sumio%head%spe%nchan = aver%done%axis%nchan
      sumio%head%spe%rchan = sumio%head%spe%rchan-floor(uchmin)+1.d0
      aver%done%axis%ref = sumio%head%spe%rchan
    else
      sumio%head%dri%npoin = aver%done%axis%nchan
      sumio%head%dri%rpoin = sumio%head%spe%rchan-floor(uchmin)+1.d0
      aver%done%axis%ref = sumio%head%dri%rpoin
    endif
    ! Enable the resampling flag. Subroutine 'do_resample' (used by
    ! TABLE) is clever enough to make a resampling or an extraction
    ! if grids are aligned (we took care of this just above)
    ! ZZZ This has to be implemented if the option /RANGE is added
    ! to other commands
    aver%done%resample = .true.
  endif
  !
end subroutine sumlin_header_xaxis_range
!
subroutine sumlin_header_xaxis_feedback(set,aver,sumio)
  use gbl_message
  use classcore_interfaces, except_this=>sumlin_header_xaxis_feedback
  use class_averaging
  use class_types
  use class_setup_new
  use sumlin_mod_first
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set    !
  type(average_t),     intent(in) :: aver   !
  type(observation),   intent(in) :: sumio  !
  ! Local
  character(len=message_length) :: mess
  real(kind=8) :: v1,v2,f1,f2
  !
  if (.not.aver%done%resample) then
    write(mess,'(a)') 'Channel alignment, no resampling:'
  else
    if (aver%do%resampling.eq.resample_auto) then
      write(mess,'(2a)') trim(align_name(aver%done%align)),  &
        ' alignment, automatic resampling:'
    elseif (aver%do%resampling.eq.resample_user) then
      write(mess,'(2a)') trim(align_name(aver%done%align)),  &
        ' alignment, custom resampling:'
    endif
  endif
  call class_message(seve%r,aver%do%rname,mess)
  !
  ! Input axes statistics
  call class_message(seve%r,aver%do%rname,'- Input axes:')
  if (aver%done%kind_is_spec) then
    if (allrdopplermin.eq.allrdopplermax) then
      write(mess,105) 'Doppler:',allrdopplermin
    else
      write(mess,106) 'Doppler:',allrdopplermin,allrdopplermax
    endif
    call class_message(seve%r,aver%do%rname,mess)
  endif
  if (aver%done%resample) then
    if (allrresomin.eq.allrresomax) then
      write(mess,103)  'Resolution:',allrresomin,align_unit(aver%done%align)
    else
      write(mess,104)  'Resolution:',allrresomin,allrresomax,align_unit(aver%done%align)
    endif
    call class_message(seve%r,aver%do%rname,mess)
  endif
  !
  ! Output axis definition
  call class_message(seve%r,aver%do%rname,'- Output axis:')
  if (aver%do%resampling.eq.resample_auto .and. aver%done%resample) then
    if (aver%done%kind_is_spec) then
      ! Always display F and V ranges
      call abscissa_sigabs_left(sumio%head,f1)
      call abscissa_sigabs_right(sumio%head,f2)
      write(mess,102) 'Frequency range:',f1,f2,align_unit(align_freq)
      call class_message(seve%r,aver%do%rname,mess)
      call abscissa_velo_left(sumio%head,v1)
      call abscissa_velo_right(sumio%head,v2)
      write(mess,102) 'Velocity range:',v1,v2,align_unit(align_velo)
      call class_message(seve%r,aver%do%rname,mess)
      if (aver%done%align.eq.align_imag) then
        ! Image range only if the working unit
        call abscissa_imaabs_left(sumio%head,f1)
        call abscissa_imaabs_right(sumio%head,f2)
        write(mess,102) 'Image range:',f1,f2,align_unit(align_imag)
        call class_message(seve%r,aver%do%rname,mess)
      endif
    else
      ! Print range in requested unit
      write(mess,102) trim(align_name(aver%done%align))//' range:',  &
        sxmin,sxmax,align_unit(aver%done%align)
      call class_message(seve%r,aver%do%rname,mess)
    endif
  endif
  write(mess,201) 'Nchan:',aver%done%axis%nchan
  call class_message(seve%r,aver%do%rname,mess)
  if (aver%done%kind_is_spec) then
    write(mess,101) 'Rchan:',sumio%head%spe%rchan
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,101) 'Restf:',sumio%head%spe%restf,align_unit(align_freq)
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,101) 'Image:',sumio%head%spe%image,align_unit(align_imag)
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,103) 'Fres:',sumio%head%spe%fres,align_unit(align_freq)
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,105) 'Doppler:',sumio%head%spe%doppler
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,101) 'Voff:',sumio%head%spe%voff,align_unit(align_velo)
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,103) 'Vres:',sumio%head%spe%vres,align_unit(align_velo)
    call class_message(seve%r,aver%do%rname,mess)
  else
    write(mess,101) 'Rpoin:',sumio%head%dri%rpoin
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,103) 'Ares:',class_setup_get_fangle()*sumio%head%dri%ares
    call class_message(seve%r,aver%do%rname,mess)
    write(mess,103) 'Aref:',class_setup_get_fangle()*sumio%head%dri%aref
    call class_message(seve%r,aver%do%rname,mess)
  endif
  !
  ! Floats, 3 digits
101 format(4x,a,1x,f0.3,1x,a)
102 format(4x,a,1x,'from',1x,f0.3,1x,'to',1x,f0.3,1x,a)
  ! Floats, 6 digits
103 format(4x,a,1x,f0.6,1x,a)
104 format(4x,a,1x,'from',1x,f0.6,1x,'to',1x,f0.6,1x,a)
  ! Floats, 5 significative digits
105 format(4x,a,1x,1pg12.5,1x,a)
106 format(4x,a,1x,'from',1x,1pg12.5,1x,'to',1x,1pg12.5,1x,a)
  ! Integers
201 format(4x,a,1x,i0,1x,a)
! 202 format(4x,a,1x,'from',1x,i12,1x,'to',1x,i12,1x,a)
  !
end subroutine sumlin_header_xaxis_feedback
!
subroutine add_history_new(in1,in2,out)
  use class_types
  use gbl_message
  use classcore_interfaces, except_this=>add_history_new
  !---------------------------------------------------------------------
  ! @ private
  ! Add histories input observations into output observation
  ! * nseq     : the number of sequences of consecutive scan numbers
  ! * start(i) : the first scan of sequence 'i'
  ! * end(i)   : the last  scan of sequence 'i'
  !---------------------------------------------------------------------
  type (observation), intent(inout) :: in1  ! New observation
  type (observation), intent(inout) :: in2  ! Old sum
  type (observation), intent(inout) :: out  ! New sum
  ! Local
  integer :: ir,it,i
  !
  ! Origin of spectra
  if (in1%head%his%nseq.eq.0) then
     in1%head%his%nseq     = 1
     in1%head%his%start(1) = in1%head%gen%scan
     in1%head%his%end(1)   = in1%head%gen%scan
  endif
  if (in2%head%his%nseq.eq.0) then
     in2%head%his%nseq     = 1
     in2%head%his%start(1) = in2%head%gen%scan
     in2%head%his%end(1)   = in2%head%gen%scan
  endif
  !
  out%head%his%nseq = 0
  it = 1
  ir = 1
  !
90 continue
  if (it.gt.in2%head%his%nseq) goto 91  ! on first passage, false
  if (ir.gt.in1%head%his%nseq) goto 92  ! on first passage, false
  if (in2%head%his%start(it).gt.in1%head%his%start(ir)) goto 91
  !
  ! start(in2) <= start(in1)
92 continue
  if (out%head%his%nseq.eq.0) then
     out%head%his%nseq     = 1
     out%head%his%start(1) = in2%head%his%start(it)
     out%head%his%end(1)   = in2%head%his%end(it)
  elseif (out%head%his%end(out%head%his%nseq).lt.in2%head%his%start(it)-1) then
     ! new interval
     if(out%head%his%nseq.eq.mseq) go to 925
     out%head%his%nseq = out%head%his%nseq+1
     out%head%his%start(out%head%his%nseq) = in2%head%his%start(it)
     out%head%his%end(out%head%his%nseq)   = in2%head%his%end(it)
  else
     ! extend current interval
     out%head%his%end(out%head%his%nseq) = &
          max(out%head%his%end(out%head%his%nseq),in2%head%his%end(it))
  endif
  it = it+1
  goto 90
  !
  ! start(in2) > start(in1)
91 continue
  if (ir.gt.in1%head%his%nseq) goto 93
  if (out%head%his%nseq.eq.0) then
     out%head%his%nseq = 1
     out%head%his%start(out%head%his%nseq) = in1%head%his%start(ir)
     out%head%his%end(out%head%his%nseq)   = in1%head%his%end(ir)
  else if (out%head%his%end(out%head%his%nseq).lt.in1%head%his%start(ir)-1) then
     if (out%head%his%nseq.eq.mseq) go to 925
     out%head%his%nseq = out%head%his%nseq+1
     out%head%his%start(out%head%his%nseq) = in1%head%his%start(ir)
     out%head%his%end(out%head%his%nseq)   = in1%head%his%end(ir)
  else
     out%head%his%end(out%head%his%nseq) =  &
          max(out%head%his%end(out%head%his%nseq),in1%head%his%end(ir))
  endif
  ir = ir+1
  goto 90
  !
  ! Overflow
925 call class_message(seve%w,'ADD_HISTORY_NEW','Origin table overflow. Cannot store history.')
  !
  ! End
93 continue
  do i=1,out%head%his%nseq
     in1%head%his%start(i) = out%head%his%start(i)
     in1%head%his%end(i)   = out%head%his%end(i)
  enddo
  in1%head%his%nseq = out%head%his%nseq
end subroutine add_history_new
!
subroutine sumlin_header_telescope(addteles,dochars,aveteles)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute an average telescope name from input name and current
  ! running average. In practice, individual characters are preserved as
  ! long as they are identical. They are changed to "-" of they differ.
  ! For example:
  !   30ME0HLI-W01
  ! + 30ME0VLO-W01
  ! = 30ME0-L--W01
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: addteles     ! The telescope to be added
  logical,          intent(inout) :: dochars(12)  ! Remaining characters to be checked
  character(len=*), intent(inout) :: aveteles     ! The running sum
  ! Local
  integer(kind=4) :: ic
  !
  do ic=1,12
    if (dochars(ic)) then
      if (aveteles(ic:ic).ne.addteles(ic:ic)) then
        aveteles(ic:ic) = '-'
        dochars(ic) = .false.
      endif
    endif
  enddo
  !
  if (.not.any(dochars))  aveteles = 'Unknown'
  !
end subroutine sumlin_header_telescope
!
!-----------------------------------------------------------------------
! ZZZ Include this for the continuum
!   !
!   ! Incorporate offset projection along the drift into value at reference pixel:
!   ! Project offsets onto drift system
!   cosa = cos(r%head%dri%apos)
!   sina = sin(r%head%dri%apos)
!   along = +r%head%pos%lamof*cosa+r%head%pos%betof*sina
!   perp  = -r%head%pos%betof*sina+r%head%pos%betof*cosa
!   ! Include projection of offsets along the drift into position at reference
!   ! pixel, and reproject the perpendicular component onto original system
!   r%head%dri%aref = r%head%dri%aref+along
!   r%head%pos%lamof = -perp*sina
!   r%head%pos%betof = +perp*cosa
!   ! Bring  the position angle difference back to [-PI/2,PI/2]
!   if (r%head%dri%apos.ge.t%head%dri%apos) then
!      i = nint((r%head%dri%apos-t%head%dri%apos)/pi)
!      r%head%dri%apos = r%head%dri%apos-i*pi
!   else
!      i = nint((t%head%dri%apos-r%head%dri%apos)/pi)
!      r%head%dri%apos = r%head%dri%apos+i*pi
!   endif
!   if (mod(i,2).eq.1) then
!      r%head%dri%aref = -r%head%dri%aref
!      r%head%dri%ares = -r%head%dri%ares
!   endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CLASSIC messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module classic_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer(kind=4) :: classic_message_id = gpack_global_id  ! Default value for startup message
  !
end module classic_message_private
!
subroutine classic_message_set_id(id)
  use gbl_message
  use classic_interfaces, except_this=>classic_message_set_id
  use classic_message_private
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: id         !
  ! Local
  character(len=message_length) :: mess
  !
  classic_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',classic_message_id
  call classic_message(seve%d,'classic_message_set_id',mess)
  !
end subroutine classic_message_set_id
!
subroutine classic_message(mkind,procname,message)
  use gkernel_interfaces
  use classic_message_private
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(classic_message_id,mkind,procname,message)
  !
end subroutine classic_message
!
subroutine classic_iostat(mkind,procname,ier)
  use gbl_message
  use gkernel_interfaces
  use classic_interfaces, except_this=>classic_iostat
  !---------------------------------------------------------------------
  ! @ private
  ! Output system message corresponding to IO error code IER, and
  ! using the MESSAGE routine
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message severity
  character(len=*), intent(in) :: procname  ! Calling routine name
  integer,          intent(in) :: ier       ! IO error number
  ! Local
  character(len=message_length) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call classic_message(mkind,procname,msg)
  !
end subroutine classic_iostat
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine load_map(error)
  use gkernel_interfaces
  use xymap_def
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! MAP initialization routine:
  ! MAP language is loaded.
  !---------------------------------------------------------------------
  logical, intent(out) :: error     ! Error status
  ! Local
  integer(kind=4), parameter :: mmap=3 ! MAP Language
  character(len=12) :: vocab_map(mmap)
  character(len=76) :: version
  !
  external :: run_map
  !
  data version /'0.2 22-Oct-2008 J.P.'/
  data vocab_map / &
       ' XY_MAP', '/NOGRID','/TYPE' /
!      ' APODISE', &
!      ' DECONVOLVE'/
  !
  error = gterrtst()
  call sic_begin('MAP','GAG_HELP_MAP',mmap,vocab_map,version,run_map,gterrtst)
  !
  call init_xymap_struct(sic_xymap_user)
  call define_sic_xymap(error)
  !
end subroutine load_map
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine run_map(line,comm,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! MAP Main library entry point
  !     Call appropriate subroutine according to COMM
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  character(len=*), intent(in)  :: comm   ! Command name
  logical,          intent(out) :: error  ! Error status
  ! Local
  character(len=80) :: mess
  !
  call class_message(seve%c,'MAP',line)
  !
  if (comm.eq.'XY_MAP') then
     call xymap(line,error)
!!$  elseif (comm.eq.'APODISE') then
!!$     !
!!$  elseif (comm.eq.'DECONVOLVE') then
!!$     !
  else
     mess = 'MAP'//char(92)//comm//' Unknown command'
     call class_message(seve%e,'MAP',mess)
     error = .true.
  endif
  !
end subroutine run_map
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine noema_spectral_sweep(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_spectral_sweep
  use ast_astro
  use my_receiver_globals
  use astro_specsweep_types
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Command to prepare multi-tuning spectral observations with NOEMA
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='SPECSWEEP'
  integer(kind=4), parameter :: i_optrange=1
  integer(kind=4), parameter :: i_optmaxband=2
  integer(kind=4), parameter :: i_optntuning=3
  integer(kind=4), parameter :: i_optzoom=4
  integer(kind=4), parameter :: i_optfile=5
  integer(kind=4), parameter :: i_optadd=6
  integer(kind=4), parameter :: margrange=2
  integer(kind=4), parameter :: margntuning=3
  logical, parameter :: doonline=.false.
  logical, parameter :: dotime=.false.
  real(kind=4), parameter :: resmed=250.0
  real(kind=4), parameter :: reslow=2000.0
  real(kind=4), parameter :: reshigh1=62.50
  real(kind=4) :: resuser
  type(noema_spsweep_t) :: ssweep
  real(kind=8) :: fs1,fs2
  character(len=filename_length) :: file,argum,file2
  integer(kind=4),parameter :: m_add=2 ! max number of additional tunings to complete the spectral sweep
  logical :: dorange,dontuning,dozoom,dofile,doadd
  integer(kind=4) :: nkey,lpar,is,iu,selmode,pmode,nplot,ier,nchar,olun
  integer(kind=4), parameter :: mkeys=3
  character(len=16) :: keys(mkeys),par,plotmode
  character(len=256) :: mess
  data keys/'MIN','CENTER','MAX'/ 
  integer(kind=4), parameter :: mp=2 ! plot modes
  character(len=16) :: plotmodes(mp)
  data plotmodes/'RECEIVER','RANGE'/
  !
  error=.false.
  !
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
    error = .true.
    return
  endif
  !
  ! Reset Sweep structure
  call ssweep%reset(error)
  if (error) return
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'NOEMA',ssweep%out%srdesc,error)
  if (error) return
  ssweep%out%srdesc%redshift = .true. ! tuning takes into accound source redshift
  if (.not.noema%recdesc%defined) noema%recdesc=ssweep%out%srdesc
  !Define source parameters
  call astro_def_recsource(rname,ssweep%out%srdesc,ssweep%out%srsou,error)
  if (error) return
  if (.not.noema%source%defined) noema%source=ssweep%out%srsou
  !
  ! Hardware related parameters
  ssweep%param%if_width=ssweep%out%srdesc%iflim(2)-ssweep%out%srdesc%iflim(1) ! 
  ssweep%param%tuning_width=2*ssweep%out%srdesc%iflim(2) ! 
  ssweep%param%couple_width=4*ssweep%param%if_width ! 
  !
  !Decoding Line Command
  doadd=sic_present(i_optadd,0) ! add to register
  dozoom=sic_present(i_optzoom,0)
  dorange=sic_present(i_optrange,0)
  dontuning=sic_present(i_optntuning,0)
  if (dorange.and.dontuning) then
    call astro_message(seve%e,rname,'Options /RANGE and /NTUNING are exclusive from each other')
    error=.true.
    return
  endif
  ! Output file
  dofile=sic_present(i_optfile,0)
  if (dofile) then
    call sic_ch(line,i_optfile,1,argum,nchar,.true.,error)
    if (error)  return
  endif
  ! Zoom
  pmode=2
  if (dozoom) then
    call sic_ke(line,i_optzoom,1,par,lpar,.false.,error)
    if (error) return
    call sic_ambigs_sub(rname,par,plotmode,nplot,plotmodes,mp,error)
    if (error) return
    if (nplot.ne.0) then
      pmode=nplot
    endif
  endif
  plotmode=plotmodes(pmode)
  ! Tuning parameters
  ssweep%in%do_limrange=.true.
  if (sic_present(i_optmaxband,0)) then
    if (.not.dorange) then
      call astro_message(seve%i,rname,'Option /BANDMAX ignored: can be combined with /RANGE only')
    else
      ssweep%in%do_limrange=.false.
    endif
  endif
  ! Command argument to define spectral mode
  resuser=2000.
  call sic_r4(line,0,1,resuser,.false.,error)
  if (error) return
  !
  if (resuser.eq.reshigh1) then
    call astro_message(seve%e,rname,'High Res coverage not implemented yet')
    error=.true.
    return
  else if  (resuser.eq.reslow) then
    selmode=1  
  else if  (resuser.eq.resmed) then
    selmode=3
  else
    call astro_message(seve%e,rname,'Entered resolution does not match any correlator mode')
    error=.true.
    return
  endif
  !
  ! Find and define the tunings
  if (dorange) then
    ssweep%in%in_range=.true.
    ssweep%in%in_ntune=.false.
    ! Sweep defined by frequency limits
    if (sic_narg(i_optrange).gt.margrange) then
      call astro_message(seve%e,rname,'Too many arguments')
      error=.true.
      return
    else  if (sic_narg(i_optrange).lt.margrange) then
      call astro_message(seve%i,rname,'Not enough arguments')
      error=.true.
      return
    endif
    ! Get limits in the command line
    call sic_r8(line,i_optrange,1,fs1,.true.,error)
    if (error) return
    call sic_r8(line,i_optrange,2,fs2,.true.,error)
    if (error) return
    if (fs1.ge.fs2) then
      call astro_message(seve%e,rname,'Please enter lower then higher frequency')
      error=.true.
      return
    endif
    fs1=fs1*mhzperghz
    call rec_inputtorest(rname,fs1,freq_axis%main,ssweep%out%srsou,ssweep%in%restlim(1),error)
    if (error) return    
    fs2=fs2*mhzperghz
    call rec_inputtorest(rname,fs2,freq_axis%main,ssweep%out%srsou,ssweep%in%restlim(2),error)
    if (error) return   
    call ssweep%dorange(error)
    if (error) return
  else if (dontuning) then
    ssweep%in%in_range=.false.
    ssweep%in%in_ntune=.true.
    ! Sweep defined with number of tunings
    ! Get requested number of tuning in the command line
    call sic_i4(line,i_optntuning,1,ssweep%in%n_tunings,.true.,error)
    if (error) return
    if (ssweep%in%n_tunings.lt.2) then
      call astro_message(seve%e,rname,'Spectral sweep requests at least 2 tunings')
      error=.true.
      return
    endif
    ! Get frequency for position of spectral sweep
    call sic_r8(line,i_optntuning,2,fs1,.true.,error)
    if (error) return
    fs1=fs1*mhzperghz
    call rec_inputtorest(rname,fs1,freq_axis%main,ssweep%out%srsou,ssweep%in%restref,error)
    if (error) return
    ssweep%in%rfref = ssweep%in%restref*ssweep%out%srsou%dopshift
    call rec_find_band(rname,ssweep%out%srdesc,ssweep%in%rfref,ssweep%out%iband,error)
    if (error) return
    ! Get code for alignement
    par='MIN'
    call sic_ke(line,i_optntuning,3,par,lpar,.false.,error)
    if (error) return
    call sic_ambigs(rname,par,ssweep%in%align,nkey,keys,mkeys,error)
    if (error) return
    write (mess,'(a,1x,i0,1x,a,1x,f0.3,1x,a,1x,a)') 'Preparing sweep of',ssweep%in%n_tunings, & 
                                  'tunings aligned on',ssweep%in%restref,'MHz',ssweep%in%align
    call astro_message(seve%i,rname,mess)
    call ssweep%donumber(error)
    if (error) return
  else
    call astro_message(seve%i,rname,'NOTHING TO DO')
    error=.true.
    return
  endif
  !  
  ! Define the IFdistribution and the backend
  do is=1,ssweep%in%n_tunings
    !Define ifproc parameters
    call rec_define_noema_ifproc(ssweep%out%sfebe(is)%i_f%ifproc,error)
    if (error) return
    call noema_ifproc(rname,ssweep%out%srdesc,ssweep%out%sfebe(is)%rectune,ssweep%out%sfebe(is)%i_f%ifproc,error)
    if (error) return
    ! define polyfix and assign if "cables" to correlator units [only input, no mode yet]
    call noema_define_pfx(ssweep%out%sfebe(is)%pfx,error)
    if (error) return
    call noema_reset_backend(ssweep%out%sfebe(is)%pfx,ssweep%out%sfebe(is)%spw%out,error)
    if (error) return
    call noema_assign_units(rname,ssweep%out%sfebe(is)%i_f%ifproc,ssweep%out%sfebe(is)%pfx,ssweep%out%srdesc,error)
    if (error) return
    do iu=1,ssweep%out%sfebe(is)%pfx%n_units
      ssweep%out%sfebe(is)%pfx%unit(iu)%imode=selmode
      call pfx_fixed_spw(rname,ssweep%out%srdesc,ssweep%out%srsou, &  
          ssweep%out%sfebe(is)%rectune,ssweep%out%sfebe(is)%pfx%unit(iu),ssweep%out%sfebe(is)%spw,error)
      if (error) return
    enddo !iu
    ! remove empty spw (if there was a reset)
    call noema_compress_spw(ssweep%out%sfebe(is)%spw%out,error)
    if (error) return
    ! sort spw
    ! Use temporary spw2 as buffer for sorting
    spw2%out=ssweep%out%sfebe(is)%spw%out
    call noema_sort_spw2(spw2%out,error)
    ssweep%out%sfebe(is)%spw%out=spw2%out
    if (error) return
    ! look for conflicts
    call noema_check_conflicts(rname,ssweep%out%sfebe(is)%spw%out,ssweep%out%sfebe(is)%pfx,error)
    if (error) return
  enddo
  !
  ! Do the plot
  call ssweep%plot(plotmode,molecules,cplot,freq_axis,error)
  if (error) return
  !
  if (doadd) then
    call noema%register%reallocate(m_register_alloc,error)
    if (error) return
    !Check that N_TUNINGS will fit in REGISTER
    if (noema%register%n_saved+ssweep%in%n_tunings.gt.noema%register%m_saved) then
      call astro_message(seve%e,rname,'Not enough free slots in register to save all FEBEs. Nothing Saved')
      error=.true.
      return
    endif
    do is=1,ssweep%in%n_tunings
      ! Add the febes to the register
      call noema%register%add(ssweep%out%sfebe(is),error)
      if (error) return
    enddo
  endif
  !
  if (dofile) then
    ! Print in files to be uploaded in SMS
    ier = sic_getlun(olun) !find a unit number
    if (ier.ne.1) then
      call astro_message(seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    do is=1,ssweep%in%n_tunings  
      file2=""
      file=""
      write (file2,'(a,a,i0)') trim(argum),'-',is
      call sic_parse_file(file2,' ','.astro',file)
      ier = sic_open(olun,file,'NEW',.false.)
      if (ier.ne.0) then
        call astro_message(seve%e,rname,'Cannot open file '//file)
        error = .true.
        call sic_frelun(olun)
        return
      endif
      call noema_setup_check(rname,ssweep%out%srsou,ssweep%out%sfebe(is), & 
                          doonline,error)
      if (error) return
      call noema_setup_source(rname,ssweep%out%srsou,doonline,dotime,olun,error)
      if (error) return
      call noema_setup_print(rname,ssweep%out%srsou,ssweep%out%sfebe(is), &
                                molecules,doonline,olun,error)
      ier = sic_close(olun)
      if (error) exit
    enddo
    call sic_frelun(olun)
  endif
  !
  call ssweep%free(error)
  !
end subroutine noema_spectral_sweep

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemask_language
  use cubetools_parameters
  use cubetools_structure
  use cubemask_messaging
  !
  use cubemask_cube
  use cubemask_erode
  use cubemask_invert
  use cubemask_poly2mask
  use cubemask_velocity
  !
  public :: cubemask_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubemask_register_language(error)
    !----------------------------------------------------------------------
    ! Register the MASK\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'MASK',&
         'J.Pety, S.Bardeau',&
         'Commands to interact with masks',&
         'MASK helps you define where emission is trusted before running&
         & science measurements.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- POLY2MASK turns polygon selections into reusable mask&
         & cubes.'//strg_cr//&
         '- CUBE and VELOCITY apply mask logic so downstream analysis&
         & keeps only selected voxels.'//strg_cr//&
         '- ERODE and INVERT refine mask boundaries or invert selection&
         & logic when needed.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> MASK\POLY2MASK [cubid]'//strg_cr//&
         'CUBE> MASK\ERODE [maskid]'//strg_cr//&
         'CUBE> MASK\CUBE [cubid]',&
         'gag_doc:hlp/cube-help-mask.hlp',&
         cubemask_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call cube%register(error)
    if (error) return
    call cubemask_erode_register(error)
    if (error) return
    call cubemask_invert_register(error)
    if (error) return
    call poly2mask%register(error)
    if (error) return
    call velocity%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubemask_register_language
  !
  subroutine cubemask_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the MASK\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'MASK?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubemask_execute_command
end module cubemask_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_pix
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_flush
  use cubeio_read
  use cubeio_write

  type cubeio_pix_t
    integer(kind=chan_k) :: nc = 0                         ! Number of channels
    integer(kind=4)      :: allocated = code_pointer_null  !
    logical              :: iscplx = .false.               ! R*4 or C*4?
    real(kind=sign_k),    pointer :: r4(:) => null()       ! [nc]
    complex(kind=sign_k), pointer :: c4(:) => null()       ! [nc]
  end type cubeio_pix_t

  private
  public :: cubeio_pix_t
  public :: cubeio_get_pix,cubeio_put_pix
  public :: cubeio_free_pix
  public :: cubeio_iterate_pix

contains

  subroutine cubeio_reallocate_pix(cubset,pix,iscplx,nc,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_pix_t
    ! Do nothing when the array sizes do not need to change
    !-------------------------------------------------------------------
    type(cube_setup_t),     intent(in)    :: cubset
    type(cubeio_pix_t),     intent(inout) :: pix
    logical,                intent(in)    :: iscplx
    integer(kind=chan_k),   intent(in)    :: nc
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>CUBE>PIX'
    integer(kind=4) :: ier
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (nc.le.0) then
      call cubeio_message(seve%e,rname,'Number of channels is null or negative')
      error = .true.
      if (error)  return
    endif
    !
    ! Allocation or reallocation?
    if (pix%allocated.eq.code_pointer_allocated) then
      ! Reallocation?
      if ((pix%iscplx.eqv.iscplx) .and. pix%nc.eq.nc) then
        ! Same type and same size => Nothing to be done!
        call cubeio_message(ioseve%alloc,rname,'Pixel array already allocated with correct size')
        goto 100
      else  ! Different type or different size => reallocation
        call cubeio_message(ioseve%alloc,rname,'Reallocating pixel array')
        call cubeio_free_pix(pix,error)
        if (error)  return
      endif
    else
      ! Allocation
      call cubeio_message(ioseve%alloc,rname,'Creating pixel array')
    endif
    !
    ! Reallocate memory of the right size
    if (iscplx) then
      allocate(pix%c4(nc),stat=ier)
    else
      allocate(pix%r4(nc),stat=ier)
    endif
    if (failed_allocate(rname,'Pixel array',ier,error)) return
    !
  100 continue
    ! Operation success
    pix%nc = nc
    pix%iscplx = iscplx
    pix%allocated = code_pointer_allocated
    !
  end subroutine cubeio_reallocate_pix

  subroutine cubeio_free_pix(pix,error)
    !---------------------------------------------------------------------
    ! Free a 'cubeio_pix_t' instance
    !---------------------------------------------------------------------
    type(cubeio_pix_t), intent(inout) :: pix
    logical,            intent(inout) :: error
    !
    if (pix%allocated.eq.code_pointer_allocated) then
      if (pix%iscplx) then
        deallocate(pix%c4)
      else
        deallocate(pix%r4)
      endif
    endif
    !
    pix%nc = 0
    pix%allocated = code_pointer_null
    pix%iscplx = .false.
    pix%c4 => null()
    pix%r4 => null()
    !
  end subroutine cubeio_free_pix

  subroutine cubeio_get_pix(cubset,cubdef,dno,cub,xpix,ypix,pix,error)
    !---------------------------------------------------------------------
    ! Get all data (Nc) for the desired pixel
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=pixe_k),         intent(in)    :: xpix,ypix
    type(cubeio_pix_t),           intent(inout) :: pix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>PIX'
    character(len=message_length) :: mess
    integer(kind=pixe_k) :: doxpix,doypix
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    doxpix = cub%x_num(xpix)
    doypix = cub%y_num(ypix)
    if (doxpix.le.0 .or. doxpix.gt.cub%desc%nx) then
      write(mess,'(2(A,I0))')  'X pixel number ',doxpix,' out of range 1 - ',cub%desc%nx
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (doypix.le.0 .or. doypix.gt.cub%desc%ny) then
      write(mess,'(2(A,I0))')  'Y pixel number ',doypix,' out of range 1 - ',cub%desc%ny
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (error)  return
    !
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_get_pix_from_memory(cubset,cub,doxpix,doypix,pix,error)
    case (code_buffer_disk)
      call cubeio_get_pix_from_block(cubset,dno,cub,doxpix,doypix,pix,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube buffering')
      error = .true.
    end select
    if (error)  return
    !
  end subroutine cubeio_get_pix

  subroutine cubeio_get_pix_from_memory(cubset,cub,xpix,ypix,pix,error)
    !---------------------------------------------------------------------
    ! Get all data (Nc) for the desired pixel, in the context of memory
    ! mode. In return, the 'pix' points to the cube data buffer.
    ! --
    ! Do not call directly, use cubeio_get_pix instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),          intent(in)    :: cubset
    type(cubeio_cube_t), target, intent(in)    :: cub
    integer(kind=pixe_k),        intent(in)    :: xpix
    integer(kind=pixe_k),        intent(in)    :: ypix
    type(cubeio_pix_t),          intent(inout) :: pix
    logical,                     intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>PIX'
    !
    select case (cub%desc%order)
    case (code_cube_speset)
      ! Data is simply associated to VLM buffer
      ! ZZZ deallocate if needed before associating!
      pix%nc =  cub%memo%nc
      if (cub%memo%iscplx) then
        pix%c4 => cub%memo%c4(:,xpix,ypix)
      else
        pix%r4 => cub%memo%r4(:,xpix,ypix)
      endif
      pix%iscplx = cub%memo%iscplx
      pix%allocated = code_pointer_associated
    case (code_cube_imaset)
      ! Data is copied/duplicated from LMV buffer
      call cubeio_reallocate_pix(cubset,pix,cub%memo%iscplx,cub%memo%nc,error)
      if (error)  return
      ! Non-contiguous (inefficient) copy
      if (cub%memo%iscplx) then
        pix%c4(:) = cub%memo%c4(xpix,ypix,:)
      else
        pix%r4(:) = cub%memo%r4(xpix,ypix,:)
      endif
    case (code_table_speset)
      ! Data is simply associated to TAB buffer
      ! ZZZ deallocate if needed before associating!
      pix%nc = cub%memo%nc-3  ! ZZZ Should introduce a 'ldaps' count
      pix%r4 => cub%memo%r4(4:cub%memo%nc,xpix,ypix)
      pix%iscplx = cub%memo%iscplx
      pix%allocated = code_pointer_associated
    case default
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
    end select
  end subroutine cubeio_get_pix_from_memory

  subroutine cubeio_get_pix_from_block(cubset,dno,cub,xpix,ypix,pix,error)
    !---------------------------------------------------------------------
    ! Get all data (Nc) for the desired pixel, in the context of disk
    ! mode. In return, the 'pix' points to a memory buffer that is
    ! intended to disappear as others pixels are accessed => no warranty
    ! the pointer remains valid after another call.
    ! --
    ! Do not call directly, use cubeio_get_pix instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t), target,  intent(inout) :: cub
    integer(kind=pixe_k),         intent(in)    :: xpix
    integer(kind=pixe_k),         intent(in)    :: ypix
    type(cubeio_pix_t),           intent(inout) :: pix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>PIX'
    integer(kind=pixe_k) :: bypix
    !
    if (cub%desc%order.ne.code_cube_speset) then
      call cubeio_message(seve%e,rname,'Reading a pixel from disk in a LMV file is prohibitive')
      call cubeio_message(seve%e,rname,'Transpose LMV file to VLM file and then READ it')
      error = .true.
      return
    endif
    !
    call cubeio_check_input_pix_block(cubset,dno,cub,ypix,ypix,error)
    if (error)  return
    !
    ! Point pixel data from correct position in pix%block
    bypix = ypix-cub%file%block%first+1  ! Position in pix%block
    ! ZZZ deallocate if needed before associating!
    pix%nc = cub%desc%nc
    if (cub%file%block%iscplx) then
      pix%c4 => cub%file%block%c4(:,xpix,bypix)
    else
      pix%r4 => cub%file%block%r4(:,xpix,bypix)
    endif
    pix%iscplx = cub%file%block%iscplx
    pix%allocated = code_pointer_associated
  end subroutine cubeio_get_pix_from_block
  !
  subroutine cubeio_put_pix(cubset,cubdef,dno,cub,xpix,ypix,pix,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Put all data (Nc) for the desired pixel
    ! (This is symetric to cubeio_get_pix)
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=pixe_k),         intent(in)    :: xpix
    integer(kind=pixe_k),         intent(in)    :: ypix
    type(cubeio_pix_t),           intent(in)    :: pix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>PIX'
    character(len=message_length) :: mess
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    if (xpix.le.0 .or. xpix.gt.cub%desc%nx) then
      write(mess,'(A,I0,A,I0,A)')  &
        'X pixel number out of range (',xpix,'/',cub%desc%nx,')'
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (ypix.le.0 .or. ypix.gt.cub%desc%ny) then
      write(mess,'(A,I0,A,I0,A)')  &
        'Y pixel number out of range (',ypix,'/',cub%desc%ny,')'
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (pix%nc.ne.cub%desc%nc) then
      write(mess,'(3(A,I0))')  'Number of channels mismatch: attempt to put ',  &
        pix%nc,' channels while output cube has ',cub%desc%nc,' channels'
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (pix%iscplx.neqv.cub%desc%iscplx) then
      call cubeio_message(seve%e,rname,'Pixel and output cube type mismatch (R*4/C*4)')
      error = .true.
    endif
    if (error)  return
    !
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_put_pix_to_data(cubset,cub,xpix,ypix,pix,error)
    case (code_buffer_disk)
      call cubeio_put_pix_to_block(cubset,dno,cub,xpix,ypix,pix,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube data buffering')
      error = .true.
      return
    end select
    !
  end subroutine cubeio_put_pix
  !
  subroutine cubeio_put_pix_to_data(cubset,cub,xpix,ypix,pix,error)
    !-------------------------------------------------------------------
    ! Write a single channel to the cubeio_memory_t, in the context of
    ! memory mode.
    ! ---
    ! Do not call directly, use cubeio_put_pix instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),   intent(in)    :: cubset
    type(cubeio_cube_t),  intent(inout) :: cub
    integer(kind=pixe_k), intent(in)    :: xpix
    integer(kind=pixe_k), intent(in)    :: ypix
    type(cubeio_pix_t),   intent(in)    :: pix
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>PIX'
    !
    select case (cub%desc%order)
    case (code_cube_speset)
      if (cub%memo%iscplx) then
        cub%memo%c4(:,xpix,ypix) = pix%c4(:)
      else
        cub%memo%r4(:,xpix,ypix) = pix%r4(:)
      endif
    case (code_cube_imaset)
      ! Non-contiguous (inefficient) copies
      if (cub%memo%iscplx) then
        cub%memo%c4(xpix,ypix,:) = pix%c4(:)
      else
        cub%memo%r4(xpix,ypix,:) = pix%r4(:)
      endif
    case default
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
    end select
    !
  end subroutine cubeio_put_pix_to_data
  !
  subroutine cubeio_put_pix_to_block(cubset,dno,cub,xpix,ypix,pix,error)
    !-------------------------------------------------------------------
    ! Write a single channel to the cubeio_block_t, in the context of
    ! disk mode.
    ! ---
    ! Do not call directly, use cubeio_put_pix instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=pixe_k),         intent(in)    :: xpix
    integer(kind=pixe_k),         intent(in)    :: ypix
    type(cubeio_pix_t),           intent(in)    :: pix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>PIX'
    integer(kind=pixe_k) :: by
    integer(kind=size_length) :: ndata
    !
    if (cub%desc%order.ne.code_cube_speset) then
      call cubeio_message(seve%e,rname,'Writing a pixel to disk in a LMV file is impossible')
      error = .true.
      return
    endif
    if (cub%file%block%iscplx.neqv.pix%iscplx) then
      call cubeio_message(seve%e,rname,'Pixel and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    !
    call cubeio_check_output_pix_block(cubset,dno,cub,ypix,ypix,error)
    if (error)  return
    !
    ! Buffer might already be in memory but read-only: switch to read-write
    cub%file%block%readwrite = .true.
    !
    ! Write DATA to cub%file%block buffer
    by = ypix-cub%file%block%first+1  ! Position in cub%file%block
    ndata = cub%desc%nc
    if (cub%file%block%iscplx) then
      call c4toc4_sl(pix%c4,cub%file%block%c4(1,xpix,by),ndata)
    else
      call r4tor4_sl(pix%r4,cub%file%block%r4(1,xpix,by),ndata)
    endif
  end subroutine cubeio_put_pix_to_block

  subroutine cubeio_iterate_pix(cubset,cubdef,dno,cub,fypix,lypix,error)
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested Y pixel row
    ! range
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=pixe_k),         intent(in)    :: fypix
    integer(kind=pixe_k),         intent(in)    :: lypix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>PIX'
    !
    select case (cub%desc%action)
    case (code_read_head)
      call cubeio_message(seve%e,rname,'Access to data not allowed for action read-header')
      error = .true.
    case (code_read,code_update)
      call cubeio_iterate_read_pix(cubset,cubdef,dno,cub,fypix,lypix,error)
    case (code_write)
      call cubeio_iterate_write_pix(cubset,cubdef,dno,cub,fypix,lypix,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected action mode')
      error = .true.
    end select
  end subroutine cubeio_iterate_pix

  subroutine cubeio_iterate_read_pix(cubset,cubdef,dno,icub,fypix,lypix,error)
    !---------------------------------------------------------------------
    ! Pre-load all or part of the data from disk in a buffer which
    ! provides (at least) the requested Y pixel row range.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: icub
    integer(kind=pixe_k),         intent(in)    :: fypix
    integer(kind=pixe_k),         intent(in)    :: lypix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>READ>PIX'
    !
    ! On first iteration, read or prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_read_cube_data(cubset,cubdef,icub,error)
    if (error)  return
    !
    ! Work to be done on next iterations
    select case (icub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_input_pix_block(cubset,dno,icub,fypix,lypix,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_read_pix

  subroutine cubeio_iterate_write_pix(cubset,cubdef,dno,ocub,fypix,lypix,error)
    !---------------------------------------------------------------------
    ! Prepare a buffer covering all or part of the data, providing
    ! (at least) the requested Y pixel row range
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: ocub
    integer(kind=pixe_k),         intent(in)    :: fypix
    integer(kind=pixe_k),         intent(in)    :: lypix
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>WRITE>PIX'
    !
    ! On first iteration, prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_create_cube_data(cubset,cubdef,dno,ocub,error)
    if (error)  return
    !
    select case (ocub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_output_pix_block(cubset,dno,ocub,fypix,lypix,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_write_pix

end module cubeio_pix

module gmath_fourt
  !---------------------------------------------------------------------
  ! Pre-Computed Sin/Cos for FFT, up to 32768 (MMAX=15)
  ! We limit FFT length to 20000 due to the prime number decomposition
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: mmax=15
  ! Pre-computed Sin/Cos, Bloc Start and Bit-Reverse
  real(kind=4), allocatable :: w1c(:),w3c(:)
  integer(kind=4), allocatable :: jx0(:),bitrev(:)
  integer(kind=4) :: idfft=0
  !$OMP THREADPRIVATE (w1c,w3c,jx0,bitrev,idfft)
end module gmath_fourt
!
module gmath_fftw
  use gildas_def
  !$ use omp_lib
  !---------------------------------------------------------------------
  !    Support for Fastest Fourier Transform in the West (of Italy)
  !
  ! These codes are for FFTW Version 3.1.1
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: fftw_r2hc    =  0
  integer(kind=4), parameter :: fftw_hc2r    =  1
  integer(kind=4), parameter :: fftw_dht     =  2
  integer(kind=4), parameter :: fftw_redft00 =  3
  integer(kind=4), parameter :: fftw_redft01 =  4
  integer(kind=4), parameter :: fftw_redft10 =  5
  integer(kind=4), parameter :: fftw_redft11 =  6
  integer(kind=4), parameter :: fftw_rodft00 =  7
  integer(kind=4), parameter :: fftw_rodft01 =  8
  integer(kind=4), parameter :: fftw_rodft10 =  9
  integer(kind=4), parameter :: fftw_rodft11 = 10
  !
  integer(kind=4), parameter :: fftw_forward  = -1
  integer(kind=4), parameter :: fftw_backward = +1
  !
  integer(kind=4), parameter :: fftw_measure                = 0
  integer(kind=4), parameter :: fftw_destroy_input          = 1
  integer(kind=4), parameter :: fftw_unaligned              = 2
  integer(kind=4), parameter :: fftw_conserve_memory        = 4
  integer(kind=4), parameter :: fftw_exhaustive             = 8
  integer(kind=4), parameter :: fftw_preserve_input         = 16
  integer(kind=4), parameter :: fftw_patient                = 32
  integer(kind=4), parameter :: fftw_estimate               = 64
  integer(kind=4), parameter :: fftw_estimate_patient       = 128
  integer(kind=4), parameter :: fftw_believe_pcost          = 256
  integer(kind=4), parameter :: fftw_no_dft_r2hc            = 512
  integer(kind=4), parameter :: fftw_no_nonthreaded         = 1024
  integer(kind=4), parameter :: fftw_no_buffering           = 2048
  integer(kind=4), parameter :: fftw_no_indirect_op         = 4096
  integer(kind=4), parameter :: fftw_allow_large_generic    = 8192
  integer(kind=4), parameter :: fftw_no_rank_splits         = 16384
  integer(kind=4), parameter :: fftw_no_vrank_splits        = 32768
  integer(kind=4), parameter :: fftw_no_vrecurse            = 65536
  integer(kind=4), parameter :: fftw_no_simd                = 131072
  integer(kind=4), parameter :: fftw_no_slow                = 262144
  integer(kind=4), parameter :: fftw_no_fixed_radix_large_n = 524288
  integer(kind=4), parameter :: fftw_allow_pruning          = 1048576
  !
  ! One plan for Direct and one for Reverse
  logical, save :: fftw_debug=.false.
#if defined(FFTW)
#if defined(GAG_USE_OPENMP)
  logical, save :: fftw_use=.false.
#else
  logical, save :: fftw_use=.true.
#endif
  integer(kind=address_length), save :: fftw_plan(2)=(/0,0/)
  integer(kind=4), save :: fftw_ndim(2)=(/0,0/)
  logical, save :: fftw_exist(2) = (/ .false.,.false. /)
  integer(kind=4), save :: fftw_dims(16,2)
#else 
  logical, save :: fftw_use=.false.
#endif
  !
end module gmath_fftw
!
subroutine fourt_set_usage(status)
  use gmath_interfaces, except_this=>fourt_set_usage
  use gmath_messaging
  use gmath_fftw
  !---------------------------------------------------------------------
  ! @ public
  !   Toggle the use of FFTW and its Debug mode, and
  !   return the previous status
  !---------------------------------------------------------------------
  logical, intent(inout) :: status(2)  !  Use and Debug FFTW code ?
  !
#if defined(FFTW)
  fftw_use = status(1)
  fftw_debug = status(2)
#else
  if (status(1)) call gmath_message(seve%w,'FFT','Not compiled with FFTW, FAST mode not available')
  status= .false. 
#endif
end subroutine fourt_set_usage
!
subroutine fourt_get_usage(status) 
  use gmath_fftw
  !---------------------------------------------------------------------
  ! @ public
  !   Toggle the use of FFTW and its Debug mode, and
  !   return the previous status 
  !---------------------------------------------------------------------
  logical, intent(out) :: status(2)    !  Use and Debug FFTW code ?
  !
  status = [fftw_use,fftw_debug]
end subroutine fourt_get_usage
!
subroutine fourt_plan(data,nn,ndim,isign,iform)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>fourt_plan
  use gmath_messaging
  use gmath_fftw
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Fast Fourier Transform Planner
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensionned to twice the largest dimension.
  !
  ! NOTES:
  !     Calls FFTW when available, if FFTW_USE is set.
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
  !         based on near-optimal Split-Radix method of P.Duhamel.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !---------------------------------------------------------------------
  complex(kind=4) :: data(*)  ! Complex array of data             Input/Output
  integer(kind=4) :: nn(*)    ! Dimensions of data array          Input
  integer(kind=4) :: ndim     ! Number of dimensions              Input
  integer(kind=4) :: isign    ! Sign of FT (-1 Direct, 1 Inverse) Input
  integer(kind=4) :: iform    ! Type of data (0 Real, 1 Complex)  (Unused)
#if defined(FFTW)
  ! Local
  character(len=*), parameter :: rname='FOURT_PLAN'
  integer(kind=4) :: iplan
  logical :: destroy
  character(len=message_length) :: mess
  integer :: the_seve = seve%d
  !
  ! Real Transform not yet ready here (REAL array conventions differ between
  !    FFTW and the other routines...)
  ! So always use the Complex DFT case
  !
  if (.not.fftw_use) return
!$  if (omp_in_parallel()) then
!$    if (fftw_debug) call gmath_message(seve%e,rname,'FOURT_PLAN call invalid in Parallel')
!$    return
!$  endif
  !
  ! Check consistency with previous call
  iplan = (isign+3)/2          ! 1 Direct, 2 Reverse
  if (fftw_exist(iplan)) then
    if (fftw_debug) then
      write(mess,*) 'Testing Plan ',iplan
      call gmath_message(the_seve,rname,mess)
    endif
    destroy = .false.
    if (ndim.ne.fftw_ndim(iplan)) destroy = .true.
    if ( any(nn(1:ndim).ne.fftw_dims(1:ndim,iplan)) ) destroy = .true.
    if (destroy) then
      if (fftw_debug) then
        write(mess,*) 'Destroying Plan ',iplan, fftw_plan(iplan)
        call gmath_message(the_seve,rname,mess)
      endif
      call sfftw_destroy_plan(fftw_plan(iplan))
      fftw_exist(iplan) = .false.
    else
      if (fftw_debug) then
        write(mess,*) 'Reusing Plan ',iplan
        call gmath_message(the_seve,rname,mess)
      endif
      return
    endif
  else
    if (fftw_debug) then 
      write(mess,*) 'No such Plan ',iplan
      call gmath_message(the_seve,rname,mess)
    endif
  endif
  !
  ! Declare the plan
  call sfftw_plan_dft(fftw_plan(iplan),ndim,nn,data,data,isign,fftw_estimate)
  ! Log its characteristics
  fftw_ndim(iplan) = ndim
  fftw_dims(:,iplan) = 0
  fftw_dims(1:ndim,iplan) = nn(1:ndim)
  fftw_exist(iplan)=.true.
  if (fftw_debug) then
    write(mess,100) 'Creating FFTW Plan ',iplan,fftw_ndim(iplan),fftw_dims(1:ndim,iplan)
    call gmath_message(seve%w,rname,mess)
  endif
100 format(a,i3,i3,20(1X,I0))
#endif
end subroutine fourt_plan
!
subroutine fourt(data,nn,ndim,isign,iform,work)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>fourt,    &
                        no_interface1=>fft1d,  &
                        no_interface2=>fft2d,  &
                        no_interface3=>fourct
  use gmath_messaging
  use gmath_fftw
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Fast Fourier Transform
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensioned to twice the largest dimension.
  !
  ! NOTES:
  !  For COMPLEX (IFORM=1) transforms
  !     Calls FFTW when available
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
  !         based on near-optimal Split-Radix method of P.Duhamel.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !  For REAL (IFORM=0) transforms
  !     Calls FFTW when available, but in COMPLEX mode only
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !  data(*) is declared as "complex (*)" here for the interface,
  !     but passed to subroutines treating it as "real (2,*)"
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: data(*)  ! Complex array of data
  integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
  integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
  integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
  integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
  real(kind=4)                   :: work(*)  ! Work space
#if defined(FFTW)
  ! Local
  character(len=*), parameter :: rname='FOURT'
  integer(kind=4) :: iplan
  character(len=message_length) :: mess
  integer :: the_seve = seve%d
#endif
  integer(kind=4) :: n,m1,m2,seuil
  ! SEUIL has been determined experimentally on HP-700 series.
  data seuil/0/
  !
#if defined(FFTW)
  if (fftw_use) then
    !
    ! Use the plan if possible
    iplan = (3+isign)/2
    if (fftw_exist(iplan)) then
!
! Test if the Plan is valid, comparing sizes to fftw_sndim and fftw_dims
    if ( (fftw_ndim(iplan).eq.ndim) .and. all(fftw_dims(1:ndim,iplan).eq.nn(1:ndim)) ) then
        if (fftw_debug) then
          write(mess,*) 'Using plan ',iplan,isign
          call gmath_message(the_seve,rname,mess)
        endif
!
! Can work with different adresses than in Plan
        call sfftw_execute_dft(fftw_plan(iplan),data,data)
        return
      endif
    endif
  else if (fftw_debug) then
    call gmath_message(the_seve,rname,'No matching FFTW plan, Falling back on FOURT')
  endif
#endif
  !
  if (ndim.eq.1) then
    m1 = power_of_two(nn(1))
    if (m1.gt.0) then
      n = nn(1)
      call fft1d(data,n,isign,m1,work(1),work(n+1))
    else
      call fourct(data,nn,ndim,isign,iform,work)
    endif
  elseif (ndim.eq.2) then
    m1 = power_of_two(nn(1))
    m2 = power_of_two(nn(2))
    if (m1.gt.seuil .and. m2.gt.seuil) then
      n = max(nn(1),nn(2))
      call fft2d(data,nn(1),nn(2),isign,m1,m2,work(1),work(n+1),n)
    else
      call fourct(data,nn,ndim,isign,iform,work)
    endif
  else
    call fourct(data,nn,ndim,isign,iform,work)
  endif
end subroutine fourt
!
subroutine fft1d(data,n,isign,m,xr,xi)
  use gmath_interfaces, except_this=>fft1d
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private-mandatory (because of explicit renaming elsewhere)
  ! Transformee de Fourier               Pierre Duhamel
  !
  ! Ce sous-programme calcule la transformee de Fourier directe
  ! (ISIGN=-1) ou inverse (ISIGN=1) du tableau complexe DATA de
  ! dimension N=2**M (n doit etre compris entre 8 et 2**mmax et etre
  ! une puissance de 2)
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: data(*)  !
  integer(kind=4), intent(in)    :: n        !
  integer(kind=4), intent(in)    :: isign    !
  integer(kind=4), intent(in)    :: m        !
  real(kind=4)                   :: xr(*)    !
  real(kind=4)                   :: xi(*)    !
  ! Local
  integer(kind=4) :: i,k
  !
  if (idfft.ne.m) call inifft(m,n)
  do i=1,n
    xr(i)=real(data(i))
    xi(i)=aimag(data(i))
  enddo
  if (isign.lt.0) then
    call fftcfr(xr,xi,m,n)
  else
    call fftcfr(xi,xr,m,n)
  endif
  do i=1,n
    k = bitrev(i)
    data(i)=cmplx(xr(k),xi(k))
  enddo
end subroutine fft1d
!
subroutine fft2d(data,dim1,dim2,isign,m1,m2,xr,xi,mm)
  use gmath_interfaces, except_this=>fft2d
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private-mandatory (because of explicit renaming elsewhere)
  ! Joue le meme role que Fourt : Pas de Normalisation.
  !
  ! If Signe=-1 Then
  !       Direct Fourier Transform
  ! Else
  !       Inverse Fourier Transform
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: dim1             !
  integer(kind=4), intent(in)    :: dim2             !
  complex(kind=4), intent(inout) :: data(dim1,dim2)  !
  integer(kind=4), intent(in)    :: isign            !
  integer(kind=4), intent(in)    :: m1               !
  integer(kind=4), intent(in)    :: m2               !
  integer(kind=4), intent(in)    :: mm               !
  real(kind=4)                   :: xr(mm)           !
  real(kind=4)                   :: xi(mm)           !
  ! Local
  integer(kind=4) :: ifft,jfft,kfft
  integer(kind=4) :: m,n
  !
  ! Init DIM1
  m = m1
  n = dim1
  if (idfft.ne.m) call inifft(m,n)
  if (isign.lt.0) then
    do jfft=1,dim2
      do ifft=1,dim1
        xr(ifft)=real(data(ifft,jfft))
        xi(ifft)=aimag(data(ifft,jfft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      do ifft=1,dim1
        kfft = bitrev(ifft)
        data(ifft,jfft)=cmplx(xr(kfft),xi(kfft))
      enddo
    enddo
  else
    do jfft=1,dim2
      do ifft=1,dim1
        xi(ifft)=real(data(ifft,jfft))
        xr(ifft)=aimag(data(ifft,jfft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      do ifft=1,dim1
        kfft = bitrev(ifft)
        data(ifft,jfft)=cmplx(xi(kfft),xr(kfft))
      enddo
    enddo
  endif
  !
  ! Init DIM2
  m = m2
  n = dim2
  if (idfft.ne.m) call inifft(m,n)
  if (isign.lt.0) then
    do jfft=1,dim1
      ! Transpose
      do ifft=1,dim2
        xr(ifft)=real(data(jfft,ifft))
        xi(ifft)=aimag(data(jfft,ifft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      ! Transpose and Bit-Reverse
      do ifft=1,dim2
        kfft = bitrev(ifft)
        data(jfft,ifft)=cmplx(xr(kfft),xi(kfft))
      enddo
    enddo
  else
    do jfft=1,dim1
      ! Transpose
      do ifft=1,dim2
        xi(ifft)=real(data(jfft,ifft))
        xr(ifft)=aimag(data(jfft,ifft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      ! Transpose and Bit-Reverse
      do ifft=1,dim2
        kfft = bitrev(ifft)
        data(jfft,ifft)=cmplx(xi(kfft),xr(kfft))
      enddo
    enddo
  endif
end subroutine fft2d
! 
subroutine fftcfr(xr,xi,m,n)
  use gmath_interfaces, except_this=>fftcfr
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private
  ! FFT de sequence complexe (xr + j*xi) de taille 2**m
  !
  ! Algorithme SRFFT, version rapide, qui necessite donc un appel
  ! de INIFFT , et decimation en frequences (les rearrangements sont a
  ! effectuer apres appel a la FFT)
  !
  !  Un algorithme de transformation de Fourier rapide a double base.
  !    Pierre DUHAMEL
  !  Annales des teleommunications, tome 40, n! 9-10, sept-oct 1985
  !---------------------------------------------------------------------
  real(kind=4)                 :: xr(*)  !
  real(kind=4)                 :: xi(*)  !
  integer(kind=4), intent(in)  :: m      !
  integer(kind=4), intent(in)  :: n      !
  ! Local
  real(kind=4), parameter :: c21=0.707106781186547
  real(kind=4), parameter :: cm=-1.414213562373095
  real(kind=4) :: sp,s,r,t,rp,y2,x2,t1,u
  integer(kind=4) :: nd4,n1,istep,ib,nb,lnb,jstep,ij,llnb
  integer(kind=4) :: j,i,i0,i1,i2,i3,i4,i5,i6,i7
  !
  !     n = 2**m
  nd4 = n/4
  n1 = n/2
  !
  istep = 1
  ib = 0
  nb = 1
  lnb = 0
  !
  ! Boucle sur les etages
  do j=1,m-3
    n1 = n1/2
    !
    ! Boucle sur les blocs
    do i=ib+1,ib+nb
      !
      !-------------0-mult butterfly------------
      i0 = jx0(i)
      i1 = i0+n1
      i2 = i1+n1
      i3 = i2+n1
      sp = xr(i1)-xr(i3)
      s = xi(i1)-xi(i3)
      xr(i1) = xr(i1)+xr(i3)
      r = xr(i0)-xr(i2)
      xr(i3) = r-s
      xr(i0) = xr(i0)+xr(i2)
      xr(i2) = r+s
      r = xi(i0)-xi(i2)
      xi(i0) = xi(i0)+xi(i2)
      xi(i1) = xi(i1)+xi(i3)
      xi(i3) = r+sp
      xi(i2) = r-sp
      !
      !-------------general 6-mult butterfly--------
      jstep = 0
      do ij=i0+1,i0+n1-1
        i1 = ij+n1
        i2 = i1+n1
        i3 = i2+n1
        r = xi(ij)-xi(i2)
        xi(ij) = xi(ij)+xi(i2)
        s = xi(i1)-xi(i3)
        xi(i1) = xi(i1)+xi(i3)
        sp = xr(i1)-xr(i3)
        t = r-sp
        r = r+sp
        xr(i1) = xr(i1)+xr(i3)
        rp = xr(ij)-xr(i2)
        sp = rp+s
        jstep = jstep+istep
        xi(i2) = t*w1c(jstep)-sp*w1c(nd4-jstep)
        xr(ij) = xr(ij)+xr(i2)
        xr(i2) = sp*w1c(jstep)+t*w1c(nd4-jstep)
        rp = rp-s
        xi(i3) = r*w3c(jstep)+rp*w3c(nd4-jstep)
        xr(i3) = rp*w3c(jstep)-r*w3c(nd4-jstep)
      enddo
    enddo
    !
    ib = ib+nb
    llnb = lnb
    lnb = nb
    nb = lnb+llnb+llnb
    istep = istep+istep
  enddo
  !
  do i=ib+1,ib+nb
    !
    !-------------8-point butterfly--------------
    i0 = jx0(i)
    i1 = i0+1
    i3 = i0+3
    i5 = i0+5
    i7 = i0+7
    r = xi(i1)-xi(i5)
    xi(i1) = xi(i1)+xi(i5)
    s = xi(i3)-xi(i7)
    xi(i3) = xi(i3)+xi(i7)
    sp = xr(i3)-xr(i7)
    xr(i3) = xr(i3)+xr(i7)
    rp = xr(i1)-xr(i5)
    t = s+rp
    y2 = (t-sp+r)*c21
    x2 = t*cm+y2
    xr(i1) = xr(i1)+xr(i5)
    t = r+sp
    sp = (t-rp+s)*c21
    rp = t*cm+sp
    !
    i2 = i0+2
    i4 = i0+4
    i6 = i0+6
    r = xi(i0)-xi(i4)
    xi(i0) = xi(i0)+xi(i4)
    s = xi(i2)-xi(i6)
    xi(i2) = xi(i2)+xi(i6)
    t = xr(i2)-xr(i6)
    t1 = r+t
    xi(i6) = t1+rp
    xi(i7) = t1-rp
    t = r-t
    xi(i4) = t+x2
    xi(i5) = t-x2
    xr(i2) = xr(i2)+xr(i6)
    r = xr(i0)-xr(i4)
    t = r-s
    xr(i6) = t+sp
    xr(i7) = t-sp
    xr(i0) = xr(i0)+xr(i4)
    s = r+s
    xr(i4) = s+y2
    xr(i5) = s-y2
  enddo
  !
  !--------------4-point dft----------------
  ib = ib+nb
  nb = nb+lnb+lnb
  do i=ib+1,ib+nb
    i0 = jx0(i)
    i1 = i0+1
    i2 = i1+1
    i3 = i2+1
    r = xi(i0)+xi(i2)
    s = xi(i0)-xi(i2)
    t = xi(i1)+xi(i3)
    xi(i0) = r+t
    u = xi(i1)-xi(i3)
    xi(i1) = r-t
    r = xr(i1)+xr(i3)
    t = xr(i1)-xr(i3)
    xi(i3) = s+t
    xi(i2) = s-t
    t = xr(i0)-xr(i2)
    xr(i3) = t-u
    s = xr(i0)+xr(i2)
    xr(i0) = s+r
    xr(i1) = s-r
    xr(i2) = t+u
  enddo
end subroutine fftcfr
!
subroutine inifft(m,n)
  use gmath_interfaces, except_this=>inifft
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private
  !  Precalcul des cos, debuts de blocs et bit-reversal
  !
  !  Sous programme a appeler avant utilisation des versions rapides.
  ! Il est commun a toutes les versions, et un seul appel a INIFFT est
  ! necessaire.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: m
  integer(kind=4), intent(in) :: n
  ! Local
  real(kind=8) :: ang, c, s, dpi, xn
  integer(kind=4) :: m1,n1,ia1,ia2,ia3,nh,ibr,i,ipair,k,j,jbr,jbri,indt
  integer(kind=4) :: n2,n2p1,n4,n8,n16,n6,n12,ip,nb,lnb,ip1,llnb
  !
  !     n   = 2**m
  if (idfft.eq.m) return
  !
  call inifft_allocate()
  !
  idfft = m
  xn  = n
  dpi = 6.283185307179586d0
  ang = dpi/xn
  n2  = n/2
  n2p1= n2+1
  n4  = n/4
  n8  = n4/2
  n16 = n8/2
  n6  = n/6
  n12 = n6/2
  !
  ! Sin/Cos
  c = cos(ang)
  s = sin(ang)
  w1c(1) = c
  w1c(n4-1) = s
  w1c(n/8) = 0.707106781186547
  do i=2,n16
    w1c(i) = w1c(i-1)*c-w1c(n4-i+1)*s
    w1c(n4-i) = w1c(n4-i+1)*c+w1c(i-1)*s
    w1c(n8+i-1) = w1c(n8+i-2)*c-w1c(n8-i+2)*s
    w1c(n8-i+1) = w1c(n8-i+2)*c+w1c(n8+i-2)*s
  enddo
  do i=1,n12
    w3c(i) = w1c(3*i)
  enddo
  do i=n12+1,n6
    w3c(i) = -w1c(n2-3*i)
  enddo
  do i=n6+1,n4-1
    w3c(i) = -w1c(3*i-n2)
  enddo
  !
  ! Bloc Beginning
  jx0(1) = 1
  jx0(2) = 1
  jx0(3) = 1
  jx0(4) = n2p1
  jx0(5) = 3*n4+1
  ip = 5
  nb = 3
  lnb = 1
  do i=1,m-4
    do j=ip+1,ip+nb
      jx0(j) = jx0(j-nb)/2+1
    enddo
    ip = ip+nb
    ip1=-(nb+nb+lnb)
    do j=ip+1,ip+lnb
      jx0(j) = jx0(j+ip1)/4+n2p1
      jx0(j+lnb) = jx0(j)+n4
    enddo
    ip = ip+lnb+lnb
    llnb = lnb
    lnb = nb
    nb = lnb+llnb+llnb
  enddo
  !
  ! Bit-Reversal
  do i=1,n
    bitrev(i) = i
  enddo
  !
  m1 = m/2
  n1 = 2**m1
  ia1= n1/2
  ia2= n/n1
  ia3= ia1+ia2
  nh = n/2
  do ipair=0,(m-m1-m1)*n1,n1
    ibr = 0
    indt = bitrev(ipair+ia1+1)
    bitrev(ipair+ia1+1) = bitrev(ipair+ia2+1)
    bitrev(ipair+ia2+1) = indt
    do i=2+ipair,ia1+ipair
      k = nh
      !            if (k.gt.ibr) go to 23
      !24          ibr = ibr-k
      !            k = k/2
      !            if (k.le.ibr) go to 24
      !23          ibr = ibr+k
      do while (k.le.ibr)
        ibr = ibr-k
        k = k/2
      enddo
      ibr = ibr+k
      !
      indt = bitrev(ibr+i+ia1)
      bitrev(ibr+i+ia1) = bitrev(ibr+i+ia2)
      bitrev(ibr+i+ia2) = indt
      !
      jbr = 0
      !
      if (m.ge.4) then
        do j=ibr+ipair+1,ibr+i-1
          jbri=jbr+i
          indt = bitrev(jbri)
          bitrev(jbri) = bitrev(j)
          bitrev(j) = indt
          indt = bitrev(jbri+ia1)
          bitrev(jbri+ia1) = bitrev(j+ia2)
          bitrev(j+ia2) = indt
          indt = bitrev(jbri+ia2)
          bitrev(jbri+ia2) = bitrev(j+ia1)
          bitrev(j+ia1) = indt
          indt = bitrev(jbri+ia3)
          bitrev(jbri+ia3) = bitrev(j+ia3)
          bitrev(j+ia3) = indt
          k = nh
          !               if (k.gt.jbr) go to 33
          !34             jbr = jbr-k
          !               k = k/2
          !               if (k.le.jbr) go to 34
          !33             jbr = jbr+k
          do while (k.le.jbr)
            jbr = jbr-k
            k = k/2
          enddo
          jbr = jbr+k
        enddo
      endif
    enddo
  enddo
  !
contains
  !
  subroutine inifft_allocate()
    use gmath_dependencies_interfaces
    !-------------------------------------------------------------------
    ! Allocate (once for all) the buffers to the maximum possible size
    !
    ! Required memory:
    !         w1c     :       nmax/4
    !         w3c     :       nmax/4
    !         jx0     :       nmax/3
    !         BITREV  :       nmax
    !                      ---------
    !         total   :  11/6*nmax
    !-------------------------------------------------------------------
    ! Local
    logical :: error
    integer(kind=4) :: nmax,ns3,ns4,ier
    !
    if (allocated(bitrev))  return
    !
    error = .false.
    nmax=2**mmax
    ns3=nmax/3
    ns4=nmax/4
    allocate(w1c(ns4),w3c(ns4),jx0(ns3),bitrev(nmax),stat=ier)
    if (failed_allocate('INITFFT','FFT buffers',ier,error)) return
  end subroutine inifft_allocate
  !
end subroutine inifft
!
function power_of_two(dim)
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4) :: power_of_two     ! Value on return
  integer(kind=4), intent(in) :: dim  !
  ! Local
  integer(kind=4) :: power(0:mmax),i
  data power /1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768/
  !
  ! MMAX is a parameter defined in gmath_fourt specifying the maximum
  ! power of two preallocated in BITREV and other pointers
  !
  do i = 1,mmax
    if (dim.eq.power(i)) then
      power_of_two = i
      return
    endif
  enddo
  power_of_two = -1
end function power_of_two
!
subroutine gi4_round_forfft(isize,osize,error,tolerance,exponent)
  use gildas_def
  use gmath_interfaces, except_this=>gi4_round_forfft
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !
  !  Find the nearest number in the form 2^n 3^p 5^q with p and q
  ! smaller than Exponent (can be 0, then only powers of two are
  ! returned.)
  !
  !  Round to near if within Tolerance. Use Ceiling if not.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)           :: isize      ! Input size
  integer(kind=4), intent(out)          :: osize      ! Output size
  real(kind=4),    intent(in), optional :: tolerance  ! Tolerance
  integer(kind=4), intent(in), optional :: exponent   ! Max exponent
  logical,         intent(inout)        :: error      !
  ! Saved globals
  character(len=*), parameter :: rname='ROUND_MAPSIZE'
  integer(kind=size_length), save :: nval(0:2)
  integer, parameter :: numbers=72
  ! There are 72 numbers between 64 and 20000 for exponent 2
  integer(kind=4), save :: values(numbers,0:2)
  integer(kind=4) :: it(numbers)
  integer(kind=4), save :: the_expo=-1
  real(kind=4), save :: the_tolerance=0.10
  !
  integer(kind=size_length) :: ival
  integer(kind=4) :: x2, x3, y3, x5, y5
  integer(kind=4) :: count, iexpo, i,j,k
  !
  if (present(tolerance)) then
    if (tolerance.lt.0 .or. tolerance.gt.0.3) then
      call gmath_message(seve%e,rname,'Tolerance out of range ]0,0.3]')
      error = .true.
      return
    endif
    the_tolerance = tolerance
  endif
  !
  ! Initialize the values
  if (the_expo.eq.-1) then
    ! Start from 5 to make sure X2 is > 32, and end at 2^(5+9) = 16384 
    ! to be less than  20000
    do i=1,9
      values(i,0) = 2**(i+5)
    enddo
    nval(0) = 9
    !
    do iexpo=1,2
      count = 0
      !
      ! Start from 1 to make sure X2 is even, and end at 2^14 = 16384 
      ! to be less than  20000
      do i=1,14  
        x2 = 2**i
        do j=0,iexpo
          x3 = 3**j
          y3 = x2*x3
          if (y3.gt.20000) exit
          do k=0,iexpo
            x5 = 5**k
            y5 = y3*x5
            if (y5.gt.20000) exit
            if (y5.ge.64) then
              count = count+1
              if (count.gt.ubound(values,1)) Stop 'Programming error'
              values(count,iexpo) = y5
            endif
          enddo
        enddo
      enddo
      call gi4_trie(values(1:count,iexpo),it,count,error)
      nval(iexpo) = count
    enddo
    the_expo = 0  ! Default value after initialization
  endif
  !
  if (present(exponent)) then
    if (exponent.lt.0 .or. exponent.gt.2) then
      call gmath_message(seve%e,rname,'Exponent not 0,1 or 2')
      error = .true.
      return
    endif
    the_expo = exponent
  endif
  !
  if (isize.gt.values(nval(the_expo),the_expo)) then
    call gmath_message(seve%w,rname,'Size exceeds capability, has been truncated')
    osize = values(nval(the_expo),the_expo)
    return
  else if (isize.lt.values(1,the_expo)/2) then
    call gmath_message(seve%e,rname,'Size below 32 pixels')
    error = .true.
    return
  else if (isize.lt.values(1,the_expo)) then
    call gmath_message(seve%d,rname,'Size rounded upwards to 64')
    osize = values(1,the_expo)
    return
  else
    ! Dichotomic search to find out the position in the values array
    call gi4_dicho(nval(the_expo),values(:,the_expo),isize,.false.,  &
      ival,error)
    if (error)  return
  endif
  !
  if (isize-values(ival,the_expo).lt.the_tolerance*isize) then
    osize = values(ival,the_expo)
  else
    osize = values(ival+1,the_expo)
  endif
end subroutine gi4_round_forfft
!
subroutine fourct(data,nn,ndim,isign,iform,work)
  use gildas_def
  use phys_const
  use gmath_interfaces, except_this=>fourct
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Cooley-Tukey Fast Fourier Transform
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensioned to twice the largest dimension
  ! which is not a power of 2. It can be replaced by 0 if all dimensions
  ! are powers of 2.
  !
  ! The FT are not normalized in the standard way. If a Direct FT is
  ! performed, then an Inverse FT on the result, the original data is
  ! multiply by the size of the data (product of all dimensions).
  !----------------------------------------------------------------------
  real(kind=4),    intent(inout) :: data(*)  ! Complex array of data
  integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
  integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
  integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
  integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
  real(kind=4)                   :: work(*)  ! Work space
  ! Local
  integer(kind=4) :: ifact(32),np0,idim,nprev
  integer(kind=4) :: if,idiv,iquot,irem,inon2,non2p
  integer(kind=4) :: ifmin,i1rng,icase,np2hf,kmin
  integer(kind=4) :: ipar,ifp1,ifp2,nhalf,nwork
  !
  integer(kind=size_length) :: np1,np2,ntot
  integer(kind=size_length) :: ntwo
  integer(kind=size_length) :: mmax,lmax,kdif,kstep
  integer(kind=size_length) :: i,j,i1,i2,i3,j2,j1,j3,k1,k2,k3,k4,l,m,n
  integer(kind=size_length) :: i1max,i2max,j2max,j3max,imax,imin,jmax,jmin
  integer(kind=size_length) :: np1tw
  !
  ! Made these Double Precision to avoid round-off errors
  real(kind=8), parameter :: rthlf=.7071067811865475244d0
  real(kind=8) :: tempr,tempi,theta,wr,wi,w2r,w2i,w3r,w3i
  real(kind=8) :: u1r,u1i,u2r,u2i,u3r,u3i,u4r,u4i,t2r,t2i,t3r,t3i,t4r,t4i
  real(kind=8) :: wstpr,wstpi,thetm,wminr,wmini,twowr,sr,si,oldsr,oldsi
  real(kind=8) :: stmpr,stmpi,wtemp,sumr,sumi,difr,difi
  !
  np0=0
  nprev=0
  if (ndim-1) 920,1,1
1 ntot=2
  do 2 idim=1,ndim
    if (nn(idim)) 920,920,2
2 ntot=ntot*nn(idim)  ! Enddo idim
  !
  !     MAIN LOOP FOR EACH DIMENSION
  !
  np1=2
  do 910 idim=1,ndim
    n=nn(idim)
    np2=np1*n
    if(n-1)920,900,5
    !
    !     IS N A POWER OF TWO AND IF NOT, WHAT ARE ITS FACTORS
    !
5   m=n
    ntwo=np1
    if=1
    idiv=2
10  iquot=m/idiv
    irem=m-idiv*iquot
    if(iquot-idiv)50,11,11
11  if(irem)20,12,20
12  ntwo=ntwo+ntwo
    ifact(if)=idiv
    if=if+1
    m=iquot
    go to 10
20  idiv=3
    inon2=if
30  iquot=m/idiv
    irem=m-idiv*iquot
    if(iquot-idiv)60,31,31
31  if(irem)40,32,40
32  ifact(if)=idiv
    if=if+1
    m=iquot
    go to 30
40  idiv=idiv+2
    go to 30
50  inon2=if
    if(irem)60,51,60
51  ntwo=ntwo+ntwo
    go to 70
60  ifact(if)=m
70  non2p=np2/ntwo
    !
    !     SEPARATE FOUR CASES--
    !        1. COMPLEX TRANSFORM
    !        2. REAL TRANSFORM FOR THE 2ND, 3RD, ETC. DIMENSION.  METHOD--
    !           TRANSFORM HALF THE DATA, SUPPLYING THE OTHER HALF BY CON-
    !           JUGATE SYMMETRY.
    !        3. REAL TRANSFORM FOR THE 1ST DIMENSION, N ODD.  METHOD--
    !           SET THE IMAGINARY PARTS TO ZERO.
    !        4. REAL TRANSFORM FOR THE 1ST DIMENSION, N EVEN.  METHOD--
    !           TRANSFORM A COMPLEX ARRAY OF LENGTH N/2 WHOSE REAL PARTS
    !           ARE THE EVEN NUMBERED REAL VALUES AND WHOSE IMAGINARY PARTS
    !           ARE THE ODD NUMBERED REAL VALUES.  SEPARATE AND SUPPLY
    !           THE SECOND HALF BY CONJUGATE SYMMETRY.
    !
    ifmin = 1
    i1rng = np1
    if (iform .le. 0 .and. idim .lt. 4) go to 71
    icase = 1
    go to 100
    !
71  if (idim .le. 1) go to 72
    icase = 2
    i1rng = np0 * (1 + nprev / 2)
    go to 100
    !
72  if (ntwo .gt. np1) go to 73
    icase = 3
    go to 100
    !
73  icase = 4
    ifmin = 2
    ntwo = ntwo / 2
    n = n / 2
    np2 = np2 / 2
    ntot = ntot / 2
    !
    i = - 1
    do 80 j = 1, ntot
      i = i + 2
      data(j) = data(i)
80  continue  ! Enddo j
    !
    !     SHUFFLE DATA BY BIT REVERSAL, SINCE N=2**K.  AS THE SHUFFLING
    !     CAN BE DONE BY SIMPLE INTERCHANGE, NO WORKING ARRAY IS NEEDED
    !
100 if(non2p-1)101,101,200
101 np2hf=np2/2
    j=1
    do 150 i2=1,np2,np1
      if(j-i2)121,130,130
121   i1max=i2+np1-2
      do 125 i1=i2,i1max,2
        do 125 i3=i1,ntot,np2
          j3=j+i3-i2
          tempr=data(i3)
          tempi=data(i3+1)
          data(i3)=data(j3)
          data(i3+1)=data(j3+1)
          data(j3)=tempr
125   data(j3+1)=tempi  ! Enddo i1,i3
130   m=np2hf
140   if(j-m)150,150,141
141   j=j-m
      m=m/2
      if(m-np1)150,140,140
150 j=j+m  ! Enddo i2
    go to 300
    !
    !     SHUFFLE DATA BY DIGIT REVERSAL FOR GENERAL N
    !
200 nwork=2*n
    do 270 i1=1,np1,2
      do 270 i3=i1,ntot,np2
        j=i3
        do 260 i=1,nwork,2
          if(icase-3)210,220,210
210       work(i)=data(j)
          work(i+1)=data(j+1)
          go to 240
220       work(i)=data(j)
          work(i+1)=0.
240       ifp2=np2
          if=ifmin
250       ifp1=ifp2/ifact(if)
          j=j+ifp1
          if(j-i3-ifp2)260,255,255
255       j=j-ifp2
          ifp2=ifp1
          if=if+1
          if(ifp2-np1)260,260,250
260     continue  ! Enddo i
        i2max=i3+np2-np1
        i=1
        do 270 i2=i3,i2max,np1
          data(i2)=work(i)
          data(i2+1)=work(i+1)
270 i=i+2  ! Enddo i1,i3,i2
    !
    !     MAIN LOOP FOR FACTORS OF TWO.
    !     W=EXP(ISIGN*2*PI*SQRT(-1)*M/(4*MMAX)).  CHECK FOR W=ISIGN*SQRT(-1)
    !     AND REPEAT FOR W=W*(1+ISIGN*SQRT(-1))/SQRT(2).
    !
300 if(ntwo-np1)600,600,305
305 np1tw=np1+np1
    ipar=ntwo/np1
310 if(ipar-2)350,330,320
320 ipar=ipar/4
    go to 310
330 do 340 i1=1,i1rng,2
      do 340 k1=i1,ntot,np1tw
        k2=k1+np1
        tempr=data(k2)
        tempi=data(k2+1)
        data(k2)=data(k1)-tempr
        data(k2+1)=data(k1+1)-tempi
        data(k1)=data(k1)+tempr
340 data(k1+1)=data(k1+1)+tempi  ! Enddo i1,k1
350 mmax=np1
360 if(mmax-ntwo/2)370,600,600
370 lmax=max(np1tw,mmax/2)
    do 570 l=np1,lmax,np1tw
      m=l
      if (mmax-np1) 420,420,380
380   theta=-twopi*float(l)/float(4*mmax)
      if (isign) 400,390,390
390   theta=-theta
400   wr=cos(theta)
      wi=sin(theta)
410   w2r=wr*wr-wi*wi
      w2i=2.*wr*wi
      w3r=w2r*wr-w2i*wi
      w3i=w2r*wi+w2i*wr
420   do 530 i1=1,i1rng,2
        kmin=i1+ipar*m
        if(mmax-np1)430,430,440
430     kmin=i1
440     kdif=ipar*mmax
450     kstep=4*kdif
        if(kstep-ntwo)460,460,530
460     do 520 k1=kmin,ntot,kstep
          k2=k1+kdif
          k3=k2+kdif
          k4=k3+kdif
          if(mmax-np1)470,470,480
470       u1r=data(k1)+data(k2)
          u1i=data(k1+1)+data(k2+1)
          u2r=data(k3)+data(k4)
          u2i=data(k3+1)+data(k4+1)
          u3r=data(k1)-data(k2)
          u3i=data(k1+1)-data(k2+1)
          if (isign) 471,472,472
471       u4r=data(k3+1)-data(k4+1)
          u4i=data(k4)-data(k3)
          go to 510
472       u4r=data(k4+1)-data(k3+1)
          u4i=data(k3)-data(k4)
          go to 510
480       t2r=w2r*data(k2)-w2i*data(k2+1)
          t2i=w2r*data(k2+1)+w2i*data(k2)
          t3r=wr*data(k3)-wi*data(k3+1)
          t3i=wr*data(k3+1)+wi*data(k3)
          t4r=w3r*data(k4)-w3i*data(k4+1)
          t4i=w3r*data(k4+1)+w3i*data(k4)
          u1r=data(k1)+t2r
          u1i=data(k1+1)+t2i
          u2r=t3r+t4r
          u2i=t3i+t4i
          u3r=data(k1)-t2r
          u3i=data(k1+1)-t2i
          if (isign) 490,500,500
490       u4r=t3i-t4i
          u4i=t4r-t3r
          go to 510
500       u4r=t4i-t3i
          u4i=t3r-t4r
510       data(k1)=u1r+u2r
          data(k1+1)=u1i+u2i
          data(k2)=u3r+u4r
          data(k2+1)=u3i+u4i
          data(k3)=u1r-u2r
          data(k3+1)=u1i-u2i
          data(k4)=u3r-u4r
520     data(k4+1)=u3i-u4i  ! Enddo k1
        kdif=kstep
        kmin=4*(kmin-i1)+i1
        go to 450
530   continue  ! Enddo i1
      m=m+lmax
      if (m-mmax) 540,540,570
540   if (isign) 550,560,560
550   tempr=wr
      wr=(wr+wi)*rthlf
      wi=(wi-tempr)*rthlf
      go to 410
560   tempr=wr
      wr=(wr-wi)*rthlf
      wi=(tempr+wi)*rthlf
      go to 410
570 continue  ! Enddo l
    ipar=3-ipar
    mmax=mmax+mmax
    go to 360
    !
    !     MAIN LOOP FOR FACTORS NOT EQUAL TO TWO.
    !     W=EXP(ISIGN*2*PI*SQRT(-1)*(J1+J2-I3-1)/IFP2)
    !
600 if(non2p-1)700,700,601
601 ifp1=ntwo
    if=inon2
610 ifp2=ifact(if)*ifp1
    theta=-twopi/float(ifact(if))
    if (isign) 612,611,611
611 theta=-theta
612 wstpr=cos(theta)
    wstpi=sin(theta)
    do 650 j1=1,ifp1,np1
      thetm=-twopi*float(j1-1)/float(ifp2)
      if (isign) 614,613,613
613   thetm=-thetm
614   wminr=cos(thetm)
      wmini=sin(thetm)
      i1max=j1+i1rng-2
      do 650 i1=j1,i1max,2
        do 650 i3=i1,ntot,np2
          i=1
          wr=wminr
          wi=wmini
          j2max=i3+ifp2-ifp1
          do 640 j2=i3,j2max,ifp1
            twowr=wr+wr
            j3max=j2+np2-ifp2
            do 630 j3=j2,j3max,ifp2
              jmin=j3-j2+i3
              j=jmin+ifp2-ifp1
              sr=data(j)
              si=data(j+1)
              oldsr=0.
              oldsi=0.
              j=j-ifp1
620           stmpr=sr
              stmpi=si
              sr=twowr*sr-oldsr+data(j)
              si=twowr*si-oldsi+data(j+1)
              oldsr=stmpr
              oldsi=stmpi
              j=j-ifp1
              if(j-jmin)621,621,620
621           work(i)=wr*sr-wi*si-oldsr+data(j)
              work(i+1)=wi*sr+wr*si-oldsi+data(j+1)
630         i=i+2  ! Enddo j3
            wtemp=wr*wstpi
            wr=wr*wstpr-wi*wstpi
640       wi=wi*wstpr+wtemp  ! Enddo j2
          i=1
          do 650 j2=i3,j2max,ifp1
            j3max=j2+np2-ifp2
            do 650 j3=j2,j3max,ifp2
              data(j3)=work(i)
              data(j3+1)=work(i+1)
650 i=i+2  ! Enddo j1,i1,i3,j2,j3
    if=if+1
    ifp1=ifp2
    if(ifp1-np2)610,700,700
    !
    !     COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N EVEN, BY CON-
    !     JUGATE SYMMETRIES.
    !
700 go to (900,800,900,701),icase
701 nhalf=n
    n=n+n
    theta=-twopi/float(n)
    if (isign) 703,702,702
702 theta=-theta
703 wstpr=cos(theta)
    wstpi=sin(theta)
    wr=wstpr
    wi=wstpi
    imin=3
    jmin=2*nhalf-1
    go to 725
710 j=jmin
    do 720 i=imin,ntot,np2
      sumr=(data(i)+data(j))/2.
      sumi=(data(i+1)+data(j+1))/2.
      difr=(data(i)-data(j))/2.
      difi=(data(i+1)-data(j+1))/2.
      tempr=wr*sumi+wi*difr
      tempi=wi*sumi-wr*difr
      data(i)=sumr+tempr
      data(i+1)=difi+tempi
      data(j)=sumr-tempr
      data(j+1)=-difi+tempi
720 j=j+np2  ! Enddo i
    imin=imin+2
    jmin=jmin-2
    wtemp=wr*wstpi
    wr=wr*wstpr-wi*wstpi
    wi=wi*wstpr+wtemp
725 if (imin-jmin) 710,730,740
730 if (isign) 731,740,740
731 do 735 i=imin,ntot,np2
735 data(i+1)=-data(i+1)  ! Enddo i
740 np2=np2+np2
    ntot=ntot+ntot
    j=ntot+1
    imax=ntot/2+1
745 imin=imax-2*nhalf
    i=imin
    go to 755
750 data(j)=data(i)
    data(j+1)=-data(i+1)
755 i=i+2
    j=j-2
    if(i-imax)750,760,760
760 data(j)=data(imin)-data(imin+1)
    data(j+1)=0.
    if(i-j)770,780,780
765 data(j)=data(i)
    data(j+1)=data(i+1)
770 i=i-2
    j=j-2
    if(i-imin)775,775,765
775 data(j)=data(imin)+data(imin+1)
    data(j+1)=0.
    imax=imin
    go to 745
780 data(1)=data(1)+data(2)
    data(2)=0.
    go to 900
    !
    !     COMPLETE A REAL TRANSFORM FOR THE 2ND, 3RD, ETC. DIMENSION BY
    !     CONJUGATE SYMMETRIES.
    !
800 if(i1rng-np1)805,900,900
805 do 860 i3=1,ntot,np2
      i2max=i3+np2-np1
      do 860 i2=i3,i2max,np1
        imax=i2+np1-2
        imin=i2+i1rng
        jmax=2*i3+np1-imin
        if(i2-i3)820,820,810
810     jmax=jmax+np2
820     if(idim-2)850,850,830
830     j=jmax+np0
        do 840 i=imin,imax,2
          data(i)=data(j)
          data(i+1)=-data(j+1)
840     j=j-2  ! Enddo i
850     j=jmax
        do 860 i=imin,imax,np0
          data(i)=data(j)
          data(i+1)=-data(j+1)
860 j=j-np0  ! Enddo i3,i2,i
    !
    !     END OF LOOP ON EACH DIMENSION
    !
900 np0=np1
    np1=np2
910 nprev=n  ! Enddo idim
920 return
end subroutine fourct

program uv_subtract
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! TASK  UV_SUBTRACT
  !       Subtract a continuum from a line table
  !
  ! Input :
  !	TABLE$	The line UV table
  !	SELF$	The continuum UV table to remove
  !	DTIME$	The smoothing time constant
  !       WCOL$   The column(s) to be subtracted
  !	SUBT$	Subtract point source model from data
  ! S.Guilloteau 19-Jun-1991
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='UV_SUBTRACT'
  ! Local
  character(len=filename_length) :: uv_table,self_name
  real(8) :: dtime
  integer :: wcol(2)
  real :: factor
  logical :: error
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('SELF$',self_name)
  call gildas_dble('DTIME$',dtime,1)
  call gildas_inte('WCOL$',wcol,2)
  call gildas_real('SUB$',factor,1)
  call gildas_close
  dtime = 0.5d0*dtime
  !
  call sub_uv_subtract(uv_table,self_name,dtime,wcol,factor,error)
  if (error) call sysexi(fatale)
end program
!
subroutine sub_uv_subtract(uv_table,self_name,dtime,wicol,factor,error)
  use image_def
  use gbl_format
  use gkernel_interfaces
  use mapping_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! TASK  UV_SUBTRACT
  !       Subtract a continuum from a line table
  !
  ! Input :
  !	TABLE$	The line UV table
  !	SELF$	The continuum UV table to remove
  !	DTIME$	The smoothing time constant
  !       WCOL$   The column(s) to be subtracted
  !	SUBT$	Subtract point source model from data
  ! S.Guilloteau 19-Jun-1991
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: uv_table
  character(len=*), intent(in) :: self_name
  real(8), intent(in)  :: dtime
  integer, intent(in)  :: wicol(2)
  real, intent(in)  :: factor
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_SUBTRACT'
  ! Local
  type(gildas) :: x,y
  character(len=filename_length) :: name
  character(len=80) :: mess
  real(8) :: time,stime
  integer :: wcol(2)
  !
  complex(4) :: resul, self
  integer :: i,nvs,nvi,nsc,nc,n,j, k, nblock, ier
  real :: rbase(2),reel,imgi,uv(2)
  real :: kilow,weight
  real(8), allocatable :: ipw(:)
  integer, allocatable :: ipi(:)
  real(8) :: freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 1.d0/299792458.d-6
  !
  self = cmplx(1.0,0.0)
  weight = 1.0
  wcol = wicol
  !
  ! Open continuum table
  n = len_trim(self_name)
  if (n.le.0) goto 999
  call gildas_null (y, type = 'UVT')
  name = self_name(1:n)
  call gdf_read_gildas (y, name, '.uvt', error)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    goto 999
  endif
  !
  freq = y%gil%val(1)+y%gil%fres*(y%gil%val(1)/y%gil%freq)*((y%gil%nchan+1)*0.5-y%gil%ref(1))
  kilow = freq*f_to_k
  nsc = min(max(1,wcol(1)),y%gil%nchan)
  wcol(1) = nsc 
  if (wcol(2).eq.0) then
    wcol(2) = nsc
  else
    wcol(2) = max(1,min(wcol(2),nsc))
  endif
  !
  ! Load time variable and sort by time order
  !
  ! Sort self-cal table
  nvs = y%gil%dim(1)
  nvi = y%gil%nvisi
  allocate (ipw(nvi), ipi(nvi), stat=ier)
  call dotime (nvs, nvi, y%r2d, ipw, ipi, stime)
  !
  ! Open line table
  n = len_trim(uv_table)
  if (n.le.0) goto 999
  call gildas_null (x, type = 'UVT')
  name = uv_table
  call gdf_read_gildas (x, name, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input/output UV table')
    goto 999
  endif
  !
  call gdf_nitems('SPACE_GILDAS',nblock,x%gil%dim(1))
  nblock = min(nblock,x%gil%dim(2))  ! A decent number of visibilities...
  !
  allocate (x%r2d(x%gil%dim(1),nblock), stat=ier)
  nc = x%gil%nchan
  !
  ! Loop over line table
  x%blc = 0
  x%trc = 0
  do i=1,x%gil%dim(2),nblock
    write(mess,*) i,' / ',x%gil%nvisi,nblock
    call map_message(seve%d,rname,mess)
    x%blc(2) = i
    x%trc(2) = min(x%gil%dim(2),i-1+nblock) 
    call gdf_read_data(x,x%r2d,error)
    k = 1
    do j=x%blc(2),x%trc(2)
      !
      ! Get time and baseline
      call getiba (x%r2d(:,k),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (nvs, nvi, wcol,y%r2d,    &
     &        time,dtime,ipw,ipi,   &
     &        rbase,resul,uv)
      !
      ! No data: flag
      if (resul.eq.cmplx(0.,0.)) then
        call doflag (nc,x%r2d(:,k))
      else
        ! Compute fraction of source to remove
        reel = factor*real(resul)
        imgi = factor*imag(resul)
        ! Remove source
        call dosubt (nc,x%r2d(:,k),reel,imgi)
      endif
      k = k+1
    enddo
    call gdf_write_data (x,x%r2d,error)
  enddo
  ! end loop
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call map_message(seve%i,rname,'Successful completion')
  return
999   error = .true.
end subroutine sub_uv_subtract

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_visi_types
  use cubetools_parameters
  use cubetools_array_types
  use cube_types
  use cubeadm_messaging
  use cubeadm_taskloop
  !
  public :: visi_t
  private
  !
  type, extends(cplx_2d_t) :: visi_t
     logical :: uvkind = .true.              ! uv or lm plane?
     type(cube_t),             private, pointer :: cube => null() ! Associated cube
     type(cubeadm_iterator_t), private, pointer :: task => null() ! Associated task iteration
   contains
     generic,   public  :: allocate       => allocate_iter,allocate_noiter
     generic,   public  :: associate      => associate_iter,associate_noiter
     procedure, public  :: get_pixel_area => visi_get_pixel_area
     procedure, public  :: get            => visi_get
     procedure, public  :: put            => visi_put
     procedure, public  :: put_in         => visi_put_in
     procedure, private :: tasknum        => visi_task_num
     !
     procedure, private :: allocate_iter    => visi_allocate_iter
     procedure, private :: allocate_noiter  => visi_allocate_noiter
     procedure, private :: associate_iter   => visi_associate_iter
     procedure, private :: associate_noiter => visi_associate_noiter
  end type visi_t
  !
contains
  !
  subroutine visi_allocate_iter(visi,name,cube,iterator,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(visi_t),                    intent(out)   :: visi
    character(len=*),                 intent(in)    :: name
    type(cube_t),             target, intent(in)    :: cube
    type(cubeadm_iterator_t), target, intent(in)    :: iterator
    logical,                          intent(inout) :: error
    !
    call visi_allocate_noiter(visi,name,cube,error)
    if (error)  return
    visi%task => iterator
  end subroutine visi_allocate_iter
  !
  subroutine visi_allocate_noiter(visi,name,cube,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(visi_t),        intent(out)   :: visi
    character(len=*),     intent(in)    :: name
    type(cube_t), target, intent(in)    :: cube
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VISI>ALLOCATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (.not.cube%iscplx()) then
       call cubeadm_message(seve%e,rname,  &
            'Invalid attempt to get a C*4 image from a R*4 cube')
       error = .true.
       return
    endif
    !
    call visi%reallocate(name,&
         cube%tuple%current%desc%nx,&
         cube%tuple%current%desc%ny,&
         error)
    if (error) return
    visi%cube => cube
    visi%task => null()
  end subroutine visi_allocate_noiter
  !
  subroutine visi_associate_iter(visi,name,cube,iterator,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(visi_t),                    intent(out)   :: visi
    character(len=*),                 intent(in)    :: name
    type(cube_t),             target, intent(in)    :: cube
    type(cubeadm_iterator_t), target, intent(in)    :: iterator
    logical,                          intent(inout) :: error
    !
    call visi_associate_noiter(visi,name,cube,error)
    if (error)  return
    visi%task => iterator
  end subroutine visi_associate_iter
  !
  subroutine visi_associate_noiter(visi,name,cube,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(visi_t),        intent(out)   :: visi
    character(len=*),     intent(in)    :: name
    type(cube_t), target, intent(in)    :: cube
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VISI>ASSOCIATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    if (.not.cube%iscplx()) then
       call cubeadm_message(seve%e,rname,  &
            'Invalid attempt to get a C*4 image from a R*4 cube')
       error = .true.
       return
    endif
    !
    call visi%prepare_association(name,&
         cube%tuple%current%desc%nx,&
         cube%tuple%current%desc%ny,&
         error)
    if (error) return
    visi%cube => cube
    visi%task => null()
  end subroutine visi_associate_noiter
  !
  !------------------------------------------------------------------------
  !
  subroutine visi_get_pixel_area(visi,area,error)
    use cubetools_axis_types
    use cubetools_header_methods
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(visi_t),     intent(in)    :: visi
    real(kind=coor_k), intent(out)   :: area
    logical,           intent(inout) :: error
    !
    type(axis_t) :: axis
    real(kind=coor_k) :: xinc,yinc
    character(len=*), parameter :: rname='GET>PIXEL>AREA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_l(visi%cube%head,axis,error)
    if (error) return
    xinc = axis%inc
    call cubetools_header_get_axis_head_m(visi%cube%head,axis,error)
    if (error) return
    yinc = axis%inc
    area = xinc*yinc
  end subroutine visi_get_pixel_area
  !
  !------------------------------------------------------------------------
  !
  subroutine visi_get(visi,ient,error)
    use cubeio_chan
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Get the ient image from the cube.
    ! When visi%val is an allocated pointer, we make a copy.
    ! In all other cases (associated or null), we make it point to the data.
    !---------------------------------------------------------------------
    class(visi_t),        intent(inout) :: visi
    integer(kind=entr_k), intent(in)    :: ient
    logical,              intent(inout) :: error
    ! 
    type(cubeio_chan_t) :: entry
    character(len=*), parameter :: rname='GET>VISI'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetuple_get_chan(visi%cube%user,visi%cube%prog,visi%cube,ient,entry,error)
    if (error) return
    !
    if (visi%pointeris.eq.code_pointer_allocated) then
       visi%val(:,:) = entry%c4(:,:)
    else
       visi%val => entry%c4
       visi%pointeris = code_pointer_associated
    endif
    visi%nx = entry%nx
    visi%ny = entry%ny
    visi%uvkind = .true.
    !
    call cubeio_free_chan(entry,error)
    if (error) return
  end subroutine visi_get
  !
  subroutine visi_put(visi,ient,error)
    !---------------------------------------------------------------------
    ! Put the ient image to the cube
    ! Only use pointers => Nothing to free
    !---------------------------------------------------------------------
    class(visi_t),        intent(in)    :: visi
    integer(kind=entr_k), intent(in)    :: ient
    logical,              intent(inout) :: error
    !
    call visi_put_in(visi,visi%cube,ient,error)
    if (error)  return
  end subroutine visi_put
  !
  subroutine visi_put_in(visi,cube,ient,error)
    use cubeio_chan
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Put the ient visi to the cube.
    ! Only use pointers => Nothing to free.
    !
    ! This flavor, which explicitely states the output cube, should be used
    ! when the input visi needs to be written in another cube without
    ! copy. See, eg, the copy tool. This should an exotic use compare to
    ! visi_put.
    ! ---------------------------------------------------------------------
    class(visi_t),        intent(in)    :: visi
    type(cube_t),         intent(inout) :: cube
    integer(kind=entr_k), intent(in)    :: ient
    logical,              intent(inout) :: error
    !
    type(cubeio_chan_t) :: entry
    character(len=*), parameter :: rname='VISI>PUT>IN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    entry%allocated = code_pointer_associated
    entry%nx = visi%nx
    entry%ny = visi%ny
    entry%c4 => visi%val
    entry%iscplx = .true.
    !
    call cubetuple_put_chan(cube%user,       &
                            cube%prog,       &
                            cube,            &
                            visi%tasknum(),  &
                            ient,            &
                            entry,           &
                            error)
    if (error) return
  end subroutine visi_put_in
  !
  function visi_task_num(visi)
    !-------------------------------------------------------------------
    ! Return the task number this visi_t is running with
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: visi_task_num
    class(visi_t), intent(in) :: visi
    !
    if (associated(visi%task)) then
      visi_task_num = visi%task%num
    else
      ! Assume single thread
      visi_task_num = 1
    endif
  end function visi_task_num
end module cubeadm_visi_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine new_data (line,error)
  use gbl_format
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces, except_this=>new_data
  use class_index
  use class_common
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS Support routine for command
  !   NEW_DATA [Interval]
  !  Wait until new data is present in the input file. No update the
  ! input and current indexes.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  logical,          intent(out) :: error  !
  ! Local
  character(len=*), parameter :: rname='NEW_DATA'
  real(kind=4) :: interval
  integer(kind=4) :: errcount
  character(len=message_length) :: mess
  !
  if (.not.filein_opened(rname,error))  return
  !
  if (filein_isvlm) then
    call class_message(seve%e,rname,'Not relevant for FILE IN VLM')
    error = .true.
    return
  endif
  !
  interval = 5.0
  call sic_r4(line,0,1,interval,.false.,error)
  if (error) return
  !
  ! Find if new data present
  errcount = 0
  !
  do
    do  ! Infinite loop, except in case of error. Normal exit with ^C
      !
      ! Re-read the File Descriptor and check if file has new observations.
      call classic_file_fflush(filein,error)  ! Flush for reading
      if (error)  exit  ! e.g. file has disappearead
      call classic_filedesc_read(filein,error)
      if (error)  exit
      !
      if (ix%next.lt.filein%desc%xnext) then
        ! There is new data present in file
        call class_message(seve%i,rname,'New data present')
        call class_message(seve%i,rname,'Call FIND NEW_DATA|UPDATE to rebuild the indexes')
        return
      else
        call sic_wait(interval)  ! wait for N seconds
        if (sic_ctrlc()) then
          call class_message(seve%e,rname,'Waiting loop aborted by ^C')
          error = .true.
          return
        endif
      endif
      !
      ! Reached here with no error, reset error count
      errcount = 0
    enddo
    !
    ! An error occured
    if (errcount.eq.1) then
      ! 2nd error in a row => abort
      call class_message(seve%e,rname,  &
        'Read error file '//trim(filein%spec)//'. Abort.')
      return
    endif
    !
    write(mess,'(A,A,A,F0.1,A)')  'Error reading file ',trim(filein%spec),  &
      ', try again in ',interval,' seconds'
    call class_message(seve%e,rname,mess)
    errcount = errcount+1
    error = .false.
    !
    call sic_wait(interval)
  enddo
  !
end subroutine new_data

subroutine sic_delvariable (var,user,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_delvariable
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (as calls with named arguments are used)
  !   Delete Variable VAR (any kind)
  !   If variable does not exist and request comes from user, an error
  ! is raised. If variable does not exist and request comes from
  ! program, no error is raised.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: var    ! Name of variable
  logical,          intent(in) :: user   ! User (TRUE) or Program request
  logical                      :: error  ! Return error code               Output
  ! Local
  character(len=*), parameter :: rname='DELETE'
  type(sic_identifier_t) :: varfound
  integer :: in,ier
  integer(kind=4) :: status
  logical :: local,luser,found
  character(len=message_length) :: mess
  !
  ! Locate the variable at current level
  varfound%name = var
  call sic_upper(varfound%name)
  varfound%lname = len_trim(var)
  varfound%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varfound,in)
  if (ier.ne.1) then
    ! Local variable not found: check for a global one if possible
    if (var_level.eq.0) then
      ! We are already at global level
      found = .false.
    else
      varfound%level = 0
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,varfound,in)
      found = ier.eq.1
      local = .false.       ! Found a Global variable
    endif
  else
    found = .true.
    local = var_level.ne.0  ! Found a Local variable if level non zero
  endif
  if (.not.found) then
    if (user) then
      error = .true.
      call sic_message(seve%e,rname,'No such variable '//var)
    endif
    return
  endif
  !
  ! Delete variable according to its Status
  ! First delete the possible associated python SicVar instance
#if defined(GAG_USE_PYTHON)
  call gpy_delvar(varfound%name,varfound%level)
#endif
  !
  ! Second free the associated memory (or variables if it is a structure) after
  ! flushing to disk if needed
  luser = user
  status = dicvar(in)%desc%status
  !
  if (status.eq.alias_defined) then  ! It is an alias, just delete it from the list
    call zap_alias(in)
    luser = .true.  ! Aliases always considered as user-defined (see symetric
                    ! comment in sic_def_alias)
    !
  elseif (status.eq.user_defined) then ! Interactively defined by user
    call del_alias(in,local)  ! Delete its aliases
    if (dicvar(in)%desc%type.eq.0) then    ! User-def structure...
      call sic_delstructure(varfound,user,error)
      if (error)  call sic_message(seve%f,rname,'Error deleting structure '//  &
      var)
    else
      call free_vm(dicvar(in)%desc%size,dicvar(in)%desc%addr)
    endif
    !
  elseif (status.gt.0) then   ! Image variable mapped on a GIO slot, unmap
    call del_alias(in,local)  ! Delete the aliases
    call sic_delstructure(varfound,user,error)
    if (.not.dicvar(in)%desc%readonly) then    ! A writeable image/header
      ! Warn if Nvisi is lower than visibility axis
      if (gdf_check_nvisi(status,mess).lt.0)  call sic_message(seve%w,rname,mess)
      call gdf_flih (status,.false.,error)
    endif
    call gio_fris (status,error)
    !
  elseif (status.eq.program_defined) then
    if (user) then
      call sic_message(seve%e,rname,'Program defined variable '//trim(var)//' is protected')
      error = .true.
      return
    endif
    if (associated(dicvar(in)%desc%head)) then
      ! Variable provides a header and it is not mapped on a GIO slot
      call sic_delstructure(varfound,user,error)
      error = .false.               ! Make sure in this case no error
    endif
    if (dicvar(in)%desc%type.eq.0) then    ! Program-def structure...
      call sic_delstructure(varfound,user,error)
      if (error)  call sic_message(seve%f,rname,'Error deleting structure '//  &
      var)
    endif
    !
  elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
          status.eq.free_operand     .or.  &
          status.eq.readonly_operand .or.  &
          status.eq.interm_operand   .or.  &
          status.eq.empty_operand) then      ! Not an image variable
    call sic_message(seve%e,rname,'Unexpected variable status on delete')
    write(mess,*) status,in,var
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
    !
  else                         ! Code not in list...
    call sic_message(seve%e,rname,'Unknown variable status code on delete')
    write(mess,*) status,in
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Now delete the variable from the list
  call sic_zapvariable(in,luser,local,error)
  if (error) return
  !
end subroutine sic_delvariable
!
subroutine sic_zapvariable(in,user,local,error)
  use sic_interfaces, except_this=>sic_zapvariable
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Delete Variable number IN from variable list
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: in     ! Variable number
  logical,         intent(in)    :: user   ! Is variable User defined?
  logical,         intent(in)    :: local  ! Is variable Local or Global
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier,i,ivar,ntot
  !
  dicvar(in)%desc%status = empty_operand
  ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,dicvar(in)%id)
  if (ier.ne.1) then
    call sic_message(seve%e,'VARIABLE','No such variable '//trim(dicvar(in)%id%name))
    error = .true.
    return
  endif
  if (.not.user) return
  !
  ! Locate the back pointer
  if (local) then
    do i=1,var_n
      if (var_pointer(i).eq.in) then
        ivar = i
        goto 80
      endif
    enddo
  else
    do i=var_g,maxvar
      if (var_pointer(i).eq.in) then
        ivar = i
        goto 80
      endif
    enddo
  endif
  call sic_message(seve%e,'VARIABLE','Internal error, no back pointer')
  error =.true.
  return
  !
  ! Decrement the back pointers from this one
80 continue
  if (local) then
    ntot = ivar+1
    do i=ntot,var_n
      var_pointer(i-1) = var_pointer(i)
    enddo
    var_pointer(var_n) = 0
    var_n = var_n-1
  else
    ntot = ivar-1
    do i=ntot,var_g,-1
      var_pointer(i+1) = var_pointer(i)
    enddo
    var_pointer(var_g) = 0
    var_g = var_g+1
  endif
end subroutine sic_zapvariable
!
subroutine sic_delstructure(structvar,user,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_delstructure
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Delete a Structure and all its members. It assumes the variable is a
  ! structure, not a header.
  ! This routine is called when input variable is already checked as a TRUE
  ! structure.
  !---------------------------------------------------------------------
  type(sic_identifier_t), intent(in)    :: structvar  ! Structure name to delete
  logical,                intent(in)    :: user       ! User or Program request
  logical,                intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DELETE'
  integer(kind=4) :: nvar,nn,ivar,list(maxvar),ik,status
  character(len=varname_length) :: sname,varname
  integer :: structlev,varlev
  logical :: local,luser
  character(len=message_length) :: mess
  !
  ! Determine the variable level
  structlev = structvar%level  ! NOT the current level VAR_LEVEL, since it
  local = structlev.ne.0       ! may be asked to delete a Global structure
  !
  ! Build the prefix of all the structure members
  sname = structvar%name         ! Say, MYOLD
  nn = len_trim(sname)
  if (sname(nn:nn).ne.'%') then
    nn = nn+1
    sname(nn:nn) = '%'           ! MYOLD%
  endif
  !
  ! Delete everything left under MYOLD%
  call gag_haslis(maxvar,pfvar,pnvar,list,nvar)
  do ivar=1,nvar
    ik = list(ivar)
    !
    ! Jump to next variable if name is not correct
    varname=dicvar(ik)%id%name
    if (index(varname,sname(:nn)).ne.1)  cycle  ! ivar
    !
    ! Jump to next variable if level is not correct
    varlev=dicvar(ik)%id%level
    if (varlev.ne.structlev)  cycle  ! ivar
    !
    ! Skip the current structure itself, it will be zapped by the calling routine
    if (varname.eq.sname)  cycle  ! ivar
    !
    ! Ok, found an attribute, delete it
    !
    ! Cannot use the simple SIC_HASDEL
    !   IER=SIC_HASDEL(MAXVAR,PFVAR,PNVAR,DICVAR,FOUND)
    ! because it does not reset VAR_N properly...
    !
    ! Instead, one should use SIC_ZAPVARIABLE, but
    !   - take care of not deleting space of program defined variable  S.Guilloteau
    !   - deleting space of the other                                  G.Duvert
    !   - only if it has not been deleted before                       S.Guilloteau
    !   - and only if that variable is not a Structure itself          S.Guilloteau
    !
    status = dicvar(ik)%desc%status
    luser = user .and. status.ne.program_defined
    ! This part mostly duplicated from sic_delvariable!
    if (status.eq.alias_defined) then  ! It is an alias, just delete it from the list
      call zap_alias(ik)
      luser = .true.  ! Aliases always considered as user-defined (see symetric
                      ! comment in sic_def_alias)
      !
    elseif (luser) then          ! Interactively defined by user
      if (status.eq.empty_operand) then
        ! Has already been deleted (should not happen?)
        continue
        !
      elseif (status.eq.user_defined) then
        ! Interactively defined by user
        call del_alias(ik,local)  ! Delete its aliases
        if (dicvar(ik)%desc%type.ne.0) then  ! Not a structure
          ! print *,'Zapping ',ik,dicvar(ik)%desc%status,program_defined,  &
          !  dicvar(ik)%desc%type,dicvar(ik)%desc%size,dicvar(ik)%desc%addr
          call free_vm(dicvar(ik)%desc%size,dicvar(ik)%desc%addr)
        endif
        !
      elseif (status.gt.0) then
        ! Image variable, unmap
        call del_alias(ik,local)      ! Delete the aliases
        if (.not.dicvar(ik)%desc%readonly) then ! A writeable image/header
          ! Warn if Nvisi is lower than visibility axis
          if (gdf_check_nvisi(status,mess).lt.0)  call sic_message(seve%w,rname,mess)
          call gdf_flih (status,.false.,error)
        endif
        call gio_fris (status,error)
        !
      endif
    endif
    !
    ! Now delete the variable from the list
    call sic_zapvariable(ik,luser,local,error)
    if (error) then
      call sic_message(seve%e,rname,'Error ZAP in sic_delstructure for '//varname)
    endif
    !
  enddo
  !
end subroutine sic_delstructure
!
subroutine erase_variables
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>erase_variables
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Delete and reset to zero all local variables at level
  !       VAR_LEVEL, and decrement VAR_LEVEL
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer(kind=4) :: i,in,ier,status
  logical :: error,user
  character(len=message_length) :: mess
  !
  !!Print *,'Start makeERASE_VARIABLES'
  user = .true.
  error = .false.
  !
  ! Loop BACKWARDS to delete structure items BEFORE the structure,
  ! and also to delete aliases BEFORE their pointees.
  do i=var_n,var_macro(var_level)+1,-1
    in = var_pointer (i)
    if (in.ne.0) status = dicvar(in)%desc%status
    !!Print *,'Treating ',in,status,dicvar(in)%id%name, alias_defined
    !
    if (in.eq.0) then
      ! This could happen if a STRUCTURE was deleted before its components
      call sic_message(seve%e,rname,'Lost variable in ERASE_VARIABLES')
      !
    elseif (status.eq.alias_defined) then
      !!Print *,'Found an ALIAS_DEFINED at ',in
      call zap_alias(in)    ! In this case, calls to del_alias become useless
      ! or
      ! cycle               ! Aliases will be deleted when deleting the pointee
      !                       by the calls to del_alias
    elseif (status.eq.user_defined) then  ! Interactively defined by user
      ! call del_alias(in,.true.)  ! Delete the aliases. No need! Because
      !   we are rewinding the events, all aliases should have been
      !   deleted before the pointees.
      if (dicvar(in)%desc%type.eq.0) then  ! User-def structure...
        call sic_delstructure(dicvar(in)%id,user,error)
        if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                    'structure '//dicvar(in)%id%name)
      else
        call free_vm (dicvar(in)%desc%size,dicvar(in)%desc%addr)
      endif
      !
    elseif (status.gt.0) then  ! Image or Header variable mapped on a GIO slot, unmap
      ! call del_alias(in,.true.)  ! Delete the aliases. No need! Because
      !   we are rewinding the events, all aliases should have been
      !   deleted before the pointees.
      call sic_delstructure(dicvar(in)%id,user,error)
      if (.not.dicvar(in)%desc%readonly) then
        ! Warn if Nvisi is lower than visibility axis
        if (gdf_check_nvisi(dicvar(in)%desc%status,mess).lt.0)  call sic_message(seve%w,rname,mess)
       call gdf_flih (dicvar(in)%desc%status,.false.,error)
      endif
      call gio_fris (dicvar(in)%desc%status,error)
      !
    elseif (status.eq.program_defined) then
      call sic_message(seve%e,rname,'Program defined variables are global')
      write(mess,*) status,dicvar(in)%id%name,in
      call sic_message(seve%e,rname,mess)
      error = .true.
    elseif (status.eq.empty_operand) then
      continue
    elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
            status.eq.free_operand     .or.  &
            status.eq.readonly_operand .or.  &
            status.eq.interm_operand) then
      call sic_message(seve%e,rname,'Unexpected variable status on delete')
      write(mess,*) status,dicvar(in)%id%name,in
      call sic_message(seve%e,rname,mess)
      error = .true.
    else                       ! Code not in list...
      call sic_message(seve%e,rname,'Unknown variable status code '//  &
      'on return')
      write(mess,*) status
      call sic_message(seve%e,rname,mess)
      error = .true.
    endif
    dicvar(in)%desc%status = empty_operand
#if defined(GAG_USE_PYTHON)
    call gpy_delvar(dicvar(in)%id%name,dicvar(in)%id%level)
#endif
    ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,dicvar(in)%id)
  enddo
  var_n = var_macro(var_level)
  var_level = var_level-1
  !!Print *,'Finished ERASE_VARIABLES'
end subroutine erase_variables
!
subroutine del_ima_var
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>del_ima_var
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Delete all image variables. This is called upon Program exit to
  !       ensure updating (when the mapping mechanism cannot be used).
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer :: i,in,status
  logical :: error,user
  character(len=message_length) :: mess
  !
  user = .false.               ! This is a Program Request !
  !
  ! Go FORWARD to delete structure items before the structure header
  do i=var_g,maxvar
    error = .false.    ! Reset error
    in = var_pointer (i)
    status = dicvar(in)%desc%status
    !!Print *,'DEL_IMA_VAR ',in, status, TRIM(DICVAR(IN)%id%name),DICVAR(IN)%id%LEVEL
    if (status.eq.user_defined) then   ! Interactively defined by user
      if (dicvar(in)%desc%type.eq.0) then  ! User-def structure...
        call sic_delstructure(dicvar(in)%id,user,error)
        if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                    'structure '//dicvar(in)%id%name)
      else
        call free_vm (dicvar(in)%desc%size,dicvar(in)%desc%addr)
      endif
    elseif (status.gt.0) then  ! Image variable, unmap
      call sic_delstructure(dicvar(in)%id,user,error)
      if (.not.dicvar(in)%desc%readonly) then      ! Means it is not readonly: Flush header
        ! Warn if Nvisi is lower than visibility axis
        if (gdf_check_nvisi(dicvar(in)%desc%status,mess).lt.0)  call sic_message(seve%w,rname,mess)
        call gdf_flih (dicvar(in)%desc%status,.false.,error)
      endif
      call gio_fris (dicvar(in)%desc%status,error)  ! Free image slot and do all writing if needed...
      if (error)  call sic_message(seve%f,rname,'Error deleting '//  &
                  'image '//dicvar(in)%id%name)
    elseif (status.eq.program_defined) then
      !call sic_message(seve%w,rname,'Program defined variable '//  &
      !  trim(dicvar(in)%id%name)//' is global')
      !error = .true.
      continue
    elseif (status.eq.empty_operand .or. status.eq.alias_defined) then
      continue
    elseif (status.eq.scratch_operand  .or.  &  ! Should not happen...
            status.eq.free_operand     .or.  &
            status.eq.readonly_operand .or.  &
            status.eq.empty_operand) then
      call sic_message(seve%e,rname,'Unexpected variable status on delete')
      write(mess,*) status,in,trim(dicvar(in)%id%name),' at level ',dicvar(in)%id%level
      call sic_message(seve%e,rname,mess)
      error = .true.
    else                       ! Code not in list...
      call sic_message(seve%e,rname,'Unknown variable status code on exit')
      write(mess,*) status
      call sic_message(seve%e,rname,mess)
      error = .true.
    endif
    dicvar(in)%desc%status = empty_operand
  enddo
end subroutine del_ima_var
!
subroutine sic_free_variable
  use sic_interfaces, except_this=>sic_free_variable
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Release the variable structure list at exit time
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='FREE_VARIABLE'
  integer :: ier
  !
  ! Deallocate variable arrays
  deallocate(dicvar,pnvar,var_pointer,alias,dicali,pointee,stat=ier)
  if (ier.ne.0) then
     call sic_message(seve%e,rname,'Dictionary deallocation error')
  endif
  !
end subroutine sic_free_variable

module mrtholo_interfaces_none
  interface
    subroutine mrtholo_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine mrtholo_message_set_id
  end interface
  !
  interface
    subroutine mrtholo_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine mrtholo_message
  end interface
  !
  interface
    subroutine dummyConvert(i,j,n)
      integer :: i,n,j
    end subroutine dummyConvert
  end interface
  !
end module mrtholo_interfaces_none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module imaging_fit
  use gbl_message
  !
  public :: fit_comm
  private
  !
contains
  !  
  subroutine fit_comm(line,error)
    use gkernel_interfaces
    use clean_beam_tool, only: beam_for_channel
    use uvmap_buffers
    use clean_buffers, only: clean_prog
    !---------------------------------------------------------------------------
    ! Support routine for command FIT [ifield]
    !---------------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ifield
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='FIT>COMM'
    !
    if (hbeam%loca%size.eq.0) then
       call map_message(seve%e,rname,'No Dirty Beam')
       error = .true.
       return
    endif
    clean_prog%ibeam = beam_for_channel(clean_prog%iplane,dirty%head,hbeam)
    ifield = 1
    call sic_i4(line,0,1,ifield,.false.,error)
    if (error) return
    ifield = min(hbeam%gil%dim(3),max(1,ifield))
    if (hbeam%gil%dim(3).gt.1) then
       write(chain,'(A,I4,A,I4)') 'Fitting beam # ',ifield,' /',hbeam%gil%dim(3)
       call map_message(seve%i,rname,chain)
    endif
    if (hbeam%gil%dim(4).gt.1) then
       write(chain,'(A,I4,A,I4)') 'Fitting plane # ',clean_prog%ibeam,' /',hbeam%gil%dim(4)
       call map_message(seve%i,rname,chain)
    endif
    clean_prog%major = 0.0
    clean_prog%minor = 0.0
    clean_prog%angle = 0.0
    clean_prog%thresh = 0.30
    call sic_get_real('THRESHOLD',clean_prog%thresh,error)
    !
    call clean_prog%fit_beam(hbeam,dbeam(:,:,ifield,clean_prog%ibeam),error)
    if (error) return
  end subroutine fit_comm
end module imaging_fit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module class_interfaces
  !---------------------------------------------------------------------
  ! CLASS interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use class_interfaces_public
  use class_interfaces_private
  !
end module class_interfaces
!
module class_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  use gkernel_interfaces
  use astro_interfaces_public
  use classcore_interfaces_public
  use classfit_interfaces_public
end module class_dependencies_interfaces
!
module class_api
  !---------------------------------------------------------------------
  ! @ public
  !   CLASS public interfaces, parameters, and types. Can be used by
  ! external programs
  !---------------------------------------------------------------------
  !
  use classic_api  ! This helps to hide the libclassic to programs using
                   ! the libclass
  !
  ! use class_parameters
  use class_types
  use classcore_interfaces_public
  use class_interfaces_public
  !
end module class_api
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_structure_main
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_package
  use cubetools_terminal_tool
  use cubetools_language
  use cubetools_command
  use cubetools_primitive_opt
  use cubetools_primitive_arg
  use cubetools_primitive_prod
  !
  public :: cubetools_register_package,cubetools_list_package_languages
  public :: cubetools_register_language,cubetools_list_language_commands
  public :: cubetools_register_primitive_comm
  public :: cubetools_register_primitive_opt
  public :: cubetools_register_primitive_arg
  public :: cubetools_register_primitive_prod
  public :: cubetools_register_dict
  public :: cubetools_execute_command,cubetools_show_command
  public :: cubetools_getarg
  public :: cubetools_nopt
  public :: cubetools_pack_has_language,cubetools_structure_help_iterate
  public :: pack
  !
  private
  !
  interface cubetools_getarg
     module procedure cubetools_getarg_r4
     module procedure cubetools_getarg_r8
     module procedure cubetools_getarg_i4
     module procedure cubetools_getarg_i8
     module procedure cubetools_getarg_st
  end interface cubetools_getarg
  !
  type(package_t), target :: pack
  !
contains
  !
  subroutine cubetools_register_package(name,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: help
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='REGISTER>PACKAGE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%put(name,help,error)
    if (error) return
  end subroutine cubetools_register_package
  !
  subroutine cubetools_register_language(name,authors,abstract,help,helpfile,run,langid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: authors
    character(len=*),     intent(in)    :: abstract
    character(len=*),     intent(in)    :: help
    character(len=*),     intent(in)    :: helpfile
    external                            :: run
    integer(kind=lang_k), intent(out)   :: langid
    logical,              intent(inout) :: error
    !
    type(language_t) :: template
    class(list_object_t), pointer :: lot
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='REGISTER>LANGUAGE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%lang%allocate(template,lot,error)
    if (error)  return
    lang => cubetools_language_ptr(lot,error)
    if (error) return
    call lang%put(name,authors,abstract,help,helpfile,run,error)
    if (error) return
    langid = pack%lang%n
  end subroutine cubetools_register_language
  !
  subroutine cubetools_register_primitive_comm(template,otemplate,  &
    name,syntax,abstract,help,run,popt,error,allowopt)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(command_t),        intent(in)    :: template   ! Command template
    class(primitive_opt_t), intent(in)    :: otemplate  ! Option template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    external                              :: run
    class(primitive_opt_t), pointer       :: popt       ! Return pointer to registered 'option'
    logical,                intent(inout) :: error
    logical, optional,      intent(in)    :: allowopt
    !
    type(language_t), pointer :: lang
    class(list_object_t), pointer :: lot
    type(command_t), pointer :: comm
    integer(kind=comm_k) :: ncomm
    character(len=*), parameter :: rname='REGISTER>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    !
    call lang%comm%allocate(template,lot,error)
    if (error)  return
    ncomm = lang%comm%n
    lang%ndict = lang%ndict+1
    comm => cubetools_command_ptr(lot,error)
    if (error) return
    call comm%put(ncomm,name,abstract,help,run,error)
    if (error) return
    if (present(allowopt))  comm%allowopt = allowopt
    ! The numbering of options to this command start at 0 (command==0)
    call comm%opt%lbound(0_list_k,error)
    if (error)  return
    !
    ! Register 0-eth option that contains command's syntax and a copy
    ! of its help and abstract
    call cubetools_register_primitive_opt(otemplate,name,syntax,abstract,help,popt,error)
    if (error) return
  end subroutine cubetools_register_primitive_comm
  !
  subroutine cubetools_register_primitive_opt(template,name,syntax,abstract,help,popt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    class(primitive_opt_t), pointer       :: popt  ! Return pointer to registered option
    logical,                intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(list_object_t), pointer :: lot
    integer(kind=opti_k) :: nopt
    character(len=*), parameter :: rname='REGISTER>OPTION'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    !
    call comm%opt%allocate(template,lot,error)
    if (error) return
    nopt = comm%opt%n
    if (nopt.gt.0) lang%ndict = lang%ndict+1
    popt => cubetools_primitive_opt_ptr(lot,error)
    if (error) return
    call popt%put(nopt,name,syntax,abstract,help,error)
    if (error) return
  end subroutine cubetools_register_primitive_opt
  !
  subroutine cubetools_register_primitive_arg(template,name,abstract,help,  &
    mandat,parg,error)
    !----------------------------------------------------------------------
    ! Register any argument of class primitive_arg_t in the global 'pack'
    !----------------------------------------------------------------------
    class(primitive_arg_t), intent(in)    :: template
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    integer(kind=code_k),   intent(in)    :: mandat
    class(primitive_arg_t), pointer       :: parg  ! Return pointer to actual arg
    logical,                intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(primitive_opt_t), pointer :: opt
    class(list_object_t), pointer :: lot
    integer(kind=narg_k) :: iarg
    integer(kind=4), parameter :: narginfinite=huge(1_4)
    character(len=*), parameter :: rname='REGISTER>ARGUMENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    parg => null()
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    opt  => cubetools_primitive_opt_ptr(comm%opt%list(comm%opt%n)%p,error)
    if (error) return
    iarg = opt%arg%n
    !
    ! Sanity: compare with previous registered argument
    if (iarg.gt.0) then
      parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
      if (error) return
      if (parg%mandatory.ne.code_arg_mandatory .and. mandat.eq.code_arg_mandatory) then
        call cubesyntax_message(seve%e,rname,'A mandatory argument can not follow an optional one')
        error = .true.
        return
      endif
    endif
    !
    ! Now insert new argument in option structure
    select case (mandat)
    case (code_arg_mandatory)
      opt%nargmin = opt%nargmin+1
      opt%nargmax = opt%nargmax+1
    case (code_arg_optional)
      if (opt%nargmax.ne.narginfinite)  opt%nargmax = opt%nargmax+1
    case (code_arg_unlimited)
      opt%nargmax = narginfinite
    end select
    !
    call opt%arg%allocate(template,lot,error)
    if (error)  return
    parg => cubetools_primitive_arg_ptr(lot,error)
    if (error) return
    iarg = opt%arg%n
    call parg%put(iarg,name,abstract,help,mandat,error)
    if (error) return
  end subroutine cubetools_register_primitive_arg
  !
  subroutine cubetools_register_primitive_prod(template,name,abstract,help,  &
    pprod,error)
    !----------------------------------------------------------------------
    ! Register any product of class primitive_prod_t in the global 'pack'
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: template
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    character(len=*),        intent(in)    :: help
    class(primitive_prod_t), pointer       :: pprod  ! Return pointer to actual product
    logical,                 intent(inout) :: error
    !
    type(language_t), pointer :: lang
    type(command_t), pointer :: comm
    class(list_object_t), pointer :: lot
    integer(kind=prod_k) :: iprod
    integer(kind=4), parameter :: narginfinite=huge(1_4)
    character(len=*), parameter :: rname='REGISTER>PRODUCT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    pprod => null()
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    comm => cubetools_command_ptr(lang%comm%list(lang%comm%n)%p,error)
    if (error) return
    iprod = comm%prod%n
    !
    call comm%prod%allocate(template,lot,error)
    if (error) return
    pprod => cubetools_primitive_prod_ptr(lot,error)
    if (error) return
    iprod = comm%prod%n
    call pprod%put(iprod,name,abstract,help,error)
    if (error) return
  end subroutine cubetools_register_primitive_prod
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_get_command_id(ilang,commname,commid,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=lang_k), intent(in)    :: ilang
    character(len=*),     intent(in)    :: commname
    integer(kind=comm_k), intent(out)   :: commid
    logical,              intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='GET>COMMAND>ID'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (ilang.gt.pack%lang%n .or. ilang.le.0) then
       call cubesyntax_message(seve%e,rname,'Unknown language ID')
       error = .true.
       return
    endif
    !
    lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    call lang%get_command_id(commname,commid,error)
    if (error) return
  end subroutine cubetools_get_command_id
  !
  subroutine cubetools_execute_command(line,ilang,comm,error)
    use cubetools_cmessaging
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    integer(kind=lang_k), intent(in)    :: ilang
    character(len=*),     intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    integer(kind=comm_k) :: icomm
    type(language_t), pointer :: plang
    type(command_t), pointer :: pcomm
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_get_command_id(ilang,comm,icomm,error)
    if (error) return
    call cubesyntax_message(seve%c,rname,line)
    plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
    if (error) return
    call cubetools_cmessaging_command(pcomm%name,error)
    if (error) return
    call pcomm%check(plang%name,line,error)
    if (error) return
    call pcomm%run(line,error)
    if (error) return
    call cubetools_cmessaging_nocommand(error)
    if (error) return
  end subroutine cubetools_execute_command
  !
  subroutine cubetools_show_command(lang,comm,error)
    use gkernel_interfaces
    use sic_def
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: lang
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    integer(kind=comm_k) :: ilang
    integer(kind=comm_k) :: icomm
    type(language_t), pointer :: plang
    type(command_t), pointer :: pcomm
    character(len=12) :: solved
    character(len=12), allocatable :: cnames(:)
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='SHOW>COMMAND'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%get_language_id(lang,ilang,error)
    if (error) return
    plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    allocate(cnames(plang%comm%n),stat=ier)
    if (failed_allocate(rname,'cnames',ier,error)) return
    do icomm=1,plang%comm%n
      pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
      if (error) return
      cnames(icomm) = pcomm%name
    enddo
    call cubetools_disambiguate_strict(comm,cnames,icomm,solved,error)
    if (error) return
    pcomm => cubetools_command_ptr(plang%comm%list(icomm)%p,error)
    if (error) return
    !
    call pcomm%show_minimum(lang,error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call cubesyntax_message(syntaxseve%help,rname,'For a more complete help please type:')
    call cubesyntax_message(syntaxseve%help,rname,trim(lang)//backslash//trim(solved)//' ?')
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_show_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_present(line,iopt,iarg,present,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    integer(kind=opti_k), intent(in)    :: iopt
    integer(kind=argu_k), intent(in)    :: iarg
    logical,              intent(out)   :: present
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: narg
    character(len=argu_l) :: arg
    character(len=*), parameter :: rname='CUBETOOLS>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (iarg.eq.0) then
       present = sic_present(iopt,iarg)
    else if (iarg.gt.0) then
       call sic_ch(line,iopt,iarg,arg,narg,mandatory,error)
       if (error) return
       if (arg.eq.strg_quest) then
          call cubesyntax_message(seve%r,rname,'Clever help')
          present = .false.
          error = .true.
          return
       else
          present = sic_present(iopt,iarg)
       endif
    else
       call cubesyntax_message(seve%r,rname,'Argument number must >= 0')
        present = .false.
        error = .true.
        return
    endif
  end subroutine cubetools_present
  !
  subroutine cubetools_getarg_i4(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=4),        intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>I4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_i4(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_i4
  !
  subroutine cubetools_getarg_i8(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=8),        intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_i8(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_i8
  !
  subroutine cubetools_getarg_r4(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=4),           intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>R4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_r4(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_r4
  !
  subroutine cubetools_getarg_r8(line,opt,iarg,value,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=8),           intent(inout) :: value
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>ARG>R8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_r8(line,opt%inum,iarg,value,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_r8
  !
  subroutine cubetools_getarg_st(line,opt,iarg,string,mandatory,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),       intent(in)    :: line
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(inout) :: string
    logical,                intent(in)    :: mandatory
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: narg
    character(len=*), parameter :: rname='GET>ARG>R8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_ch(line,opt%inum,iarg,string,narg,mandatory,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_getarg_st
  !
  function cubetools_nopt()
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=opti_k) :: cubetools_nopt
    !
    cubetools_nopt = sic_nopt()
  end function cubetools_nopt
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_list_package_languages(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIST>PACKAGE>LANGUAGES'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call pack%list(error)
    if (error) return
  end subroutine cubetools_list_package_languages
  !
  subroutine cubetools_list_language_commands(ilang,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=lang_k), intent(in)    :: ilang
    logical,              intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='LIST>LANGUAGE>COMMANDS'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (ilang.gt.pack%lang%n .or. ilang.le.0) then
       call cubesyntax_message(seve%e,rname,'Unknown language ID')
       error = .true.
       return
    endif
    !
    lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
    if (error) return
    call lang%list(error)
    if (error) return
  end subroutine cubetools_list_language_commands
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_register_dict(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='REGISTER>DICT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lang => cubetools_language_ptr(pack%lang%list(pack%lang%n)%p,error)
    if (error) return
    call lang%build_dict(error)
    if (error) return
  end subroutine cubetools_register_dict
  !
  function cubetools_pack_has_language(lang)
    !-------------------------------------------------------------------
    ! Return .true. if package provides the named language
    !-------------------------------------------------------------------
    logical :: cubetools_pack_has_language
    character(len=*), intent(in) :: lang
    !
    type(language_t), pointer :: plang
    integer(kind=4) :: ilang
    logical :: error
    !
    cubetools_pack_has_language = .false.
    error = .false.
    do ilang=1,pack%lang%n
      plang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
      if (error) return
      if (plang%name.eq.lang) then
        cubetools_pack_has_language = .true.
        return
      endif
    enddo
    !
  end function cubetools_pack_has_language
  !
  subroutine cubetools_structure_help_iterate(forma,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: forma
    logical,              intent(inout) :: error
    !
    call pack%help_iterate(forma,error)
    if (error) return
  end subroutine cubetools_structure_help_iterate
  !
end module cubetools_structure_main
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_flag_types
  use gkernel_interfaces
  use gmath_dicho_types
  use cubetools_parameters
  use cubelist_types
  use cubeheader_messaging
  !---------------------------------------------------------------------
  ! Support module for flags and list of flags
  !---------------------------------------------------------------------
  !
  ! Flag related symbols
  public :: flag_t
  public :: flag_k,dag_flagl
  public :: code_flag_technical,code_flag_action,code_flag_product,code_flag_user
  public :: flag_unknown
  public :: cubetools_flag_ptr,cubetools_flag_init,cubetools_flag_register_user
  public :: operator(.eq.),operator(.ne.)
  ! Flaglist related symbols
  public :: flag_list_t
  public :: cubetools_flaglist_sort
  public :: cubetools_flaglist_tostr,cubetools_flaglist_list_all,cubetools_flag_debug
  public :: cubetools_string_toflaglist
  private
  !
  ! Kinds
  integer(kind=code_k), parameter :: nkinds = 4
  character(len=*), parameter :: kinds(nkinds) = ['technic','action ','product','user   ']
  integer(kind=code_k), parameter :: code_flag_technical = 1
  integer(kind=code_k), parameter :: code_flag_action    = 2
  integer(kind=code_k), parameter :: code_flag_product   = 3
  integer(kind=code_k), parameter :: code_flag_user      = 4
  !
  integer(kind=4), parameter :: flag_k=list_k
  integer(kind=4), parameter :: dag_flagl=24
  character(len=1), parameter :: flagsep_strg=','
  integer(kind=4), parameter :: dag_mflags=10   ! [integer] Maximum number of flags associated to a node
  !
  type, extends(list_object_t) :: flag_t
     character(len=dag_flagl), private :: name
     character(len=dag_flagl), private :: key
     integer(kind=code_k),     private :: kind
     integer(kind=flag_k),     private :: id
   contains
     procedure, public :: register   => cubetools_flag_register_program  ! For program-defined flags only
     procedure, public :: list       => cubetools_flag_list
     procedure, public :: get_id     => cubetools_flag_get_id
     procedure, public :: get_name   => cubetools_flag_get_name
     procedure, public :: get_key    => cubetools_flag_get_key
     procedure, public :: get_kind   => cubetools_flag_get_kind
     procedure, public :: get_suffix => cubetools_flag_get_suffix
     procedure, public :: final      => cubetools_flag_final
  end type flag_t
  !
  interface operator(.eq.)  ! Offers syntax e.g. "myflag.eq.flag_any" to programmers
    module procedure cubetools_flag_eq
  end interface
  !
  interface operator(.ne.)  ! Offers syntax e.g. "myflag.ne.flag_any" to programmers
    module procedure cubetools_flag_ne
  end interface
  !
  ! One technical flag
  type(flag_t), target :: flag_unknown
  !
  type, extends(list_t) :: flag_list_t
  contains
    procedure, private :: insert   => cubetools_flaglist_insert
    procedure, public  :: create   => cubetools_flaglist_create
    procedure, public  :: remove   => cubetools_flaglist_remove
    procedure, public  :: prepend  => cubetools_flaglist_prepend
    procedure, public  :: append   => cubetools_flaglist_append
    procedure, public  :: contains => cubetools_flaglist_contains
    procedure, public  :: repr     => cubetools_flaglist_repr
    procedure, public  :: write    => cubetools_flaglist_write
    procedure, public  :: read     => cubetools_flaglist_read
    procedure, public  :: export   => cubetools_flaglist_export
  end type flag_list_t
  !
  ! Type for searching the global flag list
  type, extends(gi8_dicho_t) :: flag_list_dicho_t
    character(len=dag_flagl) :: searched_name = ''
  contains
    procedure, public :: compare       => flag_list_compare
    procedure, public :: compare_value => flag_list_compare_value
  end type flag_list_dicho_t
  !
  integer(kind=4), parameter :: key_l=24  ! Note the T26 tab below
  character(len=*), parameter :: form_na ='(A,T26,I11,(20(1X,A)))'  ! String array
  character(len=*), parameter :: form_nac='(A,T26,I11,A)'           ! String array (decoding)
  !
  ! The global list of flags
  type(list_t) :: flag_list
  integer(kind=flag_k), allocatable :: flag_list_sort(:)
  !
contains
  !
  !---------------------------------------------------------------------
  ! Support for scalar flags
  !---------------------------------------------------------------------
  !
  subroutine cubetools_flag_init(error)
    !-------------------------------------------------------------------
    ! Register the technical flags
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call flag_unknown%register('unknown',code_flag_technical,error)
    if (error) return
    !
    call cubetools_flaglist_sort(error)  ! Compute the sorting array
    if (error)  return
  end subroutine cubetools_flag_init
  !
  subroutine cubetools_flag_list(flag,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    logical,               intent(inout) :: error
    !
    character(mess_l) :: mess
    !
    write(mess,'(2x,a,i4,2x,3(2a,2x))')  &
      'id=',  flag%id, &
      'name=',flag%name, &
      'key=', flag%key, &
      'kind=',kinds(flag%kind)
    call cubeheader_message(seve%r,'FLAG>LIST',mess)
  end subroutine cubetools_flag_list
  !
  function cubetools_flag_get_id(flag) result(id)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    integer(kind=flag_k)      :: id
    !
    id = flag%id
  end function cubetools_flag_get_id
  !
  function cubetools_flag_get_name(flag) result(name)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    character(len=dag_flagl)  :: name
    !
    name = flag%name
  end function cubetools_flag_get_name
  !
  function cubetools_flag_get_key(flag) result(key)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    character(len=dag_flagl)  :: key
    !
    key = flag%key
  end function cubetools_flag_get_key
  !
  function cubetools_flag_get_kind(flag) result(kind)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    integer(kind=code_k)      :: kind
    !
    kind = flag%kind
  end function cubetools_flag_get_kind
  !
  function cubetools_flag_get_suffix(flag) result(suffix)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in)  :: flag
    character(len=dag_flagl+1) :: suffix
    !
    suffix = '-'//flag%name
  end function cubetools_flag_get_suffix
  !
  function cubetools_flag_eq(flag1,flag2)
    logical :: cubetools_flag_eq
    type(flag_t), intent(in) :: flag1,flag2
    cubetools_flag_eq = flag1%id.eq.flag2%id
  end function cubetools_flag_eq
  !
  function cubetools_flag_ne(flag1,flag2)
    logical :: cubetools_flag_ne
    type(flag_t), intent(in) :: flag1,flag2
    cubetools_flag_ne = flag1%id.ne.flag2%id
  end function cubetools_flag_ne
  !
  function cubetools_flag_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(flag_t), and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    type(flag_t), pointer :: cubetools_flag_ptr
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAG>PTR'
    !
    select type(tot)
    type is (flag_t)
      cubetools_flag_ptr => tot
    class default
      cubetools_flag_ptr => null()
      call cubeheader_message(seve%e,rname,  &
        'Internal error: object is not a flag_t type')
      error = .true.
      return
    end select
  end function cubetools_flag_ptr
  !
  function flag_list_compare(self,m,l)
    !-------------------------------------------------------------------
    ! Compare the names of the m-th and l-th flags
    !-------------------------------------------------------------------
    integer(kind=4) :: flag_list_compare
    class(flag_list_dicho_t), intent(in) :: self
    integer(kind=flag_k),     intent(in) :: m,l
    ! Local
    logical :: error
    type(flag_t), pointer :: flagm,flagl
    !
    flag_list_compare = 0
    error = .false.
    flagm => cubetools_flag_ptr(flag_list%list(m)%p,error)
    if (error)  return
    flagl => cubetools_flag_ptr(flag_list%list(l)%p,error)
    if (error)  return
    if (flagm%name.eq.flagl%name) then
      flag_list_compare = 0
    elseif (flag_name_gt(flagm%name,flagl%name)) then
      flag_list_compare = 1
    else
      flag_list_compare = -1
    endif
  end function flag_list_compare
  !
  function flag_list_compare_value(self,m)
    !-------------------------------------------------------------------
    ! Compare the name of the m-th flag to the searched name
    !-------------------------------------------------------------------
    integer(kind=4) :: flag_list_compare_value
    class(flag_list_dicho_t), intent(in) :: self
    integer(kind=flag_k),     intent(in) :: m
    ! Local
    logical :: error
    type(flag_t), pointer :: flag
    !
    flag_list_compare_value = 0
    error = .false.
    flag => cubetools_flag_ptr(flag_list%list(m)%p,error)
    if (error)  return
    if (flag%name.eq.self%searched_name) then
      flag_list_compare_value = 0
    elseif (flag_name_gt(flag%name,self%searched_name)) then
      flag_list_compare_value = 1
    else
      flag_list_compare_value = -1
    endif
  end function flag_list_compare_value
  !
  subroutine cubetools_flag_name2flag(name,found,flag)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Resolve the flag given its name. Raising an error or not is the
    ! responsibility of the caller.
    !-------------------------------------------------------------------
    character(len=*), intent(in)  :: name
    logical,          intent(out) :: found
    type(flag_t),     intent(out) :: flag
    ! Local
    character(len=dag_flagl) :: lname
    integer(kind=flag_k) :: iflag
    type(flag_t), pointer :: lflag
    logical :: error
    type(flag_list_dicho_t) :: dicho
    !
    lname = name
    call sic_lower(lname)
    found = .false.
    flag = flag_unknown
    !
    dicho%searched_name = lname
    call dicho%dicho(flag_list_sort,flag_list%n,.true.,iflag)
    if (iflag.eq.0)  return  ! Name not found
    ! In return jflag is the flag lower or equal to the request
    ! in the sorted array (flag_list_sort)
    !
    error = .false.
    lflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(iflag))%p,error)
    if (error)  return
    if (lflag%name.eq.lname) then
      found = .true.
      flag = lflag
    endif
    !
  end subroutine cubetools_flag_name2flag
  !
  function flag_name_gt(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 > name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_gt
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    ! Local
    integer(kind=4) :: len1,len2
    !
    if (isnumeric(name1(1:1)) .and. isnumeric(name2(1:1))) then
      ! Compare numerics as character strings, ensuring "2" < "10".
      ! NB: this won't work if mixing numerics and letters e.g. "123ABC",
      ! but what do we want in this case?
      len1 = len_trim(name1)
      len2 = len_trim(name2)
      if (len1.gt.len2) then
        flag_name_gt = .true.
      elseif (len1.lt.len2) then
        flag_name_gt = .false.
      else
        flag_name_gt = lgt(name1,name2)
      endif
    else
      flag_name_gt = lgt(name1,name2)
    endif
  end function flag_name_gt
  !
  function flag_name_lt(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 < name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_lt
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    ! Local
    integer(kind=4) :: len1,len2
    !
    if (isnumeric(name1(1:1)) .and. isnumeric(name2(1:1))) then
      ! Compare numerics as character strings, ensuring "2" < "10".
      ! NB: this won't work if mixing numerics and letters e.g. "123ABC",
      ! but what do we want in this case?
      len1 = len_trim(name1)
      len2 = len_trim(name2)
      if (len1.gt.len2) then
        flag_name_lt = .false.
      elseif (len1.lt.len2) then
        flag_name_lt = .true.
      else
        flag_name_lt = llt(name1,name2)
      endif
    else
      flag_name_lt = llt(name1,name2)
    endif
  end function flag_name_lt
  !
  function flag_name_ge(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 >= name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_ge
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    !
    flag_name_ge = .not.flag_name_lt(name1,name2)
  end function flag_name_ge
  !
  function isnumeric(c1)
    !-------------------------------------------------------------------
    ! Return .true. if the given character is an ASCII character in the
    ! range [0-9]
    !-------------------------------------------------------------------
    logical :: isnumeric
    character(len=1), intent(in) :: c1
    ! Local
    integer(kind=4) :: ichara
    !
    ichara = ichar(c1)-ichar('0')
    isnumeric = ichara.ge.0 .and. ichara.le.9
  end function isnumeric
  !
  subroutine cubetools_flag_final(obj,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(flag_t), intent(inout) :: obj
    logical,       intent(inout) :: error
    !
  end subroutine cubetools_flag_final
  !
  !---------------------------------------------------------------------
  ! Support for list of flags
  !---------------------------------------------------------------------
  !
  subroutine cubetools_flag_register_program(flag,name,kind,error)
    !----------------------------------------------------------------------
    ! Register a program-defined flag in the global flag list
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    character(len=*),      intent(in)    :: name
    integer(kind=code_k),  intent(in)    :: kind
    logical,               intent(inout) :: error
    !
    call cubetools_flag_register(flag,name,kind,error)
    if (error)  return
    ! Sorting is done once by caller
  end subroutine cubetools_flag_register_program
  !
  subroutine cubetools_flag_register_user(name,error)
    !----------------------------------------------------------------------
    ! Create and register a user-defined flag in the global flag list
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    logical,          intent(inout) :: error
    !
    type(flag_t) :: otherflag
    logical :: found
    type(flag_t), pointer :: flag
    character(len=*), parameter :: rname='FLAG>REGISTER>USER'
    !
    ! Sanity (only checked for user inputs)
    if (len_trim(name).gt.dag_flagl) then
      call cubeheader_message(seve%e,rname,'Flag name is too long')
      error = .true.
      return
    endif
    call cubetools_flag_name2flag(name,found,otherflag)
    if (found) then
      call cubeheader_message(seve%w,rname,'Flag named '''//trim(name)//''' already exists')
      return
    endif
    !
    allocate(flag)
    call cubetools_flag_register(flag,name,code_flag_user,error)
    if (error) then
      deallocate(flag)
      return
    endif
    call cubetools_flaglist_sort(error)  ! Compute the sorting array
    if (error)  return
  end subroutine cubetools_flag_register_user
  !
  subroutine cubetools_flag_register(flag,name,kind,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Register a flag in the global flag list
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    character(len=*),      intent(in)    :: name
    integer(kind=code_k),  intent(in)    :: kind
    logical,               intent(inout) :: error
    !
    ! Attributes
    flag%name = name
    call sic_lower(flag%name)
    flag%key = name
    call sic_upper(flag%key)
    flag%kind = kind
    flag%id = flag_list%n+1
    !
    ! Insert in global flag list
    call flag_list%associate(flag,error)
    if (error)  return
  end subroutine cubetools_flag_register
  !
  subroutine cubetools_flaglist_insert(list,flags,start,error)
    !-------------------------------------------------------------------
    ! Copy an array of flag_t to a tools_list_t, starting at given
    ! position.
    ! This subroutine DOES NOT CARE for list allocation or list%n.
    ! Because of this, it should not be used out of this module.
    !-------------------------------------------------------------------
    class(flag_list_t),   intent(inout) :: list
    type(flag_t),         intent(in)    :: flags(:)
    integer(kind=flag_k), intent(in)    :: start
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>INSERT'
    integer(kind=flag_k) :: iflag,oflag
    type(flag_t), pointer :: flag
    type(flag_t) :: template
    !
    do iflag=1,size(flags)
      oflag = start+iflag-1  ! Position in list
      call list%list(oflag)%allocate(template,error)
      if (error)  return
      flag => cubetools_flag_ptr(list%list(oflag)%p,error)
      if (error)  return
      flag = flags(iflag)
    enddo
  end subroutine cubetools_flaglist_insert
  !
  subroutine cubetools_flaglist_create(list,flags,error)
    !-------------------------------------------------------------------
    ! Create a tools_list_t of flag_t from an array of flag_t
    ! This creates copies of the flags. The list MUST be cleaned with
    ! the list%free() method.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>CREATE'
    integer(kind=flag_k) :: nflag
    !
    nflag = size(flags)
    call list%reallocate(nflag,error)
    if (error)  return
    !
    call list%insert(flags,1_flag_k,error)
    if (error)  return
    !
    list%n = nflag
  end subroutine cubetools_flaglist_create
  !
  subroutine cubetools_flaglist_remove(list,flags,error)
    !-------------------------------------------------------------------
    ! Free and pop the matching flags from a flag_list_t
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>REMOVE'
    integer(kind=flag_k) :: iflag,jflag
    type(flag_t), pointer :: flag
    !
    ! Start from the end because list%pop() compresses the list from the
    ! right and changes list%n
    iflag = list%n
    do while (iflag.ge.1)
      flag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      do jflag=1,size(flags)  ! This is a N^2 loop... on small numbers (<10 or so).
        if (flag.eq.flags(jflag)) then
          call list%pop(iflag,error)
          if (error)  return
          exit  ! Matched and removed from the list, go to next iflag in the list
        endif
      enddo
      iflag = iflag-1
    enddo
  end subroutine cubetools_flaglist_remove
  !
  subroutine cubetools_flaglist_prepend(list,flags,error)
    !-------------------------------------------------------------------
    ! Prepend a list of flags to a flag_list_t. Note that duplicates
    ! are allowed.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    ! Enlarge list to the left
    call list%enlarge(size(flags,kind=flag_k),1_flag_k,error)
    if (error)  return
    !
    ! Insert new ones in front
    call list%insert(flags,1_flag_k,error)
    if (error)  return
    !
    ! Finally update the size
    list%n = list%n+size(flags)
  end subroutine cubetools_flaglist_prepend
  !
  subroutine cubetools_flaglist_append(list,flags,error)
    !-------------------------------------------------------------------
    ! Append a list of flags to a flag_list_t. Note that duplicates are
    ! allowed.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    ! Enlarge list to the right
    call list%enlarge(size(flags,kind=flag_k),list%n+1,error)
    if (error)  return
    !
    ! Insert new ones to the end
    call list%insert(flags,list%n+1,error)
    if (error)  return
    !
    ! Finally update the size
    list%n = list%n+size(flags)
  end subroutine cubetools_flaglist_append
  !
  function cubetools_flaglist_contains(list,flag)
    !-------------------------------------------------------------------
    ! Return .true. if the flag_list_t contains the named flag.
    !-------------------------------------------------------------------
    logical :: cubetools_flaglist_contains
    class(flag_list_t), intent(in) :: list
    type(flag_t),       intent(in) :: flag
    ! Local
    logical :: error
    integer(kind=4) :: iflag
    type(flag_t), pointer :: pflag
    !
    error = .false.
    cubetools_flaglist_contains = .false.
    do iflag=1,list%n
      pflag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      if (pflag.eq.flag) then
        cubetools_flaglist_contains = .true.
        return
      endif
    enddo
  end function cubetools_flaglist_contains
  !
  subroutine cubetools_flaglist_tostr(flags,nflag,strflag,lstrflag,error)
    !-------------------------------------------------------------------
    ! Concatenate the flags list into a string.
    ! ---
    ! This version with a flat 'flag_t' array as argument
    !-------------------------------------------------------------------
    type(flag_t),               intent(in)    :: flags(:)
    integer(kind=flag_k),       intent(in)    :: nflag
    character(len=*), optional, intent(out)   :: strflag
    integer(kind=4),  optional, intent(out)   :: lstrflag
    logical,                    intent(inout) :: error
    ! Local
    type(flag_list_t) :: tmp
    !
    call tmp%create(flags(1:nflag),error)
    if (error)  return
    call tmp%repr(strflag=strflag,lstrflag=lstrflag,error=error)
    if (error)  return
    call tmp%final(error)
    if (error)  return
  end subroutine cubetools_flaglist_tostr
  !
  subroutine cubetools_flaglist_repr(list,strflag,lstrflag,error)
    !-------------------------------------------------------------------
    ! Concatenate the flags list into a string. This subroutine can be
    ! used to:
    !   1) concatenate the flags into an output list
    ! AND/OR
    !   2) return the length of the concatenatation
    ! ---
    ! This version with a tools_list_t as argument
    !-------------------------------------------------------------------
    class(flag_list_t),         intent(in)    :: list
    character(len=*), optional, intent(out)   :: strflag
    integer(kind=4),  optional, intent(out)   :: lstrflag
    logical,          optional, intent(inout) :: error
    ! Local
    integer(kind=4) :: iflag,nc,mc
    type(flag_t), pointer :: flag
    !
    if (list%n.le.0) then
      if (present(strflag))   strflag = ''
      if (present(lstrflag))  lstrflag = 0
      return
    endif
    !
    nc = 0
    if (present(strflag)) then
      mc = len(strflag)
    else
      mc = huge(mc)
    endif
    do iflag=1,list%n
      if (nc.gt.0) then
        nc = nc+1
        if (present(strflag)) strflag(nc:nc) = flagsep_strg
      endif
      flag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      ! ZZZ There used to be a specific support for flag_any
      if (present(strflag)) strflag(nc+1:mc) = flag%name
      nc = nc+len_trim(flag%name)
      if (nc.gt.mc) then
        if (present(strflag)) strflag(mc-1:mc) = '..'
        nc = mc
        exit
      endif
    enddo
    !
    if (present(lstrflag))  lstrflag = nc
    !
  end subroutine cubetools_flaglist_repr
  !
  subroutine cubetools_string_toflaglist(string,allownew,flags,error,sep)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Parse a string (e.g. "flag1,flag2,flag3") into a list of flags
    !----------------------------------------------------------------------
    character(len=*),           intent(in)    :: string
    logical,                    intent(in)    :: allownew  ! Allow creation of new (user-defined) flags?
    type(flag_t), allocatable,  intent(out)   :: flags(:)
    logical,                    intent(inout) :: error
    character(len=*), optional, intent(in)    :: sep       ! Override default separator
    !
    integer(kind=flag_k) :: nflag,iflag
    integer(kind=4) :: ichar,seppos(20),ierr
    character(len=1) :: lsep
    character(len=argu_l) :: oneflag
    character(len=mess_l) :: mess
    logical :: found,lerror
    character(len=*), parameter :: rname='STRING>TOFLAGLIST'
    !
    ! call cubeheader_message(dagseve%trace,rname,'Welcome')
    !
    if (len_trim(string).eq.0) then ! No flags given return
      return
    endif
    !
    if (present(sep)) then
      lsep = sep
    else
      lsep = flagsep_strg
    endif
    !
    nflag = 0
    seppos(:) = -1
    seppos(1) = 0
    do ichar=1,len_trim(string)
      if (string(ichar:ichar).eq.lsep) then
        nflag = nflag+1
        seppos(nflag+1) = ichar
      endif
    enddo
    nflag = nflag+1
    seppos(nflag+1) = len_trim(string)+1
    !
    lerror = .false.
    allocate(flags(nflag),stat=ierr)
    if (failed_allocate(rname,'flags',ierr,error)) return
    do iflag=1,nflag
      oneflag = string(seppos(iflag)+1:seppos(iflag+1)-1)
      if (oneflag.eq.'') then
        write(mess,'(3(a,i0))') 'Flag ',iflag,'/',nflag,' is empty'
        call cubeheader_message(seve%e,rname,mess)
        lerror = .true.
        cycle
      endif
      call cubetools_flag_name2flag(oneflag,found,flags(iflag))
      if (.not.found) then
        if (allownew) then
          call cubetools_flag_register_user(oneflag,error)
          if (error)  return
          call cubetools_flag_name2flag(oneflag,found,flags(iflag))
        else
          write(mess,'(3a)') 'Flag "',trim(oneflag),'" not recognized'
          call cubeheader_message(seve%e,rname,mess)
          lerror = .true.
          cycle
        endif
      endif
    enddo
    if (lerror) then
      call cubeheader_message(seve%e,rname,'Undecipherable flag list: "'//trim(string)//'"')
      error = .true.
      return
    endif
  end subroutine cubetools_string_toflaglist
  !
  subroutine cubetools_flag_debug(error)
    !-------------------------------------------------------------------
    ! Display the full list of flags registered
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=flag_k) :: iflag,jflag
    type(flag_t), pointer :: flag
    !
    do iflag=1,flag_list%n
      jflag = flag_list_sort(iflag)
      flag => cubetools_flag_ptr(flag_list%list(jflag)%p,error)
      if (error) return
      call flag%list(error)
      if (error) return
    enddo
  end subroutine cubetools_flag_debug
  !
  subroutine cubetools_flaglist_sort(error)
    !-------------------------------------------------------------------
    ! Compute the sorting array of the flag list (by alphabetical order
    ! of names)
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FLAGLIST>SORT'
    integer(kind=flag_k) :: iflag
    integer(kind=4) :: ier
    type(flag_list_dicho_t) :: sorter
    !
    if (allocated(flag_list_sort))  deallocate(flag_list_sort)
    allocate(flag_list_sort(flag_list%n),stat=ier)
    if (failed_allocate(rname,'flag_list_sort',ier,error)) return
    do iflag=1,flag_list%n
      flag_list_sort(iflag) = iflag
    enddo
    !
    call sorter%sort(flag_list_sort,flag_list%n,error)
    if (error)  return
  end subroutine cubetools_flaglist_sort
  !
  subroutine cubetools_flaglist_list_all(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    integer(kind=flag_k) :: iflag
    integer(kind=4) :: nlp,nla,nlu
    type(flag_t), pointer :: pflag
    character(len=2048) :: products,actions,users
    !
    character(len=*), parameter :: rname='FLAGLIST>LIST>ALL'
    !
    ! call cubeheader_message(dagseve%trace,rname,'Welcome')
    !
    products = ''
    actions  = ''
    users    = ''
    nlp = 0
    nla = 0
    nlu = 0
    do iflag=1,flag_list%n
       pflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(iflag))%p,error)
       if (error) return
       select case(pflag%kind)
       case(code_flag_product)
          call format_line_break(pflag%key,products,nlp)
       case(code_flag_action)
          call format_line_break(pflag%key,actions,nla)
       case(code_flag_user)
          call format_line_break(pflag%key,users,nlu)
       case default
          ! Do nothing
       end select
    enddo
    call cubeheader_message(seve%r,rname,'Product flags:')
    call cubeheader_message(seve%r,rname,products(1:len_trim(products)-1))
    call cubeheader_message(seve%r,rname,blankstr)
    call cubeheader_message(seve%r,rname,'Action flags:')    
    call cubeheader_message(seve%r,rname,actions(1:len_trim(actions)-1))
    call cubeheader_message(seve%r,rname,blankstr)
    call cubeheader_message(seve%r,rname,'User flags:')
    call cubeheader_message(seve%r,rname,users(1:len_trim(users)-1))
  contains
    subroutine format_line_break(key,line,nl)
      use cubetools_terminal_tool
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: key
      character(len=*), intent(inout) :: line
      integer(kind=4),  intent(inout) :: nl
      !
      integer(kind=4) :: nc
      character(len=*), parameter :: sep = ','
      !
      nc = len_trim(key)
      if (nl+nc+2.gt.terminal%width()) then
         write(line,'(2a)') trim(line),strg_cr
         nl = 0
      endif
      write(line,'(a,x,2a)') trim(line),trim(key),sep
      nl = nl+nc+2
    end subroutine format_line_break
  end subroutine cubetools_flaglist_list_all

  subroutine cubetools_flaglist_write(fl,lun,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(flag_list_t), intent(in)    :: fl
    integer(kind=4),    intent(in)    :: lun
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: iflag,nc
    character(len=dag_flagl), allocatable :: lflags(:)
    character(len=*), parameter :: rname='FLAGLIST>WRITE'
    !
    ! Flags
    call fl%export(lflags,error)
    if (error)  return
    ! Cosmetics: find the smallest length needed
    nc = 0
    do iflag=1,fl%n
      nc = max(nc,len_trim(lflags(iflag)))
    enddo
    write(lun,form_na) 'FLAG',fl%n,(/ (lflags(iflag)(1:nc),iflag=1,fl%n) /)
  end subroutine cubetools_flaglist_write

  subroutine cubetools_flaglist_export(fl,flags,error)
    !-------------------------------------------------------------------
    ! Export the flag list to character array
    !-------------------------------------------------------------------
    class(flag_list_t), intent(in)    :: fl
    character(len=*),   allocatable   :: flags(:)
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: iflag,ier
    type(flag_t), pointer :: flag
    character(len=*), parameter :: rname='FLAGLIST>EXPORT'
    !
    allocate(flags(fl%n),stat=ier)
    if (failed_allocate(rname,'flags',ier,error)) return
    do iflag=1,fl%n
      flag => cubetools_flag_ptr(fl%list(iflag)%p,error)
      if (error)  return
      flags(iflag) = flag%get_name()
    enddo
  end subroutine cubetools_flaglist_export

  subroutine cubetools_flaglist_read(fl,lun,error)
    class(flag_list_t), intent(inout) :: fl
    integer(kind=4),   intent(in)    :: lun
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FLAGLIST>READ'
    character(len=dag_flagl) :: chflags(dag_mflags)
    integer(kind=4) :: nflag,iflag
    type(flag_t), pointer :: flag
    class(list_object_t), pointer :: lot
    type(flag_t) :: template
    logical :: found
    !
    call cubetools_read_nch(lun,nflag,chflags,error)
    if (error)  return
    call fl%reallocate(nflag,error)
    if (error)  return
    ! Resolving codes from names below is inefficient. Solutions:
    !  1) Sort the main list, and use dichotomic search, OR
    !  2) Get rid of the integer codes (as we want flexibility
    !     e.g. user-defined flags)
    do iflag=1,nflag
      call fl%allocate(template,lot,error)
      if (error)  return
      flag => cubetools_flag_ptr(lot,error)
      if (error)  return
      call cubetools_flag_name2flag(chflags(iflag),found,flag)
      if (.not.found) then
        ! Implicitly recreate a user-defined flag in the main list
        call cubetools_flag_register_user(chflags(iflag),error)
        if (error)  return
        ! And search for it again. Not efficient but robust.
        call cubetools_flag_name2flag(chflags(iflag),found,flag)
      endif
    enddo
    fl%n = nflag
  end subroutine cubetools_flaglist_read

  subroutine cubetools_read_nch(lun,nch,ch,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: lun
    integer(kind=4),  intent(out)   :: nch
    character(len=*), intent(out)   :: ch(:)
    logical,          intent(inout) :: error
    ! Local
    character(len=key_l) :: key
    character(len=128) :: tmp
    !
    read(lun,form_nac) key,nch,tmp
    if (nch.gt.0) then
      read(tmp,*)  ch(1:nch)
    endif
  end subroutine cubetools_read_nch

end module cubetools_flag_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gtl_clear(line,error)
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command CLEAR
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  integer, parameter :: nvocab=8
  character(len=12) :: vocab(nvocab),to_check,comm
  integer :: ncom,nc,sever,usernum,cnum
  character(len=gtvpath_length) :: name
  !
  data vocab /'ALPHA','DIRECTORY','GRAPHIC','PLOT','SEGMENT','TREE',  &
    'WINDOW','WHOLE'/
  !
  if (sic_present(0,1)) then
    call sic_ke (line,0,1,to_check,nc,.true.,error)
    if (error) return
    call sic_upper(to_check)
    if (to_check.eq.'ALL') then
      ! Non-standard detection of 'ALL' as long as CLEAR ALPHA (often
      ! invoked with "CL AL" in procedures) exists, to avoid ambiguities.
      comm = 'ALL'
    else
      call sic_ambigs(rname,to_check,comm,ncom,vocab,nvocab,error)
      if (error)  return
    endif
  else
    comm = 'ALL'  ! Default is CLEAR ALL
  endif
  !
  if (strict2011) then
    sever = seve%e
  else
    sever = seve%w
  endif
  !
  select case (comm)
  case ('ALL')  ! Clear the content of all top directories
    call gtv_clear_all(error)
    call gtview('Update')
    !
  case ('ALPHA')  ! Lower alpha window
    ! Obsolete since 23-sep-2010
    call gtv_message(sever,rname,'CLEAR ALPHA is obsolete')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_clear_alpha(cw_output)
    !
  case('TREE')  ! Clear "current tree" e.g. GREG and its subdirectories
    ! Obsolete since 11-oct-2010
    call gtv_message(sever,rname,'CLEAR TREE is obsolete')
    call gtv_message(sever,rname,'Use CLEAR DIRECTORY [Name] instead')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    name = ' '
    call sic_ch(line,0,2,name,nc,.false.,error)
    if (error) return
    call gtv_clear_tree(name,error)
    if (error)  return
    call gtview('Update')
    return
    !
  case ('WHOLE')  ! All plots
    ! Obsolete since 11-oct-2010
    call gtv_message(sever,rname,'CLEAR WHOLE is obsolete')
    call gtv_message(sever,rname,'Use DESTROY ALL instead')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_destroy_all(error)
    return
    !
  case ('DIRECTORY')  ! Clear directory
    call gtl_clear_directory(line,error)
    if (error)  return
    !
  case ('GRAPHIC')  ! Raise alpha window
    ! Obsolete since 23-sep-2010
    call gtv_message(sever,rname,'CLEAR GRAPHIC is obsolete')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_clear_graphic(cw_output)
    !
  case ('PLOT')  ! Clear whole plot
    call gtv_message(sever,rname,'CLEAR PLOT is obsolete. If you want to (see HELP for details):')
    call gtv_message(sever,rname,'- clear the content of all the windows, use CLEAR [ALL]')
    call gtv_message(sever,rname,'- destroy all the directories and windows, use DESTROY ALL')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call gtv_destroy_all(error)
    return
    !
  case ('SEGMENT')  ! Clear segment
    if (sic_present(0,2)) then
      ! Clear named segment
      call gtl_clear_segment(line,error)
    else
      ! Clear last segment
      call gtdls  ! Write-protected
      call gtview('Update')
    endif
    !
  case ('WINDOW')
    call gtv_message(sever,rname,'CLEAR WINDOW is obsolete. If you want to (see HELP for details):')
    call gtv_message(sever,rname,'- destroy a window, use DESTROY WINDOW [DirName [WinNum]]')
    call gtv_message(sever,rname,'- clear the content of a window, use CLEAR DIRECTORY [DirName]')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    ! Clear named window
    !
    call gtv_open_segments_for_writing_from_main()
    !
    if (sic_present(0,2)) then
      call sic_i4(line,0,2,usernum,.true.,error)
      cnum = get_window_cnum(cw_directory,usernum,error)
      call win_destroy_one(cw_directory,cnum,error)
    else
      ! Current window
      call win_destroy_one(cw_directory,cw_directory%x%curwin,error)
    endif
    !
    call gtv_close_segments_for_writing_from_main()
    !
  case default
    call gtv_message(seve%e,rname,''''//trim(comm)//''' not yet implemented.')
    error = .true.
    return
  end select
  !
end subroutine gtl_clear
!
subroutine gtl_clear_segment(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear_segment
  use gtv_buffers
  !---------------------------------------------------------------------
  ! @ private
  !  Cleanly destroy named segment(s) from the GTV tree, reading name
  ! from the command line.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line  ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=gtvpath_length) :: argum
  integer :: nc
  !
  ! Get segment name
  call sic_ch(line,0,2,argum,nc,.true.,error)
  if (error) return
  !
  call gt_clear_segment(argum,.true.,error)
  if (error)  return
  !
end subroutine gtl_clear_segment
!
subroutine gt_clear_segment(argum_in,present,error)
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_clear_segment
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Destroy the input segment(s) given its(their) name. They can have
  ! an absolute path. Argument 'present' indicates if the segment(s)
  ! must exist i.e. if it should be an error if it(they) is(are) not
  ! found.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum_in  ! Segment name
  logical,          intent(in)    :: present   ! Must the segment exist?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  character(len=gtvpath_length) :: argum
  integer :: ia,la,iseg,isegstep,iseg1,iseg2
  logical :: isdir,found,done
  type(gt_directory), pointer :: workdir,father
  type(gt_segment), pointer :: segm
  !
  argum = argum_in
  call sic_upper(argum)
  !
  call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
  if (isdir) then
    call gtv_message(seve%e,rname,  &
      'Input segment is a directory, use CLEAR DIRECTORY [Name] instead')
    error = .true.
    return
  endif
  !
  ! Found or not found: assume it represents a segment. Parse wildcards,
  ! range and so on
  call gtl_segment_parse(argum,iseg1,iseg2,error)
  if (error) return
  la = len_trim(argum)
  ia = index(argum,':')
  isegstep=1
  if (iseg1.ge.iseg2) isegstep=-1
  !
  done = .false.
  !
  do iseg=iseg1,iseg2,isegstep
    if (iseg.ne.0) then
      write(argum(ia+1:),'(I6)') iseg
      la = ia+6
      call sic_black(argum,la)
      call decode_chemin(argum,cw_directory,workdir,isdir,segm,found)
    else
      found = .false.
    endif
    if (found.and..not.isdir) then
      father => segm%father
      if (associated(segm,father%leaf_last)) then
        ! We will destroy the last segment in the directory. We can
        ! decrease its number of segment used.
        father%segn = father%segn - 1
      endif
      !
      call clear_segment_elem(segm,error)
      if (error)  exit  ! iseg
      done = .true.
    endif
  enddo
  !
  if (error) then
    return
    !
  elseif (done) then
    call gtview('Update')
    !
  elseif (present) then
    call gtv_message(seve%e,rname,'No such segment '//argum_in)
    error = .true.
    return
  endif
  !
end subroutine gt_clear_segment
!
subroutine clear_segment_elem(segm,error)
  use gtv_interfaces, except_this=>clear_segment_elem
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Cleanly clear the input segment, taking care of the surrounding
  ! chain and pointers in the GTV tree.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  type(gt_segment), pointer :: segm   ! Segment to clear
  logical,    intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_segment), pointer :: othersegm,previous
  type(gt_directory), pointer :: father
  !
  if (associated(segm,co_segment)) then
    co_segment => null()
    co_segment_data => null()
  endif
  !
  ! Search for the previous segment in the linked list
  father => segm%father
  previous => null()
  othersegm => father%leaf_first
  do while (.not.associated(othersegm,segm))
    previous => othersegm
    othersegm => othersegm%nextseg
  enddo
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! Update the chain of segments
  if (.not.associated(previous)) then
    ! Segment to destroy is the first in the directory
    father%leaf_first => segm%nextseg  ! ... which can be null()
  else
    previous%nextseg => segm%nextseg ! ... which can be null()
  endif
  !
  ! Update the pointers of the parent directory
  if (associated(father%leaf_last,segm)) then
    ! Segment to destroy is the last in the directory
    father%leaf_last => previous ! ... which can be null()
  endif
  !
  ! Update the limits of the parent directory
  call gtv_limits(father,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! Free the segment: put it in the stack for later deletion
  segm%nextseg => null()  ! Do not delete its brother
  if (associated(segm))  &
    call x_destroy_segment(segm)  ! will call gtv_delsegments(segm)
  !
end subroutine clear_segment_elem
!
subroutine gtv_clear_all(error)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_clear_all
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command:
  !    CLEAR ALL
  ! Clean (i.e. destroy the content of) all the top directories,
  ! leaving them alive, with all their windows.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: keepall
  type(gt_directory), pointer :: brother
  !
  keepall = .true.  ! Keep all window of the cleared directory
  brother => root%son_first
  do while (associated(brother))
    call gt_clear_directory(brother,keepall,error)
    if (error)  return
    !
    brother => brother%brother
  enddo
  !
end subroutine gtv_clear_all
!
subroutine gtv_clear_tree(name_in,error)
  use gildas_def
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_clear_tree
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Erases the current tree only. If the current tree is alone,
  ! erases the whole plot, which saves space for the images...
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name_in  ! Tree name
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR TREE'
  character(len=64) :: dirname
  logical :: isdir,found,keepall
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  integer :: win_num
  !
  if (name_in.eq.' ') then
    workdir => cw_directory
    !
  else
    ! Get the directory
    dirname = name_in
    call sic_upper(dirname)
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,  &
        'Input segment is not a directory, use CLEAR SEGMENT [Name] instead')
      error = .true.
      return
    endif
    ! Protect root
    if (associated(workdir,root)) then
      call gtv_message(seve%e,rname,'Can not delete root directory <')
      error = .true.
      return
    endif
  endif
  !
  ! We will work from the ancestor (i.e. the whole tree)
  workdir => workdir%ancestor
  !
  ! Implicitely move to the ancestor
  win_num = 0
  call gtv_open_segments_for_writing_from_main()
  call cd_by_adr(workdir,win_num,error)
  call gtv_close_segments_for_writing_from_main()
  if (error)  return
  !
  keepall = .false.
  call gt_clear_directory(workdir,keepall,error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_clear_tree
!
subroutine gtl_clear_directory(line,error)
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_clear_directory
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command CLEAR DIRECTORY [Name]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=gtvpath_length) :: dirname
  integer(kind=4) :: nc
  logical :: keepall
  !
  if (sic_present(0,2)) then
    ! Clear the named directory
    call sic_ch(line,0,2,dirname,nc,.true.,error)
    if (error) return
    call gtv_clear_directory(dirname,error)
    if (error)  return
  else
    ! Clear current working directory
    keepall = .true.  ! Keep all windows
    call gt_clear_directory(cw_directory,keepall,error)  ! Thread-safe
    if (error)  return
  endif
  !
end subroutine gtl_clear_directory
!
subroutine gtv_clear_directory(name,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_clear_directory
  use gtv_buffers
  use gtv_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support for CLEAR DIRECTORY, using a name as input argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  character(len=gtvpath_length) :: uname
  logical :: isdir,found,keepall
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  !
  ! Get the directory
  uname = name
  call sic_upper(uname)
  call decode_chemin(uname,cw_directory,workdir,isdir,segm,found)
  if (.not.found) then
    call gtv_message(seve%e,rname,'No such directory '//name)
    error = .true.
    return
  endif
  if (.not.isdir) then
    call gtv_message(seve%e,rname,  &
      'Input segment is not a directory, use CLEAR SEGMENT [Name] instead')
    error = .true.
    return
  endif
  !
  keepall = .true.  ! Keep all windows
  call gt_clear_directory(workdir,keepall,error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_clear_directory
!
subroutine gt_clear_directory(dir,keepall,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>gt_clear_directory
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Cleanly destroy the content of the input directory, taking care of
  ! the surrounding elements in the GTV tree. The top directory and its
  ! first window is kept.
  !---------------------------------------------------------------------
  type(gt_directory), pointer :: dir      ! Directory to destroy
  logical,      intent(in)    :: keepall  ! Keep all the windows, or only one?
  logical,      intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CLEAR'
  type(gt_directory), pointer :: son_first,father,nextdir
  type(gt_segment), pointer :: leaf_first
  integer(kind=address_length) :: genv
  !
  ! 1) Check if we do not attempt to clear the root <
  if (associated(dir,root)) then
    call gtv_message(seve%e,rname,'Can not clear root directory')
    error = .true.
    return
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! 2) Check if the current working directory has to be destroyed.
  father => cw_directory%father
  do while (associated(father))
    if (associated(father,dir)) then
      ! One of the fathers is the directory to be *cleaned*, i.e. we will
      ! *destroy* the current directory. Switch to the directory to be
      ! cleaned.
      call cd_by_adr(dir,dir%x%curwin,error)
      if (error)  return
      exit
    endif
    father => father%father
  enddo
  !
  ! 3) Which windows keep at first level?
  if (.not.keepall) then
    ! Delete all but 1 window
    call win_destroy_almost(dir,genv,error)
    if (error)  return
    if (genv.ne.0) then
      ! There was actually a window to save
      dir%x%genv_array = c_new_genv_array(mwindows)
      dir%x%genv = genv
      call c_set_win_genv(dir%x%genv_array,0,dir%x%genv)
    endif
  endif
  !
  ! 4) Destroy the windows of all the subdirectories (because these
  !    directories will be destroyed)
  nextdir => dir%son_first
  do while (associated(nextdir))
    call win_destroy_all_recursive(nextdir,error)
    if (error)  return
    nextdir => nextdir%brother
  enddo
  !
  ! 5) Update the pointers in the GTV tree, i.e. forget about the son
  !    directories and leaves
  son_first => dir%son_first  ! Keep track before forgetting it
  dir%son_first => null()
  dir%son_last => null()
  leaf_first => dir%leaf_first  ! Keep track before forgetting it
  dir%leaf_first => null()
  dir%leaf_last => null()
  dir%segn = 0
  !
  ! 6) Update the limits of the parents directory
  call gtv_limits(dir,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! 7) Effectively destroy the list of son directories. This can be done
  !  out of the threads protection since nobody knows that the input
  !  directory had children one day.
  if (associated(son_first))  &
    call x_destroy_directory(son_first)  ! will call gtv_deldirectories(son_first)
  !
  ! 8) Effectively destroy the list of segments. This can be done out of the
  !  threads protection since nobody knows that the input directory had
  ! segments one day.
  if (associated(leaf_first))  &
    call x_destroy_segment(leaf_first)  ! will call gtv_delsegments(leaf_first)
  !
  ! 9) Update the plot. Only needed from the ancestor cleared directory
  !  (no need to refresh all directories)
  call gtview_update(dir%ancestor,error)
  !
end subroutine gt_clear_directory
!
subroutine exit_clear
  use gtv_interfaces, except_this=>exit_clear
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !  This function exists solely to prevent all the wild machinations
  ! that 'gtv_destroy_all' does in recreating the x graphical
  ! environment, when all you are really trying to do is exit the
  ! program so you can go home. It is therefore only called by program
  ! GreG before calling GTCLOS
  !---------------------------------------------------------------------
  ! Local
  logical :: error
  !
  error = .false.
  !
  ! Flush the stack (it contains the tree destruction, so call it
  ! whatever the device is).
  call x_flush(1)
  !
  if (cw_device%protocol.eq.p_x) then
    ! Clear all the directories (and the allocated data in each:
    ! polylines, images, etc). Put it in the stack to ensure that all the
    ! remaining drawing instructions have been performed.
    if (associated(root))  &
      call x_destroy_directory(root)  ! will call gtv_deldirectories(root)
  else
    call gtv_destroy_all(error)
  endif
  !
  ! Free memory allocated in global variables
  call gt_lut_dealloc(gbl_pen,error)
  call gt_lut_dealloc(gbl_colormap,error)
  !
  if (allocated(eqlev))  deallocate(eqlev,eqbin)
  !
end subroutine exit_clear
!
subroutine gti_clear(output)
  use gtv_interfaces, except_this=>gti_clear
  use gtv_types
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! - Erase the graphic screen only
  ! - Erase all bit planes
  ! - Reset most device features, and should normally be used to be sure
  !   that the initialisation is correct.
  ! - Rewinds the viewing pointers
  !---------------------------------------------------------------------
  type(gt_display) :: output  ! Output instance
  !
  if (.not.awake .or. error_condition) return
  !
  ! Return if no output device
  if (output%dev%protocol.eq.p_null) then
    return
    !
  elseif (output%dev%protocol.eq.p_x) then
    ! X protocol
    if (output%x%graph_env.ne.0)  call x_clear(output%x%graph_env)
    !
  endif
  !
end subroutine gti_clear

program grfont
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Construction du jeu de caracteres de GREG a partir de celui de HERSHEY
  !
  ! Organisation :
  !	2 Qualites de caracteres
  !		1 FAST		2 DUPLEX
  !	3 Jeux de caracteres par qualite
  !		1 ROMAIN	2 GREC		3 SCRIPT
  ! 	95 Caracteres par jeu
  !
  ! Addressage base sur le code ASCII du caractere
  !
  ! INDEX = ICHAR(caractere) - ICHAR(' ') + 1 + 100*(NJEU-1) + 300*(NQUAL-1)
  !---------------------------------------------------------------------
  ! Local
  integer :: nl,ier
  character(len=filename_length) :: argum,file
  !
  select case (command_argument_count())
  case (0)
    file = 'gag-font.bin'
  case (1)
    call get_command_argument(1,argum,nl,ier)
    if (ier.ne.0)  call sysexi(fatale)
    ! Parse input pattern
    call sic_parse_file(argum,' ','.bin',file)
  case default
    print *,'F-HERSHEY, Program expects 0 or 1 argument'
    call sysexi(fatale)
  end select
  !
  call hershey2gag(file)
  !
end program grfont

subroutine robs(obs,entry_num,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>robs
  use class_common
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Read file header into internal buffer. Then fill into the
  ! observation header the presec section and part of the general
  ! sections, namely the elements coming from the Entry Index:
  !     obs%head%gen%num
  !     obs%head%gen%ver
  !     obs%head%pos%sourc
  !     obs%head%spe%line/obs%head%sky%line
  !     obs%head%gen%teles
  !     obs%head%gen%dobs
  !     obs%head%gen%dred
  !     obs%head%pos%lamof
  !     obs%head%pos%betof
  !     obs%head%pos%system
  !     obs%head%gen%kind
  !     obs%head%gen%qual
  !     obs%head%gen%scan
  !     obs%head%dri%apos
  !     obs%head%gen%subscan
  !----------------------------------------------------------------------
  type(observation),          intent(inout) :: obs        ! Observation header
  integer(kind=entry_length), intent(in)    :: entry_num  ! Index number of observation
  logical,                    intent(out)   :: error      !
  ! Local
  type(indx_t) :: ind
  !
  outobs_modify = .false.
  error = .false.
  !
  ! Read the Entry Title, transfer it in observation
  call rix(entry_num,ind,error)
  if (error) return
  call index_toobs(ind,obs%head,error)
  if (error)  return
  obs%head%gen%ver = abs(obs%head%gen%ver)
  !
  if (filein_isvlm) then
    ! Mimic the entry descriptor
    obs%desc%xnum = entry_num
    obs%desc%ldata = filein_vlmhead%gil%dim(1)
    !
    ! Fill obs%head%presec(:) for VLM
    obs%head%presec(:) = .false.
    obs%head%presec(class_sec_gen_id) = .true.
    obs%head%presec(class_sec_pos_id) = .true.
    obs%head%presec(class_sec_spe_id) = .true.
    obs%head%presec(class_sec_res_id) = filein_vlmhead%gil%reso_words.gt.0
    !
  else
    ! Read the Entry Descriptor
    call class_entrydesc_read('ROBS',filein,ix,entry_num,obs%desc,ibufobs,error)
    if (error)  return
    !
    ! Fill obs%head%presec(:)
    call classic_entrydesc_secfind_all(obs%desc,obs%head%presec,-mx_sec,error)
    if (error)  return
  endif
  !
end subroutine robs
!
subroutine class_entrydesc_read(rname,file,idx,entry_num,ed,bufobs,error)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_entrydesc_read
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read the entry descriptor. Class overlay to the Classic subroutine
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: rname      ! Calling routine name
  type(classic_file_t),       intent(in)    :: file       ! Class file
  type(optimize),             intent(in)    :: idx        ! Associated index
  integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
  type(classic_entrydesc_t),  intent(out)   :: ed         ! Entry descriptor
  type(classic_recordbuf_t),  intent(inout) :: bufobs     ! Working buffer
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  integer(kind=4) :: ier,vobs_allowed
  !
  if (entry_num.le.0 .or. entry_num.ge.file%desc%xnext) then
    error = .true.
    write(mess,'(A,I0)') 'Non-existant index entry ',entry_num
    call class_message(seve%e,rname,mess)
    return
  endif
  !
  call classic_recordbuf_open(file,idx%bloc(entry_num),idx%word(entry_num),  &
    bufobs,error)
  if (error)  return
  !
  call classic_entrydesc_read(file,bufobs,ed,error)
  if (error)  return
  !
  if (file%desc%version.ne.1 .and. ed%xnum.ne.entry_num) then
    ! Check that xnum in entry descriptor is consistant with the requested
    ! entry number. NB: this has never been checked in V1 files, avoid
    ! rejecting V1 files which were accepted before.
    ! Should we have a way to enforce reading?
    write(mess,'(A,I0,A,I0)')  'Entry number mismatch (malformed file): got ',  &
      ed%xnum,' in entry descriptor, expected ',entry_num
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  vobs_allowed = vobs_stable
  ier = sic_getlog('CLASS_OBS_VERSION',vobs_allowed)
  if (ed%version.gt.vobs_allowed) then
    write (mess,'(A,I0,A)')  &
      'Observation revision number #',ed%version,' not supported'
    call class_message(seve%e,rname,mess)
    call class_message(seve%e,rname,'Your CLASS version is too old to read this spectrum')
    call class_message(seve%e,rname,'Please update CLASS to the latest release')
    error = .true.
    return
  endif
  !
end subroutine class_entrydesc_read
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mobs(obs,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>mobs
  use class_types
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Open an observation of the output file to modify it. The length of
  ! each section modified must be smaller than the length of the
  ! corresponding section already present.
  !  Find the latest version of this obs. in this file
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs    ! Observation header
  logical,           intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MOBS'
  integer(kind=entry_length) :: ifind(10),nf
  !
  if (obs%head%gen%ver.lt.0) then
     call class_message(seve%e,'UPDATE','Can only update last versions')
     error = .true.
     return
  endif
  !
  error = .false.
  !
  call fox(obs%head%gen%num,ifind(1))
  nf = ifind(1)
  if (nf.eq.0) then
     error = .true.
     call class_message(seve%e,rname,'Observation to be modified was not found')
     return
  endif
  !
  ! Read the Entry Descriptor
  call class_entrydesc_read(rname,fileout,ox,ifind(1),obs%desc,obufobs,error)
  if (error)  return
  !
  outobs_modify = .true.
end subroutine mobs
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine cobs(set,obs,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>cobs
  use class_common
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  !  Ends the writing of the output observation.
  !  Find the latest version of this observation in the file and
  ! decrease its version number by 32768
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    ! Observation header
  logical,             intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='COBS'
  integer(kind=entry_length) :: ifind(10),nf
  integer(kind=4) :: hver
  character(len=80) :: mess
  type(indx_t) :: ind
  logical :: dupl
  !
  if (obufobs%lun.ne.fileout%lun) then
     error = .true.
     call class_message(seve%e,rname,'Observation not open for write nor modify')
     return
  endif
  !
  if (.not.outobs_modify) then
     if (obs%head%gen%num.lt.0) then
        write(mess,'(A,I0)')  'Invalid observation number ',obs%head%gen%num
        call class_message(seve%e,rname,mess)
        error = .true.
        return
        !
     elseif (obs%head%gen%num.eq.0) then
        ! No specified number, use automatic numbering. Find next one (unused
        ! yet) available.
        call fox_next(obs%head%gen%num)
        !
     elseif (fileout%desc%single) then
        ! ObsNumber must be unique. Find if it is already used
        call fox(obs%head%gen%num,ifind(1))
        if (ifind(1).ne.0) then
          write(mess,'(A,I0,A)') 'Observation #',obs%head%gen%num,' already exists'
          call class_message(seve%e,rname,mess)
          error = .true.
          return
        endif
        !
     else
        ! Multiple versions allowed
        call fox(obs%head%gen%num,ifind(1))
        nf = ifind(1)
        if (nf.ne.0) then
           ! Found a previous observation with the same number
           hver = ox%ver(ifind(1))
           if (hver.gt.0) ox%ver(ifind(1)) = -hver  ! Mark it as "old" if it exists
           call rox(ifind(1),ind,error)
           if (error) return
           ind%ver = ox%ver(ifind(1))
           call mox(ifind(1),ind,error)
           if (hver.lt.0) hver = -hver
           if (error) return
           obs%head%gen%ver = hver
        endif
     endif
     obs%head%gen%ver = abs(obs%head%gen%ver)+1  ! The version number must
       ! increase: each WRITE assumes a difference between the original spectrum
       ! and the one written. Do not reset the number to avoid losing history.
  endif
  !
  ! Set up the Index 'ind'
  call sic_gagdate(obs%head%gen%dred)
  !
  call index_fromobs(obs%head,ind,error)
  if (error)  return
  ind%bloc = obufobs%rstart
  ind%word = obufobs%wstart
  !
  ! Write the Index entry
  if (outobs_modify) then
     call mox(obs%desc%xnum,ind,error)
     ! if (error)... we should have ensured that obufobs is flushed to
     ! the file, else we would have an entry partially updated i.e.
     ! inconsistent. But how can we have an error in mox and not before?
     ! Should never happen.
     if (error)  &
       call class_message(seve%e,rname,'Observation may be incompletely updated')
  else
     call wox(ind,error)
     ! if (error)... not so dramatic since as long the entry index and
     ! the file descriptor are not written/updated, the entry has no
     ! real existence.
     if (.not.error) then
       ! Take care of the sorting arrays
       call ox_sort_add(set,obs,dupl,error)
       if (dupl) then
         ! Undo what WOX has done
         fileout%desc%xnext = fileout%desc%xnext-1
         ox%next = ox%next-1
         if (filein_is_fileout())  ix%next = ix%next-1
       endif
     endif
  endif
  if (error) return
  !
  ! Write the observation header. Must be last since it contains the
  ! observation description e.g. number of blocks.
  if (obs%desc%version.gt.vobs_stable) then
    write (mess,'(A,I0,A)')  &
      'Observation revision number #',obs%desc%version,' is experimental'
    call class_message(seve%w,rname,mess)
  endif
  call classic_entrydesc_write(fileout,obufobs,obs%desc,error)
  if (error)  return
  !
  call classic_entry_close(fileout,obufobs,error)
  if (error)  return
  !
  ! FILE BOTH case
  if (filein_is_fileout()) then
    ! Must force "forgetting" the record currently buffered in ibufobs,
    ! because the same record may have changed on disk
    call classic_recordbuf_nullify(ibufobs)
  endif
  !
  ! Update the file header
  call cox(error)
  !
end subroutine cobs

subroutine gtl_hardcopy(line,error)
  use gildas_def
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_hardcopy
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support command for command
  ! HARDCOPY [Name]
  !  1  [/PRINT Destination]
  !  2  [/DEVICE Type [Options]]
  !  3  [/OVERWRITE]
  !  4  [/DIRECTORY]
  !  5  [/GEOMETRY]
  !  6  [/EXACT]
  !  7  [/FITPAGE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  integer(kind=4) :: nc,px,py
  logical :: doprint,keep,lover,isdir,found,doexact,dofitpage
  character(len=12) :: devtyp,devopt
  character(len=64) :: queue
  character(len=gtvpath_length) :: dirname
  type(gt_display) :: output
  type(gt_directory), pointer :: workdir
  type(gt_segment), pointer :: segm
  type(x_coordinates) :: geom
  character(len=32) :: argx,argy
  integer(kind=4), parameter :: optprint=1
  !
  ! 1) /PRINT (immediate plotting)
  doprint = sic_present(optprint,0)
  queue = ' '  ! Will use the default 'GAG_PRINTER' later on
  call sic_ch (line,optprint,1,queue,nc,.false.,error)
  if (error) return
  !
  ! 0) Command argument. Output can be:
  !  - a file (no /PRINT option and .not.GTV%STDOUT)
  !  - the terminal (no file name given and GTV%STDOUT is yes)
  !  - a printer (/PRINT option)
  if (doprint) then  ! /PRINT is present
    output%tofile = .true.
    output%file = 'gregplot'
    call sic_ch(line,0,1,output%file,nc,.false.,error)
    if (error)  return
    keep = sic_present(0,1)
    !
  elseif (sic_present(0,1)) then  ! A file name is given
    output%tofile = .true.
    call sic_ch(line,0,1,output%file,nc,.true.,error)
    if (error)  return
    keep = .true.
    !
  elseif (stdout) then  ! No file name, GTV%STDOUT is .true.
    output%tofile = .false.
    output%file = ''
    keep = .false.  ! Not relevant here
    !
  else  ! No file name, GTV%STDOUT is .false.
    output%tofile = .true.
    output%file = 'gregplot'
    keep = .true.
  endif
  !
  ! 2) /DEVICE (Device and Device dependent text)
  !
  ! Read from command line, if present
  if (sic_present(2,0)) then
    call sic_ke(line,2,1,devtyp,nc,.true.,error)
    if (error) return
    devopt = ' '
  else
    ! Else, read default from 'GAG_HARDCOPY'
    call sic_getlog_hardcopy(devtyp,devopt)
  endif
  !
  if (devtyp.eq.'PS' .or. devtyp.eq.'PDF') then
    ! Defaults
    output%autorotate = .true.
    output%autoscale = .true.
    output%color = .true.
    output%ps%fast  = .false.
    output%ps%exact = .false.
    ! Parse the command line arguments to setup the PostScript attributes
    call gtl_hardcopy_ps(line,output,error)
    if (error)  return
    ! Parse the device option
    call gt_hardcopy_ps(devopt,output,error)
    if (error)  return
    !
  elseif (devtyp.eq.'EPS' .or. devtyp.eq.'EPDF') then
    ! Defaults
    output%autorotate = .false.
    output%autoscale = .false.
    output%color = .true.
    output%ps%fast  = .false.
    output%ps%exact = .false.
    ! Parse the command line arguments to setup the PostScript attributes
    call gtl_hardcopy_ps(line,output,error)
    if (error)  return
    ! Parse the device option
    call gt_hardcopy_ps(devopt,output,error)
    if (error)  return
    !
  elseif (devtyp.eq.'PNG') then
    ! Defaults
    output%autorotate = .false.
    output%autoscale = .false.
    output%color = .true.
    output%background = 1  ! White
    output%png%transparency = .false.
    output%png%cropped = .false.
    output%png%noblank = .false.
    ! Parse the command line arguments to setup the PNG attributes
    call gtl_hardcopy_png(line,output,error)
    if (error)  return
    ! Parse the device option
    call gt_hardcopy_png(devopt,output,error)
    if (error)  return
    !
  elseif (devtyp.eq.'SVG') then
    ! Defaults
    output%autorotate = .false.
    output%autoscale = .false.
    output%background = 1  ! White
    output%color = .true.
    output%svg%cropped = .false.
    ! Parse the command line arguments to setup the SVG attributes
    call gtl_hardcopy_svg(line,output,error)
    if (error)  return
    ! Parse the device option
    call gt_hardcopy_svg(devopt,output,error)
    if (error)  return
    !
  endif
  if (doprint) then
    output%autorotate = .true.  ! If available on the device
    output%autoscale = .true.   ! idem
  endif
  !
  ! 3) /OVERWRITE
  lover = nofail.or.sic_present(3,0)
  !
  ! 4) /DIRECTORY. Which directory to dump? Default is current working
  !    directory.
  if (sic_present(4,0)) then
    call sic_ch(line,4,1,dirname,nc,.true.,error)
    if (error)  return
    call sic_upper(dirname)
    !
    call decode_chemin(dirname,cw_directory,workdir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,'Input segment is not a directory')
      error = .true.
      return
    endif
    !
  else
    workdir => cw_directory
  endif
  !
  ! 5) /GEOMETRY
  if (sic_present(5,0)) then
    if (devtyp.ne.'PNG' .and. devtyp.ne.'SVG') then
      call gtv_message(seve%e,rname,  &
        'Option /GEOMETRY is not supported for device '//devtyp)
      error = .true.
      return
    endif
    !
    call sic_ch(line,5,1,argx,nc,.true.,error)
    if (error) return
    call sic_ch(line,5,2,argy,nc,.true.,error)
    if (error) return
    call decode_coordinates(geom,argx,argy,error)
    if (error)  return
    call compute_coordinates_geometry(rname,geom,px,py,error)
    if (error)  return
    if (devtyp.eq.'PNG') then
      output%px1 = 1
      output%px2 = px
      output%py1 = 1
      output%py2 = py
    elseif (devtyp.eq.'SVG') then
      ! Size is numbered from 0 to N-1
      output%px1 = 0
      output%px2 = px-1
      output%py1 = py-1  ! Y scale increases from top to bottom in SVG
      output%py2 = 0
    endif
  else
    ! Set size to 0, will be automatic later on
    output%px1 = 0
    output%px2 = 0
    output%py1 = 0
    output%py2 = 0
  endif
  !
  ! 6) & 7) /EXACT and /FITPAGE
  doexact = sic_present(6,0)
  dofitpage = fitpage.or.sic_present(7,0)
  if (doexact .and. dofitpage) then
    call gtv_message(seve%e,rname,'Options /EXACT and /FITPAGE are exclusive')
    error = .true.
    return
  endif
  if (doexact) then
    output%ps%exact = .true.
  elseif (dofitpage) then
    output%autorotate = .true.
    output%autoscale = .true.
  endif
  !
  ! Do the job
  call gt_hardcopy(output,devtyp,workdir,keep,lover,doprint,queue,error)
  if (error)  return
  !
end subroutine gtl_hardcopy
!
subroutine sic_getlog_hardcopy(devtyp,devopt)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>sic_getlog_hardcopy
  !---------------------------------------------------------------------
  ! @ private
  ! Decode the SIC logical GAG_HARDCOPY
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: devtyp  !
  character(len=*), intent(out) :: devopt  !
  ! Local
  character(len=24) :: device
  integer :: iblank,ier
  !
  device = ' '
  ier = sic_getlog('GAG_HARDCOPY',device)
  call sic_upper(device)
  !
  iblank = index(device,' ')
  if (iblank.ne.0) then
    devtyp = device(1:iblank)
    devopt = device(iblank+1:)
  else
    devtyp = device
    devopt = ' '
  endif
  !
end subroutine sic_getlog_hardcopy
!
subroutine gtl_hardcopy_ps(line,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_hardcopy_ps
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the options specific to the PostScript devices coming from
  ! the command line.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line    ! Input command line
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  integer :: iarg,nc
  character(len=12) :: arg
  !
  ! Parse option /DEVICE
  do iarg=2,sic_narg(2)
    call sic_ke(line,2,iarg,arg,nc,.true.,error)
    if (error) return
    !
    call gt_hardcopy_ps(arg,output,error)
    if (error)  return
  enddo
  !
end subroutine gtl_hardcopy_ps
!
subroutine gt_hardcopy_ps(keyw,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_hardcopy_ps
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the input option specific to the PostScript devices.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: keyw    ! Keyword to decode
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  character(len=*), parameter :: color='COLOR'
  character(len=*), parameter :: grey='GREY'
  character(len=*), parameter :: fast='FAST'
  integer :: nk
  character(len=24) :: keyword
  !
  if (keyw.eq.' ')  return
  !
  keyword = keyw
  call sic_upper(keyword)
  nk = len_trim(keyword)
  !
  if (keyword(1:nk).eq.color(1:nk)) then
    output%color = .true.
  elseif (keyword(1:nk).eq.grey(1:nk)) then
    output%color = .false.
  elseif (keyword(1:nk).eq.fast(1:nk)) then
    output%ps%fast = .true.
  else
    call gtv_message(seve%e,rname,  &
      'PS attribute '''//keyw(1:nk)//''' not recognized')
    error = .true.
    return
  endif
  !
end subroutine gt_hardcopy_ps
!
subroutine gtl_hardcopy_png(line,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_hardcopy_png
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the options specific to the PNG device coming from the
  ! command line.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line    ! Input command line
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  integer :: iarg,nc
  character(len=12) :: arg
  !
  ! Parse option /DEVICE
  do iarg=2,sic_narg(2)
    call sic_ke(line,2,iarg,arg,nc,.true.,error)
    if (error) return
    !
    call gt_hardcopy_png(arg,output,error)
    if (error)  return
  enddo
  !
end subroutine gtl_hardcopy_png
!
subroutine gt_hardcopy_png(keyw,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_hardcopy_png
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the input option specific to the PNG devices.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: keyw    ! Keyword to decode
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  ! Declare these strings with trailing blanks so that we can use
  ! "foo(1:nk)" with nk>len_trim(foo)
  character(len=*), parameter :: black       = 'BLACK      '
  character(len=*), parameter :: white       = 'WHITE      '
  character(len=*), parameter :: color       = 'COLOR      '
  character(len=*), parameter :: grey        = 'GREY       '
  character(len=*), parameter :: transparent = 'TRANSPARENT'
  character(len=*), parameter :: cropped     = 'CROPPED    '
  character(len=*), parameter :: noblank     = 'NOBLANK    '
  integer :: nk
  character(len=24) :: keyword
  !
  if (keyw.eq.' ')  return
  !
  keyword = keyw
  call sic_upper(keyword)
  nk = len_trim(keyword)
  !
  if (keyword(1:nk).eq.white(1:nk)) then
    output%background = 1
  elseif (keyword(1:nk).eq.black(1:nk)) then
    output%background = 0
  elseif (keyword(1:nk).eq.color(1:nk)) then
    output%color = .true.
  elseif (keyword(1:nk).eq.grey(1:nk)) then
    output%color = .false.
  elseif (keyword(1:nk).eq.transparent(1:nk)) then
    output%png%transparency = .true.
  elseif (keyword(1:nk).eq.cropped(1:nk)) then
    output%png%cropped = .true.
  elseif (keyword(1:nk).eq.noblank(1:nk)) then
    output%png%noblank = .true.
  else
    call gtv_message(seve%e,rname,  &
      'PNG attribute '''//keyword(1:nk)//''' not recognized')
    error = .true.
    return
  endif
  !
end subroutine gt_hardcopy_png
!
subroutine gtl_hardcopy_svg(line,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_hardcopy_svg
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the options specific to the SVG device coming from the
  ! command line.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line    ! Input command line
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  integer :: iarg,nc
  character(len=12) :: arg
  !
  ! Parse option /DEVICE
  do iarg=2,sic_narg(2)
    call sic_ke(line,2,iarg,arg,nc,.true.,error)
    if (error) return
    !
    call gt_hardcopy_svg(arg,output,error)
    if (error)  return
  enddo
  !
end subroutine gtl_hardcopy_svg
!
subroutine gt_hardcopy_svg(keyw,output,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_hardcopy_svg
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Decode the input option specific to the SVG devices.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: keyw    ! Keyword to decode
  type(gt_display), intent(inout) :: output  ! Instance to customize
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  character(len=*), parameter :: cropped = 'CROPPED    '
  integer :: nk
  character(len=24) :: keyword
  !
  if (keyw.eq.' ')  return
  !
  keyword = keyw
  call sic_upper(keyword)
  nk = len_trim(keyword)
  !
  if (keyword(1:nk).eq.cropped(1:nk)) then
    output%svg%cropped = .true.
  else
    call gtv_message(seve%e,rname,  &
      'SVG attribute '''//keyword(1:nk)//''' not recognized')
    error = .true.
    return
  endif
  !
end subroutine gt_hardcopy_svg
!
subroutine gt_hardcopy(output,devtyp,directory,keep,lover,doprint,  &
  queue,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_hardcopy
  use gildas_def
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Generic interface to the internal hardcopy engine. Can be called
  ! either from command line or from menu.
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout) :: output      ! gt_display instance
  character(len=*),   intent(inout) :: devtyp      ! Device type
  type(gt_directory), intent(in)    :: directory   ! Directory to dump
  logical,            intent(in)    :: keep        ! Keep the file after printing?
  logical,            intent(in)    :: lover       ! Can overwrite existing file?
  logical,            intent(in)    :: doprint     ! Send to the printer immediately?
  character(len=*),   intent(inout) :: queue       ! Which printer?
  logical,            intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  character(len=commandline_length) :: command
  integer(kind=4) :: ier
  !
  error = gterrtst()
  if (error) return
  !
  call ghopen(output,devtyp,directory,lover,error)
  error = error.or.gterrtst()
  if (error) return
  if (output%tofile)  call gtv_message(seve%i,rname,trim(output%file)//' created')
  !
  ! Send to printer if requested
  if (doprint) then
    if (queue.eq.' ') then
      ier = sic_getlog('GAG_PRINTER',queue)
      call sic_lower(queue)
    endif
    !
    if (queue.ne.' ') then
#if defined(WIN32)
      command = trim(queue)//' '//output%file
#else
      ! Generic UNIX code
      command = ''
      ier = sic_getlog('GAG_LPR',command)
      command = trim(command)//trim(queue)//' '//output%file
#endif
      call gtv_message(seve%i,rname,'Printing '//trim(output%file)//' on '//queue)
      ier = gag_system(command)
      if (ier.ne.0) then
        call gsys_message(seve%e,rname,'Error printing '//output%file)
        error = .true.
        return
      endif
      !
    else
      ! Well, we should still be able to print, but the option "-P"
      ! should be removed in the logical GAG_LPR...
      call gtv_message(seve%e,rname,'GAG_PRINTER is not defined')
      error = .true.
      ! Do not return: cleaning hereafter
    endif
    !
    if (.not.keep) then
      call gtv_message(seve%i,rname,'Removing '//output%file)
      call gag_filrm(output%file)
    endif
  endif
  !
end subroutine gt_hardcopy
!
subroutine ghopen(output,devtyp,directory,lover,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>ghopen
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_types
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  Opens a specific Device of given Type, eventually using Options
  ! for setting parameters. Restricted version for hardcopies...
  !
  !  TYPE  The type of Graphics device to be used
  !        PostScript
  !
  !  DEVICE  Optional argument to indicate to which device the plot
  !          must be sent.
  !
  !  OPTION  Optional string to define some modes for specific devices
  !          PostScript Grey, Fast, Color
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout) :: output      ! gt_display instance
  character(len=*)                  :: devtyp      ! Type of device PostScript
  type(gt_directory), intent(in)    :: directory   ! Directory to dump
  logical,            intent(in)    :: lover       ! Allow overwriting existing file
  logical,            intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HARDCOPY'
  integer(kind=4) :: ier,dot,px,py
  character(len=filename_length) :: output_file
  character(len=8) :: extension
  type(gt_device), target :: dev
  type(x_coordinates) :: geom
  character(len=32) :: argx,argy
  character(len=message_length) :: mess
  logical :: dopdf,found
  character(len=commandline_length) :: command
  !
  if (.not.awake) then
    call gtv_message(seve%f,rname,'Graphic library not initialized')
    error = .true.
    return
  endif
  if (error_condition) then
    call gtv_message(seve%e,rname,'Library is in error condition')
    error = .true.
    return
  endif
  !
  ! Get new unit
  if (output%tofile) then
    ier = sic_getlun(output%iunit)
    if (ier.ne.1) then
      error = .true.
      return
    endif
  else
    output%iunit = 6  ! STDOUT
  endif
  !
  ! Setup device characteristics
  call gtx_setup(devtyp,dev,error)
  if (error)  goto 99
  !
  if (dev%protocol.ne.p_postscript .and.  &
      dev%protocol.ne.p_svg        .and.  &
      dev%protocol.ne.p_png) then
    call gtv_message(seve%e,rname,'Unsupported hardcopy device')
    error = .true.
    goto 99
  endif
  !
  dev%hardw_cursor = .false.
  call protocol_image_inquire(dev)  ! Colormap capabilities of the device
  !
  dopdf = .false.
  if (output%tofile) then
    ! Translate Logical Name in the file name
    output_file = output%file
    ier = sic_getlog(output%file,output_file)
    extension = '.'//device_list(dev%ident)
    if (dev%protocol.eq.p_postscript) then
      select case (devtyp)
      case ('EPS')
        extension = '.eps'
        dopdf = .false.
      case ('PDF','EPDF')
        extension = '.pdf'
        dopdf = .true.
      case default
        extension = '.ps'
        dopdf = .false.
      end select
      !
    elseif (dev%protocol.eq.p_svg) then
      extension = '.svg'
      !
    elseif (dev%protocol.eq.p_png) then
      extension = '.png'
    endif
    call sic_parse_file(output_file,' ',extension,output%file)
    dot = index(output%file,'.',.true.)
    if (output%file(dot:).ne.extension) then
      mess = 'File extension '''//trim(output%file(dot:))//  &
            ''' does not match its type '//devtyp
      call gtv_message(seve%w,rname,mess)
    endif
    !
    if (gag_inquire(output%file,len_trim(output%file)).eq.0) then
      if (lover) then
        call gag_filrm(output%file)
      else
        call gtv_message(seve%e,rname,  &
          'File '//trim(output%file)//' already exists')
        error = .true.
        goto 99
      endif
    endif
  endif
  !
  ! Define the current working output
  output%dev => dev
  dev%rxy = abs(dev%rxy)
  output%gx1 = 0.
  output%gx2 = directory%phys_size(1)
  output%gy1 = 0.
  output%gy2 = directory%phys_size(2)
  !
  ! If required for this device, open a channel for QIO's output or other
  call gtz_open(output,error)
  if (error)  goto 99
  !
  ! Update the current working directory limits (is this really needed
  ! if we are consistant everywhere else?)
  call gtv_limits(directory,error)
  if (error) then
    call gtv_message(seve%e,rname,'Updating current directory limits')
    return
  endif
  !
  ! Select appropriate protocol
  select case (dev%protocol)
  case (p_postscript)
    output%ps%encapsulated = devtyp.eq.'EPS' .or. devtyp.eq.'EPDF'
    !
    ! Set a PostScript size in pixels. This is dummy, but can be used
    ! in clip_psimage (scalx,scaly) to resample correctly images.
    output%px1 = 0
    output%px2 = nint(directory%phys_size(1)/2.54d0*72.d0)
    output%py1 = nint(directory%phys_size(2)/2.54d0*72.d0)
    output%py2 = 0
    if (dopdf) then
      output_file = output%file
      call sic_parse_file('tmp','gag_scratch:','.ps',output%file)
      ! Remove the temporary file for safety, if any (it can be absent)
      call gag_delete(output%file)
    endif
    call ps_open(output,directory,error)
    if (error) then
      call gtv_message(seve%e,rname,'Postscript open error')
      error = .true.
      goto 99
    endif
    dev%linit1 = 0
    dev%linit2 = 0
    !
  case (p_svg)
    if (output%px2.le.0 .or. output%py1.le.0) then
      ! Try to use user's logical SVG_GEOMETRY
      call sic_getlog_coordinates('SVG_GEOMETRY',argx,argy,error)
      if (error)  return
      geom%x = 0.
      geom%unitx = 'p'
      geom%y = 0.
      geom%unity = 'p'
      call decode_coordinates(geom,argx,argy,error)
      if (error)  return
      call compute_coordinates_geometry(rname,geom,px,py,error)
      if (error)  return
      ! Size is numbered from 0 to N-1
      output%px1 = 0
      output%px2 = px-1
      output%py1 = py-1  ! Y scale increases from top to bottom in SVG
      output%py2 = 0
    endif
    if (output%px2.le.0 .or. output%py1.le.0) then
      ! Fall back to device defaults
      output%px1 = output%dev%px1
      output%px2 = output%dev%px2
      output%py1 = output%dev%py1
      output%py2 = output%dev%py2
    endif
    call svg_open(output,error,directory)
    if (error) then
      call gtv_message(seve%e,rname,'SVG open error')
      error = .true.
      goto 99
    endif
    dev%linit1 = 0
    dev%linit2 = 0
    !
  case (p_png)
    if (output%px2.le.0 .or. output%py2.le.0) then
      ! Try to use user's logical PNG_GEOMETRY
      call sic_getlog_coordinates('PNG_GEOMETRY',argx,argy,error)
      if (error)  return
      geom%x = 0.
      geom%unitx = 'p'
      geom%y = 0.
      geom%unity = 'p'
      call decode_coordinates(geom,argx,argy,error)
      if (error)  return
      call compute_coordinates_geometry(rname,geom,px,py,error)
      if (error)  return
      output%px1 = 1
      output%px2 = px
      output%py1 = 1
      output%py2 = py
    endif
    if (output%px2.le.0 .or. output%py2.le.0) then
      ! Fall back to device defaults
      output%px1 = output%dev%px1
      output%px2 = output%dev%px2
      output%py1 = output%dev%py1
      output%py2 = output%dev%py2
    endif
    call png_open(output,error,directory)
    if (error) then
      call gtv_message(seve%e,rname,'PNG open error')
      error = .true.
      goto 99
    endif
    dev%linit1 = 0
    dev%linit2 = 0
    !
  end select
  !
  ! Write initialisation sequence
  if (dev%linit1.gt.0) call cwrite(output,dev%init1,dev%linit1)
  !
  ! Rewind the plot from 'directory' in the output instance:
  call gtview_rewind(output,directory)
  ! And close the output device
  call ghclos(output)
  !
  if (dopdf) then
    if (devtyp.eq.'EPDF') then
      found = gag_which('epstopdf','$PATH',command)
      if (.not.found) then
        call gtv_message(seve%e,rname,'epstopdf not found in your $PATH')
        error = .true.
        return
      endif
      command = trim(command)//' '//trim(output%file)//' --outfile='//output_file
    else
      found = gag_which('ps2pdf','$PATH',command)
      if (.not.found) then
        call gtv_message(seve%e,rname,'ps2pdf not found in your $PATH')
        error = .true.
        return
      endif
      command = trim(command)//' '//trim(output%file)//' '//output_file
    endif
    ier = gag_system(command)
    if (ier.ne.0) then
      call gsys_message(seve%e,rname,'Error converting '//trim(output%file)//' to PDF')
      call gsys_message(seve%e,rname,'Command was: '//command)
      error = .true.
      return
    endif
    call gag_filrm(output%file)  ! Remove the temporary .ps file
    output%file = output_file
  endif
  !
99 continue  ! Jump here in case of error
  call gtz_close(output)
  if (output%tofile)  call sic_frelun(output%iunit)
  call gt_output_reset(output)
  !
end subroutine ghopen
!
subroutine ghclos(output)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>ghclos
  use gtv_types
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !   Switches back to alpha mode, and empties the buffer.
  !   GHCLOS also resets flags VECFIL and LL601.
  !
  !   AWAKE flag is not reset by GTCLOS, as GTINIT is required only once
  ! even for multiple GTOPEN calls IUNIT is closed AND libered.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Output instance
  !
  if (.not.awake .or. error_condition) return
  !
  select case (output%dev%protocol)
  case(p_postscript)
    call ps_close
  case(p_svg)
    call svg_close
  case(p_png)
    call png_close(output)
  case default
    if (output%dev%linit2.gt.0)  &
      call cwrite(output,output%dev%init2,output%dev%linit2)
  end select
  !
end subroutine ghclos
!
function rgb_to_grey(r,g,b)
  !---------------------------------------------------------------------
  ! @ private
  ! Convert the 3 RGB intensities into a grey luminance
  ! Method choosen in the one implemented in the GIMP:
  !  see http://gimp-savvy.com/BOOK/index.html?node54.html
  ! ---
  !   This function transforms a 24-bit, three-channel, color image to
  ! an 8-bit, single-channel greyscale image by forming a weighted sum
  ! of the red, green, and blue components. The formula used in the GIMP
  ! is Y = 0.3R + 0.59G + 0.11B; this result is known as luminance (see
  ! [4] or [5]). The weights used to compute luminance are related to
  ! the monitor's phosphors. The explanation for these weights is due to
  ! the fact that for equal amounts of color the eye is most sensitive
  ! to green, then red, and then blue. This means that for equal amounts
  ! of green and blue light the green will, nevertheless, seem much
  ! brighter. Thus, the image obtained by the normal averaging of an
  ! image's three color components produces a greyscale brightness that
  ! is not perceptually equivalent to the brightness of the original
  ! color image. The weighted sum that defines Y, however, does.
  !---------------------------------------------------------------------
  real(kind=4) :: rgb_to_grey  ! Function value on return
  real(kind=4), intent(in) :: r  ! R intensity
  real(kind=4), intent(in) :: g  ! G intensity
  real(kind=4), intent(in) :: b  ! B intensity
  !
  ! Direct
  ! rgb_to_grey = (r+g+b)/3.
  !
  ! Natural
  rgb_to_grey = 0.3*r + 0.59*g + 0.11*b
  !
  ! Desaturate
  ! rgb_to_grey = (max(r,g,b)+min(r,g,b))/2.
  !
end function rgb_to_grey
!
subroutine gt_hardcopy_crop(output,dir,error)
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Crop the area viewed by the output instance
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout) :: output  ! Output instance
  type(gt_directory), intent(in)    :: dir     ! The directory to display
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  integer(kind=4) :: px,py
  real(kind=4) :: pngratio,phyratio
  !
  output%gx1 = dir%gen%minmax(1)
  output%gx2 = dir%gen%minmax(2)
  output%gy1 = dir%gen%minmax(3)
  output%gy2 = dir%gen%minmax(4)
  !
  ! Rescale the device size
  px = abs(output%px2-output%px1)+1
  py = abs(output%py2-output%py1)+1
  !
  pngratio = real(py)/real(px)
  phyratio = (output%gy2-output%gy1)/(output%gx2-output%gx1)
  !
  if (phyratio.gt.pngratio) then
    ! The plot is more vertically elongated than the PNG. Shrink
    ! the PNG width
    if (output%px1.lt.output%px2) then
      output%px2 = output%px1+floor(py/phyratio)
    else
      output%px1 = output%px2+floor(py/phyratio)
    endif
  else
    ! The plot is more horizontally elongated than the PNG. Shrink
    ! the PNG height
    if (output%py1.lt.output%py2) then
      output%py2 = output%py1+floor(px*phyratio)
    else
      output%py1 = output%py2+floor(px*phyratio)
    endif
  endif
  !
end subroutine gt_hardcopy_crop

subroutine clic_monitor(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  !---------------------------------------------------------------------
  ! Command MONITOR
  ! It processes CAL scans as encountered, to deduce the atmospheric
  ! parameters from the monitor at 230 GHz (receiver 2, in fact).
  ! Monitor time 0|1
  ! time defaults to 1 h ; 0 means each interval is one scan
  ! 0 for constant, 1 for linear fit to the atm power data.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_write
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ldata_in 
  integer(kind=entry_length)   :: k,kx,kxsave,kx1,kx2
  integer :: ia,izero, it
  integer :: save_mon(matmon), s_scan
  character(len=12) :: source1,ch
  real*8 :: interval, mininterval, t_old, t_now, dt
  !      PARAMETER (MININTERVAL=55.0D0)
  parameter (mininterval=10.0d0)
  integer :: chop, cold, sky, mes, i
  parameter (chop=1, cold=2, sky=3)
  real*8 :: st(3), st2(3), sw(3), t0(3,mnant), t1(3,mnant), dn
  real*8 :: sy(3,mnant), syt(3,mnant)
  real*8 :: times(m_cx)
  real :: test
  !
  ! probably not useful here 18-oct-1999
  save save_mon, s_scan
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do_write = .not.sic_present(3,0)
  if (do_write) then
    call check_output_file(error)
    if (error) return
    call check_equal_file(error)
    if (error) return
  endif
  !
  ! default 1 hour
  ! Monitor 0 : use average of scan as reference
  !
  interval = 3600.0d0
  call sic_r8(line,0,1,interval,.false.,error)
  interval = max(mininterval,interval)
  !
  ideg = 0
  call sic_i4(line,0,2,ideg,.false.,error)
  ideg = max(0,ideg)
  ideg = min(1,ideg)
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) return
  do i=1, mnant
    r_ccold_mon(i) = 0
    r_cchop_mon(i) = 0
    r_csky_mon(i) = 0
  enddo
  call r4tor4(r_nrec_mon,save_mon,matmon)
  !
  ! Get storage and data
  call get_data (ldata_in,data_in,error)
  if (error) return
  ! Decode average data record header:
  kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
  call decode_header (memory(kin))
  source1 = r_sourc
  do i=1, 3
    sw(i) = 0
    st(i) = 0
    st2(i) = 0
  enddo
  do ia = 1, r_nant
    do i=1, 3
      sy(i,ia) = 0
      syt(i,ia) = 0
    enddo
  enddo
  izero = dh_obs
  t_now = mod(dh_utc+86400d0-dh_integ/2.d0,86400d0)
  t_old = t_now
  times(knext) = 0
  kx1 = knext
  kx2 = knext
  end = .false.
  do while (.not.end)
    !
    ! Process
    mes = 0
    if (r_proc.eq.p_cal .and. r_scaty.eq.4) then
      mes = chop
    elseif (r_proc.eq.p_cal .and. r_scaty.eq.7) then
      mes = cold
    elseif (r_proc.ne.p_pass) then
      mes = sky
    endif
    if (mes.ne.0) then
      dt = t_now-t_old
      do ia=1, r_nant
        sy(mes,ia) = sy(mes,ia)+dh_test1(2,ia)*dh_integ
        syt(mes,ia) = syt(mes,ia)+dh_test1(2,ia)*dt*dh_integ
      enddo
      st(mes) = st(mes)+dt*dh_integ
      st2(mes) = st2(mes)+dt**2*dh_integ
      sw(mes) = sw(mes)+dh_integ
    endif
    !
    ! Next observation
    if (sic_ctrlc()) then
      error = .true.
      return
    endif
    kx2 = knext
    error = .false.
    s_scan = r_scan
    call get_next(end, error)
    if (error) return
    !
    ! Get storage and data
    call get_data (ldata_in,data_in,error)
    if (error) return
    kin = gag_pointer(data_in,memory) + r_ndump*r_ldump
    call decode_header (memory(kin))
    it = dh_obs-izero
    t_now = dble(it)*86400d0   &
      +mod(dh_utc-dh_integ/2.+86400d0,86400d0)
    times(knext) = t_now-t_old
    !
    ! Write the data if period has elapsed:
    if (end .or. (r_scan.ne.s_scan .and. ((r_sourc.ne.source1)   &
      .or. (dabs(t_old-t_now).ge.interval)))) then
      !
      ! Compute the regression coefficients
      do i=1, 3
        dn = st2(i)*sw(i)-st(i)**2
        if (dn.ne.0 .and. ideg.eq.1) then
          do ia = 1,r_nant
            t1(i,ia)=(syt(i,ia)*sw(i)-sy(i,ia)*st(i))/dn
            t0(i,ia)=-(syt(i,ia)*st(i)-sy(i,ia)*st2(i))/dn
          enddo
        elseif (sw(i).ne.0) then
          do ia = 1,r_nant
            t1(i,ia)=0
            t0(i,ia)=sy(i,ia)/sw(i)
          enddo
        else
          do ia = 1,r_nant
            t1(i,ia)=0
            t0(i,ia)=0
          enddo
        endif
      enddo
      !
      if (sw(chop).eq.0 .and. interval.gt.mininterval) then
        write(ch,'(i4,a4,i4)')   &
          ix_scan(cx_ind(kx1)),' to ',ix_scan(cx_ind(kx2))
        call message(8,2,'MONITOR   ',   &
          'Uncalibrated monitor data scans '//ch(1:12))
      endif
      !
      ! reset the counters
      do i=1, 3
        sw(i) = 0
        st(i) = 0
        st2(i) = 0
      enddo
      do ia = 1, r_nant
        do i=1, 3
          sy(i,ia) = 0
          syt(i,ia) = 0
        enddo
      enddo
      kxsave = r_xnum
      do k = kx1, kx2
        kx = cx_ind(k)
        call get_it(kx, error)
        if (r_proc.eq.p_cal .and. r_scaty.eq.5) then
          do ia=1,r_nant
            test  = t1(chop,ia)*times(k)+t0(chop,ia)
            if (test.gt.0) r_cchop_mon(ia)=test
            r_ccold_mon(ia) = t1(cold,ia)*times(k)+t0(cold,ia)
          enddo
          error = .false.
          call do_monitor (.false.,error)
          do i=1, mnant
            r_ccold_mon(i) = 0
          enddo
          if (.not.error)   &
            call r4tor4(r_nrec_mon,save_mon,matmon)
        else
          call r4tor4(save_mon,r_nrec_mon,matmon)
        endif
        do ia=1,r_nant
          r_csky_mon(ia)=t1(sky,ia)*times(k)+t0(sky,ia)
        enddo
        if (do_write) then
          call write_scan (.false.,error)
          if (error) return
        endif
      enddo
      ! after writing, reload the next scan
      if (.not.end) then
        call get_it(kxsave, error)
        kx1 = knext
        kx2 = knext
        t_old = t_now
        times(knext) = 0
        source1 = r_sourc
      endif
    endif
  enddo
  !
  return
end subroutine clic_monitor
!
subroutine do_monitor (again,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! The chopper standard program is called for each antenna,
  ! in the mode selected in OBS.
  !---------------------------------------------------------------------
  logical :: again                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer :: ia, ntrec
  real :: frs, fri, fro, awater, prec_water
  character(len=160) :: ch
  integer :: mode_au, mode_tr, ilevel
  character(len=4) :: cmode(mnant)
  character(len=2) :: chcode
  !------------------------------------------------------------------------
  ! Code:
  call chtoby('AU  ',mode_au,4)
  call chtoby('TR  ',mode_tr,4)
  ! Force input values if desired
  ilevel = 1
  if (r_proc.eq.p_cal) ilevel=6
  do ia = 1, r_nant
    !
    ! Water
    if (atm_mode(ia).eq.'AUTO') then
      if (atm_water.eq.0) then
        r_h2o_mon(ia) =  prec_water(r_tamb,r_humid)
      elseif (atm_water.gt.0) then
        r_h2o_mon(ia) = atm_water
      endif
      r_cmode_mon(ia) = mode_au
    elseif (atm_mode(ia).eq.'TREC') then
      if (atm_trec(ia).gt.0) then
        r_trec_mon(ia) = atm_trec(ia)
      endif
      r_cmode_mon(ia) = mode_tr
    endif
    !
    ! Gain Image
    if (atm_gim(ia).gt.0) then
      r_gim_mon(ia) = atm_gim(ia)
    endif
    write(cmode(ia),'(a2)')  chcode(r_cmode_mon(ia))
  enddo
  ! Get continuum measurement
  frs = r_frs_mon/1000.
  fri = r_fri_mon/1000.
  fro = r_flo1/1000.
  !
  ! TREC antennas
  ntrec = 0
  awater = 0
  do ia=1, r_nant
    !         print *, 'ia, cmode(ia), R_CMODE_MON(IA)',
    !     $        ia, cmode(ia), R_CMODE_MON(IA)
    if (cmode(ia).eq.'TR') then
      error = .false.
      call chopper_mon (cmode(ia), r_el, frs, fri, r_tamb,   &
        r_pamb, r_alti, r_feff_mon(ia),   &
        r_tchop_mon(ia), r_tcold_mon(ia), r_trec_mon(ia),   &
        r_gim_mon(ia), r_csky_mon(ia), r_cchop_mon(ia),   &
        r_ccold_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
        r_h2o_mon(ia), r_tatms_mon(ia), r_tatmi_mon(ia),   &
        r_taus_mon(ia), r_taui_mon(ia),   &
        again,fro, r_path_mon(ia), r_dpath_mon(ia), error)
      if (.not.again) then
        write(ch,1000) r_kant(ia),   &
          chcode(r_cmode_mon(ia)), r_h2o_mon(ia),   &
          r_trec_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
          r_dpath_mon(ia)
        call message(ilevel,1,'MONITOR   ',ch(1:lenc(ch)))
      endif
      if (.not.error) then
        awater = awater+r_h2o_mon(ia)
        ntrec = ntrec+1
      endif
    endif
  enddo
  if (ntrec.gt.0) awater = awater / ntrec
  !
  ! Then other modes
  do ia = 1, r_nant
    if (r_cmode_mon(ia).eq.mode_au) then
      if (ntrec.gt.0) r_h2o_mon(ia) = awater
    endif
    if (cmode(ia).ne.'TR' .and. cmode(ia).ne.'NO') then
      error = .false.
      call chopper_mon (cmode(ia), r_el, frs, fri, r_tamb,   &
        r_pamb, r_alti, r_feff_mon(ia),   &
        r_tchop_mon(ia), r_tcold_mon(ia), r_trec_mon(ia),   &
        r_gim_mon(ia), r_csky_mon(ia), r_cchop_mon(ia),   &
        r_ccold_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
        r_h2o_mon(ia), r_tatms_mon(ia), r_tatmi_mon(ia),   &
        r_taus_mon(ia), r_taui_mon(ia),   &
        again,fro, r_path_mon(ia), r_dpath_mon(ia), error)
      if (.not.again) then
        write(ch,1000) r_kant(ia),   &
          chcode(r_cmode_mon(ia)), r_h2o_mon(ia),   &
          r_trec_mon(ia), r_tsys_mon(ia), r_tem_mon(ia),   &
          r_dpath_mon(ia)
        call message(ilevel,1,'MONITOR   ',ch(1:lenc(ch)))
      endif
    endif
  enddo
  !
  return
1000 format('A',i1,1x,a2,' H2O=',f6.2,' Tr=',f5.1,   &
    ' Tsys=',f5.1,' Tem=',f5.1,' Dpath=',f6.3)
end subroutine do_monitor
!
subroutine chopper_mon (cmode, el, frs, fri, tamb, pamb, alti,   &
    feff, tchop, tcold, trec, gim, csky, cchop, ccold,   &
    tsysd, tem, h2o, tatms, tatmi, taus, taui,   &
    again, fro, path, dpath, error)
  use gkernel_interfaces
  use atm_interfaces_public
  !---------------------------------------------------------------------
  ! CLIC
  !	compute TCAL, TSYS, TREC, from the chop and atm values observed
  !	according to the usual chopper method (Ulich and Haas)
  !
  !	Double side band operation
  !
  !	_ If cmode is 'AU' and a cold load is available, or if cmode
  !	is 'TR', derive the sky emission TEMI from the receiver
  !	temperature TREC, and then H2O from the best model fitting.
  !	_ Else, if cmode is 'AU', the sky emission is computed from
  !	the given H2O,
  !       _ if cmode is 'MA', the sky emission is computed from the
  !       given opacities and atmospheric temperatures.
  !
  !  	Uses a curved atmosphere, equivalent height 5.5 KM
  !
  !	FRS, FRI   I	R Frequencies signal image in GHz (!!!)
  !       tamb       I    R Ambient temperature (K)
  !       pamb       I    R Ambient pressure (mbar)
  !       alti       I    R altitude in km
  !       FEFF       I    R Forward Eff
  !       BEFF       I    R Beam Eff
  !       TCHOP      I    R Ambient Load Temperature (K)
  !       TCOLD      I    R Cold  Load Temperature (K)
  !       GIM        I    R Image/Signal Gain ratio
  !       CCHOP      I    R Ambient Load Counts
  !       CSKY       I    R Sky Counts
  !       CCOLD      I    R Cold  Load Counts
  !	TREC       I/O  R Receiver dsb temperature (K)
  !	TSYSD 	   O    R DSB system temperature (K)
  !       H2O        O    R Water vapor content (mm)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  !
  character(len=2) :: cmode         !
  real :: el                        !
  real :: frs                       !
  real :: fri                       !
  real :: tamb                      !
  real :: pamb                      !
  real :: alti                      !
  real :: feff                      !
  real :: tchop                     !
  real :: tcold                     !
  real :: trec                      !
  real :: gim                       !
  real :: csky                      !
  real :: cchop                     !
  real :: ccold                     !
  real :: tsysd                     !
  real :: tem                       !
  real :: h2o                       !
  real :: tatms                     !
  real :: tatmi                     !
  real :: taus                      !
  real :: taui                      !
  logical :: again                  !
  real :: fro                       !
  real :: path                      !
  real :: dpath                     !
  logical :: error                  !
  ! Global
  real*8 :: air_mass
  ! Local
  real :: dtem, airmas, tatm, taut, dwater, err, deltaw
  real :: temis, temii, tsky, temi, t1, t2, h2o1, path1
  real :: h2o2, path2, tem1, tem2, t3, t4
  integer :: k, ier, lc
  character(len=80) :: chain
  !------------------------------------------------------------------------
  error = .false.
  ier = 0
  airmas = air_mass(el)
  !
  if (again) goto 500
  !
  ! Check for Really bad atmosphere
  if (csky.ge.cchop) then
    write(chain,1000) csky, cchop
1000 format('Bad Atmosphere: SKY=',1pg11.4,'; CHOP=',1pg11.4)
    lc = lenc(chain)
    call message (8,3,'CHOPPER_MON',chain(1:lc))
    error = .true.
    return
  endif
  if (ccold.ge.cchop) then
    call message (8,3,'CHOPPER_MON',   &
      'Signal stronger on COLD than on CHOPPER')
    error = .true.
    return
  endif
  !
  ! AUTO mode with cold load or fixed TREC : minimize for water vapor
  ! content
  if ((cmode.eq.'AU' .and. ccold.gt.0)   &
    .or. cmode.eq.'TR') then
    if (atm_interpolate) then
      call atm_atmosp_i (tamb, pamb, alti)   ! press at 2550m
    else
      call atm_atmosp (tamb, pamb, alti)   ! press at 2550m
    endif
    ! use a reasonable starting value
    h2o = min(10.,max(0.5,h2o))
    !
    ! cold load available: compute TREC
    if (ccold.ne.0) then
      trec = (tcold*cchop - tchop*ccold ) / (ccold-cchop)
    endif
    !
    ! Compute TSKY: antenna temperature on sky
    tsky = (tchop+trec) *csky/cchop-trec
    !
    ! And TEMI: brightness temperature of sky
    temi = (tsky - (1.-feff)*tamb) / feff
    err = 1e10
    dwater = .02
    k = 0
10  continue
    k = k + 1
    if (atm_interpolate) then
      call atm_transm_i (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      taus = t1 + t2
      call atm_transm_i (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
      taui = t1 + t2
      tem = (temis + temii*gim) / (1.+gim)
      call atm_transm_i (h2o+dwater,airmas,frs,temis,   &
        tatm, t1, t2, taut,ier)
      call atm_transm_i (h2o+dwater, airmas, fri,temii,   &
        tatm, t1, t2, taut,ier)
    else
      call atm_transm (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      taus = t1 + t2
      call atm_transm (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
      taui = t1 + t2
      tem = (temis + temii*gim) / (1.+gim)
      call atm_transm (h2o+dwater,airmas,frs,temis,   &
        tatm, t1, t2, taut,ier)
      call atm_transm (h2o+dwater, airmas, fri,temii,   &
        tatm, t1, t2, taut,ier)
    endif
    dtem = (temis + temii*gim) / (1.+gim) - tem
    err = tem - temi
    if (abs(err) .ge. 0.1 .and. dtem.ne.0 .and. k.le.10) then
      deltaw = dwater * err / dtem
      if(abs(dwater).ge.abs(deltaw/10.)) dwater = deltaw/10.
      ! limit optical depth to [0.01,~20]
      h2o = max(0.01,min(h2o-deltaw,   &
        20.*h2o/max(taus,taui)/airmas))
      goto 10
    endif
    if (atm_interpolate) then
      call atm_transm_i  (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm_i  (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    else
      call atm_transm  (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm  (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    endif
    taus = t1 + t2
    taui = t1 + t2
    tem = (temis + temii*gim) / (1.+gim)
  elseif (cmode .eq. 'AU') then
    !
    ! Auto Mode without cold load, or when the water vapor content is known
    if (atm_interpolate) then
      call atm_atmosp_i (tamb, pamb, alti)   ! press at 2550m
      call atm_transm_i (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm_i (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    else
      call atm_atmosp (tamb, pamb, alti)   ! press at 2550m
      call atm_transm (h2o,airmas,frs,temis,tatms,t1,t2,taut,ier)
      call atm_transm (h2o,airmas,fri,temii,tatmi,t1,t2,taut,ier)
    endif
    taus = t1 + t2
    taui = t1 + t2
    tem = (temis + temii*gim) / (1.+gim)
    tsky = (1.-feff)*tamb + feff*tem
  !
  ! Manual Mode
  elseif (cmode.eq.'MA') then
    temis = tatms * (1.-exp(-taus*airmas))
    temii = tatmi * (1.-exp(-taui*airmas))
    tem = (temis + temii*gim) / (1.+gim)
    tsky = (1.-feff)*tamb + feff*tem
  else
    call message(8,4,'CHOPPER_MON','Invalid mode '//cmode)
    error = .true.
    return
  endif
  !
  ! Compute TREC
  if (cmode.ne.'TR') then
    trec = (csky*tchop - tsky*cchop) / (cchop-csky)
  endif
  !
  ! Compute TSYSD
  tsysd = (trec+tsky)/feff
  tsysd = max(min(1e10,tsysd),0.)
  !
  ! Get pathlength (in mm.)  and difference at observing frequency
  !
500 call atm_atmosp_i (tamb, pamb, alti)
  call atm_path_i(h2o,airmas,fro,path,ier)
  path = path*10.
  !
  h2o1 = h2o-0.1
  call atm_path_i(h2o1,airmas,fro,path1,ier)
  path1 = path1*10.
  call atm_transm_i (h2o1,airmas,frs,temis,t3,t1,t2,t4,ier)
  call atm_transm_i (h2o1,airmas,fri,temii,t3,t1,t2,t4,ier)
  tem1 = (temis + temii*gim)/(1.+gim)
  !
  h2o2 = h2o+0.1
  call atm_path_i(h2o2,airmas,fro,path2,ier)
  path2 = path2*10.
  call atm_transm_i (h2o2,airmas,frs,temis,t3,t1,t2,t4,ier)
  call atm_transm_i (h2o2,airmas,fri,temii,t3,t1,t2,t4,ier)
  tem2 = (temis + temii*gim)/(1.+gim)
  !
  dtem = tem2 - tem1
  if (dtem.ne.0) then
    dpath = (path2-path1) / dtem
  else
    dpath = path
  endif
  return
end subroutine chopper_mon

subroutine listpo(line,error)
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  integer :: sic_open
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real*8 :: pi
  parameter (pi=3.14159265358979323846d0)
  real*4 :: secpi,degpi
  parameter (secpi = 3600.*180./pi)
  parameter (degpi = 180./pi)
  integer :: i,lun,iscan,ier
  character(len=80) :: ofile,name
  !
  if (ndata.eq.0 .or. npt.eq.0) return
  lun = 6
  if (sic_present(1,0)) then
    call sic_ch (line,1,1,ofile,i,.true.,error)
    if (error) return
    lun = 1
    name = ofile
    call sic_parsef(name,ofile,' ','.lis')
    ier = sic_open (lun,ofile,'NEW',.false.)
  endif
  !
  iscan = 0
  call sic_i4 (line,0,1,iscan,.false.,error)
  if (error) return
  call get_good (npt,kp)
  write(lun,102)
  do i=1,npt
    if (iscan.eq.0 .or. scan(i).eq.iscan) then
      if (good(i)) then
        write(lun,100) scan(i),nint(x(3,i)),   &
     &          x(1,i)*degpi,x(2,i)*degpi,tiem(i),   &
     &          fobs(i)*secpi,rms(i),source(i)
      else
        write(lun,101) scan(i),nint(x(3,i)),   &
     &          x(1,i)*degpi,x(2,i)*degpi,tiem(i),   &
     &          fobs(i)*secpi,rms(i),source(i)
      endif
    endif
  enddo
  if (lun.ne.6) close(lun)
  !
  100   format(1x,i6,i3,5(1x,f10.3),1x,a)
  101   format(1x,'!',i5,i3,5(1x,f10.3),1x,a)
  102   format(1x,'  Scan Code',   &
     &    '    Az         El         Time       Error      Rms')
end

subroutine feuille_cherche(dir,nom,segm,found)
  use gtv_interfaces, except_this=>feuille_cherche
  use gtv_buffers
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Recherche une feuille donnee en argument, dans un macrosegment
  ! repere par 'dir'. Rend found a vrai si la feuille existe, a faux
  ! sinon.
  !---------------------------------------------------------------------
  type(gt_directory)            :: dir    ! Starting directory
  character(len=*), intent(in)  :: nom    ! Name to search for
  type(gt_segment), pointer     :: segm   ! Segment found, if any
  logical,          intent(out) :: found  ! Found it?
  ! Local
  integer :: l1,l2,i1
  !
  found = .false.
  l1 = len_trim(nom)
  i1 = index(nom,'*')  ! enable pseudo-wildcarding. The idea is to enable
                       ! the existence of one '*' in the segment name, and
                       ! check against it.
  segm => dir%leaf_first
  do while (associated(segm))
    l2 = len_trim(segm%head%gen%name)
    !
    if (i1.eq.0) then
      if (segm%head%gen%name.eq.nom) found = .true.
    elseif (i1.eq.1) then
      if (l2-l1+i1+1.ge.1) then
        if (segm%head%gen%name(l2-l1+i1+1:l2).eq.nom(i1+1:l1))  found = .true.
      endif
    else
      if (l2-l1+i1+1.ge.1) then
        if ( segm%head%gen%name(l2-l1+i1+1:l2).eq.nom(i1+1:l1) .and.  &
             segm%head%gen%name(1:i1-1)       .eq.nom(1:i1-1) )  found = .true.
      endif
    endif
    !
    if (found)  exit
    !
    segm => segm%nextseg
  enddo
  !
end subroutine feuille_cherche
!
subroutine fils_cherche(dir,nom,trouve,found)
  use gtv_interfaces, except_this=>fils_cherche
  use gtv_buffers
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Recherche un fils donnee en argument, dans un macrosegment repere
  ! par 'dir'. Rend l'adresse de ce fils dans 'trouve'. Rend found a
  ! vrai si le fils existe, a faux sinon
  !---------------------------------------------------------------------
  type(gt_directory)              :: dir     ! Starting directory
  character(len=*),   intent(in)  :: nom     ! Name to search for
  type(gt_directory), pointer     :: trouve  ! Found address
  logical,            intent(out) :: found   ! Found it?
  ! Local
  type(gt_directory), pointer :: workdir
  !
  found = .false.
  workdir => dir%son_first
  !
  do while (associated(workdir))
    if (workdir%gen%name.eq.nom) then
      trouve => workdir
      found = .true.
      return
    endif
    workdir => workdir%brother
  enddo
  !
end subroutine fils_cherche
!
subroutine ret_pere(dir,trouve,error)
  use gtv_interfaces, except_this=>ret_pere
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Partant de la directorie reperee par 'dir', on remonte jusqu'a son
  ! pere repere par 'trouve'. error est mis a True si on cherche a
  ! remonter au dela de root.
  !---------------------------------------------------------------------
  type(gt_directory)          :: dir     ! Starting directory
  type(gt_directory), pointer :: trouve  ! Found address
  logical,      intent(inout) :: error   ! Logical error flag
  !
  trouve => dir%father
  error = .not.associated(dir%father)  ! i.e. 'dir' is root
  !
end subroutine ret_pere
!
subroutine decode_chemin(chemin,init,dir,isdir,segm,found)
  use gtv_buffers
  use gtv_interfaces, except_this=>decode_chemin
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Partant d'une directorie reperee par 'init', on cherche a
  ! atteindre un segment ou un macro segment specifie par chemin
  ! (relatif). Si le chemin est absolu, 'init' est ignore et on
  ! cherche depuis la racine.
  ! On peut aussi lire le directory courant et renvoyer son adresse si
  ! son nom correspond a chemin. Si on y arrive alors, le but est
  ! specifie par 'dir' et found est true; sinon found est false.
  ! isdir = .true. si le dernier element lu est un macrosegment, .false.
  ! sinon.
  !---------------------------------------------------------------------
  character(len=*),   intent(in)  :: chemin  ! Input path
  type(gt_directory), pointer     :: init    ! Directory to search from
  type(gt_directory), pointer     :: dir     ! Directory of the target
  logical,            intent(out) :: isdir   ! Target is a directory
  type(gt_segment),   pointer     :: segm    ! Pointer to the segment target, if not a directory
  logical,            intent(out) :: found   ! Target was found
  ! Local
  integer :: ptr_deb,ptr_fin
  logical :: absolute,last,error
  type(gt_directory), pointer :: dep
  !
  error = .false.
  !
  ! 1) Cas particulier 1: Chemin vaut < tout seul.
  if (chemin.eq.dir_root) then
    dir => root
    isdir = .true.
    segm => null()
    found = .true.
    return
  endif
  !
  ! 2) Cas particulier 2: le grand-pere
  if (chemin.eq.dir_top) then
    dir => init%ancestor
    isdir = .true.
    segm => null()
    found = .true.
    return
  endif
  !
  absolute = chemin(1:1).eq.dir_sep
  dir => null()
  found = .false.
  segm => null()
  isdir = .false.
  !
  ! 3) Path starts with "<": it is absolute. We start from root, and 'init'
  ! is ignored
  if (absolute) then
    last = .false.
    ptr_deb = 2
    dep => root
    call next_nom(chemin(ptr_deb:),ptr_deb,ptr_fin,last)
    call fils_cherche(root,chemin(ptr_deb:ptr_fin),dir,found)
    do while (.not.last .and. found)
      dep => dir
      !
      ! Get next name
      ptr_deb = ptr_fin+2
      call next_nom(chemin(ptr_deb:),ptr_deb,ptr_fin,last)
      !
      ! Handle ".."
      if (chemin(ptr_deb:ptr_fin).eq.dir_up) then
        call ret_pere(dep,dir,error)
        if (error) then
          found = .false.
          return
        endif
      else
        call fils_cherche(dep,chemin(ptr_deb:ptr_fin),dir,found)
      endif
      !
    enddo
    !
    ! Il s'agit maintenant de tester si le dernier nom contenu dans le
    ! chemin est un segment ou un macrosegment
    if (.not.found .and. .not.last)  return
    if (last) then
      ! Est ce un segment ?
      call feuille_cherche(dep,chemin(ptr_deb:),segm,found)
      if (found)  then
        isdir = .false.
        return
      endif
      !
      ! Est ce un macro segment ? (Il n'a pas ete teste dans le do while,
      ! puisque c'etait le dernier et que donc next_nom a rendu last = .true.)
      call fils_cherche(dep,chemin(ptr_deb:),dir,found)
      if (found)  isdir = .true.
      return
    endif
  endif  ! Fin du chemin absolu.
  !
  ! 4) Cas general
  dep => init
  ptr_deb = 1
  call next_nom(chemin(ptr_deb:),ptr_deb,ptr_fin,last)
  do while (.not.last)
    if (chemin(ptr_deb:ptr_fin).eq.dir_up) then
      call ret_pere(dep,dir,error)
      if (error) then
        found = .false.
        return
      endif
      dep => dir
    else
      call fils_cherche(dep,chemin(ptr_deb:ptr_fin),dir,found)
      dep => dir
      if (.not.found) return
    endif
    ptr_deb = ptr_fin + 2
    call next_nom(chemin(ptr_deb:),ptr_deb,ptr_fin,last)
  enddo
  !
  ! On est sorti avec last = .true.
  ! Il reste a traiter le dernier morceau de chemin
  ! Il peut s'agir de .. : dans ce cas, appel de ret_pere
  if (chemin(ptr_deb:ptr_fin).eq.dir_up) then
    call ret_pere(dep,dir,error)
    if (error)  then
      isdir = .false.
      found = .false.
    else
      isdir = .true.
      found = .true.
    endif
    return
  endif
  !
  ! Est ce un segment ?
  call feuille_cherche(dep,chemin(ptr_deb:ptr_fin),segm,found)
  if (found) then
    dir => dep
    isdir = .false.
    return
  endif
  !
  ! Est ce un macro segment ? (Il n'a pas ete teste dans le do while, puisque
  ! c'etait le dernier et que donc next_nom a rendu last = .true.
  found = .false.
  call fils_cherche(dep,chemin(ptr_deb:ptr_fin),dir,found)
  if (found) then
    isdir = .true.
    return
  endif
  !
end subroutine decode_chemin
!
subroutine next_nom(nom,ptr_deb,ptr_fin,last)
  use gtv_interfaces, except_this=>next_nom
  use gtv_tree
  !---------------------------------------------------------------------
  ! @ private
  ! Rend dans ptr l'indice de fin d'un nom lu entre deux separateurs <
  ! last est vrai si c'est le dernier nom de la chaine de caracteres
  ! ATTENTION
  ! ptr_deb et ptr_fin sont des pointeurs dans la chaine d'ORIGINE
  ! (Chaine d'origine transmise par nom(ptr_deb:)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: nom      ! String to parse
  integer,          intent(in)  :: ptr_deb  ! Offset to add to the returned index
  integer,          intent(out) :: ptr_fin  ! Index of the end of next name
  logical,          intent(out) :: last     ! No more name after this
  ! Local
  integer :: indice
  !
  indice = index(nom,dir_sep)
  if (indice .eq. 0) then
    last = .true.
    ptr_fin = ptr_deb + len_trim(nom)-1
    return
  endif
  !
  ptr_fin = ptr_deb-1 + indice-1
  last = .false.
  ! Cas particulier du chemin se terminant par <
  if (indice .eq. len_trim(nom)) last = .true.
  !
end subroutine next_nom
!
subroutine cree_chemin_dir(start,chemin,lch)
  use gtv_interfaces, except_this=>cree_chemin_dir
  use gtv_buffers
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the absolute path from root '<' to directory given by 'start'
  !---------------------------------------------------------------------
  type(gt_directory)            :: start   ! Directory to be resolved
  character(len=*), intent(out) :: chemin  ! Output name (full path)
  integer,          intent(out) :: lch     ! Length of output
  ! Local
  type(gt_directory), pointer :: dir
  !
  if (.not.associated(start%father)) then
    chemin = dir_root
    lch = len_trim(dir_root)
    return
  endif
  !
  chemin = start%gen%name
  dir => start%father
  do while (associated(dir%father))
    chemin = trim(dir%gen%name)//dir_sep//chemin
    dir => dir%father
  enddo
  chemin = dir_root//chemin
  !
  lch = len_trim(chemin)
  !
end subroutine cree_chemin_dir
!
subroutine cree_chemin_seg(segm,chemin,lch)
  use gtv_interfaces, except_this=>cree_chemin_seg
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Return the absolute path from root '<' to the segment given by
  ! 'segm'.
  !---------------------------------------------------------------------
  type(gt_segment)              :: segm    ! Pointer to segment
  character(len=*), intent(out) :: chemin  ! Output name (full path)
  integer,          intent(out) :: lch     ! Length of output
  !
  ! Path
  call cree_chemin_dir(segm%father,chemin,lch)
  !
  ! Add the segment name
  chemin = trim(chemin)//dir_sep//segm%head%gen%name
  lch = len_trim(chemin)
  !
end subroutine cree_chemin_seg
!
subroutine get_nomgrandpere(nom)
  use gtv_buffers
  use gtv_interfaces, except_this=>get_nomgrandpere
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Return the name of the 'grandpere' branch from current directory.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: nom  ! Returned name
  !
  nom = cw_directory%ancestor%gen%name
  !
end subroutine get_nomgrandpere

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_browse
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubesyntax_keyval_strg_types
  use cubetools_switch_types
  use cubetopology_spapos_types
  use cubego_messaging
  !
  public :: browse
  private
  !
  type :: browse_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(spapos_comm_t)         :: pixel
     type(keyval_strg_comm_t)    :: catalog
     type(switch_comm_t)         :: interactive
   contains
     procedure, public  :: register => cubego_browse_register
     procedure, private :: parse    => cubego_browse_parse
     procedure, private :: main     => cubego_browse_main
  end type browse_comm_t
  type(browse_comm_t) :: browse
  !
  type :: browse_user_t
     type(cubeid_user_t)      :: cubeids
     type(spapos_user_t)      :: pixel
     type(keyval_strg_user_t) :: catalog
     type(switch_user_t)      :: interactive
   contains
     procedure, private :: toprog => cubego_browse_user_toprog
  end type browse_user_t
  !
  type browse_prog_t
     type(cube_t), pointer :: cube
     type(cubeid_prog_t)   :: cubeids
     type(spapos_prog_t)   :: pixel
     character(len=file_l) :: catalog
     type(switch_prog_t)   :: interactive
   contains
     procedure, private :: header => cubego_browse_prog_header
     procedure, private :: data   => cubego_browse_prog_data
  end type browse_prog_t
  !
contains
  !
  subroutine cubego_browse_command(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(browse_user_t) :: user
    character(len=*),parameter :: rname='BROWSE>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call browse%parse(line,user,error)
    if (error) return
    call browse%main(user,error)
    if (error) return
    ! Force insertion in SIC stack ! *** JP Why?
    if (sic_lire().eq.0) call sic_insert(line)
  end subroutine cubego_browse_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_register(comm,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='BROWSE>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'BROWSE','[cubeid]',&
         'Interactive browse of a cube spectrum',&
         'Open the spectrum browser for one cube.',&
         cubego_browse_command,&
         comm%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Identity of the cube to be browsed',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&! Indicative: data access done by procedure
         code_access_imaset_or_speset,&! Indicative: data access done by procedure
         comm%cube,&
         error)
    if (error) return
    !
    call comm%pixel%register(&
         'PIXEL',&
         'Define the position of the pixel to be browsed',&
         error)
    if (error) return
    call comm%catalog%register(&
         'CATALOG',&
         'Supersede the default line catalog filename',&
         'The file format is an ASCII table with frequencies [GHz] in first&
         & column and line names in second column. Protect names with single&
         & quotes if needed.',&
         strg_star,&
         strg_emp,&
         error)
    if (error) return
    call comm%interactive%register(&
         'INTERACTIVE',&
         'the interactive mode',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubego_browse_register
  !
  subroutine cubego_browse_parse(comm,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(browse_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%pixel%parse(line,user%pixel,error)
    if (error) return
    call comm%catalog%parse(line,user%catalog,error)
    if (error) return
    call comm%interactive%parse(line,user%interactive,error)
    if (error) return
  end subroutine cubego_browse_parse
  !
  subroutine cubego_browse_main(comm,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(in)    :: comm
    type(browse_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(browse_prog_t) :: prog
    character(len=*), parameter :: rname='BROWSE>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(error)
    if (error) return
    call prog%data(error)
    if (error) return
  end subroutine cubego_browse_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(browse_user_t), intent(in)    :: user
    type(browse_comm_t),  intent(in)    :: comm    
    type(browse_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call cubeadm_cubeid_user2prog(comm%comm,user%cubeids,prog%cubeids,error)
    if (error) return
    call user%pixel%toprog(prog%cube,prog%pixel,error)
    if (error) return
    call user%catalog%toprog(comm%catalog,prog%catalog,error)
    if (error) return
    call prog%interactive%init(comm%interactive,error)
    if (error) return
    call user%interactive%toprog(comm%interactive,prog%interactive,error)
    if (error) return
  end subroutine cubego_browse_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_prog_header(prog,error)
    use cubego_buffer
    use cubetools_userspace
    use cubetools_userstruct
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(browse_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(userstruct_t) :: userstruct
    character(len=*), parameter :: rname='BROWSE>PROG>HEADER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%cubeids%defstruct(cubego,error)
    if (error) return
    call prog%pixel%userstruct('cubego%pixel',error)
    if (error) return
    ! catalog
    call userstruct%create('cubego%catalog',global,overwrite_prog,error)
    if (error) return
    call userstruct%set_member('file',prog%catalog,error)
    if (error) return
  end subroutine cubego_browse_prog_header
  !
  subroutine cubego_browse_prog_data(prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(browse_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PROG>DATA'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call exec_program('@ q-browse.cube')
    if (prog%interactive%act) call exec_program('@ l-ctrl-master-loop')
  end subroutine cubego_browse_prog_data
end module cubego_browse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine ini_base(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY BASELINE  b1 x1 y1 x1 b2 x2 y2 z2 ...[/OFFSET]
  !                          [FITTED]
  ! Command MODIFY ANTENNA a1 x1 y1 x1 a2 x2 y2 z2 .. [/OFFSET]
  !                          [FITTED]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  integer :: base_number
  logical :: fbnew(mnbas), fanew(mnant)
  logical :: antenna, offset
  real*8 :: bnew(3,mnbas), anew(3,mnant)
  real*8 :: bnew0(3,mnbas), anew0(3,mnant)
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: i, j, k, nch
  character(len=12) :: argum
  character(len=256) :: chain
  !      CHARACTER*1 ARG1
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real :: x(mnbas)
  integer :: kb, ibas, ia, ja, id
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1/'BASELINE','ANTENNA'/
  data antenna/.false./, offset/.false./
  save antenna, offset, anew, anew0, fanew, bnew, bnew0, fbnew, id
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  kw = 'ANTENNA'
  call clic_kw(line,iopt,1,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  antenna = kw.eq.'ANTENNA'
  offset = sic_present(3,0)
  !
  ! Mandatory argument (89 or 96 or 99 or 25)
  if (offset) then
    call sic_i4(line,3,1,id,.true.,error)
    if (id.ne.89 .and. id.ne.96 .and. id.ne.99 .and. id.ne.25) then
      call message(8,3,'MODIFY',   &
        '/OFFSET 89 or /OFFSET 96 or /OFFSET 99 or /OFFSET 25, please')
      error = .true.
      return
    endif
  else
    id = 0
  endif
  error = .false.
  do i=1, mnbas
    fbnew(i) = .false.
  enddo
  do i=1, mnant
    fanew(i) = .false.
  enddo
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  if (argum(1:2) .eq. 'FITTED') then
    do i=1, r_nbas
      if (f_bfit(i)) then
        do j=1,3
          bnew0(j,i) = b_fit(j,i)
        enddo
        fbnew(i) = .true.
      elseif (f_afit(r_iant(i)) .and.   &
        f_afit(r_jant(i))) then
        do j=1,3
          bnew0(j,i) = a_fit(j,r_jant(i))-   &
            a_fit(j,r_iant(i))
        enddo
        fbnew(i) = .true.
      endif
    enddo
  elseif (.not.antenna) then
    i = 2
    do while(sic_present(iopt,i))
      call sic_ke(line,iopt,i,argum,nch,.true.,error)
      if (error) return
      call base_to_n(argum,j,error)
      if (error) then
        call message(8,4,'INI_BASE','Invalid baseline '//argum)
        error = .true.
        return
      endif
      fbnew(j) = .true.
      do k=1, 3
        call sic_r8(line,iopt,i+k,bnew0(k,j),.true.,error)
        if (error) return
      enddo
      i = i+4
    enddo
  elseif (antenna) then
    i = 2
    do while(sic_present(iopt,i))
      call sic_i4(line,iopt,i,j,.true.,error)
      if (error) return
      fanew(j) = .true.
      do k=1, 3
        call sic_r8(line,iopt,i+k,anew0(k,j),.true.,error)
        if (error) return
      enddo
      i = i+4
    enddo
  endif
  if (.not.antenna) then
    call message(6,1,'INI_BASE','Modifying baselines to :')
    do i=1, mnbas
      if (fbnew(i)) then
        write(chain,'(1x,a2,3f15.6)') cbas(i),(bnew0(j,i),j=1,3)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,a2,a)') cbas(i), ' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      endif
    enddo
  else
    call message(6,1,'INI_BASE','Modifying antennas to :')
    do i=1, mnant
      if (fanew(i)) then
        write(chain,'(1x,i0,3f15.6)') i,(anew0(j,i),j=1,3)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,i0,a)') i,' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      endif
    enddo
  endif
  if (offset) then
    write(chain,'(a,i2,a)') '(Offset relative to `',id,' values)'
    call message (6,1,'INI_BASE',chain(1:lenc(chain)))
  endif
  return
  !
entry mod_base(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  kin = gag_pointer(data_in,memory)
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Add station offsets if needed
  if (antenna) then
    do i=1, r_nant
      if (fanew(i)) then
        do j=1, 3
          anew(j,i) = anew0(j,i)
          if (offset) then
            if(id.eq.89) then
              anew(j,i) = anew(j,i)+dble(stat89(j,r_istat(i)))
            elseif(id.eq.96) then
              anew(j,i) = anew(j,i)+dble(stat96(j,r_istat(i)))
            elseif(id.eq.99) then
              anew(j,i) = anew(j,i)+dble(stat99(j,r_istat(i)))
            elseif(id.eq.25) then
              anew(j,i) = anew(j,i)+dble(stat25(j,r_istat(i)))
            endif
          endif
        enddo
      endif
    enddo
  else
    do i=1, r_nbas
      if (fbnew(i)) then
        do j=1, 3
          bnew(j,i) = bnew0(j,i)
          if (offset) then
            if(id.eq.89) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat89(j,r_istat(r_jant(i)))   &
                -stat89(j,r_istat(r_iant(i))))
            elseif(id.eq.96) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat96(j,r_istat(r_jant(i)))   &
                -stat96(j,r_istat(r_iant(i))))
            elseif(id.eq.99) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat99(j,r_istat(r_jant(i)))   &
                -stat99(j,r_istat(r_iant(i))))
            elseif(id.eq.25) then
              bnew(j,i) = bnew(j,i)   &
                +dble(stat25(j,r_istat(r_jant(i)))   &
                -stat25(j,r_istat(r_iant(i))))
            endif
          endif
        enddo
      endif
    enddo
  endif
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do i = 1, r_nbas
    x(i) = 0
    !
    ! in antenna mode, use antenna data to compute baseline data:
    if (antenna) then
      ia = r_iant(i)
      ja = r_jant(i)
      fbnew(i) = .true.
      if (fanew(ja)) then
        do k=1, 3
          bnew(k,i) = anew(k,ja)
        enddo
      elseif (r_ant(1,ja).ne.0) then
        do k=1, 3
          bnew(k,i) = r_ant(k,ja)
        enddo
      else
        fbnew(i) = .false.
      endif
      if (fbnew(i) .and. fanew(ia)) then
        do k=1, 3
          bnew(k,i) = bnew(k,i)-anew(k,ia)
        enddo
      elseif (fbnew(i) .and. r_ant(1,ia).ne.0) then
        do k=1, 3
          bnew(k,i) = bnew(k,i)-r_ant(k,ia)
        enddo
      else
        fbnew(i) = .false.
      endif
    endif
    if (fbnew(i)) then
      do k=1, 3
        x(i) = x(i)   &
          - dh_svec(k)*(bnew(k,i)-r_bas(k,i))*f_to_k
      enddo
    endif
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Update baselines
  do ibas = 1, r_nbas
    kb = base_number (r_iant(ibas), r_jant(ibas))
    if (fbnew(kb)) then
      do i=1, 3
        r_bas(i,ibas) = bnew(i,kb)
      enddo
    endif
  enddo
  if (antenna) then
    do i=1, r_nant
      if (fanew(i)) then
        do k=1, 3
          r_ant(k,i) = anew(k,i)
        enddo
      endif
    enddo
  endif
  do_data = .true.
500 return
!
end subroutine ini_base
!
subroutine ini_delay(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY DELAY a1 d1 ... a2 x2 ... [/OFFSET] [INSTRUMENTAL]
  !         [/ALL] [/POL H|V] [/SWITCH DIRECT|CROSSED] [/BB bb] [/IF if] 
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnbb,mnant), process
  logical :: offset, new, rf, direct, crossed
  real*8 :: anew(mnbb,mnant),newval
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: i, j, ia, ja, nch, is, ipa, jpa, k, l, m
  integer :: ir, ibas, ibb, iif, jbb(mnbb), nbb, ipol
  integer :: mvoc,mvoc1,nkey
  parameter (mvoc = 3, mvoc1 = 2)
  character(len=12) :: voc(mvoc)
  character(len=12) :: voc1(mvoc1)
  character(len=12) :: argum,kw
  character(len=256) :: chain
  character(len=1) :: arg1
  real*8 :: f_to_k
  parameter (f_to_k = 2*pi/1000.)
  real :: x(mnbas), new_delay(mnbb,mnant)
  !
  save offset, anew, fanew, rf, direct, crossed
  !
  data offset/.false./, rf/.true./, direct/.false./, crossed/.false./
  data voc/'HORIZONTAL','VERTICAL','BOTH'/
  data voc1/'DIRECT','CROSSED'/
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  if (arg1.ne.'D') then
    error = .true.
    return
  endif
  !
  ! /OFFSET option
  offset = sic_present(3,0)
  error = .false.
  do i=1, mnant
    do j = 1, mnbb
      fanew(j,i) = .false.
    enddo
  enddo
  !
  ! /INSTRUMENTAL option
  rf = .not.sic_present(9,0)
  !
  ! /ALL option
  if (sic_present(10,0)) then
    nbb = r_nbb
    do i=1, r_nbb
      jbb(i) = i
    enddo
  !
  ! /BBAND option
  elseif (sic_present(7,0)) then
    call sic_i4(line,7,1,ibb,.true.,error)
    nbb = 1
    jbb(nbb) = ibb 
  !
  ! /IF option
  elseif (sic_present(8,0)) then
    call sic_i4(line,8,1,iif,.true.,error)
    nbb=0
    do i=1, r_lband
      if (r_if(i).eq.iif) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  !
  ! /POLARISATION option
  elseif (sic_present(5,0)) then
     call sic_ke(line,5,1,argum,nch,.true.,error)
     if (error) return
     call sic_ambigs('MODIFY DELAY /POLARISATION',argum,kw,nkey,voc,   &
       mvoc,error)
     if (error) return
     if (kw.eq.'HORIZONTAL') then
       ipol = 1
     elseif (kw.eq.'VERTICAL') then
       ipol = 2
     elseif (kw.eq.'BOTH') then
       ipol = 3
     else
       call message(6,3,'MODIFY','Invalid polarisation '//argum)
       error = .true.
       return
     endif
     nbb=0
     do i=1, r_lband
       if (r_lpolentry(1,i).eq.ipol.or.ipol.eq.3) then
         new = .true.
         if (nbb.ge.1) then
           do j=1,nbb
             if (r_bb(i).eq.jbb(j)) new = .false.
           enddo
         endif
         if (new) then
           nbb = nbb+1
           jbb(nbb) = r_bb(i)
         endif
       endif
     enddo
  endif
  !
  ! /SWITCH option
  crossed = .false.
  direct = .false.
  if (sic_present(12,0)) then
    call sic_ke(line,12,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY DELAY /SWITCH',argum,kw,nkey,voc1,mvoc1,error)
    if (error) return
    if (kw.eq.'DIRECT') then
      direct = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    elseif (kw.eq.'CROSSED') then
      crossed = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    else
      call message(6,3,'MODIFY','Invalid switch status '//argum)
      error = .true.
      return     
    endif
  endif
  if (nbb.le.0) then
      call message(6,3,'MODIFY','No valid baseband found')
      error = .true.
      return
  endif
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    if (j.le.0 .or. j.gt.mnant) then
      write(argum,'(i6)')
      call message(8,4,'INI_DELAY',   &
        'Invalid antenna '//argum(1:lenc(argum)))
      error = .true.
      return
    endif
    call sic_r8(line,iopt,i+1,newval,.true.,error)
    if (error) return
    i = i+2
    do k=1, nbb
      ibb = jbb(k)
      fanew(ibb,j) = .true.
      anew(ibb,j) = newval
    enddo
  enddo
  call message(6,1,'INI_DELAY','Modifying antenna delays to :')
  do i=1, mnant
    if (fanew(ibb,i)) then
      write(chain,'(1x,i0,f15.6)') i,anew(ibb,i)
      call message(6,1,'INI_DELAY',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_DELAY',chain(1:lenc(chain)))
    endif
  enddo
  write(chain,'(1x,8i2)'),(jbb(i),i=1,nbb)
  call message(6,1,'INI_DELAY','For basebands'//chain(1:lenc(chain)))
  if (offset) then
    call message (6,1,'INI_DELAY','(Offset values)')
  endif
  return
  !
entry mod_delay(do_write,do_data,error)
  !
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf .and. r_proc.ne.p_pass) goto 500
  if (r_lmode.ne.1) goto 500
  kin = gag_pointer(data_in,memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  do i=1, r_nant
    do  j = 1, r_nbb
      l = r_mapbb(j)
      process = fanew(l,i)
      m=(3-r_sb(l))/2
      if (direct) process = process.and.(r_polswitch(i,m).eq.0)
      if (crossed) process = process.and.(r_polswitch(i,m).ne.0)
      if (process) then
        if (offset) then
          new_delay(l,i) = dh_delay(l,i) + anew(l,i)
        else
          new_delay(l,i) = anew(l,i)
        endif
      else
        new_delay(l,i) = dh_delay(l,i)
      endif
      r_dmdelay(l,i) = new_delay(l,i)
    enddo
  enddo
  !
  ! Compute phase factors per subband (for crossed pol case)
  do is  = 1, lband_original
    do ibas = 1, r_nbas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      ipa = r_bb(is)
      jpa = r_bb(is)
      x(ibas) = f_to_k*((dh_delay(jpa,ja)-new_delay(jpa,ja))   &
        - (dh_delay(ipa,ia)-new_delay(ipa,ia)))
    enddo
    !
    ! Actually modify data:
    if (any(x.ne.0)) call modify_ph(memory(kin),x,is,rf)
  enddo
  !
  ! Save the new delays in the data headers:
  do ir = 1, r_ndump + max(1,r_ndatl)
    ipk = kin + h_offset(ir)
    call decode_header(memory(ipk))
    do ia = 1, r_nant
        call r4tor4(new_delay(1,ia),dh_delay(1,ia),1)
        call r4tor4(new_delay(2,ia),dh_delay(2,ia),1)
    enddo
    call encode_header(memory(ipk))
  enddo
  !
  do_data = .true.
500 return
end subroutine ini_delay
!
subroutine ini_position (line,iopt,error)
  use gkernel_interfaces
  use gbl_constant
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY POSITION Ra Dec
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  integer :: lra,lde
  real*4 :: epoch
  real*8 :: lambda,beta,svec(3),snvec(3),sovec(3),dop,lsr
  character(len=20) :: cra,cde
  character(len=2) :: cs(7),cv(4)
  real*8 :: s_2(2), s_3(3), x_0(3), ut, xx, parang
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  integer :: ibas,i
  integer(kind=address_length) :: data_in,kin,ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: itypec,dobs
  real :: x(mnbas)
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=2)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1/'EQUATORIAL','GALACTIC'/
  data cs /'UN','EQ','GA','HO','BD','EC','DA'/
  data cv /'LS','HE','EA','NU'/
  !------------------------------------------------------------------------
  save lambda,beta,epoch,itypec
  ! Code:
  call check_equal_file(error)
  if (error) return
  !
  ! Assume EQ with given epoch
  kw = 'EQUATORIAL'
  call clic_kw(line,iopt,2,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  if (error) then
    call message(7,3,'INI_POSITION',   &
      'Only Equatorial or Galactic coordinates')
    return
  endif
  if (kw.eq.'EQUATORIAL') then
    itypec = type_eq
  elseif (kw.eq.'GALACTIC') then
    itypec = type_ga
  endif
  call sic_r4(line,iopt,3,epoch,.true.,error)
  if (error) return
  call sic_ke(line,iopt,4,cra,lra,.true.,error)
  if (error) return
  call sic_ke(line,iopt,5,cde,lde,.true.,error)
  if (error) return
  !
  call sic_sexa(cra,lra,lambda,error)
  if (error) return
  lambda = lambda*pi/12.0d0
  call sic_sexa(cde,lde,beta,error)
  if (error) return
  beta = beta*pi/180.0d0
  !
  call message (6,1,'INI_POSITION',   &
    'Modifying position to '   &
    //cra(1:lra)//' '//cde(1:lde))
  return
  !
entry mod_position(do_write,do_data,error)
  ! Test
  do_write = .false.
  do_data = .false.
  !
  ! Set time
  dobs = mod(r_dobs+32768,65536)-32768
  ut = dobs+2460549.5d0+r_ut/2d0/pi
  !
  ! new subroutine calls from astro
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  !
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, sovec, x_0, parang, error)
  call do_object(cs(itypec), epoch, lambda, beta,   &
    s_2, s_3, dop, lsr, snvec, x_0, parang, error)
  !
  xx = 0
  do i=1,3
    svec(i) = snvec(i)-sovec(i)
    xx = xx+svec(i)**2
  enddo
  xx = sqrt(xx)*180d0*3600d0/pi
  if (abs(xx).lt.0.001) goto 500
  !
  r_lam = lambda
  r_bet = beta
  r_epoch = epoch
  r_typec = itypec
  !
  ! Modify observation
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) then 
    goto 500
  endif
  if (r_lmode.ne.1) then
    goto 500
  endif
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do ibas = 1, r_nbas
    x(ibas) = 0
    do i=1,3
      x(ibas) = x(ibas) - svec(i)*r_bas(i,ibas) * f_to_k
    enddo
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Real life
  do_data = .true.
  do_write = .true.
500 continue
  return
end subroutine ini_position
!
subroutine ini_time (line,iopt,error)
  use gkernel_interfaces
  use gbl_constant
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! 	MODIFY TIME Dut1
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  real*8 :: dut1
  real*8 :: svec(3),snvec(3),sovec(3),dop,lsr, parang
  character(len=80) :: chain
  character(len=2) :: cs(7),cv(4)
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  integer :: ibas,i
  integer(kind=address_length) :: data_in,kin,ipk
  integer(kind=data_length)    :: ndata, h_offset
  integer :: dobs
  real*8 :: s_2(2), s_3(3), x_0(3), ut, xx
  real :: x(mnbas)
  !
  save dut1
  !
  data cs /'UN','EQ','GA','HO','BD','EC','DA'/
  data cv /'LS','HE','EA','NU'/
  !------------------------------------------------------------------------
  ! Code:
  call check_equal_file(error)
  if (error) return
  !
  call sic_r8(line,iopt,2,dut1,.true.,error)
  if (error) return
  write(chain,'(F8.3)') dut1
  call message (6,1,'INI_TIME',   &
    'Modifying DUT1 by '//chain)
  dut1 = dut1*pi/12.d0/3600d0  ! In radians
  return
  !
entry mod_time (do_write,do_data,error)
  ! Test
  do_write = .false.
  do_data = .false.
  !
  ! Set time
  dobs = mod(r_dobs+32768,65536)-32768
  ut = dobs+2460549.5d0+r_ut/2d0/pi
  !
  ! new subroutine calls from astro
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  !
  ! new subroutine calls from astro
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, sovec, x_0, parang, error)
  !
  ! Now correct the UT time
  r_ut = r_ut+dut1
  ut = mod(r_dobs+32768,65536)-32768+2460549.5d0+r_ut/2d0/pi
  call do_astro_time(ut, 0.0d0, 56.184d0, error)
  !      CALL CLIC_TIME(DOBS,R_UT,ERROR)
  if (error) return
  call do_object(cs(r_typec), r_epoch, r_lam, r_bet,   &
    s_2, s_3, dop, lsr, snvec, x_0, parang, error)
  !
  xx = 0
  do i=1,3
    svec(i) = snvec(i)-sovec(i)
    xx = xx+svec(i)**2
  enddo
  xx = sqrt(xx)*180d0*3600d0/pi
  if (abs(xx).lt.0.01) goto 500
  !
  ! Modify observation
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) then 
    goto 500
  endif
  if (r_lmode.ne.1) then
    goto 500
  endif
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in, memory)
  !
  ! load data header from average record:
  ipk = kin + h_offset(r_ndump+1)
  call decode_header (memory(ipk))
  !
  ! Compute phase factors
  do ibas = 1, r_nbas
    x(ibas) = 0
    do i=1,3
      x(ibas) = x(ibas) - svec(i)*r_bas(i,ibas) * f_to_k
    enddo
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Real life
  do_data = .true.
  do_write = .true.
500 continue
  return
end subroutine ini_time
!
subroutine ini_axes(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY AXES_OFFSET  a1 x1 a2 x2 a3 x3 ...
  ! correct the phases of antenna ai for the offset xi (in mm) between
  ! the qazimuth and elevation axes.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnant)
  real*8 :: anew(mnant)
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ndata
  integer :: i, j
  character(len=256) :: chain
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real*8 :: bdiff
  real :: x(mnbas)
  integer :: i1, i2
  !
  save anew, fanew
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  do i=1, mnant
    fanew(i) = .false.
  enddo
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    fanew(j) = .true.
    call sic_r8(line,iopt,i+1,anew(j),.true.,error)
    if (error) return
    i = i+2
  enddo
  call message(6,1,'INI_BASE','Modifying axes offsets to :')
  do i=1, mnant
    if (fanew(i)) then
      write(chain,'(1x,i0,f12.6)') i,anew(i)
      call message(6,1,'INI_BASE',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      anew(i) = 0d0
    endif
  enddo
  return
  !
entry mod_axes(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Compute baseline based axes offsets changes:
  do i = 1, r_nbas
    i1 = r_iant(i)
    i2 = r_jant(i)
    bdiff = 0
    if (fanew(i2)) bdiff = bdiff - (anew(i2)-r_axes(i2))
    if (fanew(i1)) bdiff = bdiff + (anew(i1)-r_axes(i1))
    x(i) = cos(r_el)*bdiff*f_to_k
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)
  !
  ! Update header
  do i=1, r_nant
    if (fanew(i)) then
      r_axes(i) = anew(i)
    endif
  enddo
  do_data = .true.
500 return
!
end subroutine ini_axes
!
subroutine ini_focus(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command MODIFY FOCUS ...
  ! correct the phases of antenna ai for the offset in focus
  ! if not (correctly) applied in real time:
  !
  ! if  DATE_OBS is before 29-may-1996 :
  !        focus offset was actually logged
  ! if  DATE_OBS is before 29-nov-1996 :
  !        no correction applied to phase from focus offset
  ! if  DATE_OBS is before 02-apr-1998 and if HIGH LOCK:
  !       the focus correction was wrong sign
  ! ->
  ! MODIFY FOCUS:
  !   - between 29-may-1996 and 29-nov-1996: apply correction in header
  !   - between 29-nov-1996 and 02-apr-1998: change sign of corr.in head.
  ! MODIFY FOCUS  a1 x1 a2 x2 a3 x3 :
  !   - any date: modify phases for the focus change and log value in head.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data
  logical :: fanew(mnant)
  logical :: auto
  real*8 :: anew(mnant)
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ndata
  integer :: i, j
  character(len=256) :: chain
  real*8 :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2*pi/299792458.d-6)
  real*8 :: bdiff
  real :: x(mnbas)
  integer :: i1, i2, autod(3)
  !
  save auto, anew, fanew
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  do i=1, mnant
    fanew(i) = .false.
  enddo
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    fanew(j) = .true.
    call sic_r8(line,iopt,i+1,anew(j),.true.,error)
    if (error) return
    i = i+2
  enddo
  if (i.gt.2) then
    auto = .false.
    call message(6,1,'INI_FOCUS',   &
      'Modifying focus phase offsets to :')
    do i=1, mnant
      if (fanew(i)) then
        write(chain,'(1x,i0,f12.6)') i,anew(i)
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
      else
        write(chain,'(1x,i0,a)') i,' is not modified'
        call message(6,1,'INI_BASE',chain(1:lenc(chain)))
        anew(i) = 0d0
      endif
    enddo
  else
    auto = .true.
    call message(6,1,'INI_FOCUS',   &
      'Modifying focus phase offsets according to header')
    call cdate('29-may-1996',autod(1),error)
    call cdate('29-nov-1996',autod(2),error)
    call cdate('02-apr-1998',autod(3),error)
  endif
  return
  !
entry mod_focus(do_write,do_data,error)
  ! Get storage and data
  call get_data (ndata,data_in,error)
  if (error) return
  kin = gag_pointer(data_in,memory)
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux  &
    .and. r_proc.ne.p_otf) goto 500
  if (r_lmode.ne.1) goto 500
  !
  ! Compute baseline based axes offsets changes:
  do i = 1, r_nbas
    i1 = r_iant(i)
    i2 = r_jant(i)
    bdiff = 0
    if (auto) then
      if (r_dobs.ge.autod(1).and.r_dobs.lt.autod(2)) then
        ! It was not applied ...
        bdiff = bdiff - 2*r_corfoc(i2)
        bdiff = bdiff + 2*r_corfoc(i1)
      elseif (r_dobs.ge.autod(2).and.r_dobs.lt.autod(3)) then
        if (r_lock.gt.0) then
          ! Apply twice: it was wrong way for HIGH LOCK ...
          bdiff = bdiff - 4*r_corfoc(i2)
          bdiff = bdiff + 4*r_corfoc(i1)
        endif
      endif
    else
      if (fanew(i2)) bdiff = bdiff - (anew(i2)-r_corfoc(i2))
      if (fanew(i1)) bdiff = bdiff + (anew(i1)-r_corfoc(i1))
    endif
    ! bdiff was in millimeters.
    x(i) = -bdiff*f_to_k*0.001
  enddo
  !
  ! Actually modify data and data headers:
  call modify_ph(memory(kin),x,0,.true.)  ! Could implement a differential
  ! correction here to account for
  ! different focuses. Has to know
  ! the differences in some way.
  !
  ! Update header
  if (.not.auto) then
    do i=1, r_nant
      if (fanew(i)) then
        r_corfoc(i) = anew(i)
      endif
    enddo
  endif
  do_data = .true.
500 return
!
end subroutine ini_focus
!
subroutine modify_ph(data,x,iunit,rf)
  use classic_api
  !---------------------------------------------------------------------
  ! Actually modify the data and keep track of the modify factors.
  ! X is a baseline dependent phase to frequency ratio (in radians/MHz)
  ! Add the possibility only one spectral unit
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: data(*)                   !
  real :: x(mnbas)                  !
  integer :: iunit                  ! <= 0 means all, else unit to modify
  logical :: rf
  ! Global
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: c_offset, l_offset
  integer :: k, k1, ir, ib, isb, is, i, isign
  integer :: iu1, iu2
  real :: x0, x1, cpha(2,mnbas,mcch), lpha(2,mnbas,mrlband)
  real :: ldph(2,mnbas,mrlband)
  real*8 ::  xph
  !-----------------------------------------------------------------------
  !
  ! Store data modifiers for LR+HR in all cases.
  if (iunit.le.0) then
    iu1 = 1
    iu2 = lband_original
  elseif (iunit.gt.r_nband.or.iunit.gt.lband_original) then
    call message(8,3,'MODIFY_PH','Spectral unit not in data')
    return
  else
    iu1 = iunit
    iu2 = iu1
  endif 
  do ib = 1, r_nbas
    do isb = 1, r_lnsb 
      do is = iu1, iu2
        isign = 3-2*r_lsband(isb,is)
        if (rf) then
          xph = x(ib)*(r_flo1+isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_cfcen(is))))
        else
          xph = x(ib)*isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_cfcen(is)))
        endif
        cpha(isb,ib,is) = xph
        r_dmcpha(isb,ib,is) = r_dmcpha(isb,ib,is)+xph
        if (rf) then
          x0 = x(ib)*(r_flo1+isign*(r_flo2(is)   &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is))))
        else
          x0 = x(ib)*isign*(r_flo2(is) &
            + r_band2(is) * (r_flo2bis(is)   &
            + r_band2bis(is)*r_lfcen(is)))
        endif
        if (rf) then
          x1 = x(ib)*isign*r_band2(is)*r_band2bis(is)*r_lfres(is)
        else
          x1 = x(ib)*isign*r_band2(is)*r_band2bis(is)*r_lfres(is)
        endif
        lpha(isb,ib,is) = x0
        ldph(isb,ib,is) = x1
        r_dmlpha(isb,ib,is) = r_dmlpha(isb,ib,is) + x0
        r_dmldph(isb,ib,is) = r_dmldph(isb,ib,is) + x1
      enddo
    enddo
  enddo
  !
  ! In lowres mode, modify only LR data
  r_presec(modify_sec) = .true.
  if (lowres.and.iunit.gt.r_lband) return
  if (lowres.and.iunit.eq.0) iu2 = r_nbb
  !
  do ir = 1, r_ndump + max(1,r_ndatl)
    k = c_offset(ir) + 1
    ! Continuum
    do ib = 1, r_nbas
      do isb = 1, r_nsb
        k = k+ (iu1-1)*2
        do is = iu1, iu2
          xph = cpha(isb,ib,is)
          call rotate(data(k),xph)
          k = k+2
        enddo
        k = k + (r_nband-iu2)*2
      enddo
    enddo
    ! Line
    if (ir.gt.r_ndump) then
      k = l_offset(ir) + 1
      do ib = 1, r_nbas
        do isb = 1, r_lnsb
          do is = iu1, iu2
            k1 = k+2*r_lich(is)
            x0 = lpha(isb,ib,is)
            x1 = ldph(isb,ib,is)
            do i = 1, r_lnch(is)
              xph = x0+(i-r_lcench(is))*x1
              call rotate(data(k1),xph)
              k1 = k1+2
            enddo
          enddo
          k = k+2*r_lntch
        enddo
      enddo
    endif
  enddo
  return
end subroutine modify_ph
!
subroutine rotate(c,phi)
  !---------------------------------------------------------------------
  ! Rotate Phase of complex number C by PHI radians
  !---------------------------------------------------------------------
  complex :: c                      !
  real*8 :: phi                     !
  ! Local
  real*8 :: pi
  parameter (pi=3.141592653589d0)
  !------------------------------------------------------------------------
  ! Code:
  phi = mod(phi,2.*pi)
  c = c *cmplx(cos(phi), sin(phi))
  return
end subroutine rotate
!
subroutine clic_kw(line,iopt,iarg,kw,nkey,voc,mvoc,present,error,verbose)
  use gkernel_interfaces
  character(len=*) :: line          !
  integer :: iopt                   !
  integer :: iarg                   !
  character(len=*) :: kw            !
  integer :: nkey                   !
  integer :: mvoc                   !
  character(len=*) :: voc(mvoc)     !
  logical :: present                !
  logical :: error, verbose         !
  ! Local
  character(len=12) :: arg
  integer :: narg
  !-----------------------------------------------------------------------
  arg = kw
  call sic_ke(line,iopt,iarg,arg,narg,present,error)
  if (error.or.iarg.eq.0) return
  if (verbose) then
     call sic_ambigs('CLIC_KW',arg,kw,nkey,voc,mvoc,error)
  else
     call sic_ambigs('',arg,kw,nkey,voc,mvoc,error)
  endif
  return
end subroutine clic_kw
!
subroutine ini_phase(line,iopt,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  use clic_virtual
  !---------------------------------------------------------------------
  ! Command MODIFY PHASE a1 d1 ... a2 x2 ... [/SWITCH DIRECT|CROSSED]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_number.inc'
  include 'clic_stations.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: do_write, do_data, crossed, direct
  logical :: fanew(mnbb,mnant), process
  logical :: new
  real*8 :: anew(mnbb,mnant),newval
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length) :: ndata
  integer :: i, j, ia, ja, nch, is, ipa, jpa, k, l, m
  integer :: ibas, ibb, iif, jbb(mnbb), nbb, ipol
  integer :: mvoc,nkey, mvoc1
  parameter (mvoc = 3, mvoc1 = 2)
  character(len=12) :: voc(mvoc),voc1(mvoc1)
  character(len=12) :: argum,kw
  character(len=256) :: chain
  character(len=1) :: arg1
  real*8 :: f_to_k
  parameter (f_to_k = 2*pi/1000.)
  real :: x(mnbas), new_phase(mnbb,mnant)
  !
  save  anew, fanew, direct, crossed
  !
  data voc/'HORIZONTAL','VERTICAL','BOTH'/
  data voc1/'DIRECT','CROSSED'/
  !------------------------------------------------------------------------
  ! Code:
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  call sic_ke(line,iopt,1,arg1,nch,.false.,error)
  if (error) return
  if (arg1.ne.'P') then
    error = .true.
    return
  endif
  error = .false.
  do i=1, mnant
    do j = 1, mnbb
      fanew(j,i) = .false.
    enddo
  enddo
  !
  ! /ALL option
  if (sic_present(10,0)) then
    nbb = r_nbb
    do i=1, r_nbb
      jbb(i) = i
    enddo
  !
  ! /BBAND option
  elseif (sic_present(7,0)) then
    call sic_i4(line,7,1,ibb,.true.,error)
    nbb = 1
    jbb(nbb) = ibb 
  !
  ! /IF option
  elseif (sic_present(8,0)) then
    call sic_i4(line,8,1,iif,.true.,error)
    nbb=0
    do i=1, r_lband
      if (r_if(i).eq.iif) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  endif
  !
  ! /POLARISATION option
  if (sic_present(5,0)) then
    call sic_ke(line,5,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY PHASE /POLARISATION',argum,kw,nkey,voc,   &
     mvoc,error)
    if (error) return
    if (kw.eq.'HORIZONTAL') then
      ipol = 1
    elseif (kw.eq.'VERTICAL') then
      ipol = 2
    elseif (kw.eq.'BOTH') then
      ipol = 3
    else
      call message(6,3,'MODIFY','Invalid polarisation '//argum)
      error = .true.
      return
    endif
    nbb=0
    do i=1, r_lband
      if (r_lpolentry(1,i).eq.ipol.or.ipol.eq.3) then
        new = .true.
        if (nbb.ge.1) then
          do j=1,nbb
            if (r_bb(i).eq.jbb(j)) new = .false.
          enddo
        endif
        if (new) then
          nbb = nbb+1
          jbb(nbb) = r_bb(i)
        endif
      endif
    enddo
  endif
  !
  ! /SWITCH option
  crossed = .false.
  direct = .false.
  if (sic_present(12,0)) then
    call sic_ke(line,12,1,argum,nch,.true.,error)
    if (error) return
    call sic_ambigs('MODIFY PHASE /SWITCH',argum,kw,nkey,voc1,mvoc1,error)
    if (error) return
    if (kw.eq.'DIRECT') then
      direct = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    elseif (kw.eq.'CROSSED') then
      crossed = .true.
      call message(6,1,'MODIFY', &
        'Selecting polarisation switch in '//kw//' mode')
    else
      call message(6,3,'MODIFY','Invalid switch status '//argum)
      error = .true.
      return     
    endif
  endif
!
! Now code
  if (nbb.le.0) then
      call message(6,3,'MODIFY','No valid baseband found')
      error = .true.
      return
  endif
  call sic_ke(line,iopt,2,argum,nch,.true.,error)
  if (error) return
  i = 2
  do while(sic_present(iopt,i))
    call sic_i4(line,iopt,i,j,.true.,error)
    if (error) return
    if (j.le.0 .or. j.gt.mnant) then
      write(argum,'(i6)')
      call message(8,4,'INI_PHASE',   &
        'Invalid antenna '//argum(1:lenc(argum)))
      error = .true.
      return
    endif
    call sic_r8(line,iopt,i+1,newval,.true.,error)
    if (error) return
    i = i+2
    do k=1, nbb
      ibb = jbb(k)
      fanew(ibb,j) = .true.
      anew(ibb,j) = newval
    enddo
  enddo
  call message(6,1,'INI_PHASE','Modifying antenna phases by :')
  do i=1, mnant
    if (fanew(ibb,i)) then
      write(chain,'(1x,i0,f15.6)') i,anew(ibb,i)
      call message(6,1,'INI_PHASE',chain(1:lenc(chain)))
    else
      write(chain,'(1x,i0,a)') i,' is not modified'
      call message(6,1,'INI_PHASE',chain(1:lenc(chain)))
    endif
  enddo
  write(chain,'(1x,8i2)'),(jbb(i),i=1,nbb)
  call message(6,1,'INI_PHASE','For basebands'//chain(1:lenc(chain)))
  return
  !
entry mod_phase(do_write,do_data,error)
  !
  do_data = .false.
  if (error) return
  if (r_proc.ne.p_source .and. r_proc.ne.p_delay   &
    .and. r_proc.ne.p_gain .and. r_proc.ne.p_focus   &
    .and. r_proc.ne.p_point .and. r_proc.ne.p_holog   &
    .and. r_proc.ne.p_five  .and. r_proc.ne.p_flux   &
    .and. r_proc.ne.p_otf .and. r_proc.ne.p_pass) goto 500
  if (r_lmode.ne.1) goto 500
  !
  do i=1, r_nant
    do  j = 1, r_nbb
      l = r_mapbb(j)
      process = fanew(l,i)
      m=(3-r_sb(l))/2    
      if (direct)  process = process.and.(r_polswitch(i,m).eq.0)
      if (crossed) process = process.and.(r_polswitch(i,m).ne.0)
      if (process) then
        new_phase(l,i) = anew(l,i)
      else
        new_phase(l,i) = 0.0
      endif
    enddo
  enddo
  !
  ! Compute phase factors per subband (for crossed pol case)
  do is  = 1, lband_original
    do ibas = 1, r_nbas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      ipa = r_bb(is)
      jpa = r_bb(is)
      x(ibas) = new_phase(ipa,ia)-new_phase(jpa,ja)
      if (degrees) x(ibas) = x(ibas)*pi/180.
    enddo
    !
    ! Actually modify data:
    if (got_data(r_xnum)) then
      call get_data(ndata,data_in,error)
      kin = gag_pointer(data_in,memory)
    else
      kin = 0
    endif
    if (any(x.ne.0)) call modify_phase(memory(kin),x,is)
  enddo
  if (.not.got_data(r_xnum)) goto 500
  !
  do_data = .true.
500 return
end subroutine ini_phase
!
subroutine modify_phase(data,x,iunit)
  use classic_api
  use clic_index
  use clic_virtual
  !---------------------------------------------------------------------
  ! Actually modify the data and keep track of the modify factors.
  ! X is a baseline dependent phase offset.
  ! Add the possibility only one spectral unit.
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: data(*)                   !
  real :: x(mnbas)                  !
  integer :: iunit                  ! <= 0 means all, else unit to modify
  ! Global
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: c_offset, l_offset
  integer :: k, k1, ir, ib, isb, is, i, isign
  integer :: iu1, iu2
  real :: cpha(2,mnbas,mcch), lpha(2,mnbas,mrlband)
  real*8 ::  xph
  !-----------------------------------------------------------------------
  !
  ! Store data modifiers for LR+HR in all cases.
  if (iunit.le.0) then
    iu1 = 1
    iu2 = lband_original
  elseif (iunit.gt.r_nband.or.iunit.gt.lband_original) then
    call message(8,3,'MODIFY_PH','Spectral unit not in data')
    return
  else
    iu1 = iunit
    iu2 = iu1
  endif 
  do ib = 1, r_nbas
    do isb = 1, r_lnsb 
      do is = iu1, iu2
        isign = 3-2*r_lsband(isb,is)
        cpha(isb,ib,is) = x(ib)
        r_dmcpha(isb,ib,is) = r_dmcpha(isb,ib,is)+x(ib)
        lpha(isb,ib,is) = x(ib)
        r_dmlpha(isb,ib,is) = r_dmlpha(isb,ib,is) + x(ib)
      enddo
    enddo
  enddo
  !
  ! In lowres mode, modify only LR data
  r_presec(modify_sec) = .true.
  if (lowres.and.iunit.gt.r_lband) return
  if (lowres.and.iunit.eq.0) iu2 = r_nbb
  !
  ! Only modify data in memory
  if (.not.got_data(r_xnum)) return
  !
  do ir = 1, r_ndump + max(1,r_ndatl)
    k = c_offset(ir) + 1
    ! Continuum
    do ib = 1, r_nbas
      do isb = 1, r_nsb
        k = k+ (iu1-1)*2
        do is = iu1, iu2
          xph = cpha(isb,ib,is)
          call rotate(data(k),xph)
          k = k+2
        enddo
        k = k + (r_nband-iu2)*2
      enddo
    enddo
    ! Line
    if (ir.gt.r_ndump) then
      k = l_offset(ir) + 1
      do ib = 1, r_nbas
        do isb = 1, r_lnsb
          do is = iu1, iu2
            k1 = k+2*r_lich(is)
            xph = lpha(isb,ib,is)
            do i = 1, r_lnch(is)
              call rotate(data(k1),xph)
              k1 = k1+2
            enddo
          enddo
          k = k+2*r_lntch
        enddo
      enddo
    endif
  enddo
  return
end subroutine modify_phase

subroutine merge(set,all,error,user_function)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>merge
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! Support routine for command MERGE.
  ! Gather observations in the index into a single observations
  !
  ! * No consistency check is done
  ! * The resulting R buffer is labeled as "irregularly sampled"
  ! * time is sum(time)
  ! * Tsys is <Tsys> weighted by time
  ! * tau  is <tau>  weighted by time
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: all
  logical,             intent(inout) :: error
  logical,             external      :: user_function
  ! Local
  character(len=*), parameter :: proc='MERGE'
  type (observation) :: obs
  integer(kind=4) :: ier,npoin_final
  integer(kind=entry_length) :: iobs,i1,i2
  real(xdata_kind), allocatable :: wx(:)
  real(kind=4), allocatable :: wy(:),w4(:)
  integer(kind=4), allocatable :: wint(:)
  real(kind=4) :: total_time,newtsys,newtau
  !
  ! Verify if any input file
  if (.not.filein_opened(proc,error))  return
  if (cx%next.le.1) then
     call class_message(seve%e,proc,'Index is empty')
     error = .true.
     return
  endif
  !
  !
  knext= 1
  call init_obs(obs)
  !
  ! Read the first observation into OBS
  call get_first(set,obs,user_function,error)
  if (error) return
  !
  !
  if (obs%head%gen%kind.ne.kind_cont) then
     call class_message(seve%e,proc,'Only for continuum drifts')
     error = .true.
     return
  endif
  !
  ! if only one spectrum, make a copy
  if (cx%next.eq.2) then
     call class_message(seve%w,proc,'Only one spectrum in index!')
     call copy_obs(obs,all,error)
     if (error) then
        call class_message(seve%e,proc,'Could not copy input spectrum')
        return
     endif
  else
     !
     ! Compute final number of points
     i1 = 1
     i2 = obs%head%dri%npoin
     npoin_final = obs%head%dri%npoin
     do iobs = 2,cx%next-1
        call get_it(set,obs,cx%ind(iobs),user_function,error)
        if (error) return
        npoin_final = npoin_final + obs%head%dri%npoin
     enddo
     !
     ! Allocate working arrays
     allocate(wx(npoin_final),wy(npoin_final),wint(npoin_final),w4(npoin_final),stat=ier)
     if (failed_allocate(proc,'WX,WY,WINT,WW',ier,error)) return
     !
     ! Allocate ALL observation
     all%head  = obs%head
     call reallocate_obs(all,npoin_final,error)
     if (error) return
     all%head%dri%npoin = npoin_final
     !
     ! Loop over index
     i2 = 0
     total_time = 0.
     newtsys    = 0.
     newtau     = 0.
     do iobs = 1,cx%next-1
        call get_it(set,obs,cx%ind(iobs),user_function,error)
        if (error) exit
        call abscissa(set,obs,error)   ! Compute X arrays according to type and unit
        if (error) exit
        i1 = i2+1
        i2 = i1+obs%head%dri%npoin-1
        wx(i1:i2) = obs%datax
        wy(i1:i2) = obs%data1
        !
        ! Compute new header variables
        total_time = total_time + obs%head%gen%time
        newtsys    = newtsys + obs%head%gen%tsys*obs%head%gen%time
        newtau     = newtau  + obs%head%gen%tau*obs%head%gen%time
        call class_controlc(proc,error)
        if (error) return
     enddo
     !
     ! Sort arrays
     call gr8_trie(wx,wint,npoin_final,error)
     if (error) then
        call class_message(seve%e,proc,'Could not sort arrays')
        return
     endif
     call gr4_sort(wy,w4,wint,npoin_final)
     !
     all%datax = wx
     all%data1 = wy
  endif
  !
  ! Finalize the output observation
  if (.not.error) then
    !
    ! History will be used to keep list of summed spectra
    all%head%presec(class_sec_his_id) = .true.
    !
    ! The summed spectrum is generated by program:
    all%head%xnum = -1
    !
    ! Update header (calibration parameters)
    all%head%gen%time = total_time
    all%head%gen%tsys = newtsys / total_time
    all%head%gen%tau  = newtau / total_time
    !
    all%head%presec(class_sec_xcoo_id) = .true.
    call abscissa(set,all,error)
    if (error) return
    call newdat(set,all,error)
    call newdat_assoc(set,all,error)
    call newdat_user(set,all,error)
  endif
  !
  ! Free memory
  call free_obs(obs)
  deallocate(wx,wy,wint,w4)
end subroutine merge

program uv_gain
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  ! Compute Gains by comparing the UVT table and
  !       a UV model file.
  ! Input : a UV table (observed)
  !         a UV model
  ! Output: a UV table, with the gains.
  !         a UV calibrated table
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: gain,model,raw,cal
  integer, parameter :: mant=256  ! Valid for ALMA, VLA and most others.
  integer, parameter :: mbas=mant*(mant-1)/2
  character(len=*), parameter :: rname='UV_GAIN'
  logical :: error
  integer(4) ::  n, ichan, nvis, ncol, ier
  !
  character(len=filename_length) :: uvdata, uvmodel, uvgain, uvcal, &
    & uvsol, name   ! File names
  real :: tinteg    ! Integration time
  real :: snr       ! Minimum SNR for a solution
  integer :: refant ! Reference antenna (0 = automatic)
  logical :: flag   ! Flag data with no solution
  logical :: do_amp ! Self calibrate amplitude
  logical :: do_pha ! Self calibrate phase
  logical :: antenna_based ! Antenna based self calibration
  !
  integer, allocatable :: index(:)  ! Sorting index (by time)
  real(8), allocatable :: itime(:)  ! Times of observations
  real, allocatable, target :: basegain(:,:), antegain(:,:) ! Gain arrays
  integer :: ntimes   ! Number of different times in data
  integer :: nantes   ! Maximum number of antennas in data
  !
  ! Code
  call gildas_open
  call gildas_char('UVDATA$',uvdata)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_char('UVGAIN$',uvgain)
  call gildas_char('UVCAL$',uvcal)
  call gildas_real('TINTEG$',tinteg,1)
  call gildas_real('SNR$',snr,1)
  call gildas_logi('FLAG$',flag,1)
  call gildas_inte('CHANNEL$',ichan,1)
  call gildas_logi('DO_AMP$',do_amp,1)
  call gildas_logi('DO_PHA$',do_pha,1)
  call gildas_logi('ANTENNA_BASED$',antenna_based,1)
  call gildas_inte('REFERENCE_A$',refant,1)
  if (antenna_based) call gildas_char('UVSOL$',uvsol)
  call gildas_close
  !
  if (uvdata.eq.uvcal) then
    call map_message(seve%f,rname, &
    & 'Input and Self-calibrated table must differ.')
    error = .true.
    goto 999
  endif
  !
  ! Input file : data, in "raw"
  n = len_trim(uvdata)
  if (n.le.0) goto 999
  name = uvdata(1:n)
  call gildas_null(raw, type = 'UVT')
  call gdf_read_gildas(raw, name, '.uvt', error)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table ')
    goto 999
  endif
  !
  ! Input file : model, in "model"
  n = len_trim(uvmodel)
  if (n.le.0) goto 999
  call gildas_null(model, type = 'UVT')
  name = uvmodel(1:n)
  call gdf_read_gildas(model, name, '.uvt', error)
  if (error) then
    call map_message(seve%e,rname,'Cannot read model UV table ')
    goto 999
  endif
  !
  ! Prepare output gain table : in "gain"
  call gildas_null(gain, type = 'UVT')
  call gdf_copy_header (model, gain, error)
  n = len_trim(uvgain)
  if (n.eq.0) goto 999
  name  = uvgain(1:n)
  call sic_parsef(name,gain%file,' ','.uvt')
  call map_message(seve%i,rname,'Creating UV table '//trim(gain%file))
  call gdf_create_image (gain, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create Gain Table')
    goto 999
  endif
  !
  nvis = raw%gil%dim(2)
  ncol = raw%gil%dim(1)
  !
  if (antenna_based) then
    allocate (index(nvis), itime(nvis), &
      & basegain(10,nvis),antegain(10,nvis), stat=ier)
  else
    allocate (index(nvis), itime(nvis), &
      & basegain(10,nvis),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate gain arrays')
    goto 999
  endif
  !
  ! Get baseline-based gains ...
  call do_base_gain(do_amp,do_pha,nvis,ncol,ichan,itime,   &
     &    index,raw%r2d,model%r2d,basegain)
  !!print *,'Done do_b_gain'
  !
  ! Model table is not needed any more.
  deallocate (model%r2d, stat=ier)
  call gdf_close_image (model, error)
  !
  ! Compute antenna-based gains ...
  if (antenna_based) then
    call do_ante_gain(do_amp,do_pha,nvis,itime,tinteg,snr,   &
     &      basegain, antegain, refant, ntimes, nantes)
    call do_plot_gain(ntimes,nantes,uvsol,refant,error)
    !
    gain%r2d => antegain
  else
    gain%r2d => basegain  
  endif
  !
  ! Prepare output calibrated table
  call gildas_null(cal, type = 'UVT')
  call gdf_copy_header(raw, cal, error)
  n = len_trim(uvcal)
  if (n.eq.0) goto 999
  name  = uvcal(1:n)
  call sic_parsef(name,cal%file,' ','.uvt')
  call map_message(seve%i,rname,'Creating UV table '//trim(cal%file))
  call gdf_create_image (cal,error)
  if (.not.error) call gdf_allocate (cal, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create Calibrated Table')
    goto 999
  endif
  !
  ! Fill in calibrated table
  call do_apply_cal(ncol,raw%gil%nchan,nvis,raw%r2d,cal%r2d,gain%r2d,flag,index)
  !
  call gdf_write_data (cal, cal%r2d, error)
  call gdf_write_data (gain, gain%r2d, error)
  ! Cleaning
  if (allocated(index))     deallocate(index)
  if (allocated(itime))     deallocate(itime)
  if (allocated(basegain))  deallocate(basegain)
  if (allocated(antegain))  deallocate(antegain)
  !
  call map_message(seve%i,rname,'Successful completion')
  call sysexi(1)
  !
  999   call sysexi (fatale)
end program uv_gain
!
subroutine do_apply_cal(ncol,nch,nvis,data,cal,gain,flag,index)
  use gbl_message
  !---------------------------------------------------------------------
  ! Apply Gain Table to input UV data set
  ! Index is the ordering of the gain. Gain(i) applies to Visi(Index(i))
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: ncol             ! Number of column in visi
  integer(kind=4), intent(in)  :: nvis             ! Number of visibilities
  integer(kind=4), intent(in)  :: nch              ! Number of channels
  real(kind=4),    intent(in)  :: data(ncol,nvis)  ! Raw data
  real(kind=4),    intent(out) :: cal(ncol,nvis)   ! Calibrated data
  real(kind=4),    intent(in)  :: gain(10,nvis)    ! Gain array
  logical,         intent(in)  :: flag             ! Flag data with no solution
  integer(kind=4), intent(in)  :: index(nvis)      ! Visibility order
  ! Local
  character(len=*), parameter :: rname='UV_GAIN'
  character(len=message_length) :: mess
  integer(kind=4) :: iv, jv, k, nflag
  complex(kind=4) :: zdata, zgain, zcal
  !
  nflag = 0
  do iv=1, nvis
    jv = index(iv)
    do k=1, 7
      cal(k,jv) = data(k,jv)
    enddo
    zgain = cmplx(gain(8,iv),gain(9,iv))
    if (gain(10,iv).lt.0) then
      nflag = nflag+1
      zgain = 0
    endif
    do k=8, 5+3*nch, 3
      if (zgain.ne.0) then
        zdata = cmplx(data(k,jv),data(k+1,jv))
        zcal = zdata / zgain
        cal(k,jv) = real(zcal)
        cal(k+1,jv) = aimag(zcal)
        cal(k+2,jv) = data(k+2,jv)*abs(zgain)**2
      else
        cal(k,jv) = data(k,jv)
        cal(k+1,jv) = data(k+1,jv)
        cal(k+2,jv) = data(k+2,jv)
        if (flag) cal(k+2,jv) = -abs(cal(k+2,jv))
      endif
    enddo
    if (8+3*nch.le.ncol) then
      cal(8+3*nch:ncol,jv) = data(8+3*nch:ncol,jv)
    endif
  enddo
  !
  write(mess,'(I0,A)') nflag,' flagged visibilities in gain array'
  if (nflag.eq.0) then
    continue
  elseif (flag) then
    mess = trim(mess)//', flagged in calibrated data (FLAG$ = YES)'
  else
    mess = trim(mess)//', not flagged and no calibration applied in calibrated data (FLAG$ = NO)'
  endif
  call map_message(seve%i,rname,mess)
end subroutine do_apply_cal
!
subroutine do_ante_gain(do_amp,do_pha,nvis,times,tinteg,snr, &
  & basegain,antegain,refant,ntimes,nantes)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! UV_GAIN
  !     S.Guilloteau & V.Pietu, derived from R.Lucas CLIC code
  !
  !   Compute complex gains (antenna-based solution) from a set
  !   of initial Antenna gains, smoothing in time as needed.
  !
  !   The initial Antenna gains must be sorted by increasing time
  !---------------------------------------------------------------------
  logical, intent(in)  :: do_amp                 ! Calibrate amplitude ?
  logical, intent(in)  :: do_pha                 ! Compute phase ?
  integer, intent(in)  :: nvis                   ! Number of visibilities
  real(8), intent(in)  :: times(nvis)            ! Times of visibilities
  real, intent(in)  :: tinteg                    ! Integration time
  real, intent(in)  :: snr                       ! requested Signal to Noise 
  real, intent(in)  :: basegain(10,nvis)         ! Input baseline gain array
  real, intent(inout)  :: antegain(10,nvis)      ! Output antenna gain array
  integer, intent(in) :: refant                  ! Reference antenna
  integer, intent(out) :: ntimes                 ! Number of time steps
  integer, intent(out) :: nantes                 ! Number of antennas
  ! Global
  character(len=*), parameter :: rname='UV_GAIN'
  real(8), parameter :: pi=3.14159265358979323846d0
  ! Maximum Size of problem
  ! ALMA uses stations rather than antennas
  integer, parameter :: mant=256  
  integer, parameter :: mbas=mant*(mant-1)/2
  ! Local
  character(len=256) :: mess
  real(8) ::  t, told
  real :: ampli, phase, ug, vg, d2, dmin, maxsnr,minsnr
  integer ::  iref, iv, jv, ia, ja, ib, i, nant, nbas, j, k, nant_old
  integer ::  lia, lja, igood, isol, iflag
  integer :: ibad, kbad, icount, itest, vgood, vbad
  logical :: error, ok
  !
  integer ::  al(mant)  !Physical number of Sequential number
  integer ::  la(mant)  !Sequential number of Physical number
  real :: ua(mant), va(mant)
  real :: aa(mant), ampsnr(mant)
  real(8) ::  ca(mant), cp(mant), wp(mant)
  real(8) ::  wk2(mant,mant), wk3(mant)
  logical :: isbad(mant)
  integer :: jbad(mant)
  !
  integer ::  iant(mbas), jant(mbas)      ! Start & End antenna of baseline
  real(8) ::  x(mbas), y(mbas), w(mbas), amp(mbas), pha(mbas), wa(mbas), ss(mbas)
  ! For debug only
  integer ::  lpairs(mant), lpair(mant,mant)
  !-----------------------------------------------------------------------
  nbas = 0
  igood = 0
  isol = 0
  vgood = 0
  vbad = 0
  do j=2, mant
    do i=1, j-1
      nbas = nbas+1
      iant(nbas) = i
      jant(nbas) = j
    enddo
  enddo
  !
  ! The algorithm will find a better value for ref antenna,
  ! the one nearest to the array center.
  iref = refant
  !
  ! Loop on visibilities
  !
  told = -1d10  ! An impossibly old time...
  ntimes = 0
  nantes = 0
  do iv=1, nvis
    t = times(iv)
    !
    ! Time change ?
    if (told.ne.t) then
      !
      ! Identify a new time range
      ntimes = ntimes+1
      !print *,'New output time ',iv,told,t,ntimes
      told = t
      nant_old = 0
      jv = iv
      !
      ! Find starting visibility < Told-Tinteg/2
      do while (jv.gt.1 .and. t .ge. told-tinteg/2)
        jv = jv - 1
        t = times(jv)
      enddo
      la = 0
      ca = 0.0
      cp = 0.0
      x = 0.0
      y = 0.0
      w = 0.0
      !
      ! Search how many antennas at this time, and average
      ! over all visibilities which fit the time range
      !
      ok = (jv.lt.nvis .and. t.le.told+tinteg/2.)
      lpairs = 0
      lpair  = 0
      nant = 0
      do while (ok)
        !
        ! Only Select the UN-FLAGGED data
        !
        if (basegain(10,jv).gt.0.0) then
          !
          ! Build the antenna pointer list "la" and "al"
          !
          ! In the end, we use this formula...
          !    ia = la(nint(basegain(6,iv)))
          !    ja = la(nint(basegain(7,iv)))
          ! which figures out which sequence number is each antenna
          !
          ia = nint(basegain(6,jv))
          if (la(ia).eq.0) then
            nant = nant+1
            la(ia) = nant
            al(nant) = ia ! The reverse pointer
          endif
          ja = nint(basegain(7,jv))
          if (la(ja).eq.0) then
            nant = nant+1
            la(ja) = nant
            al(nant) = ja
          endif
          !
          !! Build the antenna pairs (for debug only)
          !! lpairs(la(ia)) = lpairs(la(ia))+1
          !! lpair(lpairs(la(ia)),la(ia)) = la(ja)
          !!
          !! lpairs(la(ja)) = lpairs(la(ja))+1
          !! lpair(lpairs(la(ja)),la(ja)) = la(ia)        

          ! Here we set in UA,VA the "Antenna" U,V coordinate
          ! relative to Antenna #1
          !   Note: we do not average UA,VA over time since it
          !   is only used to determine the Reference antenna,
          !   a nearly irrelevant number.
          lia = la(ia)
          lja = la(ja)
          if (lia.eq.1) then
            ua(lja) = basegain(1,jv)
            va(lja) = basegain(2,jv)
          elseif (lja.eq.1) then
            ua(lia) = -basegain(1,jv)
            va(lia) = -basegain(2,jv)
          endif
          !
          ! Here we average the visibility into the X,Y,W buffer
          ! we also set start antenna < end antenna
          if (lia.eq.lja) then
            print *,'Ignoring autocorrelation for ',lia,al(lia)
          else
            if (lia.lt.lja) then
              ib = (lja-1)*(lja-2)/2+lia
              y(ib) = y(ib) + basegain(9,jv)*basegain(10,jv)        
            else !! if (lja.lt.lia) then
              ib = (lia-1)*(lia-2)/2+lja
              y(ib) = y(ib) - basegain(9,jv)*basegain(10,jv)
            endif
            x(ib) = x(ib) + basegain(8,jv)*basegain(10,jv)
            w(ib) = w(ib) + basegain(10,jv)
          endif
          !
        endif  ! End selection of Un-Flagged data
        !
        jv = jv + 1
        t = times(jv)
        ok = (jv.lt.nvis .and. t.le.told+tinteg/2.)
      enddo
      !
      ! get the reference antenna, by locating the one
      ! with the shortest baselines
      !
      nbas = nant*(nant-1)/2
      !
      ! Compute the centroid of antenna positions (still relative to Antenna #1)
      ug = 0
      vg = 0
      do ia=1, nant
        ug = ug+ua(ia)
        vg = vg+va(ia)
      enddo
      ug = ug/nant
      vg = vg/nant
      dmin = 1e10
      !
      ! Locate the antenna closest to centroid (this is independent of absolute pos.)
      iref = 1
      do ia=1, nant
        d2 = (ua(ia)-ug)**2 + (va(ia)-vg)**2
        if (d2.lt.dmin) then
          dmin = d2
          iref = ia
        endif
      enddo
      !
      ! This is wrong if antenna renumbering occured
      ! It should be 
      !       la(iref) = refant
      if (refant.ne.0) iref = refant
      !
      ! Check if any antenna has no closure 
      ibad = 0
      do lia=1,nant
        icount = 0
        do lja=1,nant
          if (lia.ne.lja) then
            if (lia.lt.lja) then
              ib = (lja-1)*(lja-2)/2+lia
            else !! if (lja.lt.lia) then
              ib = (lia-1)*(lia-2)/2+lja
            endif
            if (w(ib).ne.0) then
              icount = icount+1
            endif
          endif
        enddo
        if (icount.lt.2) then
          print *,'Antenna Seq.',lia,' (Phys. ',al(lia),') has no closure'
          ibad = ibad+1
          jbad(ibad) = lia
          isbad(lia) = .true.
        else
          isbad(lia) = .false.
        endif
      enddo
      !
      if (ibad.eq.nant) then
        print *,'No antenna can be calibrated at this time'
      else if (ibad.ne.0) then
        print *,ibad,' antennas with no solution'
      endif
      !
      ! Normalize the time averaged visibilities
      do ib=1, nbas
        if (w(ib).ne.0) then
          x(ib) = x(ib)/w(ib)
          y(ib) = y(ib)/w(ib)
        endif
      enddo
      !
      ! phases
      if (do_pha) then
        !
        ! Here, normally, each antenna should have at least
        ! 2 baselines, otherwise it is not possible...
        !
        if (ibad.ne.nant) then
          ! Solve for amplitude first to estimate S/N ratio
          ! Use an intermediate weight array "wa" for this
          do ib=1, nbas
            if (w(ib).ne.0) then
              amp(ib) = log(x(ib)**2+y(ib)**2)/2.
              wa(ib)  = w(ib)*(x(ib)**2+y(ib)**2)
            else
              wa(ib) = 0.0
            endif
          enddo
          call gain_ant(1, nbas, iant, jant, iref,   &
       &          nant, amp, wa, wk2, wk3, ss, ca, wp, error)
          !
          do ia = 1, nant
            isol = isol + 1
            aa(ia) = exp(2*ca(ia))
            wa(ia) = wp(ia)/aa(ia)**2
            ampsnr(ia) = aa(ia)*sqrt(wa(ia))*1e3
            if (isbad(ia)) ampsnr(ia) = 0.0 !S.Guilloteau
            !
            ! Reset amplitude to 1 now
            ca(ia) = 0
          enddo
          maxsnr = maxval(ampsnr(1:nant))
          minsnr = maxsnr
          do ia = 1, nant
            if (ampsnr(ia).ne.0) minsnr = min(minsnr,ampsnr(ia))
          enddo
        else
          maxsnr = 0.0
          minsnr = 0.0
        endif
        !
        if (maxsnr.gt.snr) then
          !
          ! If enough SNR, solve for the Phases for the good
          ! antennas. Use the initial weights "w" here.
          do ib=1, nbas
            if (w(ib).ne.0) then
              pha(ib) = atan2(y(ib),x(ib))
              !
              ! 1-Mar-2018 S.Guilloteau
              ! Normally, the phase error in radian is the Noise to Signal ratio,
              ! so the weight of that phase should be  (Signal/Noise)^2
              ! i.e. wa(ib) = (x(ib)^2+y(ib)^2) * w(ib)
              ! since w(ib) is the 1/Noise^2 for the (real, imaginary) parts,
              ! i.e. like used above for the Amplitude
              !
            else
              pha(ib) = 0.0
            endif
          enddo
          call gain_ant(2, nbas, iant, jant, iref,   &
     &            nant, pha, w, wk2, wk3, ss, cp, wp, error)
          iflag = 0
          do ia =1, nant
            !
            ! Keep only antenna solution with required snr
            if (ampsnr(ia).lt.snr) then
              cp(ia) = 0      ! Set phase correction to Zero
              itest = 0
              !
              ! Check whether this antenna was already expected
              ! to be without solution or not.
              do kbad=1,ibad
                if (jbad(kbad).eq.ia) then
                  !!print *,'** OK ** NO Solution for flagged antenna ',ia,al(ia)
                  itest = kbad
                  exit
                endif
              enddo
              if (itest.eq.0) then
                print *,'** Warning *** Flagged one more antenna ',ia,al(ia)
                isbad(ia) = .true.
              endif
              iflag = iflag+1
            else
              ! This was happening when AMPSNR was not set to Zero for
              ! antennas with no closure.
              !do kbad=1,ibad
              !  if (jbad(kbad).eq.ia) then
              !    print *,'** Warning *** Solution for flagged antenna ',ia,al(ia)
              !    print *,' Amp SNR ',ampsnr(ia),snr,aa(ia),wa(ia)
              !    exit
              !  endif
              !enddo
              igood = igood + 1
            endif
          enddo
        else
          iflag = nant
        endif
        if (iflag.ne.0) then
          write(mess,101) told,iref,maxsnr,minsnr,iflag
        else
          write(mess,101) told,iref,maxsnr,minsnr
        endif
101   format('Time ',F16.1,' Ref ',i3,' SNR: Max ',F5.1,' Min ',F5.1,I3,' antennas ignored')
        call map_message(seve%i,rname,mess)
      endif
      !
      ! This is redundant: it has already been done above
      do ia=1,nant
        if (isbad(ia)) then
          cp(ia) = 0.
        endif
      enddo
      !
      ! amplitudes next (because Phase reset CA = 0.0)
      if (do_amp) then
        !
        ! Here, we should check that each antenna should have at least
        ! 3 baselines, otherwise it is not possible...
        !
        ! Here, we use the raw initial weights also, not the SNR weights
        do ib=1, nbas
          if (w(ib).ne.0) then
            amp(ib) = log(x(ib)**2+y(ib)**2)/2.
          endif
        enddo
        call gain_ant(1, nbas, iant, jant, iref,   &
     &          nant, amp, w, wk2, wk3, ss, ca, wp, error)
      endif
      !
      ! Write the Phase on Unit 2, Amplitude on Unit 3
      write(2,*) iref,told,nant  ! Reference antenna
      write(2,102) al(1:nant)    ! Antenna list
102   format(16(1x,i3))
      write(2,100) cp(1:nant)*180.0/pi
      write(2,100) ampsnr(1:nant)
100   format (8(2x,f10.1))
      nantes = max(nantes,nant)
      !
      !!print *,'BAD ',isbad(1:nant)
    endif
    !
    ! Fill in the antenna gains in "antegain"
    do k=1,7
      antegain(k,iv) = basegain(k,iv)
    enddo
    ia = la(nint(basegain(6,iv)))
    ja = la(nint(basegain(7,iv)))
    ampli = 1./exp(ca(ia)+ca(ja)) ! Not sure for this one...
    phase = - cp(ia) + cp(ja)     ! This is THE solution
    !! print *,'IV ',ampli, 180*phase/3.14159
    antegain(8,iv) = ampli * cos(phase)
    antegain(9,iv) = ampli * sin(phase)
    !
    ! Flag data with no solution
    !! print *,'IV ',iv,' IA ',ia,isbad(ia),' JA ',ja,isbad(ja)
    if (isbad(ia).or.isbad(ja)) then
       antegain(10,iv) = -abs(basegain(10,iv))
       vbad = vbad+1
    else
       antegain(10,iv) = basegain(10,iv)
       vgood = vgood+1
    endif
  enddo
  write(mess,'(A,I0,A,I0,A)') "Found ",igood,"/",isol," good solutions"
  call map_message(seve%i,rname,mess)
  write(mess,'(A,I0,A,I0,A)') "Retained ",vgood," valid visibilities, ", &
    vbad," flagged ones"
  call map_message(seve%i,rname,mess)
end subroutine do_ante_gain
!
subroutine do_base_gain(do_amp,do_pha,nvis,ncol,icol,times,index,   &
     &    data,model,gain)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! UV_GAIN
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  ! do_base_gain
  !   Compute the Baseline-Based Gain by comparing the Data
  !   to the Model, retaining either Amplitude or Phase
  !   (or both, but this is not used by the calling routines so far)
  ! 
  !   We use channel Icol from Data table for the Data.
  !   Model and Gain are assumed to be continuum (i.e. single-channel)
  !   tables.
  !   Gain will contain the observed baseline gains, in an increasing 
  !   time order.
  !   Times is a Real(8) array to sort out date/time 
  !   Index is an integer array yielding the ordering
  !     gain(i) = data/model (Index(i))
  !---------------------------------------------------------------------
  logical, intent(in) :: do_amp                 ! Calibrate amplitude
  logical, intent(in) :: do_pha                 ! Calibrate phase
  integer, intent(in) :: nvis                   ! Number of visibilities
  integer, intent(in) :: ncol                   ! Size of a visibility
  integer, intent(in) :: icol                   ! Reference column
  real(8), intent(out) :: times(nvis)           ! Time stamps of visibilities
  integer, intent(out) :: index(nvis)           ! Index of visibilities
  real, intent(in) :: data(ncol,nvis)           ! Raw visibilities
  real, intent(in) :: model(10,nvis)            ! Modeled visibilities
  real, intent(out) :: gain(10,nvis)            ! Gain solution
  ! Local
  logical :: error
  ! Local:
  integer :: iv, i, jv, k
  complex :: zgain, zdata, zmodel
  real :: wgain, wdata, again, date0
  !-----------------------------------------------------------------------
  !
  ! Get the chronological order:
  date0 = data(4,1)
  do iv=1, nvis
    ! Beware of Real(8) precision ...
    times(iv) = (data(4,iv)-date0)*86400.d0+data(5,iv)  
  enddo
  call gr8_trie (times,index,nvis,error)
  !
  ! Sorted data in gain:
  do iv=1,nvis
    jv = index(iv)
    do i=1, 7
      gain(i,iv) = data(i,jv)
    enddo
    k = (icol-1)*3+7
    zdata = cmplx(data(k+1,jv),data(k+2,jv))
    wdata = data(k+3,jv)
    zmodel = cmplx(model(8,jv),model(9,jv))
    if (zmodel.ne.0) then
      zgain = zdata/zmodel
      wgain = wdata*abs(zmodel)**2
      if (.not.do_amp) then
        again = abs(zmodel)
        ! Here Zgain = Zdata modified by a phase factor .
        ! If we have a good model of the data, Zgain will
        ! have module of order Unity
        zgain = zgain*again 
        wgain = wdata
      elseif (.not.do_pha) then
        ! Here Zgain is just an amplitude factor.
        ! Phases are not modified
        ! Again, if the model is good, Zgain will be close to Unity
        zgain = abs(zgain)  ! Zgain = An amplitude factor
      else  
        ! Normally, we do not do Phase and Amplitude at once
        ! so this section of code is normally Idle
        ! 
        ! Zgain has both the Phase and the Amplitude factor
        ! here, so no change needed
      endif
    else
      zgain = 0. ! It can be anything, since Wgain is Zero
      wgain = 0.
    endif
    gain(8,iv) = real(zgain)
    gain(9,iv) = aimag(zgain)
    gain(10,iv) = wgain
  enddo
end subroutine do_base_gain
!
subroutine gain_ant(iy,nbas,iant,jant,iref,nant,y,w,wk2,wk3,ss,c,wc,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! UV_GAIN
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  ! gain_ant 
  !     computes a weighted least-squares approximation
  !     to the antenna amplitudes or phases
  !     for an arbitrary set of baseline data points.
  !---------------------------------------------------------------------
  integer, intent(in) :: iy                ! 1 for log(amplitude), 2 for phase
  integer, intent(in) :: nbas              ! the number of baselines
  integer, intent(in) :: iant(nbas)        ! start antenna for each baseline
  integer, intent(in) :: jant(nbas)        ! end  antenna for each baseline
  integer, intent(in) :: iref              ! Reference antenna for phases
  integer, intent(in) :: nant              ! the number of antennas
  real(8), intent(in) :: y(nbas)           ! the data values
  real(8), intent(in) :: w(nbas)           ! weights
  real(8), intent(inout) :: wk2(nant,nant) ! work space
  real(8), intent(inout) :: wk3(nant)      ! work space
  real(8), intent(out) :: ss(nbas)         ! rms of fit for each baseline
  real(8), intent(out) :: c(nant)          ! the gains
  real(8), intent(out) :: wc(nant)         ! the weights
  logical, intent(out) :: error            !
  ! Global
  integer, external :: zant
  ! Local
  real(8) :: norm, tol
  !
  parameter (tol=1d-14)
  integer :: i, ia, ib, nantm1, ja, l, iter, ier
  real(8) ::  wi, ww, yi
  !------------------------------------------------------------------------
  ! Code
  !
  ss = 0.
  !
  ! Check that the weights are positive.
  !
  error = .false.
  do ib = 1, nbas
    if (w(ib).lt.0.0d0) then
      call gagout('E-GAIN_ANT,  Weights not positive')
      error = .true.
      return
    endif
  enddo
  !
  ! Amplitude case is simple...
  !
  if (iy.eq.1) then
    wk2 = 0.0d0
    wk3 = 0.0d0
    !
    ! store the upper-triangular part of the normal equations in wk2
    ! and the right-hand side in wk3.
    do ib=1,nbas
      wi = w(ib)
      if (wi.gt.0) then
        ia = iant(ib)
        ja = jant(ib)
        wk2(ia,ia) = wk2(ia,ia)+wi
        wk2(ia,ja) = wk2(ia,ja)+wi
        wk2(ja,ia) = wk2(ja,ia)+wi
        wk2(ja,ja) = wk2(ja,ja)+wi
      endif
    enddo
    do ib=1, nbas
      ia = iant(ib)
      ja = jant(ib)
      wi = w(ib)*y(ib)
      wk3(ia) = wk3(ia) + wi
      wk3(ja) = wk3(ja) + wi
    enddo
    !
    ! Solve the system of normal equations by first computing the Cholesky
    ! factorization
    call mth_dpotrf ('GAIN_ANT','U',nant,wk2,nant,error)
    if (error) return
    call mth_dpotrs ('GAIN_ANT','U',nant,1,wk2,nant,wk3,nant,ier)
    if (ier.ne.0) return
    do i=1,nant
      c(i) = wk3(i)
      wc(i) = wk2(i,i)**2
    enddo
    !
    ! Phase is more complicated ...
  elseif (iy.eq.2) then
    nantm1 = nant-1
    do i=1,nant
      c(i) = 0.0d0
      wc(i) = 0.0d0
    enddo
    !
    ! start iterating
    norm = 1e10
    iter = 0
    do while (norm.gt.tol .and. iter.lt.100)
      iter = iter + 1
      do i=1,nantm1
        do l=1,nantm1
          wk2(l,i) = 0.0d0
        enddo
        wk3(i) = 0.0d0
      enddo
      do ib=1,nbas
        wi = w(ib)
        if (wi.gt.0) then
          ia = zant(iant(ib),iref)
          ja = zant(jant(ib),iref)
          if (ia.ne.0) then
            wk2(ia,ia) = wk2(ia,ia)+wi
          endif
          if (ja.ne.0) then
            wk2(ja,ja) = wk2(ja,ja)+wi
          endif
          if (ia.ne.0 .and. ja.ne.0) then
            wk2(ja,ia) = wk2(ja,ia)-wi
            wk2(ia,ja) = wk2(ia,ja)-wi
          endif
        endif
      enddo
      do ib=1, nbas
        if (w(ib).gt.0) then
          yi = y(ib)
          ia = iant(ib)
          ja = jant(ib)
          yi = yi+(c(ia)-c(ja))
        else
          yi = 0
        endif
        yi = sin(yi)
        ia = zant(iant(ib),iref)
        ja = zant(jant(ib),iref)
        wi = w(ib)*yi
        if (ia.ne.0) then
          wk3(ia) = wk3(ia) - wi
        endif
        if (ja.ne.0) then
          wk3(ja) = wk3(ja) + wi
        endif
      enddo
      !
      ! Solve the system of normal equations by first computing the Cholesky
      ! factorization
      call mth_dpotrf('GAIN_ANT','U',nantm1,wk2,nant,error)
      if (error) return
      call mth_dpotrs ('GAIN_ANT','U',nantm1,1,wk2,nant,   &
     &        wk3,nantm1,ier)
      if (ier.ne.0) return
      !  Add the result to c:
      norm = 0
      do ia=1,nant
        i = zant(ia,iref)
        if (i.ne.0) then
          ww = wk3(i)
          c(ia) = c(ia)+ww
          wc(ia) = wk2(i,i)**2
          norm = norm+ww**2
        endif
      enddo
    enddo
  endif
  !
end subroutine gain_ant
!
function zant(i,r)
  !
  ! Return the apparent number of Antenna #i when reference
  ! antenna is #r. Since #r is not in the list of antennas for
  ! which a solution is to be searched, this number
  ! is #i for #i < #r, and #i-1 for #i > #r
  !
  integer :: zant                   ! intent(out)
  integer, intent(in) :: i          !
  integer, intent(in) :: r          !
  if (i.eq.r) then
    zant = 0
  elseif (i.gt.r) then
    zant = i-1
  else
    zant = i
  endif
  return
end function zant
!*
!=========================================================================
! Linear Algebra: use LAPACK routines
!
subroutine mth_dpotrf (name, uplo, n, a, lda, error)
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: lda                     !
  real(8) :: a(lda,*)                 !
  logical :: error                   !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPOTRF computes the Cholesky factorization of a real symmetric
  !  positive definite matrix A.
  !
  !  The factorization has the form
  !     A = U**T * U,  if UPLO = 'U', or
  !     A = L  * L**T,  if UPLO = 'L',
  !  where U is an upper triangular matrix and L is lower triangular.
  !
  !  This is the block version of the algorithm, calling Level 3 BLAS.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
  !          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
  !          N-by-N upper triangular part of A contains the upper
  !          triangular part of the matrix A, and the strictly lower
  !          triangular part of A is not referenced.  If UPLO = 'L', the
  !          leading N-by-N lower triangular part of A contains the lower
  !          triangular part of the matrix A, and the strictly upper
  !          triangular part of A is not referenced.
  !
  !          On exit, if INFO = 0, the factor U or L from the Cholesky
  !          factorization A = U**T*U or A = L*L**T.
  !
  !  LDA     (input) INTEGER
  !          The leading dimension of the array A.  LDA >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !          > 0:  if INFO = i, the leading minor of order i is not
  !                positive definite, and the factorization could not be
  !                completed.
  !
  ! Call LAPACK routine
  call dpotrf  (uplo, n, a, lda, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrf
!
subroutine mth_dpotrs (name,   &
     &    uplo, n, nrhs, a, lda, b, ldb, info )
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: nrhs                    !
  integer :: lda                     !
  real(8) :: a(lda,*)                 !
  integer :: ldb                     !
  real(8) :: b(ldb,*)                 !
  ! Local
  integer :: info
  logical :: error
  !
  !  Purpose
  !  =======
  !
  !  DPOTRS solves a system of linear equations A*X = B with a symmetric
  !  positive definite matrix A using the Cholesky factorization
  !  A = U**T*U or A = L*L**T computed by DPOTRF.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  NRHS    (input) INTEGER
  !          The number of right hand sides, i.e., the number of columns
  !          of the matrix B.  NRHS >= 0.
  !
  !  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
  !          The triangular factor U or L from the Cholesky factorization
  !          A = U**T*U or A = L*L**T, as computed by DPOTRF.
  !
  !  LDA     (input) INTEGER
  !          The leading dimension of the array A.  LDA >= max(1,N).
  !
  !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
  !          On entry, the right hand side matrix B.
  !          On exit, the solution matrix X.
  !
  !  LDB     (input) INTEGER
  !          The leading dimension of the array B.  LDB >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !
  ! Call LAPACK routine
  call dpotrs  (uplo, n, nrhs, a, lda, b, ldb, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrs
!
subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: ldab                      !
  real(8) :: ab(ldab,*)                 !
  logical :: error                     !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPBTRF computes the Cholesky factorization of a real symmetric
  !  positive definite band matrix A.
  !
  !  The factorization has the form
  !     A = U**T * U,  if UPLO = 'U', or
  !     A = L  * L**T,  if UPLO = 'L',
  !  where U is an upper triangular matrix and L is lower triangular.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  KD      (input) INTEGER
  !          The number of superdiagonals of the matrix A if UPLO = 'U',
  !          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
  !
  !  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
  !          On entry, the upper or lower triangle of the symmetric band
  !          matrix A, stored in the first KD+1 rows of the array.  The
  !          j-th column of A is stored in the j-th column of the array AB
  !          as follows:
  !          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
  !          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
  !
  !          On exit, if INFO = 0, the triangular factor U or L from the
  !          Cholesky factorization A = U**T*U or A = L*L**T of the band
  !          matrix A, in the same storage format as A.
  !
  !  LDAB    (input) INTEGER
  !          The leading dimension of the array AB.  LDAB >= KD+1.
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !          > 0:  if INFO = i, the leading minor of order i is not
  !                positive definite, and the factorization could not be
  !                completed.
  !
  !  Further Details
  !  ===============
  !
  !  The band storage scheme is illustrated by the following example, when
  !  N = 6, KD = 2, and UPLO = 'U':
  !
  !  On entry:                       On exit:
  !
  !      *    *   a13  a24  a35  a46      *    *   u13  u24  u35  u46
  !      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
  !     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
  !
  !  Similarly, if UPLO = 'L' the format of A is as follows:
  !
  !  On entry:                       On exit:
  !
  !     a11  a22  a33  a44  a55  a66     l11  l22  l33  l44  l55  l66
  !     a21  a32  a43  a54  a65   *      l21  l32  l43  l54  l65   *
  !     a31  a42  a53  a64   *    *      l31  l42  l53  l64   *    *
  !
  !  Array elements marked * are not used by the routine.
  !
  ! Call LAPACK routine
  call dpbtrf  (uplo, n, kd, ab, ldab, info )
  call mth_fail(name,'MTH_DPBTRF',info,error)
end subroutine mth_dpbtrf
!
subroutine mth_dpbtrs (name,   &
     &    uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: nrhs                      !
  integer :: ldab                      !
  real(8) :: ab(ldab,*)                 !
  integer :: ldb                       !
  real(8) :: b(ldb,*)                   !
  logical :: error                     !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPBTRS solves a system of linear equations A*X = B with a symmetric
  !  positive definite band matrix A using the Cholesky factorization
  !  A = U**T*U or A = L*L**T computed by DPBTRF.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangular factor stored in AB;
  !          = 'L':  Lower triangular factor stored in AB.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  KD      (input) INTEGER
  !          The number of superdiagonals of the matrix A if UPLO = 'U',
  !          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
  !
  !  NRHS    (input) INTEGER
  !          The number of right hand sides, i.e., the number of columns
  !          of the matrix B.  NRHS >= 0.
  !
  !  AB      (input) DOUBLE PRECISION array, dimension (LDAB,N)
  !          The triangular factor U or L from the Cholesky factorization
  !          A = U**T*U or A = L*L**T of the band matrix A, stored in the
  !          first KD+1 rows of the array.  The j-th column of U or L is
  !          stored in the j-th column of the array AB as follows:
  !          if UPLO ='U', AB(kd+1+i-j,j) = U(i,j) for max(1,j-kd)<=i<=j;
  !          if UPLO ='L', AB(1+i-j,j)    = L(i,j) for j<=i<=min(n,j+kd).
  !
  !  LDAB    (input) INTEGER
  !          The leading dimension of the array AB.  LDAB >= KD+1.
  !
  !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
  !          On entry, the right hand side matrix B.
  !          On exit, the solution matrix X.
  !
  !  LDB     (input) INTEGER
  !          The leading dimension of the array B.  LDB >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !
  ! Call LAPACK routine
  call dpbtrs (uplo, n, kd, nrhs, ab, ldab, b, ldb, info )
  call mth_fail(name,'MTH_DPBTRS',info,error)
end subroutine mth_dpbtrs
! End of Linear Algebra
!
subroutine mth_fail (fac,prog,ifail,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Error handling routine
  !---------------------------------------------------------------------
  character(len=*) :: fac           !
  character(len=*) :: prog          !
  integer :: ifail                  !
  logical :: error                  !
  ! Local
  integer :: l1,l2
  character(len=60) :: chain
  !
  if (ifail.eq.0) then
    error = .false.
  else
    l1=lenc(fac)
    l2=lenc(prog)
    write(chain,'(A,A,A,A,A,I4)')   &
     &      'F-',fac(1:l1),',  ERROR in ',prog(1:l2),', ifail = ',ifail
    call gagout(chain)
    error = .true.
  endif
end subroutine mth_fail
!
subroutine do_plot_gain(ntimes,nantes,uvsol,refant,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! UV_GAIN
  !
  ! Prepare the Solution Table: Amplitude and Phase
  ! corrections per antenna.
  !
  ! Convert the formatted temporary files to a Gildas Table
  !
  !---------------------------------------------------------------------
  integer, intent(in) :: ntimes   ! Number of times
  integer, intent(in) :: nantes   ! Maximum number of antennas
  character(len=*), intent(in) :: uvsol       ! Solution file name
  integer, intent(in) :: refant   ! Reference antenna
  logical, intent(inout) :: error ! Error flag
  !
  character(len=filename_length) :: name
  type(gildas) :: tab
  integer :: iref, nant, ier, i, j
  real(8) :: time, ztime, date, secs
  integer(4) :: jant, kant
  real(4) :: rphase
  ! A few automatic arrays, taken on the stack
  real(4) :: phases(0:nantes) 
  real(4) :: ampsnr(nantes) 
  integer(4) :: al(nantes)  
  ! Larger allocatable arrays (one could use re-allocation instead,
  ! but they are still small anyway)
  integer(4), allocatable :: itmp(:),ialways(:)
  !
  allocate(itmp(ntimes*nantes),ialways(ntimes*nantes),stat=ier)
  if (ier.ne.0) then
   error = .true.
   return
  endif
  !
  call gildas_null(tab)
  !
  name  = uvsol
  call sic_parsef(name,tab%file,' ','.tab')
  call map_message(seve%i,'UV_GAIN','Creating solution table '//trim(tab%file))
  !
  tab%gil%ndim = 2
  tab%gil%dim(1) = ntimes
  tab%gil%dim(2) = 4+2*nantes
  ztime = 0
  phases = 0.
  ampsnr = 0.
  !
  rewind(2)
  !
  ! Find the common antennas
  read(2,*,iostat=ier) iref, time, nant  ! Read the time step
  read(2,*,iostat=ier) al(1:nant)        ! Read the antenna list
  ialways(1:nant) = al(1:nant)
  jant = nant
  read(2,*) phases(1:nant)
  read(2,*) ampsnr(1:nant)
  do i=2,ntimes
    read(2,*,iostat=ier) iref, time, nant  ! Read the time step
    read(2,*,iostat=ier) al(1:nant)        ! Read the antenna list
    call union(ialways,jant,al,nant,itmp,kant)
    jant = kant
    ialways(1:kant) = itmp(1:kant)
    read(2,*) phases(1:nant)
    read(2,*) ampsnr(1:nant)
  enddo
  rewind(2)
  !
  write(*,*) kant,' antennas present:'
  write(*,'(16(1x,I3))') ialways(1:kant)
  !
  ! Normally, here we should use the "absolute" antenna number
  ! and the Table should be of size KANT. To be done...
  !
  allocate(tab%r2d(tab%gil%dim(1),tab%gil%dim(2)), stat=ier)
  !
  tab%r2d = 0
  do i=1,ntimes
    read(2,*,iostat=ier) iref, time, nant  ! Read the time step
    read(2,*,iostat=ier) al(1:nant)        ! Read the antenna list
    if (ztime.eq.0) ztime = time
    time = time-ztime
    secs = mod(time,86400.d0)
    date = (time-secs)/86400.d0 
    tab%r2d(i,1) = secs
    tab%r2d(i,2) = date     
    tab%r2d(i,3) = nant
    tab%r2d(i,4) = iref
    !
    read(2,*) phases(1:nant)
    read(2,*) ampsnr(1:nant)
    rphase = phases(refant)
    do j=1,nant
      tab%r2d(i,3+2*j) = phases(j) - rphase 
      tab%r2d(i,4+2*j) = ampsnr(j) 
    enddo
  enddo
  call gdf_write_image(tab,tab%r2d,error)
  deallocate(tab%r2d)
  close(2)
end subroutine do_plot_gain
!
subroutine overlap(a,n,b,m,c,k)
  !
  ! Find the intersection of ensembles A and B
  !
  integer, intent(in) :: n
  integer, intent(in) :: a(n)
  integer, intent(in) :: m
  integer, intent(in) :: b(m)
  integer, intent(inout) :: k
  integer, intent(inout) ::c(*)
  !
  integer i,j
  !
  k = 0
  do i=1,n
    do j=1,m
      if (a(i).eq.b(j)) then
        k = k+1
        c(k) = a(i)
        exit
      endif
    enddo
  enddo
  !! print *,'Overlap ',n,m,k,' = ',c(1:K)
end subroutine overlap
!
subroutine union(a,n,b,m,c,k)
  !
  ! Find the Union of ensembles A and B
  !
  integer, intent(in) :: n
  integer, intent(in) :: a(n)
  integer, intent(in) :: m
  integer, intent(in) :: b(m)
  integer, intent(inout) :: k
  integer, intent(inout) ::c(*)
  !
  integer i,j
  logical :: found
  !
  k = n
  c(1:k) = a(1:n)
  !
  do j=1,m
    found = .false.
    do i=1,n
      if (c(i).eq.b(j)) then
        found = .true.
        exit
      endif
    enddo
    if (.not.found) then
      k = k+1
      c(k) = b(j)
    endif
  enddo
end subroutine union

subroutine class_uvt(set,line,r,error,user_function)
  use gildas_def
  use image_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_uvt
  use class_types
  !----------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS Support routine for command
  !  UV_ZERO Name [/VERBOSE]
  ! Create a Zero Spacing UV Table from the current R spectrum
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  type(observation),   intent(in)    :: r              !
  logical,             intent(inout) :: error          ! Logical flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='UV_ZERO'
  character(len=filename_length) :: chain
  integer(kind=4) :: i,j,ier,nc
  integer(kind=4) :: chfirs, chlast, ltypem
  type(gildas) :: tab
  real(kind=4), allocatable :: dtab(:)
  real(kind=4) :: xoff,yoff,weight
  type(indx_t) :: ind
  integer(kind=4), parameter :: optverb=1  ! /VERBOSE
  integer(kind=4), parameter :: optnew=2  ! /NEW
  !
  if (sic_present(optnew,0)) then
    call class_uvzero_new(set,line,error,user_function)
    return
  endif
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  !
  call sic_ch (line,0,1,chain,nc,.true.,error)
  if (error) return
  call gildas_null(tab, type = 'UVT')
  !
  call sic_parse_file(chain,' ','.uvt',tab%file)
  !
  ! Feedback
  if (sic_present(optverb,0)) then
    call class_message(seve%i,rname,  &
      'Creating UV table '//trim(tab%file)//' from spectrum:')
    !
    call index_fromobs(r%head,ind,error)
    if (error)  return
    call out0('Terminal',0.,0.,error)
    if (error)  return
    call class_list_default(set,ind)
  endif
  !
  chfirs = r%cimin   ! 1
  chlast = r%cimax   ! r%cnchan
  !
  ! Prepare header
  tab%gil%ndim   = 2
  !
  tab%gil%dim(1) = 7+3*(chlast-chfirs+1)
  tab%gil%dim(2) = 1
  !
  tab%gil%ref(1) = r%head%spe%rchan-chfirs+1.d0
  tab%gil%val(1) = r%head%spe%restf ! Sky frequency
  tab%gil%inc(1) = r%head%spe%fres  ! Frequency resolution ...
  !
  tab%gil%ref(2) = 0.d0
  tab%gil%val(2) = 0.d0
  tab%gil%inc(2) = 1.d0
  !
  ! Projection information
  ltypem = r%head%pos%system
  if (ltypem.eq.type_eq) then
    tab%gil%epoc = r%head%pos%equinox
    tab%gil%ra = r%head%pos%lam
    tab%gil%dec = r%head%pos%bet
    call equ_to_gal(tab%gil%ra,tab%gil%dec,0.0,0.0,tab%gil%epoc,   &
                    tab%gil%lii,tab%gil%bii,xoff,yoff,error)
    if (error)  return
    tab%gil%a0 = tab%gil%ra
    tab%gil%d0 = tab%gil%dec
    tab%char%syst = 'EQUATORIAL'
    tab%gil%xaxi = 2
    tab%gil%yaxi = 3
  elseif (ltypem.eq.type_ga) then
    tab%gil%epoc = set%equinox
    tab%gil%lii = r%head%pos%lam
    tab%gil%bii = r%head%pos%bet
    call gal_to_equ(tab%gil%lii,tab%gil%bii,0.0,0.0,   &
                    tab%gil%ra,tab%gil%dec,xoff,yoff,tab%gil%epoc,error)
    if (error)  return
    tab%gil%a0 = tab%gil%lii
    tab%gil%d0 = tab%gil%bii
    tab%char%syst = 'GALACTIC'
    tab%gil%xaxi = 2
    tab%gil%yaxi = 3
  elseif (ltypem.eq.type_ic) then
    tab%gil%epoc = equinox_null
    tab%gil%ra = r%head%pos%lam
    tab%gil%dec = r%head%pos%bet
    tab%gil%lii = 0.d0
    tab%gil%bii = 0.d0
    tab%gil%a0 = tab%gil%ra
    tab%gil%d0 = tab%gil%dec
    tab%char%syst = 'ICRS'
    tab%gil%xaxi = 2
    tab%gil%yaxi = 3
  endif
  tab%gil%bval = r%head%spe%bad
  tab%gil%eval = -1.0
  !
  tab%char%name = r%head%pos%sourc
  !
  ! Projection
  tab%gil%ptyp = r%head%pos%proj
  tab%gil%pang = r%head%pos%projang
  tab%gil%xaxi = 2
  tab%gil%yaxi = 3
  !
  ! Spectroscopy
  tab%char%line = r%head%spe%line
  tab%gil%freq  = r%head%spe%restf
  tab%gil%voff  = r%head%spe%voff
  tab%gil%vres  = r%head%spe%vres
  tab%gil%fima  = r%head%spe%image
  tab%gil%fres  = r%head%spe%fres
  tab%gil%faxi  = 1
  !
  ! Here define the order of the basic "columns".
  ! No "extra" ones
  tab%gil%column_size = 0
  tab%gil%column_pointer(code_uvt_u) = 1
  tab%gil%column_pointer(code_uvt_v) = 2
  tab%gil%column_pointer(code_uvt_w) = 3
  tab%gil%column_pointer(code_uvt_date) = 4
  tab%gil%column_pointer(code_uvt_time) = 5
  tab%gil%column_pointer(code_uvt_anti) = 6
  tab%gil%column_pointer(code_uvt_antj) = 7
  do i=1,code_uvt_last
    if (tab%gil%column_pointer(i).ne.0) tab%gil%column_size(i) = 1
  enddo
  !
  ! Finalize the UV Table header
  tab%gil%natom = 3
  tab%gil%nstokes = 1
  tab%gil%nvisi = 1
  tab%gil%nchan = (chlast-chfirs+1)
  tab%gil%type_gdf = code_gdf_uvt
  call gdf_setuv (tab,error)
  if (error) return
  !
  ! call gdf_print_header(tab)
  ! Prepare data
  !
  allocate(dtab(tab%gil%dim(1)),stat=ier)
  if (failed_allocate(rname,'dtab',ier,error))  return
  tab%loca%size = tab%gil%dim(1)*tab%gil%dim(2)
  dtab(:) = 0.
  !
  select case (set%weigh)
  case ('S')
    call obs_weight_sigma(rname,r,weight,error)
  case ('T')
    call obs_weight_time(rname,r,weight,error)
  case ('E')
    weight = 1.
  case default
    call class_message(seve%e,rname,'SET WEIGHT '//set%weigh//' is not supported')
    error = .true.
  end select
  if (error)  return
  !
  j = 0
  do i=chfirs,chlast
    dtab(8+j) = r%spectre(i)
    if (r%spectre(i).eq.r%head%spe%bad) then
      dtab(10+j) = 0.
    else
      dtab(10+j) = weight
    endif
    j = j+3
  enddo
  call gdf_write_image(tab,dtab,error)
  if (error) then
    call class_message(seve%f,rname,'Cannot create output table')
  endif
  deallocate(dtab)
  !
end subroutine class_uvt
!
subroutine class_uvzero_new(set,line,error,user_function)
  use phys_const
  use image_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_uvzero_new
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   UV_ZERO file.uvt /NEW
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  character(len=*),    intent(in)    :: line
  logical,             intent(inout) :: error
  logical,             external      :: user_function
  ! Local
  type(gildas) :: inuvhead,ouhead
  real(kind=4), allocatable :: oudata(:,:)
  real(kind=4), allocatable :: uvoffxy(:,:),cxoffxy(:,:)
  integer(kind=4) :: ixycol(2)
  integer(kind=4) :: noff,nc
  integer(kind=4), parameter :: optnocheck=3
  integer(kind=4), parameter :: optlike=4
  character(len=filename_length) :: infile,oufile
  character(len=message_length) :: mess
  logical :: dolike
  type(resampling) :: faxis
  character(len=*), parameter :: rname='UV_ZERO'
  !
  call sic_ch(line,0,1,infile,nc,.true.,error)
  if (error) return
  dolike = sic_present(optlike,0)
  if (dolike) then
    call resample_parse_like(rname,line,optlike,faxis,error)
    if (error)  return
  endif
  !
  call uvzero_consistency(set,line,cx,error,user_function)
  if (error) return
  call read_uvhead(infile,inuvhead,error)
  if (error) return
  call read_offsets(inuvhead,ixycol,noff,uvoffxy,error)
  if (error)  return
  call reproject_offsets(cx%cons%head,inuvhead,noff,uvoffxy,cxoffxy,error)
  if (error) return
  call prepare_uvtable(noff,oufile,inuvhead,ouhead,oudata,error)
  if (error) return
  call get_and_fill_uvdata(set,cx,ixycol,noff,uvoffxy,cxoffxy,dolike,faxis,  &
    ouhead,oudata,error,user_function)
  if (error) return
  call write_uvtable(ouhead,oudata,error)
  if (error) return
  !
contains
  subroutine uvzero_consistency(set,line,idx,error,user_function)
    use class_types
    type(class_setup_t), intent(in)    :: set
    character(len=*),    intent(in)    :: line
    type(optimize),      intent(inout) :: idx
    logical,             intent(inout) :: error
    logical,             external      :: user_function
    !
    call consistency_check_selection(set,line,optnocheck,idx%cons,error)
    if (error) return
    idx%cons%off%check = .false. ! We assume the data represent some kind of mapping of the source
    call consistency_check_do(set,rname,idx,error,user_function)
    if (error) return
    if (idx%cons%prob)  error = .true.
  end subroutine uvzero_consistency
  !
  subroutine read_uvhead(name,uvhead,error)
    use image_def
    character(len=*), intent(in)    :: name
    type(gildas),     intent(out)   :: uvhead
    logical,          intent(inout) :: error
    !
    call gildas_null(uvhead,type='UVT')
    uvhead%file = trim(name)
    call gdf_read_header(uvhead,error)
    if (error) return
    call class_message(seve%i,rname,'Input UV Table is '//trim(uvhead%file))
  end subroutine read_uvhead
  !
  subroutine read_offsets(huv,ixycol,noff,offxy,error)
    use image_def
    type(gildas),     intent(inout)            :: huv
    integer(kind=4),  intent(out)              :: ixycol(2)
    integer(kind=4),  intent(out)              :: noff
    real(kind=4),     intent(out), allocatable :: offxy(:,:)
    logical,          intent(inout)            :: error
    ! Local
    integer(kind=4), parameter :: code_uvzero_single=0 ! Single field UV table
    integer(kind=4), parameter :: code_uvzero_phase=1  ! Mosaic UV table with phase offsets
    integer(kind=4), parameter :: code_uvzero_point=2  ! Mosaic UV table with pointing offsets
    real(kind=4), allocatable :: duv(:,:)
    integer(kind=4) :: np,nv,loff,moff,xoff,yoff,uvmode,ier
    !
    loff = huv%gil%column_pointer(code_uvt_loff)
    moff = huv%gil%column_pointer(code_uvt_moff)
    xoff = huv%gil%column_pointer(code_uvt_xoff)
    yoff = huv%gil%column_pointer(code_uvt_yoff)
    !
    ! Allocate and fill offxy
    if ((loff.ne.0).or.(moff.ne.0)) then
       write(mess,'(A,I0,A,I0)') 'Phase offset columns at loff: ',loff,', moff: ',moff
       call class_message(seve%i,rname,mess)
       if (moff.ne.loff+1) then
          call class_message(seve%e,rname,'moff should be equal to loff+1')
          error = .true.
          return
       endif
       ixycol(1:2) = [loff,moff]
       uvmode = code_uvzero_phase
    elseif ((xoff.ne.0).or.(yoff.ne.0)) then
       write(mess,'(A,I0,A,I0)') 'Pointing offset columns at xoff: ',xoff,', yoff: ',yoff
       call class_message(seve%i,rname,mess)
       if (yoff.ne.xoff+1) then
          call class_message(seve%e,rname,'yoff should be equal to xoff+1')
          error = .true.
          return
       endif
       ixycol(1:2) = [xoff,yoff]
       uvmode = code_uvzero_point
    else
       call class_message(seve%i,rname,'Single field uv table')
       uvmode = code_uvzero_single
    endif
    !
    if ((uvmode.eq.code_uvzero_phase).or.(uvmode.eq.code_uvzero_point)) then
       np = 2
       nv = huv%gil%dim(2)
       huv%blc(1:2) = [ixycol(1),0]
       huv%trc(1:2) = [ixycol(2),0]
       allocate (duv(np,nv),stat=ier)
       if (failed_allocate(rname,'Mosaic offsets',ier,error)) return
       call gdf_read_data(huv,duv,error)
       if (error) return
       call mosaic_getfields(duv,np,nv,1,2,noff,offxy)
       deallocate(duv)
    else if (uvmode.eq.code_uvzero_single) then
       noff = 1
       allocate (offxy(2,1),stat=ier)
       if (failed_allocate(rname,'Single field offsets',ier,error)) return
       offxy = 0.0
    endif
  end subroutine read_offsets
  !
  subroutine reproject_offsets(idxref,uvhead,noff,uvoffxy,idxoffxy,error)
    use phys_const
    use image_def
    use gkernel_types
    use classcore_dependencies_interfaces
    use class_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(header),              intent(in)    :: idxref
    type(gildas),              intent(in)    :: uvhead
    integer(kind=4),           intent(in)    :: noff
    real(kind=4),              intent(in)    :: uvoffxy(:,:)
    real(kind=4), allocatable, intent(out)   :: idxoffxy(:,:)
    logical,                   intent(inout) :: error
    !
    type(projection_t) :: uvproj,idxproj
    integer(kind=4) :: ioff,ier
    real(kind=8) :: rxoff,ryoff
    real(kind=8) :: axoff,ayoff
    !
    ! Setup projections
    call gwcs_projec(&
         uvhead%gil%a0,uvhead%gil%d0,&
         uvhead%gil%pang,uvhead%gil%ptyp,&
         uvproj,error)
    if (error)  return
    call gwcs_projec(&
         idxref%pos%lam,idxref%pos%bet,&
         idxref%pos%projang,idxref%pos%proj,&
         idxproj,error)
    if (error) return
    allocate(idxoffxy(2,noff),stat=ier)
    if (failed_allocate(rname,'Mosaic offsets in class index projection',ier,error))  return
    do ioff=1,noff
       rxoff = uvoffxy(1,ioff)
       ryoff = uvoffxy(2,ioff)
       call rel_to_abs(uvproj,rxoff,ryoff,axoff,ayoff,1)
       call abs_to_rel(idxproj,axoff,ayoff,rxoff,ryoff,1)
       idxoffxy(1,ioff) = rxoff 
       idxoffxy(2,ioff) = ryoff
       write(mess,'(A,I4,2(A,f9.2,A,f9.2,A))') &
            'Field #',ioff,&
            ', uv: (',uvoffxy(1,ioff)*sec_per_rad,',',uvoffxy(2,ioff)*sec_per_rad,')',&
            ', cx: (',idxoffxy(1,ioff)*sec_per_rad,',',idxoffxy(2,ioff)*sec_per_rad,')'
       call class_message(seve%r,rname,mess)
    enddo ! ioff
  end subroutine reproject_offsets
  !
  subroutine prepare_uvtable(nvisi,oufile,inuvhead,ouhead,oudata,error)
    use image_def
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    integer(kind=4),           intent(in)    :: nvisi
    character(len=*),          intent(in)    :: oufile
    type(gildas),              intent(in)    :: inuvhead
    type(gildas),              intent(out)   :: ouhead
    real(kind=4), allocatable, intent(inout) :: oudata(:,:)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=filename_length) :: oext,odir
    !
    call gildas_null(ouhead,type='UVT')
    call gdf_copy_header(inuvhead,ouhead,error)
    if (error) return
    call sic_parse_name(inuvhead%file,ouhead%file,oext,odir)
    ouhead%file = trim(odir)//trim(ouhead%file)//'-uvzero.'//trim(oext)
    ouhead%gil%nvisi = nvisi
    ouhead%gil%dim(2) = nvisi
    ouhead%loca%size = ouhead%gil%dim(1)*ouhead%gil%dim(2)
    ! Sanity checks
    if (ouhead%gil%natom.ne.3) then
       call class_message(seve%e,rname,'Do not know how to handle a uv table order different from (real,imag,weight)')
       error = .true.
       return
    endif
    if (ouhead%gil%nstokes.ne.1) then
       call class_message(seve%e,rname,'Do not know how to handle a uv table with more than one stokes parameter')
       error = .true.
       return
    endif
    if (ouhead%gil%column_pointer(code_uvt_scan).ne.3) then
       call class_message(seve%e,rname,'Changing uv table 3rd column to scan number')
       ouhead%gil%column_pointer(code_uvt_scan) = 3
    endif
    call gdf_setuv(ouhead,error)
    if (error) return
    allocate(oudata(ouhead%gil%dim(1),ouhead%gil%dim(2)),stat=ier)
    if (failed_allocate(rname,'uvzero table',ier,error)) return
  end subroutine prepare_uvtable
  !
  subroutine get_and_fill_uvdata(set,idx,ixycol,noff,uvoffxy,idxoffxy,  &
    dolike,faxis,ouhead,oudata,error,user_function)
    use class_parameter
    use class_index
    !---------------------------------------------------------------------
    ! On purpose, there is no protection against duplicate found. The user
    ! needs to know what it does.
    !---------------------------------------------------------------------
    type(class_setup_t), intent(in)    :: set
    type(optimize),      intent(in)    :: idx
    integer(kind=4),     intent(in)    :: ixycol(2)
    integer(kind=4),     intent(in)    :: noff
    real(kind=4),        intent(in)    :: uvoffxy(2,noff)
    real(kind=4),        intent(in)    :: idxoffxy(2,noff)
    logical,             intent(in)    :: dolike
    type(resampling),    intent(in)    :: faxis
    type(gildas),        intent(in)    :: ouhead
    real(kind=4),        intent(inout) :: oudata(:,:)
    logical,             intent(inout) :: error
    logical,             external      :: user_function
    ! Local
    type(optimize) :: mycx
    type(observation) :: obs
    logical, parameter :: output_scaling = .true.
    logical, parameter :: dofft = .false.
    logical :: myerror = .false.
    integer(kind=entry_length) :: nfound
    integer(kind=4) :: ioff,gagdate
    !
    ! Loop on all offsets
    write(mess,'(I4,A)') noff,' fields in UV table'
    call class_message(seve%r,rname,mess)
    ! Initialize 'class_list_defbrieflong' output to terminal
    call out0('Terminal',0.,0.,error)
    if (error)  return
    ! Initialize gagdate, local obs and index
    call sic_gagdate(gagdate)
    call init_obs(obs)
    do ioff=1,noff
      ! Tune the searching flags used by subroutine FIX. NB: the other flags
      ! have been reset at the end of previous call to FIX.
      flg%off1 = .true.  ! Enable search by X offset
      smin%off1 = idxoffxy(1,ioff) - set%tole
      smax%off1 = idxoffxy(1,ioff) + set%tole
      flg%off2 = .true.  ! Enable search by Y offset
      smin%off2 = idxoffxy(2,ioff) - set%tole
      smax%off2 = idxoffxy(2,ioff) + set%tole
      ! Find from given IDX
      mycx%next = 1
      call fix(set,idx,mycx,nfound,error)
      if (error)  exit
      write(mess,'(A,I4,A,I4,A,f9.2,f9.2)')  &
        'Field #',ioff,', averaging ',nfound,' entries around ',  &
        idxoffxy(1,ioff)/rad_per_sec,idxoffxy(2,ioff)/rad_per_sec
      if (nfound.eq.0) then
         call class_message(seve%e,rname,mess)
         error = .true.
         exit
      else
         call class_message(seve%r,rname,mess)
      endif
      call class_list_defbrieflong(set,mycx,rix,0,error) ! *** JP Should be only in verbose mode
      if (error) exit
      ! Read closest spectrum
      ! *** JP Right now only first one
      call get_it(set,obs,mycx%ind(1),user_function,error)
      if (error) exit
!      call modify_scale(obs,yunit_Jyperbeam,output_scaling,error)
!      if (error) exit
      if (dolike) then
         call do_resample(set,obs,faxis,dofft,error)
         if (error)  exit
      endif
      call obs2uvline(set,obs,gagdate,ouhead,ixycol,uvoffxy(:,ioff),oudata(:,ioff),error)
      if (error) exit
    enddo ! ioff
    ! Cleanup
    call free_obs(obs)
    call deallocate_optimize(mycx,myerror)
    if (myerror) error = myerror
  end subroutine get_and_fill_uvdata
  !
  subroutine obs2uvline(set,obs,gagdate,uvhead,ixycol,uvoffxy,uvline,error)
    type(class_setup_t), intent(in)    :: set
    type(observation),   intent(in)    :: obs
    integer(kind=4),     intent(in)    :: gagdate
    integer(kind=4),     intent(in)    :: ixycol(2)
    type(gildas),        intent(in)    :: uvhead
    real(kind=4),        intent(in)    :: uvoffxy(2)
    real(kind=4),        intent(inout) :: uvline(:)
    logical,             intent(inout) :: error
    !
    real(kind=4) :: weight
    integer(kind=4) :: ichan,icol,iu,iv,iscan,idate,itime,ianti,iantj
    integer(kind=4), parameter :: code_sd_iant = -1
    !
    if (obs%head%spe%nchan.ne.uvhead%gil%nchan) then
       write(mess,'(A,I0,A,I0,A)')  &
            'Different number of channels (uvt: ',uvhead%gil%nchan,', obs: ',obs%head%spe%nchan,')'
       call class_message(seve%e,rname,mess)
       call class_message(seve%e,rname,'Use the /LIKE option')
       error = .true.
       return
    endif
    select case (set%weigh)
    case ('S')
       call obs_weight_sigma(rname,obs,weight,error)
       if (error) return
    case ('T')
       call obs_weight_time(rname,obs,weight,error)
       if (error) return
    case ('E')
       weight = 1.
    case default
       call class_message(seve%e,rname,'SET WEIGHT '//set%weigh//' is not supported')
       error = .true.
       if (error)  return
    end select
    iu    = uvhead%gil%column_pointer(code_uvt_u)
    iv    = uvhead%gil%column_pointer(code_uvt_v)
    iscan = uvhead%gil%column_pointer(code_uvt_scan)
    idate = uvhead%gil%column_pointer(code_uvt_date)
    itime = uvhead%gil%column_pointer(code_uvt_time)
    ianti = uvhead%gil%column_pointer(code_uvt_anti)
    iantj = uvhead%gil%column_pointer(code_uvt_antj)
    ianti = uvhead%gil%column_pointer(code_uvt_anti)
    iantj = uvhead%gil%column_pointer(code_uvt_antj)
    uvline(iu) = 0.0
    uvline(iv) = 0.0
    uvline(iscan) = real(obs%head%gen%scan)
    uvline(idate) = gagdate
    uvline(itime) = 0.0 ! 00:00 UT
    uvline(ianti) = code_sd_iant
    uvline(iantj) = code_sd_iant
    if (ixycol(1).ne.0) uvline(ixycol(1)) = uvoffxy(1)
    if (ixycol(2).ne.0) uvline(ixycol(2)) = uvoffxy(2)
    icol = 0
    do ichan=1,obs%head%spe%nchan
       if (obs%spectre(ichan).ne.obs%head%spe%bad) then
          uvline(8+icol) = obs%spectre(ichan) ! Real
          uvline(9+icol) = 0.0                ! Imag
          uvline(10+icol) = weight            ! Weight
       else
          uvline(8+icol) = uvhead%gil%bval ! Real
          uvline(9+icol) = uvhead%gil%bval ! Imag
          uvline(10+icol) = 0.             ! Imag
       endif
       icol = icol+3
    enddo
  end subroutine obs2uvline
  !
  subroutine write_uvtable(ouhead,oudata,error)
    type(gildas), intent(inout) :: ouhead
    real(kind=4), intent(inout) :: oudata(:,:)
    logical,      intent(inout) :: error
    !
    call gdf_write_image(ouhead,oudata,error)
    if (error) then
       call class_message(seve%e,rname,'Error writing '//trim(ouhead%file)//' table')
       return
    endif
    write(mess,'(I0,A)') ouhead%gil%nvisi,' visibilities written'
    call class_message(seve%i,rname,mess)
    call gdf_print_header(ouhead) ! *** JP should be called in verbose mode only
  end subroutine write_uvtable
end subroutine class_uvzero_new
!
subroutine mosaic_getfields(visi,np,nv,ixoff,iyoff,nf,doff)
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>mosaic_getfields
  !----------------------------------------------------------------------
  ! @ private
  !  Count number of fields and get their coordinates
  !----------------------------------------------------------------------
  integer(kind=4), intent(in)    :: np                    ! Size of a visibility
  integer(kind=4), intent(in)    :: nv                    ! Number of visibilities
  real(kind=4),    intent(in)    :: visi(np,nv)           ! Input visibilities
  integer(kind=4), intent(in)    :: ixoff                 ! X pointer
  integer(kind=4), intent(in)    :: iyoff                 ! Y pointer
  integer(kind=4), intent(out)   :: nf                    ! Number of fields
  real(kind=4),    intent(out), allocatable :: doff(:,:)  ! Field offsets
  ! Local
  type(eclass_2dble_t) :: eclass
  integer(kind=4) :: ier
  logical :: error
  !
  ! ZZZ Single precision floats should be enough, but gmath does not
  !     (yet) provide the corresponding type. Work with double instead.
  !
  error = .false.
  nf = 0
  !
  call reallocate_eclass_2dble(eclass,nv,error)
  if (error)  return
  !
  eclass%val1(1:nv) = visi(ixoff,1:nv)
  eclass%val2(1:nv) = visi(iyoff,1:nv)
  eclass%cnt(1:nv) = 1
  !
  call eclass_2dble(mosaic_getfields_offset_eq,eclass)
  !
  nf = eclass%nequ
  allocate(doff(2,nf),stat=ier)
  if (.not.failed_allocate('UV_ZERO','offsets array',ier,error)) then
    doff(1,1:eclass%nequ) = eclass%val1(1:nf)
    doff(2,1:eclass%nequ) = eclass%val2(1:nf)
  endif
  !
  call free_eclass_2dble(eclass,error)
  !
end subroutine mosaic_getfields
!
function mosaic_getfields_offset_eq(x1,x2,y1,y2)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  ! Equality routine between two pairs of offset (real*8) with a
  ! tolerance.
  ! ---
  ! This subroutine should be kept in 'mosaic_getfields' under a
  ! contains statement, but gfortran 4.4 is not able to compile this...
  !---------------------------------------------------------------------
  logical :: mosaic_getfields_offset_eq
  real(kind=8), intent(in) :: x1,x2  ! [rad]
  real(kind=8), intent(in) :: y1,y2  ! [rad]
  ! Local
  real(kind=8), parameter :: tol=1.d-2*rad_per_sec  ! 0.01 sec is enough
  !
  mosaic_getfields_offset_eq = abs(x1-x2).le.tol .and. abs(y1-y2).le.tol
  !
end function mosaic_getfields_offset_eq
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubetools_header_vo
  use cubetools_parameters
  use cubetools_header_interface
  use cubetools_header_types

  type :: vo_spatial_t
    ! See specifications in "Observation Data Model Core Components and its
    ! Implementation in the Table Access Protocol" -- IVOA Proposed
    ! Recommendation, March 30, 2016
    ! Mandatory components
    real(kind=coor_k)  :: ra      ! [deg] Central right ascension, ICRS (i.e. center of region)
    real(kind=coor_k)  :: dec     ! [deg] Central declination, ICRS (i.e. center of region)
    real(kind=coor_k)  :: fov     ! [deg] Diameter (bounds) of the covered region
    character(len=128) :: region  ! [AstroCoordArea] Region covered as specified in STC or ADQL
    real(kind=coor_k)  :: reso    ! [arcsec] Spatial resolution of data as FWHM
    integer(kind=4)    :: xel1    ! [---]  Number of elements along the first spatial axis
    integer(kind=4)    :: xel2    ! [---]  Number of elements along the second spatial axis
    ! Optional components
    logical            :: dopscale=.false.  ! Is pscale available?
    real(kind=coor_k)  :: pscale  ! [arcsec] Sampling period in world coordinate units along the spatial axis
  contains
    procedure :: from_cube    => vo_spatial_from_cube
    procedure :: from_uvtable => vo_spatial_from_uvtable
  end type vo_spatial_t

  interface json_keyval_write
    module procedure json_keyval_write_i4
    module procedure json_keyval_write_i8
    module procedure json_keyval_write_r8
    module procedure json_keyval_write_ch
  end interface json_keyval_write

  interface cubetools_header_vo_list
    module procedure cubetools_header_vo_list_interface
    module procedure cubetools_header_vo_list_header
  end interface cubetools_header_vo_list

  integer(kind=code_k), parameter :: vo_version=1

  public :: cubetools_header_vodesc_list,cubetools_header_vo_list
  private

contains

  subroutine cubetools_header_vodesc_list(error)
    !-------------------------------------------------------------------
    ! Display the VO format description
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call json_main_write_start()
    !
    call json_dict_write_start('description')
    call json_keyval_write('VERSION',vo_version)
    call json_vo_description('software_version',.false.,"string")
    call json_vo_description('dataproduct_type',.true.,"string")
    call json_vo_description('dataproduct_subtype',.false.,"string")
    call json_vo_description('calib_level',.true.,"enum integer")
    call json_vo_description('access_format',.true.,"string")
    call json_vo_description('access_estsize',.true.,"integer",unit='kB')
    call json_vo_description('target_name',.true.,"string")
    call json_vo_description('s_ra',.true.,"float",unit="degree")
    call json_vo_description('s_dec',.true.,"float",unit="degree")
    call json_vo_description('s_fov',.true.,"float",unit="degree")
    call json_vo_description('s_region',.true.,"string")
    call json_vo_description('s_xel1',.true.,"integer")
    call json_vo_description('s_xel2',.true.,"integer")
    call json_vo_description('s_resolution',.true.,"float",unit="arcsec")
    call json_vo_description('s_pixel_scale',.true.,"float",unit="arcsec")
    call json_vo_description('em_ucd',.false.,"string")
    call json_vo_description('em_min',.true.,"float",unit="m")
    call json_vo_description('em_max',.true.,"float",unit="m")
    call json_vo_description('em_res_power',.true.,"float")
    call json_vo_description('em_xel',.true.,"integer")
    call json_vo_description('pol_states',.true.,"string")
    call json_vo_description('facility_name',.true.,"string",last=.true.)
    call json_dict_write_stop(last=.true.)
    !
    call json_main_write_stop()
    !
  end subroutine cubetools_header_vodesc_list

  subroutine cubetools_header_vo_list_interface(interf,error)
    !-------------------------------------------------------------------
    ! Display the interface_t under VO format
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(in)    :: interf
    logical,                       intent(inout) :: error
    !
    type(cube_header_t) :: head
    !
    call head%init(error)
    if (error)  return
    call cubetools_header_import_and_derive(interf,head,error)
    if (error)  return
    call cubetools_header_vo_list_header(head,error)
    if (error)  return
    call cubetools_header_final(head,error)
    if (error)  return
  end subroutine cubetools_header_vo_list_interface

  subroutine cubetools_header_vo_list_header(head,error)
    use phys_const
    use gkernel_interfaces
    use cubetools_parameters
    !-------------------------------------------------------------------
    ! Display the header_t under VO format
    !-------------------------------------------------------------------
    type(cube_header_t), intent(in)    :: head
    logical,             intent(inout) :: error
    !
    integer(kind=data_k) :: datasize
    real(kind=coor_k) :: ffirst,flast,fmin,fmax,wpower,wmin,wmax
    character(len=128) :: version
    character(len=32) :: format,type
    integer(kind=4) :: ier,level
    integer(kind=ndim_k) :: uv_axis,iaxis,nchan,nx,ny,nc
    type(vo_spatial_t) :: vospa
    !
    version = ''
    ier = sic_getlog('GAG_VERSION',version)
    ier = index(version,' ')
    version = version(1:ier)
    !
    !
    ! Detect if UV table. This is a poor man solution. The DAG knows
    ! if a node is a UV table or a cube.
    datasize = 1
    uv_axis = 0
    do iaxis=1,head%set%n
      datasize = max(datasize*head%set%axis(iaxis)%n,1)
      if (head%set%axis(iaxis)%name.eq.'UV-RAW')   uv_axis = uv_axis+1  ! Support for old tables
      if (head%set%axis(iaxis)%name.eq.'UV-DATA')  uv_axis = uv_axis+1
      if (head%set%axis(iaxis)%name.eq.'RANDOM')   uv_axis = uv_axis+1
    enddo
    datasize = datasize/256  ! [kB] ndata*4/1024
    if (uv_axis.eq.2) then
      ! A UV table
      type = 'visibility'
      format = 'application/x-mapping-uvt'
      level = 2
      call vospa%from_uvtable(head%spa,error)
      if (error)  return
      nchan = (head%spe%nc-7)/3
    else
      ! A standard cube
      nx = 0
      ny = 0
      nc = 0
      if (head%set%il.ne.0)  nx = head%set%axis(head%set%il)%n
      if (head%set%im.ne.0)  ny = head%set%axis(head%set%im)%n
      if (head%set%ic.ne.0)  nc = head%set%axis(head%set%ic)%n
      if (nx.gt.1 .and. ny.gt.1 .and. nc.le.1) then
        type = 'image'
      elseif (nx.le.1 .and. ny.le.1 .and. nc.gt.1) then
        type = 'spectrum'
      else  ! Everything else (?)
        type = 'cube'
      endif
      format = 'image/fits'
      level = 3
      call vospa%from_cube(head%spa,error)
      if (error)  return
      nchan = head%spe%nc
    endif
    !
    ! ZZZ THIS IS WRONG (or approximate by chance) FOR UV TABLES
    ffirst = head%spe%f%coord(1)      ! [MHz]
    flast  = head%spe%f%coord(nchan)  ! [MHz]
    fmin = min(ffirst,flast)
    fmax = max(ffirst,flast)
    wmin = clight_mhz/fmin  ! [m]
    wmax = clight_mhz/fmax  ! [m]
    wpower = abs(head%spe%f%val/head%spe%f%inc)
    !
    call json_main_write_start()
    !
    call json_dict_write_start('values')
    call json_keyval_write('VERSION',vo_version)
    call json_keyval_write('software_version',version)
    ! General description
    call json_keyval_write('dataproduct_type',type)
   !call json_keyval_write('dataproduct_subtype','NULL')  ! Optional
    call json_keyval_write('calib_level',level)
    call json_keyval_write('access_format',format)  ! i.e. MIME type
    call json_keyval_write('access_estsize',datasize)
    ! Spatial description
    call json_keyval_write('target_name',head%spa%source)
    call json_keyval_write('s_ra',vospa%ra)
    call json_keyval_write('s_dec',vospa%dec)
    call json_keyval_write('s_fov',vospa%fov)
    call json_keyval_write('s_region',vospa%region)
    call json_keyval_write('s_xel1',vospa%xel1)
    call json_keyval_write('s_xel2',vospa%xel2)
    call json_keyval_write('s_resolution',vospa%reso)
    if (vospa%dopscale) &
      call json_keyval_write('s_pixel_scale',vospa%pscale)
    ! Spectro description
    call json_keyval_write('em_ucd','em.freq')
    call json_keyval_write('em_min',wmin)
    call json_keyval_write('em_max',wmax)
    call json_keyval_write('em_res_power',wpower)
    call json_keyval_write('em_xel',nchan)
    ! Time description
    call json_keyval_write('t_xel',1)
    ! Polarization description
    call json_keyval_write('pol_xel',0)
    call json_keyval_write('pol_states','NULL')
    call json_keyval_write('facility_name','IRAM',last=.true.)
    call json_dict_write_stop(last=.true.)
    !
    call json_main_write_stop()
    !
  end subroutine cubetools_header_vo_list_header

  subroutine vo_spatial_from_cube(vo,spa,error)
    use phys_const
    use gkernel_types
    use gkernel_interfaces
    use cubetools_spatial_types
    !-------------------------------------------------------------------
    ! Convert a CUBE spatial_t to a vo_spatial_t.
    !
    ! This converts the actual 2D spatial coverage.
    !-------------------------------------------------------------------
    class(vo_spatial_t), intent(out)   :: vo
    type(spatial_t),     intent(in)    :: spa
    logical,             intent(inout) :: error
    !
    type(projection_t) :: proj
    real(kind=8) :: rxcent,rycent
    real(kind=coor_k) :: rxcorn(4),rycorn(4),axcorn(4),aycorn(4)
    real(kind=8) :: diag(2)
    !
    ! Setup projection
    call gwcs_projec(spa%pro%l0,spa%pro%m0,spa%pro%pa,spa%pro%code,  &
      proj,error)
    if (error)  return
    !
    ! Convert FOV center from relative to absolute
    rxcent = (spa%l%coord(1)+spa%l%coord(spa%l%n))/2.d0
    rycent = (spa%m%coord(1)+spa%m%coord(spa%m%n))/2.d0
    call rel_to_abs(proj,rxcent,rycent,vo%ra,vo%dec,1)
    vo%ra  = vo%ra/rad_per_deg
    vo%dec = vo%dec/rad_per_deg
    !
    ! Convert FOV corners from relative to absolute coordinates
    rxcorn(1) = spa%l%get_min()
    rxcorn(2) = spa%l%get_max()
    rxcorn(3) = spa%l%get_max()
    rxcorn(4) = spa%l%get_min()
    rycorn(1) = spa%m%get_min()
    rycorn(2) = spa%m%get_min()
    rycorn(3) = spa%m%get_max()
    rycorn(4) = spa%m%get_max()
    call rel_to_abs(proj,rxcorn,rycorn,axcorn,aycorn,4)
    !
    ! Compute FOV (largest diagonal)
    diag(1) = haversine(axcorn(1),aycorn(1),axcorn(3),aycorn(3))
    diag(2) = haversine(axcorn(2),aycorn(2),axcorn(4),aycorn(4))
    vo%fov = maxval(diag)
    axcorn = axcorn/rad_per_deg
    aycorn = aycorn/rad_per_deg
    vo%fov = vo%fov/rad_per_deg
    !
    ! These are degrees: we should writes digits down to arc second precision
    write(vo%region,'(A,8(1X,F8.4),A1)') 'ICRS (Polygon',      &
                                         axcorn(1),aycorn(1),  &
                                         axcorn(2),aycorn(2),  &
                                         axcorn(3),aycorn(3),  &
                                         axcorn(4),aycorn(4),')'
    !
    vo%reso = sqrt(spa%bea%major*spa%bea%minor)/rad_per_sec
    vo%dopscale = .true.
    vo%pscale = sqrt(abs(spa%l%inc*spa%m%inc))/rad_per_sec
    !
    vo%xel1 = spa%l%n
    vo%xel2 = spa%m%n
  end subroutine vo_spatial_from_cube

  subroutine vo_spatial_from_uvtable(vo,spa,error)
    use phys_const
    use cubetools_nan
    use cubetools_spatial_types
    !-------------------------------------------------------------------
    ! Convert a UV spatial_t to a vo_spatial_t.
    !
    ! This converts the primary beam into the coverage.
    !-------------------------------------------------------------------
    class(vo_spatial_t), intent(out)   :: vo
    type(spatial_t),     intent(in)    :: spa
    logical,             intent(inout) :: error
    !
    vo%ra  = spa%pro%l0/rad_per_deg
    vo%dec = spa%pro%m0/rad_per_deg
    ! Field of view: primary beam
    vo%fov = spa%bea%major/rad_per_deg  ! Ignore minor and angle (unset in UV table)
    !
    ! These are degrees: we should writes digits down to arc second precision
    write(vo%region,'(A,3(1X,F9.5),A1)') 'ICRS (Circle',  &
                                         vo%ra,vo%dec,vo%fov/2.d0,')'
    !
    ! Irrelevant:
    vo%reso = gr8nan
    vo%xel1 = 0
    vo%xel2 = 0
    vo%dopscale = .false.
  end subroutine vo_spatial_from_uvtable

  function haversine(ra1,dec1,ra2,dec2)
    !-------------------------------------------------------------------
    ! Use the haversine formula which is numerically better-conditioned
    ! for small distances
    !-------------------------------------------------------------------
    real(kind=8) :: haversine
    real(kind=8), intent(in) :: ra1,dec1
    real(kind=8), intent(in) :: ra2,dec2
    !
    real(kind=8) :: dra,ddec,term1,term2
    !
    dra = abs(ra1-ra2)
    ddec = abs(dec1-dec2)
    !
    term1 = sin(ddec/2)**2
    term2 = cos(dec1)*cos(dec2)*sin(dra/2)**2
    haversine = 2*asin(sqrt(term1+term2))
  end function haversine

  !---------------------------------------------------------------------

  subroutine json_vo_description(key,mandatory,type,unit,last)
    !-------------------------------------------------------------------
    ! Write one VO entry description
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    logical,          intent(in)           :: mandatory
    character(len=*), intent(in)           :: type
    character(len=*), intent(in), optional :: unit
    logical,          intent(in), optional :: last
    ! Local
    character(len=128) :: value
    !
    write(value,'(4A)')  '{',  &
                         trim(json_keyval_l42str('mandatory',mandatory)),  &
                         ', ',  &
                         trim(json_keyval_ch2str('type',type))
    if (present(unit)) then
      write(value,'(4A)')  trim(value),  &
                           ', ',  &
                           trim(json_keyval_ch2str('unit',unit)),  &
                           '}'
    else
      write(value,'(2A)')  trim(value),  &
                           '}'
    endif
    !
    call json_keyval_write_any(key,value,last)
  end subroutine json_vo_description

  !---------------------------------------------------------------------

  subroutine json_main_write_start()
    !-------------------------------------------------------------------
    ! Start the main JSON block
    !-------------------------------------------------------------------
    write(*,'(A)')  '{'
  end subroutine json_main_write_start

  subroutine json_main_write_stop()
    !-------------------------------------------------------------------
    ! Stop the main JSON block
    !-------------------------------------------------------------------
    write(*,'(A)')  '}'
  end subroutine json_main_write_stop

  subroutine json_dict_write_start(name)
    !-------------------------------------------------------------------
    ! Start a JSON dictionary
    !-------------------------------------------------------------------
    character(len=*), intent(in) :: name
    !
    write(*,'(3A)')  '"',trim(name),'": {'
  end subroutine json_dict_write_start

  subroutine json_dict_write_stop(last)
    !-------------------------------------------------------------------
    ! Stop a JSON dictionary
    !-------------------------------------------------------------------
    logical, intent(in), optional :: last
    !
    if (present(last)) then
      if (last) then
        write(*,'(A)')  '}'
        return
      endif
    endif
    write(*,'(A)')  '},'
  end subroutine json_dict_write_stop

  function json_keyval_ch2str(key,value)
    !-------------------------------------------------------------------
    ! Create a key + string value pair as a string with proper
    ! formatting
    !-------------------------------------------------------------------
    character(len=128) :: json_keyval_ch2str
    character(len=*), intent(in) :: key
    character(len=*), intent(in) :: value
    ! Local
    character(len=128) :: string
    !
    write(string,'(A1,A,A1)')  '"',trim(value),'"'
    json_keyval_ch2str = json_keyval_any2str(key,string)
  end function json_keyval_ch2str

  function json_keyval_r82str(key,value)
    !-------------------------------------------------------------------
    ! Create a key + R*8 value pair as a string with proper formatting
    !-------------------------------------------------------------------
    character(len=128) :: json_keyval_r82str
    character(len=*), intent(in) :: key
    real(kind=8),     intent(in) :: value
    ! Local
    character(len=26) :: string
    !
    write(string,'(A1,1PG0.16,A1)')  '"',value,'"'
    json_keyval_r82str = json_keyval_any2str(key,string)
  end function json_keyval_r82str

  function json_keyval_i82str(key,value)
    !-------------------------------------------------------------------
    ! Create a key + I*8 value pair as a string with proper formatting
    !-------------------------------------------------------------------
    character(len=128) :: json_keyval_i82str
    character(len=*), intent(in) :: key
    integer(kind=8),  intent(in) :: value
    ! Local
    character(len=24) :: string
    !
    write(string,'(A1,I0,A1)')  '"',value,'"'
    json_keyval_i82str = json_keyval_any2str(key,string)
  end function json_keyval_i82str

  function json_keyval_l42str(key,value)
    !-------------------------------------------------------------------
    ! Create a key + logical value pair as a string with proper
    ! formatting
    !-------------------------------------------------------------------
    character(len=128) :: json_keyval_l42str
    character(len=*), intent(in) :: key
    logical,          intent(in) :: value
    ! Local
    character(len=5) :: string
    !
    if (value) then
      string = 'true'
    else
      string = 'false'
    endif
    json_keyval_l42str = json_keyval_any2str(key,string)
  end function json_keyval_l42str

  function json_keyval_any2str(key,value)
    !-------------------------------------------------------------------
    ! Create a key + preformatted string pair as a string (not
    ! formatting)
    !-------------------------------------------------------------------
    character(len=128) :: json_keyval_any2str
    character(len=*), intent(in) :: key
    character(len=*), intent(in) :: value
    !
    write(json_keyval_any2str,'(4A)')  '"',trim(key),'": ',trim(value)
  end function json_keyval_any2str

  subroutine json_keyval_write_i4(key,value,last)
    !-------------------------------------------------------------------
    ! Write to screen a key + I*4 value with proper formatting
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    integer(kind=4),  intent(in)           :: value
    logical,          intent(in), optional :: last
    !
    character(len=1) :: trail
    !
    trail = ','
    if (present(last)) then
      if (last)  trail = ' '
    endif
    write(*,'(2A)')  trim(json_keyval_i82str(key,int(value,kind=8))),trail
  end subroutine json_keyval_write_i4

  subroutine json_keyval_write_i8(key,value,last)
    !-------------------------------------------------------------------
    ! Write to screen a key + I*8 value with proper formatting
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    integer(kind=8),  intent(in)           :: value
    logical,          intent(in), optional :: last
    !
    character(len=1) :: trail
    !
    trail = ','
    if (present(last)) then
      if (last)  trail = ' '
    endif
    write(*,'(2A)')  trim(json_keyval_i82str(key,value)),trail
  end subroutine json_keyval_write_i8

  subroutine json_keyval_write_r8(key,value,last)
    !-------------------------------------------------------------------
    ! Write to screen a key + R*8 value with proper formatting
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    real(kind=8),     intent(in)           :: value
    logical,          intent(in), optional :: last
    !
    character(len=1) :: trail
    !
    trail = ','
    if (present(last)) then
      if (last)  trail = ' '
    endif
    write(*,'(2A)')  trim(json_keyval_r82str(key,value)),trail
  end subroutine json_keyval_write_r8

  subroutine json_keyval_write_ch(key,value,last)
    !-------------------------------------------------------------------
    ! Write to screen a key + character string value with proper
    ! formatting
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    character(len=*), intent(in)           :: value
    logical,          intent(in), optional :: last
    !
    character(len=1) :: trail
    !
    trail = ','
    if (present(last)) then
      if (last)  trail = ' '
    endif
    write(*,'(2A)')  trim(json_keyval_ch2str(key,value)),trail
  end subroutine json_keyval_write_ch

  subroutine json_keyval_write_any(key,value,last)
    !-------------------------------------------------------------------
    ! Write to screen a key + character string value with no formatting
    !-------------------------------------------------------------------
    character(len=*), intent(in)           :: key
    character(len=*), intent(in)           :: value
    logical,          intent(in), optional :: last
    !
    character(len=1) :: trail
    !
    trail = ','
    if (present(last)) then
      if (last)  trail = ' '
    endif
    write(*,'(2A)')  trim(json_keyval_any2str(key,value)),trail
  end subroutine json_keyval_write_any

end module cubetools_header_vo

module mapping_interfaces_public
  interface
    subroutine dofft (np,nv,visi,jx,jy,jo   &
         &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
         &    ,ubias,vbias,ubuff,vbuff,ctype)
      use gildas_def
      use omp_buffers
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS  UV_MAP
      !   Compute FFT of image by gridding UV data
      !   Operational version using the fastest method.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv                   ! number of values
      integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
      real, intent(in) :: visi(np,nv)             ! values
      integer, intent(in) :: nc                   ! number of channels
      integer, intent(in) :: jx                   ! X coord location in VISI
      integer, intent(in) :: jy                   ! Y coord location in VISI
      integer, intent(in) :: jo                   ! first channel to map
      integer, intent(in) :: nx                   ! X map size
      integer, intent(in) :: ny                   ! Y map size
      complex, intent(out) :: map(nc+1,nx,ny)     ! gridded visibilities
      real, intent(in) :: mapx(nx)                ! X Coordinates of grid
      real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
      real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
      real, intent(in) :: cell(2)                 ! cell size in Meters
      real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
      real, intent(in) :: we(nv)                  ! Weight array
      real, intent(in) :: vv(nv)                  ! V Values
      real, intent(in) :: ubias                   ! U gridding offset
      real, intent(in) :: vbias                   ! V gridding offset
      real, intent(in) :: ubuff(4096)             ! U gridding buffer
      real, intent(in) :: vbuff(4096)             ! V gridding buffer
      integer, intent(in) :: ctype                ! type of gridding
    end subroutine dofft
  end interface
  !
  interface
    subroutine doself (model,resul,itype,self,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Compute self calibraton factor
      !---------------------------------------------------------------------
      complex, intent(in) :: model   ! Model visibility
      complex, intent(in) :: resul   ! Actual observation
      integer, intent(in) :: itype   ! Type of self calibration
      complex, intent(out) :: self   ! Self calibration factor
      real, intent(out) :: weight    ! Weight scaling factor
    end subroutine doself
  end interface
  !
  interface
    subroutine doscal (nc,visi,cosi,sinu,sreel,simag,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Apply the self-calibration factor to the current visibility
      !	  Set weight to zero if no self-cal factor
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part to subtract
      real, intent(in) :: simag           !  Imaginary part to subtract
      real, intent(in) :: cosi            !  Phase rotation cos
      real, intent(in) :: sinu            !  Phase rotation sin
      real, intent(in) :: weight          !  Scaling factor of weight
    end subroutine doscal
  end interface
  !
  interface
    subroutine dosubt (nc,visi,sreel,simag)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Subtract a continuum value from a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part
      real, intent(in) :: simag           !  Imaginary part
    end subroutine dosubt
  end interface
  !
  interface
    subroutine doflag (nc,visi)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Flag (by zero) a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
    end subroutine doflag
  end interface
  !
  interface
    subroutine getiba (visi,stime,time,base,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Get baseline and time information
      !---------------------------------------------------------------------
      real, intent(in)  :: visi(*)                   ! Visibility
      real(8), intent(in) :: stime                   ! Reference time
      real(8), intent(out) :: time                   ! Time offset
      real, intent(out)  :: base(2)                  ! First and Last antenna
      real, intent(out)  :: uv(2)                    ! U and V
    end subroutine getiba
  end interface
  !
  interface
    subroutine dotime (mv,nv,visi,wtime,it,stime)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the observing times of the data, 
      !	  sort it and return sorting index
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(inout) :: it(nv)    ! Sorting index
      real(8), intent(out) :: stime       ! Reference time
    end subroutine dotime
  end interface
  !
  interface
    subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,   &
         &    rbase,complx,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the Observed Visibility of the "model source"
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(in) :: iw(2)        ! First and Last channel
      real(8), intent(in) :: time         ! Time of observation
      real(8), intent(in) :: ftime        ! Tolerance on time +/-
      integer, intent(in) :: it(nv)       ! Ordering of visibilities
      real, intent(in) :: rbase(2)        ! Antennas
      real, intent(in) :: uv(2)           ! U and V
      complex, intent(out) :: complx      ! Result
    end subroutine geself
  end interface
  !
  interface
    subroutine findr (np,x,xlim,nlim)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Find NLIM such as
      !	 	    X(NLIM-1) < XLIM <= X(NLIM)
      !	  for input data ordered.
      !	  Use a dichotomic search for that
      !---------------------------------------------------------------------
      integer, intent(in) :: np          ! Number of data points
      real(8), intent(in) :: x(np)       ! Data values
      real(8), intent(in) :: xlim        ! Value to be localized
      integer, intent(out) :: nlim       ! Found position
    end subroutine findr
  end interface
  !
  interface
    subroutine extracs (np,nx,ny,ip,in,out,lx,ly)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from the FFT cube
      !     Plane and Cube may have different X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! output FFT X plane size
      integer,intent(in) :: ny  ! output FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      integer,intent(in) :: lx  ! input FFT cube X plane size
      integer,intent(in) :: ly  ! input FFT cube Y plane size
      complex,intent(in) :: in(np,lx,ly) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extracs
  end interface
  !
  interface
    subroutine extrac (np,nx,ny,ip,in,out)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from an FFT cube
      !     Plane and Cube must have same X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! FFT X plane size
      integer,intent(in) :: ny  ! FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      complex,intent(in) :: in(np,nx,ny) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extrac
  end interface
  !
  interface
    subroutine dovisi (np,nv,visi,vv,ww,jw)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Extract V coordinate and Weight value
      !----------------------------------------------------------------------
      integer, intent(in) :: np        ! Size of visibilities
      integer, intent(in) :: nv        ! Number of visibilities
      real, intent(in) :: visi(np,nv)  ! Visibilities
      real, intent(out) :: vv(nv)      ! V values
      real, intent(out) :: ww(nv)      ! Weight values
      integer, intent(in) :: jw        ! Weight column
    end subroutine dovisi
  end interface
  !
  interface
    subroutine dogrid (corr,corx,cory,nx,ny,beam)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute grid correction array, with normalisation
      !   of beam to 1.0 at maximum pixel
      !----------------------------------------------------------------------
      integer, intent(in) :: nx     ! X size
      integer, intent(in) :: ny     ! Y size
      real, intent(in) :: beam(nx,ny) ! Denormalized beam
      real, intent(in) :: corx(nx)    ! X grid correction
      real, intent(in) :: cory(ny)    ! Y Grid correction
      real, intent(out) :: corr(nx,ny) ! Final grid correction and beam normalization
    end subroutine dogrid
  end interface
  !
  interface
    subroutine docorr (map,corr,nd)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Apply grid correction to map
      !----------------------------------------------------------------------
      integer, intent(in) :: nd
      real, intent(inout) :: map(nd)
      real, intent(in) :: corr(nd)
    end subroutine docorr
  end interface
  !
  interface
    subroutine docoor (n,xinc,x)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute FFT grid coordinates in U or V
      !----------------------------------------------------------------------
      integer,intent(in) :: n
      real, intent(out) :: x(n)
      real, intent(in) :: xinc
    end subroutine docoor
  end interface
  !
  interface
    subroutine findp (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !   XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XX(NLIM-1) < XLIM
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findp
  end interface
  !
  interface
    subroutine findm (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !     XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XLIM < XX(NLIM)
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findm
  end interface
  !
  interface
    subroutine grdtab (n, buff, bias, corr)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Compute fourier transform of gridding function
      !----------------------------------------------------------------------
      integer, intent(in) :: n     ! Number of pixels, assuming center on N/2+1
      real, intent(in) :: buff(*)  ! Gridding function, tabulated every 1/100 cell
      real, intent(in) :: bias     ! Center of gridding function
      real, intent(out) :: corr(n) ! Gridding correction FT
    end subroutine grdtab
  end interface
  !
  interface
    subroutine retocm(r,z,nx,ny)
      !------------------------------------------------------------------------
      ! @  public
      ! MAPPING
      !   Convert real to complex, with Shifting in corners for FFT
      !------------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! Problem size
      real, intent(in) :: r(nx,ny)          ! Real values
      complex, intent(out) :: z(nx, ny)     ! Complex shifted values
    end subroutine retocm
  end interface
  !
  interface
    subroutine cmtore (in,out,nx,ny)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Utility
      !   Extract Real image from Fourier Transform of its complex FFT
      !   with appropriate recentering
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         ! Size of map
      integer, intent(in) :: ny         ! Size of map
      complex, intent(in) :: in(nx,ny)  ! Complex FFT
      real, intent(out) :: out(nx,ny)   ! Extracted real image
    end subroutine cmtore
  end interface
  !
  interface
    subroutine convfn (ctype, parm, buffer, bias)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING
      !   CONVFN computes the convolving functions and stores them in
      !   the supplied buffer. Values are tabulated every 1/100 cell.
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctype
      real(4), intent(inout) :: parm(10)
      real(4), intent(out)   :: buffer(:)
      real(4), intent(out)   :: bias
    end subroutine convfn
  end interface
  !
  interface
    subroutine grdflt (ctypx, ctypy, xparm, yparm)
      !----------------------------------------------------------------------
      ! @ public
      !
      !     GRDFLT determines default parameters for the convolution functions
      !     If no convolving type is chosen, an Spheroidal is picked.
      !     Otherwise any unspecified values ( = 0.0) will be set to some
      !     value.
      ! Arguments:
      !     CTYPX,CTYPY           I  Convolution types for X and Y direction
      !                                1 = pill box
      !                                2 = exponential
      !                                3 = sinc
      !                                4 = expontntial * sinc
      !                                5 = spheroidal function
      !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
      !                                (1) = support radius (cells)
      !
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctypx,ctypy
      real(4), intent(inout) :: xparm(10), yparm(10)
    end subroutine grdflt
  end interface
  !
  interface
    subroutine uvgmax(huv,visi,uvmax,uvmin)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Support for UV_MAP
      !       Get the Min Max of UV distances
      !----------------------------------------------------------------------
      type (gildas), intent(inout) :: huv
      real, intent(in) ::  visi(:,:) ! Visibilities
      real, intent(out) :: uvmax ! Max baseline
      real, intent(out) :: uvmin ! Min baseline
    end subroutine uvgmax
  end interface
  !
  interface
    function sump(n,a)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !       Return the sum of positive values in array
      !----------------------------------------------------------------------
      real :: sump    ! Return value, intent(out)
      integer, intent(in) :: n   ! Number of values
      real, intent(in) :: a(n)   ! Values
    end function sump
  end interface
  !
  interface
    subroutine dotape (jc,nv,visi,jx,jy,taper,we)
      use gildas_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Support for UV_MAP
      !     Apply taper to the weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv          ! number of values
      integer, intent(in) :: jc          ! Size of a visibility
      integer, intent(in) :: jx          ! X coord location in VISI
      integer, intent(in) :: jy          ! Y coord location in VISI
      real, intent(in) :: visi(jc,nv)    ! Visibilities
      real, intent(in) :: taper(4)       ! Taper definition
      real, intent(inout) :: we(nv)      ! Weights
    end subroutine dotape
  end interface
  !
  interface
    subroutine doweig (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code
    end subroutine doweig
  end interface
  !
  interface
    subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code  ! Number of sub-cells per UV uniform cell size
    end subroutine doweig_sph
  end interface
  !
  interface
    subroutine scawei (nv,uni,ori,wall)
      !---------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Scale the weights
      !---------------------------------------------------------
      integer, intent(in) :: nv     ! Number of visibilities
      real, intent(out) :: uni(nv)  ! Re-weighted weights
      real, intent(in)  :: ori(nv)  ! Original weights
      real, intent(out) :: wall     ! Sum of weights
    end subroutine scawei
  end interface
  !
  interface
    subroutine map_message(mkind,procname,message)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Messaging facility for the current library. Calls the low-level
      !   (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine map_message
  end interface
  !
end module mapping_interfaces_public

module cubedag_node_class
  use cubedag_messaging
  use cubedag_parameters
  use cubedag_link_type
  use cubedag_nodedesc_type
  !---------------------------------------------------------------------
  ! Support module for the cubedag_node_object_t, i.e. the generic
  ! object class which is able to store any kind of object without
  ! knowing it (cubes, UV tables, etc).
  !---------------------------------------------------------------------

  ! Placeholder for a 'node object' reference, i.e. for files indexed here. This
  ! type is extended by the external libraries using the DAG, to support their
  ! own object kinds (with their own Fortran types)
  type, abstract, extends(dag_object_t) :: cubedag_node_object_t
    type(cubedag_node_desc_t) :: node
  contains
    procedure(ltype_interface),    deferred, public :: ltype     ! Return string describing the polymorphic type (used e.g. in LIST)
    procedure(memsize_interface),  deferred, public :: memsize   ! Return the memory footprint
    procedure(memsize_interface),  deferred, public :: disksize  ! Return the disk footprint
    procedure(memsize_interface),  deferred, public :: datasize  ! Return the data size
    procedure(snapshot_interface), deferred, public :: snapshot  ! Snapshot the object to the tmp directory
    procedure(finish_interface),   deferred, public :: reimport  ! Reimport the object from disk to DAG
    procedure(finish_interface),   deferred, public :: finish    ! Finish the object after command execution
  ! procedure(),                   deferred         :: free      !
  ! procedure(),                   deferred         :: getsize   ! Useful for garbage collecting?
    ! Get property methods (generic and ad-hoc)
    procedure, public :: get_id       => cubedag_node_get_id
    procedure         :: get_value_i4 => cubedag_node_get_value_i4  ! [private]
    procedure         :: get_value_i8 => cubedag_node_get_value_i8  ! [private]
    procedure         :: get_value_r4 => cubedag_node_get_value_r4  ! [private]
    procedure         :: get_value_r8 => cubedag_node_get_value_r8  ! [private]
    procedure         :: get_value_cc => cubedag_node_get_value_cc  ! [private]
    procedure, public :: get_lrepr    => cubedag_node_get_lrepr
    procedure, public :: get_repr     => cubedag_node_get_repr
    procedure, public :: get_header   => cubedag_node_get_header
    ! Set property methods (generic and ad-hoc)
    generic,   public  :: set_value     => set_value_i4,set_value_i8,set_value_r4, &
                                           set_value_r8,set_value_cc
    procedure, private :: set_value_i4  => cubedag_node_set_value_i4
    procedure, private :: set_value_i8  => cubedag_node_set_value_i8
    procedure, private :: set_value_r4  => cubedag_node_set_value_r4
    procedure, private :: set_value_r8  => cubedag_node_set_value_r8
    procedure, private :: set_value_cc  => cubedag_node_set_value_cc
    procedure, public  :: set_flags     => cubedag_node_set_flags
    procedure, public  :: set_header    => cubedag_node_set_header
    procedure, public  :: set_uservar   => cubedag_node_set_uservar
    procedure, public  :: unset_uservar => cubedag_node_unset_uservar
    ! Others
    procedure, public :: final => cubedag_node_final
  end type cubedag_node_object_t

  public :: cubedag_node_object_t
  public :: cubedag_node_ptr
  private

contains

  function ltype_interface(obj)
    !-------------------------------------------------------------------
    ! Dummy procedure providing its interface for the ltype method
    !-------------------------------------------------------------------
    character(len=2) :: ltype_interface
    class(cubedag_node_object_t), intent(in) :: obj
    ltype_interface = '??'
  end function ltype_interface

  function memsize_interface(obj)
    !-------------------------------------------------------------------
    ! Dummy procedure providing its interface for the memsize method
    !-------------------------------------------------------------------
    integer(kind=size_length) :: memsize_interface
    class(cubedag_node_object_t), intent(in) :: obj
    memsize_interface = 0
  end function memsize_interface

  subroutine snapshot_interface(obj,keep,done,error)
    !-------------------------------------------------------------------
    ! Dummy procedure providing its interface for the snapshot method
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    logical,                      intent(in)    :: keep
    logical,                      intent(out)   :: done
    logical,                      intent(inout) :: error
  end subroutine snapshot_interface

  subroutine finish_interface(obj,error)
    !-------------------------------------------------------------------
    ! Dummy procedure providing its interface for the finish method
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    logical,                      intent(inout) :: error
  end subroutine finish_interface

  function cubedag_node_get_id(obj)
    !-------------------------------------------------------------------
    ! Return the node identifier
    !-------------------------------------------------------------------
    integer(kind=iden_l) :: cubedag_node_get_id
    class(cubedag_node_object_t), intent(in) :: obj
    cubedag_node_get_id = obj%node%id
  end function cubedag_node_get_id

  function cubedag_node_ptr(tot,error)
    use cubelist_types
    !-------------------------------------------------------------------
    ! Check if the input class is a 'cubedag_node_object_t', and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer :: cubedag_node_ptr  ! Function value on return
    class(list_object_t), target, intent(in)   :: tot
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='NODE>PTR'
    !
    select type(tot)
    class is (cubedag_node_object_t)
      cubedag_node_ptr => tot
    class default
      cubedag_node_ptr => null()
      call cubedag_message(seve%e,rname,'Internal error: object is not a cubedag_node_object_t')
      error = .true.
      return
    end select
  end function cubedag_node_ptr
  !
  subroutine cubedag_node_get_value_i4(obj,name,found,value,error)
    !-------------------------------------------------------------------
    ! Get an I*4 property from a cubedag_node_object_t. See
    ! requirements in cubelist_object_advanced_types.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    logical,                      intent(out)   :: found
    integer(kind=4),              intent(inout) :: value
    logical,                      intent(inout) :: error
    !
    found = .true.
    select case (name)
    case ('IDENTIFIER')
      value = obj%node%id
    case ('DATATYPE')
      value = obj%node%head%array_type
    case ('PROJTYPE')
      value = obj%node%head%spatial_projection_code
    case default
      found = .false.
      return
    end select
  end subroutine cubedag_node_get_value_i4
  !
  subroutine cubedag_node_set_value_i4(obj,name,value,error)
    !-------------------------------------------------------------------
    ! Set an I*4 property to a cubedag_node_object_t.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    integer(kind=4),              intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    select case (name)
    case ('ORIGIN')
      obj%node%origin = value
    case ('HISTORY')
      obj%node%history = value
    case default
      return
    end select
  end subroutine cubedag_node_set_value_i4
  !
  subroutine cubedag_node_get_value_i8(obj,name,found,value,error)
    !-------------------------------------------------------------------
    ! Get an I*8 property from a cubedag_node_object_t. See
    ! requirements in cubelist_object_advanced_types.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    logical,                      intent(out)   :: found
    integer(kind=8),              intent(inout) :: value
    logical,                      intent(inout) :: error
    !
    found = .true.
    select case (name)
    case ('IDENTIFIER')
      value = obj%node%id
    case ('DATATYPE')
      value = obj%node%head%array_type
    case default
      found = .false.
      return
    end select
  end subroutine cubedag_node_get_value_i8
  !
  subroutine cubedag_node_set_value_i8(obj,name,value,error)
    !-------------------------------------------------------------------
    ! Set an I*8 property to a cubedag_node_object_t.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    integer(kind=8),              intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    select case (name)
    case ('HISTORY')
      obj%node%history = value
    case default
      return
    end select
  end subroutine cubedag_node_set_value_i8
  !
  subroutine cubedag_node_get_value_r4(obj,name,found,value,error)
    !-------------------------------------------------------------------
    ! Get an R*4 property from a cubedag_node_object_t. See
    ! requirements in cubelist_object_advanced_types.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    logical,                      intent(out)   :: found
    real(kind=4),                 intent(inout) :: value
    logical,                      intent(inout) :: error
    !
    found = .true.
    select case (name)
    case default
      found = .false.
      return
    end select
  end subroutine cubedag_node_get_value_r4
  !
  subroutine cubedag_node_set_value_r4(obj,name,value,error)
    !-------------------------------------------------------------------
    ! Set an R*4 property to a cubedag_node_object_t.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    real(kind=4),                 intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    select case (name)
    case default
      return
    end select
  end subroutine cubedag_node_set_value_r4
  !
  subroutine cubedag_node_get_value_r8(obj,name,found,value,error)
    !-------------------------------------------------------------------
    ! Get an R*8 property from a cubedag_node_object_t. See
    ! requirements in cubelist_object_advanced_types.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    logical,                      intent(out)   :: found
    real(kind=8),                 intent(inout) :: value
    logical,                      intent(inout) :: error
    !
    found = .true.
    select case (name)
    case default
      found = .false.
      return
    end select
  end subroutine cubedag_node_get_value_r8
  !
  subroutine cubedag_node_set_value_r8(obj,name,value,error)
    !-------------------------------------------------------------------
    ! Set an R*8 property to a cubedag_node_object_t.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    real(kind=8),                 intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    select case (name)
    case default
      return
    end select
  end subroutine cubedag_node_set_value_r8
  !
  subroutine cubedag_node_get_value_cc(obj,name,found,value,error)
    !-------------------------------------------------------------------
    ! Get a C*(*) property from a cubedag_node_object_t. See
    ! requirements in cubelist_object_advanced_types.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    logical,                      intent(out)   :: found
    character(len=*),             intent(inout) :: value
    logical,                      intent(inout) :: error
    !
    found = .true.
    select case (name)
    case ('FAMILY')
      value = obj%node%family
    case ('FLAGS')
      call obj%node%flag%repr(strflag=value,error=error)
    case ('OBSERVATORY')
      call obj%node%head%obs%tostr(value,error)
    case ('SOURCE')
      value = obj%node%head%spatial_source
    case ('LINE')
      value = obj%node%head%spectral_line
    case default
      found = .false.
      return
    end select
  end subroutine cubedag_node_get_value_cc
  !
  subroutine cubedag_node_set_value_cc(obj,name,value,error)
    !-------------------------------------------------------------------
    ! Set a C*(*) property to a cubedag_node_object_t.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Property name
    character(len=*),             intent(in)    :: value
    logical,                      intent(inout) :: error
    !
    select case (name)
    case ('FAMILY')
      obj%node%family = value
    case default
      return
    end select
  end subroutine cubedag_node_set_value_cc
  !
  subroutine cubedag_node_get_lrepr(obj,name,width,error)
    !-------------------------------------------------------------------
    ! Return the best width for representing a property with LIST
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    character(len=*),             intent(in)    :: name  ! Column identifier
    integer(kind=4),              intent(out)   :: width
    logical,                      intent(inout) :: error
    !
    character(len=24) :: str24  ! Max column length for these is 24
    !
    select case (name)
    case ('IDENTIFIER')
      width = floor(log10(real(obj%node%id,kind=8)))+1
    case ('PARENTS','CHILDREN','TWINS')
      width = 20
    case ('UNIT')
      width = 12
    case ('SOURCE')
      width = len_trim(obj%node%head%spatial_source)
    case ('LINE')
      width = len_trim(obj%node%head%spectral_line)
    case ('PROJTYPE')
      width = 13
    case ('L0','M0')
      ! Trick because sexag wants at least 12 chars to show seconds and sub-seconds
      width = 11
    case ('PROJANGLE','BPA')
      width = 5
    case ('SPALINC','SPAMINC','SPEFREQINC')
      width = 7
    case ('SPEFREQVAL')
      width = 10
    case ('SPEVELOVAL','BMAJOR','BMINOR')
      width = 6
    case ('OBSERVATORY')
      call obj%node%head%obs%tostr(str24,error)
      if (error)  return
      width = len_trim(str24)
    case ('LOCATION')
      width = 30
    case ('ORDER')
      width = 7
    case ('ACCESS')
      width = 14
    case ('ORIGIN')
      width = 8
    case ('FAMILY')
      width = len_trim(obj%node%family)
    case ('FLAGS')
      call obj%node%flag%repr(lstrflag=width,error=error)
      if (error)  return
    case ('CUBEID')
      width = len_trim(obj%node%cubeid(error))
    case ('TYPE')
      width = 2
    case ('VARIABLE')
      width = 24
    case ('MEMSIZE','DISKSIZE','DATASIZE')
      width = 8
    case ('DATATYPE')
      width = 8
    case default
      width = 3  ! 'N/A'
    end select
  end subroutine cubedag_node_get_lrepr

  subroutine cubedag_node_get_repr(obj,name,width,repr,nline,error)
    use phys_const
    use gkernel_interfaces
    use cubetools_format
    use cubetools_string
    use cubesyntax_datatype_types
    !-------------------------------------------------------------------
    ! Return the representation (i.e. the character string) suited for
    ! command LIST. Note that some columns might spawn over several
    ! lines.
    ! The character string is assumed to best fill the 'repr' length
    ! (i.e. len(repr))
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    character(len=*),             intent(in)    :: name  ! Column identifier
    integer(kind=4),              intent(in)    :: width
    character(len=*),             intent(out)   :: repr(:)
    integer(kind=4),              intent(out)   :: nline
    logical,                      intent(inout) :: error
    !
    integer(kind=4) :: vali4,iloc
    logical :: found
    character(len=6) :: vformat
    character(len=maxdim) :: iorder
    integer(kind=code_k), parameter :: locations(2) = (/ code_buffer_memory, &
                                                         code_buffer_disk /)
    !
    nline = 1
    repr(1) = ''
    select case (name)
    case ('IDENTIFIER')
      if (obj%node%id.lt.0) then  ! Null id
        repr(1)(1:width) = '--------------------'
      else
        write(vformat,'(A,I0,A)')  '(I',width,')'
        write(repr(1)(1:width),vformat)   obj%node%id
      endif
    case ('PARENTS')
      call obj%node%links%parents%repr('p=',repr(1)(1:width))
    case ('CHILDREN')
      call obj%node%links%children%repr('c=',repr(1)(1:width))
    case ('TWINS')
      call obj%node%links%twins%repr('t=',repr(1)(1:width))
    case ('UNIT')
      repr(1)(1:width) = obj%node%head%array_unit
    case ('SOURCE')
      repr(1)(1:width) = obj%node%head%spatial_source
    case ('PROJTYPE')
      repr(1)(1:width) = projnam(obj%node%head%spatial_projection_code)
    case ('L0')
      ! Trick because sexag wants at least 12 chars to show seconds and sub-seconds
      call sexag(repr(1)(1:width+1),obj%node%head%spatial_projection_l0,24)
      repr(1)(width+1:width+1) = ' '  ! Suppress the last sub-second digit
    case ('M0')
      ! Trick because sexag wants at least 12 chars to show seconds and sub-seconds
      call sexag(repr(1)(1:width+1),obj%node%head%spatial_projection_m0,360)
      repr(1)(width+1:width+1) = ' '  ! Suppress the last sub-second digit
    case ('PROJANGLE')
      write(repr(1)(1:width),'(F5.1)')  obj%node%head%spatial_projection_pa*deg_per_rad
    case ('SPALINC')
      write(repr(1)(1:width),'(F7.2)')  obj%node%head%axset_convert  &
        (code_inc,obj%node%head%axset_ix)*sec_per_rad
    case ('SPAMINC')
      write(repr(1)(1:width),'(F7.2)')  obj%node%head%axset_convert  &
        (code_inc,obj%node%head%axset_iy)*sec_per_rad
    case ('LINE')
      repr(1)(1:width) = obj%node%head%spectral_line
    case ('SPEFREQVAL')
      write(repr(1)(1:width),'(F10.3)')  obj%node%head%spectral_signal_value
    case ('SPEFREQINC')
      write(repr(1)(1:width),'(F7.3)')  obj%node%head%spectral_increment_value
    case ('SPEVELOVAL')
      write(repr(1)(1:width),'(F6.2)')  obj%node%head%spectral_systemic_value
    case ('BMAJOR')
      write(repr(1)(1:width),'(F6.2)')  obj%node%head%spatial_beam_major*sec_per_rad
    case ('BMINOR')
      write(repr(1)(1:width),'(F6.2)')  obj%node%head%spatial_beam_minor*sec_per_rad
    case ('BPA')
      write(repr(1)(1:width),'(F5.1)')  obj%node%head%spatial_beam_pa*deg_per_rad
    case ('OBSERVATORY')
      call obj%node%head%obs%tostr(repr(1)(1:width),error)
    case ('LOCATION','ORDER','ACCESS','DISKSIZE')
      ! These columns spawn over several lines and must be displayed consistently
      nline = 0
      call obj%node%tuple%iterate_init()
      do while (obj%node%tuple%iterate(iorder))
        do iloc=1,2
          if (obj%node%tuple%hascube(iorder,locations(iloc))) then
            nline = nline+1
            if (name.eq.'LOCATION') then
              call obj%node%tuple%location(iorder,locations(iloc),repr(nline)(1:width))
            elseif (name.eq.'ORDER') then
              repr(nline)(1:width) = iorder
            elseif (name.eq.'ACCESS') then
              call cubedag_list_access(obj%node%tuple%access(iorder),repr(nline)(1:width),error)
            elseif (name.eq.'DISKSIZE') then
              repr(nline)(1:width) = cubetools_format_memsize(obj%node%tuple%disksize(iorder,locations(iloc)))
            endif
          endif
        enddo
      enddo
    case ('ORIGIN')
      call cubedag_list_origin(obj%node%origin,repr(1)(1:width),error)
    case ('FAMILY')
      repr(1)(1:width) = obj%node%family
    case ('FLAGS')
      call obj%node%flag%repr(strflag=repr(1)(1:width),error=error)
    case ('CUBEID')
      repr(1)(1:width) = obj%node%cubeid(error)
    case ('TYPE')
      repr(1)(1:width) = obj%ltype()
    case ('MEMSIZE')
      repr(1)(1:width) = cubetools_format_memsize(obj%memsize())
    case ('DATASIZE')
      repr(1)(1:width) = cubetools_format_memsize(obj%datasize())
    case ('DATATYPE')
      call obj%get_value('DATATYPE',found,vali4,error)
      if (error)  return
      repr(1)(1:width) = cubesyntax_datatype(vali4)
    case ('VARIABLE')
      call cubetools_string_concat(obj%node%nuservar,obj%node%uservar,',',repr(1)(1:width),error)
    case default
      repr(1) = 'N/A'
    end select
  contains
    subroutine cubedag_list_origin(origin,strorigin,error)
      integer(kind=code_k), intent(in)    :: origin
      character(len=*),     intent(out)   :: strorigin
      logical,              intent(inout) :: error
      select case (origin)
      case (1:dag_norigins)
        strorigin = dag_origin_names(origin)
      case default
        strorigin = '???'
      end select
    end subroutine cubedag_list_origin
    subroutine cubedag_list_access(access,straccess,error)
      integer(kind=code_k), intent(in)    :: access
      character(len=*),     intent(out)   :: straccess
      logical,              intent(inout) :: error
      select case (access)
      case (code_cube_speset)
        straccess = 'spectrum'
      case (code_cube_imaset)
        straccess = 'image'
      case (code_cube_unkset)
        straccess = 'unknown'
      case default
        straccess = '???'  ! Should not happen
      end select
    end subroutine cubedag_list_access
  end subroutine cubedag_node_get_repr

  subroutine cubedag_node_set_flags(obj,flags,error)
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! Set the flags of a 'cubedag_node_object_t'.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    type(flag_t),                 intent(in)    :: flags(:)
    logical,                      intent(inout) :: error
    !
    call obj%node%flag%create(flags,error)
  end subroutine cubedag_node_set_flags
  !
  subroutine cubedag_node_set_header(obj,head,error)
    use cubetools_header_types
    !-------------------------------------------------------------------
    ! The input cube_header_t is transfered to the DAG node header
    ! ZZZ This code should be made simpler when the cube_header_t
    !     becomes an extension of the cube_header_interface_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    type(cube_header_t),          intent(in)    :: head
    logical,                      intent(inout) :: error
    !
    call cubetools_header_export(head,obj%node%head,error)
    if (error)  return
  end subroutine cubedag_node_set_header
  !
  subroutine cubedag_node_get_header(object,head,error)
    use cubetools_header_types
    !-------------------------------------------------------------------
    ! The input DAG node header is transfered to the cube_header_t
    ! ZZZ This code should be made simpler when the cube_header_t
    !     becomes an extension of the cube_header_interface_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: object
    type(cube_header_t),          intent(inout) :: head
    logical,                      intent(inout) :: error
    !
    call cubetools_header_import_and_derive(object%node%head,head,error)
    if (error)  return
  end subroutine cubedag_node_get_header
  !
  subroutine cubedag_node_set_uservar(object,uservar,error)
    !-------------------------------------------------------------------
    ! Declare that a user variable points to this node
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: object
    character(len=*),             intent(in)    :: uservar
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='NODE>SET>USERVAR'
    integer(kind=4) :: nuservar
    !
    nuservar = object%node%nuservar+1
    if (nuservar.gt.dag_muservar) then
      call cubedag_message(seve%e,rname,'Too many user variables pointing to the same object')
      error = .true.
      return
    endif
    object%node%nuservar = nuservar
    object%node%uservar(nuservar) = uservar
  end subroutine cubedag_node_set_uservar
  !
  subroutine cubedag_node_unset_uservar(object,uservar,error)
    !-------------------------------------------------------------------
    ! Undeclare that a SIC variable points to this node
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: object
    character(len=*),             intent(in)    :: uservar
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='NODE>UNSET>USERVAR'
    integer(kind=4) :: iuservar,juservar
    !
    juservar = 0
    do iuservar=1,object%node%nuservar
      if (object%node%uservar(iuservar).eq.uservar) then
        juservar = iuservar
        exit
      endif
    enddo
    !
    if (juservar.eq.0) then
      call cubedag_message(seve%w,rname,'Internal error: no such reference to variable '//uservar)
      return
    endif
    !
    do iuservar=juservar+1,object%node%nuservar
      object%node%uservar(iuservar-1) = object%node%uservar(iuservar)
    enddo
    object%node%nuservar = object%node%nuservar-1
  end subroutine cubedag_node_unset_uservar
  !
  subroutine cubedag_node_final(obj,error)
    !-------------------------------------------------------------------
    ! Free the contents of a 'cubedag_node_object_t' (but do not take
    ! care of other links pointing to this object).
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: obj
    logical,                      intent(inout) :: error
    !
    call obj%node%flag%final(error)
    if (error)  continue
    call obj%node%links%final(error)
    if (error)  continue
  end subroutine cubedag_node_final

end module cubedag_node_class

subroutine solve_gain(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  !     CLIC
  !     Support routine for command
  !     SOLVE GAIN [SCAN]
  !     [/output /plot /Store /Reset /Offset /Closure /Search] :
  !     Not relevant here
  !     SOLVE GAIN SCAN = reduction scan by scan; otherwise average of scans.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: last
  logical :: end, scan
  integer :: i, j, ier, qlun, k, narg
  complex :: mean_visi(2,mnant,mnrec)
  real :: mean_wisi(2,mnant,mnrec)
  complex :: mean_visi_bas(2,mnbas,mnrec)
  real :: mean_wisi_bas(2,mnbas,mnrec)
  character(len=132) :: filnam, snam
  character(len=2) :: rece(4)
  !
  integer :: mvoc1, nk, ibb, bb, isolve
  integer:: i_solve(mnbb), n_solve
  logical :: saved_bb_select, saved_if_select
  logical :: crossed, reference
  parameter (mvoc1=2)
  character(len=12) :: argum, kw, voc1(mvoc1)
  data voc1/'NOSCAN','SCAN'/
  data rece/'-1','-2','-3','-4'/
  !------------------------------------------------------------------------
  qlun = 0
  !     Code:
  save_amplitude = do_amplitude
  save_flux = do_flux
  do_amplitude = .false.
  do_flux = .false.
  do_raw = .true.
  argum = 'NOSCAN'
  last = .false.
  !
  ! Reset saved phase differences.
  do i = 1, mnant
    ph_pol_saved = 0
  enddo
  !
  call sic_ke(line,0,2,argum,narg,.false.,error)
  if (error) return
  call sic_ambigs('SOLVE GAIN',argum,kw,nk,voc1,mvoc1,error)
  if (error) return
  scan = kw.eq.'SCAN'
  !
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  !
  !     Do it for both polarization
  call get_first(.true.,error)
  if (.not.scan) then
    if (sic_present(10,0)) then
      ier = sic_getlun(qlun)
      filnam = 'gain'//rece(r_nrec)
      snam = filnam
      call sic_parsef(snam,filnam,'INTER_OBS:','.obs')
      ier = sic_open (qlun,filnam(1:lenc(filnam)),'NEW',   &
        .false.)
      if (ier.ne.0) then
        call message(6,3,'SOLVE GAIN',   &
          'Cannot open INTER_OBS:gain.obs')
        call messios(6,3,'SOLVE GAIN',ier)
        goto 999
      endif
      !            WRITE(QLUN,1005) 'DEFINE LOGICAL UPH'
      if (.not.bb_select.and..not.if_select.and..not.sic_present(5,0)) then
         write (qlun,'(a)') "You should think DROIT AU BUT"
         goto 999
       endif
      call check_scan(qlun,r_scan,'Gain')
    endif
  elseif (sic_present(10,0)) then
    call message(6,2,'SOLVE_GAIN',   &
      'No gain.obs produced with SCAN argument')
  endif
  !
  ! Save status and initialize everything
  saved_bb_select = bb_select
  saved_if_select = if_select
  all_subb = .false.
  each_subb = .false.
  !
  if (.not.sic_present(5,0)) then !!!!!!!!!!!!!
    !
    ! First derive receiver rejection per "input"
    !
    do ibb = 1, r_nbb
      bb = r_mapbb(ibb)
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = bb
      call select_bb
      call set_bb_subbands(error)
      call show_display('SUB_BANDS',.false.,error)
      do j=1,mnrec
        do i=1,mnant
          do k=1,2
            mean_visi(k,i,j) = 0.0
            mean_wisi(k,i,j) = 0.0
          enddo
        enddo
      enddo
      !
      !     Loop on current index
call get_first(.true.,error)
      if (error) goto 999
      end = .false.
      do while (.not.end)
        if (r_nsb.ne.2) then
          call message(6,3,'SOLVE_GAIN','Scan has only one sideband')
          error = .true.
          goto 999
        else
          if (r_lmode.eq.1) then
            call sub_gain(mnant,mean_visi(1,1,r_nrec),   &
              mean_wisi(1,1,r_nrec),bb, error)
            if (error) goto 999
            if (scan) then
              call sub_solve_gain(qlun,r_nrec,mean_visi,mean_wisi,   &
                bb,error)
            endif
          else
            call message(8,1,'SOLVE_GAIN','Observation is not correlation')
          endif
        endif
        !
        !     Next observation
        call get_next(end, error)
        if (error) goto 999
      enddo
      if (.not.scan) then
        if (new_receivers) then
          if (r_nsb.ne.2) then
            call message(6,3,'SOLVE_GAIN','Scan has only one sideband')      
            error = .true.
            goto 999
          else
            if (r_lmode.eq.1) then
              call sub_solve_gain(qlun,r_nrec,mean_visi,mean_wisi,   &
                 bb,error)
            endif
          endif
        else
          call sub_solve_gain(qlun,1,mean_visi,mean_wisi,bb,error)
          call sub_solve_gain(qlun,2,mean_visi,mean_wisi,bb,error)
        endif
      endif
    enddo
  endif
  !
  ! Then derive horizontal and vertical polarizations.
  !
  bb_select = saved_bb_select
  if_select = saved_if_select
  !
  if (r_nbb.lt.2) goto 998 ! No need to phase if single polar
  !
  if (bb_select) then
    call message (6,1,'SOLVE_GAIN','Solving phases per basebands')
    n_solve = r_nbb
    do isolve = 1, n_solve
      i_solve(isolve) = r_mapbb(isolve)
    enddo
  elseif (saved_if_select) then
    call message (6,1,'SOLVE_GAIN','Solving phases per IF')
    n_solve = r_nif
  else
    call message (6,4,'SOLVE_GAIN','Select either basebands or IF')
    error = .true.
    return
  endif
  do isolve = 1, n_solve
    if (bb_select) then
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = i_solve(isolve)
      call set_bb_subbands(error)
    elseif (if_select) then
      n_if = 1
      l_if(1) = 1
      i_if(1,1) = isolve
      call set_if_subbands(error)
    endif
    !
    do j=1,mnrec
      do i=1,mnant
        do k=1,2
          mean_visi(k,i,j) = 0.0
          mean_wisi(k,i,j) = 0.0
        enddo
      enddo
    enddo
    !
    !     Loop on current index
call get_first(.true.,error)
    if (error) goto 999
    end = .false.
    do while (.not.end)
      crossed = .false.
      reference = .false.
      if (all(r_polswitch(1:r_nant,1).eq.1)) then
        crossed = .true.
        call message(6,2,'SOLVE_GAIN',   &
                  'Solving for all switches crossed phases')
      else
        if (any((r_polswitch(1:r_nant,1).eq.1))) then
          reference = .true.
          call message(6,3,'SOLVE_GAIN',   &
                           'Solving for V-H phase')
      endif

      endif
      if (r_lmode.eq.1) then
        if (.not.reference) then
          call sub_gain(mnant,mean_visi(1,1,r_nrec),   &
            mean_wisi(1,1,r_nrec),1, error)
          if (error) goto 999
        else
          call sub_data(mnbas,mean_visi_bas(1,1,r_nrec),   &
            mean_wisi_bas(1,1,r_nrec),1, error)
        endif
        if (scan) then
          if (reference) then
            call sub_solve_ref(qlun,r_nrec,mean_visi_bas,mean_wisi_bas, &
                               isolve,error)
          elseif (crossed) then
            call sub_solve_cross(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
          else
            call sub_solve_pha(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
          endif
        endif
      endif
      !
      !     Next observation
      call get_next(end, error)
      if (error) goto 999
    enddo
    if (.not.scan) then
      if (r_lmode.eq.1) then
        if (reference) then
          call sub_solve_ref(qlun,r_nrec,mean_visi_bas,mean_wisi_bas, &
                             isolve,error)
        elseif (crossed) then
          call sub_solve_cross(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
        else
          call sub_solve_pha(qlun,r_nrec,mean_visi,mean_wisi,isolve,error)
        endif
      endif
    endif
  enddo
  !
998 do_raw = .false.
  do_amplitude = save_amplitude
  do_flux = save_flux
  !
  if (all_base) call set_all_baselines
  if (all_subb) call set_all_subbands
  if (each_subb) call set_each_subband
  if (all_base .or. all_subb .or. each_subb ) then   
    call set_display(error)
  endif 
  if (qlun.ne.0) then
    write(qlun,1005) '! '
    close(unit=qlun)
    call sic_frelun(qlun)
  endif
  return
999 error = .true.
  goto 998
  !
1005 format(a)
end subroutine solve_gain
!
subroutine sub_gain (m,mean_visi,mean_wisi,ibb,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !	Measure the receiver gain ratios
  !       M number of antennas
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: mean_visi(2,m)         !
  real ::    mean_wisi(2,m)         !
  integer :: ibb                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_sba.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: i, jw1, jw2, ix, iy, iband, ipol, kr, isb1, isb2, kb, kif
  integer(kind=address_length) :: data_in, ipk, ipkc,ipkl
  integer(kind=address_length) :: kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  real :: vt(4,3), wt(4,3)
  real*8 :: air_mass
  integer :: iv, imm
  ! Code:
  !
  ipol = 1 ! Dummy
  kb = 1 
  kif = 1
  if (r_nsb.eq.2) then
    isb1 = 1
    isb2 = 2
  else
    isb1 = (3-r_isb)/2 
    isb2 = isb1
  endif
  ! Two antenna case
  if (r_nant.le.2) then
    call message(6,3,'SUB_GAIN', 'At least 3 antennas required')
    error = .true.
    return
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  !
  ! Select subbands and channels to be averaged
  call check_subb(1,.true.,error)
  if (error) goto 999
  jw1 = iw1(1)
  jw2 = iw2(1)
  iy = xy_ampli                ! Amplitude
  ix = xy_time
  !
  if (do_pass) then
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) goto 999
  endif
  ! Get average record
  kin = gag_pointer(data_in, memory)
  call spectral_dump(kr,0,0)
  ipk = kin + h_offset(kr)
  call decode_header (memory(ipk))
  call set_scaling(error)
  if (error) return
  do i = 1, r_nant
    call spectral_dump(kr,i,0)
    ipkc = kin + c_offset(kr)
    ipkl = kin + l_offset(kr)
    do iband = isb1, isb2
      do iv=1,4
        do imm=1,3
          vt(iv,imm) = 0
          wt(iv,imm) = 0
        enddo
      enddo
      ! Read antenna average over subbands:
      call arecord (   &
        r_nsb, r_nband, r_nbas, r_lntch,   &
        memory(ipkc), memory(ipkl), passc, passl,   &
        i, iband,ipol,kb, kif, l_subb(1),i_subb(1,1),jw1,jw2,ix,iy,   &
        vt,wt,.false.,error)
      if (error) goto 999
      if (wt(2,2).gt.0) then
        mean_wisi(iband,i) = mean_wisi(iband,i) + wt(2,2)
        ! Correct for differential atmospheric absorption
        ! signal band:
        if (r_sb(ibb) .eq. 3-2*iband) then
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taus(1,ibb)) * air_mass(r_el))
        ! image band:
        else
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taui(1,ibb)) * air_mass(r_el))
        endif
      endif
    enddo
  enddo
  return
  !
999 error = .true.
  return
  !
end subroutine sub_gain
!
subroutine sub_data (m,mean_visi,mean_wisi,ibb,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !	Load data in buffer for baseline based phase determination
  !       M number of antennas
  !---------------------------------------------------------------------
  integer :: m                      !
  complex :: mean_visi(2,m)         !
  real ::    mean_wisi(2,m)         !
  integer :: ibb                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_sba.inc'
  include 'clic_clic.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: i, jw1, jw2, ix, iy, iband, ipol, kr, isb1, isb2, kb, kif
  integer(kind=address_length) :: data_in, ipk, ipkc,ipkl
  integer(kind=address_length) :: kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  real :: vt(4,3), wt(4,3)
  real*8 :: air_mass
  integer :: iv, imm
  ! Code:
  !
  ipol = 1 ! Dummy
  kb = 1 
  kif = 1
  if (r_nsb.eq.2) then
    isb1 = 1
    isb2 = 2
  else
    isb1 = (3-r_isb)/2 
    isb2 = isb1
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) goto 999
  !
  ! Select subbands and channels to be averaged
  call check_subb(1,.true.,error)
  if (error) goto 999
  jw1 = iw1(1)
  jw2 = iw2(1)
  iy = xy_ampli                ! Amplitude
  ix = xy_time
  !
  if (do_pass) then
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) goto 999
  endif
  ! Get average record
  kin = gag_pointer(data_in, memory)
  call spectral_dump(kr,0,0)
  ipk = kin + h_offset(kr)
  call decode_header (memory(ipk))
  call set_scaling(error)
  if (error) return
  do i = 1, r_nbas
    call spectral_dump(kr,0,i)
    ipkc = kin + c_offset(kr)
    ipkl = kin + l_offset(kr)
    do iband = isb1, isb2
      do iv=1,4
        do imm=1,3
          vt(iv,imm) = 0
          wt(iv,imm) = 0
        enddo
      enddo
      ! Read antenna average over subbands:
      call brecord (   &
        r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
        memory(ipkc), memory(ipkl), passc, passl,   &
        i, iband,ipol,kb, kif, l_subb(1),i_subb(1,1),jw1,jw2,ix,iy,   &
        vt,wt,error)
      if (error) goto 999
      if (wt(2,2).gt.0) then
        mean_wisi(iband,i) = mean_wisi(iband,i) + wt(2,2)
        ! Correct for differential atmospheric absorption
        ! signal band:
        if (r_sb(ibb) .eq. 3-2*iband) then
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taus(1,ibb)) * air_mass(r_el))
        ! image band:
        else
          mean_visi(iband,i) = mean_visi(iband,i)   &
            + cmplx(vt(3,2),vt(4,2))   &
            * exp((r_taui(1,ibb)) * air_mass(r_el))
        endif
      endif
    enddo
  enddo
  return
  !
999 error = .true.
  return
  !
end subroutine sub_data
!
subroutine sub_solve_pha(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, ig, im
  complex :: av(2)
  real :: ph_pol(mnant), faz
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(ig,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    do i=1, r_nant
      if (ok(i)) then
        if (bb_select) then
          if (i.ne.ref_ant) then
            write(qlun,1009)backslash, ph_pol(i), r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          else
            write(qlun,1009)backslash, 0.0, r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          endif
        elseif (if_select) then
          if (i.ne.ref_ant) then
            write(qlun,1010)backslash, ph_pol(i), r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          else
            write(qlun,1010)backslash, 0.0, r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          endif
        endif
      endif
    enddo
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /BASEBAND ',a)
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /IF ',a)
end subroutine sub_solve_pha
!
subroutine sub_solve_cross(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, ig, im
  complex :: av(2)
  real :: ph_pol(mnant), faz
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(ig,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    do i=1, r_nant
      if (ok(i)) then
        if (bb_select) then
          if (i.ne.ref_ant) then
            write(qlun,1009)backslash, ph_pol(i), r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          else
            write(qlun,1009)backslash, 0.0, r_kant(i),ir,   &
              r_bbname(i_baseband(1,1))
          endif
        elseif (if_select) then
          if (i.ne.ref_ant) then
            write(qlun,1010)backslash, ph_pol(i), r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          else
            write(qlun,1010)backslash, 0.0, r_kant(i),ir,   &
              r_ifname(i_if(1,1))
          endif
        endif
      endif
    enddo
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /BASEBAND ',a,'/CROSSED')
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /ANTENNA ',i0,' /RECEIVER ',i1,' /IF ',a,'/CROSSED')
end subroutine sub_solve_cross
!
subroutine sub_solve_ref(qlun, ir, mean_visi, mean_wisi, ibb, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnbas,mnrec)  !
  real    :: mean_wisi(2,mnbas,mnrec)  !
  integer :: ibb                       !
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: ok(mnbas), do_rec
  integer :: i, ig, im, ia, ja, k
  complex :: av(2)
  real :: ph_pol(mnbas), faz, ph_ref
  character(len=132) :: ch
  character(len=1) :: backslash
  character(len=1) :: pol(2)
  data pol/'H','V'/
  !-----------------------------------------------------------------------
  ph_pol = 0 
  backslash=char(92)
  av(1) = 1.0
  av(2) = 1.0
  if (r_sb(ibb).eq.1) then
    ig = 1                     ! Upper sideband
    im = 2
  else
    ig = 2                     ! Lower sideband
    im = 1
  endif
  !
  do_rec  = .false.
  do i=1, r_nbas
    ia = r_iant(i)
    ja = r_jant(i)
    ok(i) = mean_wisi(ig,i,ir).gt.0.and.(r_polswitch(ia,1).ne.r_polswitch(ja,1))
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nbas
    if (ok(i)) then
      mean_visi(ig,i,ir) = mean_visi(ig,i,ir)/mean_wisi(ig,i,ir)
      !
      ! Mean phase for polarization phasing
      ph_pol(i) = faz(mean_visi(ig,i,ir))*180/pi
      ph_pol(i) = mod(ph_pol(i)+540.,360.)-180
    else
      write(ch,'(a,i0)') 'Ignoring baseline ',i
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
  enddo
  !
  ! Deal with Phases
  if (qlun.ne.0) then
    ph_ref = 0
    k = 0
    do i=1, r_nbas
      if (ok(i)) then
        ph_ref = ph_ref + ph_pol(i)
        k = k+1
      endif
    enddo
    if (k.gt.0) then
      write(ch,'(a,i0,a)') 'Averaging ',k,' baselines'
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
      ph_ref = ph_ref/k
    else
      write(ch,'(a,i0,a)') 'Found no valid baseline'
      call message(6,3,'SOLVE_GAIN',ch(1:lenc(ch)))
      return
    endif
    if (bb_select) then
      write(qlun,1009)backslash, ph_ref, ir,   &
            r_bbname(i_baseband(1,1))
    elseif (if_select) then
      write(qlun,1010)backslash, ph_ref, ir,   &
            r_ifname(i_if(1,1))
    endif    
  endif
  return
1009 format('  SET',a1,'PHASE BASEBAND ',f6.1,   &
    ' /RECEIVER ',i1,' /BASEBAND ',a,'/REFERENCE')
1010 format('  SET',a1,'PHASE POL ',f6.1,   &
    ' /RECEIVER ',i1,' /IF ',a,'/REFERENCE')
end subroutine sub_solve_ref
!
subroutine sub_solve_gain(qlun, ir, mean_visi, mean_wisi, bb,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  include 'clic_parameter.inc'
  integer :: qlun                      !
  integer :: ir                        !
  complex :: mean_visi(2,mnant,mnrec)  !
  real    :: mean_wisi(2,mnant,mnrec)  !
  integer :: bb
  logical :: error                     !
  ! Global
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_display.inc'
  ! Local
  logical :: ok(mnant), do_rec
  integer :: i, inp
  integer(kind=index_length) :: dim(2)
  complex :: av(2), ratio
  real :: wratio
  real :: solved_gain_1(mnant), solved_gain_1_err(mnant)
  real :: solved_gain_2(mnant), solved_gain_2_err(mnant)
  real :: solved_gain_3(mnant), solved_gain_3_err(mnant)
  real :: solved_gain_4(mnant), solved_gain_4_err(mnant)
  real :: solved_gain_5(mnant), solved_gain_5_err(mnant)
  real :: solved_gain_6(mnant), solved_gain_6_err(mnant)
  real,save :: solved_gain(mnant,mnbb), solved_gain_err(mnant,mnbb)
  character(len=132) :: ch
  logical, save :: sic_variable_defined = .false.
  !-----------------------------------------------------------------------
  error = .false.
  if (.not.sic_variable_defined) then
    dim(1) = mnant
    dim(2) = mnbb
    call sic_def_real ('SOLVED_GAIN',solved_gain,2,dim,   &
      .false.,error)
    sic_variable_defined = .true.
  endif
  av(1) = 1.0
  av(2) = 1.0
  !
  ! Deal with Side band ratios
  do_rec  = .false.
  do i=1, r_nant
    ok(i) = mean_wisi(1,i,ir).gt.0.and.mean_wisi(2,i,ir).gt.0
    do_rec = do_rec .or. ok(i)
  enddo
  if (.not. do_rec) return
  !
  do i=1, r_nant
    if (ok(i)) then
      mean_visi(1,i,ir) = mean_visi(1,i,ir)/mean_wisi(1,i,ir)
      mean_visi(2,i,ir) = mean_visi(2,i,ir)/mean_wisi(2,i,ir)
      !
      ! Compute ratio (=4): (AV here is set to 1)
      call mixband(4,r_sb(bb),mean_visi(1,i,ir),   &
        mean_wisi(1,i,ir),av,ratio,wratio)
      !
      write (ch,1004) ir,r_kant(i),abs(ratio),0.001/sqrt(wratio)
1004  format('R',i1,' A',i0,' I/S = ',f6.3,' +- ',f5.3)
      call message(6,1,'SOLVE_GAIN',ch(1:lenc(ch)))
      !
      ! Output values of gain
      inp = bb
      if (qlun.ne.0) then
        if (new_receivers) then
          write(qlun,1002) max(0.001,abs(ratio)) ,r_kant(i),   &
            ir,r_bbname(inp),0.001/sqrt(wratio)
        else
           write(qlun,1001) max(0.001,abs(ratio)) ,r_kant(i),   &
            ir,0.001/sqrt(wratio)
        endif
      endif
    else
      write(ch,'(a,i0,a,i1)') 'No signal for antenna ',   &
        r_kant(i),' rec. ',ir
      call message(6,2,'SOLVE_GAIN',ch(1:lenc(ch)))
    endif
    solved_gain(i,inp) = max(0.001,abs(ratio))
    solved_gain_err(i,inp) = 0.001/sqrt(wratio)
    if (inp.eq.1) then
      solved_gain_1(i) = max(0.001,abs(ratio))
      solved_gain_1_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.2) then
      solved_gain_2(i) = max(0.001,abs(ratio))
      solved_gain_2_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.3) then
      solved_gain_3(i) = max(0.001,abs(ratio))
      solved_gain_3_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.4) then
      solved_gain_4(i) = max(0.001,abs(ratio))
      solved_gain_4_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.5) then
      solved_gain_5(i) = max(0.001,abs(ratio))
      solved_gain_5_err(i) = 0.001/sqrt(wratio)
    elseif (inp.eq.6) then
      solved_gain_6(i) = max(0.001,abs(ratio))
      solved_gain_6_err(i) = 0.001/sqrt(wratio)
    endif
  enddo
  if (inp.eq.1) then
    call sic_delvariable ('SOLVED_GAIN_1',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_1_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_1',solved_gain_1,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_1_ERR',solved_gain_1_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.2) then
    call sic_delvariable ('SOLVED_GAIN_2',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_2_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_2',solved_gain_2,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_2_ERR',solved_gain_2_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.3) then
    call sic_delvariable ('SOLVED_GAIN_3',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_3_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_3',solved_gain_3,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_3_ERR',solved_gain_3_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.4) then
    call sic_delvariable ('SOLVED_GAIN_4',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_4_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_4',solved_gain_4,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_4_ERR',solved_gain_4_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.5) then
    call sic_delvariable ('SOLVED_GAIN_5',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_5_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_5',solved_gain_5,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_5_ERR',solved_gain_5_err,1,dim,   &
      .false.,error)
    error = .false.
  elseif (inp.eq.6) then
    call sic_delvariable ('SOLVED_GAIN_6',.false.,error)
    error = .false.
    call sic_delvariable ('SOLVED_GAIN_6_ERR',.false.,error)
    error = .false.
    dim = r_nant
    call sic_def_real ('SOLVED_GAIN_6',solved_gain_6,1,dim,   &
      .false.,error)
    call sic_def_real ('SOLVED_GAIN_6_ERR',solved_gain_6_err,1,dim,   &
      .false.,error)
    error = .false.
  endif
  return
1001 format('SET GAIN ',f6.3,' /ANTENNA ',i0,   &
    ' /RECEIVER ',i1,'     ! +/- ',f5.3)
1002 format('SET GAIN ',f6.3,' /ANTENNA ',i0,   &
    ' /RECEIVER ',i1,' /BASEBAND ',a,'     ! +/- ',f5.3)
end subroutine sub_solve_gain

program field_stat
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  ! 	Compute statistics on a number of fields for an input 3-D
  ! 	image, and a label image
  ! 	Results : a Table with the average spectra for each field if
  ! 	the input is 3-D.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey,namet
  logical :: error
  integer :: nfields, ier
  type(gildas) :: x,y,z
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_char('T_NAME$',namet)
  call gildas_inte('FIELD$',nfields,1)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error, rank=3)
  if (error) then
    call gagout('F-FIELD_STAT,  Cannot read input file')
    goto 100
  endif
  !
  ! Read label image
  call gildas_null(x)
  ! Check rank
  call gdf_read_gildas(x,namex,'.gdf',error, rank=-2) 
  if (error)  goto 100
  !
  ! Check image consistency
  if (x%gil%dim(1).ne.y%gil%dim(1) .or. x%gil%dim(2).ne.y%gil%dim(2)) then
    call gagout('E-FIELD_STAT,  '   &
     &      //'Label image and data cube are not coincident')
    goto 100
  endif
  !
  ! Create output table
  call gildas_null(z, type = 'TABLE' ) 
  call sic_parsef(namet,z%file,' ','.tab')
  z%gil%dim(1) = y%gil%dim(3)
  z%gil%dim(2) = nfields*2+1
  allocate (z%r2d(z%gil%dim(1), z%gil%dim(2)), stat=ier)
  z%r2d = 0.0
  !
  call field003(y%r3d,                       & ! Input Cube
                y%gil%dim(1),y%gil%dim(2),y%gil%dim(3),   &  ! Cube dimensions
                x%r2d,                       &  ! Label
                y%gil%bval,y%gil%eval,       &  ! Blanking values
                z%r2d,                       &  ! Output Table
                z%gil%dim(1),z%gil%dim(2),   &
                nfields,                     &  ! Number of fields found
                ier)
  if (nfields.eq.0) then
    call gagout('W-FIELD,  No field found')
  elseif (nfields.eq.1) then
    call gagout('I-FIELD_STAT,  Found 1 field in image')
  else
    write(namex,'(A,I0,A)') 'I-FIELD_STAT,  Found ',nfields,' fields in image'
    call gagout(namex)
  endif
  if (ier.ne.0) call gagout('W-FIELD_STAT,  Too many fields')
  !
  call field004(z%r2d,z%gil%dim(1),y%gil%inc(3),y%gil%val(3),y%gil%ref(3))
  !
  ! Now create the output table
  call gdf_create_image(z,error)
  if (error) then
    call gagout('F-FIELD_STAT,  Cannot create output table')
    goto 100
  endif
  call gdf_write_data (z,z%r2d,error)
  if (error)  continue
  call gdf_close_image(z,error)
  if (error)  continue
  call sysexi(1)
  !
100 call sysexi (fatale)
end program field_stat
!
subroutine field003(z,nx,ny,nz,y,bval,eval,t,nl,nc,nfields,ier)
  use gildas_def
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  integer(kind=index_length) :: nz                     !
  integer(kind=index_length) :: nl                     !
  integer(kind=index_length) :: nc                     !
  real :: z(nx,ny,nz)               !
  real :: y(nx,ny)                  !
  real :: bval                      !
  real :: eval                      !
  real :: t(nl,nc)                  !
  integer :: nfields                !
  integer :: ier                    !
  ! Local
  integer :: i,j,k,label
  real :: value
  !
  ier = 0
  nfields = 0
  do k = 1,nz
    do j = 1,ny
      do i = 1,nx
        label = y(i,j)
        if (2*label+1.gt.nc) then
          ier = 1
        elseif (label.ne.0) then
          value = z(i,j,k)
          if (abs(value-bval).gt.eval) then
            t(k,2*label) = t(k,2*label)+1
            t(k,2*label+1) = t(k,2*label+1)+value
          endif
        endif
        nfields = max(nfields,label)
      enddo
    enddo
  enddo
end subroutine field003
!
subroutine field004(t,nl,xinc,xval,xref)
  use gildas_def
  integer(kind=index_length) :: nl   !
  real :: t(nl)                      !
  real(8) :: xinc                    !
  real(8) :: xval                    !
  real(8) :: xref                    !
  ! Local
  integer :: i
  !
  do i =1,nl
    t(i) = (i-xref)*xinc+xval
  enddo
end subroutine field004

  	subroutine curfit (y,npts,nterms,a,sigmaa,flambda,
     1 yfit,chisqr,eps,itmax,x,conv,weight,ipt,s0,wsum)
c
c assymmetric parabola in chi-square to keep fit below image
c
	common /termpointer/ lista,peak,cent,wid
	dimension lista(11),cent(3),wid(3)
	real*4 peak
      dimension y(1),a(11),sigmaa(11),yfit(1),x(3,1)
      dimension alpha(11,11),beta(11),deriv(11)
     1,b(11)
	real*4 tau(11)
	real*4 weight(1)
	integer ipt(1)
      real*8 array(11,11),det
	logical conv,bigger
	integer termou
	dimension s0(3)
	data tau /3*0.,0.003,2*1.e-2,1.,2*10.,.1,1./
	data termou/2/

	tau(8)=sqrt(wid(1))
	tau(9)=sqrt(wid(2))
	tau(10)=sqrt(wid(3))

	conv=.true.
  	chisqr=0.
      free=wsum-float(nterms)
      if(free) 110,110,20
c
c
20	s00=s0(1)
	sm=s0(2)/2.*free
	sc=s0(3)/2.*free
c	
      iter = 0
      fnu = 10.
      go to 34
c
c     test for convergence
c
   31 continue
	ddel=abs(a(1)-a(2))*(a(1)+a(2))/
     &       (wid(1)+wid(2)+0.5*(a(1)+a(2))**2)
	do 32 i=1,nterms
	 li=lista(i)
         del = abs(a(li)-b(li))
	if (li.le.3) then
	 del = del/abs(a(li)) / (1.+wid(li)/a(li)**2)
	else if (li.eq.4) then
	 del = del/(tau(li)+abs(a(li)))*ddel
	else if (li.eq.7 .or. li.eq.11) then
	 del = 2.*abs(a(li))*del/(1.+a(li)**2)
	else
         del = del/(tau(li)+abs(a(li)))
	endif
   32    if(del.gt.eps)iflag = 1
      if(iflag.eq.0)go to 101
      iflag = 0
      iter = iter + 1
      if(iter.gt.itmax)go to 101
      flambda=flambda/fnu
      do 33 j = 1,11
   33    a(j) = b(j)
c
c    evaluate alpha and beta matrices.
c
   34 continue
	do 35 j=1,nterms
	lj=lista(j)
	if (lj.eq.11) then
	  beta(j)=4.*sm*(peak-a(11)**2-a(7)**2)*a(11)
	else if (lj.eq.7) then
	  beta(j)=4.*sm*(peak-a(11)**2-a(7)**2)*a(7)
	else if(lj.ge.8) then
	  beta(j)=2.*sc*4.*(cent(lj-7)-a(lj))/wid(lj-7)
	else
          beta(j) = 0.
	endif
       do 35 k=1,j
	lk=lista(k)
	if ( (lk.eq.11 .or. lk.eq.7) .and. 
     &       (lj.eq.11 .or. lj.eq.7) ) then
	  alpha(j,k)=8.*sm*a(lk)*a(lj)
	else if (lk.ge.8 .and. lj.eq.lk) then
	  alpha(j,k)=2.*4.*sc/wid(lj-7)
	else
          alpha(j,k) = 0.
	endif
   35 continue
	call quadini (a)
      do 50 i=1,npts
      ix = ipt(i)
      call fderiv (ix,a,deriv,x,nterms,fff)
	yfit(ix)=fff
      res = (y(ix)-yfit(ix))
	rr=1.
	if (res.le.0.) rr=1.+s00
      do 46 j=1,nterms
	lj=lista(j)
      beta(j)=beta(j)+deriv(lj)*(res*weight(ix)*rr)
      do 46 k=1,j
	lk=lista(k)
   46 alpha(j,k)=
     &    alpha(j,k)+deriv(lj)*deriv(lk)*(weight(ix)*rr)
   50 continue
      do 53 j=1,nterms
      do 53 k=1,j
   53 alpha(k,j)=alpha(j,k)
c
c     evaluate chi square at starting point.
c
	if (chisqr.eq.0.) then
	  chisq1=
     &   fchisq(y,npts,free,yfit,weight,ipt,1.e30,bigger,s0,a)
	else
	      chisq1=chisqr
	endif
	write (termou,'(1x,a,1p,8g9.2)') 
     &    'chisqr ',chisq1,a(1),a(2),a(4),a(3),a(5),a(6)
c
c     invert modified curvature matrix to find new parameters.
c
      int = 0
   71 int = int + 1
ccc	if (flambda.gt.2390.) goto 116
      if(int-25)72,116,116
   72 do 74 j=1,nterms
      do 73 k=1,nterms
      if(alpha(j,j)*alpha(k,k).eq.0.0)go to 116
   73 array(j,k)=alpha(j,k)/sqrt(alpha(j,j)*alpha(k,k))
   74 array(j,j)=1.+flambda
      call matinv(array,nterms,det)
	do 85 j=1,11
85	b(j)=a(j)
      do 84 j=1,nterms
      lj=lista(j)
      do 83 k=1,nterms
   83 b(lj)=b(lj)+beta(k)*array(j,k)/sqrt(alpha(j,j)*alpha(k,k))
   84 continue

	d4=b(4)-a(4)
	d4=0.6*tanh(d4/0.6)
	b(4)=a(4)+d4

	do 22 i=1,3
	dd=b(i)-a(i)
	if (dd.lt.0.) then
		dd=0.5*a(i)*tanh(dd/a(i)/0.5)
		if (a(i).le.1.e-6) dd=0.
	endif
	b(i)=a(i)+dd
22	continue

	dd=b(11)-a(11)
	if (dd.lt.0.) then
		if (a(11).le.1.e-6) then
			dd=0.
		else
			dd=0.5*a(11)*tanh(dd/a(11)/0.5)
		endif
	endif
	b(11)=a(11)+dd

	dd=b(7)-a(7)
	if (dd.lt.0.) then
		if (a(7).le.1.e-6) then
			dd=0.
		else 
			dd=0.5*a(7)*tanh(dd/a(7)/0.5)
		endif
	endif
	b(7)=a(7)+dd

c
c
c     if chi square increased, increase flambda and try again.
	call quadini(b)
      do 92 i=1,npts
      ix = ipt(i)
   92 yfit(ix)=functn(ix,b,x,nterms)
      chisqr=
     &  fchisq(y,npts,free,yfit,weight,ipt,chisq1,bigger,s0,b)
	if (.not.bigger) goto 31
96   	flambda=flambda*fnu
      go to 71
c
  101 if(iter-itmax)103,102,102
  102 write(termou,111)iter
	conv=.false.
      go to 100
  103 write(termou,112)iter
c
c     compute error matrix
c
100	continue
c
c     evaluate the standard deviations of the parameters.
c
      do 105 j=1,nterms
  105    sigmaa(lista(j))=sqrt(array(j,j)/ alpha(j,j)*chisqr)
	do 106 j=1,11
106	a(j)=b(j)
  110 return
  111 format(/1x,'W-CURFIT, not converged after ',i3,' iterations',/)
  112 format(/1x,'I-CURFIT, converged after ',i3,' iterations ',/)
  115 format(1x,'W-CURFIT, no convergence in inner loop, or zero element
     *(s) in curvature matrix       =>bad initial guesses.')
  116 write(termou,115)
	write (termou,*) ' int ',int,' flambda ',flambda
	write (termou,*) ' a ',a
	write (termou,*) ' b ',b
	conv=.false.
      go to 110
	end
c       
 	subroutine matinv(array,norder,det)
	dimension array(11,11),ik(11),jk(11)
        real*8 array,amax,save,det
	det=1.0
	do 100 k=1,norder
c
c	find largest element in array
c 
	   amax=0.0
   21	   do 30 i=k,norder
		do 30 j=k,norder
		if(abs(amax)-abs(array(i,j)))24,24,30
   24           amax=array(i,j)
	        ik(k)=i
		jk(k)=j
   30      continue
c 
c	interchange rows and columns to put amax in array(k,k)
c
	   if(amax)41,32,41
   32      det=0.0
	   go to 140
   41      i=ik(k)
	   if(i-k)21,51,43
   43	   do 50 j=1,norder
	      save=array(k,j)
	      array(k,j)=array(i,j)
   50	   array(i,j)=-save
   51	   j=jk(k)
	   if(j-k)21,61,53
   53	   do 60 i=1,norder
	      save=array(i,k)
	      array(i,k)=array(i,j)
   60	   array(i,j)=-save
c
c	accumulate elements of inverse matrix
c
   61	   do 70 i=1,norder
	      if(i-k)63,70,63
   63	      array(i,k)=-array(i,k)/amax
   70	   continue
	   do 80 i=1,norder
	      do 80 j=1,norder
	         if(i-k)74,80,74
   74	         if(j-k)75,80,75
   75	         array(i,j)=array(i,j)+array(i,k)*array(k,j)
   80	   continue
	   do 90 j=1,norder
	      if(j-k)83,90,83
   83	      array(k,j)=array(k,j)/amax
   90	   continue
	   array(k,k)=1.0/amax
  100	det=det*amax
c
c	restore ordering of matrix
c
	do 130 l=1,norder
	   k=norder-l+1
	   j=ik(k)
	   if(j-k)111,111,105
  105	   do 110 i=1,norder
	      save=array(i,k)
	      array(i,k)=-array(i,j)
  110	   array(i,j)=save
  111	   i=jk(k)
	   if(i-k)130,130,113
  113	   do 120 j=1,norder
	      save=array(k,j)
	      array(k,j)=-array(i,j)
  120	   array(i,j)=save
  130	continue
  140	return
	end

	function 
     &   fchisq (y,npts,free,yfit,weight,ipt,chiold,bigger,s0,a)
	common /termpointer/ lista,peak,cent,wid
	dimension lista(11),cent(3),wid(3)
	real*4 peak
	dimension a(11)
	dimension y(1), yfit(1), weight(1), ipt(1)
	logical bigger
	dimension s0(3)
	bigger=.false.
	old=chiold
	chisq = 0.
	fchisq = 0.
	if (free) 13, 13, 20
13	fchisq = 0.
	goto 40
c
c	accumulate chi square
c
20	continue
	s00=s0(1)
	chisq=s0(2)*(peak-a(11)**2-a(7)**2)**2
	do 21 i=1,3
21	chisq=chisq+s0(3)*4.*(cent(i)-a(7+i))**2/wid(i)
	do 30 i=1,npts
	ip=ipt(i)
	res=y(ip)-yfit(ip)
	rr=1.
	if (res.le.0.) rr=1.+s00
	chisq=chisq+res**2*weight(ip)/free*rr
	if (chisq.gt.old) then
		bigger=.true.
		goto 40
	endif
30	continue
c
c	divide by number of degrees of freedom
c
32	fchisq = chisq
40	return
	end

subroutine sub_alma (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_alma
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout)  :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout)  :: l_hclean
  type (gildas), intent(inout)  :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout)  :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_weight(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_weight(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable, target :: sc_beam(:,:,:)
  real, allocatable :: w_resid(:,:)
  !
  character(len=*), parameter :: rname='SUB_ALMA'
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc,kx,ky
  integer ip, ier
  real l_max, c_max
  logical do_fft, ok
  character(len=80) :: chain
  character(len=2) ans
  integer nker,mker
  parameter (mker=11)
  real smooth
  real, allocatable :: kernel(:,:),kernels(:,:,:)
  real noise,value,scale,fhat,long,compact
  !
  error = .false.
  do_fft = .true.
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),r_work(nx,ny),c_work(mx,my), &
       & w_fft(max(nx,ny)),w_comp(nc), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ALMA arrays')
    error = .true.
    return
  endif
  !
  ! Smoothed version of the Compact images
  allocate (sc_beam(mx,my,mp),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on ACA arrays')
    error = .true.
    return
  endif
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on residuals')
    error = .true.
    return
  endif
   !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_weight=> l_method%weight(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d       ! To begin with
  c_weight=> c_method%weight(:,:,1)
  !
  ! Relative noise contributions
  long = l_hdirty%gil%noise**2
  compact = c_hdirty%gil%noise**2
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  if (smooth.eq.0) then
     nker = 1
  else
     nker = mker
  endif
  allocate (kernels(nker,nker,mp),kernel(nker,nker),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error on Kernels')
    error = .true.
    return
  endif
  call init_kernel(kernel,nker,nker,smooth)
  !
  ! Initialize smoothed beams
  do ip=1,mp
     call smooth_kernel (c_dbeam(:,:,ip),sc_beam(:,:,ip),   &
          &      mx,my,nker,nker,kernel)
  enddo
  !
  ! Renormalize the beams. Have some difficulty here, because the
  ! factor isn't quite the same for each primary beam...
  !
  kx = mx/2+1
  ky = my/2+1
  noise = 0.0
  do ip=1,mp
    value = 1.0/sc_beam(kx,ky,ip)
    noise = noise + value
    sc_beam(:,:,ip) = sc_beam(:,:,ip) * value
    kernels(:,:,ip) = kernel*value
  enddo
  scale = noise/float(mp)      ! Kernel scaling factor
  kernel= kernel * scale       ! Mean smoothing kernel ...
  noise = sqrt(scale*compact/long) ! Mean noise RATIO
  !!
  !!      CALL SMOOTH_MASK (SC_MASK,C_METHOD%MASK,MX,MY,KERNEL,NKER)
  !
  ! Move pointer towards the Smoothed Compact Beams
  ! This allow to perform a "normal" deconvolution with the Smoothed
  ! Compact Beam
  c_hbeam%r3d => sc_beam
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
    l_method%flux = 0.0
    c_method%flux = 0.0
    l_method%n_iter= 0
    c_method%n_iter= 0
    !
    l_method%iplane = iplane
    c_method%iplane = iplane
    call beam_plane(l_method,l_hbeam,l_hdirty)
    ibeam = l_method%ibeam
    !
    ! Local aliases
    l_dirty => l_hdirty%r3d(:,:,iplane)
    l_resid => l_hresid%r3d(:,:,iplane)
    l_clean => l_hclean%r3d(:,:,iplane)
    l_beam  => l_hbeam%r3d(:,:,ibeam)
    !
    c_dirty => c_hdirty%r3d(:,:,iplane)
    c_resid => c_hresid%r3d(:,:,iplane)
    c_clean => c_hclean%r3d(:,:,iplane)
    !
    ! Initialize to Dirty map
    l_resid = l_dirty
    !
    ! C_RESID is now the Smoothed Compact Residual
    call smooth_kernel(c_dirty,c_resid,mx,my,nker,nker,kernel)
    !NO!         CALL SMOOTH_MASKED(C_DIRTY,C_RESID,MX,MY,KERNEL,
    !!     $   NKER,C_METHOD%MASK)
    !
    ! Prepare beam parameters
    call get_clean (l_method, l_hbeam, l_beam, error)
    if (error) return
    call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
        &        l_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
        &        c_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    ! Apply the Weight
    l_resid = l_resid * l_weight
    c_resid = c_resid * c_weight
    call mrc_plot(c_weight,mx,my,1,'Weight')
    !
    ! Performs decomposition into components:
    ! Only one major cycle per iteration, with a limited number
    ! of components ?
    !
    l_method%ngoal = 1000
    c_method%ngoal = 100
    call sic_get_inte ('C_GOAL',c_method%ngoal,error)
    !
    ! Locate the maximum of the Compact & Normal images
    l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
    c_max = amaxlst (c_method,c_list,c_resid,mx,my)
    ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
    do while (ok)
      !
      ! Plot for debug
      if (l_method%pcycle) then
        call mrc_plot(c_resid,mx,my,2,'Compact')
        call mrc_plot(l_resid,nx,ny,3,'Long')
      endif
      !
      ! NOISE is the Noise RATIO (mean value over the beams)
      !
      if (l_max.gt.c_max/noise) then
        write(chain,*) 'LONG baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in LONG baseline image
        call one_cycle90 (l_method,l_hclean,   &   !
            &          l_clean,   &   ! Final CLEAN image
            &          l_dbeam,   &   ! Dirty beams
            &          l_resid,nx,ny,   & ! Residual and size
            &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
            &          w_comp, nc,         &  ! Component storage + Size
            &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
            &          l_method%patch(1),l_method%patch(2),   &
            &          l_method%bgain,l_method%box,   &
            &          w_fft,   &     ! Work space for FFTs
            &          tcc,   &       ! Component table
            &          l_list, l_method%nlist,   & ! Search list
            &          np,   &        ! Number of fields
            &          l_dprim,   &   ! Primary beams
            &          l_weight,   &  ! Weight
            &          l_max)
        !
        ! Define component type
        tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
        ! Remove from COMPACT baselines
        call remove_inother(c_method,c_resid,mx,my,   &
            &          c_tfbeam, w_fft,mp,c_dprim,c_weight,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny,   &
            &          kernel, nker)
        ! Define number of iterations
        c_method%n_iter = l_method%n_iter
        c_method%flux = l_method%flux
      else
        write (chain,*) 'COMPACT baselines ',   &
            &          l_max,c_max/noise,noise
        call gagout(chain)
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in COMPACT baseline image
        call one_cycle90 (c_method,c_hclean,   &   !
            &          c_clean,   &   ! Final CLEAN image
            &          sc_beam,   &   ! (Smoothed) Dirty beams
            &          c_resid,mx,my,          &    ! Residual and size
            &          c_tfbeam, w_work,       &    ! FT of dirty beam + Work area
            &          w_comp, nc,             &    ! Component storage + Size
            &          c_method%beam0(1),c_method%beam0(2),   &   ! Beam center
            &          c_method%patch(1),c_method%patch(2),   &   ! Patch
            &          c_method%bgain,c_method%box,   &
            &          w_fft,    &    ! Work space for FFTs
            &          tcc,      &     ! Component table
            &          c_list, c_method%nlist,   & ! Search list
            &          mp,       &    ! Number of fields
            &          c_dprim,  &    ! Primary beams
            &          c_weight, &    ! Weight
            &          c_max)
        ! Define component type
        tcc(l_method%n_iter+1:c_method%n_iter)%type = 1
        ! Remove from LONG baselines
        call remove_inother(l_method,l_resid,nx,ny,   &
            &          l_tfbeam, w_fft, np,l_dprim,l_weight,   &
            &          tcc,l_method%n_iter+1,c_method%n_iter,mx,my,   &
            &          kernel, nker)
        ! Define number of components
        l_method%n_iter = c_method%n_iter
        l_method%flux = c_method%flux
      endif
      ! Stop if done
      l_max = amaxlst (l_method,l_list,l_resid,nx,ny)
      c_max = amaxlst (c_method,c_list,c_resid,mx,my)
      ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
      if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
    enddo
    !
    ! Add clean components and residuals to produce clean map
    ! Note that the Kernel is still scaled in the same way as before
    if (l_method%n_iter.ne.0) then
      call alma_make90 (l_method, l_hclean, c_hclean,   &
           &        tcc, kernel, nker)
    else
      l_clean = 0
    endif
    !
    ! Which residual should be added ?...
    ! We don't want to add noise, but to combine it properly...
    ! We may need to go to the full combined gridding business here...
    l_clean = l_clean + l_resid * l_weight * long
    c_clean = c_resid * c_weight * compact
    call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
    l_clean = l_clean + r_work
  enddo
end subroutine sub_alma
!
function amaxlst (method,list,resid,nx,ny)
  use clean_def
  use mapping_interfaces, only : maxlst
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !-----------------------------------------------------
  real amaxlst      ! intent(out)
  type (clean_par), intent(inout) :: method
  integer, intent(in) :: nx,ny
  integer, intent(in) :: list(:)
  real, intent(in) :: resid(nx,ny)
  !
  real maxc, minc, maxabs
  integer imin,imax,jmin,jmax
  !
  call maxlst (resid,nx,ny,list,method%nlist,   &
       &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  amaxlst = maxabs
end function amaxlst
!
subroutine one_cycle90 (method,head,   &
     &    clean,beam,resid,nx,ny,tfbeam,fcomp,   &
     &    wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, work, tcc, list, nl, nf, primary, weight, maxabs)
  use clean_def
  use image_def
  use gbl_message
  use mapping_interfaces, except_this=>one_cycle90
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Major cycle loop according to B.Clark idea
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  !
  integer, intent(in) ::  nf,nx,ny,mcl,nl
  real, intent(inout) ::  clean(nx,ny)
  real, intent(inout) ::  resid(nx,ny)
  real, intent(in) ::     beam(nx,ny,nf)
  real, intent(inout) ::  tfbeam(nx,ny,nf)     ! T.F. du beam  Complex ?
  complex, intent(inout) :: fcomp(nx,ny)       ! T.F. du vecteur modification
  type(cct_par), intent(inout) ::  wcl(mcl)
  real, intent(in) ::  bgain                   ! Maximum sidelobe level
  integer, intent(in) ::  ixbeam, iybeam       ! Beam maximum position
  integer, intent(in) ::  ixpatch, iypatch     ! Beam patch radius
  integer, intent(in) ::  box(4)               ! Cleaning box
  real, intent(inout) ::  work(*)                 ! Work space for FFT
  type(cct_par), intent(inout) :: tcc(method%m_iter) ! Clean components array
  integer, intent(in) ::  list(nl)
  !
  real, intent(in) ::  primary(nf,nx,ny)       ! Primary beams
  real, intent(in) ::  weight (nx,ny)
  !
  real    maxabs               !max et min de la carte, absolute
  real    borne                !fraction de la carte initiale
  real    limite               !intensite minimum des pts retenus
  real    clarkl
  !!      REAL FLUX                          !Total clean flux density
  integer ncl                  !nb de pts reellement retenus
  logical fini                 !critere d'arret
  logical converge             ! Indique la conv par acc de flux
  integer kcl
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'CLARK'
  !
  ! Maximum residual is already located, MAXABS
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !
  ! ONE Major cycle
  !
  ! Define minor cycle limit
  limite = max(maxabs*bgain,0.8*borne)
  clarkl = maxabs*bgain
  !!      PRINT *,'Limits ',MAXABS,LIMITE,CLARKL
  !
  kcl = mcl
  !
  ! Select points of maximum strength and load them in
  call choice (   &
       &    resid,   &           ! Current residuals
       &    nx,ny,   &           ! image size
       &    list, nl,   &        ! Search list
       &    limite,   &          ! Detection threshold
       &    kcl,   &             ! Maximum number of candidates
       &    wcl,   &             ! Selected candidate components
       &    ncl,   &             ! Selected Number of components
       &    maxabs, method%ngoal)
  !
  if (ncl.gt.0) then
     write(chain,100) 'Selected ',ncl,' points above ',limite
     call map_message(seve%i,rname,chain)
     !
     ! Make minor cycles
     call minor_cycle90 (method,   &
          &      wcl,          &    ! Original candidate components
          &      ncl,          &    ! Number of candidates
          &      beam,nx,ny,   &    ! Dirty beams and Size
          &      ixbeam,iybeam,   & ! Beam center
          &      ixpatch,iypatch,   &   ! Beam patch
          &      clarkl,limite,   &
          &      converge,   &      !
          &      tcc,   &           ! Cumulated components
          &      nf, primary, weight, method%trunca,   &
          &      method%flux,   &   ! Total Flux
          &      method%pflux, next_flux90)
     !
     ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
     call remisajour (nx*ny,   &    ! Total size
          &      clean,   &         ! CLEAN map used as work space
          &      resid,   &         ! Updated residuals
          &      tfbeam,   &        ! Beam TF
          &      fcomp,   &         ! Work space for Component TF
          &      wcl,     &         ! Clean flux values
          &      ncl,   &           ! Number of Clean Components
          &      nx,ny,   &         ! Map size
          &      work,   &          ! FFT work space
          &      nf, primary, weight, method%trunca)
     write (chain,101)  'Cleaned ',method%flux,' Jy with ',   &
          &      method%n_iter,' clean components'
     call map_message(seve%i,rname,chain)
  else
     ! No component found: finish...
     write(chain,101) 'No points selected above ',limite
     call map_message(seve%i,rname,chain)
  endif
  write(chain,102)  'CLEAN found ',method%flux,' Jy in ',   &
       &    method%n_iter,' clean components'
  call map_message(seve%i,'CLEAN',chain)
  !
100 format (a,i6,a,1pg10.3,a)
101 format (a,1pg10.3,a,i7,a)
102 format (a,1pg10.3,a,i7,a)
end subroutine one_cycle90
!
subroutine remove_inother(method,resid,nx,ny,tfbeam,wfft,   &
     &    np,primary,weight,   &
     &    tcc,first,last,mx,my,kernel,nker)
  use clean_def
  use gkernel_interfaces, only : fourt
  use mapping_interfaces, except_this=>remove_inother
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for ALMA deconvolution
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  !
  integer, intent(in) ::  np,nx,ny,mx,my,nker,first,last
  real, intent(inout) ::  resid(nx,ny)
  real, intent(inout) ::  tfbeam(nx,ny,np)     ! T.F. du beam  Complex ?
  real, intent(in) :: primary(np,nx,ny)
  real, intent(in) :: weight(nx,ny)
  real, intent(inout) :: kernel(nker,nker)
  real, intent(inout) :: wfft(*)
  type(cct_par), intent(inout) :: tcc(last)
  !
  complex, allocatable :: icomp(:,:), ocomp(:,:)
  real, allocatable :: clean(:,:), prim(:,:), sky(:,:)
  real, allocatable :: ricomp(:,:),rocomp(:,:)
  real wtrun,val,fact
  integer k,ndim,nn(2),ip,ix,iy,ier
  integer jx,jy,xfact,yfact,firstx,lastx,firsty,lasty
  logical comp
  character(len=2) :: ans
  !
  wtrun = method%trunca
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  allocate (ocomp(nx,ny),stat=ier)
  allocate (icomp(mx,my),stat=ier)
  allocate (clean(nx,ny),stat=ier)
  allocate (ricomp(mx,my),stat=ier)
  allocate (rocomp(nx,ny),stat=ier)
  allocate (sky(nx,ny),stat=ier)
  allocate (prim(nx,ny),stat=ier)
  !
  comp = mx.gt.nx
  fact = float(mx*my)/float(nx*ny)
  xfact = nx/mx
  yfact = ny/my
  !
  ! Optimized by using CLEAN to store sum of components before multiplying
  ! by the weights to subtract from the Residuals
  clean = 0.0
  ricomp = 0.0
  do k=first,last
    ix = tcc(k)%ix
    iy = tcc(k)%iy
    val = tcc(k)%value * fact
    if (tcc(k)%type.eq.0) then
      ricomp(ix,iy) = ricomp(ix,iy) + val
    else
      call add_kernel (ricomp,mx,my,val,ix,iy,nker,nker,kernel)
    endif
  enddo
  !
  ! Add compression and/or expansion
  if (comp) then
    call compress(mx,my,ricomp,icomp,nx,ny,rocomp,ocomp,wfft)
  else
    !
    ! Expand by XFACT & YFACT
    rocomp = 0.0
    do k=first,last
      ix = tcc(k)%ix
      iy = tcc(k)%iy
      val = tcc(k)%value * fact
      lastx = xfact*ix
      lasty = yfact*iy
      firstx = lastx-xfact+1
      firsty = lasty-yfact+1
      do jy=firsty,lasty
        do jx=firstx,lastx
          rocomp(jx,jy) = rocomp(jx,jy)+val
        enddo
      enddo
      !!            CALL ADD_KERNEL (RICOMP,MX,MY,VAL,IX,IY,KERNEL,NKER)
    enddo
  endif
  sky = rocomp
  if (method%pcycle) then
    call mrc_plot(weight,nx,ny,1,'Weight')
    call mrc_plot(resid,nx,ny,2,'Resid')
    call mrc_plot(sky,nx,ny,3,'Sky')
    !         if (method%qcycle) call sic_wpr('Continue',ans)
  endif
  !
  ! Loop on the fields
  do ip=np,1,-1
    prim = primary(ip,:,:)
    if (method%pcycle) call mrc_plot(prim,nx,ny,1,'Primary')
    !
    ! Multiply by Complete Primary beam...
    rocomp = sky*prim
    !
    ! Convolve with dirty beam
    ocomp = cmplx(rocomp,0.0)
    call fourt(ocomp,nn,ndim,-1,0,wfft)
    rocomp = tfbeam(:,:,ip)
    ocomp = ocomp*rocomp
    call fourt(ocomp,nn,ndim,1,1,wfft)
    rocomp = real(ocomp)
    !
    ! Multiply by Truncated Primary beam now
    where (prim.lt.wtrun)
      prim = 0
    end where
    rocomp = rocomp*prim
    if (method%pcycle) call mrc_plot(rocomp,nx,ny,3,'Comp...')
    clean(:,:) = clean + rocomp
  enddo
  if (method%pcycle) then
    !         if (method%qcycle) call sic_wpr('Continue',ans)
    call mrc_plot(clean,nx,ny,3,'Clean')
    call mrc_plot(resid,nx,ny,1,'Residu')
  endif
  resid(:,:) = resid - clean*weight
end subroutine remove_inother
!
subroutine add_primker (clean,nx,ny,np,prim,value,kx,ky,kp,ker,nk)
  !-----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Smooth an array using a kernel, with Primary Beams
  !   For ALMA deconvolution
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx,ny,np             ! Image size
  real, intent(in) :: value                   ! Input value
  real, intent(inout) :: clean(nx,ny)         ! Summed output array
  real, intent(in) :: prim(np,nx,ny)
  integer, intent(in) :: kp                   ! Field
  integer, intent(in) :: kx,ky                ! Center of value
  integer, intent(in) :: nk                   ! Kernel size
  real, intent(in) :: ker(nk,nk)
  !
  integer i,j,lk,li,lj
  !
  if (nk.eq.1) then
    clean(kx,ky) = clean(kx,ky) + prim(kp,kx,ky)*value
  else
    lk = (nk-1)/2
    do j=ky-lk,ky+lk
      lj = j-ky+lk+1
      do i=kx-lk,kx+lk
        li = i-kx+lk+1
        clean(i,j) = clean(i,j) + prim(kp,i,j) *   &
              &          ker (li,lj) * value
      enddo
    enddo
  endif
end subroutine add_primker
!
subroutine alma_make90 (method, l_hclean, c_hclean,   &
     &    tcc, kernel,nker)
  use gkernel_interfaces, only : fourt
  use clean_def
  use image_def
  use mapping_gaussian_tool
  !-------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Make clean map
  !-------------------------------------------------------------
  integer, intent(in) :: nker
  real, intent(in) :: kernel(nker,nker)
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: l_hclean, c_hclean
  type (cct_par), intent(in) :: tcc(method%n_iter)
  !
  real(8), parameter :: pi=3.141592653589793d0
  integer nx,ny,ix,iy,ic,ndim,nn(2),ier, iplane,mx,my
  real xinc, yinc,fact,val
  real, pointer :: l_clean(:,:), c_clean(:,:)
  real, allocatable :: wfft(:)
  complex, allocatable :: fcomp(:,:), c_work(:,:)
  !
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  mx = c_hclean%gil%dim(1)
  my = c_hclean%gil%dim(2)
  iplane = method%iplane
  l_clean => l_hclean%r3d(:,:,iplane)
  c_clean => c_hclean%r3d(:,:,iplane)
  !
  allocate (wfft(2*max(nx,ny)),stat=ier)
  allocate (fcomp(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  xinc = l_hclean%gil%convert(3,1)
  yinc = l_hclean%gil%convert(3,2)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  ! First pass for Compact Baselines
  c_clean = 0.0
  fact = float(nx*ny)/float(mx*my)
  do ic=1,method%n_iter
    if (tcc(ic)%type.ne.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value * fact
      call add_kernel (c_clean,mx,my,val,ix,iy,   &
           &        nker,nker,kernel)
    endif
  enddo
  !
  ! Expand the Compact Clean Components
  call expand (nx,ny,l_clean,fcomp,mx,my,c_clean,c_work,wfft)
  !
  ! Add the Long Baseline components
  do ic=1,method%n_iter
    if (tcc(ic)%type.eq.0) then
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      val = tcc(ic)%value
      l_clean(ix,iy) = l_clean(ix,iy) + val
    endif
  enddo
  !
  ! Convolve by Gaussian
  fcomp = cmplx(l_clean,0.0)
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fact = method%major*method%minor*pi/(4.0*log(2.0))   &
       &    /abs(xinc*yinc)/(nx*ny)
  call mulgau(fcomp,nx,ny,   &
       &    method%major,method%minor,method%angle,   &
       &    fact,xinc,yinc)
  call fourt(fcomp,nn,ndim,1,1,wfft)
  l_clean = real(fcomp)
end subroutine alma_make90

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_timing
  use cubetools_structure
  use cubesyntax_key_types
  use cubetools_switch_types
  use cubeset_messaging
  !
  public :: timing
  private
  !
  type :: timing_comm_t
     type(option_t), pointer :: comm
     type(switch_comm_t) :: io
     type(switch_comm_t) :: execution
     type(key_comm_t)    :: default
   contains
     procedure, public  :: register => cubeset_timing_register
     procedure, private :: parse    => cubeset_timing_parse
     procedure, private :: main     => cubeset_timing_main
  end type timing_comm_t
  type(timing_comm_t) :: timing
  !
  type :: timing_user_t
     logical :: list
     type(switch_user_t) :: io
     type(switch_user_t) :: execution
     type(key_user_t)    :: default
   contains
     procedure, private :: toprog => cubeset_timing_user_toprog
  end type timing_user_t
  !
  type :: timing_prog_t
     logical :: list
     type(switch_prog_t) :: io
     type(switch_prog_t) :: execution
     type(key_prog_t)    :: default
   contains
     procedure, private :: act => cubeset_timing_prog_act
  end type timing_prog_t
  !
contains
  !
  subroutine cubeset_timing_command(line,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(timing_user_t) :: user
    character(len=*), parameter :: rname='TIMING>COMMAND'    
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call timing%parse(line,user,error)
    if (error) return
    call timing%main(user,error)
    if (error) return
  end subroutine cubeset_timing_command
  !  
  !----------------------------------------------------------------------
  !
  subroutine cubeset_timing_register(timing,error)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: timing
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'TIMING','',&
         'Enable or disable timing feedback at the end of processing',&
         'Default is OFF. Two topics are available: /EXECUTION for&
         & execution times, and /IO for data Input and Output,&
         & Default values can be reset with option /DEFAULT. TIMING&
         & without any options displays the current timing setup.&
         & When /DEFAULT is combined with other keys on the same command&
         & line, reset is applied first.',&
         cubeset_timing_command,&
         timing%comm,&
         error)
    if (error) return
    !
    call timing%io%register(&
         'IO',&
         'IO timing',&
         'OFF',&
         strg_emp,&
         error)
    if (error) return
    !
    call timing%execution%register(&
         'EXECUTION',&
         'execution timing',&
         'OFF',&
         strg_emp,&
         error)
    if (error) return
    !
    call timing%default%register(&
         'DEFAULT',&
         'Reset settings',&
         'Reset timing settings before applying other keys from the same&
         & command line.',&
         error)
    if (error) return
  end subroutine cubeset_timing_register
  !
  subroutine cubeset_timing_parse(comm,line,user,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(timing_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    user%list = cubetools_nopt().eq.0
    !
    if (user%list) then
       ! nothing to do
    else
       call comm%io%parse(line,user%io,error)
       if (error) return
       call comm%execution%parse(line,user%execution,error)
       if (error) return
       call comm%default%parse(line,user%default,error)
       if (error) return
    endif
  end subroutine cubeset_timing_parse
  !
  subroutine cubeset_timing_main(comm,user,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_comm_t), intent(inout) :: comm
    type(timing_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(timing_prog_t) :: prog
    character(len=*), parameter :: rname='TIMING>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeset_timing_main
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_timing_user_toprog(user,comm,prog,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_user_t), intent(in)    :: user
    type(timing_comm_t),  intent(in)    :: comm
    type(timing_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>USER>TOPROG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    prog%list = user%list
    call user%io%toprog(comm%io,prog%io,error)
    if (error) return
    call user%execution%toprog(comm%execution,prog%execution,error)
    if (error) return
    call user%default%toprog(comm%default,prog%default,error)
    if (error) return
  end subroutine cubeset_timing_user_toprog
  !
  !-----------------------------------------------------------------------
  !
  subroutine cubeset_timing_prog_act(prog,error)
    use cubetools_setup_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(timing_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TIMING>PROG>ACT'
    type(cube_setup_api_t) :: setup
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (prog%default%act)   call setup%timing%reset()
    if (prog%io%act)        call setup%timing%io%set(prog%io%enabled,error)
    if (prog%execution%act) call setup%timing%command%set(prog%execution%enabled,error)
    if (prog%list) then
       call cubeset_message(seve%r,rname,'  Timing')
       prog%io%action = 'IO'
       call setup%timing%io%get(prog%io%enabled)
       call prog%io%list(error)
       if (error) return
       prog%execution%action = 'EXECUTION'
       call setup%timing%command%get(prog%execution%enabled)
       call prog%execution%list(error)
       if (error) return       
    endif    
  end subroutine cubeset_timing_prog_act
end module cubeset_timing
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program correlate_1d
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS  Computes the cross correlation of two data cubes along
  ! the last dimension
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: in_name1,in_name2,out_name
  logical :: error !! ,corr
  integer(kind=4) :: i, n
  type(gildas) :: x,y,z
  real(kind=4), allocatable :: work(:)
  integer(kind=4) :: ier
  !
  call gildas_open
  call gildas_char('IN_NAME1$',in_name1)
  call gildas_char('IN_NAME2$',in_name2)
  call gildas_char('OUT_NAME$',out_name)
  call gildas_close
  !
  call gildas_null(z)
  z%gil%ndim = 3
  call gdf_read_gildas(z,in_name1,'.gdf',error,data=.false.)
  if (error) call sysexi(fatale)
  !
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,in_name2,'.gdf',error,data=.false.)
  if (error) call sysexi(fatale)
  !
  do i=1,2
    if (y%gil%dim(i).ne.z%gil%dim(i)) then
      call gagout('F-CORRELATE,  Input cubes have different'//   &
     &        ' number of pixels')
      goto 100
    endif
  enddo
  !
  call do_check('Ref1',y%gil%ref(1),z%gil%ref(1),error)
  if (error)  goto 100
  call do_check('Val1',y%gil%val(1),z%gil%val(1),error)
  if (error)  goto 100
  call do_check('Inc1',y%gil%inc(1),z%gil%inc(1),error)
  if (error)  goto 100
  !
  call do_check('Ref2',y%gil%ref(2),z%gil%ref(2),error)
  if (error)  goto 100
  call do_check('Val2',y%gil%val(2),z%gil%val(2),error)
  if (error)  goto 100
  call do_check('Inc2',y%gil%inc(2),z%gil%inc(2),error)
  if (error)  goto 100
  !
  call do_check('Ref3',y%gil%ref(3),z%gil%ref(3),error)
  if (error)  goto 100
  call do_check('Val3',y%gil%val(3),z%gil%val(3),error)
  if (error)  goto 100
  call do_check('Inc3',y%gil%inc(3),z%gil%inc(3),error)
  if (error)  goto 100
  !
  call gildas_null(x)
  call gdf_copy_header (y,x,error)
  n = lenc(out_name)
  if (n.eq.0) goto 100
  call sic_parsef(out_name(1:n),x%file,' ','.gdf')
  !
  x%gil%extr_words = 0
  x%gil%blan_words = 2
  x%gil%bval = 0.0
  x%gil%eval = 0.0
  !
  ! Determine size of correlation spectrum
  x%gil%ndim = 1
  x%gil%dim(1) = z%gil%dim(3) !! + y%gil%dim(3) - 1
  x%gil%val(1) = z%gil%val(3)-y%gil%val(3)
  x%gil%ref(1) = z%gil%ref(3)-y%gil%ref(3)+x%gil%dim(1)/2
  x%gil%inc(1) = z%gil%inc(3)
  x%gil%faxi = 1
  x%char%code(1) = z%char%code(3)
  !
  x%loca%size = x%gil%dim(1)
  !
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-CORRELATE,  Cannot create spectrum') 
    goto 100
  endif
  !
  allocate (x%r1d(x%gil%dim(1)) , &
            work(x%gil%dim(1)) ,   &
            y%r3d(y%gil%dim(1),y%gil%dim(2),y%gil%dim(3)),  &
            z%r3d(z%gil%dim(1),z%gil%dim(2),x%gil%dim(3)), stat=ier)
  if (ier.ne.0) then
    call gagout('F-CORRELATE,  Cannot allocate work space')
    goto 100
  endif
  !
  call gdf_read_data(y,y%r3d,error)
  if (error) goto 100
  call gdf_read_data(z,z%r3d,error)
  if (error) goto 100
  !
  call do_correl_1d(  &
          z%gil%dim(1),z%gil%dim(2),x%gil%dim(3), &
          z%r3d,z%gil%bval,z%gil%eval,  &
          y%r3d,y%gil%bval,y%gil%eval,  &
          x%r1d,x%gil%dim(1),work)
  call gdf_write_data(x,x%r1d,error)
  if (error) goto 100
  !
  call gagout('S-CORRELATE,  Successful completion')
  goto 101
  !
100 call sysexi (fatale)
101 continue
end program correlate_1d
!
subroutine do_check(axis,yval,zval,error)
  use gkernel_interfaces
  character(len=*), intent(in)    :: axis   ! Axis name
  real(kind=8),     intent(inout) :: yval   !
  real(kind=8),     intent(in)    :: zval   !
  logical,          intent(inout) :: error  ! Logical error flag
  !
  real(8), parameter :: eps=1d-7
  !
  if (abs(yval-zval).ne.0d0) then  ! They differ
    write(6,*) axis, yval, zval
    if (abs(yval-zval).gt.eps*abs(yval+zval)) then 
    ! They differ by more  than eps
      call gagout('F-CORRELATE,  Input cubes have '//  &
          'incompatible conversion formula') 
      error = .true.
      return
    endif
  endif
  !
end subroutine do_check
!
subroutine do_correl_1d(nx,ny,nz, &
  in1,bval1,eval1, in2,bval2,eval2, out,nout,work)
  use gildas_def
  integer(kind=index_length), intent(in)  :: nx              !
  integer(kind=index_length), intent(in)  :: ny              !
  integer(kind=index_length), intent(in)  :: nz              !
  real(kind=4),               intent(in)  :: in1(nx,ny,nz)   !
  real(kind=4),               intent(in)  :: bval1              !
  real(kind=4),               intent(in)  :: eval1              !
  real(kind=4),               intent(in)  :: in2(nx,ny,nz)   !
  real(kind=4),               intent(in)  :: bval2              !
  real(kind=4),               intent(in)  :: eval2              !
  integer(kind=index_length), intent(in)  :: nout              !
  real(kind=4),               intent(out) :: out(nout)    !
  real(kind=4),               intent(out) :: work(nout)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m,n
  !
  ! Reset cross correlation to zero
  out = 0.0
  work = 0.0
  !
  ! Compute
  n = nout/2
  do k = 1, nz
    do l = 1, nz
      m = k-l+n
      if (m.ge.1 .and. m.le.nout) then
        do j=1,ny
          do i=1,nx
            if (abs(in2(i,j,l)-bval2).gt.eval2) then
              if (abs(in1(i,j,k)-bval1).gt.eval1) then
                out(m) = out(m)+in1(i,j,k)*in2(i,j,l)
                work(m) = work(m)+1.0
              endif
            endif
          enddo
        enddo
      endif
    enddo
  enddo
  !
  ! Normalise
  do m=1,nout
    if (work(m).ne.0) out(m) = out(m)/work(m) 
  enddo
end subroutine do_correl_1d

module gio_convert
  integer(kind=4), parameter :: unknown=-20
  !
  ! 32 bit codes
  integer(kind=4), parameter :: vax_to_ieee=+1
  integer(kind=4), parameter :: ieee_fr_vax=-1
  integer(kind=4), parameter :: ieee_to_vax=+2
  integer(kind=4), parameter :: vax_fr_ieee=-2
  integer(kind=4), parameter :: vax_to_eeei=+3
  integer(kind=4), parameter :: eeei_fr_vax=-3
  integer(kind=4), parameter :: eeei_to_vax=+4
  integer(kind=4), parameter :: vax_fr_eeei=-4
  integer(kind=4), parameter :: ieee_to_eeei=+5
  integer(kind=4), parameter :: ieee_fr_eeei=-5
  integer(kind=4), parameter :: eeei_fr_ieee=-6
  integer(kind=4), parameter :: eeei_to_ieee=+6
  !
  ! 64 bits codes: as above, but with offset off_64bit, which must be 10
  integer(kind=4), parameter :: off_64bit=+10
  integer(kind=4), parameter :: ndb_64bit=2**(31-7)  ! Number of virtual 512-byte blocks for a 2 Gbytes file
  !
  ! Only 6 effective conversions are known 
  integer(kind=4), parameter :: mconve=6
end module gio_convert
!
module gio_image
  use gio_params
  use image_def
  !--------------------------------------------------------------------
  ! GIO global variables and parameters for image I/O support
  !--------------------------------------------------------------------
  integer(kind=4), parameter :: mis=30           ! Number of image slot
  integer(kind=4), parameter :: mms=60           ! Number of memory slots
  !
  ! Image slot status
  integer(kind=4) :: islot(mis) = code_gio_empty 
  integer(kind=4) :: ichan(mis) = 0              ! Channel numbers
  integer(kind=4) :: istbl(mis)                  ! Starting block for each Slot (kind=4 is enough)
  integer(kind=4) :: iconv(mis)                  ! Image header conversion type
  integer(kind=4) :: iform(mis)                  ! Image data type
  integer(kind=4) :: indim(mis)                  ! Image number of dimensions
  integer(kind=4) :: ivers(mis)                  ! Image Format Version number
  integer(kind=index_length) :: idims(gdf_maxdims,mis)! Image dimensions
  integer(kind=index_length) :: irblock(mis)     ! Last read block
  integer(kind=index_length) :: iwblock(mis)     ! Last written block
  integer(kind=index_length) :: imblock(mis)     ! End of file block
  integer(kind=4) :: iunit(mis)                  ! Logical units for images
  logical :: mapped(mis) = .false.               ! Mapping QIO indicator
  integer(kind=4) :: isbig(mis)                  ! Big block size indicator
  !
  integer(kind=4), parameter :: lenbuf=128       ! Length of small blocks
  integer(kind=4), parameter :: lenbig=gio_block2*gio_block1*lenbuf  ! Length of big blocks
  ! 
  integer(kind=4) :: mstbl = 0                   ! Maximum number of starting blocks
  integer(kind=4) :: startbl = 2                 ! Default number of starting blocks
  integer(kind=4), allocatable :: gdfbig(:,:)    ! (lenbuf,mstbl) 
  integer(kind=4) :: gdfbuf(lenbuf)              ! First header block 
  !
  character(len=filename_length) :: cname(mis)   ! Filenames
  type(gildas), target, save :: gheads(mis)      ! New storage of Headers
  !  
  integer(kind=address_length) :: maddr(2,mms)   ! Address of memory slot
  integer(kind=4) :: mslot(mms) = 0              ! Memory image slot number
  integer(kind=size_length) :: msize(mms) = 0    ! Memory image slot size
  integer(kind=size_length) :: moffs(mms)        ! Memory address offset
  integer(kind=size_length) :: mleng(mms)        ! Memory current slot size
  integer(kind=index_length) :: mblc(gdf_maxdims,mms) ! Memory image BLC
  integer(kind=index_length) :: mtrc(gdf_maxdims,mms) ! Memory image TRC
  integer(kind=4) :: mform(mms)                  ! Memory data type
  logical :: mcont(mms)                          ! Contiguous slot indicator
  !
  logical :: pre_allocate=.false.                ! Pre-allocate the file ?
end module gio_image
!
module gio_xy
  use image_def
  type(gildas), save :: fits
end module gio_xy
!
module gio_uv
  use gio_headers
  integer(kind=4), save :: code_version_uvt_current = code_version_uvt_default
end module gio_uv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_aperture
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubesyntax_keyval_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubetopology_spaelli_types
  use cubemain_messaging
  use cubemain_stack_spectra_tool
  !
  public :: aperture
  private
  !
  type :: aperture_comm_t
     type(option_t), pointer     :: comm
     type(cuberegion_comm_t)     :: region
     type(spaelli_comm_t)        :: ellipse
     type(stack_spectra_comm_t)  :: stack
     type(keyval_dble_comm_t)    :: background
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: spectrum
   contains
     procedure, public  :: register => cubemain_aperture_comm_register
     procedure, private :: parse    => cubemain_aperture_comm_parse
     procedure, private :: main     => cubemain_aperture_comm_main
  end type aperture_comm_t
  type(aperture_comm_t) :: aperture
  !
  type aperture_user_t
     type(cubeid_user_t)        :: cubeids
     type(cuberegion_user_t)    :: region
     type(spaelli_user_t)       :: ellipse
     type(stack_spectra_user_t) :: stack
     type(keyval_dble_user_t)   :: background
   contains
     procedure, private :: toprog => cubemain_aperture_user_toprog
  end type aperture_user_t
  !
  type aperture_prog_t
     type(cuberegion_prog_t)    :: region             ! Cube region of interest
     type(spaelli_prog_t)       :: ellipse            ! Aperture geometry and position
     type(stack_spectra_prog_t) :: stack              ! Stacking options
     real(kind=coor_k)          :: backdiamfact = 0d0 ! Background diameter factor
     type(cube_t), pointer      :: cube               ! Input cube
     type(cube_t), pointer      :: spectrum           ! Output spectrum
   contains
     procedure, private :: header => cubemain_aperture_prog_header
     procedure, private :: data   => cubemain_aperture_prog_data
     procedure, private :: loop   => cubemain_aperture_prog_loop
     procedure, private :: act    => cubemain_aperture_prog_act
  end type aperture_prog_t
  !
contains
  !
  subroutine cubemain_aperture_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(aperture_user_t) :: user
    character(len=*), parameter :: rname='APERTURE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call aperture%parse(line,user,error)
    if (error) return
    call aperture%main(user,error)
    if (error) continue
  end subroutine cubemain_aperture_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='APERTURE>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'APERTURE','[cubeid]',&
         'Stack spectra within a given aperture',&
         'APERTURE stacks spectra inside a user-defined spatial aperture.'&
         //strg_bl//&
         'Behavior:'//strg_cr//&
         '- Default aperture geometry is beam-driven and centered on the&
         & projection center.'//strg_cr//&
         '- Spatial and spectral selection is controlled by /SIZE, /CENTER,&
         & and /RANGE.'//strg_cr//&
         '- Stacking mode and local background handling are controlled by&
         & /SUM, /MEAN, and /BACKGROUND.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> APERTURE cube:co'//strg_cr//&
         'CUBE> APERTURE cube:co /DIAMETER 30 arcsec /MEAN'//strg_cr//&
         'CUBE> APERTURE cube:co /CENTER 0 0 relative /RANGE -5 5 km/s',&
         cubemain_aperture_command,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    !
    call comm%ellipse%register(&
         'DIAMETER',&
         'Define the aperture ellipse axis diameters and position angle',&
         'POSITION',&
         'Define the aperture position',&
         error)
    if (error) return
    call comm%stack%register(error)
    if (error) return
    call comm%background%register(&
         'BACKGROUND',&
         'Set annulus scale for local background subtraction',&
         'Set the multiplicative factor applied to aperture diameters when&
         & defining the background annulus. Use "*" to keep the default&
         & factor (2.0).',&
         2d0,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'APERTURE',&
         'The aperture spectrum',&
         'Stacked output spectrum for the selected aperture.',&
         [flag_aperture,flag_spectrum],&
         comm%spectrum,&
         error,&
         access=code_access_imaset)
    if (error) return
  end subroutine cubemain_aperture_comm_register
  !
  subroutine cubemain_aperture_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! APERTURE [cubeid]
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(aperture_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='APERTURE>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%ellipse%parse(line,user%ellipse,error)
    if (error) return
    call comm%stack%parse(line,user%stack,error)
    if (error) return
    call comm%background%parse(line,user%background,error)
    if (error) return
  end subroutine cubemain_aperture_comm_parse
  !
  subroutine cubemain_aperture_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_comm_t), intent(in)    :: comm
    type(aperture_user_t),  intent(in)    :: user
    logical,                intent(inout) :: error
    !
    type(aperture_prog_t) :: prog
    character(len=*), parameter :: rname='APERTURE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_aperture_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_user_t), intent(in)    :: user
    type(aperture_comm_t),  intent(in)    :: comm
    type(aperture_prog_t),  intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(keyval_dble_prog_t) :: keyval
    character(len=*), parameter :: rname='APERTURE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    call user%ellipse%toprog(prog%cube,prog%ellipse,error)
    if (error) return
    call user%stack%toprog(prog%cube,prog%stack,error)
    if (error) return
    call user%background%toprog(comm%background,prog%backdiamfact,error)
    if (error) return
    ! User feedback
    call prog%region%list(error)
    if (error) return
    call prog%ellipse%list(error)
    if (error) return
    call prog%stack%list(error)
    if (error) return
    if (user%background%do) then
       call keyval%list(comm%background,prog%backdiamfact,error)
       if (error) return
    endif
  end subroutine cubemain_aperture_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_aperture_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetools_beam_types
    use cubetools_spapro_types
    use cubeadm_clone
    !----------------------------------------------------------------------
    ! The following code aproximates the header to describe a shape similar
    ! to the aperture. L axis is aligned with aperture major axis, m axis
    ! with the minor axis, projection angle is the aperture position
    ! angle. This is only an approximation as the projection effects are
    ! not taken into account.
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    type(aperture_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    real(kind=coor_k) :: absolute(2)
    type(axis_t) :: axis
    type(beam_t) :: beam
    type(spapro_t) :: spapro
    integer(kind=ndim_k), parameter :: ix = 1
    integer(kind=ndim_k), parameter :: iy = 2
    character(len=*), parameter :: rname='APERTURE>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%spectrum,  &
      prog%cube,prog%region,prog%spectrum,error)
    if (error) return
    call prog%stack%set_unit(prog%spectrum,error)
    if (error) return
    !
    ! l axis
    call cubetools_header_get_axis_head_l(prog%spectrum%head,axis,error)
    if (error) return
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = sign(max(prog%ellipse%diameter%major,abs(axis%inc)),axis%inc)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_l(axis,prog%spectrum%head,error)
    if (error) return
    !
    ! m axis
    call cubetools_header_get_axis_head_m(prog%spectrum%head,axis,error)
    if (error) return
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = sign(max(prog%ellipse%diameter%minor,abs(axis%inc)),axis%inc)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_m(axis,prog%spectrum%head,error)
    if (error) return
    !
    ! Projection
    call cubetools_header_get_spapro(prog%spectrum%head,spapro,error)
    if (error) return
    call prog%ellipse%center%absolute(absolute,error)
    if (error) return
    spapro%l0 = absolute(ix)
    spapro%m0 = absolute(iy)
    spapro%pa = prog%ellipse%diameter%pang
    call cubetools_header_put_spapro(spapro,prog%spectrum%head,error)
    if (error) return
    !
    ! Beam
    call cubetools_header_get_spabeam(prog%spectrum%head,beam,error)
    if (error) return
    ! VVV is this the correct choice for the output beam?
    if (beam%major*beam%minor.lt.prog%ellipse%diameter%major*prog%ellipse%diameter%minor) then
       beam%major = prog%ellipse%diameter%major
       beam%minor = prog%ellipse%diameter%minor
       beam%pang  = prog%ellipse%diameter%pang
       call cubetools_header_update_spabeam(beam,prog%spectrum%head,error)
       if (error) return
    endif
  end subroutine cubemain_aperture_prog_header
  !
  subroutine cubemain_aperture_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='APERTURE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_aperture_prog_data
  !   
  subroutine cubemain_aperture_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image,mask,weight,spectrum
    character(len=*), parameter :: rname='APERTURE>PROG>LOOP'
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call mask%allocate('mask',prog%cube,error) !***JP: Is this correct with respect to the region?
    if (error) return
    call mask%associate_xy(error)
    if (error) return
    if (prog%backdiamfact.le.0.0) then
       call ellipse2mask1(prog%ellipse,mask,error)
       if (error) return
    else
       call ellipse2mask2(prog%ellipse,prog%backdiamfact,mask,error)
       if (error) return
    endif
    call weight%allocate('weight',prog%cube,error) !***JP: Is this correct with respect to the region?
    if (error) return
    call weight%set(1.0,error) ! => This means uniform weighting
    if (error) return
    call spectrum%allocate('spectrum',prog%spectrum,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,image,mask,weight,spectrum,error)
       if (error) return
    enddo ! ie
    !
  contains
    !
    subroutine ellipse2mask1(ellipse,mask,error)
      use cubetools_nan
      use cubetopology_spatial_coordinates
      !--------------------------------------------------------------------
      ! Compute a mask from an ellipse definition. If a pixel is outside
      ! the aperture but it is less than half a pixel from the ellipse
      ! center then it includes it in the mask.
      !
      !***JP: This codes does not takes into account projection effects.
      !--------------------------------------------------------------------
      type(spaelli_prog_t), intent(in)    :: ellipse
      type(image_t),        intent(in)    :: mask
      logical,              intent(inout) :: error
      !
      logical :: inside
      integer(kind=pixe_k) :: ix,iy
      real(kind=coor_k) :: centeroffset(2)
      real(kind=coor_k) :: rmajor,rminor
      real(kind=coor_k) :: angle,cosang,sinang
      real(kind=coor_k) :: xpix,xcoord,xcos,xsin
      real(kind=coor_k) :: ypix,ycoord,ycos,ysin
      !
      xpix = 0.5*abs(mask%x%inc) ! Half pixel size along x
      ypix = 0.5*abs(mask%y%inc) ! Half pixel size along y
      rmajor = 0.5*ellipse%diameter%major ! Major radius
      rminor = 0.5*ellipse%diameter%minor ! Minor radius
      call cubetopology_spatial_pang_to_fortran(prog%cube,ellipse%diameter%pang,angle,error)
      if (error) return
      cosang = cos(angle)
      sinang = sin(angle)
      call ellipse%center%offset(centeroffset,error)
      if (error) return
      !
      do iy=1,mask%ny
         ycoord = mask%y%coord(iy)-centeroffset(2)
         ycos = ycoord*cosang
         ysin = ycoord*sinang
         do ix=1,mask%nx
            xcoord = mask%x%coord(ix)-centeroffset(1)
            xcos = xcoord*cosang
            xsin = xcoord*sinang
            inside = ( ((xcos+ysin)/rmajor)**2 + ((xsin-ycos)/rminor)**2 ).le.1d0
            inside = inside.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
            if (inside) then
               mask%val(ix,iy) = 1.0
            else
               mask%val(ix,iy) = gr4nan
            endif
         enddo ! iy
      enddo ! ix
    end subroutine ellipse2mask1
    !
    subroutine ellipse2mask2(ellipse,bgfact,mask,error)
      use cubetools_nan
      use cubetopology_spatial_coordinates
      !--------------------------------------------------------------------
      ! Compute a mask from an ellipse definition. If a pixel is outside
      ! the aperture but it is less than half a pixel from the ellipse
      ! center then it includes it in the mask.
      !
      !***JP: This codes does not takes into account projection effects.
      !--------------------------------------------------------------------
      type(spaelli_prog_t), intent(in)    :: ellipse
      real(kind=coor_k),    intent(in)    :: bgfact
      type(image_t),        intent(in)    :: mask
      logical,              intent(inout) :: error
      !
      logical :: insidesig,insidebg
      integer(kind=pixe_k) :: ix,iy
      real(kind=coor_k) :: centeroffset(2)
      real(kind=coor_k) :: rmajorsig,rminorsig
      real(kind=coor_k) :: rmajorbg, rminorbg
      real(kind=coor_k) :: angle,cosang,sinang
      real(kind=coor_k) :: xpix,xcoord,xcos,xsin
      real(kind=coor_k) :: ypix,ycoord,ycos,ysin
      !
      xpix = 0.5*abs(mask%x%inc)             ! Half pixel size along x
      ypix = 0.5*abs(mask%y%inc)             ! Half pixel size along y
      rmajorsig = 0.5*ellipse%diameter%major ! Major radius of signal region
      rminorsig = 0.5*ellipse%diameter%minor ! Minor radius of signal region
      rmajorbg = rmajorsig*bgfact            ! Major radius of background region
      rminorbg = rminorsig*bgfact            ! Minor radius of background region
      call cubetopology_spatial_pang_to_fortran(prog%cube,ellipse%diameter%pang,angle,error)
      if (error) return
      cosang = cos(angle)
      sinang = sin(angle)
      call ellipse%center%offset(centeroffset,error)
      if (error) return
      !
      do iy=1,mask%ny
         ycoord = mask%y%coord(iy)-centeroffset(2)
         ycos = ycoord*cosang
         ysin = ycoord*sinang
         do ix=1,mask%nx
            xcoord = mask%x%coord(ix)-centeroffset(1)
            xcos = xcoord*cosang
            xsin = xcoord*sinang
            insidebg = ( ((xcos+ysin)/rmajorbg)**2 + ((xsin-ycos)/rminorbg)**2 ).le.1d0
            insidebg = insidebg.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
            if (insidebg) then
               insidesig = ( ((xcos+ysin)/rmajorsig)**2 + ((xsin-ycos)/rminorsig)**2 ).le.1d0
               insidesig = insidesig.or.((abs(xcoord).le.xpix).and.abs(ycoord).le.ypix)
               if (insidesig) then               
                  mask%val(ix,iy) = signal
               else
                  mask%val(ix,iy) = background
               endif
            else
               mask%val(ix,iy) = gr4nan
            endif
         enddo ! iy
      enddo ! ix
    end subroutine ellipse2mask2
  end subroutine cubemain_aperture_prog_loop
  !
  subroutine cubemain_aperture_prog_act(prog,ie,image,mask,weight,spectrum,error)
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(aperture_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: mask
    type(image_t),          intent(inout) :: weight
    type(image_t),          intent(inout) :: spectrum
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='APERTURE>PROG>ACT'
    !
    call image%get(ie,error)
    if (error) return
    if (prog%backdiamfact.le.0.0) then
       call prog%stack%with_mask(image,weight,mask,spectrum,error)
       if (error) return
    else
       call prog%stack%backsubtract(image,weight,mask,spectrum,error)
       if (error) return
    endif
    call spectrum%put(ie,error)
    if (error) return
  end subroutine cubemain_aperture_prog_act  
end module cubemain_aperture
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_language
  use cubetools_parameters
  use cubetools_structure
  use cubefield_messaging
  !
  use cubefield_divergence
  use cubefield_gradient
  use cubefield_gradthin
  use cubefield_hessian
  use cubefield_incline
  use cubefield_minmax
  use cubefield_observe
  use cubefield_sht
  use cubefield_rotate
  !
  public :: cubefield_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubefield_register_language(error)
    !----------------------------------------------------------------------
    ! Register the FIELD\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'FIELD',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Analyze, transform, and project scalar or vector fields',&
         'FIELD lets you derive, transform, and project scalar or vector&
         & fields stored in images or cubes.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- GRADIENT writes DF_DX, DF_DY, AMPLITUDE, and ANGLE from a&
         & 2D field, then DIVERGENCE and HESSIAN turn those gradient&
         & products into second-order diagnostics.'//strg_cr//&
         '- GRADTHIN and SHT consume gradient amplitude/angle products&
         & to build thinned-edge masks and Hough-transform&
         & accumulators.'//strg_cr//&
         '- INCLINE and OBSERVE operate on the same 3D density/velocity&
         & cube quartet: INCLINE rotates the state cubes and OBSERVE&
         & projects them into COLDENS and VCENTROID maps.'//strg_cr//&
         '- MINMAX detects strict local minima/maxima in image slices,&
         & and ROTATE applies a local angle-field rotation to 2D vector&
         & components.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> FIELD\GRADIENT field'//strg_cr//&
         'CUBE> FIELD\GRADTHIN gradamp gradang'//strg_cr//&
         'CUBE> FIELD\SHT gradamp gradang'//strg_cr//&
         'CUBE> FIELD\INCLINE voldens vx vy vz /ANGLE 30deg'//strg_cr//&
         'CUBE> FIELD\OBSERVE voldens vx vy vz'//strg_bl//&
         'Note:'//strg_cr//&
         ' Shared region help is available on /SIZE ?, /CENTER ?, and&
         & /RANGE ? where supported.',&
         'gag_doc:hlp/cube-help-field.hlp',&
         cubefield_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call divergence%register(error)
    if (error) return
    call gradient%register(error)
    if (error) return
    call gradthin%register(error)
    if (error) return
    call hessian%register(error)
    if (error) return
    call incline%register(error)
    if (error) return
    call cubefield_minmax_register(error)
    if (error) return
    call observe%register(error)
    if (error) return
    call sht%register(error)
    if (error) return
    call rotate%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubefield_register_language
  !
  subroutine cubefield_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the FIELD\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'FIELD?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubefield_execute_command
end module cubefield_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module fit_minuit_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Support module for MINUIT fitting routines
  !---------------------------------------------------------------------
  !
  real(kind=8), parameter :: theprec=1.d-6  !
  integer(kind=4), parameter :: ntot=48     ! Size of problem
  integer(kind=4), parameter :: nvar=40     ! Size of problem
  !
end module fit_minuit_parameters
!
module fit_minuit_types
  use gildas_def
  use fit_minuit_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Support module for MINUIT fitting routines
  !---------------------------------------------------------------------
  !
  type :: fit_minuit_t
    real(kind=8) :: x(nvar), xt(nvar), dirin(nvar)
    real(kind=8) :: u(ntot), werr(ntot), alim(ntot), blim(ntot)
    real(kind=8) :: v(nvar,nvar)
    real(kind=8) :: xs(nvar), xts(nvar), wts(nvar)
    real(kind=8) :: y(nvar+1)
    real(kind=8) :: g(ntot), g2(ntot)
    real(kind=8) :: pstar(nvar), pstst(nvar), pbar(nvar), prho(nvar)
    real(kind=8) :: p(nvar,nvar), vt(nvar,nvar)
    real(kind=8) :: epsi, apsi, vtest
    real(kind=8) :: amin, up, sigma
    !
    integer(kind=4) :: maxint, npar
    integer(kind=4) :: maxext, nu, lcode(ntot), lcorsp(ntot), limset
    integer(kind=4) :: ipfix(nvar),npfix
    integer(kind=4) :: jh, jl
    integer(kind=4) :: isw(7), nblock
    integer(kind=4) :: nstepq, nfcn, nfcnmx
    integer(kind=4) :: newmin, itaur
    !
    ! Address of untyped 'blob' of data to be minimized. Not used by
    ! minuit but given back to callers thanks to callbacks. Keep this
    ! address to 0 will ensure this data will not be passed.
    integer(kind=address_length) :: data=0
    !
    ! Messages
    logical :: verbose
    integer(kind=4) :: owner=0   ! Owner id (default is the "global" package)
    integer(kind=4) :: isyswr=6  ! Output logical unit (obsolescent)
    !
  end type fit_minuit_t
  !
end module fit_minuit_types
!
module fit_minuit
  !---------------------------------------------------------------------
  ! @ public
  ! Support module for MINUIT fitting routines
  !---------------------------------------------------------------------
  use fit_minuit_parameters
  use fit_minuit_types
end module fit_minuit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module eclass_types
  !---------------------------------------------------------------------
  ! Support module for equivalence classes
  !---------------------------------------------------------------------
  !
  ! Common part shared by all equivalence class types. Not to be used
  ! directly
  type eclass_common_t
    integer(kind=4) :: nval  ! In: Number of values
    integer(kind=4) :: nequ  ! Out: Number of equivalence classes
    integer(kind=4), pointer :: cnt(:) => null()  ! In/out: counts for each value
    integer(kind=4), pointer :: bak(:) => null()  ! Out: Back pointer to the associated class
  end type eclass_common_t
  !
  type, extends(eclass_common_t) :: eclass_inte_t
    integer(kind=4), pointer :: val(:) => null()  ! In/out: values
  end type eclass_inte_t
  !
  type, extends(eclass_common_t) :: eclass_2inte_t
    integer(kind=4), pointer :: val1(:) => null()  ! In/out: values
    integer(kind=4), pointer :: val2(:) => null()  ! In/out: values
  end type eclass_2inte_t
  !
  type, extends(eclass_common_t) :: eclass_2inte1char_t
    integer(kind=4),   pointer :: val1(:) => null()  ! In/out: values
    integer(kind=4),   pointer :: val2(:) => null()  ! In/out: values
    character(len=16), pointer :: val3(:) => null()  ! In/out: values
  end type eclass_2inte1char_t
  !
  ! Not extended from eclass_common_t because of an ifort 14 bug which
  ! fails compiling mrtcal/lib-imbfits/read-header.f90
  type :: eclass_2inte2char_t
    integer(kind=4) :: nval  ! In: Number of values
    integer(kind=4) :: nequ  ! Out: Number of equivalence classes
    integer(kind=4),   pointer :: val1(:) => null()  ! In/out: values
    integer(kind=4),   pointer :: val2(:) => null()  ! In/out: values
    character(len=16), pointer :: val3(:) => null()  ! In/out: values
    character(len=16), pointer :: val4(:) => null()  ! In/out: values
    integer(kind=4), pointer :: cnt(:) => null()  ! In/out: counts for each value
    integer(kind=4), pointer :: bak(:) => null()  ! Out: Back pointer to the associated class
  end type eclass_2inte2char_t
  !
  type, extends(eclass_common_t) :: eclass_dble_t
    real(kind=8),    pointer :: val(:) => null()  ! In/out: values
  end type eclass_dble_t
  !
  type, extends(eclass_common_t) :: eclass_2dble_t
    real(kind=8),    pointer :: val1(:) => null()  ! In/out: values
    real(kind=8),    pointer :: val2(:) => null()  ! In/out: values
  end type eclass_2dble_t
  !
  type, extends(eclass_common_t) :: eclass_2dble1char_t
    real(kind=8),      pointer :: val1(:) => null()  ! In/out: values
    real(kind=8),      pointer :: val2(:) => null()  ! In/out: values
    character(len=24), pointer :: val3(:) => null()  ! In/out: values
  end type eclass_2dble1char_t
  !
  type, extends(eclass_common_t) :: eclass_2dble3inte_t
    real(kind=8),      pointer :: val1(:) => null()  ! In/out: values
    real(kind=8),      pointer :: val2(:) => null()  ! In/out: values
    integer(kind=4),   pointer :: val3(:) => null()  ! In/out: values
    integer(kind=4),   pointer :: val4(:) => null()  ! In/out: values
    integer(kind=4),   pointer :: val5(:) => null()  ! In/out: values
  end type eclass_2dble3inte_t
  !
  type, extends(eclass_common_t) :: eclass_char_t
    character(len=80), pointer :: val(:) => null()  ! In/out: values
  end type eclass_char_t
  !
end module eclass_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_extract
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_windowing
  use cubemain_ancillary_refhead_types
  use cubetopology_speline_types
  use cubetopology_sperange_types
  use cubetopology_sparange_types
  use cubetopology_spapos_types
  use cubetopology_spasize_types
  use cubetopology_cuberegion_types
  !
  public :: extract
  private
  !
  type :: extract_comm_t
     type(option_t),     pointer    :: comm
     type(cubeid_arg_t), pointer    :: cube
     type(sperange_opt_t)           :: range
     type(speline_opt_t)            :: freq
     type(spapos_comm_t)            :: center
     type(spasize_opt_t)            :: size
     type(ancillary_refhead_comm_t) :: reference  ! Support for /LIKE
     type(cube_prod_t),  pointer    :: extracted
   contains
     procedure, public  :: register => cubemain_extract_register
     procedure, private :: parse    => cubemain_extract_parse
     procedure, private :: main     => cubemain_extract_main
  end type extract_comm_t
  type(extract_comm_t) :: extract
  !
  type extract_user_t
     type(cubeid_user_t)            :: cubeids
     type(speline_user_t)           :: line       ! Optional new line name and freq
     type(sperange_user_t)          :: range      ! Spectral range to be extracted
     type(spapos_user_t)            :: center     ! [absolute|relative] Center of the region to be extracted
     type(spasize_user_t)           :: size       ! Size of the region to be extracted
     type(ancillary_refhead_user_t) :: reference
   contains
     procedure, private :: toprog => cubemain_extract_user_toprog
  end type extract_user_t
  !
  type extract_prog_t
     type(cube_t), pointer          :: cube       ! Input cube
     type(cube_t), pointer          :: extracted  ! Extracted cube
     logical                        :: doline
     type(speline_prog_t)           :: line
     type(sperange_user_t)          :: sperange
     integer(kind=ndim_k)           :: ix,iy,ic
     integer(kind=data_k)           :: range(3,2) ! Extracted ranges
     type(cuberegion_prog_t)        :: region     !
     type(ancillary_refhead_prog_t) :: reference
   contains
     procedure, private :: header          => cubemain_extract_prog_header
     procedure, private :: header_spectral => cubemain_extract_prog_header_spectral
     procedure, private :: header_spatial  => cubemain_extract_prog_header_spatial
     procedure, private :: create_region   => cubemain_extract_create_region
     procedure, private :: data            => cubemain_extract_prog_data     
     procedure, private :: loop            => cubemain_extract_prog_loop
     procedure, private :: act             => cubemain_extract_prog_act
  end type extract_prog_t
  !
contains
  !
  subroutine cubemain_extract_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(extract_user_t) :: user
    character(len=*), parameter :: rname='EXTRACT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    call extract%parse(line,user,error)
    if (error) return
    call extract%main(user,error)
    if (error) return
  end subroutine cubemain_extract_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_register(extract,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(inout) :: extract
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    !
    character(len=*), parameter :: rname='EXTRACT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'EXTRACT','[cube]',&
         'Extract a subcube',&
         'Extract a subcube from the input cube using spectral and spatial selectors.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /FREQUENCY changes velocity-axis interpretation by setting&
         & the source systemic velocity at the user-provided line rest&
         & frequency.'//strg_cr//&
         '- /LIKE copies extraction geometry from a reference cube and is exclusive with /RANGE, /CENTER, and /SIZE.'//strg_cr//&
         '- After option checks, EXTRACT reads only the minimum input&
         & cube subset needed for the requested region and range. This&
         & is especially important for huge input cubes.'//strg_cr//&
         '- At least one option must be provided.'//strg_cr//&
         '- /CENTER requires /SIZE in the same command line.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> EXTRACT cubeA /RANGE -10 10 km/s'//strg_cr//&
         'CUBE> EXTRACT cubeA /CENTER 0 0 relative /SIZE 60 60 /RANGE&
         & -5 5 km/s'//strg_cr//&
         'CUBE> EXTRACT cubeA /LIKE refcube',&
         cubemain_extract_command,&
         extract%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         extract%cube,&
         error)
    if (error) return
    !
    call extract%range%register('RANGE',&
         'Spectral range of the extracted region',&
         error)
    if (error) return
    !
    call extract%freq%register(&
         'Line name & rest frequency of the extracted region',&
         error)
    if (error) return
    !
    call extract%center%register('CENTER',&
         'Spatial center of the extracted region',&
         error)
    if (error) return
    !
    call extract%size%register(&
         'Spatial size of the extracted region',&
         error)
    if (error) return
    !
    call extract%reference%register('EXTRACT',error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'EXTRACTED',&
         'Extracted cube',&
         strg_emp,&
         [flag_extract,flag_cube],&
         extract%extracted,&
         error)
    if (error) return
  end subroutine cubemain_extract_register
  !
  subroutine cubemain_extract_parse(extract,line,user,error)
    !----------------------------------------------------------------------
    ! EXTRACT [cubeid]
    ! /RANGE first last [unit]
    ! /FREQUENCY line frequency [unit]
    ! /CENTER xpos ypos type [unit]
    ! /SIZE sx [sy [unit]]
    ! /LIKE [refcube]
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(in)    :: extract
    character(len=*),      intent(in)    :: line
    type(extract_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,extract%comm,user%cubeids,error)
    if (error) return
    call extract%range%parse(line,user%range,error)
    if (error) return
    call extract%freq%parse(line,user%line,error)
    if (error) return
    call extract%center%parse(line,user%center,error)
    if (error) return
    call extract%size%parse(line,user%size,error)
    if (error) return
    call extract%reference%parse(line,user%reference,error)
    if (error) return
    !
    ! Sanity
    if (cubetools_nopt().eq.0) then
       call cubemain_message(seve%e,rname,'No options given, nothing to do')
       error = .true.
       return
    endif
    if (user%center%present.and..not.user%size%do) then
       call cubemain_message(seve%e,rname,'A size must be specified when giving a new center')
       error = .true.
       return
    endif
    if (user%reference%present .and. &
        (user%center%present .or. user%size%do .or. user%range%do)) then
       call cubemain_message(seve%e,rname,'/LIKE is exclusive with /RANGE /CENTER /SIZE')
       error = .true.
       return
    endif
  end subroutine cubemain_extract_parse
  !
  subroutine cubemain_extract_main(extract,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_comm_t), intent(in)    :: extract
    type(extract_user_t),  intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(extract_prog_t) :: prog
    character(len=*), parameter :: rname='EXTRACT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(extract,prog,error)
    if (error) return
    call prog%header(extract,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_extract_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_user_t), intent(in)    :: user
    type(extract_comm_t),  intent(in)    :: comm
    type(extract_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=chan_k) :: stride
    real(kind=coor_k) :: offset(2)
    type(sparange_prog_t) :: lrange,mrange
    type(spapos_prog_t) :: center
    integer(kind=ndim_k), parameter :: ix=1,iy=2
    character(len=*), parameter :: rname='EXTRACT>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(extract%cube,user%cubeids,prog%cube,error)
    if (error) return
    !
    select case (prog%cube%order())
    case (code_cube_imaset)
       prog%ix = 1
       prog%iy = 2
       prog%ic = 3
    case (code_cube_speset)
       prog%ix = 2
       prog%iy = 3
       prog%ic = 1
    case default
       call cubemain_message(seve%e,rname,'Order not supported')
       error = .true.
       return
    end select
    !
    prog%doline = user%line%do
    if (prog%doline) then
       call user%line%toprog(prog%cube,prog%line,error)
       if (error) return
    endif
    !
    if (user%reference%present) then
      call cubemain_extract_user_toprog_reference(user,comm,prog, &
           prog%sperange,lrange,mrange,error)
      if (error)  return
    else
      ! User range is just copied because range resolution has to be done
      ! after frequency modification
      prog%sperange = user%range
      !
      ! Spatial center
      call user%center%toprog(prog%cube,center,error)
      if (error) return
      call center%offset(offset,error)
      if (error) return
      !
      ! Spatial ranges
      call lrange%fromuser(code_sparange_truncated,prog%cube%head%set%il,prog%cube,offset(ix),&
           user%size%x,user%size%unit,prog%cube%head%spa%l%inc,&
           prog%cube%head%spa%l%kind,error)
      if (error) return
      call mrange%fromuser(code_sparange_truncated,prog%cube%head%set%im,prog%cube,offset(iy),&
           user%size%y,user%size%unit,prog%cube%head%spa%m%inc,&
           prog%cube%head%spa%m%kind,error)
      if (error) return
    endif
    !
    call lrange%to_pixe_k(prog%range(prog%ix,1),prog%range(prog%ix,2),stride,error)
    if (error) return
    call mrange%to_pixe_k(prog%range(prog%iy,1),prog%range(prog%iy,2),stride,error)
    if (error) return
  end subroutine cubemain_extract_user_toprog
  !
  subroutine cubemain_extract_user_toprog_reference(user,comm,prog, &
    crange,lrange,mrange,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    !-------------------------------------------------------------------
    ! From the reference (/LIKE) cube provided by the user, fill the
    ! equivalent user* types
    !-------------------------------------------------------------------
    class(extract_user_t), intent(in)    :: user
    type(extract_comm_t),  intent(in)    :: comm
    type(extract_prog_t),  intent(inout) :: prog
    type(sperange_user_t), intent(out)   :: crange
    type(sparange_prog_t), intent(out)   :: lrange,mrange
    logical,               intent(inout) :: error
    !
    integer(kind=ndim_k) :: ref_ic,ref_il,ref_im
    real(kind=coor_k) :: lmin,lmax,loff(4),labs(4)
    real(kind=coor_k) :: mmin,mmax,moff(4),mabs(4)
    type(projection_t) :: gproj
    character(len=*), parameter :: rname='EXTRACT>USER>TOPROG>REFERENCE'
    !
    ! Fetch the reference header
    call user%reference%toprog(comm%reference,prog%reference,error)
    if (error) return
    !
    ! Spectral range
    ref_ic = prog%reference%cube%head%set%ic
    write(crange%val(1),'(1pg25.16)') prog%reference%cube%head%set%axis(ref_ic)%get_min()
    write(crange%val(2),'(1pg25.16)') prog%reference%cube%head%set%axis(ref_ic)%get_max()
    crange%unit =                     prog%reference%cube%head%set%axis(ref_ic)%unit
    !
    ! Spatial range: define 4 absolute positions at the middle of each
    ! side (not the corners to limit projection effects):
    !           2
    !         1   3
    !           4
    !
    ! Reference ranges (relative coordinates)
    ! ZZZ Should ensure in radians!
    ! ZZZ We ask for min/max but we should actually pick left/right, and respect
    !     the order in lrange%fromrange()
    ref_il = prog%reference%cube%head%set%il
    lmin = prog%reference%cube%head%set%axis(ref_il)%get_min()
    lmax = prog%reference%cube%head%set%axis(ref_il)%get_max()
    ref_im = prog%reference%cube%head%set%im
    mmin = prog%reference%cube%head%set%axis(ref_im)%get_min()
    mmax = prog%reference%cube%head%set%axis(ref_im)%get_max()
    !
    ! The 4 reference points in relative coordinates:
    loff(1) = lmin
    loff(2) = (lmin+lmax)/2.d0
    loff(3) = lmax
    loff(4) = (lmin+lmax)/2.d0
    moff(1) = (mmin+mmax)/2.d0
    moff(2) = mmax
    moff(3) = (mmin+mmax)/2.d0
    moff(4) = mmin
    !
    ! Convert from relative to absolute with the reference cube:
    call prog%reference%cube%head%spa%pro%gwcs(gproj,error)
    if (error) return
    call rel_to_abs(gproj,loff,moff,labs,mabs,4)
    !
    ! Convert the spherical coordinates from ref system to output system:
    ! ZZZ Don't we have a utility for this???
    if (prog%reference%cube%head%spa%fra%code .ne. &
                  prog%cube%head%spa%fra%code) then
      call cubemain_message(seve%e,rname,  &
        'Input and output cubes do not have the same coordinate system (not implemented)')
      error = .true.
      return
    endif
    !
    ! Convert back from absolute to relative in the extracted cube system:
    call prog%cube%head%spa%pro%gwcs(gproj,error)
    if (error) return
    call abs_to_rel(gproj,labs,mabs,loff,moff,4)
    !
    ! Fill the range types
    call lrange%fromrela(prog%cube%head%set%il,prog%cube,loff(1),loff(3),error)
    if (error)  return
    call mrange%fromrela(prog%cube%head%set%im,prog%cube,moff(4),moff(2),error)
    if (error)  return
  end subroutine cubemain_extract_user_toprog_reference
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_extract_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    type(extract_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%extracted,prog%cube,prog%extracted,error)
    if (error) return
    call prog%header_spectral(error)
    if (error) return
    call prog%header_spatial(error)
    if (error) return
    call prog%create_region(error)
    if (error) return
  end subroutine cubemain_extract_prog_header
  !
  subroutine cubemain_extract_create_region(prog,error)
    !-----------------------------------------------------------------
    ! Ad-hoc subroutine which converts the 3 ranges to a region type,
    ! for later use by cubeadm_datainit_all.
    !
    ! We allow here the 3rd range to overlap the cube boundaries (no
    ! truncation) because the iterator knows how to deal with this
    ! case.
    !
    ! On the other hand, the 2 first dimensions are kept full (no
    ! subset, no surset), because the subcube%get() API is not able
    ! to get a subcube overlapping the boundaries. This is treated
    ! locally with special care in cubemain_extract_prog_act.
    !-----------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    ! Default full dimensions:
    ! - 'code_indx_auto' stand for the dimensions of the cube associated
    !   cube to the entry. Remember that in the current command,
    !   dimensions of the input and output cubes might differ in all
    !   directions.
    ! - explicit values would be used explicitly. This is not what we
    !   want as our input subcubes and output subcubes might differ
    !   in size.
    prog%region%ix%first = code_indx_auto
    prog%region%ix%last = code_indx_auto
    prog%region%iy%first = code_indx_auto
    prog%region%iy%last = code_indx_auto
    prog%region%iz%first = code_indx_auto
    prog%region%iz%last = code_indx_auto
    !
    ! Then subset/surset for the last dimension
    if (prog%ix.eq.3) then
      prog%region%ix%first = prog%range(3,1)
      prog%region%ix%last  = prog%range(3,2)
    elseif (prog%iy.eq.3) then
      prog%region%iy%first = prog%range(3,1)
      prog%region%iy%last  = prog%range(3,2)
    elseif (prog%ic.eq.3) then
      prog%region%iz%first = prog%range(3,1)
      prog%region%iz%last  = prog%range(3,2)
    endif
  end subroutine cubemain_extract_create_region
  !
  subroutine cubemain_extract_prog_header_spectral(prog,error)
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! *** JP *** Think twice before modifying this one!
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    integer(kind=chan_k) :: stride
    type(sperange_prog_t) :: sperange
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER>SPECTRAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Everything below is needed!
    if (prog%doline) then
       call cubetools_header_modify_rest_frequency(prog%line%freq,prog%extracted%head,error)
       if (error) return
       call cubetools_header_put_line(prog%line%name,prog%extracted%head,error)
       if (error) return
       call cubetools_header_get_axis_head_f(prog%extracted%head,axis,error)
       if (error) return
       call cubetools_header_update_frequency_from_axis(axis,prog%extracted%head,error)
       if (error) return
    endif
    !
    ! This part of the code has to be executed after the frequency
    ! modification otherwise the range of velocities is wrong!
    call prog%sperange%toprog(prog%extracted,code_sperange_truncated,sperange,error)
    if (error) return
    call sperange%to_chan_k(prog%range(prog%ic,1),prog%range(prog%ic,2),stride,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_c(prog%extracted%head,axis,error)
    if (error) return
    axis%n = prog%range(prog%ic,2)-prog%range(prog%ic,1)+1
    axis%ref = axis%ref-prog%range(prog%ic,1)+1
    !
    ! This snippet of code was copied from: lib/edit/type-cube-buffer.f90:cubeedit_cube_buffer_resize
    ! This points to the necessity of factorizing this piece of code in lib/tools/header-methods.f90x
    if (axis%kind.eq.code_unit_freq) then
       call cubetools_header_update_frequency_from_axis(axis,prog%extracted%head,error)
       if (error) return
    else if (axis%kind.eq.code_unit_velo) then
       call cubetools_header_update_velocity_from_axis(axis,prog%extracted%head,error)
       if (error) return
    else
       call cubetools_header_update_axset_c(axis,prog%extracted%head,error)
       if (error) return
       call cubemain_message(seve%w,rname,'Unknown kind of Spectral axis')
    endif
  end subroutine cubemain_extract_prog_header_spectral
  !
  subroutine cubemain_extract_prog_header_spatial(prog,error)
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(axis_t) :: laxis, maxis
    character(len=*), parameter :: rname='EXTRACT>PROG>HEADER>SPATIAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_l(prog%extracted%head,laxis,error)
    if (error) return
    laxis%n = prog%range(prog%ix,2)-prog%range(prog%ix,1)+1
    laxis%ref = laxis%ref-1d0*prog%range(prog%ix,1)+1d0
    call cubetools_header_update_axset_l(laxis,prog%extracted%head,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_m(prog%extracted%head,maxis,error)
    if (error) return
    maxis%n = prog%range(prog%iy,2)-prog%range(prog%iy,1)+1
    maxis%ref = maxis%ref-1d0*prog%range(prog%iy,1)+1d0
    call cubetools_header_update_axset_m(maxis,prog%extracted%head,error)
    if (error) return
  end subroutine cubemain_extract_prog_header_spatial
  !
  subroutine cubemain_extract_prog_data(prog,error)
    use cubeadm_opened
    use cubetools_header_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(extract_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='EXTRACT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,prog%region,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) then
          call prog%loop(itertask,error)
       endif
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_extract_prog_data
  !
  subroutine cubemain_extract_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(extract_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXTRACT>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    do while (itertask%iterate_entry(error))
      call prog%act(itertask,error)
      if (error) return
    enddo  ! ientry
  end subroutine cubemain_extract_prog_loop
  !
  subroutine cubemain_extract_prog_act(prog,itertask,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !-------------------------------------------------------------------
    ! Extract from 1 subcube
    !-------------------------------------------------------------------
    class(extract_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    type(subcube_t) :: insub,ousub
    integer(kind=indx_k) :: ix,jx,ixmin,ixmax,ixoff
    integer(kind=indx_k) :: iy,jy,iymin,iymax,iyoff
    integer(kind=indx_k) :: iz,jz,izmin,izmax,izoff
    logical :: overlap
    character(len=*), parameter :: rname='EXTRACT>PROG>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub%associate('insub',prog%cube,itertask,error)
    if (error) return
    call ousub%allocate('ousub',prog%extracted,itertask,error)
    if (error) return
    !
    call insub%get(error)
    if (error) return
    !
    overlap = .false.
    !
    ! 1st dimension
    ixoff = prog%range(1,1)-1
    ixmin = prog%range(1,1)
    if (ixmin.lt.1) then
      overlap = .true.
      ixmin = 1
    endif
    ixmax = prog%range(1,2)
    if (ixmax.gt.insub%nx) then
      overlap = .true.
      ixmax = insub%nx
    endif
    !
    ! 2nd dimension
    iyoff = prog%range(2,1)-1
    iymin = prog%range(2,1)
    if (iymin.lt.1) then
      overlap = .true.
      iymin = 1
    endif
    iymax = prog%range(2,2)
    if (iymax.gt.insub%ny) then
      overlap = .true.
      iymax = insub%ny
    endif
    !
    ! 3rd dimension: subcubes
    izoff = insub%v3shift
    izmin = 1
    izmax = insub%nz
    if (izmax.gt.insub%nvalid3) then
      overlap = .true.
      izmax = insub%nvalid3
    endif
    !
    ! In case of surset extraction, initialize the new bits to NaN.
    ! For simplicity, initialize everything. NaN will be overwritten by
    ! valid values afterwards.
    if (overlap) then
      call ousub%set(gr4nan,error)
      if (error) return
    else
       continue ! No overlap cube boundaries, no init
    endif
    !
    do iz=izmin,izmax
      jz = iz-izoff
      do iy=iymin,iymax
        jy = iy-iyoff
        do ix=ixmin,ixmax
          jx = ix-ixoff
          ousub%val(jx,jy,jz) = insub%val(ix,iy,iz)
        enddo ! ix
      enddo ! iy
    enddo ! iz
    !
    call ousub%put(error)
    if (error) return
  end subroutine cubemain_extract_prog_act
end module cubemain_extract
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine dosmoo(raw,gwe,nc,nx,ny,map,mapx,mapy,sup,cell)
  !---------------------------------------------------------------------
  ! @ private
  ! Smooth an input data cube in VLM along L and M by convolution
  ! with a gaussian...
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: nc,nx,ny       ! Cube size
  real(kind=4),    intent(in)  :: raw(nc,nx,ny)  ! Raw cube
  real(kind=4),    intent(in)  :: gwe(nx,ny)     ! Gridded weights Not used ???? JP
  real(kind=4),    intent(out) :: map(nc,nx,ny)  ! Smoothed cube
  real(kind=4),    intent(in)  :: mapx(nx)       ! Arrays of gridded coordinates
  real(kind=4),    intent(in)  :: mapy(ny)       ! Arrays of gridded coordinates
  real(kind=4),    intent(in)  :: sup(2)         ! Convolving function support size in user unit
  real(kind=4),    intent(in)  :: cell(2)        ! Pixel size in user unit
  ! Local
  integer :: yfirs,ylast          ! Range to be considered
  integer :: xfirs,xlast          ! Range to be considered
  integer :: ix,iy,ic
  integer :: jx,jy                ! X coord, Y coord location in RAW
  real :: result,weight
  real :: u,v,du,dv,um,up,vm,vp,dx,dy
  !
  dx = abs(mapx(2)-mapx(1))
  dy = abs(mapy(2)-mapy(1))
  !
  ! Loop on Y rows
  do iy=1,ny
     v = mapy(iy)
     vm = v-sup(2)
     vp = v+sup(2)
     yfirs = max(1,nint((iy-sup(2)/dy)))
     ylast = min(ny,nint((iy+sup(2)/dy)))
     !
     ! Initialize X column
     do ix=1,nx
        do ic=1,nc
           map(ic,ix,iy) = 0.0
        enddo
     enddo
     !
     ! Loop on X cells
     if (yfirs.le.ylast) then
        do ix=1,nx
           u = mapx(ix)
           um = u-sup(1)
           up = u+sup(1)
           weight = 0.0
           xfirs = max(1,nint(ix-sup(1)/dx))
           xlast = min(nx,nint(ix+sup(1)/dx))
           !
           ! Do while in X cell
           if (xfirs.le.xlast) then
              do jy=yfirs,ylast
                 dv = (v-mapy(jy))/cell(2)
                 do jx=xfirs,xlast
                    du = (u-mapx(jx))/cell(1)
                    call convol(du,dv,result)
                    if (result.ne.0.0) then
                       weight = weight + result
                       do ic=1,nc
                          map(ic,ix,iy) = map(ic,ix,iy) + raw(ic,jx,jy)*result
                       enddo
                    endif
                 enddo
              enddo
              !
              ! Normalize weight only in cells where some data exists...
              if (weight.ne.0.0) then
                 weight = 1.0/weight
                 do ic=1,nc
                    map (ic,ix,iy) = map(ic,ix,iy)*weight
                 enddo
              endif
           endif
        enddo
     endif
  enddo
end subroutine dosmoo
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine doapod(xmin,xmax,ymin,ymax,tole,beam, &
     nc,nx,ny,map,raw,mapx,mapy,gweight,wmin)
  !---------------------------------------------------------------------
  ! @ private
  ! Replace the original (RAW) data by an apodized version
  !   - outside of the sampled region (map edges to smoothly go to zero)
  !   - and where the weight is below the minimum value (bad data points)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: xmin,xmax       ! Boundary of sampled region
  real(kind=4),    intent(in)    :: ymin,ymax       ! Boundary of sampled region
  real(kind=4),    intent(in)    :: tole            ! X-Y position tolerance
  real(kind=4),    intent(in)    :: beam            ! Beam size
  integer(kind=4), intent(in)    :: nc,nx,ny        ! Cube size
  real(kind=4),    intent(in)    :: map(nc,nx,ny)   ! Smoothed cube
  real(kind=4),    intent(inout) :: raw(nc,nx,ny)   ! Original cube
  real(kind=4),    intent(in)    :: mapx(nx)        ! Arrays of gridded coordinates
  real(kind=4),    intent(in)    :: mapy(ny)        ! Arrays of gridded coordinates
  real(kind=4),    intent(in)    :: gweight(nx,ny)  ! Gridded weights
  real(kind=4),    intent(in)    :: wmin            ! Minimum weight
  ! Local
  integer :: ic,ix,iy
  real :: lobe,apod,disty,distx,pi
  !
  pi = acos(-1.0)
  write(6,*) 'Min-Max ',xmin,xmax,ymin,ymax
  write(6,*) 'Beam, Tolerance, Increment ',beam*180*3600/pi,tole*180*3600/pi   &
       &    ,(mapx(1)-mapx(2))*180*3600/pi,'"'
  ! Use a beam size twice larger
  lobe = log(2.0)/beam**2
  do iy=1,ny
     if (mapy(iy).le.ymin-tole) then
        disty = ymin-mapy(iy)
     elseif (mapy(iy).ge.ymax+tole) then
        disty = mapy(iy)-ymax
     else
        disty = 0.0
     endif
     do ix=1,nx
        if (mapx(ix).le.xmin-tole) then
           distx = xmin-mapx(ix)
        elseif (mapx(ix).ge.xmax+tole) then
           distx = mapx(ix)-xmax
        else
           distx = 0.0
        endif
        apod = (distx**2+disty**2)*lobe
        if (apod.gt.80) then
           do ic=1,nc
              raw(ic,ix,iy) = 0.0
           enddo
        elseif  (apod.ne.0.0) then
           apod = exp(-apod)
           do ic=1,nc
              raw(ic,ix,iy) = map(ic,ix,iy)*apod
           enddo
        elseif (gweight(ix,iy).lt.wmin) then
           do ic=1,nc
              raw(ic,ix,iy) = map(ic,ix,iy)
           enddo
        endif
     enddo
  enddo
end subroutine doapod
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function nearest_power_of_two(n)
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  integer(kind=4) :: nearest_power_of_two  ! Function value on return
  integer(kind=4), intent(in) :: n          !
  ! Local
  real(kind=4) :: r
  integer(kind=4) :: i
  !
  r = real(n)
  r = log(r)/log(2.0)
  i = int(r)
  if (i.ne.r) i = i+1
  nearest_power_of_two = 2**i
end function nearest_power_of_two
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_get
  use cubetools_parameters
  use cubetools_structure
  use cubetools_userspace
  use cubesyntax_keyval_types
  use cubeedit_messaging
  use cubeedit_getdata
  use cubeedit_getheader_tool
  !
  public :: get
  private
  !
  type :: get_comm_t
     type(option_t), pointer  :: comm
     type(value_strg_comm_t)  :: edid
     type(userspace_opt_t)    :: into
     type(getheader_comm_t)   :: head
     type(getdata_comm_t)     :: data
   contains
     procedure, public  :: register => cubeedit_get_comm_register
     procedure, private :: parse    => cubeedit_get_comm_parse
     procedure, private :: main     => cubeedit_get_comm_main 
  end type get_comm_t
  type(get_comm_t) :: get
  !
  type :: get_user_t
     logical :: dolist = .false.
     type(value_strg_user_t) :: edid
     type(userspace_user_t)  :: into
     type(getheader_user_t)  :: head
     type(getdata_user_t)    :: data
   contains
     procedure, private :: toprog => cubeedit_get_user_toprog
  end type get_user_t
  !
  type :: get_prog_t
     character(len=varn_l)   :: edid = strg_unk
     !type(userspace_prog_t) :: into
     type(getheader_prog_t)  :: head
     !type(getdata_prog_t)   :: data
   contains
     procedure, private :: list => cubeedit_get_prog_act_list
     procedure, private :: get  => cubeedit_get_prog_act_get
  end type get_prog_t
  type(get_prog_t) :: get_prog
  !
contains
  !
  subroutine cubeedit_get_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command GET
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(get_user_t) :: user
    character(len=*), parameter :: rname='GET>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call get%parse(line,user,error)
    if (error) return
    call get%main(user,error)
    if (error) return
  end subroutine cubeedit_get_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_get_comm_register(comm,error)
    !-------------------------------------------------------------------
    ! Register GO\GET command and its keys
    !-------------------------------------------------------------------
    class(get_comm_t), intent(inout) :: comm
    logical,           intent(inout) :: error
    !
    logical, parameter :: iterator = .true.
    character(len=*), parameter :: rname='GET>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'GET','[bufferid]',&
         'Get array or header information from an edited buffer',&
         'Get header and data information from an opened edited buffer into SIC&
         & variables. Without options, GET lists available header/data&
         & retrieval buffers.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /INTO controls destination userspace; default parent structure&
         & name is EDITGET.'//strg_cr//&
         '- Header selectors (/AXIS, /SHAPE, /UNIT, /EXTREMA, /NOISE,&
         & /SPATIALFRAME, /SOURCE, /PTYPE, /PCENTER, /PANGLE, /BEAM,&
         & /SPECTRALFRAME, /VELOCITY, /REDSHIFT, /LINE, /FREQUENCY,&
         & /WAVELENGTH, /OBSERVATORY, /ID, /TUPLE, /PARENTS,&
         & /CHILDREN, /TWINS) fetch metadata fields.'//strg_cr//&
         '- Data selectors (/ZERO, /FIRST, /LAST, /NEXT, /PREVIOUS,&
         & /AFTERLAST, /CURRENT, /ENTRY, /PIXEL, /CHANNEL, /CUBE)&
         & choose data extraction mode.'//strg_cr//&
         '- Data selectors are mutually exclusive per command call.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- GET is read-only. Use PUT to write modifications into an&
         & edited buffer.'//strg_cr//&
         '- The edited buffer is registered in the DAG only after CLOSE.'&
         //strg_cr//&
         '- Complex spectrum and complex full-cube fetch paths are&
         & unsupported.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> GET'//strg_cr//&
         'CUBE> GET myedit /SHAPE /INTO info'//strg_cr//&
         'CUBE> GET myedit /CHANNEL 10 /INTO spec'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN myedit /LIKE source_cube'//strg_cr//&
         'CUBE> GET myedit /SHAPE /INTO info'//strg_cr//&
         'CUBE> GET myedit /CHANNEL 10 /INTO spec'//strg_cr//&
         'CUBE> PUT myedit ...'//strg_bl//&
         'Use GET outputs as inspection inputs for later PUT updates.',&
         cubeedit_get_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%edid%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_star,&
         code_arg_optional,&
         strg_emp,&
         error)
    if (error) return
    call get%into%register(error)
    if (error) return
    call get%head%register(get_prog%edid,get%into,error)
    if (error) return
    call get%data%register(get%into,access_is_fixed,iterator,error)
    if (error) return
  end subroutine cubeedit_get_comm_register
  !
  subroutine cubeedit_get_comm_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(get_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(get_user_t),  intent(inout) :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (cubetools_nopt().eq.0) then
       user%dolist = .true.
    else
       user%dolist = .false.
       call comm%edid%parse(line,comm%comm,user%edid,error)
       if (error) return
       call comm%into%parse(line,user%into,error)
       if (error) return
       call comm%head%parse(line,user%into,user%head,error)
       if (error) return
       call comm%data%parse(line,user%into,user%data,error)
       if (error) return
    endif
  end subroutine cubeedit_get_comm_parse
  !
  subroutine cubeedit_get_comm_main(comm,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(get_comm_t), intent(in)    :: comm
    type(get_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(get_prog_t) :: prog
    character(len=*), parameter :: rname='GET>COMM>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (user%dolist) then
       call prog%list(error)
       if (error) return
       !***JP: The following one should be transfered to cubeedit_get_prog_list after standardization of cubeedit_getdata
       call comm%data%list(error)
       if (error) return
    else
       call user%toprog(comm,prog,error)
       if (error) return
       call prog%get(comm,user,error)
       if (error) return
    endif
  end subroutine cubeedit_get_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_get_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(get_user_t), intent(in)    :: user
    type(get_comm_t),  intent(in)    :: comm    
    type(get_prog_t),  intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%edid%toprog(comm%edid,prog%edid,error)
    if (error) return    
    call user%head%toprog(comm%head,'EDITGET',user%data%do,prog%head,error)
    if (error) return
  end subroutine cubeedit_get_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_get_prog_act_list(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(get_prog_t), intent(in)    :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>PROG>ACT>LIST'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call prog%head%list(error)
    if (error) return
    !call prog%data%list(error)
    !if (error) return
  end subroutine cubeedit_get_prog_act_list
  !
  subroutine cubeedit_get_prog_act_get(prog,comm,user,error)
    use cube_types
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(get_prog_t), intent(inout) :: prog
    type(get_comm_t),  intent(in)    :: comm    
    type(get_user_t),  intent(in)    :: user !***JP: Should be removed
    logical,           intent(inout) :: error
    !
    integer(kind=entr_k) :: ie
    type(cube_t), pointer :: cube
    character(len=*), parameter :: rname='GET>PROG>ACT>GET'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_cube_pointer(prog%edid,cube,error)
    if (error) return
    ! As of today, data access can only be done on a cube_t. But header
    ! access can be done on any format_t
    prog%head%cube => cube
    call prog%head%get(error)
    if (error) return
    if (user%data%do) then
       call opened%get_cube_entry(prog%edid,ie,error)
       if (error) return   
       call comm%data%get(user%data,cube,'EDITGET',user%head%present,ie,error)
       if (error) return
       call opened%set_cube_entry(prog%edid,ie,error)
       if (error) return   
    endif
  end subroutine cubeedit_get_prog_act_get
end module cubeedit_get
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_spectral_fit
  use fit_minuit ! From GILDAS kernel
  use cubefit_messaging
  use cubefit_parameters
  use cubefit_spectral_obs
  use cubefit_spectral_parameters
  use cubefit_hfs
  !
  public :: fit_spectral_t,cubefit_parameters_npars_nout,cubefit_parameters_flags,cubefit_parameters_units
  private
  !
  integer(kind=code_k), parameter :: migrad_noimprov = 1
  integer(kind=code_k), parameter :: migrad_diverged = 3
  !
  integer(kind=code_k), parameter :: code_oper_minimize = 1
  integer(kind=code_k), parameter :: code_oper_iterate  = 2
  !
  type fit_spectral_t
     private
     type(fit_minuit_t)            :: minuit
     type(spectral_pars_t)         :: par
     type(spectral_obs_t)          :: obs
     type(hfs_prog_t),     pointer :: hfs
     integer(kind=chan_k), pointer :: wind(:) => null()
     logical                       :: usewind = .false.
     !
     integer(kind=code_k) :: status = code_status_unfitted
     integer(kind=code_k) :: oper   = code_oper_minimize
     !
     procedure(cubefit_spectral_init_interface),      nopass, pointer :: init     => null()
     procedure(cubefit_spectral_minimize_interface),  nopass, pointer :: mini     => null()
     procedure(cubefit_spectral_extract_interface),   nopass, pointer :: extr     => null()
     procedure(cubefit_spectral_residuals_interface), nopass, pointer :: resi     => null()
     procedure(cubefit_spectral_user2par_interface),  nopass, pointer :: user2par => null()
     procedure(cubefit_spectral_par2spec_interface),  nopass, pointer :: par2spec => null()
     procedure(cubefit_spectral_spec2par_interface),  nopass, pointer :: spec2par => null()
     procedure(cubefit_spectral_iterate_interface),   nopass, pointer :: iterate  => null()
     procedure(cubefit_spectral_wind2par_interface),  nopass, pointer :: wind2par => null()
     procedure(cubefit_spectral_profile_interface),   nopass, pointer :: prof     => null()
   contains
     procedure :: user_import => cubefit_minuit_user2par
     procedure :: spec_import => cubefit_minuit_spec2par
     procedure :: wind_import => cubefit_minuit_load_window
     procedure :: check_hfs   => cubefit_minuit_check_hfs
     procedure :: fit         => cubefit_minuit_fit
     procedure :: consistency => cubefit_minuit_consistency
     procedure :: export      => cubefit_minuit_export
     procedure :: residuals   => cubefit_minuit_residuals
     procedure :: profile     => cubefit_minuit_profile
  end type fit_spectral_t
  !
contains
  !
  subroutine cubefit_spectral_init_interface(par,obs,minuit,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(spectral_pars_t), intent(inout) :: par
    type(spectral_obs_t),  intent(in)    :: obs
    type(fit_minuit_t),    intent(inout) :: minuit
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_init_interface
  !
  subroutine cubefit_spectral_minimize_interface(npar,grad,chi2,pars,iflag,obs)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=npar_k),   intent(in)    :: npar        ! Number of parameters
    real(kind=grad_k),      intent(out)   :: grad(npar)  ! Gradients
    real(kind=chi2_k),      intent(out)   :: chi2        ! chi squared
    real(kind=para_k),      intent(in)    :: pars(npar)  ! Parameter values
    integer(kind=4),        intent(in)    :: iflag       ! Code operation
    type(spectral_obs_t),   intent(inout) :: obs         ! Observation
  end subroutine cubefit_spectral_minimize_interface
  !
  subroutine cubefit_spectral_extract_interface(minuit,obs,par,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(fit_minuit_t),    intent(inout) :: minuit
    type(spectral_obs_t),  intent(inout) :: obs
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_extract_interface
  !
  subroutine cubefit_spectral_residuals_interface(obs,spec,error)
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! 
    !------------------------------------------------------------------------
    type(spectral_obs_t), intent(inout) :: obs          
    type(spectrum_t),     intent(inout) :: spec         
    logical,              intent(inout) :: error
  end subroutine cubefit_spectral_residuals_interface
  !
  subroutine cubefit_spectral_profile_interface(ifunc,obs,spec,error)
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! 
    !------------------------------------------------------------------------
    integer(kind=func_k), intent(in)    :: ifunc
    type(spectral_obs_t), intent(inout) :: obs  
    type(spectrum_t),     intent(inout) :: spec         
    logical,              intent(inout) :: error
  end subroutine cubefit_spectral_profile_interface
  !
  subroutine cubefit_spectral_user2par_interface(flag,pars,par,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=flag_k),  intent(in)    :: flag(:)
    real(kind=para_k),     intent(in)    :: pars(:)
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_user2par_interface
  !
  subroutine cubefit_spectral_par2spec_interface(par,spec,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectral_pars_t), intent(in)    :: par
    type(spectrum_t),      intent(inout) :: spec
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_par2spec_interface
  !
  subroutine cubefit_spectral_spec2par_interface(spec,par,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectrum_t),      intent(in)    :: spec
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_spec2par_interface
  !
  subroutine cubefit_spectral_iterate_interface(par,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_iterate_interface
  !
  subroutine cubefit_spectral_wind2par_interface(obs,wind,par,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spectral_obs_t),  intent(in)    :: obs
    integer(kind=chan_k),  intent(in)    :: wind(:)
    type(spectral_pars_t), intent(inout) :: par
    logical,               intent(inout) :: error
  end subroutine cubefit_spectral_wind2par_interface
  !
  !--------------------------------------------------------------------------------
  !
  subroutine cubefit_minuit_set_method(fit,method,error)
    use cubefit_function_spectral_absorption
    use cubefit_function_spectral_gaussian
    use cubefit_function_spectral_hfs
    use cubefit_function_spectral_shell
    !------------------------------------------------------------------------
    ! Set the method to be used on the fit
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit
    integer(kind=code_k),  intent(in)    :: method
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname="MINUIT>SET>METHOD"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    select case(method)
    case(code_method_gaussian)
       fit%init     => cubefit_function_spectral_gaussian_init      ! Equivalent to CLASS's midgauss.f90 
       fit%mini     => cubefit_function_spectral_gaussian_minimize  ! Equivalent to CLASS's mingauss.f90
       fit%extr     => cubefit_function_spectral_gaussian_extract   ! Part of fitgauss in minimize.f90
       fit%resi     => cubefit_function_spectral_gaussian_residuals ! New functionality
       fit%user2par => cubefit_function_spectral_gaussian_user2par  ! Similar to CLASS's guegauss in lines.f90
       fit%par2spec => cubefit_function_spectral_gaussian_par2spec  ! New functionality
       fit%spec2par => cubefit_function_spectral_gaussian_spec2par  ! New functionality
       fit%iterate  => cubefit_function_spectral_gaussian_iterate   ! Similar to CLASS's itegauss in iterate.f90
       fit%wind2par => cubefit_function_spectral_gaussian_wind2par  ! Similar to CLASS's guegauss in lines.f90
       fit%prof     => cubefit_function_spectral_gaussian_doprofile ! New functionality
    case(code_method_absorption)
       fit%init     => cubefit_function_spectral_absorption_init      ! Equivalent to CLASS's midabs.f90 
       fit%mini     => cubefit_function_spectral_absorption_minimize  ! Equivalent to CLASS's minabs.f90
       fit%extr     => cubefit_function_spectral_absorption_extract   ! Part of fitabs in minimize.f90
       fit%resi     => cubefit_function_spectral_absorption_residuals ! New functionality
       fit%user2par => cubefit_function_spectral_absorption_user2par  ! Similar to CLASS's gueabs in lines.f90
       fit%par2spec => cubefit_function_spectral_absorption_par2spec  ! New functionality
       fit%spec2par => cubefit_function_spectral_absorption_spec2par  ! New functionality
       fit%iterate  => cubefit_function_spectral_absorption_iterate   ! Similar to CLASS's iteabs in iterate.f90
       fit%wind2par => cubefit_function_spectral_absorption_wind2par  ! Similar to CLASS's gueabs in lines.f90
       fit%prof     => cubefit_function_spectral_absorption_doprofile ! New functionality
    case(code_method_shell)
       fit%init     => cubefit_function_spectral_shell_init      ! Equivalent to CLASS's midshell.f90 
       fit%mini     => cubefit_function_spectral_shell_minimize  ! Equivalent to CLASS's minshell.f90
       fit%extr     => cubefit_function_spectral_shell_extract   ! Part of fitabs in minimize.f90
       fit%resi     => cubefit_function_spectral_shell_residuals ! New functionality
       fit%user2par => cubefit_function_spectral_shell_user2par  ! Similar to CLASS's gueshell in lines.f90
       fit%par2spec => cubefit_function_spectral_shell_par2spec  ! New functionality
       fit%spec2par => cubefit_function_spectral_shell_spec2par  ! New functionality
       fit%iterate  => cubefit_function_spectral_shell_iterate   ! Similar to CLASS's iteshell in iterate.f90
       fit%wind2par => cubefit_function_spectral_shell_wind2par  ! Similar to CLASS's gueshell in lines.f90
       fit%prof     => cubefit_function_spectral_shell_doprofile ! New functionality
    case(code_method_hfs)
       fit%init     => cubefit_function_spectral_hfs_init      ! Equivalent to CLASS's midnh3.f90 
       fit%mini     => cubefit_function_spectral_hfs_minimize  ! Equivalent to CLASS's minnh3.f90
       fit%extr     => cubefit_function_spectral_hfs_extract   ! Part of fitnh3 in minimize.f90
       fit%resi     => cubefit_function_spectral_hfs_residuals ! New functionality
       fit%user2par => cubefit_function_spectral_hfs_user2par  ! Similar to CLASS's guenh3 in lines.f90
       fit%par2spec => cubefit_function_spectral_hfs_par2spec  ! New functionality
       fit%spec2par => cubefit_function_spectral_hfs_spec2par  ! New functionality
       fit%iterate  => cubefit_function_spectral_hfs_iterate   ! Similar to CLASS's itenh3 in iterate.f90
       fit%wind2par => cubefit_function_spectral_hfs_wind2par  ! Similar to CLASS's guenh3 in lines.f90
       fit%prof     => cubefit_function_spectral_hfs_doprofile ! New functionality
    case default
       call cubefit_message(seve%e,rname,"Unrecognized method")
       error = .true.
       return
    end select
  end subroutine cubefit_minuit_set_method
  !
  subroutine cubefit_minuit_user2par(fit,hfs,npar,method,nfunc,flag,pars,error)
    !----------------------------------------------------------------------
    ! Initialize parameters according to user inputs
    !----------------------------------------------------------------------
    class(fit_spectral_t),    intent(inout) :: fit
    type(hfs_prog_t), target, intent(in)    :: hfs
    integer(kind=npar_k),     intent(in)    :: npar
    integer(kind=code_k),     intent(in)    :: method
    integer(kind=func_k),     intent(in)    :: nfunc
    integer(kind=flag_k),     intent(in)    :: flag(:)
    real(kind=para_k),        intent(in)    :: pars(:)
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname="MINUIT>USER2PAR"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubefit_minuit_set_method(fit,method,error)
    if (error) return
    !
    call fit%check_hfs(method,hfs,error)
    if (error) return
    call fit%par%init(npar,method,nfunc,error)
    if (error) return
    if (nfunc.gt.0) then
       call fit%user2par(flag,pars,fit%par,error)
       if (error) return
    endif
    fit%oper = code_oper_minimize
  end subroutine cubefit_minuit_user2par
  !
  subroutine cubefit_minuit_spec2par(fit,hfs,spec,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! Initialize parameters according to user inputs
    !----------------------------------------------------------------------
    class(fit_spectral_t),    intent(inout) :: fit
    type(hfs_prog_t), target, intent(in)    :: hfs
    type(spectrum_t),         intent(in)    :: spec         
    logical,                  intent(inout) :: error
    !
    integer(kind=func_k) :: nfunc
    integer(kind=npar_k) :: npar
    integer(kind=chan_k) :: nout
    integer(kind=code_k) :: method
    character(len=*), parameter :: rname="MINUIT>SPEC2PAR"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    method  =  nint(spec%t(icol_method),npar_k)
    nfunc   =  nint(spec%t(icol_nfunc),func_k)
    !
    call fit%check_hfs(method,hfs,error)
    if (error) return
    !
    call cubefit_parameters_npars_nout(method,nfunc,npar,nout,error)
    if (error) return
    !
    call cubefit_minuit_set_method(fit,method,error)
    if (error) return
    !
    call fit%par%init(npar,method,nfunc,error)
    if (error) return
    call fit%spec2par(spec,fit%par,error)
    if (error) return
    !
    fit%oper = code_oper_iterate
  end subroutine cubefit_minuit_spec2par
  !
  subroutine cubefit_minuit_load_window(fit,hfs,method,wind,error)
    !----------------------------------------------------------------------
    ! Load a window onto the fit and allocate parameters
    !----------------------------------------------------------------------
    class(fit_spectral_t),        intent(inout) :: fit
    type(hfs_prog_t),     target, intent(in)    :: hfs
    integer(kind=code_k),         intent(in)    :: method
    integer(kind=chan_k), target, intent(in)    :: wind(:)        
    logical,                      intent(inout) :: error
    !
    integer(kind=func_k) :: nfunc
    integer(kind=npar_k) :: npar
    integer(kind=chan_k) :: nout
    character(len=*), parameter :: rname="MINUIT>LOAD>WINDOW"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call fit%check_hfs(method,hfs,error)
    if (error) return
    !
    ! VVV Should there be a test for window size?
    nfunc = size(wind)/2
    fit%wind => wind
    fit%usewind = .true.
    call cubefit_parameters_npars_nout(method,nfunc,npar,nout,error)
    if (error) return
    call cubefit_minuit_set_method(fit,method,error)
    if (error) return
    call fit%par%init(npar,method,nfunc,error)
    if (error) return
    !
    fit%oper = code_oper_minimize
  end subroutine cubefit_minuit_load_window
  !
  subroutine cubefit_minuit_check_hfs(fit,method,hfs,error)
    !----------------------------------------------------------------------
    ! Check if fit needs a HFS structure and if it is loaded
    !----------------------------------------------------------------------
    class(fit_spectral_t),    intent(inout) :: fit
    integer(kind=code_k),     intent(in)    :: method
    type(hfs_prog_t), target, intent(in)    :: hfs
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname="MINUIT>CHECK>HFS"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    fit%hfs => hfs
    select case(method)
    case(code_method_hfs,code_method_absorption)
       if (.not.fit%hfs%loaded) then
          call cubefit_message(seve%e,rname,"No hyperfine structure loaded")
          error = .true.
          return
       endif
!!$    case(inh31,inh32,inh33)
!!$       call cubefit_hfs_nh3(method,fit%hfs,error)
!!$       if (error) return
    end select
  end subroutine cubefit_minuit_check_hfs
  !
  subroutine cubefit_minuit_fit(fit,spec,wind,error)
    use gkernel_interfaces
    use cubemain_windowing
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! Executes the minuit fit
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit          ! Fit spectral object
    type(spectrum_t),      intent(inout) :: spec         ! Observation
    type(window_array_t),  intent(in)    :: wind         ! Window
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname="MINUIT>FIT"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !    
    ! Initialize fit%obs
    call fit%obs%init(fit%hfs,fit%par,spec,wind,error)
    if (error) return
    !
    ! Initialize first guesses based on a window
    if (fit%usewind) then
       call fit%wind2par(fit%obs,fit%wind,fit%par,error)
       if (error) return
    endif
    !
    ! Minuit initialization:
    fit%minuit%owner = gpack_get_id('cube',.true.,error)
    if (error) return
    fit%minuit%maxext=ntot
    fit%minuit%maxint=nvar
    fit%minuit%verbose=.false.
    fit%minuit%isw(1:7) = 0
    fit%minuit%sigma  = 0.d0
    fit%minuit%npfix  = 0
    fit%minuit%nu     = 0
    fit%minuit%npar   = 0
    fit%minuit%u(1:fit%minuit%maxext)      = 0.0d0
    fit%minuit%lcode(1:fit%minuit%maxext)  = 0
    fit%minuit%lcorsp(1:fit%minuit%maxext) = 0
    fit%minuit%isw(5) = 1
    fit%minuit%g(:) = 0.d0
    ! Minuit keeps a pointer to the observation
    fit%minuit%data = locwrd(fit%obs)
    !
    ! Method dependant initialization
    if (fit%oper.eq.code_oper_iterate) then
       call fit%iterate(fit%par,error)
       if (error) return
    endif
    call fit%init(fit%par,fit%obs,fit%minuit,error)
    if (error) return
    !
    call fit%consistency(error)
    if (error) return
    call intoex(fit%minuit,fit%minuit%x)
    fit%minuit%up = 0.5*(fit%obs%sigbase**2+fit%obs%sigline**2)
    fit%minuit%nfcnmx  = 1000
    fit%minuit%epsi  = 0.1d0 * fit%minuit%up
    fit%minuit%newmin  = 0
    fit%minuit%itaur  = 0
    fit%minuit%isw(1)  = 0
    fit%minuit%isw(3)  = 1
    fit%minuit%nfcn = 1
    fit%minuit%vtest  = 0.04
    call fit%mini(fit%minuit%npar,fit%minuit%g,fit%minuit%amin,fit%minuit%u,code_minuit_value,fit%obs)
    !
    !------------------------------------------------------------------------
    !
    ! Do Simplex Minimisation:
    call simplx(fit%minuit,fit%mini,ier)
    if (ier.ne.0) then
       call cubefit_message(fitseve%others,rname,'Simplex Fit diverged')
       fit%status = code_status_diverged
       return
    endif
    call fit%extr(fit%minuit,fit%obs,fit%par,error)
    if (error) return
    !
    ! Gradient Minimization
    call intoex(fit%minuit,fit%minuit%x)
    call fit%mini(fit%minuit%npar,fit%minuit%g,fit%minuit%amin,fit%minuit%u,code_minuit_rms,fit%obs) 
    !
    fit%minuit%up = fit%obs%sigbase**2
    fit%minuit%epsi  = 0.1d0 * fit%minuit%up
    fit%minuit%apsi  = fit%minuit%epsi
    call hesse(fit%minuit,fit%mini)
    call migrad(fit%minuit,fit%mini,ier)
    if (ier.eq.migrad_noimprov) then
       call hesse(fit%minuit,fit%mini)
       ier = 0
    elseif (ier.eq.migrad_diverged) then
       call cubefit_message(fitseve%others,rname,'Solution not converged')
       ier = 0
       fit%status = code_status_diverged
    endif
    fit%status = code_status_converged
    !    
  end subroutine cubefit_minuit_fit
  !
  subroutine cubefit_minuit_consistency(fit,error)
    use gkernel_interfaces
    !------------------------------------------------------------------------
    ! Checks minuit consistency and set steps
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit          ! Fit spectral object
    logical,               intent(inout) :: error
    !
    real(kind=8) :: sav,sav2
    real(kind=coor_k) :: vplu,vminu
    character(len=mess_l) :: mess
    integer(kind=4) :: ninte,ipara,ifatal
    character(len=*), parameter :: rname="MINUIT>CONSISTENCY"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    ifatal = 0
    ninte  = 0
    do ipara= 1, fit%minuit%nu
       if (ipara.gt.fit%minuit%maxext) then
          ifatal = ifatal+1
       else if (fit%minuit%werr(ipara).le.0.d0) then
          ! Fixed parameter
          fit%minuit%lcode(ipara) = 0
          write(mess,'(a,i3,a)') "Parameter",ipara," is fixed"
          call cubefit_message(fitseve%others,rname,mess)
       else
          ! Variable parameter
          ninte = ninte + 1
          ! Parameter with limits
          if (fit%minuit%lcode(ipara).ne.1) then
             fit%minuit%lcode(ipara) = 4
             sav = (fit%minuit%blim(ipara)-fit%minuit%u(ipara))*(fit%minuit%u(ipara)-fit%minuit%alim(ipara))
             if (sav.lt.0d0) then
                ifatal = ifatal + 1
                write(mess,'(a,i0,3(a,f0.3))') 'Parameter #',ipara,' (',fit%minuit%u(ipara),&
                     ') outside limits ',fit%minuit%alim(ipara),' to ',fit%minuit%blim(ipara)
                call cubefit_message(seve%e,rname,mess)
             else if (sav.eq.0d0) then
                write(mess,'(a,i3,a)') "Parameter",ipara," is at limit"
                call cubefit_message(fitseve%others,rname,mess)
             endif
          endif
       endif
    enddo
    !
    ! End parameter cards
    ! Stop if fatal error
    if (ninte.gt.fit%minuit%maxint)  then
       write(mess,1008) ninte,fit%minuit%maxint
       call cubefit_message(seve%e,rname,mess)
       ifatal = ifatal + 1
    endif
    if (ninte .eq. 0) then
       call cubefit_message(seve%e,rname,'All input parameters are fixed')
       ifatal = ifatal + 1
    endif
    if (ifatal.gt.0)  then
       write(mess,'(I0,A)')  ifatal,' errors on input parameters, abort.'
       call cubefit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    ! O.K. Start
    ! Calculate step sizes DIRIN
    fit%minuit%npar = 0
    do ipara= 1, fit%minuit%nu
       if (fit%minuit%lcode(ipara) .gt. 0)  then
          fit%minuit%npar         = fit%minuit%npar + 1
          fit%minuit%lcorsp(ipara) = fit%minuit%npar
          sav = fit%minuit%u(ipara)
          fit%minuit%x(fit%minuit%npar)  = pintf(fit%minuit,sav,ipara)
          fit%minuit%xt(fit%minuit%npar) = fit%minuit%x(fit%minuit%npar)
          sav2 = sav + fit%minuit%werr(ipara)
          vplu = pintf(fit%minuit,sav2,ipara) - fit%minuit%x(fit%minuit%npar)
          sav2 = sav - fit%minuit%werr(ipara)
          vminu = pintf(fit%minuit,sav2,ipara) - fit%minuit%x(fit%minuit%npar)
          fit%minuit%dirin(fit%minuit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
       endif
    enddo
    return
    !
1008 format (' Too many variable parameters.  You request ',i5/,   &
          &    ' This version of MINUIT is only dimensioned for ',i4)
  end subroutine cubefit_minuit_consistency
  !
  subroutine cubefit_minuit_export(fit,spec,error)
    use cubetools_nan
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! Export the minuit fit results onto a spectrum type
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit          ! Fit spectral object
    type(spectrum_t),      intent(inout) :: spec         ! exported output
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: il
    integer(kind=npar_k) :: ipara
    real(kind=para_k) :: dx,al,ba,du1,du2
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname="MINUIT>EXPORT"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    spec%t(icol_status) = fit%status
    spec%t(icol_method) = fit%par%method
    spec%t(icol_nfunc)  = max(fit%par%nfunc,1)
    !
    write (mess,'(a,i0)') "Number of calls: ",fit%minuit%nfcn
    call cubefit_message(fitseve%others,rname,mess)
    write (mess,'(a,l)') "Fit converged: ",fit%status.eq.code_status_converged
    call cubefit_message(fitseve%others,rname,mess)
    !
    select case(fit%status)
    case(code_status_converged)
       call fit%extr(fit%minuit,fit%obs,fit%par,error)
       if (error) return
       !
       call fit%mini(fit%minuit%npar,fit%minuit%g,fit%minuit%amin,fit%minuit%u,code_minuit_rms,fit%obs)
       write(mess,1002) fit%obs%sigbase,fit%obs%sigline
       call cubefit_message(fitseve%others,rname,mess)
       fit%minuit%up  = fit%obs%sigbase**2
       do ipara=1,fit%minuit%nu
          il  = fit%minuit%lcorsp(ipara)
          if (il .eq. 0)  then
             fit%minuit%werr(ipara)=0.
          else
             if (fit%minuit%isw(2) .ge. 1)  then
                dx = sqrt(abs(fit%minuit%v(il,il)*fit%minuit%up))
                if (fit%minuit%lcode(ipara) .gt. 1) then
                   al = fit%minuit%alim(ipara)
                   ba = fit%minuit%blim(ipara) - al
                   du1 = al + 0.5d0 *(sin(fit%minuit%x(il)+dx) +1.0d0) * ba - fit%minuit%u(ipara)
                   du2 = al + 0.5d0 *(sin(fit%minuit%x(il)-dx) +1.0d0) * ba - fit%minuit%u(ipara)
                   if (dx .gt. 1.0d0)  du1 = ba
                   dx = 0.5d0 * (abs(du1) + abs(du2))
                endif
                fit%minuit%werr(ipara) = dx
             endif
          endif
       enddo
       !
       call fit%extr(fit%minuit,fit%obs,fit%par,error)
       if (error) return
       !
       spec%t(icol_rmsbase) = fit%obs%sigbase
       spec%t(icol_rmsline) = fit%obs%sigline
       !
       call fit%par2spec(fit%par,spec,error)
       if (error) return
       !
       do ipara=1,fit%par%n
          write(mess,'(a,i0,a,2(1pg14.7))') "Parameter #",ipara," = ",fit%par%pars(ipara),fit%par%errs(ipara)
          call cubefit_message(fitseve%others,rname,mess)
       enddo
    case(code_status_diverged)
       ! Diverged output is NaN
       spec%t(icol_nfunc:spec%n) = gr4nan
    case default
       write(mess,'(a,i0)') "Unknown fit status: ",fit%status
       call cubefit_message(seve%e,rname,mess)
       error = .true.
       return
    end select
1002 format (' RMS of Residuals :  Base = ',1pg9.2,'  Line = ',1pg9.2)
  end subroutine cubefit_minuit_export
  !
  subroutine cubefit_minuit_residuals(fit,spec,error)
    use cubemain_spectrum_real
    !------------------------------------------------------------------------
    ! Compute the residuals of a fit
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit          ! Fit spectral object
    type(spectrum_t),      intent(inout) :: spec         ! Residual output
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname="MINUIT>RESIDUALS"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (spec%n.ne.fit%obs%spec%n) then
       call cubefit_message(seve%e,rname,'Output residuals and input observation have different sizes')
       error = .true.
       return
    endif
    if (fit%status.eq.code_status_converged) then
       call fit%resi(fit%obs,spec,error)
       if (error) return
    else ! If fit diverged residuals are the input spectrum
       spec%t(:) = fit%obs%spec%t(:)
    endif
  end subroutine cubefit_minuit_residuals
  !
  subroutine cubefit_minuit_profile(fit,ifunc,spec,error)
    use cubemain_spectrum_real
    use cubemain_windowing
    !------------------------------------------------------------------------
    ! Compute the profile of a fit
    !------------------------------------------------------------------------
    class(fit_spectral_t), intent(inout) :: fit          ! Fit spectral object
    integer(kind=func_k),  intent(in)    :: ifunc        ! Component to compute profile
    type(spectrum_t),      intent(inout) :: spec         ! Residual output
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname="MINUIT>PROFILE"
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call fit%obs%point(fit%hfs,fit%par,spec,error)
    if (error) return
    call fit%prof(ifunc,fit%obs,spec,error)
    if (error) return
  end subroutine cubefit_minuit_profile
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_npars_nout(method,nfunc,npar,nout,error)
    use cubefit_function_spectral_absorption
    use cubefit_function_spectral_gaussian
    use cubefit_function_spectral_hfs
    use cubefit_function_spectral_shell
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: method
    integer(kind=func_k), intent(in)    :: nfunc
    integer(kind=npar_k), intent(out)   :: npar
    integer(kind=chan_k), intent(out)   :: nout
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PARAMETERS>NPARS>NOUT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    if (nfunc.lt.0) then
       call cubefit_message(seve%e,rname,"Number of lines must be positive")
       error = .true.
       return
    endif
    if (nfunc.gt.10) then
       call cubefit_message(seve%e,rname,"Only up to 10 lines are supported")
       error = .true.
       return
    endif
    select case(method)
    case(code_method_gaussian)
       npar = cubefit_function_spectral_gaussian_npar(max(nfunc,1))
    case(code_method_hfs)
       npar = cubefit_function_spectral_hfs_npar(max(nfunc,1))
    case(code_method_absorption)
       npar = cubefit_function_spectral_absorption_npar(max(nfunc,1))
    case(code_method_shell)
       npar = cubefit_function_spectral_shell_npar(max(nfunc,1))
    case default
       call cubefit_message(seve%e,rname,"Unrecognized method")
       error = .true.
       return
    end select
    nout = 3*npar+ndaps
  end subroutine cubefit_parameters_npars_nout
  !
  subroutine cubefit_parameters_flags(method,ipara,methflag,funcflag,paraflag,error)
    use cubedag_allflags
    use cubefit_function_spectral_absorption
    use cubefit_function_spectral_gaussian
    use cubefit_function_spectral_hfs
    use cubefit_function_spectral_shell
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: method
    integer(kind=npar_k), intent(in)    :: ipara
    type(flag_t),         intent(out)   :: methflag
    type(flag_t),         intent(out)   :: funcflag
    type(flag_t),         intent(out)   :: paraflag
    logical,              intent(inout) :: error
    !
    type(flag_t) :: methflags(nmeth)
    character(len=*), parameter :: rname='PARAMETERS>FLAGS'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    ! *** JP: The following is error-prone because it may be unsynchronized with the
    ! *** JP: definitions in the cubefit_parameters module.
    ! Declare after flags were registered at init time:
    methflags(:) = [flag_gaussian,   &
                   flag_absorption,  &
                   flag_hfs,         &
                   flag_shell]
    !
    methflag = methflags(method)
    select case(method)
    case(code_method_gaussian)
       call cubefit_function_spectral_gaussian_flags(ipara,funcflag,paraflag,error)
       if (error) return    
    case(code_method_hfs)
       call cubefit_function_spectral_hfs_flags(ipara,funcflag,paraflag,error)
       if (error) return                                                         
    case(code_method_absorption)
       call cubefit_function_spectral_absorption_flags(ipara,funcflag,paraflag,error)
       if (error) return                                                         
    case(code_method_shell)
       call cubefit_function_spectral_shell_flags(ipara,funcflag,paraflag,error)
       if (error) return
    case default
       call cubefit_message(seve%e,rname,"Unrecognized method")
       error = .true.
       return
    end select
  end subroutine cubefit_parameters_flags
  !
  subroutine cubefit_parameters_units(method,ipara,unit,error)
    use cubefit_function_spectral_absorption
    use cubefit_function_spectral_gaussian
    use cubefit_function_spectral_hfs
    use cubefit_function_spectral_shell
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: method
    integer(kind=npar_k), intent(in)    :: ipara
    character(len=*),     intent(out)   :: unit
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PARAMETERS>UNITS'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    select case(method)
    case(code_method_gaussian)
       call cubefit_function_spectral_gaussian_units(ipara,unit,error)
       if (error) return    
    case(code_method_hfs)
       call cubefit_function_spectral_hfs_units(ipara,unit,error)
       if (error) return                                                         
    case(code_method_absorption)
       call cubefit_function_spectral_absorption_units(ipara,unit,error)
       if (error) return                                                         
    case(code_method_shell)
       call cubefit_function_spectral_shell_units(ipara,unit,error)
       if (error) return
    case default
       call cubefit_message(seve%e,rname,"Unrecognized method")
       error = .true.
       return
    end select
  end subroutine cubefit_parameters_units
end module cubefit_spectral_fit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_help_tool
  use gbl_message
  use cubetools_parameters
  use cubetools_cmessaging
  !---------------------------------------------------------------------
  ! This module provides methods to display help lines, i.e. lines
  ! with severity xxxseve%help. This is usually trigerred by a command
  ! help (e.g. VIEW ?) or the COLLECT command. Such lines can go either
  ! to screen or to a file (may be with a specific format like Tex or
  ! Markdown)
  !---------------------------------------------------------------------
  !
  type :: help_tool_t
  contains
    procedure, public, nopass :: message    => cubetools_help_message
    procedure, public, nopass :: open_file  => cubetools_help_open_file
    procedure, public, nopass :: close_file => cubetools_help_close_file
  end type help_tool_t
  !
  integer(kind=code_k), parameter :: sevehelp=999  ! Value must not clash with the other seve%
  integer(kind=4) :: help_lun = 0
  !
  public :: help_tool_t,sevehelp
  private
  !
contains
  !
  subroutine cubetools_help_message(message_id,procname,message)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in) :: message_id
    character(len=*), intent(in) :: procname
    character(len=*), intent(in) :: message
    !
    if (help_lun.ne.0) then
      write(help_lun,'(A)')  trim(message)
    else
      call cubetools_cmessage(message_id,seve%r,procname,message)
    endif
  end subroutine cubetools_help_message
  !
  subroutine cubetools_help_open_file(file,error)
    use gkernel_interfaces
    use gpack_def
    !-------------------------------------------------------------------
    ! Open the file where toolseve%help messages will be redirected
    ! as long as the file is not closed.
    ! If the file is closed, these messages go to the terminal.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='HELP>OPEN>FILE'
    !
    ier = sic_getlun(help_lun)
    if (ier.ne.1) then
      call cubetools_cmessage(gpack_global_id,seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    ier = sic_open(help_lun,file,'NEW',.false.)
    if (ier.ne.0) then
      call cubetools_cmessage(gpack_global_id,seve%e,rname,'Cannot open file '//file)
      error = .true.
      call sic_frelun(help_lun)
      return
    endif
  end subroutine cubetools_help_open_file
  !
  subroutine cubetools_help_close_file(error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='HELP>CLOSE>FILE'
    !
    ier = sic_close(help_lun)
    call sic_frelun(help_lun)
    help_lun = 0
  end subroutine cubetools_help_close_file
end module cubetools_help_tool

subroutine write_sdm_focusModel(error)
  !---------------------------------------------------------------------
  ! Write the Focus Model SDM table.
  ! (very much TBD at present)
  !     int sdm_addFocusModelRow ()
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  !type(FocusModelRow) :: fmRow
  !type(FocusModelKey) :: fmKey
  integer ia
  integer sdm_addfocusModelrow, ireturn
  character sdmTable*12
  parameter (sdmTable='FocusModel')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !!fmRow%numCoeff = 1
  !call allocFocusModelRow(fmrow, error)
  if (error) return
  !
  do ia = 1, r_nant
    !ireturn = sdm_addfocusModelrow(fmrow, error)
    if (ireturn.lt.0) then
      call sdmMessageI(8,3,sdmTable   &
        ,'Error in sdm_addFocusModelRow',ireturn)
      goto 99
    endif
    FocusModel_Id(ia) = ireturn
  enddo
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_focusModel
!---------------------------------------------------------------------

*DECK I1MACH
      INTEGER FUNCTION I1MACH (I)
C***BEGIN PROLOGUE  I1MACH
C***PURPOSE  Return integer machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      INTEGER (I1MACH-I)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   I1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument and can be referenced as follows:
C
C        K = I1MACH(I)
C
C   where I=1,...,16.  The (output) value of K above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   I/O unit numbers:
C     I1MACH( 1) = the standard input unit.
C     I1MACH( 2) = the standard output unit.
C     I1MACH( 3) = the standard punch unit.
C     I1MACH( 4) = the standard error message unit.
C
C   Words:
C     I1MACH( 5) = the number of bits per integer storage unit.
C     I1MACH( 6) = the number of characters per integer storage unit.
C
C   Integers:
C     assume integers are represented in the S-digit, base-A form
C
C                sign ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C                where 0 .LE. X(I) .LT. A for I=0,...,S-1.
C     I1MACH( 7) = A, the base.
C     I1MACH( 8) = S, the number of base-A digits.
C     I1MACH( 9) = A**S - 1, the largest magnitude.
C
C   Floating-Point Numbers:
C     Assume floating-point numbers are represented in the T-digit,
C     base-B form
C                sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C                where 0 .LE. X(I) .LT. B for I=1,...,T,
C                0 .LT. X(1), and EMIN .LE. E .LE. EMAX.
C     I1MACH(10) = B, the base.
C
C   Single-Precision:
C     I1MACH(11) = T, the number of base-B digits.
C     I1MACH(12) = EMIN, the smallest exponent E.
C     I1MACH(13) = EMAX, the largest exponent E.
C
C   Double-Precision:
C     I1MACH(14) = T, the number of base-B digits.
C     I1MACH(15) = EMIN, the smallest exponent E.
C     I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of I1MACH(1) - I1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   891012  Added VAX G-floating constants.  (WRB)
C   891012  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   901009  Correct I1MACH(7) for IBM Mainframes. Should be 2 not 16.
C           (RWC)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added Convex -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C   930618  Corrected I1MACH(5) for Convex -p8 and -pd8 compiler
C           options.  (DWL, RWC and WRB).
C***END PROLOGUE  I1MACH
C
      INTEGER IMACH(16),OUTPUT
      SAVE IMACH
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        129 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1025 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA IMACH( 1) /          7 /
C     DATA IMACH( 2) /          2 /
C     DATA IMACH( 3) /          2 /
C     DATA IMACH( 4) /          2 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         33 /
C     DATA IMACH( 9) / Z1FFFFFFFF /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -256 /
C     DATA IMACH(13) /        255 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /       -256 /
C     DATA IMACH(16) /        255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /        -50 /
C     DATA IMACH(16) /         76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /     -32754 /
C     DATA IMACH(16) /      32780 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -4095 /
C     DATA IMACH(13) /       4094 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -4095 /
C     DATA IMACH(16) /       4094 /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /    6LOUTPUT/
C     DATA IMACH( 5) /         60 /
C     DATA IMACH( 6) /         10 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         48 /
C     DATA IMACH( 9) / 00007777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /       -929 /
C     DATA IMACH(13) /       1070 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /       -929 /
C     DATA IMACH(16) /       1069 /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / Z'7FFFFFFF' /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16383 /
C     DATA IMACH(16) /      16383 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -pd8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 46 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         46 /
C     DATA IMACH( 9) / 1777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 64 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 777777777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C
C     DATA IMACH( 1) /         11 /
C     DATA IMACH( 2) /         12 /
C     DATA IMACH( 3) /          8 /
C     DATA IMACH( 4) /         10 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         24 /
C     DATA IMACH( 6) /          3 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         23 /
C     DATA IMACH( 9) /    8388607 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         38 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /         43 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         63 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
      DATA IMACH( 1) /          5 /
      DATA IMACH( 2) /          6 /
      DATA IMACH( 3) /          6 /
      DATA IMACH( 4) /          6 /
      DATA IMACH( 5) /         32 /
      DATA IMACH( 6) /          4 /
      DATA IMACH( 7) /          2 /
      DATA IMACH( 8) /         31 /
      DATA IMACH( 9) / 2147483647 /
      DATA IMACH(10) /          2 /
      DATA IMACH(11) /         24 /
      DATA IMACH(12) /       -125 /
      DATA IMACH(13) /        128 /
      DATA IMACH(14) /         53 /
      DATA IMACH(15) /      -1021 /
      DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         39 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         55 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          7 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1015 /
C     DATA IMACH(16) /       1017 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) /  Z7FFFFFFF /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         54 /
C     DATA IMACH(15) /       -101 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         62 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1021 /
C     DATA IMACH(13) /       1024 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16381 /
C     DATA IMACH(16) /      16384 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          1 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /      -1024 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA IMACH( 1) /          1 /
C     DATA IMACH( 2) /          1 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C***FIRST EXECUTABLE STATEMENT  I1MACH
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH = IMACH(I)
      RETURN
C
   10 CONTINUE
      WRITE (UNIT = OUTPUT, FMT = 9000)
 9000 FORMAT ('1ERROR    1 IN I1MACH - I OUT OF BOUNDS')
C
C     CALL FDUMP
C
      STOP
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_consistency_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_format
  use cubetools_consistency_colors
  !
  public  :: consistency_desc_t
  public  :: notol,check,mess,strict,tenper
  public  :: cubetools_consistency_init,cubetools_consistency_final
  public  :: cubetools_consistency_real_check,cubetools_consistency_real_relative_check
  public  :: cubetools_consistency_angle_check,cubetools_consistency_real_print
  public  :: cubetools_consistency_angle_print
  public  :: cubetools_consistency_integer_check,cubetools_consistency_integer_print
  public  :: cubetools_consistency_string_check,cubetools_consistency_string_print
  public  :: cubetools_consistency_logical_check,cubetools_consistency_logical_print
  public  :: cubetools_consistency_title
  private
  !
  ! Formats
  integer(kind=4),  parameter :: ident  = 5  ! Ident for value print
  integer(kind=4),  parameter :: tab    = 20 ! Tabulation for values
  integer(kind=4),  parameter :: fsize  = 15 ! field size for values
  character(len=*), parameter :: rlfmt  = '1pg15.5'
  character(len=*), parameter :: rsfmt  = '1pg10.3'
  character(len=*), parameter :: ilfmt  = 'i15'
  !
  ! Initializations
  real(kind=tole_k), parameter :: notol  = 0d0
  real(kind=tole_k), parameter :: strict = 1d-7
  real(kind=tole_k), parameter :: tenper = 5d-2
  logical,      parameter :: check  = .true.
  logical,      parameter :: mess   = .true.
  !
  type consistency_desc_t
     logical         :: check=.true.  ! Check this section?
     logical         :: prob=.false.  ! Inconsistent?
     logical         :: mess=.true.   ! Output message for this section?
     real(kind=tole_k)    :: tol =0d0      ! Default tolerance  
  end type consistency_desc_t
  !
  interface cubetools_consistency_real_check
     module procedure cubetools_consistency_r8_check
     module procedure cubetools_consistency_r4_check
  end interface cubetools_consistency_real_check
  !
  interface cubetools_consistency_real_relative_check
     module procedure cubetools_consistency_r8_relative_check
     module procedure cubetools_consistency_r4_relative_check
  end interface cubetools_consistency_real_relative_check
  !
  interface cubetools_consistency_angle_check
     module procedure cubetools_consistency_r8_angle_check
     module procedure cubetools_consistency_r4_angle_check
  end interface cubetools_consistency_angle_check
  !
  interface cubetools_consistency_angle_print
     module procedure cubetools_consistency_r8_angle_print
     module procedure cubetools_consistency_r4_angle_print
  end interface cubetools_consistency_angle_print  
  !
  interface cubetools_consistency_real_print
     module procedure cubetools_consistency_r8_print
     module procedure cubetools_consistency_r4_print
     module procedure cubetools_consistency_r8_print_unit
     module procedure cubetools_consistency_r4_print_unit
     module procedure cubetools_consistency_r8_print_2unit
     module procedure cubetools_consistency_r4_print_2unit
  end interface cubetools_consistency_real_print
  !
  interface cubetools_consistency_integer_check
     module procedure cubetools_consistency_i8_check
     module procedure cubetools_consistency_i4_check
  end interface cubetools_consistency_integer_check
  !
  interface cubetools_consistency_integer_print
     module procedure cubetools_consistency_i8_print
     module procedure cubetools_consistency_i4_print
  end interface cubetools_consistency_integer_print
  !
contains
  subroutine cubetools_consistency_init(tol,check,mess,cons,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Init consistency
    !----------------------------------------------------------------------
    real(kind=tole_k),        intent(in)    :: tol
    type(consistency_desc_t), intent(out)   :: cons
    logical,                  intent(in)    :: check
    logical,                  intent(in)    :: mess
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    cons%tol   = tol
    cons%check = check
    cons%mess  = mess
  end subroutine cubetools_consistency_init
  !
  subroutine cubetools_consistency_final(cons,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Final consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(out)   :: cons
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
  end subroutine cubetools_consistency_final
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_r8_check(cons,dble1,dble2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .not.nearly_equal(dble1,dble2,cons%tol)
  end subroutine cubetools_consistency_r8_check
  !
  subroutine cubetools_consistency_r4_check(cons,real1,real2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .not.nearly_equal(real1,real2,real(cons%tol))
  end subroutine cubetools_consistency_r4_check
  !
  subroutine cubetools_consistency_r8_relative_check(cons,inc1,dble1,inc2,dble2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: inc1
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: inc2
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>RELATIVE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .false.
    cons%prob = (.not.nearly_equal(dble1/inc1,dble2/inc1,cons%tol)).or.&
         (.not.nearly_equal(dble1/inc2,dble2/inc2,cons%tol))
  end subroutine cubetools_consistency_r8_relative_check
  !
  subroutine cubetools_consistency_r4_relative_check(cons,inc1,real1,inc2,real2,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Check r4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: inc1
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: inc2
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>RELATIVE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = (.not.nearly_equal(real1/inc1,real2/inc1,real(cons%tol))).or.&
         (.not.nearly_equal(real1/inc2,real2/inc2,real(cons%tol)))
  end subroutine cubetools_consistency_r4_relative_check
  !
  subroutine cubetools_consistency_r8_angle_check(cons,angle1,angle2,error)
    use gkernel_interfaces
    use phys_const
    !----------------------------------------------------------------------
    ! Check r8 angle consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=8),             intent(in)    :: angle1
    real(kind=8),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>ANGLE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    ! VVV This is a poor solution as it does not test for angles > pi,
    ! or equal angles with oposing signs
    cons%prob = abs(angle1-angle2).gt.cons%tol*pi
  end subroutine cubetools_consistency_r8_angle_check
  !
  subroutine cubetools_consistency_r4_angle_check(cons,angle1,angle2,error)
    use gkernel_interfaces
    use phys_const
    !----------------------------------------------------------------------
    ! Check r4 angle consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    real(kind=4),             intent(in)    :: angle1
    real(kind=4),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>ANGLE>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    ! VVV This is a poor solution as it does not test for angles > pi,
    ! or equal angles with oposing signs
    cons%prob = abs(angle1-angle2).gt.cons%tol*pi
  end subroutine cubetools_consistency_r4_angle_check
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_r8_print(label,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print i8 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(dble1,dble2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(dble1,dble2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print
  !
  subroutine cubetools_consistency_r4_print(label,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(real1,real2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(real1,real2,rlfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print
  !
  subroutine cubetools_consistency_r8_print_unit(label,unit,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print r8 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST>UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(dble1,dble2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(dble1,dble2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print_unit
  !
  subroutine cubetools_consistency_r4_print_unit(label,unit,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST>UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(real1,real2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(real1,real2,rlfmt,fsize,unit)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print_unit
  !
  subroutine cubetools_consistency_r8_print_2unit(label,unit1,unit2,cons,dble1,dble2,error)
    !----------------------------------------------------------------------
    ! Print r8 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit1
    character(len=*),         intent(in)    :: unit2
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: dble1
    real(kind=8),             intent(in)    :: dble2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>LIST>2UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(dble1,unit1,dble2,unit2,rlfmt,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_print_2unit
  !
  subroutine cubetools_consistency_r4_print_2unit(label,unit1,unit2,cons,real1,real2,error)
    !----------------------------------------------------------------------
    ! Print r4 consistency with unit
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    character(len=*),         intent(in)    :: unit1
    character(len=*),         intent(in)    :: unit2
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: real1
    real(kind=4),             intent(in)    :: real2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>LIST>2UNIT'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(real1,unit1,real2,unit2,rlfmt,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_print_2unit
  !
  subroutine cubetools_consistency_r4_angle_print(label,cons,angle1,angle2,error)
    use phys_const
    !----------------------------------------------------------------------
    ! Print angle consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=4),             intent(in)    :: angle1
    real(kind=4),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R4>ANGLE>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(angle1/rad_per_deg,angle2/rad_per_deg,&
         rlfmt,fsize,'degrees')
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r4_angle_print
  !
  subroutine cubetools_consistency_r8_angle_print(label,cons,angle1,angle2,error)
    use phys_const
    !----------------------------------------------------------------------
    ! Print angle consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    real(kind=8),             intent(in)    :: angle1
    real(kind=8),             intent(in)    :: angle2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>R8>ANGLE>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(angle1/rad_per_deg,angle2/rad_per_deg,&
         rlfmt,fsize,'degrees')
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_r8_angle_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_i8_check(cons,long1,long2,error)
    !----------------------------------------------------------------------
    ! Check i8 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    integer(kind=8),          intent(in)    :: long1
    integer(kind=8),          intent(in)    :: long2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I8>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = long1.ne.long2
  end subroutine cubetools_consistency_i8_check
  !
  subroutine cubetools_consistency_i4_check(cons,inte1,inte2,error)
    !----------------------------------------------------------------------
    ! Check i4 consistency
    !----------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    integer(kind=4),          intent(in)    :: inte1
    integer(kind=4),          intent(in)    :: inte2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I4>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = inte1.ne.inte2
  end subroutine cubetools_consistency_i4_check
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_i8_print(label,cons,long1,long2,error)
    !----------------------------------------------------------------------
    ! Print i8 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    integer(kind=8),          intent(in)    :: long1
    integer(kind=8),          intent(in)    :: long2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I8>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(long1,long2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(long1,long2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_i8_print
  !
  subroutine cubetools_consistency_i4_print(label,cons,inte1,inte2,error)
    !----------------------------------------------------------------------
    ! Print i4 consistency
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    integer(kind=4),          intent(in)    :: inte1
    integer(kind=4),          intent(in)    :: inte2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSISTENCY>I4>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    if (cons%prob) then
       write(mess,fmt) label,cubetools_format_diff(inte1,inte2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%incons))
    else
       write(mess,fmt) label,cubetools_format_2values(inte1,inte2,ilfmt,fsize)
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_i4_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_string_check(cons,string1,string2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between two strings
    !-------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    character(len=*),         intent(in)    :: string1
    character(len=*),         intent(in)    :: string2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>STRING>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = string1.ne.string2
  end subroutine cubetools_consistency_string_check
  !
  subroutine cubetools_consistency_string_print(label,cons,string1,string2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two strings
    !-------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    character(len=*),         intent(in)    :: string1
    character(len=*),         intent(in)    :: string2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>STRING>LIST>1LABEL'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(string1,string2,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_string_print
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_consistency_logical_check(cons,logi1,logi2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between two logicals
    !-------------------------------------------------------------------
    type(consistency_desc_t), intent(inout) :: cons
    logical,                  intent(in)    :: logi1
    logical,                  intent(in)    :: logi2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>LOGICAL>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = logi1.neqv.logi2
  end subroutine cubetools_consistency_logical_check
  !
  subroutine cubetools_consistency_logical_print(label,cons,logi1,logi2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two logicals
    !-------------------------------------------------------------------
    character(len=*),         intent(in)    :: label
    type(consistency_desc_t), intent(in)    :: cons
    logical,                  intent(in)    :: logi1
    logical,                  intent(in)    :: logi2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONSITENCY>LOGICAL>LIST'
    character(len=mess_l) :: mess
    character(len=form_l) :: fmt
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess) return
    fmt = cubetools_consistency_write_format()
    write(mess,fmt) label,cubetools_format_2values(logi1,logi2,fsize)
    if (cons%prob) then
       mess = trim(cubetools_format_color(mess,colors%incons))
    else       
       mess = trim(cubetools_format_color(mess,colors%cons))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_logical_print
  !
  subroutine cubetools_consistency_title(title,level,check,prob,error,short)
    !-------------------------------------------------------------------
    ! Prints the title of a section
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: title
    integer(kind=4),  intent(in)    :: level
    logical,          intent(in)    :: check
    logical,          intent(in)    :: prob
    logical,          intent(inout) :: error
    logical, optional,intent(in)    :: short
    !
    character(len=*), parameter :: rname='CONSITENCY>TITLE'
    character(len=mess_l) :: mess
    character(len=form_l) :: format
    logical :: myshort
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.present(short)) then
       myshort = .false.
    else
       myshort = short
    endif
    if (level.lt.1) then
       call cubeheader_message(seve%e,rname,'Level must be positive')
       error = .true.
       return
    else if (level.eq.1) then
       write(format,'(a,a,a)') '(a)'
    else
       write(format,'(a,i0,a)') '(',2*(level-1),'x,a)'
    endif
    if (check) then
       if (prob) then
          if (myshort) then
             write(mess,format) trim(cubetools_format_color('Inconsistent '//title,colors%incons))
          else
             write(mess,format) trim(cubetools_format_color('Inconsistent '//title//':',colors%incons))
          endif
       else
          write(mess,format) trim(cubetools_format_color('Consistent '//title,colors%cons))
       endif
    else
       write(mess,format) trim(cubetools_format_color(title//' not checked',colors%notche))
    endif
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_consistency_title
  !
  function cubetools_consistency_write_format() result(fmt)
    !-------------------------------------------------------------------
    ! Produce the printing format
    !-------------------------------------------------------------------
    character(len=form_l) :: fmt
    !
    write(fmt,'(2(a,i0),a)') '(',ident,'x,a,":",t',tab,',a)'
  end function cubetools_consistency_write_format
end module cubetools_consistency_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!      program test
!      integer i
!      real r
!      do i=-4,5
!         r = i+0.5
!         write(6,*) r,modulo(r,2.),dmodulo(r*1.d0,2.d0),
!     +        i,imodulo(i,2)
!      enddo
!      end

      FUNCTION MODULO(A,B)
      REAL*4 MODULO,A,B
      IF (B.LE.0) THEN
         WRITE(6,*) 'F-MODULO,  ',
     +        'Not programmed for a negative second argument'
      ENDIF
      MODULO = MOD(A,B)
      IF (MODULO.LT.0) THEN
         MODULO = MODULO+B
      ENDIF
      END

      FUNCTION DMODULO(A,B)
      REAL*8 DMODULO,A,B
      IF (B.LE.0) THEN
         WRITE(6,*) 'F-MODULO,  ',
     +        'Not programmed for a negative second argument'
      ENDIF
      DMODULO = MOD(A,B)
      IF (DMODULO.LT.0) THEN
         DMODULO = DMODULO+B
      ENDIF
      END

      FUNCTION IMODULO(A,B)
      INTEGER IMODULO,A,B
      IF (B.LE.0) THEN
         WRITE(6,*) 'F-MODULO,  ',
     +        'Not programmed for a negative second argument'
      ENDIF
      IMODULO = MOD(A,B)
      IF (IMODULO.LT.0) THEN
         IMODULO = IMODULO+B
      ENDIF
      END

subroutine class_comment(line,r,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_comment
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS ANALYSE Support routine for command
  !  COMMENT APPEND or WRITE "New comment text"
  !          EDIT
  !          READ
  !          DELETE
  ! Reads, writes and modifies the comment section.
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line   ! Command line
  type(observation), intent(inout) :: r      !
  logical,           intent(inout) :: error  ! flag
  ! Local
  character(len=*), parameter :: rname='COMMENT'
  integer(kind=4) :: nkey,i,nc
  integer(kind=4), parameter :: mkey=5
  character(len=8) :: keys(mkey),argum,keywor
  character(len=9) :: prompt
  integer(kind=4) :: lprompt
  data keys/'APPEND','WRITE','EDIT','DELETE','READ'/
  !
  call sic_ke (line,0,1,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,nkey,keys,mkey,error)
  if (error) return
  !
  select case (keywor)
  case ('READ')
     if (r%head%presec(class_sec_com_id)) then
        do i = 1,r%head%com%ltext,76
           write(6,'(1X,A)') r%head%com%ctext(i:min(i+75,r%head%com%ltext))
        enddo
     else
        call class_message(seve%w,rname,'No comment section present')
     endif
  case ('WRITE','APPEND')
     if (keywor.eq.'APPEND')  call class_message(seve%w,rname,  &
       'COMMENT APPEND is obsolescent, use COMMENT WRITE instead')
     if (r%head%presec(class_sec_com_id)) then
        call sic_ch (line,0,2,r%head%com%ctext(r%head%com%ltext+1:),nc,.true.,error)
        if (error) return
     else
        r%head%com%ltext = 0
        call sic_ch (line,0,2,r%head%com%ctext,nc,.true.,error)
        if (error) return
        r%head%presec(class_sec_com_id) = .true.
     endif
     r%head%com%ltext = lenc(r%head%com%ctext)
  case ('EDIT')
     prompt = 'COMMENT: '
     lprompt = 9
     call sic_edit (r%head%com%ctext,r%head%com%ltext,prompt,lprompt)
     r%head%presec(class_sec_com_id) = .true.
  case ('DELETE')
     r%head%com%ltext = 0
     r%head%presec(class_sec_com_id) = .false.
  end select
end subroutine class_comment

program classic_read
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use classic_api, no_interface=>classic_entry_data_read
  !---------------------------------------------------------------------
  ! Read a Class file. 3 modes:
  !  1) index only
  !  2) same + entry descriptor (i.e. no header, no data)
  !  3) same + header only
  !  4) same + data (i.e. all the entry)
  !---------------------------------------------------------------------
  logical :: error
  type(classic_file_t) :: file
  integer(kind=4), parameter :: file_lun=50  ! Arbitrary value
  integer(kind=entry_length) :: ientry
  type(classic_recordbuf_t) :: rbufind,rbufobs
  integer(kind=4), allocatable :: bufind(:)  ! Buffer for byte-swapping one index
  integer(kind=4), allocatable :: bufsec(:)  ! Buffer for byte-swapping one section
  integer(kind=4), allocatable :: bufdat(:)  ! Buffer for byte-swapping one section
  integer(kind=8) :: ind_rstart
  integer(kind=4) :: ind_wstart
  integer(kind=data_length) :: ldata
  type(classic_entrydesc_t) :: edesc
  integer(kind=4) :: isec,arg_count,mode
  type(cputime_t) :: time
  character(len=8) :: cmode
  integer(kind=8) :: nwords,nrec,pirec,porec
  !
  error = .false.
  !
  ! Command line arguments
  arg_count = sic_get_arg_count()
  if (arg_count.lt.2) then
    call classic_read_usage
    stop 1
  endif
  !
  call sic_get_arg(1,file%spec)
  !
  call sic_get_arg(2,cmode)
  read(cmode,*) mode
  if (mode.lt.1 .or. mode.gt.4) then
    write(*,'(A)')  'Mode must be between 1 and 4'
    stop 2
  endif
  !
  ! Initialize the Classic library
  call classic_init(error)
  if (error)  stop 3
  file%lun = file_lun
  file%nspec = len_trim(file%spec)
  file%update = .false.
  call classic_file_open(file,.false.,error)
  if (error)  stop 4
  !
  call classic_filedesc_open(file,error)
  if (error)  stop 5
  !
  call reallocate_recordbuf(rbufind,file%desc%reclen,error)
  if (error)  stop 6
  call reallocate_recordbuf(rbufobs,file%desc%reclen,error)
  if (error)  stop 7
  call reallocate_buffer(bufind,int(file%desc%lind,kind=8),error)
  if (error)  stop 8
  !
  nwords = 0
  nrec = 0
  pirec = 0  ! Previous index record
  porec = 0  ! Previous observation record
  call gag_cputime_init(time)
  do ientry=1,file%desc%xnext-1  ! Read all entries
    !
    ! Read the Entry Index
    call classic_entryindex_read(file,ientry,bufind,rbufind,error)
    if (error)  stop 9
    nwords = nwords + file%desc%lind
    if (rbufind%rstart+rbufind%roff.ne.pirec) then
      nrec = nrec+1
      pirec = rbufind%rstart+rbufind%roff
    endif
    !
    if (mode.eq.1)  cycle
    !
    call classic_read_buf2ind(bufind,ind_rstart,ind_wstart,file%conv)
    if (error)  stop 10
    !
    ! Set the working buffer
    call classic_recordbuf_open(file,ind_rstart,ind_wstart,rbufobs,error)
    if (error)  stop 11
    ! Read the Entry Descriptor
    call classic_entrydesc_read(file,rbufobs,edesc,error)
    if (error)  stop 12
    !
    nwords = nwords + entrydescv2_nw1+entrydescv2_nw2*edesc%nsec
    if (rbufobs%rstart+rbufobs%roff.ne.porec) then
      nrec = nrec+rbufobs%roff+1
      porec = rbufobs%rstart+rbufobs%roff
    endif
    !
    if (mode.eq.2)  cycle
    !
    do isec=1,edesc%nsec
      !
      call reallocate_buffer(bufsec,edesc%secleng(isec),error)
      if (error)  stop 13
      call classic_entry_section_read(edesc%seciden(isec),edesc%secleng(isec),  &
        bufsec,edesc,rbufobs,error)
      if (error)  stop 14
      !
      nwords = nwords + edesc%secleng(isec)
      if (rbufobs%rstart+rbufobs%roff.ne.porec) then
        nrec = nrec + (rbufobs%rstart+rbufobs%roff) - porec
        porec = rbufobs%rstart+rbufobs%roff
      endif
    enddo
    !
    if (mode.eq.3)  cycle
    !
    ! Also read the data
    ldata = edesc%ldata
    call reallocate_buffer(bufdat,ldata,error)
    if (error)  stop 15
    call classic_entry_data_read(bufdat,ldata,edesc,rbufobs,error)
    if (error)  stop 16
    !
    nwords = nwords + edesc%ldata
    if (rbufobs%rstart+rbufobs%roff.ne.porec) then
      nrec = nrec + (rbufobs%rstart+rbufobs%roff) - porec
      porec = rbufobs%rstart+rbufobs%roff
    endif
    !
  enddo
  !
  call gag_cputime_get(time)
  write(*,'(A,3(1X,F8.3))')  'System, user, elapsed: ',  &
    time%diff%system,time%diff%user,time%diff%elapsed
  write(*,'(A,2(1X,F8.2))')  'Gross and net rates [MB/sec]: ',  &
    nrec*file%desc%reclen/1024.d0/256.d0/time%diff%elapsed,  &
    nwords/1024.d0/256.d0/time%diff%elapsed
  !
  ! Cleaning
  call deallocate_recordbuf(rbufind,error)
  if (error)  stop 17
  call deallocate_recordbuf(rbufobs,error)
  if (error)  stop 18
  if (allocated(bufind)) deallocate(bufind)
  if (allocated(bufsec)) deallocate(bufsec)
  if (allocated(bufdat)) deallocate(bufdat)
  !
  call classic_file_close(file,error)
  if (error)  stop 19
  !
contains
  subroutine classic_read_usage
    write(*,'(A)')  'Usage:'
    write(*,'(A)')  '  classic-read file mode'
    write(*,'(A)')  ''
    write(*,'(A)')  '  Read (part of) the contents of any kind of Classic file'
    write(*,'(A)')  '  and return statistics.'
    write(*,'(A)')  ''
    write(*,'(A)')  '  Mode can be:'
    write(*,'(A)')  '  1: read the index for all entries,'
    write(*,'(A)')  '  2: same as 1 + entry descriptors'
    write(*,'(A)')  '  3: same as 2 + entry headers'
    write(*,'(A)')  '  4: same as 3 + entry data'
    write(*,'(A)')  ''
  end subroutine classic_read_usage
  !
  subroutine classic_read_buf2ind(buf,rec,word,conv)
    use gildas_def
    use gkernel_interfaces
    use classic_api
    !---------------------------------------------------------------------
    ! Copy the Entry Index into the given buffer, swap bytes if needed
    !---------------------------------------------------------------------
    integer(kind=4),          intent(in)  :: buf(*)
    integer(kind=8),          intent(out) :: rec
    integer(kind=4),          intent(out) :: word
    type(classic_fileconv_t), intent(in)  :: conv
    ! Local
    integer(kind=4) :: addr4
    !
    if (file%desc%version.eq.1) then
      call conv%read%i4(buf(1),addr4,1)  !   1: record
      rec = addr4
      word = 1
    else
      call conv%read%i8(buf(1),rec, 1)  ! 1-2: record
      call conv%read%i4(buf(3),word,1)  !   3: word
    endif
  end subroutine classic_read_buf2ind
  !
  subroutine reallocate_buffer(buf,l,error)
    integer(kind=4), allocatable   :: buf(:)
    integer(kind=8), intent(in)    :: l
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    !
    if (allocated(buf)) then
      if (size(buf).ge.l) then
        return
      else
        deallocate(buf)
      endif
    endif
    allocate(buf(l),stat=ier)
    if (failed_allocate('DUMP','buffer',ier,error))  return
    !
  end subroutine reallocate_buffer
  !
end program classic_read

function concom (xq,yq,xd,yd,zd,ndp,wk,iwk,loc)
  use gcont_interfaces, except_this=>concom
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ private
  !	Interpolate the values at a given point.
  ! Arguments :
  !	XQ	R*4	X coordinate of point			Input
  !	YQ	R*4	Y coordinate of point			Input
  !	XD	R*4 (*)	Array of X coordinates of points	Input
  !	YD	R*4 (*)	Array of Y coordinates of points	Input
  !	ZD	R*4 (*)	Array of values				Input
  !	NDP	I	Number of data points			Input
  !	WK	R*4 (*)	Work space				Input
  !	IWK	I (*)	Pointer space				Input
  !	LOC	I	Position of point			Output
  !	CONCOM	R*4	Interpolated value			Output
  ! Subroutines :
  !	CONLOC
  !	CONCAL
  !---------------------------------------------------------------------
  real :: concom                    !
  real :: xq                        !
  real :: yq                        !
  real :: xd(1)                     !
  real :: yd(1)                     !
  real :: zd(1)                     !
  integer :: ndp                    !
  real :: wk(1)                     !
  integer :: iwk(1)                 !
  integer :: loc                    !
  ! Local
  !  Interpolate a given X,Y pair and return its location
  !
  real :: temp
  !
  ! Locate proper triangle
  call conloc(ndp,xd,yd,nt,iwk(jwipt),nl,iwk(jwipl),xq,yq,loc,iwk(jwiwl),wk)
  !
  !  Interpolate the location
  call concal(xd,yd,zd,nt,iwk(jwipt),nl,iwk(jwipl),wk(ipr),loc,xq,yq,temp,itpv)
  concom = temp
end function concom

!
! Simplified TABLE in LINE mode only, but with elaborate
! polarization capabilities.
!
subroutine sg_table(line,error)
  use image_def
  use gio_params
  use gkernel_interfaces
  use classic_api
  use clic_xypar
  use clic_index
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC  Internal routine.
  ! Prepare a UV Table (GILDAS Format)
  ! Command :
  !   TABLE file_name OLD|NEW
  ! 1   /ADD Item
  ! 2   /DROP n1 n2
  ! 3   /FFT  Fourier Transform resampling algorithm
  ! 4   /FREQUENCY name frest
  ! 5   /NOCHECK [SOURCE|POINTING|EPOCH|PHASE|SCAN]
  ! 6   /RESAMPLE nchan rchan res VELOCITY|FREQUENCY
  ! 7   /POLARIZATION SPLIT|AVERAGE|JOINT
  !
  ! Code currently handles dual-polarization in 3 different ways
  !   SPLIT:   A different visibility for each polarization
  !     AVERAGE: averaged polarizations before writing
  !     JOINT:   All channels Polar 1, then All channels polar 2 in visibility
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: mfvoc, mfilvoc, nkey, mshavoc, mchavoc, nk
  parameter (mfvoc=2, mfilvoc=2, mshavoc=4, mchavoc=5)
  logical :: lcheck(mchavoc)
  integer :: tnchan, ndrop(2), nvis, nfl, new_scans(m_cx), nchan
  integer :: new_dates(m_cx), n_new
  integer(kind=address_length) :: ipk, ipkl
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length) :: ldata_in, h_offset, l_offset
  integer :: ib, kr, ia, ja
  integer :: n_vis, isb, narg, is, nch, nd1, nd2
  integer :: ifirst, ilast, i
  integer :: n_visi(mnbb)
  integer :: isid_auto(mnbb)
  logical :: myend, ok, down_baseline, flagged, positions
  logical :: append, frequency, warning, warned
  logical :: check, scan, noloop, resample, fft, skip, initialized
  logical :: do_select
  real :: trchan, tfres, tvres, tvoff
  real :: width
  real(8) :: newfreq, tfoff, clight, ff, f1, fn
  character(len=256) :: chain,file
  character(len=12) :: key, fvoc(mfvoc), filvoc(mfilvoc)
  character(len=12) :: shavoc(mshavoc), chavoc(mchavoc)
  character(len=12) :: newname, shape, cpolar(3), ctele
  parameter (clight=299792.458d0)
  !
  ! test coordinates to specific precision ..
  real(8), parameter :: sec=pi/180D0/3600.D0
  ! Source, Pointing, Phase_Center, Epoch, Scan, Frequency
  real(8) :: tolerance(6) = (/0.d0 ,0.05d0*sec,0.005d0*sec,1d-5, 0.d0, 1.d-7/)
  logical :: setup=.true.
  character(len=*), parameter :: strnam = 'TOLE_SG%'
  !
  ! It is saved, but not the same as in command TABLE
  !
  integer, save :: file_uv_version
  !
  logical newuvt_format, treat_polar, add_scan, new_pola
  integer :: o_vis, ki
  integer :: ier, js, dvis, stokes, n_pol_scan, current_entry, iseq, pol_scan
  logical :: pol_flagged(mnbas)
  real, allocatable :: dima(:,:), temp(:,:)
  integer, allocatable :: pol_scan_list(:), pol_num_num(:),pol_num_list(:,:)
  integer :: npola, pola(4)
  integer :: extra(code_uvt_last)
  integer :: nextra, pcode(3), polcode
  real(8) :: xang(5)  ! Descriptive angles
  real(8) :: value(3) ! Dummy XYZ for telescope coordinates
  integer :: ipol, ibb
  complex :: est_i, prod
  !
  data shavoc/'TBOX','TPARABOLA','FBOX','FTRIANGLE'/
  data fvoc/'FREQUENCY','VELOCITY'/
  data filvoc/'NEW','OLD'/
  data chavoc/'SOURCE','POINTING','PHASE','EPOCH','SCAN'/
  data cpolar/'SPLIT','AVERAGE','JOINT'/
  data pcode /-1,0,1/
  !
  ! Only FILE should be saved ?
  save file
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (setup) then
    call sic_defstructure(strnam,.true.,error)
    call sic_def_dble(strnam//'POINT',tolerance(2),0,0,.false.,error)
    call sic_def_dble(strnam//'PHASE',tolerance(3),0,0,.false.,error)
    call sic_def_dble(strnam//'EPOCH',tolerance(4),0,0,.false.,error)
    call sic_def_dble(strnam//'FREQUENCY',tolerance(6),0,0,.false.,error)
    setup = .false.
  endif
  !
  if (.not.new_receivers) then
    call message(6,3, 'TABLE', 'This version does not process old data')
    error = .true.
    return
  endif
  !
  if (cont_select) then
    call message(6,3, 'TABLE', 'This version does not produce Continuum tables')
    error = .true.
    return
  endif
  !
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  !
  ! /NOCHECK  (Option 5)
  lcheck(1:mchavoc) = .true.
  if (sic_present(5,0)) then
    do i=1,sic_narg(5)
      call clic_kw (line,5,i,key,nkey,chavoc,mchavoc,.false.,error,.true.)
      lcheck(nkey) = .false.
    enddo
  endif
  lcheck = lcheck.and.table_check
  check = any(lcheck)
  !
  scan = .true.
  resample = .false.
  !
  ! FFT Option (3)
  fft = sic_present(3,0)
  !
  ! /ADD Columns: Scan, Position, etc...
  if (sic_present(1,0)) then
    nextra = code_uvt_last
    call uvt_extra_cols(line,nextra, extra, error)
    if (error) return
    Print *,'extra ',extra(1:nextra)
  else
    nextra = 0
  endif
  !
  ! /POLARIZATION Key
  polcode = 0
  if (sic_present(7,0)) then
    call clic_kw (line,7,1,key,nkey,cpolar,4,.false.,error,.true.)
    if (error) return
    polcode = pcode(nkey)
    Print *,'Handling polarization ',polcode,key
    npola = 0
    pola = 0
  endif
  !
  ! /STOKES Key
  stokes =  code_stokes_none
  if (sic_present(8,0)) then
    call clic_kw (line,8,1,key,nkey,gio_stokes_names,21,.false.,error,.true.)
    if (error) return
    stokes = nkey-17
    Print *,'Handling stokes number',stokes,gio_stokes_names(stokes)
    if (stokes.gt.0) then
      allocate (pol_scan_list(nindex), stat=ier)
      allocate (pol_num_num(nindex), stat=ier)
      allocate (pol_num_list(nindex,16), stat=ier)
      n_pol_scan = 0
      pol_num_num = 0
      pol_num_list = 0
    endif
  endif
  !
  ! Decode Command Line ----------------------------------------------------
  ! Get file name
  if (sic_present(0,1)) then
    file = ' '  ! Reset file name to protect against errors
    ! New name
    call sic_ch (line,0,1,chain,narg,.true.,error)
    if (error) return
    call sic_parsef(chain,file,' ','.uvt')
    key = 'OLD'
    call clic_kw (line,0,2,key,nkey,filvoc,mfilvoc,.false.,error,.true.)
    if (error) return
    if (key.eq.'NEW') then
      append = .false.
      initialized = .false.
      ! A new table will be created in X image: initialize
      call gildas_null(xima, type= 'UVT')
      xima%gil%column_pointer = 0
      xima%gil%column_size = 0
      !
    elseif (key.eq.'OLD') then
      append = .true.
      call gildas_null(xima, type= 'UVT')
      ! this puts the table header in X and Y buffers.
      call newuvt_open(xima,file,file_uv_version,error)
      if (error) return
      ! Copy to Y buffer (Y buffer is used when reading scan headers and comparing to X)
      call gdf_copy_header(xima,yima,error)
      call newuvt_close (xima) ! Free the image slot, as newuvt_extend will be called
    endif
  elseif (len_trim(file).ne.0)  then
    ! No name, use current table
    append = .true.
    !! call gdf_copy_header(xima,yima, error) ! Just in case ?
    ! No "call gildas_null(xima)" here, since its header has to be
    ! remembered from one call to another.
  else
    ! No name, no current image
    call message(6,3, 'TABLE','No table to append to ...')
    error = .true.
    return
  endif
  !
  n_vis = 0
  warned = .false.
  !
  ! Target sampling : /RESAMPLE
  tnchan = 0
  trchan = 0
  tfres = 0.
  tvres = 0.
  tfoff = 0.
  tvoff = 0.
  shape = 'TPAR'
  width = 1.0
  !
  ! /RESAMPLE
  if (sic_present(6,0)) then
    if (append) then
      call message(8,2,'TABLE','OLD Table: /RESAMPLE ignored')
    else
      call sic_i4(line,6,1,tnchan,.true.,error)
      if (error) return
      call sic_r4(line,6,2,trchan,.false.,error)
      if (error) return
      key = 'FREQUENCY'
      call clic_kw(line,6,5,key,nkey,fvoc,mfvoc,.false.,error,.true.)
      if (error) return
      if (key.eq.'FREQUENCY') then
        call sic_r8(line,6,3,tfoff,.false.,error)
        call sic_r4(line,6,4,tfres,.false.,error)
      elseif (key.eq.'VELOCITY') then
        call sic_r4(line,6,3,tvoff,.false.,error)
        call sic_r4(line,6,4,tvres,.false.,error)
      endif
      if (error) return
      call clic_kw(line,6,6,shape,nk,shavoc,mshavoc,.false.,error,.true.)
      if (error) return
      call sic_r4(line,6,7,width,.false.,error)
      if (error) return
      resample = .true.
    endif
  endif
  !
  ! Drop end channels (2)
  ndrop(1) = 0
  ndrop(2) = 0
  if (sic_present(2,0)) then
    call sic_i4(line,2,2,ndrop(2),.true.,error)
    call sic_i4(line,2,1,ndrop(1),.false.,error)
    if (error) return
  endif
  !
  ! Frequency option (4)
  frequency = sic_present(4,0)
  if (frequency) then
    if (append) then
      call message(8,2,'TABLE','OLD Table: /FREQUENCY ignored')
      newfreq = 0
    else
      call sic_ch(line,4,1,newname,narg,.true.,error)
      call sic_r8(line,4,2,newfreq,.true.,error)
      if (error) return
    endif
  else
    newfreq = 0
  endif
  ! -------------------------------------------------------------------------
  ! First loop on current index to check consistency
  n_new = 0
  myend = .false.
  call get_first(.true.,error)
  if (error) return
  !
  ! Select ALL - default are spectral bands
  if (all_select) then
    lsubb_out = max(1,r_lband)
    do is=1, lsubb_out
      isubb_out(is) = is+mbands
    enddo
    do_select = .true.
  else
    do_select = .false.
  endif
  !
  ! No loop on records if spectral bands are to be written OR if scan average
  noloop = (isubb_out(1).gt.mbands) .or. (i_average.eq.1)
  if (.not.noloop) then
    ! No loop on records anymore
    call message(6,3, 'TABLE','Only SCAN average allowed')
    error = .true.
    return
  endif
  !
  ! cut_header updates the Y image in the loop hereafter: initialize it
  ! (only once, out of the loop for efficiency reasons)
  call gildas_null(yima, type = 'UVT')
  !
  do while (.not.myend)
    ! Reset the Frequency
    if (frequency) call vel_scale_3 (newname,newfreq)
    ! Cut_header update the YIMA buffer according to scan header,
    ! in order to compare it with the XIMA buffer corresponding to the current Table.
    call cut_header (ndrop,newfreq,positions,error)
    if (error) return
    !
    ! We use the first scan header to initialise the table header,
    ! if not in append mode.
    if (.not.append .and. .not.initialized) then
      ! Use the truncate scan header to initialize the Table header
      call gdf_copy_header(yima,xima,error)
      ! We use the line command optional parameters, if any.
      ! 7 daps + (real, imag, weight)*nchannels
      if (tnchan .ne. 0) then
        !!Print *,'Setting number of channels ',tnchan
        xima%gil%nchan = tnchan
        !
        if (trchan .ne. 0) then
          xima%gil%ref(1) = trchan
        else
          xima%gil%ref(1) = xima%gil%ref(1) + nint(0.5*(tnchan+1)-xima%gil%ref(1))
        endif
        if (tfres .ne. 0) then
          xima%gil%inc(1) = tfres*xima%gil%val(1)/xima%gil%freq
          xima%gil%vres = -tfres*clight/xima%gil%freq
          xima%gil%fres = tfres
        elseif (tvres .ne. 0) then
          xima%gil%vres = tvres
          xima%gil%inc(1) = -tvres*xima%gil%val(1)/clight
          xima%gil%fres = -tvres*xima%gil%freq/clight
        endif
        ! Make velocity or frequency  change possible :
        if (tvoff.ne.0) then
          xima%gil%voff = tvoff
        elseif (tfoff.ne.0) then
          tvoff = xima%gil%voff-tfoff/xima%gil%freq*clight
          xima%gil%voff = tvoff
        endif
        ! or even frequency offset ...
      else
        continue
        !! Print *,'TNCHAN is 0 ', xima%gil%nchan
      endif
      xima%gil%vtyp = r_typev ! Velocity type
      !
      ! Extra columns
      xima%gil%fcol = 8
      if (polcode.gt.0) then  ! JOINT mode
! Do not need column_pointer(code_uvt_stok) here. This is defined
! in the %gil%stokes array
        if (stokes.ne.code_stokes_none) then
          Print *,'JOINT: Handling 4 Polarization per visibility'
          xima%gil%nstokes = 4
          xima%gil%dim(1) = 3*xima%gil%nchan*4+7
          xima%gil%lcol = xima%gil%dim(1)
        else
          Print *,'JOINT: Handling 2 Polarization per visibility'
          xima%gil%nstokes = 2
          xima%gil%dim(1) = 3*xima%gil%nchan*2+7
          xima%gil%lcol = xima%gil%dim(1)
        endif
      else if (polcode.eq.0) then ! AVERAGE mode
        xima%gil%dim(1) = 3*xima%gil%nchan+7
        xima%gil%lcol = xima%gil%dim(1)
      else if (polcode.lt.0) then ! SPLIT mode
        Print *,'SPLIT: Handling changing Polarization state'
! Need column_pointer(code_uvt_stok) here to store the information.
        xima%gil%dim(1) = 3*xima%gil%nchan+7
        xima%gil%lcol = xima%gil%dim(1)
        xima%gil%dim(1) =  xima%gil%dim(1)+1
        xima%gil%column_pointer(code_uvt_stok) = xima%gil%dim(1)
      endif
      !
      ! Add the other extra columns, avoiding duplication
      do i=1,nextra
        if (xima%gil%column_pointer(extra(i)).eq.0) then
          xima%gil%dim(1) = xima%gil%dim(1)+1
          xima%gil%column_pointer(extra(i)) = xima%gil%dim(1)
          if (extra(i).eq.code_uvt_ra .or. extra(i).eq.code_uvt_dec) then
            xima%gil%dim(1) = xima%gil%dim(1)+1
            xima%gil%column_size(extra(i)) = 2
          endif
        endif
      enddo
      !
      ! Define the primary beam size
      xima%gil%majo = 56.0*(90.0e3/xima%gil%freq)
      print *,'I-CLIC,  Primary beam size ',xima%gil%majo,'"'
      xima%gil%majo = xima%gil%majo*pi/180.0/3600.0
      !
      if (r_teles(1:4).ne.'ALMA' .and. r_teles(1:3).ne.'SMA') then
        ctele = 'NOEMA'
      else
        ctele = r_teles
      endif
      call gdf_addteles(xima,'TELE',ctele,value,error)
      ! We could finalize the UV header here...
      ! call gdf_setuv(xima,error)
      !
      ok = .true.
      warning = .false.
      warned = .false.
      initialized = .true.
    else
      ! Append to an existing table (X) - check consistency
      warning = .false.
      call check_consistency (lcheck,xima,yima,tolerance,r_num,r_scan,error)
      nchan = max(xima%gil%nchan,int(abs(xima%gil%ref(1))))
      warning = warning   &
           .or. abs(yima%gil%freq-xima%gil%freq).gt.tolerance(6)*xima%gil%freq   &
           .or. abs(yima%gil%fres-xima%gil%fres)*nchan.gt.0.1   &
           .or. yima%gil%dim(1) .ne. xima%gil%dim(1)   &
           .or. abs(yima%gil%ref(1)-xima%gil%ref(1)).gt.tolerance(6)*xima%gil%freq/yima%gil%fres
      !
      ! Force resampling for multiple line subbands.
      warning = warning .or.   &
           (lsubb_out.gt.1) .and. (isubb_out(1).gt.mbands)
    endif
    !
    ! First check for inconsistent headers : This is an error.
    !
    if (check.and. .not.ok) then
      call check_consistency (lcheck,xima,yima,tolerance,r_num,r_scan,error)
      if (error) return
    endif
    !
    ! Warning if different frequency parameters, which must force resampling.
    !
    if (warning .and. .not.warned) then
      resample = .true.
      write (chain,'(A,I5,A,I5)')   &
           'Spectrum resampling is needed, obs. # ',r_num,   &
           ' Scan ',r_scan
      call message(6,2,'TABLE',chain)
      if (yima%gil%freq.ne. xima%gil%freq) then
        write(chain,*) 'Rest frequencies :',yima%gil%freq,   &
              xima%gil%freq
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%voff.ne. xima%gil%voff) then
        write(chain,*) 'Velocities :',yima%gil%voff,   &
              xima%gil%voff
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%fres .ne. xima%gil%fres) then
        write(chain,*) 'Frequency resolutions :',yima%gil%fres,   &
              xima%gil%fres
        call message(6,2,'TABLE',chain)
      endif
      if (yima%gil%ref(1) .ne. xima%gil%ref(1)) then
        write(chain,*) 'Reference channels :',yima%gil%ref(1),   &
              xima%gil%ref(1)
        call message(6,2,'TABLE',chain)
      endif
      warned = .true.
      !
      ! Test here the extra columns
    endif
    !
    ! Count polarizations status
    if (new_receivers) then
      do js=1, lsubb_out
        is = isubb_out(js)-mbands
        do ib=1, r_nbas
          new_pola = .true.
          if (npola.gt.0) then
            do i=1, npola
              if (r_code_stokes(ib,is).eq.pola(i)) &
                new_pola = .false.
            enddo
          endif
          if (new_pola) then
            npola = npola+1
            pola(npola) = r_code_stokes(ib,is)
          endif
        enddo 
      enddo
!      hpola = 0
!      lpola = 10 ! Arbitrary number > 4
!      do js = 1, lsubb_out
!        lpol = minval(r_lpolentry(1:r_nant,is))
!        hpol = maxval(r_lpolentry(1:r_nant,is))
!        lpola = min(lpola,lpol)
!        hpola = max(hpola,hpol)
!      enddo
!      npola = hpola-lpola+1
      if (polcode.lt.0) npola = 2
    else
      npola = 1
    endif
    !
    ! Check that data are complete for stokes parameter evaluation
    if (npola.eq.4) then
      add_scan = .true.
      if (n_pol_scan.gt.0) then
        do i=1,n_pol_scan
          if (pol_scan_list(i).eq.r_scan) then
            add_scan = .false.
            current_entry = i
          endif
        enddo
      endif
      if (add_scan) then
        n_pol_scan=n_pol_scan+1
        pol_scan_list(n_pol_scan) = r_scan
        current_entry = n_pol_scan
        n_vis = n_vis + r_nbas 
      endif
      if (pol_num_num(current_entry)+1.gt.16) then
        call message(6,4,'TABLE_STOKES',&
          'More than 16 sub-scans in polarisation scan')
        error = .true.
        return
      else
        pol_num_num(current_entry) = pol_num_num(current_entry)+1
        pol_num_list(current_entry, pol_num_num(current_entry)) = r_xnum
      endif
    else  
      !
      ! Not good here if polcode > 0
      if (polcode.lt.0) then
        n_vis = n_vis + r_nbas * npola
      else
        n_vis = n_vis + r_nbas 
      endif
    endif    
    !
    if (sic_ctrlc()) then
      error = .true.
      goto 200
    endif
    !
    ! Some extra counters
    n_new = n_new+1
    new_scans(n_new) = r_scan
    new_dates(n_new) = r_dobs
    call get_next(myend,error)
    if (error) return
  enddo
  !
  if (npola.eq.4) then
    do i=1,n_pol_scan
      print *," Polarisation scan ",pol_scan_list(i),", ", pol_num_num(i),&
              " sub-scans"
      print *,"       Sub-scan obs number:",pol_num_list(i,1:pol_num_num(i))
    enddo
  endif
  !
  n_visi(1:mnbb) = 1
  !
  ! Automatic sideband determination
  if (isideb_out.eq.5) then
    isid_auto(1:mnbb) = (3-r_isb)/2
  endif
  !
  ! Select all: refine the choice of subbands, depending on the
  ! table spectral parameters.
  if (all_select) then
    lsubb_out=0
    do is = 1, r_lband
      nch = r_lnch(is)
      nd1 = max(ndrop(1),nint(fdrop(1)*nch))
      nd2 = max(ndrop(2),nint(fdrop(2)*nch))
      ok = .false.
      if (abs(xima%gil%fres).ge.abs(r_lrfres(1,is))) then
        do isb=1,2
          ff = r_lrfoff(isb,is)-xima%gil%freq   &
               -(r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
          f1 = ff+(nd1+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
          fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
          if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
             ifirst = nint(f1/xima%gil%fres+xima%gil%ref(1))
             ilast  = nint(fn/xima%gil%fres+xima%gil%ref(1))
          else
             ilast = nint(f1/xima%gil%fres+xima%gil%ref(1))
             ifirst  = nint(fn/xima%gil%fres+xima%gil%ref(1))
          endif
          ok = ok .or. ((ilast.ge.1) .and. (ifirst.le.xima%gil%nchan))
        enddo
      endif
      if (ok) then
        lsubb_out = lsubb_out + 1
        isubb_out(lsubb_out) = is+mbands
      endif
    enddo
    if (lsubb_out.gt.0) then
      write(chain,*) (csub(isubb_out(is))//' ',is=1,lsubb_out)
      call message(6,1,'TABLE','Using '//chain)
    else
      call message(8,3,'TABLE','No matching subband')
      error = .true.
      return
    endif
  endif
  !
  n_vis = n_vis * n_visi(1)
  call message(6,1,'TABLE', 'Table parameters for '//trim(file)//':')
  write(chain,'(A,A12,2(A,F12.3))')   &
       'X_LINE = ',xima%char%line ,' X_FREQ = ',xima%gil%freq,' X_VAL1 = ',xima%gil%val(1)
  call message(6,1,'TABLE',chain)
  write(chain,'(3(A,F12.3))')  'X_FRES = ',xima%gil%fres,   &
       ' X_VRES = ',xima%gil%vres,' X_VOFF = ',xima%gil%voff
  call message(6,1,'TABLE',chain)
  write(chain,'(A,I12,A,F12.4,A)')   &
       ' NCHAN = ',xima%gil%nchan ,' X_REF1 = ',xima%gil%ref(1)
  call message(6,1,'TABLE',chain)
  !
  ! Create new file or append to existing one
  if (append) then
    !!Print *,'Calling newuvt_extend'
    call gdf_setuv(xima,error) ! Test
    call newuvt_extend(xima,file,n_vis,n_new,new_dates,new_scans,   &
          error,lcheck(5))
    o_vis = xima%gil%nvisi
    !!Print *,'FCOL ', xima%gil%fcol , xima%gil%lcol
    !!Print *,' VTYPE ',xima%gil%vtyp
  else
    Print *,'Calling NEWUVT_INIT ',xima%gil%vtyp
    ! POLCODE indicates if %nstokes is > 1
    ! We also need an option to set the %freqs array here
    ! for further processing of non-contiguous frequency bands
    call newuvt_create(xima,file,n_vis,npola,polcode,error)
    !!Print *,' VTYPE ',xima%gil%vtyp
    o_vis = 0
    call gdf_copy_header(xima,yima, error)
  endif
  !
  ! Here, allocate the data space, only new region
  allocate (dima(xima%gil%dim(1),n_vis), stat=ier)
  dima = 0.0
  if (npola.eq.4) then
    allocate (temp(xima%gil%dim(1),r_nbas), stat=ier)
    temp = 0
    iseq = 0
    pol_flagged = .false.
  endif
  !
  ! Loop on current index to write the visibilities
  myend = .false.
  nfl = 0
  if (npola.eq.4) then
    call get_first(.true.,error)
  else
    call get_first(.false.,error)
  endif
  if (error) goto 98
  nvis = 0
  skip = .false.
  !
  do while (.not.myend)
    if (frequency) call vel_scale_3 (newname,newfreq)
    call get_data (ldata_in,data_in,error)
    if (error) goto 98
    if (npola.eq.4) then
      iseq = iseq+1
      if (iseq.eq.1) then
        pol_scan=r_scan
        pol_flagged = .false.
      endif
      if (r_scan.ne.pol_scan) then
        write(chain,'(a,i0,a,i0,a,i0,a)') 'Scan ',r_scan,' (num ',r_num,  &
                                ') does not match polarisation scan (',  &
                                pol_scan,')'
        call message(6,3,'READ_DATA',chain(1:lenc(chain)))
        error = .true.
        return
      endif
    endif
    !
    call check_cal(skip)
    if (skip) then
      skip = .false.
      goto 180
    endif
    if (do_pass) then
      call set_pass (r_nsb,r_nband,r_nbas+r_ntri,r_lntch, passc, passl, error)
      if (error) goto 98
    endif
    call set_corr(error)
    !
    kin = gag_pointer(data_in, memory)
    kr = 1 ! Only the Header information, Scan averaged
    call spectral_dump(kr,0,0)
    ipk = kin + h_offset(kr)
    call decode_header (memory(ipk))
    call set_scaling(error)
    if (error) return
    !
    ! Get the required angles
    call get_angles(xang)
    !
    flagged = .false.
    if (isideb_out.le.2) then
      isb = isideb_out
    elseif (isideb_out.ge.3) then
      ! find the good sideband if declared LINE DSB
      isb = nint(3-(xima%gil%freq-r_flo1)/r_fif1)/2
      isb = min(2,max(1,isb))
    endif
    !
    kr = 1 ! Always, Scan averaged
    do ib = 1, r_nbas
      if (down_baseline(ib)) then
        flagged = .true.
        pol_flagged(ib) = .true.
        cycle
      endif
      !
      ! Take corrected or uncorrected
      call spectral_dump(kr,0,ib)
      ipkl = kin + l_offset(kr)
      !
      ! Do it for the accepted SideBand
      dvis = 1
      if (npola.eq.4) then
        call add_visiline (xima,npola,temp(1,ib), r_nsb, r_nband, r_nbas, r_lntch,   &
            ib, isb, xima%gil%val(1), memory(ipkl), passl, ndrop, &
            width, shape, resample, fft, error, dvis, polcode, xang)
      else
        call add_visiline (xima,npola,dima(1,nvis+1), r_nsb, r_nband, r_nbas, r_lntch,   &
            ib, isb, xima%gil%val(1), memory(ipkl), passl, ndrop, &
            width, shape, resample, fft, error, dvis, polcode, xang)
      endif
      if (error) goto 98
      ! NVIS is used to increment
      if (npola.ne.4)  then
        nvis = nvis + dvis ! Number of added visibilities found by add_visiline
      else
        if (iseq.eq.16)  then
          dvis = 1
!          if (stokes.lt.0) then
            !
            ! Native Stokes: normalize daps
            do i=1, xima%gil%nlead
              temp(i,ib) = temp(i,ib)/16.
            enddo    
            do i=xima%gil%dim(1), xima%gil%dim(1)-xima%gil%ntrail,-1
              temp(i,ib) = temp(i,ib)/16.
            enddo
            !
            ! and visibilities
            do i=1, xima%gil%nchan*xima%gil%nstokes
              ki = xima%gil%fcol+(i-1)*xima%gil%natom
              if (temp(ki+2,ib).ne.0) then
                temp(ki,ib) = temp(ki,ib)/temp(ki+2,ib)
                temp(ki+1,ib) = temp(ki+1,ib)/temp(ki+2,ib)
              else
                temp(ki,ib) = 0. 
                temp(ki+1,ib) = 0. 
              endif
            enddo
            !
            ! Dterm correction if needed
            if (do_corrected.and.polcode.gt.0) then
            ia = r_iant(ib)
            ja = r_jant(ib)
            ibb = r_bb(isubb_out(1)-mbands)
            do i=1, xima%gil%nchan
              do ipol=1, xima%gil%nstokes
                ki=xima%gil%fcol + xima%gil%natom*(i-1)+xima%gil%natom*xima%gil%nchan*(ipol-1)  
                select case (ipol)
                !
                ! First estimate complex I
                ! I=(HH+VV)/2
                case(1)   ! vv
                  est_i = cmplx(temp(ki,ib),temp(ki+1,ib))      
                case(2)   ! hh
                  est_i = (est_i+ cmplx(temp(ki,ib),temp(ki+1,ib)))/2
                !
                ! Then correct cross-products from D-terms
                case(3)   ! vh
                  prod = (r_dx(ia,ibb)+conjg(r_dy(ja,ibb)))*est_i
                  temp(ki,ib) = temp(ki,ib)-real(prod)
                  temp(ki+1,ib) = temp(ki+1,ib)-aimag(prod)
                case(4)   ! hv
                  prod = (r_dy(ia,ibb)+conjg(r_dx(ja,ibb)))*est_i
                  temp(ki,ib) = temp(ki,ib)-real(prod)
                  temp(ki+1,ib) = temp(ki+1,ib)-aimag(prod)
                end select
              enddo
            enddo
            endif
!          else
            !
            ! Derived Stokes
!          endif
          if (.not.pol_flagged(ib)) then
            call r4tor4(temp(1,ib),dima(1,nvis+1),xima%gil%dim(1))
            nvis = nvis + dvis
          endif
          temp(:,ib) = 0
        endif
      endif
      if (dvis.eq.0) flagged = .true.
    enddo
    if (iseq.eq.16) iseq=0
    if (flagged) nfl = nfl + 1
    !
    ! End of scan
180 if (sic_ctrlc()) goto 98
    if (nfl.ne.0) then
      write(chain,'(I6,A)') nfl,' records flagged or unused'
      call message(4,2,'TABLE',chain(1:lenc(chain)))
      nfl = 0
    endif
    call get_next(myend,error)
    if (error) goto 98
  enddo
  !
  ! The table is now fnished
  write(chain,'(I6,A,I6,A)') nvis,   &
       ' visibilities written (out of ',n_vis,' possible)'
  call message(6,1,'TABLE', chain(1:lenc(chain)))
  call gdf_write_data (xima, dima, error)
  Print *,'Calling newuvt_cut ',nvis, nvis+o_vis, error
  Print *,' VTYPE ',xima%gil%vtyp
  nvis = nvis+o_vis
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis,file_uv_version,error)
  Print *,'Trying to deallocate '
  Print *,' VTYPE ',xima%gil%vtyp
!
200 continue
  deallocate (dima, stat=ier)
  Print *,'Done deallocation '
  call newuvt_close(xima)
  Print *,' VTYPE ',xima%gil%vtyp
  return
  ! Error return
98 continue
  deallocate (dima, stat=ier)
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis+o_vis,file_uv_version,error)
  call newuvt_close(xima)
  error = .true.
  return
end subroutine sg_table
!
subroutine uvt_extra_cols(line,nextra,extra,error)
  use gio_params
  use gkernel_interfaces
  use gbl_message
  !
  character(len=*), intent(in) :: line
  integer, intent(inout) :: nextra
  integer, intent(out) :: extra(*)
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='SG_TABLE /ADD'
  character(len=12) :: argum, kw
  character(len=12), save :: items(code_uvt_last)
  logical, save :: first = .true.
  integer :: i, narg, nkey
  !
  if (first) then
    call uv_column_names(items)
    first = .false.
  endif

  !
  if (sic_narg(1).gt.nextra) then
    call clic_message(seve%e,rname,'Too many extra items')
    error = .true.
    return
  endif
  extra(1:nextra) = 0
  !
  error = .false.
  do i=1,sic_narg(1)
    call sic_ke (line,1,i,argum,narg,.true.,error)
    if (error) return
    call sic_ambigs('TABLE /ADD',argum,kw,nkey,items, code_uvt_last, error)
    if (error) return
    nextra = i
    extra(nextra) = nkey
  enddo
end subroutine uvt_extra_cols
!
subroutine newuvt_create (xima,name,nvis,npola,polcode,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  integer, intent(in) :: npola          ! Number of polarisation
  integer, intent(in) :: polcode        ! Polarization treatment
  logical, intent(out) :: error         ! Error flag
  ! Local
  integer :: ier
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = 0
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                  ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  xima%gil%form = fmt_r4
  !
  ! Here define the order of the basic "columns". The "extra"
  ! ones have been set outside already
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  where (xima%gil%column_pointer.ne.0)
    xima%gil%column_size = max(1,xima%gil%column_size)
  end where
  !
  xima%gil%natom = 3
  if (polcode.gt.0) then
    if (npola.eq.4) then
      xima%gil%nstokes = 4 
      xima%gil%order = code_chan_stok ! Channel / Stokes order
      allocate (xima%gil%stokes(xima%gil%nstokes), stat=ier)
      xima%gil%stokes(1) = code_stokes_vv
      xima%gil%stokes(2) = code_stokes_hh
      xima%gil%stokes(3) = code_stokes_vh
      xima%gil%stokes(4) = code_stokes_hv
    else
      xima%gil%nstokes = 2
      xima%gil%order = code_chan_stok ! Channel / Stokes order
      allocate (xima%gil%stokes(xima%gil%nstokes), stat=ier)
      xima%gil%stokes(1) = code_stokes_vv
      xima%gil%stokes(2) = code_stokes_hh
    endif
  else
    xima%gil%nstokes = 1
  endif
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  !
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  print *, 'Into newuvt_init Lead, Trail ', xima%gil%nlead, xima%gil%ntrail
  call gdf_create_image (xima,error)
  print *, 'Done newuvt_init '
end subroutine newuvt_create
!
subroutine check_consistency(lcheck,xima,yima,tolerance,r_num,r_scan,error)
  use gkernel_interfaces
  use image_def
  use classic_api
  include 'gbl_pi.inc'
  logical, intent(in) :: lcheck(4)
  real(8),  intent(in) :: tolerance(4)
  type(gildas), intent(in) :: xima
  type(gildas), intent(in) :: yima
  integer(kind=entry_length), intent(in) :: r_num
  integer, intent(in) :: r_scan
  logical, intent(out) :: error
  !
  character(len=72) :: chain
  character(len=13) :: xch, ych
  real(8), parameter :: sec=pi/180D0/3600.D0
  !
  error = .false.
  if (lcheck(1) .and. yima%char%name .ne. xima%char%name) then
     write(6,*) 'Source :',yima%char%name, xima%char%name
     error = .true.
  endif
  if (lcheck(2) .and. abs(yima%gil%ra-xima%gil%ra).gt.tolerance(2)) then
     call sexag(xch,xima%gil%ra,24)
     call sexag(ych,yima%gil%ra,24)
     write(6,*) 'Pointing RA :',ych,xch
     error = .true.
  endif
  if (lcheck(2) .and. abs(yima%gil%dec-xima%gil%dec).gt.tolerance(2)) then
     call sexag(xch,xima%gil%dec,360)
     call sexag(ych,yima%gil%dec,360)
     write(6,*) 'Pointing DEC :',ych,xch
     error = .true.
  endif
  if (lcheck(3) .and. abs(yima%gil%a0-xima%gil%a0).gt.tolerance(3)) then
     call sexag(xch,xima%gil%a0,24)
     call sexag(ych,yima%gil%a0,24)
     write(6,*) 'Phase A0 :',ych,xch,abs(xima%gil%a0-yima%gil%a0)/sec
     error = .true.
  endif
  if (lcheck(3) .and. abs(yima%gil%d0-xima%gil%d0).gt.tolerance(3)) then
     call sexag(xch,xima%gil%d0,360)
     call sexag(ych,yima%gil%d0,360)
     write(6,*) 'Phase D0 :',ych,xch,abs(xima%gil%d0-yima%gil%d0)/sec
     error = .true.
  endif
  if (lcheck(4) .and. abs(yima%gil%epoc-xima%gil%epoc).gt.tolerance(4)) then
     write(6,*) 'Epoch :',yima%gil%epoc, xima%gil%epoc
     error = .true.
  endif
  if (error) then
     write (chain,'(A,I5,A,I5)')   &
          'Inconsistent observation set, obs. # ',r_num,   &
          ' Scan ',r_scan
     call message(6,3,'TABLE',trim(chain))
  endif
end subroutine check_consistency
!
!      call add_visiline (xima,dima(1,nvis+1), r_nsb, r_nband, r_nbas, r_lntch,   &
!            ib, isb, xima%gil%val(1), &
!            memory(ipkc), memory(ipkl), passl, ndrop, &
!            width, shape, resample, fft, error, dvis, polcode, xang)
!
subroutine add_visiline (xima,npola,visi,qsb,qband,qbas,qntch,   &
    ibase,isb,frout,datal,passl,   &
    ndrop, width, shape, resample, fft, error, dvis, polcode, xang)
  use image_def
  use phys_const
  use classic_api
  !---------------------------------------------------------------------
  ! Called by SG_TABLE
  !
  ! creates one visibility point (i.e. one baseline and one band for a
  ! given scan), but many channels if in line mode.
  !
  ! Average Polarisations if needed, or split them, or concatenate them
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  !
  integer, intent(in) :: npola      ! Number of requested polarization
  real, intent(out) :: visi(xima%gil%dim(1),npola)      ! Current visibilities
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbas                   !
  integer :: qntch                  !
  integer :: ibase                  ! Baseline number
  integer :: isb                    ! Sideband indicator
  real(8) :: frout                  !
  complex :: datal(qntch,qsb,qbas)  !
  complex :: passl(qntch,qsb,qbas)  !
  integer :: ndrop(2)               !
  real(4) :: width                  !
  character(len=*) :: shape         !
  logical :: resample               !
  logical :: fft                    !
  logical :: error                  !
  integer, intent(out) :: dvis      ! Number of visibilities added
  integer, intent(in) :: polcode    ! Code to handle polarizations
  real(8), intent(in) :: xang(5)    ! HA, Dec, Az, El, Parallactic Angle
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  !
  logical, external :: down_channel
  ! Local
  !
  integer :: inbc                   ! Sub-band indicator...
  complex :: zin(mlch), zout(mlch), zscale
  real :: wout(mlch),toto
  real :: w, tsys(2), ri, afac, factor, save_res, rchan, fresf
  integer :: is, i, j, nw, k, ni, js, i1, i2, nd1, nd2, nch
  integer :: ifirst, ilast, nchan, ia, ja, npol, ipol
  integer :: ibdata
  logical :: good
  real(8) :: f1, fn, fo1, fon, ff
  character(len=128) :: chain
  !
  integer ki, ioff
  integer ipola, jpola, opola
  !------------------------------------------------------------------------
  ! Code:
  rchan = xima%gil%ref(1)
  nchan = xima%gil%nchan
  !
  ! Here are the possibilities
  ! 1) Only one polarization
  ! 2) Two polarization, averaged for unpolarized signal
  !     a) equal
  !     b) with Tsys weighting
  ! 3) Two polarization, stored independently sequentially,
  !    in two separate visibilities, each with its Polarization flag
  ! 4) Mixed polarization status, stored in the same visibility, with
  !   possible holes, as some polarization stages can be void.
  !
  ! 5) Non contiguous frequencies (not yet available)
  !
  ! Code is only for Case 1,2,3 in this example...
  !
  dvis = 0      ! Reset number of written visibilities
  !
  !
  ia = r_iant(ibase)
  ja = r_jant(ibase)
  !
  if (dobs_0 .eq.0) then
    dobs_0 = mod(dh_obs+32768,65536)-32768
  endif
  !
  ! Initialize
!  visi(:,1:npola) = 0.0
  !
  ! U,V,W scaling factor
  ! Actually should be computed from the Doppler factor and other stuff..
  factor = 1.0
  !
  visi(xima%gil%column_pointer(code_uvt_u),1) = dh_uvm(1,ibase)*factor &
                           + visi(xima%gil%column_pointer(code_uvt_u),1) 
  visi(xima%gil%column_pointer(code_uvt_v),1) = dh_uvm(2,ibase)*factor &
                           + visi(xima%gil%column_pointer(code_uvt_v),1) 
  !! visi(xima%gil%column_pointer(code_uvt_w)) = 0.0
  visi(xima%gil%column_pointer(code_uvt_date),1) = dh_obs &
                           + visi(xima%gil%column_pointer(code_uvt_date),1) 
  visi(xima%gil%column_pointer(code_uvt_time),1) = dh_utc &
                           + visi(xima%gil%column_pointer(code_uvt_time),1) 
  visi(xima%gil%column_pointer(code_uvt_anti),1) = r_iant(ibase) &
                           + visi(xima%gil%column_pointer(code_uvt_anti),1) 
  visi(xima%gil%column_pointer(code_uvt_antj),1) = r_jant(ibase) &
                           + visi(xima%gil%column_pointer(code_uvt_antj),1) 
  !
  ! Extra Columns if specified...
  if (xima%gil%column_pointer(code_uvt_scan).ne.0) visi(xima%gil%column_pointer(code_uvt_scan),1) = r_scan  &
                           + visi(xima%gil%column_pointer(code_uvt_scan),1) 
  !
  ! There is an ambiguity between Pointing and Phase center. What happens in a MODIFY POSITION ?...
  if (xima%gil%column_pointer(code_uvt_loff).ne.0) visi(xima%gil%column_pointer(code_uvt_loff),1) = dh_offlam(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_moff).ne.0) visi(xima%gil%column_pointer(code_uvt_moff),1) = dh_offbet(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_xoff).ne.0) visi(xima%gil%column_pointer(code_uvt_xoff),1) = dh_offlam(1)*rad_per_sec 
  if (xima%gil%column_pointer(code_uvt_yoff).ne.0) visi(xima%gil%column_pointer(code_uvt_yoff),1) = dh_offbet(1)*rad_per_sec 
  !
  ! Doppler shift (for the baselines length...)
  ! This ones needs to filled SG
  if (xima%gil%column_pointer(code_uvt_topo).ne.0) then
    ! Conventions:
    ! we follow "frame-radio-redshift" convention where
    !    Obs = Rest * (1 + Doppler - Velocity/C)
    ! which is followed in all our codes (ASTRJ, RDI, CLASS)
    ! as the conversion between frequency is defined in cut_header.f90
    !    yima%gil%freq = yima%gil%val(1) / (1 + r_doppl)
    !
    ! However, until further notice, Doppler computed by MODIFY Doppler
    ! has the wrong sign
    !    r_doppl = (corr + r_veloc)/c    ! in clic_modify.f90
    !
    ! We should only put the topocentric to system velocity correction,
    ! not the local source velocity in its system
    visi(xima%gil%column_pointer(code_uvt_topo),1) = r_doppl - r_veloc/clight_kms &
                           + visi(xima%gil%column_pointer(code_uvt_topo),1) 
  endif
  ! Elevation and other angles
  if (xima%gil%column_pointer(code_uvt_el).ne.0) visi(xima%gil%column_pointer(code_uvt_el),1) = xang(4) &
                           + visi(xima%gil%column_pointer(code_uvt_el),1) 
  if (xima%gil%column_pointer(code_uvt_ha).ne.0) visi(xima%gil%column_pointer(code_uvt_ha),1) = xang(1) &
                           + visi(xima%gil%column_pointer(code_uvt_ha),1) 
  if (xima%gil%column_pointer(code_uvt_para).ne.0) visi(xima%gil%column_pointer(code_uvt_para),1) = xang(5) &
                           + visi(xima%gil%column_pointer(code_uvt_para),1) 
  if (xima%gil%column_pointer(code_uvt_int).ne.0) visi(xima%gil%column_pointer(code_uvt_int),1) = dh_integ &
                           + visi(xima%gil%column_pointer(code_uvt_int),1) 
  !
  ! Set the polarisation  / stokes column if needed
  ! Polarization codes have been chosen to verify the following equation.
  !   if (xima%gil%column_pointer(code_uvt_stok).ne.0) visi(xima%gil%column_pointer(code_uvt_stok),1) = &
  !   & = - (10*code_polar(ia) + code_polar(ja))
  ! but "code_polar" is not defined simply.  See r_lpolentry array, and debug conventions here...
  ! For the time being, put HH first, VV next
  if (xima%gil%column_pointer(code_uvt_stok).ne.0) visi(xima%gil%column_pointer(code_uvt_stok),1) = code_stokes_hh
  !
  ! Other extra columns could be added here...
  !
  if (xima%gil%column_size(code_uvt_ra).eq.1) then
    visi(xima%gil%column_pointer(code_uvt_ra),1) = r_lam &
                           + visi(xima%gil%column_pointer(code_uvt_ra),1) 
  elseif (xima%gil%column_size(code_uvt_ra).eq.2) then
    call r8tor8(r_lam, visi(xima%gil%column_pointer(code_uvt_ra),1), 1)
  endif
  if (xima%gil%column_size(code_uvt_dec).eq.1) then
    visi(xima%gil%column_pointer(code_uvt_dec),1) = r_bet &
                           + visi(xima%gil%column_pointer(code_uvt_dec),1) 
  elseif (xima%gil%column_size(code_uvt_dec).eq.2) then
    call r8tor8(r_bet, visi(xima%gil%column_pointer(code_uvt_dec),1), 1)
  endif
  !
  ! Spectrum out
  nw = 0
  !
  ! Spectrum from Continuum backend
  if (isubb_out(1).le.mbands) then
    call message(8,3,'FILL_VISI', 'Invalid selection : Continuum backend')
    error = .true.
    return
  endif
  !
  ! Spectrum from Line backend
  save_res = xima%gil%fres
  !
  opola = 0
  if (npola.eq.4) then
    npol = 1        ! Loop on polarisation done at higher level
  else
    npol = npola
  endif
  !
  ! Loop on polarisations.
  ! We assume here the polarization index gives the value of the polarization state.
  do ipola = 1,npol
    !
    good = .false.
    !
    ! Loop over all subbands, and see if their global polarization state matches
    do js = 1, lsubb_out
      !
      ! The band name
      is = isubb_out(js)-mbands
      if (qsb.eq.1) then ! Check available sideband
        if (r_sband(1,is).ne.isb) then
          call message(6,3,'TABLE','Sideband unavailable')
          error = .true.
          return
        endif
        ibdata = 1
      else
        ibdata = isb
      endif
      !
      ! Is there any valid data ?
      if (is.gt.r_lband .or. down_channel(ibase,is+mbands)) cycle
      !
      ! Scaling and Tsys, possibly for dual-polarization receivers
      if ((npola.eq.4)) then
        select case (r_code_stokes(ibase,is))
        case (code_stokes_vv)
          ipol = 1  
        case (code_stokes_hh)
          ipol = 2  
        case (code_stokes_vh)
          ipol = 3  
        case (code_stokes_hv)
          ipol = 4  
        end select
      else
        if (ipola.ne.r_lpolentry(ia,is)) cycle
        ipol = ipola
      endif
      !
      inbc = r_bb(is)
      if (inbc.eq.0) cycle
      ! Compute scaling and Tsys if not already done
      if (ipola.ne.opola) then
        if (weight_tsys) then
          if (r_sb(is).eq.1) then
            tsys(1) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
                      /dh_integ
            tsys(2) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
                      /dh_integ
           else
             tsys(2) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
                      /dh_integ
             tsys(1) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
                      /dh_integ
           endif
          where (tsys.eq.0.) tsys = 300.0**2
        else
          tsys = 300.0**2
        endif
        afac = 1.
        zscale = 1.
        call scaling (is,isb,ibase,zscale,afac,error)
        opola = ipola
      endif
      !
      !
      fresf = r_lrfres(isb,is)/(1+r_doppl)
      nch = r_lnch(is)
      ! Drop edge channels and unnecessary channels.
      nd1 = max(ndrop(1),nint(fdrop(1)*nch))
      nd2 = max(ndrop(2),nint(fdrop(2)*nch))
      ff = r_lrfoff(isb,is)-xima%gil%freq   &
        -(r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
      f1 = ff+(nd1+0.5-r_lrch(isb,is))*fresf
      fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*fresf
      !
      ! Here one would put code to handle the non-contiguous frequency
      ! channels -- a little tricky though, so only a special mode
      ! will be needed.  TO BE DONE
      !
      ! Find out edge channels. Guard band for FFT
      if (fft) then
        ioff = 1
      else
        ioff = 0
      endif
      if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
        ifirst = nint(f1/xima%gil%fres+rchan+ioff)
        ilast  = nint(fn/xima%gil%fres+rchan-ioff)
      else
        ilast = nint(f1/xima%gil%fres+rchan-ioff)
        ifirst  = nint(fn/xima%gil%fres+rchan+ioff)
      endif
      !
      ! sub-band does not intersect current frequency window
      if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
        write(chain,2000) csub(is+mbands), ifirst, ilast
        call message(6,3,'FILL_VISI',trim(chain))
        cycle
      endif
      !
      ! First & Last definition depend on resampling method
      if (fft) then
        ifirst = max(ifirst,1)
        ilast = min(ilast,nchan)
        fo1 = 1d-3*nint(1d3*(ifirst-0.5-rchan)*xima%gil%fres)
        fon = 1d-3*nint(1d3*(ilast+0.5-rchan)*xima%gil%fres)
        do while ((f1-fo1)*(f1-fon).gt.0 .and. nd1.lt.nch)
          f1 = f1+fresf
          nd1 = nd1 + 1
        enddo
        ni = nint((ilast-ifirst+1)*abs(xima%gil%fres/fresf))
      else
        ni = nch-nd1-nd2
        ifirst = max(ifirst,1)
        ilast = min(ilast,nchan)
        ilast = min(ilast,ifirst+ni-1)
      endif
      print *,"ifirst",ifirst,"ilast",ilast
      !
      ri = r_lrch(isb,is)-nd1
      do i=1, ni
        j = i+r_lich(is)+nd1
        if (ipol.ne.5) then
          zin(i) = datal(j,ibdata,ibase)  * zscale
        else
          zin(i) = (1.,0.)
          toto =real(i,kind=4)/real(ni,kind=4)
          zin(i) = toto*(1,0.)
        endif
        if (do_pass) then
          if (passl(j,isb,ibase).eq.blankc) then
            zin(i) = 0
          else
            zin(i) = zin(i)*passl(j,isb,ibase)
          endif
        endif
      enddo
      !
      ! Interpolate Gibbs-affected channels:
      if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
        i1 = nch/2-ngibbs - nd1
        i2 = nch/2+ngibbs+1 - nd1
        do i=i1+1,i2-1
          zin(i) = (zin(i1)*(i2-i)+zin(i2)*(i-i1))/(i2-i1)
        enddo
      endif
      !
      ! Resample with appropriate method
      if (resample) then
        ff = (r_lvoff(isb,is)-xima%gil%voff)/299792.458d0*xima%gil%freq
        if (ifirst.le.ilast-4 .and. fft) then
          call fft_interpolate (zout(ifirst),   &
            ilast-ifirst+1, xima%gil%fres,   &
            rchan-ifirst+1, xima%gil%freq+ff,   &
            width, shape,   &
            wout(ifirst), zin, ni, fresf,   &
            ri, r_lrfoff(isb,is),   &
            1., 'TPAR', error)
          if (error) cycle
        else
          call interpolate_2 (zout(ifirst),   &
            ilast-ifirst+1, xima%gil%fres,   &
            rchan-ifirst+1, xima%gil%freq+ff,   &
            wout(ifirst), zin, ni, fresf,   &
            ri, r_lrfoff(isb,is))
        endif
      else
        !
        ! Re-order in proper direction
        if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
          k = 1
          do i=ifirst, ilast
            zout(i) = zin(k)
            k = k+1
          enddo
        else
          k = 1
          do i=ilast, ifirst, -1
            zout(i) = zin(k)
            k = k+1
          enddo
        endif
        wout(ifirst:ilast) = 1.0
      endif
      !
      xima%gil%vres = -xima%gil%fres*299792.458d0/xima%gil%freq
      !
      ! Zout now contains the valid visibilities
      ! Wout have the valid relative weights, but not weighted
      ! time, Tsys or calibration factor yet
      !
      ! WEIGHT = 2 DELTA_NU DELTA_T / TSYS^2
      !
      if (weight_cal) then
        w = 2. / abs(zscale)**2 * abs(xima%gil%fres)
      else
        w = 2. * abs(xima%gil%fres)
      endif
      !
      ! zscale does not contains the Tsys and Integration time here ?
      w = w / tsys(isb) ! Tsys variable is actually Tsys^2/dh_integ
      !
      ! Now the weights are properly set
      wout = wout*w
      !
      ! Now fill the data by adding to the visibility
      !
      if (polcode.eq.0) then
        ! This code is for averaging the visibilities...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1)
          visi(ki,1) =  visi(ki,1)+real(zout(i))*wout(i)
          visi(ki+1,1) = visi(ki+1,1)+aimag(zout(i))*wout(i)
          visi(ki+2,1) = visi(ki+2,1)+wout(i)
        enddo
      else if (polcode.lt.0) then
        !
        ! This code is for separating the visibilities...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1)
          visi(ki,ipola) =  visi(ki,ipola)+real(zout(i))*wout(i)
          visi(ki+1,ipola) = visi(ki+1,ipola)+aimag(zout(i))*wout(i)
          visi(ki+2,ipola) = visi(ki+2,ipola)+wout(i)
        enddo
        !
        ! Put here the Polarization status ...
        ! Polarization codes have been chosen to verify the following equation.
        !   code_stoke = - (10*code_polar(ia) + code_polar(ja))
        ! but "code_polar" is not defined simply.
        ! See r_lpolentry array, and debug conventions here...
        !
        ! For the time being, by  construction, we have
        !  ipola = r_lpolentry(ia,is)
        ! so, by analogy
        jpola = r_lpolentry(ja,is)
        visi(xima%gil%column_pointer(code_uvt_stok),ipola) = - (10*ipola+jpola)
        !
      else if (polcode.gt.0) then
        ! This code is concatenating the visibilities with 2 Stokes...
        do i=ifirst, ilast
          ki = xima%gil%fcol + xima%gil%natom*(i-1) + xima%gil%natom*xima%gil%nchan*(ipol-1)
          visi(ki,1) =  visi(ki,1)+real(zout(i))*wout(i)
          visi(ki+1,1) = visi(ki+1,1)+aimag(zout(i))*wout(i)
          visi(ki+2,1) = visi(ki+2,1)+wout(i)
        enddo
      endif
      good = .true.
      !
    enddo ! Sub-bands
    !
    ! Increment if anything written
    if (good) then
      if (polcode.ge.0) then
        dvis = 1
      else
        dvis = dvis+1
      endif
    endif
    !
  enddo ! Polarisation
  !
  ! Renormalize ...
  !
!!  do j = 1,dvis
!!    do i = 1,xima%gil%nchan*xima%gil%nstokes
!!      ki = xima%gil%fcol + xima%gil%natom*(i-1)
!!      if (visi(ki+2,j).ne.0.0) then
!!        visi(ki,j) =  visi(ki,j)/visi(ki+2,j)
!!        visi(ki+1,j) = visi(ki+1,j)/visi(ki+2,j)
!!      else
!!        visi(ki,j) =  0.0
!!        visi(ki+1,j) = 0.0
!!      endif
!!    enddo
!!  enddo
  !
  ! Set header of all visibilities if needed
!!  do j = 2,dvis
!!    visi(1:xima%gil%fcol-1,j) = visi(1:xima%gil%fcol-1,1)
!!    do i = xima%gil%lcol+1,xima%gil%dim(1)
!!      if (xima%gil%column_pointer(code_uvt_stok).ne.i) then
!!        visi(i,j) = visi(i,1)
!!      else if (polcode.gt.0) then
!!        visi(i,j) = code_stokes_vv
!!      endif
!!    enddo
!!  enddo
  !
  ! Default weight...
  if (xima%gil%column_pointer(code_uvt_weig).ne.0) then
    do j = 1,dvis
      w = 0.0
      k = 0
      do i = 1,xima%gil%nchan*xima%gil%nstokes
        ki = xima%gil%fcol + xima%gil%natom*(i-1)
        w = w+visi(ki+2,j)
        k = k+1
      enddo
      w = w/k
      visi(xima%gil%column_pointer(code_uvt_weig),j) = w
    enddo
  endif
  !
  ! Final warning in case of rounding
  if (abs((save_res-xima%gil%fres)/xima%gil%fres).gt.1e-4) then
    write(chain,'(a,1pg13.6)')   &
      'Channel separation rounded to ',xima%gil%fres
    call message(4,1,'FILL_VISI',trim(chain))
  endif
  !
  return
2000 format('Subband ',a,' maps to output channels ',i9,' to ',i9)
end subroutine add_visiline
!
subroutine get_angles(x)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Return values of the descriptive angles
  !  Hour, Dec, Az, El, Parallactic
  !---------------------------------------------------------------------
  real(8), intent(out) :: x(5)
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  real(8) :: psi,the,phi ! Euler angles
  real(8) :: x_2(3), v_2(3), n_4(3), n_2(3), den, p_2(3), s_2
  real(8) :: trfm_24(3,3), lat, ho(2)
  !
  ! Well, this is ONLY for PdB...  We need it for other observatories
  ! sdm_* code does this slightly differently.
  ! CLIC or RDI should do it more properly.
  parameter (lat=(44+38d0/60d0+2d0/3600d0)*pi/180d0)
  !
  ! dh_svec is the source vector in hour-angle, dec coordinates (4)
  ! n_4 is the normal to the source meridian plane
  ! TRFM_24 goes from (4) to (2)
  ! n_2 is the normal to the source meridian plane, in horiz coords.(2)
  ! x_2 is the source vector in in horiz coords.
  ! v_2 is the intersection of the vertical plane of the source and
  ! the plane of the sky
  ! p_2 is the vector product of v_2 and n_2
  ! s_2 is the scalar product of p_2 and x_2
  psi=pi/2                   ! 90 degrees
  the=pi/2-lat               ! 90 degrees minus latitude
  phi=-pi/2                  ! -90 degrees
  call eulmat (psi,the,phi,trfm_24)
  call matvec (dh_svec, trfm_24, x_2)
  call spher(x_2, ho)
  !
  ! Return all 5 angles
  ! Hour Angle
  if (dh_svec(1).ne.0) then
    x(1) = atan2(-dh_svec(2),dh_svec(1)) !! *12./pi
  else
    call message(6,3,'VALUE','Error in hour-angle')
    x(1) = blank4
  endif
  ! Declination
  if (abs(dh_svec(3)).le.1.) then
    x(1) = asin(dh_svec(3))  !! *180./pi
  else
    call message(6,3,'VALUE','Error in declination')
    x(1) = blank4
  endif
  ho(1) = mod(ho(1)+3d0*pi,2d0*pi)-pi
  x(3) = -ho(1) !! *180d0/pi  ! Azimuth
  ho(2) = mod(ho(2)+3d0*pi,2d0*pi)-pi
  x(4) = ho(2)  !! *180d0/pi   ! Elevation
  !
  den = sqrt(dh_svec(1)**2+dh_svec(2)**2)
  n_4(1) = -dh_svec(2)/den
  n_4(2) = dh_svec(1)/den
  n_4(3) = 0
  call matvec (n_4, trfm_24, n_2)
  den = sqrt(x_2(1)**2+x_2(2)**2)
  v_2(1) = x_2(1)*x_2(3) / den
  v_2(2) = x_2(2)*x_2(3) / den
  v_2(3) = -den
  p_2(1) = v_2(2)*n_2(3)-v_2(3)*n_2(2)
  p_2(2) = v_2(3)*n_2(1)-v_2(1)*n_2(3)
  p_2(3) = v_2(1)*n_2(2)-v_2(2)*n_2(1)
  s_2 = p_2(1)*x_2(1)+p_2(2)*x_2(1)+p_2(3)*x_2(3) 
  ! Parallactic Angle
  x(5) = -pi/2+sign(acos(v_2(1)*n_2(1)+v_2(2)*n_2(2)+v_2(3)*n_2(3)),s_2)
end subroutine get_angles
!
subroutine vel_scale_3 (name,freq)
  use classic_api
  !---------------------------------------------------------------------
  ! Updates frequencies in header according to last 'SET FREQUENCY' command
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name          !
  real(8), intent(in) :: freq                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  real(8) myfreq
  character(len=12) :: myname
  integer :: isb,isub
  !------------------------------------------------------------------------
  ! Code:
  ! Defaults from Input Header:
  if (name.eq.'*') then
    myname = r_line
  else
    myname = name
  endif
  if (freq.eq.0) then
    myfreq = r_restf
  else
    myfreq = freq
  endif
  ! Loop on sidebands
  do isb = 1, 2
    !
    ! Continuum
    r_crfoff(isb) = myfreq
    r_cnam(isb) = myname
    !
    ! Line
    do isub=1, r_lband
      r_lrfoff(isb,isub) = myfreq
      r_lnam(isb,isub) = myname
    enddo
  enddo
  !
  ! Reset velocity scale accordingly
  call vel_scale
end subroutine vel_scale_3
!

subroutine mingauss(npar,g,f,x,iflag,obs)
  use classfit_interfaces, except_this=>mingauss
  use class_types
  use gauss_parameter
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Function to be minimized in the gaussian fit. By using 3 hidden
  ! parameters, the method allows dependent and independent gaussians to
  ! be fitted.
  ! The computation is highly optimised, but take care of R*4 and
  ! R*8 values !... Basic parameters are Area, Position and Width.
  !----------------------------------------------------------------------
  integer(kind=4),   intent(in)  :: npar     ! Number of parameters
  real(kind=8),      intent(out) :: g(npar)  ! Array of derivatives, size 3+3*Nline (see below)
  real(kind=8),      intent(out) :: f        ! Function values
  real(kind=8),      intent(in)  :: x(npar)  ! Input parameter values, size 3+3*Nline (see midgauss)
  integer(kind=4),   intent(in)  :: iflag    ! Code operation
  type(observation), intent(in)  :: obs      !
  ! Local
  logical :: dograd, dobase
  integer(kind=4) :: i,k,kbas,krai,kline
  real(kind=4) :: tt,vv,dd,gt,gv,gd,ff
  real(kind=4) :: arg,seuil,ta,ybas,yrai,xvel
  real(kind=4), dimension(ngauspar*mgauslin) :: xg
  real(kind=4), dimension(mgauslin) :: argexp,xf,xt,xv,xd
  !
  ! Final computations
  if (iflag.eq.3) then
     ! Compute Sigma after Minimisation
     kbas=0
     ybas=0.
     krai=0
     yrai=0.
     seuil= sigbas/3.
     !
     do i=obs%cimin,obs%cimax
        if (wfit(i).ne.0) then 
           xvel = real(obs%datax(i),4)
           ta = progauss(obs,xvel,0,dobase)
           if (abs(ta).lt.seuil) then
              kbas=kbas+1
              ybas=ybas+obs%spectre(i)**2
           else
              krai=krai+1
              yrai=yrai+(ta-obs%spectre(i))**2
           endif
        endif
     enddo
     if (kbas.gt.5) then
        sigbas=sqrt(ybas/kbas)
     else
        sigbas=0.d0
     endif
     if (krai.ne.0) then
        sigrai=sqrt(yrai/krai)
     else
        sigrai=sigbas
     endif
     if (sigbas.eq.0) sigbas = sigrai
     return
  endif
  !
  dograd = iflag.eq.2
  !
  !	g1 derivee / aire
  !	g2 derivee / vlsr
  !	g3 derivee / delt
  !
  ! Compute gaussians
  f = 0.
  xg = 0.
  gt = 0.
  gv = 0.
  gd = 0.
  xt = 0.
  xv = 0.
  xd = 0.
  ! Retrieve Parameters for Major Variables
  tt = x(1)
  vv = x(2)
  dd = x(3)     
  ! Retrieve parameters for Secondary Variables
  kline = max(nline,1)
  do i=1,kline
     xt(i) = x(3*i+1) * tt
     xv(i) = x(3*i+2) + vv
     xd(i) = x(3*i+3) * dd
  enddo
  !
  do i=obs%cimin,obs%cimax
     if (wfit(i).gt.0) then 
        xvel = obs%datax(i)
        xf     = 0.
        argexp = 0.
        argexp(1:kline) = (xvel - xv(1:kline)) / xd(1:kline)
        where(argexp(1:kline).le.4.)
           xf(1:kline) = exp(-argexp(1:kline)**2)
        end where
        ff = sum(xf(1:kline)*xt(1:kline)/xd(1:kline))
        !
        ! Compute chi^2 (No ponderation, WFIT is ignored)
        ff =  (ff - obs%spectre(i))
        f = f + ff**2
        !
        ! Compute Gradients
        if (dograd) then
           ff = 2. * ff
           do k=1,kline
              if (xf(k).ne.0.) then
                 arg            = xf(k) * ff / xd(k)
                 xg(1+3*(k-1))  = xg(1+3*(k-1)) + arg
                 gt             = gt + arg*xt(k)
                 !
                 arg            = xt(k)*arg/xd(k)
                 xg(3+3*(k-1))  = xg(3+3*(k-1)) - arg
                 gd             = gd - arg*xd(k)
                 !
                 arg            = arg*argexp(k)*2.
                 xg(2+3*(k-1))  = xg(2+3*(k-1)) + arg
                 xg(3+3*(k-1))  = xg(3+3*(k-1)) + arg*argexp(k)
                 gv             = gv + arg
                 gd             = gd + arg*argexp(k)*xd(k)
              endif
           enddo
        endif
     endif
  enddo
  !
  ! Setup values and return
  g(1)=gt/tt
  g(2)=gv
  g(3)=gd/dd
  !
  do i=1,kline
     g(3*i+1) = xg(1+3*(i-1)) *tt
     g(3*i+2) = xg(2+3*(i-1))
     g(3*i+3) = xg(3+3*(i-1)) *dd
  enddo
  !
end subroutine mingauss

subroutine amtinv(cmat,npar)
  !---------------------------------------------------------------------
  ! POINT
  ! 	Matrix inversion through Gauss maximum pivot
  !	Dimensionned for size MVAR, MVAR
  ! J.Cernicharo, S.Guilloteau
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  real*8 :: cmat(mvar,mvar)         !
  integer :: npar                   !
  ! Local
  real*8 :: amat(mvar,mvar+1),resol(mvar),amax
  integer :: j,l
  !
  if (npar.eq.1) then
    cmat(1,1)=1./cmat(1,1)
    return
  endif
  amax=-1.0d10
  do j=1,npar
    do l=1,npar
      amax = max(cmat(j,l),amax)
    enddo
  enddo
  do j=1,npar
    do l=1,npar
      amat(j,l)=cmat(j,l)/amax
    enddo
  enddo
  do j=1,npar+1
    do l=1,npar
      amat(l,npar+1)=0.0d0
    enddo
    amat(j,npar+1)=1.0d0
    call gauss(amat,resol,npar)
    do l=1,npar
      cmat(l,j)=resol(l)/amax
    enddo
  enddo
end

subroutine pico_emir(line,error)
  use gbl_message
  use gildas_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_emir
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! EMIR command to define and visualize EMIR coverage
  ! EMIR F1 SB1 F2 SB2 /CATALOG /zoom
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='EMIR'
  integer(kind=4),parameter :: optzoom=1 ! option /ZOOM
  integer(kind=4),parameter :: optpagewidth=2 ! option /PAGEWIDTH
  integer(kind=4),parameter :: optinfo=3 ! option /INFO
  integer(kind=4) :: lpar,izoom,nzmode,it
  integer(kind=4), parameter :: m_zmodes=2
  character(len=20) ::  zmodes(m_zmodes),zmode
  logical :: noarg
  real(kind=8) :: fcomm
  data zmodes/'ID','BOTH'/
  !
  error = .false.
  !
  if (obsname.ne.'PICOVELETA'.and.obsname.ne.'VELETA') then
      call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
      error = .true.
      return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'EMIR',emir%rec%desc,error)
  if (error) return
  !Define emir switchbox parameters
  call rec_define_emir_switchbox(emir%switch,error)
  if (error) return
  !
  emir%rec%desc%redshift=.true.
  call astro_def_recsource(rname,emir%rec%desc,emir%rec%source,error)
  if (error) return
  !
  !Print Receiver info in the terminal
  if (sic_present(optinfo,0)) then
    call astro_receiver_info(emir%rec%desc,rname,error)
    if (error) return
  endif
  !Decoding Line Command
  ! First tuning
  zmode='ID'
  izoom=0
  emir%comm%n_tunings = 0
  if (error) return
  if (sic_present(0,1)) then
    noarg = .false.
    call pico_reset_emir(emir,error)
    emir%comm%n_tunings = 1
    call sic_r8(line,0,1,fcomm,.true.,error)
    if (error) return
    call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%frest(1),error)
    if (error) return
    call sic_ch(line,0,2,emir%comm%code(1),lpar,.true.,error)
    if (error) return
    ! Second tuning
    emir%comm%frest(2) = 0
    emir%comm%code(2) = ''
    if (sic_present(0,3)) then
      ! second tuning
      emir%comm%n_tunings = 2
      call sic_r8(line,0,3,fcomm,.true.,error)
      if (error) return
      call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%frest(2),error)
      if (error) return
      call sic_ch(line,0,4,emir%comm%code(2),lpar,.true.,error)
      if (error) return
    endif
  else ! case without argument
    noarg=.true.
    call astro_message(seve%i,rname,'Showing the coverage of EMIR bands')
  endif
  ! Options
  ! Zoom parameter
  if (sic_present(optzoom,0)) then
    if (sic_present(optzoom,1)) then
      emir%comm%zoommode = 'NULL'
      call sic_ke (line,optzoom,1,emir%comm%zoommode,lpar,.false.,error)
      if (error) return
      call sic_ambigs_sub(rname,trim(emir%comm%zoommode),zmode,nzmode,zmodes,m_zmodes,error)
      if (error) return
      if (nzmode.eq.0) then !means that keyword was not recognized
        if (sic_present(optzoom,2)) then
          zmode='FREQ'
          call sic_r8(line,optzoom,1,fcomm,.true.,error)
          if (error) return
          fcomm=fcomm*mhzperghz
          call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%fz1,error)
          if (error) return
          call sic_r8(line,optzoom,2,fcomm,.true.,error)
          if (error) return
          fcomm=fcomm*mhzperghz
          call rec_inputtorest(rname,fcomm,freq_axis%main,emir%rec%source,emir%comm%fz2,error)
          if (error) return
        else
          if (emir%comm%n_tunings.eq.0) then
            call astro_message(seve%e,rname,'Try to tune on a not tune band')
            error = .true.
            return
          endif
          zmode='SINGLE'
          call sic_i0(line,optzoom,1,izoom,.true.,error)
          if (error) return
        endif
      endif
    else
      if (emir%comm%n_tunings.eq.1) then
        izoom = 1
        zmode='SINGLE'
      else if (emir%comm%n_tunings.eq.2) then
        izoom = 0
        zmode='BOTH'
      else
        call astro_message(seve%e,rname,'/ZOOM option without argument is ambiguous in this case')
        error = .true.
        return
      endif
    endif
  endif
  ! /pagewidth option
  if (sic_present(optpagewidth,0)) then
    emir%comm%fixed_scale = .false.
  else
    emir%comm%fixed_scale = .true.
  endif
  !
  !Prepare for the plot
  call pico_emir_setup(emir,error)
  if (error) return
  !
  if (zmode.eq.'ID') then
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        molecules,emir%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        molecules,cplot,freq_axis,error)
        if (error) return
      enddo
    endif
  else if (zmode.eq.'BOTH') then
    if (emir%rec%n_tunings.ne.2) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_nbands(emir%rec,molecules,emir%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
  else if (zmode.eq.'SINGLE') then
    if (izoom.le.0.or.izoom.gt.emir%comm%n_tunings.or.emir%comm%n_tunings.eq.0) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(emir%rec%desc,emir%rec%source,emir%rec%tune(izoom),cplot,molecules,freq_axis,error)
    if (error) return
  else if (zmode.eq.'FREQ') then
    call rec_zoom(molecules,emir%comm%fz1,emir%comm%fz2, &
                  emir%rec%desc,emir%rec%source,cplot,freq_axis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        molecules,cplot,freq_axis,error)
        if (error) return
      enddo
    endif
  endif
  !
  !
  if (noarg) then
    ! if no tuning was entered, reset the rec%n_tuning to 0
    ! like this ifproc/backend command will not work (need at least 1 tuning)
    emir%rec%n_tunings = 0
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine pico_emir
!
subroutine rec_define_emir(rname,rdesc,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_emir
  use ast_line
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! fill in the receiver type according to input name
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(inout) :: rdesc ! receiver parameters
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: i
  real(kind=8)          :: loexplore
  real(kind=8)          :: fold_offset  
  !
  ! Handle the change of frequency implemented in 2021
  if (obs_year.eq.2016) then
    fold_offset=0d0
  else if  (obs_year.eq.2021) then
    fold_offset=320d0
  else
    call astro_message(seve%e,rname,'PICO generation not understood')
    error = .true.
    return
  endif
  !
  rdesc%name = 'EMIR'
  rdesc%defined=.true.
  rdesc%n_rbands = 4
  rdesc%bandname(1) = 'E090'
  rdesc%bandname(2) = 'E150'
  rdesc%bandname(3) = 'E230'
  rdesc%bandname(4) = 'E330'
  rdesc%rejection(1) = 10
  rdesc%rejection(2) = 10
  rdesc%rejection(3) = 10
  rdesc%rejection(4) = 10
  rdesc%n_sbands = 2
  rdesc%n_bbands = 2
  rdesc%n_polar = 2
  rdesc%n_backends = 3
  ! Use FTS wide limits because it is the wider backend
  rdesc%iflim(1) = 3950d0
  rdesc%iflim(2) = 11730d0+fold_offset
  rdesc%ifband = rdesc%iflim(2)-rdesc%iflim(1)
  !basebands
  rdesc%flo2 = 0d0 !we ignore if2 for pico
  rdesc%bbname(1) = 'OUTER'
  rdesc%bblim(1,1) = 7680d0+fold_offset
  rdesc%bblim(2,1) = 11730d0+fold_offset
  rdesc%bbref(1) = 9430d0+fold_offset !from emir doc - center of vespa region
  rdesc%bbname(2) = 'INNER'
  rdesc%bblim(1,2) = 3950d0
  rdesc%bblim(2,2) = 8000d0
  rdesc%bbref(2) = 6250d0 !from emir doc - center of vespa region
  ! Polars
  rdesc%polname(1) = 'HORIZONTAL'
  rdesc%polname(2) = 'VERTICAL'
  !LO limits deduced from EMIR Doc Observable Limits
  !Take the widest range independtly on USB/LSB, a check of feasibility is done afterwards (pico_emir_lo_call)
  rdesc%locall(1,1) = 73.0d3+rdesc%bbref(1)-fold_offset !LSB outer
  rdesc%locall(2,1) = 102d3+rdesc%bbref(2) ! LSB inner allows to go ghigher than USB (in exploration mode)
  rdesc%locall(1,2) = 125d3+rdesc%bbref(1)-fold_offset !LSB outer
  rdesc%locall(2,2) = 184d3-rdesc%bbref(1)+fold_offset  !USB outer
  rdesc%locall(1,3) = 217d3-rdesc%bbref(2) ! USB inner  allows to go lower than USB
  rdesc%locall(2,3) = 263.5d3+rdesc%bbref(2) ! LSB inner
  rdesc%locall(1,4) = 277d3+rdesc%bbref(1)-fold_offset
  rdesc%locall(2,4) = 375d3-rdesc%bbref(1)+fold_offset
  !
  ! Limits from the call to guess the band (limits of possible requested freq)
  rdesc%rfcallreq(1,1) = 72.68d3
  rdesc%rfcallreq(2,1) = 117d3
  rdesc%rfcallreq(1,2) = 125d3
  rdesc%rfcallreq(2,2) = 184d3
  rdesc%rfcallreq(1,3) = 202d3
  rdesc%rfcallreq(2,3) = 274d3
  rdesc%rfcallreq(1,4) = 277d3
  rdesc%rfcallreq(2,4) = 375d3
  !
  ! wider ranges to let the user explore the edge of the bands
  ! Arbitrarily wider by 2GHz in both sides
  ! Wider limits to let some margin to explore the edge of the bands
  loexplore=1.49d3
  do i=1,rdesc%n_rbands
    rdesc%lohard(1,i) = rdesc%locall(1,i)-loexplore
    rdesc%lohard(2,i) = rdesc%locall(2,i)+loexplore
    rdesc%rfcallreq(1,i) = rdesc%rfcallreq(1,i)-loexplore
    rdesc%rfcallreq(2,i) = rdesc%rfcallreq(2,i)+loexplore

  enddo
  ! limits to be used for tuning
  do i=1,rdesc%n_rbands
      rdesc%lolim(1,i) = min(rdesc%locall(1,i),rdesc%lohard(1,i))
      rdesc%lolim(2,i) = max(rdesc%locall(2,i),rdesc%lohard(2,i))
  enddo
  ! Tolerance for tuning close to the band edge
  rdesc%lotol = 100d0  
  ! RF limits from LO +- IFmax
  do i=1,rdesc%n_rbands
      rdesc%rflim(1,i) = rdesc%lolim(1,i)-rdesc%iflim(2)
      rdesc%rflim(2,i) = rdesc%lolim(2,i)+rdesc%iflim(2)
  enddo
  ! RF limits from Call +- IFmax
  do i=1,rdesc%n_rbands
      rdesc%rfcall(1,i) = rdesc%locall(1,i)-rdesc%iflim(2)
      rdesc%rfcall(2,i) = rdesc%locall(2,i)+rdesc%iflim(2)
  enddo
  !
  rdesc%tuninggrid = .false.
  rdesc%gridbin = 0d0 ! MHz
  rdesc%gridtol = 0d0 ! MHz
  !
end subroutine rec_define_emir
!
subroutine pico_emir_lo_call(rname,ib,flo,sb,error)
  use gbl_message
  use astro_interfaces, except_this=>pico_emir_lo_call
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! call for proposal offers different LO limits according to tuning sideband
  ! rec_define_emir takes union of LSB and USB limits, we check feasibility here
  !-----------------------------------------------------------------------
  character(len=*) , intent(in) :: rname
  integer(kind=4), intent(in) :: ib
  real(kind=8), intent(in)    :: flo
  character(len=*), intent(in)    :: sb
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: isb
  real(kind=8) :: cmin,cmax
  !
  if (sb.eq."LSB") then
    isb=lsb_code
  else if (sb.eq."USB") then
    isb=usb_code
  else
    call astro_message(seve%e,rname,"Problem with Sideband")
    error=.true.
    return
  endif
  !
  if (ib.eq.1.and.isb.eq.lsb_code) then
    ! band 1 LSB: warning when Fcent above 97 in LSB
    if (flo.gt.103250d0.and.flo.le.108250d0) then
      call astro_message(seve%w,rname,'Tuning performance might not be optimal, consider switching to USB')
    endif
  else if (ib.eq.1.and.isb.eq.usb_code.and.flo.gt.1072500d0) then
    ! LSB LOmax B1 is higher than USB LOmax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.1.and.isb.eq.usb_code.and.flo.lt.82750d0) then
    ! USB LOmin B1 is higher than LSB LOmin
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.3.and.isb.eq.usb_code.and.flo.gt.264250d0) then
    ! USB LOmax is smaller than LSB LOmax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in LSB mode')
    error=.true.
    return
  else if (ib.eq.3.and.isb.eq.lsb_code.and.flo.lt.211750d0) then
    ! USB LOmin is smaller than LSB LOmmin
    call astro_message(seve%e,rname,'This LO frequency is reachable only in USB mode')
    error=.true.
    return
  else if (ib.eq.4.and.isb.eq.lsb_code.and.flo.gt.341250d0) then
    ! USB LOmax is higher than LSB LOMax
    call astro_message(seve%e,rname,'This LO frequency is reachable only in USB mode')
    error=.true.
    return
  endif
  !
end subroutine pico_emir_lo_call
!
subroutine rec_define_emir_switchbox(emirsw,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_emir_switchbox
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! switchbox characteristics
  !-----------------------------------------------------------------------
  type(correlator_input_t), intent(inout) :: emirsw ! emir switchbox parameters
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: i
  ! Switchbox
  emirsw%n_ifcables = 8
  emirsw%m_usercables = 4
  emirsw%mode = ''
  emirsw%defined = .false.
  do i=1,m_ifcables
    emirsw%ifc(i)%label = ''
    emirsw%ifc(i)%iband = 0
    emirsw%ifc(i)%sb_code = 0
    emirsw%ifc(i)%bb_code = 0
    emirsw%ifc(i)%pol_code = 0
  enddo
  !
end subroutine rec_define_emir_switchbox
!
subroutine pico_reset_emir(emir,error)
  use astro_interfaces, except_this=>pico_reset_emir
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! reset emir specific parameters
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir 
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4)       :: i
  !
  !Command parameters
  emir%comm%n_tunings = 0
  do i=1,m_tunings
    emir%comm%frest(i) = 0
    emir%comm%code(i) = ''
  enddo
  emir%comm%zoommode = ''
  emir%comm%fz1 = 0
  emir%comm%fz2 = 0
  emir%comm%fixed_scale = .false.
  !
  ! Setup parameters
  do i=1,m_tunings
    emir%setup%sb_code(i) = 0
    emir%setup%polar(i) = ''
    emir%setup%pol_code(i) = 0
  enddo
  emir%setup%sb_mode = ''
  emir%setup%polmode = ''
  !
  ! Switchbox
  emir%switch%mode = ''
  emir%switch%defined = .false.
  do i=1,m_ifcables
    emir%switch%ifc(i)%label = ''
    emir%switch%ifc(i)%iband = 0
    emir%switch%ifc(i)%sb_code = 0
    emir%switch%ifc(i)%bb_code = 0
    emir%switch%ifc(i)%pol_code = 0
  enddo
  !
end subroutine pico_reset_emir
!
subroutine pico_emir_setup(emir,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_emir_setup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! Check feasability and tune emir requested bands
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir !command line parameters
  logical, intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname='EMIR'
  integer, parameter :: m_codes=4
  integer(kind=4) :: it,icode
  character(len=2) :: emircodes(m_codes),emircode
  data emircodes/'UI','LI','UO','LO'/
  !
  emir%rec%n_tunings=emir%comm%n_tunings
  do it=1,emir%rec%n_tunings 
    emir%rec%comm(it)%rec_name = 'EMIR'
    emir%rec%comm(it)%frest = emir%comm%frest(it)
    call sic_upper(emir%comm%code(it))
    call sic_ambigs(rname,emir%comm%code(it),emircode,icode,emircodes,m_codes,error)
    if (error) then
      call astro_message(seve%e,rname,'Problem decoding tuning sideband code (UI LI UO LO)')
      return
    endif
    select case (emir%comm%code(it))
      case ('UI')
         emir%rec%comm(it)%sideband = 'USB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(inner_code)
      case ('UO')
         emir%rec%comm(it)%sideband = 'USB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(outer_code)
      case ('LI')
         emir%rec%comm(it)%sideband = 'LSB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(inner_code)
      case ('LO')
         emir%rec%comm(it)%sideband = 'LSB'
         emir%rec%comm(it)%fcent = emir%rec%desc%bbref(outer_code)
    end select
    emir%rec%comm(it)%name = ''
    ! tune the bands
    call astro_tune_receiver(rname,emir%rec%desc,emir%rec%source,emir%rec%comm(it),emir%rec%tune(it),error)
    if (error) return
    !
    !Check compliance with call for proposal LO limits
    call pico_emir_lo_call(rname,emir%rec%tune(it)%iband,emir%rec%tune(it)%flo1,emir%rec%comm(it)%sideband,error)
    if (error) return
  enddo
  !
  !Check band combination feasability (in n_tunings>1)
  !
  if (emir%rec%n_tunings.gt.1) then
    !Band combination
    if (emir%rec%tune(1)%iband.eq.emir%rec%tune(2)%iband) then
      call astro_message(seve%e,rname,'A receiver band can be tuned at only one frequency at a time')
      call rec_display_error('A receiver band can be tuned at only one frequency at a time',error)
      if (error) return
      error = .true.
      return
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E090') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).eq.'E330') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E090 can be combined with E150 or E230')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E150') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).eq.'E230') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E150 can be combined with E090 or E330')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E230') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).ne.'E090') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E230 can be combined with E090 only')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
    if (emir%rec%desc%bandname(emir%rec%tune(1)%iband).eq.'E330') then
      if (emir%rec%desc%bandname(emir%rec%tune(2)%iband).ne.'E150') then
        call astro_message(seve%e,rname,'Band combination is not allowed')
        call astro_message(seve%i,rname,'E330 can be combined with E150 only')
        call rec_display_error('Band combination is not allowed',error)
        if (error) return
        error = .true.
        return
      endif
    endif
  endif
  !
end subroutine pico_emir_setup
!
subroutine emir_switchbox(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switchbox
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! SWITCHBOX command to define what are the basebands brought to the backends
  ! no arg = defaults =  single band or maximize FTS coverage + dual polar when possible
  ! option SINGLEPOLAR (only dual band) = maximize FTS coverage + single polar when possible
  ! with arguments : sets explicitely the content of the 1-4 if cables
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout)        :: error
  ! local
  character(len=*), parameter :: rname = 'EMIR'
  integer(kind=4), parameter :: optsingle = 1
  integer(kind=4)       :: lpar,i
  logical               :: dopchanged
  character(len=5)     :: cablecode(emir%switch%m_usercables)
  character(len=200)    :: comm
  !
  if (obsname.ne.'PICOVELETA'.and.obsname.ne.'VELETA') then
    call astro_message(seve%e,rname,'Observatory changed since last tuning - Please define a new tuning')
    error = .true.
    return
  endif
  ! Check that a tuning has been set
  if (emir%rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (EMIR command) before setting the switchbox configuration')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning command
  call rec_check_doppler(emir%rec%source,emir%rec%desc%redshift,dopchanged,error)
  if (error) return
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source properties changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning (EMIR command)')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  !
  ! Automatic = widest possible / dual polar when possible
  ! + define all possible codes for cables
  emir%switch%mode = 'AUTO'
  if (sic_present(0,1)) then
    emir%switch%mode = 'LIST'
    do i=1,emir%switch%m_usercables
      call sic_ke(line,0,i,cablecode(i),lpar,.true.,error)
      if (error) return
    enddo
  endif
  if (sic_present(optsingle,0)) then
    if (emir%switch%mode.eq.'LIST') then
      call astro_message(seve%e,rname,'The option SINGLEPOLAR cannot be used when a list of basebands is provided')
      error = .true.
      return
    endif
    if (emir%rec%n_tunings.lt.2) then
      call astro_message(seve%e,rname,'The option /SINGLEPOLAR has no sense when using only 1 receiver band')
      error = .true.
      return
    endif
    emir%switch%mode = 'SINGLE'
  endif
  !
  !define the switch box situation corresponding to the setup
  if (emir%switch%mode.eq.'SINGLE'.or.emir%switch%mode.eq.'AUTO') then
    call emir_switch_autosetup(emir,error)
    if (error) return
  else if (emir%switch%mode.eq.'LIST') then
    call emir_switch_listsetup(emir,cablecode,error)
    if (error) return
!    call astro_message(seve%e,rname,'NOT YET IMPLEMENTED')
  else
    call astro_message(seve%e,rname,'Problem with switchbox mode')
    error = .true.
    return
  endif
  !
  do i=1,emir%switch%n_ifcables
    write (comm,'(a,1x,i0,1x,a,1x,a)') 'IF Cable #',i,'contains',emir%switch%ifc(i)%label
    call astro_message(seve%i,rname,comm)
  enddo
  !
  emir%switch%defined = .true.
  !
  call pico_switch_plot(emir,molecules,cplot,freq_axis,error)
  if (error) return
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine emir_switchbox
!
subroutine emir_switch_autosetup(emir,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switch_autosetup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! assign the right baseband to the 8 emir if cables - default with inner and outer
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout)   :: emir
  logical, intent(inout)        :: error
  ! Local      
  character(len=*), parameter :: rname = 'EMIR'
  integer(kind=4) :: it,is,ip,ib,icable,iother, n_polar
  integer(kind =4):: sb_code(m_sideband),bbcode(m_bbands),n_sidebands,polcode(emir%rec%desc%n_polar)
  integer(kind=4), parameter :: polh_code = 1
  integer(kind=4), parameter :: polv_code = 2
  character(len=5)      :: cablecode
  character(len=1)      :: polname(emir%rec%desc%n_polar)
  !
  bbcode(1) = outer_code
  bbcode(2) = inner_code
!   if (rec%desc%n_polar.eq.1) then
!     polname(1) = rec%desc%polname(1)(1:1)
!     if (polname(1).eq.'H') then
!       polcode(1) = polh_code
!     else if (polname(1).eq.'V') then
!       polcode(1) = polv_code
!     else
!       call astro_message(seve%e,rname,'Unknown polarization type')
!       error = .true.
!       return
!     endif
!   else if 
!     polcode(1) = polh_code
!     polcode(2) = polv_code
!     polname(1) = rec%desc%polname(1)
!     polname(2) = rec%desc%polname(2)
!   else
!     call astro_message(seve%e,rname,'Problem with polarization types')
!     error = .true.
!     return
!   endif
  !
  ! sideband and polar consequences of the band combination + SINGLE POLAR OPTION
  if (emir%rec%n_tunings.eq.2) then
    if (emir%rec%tune(1)%sb_code.ne.emir%rec%tune(2)%sb_code) then
      emir%setup%polmode='SINGLE'
      emir%setup%sb_mode = '2SB'
      emir%setup%sb_code(1) = 0
      emir%setup%sb_code(2) = 0
      call astro_message(seve%i,rname,'This tuning combination provides:')
      call astro_message(seve%i,rname,'2 sidebands and only 1 polar in each band')
      call astro_message(seve%i,rname,'Single polar observations are not recommended')
      call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)') 
      call astro_message(seve%i,rname,'You may tune the two bands in the same sideband (U/L)')
      call astro_message(seve%i,rname,'to get dual polar in 1 sideband only')
    else
      if (emir%switch%mode.eq.'AUTO') then
        emir%setup%polmode='DUAL'
        emir%setup%polar(1) = 'H+V'
        emir%setup%polar(2) = 'H+V'
        emir%setup%sb_mode = 'SSB'
        emir%setup%sb_code(1) = emir%rec%tune(1)%sb_code
        emir%setup%sb_code(2) = emir%rec%tune(2)%sb_code
        call astro_message(seve%i,rname,'The default configuration for this combination provides:')
        call astro_message(seve%i,rname,'only 1 sideband and 2 polars in each band')
        call astro_message(seve%i,rname,'The option /SINGLEPOLAR can be used to get:')
        call astro_message(seve%i,rname,'2 sidebands and only 1 polar in each band')
        call astro_message(seve%i,rname,'Single polar observations are not recommended')
        call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)') 
     else if (emir%switch%mode.eq.'SINGLE') then
        emir%setup%polmode='SINGLE'
        emir%setup%sb_mode = '2SB'
        emir%setup%sb_code(1) = 0
        emir%setup%sb_code(2) = 0
        call astro_message(seve%i,rname,'The option /SINGLEPOLAR forces the use of')
        call astro_message(seve%i,rname,'2 sidebands and only 1 polar')
        call astro_message(seve%i,rname,'Single polar observations are not recommended')
        call astro_message(seve%i,rname,'(lack of cross checks for ghostlines/calibration)')
        call astro_message(seve%i,rname,'Without the option, this band combination would provide')
        call astro_message(seve%i,rname,'2 polars in only 1 sideband in each band')
      else
        call astro_message(seve%e,rname,'Problem with switchbox mode')
        error = .true.
        return
      endif
    endif
    if (emir%setup%polmode.eq.'SINGLE') then
      do it=1,emir%rec%n_tunings
        if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E330'.or.                 &
            emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E230')            then
          emir%setup%pol_code(it) = polv_code
          emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
        else if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E090') then
          emir%setup%pol_code(it) = polh_code
          emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
        else if (emir%rec%desc%bandname(emir%rec%tune(it)%iband).eq.'E150') then
          if (it.eq.1) then 
            iother = 2
          else if (it.eq.2) then
            iother = 1
          else
            call astro_message(seve%e,rname,'Problem with Band identification')
            error = .true.
            return
          endif
          if (emir%rec%desc%bandname(emir%rec%tune(iother)%iband).eq.'E330') then
            emir%setup%pol_code(it) = polh_code
            emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
          else if (emir%rec%desc%bandname(emir%rec%tune(iother)%iband).eq.'E090') then
            emir%setup%pol_code(it) = polv_code
            emir%setup%polar(it) = emir%rec%desc%polname(emir%setup%pol_code(it))(1:1)
          endif
        else
          call astro_message(seve%e,rname,'Problem with Band identification')
          error = .true.
          return
        endif
      enddo
    endif
  else if (emir%rec%n_tunings.eq.1) then
    emir%setup%polmode='DUAL'
    emir%setup%polar(1) = 'H+V'
    emir%setup%sb_mode = '2SB'
    emir%setup%sb_code(1) = 0
  else
    call astro_message(seve%e,rname,'Problem with the number of tunings')
    error = .true.
    return
  endif
  !Define what goes through the cables - default is INNER for cable 1 to 4  !
  do it=1,emir%rec%n_tunings
    if (emir%setup%sb_mode.eq.'2SB') then
      n_sidebands = 2
      sb_code(1) = usb_code
      sb_code(2) = lsb_code
    else if (emir%setup%sb_mode.eq.'SSB') then
      n_sidebands = 1
      sb_code(1) = emir%setup%sb_code(it)
    else
      call astro_message(seve%e,rname,'Problem with sidebands')
      error = .true.
      return
    endif
    if (emir%setup%polmode.eq.'DUAL') then
      n_polar = 2
      polname(1) = 'H'
      polname(2) = 'V'
      polcode(1) = polh_code
      polcode(2) = polv_code
    else if (emir%setup%polmode.eq.'SINGLE') then
      n_polar = 1
      polname(1) = emir%setup%polar(it)
      if (polname(1).eq.'H') then
        polcode(1) = polh_code
      else if (polname(1).eq.'V') then
        polcode(1) = polv_code
      else
        call astro_message(seve%e,rname,'Problem with polarization determination')
        error = .true.
        return
      endif
    else
      call astro_message(seve%e,rname,'Problem with number of polars')
      error=.true.
      return
    endif
    do is=1,n_sidebands
      do ip=1,n_polar
        do ib=1,emir%rec%desc%n_bbands
          write (cablecode,'(i0,a,i0,i0)') emir%rec%tune(it)%iband,polname(ip),sb_code(is),bbcode(ib)
          ! by default outer goes only to cable 5 to 8 - cable 1 to 4 takes inner
          select case (cablecode)
          case ('1V22','4V22','2V12','3V12')
            icable = 1
            !
          case ('1V21','4V21','2V11','3V11')
            icable = 5
            !
          case ('1V12','4V12','2V22','3V22')
            icable = 2
            !
          case ('1V11','4V11','2V21','3V21')
            icable = 6
            !
          case ('1H22','4H22','2H12','3H12')
            icable = 3
            !
          case ('1H21','4H21','2H11','3H11')
            icable = 7
            !
          case ('1H12','4H12','2H22','3H22')
            icable = 4
            !
          case ('1H11','4H11','2H21','3H21')
            icable = 8
            !
          case default
            call astro_message(seve%e,rname,'Problem defining the switch box setup')
            error = .true.
            return
          end select
          emir%switch%ifc(icable)%iband = emir%rec%tune(it)%iband
          emir%switch%ifc(icable)%sb_code = sb_code(is)
          emir%switch%ifc(icable)%bb_code = bbcode(ib)
          emir%switch%ifc(icable)%pol_code = polcode(ip)
          write (emir%switch%ifc(icable)%label,'(a,a,a,a)') emir%rec%desc%bandname(emir%rec%tune(it)%iband)(1:2),            &
                  polname(ip)(1:1),sideband(sb_code(is))(1:1),emir%rec%desc%bbname(ib)(1:1)
        enddo
      enddo
    enddo
  enddo
  !
end subroutine emir_switch_autosetup
!
subroutine emir_switch_listsetup(emir,cablecode,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>emir_switch_listsetup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! assign user defined IF cables - user provides 4 codes, we deduce 8 IF cables
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout)   :: emir
  character(len=*), intent(inout)  :: cablecode(emir%switch%m_usercables)
  logical, intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname = 'EMIR'
  character(len=2) :: urec
  character(len=1) :: upol
  character(len=1) :: uside
  character(len=1) :: ubb
  logical :: found,assigned(emir%switch%m_usercables)
  character(len=12)      :: polname(2)
  character(len=200)      :: mess
  integer(kind=4) :: ic,it,is,ip,ib,icable,icode
  integer(kind=4) :: bbcode(emir%rec%desc%n_bbands),sb_code(m_sideband),polcode(emir%rec%desc%n_polar)
  integer(kind=4), parameter :: polh_code = 1
  integer(kind=4), parameter :: polv_code = 2
  !
  if (emir%rec%desc%n_polar.eq.2) then
    polcode(1) = polh_code
    polcode(2) = polv_code
  else
    polname(1) = emir%rec%desc%polname(1)
    if  (polname(1)(1:1).eq.'H') then
      polcode(1) = polh_code
    else if  (polname(1)(1:1).eq.'V') then
      polcode(1) = polv_code
    else
      call astro_message(seve%e,rname,'Problem with polarization determination')
      error = .true.
      return
    endif
  endif
  !
  bbcode(1) = outer_code !outer
  bbcode(2) = inner_code !inner
  !
  emir%setup%polmode = 'USER'
  emir%setup%sb_mode = ''
  !
  do ic=1,emir%switch%m_usercables
    assigned(ic) = .false.
  enddo
  do icode=1,emir%switch%m_usercables
    found = .false.
    call sic_upper(cablecode(icode))
    urec = cablecode(icode)(1:2)
    upol = cablecode(icode)(3:3)
    uside = cablecode(icode)(4:4)
    ubb = cablecode(icode)(5:5)
    do it=1,emir%rec%n_tunings
      if (urec.ne.emir%rec%desc%bandname(emir%rec%tune(it)%iband)(1:2)) cycle
      if (emir%rec%desc%n_sbands.eq.2) then
        sb_code(1) = usb_code
        sb_code(2) = lsb_code
      else
        sb_code(1) = emir%rec%tune(it)%sb_code
      endif
      do is=1,emir%rec%desc%n_sbands
        if (uside.ne.sideband(sb_code(is))(1:1)) cycle
        do ip=1,emir%rec%desc%n_polar
          if (upol.ne.emir%rec%desc%polname(ip)(1:1)) cycle
          do ib=1,emir%rec%desc%n_bbands
            if (ubb.ne.emir%rec%desc%bbname(ib)(1:1)) cycle
            select case (cablecode(icode))
            case ('E0VLI','E3VLI','E1VUI','E2VUI','E0VLO','E3VLO','E1VUO','E2VUO')
              icable = 1
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0VUI','E3VUI','E1VLI','E2VLI','E0VUO','E3VUO','E1VLO','E2VLO')
              icable = 2
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0HLI','E3HLI','E1HUI','E2HUI','E0HLO','E3HLO','E1HUO','E2HUO')
              icable = 3
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case ('E0HUI','E3HUI','E1HLI','E2HLI','E0HUO','E3HUO','E1HLO','E2HLO')
              icable = 4
              if (assigned(icable)) then
                call astro_message(seve%e,rname,'The same cable cannot be used several times')
                error = .true.
                return
              endif
              assigned(icable) = .true.
              found = .true.
            case default
              call astro_message(seve%e,rname,'Code was not understood')
              error = .true.
              return
            end select
            emir%switch%ifc(icable)%iband = emir%rec%tune(it)%iband
            emir%switch%ifc(icable)%sb_code = is
            emir%switch%ifc(icable)%bb_code = bbcode(ib)
            emir%switch%ifc(icable)%pol_code = polcode(ip)
            emir%switch%ifc(icable)%label = cablecode(icode)
            ! corresponding cable 4-8
            emir%switch%ifc(icable+emir%switch%m_usercables)%iband = emir%rec%tune(it)%iband
            emir%switch%ifc(icable+emir%switch%m_usercables)%sb_code = is
            emir%switch%ifc(icable+emir%switch%m_usercables)%bb_code = bbcode(1) !outer is forced
            emir%switch%ifc(icable+emir%switch%m_usercables)%pol_code = polcode(ip)
            write(emir%switch%ifc(icable+emir%switch%m_usercables)%label,'(a,a)')     &
                    cablecode(icode)(1:4),emir%rec%desc%bbname(1)(1:1)
          enddo ! baseband
        enddo !polar
      enddo ! sidebands
    enddo ! receivers
    if (.not.found) then
      write (mess,'(a,1x,a)') 'Code provided by the user does not match',cablecode(icode)
      call astro_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo ! user input
  !
end subroutine emir_switch_listsetup
!
subroutine pico_switch_plot(emir,cata,cplot,drawaxis,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pico_switch_plot
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the polarizations and sideband available with the current emir setup
  !-----------------------------------------------------------------------
  type(emir_t), intent(inout) :: emir
  type(plot_molecules_t), intent(in) :: cata
  type(current_boxes_t), intent(inout) :: cplot
  type(frequency_axis_t), intent(in) :: drawaxis
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='EMIR'
  integer(kind=4) :: i,j,k,sb_code(m_sideband),ip,ib,ic,izoom,it,iband
  character(len=200) :: comm,defchar,smallchar,molchar
  character(len=5) :: cablecode
  real(kind=8) :: fif1,frf,frest,yt,l1,l2,l3,l4,b1,b2,b3,b4
  type(draw_rect_t)     :: sbrect
  type(draw_line_t)     :: linebb
  real(kind=4), parameter :: sdefchar = 0.4
  logical       :: nobb
  !
  sb_code(1) = usb_code
  sb_code(2) = lsb_code
  !
  !Clear and redraw in case the frequency axis were changed since last EMIR command
  call gr_execl('CLEAR DIRECTORY')  
  !
  select case (cplot%desc%plotmode)
  case (pm_allbands)
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  case (pm_tunedbands)
    call rec_plot_nbands(emir%rec,cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
  case (pm_receiver)
    call rec_get_itune(emir%rec,cplot%box(1)%iband,izoom,error)
    if (error) return
    call rec_plot_sidebands(emir%rec%desc,emir%rec%source,emir%rec%tune(izoom),cplot,cata,drawaxis,error)
    if (error) return
  case (pm_zoom)
    call astro_message(seve%i,rname,'Leaving the zoom mode to show baseband coverage')
    call gr_execl('CLEAR DIRECTORY')
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  end select
  if (.not.(gtexist('<GREG<BOX1'))) then
    call gr_execl('CLEAR DIRECTORY')
    call rec_plot_mbands(emir%rec%desc,emir%rec%source, &
                        cata,emir%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
    if (emir%rec%n_tunings.ne.0) then
      do it=1,emir%rec%n_tunings
        call rec_plot_tuned(emir%rec%desc,emir%rec%source,emir%rec%tune(it), &
                        cata,cplot,drawaxis,error)
        if (error) return
      enddo
    endif
  endif
  !
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%smallchar
  write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
  call gr_exec1(defchar)
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
  write (comm,'(a)') 'CHANGE DIRECTORY'
  call gr_execl(comm)
  if (gtexist('IFPROC')) then
    write (comm,'(a)') 'DESTROY DIRECTORY IFPROC'
    call gr_execl(comm)
  endif
  write (comm,'(a)') 'CREATE DIRECTORY IFPROC'
  call gr_execl(comm)
  do i=1,cplot%nbox
    if (cplot%desc%plotmode.eq.pm_receiver.and.i.eq.2) cycle
    write (comm,'(a,i0)') 'CHANGE DIRECTORY <GREG<BOX',i
    call gr_execl(comm)
    l1 = cplot%box(i)%rest%xmin
    l2 = cplot%box(i)%rest%xmax
    l3 = cplot%box(i)%rest%ymin
    l4 = cplot%box(i)%rest%ymax
    b1 = cplot%box(i)%phys%xmin
    b2 = cplot%box(i)%phys%xmax
    b3 = cplot%box(i)%phys%ymin
    b4 = cplot%box(i)%phys%ymax
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
    write (comm,'(a)') 'CHANGE DIRECTORY IFPROC'
    call gr_execl(comm)
    write (comm,'(a,4(1x,f0.3))') 'SET BOX_LOCATION',b1,b2,b3,b4
    call gr_exec1(comm)
    write (comm,'(a,4(1x,f0.3))') 'LIMITS',l1,l2,l3,l4
    call gr_exec1(comm)
    if (i.eq.1) then
      if (emir%switch%mode.eq.'LIST') then
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +5 3.5 "USER SELECTION" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
      else if (emir%switch%mode.eq.'AUTO'.or.emir%switch%mode.eq.'SINGLE') then
        call gr_pen(colour=apolcol,error=error)
        if (error) return
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +3 3.5 "',trim(emir%setup%polmode),'" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
        call gr_pen(colour=adefcol,error=error)
        if (error) return
        write (comm,'(a,1x,a,1x,a)') 'DRAW TEXT +7 3.5 "POLAR" 5 0 /CHARACTER 7'
        call gr_exec1(comm)
      else
        call astro_message(seve%e,rname,'Problem with switchbox mode')
        error = .true.
        return
      endif
    endif
    do j=1,emir%rec%n_tunings
      if (emir%rec%tune(j)%iband.ne.cplot%box(i)%iband) cycle
      iband=emir%rec%tune(j)%iband
      do k=1,emir%rec%desc%n_sbands
        ! cycle if the current box does not contain the right sideband
        if (cplot%box(i)%sb_code.ne.k.and.cplot%box(i)%sb_code.ne.0) cycle
!        if (emir%setup%sb_code(j).eq.0.or.emir%setup%sb_code(j).eq.sb_code(k)) then
          !available side band --> loop on baseband and polar
          do ib=1,emir%rec%desc%n_bbands
            nobb = .true.
            do ip=1,emir%rec%desc%n_polar
              write (cablecode,'(a,a,a,a)') emir%rec%desc%bandname(iband)(1:2),            &
                  emir%rec%desc%polname(ip)(1:1),sideband(sb_code(k))(1:1),emir%rec%desc%bbname(ib)(1:1)
              do ic=1,emir%switch%n_ifcables
                if (emir%switch%ifc(ic)%label.eq.cablecode) then
                  nobb = .false.
                  !available baseband --> write name
                  fif1 = (emir%rec%desc%bblim(2,ib)+emir%rec%desc%bblim(1,ib))/2d0
                  yt = l3+((l4-l3)/6)*ip
                  call if1torf(emir%rec%tune(j)%flo1,fif1,sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,frest,error)
                  if (error) return
                  call gr_pen(colour=abbifproccol,error=error)
                  if (error) return
                  call gr_exec1(smallchar)
                  write (comm,'(a,1x,f0.6,1x,f0.3,1x,a,a,1x,a)')               &
                    'DRAW TEXT',frest,yt,'"',trim(cablecode),'" 5 0 /USER /CLIP'
                  call gr_exec1(comm)
                  !draw the limit of the baseband
                  call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(1,ib),sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,linebb%xmin,error)
                  if (error) return
                  call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(2,ib),sb_code(k),frf,error)
                  if (error) return
                  call rftorest(emir%rec%source%dopshift,frf,linebb%xmax,error)
                  if (error) return
                  linebb%ymin = cplot%box(i)%rest%ymin+(cplot%box(i)%rest%ymax-cplot%box(i)%rest%ymin)/10
                  linebb%ymax = linebb%ymin
                  linebb%col   = abbifproccol
                  linebb%dash  = 1
                  call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                  if (error) return
                  frest = linebb%xmin
                  linebb%xmin = linebb%xmax
                  linebb%xmax = frest
                  call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                  if (error) return
                  call gr_pen(colour=adefcol,error=error)
                  if (error) return
                  call gr_exec1(defchar)
                endif
              enddo ! cable
            enddo ! polar
            !
            !unavailable base band --> filled in rectangle
            if (nobb) then
              call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(1,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(emir%rec%source%dopshift,frf,sbrect%xmin,error)
              if (error) return
              call if1torf(emir%rec%tune(j)%flo1,emir%rec%desc%bblim(2,ib),sb_code(k),frf,error)
              if (error) return
              call rftorest(emir%rec%source%dopshift,frf,sbrect%xmax,error)
              if (error) return
              sbrect%ymin=cplot%box(i)%rest%ymin
              sbrect%ymax=cplot%box(i)%rest%ymax
              sbrect%col=anotselcol
              call rec_draw_frect(sbrect,cplot%box(i)%rest,error)
              if (error) return
              !
              call rec_draw_fbox(cplot,i,drawaxis,error)
              if (error) return
              !
              if (cplot%box(i)%rest%xmin.le.emir%rec%tune(j)%frest.and.cplot%box(i)%rest%xmax.ge.emir%rec%tune(j)%frest) then
                call rec_draw_linetune(emir%rec%tune(j),cplot%box(i)%rest,error)
                if (error) return
              endif
              !plot again molecules
              call gr_exec1(molchar)
              call rec_draw_molecules(cata,cplot%box(i)%rest,error)
              if (error) return
              call gr_exec1(defchar)
            endif
          enddo !baseband
!        endif
      enddo !sideband
      write (comm,'(a)') 'CHANGE DIRECTORY'
      call gr_execl(comm)
    enddo !tuning
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
  enddo ! boxes
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  call gr_exec1(defchar)
  !
end subroutine pico_switch_plot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_derivative_tool
  use cubetools_parameters
  use cubefield_messaging
  !
  public :: derivative_1d_prog_t,derivative_2d_prog_t
  private
  !
  type derivative_1d_prog_t
     integer(kind=indx_k) :: n = 0      ! Number of pixels along derivative axis
     integer(kind=indx_k) :: i = 0      ! Number of pixels used in derivative computation
     real(kind=coor_k)    :: inc = 0d0  ! Increment value
   contains
     procedure, public :: init => derivative_1d_prog_init
     procedure, public :: list => derivative_1d_prog_list
  end type derivative_1d_prog_t
  !
  type derivative_2d_prog_t
     type(derivative_1d_prog_t) :: x
     type(derivative_1d_prog_t) :: y
   contains
     procedure, public :: init => derivative_2d_prog_init
     procedure, public :: list => derivative_2d_prog_list
  end type derivative_2d_prog_t
  !
contains
  !
  subroutine derivative_1d_prog_init(d,cube,iaxis,error)
    use phys_const
    use cube_types
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(derivative_1d_prog_t), intent(out)   :: d
    type(cube_t),                intent(in)    :: cube
    integer(kind=ndim_k),        intent(in)    :: iaxis
    logical,                     intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='DERIVATIVE>1D>PROG>INIT'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head(iaxis,cube%head,axis,error)
    if (error) return
    d%n = axis%n
    d%i = 1 ! *** JP: should be customizable depending on the angular resolution
    d%inc = (2*d%i)*axis%inc
    d%inc = d%inc*sec_per_rad ! *** JP: should use the current angle unit
  end subroutine derivative_1d_prog_init
  !
  subroutine derivative_1d_prog_list(d,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(derivative_1d_prog_t), intent(in)    :: d
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='DERIVATIVE>1D>PROG>LIST'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    print *,'Axis number of pixels',d%n
    print *,'Derivative increment',d%i,d%inc
  end subroutine derivative_1d_prog_list
  !
  !------------------------------------------------------------------------
  !
  subroutine derivative_2d_prog_init(d,cube,error)
    use cube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(derivative_2d_prog_t), intent(out)   :: d
    type(cube_t),                intent(in)    :: cube
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='DERIVATIVE>2D>PROG>INIT'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call d%x%init(cube,cube%head%set%il,error)
    if (error) return
    call d%y%init(cube,cube%head%set%im,error)
    if (error) return
  end subroutine derivative_2d_prog_init
  !
  subroutine derivative_2d_prog_list(d,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(derivative_2d_prog_t), intent(in)    :: d
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='DERIVATIVE>2D>PROG>LIST'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    print *,''
    print *,'X axis'
    call d%x%list(error)
    if (error) return
    print *,'Y axis'
    call d%y%list(error)
    if (error) return
  end subroutine derivative_2d_prog_list
end module cubefield_derivative_tool
!
module cubefield_hessian
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubefield_messaging
  use cubefield_derivative_tool
  !
  public :: hessian
  private
  !
  type :: hessian_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: df_dx ! Gradient x component
     type(cubeid_arg_t), pointer :: df_dy ! Gradient y component
     type(cube_prod_t),  pointer :: d2f_dx2
     type(cube_prod_t),  pointer :: d2f_dy2
     type(cube_prod_t),  pointer :: d2f_dxdy
     type(cube_prod_t),  pointer :: laplacian
     type(cube_prod_t),  pointer :: determinant
     type(cube_prod_t),  pointer :: eigenval1
     type(cube_prod_t),  pointer :: eigenval2
     type(cube_prod_t),  pointer :: angle
   contains
     procedure, public  :: register => cubefield_hessian_comm_register
     procedure, private :: parse    => cubefield_hessian_comm_parse
     procedure, private :: main     => cubefield_hessian_comm_main
  end type hessian_comm_t
  type(hessian_comm_t) :: hessian  
  !
  type hessian_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubefield_hessian_user_toprog
  end type hessian_user_t
  !
  type hessian_prog_t
     type(cuberegion_prog_t) :: region
     type(derivative_2d_prog_t) :: d
     type(cube_t), pointer :: df_dx
     type(cube_t), pointer :: df_dy
     type(cube_t), pointer :: d2f_dx2
     type(cube_t), pointer :: d2f_dy2
     type(cube_t), pointer :: d2f_dxdy
     type(cube_t), pointer :: laplacian
     type(cube_t), pointer :: determinant
     type(cube_t), pointer :: eigenval1
     type(cube_t), pointer :: eigenval2
     type(cube_t), pointer :: angle
   contains
     procedure, private :: header => cubefield_hessian_prog_header
     procedure, private :: data   => cubefield_hessian_prog_data
     procedure, private :: loop   => cubefield_hessian_prog_loop
     procedure, private :: act    => cubefield_hessian_prog_act
  end type hessian_prog_t
  !
contains
  !
  subroutine cubefield_hessian_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(hessian_user_t) :: user
    character(len=*), parameter :: rname='HESSIAN>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call hessian%parse(line,user,error)
    if (error) return
    call hessian%main(user,error)
    if (error) continue
  end subroutine cubefield_hessian_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_hessian_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='HESSIAN>COMM>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'HESSIAN','[df_dx_id df_dy_id]',&
         'Compute the Hessian from a 2D spatial gradient',&
         'Compute centered finite-difference Hessian products from the X and&
         & Y gradient-component cubes. The command writes D2F_DX2,&
         & D2F_DY2, D2F_DXDY, LAPLACIAN, DETERMINANT, EIGENVAL1,&
         & EIGENVAL2, and ANGLE outputs. Border pixels remain blank because&
         & only interior pixels are evaluated.',&
         cubefield_hessian_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'DF_DX_ID',&
         'Identifier for the X gradient',&
         'Use the X gradient-component cube. If omitted, use the last&
         & matching cube (*gradient,dx*) in the default index (DAG by&
         & default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_gradient,flag_dx],&
         code_read,&
         code_access_imaset,&
         comm%df_dx,&
         error)
    if (error) return
    call incube%register(&
         'DF_DY_ID',&
         'Identifier for the Y gradient',&
         'Use the Y gradient-component cube. If omitted, use the last&
         & matching cube (*gradient,dy*) in the default index (DAG by&
         & default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_gradient,flag_dy],&
         code_read,&
         code_access_imaset,&
         comm%df_dy,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'D2F_DX2',&
         'Cube of hessian d2f_dx2',&
         strg_emp,&
         [flag_hessian,flag_dx2],&
         comm%d2f_dx2,&
         error)
    if (error)  return
    call oucube%register(&
         'D2F_DY2',&
         'Cube of hessian d2f_dy2',&
         strg_emp,&
         [flag_hessian,flag_dy2],&
         comm%d2f_dy2,&
         error)
    if (error)  return
    call oucube%register(&
         'D2F_DXDY',&
         'Cube of hessian d2f_dxdy',&
         strg_emp,&
         [flag_hessian,flag_dxdy],&
         comm%d2f_dxdy,&
         error)
    if (error)  return
    !
    call oucube%register(&
         'LAPLACIAN',&
         'Cube of laplacian (= trace of the hessian)',&
         'This is also equal to div(grad(F)), where F is the initial 2D field',&
         [flag_laplacian],&
         comm%laplacian,&
         error)
    if (error)  return
    call oucube%register(&
         'DETERMINANT',&
         'Cube of hessian determinant',&
         strg_emp,&
         [flag_hessian,flag_determinant],&
         comm%determinant,&
         error)
    if (error)  return
    !
    call oucube%register(&
         'EIGENVAL1',&
         'Cube of first Hessian eigenvalue',&
         strg_emp,&
         [flag_hessian,flag_eigen,flag_value,flag_one],&
         comm%eigenval1,&
         error)
    if (error)  return
    call oucube%register(&
         'EIGENVAL2',&
         'Cube of second Hessian eigenvalue',&
         strg_emp,&
         [flag_hessian,flag_eigen,flag_value,flag_two],&
         comm%eigenval2,&
         error)
    if (error)  return
    call oucube%register(&
         'ANGLE',&
         'Cube of hessian angle',&
         strg_emp,&
         [flag_hessian,flag_angle],&
         comm%angle,&
         error)
    if (error)  return
  end subroutine cubefield_hessian_comm_register
  !
  subroutine cubefield_hessian_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! HESSIAN df_dxid df_dyid
    !----------------------------------------------------------------------
    class(hessian_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    type(hessian_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='HESSIAN>COMM>PARSE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubefield_hessian_comm_parse
  !
  subroutine cubefield_hessian_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_comm_t), intent(in)    :: comm
    type(hessian_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(hessian_prog_t) :: prog
    character(len=*), parameter :: rname='HESSIAN>MAIN'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefield_hessian_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_hessian_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_user_t), intent(in)    :: user
    type(hessian_comm_t),  intent(in)    :: comm
    type(hessian_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='HESSIAN>USER>TOPROG'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%df_dx,user%cubeids,prog%df_dx,error)
    if (error) return
    call user%region%toprog(prog%df_dx,prog%region,error)
    if (error) return
    call cubeadm_get_header(comm%df_dy,user%cubeids,prog%df_dy,error)
    if (error) return
    call user%region%toprog(prog%df_dy,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return
  end subroutine cubefield_hessian_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_hessian_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_prog_t), intent(inout) :: prog
    type(hessian_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='HESSIAN>PROG>HEADER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call prog%d%init(prog%df_dx,error)
    if (error) return
    call prog%d%list(error)
    if (error) return
    !
    call cubeadm_clone_header_with_region(comm%d2f_dx2,  &
      prog%df_dx,prog%region,prog%d2f_dx2,error)
    if (error) return
    call cubeadm_clone_header_with_region(comm%d2f_dy2,  &
      prog%df_dy,prog%region,prog%d2f_dy2,error)
    if (error) return
    call cubeadm_clone_header_with_region(comm%d2f_dxdy,  &
      prog%df_dx,prog%region,prog%d2f_dxdy,error)
    if (error) return
    !
    call cubeadm_clone_header_with_region(comm%laplacian,  &
      prog%df_dx,prog%region,prog%laplacian,error)
    if (error) return
    call cubeadm_clone_header_with_region(comm%determinant,  &
      prog%df_dx,prog%region,prog%determinant,error)
    if (error) return
    !
    call cubeadm_clone_header_with_region(comm%eigenval1,  &
      prog%df_dx,prog%region,prog%eigenval1,error)
    if (error) return
    call cubeadm_clone_header_with_region(comm%eigenval2,  &
      prog%df_dx,prog%region,prog%eigenval2,error)
    if (error) return
    call cubeadm_clone_header_with_region(comm%angle,  &
      prog%df_dx,prog%region,prog%angle,error)
    if (error) return
  end subroutine cubefield_hessian_prog_header
  !
  subroutine cubefield_hessian_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(hessian_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='HESSIAN>PROG>DATA'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefield_hessian_prog_data
  !   
  subroutine cubefield_hessian_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: df_dx,df_dy
    type(image_t) :: d2f_dx2,d2f_dy2,d2f_dxdy
    type(image_t) :: laplacian,determinant
    type(image_t) :: eigenval1,eigenval2,angle
    character(len=*), parameter :: rname='HESSIAN>PROG>LOOP'
    !
    call df_dx%associate('df_dx',prog%df_dx,iter,error)
    if (error) return
    call df_dy%associate('df_dy',prog%df_dy,iter,error)
    if (error) return
    !
    call d2f_dx2%allocate('d2f_dx2',prog%d2f_dx2,iter,error)
    if (error) return
    call d2f_dy2%allocate('d2f_dy2',prog%d2f_dy2,iter,error)
    if (error) return
    call d2f_dxdy%allocate('d2f_dxdy',prog%d2f_dxdy,iter,error)
    if (error) return
    !
    call laplacian%allocate('laplacian',prog%laplacian,iter,error)
    if (error) return
    call determinant%allocate('determinant',prog%determinant,iter,error)
    if (error) return
    !
    call eigenval1%allocate('eigenval1',prog%eigenval1,iter,error)
    if (error) return
    call eigenval2%allocate('eigenval2',prog%eigenval2,iter,error)
    if (error) return
    call angle%allocate('angle',prog%angle,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,df_dx,df_dy,&
            d2f_dx2,d2f_dy2,d2f_dxdy,&
            laplacian,determinant,&
            eigenval1,eigenval2,angle,error)
       if (error) return
    enddo ! ie
  end subroutine cubefield_hessian_prog_loop
  !   
  subroutine cubefield_hessian_prog_act(prog,ie,df_dx,df_dy,&
       d2f_dx2,d2f_dy2,d2f_dxdy,&
       laplacian,determinant,&
       eigenval1,eigenval2,angle,&
       error)
    use phys_const
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(hessian_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t), target, intent(inout) :: df_dx
    type(image_t), target, intent(inout) :: df_dy
    type(image_t),         intent(inout) :: d2f_dx2
    type(image_t),         intent(inout) :: d2f_dy2
    type(image_t),         intent(inout) :: d2f_dxdy
    type(image_t),         intent(inout) :: laplacian
    type(image_t),         intent(inout) :: determinant
    type(image_t),         intent(inout) :: eigenval1
    type(image_t),         intent(inout) :: eigenval2
    type(image_t),         intent(inout) :: angle
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='HESSIAN>PROG>ACT'
    !
    call df_dx%get(ie,error)
    if (error) return
    call df_dy%get(ie,error)
    if (error) return
    call d2f_dx2%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call d2f_dy2%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call d2f_dxdy%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call laplacian%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call determinant%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call eigenval1%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call eigenval2%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    call angle%set_frame(prog%d%x%i,prog%d%y%i,gr4nan,error)
    if (error) return
    do iy=prog%d%y%i+1,prog%d%y%n-prog%d%y%i
       do ix=prog%d%x%i+1,prog%d%x%n-prog%d%x%i
          d2f_dx2%val(ix,iy)  = (df_dx%val(ix+prog%d%x%i,iy)-df_dx%val(ix-prog%d%x%i,iy))/prog%d%x%inc
          d2f_dy2%val(ix,iy)  = (df_dy%val(ix,iy+prog%d%y%i)-df_dy%val(ix,iy-prog%d%y%i))/prog%d%y%inc
          d2f_dxdy%val(ix,iy) = (df_dx%val(ix,iy+prog%d%y%i)-df_dx%val(ix,iy-prog%d%y%i))/prog%d%y%inc
          laplacian%val(ix,iy) = d2f_dx2%val(ix,iy)+d2f_dy2%val(ix,iy)
          determinant%val(ix,iy) = d2f_dx2%val(ix,iy)*d2f_dy2%val(ix,iy)-d2f_dxdy%val(ix,iy)**2
          call eigen_decomposition(&
               d2f_dx2%val(ix,iy),d2f_dy2%val(ix,iy),d2f_dxdy%val(ix,iy),&
               eigenval1%val(ix,iy),eigenval2%val(ix,iy),angle%val(ix,iy),&
               error)
          if (error) return
       enddo ! ix
    enddo ! iy
    call d2f_dx2%put(ie,error)
    if (error) return
    call d2f_dy2%put(ie,error)
    if (error) return
    call d2f_dxdy%put(ie,error)
    if (error) return
    call laplacian%put(ie,error)
    if (error) return
    call determinant%put(ie,error)
    if (error) return
    call eigenval1%put(ie,error)
    if (error) return
    call eigenval2%put(ie,error)
    if (error) return
    call angle%put(ie,error)
    if (error) return
    !
  contains
    !
    subroutine eigen_decomposition(a,b,c,eigenval1,eigenval2,angle,error)
      !--------------------------------------------------------------------
      ! Compute the eigendecomposition of a 2-by-2 symmetric matrix
      !     [  a   b  ]
      !     [  b   c  ].
      !--------------------------------------------------------------------
      real(kind=sign_k), intent(in)    :: a
      real(kind=sign_k), intent(in)    :: b
      real(kind=sign_k), intent(in)    :: c
      real(kind=sign_k), intent(out)   :: eigenval1
      real(kind=sign_k), intent(out)   :: eigenval2
      real(kind=sign_k), intent(out)   :: angle
      logical,           intent(inout) :: error
      !
      real(kind=sign_k) :: cos1,sin1
      !
      call slaev2(a,b,c,eigenval1,eigenval2,cos1,sin1)
      angle = atan2(sin1,cos1)*deg_per_rad
!!$      if (abs(eigenval1).lt.5e-2) then
!!$         print *,cos1,sin1,angle*deg_per_rad
!!$      endif
    end subroutine eigen_decomposition
  end subroutine cubefield_hessian_prog_act
end module cubefield_hessian
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtindex_table
  use gbl_message
  !---------------------------------------------------------------------
  ! This module offers a convenient tool to declare a table, dump header
  ! and write any many lines as desired, dealing with column alignment.
  !---------------------------------------------------------------------

  public :: table_t,line_t
  private

  integer(kind=4), parameter :: mcol=50      ! Up to 50 columns
  integer(kind=4), parameter :: line_l=1024  ! Max line length
  integer(kind=4), parameter :: colu_l=20    ! Max column width
  !
  type :: column_t
    character(len=colu_l) :: name
    character(len=colu_l) :: unit
    integer(kind=4)       :: width
    character(len=10)     :: format
  end type column_t
  !
  ! Buffer for 1 line
  type :: line_t
    integer(kind=4),       private :: icol=0  ! Last column printed in buffer
    character(len=line_l), private :: line=''
    integer(kind=4),       private :: ipos=1  ! Position in line buffer
  contains
    procedure, private :: new_cc    => line_new_cc
    procedure, private :: new_i4    => line_new_i4
    procedure, private :: new_r4    => line_new_r4
    procedure, private :: new_r8    => line_new_r8
    generic,   public  :: new_value => new_cc,new_i4,new_r4,new_r8
    procedure, public  :: list      => line_list
    procedure, public  :: reset     => line_reset
  end type line_t
  !
  type :: table_t
    integer(kind=4), private :: ncol=0
    type(column_t),  private :: col(mcol)
  contains
    procedure, public :: register_column => table_register_column
    procedure, public :: header          => table_header
  end type table_t
  !
contains
  !
  subroutine table_register_column(tab,name,unit,width,format,error)
    !-------------------------------------------------------------------
    ! Register a new column
    !-------------------------------------------------------------------
    class(table_t),   intent(inout) :: tab     !
    character(len=*), intent(in)    :: name    ! e.g. "Angle"
    character(len=*), intent(in)    :: unit    ! e.g. "[deg]"
    integer(kind=4),  intent(in)    :: width   ! e.g. 12 characters
    character(len=*), intent(in)    :: format  ! e.g. "1pg12.4"
    logical,          intent(inout) :: error   !
    ! Local
    character(len=*), parameter :: rname='REGISTER>COLUMN'
    !
    if (tab%ncol.ge.mcol) then
      call mrtindex_message(seve%e,rname,'Maximum number of columns exhausted')
      error = .true.
      return
    endif
    tab%ncol = tab%ncol+1
    tab%col(tab%ncol)%name = name
    tab%col(tab%ncol)%unit = unit
    tab%col(tab%ncol)%width = width
    tab%col(tab%ncol)%format = format
  end subroutine table_register_column
  !
  subroutine table_header(tab,olun,error)
    !-------------------------------------------------------------------
    ! Display the header, i.e. several comment lines with:
    !   - column numbers
    !   - column names
    !   - column units
    !-------------------------------------------------------------------
    class(table_t),  intent(in)    :: tab
    integer(kind=4), intent(in)    :: olun
    logical,         intent(inout) :: error
    !
    character(len=line_l) :: line1,line2,line3
    character(len=colu_l) :: tmp
    integer(kind=4) :: ipos,icol,wid
    logical :: first
    !
    line1 = '!'
    line2 = '!'
    line3 = '!'
    first  = .true.
    ipos = 2
    do icol=1,tab%ncol
      wid = tab%col(icol)%width
      ! Numbering
      write(tmp,'(i0)')  icol
      line1(ipos:ipos+wid-1) = recenter(tmp,wid)
      ! Name
      line2(ipos:ipos+wid-1) = recenter(tab%col(icol)%name,wid)
      ! Name
      line3(ipos:ipos+wid-1) = recenter(tab%col(icol)%unit,wid)
      if (first) then
        ipos = ipos+wid  ! Because we shifted the alignment by 1 because of the leading '!'
        first = .false.
      else
        ipos = ipos+wid+1
      endif
    enddo
    !
    line1(1:1) = '!'
    line2(1:1) = '!'
    line3(1:1) = '!'
    !
    write(olun,'(a)')  line1(1:ipos)
    write(olun,'(a)')  line2(1:ipos)
    write(olun,'(a)')  line3(1:ipos)
  end subroutine table_header
  !
  function recenter(string,width)
    !-------------------------------------------------------------------
    ! Return a string so that the input string is centered among 'width'
    ! characters.
    !-------------------------------------------------------------------
    character(len=colu_l) :: recenter  ! Function value on return
    character(len=*), intent(in) :: string
    integer(kind=4),  intent(in) :: width
    !
    integer(kind=4) :: nc,fc
    !
    nc = len_trim(string)
    if (nc.ge.width) then
      recenter = string(1:nc)
      return
    endif
    !
    fc = (width-nc)/2+1
    recenter(1:fc-1) = ' '
    recenter(fc:) = string(1:nc)
  end function recenter
  !
  subroutine line_new_cc(line,tab,cc,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t),    intent(inout) :: line
    type(table_t),    intent(in)    :: tab
    character(len=*), intent(in)    :: cc
    logical,          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>CC'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) cc
    line%ipos = line%ipos+wid+1
  end subroutine line_new_cc
  !
  subroutine line_new_i4(line,tab,i4,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t),   intent(inout) :: line
    type(table_t),   intent(in)    :: tab
    integer(kind=4), intent(in)    :: i4
    logical,         intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>I4'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) i4
    line%ipos = line%ipos+wid+1
  end subroutine line_new_i4
  !
  subroutine line_new_r4(line,tab,r4,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t), intent(inout) :: line
    type(table_t), intent(in)    :: tab
    real(kind=4),  intent(in)    :: r4
    logical,       intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>R4'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) r4
    line%ipos = line%ipos+wid+1
  end subroutine line_new_r4
  !
  subroutine line_new_r8(line,tab,r8,error)
    !-------------------------------------------------------------------
    ! Print a new value in the line buffer
    !-------------------------------------------------------------------
    class(line_t), intent(inout) :: line
    type(table_t), intent(in)    :: tab
    real(kind=8),  intent(in)    :: r8
    logical,       intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LINE>NEW>R8'
    integer(kind=4) :: wid
    !
    if (line%icol.ge.tab%ncol) then
      call mrtindex_message(seve%e,rname,'Maximum number of values exhausted')
      error = .true.
      return
    endif
    !
    line%icol = line%icol+1
    wid = tab%col(line%icol)%width
    write(line%line(line%ipos:line%ipos+wid-1),tab%col(line%icol)%format) r8
    line%ipos = line%ipos+wid+1
  end subroutine line_new_r8
  !
  subroutine line_list(line,olun,error)
    !-------------------------------------------------------------------
    ! Dump the current line buffer
    !-------------------------------------------------------------------
    class(line_t),   intent(inout) :: line
    integer(kind=4), intent(in)    :: olun
    logical,         intent(inout) :: error
    !
    write(olun,'(a)') line%line(1:line%ipos)
    line%icol = 0
    line%line = ''
    line%ipos = 1
  end subroutine line_list
  !
  subroutine line_reset(line,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(line_t),   intent(out)   :: line
    logical,         intent(inout) :: error
    ! Done with intent(out)
  end subroutine line_reset
end module mrtindex_table

module noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! Ad-hoc types and methods which allows to define some models
  !---------------------------------------------------------------------
  !
  public :: model_parabol,model_gaussian,model_parabol_gaussian
  public :: parabol_t,gaussian_t,model_t
  private
  !
  integer(kind=4), parameter :: model_parabol=1
  integer(kind=4), parameter :: model_gaussian=2
  integer(kind=4), parameter :: model_parabol_gaussian=3  ! Both combined
  !
  type :: parabol_t
    ! f(x) = offset+slope*x+factor*x**2
    real(kind=4), public :: offset=0.  ! [K]
    real(kind=4), public :: slope=0.   ! [K/GHz]
    real(kind=4), public :: factor=0.  ! [K/GHz**2]
  contains
    procedure, private :: compute => parabol_compute
  end type parabol_t
  !
  type :: gaussian_t
    ! f(x) = amp*exp(-(x-pos)**2/(2*wid**2))
    real(kind=4), public :: amp=0.  ! [K]
    real(kind=4), public :: pos=0.  ! [GHz]
    real(kind=4), public :: wid=0.  ! [GHz]
  contains
    procedure, private :: compute => gauss_compute
  end type gaussian_t
  !
  type :: model_t
    integer(kind=4),  public :: itype    ! 1=parabol, 2=gaussian
    type(parabol_t),  public :: parabol  ! Used if parabolic
    type(gaussian_t), public :: gauss    ! Used if gaussian
  contains
    procedure, public :: add     => model_add
    procedure, public :: compute => model_compute
  end type model_t
  !
contains
  !
  function parabol_compute(parabol,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: parabol_compute
    class(parabol_t), intent(in) :: parabol
    real(kind=4),     intent(in) :: x
    parabol_compute = parabol%offset + parabol%slope*x  &
                    + parabol%factor*x**2
  end function parabol_compute
  !
  function gauss_compute(gauss,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: gauss_compute
    class(gaussian_t), intent(in) :: gauss
    real(kind=4),      intent(in) :: x
    gauss_compute = gauss%amp * exp( -(x-gauss%pos)**2/(2*gauss%wid**2) )
  end function gauss_compute
  !
  subroutine model_add(model1,model2,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Add model2 into model1
    !-------------------------------------------------------------------
    class(model_t), intent(inout) :: model1
    type(model_t),  intent(in)    :: model2
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='TSYS>MODEL>ADD'
    logical :: done
    !
    done = .false.
    if (model1%itype.eq.model_parabol) then
      if (model2%itype.eq.model_parabol) then
        model1%parabol%offset = model1%parabol%offset  &
                              + model2%parabol%offset
        model1%parabol%slope  = model1%parabol%slope  &
                              + model2%parabol%slope
        model1%parabol%factor = model1%parabol%factor  &
                              + model2%parabol%factor
        done = .true.
      elseif (model2%itype.eq.model_gaussian) then
        model1%itype = model_parabol_gaussian
        model1%gauss = model2%gauss
        done = .true.
      endif
    endif
    !
    if (.not.done) then
      call astro_message(seve%e,rname,'Model combination not implemented')
      error = .true.
      return
    endif
  end subroutine model_add
  !
  function model_compute(model,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: model_compute
    class(model_t), intent(in) :: model
    real(kind=4),   intent(in) :: x
    select case (model%itype)
    case (model_parabol)
      model_compute = model%parabol%compute(x)
    case (model_gaussian)
      model_compute = model%gauss%compute(x)
    case (model_parabol_gaussian)
      model_compute = model%parabol%compute(x) + model%gauss%compute(x)
    case default
      model_compute = 0.
    end select
  end function model_compute
end module noema_tsys_interpolation

module noema_tsys_parameters
  use noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! Parameters (and variables deduced from these) which are shared by
  ! the 2 tables produced by the command NOEMA\TSYS
  !---------------------------------------------------------------------
  !
  ! Data format
  integer(kind=4), parameter :: tsysversion=1
  integer(kind=4), parameter :: contversion=2
  !
  ! Physical parameters
  real(kind=4),    parameter :: h0=2.560    ! [km]  NOEMA altitude
  real(kind=4),    parameter :: p0=1013.0   ! [HPa] At sea level
  real(kind=4)               :: p1          ! [HPa] At site altitude
  integer(kind=4), parameter :: nt=2        ! Number of atmosphere temperatures
  real(kind=4),    parameter :: t(nt) = (/ 273.,283. /)  ! [K]
  !
  ! Hardware
  real(kind=4),    parameter :: gim=0.05    ! [   ] Image gain ratio
  integer(kind=4), parameter :: nb=3        !       Number of bands
  !
  type(parabol_t),  parameter :: nullparabol = parabol_t(0.,0.,0.)
  type(gaussian_t), parameter :: nullgauss = gaussian_t(0.,0.,0.)
  ! Trec values: for each band, provide parabola coefficients.
  type(parabol_t), parameter :: trec_band1 = parabol_t(37.1,0.,0.)  ! Flat C.Fischer 26-jun-2026
  type(parabol_t), parameter :: trec_band2 = parabol_t(45.0,0.,0.)  ! Flat
  type(parabol_t), parameter :: trec_band3 = parabol_t(55.0,0.,0.)  ! Flat
  type(model_t), parameter :: trec_receiver(nb) = [   &
      model_t(model_parabol,trec_band1,nullgauss),  &
      model_t(model_parabol,trec_band2,nullgauss),  &
      model_t(model_parabol,trec_band3,nullgauss) ]
  ! Dichroic contribution if DBR mode:
  type(parabol_t),  parameter :: tdic_band1 = parabol_t(291.9,-5.45,0.0267)  ! C.Fischer 26-jun-2026
  type(parabol_t),  parameter :: tdic_band2 = parabol_t(0.,0.,0.)
  type(gaussian_t), parameter :: tdic_band3 = gaussian_t(13.798,241.938,2.824)
  type(model_t),    parameter :: trec_dichroic(nb) = [  &
      model_t(model_parabol, tdic_band1, nullgauss),  &
      model_t(model_parabol, tdic_band2, nullgauss),  &
      model_t(model_gaussian,nullparabol,tdic_band3) ]
  !
  real(kind=4),    parameter :: trec_blank=1e4  ! [K] Very bad Trec (but valid in computations)
  ! Feff values: for each band, provide parabola coefficients.
  type(parabol_t), parameter :: feff_band1 = parabol_t(0.96,0.,0.)  ! Flat
  type(parabol_t), parameter :: feff_band2 = parabol_t(0.94,0.,0.)  ! Flat
  type(parabol_t), parameter :: feff_band3 = parabol_t(1.0487,-5.778e-4,0.)  ! Linear C.Fischer 30-jun-2026
  type(model_t),   save      :: feff(nb) = [  &
      model_t(model_parabol,feff_band1,nullgauss),  &
      model_t(model_parabol,feff_band2,nullgauss),  &
      model_t(model_parabol,feff_band3,nullgauss) ]
  real(kind=4),    parameter :: feff_blank=1e-4 ! [ ] Very bad Feff (but valid in computations)
  !
  ! Frequencies. The ranges are defined at run time thanks to
  ! the subroutine 'rec_define_noema'
  real(kind=4)                 :: rf_step      ! [GHz]
  real(kind=4)                 :: rf_min(nb)   ! [GHz]
  real(kind=4)                 :: rf_max(nb)   ! [GHz]
  integer(kind=4)              :: nrf          !
  real(kind=4),    allocatable :: rf(:)        ! [GHz]
  real(kind=4)                 :: lof_step     ! [GHz]
  real(kind=4)                 :: lof_min(nb)  ! [GHz]
  real(kind=4)                 :: lof_max(nb)  ! [GHz]
  integer(kind=4)              :: nlof         !
  real(kind=4),    allocatable :: lof(:)       ! [GHz]
  !
  ! Airmass
  real(kind=4),    parameter   :: a_step=0.5  ! [Neper]
  real(kind=4),    parameter   :: a_min=1.    ! [Neper] Elevation 90 deg
  real(kind=4),    parameter   :: a_max=6.    ! [Neper] Elevation ~9.5 deg
  integer(kind=4)              :: na          !
  real(kind=4),    allocatable :: a(:)        !
  !
  ! PWV
  real(kind=4),    parameter   :: w_step=0.5  ! [mm]
  real(kind=4),    parameter   :: w_min=2.    ! [mm]
  real(kind=4),    parameter   :: w_max=7.    ! [mm]
  integer(kind=4)              :: nw          !
  real(kind=4),    allocatable :: w(:)        !
  !
end module noema_tsys_parameters
!
subroutine noema_tsys(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_tsys
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   NOEMA\TSYS TableName [/CONTINUUM] [/DBR]
  ! Compute the Tsys  binary table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: optcont=1
  integer(kind=4), parameter :: optdbr=2
  character(len=filename_length) :: tsysfile
  integer(kind=4) :: nc
  logical :: docont,dodbr
  !
  call sic_ch(line,0,1,tsysfile,nc,.true.,error)
  if (error)  return
  !
  if (gag_inquire(tsysfile,nc).eq.0) then
    call astro_message(seve%e,rname,  &
      'File '//tsysfile(1:nc)//' already exists. Remove it first.')
    error = .true.
    if (error)  return
  endif
  !
  docont = sic_present(optcont,0)
  dodbr = sic_present(optdbr,0)
  !
  if (docont) then
    call noema_tsys_continuum(tsysfile,dodbr,error)
    if (error)  continue
  else
    call noema_tsys_table(tsysfile,dodbr,error)
    if (error)  continue
  endif
  !
  call noema_tsys_clean()
  !
end subroutine noema_tsys
!
subroutine noema_tsys_setup(rfstep,lofstep,dbr,trec,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces
  use astro_types
  use ast_line
  use noema_tsys_parameters
  use noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Set up the parameters
  !---------------------------------------------------------------------
  real(kind=4),  intent(in)    :: rfstep   !
  real(kind=4),  intent(in)    :: lofstep  !
  logical,       intent(in)    :: dbr      ! DBR mode active?
  type(model_t), intent(out)   :: trec(nb) !
  logical,       intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='TSYS'
  type(receiver_desc_t) :: rdesc
  integer(kind=4) :: ib,ia,iw,irf,ilof,ier
  !
  p1 = p0*2.0**(-h0/5.5)  ! [HPa] Pressure at altitude h0
  !
  ! Get receiver parameters
  call rec_define_noema(rdesc,noema_mode,error)
  if (error)  return
  !
  if (rdesc%n_rbands.ne.nb) then
    ! If error, adapt Trec and Feff arrays
    call astro_message(seve%e,rname,'Number of bands not supported')
    error = .true.
    return
  endif
  !
  ! Frequency ranges
  do ib=1,rdesc%n_rbands
    ! Compute our frequency range. Be conservative (floor/ceiling) + align
    ! to the nearest GHz (purely cosmetic) + 1 more GHz at boundary because
    ! in some cases (e.g. Doppler effect) one has to explore slightly beyond
    ! the usual limits.
    lof_min(ib) = floor(rdesc%lohard(1,ib)/1000.)-1
    lof_max(ib) = ceiling(rdesc%lohard(2,ib)/1000.)+1
    rf_min(ib) = floor(rdesc%rflim(1,ib)/1000.)-1
    rf_max(ib) = ceiling(rdesc%rflim(2,ib)/1000.)+1
  enddo
  !
  rf_step = rfstep
  lof_step = lofstep
  !
  ! Number of RF/IF frequencies
  nrf = (rf_max(rdesc%n_rbands)-rf_min(1))/rf_step+1  ! Assume that bands are ordered increasingly
  ! Number of LO frequencies: the whole range is sampled with no gap between
  ! bands. Beware this feature is used by PMS.
  nlof = (lof_max(rdesc%n_rbands)-lof_min(1))/lof_step+1  ! Assume that bands are ordered increasingly
  ! Number of airmasses: easy
  na = (a_max-a_min)/a_step+1
  ! Number of pwv: easy
  nw = (w_max-w_min)/w_step+1
  !
  ! Define the vectors
  allocate(rf(nrf),lof(nlof),a(na),w(nw),stat=ier)
  if (failed_allocate(rname,'dimension buffers',ier,error))  return
  ! RF frequencies
  do irf=1,nrf
    rf(irf) = rf_min(1)+(irf-1)*rf_step
  enddo
  ! LO frequencies
  do ilof=1,nlof
    lof(ilof) = lof_min(1)+(ilof-1)*lof_step
  enddo
  ! Airmasses
  do ia=1,na
    a(ia) = a_min+(ia-1)*a_step
  enddo
  ! PWV
  do iw=1,nw
    w(iw) = w_min+(iw-1)*w_step
  enddo
  !
  ! Trec: prepare parabola coefficients for each band
  do ib=1,nb
    ! Receiver temperature: always
    trec(ib) = trec_receiver(ib)
    ! Dichroic temperature: if dbr mode
    if (dbr) then
      call trec(ib)%add(trec_dichroic(ib),error)
      if (error)  return
    endif
  enddo
  !
end subroutine noema_tsys_setup
!
subroutine noema_tsys_clean()
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate the global buffers. There is no need to keep them
  ! allocated after the command has ended
  !---------------------------------------------------------------------
  !
  if (allocated(rf))   deallocate(rf)
  if (allocated(lof))  deallocate(lof)
  if (allocated(a))    deallocate(a)
  if (allocated(w))    deallocate(w)
  !
end subroutine noema_tsys_clean
!
subroutine noema_tsys_table(file,dbr,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_table
  use astro_types
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(in)    :: dbr
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: if,ia,iw,it,ier,ib
  real(kind=4) :: temis,temii,tatm,tauox,tauw,dummy,taut
  integer(kind=4), allocatable :: band(:)  ! Band number for each RF
  type(model_t) :: trec(nb)
  real(kind=4), allocatable :: vtrec(:),vfeff(:)
  real(kind=4), allocatable :: tsys(:,:,:,:)
  type(time_t) :: time
  !
  ! Parameters
  real(kind=4), parameter :: intfreq=0.  ! [GHz] Intermediate frequency
  ! IF (used to compute the image frequency) is set to 0 because:
  ! 1) typical values show a Tsys difference near 0% at the center of
  !    the bands (where Tsys is flat), and less than 2% at the band
  !    sides (where Tsys varies faster in one sideband than in the
  !    other). => NB: probably not true anymore now that gim is 0.05
  ! 2) it is quite difficult/impossible to produce a generic Tsys table
  !    which would know in advance what is the image frequency distance
  !    and side (lower or upper). In other words we can not know what is
  !    the image frequency associated to a given signal frequency.
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every GHz (this produces a table of reasonable size). LO
  ! sampling is actually unused here.
  call noema_tsys_setup(1.,1.,dbr,trec,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff:
  allocate(band(nrf),vtrec(nrf),vfeff(nrf),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  ! Band number for each RF freq (side product, not in data)
  band(:) = 0
  do ib=1,nb
    where (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib))
      band = ib
    end where
  enddo
  vtrec(:) = trec_blank
  vfeff(:) = feff_blank
  do if=1,nrf
    if (band(if).eq.0)  cycle
    vtrec(if) = trec(band(if))%compute(rf(if))
    vfeff(if) = feff(band(if))%compute(rf(if))
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys table with')
  write (mess,10)  nrf,' frequencies  from ',rf(1),' to ',rf(nrf),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,' airmasses    from ',a(1),' to ',a(na),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nw,' pwv          from ',w(1),' to ',w(nw),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,' temperatures from ',t(1),' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(tsys(nrf,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na*nrf,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        do if=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(if),temis,tatm,tauox,tauw,taut,ier)
          ! Image
          if (intfreq.eq.0.) then
            temii = temis
          else
            call atm_transm(w(iw),a(ia),rf(if)+2.*intfreq,temii,tatm,tauox,tauw,dummy,ier)
          endif
          ! Store Tsys at current airmass
          tsys(if,ia,iw,it) = ( gim * (vfeff(if)*temii+(1.0-vfeff(if))*t(it) + vtrec(if)) +  &
                                      (vfeff(if)*temis+(1.0-vfeff(if))*t(it) + vtrec(if))    &
                              ) / vfeff(if) * exp(taut*a(ia))
          !
          call gtime_current(time)
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(tsysversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call r4tor4(intfreq,buffer(5),1)
    call i4toi4(nrf,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    call noema_tsys_write_binarray(lun,rf,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,nrf*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_table
!
subroutine noema_tsys_continuum(file,dbr,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_continuum
  use astro_types
  use ast_line
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(in)    :: dbr
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: irf,ilof,ia,iw,it,ier,ib
  real(kind=4) :: tatm,tauox,tauw
  integer(kind=4), allocatable :: band(:)  ! Band number for each LOF
  type(model_t) :: trec(nb)
  real(kind=4), allocatable :: vtrec(:),vfeff(:),temi(:),taut(:)
  real(kind=4), allocatable :: tsys(:,:,:,:,:)
  type(time_t) :: time
  type(receiver_desc_t) :: rdesc
  !
  ! Elements
  integer(kind=4), parameter :: ne=3  ! Number of elements stored (Tsys_aver, Tsys_min, Tsys_max)
  integer(kind=4), parameter :: imin=1   ! Index for Tsys_min
  integer(kind=4), parameter :: iaver=2  ! Index for Tsys_aver
  integer(kind=4), parameter :: imax=3   ! Index for Tsys_max
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every 0.1 GHz (this gives good estimation of the average Tsys
  ! over the side band (and this parameter does not influence the table
  ! size). The LO frequency is sampled every GHz (this produces a table
  ! of reasonable size).
  call noema_tsys_setup(0.1,1.0,dbr,trec,error)
  if (error)  return
  !
  ! Get receiver parameters
  call rec_define_noema(rdesc,noema_mode,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff. There are just defined for bookkeeping in the
  ! output table.
  allocate(band(nlof),vtrec(nlof),vfeff(nlof),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  ! Band number for each RF freq (side product, not in data)
  band(:) = 0
  do ib=1,nb
    where (lof.ge.rf_min(ib) .and. lof.le.rf_max(ib))
      band = ib
    end where
  enddo
  vtrec(:) = trec_blank
  vfeff(:) = feff_blank
  do ilof=1,nlof
    if (band(ilof).eq.0)  cycle
    vtrec(ilof) = trec(band(ilof))%compute(lof(ilof))
    vfeff(ilof) = feff(band(ilof))%compute(lof(ilof))
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys continuum table with')
  write (mess,10)  ne,  ' elements                              x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nlof,' LO frequencies  from ',lof(1),' to ',lof(nlof),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,  ' airmasses       from ',a(1),  ' to ',a(na),    ' x '
  call astro_message(seve%i,rname,mess) 
  write (mess,10)  nw,  ' pwv             from ',w(1),  ' to ',w(nw),    ' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,  ' temperatures    from ',t(1),  ' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(temi(nrf),taut(nrf),tsys(ne,nlof,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        ! Compute Temi and Tau for each frequency. They will be used to compute
        ! the Tsys in the 2 sidebands. The sampling is done at 'if_step'
        do irf=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(irf),temi(irf),tatm,tauox,tauw,taut(irf),ier)
        enddo
        do ilof=1,nlof
          call tsys_at_lof(t(it),a(ia),lof(ilof),  &
                           tsys(iaver,ilof,ia,iw,it),   &
                           tsys(imin, ilof,ia,iw,it),   &
                           tsys(imax, ilof,ia,iw,it))
          !
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
        call gtime_current(time)
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine tsys_at_lof(temp,air,lof,tsys_aver,tsys_min,tsys_max)
    !-------------------------------------------------------------------
    ! Compute the average, minimum, and maximum Tsys for the input Flo
    !-------------------------------------------------------------------
    real(kind=4), intent(in)  :: temp
    real(kind=4), intent(in)  :: air
    real(kind=4), intent(in)  :: lof
    real(kind=4), intent(out) :: tsys_aver
    real(kind=4), intent(out) :: tsys_min
    real(kind=4), intent(out) :: tsys_max
    ! Local
    integer(kind=4) :: isb,isig,iima,ntsys
    integer(kind=size_length) :: ilof
    real(kind=4) :: fmin,fmax,foreff,temrec,tsys,tsys_sum,if_min,if_max
    ! Parameters
    integer(kind=4), parameter :: nsb=2  ! LSB+USB
    !
    ! Position of lof in the RF array
    call gr4_dicho(int(nrf,kind=size_length),rf,lof,ilof)
    if (rf(ilof).ne.lof) then
      ! It is better to have it aligned so that the signal and
      ! image frequencies are exact mirrors w/t the LO freq
      call astro_message(seve%w,rname,'LOF not on RF grid')
    endif
    !
    if_min = rdesc%iflim(1)/1e3  ! [GHz] IF range
    if_max = rdesc%iflim(2)/1e3  ! [GHz] IF range
    ntsys = 0
    tsys_sum = 0.
    tsys_min = 1e10
    tsys_max = 0.
    do isb=1,nsb
      if (isb.eq.1) then
        fmin = lof - if_max
        fmax = lof - if_min
      else
        fmin = lof + if_min
        fmax = lof + if_max
      endif
      do irf=1,nrf
        if (rf(irf).lt.fmin .or. rf(irf).gt.fmax)  cycle
        !
        ! Position of signal and image frequencies in RF array
        isig = irf
        iima = ilof + (ilof-isig)
        !
        ! Feff and Trec at signal frequency
        foreff = foeff(rf(isig))
        temrec = terec(rf(isig))
        !
        ntsys = ntsys+1
        tsys = ( gim * (foreff*temi(iima)+(1.0-foreff)*temp + temrec) +  &
                       (foreff*temi(isig)+(1.0-foreff)*temp + temrec)    &
               ) / foreff * exp(taut(isig)*air)
        ! tsys_sum = tsys_sum + tsys**2
        tsys_sum = tsys_sum + 1./tsys**2
        if (tsys.lt.tsys_min)  tsys_min = tsys
        if (tsys.gt.tsys_max)  tsys_max = tsys
      enddo
    enddo
    !
    ! Post-processing
    if (ntsys.eq.0) then
      tsys_aver = 0.
    elseif (gag_isreal(tsys_sum).eq.0) then
      ! tsys_aver = sqrt(tsys_sum/ntsys)
      tsys_aver = 1./sqrt(tsys_sum/ntsys)
    else
      tsys_aver = 1e10  ! Avoid +Inf in table
    endif
    if (gag_isreal(tsys_max).eq.1)  tsys_max = 1e10  ! Trap +Inf too
    !
  end subroutine tsys_at_lof
  !
  function foeff(rf)
    real(kind=4) :: foeff
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        foeff = feff(ib)%compute(rf)
        return
      endif
    enddo
    foeff = feff_blank
  end function foeff
  !
  function terec(rf)
    real(kind=4) :: terec
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        terec = trec(ib)%compute(rf)
        return
      endif
    enddo
    terec = trec_blank
  end function terec
  !
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    ! Specific to the continuum table
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(contversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call i4toi4(ne,buffer(5),1)
    call i4toi4(nlof,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    ! NB: There is no description of the 'elements' which are stored.
    call noema_tsys_write_binarray(lun,lof,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,ne*nlof*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_continuum
!
subroutine noema_tsys_write_binarray(lun,array,n,buffer,currec,recpos,error)
  use gbl_message
  use astro_interfaces, except_this=>noema_tsys_write_binarray
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun
  integer(kind=4), intent(in)    :: n
  real(kind=4),    intent(in)    :: array(n)
  integer(kind=4), intent(inout) :: buffer(:)
  integer(kind=4), intent(inout) :: currec
  integer(kind=4), intent(inout) :: recpos
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: reclen=128
  character(len=message_length) :: mess
  integer(kind=4) :: nwritetot,nwritecur,ier
  !
  nwritetot = 0
  do while (nwritetot.lt.n)
    !
    nwritecur = min(n-nwritetot,reclen-recpos+1)
    call r4tor4(array(nwritetot+1),buffer(recpos),nwritecur)
    nwritetot = nwritetot+nwritecur
    recpos = recpos+nwritecur
    !
    if (recpos.gt.reclen) then
      ! print *,"Writing record ",currec
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      currec = currec+1
      recpos = 1
    endif
    !
  enddo
end subroutine noema_tsys_write_binarray

function conxch (x,y,i1,i2,i3,i4)
  use gcont_interfaces, except_this=>conxch
  !---------------------------------------------------------------------
  ! @ private
  ! 	This function determines whether or not the exchange of two
  ! 	triangles is necessary on the basis of max-min-angle criterion
  ! 	by C. L. LAWSON.
  !
  ! Arguments :
  !     	X	R*4 (*)	arrays containing the X coordinates
  !			of the data points			Input
  !	Y	R*4 (*) Array of Y coordinates			Input
  !     	I1	I	Point numbers of point P1		Input
  !     	I2	I	Point numbers of point P2		Input
  !     	I3	I	Point numbers of point P3		Input
  !     	I4	I	Point numbers of point P4		Input
  !			The four points P1, P2, P3, and P4
  !			form a quadrilateral with P3 and P4
  !			connected diagonally.
  ! This function returns a value 1 (one) when an exchange is
  !	needed, and 0 (zero) otherwise.
  !---------------------------------------------------------------------
  integer :: conxch                 !
  real :: x(*)                      !
  real :: y(*)                      !
  integer :: i1                     !
  integer :: i2                     !
  integer :: i3                     !
  integer :: i4                     !
  ! Local
  real :: x0(4), y0(4)
  real :: a1sq, a2sq, a3sq, a4sq
  real :: b1sq, b2sq, b3sq, b4sq
  real :: c1sq, c2sq, c3sq, c4sq
  real :: s1sq, s2sq, s3sq, s4sq
  real :: u1, u2, u3, u4
  integer :: idx
  equivalence (c2sq,c1sq),(a3sq,b2sq),(b3sq,a1sq),  &
              (a4sq,b1sq),(b4sq,a2sq),(c4sq,c3sq)
  !
  ! Calculation
  !
  x0(1) = x(i1)
  y0(1) = y(i1)
  x0(2) = x(i2)
  y0(2) = y(i2)
  x0(3) = x(i3)
  y0(3) = y(i3)
  x0(4) = x(i4)
  y0(4) = y(i4)
  idx = 0
  u3 = (y0(2)-y0(3))*(x0(1)-x0(3))-(x0(2)-x0(3))*(y0(1)-y0(3))
  u4 = (y0(1)-y0(4))*(x0(2)-x0(4))-(x0(1)-x0(4))*(y0(2)-y0(4))
  if (u3*u4 .le. 0.0) go to  100
  u1 = (y0(3)-y0(1))*(x0(4)-x0(1))-(x0(3)-x0(1))*(y0(4)-y0(1))
  u2 = (y0(4)-y0(2))*(x0(3)-x0(2))-(x0(4)-x0(2))*(y0(3)-y0(2))
  a1sq = (x0(1)-x0(3))**2+(y0(1)-y0(3))**2
  b1sq = (x0(4)-x0(1))**2+(y0(4)-y0(1))**2
  c1sq = (x0(3)-x0(4))**2+(y0(3)-y0(4))**2
  a2sq = (x0(2)-x0(4))**2+(y0(2)-y0(4))**2
  b2sq = (x0(3)-x0(2))**2+(y0(3)-y0(2))**2
  c3sq = (x0(2)-x0(1))**2+(y0(2)-y0(1))**2
  s1sq = u1*u1/(c1sq*amax1(a1sq,b1sq))
  s2sq = u2*u2/(c2sq*amax1(a2sq,b2sq))
  s3sq = u3*u3/(c3sq*amax1(a3sq,b3sq))
  s4sq = u4*u4/(c4sq*amax1(a4sq,b4sq))
  if (amin1(s1sq,s2sq) .lt. amin1(s3sq,s4sq)) idx = 1
100 conxch = idx
end function conxch

subroutine gr_segm(name,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_segm
  use greg_pen
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*)                :: name   !
  logical,          intent(inout) :: error  !
  !
  call gtsegm(name,error)
  if (penupd) call setpen(cpen)
  gxp = -1e10
  gyp = -1e10
end subroutine gr_segm
!
function gr_spen(new)
  use greg_interfaces, except_this=>gr_spen
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  !  Set the new pen to be used, and return the previous pen number.
  !---------------------------------------------------------------------
  integer(kind=4) :: gr_spen  ! Function value on return
  integer(kind=4), intent(in) :: new  ! New pen to be used
  ! Local
  integer(kind=4) :: old
  !
  call inqpen(old)
  if (new.ge.0 .and. new.ne.old) then
    cpen = new
    penupd = .true.
  endif
  gr_spen = old
end function gr_spen
!
subroutine gr_out
  use greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  call gtview('Append')
end subroutine gr_out
!
subroutine gr_segm_close(error)
  use greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  ! GreG overlay to GTV closing routine, for symetry with 'gr_segm'.
  ! Close the segment currently opened, and draw it implicitely.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call gtsegm_close(error)
  !
end subroutine gr_segm_close

	subroutine getpar (imafile,rms,beamfwhm,velres,fbeam,fvel,
     &               fitflag,s0,thresh,p0,ap,ap1,itmaxcl,itmaxfit,
     &               eps,flambda,blanking,tol,savres,savfit,minsum)
	character*30 imafile
	character*1 yn1,yn2,yn3,yn4,yn5
	logical savres
	logical savfit
	real*4  minsum
	integer fitflag(11)
	dimension s0(3)

	open (unit=1,file='clumps_input',status='old')
	read (1,1000,err=999,end=999) 
1000	format (1x)
1001	format (1x,a)
	read (1,*,err=999,end=999) imafile
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) rms,blanking,tol
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) beamfwhm,fbeam,velres,fvel
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) s0(1),thresh,itmaxcl,minsum
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) s0(2),s0(3)
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) p0,ap,ap1
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) yn1,yn2,yn3
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) itmaxfit,eps,flambda
 	read (1,1000,err=999,end=999)
	read (1,*,err=999,end=999) yn4,yn5
 
	ap=ap*ap
	ap1=ap1*ap1

	do i=1,11
	fitflag(i)=1
	enddo

	if (yn1.eq.'N'.or.yn1.eq.'n') then
		fitflag(5)=0
		fitflag(6)=0
	endif
	if (yn2.eq.'N'.or.yn2.eq.'n') then
		fitflag(8)=0
		fitflag(9)=0
		fitflag(10)=0
	endif
	if (yn3.eq.'N'.or.yn3.eq.'n') then
		fitflag(7)=0
	endif
	if (yn4.eq.'N'.or.yn4.eq.'n') savres=.false.
	if (yn5.eq.'N'.or.yn5.eq.'n') savfit=.false.

	open (unit=2,file='clumps_output',status='new')
	open (unit=3,file='clumps_list',status='new')
	write (3,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
	write (2,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
	write (6,1020) rms,beamfwhm,fbeam,velres,fvel,
     &               thresh,p0,sqrt(ap),sqrt(ap1),s0
1020	format (1x,' rms: ',1p,g10.3,', beamfwhm: ',2(g10.3,1x),
     &       ', velres: ',2(g10.3,1x),/,
     &    1x,' threshhold: ',g10.3,', contrast: ',g10.3,
     &       ', weigth-aperture: ',g10.3,
     &       1x,g10.3,/,1x,' stiffness: ',3g10.3)
	close (unit=1)
	return

999	write (6,*) 'I-GETPAR: error reading clumps_inp '
	close (unit=1)
! CKr 15.7.04:
!	call exit
	stop
! CKr.
	end

subroutine gterflag(flag)
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public
  !
  !	Controls whether fatal errors cause an Abort or just set an
  !	error condition that can be sensed using the GTERRGTO or
  !	GTERRTST routines.
  !
  !	This is the only routine that you can call BEFORE the first call
  !	to GTINIT.
  !
  ! Argument :
  !	FLAG	.FALSE.	Errors are fatal (Default behaviour)
  !		.TRUE.  Errors are not fatal and can be sensed using
  !			the routine GTERRTST
  !---------------------------------------------------------------------
  logical :: flag                   !
  erflag = flag
  error_condition = .false.
end subroutine gterflag
!
function gterrtst()
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public
  !
  !	Logical function. Senses the ERROR_CONDITION switch.
  !
  !	Returns the value of the ERROR_CONDITION flag.
  !	Resets the ERROR_CONDITION flag.
  !---------------------------------------------------------------------
  logical :: gterrtst               !
  !
  if (error_condition) then
    error_condition = .false.
    gterrtst = .true.
  else
    gterrtst = .false.
  endif
end function gterrtst

SUBROUTINE OVERRIDE(LINE,ERROR)

  USE mira

  IMPLICIT NONE

  INTEGER           :: firstIFB, ier, ifb, j, lastIFB, nbd, nc, &
                       npix, nrecords
  REAL*4            :: beamEfficiency, forwardEfficiency, gainImage
  REAL*8            :: tmpHotLoad, tmpColdLoad, tamb, pamb
  CHARACTER(LEN=1)  :: ch
  CHARACTER(LEN=10) :: string 
  CHARACTER(LEN=20) :: tmpString,tmpSwitchmode
  CHARACTER(LEN=*)  :: line
  LOGICAL           :: error
  LOGICAL           :: noSky
  LOGICAL           :: SIC_PRESENT
  LOGICAL           :: updateColdLoad, updateHotLoad, updateBeamEff,         &
 &                     updateForwEff, updateGainImage, updateTamb,           &
 &                     updatePamb

  updateColdLoad  = .false.
  updateHotLoad   = .false.
  updateBeamEff   = .false.
  updateForwEff   = .false.
  updateGainImage = .false.
  updateTamb      = .false.
  updatePamb      = .false.


  if (SIC_PRESENT(2,0)) then
     if (allocated(newpar)) then
        do j = 1, size(newpar)
           call freeNewpar(newpar(j),error)
        enddo
     endif
     deallocate(newpar,stat=ier)
     overrideFlag(1:7) = .false. 
     call GAGOUT('I-OVERRIDE: calibrations parameters changed.')
     call GAGOUT('            Please read in a calibration scan.')
     return
  endif

  if (.not.SIC_PRESENT(0,1)) then
     call GAGOUT('W-OVERRIDE: no keyword specified. Valid keywords are: '//  &
 &               'tempload, efficiency')
     return
  endif
  call SIC_CH(line,0,1,string,nc,.true.,error)
  call SIC_UPPER(string)

  if (SIC_PRESENT(1,1)) then

     call SIC_CH(line,1,1,ch,nc,.true.,error)
     call SIC_UPPER(ch)
     if (ch.eq.'A') then
        firstIFB = 1
        if (associated(scan)) then 
          lastIFB = scan%header%nfebe
        else
          call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
          return
        endif
     else 
        call SIC_I4(line,1,1,ifb,.false.,error)
        firstIFB = ifb 
        lastIFB = ifb
     endif

  else

     firstIFB = 1
     lastIFB = 1
     call GAGOUT('W-OVERRIDE: no frontend/backend number specified. Set to 1.')

  endif

  if (index(string,'TEMP').ne.0) then

     if (SIC_PRESENT(0,2)) then
        call SIC_CH(line,0,2,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updateColdLoad = .true.
           call SIC_R8(line,0,2,tmpColdLoad,.false.,error)
        endif
     endif

     if (SIC_PRESENT(0,3)) then
        call SIC_CH(line,0,3,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updateHotLoad = .true.
           call SIC_R8(line,0,3,tmpHotLoad,.false.,error)
        endif
     endif

  else if (index(string,'EFF').ne.0) then

     if (SIC_PRESENT(0,2)) then
        call SIC_CH(line,0,2,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updateForwEff = .true.
           call SIC_R4(line,0,2,forwardEfficiency,.false.,error)
        endif
     endif

     if (SIC_PRESENT(0,3)) then
        call SIC_CH(line,0,3,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updateBeamEff = .true.
           call SIC_R4(line,0,3,beamefficiency,.false.,error)
        endif
     endif

  else if (index(string,'GAIN').ne.0) then

     if (SIC_PRESENT(0,2)) then
        call SIC_R4(line,0,2,gainImage,.false.,error)
        updateGainImage = .true.
     endif

  else if (index(string,'TAMB').ne.0) then

     if (SIC_PRESENT(0,2)) then
        call SIC_CH(line,0,2,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updateTamb = .true.
           call SIC_R8(line,0,2,tamb,.false.,error)
        endif
     endif

     if (SIC_PRESENT(0,3)) then
        call SIC_CH(line,0,3,ch,nc,.true.,error)
        if (ch.ne.'*') then
           updatePamb = .true.
           call SIC_R8(line,0,3,pamb,.false.,error)
        endif
     endif

  else 

     call GAGOUT('W-OVERRIDE: no such keyword. Valid keywords are: '//  &
 &               'tempload, efficiency, gain')
     return

  endif

  if (count(overrideFlag).eq.0) then
     if (allocated(newPar)) deallocate(newPar,stat=ier)
     allocate(newPar(scan%header%nfebe),stat=ier)
  endif

  if (updateColdLoad) then
     if (.not.associated(mon)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        mon(ifb)%data%thotcold(1,2) = tmpColdLoad
     enddo
     overrideFlag(1) = .true.
  endif

  if (updateHotLoad) then
     if (.not.associated(mon)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        mon(ifb)%data%thotcold(1,1) = tmpHotLoad
     enddo
     overrideFlag(2) = .true.
  endif

  if (updateHotLoad.or.updateColdLoad) then
     do ifb = 1, scan%header%nfebe
        if (allocated(newpar(ifb)%thotcold))                              &
 &         deallocate(newpar(ifb)%thotcold,stat=ier)
        allocate(newpar(ifb)%thotcold(1,2),stat=ier)
        newpar(ifb)%thotcold = mon(ifb)%data%thotcold
     enddo
  endif

  if (updateTamb) then
     if (.not.associated(mon)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        mon(ifb)%data%tamb_p_humid(1,1) = tamb 
     enddo
     overrideFlag(6) = .true.
  endif

  if (updatePamb) then
     if (.not.associated(mon)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        mon(ifb)%data%tamb_p_humid(1,2) = pamb 
     enddo
     overrideFlag(7) = .true.
  endif

  if (updateTamb.or.updatePamb) then
     do ifb = 1, scan%header%nfebe
        if (allocated(newpar(ifb)%tamb_p_humid))                              &
 &         deallocate(newpar(ifb)%tamb_p_humid,stat=ier)
        allocate(newpar(ifb)%tamb_p_humid(1,3),stat=ier)
        newpar(ifb)%tamb_p_humid = mon(ifb)%data%tamb_p_humid
     enddo
  endif


  if (updateForwEff) then
     do ifb = firstIFB, lastIFB
        if (.not.associated(febe)) then
          call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
          return
        endif
        npix = febe(ifb)%header%febefeed
        nbd = febe(ifb)%header%febeband
        febe(ifb)%data%etafss(1:npix,1:nbd) = forwardEfficiency
     enddo
     do ifb = 1, scan%header%nfebe
        npix = febe(ifb)%header%febefeed
        nbd = febe(ifb)%header%febeband
        if (allocated(newpar(ifb)%etafss))                                   &
 &         deallocate(newpar(ifb)%etafss,stat=ier)
        allocate(newpar(ifb)%etafss(npix,nbd),stat=ier)
        newpar(ifb)%etafss = febe(ifb)%data%etafss 
     enddo
     overrideFlag(3) = .true.
  endif

  if (updateBeamEff) then
     if (.not.associated(scan)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        if (.not.associated(febe)) then
          call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
          return
        endif
        npix = febe(ifb)%header%febefeed
        nbd = febe(ifb)%header%febeband
        febe(ifb)%data%beameff(1:npix,1:nbd) = beamEfficiency
     enddo
     do ifb = 1, scan%header%nfebe
        npix = febe(ifb)%header%febefeed
        nbd = febe(ifb)%header%febeband
        if (allocated(newpar(ifb)%beameff))                           &
 &          deallocate(newpar(ifb)%beameff,stat=ier)
        allocate(newpar(ifb)%beameff(npix,nbd),stat=ier)
        newpar(ifb)%beameff = febe(ifb)%data%beameff
     enddo
     overrideFlag(4) = .true.
  endif

  if (updateGainImage) then
     if (.not.associated(scan)) then
        call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
        return
     endif
     do ifb = firstIFB, lastIFB
        if (.not.associated(febe)) then
          call GAGOUT('W-OVERRIDE: pointer not associated. Please read a scan.')
          return
        endif
        npix = febe(ifb)%header%febefeed
        nbd = febe(ifb)%header%febeband
        febe(ifb)%data%gainimag(1:npix,1:nbd) = gainImage 
     enddo
     do ifb = 1, scan%header%nfebe
        if (allocated(newpar(ifb)%gainimag))                                  &
 &          deallocate(newpar(ifb)%gainimag,stat=ier)
        allocate(newpar(ifb)%gainimag(npix,nbd),stat=ier)
        newpar(ifb)%gainimag = febe(ifb)%data%gainimag
     enddo
     overrideFlag(5) = .true.
  endif

  if (.not.updateColdLoad.and..not.updateHotLoad.and..not.updateForwEff.and.  &
 &    .not.updateBeamEff.and..not.updateGainImage.and..not.updateTamb.and.    &
 &    .not.updatePamb) then
     call gagout('I-OVERRIDE: please specify at least one value, or * to '    &
 &               //'leave it unchanged.')
     return
  endif

  if (updateColdLoad.or.updateHotLoad) then
      write(*,*) ' ' 
      write(*,10) 'idFe', 'THotLoad', 'TColdLoad', 'idBe'
      write(*,20) '---- [Kelvin] ----'
      write(*,30) '--------------------------------' 
      do ifb = firstIFB, lastIFB
         j = index(febe(ifb)%header%febe,' ')
         write(*,40) febe(ifb)%header%febe(1:5),mon(ifb)%data%thotcold(1,1),   &
 &                   mon(ifb)%data%thotcold(1,2), febe(ifb)%header%febe(j+1:j+8)
      enddo
      write(*,*) ' ' 
  endif

  if (updateForwEff.or.updateBeamEff) then
      write(*,*) ' ' 
      write(*,50) 'idFe', 'forwardEff', 'beamEff', 'idBe'
      write(*,70) '--------------------------------------' 
      do ifb = firstIFB, lastIFB
         j = index(febe(ifb)%header%febe,' ')
         write(*,80) febe(ifb)%header%febe(1:5),febe(ifb)%data%etafss(1,1),   &
 &                   febe(ifb)%data%beameff(1,1),febe(ifb)%header%febe(j+1:j+8)
      enddo
      write(*,*) ' ' 
  endif

  if (updateGainImage) then
      write(*,*) ' ' 
      write(*,120) 'idFe', 'gainImage', 'idBe'
      write(*,140) '-----------------------------' 
      do ifb = firstIFB, lastIFB
         j = index(febe(ifb)%header%febe,' ')
         write(*,150) febe(ifb)%header%febe(1:5),febe(ifb)%data%gainimag(1,1), &
 &                    febe(ifb)%header%febe(j+1:j+8)
      enddo
      write(*,*) ' ' 
  endif

  noSky = count(array(1)%data(1)%iswitch.eq.'SKY').eq.0
  tmpString = scan%header%scantype
  call sic_upper(tmpString)

  if (index(tmpString,'CAL').ne.0.and..not.noSky) then
     write(*,*)  ' '
     write(*,90) 'idFe', 'THotLoad', 'TColdLoad', 'idBe',               &
 &                  'Pix', 'recTemp', 'sysTemp', 'calTemp',             &
 &                  'tauZenith', 'pwv'
     write(*,100) '---- [Kelvin] ----','------ [Kelvin] -------',       &
 &                  '[Neper]','[mm]'
     write(*,110) '----------------------------------------------'      &
 &                //'---------------------------'
     
     do ifb = 1, scan%header%nfebe
        call do_trx(ifb,error)
        nrecords = maxval(data(ifb)%data%integnum)
        call do_tcal(ifb,1,nrecords,.false.,0.,.false.,0.,error)
     enddo
     write(*,*)  ' '
  else if (index(tmpString,'CAL').eq.0) then
     call gagout('I-OVERRIDE: please recalibrate with new parameter(s).')
  endif

10  FORMAT(T6,A4,T11,A8,T20,A9,T30,A4)
20  FORMAT(T11,A18)
30  FORMAT(T6,A32)
40  FORMAT(T6,A5,T11,F8.3,T20,F9.3,T30,A8)
50  FORMAT(T6,A4,T13,A10,T24,A7,T34,A4)
60  FORMAT(T13,A18)
70  FORMAT(T6,A36)
80  FORMAT(T6,A5,T18,F5.3,T26,F5.3,T34,A8)
90  FORMAT(T6,A4,T11,A8,T20,A9,T30,A4,T36,A3,T41,A7,T49,A7,T57,A7,T65,A9,T75,A3)
100 FORMAT(T11,A18,T41,A23,T66,A7,T75,A4)
110 FORMAT(T6,A73)
120 FORMAT(T6,A4,T16,A9,T27,A4)
130 FORMAT(T17,A7)
140 FORMAT(T6,A27)
150  FORMAT(T6,A5,T18,F5.3,T26,A8)


  RETURN

END SUBROUTINE OVERRIDE

subroutine freeNewpar(var,error)

  use mira
  implicit none

  type(override_data) :: var
  logical       :: error

  integer       :: ier

  if (allocated(var%thotcold))     deallocate(var%thotcold,stat=ier)
  if (allocated(var%etafss))       deallocate(var%etafss,stat=ier)
  if (allocated(var%beameff))      deallocate(var%beameff,stat=ier)
  if (allocated(var%gainimag))     deallocate(var%gainimag,stat=ier)
  if (allocated(var%tamb_p_humid)) deallocate(var%tamb_p_humid,stat=ier)

end subroutine freeNewpar


subroutine do_trx(ifb,error)

  USE mira

  IMPLICIT NONE

  INTEGER                            :: ifb
  LOGICAL                            :: error
  CHARACTER(len=20)                  :: switchMode

  INTEGER                            :: ichan, ipix, ibd, ier, i1, i2,&
                                        nbd, nchan, nfb, npix
  REAL                               :: pcoldsignal, photsignal
  LOGICAL, DIMENSION(:), ALLOCATABLE :: calMask

  nbd = febe(ifb)%header%febeband
  nfb = scan%header%nfebe
  npix = febe(ifb)%header%febefeed
  switchMode = febe(ifb)%header%swtchmod
  call sic_upper(switchMode)
  !
  pixelLoop: do ipix = 1, npix
     !
     baseBandLoop: do ibd = 1, nbd
        !
        nchan = array(ifb)%header(ibd)%usedchan
        i1 = array(ifb)%header(ibd)%dropchan+1
        i2 = array(ifb)%header(ibd)%dropchan   &
             +array(ifb)%header(ibd)%usedchan
        allocate(calmask(i2-i1+1),stat=ier)
        if (calbychannel) then
           calmask=gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw   &
                   .and.   &
                   gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
           do ichan =  i1, i2
              if (calmask(ichan)) then
                 photsignal = gains(ifb)%phot(ibd,ipix,ichan)
                 pcoldsignal= gains(ifb)%pcold(ibd,ipix,ichan)
                 gains(ifb)%trx(ibd,ipix,ichan)   &
                 = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                    -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                   /(pcoldsignal-photsignal)
              else
                 gains(ifb)%trx(ibd,ipix,ichan) = -1.
              endif
           enddo
        else
           calmask = gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw
           photsignal = sum(gains(ifb)%phot(ibd,ipix,i1:i2),calmask)  &
                       /count(calmask)
           calmask = gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
           pcoldsignal =sum(gains(ifb)%pcold(ibd,ipix,i1:i2),calmask) &
                       /count(calmask)
           gains(ifb)%trx(ibd,ipix,1)   &
           = (photsignal*mon(ifb)%data%thotcold(1,2)   &
              -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
             /(pcoldsignal-photsignal)
        endif
        if (index(switchMode,'FREQ').ne.0) then
           calmask = gains(ifb+nfb)%phot(ibd,ipix,i1:i2).ne.blankingraw
           photsignal = sum(   &
                          gains(ifb+nfb)%phot(ibd,ipix,i1:i2),calmask &
                        )/count(calmask)
           calmask =gains(ifb+nfb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
           pcoldsignal =sum(   &
                          gains(ifb+nfb)%pcold(ibd,ipix,i1:i2),calmask&
                        )/count(calmask)
           gains(ifb+nfb)%trx(ibd,ipix,1)   &
           = (photsignal*mon(ifb)%data%thotcold(1,2)   &
              -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
             /(pcoldsignal-photsignal)
        endif
        deallocate(calMask,stat=ier)
     enddo baseBandLoop
   enddo pixelLoop
   !
end subroutine do_trx

!-----------------------------------------------------------------------
! libclass based demo program which writes a few observations to a Class
! file.
!-----------------------------------------------------------------------
! Class modules used here:
!   class_api            (provides Class types, parameters, and
!                         procedure interfaces)
! Class subroutines used here:
!   class_write_init     (initialize the libclass for writing process)
!   class_write_clean    (clean the libclass after writing process)
!   class_fileout_open   (init/reopen a Class output file)
!   class_fileout_close  (close the Class output file)
!   class_obs_init       (initialize an 'observation' variable)
!   class_obs_reset      (zero-ify and resize an observation)
!   class_obs_write      (write an observation to the output file)
!   class_obs_clean      (clean/free an 'observation' variable)
! Class derived types used here:
!   type(observation)
! Class buffers or variables used here:
!   none (on purpose)
!-----------------------------------------------------------------------
program classdemo
  use class_api
  ! Local
  logical :: error
  !
  ! Init
  error = .false.
  call class_write_init(error)
  if (error)  stop
  !
  ! Open (or overwrite) a Class file
  call classdemo_openfile(error)
  if (error)  stop
  !
  ! Write all the observations
  call classdemo_writeall(error)
  if (error)  continue  ! Continue to ensure correct cleaning
  !
  ! Close the Class file
  call classdemo_closefile(error)
  if (error)  continue  ! Continue to ensure correct cleaning
  !
  ! Quit Class cleanly
  call class_write_clean(error)
  if (error)  stop
  !
end program classdemo
!
subroutine classdemo_openfile(error)
  use gildas_def
  use class_api
  logical, intent(inout) :: error
  ! Local
  character(len=filename_length) :: file
  integer(kind=entry_length) :: size
  logical :: new,over,single
  !
  file = 'classdemo.30m'  ! Output file name
  new = .true.            ! Create new file or append?
  over = .true.           ! Overwrite file if it already exists?
  size = 1000             ! Maximum number of observations per (V1) file
  single = .true.         ! Single/multiple file kind
  call class_fileout_open(file,new,over,size,single,error)
  if (error)  return
  !
end subroutine classdemo_openfile
!
subroutine classdemo_closefile(error)
  use class_api
  logical, intent(inout) :: error
  !
  call class_fileout_close(error)
  if (error)  return
end subroutine classdemo_closefile
!
subroutine classdemo_writeall(error)
  use class_api
  logical, intent(inout) :: error
  ! Local
  type(observation) :: obs  ! Use a custom observation, not the R buffer
  integer(kind=4) :: iobs
  !
  call class_obs_init(obs,error)
  if (error)  return
  !
  do iobs=1,100
    call classdemo_fillobs(obs,error)
    if (error)  return
    !
    call class_obs_write(obs,error)
    if (error)  return
  enddo
  !
  call class_obs_clean(obs,error)
  if (error)  return
  !
end subroutine classdemo_writeall
!
subroutine classdemo_fillobs(obs,error)
  use gbl_constant
  use phys_const
  use class_api
  type(observation), intent(inout) :: obs    !
  logical,           intent(inout) :: error  !
  ! Local
  integer(kind=4) :: nchan,ichan
  !
  nchan = 128
  !
  call class_obs_reset(obs,nchan,error)
  if (error)  return
  !
  obs%head%presec(:) = .false.  ! Disable all sections (except next ones)
  !
  ! General
  obs%head%presec(class_sec_gen_id) = .true.
  obs%head%gen%num = 0  ! 0 = Automatic numbering
  obs%head%gen%ver = 0  ! 0 = Automatic increment at write time
  obs%head%gen%teles= 'MYTELES'
  obs%head%gen%dobs = 0
  obs%head%gen%dred = 0
  obs%head%gen%kind = kind_spec
  obs%head%gen%qual = 0
  obs%head%gen%scan = 1
  obs%head%gen%subscan = 1
  obs%head%gen%ut = 0.d0
  obs%head%gen%st = 0.d0
  obs%head%gen%az = 0.
  obs%head%gen%el = 0.
  obs%head%gen%tau = 0.
  obs%head%gen%tsys = 100.
  obs%head%gen%time = 100.
  obs%head%gen%xunit = 0
  !
  ! Position
  obs%head%presec(class_sec_pos_id) = .true.
  obs%head%pos%sourc = 'MYSOURCE'
  obs%head%pos%system = type_eq
  obs%head%pos%equinox = 2000.0
  obs%head%pos%proj  = p_none
  obs%head%pos%lam   = pi/2.d0
  obs%head%pos%bet   = pi/2.d0
  obs%head%pos%projang = 0.d0
  obs%head%pos%lamof = 0.
  obs%head%pos%betof = 0.
  !
  ! Spectro
  obs%head%presec(class_sec_spe_id) = .true.
  obs%head%spe%line = 'MYLINE'
  obs%head%spe%restf = 123456.d0
  obs%head%spe%nchan = nchan
  obs%head%spe%rchan = 1.
  obs%head%spe%fres = 1.
  obs%head%spe%vres = -1.
  obs%head%spe%voff = 0.
  obs%head%spe%bad = -1000.
  obs%head%spe%image = 98765.d0
  obs%head%spe%vtype = vel_obs
  obs%head%spe%vconv = vconv_rad
  obs%head%spe%doppler = 0.d0
  !
  ! Data
  do ichan=1,nchan
    ! Fill with dummy values
    obs%data1(ichan) = sin(2.*pi*ichan/nchan)**2
  enddo
  !
end subroutine classdemo_fillobs

subroutine sic_timer(line,error)
  use sic_interfaces, except_this=>sic_timer
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    TIMER
  !    TIMER ON|OFF
  !    TIMER [Time [HOURS|MINUTES|SECONDS]] [/COMMAND String]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  logical :: show
  !
  show = .true.
  if (sic_present(0,1)) then
    call sic_timer_dotime(line,1,2,error)
    if (error)  return
    show = .false.
  endif
  if (sic_present(1,0)) then
    call sic_timer_docommand(line,error)
    if (error)  return
    show = .false.
  endif
  if (show) then
    call sic_timer_show(error)
    if (error)  return
  endif
  !  
end subroutine sic_timer
!
subroutine sic_timer_show(error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_show
  !---------------------------------------------------------------------
  ! @ private
  ! Show current status of the timer
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  character(len=message_length) :: mess
  character(len=commandline_length) :: command
  integer(kind=4) :: status,timersec
  !
  call xgag_gettimer_status(status)
  if (status.eq.0) then
    call sic_message(seve%i,rname,'Timer is OFF')
  else
    call sic_message(seve%i,rname,'Timer is ON')
  endif
  !
  call xgag_gettimer(timersec)
  if (timersec.eq.0) then
    write(mess,'(A)')         'No timer value set'
  elseif (timersec.ge.3600) then
    write(mess,'(A,F0.2,A)')  'Timer value: ',timersec/3600.,' hour(s)'
  elseif (timersec.ge.60) then
    write(mess,'(A,F0.2,A)')  'Timer value: ',timersec/60.,' minute(s)'
  else
    write(mess,'(A,I0,A)')    'Timer value: ',timersec,' second(s)'
  endif
  call sic_message(seve%i,rname,mess)
  !
  call xgag_gettimer_command(command)
  write(mess,'(A,A)')  'Timer command: ',trim(command)
  call sic_message(seve%i,rname,mess)
  !
end subroutine sic_timer_show
!
subroutine sic_timer_dotime(line,iargval,iargunit,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_dotime
  !---------------------------------------------------------------------
  ! @ private
  ! Set the timer duration
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iargval
  integer(kind=4),  intent(in)    :: iargunit
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  integer(kind=4), parameter :: nstatus=2
  character(len=3), parameter :: status(nstatus) = (/ 'ON ','OFF' /)
  integer(kind=4), parameter :: ntime=3
  character(len=7), parameter :: time(ntime) = (/ 'HOURS  ','MINUTES','SECONDS' /)
  character(len=7) :: key
  integer(kind=4) :: n,ikey
  character(len=40) :: argum
  integer(kind=4) :: timersec
  real(kind=4) :: timer
  !
  ! Try first ON or OFF
  call sic_ke(line,0,iargval,argum,n,.true.,error)
  if (error) return
  call sic_ambigs_sub(rname,argum,key,ikey,status,nstatus,error)
  if (error)  return
  if (ikey.ne.0) then
    ! Found a status
    if (ikey.eq.2)  ikey = 0   ! OFF => 0
    call xgag_settimer_status(ikey)
    return
  endif
  !
  ! No status keyword found, try a numeric value
  call sic_r4(line,0,iargval,timer,.true.,error)
  if (error)  return
  argum = 'HOURS'
  call sic_ke(line,0,iargunit,argum,n,.false.,error)
  if (error)  return
  call sic_ambigs(rname,argum,key,ikey,time,ntime,error)
  if (error)  return
  !
  if (ikey.eq.1) then
    timersec = timer*3600.
  elseif (ikey.eq.2) then
    timersec = timer*60.
  else
    timersec = timer
  endif
  call xgag_settimer(timersec)
  !
end subroutine sic_timer_dotime
!
subroutine sic_timer_docommand(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_timer_docommand
  !---------------------------------------------------------------------
  ! @ private
  ! Set the timer command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TIMER'
  integer(kind=4), parameter :: optcommand=1
  character(len=commandline_length) :: command
  integer(kind=4) :: n
  !
  if (sic_present(optcommand,2)) then
    call sic_message(seve%e,rname,'Trailing arguments to option /COMMAND')
    call sic_message(seve%e,rname,'Command string must be given as single argument, possibly double-quoted')
    error = .true.
    return
  endif
  !
  call sic_ch(line,optcommand,1,command,n,.true.,error)
  if (error)  return
  !
  call xgag_settimer_command(trim(command))
  !
end subroutine sic_timer_docommand

module cubelist_object_advanced_class
  use cubelist_messaging
  use cubelist_object_class
  !---------------------------------------------------------------------
  ! An "advanced object" is the same as the basic 'list_object_t' except
  ! it has properties which can be listed (e.g. LIST), filtered (e.g.
  ! FIND), instantiated (e.g. VARIABLE).
  !
  ! The counterpart is that such object must provide get_value_*
  ! methods.
  !---------------------------------------------------------------------
  !
  public :: list_object_advanced_t
  public :: cubelist_object_advanced_ptr
  private
  !
  type, abstract, extends(list_object_t) :: list_object_advanced_t
    logical, public :: hidden = .false.  ! Hidden to LIST, FIND, etc
  contains
    procedure, public :: hide => cubelist_object_advanced_hide
    generic,   public :: get_value => get_value_i4,get_value_i8,  &
                                      get_value_r4,get_value_r8,  &
                                      get_value_cc
    procedure(get_value_i4_interface), deferred         :: get_value_i4  ! [private]
    procedure(get_value_i8_interface), deferred         :: get_value_i8  ! [private]
    procedure(get_value_r4_interface), deferred         :: get_value_r4  ! [private]
    procedure(get_value_r8_interface), deferred         :: get_value_r8  ! [private]
    procedure(get_value_cc_interface), deferred         :: get_value_cc  ! [private]
    procedure(get_lrepr_interface),    deferred, public :: get_lrepr
    procedure(get_repr_interface),     deferred, public :: get_repr
  end type list_object_advanced_t
  !
  abstract interface
    subroutine get_value_i4_interface(obj,name,found,value,error)
      import list_object_advanced_t
      !-------------------------------------------------------------------
      ! Get an I*4 property from an object.
      ! - Found is set to .false. if the named property does not exist for
      !   this object. This is not an error: you do not want LIST or FIND
      !   to fail on an heterogeneous index. Input 'value' is preserved.
      ! - Found is set to .true. if the named property exists and is
      !   indeed an I*4; value returned in 'value'.
      ! - Error is set to .true. if the named property exists but is not
      !   I*4. This is considered as a programming error (programmer
      !   mistake: he used the wrong combination of "name" and 'value'
      !   kind).
      !-------------------------------------------------------------------
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      integer(kind=4),               intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_i4_interface
    subroutine get_value_i8_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      integer(kind=8),               intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_i8_interface
    subroutine get_value_r4_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      real(kind=4),                  intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_r4_interface
    subroutine get_value_r8_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      real(kind=8),                  intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_r8_interface
    subroutine get_value_cc_interface(obj,name,found,value,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      logical,                       intent(out)   :: found
      character(len=*),              intent(inout) :: value
      logical,                       intent(inout) :: error
    end subroutine get_value_cc_interface
    !
    subroutine get_lrepr_interface(obj,name,width,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(in)    :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      integer(kind=4),               intent(out)   :: width ! Computed column width
      logical,                       intent(inout) :: error
    end subroutine get_lrepr_interface
    subroutine get_repr_interface(obj,name,width,repr,nline,error)
      import list_object_advanced_t
      class(list_object_advanced_t), intent(inout) :: obj
      character(len=*),              intent(in)    :: name  ! Property name
      integer(kind=4),               intent(in)    :: width ! Expected column width
      character(len=*),              intent(out)   :: repr(:)
      integer(kind=4),               intent(out)   :: nline
      logical,                       intent(inout) :: error
    end subroutine get_repr_interface
  end interface
  !
contains
  !
  function cubelist_object_advanced_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(list_object_advanced_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(list_object_advanced_t), pointer :: cubelist_object_advanced_ptr
    class(list_object_t), pointer       :: obj
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBJECT>ADVANCED>PTR'
    !
    select type(obj)
    class is (list_object_advanced_t)
      cubelist_object_advanced_ptr => obj
    class default
      cubelist_object_advanced_ptr => null()
      call cubelist_message(seve%e,rname,  &
        'Internal error: object is not a list_object_advanced_t type')
      error = .true.
      return
    end select
  end function cubelist_object_advanced_ptr
  !
  subroutine cubelist_object_advanced_hide(obj)
    class(list_object_advanced_t), intent(inout) :: obj
    obj%hidden = .true.
  end subroutine cubelist_object_advanced_hide
end module cubelist_object_advanced_class

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function eclass_offset_eq(x1,x2,y1,y2,t1,t2)
  use mrtcal_buffers
  !---------------------------------------------------------------------
  ! @ private
  ! Equality routine between two pairs of offset (real*8) with a
  ! tolerance ruled by MSET CALIBRATION MATCH
  !---------------------------------------------------------------------
  logical :: eclass_offset_eq
  real(kind=8),     intent(in) :: x1,x2  ! [rad]
  real(kind=8),     intent(in) :: y1,y2  ! [rad]
  character(len=*), intent(in) :: t1,t2  ! Offset type (track, onTheFly, ...)
  !
  eclass_offset_eq = abs(x1-x2).le.rsetup%cal%match .and.  &
                     abs(y1-y2).le.rsetup%cal%match .and.  &
                     t1.eq.t2
  !
end function eclass_offset_eq
!
subroutine mrtcal_subscan_list_build(switchmode,sublist,imbf,error)
  use mrtcal_messaging
  use phys_const
  use gkernel_types
  use imbfits_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_subscan_list_build
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ private
  ! 1. Class the subscans of the current scan in TRACKED or OTF, ON or OFF
  ! 2. Associate the median offset, median MJD, and the integration time
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: switchmode
  type(subscan_list_t), intent(inout) :: sublist
  type(imbfits_t),      intent(inout) :: imbf
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4), parameter :: type_length = 80
  real(kind=8), allocatable :: r8buf(:)
  integer(kind=4), allocatable :: i4buf(:),key(:)
  character(len=type_length), allocatable :: chbuf(:)
  character(len=24), allocatable :: ch24buf(:)
  logical, allocatable :: lbuf(:)
  integer(kind=4) :: ier,isub,nsub,iequ
  type(range_t) :: time
  type(eclass_2dble1char_t) :: offset_eclass
  type(imbfits_subscan_t) :: subscan
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SUBSCAN>LIST>BUILD'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity check + allocation
  nsub = imbf%primary%n_obsp%val
  if (nsub.eq.0) then
     call mrtcal_message(seve%e,rname,'No available subscan')
     error = .true.
     return
  endif
  call reallocate_subscan_list(nsub,sublist,error)
  if (error) return
  !
  ! Check that only one offset position is associated to each subscan and
  ! make the list of these subscan position
  do isub=1,nsub
     subscan%isub = isub
     ! Read IMBF-antslow hdu and get on-track time range
     call imbfits_read_header_antslow(imbf,isub,rsetup%cal%antslowmjdshift,subscan%antslow,error)
     if (error)  goto 100
     ! Read IMBF-backendXXX for subscan%backdata%head%desc%naxis2%val
     ! Compress bad time dumps, so that 100% bad tables are detected as empty
     call imbfits_read_header_backdata(imbf,isub,.true.,subscan%backdata,error)
     if (error)  goto 100
     call mrtcal_get_time_range_for_antslow(subscan,time,error)
     if (error)  goto 100
     !
     sublist%isub(isub) = isub
     sublist%mjd(isub) = sum(subscan%antslow%table%mjd%val(time%first:time%last))/time%n ! *** JP maybe a median would be better here
     sublist%time(isub) = subscan%antslow%head%substime%val
     sublist%empty(isub) = subscan%backdata%head%desc%naxis2%val.le.0
     sublist%scanning%val(isub) = subscan%antslow%head%substype%val
     !
     if (subscan%antslow%head%substype%val.eq.'track') then
        ! Search for the equivalent classes of offset positions for each subscan
        call reallocate_eclass_2dble1char(offset_eclass,time%n,error)
        if (error) goto 100
        offset_eclass%val1(1:time%n) = subscan%antslow%table%longoff%val(time%first:time%last)
        offset_eclass%val2(1:time%n) = subscan%antslow%table%latoff%val(time%first:time%last)
        offset_eclass%val3(1:time%n) = subscan%antslow%head%substype%val
        offset_eclass%cnt(1:time%n) = 1
        call eclass_2dble1char(eclass_offset_eq,offset_eclass)
        ! Only 1 position expected per subscan in tracked psw
        if (offset_eclass%nequ.ne.1) then
           write(mess,'(A,I0)')  'Subscan #',isub
           call mrtcal_subscan_list_error(trim(mess),offset_eclass,time%n,'traces',"1")
           error = .true.
           goto 100
        endif
        ! List the subscan positions
        sublist%onoff%val1(isub) = offset_eclass%val1(1)
        sublist%onoff%val2(isub) = offset_eclass%val2(1)
        sublist%onoff%val3(isub) = offset_eclass%val3(1)
     else if (subscan%antslow%head%substype%val.eq.'onTheFly') then
        ! Set arbitrary (but identical from 1 onTheFly subscan to another)
        ! values. The comparison function will distinguish track from onTheFly
        ! by comparing the subscan type.
        sublist%onoff%val1(isub) = 0.0
        sublist%onoff%val2(isub) = 0.0
        sublist%onoff%val3(isub) = subscan%antslow%head%substype%val
     else if (subscan%antslow%head%substype%val.eq.'onFocus') then
        ! Code is duplicated from the onTheFly section because it's unclear
        ! whether some modifications will be needed
        sublist%onoff%val1(isub) = 0.0
        sublist%onoff%val2(isub) = 0.0
        sublist%onoff%val3(isub) = subscan%antslow%head%substype%val        
     else 
        call mrtcal_message(seve%e,rname,'Unknown substype: '//subscan%antslow%head%substype%val)
        error = .true.
        goto 100
     endif
  enddo ! isub
  !
  ! Sort by increasing time (just a precaution...)
  allocate(key(nsub),r8buf(nsub),i4buf(nsub),chbuf(nsub),ch24buf(nsub),lbuf(nsub),stat=ier)
  if (failed_allocate(rname,'Sorting key and buffers',ier,error)) return
  call gr8_trie(sublist%mjd,key,nsub,error)
  if (error) then
     deallocate(key,r8buf,i4buf,chbuf,ch24buf,lbuf)
     return
  endif
  call gr8_sort(sublist%mjd,r8buf,key,nsub)
  call gr8_sort(sublist%time,r8buf,key,nsub)
  call gi4_sort(sublist%isub,i4buf,key,nsub)
  call gl_sort (sublist%empty,lbuf,key,nsub)
  call gr8_sort(sublist%onoff%val1,r8buf,key,nsub)
  call gr8_sort(sublist%onoff%val2,r8buf,key,nsub)
  call gch_sort(sublist%onoff%val3,ch24buf,key,24,nsub)
  call gch_sort(sublist%scanning%val,chbuf,key,type_length,nsub)
  deallocate(key,r8buf,i4buf,chbuf,ch24buf,lbuf)
  !
  ! Search for the equivalent classes of the subscan types
  call eclass_char(eclass_char_eq,sublist%scanning)
  if (sublist%scanning%nequ.eq.1 .and. sublist%scanning%val(1).eq.'onTheFly') then
    sublist%tracked = 0
    sublist%otf = 1
    sublist%focus = 0
  else if (sublist%scanning%nequ.eq.1 .and. sublist%scanning%val(1).eq.'onFocus') then
    sublist%tracked = 0
    sublist%otf = 0
    sublist%focus = 1
  else if (sublist%scanning%nequ.ge.1 .and. sublist%scanning%val(1).eq.'track') then
    sublist%tracked = 1
    sublist%otf = 2
    sublist%focus = 0
  else if (sublist%scanning%nequ.ge.2 .and. sublist%scanning%val(2).eq.'track') then
    sublist%tracked = 2
    sublist%otf = 1
    sublist%focus = 0
  else
    call mrtcal_message(seve%e,rname,'Could not figure out TRACKED vs OTF classes')
    write(mess,'(I0,A)') sublist%scanning%nequ,' subscan type(s) found:'
    call mrtcal_message(seve%e,rname,mess)
    do iequ=1,sublist%scanning%nequ
      write(mess,'(A,I0,A,A,A,I0,A)')  '  #',iequ,': ',  &
        trim(sublist%scanning%val(iequ)),' (',sublist%scanning%cnt(iequ),' subscans)'
      call mrtcal_message(seve%e,rname,mess)
    enddo
    error = .true.
    goto 100
  endif
  !
  ! Search for the equivalent classes of the subscan positions
  call eclass_2dble1char(eclass_offset_eq,sublist%onoff)
  select case (switchmode)
  case (switchmode_pos)
     if (sublist%onoff%nequ.ne.2) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"2: ON+OFF")
        error = .true.
        goto 100
     endif
     ! Identifies classes as on and off classes. The first one is always
     ! assumed to be an OFF in IMBFITS v2...
     sublist%off = 1
     sublist%on  = 2
  case (switchmode_wob)
     if (sublist%onoff%nequ.ne.1 .and. sublist%onoff%nequ.ne.2) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"1 or 2")
        error = .true.
        goto 100
     endif
  case (switchmode_fre,switchmode_bea)
     if (sublist%onoff%nequ.ne.1) then
        call mrtcal_subscan_list_error("Scan",sublist%onoff,nsub,'subscans',"1")
        error = .true.
        goto 100
     endif
     ! Only ON subscans in frequency or beam switching!
     sublist%on  = 1
     sublist%off = 0
  case default
     call mrtcal_message(seve%e,rname,trim(imbf%scan%head%swtchmod%val)//' not supported')
     error = .true.
     goto 100
  end select
  !
100 continue
  call imbfits_free_header_antslow(subscan%antslow,error)
  call imbfits_free_header_backdata(subscan%backdata,error)
  call free_eclass_2dble1char(offset_eclass,error)
  !
contains
  subroutine mrtcal_subscan_list_error(what,eclass,nsource,source,expected)
    use mrtcal_messaging
    character(len=*),          intent(in) :: what
    type(eclass_2dble1char_t), intent(in) :: eclass
    integer(kind=4),           intent(in) :: nsource
    character(len=*),          intent(in) :: source
    character(len=*),          intent(in) :: expected
    ! Local
    character(len=message_length) :: mess
    !
    write(mess,'(2A,I0,A,I0,1X,4A)')  what,' has ',eclass%nequ,  &
      ' positions through ',nsource,source,' (expected ',expected,'):'
    call mrtcal_message(seve%e,rname,mess)
    do iequ=1,eclass%nequ
      write(mess,'(3X,A,I0,A,f0.8,2x,f0.8)')  &
        'Position #',iequ,': ',eclass%val1(iequ)*sec_per_rad,eclass%val2(iequ)*sec_per_rad
      call mrtcal_message(seve%e,rname,mess)
    enddo ! iequ
  end subroutine mrtcal_subscan_list_error
  !
end subroutine mrtcal_subscan_list_build
!
subroutine mrtcal_subscan_list_print(switchmode,sublist,error)
  use mrtcal_messaging
  use phys_const
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_subscan_list_print
  !---------------------------------------------------------------------
  ! @ private
  ! List useful information about the subscans of the current scan
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: switchmode
  type(subscan_list_t), intent(in)    :: sublist
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: isub
  character(len=7) :: equclass
  character(len=4) :: subscan_kind
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SUBSCAN>LIST>PRINT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (sublist%nsub.eq.0) then
     call mrtcal_message(seve%r,rname,'No available subscan')
  else
     write(mess,'(A)') '#     ObsType           Offsets          MJD         IntTime'
     call mrtcal_message(seve%r,rname,mess)
     do isub=1,sublist%nsub
        if (sublist%scanning%bak(isub).eq.sublist%tracked) then
           equclass = 'TRACKED'
        else if (sublist%scanning%bak(isub).eq.sublist%otf) then
           equclass = 'OTF    '
        else if (sublist%scanning%bak(isub).eq.sublist%focus) then
           equclass = 'Focus  '
        else
           call mrtcal_message(seve%e,rname,'Unknown equivalent class')
           error = .true.
           return
        endif
        select case (switchmode)
        case (switchmode_pos)
           if (sublist%onoff%bak(isub).eq.sublist%on) then
              subscan_kind = 'ON '
           else if (sublist%onoff%bak(isub).eq.sublist%off) then
              subscan_kind = 'OFF'
           else
              call mrtcal_message(seve%e,rname,'Unknown equivalent class')
              error = .true.
              return
           endif
        case (switchmode_wob)
           write(subscan_kind,'(A,I1)') 'WSW',sublist%onoff%bak(isub)
        case (switchmode_fre)
           write(subscan_kind,'(A)') 'FSW'
        case (switchmode_bea)
           write(subscan_kind,'(A)') 'BSW'
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode') ! *** JP Having the name of the switched mode would be good...
           error = .true.
           return
        end select
        write(mess,'(I2,2x,A,1x,A,2x,2F8.1,2x,F0.8,2x,F0.6)')  &
             isub,equclass,subscan_kind,&
             sublist%onoff%val1(isub)*sec_per_rad,&
             sublist%onoff%val2(isub)*sec_per_rad,&
             sublist%mjd(isub),&
             sublist%time(isub)
        call mrtcal_message(seve%r,rname,mess)
     enddo ! isub
  endif
  !
end subroutine mrtcal_subscan_list_print
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_switch_cycle_init(front,backdata,antslow,sublist,cycle,error)
  use phys_const
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_switch_cycle_init
  use imbfits_types
  use mrtcal_calib_types
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ private
  ! Note that the frequency offset in frequency switching may depend on the
  ! frontend. This imposes that the off pointer in the switch_desc_t has 
  ! noffset x nfront dimensions, and not just noffset.
  !
  ! In wobbler switching, check that offsets are given in horizontalTrue.
  ! If true, then use the sign of the longitude offset to determine the ON and OFF
  ! phases. Indeed, the backdata%head%phaseone%val value is only indicating
  ! whether the phase corresponds to the wobbler LEFT or RIGHT, not whether
  ! it is ON or OFF (even though the value names still are ON or OFF). Yes,
  ! I know: This is confusing...
  !
  ! In frequency switching, try to use backdata%head%phaseone%val to 
  ! decide who is ON and who is OFF
  !---------------------------------------------------------------------
  type(imbfits_front_t),    intent(in)    :: front
  type(imbfits_backdata_t), intent(in)    :: backdata
  type(imbfits_antslow_t),  intent(in)    :: antslow
  type(subscan_list_t),     intent(in)    :: sublist
  type(switch_cycle_t),     intent(inout) :: cycle
  logical,                  intent(inout) :: error
  !
  integer(kind=4), parameter :: ilam = 1
  integer(kind=4), parameter :: ibet = 2
  integer(kind=4) :: ifront,nfront,npha,ndump,non,noff
  real(kind=4) :: dummy
  character(len=*), parameter :: rname='PHASE>SWITCH>CYCLE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ndump = backdata%head%nphases%val
  nfront = front%table%frqoff1%n ! *** JP some test needed about the consistency with frqoff2?
  select case (cycle%mode)
  case (switchmode_pos)
     if (ndump.ne.1) then
        call mrtcal_message(seve%e,rname,'Position switching should only have one dump per dumpcycle')
        error = .true.
        return
     endif
     non  = 1
     noff = 1
     npha = 2 ! Convention: One ON and one OFF (they can be the average of several subscans)
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     cycle%on%i(1)  = 1 ! Convention
     cycle%off%i(1) = 2 ! Convention
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)
     cycle%desc(cycle%on%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%off)
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%off)
  case (switchmode_wob)
     if (antslow%head%systemof%val.ne.'horizontalTrue') then
        call mrtcal_message(seve%e,rname,'Wobbler switching offsets are not given in the True Horizontal frame')
        error = .true.
        return
     endif
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(sublist%onoff%val1(sublist%on).lt.0,cycle)
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(:,:) = 0 ! It's a convention that the ON offsets are 0 valued.
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)
  case (switchmode_fre)
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(backdata%head%phaseone%val.eq.'ON',cycle)
     do ifront=1,nfront
        ! Both weights are now +1. This comes from the fact the products
        ! which are folded are different now.
        ! In the past we used to do:
        !   F = SomeGain * (PHASE1-PHASE2)
        ! F was the usual unfolded spectrum, providing one positive and
        ! one negative shifted phases. Folding was done with:
        !   FOLDED = (+F(+shift) - F(-shift))/2
        ! which realigned the 2 phases with the shift and made them positives
        ! with the +1 and -1 weights.
        !
        ! Now we compute 2 unfolded spectra:
        !   F1 = (PHASE1-PHASE2)/PHASE2
        !   F2 = (PHASE2-PHASE1)/PHASE1
        ! In this case, PHASE1 is positive in F1, and PHASE2 is positive in F2.
        ! There is no more need to inverse F1 or F2 at folding time:
        !   FOLDED = (F1(+shift) + F2(-shift))/2
        cycle%desc(cycle%on%i(1))%wei(ifront)  = +1
        cycle%desc(cycle%off%i(1))%wei(ifront) = +1
        ! CLASS needs the frequencies in MHz
        ! But the frequency offset is in simple precision in IMBFITS while
        ! CLASS asks for a double precision. It's simpler for the end user
        ! to see -7.10000000000000 (the human double representation of a
        ! simple 7.1) than 7.10000004619360 (the correct double binary
        ! representation of a simple 7.1). NCS is passing 7.1 in a XML
        ! ASCII field. So we don't know what NCS actually does. The
        ! following trick is is thus mostly a cosmetic one.
        dummy = front%table%frqoff1%val(ifront)*1e9
        cycle%desc(cycle%on%i(1))%off(:,ifront)  = dummy*1d-6
        dummy = front%table%frqoff2%val(ifront)*1e9
        cycle%desc(cycle%off%i(1))%off(:,ifront) = dummy*1d-6
     enddo ! ifront
  case (switchmode_bea)
     non  = ndump/2
     noff = ndump/2
     npha = ndump
     call reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
     if (error) return
     call fill_switch_on_and_off_indexes(backdata%head%phaseone%val.eq.'ON',cycle)
     cycle%desc(cycle%on%i(1))%wei(:)  = +1
     cycle%desc(cycle%off%i(1))%wei(:) = -1
     cycle%desc(cycle%on%i(1))%off(:,:) = 0 ! It's a convention that the ON offsets are 0 valued.
     cycle%desc(cycle%off%i(1))%off(ilam,:) = sublist%onoff%val1(sublist%on)  ! ZZZ These are not filled properly
     cycle%desc(cycle%off%i(1))%off(ibet,:) = sublist%onoff%val2(sublist%on)  ! ZZZ These are not filled properly
  case default
     call mrtcal_message(seve%e,rname,'Unknown switch mode')
     error = .true.
     return
  end select
  !
contains
  !
  subroutine fill_switch_on_and_off_indexes(firstison,cycle)
    !---------------------------------------------------------------------
    ! If firstison = .true., then on%i = (1,3,5,...) and off%i = (2,4,6,...)
    !                        then on%i = (2,4,6,...) and off%i = (1,3,5,...)
    !---------------------------------------------------------------------
    logical,              intent(in) :: firstison
    type(switch_cycle_t), intent(inout) :: cycle
    !
    integer(kind=4) :: i
    !
    if (firstison) then
       cycle%on%i(1:non)   = (/ (1+(i-1)*2, i=1,non)  /)
       cycle%off%i(1:noff) = (/ (2+(i-1)*2, i=1,noff) /)
    else
       cycle%on%i(1:non)   = (/ (2+(i-1)*2, i=1,noff) /)
       cycle%off%i(1:noff) = (/ (1+(i-1)*2, i=1,non)  /)
    endif
  end subroutine fill_switch_on_and_off_indexes
end subroutine mrtcal_switch_cycle_init
!
subroutine mrtcal_switch_cycle_list(cycle,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_switch_cycle_list
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! List useful information about the switch cycle of the current subscan
  !---------------------------------------------------------------------
  type(switch_cycle_t), intent(in)    :: cycle
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: ifront,ipha
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='SWITCH>CYCLE>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select case (cycle%mode)
  case (switchmode_pos)
     ! Print something?
  case (switchmode_wob)
     ! Print another thing?
  case (switchmode_bea)
     ! Print still another thing?
  case (switchmode_fre)
     if (cycle%npha.eq.0) then
        call mrtcal_message(seve%w,rname,'No phase found')
     else
        write(mess,'(2x,a)') 'Phase  Weight  Front  Freq. offset'
        call mrtcal_message(seve%r,rname,mess)
        do ipha=1,cycle%npha
           if (cycle%desc(ipha)%nfront.eq.0) then
              write(mess,'(2x,a)') 'No front end for this phase'
              call mrtcal_message(seve%w,rname,mess)
           else
              do ifront=1,cycle%desc(ipha)%nfront
                 write(mess,'(2x,I5,f6.1,4x,I5,2x,f12.3)') &
                      ipha,cycle%desc(ipha)%wei(ifront), &
                      ifront, cycle%desc(ipha)%off(1,ifront)
                 call mrtcal_message(seve%r,rname,mess)
              enddo ! ipha
           endif
        enddo ! ifront
     endif
  case default
     call mrtcal_message(seve%e,rname,'Unknown switch mode')
     error = .true.
     return
  end select
  !
end subroutine mrtcal_switch_cycle_list
!
subroutine mrtcal_switch_book_list(book,error)
  use mrtcal_interfaces, except_this=>mrtcal_switch_book_list
  use mrtcal_messaging
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(switch_book_t), intent(in)    :: book
  logical,             intent(inout) :: error
  ! Local
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='PHASE>SWITCH>BOOK>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! book%idump is used as loop iterator => its value is the number of 
  ! actually checked dumps plus one!
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Checked ",book%idump-1," dumps (on ",book%ndump," on-track dumps) " 
  call mrtcal_message(mseve%calib%book,rname,mess)
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Rejected ",book%norphan," dumps (on ",book%ndump," on-track dumps) " 
  call mrtcal_message(mseve%calib%book,rname,mess)
  write(mess,'(2x,A,I0,A,I0,A)') &
       "Read ",book%ncycle," complete cycles over ",book%ndump/book%nphase," potential cycles"
  call mrtcal_message(mseve%calib%book,rname,mess)
  !
end subroutine mrtcal_switch_book_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_iterate_subscancycle(mrtset,imbf,subscanbuf,  &
  backcal,backsci,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_iterate_subscancycle
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset      !
  type(imbfits_t),         intent(in)    :: imbf        !
  type(subscan_buffer_t),  intent(inout) :: subscanbuf  !
  type(calib_backend_t),   intent(in)    :: backcal     !
  type(science_backend_t), intent(inout) :: backsci     !
  logical,                 intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='ITERATE>SUBSCANCYCLE'
  ! Cycle descriptions
  integer(kind=4), parameter :: msub=4        ! Max number of subscans per cycle
  integer(kind=4), parameter :: mcycle=3      ! Number of known cycles
  integer(kind=4), parameter :: mmode=2       ! Mode 1: detection, mode 2: calibration
  type :: cycle_t
    integer(kind=4)  :: nsub        ! Number of subscans per cycle
    integer(kind=4)  :: desc(msub)  ! Cycle description
    character(len=4) :: name        ! Human friendly cycle name
  end type cycle_t
  type(cycle_t) :: det(mcycle),cal(mcycle)  ! Detection, calibration
  ! Other
  type(chunkset_3d_t) :: cumul  ! Cumulation structure in case of SCAN accumulation
  integer(kind=4) :: isub,ifirst,jcycle,ncycle
  logical :: found,initcumul
  character(len=message_length) :: mess
  !
  ! --- Cycle descriptions ---
  ! ROOR (detection ROOR)
  det(1)%nsub    = 4
  det(1)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%on, backsci%list%off /)
  det(1)%name    = 'ROOR'
  ! ROOR (calibration ROOR)
  cal(1)%nsub    = 4
  cal(1)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%on, backsci%list%off /)
  cal(1)%name    = 'ROOR'
  ! RORO (detection RORO)
  det(2)%nsub    = 4
  det(2)%desc(:) = (/ backsci%list%off, backsci%list%on, backsci%list%off, backsci%list%on /)
  det(2)%name    = 'RORO'
  ! RORO (calibration RO)
  cal(2)%nsub    = 2
  cal(2)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  cal(2)%name    = 'RO'
  ! RO (fallback only, detection RO)
  det(3)%nsub    = 2
  det(3)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  det(3)%name    = 'RO'
  ! RO (fallback only, calibration RO)
  cal(3)%nsub    = 2
  cal(3)%desc(:) = (/ backsci%list%off, backsci%list%on, 0, 0 /)
  cal(3)%name    = 'RO'
  !
  ! --- Detection ---
  call detect_cycles(det,mcycle,jcycle,error)
  if (error)  return
  !
  ! --- Calibration ---
  !
  isub = 0
  ifirst = 1-cal(jcycle)%nsub
  ncycle = 0
  initcumul = .true.
  do while (isub.lt.backsci%list%nsub)
    !
    ! Get next cycle
    call mrtcal_find_next_subscancycle(backsci%list,cal(jcycle)%desc,  &
      cal(jcycle)%nsub,.true.,found,ifirst,isub,ncycle,error)
    if (error)  goto 10
    if (.not.found)  cycle
    !
    ! Produce ON-OFF for this cycle
    call mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,cal(jcycle)%nsub,  &
      subscanbuf,backcal,backsci,error)
    if (error)  goto 10
    !
    ! If requested, accumulate this result
    if (mrtset%out%accmode.eq.accmode_scan) then
      if (initcumul) then
        call mrtcal_chunkset_3d_accumulate_init(backsci%diff,cumul,error)
        if (error) goto 10
        initcumul = .false.
      endif
      ! backsci%diff has no weight yet. Give it some:
      call mrtcal_chunkset_3d_accumulate_setweight(backsci%diff,  &
        backsci%tscale,mrtset%out%weight,error)
      if (error)  goto 10
      call mrtcal_chunkset_3d_accumulate_do(backsci%diff,cumul,error)
      if (error)  goto 10
    endif
    !
  enddo
  !
  if (mrtset%out%accmode.eq.accmode_scan) then
    call mrtcal_write_toclass(cumul,mrtset%out,backsci%nobs,error)
    if (error)  goto 10
  endif
  !
  write(mess,'(A,I0,1X,A,A)')  'Calibrated ',ncycle,cal(jcycle)%name,' cycles'
  call mrtcal_message(seve%i,rname,mess)
  !
10 continue
  ! Cleaning
  call cumul%free(error)
  if (error)  continue
  !
contains
  subroutine detect_cycles(cycl,mcycl,found,error)
    use mrtcal_messaging
    !-------------------------------------------------------------------
    ! Detect which of the known cycles if used in the scan
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: mcycl
    type(cycle_t),   intent(in)    :: cycl(mcycl)
    integer(kind=4), intent(out)   :: found
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ncycl(mcycl),icycl
    !
    ncycl(:) = 0
    found = 0
    ! Try first ROOR and RORO
    do icycl=1,mcycl-1  ! Ignore last one for now
      call count_cycles(cycl(icycl),ncycl(icycl),error)
      if (error)  return
    enddo
    ! Which one is found?
    if (all(ncycl(1:mcycl-1).gt.0)) then
      call mrtcal_message(seve%e,rname,'Ambiguous subscan cycles')
      error = .true.
      return
    endif
    if (all(ncycl(1:mcycl-1).eq.0)) then
      ! Neither ROOR nor RORO were found. Try RO as last chance.
      call count_cycles(cycl(mcycl),ncycl(mcycl),error)  ! Try last one now
      if (error)  return
    endif
    do icycl=1,mcycl
      if (ncycl(icycl).gt.0) then
        found = icycl
        exit
      endif
    enddo
    if (found.eq.0) then
      call mrtcal_message(seve%e,rname,'No supported RO cycles found')
      error = .true.
      return
    endif
    write(mess,'(A,I0,1X,A,A)')  'Detected ',ncycl(found),cycl(found)%name,' cycles'
    call mrtcal_message(seve%i,rname,mess)
    !
  end subroutine detect_cycles
  !
  subroutine count_cycles(cycl,ncycle,error)
    !-------------------------------------------------------------------
    ! Count the number of subscan cycles
    !-------------------------------------------------------------------
    type(cycle_t),   intent(in)    :: cycl
    integer(kind=4), intent(out)   :: ncycle
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: isub,ifirst
    logical :: found
    !
    isub = 0
    ifirst = 1-cycl%nsub
    ncycle = 0
    do while (isub.lt.backsci%list%nsub)
      call mrtcal_find_next_subscancycle(backsci%list,cycl%desc,  &
        cycl%nsub,.false.,found,ifirst,isub,ncycle,error)
      if (error)  return
    enddo
  end subroutine count_cycles
  !
end subroutine mrtcal_iterate_subscancycle
!
subroutine mrtcal_find_next_subscancycle(sublist,swcycle,nswitch,  &
  verbose,found,ifirst,isub,ncycle,error)
  use imbfits_types
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_find_next_subscancycle
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(subscan_list_t), intent(in)    :: sublist
  integer(kind=4),      intent(in)    :: nswitch
  integer(kind=4),      intent(in)    :: swcycle(nswitch)
  logical,              intent(in)    :: verbose
  logical,              intent(out)   :: found
  integer(kind=4),      intent(inout) :: ifirst
  integer(kind=4),      intent(inout) :: isub
  integer(kind=4),      intent(inout) :: ncycle
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FIND>NEXT>SUBSCANCYCLE'
  logical :: notyetwarned,match
  integer(kind=4) :: iswitch
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Iterate internal counters
  isub = isub+1
  ifirst = ifirst+nswitch
  ! Initialize next cycle search
  found = .false.
  iswitch = 1
  notyetwarned = .true.
  !
  do
     ! Incomplete last / exit condition
     if (isub.gt.sublist%nsub) then
        if (iswitch.gt.1) then
           ! That's just a warning, *not* an error
           if (verbose)  &
             call mrtcal_message(seve%w,rname,'Incomplete last switch cycle')
        endif
        found = .false.
        return
     endif
     !
     ! Check switch kind
     match = sublist%onoff%bak(isub).eq.swcycle(iswitch)
     !
     if (match) then
        notyetwarned = .true.
        ! Expected switch number
        if (iswitch.eq.nswitch) then
          ! Completed a full cycle
          found = .true.
          ncycle = ncycle+1
          if (verbose) then
            write(mess,'(A,I0)') 'Found next cycle starting at ',ifirst
            call mrtcal_message(seve%i,rname,mess)
          endif
          return
        else
          ! Not yet a full cycle => Increment iswitch and subscan counters
          iswitch = iswitch+1
          isub = isub+1
        endif
     else
        ! Unexpected switch kind => Warn only once while searching for a new start of a complete cycle
        if (verbose) then
          if (notyetwarned) then
            write(mess,'(A,I0,A)') 'Incomplete or inconsistent switch cycle starting at ',  &
                  ifirst,' => Searching for start of next cycle'
            call mrtcal_message(seve%w,rname,mess)
            notyetwarned = .false.
          endif
          write(mess,'(A,I0,A,I0,A,I0,A)') 'Subscan #',isub,&
              ' has wrong switch type (',&
              sublist%onoff%bak(isub),' vs ',swcycle(iswitch),')'
          call mrtcal_message(seve%w,rname,mess)
        endif
        if (iswitch.gt.1) then
          ! We were in the middle of a cycle
          !   => Reset switch number to find start of next cycle
          ! The current subscan could be the start of this cycle
          !   => Do not increase the position counter in the subscan list
          iswitch = 1
        else
          ! Already searching for start of cycle
          !   => Just increase the position counter in the subscan list
          isub = isub+1
          ! norphan = norphan+1
        endif
        ifirst = isub
     endif ! Is the switch kind the expected one?
  enddo ! Infinite loop on subscans
  !
end subroutine mrtcal_find_next_subscancycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine check_fits_datapar(unit,ndata,addrecord, error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Check the DATAPAR-ALMATI table
  ! Return the length  of words of the data section ...
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: ndata                  !
  logical :: addrecord              !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: mf, nrows, tfields, varidat, status, ncorr, nauto, i
  integer :: nholo
  !
  ! 20 fields, 2 data tables per baseband
  integer :: mdatanum, colnum, nullval, r_npol
  integer :: ndatanum, nldump
  integer :: lc
  parameter (mf = 20,mdatanum=3, nullval=-1000)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  character(len=80) :: chain,comment
  logical :: anyf, datalog(mdatanum)
  integer :: not_found
  parameter (not_found=202)
  !------------------------------------------------------------------------------
  status = 0
  call ftghbn(unit,mf,nrows,tfields,ttype,tform,tunit,   &
    extname,varidat,status)
  !
  ! Header keywords: compute sixe of data area needed
  call ftgkyj(unit,'NO_CORR',ncorr,comment,status)
  if (status.eq.not_found) then
    ncorr = 0
  elseif (status.gt.0) then
    goto 99
  endif
  status = 0
  call ftgkyj(unit,'NO_AUTO',nauto,comment,status)
  if (status.eq.not_found) then
    nauto = 0
  elseif (status.gt.0) then
    goto 99
  endif
  status = 0
  call ftgkyj(unit,'NO_HOLO',nholo,comment,status)
  if (status.eq.not_found) then
    nholo = 0
  elseif (status.gt.0) then
    goto 99
  endif
  !
  r_nant = 1                   !!! ??? as a default
  call ftgkyj(unit,'NO_ANT',r_nant,comment,status)
  if (r_nant.gt.mnant) then
    call message(8,2,'CHECK_FITS_DATAPAR'   &
      ,'NO_ANT exceeds CLIC capacity')
    write(chain,'(a,i2,a,i2)') 'NO_ANT =',r_nant,' mnant ',mnant
    lc = lenc(chain)
    call message(6,2,'CHECK_FITS_DATAPAR',chain(1:lc))
    call message(8,2,'CHECK_FITS_DATAPAR',   &
      'Using first mnant antennas')
    r_nant = mnant
  endif
  r_nbas = max(r_nant*(r_nant-1)/2,1)
  do i=1, r_nbas
    r_iant(i) = antbas(1,i)
    r_jant(i) = antbas(2,i)
  enddo
  r_ldpar = 21 + (24+mwvrch)*r_nant + 11*r_nbas + 2*mrlband*mnant
  !c      R_LDPAR = 21 + 27*R_NANT + 11*R_NBAS
  call ftgkyj(unit,'NO_POL',r_npol,comment,status)
  call ftgkyj(unit,'NO_BAND',r_nband,comment,status)
  call ftgkyj(unit,'NO_CHAN',r_lntch,comment,status)
  call ftgkyj(unit,'NO_SIDE',r_nsb,comment,status)
  call ftgkyj(unit,'NO_PHCOR',r_ndatl,comment,status)
  r_lband = r_nband
  r_lnsb = r_nsb
  !
  if (ncorr.le.0 .and. nauto.gt.0) then
    if (nauto.gt.mdatanum) goto 98
    ndatanum = nauto
    r_lmode = 2
    r_ldatc = r_nband*r_nant*r_npol
    r_ldatl = r_lntch*r_nant*r_npol
    call ftgcno(unit,.false.,'AUTO',colnum,status)
    if (status.gt.0) goto 99
  elseif (ncorr.gt.0) then
    if (ncorr.gt.mdatanum) goto 98
    ndatanum = ncorr
    r_lmode = 1
    r_ldatc = 2*r_nband*r_nsb*r_nbas*r_npol
    r_ldatl = 2*r_lntch*r_lnsb*r_nbas*r_npol
    call ftgcno(unit,.false.,'CORR',colnum,status)
    if (status.gt.0) goto 99
  elseif (nholo.gt.0) then
    if (ncorr.gt.mdatanum) goto 98
    ndatanum = 1
    ! HOLO tables are treated as correlation in CLIC
    r_nant = 1
    r_nbas = 1
    r_lmode = 1
    ! forced to be DSB for compatibility ...
    r_nsb = 2
    r_lnsb = 2
    r_ldatc = 2*r_nband*r_nsb*r_nbas*r_npol
    r_ldatl = 2*r_lntch*r_lnsb*r_nbas*r_npol
    call ftgcno(unit,.false.,'HOLO',colnum,status)
    if (status.gt.0) goto 99
  else
    ndatanum = ncorr
    r_lmode = 1
    r_ldatc = 2*r_nband*r_nsb*r_nbas*r_npol
    r_ldatl = 2*r_lntch*r_lnsb*r_nbas*r_npol
    colnum = 0
  endif
  r_ldump = r_ldpar+r_ldatc
  !
  ndata = 0
  r_ndump = 0
  nldump = 0
  !
  do i=1, nrows
    if (colnum.ne.0) then
      call ftgcvl(unit,colnum,i,1,ndatanum,nullval,   &
        datalog,anyf,status)
      if (status.gt.0) then
        call fio_printerror('CHECK_FITS_DATAPAR','FTGCVL',   &
          status,error)
        return
      endif
    else
      ! patch
      datalog(1) = .true.
    endif
    ndata = ndata + r_ldpar
    if (datalog(1)) then
      r_ndump = r_ndump + 1
      ndata = ndata + r_ldatc
    elseif (datalog(2) .and. datalog(3)) then
      ndata = ndata + r_ldatc + r_ldatl
      if (r_ndatl.gt.1) then
        ndata = ndata + r_ldpar + r_ldatc + r_ldatl
      endif
      nldump = nldump + 1
    else
      call message(8,4,'CHECK_FITS_DATAPAR',   &
        'Unsupported data configuration')
    endif
  enddo
  !
  ! Force one average record for CLIC
  if (nldump.eq.0) then
    ndata = ndata + r_ldpar
    ndata = ndata + r_ldatc + r_ldatl
    if (r_ndatl.gt.1) then
      ndata = ndata + r_ldpar + r_ldatc + r_ldatl
    endif
    addrecord = .true.
  else
    addrecord = .false.
  endif
  return
  !
98 call message(8,4,'CHECK_FITS_DATAPAR',   &
    'Too many tables per baseband')
  error = .true.
  return
  !
99 call printerror('CHECK_FITS_DATAPAR',status)
  call message(6,2,'CHECK_FITS_DATAPAR',   &
    'Last comment was: '//comment)
  error = .true.
  return
end subroutine check_fits_datapar

subroutine gdf_update_image(imag,array,error)
  use gildas_def
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_update_image
  use gio_params
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API Routine
  !     Save an image structure and the specified data on the image file
  !     This version is for updating an existing file
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag      ! Image descriptor
  real,         intent(in)    :: array(*)  ! Data to be written
  logical,      intent(inout) :: error     ! Flag
  ! Local
  integer :: islo
  !
  call gio_geis (islo,error)
  if (error) return
  imag%loca%islo = islo
  !
  ! Open image
  imag%status = code_write_data
  call gio_wris (islo,imag%char%type,imag%file,imag%gil%form, &
       & imag%loca%size,error)
  if (error) then
    call gio_message(seve%e,'GDF_UPDATE_IMAGE','Cannot update output file')
    call gio_fris(islo,error)
    return
  endif
  !
  ! Associate pre-defined memory area to image
  imag%loca%addr = locwrd(array)
  call gio_pums (imag%loca%mslo,islo,imag%blc,imag%trc,imag%loca%addr,  &
  imag%gil%form,error)
  if (error) then
    call gio_fris(islo,error)
    return
  endif
  !
  ! Dump to disk
  call gio_fris(islo,error)
  if (.not.error) imag%status = 0
end subroutine gdf_update_image
!
subroutine gdf_write_image(imag,array,error)
  use gildas_def
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_write_image
  use gio_params
  !---------------------------------------------------------------------
  ! @ public 
  ! GDF API routine
  !     Save an image structure and the specified data on the image file
  !     This version is to create a new file
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag      ! Image descriptor
  real,         intent(in)    :: array(*)  ! Data array
  logical,      intent(inout) :: error     ! Flag
  ! Local
  character(len=*), parameter :: rname = 'GDF_WRITE_IMAGE'
  character(len=filename_length) :: fich
  integer :: i, islo
  !
  imag%status = code_write_header
  fich = imag%file
  call sic_parsef(fich,imag%file,' ','.gdf')
  call gio_geis (islo,error)
  if (error) return
  imag%loca%islo = islo
  !
  ! Use the proper routine here
  call gio_write_header(imag,islo,error)
  if (error) return
  !
  imag%loca%size = 1
  do i=1,imag%gil%ndim
    imag%loca%size = imag%loca%size*imag%gil%dim(i)
  enddo
  !
  ! Create image
  imag%status = code_write_data
  call gio_cris (islo,imag%char%type,imag%file,imag%gil%form, &
       & imag%loca%size,error)
  if (error) then
    call gio_message(seve%e,'GDF_WRITE_IMAGE','Cannot create output file')
    call gio_fris(islo,error)
    return
  endif
  !
  ! For UV Data, use specialized routine
  if (abs(imag%gil%type_gdf).eq.abs(code_gdf_uvt)) then
    if (any(imag%blc.ne.0) .or. any(imag%trc.ne.0)) then
      call gio_message(seve%w,rname,'Writing subset of UV data, not tested')
      !
      ! Associate pre-defined memory area to image
      imag%loca%addr = locwrd(array)
      call gio_pums (imag%loca%mslo,islo,imag%blc,imag%trc,imag%loca%addr,  &
      imag%gil%form,error)
    else
       call gdf_write_uvall(imag,array,error)
   endif
  else
    !
    ! Associate pre-defined memory area to image
    imag%loca%addr = locwrd(array)
    call gio_pums (imag%loca%mslo,islo,imag%blc,imag%trc,imag%loca%addr,  &
    imag%gil%form,error)
  endif
  !
  if (error) then
    call gio_fris(islo,error)
    return
  endif
  !
  ! Free image slot & Dump to disk
  call gio_fris(islo,error)
  if (.not.error) imag%status = 0
end subroutine gdf_write_image
!
subroutine gdf_open_image(imag,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_open_image
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !     Open an image structure on the requested file for writing
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag   ! Image descriptor
  logical,      intent(inout) :: error  ! Flag
  ! Local
  character(len=filename_length) :: fich
  integer :: islo
  !
  imag%status = code_write_header
  fich = imag%file
  call sic_parsef(fich,imag%file,' ','.gdf')
  call gio_geis (islo,error)
  if (error) return
  call gio_wris (islo,imag%char%type,imag%file,imag%gil%form,imag%loca%size,  &
  error)
  if (error) then
    call gio_message(seve%e,'GDF_OPEN_IMAGE','Cannot open input file')
    call gio_fris(islo,error)
    return
  endif
  imag%status = 0
  imag%loca%islo = islo
end subroutine gdf_open_image
!
subroutine gdf_create_image(imag,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_create_image
  use gio_params
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API Routine
  !     Create an image structure on the requested file
  !     Nothing is written yet to the file.
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag   ! Image descriptor
  logical,      intent(inout) :: error  ! Flag
  ! Local
  character(len=*), parameter :: rname='GDF_CREATE_IMAGE'
  character(len=filename_length) :: fich
  integer :: i, islo
  !
  imag%status = code_write_header
  call gio_geis (islo,error)
  if (error) return
  imag%loca%islo = islo
  !
  if (imag%file.eq.'') then
    call gio_message(seve%e,rname,'Empty file name')
    error = .true.
    return
  endif
  fich = imag%file
  call sic_parsef(fich,imag%file,' ','.gdf')
  !
  ! Use the proper routine here
  call gio_write_header(imag,islo,error)
  if (error) return
  !
  imag%loca%size = 1
  do i=1,imag%gil%ndim
    imag%loca%size = imag%loca%size*imag%gil%dim(i)
  enddo
  !
  ! Create image
  imag%status = code_write_data
  call gio_cris (islo,imag%char%type,imag%file,imag%gil%form, &
       & imag%loca%size,error)
  if (error) then
    call gio_message(seve%e,rname,'Cannot create output file')
    call gio_fris(islo,error)
    return
  endif
  !
  imag%loca%getvm = .false.
  imag%status = 0
end subroutine gdf_create_image
!
subroutine gdf_close_image(imag,error)
  use gio_interfaces, except_this=>gdf_close_image
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Close an image structure. No further READ allowed on this image
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag   ! Image descriptor
  logical,      intent(inout) :: error  ! Flag
  ! Local
  integer :: islo
  !
  islo = imag%loca%islo
  imag%status = code_free_image
  if (gdf_stis(islo).eq.-1) then
    call gio_message(seve%e,'GDF_CLOSE_IMAGE','No such image '//trim(imag%file))
    error = .true.
    return
  endif
  call gio_fris(islo,error)
  !
  ! Set the image slot to Undefined
  imag%loca%islo = 0
  imag%status = 0
  !
  ! Leave the error status as it was.
  !! error = .false.
end subroutine gdf_close_image
!

module gchar_interfaces_public
  interface
    subroutine vstrin(nchar,string,drawit,slengt,xp,yp,angle,ifont,size,  &
      doclip,gpoly_noclip,gpoly_clip)
      use gildas_def
      use phys_const
      use gchar_variables
      !---------------------------------------------------------------------
      ! @ public
      !
      !	Interprets a string of character with escape sequences
      !	\P or \\P  and plots out the characters according to
      !	current font quality SIMPLEX or DUPLEX
      !
      !	If the shareable common is not initialised, VSTRING attempts
      !	to initialise it using VSINIT. Just do not forget to assign
      !	properly the CHAR_FONT logical name to your GREGFONT.BIN file
      !	when you run a non-shareable image.
      !
      !	The reference point is located at the left of the string, and
      !	at middle in height. To append a second string, just move the
      !	reference point as following before calling again VSTRING :
      !		...
      !		CO = COS(ANGLE*PI/180.)
      !		SI = SIN(ANGLE*PI/180.)
      !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
      !		XP = XP + CO*SLENGT
      !		YP = YP + SI*SLENGT
      !		CALL VSTRING (..., SLENGT, XP, YP, ANGLE, ...)
      !
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: nchar         ! String length
      character(len=*), intent(in)  :: string        ! String to be drawn
      logical,          intent(in)  :: drawit        ! Draw string or compute length ?
      real(kind=4),     intent(out) :: slengt        ! Length of string in centimeters
      real(kind=4),     intent(in)  :: xp            ! Abscissa of reference point
      real(kind=4),     intent(in)  :: yp            ! Ordinate of reference point
      real(kind=4),     intent(in)  :: angle         ! Angle (Degrees)
      integer(kind=4),  intent(in)  :: ifont         ! Quality 0=Simplex 1=Duplex
      real(kind=4),     intent(in)  :: size          ! Character size
      logical,          intent(in)  :: doclip        ! Clip with current Greg box?
      external                      :: gpoly_noclip  !
      external                      :: gpoly_clip    !
      interface
        subroutine gpoly_noclip(n,vx,vy,error)
          integer, intent(in)    :: n      ! Number of points
          real*4,  intent(in)    :: vx(n)  ! Array of abscissae
          real*4,  intent(in)    :: vy(n)  ! Array of ordinates
          logical, intent(inout) :: error  ! Logical error flag
        end subroutine gpoly_noclip
        subroutine gpoly_clip(nq,xq,yq)
          use gildas_def
          integer(kind=size_length), intent(in) :: nq     ! Number of points
          real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
          real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
        end subroutine gpoly_clip
      end interface
    end subroutine vstrin
  end interface
  !
  interface
    subroutine gchar_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gchar_message_set_id
  end interface
  !
  interface
    subroutine hershey2gag(file)
      use gchar_variables
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Build of the GREG character set from the HERSHEY one
      !
      ! Organisation :
      !	2 Quality of characters
      !		1 FAST		2 DUPLEX
      !	3 Set of characters per quality
      !		1 ROMAN		2 GREEK		3 SCRIPT
      ! 	95 Characters per set
      !
      ! Addressing is based on the ASCII code of the character:
      ! INDEX = ICHAR(caractere) - ICHAR(' ') + 1 + 100*(NJEU-1) + 300*(NQUAL-1)
      !---------------------------------------------------------------------
      character(len=*) :: file          !
    end subroutine hershey2gag
  end interface
  !
end module gchar_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_obstype_equal(filename,imbf,obstype,equal,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_obstype_equal
  !---------------------------------------------------------------------
  ! @ private
  ! Read the bare minimum as reading all the main hdus may take forever
  ! on large imbfitsfile.
  ! This could be a generic subroutine imbfits_equal. *** JP
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename
  type(imbfits_t),  intent(inout) :: imbf
  character(len=*), intent(in)    :: obstype
  logical,          intent(out)   :: equal
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OBSTYPE>EQUAL'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  call imbfits_reopen_file(filename,imbf%file,imbf%hdus,error)
  if (error) return
  call imbfits_read_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  if (imbf%primary%obstype%val.ne.'calibrate') then
     call imbfits_message(seve%w,rname,trim(imbf%primary%obstype%val)//' is not a calibration scan')
     equal = .false.
  else
     equal = .true.
  endif
  !
end subroutine imbfits_obstype_equal
!
subroutine imbfits_check_version(version,error)
  use gbl_message
  use imbfits_parameters
  use imbfits_interfaces, except_this => imbfits_check_version
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: version
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>CHECK>VERSION'
  character(len=message_length) :: mess
  !
  if (version.lt.imbfits_version_min .or.  &
      version.ge.imbfits_version_max) then
    write(mess,'(A,F4.2,A)')  &
      'Version ',version,' of IMBFITS is not supported'
    call imbfits_message(seve%e,rname,mess)
    write(mess,'(A,F4.2,A,F4.2,A)')  &
      'Support starts at ',imbfits_version_min,  &
      ', up to ',imbfits_version_max,' (excluded)'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
end subroutine imbfits_check_version
!
subroutine imbfits_check_header_primary(file,primary,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_primary
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_file_t),    intent(in)    :: file
  type(imbfits_primary_t), intent(in)    :: primary
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>PRIMARY'
  character(len=message_length) :: mess
  !
! Computing NHDU with FTTHDU is highly unefficient => not available.
!   if (primary%n_obsp%val*3.ne.(file%nhdu-hdustart)) then
!     ! 3 extensions per subscan: backend, antenna, subreflector
!     ! Warning only?
!     write(mess,'(A,I0,A,I0)')  &
!       'File is inconsistent: found ',file%nhdu,  &
!       ' HDUs, expected ',hdustart+primary%n_obsp%val*3
!     call imbfits_message(seve%e,rname,mess)
!     error = .true.
!     return
!   endif
  !
  if (primary%n_obs%val.ne.primary%n_obsp%val) then
    ! Warning only
    write (mess,'(A,I0,A,I0,A)')  &
      'File is incomplete (',primary%n_obsp%val,'/',  &
      primary%n_obs%val,' subscans)'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
end subroutine imbfits_check_header_primary
!
subroutine imbfits_check_header_scan(primary,scan,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_scan
  !---------------------------------------------------------------------
  ! @ private
  ! Check the consistency of the IMBF-scan HDU
  !---------------------------------------------------------------------
  type(imbfits_primary_t), intent(in)    :: primary
  type(imbfits_scan_t),    intent(in)    :: scan
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>SCAN'
  !
  ! Nothing relevant to be tested.
  !
end subroutine imbfits_check_header_scan
!
subroutine imbfits_check_header_backend(back,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_header_backend
  !---------------------------------------------------------------------
  ! @ private
  ! Check the consistency of the IMBF-backend HDU
  ! *** JP Nothing done right now because previous test was too much
  !        restrictive. It is unclear whether this function is needed.
  !        Leave it for the time being.
  !---------------------------------------------------------------------
  type(imbfits_back_t), intent(in)    :: back
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHECK>HEADER>BACKEND'
  !
end subroutine imbfits_check_header_backend
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	subroutine backtrans(image,nimage,points,temp,npts,blanking,
     &         rms,npix1,npix2,npix3,refpix,val,inc)
	real*4 refpix(3),val(3),inc(3)
	integer(kind=4), intent(in) :: nimage
	real*4 image (nimage), points(3,nimage)
	real*4 temp(npix1,npix2,npix3)

	do 1 i=1,npix1
	do 1 j=1,npix2
	do 1 k=1,npix3
1	temp(i,j,k)=blanking

	do 2 l=1,npts
	x=points(1,l)
	y=points(2,l)
	z=points(3,l)
	i=nint((x-val(1))/inc(1)+refpix(1))
	j=nint((y-val(2))/inc(2)+refpix(2))
	k=nint((z-val(3))/inc(3)+refpix(3))
2	temp(i,j,k)=image(l)*rms

	return
	end

subroutine write_sdm_ConfigDescription(holodata, tpOnly, error)
  !---------------------------------------------------------------------
  ! Write the ConfigDescription SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_configDescription
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical :: holodata, tpOnly, error
  ! Local
  ! Three Rows, spectral, continuum, totalpower
  type (ConfigDescriptionKey) :: cdKey(3)
  type (ConfigDescriptionRow) :: cdRow(3)
  type (ConfigDescriptionOpt) :: cdOpt
  integer, parameter :: mdd=mrlband*msideband*2
  integer :: ier, i, k, ia, isb, ilc, ic, ivc, ContDdListDim,   &
    numPhasedArrayList, numSwitchCycle(3), numNumSubBand,   &
    numDataDescription(3), irow, iautosb, numApc
  character, parameter  :: sdmTable*20='ConfigDescription'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  !     Normal case (correlator data).
  !
  if (.not. holodata) then
    if (r_lmode.eq.1) then     ! correlation
      numDataDescription(1) = v_lband*r_lnsb
      numDataDescription(2) = v_lband*r_lnsb
    elseif (r_lmode.eq.2) then ! Autocorrelation
      numDataDescription(1) = v_lband*1
      numDataDescription(2) = v_lband*1
    endif
    numDataDescription(3) = 1
    numPhasedArrayList = 1
    !     the numSwitchCycle should be equal to the number of basebands
    !     no now this is the number of data description
    !         numSwitchCycle = numDataDescription
    numNumSubBand = r_lnsb
    ! check which side band to define for autocorrelations.
    if (r_isb .eq.1) then
      iautosb = 1
    else
      iautosb = 2
    endif
    do irow = 1, 3
      if (numDataDescription(irow).gt.0) then
        cdRow(irow)%numAntenna = r_nant
        cdRow(irow)%numFeed = 1
        !
        ! atm phase corrections...
        if ( irow.eq.1) then   ! line
          if (r_ndatl.eq.0) then
            numApc = 1
            else if (r_ndatl.eq.1) then
            numApc = 1
            else if (r_ndatl.eq.2) then
            numApc = 2
          endif
        else
          numApc = 1
        endif
        cdRow(irow)%numDataDescription = numDataDescription(irow)
        cdRow(irow)%numAtmPhaseCorrection = numApc
        call allocConfigDescriptionRow(cdRow(irow), error)
        if (error) return
        !
        !     internal: corr_num = number of results, corr_modes = results, with
        !     1 corr, 2 for auto.
        !
        if (r_lmode.eq.1) then ! correlation
          cdRow(irow)%correlationMode =   &
            CorrelationMode_CROSS_ONLY
        elseif (r_lmode.eq.2) then ! auto correlation only
          cdRow(irow)%correlationMode =   &
            CorrelationMode_AUTO_ONLY
        elseif (r_lmode.eq.3) then ! auto correlation and correlation (some day),
          !  ... or ALMA data
          cdRow(irow)%correlationMode =   &
            CorrelationMode_CROSS_AND_AUTO
        endif
       do ia = 1, r_nant
          cdRow(irow)%antennaId(ia) = Antenna_Id(ia)
          !     may be put actual flag info there?
          cdRow(irow)%feedId(ia)  = 0
        enddo
        do i=1, numDataDescription(irow)
          cdRow(irow)%switchCycleId(i) = switchCycle_Id
        enddo
        !
        !     This is the configuration with both channel averages and spectra.
        !     loop on cont/line subbands, spectral  subbands (=basebands), basebands
        !
        !     The order is supposed to match the one in the binary header file
        !     (where every thing is grouped by baseband)
        !
        !     keep the indices in dd_isb, dd_ilc, dd_ic so that the binaries are
        !     in the right order.
        if (irow.eq.1) then
          i = 0
          ilc = 2
          cdRow(irow)%spectralType = SpectralResolutionType_FULL_RESOLUTION
          cdRow(irow)%processorType = ProcessorType_CORRELATOR 
          do ivc = 1, v_lband
            if (r_lmode.eq.1) then ! correlation
              do isb = 1, r_lnsb
                i = i+1
                cdRow(irow)%dataDescriptionId(i) =   &
                  DataDescription_Id(isb, ivc, ilc)
                cont_list(i) = .false. !! ilc.eq.1
              enddo
              if (r_ndatl.eq.0) then
                cdRow(irow)%atmPhaseCorrection   &
                  =AtmPhaseCorrection_AP_UNCORRECTED
                else if (r_ndatl.eq.1) then
                cdRow(irow)%atmPhaseCorrection   &
                  =AtmPhaseCorrection_AP_CORRECTED
                else if (r_ndatl.eq.2) then
                cdRow(irow)%atmPhaseCorrection =(/   &
                  AtmPhaseCorrection_AP_UNCORRECTED   &
                  ,AtmPhaseCorrection_AP_CORRECTED/)
              end if
            !     if autocorrelation, only one sideband...
            elseif (r_lmode.eq.2) then ! auto correlation only
              i = i+1
              !!! check which one!
              isb = iautosb
              cdRow(irow)%dataDescriptionId(i) =   &
                DataDescription_Id(isb, ivc, ilc)
              cdRow(irow)%atmPhaseCorrection   &
                =AtmPhaseCorrection_AP_UNCORRECTED
            endif
          enddo
          cdRow(irow)%processorId = processor_Id
        elseif (irow.eq.2) then
          ilc = 1
          cdRow(irow)%spectralType = SpectralResolutionType_CHANNEL_AVERAGE
          cdRow(irow)%processorType = ProcessorType_CORRELATOR 
          i = 0
          !                  do ic = 1, r_lband
          do ivc = 1, v_lband
            if (r_lmode.eq.1) then ! correlation
              do isb = 1, r_lnsb
                i = i+1
                cdRow(irow)%dataDescriptionId(i) =   &
                  DataDescription_Id(isb, ivc, ilc)
              enddo
            !     if autocorrelation, only one sideband...
            elseif (r_lmode.eq.2) then ! auto correlation only
              i = i+1
              isb = iautosb
              cdRow(irow)%dataDescriptionId(i) =   &
                DataDescription_Id(isb, ivc, ilc)
            endif
          enddo
          cdRow(irow)%processorId = processor_Id
          cdRow(irow)%atmPhaseCorrection =   &
            AtmPhaseCorrection_AP_UNCORRECTED
        else
          cdRow(irow)%spectralType = SpectralResolutionType_BASEBAND_WIDE
          cdRow(irow)%processorType = ProcessorType_RADIOMETER 
          cdRow(irow)%dataDescriptionId(1) =   &
            TotPowDataDescription_Id
          !!cdRow(irow)%numSubBand = 1
          cdRow(irow)%correlationMode = 1
          cdRow(irow)%processorId = totPowProcessor_Id
          cdRow(irow)%atmPhaseCorrection =   &
            AtmPhaseCorrection_AP_UNCORRECTED
        endif
        !
        call addConfigDescriptionRow(cdKey(irow), cdRow(irow),   &
          error)
        if (error) return
        if (irow.eq.1) then
          configDescription_Id = cdKey(irow)%configDescriptionId
        elseif (irow.eq.2) then
          contconfigDescription_Id = cdKey(irow   &
            )%configDescriptionId
        else
          TotPowConfigDescription_Id = cdKey(irow   &
            )%configDescriptionId
        endif
      else
        if (irow.eq.1) then
          configDescription_Id = -1
        elseif (irow.eq.2) then
          contConfigDescription_Id = -1
        endif
      endif
    enddo
    !
    ! New: add the associations
    ! this should be more exact. we may add meaningless data there in some cases...
    if (.not. tpOnly) then
!!!       call allocConfigDescriptionOpt(cdRow(1), cdOpt, cdRow(1)%numAntenna,   &
!!!         error)
      cdOpt%numAssocValues = 2
      call allocConfigDescriptionOpt(cdRow(1), cdOpt, error)
      if (configDescription_Id.ge.0) then
        cdOpt%assocConfigDescriptionId(1) =   &
          contConfigDescription_Id
        cdOpt%assocNature(1) =   &
          SpectralResolutionType_CHANNEL_AVERAGE
        cdOpt%assocConfigDescriptionId(2) =   &
          TotPowConfigDescription_Id
        cdOpt%assocNature(2) =   &
          SpectralResolutionType_BASEBAND_WIDE
        call addConfigDescriptionAssocConfigDescriptionId(cdKey(1   &
          ),cdOpt, error)
        call addConfigDescriptionAssocNature(cdKey(1),   &
          cdOpt, error)
        call addConfigDescriptionNumAssocValues(cdKey(1),   &
          cdOpt, error)
      endif
      if (contConfigDescription_Id.ge.0) then
        cdOpt%assocConfigDescriptionId(1) = ConfigDescription_Id
        cdOpt%assocNature(1) =   &
          SpectralResolutionType_FULL_RESOLUTION
        cdOpt%assocConfigDescriptionId(2) =   &
          TotPowConfigDescription_Id
        cdOpt%assocNature(2) =   &
          SpectralResolutionType_BASEBAND_WIDE
        call addConfigDescriptionAssocConfigDescriptionId(cdKey(2   &
          ),cdOpt, error)
        call addConfigDescriptionAssocNature(cdKey(2),   &
             cdOpt, error)
        call addConfigDescriptionNumAssocValues(cdKey(2),   &
          cdOpt, error)
      endif
      irow = 0
      if (configDescription_Id.ge.0) then
        irow = irow+1
        cdOpt%assocConfigDescriptionId(irow) =   &
          ConfigDescription_Id
        cdOpt%assocNature(irow) =   &
          SpectralResolutionType_FULL_RESOLUTION
      endif
      if (contconfigDescription_Id.ge.0) then
        irow = irow+1
        cdOpt%assocConfigDescriptionId(irow) =   &
          contConfigDescription_Id
        cdOpt%assocNature(irow) =   &
          SpectralResolutionType_CHANNEL_AVERAGE
      endif
      if (irow.gt.0) then
        call addConfigDescriptionAssocConfigDescriptionId(cdKey(3   &
          ),cdOpt, error)
        call addConfigDescriptionAssocNature(cdKey(3),   &
          cdOpt, error)
        call addConfigDescriptionNumAssocValues(cdKey(3),   &
          cdOpt, error)
      endif
    endif
  !
  !     Special case for Holography data:
  !
  else
    !
    !     There is a single data description and a single spectral window.
    numDataDescription(1) = 1
    numPhasedArrayList = 1
    !     the numSwitchCycle should be equal to the number of basebands
    numSwitchCycle = 1
    numNumSubBand = 1
    ! check which side band to define for autocorrelations.
    if (r_isb .eq.1) then
      iautosb = 1
    else
      iautosb = 2
    endif
    irow = 1
    cdRow(irow)%numAntenna = r_nant
    cdRow(irow)%numFeed = 1
    cdRow(irow)%numDataDescription = 1
    cdRow(irow)%numAtmPhaseCorrection = 1
    numApc = 1
    !$$$         call allocConfigDescriptionRow(cdRow(irow), cdRow(irow)
    !$$$     &        %numAntenna, numDataDescription(irow), cdRow(irow)
    !$$$     &        %numFeed, numPhasedArrayList, numSwitchCycle,
    !$$$     &        numNumSubBand , numApc, error)
!!!     call allocConfigDescriptionRow(cdRow(irow), cdRow(irow)   &
!!!       %numAntenna, numDataDescription(irow), cdRow(irow)   &
!!!       %numFeed, numPhasedArrayList, numNumSubBand , numApc,   &
!!!       error)
    call allocConfigDescriptionRow(cdRow(irow), error)
    if (error) return
    !
    !     one SubBand for line, one for continuum ...
    !! cdRow(irow)%numSubBand(1)  =  1
    !
    !     *TBD* The correlatio-only mode is not assumed to be present for
    !     ALMA !
    !
    !     internal: corr_num = number of results, corr_modes = results, with
    !     1 corr, 2 for auto.
    !
    cdRow(irow)%atmPhaseCorrection = AtmPhaseCorrection_AP_UNCORRECTED
    cdRow(irow)%correlationMode = 0
    do ia = 1, r_nant
      cdRow(irow)%antennaId(ia) = Antenna_Id(ia)
      !     may be put actual flag info there?
      ! OPTIONAL IN SS2 ...            cdRow(irow)%flagAntenna(ia) = .false.
      cdRow(irow)%feedId(ia)  = 0
    enddo
    cdRow(irow)%atmPhaseCorrection =   &
      AtmPhaseCorrection_AP_UNCORRECTED
    do i=1, r_lband
      cdRow(irow)%switchCycleId(i) = switchCycle_Id
    enddo
    !
    cdRow(irow)%dataDescriptionId(1) =   &
      TotPowDataDescription_Id
    !$$$         sb_list(1) = isb
    !$$$         bb_list(1) = ic
    !$$$         cont_list(1) = .false. !! ilc.eq.1
    cdRow(irow)%processorId = totPowProcessor_Id
    !
    call addConfigDescriptionRow(cdKey(1), cdRow(irow), error)
    if (error) return
    configDescription_Id = cdKey(1)%configDescriptionId
  endif
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
!
end subroutine write_sdm_ConfigDescription
!---------------------------------------------------------------------
subroutine get_sdm_ConfigDescriptionModes(nmodes,modes,   &
    assocFullResolutionID, assocBasebandWideID,   &
    assocChannelAverageID, error)
  !---------------------------------------------------------------------
  !     Get the ConfigDescription SDM table: as a first pass we get only
  !     the number of clic r_modes (auto/cross)
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_configDescription
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  integer :: nmodes, modes(2), assocFullResolutionID,   &
    assocBasebandWideID, assocChannelAverageID
  logical error
  ! Local
  type (ConfigDescriptionKey) :: cdKey
  type (ConfigDescriptionRow) :: cdRow
  type (ConfigDescriptionOpt) :: cdOpt
  !      integer :: ier, ia, isb, ilc, ic, i
  logical::  present
  integer :: k
  integer, parameter :: mapc=2
  character, parameter :: sdmTable*24='ConfigDescription(Modes)'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  cdRow%numAntenna = mnant
  cdRow%numFeed = 1
  cdRow%numDataDescription = mrlband
  cdRow%numAtmPhaseCorrection = mapc
  call allocConfigDescriptionRow(cdRow, error)
  if (error) return
  cdOpt%numAssocValues = 1
  call allocConfigDescriptionOpt(cdRow, cdOpt, error)
  if (error) return
  cdKey%configDescriptionId = configDescription_Id
  call getConfigDescriptionRow(cdKey, cdRow, error)
  if (error) then
    print *, '!! cdKey%configDescriptionId = '   &
      ,cdKey%configDescriptionId, '  !!'
  endif
  if (error) return
  if (cdRow%correlationMode.eq.CorrelationMode_CROSS_ONLY) then
    nmodes = 1
    modes = 1
  elseif (cdRow%correlationMode.eq.CorrelationMode_AUTO_ONLY) then
    nmodes = 1
    modes = 2
  else
    nmodes = 2
    modes = (/ 1, 2 /)
  endif
  processor_Id = cdRow%processorId
  ! return three possible associations (two only may be there).
  assocFullResolutionID = -1
  assocBasebandWideID = -1
  assocChannelAverageID = -1
  call getConfigDescriptionNumAssocValues(cdKey, cdOpt, present, error)
  if (present) then
    call getConfigDescriptionAssocConfigDescriptionId(cdKey, cdOpt,   &
    present, error)
    call getConfigDescriptionAssocNature(cdKey, cdOpt, present, error)
    !print *, present, cdOpt%AssocNature
    !! This is a patch as in is omitted in 6.1.0 asdms.
    if (.not.present) then
      do k=1, cdOpt%numAssocValues
        cdOpt%AssocNature(k) = SpectralResolutionType_CHANNEL_AVERAGE
      enddo
    endif
    do k=1, cdOpt%numAssocValues
      select case(cdOpt%AssocNature(k))
      case(SpectralResolutionType_FULL_RESOLUTION)
        assocFullResolutionID =  cdOpt%AssocConfigDescriptionId(k)
      case(SpectralResolutionType_BASEBAND_WIDE)
        assocBasebandWideID =  cdOpt%AssocConfigDescriptionId(k)
      case(SpectralResolutionType_CHANNEL_AVERAGE)
        assocChannelAverageID = cdOpt%AssocConfigDescriptionId(k)
      end select
    enddo
  endif
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_ConfigDescriptionModes
!---------------------------------------------------------------------
subroutine get_sdm_ConfigDescription(error)
  !---------------------------------------------------------------------
  ! Get the ConfigDescription SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_configDescription
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (ConfigDescriptionKey) :: cdKey
  type (ConfigDescriptionRow) :: cdRow
  integer :: ier, ia, isb, ilc, ic, i
  integer, parameter :: mapc=2
  character, parameter :: sdmTable*20='ConfigDescription'
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  cdRow%numAntenna = mnant
  cdRow%numFeed = 1
  cdRow%numDataDescription = mrlband
  cdRow%numAtmPhaseCorrection = mapc
  call allocConfigDescriptionRow(cdRow, error)
  if (error) return
  !
  do i=1, cdRow%numDataDescription
    cdRow%dataDescriptionId(i) = -1
  enddo
  cdRow%atmPhaseCorrection = -1
  cdKey%configDescriptionId = configDescription_Id
  call getConfigDescriptionRow(cdKey, cdRow, error)
  if (error) then
    print *, '!! cdKey%configDescriptionId = '   &
         ,cdKey%configDescriptionId, '  !!  '
  endif
  if (error) return
  processor_Id = cdRow%processorId
  switchCycle_Id = cdRow%switchCycleId(1)
  if (r_nant.le.0) then
    r_nant = cdRow%numAntenna
  elseif ( cdRow%numAntenna.ne.r_nant) then
    call sdmMessageI(8,3,sdmTable, 'Wrong numAntenna '   &
      ,cdRow%numAntenna)
    goto 99
  endif
  if (cdRow%numFeed.gt.1) then
    call sdmMessageI(8,2,sdmTable, 'Wrong numFeed (for CLIC) '   &
      ,cdRow%numFeed)
  endif
  do i = 1, r_nant
    antenna_Id(i) = cdRow%antennaId(i)
  enddo
  ddId_size = 0
  do i = 1,  cdRow%numDataDescription
    if (cdRow%dataDescriptionId(i).ge.0) then
      ddId_size = ddId_size+1
      ddId_List(ddId_size) = cdRow%dataDescriptionId(i)
    endif
  enddo
  !!print *, 'cdRow%correlationMode, CorrelationMode_CROSS_ONLY ', & 
  !!     cdRow%correlationMode, CorrelationMode_CROSS_ONLY
  if ((cdRow%correlationMode.eq.CorrelationMode_CROSS_ONLY .and. r_lmode.ne.1) .or.   &
    (cdRow%correlationMode.eq.CorrelationMode_AUTO_ONLY .and. r_lmode.ne.2)) then
    call sdmMessageI(6,2,sdmTable,   &
      'Wrong correlationMode (for CLIC) ',cdRow%correlationMode)
    call sdmMessage(6,2,sdmTable,'Programming error?')
    if (cdRow%correlationMode.eq.CorrelationMode_CROSS_ONLY)  r_lmode=1
    if (cdRow%correlationMode.eq.CorrelationMode_AUTO_ONLY)  r_lmode=2
  endif
  ! TODO get actual flags from flagAntenna
  !     do ia = 1, r_nant
  !         phasedArrayList(ia) = -1
  !         flagAntenna(ia) = .false. ! may be put actual flag info there?
  !         feedList(ia)  = 0
  !      enddo
  if (cdRow%numAtmPhaseCorrection.ge.1) then
    r_ndatl = 2
  elseif (cdRow%atmPhaseCorrection(1).eq.   &
    AtmPhaseCorrection_AP_CORRECTED) then
    r_ndatl = max(r_ndatl,1)
  elseif (cdRow%atmPhaseCorrection(1).eq.   &
    AtmPhaseCorrection_AP_UNCORRECTED) then
    r_ndatl = max(r_ndatl,1)
  else
    call sdmMessageI(8,3,sdmTable,   &
      'Wrong atmPhaseCorrection (for CLIC) ',   &
      cdRow%atmPhaseCorrection)
    goto 99
  endif
  !$$$      print *, ddId_size, ' data description Ids ', (ddId_List(i), i=1,
  !$$$     &     ddId_size)
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_ConfigDescription

subroutine fits_gildas_sub(iname,oname,style,blc,trc,khdu,check,overwrite,error,  &
  getsymbol,wpr)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fits_gildas_sub
  use gio_params
  use gio_xy
  use gio_fitsdef
  use gbl_message
  !--------------------------------------------------------------------
  ! @ public
  ! GIO FITS interface
  ! Convert a FITS file to a GDF file
  !--------------------------------------------------------------------
  character(len=*),           intent(in)    :: iname      ! Input FITS file
  character(len=*),           intent(in)    :: oname      ! Output GILDAS file
  character(len=*),           intent(in)    :: style      ! FITS style
  integer(kind=index_length), intent(in)    :: blc(:)     ! Bottom Left Corner
  integer(kind=index_length), intent(in)    :: trc(:)     ! Top Right Corner
  integer(kind=4),            intent(in)    :: khdu       ! HDU number (1=Primary)
  logical,                    intent(in)    :: check      ! Echo keywords ?
  logical,                    intent(in)    :: overwrite  ! Overwrite existing output file?
  logical,                    intent(inout) :: error      ! Returned error code
  external                                  :: getsymbol  ! Translate FITS keyword
  external                                  :: wpr        ! Ask a question if unknown
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=filename_length) :: name
  logical :: end_of_tape,err
  integer, parameter :: mstyle=5
  character(len=16) :: styles(mstyle),comm
  integer(kind=4) :: ncom,pcount,a_stoke,nc
  ! Data
  data styles /'STANDARD','UVFITS','AIPSFITS','SORTED_AIPSFITS','CASA_UVFITS'/
  !
  call gag_notanum(fd%bval0)
  question = .false.
  gdfname = oname
  name = iname
  !
  ! Open FITS file, including basic sanity checks
  call gfits_open(name,'IN',error)
  if (error)  return
  call gfits_goto_hdu(fd,khdu,error)
  if (error)  goto 10
  !
  ! Try to read a cube or a UV FITS?
  if (style.eq.' ') then
    call fits2gdf_guess_style(a_style,error)
    if (error)  goto 10
  else
    call sic_ambigs('STYLE',style,comm,ncom,styles,mstyle,error)
    if (error)  goto 10
    a_style = ncom-1
  endif
  !
  if (a_style.lt.code_fits_uvfits) then  ! "Normal" FITS
    call gildas_null(fits)
    !
    call fitscube2gdf_header(name,khdu,fd,fits,getsymbol,error)
    if (error) then
      call gio_message(seve%e,rname,'Error reading header in file '//name)
      goto 10
    endif
    call sic_parse_file(oname,' ','.gdf',fits%file)
    nc = len_trim(fits%file)
    !
    if (overwrite .and. gag_inquire(fits%file,nc).eq.0)  &
      call gag_filrm(fits%file(1:nc))
    !
    if (any(blc.ne.0) .or. any(trc.ne.0)) then
      ! Subset only
      call read_sub(fits,error,end_of_tape,blc,trc)
    else
      ! Full data
      call read_all(fits,error,end_of_tape)
    endif
    !
  else  ! UV FITS family
    call touvt(fits,a_style,question,check,error,pcount,getsymbol)
    if (error) then
      call gio_message(seve%e,rname,'Error reading UVFITS header')
      call gfits_close(err)
      return
    endif
    if (a_style.eq.code_fits_casa) then
      a_stoke = 0   ! Get all Stokes parameters
    else
      a_stoke = 1   ! Only get unpolarized signal
    endif
    call read_uvfits(fits,a_stoke,error,end_of_tape,pcount)
    if (error) then
      call gio_message(seve%e,rname,'Error reading UVFITS data')
      goto 10
    endif
    !
  endif
  !
10 continue
  call gfits_close(error)
  !
end subroutine fits_gildas_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mira_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  external :: class_pack_set
  external :: mira_pack_init,mira_pack_clean
  !
  pack%name='mira'
  pack%ext='.mira'
  pack%authors="A.Sievers"
  pack%depend(1:3) = (/ locwrd(sic_pack_set), locwrd(greg_pack_set), locwrd(class_pack_set)/) ! List here dependencies
  pack%init=locwrd(mira_pack_init)
  pack%clean=locwrd(mira_pack_clean)
  !
end subroutine mira_pack_set
!
subroutine mira_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Activate SIC copies of structure ATM
  call atm_sicvariables(error)
  !
  ! Load local language and initialize MIRA
  call load_mira
  !
  ! Init error flag
  error = .false.
  !
end subroutine mira_pack_init
!
subroutine mira_pack_clean(error)
  !----------------------------------------------------------------------
  ! @ private
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  call exit_mira
  !
end subroutine mira_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gtchar(nchars,string,size,slength,xp,yp,co,si,ic,ifont,  &
  doclip,gpoly_clip)
  use phys_const
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtchar
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !   Plots a character string according to current line attributes.
  ! Indices, subscripts, and special fonts are selected using the escape
  ! character \ (C.f. GREG and VSTRIN routine in CHARSHR).
  !
  !   The hard font line attribute is incompatible with the handling of
  ! the escape character \ . The argument IFONT indicates which font
  ! should be taken into account: 0 = Hardware, 1 Simplex, 2 Duplex. If
  ! the hardware generator cannot reasonably match (CO,SI) and SIZE, the
  ! SIMPLEX font is used.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: nchars      ! Number of characters
  character(len=*), intent(in)  :: string      ! Character string
  real(kind=4),     intent(in)  :: size        ! Character width (plot page units)
  real(kind=4),     intent(out) :: slength     ! String length (plot page units)
  real(kind=4),     intent(in)  :: xp          ! Position where to write the string
  real(kind=4),     intent(in)  :: yp          !
  real(kind=4),     intent(in)  :: co          ! Cosine of angle
  real(kind=4),     intent(in)  :: si          ! Sine of angle
  integer(kind=4),  intent(in)  :: ic          ! Centering option according to GREG conventions
  integer(kind=4),  intent(in)  :: ifont       ! Font type (0 Simplex, 1 Duplex)
  logical,          intent(in)  :: doclip      ! Clip with current Greg box?
  external                      :: gpoly_clip  !
  ! Interfaces
  interface
    subroutine gpoly_clip(nq,xq,yq)
      use gildas_def
      integer(kind=size_length), intent(in) :: nq     ! Number of points
      real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
      real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
    end subroutine gpoly_clip
  end interface
  ! Local
  real(kind=4) :: rxp,ryp,xstart,ystart,dx,dy,angle
  integer(kind=4) :: xsign,ysign,kfont
  !
  if (.not.awake .or. error_condition)  return
  !
  if (nchars.le.0) then
    slength = 0.
    return
  endif
  !
  ! Save the current GTWHERE
  rxp = polyl%x(polyl%n)
  ryp = polyl%y(polyl%n)
  !
  ! Get the current font KFONT: 0 Simplex quality, 1 for Duplex.
  ! Compute position
  kfont = max(ifont,0)
  if (ic.ne.6) then
    xsign = mod(ic-1,3) - 1
    ysign = (ic-1)/3 - 1
    if (xsign.eq.1) then
      dx = 0
    else
      call vstrin(nchars,string,.false.,slength,0.,0.,0.,kfont,size,  &
        doclip,gtpolyl,gpoly_clip)
      dx = (xsign - 1) * 0.5 * slength
    endif
    dy = ysign * 0.5 * size
    xstart = xp + dx * co - dy * si
    ystart = yp + dy * co + dx * si
  else
    xstart = xp
    ystart = yp
  endif
  !
  ! Call the font generator
  ! We should pass CO and SI in argument of VSTRIN, not ANGLE...
  angle = atan2(si,co)
  angle = angle*180.0/pis
  ! Clipping or not clipping?
  !  - If clipping is not wanted, use directly the GTV dedicated subroutine
  !    (gtpolyl)
  !  - If clipping to the current box is wanted, use the GREG dedicated
  !    subroutine (passed as argument). This makes sense because the box
  !    is a Greg feature, not GTV.
  call vstrin(nchars,string,.true.,slength,xstart,ystart,angle,kfont,size,  &
    doclip,gtpolyl,gpoly_clip)
  !
  ! Reset the virtual pen location
  call gtreloc (rxp,ryp)
end subroutine gtchar
!
subroutine gtg_charlen (nchars,string,size,slength,ifont)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtg_charlen
  use gtv_tree
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public
  !   Returns the length of a character string according to current
  ! font attributes. No action on the plot. See also GTCHAR
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: nchars   ! Number of characters
  character(len=*), intent(in)  :: string   ! Character string
  real(kind=4),     intent(in)  :: size     ! Character size (plot page units)
  real(kind=4),     intent(out) :: slength  ! String length (plot page units)
  integer(kind=4),  intent(in)  :: ifont    ! Font type
  ! Local
  integer(kind=4) :: kfont
  !
  if (.not.awake)  return
  !
  if (nchars.le.0) then
    slength = 0.
    return
  endif
  !
  ! Get the current font KFONT: 0 for Simplex quality, 1 for Duplex.
  ! Invoke VSTRIN to get the actual length.
  kfont = max(ifont,0)
  call vstrin(nchars,string,.false.,slength,0.,0.,0.,kfont,size,  &
    .false.,gtpolyl,dummy_clip)
  !
end subroutine gtg_charlen
!
subroutine dummy_clip(nq,xq,yq)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Unused subroutine sent to 'vstrin' (doclip = .false.)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nq     ! Number of points
  real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
  real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
end subroutine dummy_clip

subroutine gr_point(n,is)
  use gildas_def
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_point
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  !  Draw 1 symbol of type N, style IS and current size
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: n   ! Number of summits
  integer(kind=4), intent(in) :: is  ! Style of polygon (0-3)
  ! Local
  real(kind=4) :: cfact  ! Half the size of the symbol in centimeters
  real(kind=4) :: dtheta, theta, stellar
  real(kind=4) :: xa,ya, xb,yb, xc,yc, xmid,ymid, xn
  integer(kind=size_length) :: j,np,nn
  logical :: doclip
  integer(kind=4), parameter :: msum=256  ! Maximum number of summits per marker
  integer(kind=4), parameter :: mpts=2*msum+1  ! Maximum size of polyline to draw the marker
  ! Buffers are SAVE'd to avoid reallocation each time entering this subroutine
  real(kind=4), save :: xwork(mpts),ywork(mpts)  ! Before clipping
  real(kind=4), save :: xworu(mpts),yworu(mpts)  ! After clipping
  !
  cfact = csymb * expand * 0.5
  !
  ! Plot a single dot if CFACT=0 or if less than 2 summits
  if (n.lt.2 .or. cfact.eq.0.) then
    np = 1
    call grdots(np,xp,yp)  ! New list of points (1 point within)
    return
  endif
  nn = min(msum,n)
  !
  ! Check clipping
  xc = xp
  yc = yp
  doclip = .not.noclip
  if (doclip) then
    if (xc+cfact.lt.gx1) then
      return
    elseif (xc-cfact.gt.gx2) then
      return
    elseif (yc+cfact.lt.gy1) then
      return
    elseif (yc-cfact.gt.gy2) then
      return
    else
      !
      ! May intersect
      if (xc-cfact.ge.gx1 .and. xc+cfact.le.gx2 .and.  &
          yc-cfact.ge.gy1 .and. yc+cfact.le.gy2) then
        doclip = .false.
      endif
    endif
  endif
  !
  dtheta = 2. * pi / nn
  theta = (3*pi + dtheta)/2 + sangle*pi/180
  !
  ! Style 0 Empty polygon
  if (is.eq.0 .or. nn.eq.2) then
    xwork(1) = cfact*cos(theta) + xc
    ywork(1) = cfact*sin(theta) + yc
    np = nn+1
    do j = 2,np
      theta = theta + dtheta
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
    enddo
    !
    ! Style 1 Vertex connected polygon
  elseif (is.eq.1) then
    np = 2*nn+1
    xwork(1) = xc
    ywork(1) = yc
    do j=2,np,2
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
      xwork(j+1) = xc
      ywork(j+1) = yc
      theta = theta + dtheta
    enddo
    !
    ! Style 2 Starred polygon, 4 Filled Star
  elseif (is.eq.2 .or. is.eq.4) then
    xa = cfact*cos(theta) + xc
    ya = cfact*sin(theta) + yc
    xwork(1) = xa
    ywork(1) = ya
    stellar = .25
    np = 2*nn+1
    do j = 2,np,2
      theta = theta + dtheta
      xb = cfact*cos(theta) + xc
      yb = cfact*sin(theta) + yc
      xmid = stellar*(xa + xb - 2*xc) + xc
      ymid = stellar*(ya + yb - 2*yc) + yc
      xwork(j) = xmid
      ywork(j) = ymid
      xwork(j+1) = xb
      ywork(j+1) = yb
      xa = xb
      ya = yb
    enddo
    !
    ! Style 3 Filled polygon
  elseif (is.eq.3) then
    !
    ! For cosmetic purposes, start plotting from a point below.
    xn = (-pi/2-theta)/dtheta
    if (xn.ge.0) then
      j = int(xn)
    else
      j = -int(-xn)-1
    endif
    theta = theta + j * dtheta
    xwork(1) = cfact*cos(theta) + xc
    ywork(1) = cfact*sin(theta) + yc
    np = nn+1
    do j = 2,np
      theta = theta + dtheta
      xwork(j) = cfact*cos(theta) + xc
      ywork(j) = cfact*sin(theta) + yc
    enddo
  endif
  !
  ! 3 and 4 are filled
  if (is.ge.3) then
    np = np+1
    xwork(np) = xwork(1)
    ywork(np) = ywork(1)
    if (doclip) then
      call clip_poly(np,xwork,ywork,xworu,yworu)
      call gr_fillpoly(np,xworu,yworu)
    else
      call gr_fillpoly(np,xwork,ywork)
    endif
  else
    if (doclip) then
      call grpoly(np,xwork,ywork)
    else
      call gtreloc(xwork(1),ywork(1))
      do j=2,np
        call gtdraw(xwork(j),ywork(j))
      enddo
      gxp = xwork(np)  ! Set the pen location after the last 'gtdraw'
      gyp = ywork(np)  !
    endif
  endif
  !
  ! Reset pen location
  call grelocate(xc,yc)
end subroutine gr_point
!
subroutine clip_poly(n,x,y,xc,yc)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>clip_poly
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(inout) :: n      ! Number of summits (updated, may be 0 on return, may be more)
  real(kind=4),              intent(in)    :: x(:)   !
  real(kind=4),              intent(in)    :: y(:)   !
  real(kind=4),              intent(out)   :: xc(:)  !
  real(kind=4),              intent(out)   :: yc(:)  !
  ! Local
  real(kind=4) :: x0,y0,x1,y1
  integer(kind=size_length) :: i,j,m
  logical :: ok
  !
  ! The last line has a special meaning, because it must be close properly ?
  m = size(xc)
  j = 0
  ok = .false.
  i = 1
  do while (i.lt.n .and. .not.ok)
    x0 = x(i)
    y0 = y(i)
    x1 = x(i+1)
    y1 = y(i+1)
    call clip_one (x0,y0,x1,y1,ok)
    if (ok) then
      xc(1) = x0
      yc(1) = y0
      xc(2) = x1
      yc(2) = y1
      j = 2
    endif
    i = i+1
  enddo
  !
  do while (i.lt.n)
    x0 = x(i)
    y0 = y(i)
    x1 = x(i+1)
    y1 = y(i+1)
    call clip_one (x0,y0,x1,y1,ok)
    if (ok) then
      if (x0.eq.xc(j).and.y0.eq.yc(j)) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      elseif (x0.eq.xc(j) .or. y0.eq.yc(j)) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x0
        yc(j) = y0
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      else
        ! Complex case
        if (xc(j).eq.gx1 .or. xc(j).eq.gx2) then
          if (j.eq.m)  goto 10
          j = j+1
          xc(j) = xc(j-1)
          yc(j) = y0
        else
          if (j.eq.m)  goto 10
          j = j+1
          xc(j) = x0
          yc(j) = yc(j-1)
        endif
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x0
        yc(j) = y0
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = x1
        yc(j) = y1
      endif
    endif
    i = i+1
  enddo
  !
  if (j.ne.0) then
    ! Try to close properly
    if (xc(1).ne.xc(j) .or. yc(1).ne.yc(j)) then
      if (xc(j).eq.gx1 .or. xc(j).eq.gx2) then
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = xc(j-1)
        yc(j) = yc(1)
      else
        if (j.eq.m)  goto 10
        j = j+1
        xc(j) = xc(1)
        yc(j) = yc(j-1)
      endif
      if (j.eq.m)  goto 10
      j = j+1
      xc(j) = xc(1)
      yc(j) = yc(1)
    endif
  endif
  !
  n = j  ! Update the number of points to the remaining ones.
  return
  !
10 continue
  call greg_message(seve%w,'CLIP','Clipping buffer exhausted')
  n = j  ! Update the number of points to the remaining ones.
  !
end subroutine clip_poly
!
subroutine clip_one (x0,y0,x1,y1,ok)
  use greg_interfaces, except_this=>clip_one
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: x0                        !
  real :: y0                        !
  real :: x1                        !
  real :: y1                        !
  logical :: ok                     !
  ! Local
  real :: x,y
  integer :: c,c0,c1
  !
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  ok = .false.
  call grclip(x0,y0,c0)
  call grclip(x1,y1,c1)
  !
  do while (c0.ne.0 .or. c1.ne.0)
    if (iand(c0,c1).ne.0) then ! line is invisible
      return
    endif
    c = c0
    if (c.eq.0) c = c1
    if (iand(c,1).ne.0) then   ! crosses GX1
      y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
      x = gx1
    elseif (iand(c,2).ne.0) then   ! crosses GX2
      y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
      x = gx2
    elseif (iand(c,4).ne.0) then   ! crosses GY1
      x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
      y = gy1
    elseif (iand(c,8).ne.0) then   ! crosses GY2
      x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
      y = gy2
    endif
    if (c.eq.c0) then
      x0 = x
      y0 = y
      call grclip(x,y,c0)
    else
      x1 = x
      y1 = y
      call grclip(x,y,c1)
    endif
  enddo
  ok = .true.
end subroutine clip_one

subroutine gstring(n,string,angle,doclip)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gstring
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !   Interprets and writes a character string
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: n       ! Length of string
  character(len=*), intent(in) :: string  !
  real(kind=8),     intent(in) :: angle   ! Text angle, in radians
  logical,          intent(in) :: doclip  ! Clip the text in the box?
  ! Local
  real*4 :: co,si,slength
  !
  co = cos(angle)      ! COS and SINE
  si = sin(angle)
  !
  ! Call the font generator
  call gtchar(n,string,cdef*expand,slength,xp,yp,co,si,6,i_font,  &
    doclip,grpoly)
  !
  ! Update the pen location to the right reference point.
  ! This will allow to use LABEL/APPEND.
  xp = xp + co*slength
  yp = yp + si*slength
end subroutine gstring
!
subroutine gstrlen(n,string,slength)
  use greg_dependencies_interfaces
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !  Finds the actual length (in centimeters) of a character string,
  ! taking into account the current G\SET CHAR and G\SET EXPAND settings
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: n        ! Length of string
  character(len=*), intent(in)  :: string   ! String
  real(kind=4),     intent(out) :: slength  ! Length in plot units
  call gtg_charlen (n,string,cdef*expand,slength,i_font)
end subroutine gstrlen

subroutine rix(ix,error)
  use classic_api
  use clic_file
  use clic_title
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	read an entry in the input file index
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix          !
  logical         :: error                  !
  !
  ! Read title from file to buffer 
  call classic_entryindex_read(i,ix,tbuf,ibufi,error)
  if (error) return
  !
  ! Convert buffer to latest version index
  call read_index(i,error)
  !
end subroutine rix
!
subroutine rox(ix,error)
  use classic_api
  use clic_file
  use clic_title
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	read an entry in the output file index
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix          !
  logical         :: error                  !
  !
  ! Read title from file to buffer 
  call classic_entryindex_read(o,ix,tbuf,obufi,error)
  if (error) return
  !
  ! Convert buffer to latest version index
  call read_index(o,error)
  !
end subroutine rox
! 
subroutine wox(error)
  use classic_api
  use clic_file
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	write an entry in the output file index
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Local
  integer(kind=entry_length) :: ix
  !
  if (o%lun.le.0) then
    error = .true.
    call message(8,4,'WOX','Output file not opened')
    return
  endif
  ix = o%desc%xnext
  if (ix.gt.m_ox) then
    error = .true.
    call message(8,4,'WOX','Output file index is full')
    return
  endif
  ! 
  ! Write title into index buffer tbuf
  call write_index(o,error)
  if (error) return
  !
  ! Write buffer to file
  call classic_entryindex_write(o,ix,tbuf,obufi,error)
  if (error) return
  !
  ! Update output index
  ox_num(ix)  = title%num
  ox_ver(ix)  = title%ver
  ox_bloc(ix) = title%bloc
  ox_word(ix) = title%word
  ox_scan(ix) = title%scan
  ox_ut(ix)   = title%ut
  ox_rece(ix) = title%recei
  !
  ! Also update input index if file both
  if (i%lun.eq.o%lun) then
    ix_num(ix)   = title%num
    ix_ver(ix)   = title%ver
    ix_bloc(ix)  = title%bloc
    ix_word(ix)  = title%word
    ix_kind(ix)  = title%kind
    ix_qual(ix)  = title%qual
    ! CLIC only
    ix_scan(ix)  = title%scan
    ix_itype(ix) = title%itype
    ix_proc(ix)  = title%proc
    ix_rece(ix)  = title%recei
    !
    call classic_recordbuf_nullify(ibufi)
    i%desc%xnext = ix+1
    !
  endif
  !  
  ! Increment file entry number
  o%desc%xnext=ix+1
  !
end subroutine wox
!
subroutine mox(ix,error)
  use classic_api
  use clic_file
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! RW 	Internal routine
  !	modifies an entry in the output file index
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix  !
  logical :: error                  !
  ! Local
  character(len=80) :: mess
  character(len=10) :: nombre
  integer :: ii
  !
  if (o%lun.le.0) then
    error = .true.
    call message(8,4,'MOX','Output file not opened')
    return
  endif
  if (ix.le.0 .or. ix.gt.o%desc%xnext .or. ix.gt.m_ox) then
    error = .true.
    write(nombre,'(I6)') ix
    mess = 'Wrong index address '//nombre
    call message(8,3,'MOX',mess)
    return
  endif
  !
  ! Write title into index buffer tbuf
  call write_index(o,error)
  if (error) return
  !
  ! Write buffer to file
  call classic_entryindex_write(o,ix,tbuf,obufi,error)
  if (error) return
  ! 
  ! Update output index
  ox_num(ix)  = title%num
  ox_ver(ix)  = title%ver
  ox_bloc(ix) = title%bloc
  ox_word(ix) = title%word
  ox_scan(ix) = title%scan
  ox_ut(ix)   = title%ut
  ox_rece(ix) = title%recei
  !
  ! Also update input index if file both
  if (i%lun.eq.o%lun) then
    ix_num(ix)   = title%num
    ix_ver(ix)   = title%ver
    ix_bloc(ix)  = title%bloc
    ix_word(ix)  = title%word
    ix_kind(ix)  = title%kind
    ix_qual(ix)  = title%qual
    ! CLIC only
    ix_scan(ix)  = title%scan
    ix_proc(ix)  = title%proc
    ix_rece(ix)  = title%recei
    ix_itype(ix) = title%itype
    !
    call classic_recordbuf_nullify(ibufi)
    !
    ! Update current index if observation in it
    do ii=1, cxnext-1
      if (cx_num(ii).eq.title%num) then
        cx_ver(ii)  = title%ver
        cx_ind(ii)  = ix
        cx_bloc(ii) = ix_bloc(ix)
        cx_word(ii) = ix_word(ix)
      endif
    enddo
  endif
  !
end subroutine mox
!
subroutine cox(error)
  use classic_api
  use clic_file
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	Close an observation in the output file index
  !---------------------------------------------------------------------
  logical :: error                  !
  !
  if (o%lun.le.0) then
    error = .true.
    call message(8,4,'COX','Output file not opened')
    return
  endif
  !
  ! Write file descriptor
  call classic_filedesc_write(o,error)
  !
  ! Update input file descriptor if file both
  if (i%lun.eq.o%lun) then
     i%desc = o%desc
  endif
  !
end subroutine cox
!
subroutine rdx(ix,error)
  use classic_api
  use gbl_constant
  use clic_file
  use clic_title
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	read an entry in the external data file index
  !     results in lbloc, ....
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix                     !
  logical :: error                  !
  ! Local
  character(len=10) :: nombre
  character(len=80) :: mess
  !
  if (ix.le.0 .or. ix.gt.d%desc%xnext) then
    error = .true.
    write(nombre,'(I6)') ix
    mess = 'Wrong index address '//nombre
    call message(8,3,'RDX',mess)
    return
  endif
  !
  if (d%lun.le.0) then
    error = .true.
    call message(8,4,'RDX','Input file not opened')
    return
  endif
  !
  ! Read title from file to buffer 
  call classic_entryindex_read(d,ix,tbuf,dbufi,error)
  if (error) return
  !
  ! Convert buffer to latest version index
  !
  call read_index(d,error)
  !
end subroutine rdx

program make_back
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Computes the background of an image. Thresholding is used
  !	to define the background, then the image is smoothed
  !	and blanked pixels are filled the CONJUGATE GRADIENT ALGORITHM :
  !	The smoothed image is the equilibrium state of a thin flexible plate
  !	constrained to pass near each height datum by a spring attached
  !	between it and the plate.
  !	the smoothing parameter p is the ratio :
  !	     p = ( plate stiffness) / ( springs stiffness)
  !	The convergence is obtained with about 10 iterations ...
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  integer(size_length) :: i
  integer :: n,niter
  real :: p,thre(3)
  real(4), allocatable :: ipw(:,:,:), ipt(:,:)
  type(gildas) :: x,y
  integer(kind=size_length) :: sdim(gdf_maxdims)
  integer :: ndim, ier
  !
  call gildas_open
  call gildas_real('P$',p,1)
  call gildas_inte('NITER$',niter,1)
  call gildas_char('IN$',namey)
  call gildas_char('OUT$',namex)
  call gildas_real('THRESHOLD$',thre,3)
  call gildas_close
  !
  ! Input file
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error, data=.false.)
  if (error) then
    write(6,*) 'F-MAKE_BACK,  Cannot read input file'
    goto 100
  endif
  !
  ! Create output image
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = lenc(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MAKE_BACK,  Cannot output image'
    goto 100
  endif
  !
  ! Re-shape to 3 - dim
  ndim = y%gil%ndim
  sdim = y%gil%dim
  y%gil%ndim = 3
  y%gil%dim(3) = y%loca%size/(y%gil%dim(1)*y%gil%dim(2))
  x%gil%ndim = 3
  x%gil%dim = y%gil%dim
  !
  ! Get work space
  allocate (ipt(x%gil%dim(1), x%gil%dim(2)), ipw(x%gil%dim(1), x%gil%dim(2), 4), stat=ier)
  if (ier.ne.0) goto 100
  allocate (x%r2d(x%gil%dim(1), x%gil%dim(2)), y%r2d(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 100
  !
  ! Now loop over planes
  do i=1,x%gil%dim(3)
    x%blc(3) = i
    x%trc(3) = i
    y%blc = x%blc
    y%trc = x%trc
    call gdf_read_data(x,x%r2d,error)
    call gdf_read_data(y,y%r2d,error)
    !
    ! Fill first work space
    call fill(y%gil%dim(1),y%gil%dim(2),   & !NX,NY,
    &        y%r2d,   & !IN
    &        ipt,     & !WORK
    &        y%gil%bval,y%gil%eval,thre,   &  !bval,eval,thre
    &        ipw(:,:,1),x%r2d) !out,guess
    call dgsm001(x%gil%dim(1),x%gil%dim(2),   &  !mi,mj
    &        ipw(:,:,2) ,   &   !AP
    &        ipw(:,:,3) ,   & !AP2
    &        ipw(:,:,4) ,   & !AP3
    &        thre(3))         !first_guess
    call dgsm002(ipw(:,:,1),x%gil%dim(1),x%gil%dim(2),   &  !V,MI,MJ
    &        x%r2d,x%gil%bval,x%gil%eval,   &   !A,BVAL,EVAL
    &        ipw(:,:,2), &   !DESC
    &        ipw(:,:,3), &   !grad
    &        ipw(:,:,4),  & !W
    &        p,niter)         !P,ITERMAX
    call gdf_write_data(x,x%r2d,error) 
  enddo
  call gagout('S-MAKE_BACK,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program make_back
!
subroutine fill (nx,ny,in,work,bval,eval,thre,   &
     &    out,guess)
  use gildas_def
  integer(kind=index_length) :: nx                     !
  integer(kind=index_length) :: ny                     !
  real :: in(nx,ny)                 !
  real :: work(nx,ny)               !
  real :: bval                      !
  real :: eval                      !
  real :: thre(3)                   !
  real :: out(nx,ny)                !
  real :: guess(nx,ny)              !
  ! Local
  integer :: i,j,ip,im,jp,jm
  real :: z,w
  !
  do j = 1,ny
    do i = 1,nx
      if (abs(in(i,j)-bval).gt.eval) then
        work(i,j) = in(i,j)
      else
        ip = max(i-1,1)
        im = min(i+1,nx)
        jp = max(j-1,1)
        jm = min(j+1,ny)
        w = 0.0
        z = 0.0
        if (abs(in(ip,j)-bval).gt.eval) then
          z = z+in(ip,j)
          w = w+1.0
        endif
        if (abs(in(im,j)-bval).gt.eval) then
          z = z+in(im,j)
          w = w+1.0
        endif
        if (abs(in(i,jp)-bval).gt.eval) then
          z = z+in(i,jp)
          w = w+1.0
        endif
        if (abs(in(i,jm)-bval).gt.eval) then
          z = z+in(i,jm)
          w = w+1.0
        endif
        if (w.gt.0) then
          work(i,j) = z/w
        else
          work(i,j) = bval
        endif
      endif
    enddo
  enddo
  !
  do j = 1,ny
    do i = 1,nx
      if (abs(in(i,j)-bval).le.eval) then
        if (abs(work(i,j)-bval).le.eval) then
          guess(i,j) = thre(3)
        else
          guess(i,j) = work(i,j)
        endif
        out(i,j) = bval
      elseif (in(i,j).gt.thre(2)) then
        work(i,j) = thre(2)
        guess(i,j) = thre(2)
        out(i,j) = bval
      elseif (in(i,j).lt.thre(1)) then
        work(i,j) = thre(1)
        guess(i,j) = thre(1)
        out(i,j) = bval
      else
        work(i,j) = in(i,j)
        guess(i,j) = in(i,j)
        out(i,j) = in(i,j)
      endif
    enddo
  enddo
end subroutine fill
!
subroutine dgsm001(mi,mj,ap,ap2,ap3,first_guess)
  use gildas_def
  !---------------------------------------------------------------------
  !	 Init
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mi                  !
  integer(kind=index_length) :: mj                  !
  real :: ap(mi,mj)                 !
  real :: ap2(mi,mj)                !
  real :: ap3(mi,mj)                !
  real :: first_guess               !
  ! Local
  ap = 0.0
  ap2 = 0.0
  ap3 = 0.0
end subroutine dgsm001
!
subroutine dgsm002(v,mi,mj,a,bval,eval,desc,grad,w,p,itermax)
  use gildas_def
  !---------------------------------------------------------------------
  ! D. Girard  smoothing technique
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: v(mi,mj)                !
  real(4) :: a(mi,mj)                !
  real(4) :: bval                    !
  real(4) :: eval                    !
  real(4) :: desc(mi,mj)             !
  real(4) :: grad(mi,mj)             !
  real(4) :: w(mi,mj)                !
  real(4) :: p                       !
  integer :: itermax                !
  ! Global
  real(4) :: dot,norme2
  ! Local
  real(4) :: beta,lambda
  real(4) :: norm2grad,norm2grad_1
  !
  ! Resolution iterative par gradient conjugue
  ! Pas de splines pour l'instant
  ! Compromis fidelite aux donnees (moindre carre)
  ! et terme de flexion de symmetrie correcte.
  ! BUT: Etude problemes de convergence.
  !						D. Girard. 20-dec-1986
  !
  ! Ici P n'a pas la signification de C. de Borr
  !-------------------------------------------
  !
  integer i0,j0,i,j,iter
  !
  i0 = max(1,mi/2)
  j0 = max(1,mj/2)
  if (itermax.le.0) return
  !
  call iprotd (v,mi,mj,p,a,grad,bval,eval) ! Calcul du gradient(=residu
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        grad(i,j)=grad(i,j)-v(i,j)
      endif
    enddo
  enddo
  norm2grad = norme2(mi,mj,grad)
  !
  call iprotd (v,mi,mj,p,grad,w,bval,eval)
  lambda = norm2grad/dot(mi,mj,grad,w)
  !
  do j=1,mj
    do i=1,mi
      desc(i,j) = - grad(i,j)
    enddo
  enddo
  !
  do j=1,mj
    do i=1,mi
      a(i,j) = a(i,j) - lambda*grad(i,j)
    enddo
  enddo
  norm2grad_1 = norm2grad
  do j=1,mj
    do i=1,mi
      grad(i,j) = grad(i,j) - lambda*w(i,j)
    enddo
  enddo
  !
  ! ITERATIONS
  do iter = 2,itermax
    norm2grad = norme2(mi,mj,grad)
    beta = norm2grad/norm2grad_1
    do j=1,mj
      do i=1,mi
        desc(i,j) = -grad(i,j) + beta*desc(i,j)
      enddo
    enddo
    call iprotd(v,mi,mj,p,desc,w,bval,eval)
    !
    lambda = norm2grad / dot(mi,mj,desc,w)
    !
    do j=1,mj
      do i=1,mi
        a(i,j) = a(i,j) + lambda*desc(i,j)
      enddo
    enddo
    !
    norm2grad_1 = norm2grad
    !
    do j=1,mj
      do i=1,mi
        grad(i,j) = grad(i,j) + lambda*w(i,j)
      enddo
    enddo
  enddo
end subroutine dgsm002
!
subroutine iprotd(v,mi,mj,p,z,s,bval,eval)
  use gildas_def
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: v(mi,mj)                !
  real(4) :: p                       !
  real(4) :: z(mi,mj)                !
  real(4) :: s(mi,mj)                !
  real(4) :: bval                    !
  real(4) :: eval                    !
  ! Local
  integer :: i,j
  real(4) :: w
  !
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        s(i,j) = z(i,j)
      else
        s(i,j) = 0
      endif
    enddo
  enddo
  do j=2,mj-1
    do i=2,mi-1
      w = p*(2*z(i,j)-z(i-1,j)-z(i+1,j))
      s(i,j) = s(i,j) +2*w
      s(i-1,j) = s(i-1,j) -w
      s(i+1,j) = s(i+1,j) -w
      w = p*(2*z(i,j)-z(i,j+1)-z(i,j-1))
      s(i,j) = s(i,j) +2*w
      s(i,j-1) = s(i,j-1) -w
      s(i,j+1) = s(i,j+1) -w
      w = 2*p*(z(i+1,j+1)+z(i-1,j-1)-z(i+1,j-1)-z(i-1,j+1))/4
      s(i+1,j+1) = s(i+1,j+1) +w/4
      s(i-1,j-1) = s(i-1,j-1) +w/4
      s(i+1,j-1) = s(i+1,j-1) -w/4
      s(i-1,j+1) = s(i-1,j+1) -w/4
    enddo
  enddo
end subroutine iprotd
!
function dot (mi,mj,z,s)
  use gildas_def
  real(4) :: dot                     !
  integer(kind=index_length) :: mi                   !
  integer(kind=index_length) :: mj                   !
  real(4) :: z(mi,mj)                !
  real(4) :: s(mi,mj)                !
  ! Local
  integer :: i,j
  !
  dot = 0.
  do j=1,mj
    do i=1,mi
      dot = dot + s(i,j)*z(i,j)
    enddo
  enddo
end function dot
!
function norme2(mi,mj,z)
  use gildas_def
  real(4) :: norme2                  !
  integer(kind=index_length) :: mi                     !
  integer(kind=index_length) :: mj                     !
  real(4) :: z(mi,mj)                !
  ! Local
  integer :: i,j
  !
  norme2 = 0.
  do j=1,mj
    do i=1,mi
      norme2 = norme2 + z(i,j)*z(i,j)
    enddo
  enddo
end function norme2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mapping_read
  use gbl_message
  !
  public :: read_comm
  public :: out_range,check_uvdata_type,mosaic_getfields
  private
  !
contains
  !
  subroutine read_comm(line,error)
    use gkernel_interfaces
    use clean_arrays
    use buffer_types
    !----------------------------------------------------------------------
    ! READ Type File
    !   [/COMPACT]
    !   [/NOTRAIL]
    !   [/RANGE Start End Type]
    !   [/FREQUENCY RestFreqMHz]
    !   [/PLANE] (obsolete)
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ntype,nn,ikey
    character(len=12) :: argu,atype
    character(len=filename_length) :: name
    logical :: compact,lexist,do_freq
    character(len=filename_length) :: file
    real(kind=8) :: dovrange(2), freq
    character(len=12) :: docrange,crange
    !
    integer(kind=4), parameter :: o_compact=1
    integer(kind=4), parameter :: o_freq=2
    integer(kind=4), parameter :: o_plane=3
    integer(kind=4), parameter :: o_range=4
    integer(kind=4), parameter :: o_trail=5
    integer(kind=4), parameter :: mranges=3
    character(len=12), parameter :: ranges(mranges)= (/'CHANNEL  ','VELOCITY ','FREQUENCY'/)
    !
    call sic_ke (line,0,1,argu,nn,.true.,error)
    if (error) return
    call sic_ch (line,0,2,name,nn,.true.,error)
    if (error) return
    !
    ! Default settings
    dovrange(:) = 0.d0
    docrange = 'NONE'
    !
    ! /PLANE (for compatibility)
    if (sic_present(o_plane,0)) then
       call sic_r8 (line,o_plane,1,dovrange(1),.true.,error)
       if (error) return
       call sic_r8 (line,o_plane,2,dovrange(2),.true.,error)
       if (error) return
       docrange = 'CHANNEL'
    endif
    !
    ! /RANGE (for flexibility)
    if (sic_present(o_range,0)) then
       call sic_r8 (line,o_range,1,dovrange(1),.true.,error)
       if (error) return
       call sic_r8 (line,o_range,2,dovrange(2),.true.,error)
       if (error) return
       call sic_ke (line,o_range,3,argu,nn,.true.,error)
       if (error) return
       call sic_ambigs('READ',argu,docrange,ikey,ranges,mranges,error)
       if (error)  return
    endif
    !
    ! /FREQUENCY Option
    do_freq = sic_present(o_freq,0)
    if (do_freq) then
       call sic_r8(line,o_freq,1,freq,.true.,error)
       if (error) return
    endif
    !
    ! /COMPACT
    compact = sic_present(o_compact,0)
    !
    if (argu.eq.'*') then
       !
       ! Find all files of relevant extension, and load them
       do ntype=1,mtype_read
          lexist = sic_findfile(name,file,' ',etype(ntype))
          if (lexist) then
             call map_message(seve%i,'READ','Loading '//vtype(ntype)//trim(file))
             if (ntype.eq.1 .or. ntype.eq.mtype) then
                ! Unclear which buffers do not support a range...
                crange = 'NONE'
             else
                crange = docrange
             endif
             if (do_freq) then
                call read_main(name,ntype,dovrange,crange,compact,error,freq)
             else
                call read_main(name,ntype,dovrange,crange,compact,error)
             endif
          endif
       enddo
    else
       call sic_ambigs ('READ',argu,atype,ntype,vtype,mtype_read,error)
       if (error) return
       !
       if (do_freq) then
          call read_main(name,ntype,dovrange,docrange,compact,error,freq)
       else
          call read_main(name,ntype,dovrange,docrange,compact,error)
       endif
    endif
  end subroutine read_comm
  !
  subroutine read_main(name,ntype,dovrange,crange,compact,error,freq)
    use gkernel_interfaces
    use clean_arrays
    use buffer_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),  intent(in)    :: name
    integer,           intent(in)    :: ntype       ! Type of data
    real(8),           intent(in)    :: dovrange(2) ! Range to be read
    character(len=*),  intent(in)    :: crange      ! Type of range
    logical,           intent(in)    :: compact     ! ACA buffer flag
    logical,           intent(inout) :: error
    real(8), optional, intent(in)    :: freq        ! Desired rest frequency
    !
    type (gildas) :: head
    integer :: nc(2)
    logical :: nochange, attempt, myerror
    real(4) :: velo
    !
    call gildas_null(head)
    call sic_parse_file(name,' ',etype(ntype),head%file)
    !
    head%blc = 0
    head%trc = 0
    !
    ! Read Header
    call gdf_read_header (head,error)
    if (error) return
    !
    ! Shift it to the requested Rest Frequency if needed
    if (present(freq)) then
       velo = head%gil%voff
       call gdf_modify(head,velo,freq,error=error)
       if (error) return
    endif
    !
    call out_range('READ',crange,dovrange,nc,head,error)
    if (error) return
    !
    ! Check if anything changed
    if (.not.compact) then
       ! We must check if the corresponding buffer is still allocated !...
       select case(vtype(ntype))
       case ('CCT')
          attempt = hcct%loca%size.ne.0
       case ('RESIDUAL')
          attempt = hresid%loca%size.ne.0
       case ('CLEAN')
          attempt = hclean%loca%size.ne.0
       case default
          attempt = .true.
       end select
       if (attempt) then
          call reread(ntype,head%file,optimize(ntype),nc,nochange)
          if (nochange) return
       endif
    endif
    !
    ! Read Data as required
    call map_read(head,vtype(ntype),nc,compact,error)
    if (error)  goto 100
    !
    ! Indicate Buffer will has been read
    optimize(ntype)%change = 0
    !
100 continue
    ! Free image slot 
    myerror = .false.
    call gdf_close_image(head,myerror)
    error = error.or.myerror
  end subroutine read_main
  !
  subroutine reread(atype,file,opti,nc,nochange)
    use gkernel_interfaces
    use uv_buffer_tool
    use buffer_types
    use clean_arrays
    !---------------------------------------------------------------------
    ! Check if the file of type "atype" needs to be read again.
    !---------------------------------------------------------------------
    integer,          intent(in)    :: atype    ! Code of type of file
    character(len=*), intent(in)    :: file     ! Filename
    type(readop_t),   intent(inout) :: opti     ! Status of corresponding buffer
    integer,          intent(in)    :: nc(2)    ! Range to be read
    logical,          intent(out)   :: nochange ! Change status
    !
    logical :: error
    integer :: msev
    character(len=36) :: mess,trail
    !
    nochange = .false.           ! By default
    !
    opti%modif%modif = .true.    ! In case of error
    call gag_filmodif(file,opti%modif,error)
    if (.not.opti%modif%modif) then
       if (nc(1).eq.opti%lastnc(1) .and. nc(2).eq.opti%lastnc(2)) then
          mess = 'File not modified and same range  -- '
          msev = seve%w
          nochange = .true.
       else
          mess = 'File not modified, different range - '
          msev = seve%i
       endif
    else
       opti%lastnc = nc
       return
    endif
    opti%lastnc = nc
    !
    ! The buffers may however have been manipulated in Mapping
    if (optimize(atype)%change.gt.1) then
       nochange = .false.
       trail = ' Buffer changed -- Reloaded '
       msev = seve%i
    else if (optimize(atype)%change.eq.1 .and. nochange) then
       ! Is there a buffer to be Reset
       if (atype.eq.code_save_uv) then
          call uv_reset_buffer('READ')
          call sic_delvariable ('UV',.false.,error)
          call sic_mapgildas('UV',huv,error,duvi)
       endif
       optimize(atype)%change = 0
       trail = ' Reset from Buffer'
    else if (nochange) then
       trail = ' not reloaded '
    else
       trail = ' reloaded '
    endif
    !
    call map_message(msev,'READ',mess//trail)
    ! No Read / Write optimization
    ! RW_Optimize is an integer, so that we may distinguish
    ! optimization based on "atype"
    if (rw_optimize.eq.0 .and. nochange) then
       call map_message(seve%w,'READ','Reading enforced by user')
       nochange = .false.
    endif
  end subroutine reread
  !
  subroutine map_read(head,out,nc,compact,error)
    use gkernel_interfaces
    use uv_buffer_tool
    use clean_arrays
    use buffer_types
    use mapping_default_types
    use mapping_mosaic
    !----------------------------------------------------------------------
    ! Read some type of input data.
    !------------------------------------------------------------------
    type (gildas),    intent(inout) :: head    ! Header of data
    character(len=*), intent(in)    :: out     ! Desired data
    integer,          intent(in)    :: nc(2)   ! Channel range
    logical,          intent(in)    :: compact ! Put in ACA space ?
    logical,          intent(inout) :: error
    !
    type (gildas) :: htmp
    logical :: subset
    integer :: i,ier,nchan,local_nc(2)
    integer, parameter :: o_trail=5
    character(len=message_length) chain
    character(len=*), parameter :: rname='READ'
    !
    error = .false.
    !
    if (.not.compact) then
       select case (out)
       case ('BEAM')
          ! Beam is a 4-D array of dimension Nx Ny Np Nb
          ! where Nb is the number of "beam frequencies"
          ! and Np the number of pointing centers
          call gdf_copy_header(head, hbeam, error)
          hbeam%loca = head%loca
          save_data(code_save_beam) = .false.
          call sic_delvariable ('BEAM',.false.,error)
          if (allocated(dbeam)) deallocate(dbeam,stat=ier)
          hbeam%gil%dim(3) = max(1,hbeam%gil%dim(3))
          hbeam%gil%dim(4) = max(1,hbeam%gil%dim(4))
          allocate(dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2),   &
               &        hbeam%gil%dim(3),hbeam%gil%dim(4)),stat=ier)
          call gdf_read_data(hbeam,dbeam,error)
          if (error) return
          !
          ! One should check here the beam order:
          ! input beams can also be
          !   Nx Ny Nb
          ! or
          !   NX Ny Np
          ! depending on GILDAS  version used for creation
          call sic_mapgildas('BEAM',hbeam,error,dbeam)
          ! Special case for UV data
       case ('UV')
          ! Free the previous zone
          call uv_free_buffers
          save_data(code_save_uv) = .false.
          !
          call gildas_null (huv, type= 'UVT')
          call gildas_null (htmp, type= 'UVT')
          call gdf_copy_header(head, htmp, error)
          ! Check appropriate order
          if (htmp%char%code(1).eq."RANDOM") then
             call map_message(seve%w,rname,'UV data is transposed')
             call gdf_transpose_header (htmp, huv, '21', error)
             subset = .true.
          else
             call gdf_copy_header(htmp, huv, error)
             subset = .false.
          endif
          if (error)  return
          htmp%loca = head%loca
          huv%loca = head%loca   ! Why : to get the image slot !...
          !
          uv_plotted = .false.
          call sic_delvariable ('UV',.false.,error)
          call sic_delvariable ('UVS',.false.,error)
          !
          ! Extract desired channels
          nchan = huv%gil%nchan
          local_nc = nc
          ier = gdf_range (local_nc, nchan)
          nchan = local_nc(2)-local_nc(1)+1
          huv%gil%ref(1) = huv%gil%ref(1)-local_nc(1)+1
          huv%gil%dim(1) = huv%gil%nlead+huv%gil%natom*huv%gil%nstokes*nchan
          if (huv%gil%ntrail.gt.0) then
             if (sic_present(o_trail,0)) then    ! /NOTRAIL option
                do i=1,code_uvt_last
                   if (huv%gil%column_pointer(i).gt.huv%gil%dim(1)) then
                      call map_message(seve%w,rname,'Found column '//uv_column_name(i))
                      huv%gil%column_size(i) = 0
                      huv%gil%column_pointer(i) = 0
                   endif
                enddo
                huv%gil%ntrail = 0
             endif
             ! use them according to user selection
             huv%gil%dim(1) = huv%gil%dim(1) + huv%gil%ntrail
          endif
          huv%gil%nchan = nchan
          allocate(duvi(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
          if (failed_allocate(rname,'UV data buffer',ier,error))  return
          call gdf_read_uvdataset(htmp,huv,local_nc,duvi,error)
          if (gildas_error(huv,rname,error)) return
          !
          ! Nullify Beyond NVISI in case of incomplete data set
          if (huv%gil%nvisi.lt.huv%gil%dim(2)) then
             duvi(:,huv%gil%nvisi+1:huv%gil%dim(2)) = 0.
          endif
          !
          duv => duvi              ! Point on original data
          duvr => duvi             ! Point on original data
          !
          ! Check the type and number of fields
          call check_uvdata_type(huv,duv,themap,error)
          if (error) return
          !!print *,'Defining UV'
          call sic_mapgildas('UV',huv,error,duvi)
          !!print *,'Copying header'
          call gildas_null (huvi, type = 'UVT')
          call gdf_copy_header(huv,huvi, error)
          !
          do_weig = .true.
          !
          ! Unload the PRIMARY array if defined
          call sic_delvariable ('PRIMARY',.false.,error)
          if (allocated(dprim)) deallocate(dprim,stat=ier)
          hprim%loca%size = 0
       case ('MODEL')
          ! Free the previous zone
          call sic_delvariable ('UVM',.false.,error)
          if (allocated(duvm)) then
             deallocate(duvm,stat=ier)
          endif
          !
          call gildas_null (huvm, type= 'UVT')
          call gildas_null (htmp, type= 'UVT')
          call gdf_copy_header(head, htmp, error)
          ! Check appropriate order
          if (htmp%char%code(1).eq."RANDOM") then
             call map_message(seve%w,rname,'UV data is transposed')
             call gdf_transpose_header (htmp, huvm, '21', error)
          else
             call gdf_copy_header(htmp, huvm, error)
          endif
          if (error)  return
          htmp%loca = head%loca
          huvm%loca = head%loca   ! Why ? See above !
          !
          ! Extract desired channels
          nchan = huvm%gil%nchan
          local_nc = nc
          ier = gdf_range (local_nc, nchan)
          nchan = local_nc(2)-local_nc(1)+1
          huvm%gil%ref(1) = huvm%gil%ref(1)-local_nc(1)+1
          huvm%gil%dim(1) = huvm%gil%nlead+huvm%gil%natom*nchan
          if (huvm%gil%ntrail.gt.0) then
             if (sic_present(o_trail,0)) then    ! /NOTRAIL option
                do i=1,code_uvt_last
                   if (huvm%gil%column_pointer(i).gt.huvm%gil%dim(1)) then
                      call map_message(seve%w,rname,'Found column '//uv_column_name(i))
                      huvm%gil%column_size(i) = 0
                      huvm%gil%column_pointer(i) = 0
                   endif
                enddo
                huvm%gil%ntrail = 0
             endif
             ! use them according to user selection
             huvm%gil%dim(1) = huvm%gil%dim(1) + huvm%gil%ntrail
          endif
          huvm%gil%nchan = nchan
          allocate(duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
          call gdf_read_uvdataset(htmp,huvm,local_nc,duvm,error)
          if (gildas_error(huvm,rname,error)) return
          !
          huvm%loca%size = huvm%gil%dim(1)*huvm%gil%dim(2)
          call sic_def_real('UVM',duvm,huvm%gil%ndim,&
               huvm%gil%dim,.true.,error)
       case ('DIRTY')
          save_data(code_save_dirty) = .false.
          call sic_delvariable ('DIRTY',.false.,error)
          if (allocated(ddirty)) deallocate(ddirty,stat=ier)
          !
          ! Specify the subset
          error = map_range(nc,head,hdirty)
          if (error) return
          !
          allocate(ddirty(hdirty%gil%dim(1),hdirty%gil%dim(2),   &
               &        hdirty%gil%dim(3)),stat=ier)
          call gdf_read_data(head,ddirty,error)
          if (error) return
          !
          call sic_mapgildas('DIRTY',hdirty,error,ddirty)
          user_method%do_mask = .true.
          !
          ! Define Min Max
          d_max = hdirty%gil%rmax
          if (hdirty%gil%rmin.eq.0) then
             d_min = -0.03*hdirty%gil%rmax
          else
             d_min = hdirty%gil%rmin
          endif
       case ('RESIDUAL')
          save_data(code_save_resid) = .false.
          call sic_delvariable ('RESIDUAL',.false.,error)
          if (allocated(dresid)) deallocate(dresid,stat=ier)
          ! Specify the subset
          error = map_range(nc,head,hresid)
          if (error) return
          allocate(dresid(hresid%gil%dim(1),hresid%gil%dim(2),   &
               &        hresid%gil%dim(3)),stat=ier)
          call gdf_read_data(head,dresid,error)
          if (error) return
          call sic_mapgildas('RESIDUAL',hresid,error,dresid)
          user_method%do_mask = .true.
       case ('CLEAN')
          save_data(code_save_clean) = .false.
          call sic_delvariable ('CLEAN',.false.,error)
          if (allocated(dclean)) deallocate(dclean,stat=ier)
          ! Specify the subset
          error = map_range(nc,head,hclean)
          if (error) return
          allocate(dclean(hclean%gil%dim(1),hclean%gil%dim(2),   &
               &        hclean%gil%dim(3)),stat=ier)
          call gdf_read_data(head,dclean,error)
          if (error) return
          call sic_mapgildas ('CLEAN',hclean,error,dclean)
       case ('MASK')
          save_data(code_save_mask) = .false.
          call sic_delvariable ('MASK',.false.,error)
          if (allocated(dmask)) deallocate(dmask,stat=ier)
          ! Specify the subset
          error = map_range(nc,head,hmask)
          if (error) return
          allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
               &        stat=ier)
          call gdf_read_data(head,dmask,error) 
          if (error) return
          call sic_mapgildas ('MASK',hmask,error,dmask)
          user_method%do_mask = .true.
       case ('PRIMARY')
          ! Primary is a 4-D array of dimension Np Nx Ny Nb
          ! where Nb is the number of "beam frequencies"
          ! and Np the number of pointing centers
          !
          ! /RANGE option not effective here
          !
          call gdf_copy_header(head, hprim, error)
          hprim%loca = head%loca
          save_data(code_save_primary) = .false.
          call sic_delvariable ('PRIMARY',.false.,error)
          if (allocated(dprim)) deallocate(dprim,stat=ier)
          hprim%gil%dim(4) = max(1,hprim%gil%dim(4))
          allocate(dprim(hprim%gil%dim(1),hprim%gil%dim(2),   &
               &        hprim%gil%dim(3),hprim%gil%dim(4)),stat=ier)
          call gdf_read_data(hprim,dprim,error)
          if (error) return
          call sic_mapgildas('PRIMARY',hprim,error,dprim)
          !
          ! Old GILDAS primary beams had only one Frequency channel
          !
          ! Switch to mosaic mode
          user_method%trunca = hprim%gil%inc(1)  ! Truncation of beam
          user_method%search = user_method%trunca
          user_method%restor = user_method%trunca
          call map_message(seve%i,rname,'Primary Beam read, setting MOSAIC')
          call mosaic_main('ON',error)
          if (error) return
       case ('CCT')
          call gdf_copy_header(head, hcct, error)
          hcct%loca = head%loca
          save_data(code_save_cct) = .false.
          call sic_delvariable ('CCT',.false.,error)
          if (allocated(dcct)) deallocate(dcct,stat=ier)
          ! Specify the subset
          call map_message(seve%w,rname,'CCT -- range ignored')
          !      error = map_range(nc,head,hcct)
          !      if (error) return
          head%blc = 0
          head%trc = 0
          allocate(dcct(hcct%gil%dim(1),hcct%gil%dim(2),   &
               &        hcct%gil%dim(3)),stat=ier)
          call gdf_read_data(head,dcct,error)
          if (error) return
          call sic_mapgildas ('CCT',hcct,error,dcct)
       case default
          chain = 'Unsupported operation '//out
          call map_message(seve%e,rname,chain)
          error = .true.
       end select
    else
       ! Compact Array data
       ! 4-D not yet done...
       !
       select case (out)
       case ('BEAM')
          call gdf_copy_header(head, c_hbeam, error)
          c_hbeam%loca = head%loca
          save_data(code_save_beam) = .false.
          call sic_delvariable ('C_BEAM',.false.,error)
          if (allocated(c_dbeam)) deallocate(c_dbeam,stat=ier)
          allocate(c_dbeam(c_hbeam%gil%dim(1),c_hbeam%gil%dim(2),   &
               &        c_hbeam%gil%dim(3)),stat=ier)
          call gdf_read_data(c_hbeam,c_dbeam,error)
          if (error) return
          c_hbeam%gil%dim(3) = max(1,c_hbeam%gil%dim(3))
          call sic_def_real ('C_BEAM',c_dbeam,c_hbeam%gil%ndim,   &
               &        c_hbeam%gil%dim,.true.,error)
       case ('DIRTY')
          call gdf_copy_header(head, c_hdirty, error)
          c_hdirty%loca = head%loca
          save_data(code_save_dirty) = .false.
          call sic_delvariable ('C_DIRTY',.false.,error)
          if (allocated(c_ddirty)) deallocate(c_ddirty,stat=ier)
          allocate(c_ddirty(c_hdirty%gil%dim(1),c_hdirty%gil%dim(2),   &
               &        c_hdirty%gil%dim(3)),stat=ier)
          call gdf_read_data(c_hdirty,c_ddirty,error)
          if (error) return
          call sic_def_real ('C_DIRTY',c_ddirty,c_hdirty%gil%ndim,   &
               &        c_hdirty%gil%dim,.true.,error)
          cuse_method%do_mask = .true.
       case ('RESIDUAL')
          call gdf_copy_header(head, c_hresid, error)
          c_hresid%loca = head%loca
          save_data(code_save_resid) = .false.
          call sic_delvariable ('C_RESIDUAL',.false.,error)
          if (allocated(c_dresid)) deallocate(c_dresid,stat=ier)
          allocate(c_dresid(c_hresid%gil%dim(1),c_hresid%gil%dim(2),   &
               &        c_hresid%gil%dim(3)),stat=ier)
          call gdf_read_data(c_hresid,c_dresid,error)
          if (error) return
          call sic_def_real ('C_RESIDUAL',c_dresid,c_hresid%gil%ndim,   &
               &        c_hresid%gil%dim,.true.,error)
          cuse_method%do_mask = .true.
          !
       case ('PRIMARY')
          call gdf_copy_header(head, c_hprim, error)
          c_hprim%loca = head%loca
          call sic_delvariable ('C_PRIMARY',.false.,error)
          if (allocated(c_dprim)) deallocate(c_dprim,stat=ier)
          allocate(c_dprim(c_hprim%gil%dim(1),c_hprim%gil%dim(2),   &
               &        c_hprim%gil%dim(3)),stat=ier)
          call gdf_read_data(c_hprim,c_dprim,error)
          if (error) return
          call sic_def_real ('C_PRIMARY',c_dprim,c_hprim%gil%ndim,   &
               &        c_hprim%gil%dim,.true.,error)
          !
          ! Switch to mosaic mode
          cuse_method%trunca = c_hprim%gil%inc(1)  ! Truncation of beam
          cuse_method%search = cuse_method%trunca
          cuse_method%mosaic = .true.
       case default
          chain = 'Unsupported operation '//out
          call map_message(seve%e,rname,chain)
          error = .true.
       end select
    endif
  end subroutine map_read
  !
  function map_range(nc,hin,hou)
    use gkernel_interfaces, only: gdf_range
    use image_def
    !---------------------------------------------------------------------
    ! Define channel range and set output Map header accordingly
    !---------------------------------------------------------------------
    integer,       intent(in)    :: nc(2)     ! Input channel range
    type (gildas), intent(inout) :: hin       ! Input header
    type (gildas), intent(inout) :: hou       ! Output header
    logical                      :: map_range ! intent(out)
    !
    integer local_nc(2), hdim, faxi
    !
    ! Copy header
    call gdf_copy_header(hin, hou, map_range)
    if (map_range) return
    hou%loca = hin%loca
    !
    ! Find out the actual range
    faxi = hin%gil%faxi
    local_nc = nc
    map_range = gdf_range(local_nc,hin%gil%dim(faxi)).ne.0
    if (map_range) return
    hdim = local_nc(2) - local_nc(1) + 1
    !
    ! Set the input header subset range
    hin%blc(faxi) = local_nc(1)
    hin%trc(faxi) = local_nc(2)
    !
    ! Set the output header reference channel and number of channels
    hou%gil%ref(faxi) = hou%gil%ref(faxi)+1-max(hin%blc(faxi),1)
    hou%gil%dim(faxi) = hdim
    !
    ! Correct the data size
    hou%loca%size = hin%loca%size*hou%gil%dim(faxi)/hin%gil%dim(faxi)
  end function map_range
  !
  subroutine out_range(rname,atype,dovrange,nc,head,error)
    use image_def
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Utility routine to define a channel range from a Velocity, Frequency
    ! or Channel range
    !---------------------------------------------------------------------
    character(len=*), intent(in)  :: rname        ! Caller name
    character(len=*), intent(in)  :: atype        ! Type of range
    real(kind=8),     intent(in)  :: dovrange(2)  ! Input range
    integer(kind=4),  intent(out) :: nc(2)        ! Ouput channel number
    type(gildas),     intent(in)  :: head         ! Reference GILDAS data frame
    logical,          intent(out) :: error        ! Error flag
    !
    real(8) :: frange(2)
    integer :: itype, nn, ier, nchan
    integer(kind=4), parameter :: mtype=4
    character(len=12) :: types(mtype),mytype,ctype
    data types /'CHANNEL','VELOCITY','FREQUENCY','NONE'/
    character(len=message_length) :: chain
    !
    ctype = atype
    call sic_upper(ctype)
    error = .false.
    call sic_ambigs(rname,ctype,mytype,itype,types,mtype,error)
    if (error)  return
    !
    if (abs(head%gil%type_gdf).eq.code_gdf_uvt) then
       nchan = head%gil%nchan
    else if (head%gil%faxi.ne.0) then
       nchan = head%gil%dim(head%gil%faxi)
    else if (head%gil%ndim.eq.2) then
       call map_message(seve%w,rname,'Dataset is 2-D only') 
       nchan = 1
    else  
       if (mytype.ne.'NONE') call map_message(seve%w,rname, &
            & 'No Frequency axis, /RANGE option ignored.')
       nc = 1
       return
    endif
    !
    if (mytype.eq.'CHANNEL') then
       nc = nint(dovrange)
    else if (mytype.eq.'VELOCITY') then
       if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
          ! UV data case
          frange = (dovrange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
       else if  (head%gil%faxi.eq.0) then  !
          call map_message(seve%e,rname,'No Velocity/Frequency Axis')
          error = .true.
          return
       else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
          frange = -(dovrange-head%gil%voff)*head%gil%freq/299792.458d0+head%gil%freq
          frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
       else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
          frange = (dovrange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
       else
          call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
          error = .true.
          return
       endif
       !
       nc = nint(frange)
       if (nc(1).gt.nc(2)) then
          nn = nc(2)
          nc(2) = nc(1)
          nc(1) = nn
       endif
       if (nc(1).gt.nchan .or. nc(2).lt.1) then
          write(chain,'(A,I8,A,I8,A,I8,A)') 'Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
          call map_message(seve%e,rname,chain)
          error = .true.
          return
       endif
       nc = max(1,min(nc,nchan))
    else if (mytype.eq.'FREQUENCY') then
       ! The current code is only valid for UV Tables.
       ! See as above for the VELOCITY case
       ! dovrange = nc - head%gil%ref(head%gil%faxi) ) * head%gil%vres + head%gil%voff
       if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
          ! UV data case is always the same...
          frange = (dovrange - head%gil%freq) / head%gil%fres + head%gil%ref(head%gil%faxi)
       else if (head%gil%faxi.eq.0) then  !
          call map_message(seve%e,rname,'No Velocity/Frequency Axis')
          error = .true.
          return
       else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
          frange = (dovrange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
       else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
          frange = -(dovrange-head%gil%freq)/head%gil%freq*299792.458d0 + head%gil%voff
          frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%vres + head%gil%ref(head%gil%faxi)
       else
          call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
          error = .true.
          return
       endif
       !
       nc = nint(frange)
       if (nc(1).gt.nc(2)) then
          nn = nc(2)
          nc(2) = nc(1)
          nc(1) = nn
       endif
       if (nc(1).gt.nchan .or. nc(2).lt.1) then
          write(chain,'(A,I8,A,I8,A,I8,A)') 'Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
          call map_message(seve%e,rname,chain)
          error = .true.
          return
       endif
       nc = max(1,min(nc,nchan))
    else if (mytype.eq.'NONE') then
       nc = [1,nchan]
    else
       call map_message(seve%f,rname,'Type of value '''//trim(mytype)//''' not supported')
       error = .true.
       return
    endif
    !
    ier = gdf_range (nc, nchan)
    if (ier.ne.0) error = .true.
  end subroutine out_range
  !
  subroutine check_uvdata_type(huv,duv,map,error)
    use image_def
    use gkernel_interfaces
    use uvmap_types
    use mapping_primary, only: get_bsize
    !-------------------------------------------------------
    ! Check number and types of fields
    !-------------------------------------------------------
    type(gildas),    intent(inout) :: huv
    real,            intent(inout) :: duv(:,:)
    type(uvmap_par), intent(inout) :: map
    logical,         intent(inout) :: error
    !
    integer :: np, nv
    integer :: loff, moff, xoff, yoff, nf, lid
    character(len=12) :: chain
    integer(kind=index_length) :: dim(2)
    real, save, target :: bsize
    real :: value
    logical, parameter :: fromressection=.true.
    !
    map%nfields = 0
    call sic_delvariable('FIELDS',.false.,error)
    error = .false.
    huv%loca%size = huv%gil%dim(1)*huv%gil%dim(2)    ! So that UV is known later
    if (huv%gil%ntrail.eq.0) return
    !
    np = huv%gil%dim(1)
    nv = huv%gil%nvisi
    !
    loff = huv%gil%column_pointer(code_uvt_loff)
    moff = huv%gil%column_pointer(code_uvt_moff)
    !
    xoff = huv%gil%column_pointer(code_uvt_xoff)
    yoff = huv%gil%column_pointer(code_uvt_yoff)
    !
    lid  = huv%gil%column_pointer(code_uvt_id)
    !
    if (lid.ne.0 .and. (loff.eq.0.or.moff.eq.0)) then
       value = duv(lid,1)
       if (any(duv(lid,:).ne.value)) then 
          nf = maxval(duv(lid,:))
          write(chain,'(I12)') nf
          call map_message(seve%e,'READ','Mosaic of '//adjustl(trim(chain))//' fields with only Source ID column')
          call map_message(seve%i,'READ','Use task UV_UPDATE_FIELDS to specify field coordinates')
          huv%loca%size = 0        ! UV undefined at this stage
          error = .true.
          return
       else
          map%nfields = 0
          call map_message(seve%w,'READ','Degenerate mosaic of 1 field with Source ID column')
       endif
    else if (loff.ne.0 .or. moff.ne.0) then
       call mosaic_getfields (duv,np,nv,loff,moff,nf,map%offxy)
       if (nf.gt.1) then
          map%nfields = -nf
          write(chain,'(I12)') nf
          call map_message(seve%i,'READ','Raw mosaic of '//adjustl(trim(chain))//' fields')
       else
          map%nfields = 0
          call map_message(seve%w,'READ','Degenerate raw mosaic of 1 field')
       endif
    else if (xoff.ne.0 .or. yoff.ne.0) then
       call mosaic_getfields (duv,np,nv,xoff,yoff,nf,map%offxy)
       if (nf.gt.1) then
          map%nfields = nf
          write(chain,'(I12)') nf
          call map_message(seve%i,'READ','Phase shifted mosaic of '//adjustl(trim(chain))//' fields')
       else
          map%nfields = 0
          call map_message(seve%w,'READ','Degenerate phase shifted mosaic of 1 field')
       endif
    endif
    !
    if (map%nfields.eq.0) return
    !
    if (huv%gil%nteles.le.0) then
       call map_message(seve%w,'READ','No Telescope section in data') 
       call map_message(seve%r,'READ', &
            &   '         Use command "SPECIFY TELESCOPE Name" to add one') 
    endif
    !  
    call get_bsize(huv,'READ',' ',fromressection,bsize,error)
    call sic_defstructure('FIELDS',.true.,error)
    call sic_def_inte('FIELDS%N',map%nfields,0,dim,.false.,error)
    dim(1:2) = [2,abs(map%nfields)]
    call sic_def_real('FIELDS%OFFSETS',map%offxy,2,dim,.false.,error) 
    call sic_def_real('FIELDS%PRIMARY',bsize,0,dim,.false.,error)
  end subroutine check_uvdata_type
  !
  subroutine mosaic_getfields(visi,np,nv,ixoff,iyoff,nf,doff)
    !----------------------------------------------------------------------
    ! Count number of fields and Get their coordinates
    !----------------------------------------------------------------------
    integer,           intent(in)    :: np           ! Size of a visibility
    integer,           intent(in)    :: nv           ! Number of visibilities
    real,              intent(inout) :: visi(np,nv)  ! Input visibilities
    integer,           intent(in)    :: ixoff        ! X pointer
    integer,           intent(in)    :: iyoff        ! Y pointer
    integer,           intent(out)   :: nf           ! Number of fields
    real, allocatable, intent(out)   :: doff(:,:)    ! Field offsets
    !
    integer :: iv,mfi,nfi,kfi,ifi,ier
    real(kind=4), allocatable :: dtmp(:,:)
    real(kind=4) :: off_tol
    !
    if (nv.le.0) then
       nf = 0
       return
    endif
    !
    ! Scan how many fields
    !
    off_tol = 1E-2*acos(-1.0)/180.0/3600.0       ! 0.01 sec is enough
    nfi = 1
    mfi = 100
    !
    allocate(dtmp(2,mfi),stat=ier)
    dtmp(1,1) = visi(ixoff,1)
    dtmp(2,1) = visi(iyoff,1)
    nfi = 1
    !
    ! Fields are not ordered here
    do iv=2,nv
       kfi = 0
       do ifi=1,nfi
          if (abs(visi(ixoff,iv)-dtmp(1,ifi)).le.off_tol .and. &
               abs(visi(iyoff,iv)-dtmp(2,ifi)).le.off_tol ) then
             visi(ixoff,iv) = dtmp(1,ifi)
             visi(iyoff,iv) = dtmp(2,ifi)
             kfi = ifi
             exit
          endif
       enddo
       !
       ! New field
       if (kfi.eq.0) then
          if (nfi.eq.mfi) then
             allocate(doff(2,mfi),stat=ier)
             doff(:,:) = dtmp(:,:)
             deallocate(dtmp)
             allocate(dtmp(2,2*mfi),stat=ier)
             dtmp(:,1:mfi) = doff
             deallocate(doff)
             mfi = 2*mfi
          endif
          nfi = nfi+1
          dtmp(1,nfi) = visi(ixoff,iv)
          dtmp(2,nfi) = visi(iyoff,iv)
       endif
    enddo
    !
    nf = nfi
    allocate(doff(2,nf),stat=ier)
    doff(:,:) = dtmp(1:2,1:nf)
  end subroutine mosaic_getfields
end module mapping_read
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! Support file for intrinsic functions in Sic
!-----------------------------------------------------------------------
!
subroutine get_funcode(chain,i_code,nfunarg,error)
  use sic_interfaces, except_this=>get_funcode
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Sends back a code for the function contained in CHAIN
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain       ! The line to be analysed
  integer(kind=4),  intent(out)   :: i_code      ! Code for function
  integer(kind=4),  intent(out)   :: nfunarg(2)  ! Min-max number of arguments
  logical,          intent(inout) :: error       ! Logical error flag
  ! Global
  integer(kind=4) :: gpy_findfunc
  ! Local
  character(len=*), parameter :: rname='MTH'
  !
  ! First should check for user defined functions
  select case (chain)
  !
  ! One operand functions
  case ('ABS')
    i_code = code_abs
    nfunarg = 1
  case ('ACOS')
    i_code = code_acos
    nfunarg = 1
  case ('ASIN')
    i_code = code_asin
    nfunarg = 1
  case ('ATAN')
    i_code = code_atan
    nfunarg = 1
  case ('ATANH')
    i_code = code_atanh
    nfunarg = 1
  case ('BESSEL_I0')
    i_code = code_bessel_i0
    nfunarg = 1
  case ('BESSEL_I1')
    i_code = code_bessel_i1
    nfunarg = 1
  case ('BESSEL_J0')
    i_code = code_bessel_j0
    nfunarg = 1
  case ('BESSEL_J1')
    i_code = code_bessel_j1
    nfunarg = 1
  case ('BESSEL_Y0')
    i_code = code_bessel_y0
    nfunarg = 1
  case ('BESSEL_Y1')
    i_code = code_bessel_y1
    nfunarg = 1
  case ('COS')
    i_code = code_cos
    nfunarg = 1
  case ('COSH')
    i_code = code_cosh
    nfunarg = 1
  case ('ERF')
    i_code = code_erf
    nfunarg = 1
  case ('ERFC')
    i_code = code_erfc
    nfunarg = 1
  case ('ERFINV')
    i_code = code_erfinv
    nfunarg = 1
  case ('ERFCINV')
    i_code = code_erfcinv
    nfunarg = 1
  case ('EXP')
    i_code = code_exp
    nfunarg = 1
  case ('INT')
    i_code = code_int
    nfunarg = 1
  case ('LOG')
    i_code = code_log
    nfunarg = 1
  case ('LOG10')
    i_code = code_log10
    nfunarg = 1
  case ('NINT')
    i_code = code_nint
    nfunarg = 1
  case ('SIN')
    i_code = code_sin
    nfunarg = 1
  case ('SINH')
    i_code = code_sinh
    nfunarg = 1
  case ('SQRT')
    i_code = code_sqrt
    nfunarg = 1
  case ('TAN')
    i_code = code_tan
    nfunarg = 1
  case ('TANH')
    i_code = code_tanh
    nfunarg = 1
  case ('FLOOR')
    i_code = code_floor
    nfunarg = 1
  case ('CEILING')
    i_code = code_ceiling
    nfunarg = 1
  case ('EXIST')
    i_code = code_exist
    nfunarg = 1
  case ('FILE')
    i_code = code_file
    nfunarg = 1
  case ('FUNCTION')
    i_code = code_function
    nfunarg = 1
  case ('SYMBOL')
    i_code = code_symbol
    nfunarg = 1
  !
  ! Function with 2 arguments or more
  case ('MAX')
    i_code = code_max
    nfunarg = 2
  case ('MIN')
    i_code = code_min
    nfunarg = 2
  case ('ATAN2')
    i_code = code_atan2
    nfunarg = 2
  case ('BESSEL_IN')
    i_code = code_bessel_in
    nfunarg = 2
  case ('BESSEL_JN')
    i_code = code_bessel_jn
    nfunarg = 2
  case ('BESSEL_YN')
    i_code = code_bessel_yn
    nfunarg = 2
  case ('DIM')
    i_code = code_dim
    nfunarg = 2
  case ('MOD')
    i_code = code_mod
    nfunarg = 2
  case ('SIGN')
    i_code = code_sign
    nfunarg = 2
    !
  case ('TYPEOF')
    i_code = code_typeof
    nfunarg = 1
  case ('RANK')
    i_code = code_rank
    nfunarg = 1
  case ('SIZE')
    i_code = code_size
    nfunarg(1) = 1  ! At least 1 arg
    nfunarg(2) = 2  ! At most 2 args
  case ('INDEX')
    i_code = code_index
    nfunarg = 2
  case ('LEN')
    i_code = code_len
    nfunarg = 1
  case ('LEN_TRIM')
    i_code = code_len_trim
    nfunarg = 1
  case ('ALL')
    i_code = code_all
    nfunarg = 1
  case ('ANY')
    i_code = code_any
    nfunarg = 1
  case ('ISNAN')
    i_code = code_isnan
    nfunarg = 1
  case ('ISNUM')
    i_code = code_isnum
    nfunarg = 1
  !
  ! Try a program-defined function
  case default
    call sic_get_func(chain,i_code,nfunarg,error)
    if (error) then
#if defined(GAG_USE_PYTHON)
      if (gpy_findfunc(chain,len_trim(chain)).eq.0) then
        i_code = code_pyfunc
        nfunarg = 0
        error = .false.
      else
        call sic_message(seve%e,rname,'Unknown function '//chain)
      endif
#else
      call sic_message(seve%e,rname,'Unknown function '//chain)
#endif
    endif
  end select
end subroutine get_funcode
!
recursive subroutine read_operand_byfunc(funcode,chain,nch,descr,error)
  use gbl_message
  use sic_interfaces, except_this=>read_operand_byfunc
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Specific operand parsing for functions which do not accept
  ! numerical operands as arguments.
  !  Recursive for e.g. evaluating ANY(A.EQ.1). The function ANY invokes
  ! its own build_tree+read_operand_byfunc to compute the array 'A.EQ.1'
  !---------------------------------------------------------------------
  integer(kind=4),        intent(inout) :: funcode  ! Function code, emptied in return
  character(len=*),       intent(in)    :: chain    ! The operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  type(sic_descriptor_t)                :: descr    ! Resulting descriptor of operand
  logical,                intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  !
  select case (funcode)
  case (code_exist)
    call read_operand_exist(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_file)
    call read_operand_file (chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_typeof,code_rank)
    call read_operand_descr(chain,nch,funcode,descr,error)
    funcode = code_nop
    !
  case (code_function)
    call read_operand_func(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_symbol)
    call read_operand_symb(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_len)
    call read_operand_len(chain,nch,.false.,descr,error)
    funcode = code_nop
    !
  case (code_len_trim)
    call read_operand_len(chain,nch,.true.,descr,error)
    funcode = code_nop
    !
  case (code_all)
    call read_operand_allorany(chain,nch,.true.,descr,error)
    funcode = code_nop
    !
  case (code_any)
    call read_operand_allorany(chain,nch,.false.,descr,error)
    funcode = code_nop
    !
  case (code_isnan)
    call read_operand_isnan(chain,nch,descr,error)
    funcode = code_nop
    !
  case (code_isnum)
    call read_operand_isnum(chain,nch,descr,error)
    funcode = code_nop
    !
  case default
    call read_operand(chain,nch,descr,error)
    ! Keep code for other "normal" functions
    !
  end select
  !
  if (error) then
    call sic_message(seve%e,rname,'Error reading operand '//chain(1:nch))
    return
  endif
  !
end subroutine read_operand_byfunc
!
subroutine read_operand_exist(chain,nch,descr,error)
  use gildas_def
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_exist
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a variable exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: descr  ! Operand descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable.
  found = .true.
  call sic_descriptor (chain(1:ip),descr,found)    ! Checked
  if (.not.found) then
    call sic_descriptor ('NO',descr,found) ! Checked
  else
    call sic_descriptor ('YES',descr,found)    ! Checked
  endif
  descr%readonly = .false.
  descr%status = readonly_operand
end subroutine read_operand_exist
!
subroutine read_operand_descr(chain,nch,funcode,descr,error)
  use gbl_message
  use sic_interfaces, except_this=>read_operand_descr
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Get one of the variable descriptor properties
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain    ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  integer(kind=4),        intent(in)    :: funcode  ! Function code
  type(sic_descriptor_t), intent(out)   :: descr    ! Operand descriptor
  logical,                intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  logical :: found
  integer(kind=4) :: ip,val
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable.
  found = .true.
  call sic_descriptor (chain(1:ip),descr,found)    ! Checked
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//chain(1:ip))
    error = .true.
    return
  endif
  !
  ! Put the desired value in a temporary variable
  if (funcode.eq.code_typeof) then
    val = descr%type
  elseif (funcode.eq.code_rank) then
    val = descr%ndim
  endif
  !
  ! Put the value in a temporary variable
  call sic_incarnate(val,descr,error)
  if (error)  return
  !
end subroutine read_operand_descr
!
subroutine read_operand_len(chain,nch,trimmed,descr,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_len
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return the length (trimmed or not) of a Sic variable
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain    ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch      ! Length of chain
  logical,                intent(in)    :: trimmed  ! Trimmed value?
  type(sic_descriptor_t), intent(out)   :: descr    ! Operand descriptor
  logical,                intent(inout) :: error    ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=8) :: rname
  logical :: found
  integer(kind=4) :: ip,length
  character(len=1) :: onechar
  integer(kind=address_length) :: ipnt
  !
  if (trimmed) then
    rname = 'LEN_TRIM'
  else
    rname = 'LEN'
  endif
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! It must be a variable. NB: it seems difficult to allow plain text
  ! strings e.g. SAY 'LEN("ABC")', because of complicated combinations
  ! like in IF LEN_TRIM("PI = "'PI').GT.0 THEN
  found = .true.  ! Verbose
  call sic_descriptor(chain(1:ip),descr,found)
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//chain(1:ip))
    error = .true.
    return
  elseif (descr%ndim.ne.0) then
    call sic_message(seve%e,rname,'Variable '//chain(1:ip)//' must be scalar')
    error = .true.
    return
  elseif (descr%type.le.0) then
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:ip)//' must be a character string')
    error = .true.
    return
  else
    if (trimmed) then
      ! Avoid copy in a (limited) temporary string
      do while (descr%type.ge.1)
        ipnt = bytpnt(descr%addr,membyt)+descr%type-1
        call bytoch(membyt(ipnt),onechar,1)
        if (onechar.ne.' ')  exit
        descr%type = descr%type-1  ! Try previous character
      enddo
    endif
    length = descr%type
  endif
  !
  ! Put the value in a temporary variable
  call sic_incarnate(length,descr,error)
  if (error)  return
  !
end subroutine read_operand_len
!
subroutine read_operand_symb(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_symb
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a SYMBOL exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip
  character(len=32) :: tran
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Check if it exists and is not Void
  call sic_getsymbol(chain(1:ip),tran,error)
  if (error.or.(len_trim(tran).eq.0)) then
    call sic_descriptor ('NO',descr,found)
    error = .false.
  else
    call sic_descriptor ('YES',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_symb
!
subroutine read_operand_func(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_func
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a function exist...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  integer(kind=4) :: ip,i
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Check if it exists
  i = sic_get_expr(chain(1:ip),ip)
  if (i.ne.0) then
    call sic_descriptor ('YES',descr,found)
  else
    call sic_descriptor ('NO',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_func
!
subroutine read_operand_file(chain,nch,descr,error)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_structures
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_file
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a file exist...
  !  The input file name (CHAIN) can be any "implicitely formatted" SIC
  ! expression.
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)    :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out)   :: descr  ! Operand descriptor
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=filename_length) :: name,file,nami
  logical :: found
  integer(kind=4) :: ip,larg,iarg
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  ip = nch
  do while (ip.ge.1 .and. (chain(ip:ip).eq.')'.or.chain(ip:ip).eq.' '))
    ip = ip-1
  enddo
  !
  ! Debugged by S.Guilloteau 15-May-2000
  !
  ! It must be a file name, possibly coded, e.g. a variable name 'MYVAR'.
  ! Two calls to SIC_EXPAND required.
  call sic_expand(nami,chain,1,ip,iarg,error)
  call sic_expand(name,nami,1,iarg,larg,error)
  !
  ! Check just in case
  if (name(1:larg).eq.chain(1:ip)) then
    call sic_get_char(name,nami,iarg,error)
    if (iarg.ne.0) then
      name = nami
      larg = iarg
    endif
    error = .false.
  endif
  if (error) return
  !
  ! Use the generic search, which returns the file name even if a path
  ! is specified in the logical name field.
  if (sic_findfile(name,file,' ',' ')) then
    call sic_descriptor ('YES',descr,found)
  else
    call sic_descriptor ('NO',descr,found)
  endif
  descr%readonly = .false.
  descr%status = readonly_operand       ! READ status in module 'sic_dictionaries'
end subroutine read_operand_file
!
subroutine read_operand_allorany(chain,nch,doall,odesc,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_allorany
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return true if all or any elements of a logical array are true
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  logical,                intent(in)  :: doall  ! Do ALL or ANY?
  type(sic_descriptor_t), intent(out) :: odesc  ! Output descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  logical, external :: all_or_any
  ! Local
  character(len=3) :: rname
  logical :: found
  integer(kind=4) :: nc
  integer(kind=address_length) :: ip
  type(sic_descriptor_t) :: idesc
  !
  if (doall) then
    rname = 'ALL'
  else
    rname = 'ANY'
  endif
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    ! Not a variable. Try to evaluate a vectorized logical expression
    call sic_math_desc(chain,nc,fmt_l,desc=idesc,error=error)
    if (error) then
      call sic_message(seve%e,rname,'Invalid logical expression '//chain(1:nc))
      return
    endif
  endif
  if (idesc%type.ne.fmt_l) then
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:nc)//' must a logical variable or expression')
    error = .true.
    call sic_volatile(idesc)
    return
  endif
  !
  ip = gag_pointer(idesc%addr,memory)
  found = .false.
  if (all_or_any(memory(ip),desc_nelem(idesc),doall)) then
    call sic_descriptor('YES',odesc,found)
  else
    call sic_descriptor('NO',odesc,found)
  endif
  odesc%readonly = .false.
  odesc%status = readonly_operand       ! READ status in module 'sic_dictionaries'
  call sic_volatile(idesc)
  !
end subroutine read_operand_allorany
!
function all_or_any(l,n,doall)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Evaluate ALL(L) or ANY(L)
  !---------------------------------------------------------------------
  logical :: all_or_any  ! Function value on return
  integer(kind=size_length), intent(in) :: n
  logical,                   intent(in) :: l(n)
  logical,                   intent(in) :: doall
  if (doall) then
    all_or_any = all(l)
  else
    all_or_any = any(l)
  endif
end function all_or_any
!
subroutine read_operand_isnan(chain,nch,odesc,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>read_operand_isnan
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return a logical array which is true for each value evaluating as
  ! NaN
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: odesc  ! Output descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ISNAN'
  logical :: found
  integer(kind=4) :: nc,ier
  integer(kind=address_length) :: ip,op
  type(sic_descriptor_t) :: idesc
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    ! Not a variable. Try to evaluate a vectorized logical expression
    call sic_math_desc(chain,nc,fmt_r8,desc=idesc,error=error)
    if (error) then
      call sic_message(seve%e,rname,'Invalid expression '//chain(1:nc))
      return
    endif
  endif
  if (idesc%type.ne.fmt_r4 .and.  &
      idesc%type.ne.fmt_r8) then
    ! We could tolerate integers. Unclear for complex.
    call sic_message(seve%e,rname,  &
      'Variable '//chain(1:nc)//' must a floating point variable or expression')
    error = .true.
    call sic_volatile(idesc)
    return
  endif
  !
  ! Create a clone of same size but logical
  odesc%type = fmt_l
  odesc%ndim = idesc%ndim
  odesc%dims(:) = idesc%dims(:)
  odesc%size = desc_nelem(odesc)
  ier = sic_getvm(odesc%size,odesc%addr)
  if (ier.ne.1)  goto 10
  odesc%head => null()
  odesc%status = scratch_operand
  odesc%readonly = .false.
  ! Fill it
  ip = gag_pointer(idesc%addr,memory)
  op = gag_pointer(odesc%addr,memory)
  if (idesc%type.eq.fmt_r4) then
    call isnan_r4(memory(ip),memory(op),desc_nelem(idesc))
  else
    call isnan_r8(memory(ip),memory(op),desc_nelem(idesc))
  endif
  !
10 continue
  call sic_volatile(idesc)
  !
end subroutine read_operand_isnan
!
subroutine isnan_r4(in,out,n)
  use ieee_arithmetic
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n
  real(kind=4),              intent(in)  :: in(n)
  logical,                   intent(out) :: out(n)
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = ieee_is_nan(in(i))
  enddo
end subroutine isnan_r4
!
subroutine isnan_r8(in,out,n)
  use ieee_arithmetic
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n
  real(kind=8),              intent(in)  :: in(n)
  logical,                   intent(out) :: out(n)
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = ieee_is_nan(in(i))
  enddo
end subroutine isnan_r8
!
subroutine read_operand_isnum(chain,nch,descr,error)
  use gildas_def
  use sic_interactions
  use sic_interfaces, except_this=>read_operand_isnum
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Find if a string is a number or scalar number variable...
  !---------------------------------------------------------------------
  character(len=*),       intent(in)  :: chain  ! Chain containing operand
  integer(kind=4),        intent(in)  :: nch    ! Length of chain
  type(sic_descriptor_t), intent(out) :: descr  ! Operand descriptor
  logical,                intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ISNUM'
  logical :: found
  integer(kind=4) :: nc, ier
  type(sic_descriptor_t) :: idesc
  real(8) :: dble
  !
  error = .false.
  !
  ! Removes closing parenthesis. Not very efficient: their index is known from
  ! GET_LEVEL
  nc = nch
  do while (nc.ge.1 .and. (chain(nc:nc).eq.')'.or.chain(nc:nc).eq.' '))
    nc = nc-1
  enddo
  !
  ! Default result
  descr%readonly = .false.
  descr%status = readonly_operand
  error = .false.
  call sic_descriptor ('NO',descr,found)
  !
  ! It can be a variable. Non-contiguous sub-arrays allowed.
  found = .true.  ! Verbose
  call sic_materialize(chain(1:nc),idesc,found)
  if (.not.found) then
    !
    if (chain(1:1).eq."'".and.chain(nc:nc).eq."'") then
      ! Try to evaluate the expression
      call sic_math_desc(chain,nc,fmt_r8,desc=idesc,error=error)
      call sic_volatile(idesc)
      if (error) then
        call sic_message(seve%e,rname,'Invalid expression '//chain(1:nc))
        return
      endif
    else
      ! Plain reading 
      read(chain(1:nc),*,iostat=ier) dble
      idesc%type = fmt_l
      if (ier.eq.0) idesc%type = fmt_r8 ! A number
    endif
  endif
  !
  ! Check it is scalar
  !!Print *,'Allowed types ',fmt_r4,fmt_r8,fmt_i4,fmt_i8
  if (idesc%type.eq.fmt_r4 .or.  &
      idesc%type.eq.fmt_r8 .or.  &
      idesc%type.eq.fmt_i4 .or.  &
      idesc%type.eq.fmt_i8) then
    if (idesc%ndim.eq.0) then
      call sic_descriptor ('YES',descr,found) ! Checked
    else if (product(idesc%dims(1:idesc%ndim)).eq.1) then
      call sic_descriptor ('YES',descr,found) ! Checked
    endif
  endif
  call sic_volatile(idesc)
  descr%readonly = .false.
  descr%status = readonly_operand
  error = .false.
end subroutine read_operand_isnum
!

subroutine dofft_parallel_v_pseudo_out (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer :: iv_block, iv_first, iv_last
  integer my,kx,ky
  integer ier, ithread, mthread,it
  real(4), allocatable :: mpa(:,:,:,:)
  real(8) :: elapsed_s,elapsed_e,elapsed
  real :: b_wait
  integer :: n_wait
  logical :: error
  !
  n_wait = 0
#ifndef GAG_USE_STATICLINK
  !$  call sic_get_inte('MY_WAIT',n_wait,error)
#endif
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  write(*,'(A)') 'I-DOFFT,  Pseudo Parallel V ',mthread
  mthread = min(mthread,4)
  !$  elapsed_s = omp_get_wtime()
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  allocate(mpa(2*nc+2,nx,my,mthread),stat=ier)
  if (ier.ne.0) then
    write(*,'(A,I10)') 'E-DOFFT,  Memory allocation error ',ier
    return
  endif
  mpa = 0.0
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished initializing -- Elapsed ',elapsed
  !
  do ithread=1,mthread
  !
  ! Start with loop on observed visibilities
  iv_block = (nv+mthread-1)/mthread
  iv_first = 1+(ithread-1)*iv_block
  iv_last  = min(ithread*iv_block,nv)
  staper = 1.0
  !
  do i=iv_first,iv_last
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = -v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
!!    write(2,'(A,I6,A,I2,4F10.2,A,I6,I6,I6,I6)') 'Visi ',i,' **Pseudo** ',ithread &
!!      & ,u,v,sup,' bound ',ixm,ixp,iym,iyp
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      if (iyp.gt.my) then
        print *,'IYP ',iyp,' > MY ',my
        iyp = my
      endif
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
               mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                res*result
            endif
            call big_wait(n_wait,b_wait)
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                  res*result
              endif
            enddo
            call big_wait(n_wait,b_wait)
          endif
        enddo
      endif
    endif
  enddo
  !
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2,A,I2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed,' Bloc ',ithread
  !
  enddo
  !
  ! Fill Map array
  do iy=1,my
    map(:,:,iy) = mpa(:,:,iy,1)
    do it=2,mthread
      map(:,:,iy) = map(:,:,iy) + mpa(:,:,iy,it)
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Filling -- Elapsed ',elapsed
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Symmetry -- Elapsed ',elapsed
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_parallel_v_pseudo_out
!
subroutine dofft_parallel_v_true_out (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer :: iv_block, iv_first, iv_last
  integer my,kx,ky
  integer ier, ithread, nthread, mthread, lchunk, it
  real(4), allocatable :: mpa(:,:,:,:)
  real(8) :: elapsed_s,elapsed_e,elapsed
  real :: b_wait
  integer :: n_wait
  logical :: error
  n_wait = 0
#ifndef GAG_USE_STATICLINK
  !$  call sic_get_inte('MY_WAIT',n_wait,error)
#endif
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  write(*,'(A)') 'I-DOFFT,  True Parallel V ',mthread
  mthread = min(mthread,4)
  !$  elapsed_s = omp_get_wtime()
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  allocate(mpa(2*nc+2,nx,my,mthread),stat=ier)
  if (ier.ne.0) then
    write(*,'(A,I10)') 'E-DOFFT,  Memory allocation error ',ier
    return
  endif
  mpa = 0.0
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished initializing -- Elapsed ',elapsed
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP   & SHARED(nc,nv,nx,my,mapx,mapy,ny) &
  !$OMP   & SHARED(jx,jy,cx,sx,cy,sy,etaper,do_taper,io) &
  !$OMP   & SHARED(xinc,xref,yinc,yref,sup,ubias,vbias,ufac,vfac) &
  !$OMP   & SHARED(ubuff,vbuff,visi,we) SHARED(mpa) &
  !$OMP   & PRIVATE(i,u,v,staper,result,resima,ixp,ixm,iyp,iym) &
  !$OMP   & PRIVATE(dv,iv,du,iu,res,iin,iou,iy,ix,ic) &
  !$OMP   & PRIVATE(ithread,lchunk,nthread) &
  !$OMP   & PRIVATE(it,kx,ky) SHARED(mthread,b_wait,n_wait) &
  !$OMP   & FIRSTPRIVATE(elapsed_s) PRIVATE(elapsed_e,elapsed) &
  !$OMP   & PRIVATE(iv_block, iv_first, iv_last)
  !
  !$OMP DO
  do ithread=1,mthread
  !
  ! Start with loop on observed visibilities
  iv_block = (nv+mthread-1)/mthread
  iv_first = 1+(ithread-1)*iv_block
  iv_last  = min(ithread*iv_block,nv)
  staper = 1.0
  !
  do i=iv_first,iv_last
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = -v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
!!    write(2,'(A,I6,A,I2,4F10.2,A,I6,I6,I6,I6)') 'Visi ',i,' **Pseudo** ',ithread &
!!      & ,u,v,sup,' bound ',ixm,ixp,iym,iyp
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      if (iyp.gt.my) then
        print *,'IYP ',iyp,' > MY ',my
        iyp = my
      endif
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                res*result
            endif
            call big_wait(n_wait,b_wait)
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  res*result
              endif
            enddo
            call big_wait(n_wait,b_wait)
          endif
        enddo
      endif
    endif
  enddo
  !
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2,A,I2,A,I2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed, &
    ' Bloc ',ithread,' Thread ',ithread
  !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Fill Map array
  do iy=1,my
    map(:,:,iy) = mpa(:,:,iy,1)
    do it=2,mthread
      map(:,:,iy) = map(:,:,iy) + mpa(:,:,iy,it)
    enddo
  enddo
  !$ elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Filling -- Elapsed ',elapsed
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Symmetry -- Elapsed ',elapsed
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_parallel_v_true_out
!
subroutine dofft_parallel_v_pseudo (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer my,kx,ky
  integer ier,ithread,mthread,it
  real(4), allocatable :: mpa(:,:,:,:)
  real(8) :: elapsed_s,elapsed_e,elapsed
  real :: b_wait
  integer :: n_wait
  logical :: error
  !
  n_wait = 0
#ifndef GAG_USE_STATICLINK
  !$  call sic_get_inte('MY_WAIT',n_wait,error)
#endif
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  write(*,'(A)') 'I-DOFFT,  Pseudo Parallel V ',mthread
  mthread = min(mthread,4)
  !$  elapsed_s = omp_get_wtime()
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  !
  ! Use symmetry
  my = ny/2+1
  allocate(mpa(mthread,2*nc+2,nx,my),stat=ier)
  if (ier.ne.0) then
    write(*,'(A,I10)') 'E-DOFFT,  Memory allocation error ',ier
    return
  endif
  mpa = 0.0
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished initializing -- Elapsed ',elapsed
  !
  do ithread=1,mthread
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=ithread,nv,mthread
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = -v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
!!    write(2,'(A,I6,A,I2,4F10.2,A,I6,I6,I6,I6)') 'Visi ',i,' **Pseudo** ',ithread &
!!      & ,u,v,sup,' bound ',ixm,ixp,iym,iyp
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      if (iyp.gt.my) then
        print *,'IYP ',iyp,' > MY ',my
        iyp = my
      endif
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
!                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
                mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
!                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
                 mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
!              mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
               mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                res*result
            endif
            call big_wait(n_wait,b_wait)
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                mpa (ithread,iou,ix,iy) = mpa(ithread,iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
            call big_wait(n_wait,b_wait)
          endif
        enddo
      endif
    endif
  enddo
  !
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2,A,I2A,I2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed, &
    & ' Bloc ',ithread,' Single Thread '
  !
  enddo
  !
  ! Fill Map array
  do iy=1,my
    map(:,:,iy) = mpa(1,:,:,iy)
    do it=2,mthread
      map(:,:,iy) = map(:,:,iy) + mpa(it,:,:,iy)
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Filling -- Elapsed ',elapsed
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Symmetry -- Elapsed ',elapsed
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_parallel_v_pseudo
!
subroutine dofft_parallel_v_true (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer my,kx,ky
  integer ier, ithread, nthread, mthread, lchunk, it
  real(4), allocatable :: mpa(:,:,:,:)
  real(8) :: elapsed_s,elapsed_e,elapsed
  real :: b_wait
  integer :: n_wait, jthread
  logical :: error
  n_wait = 0
#ifndef GAG_USE_STATICLINK
  !$  call sic_get_inte('MY_WAIT',n_wait,error)
#endif
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  write(*,'(A)') 'I-DOFFT,  True Parallel V ',mthread
  !$  mthread = min(mthread,4)
  !$  elapsed_s = omp_get_wtime()
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  allocate(mpa(mthread,2*nc+2,nx,my),stat=ier)
  if (ier.ne.0) then
    write(*,'(A,I10)') 'E-DOFFT,  Memory allocation error ',ier
    return
  endif
  mpa = 0.0
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished initializing -- Elapsed ',elapsed
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP   & SHARED(nc,nv,nx,my,mapx,mapy,ny) &
  !$OMP   & SHARED(jx,jy,cx,sx,cy,sy,etaper,do_taper,io) &
  !$OMP   & SHARED(xinc,xref,yinc,yref,sup,ubias,vbias,ufac,vfac) &
  !$OMP   & SHARED(ubuff,vbuff,visi,we) SHARED(mpa) &
  !$OMP   & PRIVATE(i,u,v,staper,result,resima,ixp,ixm,iyp,iym) &
  !$OMP   & PRIVATE(dv,iv,du,iu,res,iin,iou,iy,ix,ic) &
  !$OMP   & PRIVATE(ithread,jthread,lchunk,nthread) &
  !$OMP   & PRIVATE(it,kx,ky) SHARED(mthread,b_wait,n_wait) &
  !$OMP   & FIRSTPRIVATE(elapsed_s) PRIVATE(elapsed_e,elapsed)
  !
  !$OMP DO
  do ithread=1,mthread
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=ithread,nv,mthread
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = -v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
!!    write(2,'(A,I6,A,I2,4F10.2,A,I6,I6,I6,I6)') 'Visi ',i,' **Pseudo** ',ithread &
!!      & ,u,v,sup,' bound ',ixm,ixp,iym,iyp
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      if (iyp.gt.my) then
        print *,'IYP ',iyp,' > MY ',my
        iyp = my
      endif
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
!                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
                mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
!                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
                 mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
!              mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
               mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                res*result
            endif
            call big_wait(n_wait,b_wait)
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  mpa (ithread,iou,ix,iy) = mpa (ithread,iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                mpa (ithread,iou,ix,iy) = mpa(ithread,iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
            call big_wait(n_wait,b_wait)
          endif
        enddo
      endif
    endif
  enddo
  !
  !$  elapsed_e = omp_get_wtime()
  !$  jthread = omp_get_thread_num()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2,A,I2,I2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed, &
    ' Bloc ',ithread, jthread
  !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Fill Map array
  do iy=1,my
    map(:,:,iy) = mpa(1,:,:,iy)
    do it=2,mthread
      map(:,:,iy) = map(:,:,iy) + mpa(it,:,:,iy)
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Filling -- Elapsed ',elapsed
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Symmetry -- Elapsed ',elapsed
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_parallel_v_true
!
!
subroutine dofft_parallel_v_true2 (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  real usup,vsup
  integer my,kx,ky
  integer ier, ithread, nthread, mthread, lchunk, it
  real(4), allocatable :: mpa(:,:,:,:)
  real(8) :: elapsed_s,elapsed_e,elapsed
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  write(*,'(A,I3)') 'I-DOFFT,  True Parallel V - Threads',mthread
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  usup = sup(1)
  vsup = sup(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  allocate(mpa(2*nc+2,nx,my,mthread),stat=ier)
  if (ier.ne.0) then
    write(*,'(A,I12)') 'E-DOFFT,  Memory allocation error ',ier
    return
  endif
  mpa = 0.0
  !
  ! Start with loop on observed visibilities
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP   & SHARED(nc,nv,nx,my,mapx,mapy,ny) &
  !$OMP   & SHARED(jx,jy,cx,sx,cy,sy,etaper,do_taper,io) &
  !$OMP   & SHARED(xinc,xref,yinc,yref,usup,vsup,ubias,vbias,ufac,vfac) &
  !$OMP   & SHARED(ubuff,vbuff,visi,we) SHARED(mpa) &
  !$OMP   & PRIVATE(i,u,v,staper,result,resima,ixp,ixm,iyp,iym) &
  !$OMP   & PRIVATE(dv,iv,du,iu,res,iin,iou,iy,ix,ic) &
  !$OMP   & PRIVATE(ithread,lchunk,nthread) &
  !$OMP   & PRIVATE(it,kx,ky) SHARED(map,mthread) PRIVATE(elapsed_s,elapsed_e,elapsed)
  nthread = 1
  !$  elapsed_s = omp_get_wtime()
  !$  nthread = omp_get_num_threads()
  lchunk = (nv+nthread-1)/nthread
  if (lchunk.gt.64) lchunk = lchunk/8
  print *,'LCHUNK ',lchunk
  !! ithread = omp_get_thread_num() + 1
  if (.not.do_taper) staper = 1.0
  !$OMP DO      !! SCHEDULE(STATIC,lchunk)
  do ithread=1,mthread
    !$  print *,'Thread ',ithread,omp_get_thread_num()
  !
  do i=ithread,nv,mthread
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    if (v.gt.0) then
      u = -u
      v = -v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-usup)/xinc+xref+1.0)
    ixm = int((u+usup)/xinc+xref)
    iym = int((v-vsup)/yinc+yref)
    iyp = min(my,int((v+vsup)/yinc+yref+1.0))
!!    write(3,'(A,I6,A,I2,4F10.2,A,I6,I6,I6,I6)') 'Visi ',i,' **thread** ',ithread &
!!      & ,u,v,usup,vsup,' bound ',ixm,ixp,iym,iyp
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      if (iyp.gt.my) then
        print *,'IYP ',iyp,' > MY ',my
        iyp = my
      endif
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.vsup) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.usup) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                res*result
            endif
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.vsup) then
      ixp = int((u-usup)/xinc+xref+1.0)
      ixm = int((u+usup)/xinc+xref)
      iym = int((v-vsup)/yinc+yref)
      iyp = min(my,int((v+vsup)/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        if (iyp.gt.my) then
          print *,'IYP ',iyp,' > MY ',my
          iyp = my
        endif
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.vsup) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.usup) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  mpa (iou,ix,iy,ithread) = mpa (iou,ix,iy,ithread) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                mpa (iou,ix,iy,ithread) = mpa(iou,ix,iy,ithread) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    endif
  enddo
  !
  enddo
  !$OMP END DO
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
  !
  ! Fill Map array
  !$OMP DO
  do iy=1,my
    map(:,:,iy) = mpa(:,:,iy,1)
    do it=2,mthread
      map(:,:,iy) = map(:,:,iy) + mpa(:,:,iy,it)
    enddo
  enddo
  !$OMP END DO
  !
  ! Apply symmetry
  !$OMP DO
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$OMP END DO
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
  !$OMP END PARALLEL
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_parallel_v_true2
!
subroutine big_wait(n,b)
  real, intent(inout) :: b
  integer, intent(in) :: n
  integer i
  real a
  !
  integer, save :: j=0
  !
  real(8), parameter :: pi=3.141592653589793d0
  !
  b = 0
  do i=1,n
    a = i*pi/n
    b = b+cos(a)
  enddo
  if (j.ne.n) print *,'MY_wait ',n,b
  j = n
end subroutine big_wait

subroutine gtx_err
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtx_err
  use gildas_def
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Traps an error according to ERFLAG.
  !---------------------------------------------------------------------
  error_condition = .true.
  if (erflag) return
  call gtv_message(seve%f,'GTVIRT','Error not trapped')
  call sysexi (fatale)
end subroutine gtx_err

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_put
  use cubetools_parameters
  use cubetools_structure
  use cubeedit_messaging
  use cubeheader_edit_tool
  use cubeedit_putdata
  !
  public :: put
  private
  !
  type :: put_comm_t
     type(option_t), pointer :: comm
     type(edit_comm_t)       :: head
     type(putdata_comm_t)    :: data
   contains
     procedure, public  :: register => cubeedit_put_comm_register
     procedure, private :: parse    => cubeedit_put_comm_parse
     procedure, private :: main     => cubeedit_put_comm_main 
  end type put_comm_t
  type(put_comm_t) :: put
  !
  type put_user_t
     character(len=varn_l) :: edid
     type(edit_user_t)     :: head
     type(putdata_user_t)  :: data
  end type put_user_t
  !
contains
  !
  subroutine cubeedit_put_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command PUT
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(put_user_t) :: user
    character(len=*), parameter :: rname='PUT>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call put%parse(line,user,error)
    if (error) return
    call put%main(user,error)
    if (error) return
  end subroutine cubeedit_put_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_put_comm_register(comm,error)
    use cubedag_parameters
    !-------------------------------------------------------------------
    ! Register EDIT\PUT and its options
    !-------------------------------------------------------------------
    class(put_comm_t), intent(inout) :: comm
    logical,           intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='PUT>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'PUT','[bufferid]',&
         'Update header or data information for an edited buffer',&
         'Update header metadata or data values of an opened edited&
         & buffer. PUT applies updates to the selected edited buffer&
         & identifier.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Header selectors (/SOURCE, /SPATIALFRAME, /PTYPE, /PCENTER,&
         & /PANGLE, /BEAM, /UNIT, /NOISE, /AXIS, /AXNAMES,&
         & /OBSERVATORY, /LINE, /FREQUENCY, /WAVELENGTH, /VELOCITY,&
         & /REDSHIFT, /SPECTRALFRAME) update metadata fields.'//strg_cr//&
         '- Data selectors (/ZERO, /FIRST, /LAST, /NEXT, /PREVIOUS,&
         & /AFTERLAST, /CURRENT, /ENTRY, /PIXEL, /CHANNEL) choose where&
         & values are written in cube data.'//strg_cr//&
         '- /FROM provides the SIC variable name used for data write&
         & operations.'//strg_cr//&
         '- If bufferid is omitted, PUT targets the current edited&
         & buffer identifier (*).'//strg_bl//&
         'Notes:'//strg_cr//&
         '- PUT does not enforce semantic consistency across all header&
         & fields. Use CUBE\MODIFY for coherent model-level header&
         & transformations.'//strg_cr//&
         '- The edited buffer is registered in the DAG only after CLOSE.'&
         //strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> PUT work /SOURCE MyObject'//strg_cr//&
         'CUBE> PUT work /CHANNEL 10 /FROM spec'//strg_cr//&
         'CUBE> PUT work /AXIS 1 256 0.0 1.0 km/s LINEAR'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN work /LIKE refcube'//strg_cr//&
         'CUBE> GET work /CHANNEL 10 /INTO spec'//strg_cr//&
         'CUBE> PUT work /CHANNEL 10 /FROM spec'//strg_cr//&
         'CUBE> CLOSE work',&
         cubeedit_put_command,&
         comm%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_emp,&
         code_arg_optional,&
         error)
    if (error) return
    !
    call comm%head%register(error)
    if (error) return
    call comm%data%register(error)
    if (error) return
  end subroutine cubeedit_put_comm_register
  !
  subroutine cubeedit_put_comm_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for command PUT
    !-------------------------------------------------------------------
    class(put_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(put_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='PUT>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    user%edid = strg_star
    call cubetools_getarg(line,comm%comm,1,user%edid,.not.mandatory,error)
    if (error) return
    !
    call comm%head%parse(line,user%head,error)
    if (error) return
    call comm%data%parse(line,user%data,error)
    if (error) return
  end subroutine cubeedit_put_comm_parse
  !
  subroutine cubeedit_put_comm_main(comm,user,error)
    use cube_types
    use cubeedit_opened_types
    !-------------------------------------------------------------------
    ! Main routine for command PUT
    !-------------------------------------------------------------------
    class(put_comm_t), intent(in)    :: comm
    type(put_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(cube_t), pointer :: cube
    integer(kind=entr_k) :: ie
    character(len=*), parameter :: rname='PUT>COMM>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_cube_pointer(user%edid,cube,error)
    if (error) return
    !
    call put%head%main(user%head,cube%head,error)
    if (error) return
    call opened%get_cube_entry(user%edid,ie,error)
    if (error) return   
    call put%data%main(user%data,cube,ie,error)
    if (error) return
    call opened%set_cube_entry(user%edid,ie,error)
    if (error) return   
  end subroutine cubeedit_put_comm_main
end module cubeedit_put
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtholo_pack_set(pack)
  use gpack_def
  use mrtholo_dependencies_interfaces
  use mrtholo_interfaces, except_this => mrtholo_pack_set
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  external :: clic_pack_set
  !
  pack%name='mrtholo'
  pack%ext='.holo'
  pack%authors="R.Lucas"
  pack%depend(1:4) = (/ locwrd(sic_pack_set),    locwrd(greg_pack_set),  &
                        locwrd(mrtcal_pack_set), locwrd(clic_pack_set)/)
  pack%init=locwrd(mrtholo_pack_init)
  pack%clean=locwrd(mrtholo_pack_clean)
  !
end subroutine mrtholo_pack_set
!
subroutine mrtholo_pack_init(gpack_id,error)
  use mrtholo_interfaces, except_this => mrtholo_pack_init
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Init messaging
  call mrtholo_message_set_id(gpack_id)
  ! Init error flag
  error = .false.
  ! MRTHOLO package specific initialization
  call mrtholo_init(error)
  if (error) return
  ! Load local language
  call mrtholo_load
  !
end subroutine mrtholo_pack_init
!
subroutine mrtholo_pack_clean(error)
  use mrtholo_interfaces, except_this => mrtholo_pack_clean
  !----------------------------------------------------------------------
  ! @ private-mandatory
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  call mrtholo_exit(error)
  if (error) return
  !
end subroutine mrtholo_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_standard_comm
  use cubetools_command
  use cubetools_primitive_opt
  use cubetools_standard_opt
  use cubetools_structure_main
  !
  public :: command_t
  public :: cubetools_register_command,cubetools_command_ptr
  private
  !
contains
  !
  subroutine cubetools_register_command(name,syntax,abstract,help,run,popt,error,allowopt)
    !----------------------------------------------------------------------
    ! Register a command of exact type command_t in the global 'pack'
    !----------------------------------------------------------------------
    character(len=*),  intent(in)    :: name
    character(len=*),  intent(in)    :: syntax
    character(len=*),  intent(in)    :: abstract
    character(len=*),  intent(in)    :: help
    external                         :: run
    type(option_t),    pointer       :: popt  ! Return pointer to registered 'option'
    logical,           intent(inout) :: error
    logical, optional, intent(in)    :: allowopt
    !
    type(command_t) :: template
    type(option_t) :: otemplate
    class(primitive_opt_t), pointer :: actualopt
    !
    call cubetools_register_primitive_comm(template,otemplate,  &
      name,syntax,abstract,help,run,actualopt,error,allowopt)
    if (error)  return
    popt => cubetools_option_ptr(actualopt,error)
    if (error)  return
    popt%check          => cubetools_command_check_execute
    popt%build_syntax   => cubetools_command_build_syntax
    popt%print_abstract => cubetools_command_print_abstract
  end subroutine cubetools_register_command
  !
  subroutine cubetools_command_check_execute(opt,command,line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: command  ! Command name (for proper feedback)
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    call cubetools_option_check_execute(opt,command,line,error)
    if (error)  return
  end subroutine cubetools_command_check_execute
  !
  subroutine cubetools_command_build_syntax(opt,syntax,lprint,lnoprint,error)
    use cubetools_format
    !-------------------------------------------------------------------
    !  Build the string
    !    COMMAND Arg1 ... ArgN
    !  according to opt%name and opt%syntax
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(out)   :: syntax
    integer(kind=4),        intent(out)   :: lprint    ! Number of printable characters
    integer(kind=4),        intent(out)   :: lnoprint  ! Number of non-printable characters
    logical,                intent(inout) :: error
    !
    syntax = trim(cubetools_format_bold(opt%name,lprint,lnoprint))// &
             ' '// &
             opt%syntax
    lprint = lprint + 1 + len_trim(opt%syntax)
  end subroutine cubetools_command_build_syntax
  !
  subroutine cubetools_command_print_abstract(opt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    call cubetools_option_print_abstract(opt,error)
    if (error)  return
  end subroutine cubetools_command_print_abstract
end module cubetools_standard_comm
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program map_aver
  use gildas_def
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compress an input LMV-like image
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: mapin,mapout
  integer :: nc(2),n,naver,ier
  logical :: error
  real :: dv
  integer(kind=size_length) :: nd
  type(gildas) :: x,y
  real(kind=8) :: xposi,yposi
  !
  ! Code:
  call gildas_open
  call gildas_char('INPUT_MAP$',mapin)
  call gildas_char('OUTPUT_MAP$',mapout)
  call gildas_inte('NC$',nc,2)
  call gildas_close
  !
  ! Input file
  n = len_trim(mapin)
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapin,'.lmv',error)
  if (error) then
    call gagout('F-MAP_COMPRESS,  Cannot read input cube')
    goto 999
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapout,x%file,' ','.lmv')
  !
  ! Define number of channels
  ier = gdf_range(nc,y%gil%dim(3))
  if (ier.ne.0) goto 999
  naver = nc(2)-nc(1)+1
  !
  ! Build a pseudo axis aligned on the input one:
  !  - Number of channels set to 1,
  !  - Increment set to the extracted range,
  !  - Value at reference unchanged (same spectroscopic axis, e.g. regarding
  !    associated Rest Freq),
  !  - Center of averaged range (old axis) is aligned on the center of the
  !    output channel #1 (new axis)
  ! This writes as:
  x%gil%dim(3) = 1
! x%gil%val(3) = unchanged
  yposi = (nc(1)+nc(2))*0.5d0
  xposi = 1.d0
  x%gil%inc(3) = y%gil%inc(3)*naver
  x%gil%ref(3) = xposi - (yposi-y%gil%ref(3))/naver
  ! Do not forget the SPECTRO section
  x%gil%vres = y%gil%vres*naver
  x%gil%fres = y%gil%fres*naver
! x%gil%voff = unchanged
! x%gil%freq = unchanged
! x%gil%fima = unchanged
  !
  x%gil%extr_words = 0
  !
  call gdf_create_image(x,error)
  if (error)  goto 999
  !
  y%blc(3) = nc(1)
  y%trc(3) = nc(2)
  call gdf_read_gildas(y,mapin,'.lmv',error,rank=3)
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  !
  dv = 1.0/float(naver)
  nd = x%gil%dim(1)*x%gil%dim(2)
  call compress (y%r3d,nd,x%r2d,naver,dv)
  call gdf_write_data(x,x%r2d,error)
  if (error) goto 999
  call gagout('S-MAP_AVER,  Successful completion')
  call sysexi(1)
999 call sysexi(fatale)
end program map_aver
!
subroutine compress (in,n,out,nc,dv)
  use gildas_def
  integer(kind=size_length) :: n    !
  integer :: nc                     !
  real :: in(n,nc)                  !
  real :: out(n)                    !
  real :: dv                        !
  ! Local
  integer :: ic
  !
  out = in(:,1)
  do ic=2,nc
    out = out+in(:,ic)
  enddo
  out = out*dv
end subroutine compress

subroutine las_setvar(set,line,r,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_setvar
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  SET VARIABLE Section_name [READ|WRITE|OFF]
  ! This commands has 2 purposes:
  !  - change the RO/RW status of the R%HEAD%Section,
  !  - create/remove aliases to this section
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   !
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  !
  ! Local
  integer(kind=4) :: nkey,nc,mode
  character(len=12) :: argum,keywor
  integer, parameter :: mvocab1=24
  character(len=12) :: vocab1(mvocab1)
  ! Data
  data vocab1 /'GENERAL','POSITION','SPECTRO','RESOLUTION','BASE',        &
    'HISTORY','PLOT','FSWITCH','SWITCH','CALIBRATION','SKYDIP','GAUSS',   &
    'SHELL','NH3','HFS','ABSORPTION','DRIFT','BEAM', 'CONTINUUM',         &
    'ASSOCIATED','HERSCHEL','SECTIONS','COMMENT','USER' /
  !
  ! Access mode
  argum = setvar_modes(setvar_read)
  call sic_ke (line,0,3,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs('SET',argum,keywor,mode,setvar_modes,setvar_mmodes,error)
  if (error) return
  !
  ! Section
  call sic_ke (line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs('SET',argum,keywor,nkey,vocab1,mvocab1,error)
  if (error) return
  !
  call las_setvar_R(set,r,keywor,mode,error)
  if (error)  return
  !
end subroutine las_setvar
!
subroutine class_variable(set,line,error,user_function)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command
  !   VARIABLE Section1 [... SectionN]
  ! 1   /MODE  READ|WRITE|OFF
  ! 2   /INDEX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer(kind=4) :: nkey,nc,mode,iarg
  character(len=12) :: argum,keywor
  logical :: presec,readsec(-mx_sec:0)  ! Which section are to be added
  ! Data
  integer, parameter :: msections=22
  character(len=12) :: sections(msections)
  data sections /'SECTIONS','GENERAL','POSITION','SPECTRO','RESOLUTION',      &
    'BASE','HISTORY','PLOT','FSWITCH','SWITCH','CALIBRATION','SKYDIP',        &
    'GAUSS','SHELL','HFS','ABSORPTION','DRIFT','BEAM','CONTINUUM','COMMENT',  &
    'USER','HERSCHEL' /
  !
  ! Sections
  presec = .false.
  readsec(:) = .false.  ! None but:
  do iarg=1,sic_narg(0)
    call sic_ke(line,0,iarg,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,argum,keywor,nkey,sections,msections,error)
    if (error) return
    select case (keywor)
    case ('SECTIONS')
      presec = .true.
    case ('GENERAL')
      readsec(class_sec_gen_id) = .true.
    case ('POSITION')
      readsec(class_sec_pos_id) = .true.
    case ('SPECTRO')
      readsec(class_sec_spe_id) = .true.
    case ('RESOLUTION')
      readsec(class_sec_res_id) = .true.
    case ('BASE')
      readsec(class_sec_bas_id) = .true.
    case ('HISTORY')
      readsec(class_sec_his_id) = .true.
    case ('PLOT')
      readsec(class_sec_plo_id) = .true.
    case ('FSWITCH','SWITCH')
      readsec(class_sec_swi_id) = .true.
    case ('CALIBRATION')
      readsec(class_sec_cal_id) = .true.
    case ('SKYDIP')
      readsec(class_sec_sky_id) = .true.
    case ('GAUSS')
      readsec(class_sec_gau_id) = .true.
    case ('SHELL')
      readsec(class_sec_she_id) = .true.
    case ('HFS')
      readsec(class_sec_hfs_id) = .true.
    case ('ABSORPTION')
      readsec(class_sec_abs_id) = .true.
    case ('DRIFT')
      readsec(class_sec_dri_id) = .true.
    case ('BEAM')
      readsec(class_sec_bea_id) = .true.
    case ('CONTINUUM')
      readsec(class_sec_poi_id) = .true.
    case ('COMMENT')
      readsec(class_sec_com_id) = .true.
    case ('USER')
      readsec(class_sec_user_id) = .true.
    case ('HERSCHEL')
      readsec(class_sec_her_id) = .true.
    case default
      call class_message(seve%w,rname,  &
        'Section '//trim(keywor)//' not implemented')
    end select
  enddo
  !
  ! Access mode
  argum = setvar_modes(setvar_read)
  call sic_ke (line,1,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,mode,setvar_modes,setvar_mmodes,error)
  if (error) return
  !
  if (sic_present(2,0)) then  ! /INDEX
    call class_variable_index(set,presec,readsec,mode,error,user_function)
    if (error)  return
  else
    call class_message(seve%e,rname,'Only /INDEX is implemented')
    error = .true.
    return
  endif
  !
end subroutine class_variable
!
subroutine las_setvar_R(set,r,keywor,mode,error)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>las_setvar_R
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Instantiate the requested section in Sic structure R%HEAD
  !---------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set     !
  type(observation),   intent(inout) :: r       !
  character(len=*),    intent(in)    :: keywor  !
  integer(kind=4),     intent(in)    :: mode    ! setvar_off/read/write
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SETVAR'
  logical :: userreq
  integer(kind=index_length) :: dim(4)
  !
  userreq = .false.
  !
  select case (keywor)
  case('GENERAL')
    call las_variables_rgen('R%HEAD',r,mode.ne.setvar_write,error)  ! Must be re-created before the aliases
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_gen_id) = .true.  ! else unchanged
    call las_setvar_R_alias(class_sec_gen_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_gen_id) = mode
    !
  case('POSITION')
    call las_variables_rpos('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_pos_id) = .true.
    call las_setvar_R_alias(class_sec_pos_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_pos_id) = mode
    !
  case('SPECTRO')
    call las_variables_rspe('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_spe_id) = .true.
    call las_setvar_R_alias(class_sec_spe_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_spe_id) = mode
    !
  case('RESOLUTION')
    call las_variables_rres('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_res_id) = .true.
    call las_setvar_R_alias(class_sec_res_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_res_id) = mode
    !
  case('BASE')
    call las_variables_rbas('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_bas_id) = .true.
    call las_setvar_R_alias(class_sec_bas_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_bas_id) = mode
    !
  case('HISTORY')
    call las_variables_rhis('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_his_id) = .true.
    call las_setvar_R_alias(class_sec_his_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_his_id) = mode
    !
  case('PLOT')
    call las_variables_rplo('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_plo_id) = .true.
    call las_setvar_R_alias(class_sec_plo_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_plo_id) = mode
    !
  case('FSWITCH','SWITCH')
    call las_variables_rswi('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_swi_id) = .true.
    call las_setvar_R_alias(class_sec_swi_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_swi_id) = mode
    !
  case('CALIBRATION')
    call las_variables_rcal('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_cal_id)=.true.
    call las_setvar_R_alias(class_sec_cal_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_cal_id) = mode
    !
  case('SKYDIP')
    call las_variables_rsky('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_sky_id)=.true.
    call las_setvar_R_alias(class_sec_sky_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_sky_id) = mode
    !
  case('GAUSS')
    call las_variables_rgau('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_gau_id) = .true.
    call las_setvar_R_alias(class_sec_gau_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_gau_id) = mode
    !
  case('SHELL')
    call las_variables_rshe('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_she_id) = .true.
    call las_setvar_R_alias(class_sec_she_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_she_id) = mode
    !
  case('NH3','HFS')
    call las_variables_rhfs('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_hfs_id) = .true.
    call las_setvar_R_alias(class_sec_hfs_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_hfs_id) = mode
    !
  case('ABS')
    call las_variables_rabs('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_abs_id)=.true.
    call las_setvar_R_alias(class_sec_abs_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_abs_id) = mode
    !
  case('DRIFT')
    call las_variables_rdri('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_dri_id) = .true.
    call las_setvar_R_alias(class_sec_dri_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_dri_id) = mode
    !
  case('BEAM')
    call las_variables_rbea('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_bea_id) = .true.
    call las_setvar_R_alias(class_sec_bea_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_bea_id) = mode
    !
  case('CONTINUUM')
    call las_variables_rpoi('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_poi_id)=.true.
    call las_setvar_R_alias(class_sec_poi_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_poi_id) = mode
    !
  case('HERSCHEL')
    call las_variables_rher('R%HEAD',r,mode.ne.setvar_write,error)
    if (error)  return
    if (mode.eq.setvar_write) r%head%presec(class_sec_her_id)=.true.
    call las_setvar_R_alias(class_sec_her_id,mode.eq.setvar_off,error)
    if (error)  return
    set%varpresec(class_sec_her_id) = mode
    !
  case('ASSOCIATED')
    set%varpresec(class_sec_assoc_id) = mode  ! New mode
    call newdat_assoc(set,r,error)  ! Must come after the new mode
    if (error)  return
    ! if (mode.eq.setvar_write) r%head%presec(class_sec_assoc_id)=.true.
    !     No: activating the section with SET VAR ASSOC WR is useless without
    !     adding an Associated Array. Use command ASSOCIATE instead.
    ! call las_setvar_R_alias(class_sec_her_id,mode.eq.setvar_off,error)
    !     No: no aliases onto the assoc arrays...
    !
  case('SECTIONS')
     call sic_delvariable('R%HEAD%PRESEC',userreq,error)
     error = .false.  ! Attempt to delete non-existent variables is not an error
     if (mode.eq.setvar_off) return
     !
     dim(1) = mx_sec+1
     call sic_def_login('R%HEAD%PRESEC',r%head%presec(-mx_sec),1,dim,mode.ne.setvar_write,error)
     !
  case('COMMENT')
     if (.not.r%head%presec(class_sec_com_id)) then
        call class_message(seve%w,rname,'Comment section does not exist')
        return
     elseif (mode.eq.setvar_write) then
        call class_message(seve%e,rname,  &
          'Keyword WRITE not possible, use command COMMENT')
        error = .true.
        return
     else
        call sic_delvariable('COMMENT',userreq,error)
        error = .false.  ! Attempt to delete non-existent variables is not an error
        if (mode.eq.setvar_off) return
        call sic_def_char('COMMENT',r%head%com%ctext,mode.ne.setvar_write,error)
     endif
     set%varpresec(class_sec_com_id) = mode
     !
  case('USER')
     set%varpresec(class_sec_user_id) = mode  ! Must be set before calling newdat_user
     call user_sec_setvar(set,r,mode.eq.setvar_off,error)
     if (error)  return
     !
  case default
     call class_message(seve%e,rname,'Unknown section '//keywor)
     error = .true.
  end select
  !
end subroutine las_setvar_R
!
subroutine las_setvar_R_alias(code,delete,error)
  use gkernel_interfaces
  use classcore_interfaces, except_this=>las_setvar_R_alias
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Delete and/or (re)create aliases to the section elements.
  !  NB: aliases inherit the RW/RO status of their targets
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: code    ! Section code
  logical,         intent(in)    :: delete  ! Delete or create aliases?
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  !
  userreq = .false.
  !
  select case (code)
  case (class_sec_gen_id)
    call sic_delvariable('NUM',userreq,error)
    call sic_delvariable('VER',userreq,error)
    call sic_delvariable('TELES',userreq,error)
    call sic_delvariable('DOBS',userreq,error)
    call sic_delvariable('DRED',userreq,error)
    call sic_delvariable('CDOBS',userreq,error)
    call sic_delvariable('CDRED',userreq,error)
    call sic_delvariable('KIND',userreq,error)
    call sic_delvariable('QUAL',userreq,error)
    call sic_delvariable('UT',userreq,error)
    call sic_delvariable('ST',userreq,error)
    call sic_delvariable('AZ',userreq,error)
    call sic_delvariable('EL',userreq,error)
    call sic_delvariable('TAU',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NUM',  'R%HEAD%GEN%NUM',  .true.,error)
    call sic_def_alias('VER',  'R%HEAD%GEN%VER',  .true.,error)
    call sic_def_alias('TELES','R%HEAD%GEN%TELES',.true.,error)
    call sic_def_alias('DOBS', 'R%HEAD%GEN%DOBS', .true.,error)
    call sic_def_alias('DRED', 'R%HEAD%GEN%DRED', .true.,error)
    call sic_def_alias('CDOBS','R%HEAD%GEN%CDOBS',.true.,error)
    call sic_def_alias('CDRED','R%HEAD%GEN%CDRED',.true.,error)
    call sic_def_alias('KIND', 'R%HEAD%GEN%KIND', .true.,error)
    call sic_def_alias('QUAL', 'R%HEAD%GEN%QUAL', .true.,error)
    call sic_def_alias('UT',   'R%HEAD%GEN%UT',   .true.,error)
    call sic_def_alias('ST',   'R%HEAD%GEN%ST',   .true.,error)
    call sic_def_alias('AZ',   'R%HEAD%GEN%AZ',   .true.,error)
    call sic_def_alias('EL',   'R%HEAD%GEN%EL',   .true.,error)
    call sic_def_alias('TAU',  'R%HEAD%GEN%TAU',  .true.,error)
    if (error)  return
    !
  case (class_sec_pos_id)
    call sic_delvariable('SOURC',userreq,error)
    call sic_delvariable('EQUINOX',userreq,error)
    call sic_delvariable('LAM',userreq,error)
    call sic_delvariable('BET',userreq,error)
    call sic_delvariable('LAMOF',userreq,error)
    call sic_delvariable('BETOF',userreq,error)
    call sic_delvariable('PROJ',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('SOURC',  'R%HEAD%POS%SOURC',  .true.,error)
    call sic_def_alias('EQUINOX','R%HEAD%POS%EQUINOX',.true.,error)
    call sic_def_alias('LAM',    'R%HEAD%POS%LAM',    .true.,error)
    call sic_def_alias('BET',    'R%HEAD%POS%BET',    .true.,error)
    call sic_def_alias('LAMOF',  'R%HEAD%POS%LAMOF',  .true.,error)
    call sic_def_alias('BETOF',  'R%HEAD%POS%BETOF',  .true.,error)
    call sic_def_alias('PROJ',   'R%HEAD%POS%PROJ',   .true.,error)
    if (error)  return
    !
  case (class_sec_spe_id)
    call sic_delvariable('LINE',userreq,error)
    call sic_delvariable('NCHAN',userreq,error)
    call sic_delvariable('RESTF',userreq,error)
    call sic_delvariable('RCHAN',userreq,error)
    call sic_delvariable('FRES',userreq,error)
    call sic_delvariable('VRES',userreq,error)
    call sic_delvariable('VOFF',userreq,error)
    call sic_delvariable('BAD',userreq,error)
    call sic_delvariable('IMAGE',userreq,error)
    call sic_delvariable('VTYPE',userreq,error)
    call sic_delvariable('SKYFR',userreq,error)
    call sic_delvariable('VTELES',userreq,error)
    call sic_delvariable('DOPPLER',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LINE',   'R%HEAD%SPE%LINE',   .true.,error)
    call sic_def_alias('NCHAN',  'R%HEAD%SPE%NCHAN',  .true.,error)
    call sic_def_alias('RESTF',  'R%HEAD%SPE%RESTF',  .true.,error)
    call sic_def_alias('RCHAN',  'R%HEAD%SPE%RCHAN',  .true.,error)
    call sic_def_alias('FRES',   'R%HEAD%SPE%FRES',   .true.,error)
    call sic_def_alias('VRES',   'R%HEAD%SPE%VRES',   .true.,error)
    call sic_def_alias('VOFF',   'R%HEAD%SPE%VOFF',   .true.,error)
    call sic_def_alias('BAD',    'R%HEAD%SPE%BAD',    .true.,error)
    call sic_def_alias('IMAGE',  'R%HEAD%SPE%IMAGE',  .true.,error)
    call sic_def_alias('VTYPE',  'R%HEAD%SPE%VTYPE',  .true.,error)
  ! call sic_def_alias('SKYFR',  'R%HEAD%SPE%SKYFR',  .true.,error)
  ! call sic_def_alias('VTELES', 'R%HEAD%SPE%VTELES', .true.,error)
    call sic_def_alias('DOPPLER','R%HEAD%SPE%DOPPLER',.true.,error)
    if (error)  return
    !
  case (class_sec_bas_id)
    call sic_delvariable('DEG',userreq,error)
    call sic_delvariable('SIGFI',userreq,error)
    call sic_delvariable('AIRE',userreq,error)
    call sic_delvariable('NWIND',userreq,error)
    call sic_delvariable('W1',userreq,error)
    call sic_delvariable('W2',userreq,error)
    call sic_delvariable('SINUS',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('DEG',  'R%HEAD%BAS%DEG',  .true.,error)
    call sic_def_alias('SIGFI','R%HEAD%BAS%SIGFI',.true.,error)
    call sic_def_alias('AIRE', 'R%HEAD%BAS%AIRE', .true.,error)
    call sic_def_alias('NWIND','R%HEAD%BAS%NWIND',.true.,error)
    call sic_def_alias('W1',   'R%HEAD%BAS%W1',   .true.,error)
    call sic_def_alias('W2',   'R%HEAD%BAS%W2',   .true.,error)
    call sic_def_alias('SINUS','R%HEAD%BAS%SINUS',.true.,error)
    if (error)  return
    !
  case (class_sec_his_id)
    call sic_delvariable('NSEQ',userreq,error)
    call sic_delvariable('START',userreq,error)
    call sic_delvariable('END',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NSEQ', 'R%HEAD%HIS%NSEQ', .true.,error)
    call sic_def_alias('START','R%HEAD%HIS%START',.true.,error)
    call sic_def_alias('END',  'R%HEAD%HIS%END',  .true.,error)
    if (error)  return
    !
  case (class_sec_plo_id)
    call sic_delvariable('AMIN',userreq,error)
    call sic_delvariable('AMAX',userreq,error)
    call sic_delvariable('VMIN',userreq,error)
    call sic_delvariable('VMAX',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('AMIN','R%HEAD%PLO%AMIN',.true.,error)
    call sic_def_alias('AMAX','R%HEAD%PLO%AMAX',.true.,error)
    call sic_def_alias('VMIN','R%HEAD%PLO%VMIN',.true.,error)
    call sic_def_alias('VMAX','R%HEAD%PLO%VMAX',.true.,error)
    if (error)  return
    !
  case (class_sec_swi_id)
    call sic_delvariable('NPHAS',userreq,error)
    call sic_delvariable('DECAL',userreq,error)
    call sic_delvariable('DUREE',userreq,error)
    call sic_delvariable('POIDS',userreq,error)
    call sic_delvariable('SWMOD',userreq,error)
    call sic_delvariable('LDECAL',userreq,error)
    call sic_delvariable('BDECAL',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NPHAS', 'R%HEAD%FSW%NPHAS', .true.,error)
    call sic_def_alias('SWMOD', 'R%HEAD%FSW%SWMOD', .true.,error)
    call sic_def_alias('DECAL', 'R%HEAD%FSW%DECAL', .true.,error)
    call sic_def_alias('DUREE', 'R%HEAD%FSW%DUREE', .true.,error)
    call sic_def_alias('POIDS', 'R%HEAD%FSW%POIDS', .true.,error)
    call sic_def_alias('LDECAL','R%HEAD%FSW%LDECAL',.true.,error)
    call sic_def_alias('BDECAL','R%HEAD%FSW%BDECAL',.true.,error)
    if (error)  return
    !
  case (class_sec_cal_id)
    call sic_delvariable('BEEFF',userreq,error)
    call sic_delvariable('FOEFF',userreq,error)
    call sic_delvariable('GAINI',userreq,error)
    call sic_delvariable('H2OMM',userreq,error)
    call sic_delvariable('PAMB',userreq,error)
    call sic_delvariable('TAMB',userreq,error)
    call sic_delvariable('TATMS',userreq,error)
    call sic_delvariable('TCHOP',userreq,error)
    call sic_delvariable('TCOLD',userreq,error)
    call sic_delvariable('TAUS',userreq,error)
    call sic_delvariable('TAUI',userreq,error)
    call sic_delvariable('TATMI',userreq,error)
    call sic_delvariable('TREC',userreq,error)
    call sic_delvariable('CMODE',userreq,error)
    call sic_delvariable('ATFAC',userreq,error)
    call sic_delvariable('ALTI',userreq,error)
    call sic_delvariable('COUNT',userreq,error)
    call sic_delvariable('LCALOF',userreq,error)
    call sic_delvariable('BCALOF',userreq,error)
    call sic_delvariable('GEOLONG',userreq,error)
    call sic_delvariable('GEOLAT',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('BEEFF',  'R%HEAD%CAL%BEEFF',  .true.,error)
    call sic_def_alias('FOEFF',  'R%HEAD%CAL%FOEFF',  .true.,error)
    call sic_def_alias('GAINI',  'R%HEAD%CAL%GAINI',  .true.,error)
    call sic_def_alias('H2OMM',  'R%HEAD%CAL%H2OMM',  .true.,error)
    call sic_def_alias('PAMB',   'R%HEAD%CAL%PAMB',   .true.,error)
    call sic_def_alias('TAMB',   'R%HEAD%CAL%TAMB',   .true.,error)
    call sic_def_alias('TATMS',  'R%HEAD%CAL%TATMS',  .true.,error)
    call sic_def_alias('TCHOP',  'R%HEAD%CAL%TCHOP',  .true.,error)
    call sic_def_alias('TCOLD',  'R%HEAD%CAL%TCOLD',  .true.,error)
    call sic_def_alias('TAUS',   'R%HEAD%CAL%TAUS',   .true.,error)
    call sic_def_alias('TAUI',   'R%HEAD%CAL%TAUI',   .true.,error)
    call sic_def_alias('TATMI',  'R%HEAD%CAL%TATMI',  .true.,error)
    call sic_def_alias('TREC',   'R%HEAD%CAL%TREC',   .true.,error)
    call sic_def_alias('CMODE',  'R%HEAD%CAL%CMODE',  .true.,error)
    call sic_def_alias('ATFAC',  'R%HEAD%CAL%ATFAC',  .true.,error)
    call sic_def_alias('ALTI',   'R%HEAD%CAL%ALTI',   .true.,error)
    call sic_def_alias('COUNT',  'R%HEAD%CAL%COUNT',  .true.,error)
    call sic_def_alias('LCALOF', 'R%HEAD%CAL%LCALOF', .true.,error)
    call sic_def_alias('BCALOF', 'R%HEAD%CAL%BCALOF', .true.,error)
    call sic_def_alias('GEOLONG','R%HEAD%CAL%GEOLONG',.true.,error)
    call sic_def_alias('GEOLAT', 'R%HEAD%CAL%GEOLAT', .true.,error)
    if (error)  return
    !
  case (class_sec_sky_id)
    call sic_delvariable('SREST',userreq,error)
    call sic_delvariable('SIMAG',userreq,error)
    call sic_delvariable('NSKY',userreq,error)
    call sic_delvariable('NCHOP',userreq,error)
    call sic_delvariable('NCOLD',userreq,error)
    call sic_delvariable('ELEV',userreq,error)
    call sic_delvariable('EMISS',userreq,error)
    call sic_delvariable('CHOPP',userreq,error)
    call sic_delvariable('COLD',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('SREST','R%HEAD%SKY%RESTF',.true.,error)
    call sic_def_alias('SIMAG','R%HEAD%SKY%IMAGE',.true.,error)
    call sic_def_alias('NSKY', 'R%HEAD%SKY%NSKY', .true.,error)
    call sic_def_alias('NCHOP','R%HEAD%SKY%NCHOP',.true.,error)
    call sic_def_alias('NCOLD','R%HEAD%SKY%NCOLD',.true.,error)
    call sic_def_alias('ELEV', 'R%HEAD%SKY%ELEV', .true.,error)
    call sic_def_alias('EMISS','R%HEAD%SKY%EMISS',.true.,error)
    call sic_def_alias('CHOPP','R%HEAD%SKY%CHOPP',.true.,error)
    call sic_def_alias('COLD', 'R%HEAD%SKY%COLD', .true.,error)
    if (error)  return
    !
  case (class_sec_gau_id)
    call sic_delvariable('NLINE',userreq,error)
    call sic_delvariable('SIGBA',userreq,error)
    call sic_delvariable('SIGRA',userreq,error)
    call sic_delvariable('NFIT',userreq,error)
    call sic_delvariable('NERR',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('NLINE','R%HEAD%GAU%NLINE',.true.,error)
    call sic_def_alias('SIGBA','R%HEAD%GAU%RMS_BASE',.true.,error)
    call sic_def_alias('SIGRA','R%HEAD%GAU%RMS_LINE',.true.,error)
    call sic_def_alias('NFIT', 'R%HEAD%GAU%RESULT', .true.,error)
    call sic_def_alias('NERR', 'R%HEAD%GAU%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_she_id)
    call sic_delvariable('LSHEL',userreq,error)
    call sic_delvariable('BSHEL',userreq,error)
    call sic_delvariable('RSHEL',userreq,error)
    call sic_delvariable('NSHEL',userreq,error)
    call sic_delvariable('ESHEL',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LSHEL','R%HEAD%SHE%NLINE',.true.,error)
    call sic_def_alias('BSHEL','R%HEAD%SHE%RMS_BASE',.true.,error)
    call sic_def_alias('RSHEL','R%HEAD%SHE%RMS_LINE',.true.,error)
    call sic_def_alias('NSHEL','R%HEAD%SHE%RESULT', .true.,error)
    call sic_def_alias('ESHEL','R%HEAD%SHE%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_hfs_id)
    call sic_delvariable('LNH3',userreq,error)
    call sic_delvariable('BNH3',userreq,error)
    call sic_delvariable('RNH3',userreq,error)
    call sic_delvariable('NNH3',userreq,error)
    call sic_delvariable('ENH3',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LNH3','R%HEAD%HFS%NLINE',.true.,error)
    call sic_def_alias('BNH3','R%HEAD%HFS%RMS_BASE',.true.,error)
    call sic_def_alias('RNH3','R%HEAD%HFS%RMS_LINE',.true.,error)
    call sic_def_alias('NNH3','R%HEAD%HFS%RESULT', .true.,error)
    call sic_def_alias('ENH3','R%HEAD%HFS%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_abs_id)
    call sic_delvariable('LABS',userreq,error)
    call sic_delvariable('BABS',userreq,error)
    call sic_delvariable('RABS',userreq,error)
    call sic_delvariable('NABS',userreq,error)
    call sic_delvariable('EABS',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LABS','R%HEAD%ABS%NLINE',.true.,error)
    call sic_def_alias('BABS','R%HEAD%ABS%RMS_BASE',.true.,error)
    call sic_def_alias('RABS','R%HEAD%ABS%RMS_LINE',.true.,error)
    call sic_def_alias('NABS','R%HEAD%ABS%RESULT', .true.,error)
    call sic_def_alias('EABS','R%HEAD%ABS%ERROR', .true.,error)
    if (error)  return
    !
  case (class_sec_dri_id)
    call sic_delvariable('FREQ',userreq,error)
    call sic_delvariable('WIDTH',userreq,error)
    call sic_delvariable('NPOIN',userreq,error)
    call sic_delvariable('RPOIN',userreq,error)
    call sic_delvariable('TREF',userreq,error)
    call sic_delvariable('AREF',userreq,error)
    call sic_delvariable('TRES',userreq,error)
    call sic_delvariable('ARES',userreq,error)
    call sic_delvariable('APOS',userreq,error)
    call sic_delvariable('CBAD',userreq,error)
    call sic_delvariable('CTYPE',userreq,error)
    call sic_delvariable('CIMAG',userreq,error)
    call sic_delvariable('COLLA',userreq,error)
    call sic_delvariable('COLLE',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('FREQ', 'R%HEAD%DRI%FREQ', .true.,error)
    call sic_def_alias('WIDTH','R%HEAD%DRI%WIDTH',.true.,error)
    call sic_def_alias('NPOIN','R%HEAD%DRI%NPOIN',.true.,error)
    call sic_def_alias('RPOIN','R%HEAD%DRI%RPOIN',.true.,error)
    call sic_def_alias('TREF', 'R%HEAD%DRI%TREF', .true.,error)
    call sic_def_alias('AREF', 'R%HEAD%DRI%AREF', .true.,error)
    call sic_def_alias('TRES', 'R%HEAD%DRI%TRES', .true.,error)
    call sic_def_alias('ARES', 'R%HEAD%DRI%ARES', .true.,error)
    call sic_def_alias('APOS', 'R%HEAD%DRI%APOS', .true.,error)
    call sic_def_alias('CBAD', 'R%HEAD%DRI%BAD',  .true.,error)
    call sic_def_alias('CTYPE','R%HEAD%DRI%CTYPE',.true.,error)
    call sic_def_alias('CIMAG','R%HEAD%DRI%CIMAG',.true.,error)
    call sic_def_alias('COLLA','R%HEAD%DRI%COLLA',.true.,error)
    call sic_def_alias('COLLE','R%HEAD%DRI%COLLE',.true.,error)
    if (error)  return
    !
  case (class_sec_bea_id)
    call sic_delvariable('CAZIM',userreq,error)
    call sic_delvariable('CELEV',userreq,error)
    call sic_delvariable('SPACE',userreq,error)
    call sic_delvariable('BPOS',userreq,error)
    call sic_delvariable('BTYPE',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('CAZIM','R%HEAD%BEA%CAZIM',.true.,error)
    call sic_def_alias('CELEV','R%HEAD%BEA%CELEV',.true.,error)
    call sic_def_alias('SPACE','R%HEAD%BEA%SPACE',.true.,error)
    call sic_def_alias('BPOS', 'R%HEAD%BEA%BPOS', .true.,error)
    call sic_def_alias('BTYPE','R%HEAD%BEA%BTYPE',.true.,error)
    if (error)  return
    !
  case (class_sec_poi_id)
    call sic_delvariable('LCONT',userreq,error)
    call sic_delvariable('BCONT',userreq,error)
    call sic_delvariable('RCONT',userreq,error)
    call sic_delvariable('NCONT',userreq,error)
    call sic_delvariable('ECONT',userreq,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    if (delete) return
    call sic_def_alias('LCONT','R%HEAD%POI%NLINE',.true.,error)
    call sic_def_alias('BCONT','R%HEAD%POI%RMS_BASE',.true.,error)
    call sic_def_alias('RCONT','R%HEAD%POI%RMS_LINE',.true.,error)
    call sic_def_alias('NCONT','R%HEAD%POI%RESULT', .true.,error)
    call sic_def_alias('ECONT','R%HEAD%POI%ERROR', .true.,error)
    if (error)  return
    !
  case default
    ! No aliases for this section, not an error
    return
  end select
  !
end subroutine las_setvar_R_alias
!
subroutine las_setvar_R_aliases(set,error)
  use classcore_interfaces, except_this=>las_setvar_R_aliases
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  !  Recreate the aliases for ALL sections which are currently
  ! activated (SET VARIABLE Section ON|READ|WRITE)
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: isec
  !
  do isec=-mx_sec,0
    if (set%varpresec(isec).ne.setvar_off) then
      call las_setvar_R_alias(isec,.false.,error)
      if (error)  return
    endif
  enddo
  !
end subroutine las_setvar_R_aliases
!
!-----------------------------------------------------------------------
!
subroutine class_variable_index_reset(error)
  use classcore_interfaces, except_this=>class_variable_index_reset
  !---------------------------------------------------------------------
  ! @ private
  !  Reset the IDX% structure in Sic, probably because something has
  ! changed in CX.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  ! Destroy IDX%HEAD%: the support arrays are now outdated. Do not
  ! recompute them implicitly, this is too costly
  call sic_delvariable('IDX%HEAD',.false.,error)
  if (error)  error = .false.  ! No error if it does not exists
  call sic_delvariable('IDX%USER',.false.,error)
  if (error)  error = .false.  ! No error if it does not exists
  !
  ! Remap the CX arrays
  call class_variable_index_cx(error)
  if (error)  return
  !
end subroutine class_variable_index_reset
!
subroutine class_variable_index_cx(error)
  use classcore_dependencies_interfaces
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Create the IDX% Sic structure mapping the CX arrays (always
  ! available)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error status
  ! Local
  integer(kind=index_length) :: dim(4)
  !
  ! Create structure if needed
  if (.not.sic_varexist('idx')) then
     call sic_defstructure('idx%',.true.,error)
     call sic_def_logi('idx%oldfmt',cx%has_old_fmt,.false.,error)
     call sic_def_long('idx%time',cx%time,0,dim,.false.,error)
     if (error) return
  endif
  !
  ! Removed previously defined structure variable
  call sic_delvariable('idx%ind',    .false.,error)
  call sic_delvariable('idx%num',    .false.,error)
  call sic_delvariable('idx%ver',    .false.,error)
  call sic_delvariable('idx%kind',   .false.,error)
  call sic_delvariable('idx%qual',   .false.,error)
  call sic_delvariable('idx%scan',   .false.,error)
  call sic_delvariable('idx%subscan',.false.,error)
  call sic_delvariable('idx%dobs',   .false.,error)
  call sic_delvariable('idx%loff',   .false.,error)
  call sic_delvariable('idx%boff',   .false.,error)
  call sic_delvariable('idx%sourc',  .false.,error)
  call sic_delvariable('idx%line',   .false.,error)
  call sic_delvariable('idx%teles',  .false.,error)
  call sic_delvariable('idx%posa',   .false.,error)
  ! UT is not in index V1 or V2. Comment out IDX%UT as long as index V3
  ! is not the default and widely distributed.
! call sic_delvariable('idx%ut',     .false.,error)
  error = .false.
  !
  nindex = cx%next-1
  if (nindex.gt.0) then
     dim(1) = nindex
     call sic_def_long ('idx%ind',    cx%ind,    1,dim,.false.,error)
     call sic_def_long ('idx%num',    cx%num,    1,dim,.false.,error)
     call sic_def_inte ('idx%ver',    cx%ver,    1,dim,.false.,error)
     call sic_def_inte ('idx%kind',   cx%kind,   1,dim,.false.,error)
     call sic_def_inte ('idx%qual',   cx%qual,   1,dim,.false.,error)
     call sic_def_long ('idx%scan',   cx%scan,   1,dim,.false.,error)
     call sic_def_inte ('idx%subscan',cx%subscan,1,dim,.false.,error)
     call sic_def_inte ('idx%dobs',   cx%dobs,   1,dim,.false.,error)
     call sic_def_real ('idx%loff',   cx%off1,   1,dim,.false.,error)
     call sic_def_real ('idx%boff',   cx%off2,   1,dim,.false.,error)
     call sic_def_charn('idx%sourc',  cx%csour,  1,dim,.false.,error)
     call sic_def_charn('idx%line',   cx%cline,  1,dim,.false.,error)
     call sic_def_charn('idx%teles',  cx%ctele,  1,dim,.false.,error)
     call sic_def_real ('idx%posa',   cx%posa,   1,dim,.false.,error)
   ! call sic_def_dble ('idx%ut',     cx%ut,     1,dim,.false.,error)
     error = .false.
  endif
  !
end subroutine class_variable_index_cx
!
subroutine class_variable_index(set,presec,readsec,mode,error,user_function)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Create a section in the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set                 !
  logical,             intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,             intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  integer(kind=4),     intent(in)    :: mode                ! setvar_off/read/write
  logical,             intent(inout) :: error               !
  logical,             external      :: user_function       !
  !
  if (mode.eq.setvar_write) then
    call class_message(seve%e,'VARIABLE',  &
      '/MODE WRITE is exclusive with option /INDEX')
    error = .true.
    return
  endif
  !
  ! Delete support variables
  call class_variable_index_delvar(presec,readsec,error)
  if (error)  return
  !
  if (mode.eq.setvar_off) then  ! DELETE mode
    ! Free associated memory
    call class_variable_index_reallocate(presec,readsec,0_8,error)
    return  ! Nothing more
  endif
  !
  call class_variable_index_fill(set,presec,readsec,error,user_function)
  if (error)  return
  !
  ! Create support variables
  call class_variable_index_defvar(presec,readsec,error)
  if (error)  return
  !
end subroutine class_variable_index
!
subroutine class_variable_index_delvar(presec,readsec,error)
  use classcore_dependencies_interfaces
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Delete variables (structures) in IDX%HEAD%
  !---------------------------------------------------------------------
  logical, intent(in)    :: presec              ! Enable the 'present sections' array?
  logical, intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical, intent(inout) :: error               !
  !
  if (presec)  call sic_delvariable('IDX%HEAD%PRESEC',.false.,error)
  if (readsec(class_sec_gen_id))   call sic_delvariable('IDX%HEAD%GEN',.false.,error)
  if (readsec(class_sec_pos_id))   call sic_delvariable('IDX%HEAD%POS',.false.,error)
  if (readsec(class_sec_spe_id))   call sic_delvariable('IDX%HEAD%SPE',.false.,error)
  if (readsec(class_sec_res_id))   call sic_delvariable('IDX%HEAD%RES',.false.,error)
  if (readsec(class_sec_bas_id))   call sic_delvariable('IDX%HEAD%BAS',.false.,error)
  if (readsec(class_sec_his_id))   call sic_delvariable('IDX%HEAD%HIS',.false.,error)
  if (readsec(class_sec_plo_id))   call sic_delvariable('IDX%HEAD%PLO',.false.,error)
  if (readsec(class_sec_swi_id))   call sic_delvariable('IDX%HEAD%FSW',.false.,error)
  if (readsec(class_sec_cal_id))   call sic_delvariable('IDX%HEAD%CAL',.false.,error)
  if (readsec(class_sec_sky_id))   call sic_delvariable('IDX%HEAD%SKY',.false.,error)
  if (readsec(class_sec_gau_id))   call sic_delvariable('IDX%HEAD%GAU',.false.,error)
  if (readsec(class_sec_she_id))   call sic_delvariable('IDX%HEAD%SHE',.false.,error)
  if (readsec(class_sec_hfs_id))   call sic_delvariable('IDX%HEAD%HFS',.false.,error)
  if (readsec(class_sec_abs_id))   call sic_delvariable('IDX%HEAD%ABS',.false.,error)
  if (readsec(class_sec_dri_id))   call sic_delvariable('IDX%HEAD%DRI',.false.,error)
  if (readsec(class_sec_bea_id))   call sic_delvariable('IDX%HEAD%BEA',.false.,error)
  if (readsec(class_sec_poi_id))   call sic_delvariable('IDX%HEAD%POI',.false.,error)
  if (readsec(class_sec_com_id))   call sic_delvariable('IDX%HEAD%COM',.false.,error)
  if (readsec(class_sec_her_id))   call sic_delvariable('IDX%HEAD%HER',.false.,error)
  if (readsec(class_sec_user_id))  call sic_delvariable('IDX%USER',    .false.,error)
  !
end subroutine class_variable_index_delvar
!
subroutine class_variable_index_fill(set,presec,readsec,error,user_function)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index_fill
  use class_index
  use class_parameter
  use class_sicidx
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the section arrays for the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set                 !
  logical,             intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,             intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical,             intent(inout) :: error               !
  logical,             external      :: user_function       !
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  type(observation) :: obs
  integer(kind=entry_length) :: ient,kx
  type(time_t) :: time
  !
  if (cx%next.le.1) then
    call class_message(seve%w,rname,'Current index is empty')
    return
  endif
  !
  ! (Re)allocations
  call class_variable_index_reallocate(presec,readsec,cx%next-1,error)
  if (error)  return
  !
  call init_obs(obs)
  !
  call gtime_init(time,cx%next-1,error)
  if (error)  return
  !
  ! (Re)fill
  do ient=1,cx%next-1
    call gtime_current(time)
    !
    ! Exit when asked by user
    call class_controlc(rname,error)
    if (error)  return
    !
    kx = cx%ind(ient)
    call rheader(set,obs,kx,user_function,error,readsec)
    if (error)  return
    !
    if (presec) then
      idxhead%presec(:,ient) = obs%head%presec(:)
    endif
    if (readsec(class_sec_gen_id)) then
      idxhead%gen%num(ient)     = obs%head%gen%num
      idxhead%gen%ver(ient)     = obs%head%gen%ver
      idxhead%gen%teles(ient)   = obs%head%gen%teles
      idxhead%gen%dobs(ient)    = obs%head%gen%dobs
      idxhead%gen%dred(ient)    = obs%head%gen%dred
      idxhead%gen%kind(ient)    = obs%head%gen%kind
      idxhead%gen%qual(ient)    = obs%head%gen%qual
      idxhead%gen%subscan(ient) = obs%head%gen%subscan
      idxhead%gen%scan(ient)    = obs%head%gen%scan
      idxhead%gen%ut(ient)      = obs%head%gen%ut
      idxhead%gen%st(ient)      = obs%head%gen%st
      idxhead%gen%az(ient)      = obs%head%gen%az
      idxhead%gen%el(ient)      = obs%head%gen%el
      idxhead%gen%tau(ient)     = obs%head%gen%tau
      idxhead%gen%tsys(ient)    = obs%head%gen%tsys
      idxhead%gen%time(ient)    = obs%head%gen%time
      idxhead%gen%parang(ient)  = obs%head%gen%parang
      idxhead%gen%xunit(ient)   = obs%head%gen%xunit
    endif
    if (readsec(class_sec_pos_id)) then
      idxhead%pos%sourc(ient)   = obs%head%pos%sourc
      idxhead%pos%system(ient)  = obs%head%pos%system
      idxhead%pos%equinox(ient) = obs%head%pos%equinox
      idxhead%pos%proj(ient)    = obs%head%pos%proj
      idxhead%pos%lam(ient)     = obs%head%pos%lam
      idxhead%pos%bet(ient)     = obs%head%pos%bet
      idxhead%pos%projang(ient) = obs%head%pos%projang
      idxhead%pos%lamof(ient)   = obs%head%pos%lamof
      idxhead%pos%betof(ient)   = obs%head%pos%betof
    endif
    if (readsec(class_sec_spe_id)) then
      idxhead%spe%line(ient)    = obs%head%spe%line
      idxhead%spe%restf(ient)   = obs%head%spe%restf
      idxhead%spe%nchan(ient)   = obs%head%spe%nchan
      idxhead%spe%rchan(ient)   = obs%head%spe%rchan
      idxhead%spe%fres(ient)    = obs%head%spe%fres
      idxhead%spe%vres(ient)    = obs%head%spe%vres
      idxhead%spe%voff(ient)    = obs%head%spe%voff
      idxhead%spe%bad(ient)     = obs%head%spe%bad
      idxhead%spe%image(ient)   = obs%head%spe%image
      idxhead%spe%vtype(ient)   = obs%head%spe%vtype
      idxhead%spe%vconv(ient)   = obs%head%spe%vconv
      idxhead%spe%vdire(ient)   = obs%head%spe%vdire
      idxhead%spe%doppler(ient) = obs%head%spe%doppler
    endif
    if (readsec(class_sec_res_id)) then
      idxhead%res%major(ient)  = obs%head%res%major
      idxhead%res%minor(ient)  = obs%head%res%minor
      idxhead%res%posang(ient) = obs%head%res%posang
    endif
    if (readsec(class_sec_bas_id)) then
      idxhead%bas%deg(ient)     = obs%head%bas%deg
      idxhead%bas%sigfi(ient)   = obs%head%bas%sigfi
      idxhead%bas%aire(ient)    = obs%head%bas%aire
      idxhead%bas%nwind(ient)   = obs%head%bas%nwind
      idxhead%bas%w1(:,ient)    = obs%head%bas%w1(:)
      idxhead%bas%w2(:,ient)    = obs%head%bas%w2(:)
      idxhead%bas%sinus(:,ient) = obs%head%bas%sinus(:)
    endif
    if (readsec(class_sec_his_id)) then
      idxhead%his%nseq(ient)    = obs%head%his%nseq
      idxhead%his%start(:,ient) = obs%head%his%start(:)
      idxhead%his%end(:,ient)   = obs%head%his%end(:)
    endif
    if (readsec(class_sec_plo_id)) then
      idxhead%plo%amin(ient) = obs%head%plo%amin
      idxhead%plo%amax(ient) = obs%head%plo%amax
      idxhead%plo%vmin(ient) = obs%head%plo%vmin
      idxhead%plo%vmax(ient) = obs%head%plo%vmax
    endif
    if (readsec(class_sec_swi_id)) then
      idxhead%swi%nphas(ient)    = obs%head%swi%nphas
      idxhead%swi%decal(:,ient)  = obs%head%swi%decal(:)
      idxhead%swi%duree(:,ient)  = obs%head%swi%duree(:)
      idxhead%swi%poids(:,ient)  = obs%head%swi%poids(:)
      idxhead%swi%swmod(ient)    = obs%head%swi%swmod
      idxhead%swi%ldecal(:,ient) = obs%head%swi%ldecal(:)
      idxhead%swi%bdecal(:,ient) = obs%head%swi%bdecal(:)
    endif
    if (readsec(class_sec_cal_id)) then
      idxhead%cal%beeff(ient)   = obs%head%cal%beeff
      idxhead%cal%foeff(ient)   = obs%head%cal%foeff
      idxhead%cal%gaini(ient)   = obs%head%cal%gaini
      idxhead%cal%h2omm(ient)   = obs%head%cal%h2omm
      idxhead%cal%pamb(ient)    = obs%head%cal%pamb
      idxhead%cal%tamb(ient)    = obs%head%cal%tamb
      idxhead%cal%tatms(ient)   = obs%head%cal%tatms
      idxhead%cal%tchop(ient)   = obs%head%cal%tchop
      idxhead%cal%tcold(ient)   = obs%head%cal%tcold
      idxhead%cal%taus(ient)    = obs%head%cal%taus
      idxhead%cal%taui(ient)    = obs%head%cal%taui
      idxhead%cal%tatmi(ient)   = obs%head%cal%tatmi
      idxhead%cal%trec(ient)    = obs%head%cal%trec
      idxhead%cal%cmode(ient)   = obs%head%cal%cmode
      idxhead%cal%atfac(ient)   = obs%head%cal%atfac
      idxhead%cal%alti(ient)    = obs%head%cal%alti
      idxhead%cal%count(:,ient) = obs%head%cal%count(:)
      idxhead%cal%lcalof(ient)  = obs%head%cal%lcalof
      idxhead%cal%bcalof(ient)  = obs%head%cal%bcalof
      idxhead%cal%geolong(ient) = obs%head%cal%geolong
      idxhead%cal%geolat(ient)  = obs%head%cal%geolat
    endif
    if (readsec(class_sec_sky_id)) then
      idxhead%sky%restf(ient)   = obs%head%sky%restf
      idxhead%sky%image(ient)   = obs%head%sky%image
      idxhead%sky%nsky(ient)    = obs%head%sky%nsky
      idxhead%sky%nchop(ient)   = obs%head%sky%nchop
      idxhead%sky%ncold(ient)   = obs%head%sky%ncold
      idxhead%sky%elev(:,ient)  = obs%head%sky%elev(:)
      idxhead%sky%emiss(:,ient) = obs%head%sky%emiss(:)
      idxhead%sky%chopp(:,ient) = obs%head%sky%chopp(:)
      idxhead%sky%cold(:,ient)  = obs%head%sky%cold(:)
    endif
    if (readsec(class_sec_gau_id)) then
      idxhead%gau%nline(ient)  = obs%head%gau%nline
      idxhead%gau%sigba(ient)  = obs%head%gau%sigba
      idxhead%gau%sigra(ient)  = obs%head%gau%sigra
      idxhead%gau%nfit(:,ient) = obs%head%gau%nfit(:)
      idxhead%gau%nerr(:,ient) = obs%head%gau%nerr(:)
    endif
    if (readsec(class_sec_she_id)) then
      idxhead%she%nline(ient)  = obs%head%she%nline
      idxhead%she%sigba(ient)  = obs%head%she%sigba
      idxhead%she%sigra(ient)  = obs%head%she%sigra
      idxhead%she%nfit(:,ient) = obs%head%she%nfit(:)
      idxhead%she%nerr(:,ient) = obs%head%she%nerr(:)
    endif
    if (readsec(class_sec_hfs_id)) then
      idxhead%hfs%nline(ient)  = obs%head%hfs%nline
      idxhead%hfs%sigba(ient)  = obs%head%hfs%sigba
      idxhead%hfs%sigra(ient)  = obs%head%hfs%sigra
      idxhead%hfs%nfit(:,ient) = obs%head%hfs%nfit(:)
      idxhead%hfs%nerr(:,ient) = obs%head%hfs%nerr(:)
    endif
    if (readsec(class_sec_abs_id)) then
      idxhead%abs%nline(ient)  = obs%head%abs%nline
      idxhead%abs%sigba(ient)  = obs%head%abs%sigba
      idxhead%abs%sigra(ient)  = obs%head%abs%sigra
      idxhead%abs%nfit(:,ient) = obs%head%abs%nfit(:)
      idxhead%abs%nerr(:,ient) = obs%head%abs%nerr(:)
    endif
    if (readsec(class_sec_dri_id)) then
      idxhead%dri%freq(ient)  = obs%head%dri%freq
      idxhead%dri%width(ient) = obs%head%dri%width
      idxhead%dri%npoin(ient) = obs%head%dri%npoin
      idxhead%dri%rpoin(ient) = obs%head%dri%rpoin
      idxhead%dri%tref(ient)  = obs%head%dri%tref
      idxhead%dri%aref(ient)  = obs%head%dri%aref
      idxhead%dri%apos(ient)  = obs%head%dri%apos
      idxhead%dri%tres(ient)  = obs%head%dri%tres
      idxhead%dri%ares(ient)  = obs%head%dri%ares
      idxhead%dri%bad(ient)   = obs%head%dri%bad
      idxhead%dri%ctype(ient) = obs%head%dri%ctype
      idxhead%dri%cimag(ient) = obs%head%dri%cimag
      idxhead%dri%colla(ient) = obs%head%dri%colla
      idxhead%dri%colle(ient) = obs%head%dri%colle
    endif
    if (readsec(class_sec_bea_id)) then
      idxhead%bea%cazim(ient) = obs%head%bea%cazim
      idxhead%bea%celev(ient) = obs%head%bea%celev
      idxhead%bea%space(ient) = obs%head%bea%space
      idxhead%bea%bpos(ient)  = obs%head%bea%bpos
      idxhead%bea%btype(ient) = obs%head%bea%btype
    endif
    if (readsec(class_sec_poi_id)) then
      idxhead%poi%nline(ient)  = obs%head%poi%nline
      idxhead%poi%sigba(ient)  = obs%head%poi%sigba
      idxhead%poi%sigra(ient)  = obs%head%poi%sigra
      idxhead%poi%nfit(:,ient) = obs%head%poi%nfit(:)
      idxhead%poi%nerr(:,ient) = obs%head%poi%nerr(:)
    endif
    if (readsec(class_sec_com_id)) then
      idxhead%com%ltext(ient) = obs%head%com%ltext
      idxhead%com%ctext(ient) = obs%head%com%ctext
    endif
    if (readsec(class_sec_her_id)) then
      idxhead%her%obsid(ient)      = obs%head%her%obsid
      idxhead%her%instrument(ient) = obs%head%her%instrument
      idxhead%her%proposal(ient)   = obs%head%her%proposal
      idxhead%her%aor(ient)        = obs%head%her%aor
      idxhead%her%operday(ient)    = obs%head%her%operday
      idxhead%her%dateobs(ient)    = obs%head%her%dateobs
      idxhead%her%dateend(ient)    = obs%head%her%dateend
      idxhead%her%obsmode(ient)    = obs%head%her%obsmode
      idxhead%her%vinfo(ient)      = obs%head%her%vinfo
      idxhead%her%zinfo(ient)      = obs%head%her%zinfo
      idxhead%her%posangle(ient)   = obs%head%her%posangle
      idxhead%her%reflam(ient)     = obs%head%her%reflam
      idxhead%her%refbet(ient)     = obs%head%her%refbet
      idxhead%her%hifavelam(ient)  = obs%head%her%hifavelam
      idxhead%her%hifavebet(ient)  = obs%head%her%hifavebet
      idxhead%her%etamb(ient)      = obs%head%her%etamb
      idxhead%her%etal(ient)       = obs%head%her%etal
      idxhead%her%etaa(ient)       = obs%head%her%etaa
      idxhead%her%hpbw(ient)       = obs%head%her%hpbw
      idxhead%her%tempscal(ient)   = obs%head%her%tempscal
      idxhead%her%lodopave(ient)   = obs%head%her%lodopave
      idxhead%her%gim0(ient)       = obs%head%her%gim0
      idxhead%her%gim1(ient)       = obs%head%her%gim1
      idxhead%her%gim2(ient)       = obs%head%her%gim2
      idxhead%her%gim3(ient)       = obs%head%her%gim3
      idxhead%her%mixercurh(ient)  = obs%head%her%mixercurh
      idxhead%her%mixercurv(ient)  = obs%head%her%mixercurv
      idxhead%her%datehcss(ient)   = obs%head%her%datehcss
      idxhead%her%hcssver(ient)    = obs%head%her%hcssver
      idxhead%her%calver(ient)     = obs%head%her%calver
      idxhead%her%level(ient)      = obs%head%her%level
    endif
    if (readsec(class_sec_user_id)) then
      call user_sec_varidx_fill(obs,ient,error)
      if (error)  exit
    endif
  enddo
  !
  call free_obs(obs)
  !
end subroutine class_variable_index_fill
!
subroutine class_variable_index_defvar(presec,readsec,error)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_variable_index_defvar
  use class_index
  use class_parameter
  use class_sicidx
  !---------------------------------------------------------------------
  ! @ private
  !  Create the sections in the IDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  logical, intent(in)    :: presec              ! Enable the 'present sections' array?
  logical, intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be added
  logical, intent(inout) :: error               !
  ! Local
  character(len=10) :: struct
  integer(kind=index_length) :: dims(4)
  !
  if (.not.sic_varexist('IDX')) then
    call sic_defstructure('IDX',.true.,error)
    if (error)  return
  endif
  !
  struct = 'IDX%HEAD'
  if (.not.sic_varexist(struct)) then
    call sic_defstructure(struct,.true.,error)
    if (error)  return
  endif
  !
  ! Present sections
  if (presec) then
    dims(1) = mx_sec+1
    dims(2) = cx%next-1
    call sic_def_login(trim(struct)//'%PRESEC',idxhead%presec,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! General
  if (readsec(class_sec_gen_id)) then
    call sic_defstructure(trim(struct)//'%GEN',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_long (trim(struct)//'%GEN%NUM',    idxhead%gen%num,    1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%VER',    idxhead%gen%ver,    1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%GEN%TELES',  idxhead%gen%teles,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%DOBS',   idxhead%gen%dobs,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%DRED',   idxhead%gen%dred,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%KIND',   idxhead%gen%kind,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%QUAL',   idxhead%gen%qual,   1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%SUBSCAN',idxhead%gen%subscan,1,dims,.true.,error)
    call sic_def_long (trim(struct)//'%GEN%SCAN',   idxhead%gen%scan,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%UT',     idxhead%gen%ut,     1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%ST',     idxhead%gen%st,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%AZ',     idxhead%gen%az,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%EL',     idxhead%gen%el,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TAU',    idxhead%gen%tau,    1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TSYS',   idxhead%gen%tsys,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%GEN%TIME',   idxhead%gen%time,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%GEN%PARANG', idxhead%gen%parang, 1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%GEN%XUNIT',  idxhead%gen%xunit,  1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Position
  if (readsec(class_sec_pos_id)) then
    call sic_defstructure(trim(struct)//'%POS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_charn(trim(struct)//'%POS%SOURC',  idxhead%pos%sourc,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%POS%SYSTEM', idxhead%pos%system, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%EQUINOX',idxhead%pos%equinox,1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%POS%PROJ',   idxhead%pos%proj,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%LAM',    idxhead%pos%lam,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%BET',    idxhead%pos%bet,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%POS%PROJANG',idxhead%pos%projang,1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%LAMOF',  idxhead%pos%lamof,  1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%POS%BETOF',  idxhead%pos%betof,  1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Spectro
  if (readsec(class_sec_spe_id)) then
    call sic_defstructure(trim(struct)//'%SPE',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_charn(trim(struct)//'%SPE%LINE',   idxhead%spe%line,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%RESTF',  idxhead%spe%restf,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%NCHAN',  idxhead%spe%nchan,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%RCHAN',  idxhead%spe%rchan,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%FRES',   idxhead%spe%fres,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%VRES',   idxhead%spe%vres,   1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%VOFF',   idxhead%spe%voff,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%SPE%BAD',    idxhead%spe%bad,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%IMAGE',  idxhead%spe%image,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VTYPE',  idxhead%spe%vtype,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VCONV',  idxhead%spe%vconv,  1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%SPE%VDIRE',  idxhead%spe%vdire,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%SPE%DOPPLER',idxhead%spe%doppler,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Beam
  if (readsec(class_sec_res_id)) then
    call sic_defstructure(trim(struct)//'%RES',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%RES%MAJOR', idxhead%res%major, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%RES%MINOR', idxhead%res%minor, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%RES%POSANG',idxhead%res%posang,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Base
  if (readsec(class_sec_bas_id)) then
    call sic_defstructure(trim(struct)//'%BAS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%BAS%DEG',  idxhead%bas%deg,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%SIGFI',idxhead%bas%sigfi,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%AIRE', idxhead%bas%aire, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%BAS%NWIND',idxhead%bas%nwind,1,dims,.true.,error)
    dims(1) = mwind
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%BAS%W1',   idxhead%bas%w1,   2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BAS%W2',   idxhead%bas%w2,   2,dims,.true.,error)
    dims(1) = 3
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%BAS%SINUS',idxhead%bas%sinus,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! History
  if (readsec(class_sec_his_id)) then
    call sic_defstructure(trim(struct)//'%HIS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%HIS%NSEQ', idxhead%his%nseq, 1,dims,.true.,error)
    dims(1) = mseq
    dims(2) = cx%next-1
    call sic_def_inte(trim(struct)//'%HIS%START',idxhead%his%start,2,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%HIS%END',  idxhead%his%end,  2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Plot
  if (readsec(class_sec_plo_id)) then
    call sic_defstructure(trim(struct)//'%PLO',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%PLO%AMIN',idxhead%plo%amin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%AMAX',idxhead%plo%amax,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%VMIN',idxhead%plo%vmin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%PLO%VMAX',idxhead%plo%vmax,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Switching
  if (readsec(class_sec_swi_id)) then
    call sic_defstructure(trim(struct)//'%FSW',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%FSW%NPHAS',idxhead%swi%nphas,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%FSW%SWMOD',idxhead%swi%swmod,1,dims,.true.,error)
    dims(1) = mxphas
    dims(2) = cx%next-1
    call sic_def_dble(trim(struct)//'%FSW%DECAL', idxhead%swi%decal, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%DUREE', idxhead%swi%duree, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%POIDS', idxhead%swi%poids, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%LDECAL',idxhead%swi%ldecal,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%FSW%BDECAL',idxhead%swi%bdecal,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Calibration
  if (readsec(class_sec_cal_id)) then
    call sic_defstructure(trim(struct)//'%CAL',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%CAL%BEEFF',  idxhead%cal%beeff,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%FOEFF',  idxhead%cal%foeff,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%GAINI',  idxhead%cal%gaini,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%H2OMM',  idxhead%cal%h2omm,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%PAMB',   idxhead%cal%pamb,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAMB',   idxhead%cal%tamb,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TATMS',  idxhead%cal%tatms,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TCHOP',  idxhead%cal%tchop,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TCOLD',  idxhead%cal%tcold,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAUS',   idxhead%cal%taus,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TAUI',   idxhead%cal%taui,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TATMI',  idxhead%cal%tatmi,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%TREC',   idxhead%cal%trec,   1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%CAL%CMODE',  idxhead%cal%cmode,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%ATFAC',  idxhead%cal%atfac,  1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%ALTI',   idxhead%cal%alti,   1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%LCALOF', idxhead%cal%lcalof, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%CAL%BCALOF', idxhead%cal%bcalof, 1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%CAL%GEOLONG',idxhead%cal%geolong,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%CAL%GEOLAT', idxhead%cal%geolat, 1,dims,.true.,error)
    dims(1) = 3
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%CAL%COUNT',idxhead%cal%count,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Skydip
  if (readsec(class_sec_sky_id)) then
    call sic_defstructure(trim(struct)//'%SKY',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_dble(trim(struct)//'%SKY%SREST',idxhead%sky%restf,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%SKY%SIMAG',idxhead%sky%image,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NSKY', idxhead%sky%nsky, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NCHOP',idxhead%sky%nchop,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%SKY%NCOLD',idxhead%sky%ncold,1,dims,.true.,error)
    dims(1) = msky
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%SKY%ELEV', idxhead%sky%elev, 2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%EMISS',idxhead%sky%emiss,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%CHOPP',idxhead%sky%chopp,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SKY%COLD', idxhead%sky%cold, 2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Gauss
  if (readsec(class_sec_gau_id)) then
    call sic_defstructure(trim(struct)//'%GAU',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%GAU%NLINE',   idxhead%gau%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%RMS_BASE',idxhead%gau%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%RMS_LINE',idxhead%gau%sigra,1,dims,.true.,error)
    dims(1) = mgausfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%GAU%RESULT',idxhead%gau%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%GAU%ERROR', idxhead%gau%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Shell
  if (readsec(class_sec_she_id)) then
    call sic_defstructure(trim(struct)//'%SHE',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%SHE%NLINE',   idxhead%she%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%RMS_BASE',idxhead%she%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%RMS_LINE',idxhead%she%sigra,1,dims,.true.,error)
    dims(1) = mshellfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%SHE%RESULT',idxhead%she%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%SHE%ERROR', idxhead%she%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! HFS
  if (readsec(class_sec_hfs_id)) then
    call sic_defstructure(trim(struct)//'%HFS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%HFS%NLINE',   idxhead%hfs%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%RMS_BASE',idxhead%hfs%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%RMS_LINE',idxhead%hfs%sigra,1,dims,.true.,error)
    dims(1) = mhfsfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%HFS%RESULT',idxhead%hfs%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%HFS%ERROR', idxhead%hfs%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Absorption
  if (readsec(class_sec_abs_id)) then
    call sic_defstructure(trim(struct)//'%ABS',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%ABS%NLINE',   idxhead%abs%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%RMS_BASE',idxhead%abs%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%RMS_LINE',idxhead%abs%sigra,1,dims,.true.,error)
    dims(1) = mabsfit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%ABS%RESULT',idxhead%abs%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%ABS%ERROR', idxhead%abs%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Drift
  if (readsec(class_sec_dri_id)) then
    call sic_defstructure(trim(struct)//'%DRI',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_dble(trim(struct)//'%DRI%FREQ', idxhead%dri%freq, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%WIDTH',idxhead%dri%width,1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%DRI%NPOIN',idxhead%dri%npoin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%RPOIN',idxhead%dri%rpoin,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%TREF', idxhead%dri%tref, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%AREF', idxhead%dri%aref, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%APOS', idxhead%dri%apos, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%TRES', idxhead%dri%tres, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%ARES', idxhead%dri%ares, 1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%CBAD', idxhead%dri%bad,  1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%DRI%CTYPE',idxhead%dri%ctype,1,dims,.true.,error)
    call sic_def_dble(trim(struct)//'%DRI%CIMAG',idxhead%dri%cimag,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%COLLA',idxhead%dri%colla,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%DRI%COLLE',idxhead%dri%colle,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Beam
  if (readsec(class_sec_bea_id)) then
    call sic_defstructure(trim(struct)//'%BEA',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_real(trim(struct)//'%BEA%CAZIM',idxhead%bea%cazim,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%CELEV',idxhead%bea%celev,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%SPACE',idxhead%bea%space,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%BEA%BPOS', idxhead%bea%bpos, 1,dims,.true.,error)
    call sic_def_inte(trim(struct)//'%BEA%BTYPE',idxhead%bea%btype,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Continuum
  if (readsec(class_sec_poi_id)) then
    call sic_defstructure(trim(struct)//'%POI',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte(trim(struct)//'%POI%LCONT',idxhead%poi%nline,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%BCONT',idxhead%poi%sigba,1,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%RCONT',idxhead%poi%sigra,1,dims,.true.,error)
    dims(1) = mpoifit
    dims(2) = cx%next-1
    call sic_def_real(trim(struct)//'%POI%NCONT',idxhead%poi%nfit,2,dims,.true.,error)
    call sic_def_real(trim(struct)//'%POI%ECONT',idxhead%poi%nerr,2,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Herschel
  if (readsec(class_sec_her_id)) then
    call sic_defstructure(trim(struct)//'%HER',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_long (trim(struct)//'%HER%OBSID',     idxhead%her%obsid,     1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%INSTRUMENT',idxhead%her%instrument,1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%PROPOSAL',  idxhead%her%proposal,  1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%AOR',       idxhead%her%aor,       1,dims,.true.,error)
    call sic_def_inte (trim(struct)//'%HER%OPERDAY',   idxhead%her%operday,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEOBS',   idxhead%her%dateobs,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEEND',   idxhead%her%dateend,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%OBSMODE',   idxhead%her%obsmode,   1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%VINFO',     idxhead%her%vinfo,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ZINFO',     idxhead%her%zinfo,     1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%POSANGLE',  idxhead%her%posangle,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%REFLAM',    idxhead%her%reflam,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%REFBET',    idxhead%her%refbet,    1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%HIFAVELAM', idxhead%her%hifavelam, 1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%HIFAVEBET', idxhead%her%hifavebet, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAMB',     idxhead%her%etamb,     1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAL',      idxhead%her%etal,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%ETAA',      idxhead%her%etaa,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%HPBW',      idxhead%her%hpbw,      1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%TEMPSCAL',  idxhead%her%tempscal,  1,dims,.true.,error)
    call sic_def_dble (trim(struct)//'%HER%LODOPAVE',  idxhead%her%lodopave,  1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM0',      idxhead%her%gim0,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM1',      idxhead%her%gim1,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM2',      idxhead%her%gim2,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%GIM3',      idxhead%her%gim3,      1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%MIXERCURH', idxhead%her%mixercurh, 1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%MIXERCURV', idxhead%her%mixercurv, 1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%DATEHCSS',  idxhead%her%datehcss,  1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%HCSSVER',   idxhead%her%hcssver,   1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%HER%CALVER',    idxhead%her%calver,    1,dims,.true.,error)
    call sic_def_real (trim(struct)//'%HER%LEVEL',     idxhead%her%level,     1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! Comment
  if (readsec(class_sec_com_id)) then
    call sic_defstructure(trim(struct)//'%COM',.true.,error)
    if (error)  return
    dims(1) = cx%next-1
    call sic_def_inte (trim(struct)//'%COM%LTEXT',idxhead%com%ltext,1,dims,.true.,error)
    call sic_def_charn(trim(struct)//'%COM%CTEXT',idxhead%com%ctext,1,dims,.true.,error)
    if (error)  return
  endif
  !
  ! User section
  if (readsec(class_sec_user_id)) then
    call user_sec_varidx_defvar(error)
    if (error)  return
  endif
  !
end subroutine class_variable_index_defvar
!
subroutine class_variable_index_reallocate(presec,readsec,nent,error)
  use classcore_dependencies_interfaces
  use class_parameter
  use class_sicidx
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate (if needed) the IDX support arrays, section by section.
  !  nent <= 0 means deallocate only.
  !---------------------------------------------------------------------
  logical,         intent(in)    :: presec              ! Enable the 'present sections' array?
  logical,         intent(in)    :: readsec(-mx_sec:0)  ! Which section are to be reallocated
  integer(kind=8), intent(in)    :: nent                ! Size of reallocation
  logical,         intent(inout) :: error               ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REALLOCATE'
  logical :: realloc
  integer(kind=4) :: ier
  !
  ! Present sections
  if (presec) then
    if (allocated(idxhead%presec)) then
      realloc = ubound(idxhead%presec,2).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%presec)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc) then
      allocate(idxhead%presec(-mx_sec:0,nent),stat=ier)
      if (failed_allocate(rname,'IDX%PRESEC arrays',ier,error))  return
    endif
  endif
  !
  ! General
  if (readsec(class_sec_gen_id)) then
    if (allocated(idxhead%gen%num)) then
      realloc = size(idxhead%gen%num).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%gen%num, idxhead%gen%ver,    idxhead%gen%teles)
        deallocate(idxhead%gen%dobs,idxhead%gen%dred,   idxhead%gen%kind )
        deallocate(idxhead%gen%qual,idxhead%gen%subscan,idxhead%gen%scan )
        deallocate(idxhead%gen%ut,  idxhead%gen%st,     idxhead%gen%az   )
        deallocate(idxhead%gen%el,  idxhead%gen%tau,    idxhead%gen%tsys )
        deallocate(idxhead%gen%time,idxhead%gen%parang, idxhead%gen%xunit)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc) then
      allocate(idxhead%gen%num(nent),   idxhead%gen%ver(nent),    stat=ier)
      allocate(idxhead%gen%teles(nent), idxhead%gen%dobs(nent),   stat=ier)
      allocate(idxhead%gen%dred(nent),  idxhead%gen%kind(nent),   stat=ier)
      allocate(idxhead%gen%qual(nent),  idxhead%gen%subscan(nent),stat=ier)
      allocate(idxhead%gen%scan(nent),  idxhead%gen%ut(nent),     stat=ier)
      allocate(idxhead%gen%st(nent),    idxhead%gen%az(nent),     stat=ier)
      allocate(idxhead%gen%el(nent),    idxhead%gen%tau(nent),    stat=ier)
      allocate(idxhead%gen%tsys(nent),  idxhead%gen%time(nent),   stat=ier)
      allocate(idxhead%gen%parang(nent),idxhead%gen%xunit(nent),  stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%GEN arrays',ier,error))  return
    endif
  endif
  !
  ! Position
  if (readsec(class_sec_pos_id)) then
    if (allocated(idxhead%pos%sourc)) then
      realloc = size(idxhead%pos%sourc).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%pos%sourc,  idxhead%pos%system,idxhead%pos%equinox)
        deallocate(idxhead%pos%proj,   idxhead%pos%lam,   idxhead%pos%bet    )
        deallocate(idxhead%pos%projang,idxhead%pos%lamof, idxhead%pos%betof  )
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%pos%sourc(nent),  idxhead%pos%system(nent),stat=ier)
      allocate(idxhead%pos%equinox(nent),idxhead%pos%proj(nent),  stat=ier)
      allocate(idxhead%pos%lam(nent),    idxhead%pos%bet(nent),   stat=ier)
      allocate(idxhead%pos%projang(nent),idxhead%pos%lamof(nent), stat=ier)
      allocate(idxhead%pos%betof(nent),                           stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%POS arrays',ier,error))  return
    endif
  endif
  !
  ! Spectro
  if (readsec(class_sec_spe_id)) then
    if (allocated(idxhead%spe%line)) then
      realloc = size(idxhead%spe%line).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%spe%line, idxhead%spe%restf,idxhead%spe%nchan)
        deallocate(idxhead%spe%rchan,idxhead%spe%fres, idxhead%spe%vres)
        deallocate(idxhead%spe%voff, idxhead%spe%bad,  idxhead%spe%image)
        deallocate(idxhead%spe%vtype,idxhead%spe%vconv,idxhead%spe%vdire)
        deallocate(idxhead%spe%doppler)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%spe%line(nent), idxhead%spe%restf(nent),stat=ier)
      allocate(idxhead%spe%nchan(nent),idxhead%spe%rchan(nent),stat=ier)
      allocate(idxhead%spe%fres(nent), idxhead%spe%vres(nent), stat=ier)
      allocate(idxhead%spe%voff(nent), idxhead%spe%bad(nent),  stat=ier)
      allocate(idxhead%spe%image(nent),idxhead%spe%vtype(nent),stat=ier)
      allocate(idxhead%spe%vconv(nent),idxhead%spe%vdire(nent),stat=ier)
      allocate(idxhead%spe%doppler(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SPE arrays',ier,error))  return
    endif
  endif
  !
  ! Resolution
  if (readsec(class_sec_res_id)) then
    if (allocated(idxhead%res%major)) then
      realloc = size(idxhead%res%major).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%res%major,idxhead%res%minor,idxhead%res%posang)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%res%major(nent),idxhead%res%minor(nent),stat=ier)
      allocate(idxhead%res%posang(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%RES arrays',ier,error))  return
    endif
  endif
  !
  ! Base
  if (readsec(class_sec_bas_id)) then
    if (allocated(idxhead%bas%deg)) then
      realloc = size(idxhead%bas%deg).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%bas%deg,  idxhead%bas%sigfi,idxhead%bas%aire)
        deallocate(idxhead%bas%nwind,idxhead%bas%w1,   idxhead%bas%w2  )
        deallocate(idxhead%bas%sinus)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%bas%deg(nent),     idxhead%bas%sigfi(nent),   stat=ier)
      allocate(idxhead%bas%aire(nent),    idxhead%bas%nwind(nent),   stat=ier)
      allocate(idxhead%bas%w1(mwind,nent),idxhead%bas%w2(mwind,nent),stat=ier)
      allocate(idxhead%bas%sinus(3,nent), stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%BAS arrays',ier,error))  return
    endif
  endif
  !
  ! History
  if (readsec(class_sec_his_id)) then
    if (allocated(idxhead%his%nseq)) then
      realloc = size(idxhead%his%nseq).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%his%nseq,idxhead%his%start,idxhead%his%end)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%his%nseq(nent),    idxhead%his%start(mseq,nent),stat=ier)
      allocate(idxhead%his%end(mseq,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HIS arrays',ier,error))  return
    endif
  endif
  !
  ! Plot
  if (readsec(class_sec_plo_id)) then
    if (allocated(idxhead%plo%amin)) then
      realloc = size(idxhead%plo%amin).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%plo%amin,idxhead%plo%amax,idxhead%plo%vmin)
        deallocate(idxhead%plo%vmax)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%plo%amin(nent),idxhead%plo%amax(nent),stat=ier)
      allocate(idxhead%plo%vmin(nent),idxhead%plo%vmax(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%PLO arrays',ier,error))  return
    endif
  endif
  !
  ! Switching
  if (readsec(class_sec_swi_id)) then
    if (allocated(idxhead%swi%nphas)) then
      realloc = size(idxhead%swi%nphas).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%swi%nphas,idxhead%swi%decal,idxhead%swi%duree)
        deallocate(idxhead%swi%poids,idxhead%swi%swmod,idxhead%swi%ldecal)
        deallocate(idxhead%swi%bdecal)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%swi%nphas(nent),       idxhead%swi%decal(mxphas,nent), stat=ier)
      allocate(idxhead%swi%duree(mxphas,nent),idxhead%swi%poids(mxphas,nent), stat=ier)
      allocate(idxhead%swi%swmod(nent),       idxhead%swi%ldecal(mxphas,nent),stat=ier)
      allocate(idxhead%swi%bdecal(mxphas,nent),                               stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%FSW arrays',ier,error))  return
    endif
  endif
  !
  ! Calibration
  if (readsec(class_sec_cal_id)) then
    if (allocated(idxhead%cal%beeff)) then
      realloc = size(idxhead%cal%beeff).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%cal%beeff, idxhead%cal%foeff,  idxhead%cal%gaini )
        deallocate(idxhead%cal%h2omm, idxhead%cal%pamb,   idxhead%cal%tamb  )
        deallocate(idxhead%cal%tatms, idxhead%cal%tchop,  idxhead%cal%tcold )
        deallocate(idxhead%cal%taus,  idxhead%cal%taui,   idxhead%cal%tatmi )
        deallocate(idxhead%cal%trec,  idxhead%cal%cmode,  idxhead%cal%atfac )
        deallocate(idxhead%cal%alti,  idxhead%cal%count,  idxhead%cal%lcalof)
        deallocate(idxhead%cal%bcalof,idxhead%cal%geolong,idxhead%cal%geolat)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%cal%beeff(nent),  idxhead%cal%foeff(nent), stat=ier)
      allocate(idxhead%cal%gaini(nent),  idxhead%cal%h2omm(nent), stat=ier)
      allocate(idxhead%cal%pamb(nent),   idxhead%cal%tamb(nent),  stat=ier)
      allocate(idxhead%cal%tatms(nent),  idxhead%cal%tchop(nent), stat=ier)
      allocate(idxhead%cal%tcold(nent),  idxhead%cal%taus(nent),  stat=ier)
      allocate(idxhead%cal%taui(nent),   idxhead%cal%tatmi(nent), stat=ier)
      allocate(idxhead%cal%trec(nent),   idxhead%cal%cmode(nent), stat=ier)
      allocate(idxhead%cal%atfac(nent),  idxhead%cal%alti(nent),  stat=ier)
      allocate(idxhead%cal%count(3,nent),                         stat=ier)
      allocate(idxhead%cal%lcalof(nent), idxhead%cal%bcalof(nent),stat=ier)
      allocate(idxhead%cal%geolong(nent),idxhead%cal%geolat(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%CAL arrays',ier,error))  return
    endif
  endif
  !
  ! Skydip
  if (readsec(class_sec_sky_id)) then
    if (allocated(idxhead%sky%restf)) then
      realloc = size(idxhead%sky%restf).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%sky%restf,idxhead%sky%image,idxhead%sky%nsky)
        deallocate(idxhead%sky%nchop,idxhead%sky%ncold,idxhead%sky%elev)
        deallocate(idxhead%sky%emiss,idxhead%sky%chopp,idxhead%sky%cold)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%sky%restf(nent),     idxhead%sky%image(nent),     stat=ier)
      allocate(idxhead%sky%nsky(nent),      idxhead%sky%nchop(nent),     stat=ier)
      allocate(idxhead%sky%ncold(nent),     idxhead%sky%elev(msky,nent), stat=ier)
      allocate(idxhead%sky%emiss(msky,nent),idxhead%sky%chopp(msky,nent),stat=ier)
      allocate(idxhead%sky%cold(msky,nent),                              stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SKY arrays',ier,error))  return
    endif
  endif
  !
  ! Gauss
  if (readsec(class_sec_gau_id)) then
    if (allocated(idxhead%gau%nline)) then
      realloc = size(idxhead%gau%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%gau%nline,idxhead%gau%sigba,idxhead%gau%sigra)
        deallocate(idxhead%gau%nfit, idxhead%gau%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%gau%nline(nent),                                        stat=ier)
      allocate(idxhead%gau%sigba(nent),        idxhead%gau%sigra(nent),        stat=ier)
      allocate(idxhead%gau%nfit(mgausfit,nent),idxhead%gau%nerr(mgausfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%GAU arrays',ier,error))  return
    endif
  endif
  !
  ! Shell
  if (readsec(class_sec_she_id)) then
    if (allocated(idxhead%she%nline)) then
      realloc = size(idxhead%she%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%she%nline,idxhead%she%sigba,idxhead%she%sigra)
        deallocate(idxhead%she%nfit, idxhead%she%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%she%nline(nent),                                          stat=ier)
      allocate(idxhead%she%sigba(nent),         idxhead%she%sigra(nent),         stat=ier)
      allocate(idxhead%she%nfit(mshellfit,nent),idxhead%she%nerr(mshellfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%SHE arrays',ier,error))  return
    endif
  endif
  !
  ! HFS
  if (readsec(class_sec_hfs_id)) then
    if (allocated(idxhead%hfs%nline)) then
      realloc = size(idxhead%hfs%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%hfs%nline,idxhead%hfs%sigba,idxhead%hfs%sigra)
        deallocate(idxhead%hfs%nfit, idxhead%hfs%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%hfs%nline(nent),                                      stat=ier)
      allocate(idxhead%hfs%sigba(nent),       idxhead%hfs%sigra(nent),       stat=ier)
      allocate(idxhead%hfs%nfit(mhfsfit,nent),idxhead%hfs%nerr(mhfsfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HFS arrays',ier,error))  return
    endif
  endif
  !
  ! Absorption
  if (readsec(class_sec_abs_id)) then
    if (allocated(idxhead%abs%nline)) then
      realloc = size(idxhead%abs%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%abs%nline,idxhead%abs%sigba,idxhead%abs%sigra)
        deallocate(idxhead%abs%nfit, idxhead%abs%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%abs%nline(nent),                                      stat=ier)
      allocate(idxhead%abs%sigba(nent),       idxhead%abs%sigra(nent),       stat=ier)
      allocate(idxhead%abs%nfit(mabsfit,nent),idxhead%abs%nerr(mabsfit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%ABS arrays',ier,error))  return
    endif
  endif
  !
  ! Drift
  if (readsec(class_sec_dri_id)) then
    if (allocated(idxhead%dri%freq)) then
      realloc = size(idxhead%dri%freq).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%dri%freq, idxhead%dri%width,idxhead%dri%npoin)
        deallocate(idxhead%dri%rpoin,idxhead%dri%tref, idxhead%dri%aref )
        deallocate(idxhead%dri%apos, idxhead%dri%tres, idxhead%dri%ares )
        deallocate(idxhead%dri%bad,  idxhead%dri%ctype,idxhead%dri%cimag)
        deallocate(idxhead%dri%colla,idxhead%dri%colle)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%dri%freq(nent), idxhead%dri%width(nent),stat=ier)
      allocate(idxhead%dri%npoin(nent),idxhead%dri%rpoin(nent),stat=ier)
      allocate(idxhead%dri%tref(nent), idxhead%dri%aref(nent), stat=ier)
      allocate(idxhead%dri%apos(nent), idxhead%dri%tres(nent), stat=ier)
      allocate(idxhead%dri%ares(nent), idxhead%dri%bad(nent),  stat=ier)
      allocate(idxhead%dri%ctype(nent),idxhead%dri%cimag(nent),stat=ier)
      allocate(idxhead%dri%colla(nent),idxhead%dri%colle(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%DRI arrays',ier,error))  return
    endif
  endif
  !
  ! Resolution
  if (readsec(class_sec_bea_id)) then
    if (allocated(idxhead%bea%cazim)) then
      realloc = size(idxhead%bea%cazim).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%bea%cazim,idxhead%bea%celev,idxhead%bea%space)
        deallocate(idxhead%bea%bpos, idxhead%bea%btype)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%bea%cazim(nent),idxhead%bea%celev(nent),stat=ier)
      allocate(idxhead%bea%space(nent),idxhead%bea%bpos(nent), stat=ier)
      allocate(idxhead%bea%btype(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%BEA arrays',ier,error))  return
    endif
  endif
  !
  ! Continuum
  if (readsec(class_sec_poi_id)) then
    if (allocated(idxhead%poi%nline)) then
      realloc = size(idxhead%poi%nline).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%poi%nline,idxhead%poi%sigba,idxhead%poi%sigra)
        deallocate(idxhead%poi%nfit, idxhead%poi%nerr)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%poi%nline(nent),                                      stat=ier)
      allocate(idxhead%poi%sigba(nent),       idxhead%poi%sigra(nent),       stat=ier)
      allocate(idxhead%poi%nfit(mpoifit,nent),idxhead%poi%nerr(mpoifit,nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%POI arrays',ier,error))  return
    endif
  endif
  !
  ! Herschel
  if (readsec(class_sec_her_id)) then
    if (allocated(idxhead%her%obsid)) then
      realloc = size(idxhead%her%obsid).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%her%obsid,   idxhead%her%instrument,idxhead%her%proposal)
        deallocate(idxhead%her%aor,     idxhead%her%operday,   idxhead%her%dateobs)
        deallocate(idxhead%her%dateend, idxhead%her%obsmode,   idxhead%her%vinfo)
        deallocate(idxhead%her%zinfo,   idxhead%her%posangle,  idxhead%her%reflam)
        deallocate(idxhead%her%refbet,  idxhead%her%hifavelam, idxhead%her%hifavebet)
        deallocate(idxhead%her%etamb,   idxhead%her%etal,      idxhead%her%etaa)
        deallocate(idxhead%her%hpbw,    idxhead%her%tempscal,  idxhead%her%lodopave)
        deallocate(idxhead%her%gim0,    idxhead%her%gim1,      idxhead%her%gim2)
        deallocate(idxhead%her%gim3,    idxhead%her%mixercurh, idxhead%her%mixercurv)
        deallocate(idxhead%her%datehcss,idxhead%her%hcssver,   idxhead%her%calver)
        deallocate(idxhead%her%level)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%her%obsid(nent),    idxhead%her%instrument(nent),stat=ier)
      allocate(idxhead%her%proposal(nent), idxhead%her%aor(nent),       stat=ier)
      allocate(idxhead%her%operday(nent),  idxhead%her%dateobs(nent),   stat=ier)
      allocate(idxhead%her%dateend(nent),  idxhead%her%obsmode(nent),   stat=ier)
      allocate(idxhead%her%vinfo(nent),    idxhead%her%zinfo(nent),     stat=ier)
      allocate(idxhead%her%posangle(nent), idxhead%her%reflam(nent),    stat=ier)
      allocate(idxhead%her%refbet(nent),   idxhead%her%hifavelam(nent), stat=ier)
      allocate(idxhead%her%hifavebet(nent),idxhead%her%etamb(nent),     stat=ier)
      allocate(idxhead%her%etal(nent),     idxhead%her%etaa(nent),      stat=ier)
      allocate(idxhead%her%hpbw(nent),     idxhead%her%tempscal(nent),  stat=ier)
      allocate(idxhead%her%lodopave(nent), idxhead%her%gim0(nent),      stat=ier)
      allocate(idxhead%her%gim1(nent),     idxhead%her%gim2(nent),      stat=ier)
      allocate(idxhead%her%gim3(nent),     idxhead%her%mixercurh(nent), stat=ier)
      allocate(idxhead%her%mixercurv(nent),idxhead%her%datehcss(nent),  stat=ier)
      allocate(idxhead%her%hcssver(nent),  idxhead%her%calver(nent),    stat=ier)
      allocate(idxhead%her%level(nent),                                 stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%HER arrays',ier,error))  return
    endif
  endif
  !
  ! Comment
  if (readsec(class_sec_com_id)) then
    if (allocated(idxhead%com%ltext)) then
      realloc = size(idxhead%com%ltext).lt.nent
      if (nent.le.0 .or. realloc) then
        deallocate(idxhead%com%ltext,idxhead%com%ctext)
      endif
    else
      realloc = nent.gt.0
    endif
    !
    if (realloc .and. nent.gt.0) then
      allocate(idxhead%com%ltext(nent),idxhead%com%ctext(nent),stat=ier)
      if (failed_allocate(rname,'IDX%HEAD%COM arrays',ier,error))  return
    endif
  endif
  !
  ! User section
  if (readsec(class_sec_user_id)) then
    call user_sec_varidx_realloc(nent,error)
    if (error)  return
  endif
  !
end subroutine class_variable_index_reallocate

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments_cube_types
  use cube_types
  use cubetools_parameters
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: moments_cubeprodset_t
  public :: moments_cube_t,moments_cubeset_t
  private
  !
  type moments_cubeprod_t
     type(cube_prod_t), pointer :: sig
     type(cube_prod_t), pointer :: noi
     type(cube_prod_t), pointer :: snr
  contains
     procedure, private :: register => moments_cubeprod_register
  end type moments_cubeprod_t
  !
  type moments_cubeprodset_t
     type(moments_cubeprod_t) :: peak ! [     K] Peak intensity
     type(moments_cubeprod_t) :: area ! [*.km/s] Integrated intensity
     type(moments_cubeprod_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_cubeprod_t) :: cent ! [  km/s] Centroid velocity
     type(moments_cubeprod_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_cubeprod_t) :: eqwd ! [  km/s] area over peak
  contains
     procedure, public :: register => moments_cubeprodset_register
  end type moments_cubeprodset_t
  !
  type moments_cube_t
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     type(cube_t), pointer :: snr
   contains
     procedure, private :: header => cubemain_moments_cube_header_all
  end type moments_cube_t
  !
  type moments_cubeset_t
     type(moments_cube_t) :: peak ! [     K] Peak intensity
     type(moments_cube_t) :: area ! [*.km/s] Integrated intensity
     type(moments_cube_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_cube_t) :: cent ! [  km/s] Centroid velocity
     type(moments_cube_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_cube_t) :: eqwd ! [  km/s] area over peak
   contains
     procedure, public :: header => cubemain_moments_cubeset_header
  end type moments_cubeset_t
  !
contains
  !
  subroutine  moments_cubeprodset_register(cubeprodset,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(moments_cubeprodset_t), intent(in)    :: cubeprodset
    logical,                      intent(inout) :: error
    !
    call cubeprodset%peak%register('PEAKB','Peak brightness',&
         [flag_peak,flag_brightness],error)
    if (error) return
    call cubeprodset%velo%register('PEAKV','Peak velocity',&
         [flag_peak,flag_velocity],error)
    if (error) return
    call cubeprodset%area%register('AREA','Area',&
         [flag_area],error)
    if (error) return
    call cubeprodset%cent%register('CVELO','Centroid velocity',&
         [flag_centroid,flag_velocity],error)
    if (error) return
    call cubeprodset%fwhm%register('FWHM','FWHM',&
         [flag_fwhm,flag_width],error)
    if (error) return
    call cubeprodset%eqwd%register('EQWIDTH','Equivalent width',&
         [flag_equivalent,flag_width],error)
    if (error) return
  end subroutine moments_cubeprodset_register
  !
  subroutine moments_cubeprod_register(moments,name,hlp,flag_momkind,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(moments_cubeprod_t), intent(in)    :: moments
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: hlp
    type(flag_t),              intent(in)    :: flag_momkind(:)
    logical,                   intent(inout) :: error
    !
    type(cube_prod_t) :: oucube
    !
    call oucube%register(&
         name//'SIG',&
         hlp//' signal',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_signal],&
         moments%sig,&
         error)
    if (error) return
    call oucube%register(&
         name//'NOI',&
         hlp//' noise',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_noise],&
         moments%noi,&
         error)
    if (error) return
    call oucube%register(&
         name//'SNR',&
         hlp//' SNR',&
         strg_emp,&
         [flag_moment,flag_momkind(:),flag_snr],&
         moments%snr,&
         error)
    if (error) return
  end subroutine moments_cubeprod_register
  !
  subroutine cubemain_moments_cubeset_header(cubeset,prodset,cube,nw,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_cubeset_t),    intent(inout) :: cubeset
    type(moments_cubeprodset_t), intent(in)    :: prodset
    type(cube_t), pointer,       intent(in)    :: cube
    integer(kind=wind_k),        intent(in)    :: nw
    logical,                     intent(inout) :: error
    !
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='MOMENTS>CUBESET>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    unit = cube%head%arr%unit 
    call cubeset%peak%header(prodset%peak,unit,nw,cube,error)
    if (error) return
    call cubeset%velo%header(prodset%velo,'km/s',nw,cube,error)
    if (error) return
    call cubeset%area%header(prodset%area,trim(unit)//'.km/s',nw,cube,error)
    if (error) return
    call cubeset%cent%header(prodset%cent,'km/s',nw,cube,error)
    if (error) return
    call cubeset%fwhm%header(prodset%fwhm,'km/s',nw,cube,error)
    if (error) return
    call cubeset%eqwd%header(prodset%eqwd,'km/s',nw,cube,error)
    if (error) return
  end subroutine cubemain_moments_cubeset_header
  !
  subroutine cubemain_moments_cube_header_all(moments,momprod,unit,nw,cube,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_cube_t),    intent(inout) :: moments
    type(moments_cubeprod_t), intent(in)    :: momprod
    character(len=*),         intent(in)    :: unit
    integer(kind=wind_k),     intent(in)    :: nw
    type(cube_t), pointer,    intent(in)    :: cube
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>CUBE>HEADER>ALL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubemain_moments_cube_header_one(moments%sig,momprod%sig,&
         unit,nw,cube,error)
    if (error) return
    call cubemain_moments_cube_header_one(moments%noi,momprod%noi,&
         unit,nw,cube,error)
    if (error) return
    call cubemain_moments_cube_header_one(moments%snr,momprod%snr,&
         '---',nw,cube,error)
    if (error) return
  end subroutine cubemain_moments_cube_header_all
  !
  subroutine cubemain_moments_cube_header_one(ou,cubeprod,unit,nw,in,error)
    use cubeadm_clone
    use cubetools_axis_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: ou
    type(cube_prod_t),     intent(in)    :: cubeprod
    character(len=*),      intent(in)    :: unit
    integer(kind=wind_k),  intent(in)    :: nw
    type(cube_t), pointer, intent(in)    :: in
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='MOMENTS>CUBE>HEADER>ONE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(cubeprod,in,ou,error)
    if (error) return
    call cubetools_header_put_array_unit(unit,ou%head,error)
    if (error) return
    call cubetools_header_get_axis_head_c(ou%head,axis,error)
    if (error) return
    axis%n = nw
    axis%ref = 1d0
    axis%val = 0d0
    call cubetools_header_update_axset_c(axis,ou%head,error)
    if (error) return
  end subroutine cubemain_moments_cube_header_one  
end module cubemain_moments_cube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments_spec_types
  use cubetools_parameters
  use cubemain_messaging
  use cubemain_spectrum_real
  use cubemain_spectrum_moment_tool
  !
  public :: moments_spec_t
  private
  !
  type moments_spec_t
     type(spectrum_t) :: sig
     type(spectrum_t) :: noi
     type(spectrum_t) :: snr
   contains
     procedure, public :: reallocate => cubemain_moments_spec_reallocate
     procedure, public :: get        => cubemain_moments_spec_get
     procedure, public :: put        => cubemain_moments_spec_put
  end type moments_spec_t
  !
contains
  !
  subroutine cubemain_moments_spec_reallocate(spec,kind,nw,iterator,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_spec_t),    intent(inout) :: spec
    character(len=*),         intent(in)    :: kind
    integer(kind=wind_k),     intent(in)    :: nw
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k) :: mw
    character(len=*), parameter :: rname='MOMENTS>SPEC>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    mw = int(nw,kind=chan_k)
    call spec%sig%reallocate(kind//'-sig',mw,iterator,error)
    if (error) return
    call spec%noi%reallocate(kind//'-noi',mw,iterator,error)
    if (error) return
    call spec%snr%reallocate(kind//'-snr',mw,iterator,error)
    if (error) return
  end subroutine cubemain_moments_spec_reallocate
  !
  subroutine cubemain_moments_spec_get(spec,iw,val,error)
    use cubemain_spectrum_moment_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_spec_t),    intent(inout) :: spec
    integer(kind=wind_k),     intent(in)    :: iw
    class(spectrum_moment_t), intent(in)    :: val
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPEC>GET'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    spec%sig%t(iw) = val%sig
    spec%noi%t(iw) = val%noi
    spec%snr%t(iw) = val%snr
  end subroutine cubemain_moments_spec_get
  !
  subroutine cubemain_moments_spec_put(spec,cube,ie,error)
    use cubemain_moments_cube_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_spec_t), intent(in)    :: spec
    type(moments_cube_t),  intent(inout) :: cube
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPEC>PUT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%sig%put(cube%sig,ie,error)
    if (error) return
    call spec%noi%put(cube%noi,ie,error)
    if (error) return
    call spec%snr%put(cube%snr,ie,error)
    if (error) return
  end subroutine cubemain_moments_spec_put
end module cubemain_moments_spec_types
!
module cubemain_moments_specset_types
  use cubetools_parameters
  use cubemain_messaging
  use cubemain_moments_spec_types
  !
  public :: moments_specset_t
  private
  !
  type moments_specset_t
     type(moments_spec_t) :: peak ! [     *] Peak intensity
     type(moments_spec_t) :: velo ! [  km/s] Velocity at peak intensity
     type(moments_spec_t) :: area ! [*.km/s] Integrated intensity
     type(moments_spec_t) :: cent ! [  km/s] Centroid velocity
     type(moments_spec_t) :: fwhm ! [  km/s] Full Width at Half Maximum
     type(moments_spec_t) :: eqwd ! [  km/s] area over peak
   contains
     procedure, public :: reallocate => cubemain_moments_specset_reallocate
     procedure, public :: compute    => cubemain_moments_specset_compute
     procedure, public :: put        => cubemain_moments_specset_put
     procedure, public :: null       => cubemain_moments_specset_null
  end type moments_specset_t
  !
contains
  ! 
  subroutine cubemain_moments_specset_reallocate(specset,nw,iterator,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    integer(kind=wind_k),     intent(in)    :: nw
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPECSET>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%reallocate('peak',nw,iterator,error)
    if (error) return
    call specset%area%reallocate('area',nw,iterator,error)
    if (error) return
    call specset%velo%reallocate('velo',nw,iterator,error)
    if (error) return
    call specset%cent%reallocate('cent',nw,iterator,error)
    if (error) return
    call specset%fwhm%reallocate('fwhm',nw,iterator,error)
    if (error) return
    call specset%eqwd%reallocate('eqwd',nw,iterator,error)
    if (error) return
  end subroutine cubemain_moments_specset_reallocate
  !
  subroutine cubemain_moments_specset_compute(specset,spec,first,last,noise,good,iw,error)
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    use cubemain_spectrum_moment_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    type(spectrum_t),         intent(in)    :: spec
    integer(kind=chan_k),     intent(in)    :: first
    integer(kind=chan_k),     intent(in)    :: last
    real(kind=sign_k),        intent(in)    :: noise    
    type(spectrum_t),         intent(inout) :: good
    integer(kind=wind_k),     intent(in)    :: iw
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: line
    type(spectrum_tpeak_t) :: peak
    type(spectrum_vpeak_t) :: velo
    type(spectrum_area_t) :: area
    type(spectrum_cent_t) :: cent
    type(spectrum_fwhm_t) :: fwhm
    type(spectrum_eqwd_t) :: eqwd
    character(len=*), parameter :: rname='MOMENTS>SPECSET>COMPUTE'
    !
    call line%point_to(spec,first,last,noise,error)
    if (error) return
    call cubemain_spectrum_unblank(line,good,error)
    if (error) return
    if (good%n.gt.0) then
       ! Compute
       call peak%compute(good,error)
       if (error) return
       call velo%compute(good,peak,error)
       if (error) return             
       call area%compute(good,error)
       if (error) return
       call cent%compute(good,area,error)
       if (error) return
       call fwhm%compute(good,cent,error)
       if (error) return
       call eqwd%compute(peak,area,error)
       if (error) return
       call specset%peak%get(iw,peak,error)
       if (error) return
       call specset%area%get(iw,area,error)
       if (error) return
       call specset%velo%get(iw,velo,error)
       if (error) return
       call specset%cent%get(iw,cent,error)
       if (error) return
       call specset%fwhm%get(iw,fwhm,error)
       if (error) return
       call specset%eqwd%get(iw,eqwd,error)
       if (error) return
    else
       call specset%null(iw,error)
       if (error) return
    endif
  end subroutine cubemain_moments_specset_compute
  !
  subroutine cubemain_moments_specset_null(specset,iw,error)
    use cubemain_spectrum_moment_tool
    use cubetools_nan
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(inout) :: specset
    integer(kind=wind_k),     intent(in)    :: iw
    logical,                  intent(inout) :: error
    !
    type(spectrum_moment_t) :: null
    character(len=*), parameter :: rname='MOMENTS>SPECSET>NULL'
    !
    null%sig = gr4nan
    null%noi = gr4nan
    null%snr = gr4nan
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%get(iw,null,error)
    if (error) return
    call specset%area%get(iw,null,error)
    if (error) return
    call specset%velo%get(iw,null,error)
    if (error) return
    call specset%cent%get(iw,null,error)
    if (error) return
    call specset%fwhm%get(iw,null,error)
    if (error) return
    call specset%eqwd%get(iw,null,error)
    if (error) return
  end subroutine cubemain_moments_specset_null
  !
  subroutine cubemain_moments_specset_put(specset,cubeset,ie,error)
    use cubemain_moments_cube_types    
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_specset_t), intent(in)    :: specset
    type(moments_cubeset_t),  intent(inout) :: cubeset
    integer(kind=entr_k),     intent(in)    :: ie
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>SPECSET>PUT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call specset%peak%put(cubeset%peak,ie,error)
    if (error) return                                           
    call specset%area%put(cubeset%area,ie,error)
    if (error) return                                           
    call specset%velo%put(cubeset%velo,ie,error)
    if (error) return                                           
    call specset%cent%put(cubeset%cent,ie,error)
    if (error) return                                           
    call specset%fwhm%put(cubeset%fwhm,ie,error)
    if (error) return                                           
    call specset%eqwd%put(cubeset%eqwd,ie,error)
    if (error) return
  end subroutine cubemain_moments_specset_put
end module cubemain_moments_specset_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_moments
  use cubetools_parameters
  use cubetools_structure
  use cube_types
  use cubeadm_cubeid_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  use cubemain_moments_specset_types
  use cubemain_moments_cube_types
  use cubemain_range
  use cubemain_windowing
  !
  public :: moments
  private
  !
  type :: moments_comm_t
     type(option_t), pointer     :: comm
     type(range_opt_t)           :: range
     type(cubeid_arg_t), pointer :: cube
     type(cubeid_arg_t), pointer :: noise
     type(ancillary_cube_comm_t) :: win
     type(moments_cubeprodset_t) :: moments
   contains
     procedure, public  :: register => cubemain_moments_comm_register
     procedure, private :: parse    => cubemain_moments_comm_parse
     procedure, private :: main     => cubemain_moments_comm_main
  end type moments_comm_t
  type(moments_comm_t) :: moments
  !
  type moments_user_t
     type(cubeid_user_t)         :: cubeids
     type(ancillary_cube_user_t) :: win
     type(range_array_t)         :: range
     logical                     :: dorange = .false.
   contains
     procedure, private :: toprog => cubemain_moments_user_toprog
  end type moments_user_t
  !
  type moments_prog_t
     integer(kind=wind_k)        :: nw = 0  ! Number of windows
     integer(kind=chan_k)        :: nc = 0  ! Maximum number of channels inside one window
     type(window_array_t)        :: glowin ! One set of windows for the full index
     type(ancillary_cube_prog_t) :: locwin ! Number and positions of windows depend on the spectrum
     type(cube_t), pointer       :: noise
     type(cube_t), pointer       :: cube
     type(moments_cubeset_t)     :: moments
   contains
     procedure, private :: data        => cubemain_moments_prog_data
     procedure, private :: header      => cubemain_moments_prog_header
     procedure, private :: loop        => cubemain_moments_prog_loop
     procedure, private :: locwin_loop => cubemain_moments_prog_locwin_loop
     procedure, private :: locwin_act  => cubemain_moments_prog_locwin_act
     procedure, private :: glowin_loop => cubemain_moments_prog_glowin_loop
     procedure, private :: glowin_act  => cubemain_moments_prog_glowin_act
  end type moments_prog_t
  !
contains
  !
  subroutine cubemain_moments_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(moments_user_t) :: user
    character(len=*), parameter :: rname='MOMENTS>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call moments%parse(line,user,error)
    if (error) return
    call moments%main(user,error)
    if (error) continue
  end subroutine cubemain_moments_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(inout) :: comm
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    character(len=*), parameter :: rname='MOMENTS>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MOMENTS','[signalid [noiseid]]',&
         'Compute various moments for each spectrum of a cube',&
         'Compute moment products for each spectrum of SIGNALID using&
         & a global range or per-spectrum windows.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- MOMENTS computes peak, peak velocity, integrated area,&
         & centroid velocity, FWHM, and equivalent width.'//strg_cr//&
         '- For each quantity, signal, noise, and SNR products are&
         & written.'//strg_cr//&
         '- Window selection is controlled with /RANGE and /WINDOWS&
         & keys.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> MOMENTS 12co10:cube 12co10:noise /RANGE -5 15 km/s'//strg_cr//&
         'CUBE> MOMENTS 12co10:cube 12co10:noise /WINDOWS&
         & 12co10:window',&
         cubemain_moments_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%cube,&
         error)
    if (error) return
    call incube%register(&
         'NOISEID',&
         'Noise cube identifier',&
         'If omitted, use the last matching cube (noise flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_noise],&
         code_read,&
         code_access_speset,&
         comm%noise,&
         error)
    if (error) return
    !
    call comm%range%register('RANGE',&
         'Define the velocity range(s) over which to compute moments',&
         range_is_multiple,error)
    if (error) return
    !
    call comm%win%fully_register(&
         'WINDOWS','[windowid]',&
         'Use a window set per spectrum',&
         'If present, per-spectrum window pairs from WINDOWID are used&
         & and /RANGE is ignored. If /WINDOWS is absent, /RANGE is used&
         & and defaults to the full spectral axis when /RANGE is also&
         & absent. If WINDOWID is omitted, use the last matching cube&
         & (window flag) in the default index (DAG by default; see&
         & SET\INDEX).',&
         'WINDOWID','Spectral windows',&
         [flag_window],&
         code_arg_optional,&
         code_read,&
         code_access_speset,&
         error)
    if (error) return
    !
    ! Products
    call comm%moments%register(error)
    if (error)  return
  end subroutine cubemain_moments_comm_register
  !
  subroutine cubemain_moments_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! MOMENTS [signalid [noiseid]]
    ! /RANGE v11 v12 [... [vn1 vn2]] [unit]
    ! /WINDOWS [windowid]
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(inout) :: comm
    character(len=*),      intent(in)    :: line
    type(moments_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%range%parse(line,user%dorange,user%range,error)
    if (error) return
    call comm%win%parse(line,user%win,error)
    if (error) return
  end subroutine cubemain_moments_comm_parse
  !
  subroutine cubemain_moments_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_comm_t), intent(in)    :: comm
    type(moments_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(moments_prog_t) :: prog
    character(len=*), parameter :: rname='MOMENTS>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_moments_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_user_toprog(user,comm,prog,error)
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_user_t), intent(in)    :: user
    type(moments_comm_t),  intent(in)    :: comm
    type(moments_prog_t),  intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    logical :: conspb
    integer(kind=wind_k) :: iw
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='MOMENTS>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    conspb = .false. ! For consistency checks
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call cubeadm_get_header(comm%noise,user%cubeids,prog%noise,error)
    if (error) return
    call cubetools_consistency_signal_noise(&
         'Cube',prog%cube%head,&
         'Noise',prog%noise%head,conspb,&
         error)
    if (error) return
    call user%win%toprog(comm%win,prog%locwin,error)
    if (error) return
    if (prog%locwin%do) then
       ! User requests to use a windowing file
       call cubetools_consistency_spatial(&
            'Cube',prog%cube%head,&
            'Window',prog%locwin%cube%head,&
            conspb,error)
       if (error) return
       call cubetools_header_get_array_shape(prog%locwin%cube%head,n,error)
       if (error) return
       prog%nw = n%c
       if (mod(prog%nw,2).ne.0) then
          call cubemain_message(seve%e,rname,'Odd number of window edges!')
          error = .true.
          return
       else
          prog%nw = prog%nw/2
       endif
       !
       call cubetools_header_get_array_shape(prog%cube%head,n,error)
       if (error) return
       prog%nc = n%c
    else
       ! Try to use a global window
       ! When the user did not define any range, it defaults to the full
       ! spectrum range => 1 window
       ! *** JP: to be checked...
       call comm%range%user2prog(prog%cube,user%range,prog%glowin,error)
       if (error) return
       prog%nw = prog%glowin%n
       !
       prog%nc = 0
       do iw=1,prog%nw
          if (prog%nc.lt.prog%glowin%val(iw)%nc) prog%nc = prog%glowin%val(iw)%nc
       enddo ! iw
    endif
    if (cubetools_consistency_failed(rname,conspb,error)) return
    ! Another sanity check
    if (prog%nw.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    ! User feedback
    write (mess,'(a,i0)') 'Maximum number of spectral moments: ',prog%nw
    call cubemain_message(seve%i,rname,mess)
  end subroutine cubemain_moments_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_header(prog,comm,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(moments_prog_t), intent(inout) :: prog
    type(moments_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%moments%header(comm%moments,prog%cube,prog%nw,error)
    if (error) return
  end subroutine cubemain_moments_prog_header
  !
  subroutine cubemain_moments_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='MOMENTS>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))   
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_moments_prog_data
  !
  subroutine cubemain_moments_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='MOMENTS>PROG>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%locwin%do) then
       call prog%locwin_loop(iter,error)
       if (error) return
    else
       call prog%glowin_loop(iter,error)
       if (error) return
    endif
  end subroutine cubemain_moments_prog_loop  
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_locwin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    use cubemain_spectrum_blanking
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t), target, intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(inout) :: iter
    logical,                       intent(inout) :: error
    !
    type(spectrum_t) :: spec,good,noise,win
    type(moments_specset_t) :: specset
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MOMENTS>PROG>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%reassociate_and_init(prog%cube,iter,error)
    if (error) return
    call good%reallocate('good',prog%nc,iter,error)
    if (error) return
    call noise%reallocate('noise',one,iter,error)
    if (error) return
    call win%reallocate('win',int(2*prog%nw,kind=chan_k),iter,error)
    if (error) return
    call specset%reallocate(prog%nw,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%locwin_act(iter%ie,spec,good,noise,win,specset,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_moments_prog_locwin_loop
  !
  subroutine cubemain_moments_prog_locwin_act(prog,ie,spec,good,noise,win,specset,error)
    use cubemain_spectrum_real
    use cubetopology_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),   intent(inout) :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(spectrum_t),        intent(inout) :: spec
    type(spectrum_t),        intent(inout) :: good
    type(spectrum_t),        intent(inout) :: noise
    type(spectrum_t),        intent(inout) :: win
    type(moments_specset_t), intent(inout) :: specset
    logical,                 intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: ichan(2)
    real(kind=coor_k) :: vrange(2)
    character(len=*), parameter :: rname='MOMENTS>PROG>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    call noise%get(prog%noise,ie,error)
    if (error) return
    call win%get(prog%locwin%cube,ie,error)
    if (error) return
    do iw=1,prog%nw
       if (cubemain_window_blank(win,iw)) then
          call specset%null(iw,error)
          if (error) return
          cycle
       endif
       vrange(:) = win%t(2*iw-1:2*iw)
       call cubetopology_tool_vrange2crange(prog%cube,vrange,ichan,error)
       if (error) return
       call specset%compute(spec,ichan(1),ichan(2),noise%t(1),good,iw,error)
       if (error) return
    enddo ! iw
    call specset%put(prog%moments,ie,error)
    if (error) return
  end subroutine cubemain_moments_prog_locwin_act
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_moments_prog_glowin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: noise,spec,good
    type(moments_specset_t) :: specset
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MOMENTS>PROG>GLOWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%reassociate_and_init(prog%cube,iter,error)
    if (error) return
    call good%reallocate('good',prog%nc,iter,error)
    if (error) return
    call noise%reallocate('noise',one,iter,error)
    if (error) return
    call specset%reallocate(prog%nw,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%glowin_act(iter%ie,spec,good,noise,prog%glowin,specset,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_moments_prog_glowin_loop
  !
  subroutine cubemain_moments_prog_glowin_act(prog,ie,spec,good,noise,win,specset,error)
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(moments_prog_t),   intent(inout) :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(spectrum_t),        intent(inout) :: spec
    type(spectrum_t),        intent(inout) :: good
    type(spectrum_t),        intent(inout) :: noise
    type(window_array_t),    intent(in)    :: win
    type(moments_specset_t), intent(inout) :: specset
    logical,                 intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: sfirst,slast
    character(len=*), parameter :: rname='MOMENTS>PROG>GLOWIN>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spec%get(prog%cube,ie,error)
    if (error) return
    call noise%get(prog%noise,ie,error)
    if (error) return
    do iw=1,prog%nw
       if (win%val(iw)%nc.le.0) then
          call specset%null(iw,error)
          if (error) return
          cycle
       endif
       sfirst = win%val(iw)%o(1)
       slast  = win%val(iw)%o(2)
       call specset%compute(spec,sfirst,slast,noise%t(1),good,iw,error)
       if (error) return
    enddo ! iw
    call specset%put(prog%moments,ie,error)
    if (error) return
  end subroutine cubemain_moments_prog_glowin_act
end module cubemain_moments
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the CLIC package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine clic_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Public
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack  !
  ! Global
  external :: ephem_pack_set
  external :: clic_pack_init
  ! external :: clic_pack_clean
  !
  pack%name='clic'
  pack%ext='.clic'
  pack%depend(1:2) = (/ locwrd(ephem_pack_set), locwrd(greg_pack_set) /)
  pack%init=locwrd(clic_pack_init)
  ! pack%clean=locwrd(clic_pack_clean)
  pack%authors="V.Pietu, A.Castro-Carrizo"
  !
end subroutine clic_pack_set
!
subroutine clic_pack_init(gpack_id,error)
  use gkernel_interfaces
  use sic_def
  !---------------------------------------------------------------------
  ! Private
  !---------------------------------------------------------------------
  integer, intent(in) :: gpack_id   !
  logical, intent(inout) :: error   !
  ! Local
  character(len=80) :: comm
  !
  ! Ensure messages first since next calls produce messages
  call gmessage_log_date(.true.)
  call classic_message_set_id(gpack_id)
  call clic_message_set_id(gpack_id)  ! Set library id
  !
  ! Local language
  call init_clic
  call found_variable
  call mth_init               ! Init MATH package
  !
!!!!!!!!!!!!! Unneeded !!!!!!!!!!!!!!!!
!       CALL MESNAME(LOGFILE)
!       MESFILE = LOGFILE
!       NL = LENC(LOGFILE)
!       LOGFILE(NL-3:) = '.log'
!       MESFILE(NL-3:) = '.mes'
! Get rid of older versions
!       STATUS = SIC_PURGE (LOGFILE,2)
!       STATUS = SIC_PURGE (MESFILE,2)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!       CALL SIC_OPT(NAME,LOGFILE,.TRUE.)
!
! Set priorities:
#if defined(SDM)
      CALL MESSAGE_INIT('',2,2)
#else
      CALL MESSAGE_INIT('',1,0)
#endif
!
  comm = 'CLIC'//backslash//'SHOW'
  call sic_setsymbol('SH*OW',comm,error)
  comm = 'CLIC'//backslash//'FIND'
  call sic_setsymbol('FIN*D',comm,error)
!  comm = 'SIC'//backslash//'HELP CLIC'//backslash//' INFO'
!  call siC_setsymbol('INFO',comm,error)
  comm = 'CLIC'//backslash//'HEADER'
  call sic_setsymbol('HEAD*ER',comm,error)
  comm = 'CLIC'//backslash//'SET DEFAULT'
  call exec_program(comm)
  !
end subroutine clic_pack_init
!
! subroutine clic_pack_clean(error)
!   !----------------------------------------------------------------------
!   ! Private
!   !----------------------------------------------------------------------
!   logical, intent(inout) :: error
!   !
! end subroutine clic_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_read_header(filename,imbf,error)
  use gildas_def
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_read_header
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Open the file, read the leading HDUs, and build the list
  ! (equivalence classes) of subscans.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename
  type(imbfits_t),  intent(inout) :: imbf
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>HEADER'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  call imbfits_reopen_file(filename,imbf%file,imbf%hdus,error)
  if (error) return
  !
  call imbfits_read_leadhdus(imbf,error)
  if (error) return
  !
  call imbfits_check_leadhdus(imbf,error)
  if (error) return
  !
  call imbfits_read_subscan_eclass(imbf,error)
  if (error)  return
  !
end subroutine imbfits_read_header
!
subroutine imbfits_reopen_file(filename,file,hdus,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_reopen_file
  !---------------------------------------------------------------------
  ! @ private
  ! Open, if needed, the given file. Close of needed any previous file
  ! (if different).
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: filename
  type(imbfits_file_t), intent(inout) :: file
  type(imbfits_hdus_t), intent(inout) :: hdus
  logical,              intent(inout) :: error
  !
  if (file%name.eq.'') then
    ! No previous file in memory
    call imbfits_open_file(filename,file,hdus,error)
    !
  elseif (filename.eq.file%name) then
    ! Same file, is it closed or opened?
    if (file%unit.eq.0) then
      ! File is closed, open it
      call imbfits_open_file(filename,file,hdus,error)
    else
      ! Same file, already opened: nothing to do
      continue
    endif
  else
    ! Not the same file name
    if (file%unit.ne.0) then
      ! The old file is still opened: close it
      call imbfits_close_file(file,error)
      if (error)  return
    endif
    call imbfits_open_file(filename,file,hdus,error)
  endif
  !
end subroutine imbfits_reopen_file
!
subroutine imbfits_open_file(filename,file,hdus,error)
  use gbl_message
  use gildas_def
  use cfitsio_api
  use gkernel_interfaces
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_open_file
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: filename
  type(imbfits_file_t), intent(out)   :: file
  type(imbfits_hdus_t), intent(out)   :: hdus
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>OPEN>FILE'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  ! CFITSIO is able to deal with several files at the same time as long
  ! as we identify them with different logical units.
  status = sic_getlun(file%unit)
  if (status.ne.1) then
    call imbfits_message(seve%e,rname,'Could not get new logical unit')
    error = .true.
    return
  endif
  !
  status = 0
  file%name = filename
  call ftopen(file%unit,file%name,file%rwstatus,file%block,status)
  if (status.gt.0) then
     call imbfits_message(seve%e,rname,'Do not succeed to open '''//trim(file%name)//'''')
     call cfitsio_errormsg(status)
     error = .true.
     ! Must clean before exit
     file%name = ''
     call sic_frelun(file%unit)
     file%unit = 0
     return
  endif
  !
  call imbfits_hdus(file,hdus,error)
  if (error)  return
  !
end subroutine imbfits_open_file
!
subroutine imbfits_read_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_read_leadhdus
  !---------------------------------------------------------------------
  ! @ public
  ! Read the 4 first leading HDUs
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>LEADHDUS'
  !
  call imbfits_read_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  imbf%file%isholography = imbf%primary%instrume%val.eq.'holo'
  !
  call imbfits_read_header_scan(imbf,imbf%scan,error)
  if (error)  return
  !
  call imbfits_read_header_frontend(imbf%file,imbf%front,error)
  if (error)  return
  imbf%file%isarray = any(imbf%front%table%nofeeds%val.gt.1)
  !
  ! Backend-HDU: must come after Frontend-HDU
  call imbfits_read_header_backend(imbf,error)
  if (error)  return
  !
  ! Derotator: only for array receivers
  if (imbf%file%isarray) then
    call imbfits_read_header_derot(imbf,imbf%derot,error)
  else
    call imbfits_free_header_derot(imbf%derot,error)
  endif
  if (error)  return
  !
end subroutine imbfits_read_leadhdus
!
subroutine imbfits_check_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_check_leadhdus
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 4 first HDUs
  !---------------------------------------------------------------------
  type(imbfits_t),  intent(inout) :: imbf      !
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='CHECK>LEADHDUS'
  !
  call imbfits_check_header_primary(imbf%file,imbf%primary,error)
  if (error)  return
  call imbfits_check_header_scan(imbf%primary,imbf%scan,error)
  if (error)  return
  ! call imbfits_check_header_frontend(imbf%file,imbf%front,error)
  ! if (error)  return
  call imbfits_check_header_backend(imbf%back,error)
  if (error)  return
  !
end subroutine imbfits_check_leadhdus
!
subroutine imbfits_read_subscan_eclass(imbf,error)
  use gkernel_interfaces
  use imbfits_interfaces, except_this=>imbfits_read_subscan_eclass
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Run through all the subscans headers and build equivalences classes
  ! for all of them
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  logical,         intent(inout) :: error
  ! Local
  integer(kind=4) :: isub,nsub
  type(imbfits_subscan_t) :: subs
  !
  nsub = imbf%primary%n_obsp%val
  !
  call reallocate_eclass_char(imbf%seclass,nsub,error)
  if (error)  return
  !
  do isub=1,nsub
    ! Read IMBF-antenna ONLY for efficiency purpose
    ! Note: no need for mjd_shift => set to 0
    call imbfits_read_header_antslow(imbf,isub,0.d0,subs%antslow,error)
    if (error)  goto 100
    !
    imbf%seclass%val(isub) = subs%antslow%head%substype%val
    imbf%seclass%cnt(isub) = 1
  enddo
  !
  ! Compute equivalence classes to gather the subscans by family:
  call eclass_char(eclass_char_eq,imbf%seclass)
  !
100 continue
  call imbfits_free_header_antslow(subs%antslow,error)
  if (error)  return
  !
end subroutine imbfits_read_subscan_eclass
!
subroutine imbfits_close_file(file,error)
  use gbl_message
  use gildas_def
  use cfitsio_api
  use gkernel_interfaces
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_close_file
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(inout) :: file
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='IMBFITS>CLOSE>FILE'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  status = 0
  call ftclos(file%unit,status)
  if (status.gt.0) then
     call imbfits_message(seve%e,rname,'Do not succeed to close '//trim(file%name))
     call cfitsio_errormsg(status)
     error = .true.
     return
  endif
  !
  call sic_frelun(file%unit)
  file%unit = 0
  !
end subroutine imbfits_close_file
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_free_leadhdus(imbf,error)
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_free_leadhdus
  !---------------------------------------------------------------------
  ! @ public
  ! Free the leading HDUs. Can be called in an error recovery context
  ! i.e. with error .true. as input.
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf      !
  logical,         intent(inout) :: error     !
  !
  call imbfits_free_header_primary(imbf%primary,error)
  if (error)  continue
  call imbfits_free_header_scan(imbf%scan,error)
  if (error)  continue
  call imbfits_free_header_frontend(imbf%front,error)
  if (error)  continue
  call imbfits_free_header_backend(imbf%back,error)
  if (error)  continue
  call imbfits_free_header_derot(imbf%derot,error)
  if (error)  continue
  !
end subroutine imbfits_free_leadhdus
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!*********************************************************************
! INTEGER*8 Generic External three argument function on vectors
!
subroutine do_long_loop3 (func,n,result,m1,oper1,m2,oper2,m3,oper3,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func      !
  integer(kind=size_length)                :: n         !
  integer(kind=8)                          :: result(n) !
  integer(kind=size_length)                :: m1        !
  integer(kind=8)                          :: oper1(m1) !
  integer(kind=size_length)                :: m2        !
  integer(kind=8)                          :: oper2(m2) !
  integer(kind=size_length)                :: m3        !
  integer(kind=8)                          :: oper3(m3) !
  logical,                   intent(inout) :: error     !
  ! Local
  integer(kind=8) :: r,a,b,c
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1 .and. m3.eq.1) then
    r = func(oper1(1),oper2(1),oper3(1))
    do i=1,n
      result(i) = r
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.1) then
    b = oper2(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),b,c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.1) then
    a = oper1(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(a,oper2(i),c)
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.1) then
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),oper2(i),c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.1 .and. m3.eq.n) then
    a = oper1(1)
    b = oper2(1)
    do i=1,n
      result(i) = func(a,b,oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.n) then
    b = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),b,oper3(i))
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i),oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i),oper3(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2,m3
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop3
!
!*********************************************************************
! INTEGER*8 Generic External two argument function on vectors
!
subroutine do_long_loop2 (func,n,result,m1,oper1,m2,oper2,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func      !
  integer(kind=size_length)                :: n         !
  integer(kind=8)                          :: result(n) !
  integer(kind=size_length)                :: m1        !
  integer(kind=8)                          :: oper1(m1) !
  integer(kind=size_length)                :: m2        !
  integer(kind=8)                          :: oper2(m2) !
  logical,                   intent(inout) :: error     !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1) then
    a = func(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop2
!
!----------------------------------------------------------------------
! INTEGER*8 Two operands arithmetic operations on vectors
!
function lsic_i_bplus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bplus   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_bplus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_BPLUS',mess)
    lsic_i_bplus = 1
  endif
end function lsic_i_bplus
!
function lsic_i_bminus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bminus  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_bminus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)-oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)-a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a-oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)-oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_BMINUS',mess)
    lsic_i_bminus = 1
  endif
end function lsic_i_bminus
!
function lsic_i_mul (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_mul     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_mul = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)*oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)*a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a*oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)*oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MUL',mess)
    lsic_i_mul = 1
  endif
end function lsic_i_mul
!
function lsic_i_div (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Integer division: what should be the rule with negative operands?
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_div     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  integer(kind=8), parameter :: i_pinf=9223372036854775807_8  ! 2**63-1
  integer(kind=8), parameter :: i_minf=-i_pinf-1              ! -2**63
  integer(kind=8), parameter :: i_nan=0
  !
  lsic_i_div = 0
  if (m1.eq.1 .and. m2.eq.1) then
    if (oper2(1).ne.0) then
      a = int(oper1(1)/oper2(1),8)  ! Wrong (precision loss)?
    elseif (oper1(1).gt.0) then
      a = i_pinf
    elseif  (oper1(1).lt.0) then
      a = i_minf
    else
      a = i_nan
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      if (a.ne.0) then
        result(i) = int(oper1(i)/a,8)  ! Wrong (precision loss)?
      elseif  (oper1(i).gt.0) then
        result(i) = i_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = int(a/oper2(i),8)  ! Wrong (precision loss)?
      elseif  (a.gt.0) then
        result(i) = i_pinf
      elseif  (a.lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = int(oper1(i)/oper2(i),8)  ! Wrong (precision loss)?
      elseif  (oper1(i).gt.0) then
        result(i) = i_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = i_minf
      else
        result(i) = i_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_DIV',mess)
    lsic_i_div = 1
  endif
end function lsic_i_div
!
function lsic_i_power (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_power   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_power = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)**oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)**a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a**oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)**oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_POWER',mess)
    lsic_i_power = 1
  endif
end function lsic_i_power
!
!----------------------------------------------------------------------
! INTEGER*8 Two argument functions on vectors
!
function lsic_i_min (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_min     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_min = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = min(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = min(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = min(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = min(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MIN',mess)
    lsic_i_min = 1
  endif
end function lsic_i_min
!
function lsic_i_max (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_max     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_max = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = max(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = max(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = max(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = max(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MAX',mess)
    lsic_i_max = 1
  endif
end function lsic_i_max
!
function lsic_i_atan2 (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atan2   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATAN2','Not implemented')
  lsic_i_atan2 = 1
  !
end function lsic_i_atan2
!
function lsic_i_dim (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_dim     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_dim = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = dim(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = dim(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = dim(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = dim(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_DIM',mess)
    lsic_i_dim = 1
  endif
end function lsic_i_dim
!
function lsic_i_sign (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sign    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_sign = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = sign(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = sign(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = sign(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = sign(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_SIGN',mess)
    lsic_i_sign = 1
  endif
end function lsic_i_sign
!
function lsic_i_mod (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_mod     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: m2   !
  integer(kind=8) :: oper2(m2)      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_mod = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = mod(oper1(1),oper2(1))
    if (a.lt.0.0) a = a+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = mod(oper1(i),a)
      if (result(i).lt.0.0) result(i) = result(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = mod(a,oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = mod(oper1(i),oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'I_MOD',mess)
    lsic_i_mod = 1
  endif
end function lsic_i_mod
!
!----------------------------------------------------------------------
! INTEGER*8 Generic External single argument function on vector
!
subroutine do_long_loop1(func,n,result,m1,oper1,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           external      :: func       !
  integer(kind=size_length)                :: n          !
  integer(kind=8)                          :: result(n)  !
  integer(kind=size_length)                :: m1         !
  integer(kind=8)                          :: oper1(m1)  !
  logical,                   intent(inout) :: error      !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1) then
    a = func(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = func(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_FUNC',mess)
    error = .true.
  endif
end subroutine do_long_loop1
!
!----------------------------------------------------------------------
! INTEGER*8 Single argument functions on vectors
!
function lsic_i_abs (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_abs     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_abs = 0
  if (m1.eq.1) then
    a = abs(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = abs(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_ABS',mess)
    lsic_i_abs = 1
  endif
end function lsic_i_abs
!
function lsic_i_acos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_acos    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ACOS','Not implemented')
  lsic_i_acos = 1
  !
end function lsic_i_acos
!
function lsic_i_asin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_asin    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ASIN','Not implemented')
  lsic_i_asin = 1
  !
end function lsic_i_asin
!
function lsic_i_atan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atan    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATAN','Not implemented')
  lsic_i_atan = 1
  !
end function lsic_i_atan
!
function lsic_i_atanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_atanh   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ATANH','Not implemented')
  lsic_i_atanh = 1
  !
end function lsic_i_atanh
!
function lsic_i_cos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_cos     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_COS','Not implemented')
  lsic_i_cos = 1
  !
end function lsic_i_cos
!
function lsic_i_cosh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_cosh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_COSH','Not implemented')
  lsic_i_cosh = 1
  !
end function lsic_i_cosh
!
function lsic_i_exp (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_exp     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_EXP','Not implemented')
  lsic_i_exp = 1
  !
end function lsic_i_exp
!
function lsic_i_int (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_int     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_int = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_INT',mess)
    lsic_i_int = 1
  endif
end function lsic_i_int
!
function lsic_i_log (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_log     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_LOG','Not implemented')
  lsic_i_log = 1
  !
end function lsic_i_log
!
function lsic_i_log10 (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_log10   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_LOG10','Not implemented')
  lsic_i_log10 = 1
  !
end function lsic_i_log10
!
function lsic_i_nint (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_nint    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_nint = 0
  if (m1.eq.1) then
    a = oper1(1)  ! NINT on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_NINT',mess)
    lsic_i_nint = 1
  endif
end function lsic_i_nint
!
function lsic_i_sin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sin     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SIN','Not implemented')
  lsic_i_sin = 1
  !
end function lsic_i_sin
!
function lsic_i_sinh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sinh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SINH','Not implemented')
  lsic_i_sinh = 1
  !
end function lsic_i_sinh
!
function lsic_i_sqrt (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_sqrt    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_SQRT','Not implemented')
  lsic_i_sqrt = 1
  !
end function lsic_i_sqrt
!
function lsic_i_tan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_tan     !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_TAN','Not implemented')
  lsic_i_tan = 1
  !
end function lsic_i_tan
!
function lsic_i_tanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_tanh    !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_TANH','Not implemented')
  lsic_i_tanh = 1
  !
end function lsic_i_tanh
!
function lsic_i_floor (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_floor   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_floor = 0
  if (m1.eq.1) then
    a = oper1(1)  ! FLOOR on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_FLOOR',mess)
    lsic_i_floor = 1
  endif
end function lsic_i_floor
!
function lsic_i_ceiling (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_ceiling  !
  integer(kind=size_length) :: n     !
  integer(kind=8) :: result(n)       !
  integer(kind=size_length) :: m1    !
  integer(kind=8) :: oper1(m1)       !
  integer(kind=size_length) :: k     !
  integer :: dummy                   !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_ceiling = 0
  if (m1.eq.1) then
    a = oper1(1)  ! CEILING on int value => simple copy
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_CEILING',mess)
    lsic_i_ceiling = 1
  endif
end function lsic_i_ceiling
!
function lsic_i_uminus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_uminus  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_uminus = 0
  if (m1.eq.1) then
    a = -oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = -oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_UMINUS',mess)
    lsic_i_uminus = 1
  endif
end function lsic_i_uminus
!
function lsic_i_uplus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_uplus   !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  ! Local
  integer(kind=8) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_i_uplus = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'I_PLUS',mess)
    lsic_i_uplus = 1
  endif
end function lsic_i_uplus
!
function lsic_i_pyfunc (noper,nelem,nwords,n,result)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! INTEGER*8 Generic PYTHON function with variable number of arguments
  !        Called by DO_VECTOR
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_pyfunc  ! Function value on return
  integer(kind=4),              intent(in)  :: noper          ! Number of operands
  integer(kind=size_length),    intent(in)  :: nelem(noper)   ! # of elements for each operand
  integer(kind=address_length), intent(in)  :: nwords(noper)  ! Memory location for each operand
  integer(kind=size_length),    intent(in)  :: n              ! Size of result
  integer(kind=8),              intent(out) :: result(n)      ! Result
  !
  ! Check dimensions and construct strides
#if defined(GAG_USE_PYTHON)
  ! C does not have an equivalent for integer*8 on all platforms...
  result(:) = 0
  call sic_message(seve%e,'I_PYFUNC','Not implemented')
  lsic_i_pyfunc = 1
#else
  call sic_message(seve%e,'I_PYFUNC','Python not available')
  lsic_i_pyfunc = 1
#endif
end function lsic_i_pyfunc
!
function lsic_i_erf(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erf    !
  integer(kind=size_length) :: n   !
  integer(kind=8) :: result(n)     !
  integer(kind=size_length) :: m1  !
  integer(kind=8) :: oper1(m1)     !
  integer(kind=size_length) :: k   !
  integer :: dummy                 !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERF','Not implemented')
  lsic_i_erf = 1
  !
end function lsic_i_erf
!
function lsic_i_erfc(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfc   !
  integer(kind=size_length) :: n   !
  integer(kind=8) :: result(n)     !
  integer(kind=size_length) :: m1  !
  integer(kind=8) :: oper1(m1)     !
  integer(kind=size_length) :: k   !
  integer :: dummy                 !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFC','Not implemented')
  lsic_i_erfc = 1
  !
end function lsic_i_erfc
!
function lsic_i_erfinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfinv  !
  integer(kind=size_length) :: n    !
  integer(kind=8) :: result(n)      !
  integer(kind=size_length) :: m1   !
  integer(kind=8) :: oper1(m1)      !
  integer(kind=size_length) :: k    !
  integer :: dummy                  !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFINV','Not implemented')
  lsic_i_erfinv = 1
  !
end function lsic_i_erfinv
!
function lsic_i_erfcinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_erfcinv  !
  integer(kind=size_length) :: n     !
  integer(kind=8) :: result(n)       !
  integer(kind=size_length) :: m1    !
  integer(kind=8) :: oper1(m1)       !
  integer(kind=size_length) :: k     !
  integer :: dummy                   !
  !
  result(:) = 0
  call sic_message(seve%e,'I_ERFCINV','Not implemented')
  lsic_i_erfcinv = 1
  !
end function lsic_i_erfcinv
!
function lsic_i_bessel_i0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_i0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_I0','Not implemented')
  lsic_i_bessel_i0 = 1
  !
end function lsic_i_bessel_i0
!
function lsic_i_bessel_i1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_i1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_I1','Not implemented')
  lsic_i_bessel_i1 = 1
  !
end function lsic_i_bessel_i1
!
function lsic_i_bessel_in(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_in  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_IN','Not implemented')
  lsic_i_bessel_in = 1
  !
end function lsic_i_bessel_in
!
function lsic_i_bessel_j0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_j0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_J0','Not implemented')
  lsic_i_bessel_j0 = 1
  !
end function lsic_i_bessel_j0
!
function lsic_i_bessel_j1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_j1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_J1','Not implemented')
  lsic_i_bessel_j1 = 1
  !
end function lsic_i_bessel_j1
!
function lsic_i_bessel_jn(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_jn  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_JN','Not implemented')
  lsic_i_bessel_jn = 1
  !
end function lsic_i_bessel_jn
!
function lsic_i_bessel_y0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_y0  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_Y0','Not implemented')
  lsic_i_bessel_y0 = 1
  !
end function lsic_i_bessel_y0
!
function lsic_i_bessel_y1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_y1  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_Y1','Not implemented')
  lsic_i_bessel_y1 = 1
  !
end function lsic_i_bessel_y1
!
function lsic_i_bessel_yn(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_i_bessel_yn  !
  integer(kind=size_length) :: n       !
  integer(kind=8) :: result(n)         !
  integer(kind=size_length) :: m1      !
  integer(kind=8) :: oper1(m1)         !
  integer(kind=size_length) :: k       !
  integer :: dummy                     !
  !
  result(:) = 0
  call sic_message(seve%e,'I_BESSEL_YN','Not implemented')
  lsic_i_bessel_yn = 1
  !
end function lsic_i_bessel_yn

!-----------------------------------------------------------------------
! ZZZ Attacher du texte aux png
! ZZZ Quid si l'utilisateur a modifie ses pens?
! ZZZ DEVICE PNG BLACK devrait changer cette variable x_back (dans le
!     tdf) (cf combinaison grey+black)
! ZZZ En mode grey, la couleur des segments est mal convertie.
! ZZZ Utilisation en device principal? CLEAR?
! ZZZ Tout documenter
! ZZZ Renommer gi4_bltlis.
! ZZZ Supprimer les globaux en C puis Fortran
!-----------------------------------------------------------------------
!
module gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! Variables and parameters for PNG devices support
  !---------------------------------------------------------------------
  !
  integer(kind=4), parameter :: pngmap_size = 65536  ! i.e. the most we
    ! can encode in integers of KIND=BITMAP_DEPTH == 2
  integer(kind=4), parameter :: pngmap_offset = -32768  ! i.e. encode the
    ! 65536 colors from -32768 to 32767
  !
  ! Some integer*1 typical values
  integer(kind=1) :: i0,i255
  integer(kind=1) :: dummy  ! Used when some of the channels are not used
  !
end module gtv_png
!
subroutine png_open(output,error,dir)
  use gtv_interfaces, except_this=>png_open
  use gtv_png
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Open the PNG output file.
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout)        :: output  ! Output instance
  logical,            intent(inout)        :: error   ! Logical error flag
  type(gt_directory), intent(in), optional :: dir     ! The directory to display, or
#if defined(PNG)
  ! Local
  character(len=*), parameter :: rname='PNG_OPEN'
  integer :: ier,npixx,npixy
  integer(kind=1) :: ibackground,itransparency
  character(len=message_length) :: mess
  !
  if (output%file.eq.' ' .and. output%tofile) then
    call gtv_message(seve%e,rname,'File name is missing')
    error = .true.
    return
  endif
  !
  ! Initialize some shared values
  i0   = si4_to_ui1(0)
  i255 = si4_to_ui1(255)
  !
  ! Black or white device?
  if (output%background.eq.0) then
    ibackground = i0
  else
    ibackground = i255
  endif
  !
  ! Transparent background or not?
  if (output%png%transparency) then
    itransparency = i0
  else
    itransparency = i255
  endif
  !
  ! Set number of channels (planes). Use it also as a unique identifier since
  ! there is no ambiguity between the number of channels and the different
  ! available devices.
  if (output%color) then
    output%png%nchan = 3
  else
    output%png%nchan = 1  ! (grey)
  endif
  if (output%png%transparency)  output%png%nchan = output%png%nchan+1
  !
  if (output%png%cropped .and. present(dir)) then
    ! Crop the area viewed by the PNG instance
    call gt_hardcopy_crop(output,dir,error)
    if (error)  return
  endif
  !
  ! Use the actual number of pixels of the output instance.
  npixx = output%px2
  npixy = output%py2
  !
  ! Buffer allocation
  select case (output%png%nchan)
  case(1)
    allocate(output%png%R(npixx,npixy),stat=ier)
  case(2)
    allocate(output%png%R(npixx,npixy),  &
             output%png%A(npixx,npixy),stat=ier)
  case(3)
    allocate(output%png%R(npixx,npixy),  &
             output%png%G(npixx,npixy),  &
             output%png%B(npixx,npixy),stat=ier)
  case(4)
    allocate(output%png%R(npixx,npixy),  &
             output%png%G(npixx,npixy),  &
             output%png%B(npixx,npixy),  &
             output%png%A(npixx,npixy),stat=ier)
  case default
    call gtv_message(seve%e,rname,"Internal error, unsupported number of channels")
    error = .true.
    return
  end select
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,"Internal error, R/G/B/A allocation failed")
    error = .true.
    return
  endif
  !
  ier = gpng_zopen(output%file,len_trim(output%file),npixx,npixy,output%png%nchan)
  if (ier.ne.0) then
    write(mess,'(A,A,A,3(I0,A))') 'Error creating file ',trim(output%file),  &
      ': ',npixx,' x ',npixy,' pixels x ',output%png%nchan,' channels'
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Initialize the arrays
  output%png%R = ibackground
  if (output%png%nchan.ge.3) then
    output%png%G = ibackground
    output%png%B = ibackground
  endif
  if (output%png%transparency)  output%png%A = itransparency
  !
  ! Initialize the colormap
  ! ZZZ Do something: we may not want to use LUT 0 e.g. in grey mode
  ! call load_lut(output%map,.true.,output%color,0,error)
  ! if (error)  return
  !
#else
  call gtv_message(seve%e,'HARDCOPY','No PNG support on this system')
  error = .true.
  return
#endif
  !
end subroutine png_open
!
subroutine png_close(output,desc)
  use gtv_interfaces, except_this=>png_close
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Close the current PNG device, i.e. copy the rows to the file
  ! opened by the C routines, and close it.
  !---------------------------------------------------------------------
  type(gt_display),       intent(inout) :: output
  real(kind=4), optional, intent(in)    :: desc(4)
#if defined(PNG)
  ! Local
  integer(kind=4) :: row
  !
  do row=output%py2,1,-1
    select case (output%png%nchan)
    case (1)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          dummy,                &
                          dummy,                &
                          dummy)
    case (2)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          dummy,                &
                          dummy,                &
                          output%png%A(1,row))
    case (3)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          output%png%G(1,row),  &
                          output%png%B(1,row),  &
                          dummy)
    case (4)
      call gpng_copy_data(row,  &
                          output%png%R(1,row),  &
                          output%png%G(1,row),  &
                          output%png%B(1,row),  &
                          output%png%A(1,row))
    end select
  enddo
  !
  call gpng_finish()
  !
  if (.not.output%tofile)  call png_base64(output,desc)
  !
  call gpng_cleanup()
  !
  if (allocated(output%png%R)) deallocate(output%png%R)
  if (allocated(output%png%G)) deallocate(output%png%G)
  if (allocated(output%png%B)) deallocate(output%png%B)
  if (allocated(output%png%A)) deallocate(output%png%A)
  !
#endif
end subroutine png_close
!
subroutine png_base64(output,desc)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>png_base64
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Dump the PNG currently in memory with base 64 encoding. This makes
  ! sense only for memory only PNG, which have no associated file on
  ! disk.
  !  Because the output is not the (binary) PNG but an encoded form,
  ! a header and footer are added.
  !---------------------------------------------------------------------
  type(gt_display),       intent(in) :: output
  real(kind=4), optional, intent(in) :: desc(4)
#if defined(PNG)
  ! Local
  integer(kind=4) :: memory(2),size
  integer(kind=address_length) :: addr,ip
  !
  ! Get the memory buffer address
  call gpng_getbuf(size,addr)  ! ZZZ sanity check
  !
  ! --- Header ---
  !
  if (present(desc)) then
    ! Reference position and image size (in device units), suited for
    ! embedding in SVG
    !
    write(output%iunit,'(5(A,F0.1))')  &
      '<image preserveAspectRatio="none" x="',desc(1),'" y="',desc(2),  &
      '" width="',desc(3),'" height="',desc(4),'" xlink:href="data:image/png;base64,'
    !
  else
    ! More basic header. Relative position does not make sense
    write(output%iunit,'(A,I0,A,I0,A)')  &
      '<image width="',output%px2,'" height="',output%py2,'" xlink:href="data:image/png;base64,'
  endif
  !
  ! --- Data ---
  ! Pass the C buffer and convert it to base-64
  ip = gag_pointer(addr,memory)
  call base64_encode(memory(ip),size,output%iunit)
  !
  ! --- Footer ---
  write(output%iunit,'(A)') '"/>'
  !
#endif
end subroutine png_base64
!
subroutine png_hard(out)
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  !
  !
  ! Dash
  if (out%idashe.ne.1) then
    out%dev%hardw_line_dash = .false.
  else
    out%dev%hardw_line_dash = .true.
  endif
  !
  ! Weight. Always use hardware thickness generator. Take care
  ! that simulating thickness with gtx_chopper draws several lines
  ! on each side of the original line, which can lead to negative
  ! positions in cropped PNG => error!
  out%dev%hardw_line_weig = .true.
  !
end subroutine png_hard
!
subroutine png_pen_negative(out)
  use gtv_interfaces, except_this=>png_pen_negative
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen as negative, i.e. invert pixels below
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! The PNG instance
#if defined(PNG)
  !
  out%png%negative = .true.
  ! Put some grey just safety. Normally unused.
  out%png%rpen = si4_to_ui1(128)
  out%png%gpen = si4_to_ui1(128)
  out%png%bpen = si4_to_ui1(128)
  !
#endif
end subroutine png_pen_negative
!
subroutine png_pen_rgb(out,r,g,b)
  use gtv_interfaces, except_this=>png_pen_rgb
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen from the input R G B values (0-255)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! The PNG instance
  integer(kind=4),  intent(in)    :: r,g,b  !
#if defined(PNG)
  !
  out%png%negative = .false.
  out%png%rpen = si4_to_ui1(r)
  out%png%gpen = si4_to_ui1(g)
  out%png%bpen = si4_to_ui1(b)
  !
#endif
end subroutine png_pen_rgb
!
subroutine png_weigh(out,width)
  use gtv_interfaces, except_this=>png_weigh
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen width. Note that we may get a 0 width, which
  ! means "hairline" (smallest possible on the device)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! The PNG instance
  integer(kind=4),  intent(in)    :: width  ! New pen width (pixels)
  !
  out%png%width = max(width,1)
end subroutine png_weigh
!
subroutine png_moveto(out,x,y)
  use gtv_interfaces, except_this=>png_moveto
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Move the pen to the input location
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! Input gt_display
  real(kind=4),     intent(in)    :: x,y  ! New pen coordinates, in world coordinates
  !
  call world_to_pixel(out,x,y,out%png%xpos,out%png%ypos)
  !
end subroutine png_moveto
!
subroutine png_lineto(out,x,y)
  use gtv_interfaces, except_this=>png_lineto
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw a line from current pen position to input location, simulating
  ! its thickness if needed.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out  ! Input gt_display
  real(kind=4),     intent(in)    :: x,y  ! Draw line down to this location, in world coordinates
  ! Local
  real(kind=4) :: xend,yend
  !
  call world_to_pixel(out,x,y,xend,yend)
  !
  call png_wline(out,out%png%xpos,out%png%ypos,xend,yend)
  !
  out%png%xpos = xend
  out%png%ypos = yend
  !
end subroutine png_lineto
!
subroutine png_wline(out,xr1,yr1,xr2,yr2)
  use gtv_interfaces, except_this=>png_wline
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a line from (x1,y1) to (x2,y2), simulating its width by
  ! drawing several 1-pixel lines
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out      ! Input gt_display
  real(kind=4),     intent(in) :: xr1,yr1  !
  real(kind=4),     intent(in) :: xr2,yr2  !
  ! Local
  real(kind=4) :: dx,dy
  integer(kind=4) :: iw,x1,x2,y1,y2,start
  !
  if ((xr2-xr1).gt.(yr2-yr1)) then
    ! Line is rather horizontal
    dx = 0.
    dy = 1.
  else
    ! Line is rather vertical
    dx = 1.
    dy = 0.
  endif
  !
  if (out%png%width.eq.1) then
    start = 0
  else
    start = -out%png%width/2
  endif
  do iw=start,start+out%png%width-1
    !
    x1 = nint(xr1+iw*dx)
    y1 = nint(yr1+iw*dy)
    x2 = nint(xr2+iw*dx)
    y2 = nint(yr2+iw*dy)
    !
    ! ---------------------
    !  BOUNDARY conditions
    !
    ! The way the scale is defined (see details in subroutine get_scale_awd) for
    ! cropped PNG, there must be one (poly)line summit which starts exactly at the
    ! left of the device, i.e. left of first pixel, i.e. coordinate 0.5. Same for
    ! right limit. Because of nint() rounding, this means that these coordinates
    ! may overflow beyond the device range. No better way than bringing them back
    ! into the range. Again, this is for the boundary conditions where we want:
    !  Left  boundary =   0.5 -> pixel 1
    !  Right boundary = N+0.5 -> pixel N
    ! nint() does not satisfy this rule... Apart from this boundary problem, nint()
    ! is correct. If a line summit is exactly at position i+0.5, we can ambiguously
    ! make it start in pixel i or i+1. We let nint() decide arbitrarily.
    if (x1.lt.out%px1)  x1 = out%px1
    if (x1.gt.out%px2)  x1 = out%px2
    if (x2.lt.out%px1)  x2 = out%px1
    if (x2.gt.out%px2)  x2 = out%px2
    if (y1.lt.out%py1)  y1 = out%py1
    if (y1.gt.out%py2)  y1 = out%py2
    if (y2.lt.out%py1)  y2 = out%py1
    if (y2.gt.out%py2)  y2 = out%py2
    ! ---------------------
    !
    call png_line(out,x1,y1,x2,y2)
    !
  enddo
  !
end subroutine png_wline
!
subroutine png_line(out,x1,y1,x2,y2)
  use gtv_interfaces, except_this=>png_line
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a 1 pixel-wide line from (x1,y1) to (x2,y2), using Bresenham
  ! algorithm. See e.g.
  !  http://tech-algorithm.com/articles/drawing-line-using-bresenham-algorithm/
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out    ! Input gt_display
  integer(kind=4),  intent(in) :: x1,y1  !
  integer(kind=4),  intent(in) :: x2,y2  !
  ! Local
  integer(kind=4) :: x,y,dx1,dy1,dx2,dy2
  integer(kind=4) :: w,h,longest,shortest,numerator,i
  !
  dx1 = 0
  dy1 = 0
  dx2 = 0
  dy2 = 0
  !
  w = x2-x1
  h = y2-y1
  !
  if (w.lt.0) then
    dx1 = -1
  elseif (w.gt.0) then
    dx1 = +1
  endif
  if (h.lt.0) then
    dy1 = -1
  elseif (h.gt.0) then
    dy1 = +1
  endif
  if (w.lt.0) then
    dx2 = -1
  elseif (w.gt.0) then
    dx2 = +1
  endif
  !
  longest = abs(w)
  shortest = abs(h)
  if (longest.le.shortest) then
    longest = abs(h)
    shortest = abs(w)
    if (h.lt.0) then
      dy2 = -1
    elseif (h.gt.0) then
      dy2 = +1
    endif
    dx2 = 0
  endif
  !
  numerator = longest/2
  x = x1
  y = y1
  do i=0,longest
    call png_point(out,x,y)
    numerator = numerator+shortest
    if (numerator.ge.longest) then
      numerator = numerator-longest
      x = x+dx1
      y = y+dy1
    else
      x = x+dx2
      y = y+dy2
    endif
  enddo
  !
end subroutine png_line
!
subroutine png_fill(out,n,xr,yr)
  use gtv_interfaces, except_this=>png_fill
  use gtv_types
  use gtv_png
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Fill the input polygon
  !---------------------------------------------------------------------
  ! ZZZ Nettoyer cette routine (noms, etc)
  type(gt_display), intent(inout) :: out    ! Input gt_display
  integer,          intent(in)    :: n      ! Number of summits
  real*4,           intent(in)    :: xr(n)  ! X coordinates, in world units
  real*4,           intent(in)    :: yr(n)  ! Y coordinates, in world units
  ! Local
  integer(kind=4) :: i,iy,lnx,nr(2),j, miny, maxy
  integer(kind=4) :: x(n),y(n),ixl(n),ixu(n)  ! Automatic arrays
  !
  ! Calculation of pixel coordinates
  miny = min(out%py1,out%py2)  ! ZZZ Check this
  maxy = max(out%py1,out%py2)
  do i = 1, n
    call world_to_pixel(out,xr(i),yr(i),x(i),y(i))
    miny = min(miny, y(i))
    maxy = max(maxy, y(i))
  enddo
  !
  nr(1) = n
  do iy = miny,maxy
    ! Calculate all x inside the polygons for row #iy
    call gi4_bltlis(1,1,1,nr,x,y,iy,lnx,ixl,ixu)
    do j = 1, lnx
      call png_line(out,ixl(j),iy,ixu(j),iy)
    enddo
  enddo
  !
end subroutine png_fill
!
subroutine png_points(out,n,xr,yr)
  use gtv_interfaces, except_this=>png_points
  use gtv_types
  use gtv_png
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !   Draw dot-points at input coordinates (world units)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! Input gt_display
  integer(kind=4),  intent(in)    :: n      ! Number of summits
  real(kind=4),     intent(in)    :: xr(n)  ! X coordinates, in world units
  real(kind=4),     intent(in)    :: yr(n)  ! Y coordinates, in world units
  ! Local
  integer(kind=4) :: i
  integer(kind=4) :: xp,yp
  !
  do i=1,n
    call world_to_pixel(out,xr(i),yr(i),xp,yp)
    call png_point(out,xp,yp)
  enddo
  !
end subroutine png_points
!
subroutine gti_pngimage(out,image)
  use gtv_interfaces, except_this=>gti_pngimage
  use gildas_def
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_types
  use gtv_tree
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Load the image to be drawn in the PNG device
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out    ! Input gt_display
  type(gt_image),   intent(in)    :: image  ! Image instance
  ! Local
  character(len=*), parameter :: rname='PNGIMAGE'
  real(kind=4) :: clip(4),trans(4)
  integer(kind=4) :: window(4),ier
  type(gt_lut), pointer :: lut
  type(gt_bitmap) :: bitmap
  logical :: visible
  character(len=message_length) :: mess
  !
  ! Check the clipping box
  call clip_image(out,  &
    image%r%taille(1),  &
    image%r%taille(2),  &
    image%conv,         &
    image%position,     &
    image%limits,       &
    .true.,             &  ! Always resample to device pixels
    1.0,                &  ! Resampling factor (1 = no extra factor)
    visible,clip,window,trans)
  if (.not.visible)  return
  !
  ! Some debuging feedback
  write(mess,'(5(A,I0))')  'Image size is ',window(1),'x',window(2),  &
    ', corner at position (',window(3),',',window(4),') in the PNG'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Ximag(Xpng) = ',trans(2),' + ',trans(1),'*Xpng'
  call gtv_message(seve%d,rname,mess)
  write(mess,'(A,F0.7,A,F0.7,A)')  'Yimag(Xpng) = ',trans(4),' + ',trans(3),'*Ypng'
  call gtv_message(seve%d,rname,mess)
  !
  if (.not.image%isrgb) then
    ! Image is indexed: which LUT use?
    if (associated(image%lut)) then
      lut => image%lut  ! Custom LUT
      call gti_lut(out,lut)  ! Load this LUT, in case it is not yet
    else
      lut => gbl_colormap  ! Global LUT
    endif
  endif
  !
  ! Allocate the new resampled image
  bitmap%size(1) = window(1)
  bitmap%size(2) = window(2)
  bitmap%position(1) = window(3)
  bitmap%position(2) = window(4)
  bitmap%trans = trans
  if (image%isrgb) then
    allocate(bitmap%irvalues(window(1),window(2)),  &
             bitmap%igvalues(window(1),window(2)),  &
             bitmap%ibvalues(window(1),window(2)),stat=ier)
  else
    allocate(bitmap%irvalues(window(1),window(2)),stat=ier)
    bitmap%igvalues => null()
    bitmap%ibvalues => null()
  endif
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Memory allocation failure')
    return
  endif
  !
  ! Get it from memory...
  call gti_pngmap(image,out,bitmap,lut)
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
end subroutine gti_pngimage
!
subroutine gti_pngmap(image,output,bitmap,lut)
  use gtv_interfaces, except_this=>gti_pngmap
  use gildas_def
  use gtv_png
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device.
  !---------------------------------------------------------------------
  type(gt_image),   intent(in)    :: image   ! The image to be displayed
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(inout) :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
  ! Local
  integer :: ncol,offset
  !
  ! Use colour MAP_SIZE for blanking, so there are MAP_SIZE-1 colour
  ! available, from 1 to MAP_SIZE-1...
  ncol = output%dev%map_size-1
  offset = output%dev%map_offset
  !
  call compute_bitmap(image,bitmap,ncol,offset)
  !
  if (output%color) then
    if (image%isrgb) then
      call png_image_rgb_color(output,bitmap)
    else
      call png_image_ind_color(output,bitmap,lut)
    endif
  else
    if (image%isrgb) then
      call png_image_rgb_grey(output,bitmap)
    else
      call png_image_ind_grey(output,bitmap,lut)
    endif
  endif
  !
end subroutine gti_pngmap
!
subroutine png_image_rgb_color(output,bitmap)
  use gtv_interfaces, except_this=>png_image_rgb_color
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The input RGB
  ! intensities are rescaled from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
#if defined(PNG)
  ! Local
  integer :: i,j,x0,y0,x,y
  integer(kind=4) :: i4
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      x = x0+i-1
      y = y0+j-1
      !
      i4 = nint(real(bitmap%irvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%r(x,y) = si4_to_ui1(i4)
      !
      i4 = nint(real(bitmap%igvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%g(x,y) = si4_to_ui1(i4)
      !
      i4 = nint(real(bitmap%ibvalues(i,j)-pngmap_offset+1,kind=4)/pngmap_size*255.)
      output%png%b(x,y) = si4_to_ui1(i4)
      !
      if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
    enddo
  enddo
  !
#endif
end subroutine png_image_rgb_color
!
subroutine png_image_rgb_grey(output,bitmap)
  use gtv_interfaces, except_this=>png_image_rgb_grey
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The input RGB
  ! intensities are rescaled from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
#if defined(PNG)
  ! Local
  integer :: i,j,x0,y0,x,y
  integer(kind=4) :: i4
  real(kind=4) :: lumi
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      x = x0+i-1
      y = y0+j-1
      !
      lumi = rgb_to_grey((bitmap%irvalues(i,j)-pngmap_offset+1)*255./pngmap_size,  &
                         (bitmap%igvalues(i,j)-pngmap_offset+1)*255./pngmap_size,  &
                         (bitmap%ibvalues(i,j)-pngmap_offset+1)*255./pngmap_size)
      i4 = nint(lumi)
      output%png%r(x,y) = si4_to_ui1(i4)
      !
      if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
    enddo
  enddo
  !
#endif
end subroutine png_image_rgb_grey
!
subroutine png_image_ind_color(output,bitmap,lut)
  use gtv_interfaces, except_this=>png_image_ind_color
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in color scale. The single-scale
  ! intensities are split in 3 RGB intensities from 0 to 255.
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
#if defined(PNG)
  ! Local
  integer(kind=1) :: br(lut%size)
  integer(kind=1) :: bg(lut%size)
  integer(kind=1) :: bb(lut%size)
  integer :: intensity,i,j,x0,y0,x,y
  integer*4 :: i4
  !
  ! Prepare Byte values for R, G and B
  do intensity=1,lut%size
    i4 = nint(lut%r(intensity)*255.)
    br(intensity) = si4_to_ui1(i4)
    i4 = nint(lut%g(intensity)*255.)
    bg(intensity) = si4_to_ui1(i4)
    i4 = nint(lut%b(intensity)*255.)
    bb(intensity) = si4_to_ui1(i4)
  enddo
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      intensity = bitmap%irvalues(i,j)  &
                  - pngmap_offset + 1 ! +1 because the values were
                                      ! shifted by 1 for C indices
      x = x0+i-1
      y = y0+j-1
      !
      if (intensity.eq.lut%size .and. output%png%noblank) then
        ! Last level was used in compute_bitmap for blanking. If
        ! NOBLANK mode, do nothing! We will see the preset background or,
        ! even better, other plots already drawn!
        continue
        !
      else
        output%png%r(x,y) = br(intensity)
        output%png%g(x,y) = bg(intensity)
        output%png%b(x,y) = bb(intensity)
        if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
      endif
    enddo
  enddo
  !
#endif
end subroutine png_image_ind_color
!
subroutine png_image_ind_grey(output,bitmap,lut)
  use gtv_interfaces, except_this=>png_image_ind_grey
  use gtv_plot
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Draw the image in the PNG device, in grey scale
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! gt_display instance
  type(gt_bitmap),  intent(in)    :: bitmap  !
  type(gt_lut),     intent(in)    :: lut     ! Colormap to use
#if defined(PNG)
  ! Local
  integer(kind=1) :: bg(lut%size)
  integer :: intensity,i,j,x0,y0,x,y
  integer*4 :: i4
  !
  ! Prepare Byte values for Grey colorscale
  do intensity=1,lut%size
    i4 = nint(rgb_to_grey(lut%r(intensity),lut%g(intensity),lut%b(intensity))*255.)
    bg(intensity) = si4_to_ui1(i4)
  enddo
  !
  x0 = bitmap%position(1)
  y0 = bitmap%position(2)
  do j=1,bitmap%size(2)
    do i=1,bitmap%size(1)
      intensity = bitmap%irvalues(i,j)  &
                  - pngmap_offset + 1 ! +1 because the values were
                                      ! shifted by 1 for C indices
      x = x0+i-1
      y = y0+j-1
      !
      if (intensity.eq.lut%size .and. output%png%noblank) then
        ! Last level was used in compute_bitmap for blanking. If
        ! NOBLANK mode, do nothing! We will see the preset background or,
        ! even better, other plots already drawn!
        continue
        !
      else
        output%png%r(x,y) = bg(intensity)
        if (output%png%transparency)  output%png%a(x,y) = i255  ! i.e. not transparent
      endif
    enddo
  enddo
  !
#endif
end subroutine png_image_ind_grey
!
subroutine png_image_inquire(map_size,map_offset,map_color,map_static)
  use gtv_interfaces, except_this=>png_image_inquire
  use gtv_png
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ Not sure all these really have to be returned...
  !---------------------------------------------------------------------
  integer, intent(out) :: map_size    ! Desired scale dynamics
  integer, intent(out) :: map_offset  !
  logical, intent(out) :: map_color   ! Is a color or grey map?
  logical, intent(out) :: map_static  !
  !
  map_size = pngmap_size
  map_offset = pngmap_offset
  map_color = .true.   ! What about a Grey PNG?
  map_static = .true.  ! PNG filler is able to render one LUT per image
                       ! of the plot (if LUT STATIC mode)
  !
end subroutine png_image_inquire
!
subroutine png_point(out,x,y)
  use gtv_interfaces, except_this=>png_point
  use gtv_png
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Draw the pixel at input coordinates (pixel units)
  !---------------------------------------------------------------------
  type(gt_display)             :: out  ! Output instance
  integer(kind=4),  intent(in) :: x,y  ! Pixel coordinates, in pixel units
  !
  if (out%png%negative) then
    ! Only revert the color at pixel position
    out%png%R(x,y) = ieor(out%png%R(x,y),i255)  ! Exclusive OR: revert all the bits
    if (out%png%nchan.ge.3) then
      out%png%G(x,y) = ieor(out%png%G(x,y),i255)
      out%png%B(x,y) = ieor(out%png%B(x,y),i255)
    endif
    if (out%png%transparency)  out%png%A(x,y) = i255  ! i.e. not transparent
  else
    out%png%R(x,y) = out%png%rpen
    if (out%png%nchan.ge.3) then
      out%png%G(x,y) = out%png%gpen
      out%png%B(x,y) = out%png%bpen
    endif
    if (out%png%transparency)  out%png%A(x,y) = i255  ! i.e. not transparent
  endif
  !
end subroutine png_point
!
subroutine base64_encode(c,nc,olun)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch
  !  Encode a (binary) buffer as a base-64 string
  !
  !  Example:
  !
  ! Text content   |      M        |      a        |        n      |
  ! ASCII          |   77 (0x4d)   |   97 (0x61)   |    110 (0x6e) |
  ! Bit pattern    |0 1 0 0 1 1 0 1|0 1 1 0 0 0 0 1|0 1 1 0 1 1 1 0|
  ! Index          |     19    |    22     |     5     |     46    |
  ! Base64-encoded |     T     |    W      |     F     |     u     |
  !
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nc     ! Number of Bytes
  integer(kind=1), intent(in) :: c(nc)  ! Input buffer
  integer(kind=4), intent(in) :: olun   ! Output logical unit
  ! Local
  integer(kind=4) :: ib,ic
  integer(kind=1) :: j(4)
  integer(kind=1), parameter :: zero=0
  character(len=76) :: buf
  ! Equivalence
  integer(kind=4) :: b32  ! We need only 24 bits but we can not have an integer(kind=3)
  integer(kind=1) :: b8(4)
  equivalence (b32,b8)
  ! Table
  character(len=1), parameter :: b64table(0:63) = (/    &
  "A","B","C","D","E","F","G","H","I","J","K","L","M",  &
  "N","O","P","Q","R","S","T","U","V","W","X","Y","Z",  &
  "a","b","c","d","e","f","g","h","i","j","k","l","m",  &
  "n","o","p","q","r","s","t","u","v","w","x","y","z",  &
  "0","1","2","3","4","5","6","7","8","9","+","/"       /)
  !
  ib = 0
  ic = 1
  b8(4) = zero  ! Never used, put zeroes for safety
  do
    b8(1) = c(ic+2)
    b8(2) = c(ic+1)
    b8(3) = c(ic)
    !
    j(4) = ibits(b32, 0,6)
    j(3) = ibits(b32, 6,6)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    !
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = b64table(j(3))
    buf(ib+4:ib+4) = b64table(j(4))
    !
    ib = ib+4
    if (ib.ge.len(buf)) then
      write(olun,'(A)') buf
      ib = 0
    endif
    !
    ic = ic+3
    if (ic.gt.nc-2)  exit
  enddo
  !
  ! Last 1 or 2 bytes, need specific padding
  if (ic.eq.nc-1) then
    b8(1) = zero
    b8(2) = c(ic+1)
    b8(3) = c(ic)
    j(3) = ibits(b32, 6,6)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = b64table(j(3))
    buf(ib+4:ib+4) = '='
    ib = ib+4
  elseif (ic.eq.nc) then
    b8(1) = zero
    b8(2) = zero
    b8(3) = c(ic)
    j(2) = ibits(b32,12,6)
    j(1) = ibits(b32,18,6)
    buf(ib+1:ib+1) = b64table(j(1))
    buf(ib+2:ib+2) = b64table(j(2))
    buf(ib+3:ib+3) = '='
    buf(ib+4:ib+4) = '='
    ib = ib+4
  endif
  !
  if (ib.gt.0)  write(olun,'(A)') buf(1:ib)
  !
end subroutine base64_encode

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_standard_opt
  use cubesyntax_messaging
  use cubetools_primitive_opt
  use cubetools_structure_main
  !
  public :: option_t
  public :: opti_k
  public :: cubetools_register_option,cubetools_option_ptr
  public :: cubetools_option_check_execute,cubetools_option_print_abstract
  private
  !
  type, extends(primitive_opt_t) :: option_t  ! standard_option_t
     ! No element to add
  contains
     ! procedure :: register => cubetools_register_option
  end type option_t
  !
contains
  !
  subroutine cubetools_register_option(name,syntax,abstract,help,popt,error)
    !----------------------------------------------------------------------
    ! Register an option of exact type option_t in the global 'pack'
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    character(len=*), intent(in)    :: syntax
    character(len=*), intent(in)    :: abstract
    character(len=*), intent(in)    :: help
    type(option_t),   pointer       :: popt  ! Return pointer to registered option
    logical,          intent(inout) :: error
    !
    type(option_t) :: template
    class(primitive_opt_t), pointer :: actualopt
    !
    call cubetools_register_primitive_opt(template,name,syntax,abstract,help,actualopt,error)
    if (error)  return
    popt => cubetools_option_ptr(actualopt,error)
    if (error)  return
    popt%check          => cubetools_option_check_execute
    popt%build_syntax   => cubetools_option_build_syntax
    popt%print_abstract => cubetools_option_print_abstract
  end subroutine cubetools_register_option
  !
  function cubetools_option_ptr(pot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(option_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(option_t), pointer :: cubetools_option_ptr  ! Function value on return
    class(primitive_opt_t), pointer       :: pot
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PTR'
    !
    select type(pot)
    type is (option_t)
      cubetools_option_ptr => pot
    class default
      cubetools_option_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a option_t type')
      error = .true.
      return
    end select
  end function cubetools_option_ptr
  !
  subroutine cubetools_option_check_execute(opt,command,line,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! When a command is executed, check if the option is present. If yes,
    ! check if the number of arguments are within the expected range
    ! EXCEPT if the first argument is ?, which shows the help.
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: command  ! Command name (for proper feedback)
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    integer(kind=narg_k) :: narg
    character(len=mess_l) :: mess
    character(len=128) :: prefix
    logical :: present
    character(len=*), parameter :: rname='OPTION>CHECK>EXECUTE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Check if present and trap ? as first argument to the option:
    call opt%present(line,present,error)
    if (error) return
    if (.not.present)  return
    !
    narg = opt%getnarg()
    !
    if (opt%inum.eq.0) then
      prefix = 'Command '//opt%name
    else
      prefix = 'Key /'//opt%name
    endif
    !
    if (narg.lt.opt%nargmin) then
      write(mess,'(a,3(a,i0))')  trim(prefix),  &
        ' takes at least ',opt%nargmin,' argument(s) (',narg,' given)'
      call cubesyntax_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    if (narg.gt.opt%nargmax) then
      if (opt%nargmax.eq.0) then
        write(mess,'(a,2(a,i0))')  trim(prefix),  &
          ' takes no argument (',narg,' given)'
      else
        write(mess,'(a,3(a,i0))')  trim(prefix),  &
          ' takes at most ',opt%nargmax,' argument(s) (',narg,' given)'
      endif
      call cubesyntax_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  end subroutine cubetools_option_check_execute
  !
  subroutine cubetools_option_build_syntax(opt,syntax,lprint,lnoprint,error)
    use cubetools_format
    !-------------------------------------------------------------------
    !  Build the string
    !    /OPTNAME Arg1 ... ArgN
    !  according to opt%name and opt%syntax
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(out)   :: syntax
    integer(kind=4),        intent(out)   :: lprint    ! Number of printable characters
    integer(kind=4),        intent(out)   :: lnoprint  ! Number of non-printable characters
    logical,                intent(inout) :: error
    !
    syntax = trim(cubetools_format_bold('/'//opt%name,lprint,lnoprint))// &
             ' '// &
             opt%syntax
    lprint = lprint + 1 + len_trim(opt%syntax)
  end subroutine cubetools_option_build_syntax
  !
  subroutine cubetools_option_print_abstract(opt,error)
    use cubetools_format
    use cubetools_terminal_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='OPTION>PRINT>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  /'//cubetools_format_stdkey_boldval(opt%name,opt%abstract,terminal%width()-1)
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_option_print_abstract
end module cubetools_standard_opt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_accumulate(set,line,r,t,error)
  use classcore_interfaces, except_this=>class_accumulate
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command ACCUMULATE
  !   Adds the R and T spectra together
  !   Reset the plotting constants
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r,t    ! The observations to be added
  logical,             intent(inout) :: error  ! Logical error flag
  !
  call accumulate_generic(set,line,r,t,error)
  !
end subroutine class_accumulate
!
subroutine accumulate_generic(set,line,r,t,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>accumulate_generic
  use class_averaging
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !    AVERAGE all scans of current index together with
  !    various weights and options. Update the origin information and
  !    reset the plotting constants
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r,t    ! The observations to be added
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ACCUMULATE'
  integer(kind=4), parameter :: optresample=1
  integer(kind=4), parameter :: optnocheck=2
  integer(kind=4), parameter :: optweight=3
  type(observation) :: sumio
  type(consistency_t) :: cons
  type(average_t) :: aver
  integer(kind=4) :: nc
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  if (t%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No T spectrum in memory')
    error = .true.
    return
  endif
  !
  call init_obs(sumio)
  !
  ! Prepare the addition
  if (sic_present(optresample,0)) then
    if (sic_present(optresample,1)) then
      ! /RESAMPLE Nchan Xref Xval Xinc Unit
      aver%do%resampling = resample_user
      ! aver%do%alignment = unused
      call resample_parse_command(line,optresample,rname,r%head,aver%do%axis,error)
      if (error)  return
    else
      ! /RESAMPLE
      aver%do%resampling = resample_auto
    endif
  else
    ! No /RESAMPLE option
    aver%do%resampling = resample_no
  endif
  !
  aver%do%rname       = rname
  aver%do%kind        = r%head%gen%kind
  aver%do%alignment   = align_auto
  aver%do%weight      = set%weigh
  if (sic_present(optweight,0)) then
    call sic_ke(line,optweight,1,aver%do%weight,nc,.true.,error)
    if (error)  return
  endif
  aver%do%composition = composite_user
  aver%do%range       = .false.  ! No option /RANGE
  aver%do%modfreq     = .false.
  aver%do%restf       = 0.d0  ! Not used
  aver%do%modvelo     = .false.
  aver%do%voff        = 0.d0  ! Not used
  !
  ! Select what will be checked according to user input
  call consistency_defaults(set,cons)
  call consistency_check_selection(set,line,optnocheck,cons,error)
  if (error) return
  ! Consistency of the spectroscopic axes is enabled by default (but the user
  ! can deactivate it, to his own risk). Note that this check is useful if
  ! /RESAMPLE is present (resampling automatically disabled if useless) or
  ! not (request for enabling resampling in case of inconsistency).
  ! No need for inconsistency messages if /RESAMPLE is enabled: user
  ! already knows the axes can be inconsistent!
  cons%spe%mess = aver%do%resampling.eq.resample_no
  ! Set checking tolerances
  call consistency_tole(r%head,cons)
  ! Give user feedback on what will be done
  call consistency_print(set,r%head,cons)
  !
  ! -------------- Duplicate of SUMLIN_HEADER, for R & T --------------
  ! 1) Parse the input parameters
  call sumlin_init(set,cons,aver,error)
  if (error)  goto 10
  !
  ! 2) Prepare the sum header
  call sumlin_header_init(aver,r%head,sumio,error)
  if (error)  goto 10
  !
  ! 3) Prepare internal variables for the addition
  call sumlin_init_variables(aver,r%head,sumio%head,error)
  if (error)  goto 10
  !
  ! 4) Loop on the observations to store their axis parameters. Include
  !    also some checks.
  call sumlin_header_register(r,sumio,aver,error)
  if (error)  goto 10
  ! Check consistency of T against R
  call observation_consistency_check(set,r%head,t%head,cons)
  if (aver%done%kind_is_spec) then
    if ((cons%gen%check.and.cons%gen%prob) .or.  &
        (cons%sou%check.and.cons%sou%prob) .or.  &
        (cons%pos%check.and.cons%pos%prob) .or.  &
        (cons%off%check.and.cons%off%prob) .or.  &
        (cons%lin%check.and.cons%lin%prob) .or.  &
        (cons%cal%check.and.cons%cal%prob)) then
      error = .true.
    endif
    if (cons%spe%check.and.cons%spe%prob) then
      if (aver%do%resampling.eq.resample_no) then
        call class_message(seve%e,aver%do%rname,'Inconsistent spectroscopic '//  &
          'axes, use option /RESAMPLE to enforce resampling')
        error = .true.
      elseif (aver%do%resampling.eq.resample_auto) then
        aver%done%resample = .true.
      endif
    endif
  else
    if ((cons%gen%check.and.cons%gen%prob) .or.  &
        (cons%sou%check.and.cons%sou%prob) .or.  &
        (cons%pos%check.and.cons%pos%prob) .or.  &
        (cons%off%check.and.cons%off%prob)) then
      error = .true.
    endif
    if (cons%dri%check.and.cons%dri%prob) then
      if (aver%do%resampling.eq.resample_no) then
        call class_message(seve%e,aver%do%rname,'Inconsistent drift '//  &
          'axes, use option /RESAMPLE to enforce resampling')
        error = .true.
      elseif (aver%do%resampling.eq.resample_auto) then
        aver%done%resample = .true.
      endif
    endif
  endif
  if (error) then
    call class_message(seve%e,aver%do%rname,'R and T are inconsistent')
    goto 10
  endif
  call sumlin_header_register(t,sumio,aver,error)
  if (error)  goto 10
  !
  ! 5) Set the sum header and X axis description
  call sumlin_header_xaxis(set,aver,sumio,2_8,error)  ! Possibly modify nchan
  if (error)  goto 10
  ! --------------- End of duplicate of SUMLIN_HEADER ---------------
  !
  ! 6) Prepare the sum data
  call sumlin_data_prepro(aver,sumio,r%assoc,error)
  if (error)  goto 10
  !
  ! if (aver%do%modfreq) ...
  ! if (aver%do%modvelo) ...
  !
  ! 7) Loop on the observations to average them
  call sumlin_wadd_new(set,r,aver,sumio,error)
  if (error)  goto 10
  call sumlin_wadd_new(set,t,aver,sumio,error)
  if (error)  goto 10
  !
  ! Special for EQUAL weight: return sum instead of average
  if (set%weigh.eq.'E')  then
    call class_message(seve%w,rname,'Gives sum of spectra for EQUAL weight')
    sumio%data1 = sumio%data1*sumio%dataw
  endif
  !
  call sumlin_data_postpro_waverage(aver,sumio,error)
  if (error)  continue
  sumio%spectre => sumio%data1
  !
  call abscissa(set,sumio,error)
  if (error)  goto 10
  !
  ! Convert temporary R*4 Associated Arrays into correct format
  call copy_assoc_r4toaa(aver%comm%rname,r%assoc,sumio%assoc,error)
  if (error)  continue
  !
  ! Push the stack and copy SUM to R
  call copy_obs(r,t,error)
  if (error)  goto 10
  call copy_obs(sumio,r,error)
  if (error)  goto 10
  !
  call newdat(set,r,error)
  call newdat_assoc(set,r,error)
  call newdat_user(set,r,error)
  !
10 continue
  !
  ! Free memory
  call free_obs(sumio)
  !
end subroutine accumulate_generic

!
!     Id: pako-load.f90,v 1.2.3 2014-12-01 Hans Ungerechts
!     Id: pako-load.f90,v 1.2.3 2014-02-17 Hans Ungerechts
!     Id: pako-load.f90,v 1.2.3 2014-02-03 Hans Ungerechts
!
!         previous (inconsistent v number)
!         pako-load.f90,v 1.2.4 2013-04-19 Hans Ungerechts
!
Subroutine pako_load
  !
  Use gbl_message
  Use gkernel_interfaces
  Use modulePakoGlobalParameters    !  to get pakoVersion string
  Use modulePakoMessages            !
  !
  !---------------------------------------------------------------------
  ! Define and load languages of the package.
  !---------------------------------------------------------------------
  ! Global
  External :: pako_run
  Logical, External :: pako_error
  !
  ! Local
  ! Define commands of a new language
  !
!!$  from template:
!!$  integer, parameter :: mcom=4
!!$  character(len=12) :: vocab(mcom)
!!$  data vocab /                      &
!!$    ' DUMMY', '/OPT1', '/OPT2',     &  ! A command with 2 options
!!$    ' VOID' /                          ! A standalone command
  !
  Include 'inc/commands/pakoVocab.inc'
  !
  Character*80 messageText, shellCommand
  Integer system
  Integer ier2, ipid, iou
  Character*8   Date
  Character*10  Time
  Character*5   Zone
  Integer       Values(8)
  !
  Logical ERROR
  !
  Character*12 programName
  programName = "pako"                      !! TBD program/language name for messages and scripts
  !
  Call pako_message(seve%t,programName,                                          &
       &    " pako_load.f90 ---> SR: pako_load: ")                               ! trace execution
!!$  Call pako_message(seve%t,programName,                                          &
!!$       &    " SR pako_load, pakoVersion: "//pakoVersion )                        ! trace execution
  !
  !D   Write (6,*) " --> pako_load "
  !
  ! Load the new language:
  Call sic_begin(                                                                &
    'PAKO',                                                                      &  ! Language name
    'GAG_HELP_PAKO',                                                             &  !
    mcom,                                                                        &  ! Number of commands + options in language
    vocab,                                                                       &  ! Array of commands
    pakoVersion,                                                                 &  ! Some version string
    pako_run,                                                                    &  ! The routine which handles incoming commands
    pako_error)                                                                  !  ! The error status routine of the library
  !
!!$  from template:
!!$  call sic_begin(           &
!!$    'PAKO',             &  ! Language name
!!$    'GAG_HELP_PAKO',   &  !
!!$    mcom,                   &  ! Number of commands + options in language
!!$    vocab,                  &  ! Array of commands
!!$    '1.0    27-Oct-2008 ',  &  ! Some version string
!!$    pako_run,          &  ! The routine which handles incoming commands
!!$    pako_error)           ! The error status routine of the library
  !
  !  
  !! Check if pakoLock file exists; if yes: STOP
  if (gag_inquire(".pakoLock",9).eq.0) then
     messageText = "THIS WORKING DIRECTORY APPEARS"                              &
          &             //" TO BE LOCKED BY ANOTHER PAKO:"                       !
     Call pakoMessage(8,4,"pako",messageText)
     shellCommand = "cat .pakoLock"
     ier2 = system(shellCommand)
     messageText = "EXIT THE OTHER PAKO"                                         &
          &               //" OR USE ANOTHER WORKING DIRECTORY"                  !
     Call pakoMessage(8,4,"pako",messageText)
     messageText = 'if you are sure there is no other pako'                      &
          &              //' try: "rm .pakoLock" and again "pako"'               !
     Call pakoMessage(8,4,"pako",messageText)
     Error = .True.
     STOP
  End If
  !
  ! Create lock file
  ipid = gag_getpid()
  Call Date_And_Time(date,time,zone,values)
  iou = 31                                                                       !  !!  TBD: cleanup, use global value
!!$      iou = ioUnit%Lock
  Open (unit=iou,file=".pakoLock")
  Write (iou,'(A,A,I4.4,A,I2.2,A,I2.2,A,I2.2,A,I2.2,A,I2.2,A5,A,I0)')            &
       &            "         PAKO LOCK. ",                                      &
       &                      " DateTime:",                                      &
       &                Values(1), "-", Values(2), "-",Values(3),                &
       &                      "T",                                               &
       &                Values(5), ":", Values(6), ":",Values(7),Zone,           &
       &                      " PID: ",                                          &
       &                      ipid                                               !
  Close (unit=iou)
  shellCommand = "chmod 400 .pakoLock"
  ier2 = system(shellCommand)
  !
End Subroutine pako_load
!<FF>
Subroutine pako_run(line,comm,error)
  !---------------------------------------------------------------------
  ! Support routine for the language PAKO.
  ! This routine is able to call the routines associated to each
  ! command of the language PAKO
  !---------------------------------------------------------------------
  !
  Use modulePakoGlobalVariables
  Use modulePakoDisplayText
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoCatalog
  Use modulePakoSource
  Use modulePakoCalibrate
  Use modulePakoDIYlist
  Use modulePakoFocus
  Use modulePakoOnOff
  Use modulePakoLissajous
  Use modulePakoOtfMap
  Use modulePakoPointing
  Use modulePakoTip
  Use modulePakoTrack
  Use modulePakoVlbi
  Use modulePakoDisplay
  Use modulePakoStart
  Use modulePakoStop
  Use modulePakoSave
  !
!!   from run*.f < 2011:
!!$ !!$OLD      Use modulePakoMessages
!!$ !!$OLD      Use modulePakoGlobalParameters
!!$ !!$OLD      Use modulePakoGlobalVariables
!!$ !!$OLD      Use modulePakoDisplayText
!!$ !!$OLD      Use modulePakoReceiver
!!$ !!$OLD      Use modulePakoBackend
!!$ !!$OLD      Use modulePakoSwBeam
!!$ !!$OLD      Use modulePakoSwFrequency
!!$ !!$OLD      Use modulePakoSwWobbler
!!$ !!$OLD      Use modulePakoSwTotalPower
!!$ !!$OLD      Use modulePakoCatalog
!!$ !!$OLD      Use modulePakoSource
!!$ !!$OLD      Use modulePakoCalibrate
!!$ !!$OLD      Use modulePakoDIYlist
!!$ !!$OLD      Use modulePakoFocus
!!$ !!$OLD      Use modulePakoOnOff
!!$ !!$OLD      Use modulePakoOtfMap
!!$ !!$OLD      Use modulePakoPointing
!!$ !!$OLD      Use modulePakoTip
!!$ !!$OLD      Use modulePakoTrack
!!$ !!$OLD      Use modulePakoVlbi
!!$ !!$OLD      Use modulePakoDisplay
!!$ !!$OLD      Use modulePakoStart
!!$ !!$OLD      Use modulePakoStop
!!$ !!$OLD      Use modulePakoSave
  !
  Use gbl_message
  !
  Character(len=*),  Intent(in)    :: line   ! Command line to send to support routines
  Character(len=12), Intent(in)    :: comm   ! Command resolved by the SIC interpreter
  Logical,           Intent(inout) :: error  ! Logical error flag
  !
  Integer iUnit, ioerr
  !
  Character*128 messageText
  !
  Character*12  programName
  programName = "pako"                      !! TBD program/language name for messages and scripts
  !
!!$  Call pako_message(seve%c,'PAKO',line)
  !
  Call pako_message(seve%t,programName,                                          &
       &    " pako-load.f90, ---> SR: pako_run: ")                               ! trace execution
  Call pako_message(seve%t,programName,                                          &
       &    " SR pako-run, line: "//line )                                       ! trace execution
  !
  Include 'inc/display/displayCommandLine.inc'
  !
  ! Call appropriate subroutine according to COMM
  !
  Select Case(comm)
     !
!!$  from template:
!!$  Case('DUMMY')
!!$    Call pako_dummy(line,error)
!!$  Case('VOID')
!!$    Call pako_void(line,error)
     !
  Case ('BACKEND')        
     Call backend             (programName,LINE,COMM,ERROR)
  Case ('CALIBRATE')  
     Call CALIBRATE           (programName,LINE,COMM, ERROR)
  Case('CATALOG')  
     Call CATALOG             (LINE,ERROR)   !! TBD 1.2 review parameters
  Case ('DISPLAY')  
     Call pakoDisplay         (programName,LINE,COMM, ERROR)
  Case ('DIYLIST')  
     Call DIYlist             (programName,LINE,COMM, ERROR)
  Case('FOCUS')  
     Call FOCUS               (programName,LINE,COMM, ERROR)
  Case('OFFSETS') 
     Call OFFSETS             (programName,LINE,COMM,ERROR)
  Case('ONOFF')  
     Call ONOFF               (programName,LINE,COMM,ERROR)
!!$!! TBD future     Case('OTFCIRCLE')  
!!$!! TBD future        Call  OTFCIRCLE(LINE,COMM, ERROR)
!!$!! TBD future     Case('OTFLINEAR')  
!!$!! TBD future         Call OTFLINEAR(LINE,COMM, ERROR)
  Case('LISSAJOUS')     
     Call LISSAJOUS           (programName,LINE,COMM, ERROR)
  Case('OTFMAP')     
     Call OTFMAP              (programName,LINE,COMM, ERROR)
  Case('POINTING') 
     Call POINTING            (programName,LINE,COMM, ERROR)
  Case('RECEIVER')  
     Call receiver            (programName,LINE,COMM,ERROR)
  Case('SAVE') 
     Call pakoSave            (programName,LINE,COMM, ERROR)
!! TBD future  Case('SEGMENT') 
!! TBD future     Call segment(programName,LINE,COMM, ERROR)
  Case('SET') 
     Call pakoSet             (programName,LINE,COMM,ERROR)
  Case('SHOW')
!!$     Call pako_message(seve%t,'PAKO_RUN',' CASE '//comm)
     Call pakoShow            (programName,LINE,COMM,ERROR)
  Case('SOURCE')  
     Call source              (programName,LINE,COMM,ERROR)
  Case('START') 
     Call pakoStart           (programName,LINE,COMM, ERROR)
  Case('STOP') 
     Call pakoStop            (programName,LINE,COMM, ERROR)
  Case('SUBSCAN') 
     Call Subscan             (programName,LINE,COMM, ERROR)
  Case('SWBEAM') 
     Call swBeam              (programName,LINE,COMM,ERROR)
  Case('SWFREQUENCY') 
     Call swFrequency         (programName,LINE,COMM,ERROR)
  Case('SWTOTAL') 
     Call swTotalPower        (programName,LINE,COMM,ERROR)
  Case('SWWOBBLER') 
     Call swWobbler           (programName,LINE,COMM,ERROR)
  Case('TIP') 
     Call TIP                 (programName,LINE,COMM, ERROR)
  Case('TRACK') 
     Call TRACK               (programName,LINE,COMM, ERROR)
  Case('VLBI') 
     Call VLBI                (programName,LINE,COMM, ERROR)
     !
  Case default
    Call pako_message(seve%e,'PAKO_RUN','Unimplemented command '//comm)
    error = .True.
  End Select
  !
End Subroutine pako_run
!<FF>
Function pako_error()
  !---------------------------------------------------------------------
  ! Support routine for the error status of the library. Does nothing
  ! here.
  !---------------------------------------------------------------------
  Logical :: pako_error
  !
  pako_error = .False.
  !
End Function pako_error

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the GTEMPLATE package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtemplate_package
  use gtemplate_messaging
  use gtemplate_language
  !
  public :: gtemplate_pack_init,gtemplate_pack_clean
  private
  !
contains
  !
  subroutine gtemplate_pack_init(gpack_id,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: gpack_id
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    !
    call gtemplate_message_set_id(gpack_id)
    !
    ! Specific variables
    ier = sic_setlog('gag_help_gtemplate','gag_doc:hlp/gtemplate-help-template.hlp')
    if (ier.eq.0) then
      error=.true.
      return
    endif
    !
    ! Load local language
    call gtemplate_load
    !
    ! Specific initializations
  end subroutine gtemplate_pack_init
  !
  subroutine gtemplate_pack_clean(error)
    !----------------------------------------------------------------------
    ! Called at end of session. Might clean here for example global buffers
    ! allocated during the session
    !----------------------------------------------------------------------
    logical :: error
    !
    print *,"Called gtemplate_pack_clean"
  end subroutine gtemplate_pack_clean
end module gtemplate_package
!
subroutine gtemplate_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  use gtemplate_package
  !
  type(gpack_info_t), intent(out) :: pack
  !
  pack%name='template'
  pack%ext='.gtemplate'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /) ! List here dependencies
  pack%init=locwrd(gtemplate_pack_init)
  pack%clean=locwrd(gtemplate_pack_clean)
end subroutine gtemplate_pack_set
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK TEVLC
      SUBROUTINE TEVLC (N, D, E2, IERR)
C***BEGIN PROLOGUE  TEVLC
C***SUBSIDIARY
C***PURPOSE  Subsidiary to CBLKTR
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TEVLC-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine finds the eigenvalues of a symmetric tridiagonal
C     matrix by the rational QL method.
C
C     On Input-
C
C        N is the order of the matrix,
C
C        D contains the diagonal elements of the input matrix,
C
C        E2 contains the subdiagonal elements of the input matrix
C           in its last N-1 positions.  E2(1) is arbitrary.
C
C      On Output-
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1,2,...IERR-1, but may not be
C          the smallest eigenvalues,
C
C        E2 has been destroyed,
C
C        IERR is set to
C          ZERO       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C***SEE ALSO  CBLKTR
C***REFERENCES  C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    CCBLK
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   920528  DESCRIPTION revised and REFERENCES section added.  (WRB)
C***END PROLOGUE  TEVLC
C
      INTEGER         I          ,J          ,L          ,M          ,
     1                N          ,II         ,L1         ,MML        ,
     2                IERR
      REAL            D(*)       ,E2(*)
      REAL            B          ,C          ,F          ,G          ,
     1                H          ,P          ,R          ,S          ,
     2                MACHEP
C
      COMMON /CCBLK/  NPP        ,K          ,MACHEP     ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C***FIRST EXECUTABLE STATEMENT  TEVLC
      IERR = 0
      IF (N .EQ. 1) GO TO 115
C
      DO 101 I=2,N
         E2(I-1) = E2(I)*E2(I)
  101 CONTINUE
C
      F = 0.0
      B = 0.0
      E2(N) = 0.0
C
      DO 112 L=1,N
         J = 0
         H = MACHEP*(ABS(D(L))+SQRT(E2(L)))
         IF (B .GT. H) GO TO 102
         B = H
         C = B*B
C
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
C
  102    DO 103 M=L,N
            IF (E2(M) .LE. C) GO TO 104
C
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
C
  103    CONTINUE
C
  104    IF (M .EQ. L) GO TO 108
  105    IF (J .EQ. 30) GO TO 114
         J = J+1
C
C     ********** FORM SHIFT **********
C
         L1 = L+1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1)-G)/(2.0*S)
         R = SQRT(P*P+1.0)
         D(L) = S/(P+SIGN(R,P))
         H = G-D(L)
C
         DO 106 I=L1,N
            D(I) = D(I)-H
  106    CONTINUE
C
         F = F+H
C
C     ********** RATIONAL QL TRANSFORMATION **********
C
         G = D(M)
         IF (G .EQ. 0.0) G = B
         H = G
         S = 0.0
         MML = M-L
C
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
C
         DO 107 II=1,MML
            I = M-II
            P = G*H
            R = P+E2(I)
            E2(I+1) = S*R
            S = E2(I)/R
            D(I+1) = H+S*(H+D(I))
            G = D(I)-E2(I)/G
            IF (G .EQ. 0.0) G = B
            H = G*P/R
  107    CONTINUE
C
         E2(L) = S*G
         D(L) = H
C
C     ********** GUARD AGAINST UNDERFLOWED H **********
C
         IF (H .EQ. 0.0) GO TO 108
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 108
         E2(L) = H*E2(L)
         IF (E2(L) .NE. 0.0) GO TO 105
  108    P = D(L)+F
C
C     ********** ORDER EIGENVALUES **********
C
         IF (L .EQ. 1) GO TO 110
C
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
C
         DO 109 II=2,L
            I = L+2-II
            IF (P .GE. D(I-1)) GO TO 111
            D(I) = D(I-1)
  109    CONTINUE
C
  110    I = 1
  111    D(I) = P
  112 CONTINUE
C
      IF (ABS(D(N)) .GE. ABS(D(1))) GO TO 115
      NHALF = N/2
      DO 113 I=1,NHALF
         NTOP = N-I
         DHOLD = D(I)
         D(I) = D(NTOP+1)
         D(NTOP+1) = DHOLD
  113 CONTINUE
      GO TO 115
C
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
C
  114 IERR = L
  115 RETURN
C
C     ********** LAST CARD OF TQLRAT **********
C
      END
*DECK TEVLS
      SUBROUTINE TEVLS (N, D, E2, IERR)
C***BEGIN PROLOGUE  TEVLS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BLKTRI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TEVLS-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine finds the eigenvalues of a symmetric tridiagonal
C     matrix by the rational QL method.
C
C     On Input-
C
C        N is the order of the matrix,
C
C        D contains the diagonal elements of the input matrix,
C
C        E2 contains the subdiagonal elements of the input matrix
C           in its last N-1 positions.  E2(1) is arbitrary.
C
C      On Output-
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1,2,...IERR-1, but may not be
C          the smallest eigenvalues,
C
C        E2 has been destroyed,
C
C        IERR is set to
C          ZERO       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C***SEE ALSO  BLKTRI
C***REFERENCES  C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    CBLKT
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   920528  DESCRIPTION revised and REFERENCES section added.  (WRB)
C***END PROLOGUE  TEVLS
C
      INTEGER         I          ,J          ,L          ,M          ,
     1                N          ,II         ,L1         ,MML        ,
     2                IERR
      REAL            D(*)       ,E2(*)
      REAL            B          ,C          ,F          ,G          ,
     1                H          ,P          ,R          ,S          ,
     2                MACHEP
C
      COMMON /CBLKT/  NPP        ,K          ,MACHEP     ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C***FIRST EXECUTABLE STATEMENT  TEVLS
      IERR = 0
      IF (N .EQ. 1) GO TO 115
C
      DO 101 I=2,N
         E2(I-1) = E2(I)*E2(I)
  101 CONTINUE
C
      F = 0.0
      B = 0.0
      E2(N) = 0.0
C
      DO 112 L=1,N
         J = 0
         H = MACHEP*(ABS(D(L))+SQRT(E2(L)))
         IF (B .GT. H) GO TO 102
         B = H
         C = B*B
C
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
C
  102    DO 103 M=L,N
            IF (E2(M) .LE. C) GO TO 104
C
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
C
  103    CONTINUE
C
  104    IF (M .EQ. L) GO TO 108
  105    IF (J .EQ. 30) GO TO 114
         J = J+1
C
C     ********** FORM SHIFT **********
C
         L1 = L+1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1)-G)/(2.0*S)
         R = SQRT(P*P+1.0)
         D(L) = S/(P+SIGN(R,P))
         H = G-D(L)
C
         DO 106 I=L1,N
            D(I) = D(I)-H
  106    CONTINUE
C
         F = F+H
C
C     ********** RATIONAL QL TRANSFORMATION **********
C
         G = D(M)
         IF (G .EQ. 0.0) G = B
         H = G
         S = 0.0
         MML = M-L
C
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
C
         DO 107 II=1,MML
            I = M-II
            P = G*H
            R = P+E2(I)
            E2(I+1) = S*R
            S = E2(I)/R
            D(I+1) = H+S*(H+D(I))
            G = D(I)-E2(I)/G
            IF (G .EQ. 0.0) G = B
            H = G*P/R
  107    CONTINUE
C
         E2(L) = S*G
         D(L) = H
C
C     ********** GUARD AGAINST UNDERFLOWED H **********
C
         IF (H .EQ. 0.0) GO TO 108
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 108
         E2(L) = H*E2(L)
         IF (E2(L) .NE. 0.0) GO TO 105
  108    P = D(L)+F
C
C     ********** ORDER EIGENVALUES **********
C
         IF (L .EQ. 1) GO TO 110
C
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
C
         DO 109 II=2,L
            I = L+2-II
            IF (P .GE. D(I-1)) GO TO 111
            D(I) = D(I-1)
  109    CONTINUE
C
  110    I = 1
  111    D(I) = P
  112 CONTINUE
C
      IF (ABS(D(N)) .GE. ABS(D(1))) GO TO 115
      NHALF = N/2
      DO 113 I=1,NHALF
         NTOP = N-I
         DHOLD = D(I)
         D(I) = D(NTOP+1)
         D(NTOP+1) = DHOLD
  113 CONTINUE
      GO TO 115
C
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
C
  114 IERR = L
  115 RETURN
C
C     ********** LAST CARD OF TQLRAT **********
C
      END
*DECK TINVIT
      SUBROUTINE TINVIT (NM, N, D, E, E2, M, W, IND, Z, IERR, RV1, RV2,
     +   RV3, RV4, RV6)
C***BEGIN PROLOGUE  TINVIT
C***PURPOSE  Compute the eigenvectors of symmetric tridiagonal matrix
C            corresponding to specified eigenvalues, using inverse
C            iteration.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C3
C***TYPE      SINGLE PRECISION (TINVIT-S)
C***KEYWORDS  EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the inverse iteration tech-
C     nique in the ALGOL procedure TRISTURM by Peters and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 418-439(1971).
C
C     This subroutine finds those eigenvectors of a TRIDIAGONAL
C     SYMMETRIC matrix corresponding to specified eigenvalues,
C     using inverse iteration.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E,
C          with zeros corresponding to negligible elements of E.
C          E(I) is considered negligible if it is not larger than
C          the product of the relative machine precision and the sum
C          of the magnitudes of D(I) and D(I-1).  E2(1) must contain
C          0.0e0 if the eigenvalues are in ascending order, or 2.0e0
C          if the eigenvalues are in descending order.  If  BISECT,
C          TRIDIB, or  IMTQLV  has been used to find the eigenvalues,
C          their output E2 array is exactly what is expected here.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C        M is the number of specified eigenvalues for which eigenvectors
C          are to be determined.  M is an INTEGER variable.
C
C        W contains the M eigenvalues in ascending or descending order.
C          W is a one-dimensional REAL array, dimensioned W(M).
C
C        IND contains in its first M positions the submatrix indices
C          associated with the corresponding eigenvalues in W --
C          1 for eigenvalues belonging to the first submatrix from
C          the top, 2 for those belonging to the second submatrix, etc.
C          If  BISECT  or  TRIDIB  has been used to determine the
C          eigenvalues, their output IND array is suitable for input
C          to TINVIT.  IND is a one-dimensional INTEGER array,
C          dimensioned IND(M).
C
C     On Output
C
C       ** All input arrays are unaltered.**
C
C        Z contains the associated set of orthonormal eigenvectors.
C          Any vector which fails to converge is set to zero.
C          Z is a two-dimensional REAL array, dimensioned Z(NM,M).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          -J         if the eigenvector corresponding to the J-th
C                     eigenvalue fails to converge in 5 iterations.
C
C        RV1, RV2 and RV3 are one-dimensional REAL arrays used for
C          temporary storage.  They are used to store the main diagonal
C          and the two adjacent diagonals of the triangular matrix
C          produced in the inverse iteration process.  RV1, RV2 and
C          RV3 are dimensioned RV1(N), RV2(N) and RV3(N).
C
C        RV4 and RV6 are one-dimensional REAL arrays used for temporary
C          storage.  RV4 holds the multipliers of the Gaussian
C          elimination process.  RV6 holds the approximate eigenvectors
C          in this process.  RV4 and RV6 are dimensioned RV4(N) and
C          RV6(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TINVIT
C
      INTEGER I,J,M,N,P,Q,R,S,II,IP,JJ,NM,ITS,TAG,IERR,GROUP
      INTEGER IND(*)
      REAL D(*),E(*),E2(*),W(*),Z(NM,*)
      REAL RV1(*),RV2(*),RV3(*),RV4(*),RV6(*)
      REAL U,V,UK,XU,X0,X1,EPS2,EPS3,EPS4,NORM,ORDER
C
C***FIRST EXECUTABLE STATEMENT  TINVIT
      IERR = 0
      IF (M .EQ. 0) GO TO 1001
      TAG = 0
      ORDER = 1.0E0 - E2(1)
      Q = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX ..........
  100 P = Q + 1
C
      DO 120 Q = P, N
         IF (Q .EQ. N) GO TO 140
         IF (E2(Q+1) .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C     .......... FIND VECTORS BY INVERSE ITERATION ..........
  140 TAG = TAG + 1
      S = 0
C
      DO 920 R = 1, M
         IF (IND(R) .NE. TAG) GO TO 920
         ITS = 1
         X1 = W(R)
         IF (S .NE. 0) GO TO 510
C     .......... CHECK FOR ISOLATED ROOT ..........
         XU = 1.0E0
         IF (P .NE. Q) GO TO 490
         RV6(P) = 1.0E0
         GO TO 870
  490    NORM = ABS(D(P))
         IP = P + 1
C
         DO 500 I = IP, Q
  500    NORM = MAX(NORM, ABS(D(I)) + ABS(E(I)))
C     .......... EPS2 IS THE CRITERION FOR GROUPING,
C                EPS3 REPLACES ZERO PIVOTS AND EQUAL
C                ROOTS ARE MODIFIED BY EPS3,
C                EPS4 IS TAKEN VERY SMALL TO AVOID OVERFLOW ..........
         EPS2 = 1.0E-3 * NORM
         EPS3 = NORM
  502    EPS3 = 0.5E0*EPS3
         IF (NORM + EPS3 .GT. NORM) GO TO 502
         UK = SQRT(REAL(Q-P+5))
         EPS3 = UK * EPS3
         EPS4 = UK * EPS3
         UK = EPS4 / UK
         S = P
  505    GROUP = 0
         GO TO 520
C     .......... LOOK FOR CLOSE OR COINCIDENT ROOTS ..........
  510    IF (ABS(X1-X0) .GE. EPS2) GO TO 505
         GROUP = GROUP + 1
         IF (ORDER * (X1 - X0) .LE. 0.0E0) X1 = X0 + ORDER * EPS3
C     .......... ELIMINATION WITH INTERCHANGES AND
C                INITIALIZATION OF VECTOR ..........
  520    V = 0.0E0
C
         DO 580 I = P, Q
            RV6(I) = UK
            IF (I .EQ. P) GO TO 560
            IF (ABS(E(I)) .LT. ABS(U)) GO TO 540
C     .......... WARNING -- A DIVIDE CHECK MAY OCCUR HERE IF
C                E2 ARRAY HAS NOT BEEN SPECIFIED CORRECTLY ..........
            XU = U / E(I)
            RV4(I) = XU
            RV1(I-1) = E(I)
            RV2(I-1) = D(I) - X1
            RV3(I-1) = 0.0E0
            IF (I .NE. Q) RV3(I-1) = E(I+1)
            U = V - XU * RV2(I-1)
            V = -XU * RV3(I-1)
            GO TO 580
  540       XU = E(I) / U
            RV4(I) = XU
            RV1(I-1) = U
            RV2(I-1) = V
            RV3(I-1) = 0.0E0
  560       U = D(I) - X1 - XU * V
            IF (I .NE. Q) V = E(I+1)
  580    CONTINUE
C
         IF (U .EQ. 0.0E0) U = EPS3
         RV1(Q) = U
         RV2(Q) = 0.0E0
         RV3(Q) = 0.0E0
C     .......... BACK SUBSTITUTION
C                FOR I=Q STEP -1 UNTIL P DO -- ..........
  600    DO 620 II = P, Q
            I = P + Q - II
            RV6(I) = (RV6(I) - U * RV2(I) - V * RV3(I)) / RV1(I)
            V = U
            U = RV6(I)
  620    CONTINUE
C     .......... ORTHOGONALIZE WITH RESPECT TO PREVIOUS
C                MEMBERS OF GROUP ..........
         IF (GROUP .EQ. 0) GO TO 700
         J = R
C
         DO 680 JJ = 1, GROUP
  630       J = J - 1
            IF (IND(J) .NE. TAG) GO TO 630
            XU = 0.0E0
C
            DO 640 I = P, Q
  640       XU = XU + RV6(I) * Z(I,J)
C
            DO 660 I = P, Q
  660       RV6(I) = RV6(I) - XU * Z(I,J)
C
  680    CONTINUE
C
  700    NORM = 0.0E0
C
         DO 720 I = P, Q
  720    NORM = NORM + ABS(RV6(I))
C
         IF (NORM .GE. 1.0E0) GO TO 840
C     .......... FORWARD SUBSTITUTION ..........
         IF (ITS .EQ. 5) GO TO 830
         IF (NORM .NE. 0.0E0) GO TO 740
         RV6(S) = EPS4
         S = S + 1
         IF (S .GT. Q) S = P
         GO TO 780
  740    XU = EPS4 / NORM
C
         DO 760 I = P, Q
  760    RV6(I) = RV6(I) * XU
C     .......... ELIMINATION OPERATIONS ON NEXT VECTOR
C                ITERATE ..........
  780    DO 820 I = IP, Q
            U = RV6(I)
C     .......... IF RV1(I-1) .EQ. E(I), A ROW INTERCHANGE
C                WAS PERFORMED EARLIER IN THE
C                TRIANGULARIZATION PROCESS ..........
            IF (RV1(I-1) .NE. E(I)) GO TO 800
            U = RV6(I-1)
            RV6(I-1) = RV6(I)
  800       RV6(I) = U - RV4(I) * RV6(I-1)
  820    CONTINUE
C
         ITS = ITS + 1
         GO TO 600
C     .......... SET ERROR -- NON-CONVERGED EIGENVECTOR ..........
  830    IERR = -R
         XU = 0.0E0
         GO TO 870
C     .......... NORMALIZE SO THAT SUM OF SQUARES IS
C                1 AND EXPAND TO FULL ORDER ..........
  840    U = 0.0E0
C
         DO 860 I = P, Q
  860    U = U + RV6(I)**2
C
         XU = 1.0E0 / SQRT(U)
C
  870    DO 880 I = 1, N
  880    Z(I,R) = 0.0E0
C
         DO 900 I = P, Q
  900    Z(I,R) = RV6(I) * XU
C
         X0 = X1
  920 CONTINUE
C
      IF (Q .LT. N) GO TO 100
 1001 RETURN
      END
*DECK TQL1
      SUBROUTINE TQL1 (N, D, E, IERR)
C***BEGIN PROLOGUE  TQL1
C***PURPOSE  Compute the eigenvalues of symmetric tridiagonal matrix by
C            the QL method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQL1-S)
C***KEYWORDS  EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX, EISPACK,
C             QL METHOD
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQL1,
C     NUM. MATH. 11, 293-306(1968) by Bowdler, Martin, Reinsch, and
C     Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     This subroutine finds the eigenvalues of a SYMMETRIC
C     TRIDIAGONAL matrix by the QL method.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1, 2, ..., IERR-1, but may not be
C          the smallest eigenvalues.
C
C        E has been destroyed.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  PYTHAG
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQL1
C
      INTEGER I,J,L,M,N,II,L1,L2,MML,IERR
      REAL D(*),E(*)
      REAL B,C,C2,C3,DL1,EL1,F,G,H,P,R,S,S2
      REAL PYTHAG
C
C***FIRST EXECUTABLE STATEMENT  TQL1
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = 0.0E0
      B = 0.0E0
      E(N) = 0.0E0
C
      DO 290 L = 1, N
         J = 0
         H = ABS(D(L)) + ABS(E(L))
         IF (B .LT. H) B = H
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
         DO 110 M = L, N
            IF (B + ABS(E(M)) .EQ. B) GO TO 120
C     .......... E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 210
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         L2 = L1 + 1
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * E(L))
         R = PYTHAG(P,1.0E0)
         D(L) = E(L) / (P + SIGN(R,P))
         D(L1) = E(L) * (P + SIGN(R,P))
         DL1 = D(L1)
         H = G - D(L)
         IF (L2 .GT. N) GO TO 145
C
         DO 140 I = L2, N
  140    D(I) = D(I) - H
C
  145    F = F + H
C     .......... QL TRANSFORMATION ..........
         P = D(M)
         C = 1.0E0
         C2 = C
         EL1 = E(L1)
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            C3 = C2
            C2 = C
            S2 = S
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS(P) .LT. ABS(E(I))) GO TO 150
            C = E(I) / P
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * P * R
            S = C / R
            C = 1.0E0 / R
            GO TO 160
  150       C = P / E(I)
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * E(I) * R
            S = 1.0E0 / R
            C = C * S
  160       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
  200    CONTINUE
C
         P = -S * S2 * C3 * EL1 * E(L) / DL1
         E(L) = S * P
         D(L) = C * P
         IF (B + ABS(E(L)) .GT. B) GO TO 130
  210    P = D(L) + F
C     .......... ORDER EIGENVALUES ..........
         IF (L .EQ. 1) GO TO 250
C     .......... FOR I=L STEP -1 UNTIL 2 DO -- ..........
         DO 230 II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 270
            D(I) = D(I-1)
  230    CONTINUE
C
  250    I = 1
  270    D(I) = P
  290 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TQL2
      SUBROUTINE TQL2 (NM, N, D, E, Z, IERR)
C***BEGIN PROLOGUE  TQL2
C***PURPOSE  Compute the eigenvalues and eigenvectors of symmetric
C            tridiagonal matrix.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQL2-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQL2,
C     NUM. MATH. 11, 293-306(1968) by Bowdler, Martin, Reinsch, and
C     Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     This subroutine finds the eigenvalues and eigenvectors
C     of a SYMMETRIC TRIDIAGONAL matrix by the QL method.
C     The eigenvectors of a FULL SYMMETRIC matrix can also
C     be found if  TRED2  has been used to reduce this
C     full matrix to tridiagonal form.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        Z contains the transformation matrix produced in the
C          reduction by  TRED2, if performed.  If the eigenvectors
C          of the tridiagonal matrix are desired, Z must contain
C          the identity matrix.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct but
C          unordered for indices 1, 2, ..., IERR-1.
C
C        E has been destroyed.
C
C        Z contains orthonormal eigenvectors of the symmetric
C          tridiagonal (or full) matrix.  If an error exit is made,
C          Z contains the eigenvectors associated with the stored
C          eigenvalues.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  PYTHAG
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQL2
C
      INTEGER I,J,K,L,M,N,II,L1,L2,NM,MML,IERR
      REAL D(*),E(*),Z(NM,*)
      REAL B,C,C2,C3,DL1,EL1,F,G,H,P,R,S,S2
      REAL PYTHAG
C
C***FIRST EXECUTABLE STATEMENT  TQL2
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = 0.0E0
      B = 0.0E0
      E(N) = 0.0E0
C
      DO 240 L = 1, N
         J = 0
         H = ABS(D(L)) + ABS(E(L))
         IF (B .LT. H) B = H
C     .......... LOOK FOR SMALL SUB-DIAGONAL ELEMENT ..........
         DO 110 M = L, N
            IF (B + ABS(E(M)) .EQ. B) GO TO 120
C     .......... E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 220
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         L2 = L1 + 1
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * E(L))
         R = PYTHAG(P,1.0E0)
         D(L) = E(L) / (P + SIGN(R,P))
         D(L1) = E(L) * (P + SIGN(R,P))
         DL1 = D(L1)
         H = G - D(L)
         IF (L2 .GT. N) GO TO 145
C
         DO 140 I = L2, N
  140    D(I) = D(I) - H
C
  145    F = F + H
C     .......... QL TRANSFORMATION ..........
         P = D(M)
         C = 1.0E0
         C2 = C
         EL1 = E(L1)
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            C3 = C2
            C2 = C
            S2 = S
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS(P) .LT. ABS(E(I))) GO TO 150
            C = E(I) / P
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * P * R
            S = C / R
            C = 1.0E0 / R
            GO TO 160
  150       C = P / E(I)
            R = SQRT(C*C+1.0E0)
            E(I+1) = S * E(I) * R
            S = 1.0E0 / R
            C = C * S
  160       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
C     .......... FORM VECTOR ..........
            DO 180 K = 1, N
               H = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * H
               Z(K,I) = C * Z(K,I) - S * H
  180       CONTINUE
C
  200    CONTINUE
C
         P = -S * S2 * C3 * EL1 * E(L) / DL1
         E(L) = S * P
         D(L) = C * P
         IF (B + ABS(E(L)) .GT. B) GO TO 130
  220    D(L) = D(L) + F
  240 CONTINUE
C     .......... ORDER EIGENVALUES AND EIGENVECTORS ..........
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
C
         DO 280 J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  280    CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TQLRAT
      SUBROUTINE TQLRAT (N, D, E2, IERR)
C***BEGIN PROLOGUE  TQLRAT
C***PURPOSE  Compute the eigenvalues of symmetric tridiagonal matrix
C            using a rational variant of the QL method.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TQLRAT-S)
C***KEYWORDS  EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX, EISPACK,
C             QL METHOD
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TQLRAT.
C
C     This subroutine finds the eigenvalues of a SYMMETRIC
C     TRIDIAGONAL matrix by the rational QL method.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E2 contains the squares of the subdiagonal elements of the
C          symmetric tridiagonal matrix in its last N-1 positions.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C      On Output
C
C        D contains the eigenvalues in ascending order.  If an
C          error exit is made, the eigenvalues are correct and
C          ordered for indices 1, 2, ..., IERR-1, but may not be
C          the smallest eigenvalues.
C
C        E2 has been destroyed.
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          J          if the J-th eigenvalue has not been
C                     determined after 30 iterations.
C
C     Calls PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C               C. H. Reinsch, Eigenvalues of a real, symmetric, tri-
C                 diagonal matrix, Algorithm 464, Communications of the
C                 ACM 16, 11 (November 1973), pp. 689.
C***ROUTINES CALLED  PYTHAG, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TQLRAT
C
      INTEGER I,J,L,M,N,II,L1,MML,IERR
      REAL D(*),E2(*)
      REAL B,C,F,G,H,P,R,S,MACHEP
      REAL PYTHAG
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TQLRAT
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E2(I-1) = E2(I)
C
      F = 0.0E0
      B = 0.0E0
      E2(N) = 0.0E0
C
      DO 290 L = 1, N
         J = 0
         H = MACHEP * (ABS(D(L)) + SQRT(E2(L)))
         IF (B .GT. H) GO TO 105
         B = H
         C = B * B
C     .......... LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT ..........
  105    DO 110 M = L, N
            IF (E2(M) .LE. C) GO TO 120
C     .......... E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 210
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     .......... FORM SHIFT ..........
         L1 = L + 1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1) - G) / (2.0E0 * S)
         R = PYTHAG(P,1.0E0)
         D(L) = S / (P + SIGN(R,P))
         H = G - D(L)
C
         DO 140 I = L1, N
  140    D(I) = D(I) - H
C
         F = F + H
C     .......... RATIONAL QL TRANSFORMATION ..........
         G = D(M)
         IF (G .EQ. 0.0E0) G = B
         H = G
         S = 0.0E0
         MML = M - L
C     .......... FOR I=M-1 STEP -1 UNTIL L DO -- ..........
         DO 200 II = 1, MML
            I = M - II
            P = G * H
            R = P + E2(I)
            E2(I+1) = S * R
            S = E2(I) / R
            D(I+1) = H + S * (H + D(I))
            G = D(I) - E2(I) / G
            IF (G .EQ. 0.0E0) G = B
            H = G * P / R
  200    CONTINUE
C
         E2(L) = S * G
         D(L) = H
C     .......... GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST ..........
         IF (H .EQ. 0.0E0) GO TO 210
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 210
         E2(L) = H * E2(L)
         IF (E2(L) .NE. 0.0E0) GO TO 130
  210    P = D(L) + F
C     .......... ORDER EIGENVALUES ..........
         IF (L .EQ. 1) GO TO 250
C     .......... FOR I=L STEP -1 UNTIL 2 DO -- ..........
         DO 230 II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 270
            D(I) = D(I-1)
  230    CONTINUE
C
  250    I = 1
  270    D(I) = P
  290 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ..........
 1000 IERR = L
 1001 RETURN
      END
*DECK TRBAK1
      SUBROUTINE TRBAK1 (NM, N, A, E, M, Z)
C***BEGIN PROLOGUE  TRBAK1
C***PURPOSE  Form the eigenvectors of real symmetric matrix from
C            the eigenvectors of a symmetric tridiagonal matrix formed
C            by TRED1.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (TRBAK1-S)
C***KEYWORDS  EIGENVECTORS OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRBAK1,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine forms the eigenvectors of a REAL SYMMETRIC
C     matrix by back transforming those of the corresponding
C     symmetric tridiagonal matrix determined by  TRED1.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains information about the orthogonal transformations
C          used in the reduction by  TRED1  in its strict lower
C          triangle.  A is a two-dimensional REAL array, dimensioned
C          A(NM,N).
C
C        E contains the subdiagonal elements of the tridiagonal matrix
C          in its last N-1 positions.  E(1) is arbitrary.  These
C          elements provide the remaining information about the
C          orthogonal transformations.  E is a one-dimensional REAL
C          array, dimensioned E(N).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the eigenvectors to be back transformed in its
C          first M columns.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,M).
C
C     On Output
C
C        Z contains the transformed eigenvectors in its first M columns.
C
C     Note that TRBAK1 preserves vector Euclidean norms.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRBAK1
C
      INTEGER I,J,K,L,M,N,NM
      REAL A(NM,*),E(*),Z(NM,*)
      REAL S
C
C***FIRST EXECUTABLE STATEMENT  TRBAK1
      IF (M .EQ. 0) GO TO 200
      IF (N .EQ. 1) GO TO 200
C
      DO 140 I = 2, N
         L = I - 1
         IF (E(I) .EQ. 0.0E0) GO TO 140
C
         DO 130 J = 1, M
            S = 0.0E0
C
            DO 110 K = 1, L
  110       S = S + A(I,K) * Z(K,J)
C     .......... DIVISOR BELOW IS NEGATIVE OF H FORMED IN TRED1.
C                DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            S = (S / A(I,L)) / E(I)
C
            DO 120 K = 1, L
  120       Z(K,J) = Z(K,J) + S * A(I,K)
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK TRBAK3
      SUBROUTINE TRBAK3 (NM, N, NV, A, M, Z)
C***BEGIN PROLOGUE  TRBAK3
C***PURPOSE  Form the eigenvectors of a real symmetric matrix from the
C            eigenvectors of a symmetric tridiagonal matrix formed
C            by TRED3.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C4
C***TYPE      SINGLE PRECISION (TRBAK3-S)
C***KEYWORDS  EIGENVECTORS OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRBAK3,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine forms the eigenvectors of a REAL SYMMETRIC
C     matrix by back transforming those of the corresponding
C     symmetric tridiagonal matrix determined by  TRED3.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        NV is an INTEGER variable set equal to the dimension of the
C          array A as specified in the calling program.  NV must not
C          be less than  N*(N+1)/2.
C
C        A contains information about the orthogonal transformations
C          used in the reduction by  TRED3  in its first N*(N+1)/2
C          positions.  A is a one-dimensional REAL array, dimensioned
C          A(NV).
C
C        M is the number of columns of Z to be back transformed.
C          M is an INTEGER variable.
C
C        Z contains the eigenvectors to be back transformed in its
C          first M columns.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,M).
C
C     On Output
C
C        Z contains the transformed eigenvectors in its first M columns.
C
C     Note that TRBAK3 preserves vector Euclidean norms.
C
C     Questions and comments should be directed to b. s. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRBAK3
C
      INTEGER I,J,K,L,M,N,IK,IZ,NM,NV
      REAL A(*),Z(NM,*)
      REAL H,S
C
C***FIRST EXECUTABLE STATEMENT  TRBAK3
      IF (M .EQ. 0) GO TO 200
      IF (N .EQ. 1) GO TO 200
C
      DO 140 I = 2, N
         L = I - 1
         IZ = (I * L) / 2
         IK = IZ + I
         H = A(IK)
         IF (H .EQ. 0.0E0) GO TO 140
C
         DO 130 J = 1, M
            S = 0.0E0
            IK = IZ
C
            DO 110 K = 1, L
               IK = IK + 1
               S = S + A(IK) * Z(K,J)
  110       CONTINUE
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            S = (S / H) / H
            IK = IZ
C
            DO 120 K = 1, L
               IK = IK + 1
               Z(K,J) = Z(K,J) - S * A(IK)
  120       CONTINUE
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
*DECK TRED1
      SUBROUTINE TRED1 (NM, N, A, D, E, E2)
C***BEGIN PROLOGUE  TRED1
C***PURPOSE  Reduce a real symmetric matrix to symmetric tridiagonal
C            matrix using orthogonal similarity transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED1-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED1,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix
C     to a symmetric tridiagonal matrix using
C     orthogonal similarity transformations.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, A, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains the real symmetric input matrix.  Only the lower
C          triangle of the matrix need be supplied.  A is a two-
C          dimensional REAL array, dimensioned A(NM,N).
C
C     On Output
C
C        A contains information about the orthogonal transformations
C          used in the reduction in its strict lower triangle.  The
C          full upper triangle of A is unaltered.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2 may coincide with E if the squares are not needed.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED1
C
      INTEGER I,J,K,L,N,II,NM,JP1
      REAL A(NM,*),D(*),E(*),E2(*)
      REAL F,G,H,SCALE
C
C***FIRST EXECUTABLE STATEMENT  TRED1
      DO 100 I = 1, N
  100 D(I) = A(I,I)
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 300 II = 1, N
         I = N + 1 - II
         L = I - 1
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 1) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
  120    SCALE = SCALE + ABS(A(I,K))
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = 0.0E0
         E2(I) = 0.0E0
         GO TO 290
C
  140    DO 150 K = 1, L
            A(I,K) = A(I,K) / SCALE
            H = H + A(I,K) * A(I,K)
  150    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = A(I,L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         A(I,L) = F - G
         IF (L .EQ. 1) GO TO 270
         F = 0.0E0
C
         DO 240 J = 1, L
            G = 0.0E0
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, J
  180       G = G + A(J,K) * A(I,K)
C
            JP1 = J + 1
            IF (L .LT. JP1) GO TO 220
C
            DO 200 K = JP1, L
  200       G = G + A(K,J) * A(I,K)
C     .......... FORM ELEMENT OF P ..........
  220       E(J) = G / H
            F = F + E(J) * A(I,J)
  240    CONTINUE
C
         H = F / (H + H)
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = A(I,J)
            G = E(J) - H * F
            E(J) = G
C
            DO 260 K = 1, J
               A(J,K) = A(J,K) - F * E(K) - G * A(I,K)
  260    CONTINUE
C
  270    DO 280 K = 1, L
  280    A(I,K) = SCALE * A(I,K)
C
  290    H = D(I)
         D(I) = A(I,I)
         A(I,I) = H
  300 CONTINUE
C
      RETURN
      END
*DECK TRED2
      SUBROUTINE TRED2 (NM, N, A, D, E, Z)
C***BEGIN PROLOGUE  TRED2
C***PURPOSE  Reduce a real symmetric matrix to a symmetric tridiagonal
C            matrix using and accumulating orthogonal transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED2-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED2,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix to a
C     symmetric tridiagonal matrix using and accumulating
C     orthogonal similarity transformations.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        A contains the real symmetric input matrix.  Only the lower
C          triangle of the matrix need be supplied.  A is a two-
C          dimensional REAL array, dimensioned A(NM,N).
C
C     On Output
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        Z contains the orthogonal transformation matrix produced in
C          the reduction.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,N).
C
C        A and Z may coincide.  If distinct, A is unaltered.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED2
C
      INTEGER I,J,K,L,N,II,NM,JP1
      REAL A(NM,*),D(*),E(*),Z(NM,*)
      REAL F,G,H,HH,SCALE
C
C***FIRST EXECUTABLE STATEMENT  TRED2
      DO 100 I = 1, N
C
         DO 100 J = 1, I
            Z(I,J) = A(I,J)
  100 CONTINUE
C
      IF (N .EQ. 1) GO TO 320
C     .......... FOR I=N STEP -1 UNTIL 2 DO -- ..........
      DO 300 II = 2, N
         I = N + 2 - II
         L = I - 1
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 2) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
  120    SCALE = SCALE + ABS(Z(I,K))
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = Z(I,L)
         GO TO 290
C
  140    DO 150 K = 1, L
            Z(I,K) = Z(I,K) / SCALE
            H = H + Z(I,K) * Z(I,K)
  150    CONTINUE
C
         F = Z(I,L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         Z(I,L) = F - G
         F = 0.0E0
C
         DO 240 J = 1, L
            Z(J,I) = Z(I,J) / H
            G = 0.0E0
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, J
  180       G = G + Z(J,K) * Z(I,K)
C
            JP1 = J + 1
            IF (L .LT. JP1) GO TO 220
C
            DO 200 K = JP1, L
  200       G = G + Z(K,J) * Z(I,K)
C     .......... FORM ELEMENT OF P ..........
  220       E(J) = G / H
            F = F + E(J) * Z(I,J)
  240    CONTINUE
C
         HH = F / (H + H)
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = Z(I,J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 260 K = 1, J
               Z(J,K) = Z(J,K) - F * E(K) - G * Z(I,K)
  260    CONTINUE
C
  290    D(I) = H
  300 CONTINUE
C
  320 D(1) = 0.0E0
      E(1) = 0.0E0
C     .......... ACCUMULATION OF TRANSFORMATION MATRICES ..........
      DO 500 I = 1, N
         L = I - 1
         IF (D(I) .EQ. 0.0E0) GO TO 380
C
         DO 360 J = 1, L
            G = 0.0E0
C
            DO 340 K = 1, L
  340       G = G + Z(I,K) * Z(K,J)
C
            DO 360 K = 1, L
               Z(K,J) = Z(K,J) - G * Z(K,I)
  360    CONTINUE
C
  380    D(I) = Z(I,I)
         Z(I,I) = 1.0E0
         IF (L .LT. 1) GO TO 500
C
         DO 400 J = 1, L
            Z(I,J) = 0.0E0
            Z(J,I) = 0.0E0
  400    CONTINUE
C
  500 CONTINUE
C
      RETURN
      END
*DECK TRED3
      SUBROUTINE TRED3 (N, NV, A, D, E, E2)
C***BEGIN PROLOGUE  TRED3
C***PURPOSE  Reduce a real symmetric matrix stored in packed form to
C            symmetric tridiagonal matrix using orthogonal
C            transformations.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1B1
C***TYPE      SINGLE PRECISION (TRED3-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure TRED3,
C     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     This subroutine reduces a REAL SYMMETRIC matrix, stored as
C     a one-dimensional array, to a symmetric tridiagonal matrix
C     using orthogonal similarity transformations.
C
C     On Input
C
C        N is the order of the matrix A.  N is an INTEGER variable.
C
C        NV is an INTEGER variable set equal to the dimension of the
C          array A as specified in the calling program.  NV must not
C          be less than  N*(N+1)/2.
C
C        A contains the lower triangle, stored row-wise, of the real
C          symmetric packed matrix.  A is a one-dimensional REAL
C          array, dimensioned A(NV).
C
C     On Output
C
C        A contains information about the orthogonal transformations
C          used in the reduction in its first N*(N+1)/2 positions.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is set
C          to zero.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2 may coincide with E if the squares are not needed.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRED3
C
      INTEGER I,J,K,L,N,II,IZ,JK,NV
      REAL A(*),D(*),E(*),E2(*)
      REAL F,G,H,HH,SCALE
C
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
C***FIRST EXECUTABLE STATEMENT  TRED3
      DO  300 II = 1, N
         I = N + 1 - II
         L = I - 1
         IZ = (I * L) / 2
         H = 0.0E0
         SCALE = 0.0E0
         IF (L .LT. 1) GO TO 130
C     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) ..........
         DO 120 K = 1, L
            IZ = IZ + 1
            D(K) = A(IZ)
            SCALE = SCALE + ABS(D(K))
  120    CONTINUE
C
         IF (SCALE .NE. 0.0E0) GO TO 140
  130    E(I) = 0.0E0
         E2(I) = 0.0E0
         GO TO 290
C
  140    DO 150 K = 1, L
            D(K) = D(K) / SCALE
            H = H + D(K) * D(K)
  150    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = D(L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         D(L) = F - G
         A(IZ) = SCALE * D(L)
         IF (L .EQ. 1) GO TO 290
         F = 0.0E0
C
         DO 240 J = 1, L
            G = 0.0E0
            JK = (J * (J-1)) / 2
C     .......... FORM ELEMENT OF A*U ..........
            DO 180 K = 1, L
               JK = JK + 1
               IF (K .GT. J) JK = JK + K - 2
               G = G + A(JK) * D(K)
  180       CONTINUE
C     .......... FORM ELEMENT OF P ..........
            E(J) = G / H
            F = F + E(J) * D(J)
  240    CONTINUE
C
         HH = F / (H + H)
         JK = 0
C     .......... FORM REDUCED A ..........
         DO 260 J = 1, L
            F = D(J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 260 K = 1, J
               JK = JK + 1
               A(JK) = A(JK) - F * E(K) - G * D(K)
  260    CONTINUE
C
  290    D(I) = A(IZ+1)
         A(IZ+1) = SCALE * SQRT(H)
  300 CONTINUE
C
      RETURN
      END
*DECK TRI3
      SUBROUTINE TRI3 (M, A, B, C, K, Y1, Y2, Y3, TCOS, D, W1, W2, W3)
C***BEGIN PROLOGUE  TRI3
C***SUBSIDIARY
C***PURPOSE  Subsidiary to GENBUN
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRI3-S, CMPTR3-C)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Subroutine to solve three linear systems whose common coefficient
C     matrix is a rational function in the matrix given by
C
C                  TRIDIAGONAL (...,A(I),B(I),C(I),...)
C
C***SEE ALSO  GENBUN
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890206  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRI3
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,K(4)       ,
     1                TCOS(*)    ,Y1(*)      ,Y2(*)      ,Y3(*)      ,
     2                D(*)       ,W1(*)      ,W2(*)      ,W3(*)
      INTEGER K1P1, K2P1, K3P1, K4P1
C
C***FIRST EXECUTABLE STATEMENT  TRI3
      MM1 = M-1
      K1 = K(1)
      K2 = K(2)
      K3 = K(3)
      K4 = K(4)
      K1P1 = K1+1
      K2P1 = K2+1
      K3P1 = K3+1
      K4P1 = K4+1
      K2K3K4 = K2+K3+K4
      IF (K2K3K4 .EQ. 0) GO TO 101
      L1 = (K1+1)/(K2+1)
      L2 = (K1+1)/(K3+1)
      L3 = (K1+1)/(K4+1)
      LINT1 = 1
      LINT2 = 1
      LINT3 = 1
      KINT1 = K1
      KINT2 = KINT1+K2
      KINT3 = KINT2+K3
  101 CONTINUE
      DO 115 N=1,K1
         X = TCOS(N)
         IF (K2K3K4 .EQ. 0) GO TO 107
         IF (N .NE. L1) GO TO 103
         DO 102 I=1,M
            W1(I) = Y1(I)
  102    CONTINUE
  103    IF (N .NE. L2) GO TO 105
         DO 104 I=1,M
            W2(I) = Y2(I)
  104    CONTINUE
  105    IF (N .NE. L3) GO TO 107
         DO 106 I=1,M
            W3(I) = Y3(I)
  106    CONTINUE
  107    CONTINUE
         Z = 1./(B(1)-X)
         D(1) = C(1)*Z
         Y1(1) = Y1(1)*Z
         Y2(1) = Y2(1)*Z
         Y3(1) = Y3(1)*Z
         DO 108 I=2,M
            Z = 1./(B(I)-X-A(I)*D(I-1))
            D(I) = C(I)*Z
            Y1(I) = (Y1(I)-A(I)*Y1(I-1))*Z
            Y2(I) = (Y2(I)-A(I)*Y2(I-1))*Z
            Y3(I) = (Y3(I)-A(I)*Y3(I-1))*Z
  108    CONTINUE
         DO 109 IP=1,MM1
            I = M-IP
            Y1(I) = Y1(I)-D(I)*Y1(I+1)
            Y2(I) = Y2(I)-D(I)*Y2(I+1)
            Y3(I) = Y3(I)-D(I)*Y3(I+1)
  109    CONTINUE
         IF (K2K3K4 .EQ. 0) GO TO 115
         IF (N .NE. L1) GO TO 111
         I = LINT1+KINT1
         XX = X-TCOS(I)
         DO 110 I=1,M
            Y1(I) = XX*Y1(I)+W1(I)
  110    CONTINUE
         LINT1 = LINT1+1
         L1 = (LINT1*K1P1)/K2P1
  111    IF (N .NE. L2) GO TO 113
         I = LINT2+KINT2
         XX = X-TCOS(I)
         DO 112 I=1,M
            Y2(I) = XX*Y2(I)+W2(I)
  112    CONTINUE
         LINT2 = LINT2+1
         L2 = (LINT2*K1P1)/K3P1
  113    IF (N .NE. L3) GO TO 115
         I = LINT3+KINT3
         XX = X-TCOS(I)
         DO 114 I=1,M
            Y3(I) = XX*Y3(I)+W3(I)
  114    CONTINUE
         LINT3 = LINT3+1
         L3 = (LINT3*K1P1)/K4P1
  115 CONTINUE
      RETURN
      END
*DECK TRIDIB
      SUBROUTINE TRIDIB (N, EPS1, D, E, E2, LB, UB, M11, M, W, IND,
     +   IERR, RV4, RV5)
C***BEGIN PROLOGUE  TRIDIB
C***PURPOSE  Compute the eigenvalues of a symmetric tridiagonal matrix
C            in a given interval using Sturm sequencing.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TRIDIB-S)
C***KEYWORDS  EIGENVALUES OF A REAL SYMMETRIC MATRIX, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure BISECT,
C     NUM. MATH. 9, 386-393(1967) by Barth, Martin, and Wilkinson.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 249-256(1971).
C
C     This subroutine finds those eigenvalues of a TRIDIAGONAL
C     SYMMETRIC matrix between specified boundary indices,
C     using bisection.
C
C     On Input
C
C        N is the order of the matrix.  N is an INTEGER variable.
C
C        EPS1 is an absolute error tolerance for the computed eigen-
C          values.  If the input EPS1 is non-positive, it is reset for
C          each submatrix to a default value, namely, minus the product
C          of the relative machine precision and the 1-norm of the
C          submatrix.  EPS1 is a REAL variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C        M11 specifies the lower boundary index for the set of desired
C          eigenvalues.  M11 is an INTEGER variable.
C
C        M specifies the number of eigenvalues desired.  The upper
C          boundary index M22 is then obtained as M22=M11+M-1.
C          M is an INTEGER variable.
C
C     On Output
C
C        EPS1 is unaltered unless it has been reset to its
C          (last) default value.
C
C        D and E are unaltered.
C
C        Elements of E2, corresponding to elements of E regarded
C          as negligible, have been replaced by zero causing the
C          matrix to split into a direct sum of submatrices.
C          E2(1) is also set to zero.
C
C        LB and UB define an interval containing exactly the desired
C          eigenvalues.  LB and UB are REAL variables.
C
C        W contains, in its first M positions, the eigenvalues
C          between indices M11 and M22 in ascending order.
C          W is a one-dimensional REAL array, dimensioned W(M).
C
C        IND contains in its first M positions the submatrix indices
C          associated with the corresponding eigenvalues in W --
C          1 for eigenvalues belonging to the first submatrix from
C          the top, 2 for those belonging to the second submatrix, etc.
C          IND is an one-dimensional INTEGER array, dimensioned IND(M).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          3*N+1      if multiple eigenvalues at index M11 make
C                     unique selection of LB impossible,
C          3*N+2      if multiple eigenvalues at index M22 make
C                     unique selection of UB impossible.
C
C        RV4 and RV5 are one-dimensional REAL arrays used for temporary
C          storage of the lower and upper bounds for the eigenvalues in
C          the bisection process.  RV4 and RV5 are dimensioned RV4(N)
C          and RV5(N).
C
C     Note that subroutine TQL1, IMTQL1, or TQLRAT is generally faster
C     than TRIDIB, if more than N/4 eigenvalues are to be found.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TRIDIB
C
      INTEGER I,J,K,L,M,N,P,Q,R,S,II,M1,M2,M11,M22,TAG,IERR,ISTURM
      REAL D(*),E(*),E2(*),W(*),RV4(*),RV5(*)
      REAL U,V,LB,T1,T2,UB,XU,X0,X1,EPS1,MACHEP,S1,S2
      INTEGER IND(*)
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TRIDIB
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      TAG = 0
      XU = D(1)
      X0 = D(1)
      U = 0.0E0
C     .......... LOOK FOR SMALL SUB-DIAGONAL ENTRIES AND DETERMINE AN
C                INTERVAL CONTAINING ALL THE EIGENVALUES ..........
      DO 40 I = 1, N
         X1 = U
         U = 0.0E0
         IF (I .NE. N) U = ABS(E(I+1))
         XU = MIN(D(I)-(X1+U),XU)
         X0 = MAX(D(I)+(X1+U),X0)
         IF (I .EQ. 1) GO TO 20
         S1 = ABS(D(I)) + ABS(D(I-1))
         S2 = S1 + ABS(E(I))
         IF (S2 .GT. S1) GO TO 40
   20    E2(I) = 0.0E0
   40 CONTINUE
C
      X1 = MAX(ABS(XU),ABS(X0)) * MACHEP * N
      XU = XU - X1
      T1 = XU
      X0 = X0 + X1
      T2 = X0
C     .......... DETERMINE AN INTERVAL CONTAINING EXACTLY
C                THE DESIRED EIGENVALUES ..........
      P = 1
      Q = N
      M1 = M11 - 1
      IF (M1 .EQ. 0) GO TO 75
      ISTURM = 1
   50 V = X1
      X1 = XU + (X0 - XU) * 0.5E0
      IF (X1 .EQ. V) GO TO 980
      GO TO 320
   60 IF (S - M1) 65, 73, 70
   65 XU = X1
      GO TO 50
   70 X0 = X1
      GO TO 50
   73 XU = X1
      T1 = X1
   75 M22 = M1 + M
      IF (M22 .EQ. N) GO TO 90
      X0 = T2
      ISTURM = 2
      GO TO 50
   80 IF (S - M22) 65, 85, 70
   85 T2 = X1
   90 Q = 0
      R = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX, REFINING
C                INTERVAL BY THE GERSCHGORIN BOUNDS ..........
  100 IF (R .EQ. M) GO TO 1001
      TAG = TAG + 1
      P = Q + 1
      XU = D(P)
      X0 = D(P)
      U = 0.0E0
C
      DO 120 Q = P, N
         X1 = U
         U = 0.0E0
         V = 0.0E0
         IF (Q .EQ. N) GO TO 110
         U = ABS(E(Q+1))
         V = E2(Q+1)
  110    XU = MIN(D(Q)-(X1+U),XU)
         X0 = MAX(D(Q)+(X1+U),X0)
         IF (V .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C
  140 X1 = MAX(ABS(XU),ABS(X0)) * MACHEP
      IF (EPS1 .LE. 0.0E0) EPS1 = -X1
      IF (P .NE. Q) GO TO 180
C     .......... CHECK FOR ISOLATED ROOT WITHIN INTERVAL ..........
      IF (T1 .GT. D(P) .OR. D(P) .GE. T2) GO TO 940
      M1 = P
      M2 = P
      RV5(P) = D(P)
      GO TO 900
  180 X1 = X1 * (Q-P+1)
      LB = MAX(T1,XU-X1)
      UB = MIN(T2,X0+X1)
      X1 = LB
      ISTURM = 3
      GO TO 320
  200 M1 = S + 1
      X1 = UB
      ISTURM = 4
      GO TO 320
  220 M2 = S
      IF (M1 .GT. M2) GO TO 940
C     .......... FIND ROOTS BY BISECTION ..........
      X0 = UB
      ISTURM = 5
C
      DO 240 I = M1, M2
         RV5(I) = UB
         RV4(I) = LB
  240 CONTINUE
C     .......... LOOP FOR K-TH EIGENVALUE
C                FOR K=M2 STEP -1 UNTIL M1 DO --
C                (-DO- NOT USED TO LEGALIZE -COMPUTED GO TO-) ..........
      K = M2
  250    XU = LB
C     .......... FOR I=K STEP -1 UNTIL M1 DO -- ..........
         DO 260 II = M1, K
            I = M1 + K - II
            IF (XU .GE. RV4(I)) GO TO 260
            XU = RV4(I)
            GO TO 280
  260    CONTINUE
C
  280    IF (X0 .GT. RV5(K)) X0 = RV5(K)
C     .......... NEXT BISECTION STEP ..........
  300    X1 = (XU + X0) * 0.5E0
         S1 = ABS(XU) + ABS(X0) + ABS(EPS1)
         S2 = S1 + ABS(X0-XU)/2.0E0
         IF (S2 .EQ. S1) GO TO 420
C     .......... IN-LINE PROCEDURE FOR STURM SEQUENCE ..........
  320    S = P - 1
         U = 1.0E0
C
         DO 340 I = P, Q
            IF (U .NE. 0.0E0) GO TO 325
            V = ABS(E(I)) / MACHEP
            IF (E2(I) .EQ. 0.0E0) V = 0.0E0
            GO TO 330
  325       V = E2(I) / U
  330       U = D(I) - X1 - V
            IF (U .LT. 0.0E0) S = S + 1
  340    CONTINUE
C
         GO TO (60,80,200,220,360), ISTURM
C     .......... REFINE INTERVALS ..........
  360    IF (S .GE. K) GO TO 400
         XU = X1
         IF (S .GE. M1) GO TO 380
         RV4(M1) = X1
         GO TO 300
  380    RV4(S+1) = X1
         IF (RV5(S) .GT. X1) RV5(S) = X1
         GO TO 300
  400    X0 = X1
         GO TO 300
C     .......... K-TH EIGENVALUE FOUND ..........
  420    RV5(K) = X1
      K = K - 1
      IF (K .GE. M1) GO TO 250
C     .......... ORDER EIGENVALUES TAGGED WITH THEIR
C                SUBMATRIX ASSOCIATIONS ..........
  900 S = R
      R = R + M2 - M1 + 1
      J = 1
      K = M1
C
      DO 920 L = 1, R
         IF (J .GT. S) GO TO 910
         IF (K .GT. M2) GO TO 940
         IF (RV5(K) .GE. W(L)) GO TO 915
C
         DO 905 II = J, S
            I = L + S - II
            W(I+1) = W(I)
            IND(I+1) = IND(I)
  905    CONTINUE
C
  910    W(L) = RV5(K)
         IND(L) = TAG
         K = K + 1
         GO TO 920
  915    J = J + 1
  920 CONTINUE
C
  940 IF (Q .LT. N) GO TO 100
      GO TO 1001
C     .......... SET ERROR -- INTERVAL CANNOT BE FOUND CONTAINING
C                EXACTLY THE DESIRED EIGENVALUES ..........
  980 IERR = 3 * N + ISTURM
 1001 LB = T1
      UB = T2
      RETURN
      END
*DECK TRIDQ
      SUBROUTINE TRIDQ (MR, A, B, C, Y, D)
C***BEGIN PROLOGUE  TRIDQ
C***SUBSIDIARY
C***PURPOSE  Subsidiary to POIS3D
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIDQ-S)
C***AUTHOR  (UNKNOWN)
C***SEE ALSO  POIS3D
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900308  Renamed routine from TRID to TRIDQ.  (WRB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIDQ
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,Y(*)       ,
     1                D(*)
C***FIRST EXECUTABLE STATEMENT  TRIDQ
      M = MR
      MM1 = M-1
      Z = 1./B(1)
      D(1) = C(1)*Z
      Y(1) = Y(1)*Z
      DO 101 I=2,MM1
         Z = 1./(B(I)-A(I)*D(I-1))
         D(I) = C(I)*Z
         Y(I) = (Y(I)-A(I)*Y(I-1))*Z
  101 CONTINUE
      Z = B(M)-A(M)*D(MM1)
      IF (Z .NE. 0.) GO TO 102
      Y(M) = 0.
      GO TO 103
  102 Y(M) = (Y(M)-A(M)*Y(MM1))/Z
  103 CONTINUE
      DO 104 IP=1,MM1
         I = M-IP
         Y(I) = Y(I)-D(I)*Y(I+1)
  104 CONTINUE
      RETURN
      END
*DECK TRIS4
      SUBROUTINE TRIS4 (N, A, B, C, D, U, Z)
C***BEGIN PROLOGUE  TRIS4
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPX4
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIS4-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine solves for a non-zero eigenvector corresponding
C     to the zero eigenvalue of the transpose of the rank
C     deficient ONE matrix with subdiagonal A, diagonal B, and
C     superdiagonal C , with A(1) in the (1,N) position, with
C     C(N) in the (N,1) position, AND all other elements zero.
C
C***SEE ALSO  SEPX4
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIS4
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,D(*)       ,
     1                U(*)       ,Z(*)
C***FIRST EXECUTABLE STATEMENT  TRIS4
      BN = B(N)
      D(1) = A(2)/B(1)
      V = A(1)
      U(1) = C(N)/B(1)
      NM2 = N-2
      DO  10 J=2,NM2
         DEN = B(J)-C(J-1)*D(J-1)
         D(J) = A(J+1)/DEN
         U(J) = -C(J-1)*U(J-1)/DEN
         BN = BN-V*U(J-1)
         V = -V*D(J-1)
   10 CONTINUE
      DEN = B(N-1)-C(N-2)*D(N-2)
      D(N-1) = (A(N)-C(N-2)*U(N-2))/DEN
      AN = C(N-1)-V*D(N-2)
      BN = BN-V*U(N-2)
      DEN = BN-AN*D(N-1)
C
C     SET LAST COMPONENT EQUAL TO ONE
C
      Z(N) = 1.0
      Z(N-1) = -D(N-1)
      NM1 = N-1
      DO  20 J=2,NM1
         K = N-J
         Z(K) = -D(K)*Z(K+1)-U(K)*Z(N)
   20 CONTINUE
      RETURN
      END
*DECK TRISP
      SUBROUTINE TRISP (N, A, B, C, D, U, Z)
C***BEGIN PROLOGUE  TRISP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SEPELI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRISP-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine solves for a non-zero eigenvector corresponding
C     to the zero eigenvalue of the transpose of the rank
C     deficient ONE matrix with subdiagonal A, diagonal B, and
C     superdiagonal C , with A(1) in the (1,N) position, with
C     C(N) in the (N,1) position, and all other elements zero.
C
C***SEE ALSO  SEPELI
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRISP
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,D(*)       ,
     1                U(*)       ,Z(*)
C***FIRST EXECUTABLE STATEMENT  TRISP
      BN = B(N)
      D(1) = A(2)/B(1)
      V = A(1)
      U(1) = C(N)/B(1)
      NM2 = N-2
      DO  10 J=2,NM2
         DEN = B(J)-C(J-1)*D(J-1)
         D(J) = A(J+1)/DEN
         U(J) = -C(J-1)*U(J-1)/DEN
         BN = BN-V*U(J-1)
         V = -V*D(J-1)
   10 CONTINUE
      DEN = B(N-1)-C(N-2)*D(N-2)
      D(N-1) = (A(N)-C(N-2)*U(N-2))/DEN
      AN = C(N-1)-V*D(N-2)
      BN = BN-V*U(N-2)
      DEN = BN-AN*D(N-1)
C
C     SET LAST COMPONENT EQUAL TO ONE
C
      Z(N) = 1.0
      Z(N-1) = -D(N-1)
      NM1 = N-1
      DO  20 J=2,NM1
         K = N-J
         Z(K) = -D(K)*Z(K+1)-U(K)*Z(N)
   20 CONTINUE
      RETURN
      END
*DECK TRIX
      SUBROUTINE TRIX (IDEGBR, IDEGCR, M, A, B, C, Y, TCOS, D, W)
C***BEGIN PROLOGUE  TRIX
C***SUBSIDIARY
C***PURPOSE  Subsidiary to GENBUN
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (TRIX-S, CMPTRX-C)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Subroutine to solve a system of linear equations where the
C     coefficient matrix is a rational function in the matrix given by
C     TRIDIAGONAL  ( . . . , A(I), B(I), C(I), . . . ).
C
C***SEE ALSO  GENBUN
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  TRIX
C
      DIMENSION       A(*)       ,B(*)       ,C(*)       ,Y(*)       ,
     1                TCOS(*)    ,D(*)       ,W(*)
      INTEGER KB, KC
C***FIRST EXECUTABLE STATEMENT  TRIX
      MM1 = M-1
      KB = IDEGBR+1
      KC = IDEGCR+1
      L = (IDEGBR+1)/(IDEGCR+1)
      LINT = 1
      DO 108 K=1,IDEGBR
         X = TCOS(K)
         IF (K .NE. L) GO TO 102
         I = IDEGBR+LINT
         XX = X-TCOS(I)
         DO 101 I=1,M
            W(I) = Y(I)
            Y(I) = XX*Y(I)
  101    CONTINUE
  102    CONTINUE
         Z = 1./(B(1)-X)
         D(1) = C(1)*Z
         Y(1) = Y(1)*Z
         DO 103 I=2,MM1
            Z = 1./(B(I)-X-A(I)*D(I-1))
            D(I) = C(I)*Z
            Y(I) = (Y(I)-A(I)*Y(I-1))*Z
  103    CONTINUE
         Z = B(M)-X-A(M)*D(MM1)
         IF (Z .NE. 0.) GO TO 104
         Y(M) = 0.
         GO TO 105
  104    Y(M) = (Y(M)-A(M)*Y(MM1))/Z
  105    CONTINUE
         DO 106 IP=1,MM1
            I = M-IP
            Y(I) = Y(I)-D(I)*Y(I+1)
  106    CONTINUE
         IF (K .NE. L) GO TO 108
         DO 107 I=1,M
            Y(I) = Y(I)+W(I)
  107    CONTINUE
         LINT = LINT+1
         L = (LINT*KB)/KC
  108 CONTINUE
      RETURN
      END
*DECK TSTURM
      SUBROUTINE TSTURM (NM, N, EPS1, D, E, E2, LB, UB, MM, M, W, Z,
     +   IERR, RV1, RV2, RV3, RV4, RV5, RV6)
C***BEGIN PROLOGUE  TSTURM
C***PURPOSE  Find those eigenvalues of a symmetric tridiagonal matrix
C            in a given interval and their associated eigenvectors by
C            Sturm sequencing.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4A5, D4C2A
C***TYPE      SINGLE PRECISION (TSTURM-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     This subroutine finds those eigenvalues of a TRIDIAGONAL
C     SYMMETRIC matrix which lie in a specified interval and their
C     associated eigenvectors, using bisection and inverse iteration.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, Z, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        EPS1 is an absolute error tolerance for the computed eigen-
C          values.  It should be chosen so that the accuracy of these
C          eigenvalues is commensurate with relative perturbations of
C          the order of the relative machine precision in the matrix
C          elements.  If the input EPS1 is non-positive, it is reset
C          for each submatrix to a default value, namely, minus the
C          product of the relative machine precision and the 1-norm of
C          the submatrix.  EPS1 is a REAL variable.
C
C        D contains the diagonal elements of the symmetric tridiagonal
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the symmetric
C          tridiagonal matrix in its last N-1 positions.  E(1) is
C          arbitrary.  E is a one-dimensional REAL array, dimensioned
C          E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2(1) is arbitrary.  E2 is a one-dimensional REAL array,
C          dimensioned E2(N).
C
C        LB and UB define the interval to be searched for eigenvalues.
C          If LB is not less than UB, no eigenvalues will be found.
C          LB and UB are REAL variables.
C
C        MM should be set to an upper bound for the number of
C          eigenvalues in the interval.  MM is an INTEGER variable.
C          WARNING -  If more than MM eigenvalues are determined to lie
C          in the interval, an error return is made with no values or
C          vectors found.
C
C     On Output
C
C        EPS1 is unaltered unless it has been reset to its
C          (last) default value.
C
C        D and E are unaltered.
C
C        Elements of E2, corresponding to elements of E regarded as
C          negligible, have been replaced by zero causing the matrix to
C          split into a direct sum of submatrices.  E2(1) is also set
C          to zero.
C
C        M is the number of eigenvalues determined to lie in (LB,UB).
C          M is an INTEGER variable.
C
C        W contains the M eigenvalues in ascending order if the matrix
C          does not split.  If the matrix splits, the eigenvalues are
C          in ascending order for each submatrix.  If a vector error
C          exit is made, W contains those values already found.  W is a
C          one-dimensional REAL array, dimensioned W(MM).
C
C        Z contains the associated set of orthonormal eigenvectors.
C          If an error exit is made, Z contains those vectors already
C          found.  Z is a one-dimensional REAL array, dimensioned
C          Z(NM,MM).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          3*N+1      if M exceeds MM no eigenvalues or eigenvectors
C                     are computed,
C          4*N+J      if the eigenvector corresponding to the J-th
C                     eigenvalue fails to converge in 5 iterations, then
C                     the eigenvalues and eigenvectors in W and Z should
C                     be correct for indices 1, 2, ..., J-1.
C
C        RV1, RV2, RV3, RV4, RV5, and RV6 are temporary storage arrays,
C          dimensioned RV1(N), RV2(N), RV3(N), RV4(N), RV5(N), and
C          RV6(N).
C
C     The ALGOL procedure STURMCNT contained in TRISTURM
C     appears in TSTURM in-line.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  TSTURM
C
      INTEGER I,J,K,M,N,P,Q,R,S,II,IP,JJ,MM,M1,M2,NM,ITS
      INTEGER IERR,GROUP,ISTURM
      REAL D(*),E(*),E2(*),W(*),Z(NM,*)
      REAL RV1(*),RV2(*),RV3(*),RV4(*),RV5(*),RV6(*)
      REAL U,V,LB,T1,T2,UB,UK,XU,X0,X1,EPS1,EPS2,EPS3,EPS4
      REAL NORM,MACHEP,S1,S2
      LOGICAL FIRST
C
      SAVE FIRST, MACHEP
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  TSTURM
      IF (FIRST) THEN
         MACHEP = R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
      IERR = 0
      T1 = LB
      T2 = UB
C     .......... LOOK FOR SMALL SUB-DIAGONAL ENTRIES ..........
      DO 40 I = 1, N
         IF (I .EQ. 1) GO TO 20
         S1 = ABS(D(I)) + ABS(D(I-1))
         S2 = S1 + ABS(E(I))
         IF (S2 .GT. S1) GO TO 40
   20    E2(I) = 0.0E0
   40 CONTINUE
C     .......... DETERMINE THE NUMBER OF EIGENVALUES
C                IN THE INTERVAL ..........
      P = 1
      Q = N
      X1 = UB
      ISTURM = 1
      GO TO 320
   60 M = S
      X1 = LB
      ISTURM = 2
      GO TO 320
   80 M = M - S
      IF (M .GT. MM) GO TO 980
      Q = 0
      R = 0
C     .......... ESTABLISH AND PROCESS NEXT SUBMATRIX, REFINING
C                INTERVAL BY THE GERSCHGORIN BOUNDS ..........
  100 IF (R .EQ. M) GO TO 1001
      P = Q + 1
      XU = D(P)
      X0 = D(P)
      U = 0.0E0
C
      DO 120 Q = P, N
         X1 = U
         U = 0.0E0
         V = 0.0E0
         IF (Q .EQ. N) GO TO 110
         U = ABS(E(Q+1))
         V = E2(Q+1)
  110    XU = MIN(D(Q)-(X1+U),XU)
         X0 = MAX(D(Q)+(X1+U),X0)
         IF (V .EQ. 0.0E0) GO TO 140
  120 CONTINUE
C
  140 X1 = MAX(ABS(XU),ABS(X0)) * MACHEP
      IF (EPS1 .LE. 0.0E0) EPS1 = -X1
      IF (P .NE. Q) GO TO 180
C     .......... CHECK FOR ISOLATED ROOT WITHIN INTERVAL ..........
      IF (T1 .GT. D(P) .OR. D(P) .GE. T2) GO TO 940
      R = R + 1
C
      DO 160 I = 1, N
  160 Z(I,R) = 0.0E0
C
      W(R) = D(P)
      Z(P,R) = 1.0E0
      GO TO 940
  180 X1 = X1 * (Q-P+1)
      LB = MAX(T1,XU-X1)
      UB = MIN(T2,X0+X1)
      X1 = LB
      ISTURM = 3
      GO TO 320
  200 M1 = S + 1
      X1 = UB
      ISTURM = 4
      GO TO 320
  220 M2 = S
      IF (M1 .GT. M2) GO TO 940
C     .......... FIND ROOTS BY BISECTION ..........
      X0 = UB
      ISTURM = 5
C
      DO 240 I = M1, M2
         RV5(I) = UB
         RV4(I) = LB
  240 CONTINUE
C     .......... LOOP FOR K-TH EIGENVALUE
C                FOR K=M2 STEP -1 UNTIL M1 DO --
C                (-DO- NOT USED TO LEGALIZE -COMPUTED GO TO-) ..........
      K = M2
  250    XU = LB
C     .......... FOR I=K STEP -1 UNTIL M1 DO -- ..........
         DO 260 II = M1, K
            I = M1 + K - II
            IF (XU .GE. RV4(I)) GO TO 260
            XU = RV4(I)
            GO TO 280
  260    CONTINUE
C
  280    IF (X0 .GT. RV5(K)) X0 = RV5(K)
C     .......... NEXT BISECTION STEP ..........
  300    X1 = (XU + X0) * 0.5E0
         S1 = 2.0E0*(ABS(XU) + ABS(X0) + ABS(EPS1))
         S2 = S1 + ABS(X0 - XU)
         IF (S2 .EQ. S1) GO TO 420
C     .......... IN-LINE PROCEDURE FOR STURM SEQUENCE ..........
  320    S = P - 1
         U = 1.0E0
C
         DO 340 I = P, Q
            IF (U .NE. 0.0E0) GO TO 325
            V = ABS(E(I)) / MACHEP
            IF (E2(I) .EQ. 0.0E0) V = 0.0E0
            GO TO 330
  325       V = E2(I) / U
  330       U = D(I) - X1 - V
            IF (U .LT. 0.0E0) S = S + 1
  340    CONTINUE
C
         GO TO (60,80,200,220,360), ISTURM
C     .......... REFINE INTERVALS ..........
  360    IF (S .GE. K) GO TO 400
         XU = X1
         IF (S .GE. M1) GO TO 380
         RV4(M1) = X1
         GO TO 300
  380    RV4(S+1) = X1
         IF (RV5(S) .GT. X1) RV5(S) = X1
         GO TO 300
  400    X0 = X1
         GO TO 300
C     .......... K-TH EIGENVALUE FOUND ..........
  420    RV5(K) = X1
      K = K - 1
      IF (K .GE. M1) GO TO 250
C     .......... FIND VECTORS BY INVERSE ITERATION ..........
      NORM = ABS(D(P))
      IP = P + 1
C
      DO 500 I = IP, Q
  500 NORM = MAX(NORM, ABS(D(I)) + ABS(E(I)))
C     .......... EPS2 IS THE CRITERION FOR GROUPING,
C                EPS3 REPLACES ZERO PIVOTS AND EQUAL
C                ROOTS ARE MODIFIED BY EPS3,
C                EPS4 IS TAKEN VERY SMALL TO AVOID OVERFLOW ..........
      EPS2 = 1.0E-3 * NORM
      UK = SQRT(REAL(Q-P+5))
      EPS3 = UK * MACHEP * NORM
      EPS4 = UK * EPS3
      UK = EPS4 / SQRT(UK)
      GROUP = 0
      S = P
C
      DO 920 K = M1, M2
         R = R + 1
         ITS = 1
         W(R) = RV5(K)
         X1 = RV5(K)
C     .......... LOOK FOR CLOSE OR COINCIDENT ROOTS ..........
         IF (K .EQ. M1) GO TO 520
         IF (X1 - X0 .GE. EPS2) GROUP = -1
         GROUP = GROUP + 1
         IF (X1 .LE. X0) X1 = X0 + EPS3
C     .......... ELIMINATION WITH INTERCHANGES AND
C                INITIALIZATION OF VECTOR ..........
  520    V = 0.0E0
C
         DO 580 I = P, Q
            RV6(I) = UK
            IF (I .EQ. P) GO TO 560
            IF (ABS(E(I)) .LT. ABS(U)) GO TO 540
            XU = U / E(I)
            RV4(I) = XU
            RV1(I-1) = E(I)
            RV2(I-1) = D(I) - X1
            RV3(I-1) = 0.0E0
            IF (I .NE. Q) RV3(I-1) = E(I+1)
            U = V - XU * RV2(I-1)
            V = -XU * RV3(I-1)
            GO TO 580
  540       XU = E(I) / U
            RV4(I) = XU
            RV1(I-1) = U
            RV2(I-1) = V
            RV3(I-1) = 0.0E0
  560       U = D(I) - X1 - XU * V
            IF (I .NE. Q) V = E(I+1)
  580    CONTINUE
C
         IF (U .EQ. 0.0E0) U = EPS3
         RV1(Q) = U
         RV2(Q) = 0.0E0
         RV3(Q) = 0.0E0
C     .......... BACK SUBSTITUTION
C                FOR I=Q STEP -1 UNTIL P DO -- ..........
  600    DO 620 II = P, Q
            I = P + Q - II
            RV6(I) = (RV6(I) - U * RV2(I) - V * RV3(I)) / RV1(I)
            V = U
            U = RV6(I)
  620    CONTINUE
C     .......... ORTHOGONALIZE WITH RESPECT TO PREVIOUS
C                MEMBERS OF GROUP ..........
         IF (GROUP .EQ. 0) GO TO 700
C
         DO 680 JJ = 1, GROUP
            J = R - GROUP - 1 + JJ
            XU = 0.0E0
C
            DO 640 I = P, Q
  640       XU = XU + RV6(I) * Z(I,J)
C
            DO 660 I = P, Q
  660       RV6(I) = RV6(I) - XU * Z(I,J)
C
  680    CONTINUE
C
  700    NORM = 0.0E0
C
         DO 720 I = P, Q
  720    NORM = NORM + ABS(RV6(I))
C
         IF (NORM .GE. 1.0E0) GO TO 840
C     .......... FORWARD SUBSTITUTION ..........
         IF (ITS .EQ. 5) GO TO 960
         IF (NORM .NE. 0.0E0) GO TO 740
         RV6(S) = EPS4
         S = S + 1
         IF (S .GT. Q) S = P
         GO TO 780
  740    XU = EPS4 / NORM
C
         DO 760 I = P, Q
  760    RV6(I) = RV6(I) * XU
C     .......... ELIMINATION OPERATIONS ON NEXT VECTOR
C                ITERATE ..........
  780    DO 820 I = IP, Q
            U = RV6(I)
C     .......... IF RV1(I-1) .EQ. E(I), A ROW INTERCHANGE
C                WAS PERFORMED EARLIER IN THE
C                TRIANGULARIZATION PROCESS ..........
            IF (RV1(I-1) .NE. E(I)) GO TO 800
            U = RV6(I-1)
            RV6(I-1) = RV6(I)
  800       RV6(I) = U - RV4(I) * RV6(I-1)
  820    CONTINUE
C
         ITS = ITS + 1
         GO TO 600
C     .......... NORMALIZE SO THAT SUM OF SQUARES IS
C                1 AND EXPAND TO FULL ORDER ..........
  840    U = 0.0E0
C
         DO 860 I = P, Q
  860    U = U + RV6(I)**2
C
         XU = 1.0E0 / SQRT(U)
C
         DO 880 I = 1, N
  880    Z(I,R) = 0.0E0
C
         DO 900 I = P, Q
  900    Z(I,R) = RV6(I) * XU
C
         X0 = X1
  920 CONTINUE
C
  940 IF (Q .LT. N) GO TO 100
      GO TO 1001
C     .......... SET ERROR -- NON-CONVERGED EIGENVECTOR ..........
  960 IERR = 4 * N + R
      GO TO 1001
C     .......... SET ERROR -- UNDERESTIMATE OF NUMBER OF
C                EIGENVALUES IN INTERVAL ..........
  980 IERR = 3 * N + 1
 1001 LB = T1
      UB = T2
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_extrema_types
  use cubetools_parameters
  use cubetools_nan
  use cubetools_header_types
  use cubetools_arrelt_types
  !---------------------------------------------------------------------
  ! Support module for a dedicated type used in the context of extrema
  ! computation. As the extrema are updated at entry%put() time, there
  ! can be a race condition between tasks.
  !---------------------------------------------------------------------
  !
  type :: cubetools_extrema_t
    type(arrelt_t)       :: min   ! Minimum value
    type(arrelt_t)       :: max   ! Maximum value
    integer(kind=data_k) :: nnan  ! Number of NaN elements
  contains
    procedure, public :: init  => cubetools_extrema_init
    procedure, public :: merge => cubetools_extrema_merge
  end type cubetools_extrema_t
  !
  public :: cubetools_extrema_t
  private
  !
contains
  !
  subroutine cubetools_extrema_init(ext,head,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubetools_extrema_t), intent(out)   :: ext
    type(cube_header_t),        intent(in)    :: head
    logical,                    intent(inout) :: error
    !
    call cubetools_arrelt_init('Min',ext%min,error)
    if (error)  return
    call cubetools_arrelt_init('Max',ext%max,error)
    if (error)  return
    ! Ensure min%ix min%iy min%ic pointers are properly set
    call ext%min%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    call ext%max%associate(head%set%il,head%set%im,head%set%ic,error)
    if (error)  return
    !
    ext%nnan    = 0
  end subroutine cubetools_extrema_init
  !
  subroutine cubetools_extrema_merge(out,ouhead,in,error)
    !-------------------------------------------------------------------
    ! Merge a list of cubetools_extrema_t into a single one
    !-------------------------------------------------------------------
    class(cubetools_extrema_t), intent(out)   :: out
    type(cube_header_t),        intent(in)    :: ouhead
    type(cubetools_extrema_t),  intent(in)    :: in(:)
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: iext
    !
    call out%init(ouhead,error)
    !
    do iext=1,size(in)
      if (ieee_is_nan(out%min%val) .or. in(iext)%min%val.lt.out%min%val) then
        out%min = in(iext)%min
      endif
      if (ieee_is_nan(out%max%val) .or. in(iext)%max%val.gt.out%max%val) then
        out%max = in(iext)%max
      endif
      out%nnan = out%nnan + in(iext)%nnan
    enddo
  end subroutine cubetools_extrema_merge
  !
end module cubetools_extrema_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_file
  use image_def
  use gkernel_interfaces
  use cubetools_parameters
  use cubeio_dataformat_types
  use cubecdf_header
  use cubefitsio_header
  use cubeio_messaging
  use cubeio_block
  !
  type :: cubeio_file_t
    ! Descriptor
    character(len=file_l) :: name = ''                    ! File name on disk
    integer(kind=4)       :: hdu = 0                      ! HDU in this file, if relevant
    integer(kind=code_k)  :: kind = code_dataformat_none  ! FITS or GDF?
    ! File (1 used at a time, according to filekind)
    type(gildas)          :: hgdf   ! [private] GDF header
    type(cdf_header_t)    :: hcdf   ! [private] CDF header
    type(fitsio_header_t) :: hfits  ! [private] FITS header descriptor
    ! File buffering
    type(cubeio_block_t)  :: block  ! [private]
  contains
    procedure :: iskind        => cubeio_file_iskind
    procedure :: memsize       => cubeio_file_memsize
    procedure :: list          => cubeio_file_list
    procedure :: open          => cubeio_file_open
    procedure :: close         => cubeio_file_close
    procedure :: init          => cubeio_file_init
    procedure :: free          => cubeio_file_free
    procedure :: read_header   => cubeio_file_read_header
    procedure :: is_cube       => cubeio_file_iscube
    procedure :: is_uvt        => cubeio_file_isuvt
  end type cubeio_file_t
  !
  public :: cubeio_file_t
  public :: file_allocate_new
  private
  !
contains
  !
  function file_allocate_new(error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Allocate and initialize a new file_t in memory and return a
    ! pointer to this allocation
    !-------------------------------------------------------------------
    type(cubeio_file_t), pointer  :: file_allocate_new
    logical, intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ALLOCATE>NEW'
    !
    allocate(file_allocate_new,stat=ier)
    if (failed_allocate(rname,'object',ier,error)) return
    call file_allocate_new%init(error)
    if (error)  return
  end function file_allocate_new
  !
  function cubeio_file_iskind(file,code_dataformat)
    !-------------------------------------------------------------------
    ! Return .true. if the cubeio_file_t provides the requested kind of
    ! file
    !-------------------------------------------------------------------
    logical :: cubeio_file_iskind
    class(cubeio_file_t), intent(in) :: file
    integer(kind=code_k), intent(in) :: code_dataformat
    !
    select case (code_dataformat)
    case (code_dataformat_fits)
      ! Test if the hfits structure is used to describe some FITS header
      cubeio_file_iskind = file%hfits%dtype.ne.code_null
    case (code_dataformat_gdf)
      ! Test if the hgdf structure is used to describe some GDF header
      ! The GDF header provides both GDF description and some technical
      ! components around the file. Try to return .true. if the GDF
      ! description is filled independently of any file on disk.
      cubeio_file_iskind = file%hgdf%gil%ndim.gt.0
    case default
      cubeio_file_iskind = .false.
    end select
  end function cubeio_file_iskind
  !
  function cubeio_file_memsize(file)
    !-------------------------------------------------------------------
    ! Return the memory footprint in bytes
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubeio_file_memsize
    class(cubeio_file_t), intent(in) :: file
    !
    cubeio_file_memsize = file%block%memsize()
  end function cubeio_file_memsize
  !
  subroutine cubeio_file_list(file,code_dataformat,error)
    use gfits_types
    !-------------------------------------------------------------------
    ! List the tuple header under requested format if available
    !-------------------------------------------------------------------
    class(cubeio_file_t), intent(in)    :: file
    integer(kind=code_k), intent(in)    :: code_dataformat
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FILE>LIST'
    !
    select case (code_dataformat)
    case (code_dataformat_gdf)
      if (.not.file%iskind(code_dataformat_gdf)) then
        call cubeio_message(seve%e,rname,'Current IO cube header is not GDF')
        error = .true.
        return
      endif
      call gdf_print_header(file%hgdf)
    case (code_dataformat_fits)
      if (.not.file%iskind(code_dataformat_fits)) then
        call cubeio_message(seve%e,rname,'Current IO cube header is not FITS')
        error = .true.
        return
      endif
      call gfits_list_dict(file%hfits%dict,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unknown requested data format')
      error = .true.
      return
    end select
  end subroutine cubeio_file_list
  !
  subroutine cubeio_file_open(file,error)
    use gkernel_interfaces
    use cubefitsio_image_read
    !-------------------------------------------------------------------
    ! Open (or reopen) a 'cubeio_file_t' instance for READ-ONLY access,
    ! if not yet opened.
    !-------------------------------------------------------------------
    class(cubeio_file_t), intent(inout) :: file   !
    logical,              intent(inout) :: error  !
    !
    character(len=*), parameter :: rname='FILE>OPEN'
    !
    select case (file%kind)
    case (code_dataformat_fits)
      if (file%hfits%unit.gt.0)  return  ! Already opened
      call cubefitsio_image_open(file%hfits,file%name,'???',error)
      if (error)  return
    case (code_dataformat_gdf)
      if (file%hgdf%loca%islo.gt.0)  return  ! Already opened
      ! ZZZ Unfortunately, there is no symetric to gdf_close_image. For the
      ! time being, this re-reads the whole header...
      file%hgdf%file = file%name
      file%hgdf%blc = 0
      file%hgdf%trc = 0
      call gdf_read_header(file%hgdf,error)
      if (error) return
    case default
      call cubeio_message(seve%e,rname,  &
        'File '''//trim(file%name)//''' is neither FITS nor GDF')
      error = .true.
      return
    end select
  end subroutine cubeio_file_open
  !
  subroutine cubeio_file_close(file,error)
    use cubefitsio_image_utils
    use cubecdf_image_utils
    !-------------------------------------------------------------------
    ! Close a 'cubeio_file_t' instance. This is worth calling this
    ! subroutine as some ressources like GIO slots are limited
    !-------------------------------------------------------------------
    class(cubeio_file_t), intent(inout) :: file   !
    logical,              intent(inout) :: error  !
    ! Local
    character(len=*), parameter :: rname='FILE>CLOSE'
    logical :: myerror
    !
    ! Free image slot
    myerror = .false.
    select case (file%kind)
    case (code_dataformat_fits)
      call cubefitsio_image_close(file%hfits,myerror)
      if (myerror)  continue
    case (code_dataformat_cdf)
      call cubecdf_image_close(file%hcdf,myerror)
      if (myerror)  continue
    case (code_dataformat_gdf)
      if (file%hgdf%loca%islo.gt.0) then
        call gdf_close_image(file%hgdf,myerror)
        if (myerror)  continue
      endif
    case default
      ! For a generic use, it is valid to "close" a cube with no
      ! associated file on disk.
      continue
    end select
    if (myerror)  error = .true.
  end subroutine cubeio_file_close
  !
  subroutine cubeio_file_init(file,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Initialize a cubeio_file_t
    !-------------------------------------------------------------------
    class(cubeio_file_t), intent(inout) :: file
    logical,              intent(inout) :: error
    !
    ! Initialize the HGDF header. Must be done once and only once, before
    ! first use of the header. Must come before cubeio_free_cubeio_cube so
    ! that it works properly. Use same test as GIO does internally:
    if (file%hgdf%header.ne.1)  call gildas_null(file%hgdf)
    !
    ! Initialize the buffer block. 'free' subroutine does this correctly.
    call file%block%free(error)
    if (error)  return
  end subroutine cubeio_file_init
  !
  subroutine cubeio_file_free(file,error)
    !-------------------------------------------------------------------
    ! Free the memory-consuming components of a 'cubeio_file_t' instance.
    ! The cubeio_file_t remains useable after this free.
    !-------------------------------------------------------------------
    class(cubeio_file_t), intent(inout) :: file
    logical,              intent(inout) :: error
    !
    call file%block%free(error)
    if (error)  return
  end subroutine cubeio_file_free
  !
  subroutine cubeio_file_read_header(file,name,ihdu,cubeid,error)
    use cubefitsio_image_read
    use cubefitsio_header_read
    !------------------------------------------------------------------
    ! Read the file header from disk in the structure dedicated for
    ! the relevant data format
    !------------------------------------------------------------------
    class(cubeio_file_t), intent(inout) :: file    !
    character(len=*),     intent(in)    :: name    ! File name
    integer(kind=4),      intent(in)    :: ihdu    ! HDU number, if relevant for data format
    character(len=*),     intent(in)    :: cubeid  ! Identifier (feedback only)
    logical,              intent(inout) :: error   !
    ! Local
    character(len=*), parameter :: rname='FILE>READ>HEADER'
    integer(kind=4) :: filekind
    !
    ! Read header to get the file information
    call gag_file_guess(rname,name,filekind,error)
    if (error)  return
    !
    file%name = name
    file%hdu = ihdu
    !
    select case (filekind)
    case (1)
      file%kind = code_dataformat_gdf
      file%hgdf%file = name
      file%hgdf%blc = 0
      file%hgdf%trc = 0
      call gdf_read_header(file%hgdf,error)
      if (error) return
    case (2)
      file%kind = code_dataformat_fits
      file%hfits%hdunum = ihdu
      call cubefitsio_image_open(file%hfits,name,cubeid,error)
      if (error)  return
      call cubefitsio_header_fill(file%hfits,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unsupported file kind')
      error = .true.
      return
    end select
  end subroutine cubeio_file_read_header
  !
  function cubeio_file_iscube(file)
    use cfitsio_api
    !-------------------------------------------------------------------
    ! Determine is the cubeio_file_t provides a 3D-like cube
    !-------------------------------------------------------------------
    logical :: cubeio_file_iscube
    class(cubeio_file_t), intent(in) :: file
    !
    select case(file%kind)
    case (code_dataformat_gdf)
      cubeio_file_iscube = abs(file%hgdf%gil%type_gdf).eq.code_gdf_image
    case (code_dataformat_fits)
      cubeio_file_iscube = file%hfits%hdutype.eq.code_cfitsio_image_hdu
    case default
      cubeio_file_iscube = .false.
    end select
  end function cubeio_file_iscube
  !
  function cubeio_file_isuvt(file)
    !-------------------------------------------------------------------
    ! Determine is the cubeio_file_t provides a UV table
    !-------------------------------------------------------------------
    logical :: cubeio_file_isuvt
    class(cubeio_file_t), intent(in) :: file
    !
    select case(file%kind)
    case (code_dataformat_gdf)
      cubeio_file_isuvt = abs(file%hgdf%gil%type_gdf).eq.code_gdf_uvt
    case (code_dataformat_fits)
      cubeio_file_isuvt = .false.  ! ZZZ to be improved to discriminate UV tables
    case default
      cubeio_file_isuvt = .false.
    end select
  end function cubeio_file_isuvt
  !
end module cubeio_file
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gr8_curve(nxy,x,y,z,var,per,bval,eval,error)
  use gildas_def
  use greg_interfaces, except_this=>gr8_curve
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !	Connect a polyline with blanking value
  ! Arguments
  !	NXY	I		Number of data points		Input
  !	X	R*8 (*) 	Array of X coordinates		Input
  !	Y	R*8 (*) 	Array of Y coordinates		Input
  !	Z	R*8 (*) 	Array of Z coordinates		Input
  !	VAR	CHAR*(*)	Interpolation variable		Input
  !				'X', 'Y', 'Z',
  !				'NUMBERING',
  !				'POLYGONAL_LENGTH',
  !				'CURVILINEAR_LENGTH'
  !	PER	L*4		Periodic flag			Input
  !	BVAL	R*8 		Blanking value			Input
  !	EVAL	R*8		Tolerance on blanking value	Input
  !---------------------------------------------------------------------
  integer(kind=4)                 :: nxy    !
  real*8                          :: x(*)   !
  real*8                          :: y(*)   !
  real*8                          :: z(*)   !
  character(len=*)                :: var    !
  logical                         :: per    !
  real*8                          :: bval   !
  real*8                          :: eval   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  external :: gdraw
  ! Local
  integer(kind=size_length) :: nxy_sl,is,ne,in
  !
  nxy_sl = nxy
  if (eval.lt.0.0) then
    if (nxy_sl.ge.2)  &
      call plcurv(nxy_sl,x,y,z,accurd,'CUBIC_SPLINE',var,per,grelocate,gdraw,  &
        error)
  else
    in = 1
    do while (in.ne.0)
      call find_blank8(y,bval,eval,nxy_sl,is,ne,in)
      if (ne.ge.2)  &
        call plcurv(ne,x(is),y(is),z(is),accurd,'CUBIC_SPLINE',var,per,  &
          grelocate,gdraw,error)
    enddo
  endif
end subroutine gr8_curve
!
subroutine gr4_curve(nxy,x,y,z,var,per,bval,eval,error)
  use gildas_def
  use greg_interfaces, except_this=>gr4_curve
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !	Connect a polyline with blanking value
  ! Arguments
  !	NXY	I		Number of data points		Input
  !	X	R*4 (*) 	Array of X coordinates		Input
  !	Y	R*4 (*) 	Array of Y coordinates		Input
  !	Z	R*4 (*) 	Array of Z coordinates		Input
  !	VAR	CHAR*(*)	Interpolation variable		Input
  !				'X', 'Y', 'Z',
  !				'NUMBERING',
  !				'POLYGONAL_LENGTH',
  !				'CURVILINEAR_LENGTH'
  !	PER	L*4		Periodic flag			Input
  !	BVAL	R*4 		Blanking value			Input
  !	EVAL	R*4		Tolerance on blanking value	Input
  !---------------------------------------------------------------------
  integer(kind=4)                 :: nxy    !
  real*4                          :: x(1)   !
  real*4                          :: y(1)   !
  real*4                          :: z(1)   !
  character(len=*)                :: var    !
  logical                         :: per    !
  real*4                          :: bval   !
  real*4                          :: eval   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  external :: gdraw
  ! Local
  integer(kind=size_length) :: nxy_sl,is,ne,in
  !
  nxy_sl = nxy
  if (eval.lt.0.0) then
    if (nxy_sl.ge.2)  &
      call plcurv4(nxy_sl,x,y,z,accurd,'CUBIC_SPLINE',var,per,grelocate,gdraw,  &
        error)
  else
    in = 1
    do while (in.ne.0)
      call find_blank4(y,bval,eval,nxy_sl,is,ne,in)
      if (ne.ge.2)  &
        call plcurv4(ne,x(is),y(is),z(is),accurd,'CUBIC_SPLINE',var,per,  &
          grelocate,gdraw,error)
    enddo
  endif
end subroutine gr4_curve
!
subroutine curve (line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>curve, &
                       no_interface=>find_blank8
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  ! 	CURVE [Array_X Array_Y]
  !	/ACCURACY [en cm]
  !		Fonctions:
  !	/VARIABLE X			Y=F(X)
  !	/VARIABLE Y			X=F(Y)
  !		Courbes parametriques:
  !	/VARIABLE Z [Array_Z]		Parametre: Z
  !	/VARIABLE NUMBERING		Parametre: Numero du point
  !	/VARIABLE POLYGONAL_LENGTH	(Analytique)
  !	/VARIABLE CURVILINEAR_LENGTH	(Iteratif, non analytique)
  !
  !	/PERIODIC
  !		Suppose que les points 1 et NXY sont separes par
  !		un nombre entier de periodes:
  !		/VARIABLE X	Suppose Y(1) = Y(NXY)
  !		/VARIABLE Y	Suppose X(1) = X(NXY)
  !		Courbe parametrique, suppose
  !				X(1) = X(NXY) et Y(1)=Y(NXY)
  !	/BLANKING [Bval [Eval]]
  !
  ! Arguments :
  !	LINE	C*(*)	Command line			Input/Output
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  external :: gdraw
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='CURVE'
  logical :: periodic
  character(len=24) :: variable,buffer
  character(len=16) :: algorithm
  real :: accuracy
  real*8 :: bval,eval
  integer :: ialgos,ivar,narg,nc,form
  integer(kind=size_length) :: ixy,is,ne,in
  integer(kind=address_length) :: xaddr,yaddr,zaddr
  type(sic_descriptor_t) :: xinca,yinca,zinca
  !
  save xinca,yinca,zinca
  !
  ! Algorithmes disponibles
  integer, parameter :: nalgos=2
  character(len=16) :: algos(nalgos)
  !
  ! Variables disponibles
  integer, parameter :: nvar=6
  character(len=24) :: var(nvar)
  ! Data
  data var /             &
    'X','Y','Z',         &
    'NUMBERING',         &
    'POLYGONAL_LENGTH',  &
    'CURVILINEAR_LENGTH' /
  data algos /'CUBIC_SPLINE','SMOOTHING_SPLINE'/
  ! Code
  !
  ! Algorithm
  ialgos=1
  algorithm=algos(1)
  !
  ! Decode l'option ACCURACY avec la valeur par defaut ACCURD
  if (sic_present(1,1)) then
    call sic_r4 (line,1,1,accuracy,.false.,error)
    if (error) return
    if (sic_present(1,2)) goto 199
    if (accuracy.le.0. .or. accuracy.gt.10.) then
      call greg_message(seve%w,rname,'ACCURACY out of range, using default')
      accuracy=accurd
    endif
  else
    accuracy=accurd
  endif
  !
  ! Decode l'option /VARIABLE avec la valeur par defaut X
  if (sic_present(2,1)) then
    call sic_ke (line,2,1,buffer,nc,.false.,error)
    if (error) return
    call sic_ambigs ('CURVE',buffer,variable,ivar,var,nvar,error)
    if (error) return
    if (sic_present(2,2).and.ivar.ne.3) goto 199
  else
    ivar=1
    variable='X'
  endif
  !
  ! Decode l'option /PERIODIC
  if (sic_present(3,0)) then
    periodic=.true.
    if (sic_present(3,1)) goto 199
  else
    periodic=.false.
  endif
  !
  ! /BLANKING ?
  bval = cblank
  call sic_r8 (line,4,1,bval,.false.,error)
  if (error) return
  eval = eblank
  call sic_r8 (line,4,2,eval,.false.,error)
  if (error) return
  if (sic_present(4,3)) goto 199
  !
  ! Check on which variable
  form = fmt_r8
  narg = sic_narg(0)
  if (narg.eq.2 .or. narg.eq.0) then
    call get_incarnation('CURVE',line,form,ixy,xinca,yinca,error)
    if (error) return
  else
    call greg_message(seve%e,rname,'Two arguments or none')
    error = .true.
    return
  endif
  xaddr = gag_pointer(xinca%addr,memory)
  yaddr = gag_pointer(yinca%addr,memory)
  !
  ! Get Z if required
  if (ivar.eq.3) then
    if (sic_present(2,2)) then
      call get_same_inca ('CURVE',line,2,2,form,ixy,zinca,error)
    else
      call greg_message(seve%w,rname,'Using Z array')
      call get_greg_inca ('CURVE','Z',form,ixy,zinca,error)
    endif
    if (error) then
      call sic_volatile(xinca)
      call sic_volatile(yinca)
      return
    endif
    zaddr = gag_pointer(zinca%addr,memory)
  endif
  !
  ! On est enfin prets pour travailler
  if (eval.lt.0.0d0) then
    if (ixy.ge.2)  &
      call plcurv(ixy,memory(xaddr),memory(yaddr),memory(zaddr),accuracy,  &
      algorithm,variable,periodic,grelocate,gdraw,error)
  else
    in = 1
    do while (in.ne.0)
      call find_blank8(memory(yaddr),bval,eval,ixy,is,ne,in)
      if (ne.ge.2)  &
        call plcurv(ne,memory(xaddr+2*(is-1)),memory(yaddr+2*(is-1)),  &
          memory(zaddr+2*(is-1)),accuracy,algorithm,variable,periodic,   &
          grelocate,gdraw,error)
    enddo
  endif
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  if (ivar.eq.3) call sic_volatile(zinca)
  return
  !
199 call greg_message(seve%e,rname,'Too many parameters for Command or '//  &
      'Option')
  error=.true.
  return
end subroutine curve
!
subroutine get_same_inca (command,line,iopt,iarg,form,ixy,xinca,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>get_same_inca
  use gildas_def
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GreG  Internal routine
  !  Get incarnation of variables in command line
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: command  !
  character(len=*),          intent(in)    :: line     !
  integer(kind=4),           intent(in)    :: iopt     !
  integer(kind=4),           intent(in)    :: iarg     !
  integer(kind=4),           intent(in)    :: form     !
  integer(kind=size_length), intent(inout) :: ixy      !
  type(sic_descriptor_t),    intent(out)   :: xinca    !
  logical,                   intent(inout) :: error    !
  ! Local
  character(len=varname_length) :: var
  type(sic_descriptor_t) :: xdesc
  integer(kind=4) :: nc
  logical :: found
  !
  call sic_ke (line,iopt,iarg,var,nc,.true.,error)
  if (error) return
  found = .true.
  call sic_materialize(var,xdesc,found)
  if (.not.found) then
    call greg_message(seve%e,command,'Unknown variable '//var)
    error = .true.
    return
  endif
  call sic_incarnate(form,xdesc,xinca,error)
  if (error) then
    call sic_volatile(xdesc)   ! It may have been transposed...
    return
  endif
  !
  if (ixy.eq.0) then
    ! First call in current command
    ixy = desc_nelem(xinca)
  elseif (ixy.ne.desc_nelem(xinca)) then
    ! Subsequent calls in current command: consistency check
    call greg_message(seve%w,command,'Arrays have different sizes')
    ixy = min(desc_nelem(xinca),ixy)
  endif
  !
  if (sic_notsamedesc(xdesc,xinca)) call sic_volatile(xdesc)
end subroutine get_same_inca
!
subroutine get_greg_inca (command,name,form,ixy,xinca,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>get_greg_inca
  use gildas_def
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Get incarnation of GREG X Y or Z variable. Note that the code does
  ! not distinguish the program-defined variables (by e.g. COLUMN) from
  ! user-defined ones.
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: command  ! Command name (feedback)
  character(len=*),          intent(in)    :: name     ! Variable name
  integer(kind=4),           intent(in)    :: form     ! Desired incarnation type
  integer(kind=size_length), intent(inout) :: ixy      ! Number of elements
  type(sic_descriptor_t),    intent(out)   :: xinca    ! Incarnation descriptor
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: xdesc
  logical :: found
  character(len=varname_length) :: var
  !
  var = name
  found = .true.
  call sic_materialize(var,xdesc,found)
  if (.not.found) then
    call greg_message(seve%e,command,'Unknown variable '//var)
    error = .true.
    return
  endif
  call sic_incarnate(form,xdesc,xinca,error)
  if (error) then
    call sic_volatile(xdesc)   ! It may have been transposed...
    return
  endif
  !
  if (ixy.eq.0) then
    ! First call in current command
    ixy = desc_nelem(xinca)
  elseif (ixy.ne.desc_nelem(xinca)) then
    ! Subsequent calls in current command: consistency check
    call greg_message(seve%w,command,'Arrays have different sizes')
    ixy = min(desc_nelem(xinca),ixy)
  endif
  !
  if (sic_notsamedesc(xdesc,xinca)) call sic_volatile(xdesc)
end subroutine get_greg_inca

SUBROUTINE WRITE_SDM(LINE,ERROR)
  use gildas_def
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! Support WRITE file /DATA /NOCAL
  ! Write a SDM data set in ALMA SDM FITS format
  ! write the current index
  !( Actual options TBD)
  !     file   character     file name
  !     /DATA     option        write all data table extensions
  !     /NOCAL    option        write data uncalibrated (not multiplied by Tsys)
  !     /HOLODATA option        write data table in holography format
  !                iant  ref      scanned antennaand reference antenna
  !     /ANTENNAS  a1 a2 a3     use only a subarray ...
  !     /TELESCOPE name         telescope value
  !     /SIMULATE  list        simulate data for ATF
  !------------------------------------------------------------------------
  ! Dummy variables:
  character*(*) line
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Local variables:
  integer(kind=address_length) data_in, ip_data
  character*132 argum, argum2
  character c2*2
  character telarg*12
  integer msimvocab
  parameter (msimvocab=3)
  character simvocab(msimvocab)*12, arg*12, simkw*12
  logical :: end, data, nocal, holodata,   &
    telesc, dosubant, switch, simpolar, old, simAddressing
  integer nch, unit, ndata, status, ib, kfich, maxhdu, num,   &
    larg, larg2, holoant, holoref, holobase, nsubant, subant(mnant),   &
    i, narg, nk
  integer lfich, iswitch
  parameter (maxhdu=950)
  save unit
  data unit/-999/
  data simvocab/'SWITCH','POLARIZATION','ADDRESSING'/
  !c      data next_uid/0/, file_name/'EMPTY '/
  data file_name/'EMPTY '/
  !------------------------------------------------------------------------
  ! Code:
  DOSUBANT = .FALSE.
  switch = .FALSE.
  simpolar = .FALSE.
  simAddressing = .false.
  STATUS = 0
  !c unused       DATA = SIC_PRESENT(1,0)
  !c unused       NOCAL = SIC_PRESENT(2,0)
  HOLODATA = SIC_PRESENT(3,0)  ! used.
  TELESC = SIC_PRESENT(5,0)    ! used.
  ! get ATF simulation parameters
  if (SIC_PRESENT(6,0)) then
    i = 1
    do while (i.le.sic_narg(6))
      call sic_ke(line,6,i,arg,narg,.true.,error)
      if (error) return
      call sic_ambigs('WRITE /SIMULATE',arg,simkw,nk,   &
        simvocab,msimvocab,error)
      if (error) return
      i = i+1
      if (simkw.eq.'SWITCH') then
        switch = .true.
        CALL SIC_I4(LINE,6,i,iswitch,.TRUE.,ERROR)
        if (error) return
        i = i+1
      elseif (simkw.eq.'POLARIZATION') then
        simpolar = .true.
      elseif (simkw.eq.'ADDRESSING') then
        simAddressing = .true.
      endif
    enddo
  endif
  !
  ! /ANTENNA
  IF (SIC_PRESENT(4,0)) THEN
    NSUBANT = SIC_NARG(4)
    DO I =1, NSUBANT
      CALL SIC_I4(LINE,4,I,SUBANT(I),.FALSE.,ERROR)
      IF (SUBANT(I).LE.0 .OR. SUBANT(I).GT.MNANT) THEN
        CALL MESSAGE(8,3,'WRITE_SDM',   &
          'Wrong /ANTENNA argument')
      ENDIF
    ENDDO
    DOSUBANT = .TRUE.
  ENDIF
  ! /TELESCOPE
  IF (TELESC) THEN
    CALL SIC_CH(LINE,5,1,TELARG,NARG,.TRUE.,ERROR)
  ENDIF
  !
  ! Verify if any input file
  CALL CHECK_INPUT_FILE(ERROR)
  IF (ERROR) RETURN
  !
  CALL CHECK_INDEX(ERROR)
  IF (ERROR) RETURN
  ! Get file name
  lfich = lenc(file_name)
  if (sic_present(0,1)) then
    ARGUM = 'clicFile'
    CALL SIC_CH(LINE,0,1,ARGUM,NCH,.false.,ERROR)
    IF (ERROR) RETURN
    CALL SIC_PARSEF(ARGUM,file_name,' ','')
    lfich = lenc(file_name)
    old = .false.
    call message(2,1,'WRITE_SDM',   &
      'Creating '//file_name(1:lfich))
  else
    if (file_name(1:lfich).eq.'EMPTY') then
      error = .true.
      CALL MESSAGE(8,3,'WRITE_SDM',   &
        'No open ASDM to extend')
      return
    endif
    old = .true.
    call message(2,1,'WRITE_SDM',   &
      'Extending '//file_name(1:lfich))
  endif
  KFICH = 0
  !
  ! Now loop on current index.
  ! we need a first loop to get the start and end times for the execblock table
  eb_starttime = 9223372036854775807_8
  eb_endtime = 0
  call get_first(.true.,error)
  if (error) goto 99
  call get_data (ndata,data_in,error)
  if (error) goto 99
  ip_data = gag_pointer(data_in,memory)
  call get_eb_times (ndata, memory(ip_data), error)
  if (error) goto 99
  end = .false.
  do while (.not.end)
    
    call get_next(end,error)
    call get_data (ndata,data_in,error)
    if (error) goto 99
    ip_data = gag_pointer(data_in,memory)
    call get_eb_times (ndata, memory(ip_data), error)
  enddo
  
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) goto 99
  if (.not.dosubant) then
    nsubant = r_nant
    do i=1, nsubant
      subant(i) = i
    enddo
  endif
  lfich = lenc(file_name)
  file_name = file_name(1:lfich)//char(0)//' '
  call sdm_init(file_name(1:lfich)//char(0),error)
  if (.not.old) then
    call system('mkdir '//file_name(1:lfich))
    call system('mkdir '//file_name(1:lfich)//'/ASDMBinary')
    ! define uids for containers:
    call sdm_getUid(Project_Uid)
    call sdm_getUid(ObsUnitSet_Uid)
    call sdm_getUid(SchedBlock_Uid)
    call sdm_getUid(ExecBlock_Uid)
    r_execblocknum = 1
  endif
  ! reset all identifiers
  call init_sdm
  if (error) goto 99
  end = .false.
  !     This makes sure the time_start is set to the date of the first
  !     scan (this is used for sources and the like)
  time_start = -1
  do while (.not.end)
    !
    ! Get storage and data
    call get_data (ndata,data_in,error)
    if (error) goto 99
    ip_data = gag_pointer(data_in,memory)
    ! 
    !
    if (telesc) r_teles = telarg
    ! Specific Holography setup:
    if (holodata) then
      !c            ntch = r_nband
      r_nband = 1
      r_lband = 1
      r_lnsb = 1
      r_nsb = 2
      call write_sdm_holotables (ndata, memory(ip_data), error)
    else
      call write_sdm_tables (ndata, memory(ip_data),   &
        switch, iswitch, simAddressing, error)
    endif
    if (error) goto 99
    if (sic_ctrlc()) then
      error = .true.
      goto 99
    endif
    call get_next(end,error)
  enddo
  call write_sdm_scan(error)
  if (error) return
  call sdm_write()
  call sdm_close()
  call message(2,1,'Write_sdm','Data set '//file_name(1:lfich)//   &
    ' written.')
  return
  !
  !
99 call message(8,4,'Write_sdm','SDM Writing Failed')
  return
end subroutine WRITE_SDM
!
subroutine get_eb_times(ldata, data, error)
  integer :: ldata, data(ldata)
  logical :: error
  INCLUDE 'clic_parameter.inc'
  INCLUDE 'clic_par.inc'
  include 'sdm_identifiers.inc'
  integer :: ir, k, h_offset

  ir = r_ndump+1
  k = 1+ h_offset(ir)
  call decode_header (data(k))
  call get_time_interval
  eb_starttime = min(time_interval(1),eb_starttime)
  eb_endtime = max(time_interval(1)+time_interval(2), eb_endtime)
end subroutine get_eb_times

subroutine newformat(nd,d)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC
  !     convert the data section to new format (spectral data averaged).
  ! Arguments:
  !     ND      INTEGER    Data length (Input/Output)
  !     D       INTEGER    Data address
  !---------------------------------------------------------------------
  integer :: nd                      !
  integer(kind=address_length) :: d  !
  ! Global
  include 'clic_parameter.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: inbuf, outbuf, addr
  integer :: size, ier
  !
  data size/0/
  save size
  !
  if (size.eq.0) then
    size = mdatac+mdatal
    ier = sic_getvm(2*size,addr)
    inbuf = gag_pointer(addr,memory)
    outbuf = inbuf + size
  endif
  call sub_newformat(memory(inbuf),memory(outbuf),nd,d)
end subroutine newformat
!------------------------------------------------------------------------
!
subroutine sub_newformat(inbuf,outbuf,nd,d)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC
  !     convert the data section to new format (spectral data averaged).
  ! Arguments:
  !     ND      INTEGER    Data length (Input/Output)
  !     D       INTEGER    Data address
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  real :: inbuf(mdatac+mdatal)       !
  real :: outbuf(mdatac+mdatal)      !
  integer :: nd                      !
  integer(kind=address_length) :: d  !
  ! Global
  include 'clic_par.inc'
  include 'clic_proc_par.inc'
  include 'clic_dheader.inc'
  include 'clic_dcomp.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipk, ipo
  integer :: i, ir, nout
  integer :: ndat, t_ldatl, t_ldatc
  logical :: corr
  character(len=20) :: chain
  !------------------------------------------------------------------------
  ! Code:
  corr = r_proc.ne.p_cal   &
    .and. r_proc.ne.p_skydip .and. r_proc.ne.p_onoff   &
    .and. r_proc.ne.p_sky
  do i=1, r_lband
    r_lcench(i) = 1            ! for berkeley
  enddo
  if (r_proc.eq.p_pass .and. r_ndump.gt.1) then
    ipk = gag_pointer(d,memory)
    ipk = ipk+r_ldump          ! ignore first record
    r_ndump = 1
  else
    ipk = gag_pointer(d,memory)
  endif
  ipo = gag_pointer(d,memory)
  nout = 0
  if (corr) then
    t_ldatc = r_ldatc
    t_ldatl = r_ldatl
  else
    t_ldatc = r_nband*r_nant
    t_ldatl = r_lntch*r_nant
  endif
  ndat = t_ldatc+t_ldatl
  ! Loop on records
  if (corr) then
    r_lmode = 1
  else
    r_lmode = 2
  endif
  call zero_record(ndat,outbuf)
  do ir = 1, r_ndump
    ! Data header
    call r4tor4 (memory(ipk),memory(ipo),r_ldpar)
    call decode_header(memory(ipk))
    ipk = ipk + r_ldpar
    ipo = ipo + r_ldpar
    ! Continuum
    call r4tor4 (memory(ipk),datac,r_ldatc)
    if (corr) then
      call cmodec(r_nband,r_nbas,datac,memory(ipo))
    else
      call amodec(r_nband,r_nbas,datac,r_nant,memory(ipo))
    endif
    call r4tor4 (memory(ipo),inbuf,t_ldatc)    ! save for averaging
    ipk = ipk + r_ldatc
    ipo = ipo + t_ldatc
    ! Line
    if (corr) then
      call r4tor4(memory(ipk),inbuf(t_ldatc+1),r_ldatl)
    else
      call amodel(r_lntch,r_nbas,memory(ipk),   &
        r_nant,inbuf(t_ldatc+1))
    endif
    ipk = ipk + r_ldatl
    ! Increment
    if (dh_dump.eq.ir) then
      call add_record (ndat,inbuf,outbuf)
    else
      write(chain,'(i6)') ir
      call message(1,1,'NEWFORMAT','rec. '//chain(1:lenc(chain))   &
        //' is bad')
    endif
  enddo
  ipo = ipo + r_ldpar
  call output_record (ndat, memory(ipo), outbuf, nout)
  ipo = ipo - r_ldpar
  call r4tor4 (dcomp_void, dh_void, m_dh)
  call encode_header (memory(ipo))
  if (corr) then
    r_lmode = 1
  else
    r_ldatc = t_ldatc
    r_ldatl = t_ldatl
    r_lmode = 2
  endif
  r_ldump = r_ldpar + r_ldatc  ! new record length
  nd = r_ldump*r_ndump+r_ldpar+r_ldatc+r_ldatl
  write(chain,'(i6)') r_xnum
  call message(1,1,'NEWFORMAT','obs. '//chain(1:lenc(chain))   &
    //' converted')
end subroutine sub_newformat
!
subroutine amodec(nl,nb,cin,na,rout)
  !---------------------------------------------------------------------
  ! convert from old data order for continuum, autocorrelations
  !
  !	NL       INTEGER     Number of channels
  !       NB       INTEGER     Number of baselines
  !       NA       INTEGER     Number of antennas
  !       CIN(2,NL,NB) COMPLEX Input pseudo-complex autocorrelation data
  !       ROUT(NL,NA)  REAL    Output autocorrelation data
  !---------------------------------------------------------------------
  integer :: nl                     !
  integer :: nb                     !
  complex :: cin(2, nl, nb)         !
  integer :: na                     !
  real :: rout(nl, na)              !
  ! Local
  integer :: iant(3), jant(3)
  integer :: ib, ic, ia, ja
  !
  data iant/1,1,2/, jant/2,3,3/
  !------------------------------------------------------------------------
  ! Code:
  do ia = 1, na
    do ic=1, nl
      rout(ic, ia) = 0
    enddo
  enddo
  do ib=1, nb
    ia = iant(ib)
    ja = jant(ib)
    do ic=1, nl
      if (ia.le.na .and. rout(ic,ia).eq.0)   &
        rout(ic,ia) = real(cin(1,ic,ib))
      if (ja.le.na .and. rout(ic,ja).eq.0)   &
        rout(ic,ja) = real(cin(2,ic,ib))
    enddo
  enddo
end subroutine amodec
!
subroutine amodel(nl,nb,cin,na,rout)
  !---------------------------------------------------------------------
  ! convert from old data order for line, autocorrelations
  !
  !	NL       INTEGER     Number of channels
  !       NB       INTEGER     Number of baselines
  !       NA       INTEGER     Number of antennas
  !       CIN(2,NL,NB) COMPLEX Input pseudo-complex autocorrelation data
  !       ROUT(NL,NA)  REAL    Output autocorrelation data
  !---------------------------------------------------------------------
  integer :: nl                     !
  integer :: nb                     !
  complex :: cin(nl, 2, nb)         !
  integer :: na                     !
  real :: rout(nl, na)              !
  ! Local
  integer :: iant(3), jant(3)
  integer :: ib, ic, ia, ja
  !
  data iant/1,1,2/, jant/2,3,3/
  !------------------------------------------------------------------------
  ! Code:
  do ia = 1, na
    do ic=1, nl
      rout(ic, ia) = 0
    enddo
  enddo
  do ib=1, nb
    ia = iant(ib)
    ja = jant(ib)
    do ic=1, nl
      if (ia.le.na .and. rout(ic,ia).eq.0)   &
        rout(ic,ia) = real(cin(ic,1,ib))
      if (ja.le.na .and. rout(ic,ja).eq.0)   &
        rout(ic,ja) = real(cin(ic,2,ib))
    enddo
  enddo
end subroutine amodel
!
subroutine cmodec(nl,nb,cin,cout)
  !---------------------------------------------------------------------
  ! convert from old data order for continuum, correlations
  !
  !	NL       INTEGER     Number of channels
  !       NB       INTEGER     Number of baselines
  !       CIN(2,NL,NB)  COMPLEX Input complex correlation data
  !       COUT(NL,2,NB) COMPLEX Output correlation data
  !---------------------------------------------------------------------
  integer :: nl                     !
  integer :: nb                     !
  complex :: cin(2,nl,nb)           !
  complex :: cout(nl,2,nb)          !
  ! Local
  integer :: ib, ic
  !------------------------------------------------------------------------
  ! Code:
  do ib=1, nb
    do ic=1, nl
      cout(ic,1,ib) = cin(1,ic,ib)
      cout(ic,2,ib) = cin(2,ic,ib)
    enddo
  enddo
end subroutine cmodec

subroutine greg_plot (line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_plot
  !---------------------------------------------------------------------
  ! @ private
  ! GREG
  ! Support for command PLOT
  !  [GREG2\]PLOT [Var_name]
  !     [/BLANKING Bval Eval Colour]
  !     [/SCALING Type Low_cut High_cut]
  !     [/POSITION Posx1 Posx2 Posy1 Posy2]
  !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
  !     [/VISIBLE]
  !
  ! Usage:
  !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
  ! is a 3-D sic variable are not yet allowed. This command is normally
  ! used in the following sequence:
  !
  !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
  !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
  !     LIMITS /RGDATA                    ! Get limits
  !     PLOT Var_name                     ! Plot the array in the box
  !     BOX
  !     RGMAP                             ! Draw contour levels (...)
  !
  ! Without argument, the RG variable is plotted
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call im_plot(line,error)
  if (error)  return
  !
end subroutine greg_plot
!
subroutine im_plot (line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces, no_interface1=>gtv_image,  &
                                    no_interface2=>gtv_rgbimage,  &
                                    no_interface3=>gr4_minmax
  use greg_interfaces, except_this=>im_plot
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG
  ! Support for command PLOT
  !  [GREG2\]PLOT [Var_name]
  !     [/BLANKING Bval Eval Colour]
  !     [/SCALING Type Low_cut High_cut]
  !     [/POSITION Posx1 Posx2 Posy1 Posy2]
  !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
  !     [/VISIBLE]
  !
  ! Usage:
  !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
  ! is a 3-D sic variable are not yet allowed. This command is normally
  ! used in the following sequence:
  !
  !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
  !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
  !     LIMITS /RGDATA                    ! Get limits
  !     PLOT Var_name                     ! Plot the array in the box
  !     BOX
  !     RGMAP                             ! Draw contour levels (...)
  !
  ! Without argument, the RG variable is plotted
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='PLOT'
  integer(kind=index_length) :: mx,my
  real(kind=4) :: locx1,locx2,locy1,locy2
  real(kind=4) :: wux1,wux2,wuy1,wuy2
  real(kind=4) ::  cuts(2), extrem(2)
  real(kind=4) :: rcuts(2),rextrem(2)
  real(kind=4) :: gcuts(2),gextrem(2)
  real(kind=4) :: bcuts(2),bextrem(2)
  real(kind=4) :: loca(4),limts(4),convrt(6)
  real(kind=4) :: blank(3),scaling_lup_b
  integer(kind=4) :: k,nc
  integer(kind=size_length) :: kmin,kmax,size
  logical :: found,is_image,has_extrema,is_visible,is_rgb
  character(len=32) :: var_name,ima_name
  type(sic_descriptor_t) :: desc,inca
  integer(kind=address_length) :: ipnta,ipntr,ipntg,ipntb,ipnt
  save inca  ! Is this SAVE attribute needed?
  integer(kind=4) :: iper
  integer(kind=4) :: scaling
  integer(kind=4), parameter :: nscale=4
  character(len=12) :: scale(nscale),chain,keyw
  ! Data
  data scale/'LINEAR','LOGARITHMIC','EQUALIZATION','LUPTON'/
  !
  ! Locate the variable
  var_name = 'RG'  ! Use "RG" variable as a default
  call sic_ke (line,0,1,var_name,nc,.false.,error)
  if (error) return
  !
  call plot_getvar(var_name,inca,error)
  if (error)  return
  is_rgb = inca%ndim.eq.3 .and. inca%dims(3).gt.1  ! 3 RGB planes
  if (is_rgb) then
    ipntr = gag_pointer(inca%addr,memory)
    ipntg = ipntr+inca%dims(1)*inca%dims(2)
    ipntb = ipntg+inca%dims(1)*inca%dims(2)
  else
    ipnt = gag_pointer(inca%addr,memory)
  endif
  mx = inca%dims(1)
  my = inca%dims(2)
  !
  k = index(var_name,'[')
  if (k.ne.0) then
    ! call gagout('W-PLOT,  Plotting a Sub-array')
    var_name(k:) = ' '
  endif
  !
  ! Check if it is an IMAGE, and load the associated extrema,
  ! blanking and pixel to user coordinates conversion if so.
  iper = lenc(var_name)+1
  ima_name = var_name
  ima_name(iper:) = '%CONVERT'
  is_image = .false.
  call sic_descriptor(ima_name,desc,is_image)
  !
  if (sic_present(4,0)) then
    !
    ! 4 /BOUNDARIES option indicates the User Limits
    call sic_r4 (line,4,1,wux1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,2,wux2,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,3,wuy1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,4,4,wuy2,.true.,error)
    if (error)  goto 100
  else
    wux1 = gux1
    wux2 = gux2
    wuy1 = guy1
    wuy2 = guy2
  endif
  !
  ! This is an image with everything...
  has_extrema = .false.
  if (is_image) then
    ! Conversion
    ipnta = gag_pointer(desc%addr,memory)
    call r8tor4(memory(ipnta),convrt,6)
    ! Blanking
    ima_name(iper:) = '%BLANK'
    call sic_descriptor(ima_name,desc,found)
    ipnta = gag_pointer(desc%addr,memory)
    call r4tor4(memory(ipnta),blank,2)
    ! Extrema
    ima_name(iper:) = '%EXTREMA'
    has_extrema = sic_varexist(ima_name)
    if (has_extrema) then
      ima_name(iper:) = '%MIN'
      call sic_get_real(ima_name,extrem(1),error)
      ima_name(iper:) = '%MAX'
      call sic_get_real(ima_name,extrem(2),error)
    endif
  elseif (var_name.eq.'RG') then
    ! RG variable also has some conversion formula
    convrt(1) = rg%xref
    convrt(2) = rg%xval
    convrt(3) = rg%xinc
    convrt(4) = rg%yref
    convrt(5) = rg%yval
    convrt(6) = rg%yinc
  else
    !
    ! Compute the user coordinate conversion assuming
    !     1) The image fits in the box
    !     2) It has the corresponding user limits
    !
    convrt(1) = 0.5
    convrt(2) = wux1
    convrt(3) = (wux2-wux1)/mx
    convrt(4) = 0.5
    convrt(5) = wuy1
    convrt(6) = (wuy2-wuy1)/my
  endif
  !
  ! If limits are overridden, change them
  if (sic_present(4,0)) then
    convrt(1) = 0.5
    convrt(2) = wux1
    convrt(3) = (wux2-wux1)/mx
    convrt(4) = 0.5
    convrt(5) = wuy1
    convrt(6) = (wuy2-wuy1)/my
  endif
  !
  limts(1) = gux1
  limts(2) = gux2
  limts(3) = guy1
  limts(4) = guy2             ! It was the WUXi before ...
  !
  ! Option 1 /BLANKING
  if (sic_present(1,0)) then
    call sic_r4 (line,1,1,blank(1),.true.,error)
    if (error)  goto 100
    call sic_r4 (line,1,2,blank(2),.true.,error)
    if (error)  goto 100
    blank(3) = -1.0            ! Use Background Colour
    call sic_r4 (line,1,3,blank(3),.false.,error)
    if (error)  goto 100
  elseif (.not.is_image) then
    ! Use GreG blanking as a default
    blank(1) = cblank
    blank(2) = eblank
  endif
  !
  ! Compute the extrema
  if (is_rgb) then
    ! Ignore RG%MIN/MAX, compute extrema for each plane
    size = mx*my
    call gr4_minmax(size,memory(ipntr),blank(1),blank(2),rextrem(1),rextrem(2),  &
      kmin,kmax)
    call gr4_minmax(size,memory(ipntg),blank(1),blank(2),gextrem(1),gextrem(2),  &
      kmin,kmax)
    call gr4_minmax(size,memory(ipntb),blank(1),blank(2),bextrem(1),bextrem(2),  &
      kmin,kmax)
  else
    ! Get extrema from RG%MIN/MAX, else compute them
    if (.not.has_extrema) then
      if (var_name.eq.'RG') then
        call rgextr(0,extrem(1),extrem(2),rg%data,blank(1),blank(2),.false.)
      else
        call gr4_minmax (inca%size,memory(ipnt),blank(1),blank(2),  &
          extrem(1),extrem(2),kmin,kmax)
      endif
    endif
  endif
  !
  ! 2 /SCALING
  chain = 'LINEAR'  ! Default
  call sic_ke (line,2,1,chain,nc,.false.,error)
  if (error)  goto 100
  call sic_ambigs(rname,chain,keyw,scaling,scale,nscale,error)
  if (error)  goto 100
  !
  if (is_rgb) then
    ! RGB image (3 planes)
    rcuts = rextrem
    gcuts = gextrem
    bcuts = bextrem
    if (scaling.eq.4) then
      ! Lupton mode, retrieve beta factor
      scaling_lup_b = 3.0  ! Default
      call sic_r4(line,2,2,scaling_lup_b,.false.,error)
      if (error)  goto 100
    else
      ! Other modes, can override the default cuts
      call sic_r4(line,2,2,rcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,3,rcuts(2),.false.,error)
      if (error)  goto 100
      !
      call sic_r4(line,2,4,gcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,5,gcuts(2),.false.,error)
      if (error)  goto 100
      !
      call sic_r4(line,2,6,bcuts(1),.false.,error)
      if (error)  goto 100
      call sic_r4(line,2,7,bcuts(2),.false.,error)
      if (error)  goto 100
    endif
  else
    ! RG image (single plane)
    if (scaling.eq.4) then
      call greg_message(seve%e,rname,'LUPTON scaling valid only for RGB images')
      error = .true.
      return
    endif
    cuts = extrem
    call sic_r4 (line,2,2,cuts(1),.false.,error)
    if (error)  goto 100
    call sic_r4 (line,2,3,cuts(2),.false.,error)
    if (error)  goto 100
  endif
  !
  ! Setup the characteristics
  !
  ! Now setup the characteristics of the plotting area
  ! 3 /POSITION
  if (sic_present(3,0)) then
    call sic_r4 (line,3,1,locx1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,2,locx2,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,3,locy1,.true.,error)
    if (error)  goto 100
    call sic_r4 (line,3,4,locy2,.true.,error)
    if (error)  goto 100
  else
    ! Use GreG Box location
    locx1 = gx1
    locx2 = gx2
    locy1 = gy1
    locy2 = gy2
  endif
  loca(1) = locx1
  loca(2) = locx2
  loca(3) = locy1
  loca(4) = locy2
  !
  ! /VISIBLE
  is_visible = .not.sic_present(5,0)
  !
  ! Create the image segment
  call gr_segm(var_name,error)
  if (error) then
    call greg_message(seve%e,rname,'Could not create image segment')
    goto 100
  endif
  !
  ! Create the image descriptor in GTVIRT
  if (is_rgb) then
    ! RGB image
    call gtv_rgbimage(                    &
      mx,my,                              &  ! Size of planes
      memory(ipntr),blank,rcuts,rextrem,  &  ! R plane description
      memory(ipntg),blank,gcuts,gextrem,  &  ! G plane description
      memory(ipntb),blank,bcuts,bextrem,  &  ! B plane description
      scaling,scaling_lup_b,              &  ! RGB planes scaling mode
      loca,                               &  ! Position in Paper coordinates
      limts,                              &  ! User limits
      convrt,                             &  ! Image pixel to User conversion formula
      is_visible,                         &  ! Always Visible ?
      error)
  else
    ! RG image
    call gtv_image(        &
      mx,my,memory(ipnt),  &  ! Data
      loca,                &  ! Position in Paper coordinates
      limts,               &  ! User limits
      convrt,              &  ! Image pixel to User conversion formula
      scaling,             &  ! Scaling mode (1=Lin, 2=Log, 3=Equ)
      cuts,                &  ! Low and High cuts
      extrem,              &  ! Low and High extrema
      blank,               &  ! Blanking value
      is_visible,          &  ! Always Visible ?
      .true.,              &  ! Update the SIC structure CURIMA%
      error)
  endif
  ! if (error) do nothing: we have to close this (empty) segment
  !
  ! Close the image segment
  call gtsegm_close(error)
  if (error)  goto 100
  !
100 continue
  call sic_volatile(inca)  ! Free the image incarnation
  !
end subroutine im_plot
!
subroutine plot_getvar(name,inca,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>plot_getvar
  !---------------------------------------------------------------------
  ! @ private
  ! Check if the variable is something you can plot
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: name   ! Variable name
  type(sic_descriptor_t), intent(out)   :: inca   ! REAL*4 incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PLOT'
  type(sic_descriptor_t) :: desc
  logical :: found
  integer(kind=size_length) :: size
  integer(kind=4) :: i
  !
  call sic_descriptor(name,desc,found)
  if (.not.found) then
    call greg_message(seve%e,rname,'Variable '//trim(name)//' does not exist')
    error = .true.
    return
  endif
  !
  if (desc%ndim.eq.1) then
    call greg_message(seve%e,rname,'Variable '//trim(name)//' is 1-D only')
    error = .true.
    return
    !
! elseif (desc%ndim.eq.2) then
!   2-D RG plot: ok
  elseif (desc%ndim.eq.3) then
    ! 3th dimension == 1: ok (2D single plane RG plot)
    ! 3th dimension == 3: ok (2D 3 planes RGB plot)
    if (desc%dims(3).ne.1 .and. desc%dims(3).ne.3) then
      call greg_message(seve%e,rname,  &
        '3rd dimension must be 1 (single plane) or 3 (3 RGB planes)')
      error = .true.
      return
    endif
  elseif (desc%ndim.ge.4) then
    ! Check if the 4th and more dimensions are degenerated
    size = 1
    do i=desc%ndim,4,-1
      size = size*desc%dims(i)
    enddo
    if (size.gt.1) then
      call greg_message(seve%e,rname,'Variable '//trim(name)//' is 4-D or more')
      error = .true.
      return
    endif
  endif
  !
  !
  ! Incarnate it in REAL*4
  call sic_incarnate(fmt_r4,desc,inca,error)
  if (error) return
  !
end subroutine plot_getvar

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_standard_arg
  use cubetools_parameters
  use cubetools_primitive_arg
  use cubetools_structure_main
  !
  public :: standard_arg_t
  private
  !
  type, extends(primitive_arg_t) :: standard_arg_t
     ! No element to add
  contains
     procedure :: register => cubetools_register_standard_arg
  end type standard_arg_t
  !
contains
  !
  subroutine cubetools_register_standard_arg(template,name,abstract,help,mandat,error)
    !----------------------------------------------------------------------
    ! Register an argument of exact type standard_arg_t in the global 'pack'
    !----------------------------------------------------------------------
    class(standard_arg_t), intent(in)    :: template
    character(len=*),      intent(in)    :: name
    character(len=*),      intent(in)    :: abstract
    character(len=*),      intent(in)    :: help
    integer(kind=code_k),  intent(in)    :: mandat
    logical,               intent(inout) :: error
    !
    class(primitive_arg_t), pointer :: parg
    !
    call cubetools_register_primitive_arg(template,name,abstract,help,mandat,parg,error)
    if (error) return
  end subroutine cubetools_register_standard_arg

end module cubetools_standard_arg

module gsys_interfaces_none
  interface
    subroutine cdclose(ierror,lun)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
    end subroutine cdclose
  end interface
  !
  interface
    subroutine cddir(ierror,lun,s_dir,lines)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_dir                 !
      integer(kind=4) :: lines                  !
    end subroutine cddir
  end interface
  !
  interface
    subroutine cdfclose(ierror,fid)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: fid                    !
    end subroutine cdfclose
  end interface
  !
  interface
    subroutine cdfopen(ierror,lun,s_file,fid,recl,bytes)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_file                !
      integer(kind=4) :: fid                    !
      integer(kind=4) :: recl                   !
      integer(kind=4) :: bytes                  !
    end subroutine cdfopen
  end interface
  !
  interface
    subroutine cdfread(ierror,fid,startbyte,numbytes,array)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: fid                    !
      integer(kind=4) :: startbyte              !
      integer(kind=4) :: numbytes               !
      integer(kind=1) :: array(0:*)             !
    end subroutine cdfread
  end interface
  !
  interface
    subroutine cdgetblock(ierror,lun,block,array)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: block                  !
      integer(kind=1) :: array(0:511)           !
    end subroutine cdgetblock
  end interface
  !
  interface
    subroutine cdgetdir(ierror,lun,block,att,lines)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: block                  !
      integer(kind=4) :: att                    !
      integer(kind=4) :: lines                  !
    end subroutine cdgetdir
  end interface
  !
  interface
    subroutine cdgetdirline(ierror,lun,lineno,linebytes,linelen)
      integer(kind=4) :: ierror                  !
      integer(kind=4) :: lun                     !
      integer(kind=4) :: lineno                  !
      integer(kind=1) :: linebytes(0:*)          !
      integer(kind=4) :: linelen                 !
    end subroutine cdgetdirline
  end interface
  !
  interface
    subroutine cdgetlbs(ierror,lun,lbs,rootbeg,rootatt)
      integer(kind=4) :: ierror                 !Error flag
      integer(kind=4) :: lun                    !Logical unit number
      integer(kind=4) :: lbs                    !Logical block size
      integer(kind=4) :: rootbeg                !Starting block of root
      integer(kind=4) :: rootatt                !Attribute blocks in root
    end subroutine cdgetlbs
  end interface
  !
  interface
    subroutine cdgetlun(ierror,lun,lindex)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      integer(kind=4) :: lindex                 !
    end subroutine cdgetlun
  end interface
  !
  interface
    subroutine cdopen(ierror,lun,s_name)
      integer(kind=4) :: ierror                 !
      integer(kind=4) :: lun                    !
      character(len=*) :: s_name                !
    end subroutine cdopen
  end interface
  !
  interface
    subroutine smvb(from,length,to)
      integer(kind=1) :: from(*)                !
      integer(kind=4) :: length                 !
      integer(kind=1) :: to(*)                  !
    end subroutine smvb
  end interface
  !
#if defined(CYGWIN) || defined(MINGW)
  interface
    subroutine gbl_message_mp_seve
    end subroutine gbl_message_mp_seve
  end interface
  !
#endif
end module gsys_interfaces_none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_import
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubedag_parameters
  use cubedag_link_type
  use cubedag_node_class
  use cubedag_dag_buffer
  use cubeadm_messaging
  use cubedag_directory_type
  !
  type(cubedag_link_t) :: im  ! List of imported cubes
  type(cubedag_link_t) :: tw  ! List of current twins
  !
  public :: import
  private
  !
  type :: import_comm_t
     type(option_t),      pointer :: comm
     type(option_t),      pointer :: hdu
     type(option_t),      pointer :: mapping
     type(option_t),      pointer :: class
     type(option_t),      pointer :: optparse
     type(option_t),      pointer :: sort
     type(keywordlist_comm_t), pointer :: sort_arg
     type(option_t),      pointer :: verbose
  contains
     procedure, public  :: register => cubeadm_import_register
     procedure, private :: parse    => cubeadm_import_parse
     procedure, private :: main     => cubeadm_import_main
  end type import_comm_t
  type(import_comm_t) :: import
  !
  integer(kind=4), parameter :: fits_primary_hdu=1
  !
  integer(kind=code_k), parameter :: sort_none=1
  integer(kind=code_k), parameter :: sort_chro=2
  integer(kind=code_k), parameter :: sort_alph=3
  integer(kind=4), parameter :: nsort=3
  character(len=*), parameter :: sort_names(nsort) = &
    (/ 'NONE         ','CHRONOLOGICAL','ALPHABETICAL ' /)
  !
  type import_user_t
     character(len=file_l), allocatable :: argum(:)
     character(len=8)  :: hdu       = strg_star
     logical           :: domapping = .false.
     logical           :: doclass   = .false.
     logical           :: doparse   = .false.
     character(len=1)  :: parse_sep = '-'
     character(len=24) :: sort      = strg_star
     logical           :: doverbose = .false.
  contains
     procedure, private :: toprog => cubeadm_import_user_toprog
  end type import_user_t
  !
  type import_prog_t
    character(len=commandline_length)  :: line      ! Full command line to be inserted in history
    character(len=file_l), allocatable :: argum(:)  ! Arguments to be imported
    integer(kind=4)      :: seve       ! Severity of /VERBOSE messages
    logical              :: allhdus    ! Import all HDUs?
    integer(kind=4)      :: onehdu     ! If not all HDUs, which one?
    logical              :: domapping
    logical              :: doclass
    logical              :: doparse    ! /PARSE enabled?
    character(len=1)     :: parse_sep  ! /PARSE separator if option is enabled
    integer(kind=code_k) :: sort
  contains
    procedure, private :: act       => cubeadm_import_act
    procedure, private :: argument  => cubeadm_import_argument
    procedure, private :: pattern   => cubeadm_import_pattern
    procedure, private :: directory => cubeadm_import_directory
    procedure, private :: file      => cubeadm_import_onefile
    procedure, private :: cube      => cubeadm_import_onecube
  end type import_prog_t
  !
contains
  !
  subroutine cubeadm_import_register(import,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(import_comm_t), intent(inout) :: import
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='IMPORT>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'IMPORT','[Directory|FilePattern]',&
         'Import files into the DAG',&
         'Import GDF/FITS files into the DAG from either explicit file or directory targets. &
         & Without argument, it imports the GDF/FITS files from the default raw directory &
         & defined by the DIRECTORY /RAW command (default is ./raw).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Each argument is resolved as a file or directory pattern.'//strg_cr//&
         '- Name or extension metadata can be used during import, but header&
         & metadata takes precedence when present.'//strg_cr//&
         '- Unsupported files and already-imported entries are skipped.'//strg_bl//&
         'Additional outputs:'//strg_cr//&
         '- The /VERBOSE key reports the number of imported or skipped files.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- /MAPPING and /CLASS are mutually exclusive.'//strg_cr//&
         '- A single call can import multiple file or directory targets.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> IMPORT'//strg_cr//&
         '  CUBE> IMPORT mydir'//strg_cr//&
         '  CUBE> IMPORT mydir/*.fits'//strg_cr//&
         '  CUBE> IMPORT mydir/*.fits /HDU *'//strg_cr//&
         '  CUBE> IMPORT file1.fits file2.fits'//strg_cr//&
         'Using file patterns is also possible when invoking CUBE from the shell, e.g.'//strg_cr//&
         '  shell-prompt> cube import *',&
         cubeadm_import_command,&
         import%comm,error)
    if (error) return
    call stdarg%register( &
         'Target',  &
         'Import targets: a list of directory or file patterns', &
         strg_emp,&
         code_arg_unlimited, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'HDU','Number',&
         'Specify the FITS HDU to be imported',&
         'Use * to import all possible images or cubes. Default is 1 (Primary HDU only).',&
         import%hdu,error)
    if (error) return
    call stdarg%register( &
         'HDU Number',  &
         'FITS HDU number', &
         'Default is 1 (Primary).',&
         code_arg_optional, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'MAPPING','',&
         'Import MAPPING files and set cube flags based on the file extension',&
         'This option is ignored if the file header provides its own flags.',&
         import%mapping,error)
    if (error) return
    !
    call cubetools_register_option(&
         'CLASS','',&
         'Import CLASS files and set cube flags based on the file extension',&
         'This option is ignored if the file header provides its own flags.',&
         import%class,error)
    if (error) return
    !
    call cubetools_register_option(&
         'PARSE','Separator',&
         'Split the file basename into family and flags',&
         'The computed flags are ignored if the file header provides its own '//&
         'flags. Without this option, the whole basename is used as family name.',&
         import%optparse,error)
    if (error) return
    call stdarg%register( &
         'Separator',  &
         'Single character separator in file basename', &
         'Default is "-".',&
         code_arg_optional, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SORT','Mode',&
         'Specify the sorting order of imported files',&
         'Without this option, sorting is done in chronological order.',&
         import%sort,error)
    if (error) return
    call keyarg%register( &
         'Mode',  &
         'Sorting mode', &
         strg_emp,&
         code_arg_mandatory, &
         sort_names, &
         .not.flexible, &
         import%sort_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VERBOSE','',&
         'Indicate which files are imported or skipped',&
         strg_emp,&
         import%verbose,error)
    if (error) return
  end subroutine cubeadm_import_register
  !
  subroutine cubeadm_import_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(import_user_t) :: user
    character(len=*), parameter :: rname='IMPORT>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'welcome')
    !
    call import%parse(line,user,error)
    if (error) return
    call import%main(user,line,error)
    if (error) return
  end subroutine cubeadm_import_command
  !
  subroutine cubeadm_import_parse(comm,line,user,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Support routine for command:
    !   IMPORT
    !   IMPORT Directory
    !   IMPORT Pattern
    !---------------------------------------------------------------------
    class(import_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(import_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: narg,iarg,ier
    logical :: dosort
    character(len=*), parameter :: rname='IMPORT>COMMAND'
    !
    ! Command arguments
    narg = import%comm%getnarg()  ! Can be 0 = no argument
    allocate(user%argum(narg),stat=ier)
    if (failed_allocate(rname,'arguments',ier,error)) return
    do iarg=1,narg
      call cubetools_getarg(line,import%comm,iarg,user%argum(iarg),mandatory,error)
      if (error) return
    enddo
    !
    ! /HDU
    call cubetools_getarg(line,import%hdu,1,user%hdu,.not.mandatory,error)
    if (error)  return
    !
    ! /MAPPING or /CLASS
    call import%mapping%present(line,user%domapping,error)
    if (error) return
    call import%class%present(line,user%doclass,error)
    if (error) return
    if (user%domapping.and.user%doclass) then
       call cubeadm_message(seve%e,rname,'Options /MAPPING and /CLASS conflict with each other')
       error = .true.
       return
    endif
    !
    ! /VERBOSE
    call import%verbose%present(line,user%doverbose,error)
    if (error) return
    !
    ! /PARSE
    call import%optparse%present(line,user%doparse,error)
    if (error) return
    if (user%doparse) then
      call cubetools_getarg(line,import%optparse,1,user%parse_sep,.not.mandatory,error)
      if (error)  return
    endif
    !
    ! /SORT
    call import%sort%present(line,dosort,error)
    if (error) return
    if (dosort) then
      call cubetools_getarg(line,import%sort,1,user%sort,mandatory,error)
      if (error) return
    else
      user%sort = strg_star
    endif
  end subroutine cubeadm_import_parse
  !
  subroutine cubeadm_import_main(import,user,line,error)
    !----------------------------------------------------------------------
    ! Import all arguments passed to the command, create CX, and terminate
    ! command.
    !----------------------------------------------------------------------
    class(import_comm_t), intent(in)    :: import
    type(import_user_t),  intent(in)    :: user
    character(len=*),     intent(in)    :: line
    logical,              intent(inout) :: error
    !
    type(import_prog_t) :: prog
    character(len=*), parameter :: rname='IMPORT>MAIN'
    !
    call user%toprog(line,prog,error)
    if (error)  return
    call prog%act(error)
    if (error)  return
  end subroutine cubeadm_import_main
  !
  subroutine cubeadm_import_act(prog,error)
    use cubedag_find_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    logical :: do_cx
    integer(kind=4) :: iarg
    type(dag_find_t) :: criter
    character(len=*), parameter :: rname='IMPORT>MAIN'
    !
    do_cx = .false.
    !
    do iarg=1,size(prog%argum)
      call prog%argument(prog%argum(iarg),do_cx,error)
      if (error)  return
    enddo
    !
    if (do_cx) then
      ! Implicitly FIND everything in current index
      call criter%ix2cx(error)
      if (error) return
    endif
    !
    ! Insert in history
    call cubeadm_imported_flush_nodes(prog%line,error)
    if (error)  return
  end subroutine cubeadm_import_act
  !
  subroutine cubeadm_import_user_toprog(user,line,prog,error)
    use gkernel_interfaces
    use cubetools_string
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(import_user_t), intent(in)    :: user
    character(len=*),     intent(in)    :: line
    type(import_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: iarg,narg,ier
    character(len=argu_l) :: key
    character(len=*), parameter :: rname='IMPORT>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%line = line
    !
    ! Command arguments
    if (size(user%argum).le.0) then
      ! No argument provided: import from dir%raw
      call cubetools_string_split(dir%raw,';',prog%argum,error)
      if (error)  return
    else
      ! Fetch user arguments
      narg = size(user%argum)
      allocate(prog%argum(narg),stat=ier)
      if (failed_allocate(rname,'arguments',ier,error)) return
      do iarg=1,narg
        prog%argum(iarg) = user%argum(iarg)
      enddo
    endif
    !
    if (user%doverbose) then
      prog%seve = seve%i
    else
      prog%seve = seve%d
    endif
    !
    prog%allhdus = user%hdu.eq.strg_star
    if (prog%allhdus) then
      prog%onehdu = 0  ! Unused
    else
      read(user%hdu,*) prog%onehdu
    endif
    !
    prog%domapping = user%domapping
    prog%doclass   = user%doclass
    prog%doparse   = user%doparse
    prog%parse_sep = user%parse_sep
    !
    if (user%sort.eq.strg_star) then
      prog%sort = sort_chro
    else
      call cubetools_keywordlist_user2prog(import%sort_arg,user%sort,prog%sort,key,error)
      if (error) return
    endif
  end subroutine cubeadm_import_user_toprog
  !
  subroutine cubeadm_import_argument(prog,argum,do_cx,error)
    use gkernel_interfaces
    use cubetools_setup_types
    !----------------------------------------------------------------------
    ! Process 1 argument passed to the command
    !----------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: argum
    logical,              intent(inout) :: do_cx
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nc
    logical :: skipped
    type(cube_setup_api_t) :: setup
    integer(kind=code_k) :: default_index
    character(len=*), parameter :: rname='IMPORT>ARGUMENT'
    !
    call cubeadm_message(admseve%trace,rname,'welcome')
    !
    nc = len_trim(argum)
    call setup%index%default%get(default_index)
    if (gag_isdir(argum(1:nc)).eq.0) then
       ! A directory
       do_cx = default_index.eq.code_index_current
       call prog%directory(argum,nc,error)
    elseif (gag_inquire(argum,nc).eq.0) then
       ! A file. Note it can contain unfriendly characters (space, parentheses, etc).
       do_cx = default_index.eq.code_index_current
       call prog%file(argum,skipped,error)
    elseif (gag_exists(argum(1:nc))) then
       ! Try a pattern. Unfriendly characters badly supported.
       do_cx = default_index.eq.code_index_current
       call prog%pattern(argum,error)
    else
       ! Resolves as nothing in the shell!
       call cubeadm_message(seve%w,rname,'No such file or directory '''//argum(1:nc)//'''')
    endif
    if (error) return
  end subroutine cubeadm_import_argument
  !
  function gag_exists(pattern)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Return .true. if the pattern resolves as some file(s) or
    ! directory(ies) resolved by the shell.
    !-------------------------------------------------------------------
    logical :: gag_exists
    character(len=*), intent(in) :: pattern
    !
    integer(kind=4) :: nfile
    character(len=file_l), allocatable :: filelist(:)
    logical :: error
    !
    gag_exists = .false.
    !
    ! No better way to invoke a subroutine which translates the
    ! shell-dependant syntax (e.g. *, ?, ... for bash). The pattern
    ! is passed "as is":
    !  - exact directory name            => return the same exact name (not its contents)
    !  - exact file name                 => return the same exact name
    !  - wilcarded directory name        => return the expanded directory name (not its contents)
    !  - wilcarded file      name        => return the expanded file name
    !  - exact but non-existent name     => return empty list
    !  - wilcarded but non-existent name => return empty list
    ! (wilcarded combinations on existing material are possible).
    !
    error = .false.
    call gag_directory('.',pattern,filelist,nfile,error)
    if (error) return
    gag_exists = nfile.gt.0
  end function gag_exists
  !
  subroutine cubeadm_import_directory(prog,dirname,nc,error)
    !---------------------------------------------------------------------
    ! Import *.* files from a directory into the DAG
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: dirname
    integer(kind=4),      intent(in)    :: nc
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='IMPORT>DIRECTORY'
    !
    if (dirname(nc:nc).eq.'/') then
      call prog%pattern(dirname(1:nc)//'*.*',error)
    else
      call prog%pattern(dirname(1:nc)//'/*.*',error)
    endif
    if (error) return
  end subroutine cubeadm_import_directory
  !
  recursive subroutine cubeadm_import_pattern(prog,pattern,error)
    use gkernel_types
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Import files given a pattern into the DAG
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: pattern
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nfile,ifile,nimported,nskipped,nc,myseve
    logical :: skipped
    character(len=file_l), allocatable :: filelist(:)
    character(len=mess_l) :: mess
    type(time_t) :: time
    character(len=*), parameter :: rname='IMPORT>PATTERN'
    !
    ! Get the file names and sorting array
    call gag_directory('.',trim(pattern),filelist,nfile,error)
    if (error) return
    call cubeadm_import_sort(filelist,nfile,prog%sort,error)
    if (error)  return
    !
    call gtime_init(time,nfile,error)
    if (error) return
    !
    ! Import the GDF and FITS files in the DAG
    nimported = 0
    nskipped = 0
    do ifile=1,nfile
      call gtime_current(time)
      nc = len_trim(filelist(ifile))
      if (gag_isdir(filelist(ifile)(1:nc)).eq.0) then
        ! This is a directory. NB: this is not precisely a recursion
        ! as cubeadm_import_directory imports "somedir/*.*"
        call cubeadm_message(prog%seve,rname,'Importing directory '//filelist(ifile)(1:nc))
        call prog%directory(filelist(ifile),nc,error)
        if (error) error = .false.  ! Skip errors indexing file
      else
        ! This is not a directory (regular file...)
        call prog%file(filelist(ifile),skipped,error)
        if (error) error = .false.  ! Skip errors indexing file
        if (skipped) then ! Duplicate or not supported kind
          nskipped = nskipped+1
        else
          nimported = nimported+1
        endif
      endif
    enddo
    deallocate(filelist)
    !
    write(mess,'(I0,A,A)')  nimported,' new file(s) imported from ',trim(pattern)
    if (nimported.le.0) then
      myseve = seve%w
    else
      myseve = seve%i
    endif
    if (nskipped.gt.0)  &
      write(mess,'(A,A,I0,A)')  trim(mess),', skipped ',nskipped,' file(s)'
    call cubeadm_message(myseve,rname,mess)
  end subroutine cubeadm_import_pattern
  !
  subroutine cubeadm_import_sort(filelist,nfile,sortmode,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Sort the file-list in-place according to sorting mode
    !-------------------------------------------------------------------
    integer(kind=4),      intent(in)    :: nfile
    character(len=*),     intent(inout) :: filelist(nfile)
    integer(kind=code_k), intent(in)    :: sortmode
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: ifile,ier,nc
    integer(kind=4), allocatable :: sort(:)
    character(len=file_l), allocatable :: tmp(:)
    integer(kind=8), allocatable :: mtime(:)
    character(len=*), parameter :: rname='IMPORT>GETSORT'
    !
    nc = len(filelist(1))
    !
    select case (sortmode)
    case (sort_none)
      return
      !
    case (sort_chro)
      ! Get the file dates
      allocate(mtime(nfile))
      do ifile=1,nfile
        ier = gag_mtime(filelist(ifile),mtime(ifile))
        if (ier.ne.0) then
          call cubeadm_message(seve%w,rname,'Error evaluating date of file '//filelist(ifile))
          mtime(ifile) = 0
        endif
      enddo
      ! Compute sorting array
      allocate(sort(nfile))
      call gi8_trie(mtime,sort,nfile,error)
      if (error)  return
      deallocate(mtime)
      ! Sort the character array
      allocate(tmp(nfile))
      call gch_sort(filelist,tmp,sort,nc,nfile)
      deallocate(sort,tmp)
      !
    case (sort_alph)
      allocate(sort(nfile))
      call gch_trie(filelist,sort,nfile,nc,error)
      if (error)  return
      deallocate(sort)
    end select
  end subroutine cubeadm_import_sort
  !
  subroutine cubeadm_import_onefile(prog,filename,skipped,error)
    use gkernel_interfaces
    use cubefitsio_header
    !-------------------------------------------------------------------
    ! Try to import the named file
    !-------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: filename
    logical,              intent(out)   :: skipped
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: nc,filekind,ihdu,fhdu,lhdu
    logical :: done
    character(len=*), parameter :: rname='IMPORT>ONEFILE'
    !
    nc = len_trim(filename)
    !
    call gag_file_guess(rname,filename,filekind,error)
    if (error) error = .false.  ! Skip errors indexing file
    !
    if (filekind.ne.1 .and. filekind.ne.2) then
      call cubeadm_message(prog%seve,rname,  &
        'Skipping non-GDF/non-FITS file '//filename(1:nc))
      skipped = .true.
      return
    endif
    !
    ! Which HDU range?
    if (prog%allhdus) then
      select case (filekind)
      case (1)  ! GDF
        fhdu = 1
        lhdu = 1
      case (2)  ! FITS
        fhdu = 1
        call cubefitsio_file_nhdu(filename,lhdu,error)
        if (error) then
          error = .false.
          skipped = .true.
          return
        endif
      end select
    else
      fhdu = prog%onehdu
      lhdu = prog%onehdu
    endif
    !
    ! Loop on HDUs
    done = .false.
    do ihdu=fhdu,lhdu
      call prog%cube(filename(1:nc),ihdu,skipped,error)
      if (error) then
        error = .false.
        cycle
      endif
      if (.not.skipped)  done = .true.
    enddo
    if (done) then  ! At least 1 HDU imported
      skipped = .false.
      call cubeadm_imported_flush_twins(error)
      if (error)  return
    endif
  end subroutine cubeadm_import_onefile
  !
  subroutine cubeadm_import_onecube(prog,filename,ihdu,skipped,error)
    use cube_types
    use cubetools_flag_types
    use cubedag_allflags
    use cubedag_tuple
    use cubeio_file
    use cubetuple_format_class
    use cubeformats_uv
    use cubeformats_engine_types
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(import_prog_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: filename
    integer(kind=4),      intent(in)    :: ihdu
    logical,              intent(out)   :: skipped
    logical,              intent(inout) :: error
    !
    character(len=base_l) :: family,cubeid
    character(len=file_l) :: fullname
    type(flag_t), allocatable :: flags(:)
    integer(kind=code_k) :: code_ftype
    type(cubeio_file_t), pointer :: file
    type(cube_t), pointer :: cube
    class(format_t), pointer :: fo
    class(cubedag_node_object_t), pointer :: dno
    character(len=*), parameter :: rname='IMPORT>ONECUBE'
    !
    write(fullname,'(2a,i0,a)')  trim(filename),'[',ihdu,']'
    skipped = .true.
    !
    if (cubedag_dag_contains(filename,ihdu)) then
      call cubeadm_message(prog%seve,rname,'Skipping cube already in DAG '//fullname)
      return
    endif
    !
    ! A word on flags associated to the imported cube. They can have
    ! several origins:
    ! 1a - Reading the file header (CUBE writes FITS with dedicated
    !      keywords for flags). It has precedence if available.
    ! 1b - Still in case of FITS, if the dedicated keywords are not
    !      found, the flags based on the HDU kind and name are used.
    ! 2a - Parsing the file base name (IMPORT /PARSE) for symetry with
    !      EXPORT,
    ! 2b - Parsing the file extention (IMPORT /MAPPING|/CLASS);
    !      2a can be combined with 2b,
    ! 4 -  Some default flag as fallback.
    !
    call cubeadm_import_default_familyflags(prog,filename,family,flags,cubeid,error)
    if (error)  return
    !
    file => file_allocate_new(error)
    if (error) return
    call file%read_header(filename,ihdu,cubeid,error)
    if (error) then
      call file%free(error)
      deallocate(file)
      return
    endif
    !
    cube => null()
    if (file%is_cube()) then
      code_ftype = code_ftype_cube
      cube => cubeformats_cube_allocate(cubset,error)
      if (error) return
      fo => cube
    elseif (file%is_uvt()) then
      code_ftype = code_ftype_uv
      fo => cubeformats_uv_allocate(cubset,error)
      if (error) return
    else
      ! Clean before skipping
      call cubeadm_message(prog%seve,rname,'Skipping non-cube/non-UVT file '//fullname)
      call file%close(error)
      call file%free(error)
      deallocate(file)
      return
    endif
    call fo%attach_file(file,error)
    if (error) return
    call fo%default_iorder(error)
    if (error)  return
    !
    ! Fix the header, if relevant
    if (associated(cube)) then
      call cube%default_order(error)
      if (error)  return
    endif
    !
    ! Attach a new cube to the DAG and set its attributes
    dno => fo
    call cubedag_dag_newbranch(dno,code_ftype,error)
    if (error) return
    call dno%set_value('ORIGIN',code_origin_imported,error)
    if (error) return
    call cubeadm_import_actual_family(prog,family,fo,error)
    if (error) return
    call cubeadm_import_actual_flags(prog,flags,fo,error)
    if (error) return
    !
    call cubeadm_imported_add_node(dno)  ! Fill list of all cubes imported
    call cubeadm_imported_add_twin(dno)  ! Fill list of current twins imported
    !
    ! Cleaning
    !
    ! GIO slots: we could wait to go through the cubeadm_finish_all at the end
    ! of the command execution, but IMPORT can open hundreds of cubes, and
    ! GIO slots are more limited than this. We have to avoid accumulating
    ! them.
    ! This also includes insertion in DAG
    call fo%finish(error)
    if (error) return
    !
    ! Feedback (after insertion in DAG)
    call fo%node%tuple%location(fo%iorder(),code_buffer_disk,fullname)
    call cubeadm_message(prog%seve,rname,'Importing file '//fullname)
    skipped = .false.
  end subroutine cubeadm_import_onecube
  !
  subroutine cubeadm_import_default_familyflags(prog,filename,  &
    family,flags,cubeid,error)
    use gkernel_interfaces
    use cubetools_flag_types
    use cubedag_allflags
    use cubetools_cubeid_types
    !-------------------------------------------------------------------
    ! Create the default family, flags, and cubeid based on file name
    ! and parsing option.
    ! Note that this might not be the final family and flags attached to
    ! the cube, since the file header might provide its own ones.
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    character(len=*),    intent(in)    :: filename
    character(len=*),    intent(out)   :: family
    type(flag_t),        allocatable   :: flags(:)
    character(len=*),    intent(out)   :: cubeid
    logical,             intent(inout) :: error
    !
    character(len=base_l) :: filebase
    character(len=exte_l) :: fileext
    type(flag_t), allocatable :: baseflags(:),extflags(:)
    type(flag_t) :: noflag(0)
    integer(kind=4) :: pos
    !
    call sic_parse_name(filename,filebase,fileext)
    !
    ! Flags from the basename
    if (prog%doparse) then
      pos = index(filebase,prog%parse_sep)
      if (pos.gt.0) then
        call cubetools_string_toflaglist(filebase(pos+1:),.true.,baseflags, &
             error,sep=prog%parse_sep)
        if (error)  return
        filebase(pos:) = ''  ! Drop the parsed flags
      else
        ! filebase unchanged
        ! baseflags remains unallocated
      endif
    endif
    family = filebase
    !
    ! Flags from the extension
    if (prog%domapping) then
       call cubetools_mapping_ext2flag(fileext,extflags,error)
       if (error) return
    else if (prog%doclass) then
       call cubetools_class_ext2flag(fileext,extflags,error)
       if (error) return
    else
       ! No special flags
    endif
    !
    ! Merge baseflags+extflags
    if (.not.allocated(baseflags))  call cubeadm_import_reallocate_flags(baseflags,noflag,error)
    if (.not.allocated(extflags))   call cubeadm_import_reallocate_flags(extflags,noflag,error)
    if (size(baseflags)+size(extflags).gt.0) then
      call cubeadm_import_reallocate_flags(flags,[baseflags,extflags],error)
      if (error)  return
    else
      ! Allocate empty list of flags. It will be improved after the file
      ! header is actually read.
      call cubeadm_import_reallocate_flags(flags,noflag,error)
      if (error)  return
    endif
    !
    ! Create a cubeid (for feedback) from these default family and flags
    if (size(flags).gt.0) then
      call cubetools_cubeid_familyflags2string(family,flags,cubeid,error)
      if (error) return
    else
      ! Put a 'cube' flag as poor-man solution. Avoid 'unknown' which can be
      ! misleading.
      call cubetools_cubeid_familyflags2string(family,[flag_cube],cubeid,error)
      if (error) return
    endif
  end subroutine cubeadm_import_default_familyflags
  !
  subroutine cubeadm_import_actual_family(prog,deffamily,fo,error)
    use cubetuple_format_class
    !-------------------------------------------------------------------
    ! Set the node family name, if not yet done at read header time
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    character(len=*),    intent(in)    :: deffamily  ! Default family to be applied
    class(format_t),     intent(inout) :: fo
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='IMPORT>ACTUAL>FAMILY'
    !
    if (fo%node%family.ne.'') then
      ! The family name was read from the header: it has precedence
      if (prog%doparse)  &
        call cubeadm_message(seve%w,rname,'Family read from header; /PARSE ignored')
    else
      ! No family yet: apply the precomputed default
      call fo%set_value('FAMILY',deffamily,error)
      if (error) return
    endif
  end subroutine cubeadm_import_actual_family
  !
  subroutine cubeadm_import_actual_flags(prog,defflags,fo,error)
    use cubetools_flag_types
    use cubedag_allflags
    use cubetuple_format_class
    !-------------------------------------------------------------------
    ! Set the node flags, if not yet done at read header time
    !-------------------------------------------------------------------
    type(import_prog_t), intent(in)    :: prog
    type(flag_t),        intent(in)    :: defflags(:)  ! Default flags to be applied
    class(format_t),     intent(inout) :: fo
    logical,             intent(inout) :: error
    !
    type(flag_t), allocatable :: flags(:)
    character(len=*), parameter :: rname='IMPORT>ACTUAL>FLAGS'
    !
    if (fo%node%flag%n.gt.0) then
      ! Some flags were read from the header: they have precedence
      if (prog%doparse) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /PARSE ignored')
      if (prog%domapping) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /MAPPING ignored')
      if (prog%doclass) &
        call cubeadm_message(seve%w,rname,'Flags read from header; /CLASS ignored')
    else
      ! No flags yet
      if (size(defflags).gt.0) then
        ! Default flags available
        call cubeadm_import_reallocate_flags(flags,defflags,error)
        if (error)  return
      else
        ! No pre-computed default. Use fallback flags
        if (fo%tuple%current%file%is_cube()) then
          call cubeadm_import_reallocate_flags(flags,[flag_cube],error)
          if (error)  return
        elseif (fo%tuple%current%file%is_uvt()) then
          call cubeadm_import_reallocate_flags(flags,[flag_uv,flag_table],error)
          if (error)  return
        endif
      endif
      ! Apply them
      call fo%set_flags(flags,error)
      if (error) return
    endif
  end subroutine cubeadm_import_actual_flags
  !
  subroutine cubeadm_import_reallocate_flags(list,flags,error)
    use gkernel_interfaces
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! Ad-hoc subroutine which reallocates and stores a list of flags
    !-------------------------------------------------------------------
    type(flag_t), allocatable   :: list(:)
    type(flag_t), intent(in)    :: flags(:)
    logical,      intent(inout) :: error
    !
    integer(kind=4) :: nflags,ier
    character(len=*), parameter :: rname='IMPORT>REALLOCATE>FLAGS'
    !
    if (allocated(list))  deallocate(list)
    nflags = size(flags)
    allocate(list(nflags),stat=ier)  ! Size can be 0 on purpose
    if (failed_allocate(rname,'flags',ier,error)) return
    if (nflags.gt.0)  list(:) = flags(:)
  end subroutine cubeadm_import_reallocate_flags
  !
  subroutine cubeadm_imported_add_node(dno)
    class(cubedag_node_object_t), pointer :: dno
    logical :: error
    error = .false.
    call cubeadm_imported_add(im,dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add_node
  !
  subroutine cubeadm_imported_add_twin(dno)
    class(cubedag_node_object_t), pointer :: dno
    logical :: error
    error = .false.
    call cubeadm_imported_add(tw,dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add_twin
  !
  subroutine cubeadm_imported_add(list,dno,error)
    type(cubedag_link_t),         intent(inout) :: list
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    call list%associate(dno,error)
    if (error)  return
  end subroutine cubeadm_imported_add
  !
  subroutine cubeadm_imported_flush_nodes(line,error)
    use cubedag_history_buffer
    use cubedag_links_tool
    !-------------------------------------------------------------------
    ! Insert all imported nodes in history and reset the list
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cubedag_link_t) :: void
    integer(kind=entr_k) :: hid
    !
    call cubedag_history_add_tohx('IMPORT',line,void,im,hid,error)
    if (error)  return
    call nodeln%set_history(im,hid,error)
    if (error)  return
    call im%final(error)
    if (error)  return
  end subroutine cubeadm_imported_flush_nodes
  !
  subroutine cubeadm_imported_flush_twins(error)
    use cubedag_links_tool
    !-------------------------------------------------------------------
    ! Link all current twins and reset the list
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call nodeln%set_twins_to_children(tw,error)
    if (error)  return
    call tw%final(error)
    if (error)  return
  end subroutine cubeadm_imported_flush_twins
  !
end module cubeadm_import
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine find_edit
  use sic_interfaces, except_this=>find_edit
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Determines if editing is possible on this device
  !---------------------------------------------------------------------
  edit_mode = inter_state
  !
end subroutine find_edit
!
function history_old_behaviour(dummy)
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: history_old_behaviour  !
  integer :: dummy                  !
  ! Local
  integer(kind=4) :: ier
  !
  history_old_behaviour = .false.
  ier = sic_getlog('HISTORY_OLD_BEHAVIOUR',history_old_behaviour)
  !
end function history_old_behaviour
!
function sub_kbdline(pr,chain,code,command)
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Read one command line from terminal. Lines from stack buffer can
  ! be recovered if ^P or ^N or UP and DOWN arrow are pressed. This
  ! routine is only called when line editing is enabled. COMMAND is
  ! true if waiting for a command.
  !---------------------------------------------------------------------
  integer(kind=4) :: sub_kbdline  ! Function value on return
  character(len=*) :: pr            !
  character(len=*) :: chain         !
  integer :: code                   !
  integer :: command                !
  !
  if (sic_window) then
    sub_kbdline = read_linec(pr,chain,code,command)
  else
    sub_kbdline = kbd_line(pr,chain,code)
  endif
end function sub_kbdline
!
subroutine read_line(chain,nchain,invite,ninv)
  use sic_interfaces, except_this=>read_line
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !     Read one command line from terminal. Lines from stack buffer
  !     can be recovered if ^P or ^N or UP and DOWN arrow are pressed.
  !     This routine is only called when line editing is enabled.
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  integer :: nchain                 !
  character(len=*) :: invite        !
  integer :: ninv                   !
  ! Local
  integer :: code
  integer, parameter :: code_eof = 255
  logical :: error
  character(len=64) :: pr
  integer :: curr_line
  !
  error = .false.
  curr_line = iend+1
  pr = invite(1:ninv)//char(0)
  code = 0
  !
  nchain = sub_kbdline(pr,chain,code,1)
  if (code.eq.code_eof) then
    chain = 'sic\exit'
    nchain = len_trim(chain)
    return
  endif
  do while (code.ne.0)
    if (code.eq.-1) then
      if (curr_line.gt.1) curr_line = curr_line-1
    else
      curr_line = curr_line+1
    endif
    call sic_recall(chain,nchain,curr_line,error)
    chain(nchain+1:nchain+1) = char(0)
    code = -1
    nchain = sub_kbdline (pr,chain,code,1)
  enddo
  chain(nchain+1:nchain+1) = ' '
end subroutine read_line
!
subroutine get_line(chain,nchain,invite,ninv)
  use sic_interfaces, except_this=>get_line
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC
  !     Get line with prompt and editing.
  !     Lines from the stack cannot be recovered, but the original
  !     line can be restored when UP and DOWN arrows are pressed
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  integer :: nchain                 !
  character(len=*) :: invite        !
  integer :: ninv                   !
  ! Local
  integer :: code,mpr
  character(len=64) :: pr
  !
  mpr = min(ninv,len(pr)-1)
  pr = invite(1:mpr)//char(0)
  code = 2
  chain = char(0)
  nchain = sub_kbdline(pr,chain,code,0)
  do while (code.ne.0)
    nchain = sub_kbdline(pr,chain,code,0)
  enddo
  chain(nchain+1:nchain+1) = ' '
end subroutine get_line
!
subroutine edit_line(chain,nchain,invite,ninv)
  use sic_interfaces, except_this=>edit_line
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC
  !     Get line with prompt and editing.
  !     Lines from the stack cannot be recovered, but the original
  !     line can be restored when UP and DOWN arrows are pressed
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  integer :: nchain                 !
  character(len=*) :: invite        !
  integer :: ninv                   !
  ! Local
  integer :: code
  character(len=64) :: pr
  integer :: curr_line
  logical :: error
  !
  error = .false.
  curr_line = iend+1
  !
  ! Write prompt in reverse video. Assumes ANSI device...
  pr = invite(1:ninv-1)//' '//char(0)
  chain(nchain+1:nchain+1) = char(0)
  code = 1
  nchain = sub_kbdline(pr,chain,code,1)
  do while (code.ne.0)
    if (code.eq.-1) then
      if (curr_line.gt.1) curr_line = curr_line-1
    else
      curr_line = curr_line+1
    endif
    call sic_recall(chain,nchain,curr_line,error)
    chain(nchain+1:nchain+1) = char(0)
    code = -1
    nchain = sub_kbdline(pr,chain,code,1)
  enddo
  chain(nchain+1:nchain+1) = ' '
end subroutine edit_line
!
subroutine sic_edit(chain,nchain,invite,ninv)
  use sic_interfaces, except_this=>sic_edit
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  integer :: nchain                 !
  character(len=*) :: invite        !
  integer :: ninv                   !
  ! Local
  integer :: code
  character(len=64) :: pr
  !
  pr = invite(1:ninv)//char(0)
  code = 0
  nchain = sub_kbdline(pr,chain,code,0)
  do while (code.ne.0)
    nchain = sub_kbdline(pr,chain,code,0)
  enddo
  chain(nchain+1:nchain+1) = ' '
end subroutine sic_edit

subroutine clic_plot(line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  use classic_api
  !---------------------------------------------------------------------
  !	PLOT [SAME] [obs_number] [NEXT] [FIRST] [CLOURE]
  !		/NOFRAME [pen]		option 1
  !		/RECORD			option 2
  !		/IDENTIFY		option 3
  !		/RESET			option 4
  !		/NODRAW			option 5
  !		/APPEND                 option 6
  !               /PHYSICAL               option 7
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: ident, do_record, init_data, reset
  logical :: do_frame, nodraw, colour, closure, reset_display, power
  logical :: save_bin, physical, sort
  character(len=12) :: argum
  integer :: ic, iv, i, nnn
  integer :: pen_plot
  integer :: n_loop_save, rec_1_save(m_loop), rec_2_save(m_loop)
  integer :: rec_3_save(m_loop), nd, nysave, nch
  integer(kind=address_length) :: ipx,ipy,ipw
  type(sic_listi4_t) :: list
  integer :: mvocab, nkey, mvoc1
  parameter (mvocab=6, mvoc1=2)
  character(len=12) :: vocab(mvocab), key, voc1(mvoc1)
  data voc1/'COLOR','NOCOLOR'/
  data vocab/'ALL','CLOSURE','FIRST','NEXT','POWER','SAME'/
  data reset_display/.false./
  save reset_display
  !------------------------------------------------------------------------
  ! Code:
  ! Options:
  ! /NOFRAME pen
  do_frame = .not.sic_present(1,0)
  pen_plot = 0
  call sic_i4(line,1,1,pen_plot,.false.,error)
  if (.not.do_frame.and.many_pages) then
   call message(4,4,'CLIC_PLOT','Cannot use /NOFRAME option on a many pages plot')
   error = .true.
   return
  endif
  ! /IDENT colour
  ident = sic_present(3,0)
  argum = 'COLOR'
  call clic_kw(line,3,1,argum,nkey,voc1,mvoc1,.false.,error,.true.)
  if (error) return
  colour = argum.eq.'COLOR'
  ! /NODRAW
  nodraw = sic_present(5,0)
  ! /APPEND
  init_data = .not.sic_present(6,0)
  ! /RESET
  reset = sic_present(4,0)
  if (reset) then
    call reset_time
  endif
  ! /RECORD
  do_record = sic_present(2,1)
  if (do_record) then
    n_loop_save = n_loop
    do i=1, n_loop
      rec_1_save(i) = rec_1(i)
      rec_2_save(i) = rec_2(i)
      rec_3_save(i) = rec_3(i)
    enddo
    ic = sic_start(2,1)
    iv = sic_end(2,sic_narg(2))
    call sic_parse_listi4('CLIC_PLOT',line(ic:iv),list,m_loop,error)
    if (error) return
    n_loop = list%nlist
    rec_1(:) = list%i1(:)
    rec_2(:) = list%i2(:)
    rec_3(:) = list%i3(:)
  endif
  !  /PHYSICAL
  physical = sic_present(7,0).or.do_physical
  if (physical) then
    if (.not.phys_base) then
      phys_base = .true.
      call set_display(error)
    endif
  else
    if (phys_base) then
      phys_base = .false.
      call set_display(error)
    endif
  endif
  ! /NOSORT
  sort = .not.sic_present(9,0)
  !
  ! Command Argument
  argum = 'ALL'
  call sic_ke(line,0,1,argum,nch,.false.,error)
  if (error) return
  nnn = ichar(argum(1:1))
  if (nnn.ge.ichar('0') .and. nnn.le.ichar('9')) then
    key = argum
  else
    call sic_ambigs('PLOT',argum,key,nkey,vocab,mvocab,error)
    if (error) return
  endif
  if (key.eq.'SAME' .and. change_display) then
    call message(4,2,'CLIC_PLOT','Data needs to be read')
    argum(1:3) = 'ALL'
  endif
  if (reset_display .and. key.ne.'SAME') then
    call set_display(error)
    reset_display = .false.
  endif
  ! /BOXES
  if (sic_present(8,0)) then
    call sic_ke(line,8,1,argum,nch,.true.,error)
    if (argum.eq.'*') then
       user_box_nx = -1
    else
       call sic_i4(line,8,1,user_box_nx,.false.,error)
    endif
    call sic_ke(line,8,2,argum,nch,.true.,error)
    if (argum.eq.'*') then
       user_box_ny = -1
    else
      call sic_i4(line,8,2,user_box_ny,.false.,error)
    endif
    user_box = (user_box_nx.gt.0.or.user_box_ny.gt.0)
  else
    user_box = .false.
  endif
  !
  ! Deal with Title
  call gr_exec('SET VIEWPORT /DEF')
  ! Closure plot:
  ! set some defaults for plotting
  closure = .false.
  power = .false.
  if (key.eq.'CLOSURE') then
    call get_first(.false.,error)
    if (error) return
    change_display = .true.
    ! Y variables: amplitude and/or phase
    nysave = n_y
    n_y = 1
    if ((i_y(1).ne. xy_ampli).and.(i_y(1).ne. xy_phase)) then
      call message (8,3,'CLIC_PLOT',   &
        'Use SET Y AMPLITUDE or SET Y PHASE for closure plots')
      error = .true.
    endif
    ! all available baselines:
    n_base = r_nbas
    do i=1, n_base
      i_base(i) = i
    enddo
    call set_display(error)
    if (error) return
    closure = .true.
    key = 'ALL'
  elseif (key.eq.'POWER') then
    power = .true.
    key = 'ALL'
  endif
  !
  if (key.ne.'SAME') then
    if (plot_mode.eq.'TIME') then
      if (power) then
        save_bin = do_bin
        do_bin = .false.
      endif
      call read_data(key,sort,init_data,error)
      if (power) do_bin = save_bin
    elseif (plot_mode.eq.'SPEC') then
      call read_spec(key,init_data,error)
    endif
    if (error) return
  endif
  if (do_record) then
    n_loop = n_loop_save
    do i=1, n_loop
      rec_1(i) = rec_1_save(i)
      rec_2(i) = rec_2_save(i)
      rec_3(i) = rec_3_save(i)
    enddo
  endif
  change_display = .false.
  clear = (clear .or. key.eq.'ALL' .or. key.eq.'SAME')   &
    .and. do_frame
  if (nodraw) return
  if (closure) then
    ipx = gag_pointer(data_x,memory)
    ipy = gag_pointer(data_y,memory)
    ipw = gag_pointer(data_w,memory)
    nd = m_data
    if (i_y(1).eq.xy_phase.and.r_nant.ge.3) then
      call sub_clos_pha(r_nant,nd,n_base,   &
        memory(ipx),memory(ipy),memory(ipw),error)
    elseif (r_nant.ge.4) then
      call sub_clos_amp(r_nant,nd,n_base,   &
        memory(ipx),memory(ipy),memory(ipw),error)
    endif
    if (error) return
    call sub_resetvar(m_data,m_boxes,   &
      memory(ipx),memory(ipy),memory(ipw),error)
    if (error) return
    call position_boxes(error)
    if (error) return
  elseif (power) then
    call plot_power(error)
    if (error) return
  endif
  call sub_plot(key, ident, colour, pen_plot, error)
  if (closure) then
    n_y = nysave
    reset_display = .true.
  endif
  user_box = .false.
  return
end subroutine clic_plot
!
subroutine sub_plot(argum, ident, colour, pen_plot, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! this intermediate entry point needed for solve ... /plot
  !---------------------------------------------------------------------
  character(len=*) :: argum         !
  logical :: ident                  !
  logical :: colour                 !
  integer :: pen_plot               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipx,ipy,ipw,ipi,ips,ipj
  !-----------------------------------------------------------------------
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipw = gag_pointer(data_w,memory)
  ipi = gag_pointer(data_i,memory)
  ips = gag_pointer(data_s,memory)
  ipj = ips + m_data*m_boxes
  call sub_sub_plot(m_data, m_boxes, memory(ipx), memory(ipy),   &
    memory(ipw), memory(ipi), memory(ips),   &
    memory(ipj), argum, ident, colour, pen_plot,   &
    error)
  return
end subroutine sub_plot
!
subroutine sub_clos_pha(nant,nd,nb,x,y,w,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! same comment as for amplitudes.
  !---------------------------------------------------------------------
  integer :: nant                   !
  integer :: nd                     !
  integer :: nb                     !
  real :: x(nd,nb)                  !
  real :: y(nd,nb)                  !
  real :: w(nd,nb)                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_number.inc'
  ! Local
  integer :: i, k, id, nclos, kbox, kb, islash, ii, nt
  integer :: jcl(3,mnbas), j1, j2, j3, ib, kk
  real :: xc(mnbas),yc(mnbas),wc(mnbas),p, ww(3), yy(3), www, xx
  character(len=3) :: cc,ccl(mnbas)
  character(len=80) :: ch
  logical :: new(mnbas)
  !-----------------------------------------------------------------------
  kbox = n_boxes/n_base
  if (degrees) then
    p = 180.
  else
    p = pi
  endif
  !
  ! Build the relations table starting from the list of triangles:
  nt = nant*(nant-1)*(nant-2)/6
  nclos = 0
  do i=1, mnbas
    new(i) = .true.
  enddo
  do k=1, nt
    j1 = bastri(1,k)
    j2 = bastri(2,k)
    j3 = bastri(3,k)
    write(cc,'(4i1)') anttri(1,k),anttri(2,k),anttri(3,k)
    if (new(j1).or.new(j2).or.new(j3)) then
      nclos = nclos+1
      new(j1) = .false.
      new(j2) = .false.
      new(j3) = .false.
      jcl(1,nclos) = j1
      jcl(2,nclos) = j2
      jcl(3,nclos) = j3
      ccl(nclos) = cc
    endif
  enddo
  !
  do ib=1, kbox
    do k=1, nclos
      kb = (k-1)*kbox+ib
      header_1(kb) = 'Clos '//ccl(k)
      header_2(kb) = header_2(ib)
      header_3(kb) = header_3(ib)
      x_label(kb)  = x_label(ib)
      y_label(kb)  = y_label(ib)
      write (ch,1005) kb, kb
      islash = index(c_limits(ib),'/')-1
      c_limits(kb) = c_limits(ib)(1:islash)//ch(1:lenc(ch))
    enddo
  enddo
  !
  do id=1, n_data(k)
    do ib=1, kbox
      do i=1, nclos
        kb = (i-1)*kbox+ib
        do kk=1,3
          ii = (jcl(kk,i)-1)*kbox+ib
          yy(kk) = y(id,ii)
          ww(kk) = w(id,ii)
          xx = x(id,ii)
        enddo
        www = ww(1)*ww(2)*ww(3)
        if (www.gt.0) then
          yc(i) = mod(yy(1)-yy(2)+yy(3)+11*p,2*p)-p
          wc(i) = 1./(1/ww(1)+1/ww(2)+1/ww(3))
          xc(i) = xx
        else
          yc(i) = blank4
          wc(i) = 0
          xc(i) = blank4
        endif
      enddo
      do i=1, nclos
        ii = (i-1)*kbox+ib
        y(id,ii) =  yc(i)
        w(id,ii) =  wc(i)
        x(id,ii) =  xc(i)
      enddo
    enddo
  enddo
  n_boxes = nclos*kbox
  !
  ! reset the variables
  call sub_resetvar(nd,n_boxes,x,y,w,error)
  return
1005 format(' /VARIABLE X_DATA[',i4.4,'] Y_DATA[',i4.4,']')
end subroutine sub_clos_pha
!
subroutine sub_clos_amp(nant,nd,nb,x,y,w,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! take only 2 closures for each quadrangle (13.24/12.34 and 14.23/12.34)
  ! this would produce n*(n-1)*(n-2)*(n-3)|(4*3) closure
  ! relations of which only n*(n-3)|2 are independent. For 5 antennas these
  ! numbers are 10 and 5. For more than 5 antennas one has to sort out
  ! dependent relations because there will be more clos. relations produced
  ! than available baselines.
  ! Hint : start with 2 independent relations in a given quadrangle, and add
  ! relations with additional baselines; using only once each new baseline
  ! should give independent relations:
  !  (n-1)(n-4)|2 relations between n-1 antennas
  ! there are n-1 new baselines with a nth antenna
  ! add (n-2) relations (the first has 2 new baselines)
  ! one gets (n-1)(n-4)|2 + n-2 = (n^2-5n+4 +2n-4)|2 = n*(n-3)|2 relations.
  !---------------------------------------------------------------------
  integer :: nant                   !
  integer :: nd                     !
  integer :: nb                     !
  real :: x(nd,nb)                  !
  real :: y(nd,nb)                  !
  real :: w(nd,nb)                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_number.inc'
  ! Local
  integer ::  i, id, nclos, k, kb, kbox, l, islash, ii, nq
  integer ::  jcl(4,mnbas), j1, j2, j3, j4, ib, kk
  real :: xc(mnbas),yc(mnbas), wc(mnbas), yy(4), ww(4)
  real :: www, yyy, xx
  character(len=4) :: cc,ccl(mnbas)
  character(len=80) :: ch
  logical :: new(mnbas)
  !-----------------------------------------------------------------------
  kbox = n_boxes/n_base
  !
  ! Build the relations table starting from the list of quadrangles:
  nq = nant*(nant-1)*(nant-2)*(nant-3)/24
  nclos = 0
  do i=1, mnbas
    new(i) = .true.
  enddo
  !
  do k=1, nq
    j1 = basquad(1,k)
    j2 = basquad(6,k)
    do l=1, 2
      if (l.eq.1) then         ! (A_12*A_34)/(A_13*A_24)
        j3 = basquad(2,k)
        j4 = basquad(5,k)
        write(cc,'(4i1)') antquad(1,k),antquad(2,k),   &
          antquad(3,k),antquad(4,k)
      else                     ! (A_12*A_34)/(A_14*A_23)
        j3 = basquad(3,k)
        j4 = basquad(4,k)
        write(cc,'(4i1)') antquad(1,k),antquad(2,k),   &
          antquad(4,k),antquad(3,k)
      endif
      if (new(j1).or.new(j2).or.new(j3).or.new(j4)) then
        nclos = nclos+1
        new(j1) = .false.
        new(j2) = .false.
        new(j3) = .false.
        new(j4) = .false.
        jcl(1,nclos) = j1
        jcl(2,nclos) = j2
        jcl(3,nclos) = j3
        jcl(4,nclos) = j4
        ccl(nclos) = cc
      endif
    enddo
  enddo
  !
  do ib=1, kbox
    do k=1, nclos
      kb = (k-1)*kbox+ib
      header_1(kb) = 'Clos '//ccl(k)
      header_2(kb) = header_2(ib)
      header_3(kb) = header_3(ib)
      x_label(kb)  = x_label(ib)
      y_label(kb)  = y_label(ib)
      write (ch,1005) kb, kb
      islash = index(c_limits(ib),'/')-1
      c_limits(kb) = c_limits(ib)(1:islash)//ch(1:lenc(ch))
    enddo
  enddo
  !
  do id=1, n_data(k)
    do ib=1, kbox
      do i=1, nclos
        kb = (i-1)*kbox+ib
        do kk=1,4
          ii = (jcl(kk,i)-1)*kbox+ib
          yy(kk) = y(id,ii)
          ww(kk) = w(id,ii)
          xx = x(id,ii)
        enddo
        www = ww(1)*ww(2)*ww(3)*ww(4)
        yyy = yy(1)*yy(2)*yy(3)*yy(4)
        if (www.gt.0) then
          if (yyy.ne.0) then
            do kk=1,4
              ww(kk) = 1./ww(kk)/yy(kk)**2
            enddo
            yc(i) = (yy(1)*yy(2))/(yy(3)*yy(4))
            wc(i) = 1./(ww(1)+ww(2)+ww(3)+ww(4))/yc(i)**2
            xc(i) = xx
          endif
        else
          yc(i) = blank4
          wc(i) = 0
          xc(i) = blank4
        endif
      enddo
      do i=1, nclos
        ii = (i-1)*kbox+ib
        y(id,ii) =  yc(i)
        w(id,ii) =  wc(i)
        x(id,ii) =  xc(i)
      enddo
    enddo
  enddo
  n_boxes = nclos*kbox
  !
  ! reset the variables
  call sub_resetvar(nd,n_boxes,x,y,w,error)
  return
1005 format('/VARIABLE X_DATA[',i4.4,'] Y_DATA[',i4.4,']')
end subroutine sub_clos_amp
!
subroutine sub_sub_plot(md,mb,x_data,y_data,w_data,   &
    i_data,b_data,j_data,argum,ident, colour, pen_plot, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_index
  use clic_title
  !---------------------------------------------------------------------
  ! This version for GREG1 Version 7.2 and later : call list of
  ! GR4_HISTO was incorrect previously.
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  integer :: i_data(md,mb)             !
  real :: b_data(md,mb)             !
  integer :: j_data(mb)                !
  character(len=*) :: argum         !
  logical :: ident                  !
  logical :: colour                 !
  integer :: pen_plot               !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  ! Local
  type(title_v2_t) :: title_save
  integer :: i, l, l1, j, lc, isides, istyle, sides0, style0, k, n
  integer :: nch, ix, iy, nplot, mplot, iscan
  integer :: i_data_dumm(md)
  real :: tick(4)
  character(len=132) :: chain,ch1,ch2,ch3
  character(len=4) :: cloc
  character(len=3) :: italic
  character(len=12) :: answer
  integer :: nch1, nch2, nch3, old_pen, status
  real*4 :: cdef, cdef0, cdef1
  real*4 :: xmax, ymax, size0, sl, sl1, sl2, sl3, bx1, bx2, by1, by2
  real*4 :: xmax1, ymax1, xx1(mbox), xx2(mbox), yy1(mbox), yy2(mbox)
  real*4 :: dummy(1)
  logical :: angle_data, good(mbox)
  logical :: fatm, fwvr, fmon
  !------------------------------------------------------------------------
  save xmax1, ymax1
  data xmax1/0.0/, ymax1/0.0/
  ! 
  ! Save the current short tile
  title_save = title
  !
  ! Code:
  italic = char(92)//char(92)//'i'
  do i=1, n_x
    xx1(i) = 1e30
    xx2(i) = -1e30
  enddo
  do i=1, n_y
    yy1(i) = 1e30
    yy2(i) = -1e30
  enddo
  mplot = 0
  do i=1, n_boxes
    nplot = 0
    do j = 1, n_data(i)
      if (abs(y_data(j,i)-blank4).gt.d_blank4) then
        nplot = nplot + 1
      endif
    enddo
    if (nplot.le.0) then
      write(chain,'(A,I0)') 'No data in box ',i
      call message(8,2,'SUB_PLOT',chain(1:lenc(chain)))
    endif
    good(i) = nplot.gt.0
    mplot = mplot + nplot
  enddo
  if (mplot.le.0) then
    call message(8,2,'SUB_PLOT','No data to plot')
    call gtclear  
    error = .true.
    return
  endif
  call gr8_blanking(blank8,d_blank8)
  if (clear) then
    call gtclear
    error = gr_error()
    if (error) goto 999
    call sic_get_real('CHARACTER_SIZE',cdef0,error)
    call sic_get_real('PAGE_X',xmax,error)
    call sic_get_real('PAGE_Y',ymax,error)
    if (xmax1.ne.0 .and. (xmax.ne.xmax1 .or. ymax.ne.ymax1)) then
      call set_display(error)
      if (error) return
    endif
    xmax1 = xmax
    ymax1 = ymax
    !
    ! Central header should fit in (0.70*xmax,0.08*xmax)
    cdef = 0.08*xmax/3.0       ! space for 3 lines
    !
    ! First line
    call user_info(ch1)
    nch1 = lenc(ch1)
    ch1 = ch1(1:nch1)//'   '   &
      //r_config(1:lenc(r_config))//' '   &
      //r_teles
    nch1 = lenc(ch1)
    call gtg_charlen(nch1,ch1(1:nch1),cdef,sl1,0)
    !
    ! Second and third line -- Old receivers
    if (.not.new_receivers) then
      if ((argum.eq.'ALL' .or. argum.eq.'SAME')   &
        .and. cxnext.gt.2) then
        call rix(cx_ind(1),error)
      else
        call rix(r_xnum,error)
      endif
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Normal',error)
      call out2(ch2,error)
      nch2 = lenc(ch2)
      call gtg_charlen(nch2,ch2(1:nch2),cdef,sl2,0)
      if ((argum.eq.'ALL' .or. argum.eq.'SAME')   &
        .and. cxnext.gt.2) then
        call rix(cx_ind(cxnext-1),error)
        call out0('Chain',xmax/2,ymax-cdef,error)
        call titout('Normal',error)
        call out2(ch3,error)
        nch3 = lenc(ch3)
        call gtg_charlen(nch3,ch3(1:nch3),cdef,sl3,0)
      else
        sl3 = 0
      endif
    !
    ! Second and third lines -- New receivers
    else
      call rix(cx_ind(1),error)
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Plot',error)
      call out2(ch2,error)
      nch2 = lenc(ch2)
      call gtg_charlen(nch2,ch2(1:nch2),cdef,sl2,0)
      !
      call rix(cx_ind(cxnext-1),error)
      call out0('Chain',xmax/2,ymax-cdef,error)
      call titout('Blot',error)
      call out2(ch3,error)
      nch3 = lenc(ch3)
      call gtg_charlen(nch3,ch3(1:nch3),cdef,sl3,0)
    endif
    !
    ! Now print the two or three lines
    sl = max(sl1, sl2, sl3)
    if (sl.gt.0.70*xmax) then
      cdef = cdef*0.70*xmax/sl
    endif
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef
    call gr_exec1 (chain(1:lenc(chain)))
    call grelocate(xmax*0.5-0.1*cdef,ymax)
    call gr_labe_cent(2)
    call gr_labe(italic//ch1(1:nch1))
    call grelocate(xmax/2.,ymax-cdef)
    call gr_labe_cent(2)
    call gr_labe(ch2(1:nch2))
    if (sl3.gt.0) then
      call grelocate(xmax/2.,ymax-cdef*2)
      call gr_labe_cent(2)
      call gr_labe(ch3(1:nch3))
    endif
    !
    ! Corner labels (Left)
    cdef = 0.08*xmax/4         ! space for 4 lines
    call gtg_charlen(13,'XXXXXXXXXXXXXXXXXX',cdef,sl,0)
    if (sl.gt.0.12*xmax) then
      cdef = cdef*0.12*xmax/sl
    endif
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef
    call gr_exec1 (chain(1:lenc(chain)))
    call grelocate(0.1,ymax)
    call gr_labe_cent(3)
    call gr_labe(italic//'RF:')
    call grelocate(0.1,ymax-cdef)
    call gr_labe_cent(3)
    call gr_labe(italic//'Am:')
    call grelocate(0.1,ymax-2*cdef)
    call gr_labe_cent(3)
    call gr_labe(italic//'Ph:')
    !
    !RF
    if (do_pass) then
      if (do_pass_freq) then
        chain = 'Fr.'
      else
        chain = 'Ch.'
      endif
      if (do_pass_antenna) then
        chain(4:6) = '(A)'
      else
        chain(4:6) = '(B)'
      endif
      if (do_pass_spectrum) then
        iscan = 0
        call get_pass_scan(chain,iscan,error)
      endif
    else
      chain = 'Uncal.'
    endif
    call grelocate(3*cdef,ymax)
    call gr_labe_cent(3)
    call gr_labe(chain(1:10))
    !Amp.
    if (do_amplitude) then
      if (do_amplitude_antenna) then
        chain = 'Rel.(A)'
      else
        chain = 'Rel.(B)'
      endif
    elseif (do_scale) then
      chain = 'Scaled'
    else
      chain = 'Abs.   '
    endif
    call grelocate(3*cdef,ymax-cdef)
    call gr_labe_cent(3)
    call gr_labe(chain(1:7))
    if (do_phase) then
      if (do_phase_antenna) then
        chain = 'Rel.(A)'
      else
        chain = 'Rel.(B)'
      endif
    else
      chain = 'Abs.'
    endif
    fatm = .false.
    do i=1, r_nant
      fatm = fatm.or.do_phase_atm(i)
    enddo
    if (fatm) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Atm.'
    endif
    fwvr = .false.
    do i=1, r_nant
      fwvr = fwvr.or.do_phase_wvr(i)
    enddo
    if (fwvr) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Wvr.'
    endif
    fmon = .false.
    do i=1, r_nant
      fmon = fmon.or.do_phase_mon(i)
    enddo
    if (fmon) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Tot.'
    endif
    if (do_phase_ext) then
      lc = lenc(chain)
      chain = chain(1:lc)//' Ext.'
    endif
    lc = lenc(chain)
    call grelocate(3*cdef,ymax-2*cdef)
    call gr_labe_cent(3)
    call gr_labe(chain(1:lc))
    !
    ! Corner labels (Right)
    ! -- Averaging
    if (i_average.eq.0) then
      chain = 'No Avg.'
    elseif (i_average.eq.1) then
      chain = 'Scan Avg.'
    elseif (i_average.eq.2) then
      write(chain,'(A,F5.0,A)') 'T.Av:',t_average,' s.'
    endif
    call grelocate(xmax,ymax)
    call gr_labe_cent(1)
    nch = lenc(chain)
    call gr_labe(chain(1:nch))
    ! Obsolete ?
    !         IF (J_AVERAGE.EQ.0) THEN
    !            CHAIN = 'Scal.Avg.'
    !         ELSE
    !            CHAIN = 'Vect.Avg.'
    !         ENDIF
    !         CALL GRELOCATE(XMAX,YMAX-CDEF)
    !         CALL GR_LABE_CENT(1)
    !         CALL GR_LABE(CHAIN(1:9))
    !
    ! -- Phys. antenna
    if (phys_base) then
      old_pen = gr_spen(1)
      chain = 'PHYSICAL ant.'
      call grelocate(xmax,ymax-cdef)
      call gr_labe_cent(1)
      call gr_labe(chain(1:13))
      old_pen = gr_spen(old_pen)
      ymax = ymax-cdef
    endif
    !
    ! -- Subbands selection
    if (new_receivers) then
      chain = ' '
      if (do_polar.ne.0.or.each_polar) then
        if (do_polar.eq.1) then
          chain = 'HORIZONTAL pol.'
        elseif (do_polar.eq.2) then
          chain = 'VERTICAL pol.'
        elseif (do_polar.eq.3) then
          chain = 'BOTH polarizations'
        endif
        if (each_polar) then
          chain = 'EACH polar'
        endif
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
      if (narrow_input.ne.0) then
        if (narrow_input.eq.1) then
          chain = 'Narrow Input 1'
        elseif (narrow_input.eq.2) then
          chain = 'Narrow Input 2'
        elseif (narrow_input.eq.3) then
          chain = 'Narrow Input 1+2'
        endif
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
      if (widex_unit.ne.0) then
        write (chain,'(a,i1)')'WIDEX Unit ',widex_unit
        old_pen = gr_spen(1)
        call grelocate(xmax,ymax-cdef)
        call gr_labe_cent(1)
        call gr_labe(chain(1:lenc(chain)))
        old_pen = gr_spen(old_pen)
      endif
    endif
  endif
  !
  ! Recover the data if PLOT SAME
  if (argum.eq.'SAME') then
    call getvar(md,mb,x_data,y_data,w_data)
  endif
  !
  ! Global limits (using e.g. "/LIMITS 0 =")
  do i=1, n_boxes
    if (good(i) .and. n_data(i).gt.0) then
      l = lenc(c_limits(i))
      call gr_exec1 (c_limits(i)(1:l))
      error = gr_error()
      if (error) goto 999
      call save_limits(i,error)
      ix = k_x(i)
      if (sm_x1(ix).eq.'=') then
        xx1(ix) = min(xx1(ix),gb1_x(i))
      endif
      if (sm_x2(ix).eq.'=') then
        xx2(ix) = max(xx2(ix),gb2_x(i))
      endif
      iy = k_y(i)
      if (sm_y1(iy).eq.'=') then
        yy1(iy) = min(yy1(iy),gb1_y(i))
      endif
      if (sm_y2(iy).eq.'=') then
        yy2(iy) = max(yy2(iy),gb2_y(i))
      endif
    endif
  enddo
  do i=1, n_boxes
    ix = k_x(i)
    if (sm_x1(ix).eq.'=') then
      gb1_x(i) = xx1(ix)
    elseif (sm_x1(ix).eq.'F') then
      gb1_x(i) = gu1_x(ix)
    endif
    if (sm_x2(ix).eq.'=') then
      gb2_x(i) = xx2(ix)
    elseif (sm_x2(ix).eq.'F') then
      gb2_x(i) = gu2_x(ix)
    endif
    iy = k_y(i)
    if (sm_y1(iy).eq.'=') then
      gb1_y(i) = yy1(iy)
    elseif (sm_y1(iy).eq.'F') then
      gb1_y(i) = gu1_y(iy)
    endif
    if (sm_y2(iy).eq.'=') then
      gb2_y(i) = yy2(iy)
    elseif (sm_y2(iy).eq.'F') then
      gb2_y(i) = gu2_y(iy)
    endif
  enddo
  !
  ! Recompute The positions of boxes if needed
  if (user_box) then
    call position_boxes_user(user_box_nx,user_box_ny,error)
  else
    call position_boxes(error)
  endif
  !
  k = 0
  many_pages = .false.
  do i=1, n_boxes
    k = k + 1
    if (user_box.and.k.gt.user_nboxes) then
      answer=' '
      do while (answer(1:1).ne."C")
        call sic_wprn('I-PLOT, Type C to continue',answer,n)
        if (answer(1:1).eq."Q") return
      enddo
      call gr_execl('CHANGE DIRECTORY')
      do j=1, user_nboxes
         write(chain,'(I4.4)') j
         call gr_execl('DESTROY DIRECTORY BOX'//chain)
      enddo
      many_pages = .true.
      change_display = .true.
      k = 1
    endif
    call gr_execl('CHANGE DIRECTORY')
    error = gr_error()
    if (error) goto 999
    !
    write(chain,'(I4.4)') k
    if (clear) then
      call gr_execl('CREATE DIRECTORY BOX'//chain)
      error = gr_error()
      if (error) goto 999
    endif
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    if (n_data(i).le.0.or..not.good(i)) then
      goto 800
    endif
    !
    if (clear) then
      l = lenc(c_setbox(k))
      call gr_exec  (c_setbox(k)(1:l))
      error = gr_error()
      if (error) goto 999
      write(chain,'(A,4(1X,G19.12))') 'LIMITS ',gb1_x(i),   &
        gb2_x(i),gb1_y(i),gb2_y(i)
      l = lenc(chain)
      call gr_exec(chain(1:l))
      error = gr_error()
      if (error) goto 999
      call sic_get_real('BOX_XMIN',bx1,error)
      call sic_get_real('BOX_XMAX',bx2,error)
      call sic_get_real('BOX_YMIN',by1,error)
      call sic_get_real('BOX_YMAX',by2,error)
      cdef = 0.20*(by2-by1)
      cdef1 = min(0.1*(by2-by1),0.1*(bx2-bx1))
      nch1 = lenc(header_1(i))
      nch2 = lenc(header_2(i))
      nch3 = lenc(header_3(i))
      call gtg_charlen(nch1,header_1(i)(1:nch1),cdef,sl1,0)
      call gtg_charlen(nch2,header_2(i)(1:nch2),cdef,sl2,0)
      call gtg_charlen(nch3,header_3(i)(1:nch3),cdef,sl3,0)
      sl = max(2*sl1+sl2,2*sl3+sl2)
      if (sl.gt.0.95*(bx2-bx1)) then
        cdef = cdef*0.95*(bx2-bx1)/sl
      endif
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      ix = i_x(k_x(i))
      iy = i_y(k_y(i))
      do j=1, 4
        tick (j) = 0.0
      enddo
      ! Convert to degrees if angle data
      if (angle_data(ix)) then
        if (degrees.and.abs(gb1_x(i)-gb2_x(i)).gt.180.) then
          tick(2) = 90.
          do while (abs(gb1_x(i)-gb2_x(i))/tick(2).gt.5)
            tick(2) = tick(2)*2.0
          enddo
          tick(1) = tick(2)/3.0
        endif
      endif
      if (angle_data(iy)) then
        if (degrees.and.abs(gb1_y(i)-gb2_y(i)).gt.180.) then
          tick(4) = 90.
          do while (abs(gb1_y(i)-gb2_y(i))/tick(4).gt.5)
            tick(4) = tick(4)*2.0
          enddo
          tick(3) = tick(4)/3.0
        endif
      endif
      write (chain,'(A,4(1X,F10.1))') 'TICKSPACE ',tick
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      call gr_exec1 ('BOX')
      error = gr_error()
      if (error) goto 999
      ! Box Header
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      l = lenc(header_1(i))
      write(chain,'(A,F4.2,A)') 'DRAW TEXT 0 ',0.2*cdef,' "'
      call gr_exec1 (chain(1:18)//header_1(i)(1:l)//'" 9 /BOX 7')
      error = gr_error()
      if (error) goto 999
      l = lenc(header_2(i))
      call gr_exec1 (chain(1:18)//header_2(i)(1:l)//'" 8 /BOX 8')
      error = gr_error()
      if (error) goto 999
      l = lenc(header_3(i))
      call gr_exec1 (chain(1:18)//header_3(i)(1:l)//'" 7 /BOX 9')
      error = gr_error()
      if (error) goto 999
      write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      l = lenc(x_label(i))
      l1 = lenc(y_label(i))
      call gr_exec1 ('LABEL "'//y_label(i)(1:l1)//'  vs.  '   &
        //x_label(i)(1:l)//'" /X')
      error = gr_error()
      if (error) goto 999
    endif
    !
    ! change the pen here for overlay plots
    if (.not.clear) then
      old_pen = gr_spen(pen_plot)
    endif
    !         IF (ARGUM.EQ.'SAME') THEN
    !            CALL GETVAR(MD,MB,X_DATA,Y_DATA,W_DATA)
    !         ENDIF
    if (plot_type.eq.'LINE') then
      call gr_segm('PLOT',error)
      call gr4_connect (n_data(i),   &
        x_data(1,i),y_data(1,i),   &
        blank4,d_blank4)
      call gr_segm_close(error)
    elseif (plot_type.eq.'POIN') then
      if (.not.ident) then
        call gr_segm('PLOT',error)
        call gr4_marker (n_data(i), x_data(1,i),y_data(1,i),   &
          blank4,d_blank4)
        call gr_segm_close(error)
      else
        i_data_dumm(:) = i_data(:,i)
        call gr4_ident (n_data(i), x_data(1,i),y_data(1,i),   &
          i_data_dumm(1),j_data(1),colour,.false.,b_data(1,i),   &
          error)
      endif
    elseif (plot_type.eq.'HIST') then
      call gr_segm('PLOT',error)
      call gr4_histo (n_data(i), x_data(1,i),y_data(1,i),   &
        blank4,d_blank4)
      call gr_segm_close(error)
    elseif (plot_type.eq.'BARS') then
      do j = 1, n_data(i)
        if (w_data(j,i).gt.0.0) then
          b_data(j,i) = 1.0e-3/sqrt(w_data(j,i))
        else
          b_data(j,i) = 0.0
        endif
      enddo
      cloc = 'Y'
      if (.not.ident) then
        call gr_segm('PLOT',error)
        call gr4_bars (cloc,n_data(i),   &
          x_data(1,i),y_data(1,i),b_data(1,i),dummy,   &
          blank4,d_blank4)
        call gr4_marker (n_data(i),x_data(1,i),y_data(1,i),   &
          blank4,d_blank4)
        call gr_segm_close(error)
      else
        i_data_dumm(1:md) = i_data(1:md,i)
        call gr4_ident (n_data(i),x_data(1,i),y_data(1,i),   &
          i_data_dumm(1),j_data(1),colour,.true.,b_data(1,i),   &
          error)
      endif
    endif
    !
    ! reset the pen here for overlay plots
    if (.not.clear) then
      old_pen = gr_spen(old_pen)
    endif
    !
800 continue
  enddo
  !
  if (ident) then
    print *,'Ident ',cdef1
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef1
    call gr_exec1 (chain(1:lenc(chain)))
    error = gr_error()
    if (error) goto 999
    call gr_get_marker(sides0,style0,size0)
    old_pen = gr_spen(0)
    do i=1, n_ident
      isides = (i-1)/4 + 3
      istyle = i - (isides-3)*4 -1
      call gr_set_marker(isides,istyle,size0*3)
      if (colour) then
        status = gr_spen(mod(i-1,7))
      endif
      write (chain,'(A,1PG13.6,1X,1PG13.6,a)') 'DRAW MARKER ',   &
        0.5*cdef1,-i*cdef1,' /BOX 7'
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      write (chain,'(A,1PG13.6,1X,1PG13.6,a)') 'DRAW RELOCATE ',   &
        1.5*cdef1,-i*cdef1,' /BOX 7'
      call gr_exec1 (chain(1:lenc(chain)))
      error = gr_error()
      if (error) goto 999
      lc = lenc(ch_ident(i))
      call gr_labe_cent(6)
      call gr_labe(ch_ident(i)(1:lc))
    enddo
    call gr_set_marker(sides0,style0,size0)
    if (colour) then
      status = gr_spen(old_pen)
    endif
  endif
  call gr_execl('CHANGE DIRECTORY')
  call gr_exec1('LIMITS 0 1 0 1')
  error = gr_error()
  if (error) goto 999
  if (clear) then
    write (chain,'(A,F7.3)') 'SET CHAR ',cdef0
    call gr_exec1 (chain(1:lenc(chain)))
    error = gr_error()
    if (error) goto 999
  endif
999 continue
  !
  ! For consistency of further commands restore saved title
  title = title_save
  clear = .false.
end subroutine sub_sub_plot
!
subroutine save_limits(ibox,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Save current GREG plot limits into display common, for box # IBOX
  !---------------------------------------------------------------------
  integer :: ibox                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  ! Local
  real :: x1, x2, y1, y2
  !------------------------------------------------------------------------
  ! Code:
  call sic_get_real('USER_XMIN',x1,error)
  call sic_get_real('USER_XMAX',x2,error)
  if (x2.gt.x1) then
    gb1_x(ibox) = x1
    gb2_x(ibox) = x2
  endif
  call sic_get_real('USER_YMIN',y1,error)
  call sic_get_real('USER_YMAX',y2,error)
  if (y2.gt.y1) then
    gb1_y(ibox) = y1
    gb2_y(ibox) = y2
  endif
  return
end subroutine save_limits
!
subroutine gr4_ident (np,x,y,id,ind,colour,bars,b,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Plot data with identifying markers
  !---------------------------------------------------------------------
  integer :: np                     ! number of points
  real :: x(np)                     ! coordinates
  real :: y(np)                     ! coordinates
  integer :: id(np)                 ! identifying numbers
  integer :: ind(np)                ! identifying numbers
  logical :: colour                 !
  logical :: bars                   !
  real :: b(np)                     ! Error bars
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'      ! needed for blank4, ...
  ! Local
  real :: size,dummy(1)
  integer :: i, j, sides, style, idlast, idsave, old_pen
  integer :: status, k, nc
  character(len=48) :: chain
  character(len=4) :: cloc
  !------------------------------------------------------------------------
  ! Code:
  ! first sort data according to ID (indexes in IND)
  call gi4_trie(id,ind,np,error)
  if (error) then
    call message(8,4,'GR4_IDENT','Error in sorting points')
    return
  endif
  !
  if (colour) then
    cloc = 'Y'
    !
    ! Compute maximum number of colours
    nc = 0
    do i=1,np
      nc = max(nc,id(i))
    enddo
    old_pen = gr_spen(0)
    !
    do k=1,nc
      status = gr_spen(mod(k-1,7))
      call gr_segm('IDENT',error)
      do i=1,np
        if (id(i).eq.k) then
          j = ind(i)
          call gr4_marker (1, x(j),y(j),   &
            blank4,d_blank4)
          if (bars) then
            call gr4_bars (cloc,1,   &
              x(j),y(j),b(j),dummy,   &
              blank4,d_blank4)
          endif
        endif
      enddo
      call gr_segm_close(error)
    enddo
    status = gr_spen(old_pen)
  else
    call gr_get_marker(sides,style,size)
    idlast = style + 1 + (sides-3)*4
    idsave = idlast
    call gr_set_marker(sides,style,size*3.0)
    do i=1, np
      if (id(i).ne.idlast) then
        idlast = id(i)
        sides = (idlast-1)/4 + 3
        style = idlast - (sides-3)*4 -1
        call gr_set_marker(sides,style,size*3.0)
        if (colour) then
          status = gr_spen(mod(idlast-1,7))
        endif
      endif
      j = ind(i)
      write(chain,100) x(j),y(j)
      call gr_exec1(chain)
      error = gr_error()
      if (error) return
    enddo
    sides = (idsave-1)/4 + 3
    style = idsave - (sides-3)*4 -1
    call gr_set_marker(sides,style,size)
  endif
  return
  !
100 format('DRAW MARKER ',1pg13.6,1x,1pg13.6,' /USER')
end subroutine gr4_ident
!
subroutine user_info(name)
  use gkernel_interfaces
  character(len=*) :: name          !
  ! Local
  character(len=20) :: date,user
  !------------------------------------------------------------------------
  ! Code:
  call sic_date(date)
  call sic_user(user)
  name = 'CLIC - '//date!//' - '//user
end subroutine user_info
!
subroutine getvar(md,mb,x_data,y_data,w_data)
  use gildas_def
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Load the plot buffers with the contents of related variables
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ipnt, nd, nb
  type(sic_descriptor_t) :: descr
  logical :: found
  ! Code ----------------------------------------------------------------
  ! X_DATA
  call sic_descriptor ('X_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,x_data)
  ! Y_DATA
  call sic_descriptor ('Y_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,y_data)
  ! W_DATA
  call sic_descriptor ('W_DATA',descr,found)
  if (.not.found) return
  ipnt = gag_pointer(descr%addr,memory)
  nd = descr%dims(1)
  nb = descr%dims(2)
  call copyvar(memory(ipnt),md,nd,nb,w_data)
  return
end subroutine getvar
!
subroutine reset_time
  use gildas_def
  use classic_api
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_xy_code.inc'
  include 'clic_par.inc'
  ! Local
  integer :: iy,isb,iba,i,k,km(2),kp(2), ir,ipol
  !
  km(1) = -mnant
  kp(1) = -1
  km(2) = 1
  kp(2) = mnbas
  !
  do ir=1, 2
    do iy=1, 2
      do isb=1, 3
        do k=1,2
          do ipol=1,3
            do iba = km(k), kp(k)
              f_spline(iy,isb,ipol,iba,ir) = 0
              n_knots(iy,isb,ipol,iba,ir) = 0
              do i=1, m_spl+4
                c_spline(i,iy,isb,ipol,iba,ir) = 0
              enddo
              do i=1, m_spl+8
                k_spline(i,iy,isb,ipol,iba,ir) = 0
              enddo
              do i=1, m_pol
                c_pol(i,iy,isb,ipol,iba,ir) = 0
              enddo
              n_pol(iy,isb,ipol,iba,ir) = 0
              f_pol(iy,isb,ipol,iba,ir) = 0
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
  dobs_0 = 0
  change_display = .true.
  call message(6,1,'CLIC_PLOT','Time origin reset')
  call message(6,2,'CLIC_PLOT','Calibration curves reset')
end subroutine reset_time

subroutine getcom(ligne,nl,lire,invite,np,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>getcom
  use sic_macros_interfaces
  use sic_structures
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Gets a Command Line for the Interpretor
  ! Arguments
  !       LIGNE   Command line read               Output
  !       NL      Length of line                  Output
  !       LIRE    Input pointer                   Input
  !       INVITE  Prompt                          Input
  !       NP      Length of prompt                Input
  !       ERROR   Logical error flag              Output
  !---------------------------------------------------------------------
  character(len=*) :: ligne         !
  integer :: nl                     !
  integer :: lire                   !
  character(len=*) :: invite        !
  integer :: np                     !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='GETCOM'
  logical :: suite,fopened
  integer(kind=4) :: n,nl2,ier
  character(len=message_length) :: mess
  character(len=128) :: fname
  ! Patch to read commands like HELP; SAY "toto";
  integer :: k
  logical :: string
  ! Data
  character(len=commandline_length), save :: pending  ! Pending line
  integer(kind=4), save :: npend  ! Length of 'pending' line
  logical, save :: several  ! Is there a pending line?
  data several /.false./
  !
  ! Reset line first
  suite = .false.
  nl    = 0
  ligne = ' '
  !
  ! CHeck if multiple lines
  !D    Print *,'TEST GETCOM ',Several
  if (several) then
    ligne = pending(1:npend)
    nl = npend
    !D  Print *,'TEST GETCOM Several ',ligne(1:nl)
    goto 100
  endif
  !
  ! Reads it from the Terminal
  if (lire.eq.0) then
10  continue
    if (edit_mode.and.inter_state) then
      if (suite)then
        np=np+1
        invite(np-2:np)='-? '
        call read_line(ligne(nl+1:),n,invite,np)
        invite(np-2:np)='>  '
        np=np-1
      else
        call read_line(ligne(nl+1:),n,invite,np)
      endif
      if (n.lt.0) goto 150
    else
      if (inter_state) then
        if (suite)then
          np=np+1
          invite(np-2:np)='-? '
          write(6,101) invite(1:np)
          invite(np-2:np)='>  '
          np=np-1
        else
          write(6,101) invite(1:np)
        endif
      endif
      read (5,'(A)',err=10,end=150) ligne(nl+1:)
      n = len_trim(ligne(nl+1:))
    endif
    !
    ! Trap CTRL-C typed at prompt
    call ctrlc_check(error)
    if (n.eq.0) then
      ! Empty command => optimized loop: do not go back to SIC
      goto 10
    endif
    if (n.ge.len(ligne(nl+1:))) goto 200
    ! SYSTEM call or SIC call?
    nl2 = nl+n
    if (sic_format_system_token(ligne,nl2)) then
      nl = nl2
      return
    else
      call sblanc(ligne(nl+1:),n,suite,ier)
      if (ier.ne.1) goto 201
    endif
    !
    ! Handles Continuation Lines
    nl= nl+n
    if (nl.eq.0 .or. suite) goto 10
    goto 100
  endif
  !
  ! Reads in the Loop
  if (lire.le.-2) then
    call getlin (ligne,nl,jloo,iloo,nloo,loolen,loobuf)
    if (nl.eq.0) goto 150
    if (lverif.and.(nl.ne.0).and..not.sic_quiet) then
      call sic_echo (invite,np,ligne,nl)
    endif
    goto 100
  endif
  !
  ! Command from program
  if (lire.eq.-1) then
    call sic_message(seve%e,'SIC','Internal logic error LIRE = -1')
    error = .true.
    return
  endif
  !
  ! Reads in a Macro
30 continue
  read (lunmac(lire),'(A)',iostat=ier) ligne(nl+1:)
  if (ier.ne.0) goto 202
  jmac(lire)=jmac(lire)+1
  n = len_trim(ligne(nl+1:))
  if (n.eq.0) goto 30
  if (jmac(lire).eq.1)  call sic_format_shebang(ligne(nl+1:),n)  ! First line only
  call sblanc(ligne(nl+1:),n,suite,ier)
  if (ier.ne.1) goto 201
  !
  ! Handles Continuation Lines
  nl= nl+n
  if (nl.eq.0) goto 30
  if (suite) goto 30
  !
  if (.not.proced) then
    call sic_macros_replace_args(ligne,nl,lire,error)
    if (error) return
  endif
  if (lverif.and.(nl.ne.0).and..not.sic_quiet) then
    call sic_echo (invite,np,ligne,nl)
  endif
  !
100 continue
  string = .false.
  do k=1,nl
    if (ligne(k:k).eq.'"') then
      string = .not.string
    elseif (.not.string) then
      if (ligne(k:k).eq.';') then
        ! print *,'TEST GETCOM found ',k
        if (k.lt.nl) then
          pending = ligne(k+1:nl)
          npend = nl-k
          several = .true.
          ligne(k:nl) = ' '
          nl = len_trim(ligne)     ! was K-1
          if (nl.gt.0) then
            call sblanc(pending(1:),npend,suite,ier)
            if (ier.ne.1) goto 201
            call aroba(ligne,nl,error)
          else
            ligne = pending(1:npend)
            nl = npend
            several = .false.
            call aroba(ligne,nl,error)
          endif
          !D    print *,'TEST Returning SEVERAL commands: ',several
          !D    print *,'TEST '//trim(ligne)
          !D    print *,'TEST '//trim(pending)
          return
        else
          nl=k-1
          if (nl.gt.0) then
            ligne(nl+1:) = ' '
          else
            ligne = 'C'
            nl = 1
          endif
          nl = len_trim(ligne)     ! was not there
        endif
      endif
    endif
  enddo
  several = .false.
  ! End patch
  !
  ! If the first character is an @, add a blank after it if necessary.
  call aroba(ligne,nl,error)
  if (.not.error) return
  !
200 call sic_message(seve%e,rname,'Line too long, buffer overflow')
  error=.true.
  return
201 nl = nl+n
  error = .true.
  return
  !
202 continue
  if (ier.ne.-1) then
    ! Everything else but EOF (-1) is an error
    inquire(unit=lunmac(lire),opened=fopened,name=fname)
    if (fopened) then
      write(mess,'(A,I0,3A)') 'Read error on macro file, unit ',lunmac(lire),' (opened on file ',trim(fname),')'
    else
      write(mess,'(A,I0,A)') 'Read error on macro file, unit ',lunmac(lire),' (closed)'
    endif
    call sic_message(seve%e,rname,mess)
    call putios('E-GETCOM,  ',ier)
    error = .true.
  endif
150 return
  !
entry putcom(ligne,nl,error)
  !---------------------------------------------------------------------
  ! Patch for multiple command lines
  ! Reprocess the input line to search for multiple lines in it.
  !---------------------------------------------------------------------
  if (several) then
    ! Beware!!! There is already a pending line in the stack. Brute
    ! force: readd it to the input line
    ligne = ligne(1:nl)//'; '//pending(1:npend)
    nl = nl+2+npend
  endif
  goto 100
  !
entry delcom
  !---------------------------------------------------------------------
  !  Delete pending command line. Useful when e.g. an error occurs
  ! when executing one command in the sequence:
  !  valid1; invalid2; valid3
  !---------------------------------------------------------------------
  several = .false.
  pending = ''
  npend = 0
  !
101 format(a,$)
  !
contains
  !
  subroutine sic_format_shebang(line,nline)
    !----------------------------------------------------------------------
    ! Detect shebang line and transform it into a comment line. By design
    ! shebang can only appear in the 2 first characters of the first line
    ! of a macro.
    !----------------------------------------------------------------------
    character(len=*), intent(inout) :: line
    integer(kind=4),  intent(in)    :: nline
    if (nline.ge.2 .and. line(1:2).eq.'#!')  line(1:2) = '!!'
  end subroutine sic_format_shebang
end subroutine getcom
!
subroutine getlin(ligne,nc,j,i,next,m,buf)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>getlin
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !  Retrieves a command line from an internal buffer
  !---------------------------------------------------------------------
  character(len=*),             intent(out)   :: ligne   ! Command line retrieved
  integer(kind=4),              intent(out)   :: nc      ! Length of line
  integer(kind=4),              intent(inout) :: j       ! Current buffer command number
  integer(kind=4),              intent(in)    :: i       ! First buffer command number
  integer(kind=4),              intent(inout) :: next    ! Pointer in buffer
  integer(kind=4),              intent(in)    :: m       ! Number of commands in buffer
  integer(kind=address_length), intent(in)    :: buf(*)  ! Internal buffer
  ! Local
  integer(kind=address_length) :: addr
  integer(kind=4) :: last
  !
  nc = 0
10 j = j + 1
  if (j.gt.m) return
  last = next
  next = next + (buf(next)+3)/4 + 3
  if (j.le.i) goto 10
  !
  nc = buf(last)
  addr = buf(last+1)
  call destoc(nc,addr,ligne)
  ligne(nc+1:) = ' '
end subroutine getlin
!
subroutine aroba (line,nl,error)
  use sic_interfaces, except_this=>aroba
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !
  !       Adds a blank space after an @ if the @ is the first char in LINE
  !       and is not already followed by a blank.
  !
  !       LINE    Command line to be modified     Updated
  !       NL      Length of line                  Updated
  !       ERROR   Logical error flag              Output
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: nl                     !
  logical :: error                  !
  ! Local
  integer :: i
  !
  if (line(1:1).eq.'@') then
    if (line(2:2).eq.' ') then
      return
    else
      if (nl.ge.len(line)) then
        error=.true.           ! Line too long
      else
        !              line = '@ '//line(2:)
        do i=nl,2,-1
          line(i+1:i+1) = line(i:i)
        enddo
        line(2:2) = ' '
        nl=nl+1
      endif
    endif
  endif
end subroutine aroba
!
subroutine sic_echo (invite,np,line,nl)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_echo
  use sic_interactions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Echo the command to the terminal in VERIFY mode
  ! Arguments
  !       INVITE  C*(*)   Prompt text
  !       NP      I       Length of prompt
  !       LINE    C*(*)   Command line including prompt
  !       NL      I       Length of LINE
  !---------------------------------------------------------------------
  character(len=*) :: invite        !
  integer :: np                     !
  character(len=*) :: line          !
  integer :: nl                     !
  ! Local
  integer :: n1,n2,tt_width,n
  character(len=4) :: ans
  integer, parameter :: mp=50       ! Prompt length...
  !
  tt_width = sic_ttyncol()
  n1 = 1
  n2 = tt_width-1-np
  if (n2.ge.nl) then
    if (sic_stepin.gt.0) then
      if (nl+np.lt.mp) then
        call sic_wprn(invite(1:np)//line(1:mp)//' ? ',ans,n)
      else
        write(6,1000) invite(1:np),line(1:nl)
        call sic_wprn(' ? ',ans,n)
      endif
    else
      write(6,1000) invite(1:np),line(1:nl)
    endif
    return
  else
    write(6,1000) invite(1:np),line(1:n2)
  endif
  !
10 n1 = n2+1
  n2 = n2+tt_width-1
  if (n2.ge.nl) then
    if (sic_stepin.gt.0) then
      if (nl-n1+1.lt.mp) then
        call sic_wprn(line(n1:mp+n1-1)//' ? ',ans,n)
      else
        write(6,1000) line(n1:nl)
        call sic_wprn(' ? ',ans,n)
      endif
    else
      write(6,1000) line(n1:nl)
    endif
    return
  endif
  write(6,1000) line(n1:n2),'-'
  goto 10
  !
1000 format(20(a))
end subroutine sic_echo

!
!  ALMA - Atacama Large Millimeter Array
!  (c) European Southern Observatory, 2002
!  (c) Associated Universities Inc., 2002
!  Copyright by ESO (in the framework of the ALMA collaboration),
!  Copyright by AUI (in the framework of the ALMA collaboration),
!  All rights reserved.
!
!  This library is free software; you can redistribute it and/or
!  modify it under the terms of the GNU Lesser General Public
!  License as published by the Free software Foundation; either
!  version 2.1 of the License, or (at your option) any later version.
!
!  This library is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY, without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with this library; if not, write to the Free Software
!  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
!  MA 02111-1307  USA
!
!                                                                /
!   WARNING!  DO NOT MODIFY THIS FILE!
!    ---------------------------------------------------------
!   | This is generated code!  Do not modify this file.       |
!   | Any changes will be lost when the file is re-generated. |
!    ---------------------------------------------------------
!                                                                /
!
!  File sdm_enumerations.f90
!
module sdm_Enumerations
  integer, parameter ::  AssociatedCalNature_ASSOCIATED_EXECBLOCK=0
  integer, parameter ::  PolarizationType_R=0 , PolarizationType_L=1 , PolarizationType_X=2 , PolarizationType_Y=3
  integer, parameter ::  SyscalMethod_TEMPERATURE_SCALE=0 , SyscalMethod_SKYDIP=1
  integer, parameter ::  CalCurveType_AMPLITUDE=0 , CalCurveType_PHASE=1 , CalCurveType_UNDEFINED=2
  integer, parameter :: CalDataOrigin_TOTAL_POWER=0 , CalDataOrigin_WVR=1 , CalDataOrigin_CHANNEL_AVERAGE_AUTO=2 ,&
      & CalDataOrigin_CHANNEL_AVERAGE_CROSS=3 , CalDataOrigin_FULL_RESOLUTION_AUTO=4 ,&
      & CalDataOrigin_FULL_RESOLUTION_CROSS=5 , CalDataOrigin_OPTICAL_POINTING=6 , CalDataOrigin_HOLOGRAPHY=7 ,&
      & CalDataOrigin_NONE=8
  integer, parameter :: CalType_CAL_AMPLI=0 , CalType_CAL_ATMOSPHERE=1 , CalType_CAL_BANDPASS=2 , CalType_CAL_CURVE=3 ,&
      & CalType_CAL_DELAY=4 , CalType_CAL_FLUX=5 , CalType_CAL_FOCUS=6 , CalType_CAL_FOCUS_MODEL=7 , CalType_CAL_GAIN=8&
      & , CalType_CAL_HOLOGRAPHY=9 , CalType_CAL_PHASE=10 , CalType_CAL_POINTING=11 , CalType_CAL_POINTING_MODEL=12 ,&
      & CalType_CAL_POSITION=13 , CalType_CAL_PRIMARY_BEAM=14 , CalType_CAL_SEEING=15 , CalType_CAL_WVR=16
  integer, parameter :: ScanIntent_CALIBRATE_AMPLI=0 , ScanIntent_CALIBRATE_ATMOSPHERE=1 ,&
      & ScanIntent_CALIBRATE_BANDPASS=2 , ScanIntent_CALIBRATE_DELAY=3 , ScanIntent_CALIBRATE_FLUX=4 ,&
      & ScanIntent_CALIBRATE_FOCUS=5 , ScanIntent_CALIBRATE_FOCUS_X=6 , ScanIntent_CALIBRATE_FOCUS_Y=7 ,&
      & ScanIntent_CALIBRATE_PHASE=8 , ScanIntent_CALIBRATE_POINTING=9 , ScanIntent_CALIBRATE_POLARIZATION=10 ,&
      & ScanIntent_CALIBRATE_SIDEBAND_RATIO=11 , ScanIntent_CALIBRATE_WVR=12 , ScanIntent_DO_SKYDIP=13 ,&
      & ScanIntent_MAP_ANTENNA_SURFACE=14 , ScanIntent_MAP_PRIMARY_BEAM=15 , ScanIntent_OBSERVE_TARGET=16 ,&
      & ScanIntent_TEST=17 , ScanIntent_UNSPECIFIED=18
  integer, parameter :: StokesParameter_I=0 , StokesParameter_Q=1 , StokesParameter_U=2 , StokesParameter_V=3 ,&
      & StokesParameter_RR=4 , StokesParameter_RL=5 , StokesParameter_LR=6 , StokesParameter_LL=7 ,&
      & StokesParameter_XX=8 , StokesParameter_XY=9 , StokesParameter_YX=10 , StokesParameter_YY=11 ,&
      & StokesParameter_RX=12 , StokesParameter_RY=13 , StokesParameter_LX=14 , StokesParameter_LY=15 ,&
      & StokesParameter_XR=16 , StokesParameter_XL=17 , StokesParameter_YR=18 , StokesParameter_YL=19 ,&
      & StokesParameter_PP=20 , StokesParameter_PQ=21 , StokesParameter_QP=22 , StokesParameter_QQ=23 ,&
      & StokesParameter_RCIRCULAR=24 , StokesParameter_LCIRCULAR=25 , StokesParameter_LINEAR=26 ,&
      & StokesParameter_PTOTAL=27 , StokesParameter_PLINEAR=28 , StokesParameter_PFTOTAL=29 ,&
      & StokesParameter_PFLINEAR=30 , StokesParameter_PANGLE=31
  integer, parameter :: FluxCalibrationMethod_ABSOLUTE=0 , FluxCalibrationMethod_RELATIVE=1 ,&
      & FluxCalibrationMethod_EFFICIENCY=2
  integer, parameter :: CalibrationMode_HOLOGRAPHY=0 , CalibrationMode_INTERFEROMETRY=1 , CalibrationMode_OPTICAL=2 ,&
      & CalibrationMode_RADIOMETRY=3 , CalibrationMode_WVR=4
  integer, parameter ::  FocusMethod_THREE_POINT=0 , FocusMethod_FIVE_POINT=1
  integer, parameter :: PointingMethod_THREE_POINT=0 , PointingMethod_FOUR_POINT=1 , PointingMethod_FIVE_POINT=2 ,&
      & PointingMethod_CROSS=3 , PointingMethod_CIRCLE=4
  integer, parameter :: WindowFunction_UNIFORM=0 , WindowFunction_HANNING=1 , WindowFunction_HAMMING=2 ,&
      & WindowFunction_BARTLETT=3 , WindowFunction_BLACKMANN=4 , WindowFunction_BLACKMANN_HARRIS=5 ,&
      & WindowFunction_WELCH=6
  integer, parameter :: AssociatedFieldNature_ON=0 , AssociatedFieldNature_OFF=1 ,&
      & AssociatedFieldNature_PHASE_REFERENCE=2
  integer, parameter ::  ProcessorType_CORRELATOR=0 , ProcessorType_RADIOMETER=1 , ProcessorType_SPECTROMETER=2
  integer, parameter ::  SourceModel_GAUSSIAN=0 , SourceModel_POINT=1 , SourceModel_DISK=2
  integer, parameter ::  NetSideband_NOSB=0 , NetSideband_LSB=1 , NetSideband_USB=2 , NetSideband_DSB=3
  integer, parameter :: ReceiverSideband_NOSB=0 , ReceiverSideband_DSB=1 , ReceiverSideband_SSB=2 ,&
      & ReceiverSideband_TSB=3
  integer, parameter :: SidebandProcessingMode_NONE=0 , SidebandProcessingMode_PHASE_SWITCH_SEPARATION=1 ,&
      & SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION=2 , SidebandProcessingMode_PHASE_SWITCH_REJECTION=3 ,&
      & SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION=4
  integer, parameter :: SwitchingMode_NO_SWITCHING=0 , SwitchingMode_LOAD_SWITCHING=1 ,&
      & SwitchingMode_POSITION_SWITCHING=2 , SwitchingMode_PHASE_SWITCHING=3 , SwitchingMode_FREQUENCY_SWITCHING=4 ,&
      & SwitchingMode_NUTATOR_SWITCHING=5 , SwitchingMode_CHOPPER_WHEEL=6
  integer, parameter ::  StationType_ANTENNA_PAD=0 , StationType_MAINTENANCE_PAD=1 , StationType_WEATHER_STATION=2
  integer, parameter :: SubscanIntent_ON_SOURCE=0 , SubscanIntent_OFF_SOURCE=1 , SubscanIntent_MIXED=2 ,&
      & SubscanIntent_REFERENCE=3 , SubscanIntent_SCANNING=4 , SubscanIntent_HOT=5 , SubscanIntent_AMBIENT=6 ,&
      & SubscanIntent_TEST=7 , SubscanIntent_UNSPECIFIED=8
  integer, parameter :: BasebandName_NOBB=0 , BasebandName_BB_1=1 , BasebandName_BB_2=2 , BasebandName_BB_3=3 ,&
      & BasebandName_BB_4=4 , BasebandName_BB_5=5 , BasebandName_BB_6=6 , BasebandName_BB_7=7 , BasebandName_BB_8=8 ,&
      & BasebandName_BB_ALL=9
  integer, parameter :: AxisName_TIM=0 , AxisName_BAL=1 , AxisName_ANT=2 , AxisName_BAB=3 , AxisName_SPW=4 ,&
      & AxisName_SIB=5 , AxisName_SUB=6 , AxisName_BIN=7 , AxisName_APC=8 , AxisName_SPP=9 , AxisName_POL=10 ,&
      & AxisName_STO=11 , AxisName_HOL=12
  integer, parameter :: DataContent_CROSS_DATA=0 , DataContent_AUTO_DATA=1 , DataContent_ZERO_LAGS=2 ,&
      & DataContent_ACTUAL_TIMES=3 , DataContent_ACTUAL_DURATIONS=4 , DataContent_WEIGHTS=5 , DataContent_FLAGS=6
  integer, parameter ::  AtmPhaseCorrection_AP_UNCORRECTED=0 , AtmPhaseCorrection_AP_CORRECTED=1
  integer, parameter :: PrimitiveDataType_INT16_TYPE=0 , PrimitiveDataType_INT32_TYPE=1 ,&
      & PrimitiveDataType_INT64_TYPE=2 , PrimitiveDataType_FLOAT32_TYPE=3 , PrimitiveDataType_FLOAT64_TYPE=4
  integer, parameter :: CorrelationMode_CROSS_ONLY=0 , CorrelationMode_AUTO_ONLY=1 , CorrelationMode_CROSS_AND_AUTO=2
  integer, parameter ::  WVRMethod_ATM_MODEL=0 , WVRMethod_EMPIRICAL=1
  integer, parameter ::  AccumMode_FAST=0 , AccumMode_NORMAL=1 , AccumMode_UNDEFINED=2
  integer, parameter ::  AntennaType_GROUND_BASED=0 , AntennaType_SPACE_BASED=1 , AntennaType_TRACKING_STN=2
  integer, parameter :: AntennaMake_AEM_12=0 , AntennaMake_MITSUBISHI_7=1 , AntennaMake_MITSUBISHI_12_A=2 ,&
      & AntennaMake_MITSUBISHI_12_B=3 , AntennaMake_VERTEX_12_ATF=4 , AntennaMake_AEM_12_ATF=5 ,&
      & AntennaMake_VERTEX_12=6 , AntennaMake_IRAM_15=7 , AntennaMake_UNDEFINED=8
  integer, parameter ::  PositionMethod_DELAY_FITTING=0 , PositionMethod_PHASE_FITTING=1
  integer, parameter ::  PointingModelMode_RADIO=0 , PointingModelMode_OPTICAL=1
  integer, parameter :: InvalidatingCondition_ANTENNA_DISCONNECT=0 , InvalidatingCondition_ANTENNA_MOVE=1 ,&
      & InvalidatingCondition_ANTENNA_POWER_DOWN=2 , InvalidatingCondition_RECEIVER_EXCHANGE=3 ,&
      & InvalidatingCondition_RECEIVER_POWER_DOWN=4
  integer, parameter :: SchedulerMode_DYNAMIC=0 , SchedulerMode_INTERACTIVE=1 , SchedulerMode_MANUAL=2 ,&
      & SchedulerMode_QUEUED=3
  integer, parameter ::  FieldCode_NONE=0
  integer, parameter :: HolographyChannelType_Q2=0 , HolographyChannelType_QR=1 , HolographyChannelType_QS=2 ,&
      & HolographyChannelType_R2=3 , HolographyChannelType_RS=4 , HolographyChannelType_S2=5
  integer, parameter :: ProcessorSubType_ALMA_CORRELATOR_MODE=0 , ProcessorSubType_SQUARE_LAW_DETECTOR=1 ,&
      & ProcessorSubType_HOLOGRAPHY=2 , ProcessorSubType_ALMA_RADIOMETER=3
  integer, parameter :: ReceiverBand_ALMA_RB_01=0 , ReceiverBand_ALMA_RB_02=1 , ReceiverBand_ALMA_RB_03=2 ,&
      & ReceiverBand_ALMA_RB_04=3 , ReceiverBand_ALMA_RB_05=4 , ReceiverBand_ALMA_RB_06=5 , ReceiverBand_ALMA_RB_07=6 ,&
      & ReceiverBand_ALMA_RB_08=7 , ReceiverBand_ALMA_RB_09=8 , ReceiverBand_ALMA_RB_10=9 , ReceiverBand_ALMA_RB_ALL=10&
      & , ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER=11 , ReceiverBand_BURE_01=12 , ReceiverBand_BURE_02=13 ,&
      & ReceiverBand_BURE_03=14 , ReceiverBand_BURE_04=15 , ReceiverBand_UNSPECIFIED=16
  integer, parameter ::  SBType_OBSERVATORY=0 , SBType_OBSERVER=1 , SBType_EXPERT=2
  integer, parameter :: SpectralResolutionType_CHANNEL_AVERAGE=0 , SpectralResolutionType_BASEBAND_WIDE=1 ,&
      & SpectralResolutionType_FULL_RESOLUTION=2
  integer, parameter :: DetectorBandType_BASEBAND=0 , DetectorBandType_DOWN_CONVERTER=1 ,&
      & DetectorBandType_HOLOGRAPHY_RECEIVER=2 , DetectorBandType_SUBBAND=3
  integer, parameter :: FilterMode_FILTER_NA=0 , FilterMode_FILTER_TDM=1 , FilterMode_FILTER_TFB=2 ,&
      & FilterMode_UNDEFINED=3
  integer, parameter ::  CorrelationBit_BITS_2x2=0 , CorrelationBit_BITS_3x3=1 , CorrelationBit_BITS_4x4=2
  integer, parameter :: ACAPolarization_ACA_STANDARD=0 , ACAPolarization_ACA_XX_YY_SUM=1 , ACAPolarization_ACA_XX_50=2&
      & , ACAPolarization_ACA_YY_50=3
  integer, parameter :: CorrelatorCalibration_NONE=0 , CorrelatorCalibration_CORRELATOR_CALIBRATION=1 ,&
      & CorrelatorCalibration_REAL_OBSERVATION=2
  integer, parameter :: CorrelatorName_ALMA_ACA=0 , CorrelatorName_ALMA_BASELINE=1 , CorrelatorName_ALMA_BASELINE_ATF=2&
      & , CorrelatorName_ALMA_BASELINE_PROTO_OSF=3 , CorrelatorName_HERSCHEL=4 , CorrelatorName_IRAM_PDB=5 ,&
      & CorrelatorName_IRAM_30M_VESPA=6 , CorrelatorName_IRAM_WILMA=7 , CorrelatorName_NRAO_VLA=8 ,&
      & CorrelatorName_NRAO_WIDAR=9
  integer, parameter ::  TimeSampling_SUBINTEGRATION=0 , TimeSampling_INTEGRATION=1
  integer, parameter :: CalibrationDevice_AMBIENT_LOAD=0 , CalibrationDevice_COLD_LOAD=1 , CalibrationDevice_HOT_LOAD=2&
      & , CalibrationDevice_NOISE_TUBE_LOAD=3 , CalibrationDevice_QUARTER_WAVE_PLATE=4 ,&
      & CalibrationDevice_SOLAR_FILTER=5 , CalibrationDevice_NONE=6
  integer, parameter :: AntennaMotionPattern_NONE=0 , AntennaMotionPattern_CROSS_SCAN=1 , AntennaMotionPattern_SPIRAL=2&
      & , AntennaMotionPattern_CIRCLE=3 , AntennaMotionPattern_THREE_POINTS=4 , AntennaMotionPattern_FOUR_POINTS=5 ,&
      & AntennaMotionPattern_FIVE_POINTS=6 , AntennaMotionPattern_TEST=7 , AntennaMotionPattern_UNSPECIFIED=8
  integer, parameter :: CalibrationFunction_FIRST=0 , CalibrationFunction_LAST=1 , CalibrationFunction_UNSPECIFIED=2
  integer, parameter :: CalibrationSet_NONE=0 , CalibrationSet_AMPLI_CURVE=1 , CalibrationSet_ANTENNA_POSITIONS=2 ,&
      & CalibrationSet_PHASE_CURVE=3 , CalibrationSet_POINTING_MODEL=4 , CalibrationSet_ACCUMULATE=5 ,&
      & CalibrationSet_TEST=6 , CalibrationSet_UNSPECIFIED=7
  integer, parameter :: PositionReferenceCode_ITRF=0 , PositionReferenceCode_WGS84=1 , PositionReferenceCode_SITE=2 ,&
      & PositionReferenceCode_STATION=3 , PositionReferenceCode_YOKE=4 , PositionReferenceCode_REFLECTOR=5
  integer, parameter :: DirectionReferenceCode_J2000=0 , DirectionReferenceCode_JMEAN=1 ,&
      & DirectionReferenceCode_JTRUE=2 , DirectionReferenceCode_APP=3 , DirectionReferenceCode_B1950=4 ,&
      & DirectionReferenceCode_B1950_VLA=5 , DirectionReferenceCode_BMEAN=6 , DirectionReferenceCode_BTRUE=7 ,&
      & DirectionReferenceCode_GALACTIC=8 , DirectionReferenceCode_HADEC=9 , DirectionReferenceCode_AZELSW=10 ,&
      & DirectionReferenceCode_AZELSWGEO=11 , DirectionReferenceCode_AZELNE=12 , DirectionReferenceCode_AZELNEGEO=13 ,&
      & DirectionReferenceCode_JNAT=14 , DirectionReferenceCode_ECLIPTIC=15 , DirectionReferenceCode_MECLIPTIC=16 ,&
      & DirectionReferenceCode_TECLIPTIC=17 , DirectionReferenceCode_SUPERGAL=18 , DirectionReferenceCode_ITRF=19 ,&
      & DirectionReferenceCode_TOPO=20 , DirectionReferenceCode_ICRS=21 , DirectionReferenceCode_MERCURY=22 ,&
      & DirectionReferenceCode_VENUS=23 , DirectionReferenceCode_MARS=24 , DirectionReferenceCode_JUPITER=25 ,&
      & DirectionReferenceCode_SATURN=26 , DirectionReferenceCode_URANUS=27 , DirectionReferenceCode_NEPTUNE=28 ,&
      & DirectionReferenceCode_PLUTO=29 , DirectionReferenceCode_SUN=30 , DirectionReferenceCode_MOON=31
  integer, parameter :: BaselineReferenceCode_J2000=0 , BaselineReferenceCode_B1950=1 ,&
      & BaselineReferenceCode_GALACTIC=2 , BaselineReferenceCode_SUPERGAL=3 , BaselineReferenceCode_ECLIPTIC=4 ,&
      & BaselineReferenceCode_JMEAN=5 , BaselineReferenceCode_JTRUE=6 , BaselineReferenceCode_APP=7 ,&
      & BaselineReferenceCode_BMEAN=8 , BaselineReferenceCode_BTRUE=9 , BaselineReferenceCode_JNAT=10 ,&
      & BaselineReferenceCode_MECLIPTIC=11 , BaselineReferenceCode_TECLIPTIC=12 , BaselineReferenceCode_TOPO=13 ,&
      & BaselineReferenceCode_MERCURY=14 , BaselineReferenceCode_VENUS=15 , BaselineReferenceCode_MARS=16 ,&
      & BaselineReferenceCode_JUPITER=17 , BaselineReferenceCode_SATURN=18 , BaselineReferenceCode_NEPTUN=19 ,&
      & BaselineReferenceCode_SUN=20 , BaselineReferenceCode_MOON=21 , BaselineReferenceCode_HADEC=22 ,&
      & BaselineReferenceCode_AZEL=23 , BaselineReferenceCode_AZELGEO=24 , BaselineReferenceCode_AZELSW=25 ,&
      & BaselineReferenceCode_AZELNE=26 , BaselineReferenceCode_ITRF=27
  integer, parameter :: FrequencyReferenceCode_LABREST=0 , FrequencyReferenceCode_LSRD=1 ,&
      & FrequencyReferenceCode_LSRK=2 , FrequencyReferenceCode_BARY=3 , FrequencyReferenceCode_REST=4 ,&
      & FrequencyReferenceCode_GEO=5 , FrequencyReferenceCode_GALACTO=6 , FrequencyReferenceCode_TOPO=7
  integer, parameter :: RadialVelocityReferenceCode_LSRD=0 , RadialVelocityReferenceCode_LSRK=1 ,&
      & RadialVelocityReferenceCode_GALACTO=2 , RadialVelocityReferenceCode_BARY=3 , RadialVelocityReferenceCode_GEO=4&
      & , RadialVelocityReferenceCode_TOPO=5
  integer, parameter :: DopplerReferenceCode_RADIO=0 , DopplerReferenceCode_Z=1 , DopplerReferenceCode_RATIO=2 ,&
      & DopplerReferenceCode_BETA=3 , DopplerReferenceCode_GAMMA=4 , DopplerReferenceCode_OPTICAL=5 ,&
      & DopplerReferenceCode_RELATIVISTIC=6
  integer, parameter ::  CorrelatorType_FX=0 , CorrelatorType_XF=1 , CorrelatorType_FXF=2
contains
!
  function AssociatedCalNature_toString(i)
    integer :: i
    character*80 :: AssociatedCalNature_toString
    select case(i)
    case(AssociatedCalNature_ASSOCIATED_EXECBLOCK)
       AssociatedCalNature_toString = 'ASSOCIATED_EXECBLOCK'
    end select
  end function AssociatedCalNature_toString
!
  function AssociatedCalNature_fromString(str)
    integer :: AssociatedCalNature_fromString
    character*80 :: str
    select case(str)
    case('ASSOCIATED_EXECBLOCK')
       AssociatedCalNature_fromString = AssociatedCalNature_ASSOCIATED_EXECBLOCK
    end select
  end function AssociatedCalNature_fromString
!
  function PolarizationType_toString(i)
    integer :: i
    character*80 :: PolarizationType_toString
    select case(i)
    case(PolarizationType_R)
       PolarizationType_toString = 'R'
    case(PolarizationType_L)
       PolarizationType_toString = 'L'
    case(PolarizationType_X)
       PolarizationType_toString = 'X'
    case(PolarizationType_Y)
       PolarizationType_toString = 'Y'
    end select
  end function PolarizationType_toString
!
  function PolarizationType_fromString(str)
    integer :: PolarizationType_fromString
    character*80 :: str
    select case(str)
    case('R')
       PolarizationType_fromString = PolarizationType_R
    case('L')
       PolarizationType_fromString = PolarizationType_L
    case('X')
       PolarizationType_fromString = PolarizationType_X
    case('Y')
       PolarizationType_fromString = PolarizationType_Y
    end select
  end function PolarizationType_fromString
!
  function SyscalMethod_toString(i)
    integer :: i
    character*80 :: SyscalMethod_toString
    select case(i)
    case(SyscalMethod_TEMPERATURE_SCALE)
       SyscalMethod_toString = 'TEMPERATURE_SCALE'
    case(SyscalMethod_SKYDIP)
       SyscalMethod_toString = 'SKYDIP'
    end select
  end function SyscalMethod_toString
!
  function SyscalMethod_fromString(str)
    integer :: SyscalMethod_fromString
    character*80 :: str
    select case(str)
    case('TEMPERATURE_SCALE')
       SyscalMethod_fromString = SyscalMethod_TEMPERATURE_SCALE
    case('SKYDIP')
       SyscalMethod_fromString = SyscalMethod_SKYDIP
    end select
  end function SyscalMethod_fromString
!
  function CalCurveType_toString(i)
    integer :: i
    character*80 :: CalCurveType_toString
    select case(i)
    case(CalCurveType_AMPLITUDE)
       CalCurveType_toString = 'AMPLITUDE'
    case(CalCurveType_PHASE)
       CalCurveType_toString = 'PHASE'
    case(CalCurveType_UNDEFINED)
       CalCurveType_toString = 'UNDEFINED'
    end select
  end function CalCurveType_toString
!
  function CalCurveType_fromString(str)
    integer :: CalCurveType_fromString
    character*80 :: str
    select case(str)
    case('AMPLITUDE')
       CalCurveType_fromString = CalCurveType_AMPLITUDE
    case('PHASE')
       CalCurveType_fromString = CalCurveType_PHASE
    case('UNDEFINED')
       CalCurveType_fromString = CalCurveType_UNDEFINED
    end select
  end function CalCurveType_fromString
!
  function CalDataOrigin_toString(i)
    integer :: i
    character*80 :: CalDataOrigin_toString
    select case(i)
    case(CalDataOrigin_TOTAL_POWER)
       CalDataOrigin_toString = 'TOTAL_POWER'
    case(CalDataOrigin_WVR)
       CalDataOrigin_toString = 'WVR'
    case(CalDataOrigin_CHANNEL_AVERAGE_AUTO)
       CalDataOrigin_toString = 'CHANNEL_AVERAGE_AUTO'
    case(CalDataOrigin_CHANNEL_AVERAGE_CROSS)
       CalDataOrigin_toString = 'CHANNEL_AVERAGE_CROSS'
    case(CalDataOrigin_FULL_RESOLUTION_AUTO)
       CalDataOrigin_toString = 'FULL_RESOLUTION_AUTO'
    case(CalDataOrigin_FULL_RESOLUTION_CROSS)
       CalDataOrigin_toString = 'FULL_RESOLUTION_CROSS'
    case(CalDataOrigin_OPTICAL_POINTING)
       CalDataOrigin_toString = 'OPTICAL_POINTING'
    case(CalDataOrigin_HOLOGRAPHY)
       CalDataOrigin_toString = 'HOLOGRAPHY'
    case(CalDataOrigin_NONE)
       CalDataOrigin_toString = 'NONE'
    end select
  end function CalDataOrigin_toString
!
  function CalDataOrigin_fromString(str)
    integer :: CalDataOrigin_fromString
    character*80 :: str
    select case(str)
    case('TOTAL_POWER')
       CalDataOrigin_fromString = CalDataOrigin_TOTAL_POWER
    case('WVR')
       CalDataOrigin_fromString = CalDataOrigin_WVR
    case('CHANNEL_AVERAGE_AUTO')
       CalDataOrigin_fromString = CalDataOrigin_CHANNEL_AVERAGE_AUTO
    case('CHANNEL_AVERAGE_CROSS')
       CalDataOrigin_fromString = CalDataOrigin_CHANNEL_AVERAGE_CROSS
    case('FULL_RESOLUTION_AUTO')
       CalDataOrigin_fromString = CalDataOrigin_FULL_RESOLUTION_AUTO
    case('FULL_RESOLUTION_CROSS')
       CalDataOrigin_fromString = CalDataOrigin_FULL_RESOLUTION_CROSS
    case('OPTICAL_POINTING')
       CalDataOrigin_fromString = CalDataOrigin_OPTICAL_POINTING
    case('HOLOGRAPHY')
       CalDataOrigin_fromString = CalDataOrigin_HOLOGRAPHY
    case('NONE')
       CalDataOrigin_fromString = CalDataOrigin_NONE
    end select
  end function CalDataOrigin_fromString
!
  function CalType_toString(i)
    integer :: i
    character*80 :: CalType_toString
    select case(i)
    case(CalType_CAL_AMPLI)
       CalType_toString = 'CAL_AMPLI'
    case(CalType_CAL_ATMOSPHERE)
       CalType_toString = 'CAL_ATMOSPHERE'
    case(CalType_CAL_BANDPASS)
       CalType_toString = 'CAL_BANDPASS'
    case(CalType_CAL_CURVE)
       CalType_toString = 'CAL_CURVE'
    case(CalType_CAL_DELAY)
       CalType_toString = 'CAL_DELAY'
    case(CalType_CAL_FLUX)
       CalType_toString = 'CAL_FLUX'
    case(CalType_CAL_FOCUS)
       CalType_toString = 'CAL_FOCUS'
    case(CalType_CAL_FOCUS_MODEL)
       CalType_toString = 'CAL_FOCUS_MODEL'
    case(CalType_CAL_GAIN)
       CalType_toString = 'CAL_GAIN'
    case(CalType_CAL_HOLOGRAPHY)
       CalType_toString = 'CAL_HOLOGRAPHY'
    case(CalType_CAL_PHASE)
       CalType_toString = 'CAL_PHASE'
    case(CalType_CAL_POINTING)
       CalType_toString = 'CAL_POINTING'
    case(CalType_CAL_POINTING_MODEL)
       CalType_toString = 'CAL_POINTING_MODEL'
    case(CalType_CAL_POSITION)
       CalType_toString = 'CAL_POSITION'
    case(CalType_CAL_PRIMARY_BEAM)
       CalType_toString = 'CAL_PRIMARY_BEAM'
    case(CalType_CAL_SEEING)
       CalType_toString = 'CAL_SEEING'
    case(CalType_CAL_WVR)
       CalType_toString = 'CAL_WVR'
    end select
  end function CalType_toString
!
  function CalType_fromString(str)
    integer :: CalType_fromString
    character*80 :: str
    select case(str)
    case('CAL_AMPLI')
       CalType_fromString = CalType_CAL_AMPLI
    case('CAL_ATMOSPHERE')
       CalType_fromString = CalType_CAL_ATMOSPHERE
    case('CAL_BANDPASS')
       CalType_fromString = CalType_CAL_BANDPASS
    case('CAL_CURVE')
       CalType_fromString = CalType_CAL_CURVE
    case('CAL_DELAY')
       CalType_fromString = CalType_CAL_DELAY
    case('CAL_FLUX')
       CalType_fromString = CalType_CAL_FLUX
    case('CAL_FOCUS')
       CalType_fromString = CalType_CAL_FOCUS
    case('CAL_FOCUS_MODEL')
       CalType_fromString = CalType_CAL_FOCUS_MODEL
    case('CAL_GAIN')
       CalType_fromString = CalType_CAL_GAIN
    case('CAL_HOLOGRAPHY')
       CalType_fromString = CalType_CAL_HOLOGRAPHY
    case('CAL_PHASE')
       CalType_fromString = CalType_CAL_PHASE
    case('CAL_POINTING')
       CalType_fromString = CalType_CAL_POINTING
    case('CAL_POINTING_MODEL')
       CalType_fromString = CalType_CAL_POINTING_MODEL
    case('CAL_POSITION')
       CalType_fromString = CalType_CAL_POSITION
    case('CAL_PRIMARY_BEAM')
       CalType_fromString = CalType_CAL_PRIMARY_BEAM
    case('CAL_SEEING')
       CalType_fromString = CalType_CAL_SEEING
    case('CAL_WVR')
       CalType_fromString = CalType_CAL_WVR
    end select
  end function CalType_fromString
!
  function ScanIntent_toString(i)
    integer :: i
    character*80 :: ScanIntent_toString
    select case(i)
    case(ScanIntent_CALIBRATE_AMPLI)
       ScanIntent_toString = 'CALIBRATE_AMPLI'
    case(ScanIntent_CALIBRATE_ATMOSPHERE)
       ScanIntent_toString = 'CALIBRATE_ATMOSPHERE'
    case(ScanIntent_CALIBRATE_BANDPASS)
       ScanIntent_toString = 'CALIBRATE_BANDPASS'
    case(ScanIntent_CALIBRATE_DELAY)
       ScanIntent_toString = 'CALIBRATE_DELAY'
    case(ScanIntent_CALIBRATE_FLUX)
       ScanIntent_toString = 'CALIBRATE_FLUX'
    case(ScanIntent_CALIBRATE_FOCUS)
       ScanIntent_toString = 'CALIBRATE_FOCUS'
    case(ScanIntent_CALIBRATE_FOCUS_X)
       ScanIntent_toString = 'CALIBRATE_FOCUS_X'
    case(ScanIntent_CALIBRATE_FOCUS_Y)
       ScanIntent_toString = 'CALIBRATE_FOCUS_Y'
    case(ScanIntent_CALIBRATE_PHASE)
       ScanIntent_toString = 'CALIBRATE_PHASE'
    case(ScanIntent_CALIBRATE_POINTING)
       ScanIntent_toString = 'CALIBRATE_POINTING'
    case(ScanIntent_CALIBRATE_POLARIZATION)
       ScanIntent_toString = 'CALIBRATE_POLARIZATION'
    case(ScanIntent_CALIBRATE_SIDEBAND_RATIO)
       ScanIntent_toString = 'CALIBRATE_SIDEBAND_RATIO'
    case(ScanIntent_CALIBRATE_WVR)
       ScanIntent_toString = 'CALIBRATE_WVR'
    case(ScanIntent_DO_SKYDIP)
       ScanIntent_toString = 'DO_SKYDIP'
    case(ScanIntent_MAP_ANTENNA_SURFACE)
       ScanIntent_toString = 'MAP_ANTENNA_SURFACE'
    case(ScanIntent_MAP_PRIMARY_BEAM)
       ScanIntent_toString = 'MAP_PRIMARY_BEAM'
    case(ScanIntent_OBSERVE_TARGET)
       ScanIntent_toString = 'OBSERVE_TARGET'
    case(ScanIntent_TEST)
       ScanIntent_toString = 'TEST'
    case(ScanIntent_UNSPECIFIED)
       ScanIntent_toString = 'UNSPECIFIED'
    end select
  end function ScanIntent_toString
!
  function ScanIntent_fromString(str)
    integer :: ScanIntent_fromString
    character*80 :: str
    select case(str)
    case('CALIBRATE_AMPLI')
       ScanIntent_fromString = ScanIntent_CALIBRATE_AMPLI
    case('CALIBRATE_ATMOSPHERE')
       ScanIntent_fromString = ScanIntent_CALIBRATE_ATMOSPHERE
    case('CALIBRATE_BANDPASS')
       ScanIntent_fromString = ScanIntent_CALIBRATE_BANDPASS
    case('CALIBRATE_DELAY')
       ScanIntent_fromString = ScanIntent_CALIBRATE_DELAY
    case('CALIBRATE_FLUX')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FLUX
    case('CALIBRATE_FOCUS')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS
    case('CALIBRATE_FOCUS_X')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS_X
    case('CALIBRATE_FOCUS_Y')
       ScanIntent_fromString = ScanIntent_CALIBRATE_FOCUS_Y
    case('CALIBRATE_PHASE')
       ScanIntent_fromString = ScanIntent_CALIBRATE_PHASE
    case('CALIBRATE_POINTING')
       ScanIntent_fromString = ScanIntent_CALIBRATE_POINTING
    case('CALIBRATE_POLARIZATION')
       ScanIntent_fromString = ScanIntent_CALIBRATE_POLARIZATION
    case('CALIBRATE_SIDEBAND_RATIO')
       ScanIntent_fromString = ScanIntent_CALIBRATE_SIDEBAND_RATIO
    case('CALIBRATE_WVR')
       ScanIntent_fromString = ScanIntent_CALIBRATE_WVR
    case('DO_SKYDIP')
       ScanIntent_fromString = ScanIntent_DO_SKYDIP
    case('MAP_ANTENNA_SURFACE')
       ScanIntent_fromString = ScanIntent_MAP_ANTENNA_SURFACE
    case('MAP_PRIMARY_BEAM')
       ScanIntent_fromString = ScanIntent_MAP_PRIMARY_BEAM
    case('OBSERVE_TARGET')
       ScanIntent_fromString = ScanIntent_OBSERVE_TARGET
    case('TEST')
       ScanIntent_fromString = ScanIntent_TEST
    case('UNSPECIFIED')
       ScanIntent_fromString = ScanIntent_UNSPECIFIED
    end select
  end function ScanIntent_fromString
!
  function StokesParameter_toString(i)
    integer :: i
    character*80 :: StokesParameter_toString
    select case(i)
    case(StokesParameter_I)
       StokesParameter_toString = 'I'
    case(StokesParameter_Q)
       StokesParameter_toString = 'Q'
    case(StokesParameter_U)
       StokesParameter_toString = 'U'
    case(StokesParameter_V)
       StokesParameter_toString = 'V'
    case(StokesParameter_RR)
       StokesParameter_toString = 'RR'
    case(StokesParameter_RL)
       StokesParameter_toString = 'RL'
    case(StokesParameter_LR)
       StokesParameter_toString = 'LR'
    case(StokesParameter_LL)
       StokesParameter_toString = 'LL'
    case(StokesParameter_XX)
       StokesParameter_toString = 'XX'
    case(StokesParameter_XY)
       StokesParameter_toString = 'XY'
    case(StokesParameter_YX)
       StokesParameter_toString = 'YX'
    case(StokesParameter_YY)
       StokesParameter_toString = 'YY'
    case(StokesParameter_RX)
       StokesParameter_toString = 'RX'
    case(StokesParameter_RY)
       StokesParameter_toString = 'RY'
    case(StokesParameter_LX)
       StokesParameter_toString = 'LX'
    case(StokesParameter_LY)
       StokesParameter_toString = 'LY'
    case(StokesParameter_XR)
       StokesParameter_toString = 'XR'
    case(StokesParameter_XL)
       StokesParameter_toString = 'XL'
    case(StokesParameter_YR)
       StokesParameter_toString = 'YR'
    case(StokesParameter_YL)
       StokesParameter_toString = 'YL'
    case(StokesParameter_PP)
       StokesParameter_toString = 'PP'
    case(StokesParameter_PQ)
       StokesParameter_toString = 'PQ'
    case(StokesParameter_QP)
       StokesParameter_toString = 'QP'
    case(StokesParameter_QQ)
       StokesParameter_toString = 'QQ'
    case(StokesParameter_RCIRCULAR)
       StokesParameter_toString = 'RCIRCULAR'
    case(StokesParameter_LCIRCULAR)
       StokesParameter_toString = 'LCIRCULAR'
    case(StokesParameter_LINEAR)
       StokesParameter_toString = 'LINEAR'
    case(StokesParameter_PTOTAL)
       StokesParameter_toString = 'PTOTAL'
    case(StokesParameter_PLINEAR)
       StokesParameter_toString = 'PLINEAR'
    case(StokesParameter_PFTOTAL)
       StokesParameter_toString = 'PFTOTAL'
    case(StokesParameter_PFLINEAR)
       StokesParameter_toString = 'PFLINEAR'
    case(StokesParameter_PANGLE)
       StokesParameter_toString = 'PANGLE'
    end select
  end function StokesParameter_toString
!
  function StokesParameter_fromString(str)
    integer :: StokesParameter_fromString
    character*80 :: str
    select case(str)
    case('I')
       StokesParameter_fromString = StokesParameter_I
    case('Q')
       StokesParameter_fromString = StokesParameter_Q
    case('U')
       StokesParameter_fromString = StokesParameter_U
    case('V')
       StokesParameter_fromString = StokesParameter_V
    case('RR')
       StokesParameter_fromString = StokesParameter_RR
    case('RL')
       StokesParameter_fromString = StokesParameter_RL
    case('LR')
       StokesParameter_fromString = StokesParameter_LR
    case('LL')
       StokesParameter_fromString = StokesParameter_LL
    case('XX')
       StokesParameter_fromString = StokesParameter_XX
    case('XY')
       StokesParameter_fromString = StokesParameter_XY
    case('YX')
       StokesParameter_fromString = StokesParameter_YX
    case('YY')
       StokesParameter_fromString = StokesParameter_YY
    case('RX')
       StokesParameter_fromString = StokesParameter_RX
    case('RY')
       StokesParameter_fromString = StokesParameter_RY
    case('LX')
       StokesParameter_fromString = StokesParameter_LX
    case('LY')
       StokesParameter_fromString = StokesParameter_LY
    case('XR')
       StokesParameter_fromString = StokesParameter_XR
    case('XL')
       StokesParameter_fromString = StokesParameter_XL
    case('YR')
       StokesParameter_fromString = StokesParameter_YR
    case('YL')
       StokesParameter_fromString = StokesParameter_YL
    case('PP')
       StokesParameter_fromString = StokesParameter_PP
    case('PQ')
       StokesParameter_fromString = StokesParameter_PQ
    case('QP')
       StokesParameter_fromString = StokesParameter_QP
    case('QQ')
       StokesParameter_fromString = StokesParameter_QQ
    case('RCIRCULAR')
       StokesParameter_fromString = StokesParameter_RCIRCULAR
    case('LCIRCULAR')
       StokesParameter_fromString = StokesParameter_LCIRCULAR
    case('LINEAR')
       StokesParameter_fromString = StokesParameter_LINEAR
    case('PTOTAL')
       StokesParameter_fromString = StokesParameter_PTOTAL
    case('PLINEAR')
       StokesParameter_fromString = StokesParameter_PLINEAR
    case('PFTOTAL')
       StokesParameter_fromString = StokesParameter_PFTOTAL
    case('PFLINEAR')
       StokesParameter_fromString = StokesParameter_PFLINEAR
    case('PANGLE')
       StokesParameter_fromString = StokesParameter_PANGLE
    end select
  end function StokesParameter_fromString
!
  function FluxCalibrationMethod_toString(i)
    integer :: i
    character*80 :: FluxCalibrationMethod_toString
    select case(i)
    case(FluxCalibrationMethod_ABSOLUTE)
       FluxCalibrationMethod_toString = 'ABSOLUTE'
    case(FluxCalibrationMethod_RELATIVE)
       FluxCalibrationMethod_toString = 'RELATIVE'
    case(FluxCalibrationMethod_EFFICIENCY)
       FluxCalibrationMethod_toString = 'EFFICIENCY'
    end select
  end function FluxCalibrationMethod_toString
!
  function FluxCalibrationMethod_fromString(str)
    integer :: FluxCalibrationMethod_fromString
    character*80 :: str
    select case(str)
    case('ABSOLUTE')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_ABSOLUTE
    case('RELATIVE')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_RELATIVE
    case('EFFICIENCY')
       FluxCalibrationMethod_fromString = FluxCalibrationMethod_EFFICIENCY
    end select
  end function FluxCalibrationMethod_fromString
!
  function CalibrationMode_toString(i)
    integer :: i
    character*80 :: CalibrationMode_toString
    select case(i)
    case(CalibrationMode_HOLOGRAPHY)
       CalibrationMode_toString = 'HOLOGRAPHY'
    case(CalibrationMode_INTERFEROMETRY)
       CalibrationMode_toString = 'INTERFEROMETRY'
    case(CalibrationMode_OPTICAL)
       CalibrationMode_toString = 'OPTICAL'
    case(CalibrationMode_RADIOMETRY)
       CalibrationMode_toString = 'RADIOMETRY'
    case(CalibrationMode_WVR)
       CalibrationMode_toString = 'WVR'
    end select
  end function CalibrationMode_toString
!
  function CalibrationMode_fromString(str)
    integer :: CalibrationMode_fromString
    character*80 :: str
    select case(str)
    case('HOLOGRAPHY')
       CalibrationMode_fromString = CalibrationMode_HOLOGRAPHY
    case('INTERFEROMETRY')
       CalibrationMode_fromString = CalibrationMode_INTERFEROMETRY
    case('OPTICAL')
       CalibrationMode_fromString = CalibrationMode_OPTICAL
    case('RADIOMETRY')
       CalibrationMode_fromString = CalibrationMode_RADIOMETRY
    case('WVR')
       CalibrationMode_fromString = CalibrationMode_WVR
    end select
  end function CalibrationMode_fromString
!
  function FocusMethod_toString(i)
    integer :: i
    character*80 :: FocusMethod_toString
    select case(i)
    case(FocusMethod_THREE_POINT)
       FocusMethod_toString = 'THREE_POINT'
    case(FocusMethod_FIVE_POINT)
       FocusMethod_toString = 'FIVE_POINT'
    end select
  end function FocusMethod_toString
!
  function FocusMethod_fromString(str)
    integer :: FocusMethod_fromString
    character*80 :: str
    select case(str)
    case('THREE_POINT')
       FocusMethod_fromString = FocusMethod_THREE_POINT
    case('FIVE_POINT')
       FocusMethod_fromString = FocusMethod_FIVE_POINT
    end select
  end function FocusMethod_fromString
!
  function PointingMethod_toString(i)
    integer :: i
    character*80 :: PointingMethod_toString
    select case(i)
    case(PointingMethod_THREE_POINT)
       PointingMethod_toString = 'THREE_POINT'
    case(PointingMethod_FOUR_POINT)
       PointingMethod_toString = 'FOUR_POINT'
    case(PointingMethod_FIVE_POINT)
       PointingMethod_toString = 'FIVE_POINT'
    case(PointingMethod_CROSS)
       PointingMethod_toString = 'CROSS'
    case(PointingMethod_CIRCLE)
       PointingMethod_toString = 'CIRCLE'
    end select
  end function PointingMethod_toString
!
  function PointingMethod_fromString(str)
    integer :: PointingMethod_fromString
    character*80 :: str
    select case(str)
    case('THREE_POINT')
       PointingMethod_fromString = PointingMethod_THREE_POINT
    case('FOUR_POINT')
       PointingMethod_fromString = PointingMethod_FOUR_POINT
    case('FIVE_POINT')
       PointingMethod_fromString = PointingMethod_FIVE_POINT
    case('CROSS')
       PointingMethod_fromString = PointingMethod_CROSS
    case('CIRCLE')
       PointingMethod_fromString = PointingMethod_CIRCLE
    end select
  end function PointingMethod_fromString
!
  function WindowFunction_toString(i)
    integer :: i
    character*80 :: WindowFunction_toString
    select case(i)
    case(WindowFunction_UNIFORM)
       WindowFunction_toString = 'UNIFORM'
    case(WindowFunction_HANNING)
       WindowFunction_toString = 'HANNING'
    case(WindowFunction_HAMMING)
       WindowFunction_toString = 'HAMMING'
    case(WindowFunction_BARTLETT)
       WindowFunction_toString = 'BARTLETT'
    case(WindowFunction_BLACKMANN)
       WindowFunction_toString = 'BLACKMANN'
    case(WindowFunction_BLACKMANN_HARRIS)
       WindowFunction_toString = 'BLACKMANN_HARRIS'
    case(WindowFunction_WELCH)
       WindowFunction_toString = 'WELCH'
    end select
  end function WindowFunction_toString
!
  function WindowFunction_fromString(str)
    integer :: WindowFunction_fromString
    character*80 :: str
    select case(str)
    case('UNIFORM')
       WindowFunction_fromString = WindowFunction_UNIFORM
    case('HANNING')
       WindowFunction_fromString = WindowFunction_HANNING
    case('HAMMING')
       WindowFunction_fromString = WindowFunction_HAMMING
    case('BARTLETT')
       WindowFunction_fromString = WindowFunction_BARTLETT
    case('BLACKMANN')
       WindowFunction_fromString = WindowFunction_BLACKMANN
    case('BLACKMANN_HARRIS')
       WindowFunction_fromString = WindowFunction_BLACKMANN_HARRIS
    case('WELCH')
       WindowFunction_fromString = WindowFunction_WELCH
    end select
  end function WindowFunction_fromString
!
  function AssociatedFieldNature_toString(i)
    integer :: i
    character*80 :: AssociatedFieldNature_toString
    select case(i)
    case(AssociatedFieldNature_ON)
       AssociatedFieldNature_toString = 'ON'
    case(AssociatedFieldNature_OFF)
       AssociatedFieldNature_toString = 'OFF'
    case(AssociatedFieldNature_PHASE_REFERENCE)
       AssociatedFieldNature_toString = 'PHASE_REFERENCE'
    end select
  end function AssociatedFieldNature_toString
!
  function AssociatedFieldNature_fromString(str)
    integer :: AssociatedFieldNature_fromString
    character*80 :: str
    select case(str)
    case('ON')
       AssociatedFieldNature_fromString = AssociatedFieldNature_ON
    case('OFF')
       AssociatedFieldNature_fromString = AssociatedFieldNature_OFF
    case('PHASE_REFERENCE')
       AssociatedFieldNature_fromString = AssociatedFieldNature_PHASE_REFERENCE
    end select
  end function AssociatedFieldNature_fromString
!
  function ProcessorType_toString(i)
    integer :: i
    character*80 :: ProcessorType_toString
    select case(i)
    case(ProcessorType_CORRELATOR)
       ProcessorType_toString = 'CORRELATOR'
    case(ProcessorType_RADIOMETER)
       ProcessorType_toString = 'RADIOMETER'
    case(ProcessorType_SPECTROMETER)
       ProcessorType_toString = 'SPECTROMETER'
    end select
  end function ProcessorType_toString
!
  function ProcessorType_fromString(str)
    integer :: ProcessorType_fromString
    character*80 :: str
    select case(str)
    case('CORRELATOR')
       ProcessorType_fromString = ProcessorType_CORRELATOR
    case('RADIOMETER')
       ProcessorType_fromString = ProcessorType_RADIOMETER
    case('SPECTROMETER')
       ProcessorType_fromString = ProcessorType_SPECTROMETER
    end select
  end function ProcessorType_fromString
!
  function SourceModel_toString(i)
    integer :: i
    character*80 :: SourceModel_toString
    select case(i)
    case(SourceModel_GAUSSIAN)
       SourceModel_toString = 'GAUSSIAN'
    case(SourceModel_POINT)
       SourceModel_toString = 'POINT'
    case(SourceModel_DISK)
       SourceModel_toString = 'DISK'
    end select
  end function SourceModel_toString
!
  function SourceModel_fromString(str)
    integer :: SourceModel_fromString
    character*80 :: str
    select case(str)
    case('GAUSSIAN')
       SourceModel_fromString = SourceModel_GAUSSIAN
    case('POINT')
       SourceModel_fromString = SourceModel_POINT
    case('DISK')
       SourceModel_fromString = SourceModel_DISK
    end select
  end function SourceModel_fromString
!
  function NetSideband_toString(i)
    integer :: i
    character*80 :: NetSideband_toString
    select case(i)
    case(NetSideband_NOSB)
       NetSideband_toString = 'NOSB'
    case(NetSideband_LSB)
       NetSideband_toString = 'LSB'
    case(NetSideband_USB)
       NetSideband_toString = 'USB'
    case(NetSideband_DSB)
       NetSideband_toString = 'DSB'
    end select
  end function NetSideband_toString
!
  function NetSideband_fromString(str)
    integer :: NetSideband_fromString
    character*80 :: str
    select case(str)
    case('NOSB')
       NetSideband_fromString = NetSideband_NOSB
    case('LSB')
       NetSideband_fromString = NetSideband_LSB
    case('USB')
       NetSideband_fromString = NetSideband_USB
    case('DSB')
       NetSideband_fromString = NetSideband_DSB
    end select
  end function NetSideband_fromString
!
  function ReceiverSideband_toString(i)
    integer :: i
    character*80 :: ReceiverSideband_toString
    select case(i)
    case(ReceiverSideband_NOSB)
       ReceiverSideband_toString = 'NOSB'
    case(ReceiverSideband_DSB)
       ReceiverSideband_toString = 'DSB'
    case(ReceiverSideband_SSB)
       ReceiverSideband_toString = 'SSB'
    case(ReceiverSideband_TSB)
       ReceiverSideband_toString = 'TSB'
    end select
  end function ReceiverSideband_toString
!
  function ReceiverSideband_fromString(str)
    integer :: ReceiverSideband_fromString
    character*80 :: str
    select case(str)
    case('NOSB')
       ReceiverSideband_fromString = ReceiverSideband_NOSB
    case('DSB')
       ReceiverSideband_fromString = ReceiverSideband_DSB
    case('SSB')
       ReceiverSideband_fromString = ReceiverSideband_SSB
    case('TSB')
       ReceiverSideband_fromString = ReceiverSideband_TSB
    end select
  end function ReceiverSideband_fromString
!
  function SidebandProcessingMode_toString(i)
    integer :: i
    character*80 :: SidebandProcessingMode_toString
    select case(i)
    case(SidebandProcessingMode_NONE)
       SidebandProcessingMode_toString = 'NONE'
    case(SidebandProcessingMode_PHASE_SWITCH_SEPARATION)
       SidebandProcessingMode_toString = 'PHASE_SWITCH_SEPARATION'
    case(SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION)
       SidebandProcessingMode_toString = 'FREQUENCY_OFFSET_SEPARATION'
    case(SidebandProcessingMode_PHASE_SWITCH_REJECTION)
       SidebandProcessingMode_toString = 'PHASE_SWITCH_REJECTION'
    case(SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION)
       SidebandProcessingMode_toString = 'FREQUENCY_OFFSET_REJECTION'
    end select
  end function SidebandProcessingMode_toString
!
  function SidebandProcessingMode_fromString(str)
    integer :: SidebandProcessingMode_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       SidebandProcessingMode_fromString = SidebandProcessingMode_NONE
    case('PHASE_SWITCH_SEPARATION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_PHASE_SWITCH_SEPARATION
    case('FREQUENCY_OFFSET_SEPARATION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_FREQUENCY_OFFSET_SEPARATION
    case('PHASE_SWITCH_REJECTION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_PHASE_SWITCH_REJECTION
    case('FREQUENCY_OFFSET_REJECTION')
       SidebandProcessingMode_fromString = SidebandProcessingMode_FREQUENCY_OFFSET_REJECTION
    end select
  end function SidebandProcessingMode_fromString
!
  function SwitchingMode_toString(i)
    integer :: i
    character*80 :: SwitchingMode_toString
    select case(i)
    case(SwitchingMode_NO_SWITCHING)
       SwitchingMode_toString = 'NO_SWITCHING'
    case(SwitchingMode_LOAD_SWITCHING)
       SwitchingMode_toString = 'LOAD_SWITCHING'
    case(SwitchingMode_POSITION_SWITCHING)
       SwitchingMode_toString = 'POSITION_SWITCHING'
    case(SwitchingMode_PHASE_SWITCHING)
       SwitchingMode_toString = 'PHASE_SWITCHING'
    case(SwitchingMode_FREQUENCY_SWITCHING)
       SwitchingMode_toString = 'FREQUENCY_SWITCHING'
    case(SwitchingMode_NUTATOR_SWITCHING)
       SwitchingMode_toString = 'NUTATOR_SWITCHING'
    case(SwitchingMode_CHOPPER_WHEEL)
       SwitchingMode_toString = 'CHOPPER_WHEEL'
    end select
  end function SwitchingMode_toString
!
  function SwitchingMode_fromString(str)
    integer :: SwitchingMode_fromString
    character*80 :: str
    select case(str)
    case('NO_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_NO_SWITCHING
    case('LOAD_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_LOAD_SWITCHING
    case('POSITION_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_POSITION_SWITCHING
    case('PHASE_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_PHASE_SWITCHING
    case('FREQUENCY_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_FREQUENCY_SWITCHING
    case('NUTATOR_SWITCHING')
       SwitchingMode_fromString = SwitchingMode_NUTATOR_SWITCHING
    case('CHOPPER_WHEEL')
       SwitchingMode_fromString = SwitchingMode_CHOPPER_WHEEL
    end select
  end function SwitchingMode_fromString
!
  function StationType_toString(i)
    integer :: i
    character*80 :: StationType_toString
    select case(i)
    case(StationType_ANTENNA_PAD)
       StationType_toString = 'ANTENNA_PAD'
    case(StationType_MAINTENANCE_PAD)
       StationType_toString = 'MAINTENANCE_PAD'
    case(StationType_WEATHER_STATION)
       StationType_toString = 'WEATHER_STATION'
    end select
  end function StationType_toString
!
  function StationType_fromString(str)
    integer :: StationType_fromString
    character*80 :: str
    select case(str)
    case('ANTENNA_PAD')
       StationType_fromString = StationType_ANTENNA_PAD
    case('MAINTENANCE_PAD')
       StationType_fromString = StationType_MAINTENANCE_PAD
    case('WEATHER_STATION')
       StationType_fromString = StationType_WEATHER_STATION
    end select
  end function StationType_fromString
!
  function SubscanIntent_toString(i)
    integer :: i
    character*80 :: SubscanIntent_toString
    select case(i)
    case(SubscanIntent_ON_SOURCE)
       SubscanIntent_toString = 'ON_SOURCE'
    case(SubscanIntent_OFF_SOURCE)
       SubscanIntent_toString = 'OFF_SOURCE'
    case(SubscanIntent_MIXED)
       SubscanIntent_toString = 'MIXED'
    case(SubscanIntent_REFERENCE)
       SubscanIntent_toString = 'REFERENCE'
    case(SubscanIntent_SCANNING)
       SubscanIntent_toString = 'SCANNING'
    case(SubscanIntent_HOT)
       SubscanIntent_toString = 'HOT'
    case(SubscanIntent_AMBIENT)
       SubscanIntent_toString = 'AMBIENT'
    case(SubscanIntent_TEST)
       SubscanIntent_toString = 'TEST'
    case(SubscanIntent_UNSPECIFIED)
       SubscanIntent_toString = 'UNSPECIFIED'
    end select
  end function SubscanIntent_toString
!
  function SubscanIntent_fromString(str)
    integer :: SubscanIntent_fromString
    character*80 :: str
    select case(str)
    case('ON_SOURCE')
       SubscanIntent_fromString = SubscanIntent_ON_SOURCE
    case('OFF_SOURCE')
       SubscanIntent_fromString = SubscanIntent_OFF_SOURCE
    case('MIXED')
       SubscanIntent_fromString = SubscanIntent_MIXED
    case('REFERENCE')
       SubscanIntent_fromString = SubscanIntent_REFERENCE
    case('SCANNING')
       SubscanIntent_fromString = SubscanIntent_SCANNING
    case('HOT')
       SubscanIntent_fromString = SubscanIntent_HOT
    case('AMBIENT')
       SubscanIntent_fromString = SubscanIntent_AMBIENT
    case('TEST')
       SubscanIntent_fromString = SubscanIntent_TEST
    case('UNSPECIFIED')
       SubscanIntent_fromString = SubscanIntent_UNSPECIFIED
    end select
  end function SubscanIntent_fromString
!
  function BasebandName_toString(i)
    integer :: i
    character*80 :: BasebandName_toString
    select case(i)
    case(BasebandName_NOBB)
       BasebandName_toString = 'NOBB'
    case(BasebandName_BB_1)
       BasebandName_toString = 'BB_1'
    case(BasebandName_BB_2)
       BasebandName_toString = 'BB_2'
    case(BasebandName_BB_3)
       BasebandName_toString = 'BB_3'
    case(BasebandName_BB_4)
       BasebandName_toString = 'BB_4'
    case(BasebandName_BB_5)
       BasebandName_toString = 'BB_5'
    case(BasebandName_BB_6)
       BasebandName_toString = 'BB_6'
    case(BasebandName_BB_7)
       BasebandName_toString = 'BB_7'
    case(BasebandName_BB_8)
       BasebandName_toString = 'BB_8'
    case(BasebandName_BB_ALL)
       BasebandName_toString = 'BB_ALL'
    end select
  end function BasebandName_toString
!
  function BasebandName_fromString(str)
    integer :: BasebandName_fromString
    character*80 :: str
    select case(str)
    case('NOBB')
       BasebandName_fromString = BasebandName_NOBB
    case('BB_1')
       BasebandName_fromString = BasebandName_BB_1
    case('BB_2')
       BasebandName_fromString = BasebandName_BB_2
    case('BB_3')
       BasebandName_fromString = BasebandName_BB_3
    case('BB_4')
       BasebandName_fromString = BasebandName_BB_4
    case('BB_5')
       BasebandName_fromString = BasebandName_BB_5
    case('BB_6')
       BasebandName_fromString = BasebandName_BB_6
    case('BB_7')
       BasebandName_fromString = BasebandName_BB_7
    case('BB_8')
       BasebandName_fromString = BasebandName_BB_8
    case('BB_ALL')
       BasebandName_fromString = BasebandName_BB_ALL
    end select
  end function BasebandName_fromString
!
  function AxisName_toString(i)
    integer :: i
    character*80 :: AxisName_toString
    select case(i)
    case(AxisName_TIM)
       AxisName_toString = 'TIM'
    case(AxisName_BAL)
       AxisName_toString = 'BAL'
    case(AxisName_ANT)
       AxisName_toString = 'ANT'
    case(AxisName_BAB)
       AxisName_toString = 'BAB'
    case(AxisName_SPW)
       AxisName_toString = 'SPW'
    case(AxisName_SIB)
       AxisName_toString = 'SIB'
    case(AxisName_SUB)
       AxisName_toString = 'SUB'
    case(AxisName_BIN)
       AxisName_toString = 'BIN'
    case(AxisName_APC)
       AxisName_toString = 'APC'
    case(AxisName_SPP)
       AxisName_toString = 'SPP'
    case(AxisName_POL)
       AxisName_toString = 'POL'
    case(AxisName_STO)
       AxisName_toString = 'STO'
    case(AxisName_HOL)
       AxisName_toString = 'HOL'
    end select
  end function AxisName_toString
!
  function AxisName_fromString(str)
    integer :: AxisName_fromString
    character*80 :: str
    select case(str)
    case('TIM')
       AxisName_fromString = AxisName_TIM
    case('BAL')
       AxisName_fromString = AxisName_BAL
    case('ANT')
       AxisName_fromString = AxisName_ANT
    case('BAB')
       AxisName_fromString = AxisName_BAB
    case('SPW')
       AxisName_fromString = AxisName_SPW
    case('SIB')
       AxisName_fromString = AxisName_SIB
    case('SUB')
       AxisName_fromString = AxisName_SUB
    case('BIN')
       AxisName_fromString = AxisName_BIN
    case('APC')
       AxisName_fromString = AxisName_APC
    case('SPP')
       AxisName_fromString = AxisName_SPP
    case('POL')
       AxisName_fromString = AxisName_POL
    case('STO')
       AxisName_fromString = AxisName_STO
    case('HOL')
       AxisName_fromString = AxisName_HOL
    end select
  end function AxisName_fromString
!
  function DataContent_toString(i)
    integer :: i
    character*80 :: DataContent_toString
    select case(i)
    case(DataContent_CROSS_DATA)
       DataContent_toString = 'CROSS_DATA'
    case(DataContent_AUTO_DATA)
       DataContent_toString = 'AUTO_DATA'
    case(DataContent_ZERO_LAGS)
       DataContent_toString = 'ZERO_LAGS'
    case(DataContent_ACTUAL_TIMES)
       DataContent_toString = 'ACTUAL_TIMES'
    case(DataContent_ACTUAL_DURATIONS)
       DataContent_toString = 'ACTUAL_DURATIONS'
    case(DataContent_WEIGHTS)
       DataContent_toString = 'WEIGHTS'
    case(DataContent_FLAGS)
       DataContent_toString = 'FLAGS'
    end select
  end function DataContent_toString
!
  function DataContent_fromString(str)
    integer :: DataContent_fromString
    character*80 :: str
    select case(str)
    case('CROSS_DATA')
       DataContent_fromString = DataContent_CROSS_DATA
    case('AUTO_DATA')
       DataContent_fromString = DataContent_AUTO_DATA
    case('ZERO_LAGS')
       DataContent_fromString = DataContent_ZERO_LAGS
    case('ACTUAL_TIMES')
       DataContent_fromString = DataContent_ACTUAL_TIMES
    case('ACTUAL_DURATIONS')
       DataContent_fromString = DataContent_ACTUAL_DURATIONS
    case('WEIGHTS')
       DataContent_fromString = DataContent_WEIGHTS
    case('FLAGS')
       DataContent_fromString = DataContent_FLAGS
    end select
  end function DataContent_fromString
!
  function AtmPhaseCorrection_toString(i)
    integer :: i
    character*80 :: AtmPhaseCorrection_toString
    select case(i)
    case(AtmPhaseCorrection_AP_UNCORRECTED)
       AtmPhaseCorrection_toString = 'AP_UNCORRECTED'
    case(AtmPhaseCorrection_AP_CORRECTED)
       AtmPhaseCorrection_toString = 'AP_CORRECTED'
    end select
  end function AtmPhaseCorrection_toString
!
  function AtmPhaseCorrection_fromString(str)
    integer :: AtmPhaseCorrection_fromString
    character*80 :: str
    select case(str)
    case('AP_UNCORRECTED')
       AtmPhaseCorrection_fromString = AtmPhaseCorrection_AP_UNCORRECTED
    case('AP_CORRECTED')
       AtmPhaseCorrection_fromString = AtmPhaseCorrection_AP_CORRECTED
    end select
  end function AtmPhaseCorrection_fromString
!
  function PrimitiveDataType_toString(i)
    integer :: i
    character*80 :: PrimitiveDataType_toString
    select case(i)
    case(PrimitiveDataType_INT16_TYPE)
       PrimitiveDataType_toString = 'INT16_TYPE'
    case(PrimitiveDataType_INT32_TYPE)
       PrimitiveDataType_toString = 'INT32_TYPE'
    case(PrimitiveDataType_INT64_TYPE)
       PrimitiveDataType_toString = 'INT64_TYPE'
    case(PrimitiveDataType_FLOAT32_TYPE)
       PrimitiveDataType_toString = 'FLOAT32_TYPE'
    case(PrimitiveDataType_FLOAT64_TYPE)
       PrimitiveDataType_toString = 'FLOAT64_TYPE'
    end select
  end function PrimitiveDataType_toString
!
  function PrimitiveDataType_fromString(str)
    integer :: PrimitiveDataType_fromString
    character*80 :: str
    select case(str)
    case('INT16_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT16_TYPE
    case('INT32_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT32_TYPE
    case('INT64_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_INT64_TYPE
    case('FLOAT32_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_FLOAT32_TYPE
    case('FLOAT64_TYPE')
       PrimitiveDataType_fromString = PrimitiveDataType_FLOAT64_TYPE
    end select
  end function PrimitiveDataType_fromString
!
  function CorrelationMode_toString(i)
    integer :: i
    character*80 :: CorrelationMode_toString
    select case(i)
    case(CorrelationMode_CROSS_ONLY)
       CorrelationMode_toString = 'CROSS_ONLY'
    case(CorrelationMode_AUTO_ONLY)
       CorrelationMode_toString = 'AUTO_ONLY'
    case(CorrelationMode_CROSS_AND_AUTO)
       CorrelationMode_toString = 'CROSS_AND_AUTO'
    end select
  end function CorrelationMode_toString
!
  function CorrelationMode_fromString(str)
    integer :: CorrelationMode_fromString
    character*80 :: str
    select case(str)
    case('CROSS_ONLY')
       CorrelationMode_fromString = CorrelationMode_CROSS_ONLY
    case('AUTO_ONLY')
       CorrelationMode_fromString = CorrelationMode_AUTO_ONLY
    case('CROSS_AND_AUTO')
       CorrelationMode_fromString = CorrelationMode_CROSS_AND_AUTO
    end select
  end function CorrelationMode_fromString
!
  function WVRMethod_toString(i)
    integer :: i
    character*80 :: WVRMethod_toString
    select case(i)
    case(WVRMethod_ATM_MODEL)
       WVRMethod_toString = 'ATM_MODEL'
    case(WVRMethod_EMPIRICAL)
       WVRMethod_toString = 'EMPIRICAL'
    end select
  end function WVRMethod_toString
!
  function WVRMethod_fromString(str)
    integer :: WVRMethod_fromString
    character*80 :: str
    select case(str)
    case('ATM_MODEL')
       WVRMethod_fromString = WVRMethod_ATM_MODEL
    case('EMPIRICAL')
       WVRMethod_fromString = WVRMethod_EMPIRICAL
    end select
  end function WVRMethod_fromString
!
  function AccumMode_toString(i)
    integer :: i
    character*80 :: AccumMode_toString
    select case(i)
    case(AccumMode_FAST)
       AccumMode_toString = 'FAST'
    case(AccumMode_NORMAL)
       AccumMode_toString = 'NORMAL'
    case(AccumMode_UNDEFINED)
       AccumMode_toString = 'UNDEFINED'
    end select
  end function AccumMode_toString
!
  function AccumMode_fromString(str)
    integer :: AccumMode_fromString
    character*80 :: str
    select case(str)
    case('FAST')
       AccumMode_fromString = AccumMode_FAST
    case('NORMAL')
       AccumMode_fromString = AccumMode_NORMAL
    case('UNDEFINED')
       AccumMode_fromString = AccumMode_UNDEFINED
    end select
  end function AccumMode_fromString
!
  function AntennaType_toString(i)
    integer :: i
    character*80 :: AntennaType_toString
    select case(i)
    case(AntennaType_GROUND_BASED)
       AntennaType_toString = 'GROUND_BASED'
    case(AntennaType_SPACE_BASED)
       AntennaType_toString = 'SPACE_BASED'
    case(AntennaType_TRACKING_STN)
       AntennaType_toString = 'TRACKING_STN'
    end select
  end function AntennaType_toString
!
  function AntennaType_fromString(str)
    integer :: AntennaType_fromString
    character*80 :: str
    select case(str)
    case('GROUND_BASED')
       AntennaType_fromString = AntennaType_GROUND_BASED
    case('SPACE_BASED')
       AntennaType_fromString = AntennaType_SPACE_BASED
    case('TRACKING_STN')
       AntennaType_fromString = AntennaType_TRACKING_STN
    end select
  end function AntennaType_fromString
!
  function AntennaMake_toString(i)
    integer :: i
    character*80 :: AntennaMake_toString
    select case(i)
    case(AntennaMake_AEM_12)
       AntennaMake_toString = 'AEM_12'
    case(AntennaMake_MITSUBISHI_7)
       AntennaMake_toString = 'MITSUBISHI_7'
    case(AntennaMake_MITSUBISHI_12_A)
       AntennaMake_toString = 'MITSUBISHI_12_A'
    case(AntennaMake_MITSUBISHI_12_B)
       AntennaMake_toString = 'MITSUBISHI_12_B'
    case(AntennaMake_VERTEX_12_ATF)
       AntennaMake_toString = 'VERTEX_12_ATF'
    case(AntennaMake_AEM_12_ATF)
       AntennaMake_toString = 'AEM_12_ATF'
    case(AntennaMake_VERTEX_12)
       AntennaMake_toString = 'VERTEX_12'
    case(AntennaMake_IRAM_15)
       AntennaMake_toString = 'IRAM_15'
    case(AntennaMake_UNDEFINED)
       AntennaMake_toString = 'UNDEFINED'
    end select
  end function AntennaMake_toString
!
  function AntennaMake_fromString(str)
    integer :: AntennaMake_fromString
    character*80 :: str
    select case(str)
    case('AEM_12')
       AntennaMake_fromString = AntennaMake_AEM_12
    case('MITSUBISHI_7')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_7
    case('MITSUBISHI_12_A')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_12_A
    case('MITSUBISHI_12_B')
       AntennaMake_fromString = AntennaMake_MITSUBISHI_12_B
    case('VERTEX_12_ATF')
       AntennaMake_fromString = AntennaMake_VERTEX_12_ATF
    case('AEM_12_ATF')
       AntennaMake_fromString = AntennaMake_AEM_12_ATF
    case('VERTEX_12')
       AntennaMake_fromString = AntennaMake_VERTEX_12
    case('IRAM_15')
       AntennaMake_fromString = AntennaMake_IRAM_15
    case('UNDEFINED')
       AntennaMake_fromString = AntennaMake_UNDEFINED
    end select
  end function AntennaMake_fromString
!
  function PositionMethod_toString(i)
    integer :: i
    character*80 :: PositionMethod_toString
    select case(i)
    case(PositionMethod_DELAY_FITTING)
       PositionMethod_toString = 'DELAY_FITTING'
    case(PositionMethod_PHASE_FITTING)
       PositionMethod_toString = 'PHASE_FITTING'
    end select
  end function PositionMethod_toString
!
  function PositionMethod_fromString(str)
    integer :: PositionMethod_fromString
    character*80 :: str
    select case(str)
    case('DELAY_FITTING')
       PositionMethod_fromString = PositionMethod_DELAY_FITTING
    case('PHASE_FITTING')
       PositionMethod_fromString = PositionMethod_PHASE_FITTING
    end select
  end function PositionMethod_fromString
!
  function PointingModelMode_toString(i)
    integer :: i
    character*80 :: PointingModelMode_toString
    select case(i)
    case(PointingModelMode_RADIO)
       PointingModelMode_toString = 'RADIO'
    case(PointingModelMode_OPTICAL)
       PointingModelMode_toString = 'OPTICAL'
    end select
  end function PointingModelMode_toString
!
  function PointingModelMode_fromString(str)
    integer :: PointingModelMode_fromString
    character*80 :: str
    select case(str)
    case('RADIO')
       PointingModelMode_fromString = PointingModelMode_RADIO
    case('OPTICAL')
       PointingModelMode_fromString = PointingModelMode_OPTICAL
    end select
  end function PointingModelMode_fromString
!
  function InvalidatingCondition_toString(i)
    integer :: i
    character*80 :: InvalidatingCondition_toString
    select case(i)
    case(InvalidatingCondition_ANTENNA_DISCONNECT)
       InvalidatingCondition_toString = 'ANTENNA_DISCONNECT'
    case(InvalidatingCondition_ANTENNA_MOVE)
       InvalidatingCondition_toString = 'ANTENNA_MOVE'
    case(InvalidatingCondition_ANTENNA_POWER_DOWN)
       InvalidatingCondition_toString = 'ANTENNA_POWER_DOWN'
    case(InvalidatingCondition_RECEIVER_EXCHANGE)
       InvalidatingCondition_toString = 'RECEIVER_EXCHANGE'
    case(InvalidatingCondition_RECEIVER_POWER_DOWN)
       InvalidatingCondition_toString = 'RECEIVER_POWER_DOWN'
    end select
  end function InvalidatingCondition_toString
!
  function InvalidatingCondition_fromString(str)
    integer :: InvalidatingCondition_fromString
    character*80 :: str
    select case(str)
    case('ANTENNA_DISCONNECT')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_DISCONNECT
    case('ANTENNA_MOVE')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_MOVE
    case('ANTENNA_POWER_DOWN')
       InvalidatingCondition_fromString = InvalidatingCondition_ANTENNA_POWER_DOWN
    case('RECEIVER_EXCHANGE')
       InvalidatingCondition_fromString = InvalidatingCondition_RECEIVER_EXCHANGE
    case('RECEIVER_POWER_DOWN')
       InvalidatingCondition_fromString = InvalidatingCondition_RECEIVER_POWER_DOWN
    end select
  end function InvalidatingCondition_fromString
!
  function SchedulerMode_toString(i)
    integer :: i
    character*80 :: SchedulerMode_toString
    select case(i)
    case(SchedulerMode_DYNAMIC)
       SchedulerMode_toString = 'DYNAMIC'
    case(SchedulerMode_INTERACTIVE)
       SchedulerMode_toString = 'INTERACTIVE'
    case(SchedulerMode_MANUAL)
       SchedulerMode_toString = 'MANUAL'
    case(SchedulerMode_QUEUED)
       SchedulerMode_toString = 'QUEUED'
    end select
  end function SchedulerMode_toString
!
  function SchedulerMode_fromString(str)
    integer :: SchedulerMode_fromString
    character*80 :: str
    select case(str)
    case('DYNAMIC')
       SchedulerMode_fromString = SchedulerMode_DYNAMIC
    case('INTERACTIVE')
       SchedulerMode_fromString = SchedulerMode_INTERACTIVE
    case('MANUAL')
       SchedulerMode_fromString = SchedulerMode_MANUAL
    case('QUEUED')
       SchedulerMode_fromString = SchedulerMode_QUEUED
    end select
  end function SchedulerMode_fromString
!
  function FieldCode_toString(i)
    integer :: i
    character*80 :: FieldCode_toString
    select case(i)
    case(FieldCode_NONE)
       FieldCode_toString = 'NONE'
    end select
  end function FieldCode_toString
!
  function FieldCode_fromString(str)
    integer :: FieldCode_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       FieldCode_fromString = FieldCode_NONE
    end select
  end function FieldCode_fromString
!
  function HolographyChannelType_toString(i)
    integer :: i
    character*80 :: HolographyChannelType_toString
    select case(i)
    case(HolographyChannelType_Q2)
       HolographyChannelType_toString = 'Q2'
    case(HolographyChannelType_QR)
       HolographyChannelType_toString = 'QR'
    case(HolographyChannelType_QS)
       HolographyChannelType_toString = 'QS'
    case(HolographyChannelType_R2)
       HolographyChannelType_toString = 'R2'
    case(HolographyChannelType_RS)
       HolographyChannelType_toString = 'RS'
    case(HolographyChannelType_S2)
       HolographyChannelType_toString = 'S2'
    end select
  end function HolographyChannelType_toString
!
  function HolographyChannelType_fromString(str)
    integer :: HolographyChannelType_fromString
    character*80 :: str
    select case(str)
    case('Q2')
       HolographyChannelType_fromString = HolographyChannelType_Q2
    case('QR')
       HolographyChannelType_fromString = HolographyChannelType_QR
    case('QS')
       HolographyChannelType_fromString = HolographyChannelType_QS
    case('R2')
       HolographyChannelType_fromString = HolographyChannelType_R2
    case('RS')
       HolographyChannelType_fromString = HolographyChannelType_RS
    case('S2')
       HolographyChannelType_fromString = HolographyChannelType_S2
    end select
  end function HolographyChannelType_fromString
!
  function ProcessorSubType_toString(i)
    integer :: i
    character*80 :: ProcessorSubType_toString
    select case(i)
    case(ProcessorSubType_ALMA_CORRELATOR_MODE)
       ProcessorSubType_toString = 'ALMA_CORRELATOR_MODE'
    case(ProcessorSubType_SQUARE_LAW_DETECTOR)
       ProcessorSubType_toString = 'SQUARE_LAW_DETECTOR'
    case(ProcessorSubType_HOLOGRAPHY)
       ProcessorSubType_toString = 'HOLOGRAPHY'
    case(ProcessorSubType_ALMA_RADIOMETER)
       ProcessorSubType_toString = 'ALMA_RADIOMETER'
    end select
  end function ProcessorSubType_toString
!
  function ProcessorSubType_fromString(str)
    integer :: ProcessorSubType_fromString
    character*80 :: str
    select case(str)
    case('ALMA_CORRELATOR_MODE')
       ProcessorSubType_fromString = ProcessorSubType_ALMA_CORRELATOR_MODE
    case('SQUARE_LAW_DETECTOR')
       ProcessorSubType_fromString = ProcessorSubType_SQUARE_LAW_DETECTOR
    case('HOLOGRAPHY')
       ProcessorSubType_fromString = ProcessorSubType_HOLOGRAPHY
    case('ALMA_RADIOMETER')
       ProcessorSubType_fromString = ProcessorSubType_ALMA_RADIOMETER
    end select
  end function ProcessorSubType_fromString
!
  function ReceiverBand_toString(i)
    integer :: i
    character*80 :: ReceiverBand_toString
    select case(i)
    case(ReceiverBand_ALMA_RB_01)
       ReceiverBand_toString = 'ALMA_RB_01'
    case(ReceiverBand_ALMA_RB_02)
       ReceiverBand_toString = 'ALMA_RB_02'
    case(ReceiverBand_ALMA_RB_03)
       ReceiverBand_toString = 'ALMA_RB_03'
    case(ReceiverBand_ALMA_RB_04)
       ReceiverBand_toString = 'ALMA_RB_04'
    case(ReceiverBand_ALMA_RB_05)
       ReceiverBand_toString = 'ALMA_RB_05'
    case(ReceiverBand_ALMA_RB_06)
       ReceiverBand_toString = 'ALMA_RB_06'
    case(ReceiverBand_ALMA_RB_07)
       ReceiverBand_toString = 'ALMA_RB_07'
    case(ReceiverBand_ALMA_RB_08)
       ReceiverBand_toString = 'ALMA_RB_08'
    case(ReceiverBand_ALMA_RB_09)
       ReceiverBand_toString = 'ALMA_RB_09'
    case(ReceiverBand_ALMA_RB_10)
       ReceiverBand_toString = 'ALMA_RB_10'
    case(ReceiverBand_ALMA_RB_ALL)
       ReceiverBand_toString = 'ALMA_RB_ALL'
    case(ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER)
       ReceiverBand_toString = 'ALMA_HOLOGRAPHY_RECEIVER'
    case(ReceiverBand_BURE_01)
       ReceiverBand_toString = 'BURE_01'
    case(ReceiverBand_BURE_02)
       ReceiverBand_toString = 'BURE_02'
    case(ReceiverBand_BURE_03)
       ReceiverBand_toString = 'BURE_03'
    case(ReceiverBand_BURE_04)
       ReceiverBand_toString = 'BURE_04'
    case(ReceiverBand_UNSPECIFIED)
       ReceiverBand_toString = 'UNSPECIFIED'
    end select
  end function ReceiverBand_toString
!
  function ReceiverBand_fromString(str)
    integer :: ReceiverBand_fromString
    character*80 :: str
    select case(str)
    case('ALMA_RB_01')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_01
    case('ALMA_RB_02')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_02
    case('ALMA_RB_03')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_03
    case('ALMA_RB_04')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_04
    case('ALMA_RB_05')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_05
    case('ALMA_RB_06')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_06
    case('ALMA_RB_07')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_07
    case('ALMA_RB_08')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_08
    case('ALMA_RB_09')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_09
    case('ALMA_RB_10')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_10
    case('ALMA_RB_ALL')
       ReceiverBand_fromString = ReceiverBand_ALMA_RB_ALL
    case('ALMA_HOLOGRAPHY_RECEIVER')
       ReceiverBand_fromString = ReceiverBand_ALMA_HOLOGRAPHY_RECEIVER
    case('BURE_01')
       ReceiverBand_fromString = ReceiverBand_BURE_01
    case('BURE_02')
       ReceiverBand_fromString = ReceiverBand_BURE_02
    case('BURE_03')
       ReceiverBand_fromString = ReceiverBand_BURE_03
    case('BURE_04')
       ReceiverBand_fromString = ReceiverBand_BURE_04
    case('UNSPECIFIED')
       ReceiverBand_fromString = ReceiverBand_UNSPECIFIED
    end select
  end function ReceiverBand_fromString
!
  function SBType_toString(i)
    integer :: i
    character*80 :: SBType_toString
    select case(i)
    case(SBType_OBSERVATORY)
       SBType_toString = 'OBSERVATORY'
    case(SBType_OBSERVER)
       SBType_toString = 'OBSERVER'
    case(SBType_EXPERT)
       SBType_toString = 'EXPERT'
    end select
  end function SBType_toString
!
  function SBType_fromString(str)
    integer :: SBType_fromString
    character*80 :: str
    select case(str)
    case('OBSERVATORY')
       SBType_fromString = SBType_OBSERVATORY
    case('OBSERVER')
       SBType_fromString = SBType_OBSERVER
    case('EXPERT')
       SBType_fromString = SBType_EXPERT
    end select
  end function SBType_fromString
!
  function SpectralResolutionType_toString(i)
    integer :: i
    character*80 :: SpectralResolutionType_toString
    select case(i)
    case(SpectralResolutionType_CHANNEL_AVERAGE)
       SpectralResolutionType_toString = 'CHANNEL_AVERAGE'
    case(SpectralResolutionType_BASEBAND_WIDE)
       SpectralResolutionType_toString = 'BASEBAND_WIDE'
    case(SpectralResolutionType_FULL_RESOLUTION)
       SpectralResolutionType_toString = 'FULL_RESOLUTION'
    end select
  end function SpectralResolutionType_toString
!
  function SpectralResolutionType_fromString(str)
    integer :: SpectralResolutionType_fromString
    character*80 :: str
    select case(str)
    case('CHANNEL_AVERAGE')
       SpectralResolutionType_fromString = SpectralResolutionType_CHANNEL_AVERAGE
    case('BASEBAND_WIDE')
       SpectralResolutionType_fromString = SpectralResolutionType_BASEBAND_WIDE
    case('FULL_RESOLUTION')
       SpectralResolutionType_fromString = SpectralResolutionType_FULL_RESOLUTION
    end select
  end function SpectralResolutionType_fromString
!
  function DetectorBandType_toString(i)
    integer :: i
    character*80 :: DetectorBandType_toString
    select case(i)
    case(DetectorBandType_BASEBAND)
       DetectorBandType_toString = 'BASEBAND'
    case(DetectorBandType_DOWN_CONVERTER)
       DetectorBandType_toString = 'DOWN_CONVERTER'
    case(DetectorBandType_HOLOGRAPHY_RECEIVER)
       DetectorBandType_toString = 'HOLOGRAPHY_RECEIVER'
    case(DetectorBandType_SUBBAND)
       DetectorBandType_toString = 'SUBBAND'
    end select
  end function DetectorBandType_toString
!
  function DetectorBandType_fromString(str)
    integer :: DetectorBandType_fromString
    character*80 :: str
    select case(str)
    case('BASEBAND')
       DetectorBandType_fromString = DetectorBandType_BASEBAND
    case('DOWN_CONVERTER')
       DetectorBandType_fromString = DetectorBandType_DOWN_CONVERTER
    case('HOLOGRAPHY_RECEIVER')
       DetectorBandType_fromString = DetectorBandType_HOLOGRAPHY_RECEIVER
    case('SUBBAND')
       DetectorBandType_fromString = DetectorBandType_SUBBAND
    end select
  end function DetectorBandType_fromString
!
  function FilterMode_toString(i)
    integer :: i
    character*80 :: FilterMode_toString
    select case(i)
    case(FilterMode_FILTER_NA)
       FilterMode_toString = 'FILTER_NA'
    case(FilterMode_FILTER_TDM)
       FilterMode_toString = 'FILTER_TDM'
    case(FilterMode_FILTER_TFB)
       FilterMode_toString = 'FILTER_TFB'
    case(FilterMode_UNDEFINED)
       FilterMode_toString = 'UNDEFINED'
    end select
  end function FilterMode_toString
!
  function FilterMode_fromString(str)
    integer :: FilterMode_fromString
    character*80 :: str
    select case(str)
    case('FILTER_NA')
       FilterMode_fromString = FilterMode_FILTER_NA
    case('FILTER_TDM')
       FilterMode_fromString = FilterMode_FILTER_TDM
    case('FILTER_TFB')
       FilterMode_fromString = FilterMode_FILTER_TFB
    case('UNDEFINED')
       FilterMode_fromString = FilterMode_UNDEFINED
    end select
  end function FilterMode_fromString
!
  function CorrelationBit_toString(i)
    integer :: i
    character*80 :: CorrelationBit_toString
    select case(i)
    case(CorrelationBit_BITS_2x2)
       CorrelationBit_toString = 'BITS_2x2'
    case(CorrelationBit_BITS_3x3)
       CorrelationBit_toString = 'BITS_3x3'
    case(CorrelationBit_BITS_4x4)
       CorrelationBit_toString = 'BITS_4x4'
    end select
  end function CorrelationBit_toString
!
  function CorrelationBit_fromString(str)
    integer :: CorrelationBit_fromString
    character*80 :: str
    select case(str)
    case('BITS_2x2')
       CorrelationBit_fromString = CorrelationBit_BITS_2x2
    case('BITS_3x3')
       CorrelationBit_fromString = CorrelationBit_BITS_3x3
    case('BITS_4x4')
       CorrelationBit_fromString = CorrelationBit_BITS_4x4
    end select
  end function CorrelationBit_fromString
!
  function ACAPolarization_toString(i)
    integer :: i
    character*80 :: ACAPolarization_toString
    select case(i)
    case(ACAPolarization_ACA_STANDARD)
       ACAPolarization_toString = 'ACA_STANDARD'
    case(ACAPolarization_ACA_XX_YY_SUM)
       ACAPolarization_toString = 'ACA_XX_YY_SUM'
    case(ACAPolarization_ACA_XX_50)
       ACAPolarization_toString = 'ACA_XX_50'
    case(ACAPolarization_ACA_YY_50)
       ACAPolarization_toString = 'ACA_YY_50'
    end select
  end function ACAPolarization_toString
!
  function ACAPolarization_fromString(str)
    integer :: ACAPolarization_fromString
    character*80 :: str
    select case(str)
    case('ACA_STANDARD')
       ACAPolarization_fromString = ACAPolarization_ACA_STANDARD
    case('ACA_XX_YY_SUM')
       ACAPolarization_fromString = ACAPolarization_ACA_XX_YY_SUM
    case('ACA_XX_50')
       ACAPolarization_fromString = ACAPolarization_ACA_XX_50
    case('ACA_YY_50')
       ACAPolarization_fromString = ACAPolarization_ACA_YY_50
    end select
  end function ACAPolarization_fromString
!
  function CorrelatorCalibration_toString(i)
    integer :: i
    character*80 :: CorrelatorCalibration_toString
    select case(i)
    case(CorrelatorCalibration_NONE)
       CorrelatorCalibration_toString = 'NONE'
    case(CorrelatorCalibration_CORRELATOR_CALIBRATION)
       CorrelatorCalibration_toString = 'CORRELATOR_CALIBRATION'
    case(CorrelatorCalibration_REAL_OBSERVATION)
       CorrelatorCalibration_toString = 'REAL_OBSERVATION'
    end select
  end function CorrelatorCalibration_toString
!
  function CorrelatorCalibration_fromString(str)
    integer :: CorrelatorCalibration_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       CorrelatorCalibration_fromString = CorrelatorCalibration_NONE
    case('CORRELATOR_CALIBRATION')
       CorrelatorCalibration_fromString = CorrelatorCalibration_CORRELATOR_CALIBRATION
    case('REAL_OBSERVATION')
       CorrelatorCalibration_fromString = CorrelatorCalibration_REAL_OBSERVATION
    end select
  end function CorrelatorCalibration_fromString
!
  function CorrelatorName_toString(i)
    integer :: i
    character*80 :: CorrelatorName_toString
    select case(i)
    case(CorrelatorName_ALMA_ACA)
       CorrelatorName_toString = 'ALMA_ACA'
    case(CorrelatorName_ALMA_BASELINE)
       CorrelatorName_toString = 'ALMA_BASELINE'
    case(CorrelatorName_ALMA_BASELINE_ATF)
       CorrelatorName_toString = 'ALMA_BASELINE_ATF'
    case(CorrelatorName_ALMA_BASELINE_PROTO_OSF)
       CorrelatorName_toString = 'ALMA_BASELINE_PROTO_OSF'
    case(CorrelatorName_HERSCHEL)
       CorrelatorName_toString = 'HERSCHEL'
    case(CorrelatorName_IRAM_PDB)
       CorrelatorName_toString = 'IRAM_PDB'
    case(CorrelatorName_IRAM_30M_VESPA)
       CorrelatorName_toString = 'IRAM_30M_VESPA'
    case(CorrelatorName_IRAM_WILMA)
       CorrelatorName_toString = 'IRAM_WILMA'
    case(CorrelatorName_NRAO_VLA)
       CorrelatorName_toString = 'NRAO_VLA'
    case(CorrelatorName_NRAO_WIDAR)
       CorrelatorName_toString = 'NRAO_WIDAR'
    end select
  end function CorrelatorName_toString
!
  function CorrelatorName_fromString(str)
    integer :: CorrelatorName_fromString
    character*80 :: str
    select case(str)
    case('ALMA_ACA')
       CorrelatorName_fromString = CorrelatorName_ALMA_ACA
    case('ALMA_BASELINE')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE
    case('ALMA_BASELINE_ATF')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE_ATF
    case('ALMA_BASELINE_PROTO_OSF')
       CorrelatorName_fromString = CorrelatorName_ALMA_BASELINE_PROTO_OSF
    case('HERSCHEL')
       CorrelatorName_fromString = CorrelatorName_HERSCHEL
    case('IRAM_PDB')
       CorrelatorName_fromString = CorrelatorName_IRAM_PDB
    case('IRAM_30M_VESPA')
       CorrelatorName_fromString = CorrelatorName_IRAM_30M_VESPA
    case('IRAM_WILMA')
       CorrelatorName_fromString = CorrelatorName_IRAM_WILMA
    case('NRAO_VLA')
       CorrelatorName_fromString = CorrelatorName_NRAO_VLA
    case('NRAO_WIDAR')
       CorrelatorName_fromString = CorrelatorName_NRAO_WIDAR
    end select
  end function CorrelatorName_fromString
!
  function TimeSampling_toString(i)
    integer :: i
    character*80 :: TimeSampling_toString
    select case(i)
    case(TimeSampling_SUBINTEGRATION)
       TimeSampling_toString = 'SUBINTEGRATION'
    case(TimeSampling_INTEGRATION)
       TimeSampling_toString = 'INTEGRATION'
    end select
  end function TimeSampling_toString
!
  function TimeSampling_fromString(str)
    integer :: TimeSampling_fromString
    character*80 :: str
    select case(str)
    case('SUBINTEGRATION')
       TimeSampling_fromString = TimeSampling_SUBINTEGRATION
    case('INTEGRATION')
       TimeSampling_fromString = TimeSampling_INTEGRATION
    end select
  end function TimeSampling_fromString
!
  function CalibrationDevice_toString(i)
    integer :: i
    character*80 :: CalibrationDevice_toString
    select case(i)
    case(CalibrationDevice_AMBIENT_LOAD)
       CalibrationDevice_toString = 'AMBIENT_LOAD'
    case(CalibrationDevice_COLD_LOAD)
       CalibrationDevice_toString = 'COLD_LOAD'
    case(CalibrationDevice_HOT_LOAD)
       CalibrationDevice_toString = 'HOT_LOAD'
    case(CalibrationDevice_NOISE_TUBE_LOAD)
       CalibrationDevice_toString = 'NOISE_TUBE_LOAD'
    case(CalibrationDevice_QUARTER_WAVE_PLATE)
       CalibrationDevice_toString = 'QUARTER_WAVE_PLATE'
    case(CalibrationDevice_SOLAR_FILTER)
       CalibrationDevice_toString = 'SOLAR_FILTER'
    case(CalibrationDevice_NONE)
       CalibrationDevice_toString = 'NONE'
    end select
  end function CalibrationDevice_toString
!
  function CalibrationDevice_fromString(str)
    integer :: CalibrationDevice_fromString
    character*80 :: str
    select case(str)
    case('AMBIENT_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_AMBIENT_LOAD
    case('COLD_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_COLD_LOAD
    case('HOT_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_HOT_LOAD
    case('NOISE_TUBE_LOAD')
       CalibrationDevice_fromString = CalibrationDevice_NOISE_TUBE_LOAD
    case('QUARTER_WAVE_PLATE')
       CalibrationDevice_fromString = CalibrationDevice_QUARTER_WAVE_PLATE
    case('SOLAR_FILTER')
       CalibrationDevice_fromString = CalibrationDevice_SOLAR_FILTER
    case('NONE')
       CalibrationDevice_fromString = CalibrationDevice_NONE
    end select
  end function CalibrationDevice_fromString
!
  function AntennaMotionPattern_toString(i)
    integer :: i
    character*80 :: AntennaMotionPattern_toString
    select case(i)
    case(AntennaMotionPattern_NONE)
       AntennaMotionPattern_toString = 'NONE'
    case(AntennaMotionPattern_CROSS_SCAN)
       AntennaMotionPattern_toString = 'CROSS_SCAN'
    case(AntennaMotionPattern_SPIRAL)
       AntennaMotionPattern_toString = 'SPIRAL'
    case(AntennaMotionPattern_CIRCLE)
       AntennaMotionPattern_toString = 'CIRCLE'
    case(AntennaMotionPattern_THREE_POINTS)
       AntennaMotionPattern_toString = 'THREE_POINTS'
    case(AntennaMotionPattern_FOUR_POINTS)
       AntennaMotionPattern_toString = 'FOUR_POINTS'
    case(AntennaMotionPattern_FIVE_POINTS)
       AntennaMotionPattern_toString = 'FIVE_POINTS'
    case(AntennaMotionPattern_TEST)
       AntennaMotionPattern_toString = 'TEST'
    case(AntennaMotionPattern_UNSPECIFIED)
       AntennaMotionPattern_toString = 'UNSPECIFIED'
    end select
  end function AntennaMotionPattern_toString
!
  function AntennaMotionPattern_fromString(str)
    integer :: AntennaMotionPattern_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       AntennaMotionPattern_fromString = AntennaMotionPattern_NONE
    case('CROSS_SCAN')
       AntennaMotionPattern_fromString = AntennaMotionPattern_CROSS_SCAN
    case('SPIRAL')
       AntennaMotionPattern_fromString = AntennaMotionPattern_SPIRAL
    case('CIRCLE')
       AntennaMotionPattern_fromString = AntennaMotionPattern_CIRCLE
    case('THREE_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_THREE_POINTS
    case('FOUR_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_FOUR_POINTS
    case('FIVE_POINTS')
       AntennaMotionPattern_fromString = AntennaMotionPattern_FIVE_POINTS
    case('TEST')
       AntennaMotionPattern_fromString = AntennaMotionPattern_TEST
    case('UNSPECIFIED')
       AntennaMotionPattern_fromString = AntennaMotionPattern_UNSPECIFIED
    end select
  end function AntennaMotionPattern_fromString
!
  function CalibrationFunction_toString(i)
    integer :: i
    character*80 :: CalibrationFunction_toString
    select case(i)
    case(CalibrationFunction_FIRST)
       CalibrationFunction_toString = 'FIRST'
    case(CalibrationFunction_LAST)
       CalibrationFunction_toString = 'LAST'
    case(CalibrationFunction_UNSPECIFIED)
       CalibrationFunction_toString = 'UNSPECIFIED'
    end select
  end function CalibrationFunction_toString
!
  function CalibrationFunction_fromString(str)
    integer :: CalibrationFunction_fromString
    character*80 :: str
    select case(str)
    case('FIRST')
       CalibrationFunction_fromString = CalibrationFunction_FIRST
    case('LAST')
       CalibrationFunction_fromString = CalibrationFunction_LAST
    case('UNSPECIFIED')
       CalibrationFunction_fromString = CalibrationFunction_UNSPECIFIED
    end select
  end function CalibrationFunction_fromString
!
  function CalibrationSet_toString(i)
    integer :: i
    character*80 :: CalibrationSet_toString
    select case(i)
    case(CalibrationSet_NONE)
       CalibrationSet_toString = 'NONE'
    case(CalibrationSet_AMPLI_CURVE)
       CalibrationSet_toString = 'AMPLI_CURVE'
    case(CalibrationSet_ANTENNA_POSITIONS)
       CalibrationSet_toString = 'ANTENNA_POSITIONS'
    case(CalibrationSet_PHASE_CURVE)
       CalibrationSet_toString = 'PHASE_CURVE'
    case(CalibrationSet_POINTING_MODEL)
       CalibrationSet_toString = 'POINTING_MODEL'
    case(CalibrationSet_ACCUMULATE)
       CalibrationSet_toString = 'ACCUMULATE'
    case(CalibrationSet_TEST)
       CalibrationSet_toString = 'TEST'
    case(CalibrationSet_UNSPECIFIED)
       CalibrationSet_toString = 'UNSPECIFIED'
    end select
  end function CalibrationSet_toString
!
  function CalibrationSet_fromString(str)
    integer :: CalibrationSet_fromString
    character*80 :: str
    select case(str)
    case('NONE')
       CalibrationSet_fromString = CalibrationSet_NONE
    case('AMPLI_CURVE')
       CalibrationSet_fromString = CalibrationSet_AMPLI_CURVE
    case('ANTENNA_POSITIONS')
       CalibrationSet_fromString = CalibrationSet_ANTENNA_POSITIONS
    case('PHASE_CURVE')
       CalibrationSet_fromString = CalibrationSet_PHASE_CURVE
    case('POINTING_MODEL')
       CalibrationSet_fromString = CalibrationSet_POINTING_MODEL
    case('ACCUMULATE')
       CalibrationSet_fromString = CalibrationSet_ACCUMULATE
    case('TEST')
       CalibrationSet_fromString = CalibrationSet_TEST
    case('UNSPECIFIED')
       CalibrationSet_fromString = CalibrationSet_UNSPECIFIED
    end select
  end function CalibrationSet_fromString
!
  function PositionReferenceCode_toString(i)
    integer :: i
    character*80 :: PositionReferenceCode_toString
    select case(i)
    case(PositionReferenceCode_ITRF)
       PositionReferenceCode_toString = 'ITRF'
    case(PositionReferenceCode_WGS84)
       PositionReferenceCode_toString = 'WGS84'
    case(PositionReferenceCode_SITE)
       PositionReferenceCode_toString = 'SITE'
    case(PositionReferenceCode_STATION)
       PositionReferenceCode_toString = 'STATION'
    case(PositionReferenceCode_YOKE)
       PositionReferenceCode_toString = 'YOKE'
    case(PositionReferenceCode_REFLECTOR)
       PositionReferenceCode_toString = 'REFLECTOR'
    end select
  end function PositionReferenceCode_toString
!
  function PositionReferenceCode_fromString(str)
    integer :: PositionReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('ITRF')
       PositionReferenceCode_fromString = PositionReferenceCode_ITRF
    case('WGS84')
       PositionReferenceCode_fromString = PositionReferenceCode_WGS84
    case('SITE')
       PositionReferenceCode_fromString = PositionReferenceCode_SITE
    case('STATION')
       PositionReferenceCode_fromString = PositionReferenceCode_STATION
    case('YOKE')
       PositionReferenceCode_fromString = PositionReferenceCode_YOKE
    case('REFLECTOR')
       PositionReferenceCode_fromString = PositionReferenceCode_REFLECTOR
    end select
  end function PositionReferenceCode_fromString
!
  function DirectionReferenceCode_toString(i)
    integer :: i
    character*80 :: DirectionReferenceCode_toString
    select case(i)
    case(DirectionReferenceCode_J2000)
       DirectionReferenceCode_toString = 'J2000'
    case(DirectionReferenceCode_JMEAN)
       DirectionReferenceCode_toString = 'JMEAN'
    case(DirectionReferenceCode_JTRUE)
       DirectionReferenceCode_toString = 'JTRUE'
    case(DirectionReferenceCode_APP)
       DirectionReferenceCode_toString = 'APP'
    case(DirectionReferenceCode_B1950)
       DirectionReferenceCode_toString = 'B1950'
    case(DirectionReferenceCode_B1950_VLA)
       DirectionReferenceCode_toString = 'B1950_VLA'
    case(DirectionReferenceCode_BMEAN)
       DirectionReferenceCode_toString = 'BMEAN'
    case(DirectionReferenceCode_BTRUE)
       DirectionReferenceCode_toString = 'BTRUE'
    case(DirectionReferenceCode_GALACTIC)
       DirectionReferenceCode_toString = 'GALACTIC'
    case(DirectionReferenceCode_HADEC)
       DirectionReferenceCode_toString = 'HADEC'
    case(DirectionReferenceCode_AZELSW)
       DirectionReferenceCode_toString = 'AZELSW'
    case(DirectionReferenceCode_AZELSWGEO)
       DirectionReferenceCode_toString = 'AZELSWGEO'
    case(DirectionReferenceCode_AZELNE)
       DirectionReferenceCode_toString = 'AZELNE'
    case(DirectionReferenceCode_AZELNEGEO)
       DirectionReferenceCode_toString = 'AZELNEGEO'
    case(DirectionReferenceCode_JNAT)
       DirectionReferenceCode_toString = 'JNAT'
    case(DirectionReferenceCode_ECLIPTIC)
       DirectionReferenceCode_toString = 'ECLIPTIC'
    case(DirectionReferenceCode_MECLIPTIC)
       DirectionReferenceCode_toString = 'MECLIPTIC'
    case(DirectionReferenceCode_TECLIPTIC)
       DirectionReferenceCode_toString = 'TECLIPTIC'
    case(DirectionReferenceCode_SUPERGAL)
       DirectionReferenceCode_toString = 'SUPERGAL'
    case(DirectionReferenceCode_ITRF)
       DirectionReferenceCode_toString = 'ITRF'
    case(DirectionReferenceCode_TOPO)
       DirectionReferenceCode_toString = 'TOPO'
    case(DirectionReferenceCode_ICRS)
       DirectionReferenceCode_toString = 'ICRS'
    case(DirectionReferenceCode_MERCURY)
       DirectionReferenceCode_toString = 'MERCURY'
    case(DirectionReferenceCode_VENUS)
       DirectionReferenceCode_toString = 'VENUS'
    case(DirectionReferenceCode_MARS)
       DirectionReferenceCode_toString = 'MARS'
    case(DirectionReferenceCode_JUPITER)
       DirectionReferenceCode_toString = 'JUPITER'
    case(DirectionReferenceCode_SATURN)
       DirectionReferenceCode_toString = 'SATURN'
    case(DirectionReferenceCode_URANUS)
       DirectionReferenceCode_toString = 'URANUS'
    case(DirectionReferenceCode_NEPTUNE)
       DirectionReferenceCode_toString = 'NEPTUNE'
    case(DirectionReferenceCode_PLUTO)
       DirectionReferenceCode_toString = 'PLUTO'
    case(DirectionReferenceCode_SUN)
       DirectionReferenceCode_toString = 'SUN'
    case(DirectionReferenceCode_MOON)
       DirectionReferenceCode_toString = 'MOON'
    end select
  end function DirectionReferenceCode_toString
!
  function DirectionReferenceCode_fromString(str)
    integer :: DirectionReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('J2000')
       DirectionReferenceCode_fromString = DirectionReferenceCode_J2000
    case('JMEAN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JMEAN
    case('JTRUE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JTRUE
    case('APP')
       DirectionReferenceCode_fromString = DirectionReferenceCode_APP
    case('B1950')
       DirectionReferenceCode_fromString = DirectionReferenceCode_B1950
    case('B1950_VLA')
       DirectionReferenceCode_fromString = DirectionReferenceCode_B1950_VLA
    case('BMEAN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_BMEAN
    case('BTRUE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_BTRUE
    case('GALACTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_GALACTIC
    case('HADEC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_HADEC
    case('AZELSW')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELSW
    case('AZELSWGEO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELSWGEO
    case('AZELNE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELNE
    case('AZELNEGEO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_AZELNEGEO
    case('JNAT')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JNAT
    case('ECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ECLIPTIC
    case('MECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MECLIPTIC
    case('TECLIPTIC')
       DirectionReferenceCode_fromString = DirectionReferenceCode_TECLIPTIC
    case('SUPERGAL')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SUPERGAL
    case('ITRF')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ITRF
    case('TOPO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_TOPO
    case('ICRS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_ICRS
    case('MERCURY')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MERCURY
    case('VENUS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_VENUS
    case('MARS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MARS
    case('JUPITER')
       DirectionReferenceCode_fromString = DirectionReferenceCode_JUPITER
    case('SATURN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SATURN
    case('URANUS')
       DirectionReferenceCode_fromString = DirectionReferenceCode_URANUS
    case('NEPTUNE')
       DirectionReferenceCode_fromString = DirectionReferenceCode_NEPTUNE
    case('PLUTO')
       DirectionReferenceCode_fromString = DirectionReferenceCode_PLUTO
    case('SUN')
       DirectionReferenceCode_fromString = DirectionReferenceCode_SUN
    case('MOON')
       DirectionReferenceCode_fromString = DirectionReferenceCode_MOON
    end select
  end function DirectionReferenceCode_fromString
!
  function BaselineReferenceCode_toString(i)
    integer :: i
    character*80 :: BaselineReferenceCode_toString
    select case(i)
    case(BaselineReferenceCode_J2000)
       BaselineReferenceCode_toString = 'J2000'
    case(BaselineReferenceCode_B1950)
       BaselineReferenceCode_toString = 'B1950'
    case(BaselineReferenceCode_GALACTIC)
       BaselineReferenceCode_toString = 'GALACTIC'
    case(BaselineReferenceCode_SUPERGAL)
       BaselineReferenceCode_toString = 'SUPERGAL'
    case(BaselineReferenceCode_ECLIPTIC)
       BaselineReferenceCode_toString = 'ECLIPTIC'
    case(BaselineReferenceCode_JMEAN)
       BaselineReferenceCode_toString = 'JMEAN'
    case(BaselineReferenceCode_JTRUE)
       BaselineReferenceCode_toString = 'JTRUE'
    case(BaselineReferenceCode_APP)
       BaselineReferenceCode_toString = 'APP'
    case(BaselineReferenceCode_BMEAN)
       BaselineReferenceCode_toString = 'BMEAN'
    case(BaselineReferenceCode_BTRUE)
       BaselineReferenceCode_toString = 'BTRUE'
    case(BaselineReferenceCode_JNAT)
       BaselineReferenceCode_toString = 'JNAT'
    case(BaselineReferenceCode_MECLIPTIC)
       BaselineReferenceCode_toString = 'MECLIPTIC'
    case(BaselineReferenceCode_TECLIPTIC)
       BaselineReferenceCode_toString = 'TECLIPTIC'
    case(BaselineReferenceCode_TOPO)
       BaselineReferenceCode_toString = 'TOPO'
    case(BaselineReferenceCode_MERCURY)
       BaselineReferenceCode_toString = 'MERCURY'
    case(BaselineReferenceCode_VENUS)
       BaselineReferenceCode_toString = 'VENUS'
    case(BaselineReferenceCode_MARS)
       BaselineReferenceCode_toString = 'MARS'
    case(BaselineReferenceCode_JUPITER)
       BaselineReferenceCode_toString = 'JUPITER'
    case(BaselineReferenceCode_SATURN)
       BaselineReferenceCode_toString = 'SATURN'
    case(BaselineReferenceCode_NEPTUN)
       BaselineReferenceCode_toString = 'NEPTUN'
    case(BaselineReferenceCode_SUN)
       BaselineReferenceCode_toString = 'SUN'
    case(BaselineReferenceCode_MOON)
       BaselineReferenceCode_toString = 'MOON'
    case(BaselineReferenceCode_HADEC)
       BaselineReferenceCode_toString = 'HADEC'
    case(BaselineReferenceCode_AZEL)
       BaselineReferenceCode_toString = 'AZEL'
    case(BaselineReferenceCode_AZELGEO)
       BaselineReferenceCode_toString = 'AZELGEO'
    case(BaselineReferenceCode_AZELSW)
       BaselineReferenceCode_toString = 'AZELSW'
    case(BaselineReferenceCode_AZELNE)
       BaselineReferenceCode_toString = 'AZELNE'
    case(BaselineReferenceCode_ITRF)
       BaselineReferenceCode_toString = 'ITRF'
    end select
  end function BaselineReferenceCode_toString
!
  function BaselineReferenceCode_fromString(str)
    integer :: BaselineReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('J2000')
       BaselineReferenceCode_fromString = BaselineReferenceCode_J2000
    case('B1950')
       BaselineReferenceCode_fromString = BaselineReferenceCode_B1950
    case('GALACTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_GALACTIC
    case('SUPERGAL')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SUPERGAL
    case('ECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_ECLIPTIC
    case('JMEAN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JMEAN
    case('JTRUE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JTRUE
    case('APP')
       BaselineReferenceCode_fromString = BaselineReferenceCode_APP
    case('BMEAN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_BMEAN
    case('BTRUE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_BTRUE
    case('JNAT')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JNAT
    case('MECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MECLIPTIC
    case('TECLIPTIC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_TECLIPTIC
    case('TOPO')
       BaselineReferenceCode_fromString = BaselineReferenceCode_TOPO
    case('MERCURY')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MERCURY
    case('VENUS')
       BaselineReferenceCode_fromString = BaselineReferenceCode_VENUS
    case('MARS')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MARS
    case('JUPITER')
       BaselineReferenceCode_fromString = BaselineReferenceCode_JUPITER
    case('SATURN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SATURN
    case('NEPTUN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_NEPTUN
    case('SUN')
       BaselineReferenceCode_fromString = BaselineReferenceCode_SUN
    case('MOON')
       BaselineReferenceCode_fromString = BaselineReferenceCode_MOON
    case('HADEC')
       BaselineReferenceCode_fromString = BaselineReferenceCode_HADEC
    case('AZEL')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZEL
    case('AZELGEO')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELGEO
    case('AZELSW')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELSW
    case('AZELNE')
       BaselineReferenceCode_fromString = BaselineReferenceCode_AZELNE
    case('ITRF')
       BaselineReferenceCode_fromString = BaselineReferenceCode_ITRF
    end select
  end function BaselineReferenceCode_fromString
!
  function FrequencyReferenceCode_toString(i)
    integer :: i
    character*80 :: FrequencyReferenceCode_toString
    select case(i)
    case(FrequencyReferenceCode_LABREST)
       FrequencyReferenceCode_toString = 'LABREST'
    case(FrequencyReferenceCode_LSRD)
       FrequencyReferenceCode_toString = 'LSRD'
    case(FrequencyReferenceCode_LSRK)
       FrequencyReferenceCode_toString = 'LSRK'
    case(FrequencyReferenceCode_BARY)
       FrequencyReferenceCode_toString = 'BARY'
    case(FrequencyReferenceCode_REST)
       FrequencyReferenceCode_toString = 'REST'
    case(FrequencyReferenceCode_GEO)
       FrequencyReferenceCode_toString = 'GEO'
    case(FrequencyReferenceCode_GALACTO)
       FrequencyReferenceCode_toString = 'GALACTO'
    case(FrequencyReferenceCode_TOPO)
       FrequencyReferenceCode_toString = 'TOPO'
    end select
  end function FrequencyReferenceCode_toString
!
  function FrequencyReferenceCode_fromString(str)
    integer :: FrequencyReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('LABREST')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LABREST
    case('LSRD')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LSRD
    case('LSRK')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_LSRK
    case('BARY')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_BARY
    case('REST')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_REST
    case('GEO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_GEO
    case('GALACTO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_GALACTO
    case('TOPO')
       FrequencyReferenceCode_fromString = FrequencyReferenceCode_TOPO
    end select
  end function FrequencyReferenceCode_fromString
!
  function RadialVelocityReferenceCode_toString(i)
    integer :: i
    character*80 :: RadialVelocityReferenceCode_toString
    select case(i)
    case(RadialVelocityReferenceCode_LSRD)
       RadialVelocityReferenceCode_toString = 'LSRD'
    case(RadialVelocityReferenceCode_LSRK)
       RadialVelocityReferenceCode_toString = 'LSRK'
    case(RadialVelocityReferenceCode_GALACTO)
       RadialVelocityReferenceCode_toString = 'GALACTO'
    case(RadialVelocityReferenceCode_BARY)
       RadialVelocityReferenceCode_toString = 'BARY'
    case(RadialVelocityReferenceCode_GEO)
       RadialVelocityReferenceCode_toString = 'GEO'
    case(RadialVelocityReferenceCode_TOPO)
       RadialVelocityReferenceCode_toString = 'TOPO'
    end select
  end function RadialVelocityReferenceCode_toString
!
  function RadialVelocityReferenceCode_fromString(str)
    integer :: RadialVelocityReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('LSRD')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_LSRD
    case('LSRK')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_LSRK
    case('GALACTO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_GALACTO
    case('BARY')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_BARY
    case('GEO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_GEO
    case('TOPO')
       RadialVelocityReferenceCode_fromString = RadialVelocityReferenceCode_TOPO
    end select
  end function RadialVelocityReferenceCode_fromString
!
  function DopplerReferenceCode_toString(i)
    integer :: i
    character*80 :: DopplerReferenceCode_toString
    select case(i)
    case(DopplerReferenceCode_RADIO)
       DopplerReferenceCode_toString = 'RADIO'
    case(DopplerReferenceCode_Z)
       DopplerReferenceCode_toString = 'Z'
    case(DopplerReferenceCode_RATIO)
       DopplerReferenceCode_toString = 'RATIO'
    case(DopplerReferenceCode_BETA)
       DopplerReferenceCode_toString = 'BETA'
    case(DopplerReferenceCode_GAMMA)
       DopplerReferenceCode_toString = 'GAMMA'
    case(DopplerReferenceCode_OPTICAL)
       DopplerReferenceCode_toString = 'OPTICAL'
    case(DopplerReferenceCode_RELATIVISTIC)
       DopplerReferenceCode_toString = 'RELATIVISTIC'
    end select
  end function DopplerReferenceCode_toString
!
  function DopplerReferenceCode_fromString(str)
    integer :: DopplerReferenceCode_fromString
    character*80 :: str
    select case(str)
    case('RADIO')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RADIO
    case('Z')
       DopplerReferenceCode_fromString = DopplerReferenceCode_Z
    case('RATIO')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RATIO
    case('BETA')
       DopplerReferenceCode_fromString = DopplerReferenceCode_BETA
    case('GAMMA')
       DopplerReferenceCode_fromString = DopplerReferenceCode_GAMMA
    case('OPTICAL')
       DopplerReferenceCode_fromString = DopplerReferenceCode_OPTICAL
    case('RELATIVISTIC')
       DopplerReferenceCode_fromString = DopplerReferenceCode_RELATIVISTIC
    end select
  end function DopplerReferenceCode_fromString
!
  function CorrelatorType_toString(i)
    integer :: i
    character*80 :: CorrelatorType_toString
    select case(i)
    case(CorrelatorType_FX)
       CorrelatorType_toString = 'FX'
    case(CorrelatorType_XF)
       CorrelatorType_toString = 'XF'
    case(CorrelatorType_FXF)
       CorrelatorType_toString = 'FXF'
    end select
  end function CorrelatorType_toString
!
  function CorrelatorType_fromString(str)
    integer :: CorrelatorType_fromString
    character*80 :: str
    select case(str)
    case('FX')
       CorrelatorType_fromString = CorrelatorType_FX
    case('XF')
       CorrelatorType_fromString = CorrelatorType_XF
    case('FXF')
       CorrelatorType_fromString = CorrelatorType_FXF
    end select
  end function CorrelatorType_fromString
end module sdm_Enumerations

subroutine gag_diff_char(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_char
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  character(len=*), intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,A,T52,A)
end subroutine gag_diff_char
!
subroutine gag_diff_inte(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_inte
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=4),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_inte
!
subroutine gag_diff_long(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_long
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=8),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_long
!
subroutine gag_diff_real(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_real
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=4),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.e-6))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG12.5,T52,1PG12.5)
  !
end subroutine gag_diff_real
!
subroutine gag_diff_dble(caller,secname,secwarned,elemname,a,b)
  use gmath_interfaces, except_this=>gag_diff_dble
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=8),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.d-14))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG19.12,T52,1PG19.12)
  !
end subroutine gag_diff_dble
!
subroutine gag_diff_datar4(caller,a,b,ndata,same)
  use gildas_def
  use gmath_interfaces
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Returns a message if the two flat arrays a and b differ (with some
  ! machine tolerance).
  !---------------------------------------------------------------------
  character(len=*),          intent(in)  :: caller
  integer(kind=size_length), intent(in)  :: ndata
  real(kind=4),              intent(in)  :: a(ndata),b(ndata)
  logical,                   intent(out) :: same
  ! Local
  character(len=message_length) :: mess
  real(kind=4), parameter :: eps=1.e-6
  !
  same = nearly_equal(a,b,ndata,eps)
  !
  if (.not.same) then
    write (mess,'(A,1PG7.1,A)')  'Data differ by ',eps,' relative difference at least'
    call gmath_message(seve%r,caller,mess)
  endif
  !
end subroutine gag_diff_datar4
!
function nearly_equal_r4_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_0d
  real(kind=4), intent(in) :: a,b
  real(kind=4), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r4_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r4_0d
!
function nearly_equal_r8_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r8_0d
  real(kind=8), intent(in) :: a,b
  real(kind=8), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=8) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r8_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r8_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r8_0d
!
function nearly_equal_r4_1d(a,b,ndata,eps)
  use gildas_def
  use gmath_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_1d
  integer(kind=size_length), intent(in) :: ndata
  real(kind=4),              intent(in) :: a(ndata),b(ndata)
  real(kind=4),              intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4), allocatable :: diff(:)
  logical :: error
  integer(kind=4) :: ier
  integer(kind=size_length) :: idata
  !
  nearly_equal_r4_1d = .true.
  !
  do idata=1,ndata
    if (a(idata).ne.a(idata) .and. b(idata).ne.b(idata))  cycle  ! Both are NaN => equal
    if (a(idata).eq.b(idata))  cycle  ! Strictly equal
    nearly_equal_r4_1d = .false.  ! Not strictly equal, need comparison with tolerance
    exit
  enddo
  if (nearly_equal_r4_1d)  return
  !
  error = .false.
  allocate(diff(ndata),stat=ier)
  if (failed_allocate('DIFF','diff',ier,error)) return
  diff(:) = abs(a-b)
  !
  ! Can I write a vectorized form of this test?
!     if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
!       ! a or b is zero or both are extremely close to it. Note the use
!       ! of tiny() which returns the smallest floating point number
!       ! representable without being a denormal number.
!       ! Relative error is less meaningful here
!       nearly_equal_r4_1d = diff.lt.eps*tiny(a)
!       return
!     endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_1d = all(diff/(abs(a)+abs(b)).lt.eps)
  !
  deallocate(diff)
  !
end function nearly_equal_r4_1d

program shift_main
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Main program for shifting a 2D image by phase factor in Fourier plane.
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: pname = 'SHIFT'
  real(8), parameter :: pi=3.141592653589793d0
  !
  character(len=filename_length) :: namex,namey
  logical :: error
  real :: xx,yy,xshift,yshift
  complex :: shift
  integer :: i, j, nxy, ndim, dims(2), ier
  complex, allocatable :: cdata(:,:)
  real, allocatable :: work(:), rdata(:,:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('X_SHIFT$',xshift,1)
  call gildas_real('Y_SHIFT$',yshift,1)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot read input file '//trim(y%file) 
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot create output image'
    goto 100
  endif
  !
  ! Check if work space is needed.
  nxy = 2*max(x%gil%dim(1),x%gil%dim(2))
  allocate (work(nxy), cdata(x%gil%dim(1), x%gil%dim(2)), &
       & rdata(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  nxy = x%gil%dim(1)*x%gil%dim(2)
  if (ier.ne.0) goto 100
  !
  ! Compute shift factor
  xx = 2.d0*pi*xshift/x%gil%inc(1)
  yy = 2.d0*pi*yshift/x%gil%inc(2)
  shift = cmplx(cos(xx),sin(xx))*cmplx(cos(yy),sin(yy))
  !
  ! Prepare FFTW
  dims = x%gil%dim(1:2)
  ndim = 2
  call fourt_plan (cdata,dims,ndim,1,0)
  call fourt_plan (cdata,dims,ndim,-1,1)
  !
  do j=1,x%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i=1,x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,rdata,error)
      !
      cdata(:,:) = cmplx(rdata,0.0)
      call fourt(cdata,dims,ndim,1,0,work)
      cdata(:,:) = cdata*shift         ! Apply phase shift
      call fourt(cdata,dims,ndim,-1,+1,work) 
      rdata(:,:) = real(cdata)/nxy     ! Normalize fft
      !
      call gdf_write_data(x,rdata,error)
    enddo
  enddo
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program shift_main

subroutine difsys4 (f,eps,h,x,y)
  use greg_interfaces, except_this=>difsys4
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !       adapted from Prof. Dr. R. BULIRSCH, 1972-73
  !	P. VALIRON				21-AUG-80
  !	adapted for single precision		27-SEP-84
  !	Integration of first order differential equations.
  !	The equation is supposed to be of the form:
  !             DY/DX = F(X,Y)
  ! Arguments :
  !	F	Ext	User supplied subroutine. Computes
  !			the right end of (1) for a given X and Y
  !			F must contain the instructions:
  !				SUBROUTINE F(X,Y,DYDX)
  !				REAL*4 X,Y,DYDX
  !	EPS	R*4	Accuracy, kept internally > 1.E-11
  !	H	R*4	User estimate of the best step of
  !			integration, updated.
  !	X	R*4	initial abcissa.
  !	Y	R*4	Initial value of Y.
  !	After the calculation, X is replaced by X+H2 and Y by its
  !	value for the abscissa X+H2. H2 is less or equal to H, its value
  !	is chosen internally to satisfy the required accuracy EPS.
  !	The subroutine returns H equal to the best value for the next
  !	step. If the system seems to be ill conditioned, or if the initial
  !	value for H is much too high, H is returned equal to 0.
  !	( See BULIRSCH,R. and STOER,J.; NUM.MATH. /8/,1-13 (1966) )
  ! Subroutines :
  !	F	External
  !---------------------------------------------------------------------
  external :: f                     !
  real*4 :: eps                     !
  real*4 :: h                       !
  real*4 :: x                       !
  real*4 :: y                       !
  ! Local
  real*4 :: ya,yl,ym,dy,dz,dt(7),d(7),s
  real*4 :: xn,g,b,b1,u,v,c,ta,w,ep(4)
  logical ::   konv,bo,kl,gr
  integer :: jti,m,jr,js,j,l,k
  real :: fy,eta,fs,fv,fa
  data ep/0.4e-1,0.16e-2,0.64e-4,0.256e-5/
  !
  jti=0
  fy=1.
  eta=abs(eps)
  if (eta.lt.1.e-11) eta=1.e-11
  ya=y
  call f (x,y,dz)
10 xn=x+h
  bo=.false.
  s=0.
  m=1
  jr=2
  js=3
  do j=1,10
    if(.not.bo) goto 200
    d(2)=1.777777777777778
    d(4)=7.111111111111111
    d(6)=28.44444444444444
    goto 201
200 d(2)=2.25
    d(4)=9.
    d(6)=36.
201 if(j.le.7) goto 202
    l=7
    d(7)=64.
    goto 203
202 l=j
    d(l)=m*m
203 konv=l.gt.3
    m=m+m
    g=h/float(m)
    b=g+g
    m=m-1
    yl=ya
    ym=ya+g*dz
    do k=1,m
      call f (x+float(k)*g,ym,dy)
      u=yl+b*dy
      yl=ym
      ym=u
      u=abs(u)
      if(u.gt.s) s=u
    enddo                      ! K
    call f (xn,ym,dy)
    kl=l.lt.2
    gr=l.gt.5
    fs=0.
    v=dt(1)
    c=(ym+yl+g*dy)*0.5
    dt(1)=c
    ta=c
    if(kl) goto 233
    do k=2,l
      b1=d(k)*v
      b=b1-c
      w=c-v
      u=v
      if(b.eq.0.) goto 230
      b=w/b
      u=c*b
      c=b1*b
230   v=dt(k)
      dt(k)=u
      ta=u+ta
    enddo                      ! K
    if(.not.konv) goto 232
    if(abs(y-ta).gt.s*eta) konv=.false.
232 if(gr.or.s.eq.0.) goto 233
    fv=abs(w)/s
    if(fs.lt.fv) fs=fv
233 y=ta
    if(fs.eq.0.) goto 250
    fa=fy
    k=l-1
    fy=(ep(k)/fs)**(1./float(l+k))
    if(l.eq.2) goto 240
    if(fy.lt.0.7*fa) goto 250
240 if(fy.gt.0.7) goto 250
    h=h*fy
    jti=jti+1
    if(jti.gt.5) goto 30
    goto 10
250 if(konv) goto 20
    d(3)=4.
    d(5)=16.
    bo=.not.bo
    m=jr
    jr=js
    js=m+m
  enddo                        ! J
  h=h*0.5
  goto 10
20 x=xn
  h=h*fy
  return
30 h=0.
  y=ya
  return
end subroutine difsys4

!
subroutine dofft_parallel_y (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  use gbl_message
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  UVMAP
  !   Compute FFT of image by gridding UV data
  !   Taper after gridding
  !   Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  !
  real(8) :: elapsed_s, elapsed_e, elapsed
  ! Much less efficient than the Visibility order, but can be
  ! parallelized without major issue.
  !
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  real :: atten(nx,ny)
  integer iu,iv
  integer ifirsp,ilastp,ifirsm,ilastm,my
  integer ix,iy,ic,i,iin,iou,io
  integer kx,ky,fy
  real result,staper,vtaper,utaper,etaper
  real u,v,um,up,vm,vp,ufac,vfac
  real cx,cy,sx,sy
  !
  integer ithread,nthread,lchunk
  character(len=60) :: chain
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  ! Initialize
  !     MY = NY       ! Slow version
  my = ny/2+1                  ! Fast version, using symmetry
  ifirsp = 1
  ilastm = nv
  !
  ! Compute the first valid pixel
  fy = int((vv(1)-sup(2))/(mapy(2)-mapy(1))+ny/2+1)
  !
  ! Precompute the taper
  if (taper(3).ne.0.0) then
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
  endif
  !
  if (taper(4).ne.0) then
    etaper = taper(4)/2.0
  else
    etaper = 1.0
  endif
  !
  atten = 0.0
  !
  do iy=fy,my
    v = mapy(iy)
    if (taper(3).ne.0) then
      vtaper = -1.0
    elseif  (taper(2).eq.0) then
      vtaper = 1.0
    else
      vtaper = abs(v/taper(2))**(etaper*2.0)
      if (vtaper.gt.64) then
        vtaper = 0
      else
        vtaper = exp(-vtaper)
      endif
    endif
    if (vtaper.ne.0) then
      do ix=1,nx
        u = mapx(ix)
        if (taper(3).ne.0) then
          ! General rotated case...
          staper = (u*cx + v*sy)**2 +   &
     &            (-u*sx + v*cy)**2
          if (etaper.ne.1) staper = staper**etaper
          if (staper.gt.64.0) then
            staper = 0.0
          else
            staper = exp(-staper)
          endif
        elseif  (taper(1).eq.0) then
          staper = vtaper
        else
          utaper = abs(u/taper(1))**(2.0*etaper)
          if (utaper.gt.64) then
            utaper = 0
          else
            utaper = exp(-utaper)
          endif
          staper = vtaper*utaper
        endif
        if (taper(1).lt.0) then
          staper = 1.0-staper
          if (staper.ne.1.0) print *,u,v,staper
        endif
        !
        atten(ix,iy) = staper
      enddo
    else
      do ix=1,nx
        atten(ix,iy) = 0.0
      enddo
    endif
  enddo
  !
  write(*,'(A,F9.2)') 'I-DOFFT, Parallel Gridding Y Mode'
  !
  !$OMP PARALLEL DEFAULT (none) &
  !$OMP   & PRIVATE(nthread,lchunk,ithread) &
  !$OMP   & SHARED(fy,my,ny,nx,nc,nv,io,jx,jy) &
  !$OMP   & PRIVATE(iy,ix,vm,vp,um,up,staper) &
  !$OMP   & SHARED(map,mapx,mapy,vv,atten,sup) &
  !$OMP   & PRIVATE(ifirsp,ilastp,ifirsm,ilastm) &
  !$OMP   & PRIVATE(iin,iou,ic,result,u,v,iu,iv) &
  !$OMP   & SHARED(ubuff,vbuff,ubias,vbias,ufac,vfac,visi,we) &
  !$OMP   & PRIVATE(elapsed_s,elapsed_e,elapsed,chain, kx,ky)
  !
  nthread = 1
  !$  nthread = omp_get_num_threads()
  !$  ithread = omp_get_thread_num() + 1
  !$  elapsed_s = omp_get_wtime()
  lchunk = (my+nthread-1)/nthread
  !
  ! IFIRSP always increases, ILASTM always decreases
  ! but with Open-MP, the ordered is not guaranteed, so
  ! reinitialize each time
  ifirsp = 1
  ilastm = nv
  ! Here I tried without, as my version is sequential, but
  ! it did not change computing time, as expected
  !
  !$OMP DO
  do iy=1,ny
    map(:,:,iy) = 0.0
  enddo
  !$OMP END DO
  !
  map = 0.0
  !$OMP DO
  do iy=fy,my
    v = mapy(iy)
    !
    ! Optimized dichotomic search, taking into account the fact that
    !  VV is an ordered array
    !
    ! IFIRSP always increases, ILASTM always decreases
    ! but with Open-MP, the ordered is not guaranteed, so
    ! reinitialize each time
    ifirsp = 1
    ilastm = nv
    !
    vm = v-sup(2)
    vp = v+sup(2)
    call findp (nv,vv,vm,ifirsp)
    ilastp = ifirsp
    call findp (nv,vv,vp,ilastp)
    ilastp = ilastp-1
    !
    ilastm = ilastm+1
    vm = -v-sup(2)
    vp = -v+sup(2)
    call findm (nv,vv,vp,ilastm)
    ifirsm = ilastm
    ilastm = ilastm-1
    call findm (nv,vv,vm,ifirsm)
    !
    ! Loop on X cells
    if (ilastp.ge.ifirsp .or. ilastm.ge.ifirsm) then
      do ix=1,nx
        u = mapx(ix)
        staper = atten(ix,iy)
        !
        ! Do while in X cell for (+U,+V)
        um = u-sup(1)
        up = u+sup(1)
        do i=ifirsp,ilastp
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint((u-visi(jx,i))*ufac+ubias)
            iv = nint((v-visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            !
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo
        !
        ! Do while in X cell for (-U,-V)
        um = -u-sup(1)
        up = -u+sup(1)
        do i=ifirsm,ilastm
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint(-(u+visi(jx,i))*ufac+ubias)
            iv = nint(-(v+visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',-iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) -   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo                  ! Visibility loop
      enddo                    ! IX Loop
    endif
  enddo
  !$OMP END DO
!  write(chain,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
!  call map_message(seve%i,rname,chain)
  !
  ! Symmetry
  !$OMP DO
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !$OMP END DO
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
  !$OMP END PARALLEL
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
end subroutine dofft_parallel_y
!
subroutine dofft_parallel_x (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  use gbl_message
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  UVMAP
  !   Compute FFT of image by gridding UV data
  !   Taper after gridding
  !   Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  !
  real(8) :: elapsed_s, elapsed_e, elapsed
  ! Much less efficient than the Visibility order, but can be
  ! parallelized without major issue.
  !
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  real :: atten(nx,ny)
  integer iu,iv
  integer ifirsp,ilastp,ifirsm,ilastm,my
  integer ix,iy,ic,i,iin,iou,io
  integer kx,ky,fy
  real result,staper,vtaper,utaper,etaper
  real u,v,um,up,vm,vp,ufac,vfac
  real cx,cy,sx,sy
  !
  integer ithread,nthread,lchunk
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  ! Initialize
  !     MY = NY       ! Slow version
  my = ny/2+1                  ! Fast version, using symmetry
  ifirsp = 1
  ilastm = nv
  !
  ! Compute the first valid pixel
  fy = int((vv(1)-sup(2))/(mapy(2)-mapy(1))+ny/2+1)
  !
  ! Precompute the taper
  if (taper(3).ne.0.0) then
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
  endif
  !
  if (taper(4).ne.0) then
    etaper = taper(4)/2.0
  else
    etaper = 1.0
  endif
  !
  atten = 0.0
  !
  do iy=fy,my
    v = mapy(iy)
    if (taper(3).ne.0) then
      vtaper = -1.0
    elseif  (taper(2).eq.0) then
      vtaper = 1.0
    else
      vtaper = abs(v/taper(2))**(etaper*2.0)
      if (vtaper.gt.64) then
        vtaper = 0
      else
        vtaper = exp(-vtaper)
      endif
    endif
    if (vtaper.ne.0) then
      do ix=1,nx
        u = mapx(ix)
        if (taper(3).ne.0) then
          ! General rotated case...
          staper = (u*cx + v*sy)**2 +   &
     &            (-u*sx + v*cy)**2
          if (etaper.ne.1) staper = staper**etaper
          if (staper.gt.64.0) then
            staper = 0.0
          else
            staper = exp(-staper)
          endif
        elseif  (taper(1).eq.0) then
          staper = vtaper
        else
          utaper = abs(u/taper(1))**(2.0*etaper)
          if (utaper.gt.64) then
            utaper = 0
          else
            utaper = exp(-utaper)
          endif
          staper = vtaper*utaper
        endif
        if (taper(1).lt.0) then
          staper = 1.0-staper
          if (staper.ne.1.0) print *,u,v,staper
        endif
        !
        atten(ix,iy) = staper
      enddo
    else
      do ix=1,nx
        atten(ix,iy) = 0.0
      enddo
    endif
  enddo
  !
  map = 0.0
  write(*,'(A,F9.2)') 'I-DOFFT, Parallel Gridding X Mode'
  !
  !$  elapsed_s = omp_get_wtime()
  !
  ! IFIRSP always increases, ILASTM always decreases
  ifirsp = 1
  ilastm = nv
  !
  do iy=fy,my
    v = mapy(iy)
    !
    ! Optimized dichotomic search, taking into account the fact that
    !  VV is an ordered array
    !
    !
    vm = v-sup(2)
    vp = v+sup(2)
    call findp (nv,vv,vm,ifirsp)
    ilastp = ifirsp
    call findp (nv,vv,vp,ilastp)
    ilastp = ilastp-1
    !
    ilastm = ilastm+1
    vm = -v-sup(2)
    vp = -v+sup(2)
    call findm (nv,vv,vp,ilastm)
    ifirsm = ilastm
    ilastm = ilastm-1
    call findm (nv,vv,vm,ifirsm)
    !
    ! Loop on X cells
    if (ilastp.ge.ifirsp .or. ilastm.ge.ifirsm) then
      !$OMP PARALLEL DEFAULT (none) &
      !$OMP   & PRIVATE(nthread,lchunk,ithread) &
      !$OMP   & SHARED(fy,my,ny,nx,nc,nv,io,jx,jy) &
      !$OMP   & SHARED(iy,vm,vp,v) &
      !$OMP   & PRIVATE(ix,um,up,staper) &
      !$OMP   & SHARED(ifirsp,ilastp,ifirsm,ilastm) &
      !$OMP   & SHARED(map,mapx,mapy,vv,atten,sup) &
      !$OMP   & PRIVATE(iin,iou,ic,result,u,iu,iv) &
      !$OMP   & SHARED(ubuff,vbuff,ubias,vbias,ufac,vfac,visi,we)
      nthread = 1
      !$  nthread = omp_get_num_threads()
      !$  ithread = omp_get_thread_num() + 1
      lchunk = (my+nthread-1)/nthread
      !
      !$OMP DO
      do ix=1,nx
        u = mapx(ix)
        staper = atten(ix,iy)
        !
        ! Do while in X cell for (+U,+V)
        um = u-sup(1)
        up = u+sup(1)
        do i=ifirsp,ilastp
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint((u-visi(jx,i))*ufac+ubias)
            iv = nint((v-visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            !
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo
        !
        ! Do while in X cell for (-U,-V)
        um = -u-sup(1)
        up = -u+sup(1)
        do i=ifirsm,ilastm
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            iu = nint(-(u+visi(jx,i))*ufac+ubias)
            iv = nint(-(v+visi(jy,i))*vfac+vbias)
            result = ubuff(iu)*vbuff(iv)
            if (result.ne.0.0) then
              if (ix.eq.1) then
                print *,'Unsufficient coverage',-iy,ny
              endif
              ! Weight and taper
              result = result*staper*we(i)
              ! Channels
              iou = 1
              iin = io
              do ic=1,nc
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+1
                map (iou,ix,iy) = map (iou,ix,iy) -   &
     &                  visi(iin,i)*result
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              map (iou,ix,iy) = map(iou,ix,iy) + result
            endif
          endif
        enddo                  ! Visibility loop
      enddo                    ! IX Loop
      !$OMP END DO
      !$OMP END PARALLEL
    endif
  enddo
  !
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(*,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
!  write(chain,'(A,F9.2)') 'I-DOFFT, Finished Gridding -- Elapsed ',elapsed
!  call map_message(seve%i,rname,chain)
  !
  ! Symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
end subroutine dofft_parallel_x
!

subroutine mx_local_clean(hu,hb,hr,hc,hcct,grid,mapx,mapy,work,sblock, cpu0)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use cct_types
  use mx_parameters
  use clean_beam_tool, only: find_sidelobe
  use minmax_tool, only: maxmap
  !---------------------------------------------------------------------
  ! GILDAS: CLEAN Internal routine
  ! Implementation of MX CLEAN deconvolution algorithm.
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hu    ! UV Data  Header
  type(gildas), intent(in) :: hb    ! Beam     Header
  type(gildas), intent(in) :: hr    ! Residual Header
  type(gildas), intent(in) :: hcct  ! Clean Component Table Header
  type(gildas), intent(in) :: hc    ! Clean    Header
  real :: grid(hb%gil%dim(1),hb%gil%dim(2))     ! Gridding correction
  real :: mapx(hb%gil%dim(1))                   ! X coordinates
  real :: mapy(hb%gil%dim(2))                   ! Y coordinates
  real :: work(*)                   ! FFT Work array
  integer :: sblock                 ! Blocking factor
  real :: cpu0                      ! Starting CPU
  ! Local
  integer :: i, j, box(4), ix_min,iy_min, nx,ny,nz, nclean, k, ier
  complex, allocatable :: p_work(:,:)
  real, allocatable :: p_ux(:), p_vy(:)
  integer, allocatable :: p_iter(:)
  type (cct_par), allocatable :: p_comp(:)
  real :: xinc, yinc
  !
  nx = hr%gil%dim(1)
  ny = hr%gil%dim(2)
  !
  ! Get some memory
  nclean = (c_trc(1)-c_blc(1)+1) * (c_trc(2)-c_blc(2)+1)
  allocate (p_work(nx,ny), p_comp(nclean), p_ux(nx), p_vy(ny), stat=ier)
  !
  call mx_loadxy (hu,hr,p_ux,nx,p_vy,ny,mcol)
  !
  box(1) = 1
  box(2) = 1
  box(3) = nx
  box(4) = ny
  !
  ! Prepare beam parameters
  call maxmap (hb%r2d,nx,ny,box,   &
     &    beam_max,ix_beam,iy_beam,beam_min,ix_min,iy_min)
  write(6,1000) 'I-MX_CLEAN,  Beam maximum ',beam_max,   &
     &    ' at ',ix_beam,iy_beam
  write(6,1000) 'I-MX_CLEAN,  Beam minimum ',beam_min,   &
     &    ' at ',ix_min,iy_min
  call find_sidelobe (hb%r2d,nx,ny,   &
     &    ix_beam,iy_beam,ix_patch,iy_patch,beam_gain)
  write(6,1000) 'I-MX_CLEAN,  Maximum sidelobe is ',beam_gain
  !
  box(1) = c_blc(1)
  box(2) = c_blc(2)
  box(3) = c_trc(1)
  box(4) = c_trc(2)
  xinc = hc%gil%inc(1)
  yinc = hc%gil%inc(2)
  !
  ! Find components
  nz = hc%gil%dim(4)*hc%gil%dim(3)
  allocate (p_iter(nz), stat=ier)
  call mx_major (hu,   &
     &    hb%r2d, hr%r3d, nx,ny, nz,   &
     &    p_work, p_comp, nclean,   &
     &    box, max_iter, hcct%r3d, p_iter,   &
     &    grid,  mapx, mapy, p_ux, p_vy,  &
     &    work, map_tf, sblock, cpu0)
  !
  ! Add clean components to clean map
  k = 0
  do j=1,hc%gil%dim(4)
    do i=1,hc%gil%dim(3)
      k = k+1
      write(6,1001) 'I-CLARK,  Restoring plane ',i,j
      call mx_make_clean (   &
     &        hc%r3d(:,:,k),nx,ny,   &
     &        p_work,   &
     &        major_axis,minor_axis,pos_angle,   &
     &        xinc,yinc,hcct%r3d(:,:,k), p_iter(k), &
     &        work, hr%r3d(:,:,k) )
    enddo
  enddo
  !
  1001  format(a,i5,i5)
  1000  format(a,1pg11.4,a,i6,i6)
end subroutine mx_local_clean
!
subroutine mx_make_clean (clean,nx,ny,ft,bmaj,bmin,pa,   &
     &    xinc,yinc,compon,nc,work,resi)
  use gkernel_interfaces
  use mapping_gaussian_tool
  !---------------------------------------------------------------------
  ! GILDAS: CLEAN   Internal routine
  ! Convolve source list into residual map using the Fourier method.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: clean(nx,ny)              !
  complex :: ft(nx,ny)              !
  real :: bmaj                      !
  real :: bmin                      !
  real :: pa                        !
  real :: xinc                      !
  real :: yinc                      !
  integer :: nc                     !
  real :: compon(3,nc)              !
  real :: work(*)                   !
  real :: resi(nx,ny)               !
  ! Local
  real(8), parameter :: pi=3.141592653589793d0
  real :: fact
  integer :: i, j, ic, ndim, dim(2)
  !
  clean = resi
  if (nc.eq.0) return
  !
  ft = 0.0
  !
  ! Convolve source list into residual map ---
  do ic=1,nc
    i = nint(compon(2,ic))
    j = nint(compon(3,ic))
    ft(i,j) = ft(i,j) + compon(1,ic)
  enddo
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(ft,dim,ndim,-1,0,work)
  !
  ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
  ! normalisation
  fact = bmaj*bmin*pi/(4.0*log(2.0))/abs(xinc*yinc)/(nx*ny)
  call mulgau(ft,nx,ny,bmaj,bmin,pa,fact,xinc,yinc)
  call fourt (ft,dim,ndim,1,1,work)
  ! Add Residual and Clean image
  clean = clean + real(ft)
end subroutine mx_make_clean
!
subroutine mx_loadxy (x,y,mapux,nx,mapvy,ny,mcol)
  use gkernel_interfaces, only : gdf_uv_frequency
  use gildas_def
  use image_def
  type(gildas) :: x,y               !
  integer :: nx                     !
  real :: mapux(nx)                 !
  integer :: ny                     !
  real :: mapvy(ny)                 !
  integer :: mcol(2)                !
  !
  ! Local
  integer :: i
  real(8) :: pidsur                  ! 2*pi*D/Lambda
  real(8) :: freq, dcol
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  dcol = (mcol(1)+mcol(2))*0.5d0
  freq = gdf_uv_frequency(x,dcol)
  pidsur = f_to_k * freq
  !
  do i=1,nx
    mapux(i) = pidsur*((i-y%gil%ref(1))*y%gil%inc(1)+y%gil%val(1))
  enddo
  do i=1,ny
    mapvy(i) = pidsur*((i-y%gil%ref(2))*y%gil%inc(2)+y%gil%val(2))
  enddo
end subroutine mx_loadxy

*DECK DMACON
      SUBROUTINE DMACON
C***BEGIN PROLOGUE  DMACON
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (MACON-S, DMACON-D)
C***AUTHOR  (UNKNOWN)
C***SEE ALSO  DBVSUP
C***ROUTINES CALLED  D1MACH
C***COMMON BLOCKS    DML5MC
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DMACON
      DOUBLE PRECISION D1MACH
      INTEGER KE, LPAR
      DOUBLE PRECISION DD, EPS, FOURU, SQOVFL, SRU, TWOU, URO
      COMMON /DML5MC/ URO,SRU,EPS,SQOVFL,TWOU,FOURU,LPAR
C***FIRST EXECUTABLE STATEMENT  DMACON
      URO = D1MACH(4)
      SRU = SQRT(URO)
      DD = -LOG10(URO)
      LPAR = 0.5D0*DD
      KE = 0.5D0 + 0.75D0*DD
      EPS = 10.0D0**(-2*KE)
      SQOVFL = SQRT(D1MACH(2))
      TWOU = 2.0D0*URO
      FOURU = 4.0D0*URO
      RETURN
      END
*DECK DMGSBV
      SUBROUTINE DMGSBV (M, N, A, IA, NIV, IFLAG, S, P, IP, INHOMO, V,
     +   W, WCND)
C***BEGIN PROLOGUE  DMGSBV
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (MGSBV-S, DMGSBV-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C **********************************************************************
C Orthogonalize a set of N double precision vectors and determine their
C rank.
C
C **********************************************************************
C INPUT
C **********************************************************************
C   M = dimension of vectors.
C   N = no. of vectors.
C   A = array whose first N cols contain the vectors.
C   IA = first dimension of array A (col length).
C   NIV = number of independent vectors needed.
C   INHOMO = 1 corresponds to having a non-zero particular solution.
C   V = particular solution vector (not included in the pivoting).
C   INDPVT = 1 means pivoting will not be used.
C
C **********************************************************************
C OUTPUT
C **********************************************************************
C   NIV = no. of linear independent vectors in input set.
C     A = matrix whose first NIV cols. contain NIV orthogonal vectors
C         which span the vector space determined by the input vectors.
C   IFLAG
C          = 0 success
C          = 1 incorrect input
C          = 2 rank of new vectors less than N
C   P = decomposition matrix.  P is upper triangular and
C             (old vectors) = (new vectors) * P.
C         The old vectors will be reordered due to pivoting.
C         The dimension of P must be .GE. N*(N+1)/2.
C             (  N*(2*N+1) when N .NE. NFCC )
C   IP = pivoting vector. The dimension of IP must be .GE. N.
C             (  2*N when N .NE. NFCC )
C   S = square of norms of incoming vectors.
C   V = vector which is orthogonal to the vectors of A.
C   W = orthogonalization information for the vector V.
C   WCND = worst case (smallest) norm decrement value of the
C          vectors being orthogonalized  (represents a test
C          for linear dependence of the vectors).
C **********************************************************************
C
C***SEE ALSO  DBVSUP
C***ROUTINES CALLED  DDOT, DPRVEC
C***COMMON BLOCKS    DML18J, DML5MC
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   890921  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DMGSBV
C
      DOUBLE PRECISION DDOT, DPRVEC
      INTEGER I, IA, ICOCO, IFLAG, INDPVT, INHOMO, INTEG, IP(*), IP1,
     1     IX, IZ, J, JK, JP, JQ, JY, JZ, K, KD, KJ, KP, L, LIX, LPAR,
     2     LR, M, M2, MXNON, N, NDISK, NEQ, NEQIVP, NFCC, NIC, NIV,
     3     NIVN, NMNR, NN, NOPG, NP1, NPS, NR, NRM1, NTAPE, NTP,
     4     NUMORT, NXPTS
      DOUBLE PRECISION A(IA,*), AE, DOT, EPS, FOURU, P(*), PJP, PSAVE,
     1     RE, RY, S(*), SQOVFL, SRU, SV, T, TOL, TWOU, URO, V(*), VL,
     2     VNORM, W(*), WCND, Y
C
C
      COMMON /DML18J/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,NFCC,
     2                ICOCO
C
      COMMON /DML5MC/ URO,SRU,EPS,SQOVFL,TWOU,FOURU,LPAR
C
C***FIRST EXECUTABLE STATEMENT  DMGSBV
      IF (M .GT. 0 .AND. N .GT. 0 .AND. IA .GE. M) GO TO 10
         IFLAG = 1
      GO TO 280
   10 CONTINUE
C        BEGIN BLOCK PERMITTING ...EXITS TO 270
C           BEGIN BLOCK PERMITTING ...EXITS TO 260
C
               JP = 0
               IFLAG = 0
               NP1 = N + 1
               Y = 0.0D0
               M2 = M/2
C
C              CALCULATE SQUARE OF NORMS OF INCOMING VECTORS AND SEARCH
C              FOR VECTOR WITH LARGEST MAGNITUDE
C
               J = 0
               DO 40 I = 1, N
                  VL = DDOT(M,A(1,I),1,A(1,I),1)
                  S(I) = VL
                  IF (N .EQ. NFCC) GO TO 20
                     J = 2*I - 1
                     P(J) = VL
                     IP(J) = J
   20             CONTINUE
                  J = J + 1
                  P(J) = VL
                  IP(J) = J
                  IF (VL .LE. Y) GO TO 30
                     Y = VL
                     IX = I
   30             CONTINUE
   40          CONTINUE
               IF (INDPVT .NE. 1) GO TO 50
                  IX = 1
                  Y = P(1)
   50          CONTINUE
               LIX = IX
               IF (N .NE. NFCC) LIX = 2*IX - 1
               P(LIX) = P(1)
               S(NP1) = 0.0D0
               IF (INHOMO .EQ. 1) S(NP1) = DDOT(M,V,1,V,1)
               WCND = 1.0D0
               NIVN = NIV
               NIV = 0
C
C           ...EXIT
               IF (Y .EQ. 0.0D0) GO TO 260
C              *********************************************************
               DO 240 NR = 1, N
C                 BEGIN BLOCK PERMITTING ...EXITS TO 230
C              ......EXIT
                     IF (NIVN .EQ. NIV) GO TO 250
                     NIV = NR
                     IF (IX .EQ. NR) GO TO 130
C
C                       PIVOTING OF COLUMNS OF P MATRIX
C
                        NN = N
                        LIX = IX
                        LR = NR
                        IF (N .EQ. NFCC) GO TO 60
                           NN = NFCC
                           LIX = 2*IX - 1
                           LR = 2*NR - 1
   60                   CONTINUE
                        IF (NR .EQ. 1) GO TO 80
                           KD = LIX - LR
                           KJ = LR
                           NRM1 = LR - 1
                           DO 70 J = 1, NRM1
                              PSAVE = P(KJ)
                              JK = KJ + KD
                              P(KJ) = P(JK)
                              P(JK) = PSAVE
                              KJ = KJ + NN - J
   70                      CONTINUE
                           JY = JK + NMNR
                           JZ = JY - KD
                           P(JY) = P(JZ)
   80                   CONTINUE
                        IZ = IP(LIX)
                        IP(LIX) = IP(LR)
                        IP(LR) = IZ
                        SV = S(IX)
                        S(IX) = S(NR)
                        S(NR) = SV
                        IF (N .EQ. NFCC) GO TO 110
                           IF (NR .EQ. 1) GO TO 100
                              KJ = LR + 1
                              DO 90 K = 1, NRM1
                                 PSAVE = P(KJ)
                                 JK = KJ + KD
                                 P(KJ) = P(JK)
                                 P(JK) = PSAVE
                                 KJ = KJ + NFCC - K
   90                         CONTINUE
  100                      CONTINUE
                           IZ = IP(LIX+1)
                           IP(LIX+1) = IP(LR+1)
                           IP(LR+1) = IZ
  110                   CONTINUE
C
C                       PIVOTING OF COLUMNS OF VECTORS
C
                        DO 120 L = 1, M
                           T = A(L,IX)
                           A(L,IX) = A(L,NR)
                           A(L,NR) = T
  120                   CONTINUE
  130                CONTINUE
C
C                    CALCULATE P(NR,NR) AS NORM SQUARED OF PIVOTAL
C                    VECTOR
C
                     JP = JP + 1
                     P(JP) = Y
                     RY = 1.0D0/Y
                     NMNR = N - NR
                     IF (N .EQ. NFCC) GO TO 140
                        NMNR = NFCC - (2*NR - 1)
                        JP = JP + 1
                        P(JP) = 0.0D0
                        KP = JP + NMNR
                        P(KP) = Y
  140                CONTINUE
                     IF (NR .EQ. N .OR. NIVN .EQ. NIV) GO TO 200
C
C                       CALCULATE ORTHOGONAL PROJECTION VECTORS AND
C                       SEARCH FOR LARGEST NORM
C
                        Y = 0.0D0
                        IP1 = NR + 1
                        IX = IP1
C                       ************************************************
                        DO 190 J = IP1, N
                           DOT = DDOT(M,A(1,NR),1,A(1,J),1)
                           JP = JP + 1
                           JQ = JP + NMNR
                           IF (N .NE. NFCC) JQ = JQ + NMNR - 1
                           P(JQ) = P(JP) - DOT*(DOT*RY)
                           P(JP) = DOT*RY
                           DO 150 I = 1, M
                              A(I,J) = A(I,J) - P(JP)*A(I,NR)
  150                      CONTINUE
                           IF (N .EQ. NFCC) GO TO 170
                              KP = JP + NMNR
                              JP = JP + 1
                              PJP = RY*DPRVEC(M,A(1,NR),A(1,J))
                              P(JP) = PJP
                              P(KP) = -PJP
                              KP = KP + 1
                              P(KP) = RY*DOT
                              DO 160 K = 1, M2
                                 L = M2 + K
                                 A(K,J) = A(K,J) - PJP*A(L,NR)
                                 A(L,J) = A(L,J) + PJP*A(K,NR)
  160                         CONTINUE
                              P(JQ) = P(JQ) - PJP*(PJP/RY)
  170                      CONTINUE
C
C                          TEST FOR CANCELLATION IN RECURRENCE RELATION
C
                           IF (P(JQ) .LE. S(J)*SRU)
     1                        P(JQ) = DDOT(M,A(1,J),1,A(1,J),1)
                           IF (P(JQ) .LE. Y) GO TO 180
                              Y = P(JQ)
                              IX = J
  180                      CONTINUE
  190                   CONTINUE
                        IF (N .NE. NFCC) JP = KP
C                       ************************************************
                        IF (INDPVT .EQ. 1) IX = IP1
C
C                       RECOMPUTE NORM SQUARED OF PIVOTAL VECTOR WITH
C                       SCALAR PRODUCT
C
                        Y = DDOT(M,A(1,IX),1,A(1,IX),1)
C           ............EXIT
                        IF (Y .LE. EPS*S(IX)) GO TO 260
                        WCND = MIN(WCND,Y/S(IX))
  200                CONTINUE
C
C                    COMPUTE ORTHOGONAL PROJECTION OF PARTICULAR
C                    SOLUTION
C
C                 ...EXIT
                     IF (INHOMO .NE. 1) GO TO 230
                     LR = NR
                     IF (N .NE. NFCC) LR = 2*NR - 1
                     W(LR) = DDOT(M,A(1,NR),1,V,1)*RY
                     DO 210 I = 1, M
                        V(I) = V(I) - W(LR)*A(I,NR)
  210                CONTINUE
C                 ...EXIT
                     IF (N .EQ. NFCC) GO TO 230
                     LR = 2*NR
                     W(LR) = RY*DPRVEC(M,V,A(1,NR))
                     DO 220 K = 1, M2
                        L = M2 + K
                        V(K) = V(K) + W(LR)*A(L,NR)
                        V(L) = V(L) - W(LR)*A(K,NR)
  220                CONTINUE
  230             CONTINUE
  240          CONTINUE
  250          CONTINUE
C              *********************************************************
C
C                  TEST FOR LINEAR DEPENDENCE OF PARTICULAR SOLUTION
C
C        ......EXIT
               IF (INHOMO .NE. 1) GO TO 270
               IF ((N .GT. 1) .AND. (S(NP1) .LT. 1.0)) GO TO 270
               VNORM = DDOT(M,V,1,V,1)
               IF (S(NP1) .NE. 0.0D0) WCND = MIN(WCND,VNORM/S(NP1))
C        ......EXIT
               IF (VNORM .GE. EPS*S(NP1)) GO TO 270
  260       CONTINUE
            IFLAG = 2
            WCND = EPS
  270    CONTINUE
  280 CONTINUE
      RETURN
      END
*DECK DMOUT
      SUBROUTINE DMOUT (M, N, LDA, A, IFMT, IDIGIT)
C***BEGIN PROLOGUE  DMOUT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBOCLS and DFC
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SMOUT-S, DMOUT-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C     DOUBLE PRECISION MATRIX OUTPUT ROUTINE.
C
C  INPUT..
C
C  M,N,LDA,A(*,*) PRINT THE DOUBLE PRECISION ARRAY A(I,J),I = 1,...,M,
C                 J=1,...,N, ON OUTPUT UNIT LOUT=6. LDA IS THE DECLARED
C                 FIRST DIMENSION OF A(*,*) AS SPECIFIED IN THE CALLING
C                 PROGRAM. THE HEADING IN THE FORTRAN FORMAT STATEMENT
C                 IFMT(*), DESCRIBED BELOW, IS PRINTED AS A FIRST STEP.
C                 THE COMPONENTS A(I,J) ARE INDEXED, ON OUTPUT, IN A
C                 PLEASANT FORMAT.
C  IFMT(*)        A FORTRAN FORMAT STATEMENT. THIS IS PRINTED ON
C                 OUTPUT UNIT LOUT=6 WITH THE VARIABLE FORMAT FORTRAN
C                 STATEMENT
C                       WRITE(LOUT,IFMT).
C  IDIGIT         PRINT AT LEAST ABS(IDIGIT) DECIMAL DIGITS PER NUMBER.
C                 THE SUBPROGRAM WILL CHOOSE THAT INTEGER 4,6,14,20 OR
C                 28 WHICH WILL PRINT AT LEAST ABS(IDIGIT) NUMBER OF
C                 PLACES.  IF IDIGIT.LT.0, 72 PRINTING COLUMNS ARE
C                 UTILIZED TO WRITE EACH LINE OF OUTPUT OF THE ARRAY
C                 A(*,*). (THIS CAN BE USED ON MOST TIME-SHARING
C                 TERMINALS).  IF IDIGIT.GE.0, 133 PRINTING COLUMNS ARE
C                 UTILIZED. (THIS CAN BE USED ON MOST LINE PRINTERS).
C
C  EXAMPLE..
C
C  PRINT AN ARRAY CALLED (SIMPLEX TABLEAU   ) OF SIZE 10 BY 20 SHOWING
C  6 DECIMAL DIGITS PER NUMBER. THE USER IS RUNNING ON A TIME-SHARING
C  SYSTEM WITH A 72 COLUMN OUTPUT DEVICE.
C
C     DOUBLE PRECISION TABLEU(20,20)
C     M = 10
C     N = 20
C     LDTABL = 20
C     IDIGIT = -6
C     CALL DMOUT(M,N,LDTABL,TABLEU,21H(16H1SIMPLEX TABLEAU),IDIGIT)
C
C***SEE ALSO  DBOCLS, DFC
C***ROUTINES CALLED  I1MACH
C***REVISION HISTORY  (YYMMDD)
C   821220  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891107  Added comma after 1P edit descriptor in FORMAT
C           statements.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910403  Updated AUTHOR section.  (WRB)
C***END PROLOGUE  DMOUT
      DOUBLE PRECISION A(LDA,*)
      CHARACTER IFMT*(*),ICOL*3
      SAVE ICOL
      DATA ICOL /'COL'/
C***FIRST EXECUTABLE STATEMENT  DMOUT
      LOUT=I1MACH(2)
      WRITE(LOUT,IFMT)
      IF(M.LE.0.OR.N.LE.0.OR.LDA.LE.0) RETURN
      NDIGIT = IDIGIT
      IF(IDIGIT.EQ.0) NDIGIT = 4
      IF(IDIGIT.GE.0) GO TO 80
C
      NDIGIT = -IDIGIT
      IF(NDIGIT.GT.4) GO TO 9
C
      DO 5 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1010) (ICOL,I,I = K1, K2)
      DO 5 I = 1, M
      WRITE(LOUT,1009) I,(A(I,J),J = K1, K2)
   5  CONTINUE
      RETURN
C
   9  CONTINUE
      IF(NDIGIT.GT.6) GO TO 20
C
      DO 10 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1000) (ICOL,I,I = K1, K2)
      DO 10 I = 1, M
      WRITE(LOUT,1004) I,(A(I,J),J = K1, K2)
   10 CONTINUE
      RETURN
C
   20 CONTINUE
      IF(NDIGIT.GT.14) GO TO 40
C
      DO 30 K1=1,N,2
      K2 = MIN(N,K1+1)
      WRITE(LOUT,1001) (ICOL,I,I = K1, K2)
      DO 30 I = 1, M
      WRITE(LOUT,1005) I,(A(I,J),J = K1, K2)
   30 CONTINUE
      RETURN
C
   40 CONTINUE
      IF(NDIGIT.GT.20) GO TO 60
C
      DO 50 K1=1,N,2
      K2=MIN(N,K1+1)
      WRITE(LOUT,1002) (ICOL,I,I = K1, K2)
      DO 50 I = 1, M
      WRITE(LOUT,1006) I,(A(I,J),J = K1, K2)
   50 CONTINUE
      RETURN
C
   60 CONTINUE
      DO 70 K1=1,N
      K2 = K1
      WRITE(LOUT,1003) (ICOL,I,I = K1, K2)
      DO 70 I = 1, M
      WRITE(LOUT,1007) I,(A(I,J),J = K1, K2)
   70 CONTINUE
      RETURN
C
   80 CONTINUE
      IF(NDIGIT.GT.4) GO TO 86
C
      DO 85 K1=1,N,10
      K2 = MIN(N,K1+9)
      WRITE(LOUT,1000) (ICOL,I,I = K1, K2)
      DO 85 I = 1, M
      WRITE(LOUT,1009) I,(A(I,J),J = K1, K2)
   85 CONTINUE
C
86    IF (NDIGIT.GT.6) GO TO 100
C
      DO 90 K1=1,N,8
      K2 = MIN(N,K1+7)
      WRITE(LOUT,1000) (ICOL,I,I = K1, K2)
      DO 90 I = 1, M
      WRITE(LOUT,1004) I,(A(I,J),J = K1, K2)
   90 CONTINUE
      RETURN
C
  100 CONTINUE
      IF(NDIGIT.GT.14) GO TO 120
C
      DO 110 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1001) (ICOL,I,I = K1, K2)
      DO 110 I = 1, M
      WRITE(LOUT,1005) I,(A(I,J),J = K1, K2)
  110 CONTINUE
      RETURN
C
  120 CONTINUE
      IF(NDIGIT.GT.20) GO TO 140
C
      DO 130 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1002) (ICOL,I,I = K1, K2)
      DO 130 I = 1, M
      WRITE(LOUT,1006) I,(A(I,J),J = K1, K2)
  130 CONTINUE
      RETURN
C
  140 CONTINUE
      DO 150 K1=1,N,3
      K2 = MIN(N,K1+2)
      WRITE(LOUT,1003) (ICOL,I,I = K1, K2)
      DO 150 I = 1, M
      WRITE(LOUT,1007) I,(A(I,J),J = K1, K2)
  150 CONTINUE
      RETURN
 1000 FORMAT(10X,8(5X,A,I4,2X))
 1001 FORMAT(10X,5(9X,A,I4,6X))
 1002 FORMAT(10X,4(12X,A,I4,9X))
 1003 FORMAT(10X,3(16X,A,I4,13X))
 1004 FORMAT(1X,'ROW',I4,2X,1P,8D14.5)
 1005 FORMAT(1X,'ROW',I4,2X,1P,5D22.13)
 1006 FORMAT(1X,'ROW',I4,2X,1P,4D28.19)
 1007 FORMAT(1X,'ROW',I4,2X,1P,3D36.27)
 1009 FORMAT(1X,'ROW',I4,2X,1P,10D12.3)
 1010 FORMAT(10X,10(4X,A,I4,1X))
      END
*DECK DMPAR
      SUBROUTINE DMPAR (N, R, LDR, IPVT, DIAG, QTB, DELTA, PAR, X,
     +   SIGMA, WA1, WA2)
C***BEGIN PROLOGUE  DMPAR
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DNLS1 and DNLS1E
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LMPAR-S, DMPAR-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   **** Double Precision version of LMPAR ****
C
C     Given an M by N matrix A, an N by N nonsingular DIAGONAL
C     matrix D, an M-vector B, and a positive number DELTA,
C     the problem is to determine a value for the parameter
C     PAR such that if X solves the system
C
C           A*X = B ,     SQRT(PAR)*D*X = 0 ,
C
C     in the least squares sense, and DXNORM is the Euclidean
C     norm of D*X, then either PAR is zero and
C
C           (DXNORM-DELTA) .LE. 0.1*DELTA ,
C
C     or PAR is positive and
C
C           ABS(DXNORM-DELTA) .LE. 0.1*DELTA .
C
C     This subroutine completes the solution of the problem
C     if it is provided with the necessary information from the
C     QR factorization, with column pivoting, of A. That is, if
C     A*P = Q*R, where P is a permutation matrix, Q has orthogonal
C     columns, and R is an upper triangular matrix with diagonal
C     elements of nonincreasing magnitude, then DMPAR expects
C     the full upper triangle of R, the permutation matrix P,
C     and the first N components of (Q TRANSPOSE)*B. On output
C     DMPAR also provides an upper triangular matrix S such that
C
C            T   T                   T
C           P *(A *A + PAR*D*D)*P = S *S .
C
C     S is employed within DMPAR and may be of separate interest.
C
C     Only a few iterations are generally needed for convergence
C     of the algorithm. If, however, the limit of 10 iterations
C     is reached, then the output PAR will contain the best
C     value obtained so far.
C
C     The subroutine statement is
C
C       SUBROUTINE DMPAR(N,R,LDR,IPVT,DIAG,QTB,DELTA,PAR,X,SIGMA,
C                        WA1,WA2)
C
C     where
C
C       N is a positive integer input variable set to the order of R.
C
C       R is an N by N array. On input the full upper triangle
C         must contain the full upper triangle of the matrix R.
C         On output the full upper triangle is unaltered, and the
C         strict lower triangle contains the strict upper triangle
C         (transposed) of the upper triangular matrix S.
C
C       LDR is a positive integer input variable not less than N
C         which specifies the leading dimension of the array R.
C
C       IPVT is an integer input array of length N which defines the
C         permutation matrix P such that A*P = Q*R. Column J of P
C         is column IPVT(J) of the identity matrix.
C
C       DIAG is an input array of length N which must contain the
C         diagonal elements of the matrix D.
C
C       QTB is an input array of length N which must contain the first
C         N elements of the vector (Q TRANSPOSE)*B.
C
C       DELTA is a positive input variable which specifies an upper
C         bound on the Euclidean norm of D*X.
C
C       PAR is a nonnegative variable. On input PAR contains an
C         initial estimate of the Levenberg-Marquardt parameter.
C         On output PAR contains the final estimate.
C
C       X is an output array of length N which contains the least
C         squares solution of the system A*X = B, SQRT(PAR)*D*X = 0,
C         for the output PAR.
C
C       SIGMA is an output array of length N which contains the
C         diagonal elements of the upper triangular matrix S.
C
C       WA1 and WA2 are work arrays of length N.
C
C***SEE ALSO  DNLS1, DNLS1E
C***ROUTINES CALLED  D1MACH, DENORM, DQRSLV
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DMPAR
      INTEGER N,LDR
      INTEGER IPVT(*)
      DOUBLE PRECISION DELTA,PAR
      DOUBLE PRECISION R(LDR,*),DIAG(*),QTB(*),X(*),SIGMA(*),WA1(*),
     1 WA2(*)
      INTEGER I,ITER,J,JM1,JP1,K,L,NSING
      DOUBLE PRECISION DXNORM,DWARF,FP,GNORM,PARC,PARL,PARU,P1,P001,
     1 SUM,TEMP,ZERO
      DOUBLE PRECISION D1MACH,DENORM
      SAVE P1, P001, ZERO
      DATA P1,P001,ZERO /1.0D-1,1.0D-3,0.0D0/
C***FIRST EXECUTABLE STATEMENT  DMPAR
      DWARF = D1MACH(1)
C
C     COMPUTE AND STORE IN X THE GAUSS-NEWTON DIRECTION. IF THE
C     JACOBIAN IS RANK-DEFICIENT, OBTAIN A LEAST SQUARES SOLUTION.
C
      NSING = N
      DO 10 J = 1, N
         WA1(J) = QTB(J)
         IF (R(J,J) .EQ. ZERO .AND. NSING .EQ. N) NSING = J - 1
         IF (NSING .LT. N) WA1(J) = ZERO
   10    CONTINUE
      IF (NSING .LT. 1) GO TO 50
      DO 40 K = 1, NSING
         J = NSING - K + 1
         WA1(J) = WA1(J)/R(J,J)
         TEMP = WA1(J)
         JM1 = J - 1
         IF (JM1 .LT. 1) GO TO 30
         DO 20 I = 1, JM1
            WA1(I) = WA1(I) - R(I,J)*TEMP
   20       CONTINUE
   30    CONTINUE
   40    CONTINUE
   50 CONTINUE
      DO 60 J = 1, N
         L = IPVT(J)
         X(L) = WA1(J)
   60    CONTINUE
C
C     INITIALIZE THE ITERATION COUNTER.
C     EVALUATE THE FUNCTION AT THE ORIGIN, AND TEST
C     FOR ACCEPTANCE OF THE GAUSS-NEWTON DIRECTION.
C
      ITER = 0
      DO 70 J = 1, N
         WA2(J) = DIAG(J)*X(J)
   70    CONTINUE
      DXNORM = DENORM(N,WA2)
      FP = DXNORM - DELTA
      IF (FP .LE. P1*DELTA) GO TO 220
C
C     IF THE JACOBIAN IS NOT RANK DEFICIENT, THE NEWTON
C     STEP PROVIDES A LOWER BOUND, PARL, FOR THE ZERO OF
C     THE FUNCTION. OTHERWISE SET THIS BOUND TO ZERO.
C
      PARL = ZERO
      IF (NSING .LT. N) GO TO 120
      DO 80 J = 1, N
         L = IPVT(J)
         WA1(J) = DIAG(L)*(WA2(L)/DXNORM)
   80    CONTINUE
      DO 110 J = 1, N
         SUM = ZERO
         JM1 = J - 1
         IF (JM1 .LT. 1) GO TO 100
         DO 90 I = 1, JM1
            SUM = SUM + R(I,J)*WA1(I)
   90       CONTINUE
  100    CONTINUE
         WA1(J) = (WA1(J) - SUM)/R(J,J)
  110    CONTINUE
      TEMP = DENORM(N,WA1)
      PARL = ((FP/DELTA)/TEMP)/TEMP
  120 CONTINUE
C
C     CALCULATE AN UPPER BOUND, PARU, FOR THE ZERO OF THE FUNCTION.
C
      DO 140 J = 1, N
         SUM = ZERO
         DO 130 I = 1, J
            SUM = SUM + R(I,J)*QTB(I)
  130       CONTINUE
         L = IPVT(J)
         WA1(J) = SUM/DIAG(L)
  140    CONTINUE
      GNORM = DENORM(N,WA1)
      PARU = GNORM/DELTA
      IF (PARU .EQ. ZERO) PARU = DWARF/MIN(DELTA,P1)
C
C     IF THE INPUT PAR LIES OUTSIDE OF THE INTERVAL (PARL,PARU),
C     SET PAR TO THE CLOSER ENDPOINT.
C
      PAR = MAX(PAR,PARL)
      PAR = MIN(PAR,PARU)
      IF (PAR .EQ. ZERO) PAR = GNORM/DXNORM
C
C     BEGINNING OF AN ITERATION.
C
  150 CONTINUE
         ITER = ITER + 1
C
C        EVALUATE THE FUNCTION AT THE CURRENT VALUE OF PAR.
C
         IF (PAR .EQ. ZERO) PAR = MAX(DWARF,P001*PARU)
         TEMP = SQRT(PAR)
         DO 160 J = 1, N
            WA1(J) = TEMP*DIAG(J)
  160       CONTINUE
         CALL DQRSLV(N,R,LDR,IPVT,WA1,QTB,X,SIGMA,WA2)
         DO 170 J = 1, N
            WA2(J) = DIAG(J)*X(J)
  170       CONTINUE
         DXNORM = DENORM(N,WA2)
         TEMP = FP
         FP = DXNORM - DELTA
C
C        IF THE FUNCTION IS SMALL ENOUGH, ACCEPT THE CURRENT VALUE
C        OF PAR. ALSO TEST FOR THE EXCEPTIONAL CASES WHERE PARL
C        IS ZERO OR THE NUMBER OF ITERATIONS HAS REACHED 10.
C
         IF (ABS(FP) .LE. P1*DELTA
     1       .OR. PARL .EQ. ZERO .AND. FP .LE. TEMP
     2            .AND. TEMP .LT. ZERO .OR. ITER .EQ. 10) GO TO 220
C
C        COMPUTE THE NEWTON CORRECTION.
C
         DO 180 J = 1, N
            L = IPVT(J)
            WA1(J) = DIAG(L)*(WA2(L)/DXNORM)
  180       CONTINUE
         DO 210 J = 1, N
            WA1(J) = WA1(J)/SIGMA(J)
            TEMP = WA1(J)
            JP1 = J + 1
            IF (N .LT. JP1) GO TO 200
            DO 190 I = JP1, N
               WA1(I) = WA1(I) - R(I,J)*TEMP
  190          CONTINUE
  200       CONTINUE
  210       CONTINUE
         TEMP = DENORM(N,WA1)
         PARC = ((FP/DELTA)/TEMP)/TEMP
C
C        DEPENDING ON THE SIGN OF THE FUNCTION, UPDATE PARL OR PARU.
C
         IF (FP .GT. ZERO) PARL = MAX(PARL,PAR)
         IF (FP .LT. ZERO) PARU = MIN(PARU,PAR)
C
C        COMPUTE AN IMPROVED ESTIMATE FOR PAR.
C
         PAR = MAX(PARL,PAR+PARC)
C
C        END OF AN ITERATION.
C
         GO TO 150
  220 CONTINUE
C
C     TERMINATION.
C
      IF (ITER .EQ. 0) PAR = ZERO
      RETURN
C
C     LAST CARD OF SUBROUTINE DMPAR.
C
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This module is obsolescent. Please adapt your codes to use the more
! standard stack_spectra_tool module.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_stack_spectral
  use cubetools_parameters
  use cube_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_windowing
  use cubemain_spaelli_types
  use cubetopology_spapos_types
  !
  public :: stack_spectral_prog_t
  public :: cubemain_stack_spectral_domean
  public :: cubemain_stack_spectral_noaperture
  private
  !
  type stack_spectral_prog_t
     type(window_array_t), pointer :: wind             ! Window to be spectrally stacked
     type(cube_t), pointer         :: cube             ! Input cube
     type(cube_prod_t)             :: stackprod        ! Output (stacked) spectrum description
     type(cube_t), pointer         :: stacked          ! Output (stacked) spectrum
     type(cube_t), pointer         :: mask             ! Mask
     type(cube_t), pointer         :: noise            ! Noise reference
     real(kind=sign_k)             :: factor           ! brightness conversion factor
     logical                       :: mask2d = .false. ! Is the mask 2d?
     logical                       :: domean = .false. ! Output is a mean spectrum
     logical                       :: domask           ! Use a mask
     logical                       :: donoise          ! Use weighting by noise
     logical                       :: contaminate      ! NaNs contaminate spectrum
     logical, allocatable          :: include(:)       ! Channel is going to be included?
     !
     ! Deferred procedures
     procedure(stack_interface_header), pointer :: header => null()
     procedure(stack_interface_loop),   pointer :: loop   => null()
   contains
     procedure :: init            => cubemain_stack_spectral_init
     procedure :: allocate        => cubemain_stack_spectral_allocate
     procedure :: header_setscale => cubemain_stack_spectral_header_set_scale
     !
     procedure :: data            => cubemain_stack_spectral_data
     procedure :: get             => cubemain_stack_spectral_get_weight_image
     procedure :: act_nomask      => cubemain_stack_spectral_act_nomask
     procedure :: act_mask        => cubemain_stack_spectral_act_mask
  end type stack_spectral_prog_t
  !
contains
  !
  !----------Interfaces--------------------------------------------------
  !
  subroutine stack_interface_header(prog,error)
    !----------------------------------------------------------------------
    ! Interface for deferred procedures
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
  end subroutine stack_interface_header
  !
  subroutine stack_interface_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! Interface for deferred procedures
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),     intent(inout) :: iter
    logical,                      intent(inout) :: error
  end subroutine stack_interface_loop
  !
  !----------Common-utility----------------------------------------------
  !
  subroutine cubemain_stack_spectral_domean(cube,domean,error)
    use cubetools_header_methods
    use cubetools_brightness
    !----------------------------------------------------------------------
    ! If User has not chosen a mean or a sum decide based on cube unit
    !----------------------------------------------------------------------
    type(cube_t), intent(in)    :: cube
    logical,      intent(out)   :: domean
    logical,      intent(inout) :: error
    !
    logical :: valid
    character(len=unit_l) :: unitin
    integer(kind=code_k) :: codein
    character(len=*), parameter :: rname='STACK>SPECTRAL>DOMEAN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_array_unit(cube%head,unitin,error)
    if (error) return
    call cubetools_brightness_valid_brightness_unit(unitin,codein,valid,error)
    if (error) return
    if (valid) then
       select case(codein)
       case (code_unit_jyperbeam,code_unit_jyperpixel,code_unit_mjypersr)
          domean = .false.
       case (code_unit_tmb)
          domean = .true.
       case (code_unit_tas)
          call cubemain_message(seve%e,rname,'Convert it with CUBE\CONVERT first')
          error = .true.
          return
       case default
          call cubemain_message(seve%e,rname,'Unknown brightness unit '//trim(unitin))
          error = .true.
          return
       end select
    else
       call cubemain_message(seve%w,rname,'Default to averaging for unit '//trim(unitin))
       domean = .true.
    endif
  end subroutine cubemain_stack_spectral_domean
  !
  !----------Entry-points------------------------------------------------
  !
  subroutine cubemain_stack_spectral_noaperture(domean,window,cube,domask,&
       mask,donoise,noise,stackprod,stacked,error)
    !----------------------------------------------------------------------
    ! Does a stack without aperture
    !----------------------------------------------------------------------
    logical,               intent(in)    :: domean
    type(window_array_t),  intent(in)    :: window
    type(cube_t), pointer, intent(inout) :: cube
    logical,               intent(in)    :: domask
    type(cube_t), pointer, intent(inout) :: mask
    logical,               intent(in)    :: donoise
    type(cube_t), pointer, intent(inout) :: noise
    type(cube_prod_t),     intent(in)    :: stackprod
    type(cube_t), pointer, intent(inout) :: stacked
    logical,               intent(inout) :: error
    !
    type(stack_spectral_prog_t) :: prog
    character(len=*), parameter :: rname='STACK>SPECTRAL>NOAPERTURE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%init(domean,window,cube,domask,mask,donoise,noise,stackprod,stacked,error)
    if (error) return
    call prog%header(error)
    if (error) return
    call prog%data(error)
    if (error) return
  end subroutine cubemain_stack_spectral_noaperture
  !
  !----------Common-code-base--------------------------------------------
  !
  subroutine cubemain_stack_spectral_allocate(prog,error)
    use gkernel_interfaces
    use cubetools_shape_types
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! allocates stack_spectral_prog_t
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
    !
    type(shape_t) :: n
    integer(kind=4) :: ier,iw
    character(len=*), parameter :: rname='STACK>SPECTRAL>ALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_array_shape(prog%cube%head,n,error)
    if (error) return
    allocate(prog%include(n%c),stat=ier)
    if (failed_allocate(rname,'Channels to be included',ier,error)) return
    prog%include(:) = .false.
    do iw=1,prog%wind%n
       prog%include(prog%wind%val(iw)%o(1):prog%wind%val(iw)%o(2)) = .true.
    enddo ! iw
  end subroutine cubemain_stack_spectral_allocate
  !
  subroutine cubemain_stack_spectral_header_set_scale(prog,error)
    use cubetools_header_methods
    use cubetools_brightness
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
    !
    logical :: valid
    integer(kind=code_k) :: incode
    character(len=unit_l) :: inunit,ouunit
    real(kind=sign_k), parameter :: feff=1.0
    real(kind=sign_k), parameter :: beff=1.0
    character(len=*), parameter :: rname='STACK>SPECTRAL>HEADER>SET>SCALE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_array_unit(prog%cube%head,inunit,error)
    if (error) return
    call cubetools_brightness_valid_brightness_unit(inunit,incode,valid,error)
    if (error) return
    if (valid) then
       if (prog%domean) then
          call cubetools_header_brightness2brightness(prog%cube%head,&
               .not.applyeff,feff,beff,code_unit_tmb,prog%factor,error)
          if (error) return
          ouunit = brightness_get(code_unit_tmb)
       else
          call cubetools_header_brightness2flux(prog%cube%head,code_unit_jy,prog%factor,error)
          if (error) return
          ouunit = flux_get(code_unit_jy)
       endif
    else
       prog%factor = 1
       ouunit = inunit
    endif
    call cubetools_header_put_array_unit(ouunit,prog%stacked%head,error)
    if (error) return
  end subroutine cubemain_stack_spectral_header_set_scale
  !
  subroutine cubemain_stack_spectral_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='STACK>SPECTRAL>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          call prog%loop(iter,error)
       endif
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_stack_spectral_data
  !
  subroutine cubemain_stack_spectral_get_weight_image(prog,iter,weight,error)
    use cubeadm_image_types
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(in)    :: prog
    type(cubeadm_iterator_t),     intent(in)    :: iter
    type(image_t),                intent(out)   :: weight
    logical,                      intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: one = 1
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='STACK>SPECTRAL>GET>WEIGHT>IMAGE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%donoise) then
       call weight%associate('weight',prog%noise,iter,error)
       if (error) return
       call weight%get(one,error)
       if (error) return
       do iy=1,weight%ny
          do ix=1,weight%nx
             weight%val(ix,iy) = 1/weight%val(ix,iy)**2
          enddo ! ix
       enddo ! iy
    else
       call weight%allocate('weight',prog%cube,iter,error)
       if (error) return
       do iy=1,weight%ny
          do ix=1,weight%nx
             weight%val(ix,iy) = 1
          enddo ! ix
       enddo ! iy
    endif
  end subroutine cubemain_stack_spectral_get_weight_image
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_stack_spectral_init(prog,domean,wind,cube,domask,&
       mask,donoise,noise,stackprod,stacked,error)
    use cubetools_shape_types
    use cubetools_header_methods
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Initializes stack_spectral_prog_t
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t),  intent(out)   :: prog
    logical,                       intent(in)    :: domean
    type(window_array_t), target,  intent(in)    :: wind
    type(cube_t),         pointer, intent(in)    :: cube
    logical,                       intent(in)    :: domask
    type(cube_t),         pointer, intent(in)    :: mask
    logical,                       intent(in)    :: donoise
    type(cube_t),         pointer, intent(in)    :: noise
    type(cube_prod_t),             intent(in)    :: stackprod
    type(cube_t),         pointer, intent(in)    :: stacked
    logical,                       intent(inout) :: error
    !
    type(shape_t) :: n
    character(len=*), parameter :: rname='STACK>SPECTRAL>INIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    prog%domean = domean
    prog%wind => wind
    prog%cube => cube
    prog%domask = domask
    prog%mask => mask
    prog%donoise = donoise
    prog%noise => noise
    prog%stacked => stacked
    !
    prog%contaminate = .false.
    !
    ! Do not replace the flag in-place, do it in a copy
    call stackprod%copy(prog%stackprod,error)
    if (error)  return
    call prog%stackprod%flag_to_flag(flag_image_or_spectrum,flag_spectrum,error)
    if (error)  return
    !
    call prog%allocate(error)
    if (error) return
    !
    prog%header => cubemain_stack_spectral_header
    if (prog%domask) then
       call cubetools_header_get_array_shape(prog%mask%head,n,error)
       if (error) return
       prog%mask2d = n%c.eq.1
       prog%loop => cubemain_stack_spectral_loop_mask
    else       
       prog%loop => cubemain_stack_spectral_loop_nomask
    endif
  end subroutine cubemain_stack_spectral_init
  !
  subroutine cubemain_stack_spectral_header(prog,error)
    use phys_const
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetools_beam_types
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    logical,                      intent(inout) :: error
    !
    real(kind=coor_k) :: size(2)
    type(axis_t) :: axis
    type(beam_t) :: beam
    !
    character(len=*), parameter :: rname='STACK>SPECTRAL>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(prog%stackprod,prog%cube,prog%stacked,error)
    if (error) return
    !
    call prog%header_setscale(error)
    if (error) return
    !
    ! l axis
    call cubetools_header_get_axis_head_l(prog%stacked%head,axis,error)
    if (error) return
    ! *** JP The following code is only a first approximation. We want:
    ! *** JP 1. to set the position to the average of the unprojected sky position
    ! *** JP    inside the mask. For the moment, take the projection center.
    ! *** JP 2. to set the increment to the rms of the unprojected sky distance from
    ! *** JP    the averaged position. For the moment, take the size of the image.
    size(1) = abs(axis%inc*axis%n)
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = size(1)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_l(axis,prog%stacked%head,error)
    if (error) return
    !
    ! m axis
    call cubetools_header_get_axis_head_m(prog%stacked%head,axis,error)
    if (error) return
    ! *** JP The following code is only a first approximation. We want:
    ! *** JP 1. to set the position to the average of the unprojected sky position
    ! *** JP    inside the mask. For the moment, take the projection center.
    ! *** JP 2. to set the increment to the rms of the unprojected sky distance from
    ! *** JP    the averaged position. For the moment, take the size of the image.
    size(2) = abs(axis%inc*axis%n)
    axis%ref = 0.0
    axis%val = 0.0
    axis%inc = size(2)
    axis%n = 1_pixe_k
    call cubetools_header_update_axset_m(axis,prog%stacked%head,error)
    if (error) return
    !
    ! Beam
    call cubetools_header_get_spabeam(prog%stacked%head,beam,error)
    if (error) return
    beam%major = max(size(1),size(2))
    beam%minor = min(size(1),size(2))
    ! *** JP Unclear whether this is the correct angle convention
    if (size(1).ge.size(2)) then
       beam%pang = 0.0
    else
       beam%pang = pi/2
    endif
    call cubetools_header_update_spabeam(beam,prog%stacked%head,error)
    if (error) return
  end subroutine cubemain_stack_spectral_header
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_stack_spectral_loop_nomask(prog,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),     intent(inout) :: iter
    logical,                      intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: one = 1
    type(image_t) :: image,stacked,weight
    character(len=*), parameter :: rname='STACK>SPECTRAL>LOOP>NOMASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call prog%get(iter,weight,error)
    if (error) return
    call stacked%allocate('stacked',prog%stacked,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       if (prog%include(iter%ie)) then
          call image%get(iter%ie,error)
          if (error) return
          call prog%act_nomask(image,weight,stacked,error)
          if (error) return
       else
          stacked%val(one,one) = gr4nan
       endif
       call stacked%put(iter%ie,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_stack_spectral_loop_nomask
  ! 
  subroutine cubemain_stack_spectral_act_nomask(prog,image,weight,stacked,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(in)    :: prog
    type(image_t),                intent(in)    :: image
    type(image_t),                intent(in)    :: weight
    type(image_t),                intent(inout) :: stacked
    logical,                      intent(inout) :: error
    !
    integer(kind=pixe_k), parameter :: one = 1
    integer(kind=pixe_k) :: ix,iy
    real(kind=sign_k) :: val,wei
    character(len=*), parameter :: rname='STACK>SPECTRAL>ACT>NOMASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    val = 0
    wei = 0
    if (prog%contaminate) then
       do iy=1,image%ny
          do ix=1,image%nx
             val = val + image%val(ix,iy)*weight%val(ix,iy)
             wei = wei + weight%val(ix,iy)
          enddo ! ix
       enddo ! iy
    else
       do iy=1,image%ny
          do ix=1,image%nx
             if (.not.ieee_is_nan(image%val(ix,iy)).and..not.ieee_is_nan(weight%val(ix,iy))) then
                val = val + image%val(ix,iy)*weight%val(ix,iy)
                wei = wei + weight%val(ix,iy)
             endif
          enddo ! ix
       enddo ! iy
    endif
    if (wei.gt.0) then
       stacked%val(one,one) = val/wei*prog%factor
    else
       stacked%val(one,one) = gr4nan
    endif
  end subroutine cubemain_stack_spectral_act_nomask
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_stack_spectral_loop_mask(prog,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),     intent(inout) :: iter
    logical,                      intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: one = 1
    type(image_t) :: image,stacked,weight,mask
    character(len=*), parameter :: rname='STACK>SPECTRAL>LOOP>MASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call mask%associate('mask',prog%mask,iter,error)
    if (error) return
    call prog%get(iter,weight,error)
    if (error) return
    call stacked%allocate('stacked',prog%stacked,iter,error)
    if (error) return
    !
    if (prog%mask2d) then
      call mask%get(one,error)
      if (error) return 
    endif
    do while (iter%iterate_entry(error))
       if (prog%include(iter%ie)) then
          if (.not.prog%mask2d) then
             call mask%get(iter%ie,error)
             if (error) return 
          endif
          call image%get(iter%ie,error)
          if (error) return
          call prog%act_mask(image,weight,mask,stacked,error)
          if (error) return
       else
          stacked%val(one,one) = gr4nan
       endif
       call stacked%put(iter%ie,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_stack_spectral_loop_mask
  !
  subroutine cubemain_stack_spectral_act_mask(prog,image,weight,mask,stacked,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stack_spectral_prog_t), intent(in)    :: prog
    type(image_t),                intent(in)    :: image
    type(image_t),                intent(in)    :: weight
    type(image_t),                intent(in)    :: mask
    type(image_t),                intent(inout) :: stacked
    logical,                      intent(inout) :: error
    !
    integer(kind=pixe_k), parameter :: one = 1
    integer(kind=pixe_k) :: ix,iy
    real(kind=sign_k) :: val,wei
    character(len=*), parameter :: rname='STACK>SPECTRAL>ACT>MASK'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    val = 0
    wei = 0
    if (prog%contaminate) then
       do iy=1,image%ny
          do ix=1,image%nx
             if (ieee_is_nan(mask%val(ix,iy))) cycle
             val = val + image%val(ix,iy)*weight%val(ix,iy)
             wei = wei + weight%val(ix,iy)
          enddo ! ix
       enddo ! iy
    else
       do iy=1,image%ny
          do ix=1,image%nx
             if ((ieee_is_nan(image%val(ix,iy))).or.&
                  (ieee_is_nan(weight%val(ix,iy))).or.&
                  (ieee_is_nan(mask%val(ix,iy)))) cycle
             val = val + image%val(ix,iy)*weight%val(ix,iy)
             wei = wei + weight%val(ix,iy)
          enddo ! ix
       enddo ! iy
    endif
    if (wei.gt.0) then
       stacked%val(one,one) = val/wei*prog%factor
    else
       stacked%val(one,one) = gr4nan
    endif
  end subroutine cubemain_stack_spectral_act_mask
end module cubemain_stack_spectral
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_memory
  use cubetools_parameters
  use cubetools_structure
  use cubedag_messaging
  use cubedag_dag_buffer
  !
  public :: memory
  private
  !
  type :: memory_comm_t
    type(option_t), pointer :: comm
  contains
    procedure, public  :: register => cubedag_memory_register
    procedure, private :: parse    => cubedag_memory_parse
    procedure, private :: main     => cubedag_memory_main
  end type memory_comm_t
  type(memory_comm_t) :: memory
  !
  type memory_user_t
  contains
    procedure, private :: toprog => cubedag_memory_user_toprog
  end type memory_user_t
  !
  type memory_prog_t
  contains
    procedure, public :: act => cubedag_memory_act
  end type memory_prog_t
  !
contains
  !
  subroutine cubedag_memory_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command MEMORY
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(memory_user_t) :: user
    character(len=*), parameter :: rname='MEMORY>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call memory%parse(line,user,error)
    if (error) return
    call memory%main(user,error)
    if (error) return
  end subroutine cubedag_memory_command
  !
  subroutine cubedag_memory_register(memory,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(memory_comm_t), intent(inout) :: memory
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MEMORY','',&
         'Display the current memory and disk footprint',&
         strg_emp,&
         cubedag_memory_command,&
         memory%comm,error)
    if (error) return
  end subroutine cubedag_memory_register
  !
  subroutine cubedag_memory_parse(memory,line,user,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Parsing facility for command MEMORY
    !-------------------------------------------------------------------
    class(memory_comm_t), intent(inout) :: memory
    character(len=*),     intent(in)    :: line
    type(memory_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
  end subroutine cubedag_memory_parse
  !
  subroutine cubedag_memory_main(memory,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(memory_comm_t), intent(in)    :: memory
    type(memory_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(memory_prog_t) :: prog
    character(len=*), parameter :: rname='MEMORY>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubedag_memory_main
  !
  subroutine cubedag_memory_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(memory_user_t), intent(in)    :: user
    type(memory_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>USER2PROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
  end subroutine cubedag_memory_user_toprog
  !
  subroutine cubedag_memory_act(prog,error)
    use cubetools_format
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(memory_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MEMORY>COMMAND'
    !
    call cubedag_message(seve%r,rname,  &
      'DAG size in memory is '//cubetools_format_memsize(cubedag_dag_memsize()))
    call cubedag_message(seve%r,rname,  &
      'DAG size on disk   is '//cubetools_format_memsize(cubedag_dag_disksize()))
  end subroutine cubedag_memory_act
end module cubedag_memory
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_histo3d
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubehistogram_messaging
  use cubehistogram_histoaxis_types
  !
  public :: histo3d
  private
  !
  type histo3d_t
     type(cube_t), pointer :: cube
     type(histoaxis_prog_t) :: x
     type(histoaxis_prog_t) :: y
     type(histoaxis_prog_t) :: z
     type(switch_prog_t) :: blank     ! Blank empty bins?
     type(switch_prog_t) :: normalize ! Normalize histogram?
     integer(kind=data_k):: nin = 0   ! Number of voxels inside the histogram
  end type histo3d_t
  !
  type :: histo3d_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: xcube
     type(cubeid_arg_t), pointer :: ycube
     type(cubeid_arg_t), pointer :: zcube
     type(histoaxis_opt_t)       :: x
     type(histoaxis_opt_t)       :: y
     type(histoaxis_opt_t)       :: z
     type(switch_comm_t)         :: blank
     type(switch_comm_t)         :: normalize
     type(cube_prod_t),  pointer :: oucube
     type(cube_prod_t),  pointer :: pointer
   contains
     procedure, public  :: register => cubehistogram_histo3d_register
     procedure, private :: parse    => cubehistogram_histo3d_parse
     procedure, private :: main     => cubehistogram_histo3d_main
  end type histo3d_comm_t
  type(histo3d_comm_t) :: histo3d
  !
  type histo3d_user_t
     type(cubeid_user_t) :: cubeids
     type(histoaxis_user_t) :: x
     type(histoaxis_user_t) :: y
     type(histoaxis_user_t) :: z
     type(switch_user_t) :: blank
     type(switch_user_t) :: normalize
   contains
     procedure, private :: toprog => cubehistogram_histo3d_user_toprog
  end type histo3d_user_t
  !
  type histo3d_prog_t
     type(cube_t), pointer :: xcube   ! Input  cube used as histo3d x-axis
     type(cube_t), pointer :: ycube   ! Input  cube used as histo3d y-axis
     type(cube_t), pointer :: zcube   ! Input  cube used as histo3d y-axis
     type(cube_t), pointer :: pointer ! Output cube storing the position of the pixel in the 3D histogram
     type(histo3d_t) :: histo3d       ! Output 3D histogram
   contains
     procedure, private :: header   => cubehistogram_histo3d_prog_header
     procedure, private :: data     => cubehistogram_histo3d_prog_data
     procedure, private :: loop     => cubehistogram_histo3d_prog_loop
     procedure, private :: act      => cubehistogram_histo3d_prog_act
     procedure, private :: postloop => cubehistogram_histo3d_prog_postloop
  end type histo3d_prog_t
  !
contains
  !
  subroutine cubehistogram_histo3d_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(histo3d_user_t) :: user
    character(len=*), parameter :: rname='HISTO3D>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call histo3d%parse(line,user,error)
    if (error) return
    call histo3d%main(user,error)
    if (error) return
  end subroutine cubehistogram_histo3d_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_register(histo3d,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='HISTO3D>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'HISTO3D','xcube ycube zcube',&
         'Build a 3D histogram cube from three cubes',&
         'Build a histogram cube from three aligned input cubes. Each&
         & (X,Y) histogram bin stores the distribution of Z values&
         & that fall into that bin, so follow-up commands such as&
         & HISTOGRAM\MEAN can derive summary images from the&
         & histogram cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         'Use XCUBE, YCUBE, and ZCUBE as the X, Y, and Z value axes of&
         & the output histogram cube. The three input cubes must have&
         & the same shape. /XAXIS, /YAXIS, and /ZAXIS define the&
         & binning on each axis through the shared axis helper.'//strg_cr//&
         'The command currently requires three single-channel cubes.&
         & Multi-channel inputs are rejected before runtime.'//strg_cr//&
         'The HISTO3D product stores counts in each histogram cell.&
         & Use /BLANK and /NORMALIZE to control empty-cell handling&
         & and output scaling.'//strg_bl//&
         'Notes:'//strg_cr//&
         'The Pointer product records the histogram location of each&
         & in-range input pixel.'//strg_cr//&
         'That pointer payload is internal command state; current&
         & remap commands do not expose a public 3D pointer&
         & workflow.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'Build the 3D histogram first, then summarize the Z&
         & distribution in each (X,Y) histogram bin.'//strg_cr//&
         'CUBE> HISTOGRAM\HISTO3D xcube ycube zcube'//strg_cr//&
         'CUBE> HISTOGRAM\MEAN histo3d.',&
         cubehistogram_histo3d_command,&
         histo3d%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'XCUBEID',&
         'Identifier for input cube #1 used as X axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%xcube,&
         error)
    if (error) return
    call cubearg%register(&
         'YCUBEID',&
         'Identifier for input cube #2 used as Y axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%ycube,&
         error)
    if (error) return
    call cubearg%register(&
         'ZCUBEID',&
         'Identifier for input cube #3 used as Z axis',&
         strg_emp,&
         code_arg_mandatory,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         histo3d%zcube,&
         error)
    if (error) return
    !
    call histo3d%x%register('X',error)
    if (error) return
    call histo3d%y%register('Y',error)
    if (error) return
    call histo3d%z%register('Z',error)
    if (error) return
    call histo3d%blank%register(&
         'BLANK',&
         'setting empty bins to NaN',&
         'ON',&
         'When ON, histogram cells with zero counts are written as&
         & NaN instead of 0 after the full histogram is built.',&
         error)
    if (error) return
    call histo3d%normalize%register(&
         'NORMALIZE',&
         'histogram normalization from counts to %',&
         'OFF',&
         'When ON, the final 3D histogram cube is scaled so the&
         & included counts sum to 100%.',&
         error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'HISTO3D',&
         'Joint histogram',&
         strg_emp,&
         [flag_histo3d],&
         histo3d%oucube,&
         error,&
         access=code_access_fullset)
    if (error) return
    call oucube%register(&
         'Pointer',&
         'Positions back pointer',&
         strg_emp,&
         [flag_histo3d,flag_pointer],&
         histo3d%pointer,&
         error)
    if (error) return
  end subroutine cubehistogram_histo3d_register
  !
  subroutine cubehistogram_histo3d_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(inout) :: comm
    character(len=*),      intent(in)    :: line
    type(histo3d_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTO3D>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%x%parse(line,user%x,error)
    if (error) return
    call comm%y%parse(line,user%y,error)
    if (error) return
    call comm%z%parse(line,user%z,error)
    if (error) return
    call comm%blank%parse(line,user%blank,error)
    if (error) return
    call comm%normalize%parse(line,user%normalize,error)
    if (error) return
  end subroutine cubehistogram_histo3d_parse
  !
  subroutine cubehistogram_histo3d_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_comm_t), intent(in)    :: comm
    type(histo3d_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(histo3d_prog_t) :: prog
    character(len=*), parameter :: rname='HISTO3D>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_histo3d_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_user_t), intent(in)    :: user
    type(histo3d_comm_t),  intent(in)    :: comm
    type(histo3d_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    logical :: prob
    integer(kind=chan_k) :: nchan
    character(len=*), parameter :: rname='HISTO3D>USER2PROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(histo3d%xcube,user%cubeids,prog%xcube,error)
    if (error) return
    call cubeadm_get_header(histo3d%ycube,user%cubeids,prog%ycube,error)
    if (error) return
    call cubeadm_get_header(histo3d%zcube,user%cubeids,prog%zcube,error)
    if (error) return
    !
    prob = .false.
    call cubetools_consistency_shape(&
         'Input cube #1',prog%xcube%head,&
         'Input cube #2',prog%ycube%head,prob,error)
    if (error) return
    if (cubetools_consistency_failed(rname,prob,error)) return
    call cubetools_consistency_shape(&
         'Input cube #1',prog%xcube%head,&
         'Input cube #3',prog%zcube%head,prob,error)
    if (error) return
    if (cubetools_consistency_failed(rname,prob,error)) return
    call cubetools_header_get_nchan(prog%xcube%head,nchan,error)
    if (error) return
    if (nchan.gt.1) then
       call cubehistogram_message(&
            seve%e,rname,&
            'HISTO3D currently requires single-channel input cubes; '&
            //'multi-channel inputs are not supported')
       error = .true.
       return
    endif
    !
    call user%x%toprog(comm%x,prog%xcube,prog%histo3d%x,error)
    if (error) return
    call user%y%toprog(comm%y,prog%ycube,prog%histo3d%y,error)
    if (error) return
    call user%z%toprog(comm%z,prog%zcube,prog%histo3d%z,error)
    if (error) return
    call prog%histo3d%x%list(error)
    if (error) return
    call prog%histo3d%y%list(error)
    if (error) return
    call prog%histo3d%z%list(error)
    if (error) return
    !
    call prog%histo3d%normalize%init(comm%normalize,error)
    if (error) return
    call user%normalize%toprog(comm%normalize,prog%histo3d%normalize,error)
    if (error) return
    call prog%histo3d%blank%init(comm%blank,error)
    if (error) return
    call user%blank%toprog(comm%blank,prog%histo3d%blank,error)
    if (error) return
  end subroutine cubehistogram_histo3d_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_histo3d_prog_header(prog,comm,error)
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    type(histo3d_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='HISTO3D>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%pointer,prog%xcube,prog%pointer,error)
    if (error) return
    call cubeadm_clone_header(comm%oucube,prog%xcube,prog%histo3d%cube,error)
    if (error) return
    ! Unit
    if (prog%histo3d%normalize%enabled) then
       call cubetools_header_put_array_unit('%',prog%histo3d%cube%head,error)
       if (error) return
    else
       call cubetools_header_put_array_unit('Counts',prog%histo3d%cube%head,error)
       if (error) return
    endif
    ! X axis
    call cubetools_header_get_array_unit(prog%xcube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_l(prog%xcube%head,axis,error)
    if (error) return
    axis%name = 'X'
    if (prog%histo3d%x%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%x%n
    axis%ref = 1.0
    axis%val = prog%histo3d%x%min
    axis%inc = prog%histo3d%x%inc
    call cubetools_header_update_axset_l(axis,prog%histo3d%cube%head,error)
    if (error) return
    ! Y axis
    call cubetools_header_get_array_unit(prog%ycube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_m(prog%ycube%head,axis,error)
    if (error) return
    axis%name = 'Y'
    if (prog%histo3d%y%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%y%n
    axis%ref = 1.0
    axis%val = prog%histo3d%y%min
    axis%inc = prog%histo3d%y%inc
    call cubetools_header_update_axset_m(axis,prog%histo3d%cube%head,error)
    if (error) return
    ! Z axis
    call cubetools_header_get_array_unit(prog%zcube%head,unit,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%zcube%head,axis,error)
    if (error) return
    axis%name = 'Z'
    if (prog%histo3d%z%dolog) then
       ! *** JP huge risk of overflow here...
       ! Try to decrease potential overflow by only adding 'log ' at start.
       axis%unit = 'log '//trim(unit)
    else
       axis%unit = unit
    endif
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%n   = prog%histo3d%z%n
    axis%ref = 1.0
    axis%val = prog%histo3d%z%min
    axis%inc = prog%histo3d%z%inc
    call cubetools_header_update_axset_c(axis,prog%histo3d%cube%head,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_header
  !
  subroutine cubehistogram_histo3d_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Removed parallelization because the histo3d can not be written by
    ! several threads at the same time
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(fullcube_t) :: histo3d
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='HISTO3D>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call histo3d%allocate('histo3d',prog%histo3d%cube,error)
    if (error) return
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,histo3d,error)
    enddo ! iter
    !
    call prog%postloop(histo3d,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_data
  !
  subroutine cubehistogram_histo3d_prog_loop(prog,iter,histo3d,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    type(fullcube_t),         intent(inout) :: histo3d
    logical,                  intent(inout) :: error
    !
    type(image_t) :: xima,yima,zima,pima
    character(len=*), parameter :: rname='HISTO3D>PROG>LOOP'
    !
    ! The allocation of xima, yima, and zima allows me to take the logarithm of the inputs
    call xima%allocate('xima',prog%xcube,iter,error)
    if (error) return
    call yima%allocate('yima',prog%ycube,iter,error)
    if (error) return
    ! *** JP => segfault when zima%allocate is replaced by yima%allocate
    call zima%allocate('zima',prog%zcube,iter,error)
    if (error) return
    call pima%allocate('pointer image',prog%pointer,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,xima,yima,zima,pima,histo3d,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_histo3d_prog_loop
  !
  subroutine cubehistogram_histo3d_prog_act(prog,ie,xima,yima,zima,pima,histo3d,error)
    use cubetools_nan
    use cubeadm_image_types
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t), target, intent(inout) :: xima
    type(image_t), target, intent(inout) :: yima
    type(image_t), target, intent(inout) :: zima
    type(image_t),         intent(inout) :: pima
    type(fullcube_t),      intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy,jz
    integer(kind=data_k) :: nou,nblank
    real(kind=sign_k), pointer :: xval,yval,zval
    character(len=*), parameter :: rname='HISTO3D>ACT'
    !
    ! Get data
    call xima%get(ie,error)
    if (error) return
    call yima%get(ie,error)
    if (error) return
    call zima%get(ie,error)
    if (error) return
    ! Transform it
    if (prog%histo3d%x%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             xval => xima%val(ix,iy)
             xval = log10(xval)
          enddo ! iy
       enddo ! ix
    endif
    if (prog%histo3d%y%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             yval => yima%val(ix,iy)
             yval = log10(yval)
          enddo ! iy
       enddo ! ix
    endif
    if (prog%histo3d%z%dolog) then
       do iy=1,xima%ny
          do ix=1,xima%nx
             zval => zima%val(ix,iy)
             zval = log10(zval)
          enddo ! iy
       enddo ! ix
    endif
    ! Compute histogram
    nou = 0
    nblank = 0
    prog%histo3d%nin = 0
    histo3d%val = 0.0
    pima%val = 0
    do iy=1,xima%ny
       do ix=1,xima%nx
          xval => xima%val(ix,iy)
          yval => yima%val(ix,iy)
          zval => zima%val(ix,iy)
          if ((ieee_is_finite(xval)).and.(ieee_is_finite(yval)).and.(ieee_is_finite(zval))) then
             jx = nint((xval-prog%histo3d%x%min)/prog%histo3d%x%inc)
             jy = nint((yval-prog%histo3d%y%min)/prog%histo3d%y%inc)
             jz = nint((zval-prog%histo3d%z%min)/prog%histo3d%z%inc)
             if ((1.le.jx).and.(jx.le.prog%histo3d%x%n).and.&
                  (1.le.jy).and.(jy.le.prog%histo3d%y%n).and.&
                  (1.le.jz).and.(jz.le.prog%histo3d%z%n)) then
                ! *** JP problem when many points?
                pima%val(ix,iy) = jx+(jy-1)*pima%nx+(jz-1)*pima%nx*pima%ny
                histo3d%val(jx,jy,jz) = histo3d%val(jx,jy,jz)+1.0
                prog%histo3d%nin = prog%histo3d%nin+1
             else
                nou = nou+1
             endif
          else
             nblank = nblank+1
          endif
       enddo ! iy
    enddo ! ix
    ! Put result
    call pima%put(ie,error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_act
  !
  subroutine cubehistogram_histo3d_prog_postloop(prog,histo3d,error)
    use cubetools_nan
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(histo3d_prog_t), intent(inout) :: prog
    type(fullcube_t),      intent(inout) :: histo3d
    logical,               intent(inout) :: error
    !
    integer(kind=data_k) :: ix,iy,iz
    character(len=*), parameter :: rname='HISTO3D>PROG>POSTLOOP'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Blank empty bins when asked
    if (prog%histo3d%blank%enabled) then
       do iz=1,prog%histo3d%z%n
          do iy=1,prog%histo3d%y%n
             do ix=1,prog%histo3d%x%n
                if (histo3d%val(ix,iy,iz).le.0.0) then
                   histo3d%val(ix,iy,iz) = gr4nan
                endif
             enddo ! ix
          enddo ! iy
       enddo ! iz
    endif
    ! Normalize when asked
    if ((prog%histo3d%normalize%enabled).and.(prog%histo3d%nin.gt.0)) then
       do iz=1,prog%histo3d%z%n
          do iy=1,prog%histo3d%y%n
             do ix=1,prog%histo3d%x%n
                histo3d%val(ix,iy,iz) = 100d0*histo3d%val(ix,iy,iz)/real(prog%histo3d%nin,kind=coor_k)
             enddo ! ix
          enddo ! iy
       enddo ! iz
    endif
    ! Put result
    call histo3d%put(error)
    if (error) return
  end subroutine cubehistogram_histo3d_prog_postloop
end module cubehistogram_histo3d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_swap(line,error,user_function)
  use class_interfaces, except_this=>class_swap
  !----------------------------------------------------------------------
  ! @ private
  !  Exchange R and T memories
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  logical,          external      :: user_function
  !
  call swaprt('SWAP',error,user_function)
  !
end subroutine class_swap
!
subroutine swaprt(rname,error,user_function)
  use gbl_message
  use class_dependencies_interfaces
  use class_interfaces, except_this=>swaprt
  use class_rt
  use class_setup
  !----------------------------------------------------------------------
  ! @ private
  !  Exchange R and T memories
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  logical,          intent(inout) :: error
  logical,          external      :: user_function
  ! Local
  type(observation), pointer :: tmp
  logical :: ll,myerror
  !
  ! Use a local 'myerror' because the subroutine can be called in error
  ! recovery mode.
  !
  if (t%head%xnum.eq.0) then
    if (rname.eq.'SWAP') then
      call class_message(seve%e,rname,'No spectrum in T buffer')
      error = .true.
    endif
    return  ! Nothing to swap...
  endif
  !
  tmp => r
  r => t
  t => tmp
  r%is_R = .true.
  t%is_R = .false.
  !
  ll = user_function('SWAP')
  !
  ! Need a complete redefinition of all Sic variables pointing to R
  myerror = .false.
  call sic_delvariable ('R',.false.,myerror)
  myerror = .false.  ! No error if not found
  call las_variables_r(set,r,myerror)
  if (myerror) then
    error = .true.
    return
  endif
  call las_setvar_R_aliases(set,myerror)
  if (myerror) then
    error = .true.
    return  ! Also redefine SET VARIABLE aliases
  endif
  !
  call newdat(set,r,myerror)
  call newdat_assoc(set,r,myerror)
  call newdat_user(set,r,myerror)
  if (myerror)  error = .true.
  !
end subroutine swaprt

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Physical constants
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module phys_const
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(8), parameter :: clight = 299792458.0d0   ! [  m/s] Light velocity
  real(8), parameter :: clight_kms = clight/1d3   ! [ km/s] Frequencies are in MHz in GILDAS
  real(8), parameter :: clight_mhz = clight/1d6   ! [m.MHz] Frequencies are in MHz in GILDAS
  real(8), parameter :: kbolt  = 1.3806504d-23    ! [  J/K] Boltzman 
  real(8), parameter :: hplanck = 6.62606896d-34  ! [ J.s] Planck Constant
  ! PI is defined with more digits than necessary to avoid losing the last
  ! few bits in the decimal to binary conversion
  real(8), parameter :: pi  = 3.14159265358979323846d0
  real(4), parameter :: pis = 3.141592653
  real(8), parameter :: twopi = 2.d0*pi
  real(8), parameter :: rad_per_hang = pi/12d0
  real(8), parameter :: hang_per_rad = 12d0/pi
  real(8), parameter :: rad_per_msec = pi/(180d0*3600d0*1d3)
  real(8), parameter :: msec_per_rad = (180d0*3600d0*1d3)/pi
  real(8), parameter :: rad_per_sec = pi/(180d0*3600d0)
  real(8), parameter :: sec_per_rad = (180d0*3600d0)/pi
  real(8), parameter :: rad_per_min = pi/(180d0*60d0)
  real(8), parameter :: min_per_rad = (180d0*60d0)/pi
  real(8), parameter :: rad_per_deg = pi/(180d0)
  real(8), parameter :: deg_per_rad = (180d0)/pi
  real(8), parameter :: fwhm_per_sdev = 2.3548200450309493d0  ! sqrt(8d0*log(2d0))
  real(8), parameter :: f_to_k = twopi/clight_mhz
  integer(4), parameter :: gagzero_in_mjd = 60549
  real(kind=8), parameter :: mjdzero_in_jd = 2400000.5d0
end module phys_const
!
!!!!!!!!!!!!!!!!!!!!!!!! phys_const.f90 ends here !!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_header_array_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_shape_types
  use cubetools_arrelt_types
  use cubetools_noise_types
  use cubetools_consistency_types
  !
  public :: array_t,array_unit_user_t,array_cons_t
  public :: cubetools_array_init,cubetools_array_put_and_derive
  public :: cubetools_array_final,cubetools_array_get
  public :: cubetools_array_list,cubetools_array_unit_register
  public :: cubetools_array_extrema2userstruct
  public :: cubetools_array_unit_parse, cubetools_array_unit_user2prog
  public :: cubetools_array_unit2uservar
  public :: cubetools_array_sicdef,cubetools_array_copy
  public :: cubetools_array_consistency_init,cubetools_array_consistency_final
  public :: cubetools_array_consistency_check,cubetools_array_consistency_list
  private
  !
  type array_t
     integer(kind=code_k)  :: type = code_null ! Type of data (e.g., REAL*4)
     character(len=unit_l) :: unit = strg_unk  ! Unit
     type(shape_t)         :: n                ! Shape related numbers
     type(arrelt_t)        :: min              ! Minimum value
     type(arrelt_t)        :: max              ! Maximum value
     type(noise_t)         :: noi              ! Noise properties
  contains
     procedure :: datasize => cubetools_array_datasize
  end type array_t
  !
  type array_unit_user_t
     character(len=argu_l) :: name = strg_unk  ! Unit name
     logical               :: do   = .false.   ! Option was present
  end type array_unit_user_t
  !
  type array_extrema_user_t
     character(len=argu_l) :: minval = strg_unk ! [ ] Data min value
     character(len=argu_l) :: minix  = strg_unk ! [ ] Min value X position
     character(len=argu_l) :: miniy  = strg_unk ! [ ] Min value Y position
     character(len=argu_l) :: minic  = strg_unk ! [ ] Min value C position
     character(len=argu_l) :: maxval = strg_unk ! [ ] Data max value
     character(len=argu_l) :: maxix  = strg_unk ! [ ] Max value X position
     character(len=argu_l) :: maxiy  = strg_unk ! [ ] Max value Y position
     character(len=argu_l) :: maxic  = strg_unk ! [ ] Max value C position
     logical               :: do  = .false.  ! Option was present
  end type array_extrema_user_t
  !
  type array_cons_t
     logical                    :: check=.true.  ! Check the section
     logical                    :: prob =.false. ! Is there a problem
     logical                    :: mess =.true.  ! Output message for this section?
     type(consistency_desc_t)   :: unit          ! Unit Consistency
     type(shape_cons_t)         :: n             ! Array shape Consistent
     type(arrelt_cons_t)        :: min           ! Minimum value
     type(arrelt_cons_t)        :: max           ! Maximum value
     type(noise_cons_t)         :: noi           ! Noise properties
  end type array_cons_t
contains
  !
  subroutine cubetools_array_init(array,error)
    !-------------------------------------------------------------------
    ! Initialize
    !-------------------------------------------------------------------
    type(array_t), intent(out)   :: array
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_shape_init(array%n,error)
    if (error) return
    call cubetools_arrelt_init('Min',array%min,error)
    if (error) return
    call cubetools_arrelt_init('Max',array%max,error)
    if (error) return
    call cubetools_noise_init(array%noi,error)
    if (error) return
  end subroutine cubetools_array_init
  !
  subroutine cubetools_array_put_and_derive(type,unit,ndim,dim,nl,nm,nc,&
       minval,minloc,maxval,maxloc,sigma,rms,arr,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=code_k),  intent(in)    :: type
    character(len=unit_l), intent(in)    :: unit
    integer(kind=ndim_k),  intent(in)    :: ndim
    integer(kind=data_k),  intent(in)    :: dim(:)
    integer(kind=data_k),  intent(in)    :: nl,nm,nc
    real(kind=sign_k),     intent(in)    :: minval
    integer(kind=data_k),  intent(in)    :: minloc(:)
    real(kind=sign_k),     intent(in)    :: maxval
    integer(kind=data_k),  intent(in)    :: maxloc(:)
    real(kind=sign_k),     intent(in)    :: sigma
    real(kind=sign_k),     intent(in)    :: rms
    type(array_t),         intent(inout) :: arr
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>PUT>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    arr%type = type
    arr%unit = unit
    call cubetools_shape_get_and_derive(ndim,dim,nl,nm,nc,arr%n,error)
    if (error) return
    call cubetools_arrelt_get_and_derive(minval,minloc,arr%min,error)
    if (error) return
    call cubetools_arrelt_get_and_derive(maxval,maxloc,arr%max,error)
    if (error) return
    call cubetools_noise_get_and_derive(sigma,rms,arr%noi,error)
    if (error) return
  end subroutine cubetools_array_put_and_derive
  !
  subroutine cubetools_array_get(arr,type,unit,ndim,dim,nl,nm,nc,&
       minval,minloc,maxval,maxloc,sigma,rms,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(array_t),         intent(in)    :: arr
    integer(kind=code_k),  intent(out)   :: type
    character(len=unit_l), intent(out)   :: unit
    integer(kind=ndim_k),  intent(out)   :: ndim
    integer(kind=data_k),  intent(out)   :: dim(:)
    integer(kind=data_k),  intent(out)   :: nl,nm,nc
    real(kind=sign_k),     intent(out)   :: minval
    integer(kind=data_k),  intent(out)   :: minloc(:)
    real(kind=sign_k),     intent(out)   :: maxval
    integer(kind=data_k),  intent(out)   :: maxloc(:)
    real(kind=sign_k),     intent(out)   :: sigma
    real(kind=sign_k),     intent(out)   :: rms
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>GET'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    type = arr%type
    unit = arr%unit
    call cubetools_shape_put(arr%n,ndim,dim,nl,nm,nc,error)
    if (error) return
    call cubetools_arrelt_put(arr%min,minval,minloc,error)
    if (error) return
    call cubetools_arrelt_put(arr%max,maxval,maxloc,error)
    if (error) return
    call cubetools_noise_put(arr%noi,sigma,rms,error)
    if (error) return
  end subroutine cubetools_array_get
  !
  subroutine cubetools_array_final(array,error)
    !-------------------------------------------------------------------
    ! Finalize
    !-------------------------------------------------------------------
    type(array_t), intent(inout) :: array
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    array%type = code_null
    array%unit = 'unknown'
    call cubetools_shape_final(array%n,error)
    if (error) return
    call cubetools_arrelt_final(array%min,error)
    if (error) return
    call cubetools_arrelt_final(array%max,error)
    if (error) return
    call cubetools_noise_final(array%noi,error)
    if (error) return
  end subroutine cubetools_array_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_array_datasize(array,datasize,error)
    use gbl_format
    !-------------------------------------------------------------------
    ! Return the data size
    !-------------------------------------------------------------------
    class(array_t),       intent(in)    :: array
    integer(kind=data_k), intent(out)   :: datasize
    logical,              intent(inout) :: error
    !
    integer(kind=code_k) :: itype
    character(len=*), parameter :: rname='ARRAY>DATASIZE'
    !
    ! ZZZ This duplicates code from cubetools_shape_list
    itype = hardware-array%type ! hardware is defined in the gbl_format module
    select case (itype)
    case (1,3,4)
      datasize = 4  ! Bytes per element
    case (2,7,9)
      datasize = 8
    case (5)
      datasize = 2
    case (6)
      datasize = 1
    case (8)
      datasize = 16
    case default
       ! This should not happen
       call cubeheader_message(seve%e,rname,'Unknown data type')
       error = .true.
       return
    end select
    datasize = array%n%dat*datasize
  end subroutine cubetools_array_datasize
  !
  subroutine cubetools_array_list(array,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(array_t), intent(in)    :: array
    logical,       intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='ARRAY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_shape_list(array%type,array%n,error)
    if (error) return
    mess = cubetools_format_stdkey_boldval('Unit',array%unit,22)    
    call cubeheader_message(seve%r,rname,mess)
    call cubetools_arrelt_list(array%min,error)
    if (error) return
    call cubetools_arrelt_list(array%max,error)
    if (error) return
    call cubetools_noise_list(array%noi,error)
    if (error) return
    call cubeheader_message(seve%r,rname,' ')
  end subroutine cubetools_array_list
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_array_unit_register(name,abstract,option,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! Register a /UNIT option under a given name, abstract
    !----------------------------------------------------------------------
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    type(option_t), pointer, intent(out)   :: option
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    !
    character(len=*), parameter :: rname='ARRAY>UNIT>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'name',&
         abstract,&
         'Unit can be set to any 12 character string, but only&
         & recognized units are supported',&
         option,error)
    if (error) return
    call stdarg%register( &
         'name',  &
         'Unit name', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, error)
    if (error) return
  end subroutine cubetools_array_unit_register
  !
  subroutine cubetools_array_unit_parse(line,opt,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! Parse unit name 
    ! /UNIT name
    ! ----------------------------------------------------------------------
    character(len=*),        intent(in)    :: line
    type(option_t),          intent(in)    :: opt
    type(array_unit_user_t), intent(inout) :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>UNIT>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,opt,1,user%name,mandatory,error)
       if (error) return
       if (len_trim(user%name).gt.unit_l) call cubeheader_message(seve%w,rname,&
            'Unit name will be truncated at 12 characters')
    endif
  end subroutine cubetools_array_unit_parse
  !
  subroutine cubetools_array_unit_user2prog(user,prog,error)
    use cubetools_brightness
    use cubetools_unit_setup
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Resolves unit name based on a previous one according to user
    ! inputs
    !--------------------------------------------------------------------
    type(array_unit_user_t), intent(in)    :: user
    character(len=unit_l),   intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    type(unit_user_t) :: unit
    character(len=unit_l) :: newunit
    integer(kind=code_k) :: unitcode
    logical :: valid
    character(len=*), parameter :: rname='ARRAY>UNIT>USER2PROG'
    !
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (user%do) then
       if (trim(user%name).eq.strg_equal.or.trim(user%name).eq.strg_star) then
          continue
       else
          call cubetools_unit_get_code(user%name,unitcode,error)
          if (error) return
          select case (unitcode)
          case (code_unit_unk)
             call cubeheader_message(seve%w,rname,'Unsupported unit '//trim(user%name))
             prog = user%name
          case (code_unit_brig,code_unit_flux)
             call cubetools_brightness_valid_brightness_or_flux_unit(user%name,newunit,valid,error)
             if (error) return
             if (.not.valid) then
                call cubeheader_message(seve%e,rname,'Internal error, brightness/flux unit not recognized')
                error = .true.
                return
             else
                prog = newunit
             endif
          case default
             call unit%get_from_name_for_code(user%name,unitcode,error)
             if (error) return
             prog = unit%name
          end select
       endif
    else
       continue
    endif
  end subroutine cubetools_array_unit_user2prog
  !
  subroutine cubetools_array_unit2uservar(prog,uservar,error)
    use cubetools_userspace
    use cubetools_uservar
    !------------------------------------------------------------------------
    ! Loads array unit onto a user space variable
    !------------------------------------------------------------------------
    type(array_t),   intent(in)    :: prog
    type(uservar_t), intent(inout) :: uservar
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>UNIT2USERVAR'
    !
    call cubeheader_message(headseve%trace,rname,'welcome')
    !
    call uservar%set(prog%unit,error)
    if (error) return
  end subroutine cubetools_array_unit2uservar
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_array_extrema_prog2user(prog,user,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(array_t),              intent(in)    :: prog
    type(array_extrema_user_t), intent(out)   :: user
    logical,                    intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>EXTREMA>PROG2USER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    write(user%minval,'(1pg14.7)') prog%min%val
    write(user%minix, '(i0)')      prog%min%ix
    write(user%miniy, '(i0)')      prog%min%iy
    write(user%minic, '(i0)')      prog%min%ic
    write(user%maxval,'(1pg14.7)') prog%max%val
    write(user%maxix, '(i0)')      prog%max%ix
    write(user%maxiy, '(i0)')      prog%max%iy
    write(user%maxic, '(i0)')      prog%max%ic
  end subroutine cubetools_array_extrema_prog2user
  !
  subroutine cubetools_array_extrema2userstruct(prog,userstruct,error)
    use cubetools_userspace
    use cubetools_userstruct
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(array_t),      intent(in)    :: prog
    type(userstruct_t), intent(inout) :: userstruct
    logical,            intent(inout) :: error
    !
    type(array_extrema_user_t) :: user
    type(userstruct_t) :: minstruct,maxstruct
    character(len=*), parameter :: rname='ARRAY>EXTREMA2USERSTRUCT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_array_extrema_prog2user(prog,user,error)
    if (error) return
    call userstruct%def(error)
    if (error) return
    !
    ! Same as cubetools_arrelt_sicdef
    call userstruct%def_substruct('min',minstruct,error)
    if (error) return
    call minstruct%set_member('val',user%minval,error)
    if (error) return
    call minstruct%set_member('ix',user%minix,error)
    if (error) return
    call minstruct%set_member('iy',user%miniy,error)
    if (error) return
    call minstruct%set_member('ic',user%minic,error)
    if (error) return
    !
    call userstruct%def_substruct('max',maxstruct,error)
    if (error) return
    call maxstruct%set_member('val',user%maxval,error)
    if (error) return
    call maxstruct%set_member('ix',user%maxix,error)
    if (error) return
    call maxstruct%set_member('iy',user%maxiy,error)
    if (error) return
    call maxstruct%set_member('ic',user%maxic,error)
    if (error) return
  end subroutine cubetools_array_extrema2userstruct
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_array_sicdef(name,array,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(array_t),    intent(in)    :: array
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return
    call sic_def_charn(trim(name)//'%unit',array%unit,0,0,readonly,error)
    if (error) return
    call cubetools_shape_sicdef(trim(name)//'%n',array%n,readonly,error)
    if (error) return
    call cubetools_arrelt_sicdef(trim(name)//'%min',array%min,readonly,error)
    if (error) return
    call cubetools_arrelt_sicdef(trim(name)//'%max',array%max,readonly,error)
    if (error) return
    call cubetools_noise_sicdef(trim(name)//'%noi',array%noi,readonly,error)
    if (error) return
  end subroutine cubetools_array_sicdef
  !
  subroutine cubetools_array_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(array_t), intent(in)    :: in
    type(array_t), intent(out)   :: ou
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou%type = in%type
    ou%unit = in%unit
    call cubetools_shape_copy(in%n,ou%n,error)
    if (error) return
    call cubetools_arrelt_copy(in%min,ou%min,error)
    if (error) return
    call cubetools_arrelt_copy(in%max,ou%max,error)
    if (error) return
    call cubetools_noise_copy(in%noi,ou%noi,error)
    if (error) return
  end subroutine cubetools_array_copy
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_array_consistency_init(cons,error)
    !-------------------------------------------------------------------
    ! Init the consistency between two array sections
    !-------------------------------------------------------------------
    type(array_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_init(notol,check,mess,cons%unit,error)
    if (error) return
    call cubetools_shape_consistency_init(cons%n,error)
    if (error) return
    call cubetools_arrelt_consistency_init(cons%min,error)
    if (error) return
    call cubetools_arrelt_consistency_init(cons%max,error)
    if (error) return
    call cubetools_noise_consistency_init(cons%noi,error)
    if (error) return
    !
  end subroutine cubetools_array_consistency_init
  !
  subroutine cubetools_array_consistency_check(cons,arr1,arr2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between two array sections
    !-------------------------------------------------------------------
    type(array_cons_t), intent(inout) :: cons
    type(array_t),      intent(in)    :: arr1
    type(array_t),      intent(in)    :: arr2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    call cubetools_consistency_string_check(cons%unit,arr1%unit,arr2%unit,error)
    if (error) return
    call cubetools_shape_consistency_check(cons%n,arr1%n,arr2%n,error)
    if (error) return
    call cubetools_arrelt_consistency_check(cons%min,arr1%min,arr2%min,error)
    if (error) return
    call cubetools_arrelt_consistency_check(cons%max,arr1%max,arr2%max,error)
    if (error) return
    call cubetools_noise_consistency_check(cons%noi,arr1%noi,arr2%noi,error)
    if (error) return
    !
    cons%prob = cons%unit%prob.or.cons%n%prob.or.cons%min%prob.or.cons%max%prob
    !   
  end subroutine cubetools_array_consistency_check
  !
  subroutine cubetools_array_consistency_list(cons,arr1,arr2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two array sections
    !-------------------------------------------------------------------
    type(array_cons_t), intent(in)    :: cons
    type(array_t),      intent(in)    :: arr1
    type(array_t),      intent(in)    :: arr2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('data arrays',2,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call cubetools_array_unit_consistency_list(cons%unit,arr1%unit,arr2%unit,error)
       if (error) return
       call cubetools_shape_consistency_list(cons%n,arr1%n,arr2%n,error)
       if (error) return
       call cubetools_arrelt_consistency_list('minima',arr1%unit,arr2%unit,cons%min,arr1%min,arr2%min,error)
       if (error) return
       call cubetools_arrelt_consistency_list('maxima',arr1%unit,arr2%unit,cons%max,arr1%max,arr2%max,error)
       if (error) return
       call cubetools_noise_consistency_list(arr1%unit,arr2%unit,cons%noi,arr1%noi,arr2%noi,error)
       if (error) return
       endif
    call cubeheader_message(seve%r,rname,'')
    !
  end subroutine cubetools_array_consistency_list
  !
  subroutine cubetools_array_unit_consistency_list(cons,unit1,unit2,error)
    !-------------------------------------------------------------------
    ! List the consistency between two units
    !-------------------------------------------------------------------
    type(consistency_desc_t), intent(in)    :: cons
    character(len=*),         intent(in)    :: unit1
    character(len=*),         intent(in)    :: unit2
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>UNIT>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('units',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call cubetools_consistency_string_print('Unit names',cons,unit1,unit2,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_array_unit_consistency_list
  !
  subroutine cubetools_array_consistency_final(cons,error)
    !-------------------------------------------------------------------
    ! Final the consistency between two array sections
    !-------------------------------------------------------------------
    type(array_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_final(cons%unit,error)
    if (error) return
    call cubetools_shape_consistency_final(cons%n,error)
    if (error) return
    call cubetools_arrelt_consistency_final(cons%min,error)
    if (error) return
    call cubetools_arrelt_consistency_final(cons%max,error)
    if (error) return
    call cubetools_noise_consistency_final(cons%noi,error)
    if (error) return
    !
  end subroutine cubetools_array_consistency_final
end module cubetools_header_array_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_index
  use classic_params
  use class_types 
  !
  type (indx_t) :: smin    ! Valeurs minimales pour FIND
  type (indx_t) :: smax    ! Valeurs maximales pour FIND
  !
  type (optimize), target, save :: ix  ! Index du fichier d'entree
  type (optimize), target, save :: ox  ! Index du fichier de sortie
  type (optimize), target, save :: cx  ! Index de la selection courante
  !
  type (flag_t), save :: flg     ! Flag for selecting data
  !
  ! Index numbers of observation in memory. If 0 : no obs in memory,
  ! if -1 : an obs in memory that  was not read in a file.
  ! knext : pointer to the next index entry to consider
  integer(kind=entry_length) :: knext          ! Pointer to next observation
  integer(kind=entry_length) :: nindex         ! Index size
  integer(kind=entry_length) :: last_xnum = 0  ! Last observation obtained by GET
end module class_index
!
module class_data
  use class_types
  !
  type(observation), target  :: P  ! Plotted observation (from LOAD)
  !
  real(kind=xdata_kind), allocatable, target :: pdatas(:), pdatai(:), pdatav(:), pdatax(:)
  real, allocatable, target :: pdataw(:)
  real, allocatable, target :: pdata2(:,:)
end module class_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! TELCAL routines related to pointing
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine fit_xy_gauss(line,error)
  use telcal_interfaces, except_this=>fit_xy_gauss
  use fit_definitions
  use gildas_def
  use gkernel_interfaces
  use gbl_format
  use gkernel_types
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for command:
  !     GAUSS Xvar Yvar [Wvar]
  ! 1        [/DUAL]
  ! 2        [/BASE]
  ! 3        [/GUESS   Area1 Position1 Width1 [Area2/Area1 Position2-Position1 Width2/Width1] [Offset Slope]]
  ! 4        [/FIXED   Area1 Position1 Width1 [Area2/Area1 Position2-Position1 Width2/Width1] [Offset Slope]]
  ! 5        [/RESULTS Area1 Position1 Width1 [Area2/Area1 Position2-Position1 Width2/Width1] [Offset Slope]]]
  ! 6        [/PROFILE Y]
  !
  ! Purpose: Fit one or two Gaussian + a 1st order polynomial into given variables
  !          the 1st order polynomial fit is implied by the 2 Gaussian fit
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Error flag
  ! Local
  character(len=*), parameter :: rname='GAUSS'
  type (simple_1d) :: dat,sol
  type (fit_fun) :: fun
  logical :: do_dual,do_base
  type(sic_descriptor_t) :: inca,xinca,yinca
  integer(kind=address_length) :: ip,ipx,ipy
  integer(kind=4) :: memory(1)
  integer :: nc,ixy,inx,iny,ier,ipar
  logical :: found
  character(16) :: var
  character(80) :: chain
  !
  ! 0. Initialization
  !
  error = .false.
  !
  ! 1. Data vector setup
  !
  ! Xvar (mandatory)
  call sic_ch(line,0,1,var,nc,.true.,error)
  if (error) goto 100
  call sic_descriptor(var,xinca,found)
  if (.not.found) then
     chain = 'E-GAUSS,  Unknown variable '//var
     call gagout (chain)
     error = .true.
     goto 100
  endif
  if (xinca%type.eq.fmt_r8) then
     inx = xinca%size/2
  elseif (xinca%type.eq.fmt_r4) then
     inx = xinca%size
  endif
  !
  ! Yvar (mandatory)
  call sic_ch(line,0,2,var,nc,.true.,error)
  if (error) goto 100
  call sic_descriptor(var,yinca,found)
  if (.not.found) then
     chain = 'E-GAUSS,  Unknown variable '//var
     call gagout(chain)
     error = .true.
     goto 100
  endif
  if (yinca%type.eq.fmt_r8) then
     iny = yinca%size/2
  elseif (yinca%type.eq.fmt_r4) then
     iny = yinca%size
  endif
  if (iny.ne.inx) then
     call gagout('E-GAUSS, Arrays do not match')
     error = .true.
     goto 100
  endif
  ixy = inx
  !
  dat%n = ixy
  allocate(dat%x(dat%n),dat%y(dat%n),stat=ier)
  if (failed_allocate(rname,"data",ier,error)) goto 100
  !
  ipx = gag_pointer(xinca%addr,memory)
  ipy = gag_pointer(yinca%addr,memory)
  if (xinca%type.eq.fmt_r8) then
     call r8tor8(memory(ipx),dat%x,ixy)
  else
     call r4tor8(memory(ipx),dat%x,ixy)
  endif
  if (yinca%type.eq.fmt_r8) then
     call r8tor8(memory(ipy),dat%y,ixy)
  else
     call r4tor8(memory(ipy),dat%y,ixy)
  endif
  !
  ! Wvar (optional)
  allocate(dat%w(dat%n),stat=ier)
  if (failed_allocate(rname,"weight",ier,error)) goto 100
  !
  if (sic_present(0,3)) then
     print *,'Using input weights'
     call sic_ch(line,0,3,var,nc,.true.,error)
     if (error) goto 100
     call sic_descriptor(var,yinca,found)
     if (.not.found) then
        chain = 'E-GAUSS,  Unknown variable '//var
        call gagout (chain)
        error = .true.
        goto 100
     endif
     if (yinca%type.eq.fmt_r8) then
        iny = yinca%size/2
     elseif (yinca%type.eq.fmt_r4) then
        iny = yinca%size
     endif
     if (iny.ne.inx) then
        call gagout('E-GAUSS, Arrays do not match')
        error = .true.
        goto 100
     endif
     ipy = gag_pointer(yinca%addr,memory)
     if (yinca%type.eq.fmt_r8) then
        call r8tor8(memory(ipy),dat%w,ixy)
     else
        call r4tor8(memory(ipy),dat%w,ixy)
     endif
  else
     print *,'Setting equal weights'
     dat%w = 1.0
  endif
  !
  ! 2. Fitting function setup
  !
  ! Initialization
  nullify(fun%par)
  call null_function(fun)
  ! Fitting method
  fun%method = 'SLATEC'
  ! Search for /DUAL option
  do_dual = sic_present(1,0)
  ! Search for /BASE option
  do_base = sic_present(2,0)
  ! Function name and number of parameters
  if (do_dual) then
     fun%name = '2*GAUSSIAN+BASE'
     fun%npar = 8
  else if (do_base) then
     fun%name = 'GAUSSIAN+BASE'
     fun%npar = 5
  else
     fun%name = 'GAUSSIAN'
     fun%npar = 3
  endif
  allocate(fun%par(fun%npar),stat=ier)
  if (failed_allocate(rname,"function",ier,error)) goto 100
  !
  ! Names
  call null_parameter(fun%par(1))
  fun%par(1)%name = 'AREA1'
  call null_parameter(fun%par(2))
  fun%par(2)%name = 'POSITION1'
  call null_parameter(fun%par(3))
  fun%par(3)%name = 'WIDTH1'
  if (do_dual) then
     call null_parameter(fun%par(4))
     fun%par(4)%name = 'AREA2/AREA1'
     call null_parameter(fun%par(5))
     fun%par(5)%name = 'POSITION2-POSITION1'
     call null_parameter(fun%par(6))
     fun%par(6)%name = 'WIDTH2/WIDTH1'
     call null_parameter(fun%par(7))
     fun%par(7)%name = 'OFFSET'
     call null_parameter(fun%par(8))
     fun%par(8)%name = 'SLOPE'
  else if (do_base) then
     call null_parameter(fun%par(4))
     fun%par(4)%name = 'OFFSET'
     call null_parameter(fun%par(5))
     fun%par(5)%name = 'SLOPE'
  endif
  ! Search for /GUESS option
  if (sic_present(3,0)) then
     ! Guesses are given by user
     do ipar=1,fun%npar
        call sic_r8(line,3,ipar,fun%par(ipar)%guess,.true.,error)
        if (error) goto 100
     enddo
  else
     ! Try not-so-clever guesses
     fun%par(1:fun%npar)%guess = 1.0
  endif
  ! Fixed or variable parameters?
  if (sic_present(4,0)) then
     ! User expresses which parameter are fixed and which are free
     do ipar=1,fun%npar
        call sic_l4(line,4,ipar,fun%par(ipar)%fixed,.true.,error)
        if (error) goto 100
     enddo
  else
     ! All parameters are free
     fun%par(1:fun%npar)%fixed = .false.
  endif
  !
  ! 3. Fitting
  !
  call fit_1d(dat,fun,.true.)
  !
  ! Search for /RESULTS option
  if (sic_present(5,0)) then
     do ipar=1,fun%npar
        call sic_ch(line,5,ipar,var,nc,.true.,error)
        if (error) goto 100
        call sic_descriptor(var,inca,found)
        if (.not.found) then
           chain = 'E-GAUSS,  Unknown variable '//var
           call gagout (chain)
           error = .true.
           goto 100
        endif
        ip = gag_pointer(inca%addr,memory)
        if (inca%type.eq.fmt_r8) then
           call r8tor8(fun%par(ipar)%value,memory(ip),1)
        else
           call r8tor4(fun%par(ipar)%value,memory(ip),1)
        endif
     enddo
  endif
  !
  ! Search for /PROFILE option
  if (sic_present(6,0)) then
     ! Allocate the solution structure
     sol%n = ixy
     allocate(sol%x(sol%n),sol%y(sol%n),stat=ier)
     if (failed_allocate(rname,"solution",ier,error)) goto 100
     ! Compute the solution profile
     call get_profile(fun,sol)
     ! Get variable name
     call sic_ch(line,6,1,var,nc,.true.,error)
     if (error) goto 100
     ! Find its descriptor
     call sic_descriptor(var,inca,found)
     if (.not.found) then
        chain = 'E-GAUSS,  Unknown variable '//var
        call gagout (chain)
        error = .true.
        goto 100
     endif
     ! Transfer memory content
     ip = gag_pointer(inca%addr,memory)
     if (inca%type.eq.fmt_r8) then
        call r8tor8(sol%y,memory(ip),ixy)
     else
        call r8tor4(sol%y,memory(ip),ixy)
     endif
  endif
  !
  ! 4. Freeing memory
  !
100 continue
  call null_simple_1d(dat)
  call null_simple_1d(sol)
  call null_function(fun)
  !
end subroutine fit_xy_gauss
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine default_pointing_guess(guess)
  use telcal_interfaces, except_this=>default_pointing_guess
  use point_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for pointing
  ! Purpose: Try to make clever guesses to prepare to solve for pointing
  !          parameters. A few comments:
  !            * It is safe to leave offset and slope values to zero as
  !              the fit easily find good values from those guesses
  !            * The initial guesses of area and position will anyway
  !              be changed in the solving process. They are present here
  !              for generality
  !            * The area_ratio and width_ratio guesses are quite easy.
  !            * Nevertheless, to obtain a robust fitting, it is mandatory
  !              that the user gives (outside this routine) useful guesses
  !              of the width (probably the beam FWHM) and the beam throw
  !          We have at most 8 parameters to fit. At high SNR, without bias
  !          this will be easy. However, this is rarely the case. Fixing
  !          the value of the area_ratio, beam_throw and width_ratio is a
  !          good way to obtain a robust value of the position (the goal).
  !          Indeed, it is easy to have good guesses for those values. While
  !          it is true that those guesses are not perfect, simulations
  !          show that this gives robust determination of the pointing
  !          error even when the fit looks biased.
  !----------------------------------------------------------------------
  type(point_guess_t), intent(out) :: guess ! User guesses from command line
  !
  ! Local variables
  !
  guess%offset%value      =  0.0
  guess%slope%value       =  0.0
  guess%area%value        =  0.0
  guess%position%value    =  0.0
  guess%width%value       =  0.0
  guess%area_ratio%value  = -1.0
  guess%beam_throw%value  =  0.0
  guess%width_ratio%value = +1.0
  !
  guess%offset%fixed      = .false.
  guess%slope%fixed       = .false.
  guess%area%fixed        = .false.
  guess%position%fixed    = .false.
  guess%width%fixed       = .false.
  guess%area_ratio%fixed  = .true.
  guess%beam_throw%fixed  = .true.
  guess%width_ratio%fixed = .true.
  !
end subroutine default_pointing_guess
!
subroutine init_pointing(ndat,nsol,psys,pdir,ptype,point,error)
  use gkernel_interfaces
  use telcal_interfaces, except_this=>init_pointing
  use point_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for pointing
  ! Purpose: Free, reallocate and initialize the POINT structure
  !          according to user defined input. Data must be filled
  !          outside
  !----------------------------------------------------------------------
  integer, intent(in) :: ndat             ! Number of data points
  integer, intent(in) :: nsol             ! Number of solution points
  integer, intent(in) :: psys             ! Pointing coordinate system
  character(len=*), intent(in) :: pdir    ! Pointing direction in above system
  character(len=*), intent(in) :: ptype   ! Pointing type (SINGLE|DUAL)
  type(pointing_t), intent(out) :: point  ! Pointing structure
  logical, intent(out) :: error           ! Error flag
  !
  ! Local variables
  character(len=13) :: rname = 'INIT_POINTING'
  integer :: npar,ipar,ier
  !
  ! Initialization
  error = .false.
  !
  ! Fill in pointing coordinate system, direction, and type
  point%sys  = psys
  point%dir  = pdir
  point%type = ptype
  !
  ! Free (if needed), (re)allocate and initialize the data structure
  call null_simple_1d(point%dat)
  point%dat%n = ndat
  allocate(point%dat%x(ndat),point%dat%y(ndat),point%dat%w(ndat),point%dat%d(ndat),stat=ier)
  if (failed_allocate(rname,"data",ier,error)) return
  point%dat%x = 0.
  point%dat%y = 0.
  point%dat%w = 1.
  point%dat%d = 0.
  !
  ! Free (if needed), (re)allocate and initialize the solution structure
  call null_simple_1d(point%sol)
  point%sol%n = nsol
  allocate(point%sol%x(nsol),point%sol%y(nsol),point%sol%w(nsol),point%sol%d(nsol),stat=ier)
  if (failed_allocate(rname,"solution",ier,error)) return
  point%sol%x = 0.
  point%sol%y = 0.
  point%sol%w = 1.
  point%sol%d = 0.
  !
  ! Free (if needed), (re)allocate and initialize the function structure
  call null_function(point%fun)
  point%fun%method = 'SLATEC'
  if (ptype.eq."SINGLE") then
     point%fun%name = 'GAUSSIAN+BASE'
     npar = 5
  else
     point%fun%name = '2*GAUSSIAN+BASE'
     npar = 8
  endif
  point%fun%npar = npar
  allocate(point%fun%par(npar),stat=ier)
  if (failed_allocate(rname,"function",ier,error)) return
  do ipar=1,npar
     call null_parameter(point%fun%par(ipar))
  enddo
  point%fun%par(1)%name = 'AREA'
  point%fun%par(2)%name = 'POSITION'
  point%fun%par(3)%name = 'WIDTH'
  if (ptype.eq."SINGLE") then
     point%fun%par(4)%name = 'OFFSET'
     point%fun%par(5)%name = 'SLOPE'
  else
     point%fun%par(4)%name = 'AREA2/AREA1'
     point%fun%par(5)%name = 'POSITION2-POSITION1'
     point%fun%par(6)%name = 'WIDTH2/WIDTH1'
     point%fun%par(7)%name = 'OFFSET'
     point%fun%par(8)%name = 'SLOPE'
  endif
  !
end subroutine init_pointing
!
subroutine define_sic_pointing(point,varname,error)
  use telcal_interfaces, except_this=>define_sic_pointing
  use point_definitions
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for pointing
  ! Purpose: (Re)define the SIC structure VARNAME associated to the
  !          FORTRAN90 structure POINT
  !----------------------------------------------------------------------
  type(pointing_t), intent(in) :: point     ! FORTRAN 90 pointing structure
  character(len=*), intent(in) :: varname   ! Name of the SIC structure associated to POINT
  logical, intent(out) :: error             ! Logical flag
  ! Local
  integer :: ndat,nsol,npar,ipar
  character(len=1) :: cpar
  !
  ! Initialization
  error = .false.
  !
  ! Create the SIC substructure (Delete it first if needed)
  if (sic_varexist(varname)) then
     call sic_delvariable(varname,.false.,error)
     if (error) return
  endif
  call sic_defstructure(varname,.true.,error)
  if (error) return
  !
  call sic_def_inte (varname//'%sys',point%sys,0,0,.false.,error)
  call sic_def_charn(varname//'%dir',point%dir,0,0,.false.,error)
  !
  ! Create data, solution and function structures
  call sic_defstructure(varname//'%dat',.true.,error)
  call sic_defstructure(varname//'%sol',.true.,error)
  call sic_defstructure(varname//'%fun',.true.,error)
  if (error) return
  !
  ! Create data associated variables
  ndat = point%dat%n
  call sic_def_inte(varname//'%dat%n',point%dat%n,0,0,.false.,error)
  call sic_def_dble(varname//'%dat%x',point%dat%x,1,ndat,.false.,error)
  call sic_def_dble(varname//'%dat%y',point%dat%y,1,ndat,.false.,error)
  call sic_def_dble(varname//'%dat%w',point%dat%w,1,ndat,.false.,error)
  if (error) return
  !
  ! Create solution associated variables
  nsol = point%sol%n
  call sic_def_inte(varname//'%sol%n',point%sol%n,0,0,.false.,error)
  call sic_def_dble(varname//'%sol%x',point%sol%x,1,nsol,.false.,error)
  call sic_def_dble(varname//'%sol%y',point%sol%y,1,nsol,.false.,error)
  call sic_def_dble(varname//'%sol%w',point%sol%w,1,nsol,.false.,error)
  if (error) return
  !
  ! Create function associated variables
  npar = point%fun%npar
  call sic_def_char(varname//'%fun%name',  point%fun%name,.true.,error)
  call sic_def_char(varname//'%fun%method',point%fun%method,.true.,error)
  call sic_def_real(varname//'%fun%chi2',  point%fun%chi2,0,0,.false.,error)
  call sic_def_real(varname//'%fun%rms',   point%fun%rms,0,0,.false.,error)
  call sic_def_inte(varname//'%fun%flag',  point%fun%flag,0,0,.false.,error)
  call sic_def_inte(varname//'%fun%ncall', point%fun%ncall,0,0,.false.,error)
  call sic_def_inte(varname//'%fun%npar',  point%fun%npar,0,0,.true.,error)
  if (error) return
  ! Loop over the function parameters
  do ipar=1,npar
     write(cpar,'(i1)') ipar
     call sic_def_char(varname//'%fun%par'//cpar//'%name', point%fun%par(ipar)%name,.true.,error)
     call sic_def_dble(varname//'%fun%par'//cpar//'%guess',point%fun%par(ipar)%guess,0,0,.false.,error)
     call sic_def_dble(varname//'%fun%par'//cpar//'%value',point%fun%par(ipar)%value,0,0,.false.,error)
     call sic_def_dble(varname//'%fun%par'//cpar//'%error',point%fun%par(ipar)%error,0,0,.false.,error)
     call sic_def_dble(varname//'%fun%par'//cpar//'%mini', point%fun%par(ipar)%mini,0,0,.false.,error)
     call sic_def_dble(varname//'%fun%par'//cpar//'%maxi', point%fun%par(ipar)%maxi,0,0,.false.,error)
     call sic_def_logi(varname//'%fun%par'//cpar//'%fixed',point%fun%par(ipar)%fixed,.false.,error)
     if (error) return
  enddo
  !
end subroutine define_sic_pointing
!
subroutine solve_pointing(point,guess,verbose,error)
  use telcal_interfaces, except_this=>solve_pointing
  use point_definitions
  use phys_const
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for pointing
  ! Purpose: Find the first guesses, fit and compute profile of fit
  !          solution. The fit is iterated with position guess every half
  !          FWHM in the x coordinate range. The best fit is then selected.
  !          In real cases, this implies of the order of 20 fits if the width
  !          parameter. This scheme provides a very robust solution.
  !----------------------------------------------------------------------
  type(pointing_t), intent(inout) :: point ! FORTRAN 90 pointing structure
  type(point_guess_t), intent(in) :: guess ! User guesses from command line
  logical, intent(in)  :: verbose          ! Verbose or quiet solving?
  logical, intent(out) :: error            ! Error flag
  !
  ! Local variables
  logical :: start
  integer :: idat,isol,iiter,niter,ibestpos,ibestall
  real :: xmin,xmax,xcur
  real :: ymin,ymax,ycur
  real :: bestposchi2,bestallchi2
  real(8) :: width
  !
  ! Initialization
  error = .false.
  !
  ! Do something only when the structure is ready for solving
  if (point%fun%flag.eq.2) then
     !
     ! Check valid data points and find minimum and maximum values
     ! in x and y
     ! Maybe I should also set a minimum number of valid data point
     start = .true.
     do idat=1,point%dat%n
        if (point%dat%w(idat).gt.0) then
           xcur = point%dat%x(idat)
           ycur = point%dat%y(idat)
           if (start) then
              start = .false.
              xmin = xcur
              xmax = xmin
              ymin = ycur
              ymax = ymin
           else
              if (xcur.lt.xmin) then
                 xmin = xcur
              else if (xmax.lt.xcur) then
                 xmax = xcur
              endif
              if (ycur.lt.ymin) then
                 ymin = ycur
              else if (ymax.lt.ycur) then
                 ymax = ycur
              endif
           endif
        endif
     enddo
     if (start) then
        call gagout('E-POINT, No valid data point...')
        error = .true.
        return
     endif
     !
     ! The absolute value is to avoid fitting negative noise
     ! peaks as the searched Gaussian
     width = abs(guess%width%value)
     if (width.eq.0) then
        call gagout('E-POINT, Width must be different from 0')
        error = .true.
        return
     endif
     !
     ! The user has the choice to fixe or free any parameter
     point%fun%par(1)%fixed = guess%area%fixed
     point%fun%par(2)%fixed = guess%position%fixed
     point%fun%par(3)%fixed = guess%width%fixed
     if (point%fun%name.eq."GAUSSIAN+BASE") then
        point%fun%par(4)%fixed = guess%offset%fixed
        point%fun%par(5)%fixed = guess%slope%fixed
     else
        point%fun%par(4)%fixed = guess%area_ratio%fixed
        point%fun%par(5)%fixed = guess%beam_throw%fixed
        point%fun%par(6)%fixed = guess%width_ratio%fixed
        point%fun%par(7)%fixed = guess%offset%fixed
        point%fun%par(8)%fixed = guess%slope%fixed
     endif
     !
     ! Initial guesses for all parameters except position
     if (guess%area%fixed) then
        point%fun%par(1)%guess = guess%area%value
     else
        point%fun%par(1)%guess = 0.5*abs(ymax*width)*sqrt(pi/log(2.0))
     endif
     point%fun%par(3)%guess = width
     if (point%fun%name.eq."GAUSSIAN+BASE") then
        point%fun%par(4)%guess = guess%offset%value
        point%fun%par(5)%guess = guess%slope%value
     else
        point%fun%par(4)%guess = guess%area_ratio%value
        point%fun%par(5)%guess = guess%beam_throw%value
        point%fun%par(6)%guess = guess%width_ratio%value
        point%fun%par(7)%guess = guess%offset%value
        point%fun%par(8)%guess = guess%slope%value
        !
        xmin = xmin-0.5*point%fun%par(5)%guess
     endif
     !
     ! Position guess is essential to have a robust fitting
     ! => Particular treatement
     if (guess%position%fixed) then
        ! The user knows what he is doing...
        point%fun%par(2)%guess = guess%position%value
     else
        ! Loop over the position guess with a coordinate
        ! resolution of half FWHM. The best chi2 fit is
        ! then selected
        niter = 2*abs(xmax-xmin)/width
        ibestpos = 0
        ibestall = 0
        bestposchi2 = 1.e30
        bestallchi2 = 1.e30
        do iiter=1,niter
           point%fun%par(2)%guess = xmin+0.5*width*(iiter-1)
           call fit_1d(point%dat,point%fun,.false.)
           if (point%fun%flag.ne.0)  cycle
           ! All gaussians
           if (point%fun%chi2.lt.bestallchi2) then
             ibestall = iiter
             bestallchi2 = point%fun%chi2
           endif
           ! Positive gaussians
           if (point%fun%par(1)%value*point%fun%par(3)%value.gt.0 .and. point%fun%chi2.lt.bestposchi2) then
             ibestpos = iiter
             bestposchi2 = point%fun%chi2
           endif
        enddo
        if (ibestpos.gt.0) then
          ! Prefer best positive gaussian if available
          point%fun%par(2)%guess = xmin+0.5*width*(ibestpos-1)
        elseif (ibestall.gt.0) then
          ! Else best gaussian of all is fine
          point%fun%par(2)%guess = xmin+0.5*width*(ibestall-1)
        else
           call gagout('E-POINT, Fitting problem...')
           error = .true.
           return
        endif
     endif
     !
     ! Redo the best chi2 fit: a bit more computation but a much
     ! simpler source code
     call fit_1d(point%dat,point%fun,verbose)
     !
     ! Get profile of fit solution on the entire X axis
     do isol=1,point%sol%n
        point%sol%x(isol) = point%dat%x(1) + &
          (point%dat%x(point%dat%n)-point%dat%x(1))*(isol-1)/(point%sol%n-1)
     enddo
     call get_profile(point%fun,point%sol)
     !
  endif
  !
end subroutine solve_pointing
!
subroutine free_pointing(point)
  use telcal_interfaces, except_this=>free_pointing
  use point_definitions
  !----------------------------------------------------------------------
  ! @ public
  ! TELCAL support routine for pointing
  ! Purpose: Free memory associated to the FORTRAN 90 pointing structure
  !----------------------------------------------------------------------
  type(pointing_t), intent(inout) :: point ! FORTRAN 90 pointing structure
  !
  ! Local variables
  !
  call null_function(point%fun)
  call null_simple_1d(point%sol)
  call null_simple_1d(point%dat)
  !
end subroutine free_pointing
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine init_point_cross(my_ncross,ndat,nsol,psys,pdir,ptype,error)
  use telcal_interfaces, except_this=>init_point_cross
  use pcross_definitions
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for pointing through a cross
  ! Purpose: Initialize the PCROSS FORTRAN90 and SIC structures
  !----------------------------------------------------------------------
  integer, intent(in) :: my_ncross        ! Number of subscans real used in the PCROSS structure
  integer, intent(in) :: ndat(my_ncross)  ! Number of data points in each subscan
  integer, intent(in) :: nsol(my_ncross)  ! Number of solution points in each subscan
  integer, intent(in) :: psys(my_ncross)  ! Coordinate system of each subscan
  character(len=16), intent(in) :: pdir(my_ncross)  ! Direction of each subscan
  character(len=16), intent(in) :: ptype(my_ncross) ! Type of each subscan (SINGLE or DUAL)
  logical, intent(out) :: error
  ! Local
  character(len=128) :: mess
  character(len=32) :: varname
  integer :: icross
  !
  ! Initialization
  error = .false.
  !
  ! Sanity check
  if (my_ncross.eq.0) then
     call gagout('E-POINT, Number of cross subscans must be greater than 0')
     error = .true.
     return
  else if (my_ncross.gt.mcross) then
     write(mess,*) 'E-POINT, Number of cross subscans must be lower than',mcross
     call gagout(mess)
     error = .true.
     return
  endif
  !
  ! Set actual number of cross subscans
  ncross = my_ncross
  !
  ! Check whether the SIC pcross structure exists
  if (sic_varexist('pcross')) then
     ! Structure already exists => Delete it
     call sic_delvariable('pcross',.false.,error)
     if (error) return
  endif
  ! Recreate the PCROSS structure
  call sic_defstructure('pcross',.true.,error)
  !
  ! Loop over the subscans
  do icross=1,ncross
     ! Initialize FORTRAN90 structure
     call init_pointing(  &
          ndat(icross),   &
          nsol(icross),   &
          psys(icross),    &
          pdir(icross),   &
          ptype(icross),  &
          pcross(icross), &
          error)
     if (error) return
     ! Define associated PCROSS SIC structure
     write(varname,'(a10,i0)') "pcross%sub",icross
     call define_sic_pointing(pcross(icross),varname(1:lenc(varname)),error)
     if (error) return
  enddo
  !
end subroutine init_point_cross
!
subroutine solve_point_cross(guess,verbose,plot,error)
  use telcal_interfaces, except_this=>solve_point_cross
  use pcross_definitions
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for pointing through a cross
  ! Purpose: Solve the telescope pointing parameters through a cross
  !          and plot the results
  !----------------------------------------------------------------------
  type(point_guess_t), intent(in)  :: guess   ! User guesses from command line
  logical,             intent(in)  :: verbose ! Verbose or quiet solve?
  logical,             intent(in)  :: plot    ! Do we plot the results?
  logical,             intent(out) :: error   ! Error flag
  !
  ! Local variables
  integer :: icross
  !
  ! Initialization
  error = .false.
  !
  ! Sanity check
  if ((1.le.ncross).and.(ncross.le.mcross)) then
     ! Loop over the subscans
     do icross=1,ncross
        call solve_pointing(pcross(icross),guess,verbose,error)
        if (error) return
     enddo
     ! Plots results when asked
     if (plot) then
        call exec_program('sic\@ plot-point-cross.telcal')
     endif
  endif
  !
end subroutine solve_point_cross
!
subroutine free_point_cross
  use telcal_interfaces, except_this=>free_point_cross
  use pcross_definitions
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for pointing through a cross
  ! Purpose: Free the PCROSS FORTRAN90 and SIC structures
  !----------------------------------------------------------------------
  ! Local
  integer :: icross
  logical :: error
  !
  ! Delete associated SIC structure when needed
  if (sic_varexist('pcross')) then
     call sic_delvariable('pcross',.false.,error)
  endif
  !
  ! Sanity check
  if ((1.le.ncross).and.(ncross.le.mcross)) then
     ! Loop over the subscans
     do icross=1,ncross
        call free_pointing(pcross(icross))
     enddo
  endif
  !
  ! Reset actual number of cross subscans to avoid problem if "POINT /SOLVE" is called again
  ncross = 0
  !
end subroutine free_point_cross
!
subroutine telcal_point(line,error)
  use telcal_interfaces, except_this=>telcal_point
  use gkernel_interfaces
  use pcross_definitions
  use gbl_constant
  use phys_const
  !----------------------------------------------------------------------
  ! @ private
  ! TELCAL support routine for command
  !     POINT
  ! 1        [/INIT  SINGLE|DUAL Ndat Nsol]
  ! 2        [/SOLVE Width [BeamThrow [Area_Ratio Width_Ratio]]]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Error flag
  !
  ! Local variables
  type(point_guess_t) :: guess
  character(len=256) :: chain
  logical :: do_init,do_solve
  integer :: nchain
  integer :: ndat,nsol
  integer :: ndats(4),nsols(4),psyss(4)
  character(len=16) :: pdirs(4),ptypes(4)
  !
  integer miptype,niptype ! Input pointing type
  parameter (miptype=2)
  character(len=16) :: iptypes(miptype),iptype
  data iptypes/'SINGLE','DUAL'/
  !
  ! Initialization
  error    = .false.
  do_init  = .false.
  do_solve = .false.
  !
  ! Search for option /INIT or /SOLVE
  do_init  = sic_present(1,0)
  do_solve = sic_present(2,0)
  if (do_init.and.do_solve) then
     call gagout('E-POINT, /INIT and /SOLVE are exclusive from each other')
     error = .true.
     return
  endif
  !
  ! Initialize
  if (do_init) then
     ! Get pointing type
     call sic_ke(line,1,1,chain,nchain,.true.,error)
     call sic_ambigs('POINT',chain,iptype,niptype,iptypes,miptype,error)
     if (error) return
     ! Get length of subscans
     call sic_i4(line,1,2,ndat,.true.,error)
     ! Get length of solution
     call sic_i4(line,1,3,nsol,.true.,error)
     if (error) return
     ! Prepare initialization:
     ! 1. Number of data and solution points
     ndats = ndat
     nsols = nsol
     ! 2. Cartesian coordinate system
     psyss = p_none
     ! 3. Subscan directions
     pdirs(1) = '+LAM'
     pdirs(2) = '-LAM'
     pdirs(3) = '+BET'
     pdirs(4) = '-BET'
     ! 4. Pointing type resulting from scanning direction and chopping mode
     ptypes(1) = iptype
     ptypes(2) = iptype
!     ptypes(3) = 'SINGLE'
!     ptypes(4) = 'SINGLE'
     ptypes(3) = iptype
     ptypes(4) = iptype
     ! Initialize FORTRAN90 and SIC PCROSS associated structures
     call init_point_cross(4,ndats,nsols,psyss,pdirs,ptypes,error)
     if (error) return
  endif
  !
  ! Solve when possible
  if (ncross.ne.0) then
     ! Initialization happened => Continue
     if (do_solve) then
        ! Useful defaults
        call default_pointing_guess(guess)
        if (error) return
        ! Mandatory width guess in any case
        call sic_r8(line,2,1,guess%width%value,.true.,error)
        if (error) return
        ! Check which kind of pointing will be solved
        if (any(pcross(:)%type.eq."DUAL")) then
           iptype = "DUAL"
        else
           iptype = "SINGLE"
        endif
        ! Retrieves possible other arguments
        if (iptype.eq."DUAL") then
           ! Mandatory BeamThrow in case of DUAL beam pointing
           call sic_r8(line,2,2,guess%beam_throw%value,.true.,error)
           if (error) return
           ! Optional area_ratio
           if (sic_present(2,3)) then
              call sic_r8(line,2,3,guess%area_ratio%value,.false.,error)
           endif
           ! Optional width_ratio
           if (sic_present(2,4)) then
              call sic_r8(line,2,4,guess%width_ratio%value,.false.,error)
           endif
        endif
        ! Solve pointing and plot results
        call solve_point_cross(guess,.true.,.true.,error)
        if (error) return
     endif
  else
     ! Initialization is missing => Problem
     call gagout('E-POINT, Pointing must be initialized before solved')
     error = .true.
     return
  endif
  !
end subroutine telcal_point
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubeio_subcube
  !---------------------------------------------------------------------
  ! Support module for a contiguous block of 2D planes
  !---------------------------------------------------------------------
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_flush
  use cubeio_read
  use cubeio_write

  type cubeio_subcube_t
    integer(kind=data_k), public  :: f3 = 0  ! Index of first plane in the corresponding full cube
    integer(kind=data_k), public  :: n1 = 0                         ! Size of 1st dimension
    integer(kind=data_k), public  :: n2 = 0                         ! Size of 2nd dimension
    integer(kind=data_k), public  :: n3 = 0                         ! (Useful) size of 3rd dimension
    integer(kind=code_k), public  :: allocated = code_pointer_null  !
    logical,              public  :: iscplx = .false.               ! R*4 or C*4?
    real(kind=sign_k),    public, pointer :: r4(:,:,:) => null()    ! [n1,n2,m3]
    complex(kind=sign_k), public, pointer :: c4(:,:,:) => null()    ! [n1,n2,m3]
  contains
    procedure, public :: get  => cubeio_get_subcube
    procedure, public :: put  => cubeio_put_subcube
    procedure, public :: free => cubeio_free_subcube
  end type cubeio_subcube_t

  private
  public :: cubeio_subcube_t
  public :: cubeio_iterate_subcube

contains

  subroutine cubeio_reallocate_subcube(subcube,iscplx,n1,n2,n3,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_subcube_t
    ! Do nothing when the array sizes do not need to change
    !-------------------------------------------------------------------
    type(cubeio_subcube_t), intent(inout) :: subcube
    logical,                intent(in)    :: iscplx
    integer(kind=data_k),   intent(in)    :: n1
    integer(kind=data_k),   intent(in)    :: n2
    integer(kind=data_k),   intent(in)    :: n3  ! Minimum desired (can be different from size of allocation)
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>SUBCUBE'
    integer(kind=4) :: ier
    integer(kind=data_k) :: m3
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (n1.le.0) then
      call cubeio_message(seve%e,rname,'Size of 1st dimension is null or negative')
      error = .true.
    endif
    if (n2.le.0) then
      call cubeio_message(seve%e,rname,'Size of 2nd dimension is null or negative')
      error = .true.
    endif
    if (n3.le.0) then
      call cubeio_message(seve%e,rname,'Size of 3rd dimension is null or negative')
      error = .true.
    endif
    if (error)  return
    !
    ! Allocation or reallocation?
    if (subcube%allocated.eq.code_pointer_allocated) then
      ! Reallocation?
      if (subcube%iscplx) then
        m3 = ubound(subcube%c4,3)
      else
        m3 = ubound(subcube%r4,3)
      endif
      if ((subcube%iscplx.eqv.iscplx) .and.  &
           subcube%n1.eq.n1           .and.  &
           subcube%n2.eq.n2           .and.  &
           m3.ge.n3) then
        ! Same type and same size (at least on 3rd dim) => Nothing to be done!
        call cubeio_message(ioseve%alloc,rname,'Subcube already allocated with correct size')
        goto 100
      else  ! Different type or different size => reallocation
        call cubeio_message(ioseve%alloc,rname,'Reallocating subcube')
        call cubeio_free_subcube(subcube,error)
        if (error)  return
      endif
    else
      ! Allocation
      call cubeio_message(ioseve%alloc,rname,'Creating subcube')
    endif
    !
    ! Reallocate memory of the right size
    if (iscplx) then
      allocate(subcube%c4(n1,n2,n3),stat=ier)
    else
      allocate(subcube%r4(n1,n2,n3),stat=ier)
    endif
    if (failed_allocate(rname,'Subcube',ier,error)) return
    !
  100 continue
    ! Operation success
    subcube%n1 = n1
    subcube%n2 = n2
    subcube%n3 = n3
    subcube%iscplx = iscplx
    subcube%allocated = code_pointer_allocated
    !
  end subroutine cubeio_reallocate_subcube

  subroutine cubeio_free_subcube(subcube,error)
    !---------------------------------------------------------------------
    ! Free a 'cubeio_subcube_t' instance
    !---------------------------------------------------------------------
    class(cubeio_subcube_t), intent(inout) :: subcube
    logical,                 intent(inout) :: error
    !
    if (subcube%allocated.eq.code_pointer_allocated) then
      if (subcube%iscplx) then
        deallocate(subcube%c4)
      else
        deallocate(subcube%r4)
      endif
    endif
    !
    subcube%f3 = 0
    subcube%n1 = 0
    subcube%n2 = 0
    subcube%n3 = 0
    subcube%allocated = code_pointer_null
    subcube%iscplx = .false.
    subcube%c4 => null()
    subcube%r4 => null()
  end subroutine cubeio_free_subcube

  subroutine cubeio_get_subcube(subcube,cubset,cubdef,dno,cub,f3,l3,order,error)
    use cubetools_access_types
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range on 3rd dimension
    ! ---
    ! Usually called for a subcube in native order, if the requested order
    ! is different, implicit transposition will occur.
    !---------------------------------------------------------------------
    class(cubeio_subcube_t),      intent(inout) :: subcube
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    integer(kind=code_k),         intent(in)    :: order   ! Desired order
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE'
    integer(kind=data_k) :: n3
    character(len=message_length) :: mess
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    select case (order)
    case (code_cube_imaset)
      n3 = cub%desc%nc
    case (code_cube_speset)
      n3 = cub%desc%ny
    case default
      write(mess,'(A,I0)')  'Unexpected subcube order: ',order
      call cubeio_message(seve%e,rname,mess)
      error = .true.
      return
    end select
    if (f3.le.0 .or. l3.gt.n3) then
      write(mess,'(3(A,I0),2A)')  'Subcube range ',f3,'-',l3,  &
        ' out of input cube range 1-',n3,' for order ',cubetools_ordername(order)
      call cubeio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    subcube%f3 = f3  ! Bookkeeping at which position it was gotten
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_get_subcube_from_memory(cubset,cub,f3,l3,order,subcube,error)
    case (code_buffer_disk)
      call cubeio_get_subcube_from_block(cubset,dno,cub,f3,l3,order,subcube,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube buffering')
      error = .true.
    end select
    if (error)  return
  end subroutine cubeio_get_subcube

  subroutine cubeio_get_subcube_from_memory(cubset,cub,f3,l3,order,subcube,error)
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range, in the context of
    ! memory mode. In return, the 'subcube' points to the cube data buffer.
    ! --
    ! Do not call directly, use cubeio_get_subcube instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),          intent(in)    :: cubset
    type(cubeio_cube_t), target, intent(in)    :: cub
    integer(kind=data_k),        intent(in)    :: f3
    integer(kind=data_k),        intent(in)    :: l3
    integer(kind=code_k),        intent(in)    :: order   ! Desired order
    type(cubeio_subcube_t),      intent(inout) :: subcube
    logical,                     intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE>FROM>MEMORY'
    integer(kind=data_k) :: n3,ic,oc,iy,oy
    !
    n3 = l3-f3+1
    !
    if (order.eq.cub%desc%order) then  ! Native order
      ! Data is simply associated to memory buffer
      ! ZZZ deallocate if needed before associating!
      subcube%n1 = cub%desc%n1
      subcube%n2 = cub%desc%n2
      subcube%n3 = n3
      if (cub%memo%iscplx) then
        subcube%c4 => cub%memo%c4(:,:,f3:l3)
      else
        subcube%r4 => cub%memo%r4(:,:,f3:l3)
      endif
      subcube%iscplx = cub%memo%iscplx
      subcube%allocated = code_pointer_associated
      !
    elseif (order.eq.code_cube_speset .and.  &
            cub%desc%order.eq.code_cube_imaset) then
      ! Subcube is VLM, cube is LMV: transposition needed
      call cubeio_reallocate_subcube(subcube,cub%memo%iscplx,cub%desc%nc,cub%desc%nx,n3,error)
      if (error)  return
      if (cub%memo%iscplx) then
        do iy=f3,l3
          oy = iy-f3+1
          do ic=1,cub%desc%nc
            subcube%c4(ic,:,oy) = cub%memo%c4(:,iy,ic)
          enddo
        enddo
      else
        do iy=f3,l3
          oy = iy-f3+1
          do ic=1,cub%desc%nc
            subcube%r4(ic,:,oy) = cub%memo%r4(:,iy,ic)
          enddo
        enddo
      endif
      !
    elseif (order.eq.code_cube_imaset .and.  &
            cub%desc%order.eq.code_cube_speset) then
      ! Subcube is LMV, cube is VLM: transposition needed
      call cubeio_reallocate_subcube(subcube,cub%memo%iscplx,cub%desc%nx,cub%desc%ny,n3,error)
      if (error)  return
      if (cub%memo%iscplx) then
        do ic=f3,l3
          oc = ic-f3+1
          do iy=1,cub%desc%ny
            subcube%c4(:,iy,oc) = cub%memo%c4(ic,:,iy)
          enddo
        enddo
      else
        do ic=f3,l3
          oc = ic-f3+1
          do iy=1,cub%desc%ny
            subcube%r4(:,iy,oc) = cub%memo%r4(ic,:,iy)
          enddo
        enddo
      endif
      !
    else
      call cubeio_message(seve%e,rname,  &
        'No data available or transposition not implemented')
      error = .true.
      return
    endif
  end subroutine cubeio_get_subcube_from_memory

  subroutine cubeio_get_subcube_from_block(cubset,dno,cub,f3,l3,order,subcube,error)
    !---------------------------------------------------------------------
    ! Get all data (N1 x N2) for the desired range, in the context of
    ! disk mode. In return, the 'subcube' points to a memory buffer that is
    ! intended to disappear as others planes are accessed => no warranty
    ! the pointer remains valid after another call.
    ! --
    ! Do not call directly, use cubeio_get_subcube instead.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t), target,  intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    integer(kind=code_k),         intent(in)    :: order   ! Desired order
    type(cubeio_subcube_t),       intent(inout) :: subcube
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>SUBCUBE>FROM>BLOCK'
    integer(kind=data_k) :: n3,bf3,bl3
    !
    n3 = l3-f3+1
    !
    if (order.eq.cub%desc%order) then
      ! Native order
      call cubeio_check_input_any_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    elseif (order.eq.code_cube_speset .and.  &
            cub%desc%order.eq.code_cube_imaset) then
      ! Subcube is VLM, cube is LMV: transposition needed. This is done
      ! when reading the block.
      call cubeio_check_input_pix_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    elseif (order.eq.code_cube_imaset .and.  &
            cub%desc%order.eq.code_cube_speset) then
      ! Subcube is LMV, cube is VLM: transposition needed. This is done
      ! when reading the block.
      call cubeio_check_input_chan_block(cubset,dno,cub,f3,l3,error)
      if (error)  return
    else
      call cubeio_message(seve%e,rname,  &
        'No data available or transposition not implemented')
      error = .true.
      return
    endif
    !
    ! Now the subcube is simply associated to the file block
    bf3 = f3-cub%file%block%first+1  ! First position in cub%file%block
    bl3 = l3-cub%file%block%first+1  ! Last position in cub%file%block
    ! ZZZ deallocate if needed before associating!
    subcube%n1 = cub%file%block%dim1
    subcube%n2 = cub%file%block%dim2
    subcube%n3 = n3
    if (cub%file%block%iscplx) then
      subcube%c4 => cub%file%block%c4(:,:,bf3:bl3)
    else
      subcube%r4 => cub%file%block%r4(:,:,bf3:bl3)
    endif
    subcube%iscplx = cub%file%block%iscplx
    subcube%allocated = code_pointer_associated
  end subroutine cubeio_get_subcube_from_block
  !
  subroutine cubeio_put_subcube(subcube,cubset,cubdef,dno,cub,f3,l3,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Put all data (N1 x N2) for the desired channel range
    ! (This is symetric to cubeio_get_subcube)
    ! ---
    ! Subcube data is always put in native order
    !-------------------------------------------------------------------
    class(cubeio_subcube_t),      intent(inout) :: subcube
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    character(len=message_length) :: mess
    !
    if (.not.cub%ready()) then
      call cubeio_message(seve%e,rname,'Internal error: cube data is not ready')
      error = .true.
      return
    endif
    if (f3.le.0 .or. l3.gt.cub%desc%n3) then
      write(mess,'(3(A,I0))')  'Subcube range ',f3,'-',l3,  &
        ' out of output cube range 1-',cub%desc%n3
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (subcube%n1.ne.cub%desc%n1 .or. subcube%n2.ne.cub%desc%n2) then
      write(mess,'(5(A,I0))')  'N1 or N2 mismatch: attempt to put ',  &
        subcube%n1,'x',subcube%n2,' sized plane(s) while output cube has ',  &
        cub%desc%n1,'x',cub%desc%n2,' planes'
      call cubeio_message(seve%e,rname,mess)
      error = .true.
    endif
    if (subcube%iscplx.neqv.cub%desc%iscplx) then
      call cubeio_message(seve%e,rname,'Channel and output cube type mismatch (R*4/C*4)')
      error = .true.
    endif
    if (error)  return
    !
    subcube%f3 = f3  ! Bookkeeping at which position it was put
    select case (cub%desc%buffered)
    case (code_buffer_memory)
      call cubeio_put_subcube_to_data(cubset,cub,f3,l3,subcube,error)
    case (code_buffer_disk)
      call cubeio_put_subcube_to_block(cubset,dno,cub,f3,l3,subcube,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected cube data buffering')
      error = .true.
    end select
    if (error)  return
  end subroutine cubeio_put_subcube
  !
  subroutine cubeio_put_subcube_to_data(cubset,cub,f3,l3,subcube,error)
    !-------------------------------------------------------------------
    ! Write a data range to the cubeio_memory_t, in the context of
    ! memory mode.
    ! ---
    ! Do not call directly, use cubeio_put_subcube instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),     intent(in)    :: cubset
    type(cubeio_cube_t),    intent(inout) :: cub
    integer(kind=data_k),   intent(in)    :: f3
    integer(kind=data_k),   intent(in)    :: l3
    type(cubeio_subcube_t), intent(in)    :: subcube
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    integer(kind=data_k) :: n3,i3,o3
    !
    n3 = l3-f3+1
    !
    select case (cub%desc%order)
    case (code_cube_imaset,code_cube_speset)
      if (cub%memo%iscplx) then
        do o3=f3,l3
          i3 = o3-f3+1
          cub%memo%c4(:,:,o3) = subcube%c4(:,:,i3)
        enddo
      else
        do o3=f3,l3
          i3 = o3-f3+1
          cub%memo%r4(:,:,o3) = subcube%r4(:,:,i3)
        enddo
      endif
    case default
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
    end select
    !
  end subroutine cubeio_put_subcube_to_data
  !
  subroutine cubeio_put_subcube_to_block(cubset,dno,cub,f3,l3,subcube,error)
    !-------------------------------------------------------------------
    ! Write a data range to the cubeio_block_t, in the context of
    ! disk mode.
    ! ---
    ! Do not call directly, use cubeio_put_subcube instead.
    !-------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: f3
    integer(kind=data_k),         intent(in)    :: l3
    type(cubeio_subcube_t),       intent(in)    :: subcube
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PUT>SUBCUBE'
    integer(kind=data_k) :: n3,bf3,bl3
    integer(kind=size_length) :: ndata
    !
    if (cub%file%block%iscplx.neqv.subcube%iscplx) then
      call cubeio_message(seve%e,rname,'Channel and output cube mismatch type (R*4/C*4)')
      error = .true.
      return
    endif
    !
    call cubeio_check_output_any_block(cubset,dno,cub,f3,l3,error)
    if (error)  return
    !
    ! Buffer might already be in memory but read-only: switch to read-write
    cub%file%block%readwrite = .true.
    !
    ! Write DATA to cub%file%block buffer
    n3 = l3-f3+1
    bf3 = f3-cub%file%block%first+1  ! First position in cub%file%block
    bl3 = l3-cub%file%block%first+1  ! Last position in cub%file%block
    ndata = cub%desc%n1*cub%desc%n2*n3
    if (cub%file%block%iscplx) then
      call c4toc4_sl(subcube%c4,cub%file%block%c4(1,1,bf3),ndata)
    else
      call r4tor4_sl(subcube%r4,cub%file%block%r4(1,1,bf3),ndata)
    endif
    !
  end subroutine cubeio_put_subcube_to_block
  !
  subroutine cubeio_iterate_subcube(cubset,cubdef,dno,cub,first,last,error)
    !---------------------------------------------------------------------
    ! Prepare buffers for working (at least) on the requested range.
    ! To be used when iterating the cube in native order. Otherwise use
    ! cubeio_iterate_pix or cubeio_iterate_chan.
    ! ZZZ All the 3 iteration procedures should be merged if the 3
    ! associated types are merged.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>SUBCUBE'
    !
    select case (cub%desc%action)
    case (code_read_head)
      call cubeio_message(seve%e,rname,'Access to data not allowed for action read-header')
      error = .true.
    case (code_read,code_update)
      call cubeio_iterate_read_subcube(cubset,cubdef,dno,cub,first,last,error)
    case (code_write)
      call cubeio_iterate_write_subcube(cubset,cubdef,dno,cub,first,last,error)
    case default
      call cubeio_message(seve%e,rname,'Unexpected action mode')
      error = .true.
    end select
  end subroutine cubeio_iterate_subcube

  subroutine cubeio_iterate_read_subcube(cubset,cubdef,dno,icub,first,last,error)
    !---------------------------------------------------------------------
    ! Pre-load all or part of the data from disk in a buffer which
    ! provides (at least) the requested range.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: icub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>READ>SUBCUBE'
    !
    ! On first iteration, read or prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_read_cube_data(cubset,cubdef,icub,error)
    if (error)  return
    !
    ! Work to be done on next iterations
    select case (icub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_input_any_block(cubset,dno,icub,first,last,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_read_subcube

  subroutine cubeio_iterate_write_subcube(cubset,cubdef,dno,ocub,first,last,error)
    !---------------------------------------------------------------------
    ! Prepare a buffer covering all or part of the data, providing
    ! (at least) the requested range.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: ocub
    integer(kind=data_k),         intent(in)    :: first
    integer(kind=data_k),         intent(in)    :: last
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ITERATE>WRITE>SUBCUBE'
    !
    ! On first iteration, prepare the cube data (does nothing on
    ! subsequent iterations):
    call cubeio_create_cube_data(cubset,cubdef,dno,ocub,error)
    if (error)  return
    !
    ! Work to be done on next iterations
    select case (ocub%desc%buffered)
    case (code_buffer_none)
      return
    case (code_buffer_memory)
      return
    case (code_buffer_disk)
      ! Ensure the proper buffer is available in memory
      call cubeio_check_output_any_block(cubset,dno,ocub,first,last,error)
      if (error)  return
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_iterate_write_subcube

end module cubeio_subcube

function a_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! @ private
  !	Lever d'une etoile de declinaison D a latitude D0
  !	Ce code est different de "lever" de GreG, donc je l'appelle A_LEVER
  !	(sinon big problemes,...GD, 8-10-1992)
  !	D	Declination in radians
  !	D0	Latitude in degrees
  ! 	EL	elevation limit in degrees
  !	LEVER	Hour angle in Hours
  !
  !	PI/2-D0+EL < D	Circumpolaire
  !	D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  !	D < D0-PI/2+EL	Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real(kind=4) :: a_lever           !
  real(kind=4) :: d                 !
  real(kind=4) :: d0                !
  real(kind=4) :: el                !
  ! Local
  real(kind=4) :: dd,d1,d2,ee
  real(kind=8) :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  a_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (a_lever.le.-1.0) then
    a_lever = -12.0            ! Circumpolar
  elseif (a_lever.ge.1.0) then
    a_lever = 0.0              ! Not visible
  else
    a_lever = -12.0/pi* acos(a_lever)
  endif
end function a_lever

*DECK SODS
      SUBROUTINE SODS (A, X, B, NEQ, NUK, NRDA, IFLAG, WORK, IWORK)
C***BEGIN PROLOGUE  SODS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SODS-S)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     SODS solves the overdetermined system of linear equations A X = B,
C     where A is NEQ by NUK and NEQ .GE. NUK. If rank A = NUK,
C     X is the UNIQUE least squares solution vector. That is,
C              R(1)**2 + ..... + R(NEQ)**2 = minimum
C     where R is the residual vector  R = B - A X.
C     If rank A .LT. NUK , the least squares solution of minimal
C     length can be provided.
C     SODS is an interfacing routine which calls subroutine LSSODS
C     for the solution. LSSODS in turn calls subroutine ORTHOL and
C     possibly subroutine OHTROR for the decomposition of A by
C     orthogonal transformations. In the process, ORTHOL calls upon
C     subroutine CSCALE for scaling.
C
C **********************************************************************
C   Input
C **********************************************************************
C
C     A -- Contains the matrix of NEQ equations in NUK unknowns and must
C          be dimensioned NRDA by NUK. The original A is destroyed
C     X -- Solution array of length at least NUK
C     B -- Given constant vector of length NEQ, B is destroyed
C     NEQ -- Number of equations, NEQ greater or equal to 1
C     NUK -- Number of columns in the matrix (which is also the number
C            of unknowns), NUK not larger than NEQ
C     NRDA -- Row dimension of A, NRDA greater or equal to NEQ
C     IFLAG -- Status indicator
C            =0 For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is treated as exact
C           =-K For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is assumed to be
C               accurate to about K digits
C            =1 For subsequent calls whenever the matrix A has already
C               been decomposed (problems with new vectors B but
C               same matrix a can be handled efficiently)
C     WORK(*),IWORK(*) -- Arrays for storage of internal information,
C                     WORK must be dimensioned at least  2 + 5*NUK
C                     IWORK must be dimensioned at least NUK+2
C     IWORK(2) -- Scaling indicator
C                 =-1 If the matrix A is to be pre-scaled by
C                 columns when appropriate
C                 If the scaling indicator is not equal to -1
C                 no scaling will be attempted
C              For most problems scaling will probably not be necessary
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C     IFLAG -- Status indicator
C            =1 If solution was obtained
C            =2 If improper input is detected
C            =3 If rank of matrix is less than NUK
C               If the minimal length least squares solution is
C               desired, simply reset IFLAG=1 and call the code again
C     X -- Least squares solution of  A X = B
C     A -- Contains the strictly upper triangular part of the reduced
C           matrix and the transformation information
C     WORK(*),IWORK(*) -- Contains information needed on subsequent
C                         Calls (IFLAG=1 case on input) which must not
C                         be altered
C                         WORK(1) contains the Euclidean norm of
C                         the residual vector
C                         WORK(2) contains the Euclidean norm of
C                         the solution vector
C                         IWORK(1) contains the numerically determined
C                         rank of the matrix A
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C               H. A. Watts, Solving linear least squares problems
C                 using SODS/SUDS/CODS, Sandia Report SAND77-0683,
C                 Sandia Laboratories, 1977.
C***ROUTINES CALLED  LSSODS
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SODS
      DIMENSION A(NRDA,*),X(*),B(*),WORK(*),IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  SODS
      ITER=0
      IS=2
      IP=3
      KS=2
      KD=3
      KZ=KD+NUK
      KV=KZ+NUK
      KT=KV+NUK
      KC=KT+NUK
C
      CALL LSSODS(A,X,B,NEQ,NUK,NRDA,IFLAG,IWORK(1),IWORK(IS),A,
     1            WORK(KD),IWORK(IP),ITER,WORK(1),WORK(KS),
     2            WORK(KZ),B,WORK(KV),WORK(KT),WORK(KC))
C
      RETURN
      END
*DECK SOMN
      SUBROUTINE SOMN (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, AP,
     +   EMAP, DZ, CSAV, RWORK, IWORK)
C***BEGIN PROLOGUE  SOMN
C***PURPOSE  Preconditioned Orthomin Sparse Iterative Ax=b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            the Preconditioned Orthomin method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SOMN-S, DOMN-D)
C***KEYWORDS  ITERATIVE PRECONDITION, NON-SYMMETRIC LINEAR SYSTEM,
C             ORTHOMIN, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, NSAVE, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     REAL     B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N)
C     REAL     P(N,0:NSAVE), AP(N,0:NSAVE), EMAP(N,0:NSAVE)
C     REAL     DZ(N), CSAV(NSAVE), RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL SOMN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
C    $     NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R,
C    $     Z, P, AP, EMAP, DZ, CSAV, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below, for more
C         details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotest that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C NSAVE  :IN       Integer.
C         Number of  direction vectors to save and orthogonalize
C         against.  NSAVE >= 0.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Breakdown of method detected.
C                       (p,Ap) < epsilon**2.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C P      :WORK     Real P(N,0:NSAVE).
C AP     :WORK     Real AP(N,0:NSAVE).
C EMAP   :WORK     Real EMAP(N,0:NSAVE).
C DZ     :WORK     Real DZ(N).
C CSAV   :WORK     Real CSAV(NSAVE)
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used for workspace in MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE.
C
C *Description
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines SSDOMN and SSLUOM are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDOMN, SSLUOM, ISSOMN
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSOMN, R1MACH, SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C   930326  Removed unused variable.  (FNF)
C***END PROLOGUE  SOMN
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT, NSAVE
C     .. Array Arguments ..
      REAL A(NELT), AP(N,0:NSAVE), B(N), CSAV(NSAVE), DZ(N),
     +     EMAP(N,0:NSAVE), P(N,0:NSAVE), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL AK, AKDEN, AKNUM, BKL, BNRM, FUZZ, SOLNRM
      INTEGER I, IP, IPO, K, L, LMAX
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSOMN
      EXTERNAL R1MACH, SDOT, ISSOMN
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY
C     .. Intrinsic Functions ..
      INTRINSIC ABS, MIN, MOD
C***FIRST EXECUTABLE STATEMENT  SOMN
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      FUZZ = R1MACH(3)
      IF( TOL.LT.500*FUZZ ) THEN
         TOL = 500*FUZZ
         IERR = 4
      ENDIF
      FUZZ = FUZZ*FUZZ
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I)  = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $     R, Z, P, AP, EMAP, DZ, CSAV,
     $     RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C
C         ***** iteration loop *****
C
CVD$R NOVECTOR
CVD$R NOCONCUR
      DO 100 K = 1, ITMAX
         ITER = K
         IP = MOD( ITER-1, NSAVE+1 )
C
C         calculate direction vector p, a*p, and (m-inv)*a*p,
C         and save if desired.
         CALL SCOPY(N, Z, 1, P(1,IP), 1)
         CALL MATVEC(N, P(1,IP), AP(1,IP), NELT, IA, JA, A, ISYM)
         CALL MSOLVE(N, AP(1,IP), EMAP(1,IP), NELT, IA, JA, A, ISYM,
     $        RWORK, IWORK)
         IF( NSAVE.EQ.0 ) THEN
            AKDEN = SDOT(N, EMAP, 1, EMAP, 1)
         ELSE
            IF( ITER.GT.1 ) THEN
               LMAX = MIN( NSAVE, ITER-1 )
               DO 20 L = 1, LMAX
                  IPO = MOD(IP+(NSAVE+1-L),NSAVE+1)
                  BKL = SDOT(N, EMAP(1,IP), 1, EMAP(1,IPO), 1)
                  BKL = BKL*CSAV(L)
                  CALL SAXPY(N, -BKL,    P(1,IPO), 1,    P(1,IP), 1)
                  CALL SAXPY(N, -BKL,   AP(1,IPO), 1,   AP(1,IP), 1)
                  CALL SAXPY(N, -BKL, EMAP(1,IPO), 1, EMAP(1,IP), 1)
 20            CONTINUE
               IF( NSAVE.GT.1 ) THEN
                  DO 30 L = NSAVE-1, 1, -1
                     CSAV(L+1) = CSAV(L)
 30               CONTINUE
               ENDIF
            ENDIF
            AKDEN = SDOT(N, EMAP(1,IP), 1, EMAP(1,IP), 1)
            IF( ABS(AKDEN).LT.FUZZ ) THEN
               IERR = 6
               RETURN
            ENDIF
            CSAV(1) = 1.0E0/AKDEN
C
C         calculate coefficient ak, new iterate x, new residual r, and
C         new pseudo-residual z.
         ENDIF
         AKNUM = SDOT(N, Z, 1, EMAP(1,IP), 1)
         AK = AKNUM/AKDEN
         CALL SAXPY(N,  AK,    P(1,IP), 1, X, 1)
         CALL SAXPY(N, -AK,   AP(1,IP), 1, R, 1)
         CALL SAXPY(N, -AK, EMAP(1,IP), 1, Z, 1)
C
C         check stopping criterion.
         IF( ISSOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $        ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $        R, Z, P, AP, EMAP, DZ, CSAV,
     $        RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF SOMN FOLLOWS ----------------------------
      END
*DECK SOPENM
      SUBROUTINE SOPENM (IPAGE, LPAGE)
C***BEGIN PROLOGUE  SOPENM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      ALL (SOPENM-A)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     1. OPEN UNIT NUMBER IPAGEF AS A RANDOM ACCESS FILE.
C
C     2. THE RECORD LENGTH IS CONSTANT=LPG.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  SOPENM
      CHARACTER*8 XERN1
C
C***FIRST EXECUTABLE STATEMENT  SOPENM
      IPAGEF=IPAGE
      LPG   =LPAGE
      OPEN(UNIT=IPAGEF,IOSTAT=IOS,ERR=100,STATUS='UNKNOWN',
     *ACCESS='DIRECT',FORM='UNFORMATTED',RECL=LPG)
      RETURN
C
 100  WRITE (XERN1, '(I8)') IOS
      CALL XERMSG ('SLATEC', 'SOPENM',
     *   'IN SPLP, OPEN HAS ERROR FLAG = ' // XERN1, 100, 1)
      RETURN
      END
*DECK SORTH
      SUBROUTINE SORTH (VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C***BEGIN PROLOGUE  SORTH
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SORTH-S, DORTH-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This routine  orthogonalizes  the  vector  VNEW  against the
C        previous KMP  vectors in the   V array.  It uses  a modified
C        Gram-Schmidt   orthogonalization procedure with  conditional
C        reorthogonalization.
C
C *Usage:
C      INTEGER N, LL, LDHES, KMP
C      REAL VNEW(N), V(N,LL), HES(LDHES,LL), SNORMW
C
C      CALL SORTH(VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C
C *Arguments:
C VNEW   :INOUT    Real VNEW(N)
C         On input, the vector of length N containing a scaled
C         product of the Jacobian and the vector V(*,LL).
C         On output, the new vector orthogonal to V(*,i0) to V(*,LL),
C         where i0 = max(1, LL-KMP+1).
C V      :IN       Real V(N,LL)
C         The N x LL array containing the previous LL
C         orthogonal vectors V(*,1) to V(*,LL).
C HES    :INOUT    Real HES(LDHES,LL)
C         On input, an LL x LL upper Hessenberg matrix containing,
C         in HES(I,K), K.lt.LL, the scaled inner products of
C         A*V(*,K) and V(*,i).
C         On return, column LL of HES is filled in with
C         the scaled inner products of A*V(*,LL) and V(*,i).
C N      :IN       Integer
C         The order of the matrix A, and the length of VNEW.
C LL     :IN       Integer
C         The current order of the matrix HES.
C LDHES  :IN       Integer
C         The leading dimension of the HES array.
C KMP    :IN       Integer
C         The number of previous vectors the new vector VNEW
C         must be made orthogonal to (KMP .le. MAXL).
C SNORMW :OUT      REAL
C         Scalar containing the l-2 norm of VNEW.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  SAXPY, SDOT, SNRM2
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SORTH
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      REAL SNORMW
      INTEGER KMP, LDHES, LL, N
C     .. Array Arguments ..
      REAL HES(LDHES,*), V(N,*), VNEW(*)
C     .. Local Scalars ..
      REAL ARG, SUMDSQ, TEM, VNRM
      INTEGER I, I0
C     .. External Functions ..
      REAL SDOT, SNRM2
      EXTERNAL SDOT, SNRM2
C     .. External Subroutines ..
      EXTERNAL SAXPY
C     .. Intrinsic Functions ..
      INTRINSIC MAX, SQRT
C***FIRST EXECUTABLE STATEMENT  SORTH
C
C         Get norm of unaltered VNEW for later use.
C
      VNRM = SNRM2(N, VNEW, 1)
C   -------------------------------------------------------------------
C         Perform the modified Gram-Schmidt procedure on VNEW =A*V(LL).
C         Scaled inner products give new column of HES.
C         Projections of earlier vectors are subtracted from VNEW.
C   -------------------------------------------------------------------
      I0 = MAX(1,LL-KMP+1)
      DO 10 I = I0,LL
         HES(I,LL) = SDOT(N, V(1,I), 1, VNEW, 1)
         TEM = -HES(I,LL)
         CALL SAXPY(N, TEM, V(1,I), 1, VNEW, 1)
 10   CONTINUE
C   -------------------------------------------------------------------
C         Compute SNORMW = norm of VNEW.  If VNEW is small compared
C         to its input value (in norm), then reorthogonalize VNEW to
C         V(*,1) through V(*,LL).  Correct if relative correction
C         exceeds 1000*(unit roundoff).  Finally, correct SNORMW using
C         the dot products involved.
C   -------------------------------------------------------------------
      SNORMW = SNRM2(N, VNEW, 1)
      IF (VNRM + 0.001E0*SNORMW .NE. VNRM) RETURN
      SUMDSQ = 0
      DO 30 I = I0,LL
         TEM = -SDOT(N, V(1,I), 1, VNEW, 1)
         IF (HES(I,LL) + 0.001E0*TEM .EQ. HES(I,LL)) GO TO 30
         HES(I,LL) = HES(I,LL) - TEM
         CALL SAXPY(N, TEM, V(1,I), 1, VNEW, 1)
         SUMDSQ = SUMDSQ + TEM**2
 30   CONTINUE
      IF (SUMDSQ .EQ. 0.0E0) RETURN
      ARG = MAX(0.0E0,SNORMW**2 - SUMDSQ)
      SNORMW = SQRT(ARG)
C
      RETURN
C------------- LAST LINE OF SORTH FOLLOWS ----------------------------
      END
*DECK SOS
      SUBROUTINE SOS (FNC, NEQ, X, RTOLX, ATOLX, TOLF, IFLAG, RW, LRW,
     +   IW, LIW)
C***BEGIN PROLOGUE  SOS
C***PURPOSE  Solve a square system of nonlinear equations.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      SINGLE PRECISION (SOS-S, DSOS-D)
C***KEYWORDS  BROWN'S METHOD, NEWTON'S METHOD, NONLINEAR EQUATIONS,
C             ROOTS, SOLUTIONS
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     SOS solves a system of NEQ simultaneous nonlinear equations in
C     NEQ unknowns.  That is, it solves the problem   F(X)=0
C     where X is a vector with components  X(1),...,X(NEQ)  and  F
C     is a vector of nonlinear functions.  Each equation is of the form
C
C               F (X(1),...,X(NEQ))=0     for K=1,...,NEQ.
C                K
C
C     The algorithm is based on an iterative method which is a
C     variation of Newton's method using Gaussian elimination
C     in a manner similar to the Gauss-Seidel process.  Convergence
C     is roughly quadratic.  All partial derivatives required by
C     the algorithm are approximated by first difference quotients.
C     The convergence behavior of this code is affected by the
C     ordering of the equations, and it is advantageous to place linear
C     and mildly nonlinear equations first in the ordering.
C
C     Actually, SOS is merely an interfacing routine for
C     calling subroutine SOSEQS which embodies the solution
C     algorithm.  The purpose of this is to add greater
C     flexibility and ease of use for the prospective user.
C
C     SOSEQS calls the accompanying routine SOSSOL, which solves special
C     triangular linear systems by back-substitution.
C
C     The user must supply a function subprogram which evaluates the
C     K-th equation only (K specified by SOSEQS) for each call
C     to the subprogram.
C
C     SOS represents an implementation of the mathematical algorithm
C     described in the references below.  It is a modification of the
C     code SOSNLE written by H. A. Watts in 1973.
C
C **********************************************************************
C   -Input-
C
C     FNC -Name of the function program which evaluates the equations.
C          This name must be in an EXTERNAL statement in the calling
C          program.  The user must supply FNC in the form FNC(X,K),
C          where X is the solution vector (which must be dimensioned
C          in FNC) and FNC returns the value of the K-th function.
C
C     NEQ -Number of equations to be solved.
C
C     X   -Solution vector.  Initial guesses must be supplied.
C
C     RTOLX -Relative error tolerance used in the convergence criteria.
C          Each solution component X(I) is checked by an accuracy test
C          of the form   ABS(X(I)-XOLD(I)) .LE. RTOLX*ABS(X(I))+ATOLX,
C          where XOLD(I) represents the previous iteration value.
C          RTOLX must be non-negative.
C
C     ATOLX -Absolute error tolerance used in the convergence criteria.
C          ATOLX must be non-negative.  If the user suspects some
C          solution component may be zero, he should set ATOLX to an
C          appropriate (depends on the scale of the remaining variables)
C          positive value for better efficiency.
C
C     TOLF -Residual error tolerance used in the convergence criteria.
C          Convergence will be indicated if all residuals (values of the
C          functions or equations) are not bigger than TOLF in
C          magnitude.  Note that extreme care must be given in assigning
C          an appropriate value for TOLF because this convergence test
C          is dependent on the scaling of the equations.  An
C          inappropriate value can cause premature termination of the
C          iteration process.
C
C     IFLAG -Optional input indicator.  You must set  IFLAG=-1  if you
C          want to use any of the optional input items listed below.
C          Otherwise set it to zero.
C
C     RW  -A REAL work array which is split apart by SOS and used
C          internally by SOSEQS.
C
C     LRW -Dimension of the RW array.  LRW must be at least
C                    1 + 6*NEQ + NEQ*(NEQ+1)/2
C
C     IW  -An INTEGER work array which is split apart by SOS and used
C          internally by SOSEQS.
C
C     LIW -Dimension of the IW array. LIW must be at least  3 + NEQ.
C
C   -Optional Input-
C
C     IW(1) -Internal printing parameter.  You must set  IW(1)=-1  if
C          you want the intermediate solution iterates to be printed.
C
C     IW(2) -Iteration limit.  The maximum number of allowable
C          iterations can be specified, if desired.  To override the
C          default value of 50, set IW(2) to the number wanted.
C
C     Remember, if you tell the code that you are using one of the
C               options (by setting IFLAG=-1), you must supply values
C               for both IW(1) and IW(2).
C
C **********************************************************************
C   -Output-
C
C     X   -Solution vector.
C
C     IFLAG -Status indicator
C
C                         *** Convergence to a Solution ***
C
C          1 Means satisfactory convergence to a solution was achieved.
C            Each solution component X(I) satisfies the error tolerance
C            test   ABS(X(I)-XOLD(I)) .LE. RTOLX*ABS(X(I))+ATOLX.
C
C          2 Means procedure converged to a solution such that all
C            residuals are at most TOLF in magnitude,
C            ABS(FNC(X,I)) .LE. TOLF.
C
C          3 Means that conditions for both IFLAG=1 and IFLAG=2 hold.
C
C          4 Means possible numerical convergence.  Behavior indicates
C            limiting precision calculations as a result of user asking
C            for too much accuracy or else convergence is very slow.
C            Residual norms and solution increment norms have
C            remained roughly constant over several consecutive
C            iterations.
C
C                         *** Task Interrupted ***
C
C          5 Means the allowable number of iterations has been met
C            without obtaining a solution to the specified accuracy.
C            Very slow convergence may be indicated.  Examine the
C            approximate solution returned and see if the error
C            tolerances seem appropriate.
C
C          6 Means the allowable number of iterations has been met and
C            the iterative process does not appear to be converging.
C            A local minimum may have been encountered or there may be
C            limiting precision difficulties.
C
C          7 Means that the iterative scheme appears to be diverging.
C            Residual norms and solution increment norms have
C            increased over several consecutive iterations.
C
C                         *** Task Cannot Be Continued ***
C
C          8 Means that a Jacobian-related matrix was singular.
C
C          9 Means improper input parameters.
C
C          *** IFLAG should be examined after each call to   ***
C          *** SOS with the appropriate action being taken.  ***
C
C
C     RW(1) -Contains a norm of the residual.
C
C     IW(3) -Contains the number of iterations used by the process.
C
C **********************************************************************
C***REFERENCES  K. M. Brown, Solution of simultaneous nonlinear
C                 equations, Algorithm 316, Communications of the
C                 A.C.M. 10, (1967), pp. 728-729.
C               K. M. Brown, A quadratically convergent Newton-like
C                 method based upon Gaussian elimination, SIAM Journal
C                 on Numerical Analysis 6, (1969), pp. 560-569.
C***ROUTINES CALLED  SOSEQS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Convert XERRWV calls to XERMSG calls, changed Prologue
C           comments to agree with DSOS.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SOS
      DIMENSION X(*), RW(*), IW(*)
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3, XERN4
      EXTERNAL FNC
C***FIRST EXECUTABLE STATEMENT  SOS
      INPFLG = IFLAG
C
C     CHECK FOR VALID INPUT
C
      IF (NEQ .LE. 0) THEN
         WRITE (XERN1, '(I8)') NEQ
         CALL XERMSG ('SLATEC', 'SOS', 'THE NUMBER OF EQUATIONS ' //
     *      'MUST BE A POSITIVE INTEGER.  YOU HAVE CALLED THE ' //
     *      'CODE WITH NEQ = ' // XERN1, 1, 1)
         IFLAG = 9
      ENDIF
C
      IF (RTOLX .LT. 0.0D0 .OR. ATOLX .LT. 0.0D0) THEN
         WRITE (XERN3, '(1PE15.6)') ATOLX
         WRITE (XERN4, '(1PE15.6)') RTOLX
         CALL XERMSG ('SLATEC', 'SOS', 'THE ERROR TOLERANCES FOR ' //
     *      'THE SOLUTION ITERATES CANNOT BE NEGATIVE. YOU HAVE ' //
     *      'CALLED THE CODE WITH  RTOLX = ' // XERN3 //
     *      ' AND ATOLX = ' // XERN4,2, 1)
            IFLAG = 9
      ENDIF
C
      IF (TOLF .LT. 0.0D0) THEN
         WRITE (XERN3, '(1PE15.6)') TOLF
         CALL XERMSG ('SLATEC', 'SOS', 'THE RESIDUAL ERROR ' //
     *      'TOLERANCE MUST BE NON-NEGATIVE.  YOU HAVE CALLED THE ' //
     *      'CODE WITH TOLF = ' // XERN3, 3, 1)
            IFLAG = 9
      ENDIF
C
      IPRINT = 0
      MXIT = 50
      IF (INPFLG .EQ. (-1)) THEN
         IF (IW(1) .EQ. (-1)) IPRINT = -1
         MXIT = IW(2)
         IF (MXIT .LE. 0) THEN
            WRITE (XERN1, '(I8)') MXIT
            CALL XERMSG ('SLATEC', 'SOS', 'YOU HAVE TOLD THE CODE ' //
     *         'TO USE OPTIONAL IN PUT ITEMS BY SETTING  IFLAG=-1. '//
     *         'HOWEVER YOU HAVE CALLED THE CODE WITH THE MAXIMUM ' //
     *         'ALLOWABLE NUMBER OF ITERATIONS SET TO  IW(2) = ' //
     *         XERN1, 4, 1)
            IFLAG = 9
         ENDIF
      ENDIF
C
      NC = (NEQ*(NEQ+1))/2
      IF (LRW .LT. 1 + 6*NEQ + NC) THEN
         WRITE (XERN1, '(I8)') LRW
         CALL XERMSG ('SLATEC', 'SOS', 'DIMENSION OF THE RW ARRAY ' //
     *      'MUST BE AT LEAST 1 + 6*NEQ + NEQ*(NEQ+1)/2 .  YOU HAVE ' //
     *      'CALLED THE CODE WITH LRW = ' // XERN1, 5, 1)
         IFLAG = 9
      ENDIF
C
      IF (LIW .LT. 3 + NEQ) THEN
         WRITE (XERN1, '(I8)') LIW
         CALL XERMSG ('SLATEC', 'SOS', 'DIMENSION OF THE IW ARRAY ' //
     *      'MUST BE AT LEAST   3 + NEQ.  YOU HAVE CALLED THE CODE ' //
     *      'WITH  LIW = ' // XERN1, 6, 1)
         IFLAG = 9
      ENDIF
C
      IF (IFLAG .NE. 9) THEN
         NCJS = 6
         NSRRC = 4
         NSRI = 5
C
         K1 = NC + 2
         K2 = K1 + NEQ
         K3 = K2 + NEQ
         K4 = K3 + NEQ
         K5 = K4 + NEQ
         K6 = K5 + NEQ
C
         CALL SOSEQS(FNC, NEQ, X, RTOLX, ATOLX, TOLF, IFLAG, MXIT, NCJS,
     1               NSRRC, NSRI, IPRINT, RW(1), RW(2), NC, RW(K1),
     2               RW(K2), RW(K3), RW(K4), RW(K5), RW(K6), IW(4))
C
         IW(3) = MXIT
      ENDIF
      RETURN
      END
*DECK SOSEQS
      SUBROUTINE SOSEQS (FNC, N, S, RTOLX, ATOLX, TOLF, IFLAG, MXIT,
     +   NCJS, NSRRC, NSRI, IPRINT, FMAX, C, NC, B, P, TEMP, X, Y, FAC,
     +   IS)
C***BEGIN PROLOGUE  SOSEQS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SOS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SOSEQS-S, DSOSEQ-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SOSEQS solves a system of N simultaneous nonlinear equations.
C     See the comments in the interfacing routine SOS for a more
C     detailed description of some of the items in the calling list.
C
C ********************************************************************
C
C   -INPUT-
C     FNC -Function subprogram which evaluates the equations
C     N   -Number of equations
C     S   -Solution vector of initial guesses
C     RTOLX-Relative error tolerance on solution components
C     ATOLX-Absolute error tolerance on solution components
C     TOLF-Residual error tolerance
C     MXIT-Maximum number of allowable iterations.
C     NCJS-Maximum number of consecutive iterative steps to perform
C          using the same triangular Jacobian matrix approximation.
C     NSRRC-Number of consecutive iterative steps for which the
C          limiting precision accuracy test must be satisfied
C          before the routine exits with IFLAG=4.
C     NSRI-Number of consecutive iterative steps for which the
C          diverging condition test must be satisfied before
C          the routine exits with IFLAG=7.
C     IPRINT-Internal printing parameter.  You must set IPRINT=-1 if you
C          want the intermediate solution iterates and a residual norm
C          to be printed.
C     C   -Internal work array, dimensioned at least N*(N+1)/2.
C     NC  -Dimension of C array. NC  .GE.  N*(N+1)/2.
C     B   -Internal work array, dimensioned N.
C     P   -Internal work array, dimensioned N.
C     TEMP-Internal work array, dimensioned N.
C     X   -Internal work array, dimensioned N.
C     Y   -Internal work array, dimensioned N.
C     FAC -Internal work array, dimensioned N.
C     IS  -Internal work array, dimensioned N.
C
C   -OUTPUT-
C     S   -Solution vector
C     IFLAG-Status indicator flag
C     MXIT-The actual number of iterations performed
C     FMAX-Residual norm
C     C   -Upper unit triangular matrix which approximates the
C          forward triangularization of the full Jacobian matrix.
C          stored in a vector with dimension at least N*(N+1)/2.
C     B   -Contains the residuals (function values) divided
C          by the corresponding components of the P vector
C     P   -Array used to store the partial derivatives. After
C          each iteration P(K) contains the maximal derivative
C          occurring in the K-th reduced equation.
C     TEMP-Array used to store the previous solution iterate.
C     X   -Solution vector. Contains the values achieved on the
C          last iteration loop upon exit from SOS.
C     Y   -Array containing the solution increments.
C     FAC -Array containing factors used in computing numerical
C          derivatives.
C     IS  -Records the pivotal information (column interchanges)
C
C **********************************************************************
C *** Three machine dependent parameters appear in this subroutine.
C
C *** The smallest positive magnitude, zero, is defined by the function
C *** routine R1MACH(1).
C
C *** URO, The computer unit roundoff value, is defined by R1MACH(3) for
C *** machines that round or R1MACH(4) for machines that truncate.
C *** URO is the smallest positive number such that 1.+URO  .GT.  1.
C
C *** The output tape unit number, LOUN, is defined by the function
C *** I1MACH(2).
C **********************************************************************
C
C***SEE ALSO  SOS
C***ROUTINES CALLED  I1MACH, R1MACH, SOSSOL
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SOSEQS
C
C
      DIMENSION S(*), C(NC), B(*), IS(*), P(*), TEMP(*), X(*), Y(*),
     1          FAC(*)
C
C***FIRST EXECUTABLE STATEMENT  SOSEQS
      URO = R1MACH(4)
      LOUN = I1MACH(2)
      ZERO = R1MACH(1)
      RE = MAX(RTOLX,URO)
      SRURO = SQRT(URO)
C
      IFLAG = 0
      NP1 = N + 1
      ICR = 0
      IC = 0
      ITRY = NCJS
      YN1 = 0.
      YN2 = 0.
      YN3 = 0.
      YNS = 0.
      MIT = 0
      FN1 = 0.
      FN2 = 0.
      FMXS = 0.
C
C     INITIALIZE THE INTERCHANGE (PIVOTING) VECTOR AND
C     SAVE THE CURRENT SOLUTION APPROXIMATION FOR FUTURE USE.
C
      DO 10 K=1,N
        IS(K) = K
        X(K) = S(K)
        TEMP(K) = X(K)
   10 CONTINUE
C
C
C    *****************************************
C    **** BEGIN PRINCIPAL ITERATION LOOP  ****
C    *****************************************
C
      DO 330 M=1,MXIT
C
        DO 20 K=1,N
          FAC(K) = SRURO
   20   CONTINUE
C
   30   KN = 1
        FMAX = 0.
C
C
C    ******** BEGIN SUBITERATION LOOP DEFINING THE LINEARIZATION OF EACH
C    ******** EQUATION WHICH RESULTS IN THE CONSTRUCTION OF AN UPPER
C    ******** TRIANGULAR MATRIX APPROXIMATING THE FORWARD
C    ******** TRIANGULARIZATION OF THE FULL JACOBIAN MATRIX
C
        DO 170 K=1,N
          KM1 = K - 1
C
C     BACK-SOLVE A TRIANGULAR LINEAR SYSTEM OBTAINING
C     IMPROVED SOLUTION VALUES FOR K-1 OF THE VARIABLES
C     FROM THE FIRST K-1 EQUATIONS. THESE VARIABLES ARE THEN
C     ELIMINATED FROM THE K-TH EQUATION.
C
          IF (KM1 .EQ. 0) GO TO 50
          CALL SOSSOL(K, N, KM1, Y, C, B, KN)
          DO 40 J=1,KM1
            JS = IS(J)
            X(JS) = TEMP(JS) + Y(J)
   40     CONTINUE
C
C
C     EVALUATE THE K-TH EQUATION AND THE INTERMEDIATE COMPUTATION
C     FOR THE MAX NORM OF THE RESIDUAL VECTOR.
C
   50     F = FNC(X,K)
          FMAX = MAX(FMAX,ABS(F))
C
C     IF WE WISH TO PERFORM SEVERAL ITERATIONS USING A FIXED
C     FACTORIZATION OF AN APPROXIMATE JACOBIAN,WE NEED ONLY
C     UPDATE THE CONSTANT VECTOR.
C
          IF (ITRY .LT. NCJS) GO TO 160
C
C
          IT = 0
C
C     COMPUTE PARTIAL DERIVATIVES THAT ARE REQUIRED IN THE LINEARIZATION
C     OF THE K-TH REDUCED EQUATION
C
          DO 90 J=K,N
            ITEM = IS(J)
            HX = X(ITEM)
            H = FAC(ITEM)*HX
            IF (ABS(H) .LE. ZERO) H = FAC(ITEM)
            X(ITEM) = HX + H
            IF (KM1 .EQ. 0) GO TO 70
            Y(J) = H
            CALL SOSSOL(K, N, J, Y, C, B, KN)
            DO 60 L=1,KM1
              LS = IS(L)
              X(LS) = TEMP(LS) + Y(L)
   60       CONTINUE
   70       FP = FNC(X,K)
            X(ITEM) = HX
            FDIF = FP - F
            IF (ABS(FDIF) .GT. URO*ABS(F)) GO TO 80
            FDIF = 0.
            IT = IT + 1
   80       P(J) = FDIF/H
   90     CONTINUE
C
          IF (IT .LE. (N-K)) GO TO 110
C
C     ALL COMPUTED PARTIAL DERIVATIVES OF THE K-TH EQUATION
C     ARE EFFECTIVELY ZERO.TRY LARGER PERTURBATIONS OF THE
C     INDEPENDENT VARIABLES.
C
          DO 100 J=K,N
            ISJ = IS(J)
            FACT = 100.*FAC(ISJ)
            IF (FACT .GT. 1.E+10) GO TO 340
            FAC(ISJ) = FACT
  100     CONTINUE
          GO TO 30
C
  110     IF (K .EQ. N) GO TO 160
C
C     ACHIEVE A PIVOTING EFFECT BY CHOOSING THE MAXIMAL DERIVATIVE
C     ELEMENT
C
          PMAX = 0.
          DO 120 J=K,N
            TEST = ABS(P(J))
            IF (TEST .LE. PMAX) GO TO 120
            PMAX = TEST
            ISV = J
  120     CONTINUE
          IF (PMAX .EQ. 0.) GO TO 340
C
C     SET UP THE COEFFICIENTS FOR THE K-TH ROW OF THE TRIANGULAR
C     LINEAR SYSTEM AND SAVE THE PARTIAL DERIVATIVE OF
C     LARGEST MAGNITUDE
C
          PMAX = P(ISV)
          KK = KN
          DO 140 J=K,N
            IF (J .EQ. ISV) GO TO 130
            C(KK) = -P(J)/PMAX
  130       KK = KK + 1
  140     CONTINUE
          P(K) = PMAX
C
C
          IF (ISV .EQ. K) GO TO 160
C
C     INTERCHANGE THE TWO COLUMNS OF C DETERMINED BY THE
C     PIVOTAL STRATEGY
C
          KSV = IS(K)
          IS(K) = IS(ISV)
          IS(ISV) = KSV
C
          KD = ISV - K
          KJ = K
          DO 150 J=1,K
            CSV = C(KJ)
            JK = KJ + KD
            C(KJ) = C(JK)
            C(JK) = CSV
            KJ = KJ + N - J
  150     CONTINUE
C
  160     KN = KN + NP1 - K
C
C     STORE THE COMPONENTS FOR THE CONSTANT VECTOR
C
          B(K) = -F/P(K)
C
  170   CONTINUE
C
C    ********
C    ******** END OF LOOP CREATING THE TRIANGULAR LINEARIZATION MATRIX
C    ********
C
C
C     SOLVE THE RESULTING TRIANGULAR SYSTEM FOR A NEW SOLUTION
C     APPROXIMATION AND OBTAIN THE SOLUTION INCREMENT NORM.
C
        KN = KN - 1
        Y(N) = B(N)
        IF (N .GT. 1) CALL SOSSOL(N, N, N, Y, C, B, KN)
        XNORM = 0.
        YNORM = 0.
        DO 180 J=1,N
          YJ = Y(J)
          YNORM = MAX(YNORM,ABS(YJ))
          JS = IS(J)
          X(JS) = TEMP(JS) + YJ
          XNORM = MAX(XNORM,ABS(X(JS)))
  180   CONTINUE
C
C
C     PRINT INTERMEDIATE SOLUTION ITERATES AND RESIDUAL NORM IF DESIRED
C
        IF (IPRINT.NE.(-1)) GO TO 190
        MM = M - 1
        WRITE (LOUN,1234) FMAX, MM, (X(J),J=1,N)
 1234   FORMAT ('0RESIDUAL NORM =', E9.2, /1X, 'SOLUTION ITERATE',
     1   ' (', I3, ')', /(1X, 5E26.14))
  190   CONTINUE
C
C     TEST FOR CONVERGENCE TO A SOLUTION (RELATIVE AND/OR ABSOLUTE ERROR
C     COMPARISON ON SUCCESSIVE APPROXIMATIONS OF EACH SOLUTION VARIABLE)
C
        DO 200 J=1,N
          JS = IS(J)
          IF (ABS(Y(J)) .GT. RE*ABS(X(JS))+ATOLX) GO TO 210
  200   CONTINUE
        IF (FMAX .LE. FMXS) IFLAG = 1
C
C     TEST FOR CONVERGENCE TO A SOLUTION BASED ON RESIDUALS
C
  210   IF (FMAX .GT. TOLF) GO TO 220
        IFLAG = IFLAG + 2
  220   IF (IFLAG .GT. 0) GO TO 360
C
C
        IF (M .GT. 1) GO TO 230
        FMIN = FMAX
        GO TO 280
C
C     SAVE SOLUTION HAVING MINIMUM RESIDUAL NORM.
C
  230   IF (FMAX .GE. FMIN) GO TO 250
        MIT = M + 1
        YN1 = YNORM
        YN2 = YNS
        FN1 = FMXS
        FMIN = FMAX
        DO 240 J=1,N
          S(J) = X(J)
  240   CONTINUE
        IC = 0
C
C     TEST FOR LIMITING PRECISION CONVERGENCE.  VERY SLOWLY CONVERGENT
C     PROBLEMS MAY ALSO BE DETECTED.
C
  250   IF (YNORM .GT. SRURO*XNORM) GO TO 260
        IF ((FMAX .LT. 0.2*FMXS) .OR. (FMAX .GT. 5.*FMXS)) GO TO 260
        IF ((YNORM .LT. 0.2*YNS) .OR. (YNORM .GT. 5.*YNS)) GO TO 260
        ICR = ICR + 1
        IF (ICR .LT. NSRRC) GO TO 270
        IFLAG = 4
        FMAX = FMIN
        GO TO 380
  260   ICR = 0
C
C     TEST FOR DIVERGENCE OF THE ITERATIVE SCHEME.
C
        IF ((YNORM .LE. 2.*YNS) .AND. (FMAX .LE. 2.*FMXS)) GO TO 270
        IC = IC + 1
        IF (IC .LT. NSRI) GO TO 280
        IFLAG = 7
        GO TO 360
  270   IC = 0
C
C     CHECK TO SEE IF NEXT ITERATION CAN USE THE OLD JACOBIAN
C     FACTORIZATION
C
  280   ITRY = ITRY - 1
        IF (ITRY .EQ. 0) GO TO 290
        IF (20.*YNORM .GT. XNORM) GO TO 290
        IF (YNORM .GT. 2.*YNS) GO TO 290
        IF (FMAX .LT. 2.*FMXS) GO TO 300
  290   ITRY = NCJS
C
C     SAVE THE CURRENT SOLUTION APPROXIMATION AND THE RESIDUAL AND
C     SOLUTION INCREMENT NORMS FOR USE IN THE NEXT ITERATION.
C
  300   DO 310 J=1,N
          TEMP(J) = X(J)
  310   CONTINUE
        IF (M.NE.MIT) GO TO 320
        FN2 = FMAX
        YN3 = YNORM
  320   FMXS = FMAX
        YNS = YNORM
C
C
  330 CONTINUE
C
C    *****************************************
C    **** END OF PRINCIPAL ITERATION LOOP ****
C    *****************************************
C
C
C     TOO MANY ITERATIONS, CONVERGENCE WAS NOT ACHIEVED.
      M = MXIT
      IFLAG = 5
      IF (YN1 .GT. 10.0*YN2 .OR. YN3 .GT. 10.0*YN1) IFLAG = 6
      IF (FN1 .GT. 5.0*FMIN .OR. FN2 .GT. 5.0*FMIN) IFLAG = 6
      IF (FMAX .GT. 5.0*FMIN) IFLAG = 6
      GO TO 360
C
C
C     A JACOBIAN-RELATED MATRIX IS EFFECTIVELY SINGULAR.
  340 IFLAG = 8
      DO 350 J=1,N
        S(J) = TEMP(J)
  350 CONTINUE
      GO TO 380
C
C
  360 DO 370 J=1,N
        S(J) = X(J)
  370 CONTINUE
C
C
  380 MXIT = M
      RETURN
      END
*DECK SOSSOL
      SUBROUTINE SOSSOL (K, N, L, X, C, B, M)
C***BEGIN PROLOGUE  SOSSOL
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SOS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SOSSOL-S, DSOSSL-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SOSSOL solves an upper triangular type of linear system by back
C     substitution.
C
C     The matrix C is upper trapezoidal and stored as a linear array by
C     rows. The equations have been normalized so that the diagonal
C     entries of C are understood to be unity. The off diagonal entries
C     and the elements of the constant right hand side vector B have
C     already been stored as the negatives of the corresponding equation
C     values.
C     with each call to SOSSOL a (K-1) by (K-1) triangular system is
C     resolved. For L greater than K, column L of C is included in the
C     right hand side vector.
C
C***SEE ALSO  SOS
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SOSSOL
C
C
      DIMENSION X(*), C(*), B(*)
C
C***FIRST EXECUTABLE STATEMENT  SOSSOL
      NP1 = N + 1
      KM1 = K - 1
      LK = KM1
      IF (L .EQ. K) LK = K
      KN = M
C
C
      DO 40 KJ=1,KM1
        KMM1 = K - KJ
        KM = KMM1 + 1
        XMAX = 0.
        KN = KN - NP1 + KMM1
        IF (KM .GT. LK) GO TO 20
        JKM = KN
C
        DO 10 J=KM,LK
          JKM = JKM + 1
          XMAX = XMAX + C(JKM)*X(J)
   10   CONTINUE
C
   20   IF (L .LE. K) GO TO 30
        JKM = KN + L - KMM1
        XMAX = XMAX + C(JKM)*X(L)
   30   X(KMM1) = XMAX + B(KMM1)
   40 CONTINUE
C
      RETURN
      END

module cubetools_ascii
  use cubetools_parameters
  use cubetools_messaging
  !
  public :: writ_l
  public :: ascii_file_t
  private
  !
  character(len=*), parameter :: readwrite(3) = &
       ['readonly ','writeonly','readwrite']
  integer(kind=code_k), parameter :: read_only  = 1
  integer(kind=code_k), parameter :: write_only = 2
  integer(kind=code_k), parameter :: read_write = 3
  !
  integer(kind=4), parameter :: lun_k = 4
  integer(kind=4), parameter :: line_k = 4
  integer(kind=4), parameter :: writ_l = 256
  !
  type ascii_file_t
     character(len=file_l),private :: name
     integer(kind=code_k), private :: status
     integer(kind=lun_k),  private :: lun
     integer(kind=line_k), private :: iline
     integer(kind=line_k), private :: nline
   contains
     procedure, public :: open       => cubetools_ascii_file_open
     procedure, public :: read_next  => cubetools_ascii_file_read_next
     procedure, public :: write_next => cubetools_ascii_file_write_next
     procedure, public :: get_nline  => cubetools_ascii_file_get_nline
     procedure, public :: close      => cubetools_ascii_file_close
  end type ascii_file_t
  !
contains
  !
  subroutine cubetools_ascii_file_open(file,name,status,error)
    use gkernel_interfaces
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    ! Opens an ASCII file 
    !----------------------------------------------------------------------
    class(ascii_file_t), intent(out)   :: file
    character(len=*),    intent(in)    :: name
    character(len=*),    intent(in)    :: status
    logical,             intent(inout) :: error
    !
    character(len=argu_l) :: argu
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ASCII>FILE>OPEN'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_strict(status,readwrite,file%status,argu,error)
    if (error) return
    !
    ier = sic_getlun(file%lun)
    if (ier.ne.1) then
       call cubetools_message(seve%e,rname,'Cannot allocate LUN')
       error = .true.
       return
    endif
    select case(file%status)
    case(read_only)
       ier = sic_open(file%lun,name,'OLD',.true.)
    case(read_write)
       ier = sic_open(file%lun,name,'OLD',.false.)
    case(write_only)
       ier = sic_open(file%lun,name,'NEW',.false.)
    case default
       call cubetools_message(seve%e,rname,'Unrecognized status')
       error = .true.
       return
    end select
    if (ier.ne.0) then
       call cubetools_message(seve%e,rname,'Cannot open file '//name)
       error = .true.
       return
    endif
    file%name  = name
    file%iline = 0
    file%nline = 0
    !
    if (file%status.eq.read_only.or.file%status.eq.read_write) then
       do while (.true.)
          read(file%lun,*,iostat=ier)
          if (ier.ne.0) exit
          file%nline = file%nline+1
       enddo
       ier = sic_close(file%lun)
       ier = sic_open(file%lun,name,'OLD',.true.)
    endif
  end subroutine cubetools_ascii_file_open
  !
  subroutine cubetools_ascii_file_close(file,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Opens an ASCII file 
    !----------------------------------------------------------------------
    class(ascii_file_t), intent(inout) :: file
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='ASCII>FILE>OPEN'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    ier = sic_close(file%lun)
    call sic_frelun(file%lun)
    file%lun = 0
    file%iline = 0
    file%nline = 0
  end subroutine cubetools_ascii_file_close
  !
  function cubetools_ascii_file_get_nline(file) result(nline)
    !----------------------------------------------------------------------
    ! Gets the number of lines in an ASCII file
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(in) :: file
    integer(kind=line_k)             :: nline
    !
    character(len=*), parameter :: rname='ASCII>FILE>GET_NLINE'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    nline = file%nline
  end function cubetools_ascii_file_get_nline
  !
  subroutine cubetools_ascii_file_read_next(file,line,error)
    !----------------------------------------------------------------------
    ! reads next line from an ASCII file
    ! Caveat: Line can only be up to 100 characters
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(inout) :: file
    character(len=*),     intent(out)   :: line
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ASCII>FILE>READ>NEXT'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    file%iline = file%iline+1
    if (file%iline.gt.file%nline) then
       call cubetools_message(seve%e,rname,'Trying to read beyond end of the file')
       error = .true.
       return
    endif
    read(file%lun,'(a)') line
  end subroutine cubetools_ascii_file_read_next
  !
  subroutine cubetools_ascii_file_write_next(file,line,error)
    !----------------------------------------------------------------------
    ! write next line to an ASCII file
    !----------------------------------------------------------------------
    class(ascii_file_t),  intent(inout) :: file
    character(len=*),     intent(in)    :: line
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ASCII>FILE>WRITE>NEXT'
    !
    call cubetools_message(toolseve%trace,rname,'Welcome')
    !
    write(file%lun,'(a)') trim(line)
    file%iline = file%iline+1
    file%nline = file%nline+1
  end subroutine cubetools_ascii_file_write_next
end module cubetools_ascii

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_beam_tool
  use gbl_message
  !
  public :: beam_plane,beam_for_channel,get_beam,find_sidelobe
  public :: init_convolve,convolve
  private
  !
contains
  !
  subroutine beam_plane(method,hbeam,hdirty)
    use image_def
    use clean_types
    !----------------------------------------------------------------
    ! Define beam plane and check if fit is required
    !----------------------------------------------------------------
    type(clean_par), intent(inout) :: method
    type(gildas),    intent(in)    :: hbeam
    type(gildas),    intent(in)    :: hdirty ! Used to figure out which plane
    !
    integer :: ibeam
    !
    ! Check if beam parameters must be recomputed
    if (hbeam%gil%dim(4).le.1) then
       method%ibeam = 1
    else
       ! Cannot set method%ibeam  directly ?
       ibeam = beam_for_channel(method%iplane,hdirty,hbeam)
       !!call map_message(seve%w,'CLEAN','Recomputing the beam parameters')
       method%ibeam = ibeam
       !! print *,'IBEAM ',method%ibeam,'... '
    endif
  end subroutine beam_plane
  !
  function beam_for_channel(iplane,hdirty,hbeam)
    use image_def
    !----------------------------------------------------------------
    !
    !----------------------------------------------------------------
    integer                  :: beam_for_channel ! intent(out)
    type(gildas), intent(in) :: hdirty
    type(gildas), intent(in) :: hbeam
    integer,      intent(in) :: iplane
    !
    integer :: ibeam,nstep
    real(8) :: i_freq
    !
    if (hbeam%gil%dim(4).le.1) then
       beam_for_channel = 1
    else
       nstep = hdirty%gil%dim(3) / hbeam%gil%dim(4)
       if (hbeam%gil%dim(4)*nstep.ne.hdirty%gil%dim(3)) nstep = nstep+1
       ibeam = (iplane+nstep-1)/nstep
       !!print *,'Approximate Beam channel ',ibeam,' for ',iplane
       ! This may be the better way of doing it:
       i_freq = (iplane-hdirty%gil%ref(3))*hdirty%gil%fres + hdirty%gil%freq
       ! i_freq = (ibeam-hbeam%gil%ref(4))*hbeam%gil%fres + hbeam%gil%freq
       ibeam = nint((i_freq-hbeam%gil%freq)/hbeam%gil%fres + hbeam%gil%ref(4))
       !!print *,'Nearest Beam channel ',ibeam,' for ',iplane
       ibeam = min(max(1,ibeam),hbeam%gil%dim(4)) ! Just  in case
       !
       beam_for_channel = ibeam
    endif
  end function beam_for_channel
  !
  subroutine get_beam(method,hbeam,hresid,hprim,tfbeam,w_work,w_fft,fhat,error,mask)
    use image_def
    use gkernel_interfaces
    use minmax_tool, only: maxmap
    use clean_types
    !-----------------------------------------------------------------
    ! Get beam related information
    !-----------------------------------------------------------------
    type(clean_par),   intent(inout) :: method
    type(gildas),      intent(in)    :: hbeam
    type(gildas),      intent(in)    :: hresid
    type(gildas),      intent(in)    :: hprim
    real,              intent(inout) :: tfbeam(hbeam%gil%dim(1),hbeam%gil%dim(2),hbeam%gil%dim(3))
    complex,           intent(inout) :: w_work(hbeam%gil%dim(1),hbeam%gil%dim(2))
    real,              intent(inout) :: fhat,w_fft(:)
    logical,           intent(inout) :: error
    logical, optional, intent(inout) :: mask(:,:)
    !
    ! Note that HRESID is unused here...
    logical :: do_fft
    integer :: ip,ib,nx,ny,np,nb
    integer :: ix_min,ix_max,iy_min,iy_max
    real :: beam_min,beam_max,beam_area,f
    real, pointer :: d2beam(:,:)      ! Beam (single field & frequency)
    real, pointer :: d3prim(:,:,:)    ! Primary beams (per frequency)
    real, pointer :: d3beam(:,:,:)    ! Dirty beam (per frequency)
    real, pointer :: weight(:,:,:)
    character(len=message_length) :: chain
    character(len=*), parameter :: rname='GET>BEAM'
    !
    nx = hbeam%gil%dim(1)
    ny = hbeam%gil%dim(2)
    np = hbeam%gil%dim(3)
    nb = hbeam%gil%dim(4)
    !
    weight=> method%weight
    do_fft = method%method.ne.'HOGBOM' .and. method%method.ne.'MX'
    !
    if (method%mosaic) then
       if (.not.present(mask)) then
          call map_message(seve%f,rname,'Programming error: Missing MASK argument with MOSAIC mode')
          error = .true.
          return
       endif
       !
       d3beam => hbeam%r4d(:,:,:,method%ibeam)
       !
       np = hprim%gil%dim(1)
       !
       ! Analyze beam
       do ip = 1,np
          if (method%verbose) then
             write(chain,101) 'Field ',ip,'/',np
             call map_message(seve%i,rname,chain)
          endif
          call maxmap(d3beam(:,:,ip),nx,ny,method%bzone,&
               beam_max,ix_max,iy_max,beam_min,ix_min,iy_min)
          if (method%verbose) then
             write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
                  'Beam max. ',beam_max,' at ',ix_max,iy_max,  &
                  ', Min. ',beam_min,' at ',ix_min,iy_min
             call map_message(seve%i,rname,chain)
          endif
          if (do_fft) then
             call init_convolve(ix_max,iy_max,nx,ny,   &
                  d3beam(:,:,ip),w_work,beam_area,w_fft)
             tfbeam(:,:,ip) = real(w_work)
             if (method%verbose) then
                write(chain,102) 'Beam area is ',beam_area
                call map_message(seve%i,rname,chain)
             endif
          endif
          !
          ! Prussian Hat - NOT SUPPORTED HERE
       enddo
       !
       if (method%method.ne.'HOGBOM') then
          call mos_sidelobe(d3beam(:,:,1),nx,ny,ix_max,iy_max,   &
               method%patch(1),method%patch(2),method%bgain,np)
          write(chain,102) 'Sidelobe is ',method%bgain
          call map_message(seve%i,rname,chain)
       endif
       !
       ! Define the weight function and truncate the mask
       do ib=1,nb
          d3prim => hprim%r4d(:,:,:,ib)
          call set_weight(nx,ny,np,weight(:,:,ib),d3prim,mask,   &
               method%search,method%restor,method%trunca)
       enddo
    else
       d2beam  => hbeam%r4d(:,:,1,method%ibeam)
       if (method%verbose) then
          print *,'Beam center ',hbeam%r4d(nx/2+1,ny/2+1,1,method%ibeam)
       endif
       !
       ! Simple case
       call maxmap(d2beam,nx,ny,method%bzone,   &
            beam_max,ix_max,iy_max,   &
            beam_min,ix_min,iy_min)
       if (method%verbose) then
          write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
               'Beam max. ',beam_max,' at ',ix_max,iy_max,  &
               ', Min. ',beam_min,' at ',ix_min,iy_min
          call map_message(seve%i,rname,chain)
       endif
       if (beam_max.eq.0.0) then
          call map_message(seve%w,rname,'Beam is empty')
          error = .true.
          return
       endif
       call comshi(d2beam,nx,ny,ix_max,iy_max,method%bshift)
       if (do_fft) then
          call init_convolve(ix_max,iy_max,nx,ny,   &
               d2beam,w_work,beam_area,w_fft)
          tfbeam(:,:,1)  = real(w_work)
          if (method%verbose) then
             write(chain,102) 'Beam area is ',beam_area
             call map_message(seve%i,rname,chain)
          endif
       endif
       !
       ! Prussian Hat
       if (method%phat.ne.0) then
          d2beam(ix_max,iy_max) = d2beam(ix_max,iy_max) + method%phat
          f = 1.0/d2beam(ix_max,iy_max)
          d2beam(:,:) = d2beam*f
       else
          f = 1.0
       endif
       !
       if (method%method.ne.'HOGBOM') then
          call find_sidelobe (d2beam,nx,ny,ix_max,iy_max,   &
               method%patch(1),method%patch(2),method%bgain)
          write(chain,102) 'Sidelobe is ',method%bgain
          call map_message(seve%i,rname,chain)
       endif
    endif
    method%beam0 = (/ix_max,iy_max/)
    if (method%phat.ne.0) fhat = f
    error = .false.
    return
    !
101 format(a,i3,a,i3)
102 format(a,1pg10.3,a,i6,i6)
  end subroutine get_beam
!
subroutine set_weight(nx,ny,np,weight,primary,mask,wsear,wrest,wmin)
  !---------------------------------------------------
  ! Set the mosaic weights
  !---------------------------------------------------
  integer, intent(in) :: nx  ! X size
  integer, intent(in) :: ny  ! Y size 
  integer, intent(in) :: np  ! Number of pointings
  real, intent(out) ::  weight(nx,ny)     ! Weight map
  real, intent(in) ::  primary(np,nx,ny)  ! Primary beams
  real, intent(in) ::  wsear              ! Search threshold
  real, intent(in) ::  wrest              ! Restore threshold   
  real, intent(in) ::  wmin               ! Minimum beal value  
  logical, intent(inout) ::  mask(nx,ny)  ! Search mask
  !
  real wr,ws2,wr2
  integer i,j,ip
  character(len=80) :: chain
  !
  write(chain,'(A,1pg10.3,1x,1pg10.3,1x,1pg10.3)') &
      &   'Thresholds ',wsear,wrest,wmin
  call map_message(seve%i,'CLEAN',chain)
  wr2 = wrest                  !*WREST
  ws2 = wsear
  !
  ! Compute the "weigt" function 1/N
  do j=1,ny
    do i=1,nx
      wr = 0.0
      do ip=1,np
        if (primary(ip,i,j).gt.wmin) then
          wr = wr+primary(ip,i,j)*primary(ip,i,j)
        endif
      enddo
      ! Cut the search mask
      if (wr.le.ws2) mask(i,j) = .false.
      ! Cut the restore area if it is not a search area also
      if (wr.le.wr2 .and. .not.mask(i,j)) wr = 0.0
      ! Convert to the 1/N function
      if (wr.ne.0.0) then
        weight(i,j) = 1.0/sqrt(wr)
      else
        weight(i,j) = 0.0
      endif
    enddo
  enddo
end subroutine set_weight
  !
  subroutine comshi(beam,nx,ny,ix,iy,shift)
    !-----------------------------------------------------
    ! Shift beam if needed
    !-----------------------------------------------------
    integer, intent(in)  :: nx,ny       ! X,Y Size
    integer, intent(in)  :: ix,iy       ! Position of maximum
    real,    intent(in)  :: beam(nx,ny) ! Beam
    integer, intent(out) :: shift(3)    ! Shift information
    !
    real :: tol
    !
    ! Attempt to find where is the true maximum of the (SYMMETRIC) beam
    ! based on a fit by a parabola in 9 points around maximum
    !
    tol = 1e-4*beam(ix,iy)
    shift(3) = 1
    if (abs(beam(ix-1,iy-1)-beam(ix+1,iy+1)).lt.tol) then
       shift(1) = 0
       shift(2) = 0
       shift(3) = 0
    elseif (abs(beam(ix+1,iy+1)-beam(ix,iy)).lt.tol) then
       shift(1) = 1
       shift(2) = 1
    elseif (abs(beam(ix-1,iy-1)-beam(ix,iy)).lt.tol) then
       shift(1) = -1
       shift(2) = -1
    elseif (abs(beam(ix+1,iy-1)-beam(ix,iy)).lt.tol) then
       shift(1) =  1
       shift(2) = -1
    elseif (abs(beam(ix-1,iy+1)-beam(ix,iy)).lt.tol) then
       shift(1) = -1
       shift(2) = 1
    elseif (abs(beam(ix+1,iy-1)-beam(ix,iy+1)).lt.tol) then
       shift(1) = 1
       shift(2) = 0
    elseif (abs(beam(ix-1,iy-1)-beam(ix,iy+1)).lt.tol) then
       shift(1) = -1
       shift(2) = 0
    elseif (abs(beam(ix-1,iy-1)-beam(ix+1,iy)).lt.tol) then
       shift(1) = 0
       shift(2) = -1
    elseif (abs(beam(ix-1,iy+1)-beam(ix+1,iy)).lt.tol) then
       shift(1) = 0
       shift(2) = 1
    else
       call map_message(seve%w,'SHIFT','Unknown beam symmetry')
       shift(1) = 0
       shift(2) = 0
       shift(3) = 0
    endif
  end subroutine comshi
  !
  subroutine find_sidelobe(beam,nx,ny,i0,j0,nxp,nyp,bgain)
    !----------------------------------------------------------------------
    ! Find the maximum sidelobe outside the beam patch defined by the beam
    ! center (I0,J0) and patch size (NXP,NYP)
    !----------------------------------------------------------------------
    integer, intent(in)  :: nx          ! X size
    integer, intent(in)  :: ny          ! Y size
    real,    intent(in)  :: beam(nx,ny) ! Input beam
    integer, intent(in)  :: i0          ! X beam center
    integer, intent(in)  :: j0          ! Y beam center
    integer, intent(in)  :: nxp         ! X beam patch
    integer, intent(in)  :: nyp         ! Y beam patch
    real,    intent(out) :: bgain       ! Maximum sidelobe
    !
    integer :: i,j
    real :: bmax,bmin
    !
    ! Compute maximum sidelobe
    bmax = beam(1,1)
    bmin = beam(1,1)
    do j = 1,j0-nyp
       do i = 1,nx
          if (beam(i,j).gt.bmax) then
             bmax = beam(i,j)
          elseif (beam(i,j).lt.bmin) then
             bmin = beam(i,j)
          endif
       enddo
    enddo
    do j = max(1,j0-nyp+1),min(ny,j0+nyp-1)
       do i = 1,i0-nxp
          if (beam(i,j).gt.bmax) then
             bmax = beam(i,j)
          elseif (beam(i,j).lt.bmin) then
             bmin = beam(i,j)
          endif
       enddo
       do i = i0+nxp,nx
          if (beam(i,j).gt.bmax) then
             bmax = beam(i,j)
          elseif (beam(i,j).lt.bmin) then
             bmin = beam(i,j)
          endif
       enddo
    enddo
    do j = j0+nyp,ny
       do i = 1,nx
          if (beam(i,j).gt.bmax) then
             bmax = beam(i,j)
          elseif (beam(i,j).lt.bmin) then
             bmin = beam(i,j)
          endif
       enddo
    enddo
    bgain = max(abs(bmax),abs(bmin))
    bgain = bgain/abs(beam(i0,j0))
  end subroutine find_sidelobe
  !
  subroutine mos_sidelobe(beam,nx,ny,i0,j0,nxp,nyp,bgain,nf)
    !----------------------------------------------------------------------
    ! Find the maximum sidelobe outside the beam patch defined by the beam
    ! center (I0,J0) and patch size (NXP,NYP)
    !
    ! Adapted for Mosaic
    !----------------------------------------------------------------------
    integer :: nx,ny,i0,j0,nxp,nyp,nf
    real    :: beam(nx,ny,nf),bgain
    !
    integer :: i,j,k
    real :: bmax,bmin
    !
    ! Compute maximum sidelobe
    bmax = 0
    bmin = 0
    do k = 1,nf
       do j = 1,j0-nyp
          do i = 1,nx
             if (beam(i,j,k).gt.bmax) then
                bmax = beam(i,j,k)
             elseif (beam(i,j,k).lt.bmin) then
                bmin = beam(i,j,k)
             endif
          enddo
       enddo
       do j = max(1,j0-nyp+1),min(ny,j0+nyp-1)
          do i = 1,i0-nxp
             if (beam(i,j,k).gt.bmax) then
                bmax = beam(i,j,k)
             elseif (beam(i,j,k).lt.bmin) then
                bmin = beam(i,j,k)
             endif
          enddo
          do i = i0+nxp,nx
             if (beam(i,j,k).gt.bmax) then
                bmax = beam(i,j,k)
             elseif (beam(i,j,k).lt.bmin) then
                bmin = beam(i,j,k)
             endif
          enddo
       enddo
       do j = j0+nyp,ny
          do i = 1,nx
             if (beam(i,j,k).gt.bmax) then
                bmax = beam(i,j,k)
             elseif (beam(i,j,k).lt.bmin) then
                bmin = beam(i,j,k)
             endif
          enddo
       enddo
    enddo
    bgain = max(abs(bmax),abs(bmin))
    bgain = bgain/abs(beam(i0,j0,1))
  end subroutine mos_sidelobe
  !
subroutine init_convolve(i0,j0,nx,ny,beam,fbeam,area,work)
  !----------------------------------------------------------------------
  ! Compute the FT of a beam centered on pixel I0,J0
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny          ! Problem size
  integer, intent(in) :: i0,j0          ! Position of peak
  complex, intent(out) :: fbeam(nx,ny)  ! TF of beam
  real, intent(in) :: beam(nx,ny)       ! Beam
  real, intent(inout) :: work(*)        ! Work space
  real, intent(out) :: area             ! Beam area
  !
  integer i,j,nn(2),ndim
  real fact
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  fact = 1.0/float(nx*ny)
  do j=1,j0-1
    do i=1,i0-1
      fbeam(i+nx-i0+1,j+ny-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
    do i=i0, nx
      fbeam(i-i0+1,j+ny-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
  enddo
  do j=j0,ny
    do i=1,i0-1
      fbeam(i+nx-i0+1,j-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
    do i=i0,nx
      fbeam(i-i0+1,j-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
  enddo
  call fourt(fbeam,nn,ndim,-1,0,work)
  area = real(fbeam(1,1))/beam(i0,j0)
end subroutine init_convolve
!
subroutine convolve (image,dirty,nx,ny,fbeam,fcomp,wfft)
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  ! Convolve an image by a beam through Fourier Transform
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny          ! Problem size
  complex, intent(in) :: fbeam(nx,ny)    ! Beam TF
  complex, intent(inout) :: fcomp(nx,ny) ! TF workspace
  real, intent(in) :: image(nx,ny)      ! Input image
  real, intent(out) :: dirty(nx,ny)     ! Convolved image
  real, intent(inout) :: wfft(*)        ! Work area
  !
  integer :: ndim,nn(2)
  !
  ! Reset
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  fcomp = cmplx(image,0.0)
  !
  ! Direct TF
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  !
  ! Multiplication (note normalisation done in FBEAM)
  fcomp = fcomp*fbeam
  !!do j=1,ny
  !!  do i=1,nx
  !!    reel = fbeam(1,i,j)*fcomp(1,i,j) - fbeam(2,i,j)*fcomp(2,i,j)
  !!    imag = fbeam(2,i,j)*fcomp(1,i,j) + fbeam(1,i,j)*fcomp(2,i,j)
  !!    fcomp(1,i,j) = reel
  !!    fcomp(2,i,j) = imag
  !!  enddo
  !!enddo
  !
  ! Reverse TF
  call fourt(fcomp,nn,ndim,1,1,wfft)
  !
  ! Dirty map
  dirty = real(fcomp)
end subroutine convolve
end module clean_beam_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mrtindex_variable_entry(struct,head,ro,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Map a Sic structure on an entry
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: struct  ! Structure name
  type(mrtindex_header_t), intent(inout) :: head    !
  logical,                 intent(in)    :: ro      ! Read-Only?
  logical,                 intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  !
  userreq = .false.
  !
  call sic_delvariable(struct,userreq,error)
  call sic_defstructure(struct,.true.,error)
  if (error)  return
  !
  call mrtindex_variable_entry_key(struct,head%key,ro,error)
  if (error)  return
  call mrtindex_variable_entry_prim(struct,head%pri,ro,error)
  if (error)  return
  call head%cal%variable(struct,ro,error)
  if (error)  return
  call head%sci%variable(struct,ro,error)
  if (error)  return
  call head%poi%variable(struct,ro,error)
  if (error)  return
  !
end subroutine mrtindex_variable_entry
!
subroutine mrtindex_variable_entry_key(struct,key,ro,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_key
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: struct  ! Structure name
  type(mrtindex_key_t), intent(in)    :: key     !
  logical,            intent(in)    :: ro      ! Read-Only?
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  integer(kind=index_length) :: dims(sic_maxdims)
  !
  userreq = .false.
  str = trim(struct)//'%KEY'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_inte (trim(str)//'%VERSION',     key%version,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%TELESCOPE',   key%telescope,   0,0,   ro,error)
  call sic_def_char (trim(str)//'%PROJID',      key%projid,             ro,error)
  call sic_def_char (trim(str)//'%SOURCE',      key%source,             ro,error)
  call sic_def_inte (trim(str)//'%DOBS',        key%dobs,        0,0,   ro,error)
  call sic_def_dble (trim(str)//'%UT',          key%ut,          0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LST',         key%lst,         0,0,   ro,error)
  call sic_def_real (trim(str)//'%AZ',          key%az,          0,0,   ro,error)
  call sic_def_real (trim(str)//'%EL',          key%el,          0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LON',         key%lon,         0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LAT',         key%lat,         0,0,   ro,error)
  call sic_def_inte (trim(str)//'%SYSTEM',      key%system,      0,0,   ro,error)
  call sic_def_real (trim(str)//'%EQUINOX',     key%equinox,     0,0,   ro,error)
  dims(1) = mrtcal_indx_mfrontend
  call sic_def_charn(trim(str)//'%FRONTEND',    key%frontend,    1,dims,ro,error)
  call sic_def_inte (trim(str)//'%SCAN',        key%scan,        0,0,   ro,error)
  call sic_def_inte (trim(str)//'%BACKEND',     key%backend,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%OBSTYPE',     key%obstype,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%SWITCHMODE',  key%switchmode,  0,0,   ro,error)
  call sic_def_inte (trim(str)//'%POLARIMETRY', key%polstatus,   0,0,   ro,error)
  call sic_def_inte (trim(str)//'%FILSTATUS',   key%filstatus,   0,0,   ro,error)
  call sic_def_inte (trim(str)//'%CALSTATUS',   key%calstatus,   0,0,   ro,error)
  call sic_def_inte (trim(str)//'%SOLSTATUS',   key%solstatus,   0,0,   ro,error)
  call sic_def_char (trim(str)//'%FILENAME',    key%filename,           ro,error)
  !
end subroutine mrtindex_variable_entry_key
!
subroutine mrtindex_variable_entry_prim(struct,prim,ro,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_prim
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: struct  ! Structure name
  type(sec_primary_t), intent(in)    :: prim    !
  logical,             intent(in)    :: ro      ! Read-Only?
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  !
  userreq = .false.
  str = trim(struct)//'%PRI'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_real(trim(str)//'%IMBFVERS',prim%imbfvers,0,0,ro,error)
  !
end subroutine mrtindex_variable_entry_prim
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_variable_index(cx,error)
  use mrtindex_types
  use mrtindex_interfaces, except_this=>mrtindex_variable_index
  !---------------------------------------------------------------------
  ! @ public
  ! Support for command
  !  VARIABLE /INDEX
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  !
  ! Delete support variables
  call mrtindex_variable_index_delvar(error)
  if (error)  return
  !
  call mrtindex_variable_index_fill(cx,error)
  if (error)  return
  !
  ! Create support variables
  call mrtindex_variable_index_defvar(cx,error)
  if (error)  return
end subroutine mrtindex_variable_index
!
subroutine mrtindex_variable_index_delvar(error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_index_delvar
  !---------------------------------------------------------------------
  ! @ private
  ! Delete variables (structures) in MDX%HEAD%
  !---------------------------------------------------------------------
  logical, intent(inout) :: error               !
  !
  call sic_delvariable('MDX%HEAD%KEY',.false.,error)
  call sic_delvariable('MDX%HEAD%PRI',.false.,error)
  call sic_delvariable('MDX%HEAD%CAL',.false.,error)
  call sic_delvariable('MDX%HEAD%SCI',.false.,error)
  call sic_delvariable('MDX%HEAD%POI',.false.,error)
  if (error)  return
end subroutine mrtindex_variable_index_delvar
!
subroutine mrtindex_variable_index_reallocate(mfreq,mset,mpix,msol,nent,error)
  use mrtindex_types
  use mrtindex_array_types
  use mrtindex_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Reallocate (if needed) the MDX support arrays, section by section.
  ! nent <= 0 means deallocate only.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: mfreq  !
  integer(kind=4), intent(in)    :: mset   !
  integer(kind=4), intent(in)    :: mpix   !
  integer(kind=4), intent(in)    :: msol   ! Maximum number of solutions to be stored for pointing
  integer(kind=8), intent(in)    :: nent   ! Size of reallocation
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REALLOCATE'
  logical :: realloc
  integer(kind=4) :: ier
  !
  ! --- Key ------------------------------------------------------------
  if (allocated(mdxhead%key%version)) then
    realloc = size(mdxhead%key%version).lt.nent
    if (nent.le.0 .or. realloc) then
      deallocate(mdxhead%key%version,  mdxhead%key%telescope,mdxhead%key%projid)
      deallocate(mdxhead%key%source,   mdxhead%key%dobs,     mdxhead%key%ut)
      deallocate(mdxhead%key%lst,      mdxhead%key%az,       mdxhead%key%el)
      deallocate(mdxhead%key%lon,      mdxhead%key%lat,      mdxhead%key%system)
      deallocate(mdxhead%key%equinox,  mdxhead%key%frontend, mdxhead%key%scan)
      deallocate(mdxhead%key%backend,  mdxhead%key%obstype,  mdxhead%key%switchmode)
      deallocate(mdxhead%key%polstatus,mdxhead%key%filstatus,mdxhead%key%calstatus)
      deallocate(mdxhead%key%solstatus,mdxhead%key%filename)
    endif
  else
    realloc = nent.gt.0
  endif
  !
  if (realloc) then
    allocate(mdxhead%key%version(nent),  mdxhead%key%telescope(nent), stat=ier)
    allocate(mdxhead%key%projid(nent),   mdxhead%key%source(nent),    stat=ier)
    allocate(mdxhead%key%dobs(nent),     mdxhead%key%ut(nent),        stat=ier)
    allocate(mdxhead%key%lst(nent),      mdxhead%key%az(nent),        stat=ier)
    allocate(mdxhead%key%el(nent),       mdxhead%key%lon(nent),       stat=ier)
    allocate(mdxhead%key%lat(nent),      mdxhead%key%system(nent),    stat=ier)
    allocate(mdxhead%key%equinox(nent),                               stat=ier)
    allocate(mdxhead%key%frontend(mrtcal_indx_mfrontend,nent),        stat=ier)
    allocate(mdxhead%key%scan(nent),     mdxhead%key%backend(nent),   stat=ier)
    allocate(mdxhead%key%obstype(nent),  mdxhead%key%switchmode(nent),stat=ier)
    allocate(mdxhead%key%polstatus(nent),mdxhead%key%filstatus(nent), stat=ier)
    allocate(mdxhead%key%calstatus(nent),mdxhead%key%solstatus(nent), stat=ier)
    allocate(mdxhead%key%filename(nent),                              stat=ier)
    if (failed_allocate(rname,'MDX%HEAD%Key arrays',ier,error))  return
  endif
  !
  ! --- Calibration ----------------------------------------------------
  call mdxhead%cal%reallocate(mfreq,mset,mpix,nent,error)
  if (error)  return
  !
  ! --- Science --------------------------------------------------------
  call mdxhead%sci%reallocate(nent,error)
  if (error)  return
  !
  ! --- Pointing -------------------------------------------------------
  call mdxhead%poi%reallocate(msol,nent,error)
  if (error)  return
  !
end subroutine mrtindex_variable_index_reallocate
!
subroutine mrtindex_variable_index_fill(cx,error)
  use gbl_message
  use mrtindex_types
  use mrtindex_array_types
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_index_fill
  !---------------------------------------------------------------------
  ! @ private
  ! Fill the section arrays for the MDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  type(mrtindex_entry_t) :: entry
  integer(kind=4) :: mfreq,mset,mpix,msol
  integer(kind=entry_length) :: ient
  !
  if (cx%next.le.1) then
    call mrtindex_message(seve%w,rname,'Current index is empty')
    return
  endif
  !
  ! Compute maximum number of pointing solutions. If you feel the
  ! computing cost is too large you can use an arbitrary large enough
  ! size instead
  mfreq = 0
  mset = 0
  mpix = 0
  msol = 0
  do ient=1,cx%next-1
    call mrtindex_optimize_to_entry(cx,ient,entry,error)
    if (error)  return
    if (entry%head%cal%nfreq.gt.mfreq)  mfreq = entry%head%cal%nfreq
    if (entry%head%cal%nset.gt.mset)    mset = entry%head%cal%nset
    if (entry%head%cal%npix.gt.mpix)    mpix = entry%head%cal%npix
    if (entry%head%poi%nsol.gt.msol)    msol = entry%head%poi%nsol
  enddo
  !
  ! (Re)allocations
  call mrtindex_variable_index_reallocate(mfreq,mset,mpix,msol,cx%next-1,error)
  if (error)  return
  !
  ! (Re)fill
  do ient=1,cx%next-1
    call mrtindex_optimize_to_entry(cx,ient,entry,error)
    if (error)  return
    !
    ! --- Key ----------------------------------------------------------
    mdxhead%key%version(ient)    = entry%head%key%version
    mdxhead%key%telescope(ient)  = entry%head%key%telescope
    mdxhead%key%projid(ient)     = entry%head%key%projid
    mdxhead%key%source(ient)     = entry%head%key%source
    mdxhead%key%dobs(ient)       = entry%head%key%dobs
    mdxhead%key%ut(ient)         = entry%head%key%ut
    mdxhead%key%lst(ient)        = entry%head%key%lst
    mdxhead%key%az(ient)         = entry%head%key%az
    mdxhead%key%el(ient)         = entry%head%key%el
    mdxhead%key%lon(ient)        = entry%head%key%lon
    mdxhead%key%lat(ient)        = entry%head%key%lat
    mdxhead%key%system(ient)     = entry%head%key%system
    mdxhead%key%equinox(ient)    = entry%head%key%equinox
    mdxhead%key%frontend(:,ient) = entry%head%key%frontend(:)
    mdxhead%key%scan(ient)       = entry%head%key%scan
    mdxhead%key%backend(ient)    = entry%head%key%backend
    mdxhead%key%obstype(ient)    = entry%head%key%obstype
    mdxhead%key%switchmode(ient) = entry%head%key%switchmode
    mdxhead%key%polstatus(ient)  = entry%head%key%polstatus
    mdxhead%key%filstatus(ient)  = entry%head%key%filstatus
    mdxhead%key%calstatus(ient)  = entry%head%key%calstatus
    mdxhead%key%solstatus(ient)  = entry%head%key%solstatus
    mdxhead%key%filename(ient)   = entry%head%key%filename
    !
    ! --- Calibration --------------------------------------------------
    call mdxhead%cal%set(ient,entry%head%cal,error)
    if (error)  return
    !
    ! --- Science ------------------------------------------------------
    call mdxhead%sci%set(ient,entry%head%sci,error)
    if (error)  return
    !
    ! --- Pointing -----------------------------------------------------
    call mdxhead%poi%set(ient,entry%head%poi,error)
    if (error)  return
  enddo

end subroutine mrtindex_variable_index_fill
!
subroutine mrtindex_variable_index_defvar(cx,error)
  use mrtindex_types
  use mrtindex_array_types
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_index_defvar
  !---------------------------------------------------------------------
  ! @ private
  ! Create the sections in the MDX%HEAD% Sic structure
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  ! Local
  character(len=10) :: struct
  integer(kind=index_length) :: dims(4)
  !
  if (.not.sic_varexist('MDX')) then
    call sic_defstructure('MDX',.true.,error)
    if (error)  return
  endif
  !
  struct = 'MDX%HEAD'
  if (.not.sic_varexist(struct)) then
    call sic_defstructure(struct,.true.,error)
    if (error)  return
  endif
  !
  ! --- Key ------------------------------------------------------------
  call sic_defstructure(trim(struct)//'%KEY',.true.,error)
  if (error)  return
  dims(1) = cx%next-1
  call sic_def_inte (trim(struct)//'%KEY%VERSION',   mdxhead%key%version,   1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%TELESCOPE', mdxhead%key%telescope, 1,dims,.true.,error)
  call sic_def_charn(trim(struct)//'%KEY%PROJID',    mdxhead%key%projid,    1,dims,.true.,error)
  call sic_def_charn(trim(struct)//'%KEY%SOURCE',    mdxhead%key%source,    1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%DOBS',      mdxhead%key%dobs,      1,dims,.true.,error)
  call sic_def_dble (trim(struct)//'%KEY%UT',        mdxhead%key%ut,        1,dims,.true.,error)
  call sic_def_dble (trim(struct)//'%KEY%LST',       mdxhead%key%lst,       1,dims,.true.,error)
  call sic_def_real (trim(struct)//'%KEY%AZ',        mdxhead%key%az,        1,dims,.true.,error)
  call sic_def_real (trim(struct)//'%KEY%EL',        mdxhead%key%el,        1,dims,.true.,error)
  call sic_def_dble (trim(struct)//'%KEY%LON',       mdxhead%key%lon,       1,dims,.true.,error)
  call sic_def_dble (trim(struct)//'%KEY%LAT',       mdxhead%key%lat,       1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%SYSTEM',    mdxhead%key%system,    1,dims,.true.,error)
  call sic_def_real (trim(struct)//'%KEY%EQUINOX',   mdxhead%key%equinox,   1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%SCAN',      mdxhead%key%scan,      1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%BACKEND',   mdxhead%key%backend,   1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%OBSTYPE',   mdxhead%key%obstype,   1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%SWITCHMODE',mdxhead%key%switchmode,1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%POLSTATUS', mdxhead%key%polstatus, 1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%FILSTATUS', mdxhead%key%filstatus, 1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%CALSTATUS', mdxhead%key%calstatus, 1,dims,.true.,error)
  call sic_def_inte (trim(struct)//'%KEY%SOLSTATUS', mdxhead%key%solstatus, 1,dims,.true.,error)
  call sic_def_charn(trim(struct)//'%KEY%FILENAME',  mdxhead%key%filename,  1,dims,.true.,error)
  if (error)  return
  dims(1) = mrtcal_indx_mfrontend
  dims(2) = cx%next-1
  call sic_def_charn(trim(struct)//'%KEY%FRONTEND',  mdxhead%key%frontend,  2,dims,.true.,error)
  if (error)  return
  !
  ! --- Calibration ----------------------------------------------------
  call mdxhead%cal%variable(struct,error)
  if (error)  return
  !
  ! --- Science --------------------------------------------------------
  call mdxhead%sci%variable(struct,error)
  if (error)  return
  !
  ! --- Pointing -------------------------------------------------------
  call mdxhead%poi%variable(struct,error)
  if (error)  return
end subroutine mrtindex_variable_index_defvar

subroutine ghisto(line,error)
  use gildas_def
  use gbl_format
  use phys_const
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>ghisto,  &
                       no_interface1=>gr8_histo,  &
                       no_interface2=>gr8_yxhisto,  &
                       no_interface3=>gr8_histo_base,  &
                       no_interface4=>gr8_yxhisto_base,  &
                       no_interface5=>gr8_histo_hatchfill,  &
                       no_interface6=>gr8_yxhisto_hatchfill
  use greg_kernel
  use greg_pen
  use greg_types
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   HISTOGRAM [Array_X Array_Y]
  ! 1   [/BLANKING  Bval Eval]
  ! 2   [/FILL [Icolor]]
  ! 3   [/BASE [Base]]
  ! 4   [/HATCH [Ipen] [Angle] [Separ] [Phase]]
  ! 5   [/Y]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='HISTOGRAM'
  integer(kind=size_length) :: ixy,nbase
  integer(kind=4) :: form,narg,icol_old,ipen_old,nxy4
  type(sic_descriptor_t) :: xinca,yinca,basedesc
  integer(kind=address_length) :: ipx,ipy
  real(kind=8) :: bval,eval
  type(polygon_drawing_t) :: drawing
  logical :: yxhisto
  real(kind=8), allocatable :: base(:)
  integer(kind=4), parameter :: optblank=1
  integer(kind=4), parameter :: optfill=2
  integer(kind=4), parameter :: optbase=3
  integer(kind=4), parameter :: opthatch=4
  integer(kind=4), parameter :: opty=5
  !
  save xinca,yinca
  !
  ! Command line parsing
  narg = sic_narg(0)
  if (narg.ne.0 .and. narg.ne.2)  return
  !
  ! /BLANK options
  bval = cblank
  call sic_r8 (line,optblank,1,bval,.false.,error)
  if (error) return
  eval = eblank
  call sic_r8 (line,optblank,2,eval,.false.,error)
  if (error) return
  !
  ! /FILL and /HATCH options
  if (penupd) call setpen(cpen)
  call inqcol(icol_old)
  call inqpen(ipen_old)
  call parse_polygon_drawing(rname,line,optfill,opthatch,drawing,error)
  if (error)  return
  !
  ! /Y option
  yxhisto = sic_present(opty,0)
  !
  ! Command arguments (X and Y arrays)
  form = fmt_r8
  call get_incarnation('HISTOGRAM',line,form,ixy,xinca,yinca,error)
  if (error) return
  ipx = gag_pointer(xinca%addr,memory)
  ipy = gag_pointer(yinca%addr,memory)
  call gr8_histo_sanity(ixy,memory(ipx),memory(ipy),yxhisto,error)
  if (error)  return
  !
  ! /BASE option: argument can be scalar or 1D
  if (.not.sic_present(optbase,1)) then
    nbase = 1
    allocate(base(nbase))
    base(:) = 0.d0
  else
    call sic_de(line,optbase,1,basedesc,.true.,error)
    if (error)  goto 10
    if (desc_nelem(basedesc).eq.1) then
      nbase = 1
      allocate(base(nbase))
      call sic_descriptor_getval(basedesc,base,error)
      if (error)  goto 10
    elseif (basedesc%ndim.eq.1) then
      nbase = basedesc%dims(1)
      if (nbase.ne.ixy) then
        call greg_message(seve%e,rname,  &
          '/BASE argument must be scalar or same size as X and Y arrays')
        error = .true.
        goto 10
      endif
      allocate(base(nbase))
      call sic_descriptor_getval(basedesc,base,error)
      if (error)  goto 10
    else
      call greg_message(seve%e,rname,'/BASE argument must scalar or 1D')
      error = .true.
      goto 10
    endif
  endif
  !
  call gr_segm(rname,error)
  if (error)  goto 10
  !
  if (drawing%hatched) then  ! /HATCH (+ maybe /FILL)
    if (drawing%filled) then
      ! Hatch+Fill = color filled histogram (base assumed)
      drawing%hatched = .false. ! Temporarily disable hatching (segment colour issue)
      call setcol(drawing%fcolor)
      if (yxhisto) then
        call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      else
        call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      endif
      !
      ! New segment (may have different colors)
      call gtsegm_close(error)
      call setcol(icol_old)  ! Reset color *after* closing the segment
      call gr_segm(rname,error)
      drawing%hatched = .true. ! Reenabled
    endif
    !
    drawing%filled = .false. ! Disable filling (segment colour issue)
    call setpen(drawing%hpen)
    if (yxhisto) then
      call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
    else
      call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
    endif
    if (error)  continue
    !
  elseif (sic_present(optbase,0)) then  ! /BASE
    if (drawing%filled) then  ! /FILL
      ! Base+Fill = color filled histogram
      call setcol(drawing%fcolor)
      if (yxhisto) then
        call gr8_yxhisto_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      else
        call gr8_histo_hatchfill(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval,drawing,error)
      endif
    else
      if (yxhisto) then
        call gr8_yxhisto_base(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval)
      else
        call gr8_histo_base(ixy,memory(ipx),memory(ipy),nbase,base,bval,eval)
      endif
    endif
    !
  else
    ! No Base (maybe fill): top of histogram (maybe colored)
    if (drawing%filled)  call setcol(drawing%fcolor)
    nxy4 = ixy
    if (yxhisto) then
      call gr8_yxhisto(nxy4,memory(ipx),memory(ipy),bval,eval)
    else
      call gr8_histo(nxy4,memory(ipx),memory(ipy),bval,eval)
    endif
  endif
  !
  call gtsegm_close(error)
  !
10 continue
  ! Reset pen *after* closing the segment
  call setpen(ipen_old)
  call setcol(icol_old)
  !
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  call sic_volatile(basedesc)
end subroutine ghisto
!
subroutine gr8_histo_sanity(nxy,x,y,yxhisto,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Check if bin coordinates are monotoneous (HISTOGRAM does not work
  ! properly if not).
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy      ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)   ! X array
  real(kind=8),              intent(in)    :: y(nxy)   ! Y array
  logical,                   intent(in)    :: yxhisto  ! XY or YX histogram?
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HISTOGRAM'
  character(len=1) :: bin_name,cnt_name
  logical :: cnt_monotonic
  !
  if (yxhisto) then
    ! XY histogram
    if (monotonic_array(nxy,y))  return
    bin_name = 'Y'
    cnt_monotonic = monotonic_array(nxy,x)
    cnt_name = 'X'
  else
    ! XY histogram
    if (monotonic_array(nxy,x))  return
    bin_name = 'X'
    cnt_monotonic = monotonic_array(nxy,y)
    cnt_name = 'Y'
  endif
  call greg_message(seve%e,rname,bin_name//' is not a monotonic array')
  if (cnt_monotonic)  call greg_message(seve%e,rname,  &
    cnt_name//' is monotonic: missing option /'//cnt_name//' ?')
  error = .true.
  return
  !
contains
  !
  function monotonic_array(nxy,array)
    logical :: monotonic_array
    integer(kind=size_length), intent(in) :: nxy
    real(kind=8),              intent(in) :: array(nxy)
    ! Local
    integer(kind=size_length) :: ixy
    !
    monotonic_array = .true.
    if (array(1).lt.array(nxy)) then
      do ixy=1,nxy-1
        if (array(ixy).gt.array(ixy+1)) then
          monotonic_array = .false.
          return
        endif
      enddo
    else
      do ixy=1,nxy-1
        if (array(ixy).lt.array(ixy+1)) then
          monotonic_array = .false.
          return
        endif
      enddo
    endif
  end function monotonic_array
  !
end subroutine gr8_histo_sanity
!
subroutine gr4_histo(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr4_histo
  !---------------------------------------------------------------------
  ! @ public
  !  Connect a set of points with blanked values using histogram (top of
  ! histogram is drawn). Support for blank values and NaN.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=4),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=4),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=4),    intent(in) :: bval    ! Blanking value
  real(kind=4),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  real(kind=8) :: xav,yav
  integer(kind=4) :: j
  logical :: up
  !
  if (nxy.lt.2) return
  !
  xav = x(1) - 0.5*(x(2)-x(1))
  if (y(1).eq.y(1).and.abs(y(1)-bval) .gt. eval) then
    yav = y(1)
    call relocate(xav,yav)
    up = .false.
  else
    up = .true.
  endif
  !
  do j = 2,nxy
    xav = 0.5 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval) .gt. eval) then
      if (up) then
        yav = y(j)
        call relocate(xav,yav)
        up = .false.
      else
        yav = y(j-1)
        call draw(xav,yav)
        yav = y(j)
        call draw(xav,yav)
      endif
    elseif (.not.up) then
      yav = y(j-1)
      call draw(xav,yav)
      up = .true.
    endif
  enddo
  if (up) return
  xav = x(nxy) + 0.5*(x(nxy)-x(nxy-1))
  yav = y(nxy)
  call draw(xav,yav)
end subroutine gr4_histo
!
subroutine gr8_histo(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr8_histo
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Connect a set of points with blanked values using histogram (top of
  ! histogram is drawn). Support for blank values and NaN.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=8),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=8),    intent(in) :: bval    ! Blanking value
  real(kind=8),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  integer(kind=4) :: j
  real(kind=8) :: xav
  logical :: up
  !
  if (nxy.lt.2) return
  !
  ! Left of first bin
  xav = x(1) - 0.5d0*(x(2)-x(1))
  if ((y(1).eq.y(1)).and.abs(y(1)-bval).gt.eval) then
    call relocate(xav,y(1))
    up = .false.
  else
    up = .true.
  endif
  !
  ! Central bins
  do j = 2,nxy
    xav = 0.5d0 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (up) then
        call relocate(xav,y(j))
        up = .false.
      else
        call draw(xav,y(j-1))
        call draw(xav,y(j))
      endif
    elseif (.not.up) then
      call draw(xav,y(j-1))
      up = .true.
    endif
  enddo
  !
  ! Right of last bin
  xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
  if (.not.up) call draw(xav,y(nxy))
end subroutine gr8_histo
!
subroutine gr8_yxhisto(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr8_yxhisto
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Same as gr8_histo, but binning is along Y, and X provides the
  ! counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nxy     ! Number of points
  real(kind=8),    intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),    intent(in) :: y(nxy)  ! Array of Y coordinates
  real(kind=8),    intent(in) :: bval    ! Blanking value
  real(kind=8),    intent(in) :: eval    ! Tolerance on blanking
  ! Local
  integer(kind=4) :: j
  real(kind=8) :: yav
  logical :: up
  !
  if (nxy.lt.2) return
  !
  ! Left of first bin
  yav = y(1) - 0.5d0*(y(2)-y(1))
  if ((x(1).eq.x(1)).and.abs(x(1)-bval).gt.eval) then
    call relocate(x(1),yav)
    up = .false.
  else
    up = .true.
  endif
  !
  ! Central bins
  do j = 2,nxy
    yav = 0.5d0 * (y(j)+y(j-1))
    if (x(j).eq.x(j).and.abs(x(j)-bval).gt.eval) then
      if (up) then
        call relocate(x(j),yav)
        up = .false.
      else
        call draw(x(j-1),yav)
        call draw(x(j),yav)
      endif
    elseif (.not.up) then
      call draw(x(j-1),yav)
      up = .true.
    endif
  enddo
  !
  ! Right of last bin
  yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
  if (.not.up) call draw(x(nxy),yav)
end subroutine gr8_yxhisto
!
subroutine gr8_histo_base(nxy,x,y,nbase,base,bval,eval)
  use gildas_def
  use greg_interfaces, except_this=>gr8_histo_base
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Connect a set of points with blanked values using histogram
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy          ! Number of points
  real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
  real(kind=8),              intent(in) :: bval         ! Blanking value
  real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
  ! Local
  real(kind=8) :: xav
  integer(kind=size_length) :: j
  integer(kind=4) :: sbase
  logical :: up
  integer(kind=size_length), parameter :: first=1
  !
  if (nxy.lt.2) return
  !
  xav = x(1) - 0.5d0*(x(2)-x(1))
  if (y(1).eq.y(1) .and. abs(y(1)-bval).gt.eval) then
    call relocate(xav,base(ibase(first)))
    call draw(xav,y(1))
    up = .false.
  else
    up = .true.
  endif
  !
  if (nbase.eq.nxy) then
    sbase = 1
  else
    sbase = 0
  endif
  !
  do j = 2,nxy
    xav = 0.5d0 * (x(j)+x(j-1))
    if (y(j).eq.y(j).and.abs(y(j)-bval) .gt. eval) then
      if (up) then
        call relocate(xav,base(ibase(j)))
        call draw(xav,y(j))
        up = .false.
      else
        call draw(xav,y(j-1))
        call draw(xav,base(ibase(j)))
        call draw(xav,y(j))
      endif
    elseif (.not.up) then
      call draw(xav,y(j-1))
      call draw(xav,base(ibase(j)))
      up = .true.
    endif
  enddo
  if (up) return
  xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
  call draw(xav,y(nxy))
  call draw(xav,base(ibase(nxy)))
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
end subroutine gr8_histo_base
!
subroutine gr8_yxhisto_base(nxy,x,y,nbase,base,bval,eval)
  use gildas_def
  use greg_interfaces, except_this=>gr8_yxhisto_base
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !  Same as gr8_histo_base, but binning is along Y, and X provides the
  ! counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy          ! Number of points
  real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
  real(kind=8),              intent(in) :: bval         ! Blanking value
  real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
  ! Local
  real(kind=8) :: yav
  integer(kind=size_length) :: j
  integer(kind=4) :: sbase
  logical :: up
  integer(kind=size_length), parameter :: first=1
  !
  if (nxy.lt.2) return
  !
  yav = y(1) - 0.5d0*(y(2)-y(1))
  if (x(1).eq.x(1) .and. abs(x(1)-bval).gt.eval) then
    call relocate(base(ibase(first)),yav)
    call draw(x(1),yav)
    up = .false.
  else
    up = .true.
  endif
  !
  if (nbase.eq.nxy) then
    sbase = 1
  else
    sbase = 0
  endif
  !
  do j = 2,nxy
    yav = 0.5d0 * (y(j)+y(j-1))
    if (x(j).eq.x(j).and.abs(x(j)-bval) .gt. eval) then
      if (up) then
        call relocate(base(ibase(j)),yav)
        call draw(y(j),yav)
        up = .false.
      else
        call draw(x(j-1),yav)
        call draw(base(ibase(j)),yav)
        call draw(x(j),yav)
      endif
    elseif (.not.up) then
      call draw(x(j-1),yav)
      call draw(base(ibase(j)),yav)
      up = .true.
    endif
  enddo
  if (up) return
  yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
  call draw(x(nxy),yav)
  call draw(base(ibase(nxy)),yav)
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
end subroutine gr8_yxhisto_base
!
subroutine gr8_histo_hatchfill(nxy,x,y,nbase,base,bval,eval,drawing,error)
  use gildas_def
  use greg_interfaces, except_this=>gr8_histo_hatchfill
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Build the histogram from the input X and Y values, and fill it
  ! with hatches and maybe color. Contour is not drawn.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy          ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in)    :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in)    :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in)    :: base(nbase)  ! Base of histogram
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance on blanking value
  type(polygon_drawing_t),   intent(in)    :: drawing      ! Drawing description
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  real(kind=8), allocatable :: x2(:),y2(:)
  real(kind=8) :: xav
  integer(kind=size_length) :: j,istart,nelem,inext,jbase,npts
  !
  if (nxy.lt.2) return
  !
  inext = 1
  do while (inext.ne.0)
    ! Read data by blocks of valid values (non blanks if eval>=0, and non NaNs)
    call find_blank8(y,bval,eval,nxy,istart,nelem,inext)
    if (nelem.le.0)  cycle
    !
    ! 1) Build the polygon histogram from the valid values
    npts = 0
    if (istart.eq.1) then
      xav = x(1) - 0.5d0*(x(2)-x(1))
    else
      xav = 0.5d0 * (x(istart-1)+x(istart))
    endif
    call new_point(xav,base(ibase(istart)))  ! First point
    call new_point(xav,y(istart))
    !
    ! Histogram top (left parts)
    do j=2,nelem
      xav = 0.5d0 * (x(istart+j-2)+x(istart+j-1))
      call new_point(xav,y(istart+j-2))
      call new_point(xav,y(istart+j-1))
    enddo
    ! Histogram top (right part)
    if (istart+nelem-1.eq.nxy) then
      xav = x(nxy) + 0.5d0*(x(nxy)-x(nxy-1))
    else
      xav = 0.5d0 * (x(istart+nelem-1)+x(istart+nelem))
    endif
    call new_point(xav,y(istart+nelem-1))
    !
    ! Base
    call new_point(xav,base(ibase(istart+nelem-1)))
    if (nbase.eq.nxy) then
      ! 1D base array
      do jbase=istart+nelem-1,istart+1,-1
        xav = 0.5d0 * (x(jbase-1)+x(jbase))
        call new_point(xav,base(ibase(jbase)))
        call new_point(xav,base(ibase(jbase-1)))
      enddo
    endif
    !
    ! Close the polygon
    call last_point()
    !
    ! 2) Drawings
    ! Contour:
    ! call gr8_connect(nxy2,x2,y2,bval,eval)
    !
    if (drawing%filled) then
      ! Fill the region
      call gr8_ufill(npts,x2,y2)
    endif
    !
    if (drawing%hatched) then
      ! Hatch the region
      call gr8_hatch('HISTO',npts,x2,y2,  &
                    drawing%hangle,drawing%hsepar,drawing%hphase,error)
      if (error)  return
    endif
    !
  enddo
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
  !
  subroutine new_point(xx,yy)
    real(kind=8), intent(in) :: xx,yy
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = xx
    y2(npts) = yy
  end subroutine new_point
  !
  subroutine last_point()
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = x2(1)
    y2(npts) = y2(1)
  end subroutine last_point
  !
  subroutine reallocate_x2y2(nn)
    integer(kind=size_length), intent(in) :: nn
    integer(kind=size_length), parameter :: minalloc=100
    integer(kind=size_length) :: osize,nsize
    real(kind=8), allocatable :: xtmp(:),ytmp(:)
    nsize = max(nn,minalloc)
    if (allocated(x2)) then
      osize = size(x2)
      if (osize.ge.nn)  return  ! Resize not needed
      call move_alloc(from=x2,to=xtmp)
      call move_alloc(from=y2,to=ytmp)
      nsize = max(nsize,2*osize)
    endif
    allocate(x2(nsize),y2(nsize))
    if (allocated(xtmp)) then
      x2(1:osize) = xtmp(1:osize)
      y2(1:osize) = ytmp(1:osize)
      deallocate(xtmp,ytmp)
    endif
  end subroutine reallocate_x2y2
  !
end subroutine gr8_histo_hatchfill
!
subroutine gr8_yxhisto_hatchfill(nxy,x,y,nbase,base,bval,eval,drawing,error)
  use gildas_def
  use greg_interfaces, except_this=>gr8_yxhisto_hatchfill
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Same as gr8_histo_hatchfill, but binning is along Y, and X provides
  ! the counts per bin. Bval/Eval apply on X.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy          ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)       ! Array of X coordinates
  real(kind=8),              intent(in)    :: y(nxy)       ! Array of Y coordinates
  integer(kind=size_length), intent(in)    :: nbase        ! Number base points (1 or Nxy)
  real(kind=8),              intent(in)    :: base(nbase)  ! Base of histogram
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance on blanking value
  type(polygon_drawing_t),   intent(in)    :: drawing      ! Drawing description
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  real(kind=8), allocatable :: x2(:),y2(:)
  real(kind=8) :: yav
  integer(kind=size_length) :: j,istart,nelem,inext,jbase,npts
  !
  if (nxy.lt.2) return
  !
  inext = 1
  do while (inext.ne.0)
    ! Read data by blocks of valid values (non blanks if eval>=0, and non NaNs)
    call find_blank8(x,bval,eval,nxy,istart,nelem,inext)
    if (nelem.le.0)  cycle
    !
    ! 1) Build the polygon histogram from the valid values
    npts = 0
    if (istart.eq.1) then
      yav = y(1) - 0.5d0*(y(2)-y(1))
    else
      yav = 0.5d0 * (y(istart-1)+y(istart))
    endif
    call new_point(base(ibase(istart)),yav)  ! First point
    call new_point(x(istart),yav)
    !
    ! Histogram top (left parts)
    do j=2,nelem
      yav = 0.5d0 * (y(istart+j-2)+y(istart+j-1))
      call new_point(x(istart+j-2),yav)
      call new_point(x(istart+j-1),yav)
    enddo
    ! Histogram top (right part)
    if (istart+nelem-1.eq.nxy) then
      yav = y(nxy) + 0.5d0*(y(nxy)-y(nxy-1))
    else
      yav = 0.5d0 * (y(istart+nelem-1)+y(istart+nelem))
    endif
    call new_point(x(istart+nelem-1),yav)
    !
    ! Base
    call new_point(base(ibase(istart+nelem-1)),yav)
    if (nbase.eq.nxy) then
      do jbase=istart+nelem-1,istart+1,-1
        yav = 0.5d0 * (y(jbase-1)+y(jbase))
        call new_point(base(ibase(jbase)),yav)
        call new_point(base(ibase(jbase-1)),yav)
      enddo
    endif
    !
    ! Close the polygon
    call last_point()
    !
    ! 2) Drawings
    ! Contour:
    ! call gr8_connect(nxy2,x2,y2,bval,eval)
    !
    if (drawing%filled) then
      ! Fill the region
      call gr8_ufill(npts,x2,y2)
    endif
    !
    if (drawing%hatched) then
      ! Hatch the region
      call gr8_hatch('HISTO',npts,x2,y2,  &
                    drawing%hangle,drawing%hsepar,drawing%hphase,error)
      if (error)  return
    endif
    !
  enddo
  !
contains
  function ibase(ival)
    !-------------------------------------------------------------------
    ! Return index in base arrray for ival-th of histogram
    !-------------------------------------------------------------------
    integer(kind=size_length) :: ibase
    integer(kind=size_length), intent(in) :: ival
    if (nbase.eq.nxy) then
      ibase = ival
    else
      ibase = 1
    endif
  end function ibase
  !
  subroutine new_point(xx,yy)
    real(kind=8), intent(in) :: xx,yy
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = xx
    y2(npts) = yy
  end subroutine new_point
  !
  subroutine last_point()
    npts = npts+1
    call reallocate_x2y2(npts)
    x2(npts) = x2(1)
    y2(npts) = y2(1)
  end subroutine last_point
  !
  subroutine reallocate_x2y2(nn)
    integer(kind=size_length), intent(in) :: nn
    integer(kind=size_length), parameter :: minalloc=100
    integer(kind=size_length) :: osize,nsize
    real(kind=8), allocatable :: xtmp(:),ytmp(:)
    nsize = max(nn,minalloc)
    if (allocated(x2)) then
      osize = size(x2)
      if (osize.ge.nn)  return  ! Resize not needed
      call move_alloc(from=x2,to=xtmp)
      call move_alloc(from=y2,to=ytmp)
      nsize = max(nsize,2*osize)
    endif
    allocate(x2(nsize),y2(nsize))
    if (allocated(xtmp)) then
      x2(1:osize) = xtmp(1:osize)
      y2(1:osize) = ytmp(1:osize)
      deallocate(xtmp,ytmp)
    endif
  end subroutine reallocate_x2y2
  !
end subroutine gr8_yxhisto_hatchfill

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_init(error)
  use mrtcal_messaging
  use classic_api
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_init
  use mrtcal_index_vars
  use mrtcal_buffers
  !----------------------------------------------------------------------
  ! @ private
  ! MRTCAL Initialization
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='INIT'
  integer :: ier
  integer(kind=4) :: dim
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_setup_debug_all(seve%d,error)
  if (error)  return
  !
  ier = sic_setlog('gag_help_mrtcal','gag_doc:hlp/mrtcal-help-mrtcal.hlp')
  if (ier.eq.0) then
    error=.true.
    return
  endif
  !
  call mrtindex_init(error)
  if (error)  return
  !
  call mrtcal_toclass_init(error)
  if (error)  return
  !
  ! Buffer allocation
  call reallocate_calib_scan(nbackends_mrtcal,rcalib%scan,error)
  if (error)  return
  call reallocate_science_scan(nbackends_mrtcal,rscience%scan,error)
  if (error)  return
  !
  ! Variables
  call sic_def_long('MFOUND',mfound,0,dim,.true.,error)
  call mrtindex_code2sic(error)
  if (error) return
  call mrtcal_setup_variable(error)
  if (error)  return
  !
end subroutine mrtcal_init
!
subroutine mrtcal_exit(error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_exit
  use mrtcal_buffers
  use mrtcal_index_vars
  !----------------------------------------------------------------------
  ! @ private
  ! MRTCAL Cleaning on exit
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='EXIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_toclass_exit(error)
  ! if (error)  continue
  !
  ! Deallocate RFILE buffers
  call imbfits_free_leadhdus(rfile%imbf,error)
  call free_eclass_char(rfile%imbf%seclass,error)
  call imbfits_free_subscan_header(rfile%subscanbuf%subscan,error)
  call mrtcal_free_subscan_data(rfile%subscanbuf%databuf,error)
  !
  ! Deallocate RCALIB buffers
  call rcalib%scan%free(error)
  call deallocate_mrtoptimize(rcalib%idx,error)
  !
  ! Deallocate RSCIENCE buffers
  call rscience%scan%free(error)
  call deallocate_mrtoptimize(rscience%idx,error)
  !
  ! Deallocate read-write buffers used for Index file
  call deallocate_mrtoptimize(ix,error)
  call deallocate_mrtoptimize(cx,error)
  !
  call mrtindex_exit(error)
  !
  ! Deallocate support variables for command VARIABLE
  call mrtindex_entry_fheader(kentry%head,error)
  !
end subroutine mrtcal_exit
!
subroutine mrtcal_load
  use mrtcal_interfaces, except_this => mrtcal_load
  !---------------------------------------------------------------------
  ! @ private
  ! Define and load the MRTCAL language
  !---------------------------------------------------------------------
  !
  integer, parameter :: mmrtcal=44
  character(len=12) :: vocab(mmrtcal)
  data vocab /                                                            &
    ' CALIBRATE', '/WITH',                                                &
    ' INDEX', '/FILE','/RECURSIVE','/PATTERN','/DATE','/TIMEOUT',         &
    ' MCOPY', '/FILE',                                                    &
    ' MDUMP', '/OUTPUT',                                                  &
    ' MFIND', '/DATE','/SCAN','/BACKEND','/OBSTYPE','/SOURCE','/PROJID',  &
              '/COMPLETENES','/CALIBRATED','/SOLVED','/SWITCHMODE',       &
              '/FRONTEND','/POLARIMETRY',                                 &
    ' MLIST', '/TOC','/PAGE','/COLUMNS','/FILE','/VARIABLE','/POINTING',  &
    ' MSETUP',                                                            &
    ' MUPDATE',                                                           &
    ' MWRITE',                                                            &
    ' PIPELINE', '/SHOW',                                                 &
    ' SOLVE', '/WITH',                                                    &
    ' READ', '/SUBSCAN','/FILENAME',                                      &
    ' VARIABLE', '/INDEX' /
  !
  ! Load the new language
  call sic_begin(         &
    'MRTCAL',             &  ! Language name
    'GAG_HELP_MRTCAL',    &  !
    mmrtcal,              &  ! Number of commands + options in language
    vocab,                &  ! Array of commands + options
    '0.1',                &  ! Some version string
    mrtcal_run,           &  ! The routine which handles incoming commands
    mrtcal_error)            ! The error status routine of the library
  !
end subroutine mrtcal_load
!
subroutine mrtcal_run(line,command,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_run
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for the language MRTCAL.
  ! This routine is able to call the routines associated to each
  ! command of the language MRTCAL
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line
  character(len=12), intent(in)    :: command
  logical,           intent(inout) :: error
  !
  call mrtcal_message(seve%c,'MRTCAL',line)
  !
  ! Call appropriate subroutine according to COMMAND
  select case(command)
  case('CALIBRATE')
     call mrtcal_calib_command(line,error)     
  case('INDEX')
     call mrtcal_index_comm(line,error)
  case('MCOPY')
     call mrtcal_copy_command(line,error)
  case('MDUMP')
     call mrtcal_dump_command(line,error)
  case('MFIND')
     call mrtcal_find_comm(line,error)     
  case('MLIST')
     call mrtcal_list_comm(line,error)
  case('MSETUP')
     call mrtcal_setup_comm(line,error)
  case('MUPDATE')
     call mrtcal_update_command(line,error)
  case('MWRITE')
     call mrtcal_write_command(line,error)
  case('PIPELINE')
     call mrtcal_pipe_command(line,error)
  case('SOLVE')
     call mrtcal_solve_command(line,error)
  case('READ')
     call mrtcal_read_command(line,error)
  case('VARIABLE')
     call mrtcal_variable_comm(line,error)
  case default
     call mrtcal_message(seve%e,'MRTCAL_RUN','Unimplemented command '//command)
     error = .true.
  end select
  ! Reset ctrlc to .FALSE. in case SIC_CTRLC_STATUS was used (e.g., in mrtcal_calib_command) 
  if (sic_ctrlc()) error = .true.
end subroutine mrtcal_run
!
function mrtcal_error()
  use mrtcal_interfaces, except_this => mrtcal_error
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for the error status of the library. 
  ! It is a scory. Please do not use it
  !---------------------------------------------------------------------
  logical :: mrtcal_error
  !
  mrtcal_error = .false.
  !
end function mrtcal_error
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Singular Value Decomposition
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_svd_tool
  use cubetools_parameters
  use cubemain_messaging
  !
  public :: svd_t
  private
  !
  type svd_t
     integer(kind=chan_k),  private :: mp = 0
     integer(kind=inte_k),  private :: np = 0
     real(kind=4), pointer, private :: u(:,:) => null() ! mp x np
     real(kind=4), pointer, private :: v(:,:) => null() ! np x np
     real(kind=4), pointer, private :: w(:)   => null() ! np
   contains
     procedure, public  :: reallocate     => cubemain_svd_reallocate
     procedure, public  :: fit            => cubemain_svd_fit
     procedure, public  :: minloc_w_lt_np => cubemain_svd_minloc_w_lt_np
     procedure, private :: compute        => cubemain_svd_compute
     procedure, private :: solve_for      => cubemain_svd_solve_for
     procedure, private :: free           => cubemain_svd_free
     final :: cubemain_svd_final
  end type svd_t
  !
contains
  !
  subroutine cubemain_svd_reallocate(svd,mp,np,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(svd_t),         intent(inout) :: svd
    integer(kind=chan_k), intent(in)    :: mp
    integer(kind=inte_k), intent(in)    :: np
    logical,              intent(inout) :: error
    !
    logical :: alloc
    integer(kind=4) :: ier
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SVD>REALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (mp.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of channels')
       error = .true.
       return
    endif
    if (np.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of coefficients')
       error = .true.
       return
    endif
    alloc = .true.
    if (associated(svd%u)) then
       if ((svd%mp.eq.mp).and.(svd%np.eq.np)) then
          write(mess,'(a,i0,a,i0)')  &
               'svd pointers already associated at the right size: ',mp,' x ',np
          call cubemain_message(mainseve%alloc,rname,mess)
          alloc = .false.
       else
          if (svd%np.ne.np) then
             ! At least np changed => Reallocate everybody
             write(mess,'(a)') &
                  'svd pointers already associated but with a different size => Freeing them first'
             call cubemain_message(mainseve%alloc,rname,mess)
             call svd%free(error)
             if (error) return
             alloc = .true.
          else 
             ! Only mp has changed => Reallocate only U
             write(mess,'(a)') &
                  'svd%u pointer already associated but with a different size => Freeing it first'
             call cubemain_message(mainseve%alloc,rname,mess)
             if (associated(svd%u)) deallocate(svd%u)
             allocate(svd%u(mp,np),stat=ier)
             if (failed_allocate(rname,' svd%u',ier,error)) return
             alloc = .false.
          endif
       endif
    endif
    if (alloc) then
       allocate(svd%u(mp,np),svd%v(np,np),svd%w(np),stat=ier)
       if (failed_allocate(rname,'svd pointers',ier,error)) return
    endif
    ! Allocation success => svd%mp and svd%np may be updated
    svd%mp = mp
    svd%np = np
  end subroutine cubemain_svd_reallocate
  !
  subroutine cubemain_svd_free(svd,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(svd_t), intent(inout) :: svd
    logical,      intent(inout) :: error
    !
    character(len=*), parameter :: rname='SVD>FREE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    svd%mp = 0
    svd%np = 0
    if (associated(svd%u)) deallocate(svd%u)
    if (associated(svd%v)) deallocate(svd%v)
    if (associated(svd%w)) deallocate(svd%w)
  end subroutine cubemain_svd_free
  !
  subroutine cubemain_svd_final(svd)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(svd_t), intent(inout) :: svd
    !
    logical :: error
    character(len=*), parameter :: rname='SVD>FINAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call svd%free(error)
  end subroutine cubemain_svd_final
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_svd_fit(svd,data,a,ma,chisq,funcs,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! Given a set of data%n points data%x(id), data%y(id) with weights
    ! data%w(id), use Chi2 minimization to determine the MA coefficients A
    ! of the fitting function. Here we solve the fitting equations using
    ! singular value decomposition of the data%n by MA matrix.
    !
    ! The user supplies a subroutine FUNCS(X,AFUNC,MA) that returns the MA
    ! basis functions evaluated at x=X in the array AFUNC.
    !
    ! The programs returns values for the MA fit parameters and Chi2, CHISQ. 
    !
    ! Arrays U,V,W provide workspace on input. On output they define the
    ! singular value decomposition and can be used to obtain the covariance
    ! matrix.
    !
    ! It is necessary that svd%mp >= data%n, svd%np >= ma.
    !----------------------------------------------------------------------
    class(svd_t),         intent(inout) :: svd
    type(spectrum_t),     intent(in)    :: data
    real(kind=4),         intent(out)   :: a(ma)
    integer(kind=4),      intent(in)    :: ma
    real(kind=sign_k),    intent(out)   :: chisq
    external                            :: funcs
    logical,              intent(inout) :: error
    !
    real(kind=4), parameter :: tol=1.e-5
    real(kind=4) :: b(data%n)
    real(kind=4) :: afunc(ma)
    integer(kind=4) :: id,j
    real(kind=4) :: wmax,thresh,sum,tmp
    character(len=*), parameter :: rname='SVD>FIT'
    !
    ! Initialize the svd%u matrix
    do id=1,data%n
       call funcs(data%x%val(id),afunc,ma)
       tmp = sqrt(data%w%val(id))
       do j=1,ma
          svd%u(id,j) = afunc(j)*tmp
       enddo
       b(id) = data%y%val(id)*tmp
    enddo ! id
    call svd%compute(data%n,ma,error)
    if (error) goto 10
    ! Edit out the (nearly) singular values
    wmax = 0.
    do j=1,ma
       if (svd%w(j).gt.wmax) wmax=svd%w(j)
    enddo
    thresh = tol*wmax
    do j=1,ma
       if (svd%w(j).lt.thresh) svd%w(j) = 0
    enddo
    ! Solve the equations
    call svd%solve_for(data%n,ma,b,a,error)
    if (error) goto 10
    ! Evaluate chi-square
    chisq = 0.
    do id=1,data%n
       call funcs(data%x%val(id),afunc,ma)
       sum=0.
       do j=1,ma
          sum = sum+a(j)*afunc(j)
       enddo
       chisq = chisq+(data%y%val(id)-sum)**2*data%w%val(id)
    enddo ! id
    return
    ! Exception handler
10  call cubemain_message(seve%e,rname,'Error in singular value decomposition')
  end subroutine cubemain_svd_fit
  !
  function cubemain_svd_minloc_w_lt_np(svd) result(test)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(svd_t), intent(in)  :: svd
    logical                   :: test
    !
    test = minloc(svd%w,1).lt.svd%np
  end function cubemain_svd_minloc_w_lt_np
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_svd_compute(svd,m,n,error)
    !---------------------------------------------------------------------
    ! Given a matrix A with logical dimensions M by N and physical dimensions
    ! MP by NP, this routine computes its singular value decomposition
    !	A = U.W.Vt
    !
    ! The matrix U is initialized to A on input and computed to its actual
    ! value in output. The diagonal matrix of singular values W is output
    ! as vector W. The matrix V (not the transpose Vt) is output as V.
    !
    ! M must be greater or equal to N. If it is smaller, then A should be
    ! filled up to square with zero rows.
    !---------------------------------------------------------------------
    class(svd_t),         intent(inout) :: svd
    integer(kind=chan_k), intent(in)    :: m
    integer(kind=4),      intent(in)    :: n
    logical,              intent(out)   :: error
    !
    integer(kind=4), parameter :: nmax=100 ! Maximum anticipated value of N
    real(kind=4) ::  rv1(nmax)
    integer(kind=4) :: i,j,k,l,nm,its,jj
    real(kind=4) :: scale,anorm,c,s,x,y,z
    real(kind=4) :: f,g,h
    character(len=*), parameter :: rname='SVD>COMPUTE'
    !
    if (n.gt.nmax) then
       call cubemain_message(seve%e,rname,'NMAX dimension too small => Recompilation needed')
       error = .true.
       return
    elseif (m.lt.n) then
       call cubemain_message(seve%e,rname,'You must add extra zero rows to A')
       error = .true.
       return
    endif
    ! Householder reduction to diagonal form
    g = 0.0
    scale = 0.0
    anorm = 0.0
    do i=1,n
       l=i+1
       rv1(i) = scale*g
       g = 0.0
       s = 0.0
       scale = 0.0
       if (i.le.m) then
          do k=i,m
             scale = scale+abs(svd%u(k,i))
          enddo
          if (scale.ne.0.0) then
             do k=i,m
                svd%u(k,i) = svd%u(k,i)/scale
                s = s+svd%u(k,i)*svd%u(k,i)
             enddo
             f = svd%u(i,i)
             g = -sign(sqrt(s),f)
             h = f*g-s
             svd%u(i,i) = f-g
             if (i.ne.n) then
                do j=l,n
                   s=0.0
                   do k=i,m
                      s = s+svd%u(k,i)*svd%u(k,j)
                   enddo
                   f = s/h
                   do k=i,m
                      svd%u(k,j) = svd%u(k,j)+f*svd%u(k,i)
                   enddo
                enddo
             endif
             do k=i,m
                svd%u(k,i) = scale*svd%u(k,i)
             enddo
          endif
       endif
       svd%w(i) = scale*g
       g = 0.0
       s = 0.0
       scale = 0.0
       if ((i.le.m).and.(i.ne.n)) then
          do k=l,n
             scale = scale+abs(svd%u(i,k))
          enddo
          if (scale.ne.0) then
             do k=l,n
                svd%u(i,k)=svd%u(i,k)/scale
                s=s+svd%u(i,k)*svd%u(i,k)
             enddo
             f=svd%u(i,l)
             g=-sign(sqrt(s),f)
             h=f*g-s
             svd%u(i,l)=f-g
             do k=l,n
                rv1(k)=svd%u(i,k)/h
             enddo
             if (i.ne.m) then
                do j=l,m
                   s=0.0
                   do k=l,n
                      s=s+svd%u(j,k)*svd%u(i,k)
                   enddo
                   do k=l,n
                      svd%u(j,k)=svd%u(j,k)+s*rv1(k)
                   enddo
                enddo
             endif
             do k=l,n
                svd%u(i,k)=scale*svd%u(i,k)
             enddo
          endif
       endif
       anorm = max(anorm,(abs(svd%w(i))+abs(rv1(i))))
    enddo
    ! Accumulation of right hand transformation
    do i=n,1,-1
       if (i.lt.n) then
          if (g.ne.0.0) then
             do j=l,n
                ! Double division avoids possible underflow
                svd%v(j,i) = (svd%u(i,j)/svd%u(i,l))/g
             enddo
             do j=l,n
                s=0.0
                do k=l,n
                   s=s+svd%u(i,k)*svd%v(k,j)
                enddo
                do k=l,n
                   svd%v(k,j)=svd%v(k,j)+s*svd%v(k,i)
                enddo
             enddo
          endif
          do j=l,n
             svd%v(i,j) = 0.0
             svd%v(j,i) = 0.0
          enddo
       endif
       svd%v(i,i) = 1.0
       g = rv1(i)
       l = i
    enddo
    ! Accumulation of left hand transformations
    do i=n,1,-1
       l = i+1
       g = svd%w(i)
       if (i.lt.n) then
          do j=l,n
             svd%u(i,j) = 0.0
          enddo
       endif
       if (g.ne.0.0) then
          g = 1.0/g
          if (i.ne.n) then
             do j=l,n
                s = 0.0
                do k=l,m
                   s = s+svd%u(k,i)*svd%u(k,j)
                enddo
                f = (s/svd%u(i,i))*g
                do k=i,m
                   svd%u(k,j)=svd%u(k,j)+f*svd%u(k,i)
                enddo
             enddo
          endif
          do j=i,m
             svd%u(j,i) = svd%u(j,i)*g
          enddo
       else
          do j=i,m
             svd%u(j,i) = 0.0
          enddo
       endif
       svd%u(i,i) = svd%u(i,i)+1.0
    enddo
    ! Diagonalization of the bidiagonal form
    do k=n,1,-1 ! Loop over singular values
       do its=1,30 ! Loop over allowed iterations
          do l=k,1,-1 ! Test for splitting:
             nm=l-1 ! Note that RV1(1) is always zero
             if ((abs(rv1(l))+anorm).eq.anorm) goto 2
             if ((abs(svd%w(nm))+anorm).eq.anorm) goto 1
          enddo
1         continue
          c=0.0 ! Cancellation of RV1(L), if L>1
          s=1.0
          do i=l,k
             f=s*rv1(i)
             if ((abs(f)+anorm).ne.anorm) then
                g = svd%w(i)
                h = sqrt(f*f+g*g)
                svd%w(i) = h
                h = 1.0/h
                c = (g*h)
                s = -f*h
                do j=1,m
                   y = svd%u(j,nm)
                   z = svd%u(j,i)
                   svd%u(j,nm)=(y*c)+(z*s)
                   svd%u(j,i)=-(y*s)+(z*c)
                enddo
             endif
          enddo
2         continue
          z=svd%w(k)
          if (l.eq.k) then
             ! Convergence
             if (z.lt.0.0) then
                ! Singular value is made non negative
                svd%w(k)=-z
                do j=1,n
                   svd%v(j,k)=-svd%v(j,k)
                enddo
             endif
             goto 3
          endif
          if (its.eq.30) then
             call cubemain_message(seve%e,rname,'No convergence in 30 iterations')
             error = .true.
             return
          endif
          x=svd%w(l) ! Shift from bottom 2-by-2 minor
          nm = k-1
          y = svd%w(nm)
          g = rv1(nm)
          h = rv1(k)
          f = ((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
          g = sqrt(f*f+1.0)
          f = ((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
          ! Next QR transformation
          c=1.0
          s=1.0
          do j=l,nm
             i=j+1
             g=rv1(i)
             y=svd%w(i)
             h=s*g
             g=c*g
             z=sqrt(f*f+h*h)
             rv1(j) = z
             c=f/z
             s=h/z
             f= (x*c)+(g*s)
             g=-(x*s)+(g*c)
             h=y*s
             y=y*c
             do jj=1,n
                x=svd%v(jj,j)
                z=svd%v(jj,i)
                svd%v(jj,j)= (x*c)+(z*s)
                svd%v(jj,i)=-(x*s)+(z*c)
             enddo
             z=sqrt(f*f+h*h)
             svd%w(j) = z
             if (z.ne.0) then
                ! Rotation can be arbitrary if Z=0
                z=1.0/z
                c=f*z
                s=h*z
             endif
             f= (c*g)+(s*y)
             x=-(s*g)+(c*y)
             do jj=1,m
                y=svd%u(jj,j)
                z=svd%u(jj,i)
                svd%u(jj,j) = (y*c)+(z*s)
                svd%u(jj,i) =-(y*s)+(z*c)
             enddo
          enddo
          rv1(l)=0.0
          rv1(k)=f
          svd%w(k)=x
       enddo
3      continue
    enddo
  end subroutine cubemain_svd_compute
  !
  subroutine cubemain_svd_solve_for(svd,m,n,b,x,error)
    !---------------------------------------------------------------------
    ! Solves A.X = B for a vector X, where A is specified by the arrays U,W,V
    ! as returned by svd%compute.
    !
    ! M and N are the logical dimensions of A, and will be equal for square
    ! matrices. MP and NP are the physical dimensions of A.
    !
    ! B is the input right hand side. X is the output solution vector. No
    ! input quantities are destroyed, so the routine may be called
    ! sequentially with different B's.
    !---------------------------------------------------------------------
    class(svd_t),         intent(in)  :: svd
    integer(kind=chan_k), intent(in)  :: m
    integer(kind=4),      intent(in)  :: n
    real(kind=4),         intent(in)  :: b(svd%mp)
    real(kind=4),         intent(out) :: x(svd%np)
    logical,              intent(out) :: error
    !
    integer(kind=4), parameter :: nmax=100
    real(kind=4) :: tmp(nmax),s
    integer(kind=4) :: i,j,jj
    character(len=*), parameter :: rname='SVD>SOLVE>FOR'
    !
    if (n.gt.nmax) then
       call cubemain_message(seve%e,rname,'NMAX dimension too small => Will need to recompile')
       error = .true.
       return
    endif
    ! Calculate UtB
    do j=1,n
       s = 0.
       if (svd%w(j).ne.0.) then
          do i=1,m
             s=s+svd%u(i,j)*b(i)
          enddo
          s = s/svd%w(j)
       endif
       tmp(j) = s
    enddo
    ! Matrix multiply by V to get answer
    do j=1,n
       s = 0.0
       do jj=1,n
          s = s+svd%v(j,jj)*tmp(jj)
       enddo
       x(j) = s
    enddo
  end subroutine cubemain_svd_solve_for
end module cubemain_svd_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_convert
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: convert
  private
  !
  type :: convert_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(option_t),     pointer :: unit
     type(option_t),     pointer :: efficiencies
     type(option_t),     pointer :: factor
     type(cube_prod_t),  pointer :: converted
   contains
     procedure, public  :: register           => cubemain_convert_register
     procedure, private :: parse              => cubemain_convert_parse
     procedure, private :: parse_unit         => cubemain_convert_parse_unit
     procedure, private :: parse_factor       => cubemain_convert_parse_factor
     procedure, private :: parse_efficiencies => cubemain_convert_parse_efficiencies
     procedure, private :: main               => cubemain_convert_main
  end type convert_comm_t  
  type(convert_comm_t) :: convert
  !
  type convert_user_t
     type(cubeid_user_t)   :: cubeids
     logical               :: dounit
     character(len=argu_l) :: unit
     logical               :: dofactor
     real(kind=sign_k)     :: factor     ! User defined convertion factor
     logical               :: doapplyeff
     real(kind=sign_k)     :: beff       ! Beam Efficiency
     real(kind=sign_k)     :: feff       ! Forward Efficiency
   contains
     procedure, private :: toprog => cubemain_convert_user_toprog
  end type convert_user_t
  !
  type convert_prog_t
     type(cube_t), pointer :: incube     ! Input cube
     type(cube_t), pointer :: converted  ! Output cube
     character(len=unit_l) :: unit_name  ! Name of output unit
     integer(kind=code_k)  :: unit_code  ! Code of output unit
     real(kind=sign_k)     :: factor     ! Convertion factor
   contains
     procedure, private :: header => cubemain_convert_prog_header
     procedure, private :: data   => cubemain_convert_prog_data
     procedure, private :: loop   => cubemain_convert_prog_loop
     procedure, private :: act    => cubemain_convert_prog_act
  end type convert_prog_t
  !
contains
  !
  subroutine cubemain_convert_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(convert_user_t) :: user
    character(len=*), parameter :: rname='CONVERT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%parse(line,user,error)
    if (error) return
    call convert%main(user,error)
    if (error) continue
  end subroutine cubemain_convert_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_register(convert,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(inout) :: convert
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='CONVERT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CONVERT','[cubeid]',&
         'Convert the unit of the cube data',&
         'CONVERT applies a multiplicative factor to cube data array in order to&
         &change the data unit.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The input unit comes from the input cube header array unit&
         & field.'//strg_cr//&
         '- At least one of /UNIT or /EFFICIENCIES is required.'//strg_cr//&
         '- /UNIT selects the target output unit.'//strg_cr//&
         '- /FACTOR with /UNIT forces an explicit multiplicative conversion&
         &factor. Without /FACTOR, CONVERT infers a factor only for supported&
         &unit conversions.'//strg_cr//&
         '- /EFFICIENCIES Beff Feff applies beam and forward efficiencies for&
         &brightness-unit conversions involving "K (Ta*)".'//strg_bl//&
         'Note:'//strg_cr//&
         '- Use the EDIT language for low-level manual header fixes when&
         & incoherences must be corrected directly.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT "K (Tmb)"'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT Jy/beam /FACTOR 0.12'//strg_cr//&
         'CUBE> CONVERT 12co10:cube /UNIT "K (Ta*)" /EFFICIENCIES 0.7 0.9',&
         cubemain_convert_command,&
         convert%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (cube flag) in the default&
         & index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_subset,&
         convert%incube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'UNIT',&
         'name',&
         'Select the desired output unit',&
         strg_emp,&
         convert%unit,&
         error)
    if (error) return
    call stdarg%register(&
         'NAME',&
         'A unit name either known or unknown by the program',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FACTOR','value',&
         'Explicitly define a unit conversion factor',&
         'This key gives the user the ability to do unsupported conversions. The&
         &given value is used as a multiplicative factor over the whole cube and the&
         &new unit is taken to be the unit given with /UNIT key. WARNING: No checks&
         &about the validity of the conversion are performed.',&
         convert%factor,&
         error)
    if (error) return
    call stdarg%register(&
         'VALUE',&
         'Unit conversion factor',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'EFFICIENCIES','Beff Feff',&
         'Convert to and From "K (Ta*)"',&
         'Specify the Beam and Forward efficiencies to use when&
         & converting to and from "K (Ta*)".',&
         convert%efficiencies,&
         error)
    if (error) return
    call stdarg%register(&
         'Beff',&
         'Telescope beam efficiency',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'Feff',&
         'Telescope forward efficiency',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'CONVERTED',&
         'Converted cube',&
         strg_emp,&
         [flag_convert,flag_cube],&
         convert%converted,&
         error)
    if (error) return
  end subroutine cubemain_convert_register
  !
  !
  subroutine cubemain_convert_parse(convert,line,user,error)
    !----------------------------------------------------------------------
    ! CONVERT [cubeid]
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,convert%comm,user%cubeids,error)
    if (error) return
    call convert%parse_unit(line,user,error)
    if (error) return
    call convert%parse_factor(line,user,error)
    if (error) return
    call convert%parse_efficiencies(line,user,error)
    if (error) return
    if (.not.(user%dounit.or.user%doapplyeff)) then
       call cubemain_message(seve%e,rname,"At least one option must be given")
       error = .true.
       return
    endif
  end subroutine cubemain_convert_parse
  !
  subroutine cubemain_convert_parse_unit(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /UNIT name
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>UNIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%unit%present(line,user%dounit,error)
    if (error) return
    if (user%dounit) then
       call cubetools_getarg(line,convert%unit,1,user%unit,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_unit
  !
  subroutine cubemain_convert_parse_factor(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /FACTOR value
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>FACTOR'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%factor%present(line,user%dofactor,error)
    if (error) return
    if (user%dofactor) then
       call cubetools_getarg(line,convert%factor,1,user%factor,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_factor
  !
  subroutine cubemain_convert_parse_efficiencies(convert,line,user,error)
    !----------------------------------------------------------------------
    ! /EFFICIENCIES beff feff
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: convert
    character(len=*),      intent(in)    :: line
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PARSE>EFFICIENCIES'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call convert%efficiencies%present(line,user%doapplyeff,error)
    if (error) return
    if (user%doapplyeff) then
       call cubetools_getarg(line,convert%efficiencies,1,user%beff,mandatory,error)
       if (error) return
       call cubetools_getarg(line,convert%efficiencies,2,user%feff,mandatory,error)
       if (error) return
    endif
  end subroutine cubemain_convert_parse_efficiencies
  !
  subroutine cubemain_convert_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_comm_t), intent(in)    :: comm
    type(convert_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(convert_prog_t) :: prog
    character(len=*), parameter :: rname='CONVERT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_convert_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_user_toprog(user,comm,prog,error)
    use cubetools_header_methods
    use cubetools_brightness
    use cubetools_disambiguate
    use cubetools_unit_setup
    use cubetools_unit
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_user_t), intent(in)    :: user
    type(convert_comm_t),  intent(in)    :: comm 
    type(convert_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    logical :: converror
    integer(kind=code_k) :: codein,codeou
    character(len=unit_l) :: unitin,unitou
    character(len=mess_l) :: mess
    type(unit_user_t) :: inunit,ouunit
    character(len=*), parameter :: rname='CONVERT>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    !
    call cubetools_header_get_array_unit(prog%incube%head,unitin,error)
    if (error) return
    call cubetools_unit_get_code(unitin,codein,error)
    if (error) return
    call cubetools_unit_get_code(user%unit,codeou,error)
    if (error) return
    !
    if (user%dofactor) then
       ! User has given a factor, simple case
       prog%factor = user%factor
       unitou = user%unit
       if (codeou.eq.code_unit_unk) &
            call cubemain_message(seve%w,rname,'Unsupported unit '//trim(user%unit))
    else
       ! Automatic convertion factor 
       converror = .false.
       !
       select case(codein)
       case(code_unit_unk)
          converror = .true.
       case(code_unit_brig)
          if (codeou.eq.code_unit_brig) then
             prog%unit_code = brightness_get(user%unit)  ! NB: user%unit was already tested for invalid names
             unitou = brightness_get(prog%unit_code)
             call cubetools_header_brightness2brightness(prog%incube%head,&
                  user%doapplyeff,user%feff,user%beff,&
                  prog%unit_code,prog%factor,error)
             if (error) return
          else
             converror = .true.
          endif
       case(code_unit_flux)
          if (codeou.eq.code_unit_flux) then
             prog%unit_code = flux_get(user%unit)
             unitou = flux_get(prog%unit_code)
             call cubetools_header_flux2flux(prog%incube%head,prog%unit_code,prog%factor,error)
             if (error) return
          else
             converror = .true.
          endif
       case default
          select case(codein)
          case(code_unit_freq,code_unit_velo,code_unit_wave&
               &,code_unit_pixe,code_unit_chan,code_unit_dist)
             ! Non equivalent units, convertion only possible if kind is
             ! the same
             converror = codein.ne.codeou
          case (code_unit_fov,code_unit_beam)
             ! All unit kinds here are angle units and can hence be
             ! treated together
             converror = .not.(codeou.eq.code_unit_fov.or.codeou.eq.code_unit_beam)
          case default
             call cubemain_message(seve%e,rname,'Programming error')
             error = .true.
             return
          end select
          if (.not.converror) then
             call inunit%get_from_name_for_code(unitin,codein,error)
             if (error) return
             call ouunit%get_from_name_for_code(user%unit,codeou,error)
             if (error) return
             prog%factor = inunit%prog_per_user*ouunit%user_per_prog
             unitou = ouunit%name
          else
             ! Do nothing
          endif
       end select
       !
       if (converror) then
          write(mess,'(8a)') 'Cannot convert from ',trim(unitin),' of kind ',trim(unitkinds(codein)),&
               ' to ',trim(user%unit),' of kind ',trim(unitkinds(codeou))
          call cubemain_message(seve%e,rname,mess)
          error = .true.
          return
       endif
    endif
    !
    ! User feedback
    write(mess,'(5a,1pg14.7)') 'Converting from ',trim(unitin),' to ',trim(unitou),&
         ', factor: ',prog%factor
    call cubemain_message(seve%i,rname,mess)
    prog%unit_name = unitou
  end subroutine cubemain_convert_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_convert_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_prog_t), intent(inout) :: prog
    type(convert_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%converted,prog%incube,prog%converted,error)
    if (error) return
    call cubetools_header_put_array_unit(prog%unit_name,prog%converted%head,error)
    if (error) return
  end subroutine cubemain_convert_prog_header
  !
  subroutine cubemain_convert_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(convert_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='CONVERT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) &
         call prog%loop(itertask,error)
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_convert_prog_data
  !   
  subroutine cubemain_convert_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! The subcube iterator will be shared by all input and output subcubes
    !----------------------------------------------------------------------
    class(convert_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='CONVERT>PROG>LOOP'
    !
    do while (itertask%iterate_entry(error))
       call prog%act(itertask,error)
       if (error) return
    enddo  ! ientry
  end subroutine cubemain_convert_prog_loop
  !   
  subroutine cubemain_convert_prog_act(prog,itertask,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(convert_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: incube,converted
    character(len=*), parameter :: rname='CONVERT>PROG>ACT'
    !
    ! Converts are initialized here as their size (3rd dim) may change from
    ! from one convert to another.
    call incube%associate('incube',prog%incube,itertask,error)
    if (error) return
    call converted%allocate('converted',prog%converted,itertask,error)
    if (error) return
    !
    call incube%get(error)
    if (error) return
    do iz=1,incube%nz
       do iy=1,incube%ny
          do ix=1,incube%nx
             converted%val(ix,iy,iz) = incube%val(ix,iy,iz)*prog%factor
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call converted%put(error)
    if (error) return
  end subroutine cubemain_convert_prog_act
end module cubemain_convert
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sicset_message(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use gpack_def
  use sic_interfaces, except_this=>sicset_message
  !---------------------------------------------------------------------
  ! @ private
  !    Support routine for command SIC\SIC MESSAGE. Should only be
  ! called by SICSET subroutine, which supports the SIC\SIC command.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  !
  if (sic_present(1,0)) then  ! /COLOR
    call sicset_message_colors(line,error)
    if (error)  return
  else
    call sicset_message_rules(line,error)
    if (error)  return
  endif
  !
end subroutine sicset_message
!
subroutine sicset_message_rules(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use gpack_def
  use sic_interfaces, except_this=>sicset_message_rules
  !---------------------------------------------------------------------
  ! @ private
  ! Syntax may be:
  !    SIC MESSAGE
  !       (nothing done, just print active filters)
  !    SIC MESSAGE PackName [ [S|L|A][-|=|+]F|E|W|R|I|D|T ] [...]
  !       (update and print considered package(s) filters)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=80) :: arg
  character(len=80) :: package
  integer :: narg,iarg,al,pack_id,sev
  logical :: newone,found
  character(len=*), parameter :: rname = 'SIC MESSAGE'
  !
  sev = seve%r
  narg = sic_narg(0)
  !
  ! Print current values if no argument: loop on all active packages
  if (narg.eq.1) then
    call gmessage_print_active(sev,error)
    return
  endif
  !
  iarg = 2
  error  = .false.
  newone = .true.    ! Next arg must be a new package?
  !
  do while (iarg.le.narg)
    !
    call sic_ch(line,0,iarg,arg,al,.true.,error) ! Get next arg
    if (error) return
    !
    ! Try to resolve package name
    call gpack_resolve(arg,found,error)
    if (error) return
    !
    ! Found a new package or *:
    if (found .or. arg.eq.'*') then
      !
      ! Flush previous package
      if (iarg .ne. 2) then
         if (package.eq.'*') then
           call gmessage_print_all(sev,error)
         else
           call gmessage_print_id(pack_id,sev,error)
         endif
         if (error) return
         sev = seve%r
      endif
      !
      ! Set new package
      package = arg
      if (package.ne.'*')  pack_id = gpack_get_id(package,.true.,error)
      newone  = .false.
    !
    ! Expected a package, but it is not found:
    elseif (newone .and. .not.found) then
      !
      call sic_message(seve%e,rname,'Unknown package '''//arg(1:al)//'''')
      error = .true.
      return
    !
    ! Special case for 'global' rules:
    elseif (package.eq.gpack_global_name) then
      !
      if (arg.eq.'on') then
        call sic_message(seve%r,rname,"Turning ON global filtering rules")
        call gmessage_use_gbl_rules(.true.)
      elseif (arg(1:2).eq.'of') then
        call sic_message(seve%r,rname,"Turning OFF global filtering rules")
        call gmessage_use_gbl_rules(.false.)
      else           ! Must be a 'global' rule
        call gmessage_parse_and_set(pack_id,arg,error)
        sev = seve%d
        if (error) return
      endif
      !
    ! Else must be a rule:
    else
      !
      if (package.eq.'*') then
        call gmessage_parse_and_set_all(arg,error)
      else
        call gmessage_parse_and_set(pack_id,arg,error)
      endif
      if (error) return
      sev = seve%d
      newone = .true.
      !
    endif
    !
    iarg = iarg+1
  enddo
  !
  ! Print pending package:
  if (package.eq.'*') then
    call gmessage_print_all(sev,error)
  else
    call gmessage_print_id(pack_id,sev,error)
  endif
  if (error) return
  !
end subroutine sicset_message_rules
!
subroutine sicset_message_colors(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use sic_interfaces, except_this=>sicset_message_colors
  !---------------------------------------------------------------------
  ! @ private
  ! Syntax may be:
  !    SIC MESSAGE /COLOR
  !       (nothing done, just print active colors)
  !    SIC MESSAGE /COLOR ON|OFF
  !       (turn on/off the message coloring)
  !    SIC MESSAGE /COLOR E=RED W=ORANGE ...
  !       (update relevant message colors)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname = 'SIC MESSAGE'
  integer(kind=4), parameter :: optcolor=1
  integer(kind=4) :: iarg,narg,nc
  character(len=32) :: argum
  !
  narg = sic_narg(optcolor)
  !
  ! Print current values if no argument: loop on all active packages
  if (narg.eq.0) then
    call gmessage_print_colors(error)
    return
  endif
  !
  do iarg=1,narg
    call sic_ke(line,optcolor,iarg,argum,nc,.true.,error)
    if (error)  return
    if (argum.eq.'ON') then
      call gmessage_colors_swap(.true.)
    elseif (argum.eq.'OFF') then
      call gmessage_colors_swap(.false.)
    else
      call gmessage_colors_parse(argum,error)
      if (error)  return
    endif
  enddo
  !
end subroutine sicset_message_colors
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sic_message_command(line,error)
  use sic_dependencies_interfaces
  use gbl_message
  use gpack_def
  use sic_interfaces, except_this=>sic_message_command
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !    Support routine for command SIC\MESSAGE. Syntax is:
  !    MESSAGE F|E|W|R|I|D|T  ProcName  "Message"
  !    MESSAGE F|E|W|R|I|D|T  ProcName  Arg1 Arg2 ... ArgN
  ! 1  [/FORMAT <fmt1> <fmt2> ... <fmtN>]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname = 'MESSAGE'
  character(len=1) :: lsev
  character(len=32) :: proc            ! Length should be a parameter
  character(len=message_length) :: chain,message
  integer :: larg,scode,narg,iarg,ml,lchain
  logical :: do_format
  !
  narg = sic_narg(0)
  if (narg.lt.3) then
    call sic_message(seve%e,rname,'Command MESSAGE needs at least 3 arguments')
    error = .true.
    return
  endif
  !
  ! Retrieve kind letter and translate it
  call sic_ch (line,0,1,lsev,larg,.true.,error)
  if (error) return
  call gmessage_translate(lsev,scode,error)
  if (error) return
  !
  ! Retrieve procedure name
  call sic_ch (line,0,2,proc,larg,.true.,error)
  if (error) return
  call sic_upper(proc)
  !
  ! Retrieve message
  ml = 1
  do_format = sic_present(1,0)
  do iarg=3,narg
    if (do_format) then
      call say_format_arg(line,iarg,iarg-2,0,chain,lchain,error)
      if (error) return
    else
      call sic_ch (line,0,iarg,chain,lchain,.true.,error)
      if (error) return
    endif
    message(ml:) = chain(:lchain)
    ml = ml+lchain+1
  enddo
  !
  call gmessage_write(gmaster_get_id(),scode,proc,message)
  !
end subroutine sic_message_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! Support file for command PERSPECTIVE
!-----------------------------------------------------------------------
module greg_hautbas
  !---------------------------------------------------------------------
  ! Support module
  !---------------------------------------------------------------------
  logical :: lower      ! /LOWER is present
  logical :: vert_flag  ! /VERTICAL is present
end module greg_hautbas
!
module greg_nxtv1
  integer, parameter :: nn=3000
  integer :: kk,ll
  real :: xx(nn),yy(nn)
end module greg_nxtv1
!
subroutine threed (line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>threed
  use greg_axes
  use greg_hautbas
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !
  ! PERSPECTIVE [Altitude Azimuth]
  ! 1           [/FACTOR factor offset]
  ! 2           [/LOWER]
  ! 3           [/LINES]
  ! 4           [/STEP nx ny]
  ! 5           [/AXES Xmin Xmax Ymin Ymax]
  ! 6           [/CENTER]
  ! 7           [/VERTICAL Vmin Vmax]
  !
  ! 3D perspective plot, define the projective transformation
  !
  ! ALTitude      : degrees
  ! AZImuth       : degrees
  ! XLEN and YLEN : Length of X and Y axes (cf SET LOCATION)
  ! XOFF and YOFF : Origin position
  ! ZFACtor       : Conversion factor from Z to physical units
  ! ZOFF          : Origine offset along Z (physical units)
  !---------------------------------------------------------------------
  character(len=*) :: line          ! Command line               Input
  logical :: error                  ! Logical error flag         Output
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='PERSPECTIVE'
  integer :: l
  real*4 :: xlen,ylen,xoff,yoff,alt,az,goff,azi
  real*4 :: zfac,zoff,gxo1,gxo2,gyo1,gyo2,factor
  real*4 :: wsize,aaz,yoffset
  integer :: ier,nqx,nqy,nstx,nsty,ix1,ix2,ix3,iy1,iy2,iy3
  real(kind=4), pointer :: swdata(:,:)
  real(kind=4), allocatable :: xwork(:),ywork(:)
  real(kind=4), allocatable :: zdata(:,:)
  logical :: doswap
  real :: blnk3d,rcblank,reblank
  !
  save alt,az,factor,goff
  ! Data
  data alt /30./, az/45./, factor/1./, goff/0./
  ! Code
  ! Check whether one can do something
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
    return
  endif
  ! Get a R4 blanking value
  rcblank = cblank
  reblank = eblank
  !
  ! Define size approximately the one of box
  wsize = 0.8
  goff  = 0.0
  !
  ! Set up parameters
  lower = sic_present(2,0)
  vert_flag = sic_present(7,0)
  call sic_r4 (line,0,1,alt,.false.,error)
  if (error) return
  call sic_r4 (line,0,2,az,.false.,error)
  if (error) return
  call sic_r4 (line,1,1,factor,.false.,error)
  if (error) return
  call sic_r4 (line,1,2,goff,.false.,error)
  if (error) return
  !
  ! If /CENTER option, change size for a square box
  if (sic_present(6,0)) then
    aaz = abs(az)
    if (aaz.le.45) then
      wsize=(1.5+0.1*exp(-aaz))/2.5
    elseif (aaz.le.135) then
      wsize=(1.5+0.1*exp(-abs(aaz-90.)))/2.5
    elseif (aaz.le.225) then
      wsize=(1.5+0.1*exp(-abs(aaz-180.)))/2.5
    elseif (aaz.le.315) then
      wsize=(1.5+0.1*exp(-abs(aaz-270.0)))/2.5
    endif
    ! Change offset also
    yoffset=((90.0-abs(alt))/20.)*(gy2-gy1)/20.0
    if (abs(alt).le.90.0) then
      goff=goff-yoffset
    elseif (abs(alt).le.180.0) then
      goff=goff+yoffset
    endif
  endif
  xlen = wsize*(gx2-gx1)
  ylen = wsize*(gy2-gy1)
  !
  ! Compute Z scaling factor
  if (.not.sic_present(7,2)) then
    call rgextr (0,zmin,zmax,rg%data,rcblank,reblank,.false.)
  endif
  if (vert_flag) then
    call sic_r4 (line,7,1,zmin,.false.,error)
    if (error) return
    call sic_r4 (line,7,2,zmax,.false.,error)
    if (error) return
  endif
  if (zmax-zmin.gt.0.0) then
    zfac = ylen*factor/(zmax-zmin)/1.5
  else
    zfac = 1.0
  endif
  zoff = -zmin
  !
  ! Axis bounds
  xl1=rg%xval+(1.0d0-rg%xref)*rg%xinc   ! Pas 0.5 comme dans RGMAP ?
  xl2=rg%xval+(rg%nx-rg%xref)*rg%xinc      ! Pas NX+0.5 comme dans RGMAP ?
  yl2=rg%yval+(1.0d0-rg%yref)*rg%yinc
  yl1=rg%yval+(rg%ny-rg%yref)*rg%yinc
  ! Plot axe information. Logical DOAXES used elsewhere, not here.
  if (sic_present(5,0)) then
    call sic_r4 (line,5,1,xl1,.false.,error)
    if (error) return
    call sic_r4 (line,5,2,xl2,.false.,error)
    if (error) return
    call sic_r4 (line,5,4,yl1,.false.,error)
    if (error) return
    call sic_r4 (line,5,3,yl2,.false.,error)
    if (error) return
  endif
  !
  if (.not.sic_present(3,0)) then
    ! No /LINES option, use perspective with both line directions
    !
    ! Swap image if needed
    if ( (gux2-gux1)*sign(1.d0,rg%xinc).gt.0) then
      ix1 = rg%nx
      ix2 = 1
      ix3 = -1
      doswap = .true.
    else
      ix1 = 1
      ix2 = rg%nx
      ix3 = 1
      doswap = .false.
    endif
    if ( (guy2-guy1)*sign(1.d0,rg%yinc).gt.0) then
      iy1 = 1
      iy2 = rg%ny
      iy3 = 1
    else
      iy1 = rg%ny
      iy2 = 1
      iy3 = -1
      doswap = .true.
    endif
    !
    ! /STEP option : load subset of map in buffer
    if (sic_present(4,0)) then
      call sic_i4 (line,4,2,nsty,.true.,error)
      if (error) return
      call sic_i4 (line,4,1,nstx,.true.,error)
      if (error) return
      nstx = max(nstx,1)
      nsty = max(nsty,1)
      if (nstx.ge.rg%nx) then
        call greg_message(seve%e,rname,'Step in X too large')
        error = .true.
        return
      endif
      if (nsty.ge.rg%ny) then
        call greg_message(seve%e,rname,'Step in Y too large')
        error = .true.
        return
      endif
      nqx = rg%nx/nstx
      if (nqx*nstx.ne.rg%nx) nqx=nqx+1
      nqy = rg%ny/nsty
      if (nqy*nsty.ne.rg%ny) nqy=nqy+1
      ix3 = nstx*ix3
      iy3 = nsty*iy3
      doswap = .true.
    else
      nqx = rg%nx
      nqy = rg%ny
    endif
    !
    ! Get work space
    l = 2*min(nqx,nqy)+1
    allocate(xwork(l),ywork(l),stat=ier)
    if (failed_allocate(rname,'xwork and ywork buffers',ier,error))  return
    !
    ! Get swap area
    if (doswap) then
      allocate(swdata(nqx,nqy),stat=ier)
      if (failed_allocate(rname,'swdata buffer',ier,error)) then
        deallocate(xwork,ywork)
        return
      endif
      call pswap (rg%data,rg%nx,rg%ny,swdata,nqx,nqy,ix1,ix2,ix3,iy1,iy2,iy3)
    else
      swdata => rg%data
    endif
    ! use a patch for blanked values:
    blnk3d = zmin
    !
    ! Set full page clipping window for this command
    gxo1 = gx1
    gxo2 = gx2
    gyo1 = gy1
    gyo2 = gy2
    gx1  = lx1
    gx2  = lx2
    gy1  = ly1
    gy2  = ly2
    !
    ! Rotate extra 90.0 degrees
    azi = az+90.0
    !
    ! Take care of bottom view
    xoff = 0.5*(gx2+gx1)
    if (lower) then
      alt = -alt
      zfac = -zfac
      yoff = -goff-0.5*(gy2+gy1) + ly2+ly1
    else
      yoff = goff+0.5*(gy2+gy1)
    endif
    call plt3d (swdata,nqx,nqy,xwork,ywork,l,alt,azi,xlen,xoff,ylen,yoff,  &
      zfac,zoff,blnk3d,rcblank,reblank,ier)
    !
    ! Signal any error
    if (ier.ne.0) then
      error = .true.
      if (ier.eq.1) then
        call greg_message(seve%e,rname,'Internal buffer too small')
      elseif (ier.eq.2) then
        call greg_message(seve%e,rname,'Insufficient work space')
      elseif (ier.eq.-1) then
        call greg_message(seve%e,rname,'Aborted by ^C')
      else
        call greg_message(seve%e,rname,'Unknown Error')
      endif
    endif
    !
    ! Reset previous situation
    if (lower) then
      alt = -alt
      zfac = -zfac
      yoff = goff+0.5*(gy2+gy1)
    endif
    gx1  = gxo1
    gx2  = gxo2
    gy1  = gyo1
    gy2  = gyo2
    ! Plot axes After:
    doaxes = sic_present(5,0)
    if (doaxes) then
      call plt3d (swdata,nqx,nqy,xwork,ywork,l,alt,azi,xlen,xoff,ylen,yoff,  &
        zfac,zoff,blnk3d,rcblank,reblank,ier)
      doaxes=.false.
    endif
    if (doswap) then
      deallocate(swdata)
      doswap = .false.
    endif
    deallocate(xwork,ywork)
    !
  else
    ! /LINES option
    nqx  = rg%nx
    nqy  = rg%ny
    if (sic_present(2,0)) then
      call greg_message(seve%e,rname,'/LOWER not implemented for /LINES')
      error = .true.
      return
    endif
    xoff = 0.5*(gx2+gx1)
    yoff = goff+0.5*(gy2+gy1)
    gxo1 = gx1
    gxo2 = gx2
    gyo1 = gy1
    gyo2 = gy2
    gx1  = lx1
    gx2  = lx2
    gy1  = ly1
    gy2  = ly2
    allocate(zdata(nqx,nqy),stat=ier)
    if (failed_allocate(rname,'zdata buffer',ier,error))  return
    zdata(:,:) = rg%data(:,:)
    call zmont(zdata,nqx,1,nqx,1,nqy,xoff,yoff,xlen,ylen,az,alt,zfac)
    deallocate(zdata)
    gx1  = gxo1
    gx2  = gxo2
    gy1  = gyo1
    gy2  = gyo2
  endif
end subroutine threed
!
subroutine pswap (xin,nx,ny,xout,mx,my,ix1,ix2,ix3,iy1,iy2,iy3)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: xin(nx,ny)                !
  integer :: mx                     !
  integer :: my                     !
  real :: xout(mx,my)               !
  integer :: ix1                    !
  integer :: ix2                    !
  integer :: ix3                    !
  integer :: iy1                    !
  integer :: iy2                    !
  integer :: iy3                    !
  ! Local
  integer :: i,j,k,l
  !
  l = 0
  do j=iy1,iy2,iy3
    l = l+1
    k = 0
    do i=ix1,ix2,ix3
      k = k+1
      xout(k,l) = xin(i,j)
    enddo
  enddo
end subroutine pswap
!
subroutine plt3d(a,m,n,x,y,l,alt,az,xlen,xoff,ylen,yoff,zfac,zoff,blnk3d,  &
  rgblank,eblank,ier)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>plt3d
  use greg_axes
  !---------------------------------------------------------------------
  ! @ private
  ! 3D plot routine, adapted from SAS-3 routine of same name
  !---------------------------------------------------------------------
  integer :: m     ! Dimensions of data array A
  integer :: n     ! Dimensions of data array A
  real :: a(m,n)   ! Array, represents height of surface as function of location in plane
  integer :: l     ! Length of work arrays, .GE. 2*MIN(M,N)
  real :: x(l)     ! Real work array
  real :: y(l)     ! Real work array
  real :: alt      ! Altitude viewing angle in degrees
  real :: az       ! Azimuth viewing angle in degrees
  real :: xlen     ! Length of unprojected X axis in plot coordinates
  real :: xoff     ! Offset of origin in plot coordinates
  real :: ylen     ! Length of unprojected Y axis in plot coordinates
  real :: yoff     ! Offset of origin in plot coordinates
  real :: zfac     ! Scaling of Z-axis from data units to unprojected plot coordinates
  real :: zoff     ! Offset of Z-origin in plot coordinates
  real :: blnk3d   !
  real :: rgblank  !
  real :: eblank   !
  integer :: ier   ! Returns 0 for no error
  ! Local
  integer :: lmax,iaz,ifirst,istep,ilast,jfirst,jstep,jlast
  integer :: lli,ic,ibeg,lnth,ll,i,jbeg,j,lll
  real :: taz,talt,saz,sal,caz,cal,xsc,ysc
  real :: a1,a2,a3,b1,b2,b3,b4,xx,yy
  !
  logical :: error
  !
  ier = 0
  !
  taz = az*0.0174532925
  talt = alt*0.0174532925
  !
  saz = sin(taz)
  caz = cos(taz)
  sal = sin(talt)
  cal = cos(talt)
  !
  xsc = xlen/float(n-1)
  ysc = ylen/float(m-1)
  a1 = caz*xsc
  a2 = -saz*ysc
  a3 = xoff-0.5*(a1*float(n+1)+a2*float(m+1))
  b1 = saz*sal*xsc
  b2 = caz*sal*ysc
  b3 = zfac*cal
  b4 = b3*zoff+yoff-0.5*(b1*float(n+1)+b2*float(m+1))
  !
  ! Plot the axes if needed
  if (doaxes) then
    call sub_axes(a,m,n,a3,a2,a1,b1,b2,b3,b4,saz,caz,blnk3d)
    doaxes = .false.
    return
  endif
  error = .false.
  call gr_segm('PERSP',error)
  !
  ! Is buffer large enough ?
  lmax = 2*min(m,n)
  if (l.lt.lmax) then
    ier = 2
    return
  endif
  !
  iaz = 1
  if (a1 .le. 0.0) iaz = iaz+1
  if (a2 .le. 0.0) iaz = iaz+2
  !
  if (iaz.eq.2 .or. iaz.eq.4) then
    ifirst = m
    istep = -1
    ilast = 1
  else
    ifirst = 1
    istep = 1
    ilast = m
  endif
  !
  if (iaz.eq.1 .or. iaz.eq.2) then
    jfirst = n
    jstep = -1
    jlast = 1
  else
    jfirst = 1
    jstep = 1
    jlast = n
  endif
  !
  if (iaz.eq.1 .or. iaz.eq.4) then
    lli = -1
  else
    lli = 1
  endif
  !
  ic = 0
  ibeg = ifirst+istep
  !
  ! OK ready to go
  lll = 0
70 continue
  lnth = min(2*iabs(ibeg-ifirst)+1,lmax)
  if (lli.eq.-1) then
    ll = lnth+1
  else
    ll = 0
  endif
  i = ibeg
  j = jfirst
  xx = float(j)
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
80 i = i-istep
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll = lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (j.eq.jlast) goto 85
  j = j+jstep
  xx = float(j)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll = lll+1
  else
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (i.ne.ifirst) goto 80
  !
  !85    CALL NXTVU(IC,X,Y,LNTH,IER)
85 continue
  if (lll.gt.0) then
    if (lli.eq.-1) then
      call nxtvu(ic,x(ll),y(ll),lll,ier)
    else
      call nxtvu(ic,x(ll-lll+1),y(ll-lll+1),lll,ier)
    endif
    if (ier.ne.0) return
  endif
  lll=0
  ic = 1
  if (ibeg.eq.ilast) goto 90
  ibeg = ibeg+istep
  goto 70
  !
90 jbeg = jfirst
100 lnth = min(2*iabs(jbeg-jlast)+1,lmax)
  if (lli.eq.-1) then
    ll = lnth+1
  else
    ll = 0
  endif
  i = ilast
  j = jbeg
  xx = float(j)
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
110 j = j+jstep
  xx = float(j)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (i.eq.ifirst) goto 120
  i = i-istep
  yy = float(i)
  ll = ll+lli
  x(ll) = a1*xx+a2*yy+a3
  if (sic_fini4(a(i,j)).and.abs(a(i,j)-rgblank).gt.eblank) then
    y(ll) = b1*xx+b2*yy+b3*a(i,j)+b4
    lll=lll+1
  else                         ! NaNs and INFs are here
    y(ll) = b1*xx+b2*yy+b3*blnk3d+b4
    if(lll.gt.1) then
      if (lli.eq.-1) then
        call nxtvu(ic,x(ll+1),y(ll+1),lll,ier)
      else
        call nxtvu(ic,x(ll-lll),y(ll-lll),lll,ier)
      endif
      if (ier.ne.0) return
    endif
    lll=0
  endif
  if (j.ne.jlast) goto 110
  !
  !120   CALL NXTVU(1,X,Y,LNTH,IER)
120 continue
  if(lll.gt.0) then
    if (lli.eq.-1) then
      call nxtvu(ic,x(ll),y(ll),lll,ier)
    else
      call nxtvu(ic,x(ll-lll+1),y(ll-lll+1),lll,ier)
    endif
    if (ier.ne.0) return
  endif
  lll=0
  jbeg = jbeg+jstep
  if (jbeg.eq.jlast) goto 999
  goto 100
  !
999 continue
  !
  call gtsegm_close(error)
  !
end subroutine plt3d
!
subroutine nxtvu(ic,x,y,n,ier)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>nxtvu
  use greg_kernel
  use greg_nxtv1
  use greg_hautbas
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Find the next vector visible and plot it.
  !---------------------------------------------------------------------
  integer :: ic           ! Integer code                         Input
  integer :: n            ! Length of X and Y arrays             Input
  real :: x(n)            ! Work array
  real :: y(n)            ! Work array
  integer :: ier          ! Error code                           Output
  ! Local
  integer :: i,j,jj,ii,iov0,isw,iov1
  real :: ya0,yb0,xl,yl,x0,x1,ya1,yb1,frac,xi,yi
  !
  if (sic_ctrlc()) then
    ier = -1
    return
  endif
  if (n.gt.nn) then
    ier = 1
    return
  endif
  !
  ! First: always visible...
  if (ic.eq.0) then
    ll = nn-n+1
    i = ll
    xx(i) = x(1)
    yy(i) = y(1)
    if (lower) then
      call grelocate(xx(ll),ly2-yy(ll))
    else
      call grelocate(xx(ll),yy(ll))
    endif
    do j = 2,n
      i = i+1
      xx(i) = x(j)
      yy(i) = y(j)
      if (lower) then
        call gdraw(xx(i),ly2-yy(i))
      else
        call gdraw(xx(i),yy(i))
      endif
    enddo
    ier = 0
    return
  endif
  !
  ! Case IC not 0: check what is hidden
  ii = 1
  jj = ll
  kk = 0
  ya0 = y(1)
  yb0 = yy(ll)
  if (x(1).le.xx(ll)) then
    !
    ! X(1) <= X(LL)
    if (lower) then
      call grelocate(x(1),ly2 - ya0)
    else
      call grelocate(x(1),ya0)
    endif
40  call outp(x(ii),y(ii),ier)
    if (ii.eq.n) goto 360
    ii = ii+1
    ya0 = y(ii)
    if (x(ii) .gt. xx(ll)) goto 50
    if (lower) then
      call gdraw(x(ii),ly2 - ya0)
    else
      call gdraw(x(ii),ya0)
    endif
    goto 40
    !
50  ii = ii-1
    xl = x(ii)
    yl = y(ii)
    ya0 = alin(x(ii),x(ii+1),y(ii),y(ii+1),xx(ll))
    x0 = xx(ll)
    if (ya0 .gt. yb0) then
      iov0 = 1
    else
      if (lower) then
        call gdraw(x0,ly2 - ya0)
      else
        call gdraw(x0,ya0)
      endif
      call outp(x0,ya0,ier)
      call outp(x0,yb0,ier)
      iov0 = 0
    endif
    !
    ! X(1) > X(LL)
  else
70  call outp(xx(jj),yy(jj),ier)
    if (jj.eq.nn) goto 380
    jj = jj+1
    yb0 = yy(jj)
    if (x(1).ge.xx(jj)) goto 70
    !
    jj = jj-1
    yb0 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x(1))
    x0 = x(1)
    if (ya0 .le. yb0) then
      iov0 = 0
    else
      call outp(x0,yb0,ier)
      call outp(x0,ya0,ier)
      xl = x0
      yl = ya0
      iov0 = 1
    endif
  endif
  !
  ! Common block
120 continue
  if (ii.eq.n) goto 300
  if (jj.eq.nn) goto 310
  if (x(ii+1) .le. xx(jj+1)) then
    isw = +1
    ii = ii+1
    x1 = x(ii)
    ya1 = y(ii)
    yb1 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x1)
  else
    if (xx(jj+1) .ge. x(n)) goto 340
    isw = -1
    jj = jj+1
    x1 = xx(jj)
    ya1 = alin(x(ii),x(ii+1),y(ii),y(ii+1),x1)
    yb1 = yy(jj)
  endif
  if (ya1 .le. yb1) goto 160
  iov1 = 1
  if (iov0.eq.0) goto 170
150 continue
  if (isw.eq.-1) goto 200
  call outp (x1,ya1,ier)
  if (lower) then
    call grelocate(xl,ly2-yl)
    call gdraw(x1,ly2-ya1)
  else
    call grelocate(xl,yl)
    call gdraw(x1,ya1)
  endif
  xl = x1
  yl = ya1
  goto 200
160 iov1 = 0
  if (iov0.eq.0) goto 190
170 frac = (yb0-ya0)/(ya1-yb1+yb0-ya0)
  xi = (x1-x0)*frac+x0
  yi = (ya1-ya0)*frac+ya0
  call outp(xi,yi,ier)
  if (iov0.eq.0) goto 180
  if (lower) then
    call grelocate(xl,ly2 - yl)
    call gdraw(xi,ly2 - yi)
  else
    call grelocate(xl,yl)
    call gdraw(xi,yi)
  endif
  xl = xi
  yl = yi
  goto 190
180 xl = xi
  yl = yi
  goto 150
  !
190 continue
  if (isw.eq.+1) goto 200
  call outp(xx(jj),yy(jj),ier)
200 continue
  if (ier.ne.0) return
  x0 = x1
  ya0 = ya1
  yb0 = yb1
  iov0 = iov1
  goto 120
  !
  ! Exit tests
310 x1 = xx(nn)
  ya1 = alin(x(ii),x(ii+1),y(ii),y(ii+1),x1)
  yb1 = yy(nn)
  if (ya1 .gt. yb1) goto 320
  call outp(x1,yb1,ier)
  call outp(x1,ya1,ier)
  if (lower) then
    call grelocate(x1,ly2 - ya1)
  else
    call grelocate(x1,ya1)
  endif
  goto 330
380 ii = 1
320 continue
  if (lower) then
    call grelocate(x(ii),ly2-y(ii))
  else
    call grelocate(x(ii),y(ii))
  endif
330 if (ii.eq.n) goto 400
  ii = ii+1
  call outp(x(ii),y(ii),ier)
  if (lower) then
    call gdraw(x(ii),ly2-y(ii))
  else
    call gdraw(x(ii),y(ii))
  endif
  goto 330
300 continue
  if (jj.eq.nn) goto 400
340 x1 = x(n)
  ya1 = y(n)
  yb1 = alin(xx(jj),xx(jj+1),yy(jj),yy(jj+1),x1)
  if (ya1 .le. yb1) goto 350
  call outp(x1,ya1,ier)
  call outp(x1,yb1,ier)
  if (lower) then
    call grelocate(xl,ly2 - yl)
    call gdraw(x1,ly2 - ya1)
  else
    call grelocate(xl,yl)
    call gdraw (x1,ya1)
  endif
350 continue
  if (jj.eq.nn) goto 400
  jj = jj+1
  call outp(xx(jj),yy(jj),ier)
  goto 350
360 jj = 0
  goto 350
400 ll = nn-kk+1
  i = ll
  do j = 1,kk
    xx(i) = xx(j)
    yy(i) = yy(j)
    i = i+1
  enddo
end subroutine nxtvu
!
subroutine outp(x,y,ier)
  use greg_nxtv1
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Buffers the vector to keep track of vectors plotted
  !---------------------------------------------------------------------
  real :: x                         !              Input
  real :: y                         !              Input
  integer :: ier                    ! Error code   Output
  ! Local
  real, parameter :: eps=.001
  !
  if (kk.eq.0) then
    kk = 1
    xx(1) = x
    yy(1) = y
  elseif (kk.eq.ll-1) then
    ier = 1
  elseif (abs(xx(kk)-x)+abs(yy(kk)-y) .ge. eps) then
    kk = kk+1
    xx(kk) = x
    yy(kk) = y
  endif
end subroutine outp
!
function alin(x0,x1,y0,y1,x)
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Find the Y coordinate of absissae X along line (X0,Y0)-->(X1,Y1)
  !---------------------------------------------------------------------
  real :: alin          ! Y coordinate of point                 Output
  real :: x0            ! X coordinate of start point           Input
  real :: x1            ! X coordinate of end point             Input
  real :: y0            ! Y coordinate of start point           Input
  real :: y1            ! Y coordinate of end point             Input
  real :: x             ! X coordinate of point                 Input
  !
  if (x0.ne.x1) then
    alin = (x-x0)*(y1-y0)/(x1-x0)+y0
  elseif (y1.gt.y0) then
    alin = y1
  else
    alin = y0
  endif
end function alin
!
subroutine sub_axes(a,m,n,a3,a2,a1,b1,b2,b3,b4,saz,caz,blnk3d)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>sub_axes
  use greg_pen
  use greg_axes
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Cette routine trace les axes sur la vue en perspective lorsque
  ! l'option /AXES est presente dans la commande PERSPECTIVE.
  !---------------------------------------------------------------------
  integer :: m                      !
  integer :: n                      !
  real :: a(m,n)                    !
  real :: a3                        !
  real :: a2                        !
  real :: a1                        !
  real :: b1                        !
  real :: b2                        !
  real :: b3                        !
  real :: b4                        !
  real :: saz                       !
  real :: caz                       !
  real :: blnk3d                    !
  ! Local
  real :: zz,ex1,ey1,ex2,ey2,ex3,ey3,ex4,ey4
  real :: eyy1,eyy2,eyy3,eyy4,zmin1,zmin2,zmin3,zmin4
  real :: zmax1,zmax2,zmax3,zmax4, aval
  real :: alpha1,beta1,alpha2,beta2,alpha3,beta3,alpha4,beta4
  real :: zlx1,zlx2,zlx3,zlx4, zly1,zly2,zly3,zly4, zlzz
  real, parameter :: pi=3.141592653
  logical :: error
  !
  ! Base thickness is proportional to ZMIN-ZMAX
  zz  =  zmin-0.1*(zmax-zmin)
  !
  ! The 8 corners of the box. Patched for INFs and NaNs
  ex1 = a3+a2+a1
  ey1 = b1+b2+b4+b3*a(1,1)
  if ((ey1.eq.ey1+1) .or. .not.(ey1.eq.ey1))  ey1=b1+b2+b4+b3*blnk3d
  ex3 = a1*n+a2*m+a3
  ey3 = b1*n+b2*m+b3*a(m,n)+b4
  if ((ey3.eq.ey3+1) .or. .not.(ey3.eq.ey3))  ey3=b1*n+b2*m+b3*blnk3d+b4
  ex2 = a1*n+a2+a3
  ey2 = b1*n+b2+b4+b3*a(1,n)
  if ((ey2.eq.ey2+1) .or. .not.(ey2.eq.ey2))  ey2=b1*n+b2+b4+b3*blnk3d
  ex4 = a1+a2*m+a3
  ey4 = b1+b2*m+b3*a(m,1)+b4
  if ((ey4.eq.ey4+1) .or. .not.(ey4.eq.ey4))  ey4=b1+b2*m+b3*blnk3d+b4
  eyy4 = b1+b2*m+b3*zz+b4
  eyy3 = b1*n+b2*m+b4+b3*zz
  eyy2 = b1*n+b2+b4+b3*zz
  eyy1 = b1+b2+b4+b3*zz
  !
  ! Define vertical axis
  zmin1 = b1+b2+b4+b3*zmin
  zmin2 = b1*n+b2+b4+b3*zmin
  zmin3 = b1*n+b2*m+b4+b3*zmin
  zmin4 = b1+b2*m+b4+b3*zmin
  zmax1 = b1+b2+b4+b3*zmax
  zmax2 = b1*n+b2+b4+b3*zmax
  zmax3 = b1*n+b2*m+b4+b3*zmax
  zmax4 = b1+b2*m+b4+b3*zmax
  zlzz  = zmax1-zmin1
  !
  ! Compute angles of axes
  if (ex1.eq.ex4) then
    alpha1 = 0.0
    beta4  =-90.0
  else
    aval  =  (eyy1-eyy4)/(ex1-ex4)
    alpha1= atan(aval)*180.0/pi
    beta4 =-atan(-aval)*180.0/pi
  endif
  if (ex3.eq.ex4) then
    alpha2 = 0.0
    beta1  =-90.0
  else
    aval  =  (eyy4-eyy3)/(ex4-ex3)
    alpha2= atan(aval)*180.0/pi
    beta1 =-atan(-aval)*180.0/pi
  endif
  if (ex3.eq.ex2) then
    alpha3=0.0
    beta2 = -90.
  else
    aval  =  (eyy3-eyy2)/(ex3-ex2)
    alpha3=atan(aval)*180./pi
    beta2 =-atan(-aval)*180./pi
  endif
  if (ex2.eq.ex1) then
    alpha4= 0.0
    beta3 =-90.
  else
    aval  = (eyy2-eyy1)/(ex2-ex1)
    alpha4= atan(aval)*180./pi
    beta3 =-atan(-aval)*180./pi
  endif
  !
  ! Compute length of axes
  zlx1 = sqrt((ex1-ex4)**2+(eyy1-eyy4)**2)
  zlx2 = sqrt((ex4-ex3)**2+(eyy4-eyy3)**2)
  zlx3 = sqrt((ex3-ex2)**2+(eyy3-eyy2)**2)
  zlx4 = sqrt((ex2-ex1)**2+(eyy2-eyy1)**2)
  zly1 = zlx2
  zly2 = zlx3
  zly3 = zlx4
  zly4 = zlx1
  !
  ! Plot the corners
  error = .false.
  call gr_segm('3BOX',error)
  if (saz.le.0.0) then
    if (caz.le.0.0) then
      call permute(xl1,xl2)
      call echange(xl1,xl2,yl1,yl2)
      call grline(ex4,ey4,ex4,eyy4)
      call grline(ex2,ey2,ex2,eyy2)
      call grline(ex3,ey3,ex3,eyy3)
      call echange(xl1,xl2,yl1,yl2)
      call permute(xl1,xl2)
    else
      call permute(xl1,xl2)
      call permute(yl1,yl2)
      call grline(ex1,ey1,ex1,eyy1)
      call grline(ex3,ey3,ex3,eyy3)
      call grline(ex2,ey2,ex2,eyy2)
      call permute(xl1,xl2)
      call permute(yl1,yl2)
    endif
  else
    if (caz.ge.0.0) then
      call permute(yl1,yl2)
      call echange(xl1,xl2,yl1,yl2)
      call grline(ex4,ey4,ex4,eyy4)
      call grline(ex2,ey2,ex2,eyy2)
      call grline(ex1,ey1,ex1,eyy1)
      call echange(xl1,xl2,yl1,yl2)
      call permute(yl1,yl2)
    else
      call grline(ex3,ey3,ex3,eyy3)
      call grline(ex1,ey1,ex1,eyy1)
      call grline(ex4,ey4,ex4,eyy4)
    endif
  endif
  call gtsegm_close(error)
  if (error)  return
  !
  ! Now the real axis
  if (saz.le.0.0) then
    if (caz.le.0.0) then
      call permute(xl1,xl2)
      call echange(xl1,xl2,yl1,yl2)
      call traxes(alpha2,beta2,ex3,eyy3,zlx2,zly2,ex2,eyy2,ex4,eyy4,zmin2,zlzz)
      call echange(xl1,xl2,yl1,yl2)
      call permute(xl1,xl2)
    else
      call permute(xl1,xl2)
      call permute(yl1,yl2)
      call traxes(alpha3,beta3,ex2,eyy2,zlx3,zly3,ex1,eyy1,ex3,eyy3,zmin1,zlzz)
      call permute(xl1,xl2)
      call permute(yl1,yl2)
    endif
  else
    if (caz.ge.0.0) then
      call permute(yl1,yl2)
      call echange(xl1,xl2,yl1,yl2)
      call traxes(alpha4,beta4,ex1,eyy1,zlx4,zly4,ex4,eyy4,ex2,eyy2,zmin4,zlzz)
      call echange(xl1,xl2,yl1,yl2)
      call permute(yl1,yl2)
    else
      call traxes(alpha1,beta1,ex4,eyy4,zlx1,zly1,ex3,eyy3,ex1,eyy1,zmin3,zlzz)
    endif
  endif
  !
end subroutine sub_axes
!
subroutine traxes (alpha,beta,ex,exx,zlxx,zlyy,ey,eyy,ez,ezz,vz,zlzz)
  use greg_interfaces, except_this=>traxes
  use greg_axes
  use greg_xyz
  use greg_hautbas
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Internal routine
  ! Cette routine est utilisee par la routine SUB_AXES pour afficher ces
  ! axes
  !---------------------------------------------------------------------
  real :: alpha              ! Orientation de l'axe des abscisses
  real :: beta               ! Orientation de l'axe des ordonnees
  real :: ex                 ! abscisse du coin apparaissant au centre
  real :: exx                ! ordonnee du coin apparaissant au centre
  real :: zlxx               ! longueur de l'axe des abscisses
  real :: zlyy               ! longueur de l'axe des ordonnees
  real :: ey                 ! abscisse du coin apparaissant a gauche
  real :: eyy                ! ordonnee du coin apparaissant a gauche
  real :: ez                 ! abscisse du coin apparaissant a droite
  real :: ezz                ! ordonnee du coin apparaissant a droite
  real :: vz                 ! ordonnee du bas de l'axe vertical
  real :: zlzz               ! longueur de l'axe des donnees
  ! Local
  character(len=4) :: atype
  character(len=1) :: ochar
  character(len=120) :: line
  real :: esp,angsav1,angsav2
  real, parameter :: pi=3.141592653
  !
  call inqang(angsav1,angsav2)
  esp = abs(ez-ey)
  !
  ! X Axis : check visibility and plot
  if ((abs(ez-ex).ge.0.5) .or. (abs(ezz-exx).ge.0.2)) then
    call setang(alpha,angsav2)
    if (alpha.gt.60.0) then
      ochar = 'O'
    else
      ochar = 'P'
    endif
    write (line,100) ' XL ',xl1,xl2,ex,exx,zlxx,ochar
    call gr_exec1(line)
    if (gr_error()) goto 99
    !
    ! Text below X axis
    xposx = ex+0.5*(ez-ex)+(.5+esp/11.0)*sin(pi*alpha/180.0)
    xposy = exx+0.5*(ezz-exx)-(.5+esp/11.0)*cos(pi*alpha/180.0)
  endif
  !
  ! Y Axis: Check visibility and plot
  if ((abs(ey-ex).ge.0.5) .or. (abs(eyy-exx).ge.0.2)) then
    if (beta.gt.-60.0) then
      call setang(beta,angsav2)
      atype = ' XL '
      ochar = 'P'
      write(line,100) atype,yl1,yl2,ey,eyy,zlyy,ochar
    else
      !
      call setang(90.0+beta,angsav2)
      atype = ' YL '
      ochar = 'O'
      !
      !            WRITE(LINE,100) ATYPE,YL1,YL2,EY,EYY,ZLYY,OCHAR
      ! Note reverse axis starting from end
      write(line,100) atype,yl2,yl1,ex,exx,zlyy,ochar
    endif
    call gr_exec1(line)
    if (gr_error()) goto 99
    !
    ! Text below Y axis
    yposx=ey+0.5*(ex-ey)-(.5+esp/11.0)*sin(-beta*pi/180.0)
    yposy=exx+0.5*(eyy-exx)-(.5+esp/11.0)*cos(-beta*pi/180.0)
  endif
  !
  ! Z axis if required
  if (vert_flag) then
    call setang(0.0,angsav2)
    write(line,100) ' YL ',zmin,zmax,ey,vz,zlzz,'O'
    call gr_exec1(line)
    if (gr_error()) goto 99
  endif
99 call setang(angsav1,angsav2)
  return
100 format('AXIS',a,2(1x,e15.7),' /LOCATION ',3(1x,f8.2),  &
      ' /TICK OUT /LABEL ',a)
end subroutine traxes
!
subroutine echange (xl1,xl2,yl1,yl2)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real*4 :: xl1                     !
  real*4 :: xl2                     !
  real*4 :: yl1                     !
  real*4 :: yl2                     !
  ! Local
  real*4 :: varint
  !
  varint = xl1
  xl1 = yl1
  yl1 = varint
  varint = xl2
  xl2 = yl2
  yl2 = varint
end subroutine echange
!
subroutine permute (val1,val2)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real*4 :: val1                    !
  real*4 :: val2                    !
  ! Local
  real*4 :: varint
  !
  varint = val1
  val1 = val2
  val2 = varint
end subroutine permute

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_noise
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  use cubemain_range
  use cubemain_windowing
  !
  public :: noise
  private
  !
  type :: noise_comm_t
     type(option_t), pointer :: comm
     type(cubeid_arg_t), pointer :: sig
     type(cubeid_arg_t), pointer :: win
     type(cube_prod_t),  pointer :: noi
     type(option_t), pointer :: mad     
     type(option_t), pointer :: nchan
     type(range_opt_t)       :: range
   contains
     procedure, public  :: register => cubemain_noise_comm_register
     procedure, private :: parse    => cubemain_noise_comm_parse
     procedure, private :: main     => cubemain_noise_comm_main
  end type noise_comm_t
  type(noise_comm_t) :: noise
  !
  type noise_user_t
     type(cubeid_user_t)   :: cubeids           ! Signal and window cubeids
     logical               :: dorange = .false. ! Do range 
     type(range_array_t)   :: range             ! Range(s) to be ignored
     logical               :: domad = .false.   ! Do MAD noise
     character(len=argu_l) :: nchan             ! Number of channels to be used in mad mode
   contains
     procedure, private :: toprog => cubemain_noise_user_toprog
  end type noise_user_t
  !
  type noise_prog_t
     logical               :: domad = .false.
     logical               :: dowin = .false.
     logical               :: doloc = .false.
     integer(kind=chan_k)  :: nchan = 0  ! number of channels to be used
     integer(kind=chan_k)  :: nnois = 0  ! Number of noise estimates
     integer(kind=chan_k)  :: nhalf = 0  ! Half number of used channels
     type(window_array_t)  :: glowin     ! One set of windows for the full index
     type(cube_t), pointer :: locwin     ! Number and positions of windows depend on the spectrum
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     procedure(cubemain_noise_prog_mad_loop), pointer :: loop => null()
   contains
     procedure, private :: header        => cubemain_noise_prog_header
     procedure, private :: data          => cubemain_noise_prog_data
     procedure, private :: mad_act       => cubemain_noise_prog_mad_act
     procedure, private :: glowin_act   => cubemain_noise_prog_glowin_act
     procedure, private :: locwin_act   => cubemain_noise_prog_locwin_act
     procedure, private :: compute_noise => cubemain_noise_prog_compute_noise
  end type noise_prog_t
  !
contains
  !
  subroutine cubemain_noise_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)  :: line
    logical,          intent(out) :: error
    !
    type(noise_user_t) :: user
    character(len=*), parameter :: rname='NOISE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call noise%parse(line,user,error)
    if (error) return
    call noise%main(user,error)
    if (error) return
  end subroutine cubemain_noise_command
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='NOISE>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'NOISE','[signalid [windowid]]',&
         'Compute the noise RMS of each spectrum of a cube',&
         'Compute one noise value per spectrum using global or local&
         & spectral windows.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /RANGE defines global signal ranges excluded from noise&
         & estimation.'//strg_cr//&
         '- Without /RANGE, NOISE resolves WINDOW from the second&
         & positional argument (windowid) when provided; otherwise&
         & through standard WINDOW cubeid resolution.'//strg_cr//&
         '- /MAD computes median-absolute-deviation noise and ignores&
         & /RANGE and WINDOW inputs.'//strg_cr//&
         '- /NCHAN sets the number of channels per noise block in both&
         & RMS and /MAD modes.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> NOISE 12co10:cube /RANGE -5 5 km/s'//strg_cr//&
         'CUBE> NOISE 12co10:cube 12co10:window'//strg_cr//&
         'CUBE> NOISE 12co10:cube /NCHAN 31.'//strg_cr//&
         'CUBE> NOISE 12co10:cube /NCHAN 31 /MAD',&
         cubemain_noise_command,&
         noise%comm,error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%sig,&
         error)
    if (error) return
    call incube%register(&
         'WINDOWID',&
         'Local spectral range(s) containing signal',&
         'Used only when /RANGE is absent: local per-spectrum windows&
         & are read from this cube (window flag). If omitted, use the&
         & last matching cube (window flag) in the default index (DAG&
         & by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_window],&
         code_read,&
         code_access_speset,&
         comm%win,&
         error)
    if (error) return
    !
    call noise%range%register(&
         'RANGE',&
         'Define global spectral range(s) containing signal',&
         range_is_multiple,error)
    if (error) return
    !
    call cubetools_register_option(&
         'MAD','',&
         'Compute Median Absolute Deviation noise instead of RMS',&
         strg_emp,&
         noise%mad,error)
    if (error) return
    !
    call cubetools_register_option(&
         'NCHAN','nchan',&
         'Number of channels per noise block (RMS and /MAD modes)',&
         strg_emp,&
         noise%nchan,error)
    if (error) return
    call stdarg%register(&
         'nchan',&
         'number of channels',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'NOISE',&
         'Cube of noise estimations',&
         strg_emp,&
         [flag_noise],&
         comm%noi,&
         error)
    if (error) return
  end subroutine cubemain_noise_comm_register
  !
  subroutine cubemain_noise_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! NOISE [signalid [windowid]]
    ! /NCHAN nchan
    ! /RANGE v11 v12 [... [vn1 vn2]] [unit]
    ! /MAD
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(noise_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%mad%present(line,user%domad,error)
    if (error) return
    call cubemain_noise_comm_parse_nchan(line,comm%nchan,1,user%nchan,error)
    if (error) return
    call comm%range%parse(line,user%dorange,user%range,error)
    if (error) return
  end subroutine cubemain_noise_comm_parse
  !
  subroutine cubemain_noise_comm_parse_nchan(line,opt,iarg,nchan,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),      intent(in)    :: line
    type(option_t),        intent(in)    :: opt
    integer(kind=4),       intent(in)    :: iarg
    character(len=argu_l), intent(out)   :: nchan
    logical,               intent(inout) :: error
    !
    logical :: present
    character(len=*), parameter :: rname='NOISE>COMM>PARSE>NCHAN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,opt,iarg,nchan,mandatory,error)
       if (error) return
    else
       nchan = strg_star
    endif
  end subroutine cubemain_noise_comm_parse_nchan
  !
  subroutine cubemain_noise_comm_main(comm,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_comm_t), intent(in)    :: comm
    type(noise_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(noise_prog_t) :: prog
    character(len=*), parameter :: rname='NOISE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_noise_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_user_t), intent(inout) :: user
    class(noise_comm_t), intent(in)    :: comm
    type(noise_prog_t),  intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    logical :: conspb
    integer(kind=chan_k) :: default
    character(len=*), parameter :: rname='NOISE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    default = 0
    call cubetools_user2prog_resolve_star(user%nchan,default,prog%nchan,error)
    if (error) return
    !
    call cubeadm_get_header(comm%sig,user%cubeids,prog%sig,error)
    if (error) return
    !
    prog%domad = user%domad
    if (user%domad) then
       ! No window searched
       prog%dowin = .false.
    else
       prog%dowin = .true.
       if (user%dorange) then
          ! Define a global window
          prog%doloc = .false.
          ! Ranges are truncated to avoid segfault
          user%range%val(:)%truncate = .true.
          call noise%range%user2prog(prog%sig,user%range,prog%glowin,error)
          if (error) return
       else
          prog%doloc = .true.
          conspb = .false.
          ! Search for a data cube with the definitions of the local windows
          call cubeadm_get_header(comm%win,user%cubeids,prog%locwin,error)
          if (error) return
          call cubetools_consistency_spatial(&
               'Input cube',prog%sig%head,&
               'Window',prog%locwin%head,&
               conspb,error)
          if (error) return
          if (cubetools_consistency_failed(rname,conspb,error)) return
       endif
    endif
    !
    if (prog%domad) then
       prog%loop => cubemain_noise_prog_mad_loop
    else if (prog%dowin) then
       if (prog%doloc) then
          prog%loop => cubemain_noise_prog_locwin_loop
       else
          prog%loop => cubemain_noise_prog_glowin_loop
       endif
    endif
  end subroutine cubemain_noise_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !---------------------------------------------------------------------- 
    ! To deal with edge effects, we cheat on the last frequency segment
    ! that we attribute beyond the original frequency range while we 
    ! always compute the noise inside this range. This should have no 
    ! consequence as the noise should be interpolated in frequency
    ! in later use.
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    type(noise_comm_t),  intent(in)    :: comm
    logical,             intent(inout) :: error
    !
    integer(kind=chan_k) :: in_nchan,nhalf
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='NOISE>PROG>HEADER'
    !
    if ((prog%domad).and.(prog%dowin)) then
       call cubemain_message(seve%e,rname,'Options /RANGE and /MAD are exclusives')
       error = .true.
       return
    else if (.not.((prog%domad).or.(prog%dowin))) then
       call cubemain_message(seve%e,rname,'Do not understand what you want')
       error = .true.
       return
    endif
    !
    call cubetools_header_get_nchan(prog%sig%head,in_nchan,error)
    if (error) return
    call cubeadm_clone_header(comm%noi,prog%sig,prog%noi,error)
    if (error) return
    if ((prog%nchan.lt.0).or.(prog%nchan.gt.in_nchan)) then
       call cubemain_message(seve%e,rname,'Number of asked channels outside cube range')
       error = .true.
       return
    else if (prog%nchan.eq.0) then
       ! Default value
       prog%nchan = in_nchan
       nhalf = prog%nchan
       prog%nnois = 1
    else
       ! User value
       ! Ensure that prog%nchan will be odd in output because the median definition 
       ! is simpler
       if (mod(prog%nchan,2).eq.0) then
          prog%nchan = prog%nchan-1
       endif
       nhalf = floor(0.5*prog%nchan)
       prog%nnois  = floor(dble(in_nchan)/dble(nhalf))
       if (nhalf*prog%nnois.lt.in_nchan) then
          prog%nnois = prog%nnois+1
       endif
    endif
    if ((prog%nchan.lt.5)) then
       call cubemain_message(seve%e,rname,'Minimum number of channels must be 5')
       error = .true.
       return
    else if (prog%nchan.gt.in_nchan) then
          call cubemain_message(&
               seve%e,rname,&
               'You asked to compute the noise rms on more samples than '//&
               'channels in the spectrum!')
       error = .true.
       return
    endif
    prog%nhalf = floor(0.5*prog%nchan)
    ! Update noise header accordingly
    call cubetools_header_put_nchan(prog%nnois,prog%noi%head,error)
    if (error) return
    call cubetools_header_multiply_spectral_spacing(nhalf,prog%noi%head,error)
    if (error) return
    call cubetools_header_rederive_spectral_axes(prog%noi%head,error)
    if (error) return
    ! User feedback
    write(mess,'(a,i0,a,i0,a)') &
         'Computing ',prog%nnois,' noise values, each using ',prog%nchan,' channels'
    call cubemain_message(seve%i,rname,mess)
  end subroutine cubemain_noise_prog_header
  !
  subroutine cubemain_noise_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='NOISE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,iter,error)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_noise_prog_data
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_mad_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe,good,noi
    character(len=*), parameter :: rname='NOISE>PROG>MAD>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spe%associate('spe',prog%sig,iter,error)
    if (error) return
    call good%allocate('good',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%mad_act(iter%ie,spe,good,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_mad_loop
  !
  subroutine cubemain_noise_prog_mad_act(prog,ie,spe,good,noi,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    use cubemain_spectrum_blanking
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    ! Compute a running median absolute deviation filter
    !----------------------------------------------------------------------
    class(noise_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: spe
    type(spectrum_t),     intent(inout) :: good
    type(spectrum_t),     intent(inout) :: noi
    logical,              intent(inout) :: error
    !  
    type(spectrum_t) :: line ! We just make the line%y%val array to point => No allocation
    integer(kind=chan_k) :: in,nn,nc
    integer(kind=chan_k) :: first,last,nhalf,nchan
    real(kind=sign_k) :: median
    character(len=*), parameter :: rname='NOISE>PROG>MAD>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    nchan = prog%nchan
    nhalf = floor(0.5*nchan)
    nn = noi%n
    nc = spe%n
    !
    call spe%get(ie,error)
    if (error) return
    first = 1
    do in=1,nn
       ! The following ensures that
       !    1) we never get past the number of channels
       !    2) we always compute the mad on nchan contiguous samples
       last  = min(first+nchan-1,nc)
       first = last-nchan+1
       call line%point_to(spe,first,last,1.0,error)
       if (error) return
       call good%unblank(line,error)
       if (error) return
       if (good%n.ge.1) then
          median = statistics%median(good%y%val,good%n)
          noi%y%val(in) = statistics%mad(good%y%val,good%n,median)
       else
          noi%y%val(in) = gr4nan
       endif
       first = first+nhalf
    enddo ! in
    call noi%put(ie,error)
    if (error) return   
  end subroutine cubemain_noise_prog_mad_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_locwin_loop(prog,iter,error)
    use cubetools_parameters
    use cubetools_header_methods
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    use cubemain_window_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k) :: nw
    type(window_t) :: win
    type(spectrum_t) :: spe,base,noi
    character(len=*), parameter :: rname='NOISE>LOCWIN>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_nchan(prog%locwin%head,nw,error)
    if (error) return
    if (nw.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    !
    call win%associate('win',prog%locwin,iter,error)
    if (error) return
    call spe%allocate('spe',prog%sig,iter,error)
    if (error) return
    call base%allocate('base',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%locwin_act(iter%ie,win,spe,base,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_locwin_loop
  !
  subroutine cubemain_noise_prog_locwin_act(prog,ie,win,spe,base,noi,error)
    use cubetools_nan
    use cubetopology_tool
    use cubeadm_spectrum_types
    use cubemain_window_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),  intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(window_t),       intent(inout) :: win
    type(spectrum_t),     intent(inout) :: spe
    type(spectrum_t),     intent(inout) :: base
    type(spectrum_t),     intent(inout) :: noi
    logical,              intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=chan_k) :: ichan(2)
    real(kind=coor_k) :: vrange(2)
    character(len=*), parameter :: rname='NOISE>LOCAL'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call spe%get(ie,error)
    if (error) return
    call win%get(ie,error)
    if (error) return
    ! Blank signal
    do iw=1,win%n/2 ! *** JP: This is dangerous. It should be a method of the window_t
       if (win%isblank(iw)) cycle
       vrange(:) = win%y%val(2*iw-1:2*iw)
       call cubetopology_tool_vrange2crange(prog%sig,vrange,ichan,error)
       if (error) return
       spe%y%val(ichan(1):ichan(2)) = gr4nan
    enddo
    call prog%compute_noise(spe,base,noi,error)
    if (error) return
    call noi%put(ie,error)
    if (error) return
  end subroutine cubemain_noise_prog_locwin_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_glowin_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(noise_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe,base,noi
    character(len=*), parameter :: rname='NOISE>WIN>GLOBAL>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%glowin%n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of windows')
       error = .true.
       return
    endif
    !
    call spe%allocate('spe',prog%sig,iter,error)
    if (error) return
    call base%allocate('base',prog%sig,error)
    if (error) return
    call noi%allocate('noi',prog%noi,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%glowin_act(iter%ie,spe,base,noi,error)
       if (error) return
    enddo
  end subroutine cubemain_noise_prog_glowin_loop
  !
  subroutine cubemain_noise_prog_glowin_act(prog,ie,spe,base,noi,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), target, intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(spectrum_t),            intent(inout) :: spe
    type(spectrum_t),            intent(inout) :: base
    type(spectrum_t),            intent(inout) :: noi
    logical,                     intent(inout) :: error
    !
    integer(kind=chan_k) :: iw
    type(window_array_t), pointer :: win
    character(len=*), parameter :: rname='NOISE>PROG>GLOWIN>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    win => prog%glowin
    !
    call spe%get(ie,error)
    if (error) return
    ! Blank signal
    do iw=1,win%n
       spe%y%val(win%val(iw)%o(1):win%val(iw)%o(2)) = gr4nan
    enddo
    call prog%compute_noise(spe,base,noi,error)
    if (error) return
    call noi%put(ie,error)
    if (error) return
  end subroutine cubemain_noise_prog_glowin_act
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_noise_prog_compute_noise(prog,spe,base,noi,error)
    use cubeadm_spectrum_types
    use cubemain_spectrum_computation_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(noise_prog_t), intent(inout) :: prog
    type(spectrum_t),    intent(inout) :: spe
    type(spectrum_t),    intent(inout) :: base
    type(spectrum_t),    intent(inout) :: noi
    logical,             intent(inout) :: error
    !
    type(spectrum_t) :: line
    integer(kind=chan_k) :: first,last,in
    character(len=*), parameter :: rname='NOISE>PROG>COMPUTE>NOISE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    first = 1
    do in=1,prog%nnois
       last  = min(first+prog%nchan-1,spe%n)
       first = last-prog%nchan+1
       call line%point_to(spe,first,last,1.0,error)
       if (error) return
       call base%unblank(line,error)
       if (error) return
       call spectrum_compute%rms(base,error)
       if (error) return
       noi%y%val(in) = base%noi
       first = first+prog%nhalf
    enddo
  end subroutine cubemain_noise_prog_compute_noise
end module cubemain_noise
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine mth_init
  call message(6,1,'MTH_INIT','Using NAG library')
end subroutine mth_init
!
subroutine mth_fitspl (name, nd, nk8, x, y, w, ks,   &
    wk1, wk2, cs, ss, error)
  character(len=*) :: name          !
  integer :: nd                     !
  integer :: nk8                    !
  real*8 :: x(nd)                   !
  real*8 :: y(nd)                   !
  real*8 :: w(nd)                   !
  real*8 :: ks(nk8)                 !
  real*8 :: wk1(nd)                 !
  real*8 :: wk2(4,nk8)              !
  real*8 :: cs(nk8)                 !
  real*8 :: ss                      !
  logical :: error                  !
  ! Local
  integer :: ifail, i
  character(len=60) :: chain
  !
  ! Fit splines
  ifail = 1
  error = .false.
  call e02baf(nd, nk8, x, y, w, ks, wk1, wk2, cs,   &
    ss, ifail)
  if (ifail.eq.5) then
    error = .true.
    call message(8,4,name,'Too many breaks')
    write(chain,*) 'Using ',nk8, ' breaks :'
    call message(4,1,name,chain)
    do i=1, nk8
      write(chain,*) i,' at ',ks(i+4)
      call message(4,1,name,chain)
    enddo
    error = .true.
  elseif (ifail.ne.0) then
    call mth_fail (name,'MTH_FITSPL',ifail,error)
  endif
end subroutine mth_fitspl
!
subroutine mth_fitpol(name,nd,ipol,m_pol,xxx,yyy,www,   &
    wk1,wk3,apol,spol,error)
  character(len=*) :: name          !
  integer :: nd                     !
  integer :: ipol                   !
  integer :: m_pol                  !
  real*8 :: xxx(nd)                 !
  real*8 :: yyy(nd)                 !
  real*8 :: www(nd)                 !
  real*8 :: wk1(3*nd)               !
  real*8 :: wk3(2*ipol)             !
  real*8 :: apol(m_pol,ipol)        !
  real*8 :: spol(ipol)              !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02adf(nd,ipol,m_pol,xxx,yyy,www,wk1,wk3,   &
    apol,spol,ifail)
  call mth_fail (name,'MTH_FITPOL',ifail,error)
end subroutine mth_fitpol
!
subroutine mth_getspl(name,nk8, ks, cs, xx, yy, error)
  character(len=*) :: name          !
  integer :: nk8                    !
  real*8 :: ks(nk8)                 !
  real*8 :: cs(nk8)                 !
  real*8 :: xx                      !
  real*8 :: yy                      !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02bbf(nk8, ks, cs, xx, yy, ifail)
  call nag_fail (name,'MTH_GETSPL',ifail,error)
end subroutine mth_getspl
!
subroutine mth_getspd(name,nk8, ks, cs, xx, left, yy, error)
  character(len=*) :: name          !
  integer :: nk8                    !
  real*8 :: ks(nk8)                 !
  real*8 :: cs(nk8)                 !
  real*8 :: xx                      !
  integer :: left                   !
  real*8 :: yy(4)                   !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02bcf(nk8, ks, cs, xx, left, yy, ifail)
  call nag_fail (name,'MTH_GETSPD',ifail,error)
end subroutine mth_getspd
!
subroutine mth_getpol(name,ipol,aa,xx,yy,error)
  character(len=*) :: name          !
  integer :: ipol                   !
  real*8 :: aa(ipol)                !
  real*8 :: xx                      !
  real*8 :: yy                      !
  logical :: error                  !
  ! Local
  integer :: ifail
  !
  call e02aef(ipol,aa,xx,yy,ifail)
  call mth_fail (name,'MTH_GETPOL',ifail,error)
end subroutine mth_getpol
!
subroutine mth_fail (fac,prog,ifail,error)
  character(len=*) :: fac           !
  character(len=*) :: prog          !
  integer :: ifail                  !
  logical :: error                  !
  ! Local
  character(len=60) :: chain
  !
  if (ifail.eq.0) then
    error = .false.
  else
    write(chain,'(A,A,A,I4)')   &
      'ERROR in ',prog,', ifail = ',ifail
    call message(8,4,fac,chain)
    error = .true.
  endif
end subroutine mth_fail
!
subroutine mth_fitlin (name,ndd,nvar,a,b,nd,sigma)
  character(len=*) :: name          !
  integer :: ndd                    !
  integer :: nvar                   !
  integer :: nd                     !
  real*8 :: a(nd,nvar)              !
  real*8 :: b(nd)                   !
  real*8 :: sigma                   !
  ! Local
  logical :: error
  !
  integer :: mvar
  parameter (mvar=10)          ! 7 is required for baseline fit.
  integer :: ifail, irank, lwork
  parameter (lwork = 4*mvar)
  real*8 :: work(lwork), work2(mvar)
  !
  ifail = 1
  call f04jaf(ndd,nvar,a,nd,b,1d-5,sigma,irank,work,lwork,   &
    ifail)
  call mth_fail(name,'MTH_FILIN (fit)',ifail,error)
  ifail = 1
  call f04yaf(-1,nvar,sigma,a,nd,.true.,irank,work,work2,work2,   &
    ifail)
  call mth_fail(name,'MTH_FILIN (fit)',ifail,error)
end subroutine mth_fitlin
!
subroutine mth_dpotrf (name, uplo, n, a, lda, error)
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: lda                     !
  real*8 :: a(lda,*)                 !
  logical :: error                   !
  ! Local
  integer :: info
  !
  ! Call NAG routine
  call f07fdf (uplo, n, a, lda, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrf
!
subroutine mth_dpotrs (name,   &
    uplo, n, nrhs, a, lda, b, ldb, info )
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: nrhs                    !
  integer :: lda                     !
  real*8 :: a(lda,*)                 !
  integer :: ldb                     !
  real*8 :: b(ldb,*)                 !
  ! Local
  integer :: info
  logical :: error
  !
  ! Call NAG routine
  call f07fef( uplo, n, nrhs, a, lda, b, ldb, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrs
!
subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: ldab                      !
  real*8 :: ab(ldab,*)                 !
  logical :: error                     !
  ! Local
  integer :: info
  !
  ! Call NAG
  call f07hdf( uplo, n, kd, ab, ldab, info )
  call mth_fail(name,'MTH_DPBTRF',info,error)
end subroutine mth_dpbtrf
!
subroutine mth_dpbtrs (name,   &
    uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: nrhs                      !
  integer :: ldab                      !
  real*8 :: ab(ldab,*)                 !
  integer :: ldb                       !
  real*8 :: b(ldb,*)                   !
  logical :: error                     !
  ! Local
  integer :: info
  !
  ! Call LAPACK
  call f07hef( uplo, n, kd, nrhs, ab, ldab, b, ldb, info )
  call mth_fail(name,'MTH_DPBTRS',info,error)
end subroutine mth_dpbtrs
!
function mth_bessj0 (x)
  !---------------------------------------------------------------------
  ! Compute Bessel function J0
  !---------------------------------------------------------------------
  real*8 :: mth_bessj0              !
  real*8 :: x                       !
  ! Local
  real*8 :: s17aef
  integer :: ifail
  !
  ifail = 0
  mth_bessj0 = s17aef(x,ifail)
end function mth_bessj0
!
function mth_bessj1 (x)
  !---------------------------------------------------------------------
  ! Compute Bessel function J1
  !---------------------------------------------------------------------
  real*8 :: mth_bessj1              !
  real*8 :: x                       !
  ! Local
  real*8 :: s17aff
  integer :: ifail
  !
  ifail = 0
  mth_bessj1 = s17aff(x,ifail)
end function mth_bessj1
!
subroutine mth_bessjn (x,j,n)
  !---------------------------------------------------------------------
  ! Compute Bessels functions from J1 to Jn
  !---------------------------------------------------------------------
  real*8 :: x                       !
  integer :: n                      !
  real*8 :: j(n)                    !
  ! Local
  integer :: i
  !
  ! Unefficient implementation, if you don't care
  !      REAL*8 MTH_BESSJ1,MTH_BESSJ
  !      J(1) = MTH_BESSJ1(X)
  !      DO I=2,N
  !         J(I) = MTH_BESSJ(I,X)
  !      ENDDO
  !      RETURN
  !
  ! NAG version
  integer m
  parameter (m=16)
  complex*16 z,jj(m)
  integer ifail
  !
  if (n.gt.m) then
    ifail = 6
  else
    z = cmplx(x,0d0)
    ifail = 0
    call s17def(1.d0,z,2,'U',jj,2,ifail)
    do i=1,n
      !            J(I) = REAL(JJ(I))
      j(i) = dble(jj(i))
    enddo
  endif
end subroutine mth_bessjn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine doplace(map,table,cube,gweight,time,error)
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>doplace
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(xymap_prog_t), intent(in)    :: map ! Gridding description
  real(kind=4),       intent(in)    :: table(map%tab%nchan,map%tab%nposi)
  real(kind=4),       intent(inout) :: cube(map%cub%nchan,map%cub%nx,map%cub%ny)
  real(kind=4),       intent(inout) :: gweight(map%cub%nx,map%cub%ny)
  type(time_t),       intent(inout) :: time
  logical,            intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  real(kind=8) :: rx,ry
  integer(kind=index_length) :: ilin,ix,iy
  character(len=message_length) :: mess
  !
  call class_message(seve%d,rname,'Placing')
  !
  ! Put spectrum at appropriate place
  do ilin=1,map%tab%nposi
     call class_controlc(rname,error)
     if (error)  return
     !
     rx = map%xconv(1)+(map%tab%x(ilin)-map%xconv(2))/map%xconv(3)
     ry = map%yconv(1)+(map%tab%y(ilin)-map%yconv(2))/map%yconv(3)
     ix = nint(rx)
     iy = nint(ry)
     if ((ix.lt.1).or.(ix.gt.map%cub%nx)) then
        write(mess,*) 'Table line #',ilin,' out of x grid'
        call class_message(seve%w,rname,mess)
        cycle
     endif
     if ((iy.lt.1).or.(iy.gt.map%cub%ny)) then
        write(mess,*) 'Table line #',ilin,' out of y grid'
        call class_message(seve%w,rname,mess)
        cycle
     endif
     cube(:,ix,iy) = table(:,ilin)
     gweight(ix,iy) = map%tab%w(ilin)
     !
     call gtime_current(time)
  enddo
  !
end subroutine doplace
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine docoor(n,xref,xval,xinc,x)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Compute coordinate array from conversion formula
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: n     ! Number of pixel
  real(kind=8),               intent(in)  :: xref  ! Reference pixel
  real(kind=8),               intent(in)  :: xval  ! Value at reference pixel
  real(kind=8),               intent(in)  :: xinc  ! Pixel size
  real(kind=4),               intent(out) :: x(n)  ! Axis coordinate
  ! Local
  integer(kind=index_length) :: i
  !
  do i=1,n
     x(i) = (dble(i)-xref)*xinc+xval
  enddo
end subroutine docoor
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gag_cputime_add(sum,last)
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !   Get the times since last call for 'last', and add the times to
  ! the structure 'sum'. Note that the reference times in 'sum' have
  ! not much meaning in this context.
  ! ---
  !   This subroutine is helpful to add non-contiguous time counts,
  ! while the official cputime_t is made to count times from a reference
  ! or from last call. Should this be merged in gsys?
  !---------------------------------------------------------------------
  type(cputime_t), intent(inout) :: sum
  type(cputime_t), intent(inout) :: last
  !
  call gag_cputime_get(last)
  sum%curr%elapsed = sum%curr%elapsed + last%diff%elapsed
  sum%curr%user    = sum%curr%user    + last%diff%user
  sum%curr%system  = sum%curr%system  + last%diff%system
  !
end subroutine gag_cputime_add
!
subroutine print_cputime_feedback(time)
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>print_cputime_feedback
  use xymap_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(xymap_time_t), intent(in) :: time
  ! Local
  character(len=*), parameter :: rname='XY_MAP'
  character(len=message_length) :: mess
  !
  ! Nothing shown if command is faster than 10 sec (NB: 10 sec is also
  ! the threshold used by the gtime statistics)
  if (time%total%diff%elapsed.lt.10.)  return
  !
  print *,''
  !
  write(mess,10)  &
    'Time elapsed in command (total):',time%total%diff%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed reading XYW:',time%xyw%diff%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed reading the table:',time%read%curr%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed sorting the table:',time%sort%curr%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed transposing table or cube:',time%tran%curr%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed convolving:',time%conv%curr%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
  write(mess,10)  &
    'Time elapsed writing the cube:',time%writ%curr%elapsed,' sec'
  call class_message(seve%i,rname,mess)
  !
10 format(A,T40,F10.2,A)
end subroutine print_cputime_feedback
!
subroutine reallocate_tab(array,n1,n2,error)
  use gildas_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>reallocate_tab
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate a 2D table
  !---------------------------------------------------------------------
  real(kind=4),               allocatable   :: array(:,:)
  integer(kind=index_length), intent(in)    :: n1,n2
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP>REALLOCATE>2D'
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  !
  if (n1.le.0 .or. n2.le.0) then
    write(mess,'(A,2(I0,A))')  &
      'Array size can not be zero nor negative (got ',n1,'x',n2,')'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (allocated(array)) then
    if (ubound(array,1).eq.n1 .and.  &
        ubound(array,2).eq.n2) then
      call print_size(rname,'Workspace already allocated at an appropriate size',n1,n2)
      alloc = .false.
    else
      deallocate(array)
    endif
  endif
  !
  if (alloc) then
    allocate(array(n1,n2),stat=ier)
    if (failed_allocate(rname,'XY_MAP WORKSPACE',ier,error))  return
    call print_size(rname,'Allocated workspace of size',n1,n2)
  endif
  !
contains
  subroutine print_size(rname,start,n1,n2)
    use gildas_def
    use gbl_message
    use classmap_interfaces
    character(len=*),           intent(in) :: rname
    character(len=*),           intent(in) :: start
    integer(kind=index_length), intent(in) :: n1,n2
    ! Local
    character(len=message_length) :: mess
    integer(kind=size_length) :: nw
    nw = n1*n2
    write(mess,'(a,a,i0,a,i0,a,a)')  &
      trim(start),': ',n1,' x ',n2,' = ',pretty_size(nw)
    call class_message(seve%d,rname,mess)
  end subroutine print_size
  !
end subroutine reallocate_tab
!
subroutine reallocate_cub(array,n1,n2,n3,error)
  use gildas_def
  use gbl_message
  use classmap_dependencies_interfaces
  use classmap_interfaces, except_this=>reallocate_cub
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate a 3D cube
  !---------------------------------------------------------------------
  real(kind=4),               allocatable   :: array(:,:,:)
  integer(kind=index_length), intent(in)    :: n1,n2,n3
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='XY_MAP>REALLOCATE>3D'
  character(len=message_length) :: mess
  logical :: alloc
  integer(kind=4) :: ier
  !
  if (n1.le.0 .or. n2.le.0 .or. n3.le.0) then
    write(mess,'(A,3(I0,A))')  &
      'Array size can not be zero nor negative (got ',n1,'x',n2,'x',n3,')'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (allocated(array)) then
    if (ubound(array,1).eq.n1 .and.  &
        ubound(array,2).eq.n2 .and.  &
        ubound(array,3).eq.n3) then
      call print_size(rname,'Workspace already allocated at an appropriate size',n1,n2,n3)
      alloc = .false.
    else
      deallocate(array)
    endif
  endif
  !
  if (alloc) then
    allocate(array(n1,n2,n3),stat=ier)
    if (failed_allocate(rname,'XY_MAP WORKSPACE',ier,error))  return
    call print_size(rname,'Allocated workspace of size',n1,n2,n3)
  endif
  !
contains
  subroutine print_size(rname,start,n1,n2,n3)
    use gildas_def
    use gbl_message
    use classmap_interfaces
    character(len=*),           intent(in) :: rname
    character(len=*),           intent(in) :: start
    integer(kind=index_length), intent(in) :: n1,n2,n3
    ! Local
    character(len=message_length) :: mess
    integer(kind=size_length) :: nw
    nw = n1*n2*n3
    write(mess,'(a,a,i0,a,i0,a,i0,a,a)')  &
      trim(start),': ',n1,' x ',n2,' x ',n3,' = ',pretty_size(nw)
    call class_message(seve%d,rname,mess)
  end subroutine print_size
  !
end subroutine reallocate_cub
!
function pretty_size(nwords)
  use gildas_def
  use classmap_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !  Return a string describing the input size (words) in a bytes
  ! multiple
  !---------------------------------------------------------------------
  character(len=20) :: pretty_size     ! Function value on return
  integer(kind=size_length) :: nwords  ! [words]
  ! Local
  integer(kind=size_length) :: siz
  !
  siz = nwords*4_8
  pretty_size = gag_memsize_format(siz)
end function pretty_size

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_cumulant
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubecompute_messaging
  use cubecompute_operdir_types
  !
  public :: cumulant
  private
  !
  type :: cumulant_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(operdir_comm_t)    :: direction
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: cumulant ! Approx cube prod registered at start-up
   contains
     procedure, public  :: register => cubecompute_cumulant_comm_register
     procedure, private :: parse    => cubecompute_cumulant_comm_parse
     procedure, private :: main     => cubecompute_cumulant_comm_main
  end type cumulant_comm_t
  type(cumulant_comm_t) :: cumulant  
  !
  type cumulant_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
     type(operdir_user_t)    :: direction
   contains
     procedure, private :: toprog => cubecompute_cumulant_user_toprog
  end type cumulant_user_t
  !
  type cumulant_prog_t
     !***JP: Why cubeprod needs to be global?
     type(cube_prod_t)       :: cubeprod ! Exact cube product evaluated at run time
     type(cuberegion_prog_t) :: region
     type(operdir_prog_t)    :: direction
     type(cube_t), pointer   :: cube
     type(cube_t), pointer   :: cumulant
     procedure(cubecompute_cumulant_prog_act_from_blc), pointer :: act => null()
   contains
     procedure, private :: header => cubecompute_cumulant_prog_header
     procedure, private :: data   => cubecompute_cumulant_prog_data
     procedure, private :: loop   => cubecompute_cumulant_prog_loop
  end type cumulant_prog_t
  !
contains
  !
  subroutine cubecompute_cumulant_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cumulant_user_t) :: user
    character(len=*), parameter :: rname='CUMULANT>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cumulant%parse(line,user,error)
    if (error) return
    call cumulant%main(user,error)
    if (error) continue
  end subroutine cubecompute_cumulant_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: cube
    type(cube_prod_t) :: cumulant
    character(len=*), parameter :: rname='CUMULANT>COMM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'CUMULANT','[cubeid]',&
         'Compute cumulative sums in each image plane of a real cube',&
         'Compute 2D cumulative sums within each selected image plane of a&
         & real cube. The output cube matches the selected region of the&
         & input cube. Each output pixel stores the cumulative sum from the&
         & chosen corner to that pixel.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /DIRECT accumulates from the bottom-left corner. If neither&
         & /DIRECT nor /INVERSE is given, the command defaults to /DIRECT.'&
         //strg_cr//&
         '- /INVERSE accumulates from the top-right corner.'//strg_cr//&
         '- In inverse mode, zero cumulative values are converted to NaN by&
         & the current implementation.'//strg_bl//&
         'Examples:'//strg_cr//&
         '- CUBE> CUMULANT cube /DIRECT.'//strg_cr//&
         '- CUBE> CUMULANT cube /INVERSE /RANGE -5km/s 5km/s.',&
         cubecompute_cumulant_command,&
         comm%comm,&
         error)
    if (error) return
    call cube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    call comm%direction%register(&
         'Cumulate from bottom left  corner',&
         'Cumulate from    top right corner',&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call cumulant%register(&
         'CUMULANT',&
         'CUMULANT cube',&
         strg_emp,&
         [flag_any,flag_cumulant],&! flag_any resolved at run time
         comm%cumulant,&
         error)
    if (error)  return
  end subroutine cubecompute_cumulant_comm_register
  !
  subroutine cubecompute_cumulant_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! CUMULANT cubname [ /DIRECT | /INVERSE ]
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(cumulant_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUMULANT>COMM>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%direction%parse(line,user%direction,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubecompute_cumulant_comm_parse
  !
  subroutine cubecompute_cumulant_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_comm_t), intent(in)    :: comm
    type(cumulant_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(cumulant_prog_t) :: prog
    character(len=*), parameter :: rname='CUMULANT>MAIN'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubecompute_cumulant_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_user_t), intent(in)    :: user
    type(cumulant_comm_t),  intent(in)    :: comm
    type(cumulant_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='CUMULANT>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    !
    call user%direction%toprog(comm%direction,prog%direction,error)
    if (error) return
    select case (prog%direction%code)
    case (code_operdir_direct,code_operdir_default)
       prog%direction%code = code_operdir_direct
       prog%act => cubecompute_cumulant_prog_act_from_blc
    case (code_operdir_inverse)
       prog%act => cubecompute_cumulant_prog_act_from_trc
    case default
       call cubecompute_message(seve%e,rname,'Unknown operation direction')
       error = .true.
       return
    end select
    ! User feedback about the interpretation of his command line
    call prog%direction%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubecompute_cumulant_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_cumulant_prog_header(prog,comm,error)
    use cubedag_allflags
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !***JP: Maybe this one could be factorized in type-operdir.f90???
    ! Create cumulant cube with proper flags
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    type(cumulant_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    !***JP: Why cubeprod needs to be global?
    !type(cube_prod_t) :: cubeprod ! Exact cube product evaluated at run time
    character(len=*), parameter :: rname='CUMULANT>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call comm%cumulant%copy(prog%cubeprod,error)
    if (error) return
    if (prog%direction%code.eq.code_operdir_direct) then
      call prog%cubeprod%flag_to_flag(flag_any,flag_direct,error)
      if (error) return
    else
      call prog%cubeprod%flag_to_flag(flag_any,flag_inverse,error)
      if (error) return
    endif
    call cubeadm_clone_header_with_region(prog%cubeprod,&
      prog%cube,prog%region,prog%cumulant,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_header
  !
  subroutine cubecompute_cumulant_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='CUMULANT>PROG>DATA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubecompute_cumulant_prog_data
  !   
  subroutine cubecompute_cumulant_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(cumulant_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image
    type(image_t) :: cumul
    character(len=*), parameter :: rname='CUMULANT>PROG>LOOP'
    !
    call image%associate('image',prog%cube,iter,error)
    if (error) return
    call cumul%allocate('cumul',prog%cumulant,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,image,cumul,error)
      if (error) return
    enddo ! ie
  end subroutine cubecompute_cumulant_prog_loop
  !
  subroutine cubecompute_cumulant_prog_act_from_blc(prog,ie,image,cumul,error)
    use cubetools_nan
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Start computation from bottom left corner
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: cumul
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    real(kind=sign_k) :: value
    character(len=*), parameter :: rname='CUMULANT>PROG>ACT>FROM>BLC'
    !
    call image%get(ie,error)
    if (error) return
    call cumul%set(0.0,error)
    if (error) return
    ! Bottom left corner
    if (ieee_is_nan(image%val(1,1))) then
       cumul%val(1,1) = 0.0
    else
       cumul%val(1,1) = image%val(1,1)
    endif
    ! First row
    do ix=2,image%nx
       if (ieee_is_nan(image%val(ix,1))) then
          value = 0.0
       else
          value = image%val(ix,1)
       endif
       cumul%val(ix,1) = cumul%val(ix-1,1)+value
    enddo ! ix
    ! Other raws
    do iy=2,image%ny
       ! Cumulate along x axis
       if (ieee_is_nan(image%val(1,iy))) then
          cumul%val(1,iy) = 0.0
       else
          cumul%val(1,iy) = image%val(1,iy)
       endif
       do ix=2,image%nx
          if (ieee_is_nan(image%val(ix,iy))) then
             value = 0.0
          else
             value = image%val(ix,iy)
          endif
          cumul%val(ix,iy) = cumul%val(ix-1,iy)+value
       enddo ! ix
       ! Now cumulate current and previous raw
       do ix=1,image%nx
          cumul%val(ix,iy) = cumul%val(ix,iy)+cumul%val(ix,iy-1)
       enddo ! ix
    enddo ! iy
    do iy=1,image%ny
       do ix=1,image%nx
          if (ieee_is_nan(image%val(ix,iy))) cumul%val(ix,iy) = gr4nan
       enddo !ix
    enddo !iy
    call cumul%put(ie,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_act_from_blc
  !
  subroutine cubecompute_cumulant_prog_act_from_trc(prog,ie,image,cumul,error)
    use cubetools_nan
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Start computation from top right corner
    !----------------------------------------------------------------------
    class(cumulant_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t),          intent(inout) :: image
    type(image_t),          intent(inout) :: cumul
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,nx
    integer(kind=pixe_k) :: iy,ny
    real(kind=sign_k) :: value
    character(len=*), parameter :: rname='CUMULANT>PROG>ACT>FROM>TRC'
    !
    call image%get(ie,error)
    if (error) return
    call cumul%set(0.0,error)
    if (error) return
    ! Top right corner
    nx = image%nx
    ny = image%ny
    if (ieee_is_nan(image%val(nx,ny))) then
       cumul%val(nx,ny) = 0.0
    else
       cumul%val(nx,ny) = image%val(nx,ny)
    endif
    ! Last raw
    do ix=image%nx-1,1,-1
       if (ieee_is_nan(image%val(ix,ny))) then
          value = 0.0
       else
          value = image%val(ix,ny)
       endif
       cumul%val(ix,ny) = cumul%val(ix+1,ny)+value
    enddo ! ix
    ! Other raws
    do iy=image%ny-1,1,-1
       ! Cumulate along x axis
       if (ieee_is_nan(image%val(nx,iy))) then
          cumul%val(nx,iy) = 0.0
       else
          cumul%val(nx,iy) = image%val(nx,iy)
       endif
       do ix=image%nx-1,1,-1
          if (ieee_is_nan(image%val(ix,iy))) then
             value = 0.0
          else
             value = image%val(ix,iy)
          endif
          cumul%val(ix,iy) = cumul%val(ix+1,iy)+value
       enddo ! ix
       ! Now cumulate current and previous raw
       do ix=1,image%nx
          cumul%val(ix,iy) = cumul%val(ix,iy)+cumul%val(ix,iy+1)
       enddo ! ix
    enddo ! iy
    do iy=1,image%ny
       do ix=1,image%nx
          !if (ieee_is_nan(image%val(ix,iy))) cumul%val(ix,iy) = gr4nan
          if (cumul%val(ix,iy).eq.0) cumul%val(ix,iy) = gr4nan
       enddo !ix
    enddo !iy
    call cumul%put(ie,error)
    if (error) return
  end subroutine cubecompute_cumulant_prog_act_from_trc
end module cubecompute_cumulant
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP,QUIET,WARNING,ERROR)
      INTEGER N,NP,M,MP
      REAL*4 A(NP,NP),B(NP,MP)
      LOGICAL QUIET,WARNING,ERROR
*
      INTEGER NMAX
      PARAMETER (NMAX=512)  ! Dangerously large value, but the covariance
                            ! matrix is normally well conditioned
      INTEGER IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      INTEGER I,J,K,L,LL,IROW,ICOL
      REAL*4 BIG,DUM,PIVINV
*
      WARNING = .FALSE.
      ERROR = .FALSE.
      ICOL = -1E8  ! Cause an access violation if not set later 
      IROW = -1E8
      IF (N.GT.NMAX) THEN
         WRITE(6,*) 'F-GAUSSJ,  Insufficient internal work space'
         ERROR = .TRUE.
         RETURN
      ENDIF
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSEIF (IPIV(K).GT.1) THEN
                IF (.NOT.QUIET) THEN
                   WRITE(6,*) 'E-GAUSSJ,  Singular matrix'
                ENDIF
                ERROR = .TRUE.
                RETURN
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) THEN
           IF (.NOT.QUIET) THEN
              WRITE(6,'(A)') 'E-GAUSSJ,  Singular matrix.'
           ENDIF
           ERROR = .TRUE.
           RETURN
        ENDIF
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

!
subroutine adjust_mcmc (comm,line,error)
  use gildas_def
  use gbl_format
  use sic_adjust
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>adjust_mcmc
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !     Support for commands
  !
  !     EMCEE [Data Command] [/BEGIN] [/START A1 B1 C1 ...] [/STEP A2 B2 C2 ...]
  !     [/Bounds Par Low Up [...]] [/Parameters Va Vb Vc ...]
  !     [/ROOT  Name] [/WALKERS NWalk] [/LENGTH Length]
  !
  ! Allows fitting arbitrary data with arbitrary number of parameters
  ! using a MCMC routine
  !---------------------------------------------------------------------
  character(len=*)                :: comm   !
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='EMCEE'
  !
  !  ' EMCEE', '/BEGIN', '/BOUNDS', '/LENGTH', '/PARAMETERS', '/ROOT_NAME', &
  !  '/START', '/STEP', '/WALKERS'/
  integer, parameter :: O_BEGIN = 1
  integer, parameter :: O_BOUND = 2
  integer, parameter :: O_LENGTH = 3
  integer, parameter :: O_PAR = 4
  integer, parameter :: O_ROOT = 5
  integer, parameter :: O_START = 6
  integer, parameter :: O_STEP = 7
  integer, parameter :: O_WALK = 8
  !
  character(len=formula_length) :: aprint,bprint
  character(len=commandline_length) :: cprint, chi2_expression
  character(len=varname_length) :: avar,cvar,argum
  character(len=64) :: work
  character(len=16) :: ch
  integer :: i,narg,ivar
  real(4), save :: xstart(adj_m),xstep(adj_m)
  type(sic_descriptor_t) :: ddesc,default
  integer :: nc,pdim
  integer :: lun,n,lk
  !
  integer :: ier
  logical :: resume, begin
  character(len=filename_length) :: file
  character(len=message_length) :: mess
  !
  logical, save :: first=.true.
  logical, save :: setup=.false.
  logical, save :: load_emcee=.false.
  integer, save :: adj_all, adj_counter
  !
  if (first) then
    xstart = 0.0
    xstep  = 1.0
    adj_lower = -5.0
    adj_upper = 5.0
    first = .false.
    call sic_defstructure('EMCEE',.true.,error)
    call sic_def_dble('EMCEE%CHI2',adj_chi2,0,0,.false.,error)
    call sic_def_inte('EMCEE%ALL',adj_all,0,0,.false.,error)
    call sic_def_inte('EMCEE%COUNTER',adj_counter,0,0,.false.,error)
    call sic_def_login('EMCEE%RESTART',adj_restart,0,0,.true.,error)
    call sic_def_inte('EMCEE_LENGTH',adj_length,0,0,.true.,error)
    call sic_def_inte('EMCEE_WALKERS',adj_walkers,0,0,.true.,error)
    call sic_def_inte('EMCEE_PARAMS',adj_n,0,0,.true.,error)
    call sic_def_char('EMCEE_ROOT',adj_root,.true.,error)
    adj_root = 'EMCEE'
    load_emcee = .true.
  endif
  adj_all = 0
  adj_counter = 0
  !
  ! No argument, No option /BEGIN
  begin = sic_present(O_BEGIN,0)
  if (begin) then
    resume = .false.
  else if (sic_narg(0).eq.0) then
    if (.not.setup) then
      call sic_message(seve%e,rname,'MCMC parameters have not been defined')
      error = .true.
      return
    else
      resume = .true.
    endif
  else
    resume = .false.
  endif
  !
  ! /LENGTH option (can be changed in all cases)
  call sic_i4 (line,O_LENGTH,1,adj_length,.false.,error)
  !
  if (.not.resume) then
    !
    ! Delete the generic structure name
    call sic_delvariable(adj_root(1:adj_lroot),.false.,error)
    error = .false.
    !
    cur_exec = adj_exec
    pdim = sic_narg(O_PAR)
    if (pdim.le.0) then
      call sic_message(seve%e,rname,'No variable specified')
      error = .true.
      return
    endif
    !
    ! Option /ROOT : Root name
    if (sic_present(O_ROOT,1)) then
       call sic_ch(line,O_ROOT,1,adj_root,adj_lroot,.true.,error)
       if (error) return
    endif
    !
    ! Main arguments
    !
    default%type = fmt_r8
    default%readonly = .false.
    default%addr = 0
    default%ndim = 0
    default%dims(:) = 0
    default%size = 0
    default%status = 0
    call sic_desc (line,0,1,ddesc,default,.true.,error)
    if (error) return
    !
    call sic_ch(line,0,2,chi2_expression,nc,.true.,error)
    if (error) return
    !
    ! Option /PARAMETER : parameter names, must be parsed before /BOUND
    pdim = sic_narg(O_PAR)
    if (pdim.gt.adj_m) then
      write(work,'(I0)') adj_m
      call sic_message(seve%e,rname,'Too many parameters, maximum allowed is '//work)
      error = .true.
      return
    endif
    !
    do i=1,pdim
      call sic_ke(line,O_PAR,i,work,nc,.true.,error)
      if (error) return
      if (.not.sic_varexist(work(1:nc))) then
         call sic_message(seve%e,rname,'Parameter'//work(1:nc)//' does not exist')
         error = .true.
         return
      endif
      call sic_lower(work)
      adj_names(i) = work
    enddo
    adj_n = pdim
    !
    ! Option Starting values : must be parsed before STEPS and BOUNDS
    narg = min(sic_narg(O_START),pdim)
    do i=1,narg
      call sic_r4 (line,O_START,i,xstart(i),.false.,error)
      if (error) return
    enddo
    !
    ! Option Steps: must be parsed before BOUNDS
    narg = min(sic_narg(O_STEP),pdim) ! Hum pas bon, mais on patche
    do i=1,narg
      call sic_r4 (line,O_STEP,i,xstep(i),.false.,error)
      if (error) return
      adj_lower(i) = xstart(i)-5*xstep(i)
      adj_upper(i) = xstart(i)+5*xstep(i)
    enddo
    !
    ! Option /BOUND : Allowed range for parameter values
    narg = max(0,min(sic_narg(O_BOUND),3*pdim)) ! is -1 if no argument
    if (mod(narg,3).ne.0) then
      call sic_message(seve%e,rname,'/BOUND requires N times 3 arguments')
      error = .true.
      return
    endif
    do i=1,narg,3
      call sic_ke (line,O_BOUND,i,avar,lk,.false.,error)
      ! Parameter names have been defined
      call sic_lower(avar)
      call sic_ambigs('/BOUNDS',avar,cvar,ivar,adj_names,pdim,error)
      if (error) return
      !      
      call sic_ke (line,O_BOUND,i+1,argum,lk,.false.,error)
      if (argum.eq.'*') then
        call sic_message(seve%e,rname,'Free Lower bound not yet supported')
        error = .true.
        return
      else
        call sic_r8 (line,O_BOUND,i+1,adj_lower(ivar),.false.,error)
      endif
      call sic_ke (line,O_BOUND,i+2,argum,lk,.false.,error)
      if (argum.eq.'*') then
        call sic_message(seve%e,rname,'Free Upper bound not yet supported')
        error = .true.
        return
      else
        call sic_r8 (line,O_BOUND,i+2,adj_upper(ivar),.false.,error)
      endif
      adj_bound(ivar) = 3
      write (mess,*) trim(adj_names(ivar)),' bounds ',real(adj_lower(ivar)),real(adj_upper(ivar))
      call sic_message(seve%i,rname,mess)
    enddo
    !
    ! Number of Walkers
    call sic_i4 (line,O_WALK,1,adj_over,.false.,error)
    adj_walkers = adj_over*adj_n
    !
    ! Write the mcmc-adjust.py
    ier = sic_getlun(lun)
    file = 'adjust-emcee.py'
    ier = sic_open(lun,file,'UNKNOWN',.false.)
    write(lun,'(A)') '#'
    write(lun,'(A)') 'import numpy as np'
    write(lun,'(A)') 'import sys'
    write(lun,'(A)') 'import math'
    write(lun,'(A)') 'import pysic'
    write(lun,'(A)') 'pysic.get()'
    write(lun,'(A)') 'sic = pysic.gdict'
    write(lun,'(A)') '#'
    write(lun,'(A)') '# list of variables'
    !
    do i=1,adj_n
      ! name + guess, min, max
      write(lun,'(A)') trim(adj_names(i))//"_guess = sic."//trim(adj_names(i))
      write(lun,'(A,1pg16.7)') trim(adj_names(i))//"_min = ",adj_lower(i)
      write(lun,'(A,1pg16.7)') trim(adj_names(i))//"_max = ",adj_upper(i)
    enddo
    !
    write(lun,'(A)') '# Likelihood and Prior'
    write(lun,'(A)') 'def lnlike(theta) : '
    aprint = "  "//adj_names(1)
    n = len_trim(aprint)+1
    do i=2,adj_n
      aprint(n:) = ","//adj_names(i)
      n = len_trim(aprint)+1
    enddo
    aprint(n:) = " = theta"
    !
    write(lun,'(A)') trim(aprint)
    do i=1,adj_n
      write(lun,'(A)') "  sic."//trim(adj_names(i))//" = "//adj_names(i)
    enddo
    write(lun,'(A)') "  Sic.comm('"//trim(chi2_expression)//"')"
    write(lun,'(A)') "  return -0.5*sic.emcee.chi2[0]"
    !
    write(lun,'(A)')
    write(lun,'(A)') "nll=lambda *args: -lnlike(*args)"
    !
    write(lun,'(A)') "def lnprior(theta):"
    write(lun,'(A)') trim(aprint)
    do i=1,adj_n
      write(lun,'(A)') "  if "//trim(adj_names(i))//"<"//trim(adj_names(i))//"_min : "
      write(lun,'(A)') "    return -np.inf "
      write(lun,'(A)') "  if "//trim(adj_names(i))//"_max<"//trim(adj_names(i))//" : "
      write(lun,'(A)') "    return -np.inf "
    enddo
    write(lun,'(A)') "  return 0.0"
    !
    write(lun,'(A)') " "
    write(lun,'(A)') "def lnprob(theta): "
    write(lun,'(A)') "  lp=lnprior(theta) "
    write(lun,'(A)') "  if not np.isfinite(lp): "
    write(lun,'(A)') "    return -np.inf "
    write(lun,'(A)') "  return lp+lnlike(theta) "
    !
    write(lun,'(A)')
    bprint = "start = ["//trim(adj_names(1))//"_guess"
    n = len_trim(bprint)+1
    do i=2,adj_n
      bprint(n:) = ", "//trim(adj_names(i))//"_guess"
      n = len_trim(bprint)+1
    enddo
    bprint(n:n) = "]"
    write(lun,'(A)') trim(bprint)
    write(lun,'(A)') " "
    !
    write(lun,'(A)') "# Prepare MCMC"
    write(lun,'(A)') "import emcee "
    write(lun,'(A)') "import pickle "
    write(lun,'(A)') "import sys"
    write(lun,'(A)') " "
    write(lun,'(A)') "# Use EMCEE to find the distribution "
    write(lun,'(A)') "# "
    write(lun,'(A)') "# Initialize the walkers "
    !
    ! pos_random = [   1.0,  0.10]  # Comes from the steps ?
    cprint = "pos_random = [ "
    n = len_trim(cprint)+1
    do i=1,adj_n
      write(cprint(n:),'(1pg12.4,a)') xstep(i),','
      n = len_trim(cprint)+1
    enddo
    cprint(n-1:n) = "]"
    write(lun,'(A)') cprint(1:n)
    write(lun,"(a,(i4,a,i4))") "numdim, nwalkers = ",adj_n,",",adj_walkers
    write(lun,'(A)') "pos=[start+pos_random*np.random.randn(numdim) for i in range(nwalkers)]"
    write(lun,'(A)') " "
    write(lun,'(A)') "# or get the starting point from the saved value"
    write(lun,'(A)') "restart = sic.emcee.restart"
    write(lun,'(A)') "if restart:"
    write(lun,'(A)') "  if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "    input = open('emcee-last.pkl', 'r')"
    write(lun,'(A)') "    pos = pickle.load(input)"
    write(lun,'(A)') "  else:"
    write(lun,'(A)') "    input = open('emcee-last.pkl', 'rb')"
    write(lun,'(A)') "    pos = pickle.load(input,encoding='latin1')"
    write(lun,'(A)') " "
    write(lun,'(A)') "# Run the EMCEE sampler"

    write(lun,'(A)') "clength = sic.emcee_length "
    write(lun,'(A)') "sampler = emcee.EnsembleSampler(nwalkers, numdim, lnprob)"
    write(lun,'(A)') "sampler.run_mcmc(pos, clength) "
    write(lun,'(A)') "# Save the full chains in Pickle format"
    write(lun,'(A)') "if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "  output = open('emcee-chain.pkl', 'w')"
    write(lun,'(A)') "else:"
    write(lun,'(A)') "  output = open('emcee-chain.pkl', 'wb')"
    write(lun,'(A)') "pickle.dump(sampler.chain, output)"
    write(lun,'(A)') "output.close()"
    write(lun,'(A)') "#"
    write(lun,'(A)') "# Export result as a Gildas file too"
!!    write(lun,'(A,A,A)') "Sic.comm('define image ", &
!!      & "adjust_current[adjust_length,adjust_walkers,adjust_params] ", &
!!      & "adjust-current.tab real /global')"
    write(lun,'(A)') "for i in range(sic.emcee_params):"
    write(lun,'(A)') "  for j in range(sic.emcee_walkers):"
    write(lun,'(A)') "    sic.emcee_current[i,j,:] = sampler.chain[j,:,i]"
!!    write(lun,'(A)') "Sic.comm('delete /variable adjust_current')"
    write(lun,'(A)') "#"

    write(lun,'(A)') "# Export the last point of the chain as a Pickle file "
    write(lun,'(A)') "clength = clength-1 "
    write(lun,'(A)') "last = sampler.chain[:,clength,:]"
    write(lun,'(A)') "if sys.version_info[:1] == (2,):"
    write(lun,'(A)') "  output = open('emcee-last.pkl', 'w')"
    write(lun,'(A)') "else:"
    write(lun,'(A)') "  output = open('emcee-last.pkl', 'wb')"
    write(lun,'(A)') "pickle.dump(last, output) "
    write(lun,'(A)') "output.close()"

    write(lun,'(A)') "#"
    write(lun,'(A)') "# Printing checkup"
    write(lun,'(A)') 'print("Mean acceptance fraction: {0:.3f}"'
    write(lun,'(A)') "              .format(np.mean(sampler.acceptance_fraction)))"
    close(unit=lun)
    call sic_frelun(lun)
    !
    setup = .true.
  endif
  !
  call sic_delvariable('emcee_current',.false.,error)
  error = .false.
  call exec_program('define image '// &
    'emcee_current[emcee_length,emcee_walkers,emcee_params] '// &
    'emcee-current.tab real /global')
  !
  if (load_emcee) then
    call exec_program('@ emcee-tools.sic')
    load_emcee = .false.
  endif
  !
  if (.not.(begin.or.resume)) then
    if (sic_lire().eq.0) call sic_insert(line)
    return
  endif
  !
  adj_all = adj_walkers * adj_length
  !
  ! Restart from last point in case of RESUME.
  adj_restart = resume
  !
  call exec_program('SIC CPU')
  call exec_program('python adjust-emcee.py')
  call exec_program('delete /variable emcee_current')
  if (error) return
  if (adj_restart) then
    call exec_program('@ emcee-append emcee')
  else
    call exec_program('SIC RENAME emcee-current.tab emcee-chain.tab')
  endif
  if (sic_lire().eq.0) call sic_insert(line)
  !
  ier = sic_getlun(lun)
  ier = sic_open(lun,'emcee-args.greg','UNKNOWN',.false.)
  !
  write(lun,'(A)') "define character*16 nn"
  write(lun,'(A,I6)') "let nn ",adj_n
  write(lun,'(A)') "if (pro%arg[1].ne.nn) then"
  write(lun,'(A)') "  SAY emcee-args.greg does not match the expected arguments"
  write(lun,'(A)') "  return"
  write(lun,'(A)') "endif"
  write(lun,'(A)') "if .not.exist(s_) then"
  write(lun,'(A)') "  define structure s_ /global"
  write(lun,'(A)') "endif"
  write(ch,*) adj_n
  ch = adjustl(ch)
  write(lun,'(A)') "define character*16 s_%arguments["//trim(ch)//"] /global"
  do i =1,adj_n
    write(ch,*) i
    ch = adjustl(ch)
    write(lun,'(A)') "let s_%arguments["//trim(ch)//"] "//trim(adj_names(i))
  enddo
  close(unit=lun)
  call sic_frelun(lun)
end subroutine adjust_mcmc
!
subroutine adjust_display(comm,line,error)
  use gildas_def
  use sic_adjust
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>adjust_display
  use sic_types
  use gbl_message
  !------------------------------------------------------------------
  ! @ private
  !   ADJUST support for ESHOW
  !   ESHOW AUTOCORR|CHAINS|ERRORS|RESULTS|TRIANGLES [Args]
  !     [/BURN] [/SPLIT]
  !------------------------------------------------------------------
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical, intent(out) :: error
  !
  integer, parameter :: o_split=2
  integer, parameter :: o_burn=1
  integer :: na,iarg,iburn,ispli
  character(len=12) :: arg, argument
  character(len=32) :: trail
  logical :: do_init
  integer, parameter :: mpar=5
  character(len=12) :: cpar(mpar)
  data cpar /'AUTOCORR','CHAINS','ERRORS','RESULTS','TRIANGLES'/
  !
  trail = ' '
  iburn = sic_start(o_burn,0)
  if (iburn.ne.0) then
    ispli = sic_start(o_split,0)
    if (ispli.gt.iburn) then
      trail = line(iburn:ispli-1)
    else
      trail = line(iburn:)
    endif
  endif
  !
  error = .false.
  call sic_ch(line,0,1,arg,na,.false.,error)
  call sic_upper (arg)
  call sic_ambigs('ESHOW',arg,argument,iarg,cpar,mpar,error)
  if (error) return
  !
  do_init = .not.sic_varexist('EMCEE_LOADED')  
  !
  select case (argument)
  case ('AUTOCORR')
    arg = '100'
    call sic_ch(line,0,2,arg,na,.false.,error)
    trail = trim(arg)//' '//trim(trail)
    if (do_init) call exec_program('@ emcee-tools') 
    if (sic_present(o_split,0)) then
      call exec_program('@ emcee-corr '//trail)
    else
      call exec_program('@ emcee-auto '//trail)
    endif
  case ('CHAINS')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-plot CHAINS '//trail)
  case ('ERRORS')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-display * '//trail)
  case ('RESULTS')
    arg = 'results'
    call sic_ch(line,0,2,arg,na,.false.,error)
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-display '//trim(arg)//' '//trail)
  case ('TRIANGLES')
    if (do_init) call exec_program('@ emcee-tools') 
    call exec_program('@ emcee-plot TRIANGLES '//trail)
  case default
    error = .true.
    return
  end select
  if (sic_lire().eq.0) call sic_insert(line)
end subroutine adjust_display
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_close
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_keyval_types
  use cubeadm_identifier
  use cubeedit_messaging
  !
  public :: close
  private
  !
  type :: close_comm_t
     type(option_t), pointer :: comm
     type(value_strg_comm_t) :: edid
     type(identifier_opt_t)  :: as
   contains
     procedure, public  :: register => cubeedit_close_comm_register
     procedure, private :: parse    => cubeedit_close_comm_parse
     procedure, private :: main     => cubeedit_close_comm_main
  end type close_comm_t
  type(close_comm_t) :: close
  !
  type close_user_t
     type(value_strg_user_t) :: edid
     type(identifier_user_t) :: as
   contains
     procedure, private :: toprog => cubeedit_close_user_toprog
  end type close_user_t
  !
  type :: close_prog_t
     character(len=base_l) :: edid = strg_unk
     character(len=base_l) :: ouid = strg_unk
   contains
     procedure, private :: act => cubeedit_close_prog_act
  end type close_prog_t
  !
contains
  !
  subroutine cubeedit_close_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command CLOSE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(close_user_t) :: user
    character(len=*), parameter :: rname='CLOSE>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call close%parse(line,user,error)
    if (error) return
    call close%main(user,error)
    if (error) return
  end subroutine cubeedit_close_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_close_comm_register(comm,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CLOSE','[bufferid]',&
         'Close an opened edited buffer',&
         'Close an opened edited buffer. The edited buffer is registered in&
         & the DAG only after CLOSE. By default, CLOSE uses the resolved&
         & edited buffer identifier as output cube&
         & identifier.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- CLOSE resolves bufferid. When omitted, it closes the most&
         & recently opened edited buffer.'//strg_cr//&
         '- Without /AS, the output cube identifier is the resolved&
         & edited buffer identifier.'//strg_cr//&
         '- With /AS outcubeid, CLOSE uses outcubeid as output cube&
         & identifier.'//strg_cr//&
         '- During close, family/flags are finalized before DAG&
         & registration.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- /AS changes only the output cube identifier and does not change&
         & which&
         & edited buffer is selected.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> CLOSE'//strg_cr//&
         'CUBE> CLOSE myedit'//strg_cr//&
         'CUBE> CLOSE myedit /AS final_cube'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN myedit /LIKE source_cube'//strg_cr//&
         'CUBE> PUT myedit ...'//strg_cr//&
         'CUBE> CLOSE myedit /AS final_cube'//strg_bl//&
         'The edited buffer is registered in the DAG only after CLOSE.',&
         cubeedit_close_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%edid%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_star,&
         code_arg_optional,&
         strg_emp,&
         error)
    if (error) return
    call comm%as%register(&
         'Output cube identifier',&
         changeflags,&
         error)
    if (error) return
  end subroutine cubeedit_close_comm_register
  !
  subroutine cubeedit_close_comm_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(close_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%edid%parse(line,comm%comm,user%edid,error)
    if (error) return
    call close%as%parse(line,user%as,error)
    if (error) return
  end subroutine cubeedit_close_comm_parse
  !
  subroutine cubeedit_close_comm_main(comm,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: comm
    type(close_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    type(close_prog_t) :: prog
    character(len=*), parameter :: rname='CLOSE>COMM>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubeedit_close_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_close_user_toprog(user,comm,prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(close_user_t), intent(in)    :: user
    type(close_comm_t),  intent(in)    :: comm    
    type(close_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_editedid(user%edid%val,prog%edid,error)
    if (error) return
    if (user%as%do) then
       prog%ouid = user%as%identifier
    else
       prog%ouid = prog%edid
    endif
  end subroutine cubeedit_close_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeedit_close_prog_act(prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(close_prog_t), intent(in)    :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>PROG>ACT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%close(prog%edid,prog%ouid,error)
    if (error) return
  end subroutine cubeedit_close_prog_act
end module cubeedit_close
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine alma_line(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use ast_line
  use ast_astro
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  ! ALMA 	Internal routine, support for command
  !	FREQUENCY name Freq Sideband [Center]
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !
  logical, intent(out) :: error            !
  ! Local
  character(len=*), parameter :: rname='ALMA_LINE'
  character(len=32) :: name,par
  integer(kind=4) :: lname, lpar
  character(len=4) :: band
  real(kind=8) :: fcent, fsky,  vsys
  integer(kind=4) :: irec, userrec
!!  real(8), parameter :: eps=(100.25d0)   ! MHz, where does that come from ?...
  character(len=message_length) :: mess
  integer, parameter :: mkeys=2
  integer ::nkey
  character(len=4) :: keys(mkeys), key
  data keys/'LSB ','USB '/
  ! ---------------------------------------------------------------------------
  !
  ! Reset
  !
  error = .false.
  bb_def(:) = .false.
  bb_nspw(:) = 0
  !
  ! FREQ linename freq lsb|usb [if]
  !
  ! Line name
  !
  lname = 12
  call sic_ch (line,0,1,name,lname,.true.,error)
  if (error) return
  !
  ! Frequency
  !
  call sic_ch (line,0,2,par,lpar,.true.,error)
  if (error) goto 99
  call sic_math_dble(par,lpar,freq,error)
  if (error) goto 930
  ! Apply the redshift correction
  if (fshift.eq.0.0d0) fshift = 1.0d0
  fsky = freq*1d3*fshift       ! In MHz
  !
  ! Sideband
  !
  call sic_ch (line,0,3,par,lpar,.true.,error)
  if (error) goto 99
  call sic_upper(par(1:lpar))
  call sic_ambigs(rname,par,key,nkey,keys,mkeys,error)
  if (error) goto 99
  if (key.eq. 'LSB') then
    band = 'LSB '
    sky = -1
  elseif (key.eq. 'USB') then
    band = 'USB '
    sky = +1
  endif
  !
  ! Find receiver band irec
  ! fcent is the default IF frequency for the requested tuning
  ! = the middle of the IF band
  !
  ! Note: the frequency boundaries below are approximative
  if (fsky.gt.80e3 .and. fsky.lt.120e3) then
    irec = 3
    iflim(1) = 4000
    iflim(2) = 8000
    fcent = 6000  ! B3 4-8 GHz 2SB
  elseif (fsky.gt.121e3 .and. fsky.lt.163e3) then
    irec = 4
    iflim(1) = 4000
    iflim(2) = 8000
    fcent = 6000  ! B4 4-8 GHz 2SB
  elseif (fsky.gt.163e3 .and. fsky.lt.211e3) then
    irec = 5
    iflim(1) = 4000
    iflim(2) = 8000
    fcent = 6000  ! B5 4-8 GHz 2SB
  elseif (fsky.gt.211e3 .and. fsky.lt.275e3) then
    irec = 6
    iflim(1) = 4500
    iflim(2) = 10000
    fcent = 8000  ! B6 5-10 GHz 2SB
  elseif (fsky.gt.275e3 .and. fsky.lt.373e3) then
    irec = 7
    iflim(1) = 4000
    iflim(2) = 8000
    fcent = 6000  ! B7 4-8 GHz 2SB
  elseif (fsky.gt.385e3 .and. fsky.lt.500e3) then
    irec = 8
    iflim(1) = 4000
    iflim(2) = 8000
    fcent = 6000  ! B8 4-8 GHz 2SB
  elseif (fsky.gt.602e3 .and. fsky.lt.720e3) then
    irec = 9
    iflim(1) = 4000
    iflim(2) = 12000
    fcent = 8000  ! B9 4-12 GHz DSB
  elseif (fsky.gt.787e3 .and. fsky.lt.950e3) then
    irec = 10
    iflim(1) = 4000
    iflim(2) = 12000
    fcent = 8000  ! B10 4-12 GHz DSB
  else
    call astro_message(seve%e,rname,'Frequency cannot be observed with ALMA')
    error = .true.
    return
  endif
  !
  call check_receiver(irec, error)
  if (error) then
    call astro_message(seve%e, rname,'Receiver band not available in selected Cycle')
    return
  endif
  !
  userrec = irec
  call sic_i4(line,8,1,userrec,.false.,error)
  if (error) return
  if (irec.ne.userrec) then
    call astro_message(seve%e,rname,'Frequency/Receiver mismatch')
    error = .true.
    return
  endif
  !
  ! Center IF
  if (sic_present(0,4)) then
    call sic_ch (line,0,4,par,lpar,.true.,error)
    if (error) goto 99
    if (par(1:1).eq.'*') then
      call astro_message(seve%i,rname,'Using default center freq.')
    else
      call sic_math_dble(par,lpar,fcent,error)
      if (error) goto 930
      if (fcent.lt.iflim(1) .or. fcent.gt.iflim(2)) then
        call astro_message(seve%e,rname,'Invalid center frequency')
        goto 930
      endif
    endif
  endif
  !
  ! Compute FLO1
  !
  flo1 = fsky-sky*fcent
  !
  ! Final check on setup feasibility
  !
  call check_flo1(irec, flo1, mess, error)
  if (error) then
    call astro_message(seve%e, rname, mess) 
    return
  endif
  ! Output message
  !
  write(mess,'(A,I2)') 'Setup valid for receiver band ', irec
  call astro_message(seve%i,rname,mess)
  if (irec.eq.6) then
     write(mess,'(A,I2,A)') 'Band ',irec,' is a 2SB receiver with IF = 5 to 10 GHz'
  elseif (irec.gt.8) then
     write(mess,'(A,I2,A)') 'Band ',irec,' is a DSB receiver with IF = 4 to 12 GHz'
  else
     write(mess,'(A,I2,A)') 'Band ',irec,' is a 2SB receiver with IF = 4 to 8 GHz'
  endif
  call astro_message(seve%i,rname,mess)
  !
  ! Trec
  !
  call alma_receiver(flo1,flo1,irec)
  !
  vsys = (1.d0-fshift)*299792.458
  if (vsys.ne.0) then
    write(mess,*) 'Source velocity = ', vsys,' km/s'
    call astro_message(seve%r,rname,mess)
  endif
  write(mess,'(a,f10.5,a)') ' FSKY  = ',fsky/1d3,' GHz'
  call astro_message(seve%r,rname,mess)
  write(mess,'(a,f10.5,a)') ' FLO1  = ',flo1/1d3,' GHz'
  call astro_message(seve%r,rname,mess)
  write(mess,'(a,f6.1,a)') ' TREC  = ',trec,' K'
  call astro_message(seve%r,rname,mess)
  !
  ! Plot label
  !
  write(label,1010) 'ALMA BAND ', irec, name(1:lenc(name)), fsky*1d-3/fshift, band, fcent,  &
  '   [V= ',vsys,' km/s]'
  recband = irec
  !
  ! Now do the plot
  !
  plot_mode = 10
  call alma_plot_def(error)
  if (error) return
  call alma_plot_line
  !
  ! End
  !
  return
  !
  ! Errors
  !
  930  call astro_message(seve%e,rname,'Error decoding '//par(1:lpar))
  99   error = .true.
  return
  !
  ! Format
  !
  ! 1010 format(a,i2,' FREQ ',a,1x,f10.5,1x,a,1x,f7.2,a,f6.1,a)
  1010 format(a,i2,a,1x,f10.5,1x,a,1x,f7.2,a,f6.1,a)
  !
end subroutine alma_line
!
function rffromif(if,band)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4) :: rffromif             !
  real(kind=4), intent(in) :: if       !
  integer(kind=4), intent(in) :: band  !
  rffromif = flo1+band*if
end function rffromif
!
function iffromrf(rf,band)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4) :: iffromrf             !
  real(kind=4), intent(in) :: rf       !
  integer(kind=4), intent(in) :: band  !
  iffromrf = (rf-flo1)/band
end function iffromrf
!
subroutine decoderf(rf,if,band)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: rf        !
  real(kind=4), intent(out) :: if       !
  integer(kind=4), intent(out) :: band  !
  band = 1
  if (rf.lt.flo1) band = -1
  if = (rf-flo1)/band
end subroutine decoderf
!
subroutine alma_receiver(f,u,irec)
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: f        ! Signal frequency
  real(kind=8), intent(in) :: u        ! Image frequency
  integer(kind=4), intent(in) :: irec  ! Receiver band
  ! Local
  real(kind=4), parameter :: h_sur_k = 6.62e-34/1.38e-23*1e9
  real(kind=4) :: ff
  !
  ! These are the Trec used by the OT (version Cycle 0)
  real(kind=4) :: ottrec(10)
  data ottrec/17.0,30.0,45.0,51.0,65.0,55.0,75.0,196.0,110.0,230.0/
  !
  ff = f*1e-3
  !
  feff = 0.95-0.05*(ff/900.0)**2  ! Forward efficiency guess
  if (f.lt.390.0) then
    gim = 0.1
    if (f.lt.300.0) then
        trec = 4.0*h_sur_k*ff + 4.0
    else
        trec = 6.0*h_sur_k*ff + 4.0
    endif
    trec = max(trec,25.0)
  else
    gim = 1.0
    trec = 5.0*h_sur_k*ff
  endif
  trec = ottrec(irec)
end subroutine alma_receiver
!
subroutine check_receiver(irec, error)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: irec  !
  logical, intent(out) :: error        !
  !
  error = .false.
  if (alma_cycle.eq.0) then
    if (irec.ne.3 .and. irec.ne.6 .and. irec.ne.7 .and. irec.ne.9) then
      error = .true.
    endif
  else
    if (irec.lt.3) then
      error = .true.
    endif
  endif
end subroutine check_receiver
!
subroutine check_flo1(irec, flo, chain, error)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: irec  !
  real(kind=8), intent(in) :: flo      !
  character(len=*), intent(inout) :: chain
  logical, intent(out) :: error        !
  ! Local
  logical :: ok
  real(kind=8) :: lo
  real(8) :: flo_limits(2,3:10)
  data flo_limits /92,108, &
  & 133, 155, &
  & 171, 203, &
  & 221, 265, &
  & 283, 365, &
  & 393, 492, &
  & 610, 712, &
  & 795, 942 /
  !
  ! Check limits of FLO1. Should be independant from Cycle,
  ! though here are Cycle 0 values (Tech. Handbook Table 1)
  !
  lo = flo/1d3
  if (irec.lt.3 .or. irec.gt.10) then
    write(chain,'(A,I0)') 'Invalid receiver ',irec
    error = .true.
    return
  endif
  ok = (lo.ge.flo_limits(1,irec)) .and. (lo.le.flo_limits(2,irec))
  if (.not.ok) then
    write(chain,'(A,F6.1,A,2F6.1)') 'LO1 ',lo,' not in range ', &
    & flo_limits(1,irec),flo_limits(2,irec)
    error = .true.
  else
    error = .false.
  endif
end subroutine check_flo1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_complex_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_complex_command
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    COMPLEX VISICUBE|WIFICUBE TO|FROM AMPLITUDE|PHASE|REAL|IMAGINARY
  !      1 /LOGSCALE
  !      2 /NORMALIZE
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  logical :: logscale
  integer :: narg,ioper,icube,idire
  character(len=*), parameter :: rname='COMPLEX/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  narg = sic_narg(0)
  if (narg.ne.3) then
     call wifisyn_message(seve%e,rname,'Three arguments needed')
     error = .true.
     return
  endif
  ! Parse
  call wifisyn_parse_cube_kind(line,icube,error)
  if (error) return
  call wifisyn_parse_dire_kind(line,idire,error)
  if (error) return
  call wifisyn_parse_oper_kind(line,ioper,error)
  if (error) return
  if (ioper.eq.code_ampl) then
     ! Currently logscale enabled only for AMPLITUDE...
     logscale = sic_present(1,0)
  endif
  ! Dispatch work
  if (idire.eq.code_complex2real) then
     if (icube.eq.code_cube_visi) then
        call wifisyn_visi_complex2real(logscale,ioper,progmap%win%cur(1),progmap,visi,error)
        if (error) return
     else if (icube.eq.code_cube_wifi) then
        call wifisyn_wifi_complex2real(logscale,ioper,1,progmap,wifi,error)
        if (error) return
     else
        call wifisyn_message(seve%e,rname,'Unknown cube kind')
        error = .true.
        return
     endif
  else if (idire.eq.code_real2complex) then
     if (icube.eq.code_cube_visi) then
        call wifisyn_visi_real2complex(ioper,progmap%win%cur(1),visi,error)
        if (error) return
     else if (icube.eq.code_cube_wifi) then
        call wifisyn_wifi_real2complex(ioper,1,wifi,error)
        if (error) return
     else
        call wifisyn_message(seve%e,rname,'Unknown cube kind')
        error = .true.
        return
     endif
  else
     call wifisyn_message(seve%e,rname,'Unknown cube kind')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_complex_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_complex2real(logscale,ioper,ichan,map,wifi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_wifi_complex2real
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,      intent(in)    :: logscale
  integer,      intent(in)    :: ioper
  integer,      intent(in)    :: ichan
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  real(kind=4) :: wreal,wimag
  integer :: ix,iy,iu,iv
  character(len=*), parameter :: rname='WIFI/COMPLEX2REAL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_wifi_header(map,wifi,error)
  if (error) return
  call wifisyn_cube_reallocate_r4d('wifi%amp',wifi%amp,error)
  if (error) return
  do iv=1,wifi%cub%nv
     do iu=1,wifi%cub%nu
        do iy=1,wifi%cub%ny
           do ix=1,wifi%cub%nx
              if (ioper.eq.code_ampl) then
                 wifi%amp%r4d(ix,iy,iu,iv) = abs(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_phas) then
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wifi%amp%r4d(ix,iy,iu,iv) = atan2(wimag,wreal)*deg_per_rad
              else if (ioper.eq.code_real) then
                 wifi%amp%r4d(ix,iy,iu,iv) = real(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_imag) then
                 wifi%amp%r4d(ix,iy,iu,iv) = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
              else
                 call wifisyn_message(seve%e,rname,'Unknown operation')
                 error = .true.
                 return
              endif
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  call wifisyn_cube_minmax_r4d(logscale,wifi%amp,error)
  if (error) return
  call wifisyn_cube_sicdef(code_readwrite,'xyuv',wifi%amp,error)
  if (error) return
  !
end subroutine wifisyn_wifi_complex2real
!
subroutine wifisyn_visi_complex2real(logscale,ioper,win,map,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_complex2real
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  integer,        intent(in)    :: ioper
  type(window_t), intent(in)    :: win
  type(map_t),    intent(in)    :: map
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  integer :: ic,iu,iv
  real(kind=4) :: wreal,wimag
  character(len=*), parameter :: rname='VISI/COMPLEX2REAL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_visi_header(map,visi,error)
  if (error) return
  call wifisyn_cube_reallocate_r3d(win%nchan,'visi%amp',visi%amp,error)
  if (error) return
  do ic=1,visi%cub%nc
     do iv=1,visi%cub%ny
        do iu=1,visi%cub%nx
           if (ioper.eq.code_ampl) then
              visi%amp%r3d(iu,iv,ic) = abs(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_phas) then
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = aimag(visi%cub%val(iu,iv,ic))
              visi%amp%r3d(iu,iv,ic) = atan2(wimag,wreal)*deg_per_rad
           else if (ioper.eq.code_real) then
              visi%amp%r3d(iu,iv,ic) = real(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_imag) then
              visi%amp%r3d(iu,iv,ic) = aimag(visi%cub%val(iu,iv,ic))
           else
              call wifisyn_message(seve%e,rname,'Unknown operation')
              error = .true.
              return
           endif
        enddo ! iu
     enddo ! iv
  enddo ! ic
  call wifisyn_cube_minmax_r3d(logscale,win,visi%amp,error)
  if (error) return
  call wifisyn_cube_sicdef(code_readwrite,'uv',visi%amp,error)
  if (error) return
  !
end subroutine wifisyn_visi_complex2real
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_header(map,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_wifi_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='WIFI/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,wifi%amp,error)
  if (error) return
  wifi%amp%gil%xaxi = 0
  wifi%amp%gil%yaxi = 0
  if (wifi%xykind) then
     ! 1st axis
     wifi%amp%char%code(1) = 'RA'
     wifi%amp%gil%dim(1) = map%axes(1)%x%sky%n
     wifi%amp%gil%ref(1) = map%axes(1)%x%sky%ref
     wifi%amp%gil%val(1) = map%axes(1)%x%sky%val
     wifi%amp%gil%inc(1) = map%axes(1)%x%sky%inc
     ! 2nd axis
     wifi%amp%char%code(2) = 'DEC'
     wifi%amp%gil%dim(2) = map%axes(2)%x%sky%n
     wifi%amp%gil%ref(2) = map%axes(2)%x%sky%ref
     wifi%amp%gil%val(2) = map%axes(2)%x%sky%val
     wifi%amp%gil%inc(2) = map%axes(2)%x%sky%inc
  else
     ! 1st axis
     wifi%amp%char%code(1) = 'Us'
     wifi%amp%gil%dim(1) = map%axes(1)%x%uvp%n
     wifi%amp%gil%ref(1) = map%axes(1)%x%uvp%ref
     wifi%amp%gil%val(1) = map%axes(1)%x%uvp%val
     wifi%amp%gil%inc(1) = map%axes(1)%x%uvp%inc
     ! 2nd axis
     wifi%amp%char%code(2) = 'Vs'
     wifi%amp%gil%dim(2) = map%axes(2)%x%uvp%n
     wifi%amp%gil%ref(2) = map%axes(2)%x%uvp%ref
     wifi%amp%gil%val(2) = map%axes(2)%x%uvp%val
     wifi%amp%gil%inc(2) = map%axes(2)%x%uvp%inc
  endif
  if (wifi%uvkind) then
     ! 3rd axis
     wifi%amp%char%code(3) = 'Up'
     wifi%amp%gil%dim(3) = map%axes(1)%u%uvp%n
     wifi%amp%gil%ref(3) = map%axes(1)%u%uvp%ref
     wifi%amp%gil%val(3) = map%axes(1)%u%uvp%val
     wifi%amp%gil%inc(3) = map%axes(1)%u%uvp%inc
     ! 4th axis
     wifi%amp%char%code(4) = 'Vp'
     wifi%amp%gil%dim(4) = map%axes(2)%u%uvp%n
     wifi%amp%gil%ref(4) = map%axes(2)%u%uvp%ref
     wifi%amp%gil%val(4) = map%axes(2)%u%uvp%val
     wifi%amp%gil%inc(4) = map%axes(2)%u%uvp%inc
  else
     ! 3rd axis
     wifi%amp%char%code(3) = 'RA'
     wifi%amp%gil%dim(3) = map%axes(1)%u%sky%n
     wifi%amp%gil%ref(3) = map%axes(1)%u%sky%ref
     wifi%amp%gil%val(3) = map%axes(1)%u%sky%val
     wifi%amp%gil%inc(3) = map%axes(1)%u%sky%inc
     ! 4th axis
     wifi%amp%char%code(4) = 'DEC'
     wifi%amp%gil%dim(4) = map%axes(2)%u%sky%n
     wifi%amp%gil%ref(4) = map%axes(2)%u%sky%ref
     wifi%amp%gil%val(4) = map%axes(2)%u%sky%val
     wifi%amp%gil%inc(4) = map%axes(2)%u%sky%inc
  endif
  !
end subroutine wifisyn_wifi_header
!
subroutine wifisyn_visi_header(map,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_header
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(visi_t), intent(inout) :: visi
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='VISI/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_common_header(map,visi%amp,error)
  if (error) return
  visi%amp%gil%ndim = 3
  if (visi%uvkind) then
     ! 1st axis
     visi%amp%char%code(1) = 'U'
     visi%amp%gil%dim(1) = map%axes(1)%a%uvp%n
     visi%amp%gil%ref(1) = map%axes(1)%a%uvp%ref
     visi%amp%gil%val(1) = map%axes(1)%a%uvp%val
     visi%amp%gil%inc(1) = map%axes(1)%a%uvp%inc
     visi%amp%gil%xaxi = 0
     ! 2nd axis
     visi%amp%char%code(2) = 'V'
     visi%amp%gil%dim(2) = map%axes(2)%a%uvp%n
     visi%amp%gil%ref(2) = map%axes(2)%a%uvp%ref
     visi%amp%gil%val(2) = map%axes(2)%a%uvp%val
     visi%amp%gil%inc(2) = map%axes(2)%a%uvp%inc
     visi%amp%gil%yaxi = 0
  else
     ! 1st axis
     visi%amp%char%code(1) = 'RA'
     visi%amp%gil%dim(1) = map%axes(1)%a%sky%n
     visi%amp%gil%ref(1) = map%axes(1)%a%sky%ref
     visi%amp%gil%val(1) = map%axes(1)%a%sky%val
     visi%amp%gil%inc(1) = map%axes(1)%a%sky%inc
     visi%amp%gil%xaxi = 1
     ! 2nd axis
     visi%amp%char%code(2) = 'DEC'
     visi%amp%gil%dim(2) = map%axes(2)%a%sky%n
     visi%amp%gil%ref(2) = map%axes(2)%a%sky%ref
     visi%amp%gil%val(2) = map%axes(2)%a%sky%val
     visi%amp%gil%inc(2) = map%axes(2)%a%sky%inc
     visi%amp%gil%yaxi = 2
  endif
  ! 3rd axis
  ! *** JP The following information should be stored in a freq/velo axis component of map
  visi%amp%char%code(3) = 'VELOCITY'
  visi%amp%gil%dim(3) = map%win%cur(map%win%n)%last-map%win%cur(1)%first+1
  visi%amp%gil%ref(3) = map%huv%gil%ref(2) - map%win%cur(1)%first +1
  visi%amp%gil%val(3) = map%huv%gil%voff
  visi%amp%gil%inc(3) = -(clight/1000d0)*map%huv%gil%fres/map%huv%gil%freq ! *** JP doppler not taken into account
!  visi%amp%gil%inc(3) = map%huv%gil%vres
  visi%amp%gil%faxi = 3
  !
end subroutine wifisyn_visi_header
!
subroutine wifisyn_common_header(map,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_common_header
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(map_t),  intent(in)    :: map
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='COMMON/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call gdf_copy_header(map%huv,cube,error)
  if (error)  return
  !
  ! Cube unit
  cube%char%unit = 'Jy/beam'
  ! Projection information (assume equatorial system)
  cube%gil%proj_words = 9
! *** JP Should use the map%shift information.
!  cube%gil%ra  = map%huv%gil%ra
!  cube%gil%dec = map%huv%gil%dec
!  cube%gil%lii = map%huv%gil%lii
!  cube%gil%bii = map%huv%gil%bii
  cube%gil%ptyp = p_azimuthal ! Azimuthal (Sin)
  cube%gil%pang = map%shift%pang
  cube%gil%a0 = map%shift%a0
  cube%gil%d0 = map%shift%d0
  cube%char%syst = 'EQUATORIAL'
  ! Noise section
  cube%gil%nois_words = 0
  ! Initialized extrema section
  cube%gil%extr_words = 10
  cube%gil%rmin = +1e38
  cube%gil%rmax = -1e38
  ! No beam yet
  cube%gil%reso_words = 0
  ! Others
  cube%char%type = 'GILDAS_IMAGE'
  cube%loca%size = cube%gil%dim(1)*cube%gil%dim(2)*cube%gil%dim(3)*cube%gil%dim(4)
  !
end subroutine wifisyn_common_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_wifi_real2complex(ioper,ichan,wifi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_wifi_real2complex
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,      intent(in)    :: ioper
  integer,      intent(in)    :: ichan
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  real(kind=4) :: wreal,wimag,wampl,wphas
  integer :: ix,iy,iu,iv
  character(len=*), parameter :: rname='WIFI/REAL2COMPLEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  do iv=1,wifi%cub%nv
     do iu=1,wifi%cub%nu
        do iy=1,wifi%cub%ny
           do ix=1,wifi%cub%nx
              if (ioper.eq.code_ampl) then
                 wampl = wifi%amp%r4d(ix,iy,iu,iv)
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wphas = atan2(wimag,wreal)
                 wreal = wampl*cos(wphas)
                 wimag = wampl*sin(wphas)
              else if (ioper.eq.code_phas) then
                 wampl = abs(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wphas = wifi%amp%r4d(ix,iy,iu,iv)*rad_per_deg
                 wreal = wampl*cos(wphas)
                 wimag = wampl*sin(wphas)
              else if (ioper.eq.code_real) then
                 wreal = wifi%amp%r4d(ix,iy,iu,iv)
                 wimag = aimag(wifi%cub%val(ichan,ix,iy,iu,iv))
              else if (ioper.eq.code_imag) then
                 wreal = real(wifi%cub%val(ichan,ix,iy,iu,iv))
                 wimag = wifi%amp%r4d(ix,iy,iu,iv)
              else
                 call wifisyn_message(seve%e,rname,'Unknown operation')
                 error = .true.
                 return
              endif
              wifi%cub%val(ichan,ix,iy,iu,iv) = cmplx(wreal,wimag)
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  !
end subroutine wifisyn_wifi_real2complex
!
subroutine wifisyn_visi_real2complex(ioper,win,visi,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_visi_real2complex
  use wifisyn_gridding_types
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,        intent(in)    :: ioper
  type(window_t), intent(in)    :: win
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  integer :: ic,iu,iv
  real(kind=4) :: wreal,wimag,wampl,wphas
  character(len=*), parameter :: rname='VISI/REAL2COMPLEX'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  do ic=1,visi%cub%nc
     do iv=1,visi%cub%ny
        do iu=1,visi%cub%nx
           if (ioper.eq.code_ampl) then
              wampl = visi%amp%r3d(iu,iv,ic)
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = aimag(visi%cub%val(iu,iv,ic))
              wphas = atan2(wimag,wreal)
              wreal = wampl*cos(wphas)
              wimag = wampl*sin(wphas)
           else if (ioper.eq.code_phas) then
              wampl = abs(visi%cub%val(iu,iv,ic))
              wphas = visi%amp%r3d(iu,iv,ic)*rad_per_deg
              wreal = wampl*cos(wphas)
              wimag = wampl*sin(wphas)
           else if (ioper.eq.code_real) then
              wreal = visi%amp%r3d(iu,iv,ic)
              wimag = aimag(visi%cub%val(iu,iv,ic))
           else if (ioper.eq.code_imag) then
              wreal = real(visi%cub%val(iu,iv,ic))
              wimag = visi%amp%r3d(iu,iv,ic)
           else
              call wifisyn_message(seve%e,rname,'Unknown operation')
              error = .true.
              return
           endif
           visi%cub%val(iu,iv,ic) = cmplx(wreal,wimag)
        enddo ! iu
     enddo ! iv
  enddo ! ic
  !
end subroutine wifisyn_visi_real2complex
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine astro_uv_doppler(line,error)
  use image_def
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_uv_doppler
  use gbl_format
  use gbl_message
  !-----------------------------------------------------------------------
  ! @ private
  !   Support for command UV_DOPPLER
  ! Task to compute the Doppler correction and apply it (by changing
  ! the u,v coordinates) to an UV Table.
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=filename_length) :: file
  character(len=12) :: telescope
  character(len=*), parameter :: rname='UV_DOPPLER'
  type (gildas) :: uvin, uvou
  integer(kind=4) :: nf, i, ier, ib
  real(kind=4) :: rdate, rtime, doppler
  real(kind=8), parameter :: clight_kms=299792.458d0
  character(len=2) :: coord
  character(len=80) :: mess
  real(kind=4) :: equinox
  real(kind=8) :: lambda, beta
  integer(kind=4) :: nblock, nvisi, idate, itime
  logical :: output
  integer(kind=4) :: mode
  integer(kind=4) :: idopp
  !
  call sic_ke(line,0,1,telescope,nf,.true.,error)
  if (error)  return
  call astro_observatory(telescope,error)
  if (error) return
  !
  call sic_ch(line,0,2,file,nf,.true.,error)
  if (error)  return
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
  if (error) then
    call astro_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock),stat=ier)
  if (failed_allocate(rname,'UV input data',ier,error))  return
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  output = sic_present(0,3)
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  !
  mode = 0
  call sic_i4(line,0,4,mode,.false.,error)
  if (error)  return
  if (mode.ne.0) then
    idopp = 3
    do i = 1,code_uvt_last
      if (uvou%gil%column_pointer(i).eq.idopp)  then
        uvou%gil%column_size(i) = 0
        uvou%gil%column_pointer(i) = 0
      endif
    enddo
    uvou%gil%column_pointer(code_uvt_topo) = idopp
    uvou%gil%column_size(code_uvt_topo) = 1
  endif
  !
  if (output) then
    call sic_ch(line,0,3,file,nf,.true.,error)
    call sic_parse_file(file,' ','.uvt',uvou%file)
    !
    ! create the image
    uvou%gil%dopp = 0.d0
    uvou%gil%version_uv = code_version_uvt_syst
    call gdf_create_image(uvou,error)
    if (error) then
      call gdf_close_image(uvin,error)
      deallocate(uvin%r2d,stat=ier)
      error = .true.
      return
    endif
  endif
  !
  coord = uvin%char%syst
  if (coord.eq.'EQ') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  else if (coord.eq.'GA') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%lii
    beta   = uvin%gil%bii
  else
    coord = 'EQ'
    call astro_message(seve%w,rname,'Unsupported system '//coord)
    call astro_message(seve%w,rname,'Assuming EQUATORIAL')
    equinox = 2000.0
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  endif
  !
  ! Loop over line table
  uvou%blc = 0
  uvou%trc = 0
  uvin%blc = 0
  uvin%trc = 0
  rdate = -1e38
  rtime = -1e38
  idate = uvin%gil%column_pointer(code_uvt_date)
  itime = uvin%gil%column_pointer(code_uvt_time)
  !
  do ib = 1,uvou%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvou%gil%dim(2),nblock
    call astro_message(seve%d,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    nvisi = uvin%trc(2)-uvin%blc(2)+1
    !
    ! Here do the job
    do i=1,nvisi
      !
      if (uvin%r2d(idate,i).ne.rdate .or. uvin%r2d(itime,i).ne.rtime) then
        rdate = uvin%r2d(idate,i)
        rtime = uvin%r2d(itime,i)
        call sub_uv_doppler(uvin%gil%vtyp,rdate,rtime,doppler,&
          coord,equinox,lambda,beta,error)
        !! factor = (1.d0 + doppler)
        if (.not.output) then
          Print *,' Visi ',i+nblock*(ib-1),rdate,rtime,clight_kms*doppler
        endif
      endif
      if (idopp.ne.0) uvin%r2d(idopp,i) = doppler
    enddo
    !
    if (output) then
      call gdf_write_data (uvou,uvin%r2d,error)
      if (error) then
        call gdf_close_image(uvou,error)
        call gdf_close_image(uvin,error)
        deallocate(uvin%r2d,stat=ier)
        error = .true.
        return
      endif
    endif
  enddo
  !
  call gdf_close_image(uvin,error)
  if (output) call gdf_close_image(uvou,error)
  deallocate(uvin%r2d,stat=ier)
end subroutine astro_uv_doppler
!
subroutine sub_uv_doppler(vtype,rdate,rtime,doppler, &
        & coord,equinox,lambda,beta,error)
  use image_def
  use astro_interfaces, except_this => sub_uv_doppler
  use gbl_message
  use gbl_constant
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! Compute the Doppler correction, calling ASTRO routine, according to:
  ! * observatory location
  ! * reference frame (LSR, Helio...)
  ! Radio convention is used
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: vtype    ! Type of referential
  real(kind=4),     intent(in)  :: rdate    ! GAG Date
  real(kind=4),     intent(in)  :: rtime    ! UT Time
  real(kind=4),     intent(out) :: doppler  ! Doppler factor
  character(len=2), intent(in)  :: coord    !
  real(kind=4),     intent(in)  :: equinox  !
  real(kind=8),     intent(in)  :: lambda   !
  real(kind=8),     intent(in)  :: beta     !
  logical,          intent(out) :: error    ! flag
  ! Local
  real(kind=8) :: vshift
  real(kind=8) :: s_2(2), s_3(3), dop, lsr, svec(3), x_0(3), parang
  real(kind=8) :: jtdt, jut1, jutc
  !
  doppler = -1d0
  !
  ! Reset the time
  jutc = rdate + rtime/86400.d0 +  2460549.5d0
  !
  ! For what we want to do, these are negligible
  jut1 = 0.d0
  Jtdt = 0.
  call do_astro_time(jutc,jut1,jtdt,error)
  if (error) return
  !
  ! Call ASTRO
  call do_object(coord,equinox,lambda,beta,s_2,s_3,dop,lsr,svec, &
      &   x_0,parang,error)
  if (error) return
  !
  ! Now retrieve the Doppler value
  !
  select case (vtype)
  case (vel_lsr)
     vshift = dop+lsr
  case (vel_hel)
     vshift = dop
  case (vel_ear)
     vshift = 0.0d0
  case default
     vshift = 0.0d0
  end select
  !
  ! This follows the CLASS convention, but it seems that the
  ! CLIC convention is WRONG ...
  doppler = - vshift / clight * 1d3
end subroutine sub_uv_doppler

subroutine init_alma_sdm(file,error)
  character *(*) file          ! the root file (directory) of the SDM
  logical error                ! error return
  print *,'I-SDM, init ',file
end subroutine init_alma_sdm
!

module greg_wcs
  use gbl_constant
  use gwcs_types
  !--------------------------------------------------------------------
  ! Projection definitions
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  ! Current projection in Greg
  type(projection_t), save :: gproj
  !
  ! Internal to GreG only
  integer(kind=4)         :: u_angle    ! Angle unit
  integer(kind=4)         :: ipole      ! Which pole visible ? 1 none, 2 North, 3 South, 4 Both
  integer(kind=4), save   :: i_system   ! Coordinate system
  real(kind=4)            :: i_equinox  ! Equinox if coordinate system is Equatorial
  real(kind=4), parameter :: i_equinox_def=2000.0  ! Default equinox if Equatorial system
  logical                 :: vpole      ! Pole at infinity
  !
  ! Remarkable points
  real(kind=8) :: axrem1,axrem2,axrem3,axrem4,axrem5,axrem6
  real(kind=8) :: ayrem1,ayrem2,ayrem3,ayrem4,ayrem5,ayrem6
  real(kind=8), save :: decmin,decmax   ! Dec minima and maxima
  real(kind=8), save :: ramin,ramax     ! RA minima and maxima
end module greg_wcs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_wsw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_level_codes
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_wsw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked wobbler switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  integer(kind=4) :: iref,nref
  character(len=*), parameter :: rname='CALIB>TRACKED>WSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_refloop(backsci,nref,error)
  if (error) return
  do iref=1,nref
     call mrtcal_get_nextref(backsci,error)
     if (error) return
     call mrtcal_init_onloop(backsci,non,error)
     if (error) return
     do ion=1,non
        call mrtcal_get_nexton(backsci,error)
        if (error) return
        call mrtcal_init_dumpcycle_loop('track',mrtset,filebuf,backsci,error)
        if (error) return
        do while (backsci%switch%book%idump.le.backsci%switch%book%ndump)
           call mrtcal_get_next_dumpcycle(mrtset,filebuf,backsci,error)
           if (error) return
           if (backsci%switch%book%found) then
              call mrtcal_on_minus_off_new(nototfmap,notfsw,backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_computation(backcal,backsci,error)
              if (error) return
              call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
              if (error) return
              call mrtcal_accumulate_or_write(level_cycl_code,mrtset,backsci,error)
              if (error) return
           endif
           ! User can interrupt the pipeline
           if (sic_ctrlc_status()) then
              error = .true.
              exit
           endif
        enddo ! switch%book%idump
        call mrtcal_switch_book_list(backsci%switch%book,error)
        if (error) return
        call mrtcal_accumulate_or_write(level_subs_code,mrtset,backsci,error)
        if (error) return
     enddo ! ion
  enddo ! iref
  call mrtcal_accumulate_or_write(level_scan_code,mrtset,backsci,error)
  if (error) return
  !
end subroutine mrtcal_calib_tracked_wsw
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_shift_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_command
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! @ private
  ! Entry point for command SHIFT
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(action_t) :: user_trans
  type(user_shift_t) :: user_shift
  character(len=*), parameter :: rname='SHIFT/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_parse_transform_bis(line,user_trans,error)
  if (error) return
  call wifisyn_shift_parse(line,user_trans,user_shift,error)
  if (error) return
  call wifisyn_shift_main(user_trans,user_shift,error)
  if (error) return
  !
end subroutine wifisyn_shift_command
!
subroutine wifisyn_shift_parse(line,user_trans,user_shift,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_parse
  use wifisyn_buffer_parameters
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*),   intent(inout) :: line
  type(action_t),     intent(in)    :: user_trans
  type(user_shift_t), intent(out)   :: user_shift
  logical,            intent(inout) :: error
  !
  integer, parameter :: ivisi = 4
  integer, parameter :: idx = 1
  integer, parameter :: idy = 2
  integer, parameter :: iunit = 3
  !
  character(len=*), parameter :: rname='SHIFT/PARSE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (user_trans%cube.ne.code_buffer_visi) return
  call sic_r8(line,ivisi,idx,user_shift%dx,.true.,error)
  if (error) return
  call sic_r8(line,ivisi,idy,user_shift%dy,.true.,error)
  if (error) return
  call wifisyn_parse_unit_kind(line,ivisi,iunit,user_shift%unit,error)
  if (error) return
  !
end subroutine wifisyn_shift_parse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_shift_main(user_trans,user_shift,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_main
  use wifisyn_transform_types
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(action_t),     intent(in)    :: user_trans
  type(user_shift_t), intent(in)    :: user_shift
  logical,            intent(inout) :: error
  !
  character(len=*), parameter :: rname='SHIFT/MAIN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  select case (user_trans%cube)
  case (code_buffer_uv)
     call wifisyn_message(seve%e,rname,'Not yet implemented')
     error = .true.
     return
  case (code_buffer_visi)
     call wifisyn_shift_visi(user_trans%dire,user_shift,progmap,visi,error)
     if (error) return
  case (code_buffer_wifi)
     select case (user_trans%space)
     case (code_space_uv)
        call wifisyn_shift_wifi_uv(user_trans%dire,progmap,wifi,error)
        if (error) return
     case (code_space_xy)
        call wifisyn_message(seve%e,rname,'Not yet implemented')
        error = .true.
        return
     case default
        call wifisyn_message(seve%e,rname,'Unknown space')
        error = .true.
        return
     end select
  case default
     call wifisyn_message(seve%e,rname,'Unknown buffer')
     error = .true.
     return
  end select
  !
end subroutine wifisyn_shift_main
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_shift_wifi_uv(idir,map,wifi,error)
  use gbl_message
  use phys_const
  use gkernel_interfaces
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_shift_wifi_uv
  use wifisyn_transform_types
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,             intent(in)    :: idir
  type(map_t), target, intent(in)    :: map
  type(wifi_t),        intent(inout) :: wifi
  logical,             intent(inout) :: error
  !
  integer :: ix,iy,iu,iv
  real(kind=8) :: tophase,pha,xu,yv
  complex(kind=8) :: exppha
  type(dble_1d_t), pointer :: ucoord
  type(dble_1d_t), pointer :: vcoord
  type(dble_1d_t), pointer :: xcoord
  type(dble_1d_t), pointer :: ycoord
  type(time_t) :: time
  character(len=*), parameter :: rname='SHIFT/WIFI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (.not.wifi%uvkind) then
     call wifisyn_message(seve%e,rname,'WIFICUB UV space must be of type UVP => Use first FFT /DIR')
     error = .true.
     return
  endif
  ucoord => map%axes(1)%u%uvp%coord
  vcoord => map%axes(2)%u%uvp%coord
  xcoord => map%axes(1)%x%sky%coord
  ycoord => map%axes(2)%x%sky%coord
  tophase = f_to_k*map%rchan%freq
  if (idir.eq.code_inverse) then
     tophase = -tophase
  else if (idir.ne.code_direct) then
     call wifisyn_message(seve%e,rname,'Unknown direction')
     error = .true.
     return
  endif
  call gtime_init(time,wifi%cub%nv,error)
  if (error) return
  do iv=1,wifi%cub%nv
     call gtime_current(time)
     do iu=1,wifi%cub%nu
        do iy=1,wifi%cub%ny
           yv = ycoord%val(iy)*vcoord%val(iv)
           do ix=1,wifi%cub%nx
              xu = xcoord%val(ix)*ucoord%val(iu)
              pha = tophase*(xu+yv)
              exppha = cmplx(cos(pha),sin(pha))
              wifi%cub%val(:,ix,iy,iu,iv) = wifi%cub%val(:,ix,iy,iu,iv)*exppha
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  !
end subroutine wifisyn_shift_wifi_uv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_shift_visi(idire,user,map,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_visi
  use wifisyn_transform_types
  use wifisyn_cube_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** JP Should we change a0 and d0???
  !---------------------------------------------------------------------
  integer,            intent(in)    :: idire
  type(user_shift_t), intent(in)    :: user
  type(map_t),        intent(in)    :: map
  type(visi_t),       intent(inout) :: visi
  logical,            intent(inout) :: error
  !
  type(myshift_t) :: shift
  character(len=*), parameter :: rname='SHIFT/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_shift_visi_set(map,visi,idire,user,shift,error)
  if (error) return
  if (shift%phase) then
     call wifisyn_shift_visi_phase(shift,visi,error)
     if (error) return
  else
     call wifisyn_shift_visi_grid(shift,visi,error)
     if (error) return
  endif
  !
end subroutine wifisyn_shift_visi
!
subroutine wifisyn_shift_visi_set(map,visi,idire,user,shift,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_shift_visi_set
  use wifisyn_cube_types
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(map_t), target, intent(in)    :: map
  type(visi_t),        intent(in)    :: visi
  integer,             intent(in)    :: idire
  type(user_shift_t),  intent(in)    :: user
  type(myshift_t),     intent(out)   :: shift
  logical,             intent(inout) :: error
  !
  type(axis_1d_t), pointer :: xaxis,yaxis
  type(dble_1d_t), pointer :: ucoord,vcoord
  character(len=*), parameter :: rname='SHIFT/VISI/SET'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  shift%dire = idire
  shift%freq = map%rchan%freq
  select case (user%unit)
  case (code_unit_second)
     ! Simple case: uv and xy coordinate names are intuitive
     shift%phase = visi%uvkind
     if (shift%phase) then
        shift%ucoord => map%axes(1)%a%uvp%coord
        shift%vcoord => map%axes(2)%a%uvp%coord
     endif
     xaxis => map%axes(1)%a%sky
     yaxis => map%axes(2)%a%sky
     shift%dx = user%dx*rad_per_sec
     shift%dy = user%dy*rad_per_sec
  case (code_unit_meter)
     ! Complex case: uv and xy coordinate names are exchanged to simplify
     ! later calling sequences
     shift%phase = .not.visi%uvkind
     if (shift%phase) then
        shift%ucoord => map%axes(1)%a%sky%coord
        shift%vcoord => map%axes(2)%a%sky%coord
     endif
     xaxis => map%axes(1)%a%uvp
     yaxis => map%axes(2)%a%uvp
     shift%dx = user%dx
     shift%dy = user%dy
  case default
     call wifisyn_message(seve%e,rname,'Unknown unit')
     error = .true.
     return
  end select
  !
  ! This ensures that the shift double vector matches the shift pixel vector
  call wifisyn_axis_ddx2idx(xaxis,shift%dx,shift%idx,error)
  call wifisyn_axis_idx2ddx(xaxis,shift%idx,shift%dx,error)
  call wifisyn_axis_ddx2idx(yaxis,shift%dy,shift%idy,error)
  call wifisyn_axis_idx2ddx(yaxis,shift%idy,shift%dy,error)
  !
end subroutine wifisyn_shift_visi_set
!
subroutine wifisyn_shift_visi_phase(shift,visi,error)
  use gbl_message
  use phys_const
  use gkernel_interfaces
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_shift_visi_phase
  use wifisyn_transform_types
  use wifisyn_cube_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(myshift_t), intent(in)    :: shift
  type(visi_t),    intent(inout) :: visi
  logical,         intent(inout) :: error
  !
  integer :: iu,iv
  real(kind=8) :: dx,udx
  real(kind=8) :: dy,vdy
  real(kind=8) :: tophase,pha
  complex(kind=8) :: exppha
  type(time_t) :: time
  character(len=*), parameter :: rname='SHIFT/VISI/PHASE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  tophase = f_to_k*shift%freq
  select case (shift%dire)
  case (code_direct)
     dx = +tophase*shift%dx
     dy = +tophase*shift%dy
  case (code_inverse)
     dx = -tophase*shift%dx
     dy = -tophase*shift%dy
  case default
     call wifisyn_message(seve%e,rname,'Unknown direction')
     error = .true.
     return
  end select
  !
  call gtime_init(time,visi%cub%ny,error)
  if (error) return
  do iv=1,visi%cub%ny
     call gtime_current(time)
     vdy = shift%vcoord%val(iv)*dy
     do iu=1,visi%cub%nx
        udx = shift%ucoord%val(iu)*dx
        pha = udx+vdy
        exppha = cmplx(cos(pha),sin(pha),8)
        visi%cub%val(iu,iv,:) = visi%cub%val(iu,iv,:)*exppha
     enddo ! iu
  enddo ! iv
  !
end subroutine wifisyn_shift_visi_phase
!
subroutine wifisyn_shift_visi_grid(shift,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_visi_grid
  use wifisyn_transform_types
  use wifisyn_cube_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(myshift_t), intent(in)    :: shift
  type(visi_t),    intent(inout) :: visi
  logical,         intent(inout) :: error
  !
  integer :: jdx,jdy
  character(len=80) :: mess
  character(len=*), parameter :: rname='SHIFT/VISI/GRID'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  select case (shift%dire)
  case (code_direct)
     jdx = -shift%idx
     jdy = -shift%idy
  case (code_inverse)
     jdx = +shift%idx
     jdy = +shift%idy
  case default
     call wifisyn_message(seve%e,rname,'Unknown direction')
     error = .true.
     return
  end select
  write(mess,'(a,i0,a,i0,a)') 'Shifting by (',jdx,',',jdy,') pixels'
  call wifisyn_message(seve%i,rname,mess)
  !
  visi%cub%val = cshift(visi%cub%val,jdx,dim=1)
  visi%cub%val = cshift(visi%cub%val,jdy,dim=2)
  !
end subroutine wifisyn_shift_visi_grid
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_shift_uv_head(shift,htab,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_uv_head
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  ! The output table has its U and V shifted and rotated
  ! All V values are flip to be negative
  ! UVMIN and UVMAX are computed
  !----------------------------------------------------------------------
  type(shift_t),   intent(inout) :: shift
  type(uv_head_t), intent(inout) :: htab
  logical,         intent(inout) :: error
  !
  integer :: ndata,idata
  real :: uv,uvmin,uvmax
  real :: udata,umin,umax
  real :: vdata,vmin,vmax
  real :: xdata,xmin,xmax
  real :: ydata,ymin,ymax
  character(len=*), parameter :: rname='SHIFT/UV/HEAD'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ndata = htab%type%ndata
  call wifisyn_allocate_logi_1d('vsign',ndata,shift%vsign,error)
  if (error) return
  !
  ! Initialize dertermination of xyuv minimum and maximum
  umin = +1e38
  vmin = +1e38
  xmin = +1e38
  ymin = +1e38
  umax = -1e38
  vmax = -1e38
  xmax = -1e38
  ymax = -1e38
  uvmax = 0.0
  uvmin = +1e38
  !
  ! Flip visibility uv positions and keep associated sign information
  if (shift%cs(2).eq.0.0) then
     ! Simple case: No phase shift
     do idata=1,ndata
        udata = htab%u(idata)
        vdata = htab%v(idata)
        xdata = htab%x(idata)
        ydata = htab%y(idata)
        if (vdata.gt.0) then
           htab%u(idata) = -udata
           htab%v(idata) = -vdata
           shift%vsign%val(idata) = .false.
        else
           shift%vsign%val(idata) = .true.
        endif
        uv = udata*udata+vdata*vdata
        if (uv.ne.0) then
           uvmax = max(uvmax,uv)
           uvmin = min(uvmin,uv)
        endif
        umin = min(umin,udata)
        vmin = min(vmin,vdata)
        xmin = min(xmin,xdata)
        ymin = min(ymin,ydata)
        umax = max(umax,udata)
        vmax = max(vmax,vdata)
        xmax = max(xmax,xdata)
        ymax = max(ymax,ydata)
     enddo
  else
     ! Complex case: Phase center has been shifted
     do idata=1,ndata
        udata = htab%u(idata)
        vdata = htab%v(idata)
        xdata = htab%x(idata)
        ydata = htab%y(idata)
        htab%u(idata) = shift%cs(1)*udata - shift%cs(2)*vdata
        htab%v(idata) = shift%cs(2)*udata + shift%cs(1)*vdata
        udata = htab%u(idata)
        vdata = htab%v(idata)
        if (vdata.gt.0) then
           htab%u(idata) = -udata
           htab%v(idata) = -vdata
           shift%vsign%val(idata) = .false.
        else
           shift%vsign%val(idata) = .true.
        endif
        uv = udata*udata+vdata*vdata
        if (uv.ne.0) then
           uvmax = max(uvmax,uv)
           uvmin = min(uvmin,uv)
        endif
        ! Shifting of X and Y axis
        umin = min(umin,udata)
        vmin = min(vmin,vdata)
        xmin = min(xmin,xdata)
        ymin = min(ymin,ydata)
        umax = max(umax,udata)
        vmax = max(vmax,vdata)
        xmax = max(xmax,xdata)
        ymax = max(ymax,ydata)
     enddo
  endif
  !
  ! End determination of uv minimum and maximum
  htab%type%uvmin = sqrt(uvmin)
  htab%type%uvmax = sqrt(uvmax)
  !
  htab%type%umin = umin
  htab%type%vmin = vmin
  !
  htab%type%umax = umax
  htab%type%vmax = vmax
  !
  htab%type%xmin = xmin
  htab%type%xmax = xmax
  !
  htab%type%ymin = ymin
  htab%type%ymax = ymax
  !
end subroutine wifisyn_shift_uv_head
!
subroutine wifisyn_shift_uv_data(shift,tabin,tabout,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_shift_uv_data
  use wifisyn_uv_types
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  ! The output UV table is a rotated, phase shifted copy of
  ! the input one
  !----------------------------------------------------------------------
  type(shift_t), intent(inout) :: shift
  type(uv_t),    intent(in)    :: tabin
  type(uv_t),    intent(inout) :: tabout
  logical,       intent(inout) :: error
  !
  integer :: ndata,idata
  real :: phi,cphi,sphi
  character(len=*), parameter :: rname='SHIFT/UV/DATA'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ndata = tabin%head%type%ndata
  if (inconsistent_size(rname,'input  table',ndata,'output table',tabout%head%type%ndata,error)) return
  if (inconsistent_size(rname,'input  table',tabin%head%type%nchan,'output table',tabout%head%type%nchan,error)) return
  if (inconsistent_size(rname,'input  table',ndata,'v sign array',shift%vsign%n,error)) return
  !
  if (shift%xy(1).eq.0 .and. shift%xy(2).eq.0) then
     ! Simple case: No phase shift
     do idata=1,ndata
        if (shift%vsign%val(idata)) then
           tabout%data(idata,:,:) = tabin%data(idata,:,:)
        else
           tabout%data(idata,1,:) =  tabin%data(idata,1,:)
           tabout%data(idata,2,:) = -tabin%data(idata,2,:)
           tabout%data(idata,3,:) =  tabin%data(idata,3,:)
        endif
     enddo
  else
     ! Complex case: Phase center has been shifted
     do idata=1,ndata
        phi = shift%xy(1)*tabout%head%u(idata)+shift%xy(2)*tabout%head%v(idata)
        cphi = cos(phi)
        sphi = sin(phi)
        if (shift%vsign%val(idata)) then
           tabout%data(idata,1,:) = tabin%data(idata,1,:)*cphi - tabin%data(idata,2,:)*sphi
           tabout%data(idata,2,:) = tabin%data(idata,1,:)*sphi + tabin%data(idata,2,:)*cphi
           tabout%data(idata,3,:) = tabin%data(idata,3,:)
        else
           tabout%data(idata,1,:) = tabin%data(idata,1,:)*cphi + tabin%data(idata,2,:)*sphi
           tabout%data(idata,2,:) = tabin%data(idata,1,:)*sphi - tabin%data(idata,2,:)*cphi
           tabout%data(idata,3,:) = tabin%data(idata,3,:)
        endif
     enddo
  endif
  ! Clean up
  call wifisyn_free_logi_1d(shift%vsign,error)
  if (error) return
  !
end subroutine wifisyn_shift_uv_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_compress
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubemain_messaging
  !
  public :: compress
  private
  !
  type :: compress_comm_t
     type(option_t), pointer :: comm
     type(option_t), pointer :: spatial
     type(option_t), pointer :: spectral
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: register => cubemain_compress_comm_register
     procedure, private :: parse    => cubemain_compress_comm_parse
     procedure, private :: main     => cubemain_compress_comm_main
  end type compress_comm_t
  type(compress_comm_t) :: compress
  !
  type compress_user_t
     type(cubeid_user_t)     :: cubeids
     logical                 :: dospatial
     character(len=24)       :: lmfactor
     logical                 :: dospectral
     character(len=24)       :: cfactor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubemain_compress_user_toprog
  end type compress_user_t
  !
  type compress_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer   :: incube
     integer(kind=indx_k)    :: lmfactor,cfactor
     integer(kind=indx_k)    :: factor1,factor2,factor3
     type(cube_t), pointer   :: oucube
   contains
     procedure, private :: header => cubemain_compress_prog_header
     procedure, private :: data   => cubemain_compress_prog_data
     procedure, private :: loop   => cubemain_compress_prog_loop
     procedure, private :: act    => cubemain_compress_prog_act
  end type compress_prog_t
  !
contains
  !
  subroutine cubemain_compress_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(compress_user_t) :: user
    character(len=*), parameter :: rname='COMPRESS>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call compress%parse(line,user,error)
    if (error) return
    call compress%main(user,error)
    if (error) continue
  end subroutine cubemain_compress_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_compress_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(standard_arg_t) :: stdarg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='COMPRESS>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'COMPRESS','[cubeid]',&
         'Compress an image or cube by a factor 2 in spatial directions',&
         'For extremely large cubes, COMPRESS builds a lower-resolution&
         & quick-look cube by binning neighboring spatial pixels and&
         & spectral channels, so you can inspect it first and then&
         & EXTRACT the interesting region from the full-resolution&
         & input cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /SPATIAL and /SPECTRAL control the spatial and spectral binning factors.'//strg_cr//&
         '- Each output voxel is the arithmetic mean of the input voxels in&
         & the corresponding compression block.'//strg_cr//&
         '- Boundary blocks use the same mean rule on the available voxels&
         & only when the block is truncated at cube edges.'//strg_cr//&
         '- /RANGE, /CENTER, and /SIZE restrict the input region before&
         & compression.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> COMPRESS cubeA'//strg_cr//&
         'CUBE> COMPRESS cubeA /SPATIAL 4 /SPECTRAL 2'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> COMPRESS hugecube /SPATIAL 8 /SPECTRAL 2'//strg_cr//&
         'CUBE> GO\VIEW'//strg_cr//&
         'CUBE> EXTRACT hugecube /CENTER 120 80 relative arcsec /SIZE&
         & 40 40 arcsec /RANGE -10 10 km/s'//strg_cr//&
         'CUBE> GO\VIEW',&
         cubemain_compress_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'CUBEID',&
         'Signal cube',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SPATIAL','N',&
         'Customize the compression factor along spatial axes',&
         'Set the spatial compression factor N applied to both spatial&
         & axes. If /SPATIAL is omitted, default is 2.',&
         comm%spatial,error)
    if (error) return
    call stdarg%register(&
         'N',&
         'Compression factor',&
         'Required when /SPATIAL is present.',&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SPECTRAL','N',&
         'Customize the compression factor along spectral axis',&
         'Set the spectral compression factor N applied to the channel&
         & axis. If /SPECTRAL is omitted, default is 1 (no spectral&
         & compression).',&
         comm%spectral,error)
    if (error) return
    call stdarg%register(&
         'N',&
         'Compression factor',&
         'Required when /SPECTRAL is present.',&
         code_arg_mandatory,&
         error)
    if (error) return
    !
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'COMPRESSED',&
         'Output cube',&
         strg_emp,&
         [flag_compress],&
         comm%oucube,&
         error,&
         flagmode=keep_prod)
    if (error)  return
  end subroutine cubemain_compress_comm_register
  !
  subroutine cubemain_compress_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COMPRESS [cubeid]
    !   /SPATIAL n
    !   /SPECTRAL n
    !   /RANGE first last [unit]
    !   /CENTER xpos ypos type [unit]
    !   /SIZE sx [sy [unit]]
    !----------------------------------------------------------------------
    class(compress_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(compress_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='COMPRESS>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    !
    call comm%spatial%present(line,user%dospatial,error)
    if (error) return
    if (user%dospatial) then
       call cubetools_getarg(line,comm%spatial,1,user%lmfactor,mandatory,error)
       if (error) return
    else
       user%lmfactor = strg_star
    endif
    !
    call comm%spectral%present(line,user%dospectral,error)
    if (error) return
    if (user%dospectral) then
       call cubetools_getarg(line,comm%spectral,1,user%cfactor,mandatory,error)
       if (error) return
    else
       user%cfactor = strg_star
    endif
    !
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubemain_compress_comm_parse
  !
  subroutine cubemain_compress_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_comm_t), intent(in)    :: comm
    type(compress_user_t),  intent(inout) :: user
    logical,                   intent(inout) :: error
    !
    type(compress_prog_t) :: prog
    character(len=*), parameter :: rname='COMPRESS>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_compress_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_compress_user_toprog(user,comm,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_user_t), intent(in)    :: user
    type(compress_comm_t),  intent(in)    :: comm
    type(compress_prog_t),  intent(out)   :: prog
    logical,                   intent(inout) :: error
    !
    integer(kind=indx_k), parameter :: lmdefault=2
    integer(kind=indx_k), parameter :: cdefault=1
    character(len=*), parameter :: rname='COMPRESS>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    !
    call cubetools_user2prog_resolve_star(user%lmfactor,lmdefault,prog%lmfactor,error)
    if (error) return
    !
    call cubetools_user2prog_resolve_star(user%cfactor,cdefault,prog%cfactor,error)
    if (error) return
    !
    select case (prog%incube%order())  ! Cube native order
    case (code_cube_imaset)
      prog%factor1 = prog%lmfactor
      prog%factor2 = prog%lmfactor
      prog%factor3 = prog%cfactor
    case (code_cube_speset)
      prog%factor1 = prog%cfactor
      prog%factor2 = prog%lmfactor
      prog%factor3 = prog%lmfactor
    case default
      call cubemain_message(seve%e,rname,'Unexpected cube order')
      error = .true.
      return
    end select
    !
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    ! call prog%region%list(error)
    ! if (error) return
  end subroutine cubemain_compress_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_compress_prog_header(prog,comm,error)
    use cubetools_axis_types
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_prog_t), intent(inout) :: prog
    type(compress_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    type(axis_t) :: axis
    character(len=*), parameter :: rname='COMPRESS>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%oucube,  &
      prog%incube,prog%region,prog%oucube,error)
    if (error) return
    !
    ! Then compress the relevant axes
    call cubetools_header_get_axis_head_l(prog%oucube%head,axis,error)
    if (error) return
    call cubemain_compress_axis(axis,prog%lmfactor,error)
    if (error) return
    call cubetools_header_update_axset_l(axis,prog%oucube%head,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_m(prog%oucube%head,axis,error)
    if (error) return
    call cubemain_compress_axis(axis,prog%lmfactor,error)
    if (error) return
    call cubetools_header_update_axset_m(axis,prog%oucube%head,error)
    if (error) return
    !
    call cubetools_header_get_axis_head_c(prog%oucube%head,axis,error)
    if (error) return
    call cubemain_compress_axis(axis,prog%cfactor,error)
    if (error) return
    call cubetools_header_update_axset_c(axis,prog%oucube%head,error)
    if (error) return
  end subroutine cubemain_compress_prog_header
  !
  subroutine cubemain_compress_axis(axis,factor,error)
    use cubetools_axis_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(axis_t),         intent(inout)  :: axis
    integer(kind=indx_k), intent(in)     :: factor
    logical,              intent(inout)  :: error
    !
    integer(kind=4), parameter :: limit=1
    character(len=*), parameter :: rname='COMPRESS>AXIS'
    !
    axis%n = (axis%n-1)/factor+1   ! Take care of non-integer division
    if (axis%n.lt.limit) then
      call cubemain_message(seve%e,rname,  &
        'Output cube would have less than 1 pixel along '//axis%name)
      error = .true.
      return
    endif
    axis%ref = 0.5d0 - (0.5d0-axis%ref)/factor
   !axis%val = unchanged
    axis%inc = factor * axis%inc
  end subroutine cubemain_compress_axis
  !
  subroutine cubemain_compress_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='COMPRESS>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_compress_prog_data
  !
  subroutine cubemain_compress_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t),  intent(inout) :: iter
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='COMPRESS>PROG>LOOP'
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter,error)
      if (error) return
    enddo ! ie
  end subroutine cubemain_compress_prog_loop
  !
  subroutine cubemain_compress_prog_act(prog,itertask,error)
    use cubetools_real_2d_types
    use cubetools_real_3d_types
    use cubeadm_subcube_types
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(compress_prog_t),   intent(in)    :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    type(subcube_t) :: insub,ousub
    type(real_3d_t) :: insubsub
    type(real_2d_t) :: ouima
    integer(kind=indx_k) :: o3,first,last
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='COMPRESS>PROG>ACT'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one task to another.
    call insub%associate('insub',prog%incube,itertask,error)
    if (error) return
    call insub%get(error)
    if (error) return
    !
    call ousub%allocate('ousub',prog%oucube,itertask,error)
    if (error) return
    !
    ! Sanity check: check that the iterator and insub%get have done things
    ! as expected.
    ! 1) insub must provide a multiple of factor3 dimension in any
    ! case (it is the responsibility of the iterator to respect this).
    ! The last subcube might overlap beyond the right cube boundary: this
    ! is treated after (insub%nvalid3)
    if (mod(insub%nz,prog%factor3).ne.0) then
      write(mess,'(2(a,i0))')  &
        'Internal error: subcube 3rd dimension is size ',insub%nz,  &
        ' while expected a multiple of ',prog%factor3
      call cubemain_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    ! 2) insub must not overlap the left boundary of the cube. This should
    ! not happen regarding the way we define in this command the output 3rd
    ! axis from the input 3rd axis (left boundaries are aligned)
    if (insub%v3shift.ne.0) then
      write(mess,'(a,i0,a)')  &
        'Internal error: subcube overlaps left cube boundary (v3shift=',  &
        insub%v3shift,')'
      call cubemain_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    call insubsub%prepare_association('insubsub',insub%nx,insub%ny,prog%factor3,error)
    if (error) return
    call ouima%prepare_association('ouima',ousub%nx,ousub%ny,error)
    if (error)  return
    ouima%pointeris = code_pointer_associated
    !
    do o3=1,ousub%nz                              ! For each output plane:
      first = (o3-1)*prog%factor3+1               ! - first plane processed in insub
      last  = min(o3*prog%factor3,insub%nvalid3)  ! - last plane processed in insub
      insubsub%val => insub%val(:,:,first:last)
      insubsub%nz  = last-first+1
      ouima%val    => ousub%val(:,:,o3)
      call cubemain_compress_prog_image(prog,insubsub,ouima,error)
      if (error)  return
    enddo
    !
    call ousub%put(error)
    if (error)  return
  end subroutine cubemain_compress_prog_act

  subroutine cubemain_compress_prog_image(prog,insub,ouima,error)
    use cubetools_real_2d_types
    use cubetools_real_3d_types
    !-------------------------------------------------------------------
    ! Compute one output image from the input subcube.
    ! Note that this engine is generic for any data order (LMV/VLM)
    ! while the suffixes x/y/z might be misleading.
    !-------------------------------------------------------------------
    type(compress_prog_t), intent(in)    :: prog
    type(real_3d_t),       intent(inout) :: insub
    type(real_2d_t),       intent(inout) :: ouima
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: i1,i2,i3
    integer(kind=indx_k) :: o1,o2
    integer(kind=indx_k) :: l1,l2,l3
    integer(kind=indx_k) :: n1,n2
    integer(kind=data_k) :: w
    real(kind=8) :: s
    !
    n1 = prog%factor1
    n2 = prog%factor2
    !
    l1 = insub%nx/n1  ! Integer division (as opposed to ouima%nx value)
    l2 = insub%ny/n2
    l3 = insub%nz
    !
    ! Main loop for "full" pixels. For efficiency purpose, do not
    ! compute the non-integer boundary pixels, if any. This avoids "if"
    ! tests or min(n*o1,inima%nx) for ALL pixels while we know these
    ! apply only on boundary and this command is meant to be executed
    ! on huge images.
    w = n1*n2*l3  ! Always in this loop
    do o2=1,l2
      do o1=1,l1
        s = 0.d0
       !w = 0
        do i3=1,l3  ! Non-contiguous read of input subcube (this is
                    ! inherent to the problem)
          ! Do not call compute_pixel also for efficiency, loop is
          ! simpler anyway.
          do i2=n2*o2-n2+1,n2*o2
            do i1=n1*o1-n1+1,n1*o1
              s = s + insub%val(i1,i2,i3)
             !w = w+1
            enddo  ! i1
          enddo  ! i2
          ouima%val(o1,o2) = s/w
        enddo ! i3
      enddo ! o1
    enddo ! o2
    !
    ! Last column with upper i1 truncated to NX
    if (l1.lt.ouima%nx) then
      o1 = ouima%nx
      do o2=1,l2
        ouima%val(o1,o2) = compute_pixel(o1,o2,insub%nx,n2*o2)
      enddo
    endif
    !
    ! Last row with upper i2 truncated to NY
    if (l2.lt.ouima%ny) then
      o2 = ouima%ny
      do o1=1,l1
        ouima%val(o1,o2) = compute_pixel(o1,o2,n1*o1,insub%ny)
      enddo
    endif
    !
    ! Last pixel with upper i1 and i2 truncated to NX and NY
    if (l1.lt.ouima%nx .and. l2.lt.ouima%ny) then
      o1 = ouima%nx
      o2 = ouima%ny
      ouima%val(o1,o2) = compute_pixel(o1,o2,insub%nx,insub%ny)
    endif
    !
  contains
    !
    function compute_pixel(o1,o2,mx,my)
      real(kind=4) :: compute_pixel
      integer(kind=pixe_k), intent(in) :: o1,o2
      integer(kind=pixe_k), intent(in) :: mx,my
      s = 0.d0
      w = 0
      do i3=1,l3
        do i2=n2*o2-n2+1,my
          do i1=n1*o1-n1+1,mx
            w = w+1
            s = s + insub%val(i1,i2,i3)
          enddo  ! i1
        enddo  ! i2
      enddo
      compute_pixel = s/w
    end function compute_pixel
  end subroutine cubemain_compress_prog_image
end module cubemain_compress
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine astro_draw(name,icat,argum,clip,error)
  use gbl_message
  use gkernel_types
  use gkernel_interfaces, no_interface=>gr8_marker
  use astro_interfaces, except_this=>astro_draw
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  integer(kind=4),  intent(in)    :: icat
  character(len=*), intent(in)    :: argum(:) ! /Draw arguments
  logical,          intent(in) :: clip          ! clipping of source names
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DRAW'
  real(kind=8) :: x,y
  character(len=commandline_length) :: command
  logical :: in,clip_state
  integer(kind=4) :: ns,is,i
  real(kind=4) :: siz,flux,test,zmin,xp,yp,xlen,ylen,margin
  parameter (zmin=5)
  type(projection_t) :: gregproj
  !
  ! Get new plot coords
  if (projection) then
    call greg_projec_get(gregproj)  ! Get current Greg projection
    if (frame.eq.'EQUATORIAL') then
      call abs_to_rel(gregproj,ra,dec,x,y,1)
    else
      call abs_to_rel(gregproj,azimuth,elevation,x,y,1)
    endif
  else
    if (frame.eq.'EQUATORIAL') then
      x = ra
      y = dec
    else
      x = azimuth
      y = elevation
    endif
  endif
  if (nsplot.lt.msplot .and. icat.gt.0) then
    nsplot = nsplot+1
    splot(nsplot) = name
    ccplot(nsplot) = catalog_name(icat)
    xsplot(nsplot) = x
    ysplot(nsplot) = y
    zsplot(nsplot) = z_axis
  endif
  !
  call gr_exec1('SET COORD USER')
  clip_state = gr_clip(.true.)
  in = isvisible(x,y)
  if (frame.eq.'HORIZONTAL') in = in .and. (elevation.ge.0d0)
  !
  do i=1,size(argum)
    if (argum(i).eq.'')  cycle
    !
    ! LINE
    if (argum(i).eq.'L') then
      call gr_segm('LINE',error)
      if (frame.eq.'EQUATORIAL') then
        call great_circle(ra_old,dec_old,ra,dec,error)
      elseif (frame.eq.'HORIZONTAL') then
        call great_circle(azimuth_old,elevation_old, azimuth,elevation,error)
      endif
      call gr_segm_close(error)
    endif
    !
    if (.not.in)  cycle  ! Next argument
    !
    ! MARKER or FULL
    if (argum(i).eq.'M' .or. argum(i).eq.'F') then
      call gr_get_marker(ns,is,siz)
      if (z_axis_type.eq.'MA') then
        flux = max((1.-(z_axis/zmin))*siz,0.0)
      elseif (z_axis_type.eq.'FL') then
        if (z_axis.ne.0) then
          ! test = -2.5*alog10(z_axis/100.)
          test = -5*alog10(z_axis) ! 1 Jy -> mag 0
          flux = max((1.-(test/zmin))*siz,0.0)
        else
          flux = siz
        endif
      endif
      call gr_set_marker(ns,is,flux)
      call gr_segm('MARKER',error)
      call gr8_marker(1,x,y,0d0,-1d0)
      call gr_segm_close(error)
      call gr_set_marker(ns,is,siz)
    endif
    !
    ! FULL
    if (argum(i).eq.'F') then  ! FULL = MARKER + SYMBOL above marker
      ! --- Ugly trick to Y-shift the text by one marker height
      call relocate(x,y)          ! Locate pen at marker position
      call gr_where(x,y,xp,yp)    ! Get pen position in user and phys coordinates
      call grelocate(xp,yp+flux)  ! Relocate pen at Y-shifted phys coordinates
      call gr_where(x,y,xp,yp)    ! Get pen position in user and phys coordinates
      ! --- End of trick
      write(command,'(A,2(1PG14.6,1X),3A)')  &
        'DRAW TEXT ',x,y,'"',trim(name),'" 8 /USER'
      if (clip) then
        write(command,'(A,1X,A)') trim(command),'/CLIP SOFT'
      endif
      call gr_exec1(command)
      call relocate(x,y)  ! Relocate pen at exact source position
    endif
    !
    ! SYMBOL
    if (argum(i).eq.'S') then
      write(command,'(A,2(1PG14.6,1X),3A)')  &
        'DRAW TEXT ',x,y,'"',trim(name),'" 5 /USER'
      if (clip) then
        write(command,'(A,1X,A)') trim(command),'/CLIP SOFT'
      endif
      call gr_exec1(command)
      call relocate(x,y)  ! Relocate pen at exact source position
    endif
    !
    ! BOX
    if (argum(i).eq.'B') then
      ! Get string height, taking into account G\SET CHAR and G\SET EXPAND.
      ! "\\g." is a square symbol, i.e. get its width and reuse it as height.
      call gstrlen(4,'\\g.',ylen)
      margin = ylen/10.
      ylen = ylen/2.+margin
      call gstrlen(len_trim(name),name,xlen)
      xlen = xlen/2.+margin
      call relocate(x,y)               ! Relocate pen at exact source position
      call gr_where(x,y,xp,yp)         ! Get pen position in user and physical
      call gr_segm('BOX',error)
      call grelocate(xp-xlen,yp-ylen)  ! Relocate at 1st box corner (physical coordinates)
      call gdraw    (xp+xlen,yp-ylen)  ! Draw to 2nd box corner (physical coordinates)
      call gdraw    (xp+xlen,yp+ylen)  !
      call gdraw    (xp-xlen,yp+ylen)  !
      call gdraw    (xp-xlen,yp-ylen)  ! Close the box
      call gr_segm_close(error)
      call relocate(x,y)               ! Relocate pen at exact source position
    endif
    !
  enddo
  elevation_old=elevation
  azimuth_old=azimuth
  ra_old=ra
  dec_old=dec
  !
contains
  function isvisible(x,y)
    logical :: isvisible
    real(kind=8), intent(in) :: x,y
    ! Local
    real(kind=8) :: xmin,xmax,ymin,ymax,x1
    !
    call sic_get_dble('USER_XMIN',xmin,error)
    call sic_get_dble('USER_XMAX',xmax,error)
    call sic_get_dble('USER_YMIN',ymin,error)
    call sic_get_dble('USER_YMAX',ymax,error)
    if (xmax.lt.xmin) then
      x1 = xmin
      xmin = xmax
      xmax = x1
    endif
    if (ymax.lt.ymin) then
      x1 = ymin
      ymin = ymax
      ymax = x1
    endif
    isvisible = x.le.xmax .and. x.ge.xmin  .and. y.le.ymax .and. y.ge.ymin
  end function isvisible
  !
end subroutine astro_draw
!
subroutine astro_draw_parse(caller,line,optdraw,drawargs,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_draw_parse
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for
  !   SOURCE|PLANET /DRAW Arg1 ... ArgN
  !  Parse the arguments of the option /DRAW
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: optdraw
  character(len=*), intent(out)   :: drawargs(:)
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: iarg,narg,ikey,nc
  character(len=12) :: arg,key
  character(len=message_length) :: mess
  integer(kind=4), parameter :: mdrawkinds=5
  character(len=6), parameter :: drawkinds(mdrawkinds) =  &
    (/ 'LINE  ', 'MARKER', 'SYMBOL', 'FULL  ', 'BOX   ' /)
  !
  ! Loop on arguments of /DRAW
  drawargs(:) = ''
  narg = sic_narg(optdraw)
  if (narg.gt.size(drawargs)) then
    narg = size(drawargs)
    write(mess,'(A,I0,A)')  '/DRAW argument list truncated to ',narg,' keywords'
    call astro_message(seve%w,caller,mess)
  endif
  !
  if (narg.le.0) then
    drawargs(1) = 'S'  ! Default SYMBOL
    return
  endif
  !
  do iarg=1,narg
    call sic_ke(line,1,iarg,arg,nc,.true.,error)
    if (error) return
    call sic_ambigs(caller,arg,key,ikey,drawkinds,mdrawkinds,error)
    if (error)  return
    drawargs(iarg) = key  ! Truncated to 1 character
  enddo
  !
end subroutine astro_draw_parse

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_calib_types
  use imbfits_types
  use mrtcal_chunk_types
  use mrtcal_chunkset_types
  use mrtcal_chunkset_nd_types
  use mrtcal_chopperset_types
  use mrtindex_types
  use mrtindex_parse_types
  use mrtcal_obs_list
  use mrtcal_science_types
  use mrtcal_calibration_types
end module mrtcal_calib_types
!
module mrtcal_sicidx
  !---------------------------------------------------------------------
  ! Support module for
  !  Sic structure  IDX%USER%
  !  Command        VARIABLE USER /INDEX
  !---------------------------------------------------------------------
  !
  type mrtcal_classuser_arr_t
    integer(kind=4), allocatable :: obstype(:)  ! Observation type
    real(kind=4),    allocatable :: noise(:)    ! Theoretical noise (rms) from calibration
    real(kind=4),    allocatable :: backeff(:)  ! Backend efficiency
    real(kind=4),    allocatable :: airmass(:)  ! Airmass
    real(kind=4),    allocatable :: expatau(:)  ! exp( airmass * tauzen )
  end type mrtcal_classuser_arr_t
  !
  ! Support variable for command "SET VARIABLE Section /INDEX"
  type(mrtcal_classuser_arr_t), save :: idxuser
  !
end module mrtcal_sicidx
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_drop(line,error)
  use gkernel_interfaces
  use clic_index
  !---------------------------------------------------------------------
  ! CLIC 	Support routine for command
  !	DROP Number [Version]
  !	Deletes an observation from current index
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  logical :: lst,found
  integer :: versio
  character(len=20) :: nombre
  integer :: tver
  integer(kind=entry_length) :: i, number
  !------------------------------------------------------------------------
  ! Code:
  call check_index(error)
  if (error) return
  if (sic_present(0,1)) then
    call sic_i8(line,0,1,number,.true.,error)
    if (error) return
    versio = 0
    call sic_i4(line,0,2,versio,.false.,error)
    if (error) return
    lst = versio .eq. 0
  else
    number=r_num
    versio=abs(r_ver)
    lst = .false.
  endif
  found = .false.
  do 200 i=1,cxnext-1
    if (.not.found) then
      if (lst) then
        found = cx_num(i).eq.number .and. cx_ver(i).ge.0
      else
        tver = abs(cx_ver(i))
        found = cx_num(i).eq.number .and. tver.eq.versio
      endif
      if (found) then
        if (knext .ge. i) knext = knext-1
      endif
    else
      cx_ind(i-1)  = cx_ind(i)
      cx_num(i-1)  = cx_num(i)
      cx_ver(i-1)  = cx_ver(i)
      cx_bloc(i-1) = cx_bloc(i)
      cx_word(i-1) = cx_word(i)
    endif
200 continue
  if (found) then
    cxnext = cxnext - 1
  else
    write(nombre,1001) number,versio
    call message(8,1,'DROP',nombre//' not in current index')
    error = .true.
    return
  endif
  call index_variable
  return
1001 format(i10,';',i6)
end subroutine clic_drop

subroutine fitpnl(x,y,n,nterms,ipar,a,niter,   &
     &    num,yfit,sigma,sigmaa,eps,bavard, good)
  !---------------------------------------------------------------------
  !	Fit non lineaire
  !
  !	N est le nombre de points
  !       NTERMS est le nombre de terms a fitter
  !       A(J),J=1,NTERMS sont les estimations initiales des parametres
  !       X(K,J),J=1,N K=1,NVAR et Y(J),J=1,N sont les valeurs des X et Y
  !       NITER est le nombre maximal d'iterations tolere
  !       NUM est le nombre d'iterations effectuees
  !       YFIT(J),J=1,N  sont les valeurs fittees
  !	SIGMA est le sigma du fit (S(Y(J)-YFIT(J))**2)/N
  !	SIGMAA(J),J=1,NTERMS sont les sigmas sur les parametres
  !	EPS est la tolerance sur SQRT(CHISQ)
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  integer :: n                      ! Number of data points
  real*8 :: x(3,n)                  ! Data points coordinates
  real*8 :: y(n)                    ! Data points values
  integer :: nterms                 ! Number of parameters
  integer :: ipar(mvar)             !
  real*8 :: a(mvar)                 ! Parameters
  integer :: niter                  ! Maximum Number of iterations
  integer :: num                    ! Current Number of iterations
  real*8 :: yfit(n)                 ! Fitted values
  real*8 :: sigma                   ! Rms of residuals
  real*8 :: sigmaa(nterms)          ! Errors on parameters
  real*8 :: eps                     ! Stability of minimum
  logical :: bavard                 ! Write down progress
  logical :: good(n)                !
  ! Global
  real*8 :: funpnl,fchisq
  external :: funpnl,fchisq
  ! Local
  real*8 :: alpha(mvar,mvar),array(mvar,mvar),beta(mvar)
  real*8 :: deriv(mvar),b(mvar),aa(mvar)
  integer :: ntermx,i,j,k,jj,kk
  real*8 :: flamda,rts,chisq1,chisqr
  !
  ntermx=mvar
  flamda=0.001
  rts=57.29577951*3600.
  !
  do num=1,niter
    do j=1,nterms
      beta(j)=0.
      do k=1,j
        alpha(j,k)=0.
      enddo
    enddo
    do i=1,n
      if (good(i)) then
        call dpoinl(x(1,i),a,deriv)
        do  j=1,nterms
          jj=ipar(j)
          beta(j)=beta(j)+(y(i)-funpnl(x(1,i),a))*deriv(jj)
          do k=1,j
            kk=ipar(k)
            alpha(j,k)=alpha(j,k)+deriv(jj)*deriv(kk)
          enddo
        enddo
      endif
    enddo
    do j=1,nterms
      do k=1,j
        alpha(k,j)=alpha(j,k)
      enddo
    enddo
    do i=1,n
      if (good(i)) yfit(i)=funpnl(x(1,i),a)
    enddo
    chisq1=fchisq(y,n,nterms,yfit,good)
    !
    100      continue
    do j=1,nterms
      do k=1,nterms
        array(j,k)=alpha(j,k)/dsqrt(alpha(j,j)*alpha(k,k))
      enddo
      array(j,j)=1.+flamda
    enddo
    call amtinv(array,nterms)
    do j=1,nterms
      jj=ipar(j)
      b(j)=a(jj)
      do  k=1,nterms
        b(j)=b(j)+beta(k)*array(j,k)/dsqrt(alpha(j,j)*alpha(k,k))
      enddo
    enddo
    do j=1,ntermx
      aa(j)=a(j)
    enddo
    do j=1,nterms
      jj=ipar(j)
      aa(jj)=b(j)
    enddo
    do i=1,n
      if (good(i)) yfit(i)=funpnl(x(1,i),aa)
    enddo
    chisqr=fchisq(y,n,nterms,yfit,good)
    if (chisq1.lt.chisqr) then
      flamda = 10*flamda
      goto 100
    endif
    !
    ! Converged ...
    flamda=flamda/10.
    sigma=dsqrt(chisqr)
    do j=1,nterms
      jj=ipar(j)
      a(jj)=b(j)
      sigmaa(j)=dsqrt(array(j,j)/alpha(j,j))*sigma
    enddo
    if (bavard) then
      write(6,1001) num,sigma*rts
      do k=1,nterms
        jj=ipar(k)
        write(6,1000) num,jj,a(jj)*rts,sigmaa(k)*rts
      enddo
    endif
    if ((chisq1-chisqr).lt.eps*chisq1) return
  enddo
  1000  format(' ite = ',i3,' a(',i2,') =',f12.2,' err = ',f12.3)
  1001  format(' ite = ',i3,' sigma = ',f12.2)
end

*DECK DTIN
      SUBROUTINE DTIN (N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB)
C***BEGIN PROLOGUE  DTIN
C***PURPOSE  Read in SLAP Triad Format Linear System.
C            Routine to read in a SLAP Triad format matrix and right
C            hand side and solution to the system, if known.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      DOUBLE PRECISION (STIN-S, DTIN-D)
C***KEYWORDS  DIAGNOSTICS, LINEAR SYSTEM, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT, JOB
C     DOUBLE PRECISION A(NELT), SOLN(N), RHS(N)
C
C     CALL DTIN( N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB )
C
C *Arguments:
C N      :OUT      Integer
C         Order of the Matrix.
C NELT   :INOUT    Integer.
C         On input NELT is the maximum number of non-zeros that
C         can be stored in the IA, JA, A arrays.
C         On output NELT is the number of non-zeros stored in A.
C IA     :OUT      Integer IA(NELT).
C JA     :OUT      Integer JA(NELT).
C A      :OUT      Double Precision A(NELT).
C         On output these arrays hold the matrix A in the SLAP
C         Triad format.  See "Description", below.
C ISYM   :OUT      Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C SOLN   :OUT      Double Precision SOLN(N).
C         The solution to the linear system, if present.  This array
C         is accessed if and only if JOB to read it in, see below.
C         If the user requests that SOLN be read in, but it is not in
C         the file, then it is simply zeroed out.
C RHS    :OUT      Double Precision RHS(N).
C         The right hand side vector.  This array is accessed if and
C         only if JOB is set to read it in, see below.
C         If the user requests that RHS be read in, but it is not in
C         the file, then it is simply zeroed out.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to write the matrix
C         to.  This unit must be connected in a system dependent fashion
C         to a file or the console or you will get a nasty message
C         from the Fortran I/O libraries.
C JOB    :INOUT    Integer.
C         Flag indicating what I/O operations to perform.
C         On input JOB indicates what Input operations to try to
C         perform.
C         JOB = 0 => Read only the matrix.
C         JOB = 1 => Read matrix and RHS (if present).
C         JOB = 2 => Read matrix and SOLN (if present).
C         JOB = 3 => Read matrix, RHS and SOLN (if present).
C         On output JOB indicates what operations were actually
C         performed.
C         JOB = 0 => Read in only the matrix.
C         JOB = 1 => Read in the matrix and RHS.
C         JOB = 2 => Read in the matrix and SOLN.
C         JOB = 3 => Read in the matrix, RHS and SOLN.
C
C *Description:
C       The format for the  input is as follows.  On  the first line
C       are counters and flags: N, NELT, ISYM, IRHS, ISOLN.  N, NELT
C       and ISYM are described above.  IRHS is  a flag indicating if
C       the RHS was  written out (1 is  yes, 0 is  no).  ISOLN  is a
C       flag indicating if the SOLN was written out  (1 is yes, 0 is
C       no).  The format for the fist line is: 5i10.  Then comes the
C       NELT Triad's IA(I), JA(I) and A(I), I = 1, NELT.  The format
C       for  these lines is   :  1X,I5,1X,I5,1X,D16.7.   Then  comes
C       RHS(I), I = 1, N, if IRHS = 1.  Then  comes SOLN(I), I  = 1,
C       N, if ISOLN = 1.  The format for these lines is: 1X,D16.7.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero  matrix  element is  placed   in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   921007  Changed E's to D's in formats.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  DTIN
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, JOB, N, NELT
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), RHS(N), SOLN(N)
      INTEGER IA(NELT), JA(NELT)
C     .. Local Scalars ..
      INTEGER I, IRHS, ISOLN, JOBRET, NELTMX
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C***FIRST EXECUTABLE STATEMENT  DTIN
C
C         Read in the information heading.
C
      NELTMX = NELT
      READ(IUNIT,1000) N, NELT, ISYM, IRHS, ISOLN
      NELT = MIN( NELT, NELTMX )
C
C         Read in the matrix non-zeros in Triad format.
      DO 10 I = 1, NELT
         READ(IUNIT,1010) IA(I), JA(I), A(I)
 10   CONTINUE
C
C         If requested, read in the rhs.
      JOBRET = 0
      IF( JOB.EQ.1 .OR. JOB.EQ.3 ) THEN
C
C         Check to see if rhs is in the file.
         IF( IRHS.EQ.1 ) THEN
            JOBRET = 1
            READ(IUNIT,1020) (RHS(I),I=1,N)
         ELSE
            DO 20 I = 1, N
               RHS(I) = 0
 20         CONTINUE
         ENDIF
      ENDIF
C
C         If requested, read in the solution.
      IF( JOB.GT.1 ) THEN
C
C         Check to see if solution is in the file.
         IF( ISOLN.EQ.1 ) THEN
            JOBRET = JOBRET + 2
            READ(IUNIT,1020) (SOLN(I),I=1,N)
         ELSE
            DO 30 I = 1, N
               SOLN(I) = 0
 30         CONTINUE
         ENDIF
      ENDIF
C
      JOB = JOBRET
      RETURN
 1000 FORMAT(5I10)
 1010 FORMAT(1X,I5,1X,I5,1X,D16.7)
 1020 FORMAT(1X,D16.7)
C------------- LAST LINE OF DTIN FOLLOWS ----------------------------
      END
*DECK DTOUT
      SUBROUTINE DTOUT (N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB)
C***BEGIN PROLOGUE  DTOUT
C***PURPOSE  Write out SLAP Triad Format Linear System.
C            Routine to write out a SLAP Triad format matrix and right
C            hand side and solution to the system, if known.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      DOUBLE PRECISION (STOUT-S, DTOUT-D)
C***KEYWORDS  DIAGNOSTICS, LINEAR SYSTEM, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT, JOB
C     DOUBLE PRECISION A(NELT), SOLN(N), RHS(N)
C
C     CALL DTOUT( N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB )
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C NELT   :IN       Integer.
C         Number of non-zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Double Precision A(NELT).
C         These arrays should hold the matrix A in the SLAP
C         Triad format.  See "Description", below.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C SOLN   :IN       Double Precision SOLN(N).
C         The solution to the linear system, if known.  This array
C         is accessed if and only if JOB is set to print it out,
C         see below.
C RHS    :IN       Double Precision RHS(N).
C         The right hand side vector.  This array is accessed if and
C         only if JOB is set to print it out, see below.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to write the matrix
C         to.  This unit must be connected in a system dependent fashion
C         to a file or the console or you will get a nasty message
C         from the Fortran I/O libraries.
C JOB    :IN       Integer.
C         Flag indicating what I/O operations to perform.
C         JOB = 0 => Print only the matrix.
C             = 1 => Print matrix and RHS.
C             = 2 => Print matrix and SOLN.
C             = 3 => Print matrix, RHS and SOLN.
C
C *Description:
C       The format for the output is as follows.  On  the first line
C       are counters and flags: N, NELT, ISYM, IRHS, ISOLN.  N, NELT
C       and ISYM are described above.  IRHS is  a flag indicating if
C       the RHS was  written out (1 is  yes, 0 is  no).  ISOLN  is a
C       flag indicating if the SOLN was written out  (1 is yes, 0 is
C       no).  The format for the fist line is: 5i10.  Then comes the
C       NELT Triad's IA(I), JA(I) and A(I), I = 1, NELT.  The format
C       for  these lines is   :  1X,I5,1X,I5,1X,D16.7.   Then  comes
C       RHS(I), I = 1, N, if IRHS = 1.  Then  comes SOLN(I), I  = 1,
C       N, if ISOLN = 1.  The format for these lines is: 1X,D16.7.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero  matrix  element is  placed   in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   921007  Changed E's to D's in formats.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  DTOUT
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, JOB, N, NELT
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), RHS(N), SOLN(N)
      INTEGER IA(NELT), JA(NELT)
C     .. Local Scalars ..
      INTEGER I, IRHS, ISOLN
C***FIRST EXECUTABLE STATEMENT  DTOUT
C
C         If RHS and SOLN are to be printed also.
C         Write out the information heading.
C
      IRHS = 0
      ISOLN = 0
      IF( JOB.EQ.1 .OR. JOB.EQ.3 ) IRHS = 1
      IF( JOB.GT.1 ) ISOLN = 1
      WRITE(IUNIT,1000) N, NELT, ISYM, IRHS, ISOLN
C
C         Write out the matrix non-zeros in Triad format.
      DO 10 I = 1, NELT
         WRITE(IUNIT,1010) IA(I), JA(I), A(I)
 10   CONTINUE
C
C         If requested, write out the rhs.
      IF( IRHS.EQ.1 ) THEN
         WRITE(IUNIT,1020) (RHS(I),I=1,N)
      ENDIF
C
C         If requested, write out the solution.
      IF( ISOLN.EQ.1 ) THEN
         WRITE(IUNIT,1020) (SOLN(I),I=1,N)
      ENDIF
      RETURN
 1000 FORMAT(5I10)
 1010 FORMAT(1X,I5,1X,I5,1X,D16.7)
 1020 FORMAT(1X,D16.7)
C------------- LAST LINE OF DTOUT FOLLOWS ----------------------------
      END
*DECK DTRCO
      SUBROUTINE DTRCO (T, LDT, N, RCOND, Z, JOB)
C***BEGIN PROLOGUE  DTRCO
C***PURPOSE  Estimate the condition number of a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3
C***TYPE      DOUBLE PRECISION (STRCO-S, DTRCO-D, CTRCO-C)
C***KEYWORDS  CONDITION NUMBER, LINEAR ALGEBRA, LINPACK,
C             TRIANGULAR MATRIX
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     DTRCO estimates the condition of a double precision triangular
C     matrix.
C
C     On Entry
C
C        T       DOUBLE PRECISION(LDT,N)
C                T contains the triangular matrix.  The zero
C                elements of the matrix are not referenced, and
C                the corresponding elements of the array can be
C                used to store other information.
C
C        LDT     INTEGER
C                LDT is the leading dimension of the array T.
C
C        N       INTEGER
C                N is the order of the system.
C
C        JOB     INTEGER
C                = 0         T  is lower triangular.
C                = nonzero   T  is upper triangular.
C
C     On Return
C
C        RCOND   DOUBLE PRECISION
C                an estimate of the reciprocal condition of  T .
C                For the system  T*X = B , relative perturbations
C                in  T  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                           1.0 + RCOND .EQ. 1.0
C                is true, then  T  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       DOUBLE PRECISION(N)
C                a work vector whose contents are usually unimportant.
C                If  T  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DASUM, DAXPY, DSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DTRCO
      INTEGER LDT,N,JOB
      DOUBLE PRECISION T(LDT,*),Z(*)
      DOUBLE PRECISION RCOND
C
      DOUBLE PRECISION W,WK,WKM,EK
      DOUBLE PRECISION TNORM,YNORM,S,SM,DASUM
      INTEGER I1,J,J1,J2,K,KK,L
      LOGICAL LOWER
C***FIRST EXECUTABLE STATEMENT  DTRCO
      LOWER = JOB .EQ. 0
C
C     COMPUTE 1-NORM OF T
C
      TNORM = 0.0D0
      DO 10 J = 1, N
         L = J
         IF (LOWER) L = N + 1 - J
         I1 = 1
         IF (LOWER) I1 = J
         TNORM = MAX(TNORM,DASUM(L,T(I1,J),1))
   10 CONTINUE
C
C     RCOND = 1/(NORM(T)*(ESTIMATE OF NORM(INVERSE(T)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  T*Z = Y  AND  TRANS(T)*Y = E .
C     TRANS(T)  IS THE TRANSPOSE OF T .
C     THE COMPONENTS OF  E  ARE CHOSEN TO CAUSE MAXIMUM LOCAL
C     GROWTH IN THE ELEMENTS OF Y .
C     THE VECTORS ARE FREQUENTLY RESCALED TO AVOID OVERFLOW.
C
C     SOLVE TRANS(T)*Y = E
C
      EK = 1.0D0
      DO 20 J = 1, N
         Z(J) = 0.0D0
   20 CONTINUE
      DO 100 KK = 1, N
         K = KK
         IF (LOWER) K = N + 1 - KK
         IF (Z(K) .NE. 0.0D0) EK = SIGN(EK,-Z(K))
         IF (ABS(EK-Z(K)) .LE. ABS(T(K,K))) GO TO 30
            S = ABS(T(K,K))/ABS(EK-Z(K))
            CALL DSCAL(N,S,Z,1)
            EK = S*EK
   30    CONTINUE
         WK = EK - Z(K)
         WKM = -EK - Z(K)
         S = ABS(WK)
         SM = ABS(WKM)
         IF (T(K,K) .EQ. 0.0D0) GO TO 40
            WK = WK/T(K,K)
            WKM = WKM/T(K,K)
         GO TO 50
   40    CONTINUE
            WK = 1.0D0
            WKM = 1.0D0
   50    CONTINUE
         IF (KK .EQ. N) GO TO 90
            J1 = K + 1
            IF (LOWER) J1 = 1
            J2 = N
            IF (LOWER) J2 = K - 1
            DO 60 J = J1, J2
               SM = SM + ABS(Z(J)+WKM*T(K,J))
               Z(J) = Z(J) + WK*T(K,J)
               S = S + ABS(Z(J))
   60       CONTINUE
            IF (S .GE. SM) GO TO 80
               W = WKM - WK
               WK = WKM
               DO 70 J = J1, J2
                  Z(J) = Z(J) + W*T(K,J)
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
         Z(K) = WK
  100 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
C
      YNORM = 1.0D0
C
C     SOLVE T*Z = Y
C
      DO 130 KK = 1, N
         K = N + 1 - KK
         IF (LOWER) K = KK
         IF (ABS(Z(K)) .LE. ABS(T(K,K))) GO TO 110
            S = ABS(T(K,K))/ABS(Z(K))
            CALL DSCAL(N,S,Z,1)
            YNORM = S*YNORM
  110    CONTINUE
         IF (T(K,K) .NE. 0.0D0) Z(K) = Z(K)/T(K,K)
         IF (T(K,K) .EQ. 0.0D0) Z(K) = 1.0D0
         I1 = 1
         IF (LOWER) I1 = K + 1
         IF (KK .GE. N) GO TO 120
            W = -Z(K)
            CALL DAXPY(N-KK,W,T(I1,K),1,Z(I1),1)
  120    CONTINUE
  130 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (TNORM .NE. 0.0D0) RCOND = YNORM/TNORM
      IF (TNORM .EQ. 0.0D0) RCOND = 0.0D0
      RETURN
      END
*DECK DTRDI
      SUBROUTINE DTRDI (T, LDT, N, DET, JOB, INFO)
C***BEGIN PROLOGUE  DTRDI
C***PURPOSE  Compute the determinant and inverse of a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3, D3A3
C***TYPE      DOUBLE PRECISION (STRDI-S, DTRDI-D, CTRDI-C)
C***KEYWORDS  DETERMINANT, INVERSE, LINEAR ALGEBRA, LINPACK,
C             TRIANGULAR MATRIX
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     DTRDI computes the determinant and inverse of a double precision
C     triangular matrix.
C
C     On Entry
C
C        T       DOUBLE PRECISION(LDT,N)
C                T contains the triangular matrix.  The zero
C                elements of the matrix are not referenced, and
C                the corresponding elements of the array can be
C                used to store other information.
C
C        LDT     INTEGER
C                LDT is the leading dimension of the array T.
C
C        N       INTEGER
C                N is the order of the system.
C
C        JOB     INTEGER
C                = 010       no det, inverse of lower triangular.
C                = 011       no det, inverse of upper triangular.
C                = 100       det, no inverse.
C                = 110       det, inverse of lower triangular.
C                = 111       det, inverse of upper triangular.
C
C     On Return
C
C        T       inverse of original matrix if requested.
C                Otherwise unchanged.
C
C        DET     DOUBLE PRECISION(2)
C                determinant of original matrix if requested.
C                Otherwise not referenced.
C                DETERMINANT = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) .EQ. 0.0 .
C
C        INFO    INTEGER
C                INFO contains zero if the system is nonsingular
C                and the inverse is requested.
C                Otherwise INFO contains the index of
C                a zero diagonal element of T.
C
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DAXPY, DSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DTRDI
      INTEGER LDT,N,JOB,INFO
      DOUBLE PRECISION T(LDT,*),DET(2)
C
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION TEN
      INTEGER I,J,K,KB,KM1,KP1
C***FIRST EXECUTABLE STATEMENT  DTRDI
C
C        COMPUTE DETERMINANT
C
         IF (JOB/100 .EQ. 0) GO TO 70
            DET(1) = 1.0D0
            DET(2) = 0.0D0
            TEN = 10.0D0
            DO 50 I = 1, N
               DET(1) = T(I,I)*DET(1)
               IF (DET(1) .EQ. 0.0D0) GO TO 60
   10          IF (ABS(DET(1)) .GE. 1.0D0) GO TO 20
                  DET(1) = TEN*DET(1)
                  DET(2) = DET(2) - 1.0D0
               GO TO 10
   20          CONTINUE
   30          IF (ABS(DET(1)) .LT. TEN) GO TO 40
                  DET(1) = DET(1)/TEN
                  DET(2) = DET(2) + 1.0D0
               GO TO 30
   40          CONTINUE
   50       CONTINUE
   60       CONTINUE
   70    CONTINUE
C
C        COMPUTE INVERSE OF UPPER TRIANGULAR
C
         IF (MOD(JOB/10,10) .EQ. 0) GO TO 170
            IF (MOD(JOB,10) .EQ. 0) GO TO 120
                  DO 100 K = 1, N
                     INFO = K
                     IF (T(K,K) .EQ. 0.0D0) GO TO 110
                     T(K,K) = 1.0D0/T(K,K)
                     TEMP = -T(K,K)
                     CALL DSCAL(K-1,TEMP,T(1,K),1)
                     KP1 = K + 1
                     IF (N .LT. KP1) GO TO 90
                     DO 80 J = KP1, N
                        TEMP = T(K,J)
                        T(K,J) = 0.0D0
                        CALL DAXPY(K,TEMP,T(1,K),1,T(1,J),1)
   80                CONTINUE
   90                CONTINUE
  100             CONTINUE
                  INFO = 0
  110          CONTINUE
            GO TO 160
  120       CONTINUE
C
C              COMPUTE INVERSE OF LOWER TRIANGULAR
C
               DO 150 KB = 1, N
                  K = N + 1 - KB
                  INFO = K
                  IF (T(K,K) .EQ. 0.0D0) GO TO 180
                  T(K,K) = 1.0D0/T(K,K)
                  TEMP = -T(K,K)
                  IF (K .NE. N) CALL DSCAL(N-K,TEMP,T(K+1,K),1)
                  KM1 = K - 1
                  IF (KM1 .LT. 1) GO TO 140
                  DO 130 J = 1, KM1
                     TEMP = T(K,J)
                     T(K,J) = 0.0D0
                     CALL DAXPY(N-K+1,TEMP,T(K,K),1,T(K,J),1)
  130             CONTINUE
  140             CONTINUE
  150          CONTINUE
               INFO = 0
  160       CONTINUE
  170    CONTINUE
  180 CONTINUE
      RETURN
      END
*DECK DTRSL
      SUBROUTINE DTRSL (T, LDT, N, B, JOB, INFO)
C***BEGIN PROLOGUE  DTRSL
C***PURPOSE  Solve a system of the form  T*X=B or TRANS(T)*X=B, where
C            T is a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3
C***TYPE      DOUBLE PRECISION (STRSL-S, DTRSL-D, CTRSL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, TRIANGULAR LINEAR SYSTEM,
C             TRIANGULAR MATRIX
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     DTRSL solves systems of the form
C
C                   T * X = B
C     or
C                   TRANS(T) * X = B
C
C     where T is a triangular matrix of order N.  Here TRANS(T)
C     denotes the transpose of the matrix T.
C
C     On Entry
C
C         T         DOUBLE PRECISION(LDT,N)
C                   T contains the matrix of the system.  The zero
C                   elements of the matrix are not referenced, and
C                   the corresponding elements of the array can be
C                   used to store other information.
C
C         LDT       INTEGER
C                   LDT is the leading dimension of the array T.
C
C         N         INTEGER
C                   N is the order of the system.
C
C         B         DOUBLE PRECISION(N).
C                   B contains the right hand side of the system.
C
C         JOB       INTEGER
C                   JOB specifies what kind of system is to be solved.
C                   If JOB is
C
C                        00   solve T*X=B, T lower triangular,
C                        01   solve T*X=B, T upper triangular,
C                        10   solve TRANS(T)*X=B, T lower triangular,
C                        11   solve TRANS(T)*X=B, T upper triangular.
C
C     On Return
C
C         B         B contains the solution, if INFO .EQ. 0.
C                   Otherwise B is unaltered.
C
C         INFO      INTEGER
C                   INFO contains zero if the system is nonsingular.
C                   Otherwise INFO contains the index of
C                   the first zero diagonal element of T.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DAXPY, DDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DTRSL
      INTEGER LDT,N,JOB,INFO
      DOUBLE PRECISION T(LDT,*),B(*)
C
C
      DOUBLE PRECISION DDOT,TEMP
      INTEGER CASE,J,JJ
C***FIRST EXECUTABLE STATEMENT  DTRSL
C
C        CHECK FOR ZERO DIAGONAL ELEMENTS.
C
         DO 10 INFO = 1, N
            IF (T(INFO,INFO) .EQ. 0.0D0) GO TO 150
   10    CONTINUE
         INFO = 0
C
C        DETERMINE THE TASK AND GO TO IT.
C
         CASE = 1
         IF (MOD(JOB,10) .NE. 0) CASE = 2
         IF (MOD(JOB,100)/10 .NE. 0) CASE = CASE + 2
         GO TO (20,50,80,110), CASE
C
C        SOLVE T*X=B FOR T LOWER TRIANGULAR
C
   20    CONTINUE
            B(1) = B(1)/T(1,1)
            IF (N .LT. 2) GO TO 40
            DO 30 J = 2, N
               TEMP = -B(J-1)
               CALL DAXPY(N-J+1,TEMP,T(J,J-1),1,B(J),1)
               B(J) = B(J)/T(J,J)
   30       CONTINUE
   40       CONTINUE
         GO TO 140
C
C        SOLVE T*X=B FOR T UPPER TRIANGULAR.
C
   50    CONTINUE
            B(N) = B(N)/T(N,N)
            IF (N .LT. 2) GO TO 70
            DO 60 JJ = 2, N
               J = N - JJ + 1
               TEMP = -B(J+1)
               CALL DAXPY(J,TEMP,T(1,J+1),1,B(1),1)
               B(J) = B(J)/T(J,J)
   60       CONTINUE
   70       CONTINUE
         GO TO 140
C
C        SOLVE TRANS(T)*X=B FOR T LOWER TRIANGULAR.
C
   80    CONTINUE
            B(N) = B(N)/T(N,N)
            IF (N .LT. 2) GO TO 100
            DO 90 JJ = 2, N
               J = N - JJ + 1
               B(J) = B(J) - DDOT(JJ-1,T(J+1,J),1,B(J+1),1)
               B(J) = B(J)/T(J,J)
   90       CONTINUE
  100       CONTINUE
         GO TO 140
C
C        SOLVE TRANS(T)*X=B FOR T UPPER TRIANGULAR.
C
  110    CONTINUE
            B(1) = B(1)/T(1,1)
            IF (N .LT. 2) GO TO 130
            DO 120 J = 2, N
               B(J) = B(J) - DDOT(J-1,T(1,J),1,B(1),1)
               B(J) = B(J)/T(J,J)
  120       CONTINUE
  130       CONTINUE
  140    CONTINUE
  150 CONTINUE
      RETURN
      END

subroutine write_sdm_SwitchCycle(error)
  !---------------------------------------------------------------------
  ! Write the FreqOffset SDM table.
  !
  !     int sdm_addSwitchCycleRow (int * numStep, float * weightArray, int
  !     * weightArrayDimOne, double * offsetArray, int *
  !     offsetArrayDimOne, int * offsetArrayDimTwo, double *
  !     freqOffsetArray, int * freqOffsetArrayDimOne)
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_SwitchCycle
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (SwitchCycleRow) :: scRow
  type (SwitchCycleKey) :: scKey
  character sdmTable*12
  parameter (sdmTable='SwitchCycle')
  integer :: ier
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! we do not cycle.
  !
  scRow%numStep = 1
  call  allocSwitchCycleRow(scRow, scRow%numStep, error)
  if (error) return
  scRow%weightArray = 1.0
  scRow%dirOffsetArray = 0.0
  scRow%freqOffsetArray = 0.0
  scRow%stepDurationArray = 0.0
  call addSwitchCycleRow(scKey, scRow, error)
  if (error) return
  SwitchCycle_Id = scKey%switchCycleId
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
!
end subroutine write_sdm_SwitchCycle
!---------------------------------------------------------------------
subroutine get_sdm_SwitchCycle(error)
  !---------------------------------------------------------------------
  ! Read the FreqOffset SDM table.
  !
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_SwitchCycle
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (SwitchCycleRow) :: scRow
  type (SwitchCycleKey) :: scKey
  integer, parameter :: mstep = 2
  character sdmTable*12
  parameter (sdmTable='SwitchCycle')
  integer :: ier
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! we do not cycle.
  !
  call  allocSwitchCycleRow(scRow, mStep, error)
  if (error) return
  scKey%switchCycleId = SwitchCycle_Id
  !$$$      print *, 'SwitchCycle_Id ', SwitchCycle_Id
  call getSwitchCycleRow(scKey, scRow, error)
  if (error) return
  !
  if (scRow%numStep .gt. 1) then
    call sdmMessageI(6,3,sdmTable ,'Too many switch steps '   &
      ,scRow%numStep)
    error = .true.
    return
  endif
  call sdmMessage(1,1,sdmTable ,'Read.')
  !
  return
end subroutine get_sdm_SwitchCycle
!---------------------------------------------------------------------
!!! subroutine allocSwitchCycleRow(row, numStep, error)
!!!   !---------------------------------------------------------------------
!!!   !     real, allocatable :: weightArray(:)
!!!   !     real*8, allocatable :: offsetArray(:,:)
!!!   !     real*8, allocatable :: freqOffsetArray(:)
!!!   !---------------------------------------------------------------------
!!!   use sdm_SwitchCycle
!!!   type(SwitchCycleRow) :: row
!!!   integer :: numStep, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*12 = 'SwitchCycle'
!!!   !
!!!   ! weightArray(numStep)
!!!   if (allocated(row%weightArray)) then
!!!     deallocate(row%weightArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%weightArray(numStep), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! offsetArray(2, numStep)
!!!   if (allocated(row%dirOffsetArray)) then
!!!     deallocate(row%dirOffsetArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%dirOffsetArray(2, numStep), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! freqOffsetArray(numStep)
!!!   if (allocated(row%freqOffsetArray)) then
!!!     deallocate(row%freqOffsetArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%freqOffsetArray(numStep), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   ! stepDurationArray(numStep)
!!!   if (allocated(row%stepDurationArray)) then
!!!     deallocate(row%stepDurationArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%stepDurationArray(numStep), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   !
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !---------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_gradthin
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubefield_messaging
  !
  public :: gradthin
  private
  !
  type :: gradthin_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: gradamp ! Gradient Amplitude
     type(cubeid_arg_t), pointer :: gradang ! Gradient Angle
     type(cube_prod_t),  pointer :: thinned
   contains
     procedure, public  :: register => cubefield_gradthin_comm_register
     procedure, private :: parse    => cubefield_gradthin_comm_parse
     procedure, private :: main     => cubefield_gradthin_comm_main
  end type gradthin_comm_t
  type(gradthin_comm_t) :: gradthin  
  !
  type gradthin_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubefield_gradthin_user_toprog
  end type gradthin_user_t
  !
  type gradthin_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer   :: gradamp
     type(cube_t), pointer   :: gradang
     type(cube_t), pointer   :: thinned
   contains
     procedure, private :: header => cubefield_gradthin_prog_header
     procedure, private :: data   => cubefield_gradthin_prog_data
     procedure, private :: loop   => cubefield_gradthin_prog_loop
     procedure, private :: act    => cubefield_gradthin_prog_act
  end type gradthin_prog_t
  !
contains
  !
  subroutine cubefield_gradthin_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(gradthin_user_t) :: user
    character(len=*), parameter :: rname='GRADTHIN>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call gradthin%parse(line,user,error)
    if (error) return
    call gradthin%main(user,error)
    if (error) continue
  end subroutine cubefield_gradthin_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_gradthin_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_comm_t), intent(inout) :: comm
    logical,                intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='GRADTHIN>COMM>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'GRADTHIN','[gradampid granangid]',&
         'Output a mask of thin edges',&
         'Mark pixels that are a local maximum of the gradient amplitude along&
         & the gradient direction. Suppressed pixels remain blank in the&
         & THINNED output.',&
         cubefield_gradthin_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'GRADAMPID',&
         'Cube identifier for the gradient amplitudes',&
         'Use the gradient-amplitude cube. If omitted, use the last matching&
         & cube (*gradient,amplitude*) in the default index (DAG by&
         & default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_gradient,flag_amplitude],&
         code_read,&
         code_access_imaset,&
         comm%gradamp,&
         error)
    if (error) return
    call incube%register(&
         'GRADANGID',&
         'Cube identifier for the gradient angles',&
         'Use the gradient-angle cube. If omitted, use the last matching&
         & cube (*gradient,angle*) in the default index (DAG by default;&
         & see SET\INDEX).',&
         code_arg_optional,&
         [flag_gradient,flag_angle],&
         code_read,&
         code_access_imaset,&
         comm%gradang,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'THINNED',&
         'Cube of thinned edges',&
         strg_emp,&
         [flag_thinned,flag_edge],&
         comm%thinned,&
         error)
    if (error)  return
  end subroutine cubefield_gradthin_comm_register
  !
  subroutine cubefield_gradthin_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! GRADTHIN gradampid gradangid
    !----------------------------------------------------------------------
    class(gradthin_comm_t), intent(in)    :: comm
    character(len=*),       intent(in)    :: line
    type(gradthin_user_t),  intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADTHIN>COMM>PARSE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubefield_gradthin_comm_parse
  !
  subroutine cubefield_gradthin_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_comm_t), intent(in)    :: comm
    type(gradthin_user_t),  intent(inout) :: user
    logical,                intent(inout) :: error
    !
    type(gradthin_prog_t) :: prog
    character(len=*), parameter :: rname='GRADTHIN>MAIN'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefield_gradthin_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_gradthin_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_user_t), intent(in)    :: user
    type(gradthin_comm_t),  intent(in)    :: comm
    type(gradthin_prog_t),  intent(out)   :: prog
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADTHIN>USER>TOPROG'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%gradamp,user%cubeids,prog%gradamp,error)
    if (error) return
    call user%region%toprog(prog%gradamp,prog%region,error)
    if (error) return
    call cubeadm_get_header(comm%gradang,user%cubeids,prog%gradang,error)
    if (error) return
    call user%region%toprog(prog%gradang,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return
  end subroutine cubefield_gradthin_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_gradthin_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_prog_t), intent(inout) :: prog
    type(gradthin_comm_t),  intent(in)    :: comm
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='GRADTHIN>PROG>HEADER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header_with_region(comm%thinned,  &
      prog%gradamp,prog%region,prog%thinned,error)
    if (error) return
    ! Unit
    call cubetools_header_put_array_unit('Boolean',prog%thinned%head,error)
    if (error) return
  end subroutine cubefield_gradthin_prog_header
  !
  subroutine cubefield_gradthin_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(gradthin_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='GRADTHIN>PROG>DATA'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefield_gradthin_prog_data
  !   
  subroutine cubefield_gradthin_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_prog_t),   intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: gradamp,gradang,thinned
    character(len=*), parameter :: rname='GRADTHIN>PROG>LOOP'
    !
    call gradamp%associate('gradamp',prog%gradamp,iter,error)
    if (error) return
    call gradang%associate('gradang',prog%gradang,iter,error)
    if (error) return
    call thinned%allocate('thinned',prog%thinned,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,gradamp,gradang,thinned,error)
      if (error) return
    enddo ! ie
  end subroutine cubefield_gradthin_prog_loop
  !   
  subroutine cubefield_gradthin_prog_act(prog,ie,gradamp,gradang,thinned,error)
    use phys_const
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(gradthin_prog_t), intent(inout) :: prog
    integer(kind=entr_k),   intent(in)    :: ie
    type(image_t), target,  intent(inout) :: gradamp
    type(image_t), target,  intent(inout) :: gradang
    type(image_t),          intent(inout) :: thinned
    logical,                intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy,idx,idy
    integer(kind=inte_k) :: iangle
    real(kind=sign_k), pointer :: ampli,angle,thin
    real(kind=dble_k), parameter :: pi4=pi/4
    real(kind=dble_k), parameter :: pi8=pi/8
    character(len=*), parameter :: rname='GRADTHIN>PROG>ACT'
    !
    idx = 1
    idy = 1
    call gradamp%get(ie,error)
    if (error) return
    call gradang%get(ie,error)
    if (error) return
    call thinned%set(gr4nan,error)
    if (error) return
    do iy=3,gradamp%ny-2
       do ix=3,gradamp%nx-2
          ampli => gradamp%val(ix,iy)
          angle => gradang%val(ix,iy)
          thin  => thinned%val(ix,iy)
          if (isnan(ampli).or.isnan(angle)) then
             thin = gr4nan
          else
             thin = ampli
             iangle = int(modulo(angle+pi8,pi)/pi4)
             select case (iangle)
             case (0)
                ! Mostly horizontal gradient
                if (ampli.lt.gradamp%val(ix-idx,iy) .or. ampli.lt.gradamp%val(ix+idx,iy)) then
                   thin = gr4nan
                endif
             case (1)
                ! Mostly oblique at +45 deg
                if (ampli.lt.gradamp%val(ix-idx,iy+idy) .or. ampli.lt.gradamp%val(ix+idx,iy-idy)) then
                   thin = gr4nan
                endif
             case (2)
                ! Mostly vertical gradient
                if (ampli.lt.gradamp%val(ix,iy-idy) .or. ampli.lt.gradamp%val(ix,iy+idy)) then
                   thin = gr4nan
                endif
             case (3)
                ! Mostly oblique at +135 deg
                if (ampli.lt.gradamp%val(ix-idx,iy-idy) .or. ampli.lt.gradamp%val(ix+idx,iy+idy)) then
                   thin = gr4nan
                endif
             case default
                error = .true.
                return
             end select
          endif
       enddo ! ix
    enddo ! iy
    call thinned%put(ie,error)
    if (error) return
  end subroutine cubefield_gradthin_prog_act
end module cubefield_gradthin
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_reallocate_r4d(kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r4d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny,nu,nv
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r4d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  nu = cube%gil%dim(3)
  nv = cube%gil%dim(4)
  allocate(cube%r4d(nx,ny,nu,nv),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny,' x ',nu,' x ',nv
  call wifisyn_message(seve%i,rname,mess)
  cube%gil%ndim = 4
  ! Initialize
  cube%r4d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r4d
!
subroutine wifisyn_cube_free_r4d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r4d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r4d)) deallocate(cube%r4d)
  nullify(cube%r4d)
  !
end subroutine wifisyn_cube_free_r4d
!
subroutine wifisyn_cube_reallocate_r3d(nc,kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r3d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,          intent(in)    :: nc
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r3d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  if (nc.gt.cube%gil%dim(3)) then
     write(mess,'(a,i0,a,i0,a)') 'Trying to allocate more channels (',nc,') than expected in file (',cube%gil%dim(3),')'
     call wifisyn_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  allocate(cube%r3d(nx,ny,nc),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny,' x ',nc
  call wifisyn_message(seve%i,rname,mess)
  ! Header update (do *not* update the 3rd header dimensions here...)
  cube%gil%ndim = 3
  cube%gil%dim(4) = 1
  ! Initialize
  cube%r3d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r3d
!
subroutine wifisyn_cube_free_r3d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r3d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r3d)) deallocate(cube%r3d)
  nullify(cube%r3d)
  !
end subroutine wifisyn_cube_free_r3d
!
subroutine wifisyn_cube_reallocate_r2d(kind,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_reallocate_r2d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: kind
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  !
  integer :: ier,nx,ny
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/REALLOCATE/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  ! Free when needed
  call wifisyn_cube_free_r2d(cube,error)
  ! Allocate
  nx = cube%gil%dim(1)
  ny = cube%gil%dim(2)
  allocate(cube%r2d(nx,ny),stat=ier)
  if (failed_allocate(rname,kind,ier,error)) return
  ! User feedback
  write(mess,'(a,a,a,i0,a,i0)') 'Allocated ',kind,' array of size: ',nx,' x ',ny
  call wifisyn_message(seve%i,rname,mess)
  ! Header update
  cube%gil%ndim = 2
  cube%gil%dim(3) = 1
  cube%gil%dim(4) = 1
  ! Initialize
  cube%r2d = cube%gil%bval
  !
end subroutine wifisyn_cube_reallocate_r2d
!
subroutine wifisyn_cube_free_r2d(cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_free_r2d
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: cube
  logical,      intent(inout) :: error
  !
  character(len=*), parameter :: rname='CUBE/FREE/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (associated(cube%r2d)) deallocate(cube%r2d)
  nullify(cube%r2d)
  !
end subroutine wifisyn_cube_free_r2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_minmax_r4d(logscale,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r4d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy,iu,iv
  character(len=*), parameter :: rname='CUBE/MINMAX/R4D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.4) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 4')
     error = .true.
     return
  endif
  !
  do iv=1,cube%gil%dim(4)
     do iu=1,cube%gil%dim(3)
        do iy=1,cube%gil%dim(2)
           do ix=1,cube%gil%dim(1)
              cubval = cube%r4d(ix,iy,iu,iv)
              if (logscale.and.(cubval.eq.0.0)) cycle
              if (cubval.gt.cube%gil%rmax) then
                 cube%gil%rmax = cubval
                 cube%gil%maxloc(1) = ix
                 cube%gil%maxloc(2) = iy
                 cube%gil%maxloc(3) = iu
                 cube%gil%maxloc(4) = iv
              endif
              if (cubval.lt.cube%gil%rmin) then
                 cube%gil%rmin = cubval
                 cube%gil%minloc(1) = ix
                 cube%gil%minloc(2) = iy
                 cube%gil%minloc(3) = iu
                 cube%gil%minloc(4) = iv
              endif
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  if (logscale.and.(cube%gil%rmin.eq.cube%gil%rmax)) cube%gil%rmin = cube%gil%rmax/10.0
  !
  print *,"max:",cube%gil%rmax,cube%gil%maxloc(1:4)
  print *,"min:",cube%gil%rmin,cube%gil%minloc(1:4)
  !
end subroutine wifisyn_cube_minmax_r4d
!
subroutine wifisyn_cube_minmax_r3d(logscale,win,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r3d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(window_t), intent(in)    :: win
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy,ic
  character(len=*), parameter :: rname='CUBE/MINMAX/R3D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.3) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 3')
     error = .true.
     return
  endif
  !
  do ic=win%first,win%last
     do iy=1,cube%gil%dim(2)
        do ix=1,cube%gil%dim(1)
           cubval = cube%r3d(ix,iy,ic)
           if (logscale.and.(cubval.eq.0.0)) cycle
           if (cubval.gt.cube%gil%rmax) then
              cube%gil%rmax = cubval
              cube%gil%maxloc(1) = ix
              cube%gil%maxloc(2) = iy
              cube%gil%maxloc(3) = ic
           endif
           if (cubval.lt.cube%gil%rmin) then
              cube%gil%rmin = cubval
              cube%gil%minloc(1) = ix
              cube%gil%minloc(2) = iy
              cube%gil%minloc(3) = ic
           endif
        enddo ! ix
     enddo ! iy
  enddo ! ic
  if (logscale.and.(cube%gil%rmin.eq.cube%gil%rmax)) cube%gil%rmin = cube%gil%rmax/10.0
  !
  print *,"max:",cube%gil%rmax,cube%gil%maxloc(1:3)
  print *,"min:",cube%gil%rmin,cube%gil%minloc(1:3)
  !
end subroutine wifisyn_cube_minmax_r3d
!
subroutine wifisyn_cube_minmax_r2d(logscale,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_minmax_r2d
  use wifisyn_gridding_types
  !--------------------------------------------------------------------
  ! @ private
  ! Update the minimum and maximum value of a cube and
  ! their locations. We here assume that the initializations
  ! were done when the cube was initialized...
  !--------------------------------------------------------------------
  logical,        intent(in)    :: logscale
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  !
  real(kind=4) :: cubval
  integer(kind=index_length) :: ix,iy
  character(len=*), parameter :: rname='CUBE/MINMAX/R2D'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (cube%gil%ndim.ne.2) then
     call wifisyn_message(seve%e,rname,'Cube rank is not 2')
     error = .true.
     return
  endif
  do iy=1,cube%gil%dim(2)
     do ix=1,cube%gil%dim(1)
        cubval = cube%r2d(ix,iy)
        if (logscale.and.(cubval.eq.0.0)) cycle
        if (cubval.gt.cube%gil%rmax) then
           cube%gil%rmax = cubval
           cube%gil%maxloc(1) = ix
           cube%gil%maxloc(2) = iy
        endif
        if (cubval.lt.cube%gil%rmin) then
           cube%gil%rmin = cubval
           cube%gil%minloc(1) = ix
           cube%gil%minloc(2) = iy
        endif
     enddo ! ix
  enddo ! iy
  !
end subroutine wifisyn_cube_minmax_r2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_open(name,ibuffer,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_open
  use wifisyn_buffer_parameters
  !----------------------------------------------------------------------
  ! @ private
  ! *** JP should probably here use the readwrite_t
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  integer,          intent(in)    :: ibuffer
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/OPEN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if ((ibuffer.lt.1).or.(mbuffer.lt.ibuffer)) then
     call wifisyn_message(seve%e,rname,'Unknown buffer')
     error = .true.
     return
  endif
  call sic_parse_file(name,' ',known_buffer_type(ibuffer),cube%file)
  call gdf_create_image(cube,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_open
!
subroutine wifisyn_cube_read(do,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_read
  use wifisyn_readwrite_types
  use wifisyn_cube_types
  !------------------------------------------------------------------
  ! @ private
  ! Read input cube header and data
  !------------------------------------------------------------------
  type(readwrite_t), intent(in)    :: do
  type(gildas),      intent(inout) :: cube
  logical,           intent(inout) :: error
  ! Local
  integer :: nchan
  character(len=*), parameter :: rname = 'CUBE/READ'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call sic_parse_file(do%name,' ',do%type,cube%file)
  cube%blc = 0
  cube%trc = 0
  call gdf_read_header(cube,error)
  if (gildas_error(cube,rname,error)) return
  if (cube%gil%ndim.eq.3) then
     nchan = max(1,do%last-do%first)
     call wifisyn_cube_reallocate_r3d(nchan,do%kind,cube,error)
     if (error) return
     call gdf_read_data(cube,cube%r3d,error)
     if (gildas_error(cube,rname,error)) return
  else if (cube%gil%ndim.eq.4) then
     call wifisyn_cube_reallocate_r4d(do%kind,cube,error)
     if (error) return
     call gdf_read_data(cube,cube%r4d,error)
     if (gildas_error(cube,rname,error)) return
  endif
  call gdf_close_image(cube,error) ! Free image slot
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_read
!
subroutine wifisyn_cube_write_r4d(i3,i4,cube,error)
  use gbl_message
  use gildas_def
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_write_r4d
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  integer,              intent(in)    :: i3
  integer,              intent(in)    :: i4
  type(gildas), target, intent(inout) :: cube
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/WRITE/R4D'
  !
  real, pointer :: cube_r2d(:,:) => null()
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  cube%blc(:) = 0
  cube%blc(3) = i3
  cube%blc(4) = i4
  cube%trc(:) = 0
  cube%trc(3) = i3
  cube%trc(4) = i4
  cube_r2d => cube%r4d(:,:,i3,i4)
  call gdf_write_data(cube,cube_r2d,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_write_r4d
!
subroutine wifisyn_cube_write(win,cube,error)
  use gbl_message
  use gildas_def
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_write
  use wifisyn_gridding_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(window_t), intent(in)    :: win
  type(gildas),   intent(inout) :: cube
  logical,        intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/WRITE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  cube%blc(:) = 0
  cube%blc(3) = win%first
  cube%trc(:) = 0
  cube%trc(3) = win%last
  call gdf_write_data(cube,cube%r3d,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_write
!
subroutine wifisyn_cube_close(cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_close
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(gildas),     intent(inout) :: cube
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CUBE/CLOSE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call gdf_update_header(cube,error)
  if (gildas_error(cube,rname,error)) return
  call gdf_close_image(cube,error)
  if (gildas_error(cube,rname,error)) return
  !
end subroutine wifisyn_cube_close
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_cube_sicdef(readonly,name,cube,error)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_cube_sicdef
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical,          intent(in)    :: readonly
  character(len=*), intent(in)    :: name ! sic name
  type(gildas),     intent(inout) :: cube ! buffer
  logical,          intent(inout) :: error
  !
  integer :: ndim
  character(len=80) :: mess
  character(len=*), parameter :: rname='CUBE/SICDEF'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  call wifisyn_message(seve%i,rname,'Defining '//trim(name)//' SIC structure')
  !
  if (sic_varexist(name)) then
     call wifisyn_message(seve%d,rname,trim(name)//' SIC structure already exists')
     call wifisyn_cube_sicdel_header(name,error)
     if (error) return
     call sic_delvariable(name,.false.,error)
     if (error) return
  endif
  ndim = cube%gil%ndim
  if (ndim.eq.2) then
     call sic_def_real(name,cube%r2d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else if (ndim.eq.3) then
     call sic_def_real(name,cube%r3d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else if (ndim.eq.4) then
     call sic_def_real(name,cube%r4d,ndim,cube%gil%dim,readonly,error)
     if (error) return
  else
     write(mess,*) ndim,' dimensions in ',trim(name),' while expecting at least 2'
     call wifisyn_message(seve%e,rname,mess)
     error = readonly
     return
  endif
  call sic_def_header(name,cube,readonly,error)
  if (error) return
  !
end subroutine wifisyn_cube_sicdef
!
subroutine wifisyn_cube_sicdel_header(name,error)
  use gbl_message
  use gildas_def
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_cube_sicdel_header
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name
  logical,          intent(inout) :: error
  !
  integer :: nn
  character(len=varname_length) :: pre
  character(len=*), parameter :: rname='CUBE/SICDEL/HEADER'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nn = len_trim(name)+1
  pre = name
  pre(nn:nn) = '%'
  !
  ! GENERAL section
  call sic_delvariable(pre(1:nn)//'GENE',.false.,error)
  call sic_delvariable(pre(1:nn)//'NDIM',.false.,error)
  call sic_delvariable(pre(1:nn)//'DIM',.false.,error)
  call sic_delvariable(pre(1:nn)//'CONVERT',.false.,error)
  ! Blanking section
  call sic_delvariable(pre(1:nn)//'BLAN',.false.,error)
  call sic_delvariable(pre(1:nn)//'BLANK',.false.,error)
  ! Extrema
  call sic_delvariable(pre(1:nn)//'EXTREMA',.false.,error)
  call sic_delvariable(pre(1:nn)//'MIN',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAX',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAXLOC',.false.,error)
  call sic_delvariable(pre(1:nn)//'MINLOC',.false.,error)
  ! Units and cooreadonlyinate system
  call sic_delvariable(pre(1:nn)//'DESC',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT1',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT2',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT3',.false.,error)
  call sic_delvariable(pre(1:nn)//'UNIT4',.false.,error)
  call sic_delvariable(pre(1:nn)//'SYSTEM',.false.,error)
  !
  ! Astronomical position
  call sic_delvariable(pre(1:nn)//'POSI',.false.,error)
  call sic_delvariable(pre(1:nn)//'SOURCE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RA',.false.,error)
  call sic_delvariable(pre(1:nn)//'DEC',.false.,error)
  call sic_delvariable(pre(1:nn)//'LII',.false.,error)
  call sic_delvariable(pre(1:nn)//'BII',.false.,error)
  !
  call sic_delvariable(pre(1:nn)//'EPOCH',.false.,error)
  !
  ! Projection
  call sic_delvariable(pre(1:nn)//'PROJ',.false.,error)
  call sic_delvariable(pre(1:nn)//'PTYPE',.false.,error)
  call sic_delvariable(pre(1:nn)//'A0',.false.,error)
  call sic_delvariable(pre(1:nn)//'D0',.false.,error)
  call sic_delvariable(pre(1:nn)//'ANGLE',.false.,error)
  call sic_delvariable(pre(1:nn)//'X_AXIS',.false.,error)
  call sic_delvariable(pre(1:nn)//'Y_AXIS',.false.,error)
  !
  ! Spectroscopy
  call sic_delvariable(pre(1:nn)//'SPEC',.false.,error)
  call sic_delvariable(pre(1:nn)//'LINE',.false.,error)
  call sic_delvariable(pre(1:nn)//'FREQRES',.false.,error)
  call sic_delvariable(pre(1:nn)//'IMAGFRE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RESTFRE',.false.,error)
  call sic_delvariable(pre(1:nn)//'VELRES',.false.,error)
  call sic_delvariable(pre(1:nn)//'VELOFF',.false.,error)
  call sic_delvariable(pre(1:nn)//'F_AXIS',.false.,error)
  !
  ! Beam size
  call sic_delvariable(pre(1:nn)//'BEAM',.false.,error)
  call sic_delvariable(pre(1:nn)//'MAJOR',.false.,error)
  call sic_delvariable(pre(1:nn)//'MINOR',.false.,error)
  call sic_delvariable(pre(1:nn)//'PA',.false.,error)
  !
  ! Noise
  call sic_delvariable(pre(1:nn)//'SIGMA',.false.,error)
  call sic_delvariable(pre(1:nn)//'NOISE',.false.,error)
  call sic_delvariable(pre(1:nn)//'RMS',.false.,error)
  !
  call sic_delvariable(pre(1:nn)//'PROPER',.false.,error)
  call sic_delvariable(pre(1:nn)//'MU',.false.,error)
  call sic_delvariable(pre(1:nn)//'PARALLAX',.false.,error)

  !
end subroutine wifisyn_cube_sicdel_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_wavelets
  !---------------------------------------------------------------------
  ! Support module for command LAS\WAVELET
  !---------------------------------------------------------------------
  real(kind=4), allocatable :: wavelets(:,:)  ! Support for Sic variable 'WAVELET'
end module class_wavelets
!
subroutine class_wavelet(line,r,error,user_function)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_wavelet
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !  WAVELET [/BASE]
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line
  type(observation), intent(inout) :: r
  logical,           intent(inout) :: error
  logical,           external      :: user_function
  ! Local
  character(len=*), parameter :: rname='WAVELET'
  integer(kind=4), parameter :: optbase=1
  integer(kind=4), parameter :: optplot=2
  logical :: dobase,doplot
  integer(kind=4) :: base_order,plotpen
  !
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No R spectrum in memory')
    error = .true.
    return
  endif
  !
  ! /BASE
  dobase = sic_present(optbase,0)
  if (dobase) then
    base_order = 5  ! Default
    call sic_i4(line,optbase,1,base_order,.false.,error)
    if (error) return
  else
    base_order = 0 ! => R not modified on return
  endif
  !
  ! /PLOT
  doplot = dobase.and.sic_present(optplot,0)
  plotpen = 1
  call sic_i4(line,optplot,1,plotpen,.false.,error)
  if (error) return
  !
  call wavelet_obs(r,base_order,doplot,plotpen,error)
  if (error) return
  !
end subroutine class_wavelet
!
subroutine wavelet_obs(obs,iorder,doplot,plotpen,error)
  use gildas_def
  use gkernel_interfaces
  use classcore_interfaces, except_this=>wavelet_obs
  use class_wavelets
  use class_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compute and modify inplace the wavelets for input observation
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  integer(kind=4),   intent(in)    :: iorder   ! /BASE order?
  logical,           intent(in)    :: doplot   !
  integer(kind=4),   intent(in)    :: plotpen  !
  logical,           intent(inout) :: error    !
  ! Local
  integer(kind=4) :: nchan,odeg
  integer(kind=index_length) :: dims(2)
  character(len=*), parameter :: rname='WAVELET'
  !
  ! Remove previous SIC variable when it exists
  call sic_delvariable('WAVELET',.false.,error)
  if (error) error = .false.
  ! Compute the wavelet array
  nchan = obs%cnchan
  call gwavelet_gaps(obs%spectre(1:nchan),wavelets,error)
  if (error) return
  ! Redefine the SIC variable when the computation succeeded
  dims(1) = nchan
  dims(2) = size(wavelets,2)
  call sic_def_real('WAVELET',wavelets,2,dims,.true.,error)
  if (error) return
  call gwavelet_subtract(iorder,wavelets,obs%spectre(1:nchan),error)
  if (error) return
  !
  if (doplot) then
    ! NB1: this needs a non-zero iorder, i.e. /BASE was invoked
    ! NB2: temporarily set obs%head%bas%deg to -2, pseudo-code for
    ! BASE WAVELET (similar to BASE SINUS, code -1). But since this
    ! is not yet in the standard, undo this right after the plot.
    odeg = obs%head%bas%deg
    obs%head%bas%deg = -2
    call baseline_plot(obs,wavelets(:,iorder),plotpen,error)
    if (error)  return
    obs%head%bas%deg = odeg
  endif
  !
end subroutine wavelet_obs
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine load_2d(set,line,error,user_function)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>load_2d
  use class_types
  use class_index
  use class_data
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !   LOAD /NOCHECK
  ! Convert the entire index in a single 2-D data set for further plot
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set            !
  character(len=*),    intent(in)  :: line           ! Command Line
  logical,             intent(out) :: error          ! Return error code
  logical,             external    :: user_function  ! handling of user defined sections, intent(in)
  ! Local
  character(len=*), parameter :: rname='LOAD'
  type(observation) :: obs
  type(header) :: ref_head
  integer(kind=index_length) :: dim(4)
  integer(kind=entry_length) :: iobs,nobs,ksave
  integer(kind=4) :: iline,nchan
  character(len=message_length) :: mess
  character(len=12) :: stele  ! Telescope name for the index
  logical :: stele_c(12)  ! Characters to be compared
  !
  if (set%kind.ne.kind_spec) then
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
    return
  endif
  !
  ! Initialization
  error = .false.
  call init_obs(obs)
  call init_obs(p)
  !
  ! Select what will be checked according to user input
  call consistency_check_selection(set,line,1,cx%cons,error)
  if (error) return  ! Ignore cx%cons%prob since we ignore cx%cons%off%prob
  cx%cons%off%check = .false.
  !
  ! Sanity check
  if (cx%next.le.1) then
     call class_message(seve%f,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  ! Read first index spectrum to set its header as reference
  ksave = knext
  call get_first(set,obs,user_function,error)
  knext = ksave
  if (error) return
  ref_head = obs%head
  !
  ! Set checking tolerances
  call consistency_tole(ref_head,cx%cons)
  !
  ! Give user feedback on what will be done
  call consistency_print(set,ref_head,cx%cons)
  !
  ! Clean associated SIC variable
  call sic_delvariable('P',.false.,error)
  error = .false.
  !
  ! Allocation of P arrays
  nobs = cx%next-1
  nchan = ref_head%spe%nchan
  call reallocate_pq(nchan,nobs,error)
  if (error) return
  write(mess,*) 'Found ',nobs,' spectra of ',nchan,' channels'
  call class_message(seve%i,rname,mess)
  !
  ! Initialize header and x arrays
  p%head = ref_head
  call abscissa(set,p,error)
  if (error) return
  p%head%des%ndump = nobs
  p%head%xnum = -1 ! Is that correct ??? JP
  !
  ! Initialize telescope variables
  stele = ref_head%gen%teles
  stele_c(:) = .true.  ! At start, compare the 12 characters
  !
  ! Initialization of p
  p%data2 = ref_head%spe%bad
  !
  ! Loop on observation
  iline = 0
  do iobs = 1,nobs
     if (sic_ctrlc()) exit
     ! Read into buffer header section from file
     call robs(obs,cx%ind(iobs),error)
     if (error) cycle
     ! Read only interesting sections
     call rgen(set,obs,error)  ! General section
     if (error) cycle
     call rpos(set,obs,error)  ! Position section
     if (error) cycle
     call rspec(set,obs,error) ! Spectroscopic section
     if (error) cycle
     if (obs%head%presec(class_sec_cal_id)) then
       call rcal(set,obs,error)
       if (error) cycle
     endif
     if (obs%head%presec(class_sec_swi_id)) then
       call rswi(set,obs,error)  ! Switching section
       if (error) cycle
     endif
     ! Consistency checks
     if (cx%cons%check) then
        call spectrum_consistency_check(set,ref_head,obs%head,cx%cons)
        if (cx%cons%prob)  exit
     endif
     ! Telescope
     call sumlin_header_telescope(obs%head%gen%teles,stele_c,stele)
     ! Get data
     if (obs%head%spe%nchan.ne.nchan) then
       ! This can happen if user has disabled SPECTROSCOPY check. This leads
       ! to segfaults in rdata() and p%data2 assignments.
       write (mess,'(A,I0,A,I0,A,I0,A)')  &
         'Obs #',obs%head%gen%num,' has an unexpected number of channels (',  &
         obs%head%spe%nchan,' instead of ',nchan,')'
       call class_message(seve%e,rname,mess)
       if (.not.cx%cons%spe%check) then
         call class_message(seve%e,rname,  &
           'Check of spectroscopy sections is disabled but they differ too much')
       endif
       error = .true.
       goto 100
     endif
     call rdata(set,obs,obs%head%spe%nchan,obs%data1,error)
     if (error) cycle
     iline = iline+1
     p%data2(:,iline) = obs%data1
  enddo
  !
  p%head%gen%teles = stele
  !
  ! Compute limits
  call newlim(set,p,error)
  if (error) return
  !
  ! Define associated SIC structure
  dim(1) = nchan
  dim(2) = nobs
  if (.not.sic_varexist('p')) then
     call sic_defstructure('p%',.true.,error)
     if (error) return
  endif
  call sic_delvariable('p%x',.false.,error)
  call sic_delvariable('p%y',.false.,error)
  error = .false.
  call sic_def_dble('p%x',p%datax,1,dim,.true.,error)
  call sic_def_real('p%y',p%data2,2,dim,.false.,error)
  error = .false.
  !
  ! Feedback
  call index_consistency_analysis(set,cx%cons,rname)
  if (cx%cons%prob) then
     error = .true.
  endif
  !
100 continue
  !
  ! Cleaning
  call free_obs(obs)
end subroutine load_2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_putdata
  use cubetools_parameters
  use cubetools_structure
  use cubetopology_spapos_types
  use cubetopology_spechannel_types
  use cubeedit_messaging
  use cubeedit_entry
  use cubeedit_which_data
  !
  public :: putdata_comm_t,putdata_user_t
  private
  !
  integer(kind=4), parameter :: izero=1
  integer(kind=4), parameter :: ifirst=2
  integer(kind=4), parameter :: ilast=3
  integer(kind=4), parameter :: inext=4
  integer(kind=4), parameter :: iprevious=5
  integer(kind=4), parameter :: iafter=6
  integer(kind=4), parameter :: icurrent=7
  integer(kind=4), parameter :: nwhich = icurrent
  !
  character(len=*), parameter :: options(nwhich) = &
       ['ZERO     ','FIRST    ','LAST     ','NEXT     ','PREVIOUS ','AFTERLAST','CURRENT  ']
  !
  logical, parameter :: access_is_fixed  = .true.
  !
  type :: putdata_comm_t
     type(entry_opt_t)       :: entry
     type(spapos_comm_t)     :: pixel
     type(spechannel_opt_t)  :: channel
     type(which_comm_t)      :: which(1:nwhich)
     type(option_t), pointer :: from
   contains
     procedure, public :: register => cubeedit_putdata_register
     procedure, public :: parse    => cubeedit_putdata_parse
     procedure, public :: main     => cubeedit_putdata_main
  end type putdata_comm_t
  !
  type putdata_user_t
     type(which_user_t)      :: which(1:nwhich)
     type(entry_user_t)      :: entry     
     type(spapos_user_t)     :: pixel
     type(spechannel_user_t) :: channel
     logical                 :: dofrom
     character(len=varn_l)   :: varname
     logical                 :: do
  end type putdata_user_t
  !
contains
  !
  subroutine cubeedit_putdata_register(putdata,error)
    !----------------------------------------------------------------------
    ! Register options related to data edition
    !----------------------------------------------------------------------
    class(putdata_comm_t), intent(inout) :: putdata
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iwhich
    type(standard_arg_t) :: stdarg
    logical, parameter :: access_is_fixed = .true.
    logical, parameter :: active = .true.
    character(len=*), parameter :: rname='PUTDATA>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    do iwhich=1, nwhich
       call putdata%which(iwhich)%register(options(iwhich), &
            'Put the '//trim(options(iwhich))//' entry into the cube',&
            access_is_fixed,active,error)
       if (error) return
    enddo
    !
    call putdata%entry%register(&
         'Define the entry to be put in the cube',access_is_fixed,error)
    if (error) return
    ! 
    call putdata%pixel%register('PIXEL',&
         'Define the position of the pixel to be put',&
         error)
    if (error) return
    !
    call putdata%channel%register('CHANNEL',&
         'Define the velocity of the channel to be put',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FROM','varname',&
         'Define from which variable we fetch data',&
         strg_emp,&
         putdata%from,error)
    if (error) return
    call stdarg%register(&
         'varname',&
         'Variable name containing data to be put',&
         strg_emp,&
         code_arg_mandatory,error)
    if (error) return
  end subroutine cubeedit_putdata_register
  !
  subroutine cubeedit_putdata_parse(putdata,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for data part of command PUT
    !-------------------------------------------------------------------
    class(putdata_comm_t), intent(in)    :: putdata
    character(len=*),      intent(in)    :: line
    type(putdata_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: nopt,iwhich
    character(len=mess_l) :: optmess
    character(len=*), parameter :: rname='PUTDATA>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    nopt = 0
    do iwhich=1, nwhich
       call putdata%which(iwhich)%parse(line,user%which(iwhich),error)
       if (error) return
       if (user%which(iwhich)%do) nopt = nopt+1 
    enddo
    ! /ENTRY
    call putdata%entry%parse(line,user%entry,error)
    if (error) return
    if (user%entry%do)   nopt = nopt+1
    ! /PIXEL
    call putdata%pixel%parse(line,user%pixel,error)
    if (error) return
    if (user%pixel%present)   nopt = nopt+1
    ! /CHANNEL
    call putdata%channel%parse(line,user%channel,error)
    if (error) return
    if (user%channel%do) nopt = nopt+1
    !
    ! FROM
    call putdata%from%present(line,user%dofrom,error)
    if (error) return
    !
    optmess = 'Options'
    do iwhich=1,nwhich
       optmess = trim(optmess)//' /'//trim(options(iwhich))//','
    enddo
    optmess = trim(optmess)//' /ENTRY, /CHANNEL and /PIXEL'
    
    user%do = .false.
    if (nopt.eq.1) then
       if (user%dofrom) then
          call cubetools_getarg(line,putdata%from,1,user%varname,mandatory,error)
          if (error) return
          user%do = .true.
       else
          call cubeedit_message(seve%e,rname,trim(optmess)//' Require option /FROM')
          error = .true.
          return
       endif
    else if (nopt.gt.1) then ! Problem, Conflicting options
       call cubeedit_message(seve%e,rname,trim(optmess)//' conflict with each other')
       error = .true.
       return
    else ! Nothing to be done
       if (user%dofrom) call cubeedit_message(seve%w,rname,'Option &
            &/FROM only applies to '//trim(optmess))
    endif
  end subroutine cubeedit_putdata_parse
  !
  subroutine cubeedit_putdata_main(putdata,user,cube,ie,error)
    use cube_types
    use cubeadm_get
    !-------------------------------------------------------------------
    ! Main routine for data part of command PUT
    !-------------------------------------------------------------------
    class(putdata_comm_t), intent(in)    :: putdata
    type(putdata_user_t),  intent(in)    :: user
    type(cube_t), pointer, intent(inout) :: cube
    integer(kind=entr_k),  intent(inout) :: ie
    logical,               intent(inout) :: error
    !
    logical :: doima,put
    integer(kind=4) :: iwhich
    type(spapos_prog_t) :: pixel
    type(spechannel_prog_t) :: channel
    character(len=*), parameter :: rname='PUTDATA>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (user%do) then
       doima = cube%order().eq.code_access_imaset
       if (user%pixel%present.and.doima) then
          call cubeedit_message(seve%e,rname,'Cannot put a pixel in a cube that is accessed by images')
          error = .true.
          return
       endif
       if (user%channel%do.and..not.doima) then
          call cubeedit_message(seve%e,rname,'Cannot put a channel in a cube that is accessed by spectra')
          error = .true.
          return
       endif
       !
       put = .true.
       if (user%pixel%present) then
          call user%pixel%toprog(cube,pixel,error)
          if (error) return
          ie = pixel%nearest_entry()
       else if (user%channel%do) then
          call user%channel%toprog(putdata%channel,cube,channel,error)
          if (error) return
          ie = channel%ic
       else if (user%entry%do) then
          ie = user%entry%ientry
       else
          do iwhich=1,nwhich
             if (.not.user%which(iwhich)%do)  cycle
             select case (iwhich)
             case (izero)
                put = .false.
                ie = 0
             case (ifirst)
                ie = 1
             case (ilast)
                ie = cube%nentry()
             case (inext)
                ie = ie+1
             case (iprevious)
                ie = ie-1
             case (iafter)
                put = .false.
                ie = cube%nentry()+1
             case(icurrent)
                ! No change to ie
             end select
          enddo
       endif
       if (ie.lt.0) then
          call cubeedit_message(seve%e,rname,'Trying to put data before the start of the cube')
          error = .true.
          return
       elseif (ie.gt.cube%nentry()) then
          call cubeedit_message(seve%e,rname,'Trying to put data beyond number of entries')
          error = .true.
          return
       endif
       !
       if (put) then
          if (doima) then
             if (cube%iscplx()) then
                call cubeedit_putdata_image_cplx(cube,user%varname,ie,error)
                if (error) return
             else
                call cubeedit_putdata_image_real(cube,user%varname,ie,error)
                if (error) return
             endif
          else
             if (cube%iscplx()) then
                call cubeedit_message(seve%e,rname,'Putting complex spectra is unsupported')
                error = .true.
                return
!!$                call cubeedit_putdata_spectrum_cplx(cube,user%varname,ie,error)
!!$                if (error) return
             else
                call cubeedit_putdata_spectrum_real(cube,user%varname,ie,error)
                if (error) return
             endif
          endif
       else
          ! Nothing to be put
       endif
    else
       ! Nothing to be done
    endif
  end subroutine cubeedit_putdata_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_putdata_image_real(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(image_t) :: ima
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>IMAGE>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.2) then
       write(mess,'(a,i0,a)') 'Expected a 2D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%l.or.dims(2).ne.n%m) then
       write(mess,'(4(a,i0))') 'Expected a ',n%l,'x',n%m,' array got ',dims(1),'x',dims(2)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call ima%allocate('ima from var',cube,error)
    if (error) return
    call var%get(ima%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call ima%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_image_real
  !
  subroutine cubeedit_putdata_image_cplx(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(visi_t) :: ima
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>IMAGE>CPLX'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.2) then
       write(mess,'(a,i0,a)') 'Expected a 2D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%l.or.dims(2).ne.n%m) then
       write(mess,'(4(a,i0))') 'Expected a ',n%l,'x',n%m,' array got ',dims(1),'x',dims(2)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call ima%allocate('ima from var',cube,error)
    if (error) return
    call var%get(ima%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call ima%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_image_cplx
  !
  subroutine cubeedit_putdata_spectrum_real(cube,varname,ie,error)
    use cube_types
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_uservar
    use cubeadm_ioloop
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(cube_t), pointer, intent(inout) :: cube
    character(len=*),      intent(in)    :: varname
    integer(kind=entr_k),  intent(in)    :: ie
    logical,               intent(inout) :: error
    !
    type(shape_t) :: n
    type(spectrum_t) :: spe
    type(uservar_t) :: var
    integer(kind=4) :: ndim
    integer(kind=entr_k), allocatable :: dims(:)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PUTDATA>SPECTRUM>REAL'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_userspace_get(varname,var,error)
    if (error) return
    call var%get_dims(ndim,dims,error)
    if (error) return
    if (ndim.ne.1) then
       write(mess,'(a,i0,a)') 'Expected a 1D array got a ',ndim,'D array'
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    if (dims(1).ne.n%c) then
       write(mess,'(2(a,i0))') 'Expected an array of size ',n%c,' got ',dims(1)
       call cubeedit_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    call spe%allocate('spe from var',cube,error)
    if (error) return
    call var%get(spe%y%val,error)
    if (error) return
    call cubeadm_io_iterate(ie,ie,cube,error)
    if (error) return
    call spe%put(ie,error)
    if (error) return
  end subroutine cubeedit_putdata_spectrum_real
  !
!!$  subroutine cubeedit_putdata_spectrum_cplx(cube,varname,ie,error)
!!$    use cube_types
!!$    use cubetools_shape_types
!!$    use cubetools_header_methods
!!$    use cubetools_uservar
!!$    use cubeadm_ioloop
!!$    use cubemain_spectrum_cplx
!!$    !----------------------------------------------------------------------
!!$    !
!!$    !----------------------------------------------------------------------
!!$    type(cube_t), pointer, intent(inout) :: cube
!!$    character(len=*),      intent(in)    :: varname
!!$    integer(kind=entr_k),  intent(in)    :: ie
!!$    logical,               intent(inout) :: error
!!$    !
!!$    type(shape_t) :: n
!!$    type(spectrum_cplx_t) :: spec
!!$    type(uservar_t) :: var
!!$    integer(kind=4) :: ndim
!!$    integer(kind=entr_k), allocatable :: dims(:)
!!$    character(len=mess_l) :: mess
!!$    character(len=*), parameter :: rname='PUTDATA>SPECTRUM>CPLX'
!!$    !
!!$    call cubeedit_message(edseve%trace,rname,'Welcome')
!!$    !
!!$    call cubetools_userspace_get(varname,var,error)
!!$    if (error) return
!!$    call var%get_dims(ndim,dims,error)
!!$    if (error) return
!!$    if (ndim.ne.1) then
!!$       write(mess,'(a,i0,a)') 'Expected a 1D array got a ',ndim,'D array'
!!$       call cubeedit_message(seve%e,rname,mess)
!!$       error = .true.
!!$       return
!!$    endif
!!$    !
!!$    call cubetools_header_get_array_shape(cube%head,n,error)
!!$    if (error) return
!!$    if (dims(1).ne.nc) then
!!$       write(mess,'(2(a,i0))') 'Expected an array of size ',nc,' got ',dims(1)
!!$       call cubeedit_message(seve%e,rname,mess)
!!$       error = .true.
!!$       return
!!$    endif
!!$    !
!!$    call spec%reallocate('fromvar',nc,error)
!!$    if (error) return
!!$    call var%get(spec%t,error)
!!$    if (error) return
!!$    call cubeadm_io_iterate(ie,ie,cube,error)
!!$    if (error) return
!!$    call spec%put(cube,ie,error)
!!$    if (error) return
!!$  end subroutine cubeedit_putdata_spectrum_cplx
end module cubeedit_putdata
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_fits_dobs (unit, error)
  use classic_api  
  implicit none
  integer :: unit                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: status, date(7)
  character(len=40) :: chain
  !
  ! Write scan number, obs number and date in a HDU.
  status = 0
  call ftpkyj(unit,'SCAN-NUM',r_scan,'Scan number',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'OBS-NUM',r_num,'Observation number',status)
  if (status .gt. 0) goto 99
  call jjdate (r_dobs+2460549.5d0+r_ut/pi/2,date)
  call fttm2s(date(1),date(2),date(3),date(4),date(5),   &
    date(6)+date(7)*0.001d0,   &
    3,chain,status)
  if (status .gt. 0) goto 99
  call ftpkys(unit,'DATE-OBS',chain,'Date',status)
  if (status .gt. 0) goto 99
  return
  ! error return
99 call printerror('WRITE_FITS_DOBS',status)
  error = .true.
end subroutine write_fits_dobs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine class_plot(set,line,r,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_plot
  use class_data
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !      PLOT [ArrayName]
  ! 1         [/INDEX]
  ! 2         [/OBS]
  ! Plot specified observation for command
  !----------------------------------------------------------------------
  type(class_setup_t), intent(inout) :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='PLOT'
  logical :: doindex
  character(len=16) :: aline,comm,aaname
  integer(kind=4) :: nline,nc
  !
  ! Parse input line
  doindex = set%action.eq.'I'
  if (sic_present(1,0).and.sic_present(2,0)) then
     call class_message(seve%e,rname,'/INDEX and /OBS are not compatible')
     error = .true.
     return
  else if (sic_present(1,0)) then
     if (.not.associated(p%data2)) then
        call class_message(seve%e,rname,'No index loaded')
        error = .true.
        return
     endif
     doindex = .true.
  else if (sic_present(2,0)) then
     doindex = .false.
  endif
  !
  if (doindex) then
     call plot_index(set,error)
  else
     if (r%head%xnum.eq.0) then
        call class_message(seve%e,rname,'No such spectrum in memory.')
        error = .true.
        return
     endif
     if (r%head%gen%kind.eq.kind_sky) then
        call class_message(seve%e,rname,'Not yet implemented for SKYDIP.')
        error = .true.
        !!call plot_sky(line,error)
     elseif (r%head%gen%kind.eq.kind_onoff) then
        call class_message(seve%e,rname,'Not yet implemented for ON/OFF.')
        error = .true.
     else
        call gtv_clear_directory('^',error)  ! ^ = ancestor of current tree
        if (error)  return
        call newlim(set,r,error)
        ! Spectrum
        aaname = 'Y'  ! Plot RY
        call sic_ke(line,0,1,aaname,nc,.false.,error)
        if (error)  return
        call spectr1d(rname,set,r,error,aaname=aaname)
        if (error)  return
        ! Box
        call class_box_default(set,.false.,r,aaname,error)
        if (error)  return
        ! Title
        aline = 'LAS'//CHAR(92)//'TITLE /OBS'
        nline = len_trim(aline)
        call sic_analyse(comm,aline,nline,error)
        call class_title(set,aline,r,error)
     endif
  endif
  !
  ! Set space to direct
  set%fft = .false.
  !
end subroutine class_plot
!
subroutine plot_index(set,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>plot_index
  use class_data
  use class_index
  use class_popup
  use class_types
  use plot_formula
  !-----------------------------------------------------------------------
  ! @ private
  ! CLASS Support routine for command
  !     PLOT /INDEX
  ! Plot the currently loaded 2-D array as an image
  !-----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PLOT'
  character(len=16) :: aline,comm
  character(len=1) :: unit_up,unit_low
  integer(kind=entry_length) :: i
  integer(kind=4) :: ier,nline
  !
  if (.not.associated(p%data2)) then
     call class_message(seve%e,rname,'No 2-D data loaded')
     error = .true.
     return
  endif
  !
  ! Compute plot limits
  call newlim(set,p,error)
  if (error) return
  !
  ! Clear plot
  call geunit(set,p%head,unit_low, unit_up)
  call gtclear
  !
  ! Spectrum
  call spectr2d(p,error)
  !
  ! Box and wedge
  call class_box_default(set,.true.,p,'Y',error)
  if (error)  return
  call gr_exec2('WEDGE')
  !
  ! Title
  aline = 'LAS'//CHAR(92)//'TITLE /INDEX'
  nline = len_trim(aline)
  call sic_analyse(comm,aline,nline,error)
  call class_title(set,aline,p,error)
  !
  ! Save for POPUP commands.
  npop = p%head%des%ndump
  if (allocated(ipop)) deallocate(ipop,xpop,ypop)
  allocate(ipop(npop),xpop(npop),ypop(npop),stat=ier)
  if (ier.ne.0) then
     call class_message(seve%f,rname,'Allocation error')
     error = .true.
     npop = 0
  else
     do i=1, npop
        ipop(i) = cx%num(i) !! r%head%gen%num
     enddo
  endif
  cpop = cpop_plotindex
  pgx1 = gx1
  pgx2 = gx2
  pgz1 = gy1
  pgz2 = gy2
  pux1 = 0.5
  pux2 = p%head%spe%nchan+0.5
  if (set%modez.eq.'A'.or.set%modez.eq.'T') then
     puz1 = 0.5
     puz2 = p%head%des%ndump+0.5
  endif
  !
end subroutine plot_index

subroutine sub_major_lin(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  use gbl_message
  use image_def
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_major_lin
  use cct_types
  use clean_types
  use clean_support_tool
  use clean_flux_tool, only: init_plot
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the MRC (Multi Resolution CLEAN)
  !     which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  external :: major_plot
  external :: next_flux
  !
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(in) :: hprim
  type (gildas), intent(in) :: hmask
  real, intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
  logical, intent(in), target :: mask(:,:)
  integer, intent(in), target :: list(:)
  logical, intent(inout) ::  error
  !
  real, pointer :: dirty(:,:)  ! Dirty map
  real, pointer :: resid(:,:)  ! Iterated residual
  real, pointer :: clean(:,:)  ! Clean Map
  real, pointer :: d3prim(:,:,:)   ! Primary beam (for one frequency)
  real, pointer :: d3beam(:,:,:)   ! Dirty beam (for one frequency)
  real, pointer :: weight(:,:)     ! Mosaic weight
  !
  real, allocatable :: tfbeam(:,:,:)
  real, allocatable :: w_fft(:)    ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cct(:,:)
  logical, allocatable :: s_mask(:,:)
  real, allocatable :: s_beam(:,:,:), t_beam(:,:), s_resi(:,:)
  integer, allocatable :: mymask(:,:)
  integer :: f_iter, m_iter
  !
  real, target :: dummy_prim(1,1,1), dummy_weight(1,1)
  integer iplane
  integer nx,ny,np,nl,mx,my,nc
  integer ip,ier,ix,iy,i,jcode
  real fhat, limit, flux
  logical do_fft
  character(len=message_length) :: chain
  character(len=12) :: cname 
  integer :: nplane
  !
  type (cct_par), allocatable :: tcc(:)
  !
  integer, pointer :: llist(:)
  logical, pointer :: lmask(:,:)
  !
  error = .false.
  do_fft = method%method.ne.'HOGBOM'
  cname = method%method
  !
  llist => list
  lmask => mask
  !
  ! Local variables
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  mx = hbeam%gil%dim(1)
  my = hbeam%gil%dim(2)
  nl = method%nlist
  nc = nx*ny
  np = max(1,hprim%gil%dim(1)) ! or ! np = hbeam%gil%dim(3)
  !
  if (do_fft) then
    allocate(w_work(nx,ny),w_fft(2*max(nx,ny)),tfbeam(nx,ny,np),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,cname,'Memory allocation error for TFBEAM')
      error = .true.
      return
    endif
  else
    allocate(w_work(1,1),w_fft(1),tfbeam(1,1,1),stat=ier)  
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'FFT Memory allocation failure')
    error = .true.
    return
  endif
  !
  if (method%method.eq.'CLARK') then
    allocate(w_comp(nc), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'SDI') then
    allocate(w_comp(nc),w_cct(nx,ny),mymask(nx,ny), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'MULTI') then
    allocate (s_mask(nx,ny),s_resi(nx,ny),t_beam(nx,ny), &
      & s_beam(nx,ny,3),w_cct(nx,ny),mymask(nx,ny), &
      & w_comp(1), stat=ier)
  else
    allocate(w_comp(1), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Work Arrays Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Clean component work array
  allocate(tcc(method%m_iter),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Memory allocation error for TCC')
    error = .true.
    return
  endif
  !
  nplane = method%last-method%first+1
  !
  ! Global aliases
  if (method%mosaic) then
    d3prim => dummy_prim
  else
    d3prim => dummy_prim
    weight => dummy_weight
  endif
  !
  cname = method%method
  !
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    ! Get the new mask (if any...)
    call get_maskplane(method,hmask,hdirty,lmask,llist)    
    nl = method%nlist
    !
    ! Local aliases
    if (method%imask.ge.1) then
      write(chain,'(A,I6,I6,I6,A,I2)') 'Image, Beam & Mask planes ',   &
          &      method%iplane,method%ibeam,method%imask
    else
      write(chain,'(A,I6,I6,A,I2)') 'Image & Beam planes ',   &
          &      method%iplane,method%ibeam
    endif
    call map_message(seve%i,cname,chain)
    dirty => hdirty%r3d(:,:,iplane)
    resid => hresid%r3d(:,:,iplane)
    clean => hclean%r3d(:,:,iplane)
    d3beam => hbeam%r4d(:,:,:,method%ibeam)
    if (method%mosaic) d3prim => hprim%r4d(:,:,:,method%ibeam)
    !
    ! Initialize to Dirty map
    resid = dirty
    if (method%pcycle) call init_plot (method,hdirty,resid)
    !
    ! Prepare beam parameters - subroutine is not Thread safe though...
    call method%fit_beam(hbeam,d3beam,error)
    if (error) then
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    call get_beam (method,hbeam,hresid,hprim,   &
        &        tfbeam,w_work,w_fft,fhat,error, lmask)
    ! Empty beam case
    if (error) then
      error = .false.
      clean = resid
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    !
    ! Mosaic case
    if (method%mosaic) then
      ! Reset search list as the mask may have been altered
      call lmask_to_list (lmask,nx*ny,llist,method%nlist)
      weight=> method%weight(:,:,method%ibeam)
      resid = resid * weight
    endif
    !
    !
    ! Performs decomposition into components
    select case (method%method)
    case('HOGBOM')
      call hogbom_cycle (cname,method%pflux,   &   ! Plot flux
           &        d3beam,mx,my,   & ! Beam and size
           &        resid,nx,ny,   & ! Residual and size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%box, method%fres, method%ares,   &
           &        method%m_iter,  method%p_iter, method%n_iter,   &
           &        method%gain, method%keep,   &    !
           &        tcc,   &         ! Component Structure
           &        lmask,   & ! Search mask
           &        llist,   & ! Search list
           &        nl,   &          ! and its size
           &        np,   &          ! Number of fields
           &        d3prim,   &       ! Primary beams
           &        weight,   &      ! Weight
           &        method%trunca, flux, jcode, next_flux)
    case('CLARK')
      !
      ! Find components
      call major_cycle (cname,method,hclean,   &   !
           &        clean,   &       ! Final CLEAN image
           &        d3beam,   &       ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        tcc,   &         ! Component table
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot,        & ! Plotting routine
           &        next_flux)
    case('SDI')
      !
      ! Find components
      call major_sdi (cname,method,hclean,   &
           &        clean,   &       ! Final CLEAN image
           &        d3beam(:,:,method%ibeam),   & ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        w_cct,   &       ! Clean Component Image
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot)          ! Plotting routine
    case('MULTI')
      !
      ! Performs decomposition into components
      call amaxmask (resid,lmask,nx,ny,ix,iy)
      limit = max(method%ares,method%fres*abs(resid(ix,iy)))
      call map_message(seve%i,method%method,chain)
      if (limit.eq.method%ares) then
        write (chain,'(A,1PG10.3,A)')  'Cleaning down to ',limit,' from ARES'
      else
        write (chain,'(A,1PG10.3,A,I7,I7)')  'Cleaning down to ',limit,' from FRES at ',ix,iy
      endif
      call map_message(seve%i,cname,chain)
      !
      call major_multi (cname,method,hclean,   &
           &        hdirty%r3d(:,:,iplane),   &
           &        hresid%r3d(:,:,iplane),   &
           &        hbeam%r4d(:,:,:,method%ibeam),                  &
           &        lmask,              & ! Check definition of this mask...
           &        hclean%r3d(:,:,iplane),   &
           &        nx,ny,                    &
           &        tcc,   &         ! Clean component
           &        method%m_iter,   &   ! Maximum number of components
           &        limit,   &       ! Residual
           &        method%n_iter,   &   ! Number of components
           &        s_mask,   &      ! Smoothed mask
           &        s_resi,   &      ! Smoothed residual,
           &        t_beam,   &      ! Translated beam
           &        w_work,   &      ! Complex work space
           &        s_beam,   &      ! Smoothed beams
           &        tfbeam,   &      ! Beam Fourier Transform (real)
           &        w_fft)
    ! Need to add
    !             &        np,   &          ! Number of fields
    !             &        d3prim,   &      ! Primary beams
    !             &        weight)          ! Weight
      w_cct(:,:) = clean
    end select
    !
    ! Add clean components and residuals to produce clean map
    if (method%n_iter.ne.0) then
      call clean_make (method, hclean, clean, tcc)
      if (np.le.1) then
        clean = clean + resid
      else
        clean = clean + resid*weight
        where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
      endif
    else
      if (np.le.1) then
        clean = resid
      else
        clean = resid*weight
      endif
    endif
    !
    ! Put the TCC structure into its final place
    if (method%method.eq.'MULTI' .or. method%method.eq.'SDI') then
      if (method%method.eq.'MULTI') then
        m_iter = method%ninflate*method%m_iter
      else
        m_iter = method%m_iter
      endif
      where (w_cct.ne.0)
        mymask = 1
      elsewhere
        mymask = 0
      end where
      f_iter = sum(mymask)
      if (f_iter.gt.m_iter) then
        write(chain,'(A,I8,A,I8)') 'Iterations overflow ',f_iter, &
            &  ' > ',m_iter
        call map_message(seve%w,cname,chain)
        dcct(3,iplane,1) = 0
        chain = 'UV_RESTORE will not work, consider increasing INFLATE'
        call map_message(seve%i,cname,chain)
      else
        i = 0
        flux = 0
        do iy=1,ny
          do ix=1,nx
            if (w_cct(ix,iy).ne.0) then
              i = i+1
              dcct(1,iplane,i) = (dble(ix) -   &
               & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
               & hclean%gil%convert(2,1)
              dcct(2,iplane,i) = (dble(iy) -   &
               & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
               & hclean%gil%convert(2,2)
              dcct(3,iplane,i) = w_cct(ix,iy)
              flux = flux+w_cct(ix,iy)
            endif
          enddo
        enddo
        method%n_iter = i
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
            &        ' Jy with ',method%n_iter,' components ' &
            &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
    else if (method%method.ne.'MRC') then
      do i=1,method%n_iter
        dcct(1,iplane,i) = (dble(tcc(i)%ix) -   &
            & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
            & hclean%gil%convert(2,1)
        dcct(2,iplane,i) = (dble(tcc(i)%iy) -   &
            & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
            & hclean%gil%convert(2,2)
        dcct(3,iplane,i) = tcc(i)%value
      enddo
      if (method%n_iter.lt.method%m_iter) then
        dcct(3,iplane,method%n_iter+1) = 0
      endif
      if (method%method.eq.'HOGBOM') then
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
          &        ' Jy with ',method%n_iter,' components ' &
          &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
      !
    endif
  enddo
  !
  ! PHAT
  if (method%phat.ne.0) then
    fhat = 1.0/fhat
    if (method%mosaic) then
      d3beam = d3beam*fhat
      do ip=1,np
        d3beam(method%beam0(1),method%beam0(2),ip) =   &
            &          d3beam(method%beam0(1),method%beam0(2),ip) -   &
            &          method%phat
      enddo
    else
      d3beam = d3beam*fhat
    endif
  endif
  !
  ! Set the blanking value for Mosaics
  if (method%mosaic) then
    hclean%gil%eval = 0
  endif
  !
  ! Clean work space: in principle, Fortran 95 does it for you
  if (method%method.eq.'CLARK') then
    deallocate(w_comp,stat=ier)
  elseif  (method%method.eq.'SDI') then
    deallocate(w_comp,w_cct,mymask)
  elseif  (method%method.eq.'MULTI') then
    deallocate (s_mask,s_resi,t_beam,s_beam,w_cct,mymask)
  endif
  if (do_fft) then
    deallocate(w_work,w_fft)
  endif
  !
end subroutine sub_major_lin

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_primitive_opt
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_primitive_arg
  use cubetools_terminal_tool
  !
  public :: primitive_opt_t,opti_k,narg_k,strg_quest
  public :: cubetools_primitive_opt_ptr
  !
  private
  !
  integer(kind=code_k), parameter :: help_src_unkn=0  ! Unknown
  integer(kind=code_k), parameter :: help_src_none=1  ! No help => look at abstract
  integer(kind=code_k), parameter :: help_src_strg=2  ! From string
  integer(kind=code_k), parameter :: help_src_file=3  ! From file
  !
  integer(kind=4), parameter :: opti_k = 4
  integer(kind=4), parameter :: opti_l = 16
  integer(kind=4), parameter :: abst_l = 80
  integer(kind=4), parameter :: synt_l = 60
  !
  character(len=*), parameter :: strg_quest = '?' ! Short help
  !
  type, extends(list_object_t) :: primitive_opt_t
     integer(kind=opti_k)          :: inum     = code_abs  ! Option number in command
     character(len=opti_l)         :: name     = strg_unk
     character(len=synt_l)         :: syntax   = strg_emp
     character(len=abst_l)         :: abstract = strg_emp  ! One-line abstract help
     integer(kind=code_k)          :: help_src = help_src_unkn
     character(len=:), allocatable :: help_strg            ! Long/multiline help OR
     character(len=file_l)         :: help_file            ! File name for help
     integer(kind=narg_k)          :: nargmin  = code_abs
     integer(kind=narg_k)          :: nargmax  = code_abs
     type(list_t)                  :: arg                  ! List of arguments to the option
     procedure(opt_check_interface),          pointer :: check => null()
     procedure(opt_build_syntax_interface),   pointer :: build_syntax => null()
     procedure(opt_print_abstract_interface), pointer :: print_abstract => null()
   contains
     ! Parsing
     procedure :: getnarg      => cubetools_option_getnarg
     procedure :: present      => cubetools_option_present
     procedure, private :: traphelp  => cubetools_option_traphelp
     procedure, private :: getarg_i4 => cubetools_option_getarg_i4
     procedure, private :: getarg_i8 => cubetools_option_getarg_i8
     procedure, private :: getarg_r4 => cubetools_option_getarg_r4
     procedure, private :: getarg_r8 => cubetools_option_getarg_r8
     procedure, private :: getarg_st => cubetools_option_getarg_st
     generic   :: getarg       => getarg_i4, getarg_i8, getarg_r4, getarg_r8, getarg_st
     !
     ! General
     procedure :: init  => cubetools_option_init
     procedure :: final => cubetools_option_final
     procedure :: free  => cubetools_option_free
     !
     ! Registering
     procedure :: put          => cubetools_option_put
     !
     ! Listing and Help
     procedure :: list           => cubetools_option_list
     procedure :: help           => cubetools_option_help
     procedure :: summary        => cubetools_option_summary
     procedure :: show_syntax    => cubetools_option_show_syntax
     procedure :: help_iterate   => cubetools_option_help_iterate
     procedure, private :: print_syntax    => cubetools_option_print_syntax
     procedure, private :: print_help_strg => cubetools_option_print_help_strg
     procedure, private :: print_help_file => cubetools_option_print_help_file
  end type primitive_opt_t
  !
  abstract interface
    subroutine opt_check_interface(opt,command,line,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      character(len=*),       intent(in)    :: command
      character(len=*),       intent(in)    :: line
      logical,                intent(inout) :: error
    end subroutine opt_check_interface
    subroutine opt_build_syntax_interface(opt,syntax,lprint,lnoprint,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      character(len=*),       intent(out)   :: syntax
      integer(kind=4),        intent(out)   :: lprint
      integer(kind=4),        intent(out)   :: lnoprint
      logical,                intent(inout) :: error
    end subroutine opt_build_syntax_interface
    subroutine opt_print_abstract_interface(opt,error)
      import primitive_opt_t
      class(primitive_opt_t), intent(in)    :: opt
      logical,                intent(inout) :: error
    end subroutine opt_print_abstract_interface
  end interface
  !
contains
  !
  !---Parsing-utilities--------------------------------------------------
  !
  function cubetools_option_getnarg(opt)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Returns number of arguments given to option
    !-------------------------------------------------------------------
    integer(kind=narg_k) :: cubetools_option_getnarg
    class(primitive_opt_t), intent(in) :: opt
    !
    cubetools_option_getnarg = sic_narg(opt%inum)
  end function cubetools_option_getnarg
  !
  subroutine cubetools_option_present(opt,line,present,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Returns if option is present.
    ! If the option has a question mark (?) argument, show the either
    ! the option or the argument help.
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    logical,                intent(out)   :: present
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc,narg
    character(len=1) :: arg1
    character(len=argu_l) :: arg
    character(len=*), parameter :: rname='OPTION>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    present = sic_present(opt%inum,icomm)
    if (.not.present)  return
    !
    ! Trap ? on last argument
    narg = opt%getnarg()
    if (narg.le.0)  return  ! No argument present
    !
    if (sic_len(opt%inum,narg).ne.1)  return  ! Argument can not be ?
    !
    call sic_ch(line,opt%inum,narg,arg1,nc,mandatory,error)
    if (error) return
    if (arg1.ne.strg_quest)  return  ! Not a question mark
    !
    if (narg.eq.1) then
      ! Question mark follows the option: show help summary
      call opt%summary(error)
      if (error) return
    else
      ! Question mark follows an argument: show its full summary
      call sic_ke(line,opt%inum,narg-1,arg,nc,mandatory,error)
      if (error) return
      call cubetools_option_help_onearg(opt,arg(1:nc),error)
      if (error) return
    endif
    !
    ! Raise error to ensure the whole calling cascade is exited.
    error = .true.
    return
  end subroutine cubetools_option_present
  !
  subroutine cubetools_option_traphelp(opt,line,iarg,argum,nc,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Get the iarg-th argument (as a string) of the option from the command
    ! line. If the argument is a question mark (?), show the option help.
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(out)   :: argum
    integer(kind=4),        intent(out)   :: nc
    logical,                intent(inout) :: error
    !
    logical :: obligatory
    type(primitive_arg_t), pointer :: parg
    character(len=*), parameter :: rname='GET>ARG>TRAP>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
    obligatory = parg%mandatory.eq.code_arg_mandatory.or.parg%mandatory.eq.code_arg_optional
    call sic_ch(line,opt%inum,iarg,argum,nc,obligatory,error)
    if (error) return
    if (argum.eq.strg_quest) then
       call opt%summary(error)
       if (error) return
       error = .true.
       return
    endif
  end subroutine cubetools_option_traphelp
  !
  subroutine cubetools_option_getarg_i4(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=4),        intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I4'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_inte(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_i4
  !
  subroutine cubetools_option_getarg_i8(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    integer(kind=8),        intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_long(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_i8
  !
  subroutine cubetools_option_getarg_r4(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=4),           intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_real(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_r4
  !
  subroutine cubetools_option_getarg_r8(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    real(kind=8),           intent(inout) :: value
    logical,                intent(inout) :: error
    !
    character(len=base_l) :: argum
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>I8'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,argum,nc,error)
    if (error) return
    call sic_math_dble(argum,nc,value,error)
    if (error) then
       error = .false.
       call opt%show_syntax(error)
       error = .true.
       return
    endif
  end subroutine cubetools_option_getarg_r8
  !
  subroutine cubetools_option_getarg_st(opt,line,iarg,value,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    integer(kind=argu_k),   intent(in)    :: iarg
    character(len=*),       intent(inout) :: value
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: nc
    character(len=*), parameter :: rname='GET>ARG>ST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%traphelp(line,iarg,value,nc,error)
    if (error) return
  end subroutine cubetools_option_getarg_st
  !
  !---General-routines-----------------------------------------------------
  !
  subroutine cubetools_option_init(opt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(out)   :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_option_init
  !
  subroutine cubetools_option_final(obj,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: obj
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_option_free(obj,error)
    if (error) return
  end subroutine cubetools_option_final
  !
  function cubetools_primitive_opt_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(primitive_opt_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(primitive_opt_t), pointer :: cubetools_primitive_opt_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRIMITIVE>OPT>PTR'
    !
    select type(tot)
    class is (primitive_opt_t)
      cubetools_primitive_opt_ptr => tot
    class default
      cubetools_primitive_opt_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a primitive_opt_t type')
      error = .true.
      return
    end select
  end function cubetools_primitive_opt_ptr
  !
  subroutine cubetools_option_free(opt,error)
    !----------------------------------------------------------------------
    ! Free the contents of an 'primitive_opt_t'
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>FREE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%arg%final(error)
    if (error) return
  end subroutine cubetools_option_free
  !
  !---Registering----------------------------------------------------------
  !
  subroutine cubetools_option_put(opt,inum,name,syntax,abstract,help,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(inout) :: opt
    integer(kind=opti_k),   intent(in)    :: inum
    character(len=*),       intent(in)    :: name
    character(len=*),       intent(in)    :: syntax
    character(len=*),       intent(in)    :: abstract
    character(len=*),       intent(in)    :: help
    logical,                intent(inout) :: error
    !
    character(len=file_l) :: filename
    character(len=*), parameter :: rname='OPTION>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_option_final(opt,error)
    if (error) return
    call cubetools_option_init(opt,error)
    if (error) return
    !
    opt%inum     = inum
    opt%name     = name
    opt%syntax   = syntax
    opt%abstract = abstract
    if (help.eq.strg_emp) then
      opt%help_src = help_src_none
    else
      call sic_parse_file(help,'','',filename)
      if (gag_inquire(filename,len_trim(filename)).eq.0) then
         opt%help_src = help_src_file
         opt%help_file = filename
      else
         opt%help_src = help_src_strg
         opt%help_strg = help
      endif
    endif
    opt%nargmin  = 0
    opt%nargmax  = 0
  end subroutine cubetools_option_put
  !
  !---Listing-and-Help---------------------------------------------------
  !
  subroutine cubetools_option_print_syntax(opt,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: width,nmess,lprint,lnoprint
    character(len=mess_l) :: mess,key
    character(len=synt_l) :: optsyntax
    character(len=*), parameter :: rname='OPTION>PRINT>SYNTAX'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = ''
    nmess = 0
    width = terminal%width()
    key = 'Syntax'
    call opt%build_syntax(optsyntax,lprint,lnoprint,error)
    if (error)  return
    width = width+lnoprint
    mess = '  '//cubetools_format_stdkey_stdval(key,optsyntax,width)
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_option_print_syntax
  !
  subroutine cubetools_option_list(opt,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=narg_k) :: iarg
    class(primitive_arg_t), pointer :: arg
    character(len=*), parameter :: rname='OPTION>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (opt%arg%n.le.0) return
    !
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    write(mess,'(a)') '  Arguments'
    call cubesyntax_message(syntaxseve%help,rname,mess)
    do iarg=1,opt%arg%n
       arg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
       if (error) return
       call arg%print_abstract(iarg,error)
       if (error) return
    enddo !iarg
  end subroutine cubetools_option_list
  !
  subroutine cubetools_option_help(opt,error)
    !-------------------------------------------------------------------
    ! Print option help
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    select case (opt%help_src)
    case (help_src_none)
      ! Only abstract is available
      return
    case (help_src_strg)
      call opt%print_help_strg(error)
      if (error) return
    case (help_src_file)
      call opt%print_help_file(error)
      if (error) return
    case default
      call cubesyntax_message(seve%e,rname,'Unexpected help source')
      error = .true.
      return
    end select
    !
  end subroutine cubetools_option_help
  !
  subroutine cubetools_option_print_help_strg(opt,error)
    !-------------------------------------------------------------------
    ! Print option help from opt%help_strg
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PRINT>HELP>STRG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    if (.not.allocated(opt%help_strg)) return
    if (len_trim(opt%help_strg).le.0) return
    if (opt%help_strg.eq.strg_emp) return
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call terminal%print_strg(syntaxseve%help,opt%help_strg)
  end subroutine cubetools_option_print_help_strg
  !
  subroutine cubetools_option_print_help_file(opt,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Print option help from file opt%help_file
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PRINT>HELP>FILE'
    character(len=256) :: line
    integer(kind=4) :: ier,ilun
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    !
    ier = sic_getlun(ilun)
    if (ier.ne.1) then
      call cubesyntax_message(seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    ier = sic_open(ilun,opt%help_file,'OLD',.true.)
    if (ier.ne.0) then
      call cubesyntax_message(seve%e,rname,'Cannot open '//opt%help_file)
      call putios('E-OPTION>HELP>FILE,  ',ier)
      error = .true.
      return
    endif
    do while (.true.)
      read(ilun,'(A)',end=40,err=50) line
      if (line.eq.'ENDOFHELP')  goto 40
      call cubesyntax_message(syntaxseve%help,rname,line)
    enddo
    !
    ! Error
50  call cubesyntax_message(seve%e,rname,'Error reading '//opt%help_file)
    error = .true.
    !
    ! Error and success
40  ier = sic_close(ilun)
    call sic_frelun(ilun)
  end subroutine cubetools_option_print_help_file
  !
  subroutine cubetools_option_summary(opt,error)
    !-------------------------------------------------------------------
    ! Short option summary
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>SUMMARY'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%print_syntax(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call opt%print_abstract(error)
    if (error) return
    call opt%help(error)
    if (error) return
    call opt%list(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_option_summary
  !
  subroutine cubetools_option_show_syntax(opt,error)
    !-------------------------------------------------------------------
    ! Short option syntax reminder
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>SHOW>SYNTAX'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%print_syntax(error)
    call opt%list(error)
    call cubesyntax_message(syntaxseve%help,rname,'')
  end subroutine cubetools_option_show_syntax
  !
  subroutine cubetools_option_help_onearg(opt,arg,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Disambiguate and show the help for one argument of the option
    ! (among all the other arguments). Might show the option help as
    ! fallback.
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: arg
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: iarg,ikey
    character(len=argu_l) :: solved
    class(primitive_arg_t), pointer :: parg
    character(len=argu_l), allocatable :: arglist(:)
    character(len=*), parameter :: rname='OPTION>PRESENT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Build the list of argument names
    allocate(arglist(opt%arg%n))
    do iarg=1,opt%arg%n
      parg => cubetools_primitive_arg_ptr(opt%arg%list(iarg)%p,error)
      if (error) return
      arglist(iarg) = parg%name
    enddo
    !
    ! Identify and show help
    call cubetools_disambiguate_flexible(arg,arglist,ikey,solved,error)
    if (error) return
    if (ikey.eq.code_unresolved) then
      ! Not a known argument
      call cubesyntax_message(seve%w,rname,  &
        'Unrecognized argument '//arg//'. Possible arguments are:')
      call opt%list(error)
      if (error) return
    else
      ! Show argument help summary
      parg => cubetools_primitive_arg_ptr(opt%arg%list(ikey)%p,error)
      call parg%summary(error)
      if (error) return
    endif
  end subroutine cubetools_option_help_onearg
  !
  subroutine cubetools_option_help_iterate(opt,forma,langname,commname,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    integer(kind=code_k),   intent(in)    :: forma
    character(len=*),       intent(in)    :: langname
    character(len=*),       intent(in)    :: commname
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP>ITERATE'
    !
    select case (forma)
    case (help_format_tex)
      call cubetools_option_help_iterate_tex(opt,langname,commname,error)
      if (error)  return
    case default
      call cubesyntax_message(seve%e,rname,'Help format not implemented')
      error = .true.
      return
    end select
  end subroutine cubetools_option_help_iterate
  !
  subroutine cubetools_option_help_iterate_tex(opt,langname,commname,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: langname
    character(len=*),       intent(in)    :: commname
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>HELP>ITERATE>TEX'
    !
    call cubesyntax_message(syntaxseve%help,rname,'\subsubsection{'//trim(commname)//' /'//trim(opt%name)//'}')
    call cubesyntax_message(syntaxseve%help,rname,'\label{sec:'//trim(langname)//':'//trim(commname)//&
         ':'//trim(opt%name)//':help}')
    call cubesyntax_message(syntaxseve%help,rname,'\index{'//trim(langname)//' '//trim(commname)//&
         ' /'//trim(opt%name)//' option}')
    !
    call cubesyntax_message(syntaxseve%help,rname,'\begin{PlusVerbatim}')
    call opt%summary(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,'\end{PlusVerbatim}')
  end subroutine cubetools_option_help_iterate_tex
  !
end module cubetools_primitive_opt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
subroutine t_uvsort (np,nv,vin,vout,inxy,incs,uvmax,uvmin,sort,error)
  use gildas_def 
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces
  use uv_rotate_shift_and_sort_tool, only: loaduv,sortuv,chksuv
  !----------------------------------------------------------------------
  ! UV_MAP
  !     Rotate, Shift and Sort a UV table for map making
  !     Differential precession should have been applied before.
  !----------------------------------------------------------------------
  !
  integer, intent(in) :: np                   ! Size of a visibility
  integer, intent(in) :: nv                   ! Number of visibilities
  real, intent(in) :: vin(np,nv)              ! Input visibilities
  real, intent(out) :: vout(np,nv)            ! Output visibilities
  real(8), intent(in) :: inxy(2)              ! Phase shift
  real(8), intent(in) :: incs(2)              ! Frame Rotation
  real, intent(out) :: uvmax                  ! Max UV value
  real, intent(out) :: uvmin                  ! Min UV value
  logical, intent(inout) :: sort              ! Data has been sorted
  logical, intent(out) :: error
  !
  logical, allocatable :: suv(:) ! Sign
  real, allocatable :: uuv(:) ! U
  real, allocatable :: vuv(:) ! V
  integer, allocatable :: iuv(:) ! Index
  !
  integer ier 
  logical sorted
  real(4) :: xy(2)                   ! Real*4 Phase shift for SortUV
  real(4) :: cs(2)                   ! Real*4 Frame Rotation for LoadUV
  !
  sorted = .false.
  xy = inxy
  cs = incs
  !
  ! Load U,V coordinates, applying possible rotation (CS), and
  ! making all V negative
  allocate (suv(nv),uuv(nv),vuv(nv),iuv(nv),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  call loaduv (vin,np,nv,cs,uuv,vuv,suv,uvmax,uvmin)
  !
  ! Sort if needed
  call chksuv (nv,vuv,iuv,sorted)
  if (.not.sorted) then
     sort = .true.
     call gr4_trie (vuv,iuv,nv,error)
     if (error) return
  endif
  !
  ! Apply phase shift and copy to output visibilities
  call sortuv (vin,vout,np,nv,0,xy,uuv,vuv,suv,iuv) 
  !
  deallocate(suv,uuv,vuv,iuv)
end subroutine t_uvsort

  

	subroutine findmax (image,nimage,imax,npts,points,badpts,
     &    rms,sum)
	integer(kind=4), intent(in) :: nimage
	real*4    image(nimage),points(3,nimage)
	integer*2 badpts (nimage)
	real*4    max,min

	max=-1.e30
	min=1.e30
	sum=0.

	do 1 i=1,npts
	if (max.lt.image(i) .and. badpts(i).ne.1) then
	 imax=i
	 max=image(i)
	endif
	if (min.gt.image(i)) then
	 imin=i
	 min=image(i)
	endif
	sum=sum+image(i)
1	continue

	write (2,*) 'I-FINDMAX, maximum found at ',
     &    points(1,imax),points(2,imax),points(3,imax),' ',max*rms
	write (2,*) 'I-FINDMAX, minimum found at ',
     &    points(1,imin),points(2,imin),points(3,imin),' ',min*rms
	write (2,*) 'I-FINDMAX, integral ',sum*rms
	write (6,*) 'I-FINDMAX, integral ',sum*rms

	return
	end

module cubeadm_taskloop_iteration
  use cubetools_parameters
  !
  ! Description of one task iteration
  type taskloop_iteration_t
    integer(kind=entr_k) :: num         ! This task number
    integer(kind=entr_k) :: ie          ! The entry number iterated in this task
    integer(kind=data_k) :: firstdata   ! First data  to be processed
    integer(kind=data_k) :: lastdata    ! Last  data  to be processed
    integer(kind=entr_k) :: firstplane  ! First plane to be processed
    integer(kind=entr_k) :: lastplane   ! Last  plane to be processed
    integer(kind=entr_k) :: first       ! First entry to be processed (kept for backward compatibility)
    integer(kind=entr_k) :: last        ! Last  entry to be processed (kept for backward compatibility)
  end type taskloop_iteration_t
  !
  public :: taskloop_iteration_t
  private
  !
end module cubeadm_taskloop_iteration

subroutine mrtcal_find_comm(line,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_find_comm
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command:
  !   MFIND
  ! Read the index file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  !
  mfound = 0
  !
  call mrtindex_find_comm(line,ix,cx,error)
  if (error)  return
  !
  mfound = cx%next-1
  kcurr_cx = 0  ! For READ ZERO|FIRST|LAST|NEXT|PREV
  kcurr_ix = 0
  !
  call sic_def_long('mdx%curr',kcurr_cx,0,1,.false.,error)
  !
end subroutine mrtcal_find_comm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_snr
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: snr
  private
  !
  type :: snr_comm_t
     type(option_t), pointer :: comm
     type(cubeid_arg_t), pointer :: sig
     type(cubeid_arg_t), pointer :: noi
     type(cube_prod_t),  pointer :: snr
   contains
     procedure, public  :: register => cubemain_snr_comm_register
     procedure, private :: parse    => cubemain_snr_comm_parse
     procedure, private :: main     => cubemain_snr_comm_main
  end type snr_comm_t
  type(snr_comm_t) :: snr
  !
  type snr_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubemain_snr_user_toprog
  end type snr_user_t
  !
  type snr_prog_t
     type(cube_t), pointer :: sig
     type(cube_t), pointer :: noi
     type(cube_t), pointer :: snr
     procedure(cubemain_snr_prog_singlenoise_loop), pointer :: loop => null()
   contains
     procedure, private :: header          => cubemain_snr_prog_header
     procedure, private :: data            => cubemain_snr_prog_data
     procedure, private :: singlenoise_act => cubemain_snr_prog_singlenoise_act
     procedure, private :: multinoise_act  => cubemain_snr_prog_multinoise_act
  end type snr_prog_t
  !
contains
  !
  subroutine cubemain_snr_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(snr_user_t) :: user
    character(len=*), parameter :: rname='SNR>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call snr%parse(line,user,error)
    if (error) return
    call snr%main(user,error)
    if (error) continue
  end subroutine cubemain_snr_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(inout) :: comm
    logical,           intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='SNR>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'SNR','[signalid [noiseid]]',&
         'Compute the signal to noise ratio',&
         'SNR divides SIGNALID by NOISEID to produce an SNR cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- If NOISEID has one channel, that single value is used for&
         & all SIGNALID channels.'//strg_cr//&
         '- If NOISEID has multiple channels, it is interpolated on the&
         & SIGNALID spectral axis before division.',&
         cubemain_snr_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_speset,&
         comm%sig,&
        error)
    if (error) return
    call incube%register(&
         'NOISEID',&
         'Noise cube identifier',&
         'If omitted, use the last matching cube (noise flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_noise],&
         code_read,&
         code_access_speset,&
         comm%noi,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'SNR',&
         'Cube of Signal-to-Noise Ratios',&
         strg_emp,&
         [flag_snr],&
         comm%snr,&
         error)
    if (error) return
  end subroutine cubemain_snr_comm_register
  !
  subroutine cubemain_snr_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! SNR [signalid [noiseid]]
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(in)    :: comm
    character(len=*),  intent(in)    :: line
    type(snr_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubemain_snr_comm_parse
  !
  subroutine cubemain_snr_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_comm_t), intent(in)    :: comm
    type(snr_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(snr_prog_t) :: prog
    character(len=*), parameter :: rname='SNR>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_snr_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_user_t), intent(in)    :: user
    type(snr_comm_t),  intent(in)    :: comm
    type(snr_prog_t),  intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    logical :: conspb
    integer(kind=chan_k) :: nnoi
    character(len=*), parameter :: rname='SNR>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !    
    call cubeadm_get_header(comm%sig,user%cubeids,prog%sig,error)
    if (error) return
    call cubeadm_get_header(comm%noi,user%cubeids,prog%noi,error)
    if (error) return
    !
    conspb = .false.
    call cubetools_consistency_signal_noise(&
         'Input cube',prog%sig%head,&
         'Noise',prog%noi%head,&
         conspb,error)
    if (error) return
    if (cubetools_consistency_failed(rname,conspb,error)) return
    !
    call cubetools_header_get_nchan(prog%noi%head,nnoi,error)
    if (error) return
    if (nnoi.eq.1) then
       prog%loop => cubemain_snr_prog_singlenoise_loop
    else
       prog%loop => cubemain_snr_prog_multinoise_loop
    endif
  end subroutine cubemain_snr_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_snr_prog_header(prog,comm,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(snr_prog_t), intent(inout) :: prog
    class(snr_comm_t), intent(in)    :: comm
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%snr,prog%sig,prog%snr,error)
    if (error) return
    call cubetools_header_put_array_unit('---',prog%snr%head,error)
    if (error) return
  end subroutine cubemain_snr_prog_header
  !
  subroutine cubemain_snr_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='SNR>PROG>DATA'
    type(cubeadm_iterator_t) :: iter
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          call prog%loop(iter,error)
       endif
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_snr_prog_data
  !
  subroutine cubemain_snr_prog_singlenoise_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: sig,noi,snr
    character(len=*), parameter :: rname='SNR>PROG>SINGLENOISE>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    ! 
    call sig%associate('sig',prog%sig,iter,error)
    if (error) return
    call noi%associate('noi',prog%noi,iter,error)
    if (error) return
    call snr%allocate('snr',prog%snr,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%singlenoise_act(iter%ie,sig,noi,snr,error)
      if (error) return
    enddo ! iter
  end subroutine cubemain_snr_prog_singlenoise_loop
  !
  subroutine cubemain_snr_prog_singlenoise_act(prog,ie,sig,noi,snr,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),    intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: sig
    type(spectrum_t),     intent(inout) :: noi
    type(spectrum_t),     intent(inout) :: snr
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=sign_k), pointer :: noise
    character(len=*), parameter :: rname='SNR>PROG>SINGLENOISE>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%get(ie,error)
    if (error) return
    call noi%get(ie,error)
    if (error) return
    noise => noi%y%val(1)
    if ((noise.gt.0).and.(.not.ieee_is_nan(noise))) then
       do ic=1,snr%n
          if (.not.ieee_is_nan(sig%y%val(ic))) then
             snr%y%val(ic) = sig%y%val(ic)/noise
          else
             snr%y%val(ic) = gr4nan 
          endif
       enddo ! ic
    else
       snr%y%val(:) = gr4nan
    endif
    call snr%put(ie,error)
    if (error) return
  end subroutine cubemain_snr_prog_singlenoise_act
  !
  subroutine cubemain_snr_prog_multinoise_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    use cubemain_interpolate_spectrum_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),        intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: sig,rawnoi,intnoi,snr
    type(interpolate_spectrum_prog_t) :: interp
    character(len=*), parameter :: rname='SNR>PROG>MULTINOISE>LOOP'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%associate('sig',prog%sig,iter,error)
    if (error) return
    call intnoi%allocate('intnoi',prog%sig,iter,error)
    if (error) return
    call intnoi%get_header(error)
    if (error) return
    call rawnoi%associate('rawnoi',prog%noi,iter,error)
    if (error) return
    call rawnoi%get_header(error)
    if (error) return
    call snr%allocate('snr',prog%snr,iter,error)
    if (error) return
    call interp%init(rawnoi,intnoi,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%multinoise_act(iter%ie,sig,rawnoi,intnoi,snr,interp,error)
       if (error) return
    enddo ! iter
  end subroutine cubemain_snr_prog_multinoise_loop
  !
  subroutine cubemain_snr_prog_multinoise_act(prog,ie,sig,rawnoi,intnoi,snr,interp,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    use cubemain_interpolate_spectrum_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(snr_prog_t),                 intent(inout) :: prog
    integer(kind=entr_k),              intent(in)    :: ie
    type(spectrum_t),                  intent(inout) :: sig
    type(spectrum_t),                  intent(inout) :: rawnoi
    type(spectrum_t),                  intent(inout) :: intnoi
    type(spectrum_t),                  intent(inout) :: snr
    type(interpolate_spectrum_prog_t), intent(in)    :: interp
    logical,                           intent(inout) :: error
    !
    integer(kind=chan_k) :: ic
    real(kind=sign_k), pointer :: noise
    character(len=*), parameter :: rname='SNR>PROG>MULTINOISE>ACT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call sig%get(ie,error)
    if (error) return
    call rawnoi%get(ie,error)
    if (error) return
    snr%y%val(:) = gr4nan
    if (rawnoi%y%isblanked()) then
       ! Nothing to do
    else
       call interp%spectrum(rawnoi,intnoi,error)
       if (error) return
       do ic=1,snr%n
          noise => intnoi%y%val(ic) 
          if ((noise.gt.0).and.(.not.ieee_is_nan(noise))) then
             if (.not.ieee_is_nan(sig%y%val(ic))) then
                ! *** JP: The fact that only positive or both
                ! *** JP: positive and negative values should be considered
                ! *** JP: signal should be a user-domain decision
                snr%y%val(ic) = sig%y%val(ic)/noise
             endif
          endif
       enddo ! ic
    endif
    call snr%put(ie,error)
    if (error) return
  end subroutine cubemain_snr_prog_multinoise_act
end module cubemain_snr
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program main_map_expand
  use gbl_format
  use gkernel_interfaces
  !
  logical error
  !
  error = .false.
  call map_expand(error)
  if (error) call sysexi(fatale)
end program
!
subroutine map_expand(error)
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Expand a data cube along its TWO first dimensions, by Fourier
  !     Transform
  !---------------------------------------------------------------------
  logical, intent(out) :: error
  ! Local
  real, parameter :: eps = 2.e-7
  character(len=filename_length) :: mapin, mapout
  integer :: i,j,ier,n,nexp, ndim, dim(2)
  complex, allocatable :: ipl(:,:), ips(:,:)
  real, allocatable :: ipw(:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('INPUT_MAP$',mapin)
  call gildas_char('OUTPUT_MAP$',mapout)
  call gildas_inte('EXPAND$',nexp,1)
  call gildas_close
  !
  if (nexp.lt.2. .or. nexp.gt.8) then
    write(6,*) 'E-MAP_EXPAND,  Invalid expansion ',nexp
    error = .true.
    return
  endif
  !
  ! Input file
  n = len_trim(mapin)
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapin,'.lmv',error, data=.false.)
  if (error) then
    call gagout('F-MAP_EXPAND,  Cannot read input cube')
    error = .true.
    return
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapout,x%file,' ','.lmv')
  !
  x%gil%dim(1:2) = y%gil%dim(1:2)*nexp
  !
  allocate(ips(y%gil%dim(1),y%gil%dim(2)), ipl(x%gil%dim(1),x%gil%dim(2)), &
  & ipw(2*max(x%gil%dim(1),x%gil%dim(2))), stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  allocate(y%r2d(y%gil%dim(1),y%gil%dim(2)), x%r2d(x%gil%dim(1),x%gil%dim(2)), & 
  & stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ! Transform coordinates (1,1) ---> (1,1)
  x%gil%inc(1:2) = y%gil%inc(1:2)/nexp
  x%gil%ref(1:2) = 1.0d0
  x%gil%val(1:2) = (x%gil%ref(1:2)-y%gil%ref(1:2))*y%gil%inc(1:2)+y%gil%val(1:2)
  !
  ! Create Output file
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MAP_EXPAND,  Cannot create output image'
    error = .true.
    return
  endif
  !
  ! Use the NX/2+1 pixel as reference value for convenience
  x%gil%val(1:2)  = (x%gil%dim(1:2)/2+1.d0-x%gil%ref(1:2))*x%gil%inc(1:2) + x%gil%val(1:2)
  x%gil%ref(1:2) = x%gil%dim(1:2)/2+1.d0
  !
  !
  ! Setup FFTW
  ndim = 2
  dim(1) = x%gil%dim(1)
  dim(2) = x%gil%dim(2)
  call fourt_plan(ipl,dim,ndim,-1,0)
  dim(1) = y%gil%dim(1)
  dim(2) = y%gil%dim(2)
  call fourt_plan(ips,dim,ndim,1,1)
  !
  ! Now loop over planes
  do j = 1,x%gil%dim(4)
    y%blc(4) = j
    y%trc(4) = j  
    do i = 1,x%gil%dim(3)
      y%blc(3) = i
      y%trc(3) = i
      x%blc = y%blc
      x%trc = y%trc
      call gdf_read_data(y,y%r2d,error)
      call expand (   &
     &      x%gil%dim(1),x%gil%dim(2),x%r2d,ipl,   &
     &      y%gil%dim(1),y%gil%dim(2),y%r2d,ips,   &
     &      ipw )
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  !
  deallocate(ips,ipl,ipw,x%r2d,y%r2d,stat=ier)
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call gagout ('S-EXPAND,  Successful completion')
  error = .false.
end subroutine map_expand
!
subroutine expand (nx,ny,large,wl,mx,my,small,ws,work)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !	Expand an image through FT zero extension
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nx   ! Large X size
  integer(kind=index_length), intent(in) :: ny   ! Large Y size
  real, intent(out) :: large(nx,ny)              ! Output (expanded) image
  complex, intent(inout) :: wl(nx,ny)            ! Work array
  integer(kind=index_length), intent(in) :: mx   ! Small X size
  integer(kind=index_length), intent(in) :: my   ! Small Y size
  real, intent(in) :: small(mx,my)               ! Input (small) image
  complex, intent(inout) :: ws(mx,my)            ! Work array
  real, intent(inout) :: work(*)                 ! FFT work space
  ! Local
  integer :: j,ndim,dim(2)
  real :: fact
  !
  ws = small
  !
  ndim = 2
  dim(1) = mx
  dim(2) = my
  call fourt(ws,dim,ndim,-1,0,work)
  !
  ! Clear output FT
  wl = 0.0
  ! Load inner quarter
  do j=1,my/2
    call r4tor4 (ws(1,j),wl(1,j),mx)
    call r4tor4 (ws(mx/2+1,j),wl(1+nx-mx/2,j),mx)
  enddo
  do j=my/2+1,my
    call r4tor4 (ws(1,j),wl(1,j+ny-my),mx)
    call r4tor4 (ws(mx/2+1,j),wl(1+nx-mx/2,j+ny-my),mx)
  enddo
  dim(1) = nx
  dim(2) = ny
  call fourt (wl,dim,ndim,1,1,work)
  !
  fact = 1.0/(mx*my)
  large = real(wl)*fact
end subroutine expand

module cubeadm_verify
  use cubetools_structure
  use cubetuple_format_class
  use cubeadm_cubeid_types
  use cubeadm_messaging
  !
  public :: verify
  private
  !
  type :: verify_comm_t
    type(option_t),      pointer :: comm
    type(cubeid_arg_t),  pointer :: cube
  contains
    procedure, public  :: register => cubeadm_verify_register
    procedure, private :: parse    => cubeadm_verify_parse
    procedure, private :: main     => cubeadm_verify_main
  end type verify_comm_t
  type(verify_comm_t) :: verify
  !
  type verify_user_t
    type(cubeid_user_t)   :: cubeids
  contains
    procedure, private :: toprog => cubeadm_verify_user_toprog
  end type verify_user_t
  !
  type verify_prog_t
    class(format_t), pointer :: cube
  contains
    procedure, private :: do => cubeadm_verify_do
  end type verify_prog_t
  !
  interface cubeadm_verify_and_get
    module procedure cubeadm_verify_and_get_i4
  end interface cubeadm_verify_and_get
  !
  interface cubeadm_verify_and_compare
    module procedure cubeadm_verify_and_compare_ch
  end interface cubeadm_verify_and_compare
  !
contains
  !
  subroutine cubeadm_verify_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command VERIFY
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(verify_user_t) :: user
    character(len=*), parameter :: rname='VERIFY>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call verify%parse(line,user,error)
    if (error) return
    call verify%main(user,error)
    if (error) return
  end subroutine cubeadm_verify_command
  !
  subroutine cubeadm_verify_register(verify,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! Register ADM\VERIFY command and its options
    !-------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='VERIFY>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Command
    call cubetools_register_command(&
         'VERIFY','[cubeid]',&
         'Check whether a cube header is CUBE-conformant',&
         'Check whether the selected object satisfies current CUBE&
         & conformity checks. This commands is used in the DMS part&
         & of the Observatory Management System ( https://oms.iram.fr ).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Verification path depends on detected object kind.'//strg_cr//&
         '- For cube-like objects, fatal prerequisites stop verification and'//strg_cr//&
         '  the command execution with an error. Other checks report missing'//strg_cr//&
         '  or non-conformant metadata.'//strg_cr//&
         '- For UV tables, detailed key-by-key conformity checks are&
         & currently not implemented.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- An empty output means that the cube header is conformant.'//strg_bl//&
         'Examples:'//strg_cr//&
         '  CUBE> VERIFY'//strg_cr//&
         '  CUBE> VERIFY mycube'//strg_cr//&
         'Without argument, VERIFY checks the current object.',&
         cubeadm_verify_command,&
         verify%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         '[cubeid]',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&  ! Data not needed
         code_access_any,&
         verify%cube,&
         error)
    if (error) return
  end subroutine cubeadm_verify_register
  !
  subroutine cubeadm_verify_parse(verify,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   VERIFY CubeID
    !-------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    character(len=*),     intent(in)    :: line
    type(verify_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,verify%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeadm_verify_parse
  !
  subroutine cubeadm_verify_main(verify,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(verify_comm_t), intent(in)    :: verify
    type(verify_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(verify_prog_t) :: prog
    character(len=*), parameter :: rname='verify>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(verify,prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubeadm_verify_main
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_verify_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(verify_user_t), intent(in)    :: user
    type(verify_comm_t),  intent(in)    :: comm
    type(verify_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_get_fheader(verify%cube,user%cubeids,prog%cube,error)
    if (error) return
  end subroutine cubeadm_verify_user_toprog
  !
  subroutine cubeadm_verify_do(prog,error)
    use gkernel_types
    use cubeformats_uv
    use cube_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(verify_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>CHECK'
    !
    class(format_t), pointer :: format
    !
    format => prog%cube
    select type (format)
    type is (cube_t)
      call cubeadm_verify_check_cube(format,error)
      if (error) return
    type is (uv_t)
      call cubeadm_verify_check_uvt(format,error)
      if (error) return
    class default
      call cubeadm_message(seve%e,rname,'Unexpected file kind')
      error = .true.
      return
    end select
  end subroutine cubeadm_verify_do
  !
  subroutine cubeadm_verify_check_cube(cube,error)
    use gkernel_types
    use cubeio_dataformat_types
    use cube_types
    !-------------------------------------------------------------------
    ! Verify if a cube_t is CUBE conformant
    !-------------------------------------------------------------------
    type(cube_t), intent(in)    :: cube
    logical,      intent(inout) :: error
    !
    type(gfits_hdict_t), pointer :: hdict
    integer(kind=4) :: naxis
    character(len=*), parameter :: rname='VERIFY>CHECK>CUBE'
    !
    if (.not.cube%tuple%haskind(code_dataformat_fits)) then
      call cubeadm_message(seve%e,rname,'Cube is not a FITS file')
      error = .true.
      return
    endif
    !
    hdict => cube%tuple%current%file%hfits%dict
    !
    ! Convert information
    call cubeadm_verify_and_get(hdict,'NAXIS',naxis,error)
    if (error)  return
    if (naxis.ge.1) then
      call cubeadm_verify_one(hdict,'CTYPE1',error)
      call cubeadm_verify_one(hdict,'CRVAL1',error)
      call cubeadm_verify_one(hdict,'CDELT1',error)
      call cubeadm_verify_one(hdict,'CRPIX1',error)
    endif
    if (naxis.ge.2) then
      call cubeadm_verify_one(hdict,'CTYPE2',error)
      call cubeadm_verify_one(hdict,'CRVAL2',error)
      call cubeadm_verify_one(hdict,'CDELT2',error)
      call cubeadm_verify_one(hdict,'CRPIX2',error)
    endif
    if (naxis.ge.3) then
      call cubeadm_verify_one(hdict,'CTYPE3',error)
      call cubeadm_verify_one(hdict,'CRVAL3',error)
      call cubeadm_verify_one(hdict,'CDELT3',error)
      call cubeadm_verify_one(hdict,'CRPIX3',error)
    endif
    if (error)  return
    !
    ! Data information
    call cubeadm_verify_one(hdict,'DATAMIN', error)
    call cubeadm_verify_one(hdict,'DATAMAX', error)
    call cubeadm_verify_one(hdict,'BUNIT',   error)
   !call cubeadm_verify_one(hdict,'NOISETHE',error)  Might be absent if no value available
   !call cubeadm_verify_one(hdict,'NOISEMEA',error)  Might be absent if no value available
    if (error)  return
    !
    ! Spatial information
    call cubeadm_verify_one(hdict,'OBJECT', error)
    call cubeadm_verify_one(hdict,'RA',     error)
    call cubeadm_verify_one(hdict,'DEC',    error)
   !call cubeadm_verify_one(hdict,'RADESYS',error)  Not mandatory, because equinox could be arbitrary
    if (error)  return
    !
    ! Spectral information
    call cubeadm_verify_one(hdict,'LINE',    error)
    call cubeadm_verify_one(hdict,'RESTFREQ',error)
    call cubeadm_verify_one(hdict,'VELREF',  error)
   !call cubeadm_verify_one(hdict,'SPECSYS', error)  Redundant with VELREF but less information
   !call cubeadm_verify_one(hdict,'VELO-XXX',error)  Suffix depends on spectral frame (VELREF)
    call cubeadm_verify_one(hdict,'FREQRESO',error)  ! or WAVERESO depends on spectral kind
    if (error)  return
    !
    ! Resolution information
    call cubeadm_verify_one(hdict,'BMAJ',error)
    call cubeadm_verify_one(hdict,'BMIN',error)
    call cubeadm_verify_one(hdict,'BPA', error)
    if (error)  return
    !
    ! Misc
    call cubeadm_verify_one(hdict,'TELESCOP',error)
    if (error)  return
    !
    ! Origin
    call cubeadm_verify_and_compare(hdict,'ORIGIN','GILDAS CUBE',error)
    if (error)  return
  end subroutine cubeadm_verify_check_cube
  !
  subroutine cubeadm_verify_and_get_i4(hdict,key,value,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present and get its value (error if absent)
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    integer(kind=4),     intent(out)   :: value
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=*), parameter :: rname='VERIFY>AND>GET'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found) then
      call cubeadm_message(seve%e,rname,'Missing key '''//trim(key)//''', can not verify more')
      error = .true.
      return
    endif
  end subroutine cubeadm_verify_and_get_i4
  !
  subroutine cubeadm_verify_and_compare_ch(hdict,key,expected,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present and if its value is as expected
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    character(len=*),    intent(in)    :: expected
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=char0d_length) :: value
    character(len=*), parameter :: rname='VERIFY>AND>COMPARE'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found) then
      call cubeadm_message(seve%w,rname,'Missing key '''//trim(key)//'''')
      return
    endif
    if (value.ne.expected) then
      call cubeadm_message(seve%w,rname,'Key '''//trim(key)//''' is '''//  &
        trim(value)//''' (expected '''//trim(expected)//''')')
      return
    endif
  end subroutine cubeadm_verify_and_compare_ch
  !
  subroutine cubeadm_verify_one(hdict,key,error)
    use gkernel_types
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Verify if a key is present
    !-------------------------------------------------------------------
    type(gfits_hdict_t), intent(in)    :: hdict
    character(len=*),    intent(in)    :: key
    logical,             intent(inout) :: error
    !
    logical :: found
    character(len=char0d_length) :: value
    character(len=*), parameter :: rname='VERIFY>ONE'
    !
    call gfits_get_value(hdict,key,found,value,error)
    if (error)  return
    if (.not.found)  &
      call cubeadm_message(seve%w,rname,'Missing key '''//trim(key)//'''')
  end subroutine cubeadm_verify_one
  !
  subroutine cubeadm_verify_check_uvt(uv,error)
    use cubeformats_uv
    !-------------------------------------------------------------------
    ! Verify if a uv_t is CUBE conformat
    !-------------------------------------------------------------------
    type(uv_t), intent(in)    :: uv
    logical,    intent(inout) :: error
    !
    character(len=*), parameter :: rname='VERIFY>CHECK>UV'
    !
    ! For now on we don't check anything as we only support GDF
    ! UV tables
  end subroutine cubeadm_verify_check_uvt
  !
end module cubeadm_verify

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***JP: Aborted try to use the one2two_real_comm_t.
!***JP: The problem is that we here need a /AT additional keyval!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubestatistics_percentile
  use cubetemplate_one2two_real_template
  use cubestatistics_messaging
  !
  public :: cubestatistics_percentile_register
  private
  !
  type(one2two_real_comm_t) :: percentile
  !
contains
  !
  subroutine cubestatistics_percentile_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='PERCENTILE>REGISTER'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call percentile%register_syntax(&
         'PERCENTILE','cubeid','3D cube',[flag_any],cubestatistics_percentile_command,&
         'qmin',[flag_minimum,flag_percentile,flag_image],&
         'qmax',[flag_maximum,flag_percentile,flag_image],&
         error)
    if (error) return
    call percentile%register_act(cubestatistics_percentile_prog_act,error)
    if (error) return
  end subroutine cubestatistics_percentile_register
  !
  subroutine cubestatistics_percentile_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2two_real_user_t) :: user
    character(len=*), parameter :: rname='PERCENTILE>COMMAND'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call percentile%parse(line,user,error)
    if (error) return
    call percentile%main(user,error)
    if (error) continue
  end subroutine cubestatistics_percentile_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_percentile_prog_act(prog,ie,spec,good,qmin,qmax,error)
    use cubetools_parameters
    use cubeadm_spectrum_types
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_real_prog_t), intent(inout) :: prog
    integer(kind=entr_k),       intent(in)    :: ie
    type(spectrum_t),           intent(inout) :: spec
    type(spectrum_t),           intent(inout) :: good
    type(spectrum_t),           intent(inout) :: qmin
    type(spectrum_t),           intent(inout) :: qmax
    logical,                    intent(inout) :: error
    !
    type(spectrum_t) :: line
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='PERCENTILE>PROG>ACT'
    !
    call spec%get(ie,error)
    if (error) return
    call line%point_to(spec,prog%region%iz%first,prog%region%iz%last,1.0,error)
    if (error) return
    call good%unblank(line,error)
    if (error) return
    !
    qmin%y%val(one) = statistics%percentile(good%y%val,good%n,prog%percentage)
    call qmin%put(ie,error)
    if (error) return
    !
    qmax%y%val(one) = statistics%percentile(good%y%val,good%n,prog%percentage)
    call qmax%put(ie,error)
    if (error) return
  end subroutine cubestatistics_percentile_prog_act
end module cubestatistics_percentile
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module maptasks_interfaces_none
  interface
    subroutine get_weightmode(task,mode,error)
      !---------------------------------------------------------------------
      !
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: task
      character(len=*), intent(inout) :: mode
      logical, intent(out) :: error
    end subroutine get_weightmode
  end interface
  !
  interface
    subroutine get_uvmap_par (task,uvdata,name,map,error)
      !
      ! UV_INVERT / UV_MAP
      !    Define mapping parameters
      !
      use phys_const
      use uvmap_def_task
      !
      character(len=*), intent(in) :: task
      character(len=*), intent(out) :: uvdata
      character(len=*), intent(out) :: name
      type (par_uvmap), intent(inout) :: map
      logical, intent(out) :: error
    end subroutine get_uvmap_par
  end interface
  !
  interface
    subroutine t_doweig (nv,uu,vv,wuv,unif,wm,error)
      !----------------------------------------------------------------------
      ! UV_INVERT / UV_MAP
      !   Compute weights of the visibility points.
      !----------------------------------------------------------------------
      use gildas_def
      integer, intent(in) :: nv  ! number of values
      real, intent(in) :: uu(nv)     ! U values
      real, intent(in) :: vv(nv)     ! V values
      real, intent(inout) :: wuv(nv) ! Weights
      real, intent(in) :: unif   ! uniform cell size in Meters
      real, intent(inout) :: wm      ! on input: % of uniformity
      logical, intent(out) :: error
    end subroutine t_doweig
  end interface
  !
  interface
    subroutine t_doweig_quick (nv,uu,vv,wuv,unif,we,wm,mv,umin,umax,  &
      vmin,vmax,nbcv,error)
      !----------------------------------------------------------------------
      ! UV_INVERT / UV_MAP
      !   Compute weights of the visibility points.
      !     Quick version using sub-grids
      !----------------------------------------------------------------------
      integer, intent(in) :: nv  ! number of values
      real, intent(in) :: uu(nv)     ! U values
      real, intent(in) :: vv(nv)     ! V values
      real, intent(inout) :: wuv(nv) ! Weights
      real, intent(in) :: unif   ! uniform cell size in Meters
      real, intent(in) :: wm         ! Weight scale factor
      real, intent(out) :: we(nv)
      integer, intent(in) :: mv
      integer, intent(in) :: nbcv    ! sub-grid scale factor
      real, intent(in) :: umin
      real, intent(in) :: umax
      real, intent(in) :: vmin
      real, intent(in) :: vmax
      logical, intent(out) :: error
    end subroutine t_doweig_quick
  end interface
  !
  interface
    subroutine t_dotaper(nv,uu,vv,ww,taper)
      !
      ! UV_INVERT / UV_MAP
      !    Apply taper
      !
      use phys_const
      integer, intent(in) :: nv      ! Number of UV points
      real, intent(in) :: uu(nv)     ! U values
      real, intent(in) :: vv(nv)     ! V values
      real, intent(inout) :: ww(nv)  ! Weights
      real, intent(in) :: taper(4)   ! Taper parameters
    end subroutine t_dotaper
  end interface
  !
  interface
    subroutine t_channel(huv,map)
      use gildas_def
      use image_def
      use uvmap_def_task
      !----------------------------------------------------------
      ! UV_INVERT / UV_MAP
      !    Setup the channel associated parameters
      !----------------------------------------------------------
      type (gildas), intent(in) :: huv        ! UV header
      type (par_uvmap), intent(inout) :: map  ! Imaging parameters
    end subroutine t_channel
  end interface
  !
  interface
    subroutine t_map(task,map,huv,uvmin,uvmax,conv)
      !----------------------------------------------------------
      ! UV_INVERT / UV_MAP
      !    Setup the image plane associated parameters
      !----------------------------------------------------------
      use gildas_def
      use image_def
      use uvmap_def_task
      use phys_const
      !
      character(len=*), intent(in) :: task
      type (par_uvmap), intent(inout) :: map
      type (gildas), intent(in) :: huv
      real, intent(inout) :: uvmin  ! Minimum UV length (in meters on input)
      real, intent(inout) :: uvmax  ! Maximum UV length (in Wavelength on output)
      type (gridding), intent(out) :: conv
    end subroutine t_map
  end interface
  !
  interface
    subroutine t_setbeam(huv,hbeam,map,ndim)
      !-----------------------------------------------------
      ! UV_INVERT / UV_MAP
      !     Set Beam Header
      !-----------------------------------------------------
      use image_def
      use uvmap_def_task
      type (par_uvmap), intent(in) :: map
      type (gildas), intent(in), target :: huv
      type (gildas), intent(inout), target :: hbeam
      integer, intent(in) :: ndim  ! Number of dimensions
    end subroutine t_setbeam
  end interface
  !
  interface
    subroutine t_setdirty(huv,hdirty,map,wall)
      use image_def
      use uvmap_def_task
      !-----------------------------------------------------
      ! UV_INVERT / UV_MAP
      !     Set Dirty Header
      !-----------------------------------------------------
      type (par_uvmap), intent(in) :: map    ! Imaging parameters
      type (gildas), intent(in), target :: huv        ! UV Header
      type (gildas), intent(inout), target :: hdirty  ! Dirty Header
      real, intent(in) :: wall    ! Theoretical noise
    end subroutine t_setdirty
  end interface
  !
  interface
    subroutine do_mapslow(np,nv,visi,we,lc,   &
         &    freq,nc,nx,ny,map,beam,mapcox,mapcoy)
      use phys_const
      integer, intent(in) :: np                     ! Size of a visibility
      integer, intent(in) :: nv                     ! Number of visibilities
      real, intent(in) :: visi(np,nv)               ! Visibilities UVT
      real, intent(in) :: we(nv)                    ! Weights
      integer, intent(in) :: lc                     !
      real(8), intent(in) :: freq                   ! Observing frequency
      integer, intent(in) :: nc                     ! Number of channels
      integer, intent(in) :: nx                     ! Number of pixels in X
      integer, intent(in) :: ny                     ! Number of pixels in Y
      real, intent(out) :: map(nc,nx,ny)            ! Dirty cube
      real, intent(out) :: beam(nx,ny)              ! Dirty beam
      real, intent(in) :: mapcox(nx)                ! X coordinates
      real, intent(in) :: mapcoy(ny)                ! Y coordinates
    end subroutine do_mapslow
  end interface
  !
  interface
    subroutine t_uvsort (np,nv,vin,vout,inxy,incs,uvmax,uvmin,sort,error)
      use gildas_def 
      use gbl_message
      use uv_rotate_shift_and_sort_tool, only: loaduv,sortuv,chksuv
      !----------------------------------------------------------------------
      ! UV_MAP
      !     Rotate, Shift and Sort a UV table for map making
      !     Differential precession should have been applied before.
      !----------------------------------------------------------------------
      !
      integer, intent(in) :: np                   ! Size of a visibility
      integer, intent(in) :: nv                   ! Number of visibilities
      real, intent(in) :: vin(np,nv)              ! Input visibilities
      real, intent(out) :: vout(np,nv)            ! Output visibilities
      real(8), intent(in) :: inxy(2)              ! Phase shift
      real(8), intent(in) :: incs(2)              ! Frame Rotation
      real, intent(out) :: uvmax                  ! Max UV value
      real, intent(out) :: uvmin                  ! Min UV value
      logical, intent(inout) :: sort              ! Data has been sorted
      logical, intent(out) :: error
    end subroutine t_uvsort
  end interface
  !
  interface
    subroutine mx_uvmap (u,b,m,grid,mapu,mapv,work,sblock,cpu0,rms)
      use gildas_def
      use image_def
      use gbl_format
      use mx_parameters
      use uvstat_tool, only: prnoise
      !---------------------------------------------------------------------
      ! MX:
      ! UVMAP Compute a map from a CLIC UV Sorted Table
      ! by Gridding and Fast Fourier Transform, with
      ! one single beam for all channels.
      !
      ! Input : (in X)
      ! a precessed UV table, sorted in V, ordered in
      ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
      ! Output :
      ! a beam image (in B)
      ! a VLM cube   (in Y)
      ! Work space :
      ! a  VLM complex Fourier cube (first V value is for beam)
      ! a  complex plane
      ! Save results
      ! The grid correction GRID
      ! The UV coordinates  MAPU, MAPV
      ! The UV weight array WE_ADDR
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: u,b,m    !
      real :: grid(map_size(1),map_size(2))   !
      real :: mapu(map_size(1))                         !
      real :: mapv(map_size(2))                         !
      real :: work(*)                         !
      integer(4) :: sblock                    !
      real :: cpu0                            !
      real :: rms                             !
    end subroutine mx_uvmap
  end interface
  !
  interface
    subroutine mx_uvsort (x,y,uvtable,new,shift,uvmax,uvmin,error)
      use gildas_def
      use gbl_format
      use image_def
      use uv_shift, only: uv_shift_header
      use uv_rotate_shift_and_sort_tool, only: uvsort_uv
      !---------------------------------------------------------------------
      ! GILDAS
      !   Sort an input UV table
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: x            ! Unsorted UV table
      type(gildas), intent(inout) :: y            ! Sorted UV table
      character(len=*), intent(in) :: uvtable     ! Table name
      real(8), intent(inout) :: new(3)            ! New phase center
      logical, intent(inout) :: shift             ! Shift phase center ?
      real(4), intent(inout) :: uvmax             !
      real(4), intent(inout) :: uvmin             !
      logical, intent(out) :: error               ! Error flag
    end subroutine mx_uvsort
  end interface
  !
  interface
    subroutine mx_local_clean(hu,hb,hr,hc,hcct,grid,mapx,mapy,work,sblock, cpu0)
      use gildas_def
      use image_def
      use cct_types
      use mx_parameters
      use clean_beam_tool, only: find_sidelobe
      use minmax_tool, only: maxmap
      !---------------------------------------------------------------------
      ! GILDAS: CLEAN Internal routine
      ! Implementation of MX CLEAN deconvolution algorithm.
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hu    ! UV Data  Header
      type(gildas), intent(in) :: hb    ! Beam     Header
      type(gildas), intent(in) :: hr    ! Residual Header
      type(gildas), intent(in) :: hcct  ! Clean Component Table Header
      type(gildas), intent(in) :: hc    ! Clean    Header
      real :: grid(hb%gil%dim(1),hb%gil%dim(2))     ! Gridding correction
      real :: mapx(hb%gil%dim(1))                   ! X coordinates
      real :: mapy(hb%gil%dim(2))                   ! Y coordinates
      real :: work(*)                   ! FFT Work array
      integer :: sblock                 ! Blocking factor
      real :: cpu0                      ! Starting CPU
    end subroutine mx_local_clean
  end interface
  !
  interface
    subroutine mx_make_clean (clean,nx,ny,ft,bmaj,bmin,pa,   &
         &    xinc,yinc,compon,nc,work,resi)
      use mapping_gaussian_tool
      !---------------------------------------------------------------------
      ! GILDAS: CLEAN   Internal routine
      ! Convolve source list into residual map using the Fourier method.
      !---------------------------------------------------------------------
      integer :: nx                     !
      integer :: ny                     !
      real :: clean(nx,ny)              !
      complex :: ft(nx,ny)              !
      real :: bmaj                      !
      real :: bmin                      !
      real :: pa                        !
      real :: xinc                      !
      real :: yinc                      !
      integer :: nc                     !
      real :: compon(3,nc)              !
      real :: work(*)                   !
      real :: resi(nx,ny)               !
    end subroutine mx_make_clean
  end interface
  !
  interface
    subroutine mx_loadxy (x,y,mapux,nx,mapvy,ny,mcol)
      use gildas_def
      use image_def
      type(gildas) :: x,y               !
      integer :: nx                     !
      real :: mapux(nx)                 !
      integer :: ny                     !
      real :: mapvy(ny)                 !
      integer :: mcol(2)                !
    end subroutine mx_loadxy
  end interface
  !
  interface
    subroutine mx_major (u,beam,residu,nx,ny, nz,   &
         &    fwork,wclean,mclean,box,maxiter,compon,niter,   &
         &    grid, mapu, mapv, mapx, mapy, wfft, fft, sblock, cpu0)
      use gildas_def
      use image_def
      use mx_parameters
      use cct_types
      use minmax_tool, only: maxmap
      !---------------------------------------------------------------------
      ! CLEAN
      !	Major cycle loop according to MX idea
      !---------------------------------------------------------------------
      type(gildas) :: u                 !
      integer :: nx                     !
      integer :: ny                     !
      real ::    beam(nx,ny)            !
      integer :: nz                     !
      real ::    residu(nx,ny,nz)       !
      complex :: fwork(nx,ny)           ! Work space for T.F.
      integer :: mclean                 !
      type(cct_par) :: wclean(mclean)   ! Work space for clean components
      integer :: box(4)                 ! Cleaning box
      integer :: maxiter                ! Maximum number of clean components
      real ::  compon(3,maxiter,nz)     ! Clean component table
      integer :: niter(nz)              ! Number of Clean components
      real ::    grid(nx,ny)            ! Grid correction
      real :: mapu(nx)                  ! Coordinates of UV grid
      real :: mapv(ny)                  ! Coordinates of UV grid
      real :: mapx(nx)                  ! Coordinates of XY map in 1/m
      real :: mapy(ny)                  ! Coordinates of XY map in 1/m
      real :: wfft(*)                   ! FFT work space
      complex :: fft(nz+1,nx,ny)        ! FFTs of planes
      integer :: sblock                 !
      real :: cpu0                      !
    end subroutine mx_major
  end interface
  !
  interface
    subroutine mx_uvsub_loc(nx,ny,mapx,mapy,wclean,nclean,flux,jc,nv,visi,io)
      use cct_types
      !-------------------------------------------------------------------
      ! GILDAS:	CLEAN 	Internal routine
      !	Subtract last major cycle components from residual map.
      !-------------------------------------------------------------------
      integer :: nx                   !
      integer :: ny                   !
      real :: mapx(nx)                !
      real :: mapy(ny)                !
      integer :: nclean               !
      type(cct_par) :: wclean(nclean) !
      real :: flux                    !
      integer :: jc                   !
      integer :: nv                   !
      real :: visi(jc,nv)             !
      integer :: io                   !
    end subroutine mx_uvsub_loc
  end interface
  !
  interface
    subroutine mx_minor (wclean,nbpoint,   &
        &      beam,nx,ny,ixbeam,iybeam,ixpatch,iypatch,   &
        &      gain,maxiter,clarkmin,limite,converge,check,   &
        &      compon,niter)
      use cct_types
      !-------------------------------------------------------------------
      ! MX:
      !     CLEAN    Internal routine
      !        B.Clark minor cycles
      !     Deconvolve as in standard clean a list of NBPOINT points
      !     selected in the map until the residuals is less than CLARKMIN
      !-------------------------------------------------------------------
      type(cct_par) :: wclean(*)      ! Clean component
      integer :: nbpoint              ! nombre de points retenus
      integer :: nx                   ! dimension et centre du beam
      integer :: ny                   ! dimension et centre du beam
      real :: beam(nx,ny)             ! beam
      integer :: ixbeam               ! dimension et centre du beam
      integer :: iybeam               ! dimension et centre du beam
      integer :: ixpatch              ! rayon utile du Beam
      integer :: iypatch              ! rayon utile du Beam
      real :: gain                    ! gain de clean
      integer :: maxiter              ! nombre max d'iteration
      real :: clarkmin                ! borne d'arret de clean
      real :: limite                  ! borne d'arret de clean
    !  real :: cclean(*)               ! valeur des composantes
      logical :: converge             ! Controle de la convergence
      logical :: check                ! ibid.
      real :: compon(3,maxiter)       ! Effective clean components
      integer :: niter                ! Number of clean components
    end subroutine mx_minor
  end interface
  !
  interface
    subroutine mx_get_parameters(nx,ny)
      use gildas_def
      use mx_parameters
      use clean_tool, only: check_box
      !---------------------------------------------------------------------
      ! GILDAS:	MX Internal routine
      !	Retrieves input parameters for MX Uvmap & Clean
      !---------------------------------------------------------------------
      integer, intent(out) :: nx,ny
    end subroutine mx_get_parameters
  end interface
  !
  interface
    subroutine mx_open_clean(hd,hc,hcct,rms,error)
      use gildas_def
      use image_def
      use gbl_format
      use mx_parameters
      !---------------------------------------------------------------------
      ! GILDAS:	MX routine
      !	Open missing input maps
      !	Dirty beam has been copied into B area
      !	Clean Component Table created in C area, after creation in Z.
      !	Residual map is in Y, originally loaded with dirty map
      !	Cleaned map in Z, originally undefined
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hd
      type(gildas), intent(inout) :: hc,hcct
      real, intent(in) :: rms
      logical, intent(out) :: error
    end subroutine mx_open_clean
  end interface
  !
  interface
    subroutine mx_fit_beam(hb,error)
      use image_def
      use mx_parameters
      use fit_beam_tool
      type(gildas), intent(inout) :: hb
      logical, intent(out) :: error
    end subroutine mx_fit_beam
  end interface
  !
end module maptasks_interfaces_none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_tracked_psw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_tracked_psw
  !---------------------------------------------------------------------
  ! @ private
  ! Gather all needed steps to read, calibrate, and write a 
  ! tracked position switched scan for a given backend
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_iterate_subscancycle(mrtset,filebuf%imbf, &
    filebuf%subscanbuf,backcal,backsci,error)
  if (error) return
  !
end subroutine mrtcal_calib_tracked_psw
!
subroutine mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,nswitch,  &
  subscanbuf,backcal,backsci,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_tracked_psw_cycle
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Calibrate a TRACKED PSW cycle of subscans
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)            :: mrtset      !
  type(imbfits_t),         intent(in)            :: imbf        !
  integer(kind=4),         intent(in)            :: ifirst      ! First subscan in cycle
  integer(kind=4),         intent(in)            :: nswitch     ! Number of subscans in cycle
  type(subscan_buffer_t),  intent(inout)         :: subscanbuf  !
  type(calib_backend_t),   intent(in)            :: backcal     !
  type(science_backend_t), intent(inout), target :: backsci     !
  logical,                 intent(inout)         :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CALIB>TRACKED>PSW>CYCLE'
  integer(kind=4) :: isub
  logical, parameter :: iscal=.false.
  type(chunkset_2d_t) :: curr  ! Buffer for reading a ON or OFF subscan
  type(chunkset_2d_t), pointer :: cumul  ! Pointer to current ON or OFF cumulation
  logical :: initon,initoff
  character(len=23) :: iso
  character(len=message_length) :: mess
  !
  initon = .true.
  initoff = .true.
  do isub=ifirst,ifirst+nswitch-1
    call mrtcal_average_times(mrtset,iscal,isub,'track',imbf,subscanbuf,curr,error)
    if (error)  goto 10
    !
    if (backsci%list%onoff%bak(isub).eq.backsci%list%on) then
      if (initon) then
        ! Use first ON subscan to initialize the ON structure (in particular
        ! regarding offsets)
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%on%curr,error)
        if (error)  goto 10
        initon = .false.
      endif
      cumul => backsci%on%curr
    else
      if (initoff) then
        ! Use first OFF subscan to initialize the OFF structure (in particular
        ! regarding offsets)
        backsci%off%curr => backsci%off%computed  ! Use the 'computed' buffer
        call mrtcal_chunkset_2d_accumulate_init(curr,backsci%off%curr,error)
        if (error)  goto 10
        initoff = .false.
      endif
      cumul => backsci%off%curr
    endif
    !
    call mrtcal_chunkset_2d_accumulate_setweight(curr,backsci%tscale,  &
      mrtset%out%weight,error)
    if (error)  goto 10
    call mrtcal_chunkset_2d_accumulate_do(curr,cumul,error)
    if (error)  goto 10
  enddo
  !
  call mrtcal_on_minus_off(nototfmap,notfsw,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_computation(backcal,backsci,error)
  if (error)  goto 10
  call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
  if (error)  goto 10
  !
  call gag_mjd2isodate(backsci%off%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average OFF    date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%on%curr%chunkset(1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON     date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  call gag_mjd2isodate(backsci%diff%chunkset(1,1,1)%chunks(1)%mjd,iso,error)
  write(mess,'(6a)') 'Average ON-OFF date: ',iso
  call mrtcal_message(seve%i,rname,mess)
  !
  if (mrtset%out%accmode.eq.accmode_cycl) then
    call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nobs,error)
    if (error)  goto 10
  endif
  !
10 continue
  call curr%free(error)
  if (error)  return
  !
end subroutine mrtcal_calib_tracked_psw_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtholo_init(error)
  use gbl_message
  use gkernel_interfaces
  use mrtholo_interfaces, except_this=>mrtholo_init
  !----------------------------------------------------------------------
  ! @ private
  ! MRTHOLO Initialization
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='INIT'
  integer(kind=4) :: ier
  !
  call mrtholo_message(seve%d,rname,'Welcome')
  !
  ier = sic_setlog('gag_help_mrtholo','gag_doc:hlp/mrtholo-help-mrtholo.hlp')
  if (ier.eq.0) then
    error=.true.
    return
  endif
  !
end subroutine mrtholo_init
!
subroutine mrtholo_exit(error)
  use gbl_message
  use mrtholo_interfaces, except_this=>mrtholo_exit
  !----------------------------------------------------------------------
  ! @ private
  ! MRTHOLO Cleaning on exit
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='EXIT'
  !
  call mrtholo_message(seve%d,rname,'Welcome')
  !
end subroutine mrtholo_exit
!
subroutine mrtholo_load
  use mrtholo_interfaces, except_this=>mrtholo_load
  !---------------------------------------------------------------------
  ! @ private
  ! Define and load the MRTHOLO language
  !---------------------------------------------------------------------
  ! Local
  integer, parameter :: mmrtholo=2
  character(len=12) :: vocab(mmrtholo)
  data vocab / ' TOCLIC', '/NORMALIZE' /
  !
  ! Load the new language
  call sic_begin(        &
    'MRTHOLO',           &  ! Language name
    'GAG_HELP_MRTHOLO',  &  !
    mmrtholo,            &  ! Number of commands + options in language
    vocab,               &  ! Array of commands
    '0.1',               &  ! Some version string
    mrtholo_run,         &  ! The routine which handles incoming commands
    mrtholo_error)          ! The error status routine of the library
  !
end subroutine mrtholo_load
!
subroutine mrtholo_run(line,command,error)
  use gbl_message
  use mrtholo_interfaces, except_this=>mrtholo_run
  !---------------------------------------------------------------------
  ! @ private-mandatory
  ! Support routine for the language MRTHOLO.
  ! This routine is able to call the routines associated to each
  ! command of the language MRTHOLO
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line
  character(len=12), intent(in)    :: command
  logical,           intent(inout) :: error
  !
  call mrtholo_message(seve%c,'MRTHOLO',line)
  !
  ! Call appropriate subroutine according to COMMAND
  select case(command)
  case ('TOCLIC')
    call mrtholo_toclic_command(line,error)
  case default
    call mrtholo_message(seve%e,'MRTHOLO_RUN','Unimplemented command '//command)
    error = .true.
  end select
  !
end subroutine mrtholo_run
!
function mrtholo_error()
  use mrtholo_interfaces, except_this=>mrtholo_error
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for the error status of the library.
  ! It is a scory. Please do not use it
  !---------------------------------------------------------------------
  logical :: mrtholo_error
  !
  mrtholo_error = .false.
  !
end function mrtholo_error
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine result_comm(set,line,obs,user_function,error)
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>result_comm
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command FIT\RESULT [N]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  type(observation),   intent(inout) :: obs            !
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  character(len=*), parameter :: rname='RESULT'
  !
  call fit_res_comm(set,line,rname,obs,.true.,user_function,error)
  if (error)  return
  !
end subroutine result_comm
!
subroutine residu_comm(set,line,obs,user_function,error)
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>residu_comm
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command FIT\RESIDUALS [N]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  type(observation),   intent(inout) :: obs            !
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  character(len=*), parameter :: rname='RESIDUAL'
  !
  call fit_res_comm(set,line,rname,obs,.false.,user_function,error)
  if (error)  return
  !
end subroutine residu_comm
!
subroutine fit_res_comm(set,line,rname,obs,doresu,user_function,error)
  use gbl_message
  use classfit_dependencies_interfaces
  use classfit_interfaces, except_this=>fit_res_comm
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for commands:
  !   FIT\RESULT [N]
  !   FIT\RESIDUAL [N]
  ! Redirection relying on SET METHOD
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  character(len=*),    intent(in)    :: rname          ! Calling routine name
  type(observation),   intent(inout) :: obs            !
  logical,             intent(in)    :: doresu         ! result or residual?
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  integer(kind=4) :: m
  !
  m = 0
  call sic_i4 (line,0,1,m,.false.,error)
  if (error) return
  m = max(m,0)
  !
  select case (set%method)
  case ('CONTINUUM','BASECONT')
    call fit_res(set,obs,doresu,propoi,m,user_function,error)
  case ('GAUSS')
    call fit_res(set,obs,doresu,progauss,m,user_function,error)
  case ('NH3','HFS')
    call fit_res(set,obs,doresu,pronh3,m,user_function,error)
  case ('ABSORPTION')
    call fit_res(set,obs,doresu,proabs,m,user_function,error)
  case ('SHELL')
    call fit_res(set,obs,doresu,proshell,m,user_function,error)
  case default
    call class_message(seve%e,rname,'Not implemented for method '//set%method)
    error = .true.
    return
  end select
  !
end subroutine fit_res_comm
!
subroutine fit_res(set,obs,doresu,fnc,m,user_function,error)
  use gildas_def
  use classfit_interfaces, except_this=>fit_res
  use class_types
  !--------------------------------------------------------------------
  ! @ private
  ! Support routine for commands
  !  FIT\RESULT [N]
  !  FIT\RESIDUAL [N]
  !
  ! Compute the residuals from last fit
  !  M indicates which line must be subtracted. If M = 0 (default), all
  ! lines must be subtracted.
  !  Copy R into T
  !  Compute R = T - Fit(N)
  !--------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  type(observation),   intent(inout) :: obs            !
  logical,             intent(in)    :: doresu         ! result or residual?
  integer(kind=4),     intent(in)    :: m              ! Line number
  logical,             external      :: user_function  !
  real(kind=4),        external      :: fnc            ! Function used for the fit
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  real(kind=4) :: a,b,resul
  integer(kind=4) :: i
  logical :: dobase
  !
  if (set%method.eq.'SHELL') then
    b = - obs%head%spe%rchan * obs%head%spe%fres
    a = obs%head%spe%fres
    do i=1,obs%cnchan
      if (obs%spectre(i).ne.obs%head%spe%bad) then
        resul = fnc(obs,a*float(i)+b,m,dobase)
        if (doresu) then
          obs%spectre(i) = resul
        else
          obs%spectre(i) = obs%spectre(i) - resul
        endif
      endif
    enddo
    !
  else
    do i=1,obs%cnchan
      if (obs%spectre(i).ne.obs%head%spe%bad) then
        a = real(obs%datax(i),kind=4)  ! data type conversion
        resul = fnc(obs,a,m,dobase)
        if (doresu) then
          obs%spectre(i) = resul
        else
          obs%spectre(i) = obs%spectre(i)-resul
        endif
      endif
    enddo
  endif
  !
  call newlimy(set,obs,error)
  !
end subroutine fit_res

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_minmax
  use cubetools_parameters
  use cubetemplate_one2two_image_template
  use cubefield_messaging
  !
  public :: cubefield_minmax_register
  private
  !
  type(one2two_image_comm_t) :: minmax
  !
contains
  !
  subroutine cubefield_minmax_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: comm_abstract = &
         'Detect local minima and maxima in image slices'
    character(len=*), parameter :: comm_help = &
         'Detect strict local minima and maxima on each selected image&
         & slice of the input 3D cube by comparing every interior pixel&
         & with its 8 neighbors. The min output keeps only strict minima&
         & and the max output keeps only strict maxima. Border pixels&
         & and flat plateaus remain blank.'
    character(len=*), parameter :: incube_help = &
         'Use the input 3D cube. If omitted, use the last matching cube&
         & in the default index (DAG by default; see SET\INDEX).'
    character(len=*), parameter :: ou1help = 'Local minimum values'
    character(len=*), parameter :: ou2help = 'Local maximum values'
    character(len=*), parameter :: rname='MINMAX>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call minmax%register_syntax(&
         'MINMAX','cubeid','3D cube',[flag_any],cubefield_minmax_command,&
         'min',[flag_local,flag_2d,flag_minimum],&
         'max',[flag_local,flag_2d,flag_maximum],&
         error,&
         comm_abstract=comm_abstract,&
         comm_help=comm_help,&
         incube_help=incube_help,&
         ou1help=ou1help,&
         ou2help=ou2help)
    if (error) return
    call minmax%register_act(cubefield_minmax_prog_act,error)
    if (error) return
  end subroutine cubefield_minmax_register
  !
  subroutine cubefield_minmax_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(one2two_image_user_t) :: user
    character(len=*), parameter :: rname='MINMAX>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call minmax%parse(line,user,error)
    if (error) return
    call minmax%main(user,error)
    if (error) continue
  end subroutine cubefield_minmax_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefield_minmax_prog_act(prog,ie,ima,min,max,error)
    !    use cubetools_parameters
    use cubetools_nan
    use cubeadm_image_types
    use cubefield_pixel_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(one2two_image_prog_t), intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(image_t),               intent(inout) :: ima
    type(image_t),               intent(inout) :: min
    type(image_t),               intent(inout) :: max
    logical,                     intent(inout) :: error
    !
    logical :: ismin,ismax
    integer(kind=pixe_k) :: ix,iy
    integer(kind=indx_k) :: ilist
    type(pixprop_t) :: list(8)
    character(len=*), parameter :: rname='MINMAX>PROG>ACT'
    !
    !***JP: Should be parameter initialization
    list(1)%ix =  0
    list(1)%iy = +1
    list(2)%ix = +1
    list(2)%iy = +1
    list(3)%ix = +1
    list(3)%iy =  0
    list(4)%ix = +1
    list(4)%iy = -1
    list(5)%ix =  0
    list(5)%iy = -1
    list(6)%ix = -1
    list(6)%iy = -1
    list(7)%ix = -1
    list(7)%iy =  0
    list(8)%ix = -1
    list(8)%iy = +1
    !
!!$    do ilist=1,8
!!$       print *,'pixel #',ilist,'(ix,iy) = ',list(ilist)%ix,list(ilist)%iy
!!$    enddo
    !      
    call ima%get(ie,error)
    if (error) return
    call min%set(gr4nan,error)
    if (error) return
    call max%set(gr4nan,error)
    if (error) return
    do ix=2,ima%nx-1
       do iy=2,ima%ny-1
          ismin = .true.
          do ilist=1,8
             if (ima%val(ix,iy).ge.ima%val(ix+list(ilist)%ix,iy+list(ilist)%iy)) then
                ismin = .false.
                exit
             endif
          enddo
          if (ismin) then
             min%val(ix,iy) = ima%val(ix,iy)
          endif
          !
          ismax = .true.
          do ilist=1,8
             if (ima%val(ix,iy).le.ima%val(ix+list(ilist)%ix,iy+list(ilist)%iy)) then
                ismax = .false.
                exit
             endif
          enddo
          if (ismax) then
             max%val(ix,iy) = ima%val(ix,iy)
          endif
       enddo ! iy
    enddo ! ix
    call min%put(ie,error)
    if (error) return
    call max%put(ie,error)
    if (error) return
  end subroutine cubefield_minmax_prog_act
end module cubefield_minmax
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function gr_clip(clip)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  ! Toggle Clipping
  !---------------------------------------------------------------------
  logical :: gr_clip                !
  logical :: clip                   !
  !
  gr_clip = .not.noclip
  noclip = .not.clip
end function gr_clip
!
subroutine gr4_phys_user (xi,yi,xu,yu,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !  Convert Physical units to User units
  !---------------------------------------------------------------------
  real(4), intent(in) :: xi(*)      ! X plot coordinates
  real(4), intent(in) :: yi(*)      ! Y plot coordinates
  real(4), intent(out) :: xu(*)     ! X User coordinates
  real(4), intent(out) :: yu(*)     ! Y User coordinates
  integer(4), intent(in) :: nxy     ! Number of points
  ! Local
  integer(4) :: i
  !
  if (axis_xlog) then
    do i=1,nxy
      xu(i) = exp((xi(i)-gx1)/gux + lux)
    enddo
  else
    do i=1,nxy
      xu(i) = (xi(i)-gx1)/gux + gux1
    enddo
  endif
  if (axis_ylog) then
    do i=1,nxy
      yu(i) = exp((yi(i)-gy1)/guy + luy)
    enddo
  else
    do i=1,nxy
      yu(i) = (yi(i)-gy1)/guy + guy1
    enddo
  endif
end subroutine gr4_phys_user
!
subroutine gr8_phys_user (xi,yi,xu,yu,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (because of rank mismatch)
  !  Convert Physical units to User units
  !---------------------------------------------------------------------
  real(4), intent(in) :: xi(*)      ! X plot coordinates
  real(4), intent(in) :: yi(*)      ! Y plot coordinates
  real(8), intent(out) :: xu(*)     ! X User coordinates
  real(8), intent(out) :: yu(*)     ! Y User coordinates
  integer(4), intent(in) :: nxy     ! Number of points
  ! Local
  integer(4) :: i
  !
  if (axis_xlog) then
    do i=1,nxy
      xu(i) = exp((xi(i)-gx1)/gux + lux)
    enddo
  else
    do i=1,nxy
      xu(i) = (xi(i)-gx1)/gux + gux1
    enddo
  endif
  if (axis_ylog) then
    do i=1,nxy
      yu(i) = exp((yi(i)-gy1)/guy + luy)
    enddo
  else
    do i=1,nxy
      yu(i) = (yi(i)-gy1)/guy + guy1
    enddo
  endif
end subroutine gr8_phys_user
!
subroutine us8_to_int(xu,yu,xi,yi,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument rank mismatch)
  ! GREG	Internal routine
  !	Converts XU array in user coordinates into XI array in plot
  !	coordinates
  ! No subroutine referenced
  !---------------------------------------------------------------------
  real(8), intent(in) :: xu(*)       ! X User coordinates
  real(8), intent(in) :: yu(*)       ! Y User coordinates
  real(4), intent(out) :: xi(*)      ! X Plot coordinates
  real(4), intent(out) :: yi(*)      ! Y plot coordinates
  integer(4), intent(in) :: nxy      ! Number of points
  ! Local
  integer(4) :: i
  !
entry gr8_user_phys (xu,yu,xi,yi,nxy)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (axis_xlog) then
    do i=1,nxy
      if (xu(i).gt.0) then
        xi(i) = gx1 + gux * (log(xu(i))-lux)
      else if (gux.gt.0) then
        xi(i) = gx1
     else
        xi(i) = gx2
      endif
    enddo
  else
    do i=1,nxy
      xi(i) = gx1 + gux * (xu(i)-gux1)
    enddo
  endif
  !
  if (axis_ylog) then
    do i=1,nxy
      if (yu(i).gt.0) then
        yi(i) = gy1 + guy * (log(yu(i))-luy)
      else if (guy.gt.0) then
        yi(i) = gy1
     else
        yi(i) = gy2
      endif
    enddo
  else
    do i=1,nxy
      yi(i) = gy1 + guy * (yu(i)-guy1)
    enddo
  endif
end subroutine us8_to_int
!
subroutine us4_to_int(xu,yu,xi,yi,nxy)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface
  ! GREG	Internal routine
  !	Converts XU array in user coordinates into XI array in plot
  !	coordinates
  !---------------------------------------------------------------------
  real(4), intent(in) :: xu(*)       ! X User coordinates
  real(4), intent(in) :: yu(*)       ! Y User coordinates
  real(4), intent(out) :: xi(*)      ! X Plot coordinates
  real(4), intent(out) :: yi(*)      ! Y Plot coordinates
  integer(4), intent(in) :: nxy      ! Number of points
  ! Local
  integer(4) :: i
  !
entry gr4_user_phys (xu,yu,xi,yi,nxy)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (axis_xlog) then
    do i=1,nxy
      if (xu(i).gt.0) then
        xi(i) = gx1 + gux * (log(xu(i))-lux)
      else if (gux.gt.0) then
        xi(i) = gx1
     else
        xi(i) = gx2
      endif
    enddo
  else
    do i=1,nxy
      xi(i) = gx1 + gux * (xu(i)-gux1)
    enddo
  endif
  !
  if (axis_ylog) then
    do i=1,nxy
      if (yu(i).gt.0) then
        yi(i) = gy1 + guy * (log(yu(i))-luy)
      else if (guy.gt.0) then
        yi(i) = gy1
     else
        yi(i) = gy2
      endif
    enddo
  else
    do i=1,nxy
      yi(i) = gy1 + guy * (yu(i)-guy1)
    enddo
  endif
end subroutine us4_to_int

subroutine flagData(line,error)
!
! Used for attributing the blanking value of raw data (blankingRaw), 
! respectively calibrated data (blankingRed) for a given spectral
! channel, receiver pixel, record, or spectral baseband.
!
! Called by run_mira (interactive command: FLAG, see online help or 
! users' manual for options).
!
! Input:        line    character       command line in interactive MIRA session
! Output:       error   logical         error flag
!
!

 USE mira
 IMPLICIT none

 CHARACTER(LEN=*)                   :: LINE
 LOGICAL                            :: ERROR

 integer                            :: i, ier, ifb, ifb1, ifb2, ii, j, jj, k,  &
&                                      kk, l, ll, nbb, nc, nchan, npix, nrec,  &
&                                      nsub, sic_narg
 integer, dimension(:), allocatable :: ibb, ichan, ipix, irec, isub
 real                               :: bval
 character(len=3)                   :: string
 logical                            :: flagBaseband,flagChannel,flagPixel,     &
&                                      flagRecord,flagSubscan, sic_present

 if (.not.sic_present(0,1)) then
    call gagout('E-FLAG: please specify a frontend-backend combination or ALL.')
    error = .true.
    return
 else
    call sic_ch(line,0,1,string,nc,.false.,error)
    call sic_upper(string)
    if (index(string(1:1),'A').ne.0) then
       ifb1 = 1
       ifb2 = scan%header%nfebe
    else
       call sic_i4(line,0,1,ifb,.false.,error)
       ifb1 = ifb
       ifb2 = ifb
    endif
 endif

 febeLoop: do ifb = ifb1, ifb2

    do i = 1, 5
       if (sic_present(i,0).and..not.sic_present(i,1)) then
          call gagout('E-FLAG: please specify a number.')
          error = .true.
          return
       endif
    enddo
 
    flagBaseband = sic_present(1,1)

    if (reduce(ifb)%calibration_done(3).and.flagBaseband) then
       call gagout('E-FLAG: individual basebands cannot be flagged at this '&
&                  //'stage, since the basebands are already concatenated.')
       error = .true.
       return
    endif
    
    flagChannel  = sic_present(2,1)
    flagPixel    = sic_present(3,1)
    flagRecord   = sic_present(4,1)
    flagSubscan  = sic_present(5,1)

    nbb      = 0
    nchan    = 0
    npix     = 0
    nrec     = 0
    nsub     = 0

    if (flagBaseband) then
       nbb = sic_narg(1)
       allocate(ibb(nbb),stat=ier)
       do i = 1, nbb
          call sic_i4(line,1,i,ibb(i),.false.,error)
          if (ibb(i).gt.febe(ifb)%header%febeband) then
             call gagout('E-FLAG: invalid baseband number.')
             error = .true.
             return
          endif
       enddo
    else if (.not.reduce(ifb)%calibration_done(3)) then
       nbb = febe(ifb)%header%febeband
       allocate(ibb(nbb),stat=ier)
       do i = 1, nbb
          ibb(i) = i
       enddo
    endif

    if (flagChannel) then
       nchan = sic_narg(2)
       allocate(ichan(nchan),stat=ier)
       do i = 1, nchan
          call sic_i4(line,2,i,ichan(i),.false.,error)
          if (reduce(ifb)%calibration_done(3)) then
             if (ichan(i).gt.data(ifb)%header%channels) then
                call gagout('E-FLAG: invalid channel number.')
                error = .true.
                return
             endif
          else
             if (ichan(i).gt.array(ifb)%header(1)%channels) then
                call gagout('E-FLAG: invalid channel number.')
                error = .true.
                return
             endif
          endif
       enddo
    else
       nchan = array(ifb)%header(1)%channels
       allocate(ichan(nchan),stat=ier)
       do i = 1, nchan
          ichan(i) = i
       enddo
    endif

    if (flagPixel) then
       npix = sic_narg(3)
       allocate(ipix(npix),stat=ier)
       do i = 1, npix
          call sic_i4(line,3,i,ipix(i),.false.,error)
          if (ipix(i).gt.febe(ifb)%header%febefeed) then
             call gagout('E-FLAG: invalid pixel number.')
             error = .true.
             return
          endif
       enddo
    else
       npix = febe(ifb)%header%febefeed
       allocate(ipix(npix),stat=ier)
       do i = 1, npix
          ipix(i) = i
       enddo
    endif

    if (flagRecord) then
       nrec = sic_narg(4)
       allocate(irec(nrec),stat=ier)
       do i = 1, nrec
          call sic_i4(line,4,i,irec(i),.false.,error)
          if (irec(i).gt.maxval(data(ifb)%data%integnum)) then
             call gagout('E-FLAG: invalid record number.')
             error = .true.
             return
          endif
       enddo
    else if (.not.flagSubscan) then
       nrec = maxval(data(ifb)%data%integnum)
       allocate(irec(nrec),stat=ier)
       do i = 1, nrec
          irec(i) = i
       enddo
    endif

    if (flagSubscan) then

       if (flagRecord) then
         call gagout('W-FLAG: options /RECORD and /SUBSCAN are '//     &
&                    'mutually exclusive. Ignoring option /RECORD.')
         if (allocated(irec)) deallocate(irec)
       endif

    endif

    nsub = sic_narg(5)
    allocate(isub(nsub),stat=ier)
    do i = 1, nsub
       call sic_i4(line,5,i,isub(i),.false.,error)
       if (isub(i).gt.scan%header%nobs) then
          call gagout('E-FLAG: invalid subscan number.')
          error = .true.
          return
       endif
    enddo

    flagRecord = .true.
    nrec = 0
    do i = 1, nsub
       ii = isub(i)
       nrec = nrec+count(data(ifb)%data%subscan(:).eq.ii)
    enddo
    allocate(irec(nrec),stat=ier)
    k = 0
    do i = 1, nsub
       ii = isub(i)
       do j = 1, maxval(data(ifb)%data%integnum)
          if (ii.eq.data(ifb)%data%subscan(j)) then
             k = k+1
             irec(k) = data(ifb)%data%integnum(j)
          endif
       enddo
    enddo

    flagSubscan = .false.
    if (reduce(ifb)%calibration_done(3)) then   

       bval = blankingRed

       do i = 1, nchan
          ii = ichan(i)
          do j = 1, npix
             jj = ipix(j)
             data(ifb)%data%rdata(jj,ii) = bval
             do k = 1, nrec
                kk = irec(k)
                data(ifb)%data%otfdata(jj,ii,kk) = bval
             enddo
          enddo
       enddo

    else

       if (.not.reduce(ifb)%calibration_done(1)) then
          bval = blankingRaw
       else
          bval = blankingRed
       endif

       do i = 1, nbb
          ii = ibb(i)
          do j = 1, nchan
             jj = ichan(j)
             do k = 1, npix
                kk = ipix(k)
                do l = 1, nrec
                   ll = irec(l)
                   array(ifb)%data(ii)%data(kk,jj,ll,:) = bval
                enddo
             enddo
          enddo
       enddo
       
    endif

 enddo febeLoop

 if (allocated(ibb))   deallocate(ibb,stat=ier)
 if (allocated(ichan)) deallocate(ichan,stat=ier)
 if (allocated(ipix))  deallocate(ipix,stat=ier)
 if (allocated(irec))  deallocate(irec,stat=ier)

end subroutine flagData

subroutine write_sdm_pointingModel(error)
  !---------------------------------------------------------------------
  !     Write the Poinitng Model SDM table.
  !     (very much *TBD* at present) but required soon
  !     int sdm_addPointingModelRow ()
  !---------------------------------------------------------------------
  use gildas_def
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  integer sdm_addPointingModelRow, ireturn
  integer ia
  character sdmTable*16
  parameter (sdmTable='PointingModel')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  do ia = 1, r_nant
    ireturn =  sdm_addPointingModelRow()
    if (ireturn.lt.0) then
      call sdmMessageI(8,3,sdmTable   &
        ,'Error in sdm_addPointingModelRow',ireturn)
      goto 99
    endif
    PointingModel_Id(ia) = ireturn
  enddo
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_pointingModel
!---------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_taskloop
  use gkernel_interfaces
  use cubetools_parameters
  use cubetuple_format_class
  use cubedag_link_type
  use cubetopology_cuberegion_types
  use cube_types
  use cubeadm_messaging
  use cubeadm_entryloop
  use cubeadm_taskloop_iteration
  !
  integer(kind=code_k), parameter :: code_1entry_for_allplanes=-1
  !
  type :: cubeadm_iterator_cubedesc_t
    ! Convenient type which gathers temporarily all the cubes relevant
    ! information needed to compute the iterator.
    logical                          :: input   ! Is this an input or output cube?
    class(format_t),         pointer :: cube    ! The associated cube
    type(cuberegion_prog_t), pointer :: region  ! The associated region, if relevant
    integer(kind=code_k)             :: access  ! Iterator access mode
  end type cubeadm_iterator_cubedesc_t
  !
  type :: cubeadm_iterator_t
    ! Entries
    integer(kind=entr_k), public  :: ne          ! Total number of entries
    integer(kind=entr_k), private :: neperplane  ! Number of output entries per plane
    ! Tasks
    integer(kind=entr_k), public  :: nt          ! Total number of tasks
    ! Planes
    integer(kind=entr_k), private :: np          ! Total number of reference planes
    integer(kind=entr_k), private :: nppertask   ! Number of planes per task
    ! Current task iteration
    ! NB: this is a duplicate of taskloop_iteration_t. Ifort 13 and 18 have
    !     a bug which does not correctly duplicates sub-types components in
    !     FIRSTPRIVATE statements. No better way than duplicating the type
    !     here
    integer(kind=entr_k), public  :: num         ! This task number
    integer(kind=entr_k), public  :: ie          ! The output entry number iterated in this task
    integer(kind=entr_k), private :: ofe,ole     ! Output first/last entry to be processed by this task
    integer(kind=entr_k), public  :: prange(2)   ! Ref    first/last plane to be processed by this task
  contains
    procedure, public :: iterate_entry => cubeadm_iterator_iterate_entry
  end type cubeadm_iterator_t
  !
  public :: cubeadm_iterator_t
  public :: cubeadm_taskloop_init,cubeadm_taskloop_iterate
  private
  !
contains
  !
  subroutine cubeadm_taskloop_init(incubes,oucubes,align,region,iter,error)
    use cubedag_node_class
    !----------------------------------------------------------------------
    ! Set up the iterator suited for the input and the output cubes
    !----------------------------------------------------------------------
    type(cubedag_link_t),     intent(in)    :: incubes  ! In cube list
    type(cubedag_link_t),     intent(in)    :: oucubes  ! Out cube list
    integer(kind=code_k),     intent(in)    :: align    !
    type(cuberegion_prog_t),  pointer       :: region   !
    type(cubeadm_iterator_t), intent(out)   :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>INIT'
    type(cubeadm_iterator_cubedesc_t), allocatable :: myiter(:)
    integer(kind=entr_k) :: icube,ncube
    class(format_t), pointer :: cube
    integer(kind=4) :: ier
    class(cubedag_node_object_t), pointer :: dno
    character(len=message_length) :: mess
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Compute one iterator per cube
    allocate(myiter(incubes%n+oucubes%n),stat=ier)
    if (failed_allocate(rname,'iterator',ier,error)) return
    ncube = 0
    !
    ! Input cubes
    do icube=1,incubes%n
      dno => cubedag_node_ptr(incubes%list(icube)%p,error)
      if (error) return
      cube => cubetuple_format_ptr(dno,error)
      if (error) return
      ! Skip cubes for which we won't iterate data
      if (cube%tuple%current%desc%action.eq.code_read_head)  cycle
      ! Set up an iterator suited for this cube
      ncube = ncube+1
      write(mess,'(A,I0)') '--- Computing iterator for cube #',ncube
      call cubeadm_message(admseve%others,rname,mess)
      call cubeadm_taskloop_cubedesc_fill(cube,.true.,region,myiter(ncube),error)
      if (error) return
    enddo
    !
    ! Output cubes
    do icube=1,oucubes%n
      dno => cubedag_node_ptr(oucubes%list(icube)%p,error)
      if (error) return
      cube => cubetuple_format_ptr(dno,error)
      if (error) return
      ! Set up an iterator suited for this cube
      ncube = ncube+1
      write(mess,'(A,I0)') '--- Computing iterator for cube #',ncube
      call cubeadm_message(admseve%others,rname,mess)
      call cubeadm_taskloop_cubedesc_fill(cube,.false.,null(),myiter(ncube),error)
      if (error) return
    enddo
    !
    ! Cubes consistency: number of entries must be the same or 1
    ! me = maxval(myiter(1:ncube)%ne)
    ! do icube=1,ncube
    !   if (myiter(icube)%ne.ne.1 .and. myiter(icube)%ne.ne.me) then
    !     write(mess,'(A,I0,A,I0)')  &
    !       'Iterated cubes have different number of entries: ',myiter(icube)%ne,',',me
    !     call cubeadm_message(seve%e,rname,mess)
    !     error = .true.
    !     return
    !   endif
    ! enddo
    !
    ! Compute the global iterator by merging all the individual ones
    call cubeadm_message(admseve%others,rname,'--- Computing global iterator')
    call cubeadm_taskloop_iterator_compute(myiter,ncube,align,iter,error)
    if (error) return
    call cubeadm_message(admseve%others,rname,'--- Done')
  end subroutine cubeadm_taskloop_init
  !
  subroutine cubeadm_taskloop_cubedesc_fill(cub,input,region,iter,error)
    use cubetools_access_types
    !----------------------------------------------------------------------
    ! Set up the iterator suited for a single cube.
    !----------------------------------------------------------------------
    class(format_t), target,           intent(in)    :: cub
    logical,                           intent(in)    :: input
    type(cuberegion_prog_t),           pointer       :: region
    type(cubeadm_iterator_cubedesc_t), intent(out)   :: iter
    logical,                           intent(inout) :: error
    !
    character(len=*), parameter :: rname='TASKLOOP>ITERATOR'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    iter%input  = input
    iter%cube   => cub
    iter%region => region
    !
    ! Which access?
    select case (cub%access())
    case (code_access_subset,code_access_fullset)
      iter%access = cub%access()
    case (code_access_blobset)
      call cubeadm_message(seve%e,rname,'Blob access mode is not implemented')
      error = .true.
      return
    case default
      ! Other accesses based on actual data order
      select case (cub%order())
      case (code_access_imaset)
        iter%access = code_access_imaset
      case (code_access_speset)
        iter%access = code_access_speset
      case default
        call cubeadm_message(seve%e,rname,'Unsupported access mode')
        error = .true.
        return
      end select
    end select
    call cubeadm_message(admseve%others,rname,  &
      'Cube is ordered '//cubetools_accessname(cub%order())//  &
      ' and will be iterated with access '//cubetools_accessname(iter%access))
  end subroutine cubeadm_taskloop_cubedesc_fill
  !
  subroutine cubeadm_taskloop_iterator_compute(iter,ncube,align,merged,error)
    !-------------------------------------------------------------------
    ! Merge all the iterators to produce the final iterator
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    integer(kind=code_k),              intent(in)    :: align
    type(cubeadm_iterator_t),          intent(out)   :: merged
    logical,                           intent(inout) :: error
    !
    integer(kind=4) :: ref
    logical :: parallel
    real(kind=4) :: buftask
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='TASKLOOP>MERGE'
    !
    ! This subroutine is the core of the problem. It is intended to
    ! scale properly the entries and tasks, knowing all the input and
    ! output cubes. The main goal is to compute the number of planes
    ! per task, which must fit in the user limit (max task size).
    !
    ! However there are some tricky details like mixed accesses. For
    ! example HISTO3D reads three 2D images (imaset) and creates one 2D
    ! image (imaset) and one 3D cube (fullset).
    !
    ! Because of this, fullset-accessed cubes are excluded in the analysis
    ! below as they are not involved in the task sizing (100% of data
    ! treated by a single task).
    !
    ! Select the reference cube
    ref = cubeadm_taskloop_get_reference(iter,ncube,error)
    if (error)  return
    !
    ! Set the reference axes to each iterated cube
    call cubeadm_tuple_iterator_axes(iter,ncube,iter(ref)%cube,align,error)
    if (error)  return
    !
    ! Search for best nplane-per-task
    parallel = .false.
    !$ parallel = .true.
    if (parallel .and. .not.iter(ref)%access.eq.code_access_fullset) then
      buftask = iter(ref)%cube%user%buff%task
    else
      buftask = huge(0.)
    endif
    call cubeadm_taskloop_nrpperbuf(iter,ncube,buftask,merged%nppertask,error)
    if (error)  return
    call cubeadm_taskloop_neperplane(iter(ref),merged%neperplane,error)
    if (error)  return
    merged%np = iter(ref)%cube%iter%compute_nplane_total(error)
    if (error)  return
    !
    ! Total number of tasks and entries. Can not guess by simple divisions.
    ! Apply iterator for exact values.
    call cubeadm_taskloop_reset(merged,error)
    if (error) return
    do while (cubeadm_taskloop_iterate(merged,error))
      continue
    enddo
    if (error)  return
    merged%nt = merged%num
    merged%ne = merged%ole
    !
    write(mess,'(4(a,i0))')   &
      'Split job using ',merged%nt, &
      ' tasks (',merged%nppertask, &
      ' planes per task) for ',merged%ne, &
      ' entries'
    call cubeadm_message(admseve%others,rname,mess)
    !
    ! Reset iteration before real use
    call cubeadm_taskloop_reset(merged,error)
    if (error) return
  end subroutine cubeadm_taskloop_iterator_compute
  !
  subroutine cubeadm_tuple_iterator_axes(iter,ncube,refcube,align,error)
    !-------------------------------------------------------------------
    ! Set the current and reference axes for the given cube
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    class(format_t),                   intent(in)    :: refcube
    integer(kind=code_k),              intent(in)    :: align
    logical,                           intent(inout) :: error
    !
    integer(kind=entr_k) :: iiter
    class(format_t), pointer :: thiscube
    type(cuberegion_prog_t), pointer :: thisregion
    !
    do iiter=1,ncube
      thiscube   => iter(iiter)%cube
      thisregion => iter(iiter)%region
      if (associated(thisregion)) then
        call thisregion%apply_to_cube(thiscube,error,align)
        if (error)  return
      else
        call thiscube%default_region(error,align)
        if (error)  return
      endif
      call thiscube%iter%set_reference(refcube%iter,error)
      if (error)  return
    enddo
  end subroutine cubeadm_tuple_iterator_axes
  !
  subroutine cubeadm_taskloop_neperplane(iter,neperplane,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter
    integer(kind=entr_k),              intent(out)   :: neperplane
    logical,                           intent(inout) :: error
    !
    select case (iter%access)
    case (code_access_subset)
      neperplane = code_1entry_for_allplanes
    case (code_access_fullset)
      neperplane = code_1entry_for_allplanes
    case (code_access_imaset)
      neperplane = 1
    case (code_access_speset)
      neperplane = iter%cube%tuple%current%desc%nx
    end select
  end subroutine cubeadm_taskloop_neperplane
  !
  subroutine cubeadm_taskloop_nrpperbuf(iter,ncube,bufsize,nrpperbuf,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! Find the best (smallest) "Number of Reference Plane Per Block"
    !-------------------------------------------------------------------
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    real(kind=4),                      intent(in)    :: bufsize  ! [Bytes]
    integer(kind=entr_k),              intent(out)   :: nrpperbuf
    logical,                           intent(inout) :: error
    !
    integer(kind=entr_k) :: iiter,thisnrp
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TASKLOOP>NRPERBUF'
    !
    nrpperbuf = huge(0_entr_k)
    do iiter=1,ncube
      ! Fullset-accessed cubes are not involved in the best value
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      thisnrp = iter(iiter)%cube%iter%compute_nplane_per_buffer(bufsize,error)
      if (error)  return
      if (thisnrp.lt.nrpperbuf)  nrpperbuf = thisnrp
    enddo
    write(mess,'(i0,a,a)')  &
      nrpperbuf,' ref. planes per ',cubetools_format_memsize(bufsize)
    call cubeadm_message(admseve%others,rname,mess)
  end subroutine cubeadm_taskloop_nrpperbuf
  !
  function cubeadm_taskloop_get_reference(iter,ncube,error) result(ref_cube)
    !-------------------------------------------------------------------
    ! From the list of all cubes, choose the reference cube (i.e. used
    ! as reference for the iterations)
    !-------------------------------------------------------------------
    integer(kind=4) :: ref_cube  ! Function value on return
    integer(kind=entr_k),              intent(in)    :: ncube
    type(cubeadm_iterator_cubedesc_t), intent(in)    :: iter(ncube)
    logical,                           intent(inout) :: error
    !
    integer(kind=4) :: iiter
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TASKLOOP>GET>REFERENCE'
    !
    ref_cube = 0
    !
    ! 1) Preferably select an output cube with non-fullset access
    do iiter=1,ncube
      if (iter(iiter)%input)                          cycle
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 2) Otherwise select an input cube with non-fullset access
    do iiter=1,ncube
      if (.not.iter(iiter)%input)                     cycle
      if (iter(iiter)%access.eq.code_access_fullset)  cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 3) Otherwise select an output cube possibly with fullset access
    do iiter=1,ncube
      if (iter(iiter)%input)                          cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    ! 4) Otherwise select an input cube possibly with fullset access
    do iiter=1,ncube
      if (.not.iter(iiter)%input)                     cycle
      ref_cube = iiter
      exit
    enddo
    if (ref_cube.ne.0)  goto 10
    !
    call cubeadm_message(seve%e,rname,'Internal error: no cube reference cube found')
    error = .true.
    return
    !
10  continue
    write(mess,'(a,i0)')  'Reference cube is #',ref_cube
    call cubeadm_message(admseve%others,rname,mess)
  end function cubeadm_taskloop_get_reference
  !
  subroutine cubeadm_taskloop_reset(iter,error)
    !-------------------------------------------------------------------
    ! Reset iterator before iterating with cubeadm_taskloop_iterate
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    iter%num = 0
    iter%prange(2) = 0  ! So that 1st iteration starts at correct position
  end subroutine cubeadm_taskloop_reset
  !
  function cubeadm_taskloop_iterate(iter,error)
    !----------------------------------------------------------------------
    ! Iterate the iterator for next range of entries to be processed.
    ! Return .false. if no more data is to be processed.
    !----------------------------------------------------------------------
    logical :: cubeadm_taskloop_iterate
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>ITERATE'
    !
    if (.true.) then
      ! Plane-iterating mode
      cubeadm_taskloop_iterate = cubeadm_taskloop_iterate_planes(iter,error)
      if (error) return
    else
      ! Data-iterating mode
      ! cubeadm_taskloop_iterate = cubeadm_taskloop_iterate_data(iter,error)
      ! if (error) return
    endif
  end function cubeadm_taskloop_iterate
  !
  function cubeadm_taskloop_iterate_planes(iter,error)
    !----------------------------------------------------------------------
    ! Iterate the iterator for next range of PLANES to be processed.
    !
    ! Return .false. if no more data is to be processed.
    !----------------------------------------------------------------------
    logical :: cubeadm_taskloop_iterate_planes
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TASKLOOP>ITERATE>PLANES'
    integer(kind=entr_k) :: nplane,nentry
    character(len=message_length) :: mess
    !
    ! No welcome on purpose here!
    if (iter%prange(2).ge.iter%np) then
      ! Last entry iteration was processed on previous iteration: all done
      cubeadm_taskloop_iterate_planes = .false.
      return
    endif
    !
    ! Current task
    iter%num = iter%num+1
    !
    ! Reference planes
    iter%prange(1) = iter%prange(2)+1
    iter%prange(2) = min(iter%prange(1)+iter%nppertask-1,iter%np)
    nplane = iter%prange(2)-iter%prange(1)+1
    !
    ! Reference entries
    if (iter%neperplane.eq.code_1entry_for_allplanes) then
      ! 1 subcube for all planes in the task
      iter%ofe = iter%num
      iter%ole = iter%ofe
    else
      iter%ofe = (iter%num-1)*iter%nppertask*iter%neperplane+1
      iter%ole = iter%ofe + nplane*iter%neperplane - 1
    endif
    !
    ! Entries
    nentry = iter%ole-iter%ofe+1
    iter%ie = iter%ofe-1  ! Current entry, to be iterated with cubeadm_iterator_iterate_entry
    !
    cubeadm_taskloop_iterate_planes = .true.
    !
    write(mess,'(8(a,i0))')  &
      'Iterating task ',iter%num,  &
      ', entries ',iter%ofe,  &
      ' to ',iter%ole,  &
      ' (',nentry, &
      ' entries), planes ',iter%prange(1),  &
      ' to ',iter%prange(2),  &
      ' (',nplane, &
      ' planes)'
    call cubeadm_message(admseve%others,rname,mess)
  end function cubeadm_taskloop_iterate_planes
  !
  function cubeadm_iterator_iterate_entry(itertask,error)
    !-------------------------------------------------------------------
    ! Iterate the entry known by the current task iterator
    !-------------------------------------------------------------------
    logical :: cubeadm_iterator_iterate_entry
    class(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                   intent(inout) :: error
    !
    cubeadm_iterator_iterate_entry = .false.
    !
    if (itertask%ie.eq.itertask%ole)  return  ! All done
    !
    itertask%ie = itertask%ie+1
    call cubeadm_entryloop_iterate(itertask%ie,error)
    if (error)  return
    cubeadm_iterator_iterate_entry = .true.  ! New entry and no error
  end function cubeadm_iterator_iterate_entry
  !
end module cubeadm_taskloop
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mrtcal_interfaces_private
  interface
    subroutine mrtcal_calib_focus_bsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_level_codes
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_focus_bsw
  end interface
  !
  interface
    subroutine mrtcal_calib_otf_fsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_otf_fsw
  end interface
  !
  interface
    subroutine mrtcal_calib_otf_psw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_otf_psw
  end interface
  !
  interface
    subroutine mrtcal_get_next_otfpsw_cycle(mrtset,filebuf,backsci,error)
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! OTF PSW is an hybrid case between tracked PSW that only deals with
      ! subscan cycles and (WSW and FSW) that only deal with dump cycle. In
      ! OTF PSW, the ON is delivered as a dump, but the OFF is typically
      ! interpolated between two OFF subscans.
      !
      ! So here, we first read the current ON dump and put it in the
      ! cycle%data(1) structure, we then compute the OFF "phase" from one or
      ! two OFF subscans and put it in the cycle%data(2) structure. We can then
      ! fill the switching sections based on the cycle%desc structure.
      ! ---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_next_otfpsw_cycle
  end interface
  !
  interface
    subroutine mrtcal_otf_psw_read_surrounding_offs(mrtset,imbf,subscanbuf,backsci,error)
      use gkernel_types
      use mrtcal_buffer_types
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Get in the current list of subscans the number of the previous and 
      ! the next OFF subscans, read them, average them in time, and store 
      ! them into backsci%off
      !
      ! That's a stack. The code must start the previous OFF subscan, because 
      ! it probably is the current next OFF subscan, as the subscans are 
      ! ordered by increasing time. This saves data reading. Setting the 
      ! subscan number to zero means that we did not find either the previous 
      ! or the next off
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),            intent(in)    :: mrtset
      type(imbfits_t),                 intent(in)    :: imbf
      type(subscan_buffer_t),          intent(inout) :: subscanbuf
      type(science_backend_t), target, intent(inout) :: backsci
      logical,                         intent(inout) :: error
    end subroutine mrtcal_otf_psw_read_surrounding_offs
  end interface
  !
  interface
    subroutine mrtcal_otf_psw_interpolate_off_init(off,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! *** JP In output, interp%isub = prev%isub or interp%isub = next%isub
      ! *** JP It would be better to have the averaged value stored as a real
      ! *** JP If this subscan number is used at read time, some additional
      ! *** JP protection would be needed.
      !---------------------------------------------------------------------
      type(off_stack_t), target, intent(inout) :: off
      logical,                   intent(inout) :: error
    end subroutine mrtcal_otf_psw_interpolate_off_init
  end interface
  !
  interface
    subroutine mrtcal_otf_psw_prepare_nextoff(mrtset,filebuf,backsci,error)
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the OFF subscans surrounding the current ON subscan and prepare
      ! the linear interpolation in time, i.e., compute the segment slope and
      ! constant
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_otf_psw_prepare_nextoff
  end interface
  !
  interface
    subroutine mrtcal_otf_psw_select_off(mrtset,backsci,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Select the OFF subscan to be used. It can be either a linear
      ! interpolation of the previous and next OFF or the nearest neighbour
      ! in time. That's MRTSET%CAL%INTERPOFF that switches the behavior.
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),            intent(in)    :: mrtset
      type(science_backend_t), target, intent(inout) :: backsci
      logical,                         intent(inout) :: error
    end subroutine mrtcal_otf_psw_select_off
  end interface
  !
  interface
    subroutine mrtcal_calib_pointing_bsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_level_codes
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_pointing_bsw
  end interface
  !
  interface
    subroutine mrtcal_calib_tracked_fsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      use mrtcal_level_codes
      !---------------------------------------------------------------------
      ! @ private
      ! Gather all needed steps to read, calibrate, and write a 
      ! tracked frequency switched scan for a given backend
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_tracked_fsw
  end interface
  !
  interface
    subroutine mrtcal_calib_tracked_psw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gather all needed steps to read, calibrate, and write a 
      ! tracked position switched scan for a given backend
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_tracked_psw
  end interface
  !
  interface
    subroutine mrtcal_calib_tracked_psw_cycle(mrtset,imbf,ifirst,nswitch,  &
      subscanbuf,backcal,backsci,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Calibrate a TRACKED PSW cycle of subscans
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)            :: mrtset      !
      type(imbfits_t),         intent(in)            :: imbf        !
      integer(kind=4),         intent(in)            :: ifirst      ! First subscan in cycle
      integer(kind=4),         intent(in)            :: nswitch     ! Number of subscans in cycle
      type(subscan_buffer_t),  intent(inout)         :: subscanbuf  !
      type(calib_backend_t),   intent(in)            :: backcal     !
      type(science_backend_t), intent(inout), target :: backsci     !
      logical,                 intent(inout)         :: error       ! Logical error flag
    end subroutine mrtcal_calib_tracked_psw_cycle
  end interface
  !
  interface
    subroutine mrtcal_calib_tracked_wsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_level_codes
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gather all needed steps to read, calibrate, and write a 
      ! tracked wobbler switched scan for a given backend
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_calib_tracked_wsw
  end interface
  !
  interface
    subroutine reallocate_calib_scan(n,calarray,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate calibration arrays
      !-------------------------------------------------------------------
      integer(kind=4),    intent(in)    :: n
      type(calib_scan_t), intent(inout) :: calarray
      logical,            intent(inout) :: error
    end subroutine reallocate_calib_scan
  end interface
  !
  interface
    subroutine reallocate_science_scan(n,sciarray,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate science arrays
      !-------------------------------------------------------------------
      integer(kind=4),              intent(in)    :: n
      type(science_scan_t), target, intent(inout) :: sciarray
      logical,                      intent(inout) :: error
    end subroutine reallocate_science_scan
  end interface
  !
  interface
    subroutine reallocate_backend_list(n,backarray,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate backend list arrays
      !-------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: n
      type(backend_list_t), intent(inout) :: backarray
      logical,              intent(inout) :: error
    end subroutine reallocate_backend_list
  end interface
  !
  interface
    subroutine reallocate_subscan_list(n,list,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate subscan list arrays
      !-------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: n
      type(subscan_list_t), intent(inout) :: list
      logical,              intent(inout) :: error
    end subroutine reallocate_subscan_list
  end interface
  !
  interface
    subroutine reallocate_switch_desc(noffset,nfront,desc,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate switch desc arrays
      !-------------------------------------------------------------------
      integer(kind=4),     intent(in)    :: noffset
      integer(kind=4),     intent(in)    :: nfront
      type(switch_desc_t), intent(inout) :: desc
      logical,             intent(inout) :: error
    end subroutine reallocate_switch_desc
  end interface
  !
  interface
    subroutine reallocate_switch_on_or_off_index(n,idx,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate switch on or off index arrays
      !-------------------------------------------------------------------
      integer(kind=4),                intent(in)    :: n
      type(switch_on_or_off_index_t), intent(inout) :: idx
      logical,                        intent(inout) :: error
    end subroutine reallocate_switch_on_or_off_index
  end interface
  !
  interface
    subroutine reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocate cycle arrays
      !-------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: ndump
      integer(kind=4),      intent(in)    :: npha
      integer(kind=4),      intent(in)    :: non
      integer(kind=4),      intent(in)    :: noff
      integer(kind=4),      intent(in)    :: nfront
      type(switch_cycle_t), intent(inout) :: cycle
      logical,              intent(inout) :: error
    end subroutine reallocate_switch_cycle
  end interface
  !
  interface
    subroutine free_backend_list(backarray,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(backend_list_t), intent(inout) :: backarray
      logical,              intent(inout) :: error
    end subroutine free_backend_list
  end interface
  !
  interface
    subroutine reallocate_dble_1d(r8,newndata,keep,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Reallocate a simple 1D REAL*8 pointer
      !---------------------------------------------------------------------
      real(kind=8),    pointer       :: r8(:)     !
      integer(kind=4), intent(in)    :: newndata  !
      logical,         intent(in)    :: keep      !
      logical,         intent(inout) :: error     !
    end subroutine reallocate_dble_1d
  end interface
  !
  interface
    subroutine mrtcal_bookkeeping_init_time(bufsize,subs,time,error)
      use ram_sizes
      use imbfits_types
      use mrtcal_bookkeeping_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize a time loop
      !---------------------------------------------------------------------
      integer(kind=8),         intent(in)    :: bufsize
      type(imbfits_subscan_t), intent(in)    :: subs
      type(book_t),            intent(inout) :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_bookkeeping_init_time
  end interface
  !
  interface
    subroutine mrtcal_bookkeeping_iterate(time,subs,first,last,needupdate,error)
      use imbfits_types
      use mrtcal_bookkeeping_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the time%cur% structure suited for reading at least dumps
      ! 'first' to 'last'. They are the first and last dumps the caller
      ! wants to be present AT LEAST in the buffer. 'first' and 'last' are
      ! absolute positions in the compressed backdata columns.
      !---------------------------------------------------------------------
      type(book_t),            intent(inout) :: time
      type(imbfits_subscan_t), intent(in)    :: subs
      integer(kind=4),         intent(in)    :: first
      integer(kind=4),         intent(in)    :: last
      logical,                 intent(out)   :: needupdate
      logical,                 intent(inout) :: error
    end subroutine mrtcal_bookkeeping_iterate
  end interface
  !
  interface
    subroutine mrtcal_bookkeeping_compr2uncompr(compr,backpoin,uncompr,error)
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      !   Convert a "compressed" range_t (i.e. providing indices in the
      ! compressed columns to an "uncompressed" range_t.
      !   "compressed" columns are present in the BackendData e.g. if SET
      ! CALIB BAD is NO
      !---------------------------------------------------------------------
      type(range_t),   intent(in)    :: compr        !
      integer(kind=4), intent(in)    :: backpoin(:)  ! Back-pointer array
      type(range_t),   intent(out)   :: uncompr      !
      logical,         intent(inout) :: error        !
    end subroutine mrtcal_bookkeeping_compr2uncompr
  end interface
  !
  interface
    subroutine mrtcal_init_scan_cal(backsci,imbf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_t),         intent(inout) :: imbf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_init_scan_cal
  end interface
  !
  interface
    subroutine mrtcal_init_accumulate_or_write(obstype,swmode,iset,oset,error)
      use mrtcal_messaging
      use mrtindex_parameters
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Set up the accumulation mode according to user's MSET OUTPUT
      ! INTEGRATION choice, and to observing mode in case of automatic
      ! choice.
      !---------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: obstype  ! [code] Observing type
      integer(kind=4),      intent(in)    :: swmode   ! [code] Switching mode
      type(mrtcal_setup_t), intent(in)    :: iset     ! Setup (user choices)
      type(mrtcal_setup_t), intent(inout) :: oset     ! Setup (resolved)
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_init_accumulate_or_write
  end interface
  !
  interface
    subroutine mrtcal_write_cycle(setout,backsci,error)
      use mrtcal_setup_types
      use mrtcal_calib_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_output_t), intent(in)    :: setout
      type(science_backend_t),     intent(inout) :: backsci
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_cycle
  end interface
  !
  interface
    subroutine mrtcal_write_subscan(setout,backsci,error)
      use mrtcal_setup_types
      use mrtcal_calib_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_output_t), intent(in)    :: setout
      type(science_backend_t),     intent(inout) :: backsci
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_subscan
  end interface
  !
  interface
    subroutine mrtcal_write_scan(setout,backsci,error)
      use mrtcal_setup_types
      use mrtcal_calib_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_output_t), intent(in)    :: setout
      type(science_backend_t),     intent(inout) :: backsci
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_scan
  end interface
  !
  interface
    subroutine mrtcal_accumulate_or_write(level_code,mrtset,backsci,error)
      use mrtcal_messaging
      use mrtcal_level_codes
      use mrtcal_setup_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: level_code
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_accumulate_or_write
  end interface
  !
  interface
    subroutine mrtcal_append_or_write(level_code,mrtset,backsci,error)
      use mrtcal_messaging
      use mrtcal_level_codes
      use mrtcal_setup_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Append chunk_t to the 'cumul' set, or write the 'cumul' set
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: level_code
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_append_or_write
  end interface
  !
  interface
    subroutine mrtcal_append_init(backsci,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize the 'cumul' set in preparation for next appends
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_append_init
  end interface
  !
  interface
    subroutine mrtcal_append(mrtset,backsci,error)
      use mrtcal_setup_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Append chunk_t to the 'cumul' set
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_append
  end interface
  !
  interface
    subroutine mrtcal_init_refloop(backsci,nref,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize the loop on REF subscans, i.e., number of REF.
      ! Enforce initialization of the cumulated chunkset_2d structure if and when needed
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      integer(kind=4),         intent(out)   :: nref
      logical,                 intent(inout) :: error
    end subroutine mrtcal_init_refloop
  end interface
  !
  interface
    subroutine mrtcal_get_nextref(backsci,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Update the REF number
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_nextref
  end interface
  !
  interface
    subroutine mrtcal_init_onloop(backsci,non,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize the loop on ON subscans, i.e., number of ON, current on and
      ! OFF subscan numbers
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      integer(kind=4),         intent(out)   :: non
      logical,                 intent(inout) :: error
    end subroutine mrtcal_init_onloop
  end interface
  !
  interface
    subroutine mrtcal_get_nexton(backsci,error)
      use gkernel_types
      use imbfits_types
      use mrtcal_calib_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Get in the current list of subscans the number of next ON subscan
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_nexton
  end interface
  !
  interface
    subroutine mrtcal_sanity_check(backsci,error)
      use mrtcal_calib_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Check whether ON and OFF subscans are red and give user feedback
      ! about the next processing step
      !---------------------------------------------------------------------
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_sanity_check
  end interface
  !
  interface
    subroutine mrtcal_init_dumpcycle_loop(name,mrtset,filebuf,backsci,error)
      use mrtcal_buffer_types
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: name
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_init_dumpcycle_loop
  end interface
  !
  interface
    subroutine mrtcal_init_dumpcycle_book(time,switch,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(book_t),   intent(in)    :: time
      type(switch_t), intent(inout) :: switch
      logical,        intent(inout) :: error
    end subroutine mrtcal_init_dumpcycle_book
  end interface
  !
  interface
    subroutine mrtcal_get_next_dumpcycle(mrtset,filebuf,backsci,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Search for and then read next cycle
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)            :: mrtset
      type(imbfits_buffer_t),  intent(inout)         :: filebuf
      type(science_backend_t), intent(inout), target :: backsci
      logical,                 intent(inout)         :: error
    end subroutine mrtcal_get_next_dumpcycle
  end interface
  !
  interface
    subroutine mrtcal_find_next_dumpcycle(backdata,book,error)
      use mrtcal_messaging
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Search for cycle phases in increasing order and return when found.
      ! If the cycle is incomplete, try to find the next cycle.
      ! Return with found = .false. when it tries to read past the last dump
      ! of the subscan.
      ! Caution: Modifying this code can lead to infinite loops...
      !---------------------------------------------------------------------
      type(imbfits_backdata_t), intent(in)    :: backdata
      type(switch_book_t),      intent(inout) :: book
      logical,                  intent(inout) :: error
    end subroutine mrtcal_find_next_dumpcycle
  end interface
  !
  interface
    subroutine mrtcal_read_next_dumpcycle(setup,imbf,subshead,databuf,switch,error)
      use mrtcal_messaging
      use imbfits_types
      use mrtcal_setup_types
      use mrtcal_buffer_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: setup
      type(imbfits_t),         intent(in)    :: imbf
      type(imbfits_subscan_t), intent(in)    :: subshead
      type(data_buffer_t),     intent(inout) :: databuf
      type(switch_t),          intent(inout) :: switch
      logical,                 intent(inout) :: error
    end subroutine mrtcal_read_next_dumpcycle
  end interface
  !
  interface
    subroutine mrtcal_update_databuf(setup,imbf,subshead,book,databuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Update (only IF NEEDED) the DATA buffer currently in memory
      ! according to the switching cycle described in 'switch'. As output
      ! the subroutine guarantees that (at least) this cycle is entirely in
      ! the DATA buffer.
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: setup
      type(imbfits_t),         intent(in)    :: imbf
      type(imbfits_subscan_t), intent(in)    :: subshead
      type(switch_book_t),     intent(in)    :: book
      type(data_buffer_t),     intent(inout) :: databuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_update_databuf
  end interface
  !
  interface
    subroutine mrtcal_fill_dumpphase(iphase,subshead,databuf,book,dump,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: iphase
      type(imbfits_subscan_t), intent(in)    :: subshead
      type(data_buffer_t),     intent(in)    :: databuf
      type(switch_book_t),     intent(in)    :: book
      type(chunkset_2d_t),     intent(inout) :: dump
      logical,                 intent(inout) :: error
    end subroutine mrtcal_fill_dumpphase
  end interface
  !
  interface
    subroutine mrtcal_calib_calibration(mrtset,filebuf,backcal,error)
      use mrtcal_buffer_types
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !
      !  1. Check the polarimetry status of the calibration scan.
      !  2. Read the calambient, calcold subscan in the order they
      !     appear in the IMBFITS and compute the mean counts over the channels.
      !  3. Read the calsky when it exists (it probably needs to rewind a bit
      !     the file before reading it) or mock it.
      !  4. Fill the chopper structure, compute the Tamt, Trec, Tsys, and Tcal,
      !     and fill the chunkset structure with these results.
      !  5. Calibrate the grid subscan when it is available.
      !  6. List results on screen and write results in the output CLASS file.
      !
      !  When the calsky is the only missing subscan, we can still compute an
      !  approximated receiver temperature (i.e., assuming 100% coupling to the
      !  hot and cold loads). To do this, we create a blanked calsky so that we
      !  can use exactly the same steps/pieces of code. It's only in the
      !  chopper code that we'll catch the fact we can only compute the Trec.  
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),   intent(in)    :: mrtset
      type(imbfits_buffer_t), intent(inout) :: filebuf
      type(calib_backend_t),  intent(inout) :: backcal
      logical,                intent(inout) :: error
    end subroutine mrtcal_calib_calibration
  end interface
  !
  interface
    subroutine mrtcal_calibrate_toclass(mrtset,backcal,error)
      use chopper_definitions
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),  intent(in)    :: mrtset
      type(calib_backend_t), intent(inout) :: backcal
      logical,               intent(inout) :: error
    end subroutine mrtcal_calibrate_toclass
  end interface
  !
  interface
    subroutine mrtcal_calibrate_user_feedback(backcal,setout,error)
      use mrtcal_messaging
      use mrtcal_buffers
      use mrtcal_calib_types
      use mrtcal_setup_types
      use mrtcal_user_feedback_tool
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t), target, intent(in)    :: backcal
      type(mrtcal_setup_output_t),   intent(in)    :: setout
      logical,                       intent(inout) :: error
    end subroutine mrtcal_calibrate_user_feedback
  end interface
  !
  interface
    subroutine mrtcal_calibrate_compute_chopperset(backcal,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t), intent(inout) :: backcal
      logical,               intent(inout) :: error
    end subroutine mrtcal_calibrate_compute_chopperset
  end interface
  !
  interface
    subroutine mrtcal_calibrate_chunkset2chopperset(backcal,mrtset,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      use mrtcal_chopperset_tools
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t), intent(inout), target :: backcal
      type(mrtcal_setup_t),  intent(in)            :: mrtset
      logical,               intent(inout)         :: error
    end subroutine mrtcal_calibrate_chunkset2chopperset
  end interface
  !
  interface
    subroutine mrtcal_calibrate_chopperset2chunkset(backcal,mrtset,error)
      use mrtcal_messaging
      use chopper_definitions
      use mrtcal_calib_types
      use mrtcal_chopperset_tools
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t), target, intent(inout) :: backcal
      type(mrtcal_setup_t),          intent(in)    :: mrtset
      logical,                       intent(inout) :: error
    end subroutine mrtcal_calibrate_chopperset2chunkset
  end interface
  !
  interface
    subroutine mrtcal_calibrate_average_load(mrtset,name,imbf,subscanbuf,load,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),   intent(in)    :: mrtset
      character(len=*),       intent(in)    :: name
      type(imbfits_t),        intent(in)    :: imbf
      type(subscan_buffer_t), intent(inout) :: subscanbuf
      type(chunkset_2d_t),    intent(inout) :: load
      logical,                intent(inout) :: error
    end subroutine mrtcal_calibrate_average_load
  end interface
  !
  interface
    subroutine mrtcal_calibrate_grid(mrtset,imbf,subscanbuf,backcal,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),   intent(in)    :: mrtset
      type(imbfits_t),        intent(in)    :: imbf
      type(subscan_buffer_t), intent(inout) :: subscanbuf
      type(calib_backend_t),  intent(inout) :: backcal
      logical,                intent(inout) :: error
    end subroutine mrtcal_calibrate_grid
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_calgrid(chunksetlist,grid_2d,amppha_2d,sincos_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: chunksetlist
      type(chunkset_2d_t), target, intent(in)    :: grid_2d
      type(chunkset_2d_t), target, intent(inout) :: amppha_2d
      type(chunkset_2d_t), target, intent(inout) :: sincos_2d
      logical,                     intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_calgrid
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_cross(chunksetlist,operation,chunkset_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: chunksetlist
      type(chunkset_2d_t), target, intent(inout) :: chunkset_2d
      logical,                     intent(inout) :: error
      external :: operation
    end subroutine mrtcal_chunkset_2d_cross
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_modify_source(source,chunkset_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),    intent(in)    :: source
      type(chunkset_2d_t), intent(inout) :: chunkset_2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_modify_source
  end interface
  !
  interface
    subroutine mrtcal_gr8_median(data,ndata,bval,eval,median,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! *** JP Trick because gr8_median does not return the blanking
      ! *** JP value when there is no valid data
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: ndata        ! Array size
      real(kind=8),              intent(in)    :: data(ndata)  ! Data
      real(kind=8),              intent(in)    :: bval         ! Blanking value
      real(kind=8),              intent(in)    :: eval         ! Tolerance
      real(kind=8),              intent(inout) :: median       ! Median of input array
      logical,                   intent(inout) :: error        ! Logical error flag
    end subroutine mrtcal_gr8_median
  end interface
  !
  interface
    subroutine mrtcal_check_substype(ith,name,subheader,error)
      use mrtcal_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: ith
      character(len=*),        intent(in)    :: name
      type(imbfits_subscan_t), intent(in)    :: subheader
      logical,                 intent(inout) :: error
    end subroutine mrtcal_check_substype
  end interface
  !
  interface
    subroutine mrtcal_average_times(mrtset,iscal,ith,name,imbf,subscanbuf,averaged,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! We read the imbfits data in a limited size buffer. To do this, we
      ! read it by part. Thus, there is no reason to keep it in the main
      ! structure. We keep only the product, i.e. the time average...
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),   intent(in)    :: mrtset
      logical,                intent(in)    :: iscal
      integer(kind=4),        intent(in)    :: ith
      character(len=*),       intent(in)    :: name
      type(imbfits_t),        intent(in)    :: imbf
      type(subscan_buffer_t), intent(inout) :: subscanbuf
      type(chunkset_2d_t),    intent(inout) :: averaged
      logical,                intent(inout) :: error
    end subroutine mrtcal_average_times
  end interface
  !
  interface
    subroutine mrtcal_average_time_init(elevation,chunkset_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !  Initialize the input array of chunksets:
      !  - the data and weights arrays (Npix x Nset) are filled with zeros,
      !---------------------------------------------------------------------
      real(kind=8),        intent(in)    :: elevation    ! Double in contrast with CLASS header
      type(chunkset_2d_t), intent(inout) :: chunkset_2d  !
      logical,             intent(inout) :: error        !
    end subroutine mrtcal_average_time_init
  end interface
  !
  interface
    subroutine mrtcal_average_time_range(chunkset_3d,chunkset_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !  Average all the chunksets from the input chunkset_3d into the
      ! output chunkset_2d.
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(in)    :: chunkset_3d
      type(chunkset_2d_t), intent(inout) :: chunkset_2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_average_time_range
  end interface
  !
  interface
    subroutine mrtcal_average_channels(chunkset_2d,error)
      use gildas_def
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(inout) :: chunkset_2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_average_channels
  end interface
  !
  interface
    subroutine mrtcal_compute_opacity_corr(tauzen,current,expatau,error)
      use mrtcal_messaging
      use phys_const
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the opacity correction for all the chunks of a chunkset_2d
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: tauzen
      type(chunkset_2d_t), intent(in)    :: current
      type(chunkset_2d_t), intent(inout) :: expatau
      logical,             intent(inout) :: error
    end subroutine mrtcal_compute_opacity_corr
  end interface
  !
  interface
    subroutine mrtcal_compute_opacity_corr_data(bad,nchan,airmass,tauzen,expatau,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the opacity correction, i.e., exp( airmass * tauzen ), as
      ! a function of the frequency
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)    :: bad
      integer(kind=4), intent(in)    :: nchan
      real(kind=4),    intent(in)    :: airmass
      real(kind=4),    intent(in)    :: tauzen(nchan)
      real(kind=4),    intent(out)   :: expatau(nchan)
      logical,         intent(inout) :: error
    end subroutine mrtcal_compute_opacity_corr_data
  end interface
  !
  interface
    subroutine mrtcal_compute_opacity_corr_head(airmass,chunk,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the opacity correction, i.e., exp( airmass * tauzen )
      ! *** JP it could be some kind of average or median value
      !---------------------------------------------------------------------
      real(kind=4),  intent(in)    :: airmass
      type(chunk_t), intent(inout) :: chunk
      logical,       intent(inout) :: error
    end subroutine mrtcal_compute_opacity_corr_head
  end interface
  !
  interface
    subroutine mrtcal_on_minus_off(isotfmap,isfsw,backsci,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute ON-OFF and update the associated header
      !---------------------------------------------------------------------
      logical,                         intent(in)    :: isotfmap
      logical,                         intent(in)    :: isfsw
      type(science_backend_t), target, intent(inout) :: backsci
      logical,                         intent(inout) :: error
    end subroutine mrtcal_on_minus_off
  end interface
  !
  interface
    subroutine mrtcal_on_minus_off_new(isotfmap,isfsw,backcal,backsci,error)
      use mrtcal_messaging
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute ON-OFF and update the associated header
      !---------------------------------------------------------------------
      logical,                         intent(in)    :: isotfmap
      logical,                         intent(in)    :: isfsw
      type(calib_backend_t),   target, intent(in)    :: backcal
      type(science_backend_t), target, intent(inout) :: backsci
      logical,                         intent(inout) :: error
    end subroutine mrtcal_on_minus_off_new
  end interface
  !
  interface
    subroutine mrtcal_on_minus_off_head(isotfmap,idxon,idxoff,on,off,diff,error)
      use mrtcal_messaging
      use gildas_def
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Update the ON-OFF time and noise
      !---------------------------------------------------------------------
      logical,                        intent(in)    :: isotfmap
      type(switch_on_or_off_index_t), intent(in)    :: idxon
      type(switch_on_or_off_index_t), intent(in)    :: idxoff
      type(chunk_t),                  intent(in)    :: on
      type(chunk_t),                  intent(in)    :: off
      type(chunk_t),                  intent(inout) :: diff
      logical,                        intent(inout) :: error
    end subroutine mrtcal_on_minus_off_head
  end interface
  !
  interface
    subroutine mrtcal_on_minus_off_data_auto(bad,nchan,on,off,diff)
      use mrtcal_messaging
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Compute:  ON/OFF - 1
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)  :: bad
      integer(kind=4), intent(in)  :: nchan
      real(kind=4),    intent(in)  :: on(nchan)
      real(kind=4),    intent(in)  :: off(nchan)
      real(kind=4),    intent(out) :: diff(nchan)
    end subroutine mrtcal_on_minus_off_data_auto
  end interface
  !
  interface
    subroutine mrtcal_on_minus_off_data_cross(bad,nchan,on,off,auto1,auto2,diff)
      use mrtcal_messaging
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Compute:  (ON-OFF)/sqrt(AUTO1*AUTO2)
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)  :: bad
      integer(kind=4), intent(in)  :: nchan
      real(kind=4),    intent(in)  :: on(nchan)
      real(kind=4),    intent(in)  :: off(nchan)
      real(kind=4),    intent(in)  :: auto1(nchan)
      real(kind=4),    intent(in)  :: auto2(nchan)
      real(kind=4),    intent(out) :: diff(nchan)
    end subroutine mrtcal_on_minus_off_data_cross
  end interface
  !
  interface
    subroutine mrtcal_tscale_computation(backcal,backsci,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      logical,                 intent(inout) :: error
    end subroutine mrtcal_tscale_computation
  end interface
  !
  interface
    subroutine mrtcal_tscale_application(tscale,inout,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Multiply the data spectra by the tscale spectra
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: tscale
      type(chunkset_3d_t), intent(inout) :: inout
      logical,             intent(inout) :: error
    end subroutine mrtcal_tscale_application
  end interface
  !
  interface
    subroutine mrtcal_fill_switch_section(cycle,error)
      use mrtcal_messaging
      use gbl_constant
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(switch_cycle_t), intent(inout) :: cycle
      logical,              intent(inout) :: error
    end subroutine mrtcal_fill_switch_section
  end interface
  !
  interface
    subroutine mrtcal_calib_command(line,error)
      use mrtcal_messaging
      use mrtcal_parameters
      use mrtcal_buffers
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! CALIBRATE ient
      ! 1. /WITH ical
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_calib_command
  end interface
  !
  interface
    subroutine mrtcal_solve_command(line,error)
      use mrtcal_messaging
      use mrtcal_parameters
      use mrtcal_buffers
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! SOLVE ient
      ! 1. /WITH ical
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_solve_command
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_parse(line,ientuser,icaluser,error)
      use mrtcal_messaging
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! CALIBRATE | SOLVE ient
      ! 1. /WITH ical
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: line
      integer(kind=entry_length), intent(out)   :: ientuser
      integer(kind=entry_length), intent(out)   :: icaluser
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_parse
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_ix_entry(commcode,mrtset,ix,ientuser,icaluser,filebuf,  &
         calib,science,error)
      use mrtcal_messaging
      use mrtcal_parameters
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),            intent(in)    :: commcode
      type(mrtcal_setup_t),       intent(in)    :: mrtset
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(inout) :: ientuser
      integer(kind=entry_length), intent(inout) :: icaluser
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(calib_t),              intent(inout) :: calib
      type(science_t),            intent(inout) :: science
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_ix_entry
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,icaluser,filebuf,  &
         calib,error)
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Calibrate the 'icaluser' entry (calibration scan) in IX
      ! Return the new (calibrated) entry number in 'icaluser'.
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),       intent(in)    :: mrtset
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(inout) :: icaluser
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(calib_t),              intent(inout) :: calib
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_ix_entry_calib
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_get_backid(idx,ient,backid,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Return the backend identifier for the i-th entry in the input index
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      integer(kind=entry_length), intent(in)    :: ient
      integer(kind=4),            intent(out)   :: backid
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_get_backid
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_autofind_matching_cal(idx,backward,mtole,ientuser,  &
      istart,jcalprog,error)
      use phys_const
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !   Automatic search of the previous or next matching calibration in
      ! the input index, starting from the istart entry.
      !   The returned scan will be:
      !    - a calibration (obstype)
      !    - with calibration status none or done (reject failed or empty)
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      logical,                    intent(in)    :: backward  ! Backward or forward search?
      real(kind=4),               intent(in)    :: mtole     ! [min] Tolerance
      integer(kind=entry_length), intent(in)    :: ientuser
      integer(kind=entry_length), intent(inout) :: istart
      integer(kind=entry_length), intent(out)   :: jcalprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_autofind_matching_cal
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_autofind_done_cal(mrtset,ix,ientuser,jcalprog,filebuf,calib,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Automatic search of the nearest matching calibration in the input index.
      ! Calibrate it when needed
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),       intent(in)    :: mrtset
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(in)    :: ientuser
      integer(kind=entry_length), intent(out)   :: jcalprog
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(calib_t),              intent(inout) :: calib
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_autofind_done_cal
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_check_consistency(idx,ient,ical,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      integer(kind=entry_length), intent(in)    :: ient
      integer(kind=entry_length), intent(inout) :: ical
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_check_consistency
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_check_obstype_is_cal(idx,ical,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      integer(kind=entry_length), intent(inout) :: ical
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_check_obstype_is_cal
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_check_calstatus(idx,ical,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      integer(kind=entry_length), intent(in)    :: ical
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_check_calstatus
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_check_current(idx,ical,backcal,warn,same,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !  Check if the calibration scan given as argument is the ical-th
      ! entry in the index. Issue warning messages if needed.
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: idx
      integer(kind=entry_length), intent(in)    :: ical
      type(calib_backend_t),      intent(in)    :: backcal
      logical,                    intent(in)    :: warn
      logical,                    intent(out)   :: same
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_check_current
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_reload(mrtset,idx,ient,filebuf,calib,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_calib_types
      use mrtindex_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),       intent(in)    :: mrtset
      type(mrtindex_optimize_t),  intent(inout) :: idx
      integer(kind=entry_length), intent(inout) :: ient
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(calib_t),              intent(inout) :: calib
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_reload
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_feedback(idx,ient,ical,warnlim,error)
      use phys_const
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)           :: idx
      integer(kind=entry_length), intent(in)           :: ient
      integer(kind=entry_length), intent(in), optional :: ical
      real(kind=4),               intent(in), optional :: warnlim
      logical,                    intent(inout)        :: error
    end subroutine mrtcal_calib_or_solve_feedback
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_init_calib(ix,ientuser,ientprog,error)
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Prepare a new entry for a calibration scan
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(in)    :: ientuser
      integer(kind=entry_length), intent(out)   :: ientprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_init_calib
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_init_science(ix,ientuser,ientprog,error)
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Prepare a new entry for a science scan
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),    intent(inout) :: ix
      integer(kind=entry_length), intent(in)    :: ientuser
      integer(kind=entry_length), intent(out)   :: ientprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_init_science
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_init(ix,iscalib,ientuser,ientprog,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Do not call directly! Call mrtcal_calib_or_solve_init_calib or
      ! mrtcal_calib_or_solve_init_science instead.
      ! ---
      ! Copy the ient entry of the input index into a new entry. Then set 
      ! in place its calstatus to calstatus_failed. This status will
      ! be replaced in place by calstatus_done in mrtcal_calib_or_solve_exit_*
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(inout) :: ix
      logical,                    intent(in)    :: iscalib
      integer(kind=entry_length), intent(in)    :: ientuser
      integer(kind=entry_length), intent(out)   :: ientprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_init
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_exit_calib(cal,ix,ientprog,error)
      use mrtcal_messaging
      use mrtindex_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_work_t), intent(inout) :: cal
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(in)    :: ientprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_exit_calib
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_exit_science(sci,ix,isciprog,icalprog,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(science_backend_t),    intent(in)    :: sci
      type(mrtindex_optimize_t),  intent(inout) :: ix
      integer(kind=entry_length), intent(in)    :: isciprog
      integer(kind=entry_length), intent(in)    :: icalprog
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_exit_science
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_onebackend_calibration(mrtset,scanidx,ient,filebuf,&
         backcal,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),       intent(in)    :: mrtset
      type(mrtindex_optimize_t),  intent(in)    :: scanidx
      integer(kind=entry_length), intent(in)    :: ient
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(calib_backend_t),      intent(inout) :: backcal
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_onebackend_calibration
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_onebackend_science(commcode,doset,backcal,&
         scanidx,ient,filebuf, backsci,error)
      use mrtcal_messaging
      use mrtcal_parameters
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),            intent(in)    :: commcode
      type(mrtcal_setup_t),       intent(in)    :: doset    ! Setup (user choices)
      type(calib_backend_t),      intent(in)    :: backcal
      type(mrtindex_optimize_t),  intent(in)    :: scanidx
      integer(kind=entry_length), intent(in)    :: ient
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(science_backend_t),    intent(inout) :: backsci
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_onebackend_science
  end interface
  !
  interface
    subroutine mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,head,error)
      use mrtcal_messaging
      use classic_api
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t),  intent(in)    :: scanidx
      integer(kind=entry_length), intent(in)    :: ient
      type(imbfits_buffer_t),     intent(inout) :: filebuf
      type(mrtindex_header_t),    intent(inout) :: head
      logical,                    intent(inout) :: error
    end subroutine mrtcal_calib_or_solve_read_backend_header
  end interface
  !
  interface
    subroutine mrtcal_chunksets_from_data(imbf,subs,databuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      ! Extract all chunks from DATA.
      !---------------------------------------------------------------------
      type(imbfits_t), target, intent(in)    :: imbf
      type(imbfits_subscan_t), intent(in)    :: subs
      type(data_buffer_t),     intent(inout) :: databuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_chunksets_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunksets_from_data_1time1pix(imbf,subs,data,weight,  &
         ipix,itime,chunks,set,error)
      use imbfits_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gather the chunks by sets, for 1 time dump and 1 receiver pixel.
      !---------------------------------------------------------------------
      type(imbfits_t),             intent(in)    :: imbf
      type(imbfits_subscan_t),     intent(in)    :: subs
      real(kind=4),                intent(inout) :: data(:)    ! Input data values
      real(kind=4),                intent(in)    :: weight(:)  ! Input data weights
      integer(kind=4),             intent(in)    :: ipix
      integer(kind=4),             intent(in)    :: itime
      type(imbfits_back_chunks_t), intent(in)    :: chunks     ! Chunks description
      type(chunkset_t),            intent(inout) :: set(:)     ! Output chunksets
      logical,                     intent(inout) :: error
    end subroutine mrtcal_chunksets_from_data_1time1pix
  end interface
  !
  interface
    subroutine mrtcal_chunksets_from_data_1time1pix_1chunk(subs,data,weight,  &
      ipix,itime,ichunk,primary,scan,front,back,derot,chunk,error)
      use mrtcal_calib_types
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the 'chunk' instance with correct values and data, from given
      ! IMBFITS tables.
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      real(kind=4),            intent(inout) :: data(:)    ! Input data values
      real(kind=4),            intent(in)    :: weight(:)  ! Input data weights
      integer(kind=4),         intent(in)    :: ipix
      integer(kind=4),         intent(in)    :: itime
      integer(kind=4),         intent(in)    :: ichunk     ! Chunk position in the backend table
      type(imbfits_primary_t), intent(in)    :: primary
      type(imbfits_scan_t),    intent(in)    :: scan
      type(imbfits_front_t),   intent(in)    :: front
      type(imbfits_back_t),    intent(in)    :: back
      type(imbfits_derot_t),   intent(in)    :: derot
      type(chunk_t),           intent(inout) :: chunk      ! The chunk to be filled
      logical,                 intent(inout) :: error
    end subroutine mrtcal_chunksets_from_data_1time1pix_1chunk
  end interface
  !
  interface
    subroutine mrtcal_chunk_data_from_data(dataval,datawei,backe,ichunk,  &
         chunk,error)
      use imbfits_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Extract one chunk from DATA
      !---------------------------------------------------------------------
      real(kind=4), target, intent(inout) :: dataval(:)  ! inout because of sign flip
      real(kind=4), target, intent(in)    :: datawei(:)
      type(imbfits_back_t), intent(in)    :: backe
      integer(kind=4),      intent(in)    :: ichunk
      type(chunk_t),        intent(inout) :: chunk
      logical,              intent(inout) :: error
    end subroutine mrtcal_chunk_data_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_cal_from_data(scan,front,ifront,cal,error)
      use mrtcal_messaging
      use phys_const
      use class_types
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_scan_t),    intent(in)    :: scan
      type(imbfits_front_t),   intent(in)    :: front
      integer(kind=4),         intent(in)    :: ifront
      type(class_calib_t),     intent(out)   :: cal
      logical,                 intent(inout) :: error
    end subroutine mrtcal_chunk_cal_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_spe_from_data(antslow,front,ifront,back,ichunk,spe,error)
      use mrtcal_messaging
      use gbl_constant
      use phys_const
      use class_types
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! It is unclear whether at this stage we want the freq/vel axis
      ! to be defined in the source or the observatory frame *** JP
      ! Right now it is defined in the source frame
      !
      ! Order matters here!...
      !
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(in)    :: antslow
      type(imbfits_front_t),   intent(in)    :: front
      integer(kind=4),         intent(in)    :: ifront
      type(imbfits_back_t),    intent(in)    :: back
      integer(kind=4),         intent(in)    :: ichunk
      type(class_spectro_t),   intent(out)   :: spe
      logical,                 intent(inout) :: error
    end subroutine mrtcal_chunk_spe_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_con_from_data(scan,antslow,front,ifront,back,  &
      ichunk,backdata,itime,mjd,con,error)
      use phys_const
      use class_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Write the a minimalist continuum drift section
      !---------------------------------------------------------------------
      type(imbfits_scan_t),     intent(in)    :: scan
      type(imbfits_antslow_t),  intent(in)    :: antslow
      type(imbfits_front_t),    intent(in)    :: front
      integer(kind=4),          intent(in)    :: ifront
      type(imbfits_back_t),     intent(in)    :: back
      integer(kind=4),          intent(in)    :: ichunk
      type(imbfits_backdata_t), intent(in)    :: backdata
      integer(kind=4),          intent(in)    :: itime
      real(kind=8),             intent(in)    :: mjd
      type(class_drift_t),      intent(out)   :: con
      logical,                  intent(inout) :: error
    end subroutine mrtcal_chunk_con_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_gen_from_data(primary,obstype,scan,back,ichunk,backdata,  &
      itime,mjd,azimuth,elevation,lst,frontend,gen,error)
      use gbl_constant
      use phys_const
      use class_types
      use imbfits_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_primary_t),  intent(in)    :: primary
      integer(kind=4),          intent(in)    :: obstype
      type(imbfits_scan_t),     intent(in)    :: scan
      type(imbfits_back_t),     intent(in)    :: back
      integer(kind=4),          intent(in)    :: ichunk
      type(imbfits_backdata_t), intent(in)    :: backdata
      integer(kind=4),          intent(in)    :: itime
      real(kind=8),             intent(in)    :: mjd
      real(kind=4),             intent(in)    :: azimuth
      real(kind=4),             intent(in)    :: elevation
      real(kind=8),             intent(in)    :: lst
      character(len=*),         intent(in)    :: frontend
      type(class_general_t),    intent(out)   :: gen
      logical,                  intent(inout) :: error
    end subroutine mrtcal_chunk_gen_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_parang_from_gen(gen,error)
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the parallactic angle from/to general section, assuming
      ! 30m latitude and azimuth convention.
      !---------------------------------------------------------------------
      type(class_general_t), intent(inout) :: gen
      logical,               intent(inout) :: error
    end subroutine mrtcal_chunk_parang_from_gen
  end interface
  !
  interface
    subroutine mrtcal_chunk_pos_from_data(primary,scan,front,derot,ifront,  &
      pixel,subs,mjd,longoff,latoff,pos,error)
      use gbl_constant
      use phys_const
      use class_types
      use imbfits_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_primary_t), intent(in)    :: primary
      type(imbfits_scan_t),    intent(in)    :: scan
      type(imbfits_front_t),   intent(in)    :: front
      type(imbfits_derot_t),   intent(in)    :: derot
      integer(kind=4),         intent(in)    :: ifront
      integer(kind=4),         intent(in)    :: pixel
      type(imbfits_subscan_t), intent(in)    :: subs
      real(kind=8),            intent(in)    :: mjd
      real(kind=4),            intent(in)    :: longoff  ! [rad] Antenna X offset (interpolated)
      real(kind=4),            intent(in)    :: latoff   ! [rad] Antenna Y offset (interpolated)
      type(class_position_t),  intent(out)   :: pos
      logical,                 intent(inout) :: error
    end subroutine mrtcal_chunk_pos_from_data
  end interface
  !
  interface
    function mrtcal_chunk_system_from_data(scan,error)
      use gbl_format
      use mrtcal_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Return the coordinate system code from scan HDU
      !---------------------------------------------------------------------
      integer(kind=4) :: mrtcal_chunk_system_from_data
      type(imbfits_scan_t), intent(in)    :: scan
      logical,              intent(inout) :: error
    end function mrtcal_chunk_system_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_swi_from_data(time,swi,error)
      use mrtcal_messaging
      use gbl_constant
      use phys_const
      use class_types
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=4),         intent(in)    :: time
      type(class_switch_t), intent(out)   :: swi
      logical,              intent(inout) :: error
    end subroutine mrtcal_chunk_swi_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_res_from_data(teles,restf,res,error)
      use mrtcal_messaging
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: teles  !
      real(kind=8),      intent(in)    :: restf  ! [MHz]
      type(class_res_t), intent(out)   :: res    !
      logical,           intent(inout) :: error  !
    end subroutine mrtcal_chunk_res_from_data
  end interface
  !
  interface
    subroutine mrtcal_get_offset_from_scan(scan,projcode,projname,xoffset,yoffset,error)
      use gbl_constant
      use mrtcal_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Set the observed scan offsets (there can be additional per-subscan
      ! offsets that will be added later on).
      !---------------------------------------------------------------------
      type(imbfits_scan_t), intent(in)    :: scan      !
      integer(kind=4),      intent(out)   :: projcode  ! [code] Projection kind for these offsets
      character(len=*),     intent(out)   :: projname  ! [char] Projection kind for these offsets
      real(kind=4),         intent(out)   :: xoffset   ! [rad]
      real(kind=4),         intent(out)   :: yoffset   ! [rad]
      logical,              intent(inout) :: error     !
    end subroutine mrtcal_get_offset_from_scan
  end interface
  !
  interface
    subroutine mrtcal_pixel_offset(pos,recname,pixel,rotang,error)
      use phys_const
      use mrtcal_messaging
      use gkernel_types
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      ! Apply the receiver array offsets (e.g. for HERA). pos%lamof and
      ! pos%betof are modified in return
      !---------------------------------------------------------------------
      type(class_position_t), intent(inout) :: pos      !
      character(len=*),       intent(in)    :: recname  ! Receiver name
      integer(kind=4),        intent(in)    :: pixel    ! Pixel number
      real(kind=8),           intent(in)    :: rotang   ! [deg] Derotator angle
      logical,                intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_pixel_offset
  end interface
  !
  interface
    subroutine mrtcal_chunk_user_from_data(primary,user,error)
      use mrtcal_messaging
      use class_types
      use imbfits_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_primary_t),  intent(in)    :: primary
      type(mrtcal_classuser_t), intent(out)   :: user
      logical,                  intent(inout) :: error
    end subroutine mrtcal_chunk_user_from_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_show(chunk)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Display a 'chunk' element. For debugging purpose.
      !---------------------------------------------------------------------
      type(chunk_t), intent(in) :: chunk
    end subroutine mrtcal_chunk_show
  end interface
  !
  interface
    subroutine mrtcal_chunk_swi_fill(swmode,swdesc,chunk,error)
      use mrtcal_messaging
      use gbl_constant
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! At this point, the phase of the cycle are not yet combined. Hence,
      ! only the part corresponding to each phase is filled in the CLASS 
      ! switching section. Combination will be done during ON-OFF so that
      ! the user can write separately the different phases with consistent
      ! headers...
      !
      ! Moreover the different decal arrays have been set to zero at data read
      ! time. So only the first value is set here according to the switch
      ! mode.
      !---------------------------------------------------------------------
      integer(kind=4),     intent(in)    :: swmode
      type(switch_desc_t), intent(in)    :: swdesc
      type(chunk_t),       intent(inout) :: chunk
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunk_swi_fill
  end interface
  !
  interface
    subroutine mrtcal_chunk_self_multiply(gain,inout,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: gain
      type(chunk_t), intent(inout) :: inout
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_self_multiply
  end interface
  !
  interface
    subroutine mrtcal_chunk_self_multiply_head(gain,inout,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: gain
      type(chunk_t), intent(inout) :: inout
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_self_multiply_head
  end interface
  !
  interface
    subroutine mrtcal_chunk_self_multiply_data(bad,nchan,gain,inout,error)
      use mrtcal_messaging
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)    :: bad
      integer(kind=4), intent(in)    :: nchan
      real(kind=4),    intent(in)    :: gain(nchan)
      real(kind=4),    intent(inout) :: inout(nchan)
      logical,         intent(inout) :: error
    end subroutine mrtcal_chunk_self_multiply_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_multiply_head(atsys,expatau,tscale,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! This subroutine is NOT a generic multiplication of 2 headers.
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: atsys
      type(chunk_t), intent(in)    :: expatau
      type(chunk_t), intent(inout) :: tscale
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_multiply_head
  end interface
  !
  interface
    subroutine mrtcal_chunk_multiply_data(in1,in2,out,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: in1
      type(chunk_t), intent(in)    :: in2
      type(chunk_t), intent(inout) :: out
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_multiply_data
  end interface
  !
  interface
    subroutine mrtcal_chunk_noise_init(chunk,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize the computation of the theoretical noise of the chunk with
      ! 1.0 / [backeff * sqrt(dnu * tint)]
      !---------------------------------------------------------------------
      type(chunk_t), intent(inout) :: chunk
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_noise_init
  end interface
  !
  interface
    subroutine mrtcal_chunk_interpolate_init(prev,next,slope,offset,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize linear interpolation using the following formula
      !     xoffset = xprev
      !     y(x) = (x-xoffset)*slope + offset
      ! We shift the x axis by xoffset to avoid rounding errors as the
      ! computation are done in single precision while the x axis is MJD...
      !---------------------------------------------------------------------
      type(chunk_t), target, intent(in)    :: prev
      type(chunk_t), target, intent(in)    :: next
      type(chunk_t),         intent(inout) :: slope
      type(chunk_t),         intent(inout) :: offset
      logical,               intent(inout) :: error
    end subroutine mrtcal_chunk_interpolate_init
  end interface
  !
  interface
    subroutine mrtcal_chunk_interpolate_do(mjd,slope,offset,interp,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute linear interpolation from previously computed slope and offset
      ! using the following formula
      !     xoffset = xprev
      !     y(x) = (x-xoffset)*slope + offset
      ! We shift the x axis by xoffset to avoid rounding errors as the
      ! computation are done in single precision while the x axis is MJD...
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: mjd
      type(chunk_t),   intent(in)    :: slope
      type(chunk_t),   intent(in)    :: offset
      type(chunk_t),   intent(inout) :: interp
      logical,         intent(inout) :: error
    end subroutine mrtcal_chunk_interpolate_do
  end interface
  !
  interface
    subroutine mrtcal_chunk_calgrid(hh,vv,real,imag,amp,pha,cos,sin,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunk_t), intent(inout) :: hh,vv
      type(chunk_t), intent(inout) :: real,imag
      type(chunk_t), intent(inout) :: amp,pha
      type(chunk_t), intent(inout) :: cos,sin
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_calgrid
  end interface
  !
  interface
    subroutine mrtcal_chunk_cross(hh,vv,hv,vh,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: hh
      type(chunk_t), intent(in)    :: vv
      type(chunk_t), intent(inout) :: hv
      type(chunk_t), intent(inout) :: vh
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_cross
  end interface
  !
  interface
    subroutine mrtcal_chunk_mean(h,v,hv,vh,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: h
      type(chunk_t), intent(in)    :: v
      type(chunk_t), intent(inout) :: hv
      type(chunk_t), intent(inout) :: vh
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_mean
  end interface
  !
  interface
    subroutine mrtcal_chunk_flag(h,v,hv,vh,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: h
      type(chunk_t), intent(in)    :: v
      type(chunk_t), intent(inout) :: hv
      type(chunk_t), intent(inout) :: vh
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_flag
  end interface
  !
  interface
    subroutine mrtcal_chunk_unrotate(cos,sin,real,imag,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! The phase is rotated by a given phase with cos = cos(phase) and sin =
      ! sin(phase). This subroutine unrotate the phase. Hence the sign
      ! convention used here in applying a rotation of -phase.
      ! ---------------------------------------------------------------------
      type(chunk_t), intent(in)    :: cos
      type(chunk_t), intent(in)    :: sin
      type(chunk_t), intent(inout) :: real
      type(chunk_t), intent(inout) :: imag
      logical,       intent(inout) :: error
    end subroutine mrtcal_chunk_unrotate
  end interface
  !
  interface
    subroutine mrtcal_chunkset_check(set,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Check the integrity of a set of chunks
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_check
  end interface
  !
  interface
    subroutine mrtcal_chunkset_show(chunkset)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Display a set of chunks. For debugging purpose.
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in) :: chunkset
    end subroutine mrtcal_chunkset_show
  end interface
  !
  interface
    subroutine mrtcal_chunkset_accumulate_setweight(diff,tscale,dowei,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! ZZZ
      ! Quick and dirty subroutine to enforce chunks dataw to something
      ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
      ! equal weights. Should probably come early and cleverly e.g.
      ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
      !---------------------------------------------------------------------
      type(chunkset_t), intent(inout) :: diff
      type(chunkset_t), intent(in)    :: tscale
      logical,          intent(in)    :: dowei   ! Compute real weights or dummy?
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_accumulate_setweight
  end interface
  !
  interface
    subroutine mrtcal_chunkset_accumulate_do(inchunkset,ouchunkset,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Accumulate the input chunkset into the running output chunkset
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: inchunkset
      type(chunkset_t), intent(inout) :: ouchunkset
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_accumulate_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_copy(in,ofirst,ou,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Copy the chunkset to the output structure (from ofirst chunk),
      ! taking care of reallocating chunkds if needed. Copy is done with
      ! allocations, not associations.
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: in
      integer(kind=4),  intent(in)    :: ofirst
      type(chunkset_t), intent(inout) :: ou
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_copy
  end interface
  !
  interface
    subroutine mrtcal_chunkset_append_do(in,ou,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Append the input chunkset into the running output chunkset
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: in
      type(chunkset_t), intent(inout) :: ou
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_append_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_swi_fill(swmode,swdesc,chunkset2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),     intent(in)    :: swmode
      type(switch_desc_t), intent(in)    :: swdesc
      type(chunkset_2d_t), intent(inout) :: chunkset2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_swi_fill
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_copy_data(in,out,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Data are copied
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: in
      type(chunkset_2d_t), intent(inout) :: out
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_copy_data
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_interpolate_init(prev,next,slope,offset,interp,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Initialize linear interpolation
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: prev
      type(chunkset_2d_t), intent(in)    :: next
      type(chunkset_2d_t), intent(inout) :: slope
      type(chunkset_2d_t), intent(inout) :: offset
      type(chunkset_2d_t), intent(inout) :: interp
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_interpolate_init
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_interpolate_init_as_ref(ref,slope,offset,interp,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Reallocate as ref and copy header from ref
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: ref
      type(chunkset_2d_t), intent(inout) :: slope
      type(chunkset_2d_t), intent(inout) :: offset
      type(chunkset_2d_t), intent(inout) :: interp
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_interpolate_init_as_ref
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_interpolate_do(mjd,slope,offset,interp,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Compute linear interpolation
      !---------------------------------------------------------------------
      real(kind=8),        intent(in)    :: mjd
      type(chunkset_2d_t), intent(inout) :: slope
      type(chunkset_2d_t), intent(inout) :: offset
      type(chunkset_2d_t), intent(inout) :: interp
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_interpolate_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_blank(ref,blank,error)
      use class_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Create a blank 'chunkset_2d' (all 'bad' data), duplicate of the
      ! reference, with relevant sections blanked or kept.
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: ref
      type(chunkset_2d_t), intent(inout) :: blank
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_blank
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_accumulate_init(ref,acc,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! (Re)allocate and initialize a 'chunkset_2d' structure for future
      ! use in mrtcal_chunkset_2d_accumulate_2d.
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: ref
      type(chunkset_2d_t), intent(inout) :: acc
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_accumulate_init
  end interface
  !
  interface
    subroutine mrtcal_chunkset_3d_accumulate_init(ref,acc,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! (Re)allocate and initialize a 'chunkset_3d' structure for future
      ! use in mrtcal_chunkset_accumulate_do.
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(in)    :: ref
      type(chunkset_3d_t), intent(inout) :: acc
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_3d_accumulate_init
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_accumulate_setweight(diff,tscale,dowei,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! ZZZ
      ! Quick and dirty subroutine to enforce chunks dataw to something
      ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
      ! equal weights. Should probably come early and cleverly e.g.
      ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(inout) :: diff
      type(chunkset_2d_t), intent(in)    :: tscale
      logical,             intent(in)    :: dowei   ! Compute real weights or dummy?
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_accumulate_setweight
  end interface
  !
  interface
    subroutine mrtcal_chunkset_3d_accumulate_setweight(diff,tscale,dowei,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! ZZZ
      ! Quick and dirty subroutine to enforce chunks dataw to something
      ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
      ! equal weights. Should probably come early and cleverly e.g.
      ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(inout) :: diff
      type(chunkset_2d_t), intent(in)    :: tscale
      logical,             intent(in)    :: dowei   ! Compute real weights or dummy?
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_3d_accumulate_setweight
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_accumulate_do(in2d,ou2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Accumulate the input chunkset_2d into the running 'ou2d'
      ! chunkset_2d.
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(in)    :: in2d
      type(chunkset_2d_t), intent(inout) :: ou2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_accumulate_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_3d_accumulate_do(in3d,ou3d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Accumulate the input chunkset_3d into the running 'ou3d'
      ! chunkset_3d.
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(in)    :: in3d
      type(chunkset_3d_t), intent(inout) :: ou3d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_3d_accumulate_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_3d_append_init(ref,acc,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! (Re)allocate and initialize a 'chunkset_3d' structure for future
      ! use in mrtcal_chunkset_append_do
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(in)    :: ref
      type(chunkset_3d_t), intent(inout) :: acc
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_3d_append_init
  end interface
  !
  interface
    subroutine mrtcal_chunkset_3d_append_do(in3d,ou3d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Append the input chunkset_3d into the running 'ou3d'
      ! chunkset_3d.
      !---------------------------------------------------------------------
      type(chunkset_3d_t), intent(in)    :: in3d
      type(chunkset_3d_t), intent(inout) :: ou3d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_3d_append_do
  end interface
  !
  interface
    subroutine mrtcal_chunkset_2d_noise_init(chunkset_2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunkset_2d_t), intent(inout) :: chunkset_2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_2d_noise_init
  end interface
  !
  interface
    subroutine mrtcal_dump_command(line,error)
      use mrtcal_messaging
      use gildas_def
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command DUMP
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_dump_command
  end interface
  !
  interface
    subroutine mrtcal_imbfits_dump_data(isub,databuf,ceclass,short,olun,error)
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: isub     ! Subscan number
      type(data_buffer_t),       intent(in)    :: databuf  !
      type(eclass_2inte2char_t), intent(in)    :: ceclass  ! Chunkset equiv classes
      logical,                   intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),           intent(in)    :: olun     ! Output LUN
      logical,                   intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_imbfits_dump_data
  end interface
  !
  interface
    subroutine mrtcal_imbfits_dump_mrtcdata(mrtc,ceclass,olun,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunkset_3d_t),       intent(in)    :: mrtc     !
      type(eclass_2inte2char_t), intent(in)    :: ceclass  ! Chunkset equiv classes
      integer(kind=4),           intent(in)    :: olun     ! Output LUN
      logical,                   intent(inout) :: error    !
    end subroutine mrtcal_imbfits_dump_mrtcdata
  end interface
  !
  interface
    subroutine mrtcal_find_comm(line,error)
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command:
      !   MFIND
      ! Read the index file
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_find_comm
  end interface
  !
  interface
    subroutine mrtcal_index_comm(line,error)
      use mrtcal_messaging
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command
      !   INDEX BUILD|UPDATE|OPEN|APPEND|WATCH|OUTPUT [DirName]
      ! 1       [/FILE IndexFile]
      ! 2       [/RECURSIVE]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line  ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_index_comm
  end interface
  !
  interface
    subroutine mrtcal_entry_chopperset2calsec(backcal,calsec,error)
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(calib_backend_t), intent(in)    :: backcal  !
      type(sec_calib_t),     intent(inout) :: calsec   !
      logical,               intent(inout) :: error    !
    end subroutine mrtcal_entry_chopperset2calsec
  end interface
  !
  interface
    subroutine mrtcal_entry_calsec2chopperset(calsec,backcal,error)
      use chopper_definitions
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(sec_calib_t),     intent(in)            :: calsec   !
      type(calib_backend_t), intent(inout), target :: backcal  !
      logical,               intent(inout)         :: error    !
    end subroutine mrtcal_entry_calsec2chopperset
  end interface
  !
  interface
    subroutine mrtcal_entry_sdrifts2poisec(backsci,poisec,error)
      use class_types
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Transfer the "solved-drifts" (sdrifts) to the pointing section in
      ! the index.
      !---------------------------------------------------------------------
      type(science_backend_t), intent(in)    :: backsci
      type(sec_pointing_t),    intent(inout) :: poisec
      logical,                 intent(inout) :: error
    end subroutine mrtcal_entry_sdrifts2poisec
  end interface
  !
  interface
    subroutine mrtcal_calsec_chunkset_consistency(calsec,c2d,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !  Check the consistency of a chunkset_2d against calibration section
      !---------------------------------------------------------------------
      type(sec_calib_t),   intent(in)    :: calsec
      type(chunkset_2d_t), intent(in)    :: c2d
      logical,             intent(inout) :: error
    end subroutine mrtcal_calsec_chunkset_consistency
  end interface
  !
  interface
    subroutine mrtcal_init(error)
      use mrtcal_messaging
      use classic_api
      use mrtcal_index_vars
      use mrtcal_buffers
      !----------------------------------------------------------------------
      ! @ private
      ! MRTCAL Initialization
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_init
  end interface
  !
  interface
    subroutine mrtcal_exit(error)
      use mrtcal_messaging
      use mrtcal_buffers
      use mrtcal_index_vars
      !----------------------------------------------------------------------
      ! @ private
      ! MRTCAL Cleaning on exit
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_exit
  end interface
  !
  interface
    subroutine mrtcal_load
      !---------------------------------------------------------------------
      ! @ private
      ! Define and load the MRTCAL language
      !---------------------------------------------------------------------
      !
    end subroutine mrtcal_load
  end interface
  !
  interface
    subroutine mrtcal_run(line,command,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for the language MRTCAL.
      ! This routine is able to call the routines associated to each
      ! command of the language MRTCAL
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: line
      character(len=12), intent(in)    :: command
      logical,           intent(inout) :: error
    end subroutine mrtcal_run
  end interface
  !
  interface
    function mrtcal_error()
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for the error status of the library. 
      ! It is a scory. Please do not use it
      !---------------------------------------------------------------------
      logical :: mrtcal_error
    end function mrtcal_error
  end interface
  !
  interface
    subroutine mrtcal_list_comm(line,error)
      use mrtcal_messaging
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   LIST [IN|CURRENT]
      !   1    [/TOC]
      !   2    [/PAGE]
      !   3    [/COLUMNS List]
      !   4    [/FILE OutputFile]
      !   5    [/VARIABLE VarName]
      !   6    [/POINTING]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_list_comm
  end interface
  !
  interface
    subroutine calibration_to_VO(fits,backcal,error)
      use phys_const
      use gbl_format
      use mrtcal_messaging
      use class_types
      use imbfits_types
      use mrtcal_buffers
      use mrtcal_calib_types
      use pako_xml
      use results_to_vo
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_t),        intent(in)    :: fits
      type(calib_backend_t),  intent(in)    :: backcal
      logical,                intent(inout) :: error
    end subroutine calibration_to_VO
  end interface
  !
  interface
    subroutine pointing_to_VO(fits,backsci,error)
      use phys_const
      use gbl_format
      use mrtcal_messaging
      use class_types
      use imbfits_types
      use mrtcal_buffers
      use mrtcal_calib_types
      use pako_xml
      use results_to_vo
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: fits
      type(science_backend_t), intent(in)    :: backsci
      logical,                 intent(inout) :: error
    end subroutine pointing_to_VO
  end interface
  !
  interface
    subroutine mrtcal_pack_init(gpack_id,error)
      use cal2vo_messaging
      use mrtcal_messaging
      !----------------------------------------------------------------------
      ! @ private-mandatory
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine mrtcal_pack_init
  end interface
  !
  interface
    subroutine mrtcal_pack_clean(error)
      !----------------------------------------------------------------------
      ! @ private-mandatory
      ! Called at end of session. Might clean here for example global buffers
      ! allocated during the session
      !----------------------------------------------------------------------
      logical :: error
    end subroutine mrtcal_pack_clean
  end interface
  !
  interface
    subroutine mrtcal_pipe_command(line,error)
      use mrtcal_messaging
      use gkernel_types
      use mrtcal_parameters
      use mrtcal_buffers
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! PIPELINE
      ! 1. /SHOW [*|NONE|DONE|FAILED]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_pipe_command
  end interface
  !
  interface
    subroutine mrtcal_pipe_parse(line,iopt,select,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),   intent(in)    :: line
      integer(kind=4),    intent(in)    :: iopt
      type(user_calib_t), intent(out)   :: select
      logical,            intent(inout) :: error
    end subroutine mrtcal_pipe_parse
  end interface
  !
  interface
    subroutine mrtcal_pipe_feedback(select,ix,cx,error)
      use mrtcal_messaging
      use mrtindex_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! User feedback: Update CX according to user choice
      !---------------------------------------------------------------------
      type(user_calib_t),        intent(in)    :: select
      type(mrtindex_optimize_t), intent(in)    :: ix
      type(mrtindex_optimize_t), intent(inout) :: cx
      logical,                   intent(inout) :: error
    end subroutine mrtcal_pipe_feedback
  end interface
  !
  interface
    subroutine mrtcal_pipe_update_cx(ix,cx,error)
      use mrtcal_messaging
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Update CX with latest version of the IX entries
      !---------------------------------------------------------------------
      type(mrtindex_optimize_t), intent(in)    :: ix
      type(mrtindex_optimize_t), intent(inout) :: cx
      logical,                   intent(inout) :: error
    end subroutine mrtcal_pipe_update_cx
  end interface
  !
  interface
    subroutine mrtcal_pipe_filter_cx(select,cx,error)
      use mrtcal_messaging
      use mrtindex_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Filter CX according to user choice
      !---------------------------------------------------------------------
      type(user_calib_t),        intent(in)    :: select
      type(mrtindex_optimize_t), intent(inout) :: cx
      logical,                   intent(inout) :: error
    end subroutine mrtcal_pipe_filter_cx
  end interface
  !
  interface
    subroutine mrtcal_separator(severity,rname,nline,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Print nline white lines as entry separators
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: severity
      character(len=*), intent(in)    :: rname
      integer(kind=4),  intent(in)    :: nline
      logical,          intent(inout) :: error
    end subroutine mrtcal_separator
  end interface
  !
  interface
    subroutine mrtcal_read_command(line,error)
      use mrtcal_messaging
      use gildas_def
      use mrtcal_buffers
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   READ [Filename|FileNum|ZERO|FIRST|LAST|NEXT|PREV] [/FILENAME] [/SUBSCAN Isub]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_read_command
  end interface
  !
  interface
    subroutine mrtcal_read_argument(line,found,error)
      use gildas_def
      use mrtcal_messaging
      use classic_api
      use mrtcal_index_vars
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command READ. Decode command 1st argument:
      !   READ [Filename|FileNum|ZERO|FIRST|LAST|NEXT|PREV] [/FILENAME]
      ! Of course, PREV or NEXT are unrelated to Filename or Filenum.
      ! This may be confusing for newcomers but there is no obvious solution
      ! as Filename or FileNum do not need to be related to the current index.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(out)   :: found ! Found a name to be opened?
      logical,          intent(inout) :: error
    end subroutine mrtcal_read_argument
  end interface
  !
  interface
    subroutine mrtcal_parse_numver(rname,line,iopt,iarg,ix,ient,error)
      use classic_api
      use mrtindex_types
      !---------------------------------------------------------------------
      ! @ private
      !  Parse the command line to retrieve an argument of the form "N" or
      ! "N.V" and convert it into the entry position in IX
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: rname  ! Calling routine name
      character(len=*),           intent(in)    :: line   ! Command line
      integer(kind=4),            intent(in)    :: iopt   ! Option number
      integer(kind=4),            intent(in)    :: iarg   ! Argument number
      type(mrtindex_optimize_t),  intent(in)    :: ix     !
      integer(kind=entry_length), intent(out)   :: ient   ! Resolved entry number
      logical,                    intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_parse_numver
  end interface
  !
  interface
    subroutine mrtcal_read_main(filename,isub,filebuf,error)
      use gildas_def
      use mrtcal_buffers
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),       intent(in)    :: filename
      integer(kind=4),        intent(in)    :: isub
      type(imbfits_buffer_t), intent(inout) :: filebuf
      logical,                intent(inout) :: error
    end subroutine mrtcal_read_main
  end interface
  !
  interface
    subroutine mrtcal_free_subscan_data(databuf,error)
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free of the DATA column from the current subscan, and its conversion
      ! in chunksets.
      !---------------------------------------------------------------------
      type(data_buffer_t), intent(inout) :: databuf
      logical,             intent(inout) :: error
    end subroutine mrtcal_free_subscan_data
  end interface
  !
  interface
    subroutine mrtcal_setup_comm(line,error)
      use mrtcal_messaging
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   MSETUP INPUT|BOOKKEEPING|CALIBRATION|OUTPUT|SOLVE|PIPELINE|DEBUG
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_setup_comm
  end interface
  !
  interface
    subroutine mrtcal_setup_print(mrtset,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t), intent(in)    :: mrtset
      logical,              intent(inout) :: error
    end subroutine mrtcal_setup_print
  end interface
  !
  interface
    subroutine mrtcal_setup_input_parse(line,mrtsetinp,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    MSETUP INPUT DATA        NONE|ONTRACK|ALL
      ! or MSETUP INPUT TOCHUNK     YES|NO
      ! or MSETUP INPUT BAD         YES|NO
      ! or MSETUP INPUT MJDINTER    YES|NO
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: line
      type(mrtcal_setup_input_t), intent(inout) :: mrtsetinp
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_input_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_input_print(mrtsetinp,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_input_t), intent(in)    :: mrtsetinp
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_input_print
  end interface
  !
  interface
    subroutine mrtcal_setup_bookkeeping_parse(line,mrtset,error)
      use mrtcal_messaging
      use ram_sizes
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command 
      ! MSETUP BOOKKEPPING SPACE value
      ! *** JP It would probably be better if it was a fraction of the
      ! *** JP available ramsize. Afterthought: Not fully clear because
      ! *** JP even with a large amount of RAM, there may be an optimal
      ! *** JP amount of buffer space. Maybe the two possibility should
      ! *** JP be authorized MSETUP BOOKKEEPING SPACE value % or value MB.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: line
      type(mrtcal_setup_t), intent(inout) :: mrtset
      logical,              intent(inout) :: error
    end subroutine mrtcal_setup_bookkeeping_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_bookkeeping_print(mrtset,error)
      use mrtcal_messaging
      use ram_sizes
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t), intent(in)    :: mrtset
      logical,              intent(inout) :: error
    end subroutine mrtcal_setup_bookkeeping_print
  end interface
  !
  interface
    subroutine mrtcal_setup_calibration_parse(line,mrtsetcal,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    MSETUP CALIBRATION BAD         YES|NO
      ! or MSETUP CALIBRATION BANDWIDTH   Value
      ! or MSETUP CALIBRATION CHOPPER     STRICT|TOLERANT
      ! or MSETUP CALIBRATION FEEDBACK    PIXEL|SET|ELEMENT
      ! or MSETUP CALIBRATION INTERVAL    Value
      ! or MSETUP CALIBRATION MATCH       Value
      ! or MSETUP CALIBRATION MJDINTER    YES|NO
      ! or MSETUP CALIBRATION OFF         NEAREST|LINEAR
      ! or MSETUP CALIBRATION PRODUCTS    NEAREST|LINEAR|SPLINE
      ! or MSETUP CALIBRATION SCAN        NEAREST|LINEAR
      ! or MSETUP CALIBRATION WATER       SET|ELEMENT|FIXED [Value]
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: line
      type(mrtcal_setup_calib_t), intent(inout) :: mrtsetcal
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_calibration_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_calibration_print(mrtsetcal,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_calib_t), intent(in)    :: mrtsetcal
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_calibration_print
  end interface
  !
  interface
    subroutine mrtcal_setup_solve_parse(line,mrtsetsol,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    MSETUP SOLVE POINTING Mode
      ! OR ...
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: line
      type(mrtcal_setup_solve_t), intent(inout) :: mrtsetsol
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_solve_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_solve_print(mrtsetsol,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_solve_t), intent(in)    :: mrtsetsol
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_solve_print
  end interface
  !
  interface
    subroutine mrtcal_setup_output_parse(line,mrtsetout,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    MSETUP OUTPUT CALIBRATION SPECTRA|ASSOCIATED|NONE
      ! or MSETUP OUTPUT CHUNK       ELEMENT|SET
      ! or MSETUP OUTPUT FOLD        YES|NO
      ! or MSETUP OUTPUT INTEGRATION CYCLE|SUBSCAN|SCAN|*
      ! or MSETUP OUTPUT RESTABLE    YES|NO
      ! or MSETUP OUTPUT SPECTRA     YES|NO
      ! or MSETUP OUTPUT USERSECTION YES|NO
      ! or MSETUP OUTPUT VDIRECTION  YES|NO
      ! or MSETUP OUTPUT VOXML       YES|NO
      ! or MSETUP OUTPUT VODIR       DirName
      ! or MSETUP OUTPUT WEIGHT      YES|NO
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: line
      type(mrtcal_setup_output_t), intent(inout) :: mrtsetout
      logical,                     intent(inout) :: error
    end subroutine mrtcal_setup_output_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_output_print(mrtsetout,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_output_t), intent(in)    :: mrtsetout
      logical,                     intent(inout) :: error
    end subroutine mrtcal_setup_output_print
  end interface
  !
  interface
    subroutine mrtcal_setup_pipeline_parse(line,mrtset,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command 
      ! MSETUP PIPELINE ONERROR CONTINUE|STOP
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: line
      type(mrtcal_setup_t), intent(inout) :: mrtset
      logical,              intent(inout) :: error
    end subroutine mrtcal_setup_pipeline_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_pipeline_print(mrtset,error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t), intent(in)    :: mrtset
      logical,              intent(inout) :: error
    end subroutine mrtcal_setup_pipeline_print
  end interface
  !
  interface
    subroutine mrtcal_setup_debug_all(newseve,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Set the default state for command
      !    MSET DEBUG ON|OFF
      ! for all topics
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: newseve
      logical,         intent(inout) :: error
    end subroutine mrtcal_setup_debug_all
  end interface
  !
  interface
    subroutine mrtcal_setup_debug_parse(line,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      ! MSETUP DEBUG [Topic [Subtopic]] ON|OFF
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_setup_debug_parse
  end interface
  !
  interface
    subroutine mrtcal_setup_debug_print(error)
      use mrtcal_messaging
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_setup_debug_print
  end interface
  !
  interface
    subroutine mrtcal_setup_variable(error)
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      ! Fill the structure SET%MRTCAL%
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_setup_variable
  end interface
  !
  interface
    subroutine mrtcal_setup_calibration_variable(parent,cal,error)
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Fill the structure SET%MRTCAL%CALIB%
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: parent
      type(mrtcal_setup_calib_t), intent(in)    :: cal
      logical,                    intent(inout) :: error
    end subroutine mrtcal_setup_calibration_variable
  end interface
  !
  interface
    subroutine mrtcal_setup_output_variable(parent,out,error)
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Fill the structure SET%MRTCAL%OUTPUT%
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: parent
      type(mrtcal_setup_output_t), intent(in)    :: out
      logical,                     intent(inout) :: error
    end subroutine mrtcal_setup_output_variable
  end interface
  !
  interface
    subroutine mrtcal_setup_do2done(obstype,swmode,doset,doneset,error)
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Translate a user setup type (which may include * choices, i.e. let
      ! Mrtcal choose) to actual setup. This depends on the current scan.
      !---------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: obstype  ! [code] Observing type
      integer(kind=4),      intent(in)    :: swmode   ! [code] Switching mode
      type(mrtcal_setup_t), intent(in)    :: doset    ! Setup (user choices)
      type(mrtcal_setup_t), intent(out)   :: doneset  ! Setup (resolved)
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_setup_do2done
  end interface
  !
  interface mrtcal_setup_parse
    subroutine mrtcal_setup_parse_keyword(line,iarg,mvocab,vocab,keyword,found,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_setup_parse
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(in)    :: iarg
      integer(kind=4),  intent(in)    :: mvocab
      character(len=*), intent(in)    :: vocab(mvocab)
      character(len=*), intent(out)   :: keyword
      logical,          intent(out)   :: found
      logical,          intent(inout) :: error
    end subroutine mrtcal_setup_parse_keyword
    subroutine mrtcal_setup_parse_ikey(line,iarg,mvocab,vocab,ikey,error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_setup_parse
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(in)    :: iarg
      integer(kind=4),  intent(in)    :: mvocab
      character(len=*), intent(in)    :: vocab(mvocab)
      integer(kind=4),  intent(out)   :: ikey
      logical,          intent(inout) :: error
    end subroutine mrtcal_setup_parse_ikey
  end interface mrtcal_setup_parse
  !
  interface
    subroutine mrtcal_solve_focus_bsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_solve_focus_bsw
  end interface
  !
  interface
    subroutine mrtcal_pointing_create(backsci,drifts,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(science_backend_t), intent(in)    :: backsci  !
      type(obs_list_t),        intent(inout) :: drifts   ! Output collection of drifts
      logical,                 intent(inout) :: error    !
    end subroutine mrtcal_pointing_create
  end interface
  !
  interface
    subroutine mrtcal_pointing_create_from_chunkset(chunkset,drifts,error)
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: chunkset  !
      type(obs_list_t), intent(inout) :: drifts    ! Output collection of drifts
      logical,          intent(inout) :: error     !
    end subroutine mrtcal_pointing_create_from_chunkset
  end interface
  !
  interface
    subroutine mrtcal_solve_and_write_obslist(drifts,out,ndrift,error)
      use class_types
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(obs_list_t),            intent(inout) :: drifts  ! Collection of drifts
      type(mrtcal_setup_output_t), intent(in)    :: out     ! Output configuration
      integer(kind=4),             intent(inout) :: ndrift  ! Cumulative sum of drifts written
      logical,                     intent(inout) :: error   !
    end subroutine mrtcal_solve_and_write_obslist
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_observation(obs,error)
      use phys_const
      use point_definitions
      use class_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_solve_pointing_observation
  end interface
  !
  interface
    subroutine mrtcal_pointing_peak(poi,vpeak,epeak,error)
      use phys_const
      use class_types
      use mrtindex_sec_pointing
      !---------------------------------------------------------------------
      ! @ private
      ! From a CLASS pointing section, return the peak value and its error.
      ! This information is redundant with the (area,position,fwhm) stored
      ! in the section.
      !---------------------------------------------------------------------
      type(class_pointing_t), intent(in)    :: poi
      real(kind=4),           intent(out)   :: vpeak  ! Peak value
      real(kind=4),           intent(out)   :: epeak  ! Peak error
      logical,                intent(inout) :: error
    end subroutine mrtcal_pointing_peak
  end interface
  !
  interface
    subroutine mrtcal_pointing_associate_array(obs,error)
      use class_types
      use mrtindex_sec_pointing
      !---------------------------------------------------------------------
      ! @ private
      ! If the observation provides a pointing drift fit, it is modified so
      ! that:
      ! 1) RY provides the baselined pointing drift,
      ! 2) an associated array named XX provides the (original)
      !    non-baselined pointing drifts
      !---------------------------------------------------------------------
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_pointing_associate_array
  end interface
  !
  interface
    subroutine mrtcal_pointing_classify(mrtset,idrifts,sdrifts,error)
      use phys_const
      use mrtcal_messaging
      use toc_types
      use class_toc_parameters
      use class_types
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gtaher drifts by equivalence class and solve each class.
      !---------------------------------------------------------------------
      type(mrtcal_setup_t), intent(in)    :: mrtset   !
      type(obs_list_t),     intent(in)    :: idrifts  ! Collection of individual drifts
      type(obs_list_t),     intent(inout) :: sdrifts  ! Collection of averaged and solved drifts
      logical,              intent(inout) :: error    !
    end subroutine mrtcal_pointing_classify
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_oneclass(drifts,iequ,cnt,bak,obs,error)
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Produce the drift for one equivalence class
      !---------------------------------------------------------------------
      type(obs_list_t),           intent(in)    :: drifts  ! Collection of drifts
      integer(kind=entry_length), intent(in)    :: iequ    ! Eq. class identifier
      integer(kind=entry_length), intent(in)    :: cnt     ! Number of elements in this eq. class
      integer(kind=entry_length), intent(in)    :: bak(:)  ! Back pointer to original elements
      type(observation),          intent(inout) :: obs     !
      logical,                    intent(inout) :: error   !
    end subroutine mrtcal_solve_pointing_oneclass
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_gather(drifts,list,obs,error)
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gather the drifts indentfies in the list and produce a single drift
      ! observation
      !---------------------------------------------------------------------
      type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
      integer(kind=entry_length), intent(in)    :: list(:)  !
      type(observation),          intent(inout) :: obs      !
      logical,                    intent(inout) :: error    !
    end subroutine mrtcal_solve_pointing_gather
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Resample each irregular drift to a common axis and average them.
      !---------------------------------------------------------------------
      type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
      integer(kind=entry_length), intent(in)    :: list(:)  !
      type(observation),          intent(inout) :: obs      !
      logical,                    intent(inout) :: error    !
    end subroutine mrtcal_solve_pointing_gather_regular
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Gather the drifts identifies in the list and produce a single drift
      ! observation. Just concatenate and sort the (X,Y) data point, leave
      ! the observation irregular.
      ! This solution is well suited for minimization of the point cloud,
      ! but can not be extensively used in CLASS. In particular, such an
      ! irregular axis does not behave well with the RESAMPLE command.
      !---------------------------------------------------------------------
      type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
      integer(kind=entry_length), intent(in)    :: list(:)  !
      type(observation),          intent(inout) :: obs      !
      logical,                    intent(inout) :: error    !
    end subroutine mrtcal_solve_pointing_gather_irregular
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_user_feedback(backsci,setout,error)
      use mrtcal_messaging
      use mrtcal_buffers
      use mrtcal_calib_types
      use mrtcal_setup_types
      use mrtcal_user_feedback_tool
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(science_backend_t),     intent(in)    :: backsci
      type(mrtcal_setup_output_t), intent(in)    :: setout
      logical,                     intent(inout) :: error
    end subroutine mrtcal_solve_pointing_user_feedback
  end interface
  !
  interface
    subroutine mrtcal_solve_pointing_bsw(mrtset,backcal,backsci,filebuf,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset
      type(calib_backend_t),   intent(in)    :: backcal
      type(science_backend_t), intent(inout) :: backsci
      type(imbfits_buffer_t),  intent(inout) :: filebuf
      logical,                 intent(inout) :: error
    end subroutine mrtcal_solve_pointing_bsw
  end interface
  !
  interface
    function eclass_offset_eq(x1,x2,y1,y2,t1,t2)
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      ! Equality routine between two pairs of offset (real*8) with a
      ! tolerance ruled by MSET CALIBRATION MATCH
      !---------------------------------------------------------------------
      logical :: eclass_offset_eq
      real(kind=8),     intent(in) :: x1,x2  ! [rad]
      real(kind=8),     intent(in) :: y1,y2  ! [rad]
      character(len=*), intent(in) :: t1,t2  ! Offset type (track, onTheFly, ...)
    end function eclass_offset_eq
  end interface
  !
  interface
    subroutine mrtcal_subscan_list_build(switchmode,sublist,imbf,error)
      use mrtcal_messaging
      use phys_const
      use gkernel_types
      use imbfits_types
      use mrtcal_buffers
      use mrtcal_calib_types
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      ! 1. Class the subscans of the current scan in TRACKED or OTF, ON or OFF
      ! 2. Associate the median offset, median MJD, and the integration time
      !---------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: switchmode
      type(subscan_list_t), intent(inout) :: sublist
      type(imbfits_t),      intent(inout) :: imbf
      logical,              intent(inout) :: error
    end subroutine mrtcal_subscan_list_build
  end interface
  !
  interface
    subroutine mrtcal_subscan_list_print(switchmode,sublist,error)
      use mrtcal_messaging
      use phys_const
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! List useful information about the subscans of the current scan
      !---------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: switchmode
      type(subscan_list_t), intent(in)    :: sublist
      logical,              intent(inout) :: error
    end subroutine mrtcal_subscan_list_print
  end interface
  !
  interface
    subroutine mrtcal_switch_cycle_init(front,backdata,antslow,sublist,cycle,error)
      use phys_const
      use mrtcal_messaging
      use imbfits_types
      use mrtcal_calib_types
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      ! Note that the frequency offset in frequency switching may depend on the
      ! frontend. This imposes that the off pointer in the switch_desc_t has 
      ! noffset x nfront dimensions, and not just noffset.
      !
      ! In wobbler switching, check that offsets are given in horizontalTrue.
      ! If true, then use the sign of the longitude offset to determine the ON and OFF
      ! phases. Indeed, the backdata%head%phaseone%val value is only indicating
      ! whether the phase corresponds to the wobbler LEFT or RIGHT, not whether
      ! it is ON or OFF (even though the value names still are ON or OFF). Yes,
      ! I know: This is confusing...
      !
      ! In frequency switching, try to use backdata%head%phaseone%val to 
      ! decide who is ON and who is OFF
      !---------------------------------------------------------------------
      type(imbfits_front_t),    intent(in)    :: front
      type(imbfits_backdata_t), intent(in)    :: backdata
      type(imbfits_antslow_t),  intent(in)    :: antslow
      type(subscan_list_t),     intent(in)    :: sublist
      type(switch_cycle_t),     intent(inout) :: cycle
      logical,                  intent(inout) :: error
    end subroutine mrtcal_switch_cycle_init
  end interface
  !
  interface
    subroutine mrtcal_switch_cycle_list(cycle,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! List useful information about the switch cycle of the current subscan
      !---------------------------------------------------------------------
      type(switch_cycle_t), intent(in)    :: cycle
      logical,              intent(inout) :: error
    end subroutine mrtcal_switch_cycle_list
  end interface
  !
  interface
    subroutine mrtcal_switch_book_list(book,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(switch_book_t), intent(in)    :: book
      logical,             intent(inout) :: error
    end subroutine mrtcal_switch_book_list
  end interface
  !
  interface
    subroutine mrtcal_iterate_subscancycle(mrtset,imbf,subscanbuf,  &
      backcal,backsci,error)
      use mrtcal_messaging
      use mrtcal_buffer_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(mrtcal_setup_t),    intent(in)    :: mrtset      !
      type(imbfits_t),         intent(in)    :: imbf        !
      type(subscan_buffer_t),  intent(inout) :: subscanbuf  !
      type(calib_backend_t),   intent(in)    :: backcal     !
      type(science_backend_t), intent(inout) :: backsci     !
      logical,                 intent(inout) :: error       !
    end subroutine mrtcal_iterate_subscancycle
  end interface
  !
  interface
    subroutine mrtcal_find_next_subscancycle(sublist,swcycle,nswitch,  &
      verbose,found,ifirst,isub,ncycle,error)
      use imbfits_types
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(subscan_list_t), intent(in)    :: sublist
      integer(kind=4),      intent(in)    :: nswitch
      integer(kind=4),      intent(in)    :: swcycle(nswitch)
      logical,              intent(in)    :: verbose
      logical,              intent(out)   :: found
      integer(kind=4),      intent(inout) :: ifirst
      integer(kind=4),      intent(inout) :: isub
      integer(kind=4),      intent(inout) :: ncycle
      logical,              intent(inout) :: error
    end subroutine mrtcal_find_next_subscancycle
  end interface
  !
  interface
    subroutine antslow_mjd(mjd,antslow,ceil,itrace,error)
      use mrtcal_messaging
      use gildas_def
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Search in the input 'AntSlow' the slow trace which has the nearest
      ! MJD. Return the index of this slow trace
      !---------------------------------------------------------------------
      real(kind=8),              intent(in)    :: mjd
      type(imbfits_antslow_t),   intent(in)    :: antslow
      logical,                   intent(in)    :: ceil
      integer(kind=size_length), intent(out)   :: itrace
      logical,                   intent(inout) :: error
    end subroutine antslow_mjd
  end interface
  !
  interface
    subroutine mrtcal_get_median_elevation(subs,medelev,error)
      use mrtcal_messaging
      use phys_const
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !  Get the median elevation from CELEVATIO in AntSlow table, on track
      ! part.
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs    !
      real(kind=8),            intent(out)   :: medelev ! [rad] double in contrast with CLASS
      logical,                 intent(inout) :: error   !
    end subroutine mrtcal_get_median_elevation
  end interface
  !
  interface
    subroutine mrtcal_get_time_range_for_antslow(subs,time,error)
      use gildas_def
      use imbfits_types
      use mrtcal_bookkeeping_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      type(range_t),           intent(out)   :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_time_range_for_antslow
  end interface
  !
  interface
    subroutine mrtcal_get_time_range_for_antfast(subs,time,error)
      use gildas_def
      use imbfits_types
      use mrtcal_bookkeeping_types
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      type(range_t),           intent(out)   :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_time_range_for_antfast
  end interface
  !
  interface
    subroutine mrtcal_get_time_range_for_all(subs,time,error)
      use imbfits_types
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      !  Select the whole time range (on-track and off-track)
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(in)    :: subs
      type(range_t),           intent(out)   :: time
      logical,                 intent(inout) :: error
    end subroutine mrtcal_get_time_range_for_all
  end interface
  !
  interface
    subroutine mrtcal_dicho(rname,np,x,xval,ceil,toler,ival,error)
      use gildas_def
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      ! Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! Suited for MJD values only.
      ! The algorithm (dichotomic search) assumes the input data is
      ! increasingly ordered.
      !---------------------------------------------------------------------
      character(len=*),          intent(in)    :: rname  ! Calling routine name
      integer(kind=size_length), intent(in)    :: np     ! Number of input points
      real(kind=8),              intent(in)    :: x(np)  ! Input ordered Values
      real(kind=8),              intent(in)    :: xval   ! The value we search for
      logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
      real(kind=8),              intent(in)    :: toler  ! Acceptable error
      integer(kind=size_length), intent(out)   :: ival   ! Position in the array
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_dicho
  end interface
  !
  interface
    subroutine mrtcal_get_dewang_from_derot(front,derot,mjd,dewang,error)
      use mrtcal_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Interpolate the derotator angle from the derotator table, according
      ! to the input MJD
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front   !
      type(imbfits_derot_t), intent(in)    :: derot   !
      real(kind=8),          intent(in)    :: mjd     !
      real(kind=8),          intent(out)   :: dewang  ! [Derot table unit]
      logical,               intent(inout) :: error   ! Logical error flag
    end subroutine mrtcal_get_dewang_from_derot
  end interface
  !
  interface
    subroutine mrtcal_toclass_init(error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !  Initialize the 'toclass' buffers. This should be done only once in
      ! a session.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_toclass_init
  end interface
  !
  interface
    subroutine mrtcal_toclass_exit(error)
      use mrtcal_messaging
      !---------------------------------------------------------------------
      ! @ private
      !  Finalize the 'toclass' buffers. This should be done only once in
      ! a session.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine mrtcal_toclass_exit
  end interface
  !
  interface
    subroutine mrtcal_chunkset_fsw_to_obs(out,set1,set2,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !  Specific to FSW data
      !  Fold the pair of chunksets and produce a single class spectrum
      !---------------------------------------------------------------------
      type(mrtcal_setup_output_t), intent(in)    :: out
      type(chunkset_t),            intent(in)    :: set1
      type(chunkset_t),            intent(in)    :: set2
      logical,                     intent(inout) :: error
    end subroutine mrtcal_chunkset_fsw_to_obs
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_ry(set,obs,error)
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Stitch the spectra in the set and save them as the RY spectrum
      ! in the observation.
      !---------------------------------------------------------------------
      type(chunkset_t),  intent(in)    :: set
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_ry
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_assoc(set,obs,error)
      use gbl_format
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !  Stitch the spectra in the set and save them as a new associated
      ! array in the observation.
      !---------------------------------------------------------------------
      type(chunkset_t),  intent(in)    :: set
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_assoc
  end interface
  !
  interface
    subroutine mrtcal_reallocate_r4(r4,n,error)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=4), allocatable, intent(inout) :: r4(:)
      integer(kind=4),           intent(in)    :: n
      logical,                   intent(inout) :: error
    end subroutine mrtcal_reallocate_r4
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_head(set,obs,error)
      use mrtcal_messaging
      use class_api
      use class_types
      use mrtcal_buffers
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      !   This subroutine fills a Class header from a chunkset (collection
      ! of several chunks).
      !   General and position sections are assumed to be common between all
      ! the chunks of the chunkset. Should it be checked? *** JP
      !---------------------------------------------------------------------
      type(chunkset_t),  intent(in)    :: set
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_head
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_gen(set,gen,error)
      use gildas_def
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Define the general section suited for the stitched chunks
      !---------------------------------------------------------------------
      type(chunkset_t),      intent(in)    :: set
      type(class_general_t), intent(out)   :: gen
      logical,               intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_gen
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_spe(set,spe,error)
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Define the spectroscopic section suited for the stitched chunks
      !---------------------------------------------------------------------
      type(chunkset_t),      intent(in)    :: set
      type(class_spectro_t), intent(out)   :: spe
      logical,               intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_spe
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_con(set,con,time,error)
      use phys_const
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Define the continuum drift section suited for the stitched chunks
      !---------------------------------------------------------------------
      type(chunkset_t),    intent(in)    :: set    !
      type(class_drift_t), intent(out)   :: con    !
      real(kind=4),        intent(out)   :: time   ! [s] Integration time
      logical,             intent(inout) :: error  !
    end subroutine mrtcal_chunkset_to_obs_con
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_cal(set,cal,error)
      use gildas_def
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Define the calibration section suited for the stitched chunks
      !---------------------------------------------------------------------
      type(chunkset_t),    intent(in)    :: set
      type(class_calib_t), intent(out)   :: cal
      logical,             intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_cal
  end interface
  !
  interface
    subroutine mrtcal_fit_to_obs_poi(fun,obs,error)
      use phys_const
      use mrtcal_messaging
      use fit_definitions
      use class_types
      use mrtindex_sec_pointing
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(fit_fun),     intent(in)    :: fun
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_fit_to_obs_poi
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_data(set,head,datax,data1,dataw,error)
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Merge the chunks in the chunkset to produce the CLASS observation
      ! data.
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set
      type(header),     intent(in)    :: head
      real(kind=8),     intent(out)   :: datax(:)
      real(kind=4),     intent(out)   :: data1(:)
      real(kind=4),     intent(out)   :: dataw(:)
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_data
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_data_con(set,datax,data1,dataw,error)
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Continuum case
      ! Merge the single-point continuum chunks into a N-points drift
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set
      real(kind=8),     intent(out)   :: datax(:)
      real(kind=4),     intent(out)   :: data1(:)
      real(kind=4),     intent(out)   :: dataw(:)
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_data_con
  end interface
  !
  interface
    subroutine mrtcal_chunkset_to_obs_data_spe(set,head,data1,dataw,error)
      use mrtcal_messaging
      use class_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Simple stitching. No resampling is foreseen.
      ! However, we check that the frequency axes are aligned.
      ! A simple average is performed for channels which are present in more
      ! than one chunk (use the SET BAD OR policy of CLASS).
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set
      type(header),     intent(in)    :: head
      real(kind=4),     intent(out)   :: data1(:)
      real(kind=4),     intent(out)   :: dataw(:)
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset_to_obs_data_spe
  end interface
  !
  interface
    subroutine mrtcal_obs_to_class(obs,error)
      use class_types
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      !  Write the observation to the current Class file
      !---------------------------------------------------------------------
      type(observation), intent(inout) :: obs
      logical,           intent(inout) :: error
    end subroutine mrtcal_obs_to_class
  end interface
  !
  interface
    function mrtcal_user_function(action)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical :: mrtcal_user_function
      character(len=*), intent(in) :: action
    end function mrtcal_user_function
  end interface
  !
  interface
    subroutine mrtcal_toclass_user(mydata,version,error)
      use mrtcal_messaging
      use class_api
      use mrtcal_chunk_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Transfer and order the input 'mydata' object to the internal Class
      ! data buffer.
      !---------------------------------------------------------------------
      type(mrtcal_classuser_t), intent(in)    :: mydata   !
      integer(kind=4),          intent(in)    :: version  ! The version of the data
      logical,                  intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_toclass_user
  end interface
  !
  interface
    subroutine mrtcal_fromclass_user(mydata,version,error)
      use mrtcal_messaging
      use class_api
      use mrtcal_chunk_types
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private
      ! Transfer the data values from the Class data buffer to the 'mydata'
      ! instance.
      !---------------------------------------------------------------------
      type(mrtcal_classuser_t), intent(out)   :: mydata   !
      integer(kind=4),          intent(in)    :: version  ! The version of the data
      logical,                  intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_fromclass_user
  end interface
  !
  interface
    subroutine mrtcal_user_dump(version,error)
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Dump to screen the Mrtcal User Subsection
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: version ! The version of the data
      logical,         intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_user_dump
  end interface
  !
  interface
    subroutine mrtcal_user_setvar(version,error)
      use class_api
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Define SIC variables in the structure R%USER%OWNER% which map the
      ! subsection content.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: version ! The version of the data
      logical,         intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_user_setvar
  end interface
  !
  interface
    subroutine mrtcal_user_fix(version,found,error)
      use mrtcal_index_vars
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Hook to command:
      !   LAS\FIND /USER
      !  Find or not according the Mrtcal User Subsection. Called only if
      ! the observation has a user section and it matches the one
      ! declared here.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: version  ! The version of the data
      logical,         intent(out)   :: found    !
      logical,         intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_user_fix
  end interface
  !
  interface
    subroutine mrtcal_user_find(arg,narg,error)
      use mrtcal_index_vars
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Hook to command:
      !   LAS\FIND /USER [Arg1] ... [ArgN]
      ! Command line parsing: retrieve the arguments given to the option.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: narg       !
      character(len=*), intent(in)    :: arg(narg)  !
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine mrtcal_user_find
  end interface
  !
  interface
    subroutine mrtcal_user_varidx_fill(version,ient,error)
      use classic_api
      use mrtcal_calib_types
      use mrtcal_sicidx
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Hook to command:
      !   EXP\VARIABLE USER /INDEX  (array filling part)
      ! Fill the arrays supporting the structure IDX%USER%
      !---------------------------------------------------------------------
      integer(kind=4),            intent(in)    :: version  ! The version of the data
      integer(kind=entry_length), intent(in)    :: ient     !
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_user_varidx_fill
  end interface
  !
  interface
    subroutine mrtcal_user_varidx_defvar(error)
      use classic_api
      use mrtcal_sicidx
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Hook to command:
      !   EXP\VARIABLE USER /INDEX  (variables definition)
      ! Define the Sic arrays in IDX%USER%30M%MRTCAL%
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine mrtcal_user_varidx_defvar
  end interface
  !
  interface
    subroutine mrtcal_user_varidx_realloc(nent,error)
      use gildas_def
      use classic_api
      use mrtcal_sicidx
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Hook to command:
      !   EXP\VARIABLE USER /INDEX  (re/deallocation part)
      ! Re/Deallocate the support arrays. nent <= 0 means deallocation only
      ! (useful at exit time)
      !---------------------------------------------------------------------
      integer(kind=entry_length), intent(in)    :: nent     !
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine mrtcal_user_varidx_realloc
  end interface
  !
  interface mrtcal_chunkset_to_obs
    subroutine mrtcal_chunkset0d_to_obs(set,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_chunkset_to_obs
      ! Stitch the spectra in the set and write them as a Class observation
      ! into the Class output file
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset0d_to_obs
    subroutine mrtcal_chunkset1d_to_obs(set,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_chunkset_to_obs
      ! Convert an array of chunksets to one Class observation with
      ! Associated Arrays
      !---------------------------------------------------------------------
      type(chunkset_t), intent(in)    :: set(:)
      logical,          intent(inout) :: error
    end subroutine mrtcal_chunkset1d_to_obs
  end interface mrtcal_chunkset_to_obs
  !
  interface
    subroutine mrtcal_update_command(line,error)
      use mrtcal_messaging
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command MUPDATE
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_update_command
  end interface
  !
  interface
    subroutine mrtcal_variable_comm(line,error)
      use mrtcal_messaging
      use mrtcal_buffers
      use mrtcal_index_vars
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command
      !   VARIABLE [*|WHAT [READ|WRITE]]
      !  Create the Sic structures mapping the mrtcal internal buffers
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine mrtcal_variable_comm
  end interface
  !
  interface
    subroutine mrtcal_variable_databuf(struct,databuf,ro,error)
      use mrtcal_buffer_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a data_buffer_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),    intent(in)    :: struct   ! Parent structure name
      type(data_buffer_t), intent(in)    :: databuf  !
      logical,             intent(in)    :: ro       ! Read-Only
      logical,             intent(inout) :: error    !
    end subroutine mrtcal_variable_databuf
  end interface
  !
  interface
    subroutine mrtcal_variable_book(struct,book,ro,error)
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a book_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: struct  ! Parent structure name
      type(book_t),     intent(in)    :: book    !
      logical,          intent(in)    :: ro      ! Read-Only
      logical,          intent(inout) :: error   !
    end subroutine mrtcal_variable_book
  end interface
  !
  interface
    subroutine mrtcal_variable_range(struct,range,ro,error)
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a range_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: struct  ! Parent structure name
      type(range_t),    intent(in)    :: range   !
      logical,          intent(in)    :: ro      ! Read-Only
      logical,          intent(inout) :: error   !
    end subroutine mrtcal_variable_range
  end interface
  !
  interface
    subroutine mrtcal_variable_block(struct,block,ro,error)
      use mrtcal_bookkeeping_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a block_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: struct  ! Parent structure name
      type(block_t),    intent(in)    :: block   !
      logical,          intent(in)    :: ro      ! Read-Only
      logical,          intent(inout) :: error   !
    end subroutine mrtcal_variable_block
  end interface
  !
  interface
    subroutine mrtcal_write_command(line,error)
      use mrtcal_messaging
      use mrtcal_buffers
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command WRITE
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine mrtcal_write_command
  end interface
  !
  interface
    subroutine mrtcal_write_chunkset_fsw_toclass(chunkset1,chunkset2,out,nspec,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private
      !  Specific to FSW data
      !  Fold the pair of chunksets and produce a single class spectrum
      !---------------------------------------------------------------------
      type(chunkset_t),            intent(in)    :: chunkset1
      type(chunkset_t),            intent(in)    :: chunkset2
      type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
      integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_chunkset_fsw_toclass
  end interface
  !
  interface mrtcal_write_chunkset_toclass
    subroutine mrtcal_write_chunkset0d_toclass(chunkset0d,out,nspec,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_write_chunkset_toclass
      !  Write a single chunk set to the Class output file by chunk or
      !  by set of chunks
      !---------------------------------------------------------------------
      type(chunkset_t),            intent(in)    :: chunkset0d
      type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
      integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_chunkset0d_toclass
    subroutine mrtcal_write_chunkset1d_toclass(chunkset1d,out,nspec,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_write_chunkset_toclass
      !  Write a single chunk set to the Class output file by chunk or
      !  by set of chunks
      !---------------------------------------------------------------------
      type(chunkset_t),            intent(in)    :: chunkset1d(:)
      type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
      integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_chunkset1d_toclass
  end interface mrtcal_write_chunkset_toclass
  !
  interface mrtcal_write_toclass
    subroutine mrtcal_write_chunkset3d_toclass(chunkset_3d,out,nspec,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_write_toclass
      ! Convert the input chunk sets to Class observations
      ! This version for 3D chunk sets (i.e. not yet time averaged)
      !---------------------------------------------------------------------
      type(chunkset_3d_t),         intent(in)    :: chunkset_3d
      type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
      integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
      logical,                     intent(inout) :: error
    end subroutine mrtcal_write_chunkset3d_toclass
    subroutine mrtcal_write_chunkset2d_toclass(data_2d,out,nspec,error)
      use mrtcal_messaging
      use mrtcal_calib_types
      use mrtcal_setup_types
      !---------------------------------------------------------------------
      ! @ private-generic mrtcal_write_toclass
      ! Convert the input chunk sets to Class observations
      ! This version for 2D chunk sets (i.e. already time averaged)
      !---------------------------------------------------------------------
      type(chunkset_2d_t),           intent(in)    :: data_2d  ! The data RY to be written
      type(mrtcal_setup_output_t),   intent(in)    :: out      ! Output configuration
      integer(kind=4),               intent(inout) :: nspec    ! Cumulative number of spectra written
      logical,                       intent(inout) :: error    !
    end subroutine mrtcal_write_chunkset2d_toclass
  end interface mrtcal_write_toclass
  !
end module mrtcal_interfaces_private

subroutine selimy(y1,y2)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Set Y limits to Y1 Y2
  !---------------------------------------------------------------------
  real(kind=plot_length), intent(in) :: y1,y2  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real(kind=plot_length) :: deps
  !
  ! Minimal protection against floating overflows...
  deps = epsr4
  if ((abs(y1).gt.maxr4/2).or.(abs(y2).gt.maxr4/2)) then
     guy1 = -maxr4/2
     guy2 = +maxr4/2
  elseif (abs(y1-y2).lt.min(deps*abs(y1),deps*deps)) then
     guy1 = y1*(1+deps)
     guy2 = y1*(1-deps)
  else
     guy1 = y1
     guy2 = y2
  endif
  call get_box(gx1,gx2,gy1,gy2)
  guy  = (gy2-gy1)/(guy2-guy1)
end subroutine selimy
!
subroutine gelimy(y1,y2,dy)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Returns current limits in Y and conversion factor
  ! Arguments :
  !	Y1,Y2	R*4	Limits 			Output
  !	DY	R*4	Conversion factor	Output
  !---------------------------------------------------------------------
  real(kind=plot_length), intent(out) :: y1,y2  !
  real(kind=plot_length), intent(out) :: dy     !
  !
  y1  = guy1
  y2  = guy2
  guy = (gy2-gy1)/(guy2-guy1)
  dy  = guy
end subroutine gelimy
!
subroutine selimy2d(y1,y2)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Set Y limits to Y1 Y2
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: y1,y2  !
  ! Global
  include 'gbl_pi.inc'
  !
  ! Minimal protection against floating overflows...
  if ((abs(y1).gt.maxr4/2).or.(abs(y2).gt.maxr4/2)) then
     guy1 = -maxr4/2
     guy2 = +maxr4/2
  elseif (abs(y1-y2).lt.min(epsr4*abs(y1),epsr4*epsr4)) then
     guy1 = y1*(1+epsr4)
     guy2 = y1*(1-epsr4)
  else
     guy1 = y1
     guy2 = y2
  endif
end subroutine selimy2d
!
subroutine selimz(z1,z2)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Set Z limits to Z1 Z2
  !---------------------------------------------------------------------
  real(kind=plot_length), intent(in) :: z1,z2  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real(kind=plot_length) :: deps
  !
  ! Minimal protection against floating overflows...
  deps = epsr4
  if ((abs(z1).gt.maxr4/2).or.(abs(z2).gt.maxr4/2)) then
     guz1 = -maxr4/2
     guz2 = +maxr4/2
  elseif (abs(z1-z2).lt.min(deps*abs(z1),deps*deps)) then
     guz1 = z1*(1+deps)
     guz2 = z1*(1-deps)
  else
     guz1 = z1
     guz2 = z2
  endif
  call get_box(gx1,gx2,gy1,gy2)
  guz  = (gy2-gy1)/(guz2-guz1)
end subroutine selimz
!
subroutine gelimz(z1,z2,dz)
  use plot_formula
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS	Internal routine
  !	Returns current limits in Z and conversion factor
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: z1,z2  !
  real(kind=4), intent(out) :: dz     !
  !
  z1  = guz1
  z2  = guz2
  guz = (gy2-gy1)/(guz2-guz1)
  dz  = guz
  !
end subroutine gelimz

module cubeset_buffering
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_setup_types
  use cubetools_datasize
  use cubeset_messaging
  !
  public :: bufferingcomm
  private
  !
  type :: buffering_comm_t
     type(option_t),      pointer :: comm
     type(option_t),      pointer :: input
     type(keywordlist_comm_t), pointer :: input_arg
     type(option_t),      pointer :: output
     type(keywordlist_comm_t), pointer :: output_arg
     type(option_t),      pointer :: block
     type(option_t),      pointer :: limit
     type(option_t),      pointer :: task
     type(option_t),      pointer :: defaults
   contains
     procedure, public  :: register => cubeset_buffering_register
     procedure, private :: parse    => cubeset_buffering_parse
     procedure, private :: print    => cubeset_buffering_print
  end type buffering_comm_t
  type(buffering_comm_t) :: bufferingcomm
  !
contains
  subroutine cubeset_buffering_command(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    ! BUFFERING Mode
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='BUFFERING>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    if (cubetools_nopt().eq.0) then
       call bufferingcomm%print(error)
       return
    endif
    call bufferingcomm%parse(line,error)
    if (error) return
  end subroutine cubeset_buffering_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_buffering_register(bufferingcomm,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(inout) :: bufferingcomm
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: rname='BUFFERING>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'BUFFERING','',&
         'Set how input and output files are buffered',&
         'Large input/output files may not fit in RAM memory.&
         & This command allows the user to tune the CUBE&
         & behavior in such a case. The MEMORY only mode will&
         & return an error, while the DISK mode will read/write&
         & only part of the data in RAM memory at a given time.&
         & The AUTOMATIC mode decides which method to use for&
         & each cube depending on its size. Use /DEFAULT to reset&
         & buffering settings. When /DEFAULT is combined with other&
         & keys on the same command line, reset is applied first.',&
         cubeset_buffering_command,&
         bufferingcomm%comm,error)
    if (error) return
    !
    call cubetools_register_option(&
         'INPUT','value',&
         'Define buffering mode for input files',&
         'Choose whether the input files should be stored entirely in&
         & memory (MEMORY mode), or processed by blocks (DISK mode).&
         & Another possibility is to automatically switch between memory&
         & and disk mode depending on the cube size (AUTOMATIC mode).',&
         bufferingcomm%input,error)
    if (error) return
    call keyarg%register(&
         'value',&
         'Input buffering mode',&
         strg_emp,&
         code_arg_mandatory,&
         buffering,&
         .not.flexible,&
         bufferingcomm%input_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'OUTPUT','value',&
         'Define buffering for output files',&
         'Choose whether the output files should be stored entirely in&
         & memory (MEMORY mode), or processed by blocks (DISK mode).&
         & Another possibility is to automatically switch between memory&
         & and disk mode depending on the cube size (AUTOMATIC mode).',&
         bufferingcomm%output,error)
    if (error) return
    call keyarg%register(&
         'value',&
         'Output buffering mode',&
         strg_emp,&
         code_arg_mandatory,&
         buffering,&
         .not.flexible,&
         bufferingcomm%output_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'BLOCK','size [unit]',&
         'Block size for disk access',&
         'In MEMORY mode, files are read from disk to memory all at&
         & once in a single buffer, but this process is done by blocks&
         & of the given size.'//strg_bl//&
         'In DISK mode files are accessed by contiguous blocks of&
         & limited size. This allows processing of files larger than&
         & the available memory. In serial mode, keeping this&
         & parameter relatively small (e.g. 1% of the file size)&
         & saves memory with marginal file access overheads (e.g. 1%&
         & means 100 accesses to the file). In parallel mode, however&
         &, one might want to increase this value so that a large&
         & slice of the file is loaded in memory and is processed by&
         & several parallelisation tasks: the ideal value is Nthread&
         & times the /TASK size parameter.',&
         bufferingcomm%block,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Block size for disk mode',&
         'Default is 0.1 GiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for block size',&
         'Default is GiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'LIMIT','size [unit]',&
         'Define the threshold for DISK use in automatic mode',&
         'In AUTOMATIC mode, define the cube size threshold above&
         & which the file is processed by blocks on disk.',&
         bufferingcomm%limit,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Limit between DISK access and MEMORY access',&
         'Default is 1 GiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for limit',&
         'Default is GiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'TASK','size [unit]',&
         'Define parallel task size',&
         'When parallel processing is available, the entries (either&
         &images, spectra, or subcubes) are grouped in different tasks,&
         &and the tasks are executed in parallel.'&
         //strg_bl//&
         'The larger the task, the smaller the task overheads. On the&
         &other hand, if tasks are too large, the currently processed&
         &data block (full file or file block) might not be divided in&
         &enough tasks to occupy all the parallel threads.',&
         bufferingcomm%task,error)
    if (error) return
    call stdarg%register(&
         'size',&
         'Size for parallelisation tasks',&
         'Default is 100 KiB.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'unit for task size',&
         'Default is KiB.',&
         code_arg_optional,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEFAULT','',&
         'Reset buffering settings',&
         'Reset BUFFERING settings before applying other keys from the&
         & same command line.',&
         bufferingcomm%defaults,error)
    if (error) return
  end subroutine cubeset_buffering_register
  !
  subroutine cubeset_buffering_parse(bufferingcomm,line,error)
    use cubeadm_setup
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(in)    :: bufferingcomm
    character(len=*),        intent(in)    :: line
    logical,                 intent(inout) :: error
    !
    type(cube_setup_buffer_t) :: defaults
    ! Topics
    logical :: dodefaults
    character(len=*), parameter :: rname='BUFFERING>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call bufferingcomm%defaults%present(line,dodefaults,error)
    if (error) return
    if (dodefaults) then  
       cubset%buff%input   = defaults%input
       cubset%buff%output  = defaults%output
       cubset%buff%limit   = defaults%limit
       cubset%buff%block   = defaults%block
       cubset%buff%task    = defaults%task
    endif
    !
    call cubeset_buffering_parse_mode(line,bufferingcomm%input,bufferingcomm%input_arg,cubset%buff%input,error)
    if (error) return
    call cubeset_buffering_parse_mode(line,bufferingcomm%output,bufferingcomm%output_arg,cubset%buff%output,error)
    if (error) return
    !
    call cubeset_buffering_parse_size(line,bufferingcomm%block,defaults%block,dataunit(iGiB),cubset%buff%block,error)
    if (error) return
    call cubeset_buffering_parse_size(line,bufferingcomm%limit,defaults%limit,dataunit(iGiB),cubset%buff%limit,error)
    if (error) return
    call cubeset_buffering_parse_size(line,bufferingcomm%task,defaults%task,dataunit(ikiB),cubset%buff%task,error)
    if (error) return
  end subroutine cubeset_buffering_parse
  !
  subroutine cubeset_buffering_parse_mode(line,opt,keyarg,mode,error)
    use cubetools_disambiguate
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    type(option_t),       intent(in)    :: opt
    type(keywordlist_comm_t),  intent(in)    :: keyarg
    integer(kind=code_k), intent(out)   :: mode
    logical,              intent(inout) :: error
    !
    logical :: do
    character(len=argu_l) :: argu, key
    character(len=*), parameter :: rname='BUFFERING>PARSE>MODE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,opt,1,argu,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(keyarg,argu,mode,key,error)
       if (error) return
    endif
  end subroutine cubeset_buffering_parse_mode
  !
  subroutine cubeset_buffering_parse_size(line,opt,defsize,defunit,size,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    type(option_t),       intent(in)    :: opt
    real(kind=size_k),    intent(in)    :: defsize
    character(len=*),     intent(in)    :: defunit
    real(kind=size_k),    intent(inout) :: size
    logical,              intent(inout) :: error
    !
    logical :: do
    character(len=argu_l) :: usize, uunit
    character(len=*), parameter :: rname='BUFFERING>PARSE>MODE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,opt,1,usize,mandatory,error)
       if (error) return
       uunit = defunit
       call cubetools_getarg(line,opt,2,uunit,.not.mandatory,error)
       if (error) return
       !
       call cubetools_datasize_user2prog(usize,uunit,defsize,size,error)
       if (error) return
    endif
  end subroutine cubeset_buffering_parse_size
  !
  subroutine cubeset_buffering_print(bufferingcomm,error)
    use cubetools_format
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(buffering_comm_t), intent(in)    :: bufferingcomm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='BUFFERING>PRINT'
    !
    character(len=message_length) :: mess
    !
    call cubeset_message(seve%r,rname,'  Buffering')
    write(mess,'(2A)')  '    INPUT:  ',buffering(cubset%buff%input)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    OUTPUT: ',buffering(cubset%buff%output)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    LIMIT:  ',cubetools_format_memsize(cubset%buff%limit)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    BLOCK:  ',cubetools_format_memsize(cubset%buff%block)
    call cubeset_message(seve%r,rname,mess)
    write(mess,'(2A)')  '    TASK:   ',cubetools_format_memsize(cubset%buff%task)
    call cubeset_message(seve%r,rname,mess)
  end subroutine cubeset_buffering_print
end module cubeset_buffering

module sic_hashing_types
  use gmath_quicksort_types
  use sic_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting type(sic_variable_t) dictionaries
  type, extends(gi4_quicksort_t) :: sic_hassort_t
    type(sic_variable_t), pointer :: dict(:)
  contains
    procedure, public :: compare => sic_hassort_compare
  end type sic_hassort_t
  !
  ! Type for sorting character string dictionaries
  type, extends(gi4_quicksort_t) :: gag_hassort_t
    character(len=:), pointer :: dict(:)
  contains
    procedure, public :: compare => gag_hassort_compare
  end type gag_hassort_t
  !
contains
  !
  function sic_hassort_compare(self,m,l)
    !-------------------------------------------------------------------
    ! Variable comparison function: just compare the variable names
    !-------------------------------------------------------------------
    integer(kind=4) :: sic_hassort_compare
    class(sic_hassort_t), intent(in) :: self
    integer(kind=4),      intent(in) :: m,l
    if (self%dict(m)%id%name.eq.self%dict(l)%id%name) then
      sic_hassort_compare = 0
    elseif (lgt(self%dict(m)%id%name,self%dict(l)%id%name)) then
      sic_hassort_compare = 1
    else
      sic_hassort_compare = -1
    endif
  end function sic_hassort_compare
  !
  function gag_hassort_compare(self,m,l)
    !-------------------------------------------------------------------
    ! Variable comparison function: just compare the variable names
    !-------------------------------------------------------------------
    integer(kind=4) :: gag_hassort_compare
    class(gag_hassort_t), intent(in) :: self
    integer(kind=4),      intent(in) :: m,l
    if (self%dict(m).eq.self%dict(l)) then
      gag_hassort_compare = 0
    elseif (lgt(self%dict(m),self%dict(l))) then
      gag_hassort_compare = 1
    else
      gag_hassort_compare = -1
    endif
  end function gag_hassort_compare
end module sic_hashing_types
!
function sic_hasins(rname,mdim,pf,pn,dict,var,in)
  use gbl_message
  use sic_interfaces, except_this=>sic_hasins
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Insert a new name or replace an existing name
  !       in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASINS      0       E  Invalid name
  !                       1       S  Successfully inserted
  !                       2       E  Too many names
  !                       3       S  Successfully replaced
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasins  ! Function value on return
  character(len=*),       intent(in)    :: rname       ! Calling routine name
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be inserted
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j,k
  character(len=message_length) :: mess
  !
  in = 0
  sic_hasins = 0
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) then
    call sic_message(seve%e,rname,'Invalid variable name '//var%name)
    return
  endif
  !
  ! Find if it exits already
  k = pf(j)
  do while (k.gt.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        in = k
        sic_hasins = 3
        return
      endif
    endif
    k = pn(k)
  enddo
  !
  ! Find if place left
  if (pf(26).eq.0) then
    write(mess,'(A,I0,A)')  'Too many variables, set SIC_MAXVAR to more than ',  &
      mdim,' in your $HOME/.gag.dico'
    call sic_message(seve%e,rname,mess)
    sic_hasins = 2
    return
  endif
  !
  ! Insert NAME in place and set pointers
  k = pf(26)
  pf(26) = pn(k)
  pn(k) = pf(j)
  pf(j) = k
  dict(k)%id = var
  in = k
  pf(27) = pf(27)+1
  sic_hasins = 1
  !
end function sic_hasins
!
function sic_hasdel(mdim,pf,pn,dict,var)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Delete a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASDEL      1       Name deleted
  !                       3       Name does not exist
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasdel  ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be deleted
  ! Local
  integer(kind=4) :: j,kl,k
  !
  sic_hasdel = 3
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine if it is a known symbol
  kl = 0
  k = pf(j)
  do while (k.ne.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        exit
      endif
    endif
    kl = k
    k = pn(k)
  enddo
  if (k.eq.0)  return  ! Nothing found (reached end of dictionary with no matching
                       ! variable)
  !
  ! Now delete it
  sic_hasdel = 1
  if (kl.ne.0) then
    pn(kl) = pn(k)
  else
    pf(j) = pn(k)
  endif
  pn(k) = pf(26)
  pf(26) = k
  pf(27) = pf(27)-1
end function sic_hasdel
!
function sic_hasfin(mdim,pf,pn,dict,var,in)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASFIN      0       No such name
  !                       1       Name found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasfin                          ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(in)    :: pf(0:27)    !
  integer(kind=4),        intent(in)    :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be found
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j
  !
  ! If no symbol return
  in = 0
  sic_hasfin = 0
  if (pf(27).eq.0) return
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (var%level.eq.dict(j)%id%level .and. var%lname.eq.dict(j)%id%lname) then
      if (var%name(1:var%lname).eq.dict(j)%id%name(1:var%lname)) then
        in = j
        sic_hasfin = 1
        return
      endif
    endif
    j = pn(j)
  enddo
  !
end function sic_hasfin
!
function sic_hasambigs(mdim,pf,pn,dict,name,if,il)
  use sic_dependencies_interfaces
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find all names beginning with the letters of NAME
  !       in  a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASAMBIGS   0       No such name
  !                       n       N Names found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasambigs                     ! Value on return
  integer(kind=4),      intent(in)  :: mdim        ! Size of dictionary
  integer(kind=4),      intent(in)  :: pf(0:27)    !
  integer(kind=4),      intent(in)  :: pn(mdim)    !
  type(sic_variable_t), intent(in)  :: dict(mdim)  ! Dictionary array
  character(len=*),     intent(in)  :: name        ! Name against whom search
  integer(kind=4),      intent(out) :: if          ! Adress of first Match
  integer(kind=4),      intent(out) :: il          ! Adress of  last Match
  ! Local
  integer(kind=4) :: j,l
  character(len=varname_length) :: uname
  !
  ! If no symbol return
  if = 0
  il = 0
  sic_hasambigs = 0
  !
  ! Find the place in PF
  l = len_trim(name)
  uname = name
  call sic_upper(uname)
  j = ichar(uname(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  if (pf(27).eq.0) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      if (if.eq.0) if = j
      il = j
      sic_hasambigs = sic_hasambigs+1
    endif
    j = pn(j)
  enddo
  if (if.eq.0) return
  !
  if (if.eq.il .and. uname.eq.dict(if)%id%name) return
  !
  call sic_message(seve%w,'SIC','Ambiguous Name, Could be:')
  j = ichar(uname(1:1))-ichar('A')
  j = pf(j)
  !
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      write (*,'(A)') trim(dict(j)%id%name)
    endif
    j = pn(j)
  enddo
  !
end function sic_hasambigs
!
subroutine sic_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_hashing_types
  use sic_interfaces, except_this=>sic_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),              intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),              intent(in)  :: pf(0:27)    !
  integer(kind=4),              intent(in)  :: pn(mdim)    !
  type(sic_variable_t), target, intent(in)  :: dict(mdim)  ! Dictionary array
  integer(kind=4),              intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),              intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  type(sic_hassort_t) :: hassort
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionnary
  !
  error = .false.
  hassort%dict => dict
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call hassort%sort(list(first:last),last-first+1,error)
    if (error)  return
    !
  enddo
  !
end subroutine sic_hassort
!
subroutine gag_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_hashing_types
  use sic_interfaces, except_this=>gag_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as character string arrays ***
  !  (This subroutine should go in kernel/lib/gsys/hashing.f90 but
  !   the module gmath_quicksort_types is needed.)
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),          intent(in)  :: pf(0:27)    !
  integer(kind=4),          intent(in)  :: pn(mdim)    !
  character(len=*), target, intent(in)  :: dict(mdim)  ! Dictionary array
  integer(kind=4),          intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),          intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  type(gag_hassort_t) :: hassort
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionary
  !
  error = .false.
  hassort%dict => dict
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call hassort%sort(list(first:last),last-first+1,error)
    if (error)  return
    !
  enddo
  !
end subroutine gag_hassort

module cubeio_highlevel
  use cubetools_parameters
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_messaging
  use cubeio_cube_define
  use cubeio_cube
  use cubeio_desc_setup
  use cubeio_interface
  use cubeio_header_iodesc
  use cubeio_header_interface
  use cubeio_flush
  !---------------------------------------------------------------------
  ! High level API which makes sense for outer libraries
  !---------------------------------------------------------------------

  public :: cubeio_get_header
  public :: cubeio_interface_put
  public :: cubeio_clone_header
  public :: cubeio_dump_cube
  public :: cubeio_cube_finish
  private

contains

  subroutine cubeio_get_header(cubset,cubdef,dno,cub,error)
    !----------------------------------------------------------------------
    ! Get the file header, derived from the file header on disk (whatever
    ! the file kind).
    ! Also set up the IO-descriptor internal structure.
    !----------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='GET>HEADER'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call cubeio_cube_read_header(cubdef,dno,cub,error)
    if (error)  return
    !
    ! Set up descriptor
    call cubeio_set_descriptor_intrinsic(dno,cub,error)
    if (error)  return
    call cubeio_set_descriptor_external(cubset,cubdef,.true.,cub,error)
    if (error)  return
  end subroutine cubeio_get_header

  subroutine cubeio_interface_put(dno,order,cub,error)
    !-------------------------------------------------------------------
    ! From interface_t to header_t and iodesc_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: order  ! code_order_*
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    !
    call cubeio_header_interface_transpose(dno%node%head,order,error)  ! Inplace
    if (error) return
    call dno%node%interf2head(error)
    if (error) return
    call cubeio_iodesc_import(dno%node%head,cub%desc,error)
    if (error) return
  end subroutine cubeio_interface_put

  subroutine cubeio_clone_header(cubset,cubdef,dno,cout,error)
    !---------------------------------------------------------------------
    ! Prepare the output descriptor according to input reference and
    ! optional changes
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cout
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='CLONE>HEADER'
    !
    ! Sanity
    if (.not.cubdef%dofilename) then
      call cubeio_message(seve%e,rname,'Internal error: cube file name must be set')
      error = .true.
      return
    endif
    if (.not.cubdef%doorder) then
      call cubeio_message(seve%e,rname,'Internal error: output order must be set')
      error = .true.
      return
    endif
    if (.not.cubdef%doaccess) then
      call cubeio_message(seve%e,rname,'Internal error: output access mode must be set')
      error = .true.
      return
    endif
    !
    ! Set up the IO descriptor
    cout%file%name = cubdef%filename
    cout%file%hdu = cubdef%hdu
    call cubeio_header_put(dno,cubdef%order,cout%desc,error)
    if (error)  return
    call cubeio_set_descriptor_external(cubset,cubdef,.false.,cout,error)
    if (error)  return
  end subroutine cubeio_clone_header

  subroutine cubeio_dump_cube(cubset,cubdef,dno,cub,error)
    !---------------------------------------------------------------------
    ! Dump (i.e. write or update) all-at-once a cube from memory to disk,
    ! if relevant (i.e. nothing done for a read-only cube).
    ! ---
    ! ZZZ This all-at-once toolbox is a bit ad-hoc. Should it be ported
    ! to a more standard internal API (with blocks iteration)?
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DUMP>CUBE'
    !
    call cubeio_set_descriptor_external(cubset,cubdef,.false.,cub,error)
    if (error)  return
    !
    select case (cub%desc%action)
    case (code_read_head,code_read)
      ! Nothing to be done
    case (code_write)
      call cubeio_write_cube(cubset,cubdef,dno,cub,error)
    case (code_update)
      call cubeio_message(seve%e,rname,'Update mode not implemented')
      error = .true.
    case default
      call cubeio_message(seve%e,rname,'Invalid action code')
      error = .true.
    end select
    !
  end subroutine cubeio_dump_cube

  subroutine cubeio_write_cube(cubset,cubdef,dno,cub,error)
    !---------------------------------------------------------------------
    ! Write a cube from memory to disk
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    type(cube_define_t),          intent(in)    :: cubdef
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WRITE>CUBE'
    !
    select case (cub%desc%buffered)
    case (code_buffer_none)
      call cubeio_message(seve%e,rname,'No data available')
      error = .true.
      return
      !
    case (code_buffer_memory)
      if (.not.cubset%output%write)  return  ! Writing is disabled
      !
      ! Sanity
      if (.not.cubdef%dofilename) then
        call cubeio_message(seve%e,rname,'Missing file name')
        error = .true.
        return
      endif
      if (.not.cubdef%doaccess) then
        call cubeio_message(seve%e,rname,'Internal error: output access mode must be set')
        error = .true.
        return
      endif
      !
      ! Write everything (header+data) from memory to disk
      call cubeio_cube_write_cube(cub,cubdef,dno,error)
      if (error)  return
      call cubeio_message(seve%i,rname,'Cube written to file '//cubdef%filename)
      !
    case (code_buffer_disk)
      ! Already on disk... might need flushing the last buffer.
      call cubeio_flush_block(dno,cub,cub%file%block,error)
      if (error)  return
      call cubeio_message(seve%i,rname,'Cube flushed to file '//cub%file%hgdf%file)
      !
    case default
      call cubeio_message(seve%e,rname,'Unexpected buffering kind')
      error = .true.
      return
    end select
  end subroutine cubeio_write_cube

  subroutine cubeio_cube_finish(cubset,dno,cub,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! This subroutine is to be invoked once the cube is fully read or
    ! created or modified, to leave it in a 'better' state.
    !---------------------------------------------------------------------
    type(cube_setup_t),           intent(in)    :: cubset
    class(cubedag_node_object_t), intent(inout) :: dno
    type(cubeio_cube_t),          intent(inout) :: cub
    logical,                      intent(inout) :: error
    !
    ! Might need flushing of last block in case of disk mode
    call cubeio_flush_block(dno,cub,cub%file%block,error)
    if (error)  continue
    !
    ! Free temporary buffers as they are not needed anymore
    call cub%file%block%free(error)
    if (error)  continue
    !
    if (cub%desc%action.eq.code_write .or.  &
        cub%desc%action.eq.code_update) then
      ! Reload FITS header for extra entries
      call cubeio_cube_reload_header(cub,error)
      if (error)  return
    endif
    !
    ! Timing feedback?
    call gag_cputime_get(cub%time%total)  ! Get total time on this cube
    call cub%feedback()
  end subroutine cubeio_cube_finish

end module cubeio_highlevel

module cubedag_digraph
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_node_class
  use cubedag_messaging
  use cubedag_walker_types

  public :: cubedag_digraph_create
  private

  integer(kind=4) :: lun,mode
  logical :: noroot

contains
  !
  subroutine cubedag_digraph_create(start,childwalk,ofile,imode,error,inoroot)
    !-------------------------------------------------------------------
    ! Build the digraph (.dot file) by recursing children from the root
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: start
    logical,                      intent(in)    :: childwalk
    character(len=*),             intent(in)    :: ofile
    integer(kind=4),              intent(in)    :: imode
    logical,                      intent(inout) :: error
    logical, optional,            intent(in)    :: inoroot
    ! Local
    character(len=*), parameter :: rname='DIGRAPH>CREATE'
    integer(kind=4) :: ier
    class(cubedag_node_object_t), pointer :: object
    type(parentwalker_t) :: parentwalker
    type(childwalker_t) :: childwalker
    !
    mode = imode
    if (present(inoroot)) then
      noroot = inoroot
    else
      noroot = .true.
    endif
    !
    ier = sic_getlun(lun)
    if (mod(ier,2).eq.0) then
      call cubedag_message(seve%e,rname,'Cannot allocate LUN')
      error = .true.
      return
    endif
    ier = sic_open(lun,ofile,'NEW',.false.)
    if (ier.ne.0) then
      call putios('E-SIC, ',ier)
      error = .true.
      return
    endif
    !
    write(lun,'(A)')  'digraph CUBE {'
    write(lun,'(A)')  '  rankdir=BT;'
    write(lun,'(A)')  '  node [shape = ellipse];'
    !
    if (childwalk) then
      call childwalker%reset(start,cubedag_digraph_link,error)
      if (error)  return
      do while (childwalker%next(object))
        ! print *,'Found child: ',object%node%id
      enddo
    else
      call parentwalker%reset(start,cubedag_digraph_link,error)
      if (error)  return
      do while (parentwalker%next(object))
        ! print *,'Found parent: ',object%node%id
      enddo
    endif
    !
    write(lun,'(A)')  '}'
    !
    ier = sic_close(lun)
    call sic_frelun(lun)
  end subroutine cubedag_digraph_create
  !
  subroutine cubedag_digraph_link(par,chi,error)
    !-------------------------------------------------------------------
    ! Link a parent to its child in the digraph
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par
    class(cubedag_node_object_t), intent(in)    :: chi
    logical,                      intent(inout) :: error
    !
    if (noroot .and. (par%node%id.eq.0 .or. chi%node%id.eq.0) )  return
    !
    write(lun,'(5A)')  '  "',trim(cubedag_digraph_nodename(chi,error)),  &
                    '" -> "',trim(cubedag_digraph_nodename(par,error)),'";'
  end subroutine cubedag_digraph_link
  !
  function cubedag_digraph_nodename(no,error)
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! Return the node name under various format depending on 'mode'
    ! 1:  id
    ! 2:  family\n
    !     flag1,flag2,flag3
    ! 3:  id: family\n
    !     flag1,flag2,flag3
    ! 4:  id: family\n
    !     flag1,\n
    !     flag2,\n
    !     flag3
    !-------------------------------------------------------------------
    character(len=base_l) :: cubedag_digraph_nodename
    class(cubedag_node_object_t), intent(in)    :: no
    logical,                      intent(inout) :: error
    ! Local
    character(len=8) :: id
    character(len=128) :: flagoneline,flagsevline
    character(len=base_l) :: family
    integer(kind=4) :: nc,iflag
    type(flag_t), pointer :: flag
    !
    write(id,'(I0)')  no%node%id
    family = no%node%family
    flagoneline = ''
    flagsevline = ''
    if (no%node%flag%n.gt.0) then
      !
      flagoneline(1:2) = '\n'
      call no%node%flag%repr(flagoneline(3:),nc,error)
      if (error)  return
      !
      nc = 0
      do iflag=1,no%node%flag%n
        flag => cubetools_flag_ptr(no%node%flag%list(iflag)%p,error)
        if (error)  return
        flagsevline = trim(flagsevline)//'\n'//flag%get_name()
      enddo
    endif
    !
    select case (mode)
    case (1)
      cubedag_digraph_nodename = id
    case (2)
      cubedag_digraph_nodename = trim(family)//flagoneline
    case (3)
      cubedag_digraph_nodename = trim(id)//': '//trim(family)//flagoneline
    case (4)
      cubedag_digraph_nodename = trim(id)//': '//trim(family)//flagsevline
    case default
      cubedag_digraph_nodename = id
    end select
  end function cubedag_digraph_nodename
  !
end module cubedag_digraph

module gwcs_types
  !---------------------------------------------------------------------
  ! Projection definitions
  !---------------------------------------------------------------------
  !
  ! The following type is not specific to SFL but only implemented for
  ! SFL for now. See Calabretta & Greisen 2002, table 1.
  type :: projection_sfl_t
    real(kind=8) :: phi_p    ! Native longitude of the celestial pole
    real(kind=8) :: alpha_p  ! Celestial longitude of the native pole
    real(kind=8) :: delta_p  ! Celestial latitude of the native pole
    real(kind=8) :: cosdp    ! Cosinus of delta_p
    real(kind=8) :: sindp    ! Sinus of delta_p
  end type projection_sfl_t
  !
  type :: projection_t
    ! Projection definition
    real(kind=8)    :: a0     ! X Coordinate of projection point
    real(kind=8)    :: d0     ! Y Coordinate of projection point
    real(kind=8)    :: angle  ! Angle of projection line
    integer(kind=4) :: type   ! Projection type
    ! Derived parameters
    real(kind=8)    :: sina0  ! Sinus and
    real(kind=8)    :: cosa0  ! Cosinus of A0
    real(kind=8)    :: sind0  ! Sinus and
    real(kind=8)    :: cosd0  ! Cosinus of D0
    real(kind=8)    :: npole  ! Position of North pole
    real(kind=8)    :: spole  ! Position of South pole
    ! SFL support
    type(projection_sfl_t) :: sfl
  end type projection_t
end module gwcs_types

subroutine mesname (file)
  use gkernel_interfaces
  character(len=*) :: file          !
  ! Local
  character(len=48) :: name
  character(len=32) :: mess
  integer :: i
  !
  call sic_date(mess)
  call sic_lower(mess)
  i = index(mess,':')
  do while (i.gt.0)
    mess(i:)=mess(i+1:)
    i = index(mess,':')
  enddo
  i = index(mess,'-')
  do while (i.gt.0)
    mess(i:)=mess(i+1:)
    i = index(mess,'-')
  enddo
  name = 'clic-'//mess(1:9)//'-'//mess(11:16)
  call sic_parsef (name,file,'GAG_LOG:','.dat')
end subroutine mesname
!
subroutine messios (prio,seve,name,ier)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Output system message corresponding to IO error code IER, and
  ! using the MESSAGE routine, using the portable GAG_IOSTAT routine
  !---------------------------------------------------------------------
  integer :: prio                   !
  integer :: seve                   !
  character(len=*) :: name          !
  integer :: ier                    !
  ! Local
  character(len=60) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call message(prio,seve,name,msg)
end subroutine messios
!
function get_file_type ( fspec, ftype, ftype_len, new)
  use gkernel_interfaces
  integer :: get_file_type          !
  character(len=*) :: fspec         ! file spec to parse
  character(len=*) :: ftype         ! type field
  integer*4 :: ftype_len            ! length of type string
  logical :: new                    !
  ! Local
  integer :: i,j,l
  !
  i = index(fspec,'.')
  if (i.ne.0) then
    l = lenc(fspec)
    do j=l,i,-1
      if (fspec(j:j).eq.'.') then
        ftype = fspec(j:)
        ftype_len = lenc(ftype)
        call sic_upper(ftype)
        get_file_type = 1
        return
      endif
    enddo
  else
    get_file_type = 0
  endif
end function get_file_type
!
function get_file_name ( fspec, fname, fname_len)
  use gkernel_interfaces
  integer :: get_file_name          !
  character(len=*) :: fspec         ! file spec to parse
  character(len=*) :: fname         ! type field
  integer*4 :: fname_len            ! length of type string
  ! Local
  integer :: i
  character(len=1) :: cdir,insep,ousep
  !
  call gag_separ(insep,ousep,cdir)
  fname = fspec
  fname_len = lenc(fname)
  i = index(fname,cdir)
  do while (i.gt.0)
    fname(1:) = fname(i+1:fname_len)
    fname_len = fname_len - i
    i = index(fname,cdir)
  enddo
  i = index(fname,'.')
  if (i.le.0) return
  fname_len = i-1
  if (i.gt.1) then
    fname = fname(1:i-1)
  elseif (i.eq.1) then
    fname = ' '
  endif
  call sic_upper(fname)
  get_file_name = 1
end function get_file_name
!
function no_number(f)
  !---------------------------------------------------------------------
  !  Return codes of fpclassifyf:
  !
  !  FP_PLUS_NORM      0	/* Positive normalized */
  !  FP_MINUS_NORM     1	/* Negative normalized */
  !  FP_PLUS_ZERO      2	/* Positive zero */
  !  FP_MINUS_ZERO     3	/* Negative zero */
  !  FP_PLUS_INF	     4	/* Positive infinity */
  !  FP_MINUS_INF      5	/* Negative infinity */
  !  FP_PLUS_DENORM    6	/* Positive denormalized */
  !  FP_MINUS_DENORM   7	/* Negative denormalized */
  !  FP_SNAN	     8	/* Signalling NaN */
  !  FP_QNAN	     9	/* Quiet NaN */
  ! shanged to use gag_isreal
  !---------------------------------------------------------------------
  logical :: no_number              !
  real :: f                         !
  ! Global
  integer :: gag_isreal
  !-----------------------------------------------------------------------
  no_number = gag_isreal(f).ne.0   ! .FALSE.
  return
end function no_number
!
subroutine clic_directory(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! INPUT
  !     line       char    command line
  !     error      LOGICAL error parameter
  ! OUTPUT
  !     define  DIR_NFILE and DIR_FILE variables
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  integer :: nc, dir_nfile, id, lch, ier
  character(len=256) :: filestring, ch
  character(len=256), allocatable :: dir_file(:)
  save dir_nfile, dir_file
  !-----------------------------------------------------------------------
  filestring = '*.hpb'
  call sic_ch(line,0,1,filestring,nc,.false.,error)
  if (error) return
  id = index(filestring,':')
  if (id.gt.2) then
    ch = filestring(1:id)
    ier = sic_getlog(ch)
    lch = lenc(ch)
    filestring = ch(1:lch)//filestring(id+1:)
  endif
  call gag_directory(' ',filestring,dir_file,dir_nfile,error)
  if (error) return
  call sic_delvariable('DIR_NFILE',.false.,error)
  call sic_delvariable('DIR_FILE',.false.,error)
  if (dir_nfile.gt.0) then
    error = .false.
    call sic_def_inte('DIR_NFILE',dir_nfile,0,1,.true.,error)
    call sic_def_charn   &
      ('DIR_FILE',dir_file,1,dir_nfile,.true.,error)
  else
    call message(8,3,'CLIC_DIRECTORY','No file found')
  endif
  return
end subroutine clic_directory

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_init
  use cubeset_buffer
  use cubeset_spatial
  use cubeset_spectral
  use cubeset_messaging
  !
  public :: cubeset_library_init
  private
  !
contains
  !
  subroutine cubeset_library_init(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='LIBRARY>INIT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubeset%init('cubeset',error)
    if (error) return
    call userspe%init(error)
    if (error) return
    call userspa%init(error)
    if (error) return
  end subroutine cubeset_library_init
end module cubeset_init
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetuple_format_class
  use cubetools_parameters
  use cubetools_header_types
  use cubetools_processing_types
  use cubetools_setup_types
  use cubedag_node_class
  use cubeio_cube_define
  use cubetuple_messaging
  use cubetuple_iterator
  use cubetuple_tuple
  !---------------------------------------------------------------------
  ! Support module for any data kind which can be described with a
  ! cube_header_t, 0 or more DAPS, and some data with consistent shape.
  !---------------------------------------------------------------------
  !
  type, abstract, extends(cubedag_node_object_t) :: format_t
    type(cube_header_t)          :: head   ! [public]  User friendly cube description
  ! type(daps_t)                 :: daps   !
    type(cubetuple_t)            :: tuple  ! [private]
    type(cube_define_t)          :: prog   ! [private] program request
    type(cube_setup_t), pointer  :: user   ! [private] user    request
    type(cubetools_processing_t) :: proc   ! [private] technical components for processing
    type(cubetuple_iterator_t), public :: iter  ! Iterator utilities when processing a command
  contains
    procedure          :: init            => cubetuple_format_init
    procedure          :: list            => cubetuple_format_list
    procedure, private :: close           => cubetuple_format_close
    procedure, public  :: reimport_format => cubetuple_format_reimport_format
    procedure          :: finish_format   => cubetuple_format_finish_format
    procedure, public  :: default_iorder  => cubetuple_format_default_intrinsic_order
    procedure, public  :: set_iorder      => cubetuple_format_set_intrinsic_order
    procedure          :: iorder          => cubetuple_format_get_intrinsic_order
    procedure          :: order           => cubetuple_format_get_mapped_order
    procedure          :: access          => cubetuple_format_get_access
    procedure, public  :: iscplx          => cubetuple_format_get_iscplx
    procedure          :: attach_file     => cubetuple_format_attach_file
    procedure, private :: dag_upsert      => cubetuple_format_dag_upsert
    procedure, private :: timing_collect  => cubetuple_format_timing_collect
    procedure, public  :: default_region  => cubetuple_format_default_region
    procedure, public  :: autotranspose   => cubetuple_format_autotranspose
    procedure, public  :: final_format    => cubetuple_format_final_format
  end type format_t
  !
  public :: format_t
  public :: cubetuple_format_ptr
  private
  !
contains
  !
  subroutine cubetuple_format_init(format,setup,error)
    !-------------------------------------------------------------------
    ! Initialize a format_t
    !-------------------------------------------------------------------
    class(format_t),     intent(inout)       :: format
    type(cube_setup_t),  intent(in), target  :: setup
    logical,             intent(inout)       :: error
    !
    format%user => setup
    call format%tuple%init(error)
    if (error)  return
    call format%head%init(error)
    if (error)  return
    call format%node%head_associate(format%head,error)
    if (error)  return
  end subroutine cubetuple_format_init
  !
  subroutine cubetuple_format_list(format,code_dataformat,error)
    use gfits_types
    use cubeio_dataformat_types
    use cubefitsio_header
    use cubeio_interface
    use cubetools_header_vo
    !-------------------------------------------------------------------
    ! List the cube header under requested format
    !-------------------------------------------------------------------
    class(format_t),      intent(inout) :: format
    integer(kind=code_k), intent(in)    :: code_dataformat
    logical,              intent(inout) :: error
    !
    type(fitsio_header_t) :: hfits
    !
    select case (code_dataformat)
    case (code_dataformat_cube)
      call format%head%list(error)
      if (error) return
    case (code_dataformat_interface)
      call format%node%head%list(error)  ! format%node%head is interface_t
      if (error) return
    case (code_dataformat_fits)
      if (format%tuple%haskind(code_dataformat_fits)) then
        ! Tuple will just list its current FITS header
        call format%tuple%list(code_dataformat,error)
        if (error)  return
      else
        ! Convert format%head to FITS format
        call cubetuple_message(seve%w,'LIST','Current header is not FITS')
        ! NB: Display in its current order (no internal transposition at conversion
        ! time)
        call cubeio_header_put(format,format%tuple%order(),hfits,error)
        if (error)  return
        call gfits_list_dict(hfits%dict,error)
        if (error)  return
      endif
    case (code_dataformat_vo)
      call cubetools_header_vo_list(format%head,error)
      if (error) return
    case default
      call format%tuple%list(code_dataformat,error)
      if (error)  return
    end select
  end subroutine cubetuple_format_list
  !
  subroutine cubetuple_format_close(format,error)
    !---------------------------------------------------------------------
    ! GIO-close a 'format_t' instance. This is worth calling this
    ! subroutine as GIO slots are a limited ressource
    !---------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    !
    call format%tuple%close(error)
    if (error)  return
  end subroutine cubetuple_format_close
  !
  subroutine cubetuple_format_reimport_format(format,error)
    !---------------------------------------------------------------------
    ! Reimport a 'format_t' instance from disk to DAG
    !---------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    !
    call format%get_header(format%head,error)
    if (error) return
  end subroutine cubetuple_format_reimport_format
  !
  subroutine cubetuple_format_finish_format(format,error)
    use cubeio_desc
    use cubeio_highlevel
    !---------------------------------------------------------------------
    ! Properly finish a cube after command execution. Namely:
    ! - flush the remaining buffers from memory to disk if relevant
    ! - upsert in DAG
    ! - collect timing
    ! - free I/O ressources
    !---------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FORMAT>FINISH'
    !
    if (error) return  ! Error recovery: we should probably do some cleaning below!
    !
    ! File extrema
    call format%proc%put_extrema(format%head,error)
    if (error)  return
    !
    if (format%tuple%trans%do.ne.code_trans_none) then
      call cubetuple_message(seve%d,rname,  &
        'Finishing the tuple but a transposition is pending')
      ! Two possibilities:
      ! - If the next command needs the direct access, there is no point
      !   performing this transposition.
      ! - If the next command needs the transposed access, we will re-
      !   prepare it from scratch. As of today leaving remnants breaks
      !   the transposition preparation.
      ! => forget the transposition preparation
      call cubeio_desc_reset(format%tuple%cube(format%tuple%trans%to)%desc,error)
      if (error)  continue
      call format%tuple%trans%reset(error)
      if (error)  continue
    endif
    !
    if (associated(format%tuple%current)) then
      ! It may not be associated e.g. in error recovery mode
      ! ZZZ Should we finish all cubes or only the current one?
      call cubeio_cube_finish(format%user,format,format%tuple%current,error)
      if (error)  return
    endif
    !
    ! The iterator is reset, so that it can not be used until next command
    call format%iter%finish(error)
    if (error)  return
    !
    ! The define type is reset, so that all requests are redefined by
    ! the next command
    call format%prog%reset(error)
    if (error)  continue
    !
    ! DAG upsertion
    call format%dag_upsert(error)
    if (error) continue
    !
    ! Execution timing
    call format%timing_collect(error)
    if (error) continue
    !
    ! Always free the GIO slot, which is a limited ressource. The other
    ! ressources are handled by the GC
    call format%close(error)
    if (error) return
  end subroutine cubetuple_format_finish_format
  !
  subroutine cubetuple_format_default_intrinsic_order(format,error)
    !-------------------------------------------------------------------
    ! Set the default intrinsic order string (e.g. "ABC") of the CURRENT
    ! cube
    !-------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    !
    call format%tuple%default_iorder(error)
    if (error)  return
  end subroutine cubetuple_format_default_intrinsic_order
  !
  subroutine cubetuple_format_set_intrinsic_order(format,iorder,error)
    !-------------------------------------------------------------------
    ! Set the intrinsic order string (e.g. "ABC") of the CURRENT cube
    !-------------------------------------------------------------------
    class(format_t),  intent(inout) :: format
    character(len=*), intent(in)    :: iorder
    logical,          intent(inout) :: error
    !
    call format%tuple%set_iorder(iorder,error)
    if (error)  return
  end subroutine cubetuple_format_set_intrinsic_order
  !
  function cubetuple_format_get_intrinsic_order(format)
    !-------------------------------------------------------------------
    ! Return the intrinsic order string (e.g. "ABC") of the CURRENT cube
    !-------------------------------------------------------------------
    character(len=maxdim) :: cubetuple_format_get_intrinsic_order
    class(format_t), intent(in) :: format
    cubetuple_format_get_intrinsic_order = format%tuple%iorder()
  end function cubetuple_format_get_intrinsic_order
  !
  function cubetuple_format_get_mapped_order(format)
    !-------------------------------------------------------------------
    ! Return the mapped order code (e.g. code_imaset) of the CURRENT cube
    !-------------------------------------------------------------------
    integer(kind=4) :: cubetuple_format_get_mapped_order
    class(format_t), intent(in) :: format
    cubetuple_format_get_mapped_order = format%tuple%order()
  end function cubetuple_format_get_mapped_order
  !
  function cubetuple_format_get_access(format)
    !-------------------------------------------------------------------
    ! Return the CURRENT cube access
    !-------------------------------------------------------------------
    integer(kind=code_k) :: cubetuple_format_get_access
    class(format_t), intent(in) :: format
    cubetuple_format_get_access = format%tuple%access()
  end function cubetuple_format_get_access
  !
  function cubetuple_format_get_iscplx(format)
    !-------------------------------------------------------------------
    ! Return .true. if the cube data is complex*4
    !-------------------------------------------------------------------
    logical :: cubetuple_format_get_iscplx
    class(format_t), intent(in) :: format
    cubetuple_format_get_iscplx = format%tuple%iscplx()
  end function cubetuple_format_get_iscplx
  !
  subroutine cubetuple_format_attach_file(format,file,error)
    use cubeio_file
    use cubeio_desc_setup
    !-------------------------------------------------------------------
    ! Attach the pre-loaded cubeio_file_t and compute the associated
    ! header_t
    !-------------------------------------------------------------------
    class(format_t),     intent(inout)       :: format
    type(cubeio_file_t), intent(in), pointer :: file
    logical,             intent(inout)       :: error
    !
    call format%tuple%attach_file(file,error)
    if (error)  return
    ! Propagate the header of this data type to interface_t, header_t, iodesc_t
    call cubeio_set_descriptor_intrinsic(format,format%tuple%current,error)
    if (error)  return
  end subroutine cubetuple_format_attach_file
  !
  subroutine cubetuple_format_dag_upsert(format,error)
    use cubedag_tuple
    !-------------------------------------------------------------------
    ! Upsert the format in DAG
    !-------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    ! Local
    integer(kind=code_k) :: code_where
    integer(kind=4) :: hdu
    character(len=file_l) :: where
    !
    if (.not.associated(format%tuple%current) .or. &
        format%iorder().eq.'') then
      ! This can happen in error recovery mode
      return
    endif
    !
    if (format%tuple%trans%do.ne.code_trans_none) then
      ! This can happen if a transposition was prepared at get_header
      ! time, but was not actually performed because no data was
      ! actually accessed (get_image/get_spectrum).
      ! => no upsertion in the DAG as the data is not ready
      return
    endif
    !
    if (format%tuple%current%desc%buffered.eq.code_buffer_memory) then
      code_where = code_buffer_memory
      ! where = '<memory>'  ignored
      ! hdu = 0             ignored
    else
      code_where = code_buffer_disk
      where = format%tuple%current%file%name
      hdu = format%tuple%current%file%hdu
    endif
    call cubedag_tuple_upsert(format%node%tuple,  &
                              format%iorder(),  &
                              format%order(), &
                              code_where,  &
                              where,hdu,error)
    if (error)  return
    !
  end subroutine cubetuple_format_dag_upsert
  !
  subroutine cubetuple_format_timing_collect(format,error)
    use cubeadm_timing
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(format_t), intent(in)    :: format
    logical,         intent(inout) :: error
    !
    call cubeadm_timing_collect(format%tuple%elapsed_read(), &
                                format%tuple%elapsed_write(), &
                                format%tuple%elapsed_trans())
  end subroutine cubetuple_format_timing_collect
  !
  subroutine cubetuple_format_default_region(format,error,align)
    !-------------------------------------------------------------------
    ! 1) Declare the original axes of this cube to its iterator, i.e.
    !    the leading ones and the iterated one.
    ! 2) Declare that the region to be applied on the cube is the default
    !    one. In practice this means that the data access will use 100%
    !    of the cube (not more, not less), i.e. 100% of the axes.
    ! See also cuberegion_prog_t%apply_to_cube() if a region is to be
    ! applied.
    !-------------------------------------------------------------------
    class(format_t),      intent(inout)        :: format
    logical,              intent(inout)        :: error
    integer(kind=code_k), intent(in), optional :: align
    !
    integer(kind=code_k) :: lalign,order
    integer(kind=indx_k), parameter :: auto=code_indx_auto
    character(len=*), parameter :: rname='FORMAT>DEFAULT>REGION'
    !
    if (present(align)) then
      lalign = align
    else
      lalign = code_align_auto
    endif
    !
    ! Rely on internal data order (cub is already the cube with desired
    ! order), not the way we access it (e.g. by subcube):
    order = format%order()
    !
    ! Fetch this cube axes
    call format%iter%get_axes(format%head,order,lalign,error)
    if (error)  return
    !
    call format%iter%set_region_l(auto,auto,auto,error)
    if (error)  return
    call format%iter%set_region_m(auto,auto,auto,error)
    if (error)  return
    call format%iter%set_region_c(auto,auto,auto,error)
    if (error)  return
  end subroutine cubetuple_format_default_region
  !
  subroutine cubetuple_format_autotranspose(format,error)
    use cubedag_tuple
    use cubeio_cube
    use cubeio_transpose
    !-------------------------------------------------------------------
    ! If needed, perform the pending tranposition of the relevant file
    !-------------------------------------------------------------------
    class(format_t), target, intent(inout) :: format
    logical,                 intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FORMAT>AUTOTRANSPOSE'
    character(len=file_l) :: ffilename,tfilename
    type(cubeio_cube_t), pointer :: cubin,cubout
    integer(kind=code_k) :: fromorder
    logical :: insertin
    integer(kind=4) :: hdu
    character(len=maxdim) :: iorder
    !
    if (format%tuple%trans%do.eq.code_trans_none)  return
    !
    ! Reinitialize timer before real transposition processing (so that
    ! we do not take into account overheads before reaching this point)
    call gag_cputime_init(format%tuple%trans%time)
    !
    cubin  => format%tuple%cube(format%tuple%trans%from)
    cubout => format%tuple%cube(format%tuple%trans%to)
    !
    ! Sanity
    if (.not.associated(cubout,format%tuple%current)) then
      call cubetuple_message(seve%e,rname,  &
        'Internal error: the cube to be created is not the current one')
      error = .true.
      return
    endif
    !
    ! ZZZ The new implementation in cubeio_transpose is actually able to
    ! deal with any case (input in memory or disk, output in memory or disk).
    ! But such mismatch does not make much sense as the input and output
    ! have strictly the same size.
    select case (format%tuple%trans%do)
    case (code_trans_memo)
      insertin = cubin%memo%ready.ne.code_buffer_memory
      call cubeio_transpose_memory(format%user,format%prog,format,cubin,cubout,error)
      if (error)  return
      !
      if (insertin) then
        ! Avoid reinserting the direct cube and changing its timestamp if it
        ! was already in memory
        call cubedag_tuple_upsert(format%node%tuple,cubin%iorder(),cubin%order(),  &
          code_buffer_memory,'<memory>',0,error)
        if (error)  return
      endif
      ! The transposed cube is now in memory
      call cubedag_tuple_upsert(format%node%tuple,cubout%iorder(),cubout%order(),  &
        code_buffer_memory,'<memory>',0,error)
      if (error)  return
      !
    case (code_trans_disk)
      ! Sanity
      if (cubout%desc%action.ne.code_read) then
        call cubetuple_message(seve%e,rname,'Internal error: implicit '//  &
          'transposition is relevant only for cubes opened in read mode')
        error = .true.
        return
      endif
      fromorder = format%tuple%cube(format%tuple%trans%from)%order()
      if (.not.cubedag_tuple_hasuptodatefile(format%node%tuple,fromorder,code_buffer_disk, &
        iorder,ffilename,hdu)) then
        call cubetuple_message(seve%e,rname,'Internal error: lost the file I am looking for')
        error = .true.
        return
      endif
      if (error)  return
      !
      tfilename = cubout%file%name
      call cubeio_transpose_disk(format%user,format%prog,ffilename,hdu,tfilename,  &
        format,cubin,cubout,error)
      if (error)  return
      !
      ! Insert this new/updated file in the tuple, and set the tuple as
      ! consistent at this precise moment
      call cubedag_tuple_upsert(format%node%tuple,cubout%iorder(),cubout%order(), &
        code_buffer_disk,tfilename,1,error)
      if (error)  return
      call cubedag_tuple_setconsistent(format%node%tuple,error)
      if (error)  return
      !
    case default
      call cubetuple_message(seve%e,rname,'Transposition mode not implemented')
      error = .true.
      return
    end select
    !
    ! Transposition is now done
    call format%tuple%trans%reset(error)
    if (error)  return
    !
    call gag_cputime_get(format%tuple%trans%time)
  end subroutine cubetuple_format_autotranspose
  !
  subroutine cubetuple_format_final_format(format,error)
    use cubetools_header_types
    !---------------------------------------------------------------------
    ! Finalize a 'format_t' instance, i.e. free all its components before
    ! deleting the object itself
    !---------------------------------------------------------------------
    class(format_t), intent(inout) :: format
    logical,         intent(inout) :: error
    !
    call cubetools_header_final(format%head,error)
    if (error)  continue
    ! call cubetuple_final(format%tuple) => implicit at finalization time
  end subroutine cubetuple_format_final_format
  !
  function cubetuple_format_ptr(dno,error)
    !-------------------------------------------------------------------
    ! Check if the input class is a 'format_t', and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    class(format_t), pointer :: cubetuple_format_ptr  ! Function value on return
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='FORMAT>PTR'
    !
    select type(dno)
    class is (format_t)
      cubetuple_format_ptr => dno
    class default
      cubetuple_format_ptr => null()
      call cubetuple_message(seve%e,rname,'Internal error: object is not a format_t')
      error = .true.
      return
    end select
  end function cubetuple_format_ptr
  !
end module cubetuple_format_class
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine header_ra
  !---------------------------------------------------------------------
  ! POINTING
  !	Read CLASS ANALYSE\PRINT POINTING output files
  !---------------------------------------------------------------------
  character(len=80) :: chain
  !
  ! Skip header lines (4)
  read(2,*)
  read(2,*)
  read(2,*)
  read(2,'(A)') chain
end
!<FF>
subroutine header_op
  !---------------------------------------------------------------------
  ! POINTING
  !	Read optical data files.
  !---------------------------------------------------------------------
  ! Global
  integer :: lenc
  ! Local
  character(len=80) :: chain
  character(len=3) :: station(4)
  integer :: i,iant
  !
  read(2,'(A)') chain          ! Antenna and Station
  call sic_upper (chain)
  !
  ! Single-dish format
  write(6,*) 'I-POINTING,  Reading optical data file'
  if (index(chain,'ANT').ne.0) then
    write(6,'(1x,a,a)') 'I-POINTING,  Found single antenna data '   &
     &      ,chain(1:lenc(chain))
  else
    write(6,'(1x,a,a)') 'I-POINTING,  Found multi-antenna data '   &
     &      ,chain(1:lenc(chain))
    read(2,*)                  ! Plateau de Bure coordinates
    do i=1,4
      read(2,'(A)') chain
      station(i) = chain(12:14)
      read(2,*)                ! IAZ IEL
      read(2,*)                ! etc...
      read(2,*)                ! etc...
      read(2,*)                ! etc...
    enddo
    iant = 0
    do i=1,4
      if (station(i).ne.'0  ') then
        iant = iant+1
      endif
    enddo
    if (iant.eq.0) then
      write(6,*) 'E-POINTING,  No antenna on station'
    else
      do i=1,4
        if (station(i).ne.'0  ') then
          write(6,'(1X,A,I1,A,A)') 'I-POINTING,  Antenna ',   &
     &            i,' on station ',station(i)
        endif
      enddo
    endif
  endif
end
!<FF>
subroutine header_in
  !---------------------------------------------------------------------
  ! POINTING
  !	Read CLIC SOLVE POINTING /OUTPUT output files
  !---------------------------------------------------------------------
end

subroutine sicsay (line,nline,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sicsay
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command SAY
  !   SAY 'Expression' "String" 'Character_variable' ...
  ! 1 [/FORMAT  a10 i2 f5.2 ...]
  ! 2 [/NOADVANCE]
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  integer                         :: nline  !
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='SAY'
  ! Note: ARGUM must have at least a length equal to TEXTLENGTH parameter
  ! in 'gwidget.h' .
  character(len=1024) :: argum,chain,string
  integer :: nleft,nchara,nfirst,nremain,iarg,narg,curwidth,lstring,outlun
  integer(kind=address_length) :: ia,ja
  character(len=message_length) :: mess
  logical :: noadvance
  integer(kind=4), parameter :: optformat=1
  integer(kind=4), parameter :: optnoadvance=2
  !
  if (siclun.eq.0) then
    curwidth = sic_ttyncol()
  else
    curwidth = len(chain)
  endif
  !
  noadvance = sic_present(optnoadvance,0)
  !
  ! /FORMAT Option
  if (sic_present(optformat,0)) then
    if (lxwindow) then
      outlun = 0
    else if (siclun.ne.0) then
      outlun = siclun
    else
      outlun = 6  ! stdout
    endif
    narg = sic_narg(0)
    nfirst = 1
    do iarg=1,narg
      ! Concatenate the formatted arguments in a single string
      call say_format_arg(line,iarg,iarg,outlun,string,lstring,error)
      if (error) return
      !
      if (outlun.eq.0) then
        argum(nfirst:) = string(:lstring)
        nfirst = nfirst+lstring
      endif
    enddo
    !
    ! Check for widget creation
    if (lxwindow) then
      if (nfirst.eq.1) then
        call xgag_separator (noptscr)
      else
        ia = locstr(argum)
        ja = bytpnt(ia,membyt)
        call xgag_show (membyt(ja),nfirst-1,noptscr)
      endif
    else if (noadvance) then
      continue
    else
      write(outlun,'(A)') ''  ! Simple carriage return
    endif
  else
    !
    ! Automatic format
    if (lxwindow) then
      curwidth = len(chain)
    endif
    nleft = curwidth           ! Pas 0
    nfirst = 0
    narg = sic_narg(0)
    do iarg=1,narg
      call sic_ch (line,0,iarg,argum,nchara,.true.,error)
      if (error) then
        write(mess,'(A,I0)')  'Could not read argument #',iarg
        call sic_message(seve%e,rname,mess)
        return
      endif
      if (nchara.le.nleft) then
        chain (nfirst+1:) = argum(1:nchara)
        nleft = nleft-nchara-1
        nfirst = nfirst+nchara+1
      else
        if (nfirst.gt.0) then
          if (siclun.ne.0) then
            write(siclun,101) chain(1:nfirst-1)  ! Drop last blank
          else
            write(6,100) chain(1:nfirst-1)  ! Drop last blank
          endif
        endif
        nfirst = 0
        nremain = nchara
        do while (nfirst.lt.nchara)
          if (nremain.le.curwidth) then
            chain = argum(nfirst+1:nchara)
            nleft = curwidth-nremain-1
            nfirst = nchara+2
          else
            !
            if (lxwindow) then
              argum(nfirst+curwidth+1:nfirst+curwidth+1) = char(0)
              ia = locstr(argum)
              ja = bytpnt(ia,membyt)+nfirst
              call xgag_show (membyt(ja),curwidth,noptscr)
            else
              if (siclun.ne.0) then
                write(siclun,101) argum(nfirst+1:nfirst+curwidth)
              else
                write(6,100) argum(nfirst+1:nfirst+curwidth)
              endif
              nfirst = nfirst+curwidth
              nremain = nremain-curwidth
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Check for widget creation
    if (nfirst.gt.0) then
      if (lxwindow) then
        nfirst = len_trim(argum)
        if (nfirst.gt.0) then
          nfirst = nfirst+1
          argum(nfirst:nfirst) = char(0)
          ia = locstr(argum)
          ja = bytpnt(ia,membyt)
          call xgag_show (membyt(ja),nfirst,noptscr)
        else
          call xgag_separator(noptscr)
        endif
      else
        if (siclun.ne.0) then
          write(siclun,101) chain(1:nfirst-1)  ! Drop last blank
        else
          write(6,100) chain(1:nfirst-1)  ! Drop last blank
        endif
      endif
    elseif (lxwindow) then
      call xgag_separator(noptscr)
    endif
  endif
  !
100 format(20(a))
101 format(a)
end subroutine sicsay
!
subroutine sicmsg(line)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sicmsg
  use sic_interactions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  ! Local
  integer :: nl,nt,n1,tt_width
  !
  if (sic_quiet) return
  !
  tt_width = sic_ttyncol()
  nl = len_trim(line)
  n1 = 1
  nt = nl
  do while (n1.le.nl)
    if (nt.le.tt_width) then
      write(6,100) line(n1:nl)
      return
    else
      write(6,100) line(n1:n1+tt_width-1)
      n1 = n1+tt_width
      nt = nt-tt_width
    endif
  enddo
  !
100 format(20(a))
end subroutine sicmsg
!
subroutine say_format_arg(line,iarg,iform,outlun,fmtd_string,lstring,error)
  use sic_dependencies_interfaces
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_interfaces, except_this=>say_format_arg
  use sic_types
  !---------------------------------------------------------------------
  ! @private
  ! From input line, format the iarg-th argument of the command
  ! according to the iform-th format of the option /FORMAT. Formatted
  ! string is returned in fmtd_string, and its usefull length is lstring.
  ! Warnings!
  !  1) /FORMAT option must be the 1st option of the calling command
  !  2) In return, fmtd_string(1:lstring) != fmtd_string
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line         ! Line to analyze
  integer,          intent(in)    :: iarg         ! The arg number to analyze
  integer,          intent(in)    :: iform        ! The format number to be used
  integer,          intent(in)    :: outlun       ! Logical unit to write to (if > 0)
  character(len=*), intent(out)   :: fmtd_string  ! Output string (if outlun == 0)
  integer,          intent(out)   :: lstring      ! Output string usefull length
  logical,          intent(inout) :: error        ! Error status
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='/FORMAT'
  character(len=64) :: forma
  integer(kind=4) :: lforma
  integer(kind=size_length) :: nelem
  integer(kind=address_length) :: ia
  type(sic_descriptor_t) :: inca
  logical :: advance
  character(len=message_length) :: mess
  !
  fmtd_string = ''
  lstring = 0
  !
  call say_getformat(line,iform,forma,lforma,error)
  if (error)  return
  !
  call say_incarnate_arg(line,iarg,forma(1:lforma),inca,error)
  if (error)  return
  !
  nelem = desc_nelem(inca)
  if (inca%type.ge.0) then  ! Character strings
    ! NB: inca%type should be strictly > 0 (chain length), as usually we
    ! can not define empty chains in SIC. But the syntax
    !   SAY 'empty' /FORMAT A  (where "empty" is a fully blank character variable)
    ! creates a zero-length incarnation. Tolerate this possibility, and print as
    ! result a zero-length string. Note that there is no risk of confusion with
    ! headers (type.eq.0) as this is rejected by say_incarnate_arg when it
    ! encounters such a variable.
    advance = .false.  ! Advance only if one item ?
    call say_array_ch(inca%addr,inca%type,nelem,forma(1:lforma),outlun,fmtd_string,advance,error)
  else  ! Numerics
    ia = gag_pointer(inca%addr,memory)
    select case (inca%type)
    case (fmt_r4)
      call say_array_r4(memory(ia),nelem,forma(1:lforma),outlun,fmtd_string,error)
    case (fmt_r8)
      call say_array_r8(memory(ia),nelem,forma(1:lforma),outlun,fmtd_string,error)
    case (fmt_i4)
      call say_array_i4(memory(ia),nelem,forma(1:lforma),outlun,fmtd_string,error)
    case (fmt_i8)
      call say_array_i8(memory(ia),nelem,forma(1:lforma),outlun,fmtd_string,error)
    case (fmt_l)
      call say_array_l4(memory(ia),nelem,forma(1:lforma),outlun,fmtd_string,error)
    case default
      call sic_message(seve%e,rname,'Unsupported data type')
      error = .true.
    end select
  endif
  call sic_volatile(inca)
  !
  if (error) then
    write(mess,'(3A,I0)')  'Error applying format ',forma(1:lforma),' on argument #',iarg
    call sic_message(seve%e,rname,mess)
    return
  endif
  !
  if (outlun.eq.0) then
    ! Drop the last "?"
    lstring = len_trim(fmtd_string)
    if (fmtd_string(lstring:lstring).eq.'?') lstring = lstring-1
  endif
  !
end subroutine say_format_arg
!
subroutine say_getformat(line,iform,forma,lforma,error)
  !---------------------------------------------------------------------
  ! @ private
  ! Retrieve the format from the command line, and format it to make
  ! it applicable on arrays.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iform
  character(len=*), intent(out)   :: forma
  integer(kind=4),  intent(out)   :: lforma
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4), parameter :: optformat=1
  logical :: add_repeat
  integer(kind=4) :: ic
  !
  ! Get the desired format
  call sic_ke(line,optformat,iform,forma,lforma,.true.,error)
  if (error) return
  !
  ! Strip off parentheses if any
  if (forma(1:1).eq.'('  .and. forma(lforma:lforma).eq.')') then
    forma = forma(2:lforma-1)
    lforma = lforma-2
  endif
  !
  ! Check if a repetition is to be added
  if (forma(1:lforma).eq.'*') then
    add_repeat = .false.
  else
    ! Test if format already includes a repetition or not
    ic = ichar(forma(1:1))-ichar('0')
    if (ic.gt.0.and.ic.le.9) then  ! Starts with a numeric
      ! Ignore shifting factors > 9, just test if next character is a shifting code
      add_repeat = forma(2:2).eq.'P'
    else  ! Does not start with a numeric
      add_repeat = .true.
    endif
  endif
  !
  if (add_repeat) then
    ! Repeat it as so-called "unlimited format" to avoid error when
    ! applying a scalar format on an array:
    forma = '*('//forma(1:lforma)//')'
    lforma = lforma+3
  endif
  !
  ! Add parentheses
  forma = '('//forma(1:lforma)//')'
  lforma = lforma+2
  !
end subroutine say_getformat
!
subroutine say_incarnate_arg(line,iarg,forma,inca,error)
  use gbl_message
  use sic_interfaces, except_this=>say_incarnate_arg
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Fetch an incarnation of the argument, according to the type
  ! requested by the format
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: line
  integer(kind=4),        intent(in)    :: iarg
  character(len=*),       intent(in)    :: forma
  type(sic_descriptor_t), intent(out)   :: inca
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SAY'
  logical :: dostring,dointe,dologi,doreal,donative
  type(sic_descriptor_t) :: adesc
  logical :: found
  character(len=argument_length) :: arg
  integer(kind=4) :: larg
  ! Arguments
  logical :: l4
  real(kind=8) :: r8
  integer(kind=8) :: i8
  character(len=argument_length) :: expr
  integer(kind=4) :: lexpr
  !
  dostring = scan(forma,'A').ne.0
  dointe   = scan(forma,'I').ne.0
  dologi   = scan(forma,'L').ne.0
  doreal   = scan(forma,'EFGS').ne.0
  ! Support for * format (but avoid ambiguity with e.g. (*(I3)) )
  donative = .not.dostring .and. .not.dointe  .and. .not.dologi  .and. .not.doreal
  !
  ! Get the argument (as string). Can not use sic_ch as it does not
  ! distinguish variable pi vs string "pi" (i.e. with double-quotes or not).
  larg = sic_len(0,iarg)
  arg = line(sic_start(0,iarg):sic_end(0,iarg))
  !
  ! Try a variable. Materialize possible non-contiguous subset
  found = .false.  ! Not verbose
  call sic_materialize(arg(1:larg),adesc,found)
  !
  if (found) then
    ! Incarnate an existing variable to proper type
    if (donative) then
      call copy_descr(adesc,inca,error)
      if (error)  goto 10
    elseif (dostring) then
      if (adesc%type.gt.0) then
        call copy_descr(adesc,inca,error)
        if (error)  goto 10
      else
        call sic_message(seve%e,rname,'Can not print a non-character variable with format A')
        error = .true.
        goto 10
      endif
    elseif (dointe) then
      call sic_incarnate_desc(fmt_i8,adesc,inca,error)
      if (error)  goto 10
    elseif (dologi) then
      if (adesc%type.eq.fmt_l) then
        call copy_descr(adesc,inca,error)
        if (error)  goto 10
      else
        ! This could be implemented in sic_incarnate_desc, following
        ! Fortran standard rules.
        call sic_message(seve%e,rname,'Can not print a non-logical variable with format L')
        error = .true.
        goto 10
      endif
    else
      call sic_incarnate_desc(fmt_r8,adesc,inca,error)
      if (error)  goto 10
    endif
    !
  else
    ! Incarnate the argument under proper type
    if (dostring.or.donative) then
      call sic_ch(line,0,iarg,expr,lexpr,.true.,error)
      if (error)  goto 10
      call sic_incarnate(expr(1:lexpr),inca,error)
      if (error)  goto 10
    elseif (dointe) then
      call sic_i8(line,0,iarg,i8,.true.,error)
      if (error)  goto 10
      call sic_incarnate(i8,inca,error)
      if (error)  goto 10
    elseif (dologi) then
      call sic_l4(line,0,iarg,l4,.true.,error)
      if (error)  goto 10
      call sic_incarnate(l4,inca,error)
      if (error)  goto 10
    else
      call sic_r8(line,0,iarg,r8,.true.,error)
      if (error)  goto 10
      call sic_incarnate(r8,inca,error)
      if (error)  goto 10
    endif
  endif
  !
10 continue
  if (sic_notsamedesc(adesc,inca))  call sic_volatile(adesc)
  !
end subroutine say_incarnate_arg
!
subroutine say_array_r4(array,na,form,lun,string,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: na         ! Length of array
  real(kind=4),              intent(in)    :: array(na)  ! Array of values
  character(len=*),          intent(in)    :: form       ! Output format
  integer(kind=4),           intent(in)    :: lun        ! Output unit
  character(len=*),          intent(out)   :: string     ! Output string (used if lun=0)
  logical,                   intent(inout) :: error      ! Error code
  ! Local
  integer(kind=4) :: ier
  !
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_r4
!
subroutine say_array_r8(array,na,form,lun,string,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: na         ! Length of array
  real(kind=8),              intent(in)    :: array(na)  ! Array of values
  character(len=*),          intent(in)    :: form       ! Output format
  integer(kind=4),           intent(in)    :: lun        ! Output unit
  character(len=*),          intent(out)   :: string     ! Output string (used if lun=0)
  logical,                   intent(inout) :: error      ! Error code
  ! Local
  integer(kind=4) :: ier
  !
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_r8
!
subroutine say_array_i4(array,na,form,lun,string,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: na         ! Length of array
  integer(kind=4),           intent(in)    :: array(na)  ! Array of values
  character(len=*),          intent(in)    :: form       ! Output format
  integer(kind=4),           intent(in)    :: lun        ! Output unit
  character(len=*),          intent(out)   :: string     ! Output string (used if lun=0)
  logical,                   intent(inout) :: error      ! Error code
  ! Local
  integer(kind=4) :: ier
  !
  ier = 0
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_i4
!
subroutine say_array_i8(array,na,form,lun,string,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: na         ! Length of array
  integer(kind=8),           intent(in)    :: array(na)  ! Array of values
  character(len=*),          intent(in)    :: form       ! Output format
  integer(kind=4),           intent(in)    :: lun        ! Output unit
  character(len=*),          intent(out)   :: string     ! Output string (used if lun=0)
  logical,                   intent(inout) :: error      ! Error code
  ! Local
  integer(kind=4) :: ier
  !
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_i8
!
subroutine say_array_l4(array,na,form,lun,string,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: na         ! Length of array
  logical,                   intent(in)    :: array(na)  ! Array of values
  character(len=*),          intent(in)    :: form       ! Output format
  integer(kind=4),           intent(in)    :: lun        ! Output unit
  character(len=*),          intent(out)   :: string     ! Output string (used if lun=0)
  logical,                   intent(inout) :: error      ! Error code
  ! Local
  integer(kind=4) :: ier
  !
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_l4
!
subroutine say_array_ch(addr,nc,na,form,lun,string,advance,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>say_array_ch
  use gildas_def
  use iso_fortran_env
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)    :: addr     ! Address of first element
  integer(kind=4),              intent(in)    :: nc       ! Full length of 1 element
  integer(kind=size_length),    intent(in)    :: na       ! Number of elements in array
  character(len=*),             intent(in)    :: form     ! Format to be used
  integer,                      intent(in)    :: lun      ! Send output to this logical unit
  character(len=*),             intent(inout) :: string   ! Output string (used if lun=0)
  logical,                      intent(in)    :: advance  ! Advancing or not ?
  logical,                      intent(inout) :: error    ! Error flag
  ! Local
  integer :: ier, i, ma
  integer(kind=size_length) :: ia
  integer(kind=address_length) :: myaddr
  character(len=:), allocatable :: array(:)
  !
  if (lun.eq.0) then
    ma = na+1
  else
    ma = na
  endif
  allocate(character(nc)::array(ma),stat=ier)
  if (failed_allocate('SAY','character array',ier,error))  return
  !
  ! Fill temporary array with proper character length and number of elements
  myaddr = addr
  do ia=1,na
    call destoc(nc,myaddr,array(ia))
    myaddr = myaddr+nc
  enddo
  if (lun.eq.0) array(ma) = '?'
  !
  if (form.ne.'(*)') then
    if (lun.eq.0) then
      write(string,form,iostat=ier) array
    else if (advance) then
      do i=1,ma
        write(lun,form,iostat=ier) array(i)
      enddo
    else
      write(lun,form,iostat=ier,advance='NO') array
    endif
  else
    ! Free format, force advance
    if (lun.eq.0) then
      write(string,*,iostat=ier) array
    else
      write(lun,*,iostat=ier) array
    endif
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY,  ',ier)
    error = .true.
  endif
end subroutine say_array_ch

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_reproject_opt
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !---------------------------------------------------------------------
  ! Support module for commands which need to call the reproject engine:
  ! they must share the same command (option 0) type (= option_t +
  ! cubeid_arg_t)
  !---------------------------------------------------------------------
  !
  public :: reproject_opt_comm_t,reproject_opt_user_t
  private
  !
  type :: reproject_opt_comm_t
    type(option_t),     pointer :: comm
    type(cubeid_arg_t), pointer :: cube
    type(cube_prod_t),  pointer :: reprojected
  contains
    procedure, public :: register => cubemain_reproject_opt_register
    procedure, public :: parse    => cubemain_reproject_opt_parse
  end type reproject_opt_comm_t
  !
  type reproject_opt_user_t
    type(cubeid_user_t) :: cubeids ! Input cube
  end type reproject_opt_user_t
  !
contains
  !
  subroutine cubemain_reproject_opt_register(comm,name,abstract,help,run, &
    ouname,ouflag,error)
    use cubedag_allflags
    use cubedag_parameters
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_opt_comm_t), intent(inout) :: comm
    character(len=*),            intent(in)    :: name      ! Command name
    character(len=*),            intent(in)    :: abstract  ! Command abstract
    character(len=*),            intent(in)    :: help      ! Command help
    external                                   :: run       !
    character(len=*),            intent(in)    :: ouname    ! Output cube qualifier
    type(flag_t),                intent(in)    :: ouflag    ! Output cube flag
    logical,                     intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='REPROJECT>OPT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         name,'[cube]',&
         abstract,&
         help,&
         run,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBE',&
         'Signal cube',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         name,&
         ouname//' cube',&
         strg_emp,&
         [ouflag,flag_cube],&
         comm%reprojected,&
         error)
    if (error) return
  end subroutine cubemain_reproject_opt_register
  !
  subroutine cubemain_reproject_opt_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_opt_comm_t), intent(in)    :: comm
    character(len=*),            intent(in)    :: line
    type(reproject_opt_user_t),  intent(out)   :: user
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>OPT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubemain_reproject_opt_parse
end module cubemain_reproject_opt
!
module cubemain_reproject
  use gbl_constant
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetools_axis_types
  use cubetools_spatial_types
  use cubetools_header_types
  use cubeadm_cubeid_types
  use cubemain_messaging
  use cubemain_auxiliary
  use cubemain_reproject_opt
  !
  public :: reproject
  public :: code_conv_none,code_conv_equ2gal,code_conv_gal2equ,code_conv_equ2equ
  public :: reproject_comm_t,reproject_user_t,reproject_prog_t
  public :: cubemain_reproject_user_toprog_find_conv
  private
  !
  ! Coordinate system conversion codes
  integer(kind=code_k), parameter :: code_conv_none    =  0
  integer(kind=code_k), parameter :: code_conv_equ2gal =  1
  integer(kind=code_k), parameter :: code_conv_gal2equ = -1
  integer(kind=code_k), parameter :: code_conv_equ2equ = -2
  type :: reproject_conv_t  ! Conversion description
    integer(kind=code_k) :: code  = code_conv_none
    real(kind=4)         :: eqin  = equinox_null  ! Input equinox, if relevant
    real(kind=4)         :: eqout = equinox_null  ! Output equinox, if relevant
  end type reproject_conv_t
  !
  type :: reproject_comm_t
     type(reproject_opt_comm_t)  :: comm   ! Command (option 0) description
     type(option_t),     pointer :: like
     type(cubeid_arg_t), pointer :: like_arg
     type(spafra_opt_t)          :: spafra
     type(spapro_type_opt_t)     :: ptype
     type(spapro_center_opt_t)   :: pcenter
     type(spapro_angle_opt_t)    :: pangle
     type(axis_opt_t)            :: laxis
     type(axis_opt_t)            :: maxis
   contains
     procedure, public  :: register => cubemain_reproject_register
     procedure, private :: parse    => cubemain_reproject_parse
     procedure, public  :: main     => cubemain_reproject_main
  end type reproject_comm_t
  type(reproject_comm_t) :: reproject
  !
  type reproject_user_t
     type(reproject_opt_user_t) :: comm    ! Command (option 0) arguments
     type(auxiliary_user_t)     :: like    ! Use another cube as reference
     type(spafra_user_t)        :: spafra  ! User Spatial frame
     type(spapro_type_user_t)   :: ptype   ! Projection type
     type(spapro_center_user_t) :: pcenter ! Projection center
     type(spapro_angle_user_t)  :: pangle  ! Projection angle
     type(axis_user_t)          :: newx    ! [sec|min|deg|rad] User l axis description
     type(axis_user_t)          :: newy    ! [sec|min|deg|rad] User m axis description
   contains
     procedure, public  :: init   => cubemain_reproject_user_init 
     procedure, private :: toprog => cubemain_reproject_user_toprog
  end type reproject_user_t
  !
  type reproject_prog_t
     type(cube_t), pointer  :: cube                  ! Input cube
     type(cube_t), pointer  :: reprojected           ! Reprojected cube
     type(cube_header_t)    :: ouhead
     type(reproject_conv_t) :: conv
     type(axis_t)           :: oldx                  ! [rad] old l axis description
     type(axis_t)           :: oldy                  ! [rad] old m axis description
     type(axis_t)           :: newx                  ! [rad] new l axis description 
     type(axis_t)           :: newy                  ! [rad] new m axis description
     real(kind=coor_k), allocatable :: xfrac(:,:)   ! [---] Fraction of input pixel in output pixel
     real(kind=coor_k), allocatable :: yfrac(:,:)   ! [---] Fraction of input pixel in output pixel
     integer(kind=pixe_k), allocatable :: ix(:,:)   ! Output pixel number in input cube
     integer(kind=pixe_k), allocatable :: iy(:,:)   ! Output pixel number in input cube
   contains
     procedure, public  :: header     => cubemain_reproject_prog_header
     procedure, public  :: precompute => cubemain_reproject_prog_precompute
     procedure, public  :: data       => cubemain_reproject_prog_data
     procedure, private :: loop       => cubemain_reproject_prog_loop
     procedure, private :: act        => cubemain_reproject_prog_act
  end type reproject_prog_t
  !
contains
  !
  subroutine cubemain_reproject_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(reproject_user_t) :: user
    character(len=*), parameter :: rname='REPROJECT>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call reproject%parse(line,user,error)
    if (error) return
    call reproject%main(user,error)
    if (error) continue
  end subroutine cubemain_reproject_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_reproject_register(comm,error)
    use cubetools_unit
    use cubedag_parameters
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%comm%register(&
         'REPROJECT',&
         'Reproject the spatial grid of a cube',&
         'Reproject the spatial axes of an input image or cube to a&
         & different projection or coordinate system.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Spatial resampling uses bilinear interpolation. For best interpolation&
         & fidelity, choose output pixel increments smaller than the input ones.'//strg_cr//&
         '- At least one target-definition option must be provided.'//strg_cr//&
         '- /SPATIALFRAME, /PTYPE, /PCENTER, /PANGLE, /LAXIS, and /MAXIS can be&
         & combined to define the output projection and coordinates.'//strg_cr//&
         '- If /LIKE is provided, all other target-definition options are ignored&
         & and output projection and coordinates are copied from the&
         & reference cube.'//strg_cr//&
         '- REPROJECT changes the spatial grid while keeping non-spatial&
         & axes unchanged.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> REPROJECT cubeA /SPATIALFRAME EQUATORIAL /PTYPE TAN'//strg_cr//&
         'CUBE> REPROJECT cubeA /LAXIS 512 256 0 1 arcsec /MAXIS 512&
         & 256 0 1 arcsec'//strg_cr//&
         'CUBE> REPROJECT cubeA /LIKE refcube'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> HEADER cubeA'//strg_cr//&
         'CUBE> REPROJECT cubeA /LIKE refcube'//strg_cr//&
         'CUBE> HEADER reprojected'//strg_cr//&
         'CUBE> CONSISTENCY refcube reprojected',&
         cubemain_reproject_command,&
         'Reprojected',flag_reproject,error)
    if (error)  return
    !
    call comm%spafra%register(&
         'Define the spatial frame of the reprojected cube',&
         error)
    if (error) return
    !
    call comm%ptype%register(&
         'PTYPE',&
         'Define the new projection type',&
         error)
    if (error) return
    call comm%pcenter%register(&
         'PCENTER',&
         'Define the new projection center',&
         error)
    if (error) return
    call comm%pangle%register(&
         'PANGLE',&
         'Define the new projection angle',&
         error)
    if (error) return
    !
    call comm%laxis%register(&
         code_unit_fov,&
         'LAXIS',&
         'Define the l axis of the reprojected cube',&
         error)
    if (error) return
    call comm%maxis%register(&
         code_unit_fov,&
         'MAXIS',&
         'Define the m axis of the reprojected cube',&
         error)
    if (error) return
    !
    call cubemain_auxiliary_register(&
         'LIKE',&
         'Reproject onto the same grid as a reference cube',&
         strg_emp,&
         comm%like,&
         'Reference cube',&
         [flag_cube],&
         code_arg_mandatory, &
         code_access_imaset, &
         comm%like_arg, &
         error)
    if (error) return
  end subroutine cubemain_reproject_register
  !
  subroutine cubemain_reproject_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! REPROJECT [cubeid]
    ! /SPATIALFRAME name [equinox]
    ! /PTYPE type
    ! /PCENTER l0 m0 relative|absolute [unit]
    ! /PANGLE  pang [pangunit]
    ! /LAXIS n ref val inc [unit]
    ! /MAXIS n ref val inc [unit]
    ! /LIKE refcube
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(in)    :: comm
    character(len=*),        intent(in)    :: line
    type(reproject_user_t),  intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%init(error)
    if (error) return
    call comm%comm%parse(line,user%comm,error)
    if (error)  return
    call cubemain_auxiliary_parse(line,comm%like,user%like,error)
    if (error) return
    call comm%ptype%parse(line,user%ptype,error)
    if (error) return
    call comm%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call comm%pangle%parse(line,user%pangle,error)
    if (error) return
    call comm%spafra%parse(line,user%spafra,error)
    if (error) return
    call comm%laxis%parse(line,user%newx,error)
    if (error) return
    call comm%maxis%parse(line,user%newy,error)
    if (error) return
  end subroutine cubemain_reproject_parse
  !
  subroutine cubemain_reproject_main(comm,user,error)
    use cubetools_header_types
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_comm_t), intent(in)    :: comm
    type(reproject_user_t),  intent(in)    :: user
    logical,                 intent(inout) :: error
    !
    type(reproject_prog_t) :: prog
    character(len=*), parameter :: rname='REPROJECT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) goto 10
    call prog%header(comm,error)
    if (error) goto 10
    call cubeadm_timing_prepro2process()
    call prog%data(prog%cube,prog%reprojected,error)
    if (error) goto 10
    call cubeadm_timing_process2postpro()
10  call cubetools_header_final(prog%ouhead,error)
  end subroutine cubemain_reproject_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_reproject_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize at strg_star things that are should be kept as default in
    ! the case of the rotate command
    !----------------------------------------------------------------------
    class(reproject_user_t), intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>USER>INIT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    user%newx%n    = strg_star
    user%newx%ref  = strg_star
    user%newx%val  = strg_star
    user%newx%inc  = strg_star
    user%newx%unit = strg_star
    user%newy%n    = strg_star
    user%newy%ref  = strg_star
    user%newy%val  = strg_star
    user%newy%inc  = strg_star
    user%newy%unit = strg_star
  end subroutine cubemain_reproject_user_init
  !
  subroutine cubemain_reproject_user_toprog(user,reproject,prog,error)
    use cubetools_header_types
    use cubetools_header_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_user_t), intent(in)    :: user
    type(reproject_comm_t),  intent(in)    :: reproject
    type(reproject_prog_t),  intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    type(cube_t), pointer :: refcube
    character(len=*), parameter :: rname='REPROJECT>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(reproject%comm%cube,user%comm%cubeids,prog%cube,error)
    if (error) return
    call cubetools_header_copy(prog%cube%head,prog%ouhead,error)
    if (error) return
    !
    ! Get input cube axes description in the prog%oldx and prog%oldy description
    call cubetools_header_get_axis_head_l(prog%cube%head,prog%oldx,error)
    if (error) return
    call cubetools_header_get_axis_head_m(prog%cube%head,prog%oldy,error)
    if (error) return
    !
    if (user%like%do) then
       ! Simple case => The grid is completly defined by the reference cube
       call cubemain_auxiliary_user2prog(reproject%like_arg,user%like,refcube,error)
       if (error) return
       call cubetools_header_spatial_like(refcube%head,prog%ouhead,error)
       if (error) return
       call cubemain_reproject_user_toprog_find_conv(&
            prog%cube%head%spa%fra,&
            prog%ouhead%spa%fra,&
            prog%conv,error)
       if (error) return
       !
       call cubetools_header_get_axis_head_l(prog%ouhead,prog%newx,error)
       if (error) return
       call cubetools_header_get_axis_head_m(prog%ouhead,prog%newy,error)
       if (error) return
    else      
       ! Complex case => We may need clear default when the user does not define everything
       ! First: User2prog user inputs
       call cubetools_header_get_axis_head_l(prog%ouhead,prog%newx,error)
       if (error) return
       call cubetools_header_get_axis_head_m(prog%ouhead,prog%newy,error)
       if (error) return
       call reproject%spafra%user2prog(user%spafra,prog%ouhead%spa%fra,error)
       if (error) return
       call reproject%ptype%user2prog(user%ptype,prog%ouhead%spa%pro,error)
       if (error) return
       call reproject%pcenter%user2prog(prog%ouhead%spa%fra,user%pcenter,prog%ouhead%spa%pro,error)
       if (error) return
       call reproject%pangle%user2prog(user%pangle,prog%ouhead%spa%pro,error)
       if (error) return
       !
       ! Second: Change of referential
       call cubemain_reproject_user_toprog_find_conv(&
            prog%cube%head%spa%fra,&
            prog%ouhead%spa%fra,&
            prog%conv,error)
       if (error) return
       call cubemain_reproject_user_toprog_center(prog%conv,prog%cube%head%spa,prog%ouhead%spa,error)
       if (error) return
       ! Third: Axis redefinition
       call cubemain_reproject_user_toprog_find_grid(user%newx,user%newy,prog,error)
       if (error) return
    endif
  end subroutine cubemain_reproject_user_toprog
  !
  subroutine cubemain_reproject_user_toprog_center(conv,old,new,error)
    use gkernel_interfaces
    use cubetools_spatial_types
    !----------------------------------------------------------------------
    ! Update projection center according to new spatial frame
    !----------------------------------------------------------------------
    type(reproject_conv_t), intent(in)    :: conv
    type(spatial_t),        intent(in)    :: old
    type(spatial_t),        intent(inout) :: new
    logical,                intent(inout) :: error
    !
    character(len=fram_l) :: frame
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>CENTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (conv%code.eq.code_conv_none) return
    ! If The user has given explicit l0 and m0 no need to compute
    ! coordinates in new spatial frame, user can change just l0 or
    ! just m0.
    if ((new%pro%l0.ne.old%pro%l0).or.(new%pro%m0.ne.old%pro%m0)) return
    !
    if (conv%code.eq.code_conv_equ2gal) then
       call equ_gal(old%pro%l0,old%pro%m0,conv%eqin,  &
                    new%pro%l0,new%pro%m0,            &
                    error)
       if (error) return
    else if (conv%code.eq.code_conv_gal2equ) then
       call gal_equ(old%pro%l0,old%pro%m0,             &
                    new%pro%l0,new%pro%m0,conv%eqout,  &
                    error)
       if (error) return
    else if (conv%code.eq.code_conv_equ2equ) then
       call equ_equ(old%pro%l0,old%pro%m0,conv%eqin,  &
                    new%pro%l0,new%pro%m0,conv%eqout, &
                    error)
       if (error) return
    else
       call cubemain_message(seve%e,rname,'Unrecognized conversion code: '//trim(frame))
       error = .true.
       return
    endif
  end subroutine cubemain_reproject_user_toprog_center
  !
  subroutine cubemain_reproject_user_toprog_find_conv(oldframe,newframe,&
       conv,error)
    use cubetools_header_interface
    use cubetools_spafra_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(spafra_t),         intent(in)    :: oldframe
    type(spafra_t),         intent(in)    :: newframe
    type(reproject_conv_t), intent(out)   :: conv
    logical,                intent(inout) :: error
    !
    logical :: converror,convicrs
    character(len=fram_l) :: newname, oldname
    real(kind=4), parameter :: eqicrs=2000.0  ! ICRS equinox when approximated to Equatorial
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>CONV'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    converror = .false.
    convicrs = .false.
    select case (newframe%code)
    case (code_spaframe_icrs)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          conv%code = code_conv_equ2equ
          convicrs = .true.
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_gal2equ
          convicrs = .true.
       elseif (oldframe%code.eq.code_spaframe_icrs) then
          conv%code = code_conv_none
       else
          converror = .true.
       endif
    case (code_spaframe_galactic)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          conv%code = code_conv_equ2gal
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_none
       else if (oldframe%code.eq.code_spaframe_icrs) then
          conv%code = code_conv_equ2gal
          convicrs = .true.
       else
          converror = .true.
       endif
    case (code_spaframe_equatorial)
       if (oldframe%code.eq.code_spaframe_equatorial) then
          if (oldframe%equinox.ne.newframe%equinox) then
             ! Both Equatorial, but different equinox
             call cubemain_message(seve%i,rname,'Converting from equinox '//&
                  trim(equinox_name(oldframe%equinox))//  &
                  ' to '//trim(equinox_name(newframe%equinox)))
             conv%code = code_conv_equ2equ
          else
             ! Both Equatorial, same equinox
             conv%code = code_conv_none
          endif
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          conv%code = code_conv_gal2equ
       else if (oldframe%code.eq.code_spaframe_icrs) then
          if (newframe%equinox.ne.eqicrs) then
             ! From ICRS to Equatorial but improper equinox
             call cubemain_message(seve%i,rname,'Converting from equinox '//&
                  trim(equinox_name(eqicrs))//  &
                  ' to '//trim(equinox_name(newframe%equinox)))
             conv%code = code_conv_equ2equ
          else
             ! From ICRS to EQ 2000: no conversion
             conv%code = code_conv_none
          endif
          convicrs = .true.
       else
          converror = .true.
       endif
    case (code_spaframe_unknown)
       if (oldframe%code.eq.code_spaframe_icrs) then
          converror = .true.
       elseif (oldframe%code.eq.code_spaframe_galactic) then
          converror = .true.
       elseif (oldframe%code.eq.code_spaframe_equatorial) then
          converror = .true.
       else
          conv%code = code_conv_none
       endif
    case default
       call cubemain_message(seve%w,rname,'Unknown spatial frame code, no conversion applied')
       conv%code = code_conv_none
    end select
    !
    if (converror) then
       call cubetools_convert_code2spaframe(oldframe%code,oldname,error)
       if (error) return
       call cubetools_convert_code2spaframe(newframe%code,newname,error)
       if (error) return
       call cubemain_message(seve%e,rname,'Cannot convert from '//oldname//' to '//newname)
       error = .true.
       return
    endif
    !
    ! Set up the from/to equinoxes
    if (oldframe%code.eq.code_spaframe_equatorial)  conv%eqin  = oldframe%equinox
    if (newframe%code.eq.code_spaframe_equatorial)  conv%eqout = newframe%equinox
    if (convicrs) then
      call cubemain_message(seve%w,rname,  &
        'Approximating ICRS system to equatorial '//equinox_name(eqicrs))
      if (oldframe%code.eq.code_spaframe_icrs)  conv%eqin  = eqicrs
      if (newframe%code.eq.code_spaframe_icrs)  conv%eqout = eqicrs
    endif
    !
  contains
    function equinox_name(equinox)
      real(kind=4), intent(in) :: equinox
      character(len=10) :: equinox_name
      !
      if (equinox.eq.equinox_null) then
         equinox_name = 'Unknown'
      else
         write(equinox_name,'(F0.2)') equinox
      endif
    end function equinox_name
  end subroutine cubemain_reproject_user_toprog_find_conv
  !
  subroutine cubemain_reproject_user_toprog_find_grid(newx,newy,prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    use cubetools_header_methods
    use cubetools_header_interface
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    ! Compute n, inc, and ref for X and Y reprojected axes.  The X and Y
    ! val are left unmodified. val.eq.0 means aligned on projection center.
    ! 
    ! *** JP should we use float or dble in this routine?
    !----------------------------------------------------------------------
    type(axis_user_t),      intent(in)    :: newx
    type(axis_user_t),      intent(in)    :: newy
    type(reproject_prog_t), intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    integer(kind=8), parameter :: one=1
    !
    logical :: warn,doxinc,doyinc,findgrid,doxref,doyref,doxn,doyn
    ! VVV has to be integer 4 for interface reasons...
    integer(kind=4) :: ier,ndp
    integer(kind=pixe_k) :: ix,iy,smartn
    real(kind=coor_k), allocatable :: dxd(:),indxd(:),oudxd(:)
    real(kind=coor_k), allocatable :: dyd(:),indyd(:),oudyd(:)
    real(kind=coor_k) :: sizex,sizey,ratio
    real(kind=coor_k) :: dxmin,dxmax
    real(kind=coor_k) :: dymin,dymax,boundary
    type(projection_t) :: proj
    type(unit_user_t) :: xunit, yunit
    real(kind=coor_k) :: default
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>GRID'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    doxn   = newx%n.eq.strg_star
    doyn   = newy%n.eq.strg_star
    doxref = newx%ref.eq.strg_star
    doyref = newy%ref.eq.strg_star
    doxinc = newx%inc.eq.strg_star
    doyinc = newy%inc.eq.strg_star
    findgrid = doxinc.or.doyinc.or.doxref.or.doyref.or.doxn.or.doyn
    if (.not.findgrid) return
    !
    ! Allocation of work arrays
    allocate(dxd(prog%oldx%n*prog%oldy%n),dyd(prog%oldx%n*prog%oldy%n), stat=ier)
    if (failed_allocate(rname,'work arrays',ier,error)) return
    !
    ! Convert input projection to absolute coordinates
    call prog%cube%head%spa%pro%gwcs(proj,error)
    if (error) return
    ! Load data points
    ndp=0
    do iy=1,prog%oldy%n
       do ix=1,prog%oldx%n
          ndp = ndp+1
          dxd(ndp) = prog%oldx%coord(ix)
          dyd(ndp) = prog%oldy%coord(iy)
       enddo
    enddo
    !
    if (prog%conv%code.ne.code_conv_none) then
       ! Change coordinate spaframe and use new equinox
       allocate(indxd(ndp),indyd(ndp),oudxd(ndp),oudyd(ndp),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs(proj,dxd,dyd,oudxd,oudyd,ndp)
       if (prog%conv%code.eq.code_conv_equ2gal) then
          call equ_gal(oudxd,oudyd,prog%conv%eqin,  &
                       indxd,indyd,                 &
                       ndp,error)
       elseif (prog%conv%code.eq.code_conv_gal2equ) then
          call gal_equ(oudxd,oudyd,                     &
                       indxd,indyd,prog%conv%eqout,     &
                       ndp,error)
       elseif (prog%conv%code.eq.code_conv_equ2equ) then
          call equ_equ(oudxd,oudyd,prog%conv%eqin,   &
                       indxd,indyd,prog%conv%eqout,  &
                       ndp,error)
       endif
       deallocate(oudxd,oudyd)
       if (error) return
    else
       allocate(indxd(ndp),indyd(ndp),stat=ier) 
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs(proj,dxd,dyd,indxd,indyd,ndp)
    endif
    !
    ! Setup Output projection
    call prog%ouhead%spa%pro%gwcs(proj,error)
    if (error) return
    !
    ! Convert Absolute coordinates to input projection
    call abs_to_rel(proj,indxd,indyd,dxd,dyd,ndp)
    !
    dxmin = minval(dxd(1:ndp))
    dymin = minval(dyd(1:ndp))
    dxmax = maxval(dxd(1:ndp))
    dymax = maxval(dyd(1:ndp))
    !
    ! Test extreme cases of unbound projections
    if (prog%ouhead%spa%pro%code.eq.p_gnomonic) then
       boundary = 1.5d0
    elseif (prog%ouhead%spa%pro%code.eq.p_stereo) then
       boundary = 1.0d0
    endif
    if (prog%ouhead%spa%pro%code.eq.p_gnomonic .or. &
         prog%ouhead%spa%pro%code.eq.p_stereo) then
       if (dxmin.lt.-boundary) then
          warn = .true.
          dxmin = -boundary
       endif
       if (dymin.lt.-boundary) then
          warn = .true.
          dymin = -boundary
       endif
       if (dxmax.gt.boundary) then
          warn = .true.
          dxmax = boundary
       endif
       if (dymax.gt.boundary) then
          warn = .true.
          dymax = boundary
       endif
       if (warn) then
          call cubemain_message(seve%w,rname,'Output Projection is unbound')
          call cubemain_message(seve%w,rname,'Will be limited to one hemisphere')
       endif
    endif
    !
    ! Image dimension and spatial increments
    sizex = dxmax-dxmin
    sizey = dymax-dymin
    ratio = sizex/sizey
    !
    call yunit%get_from_name_for_code(newy%unit,prog%newy%kind,error)
    if (error) return
    default = 0d0
    call cubetools_user2prog_resolve_all(newy%val,yunit,default,prog%oldy%val,prog%newy%val,error)
    if (error) return
    call xunit%get_from_name_for_code(newx%unit,prog%newx%kind,error)
    if (error) return
    default = 0d0
    call cubetools_user2prog_resolve_all(newx%val,xunit,default,prog%oldx%val,prog%newx%val,error)
    if (error) return
    !
    ! If user gave number of pixels, use it
    if (doyinc) then
       smartn = nint(sqrt(dble(prog%oldx%n*prog%oldy%n)*2d0/ratio))
       call cubetools_user2prog_resolve_all(newy%n,smartn,prog%oldy%n,prog%newy%n,error)
       if (error) return
    else
       default = prog%oldy%inc
       call cubetools_user2prog_resolve_all(newy%inc,yunit,default,prog%oldy%inc,prog%newy%inc,error)
       if (error) return
       prog%newy%n = sizey/abs(prog%newy%inc)+1
    endif  
    if (doxinc) then
       smartn = nint(dble(prog%newy%n)*ratio)
       call cubetools_user2prog_resolve_all(newx%n,smartn,prog%oldx%n,prog%newx%n,error)
       if (error) return
    else
       default = prog%oldx%inc
       call cubetools_user2prog_resolve_all(newx%inc,xunit,default,prog%oldx%inc,prog%newx%inc,error)
       if (error) return
       prog%newx%n = sizex/abs(prog%newx%inc)+1
    endif
    ! Sanity check
    if (prog%newx%n.le.0.or.prog%newy%n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero sized image')
       error = .true.
       return
    endif
    ! Compute increments from dimensions if requested
    if (doxinc) prog%newx%inc = sizex/(prog%newx%n-1)
    if (doyinc) prog%newy%inc = sizey/(prog%newy%n-1)
    if (doxinc.and.doyinc) then
       ! Both Xinc and Yinc are automatic => At this stage the automatic
       ! increments may be slightly different because
       ! prog%newx%n/prog%newy%n differs slightly from sizex/sizey (nint()
       ! rounding). Equal increments are desirable. Select the one which
       ! ensures no loss of map coverage.
       if (prog%newx%inc.gt.prog%newy%inc) then
          prog%newy%inc = prog%newx%inc
       else
          prog%newx%inc = prog%newy%inc
       endif
    endif
    ! Keep input map conventions, if any
    if (doxinc .and. prog%oldx%inc.lt.0.d0) prog%newx%inc = -prog%newx%inc
    if (doyinc .and. prog%oldy%inc.lt.0.d0) prog%newy%inc = -prog%newy%inc
    !
    ! Reference pixels
    call cubemain_reproject_user_toprog_find_grid_ref(newx%ref,dxmin,dxmax,prog%newx,error)
    if (error) return
    call cubemain_reproject_user_toprog_find_grid_ref(newy%ref,dymin,dymax,prog%newy,error)
    if (error) return
    !
    select case(prog%ouhead%spa%fra%code)
    case (code_spaframe_galactic)
       prog%newx%name = 'Lii'
       prog%newy%name = 'Bii'
    case (code_spaframe_equatorial,code_spaframe_icrs)
       prog%newx%name = 'RA'
       prog%newy%name = 'DEC'
    case default
       prog%newx%name = 'L'
       prog%newy%name = 'M'
    end select
    !
    ! Update reprojected header
    call cubetools_header_update_axset_l(prog%newx,prog%ouhead,error)
    if (error) return
    call cubetools_header_update_axset_m(prog%newy,prog%ouhead,error)
    if (error) return
  end subroutine cubemain_reproject_user_toprog_find_grid
  !
  subroutine cubemain_reproject_user_toprog_find_grid_ref(user,min,max,new,error)
    use cubetools_user2prog
    use cubetools_unit
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    character(len=*),  intent(in)    :: user
    real(kind=coor_k), intent(in)    :: min
    real(kind=coor_k), intent(in)    :: max
    type(axis_t),      intent(inout) :: new
    logical,           intent(inout) :: error
    !
    real(kind=coor_k) :: smartref,previous
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='REPROJECT>USER>TOPROG>FIND>GRID>REF'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (new%inc.gt.0.d0) then
       smartref = 1.d0-min/new%inc  ! ref so that 1st pixel (1.0) is aligned on dxmin
    else
       smartref = 1.d0-max/new%inc  ! ref (same at dmax)
    endif
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    previous = new%ref
    call cubetools_user2prog_resolve_all(user,nounit,smartref,previous,new%ref,error)
    if (error) return
    ! Round ref to an integer value so that the projection center at the
    ! middle of a pixel. Use nearest value towards Nx/2+1 so that we stay as
    ! near as possible to the Fourier Transform solution.
    if (new%ref.lt.new%n/2.d0+1.d0) then
       new%ref = ceiling(new%ref)
    else
       new%ref = floor(new%ref)
    endif
  end subroutine cubemain_reproject_user_toprog_find_grid_ref
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_reproject_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    class(reproject_comm_t), intent(in)    :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPROJECT>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%comm%reprojected,prog%cube,prog%reprojected,error)
    if (error) return
    call cubetools_header_copy(prog%ouhead,prog%reprojected%head,error)
    if (error) return
  end subroutine cubemain_reproject_prog_header
  !
  subroutine cubemain_reproject_prog_precompute(prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetools_spapro_types
    !----------------------------------------------------------------------
    ! Precomputes coordinates to speed up reprojection
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=4) :: npoints
    integer(kind=pixe_k) :: ixou,iyou
    real(kind=coor_k) :: xvalin,yvalin,xpixin,ypixin,oldxref,oldxval,oldyref,oldyval
    real(kind=coor_k), allocatable :: xou(:,:),you(:,:),inxou(:),inyou(:),ouxou(:),ouyou(:)
    type(projection_t) :: proj
    character(len=*), parameter :: rname='REPROJECT>PROG>PRECOMPUTE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    npoints = prog%newx%n*prog%newy%n
    ! Setup Output projection
    call prog%reprojected%head%spa%pro%gwcs(proj,error)
    if (error) return
    !
    allocate(xou(prog%newx%n,prog%newy%n),you(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'work arrays',ier,error)) return
    !
    ! Convert Output projection to Absolute coordinates
    do iyou=1,prog%newy%n
       do ixou=1,prog%newx%n
          xou(ixou,iyou) = prog%reprojected%head%spa%l%coord(ixou)
          you(ixou,iyou) = prog%reprojected%head%spa%m%coord(iyou)
       enddo
    enddo
    if (prog%conv%code.ne.code_conv_none) then
       allocate(inxou(npoints),inyou(npoints),ouxou(npoints),ouyou(npoints),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs_1dn4(proj,xou,you,ouxou,ouyou,npoints)
       ! Change coordinate
       ! Warning: codes are reversed on purpose because we here
       !          start from the output map...
       if (prog%conv%code.eq.code_conv_equ2gal) then
          call gal_equ(ouxou,ouyou,                 &
                       inxou,inyou,prog%conv%eqin,  &
                       npoints,error)
       elseif (prog%conv%code.eq.code_conv_gal2equ) then
          call equ_gal(ouxou,ouyou,prog%conv%eqout,  &
                       inxou,inyou,                  &
                       npoints,error)
       elseif (prog%conv%code.eq.code_conv_equ2equ) then
          call equ_equ(ouxou,ouyou,prog%conv%eqout,  &
                       inxou,inyou,prog%conv%eqin,   &
                       npoints,error)
       endif
       if (error) return
    else
       allocate(inxou(npoints),inyou(npoints),stat=ier)
       if (failed_allocate(rname,'work arrays',ier,error)) return
       call rel_to_abs_1dn4(proj,xou,you,inxou,inyou,npoints)
    endif
    !
    ! Setup input projection
    call prog%cube%head%spa%pro%gwcs(proj,error)
    if (error) return    
    !
    ! Convert absolute coordinates to input projection
    call abs_to_rel_1dn4(proj,inxou,inyou,xou,you,npoints)
    !
    ! Force the conversion formula for input to be adapted to the
    ! NINT function that will be used on the reprojection. Now Xref=1.0
    oldxval = (1.0-prog%oldx%ref)*prog%oldx%inc+prog%oldx%val
    oldxref = 1.0
    oldyval = (1.0-prog%oldy%ref)*prog%oldy%inc+prog%oldy%val
    oldyref = 1.0
    !
    allocate(prog%ix(prog%newx%n,prog%newy%n),prog%iy(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'Pixels',ier,error)) return
    allocate(prog%xfrac(prog%newx%n,prog%newy%n),prog%yfrac(prog%newx%n,prog%newy%n),stat=ier)
    if (failed_allocate(rname,'Pixel fractions',ier,error)) return
    !
    ! Precompute pixel fractions
    do iyou = 1,prog%newy%n
       do ixou = 1,prog%newx%n
          xvalin = xou(ixou,iyou)
          yvalin = you(ixou,iyou)
          xpixin = (xvalin-oldxval)/prog%oldx%inc+oldxref
          ypixin = (yvalin-oldyval)/prog%oldy%inc+oldyref
          prog%ix(ixou,iyou)    = int(xpixin)
          prog%iy(ixou,iyou)    = int(ypixin)
          prog%xfrac(ixou,iyou) = xpixin-dble(prog%ix(ixou,iyou))
          prog%yfrac(ixou,iyou) = ypixin-dble(prog%iy(ixou,iyou))
       enddo !ixou
    enddo ! iyou  
  end subroutine cubemain_reproject_prog_precompute
  !
  subroutine cubemain_reproject_prog_data(prog,incube,oucube,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! This function takes as arguments two cubes so that it can be
    ! used by an exterior caller
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(inout) :: prog
    type(cube_t),            intent(inout) :: incube
    type(cube_t),            intent(inout) :: oucube
    logical,                 intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='REPROJECT>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call prog%precompute(error)
    if (error) return
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,incube,oucube,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,incube,oucube,error) FIRSTPRIVATE(iter)
       if (.not.error) & 
          call prog%loop(incube,oucube,iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_reproject_prog_data
  !
  subroutine cubemain_reproject_prog_loop(prog,incube,oucube,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(reproject_prog_t),  intent(inout) :: prog
    type(cube_t),             intent(inout) :: incube
    type(cube_t),             intent(inout) :: oucube
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: inima,ouima
    character(len=*), parameter :: rname='REPROJECT>DATA>LOOP'
    !
    call inima%associate('inima',incube,iter,error)
    if (error) return
    call ouima%allocate('ouima',oucube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,inima,ouima,error)
       if (error) return
    enddo ! ie
  end subroutine cubemain_reproject_prog_loop
  !
  subroutine cubemain_reproject_prog_act(prog,ie,inima,ouima,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(reproject_prog_t), intent(in)    :: prog
    integer(kind=entr_k),    intent(in)    :: ie
    type(image_t),           intent(inout) :: inima
    type(image_t),           intent(inout) :: ouima
    logical,                 intent(inout) :: error
    !
    integer(kind=pixe_k) :: ixou,iyou
    character(len=*), parameter :: rname='REPROJECT>PROG>ACT'
    !
    call inima%get(ie,error)
    if (error) return
    !
    do iyou=1,prog%newy%n
       do ixou=1,prog%newx%n
          if (prog%ix(ixou,iyou).lt.1 .or. prog%ix(ixou,iyou).ge.prog%oldx%n .or.&
               prog%iy(ixou,iyou).lt.1 .or. prog%iy(ixou,iyou).ge.prog%oldy%n) then
             ouima%val(ixou,iyou) = gr4nan
          else
             ouima%val(ixou,iyou) = &
             (1-prog%xfrac(ixou,iyou))*(1-prog%yfrac(ixou,iyou))*inima%val(prog%ix(ixou,iyou),prog%iy(ixou,iyou))+&
             prog%xfrac(ixou,iyou)*(1-prog%yfrac(ixou,iyou))*inima%val(prog%ix(ixou,iyou)+1,prog%iy(ixou,iyou))+&
             prog%xfrac(ixou,iyou)*prog%yfrac(ixou,iyou)*inima%val(prog%ix(ixou,iyou)+1,prog%iy(ixou,iyou)+1)+ &
             (1-prog%xfrac(ixou,iyou))*prog%yfrac(ixou,iyou)*inima%val(prog%ix(ixou,iyou),prog%iy(ixou,iyou)+1)
          endif
       enddo ! ixou
    enddo ! iyou
    !
    call ouima%put(ie,error)
    if (error) return
  end subroutine cubemain_reproject_prog_act
end module cubemain_reproject
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine polyno_obs(set,obs,last,cont,flux,z,error)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>polyno_obs
  use class_types
  !---------------------------------------------------------------------
  ! @ private (?)
  ! Support routine for command BASE.
  ! This version for a single observation.
  ! Computes and remove a polynomial baseline. This version uses
  ! singular value decomposition, with fall back to Gauss Jordan if not
  ! possible.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(observation),   intent(inout) :: obs    ! The input observation to work on
  logical,             intent(inout) :: last   ! Use last baseline determination
  logical,             intent(in)    :: cont   ! Divide rather than subtract baseline
  real(kind=4),        intent(inout) :: flux   ! Flux value (if 0, average of base channels)
  real(kind=4),        intent(inout) :: z(*)   ! Working array
  logical,             intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='POLYNO'
  real(kind=4) :: m0,m1,m2
  real(kind=8) :: x_inc,x_off
  real(kind=4) :: s0,s1,s2,alim,s12,rd,s11,resid
  integer(kind=4) :: i,j,mmm,np,w2,status
  real(kind=4) :: a_coef(mdeg),pp(mdeg),chisq,xi,xx,yy
  real(kind=4) :: xmin,xmax,ymin,ymax
  real(kind=8) :: xoff,dxoff
  real(kind=4), allocatable, save :: x(:)
  integer(kind=4), allocatable, save :: w1(:)
  real(kind=4), allocatable, save :: weight(:),y(:)
  real(kind=4), allocatable :: ipu(:,:), ipv(:,:), ipw(:)
  character(len=80) :: chain
  !
  ! Don't like this, but it is for BASE LAST ... Warning: can not work
  ! for parallel processing
  save a_coef,mmm,xmin,xmax,xoff
  !
  if (allocated(x)) then
     if (ubound(x,1).ne.obs%cnchan) then
        if (last) then
           call class_message(seve%w,rname,'Number of channels changed, LAST mode ignored')
           last = .false.
        endif
        deallocate(x,y,weight,w1)
     endif
  endif
  if (.not.allocated(x)) then
     allocate(x(obs%cnchan),y(obs%cnchan))
     allocate(weight(obs%cnchan),w1(obs%cnchan))
  endif
  !
  ! Set up the arrays to be minimized
  if (obs%head%gen%kind.ne.kind_onoff) then
    call polyno_obs_arrays_spec(obs,last,x,y,weight,w1,np,error)
    if (error)  return
  else
    call polyno_obs_arrays_cont(obs,x,y,weight,w1,np,error)
    if (error)  return
  endif
  !
  ! Check that we have enough points: #(points) > polynom degree
  ! Note: np = sum(weight) NOT sum(w1)
  ! Note: polynom degree>=0 implies np>0
  if (np.le.obs%head%bas%deg.and..not.last) then
     error = .true.
     write(chain,*) 'Not enough channels to fit baseline: ',np,obs%head%bas%deg
     call class_message(seve%e,rname,chain)
     return
  endif
  !
  !  Determine the baseline
  if (last) then
    ! Compute Delta-X-offset, i.e. the difference of offsets between
    ! the LAST and the current X values, since these offsets are not
    ! in obs%datax
    if (set%unitx(1).eq.'F') then
      dxoff = obs%head%spe%restf - xoff
    elseif (set%unitx(1).eq.'I') then
      dxoff = obs%head%spe%image - xoff
    else
      dxoff = 0.d0
    endif
    !
  else
     mmm = min(obs%head%bas%deg+1,mdeg)
     xmin = x(1)
     xmax = x(np)
     if (set%unitx(1).eq.'F') then
       xoff = obs%head%spe%restf
     elseif (set%unitx(1).eq.'I') then
       xoff = obs%head%spe%image
     else
       xoff = 0.d0
     endif
     dxoff = 0.d0
     !
     !  Normalize range to [-1,1]
     do i=1,np
        x(i) = (2*x(i)-xmin-xmax)/(xmax-xmin)
     enddo
     !  Allocate work space for both methods
     allocate (ipv(mmm,mmm),stat=status)
     if (status.ne.0) then
        call class_message(seve%f,rname,'Insufficient memory for work space')
        error = .true.
        return
     endif
     allocate(ipu(np,mmm),ipw(mmm),stat=status)
     if (status.eq.0) then
        ! If possible, use singular value decomposition
        ! The 'mmm' coefficients are in array 'a_coef'
        call svdfit(x,y,weight,np,a_coef,mmm,ipu,ipv,ipw,np,mmm,chisq,fcheb,error)
        if (error) then
           call class_message(seve%e,rname,'Error in singular value decomposition')
        else
           !  Check for too high a degree
           call mindeg (ipw,mmm)
        endif
        deallocate(ipu,ipw)
        deallocate(ipv)
        if (error) return
     else
        !  Fall back on gauss-jordan inversion of the normal
        !  Equations when there is not enough memory
        call lfit(x,y,weight,np,a_coef,mmm,ipv,mmm,chisq,fcheb,error)
        deallocate(ipv)
        if (error) then
           call class_message(seve%e,rname,'Error during least square fit.')
           return
        endif
     endif
  endif
  !
  !  Compute baseline value for edges
  xx = -1.0
  call fcheb(xx,pp,mmm)
  yy = 0
  do j=1,mmm
     yy = yy+a_coef(j)*pp(j)
  enddo
  ymin = yy
  !
  xx = 1.0
  call fcheb(xx,pp,mmm)
  yy = 0
  do j=1,mmm
     yy = yy+a_coef(j)*pp(j)
  enddo
  ymax = yy
  !
  if (mmm.gt.2) then
     !  Degree > 1 => mmm.gt.2
     ! Compute polynomial in fitting range, constant value outside
     ! this range
     do i=1, obs%cnchan
        xi = obs%datax(i)+dxoff
        xx = ((xi-xmin)-(xmax-xi))/(xmax-xmin)
        if (xx.le.-1.0) then
           yy = ymin
        elseif (xx.ge.1.0) then
           yy = ymax
        else
           call fcheb(xx,pp,mmm)
           yy = 0
           do j=1,mmm
              yy = yy+a_coef(j)*pp(j)
           enddo
        endif
        z(i) = yy
     enddo
  else
     ! Degree 0 or 1 : compute polynomial everywhere (including
     ! extrapolation beyond edges)
     do i=1, obs%cnchan
        xi = obs%datax(i)+dxoff
        xx = ((xi-xmin)-(xmax-xi))/(xmax-xmin)
        yy = ymin + (xx+1.0)*(ymax-ymin)/2.0
        z(i) = yy
     enddo
  endif
  !
  !  Subtract the baseline and find the sigma
  s0 = 0.
  s1 = 0.
  s2 = 0.
  s11 = 0
  do i = 1, obs%cnchan
     !  Avoid bad channels
     if (obs%spectre(i).ne.obs%head%spe%bad) then
        resid = obs%spectre(i)-z(i)
        !  Continuum or spectral data
        if (.not.cont) then
           obs%spectre(i) = resid
        else
           obs%spectre(i) = obs%spectre(i)/z(i)
        endif
        if (w1(i).ne.0) then
           s0 = s0 + w1(i)
           s1 = s1 + w1(i)*resid
           s2 = s2 + w1(i)*resid**2
           if (cont) s11 = s11+w1(i)*z(i)
        endif
     endif
  enddo
  if (cont) then
     if (flux.eq.0 .and. s0.gt.0) then
        flux = s11/s0
        s11 = 1
     else
        s11 = flux/s11*s0
     endif
     write(chain,'(A,F0.3)') 'Average flux value: ',flux
     call class_message(seve%i,rname,chain)
     do i = 1, obs%cnchan
        if (obs%spectre(i).ne.obs%cbad) then
           obs%spectre(i) = obs%spectre(i)*flux
        endif
     enddo
     obs%head%gen%tsys = obs%head%gen%tsys*abs(s11)
     s1 = s1 * s11
     s2 = s2 * s11**2
  endif
  if (s0.ne.0) then
     s1 = s1 / s0          ! 1st order moment
     s2 = s2 / s0          ! 2bd order moment
     obs%head%bas%sigfi = sqrt(s2-s1**2)
  else
     obs%head%bas%sigfi = 0.
  endif
  !
  !  Area, velocity, width
  obs%head%bas%aire = 0.
  m0 = 0.  ! area
  m1 = 0.  ! 1st order moment
  m2 = 0.  ! 2nd order moment
  alim = obs%head%bas%sigfi * 3.0
  s0 = 0.
  s1 = 0.
  s2 = 0.
  do i = obs%cimin, obs%cimax
     !  Avoid bad channels
     w2 = 1-w1(i)       ! w2=1 means channel in window(s)
     if (w2.ne.0) then
        rd = obs_good(obs,i)  ! if channel is bad, repair it
        if (cont) then
           resid = rd-flux
        else
           resid = rd
        endif
        obs%head%bas%aire = obs%head%bas%aire + resid * w2
        if (abs(resid).ge.alim) then
           s0 = s0 + resid * w2
           s1 = s1 + resid * i * w2
           s2 = s2 + resid * float(i)**2 * w2
        endif
     endif
  enddo
  !
  ! Type out result according to kind
  ! - units of outputs (area,width,position) depend on X axis unit
  ! - obs%head%bas%area is stored with X unit in km/s
  if (obs%head%gen%kind.eq.kind_spec) then
     if (set%unitx(1).eq."V") then
        x_inc = obs%head%spe%vres
        x_off = obs%head%spe%voff
     else if (set%unitx(1).eq."F" .or. set%unitx(1).eq."I") then
        x_inc = obs%head%spe%fres
        x_off = 0.d0
     else if (set%unitx(1).eq."C") then
        x_inc = 1.d0
        x_off = obs%head%spe%rchan
     endif
     m0 = obs%head%bas%aire*abs(x_inc)
     obs%head%bas%aire = obs%head%bas%aire * abs(obs%head%spe%vres)
     if (s0.ne.0) then
        s1 = s1 / s0
        m1 = (s1-obs%head%spe%rchan)*x_inc+x_off
        s2 = s2 / s0
        s12 = s1**2
        if (s2.le.s12) s2 = s12
        m2 = abs(x_inc)*sqrt((s2-s12)*8.*alog(2.))
     endif
  else
     obs%head%bas%aire = obs%head%bas%aire * abs (obs%head%dri%ares)
     m0 = obs%head%bas%aire
     if (s0.ne.0) then
        s1 = s1 / s0
        m1 = (s1-obs%head%dri%rpoin) * obs%head%dri%ares + obs%head%dri%aref
        s2 = s2 / s0
        s12 = s1**2
        if (s2.le.s12) s2 = s12
        m2  =  abs (obs%head%dri%ares) * sqrt((s2-s12)*8.*alog(2.))
     endif
  endif
  !
  ! Output
  if (obs%head%bas%sigfi.ne.0.) then
     write(chain,'(a,i3,a,1pg10.3,a,1pg10.3,a,1pg11.4,a,1pg10.4)')  &
          'degree: ',obs%head%bas%deg,    &
          ' rms:',   obs%head%bas%sigfi,  &
          ' area:',  m0,                  &
          ' v0:',    m1,                  &
          ' width:', m2
  else
     write(chain,'(a,i3,a,a,1pg10.3,a,1pg11.4,a,1pg10.4)')  &
          'degree: ',obs%head%bas%deg,  &
          ' rms: not measured',         &
          ' area:',  m0,                &
          ' v0:',    m1,                &
          ' width:', m2
  endif
  call class_message(seve%i,rname,chain)
end subroutine polyno_obs
!
subroutine polyno_obs_arrays_spec(obs,last,x,y,weight,w1,np,error)
  use gbl_message
  use classcore_interfaces, except_this=>polyno_obs_arrays_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the X, Y, WEIGHT arrays with the valid points to be used for
  ! baselining. A valid point is not in a signal window and is not
  ! bad. The number of valid points is set in NP.
  !  Also fill the W1 array with 0 (in a signal window) or 1 (out a
  ! signal window), i.e. W1 is the representation of the signal windows
  ! as an array of channels.
  !  X, Y, WEIGHT and W1 must have been preallocated to the size
  ! obs%cnchan (i.e. the number of channels currently covered by SET
  ! MODE X), even if they are not entirely used in return.
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs        !
  logical,           intent(in)    :: last       ! Do we reuse the last fitting results?
  real(kind=4),      intent(out)   :: x(:)       ! X positions, in current DATAX units
  real(kind=4),      intent(out)   :: y(:)       ! Y intensities
  real(kind=4),      intent(out)   :: weight(:)  !
  integer(kind=4),   intent(out)   :: w1(:)      ! In or out the signal windows
  integer(kind=4),   intent(out)   :: np         !
  logical,           intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='POLYNO'
  integer(kind=4) :: i,i1,i2,i3,iw
  real(kind=4) :: vv
  integer(kind=4), pointer :: line(:)
  !
  ! Velocity increases or decreases with channel number, increment I3 = +/- 1
  if (obs%datax(obs%cnchan).gt.obs%datax(1)) then
    i1 = 1
    i2 = obs%cnchan
    i3 = 1
  else
    i1 = obs%cnchan
    i2 = 1
    i3 = -1
  endif
  !
  ! Loop on channels
  ! w1(i)=1 if channel i not in window
  ! weight(i)=1 if w1(i)=1 AND channel i not bad
  ! np = sum(weight)
  np = 0
  !
  if (obs%head%bas%nwind.eq.basnwind_assoc) then
    ! Automatic mode: no spectral windows; use Associated Array named "LINE"
    ! which provides, for each channel, 0 (out of a line) or 1 (in a line).
    if (.not.class_assoc_exists(obs,'LINE',line)) then
      call class_message(seve%e,rname,'Associated Array LINE does not exists')
      error = .true.
      return
    endif
    do i=i1, i2, i3
      w1(i) = 0
      if (i.lt.obs%cimin .or. i.gt.obs%cimax)  cycle
      if (line(i).eq.1)  cycle
      if (obs%spectre(i).ne.obs%head%spe%bad) then  !  Avoid bad channels
        np = np + 1
        weight(np)= +1.0
        x(np) = obs%datax(i)
        y(np) = obs%spectre(i)
      endif
      w1(i) = 1
    enddo
    !
  else
    ! Spectral windows are found in obs%head%bas%w1 and w2, which have been
    ! preset.
chanloop: do i=i1, i2, i3
      w1(i) = 0
      if (i.lt.obs%cimin .or. i.gt.obs%cimax)  cycle
      vv = obs%datax(i)
      !  Loop on spectral window(s)
      do iw = 1, obs%head%bas%nwind  ! Nwind can be zero
        ! Dichotomy-like test to check whether in or out of the signal window
        if ( (vv-obs%head%bas%w1(iw))*(vv-obs%head%bas%w2(iw)).lt.0.) then
          ! In a signal window. Skip this channel, but warn for
          ! extrapolation.
          if (i.ne.obs%cimin .and. i.ne.obs%cimax) then
            cycle chanloop
          elseif (.not.last .and. obs%head%bas%deg.gt.1) then
            ! This means a window overlaps a boundary of the SET MODE X
            ! range. What happens to the baselining in this boundary window?
            !  - degrees 0, 1 or sinus are extrapolated
            !  - degrees >=2 are not extrapolated, i.e. a constant value
            !    is used.
            ! In other words, when a window overlaps a SET MODE X boundary,
            ! the fitting range is not SET MODE X, but SET MODE X less the
            ! window. Out of the fitting range, the usual extrapolation rules
            ! apply.
            call class_message(seve%w,rname,'Baseline extrapolation is hazardous')
            cycle chanloop
          else
            cycle chanloop
          endif
        endif
      enddo
      if (obs%spectre(i).ne.obs%head%spe%bad) then  !  Avoid bad channels
        np = np + 1
        weight(np)= +1.0
        x(np) = obs%datax(i)
        y(np) = obs%spectre(i)
      endif
      w1(i) = 1
    enddo chanloop
  endif
  !
end subroutine polyno_obs_arrays_spec
!
subroutine polyno_obs_arrays_cont(obs,x,y,weight,w1,np,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Handle the special case of continuum on/off
  !---------------------------------------------------------------------
  type(observation), intent(in)    :: obs        !
  real(kind=4),      intent(out)   :: x(:)       ! X positions, in current DATAX units
  real(kind=4),      intent(out)   :: y(:)       ! Y intensities
  real(kind=4),      intent(out)   :: weight(:)  !
  integer(kind=4),   intent(out)   :: w1(:)      ! In or out the signal windows
  integer(kind=4),   intent(out)   :: np         !
  logical,           intent(inout) :: error      !
  ! Global
  include 'gbl_pi.inc'  ! For epsr4
  ! Local
  integer(kind=4) :: i
  !
  ! Group the data points in pairs, and ignore windows.
  np = 1
  x(1) = obs%datax(1)
  y(1) = (obs%spectre(1)+obs%spectre(2))/2
  weight(1) = epsr4
  do i=1,obs%cnchan/2
    if (obs%spectre(2*i-1).ne.obs%cbad .and. obs%spectre(2*i).ne.obs%cbad) then
      np = np + 1
      weight(np)= +1.0
      x(np) = (obs%datax(2*i-1)+obs%datax(2*i))/2
      y(np) = (obs%spectre(2*i-1)+obs%spectre(2*i))/2
    endif
    w1(2*i)   = 1
    w1(2*i-1) = 1
  enddo
  np = np+1
  x(np) = obs%datax(obs%cnchan)
  y(np) = (obs%spectre(obs%cnchan)+obs%spectre(obs%cnchan-1))/2
  weight(np) = epsr4
  !
end subroutine polyno_obs_arrays_cont
!
subroutine mindeg(a,n)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS  Internal routine
  !    Warn if the polynomial degree is too high
  !---------------------------------------------------------------------
  integer, intent(in) :: n     ! Polynom degree + 1
  real,    intent(in) :: a(n)  ! RMS for each degree
  !
  ! Local variables
  integer :: imin
  character(len=32) :: chain
  !
  imin = minloc(a,1)
  if (imin.lt.n) then
     write(chain,'(A,I2,A)') 'Degree ',imin-1,' would be even better'
     call class_message(seve%i,'POLYNO',chain)
  endif
end subroutine mindeg

program uv_closephase
  use gildas_def
  use gkernel_interfaces
!
! Apply a phase error (antenna based) to an input UV table
!
  character(len=filename_length) nami,namo
  real(4) :: phase
  logical error
!
  call gildas_open
  call gildas_char('INPUT$',nami)
  call gildas_char('OUTPUT$',namo)
  call gildas_real('PHASE$',phase,1)
  call gildas_close
  call sub_closephase(nami,namo,phase,error)
  call gagout('I-UV_CLOSEPHASE,  Successful completion')
end program uv_closephase
!<ff>
subroutine sub_closephase(nami,namo,phase,error)
  use image_def
  use gkernel_interfaces
  character(len=*) nami,namo
  real :: phase
  logical error
!
  type (gildas) :: hin,hout
  real, allocatable :: din(:,:)
  integer nt,nv,nant,ntime,ier
  real(8), allocatable :: altimes(:), intimes(:)
  integer, allocatable :: inant(:)
  character*60 chain
!
! Read Header of a sorted, UV table
  call gildas_null(hin)
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  allocate (din(hin%gil%dim(1),hin%gil%dim(2)),stat=ier)
  call gdf_read_data (hin,din,error)
  if (error) return
  nt = hin%gil%dim(1) 
  nv = hin%gil%dim(2)
!
! Define the problem size
  allocate (intimes(nv),altimes(nv),inant(nv),stat=ier)
  call analyze_uvtable(din,nt,nv,intimes,altimes,inant,nant,ntime) 
!
! Define the image header
  call gdf_copy_header (hin,hout,error)
  call sic_parsef (namo,hout%file,' ','.uvt')
!
! Load the sorted data
  phase = phase*acos(-1.0)/180.
  call treat_uvtable (phase,din,nt,nv,intimes,altimes,inant,nant,ntime)
!
  call gdf_write_image(hout,din,error)
  if (gildas_error(hout,'CLOSEPHASE',error)) call sysexi(fatale)
  deallocate (intimes,altimes,inant)
  deallocate (din)
  call gagout('I-CLOSEPHASE,  Successful completion')
  return
end subroutine sub_closephase
!
subroutine analyze_uvtable(din,nt,nv,intimes,altimes,inant,nant,ntime)
  use gkernel_interfaces
  integer, intent(in) :: nv
  integer, intent(in) :: nt
  integer, intent(out) :: nant            ! Number of antennas
  integer, intent(out) :: ntime           ! Number of times
  real, intent(in) :: din(nt,nv) 
  real(8), intent(out) :: intimes(nv)     ! Times for each visibility
  real(8), intent(out) :: altimes(nv)     ! Number of times
  integer, intent(out) :: inant(nv)       ! Number of antennas for each time
  !
  integer, allocatable :: it(:), work(:)
  integer nd,iv,ii
  logical ok, error
  character*60 chain
  !
  ! Scan how many dates
  nd = 1
  altimes(nd) = din(4,1)
  do iv=1,nv
     intimes(iv) = 0
     do ii=1,nd
        if (din(4,iv).eq.altimes(ii)) then
           intimes(iv) = ii
        endif
     enddo
     if (intimes(iv).eq.0) then
        nd = nd+1
        altimes(nd) = din(4,iv)
        intimes(iv) = nd
     endif
  enddo
  write(chain,*) 'Found ',nd,' dates '
  call gagout(chain(2:))
!
! Time compacted value
  do iv=1,nv
     intimes(iv) = intimes(iv)-1.d0+din(5,iv)/86400d0
  enddo
!
! Find out how many times...
  altimes = 0.0
  altimes(1) = intimes(1)
  inant(1) = din(7,iv)      ! End antenna
  ntime = 1
  do iv=2,nv
     ok = .false.
     ii = 1
     do while (.not.ok.and.ii.le.ntime)
        if (intimes(iv).eq.altimes(ii)) then
           ok = .true.
           ! Now about antennas. This assumes no antenna is ever flagged...
           if (din(7,iv).gt.inant(ii)) then
              inant(ii) = din(7,iv)
           endif
        else
           ii = ii+1
        endif
     enddo
     if (.not.ok) then
        ntime = ntime+1
        altimes(ntime) = intimes(iv)
        inant(ntime) = din(7,iv)
     endif
  enddo
!
  write(chain,*) 'I-UV,  Found ',ntime,' times '
  call gagout(chain(2:))
!
! Pending nightmare: are the times sorted ?
! Answer: of course not, let us do it now...
  allocate(it(nv), work(nv))
  do ii=1,ntime
     it(ii) = ii
  enddo
  call gr8_trie(altimes,it,ntime,error)
  call gi4_sort(inant,work,it,ntime)
!
! Find out how many antennas
  nd = 1
  do ii=1,ntime
    nd = max(nd,inant(ii))
  enddo
  deallocate(it,work)
  write(chain,*) 'I-UV,  Found ',nd,' antennas '
  nant = nd
  call gagout(chain(2:))
end subroutine analyze_uvtable
!
!<FF>
subroutine treat_uvtable (phase_error,din,nt,nv,intimes,altimes,inant,nant,ntime)
  use gkernel_interfaces
  integer, intent(in) :: nv
  integer, intent(in) :: nt
  integer, intent(in) :: nant
  integer, intent(in) :: ntime
  real, intent(inout) :: din(nt,nv)
  real(8), intent(in) :: intimes(nv)     ! Times for each visibility
  real(8), intent(in) :: altimes(ntime)  ! Number of times
  integer, intent(in) :: inant(ntime)    !
  real, intent(in) :: phase_error        !
  !
  integer iv,it,ia, ier
  real, allocatable :: aphase(:,:)
  real :: phase, re, im, cp, sp
  !
  allocate (aphase(nant,ntime),stat=ier)
  do it=1,ntime
    ! Get random antenna phase
    do ia = 1,inant(it)
       aphase(ia,it) = rangau(phase_error)
    enddo
  enddo
  !
  do iv=1,nv
    !
    ! Check next time match
    do it = 1,ntime
      if (intimes(iv).eq.altimes(it)) then
        phase = aphase(nint(din(6,iv)),it) - aphase(nint(din(7,iv)),it)
        exit
      endif
    enddo
    cp = cos(phase)
    sp = sin(phase)
    !
    ! Apply phase error. Channels must be added here...
    re = din(8,iv)*cp-din(9,iv)*sp 
    im = din(8,iv)*sp+din(9,iv)*cp
    din(8,iv) = re
    din(9,iv) = im
  enddo    
  !
  deallocate (aphase)
end subroutine treat_uvtable

subroutine kvatm(np,p,t,rho,h,agu,oxi,v,temi,tatm,tag,tagu,tox,   &
     &    toxi,ilag,ilox,kvat,ama,ier)
  !----------------------------------------------------------------------
  !	opacidad de la atmosfera a la frecuencia 'v' debida al
  !	vapor de agua y al oxigeno.
  !
  !	np .... numero de capas
  !	h  .... espesor de las capas     (cm)
  !	p  .... presion (milibares)
  !	t  .... temperatura (k)
  !	rho ... cantidad de vapor de agua (gr/m**3)
  !	temi .. emisividad total de la atmosfera     (k)
  !	kvat .. opacidad total (nepers)
  !	tatm .. temperatura media de la atmosfera   (k)
  !	agu ... opacidad debida al vapor de agua (nepers)
  !	oxi ... opacidad debida al oxigeno       (   "  )
  !	tag ... emisividad debida al vapor de agua (atmosfera sin oxigeno)
  !	tox ... idem para el oxigeno (sin vapor de agua)
  !	tagu .. temperatura media de la capa de vapor de agua (k)
  !	toxi .. temperatura media de la capa de oxigeno (k)
  !
  ! J.Cernicharo
  !----------------------------------------------------------------------
  integer np,ilag,ilox,ier
  real agu,oxi,v,temi,tatm,tag,tagu,tox,toxi,kvat,ama
  real h(*),p(*),t(*),rho(*)
  !
  integer j
  real r,pr,tem,dh,ox,ag,kv
  real kh2o, ko2
  !
  temi=0.
  kv=0.
  tag=0.
  tox=0.
  agu=0.
  oxi=0.
  do j=1,np
    r=rho(j)
    pr=p(j)
    tem=t(j)
    dh=h(j)
    ag=kh2o(r,tem,pr,v,ilag)*dh*ama
    ox=ko2(tem,pr,v,ilox)*dh*ama
    call jnu(tem,v,tem)        ! Can give TEM as output
    tag=tag+tem*exp(-agu)*(1.-exp(-ag))
    agu=agu+ag
    tox=tox+tem*exp(-oxi)*(1.-exp(-ox))
    oxi=oxi+ox
    temi=temi+tem*exp(-kv)*(1.-exp(-ag-ox))
    kv=agu+oxi
  enddo
  kvat=kv
  if ( kv.le.1.e-10 ) then
    ier = 1
  elseif ( oxi.le.1.e-20) then
    ier = 2
  elseif ( agu.le.1.e-20 ) then
    ier = 3
  else
    tatm=temi/(1.-exp(-kv))
    tagu=tag/(1.-exp(-agu))
    toxi=tox/(1.-exp(-oxi))
    ier = 0
  endif
end subroutine kvatm
!
subroutine jnu(j,v,t)
  real j                       ! Rayleigh Jeans temperature
  real v                       ! Frequency in GHz
  real t                       ! Temperature
  logical l
  !
  real hsurk, r
  parameter (hsurk=6.62e-34*1e9/1.38e-23)
  logical rayleigh_case
  save rayleigh_case
  !
  if (rayleigh_case) then
    r = hsurk*v/(exp(hsurk*v/t)-1)
    j = r
  else
    j = t
  endif
  return
  !
  entry atm_jnu (l)
  rayleigh_case = l
end subroutine jnu

!-----------------------------------------------------------------------
! This file provides routines which return useful values of Any Working
! (GTV) Directory or Device.
!-----------------------------------------------------------------------
subroutine get_free_slot_output(output,error)
  use gtv_interfaces, except_this=>get_free_slot_output
  use gtv_types
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Get a free slot for a 'output' instance.
  ! ---
  !  Thread status: not thread safe. Should the 'all_outputs' structure
  ! be protected?
  !---------------------------------------------------------------------
  type(gt_display), pointer :: output  ! The 'gt_display' instance found
  logical,    intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_FREE_SLOT_OUTPUT'
  integer :: iout
  !
  do iout=1,moutputs
    if (.not.all_outputs(iout)%used) then
      ! Found an available slot at iout position
      all_outputs(iout)%used = .true.
      output => all_outputs(iout)
      return
    endif
  enddo
  !
  ! No free instance available
  ! call gtv_message(seve%e,rname,'Internal error: no free output instance')
  ! The following message is currently biased to X windows as it is the
  ! only device which uses the 'all_outputs' array.
  call gtv_message(seve%e,'DEVICE','Can not create more than 20 windows')
  output => null()
  error = .true.
  !
end subroutine get_free_slot_output
!
subroutine get_slot_output_by_num(dir,win_num,output,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>get_slot_output_by_num
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the index of the output instance which is identified by
  ! the input directory and window number.
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  type(gt_directory)              :: dir      ! Input directory
  integer(kind=4),  intent(in)    :: win_num  ! Window number
  type(gt_display), pointer       :: output   ! The 'gt_display' instance found
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_SLOT_OUTPUT_BY_NUM'
  integer(kind=address_length) :: graph_env
  character(len=message_length) :: mess
  logical :: found
  !
  graph_env = c_get_win_genv(dir%x%genv_array,win_num)
  !
  call get_slot_output_by_genv(graph_env,output,.true.,found,error)
  if (error) then
    write(mess,*) 'Internal error: output instance not found (num = ',  &
      win_num,')'
    call gtv_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine get_slot_output_by_num
!
subroutine get_slot_output_by_genv(graph_env,output,present,found,error)
  use gtv_interfaces, except_this=>get_slot_output_by_genv
  use gildas_def
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the index of the output instance which is identified by
  ! the input graph_env.
  ! ---
  !  Thread status: not thread safe. Should the 'all_outputs' structure
  ! be protected?
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)    :: graph_env  ! Identifier
  type(gt_display),             pointer       :: output     ! The 'gt_display' instance found
  logical,                      intent(in)    :: present    ! Must the graph_env exist?
  logical,                      intent(out)   :: found      ! .true. if found
  logical,                      intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GET_SLOT_OUTPUT_BY_GENV'
  integer :: iout
  character(len=message_length) :: mess
  !
  do iout=1,moutputs
    if (all_outputs(iout)%used) then
      if (all_outputs(iout)%x%graph_env.eq.graph_env) then
        found = .true.
        output => all_outputs(iout)
        return
      endif
    endif
  enddo
  !
  ! Not found...
  found = .false.
  output => null()
  if (present) then
    write(mess,*) 'Internal error: output instance not found (genv = ',  &
      graph_env,')'
    call gtv_message(seve%e,rname,mess)
    error = .true.
  endif
  !
end subroutine get_slot_output_by_genv
!
function get_window_cnum_byname(dir,rname,line,iopt,iarg,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>get_window_cnum_byname
  use gtv_types
  use gtv_tree
  !---------------------------------------------------------------------
  ! @ private
  !  Return the window instance in the input directory which is
  ! identified by its name (can be "ZOOM") or window number (as seen
  ! by user).
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_cnum_byname  ! Function value on return
  type(gt_directory), intent(in)    :: dir    ! Directory to search in
  character(len=*),   intent(in)    :: rname  ! Calling routine name
  character(len=*),   intent(in)    :: line   ! Command line
  integer(kind=4),    intent(in)    :: iopt   ! Option number in command line
  integer(kind=4),    intent(in)    :: iarg   ! Argument number in option
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: zoom='ZOOM'
  character(len=gtvpath_length) :: wname
  logical :: found
  integer(kind=4) :: nc,win_num
  !
  call sic_ke(line,iopt,iarg,wname,nc,.true.,error)
  if (error) return
  !
  if (wname(1:nc).eq.zoom(1:min(nc,4))) then
    call get_zoom_win(dir,get_window_cnum_byname,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,  &
        'No zoom window attached to current directory')
      error = .true.
      return
    endif
  else
    call sic_math_inte(wname,nc,win_num,error)
    ! Translate the user number into internal number
    get_window_cnum_byname = get_window_cnum(dir,win_num,error)
  endif
  !
end function get_window_cnum_byname
!
function get_window_cnum(dir,usernum,error)
  use gbl_message
  use gildas_def
  use gtv_buffers
  use gtv_interfaces, except_this=>get_window_cnum
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Return the window instance which is identified by its parent
  ! directory and window number (as seen by user).
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_cnum  ! Function value on return
  type(gt_directory), intent(in)    :: dir      ! Input directory
  integer(kind=4),    intent(in)    :: usernum  ! Window number (as seen by user)
  logical,            intent(inout) :: error    ! Logical error flag
  ! Local
  integer :: iwin
  type(gt_display), pointer :: output
  !
  if (error)  return
  !
  if (dir%x%nbwin.eq.0) then
    get_window_cnum = 0
    return
  else
    get_window_cnum = -1
  endif
  !
  do iwin=0,dir%x%nbwin-1
    call get_slot_output_by_num(dir,iwin,output,error)
    if (error)  return
    if (output%x%number.eq.usernum) then
      get_window_cnum = iwin
      return
    endif
  enddo
  !
  ! Not found... Error will be detected later.
  !
end function get_window_cnum
!
function get_window_usernum(dir,cnum,error)
  use gtv_types
  use gtv_interfaces, except_this=>get_window_usernum
  !---------------------------------------------------------------------
  ! @ private
  !  Return the window number in the user system of numbering, given
  ! the internal number in the C-and-continuous internal system of
  ! numbering.
  !---------------------------------------------------------------------
  integer(kind=4) :: get_window_usernum  ! Function value on return
  type(gt_directory), intent(in)    :: dir    ! The directory the window is attached on
  integer(kind=4),    intent(in)    :: cnum   ! The C number of the window we look for
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  !
  get_window_usernum = 0
  !
  call get_slot_output_by_num(dir,cnum,output,error)
  if (error)  return
  !
  get_window_usernum = output%x%number
  !
end function get_window_usernum
!
subroutine free_slot_output_by_genv(graph_env,error)
  use gtv_interfaces, except_this=>free_slot_output_by_genv
  use gildas_def
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! RenameMe!
  !  Free the output instance which is identified by the input
  ! graph_env.
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)  :: graph_env  ! Identifier
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FREE_SLOT_OUTPUT_BY_GENV'
  integer :: iout
  !
  do iout=1,moutputs
    if (all_outputs(iout)%used) then
      if (all_outputs(iout)%x%graph_env.eq.graph_env) then
        call gt_output_reset(all_outputs(iout))
        return
      endif
    endif
  enddo
  !
  ! Not found...
  call gtv_message(seve%e,rname,'Internal error: output instance not found')
  error = .true.
  !
end subroutine free_slot_output_by_genv
!
subroutine gt_output_reset(output)
  use gtv_interfaces, except_this=>gt_output_reset
  use gtv_types
  use gtv_bitmap
  !---------------------------------------------------------------------
  ! @ private
  !   Reset the instance parameters, set it unused, and free the
  ! allocated memory it was using for images.
  !---------------------------------------------------------------------
  type(gt_display) :: output  ! Output instance
  !
  output%used = .false.
  output%autorotate = .false.
  output%autoscale = .true.
  !
  output%px1 = 0  ! Reset actual size ensures that device defaults will
  output%px2 = 0  ! be used instead.
  output%py1 = 0
  output%py2 = 0
  !
  output%idashe = 1
  output%iweigh = graisse(1)
  output%icolou = 1
  !
  call x_display_reset(output%x)
  !
end subroutine gt_output_reset
!
subroutine x_display_reset(xdisplay)
  use gtv_interfaces, except_this=>x_display_reset
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(x_output), intent(inout) :: xdisplay  ! Instance to be reset
  ! Local
  type(gt_bitmap), pointer :: xbitmap,next
  !
  xdisplay%name = ' '
  xdisplay%graph_env = 0
  xdisplay%is_zoom = .false.
  !
  ! 0 values (invalid for size) mean unset
  xdisplay%geometry%x = 0.
  xdisplay%geometry%unitx = ' '
  xdisplay%geometry%y = 0.
  xdisplay%geometry%unity = ' '
  !
  ! -1 values (invalid for position) mean unset
  xdisplay%position%x = -1.
  xdisplay%position%unitx = ' '
  xdisplay%position%y = -1.
  xdisplay%position%unity = ' '
  !
  ! Clean the X bitmaps
  xbitmap => xdisplay%bitmap_first
  do while (associated(xbitmap))
    ! Keep track of next before deletion
    next => xbitmap%next
    !
    call gt_bitmap_deallocate(xbitmap)
    xbitmap => next
  enddo
  xdisplay%bitmap_first => null()
  xdisplay%bitmap_last => null()
  !
end subroutine x_display_reset
!
subroutine gt_bitmap_deallocate(bitmap)
  use gtv_interfaces, except_this=>gt_bitmap_deallocate
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which deallocates the input 'gt_bitmap' and
  ! frees the data associated. This routine does NOT take care of the
  ! pointers to this instance: it is up to the calling routine to
  ! remake the chain, if required.
  !---------------------------------------------------------------------
  type(gt_bitmap), pointer :: bitmap  !
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
  ! No need: we destroy the instance right after
  ! bitmap%irvalues => null()
  ! bitmap%igvalues => null()
  ! bitmap%ibvalues => null()
  ! bitmap%image => null()
  ! bitmap%next => null()
  !
  deallocate(bitmap)
  !
end subroutine gt_bitmap_deallocate
!
subroutine print_gt_device(dev)
  use gtv_interfaces, except_this=>print_gt_device
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print the content various variables attached to the input gt_device
  ! structure. For debugging purpose.
  !---------------------------------------------------------------------
  type(gt_device), intent(in) :: dev  ! Input gt_device
  !
  write(*,101) 'Protocol:',dev%protocol
  write(*,101) 'Linit1:',  dev%linit1
  write(*,100) 'Init1:',   trim(dev%init1)
  write(*,101) 'Linit2:',  dev%linit2
  write(*,100) 'Init2:',   trim(dev%init2)
  !
  write(*,101) 'Px1 (default):',dev%px1
  write(*,101) 'Px2 (default):',dev%px2
  write(*,101) 'Py1 (default):',dev%py1
  write(*,101) 'Py2 (default):',dev%py2
  write(*,102) 'Rxy:',          dev%rxy
  !
  ! To be continued
  !
100 format(2X,A,T25,A)     ! Character string
101 format(2X,A,T25,I8)    ! Integer value
102 format(2X,A,T25,F8.3)  ! Float value
end subroutine print_gt_device
!
subroutine print_gt_output(output)
  use gtv_interfaces, except_this=>print_gt_output
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print the content of various variables attached to the input
  ! gt_device structure. For debugging purpose.
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: output  ! Input gt_display instance
  !
  write(*,111) 'Px1, Px2 (actual):',output%px1,output%px2
  write(*,111) 'Py1, Py2 (actual):',output%py1,output%py2
  !
  write(*,112) 'Gx1, Gx2:',         output%gx1,output%gx2
  write(*,112) 'Gy1, Gy2:',         output%gy1,output%gy2
  !
  ! To be continued
  !
! 103 format(2X,A,T25,L1,  T35,L1)    ! 1 Logical value
! 110 format(2X,A,T25,A,   T35,A)     ! 2 Character strings
111 format(2X,A,T25,I8,  T35,I8)    ! 2 Integer values
112 format(2X,A,T25,F8.3,T35,F8.3)  ! 2 Float values
end subroutine print_gt_output
!
subroutine get_scale_awd(out,scalex,scaley)
  use gtv_interfaces, except_this=>get_scale_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the X and Y scaling relation between physical and pixel
  ! units, for Input Working Device.
  !  Note that the range of pixels [out%px1:out%px2] is fully mapped
  ! on the physical range [out%gx1:out%gx2]. Pixels have a finite size:
  ! the left border of the first pixel is aligned on the left border of
  ! the physical range, and the right border of the last pixel is
  ! aligned on the right border of the physical range.
  !  This is very useful for images: when you ask a 100 pixels image to
  ! be displayed on a 100 pixels device, you except a 1 to 1 pixel
  ! alignment (not 100 image pixels on 99 device pixels). Note also that
  ! you want to align the boundaries of the side pixels, NOT the center
  ! of the side pixels. Example:
  ! 1) Same number of pixels
  !  Image:  |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  !  Device: |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  ! 2a) Twice more, we want boundaries aligned:
  !  Image:  |-----.-----|-----.-----|-----.-----|-----.-----|  4 pixels
  !  Device: |--.--|--.--|--.--|--.--|--.--|--.--|--.--|--.--|  8 pixels
  ! 2b) Twice more, we DO NOT want centers aligned because this truncate
  !     the original pixels:
  !  Image:  |-----.-----|-----.-----|-----.-----|-----.-----|  4 pixels
  !  Device:     |-.--|--.-|--.-|--.-|--.-|--.-|--.-|--.-|      8 pixels
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out     ! Input gt_display
  real(kind=4),     intent(out) :: scalex  ! Number of pixels per world unit in X
  real(kind=4),     intent(out) :: scaley  ! Number of pixels per world unit in Y
  ! Local
  real(kind=4) :: gx,gy,kxy
  !
  if (out%py1.lt.out%py2) then
    ! out%py2-out%py1+1 > 0 = +(number of pixels)
    gy = (out%gy2-out%gy1)/float(out%py2-out%py1+1)
  else
    ! out%py2-out%py1-1 < 0 = -(number of pixels)
    gy = (out%gy2-out%gy1)/float(out%py2-out%py1-1)
  endif
  if (out%px1.lt.out%px2) then
    gx = (out%gx2-out%gx1)/float(out%px2-out%px1+1)
  else
    gx = (out%gx2-out%gx1)/float(out%px2-out%px1-1)
  endif
  kxy = gx/gy
  if (abs(gy*out%dev%rxy) .ge. abs(gx)) then
    scaley = 1./gy
    if (kxy.gt.0.) then
      scalex = scaley / out%dev%rxy
    else
      scalex = - scaley / out%dev%rxy
    endif
  else
    scalex = 1./gx
    if (kxy.gt.0.) then
      scaley = scalex * out%dev%rxy
    else
      scaley = - scalex * out%dev%rxy
    endif
  endif
  !
end subroutine get_scale_awd
!
subroutine get_central_pixel_awd(out,xpix_center,ypix_center)
  use gtv_interfaces, except_this=>get_central_pixel_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the center pixel of Input Working Device. Should be dynamic
  ! at some point i.e. will dynamically get the device size (and NOT
  ! from some global variable), and then compute this center.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out          ! Input gt_display
  real(kind=4),     intent(out) :: xpix_center  ! Central pixel X coordinate
  real(kind=4),     intent(out) :: ypix_center  ! Central pixel X coordinate
  !
  xpix_center = float(out%px1+out%px2)/2. + (0.5-out%dev%poff)
  ypix_center = float(out%py1+out%py2)/2. + (0.5-out%dev%poff)
  !
end subroutine get_central_pixel_awd
!
subroutine get_central_clipping_awd(out,x_center,y_center)
  use gtv_interfaces, except_this=>get_central_clipping_awd
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the center of the clipping window of the Input Working
  ! Device. Should be dynamic at some point i.e. will dynamically get
  ! the current device clipping window (and NOT from some global
  ! variable), and then compute this center.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out       ! Input gt_display
  real(kind=4),     intent(out) :: x_center  ! Center X point of plot space
  real(kind=4),     intent(out) :: y_center  ! Center Y point of plot space
  !
  x_center = (out%gx1+out%gx2)/2.
  y_center = (out%gy1+out%gy2)/2.
  !
end subroutine get_central_clipping_awd
!
subroutine world_to_pixel_size_i4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_size_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel_size
  ! Convert world SIZE into pixel size for the input working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input size in world coordinates
  integer(kind=4),  intent(out) :: px,py  ! Output size in pixels
  ! Local
  real(kind=4) :: rpx,rpy
  !
  call world_to_pixel_size_r4(out,wx,wy,rpx,rpy)
  !
  px = nint(rpx)
  py = nint(rpy)
  !
end subroutine world_to_pixel_size_i4
!
subroutine world_to_pixel_size_r4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_size_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel_size
  ! Convert world SIZE into pixel size for the input working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input size in world coordinates
  real(kind=4),     intent(out) :: px,py  ! Output size in pixels
  ! Local
  real(kind=4) :: gsclx,gscly
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  !
  px = wx*abs(gsclx)
  py = wy*abs(gscly)
  !
end subroutine world_to_pixel_size_r4
!
subroutine pixel_to_world_size_i4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_size_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world_size
  !  Convert pixel SIZE into world size for the input working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  integer(kind=4),  intent(in)  :: px,py  ! Input pixel size
  real(kind=4),     intent(out) :: wx,wy  ! Output world size
  !
  call pixel_to_world_size_r4(out,real(px,kind=4),real(py,kind=4),wx,wy)
  !
end subroutine pixel_to_world_size_i4
!
subroutine pixel_to_world_size_r4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_size_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world_size
  !  Convert pixel SIZE into world size for the input working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world_size' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: px,py  ! Input pixel size
  real(kind=4),     intent(out) :: wx,wy  ! Output world size
  ! Local
  real(kind=4) :: gsclx,gscly
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  !
  wx = px/gsclx
  wy = py/gscly
  !
end subroutine pixel_to_world_size_r4
!
subroutine world_to_pixel_i4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel
  ! Convert world COORDINATES into pixel coordinates for the input
  ! working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input world coordinates
  integer(kind=4),  intent(out) :: px,py  ! Output pixel coordinates
  ! Local
  real(kind=4) :: rpx,rpy
  !
  call world_to_pixel_r4(out,wx,wy,rpx,rpy)
  !
  px = nint(rpx)
  py = nint(rpy)
  !
end subroutine world_to_pixel_i4
!
subroutine world_to_pixel_r4(out,wx,wy,px,py)
  use gtv_interfaces, except_this=>world_to_pixel_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic world_to_pixel
  ! Convert world COORDINATES into pixel coordinates for the input
  ! working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'world_to_pixel' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: wx,wy  ! Input world coordinates
  real(kind=4),     intent(out) :: px,py  ! Output pixel coordinates
  ! Local
  real(kind=4) :: gsclx,gscly,pox,poy,gox,goy
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  call get_central_pixel_awd(out,pox,poy)
  call get_central_clipping_awd(out,gox,goy)
  !
  px = (wx-gox)*gsclx + pox
  py = (wy-goy)*gscly + poy
  !
  ! Description of the above formula:
  ! - we want to align out%gx1 to the left border  of the letf  pixel, and
  !                    out%gx2 to the right border of the right pixel
  !   (i.e. the physical range covers all the pixels).
  ! - This writes as:
  !    out%gx1 <=> out%px1-1/2
  !    out%gx2 <=> out%px2+1/2  if  out%px1<out%px2, OR
  !    out%gx1 <=> out%px2-1/2
  !    out%gx2 <=> out%px1+1/2  if  out%px1>out%px2
  ! - in get_scale_awd, we get easily the slope of the relationship
  !   formula (something like px = wx*m+p)
  ! - Now we have m but we need p. Instead of choosing p aligned on gx1
  !   or gx2, we choose p at the center of them. This makes our life
  !   easier, because it nullifies the +-1/2 problem depending on the
  !   pixel axis sign.
  !
end subroutine world_to_pixel_r4
!
subroutine pixel_to_world_i4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_i4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world
  !  Convert pixel coordinates into world coordinates for the input
  ! working device.
  ! ---
  !  Integer(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  integer(kind=4),  intent(in)  :: px,py  ! Input pixel coordinates
  real(kind=4),     intent(out) :: wx,wy  ! Output world coordinates
  !
  call pixel_to_world_r4(out,real(px,kind=4),real(py,kind=4),wx,wy)
  !
end subroutine pixel_to_world_i4
!
subroutine pixel_to_world_r4(out,px,py,wx,wy)
  use gtv_interfaces, except_this=>pixel_to_world_r4
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private-generic pixel_to_world
  !  Convert pixel coordinates into world coordinates for the input
  ! working device.
  ! ---
  !  Real(kind=4) version: do not call directly. Use generic
  ! interface 'pixel_to_world' instead.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out    ! Input gt_display
  real(kind=4),     intent(in)  :: px,py  ! Input pixel coordinates
  real(kind=4),     intent(out) :: wx,wy  ! Output world coordinates
  ! Local
  real(kind=4) :: gsclx,gscly,pox,poy,gox,goy
  !
  ! Get the Current Working Device parameters:
  call get_scale_awd(out,gsclx,gscly)
  call get_central_pixel_awd(out,pox,poy)
  call get_central_clipping_awd(out,gox,goy)
  !
  wx = (px-pox)/gsclx + gox
  wy = (py-poy)/gscly + goy
  !
end subroutine pixel_to_world_r4

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehelp_collect
  use sic_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_ascii
  use cube_messaging
  !
  public :: collect
  private
  !
  type :: collect_comm_t
     type(option_t),           pointer :: comm
     type(option_t),           pointer :: format
     type(keywordlist_comm_t), pointer :: format_arg
   contains
     procedure, public  :: register  => cubehelp_collect_register
     procedure, private :: parse     => cubehelp_collect_parse
     procedure, private :: main      => cubehelp_collect_main
  end type collect_comm_t
  type(collect_comm_t) :: collect
  !
  character(len=*), parameter :: collect_basename_default='cube'
  type :: collect_user_t
     character(len=file_l) :: filename
     character(len=argu_l) :: format
   contains
     procedure, private :: toprog => cubehelp_collect_user_toprog
  end type collect_user_t
  !
  type :: collect_prog_t
     character(len=file_l) :: filename
     integer(kind=code_k)  :: iformat
     type(ascii_file_t)    :: file
   contains
     procedure, private :: collect_help  => cubehelp_collect_prog_help
     procedure, private :: collect_flags => cubehelp_collect_prog_flags
     procedure, private :: language      => cubehelp_collect_flags_language
     procedure, private :: command       => cubehelp_collect_flags_command 
     procedure, private :: option        => cubehelp_collect_flags_option
     procedure, private :: arguments     => cubehelp_collect_flags_arguments
     procedure, private :: argument      => cubehelp_collect_flags_argument
  end type collect_prog_t
  type(collect_prog_t) :: prog
  !
contains
  !
  subroutine cubehelp_collect_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(collect_user_t) :: user
    !
    call collect%parse(line,user,error)
    if (error) return
    call collect%main(user,error)
    if (error) return
  end subroutine cubehelp_collect_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_register(collect,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(collect_comm_t), intent(inout) :: collect
    logical,               intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='COLLECT>REGISTER'
    !
    call cube_message(seve%t,rname,'Welcome')
    !
    call cubetools_register_command(&
         'COLLECT','[File]',&
         'Collect all the helps in a single file',&
         strg_id,&
         cubehelp_collect_command,&
         collect%comm,error)
    if (error) return
    call stdarg%register( &
         'FILE',  &
         'Output file name', &
         'Output file name (default is "cube.hlp" in the current working directory).',&
         code_arg_optional, &
         error)
    if (error) return
    !
    ! /FORMAT
    call cubetools_register_option(&
         'FORMAT','Kind',&
         'Collect options, arguments, and flags under the named kind',&
         strg_id,&
         collect%format,error)
    if (error) return
    call keyarg%register( &
         'Kind',  &
         'Format kind', &
         'TEX: TeX format for inclusion in LaTeX files'&
         //strg_cr//&
         'FLAGS: ASCII format showing expected flags for command and &
         &option arguments',&
         code_arg_mandatory, &
         help_formats, &
         .not.flexible, &
         collect%format_arg, &
         error)
    if (error) return
    !
  end subroutine cubehelp_collect_register
  !
  subroutine cubehelp_collect_parse(collect,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_comm_t), intent(in)    :: collect
    character(len=*),      intent(in)    :: line
    type(collect_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    user%filename = collect_basename_default
    call cubetools_getarg(line,collect%comm,1,user%filename,.not.mandatory,error)
    if (error) return
    !
    user%format = help_formats(help_format_tex)
    call cubetools_getarg(line,collect%format,1,user%format,.not.mandatory,error)
    if (error) return
  end subroutine cubehelp_collect_parse
  !
  subroutine cubehelp_collect_main(collect,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_comm_t), intent(in)    :: collect
    type(collect_user_t),  intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(collect_prog_t) :: prog
    !
    call user%toprog(prog,error)
    if (error) return
    select case (prog%iformat)
    case (help_format_flags)
      call prog%collect_flags(error)
      if (error) return
    case (help_format_tex)
      call prog%collect_help(error)
      if (error) return
    end select
  end subroutine cubehelp_collect_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_user_toprog(user,prog,error)
    use gkernel_interfaces
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(collect_user_t), intent(in)    :: user
    type(collect_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=32) :: solved
    character(len=*), parameter :: rname='COLLECT>USER>TOPROG'
    !
    call cubetools_disambiguate_strict(user%format,help_formats,  &
      prog%iformat,solved,error)
    if (error)  return
    !
    call sic_parse_file(user%filename,' ',help_extensions(prog%iformat),prog%filename)
  end subroutine cubehelp_collect_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_prog_help(prog,error)
    use gkernel_interfaces
    use cubetools_help_tool
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    logical,               intent(inout) :: error
    !
    type(help_tool_t) :: help
    character(len=*), parameter :: rname='COLLECT>HELP'
    !
    call file%set_width() ! Default file width
    call file%set_format(help_format_tex)
    call help%open_file(prog%filename,error)
    if (error) goto 10
    call cubetools_structure_help_iterate(help_format_tex,error)
    if (error) goto 10
10  continue
    call help%close_file(error)
    if (error) return
    call terminal%set_width()  ! Dynamic terminal width
    call terminal%set_format()  ! Specific terminal format
  end subroutine cubehelp_collect_prog_help
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehelp_collect_prog_flags(prog,error)
    use cubetools_language
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=lang_k) :: ilang
    type(language_t), pointer :: lang
    character(len=*), parameter :: rname='COLLECT>FLAGS'
    !
    ! Note this help format can not use the generic help collector in
    ! libcubesyntax because it needs properties of cubeid_arg_t
    !
    call prog%file%open(prog%filename,'write',error)
    if (error) return
    !
    call prog%file%write_next('List of Flags demanded by commands',error)
    if (error) return
    call prog%file%write_next('* Package: '//pack%name,error)
    if (error) return
    !
    do ilang=1,pack%lang%n
       lang => cubetools_language_ptr(pack%lang%list(ilang)%p,error)
       if (error) return
       call prog%language(lang,error)
       if (error) return
    enddo
    !
    call prog%file%close(error)
    if (error) return
  end subroutine cubehelp_collect_prog_flags
  !
  subroutine cubehelp_collect_flags_language(prog,lang,error)
    use cubetools_standard_comm
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    type(language_t),      intent(in)    :: lang
    logical,               intent(inout) :: error
    !
    integer(kind=comm_k) :: icomm
    type(command_t), pointer :: comm
    character(len=*), parameter :: rname='COLLECT>FLAGS>LANGUAGE'
    !
    call prog%file%write_next('** Language: '//lang%name,error)
    if (error) return
    do icomm=1,lang%comm%n
      comm => cubetools_command_ptr(lang%comm%list(icomm)%p,error)
      if (error) return
      call prog%command(comm,lang%name,error)
      if (error) return
    enddo
  end subroutine cubehelp_collect_flags_language
  !
  subroutine cubehelp_collect_flags_command(prog,comm,langname,error)
    use sic_def
    use cubetools_primitive_opt
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(inout) :: prog
    type(command_t),       intent(in)    :: comm
    character(len=*),      intent(in)    :: langname
    logical,               intent(inout) :: error
    !
    character(len=2048) :: outbuffer
    character(len=512) :: chain
    integer(kind=opti_k) :: iopt
    class(primitive_opt_t), pointer :: opt
    character(len=*), parameter :: rname='COLLECT>FLAGS>COMMAND'
    !
    outbuffer = '*** Command '//trim(langname)//backslash//trim(comm%name)//strg_cr
    opt => cubetools_primitive_opt_ptr(comm%opt%list(0)%p,error)
    if (error) return
    !
    call prog%option(opt,'Command ',chain,error)
    if (error)  return
    outbuffer = trim(outbuffer)//chain
    !
    do iopt=1,comm%opt%n
       opt => cubetools_primitive_opt_ptr(comm%opt%list(iopt)%p,error)
       if (error) return
       call prog%option(opt,'Option /',chain,error)
       if (error) return
       outbuffer = trim(outbuffer)//chain
    enddo
    !
    call prog%file%write_next(outbuffer,error)
    if (error) return
  end subroutine cubehelp_collect_flags_command
  !
  subroutine cubehelp_collect_flags_option(prog,opt,optkind,chain,error)
    use cubetools_primitive_opt
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(collect_prog_t),  intent(in)    :: prog
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: optkind
    character(len=*),       intent(out)   :: chain
    logical,                intent(inout) :: error
    !
    integer(kind=narg_k) :: ncubes
    character(len=256) :: optargs
    !
    call prog%arguments(opt%arg,ncubes,optargs,error)
    if (error) return
    write(chain,'(4a,i0,a,i0,2a)')  &
      '    ',optkind,trim(opt%name),' has ',opt%arg%n,  &
      ' arguments (',ncubes
    if (ncubes.eq.0) then
      chain = trim(chain)//' cube)'//strg_cr
    elseif (ncubes.eq.1) then
      chain = trim(chain)//' cube):'//strg_cr//trim(optargs)
    else
      chain = trim(chain)//' cubes):'//strg_cr//trim(optargs)
    endif
  end subroutine cubehelp_collect_flags_option
  !
  subroutine cubehelp_collect_flags_arguments(prog,arglist,ncubes,optargs,error)
    use cubelist_types
    use cubeadm_cubeid_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    type(list_t),          intent(in)    :: arglist
    integer(kind=narg_k),  intent(out)   :: ncubes   ! Number of cubes for this option
    character(len=*),      intent(out)   :: optargs  ! Description
    logical,               intent(inout) :: error
    !
    integer(kind=narg_k) :: iarg
    character(len=128) :: argflags
    class(list_object_t), pointer :: arg
    character(len=*), parameter :: rname='COLLECT>FLAGS>ARGUMENTS'
    !
    ncubes = 0
    optargs = ''
    do iarg=1,arglist%n
       arg => arglist%list(iarg)%p
       select type(arg)
       type is (cubeid_arg_t)
          ncubes = ncubes+1
          call prog%argument(arg,argflags,error)
          if (error) return
          optargs = trim(optargs)//trim(argflags)//strg_cr
       class default
          ! do nothing
       end select
    enddo
  end subroutine cubehelp_collect_flags_arguments
  !
  subroutine cubehelp_collect_flags_argument(prog,arg,argflags,error)
    use cubedag_allflags
    use cubeadm_cubeid_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(collect_prog_t), intent(in)    :: prog
    type(cubeid_arg_t),    intent(in)    :: arg
    character(len=*),      intent(out)   :: argflags
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iflag
    character(len=*), parameter :: rname='COLLECT>FLAGS>ARGUMENT'
    !
    write(argflags,'(3a)') '       ',trim(arg%name),':'
    do iflag=1,arg%nflag
       if (arg%flag(iflag).eq.flag_any) then
          write(argflags,'(2a)') trim(argflags),' any'
       else
          write(argflags,'(3a)') trim(argflags),' ',arg%flag(iflag)%get_name()
       endif
       if (iflag.lt.arg%nflag) write(argflags,'(2a)') trim(argflags),','
    enddo
  end subroutine cubehelp_collect_flags_argument
end module cubehelp_collect
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults(set,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_defaults
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set   !
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_defaults_spec(cons)
  case (kind_cont)
    call consistency_defaults_cont(cons)
  ! case default
    ! No default set at this stage (i.e. can be called from FIND with any
    ! kind). Non supported kinds will be trappped when actually trying to
    ! check their consistency.
  end select
  !
end subroutine consistency_defaults
!
subroutine consistency_check_selection(set,line,iopt,cons,error)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_check_selection
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_check_selection_spec(set,line,iopt,cons,error)
  case (kind_cont)
    call consistency_check_selection_cont(set,line,iopt,cons,error)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
  end select
  !
end subroutine consistency_check_selection
!
subroutine consistency_check_gen(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'general' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%gen%check.and.cons%gen%done) then
     if (cons%gen%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%gen%check = .false.
     endif
     write(mess,100) 'Data type',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_gen
!
subroutine consistency_check_sou(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'source' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%sou%check.and.cons%sou%done) then
     if (cons%sou%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%sou%check = .false.
     endif
     write(mess,100) 'Source name',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_sou
!
subroutine consistency_check_pos(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'position' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%pos%check.and.cons%pos%done) then
     if (cons%pos%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%pos%check = .false.
     endif
     write(mess,100) 'Position information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_pos
!
subroutine consistency_check_off(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'offset' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%off%check.and.cons%off%done) then
     if (cons%off%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%off%check = .false.
     endif
     write(mess,100) 'Offset position',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_off
!
subroutine consistency_check_lin(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'line' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%lin%check.and.cons%lin%done) then
     if (cons%lin%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%lin%check = .false.
     endif
     write(mess,100) 'Line name',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_lin
!
subroutine consistency_check_spe(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'spectroscopy' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%spe%check.and.cons%spe%done) then
     if (cons%spe%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%spe%check = .false.
     endif
     write(mess,100) 'Spectroscopic information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_spe
!
subroutine consistency_check_cal(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'calibration' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%cal%check.and.cons%cal%done) then
     if (cons%cal%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%cal%check = .false.
     endif
     write(mess,100) 'Calibration information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_cal
!
subroutine consistency_check_swi(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'switching' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%swi%check.and.cons%swi%done) then
     if (cons%swi%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%swi%check = .false.
     endif
     write(mess,100) 'Switching information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_swi
!
subroutine consistency_check_dri(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check if 'drift' consistency has already been checked
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1
  integer(kind=4) :: sever
  character(len=message_length) :: mess
  !
  if (cons%dri%check.and.cons%dri%done) then
     if (cons%dri%prob) then
        chain1 = 'Inconsistent'
        sever = seve%w
     else
        chain1 = 'Consistent'
        sever = seve%i
        cons%dri%check = .false.
     endif
     write(mess,100) 'Drift information',chain1
     call class_message(sever,rname,mess)
  endif
  !
100 format('Already checked ',A,':',T44,A)
end subroutine consistency_check_dri
!
subroutine consistency_print(set,ref_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call consistency_print_spec(ref_head,cons)
  case (kind_cont)
    call consistency_print_cont(ref_head,cons)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine consistency_print
!
subroutine consistency_print_gen(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'general' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%gen%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Data type and regular x-axis sampling')
  !
end subroutine consistency_print_gen
!
subroutine consistency_print_sou(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'source' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%sou%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Source Name')
  !
end subroutine consistency_print_sou
!
subroutine consistency_print_pos(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'position' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%pos%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Position information')
  !
end subroutine consistency_print_pos
!
subroutine consistency_print_off(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'offset' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%off%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Offset position')
  !
end subroutine consistency_print_off
!
subroutine consistency_print_lin(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'line' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%lin%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Line Name')
  !
end subroutine consistency_print_lin
!
subroutine consistency_print_spe(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'spectroscopy' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%spe%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Spectroscopic information')
  !
end subroutine consistency_print_spe
!
subroutine consistency_print_cal(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'calibration' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%cal%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Calibration information')
  !
end subroutine consistency_print_cal
!
subroutine consistency_print_swi(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'switching' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%swi%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Switching information')
  !
end subroutine consistency_print_swi
!
subroutine consistency_print_dri(cons)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Print checking status of the 'drift' consistency
  !---------------------------------------------------------------------
  type(consistency_t), intent(in) :: cons  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=11) :: chain1
  !
  if (cons%dri%check) then
     chain1 = '  Checking'
  else
     chain1 = '  Leaving'
  endif
  call class_message(seve%r,rname,chain1//'Drift information')
  !
end subroutine consistency_print_dri
!
subroutine observation_consistency_check(set,ref_head,obs_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: obs_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  select case (set%kind)
  case (kind_spec)
    call spectrum_consistency_check(set,ref_head,obs_head,cons)
  case (kind_cont)
    call continuum_consistency_check(set,ref_head,obs_head,cons)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine observation_consistency_check
!
subroutine observation_consistency_check_gen(kind,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_gen
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'general' consistency of the input observation header
  !---------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: kind      ! Expected kind of data
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  if (cons%gen%check) then
     cons%gen%prob = .false.
     if (obs_head%gen%kind.ne.kind) then
        if (cons%gen%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,  &
             '  Kind of data not supported')
        endif
        cons%gen%prob = .true.
        cons%prob = .true.
     endif
     if (obs_head%presec(class_sec_xcoo_id)) then
        if (cons%gen%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,  &
             '  Irregular sampling along the x-axis data unsupported')
        endif
        cons%gen%prob = .true.
        cons%prob = .true.
     endif
     if (cons%gen%prob) then
        cons%gen%num = obs_head%gen%num
     endif
  endif
  !
end subroutine observation_consistency_check_gen
!
subroutine observation_consistency_check_sou(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_sou
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'source' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%sou%check) then
     cons%sou%prob = .false.
     if (obs_head%pos%sourc.ne.ref_head%pos%sourc) then
        if (cons%sou%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,101) 'Source Name: ',ref_head%pos%sourc,obs_head%pos%sourc
           call class_message(seve%w,rname,mess)
        endif
        cons%sou%num = obs_head%gen%num
        cons%sou%prob = .true.
        cons%prob = .true.
     endif
  endif
  !
101 format(2x,a,a,    ', ',a)      ! Strings
end subroutine observation_consistency_check_sou
!
subroutine observation_consistency_check_pos(set,ref_head,obs_head,cons,warned)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_pos
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'position' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%pos%check) then
     cons%pos%prob = .false.
     if (obs_head%pos%system.ne.ref_head%pos%system) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Coordinate System: ',ref_head%pos%system,obs_head%pos%system
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%system.eq.type_eq.and.(obs_head%pos%equinox.ne.ref_head%pos%equinox)) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,103) 'Equinox: ',ref_head%pos%equinox,obs_head%pos%equinox
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%proj.ne.ref_head%pos%proj) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Projection System: ',ref_head%pos%proj,obs_head%pos%proj
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (abs(obs_head%pos%lam-ref_head%pos%lam).gt.cons%ptole) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Lambda Proj Centers: ',ref_head%pos%lam,obs_head%pos%lam
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (abs(obs_head%pos%bet-ref_head%pos%bet).gt.cons%ptole) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Beta Proj Centers: ',ref_head%pos%bet,obs_head%pos%bet
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     if (obs_head%pos%projang.ne.ref_head%pos%projang) then
        if (cons%pos%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,104) 'Proj. Angles: ',ref_head%pos%projang,obs_head%pos%projang
           call class_message(seve%w,rname,mess)
        endif
        cons%pos%prob = .true.
     endif
     !
     call observation_consistency_check_off(set,ref_head,obs_head,cons,warned)
     !
     if (cons%pos%prob) then
        cons%pos%num = obs_head%gen%num
        cons%prob = .true.
     endif
  endif
  !
  ! Formats. Display all digits for floating points for best understanding
  ! of the mismatch, if any.
102 format(2x,a,i0,     ', ',i0)       ! Integers
103 format(2x,a,1pg14.7, ', ',1pg14.7)   ! Single precision
104 format(2x,a,1pg23.16,', ',1pg23.16)  ! Double precision
end subroutine observation_consistency_check_pos
!
subroutine observation_consistency_check_off(set,ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_off
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'offset' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  real(kind=4) :: dpos2
  !
  if (cons%off%check) then
    ! Also check the offset positions. Check distance around reference:
    cons%off%prob = .false.
    dpos2 = (  &
      (ref_head%pos%lam+ref_head%pos%lamof-obs_head%pos%lam-obs_head%pos%lamof)  &
      *cos(ref_head%pos%bet))**2 +  &
      (ref_head%pos%bet+ref_head%pos%betof-obs_head%pos%bet-obs_head%pos%betof)**2
    if (dpos2.gt.set%tole**2) then
      if (cons%off%mess) then
        call observation_consistency_warn(obs_head,warned)
        call class_message(seve%w,rname,'Position offsets are not compatible')
      endif
      cons%off%prob = .true.
    endif
    if (cons%off%prob) then
      cons%off%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
end subroutine observation_consistency_check_off
!
subroutine observation_consistency_check_lin(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_lin
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'line' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%lin%check) then
     cons%lin%prob = .false.
     if (obs_head%spe%line.ne.ref_head%spe%line) then
        if (cons%lin%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,101) 'Line Name: ',ref_head%spe%line,obs_head%spe%line
           call class_message(seve%w,rname,mess)
        endif
        cons%lin%num = obs_head%gen%num
        cons%lin%prob = .true.
        cons%prob = .true.
     endif
  endif
  !
101 format(2x,a,a,    ', ',a)      ! Strings
end subroutine observation_consistency_check_lin
!
subroutine observation_consistency_check_spe(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'spectroscopy' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  real(kind=8) :: ref_val,spe_val,cha_val
  integer(kind=4) :: nc
  !
  if (cons%spe%check) then
     cons%spe%prob = .false.
     if (obs_head%spe%nchan.ne.ref_head%spe%nchan) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,102) 'Number of channels: ',ref_head%spe%nchan,obs_head%spe%nchan
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     if (obs_head%spe%fres*ref_head%spe%fres.le.0.d0) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           write(mess,105) 'F resolution sign: ',ref_head%spe%fres,obs_head%spe%fres
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Signal frequency range
     call abscissa_sigabs_left(obs_head,spe_val)          ! Freq at left of spectrum
     call abscissa_sigabs2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_sigabs_left(ref_head,ref_val)
           write(mess,106) 'F range (left) : ',  &
             ref_val,spe_val,cha_val-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     call abscissa_sigabs_right(obs_head,spe_val)         ! Freq at right of spectrum
     call abscissa_sigabs2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-ref_head%spe%nchan-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_sigabs_right(ref_head,ref_val)
           write(mess,106) 'F range (right): ',  &
             ref_val,spe_val,cha_val-ref_head%spe%nchan-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity range
     call abscissa_velo_left(obs_head,spe_val)          ! Velo at left of spectrum
     call abscissa_velo2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_velo_left(ref_head,ref_val)
           write(mess,106) 'V range (left) : ',  &
             ref_val,spe_val,cha_val-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     call abscissa_velo_right(obs_head,spe_val)         ! Velo at right of spectrum
     call abscissa_velo2chan(ref_head,spe_val,cha_val)  ! Chan position in ref
     if (abs(cha_val-ref_head%spe%nchan-.5d0).gt.cons%ctole) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call abscissa_velo_right(ref_head,ref_val)
           write(mess,106) 'V range (right): ',  &
             ref_val,spe_val,cha_val-ref_head%spe%nchan-.5d0
           call sic_noir(mess,nc)
           call class_message(seve%w,rname,mess)
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity types
     if (obs_head%spe%vtype.ne.ref_head%spe%vtype) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,'  V type')
        endif
        cons%spe%prob = .true.
     endif
     ! Velocity conventions
     if (obs_head%spe%vconv.ne.ref_head%spe%vconv) then
        if (cons%spe%mess) then
           call observation_consistency_warn(obs_head,warned)
           call class_message(seve%w,rname,'  V convention')
        endif
        cons%spe%prob = .true.
     endif
     if (cons%spe%prob) then
        cons%spe%num = obs_head%gen%num
        cons%prob = .true.
     endif
  endif
  !
102 format(2x,a,i0,   ', ',i0)     ! Integers
105 format(2x,a,e13.6,', ',e13.6)  ! Floats (e13.6 digits)
! Frequency resolution: down to 1 kHz
! Velocity resolution: down to 1 m/s @ 300 GHz
106 format(2x,a,f0.3,', ',f0.3,' (',f9.2,' channels)')
end subroutine observation_consistency_check_spe
!
subroutine observation_consistency_check_cal(set,ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_cal
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'calibration' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (cons%cal%check                    .and.  &
      obs_head%presec(class_sec_cal_id) .and.  &
      ref_head%presec(class_sec_cal_id)) then
    cons%cal%prob = .false.
    if (set%beamt.gt.0.) then
      if (abs(obs_head%cal%beeff-ref_head%cal%beeff).gt.set%beamt) then
        if (cons%cal%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,108) 'Beam efficiencies',ref_head%cal%beeff,obs_head%cal%beeff
          call class_message(seve%w,rname,mess)
        endif
        cons%cal%prob = .true.
      endif
    endif
    if (set%gaint.gt.0.) then
      if (abs(obs_head%cal%gaini-ref_head%cal%gaini).gt.set%gaint) then
        if (cons%cal%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,108) 'Gain ratios',ref_head%cal%gaini,obs_head%cal%gaini
          call class_message(seve%w,rname,mess)
        endif
        cons%cal%prob = .true.
      endif
    endif
    if (cons%cal%prob) then
      cons%cal%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
108 format(2x,a,f7.3, ', ',f7.3)   ! Floats (f7.3 digit)
end subroutine observation_consistency_check_cal
!
subroutine observation_consistency_check_swi(ref_head,obs_head,cons,warned)
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_swi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'switching' consistency of the input observation header
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  integer(kind=4) :: iphas
  !
  if (cons%swi%check                    .and.  &
      obs_head%presec(class_sec_swi_id) .and.  &
      ref_head%presec(class_sec_swi_id)) then
    cons%swi%prob = .false.
    if (ref_head%swi%swmod.ne.obs_head%swi%swmod) then  ! Different modes
      ! Only a problem if combining unfolded fsw to something else
      cons%swi%prob = ref_head%swi%swmod.eq.mod_freq .or.  &
                      obs_head%swi%swmod.eq.mod_freq
      if (cons%swi%prob .and. cons%swi%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,101) 'Switching modes: ',trim(obs_swmod(ref_head%swi%swmod)),  &
                                            trim(obs_swmod(obs_head%swi%swmod))
        call class_message(seve%w,rname,mess)
      endif
    elseif (ref_head%swi%swmod.eq.mod_freq) then  ! Both are unfolded FSW
      if (ref_head%swi%nphas.ne.obs_head%swi%nphas) then
        ! Not the same number of phases
        if (cons%swi%mess) then
          call observation_consistency_warn(obs_head,warned)
          write(mess,102) 'Number of phases: ',ref_head%swi%nphas,obs_head%swi%nphas
          call class_message(seve%w,rname,mess)
        endif
        cons%swi%prob = .true.
      else
        ! Same number of phases
        do iphas=1,ref_head%swi%nphas
          if (ref_head%swi%decal(iphas).ne.obs_head%swi%decal(iphas)) then
            if (cons%swi%mess) then
              call observation_consistency_warn(obs_head,warned)
              write(mess,103) 'Frequency switching offsets: ',iphas,ref_head%swi%decal(iphas),obs_head%swi%decal(iphas)
              call class_message(seve%w,rname,mess)
            endif
            cons%swi%prob = .true.
          endif
        enddo
      endif
    elseif (ref_head%swi%swmod.eq.mod_pos) then   ! Both are PSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_fold) then  ! Both are folded FSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_wob) then   ! Both are WSW
      ! Is this fully safe?
    elseif (ref_head%swi%swmod.eq.mod_mix) then   ! Both are mixed modes
      ! Is this fully safe? By construction, CLASS builds "mixed" spectra
      ! from a consistent index, so it should be safe.
    endif
    if (cons%swi%prob) then
      cons%swi%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
101 format(2x,a,a,             ', ',a)     ! Characters
102 format(2x,a,i0,            ', ',i0)    ! Integers
103 format(2x,a,'#',i0,1x,f7.3,', ',f7.3)  ! Floats (f7.3 digit)
end subroutine observation_consistency_check_swi
!
subroutine observation_consistency_check_dri(set,ref_head,obs_head,cons,warned)
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>observation_consistency_check_dri
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check the 'drift' consistency of the input observation header
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  !
  type(header),        intent(in)    :: obs_head  !
  type(consistency_t), intent(inout) :: cons      !
  logical,             intent(inout) :: warned    ! Warning flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  real(kind=8) :: ref_val,ang_val,cha_val
  integer(kind=4) :: nc
  real(kind=8) :: apos1,apos2
  logical :: notsame,notopposite
  !
  if (cons%dri%check) then
    cons%dri%prob = .false.
    if (obs_head%dri%npoin.ne.ref_head%dri%npoin) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,102) 'Number of points: ',ref_head%dri%npoin,obs_head%dri%npoin
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    if (obs_head%dri%ares*ref_head%dri%ares.le.0.d0) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        write(mess,105) 'A resolution sign: ',ref_head%dri%ares,obs_head%dri%ares
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    ! Angle range
    call abscissa_angl_left(obs_head,ang_val)          ! Angle at left of drift
    call abscissa_angl2chan(ref_head,ang_val,cha_val)  ! Chan position in ref
    if (abs(cha_val-.5d0).gt.cons%ptole) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call abscissa_angl_left(ref_head,ref_val)
        write(mess,106) 'A range (left) : ',  &
          ref_val*class_setup_get_fangle(),   &
          ang_val*class_setup_get_fangle(),   &
          cha_val-.5d0
        call sic_noir(mess,nc)
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    call abscissa_angl_right(obs_head,ang_val)         ! Angle at right of drift
    call abscissa_angl2chan(ref_head,ang_val,cha_val)  ! Chan position in ref
    if (abs(cha_val-ref_head%dri%npoin-.5d0).gt.cons%ptole) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call abscissa_angl_right(ref_head,ref_val)
        write(mess,106) 'A range (right): ',  &
          ref_val*class_setup_get_fangle(),   &
          ang_val*class_setup_get_fangle(),   &
          cha_val-ref_head%dri%npoin-.5d0
        call sic_noir(mess,nc)
        call class_message(seve%w,rname,mess)
      endif
      cons%dri%prob = .true.
    endif
    ! Position angles are consistent if equal +- pi. Do not use modulo as value
    ! 'pi-eps' is not reduced to '0-eps' almost equal to 0.
    apos1 = abs(ref_head%dri%apos-obs_head%dri%apos)
    apos2 = abs(apos1-pi)
    notsame = apos1.gt.cons%atole
    notopposite = apos2.gt.cons%atole
    if (notsame.and.notopposite) then
      if (cons%dri%mess) then
        call observation_consistency_warn(obs_head,warned)
        call class_message(seve%w,rname,'Drift angles are not compatible')
      endif
      cons%dri%prob = .true.
    endif
    if (cons%dri%prob) then
      cons%dri%num = obs_head%gen%num
      cons%prob = .true.
    endif
  endif
  !
102 format(2x,a,i0,   ', ',i0)     ! Integers
105 format(2x,a,e13.6,', ',e13.6)  ! Floats (e13.6 digits)
! Angle resolution: down to 1 mas
106 format(2x,a,f0.3,', ',f0.3,' (',f9.2,' channels)')
end subroutine observation_consistency_check_dri
!
subroutine observation_consistency_warn(obs_head,warned)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  ! Warn user about inconsistant spectrum, if not yet done
  !---------------------------------------------------------------------
  type(header), intent(in)    :: obs_head  !
  logical,      intent(inout) :: warned    !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=message_length) :: mess
  !
  if (warned)  return  ! Already done
  !
  write(mess,'(a,i0,a)') 'Obs #',obs_head%gen%num,' differs. Inconsistent:'
  call class_message(seve%w,rname,mess)
  warned = .true.
  !
end subroutine observation_consistency_warn
!
subroutine consistency_tole(ref_head,cons)
  use phys_const
  use classcore_interfaces, except_this=>consistency_tole
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  !
  ! Tolerance 10% of channel at spectrum edges
  cons%ctole = 1.d-1
  !
  ! Tolerance 10 milli-arcsec for position/projection center
  cons%ptole = 1.d-2 * rad_per_sec
  !
  ! Tolerance 0.01 degree for position angles
  cons%atole = 1.d-2 * rad_per_deg
  !
end subroutine consistency_tole
!
subroutine index_consistency_analysis(set,cons,rname)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  select case (set%kind)
  case (kind_spec)
    call index_consistency_analysis_spec(cons,rname)
  case (kind_cont)
    call index_consistency_analysis_cont(cons,rname)
  case default
    call class_message(seve%e,rname,'Unsupported kind of data')
    ! error = .true.
  end select
  !
end subroutine index_consistency_analysis
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults_spec(cons)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  !
  ! Default is to check everything
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = .true.
  cons%lin%check = .true.
  cons%spe%check = .true.
  cons%cal%check = .true.
  cons%swi%check = .true.
  !
  ! Default is to give feedback to users
  cons%gen%mess = .true.
  cons%sou%mess = .true.
  cons%pos%mess = .true.
  cons%off%mess = .true.
  cons%lin%mess = .true.
  cons%spe%mess = .true.
  cons%cal%mess = .true.
  cons%swi%mess = .true.
  !
  ! At start, there is no problem
  cons%prob     = .false.
  cons%gen%prob = .false.
  cons%sou%prob = .false.
  cons%pos%prob = .false.
  cons%off%prob = .false.
  cons%lin%prob = .false.
  cons%spe%prob = .false.
  cons%cal%prob = .false.
  cons%swi%prob = .false.
  !
  ! At start, nothing has been checked
  cons%gen%done = .false.
  cons%sou%done = .false.
  cons%pos%done = .false.
  cons%off%done = .false.
  cons%lin%done = .false.
  cons%spe%done = .false.
  cons%cal%done = .false.
  cons%swi%done = .false.
  !
  ! At start, no spectrum is faulty
  cons%gen%num = -1
  cons%sou%num = -1
  cons%pos%num = -1
  cons%off%num = -1
  cons%lin%num = -1
  cons%spe%num = -1
  cons%cal%num = -1
  cons%swi%num = -1
  !
end subroutine consistency_defaults_spec
!
subroutine consistency_check_selection_spec(set,line,iopt,cons,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_selection_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1,chain2
  integer(kind=4) :: iarg,nchain,nctype
  integer(kind=4), parameter :: mctype=7
  character(len=12) :: ctype(mctype)
  data ctype/'SOURCE','POSITION','OFFSET','LINE','SPECTROSCOPY','CALIBRATION','SWITCHING'/
  !
  ! Default checks are ruled by the general SET [NO]CHECK tuning
  cons%gen%check = .true.
  cons%sou%check = set%check%sou
  cons%pos%check = set%check%pos
  cons%off%check = set%check%pos.and.set%check%off.and.set%match
  cons%lin%check = set%check%lin
  cons%spe%check = set%check%spe
  cons%cal%check = set%check%cal.and.(set%beamt.gt.0..or.set%gaint.gt.0.)
  cons%swi%check = set%check%swi
  !
  ! Parse line for the /NOCHECK option
  if (sic_present(iopt,0)) then
     if (sic_narg(iopt).eq.0) then
        cons%sou%check = .false.
        cons%pos%check = .false.
        cons%off%check = .false.
        cons%lin%check = .false.
        cons%spe%check = .false.
        cons%cal%check = .false.
        cons%swi%check = .false.
     else
        do iarg = 1, sic_narg(iopt)
           call sic_ke(line,iopt,iarg,chain1,nchain,.true.,error)
           call sic_ambigs('/NOCHECK',chain1,chain2,nctype,ctype,mctype,error)
           if (error) return
           select case (nctype)
           case(1) ! SOURCE
              cons%sou%check = .false.
           case(2) ! POSITION+OFFSET
              cons%pos%check = .false.
              cons%off%check = .false.
           case(3) ! OFFSET
              cons%off%check = .false.
           case(4) ! LINE
              cons%lin%check = .false.
           case(5) ! SPECTROSCOPY
              cons%spe%check = .false.
           case(6) ! CALIBRATION
              cons%cal%check = .false.
           case(7) ! SWITCHING
              cons%swi%check = .false.
           end select
        enddo
     endif
  endif
  !
  ! Avoid checking again when consistency is proved
  call consistency_check_gen(cons)
  call consistency_check_sou(cons)
  call consistency_check_pos(cons)
  call consistency_check_off(cons)
  call consistency_check_lin(cons)
  call consistency_check_spe(cons)
  call consistency_check_cal(cons)
  call consistency_check_swi(cons)
  !
  ! This subroutine is called before a new check. So cons%prob must be
  ! reset. Now there is NO problem if the user says so, e.g. if the user
  ! turns off all the checks even though there may be an already located
  ! inconsistency...
  cons%prob = (cons%gen%check.and.cons%gen%done.and.cons%gen%prob) .or.  &
              (cons%sou%check.and.cons%sou%done.and.cons%sou%prob) .or.  &
              (cons%pos%check.and.cons%pos%done.and.cons%pos%prob) .or.  &
              (cons%off%check.and.cons%off%done.and.cons%off%prob) .or.  &
              (cons%lin%check.and.cons%lin%done.and.cons%lin%prob) .or.  &
              (cons%spe%check.and.cons%spe%done.and.cons%spe%prob) .or.  &
              (cons%cal%check.and.cons%cal%done.and.cons%cal%prob) .or.  &
              (cons%swi%check.and.cons%swi%done.and.cons%swi%prob)
  !
  ! Is there anything left to be checked?
  cons%check = cons%gen%check .or.  &
               cons%sou%check .or.  &
               cons%pos%check .or.  &
               cons%off%check .or.  &
               cons%lin%check .or.  &
               cons%spe%check .or.  &
               cons%cal%check .or.  &
               cons%swi%check
  !
  ! User feedback
  if (.not.cons%check) then
     if (cons%prob) then
        call class_message(seve%e,rname,'Index is inconsistent')
     else
        call class_message(seve%i,rname,'Index is consistent')
     endif
  endif
  !
end subroutine consistency_check_selection_spec
!
subroutine consistency_print_spec(ref_head,cons)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=256) :: chain
  !
  ! First: What will be checked
  call class_message(seve%r,rname,'Consistency checks:')
  call consistency_print_gen(cons)  ! General
  call consistency_print_sou(cons)  ! Source name
  call consistency_print_pos(cons)  ! Position information
  call consistency_print_off(cons)  ! Offset positions
  call consistency_print_lin(cons)  ! Line name
  call consistency_print_spe(cons)  ! Spectroscopy information
  call consistency_print_cal(cons)  ! Calibration information
  call consistency_print_swi(cons)  ! Switching information
  !
  ! Second: Reference information
  call class_message(seve%r,rname,'Reference spectrum:')
  !
  ! Source name
  write(chain,101) 'Source Name',ref_head%pos%sourc
  call class_message(seve%r,rname,chain)
  !
  ! Position information
  if (ref_head%pos%system.eq.type_eq) then
     write(chain,102) 'Coordinate System','EQUATORIAL ',ref_head%pos%equinox
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ga) then
     write(chain,101) 'Coordinate System','GALACTIC'
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ic) then
     write(chain,101) 'Coordinate System','ICRS'
     call class_message(seve%r,rname,chain)
  endif
  write(chain,103) 'Proj. Center (rad)','lambda ',ref_head%pos%lam,  &
                                      ', beta ',ref_head%pos%bet,    &
                                      ', tolerance ',cons%ptole
  call class_message(seve%r,rname,chain)
  !
  ! Line name
  write(chain,101) 'Line Name',ref_head%spe%line
  call class_message(seve%r,rname,chain)
  !
  ! Spectroscopic information
  write(chain,105) 'Frequency (MHz)','rest ',ref_head%spe%restf,  &
                                   ', resol ',ref_head%spe%fres
  call class_message(seve%r,rname,chain)
  write(chain,105) 'Velocity (km/s)','resol ',ref_head%spe%vres,  &
                                   ', offset ',ref_head%spe%voff
  call class_message(seve%r,rname,chain)
  write(chain,106) 'Alignment (chan)','tolerance ',cons%ctole*1.d2
  call class_message(seve%r,rname,chain)
  !
  ! Calibration information
  if (ref_head%presec(class_sec_cal_id)) then
    write(chain,107) 'Calibration','beeff',ref_head%cal%beeff,  &
                                  ',gain',ref_head%cal%gaini
    call class_message(seve%r,rname,chain)
  endif
  !
  ! Switching information
  if (ref_head%presec(class_sec_swi_id)) then
    ! The kind of data displayed is the same as the kind of data
    ! diff'ed in observation_consistency_check_swi
    if (ref_head%swi%swmod.eq.mod_freq) then
      write(chain,108) 'Switching',trim(obs_swmod(ref_head%swi%swmod)),  &
                       ', nphase ',ref_head%swi%nphas, &
                       ', offsets',ref_head%swi%decal(1:ref_head%swi%nphas)
    else
      write(chain,108) 'Switching',trim(obs_swmod(ref_head%swi%swmod))
    endif
    call class_message(seve%r,rname,chain)
  endif
  !
101 format(2x,a,t21,': ',a)
102 format(2x,a,t21,': ',a,f7.1)
107 format(2x,a,t21,': ',a,f7.3,a,f7.3)  ! 2 floats (f7.3 digit)
103 format(2x,a,t21,': ',a,f12.6, a,f12.6, a,1pg7.1)
105 format(2x,a,t21,': ',a,es12.3,a,es12.3)
106 format(2x,a,t21,': ',a,f7.1,'%')  ! Percents
108 format(2x,a,t21,': ',a,a,i0,a,8(1x,f0.3))
end subroutine consistency_print_spec
!
subroutine spectrum_consistency_check(set,ref_head,spe_head,cons)
  use gbl_constant
  use classcore_interfaces, except_this=>spectrum_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: spe_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  logical :: warned
  !
  ! If the program arrived here, it means that something must be checked and
  ! the basic assumption is there is no problem... On the other hand, the subsection
  ! problem variables are initialized to .false. only when the subsection is checked
  ! to avoid loosing the history
  warned = .false.
  cons%prob = .false.
  !
  call observation_consistency_check_gen(kind_spec,spe_head,cons,warned)
  call observation_consistency_check_sou(ref_head,spe_head,cons,warned)
  call observation_consistency_check_pos(set,ref_head,spe_head,cons,warned)
  ! Offsets checked above, if enabled
  call observation_consistency_check_lin(ref_head,spe_head,cons,warned)
  call observation_consistency_check_spe(ref_head,spe_head,cons,warned)
  call observation_consistency_check_cal(set,ref_head,spe_head,cons,warned)
  call observation_consistency_check_swi(ref_head,spe_head,cons,warned)
  !
end subroutine spectrum_consistency_check
!
subroutine index_consistency_analysis_spec(cons,rname)
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis_spec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For spectroscopic data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  if (cons%prob) then
     ! Only the parts that are inconsistent can be marked as checked
     if (cons%gen%prob) cons%gen%done = .true.
     if (cons%sou%prob) cons%sou%done = .true.
     if (cons%pos%prob) cons%pos%done = .true.
     if (cons%off%prob) cons%off%done = .true.
     if (cons%lin%prob) cons%lin%done = .true.
     if (cons%spe%prob) cons%spe%done = .true.
     if (cons%cal%prob) cons%cal%done = .true.
     if (cons%swi%prob) cons%swi%done = .true.
     call class_message(seve%e,rname,'Index is inconsistent')
  else
     ! The parts that have been checked are consistent
     if (cons%gen%check) cons%gen%done = .true.
     if (cons%sou%check) cons%sou%done = .true.
     if (cons%pos%check) cons%pos%done = .true.
     if (cons%off%check) cons%off%done = .true.
     if (cons%lin%check) cons%lin%done = .true.
     if (cons%spe%check) cons%spe%done = .true.
     if (cons%cal%check) cons%cal%done = .true.
     if (cons%swi%check) cons%swi%done = .true.
     call class_message(seve%i,rname,'Index is consistent')
  endif
  !
end subroutine index_consistency_analysis_spec
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine consistency_defaults_cont(cons)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons  ! Performed actions, tolerances and results
  !
  ! Default is to check everything
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = .true.
  cons%dri%check = .true.
  !
  ! Default is to give feedback to users
  cons%gen%mess = .true.
  cons%sou%mess = .true.
  cons%pos%mess = .true.
  cons%off%mess = .true.
  cons%dri%mess = .true.
  !
  ! At start, there is no problem
  cons%prob     = .false.
  cons%gen%prob = .false.
  cons%sou%prob = .false.
  cons%pos%prob = .false.
  cons%off%prob = .false.
  cons%dri%prob = .false.
  !
  ! At start, nothing has been checked
  cons%gen%done = .false.
  cons%sou%done = .false.
  cons%pos%done = .false.
  cons%off%done = .false.
  cons%dri%done = .false.
  !
  ! At start, no spectrum is faulty
  cons%gen%num = -1
  cons%sou%num = -1
  cons%pos%num = -1
  cons%off%num = -1
  cons%dri%num = -1
  !
end subroutine consistency_defaults_cont
!
subroutine consistency_check_selection_cont(set,line,iopt,cons,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_selection_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  integer(kind=4),     intent(in)    :: iopt   ! Number of the /NOCHECK option
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=64) :: chain1,chain2
  integer(kind=4) :: iarg,nchain,nctype
  integer(kind=4), parameter :: mctype=4
  character(len=12) :: ctype(mctype)
  data ctype/'SOURCE','POSITION','OFFSET','DRIFT'/
  !
  ! Check everything by default
  cons%gen%check = .true.
  cons%sou%check = .true.
  cons%pos%check = .true.
  cons%off%check = set%match
  cons%dri%check = .true.
  !
  ! Parse line for the /NOCHECK option
  if (sic_present(iopt,0)) then
     if (sic_narg(iopt).eq.0) then
        cons%sou%check = .false.
        cons%pos%check = .false.
        cons%off%check = .false.
        cons%dri%check = .false.
     else
        do iarg = 1, sic_narg(iopt)
           call sic_ke(line,iopt,iarg,chain1,nchain,.true.,error)
           call sic_ambigs('/NOCHECK',chain1,chain2,nctype,ctype,mctype,error)
           if (error) return
           select case (nctype)
           case(1) ! SOURCE
              cons%sou%check = .false.
           case(2) ! POSITION
              cons%pos%check = .false.
           case(3) ! OFFSET
              cons%off%check = .false.
           case(4) ! DRIFT
              cons%dri%check = .false.
           end select
        enddo
     endif
  endif
  !
  ! Avoid checking again when consistency is proved
  call consistency_check_gen(cons)
  call consistency_check_sou(cons)
  call consistency_check_pos(cons)
  call consistency_check_off(cons)
  call consistency_check_dri(cons)
  !
  ! This subroutine is called before a new check. So cons%prob must be
  ! reset. Now there is NO problem if the user says so, e.g. if the user
  ! turns off all the checks even though there may be an already located
  ! inconsistency...
  cons%prob = (cons%gen%check.and.cons%gen%done.and.cons%gen%prob) .or.  &
              (cons%sou%check.and.cons%sou%done.and.cons%sou%prob) .or.  &
              (cons%pos%check.and.cons%pos%done.and.cons%pos%prob) .or.  &
              (cons%off%check.and.cons%off%done.and.cons%off%prob) .or.  &
              (cons%dri%check.and.cons%dri%done.and.cons%dri%prob)
  !
  ! Is there anything left to be checked?
  cons%check = cons%gen%check .or.  &
               cons%sou%check .or.  &
               cons%pos%check .or.  &
               cons%off%check .or.  &
               cons%dri%check
  !
  ! User feedback
  if (.not.cons%check) then
     if (cons%prob) then
        call class_message(seve%e,rname,'Index is inconsistent')
     else
        call class_message(seve%i,rname,'Index is consistent')
     endif
  endif
  !
end subroutine consistency_check_selection_cont
!
subroutine consistency_print_cont(ref_head,cons)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>consistency_print_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  character(len=256) :: chain
  !
  ! First: What will be checked
  call class_message(seve%r,rname,'Consistency checks:')
  call consistency_print_gen(cons)  ! General
  call consistency_print_sou(cons)  ! Source name
  call consistency_print_pos(cons)  ! Position information
  call consistency_print_off(cons)  ! Offset positions
  call consistency_print_dri(cons)  ! Offset positions
  !
  ! Second: Reference information
  call class_message(seve%r,rname,'Reference drift:')
  !
  ! Source name
  write(chain,101) 'Source Name',ref_head%pos%sourc
  call class_message(seve%r,rname,chain)
  !
  ! Position information
  if (ref_head%pos%system.eq.type_eq) then
     write(chain,102) 'Coordinate System','EQUATORIAL ',ref_head%pos%equinox
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ga) then
     write(chain,101) 'Coordinate System','GALACTIC'
     call class_message(seve%r,rname,chain)
  elseif (ref_head%pos%system.eq.type_ic) then
     write(chain,101) 'Coordinate System','ICRS'
     call class_message(seve%r,rname,chain)
  endif
  write(chain,103) 'Proj. Center (rad)','lambda ',ref_head%pos%lam,  &
                                      ', beta ',ref_head%pos%bet,    &
                                      ', tolerance ',cons%ptole
  call class_message(seve%r,rname,chain)
  !
101 format(2x,a,t21,': ',a)
102 format(2x,a,t21,': ',a,f7.1)
103 format(2x,a,t21,': ',a,f12.6, a,f12.6, a,1pg7.1)
end subroutine consistency_print_cont
!
subroutine continuum_consistency_check(set,ref_head,dri_head,cons)
  use gbl_constant
  use gbl_message
  use classcore_interfaces, except_this=>continuum_consistency_check
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set       !
  type(header),        intent(in)    :: ref_head  ! Reference header
  type(header),        intent(in)    :: dri_head  ! Header to be checked
  type(consistency_t), intent(inout) :: cons      ! Performed actions, tolerances and results
  ! Local
  logical :: warned
  !
  ! If the program arrived here, it means that something must be checked and
  ! the basic assumption is there is no problem... On the other hand, the subsection
  ! problem variables are initialized to .false. only when the subsection is checked
  ! to avoid loosing the history
  warned = .false.
  cons%prob = .false.
  !
  call observation_consistency_check_gen(kind_cont,dri_head,cons,warned)
  call observation_consistency_check_sou(ref_head,dri_head,cons,warned)
  call observation_consistency_check_pos(set,ref_head,dri_head,cons,warned)
  ! Offsets checked above, if enabled
  call observation_consistency_check_dri(set,ref_head,dri_head,cons,warned)
  !
end subroutine continuum_consistency_check
!
subroutine index_consistency_analysis_cont(cons,rname)
  use gbl_message
  use classcore_interfaces, except_this=>index_consistency_analysis_cont
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! For continuum data
  !---------------------------------------------------------------------
  type(consistency_t), intent(inout) :: cons   ! Performed actions, tolerances and results
  character(len=*),    intent(in)    :: rname  ! Calling routine name
  !
  if (cons%prob) then
     ! Only the parts that are inconsistent can be marked as checked
     if (cons%gen%prob) cons%gen%done = .true.
     if (cons%sou%prob) cons%sou%done = .true.
     if (cons%pos%prob) cons%pos%done = .true.
     if (cons%off%prob) cons%off%done = .true.
     if (cons%dri%prob) cons%dri%done = .true.
     call class_message(seve%e,rname,'Index is inconsistent')
  else
     ! The parts that have been checked are consistent
     if (cons%gen%check) cons%gen%done = .true.
     if (cons%sou%check) cons%sou%done = .true.
     if (cons%pos%check) cons%pos%done = .true.
     if (cons%off%check) cons%off%done = .true.
     if (cons%dri%check) cons%dri%done = .true.
     call class_message(seve%i,rname,'Index is consistent')
  endif
  !
end subroutine index_consistency_analysis_cont
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine index_consistency_check(set,line,error,user_function)
  use classcore_interfaces, except_this=>index_consistency_check
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Generic for spectroscopic or continuum data
  ! Support routine for command
  !     CONSISTENCY [/NOCHECK [SOURCE|POSITION|OFFSET|LINE|SPECTROSCOPY|
  !                            CALIBRATION|SWITCHING]]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='CONSISTENCY'
  !
  ! Select what will be checked according to user input
  call consistency_check_selection(set,line,1,cx%cons,error)
  if (error .or. cx%cons%prob) return
  !
  ! It happens after analysis that nothing needs to be checked...
  if (.not.cx%cons%check)  return
  !
  ! Check consistency according to selection
  call consistency_check_do(set,rname,cx,error,user_function)
  if (error)  return
  !
end subroutine index_consistency_check
!
subroutine consistency_check_do(set,rname,idx,error,user_function)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>consistency_check_do
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Generic for spectroscopic or continuum data
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  character(len=*),    intent(in)    :: rname
  type(optimize),      intent(inout) :: idx
  logical,             intent(inout) :: error
  logical,             external      :: user_function
  ! Local
  type(observation) :: obs
  integer(kind=entry_length) :: iobs,nobs
  type(time_t) :: time
  !
  ! Sanity check
  nobs = idx%next-1
  if (nobs.le.0) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
     return
  endif
  !
  ! Read first index spectrum to set its header as reference
  call init_obs(obs)
  call get_it(set,obs,idx%ind(1),user_function,error)
  if (error) return
  call sic_upper(obs%head%gen%teles)
  call sic_upper(obs%head%pos%sourc)
  call sic_upper(obs%head%spe%line)
  call copy_header(obs%head,idx%cons%head)
  !
  ! Set checking tolerances
  call consistency_tole(idx%cons%head,idx%cons)
  !
  ! Give user feedback on what will be done
  call consistency_print(set,idx%cons%head,idx%cons)
  !
  ! Loop on observations
  call gtime_init(time,nobs,error)
  if (error)  goto 100
  if (set%kind.eq.kind_spec) then
    do iobs = 1,nobs
      call gtime_current(time)
      ! Exit when asked by user
      call class_controlc(rname,error)
      if (error)  exit
      ! Read useful header sections
      call robs(obs,idx%ind(iobs),error)
      if (error) exit
      call rgen(set,obs,error)
      if (error) exit
      call rpos(set,obs,error)
      if (error) exit
      call rspec(set,obs,error)
      if (error) exit
      if (obs%head%presec(class_sec_cal_id)) then
        call rcal(set,obs,error)
        if (error) exit
      endif
      if (obs%head%presec(class_sec_swi_id)) then
        call rswi(set,obs,error)
        if (error) exit
      endif
      call sic_upper(obs%head%gen%teles)
      call sic_upper(obs%head%pos%sourc)
      call sic_upper(obs%head%spe%line)
      call spectrum_consistency_check(set,idx%cons%head,obs%head,idx%cons)
      ! There is a consistency problem => Exit the loop
      if (idx%cons%prob)  exit
    enddo
  elseif (set%kind.eq.kind_cont) then
    do iobs = 1,nobs
      call gtime_current(time)
      ! Exit when asked by user
      call class_controlc(rname,error)
      if (error)  exit
      ! Read useful header sections
      call robs(obs,idx%ind(iobs),error)
      if (error) exit
      call rgen(set,obs,error)
      if (error) exit
      call rpos(set,obs,error)
      if (error) exit
      call rcont(set,obs,error)
      if (error)  exit
      call sic_upper(obs%head%gen%teles)
      call sic_upper(obs%head%pos%sourc)
      call continuum_consistency_check(set,idx%cons%head,obs%head,idx%cons)
      ! There is a consistency problem => Exit the loop
      if (idx%cons%prob)  exit
    enddo
  else
    call class_message(seve%e,rname,'Unsupported kind of data')
    error = .true.
    goto 100
  endif
  !
  ! Feedback
  call index_consistency_analysis(set,idx%cons,rname)
  !
100 continue
  call free_obs(obs)
  !
end subroutine consistency_check_do
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 1D X axes computations, single or double precision
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine abscissa_velo_r4(head,velo,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_velo
  !    Given the velocity axis parameters in the observation header,
  ! fill the array 'velo' with appropriate velocities in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_velo'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: velo(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    velo(ichan) = head%spe%voff + (ichan-head%spe%rchan)*head%spe%vres
  enddo
  !
end subroutine abscissa_velo_r4
!
subroutine abscissa_velo_r8(head,velo,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_velo
  !    Given the velocity axis parameters in the observation header,
  ! fill the array 'velo' with appropriate velocities in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_velo'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: velo(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    velo(ichan) = head%spe%voff + (ichan-head%spe%rchan)*head%spe%vres
  enddo
  !
end subroutine abscissa_velo_r8
!
subroutine abscissa_sigoff_r4(head,soff,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_sigoff
  !    Given the signal frequency axis parameters in the observation
  ! header, fill the array 'soff' with appropriate signal frequency
  ! offsets in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_sigoff'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: soff(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    soff(ichan) = (ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_sigoff_r4
!
subroutine abscissa_sigoff_r8(head,soff,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_sigoff
  !    Given the signal frequency axis parameters in the observation
  ! header, fill the array 'soff' with appropriate signal frequency
  ! offsets in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_sigoff'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: soff(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    soff(ichan) = (ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_sigoff_r8
!
subroutine abscissa_imaoff_r4(head,ioff,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaoff
  !    Given the image frequency axis parameters in the observation
  ! header, fill the array 'ioff' with appropriate image frequency
  ! offsets in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_imaoff'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: ioff(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    ioff(ichan) = -(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_imaoff_r4
!
subroutine abscissa_imaoff_r8(head,ioff,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaoff
  !    Given the image frequency axis parameters in the observation
  ! header, fill the array 'ioff' with appropriate image frequency
  ! offsets in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_imaoff'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: ioff(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    ioff(ichan) = -(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_imaoff_r8
!
subroutine abscissa_sigabs_r4(head,sabs,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_sigabs
  !    Given the signal frequency axis parameters in the observation
  ! header, fill the array 'sabs' with appropriate absolute signal
  ! frequencies in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_sigabs'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: sabs(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    sabs(ichan) = head%spe%restf+(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_sigabs_r4
!
subroutine abscissa_sigabs_r8(head,sabs,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_sigabs
  !    Given the signal frequency axis parameters in the observation
  ! header, fill the array 'sabs' with appropriate absolute signal
  ! frequencies in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_sigabs'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: sabs(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    sabs(ichan) = head%spe%restf+(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_sigabs_r8
!
subroutine abscissa_imaabs_r4(head,iabs,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaabs
  !    Given the image frequency axis parameters in the observation
  ! header, fill the array 'iabs' with appropriate absolute image
  ! frequencies in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_imaabs'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: iabs(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    iabs(ichan) = head%spe%image-(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_imaabs_r4
!
subroutine abscissa_imaabs_r8(head,iabs,c1,c2)
  use gbl_message
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaabs
  !    Given the image frequency axis parameters in the observation
  ! header, fill the array 'iabs' with appropriate absolute image
  ! frequencies in the channel range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_imaabs'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: iabs(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  character(len=*), parameter :: rname='ABSCISSA'
  real(kind=8) :: dnu
  integer(kind=4) :: ichan
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    call class_message(seve%w,rname,'No Doppler correction applied')
    dnu = head%spe%fres
  endif
  !
  do ichan=c1,c2
    iabs(ichan) = head%spe%image-(ichan-head%spe%rchan)*dnu
  enddo
  !
end subroutine abscissa_imaabs_r8
!
subroutine abscissa_time_r4(head,time,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_time
  !    Given the time axis parameters in the observation header,
  ! fill the array 'time' with appropriate times in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_time'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: time(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    time(ichan) = head%dri%tref + (ichan-head%dri%rpoin)*head%dri%tres
  enddo
  !
end subroutine abscissa_time_r4
!
subroutine abscissa_time_r8(head,time,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_time
  !    Given the time axis parameters in the observation header,
  ! fill the array 'time' with appropriate times in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_time'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: time(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    time(ichan) = head%dri%tref + (ichan-head%dri%rpoin)*head%dri%tres
  enddo
  !
end subroutine abscissa_time_r8
!
subroutine abscissa_angl_r4(head,angl,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_angl
  !    Given the angle axis parameters in the observation header,
  ! fill the array 'angl' with appropriate angles in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Single precision version. Use generic entry point 'abscissa_angl'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=4),    intent(inout) :: angl(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    angl(ichan) = head%dri%aref + (ichan-head%dri%rpoin)*head%dri%ares
  enddo
  !
end subroutine abscissa_angl_r4
!
subroutine abscissa_angl_r8(head,angl,c1,c2)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_angl
  !    Given the angle axis parameters in the observation header,
  ! fill the array 'angl' with appropriate angles in the channel
  ! range c1 to c2 (assume c1<=c2)
  ! ---
  !   Double precision version. Use generic entry point 'abscissa_angl'
  ! to access this routine.
  !---------------------------------------------------------------------
  type(header),    intent(in)    :: head     !
  real(kind=8),    intent(inout) :: angl(*)  ! Array to be filled/updated
  integer(kind=4), intent(in)    :: c1,c2    ! Channel range
  ! Local
  integer(kind=4) :: ichan
  !
  do ichan=c1,c2
    angl(ichan) = head%dri%aref + (ichan-head%dri%rpoin)*head%dri%ares
  enddo
  !
end subroutine abscissa_angl_r8
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Scalar X value computations, single or double precision
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine abscissa_chan2velo_r4(head,chan,velo)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_chan2velo
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: chan  !
  real(kind=4), intent(out) :: velo  !
  !
  velo = (chan-head%spe%rchan)*head%spe%vres+head%spe%voff
  !
end subroutine abscissa_chan2velo_r4
!
subroutine abscissa_chan2velo_r8(head,chan,velo)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_chan2velo
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: chan  !
  real(kind=8), intent(out) :: velo  !
  !
  velo = (chan-head%spe%rchan)*head%spe%vres+head%spe%voff
  !
end subroutine abscissa_chan2velo_r8
!
subroutine abscissa_velo2chan_r4(head,velo,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_velo2chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: velo  !
  real(kind=4), intent(out) :: chan  !
  !
  chan = head%spe%rchan+(velo-head%spe%voff)/head%spe%vres
  !
end subroutine abscissa_velo2chan_r4
!
subroutine abscissa_velo2chan_r8(head,velo,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_velo2chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: velo  !
  real(kind=8), intent(out) :: chan  !
  !
  chan = head%spe%rchan+(velo-head%spe%voff)/head%spe%vres
  !
end subroutine abscissa_velo2chan_r8
!
subroutine abscissa_chan2sigabs_r4(head,chan,sigabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2sigabs
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: chan    !
  real(kind=4), intent(out) :: sigabs  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  sigabs = head%spe%restf+(chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2sigabs_r4
!
subroutine abscissa_chan2sigabs_r8_head(head,chan,sigabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2sigabs
  !  *** type(header) as argument ***
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: chan    !
  real(kind=8), intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs_r8_spe(head%spe,chan,sigabs)
  !
end subroutine abscissa_chan2sigabs_r8_head
!
subroutine abscissa_chan2sigabs_r8_spe(spe,chan,sigabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2sigabs
  !  *** type(class_spectro_t) as argument ***
  !--------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(in)  :: chan    !
  real(kind=8),          intent(out) :: sigabs  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (spe%doppler.ne.-1.d0) then
    dnu = spe%fres/(1.d0+spe%doppler)
  else
    dnu = spe%fres
  endif
  !
  sigabs = spe%restf+(chan-spe%rchan)*dnu
  !
end subroutine abscissa_chan2sigabs_r8_spe
!
subroutine abscissa_sigabs2chan_r4(head,sigabs,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs2chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: sigabs  !
  real(kind=4), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan+(sigabs-head%spe%restf)/dnu
  !
end subroutine abscissa_sigabs2chan_r4
!
subroutine abscissa_sigabs2chan_r8_head(head,sigabs,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs2chan
  !  *** type(header) as argument ***
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: sigabs  !
  real(kind=8), intent(out) :: chan    !
  !
  call abscissa_sigabs2chan_r8_spe(head%spe,sigabs,chan)
  !
end subroutine abscissa_sigabs2chan_r8_head
!
subroutine abscissa_sigabs2chan_r8_spe(spe,sigabs,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs2chan
  !  *** type(class_spectro_t) as argument ***
  !--------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(in)  :: sigabs  !
  real(kind=8),          intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (spe%doppler.ne.-1.d0) then
    dnu = spe%fres/(1.d0+spe%doppler)
  else
    dnu = spe%fres
  endif
  !
  chan = spe%rchan+(sigabs-spe%restf)/dnu
  !
end subroutine abscissa_sigabs2chan_r8_spe
!
subroutine abscissa_chan2sigoff_r4(head,chan,sigoff)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_chan2sigoff
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: chan    !
  real(kind=4), intent(out) :: sigoff  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  sigoff = (chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2sigoff_r4
!
subroutine abscissa_chan2sigoff_r8(head,chan,sigoff)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_chan2sigoff
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: chan    !
  real(kind=8), intent(out) :: sigoff  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  sigoff = (chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2sigoff_r8
!
subroutine abscissa_sigoff2chan_r4(head,sigoff,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_sigoff2chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: sigoff  !
  real(kind=4), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan+sigoff/dnu
  !
end subroutine abscissa_sigoff2chan_r4
!
subroutine abscissa_sigoff2chan_r8(head,sigoff,chan)
  use class_types
  !--------------------------------------------------------------------
  ! @ private-generic abscissa_sigoff2chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: sigoff  !
  real(kind=8), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan+sigoff/dnu
  !
end subroutine abscissa_sigoff2chan_r8
!
subroutine abscissa_chan2imaabs_r4(head,chan,imaabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2imaabs
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: chan    !
  real(kind=4), intent(out) :: imaabs  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  imaabs = head%spe%image-(chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2imaabs_r4
!
subroutine abscissa_chan2imaabs_r8_head(head,chan,imaabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2imaabs
  !  *** type(header) as argument ***
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: chan    !
  real(kind=8), intent(out) :: imaabs  !
  !
  call abscissa_chan2imaabs_r8_spe(head%spe,chan,imaabs)
  !
end subroutine abscissa_chan2imaabs_r8_head
!
subroutine abscissa_chan2imaabs_r8_spe(spe,chan,imaabs)
  use class_types
  !--------------------------------------------------------------------
  ! @ public-generic abscissa_chan2imaabs
  !  *** type(class_spectro_t) as argument ***
  !--------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(in)  :: chan    !
  real(kind=8),          intent(out) :: imaabs  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (spe%doppler.ne.-1.d0) then
    dnu = spe%fres/(1.d0+spe%doppler)
  else
    dnu = spe%fres
  endif
  !
  imaabs = spe%image-(chan-spe%rchan)*dnu
  !
end subroutine abscissa_chan2imaabs_r8_spe
!
subroutine abscissa_imaabs2chan_r4(head,imaabs,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaabs2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: imaabs  !
  real(kind=4), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan-(imaabs-head%spe%image)/dnu
  !
end subroutine abscissa_imaabs2chan_r4
!
subroutine abscissa_imaabs2chan_r8(head,imaabs,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaabs2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: imaabs  !
  real(kind=8), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan-(imaabs-head%spe%image)/dnu
  !
end subroutine abscissa_imaabs2chan_r8
!
subroutine abscissa_chan2imaoff_r4(head,chan,imaoff)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2imaoff
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: chan    !
  real(kind=4), intent(out) :: imaoff  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  imaoff = -(chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2imaoff_r4
!
subroutine abscissa_chan2imaoff_r8(head,chan,imaoff)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2imaoff
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: chan    !
  real(kind=8), intent(out) :: imaoff  !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  imaoff = -(chan-head%spe%rchan)*dnu
  !
end subroutine abscissa_chan2imaoff_r8
!
subroutine abscissa_imaoff2chan_r4(head,imaoff,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaoff2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=4), intent(in)  :: imaoff  !
  real(kind=4), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan-imaoff/dnu
  !
end subroutine abscissa_imaoff2chan_r4
!
subroutine abscissa_imaoff2chan_r8(head,imaoff,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_imaoff2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: imaoff  !
  real(kind=8), intent(out) :: chan    !
  ! Local
  real(kind=8) :: dnu
  !
  ! Doppler correction
  if (head%spe%doppler.ne.-1.d0) then
    dnu = head%spe%fres/(1.d0+head%spe%doppler)
  else
    dnu = head%spe%fres
  endif
  !
  chan = head%spe%rchan-imaoff/dnu
  !
end subroutine abscissa_imaoff2chan_r8
!
subroutine abscissa_chan2obsfre(head,chan,obsfre)
  use class_types
  !--------------------------------------------------------------------
  ! @ private
  ! Compute absolute observatory frequency at channel #chan
  !--------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(in)  :: chan    !
  real(kind=8), intent(out) :: obsfre  !
  ! Local
  real(kind=8) :: rf
  !
  ! fres: not Doppler corrected = in observatory frame
  ! restf: shifted to observatory frame
  rf = head%spe%restf*(1.d0+head%spe%doppler)
  !
  obsfre = rf+(chan-head%spe%rchan)*head%spe%fres
  !
end subroutine abscissa_chan2obsfre
!
subroutine abscissa_chan2angl_r4(head,chan,angl)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2angl
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: chan  !
  real(kind=4), intent(out) :: angl  !
  !
  angl = (chan-head%dri%rpoin)*head%dri%ares+head%dri%aref
  !
end subroutine abscissa_chan2angl_r4
!
subroutine abscissa_chan2angl_r8(head,chan,angl)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2angl
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: chan  !
  real(kind=8), intent(out) :: angl  !
  !
  angl = (chan-head%dri%rpoin)*head%dri%ares+head%dri%aref
  !
end subroutine abscissa_chan2angl_r8
!
subroutine abscissa_angl2chan_r4(head,angl,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_angl2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: angl  !
  real(kind=4), intent(out) :: chan  !
  !
  chan = head%dri%rpoin+(angl-head%dri%aref)/head%dri%ares
  !
end subroutine abscissa_angl2chan_r4
!
subroutine abscissa_angl2chan_r8(head,angl,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_angl2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: angl  !
  real(kind=8), intent(out) :: chan  !
  !
  chan = head%dri%rpoin+(angl-head%dri%aref)/head%dri%ares
  !
end subroutine abscissa_angl2chan_r8
!
subroutine abscissa_chan2time_r4(head,chan,time)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2time
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: chan  !
  real(kind=4), intent(out) :: time  !
  !
  time = (chan-head%dri%rpoin)*head%dri%tres+head%dri%tref
  !
end subroutine abscissa_chan2time_r4
!
subroutine abscissa_chan2time_r8(head,chan,time)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_chan2time
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: chan  !
  real(kind=8), intent(out) :: time  !
  !
  time = (chan-head%dri%rpoin)*head%dri%tres+head%dri%tref
  !
end subroutine abscissa_chan2time_r8
!
subroutine abscissa_time2chan_r4(head,time,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_time2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=4), intent(in)  :: time  !
  real(kind=4), intent(out) :: chan  !
  !
  chan = head%dri%rpoin+(time-head%dri%tref)/head%dri%tres
  !
end subroutine abscissa_time2chan_r4
!
subroutine abscissa_time2chan_r8(head,time,chan)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic abscissa_time2chan
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(in)  :: time  !
  real(kind=8), intent(out) :: chan  !
  !
  chan = head%dri%rpoin+(time-head%dri%tref)/head%dri%tres
  !
end subroutine abscissa_time2chan_r8
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine abscissa_any2chan(set,obs,val,chan)
  use gbl_constant
  use classcore_interfaces, except_this=>abscissa_any2chan
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Convert a X coordinate in current unit to channel value.
  ! Signal (F) and Image (I) frequencies are assumed to be offset
  ! frequencies. Support for spectro and continuum, and also for
  ! irregular axes.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set   !
  type(observation),   intent(in)  :: obs   !
  real(kind=8),        intent(in)  :: val   ! The value to be converted
  real(kind=8),        intent(out) :: chan  ! The corresponding channel
  ! Local
  integer(kind=4) :: ichan
  !
  if (obs%head%presec(class_sec_xcoo_id)) then
    ! Irregularly sampled X axis
    ! Interpolate: this must exist somewhere else...
    if (obs%datax(1).lt.obs%datax(2)) then
      if (val.lt.obs%datax(1)) then
        chan = 0.d0
      elseif (val.gt.obs%datax(obs%cnchan)) then
        chan = obs%cnchan+1.d0
      else
        do ichan=2,obs%cnchan
          if (val.lt.obs%datax(ichan)) exit
        enddo
        chan = real(ichan,kind=8) - ((obs%datax(ichan)-val)/(obs%datax(ichan)-obs%datax(ichan-1)))
      endif
    else
      if (val.lt.obs%datax(obs%cnchan)) then
        chan = obs%cnchan+1.d0
      elseif (val.gt.obs%datax(1)) then
        chan = 0.d0
      else
        do ichan=2,obs%cnchan
          if (val.gt.obs%datax(ichan)) exit
        enddo
        chan = real(ichan,kind=8) - ((obs%datax(ichan)-val)/(obs%datax(ichan)-obs%datax(ichan-1)))
      endif
    endif
  else
    ! Regularly sampled X axis
    if (obs%head%gen%kind.eq.kind_spec) then
      ! Spectroscopic data
      if (set%unitx(1).eq.'C') then
        chan = val
      elseif (set%unitx(1).eq.'V') then
        call abscissa_velo2chan(obs%head,val,chan)
      elseif (set%unitx(1).eq.'F') then
        call abscissa_sigoff2chan(obs%head,val,chan)
      elseif (set%unitx(1).eq.'I') then
        call abscissa_imaoff2chan(obs%head,val,chan)
      endif
    else
      ! Continuum data
      if (set%unitx(1).eq.'C') then
        chan = val
      elseif (set%unitx(1).eq.'T') then
        call abscissa_time2chan(obs%head,val,chan)
      elseif (set%unitx(1).eq.'A') then
        call abscissa_angl2chan(obs%head,val,chan)
      endif
    endif
  endif
  !
end subroutine abscissa_any2chan
!
subroutine abscissa_chan2any(set,obs,chan,val)
  use gbl_constant
  use classcore_interfaces, except_this=>abscissa_chan2any
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Convert a X coordinate from channel value to current unit.
  ! Signal (F) and Image (I) frequencies are assumed to be offset
  ! frequencies. Support for spectro and continuum, and also for
  ! irregular axes.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set   !
  type(observation),   intent(in)  :: obs   !
  real(kind=8),        intent(in)  :: chan  ! The channel to be converted
  real(kind=8),        intent(out) :: val   ! The corresponding value
  ! Local
  integer(kind=4) :: ichan
  !
  if (obs%head%presec(class_sec_xcoo_id)) then
    ! Irregularly sampled X axis
    ! Interpolate: this must exist somewhere else...
    if (chan.lt.1d0) then
      val = obs%datax(1)
    elseif (chan.gt.obs%cnchan) then
      val = obs%datax(obs%cnchan)
    else
      ichan = floor(chan)
      val = obs%datax(ichan) + (obs%datax(ichan+1)-obs%datax(ichan))*(ichan-chan)
    endif
  else
    ! Regularly sampled X axis
    if (obs%head%gen%kind.eq.kind_spec) then
      ! Spectroscopic data
      if (set%unitx(1).eq.'C') then
        val = chan
      elseif (set%unitx(1).eq.'V') then
        call abscissa_chan2velo(obs%head,chan,val)
      elseif (set%unitx(1).eq.'F') then
        call abscissa_chan2sigoff(obs%head,chan,val)
      elseif (set%unitx(1).eq.'I') then
        call abscissa_chan2imaoff(obs%head,chan,val)
      endif
    else
      ! Continuum data
      if (set%unitx(1).eq.'C') then
        val = chan
      elseif (set%unitx(1).eq.'T') then
        call abscissa_chan2time(obs%head,chan,val)
      elseif (set%unitx(1).eq.'A') then
        call abscissa_chan2angl(obs%head,chan,val)
      endif
    endif
  endif
  !
end subroutine abscissa_chan2any
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine abscissa_velo_left(head,velo)
  use classcore_interfaces, except_this=>abscissa_velo_left
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Compute the leftmost (channelwise) velocity of input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(out) :: velo  !
  !
  call abscissa_chan2velo(head,.5d0,velo)
  !
end subroutine abscissa_velo_left
!
subroutine abscissa_velo_right(head,velo)
  use classcore_interfaces, except_this=>abscissa_velo_right
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Compute the rightmost (channelwise) velocity of input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(out) :: velo  !
  !
  call abscissa_chan2velo(head,dble(head%spe%nchan)+.5d0,velo)
  !
end subroutine abscissa_velo_right
!
subroutine abscissa_sigabs_left_head(head,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_left_head
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_left
  ! Compute the leftmost (channelwise) absolute signal frequency of
  ! input spectrum
  !  *** type(header) as argument ***
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(head,.5d0,sigabs)
  !
end subroutine abscissa_sigabs_left_head
!
subroutine abscissa_sigabs_left_spe(spe,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_left_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_left
  ! Compute the leftmost (channelwise) absolute signal frequency of
  ! input spectrum
  !  *** type(class_spectro_t) as argument ***
  !---------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(spe,.5d0,sigabs)
  !
end subroutine abscissa_sigabs_left_spe
!
subroutine abscissa_sigabs_middle_head(head,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_middle_head
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_middle
  ! Compute the middle absolute signal frequency of input spectrum
  !  *** type(header) as argument ***
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(head,(dble(head%spe%nchan)+1.d0)/2.d0,sigabs)
  !
end subroutine abscissa_sigabs_middle_head
!
subroutine abscissa_sigabs_middle_spe(spe,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_middle_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_middle
  ! Compute the middle absolute signal frequency of input spectrum
  !  *** type(class_spectro_t) as argument ***
  !---------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(spe,(dble(spe%nchan)+1.d0)/2.d0,sigabs)
  !
end subroutine abscissa_sigabs_middle_spe
!
subroutine abscissa_sigabs_right_head(head,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_right_head
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_right
  ! Compute the rightmost (channelwise) absolute signal frequency of
  ! input spectrum
  !  *** type(header) as argument ***
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(head,dble(head%spe%nchan)+.5d0,sigabs)
  !
end subroutine abscissa_sigabs_right_head
!
subroutine abscissa_sigabs_right_spe(spe,sigabs)
  use classcore_interfaces, except_this=>abscissa_sigabs_right_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_sigabs_right
  ! Compute the rightmost (channelwise) absolute signal frequency of
  ! input spectrum
  !  *** type(class_spectro_t) as argument ***
  !---------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(out) :: sigabs  !
  !
  call abscissa_chan2sigabs(spe,dble(spe%nchan)+.5d0,sigabs)
  !
end subroutine abscissa_sigabs_right_spe
!
subroutine abscissa_imaabs_left(head,imaabs)
  use classcore_interfaces, except_this=>abscissa_imaabs_left
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the leftmost (channelwise) absolute image frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: imaabs  !
  !
  call abscissa_chan2imaabs(head,.5d0,imaabs)
  !
end subroutine abscissa_imaabs_left
!
subroutine abscissa_imaabs_middle_head(head,imaabs)
  use classcore_interfaces, except_this=>abscissa_imaabs_middle_head
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_imaabs_middle
  ! Compute the middle absolute image frequency of input spectrum
  !  *** type(header) as argument ***
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: imaabs  !
  !
  call abscissa_chan2imaabs(head,(dble(head%spe%nchan)+1.d0)/2.d0,imaabs)
  !
end subroutine abscissa_imaabs_middle_head
!
subroutine abscissa_imaabs_middle_spe(spe,imaabs)
  use classcore_interfaces, except_this=>abscissa_imaabs_middle_spe
  use class_types
  !---------------------------------------------------------------------
  ! @ public-generic abscissa_imaabs_middle
  ! Compute the middle absolute image frequency of input spectrum
  !  *** type(class_spectro_t) as argument ***
  !---------------------------------------------------------------------
  type(class_spectro_t), intent(in)  :: spe     !
  real(kind=8),          intent(out) :: imaabs  !
  !
  call abscissa_chan2imaabs(spe,(dble(spe%nchan)+1.d0)/2.d0,imaabs)
  !
end subroutine abscissa_imaabs_middle_spe
!
subroutine abscissa_imaabs_right(head,imaabs)
  use classcore_interfaces, except_this=>abscissa_imaabs_right
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the rightmost (channelwise) absolute image frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: imaabs  !
  !
  call abscissa_chan2imaabs(head,dble(head%spe%nchan)+.5d0,imaabs)
  !
end subroutine abscissa_imaabs_right
!
subroutine abscissa_sigoff_left(head,sigoff)
  use classcore_interfaces, except_this=>abscissa_sigoff_left
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the leftmost (channelwise) offset signal frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: sigoff  !
  !
  call abscissa_chan2sigoff(head,.5d0,sigoff)
  !
end subroutine abscissa_sigoff_left
!
subroutine abscissa_sigoff_right(head,sigoff)
  use classcore_interfaces, except_this=>abscissa_sigoff_right
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the rightmost (channelwise) offset signal frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: sigoff  !
  !
  call abscissa_chan2sigoff(head,dble(head%spe%nchan)+.5d0,sigoff)
  !
end subroutine abscissa_sigoff_right
!
subroutine abscissa_imaoff_left(head,imaoff)
  use classcore_interfaces, except_this=>abscissa_imaoff_left
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the leftmost (channelwise) offset image frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: imaoff  !
  !
  call abscissa_chan2imaoff(head,.5d0,imaoff)
  !
end subroutine abscissa_imaoff_left
!
subroutine abscissa_imaoff_right(head,imaoff)
  use classcore_interfaces, except_this=>abscissa_imaoff_right
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the rightmost (channelwise) offset image frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: imaoff  !
  !
  call abscissa_chan2imaoff(head,dble(head%spe%nchan)+.5d0,imaoff)
  !
end subroutine abscissa_imaoff_right
!
subroutine abscissa_obsfre_left(head,obsfre)
  use classcore_interfaces, except_this=>abscissa_obsfre_left
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the leftmost (channelwise) absolute observatory frequency of
  ! input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: obsfre  !
  !
  call abscissa_chan2obsfre(head,.5d0,obsfre)
  !
end subroutine abscissa_obsfre_left
!
subroutine abscissa_obsfre_middle(head,obsfre)
  use classcore_interfaces, except_this=>abscissa_obsfre_middle
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the middle absolute observatory frequency of input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: obsfre  !
  !
  call abscissa_chan2obsfre(head,(dble(head%spe%nchan)+1.d0)/2.d0,obsfre)
  !
end subroutine abscissa_obsfre_middle
!
subroutine abscissa_obsfre_right(head,obsfre)
  use classcore_interfaces, except_this=>abscissa_obsfre_right
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the rightmost (channelwise) absolute observatory frequency
  ! of input spectrum
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head    !
  real(kind=8), intent(out) :: obsfre  !
  !
  call abscissa_chan2obsfre(head,dble(head%spe%nchan)+.5d0,obsfre)
  !
end subroutine abscissa_obsfre_right
!
subroutine abscissa_angl_left(head,angl)
  use classcore_interfaces, except_this=>abscissa_angl_left
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the leftmost (channelwise) position angle of input drift
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(out) :: angl  !
  !
  call abscissa_chan2angl(head,.5d0,angl)
  !
end subroutine abscissa_angl_left
!
subroutine abscissa_angl_right(head,angl)
  use classcore_interfaces, except_this=>abscissa_angl_right
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the rightmost (channelwise) position angle of input drift
  !---------------------------------------------------------------------
  type(header), intent(in)  :: head  !
  real(kind=8), intent(out) :: angl  !
  !
  call abscissa_chan2angl(head,dble(head%dri%npoin)+.5d0,angl)
  !
end subroutine abscissa_angl_right
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine contng (ndp,xd,yd,ntr,ipt,nli,ipl,iwl,iwp,wk)
  use gcont_interfaces, except_this=>contng
  use gcont_contour
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !	This subroutine performs triangulation.  It divides the X-Y
  !	plane into a number of triangles according to given data
  !	points in the plane, determines line segments that form the
  !	border of data area, and determines the triangle numbers
  !	corresponding to the border line segments.
  !	At completion, point numbers of the vertexes of each triangle
  !	are listed counter-clockwise.  Point numbers of the end points
  !	of each border line segment are listed counter-clockwise,
  !	listing order of the line segments being counter-clockwise.
  ! Arguments :
  !	NDP 	I	Number of data points			Input
  !	XD  	R*4 (*)	Array of dimension NDP containing the
  !			X coordinates of the data points	Input
  !	YD  	R*4 (*) Array of Y coordinates			Input
  !	NTR  	I	Number of triangles			Output
  !	IPT 	I (*)	Array of dimension 6*NDP-15, where the
  !			point numbers of the vertexes of the
  !			(IT)th triangle are to be stored as the
  !			(3*IT-2)nd, (3*IT-1)st, and (3*IT)th
  !			elements, IT=1,2,...,NTR		Output
  !	NLI  	I	Number of border line segments		Output
  !	IPL 	I (*)	Array of dimension 6*NDP, where the point
  !			numbers of the end points of the (IL)th
  !			border line segment and its respective
  !			triangle number are to be stored as the
  !			(3*IL-2)nd, (3*IL-1)st, and (3*IL)th
  !			elements, IL=1,2,..., NLI.		Output
  !	IWL 	I (*)	Array of dimension 18*NDP used
  !			internally as a work area
  !	IWP 	I (*)	Array of dimension NDP used
  !			internally as a work area
  !	WK  	R*4 (*)	Array of dimension NDP used
  !			internally as a work area.
  ! No subroutine referenced
  !---------------------------------------------------------------------
  integer :: ndp                    !
  real :: xd(*)                     !
  real :: yd(*)                     !
  integer :: ntr                    !
  integer :: ipt(*)                 !
  integer :: nli                    !
  integer :: ipl(*)                 !
  integer :: iwl(*)                 !
  integer :: iwp(*)                 !
  real :: wk(*)                     !
  ! Local
  character(len=*), parameter :: rname='RANDOM'
  ! real dsqf,u1,v1,u2,v2,u3,v3,side
  character(len=72) :: messag
  integer :: itf(2)
  integer :: nrep, ndpm1, ipmn1, ipmn2, ip1, ip1p1, ip2
  real :: ratio, dsqmn, x1, y1, dsqi, dsq12, xdmp, ydmp, dsqmx
  integer :: jp1, jpmn, jp2, its, jp, ip, jpmx, jpc, ip3
  integer :: nt0, ntt3, nl0, nlt3, nsh, nsht3, jp2t3
  real :: ar, dx21, dy21, dxmn, dymn, armn, dxmx, dymx, armx
  integer :: jp3t3, jwl, ipl1, ipl2, it, nln, nlnt3, itt3
  real :: dx, dy
  integer :: ipti, nlf, ntt3p3, irep, ilf, ilft2, ntf
  integer :: itt3r, ipt1, ipt2, ipt3, it1t3, ipti1, it2t3, ipti2
  integer :: jlt3, iplj1, iplj2, nlfc, jwl1mn, nlft2, jwl1
  ! Data
  data ratio /1.0e-6/, nrep/100/
  !
  ! Statement functions
  !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
  !      SIDE(U1,V1,U2,V2,U3,V3) = (V3-V1)*(U2-U1)-(U3-U1)*(V2-V1)
  !
  ! Preliminary processing
  ndpm1 = ndp-1
  !
  ! Determines the closest pair of data points and their midpoint.
  dsqmn = dsqf(xd(1),yd(1),xd(2),yd(2))
  ipmn1 = 1
  ipmn2 = 2
  do ip1=1,ndpm1
    x1 = xd(ip1)
    y1 = yd(ip1)
    ip1p1 = ip1+1
    do ip2=ip1p1,ndp
      dsqi = dsqf(x1,y1,xd(ip2),yd(ip2))
      if (dsqi .ne. 0.) go to  120
      !
      ! Error, identical input data points
      write(messag,1000) ip1,ip2
      call gcont_message(seve%e,rname,messag)
      irec = 4
      return
      !
120   continue
      if (dsqi .ge. dsqmn) go to  130
      dsqmn = dsqi
      ipmn1 = ip1
      ipmn2 = ip2
130   continue
    enddo                      ! 130
  enddo
  dsq12 = dsqmn
  xdmp = (xd(ipmn1)+xd(ipmn2))/2.0
  ydmp = (yd(ipmn1)+yd(ipmn2))/2.0
  !
  ! Sorts the other (NDP-2) data points in ascending order of
  ! distance from the midpoint and stores the sorted data point
  ! numbers in the IWP array.
  jp1 = 2
  do ip1=1,ndp
    if (ip1.eq.ipmn1 .or. ip1.eq.ipmn2)  go to 150
    jp1 = jp1+1
    iwp(jp1) = ip1
    wk(jp1) = dsqf(xdmp,ydmp,xd(ip1),yd(ip1))
150 continue
  enddo
  do jp1=3,ndpm1
    dsqmn = wk(jp1)
    jpmn = jp1
    do jp2=jp1,ndp
      if (wk(jp2) .ge. dsqmn)  go to 160
      dsqmn = wk(jp2)
      jpmn = jp2
160   continue
    enddo
    its = iwp(jp1)
    iwp(jp1) = iwp(jpmn)
    iwp(jpmn) = its
    wk(jpmn) = wk(jp1)
  enddo
  !
  ! If necessary, modifies the ordering in such a way that the
  ! first three data points are not collinear.
  ar = dsq12*ratio
  x1 = xd(ipmn1)
  y1 = yd(ipmn1)
  dx21 = xd(ipmn2)-x1
  dy21 = yd(ipmn2)-y1
  do jp=3,ndp
    ip = iwp(jp)
    if (abs((yd(ip)-y1)*dx21-(xd(ip)-x1)*dy21) .gt. ar) then
      jpmx = jp
      go to 190
    endif
  enddo
  !
  ! Error: Collinear data points
  call gcont_message(seve%e,rname,'All data points are collinear')
  irec = 3
190 continue
  if (jpmx.eq.3)  go to 210
  !      jpmx = jp
  jp = jpmx+1
  do jpc=4,jpmx
    jp = jp-1
    iwp(jp) = iwp(jp-1)
  enddo
  iwp(3) = ip
  !
  ! Forms the first triangle.  stores point numbers of the ver-
  ! texes of the triangle in the IPT array, and stores point num-
  ! bers of the border line segments and the triangle number in
  ! the IPL array.
210 ip1 = ipmn1
  ip2 = ipmn2
  ip3 = iwp(3)
  if (side(xd(ip1),yd(ip1),xd(ip2),yd(ip2),xd(ip3),yd(ip3)).ge.0.0)  go to 220
  ip1 = ipmn2
  ip2 = ipmn1
220 nt0 = 1
  ntt3 = 3
  ipt(1) = ip1
  ipt(2) = ip2
  ipt(3) = ip3
  nl0 = 3
  nlt3 = 9
  ipl(1) = ip1
  ipl(2) = ip2
  ipl(3) = 1
  ipl(4) = ip2
  ipl(5) = ip3
  ipl(6) = 1
  ipl(7) = ip3
  ipl(8) = ip1
  ipl(9) = 1
  !
  ! Adds the remaining (NDP-3) data points, one by one.
  do jp1=4,ndp                 ! DO 400
    ip1 = iwp(jp1)
    x1 = xd(ip1)
    y1 = yd(ip1)
    !
    ! Determines the visible border line segments.
    ip2 = ipl(1)
    jpmn = 1
    dxmn = xd(ip2)-x1
    dymn = yd(ip2)-y1
    dsqmn = dxmn*dxmn+dymn*dymn
    armn = dsqmn*ratio
    jpmx = 1
    dxmx = dxmn
    dymx = dymn
    dsqmx = dsqmn
    armx = armn
    do jp2=2,nl0               ! DO 240
      ip2 = ipl(3*jp2-2)
      dx = xd(ip2)-x1
      dy = yd(ip2)-y1
      ar = dy*dxmn-dx*dymn
      if (ar.gt.armn)  go to 230
      dsqi = dx*dx+dy*dy
      if (ar.ge.(-armn) .and. dsqi.ge.dsqmn)  go to 230
      jpmn = jp2
      dxmn = dx
      dymn = dy
      dsqmn = dsqi
      armn = dsqmn*ratio
230   ar = dy*dxmx-dx*dymx
      if (ar.lt.(-armx))  go to 240
      dsqi = dx*dx+dy*dy
      if (ar.le.armx .and. dsqi.ge.dsqmx)  go to 240
      jpmx = jp2
      dxmx = dx
      dymx = dy
      dsqmx = dsqi
      armx = dsqmx*ratio
240   continue
    enddo
    if (jpmx .lt. jpmn) jpmx = jpmx+nl0
    nsh = jpmn-1
    if (nsh .le. 0)  go to 270
    !
    ! Shifts (rotates) the IPL array to have the invisible border
    ! line segments contained in the first part of the IPL array.
    nsht3 = nsh*3
    do  jp2t3=3,nsht3,3
      jp3t3 = jp2t3+nlt3
      ipl(jp3t3-2) = ipl(jp2t3-2)
      ipl(jp3t3-1) = ipl(jp2t3-1)
      ipl(jp3t3) = ipl(jp2t3)
    enddo
    do  jp2t3=3,nlt3,3
      jp3t3 = jp2t3+nsht3
      ipl(jp2t3-2) = ipl(jp3t3-2)
      ipl(jp2t3-1) = ipl(jp3t3-1)
      ipl(jp2t3) = ipl(jp3t3)
    enddo
    jpmx = jpmx-nsh
    !
    ! Adds triangles to the IPT array, updates border line
    ! segments in the IPL array, and sets flags for the border
    ! line segments to be reexamined in the IWL array.
270 jwl = 0
    do jp2=jpmx,nl0
      jp2t3 = jp2*3
      ipl1 = ipl(jp2t3-2)
      ipl2 = ipl(jp2t3-1)
      it = ipl(jp2t3)
      !
      ! Adds a triangle to the IPT array.
      nt0 = nt0+1
      ntt3 = ntt3+3
      ipt(ntt3-2) = ipl2
      ipt(ntt3-1) = ipl1
      ipt(ntt3) = ip1
      !
      ! Updates border line segments in the IPL array.
      if (jp2 .ne. jpmx)  go to 280
      ipl(jp2t3-1) = ip1
      ipl(jp2t3) = nt0
280   continue
      if (jp2 .ne. nl0)  go to 290
      nln = jpmx+1
      nlnt3 = nln*3
      ipl(nlnt3-2) = ip1
      ipl(nlnt3-1) = ipl(1)
      ipl(nlnt3) = nt0
      !
      ! Determines the vertex that does not lie on the border
      ! line segments.
290   itt3 = it*3
      ipti = ipt(itt3-2)
      if (ipti.ne.ipl1 .and. ipti.ne.ipl2)  go to 300
      ipti = ipt(itt3-1)
      if (ipti.ne.ipl1 .and. ipti.ne.ipl2)  go to 300
      ipti = ipt(itt3)
      !
      ! Checks if the exchange is necessary.
300   continue
      if (conxch(xd,yd,ip1,ipti,ipl1,ipl2).eq.0)  go to 310
      !
      ! Modifies the IPT array when necessary.
      ipt(itt3-2) = ipti
      ipt(itt3-1) = ipl1
      ipt(itt3) = ip1
      ipt(ntt3-1) = ipti
      if (jp2 .eq. jpmx) ipl(jp2t3) = it
      if (jp2.eq.nl0 .and. ipl(3).eq.it) ipl(3) = nt0
      !
      ! Sets flags in the IWL array.
      jwl = jwl+4
      iwl(jwl-3) = ipl1
      iwl(jwl-2) = ipti
      iwl(jwl-1) = ipti
      iwl(jwl) = ipl2
310   continue
    enddo
    nl0 = nln
    nlt3 = nlnt3
    nlf = jwl/2
    if (nlf .eq. 0)  go to 400
    !
    ! Improves triangulation.
    ntt3p3 = ntt3+3
    do irep=1,nrep
      do ilf=1,nlf
        ilft2 = ilf*2
        ipl1 = iwl(ilft2-1)
        ipl2 = iwl(ilft2)
        !
        ! Locates in the IPT array two triangles on both sides of
        ! the flagged line segment.
        ntf = 0
        do itt3r=3,ntt3,3
          itt3 = ntt3p3-itt3r
          ipt1 = ipt(itt3-2)
          ipt2 = ipt(itt3-1)
          ipt3 = ipt(itt3)
          if (ipl1.ne.ipt1 .and. ipl1.ne.ipt2 .and. ipl1.ne.ipt3)  go to 320
          if (ipl2.ne.ipt1 .and. ipl2.ne.ipt2 .and. ipl2.ne.ipt3)  go to 320
          ntf = ntf+1
          itf(ntf) = itt3/3
          if (ntf.eq.2)  go to 330
320       continue
        enddo
        if (ntf.lt.2) go to 370
        !
        ! Determines the vertexes of the triangles that do not lie
        ! on the line segment.
330     it1t3 = itf(1)*3
        ipti1 = ipt(it1t3-2)
        if (ipti1.ne.ipl1 .and. ipti1.ne.ipl2) go to  340
        ipti1 = ipt(it1t3-1)
        if (ipti1.ne.ipl1 .and. ipti1.ne.ipl2) go to  340
        ipti1 = ipt(it1t3)
340     it2t3 = itf(2)*3
        ipti2 = ipt(it2t3-2)
        if (ipti2.ne.ipl1 .and. ipti2.ne.ipl2) go to  350
        ipti2 = ipt(it2t3-1)
        if (ipti2.ne.ipl1 .and. ipti2.ne.ipl2) go to  350
        ipti2 = ipt(it2t3)
        !
        ! Checks if the exchange is necessary.
350     continue
        if (conxch(xd,yd,ipti1,ipti2,ipl1,ipl2).eq.0)  go to 370
        !
        ! Modifies the IPT array when necessary.
        ipt(it1t3-2) = ipti1
        ipt(it1t3-1) = ipti2
        ipt(it1t3) = ipl1
        ipt(it2t3-2) = ipti2
        ipt(it2t3-1) = ipti1
        ipt(it2t3) = ipl2
        !
        ! Sets new flags.
        jwl = jwl+8
        iwl(jwl-7) = ipl1
        iwl(jwl-6) = ipti1
        iwl(jwl-5) = ipti1
        iwl(jwl-4) = ipl2
        iwl(jwl-3) = ipl2
        iwl(jwl-2) = ipti2
        iwl(jwl-1) = ipti2
        iwl(jwl) = ipl1
        do jlt3=3,nlt3,3
          iplj1 = ipl(jlt3-2)
          iplj2 = ipl(jlt3-1)
          if ((iplj1.eq.ipl1 .and. iplj2.eq.ipti2) .or.  &
              (iplj2.eq.ipl1 .and. iplj1.eq.ipti2))  ipl(jlt3) = itf(1)
          if ((iplj1.eq.ipl2 .and. iplj2.eq.ipti1) .or.  &
              (iplj2.eq.ipl2 .and. iplj1.eq.ipti1))  ipl(jlt3) = itf(2)
        enddo
370     continue
      enddo
      nlfc = nlf
      nlf = jwl/2
      if (nlf.eq.nlfc)  go to 400
      !
      ! Resets the IWL array for the next round.
      !
      jwl = 0
      jwl1mn = (nlfc+1)*2
      nlft2 = nlf*2
      do jwl1=jwl1mn,nlft2,2
        jwl = jwl+2
        iwl(jwl-1) = iwl(jwl1-1)
        iwl(jwl) = iwl(jwl1)
      enddo
      nlf = jwl/2
    enddo
400 continue
  enddo
  !
  ! Rearrange the IPT array so that the vertexes of each triangle
  ! are listed counter-clockwise.
  do  itt3=3,ntt3,3
    ip1 = ipt(itt3-2)
    ip2 = ipt(itt3-1)
    ip3 = ipt(itt3)
    if (side(xd(ip1),yd(ip1),xd(ip2),yd(ip2),xd(ip3),yd(ip3)).ge.0.0)  go to 410
    ipt(itt3-2) = ip2
    ipt(itt3-1) = ip1
410 continue
  enddo
  ntr = nt0
  nli = nl0
  return
1000 format('Identical input data points found at ',i5,' and ',i5)
  !
contains
  real function dsqf(u1,v1,u2,v2)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    dsqf  = (u2-u1)**2+(v2-v1)**2
  end function dsqf
  !
  real function side(u1,v1,u2,v2,u3,v3)
    real :: u1                      !
    real :: v1                      !
    real :: u2                      !
    real :: v2                      !
    real :: u3                      !
    real :: v3                      !
    side = (v3-v1)*(u2-u1)-(u3-u1)*(v2-v1)
  end function side
  !
end subroutine contng

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_touch
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_messaging
  !
  public :: touch
  private
  !
  type :: touch_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
   contains
     procedure, public  :: register => cubeadm_touch_register
     procedure, private :: parse    => cubeadm_touch_parse
     procedure, private :: main     => cubeadm_touch_main
  end type touch_comm_t
  type(touch_comm_t) :: touch
  !
  type touch_user_t
     type(cubeid_user_t) :: cubeids
   contains
     procedure, private :: toprog => cubeadm_touch_user_toprog
  end type touch_user_t
  !
  type touch_prog_t
     type(cube_t), pointer :: cube
   contains
     procedure, private :: data => cubeadm_touch_prog_data
  end type touch_prog_t
  !
contains
  !
  subroutine cubeadm_touch_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(touch_user_t) :: user
    character(len=*), parameter :: rname='TOUCH>COMMAND'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call touch%parse(line,user,error)
    if (error) return
    call touch%main(user,error)
    if (error) continue
  end subroutine cubeadm_touch_command
  !
  subroutine cubeadm_touch_register(comm,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(touch_comm_t), intent(inout) :: comm
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: cube
    character(len=*), parameter :: rname='TOUCH>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'TOUCH','[CubeId]',&
         'Touch the file so that its data is pre-loaded in memory',&
         'This only makes sense if the input files are accessible in memory mode.',&
         cubeadm_touch_command,&
         comm%comm,&
         error)
    if (error) return
    call cube%register(&
         'CUBE',&
         'Any cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&  ! An access with no enforced order
         comm%cube,&
         error)
    if (error) return
  end subroutine cubeadm_touch_register
  !
  subroutine cubeadm_touch_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(touch_comm_t), intent(in)    :: comm
    character(len=*),    intent(in)    :: line
    type(touch_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOUCH>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeadm_touch_parse
  !
  subroutine cubeadm_touch_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_comm_t), intent(in)    :: comm
    type(touch_user_t),  intent(inout) :: user
    logical,             intent(inout) :: error
    !
    type(touch_prog_t) :: prog
    character(len=*), parameter :: rname='TOUCH>MAIN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubeadm_touch_main
  !
  subroutine cubeadm_touch_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_user_t), intent(in)    :: user
    type(touch_comm_t),  intent(in)    :: comm
    type(touch_prog_t),  intent(out)   :: prog
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='TOUCH>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
  end subroutine cubeadm_touch_user_toprog
  !
  subroutine cubeadm_touch_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(touch_prog_t), intent(inout) :: prog
    logical,             intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    logical :: status
    character(len=*), parameter :: rname='TOUCH>PROG>DATA'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    ! Touch is done by preparing a first iteration (i.e. prepare
    ! the appropriate buffers, namely load the cube in memory)
    status = cubeadm_dataiterate_all(iter,error)
    if (error)  return
  end subroutine cubeadm_touch_prog_data
  !
end module cubeadm_touch
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! EXPAND_MACRO:
!
!     SIC EXPAND infilename outfilename
!
!     Purpose: Add the langage name before each command of the macro
!              file "infilename" and write the results into the new
!              macro file "outfilename".
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine expand_macro(line,error)
  use sic_interfaces, except_this=>expand_macro
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=256) :: infile,outfile,chain
  character(len=1024) :: ligne,long,space
  character(len=16) :: command
  integer :: ier,nb,nc,nl,nk,lun1,lun2
  logical :: readonly=.true.
  logical :: readwrite=.false.
  character(len=10) :: rname = 'SIC_EXPAND'
  data space /' '/
  !
  call sic_ch(line,0,2,chain,nl,.true.,error)
  if (error) then
     call sic_message(seve%e,rname,'Input macro name mandatory')
     return
  endif
  call sic_parse_file(chain,' ','.pro',infile)
  ier = sic_getlun(lun1)
  ier = sic_open(lun1,infile,'OLD',readonly)
  if (ier.ne.0) then
     call putios('E-SIC_EXPAND,  ',ier)
     error = .true.
     return
  endif
  !
  call sic_ch(line,0,3,chain,nl,.true.,error)
  call sic_parse_file(chain,' ','.pro',outfile)
  if (error) then
     call sic_message(seve%e,rname,'Output macro name mandatory')
     return
  endif
  ier = sic_getlun(lun2)
  ier = sic_open(lun2,outfile,'NEW',readwrite)
  if (ier.ne.0) then
     call putios('E-SIC_EXPAND,  ',ier)
     error = .true.
     return
  endif
  rewind(lun2)
  !
  do while (.true.)
     nl = 0
     read(lun1,'(A)',iostat=ier) ligne
     if (ier.ne.0) exit
     nl = len_trim(ligne)
     if (nl.eq.0) then
        write(lun2,'(A)') '!'
     else
        ! nb: position where the line starts (ie first non-space character)
        ! nc: position where the line first word ends
        ! nk: First word length
        ! nl: Line length
        long = ' '
        nc = 1
        do while ((nc.le.nl).and.(ligne(nc:nc).eq.' '))
           nc = nc+1
        enddo
        nb = nc-1
        nk = 1
        do while ((nc.le.nl).and.(ligne(nc:nc).ne.' '))
           long(nk:nk) = ligne(nc:nc)
           nk = nk+1
           nc = nc+1
        enddo
        nk = nk-1
        call sic_upper(long)
!        print *,"ligne",ligne
!        print *,"long",long
        !
        ! Expand it
        error = .false.
        command = ' '
        if (long(1:1).eq.'!') then
           write (lun2,'(A)') ligne(1:nl)
        else
           call sic_find(command,long,nk,error)
!          print *,"command",command
!          print *,"long",long
           if (.not.error) then
              if (long(1:3).eq.'SIC') then
                 write (lun2,'(A)') ligne(1:nl)
              else
                 call sic_lower(long)
                 if (nb.ne.0) then
                    write (lun2,'(A,A,A)') space(1:nb), long(1:nk), ligne(nc:nl)
                 else
                    write (lun2,'(A,A)') long(1:nk), ligne(nc:nl)
                 endif
              endif
           else
              call sic_message(seve%e,rname,ligne(1:nl))
              write (lun2,'(A)') ligne(1:nl)
           endif
        endif
     endif
  enddo
  !
  close(unit=lun2)
  call sic_frelun(lun2)
  close(unit=lun1)
  call sic_frelun(lun1)
  error = .false.
end subroutine expand_macro
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_read_subscan_data(imbf,subs,tochunk,databuf,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_read_subscan_data
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ public
  ! Read part of the DATA column from the current subscan (i.e. the
  ! current one CFITSIO is positioned in), and implicitely convert it
  ! in chunksets.
  !---------------------------------------------------------------------
  type(imbfits_t),         intent(in)    :: imbf
  type(imbfits_subscan_t), intent(in)    :: subs
  logical,                 intent(in)    :: tochunk
  type(data_buffer_t),     intent(inout) :: databuf
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='READ>SUBSCAN>DATA'
  integer(kind=4) :: nchan,npix
  type(range_t) :: drange
  !
  if (databuf%time%cur%n.eq.0) then
    ! We actually want a warning (no error), but we have to check twice
    ! the subsequent protection for 0-sized arrays...
    call mrtcal_message(seve%e,rname,'Nothing to read')
    error = .true.
    return
  endif
  !
  ! 1) Data only
  nchan = subs%backdata%head%channels%val
  npix  = 1  ! ZZZ TBD: set correctly
  ! Compute DATA range to read from compressed range:
  call mrtcal_bookkeeping_compr2uncompr(databuf%time%cur,  &
    subs%backdata%table%backpoin%val,drange,error)
  if (error)  return
  call imbfits_read_data(rname,         &
                         imbf%file,     &
                         nchan,         &
                         npix,          &
                         drange%first,  &
                         drange%n,      &  ! Number of non-compressed DATA rows to read
                         databuf%imbf,  &
                         error)
  if (error)  return
  !
  if (tochunk) then
    ! 2) Convert in chunk sets
    call mrtcal_chunksets_from_data(imbf,subs,databuf,error)
    if (error)  return
  endif
  !
end subroutine mrtcal_read_subscan_data
!
subroutine mrtcal_free_subscan_data(databuf,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_free_subscan_data
  use mrtcal_buffer_types
  !---------------------------------------------------------------------
  ! @ private
  ! Free of the DATA column from the current subscan, and its conversion
  ! in chunksets.
  !---------------------------------------------------------------------
  type(data_buffer_t), intent(inout) :: databuf
  logical,             intent(inout) :: error
  !
  ! 1) Data only
  call imbfits_free_data(databuf%imbf,error)
  if (error)  return
  !
  ! 2) Conversion in chunk sets
  call databuf%mrtc%free(error)
  if (error)  return
  !
end subroutine mrtcal_free_subscan_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program reproject
  use gildas_def
  use image_def
  use gbl_format
  use gbl_constant
  use phys_const
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GDF Stand alone program
  !  Resample an input image to a different projection system. Now
  ! accepts EPOCH conversion for Equatorials. Forced interpolation to
  ! bilinear.
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: pname = 'REPROJECT'
  character(len=filename_length) :: namein,namete,nameout
  character(len=80) :: center_1,center_2
  logical :: error
  integer(kind=4) :: nkey,ier,sys_code
  integer(kind=8) :: space_gildas
  integer(kind=4), parameter :: msvoc=3
  character(len=16) :: pvocab(0:mproj),svocab(msvoc),key,argproj,argsyst,newsystem
  character(len=40) :: systchain
  character(len=132) :: chain
  type(gildas) :: in,tem,out
  integer(kind=4) :: n, dim(2), il, ib
  integer(kind=size_length) :: melem
  real(kind=4) :: arr(2),newepoch
  real(kind=8) :: center(2),angle,conv(6), convertx(3,4), converty(3,4)
  logical :: change,template
  real(kind=8), allocatable :: work1(:,:),work2(:,:)
  character(len=256) :: mess
  ! Data
  data conv/6*0/
  data svocab/'UNCHANGED','EQUATORIAL','GALACTIC'/
  !
  call gildas_open
  call gildas_char('Z_NAME$',namein)
  call gildas_char('X_NAME$',nameout)
  call gildas_logi('TEMPLATE$',template,1)
  if (template) then
    call gildas_char('Y_NAME$',namete)
  else
    call gildas_char('PROJECTION$',argproj)
    call gildas_char('SYSTEM$',systchain)
    call gildas_char('CENTER_1$',center_1)
    call gildas_char('CENTER_2$',center_2)
    call gildas_dble('ANGLE$',angle,1)
    call gildas_inte('DIMENSIONS$',dim,2)
    call gildas_dble('AXIS_1$',conv(1:3),3)
    call gildas_dble('AXIS_2$',conv(4:6),3)
  endif
  call gildas_logi('CHANGE$',change,1)
  if (change) call gildas_real('BLANKING$',arr,2)
  call gildas_close
  !
  call gildas_null(in)
  call gildas_null(tem)
  call gildas_null(out)
  !
  in%gil%ndim = 0
  in%gil%form = fmt_r4
  call gdf_read_gildas(in,namein,'.gdf',error,rank=0)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  call sanity_check(in,error)
  if (error)  goto 100
  !
  ! Copy input header into output X header
  call gdf_copy_header(in,out,error)
  !
  ! Now define output
  if (template) then
    ! Whole header taken from template
    call gdf_read_gildas(tem,namete,'.gdf',error,data=.false.)
    if (error) then
      call gagout('F-'//pname//',  Cannot read template file')
      goto 100
    endif
    call sanity_check(tem,error)
    if (error)  goto 100
    out%char%syst = tem%char%syst
    out%gil%ra   = tem%gil%ra
    out%gil%dec  = tem%gil%dec
    out%gil%lii  = tem%gil%lii
    out%gil%bii  = tem%gil%bii
    out%gil%epoc = tem%gil%epoc
    out%gil%ptyp = tem%gil%ptyp
    out%gil%a0   = tem%gil%a0
    out%gil%d0   = tem%gil%d0
    out%gil%pang = tem%gil%pang
    out%char%code(out%gil%xaxi) = tem%char%code(tem%gil%xaxi)
    out%char%code(out%gil%yaxi) = tem%char%code(tem%gil%yaxi)
    out%gil%dim(out%gil%xaxi) = tem%gil%dim(tem%gil%xaxi)
    out%gil%dim(out%gil%yaxi) = tem%gil%dim(tem%gil%yaxi)
    out%loca%size = out%gil%dim(1)*out%gil%dim(2)*out%gil%dim(3)*out%gil%dim(4)
    out%gil%proj_words = tem%gil%proj_words
    call r8tor8 (out%gil%convert,convertx,12)
    call r8tor8 (tem%gil%convert,converty,12)
    convertx(:,out%gil%xaxi) = converty(:,tem%gil%xaxi)
    convertx(:,out%gil%yaxi) = converty(:,tem%gil%yaxi)
    call r8tor8 (convertx,out%gil%convert,12) 
    call r8tor8 (converty,tem%gil%convert,12) 
    !
    call get_sys_code(in,out,sys_code)
  endif  ! template
  !
  n = lenc(nameout)
  call sic_parsef(nameout(1:n),out%file,' ','.gdf')
  if (.not.template) then
    ! Header copied from input file, and modified according to inputs
    call gdf_copy_header(in,tem,error)
    !
    if (argproj.ne.'UNCHANGED') then
      call sic_upper(argproj)
      n = lenc(argproj)
      if (n.ne.0) then
        call projnam_list(pvocab)  ! Get all projection names
        call sic_ambigs('PROJECTION',argproj,key,nkey,pvocab,1+mproj,error)
        if (error) goto 98
        out%gil%ptyp = nkey-1
      endif
    endif
    !
    ! Coordinate system
    ! Test presence of an epoch
    newepoch=tem%gil%epoc  ! Default is to reuse old epoch
    il = lenc(systchain)
    call sic_blanc(systchain,il)
    ib = index(systchain,' ')
    if (ib.ne.0.and.il.gt.ib) then
       read(systchain(ib+1:il),*,iostat=ier) newepoch
       if (ier.ne.0) then
          call gagout('W-'//pname//', Error decoding Epoch')
          newepoch=tem%gil%epoc
       endif
       argsyst=systchain(1:ib-1)
    else
       argsyst=systchain(1:il)
    endif
    ! Decode system string
    call sic_upper(argsyst)
    call sic_ambigs('SYSTEM',argsyst,newsystem,nkey,svocab,msvoc,error)
    if (error) goto 99
    if (newsystem.ne.'UNCHANGED') then
      out%char%syst = newsystem
      out%gil%epoc = newepoch
      call get_sys_code(tem,out,sys_code)
    else
      sys_code = 0
    endif
    !
    ! Apply new system on projection center:
    call sic_upper(center_1)
    call sic_upper(center_2)
    if (center_1.eq.'UNCHANGED'.or.center_2.eq.'UNCHANGED')  then
      if (out%char%syst.eq.'ICRS') then
        if (tem%char%syst.eq.'ICRS') then  ! From ICRS to ICRS
          continue  ! Nothing to be done
        else
          call gagout('F-'//pname//',  Converting system to ICRS is not implemented')
          goto 100
        endif
      elseif (out%char%syst.eq.'EQUATORIAL') then
        if (tem%char%syst.eq.'ICRS') then  ! From ICRS to Equatorial
          call gagout('F-'//pname//',  Converting system from ICRS is not implemented')
          goto 100
        elseif (tem%char%syst.eq.'EQUATORIAL') then  ! From Equatorial to Equatorial
          call equ_equ(tem%gil%a0,tem%gil%d0,tem%gil%epoc,out%gil%a0,out%gil%d0,out%gil%epoc,error)
          if (error)  goto 100
        elseif (tem%char%syst.eq.'GALACTIC') then  ! From Galactic to Equatorial
          call gal_equ(tem%gil%a0,tem%gil%d0,out%gil%a0,out%gil%d0,out%gil%epoc,error)
          if (error)  goto 100
        else
          call gagout('F-'//pname//',  UNCHANGED Center not permitted here')
          goto 100
        endif
      elseif (out%char%syst.eq.'GALACTIC')then
        if (tem%char%syst.eq.'ICRS') then  ! From ICRS to Galactic
          call gagout('F-'//pname//',  Converting system from ICRS is not implemented')
          goto 100
        elseif (tem%char%syst.eq.'EQUATORIAL') then  ! From Equatorial to Galactic
          call equ_gal(tem%gil%a0,tem%gil%d0,tem%gil%epoc,out%gil%a0,out%gil%d0,error)
          if (error)  goto 100
        elseif (tem%char%syst.eq.'GALACTIC') then  ! From Galactic to Galactic
          continue  ! Nothing to be done
        else
          call gagout('F-'//pname//',  UNCHANGED Center not permitted here')
          goto 100
        endif
      endif
    else
      if (out%char%syst.eq.'EQUATORIAL' .or. out%char%syst.eq.'ICRS') then
        call sic_decode(center_1,center(1),24,error)
        if (error) goto 101
      else
        call sic_decode(center_1,center(1),360,error)
        if (error) goto 101
      endif
      call sic_decode(center_2,center(2),360,error)
      if (error) goto 101
      out%gil%a0 = center(1)
      out%gil%d0 = center(2)
    endif
    !
    ! Apply new system on source position
    if (out%char%syst.eq.'ICRS')then  ! From any to ICRS
      ! No recomputation of ra-dec and lii-bii (they should already be
      ! consistant)
      continue  ! Nothing to be done
    elseif (out%char%syst.eq.'EQUATORIAL') then
      if (tem%char%syst.eq.'ICRS') then  ! From ICRS to Equatorial
        call gagout('F-'//pname//',  Converting system from ICRS is not implemented')
        goto 100
      elseif (tem%char%syst.eq.'EQUATORIAL') then  ! From Equatorial to Equatorial
        ! Equatorial epoch may have changed. Compute ra-dec new epoch from
        ! ra-dec old epoch
        call equ_equ(tem%gil%ra,tem%gil%dec,tem%gil%epoc,out%gil%ra,out%gil%dec,out%gil%epoc,error)
        if (error)  goto 100
        ! Do not recompute lii-bii, should be unchanged
      elseif (tem%char%syst.eq.'GALACTIC')then  ! From Galactic to Equatorial
        ! Equatorial epoch may have changed. Compute ra-dec new epoch from
        ! lii-bii
        call gal_equ(tem%gil%lii,tem%gil%bii,out%gil%ra,out%gil%dec,out%gil%epoc,error)
        if (error)  goto 100
      endif
    elseif (out%char%syst.eq.'GALACTIC')then  ! From Equ|Gal to Galactic
      ! No recomputation of ra-dec and lii-bii (they should already be
      ! consistant, and equatorial epoch is unchanged)
      continue  ! Nothing to be done
    endif
    !
    ! Check angle
    if (angle.ne.0.d0 .and. (out%gil%ptyp.eq.p_radio .or.  &
                             out%gil%ptyp.eq.p_aitoff)) then
      chain = 'E-'//pname//',  Angle not supported in projection RADIO or AITOFF'
      call gagout(chain)
      chain = 'E-'//pname//',  Projection AZIMUTHAL can be prefered instead'
      call gagout(chain)
      call sysexi(fatale)
    endif
    out%gil%pang = angle*pi/180.d0
    !
    if (dim(1).eq.0 .or. dim(2).eq.0 .or. conv(3).eq.0 .or. conv(6).eq.0) then
      allocate(work1(in%gil%dim(1),in%gil%dim(2)),  &
               work2(in%gil%dim(1),in%gil%dim(2)),  &
               stat=ier)
      if (ier.ne.0) goto 103
      if (in%gil%blan_words.eq.0) then
        in%gil%bval = 0.0
        in%gil%eval = -1.0
      endif
      call findgrid(  &
        in%r1d,in%gil%dim(1),in%gil%dim(2),in%gil%dim(3)*in%gil%dim(4),  &
        in%gil%convert,in%gil%ptyp,in%gil%a0,in%gil%d0,in%gil%pang,in%gil%epoc,  &
        in%gil%bval,in%gil%eval,out%gil%ptyp,out%gil%a0,out%gil%d0,out%gil%pang,  &
        out%gil%epoc,sys_code, work1, work2, conv,dim)
      deallocate(work1,work2)
      !
      ! Check size so that we do not allocate more than SPACE_GILDAS
      ! (see allocations below: r1d (R4), work1 (R8), work2 (R8)
      space_gildas = 256
      ier = sic_getlog('SPACE_GILDAS',space_gildas)
      melem = space_gildas*1024*256/(max(1,out%gil%dim(3))*max(1,out%gil%dim(4)) + 2*2)
      if (dim(1)*dim(2).gt.melem) then
        write (mess,'(A,I0,A,I0,A,I0,A,I0,A)')  &
          'Computed Output Image size (',dim(1),'x',dim(2),  &
          ') has too many pixels (limit ',int(sqrt(real(melem))),'x',int(sqrt(real(melem))),').'
        call gagout(mess)
        call gagout('Increase SPACE_GILDAS or specify Output Image Header. STOP.')
        goto 100
      endif
    endif
    out%gil%dim(1) = dim(1)
    out%gil%dim(2) = dim(2)
    out%gil%dim(3) = max(1,out%gil%dim(3))
    out%gil%dim(4) = max(1,out%gil%dim(4))
    out%loca%size = out%gil%dim(1)*out%gil%dim(2)*out%gil%dim(3)*out%gil%dim(4)
    ! in case everything is not present in the input file:
    call r8tor8 (conv,out%gil%convert,6)
    out%gil%coor_words = 6*gdf_maxdims
    out%gil%blan_words = 2
    out%gil%extr_words = 6
    out%gil%desc_words = 18
    out%gil%posi_words = 12
    out%gil%proj_words = 9
  endif
  if (in%gil%blan_words.eq.0) then
    out%gil%blan_words = 2
    in%gil%bval = 0.0
    in%gil%eval = -1.0
    out%gil%bval = arr(1)
    out%gil%eval = arr(2)
  elseif (change) then
    out%gil%blan_words = 2
    out%gil%bval = arr(1)
    out%gil%eval = arr(2)
  endif
  !
  ! Method of solution
  call gagout('I-'//pname//',  Using bilinear gridding method')
  if (in%gil%eval.lt.0.0) then
    call gagout('              with no input blanking...')
  else
    call gagout('              taking input blanking in account')
  endif
  !
  ! Create output image
  if (out%char%syst.eq.'GALACTIC') then
     out%char%code(1) = 'LII'
     out%char%code(2) = 'BII'
  else if (out%char%syst.eq.'EQUATORIAL' .or. out%char%syst.eq.'ICRS') then
     out%char%code(1) = 'RA'
     out%char%code(2) = 'DEC'
  endif
  call gdf_create_image(out,error)
  if (error) then
    call gagout('F-'//pname//',  Cannot create out file:')
    call gagout(out%file)
    goto 100
  endif
  !
  allocate(out%r1d(out%loca%size), stat=ier)
  if (ier.ne.0) goto 103
  allocate(work1(out%gil%dim(1),out%gil%dim(2)),  &
           work2(out%gil%dim(1),out%gil%dim(2)),  &
           stat=ier)
  if (ier.ne.0) goto 103
  !
  call gagout ('Start computing')
  call gridlin(                                                  &
     in%r1d,in%gil%dim(1),in%gil%dim(2),in%gil%dim(3)*in%gil%dim(4),  &
     in%gil%convert,in%gil%ptyp,in%gil%a0,in%gil%d0,in%gil%pang,      &
     in%gil%epoc,in%gil%bval,in%gil%eval,      &
     out%r1d,out%gil%dim(1),out%gil%dim(2),                            &
     out%gil%convert,out%gil%ptyp,out%gil%a0,out%gil%d0,out%gil%pang,  &
     out%gil%epoc,out%gil%bval,    &
     sys_code,work1,work2)
  !
  deallocate(work1,work2)
  call gdf_write_data(out,out%r1d,error)
  !
  call gagout('S-'//pname//',  Successful completion')
  call sysexi(1)
  !
  ! Errors:
  !
100 call sysexi (fatale)
  !
98 call gagout('F-'//pname//',  Invalid projection system')
  call sysexi (fatale)
  !
99 call gagout('F-'//pname//',  Invalid coordinate system')
  call sysexi (fatale)
  !
101 call gagout('F-'//pname//',  Bad syntax in center coordinates')
  call sysexi (fatale)
  !
103 call gagout('F-'//pname//', Allocation error')
  call sysexi (fatale)
  !
contains
  subroutine sanity_check(x,error)
    use image_def
    !-------------------------------------------------------------------
    ! Sanity check for input or template file
    !-------------------------------------------------------------------
    type(gildas), intent(in)    :: x
    logical,      intent(inout) :: error
    !
    ! Check if the 2 first dimensions are spatial. We could support any
    ! order but this is not implemented (and would be unefficient)
    if (x%gil%xaxi*x%gil%yaxi.ne.2) then
      call gagout('F-'//pname//', Spatial dimensions must be first and second dimensions')
      error = .true.
      return
    endif
    !
  end subroutine sanity_check
end program reproject
!
subroutine get_sys_code(in,out,sys_code)
  use gbl_format
  use image_def
  !---------------------------------------------------------------------
  ! Get old-system to new-system conversion code
  ! Trap illegal/impossible conversions.
  !---------------------------------------------------------------------
  type(gildas),    intent(in)  :: in        ! Input header
  type(gildas),    intent(in)  :: out       ! Desired output header
  integer(kind=4), intent(out) :: sys_code  ! Conversion code
  ! Local
  character(len=*), parameter :: pname='REPROJECT'
  integer(kind=4), parameter :: conv_none   = 0
  integer(kind=4), parameter :: conv_equ2gal= 1
  integer(kind=4), parameter :: conv_gal2equ=-1
  integer(kind=4), parameter :: conv_equ2equ=-2
  !
  select case (out%char%syst)
  case ('ICRS')
    if (in%char%syst.eq.'ICRS') then
      sys_code = conv_none
    else
      goto 102
    endif
    !
  case ('GALACTIC')
    if (in%char%syst.eq.'EQUATORIAL') then
      sys_code = conv_equ2gal
    elseif (in%char%syst.eq.'GALACTIC') then
      sys_code = conv_none
    else
      goto 102
    endif
    !
  case ('EQUATORIAL')
    if (in%char%syst.eq.'EQUATORIAL') then
      if (in%gil%epoc.ne.out%gil%epoc) then
        ! Both Equatorial, not same equinox
        call gagout('Converting from equinox '//trim(equinox_name(in%gil%epoc))//  &
                                        ' to '//trim(equinox_name(out%gil%epoc)))
        sys_code = conv_equ2equ
      else
        ! Both Equatorial, same equinox
        sys_code = conv_none
      endif
    elseif (in%char%syst.eq.'GALACTIC') then
      sys_code = conv_gal2equ
    else
      goto 102
    endif
    !
  case ('UNKNOWN')
    if (in%char%syst.eq.'ICRS') then
      goto 102
    elseif (in%char%syst.eq.'GALACTIC') then
      goto 102
    elseif (in%char%syst.eq.'EQUATORIAL') then
      goto 102
    else
      sys_code = conv_none
    endif
    !
  case default
    call gagout('W-'//pname//', Unknown system '//out%char%syst//', no conversion applied')
    sys_code = conv_none
    !
  end select
  return
  !
102 continue
  call gagout('F-'//pname//', Cannot convert from '//in%char%syst//' to '//out%char%syst)
  call sysexi(fatale)
  !
contains
  function equinox_name(equinox)
    real(kind=4), intent(in) :: equinox
    character(len=10) :: equinox_name
    if (equinox.eq.equinox_null) then
      equinox_name = 'Unknown'
    else
      write(equinox_name,'(F0.2)') equinox
    endif
  end function equinox_name
  !
end subroutine get_sys_code
!
subroutine findgrid(a,mx,my,mz,aconv,atype,aa0,ad0,aangle,aepoc,abval,aeval,  &
                    btype,ba0,bd0,bangle,bepoc,code,dxd,dyd,bconv,bdim)
  use gildas_def
  use gbl_constant
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  ! CODE:   (-1) GAL --> EQU
  !         ( 1) EQU --> GAL
  !         (-2) EQU --> EQU
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)    :: mx           ! Size of pseudo-map
  integer(kind=index_length), intent(in)    :: my           !
  integer(kind=index_length), intent(in)    :: mz           !
  real(kind=4),               intent(in)    :: a(mx,my,mz)  ! Pseudo-map
  real(kind=8),               intent(in)    :: aconv(6)     ! Pixel conversion formulae
  integer(kind=4),            intent(in)    :: atype        ! Type of projection
  real(kind=8),               intent(in)    :: aa0          ! Input projection A0
  real(kind=8),               intent(in)    :: ad0          ! Input projection D0
  real(kind=8),               intent(in)    :: aangle       ! Input projection Angle
  real(kind=4),               intent(in)    :: aepoc        ! Epoch if Needed
  real(kind=4),               intent(in)    :: abval        ! Blank val
  real(kind=4),               intent(in)    :: aeval        ! Blank errval
  integer(kind=4),            intent(in)    :: btype        ! Type of projection
  real(kind=8),               intent(in)    :: ba0          ! Output projection A0
  real(kind=8),               intent(in)    :: bd0          ! Output projection D0
  real(kind=8),               intent(in)    :: bangle       ! Output projection Angle
  real(kind=4),               intent(in)    :: bepoc        ! Epoch if Needed
  integer(kind=4),            intent(in)    :: code         ! Conversion code
  real(kind=8)                              :: dxd(*)       ! X work array
  real(kind=8)                              :: dyd(*)       ! Y work array
  real(kind=8),               intent(inout) :: bconv(6)     ! Output best conv
  integer(kind=4),            intent(inout) :: bdim(2)      ! Output best DIM
  ! Global
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer(kind=4), parameter :: conv_none   = 0
  integer(kind=4), parameter :: conv_equ2gal= 1
  integer(kind=4), parameter :: conv_gal2equ=-1
  integer(kind=4), parameter :: conv_equ2equ=-2
  ! Local
  real(kind=8) :: boundary
  integer(kind=index_length) :: i,j
  integer(kind=4) :: ndp, ier
  real(kind=8) :: axref,axval,axinc, ayref,ayval,ayinc
  real(kind=8) :: dxmin,dxmax,dymin,dymax
  real(kind=8), allocatable :: adxd(:),adyd(:),bdxd(:),bdyd(:)
  real(kind=4) :: sizx,sizy,ratio
  character(len=80) :: chain
  logical :: warn,doxinc,doyinc
  type(projection_t) :: proj
  logical :: error
  !
  ! Preliminary processing
  axref = aconv(1)
  axval = aconv(2)
  axinc = aconv(3)
  ayref = aconv(4)
  ayval = aconv(5)
  ayinc = aconv(6)
  !
  ! Load X,Y,Z arrays
  !
  ! Setup Input projection
  error = .false.
  call gwcs_projec(aa0,ad0,aangle,atype,proj,error)
  !
  ! Convert Input projection to Absolute coordinates and load data points
  ndp=0
  do j=1,my
    do i=1,mx
      if (abs(a(i,j,1)-abval).gt.aeval) then
        ndp = ndp+1
        dxd(ndp) = (i-axref)*axinc + axval
        dyd(ndp) = (j-ayref)*ayinc + ayval
      endif
    enddo
  enddo
  call gagout('I-REPROJECT,  Evaluating Output Image Header...')
  write(chain,1000) ndp
  call gagout(chain)
  if (ndp.eq.0) then
    call gagout('No valid data points in input image')
    call sysexi(fatale)
  endif
  !
  if (code.ne.conv_none) then
    allocate(adxd(ndp),adyd(ndp),bdxd(ndp),bdyd(ndp),stat=ier)  
    if (ier.ne.0) then
      call gagout('Memory allocation error 1')
      call sysexi(fatale)
    endif
    call rel_to_abs(proj,dxd,dyd,bdxd,bdyd,ndp)
    !
    ! Change coordinate system. use new epoch also
    if (code.eq.1) then
      call equ_gal(bdxd,bdyd,aepoc,adxd,adyd,ndp,error)
    elseif (code.eq.-1) then
      call gal_equ(bdxd,bdyd,adxd,adyd,bepoc,ndp,error)
    elseif (code.eq.-2) then
      call equ_equ(bdxd,bdyd,aepoc,adxd,adyd,bepoc,ndp,error)
    endif
    if (error)  call sysexi(fatale)
  else
    allocate(adxd(ndp),adyd(ndp),stat=ier)  
    if (ier.ne.0) then
      call gagout('Memory allocation error 2')
      call sysexi(fatale)
    endif
    call rel_to_abs(proj,dxd,dyd,adxd,adyd,ndp)
  endif
  !
  ! Setup Output projection
  call gwcs_projec(ba0,bd0,bangle,btype,proj,error)
  !
  ! Convert Absolute coordinates to input projection
  call abs_to_rel(proj,adxd,adyd,dxd,dyd,ndp)
  !
  call bestbox(dxd,dyd,ndp,dxmin,dxmax,dymin,dymax)
  ! Test extreme cases of unbound projections:
  if (btype.eq.p_gnomonic) then    ! GNOMONIC
    boundary=1.5d0
  elseif (btype.eq.p_stereo) then  ! STEREOGRAPHIC
    boundary=1.0d0
  endif
  if (btype.eq.p_gnomonic .or. btype.eq.p_stereo) then
    if (dxmin.lt.-boundary) then
      warn=.true.
      dxmin=-boundary
    endif
    if (dymin.lt.-boundary) then
      warn=.true.
      dymin=-boundary
    endif
    if (dxmax.gt.boundary) then
      warn=.true.
      dxmax=boundary
    endif
    if (dymax.gt.boundary) then
      warn=.true.
      dymax=boundary
    endif
    if (warn) then
      call gagout('W-REPROJECT, Output Projection is unbound')
      call gagout('Will be limited to one hemisphere')
    endif
  endif
  !
  sizx=dxmax-dxmin
  sizy=dymax-dymin
  ratio=sizx/sizy
  doxinc = bconv(3).eq.0.d0
  doyinc = bconv(6).eq.0.d0
  ! If user gave number of pixels, use it
  if (bdim(2).eq.0)  bdim(2) = nint(sqrt(float(mx*my)*2.0/ratio))
  if (bdim(1).eq.0)  bdim(1) = nint(float(bdim(2))*ratio)
  ! If user gave increments, override BDIM
  if (.not.doxinc)  bdim(1) = sizx/abs(bconv(3))+1
  if (.not.doyinc)  bdim(2) = sizy/abs(bconv(6))+1
  !
  ! Compute increments from BDIM if requested
  if (doxinc)  bconv(3) = sizx/(bdim(1)-1)  ! Xinc is automatic
  if (doyinc)  bconv(6) = sizy/(bdim(2)-1)  ! Yinc is automatic
  if (doxinc.and.doyinc) then  ! Both Xinc and Yinc are automatic
    ! At this stage the automatic increments may be slightly different because
    ! bdim(1)/bdim(2) differs slightly from sizx/sizy (nint() rounding). Prefer
    ! equal increments. Select the one which ensures no loss of map coverage.
    if (bconv(3).gt.bconv(6)) then
      bconv(6) = bconv(3)
    else
      bconv(3) = bconv(6)
    endif
  endif
  ! Keep input map conventions, if any.
  if (doxinc .and. aconv(3).lt.0.d0)  bconv(3) = -bconv(3)
  if (doyinc .and. aconv(6).lt.0.d0)  bconv(6) = -bconv(6)
  !
  ! VAL(1)=bconv(2) is left unmodified. 0 means aligned on projection center.
  ! REF(1)=bconv(1):
  if (bconv(1).eq.0.d0) then
    ! Automatic mode: set REFerence pixel so that 1st pixel is aligned on image boundary
    if (bconv(3).gt.0.d0) then  ! inc(1)
      bconv(1) = 1.d0-(dxmin-bconv(2))/bconv(3)  ! ref(1) so that 1st pixel (1.0) is aligned on dxmin
    else
      bconv(1) = 1.d0-(dxmax-bconv(2))/bconv(3)  ! ref(1) (same, at dxmax)
    endif
    ! Round ref(1) to an integer value so that the projection center at the
    ! middle of a pixel. Use nearest value towards Nx/2+1 so that we stay as
    ! near as possible to the Fourier Transform solution.
    if (bconv(1).lt.bdim(1)/2.d0+1.d0) then
      bconv(1) = ceiling(bconv(1))
    else
      bconv(1) = floor(bconv(1))
    endif
  else
    ! Leave user defined REF(1)
    continue
  endif
  !
  ! VAL(2)=bconv(5) is left unmodified. 0 means aligned on projection center.
  ! REF(2)=bconv(4):
  if (bconv(4).eq.0.d0) then
    ! Automatic mode: set REFerence pixel so that 1st pixel is aligned on image boundary
    if (bconv(6).gt.0.d0) then  ! inc(2)
      bconv(4) = 1.d0-(dymin-bconv(5))/bconv(6)  ! ref(2) so that 1st pixel (1.0) is aligned on dymin
    else
      bconv(4) = 1.d0-(dymax-bconv(5))/bconv(6)  ! ref(2) (same, at dymax)
    endif
    ! Round ref(2) to an integer value so that the projection center at the
    ! middle of a pixel. Use nearest value towards Ny/2+1 so that we stay as
    ! near as possible to the Fourier Transform solution.
    if (bconv(4).lt.bdim(2)/2.d0+1.d0) then
      bconv(4) = ceiling(bconv(4))
    else
      bconv(4) = floor(bconv(4))
    endif
  else
    ! Leave user defined REF(2)
    continue
  endif
  !
  write(*,100)
  write(*,101) bdim(1),(bconv(j),j=1,3)
  write(*,102) bdim(2),(bconv(j),j=4,6)
  !
  return
100 format ('Output Image header values:',   &
          /,'Axis Npix     Ref          Val            Inc')
101 format ('  1 ',i4,1x,3(g12.5e2,1x))
102 format ('  2 ',i4,1x,3(g12.5e2,1x))
1000 format ('              Found ',i8,' Valid points')
end subroutine findgrid
!
subroutine bestbox(dxd,dyd,ndp,dxmin,dxmax,dymin,dymax)
  real(kind=8) :: dxd(*)                  !
  real(kind=8) :: dyd(*)                  !
  integer(kind=4) :: ndp                    !
  real(kind=8) :: dxmin                   !
  real(kind=8) :: dxmax                   !
  real(kind=8) :: dymin                   !
  real(kind=8) :: dymax                   !
  ! Local
  integer(kind=4) :: i
  !
  dxmin=dxd(1)
  dxmax=dxd(1)
  dymin=dyd(1)
  dymax=dyd(1)
  do i=2,ndp
    dxmin=min(dxmin,dxd(i))
    dymin=min(dymin,dyd(i))
    dxmax=max(dxmax,dxd(i))
    dymax=max(dymax,dyd(i))
  enddo
  !
end subroutine bestbox
!
subroutine gridlin(a,mx,my,mz,aconv,atype,aa0,ad0,aangle,aepoc,abval,aeval,  &
                   b,nx,ny,   bconv,btype,ba0,bd0,bangle,bepoc,bbval,  &
                   code,xb,yb)
  use gildas_def
  use gkernel_interfaces, no_interface1=>abs_to_rel_1dn4,  &
                          no_interface2=>rel_to_abs_1dn4
  use gkernel_types
  !---------------------------------------------------------------------
  ! GREG Stand alone subroutine
  !  Regrid an input map in a given projection to an output map in
  ! another projection, bilinear interpolation
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: mx  ! Size of A
  integer(kind=index_length), intent(in) :: my  ! Size of A
  integer(kind=index_length), intent(in) :: mz  ! Size of A and B
  real(kind=4)    :: a(mx,my,mz)  ! Input map of dimensions MX MY MZ
  real(kind=8)    :: aconv(6)     ! Pixel conversion formulae: CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  integer(kind=4) :: atype        ! Type of projection
  real(kind=8)    :: aa0          ! Input projection A0
  real(kind=8)    :: ad0          ! Input projection D0
  real(kind=8)    :: aangle       ! Input projection angle
  real(kind=4)    :: aepoc        ! Epoch if Needed
  real(kind=4)    :: abval        !
  real(kind=4)    :: aeval        !
  integer(kind=index_length), intent(in) :: nx  ! Size of B
  integer(kind=index_length), intent(in) :: ny  ! Size of B
  real(kind=4)    :: b(nx,ny,mz)  ! Output map of dimensions NX,NY,MZ
  real(kind=8)    :: bconv(6)     !
  integer(kind=4) :: btype        !
  real(kind=8)    :: ba0          ! Output projection A0
  real(kind=8)    :: bd0          ! Output projection D0
  real(kind=8)    :: bangle       ! Output projection angle
  real(kind=4)    :: bepoc        ! Epoch if Needed
  real(kind=4)    :: bbval        ! Blanking value
  integer(kind=4) :: code         ! Galactic to Equatorial (-1) or Equatorial to Galactic (1)
  real(kind=8)    :: xb(nx,ny)    ! Work arrays of dimension MX,MY
  real(kind=8)    :: yb(nx,ny)    ! Work arrays of dimension MX,MY
  !
  integer(kind=4), parameter :: conv_none   = 0
  integer(kind=4), parameter :: conv_equ2gal= 1
  integer(kind=4), parameter :: conv_gal2equ=-1
  integer(kind=4), parameter :: conv_equ2equ=-2
  ! Local
  integer(kind=index_length) :: ia,ja,k
  integer(kind=4) :: ib,jb,ier,n4
  real(kind=8) :: axref,axval,axinc, ayref,ayval,ayinc
  real(kind=8) :: bxref,bxval,bxinc, byref,byval,byinc
  real(kind=8) :: xa,ya
  real(kind=4) :: xr,yr
  real(kind=8), allocatable :: axb(:),ayb(:),bxb(:),byb(:)
  type(projection_t) :: proj
  logical :: error
  !
  ! JP TEST
  ! print *,"a",aproj
  ! print *,"b",bproj
  ! aproj(3) = 0
  ! bproj(3) = 0
  !
  ! I force the conversion formula for input to be adapted to the
  ! NINT function that will be used below. Now Xref=1.0
  axref = 1.0                  ! was ACONV(1)
  axval = (1.0-aconv(1))*aconv(3)+aconv(2)
  axinc = aconv(3)
  ayref = 1.0                  ! was ACONV(4)
  ayval = (1.0-aconv(4))*aconv(6)+aconv(5)
  ayinc = aconv(6)
  ! the output is unchanged.
  bxref = bconv(1)
  bxval = bconv(2)
  bxinc = bconv(3)
  byref = bconv(4)
  byval = bconv(5)
  byinc = bconv(6)
  !
  ! Setup Output projection
  error = .false.
  call gwcs_projec(ba0,bd0,bangle,btype,proj,error)
  !
  ! Convert Output projection to Absolute coordinates
  do jb=1,ny
    do ib=1,nx
      xb(ib,jb) = (ib-bxref)*bxinc + bxval
      yb(ib,jb) = (jb-byref)*byinc + byval
    enddo
  enddo
  !
  if (code.ne.conv_none) then
    allocate(axb(nx*ny),ayb(nx*ny),bxb(nx*ny),byb(nx*ny),stat=ier)
    call rel_to_abs_1dn4(proj,xb,yb,bxb,byb,nx*ny)
    !
    ! Change coordinate system. use new epoch also. Warning: codes are
    ! reversed since we start form output map!
    n4 = nx*ny
    if (code.eq.1) then
      call gal_equ(bxb,byb,axb,ayb,aepoc,n4,error)
    elseif (code.eq.-1) then
      call equ_gal(bxb,byb,bepoc,axb,ayb,n4,error)
    elseif (code.eq.-2) then
      call equ_equ(bxb,byb,bepoc,axb,ayb,aepoc,n4,error)
    endif
    if (error)  call sysexi(fatale)
  else
    allocate(axb(nx*ny),ayb(nx*ny),stat=ier)
    call rel_to_abs_1dn4(proj,xb,yb,axb,ayb,nx*ny)
  endif
  !
  ! Setup Input projection
  call gwcs_projec(aa0,ad0,aangle,atype,proj,error)
  !
  ! Convert Absolute coordinates to input projection
  call abs_to_rel_1dn4(proj,axb,ayb,xb,yb,nx*ny)
  !
  ! Interpolate
  !
  ! Take Blanking into account, version #1
  if (aeval.lt.0.0) then
    ! Loop over Output data points
    do k = 1,mz
      do jb = 1,ny
        do ib = 1,nx
          !
          ! Find pixel coordinate in input map
          xa = xb(ib,jb)
          ya = yb(ib,jb)
          xr = (xa-axval)/axinc+axref
          yr = (ya-ayval)/ayinc+ayref
          ia = int(xr)
          ja = int(yr)
          xr = xr-float(ia)
          yr = yr-float(ja)
          !
          ! Avoid edges
          if (ia.lt.1 .or. ia.ge.mx .or. ja.lt.1 .or. ja.ge.my) then
            b(ib,jb,k) = bbval
          else
            ! Interpolate
            b(ib,jb,k) = (1-xr)*(1-yr)*a(ia,ja,k)+   &
                         xr*(1-yr)*a(ia+1,ja,k)+   &
                         xr*yr*a(ia+1,ja+1,k)+   &
                         (1-xr)*yr*a(ia,ja+1,k)
          endif
        enddo
      enddo
    enddo
  else
    ! Loop over Output data points
    do k = 1,mz
      do jb = 1,ny
        do ib = 1,nx
          xa = xb(ib,jb)
          ya = yb(ib,jb)
          xr = (xa-axval)/axinc+axref
          yr = (ya-ayval)/ayinc+ayref
          ia = int(xr)
          ja = int(yr)
          xr = xr-float(ia)
          yr = yr-float(ja)
          if (ia.lt.1 .or. ia.ge.mx .or. ja.lt.1 .or. ja.ge.my) then
            b(ib,jb,k) = bbval
          elseif (abs(a(ia,ja,k)-abval).le.aeval) then
            b(ib,jb,k) = bbval
          elseif (abs(a(ia+1,ja,k)-abval).le.aeval) then
            b(ib,jb,k) = bbval
          elseif (abs(a(ia,ja+1,k)-abval).le.aeval) then
            b(ib,jb,k) = bbval
          elseif (abs(a(ia+1,ja+1,k)-abval).le.aeval) then
            b(ib,jb,k) = bbval
          else
            b(ib,jb,k) = (1-xr)*(1-yr)*a(ia,ja,k)+  &
                         xr*(1-yr)*a(ia+1,ja,k)+   &
                         xr*yr*a(ia+1,ja+1,k)+   &
                         (1-xr)*yr*a(ia,ja+1,k)
          endif
        enddo
      enddo
    enddo
  endif
  !
end subroutine gridlin

subroutine ctrlc_check (error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>ctrlc_check
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Pause if ^C has been pressed and reset CONTROLC flag to false.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  if (.not.sic_ctrlc()) return
  if (mlire(nlire).eq.0) then  ! At the terminal prompt
    call sic_message(seve%i,'SIC','^C')
  elseif (nlire.lt.maxlev) then  ! During a command execution
    call sic_message(seve%i,'PAUSE','Generated by pressing ^C')
    if (error) then
      call sic_message(seve%w,'PAUSE','Error returned by aborted command '//  &
      'ignored')
      error = .false.
    endif
    call break
  else  ! During a command execution but too deep
    call sic_message(seve%w,'SIC','<^C> Ignored, level too deep')
  endif
end subroutine ctrlc_check

subroutine mrtindex_index_comm(line,ix,cx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_index_comm
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Support routine for command
  !   INDEX BUILD|UPDATE|OPEN|APPEND|WATCH|OUTPUT|CONVERT [DirName]
  ! 1       [/FILE IndexFile]
  ! 2       [/RECURSIVE]
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line   ! Input command line
  type(mrtindex_optimize_t), intent(inout) :: ix
  type(mrtindex_optimize_t), intent(inout) :: cx
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  integer(kind=4), parameter :: mvocab=7
  character(len=7) :: vocab(mvocab)
  character(len=16) :: argum,keyword
  integer(kind=4) :: nc,ikey
  logical :: append
  ! Data
  data vocab / 'BUILD','UPDATE','OPEN','APPEND','WATCH','OUTPUT','CONVERT' /
  !
  if (sic_present(1,0) .and. sic_present(2,0)) then
    call mrtindex_message(seve%e,rname,'Exclusive options /FILE and /RECURSIVE')
    error = .true.
    return
  endif
  !
  argum = 'OPEN'
  call sic_ke(line,0,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,keyword,ikey,vocab,mvocab,error)
  if (error)  return
  !
  ! All these commands modify the input index: reset the current index
  cx%next = 1
  !
  append = .false.
  select case (ikey)
  case (1)  ! BUILD
    call mrtindex_index_update(line,.true.,ix,error)
    if (error)  return
  case (2)  ! UPDATE
    call mrtindex_index_update(line,.false.,ix,error)
    if (error)  return
  case (3)  ! OPEN
    continue ! Work done below
  case (4)  ! APPEND
    append = .true.
    continue ! Work done below
  case (5)  ! WATCH
    call mrtindex_watch_comm(line,error)
    return
  case (6)  ! OUTPUT
    call mrtindex_index_output(line,error)
    if (error)  return
    append = .true.
  case (7)  ! CONVERT
    call mrtindex_index_convert(line,ix,error)
    return
  end select
  !
  ! Doing an implicit OPEN at the end is a desired feature of all
  ! modes (except WATCH and CONVERT)
  call mrtindex_index_open(line,append,ix,error)
  if (error)  return
  !
end subroutine mrtindex_index_comm
!
subroutine mrtindex_index_update(line,overwrite,ix,error)
  use gildas_def
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_index_update
  use mrtindex_types
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   INDEX BUILD|UPDATE [DirName] [/FILE IndexFile] [/RECURSIVE]
  ! Build or update the scans index.
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line       ! Input command line
  logical,                   intent(in)    :: overwrite  ! Overwrite or update only?
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=filename_length) :: directory,indexfile
  type(user_pattern_t) :: pattern
  !
  call mrtindex_parse(line,directory,indexfile,pattern,error)
  if (error)  return
  !
  if (overwrite) then
    ! If BUILD (not UPDATE), close all previous index files
    call mrtindex_ix_close(error)
    if (error)  return
    ix%next = 1  ! Forget all previous entries in IX
  endif
  !
  if (sic_present(2,0)) then  ! /RECURSIVE
    if (overwrite) then
      call mrtindex_index_build_recurs(directory,pattern,error)
    else
      call mrtindex_index_update_recurs(directory,pattern,error)
    endif
  else
    call mrtindex_file_update(indexfile,directory,pattern,overwrite,  &
      .true.,error)
  endif
  if (error)  return
  !
end subroutine mrtindex_index_update
!
recursive subroutine mrtindex_index_build_recurs(directory,pattern,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_index_build_recurs
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Build index files recursively from given directory
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: directory  !
  type(user_pattern_t), intent(in)    :: pattern    ! Pattern for file to be indexed
  logical,              intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='BUILD>RECURSIVE'
  character(len=filename_length) :: indexfile
  integer(kind=4) :: ier
  !
  ! 1) Build local index file
  indexfile = trim(directory)//'/index.mrt'
  call mrtindex_file_update(indexfile,directory,pattern,.true.,.false.,error)
  if (error)  return
  !
  ! 2) Loop on sub-directories
  ier = gag_directory_exedir(directory,pattern,mrtindex_index_build_recurs)
  if (ier.ne.0) then
    call mrtindex_message(seve%e,rname,'Error looping in directory '//directory)
    error = .true.
    return
  endif
  !
end subroutine mrtindex_index_build_recurs
!
recursive subroutine mrtindex_index_update_recurs(directory,pattern,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_index_update_recurs
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Update index files recursively from given directory
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: directory  !
  type(user_pattern_t), intent(in)    :: pattern    ! Pattern for file to be indexed
  logical,              intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='UPDATE>RECURSIVE'
  character(len=filename_length) :: indexfile
  integer(kind=4) :: ier
  !
  ! 1) Update/build local index file
  indexfile = trim(directory)//'/index.mrt'
  call mrtindex_file_update(indexfile,directory,pattern,.false.,.false.,error)
  if (error)  return
  !
  ! 2) Loop on sub-directories
  ier = gag_directory_exedir(directory,pattern,mrtindex_index_update_recurs)
  if (ier.ne.0) then
    call mrtindex_message(seve%e,rname,'Error looping in directory '//directory)
    error = .true.
    return
  endif
  !
end subroutine mrtindex_index_update_recurs
!
subroutine mrtindex_index_open(line,append,ix,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_index_open
  use mrtindex_types
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   INDEX OPEN|APPEND [DirName] [/FILE IndexFile] [/RECURSIVE]
  ! Load in memory an index file
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line    ! Input command line
  logical,                   intent(in)    :: append  ! Overwrite or append in memory?
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  character(len=message_length) :: mess
  character(len=filename_length) :: directory,indexfile
  type(user_pattern_t) :: pattern
  !
  call mrtindex_parse(line,directory,indexfile,pattern,error)
  if (error)  return
  !
  if (.not.append) then
    ! If OPEN (not APPEND), close all previous index files
    call mrtindex_ix_close(error)
    if (error)  return
    ix%next = 1  ! Forget all previous entries in IX
  endif
  !
  if (sic_present(2,0)) then  ! /RECURSIVE
    call mrtindex_open_recurs(directory,ix,error)
  else
    call mrtindex_open_one(indexfile,directory,ix,error)
  endif
  if (error)  return
  !
  call mrtindex_ix_sort(ix,error)
  if (error)  return
  !
  call mrtindex_ix_setnum(ix,error)
  if (error)  return
  !
  write(mess,'(I0,A)')  ix%next-1,' entries in Input indeX'
  call mrtindex_message(seve%i,rname,mess)
  !
end subroutine mrtindex_index_open
!
subroutine mrtindex_parse(line,dirname,filename,pattern,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_parse
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Parse command line of the form
  !   COMMAND YYY Dirname /OPT1 FileName /OPT3 Pattern
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: line      ! Input command line
  character(len=*),     intent(out)   :: dirname   !
  character(len=*),     intent(out)   :: filename  !
  type(user_pattern_t), intent(out)   :: pattern   ! For files to be indexed
  logical,              intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>PARSE'
  integer(kind=4) :: nd,nf
  character(len=filename_length) :: dirstring,filestring
  logical :: getpattern,getdate
  character(len=commandline_length) :: string
  integer(kind=4), parameter :: mlist=10
  !
  dirstring = '.' ! Default current working directory
  nd = 1
  call sic_ch(line,0,2,dirstring,nd,.false.,error)
  if (error)  return
  if (dirstring(nd:nd).eq.'/') then  ! ZZZ should use gag_separ for a more portable code
    dirstring(nd:nd) = ' '
    nd = nd-1
  endif
  call sic_resolve_env(dirstring,dirname)  ! Resolve ~ and other environment vars
  call sic_resolve_log(dirname)            ! Resolve sic logicals
  !
  ! /OPT1 FileName
  if (sic_present(1,0)) then
    call sic_ch(line,1,1,filestring,nf,.true.,error)
    if (error)  return
    call sic_parse_file(filestring,'','.mrt',filename)
  else
    ! Default 'index.mrt' in target directory
    if (dirname.eq.'.') then
      filename = 'index.mrt'
    else
      filename = trim(dirname)//'/index.mrt'
    endif
  endif
  !
  ! /PATTERN or /DATE
  getpattern = sic_present(3,0)
  getdate = sic_present(4,0)
  if (getpattern .and. getdate) then
    call mrtindex_message(seve%e,rname,'Incompatible options /PATTERN and /DATE')
    error = .true.
    return
  endif
  if (getpattern) then
    pattern%bylist = .false.
    call sic_ch(line,3,1,pattern%custom,nf,.true.,error)
    if (error)  return
  elseif (getdate) then
    pattern%bylist = .true.
    call datelist_decode(line,4,string,error)
    if (error)  return
    call sic_parse_listi4(rname,string,pattern%datelist,mlist,error)
    if (error)  return
    if (any(pattern%datelist%i3(1:pattern%datelist%nlist).ne.1)) then
      call mrtindex_message(seve%e,rname,  &
        'Step other than 1 in /DATE list(s) not implemented')
      error = .true.
      return
    endif
  else
    pattern%bylist = .false.
    pattern%custom = imbfits_name('*')
  endif
  !
end subroutine mrtindex_parse
!
recursive subroutine mrtindex_open_recurs(directory,ix,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_open_recurs
  use mrtindex_types
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Open and load in IX index files recursively found in given
  ! directory
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: directory  !
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='OPEN>RECURSIVE'
  character(len=filename_length) :: indexfile
  integer(kind=4) :: nc,ier
  !
  ! 1) Load local index file
  indexfile = trim(directory)//'/index.mrt'
  nc = len_trim(indexfile)
  if (gag_inquire(indexfile,nc).eq.0) then
    call mrtindex_open_one(indexfile,directory,ix,error)
    if (error)  return
  endif
  !
  ! 2) Loop on sub-directories
  ier = gag_directory_exedir(directory,ix,mrtindex_open_recurs)
  if (ier.ne.0) then
    call mrtindex_message(seve%e,rname,'Error looping in directory '//directory)
    error = .true.
    return
  endif
  !
end subroutine mrtindex_open_recurs
!
subroutine mrtindex_index_output(line,error)
  use gildas_def
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_index_output
  use mrtindex_vars
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !  Create the new INDEX OUTPUT file, used for saving the calibrated
  ! entries (default is to save them in the index they come from).
  !  Note that the associated directory is left undeclared, which may
  ! mean more or less troubles...
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>OUTPUT'
  character(len=filename_length) :: directory,indexfile
  type(user_pattern_t) :: pattern
  !
  call mrtindex_parse(line,directory,indexfile,pattern,error)
  if (error)  return
  !
  call mrtindex_file_new(indexfile,.false.,directory,ox_fileid,error)
  if (error)  return
  !
  ! Do not keep opened this file, we may be building|updating a large
  ! number
  call mrtindex_file_close(ix_files(ox_fileid),error)
  if (error)  continue
  !
end subroutine mrtindex_index_output
!
subroutine mrtindex_index_convert(line,ix,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_index_convert
  use mrtindex_parse_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   INDEX CONVERT [/FILE IndexFile]
  ! Convert an index file to the latest index version (if relevant),
  ! most likely before trying to write into it afterwards.
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: line    ! Input command line
  type(mrtindex_optimize_t), intent(inout) :: ix      !
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX'
  character(len=message_length) :: mess
  character(len=filename_length) :: imbdir,indexdir,indexfile,oldfile,indexbase,oldbase
  character(len=12) :: ext
  type(user_pattern_t) :: pattern
  integer(kind=4) :: nc,ier,fileid
  type(mrtindex_optimize_t) :: idx
  !
  call mrtindex_parse(line,imbdir,indexfile,pattern,error)
  if (error)  return
  !
  nc = len_trim(indexfile)
  if (gag_inquire(indexfile,nc).ne.0) then
    call mrtindex_message(seve%w,rname,  &
      'No such file '//indexfile(1:nc)//', nothing done')
    return
  endif
  !
  ! Use general API. But this needs to reset the input index.
  call mrtindex_ix_close(error)
  if (error)  return
  ix%next = 1  ! Forget all previous entries in IX
  !
  ! Check for index version (in the CLASSIC sense). Play fast (i.e.
  ! avoid loading the whole index if not necessary):
  call mrtindex_file_old(indexfile,imbdir,.false.,fileid,error)
  if (error)  return
  if (ix_files(fileid)%desc%vind.eq.mrtcal_indx_version) then
    write(mess,'(3a,i0,a)')  'File ',indexfile(1:nc),  &
      ' is already at latest version (v',ix_files(fileid)%desc%vind,')'
    call mrtindex_message(seve%i,rname,mess)
    return
  endif
  !
  ! Rename old file
  call mrtindex_ix_close(error)
  if (error)  return
  call sic_parse_name(indexfile,indexbase,oext=ext,odir=indexdir)
  write(oldbase,'(a,a,i0)')  trim(indexbase),'-v',ix_files(fileid)%desc%vind
  call sic_parse_file(oldbase,indexdir,'.'//ext,oldfile)
  ier = gag_filrename(indexfile,oldfile)
  call mrtindex_message(seve%i,rname,'Old index file backup''ed to '//trim(oldfile))
  !
  ! Load in custom index
  call mrtindex_open_one(oldfile,imbdir,idx,error)
  if (error)  return
  write(mess,'(a,i0,a)')  'Converting an index of ',idx%next-1,' entries'
  call mrtindex_message(seve%i,rname,mess)
  !
  ! Convert
  call mrtindex_copy_index(indexfile,idx,error)
  if (error)  return
  !
  ! All done
  call deallocate_mrtoptimize(idx,error)
  if (error)  return
end subroutine mrtindex_index_convert
!
subroutine mrtindex_ix_sort(ix,error)
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_ix_sort
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Sort the whole IX. Can be useful if e.g. 1) the index.mrt was not
  ! sorted, or 2) if we merged (APPEND or /RECURSIVE) several index
  ! files
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IX>SORT'
  integer(kind=entry_length) :: ient,ielem
  type(mrtindex_optimize_t) :: tmpx
  !
  ! Need a copy of IX, can not sort inplace
  call mrtindex_optimize_to_optimize(ix,tmpx,error)
  if (error)  return
  !
  call mrtindex_optimize_setsort(tmpx,error)
  if (error)  goto 100
  !
  ix%next = 1
  do ient=1,tmpx%next-1
    ielem = tmpx%sort(ient)
    call mrtindex_optimize_to_optimize(tmpx,ielem,ix,error)
    if (error)  goto 100
  enddo
  !
  ! Need to renumber ix%mnum which is contiguous bu definition
  do ient=1,ix%next-1
    ix%mnum(ient) = ient
  enddo
  !
100 continue
  call deallocate_mrtoptimize(tmpx,error)
  if (error)  return
  !
end subroutine mrtindex_ix_sort
!
subroutine mrtindex_ix_setnum(ix,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_ix_setnum
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(inout) :: ix
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: ient,iprev,num
  !
  if (ix%next.le.1)  return
  !
  num = 1
  iprev = 1
  ix%num(1) = num
  ix%islast(1) = .false.
  !
  ! This works because IX has been sorted with those criterions
  do ient=2,ix%next-1
    if (ix%dobs(ient).ne.ix%dobs(iprev) .or.  &
        ix%scan(ient).ne.ix%scan(iprev) .or.  &
        ix%backend(ient).ne.ix%backend(iprev)) then
      num = num+1
      iprev = ient
      ix%islast(ient-1) = .true.
    endif
    ix%num(ient) = num
    ix%islast(ient) = .false.
  enddo
  !
  ix%islast(ix%next-1) = .true.
  !
end subroutine mrtindex_ix_setnum
!
subroutine mrtindex_ix_close(error)
  use mrtindex_interfaces, except_this=>mrtindex_ix_close
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Close all index files used in IX
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: ifile
  !
  do ifile=1,ix_ndir
    if (ix_files(ifile)%lun.ne.0) then
      call mrtindex_file_close(ix_files(ifile),error)
      ! if (error)  continue
    endif
  enddo
  !
  ix_ndir = 0
  ox_fileid = 0  ! Forget the previous INDEX OUTPUT, because it is IN-OUT
  !
end subroutine mrtindex_ix_close
!
subroutine reallocate_index_ibuf(file,error)
  use classic_api
  use mrtindex_interfaces, except_this=>reallocate_index_ibuf
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate the Input working buffers according to given file
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  !
  !
  call reallocate_recordbuf(ibufobs,file%desc%reclen,error)
  if (error)  return
  call reallocate_recordbuf(ibufbi,file%desc%reclen,error)
  if (error)  return
  !
end subroutine reallocate_index_ibuf
!
subroutine reallocate_index_obuf(file,error)
  use classic_api
  use mrtindex_interfaces, except_this=>reallocate_index_obuf
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  Reallocate the Ouput working buffers according to given file
  !---------------------------------------------------------------------
  type(classic_file_t), intent(in)    :: file   !
  logical,              intent(inout) :: error  !
  !
  call reallocate_recordbuf(obufobs,file%desc%reclen,error)
  if (error)  return
  call reallocate_recordbuf(obufbi,file%desc%reclen,error)
  if (error)  return
  !
end subroutine reallocate_index_obuf

module greg_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Greg interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use greg_interfaces_private
  use greg_interfaces_public
  !
end module greg_interfaces
!
module greg_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GREG dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gmath_interfaces_public
  use gwcs_interfaces_public
  use gio_interfaces_public
  use sic_interfaces_public
  use gchar_interfaces_public
  use gcont_interfaces_public
  use gtv_interfaces_public
end module greg_dependencies_interfaces

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_tuning
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_keyval_types
  use cubesimulate_messaging
  !
  public :: tuning_comm_t,tuning_prog_t
  public :: tuning_comm,tuning_prog
  private
  !
  type :: tuning_comm_t
     type(option_t), pointer  :: comm
     type(keyval_strg_comm_t) :: line
     type(keyvalunit_dble_comm_t) :: freq
   contains
     procedure, public  :: register => cubesimulate_tuning_comm_register
     procedure, private :: parse    => cubesimulate_tuning_comm_parse
     procedure, private :: main     => cubesimulate_tuning_comm_main
  end type tuning_comm_t
  type(tuning_comm_t), target :: tuning_comm
  !
  type tuning_user_t
     logical :: dolist = .false.
     type(keyval_strg_user_t) :: line
     type(keyvalunit_dble_user_t) :: freq
   contains
     procedure, private :: toprog => cubesimulate_tuning_user_toprog
  end type tuning_user_t
  !
  type tuning_prog_t
     character(len=line_l) :: line = '13CO(1-0)'   ! 
     real(kind=coor_k)     :: freq = 110201.3543d0 ! Signal Frequency
     real(kind=coor_k)     :: fima = 0d0           ! Image  Frequency
     real(kind=coor_k)     :: wave = 0d0           ! Signal Wavelength
   contains
     procedure, public  :: list   => cubesimulate_tuning_prog_list
     procedure, private :: header => cubesimulate_tuning_prog_header
  end type tuning_prog_t
  type(tuning_prog_t), target :: tuning_prog
  !
contains
  !
  subroutine cubesimulate_tuning_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(tuning_user_t) :: user
    character(len=*), parameter :: rname='TUNING>COMMAND'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call tuning_comm%parse(line,user,error)
    if (error) return
    call tuning_comm%main(user,tuning_prog,error)
    if (error) continue
  end subroutine cubesimulate_tuning_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubesimulate_tuning_comm_register(comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(tuning_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUNING>COMM>REGISTER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'TUNING','',&
         'Set or list the receiver tuning',&
         'Without options, list the current line label, rest frequency,&
         & image frequency, and wavelength. Use /LINE and /FREQUENCY to&
         & update the stored tuning state.',&
         cubesimulate_tuning_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%line%register(&
         'LINE',&
         'Observed line label',&
         'Set the stored observed-line label. The label is&
         & informational only and does not change /FREQUENCY.',&
         tuning_prog%line,&
         'Observed line label.',&
         error)
    if (error) return
    call comm%freq%register(&
         'FREQUENCY',&
         'Rest frequency of the observed line',&
         'Set the rest frequency used to derive the image&
         & frequency and wavelength. The current image-frequency rule is&
         & rest frequency minus 8000 MHz. The value must stay > 0 after&
         & unit conversion.',&
         tuning_prog%freq,&
         code_unit_freq,&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubesimulate_tuning_comm_register
  !
  subroutine cubesimulate_tuning_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! TUNING
    !----------------------------------------------------------------------
    class(tuning_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(tuning_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUNING>COMM>PARSE'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (cubetools_nopt().eq.0) then
       user%dolist = .true.
    else
       user%dolist = .false.
       call comm%line%parse(line,user%line,error)
       if (error) return
       call comm%freq%parse(line,user%freq,error)
       if (error) return
    endif
  end subroutine cubesimulate_tuning_comm_parse
  !
  subroutine cubesimulate_tuning_comm_main(comm,user,prog,error) 
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(tuning_comm_t), intent(in)    :: comm
    type(tuning_user_t),  intent(inout) :: user
    type(tuning_prog_t),  intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUNING>COMM>MAIN'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (user%dolist) then
       call prog%header(comm,error)
       if (error) return
       call prog%list(comm,error)
       if (error) return
    else
       call user%toprog(comm,prog,error)
       if (error) return
       call prog%header(comm,error)
       if (error) return
    endif
  end subroutine cubesimulate_tuning_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_tuning_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(tuning_user_t), intent(in)    :: user
    type(tuning_comm_t),  intent(in)    :: comm    
    type(tuning_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUNING>USER>TOPROG'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call user%line%toprog(comm%line,prog%line,error)
    if (error) return
    call user%freq%toprog(comm%freq,prog%freq,error)
    if (error) return
  end subroutine cubesimulate_tuning_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_tuning_prog_header(prog,comm,error)
    use phys_const
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(tuning_prog_t), intent(inout) :: prog
    type(tuning_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='TUNING>PROG>HEADER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (prog%freq.gt.0) then
       prog%fima = prog%freq-8000d0 !***JP: Needs a better definition that depends on LSB/USB tuning
       prog%wave = clight/prog%freq
    else
       call cubesimulate_message(seve%e,rname,'Negative or zero valued frequency')
       error = .true.
       return
    endif
  end subroutine cubesimulate_tuning_prog_header
  !
  subroutine cubesimulate_tuning_prog_list(prog,comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(tuning_prog_t), intent(inout) :: prog
    type(tuning_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    type(keyvalunit_list_t) :: keyvalunit
    type(keyval_strg_prog_t) :: keyval_strg
    type(keyvalunit_dble_prog_t) :: keyvalunit_dble
    character(len=*), parameter :: rname='TUNING>PROG>LIST'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call cubesimulate_message(seve%r,rname,blankstr)
    call cubesimulate_message(seve%r,rname,'Tuning')
    !
    call keyval_strg%list(comm%line,prog%line,error)
    if (error) return
    call keyvalunit_dble%list(comm%freq,prog%freq,error)
    if (error) return
    call keyvalunit%list('IMAGE FREQ',prog%fima,code_unit_freq,error)
    if (error) return
    call keyvalunit%list('WAVELENGTH',prog%wave,code_unit_wave,error)
    if (error) return
  end subroutine cubesimulate_tuning_prog_list
end module cubesimulate_tuning
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine write_sdm_calHolography(nmode, rmsu, rmsw, bmes, nscrew   &
    ,screwName, screwMotion, screwMotionError, surfaceMapUid,   &
    beamMapUid, error)
  use gildas_def
  use gkernel_interfaces
  use sdm_CalHolography
  use sdm_CalData
  use sdm_CalReduction
  use sdm_Enumerations
  !---------------------------------------------------------------------
  ! Write the calHolography SDM table, and related tables.
  !---------------------------------------------------------------------
  ! Dummy
  integer :: nmode, nscrew
  logical :: error
  real*8 bmes(7)
  real rmsu, rmsw, screwMotion(nscrew),   &
    screwMotionError(nscrew)
  character*12 screwName(nscrew)
  character*(*) surfaceMapUid, beamMapUid
  integer :: luid
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  include 'gbl_xpar.inc'
  include 'gbl_ypar.inc'
  include 'sdm_identifiers.inc'
  character :: version*20
  ! Local
  type(CalHolographyRow) :: chRow
  type(CalHolographyKey) :: chKey
  type(CalHolographyOpt) :: chOpt
  type(CalDataRow) :: cdRow
  type(CalDataKey) :: cdKey
  type(CalReductionRow) :: crRow
  type(CalReductionKey) :: crKey
  integer sig, ima, nfreq, ia, isb, ier, i, l
  integer ireturn, sdm_addCalDataRow, sdm_addCalReductionRow,   &
    sdm_addCalHolographyRow
  character sdmTable*16, uid*80
  parameter (sdmTable = 'calHolography')
  !---------------------------------------------------------------------
  include 'clic_version.inc'
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ! cal data table:
  cdRow%numScan = 1
!!  call allocCalDataRow(cdRow, cdRow%numScan, error)
  call allocCalDataRow(cdRow, error)
  if (error) return
  !
  cdRow%scanSet(1) = r_scan
  cdRow%calType = CalType_CAL_HOLOGRAPHY
  !     this is not stricly true, but we lost track of the time of actual
  !     load observations...
  !
  cdRow%startTimeObserved = time_interval(1)
  cdRow%endTimeObserved = time_interval(1)+time_interval(2)
  call addCalDataRow(cdKey, cdRow, error)
  if (error) goto 99
  !
  ! cal reduction table:
  !
  crRow%numApplied = 1
  crRow%numParam = 1
  crRow%numInvalidConditions = 1
!!!   call allocCalReductionRow(crRow, crRow%numApplied, crRow%numParam,   &
!!!     crRow%numInvalidConditions, error)
  call allocCalReductionRow(crRow, error)
  if (error) goto 99
  !
  !!crRow%calAppliedArray(1) = 'None'
  crRow%AppliedCalibrations(1) = 'None'
  crRow%paramSet(1) = 'None'
  !
  ! That's now! calculate...
  crRow%timeReduced = time_Interval(1) + time_Interval(2)
  crRow%messages = 'None'
  crRow%software = 'CLIC'
  crRow%softwareVersion = version
  crRow%invalidConditions = InvalidatingCondition_RECEIVER_EXCHANGE
  !
  call addCalReductionRow(crKey, crRow, error)
  if (error) goto 99
  !
  ! calHolography  table:
  !     TODO antenna name must somehow be saved in CLIC file! (holography
  !     section)
  if (r_kant(1).lt.100) then
    ia = r_kant(1)
    write (chKey%antennaName,'(a4,i2.2)')  'BURE',ia
  elseif (r_kant(1).lt.200) then
    ia = r_kant(1)-100
    write (chKey%antennaName,'(a4,i2.2)')  'ALMA',ia
  endif
  !
  chKey%CalReductionId = crKey%CalReductionId
  chKey%CalDataId = cdKey%CalDataId
  !
  ! in Data:
  !    integer :: numScrew
  ! this will be 2 for astronomical holography, probably.
  chRow%numReceptor = 1
!!!   call allocCalHolographyRow(chRow, chRow%numReceptor,   &
!!!     chRow%numScrew, error)
  call allocCalHolographyRow(chRow, error)
  if (error) return
  chOpt%numScrew = nscrew
  call allocCalHolographyOpt(chRow, chOpt, error)
  if (error) return
  !    integer*8 :: startValidTime
  !    integer*8 :: endValidTime
  chRow%startValidTime = cdRow%startTimeObserved
  chRow%endValidTime = -1      !???
  !    real*8, allocatable :: focusPosition(:) X, Y, Z
  chRow%focusPosition(1) = bmes(5)
  chRow%focusPosition(2) = bmes(6)
  chRow%focusPosition(3) = bmes(4)
  chRow%rawRms = rmsu
  chRow%weightedRms = rmsw
  ! could be X, I'm not sure
  chRow%polarizationTypes(1) = PolarizationType_Y
  do i=1, nscrew
    chOpt%screwName(i) = screwName(i)//char(0)
    chOpt%screwMotion(i) = screwMotion(i)
    chOpt%screwMotionError(i) = screwMotionError(i)
  enddo
  chRow%direction(1) = r_az
  chRow%direction(2) = r_el
  chRow%ambientTemperature = r_tamb
!!  chrow%panelModes = nmode
  chrow%numPanelModes = nmode
  !
  !     real*8 :: frequency
  if (i_band(1).eq.1) then
    chrow%frequencyRange = r_flo1+r_fif1
  elseif (i_band(1).eq.2) then
    chrow%frequencyRange = r_flo1-r_fif1
  else
    chrow%frequencyRange = r_flo1
  endif
  luid = lenc(surfaceMapUid)
  chrow%surfaceMapUID = '<EntityRef '//   &
    'entityId="'//surfaceMapuid(1:luid)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="holographyMap" '//   &
    'documentVersion="1"/>'
  luid = lenc(beamMapUid)
  chrow%beamMapUID = '<EntityRef '//   &
    'entityId="'//beamMapuid(1:luid)//   &
    '" partId="X00000002" '//   &
    'entityTypeName="beamMap" '//   &
    'documentVersion="1"/>'
  call addCalHolographyRow(chkey, chRow, error)
  if (error) return
  call addCalHolographyNumScrew(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewName(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewMotion(chkey, chOpt, error)
  if (error) return
  call addCalHolographyScrewMotionError(chkey, chOpt, error)
  if (error) return
  call sdmMessage(1,1,sdmTable ,'Written.')
99 return
end subroutine write_sdm_calHolography
!---------------------------------------------------------------------
!---------------------------------------------------------------------
!!! subroutine allocCalHolographyRow(row, numReceptor, numScrew,   &
!!!     error)
!!!   !
!!!   ! Allocate memory for a CalHolography Row.
!!!   !
!!!   use sdm_CalHolography
!!!   type(CalHolographyRow) :: row
!!!   integer :: numReceptor, numScrew, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*16 = 'calHolography'
!!!   ! focusPosition
!!!   if (allocated(row%focusPosition)) then
!!!     deallocate(row%focusPosition, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%focusPosition(3), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! frequencyRange
!!!   if (allocated(row%frequencyRange)) then
!!!     deallocate(row%frequencyRange, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequencyRange(2), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! direction
!!!   if (allocated(row%direction)) then
!!!     deallocate(row%direction, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%direction(2), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwName
!!!   if (allocated(row%screwName)) then
!!!     deallocate(row%screwName, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwName(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwMotion
!!!   if (allocated(row%screwMotion)) then
!!!     deallocate(row%screwMotion, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwMotion(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! screwMotionError
!!!   if (allocated(row%screwMotionError)) then
!!!     deallocate(row%screwMotionError, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%screwMotionError(numScrew), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! polarizationTypes
!!!   if (allocated(row%polarizationTypes)) then
!!!     deallocate(row%polarizationTypes, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%polarizationTypes(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!!! !
subroutine sdm_holoTimes(first, error)
  logical :: error, first
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'sdm_identifiers.inc'
  integer*8 times(2)
  !
  times(1) = ((dh_obs+60549.0d0)*86400.d0+dh_utc-0.5d0*dh_integ)   &
    *1d9
  times(2) = dh_integ*1d9
  if (first) then
    time_interval(1) = times(1)
    time_interval(2) = times(2)
  else
    time_interval(1) = min(time_interval(1), times(1))
    time_interval(2) = max(time_interval(1)+time_interval(2),   &
      times(1)+times(2)) - time_interval(1)
  endif
  return
end subroutine sdm_holoTimes

module sofia_types
  !
  type sofia_kalibrate_t
    ! Atmospheric model information
    character(len=12)   :: atmodel
    character(len=36)   :: atmid
    integer(kind=4)     :: atmarg
    ! Environment information
    real(kind=4)        :: tamb_sofi
    real(kind=4)        :: tempri1
    real(kind=4)        :: tempsec1
    ! Flight information
    real(kind=4)        :: gndspeed
    real(kind=4)        :: heading
    ! Instrument information
    character(len=16)   :: instrume
    character(len=32)   :: instcfg
    character(len=16)   :: frontend
    character(len=16)   :: backend
    ! Chopper information
    real(kind=4)        :: schpfrq
    real(kind=4)        :: chpamp1
    real(kind=8)        :: chpangle
    ! Mission management
    character(len=32)   :: datasrc
    character(len=32)   :: observer
    character(len=32)   :: operater ! operator is a keyword even in Fortran
    character(len=32)   :: planid
    character(len=32)   :: mission_id
    character(len=32)   :: obs_id
    ! Atmospheric calibration parameters
    real(kind=4)        :: pwv_mm
    real(kind=4)        :: err_pwv_mm
    integer(kind=4)     :: fit_pwv_mm
    real(kind=8)        :: ratio_f_th
    real(kind=4)        :: dry_atm
    real(kind=4)        :: err_dry_atm
    integer(kind=4)     :: fit_dry_atm
    real(kind=4)        :: dry_ratio
    real(kind=4)        :: err_dry_ratio
    integer(kind=4)     :: fit_dry_ratio
    real(kind=4)        :: tcold_scale
    real(kind=4)        :: err_tcold_scale
    integer(kind=4)     :: fit_tcold_scale
    real(kind=4)        :: tcold_ratio
    real(kind=4)        :: err_tcold_ratio
    integer(kind=4)     :: fit_tcold_ratio
    real(kind=4)        :: chisq
    real(kind=4)        :: pwv_ratio
    real(kind=4)        :: err_pwv_ratio
    integer(kind=4)     :: fit_pwv_ratio
    real(kind=4)        :: dry_off
    real(kind=4)        :: err_dry_off
    integer(kind=4)     :: fit_dry_off
    real(kind=4)        :: dry_off_ratio
    real(kind=4)        :: err_dry_off_ratio
    integer(kind=4)     :: fit_dry_off_ratio
    integer(kind=4)     :: last_load
    real(kind=8)        :: freq_off
    ! Beam rotator related angles
    real(kind=8)        :: posangle
    real(kind=8)        :: beamangle
    real(kind=8)        :: anglediff
    real(kind=8)        :: rxdx
    real(kind=8)        :: rxdy
    real(kind=8)        :: refrxdx
    real(kind=8)        :: refrxdy
    integer(kind=4)     :: signrxdx
    integer(kind=4)     :: signrxdy
    real(kind=8)        :: focallength
    ! Atmospheric model
    integer(kind=4)     :: atm_model_dim(2)
    real(kind=4), allocatable :: atm_model_data(:,:)
    character(len=12), allocatable :: atm_model_param(:)
    ! Runtime setup of kalibrate
    character(len=256)  :: kalibraterc
    character(len=256)  :: kalibrate_args
    character(len=256)  :: processing_steps
    character(len=256)  :: backend_grouping
    ! Observation setup
    character(len=32)   :: aor_id
    integer(kind=4)     :: aot_id_len
    character(len=4), allocatable :: aot_id(:)
    real(kind=4)        :: main_beam_eff
    integer(kind=4)     :: pi_name_len
    character(len=4), allocatable :: pi_name(:)
  end type sofia_kalibrate_t
  !
end module sofia_types
!
subroutine sofia_fromclass1(skdata,version)
  use sofia_types
  use class_api
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  type(sofia_kalibrate_t), intent(out) :: skdata   ! The data to be filled with the Class buffer
  integer(kind=4),         intent(in)  :: version  ! The version of the data
  !
  ! print *,'>>> Entering sofia_fromclass1'
  !
  call class_user_classtodata(skdata%atmodel)
  call class_user_classtodata(skdata%atmid)
  call class_user_classtodata(skdata%atmarg)

  if (version .lt. 2) then
    return
  end if

  call class_user_classtodata(skdata%tamb_sofi)
  call class_user_classtodata(skdata%tempri1)
  call class_user_classtodata(skdata%tempsec1)

  call class_user_classtodata(skdata%gndspeed)
  call class_user_classtodata(skdata%heading)

  call class_user_classtodata(skdata%instrume)
  call class_user_classtodata(skdata%instcfg)
  call class_user_classtodata(skdata%frontend)
  call class_user_classtodata(skdata%backend)

  call class_user_classtodata(skdata%schpfrq)
  call class_user_classtodata(skdata%chpamp1)
  call class_user_classtodata(skdata%chpangle)

  if (version .lt. 3) then
    return
  end if

  call class_user_classtodata(skdata%datasrc)
  call class_user_classtodata(skdata%observer)
  call class_user_classtodata(skdata%operater)
  call class_user_classtodata(skdata%planid)
  call class_user_classtodata(skdata%mission_id)
  call class_user_classtodata(skdata%obs_id)

  if (version .lt. 4) then
    return
  end if

  call class_user_classtodata(skdata%pwv_mm)
  call class_user_classtodata(skdata%err_pwv_mm)
  call class_user_classtodata(skdata%fit_pwv_mm)

  call class_user_classtodata(skdata%ratio_f_th)

  call class_user_classtodata(skdata%dry_atm)
  call class_user_classtodata(skdata%err_dry_atm)
  call class_user_classtodata(skdata%fit_dry_atm)

  call class_user_classtodata(skdata%dry_ratio)
  call class_user_classtodata(skdata%err_dry_ratio)
  call class_user_classtodata(skdata%fit_dry_ratio)

  call class_user_classtodata(skdata%tcold_scale)
  call class_user_classtodata(skdata%err_tcold_scale)
  call class_user_classtodata(skdata%fit_tcold_scale)

  call class_user_classtodata(skdata%tcold_ratio)
  call class_user_classtodata(skdata%err_tcold_ratio)
  call class_user_classtodata(skdata%fit_tcold_ratio)

  if (version .lt. 5) then
    return
  end if

  call class_user_classtodata(skdata%chisq)

  if (version .lt. 6) then
    return
  end if

  call class_user_classtodata(skdata%pwv_ratio)
  call class_user_classtodata(skdata%err_pwv_ratio)
  call class_user_classtodata(skdata%fit_pwv_ratio)

  if (version .lt. 7) then
    return
  end if

  call class_user_classtodata(skdata%dry_off)
  call class_user_classtodata(skdata%err_dry_off)
  call class_user_classtodata(skdata%fit_dry_off)

  call class_user_classtodata(skdata%dry_off_ratio)
  call class_user_classtodata(skdata%err_dry_off_ratio)
  call class_user_classtodata(skdata%fit_dry_off_ratio)

  if (version .lt. 8) then
    return
  end if

  call class_user_classtodata(skdata%last_load)

  if (version .lt. 9) then
    return
  end if

  call class_user_classtodata(skdata%freq_off)

  if (version .lt. 10) then
    return
  end if

  call class_user_classtodata(skdata%posangle)
  call class_user_classtodata(skdata%beamangle)
  call class_user_classtodata(skdata%anglediff)

  if (version .lt. 11) then
    return
  end if

  call class_user_classtodata(skdata%rxdx)
  call class_user_classtodata(skdata%rxdy)
  call class_user_classtodata(skdata%refrxdx)
  call class_user_classtodata(skdata%refrxdy)
  call class_user_classtodata(skdata%signrxdx)
  call class_user_classtodata(skdata%signrxdy)
  call class_user_classtodata(skdata%focallength)

  if (version .lt. 12) then
    return
  end if

  call class_user_classtodata(skdata%atm_model_dim)
  if (allocated(skdata%atm_model_data)) then
    deallocate(skdata%atm_model_data)
  end if
  allocate(skdata%atm_model_data(skdata%atm_model_dim(1),skdata%atm_model_dim(2)))
  call class_user_classtodata(skdata%atm_model_data)

  if (version .lt. 13) then
    return
  end if

  if (allocated(skdata%atm_model_param)) then
    deallocate(skdata%atm_model_param)
  end if
  allocate(skdata%atm_model_param(skdata%atm_model_dim(1)))
  call class_user_classtodata(skdata%atm_model_param)

  if (version .lt. 14) then
    return
  end if
  call class_user_classtodata(skdata%kalibraterc)
  call class_user_classtodata(skdata%kalibrate_args)
  call class_user_classtodata(skdata%processing_steps)
  call class_user_classtodata(skdata%backend_grouping)

  if (version .lt. 15) then
     return
  end if
  call class_user_classtodata(skdata%aor_id)
  call class_user_classtodata(skdata%aot_id_len)
  if (allocated(skdata%aot_id)) then
     deallocate(skdata%aot_id)
  end if
  allocate(skdata%aot_id(skdata%aot_id_len/4))
  call class_user_classtodata(skdata%aot_id)
  if (version .lt. 16) then
     return
  end if
  call class_user_classtodata(skdata%main_beam_eff)

  call class_user_classtodata(skdata%pi_name_len)
  if (allocated(skdata%pi_name)) then
     deallocate(skdata%pi_name)
  end if
  allocate(skdata%pi_name(skdata%pi_name_len/4))
  call class_user_classtodata(skdata%pi_name)
  return
  !
end subroutine sofia_fromclass1
!
subroutine sofia_dump1(version,error)
  use sofia_types
  !---------------------------------------------------------------------
  ! Hook for command LAS\DUMP
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version  ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  type(sofia_kalibrate_t) :: skdata   ! The data to be listed
  !
  ! print *,'>>> Entering sofia_dump1 for version ',version
  !
  call sofia_fromclass1(skdata,version)
  !
  print *,' atmodel            = ',skdata%atmodel
  print *,' atmid              = ',skdata%atmid
  print *,' atmarg             = ',skdata%atmarg

  if (version .lt. 2) then
    return
  end if

  print *,' tamb_sofi          = ',skdata%tamb_sofi
  print *,' tempri1            = ',skdata%tempri1
  print *,' tempsec1           = ',skdata%tempsec1

  print *,' gndspeed           = ',skdata%gndspeed
  print *,' heading            = ',skdata%heading

  print *,' instrume           = ',skdata%instrume
  print *,' instcfg            = ',skdata%instcfg
  print *,' frontend           = ',skdata%frontend
  print *,' backend            = ',skdata%backend

  print *,' schpfrq            = ',skdata%schpfrq
  print *,' chpamp1            = ',skdata%chpamp1
  print *,' chpangle           = ',skdata%chpangle

  if (version .lt. 3) then
    return
  end if

  print *,' datasrc            = ',skdata%datasrc
  print *,' observer           = ',skdata%observer
  print *,' operator           = ',skdata%operater
  print *,' planid             = ',skdata%planid
  print *,' mission_id         = ',skdata%mission_id
  print *,' obs_id             = ',skdata%obs_id

  if (version .lt. 4) then
    return
  end if

  print *,' pwv_mm             = ',skdata%pwv_mm
  print *,' err_pwv_mm         = ',skdata%err_pwv_mm
  print *,' fit_pwv_mm         = ',skdata%fit_pwv_mm

  print *,' ratio_f_th         = ',skdata%ratio_f_th

  print *,' dry_atm            = ',skdata%dry_atm
  print *,' err_dry_atm        = ',skdata%err_dry_atm
  print *,' fit_dry_atm        = ',skdata%fit_dry_atm

  print *,' dry_ratio          = ',skdata%dry_ratio
  print *,' err_dry_ratio      = ',skdata%err_dry_ratio
  print *,' fit_dry_ratio      = ',skdata%fit_dry_ratio

!  print *,' tcold_scale        = ',skdata%tcold_scale
!  print *,' err_tcold_scale    = ',skdata%err_tcold_scale
!  print *,' fit_tcold_scale    = ',skdata%fit_tcold_scale

!  print *,' tcold_ratio        = ',skdata%tcold_ratio
!  print *,' err_tcold_ratio    = ',skdata%err_tcold_ratio
!  print *,' fit_tcold_ratio    = ',skdata%fit_tcold_ratio

  if (version .lt. 5) then
    return
  end if

  print *,' chisq              = ',skdata%chisq

  if (version .lt. 6) then
    return
  end if

  print *,' pwv_ratio          = ',skdata%pwv_ratio
  print *,' err_pwv_ratio      = ',skdata%err_pwv_ratio
  print *,' fit_pwv_ratio      = ',skdata%fit_pwv_ratio

  if (version .lt. 7) then
    return
  end if

  print *,' dry_off            = ',skdata%dry_off
  print *,' err_dry_off        = ',skdata%err_dry_off
  print *,' fit_dry_off        = ',skdata%fit_dry_off

  print *,' dry_off_ratio      = ',skdata%dry_off_ratio
  print *,' err_dry_off_ratio  = ',skdata%err_dry_off_ratio
  print *,' fit_dry_off_ratio  = ',skdata%fit_dry_off_ratio

  if (version .lt. 8) then
    return
  end if

  print *,' last_load          = ',skdata%last_load

  if (version .lt. 9) then
    return
  end if

  print *,' freq_off           = ',skdata%freq_off

  if (version .lt. 10) then
    return
  end if

  print *,' posangle           = ',skdata%posangle
  print *,' beamangle          = ',skdata%beamangle
  print *,' anglediff          = ',skdata%anglediff

  if (version .lt. 11) then
    return
  end if

  print *,' rxdx               = ',skdata%rxdx
  print *,' rxdy               = ',skdata%rxdy
  print *,' refrxdx            = ',skdata%refrxdx
  print *,' refrxdy            = ',skdata%refrxdy
  print *,' signrxdx           = ',skdata%signrxdx
  print *,' signrxdy           = ',skdata%signrxdy
  print *,' focallength        = ',skdata%focallength

  if (version .lt. 12) then
    return
  end if

  print *,' atm_model_dim      = ',skdata%atm_model_dim
  print *,' atm_model_data     = (2-D array)'

  if (version .lt. 13) then
    return
  end if

  print *,' atm_model_param    = (string array)'

  if (version .lt. 14) then
    return
  end if

  print *,' kalibraterc        = ',trim(skdata%kalibraterc)
  print *,' kalibrate_args     = ',trim(skdata%kalibrate_args)
  print *,' processing_steps   = ',trim(skdata%processing_steps)
  print *,' backend_grouping   = ',trim(skdata%backend_grouping)

  if (version .lt. 15) then
     return
  end if

  print *,' aor_id             = ',skdata%aor_id
  print *,' aot_id_len         = ',skdata%aot_id_len
  print *,' aot_id             =  (character array)'

  if (version .lt. 16) then
     return
  end if

  print *,' main_beam_eff      = ',skdata%main_beam_eff
  print *,' pi_name_len        = ',skdata%pi_name_len
  print *,' pi_name            =  (character array)'

  return
  !
end subroutine sofia_dump1
!
subroutine sofia_setvar1(version,error)
  use gbl_message
  use class_api
  use sofia_types
  !---------------------------------------------------------------------
  ! Hook for command LAS\SET VARIABLE USER
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: version  ! The version of the data
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: ndim,dims(4)
  character(len=*), parameter :: rname='SOFIA_SETVAR1'
  !
  ! print *,'>>> Entering sofia_setvar1 for version ',version
  !
  error = .false.
  ndim = 0
  call class_user_def_char('ATMODEL',12,error)
  call class_user_def_char('ATMID',36,error)
  call class_user_def_inte('ATMARG',ndim,dims,error)

  if (version .lt. 2) then
    return
  end if

  call class_user_def_real('TAMB_SOFI',ndim,dims,error)
  call class_user_def_real('TEMPRI1',ndim,dims,error)
  call class_user_def_real('TEMPSEC1',ndim,dims,error)

  call class_user_def_real('GNDSPEED',ndim,dims,error)
  call class_user_def_real('HEADING',ndim,dims,error)

  call class_user_def_char('INSTRUME',16,error)
  call class_user_def_char('INSTCFG',32,error)
  call class_user_def_char('FRONTEND',16,error)
  call class_user_def_char('BACKEND',16,error)

  call class_user_def_real('SCHPFRQ',ndim,dims,error)
  call class_user_def_real('CHPAMP1',ndim,dims,error)
  call class_user_def_dble('CHPANGLE',ndim,dims,error)

  if (version .lt. 3) then
    return
  end if

  call class_user_def_char('DATASRC',32,error)
  call class_user_def_char('OBSERVER',32,error)
  call class_user_def_char('OPERATOR',32,error)
  call class_user_def_char('PLANID',32,error)
  call class_user_def_char('MISSION_ID',32,error)
  call class_user_def_char('OBS_ID',32,error)

  if (version .lt. 4) then
    return
  end if

  call class_user_def_real('PWV_MM',ndim,dims,error)
  call class_user_def_real('ERR_PWV_MM',ndim,dims,error)
  call class_user_def_inte('FIT_PWV_MM',ndim,dims,error)

  call class_user_def_dble('RATIO_F_TH',ndim,dims,error)

  call class_user_def_real('DRY_ATM',ndim,dims,error)
  call class_user_def_real('ERR_DRY_ATM',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_ATM',ndim,dims,error)

  call class_user_def_real('DRY_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_DRY_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_RATIO',ndim,dims,error)

  call class_user_def_real('TCOLD_SCALE',ndim,dims,error)
  call class_user_def_real('ERR_TCOLD_SCALE',ndim,dims,error)
  call class_user_def_inte('FIT_TCOLD_SCALE',ndim,dims,error)

  call class_user_def_real('TCOLD_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_TCOLD_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_TCOLD_RATIO',ndim,dims,error)

  if (version .lt. 5) then
    return
  end if

  call class_user_def_real('CHISQ',ndim,dims,error)

  if (version .lt. 6) then
    return
  end if

  call class_user_def_real('PWV_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_PWV_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_PWV_RATIO',ndim,dims,error)

  if (version .lt. 7) then
    return
  end if

  call class_user_def_real('DRY_OFF',ndim,dims,error)
  call class_user_def_real('ERR_DRY_OFF',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_OFF',ndim,dims,error)

  call class_user_def_real('DRY_OFF_RATIO',ndim,dims,error)
  call class_user_def_real('ERR_DRY_OFF_RATIO',ndim,dims,error)
  call class_user_def_inte('FIT_DRY_OFF_RATIO',ndim,dims,error)

  if (version .lt. 8) then
    return
  end if

  call class_user_def_inte('LAST_LOAD',ndim,dims,error)

  if (version .lt. 9) then
    return
  end if

  call class_user_def_dble('FREQ_OFF',ndim,dims,error)

  if (version .lt. 10) then
    return
  end if

  call class_user_def_dble('POSANGLE',ndim,dims,error)
  call class_user_def_dble('BEAMANGLE',ndim,dims,error)
  call class_user_def_dble('ANGLEDIFF',ndim,dims,error)

  if (version .lt. 11) then
    return
  end if

  call class_user_def_dble('RXDX',ndim,dims,error)
  call class_user_def_dble('RXDY',ndim,dims,error)
  call class_user_def_dble('REFRXDX',ndim,dims,error)
  call class_user_def_dble('REFRXDY',ndim,dims,error)
  call class_user_def_inte('SIGNRXDX',ndim,dims,error)
  call class_user_def_inte('SIGNRXDY',ndim,dims,error)
  call class_user_def_dble('FOCALLENGTH',ndim,dims,error)

  if (version .lt. 12) then
    return
  end if

  ndim = 1
  dims(1) = 2
  call class_user_def_inte('ATM_MODEL_DIM',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%ATM_MODEL_DIM[1]',dims(1),error)
  if (error) then
    call class_message(seve%e, rname, 'Cannot get R%USER%SOFIA%ATM_MODEL_DIM[1]')
    return
  end if
  call sic_get_inte('R%USER%SOFIA%ATM_MODEL_DIM[2]',dims(2),error)
  if (error) then
    call class_message(seve%e, rname, 'Cannot get R%USER%SOFIA%ATM_MODEL_DIM[2]')
    return
  end if
  if (dims(1)*dims(2) .gt. 0) then
    ndim = 2
    call class_user_def_real('ATM_MODEL_DATA',ndim,dims,error)
  end if
  ndim = 0

  if (version .lt. 13) then
    return
  end if

  if (dims(1) .gt. 0) then
    call class_user_def_char('ATM_MODEL_PARAM',12*dims(1),error)
  end if

  if (version .lt. 14) then
    return
  end if

  call class_user_def_char('KALIBRATERC',256,error)
  call class_user_def_char('KALIBRATE_ARGS',256,error)
  call class_user_def_char('PROCESSING_STEPS',256,error)
  call class_user_def_char('BACKEND_GROUPING',256,error)

  if (version .lt. 15) then
     return
  end if

  call class_user_def_char('AOR_ID',32,error)
  call class_user_def_inte('AOT_ID_LEN',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%AOT_ID_LEN',dims(1),error)
  if (error) then
     call class_message(seve%e, rname, 'Cannot get AOT_ID_LEN')
     return
  end if
  call class_user_def_char('AOT_ID',dims(1),error)

  if (version .lt. 16) then
     return
  end if
  call class_user_def_real('MAIN_BEAM_EFF',ndim,dims,error)
  call class_user_def_inte('PI_NAME_LEN',ndim,dims,error)
  call sic_get_inte('R%USER%SOFIA%PI_NAME_LEN',dims(1),error)
  if (error) then
     call class_message(seve%e, rname, 'Cannot get PI_NAME_LEN')
     return
  end if
  call class_user_def_char('PI_NAME',dims(1),error)

  return
  !
end subroutine sofia_setvar1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_write_command(line,error)
  use mrtcal_messaging
  use mrtcal_buffers
  use mrtcal_interfaces, except_this => mrtcal_write_command
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command WRITE
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>COMMAND'
  integer(kind=4) :: nspec
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  nspec = 0
  call mrtcal_write_toclass(rfile%subscanbuf%databuf%mrtc,rsetup%out,nspec,error)
  if (error)  return
  !
  ! ZZZ feedback nspec?
  !
end subroutine mrtcal_write_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_write_chunkset3d_toclass(chunkset_3d,out,nspec,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_write_chunkset3d_toclass
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_write_toclass
  ! Convert the input chunk sets to Class observations
  ! This version for 3D chunk sets (i.e. not yet time averaged)
  !---------------------------------------------------------------------
  type(chunkset_3d_t),         intent(in)    :: chunkset_3d
  type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
  integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
  logical,                     intent(inout) :: error
  ! Local
  integer(kind=4) :: itime,ipix,iset
  character(len=*), parameter :: rname='WRITE>CHUNSET3D>TOCLASS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select case (chunkset_3d%kind)
  case (ckind_time)
    ! Convert chunk sets to Class observations
    do itime=1,chunkset_3d%ntime
      do ipix=1,chunkset_3d%npix
        do iset=1,chunkset_3d%nset
          call mrtcal_write_chunkset_toclass(  &
            chunkset_3d%chunkset(iset,ipix,itime),out,nspec,error)
          if (error)  return
        enddo
      enddo
    enddo
    !
  case (ckind_calib)
    ! Convert chunk sets to Class observations, but the Ntime dimension
    ! produces a single spectrum including (N-1) associated arrays.
    do ipix=1,chunkset_3d%npix
      do iset=1,chunkset_3d%nset
        call mrtcal_write_chunkset_toclass(  &
         chunkset_3d%chunkset(iset,ipix,:),out,nspec,error)
         if (error)  return
      enddo
    enddo
    !
  case (ckind_onoff)
    ! Collections of ON-OFF
    if (chunkset_3d%ntime.eq.1) then
      ! "time" dimension is 1: write as is
      do ipix=1,chunkset_3d%npix
        do iset=1,chunkset_3d%nset
          call mrtcal_write_chunkset_toclass(  &
            chunkset_3d%chunkset(iset,ipix,1),out,nspec,error)
          if (error)  return
        enddo
      enddo
    elseif (chunkset_3d%ntime.eq.2) then
      ! "time" dimension if 2: assume frequency switch and fold them together
      do ipix=1,chunkset_3d%npix
        do iset=1,chunkset_3d%nset
          ! The chunksets are sent separately to avoid array contiguity issues.
          call mrtcal_write_chunkset_fsw_toclass(  &
            chunkset_3d%chunkset(iset,ipix,1),     &
            chunkset_3d%chunkset(iset,ipix,2),     &
            out,nspec,error)
          if (error)  return
        enddo
      enddo
    else
      call mrtcal_message(seve%e,rname,'Kind of chunkset 3D not supported (1)')
      error = .true.
      return
    endif
    !
  case default
    call mrtcal_message(seve%e,rname,'Kind of chunkset 3D not supported (2)')
    error = .true.
    return
  end select
  !
end subroutine mrtcal_write_chunkset3d_toclass
!
subroutine mrtcal_write_chunkset2d_toclass(data_2d,out,nspec,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_write_chunkset2d_toclass
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_write_toclass
  ! Convert the input chunk sets to Class observations
  ! This version for 2D chunk sets (i.e. already time averaged)
  !---------------------------------------------------------------------
  type(chunkset_2d_t),           intent(in)    :: data_2d  ! The data RY to be written
  type(mrtcal_setup_output_t),   intent(in)    :: out      ! Output configuration
  integer(kind=4),               intent(inout) :: nspec    ! Cumulative number of spectra written
  logical,                       intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='WRITE>CHUNSET2D>TOCLASS'
  integer(kind=size_length) :: ipix,iset,ichunk
  type(chunkset_t), pointer :: data
  type(chunkset_t) :: twosets(2)
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (out%weight) then
    ! Write each spectrum, plus its weight array as an Associated Array. We
    ! have to split RY (data1) and W (dataw) in 2 different chunksets.
    ! mrtcal_write_chunkset_toclass will understand it has to write the
    ! first one as the main spectrum and the second one as an Associated
    ! Array.
    !
    do ipix=1,data_2d%npix
      do iset=1,data_2d%nset
        data => data_2d%chunkset(iset,ipix)
        !
        ! Create a pair of chunksets. First is the spectrum, just need
        ! pointers. Minor cost, no data duplicated.
        call twosets(1)%reassociate(data,error)
        if (error)  return
        !
        ! Second is the weight array, but we need to duplicate it to store the
        ! dataw(:) as data1(:) in a new chunkset. This needs another allocated
        ! chunkset:
        call twosets(2)%clone(data,.true.,error)
        if (error)  return
        !
        do ichunk=1,twosets(2)%n
          twosets(2)%chunks(ichunk)%pos%sourc = 'W'
          twosets(2)%chunks(ichunk)%data1(:) = data%chunks(ichunk)%dataw(:)
        enddo
        !
        ! Write this pair as 1 spectrum + 1 associated array
        call mrtcal_write_chunkset_toclass(twosets,out,nspec,error)
        if (error)  return
        !
      enddo ! iset
    enddo ! ipix
    ! NB: we free only twosets(2). twosets(1) was only associated
    call twosets(2)%free(error)
    if (error)  return
    !
  else
    !
    do ipix=1,data_2d%npix
      do iset=1,data_2d%nset
        call mrtcal_write_chunkset_toclass(data_2d%chunkset(iset,ipix),out,nspec,error)
        if (error)  return
      enddo ! iset
    enddo ! ipix
    !
  endif
  !
end subroutine mrtcal_write_chunkset2d_toclass
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_write_chunkset0d_toclass(chunkset0d,out,nspec,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_write_chunkset0d_toclass
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_write_chunkset_toclass
  !  Write a single chunk set to the Class output file by chunk or
  !  by set of chunks
  !---------------------------------------------------------------------
  type(chunkset_t),            intent(in)    :: chunkset0d
  type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
  integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
  logical,                     intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>CHUNKSET0D>TOCLASS'
  integer(kind=4) :: ichunk
  type(chunkset_t) :: single
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (out%bychunk) then
    ! Convert each chunk
    if (out%toclass) then
      do ichunk=1,chunkset0d%n
        ! Create a dummy chunkset containing a single chunk
        call single%reassociate(chunkset0d,error,ichunk)
        if (error)  return
        call mrtcal_chunkset_to_obs(single,error)
        if (error)  return
      enddo
    endif
    nspec = nspec+chunkset0d%n
  else
    ! Stitch by set of chunks and convert
    if (out%toclass) then
      call mrtcal_chunkset_to_obs(chunkset0d,error)
      if (error)  return
    endif
    nspec = nspec+1
  endif
  !
end subroutine mrtcal_write_chunkset0d_toclass
!
subroutine mrtcal_write_chunkset1d_toclass(chunkset1d,out,nspec,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_write_chunkset1d_toclass
  !---------------------------------------------------------------------
  ! @ private-generic mrtcal_write_chunkset_toclass
  !  Write a single chunk set to the Class output file by chunk or
  !  by set of chunks
  !---------------------------------------------------------------------
  type(chunkset_t),            intent(in)    :: chunkset1d(:)
  type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
  integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
  logical,                     intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>CHUNKSET1D>TOCLASS'
  integer(kind=4) :: nchunk,ichunk,nset,iset
  type(chunkset_t), allocatable :: single1d(:)
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (out%bychunk) then
    ! Convert each chunk
    nchunk = chunkset1d(1)%n  ! Assume all chunkset have same number of chunks
    if (out%toclass) then
      nset = size(chunkset1d)
      allocate(single1d(nset))
      do ichunk=1,nchunk
        ! Create a dummy chunkset1d with single chunk each
        do iset=1,nset
          call single1d(iset)%reassociate(chunkset1d(iset),error,ichunk)
          if (error)  return
        enddo
        call mrtcal_chunkset_to_obs(single1d,error)
        if (error)  return
      enddo
      deallocate(single1d)
    endif
    nspec = nspec+nchunk
  else
    ! Stitch by set of chunks and convert
    if (out%toclass) then
      call mrtcal_chunkset_to_obs(chunkset1d,error)
      if (error)  return
    endif
    nspec = nspec+1
  endif
  !
end subroutine mrtcal_write_chunkset1d_toclass
!
subroutine mrtcal_write_chunkset_fsw_toclass(chunkset1,chunkset2,out,nspec,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_write_chunkset_fsw_toclass
  !---------------------------------------------------------------------
  ! @ private
  !  Specific to FSW data
  !  Fold the pair of chunksets and produce a single class spectrum
  !---------------------------------------------------------------------
  type(chunkset_t),            intent(in)    :: chunkset1
  type(chunkset_t),            intent(in)    :: chunkset2
  type(mrtcal_setup_output_t), intent(in)    :: out    ! Output configuration
  integer(kind=4),             intent(inout) :: nspec  ! Cumulative number of spectra written
  logical,                     intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>CHUNKSET>FSW>TOCLASS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (out%bychunk) then
    ! Probably not worth implementing this mode. The chunks are typically
    ! 20 Mhz while the throw is about 5 to 10 MHz => we would loose almost
    ! everything!
    call mrtcal_message(seve%e,rname,'Can not write FSW data per chunk')
    error = .true.
    return
    !
  else
    ! Stitch by set of chunks and convert
    if (out%toclass) then
      call mrtcal_chunkset_fsw_to_obs(out,chunkset1,chunkset2,error)
      if (error)  return
    endif
    nspec = nspec+1
  endif
  !
end subroutine mrtcal_write_chunkset_fsw_toclass
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubetools_cubeid_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_flag_types
  !---------------------------------------------------------------------
  ! Support module for CubeID strings, i.e. family:flag1,flag2,...
  !---------------------------------------------------------------------
  !
  public :: cubeid_separ
  public :: cubetools_cubeid_string2familyflags
  public :: cubetools_cubeid_familyflags2string
  private
  !
  character(len=1), parameter :: cubeid_separ=':'  ! Family/flags separator
  !
  ! As of today there is no specific type defined for CubeID
  !
contains
  !
  subroutine cubetools_cubeid_string2familyflags(string,family,flags,error)
    !-------------------------------------------------------------------
    ! Transform a string into family name + list of flag_t
    !-------------------------------------------------------------------
    character(len=*),          intent(in)    :: string
    character(len=*),          intent(out)   :: family
    type(flag_t), allocatable, intent(out)   :: flags(:)
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: sep
    character(len=argu_l) :: stflags
    character(len=*), parameter :: rname='CUBEID>STRING2FAMILYFLAGS'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    sep = index(string,cubeid_separ)
    if (sep.eq.0) sep = len_trim(string)+1  ! No flags
    if (sep.eq.1) then
      call cubeheader_message(seve%e,rname,'Family name is empty')
      error =.true.
      return
    endif
    !
    family  = string(1:sep-1)
    stflags = string(sep+1:)
    !
    call cubetools_string_toflaglist(stflags,.false.,flags,error)
    if (error) return
  end subroutine cubetools_cubeid_string2familyflags
  !
  subroutine cubetools_cubeid_familyflags2string(family,flags,string,error)
    !-------------------------------------------------------------------
    ! From family name and flag codes, build the CubeID string
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: family
    type(flag_t),     intent(in)    :: flags(:)
    character(len=*), intent(out)   :: string
    logical,          intent(inout) :: error
    !
    call cubetools_flaglist_tostr(flags,size(flags,kind=flag_k),strflag=string,error=error)
    if (error) return
    string = trim(family)//cubeid_separ//string
  end subroutine cubetools_cubeid_familyflags2string
end module cubetools_cubeid_types

program uv_track
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Task to create a UV table from Station Coordinates and Observation
  ! parameters.
  !
  ! Does not include proper noise estimate for the time being
  !---------------------------------------------------------------------
  ! Global
  real :: a_lever
  include 'gbl_pi.inc'
  ! Local
  type(gildas) :: xima
  integer :: mstat, nstat, muv, ier, nc
  parameter (mstat=100, muv=10000)
  real, allocatable :: zch(:), zsh(:)
  real :: x(mstat), xx, yy, zz, sd, cd, sp, cp, h, sh, ch, phn(mstat)
  real :: y(mstat), z(mstat), extr, hlim(2)
  real :: hmin, hmax, array, uk, vk, horizon, phase, ph
  real :: uvmin, uvmin2, uv_spacing, diameter
  real*8 :: decs,freq,latitud,amat(9),bvec(3),az,el,avec(3),bandwidth
  integer :: i, j, k, kh, nh, lun, count, nvis, nshadow, nfill, ip, ff
  character(len=132) :: chain, file, fstation
  logical :: error,new,complete(mstat),ok
  real :: integ_time, frac, test, date, time, bandw
  real :: trec, tsys, tau, jpk, weight, total
  real :: step_time
  parameter (step_time=180.0)
  logical :: first
  integer :: next
  !------------------------------------------------------------------------
  nshadow = 0
  trec = 50.0
  tau = 0.1
  first = .true.
  total = 0.0
  ! Code:
  call gildas_open
  call gildas_dble('DECLINATION$',decs,1)
  call gildas_dble('FREQUENCY$',freq,1)
  call gildas_logi('NEW$',new,1)
  call gildas_char('UV_TABLE$',file)
  call gildas_char('STATION_FILE$',fstation)
  call gildas_real('UV_SPACING$',uv_spacing,1)
  call gildas_real('DIAMETER$',diameter,1)
  call gildas_real('HORIZON$',horizon,1)
  call gildas_dble('LATITUDE$',latitud,1)
  call gildas_real('HOUR$',hlim,2)
  call gildas_real('INTEGRATION$',integ_time,1)
  call gildas_real('BANDWIDTH$',bandw,1)
  !
  call gildas_real('TREC$',trec,1)
  call gildas_real('TAU$',tau,1)
  call gildas_real('PHASE$',phase,1)
  call gildas_close
  !
  decs = decs*pi/180.0
  !
  chain = file
  nc = lenc(chain)
  call sic_parsef(chain,file,' ','.uvt')
  call gagout('W-UV_TRACK,  Table name '   &
     &    //file(1:lenc(file)))
  !
  ! Use all stations in station file
  chain = fstation
  ier = sic_getlog(chain)
  call sic_parsef (chain,fstation,' ','.dat')
  !
  ! Antenna Diameter and Min UV spacing
  if (diameter.eq.0) then
    call gagout ('W-UV_TRACKS,  Antenna size unknown. '//   &
     &      'No shadowing warnings will be given.')
    jpk = 1.0
  else
    !
    ! Jy/K for 70 % Aperture efficiency
    jpk = 2.0*1.38e3*4.0/(pi*diameter**2)/0.70
    print *,'Using ',jpk,' Jansky/K'
  endif
  !
  ! Hour angle coverage
  horizon = max(3.0,min(horizon,90.0))
  !
  ! Observatory coordinates
  call amset(latitud,amat)     ! Hour-Dec to Az-El matrix
  !
  hmin = a_lever(sngl(decs),sngl(latitud),horizon)
  if (hmin.ge.0) then
    write(6,*) 'Dec. ',decs
    write(6,*) 'Latitude ',latitud
    write(6,*) 'E-UV_TRACK,  Source is not visible'
    call sysexi(fatale)
  endif
  sd = sin(decs)
  cd = cos(decs)
  !
  ! Hour angle range
  hmax = -hmin
  if (hlim(1).ne.0.0) then
    if (hlim(1).lt.hmin) then
      write(6,*) 'W-UV_TRACK,  Source rises only at ',hmin
    else
      hmin = hlim(1)
    endif
  endif
  if (hlim(2).ne.0.0) then
    if (hlim(2).gt.hmax) then
      write(6,*) 'W-UV_TRACK,  Source already sets at ',hmax
    else
      hmax = hlim(2)
    endif
  endif
  !
  ! Open Station Main List; Get best coverage from First Line
  ier = sic_getlun (lun)
  open (unit=lun,file=fstation(1:lenc(fstation)),status='OLD',   &
     &    iostat=ier,err=998)
  read (lun,'(A)',iostat=ier,end=998,err=998) chain
  !
  ! Handle various formats.
  array = 0.0
  ok = chain(1:1).eq.'!'
  if (ok) then
    do while(ok)
      read(lun,'(A)',iostat=ier) chain
      ok = chain(1:1).eq.'!'
    enddo
  else
    read(lun,'(A)',iostat=ier) chain
  endif
  array = array**2
  !
  ! Read X,Y,Z coordinates from station file
  nstat = 0
  xx = 0.
  yy = 0.
  zz = 0.
  ok = .true.
  do while (ok)
    nstat = nstat+1
    i = 1
    do while(chain(i:i).eq.' ')
      i = i+1
    enddo
    ip = index(chain(i:),' ')+i
    read(chain(ip:),*,iostat=ier) x(nstat),y(nstat),z(nstat)
    xx = xx+x(nstat)
    yy = yy+y(nstat)
    zz = zz+z(nstat)
    read(lun,'(A)',iostat=ier) chain
    ok = ier.eq.0
  enddo
  close(unit=lun)
  call sic_frelun(lun)
  xx = xx/nstat
  yy = yy/nstat
  zz = zz/nstat
  array = 0.0
  do i=1,nstat
    array = max(array,(x(i)-xx)**2+   &
     &      (y(i)-yy)**2+(z(i)-zz)**2)
  enddo
  array = 2.0*sqrt(array)
  write(6,*) 'I-UV_TRACKS, Array size is ',array
  !
  ! Get integration time in seconds
  ! FG 05.01.01 : force use of INTEG_TIME if given
  !
  if (integ_time.eq.0) then
    integ_time = 24.*3600.*uv_spacing/(4.*pi*array)
  endif
  integ_time = nint(integ_time)
  if (integ_time.gt.step_time) integ_time = step_time
  write(6,*) 'I-UV_TRACKS, Integration time ',integ_time,' sec.'
  frac = integ_time/3600.
  !
  ! Convert the phase noise into radian
  phase = pi*phase/180.0
  !
  ! Precompute the coordinates
  nh = nint((hmax-hmin)/frac)+2
  write(6,*) 'Number of time dump ',nh
  allocate (zch(nh),zsh(nh),stat=ier)
  nh = 0
  h = pi*hmin/12.0
  do while (h.lt.(pi*hmax/12.0))
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  write(6,*) 'Number of time dump ',nh
  !
  ! Bandwidth (in MHz)
  bandwidth = bandw            ! single -> double precision
  if (bandwidth.eq.0) then
    bandwidth = 8000.
  endif
  !
  ! Create or open table
  nvis = nh*nstat*(nstat-1)/2
  write(6,*) 'Number of visibilities ',nvis
  if (new) then
    xima%gil%inc(2) = integ_time
    call init_table (xima,file,nvis,decs,freq,bandwidth,error)
  else
    call extend_table (xima,file,nvis,decs,freq,bandwidth,error)
  endif
  if (error) then
    write(6,*) 'W-UV_TRACK,  Cannot open output Table'
    call sysexi(fatale)
  endif
  if (new) then
    allocate (xima%r2d(xima%gil%dim(1), xima%gil%dim(2)), stat=ier)
  else
    allocate (xima%r2d(xima%gil%dim(1), xima%trc(2)-xima%blc(2)+1), stat=ier)
  endif
  if (error) then
    write(6,*) 'W-UV_TRACK,  Cannot allocate output Table'
    call sysexi(fatale)
  endif
  count = 1
  !
  ! Shadowing
  uvmin2 = diameter**2
  h = pi*hmin/12.0
  next = 0
  nfill = 0
  !
  do k = 1,nh
    !
    ! Reset shadowing
    do i=1,nstat
      complete(i) = .true.
    enddo
    !
    ! Check for shadowing
    do i=1,nstat-1
      if (complete(i)) then
        do j=i+1,nstat
          if (complete(j)) then
            xx = x(i)-x(j)
            yy = y(i)-y(j)
            zz = z(i)-z(j)
            uk = zsh(k)*xx + zch(k)*yy
            vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
            if ((uk**2+vk**2).le.uvmin2) then
              test = (xx*zch(k) - yy*zsh(k))*cd + zz*sd
              if (test.gt.0.0) then
                complete(j) = .false.
                ff = j
              else
                complete(i) = .false.
                ff = i
              endif
              !!                        PRINT *,'U2+V2',UK**2+VK**2,UK,VK,UVMIN2,I,J,FF
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now
    date = float(count)        ! In days
    time = k*frac*3600.0       ! In seconds
    !
    ! Compute source elevation
    avec(1) = zch(k)*cd
    avec(2) = zsh(k)*cd
    avec(3) = sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    ! Compute Tsys
    call atmos(trec,tsys,tau,el)
    if (first) then
      print *,'Tsys ',tsys
      first = .false.
    endif
    ! Compute Weight
    weight= 2*bandwidth*integ_time/(jpk*tsys)**2
    total = total+weight
    !
    ! Generate phase noise
    call phase_sinus (phase,phn,nstat,h)
    !
    do i=1,nstat-1
      do j=i+1,nstat
        ph = phn(i)-phn(j)
        xx = x(i)-x(j)
        yy = y(i)-y(j)
        zz = z(i)-z(j)
        uk = zsh(k)*xx + zch(k)*yy
        vk = sd*(-zch(k)*xx+zsh(k)*yy)+cd*zz
        next = next+1
        if (complete(i).and.complete(j)) then
          call fill_table (uk,vk,date,time,   &
     &            weight,i,j,xima%r2d(1,next),el,   &
     &            integ_time,ph)
          total = total+weight
          nfill = nfill+1
        else
          call fill_table (uk,vk,date,time,   &
     &            0.0,i,j,xima%r2d(1,next),el,   &
     &            integ_time,ph)
          nshadow = nshadow+1
        endif
      enddo
    enddo
    h = h+pi*frac/12.0
  enddo
  write(6,*) 'Wrote ',nfill,' Visibilities (',nshadow,' shadowed)'
  call gdf_write_data(xima,xima%r2d,error)
  call cut_table(xima,file,0,error)
  !
  ! Write estimate noise
  total = 1e-3/sqrt(total)
  write(6,*) 'I-UV_TRACK,  Expected noise ',total,' Jy/beam'
  stop
  !
  998   write(6,*) 'E-UV_TRACK,  Trouble with ASTRO_STATIONS'
  print *,fstation(1:lenc(fstation))
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
end program uv_track
!
!!subroutine newuvt_init (xima,name,nvis,error)
subroutine init_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
  ! Local
  integer :: i, last
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = def_extr_words
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                  ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  !
  xima%gil%dec = dec
  xima%gil%epoc = 2000.0
  xima%gil%a0 = xima%gil%ra
  xima%gil%d0 = xima%gil%dec
  xima%char%line = ' '
  xima%gil%fres = bandwidth
  if (freq.ne.0d0) then
    xima%gil%fima = (freq+12.0)*1d3
    xima%gil%freq = freq*1d3
  else
    xima%gil%fima = 102d3
    xima%gil%freq = 90d3
  endif
  xima%gil%val(1) = xima%gil%freq
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  ! Extra columns
  xima%gil%fcol = 8
  last = xima%gil%fcol+xima%gil%natom * xima%gil%nchan
  xima%gil%column_pointer(code_uvt_el) = last
  last = last+1
  xima%gil%column_pointer(code_uvt_int) = last
!  if (scan) then
!    xima%gil%column_pointer(code_uvt_scan) = last
!    last = last+1
!  endif
!
!  if (positions) then
!    xima%gil%column_pointer(code_uvt_loff) = last
!    xima%gil%column_pointer(code_uvt_moff) = last
!    last = last+2
!  endif
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  call gdf_create_image (xima,error)
  print *, 'Done newuvt_init '
end subroutine init_table
!<FF>
!!subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)
subroutine extend_table (xima,name,nvis,dec,freq,bandwidth,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open a Table to extend it.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  real(8), intent(in) :: dec                         !
  real(8), intent(in) :: freq                        !
  real(8), intent(in) :: bandwidth                   !
!  integer, intent(in) :: nn             !
!  integer, intent(in) :: ndobs(nn)      !
!  integer, intent(in) :: ndscan(nn)     !
!  logical, intent(in) :: lc             ! Check table before
  ! Local
  integer(kind=size_length) :: mvis
  integer :: ier
  character(len=60) :: chain
  !-----------------------------------------------------------------------
  !
  call gdf_read_gildas(xima, name, '.uvt', error, data=.false.)
  if (.not.error) then
    if (abs(xima%gil%dec-dec).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV,  Different declinations'
      error = .true.
    endif
    if (freq.ne.0.0 .and. (abs(freq-xima%gil%freq*1d-3).gt.1d-6)) then
      write(6,*) 'W-ASTRO_UV,  Different frequencies'
      error = .true.
    endif
    if (abs(bandwidth-xima%gil%fres).gt.1d-6) then
      write(6,*) 'W-ASTRO_UV, Different bandwidth'
      error = .true.
    endif
  endif
  if (error) return
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) xima%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call gagout('I-EXTEND_TABLE,  '//chain)
  !
  mvis = xima%gil%dim(2)+nvis
  !
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  call gdf_extend_image (xima,mvis,error)
  print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  if (error) then
    call gagout('I-EXTEND_TABLE,  Table extension failed')
    return
  endif
  !
  ! Map only new region
  xima%blc(1) = 1
  xima%blc(2) = xima%gil%dim(2)+1-nvis
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%dim(2)
  print *, 'Done newuvt_extend '
end subroutine extend_table
!
subroutine cut_table (xima,name,ncut,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Update the number of visibilities
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima !
  character(len=*) :: name          !
  integer, intent(in) :: ncut         ! Number of missing visibilities
  logical :: error                    !
  !
  ! Local
  character(len=80) :: chain
  !----------------------------------------------------------------------
  !
  xima%gil%nvisi = xima%gil%dim(2) - ncut
  write(chain,1001) xima%gil%dim(2), xima%gil%nvisi
  xima%gil%dim(2) = xima%gil%nvisi
  call gagout('I-CUT_TABLE,  '//chain)
  call gdf_update_header(xima,error)
  print *, 'Done newuvt_cut ',xima%gil%nchan
  !
1001 format('Old size ',i8,' New ',i8)
end subroutine cut_table
!<FF>
subroutine fill_table (u,v,d,t,w,ideb,ifin,visi,e,dt,ph)
  !---------------------------------------------------------------------
  ! 7 Parametres :
  ! U, V, W=0, Date, Temps, Ant1, Ant2
  ! 3 values
  ! Reel, Imag, Poids
  ! 1.0,  0.0, 1.0
  !---------------------------------------------------------------------
  real :: u                         !
  real :: v                         !
  real :: d                         !
  real :: t                         !
  real :: w                         !
  integer :: ideb                   !
  integer :: ifin                   !
  real :: visi(*)                   !
  real :: e                         !
  real :: dt                        !
  real :: ph                        !
  !
  visi(1) = u
  visi(2) = v
  visi(3) = 0.0
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = cos(ph)
  visi(9) = sin(ph)
  visi(10) = w
  visi(11) = e
  visi(12) = dt
end
!<FF>
function a_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! Lever d'une etoile de declinaison D a latitude D0
  ! Ce code est different de "lever" de GreG, donc je l'appelle A_LEVER
  ! (sinon big problemes,...GD, 8-10-1992)
  ! D Declination in radians
  ! D0  Latitude in degrees
  !   EL  elevation limit in degrees
  ! LEVER Hour angle in Hours
  !
  ! PI/2-D0+EL < D  Circumpolaire
  ! D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  ! D < D0-PI/2+EL  Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real :: a_lever                   !
  real :: d                         !
  real :: d0                        !
  real :: el                        !
  ! Local
  real :: dd,d1,d2,ee
  real*8 :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  a_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (a_lever.le.-1.0) then
    a_lever = -12.0            ! Circumpolar
  elseif (a_lever.ge.1.0) then
    a_lever = 0.0              ! Not visible
  else
    a_lever = -12.0/pi* acos(a_lever)
  endif
end
!<FF>
subroutine amset(obslat,amat)
  !---------------------------------------------------------------------
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real*8 ::  obslat                 ! in degrees
  real*8 ::  amat(9)                !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::  x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end
!<FF>
subroutine dangle(along,alat,a)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along=datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end
!<FF>
subroutine dcosin(along,alat,a)    ! direction cosinus
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine computes the vector a for the angles, along and alat,
  ! which should be specified in deg_to_radrees.
  !---------------------------------------------------------------------
  real*8 ::   along                 !
  real*8 ::   alat                  !
  real*8 ::   a(3)                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 ::   x,y,z
  !
  x    = along                 ! x in radians
  y    = alat                  ! y in radians
  z    = dcos(y)
  a(1) = dcos(x)*z
  a(2) = dsin(x)*z
  a(3) = dsin(y)
end
!<FF>
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real*8 ::    mat(3,3)             !
  real*8 ::    a(1)                 !
  real*8 ::    b(1)                 !
  integer ::   n                    !
  ! Local
  integer ::   i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end
!<FF>
subroutine atmos(trec,tsys,tau0,el)
  real :: trec                      !
  real :: tsys                      !
  real :: tau0                      !
  real*8 :: el                      !
  ! Local
  real :: tau,tatm,feff,tcab
  feff = 0.93
  tatm = 240.0
  tcab = 300.0
  !
  tau = tau0/sin(el)
  tsys = feff*(1.-exp(-tau))*tatm + (1.0-feff)*tcab + trec
  tsys = exp(tau)/feff*tsys
end
!<FF>
subroutine phase_sinus(phase,phn,n,h)
  real :: phase                     !
  integer :: n                      !
  real :: phn(n)                    !
  real :: h                         !
  ! Local
  integer :: i
  real :: rangau
  !
  ! A simple sinusoid variation
  do i = 1,n
    phn(i) = phase * sin(i*h)
  enddo
  ! Print *,'Phases ',phn
end

module ram_sizes
  integer(kind=8), parameter :: bytes_per_real = 4
  integer(kind=8), parameter :: kB = 1024
  integer(kind=8), parameter :: MB = 1024**2
  integer(kind=8), parameter :: GB = 1024**3
end module ram_sizes
!
module imbfits_parameters
  !
  real(kind=4), parameter :: bad=-1000.e0
  real(kind=8), parameter :: bad8=-1000.d0
  !
  integer(kind=4), parameter :: code_imbfits_init = 0
  integer(kind=4), parameter :: code_imbfits_started = 1
  integer(kind=4), parameter :: code_imbfits_done = 2
  real(kind=4), parameter :: imbfits_version_min=1.1999  ! Min supported (included)
  real(kind=4), parameter :: imbfits_version_max=3.      ! Max supported (excluded)
  !
  integer(kind=4), parameter :: mhdukinds=8
  integer(kind=4), parameter :: hdu_scan=1           ! HDU Scan identifier
  integer(kind=4), parameter :: hdu_frontend=2       ! HDU Frontend identifier
  integer(kind=4), parameter :: hdu_backend=3        ! HDU Backend identifier
  integer(kind=4), parameter :: hdu_backdata=4       ! HDU BackEndXXX identifier
  integer(kind=4), parameter :: hdu_antslow=5        ! HDU AntennaSlow identifier
  integer(kind=4), parameter :: hdu_antfast=6        ! HDU AntennaFast identifier
  integer(kind=4), parameter :: hdu_subreflector=7   ! HDU Subreflector identifier
  integer(kind=4), parameter :: hdu_derot=8          ! HDU Derotator identifier
  !
  ! Known telescopes
  integer(kind=4), parameter :: telescope_length=12
  integer(kind=4), parameter :: ntelescopes=1
  ! Ad vitam aeternam codes:
  integer(kind=4), parameter :: telescope_unknown=0
  integer(kind=4), parameter :: telescope_iram30m=1
  ! Order must match telescope codes:
  character(len=telescope_length), parameter :: telescopes(0:ntelescopes) =  &
    (/ 'unknown     ','IRAM 30m    ' /)
  !
  ! Known backends
  integer(kind=4), parameter :: backname_length=9
  integer(kind=4), parameter :: nbackends_imbfits=10
  integer(kind=4), parameter :: nbackends_mrtcal=9
  ! Ad vitam aeternam codes:
  integer(kind=4), parameter :: backend_unknown  =0
  integer(kind=4), parameter :: backend_nbc      =1
  integer(kind=4), parameter :: backend_bbc      =2
  integer(kind=4), parameter :: backend_4mhz     =3
  integer(kind=4), parameter :: backend_vespa    =4
  integer(kind=4), parameter :: backend_wilma    =5
  integer(kind=4), parameter :: backend_fts      =6
  integer(kind=4), parameter :: backend_nika1mm  =7
  integer(kind=4), parameter :: backend_nika2mm  =8
  integer(kind=4), parameter :: backend_holo     =9
  ! Used by IMBFITS, do not use for MRTCAL (this code can be modified)
  integer(kind=4), parameter :: backend_continuum=10
  ! Order must match backend codes:
  ! 1) As found in IMBFITS files
  character(len=backname_length), parameter :: backends_imbfits(nbackends_imbfits) =  &
    (/             'NBC      ','BBC      ','4MHZ     ','VESPA    ',  &
       'WILMA    ','FTS      ','NIKA1MM  ','NIKA2MM  ','HOLO     ',  &
       'CONTINUUM'/)
  ! 2) As displayed by MRTCAL
  character(len=backname_length), parameter :: backends_mrtcal(0:nbackends_mrtcal) =  &
    (/ 'UNKNOWN  ','NBC      ','BBC      ','4MHZ     ','VESPA    ',  &
       'WILMA    ','FTS      ','NIKA1MM  ','NIKA2MM  ','HOLO     ' /)
  !
end module imbfits_parameters

program mask_3d
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Task
  !   Apply a 3-D real mask to an input data cube
  !   Ouput = Input where Mask is non zero
  !
  !   The Mask does not need to share the same sampling as the
  !   data cube.
  !---------------------------------------------------------------------
  character(len=filename_length) :: cmask
  character(len=filename_length) :: cinp
  character(len=filename_length) :: cout 
  logical :: error
  !
  call gildas_open
  call gildas_char('MASK$',cmask)
  call gildas_char('INPUT$',cinp)
  call gildas_char('OUTPUT$',cout)
  call gildas_close
  !
  call sub_mask3d(cmask,cinp,cout,error)
  if (error) call sysexi(fatale)
  call gagout('S-MASK_3D, successful completion')
  contains
!
subroutine sub_mask3d(cmask,cinp,cout,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  ! @ private
  character(len=*), intent(inout) :: cmask
  character(len=*), intent(inout) :: cinp
  character(len=*), intent(inout) :: cout
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'MASK_3D'
  ! Local
  type(gildas) :: gmask, ginp, gout
  real, allocatable :: rmask(:,:), data(:,:,:)
  integer :: nblock, iloop, j, ier, iplane, imask
  !
  ! Code
  call gildas_null (ginp) 
  call gdf_read_gildas (ginp, cinp, '.gdf', error, data=.false.)
  !
  ! Make it a 3-D data set even if only one plane
  call gildas_null (gmask) 
  call gdf_read_gildas (gmask, cmask, '.msk', error, rank=3, data=.true.)
  !
  call gildas_null (gout) 
  call gdf_copy_header(ginp,gout,error)
  if (error) return
  !
  if (gmask%gil%dim(3).gt.1) then
    if (ginp%gil%faxi.ne.3 .or. gmask%gil%faxi.ne.3) then
      call gag_message(seve%e,rname,'Mask and Cube must have FREQUENCY / VELOCITY axis as 3rd one')
      error = .true.
      return
    endif
    if (ginp%char%code(3).ne.gmask%char%code(3)) then
      call gag_message(seve%e,rname,'3rd axis must be of same type')
      error = .true.
      return
    endif
  endif
  !
  call sic_parsef(cout,gout%file,' ','.gdf')
  call gdf_create_image(gout,error)
  if (error) return
  !
  call gdf_nitems('SPACE_GILDAS',nblock,ginp%gil%dim(1)*ginp%gil%dim(2)) 
  nblock = min(nblock,ginp%gil%dim(3))
  allocate(rmask(ginp%gil%dim(1),ginp%gil%dim(2)), &
    & data(ginp%gil%dim(1),ginp%gil%dim(2),nblock),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Initialize
  imask = 0
  ! Loop over blocks
  do iloop = 1,ginp%gil%dim(3),nblock
    ginp%blc(3) = iloop
    ginp%trc(3) = min(iloop+nblock-1,ginp%gil%dim(3))
    gout%blc(3) = iloop
    gout%trc(3) = ginp%trc(3)
    call gdf_read_data (ginp,data,error)
    if (error) return
    !
    ! Mask it
    do j=1,ginp%trc(3)-ginp%blc(3)+1
      iplane = j+ginp%blc(3)-1
      call get_realmask(imask,iplane,gmask,ginp,rmask)
      data(:,:,j) = rmask*data(:,:,j)
    enddo
    call gdf_write_data (gout, data, error)
    if (error) return
  enddo
  call gdf_close_image(gout,error)
  call gdf_close_image(ginp,error)
  call gdf_close_image(gmask,error)
end subroutine sub_mask3d
!
subroutine get_realmask(imask,iplane,hmask,hmap,rmask)
  use image_def
  !----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Define beam plane and check if fit is required
  !----------------------------------------------------------------
  integer, intent(inout) :: imask
  integer, intent(inout) :: iplane
  type (gildas), intent(in) :: hmask
  type (gildas), intent(in) :: hmap   ! Used to figure out which plane
  real, intent(inout) :: rmask(:,:)
  !
  integer :: i, j, nx, ny, ier
  real(8) :: i_freq, r
  integer, allocatable :: im(:), jm(:)
  !
  if (hmask%gil%dim(3).le.1) then
    iplane = 1
 else
    i_freq = (iplane-hmap%gil%ref(3))*hmap%gil%inc(3) + hmap%gil%val(3)
    iplane = nint((i_freq-hmask%gil%val(3))/hmask%gil%inc(3) + hmask%gil%ref(3))
    iplane = min(max(1,iplane),hmask%gil%dim(3)) ! Just  in case
  endif
  !
  if (imask.ne.iplane) then
    !
    ! Should also work in OMP mode...
    nx = hmap%gil%dim(1)
    ny = hmap%gil%dim(2)
    !
    allocate(im(nx),jm(ny),stat=ier)
    !
    do i=1,nx
      r = (i-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1)
      im(i) = (r-hmask%gil%val(1))/hmask%gil%inc(1) + hmask%gil%ref(1)
      im(i) = max(1,im(i))
      im(i) = min(hmask%gil%dim(1),im(i))
    enddo
    !
    do i=1,ny
      r = (i-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2)
      jm(i) = (r-hmask%gil%val(2))/hmask%gil%inc(2) + hmask%gil%ref(2)
      jm(i) = max(1,jm(i))
      jm(i) = min(hmask%gil%dim(2),jm(i))
    enddo
    !
    do j=1,ny
      do i=1,nx
        if (hmask%r3d(im(i),jm(j),iplane).ne.0) then
          rmask(i,j) = 1.0
        else
          rmask(i,j) = 0.0
        endif
      enddo
    enddo
    deallocate(im,jm)
    imask = iplane
  endif
end subroutine get_realmask
!
end program

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_chunkset_check(set,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_check
  !---------------------------------------------------------------------
  ! @ private
  ! Check the integrity of a set of chunks
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: set
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CHUNKSET>CHECK'
  integer(kind=4) :: ichunk,id
  character(len=12) :: line
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  id = set%chunks(1)%id
  line = set%chunks(1)%spe%line
  do ichunk=2,set%n
     if (set%chunks(ichunk)%id.ne.id) then
        call mrtcal_message(seve%e,rname,'Inconsistant identifiers in set of chunks')
        error = .true.
        return
     endif
     if (set%chunks(ichunk)%spe%line.ne.line) then
        call mrtcal_message(seve%e,rname,'Inconsistant line names in set of chunks')
        error = .true.
        return
     endif
  enddo
  !
end subroutine mrtcal_chunkset_check
!
subroutine mrtcal_chunkset_show(chunkset)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_show
  !---------------------------------------------------------------------
  ! @ private
  ! Display a set of chunks. For debugging purpose.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in) :: chunkset
  ! Local
  integer(kind=4) :: ichunk
  character(len=*), parameter :: rname='CHUNKSET>SHOW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  do ichunk=1,chunkset%n
     write(*,'(A,I0)') 'Chunk #',ichunk
     call mrtcal_chunk_show(chunkset%chunks(ichunk))
  enddo
  !
end subroutine mrtcal_chunkset_show
!
subroutine mrtcal_chunkset_accumulate_setweight(diff,tscale,dowei,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_accumulate_setweight
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! ZZZ
  ! Quick and dirty subroutine to enforce chunks dataw to something
  ! non-zero (needed by simple_waverage). Currently set to 1.0 i.e.
  ! equal weights. Should probably come early and cleverly e.g.
  ! weight equal, tsys, time, maybe in mrtcal_on_minus_off.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(inout) :: diff
  type(chunkset_t), intent(in)    :: tscale
  logical,          intent(in)    :: dowei   ! Compute real weights or dummy?
  logical,          intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ichunk,ichan
  real(kind=4) :: fact
  !
  if (dowei) then
    !
    do ichunk=1,diff%n
      fact = diff%chunks(ichunk)%gen%time * abs(diff%chunks(ichunk)%spe%fres)
      do ichan=1,diff%chunks(ichunk)%ndata
        diff%chunks(ichunk)%dataw(ichan) =  &
          fact / tscale%chunks(ichunk)%data1(ichan)**2
      enddo
    enddo ! ichunk
    !
  else
    !
    do ichunk=1,diff%n
      diff%chunks(ichunk)%dataw(:) = 1.0
    enddo ! ichunk
    !
  endif
  !
end subroutine mrtcal_chunkset_accumulate_setweight
!
subroutine mrtcal_chunkset_accumulate_do(inchunkset,ouchunkset,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_accumulate_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Accumulate the input chunkset into the running output chunkset
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: inchunkset
  type(chunkset_t), intent(inout) :: ouchunkset
  logical,          intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ichunk
  logical, parameter :: contaminate=.true.  ! Input bad channels contaminate the output sum
  real(kind=8) :: iinteg,ointeg,sinteg
  !
  do ichunk=1,inchunkset%n
    call simple_waverage(                   &
      inchunkset%chunks(ichunk)%data1,      &
      inchunkset%chunks(ichunk)%dataw,bad,  &
      ouchunkset%chunks(ichunk)%data1,      &
      ouchunkset%chunks(ichunk)%dataw,bad,  &
      1,inchunkset%chunks(ichunk)%ndata,    &
      contaminate,.true.)
    ! The following lines assume that the whole spectrum is
    ! not bad
    iinteg = inchunkset%chunks(ichunk)%gen%time
    ointeg = ouchunkset%chunks(ichunk)%gen%time
    sinteg = iinteg+ointeg  ! Total integration time
    ! Compute mean MJD = DOBS + UT
    ouchunkset%chunks(ichunk)%mjd =  &
            (ouchunkset%chunks(ichunk)%mjd*ointeg +  &
            inchunkset%chunks(ichunk)%mjd*iinteg)/sinteg
    call mrtindex_mjd2gagut(ouchunkset%chunks(ichunk)%scandate,  &
                            ouchunkset%chunks(ichunk)%mjd,       &
                            ouchunkset%chunks(ichunk)%gen%dobs,  &
                            ouchunkset%chunks(ichunk)%gen%ut,    &
                            error)
    ! Compute mean AZ EL, rederive parallactic angle
    ouchunkset%chunks(ichunk)%gen%az =  &
           (ouchunkset%chunks(ichunk)%gen%az*ointeg +  &
            inchunkset%chunks(ichunk)%gen%az*iinteg)/sinteg
    ouchunkset%chunks(ichunk)%gen%el =  &
           (ouchunkset%chunks(ichunk)%gen%el*ointeg +  &
            inchunkset%chunks(ichunk)%gen%el*iinteg)/sinteg
    call mrtcal_chunk_parang_from_gen(ouchunkset%chunks(ichunk)%gen,error)
    ! Same for continuum drift offsets
    ouchunkset%chunks(ichunk)%offset(1:2) =  &
           (ouchunkset%chunks(ichunk)%offset(1:2)*ointeg +  &
            inchunkset%chunks(ichunk)%offset(1:2)*iinteg)/sinteg
    ! Set total integration time
    ouchunkset%chunks(ichunk)%gen%time = sinteg
    ! *** JP Normally OTF PSW never explore this subroutine.
    ! *** JP But if it would, the OFF time would be wrongly added...
    ouchunkset%chunks(ichunk)%swi%duree   =  &
      ouchunkset%chunks(ichunk)%swi%duree +  &
      inchunkset%chunks(ichunk)%swi%duree
  enddo ! ichunk
  !
end subroutine mrtcal_chunkset_accumulate_do
!
subroutine mrtcal_chunkset_copy(in,ofirst,ou,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_copy
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy the chunkset to the output structure (from ofirst chunk),
  ! taking care of reallocating chunkds if needed. Copy is done with
  ! allocations, not associations.
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: in
  integer(kind=4),  intent(in)    :: ofirst
  type(chunkset_t), intent(inout) :: ou
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: ichunk,ochunk
  !
  ochunk = ofirst-1
  do ichunk=1,in%n
    ochunk = ofirst-1+ichunk
    call ou%chunks(ochunk)%reallocate(in%chunks(ichunk)%ndata,error)
    if (error) return
    call ou%chunks(ochunk)%copy_header(in%chunks(ichunk),error)
    if (error) return
    call ou%chunks(ochunk)%copy_data(in%chunks(ichunk),error)
    if (error) return
  enddo
  ou%n = ochunk
end subroutine mrtcal_chunkset_copy
!
subroutine mrtcal_chunkset_append_do(in,ou,error)
  use mrtcal_interfaces, except_this=>mrtcal_chunkset_append_do
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Append the input chunkset into the running output chunkset
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: in
  type(chunkset_t), intent(inout) :: ou
  logical,          intent(inout) :: error
  ! Local
  type(chunkset_t) :: tmp
  integer(kind=4) :: newsize
  !
  if (size(ou%chunks).lt.ou%n+in%n) then
    ! ZZZ reallocate_chunkset should have a "keep" mode
    newsize = max(ou%n+in%n,2*ou%n)
    ! Allocate a temporary copy
    call tmp%reallocate(ou%n,error)
    if (error)  return
    ! Duplicate the output chunkset
    call mrtcal_chunkset_copy(ou,1,tmp,error)
    if (error)  return
    ! Enlarge the original
    call ou%reallocate(newsize,error)
    if (error)  return
    ! Copy back from tmp to original
    call mrtcal_chunkset_copy(tmp,1,ou,error)
    if (error)  return
    ! Free the temporary
    call tmp%free(error)
    if (error)  return
  endif
  !
  ! Insert the new ones!
  call mrtcal_chunkset_copy(in,ou%n+1,ou,error)
  if (error)  return
end subroutine mrtcal_chunkset_append_do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine import_package(line,error)
  use sic_dependencies_interfaces
  use gpack_def
  use sic_interfaces, except_this=>import_package
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !    Support routine for command SIC\IMPORT. Syntax is:
  !    IMPORT foo [/DEBUG]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=gpack_name_length) :: packname
  character(len=6) :: rname = 'IMPORT'
  integer :: pl,narg
  logical :: debug = .false.  ! Load library in debug mode?
  !
  narg = sic_narg(0)
  if (narg.ne.1) then
    call sic_message(seve%e,rname,'Command IMPORT needs 1 and only 1 argument')
    error = .true.
    return
  endif
  !
  ! Retrieve package name
  call sic_ch (line,0,1,packname,pl,.true.,error)
  if (error) return
  call sic_lower(packname)
  !
  if (sic_present(1,0)) then
    debug = .true.
  endif
  !
  ! Dynamic load the library
  call gpack_sic_import(packname,debug,error)
  !
end subroutine import_package
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine cd_by_name(argum,active,win_num,error)
  use gildas_def
  use gtv_buffers
  use gtv_protocol
  use gtv_interfaces, except_this=>cd_by_name
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Effectively move to the explicit directory named ARGUM, and on the
  ! specified window number if any.
  !  Warning: the window number is the number as seen by user!
  ! ---
  !  Thread status: thread safe for reading/writing from main.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum    ! Directory name to go to
  logical,          intent(in)    :: active   ! Use the active window?
  integer(kind=4),  intent(inout) :: win_num  ! Else, window number to use
  logical,          intent(inout) :: error    ! Error flag
  ! Local
  character(len=*), parameter :: rname='CD'
  logical :: dir,found
  integer :: win_num_c
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: dir_new
  !
  ! Note philosophique
  ! ------------------
  ! Il y a un probleme de M.A.J. de la couleur courante sur CD
  ! Manifestation: Avec les fenetres blanches et noires, la plume change mal
  ! parfois ... Je LAISSE ce probleme en suspens, jusqu'a ce que les attributs
  ! du repertoire contiennent toutes les caracteristiques (Plot page, limites ..
  ! et je pense aussi plume courante. (Cette p.. de plume courante me fait
  ! bien marcher - A mon age, on ne court plus-)
  !
  if (argum.eq.' ') then
    ! Input is empty: return to root '<'
    dir_new => root
    !
  else
    !
    ! Input is a standard directory
    call decode_chemin(argum,cw_directory,dir_new,dir,segm,found)
    !
    ! Not found?
    if (.not. (found.and.dir)) then
      error = .true.
      call gtv_message(seve%e,rname,'No such directory '//argum)
      return
    endif
    !
    ! Root?
    if (associated(dir_new,root)) then
      error = .true.
      call gtv_message(seve%e,rname,'Root directory - permission denied')
      return
    endif
    !
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (active) then
    ! Use the active window
    win_num_c = dir_new%x%curwin
  else
    ! Translate the window number into its internal value
    win_num_c = get_window_cnum(dir_new,win_num,error)
  endif
  !
  call cd_by_adr(dir_new,win_num_c,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine cd_by_name
!
subroutine cd_by_adr(dir_new,win_num,error)
  use gtv_interfaces, except_this=>cd_by_adr
  use gtv_buffers
  use gtv_graphic
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Effectively move to the directory identified by DIR_NEW, and on the
  ! specified window number if any.
  !  Warning: the window number is the internal number!
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing (because the active window can be changed).
  !---------------------------------------------------------------------
  type(gt_directory), pointer       :: dir_new  ! Directory to move to
  integer*4,          intent(inout) :: win_num  ! Can be adjusted on return
  logical,            intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CD'
  type(greg_values) :: tab_greg
  integer :: nc
  !
  if (error)  return
  !
  ! Update extrema of the Pere
  if (associated(cw_directory%father)) then
    ! We are not in root
    call dir_extrema(cw_directory%father,cw_directory%gen%minmax)
  endif
  !
  ! Sauvegarde du contexte courant
  if (flag_greg) then
    call get_greg_values(tab_greg)
    call attach_greg_values(cw_directory,tab_greg,error)
    if (error)  return
  endif
  !
  if (associated(cw_directory,dir_new)) then
    ! New dir is old dir
    if (win_num.eq.cw_directory%x%curwin) return  ! Nothing to do
  else
    cw_directory => dir_new
  endif
  call cree_chemin_dir(cw_directory,pwd,nc)
  !
  ! Restauration "a priori" des constantes de Greg
  if (flag_greg)  &
    call send_greg_values(cw_directory%val_greg)
  !
  ! Change to input window
  call cd_by_win(cw_directory,win_num,error)
  if (error)  return
  !
end subroutine cd_by_adr
!
subroutine cd_by_win(dir,win_num_in,error)
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>cd_by_win
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Change the active window of the input directory.
  !  Warning: the window number is the internal number!
  ! ---
  !  Thread status: not thread safe. Calling routine must be thread
  ! safe for writing (because the active window can be changed).
  !---------------------------------------------------------------------
  type(gt_directory)             :: dir         ! Directory to work on
  integer(kind=4), intent(in)    :: win_num_in  ! Window to move to
  logical,         intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CD'
  integer :: win_num
  integer(kind=address_length) :: graph_env
  logical :: found
  !
  if (error)  return
  !
  if (dir%x%nbwin.eq.0) then
    ! No windows attached
    call gt_output_reset(null_output)
    null_output%dev => cw_device  ! Use current protocol
    cw_output => null_output
    return
  endif
  !
  ! Basic check.
  win_num = win_num_in
  if ( win_num.lt.0 .or. (win_num.ne.0 .and. win_num.ge.dir%x%nbwin) ) then
    call gtv_message(seve%w,'CD','Invalid window number - using first window')
    win_num = 0
  endif
  !
  ! Get the address of the table of genv addresses for this directory
  if (dir%x%genv_array.eq.0) then
    call gtv_message(seve%e,rname,  &
      'Internal error: no graphical environments found')
    error = .true.
    return
  endif
  !
  ! Get the current graphical environment from the table (indexed by window num)
  graph_env = c_get_win_genv(dir%x%genv_array,win_num)
  !
  if (graph_env.eq.-1) then
    call gtv_message(seve%e,rname,'No valid Graphic Environment')
    error=.true.
    return
    !
  elseif (graph_env.eq.0) then
    if (win_num.ne.0) then
      call gtv_message(seve%e,rname,'Invalid window number')
      error=.true.
      return
    endif
    !
  else
    ! Store the address of the environment in the directory descriptor.
    dir%x%genv = graph_env
    !
    ! Update the Current Working Instance
    call get_slot_output_by_genv(graph_env,cw_output,.true.,found,error)
    if (error)  return
    !
  endif
  !
  ! Update the value of the current window for this directory
  dir%x%curwin = win_num
  !
end subroutine cd_by_win
!
function gtexist(name)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtexist
  use gtv_types
  !---------------------------------------------------------------------
  ! @ public
  ! Logical function indicating wether a segment/directory exists
  !---------------------------------------------------------------------
  logical :: gtexist                    ! Function value on return
  character(len=*), intent(in) :: name  ! Name to search for
  ! Local
  logical :: isdir,found
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: dir
  !
  call decode_chemin(name,cw_directory,dir,isdir,segm,found)
  gtexist = found
end function gtexist

program uv_update_fields
  use gildas_def
  use image_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! GILDAS
  !   Task for @ fits_to_uvt.map
  !     Replace fields ID by Fields offsets
  !     The Fiels offsets are found in the AIPS SU Table
  !     which is not decoded by the FITS command, but only
  !     through the DEFINE FITS command.
  !----------------------------------------------------------------------
  character(len=filename_length) :: uvdata, fields
  character(len=32) :: chain
  integer :: nf, ier, i, j
  integer :: lun=1
  real, allocatable :: raoff(:),deoff(:)
  real :: off(2)
  logical :: error
  !
  ! Code:
  error = .false.
  call gildas_open
  call gildas_char('UVDATA$',uvdata)
  call gildas_inte('NFIELDS$',nf,1)
  !
  allocate (raoff(abs(nf)),deoff(abs(nf)),stat=ier)
  if (ier.ne.0) then
    call gagout('E-UV_UPDATE_FIELDS, Memory allocation error')
    call sysexi(fatale)
  endif
  !
  if (nf.lt.0) then
    nf = -nf
    call gildas_char('FIELD_LIST$',fields)
    call gildas_close
    !
    open(unit=lun,file=fields,status='OLD',iostat=ier)
    if (ier.ne.0) then
      call gagout('E-UV_UPDATE_FIELDS, Error opening '//trim(fields))
      call putios('E-UV_UPDATE_FIELDS, ',ier)
      call sysexi(fatale)
    endif
    !
    do i=1,nf
      read(lun,*) j, off(1:2)
      if (j.ne.i) then
        call gagout('E-UV_UPDATE_FIELDS, Unordered field list')
        call sysexi(fatale)
      else
        raoff(i) = off(1)
        deoff(i) = off(2)
      endif
    enddo
    close(unit=lun)
  else
    do i=1,nf
      write(chain,'(a,i0,a)') 'FIELD_',i,'$'
      call gildas_real(chain,off,2)
      raoff(i) = off(1)
      deoff(i) = off(2)
    enddo
    call gildas_close
  endif
  call sub_update_fields(uvdata,nf,raoff,deoff,error)
  if (error) call sysexi(fatale)
  call gagout ('S-UV_UPDATE_FIELDS,  Successful completion')
end program uv_update_fields
!
subroutine sub_update_fields (cuvin, nf,raoff,deoff,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !   Support for @ fits_to_uvt.map
  !     Replace fields ID by Fields offsets
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin
  integer, intent(in) :: nf
  real, intent(in) :: raoff(nf), deoff(nf)
  logical, intent(out) :: error
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_UPDATE_FIELDS'
  character(len=80)  :: mess
  type (gildas) :: uvin
  integer :: ier, nblock, ib, invisi, iv, ixoff, iyoff, isou, icode
  real :: rsou
  !
  ! Simple checks
  error = len_trim(cuvin).eq.0
  if (error) then
    call gag_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call gag_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Update the proper columns
  if (uvin%gil%column_size(code_uvt_id).ne.0) then
    call gag_message(seve%i,rname,'Replacing Field numbers by PHASE offsets')
    ixoff = uvin%gil%column_pointer(code_uvt_id)
    iyoff = ixoff+1
    uvin%gil%column_pointer(code_uvt_loff) = ixoff
    uvin%gil%column_pointer(code_uvt_moff) = iyoff
    uvin%gil%column_size(code_uvt_loff) = 1
    uvin%gil%column_size(code_uvt_moff) = 1
    uvin%gil%column_pointer(code_uvt_id) = 0
    uvin%gil%column_size(code_uvt_id) = 0
    icode = 0
  else if (uvin%gil%column_size(code_uvt_loff).ne.0) then
    ixoff =     uvin%gil%column_pointer(code_uvt_loff)
    iyoff =     uvin%gil%column_pointer(code_uvt_moff)
    call gag_message(seve%w,rname,'UV Table is already of type PHASE, checking Field numbers')
    icode = 1
  else if (uvin%gil%column_size(code_uvt_xoff).ne.0) then
    ixoff =     uvin%gil%column_pointer(code_uvt_xoff)
    iyoff =     uvin%gil%column_pointer(code_uvt_yoff)
    call gag_message(seve%w,rname,'UV Table is already of type POINT, checking Field numbers')
    icode = -1
  else
    call gag_message(seve%e,rname,'UV table is not a mosaic')
    error = .true.
    return
  endif
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call gag_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table by block
  uvin%blc = 0
  uvin%trc = 0
  !
  do ib = 1,uvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
    call gag_message(seve%i,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    invisi = uvin%trc(2)-uvin%blc(2)+1
    call gdf_read_data(uvin,uvin%r2d,error)
    !
    if (icode.eq.0) then
      do iv=1,invisi
        isou = uvin%r2D(ixoff,iv)
        uvin%r2d(ixoff,iv) = raoff(isou)
        uvin%r2d(iyoff,iv) = deoff(isou)
      enddo
    else
      do iv=1,invisi
        isou = uvin%r2D(ixoff,iv)
        rsou = isou
        if (rsou.ne.uvin%r2D(ixoff,iv)) then  
          mess = 'Non integer field number'
          error = .true.
        else if (isou.lt.1 .or. isou.gt.nf) then
          mess = 'Field number out of range'
          error = .true.
        endif
        if (error) then
          call gag_message(seve%e,rname,mess)
          return
        endif
        uvin%r2d(ixoff,iv) = raoff(isou)
        uvin%r2d(iyoff,iv) = deoff(isou)
      enddo
    endif
    !
    call gdf_write_data (uvin,uvin%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_update_header(uvin,error)
  if (error) return
  call gdf_close_image(uvin,error)
end subroutine sub_update_fields

program uv_table
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>fourt
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compute the UV data set corresponding to an image
  !	Input : an image.
  !	Output: the UV table, where the visibilities have been computed.
  ! This tasks differs from UV_MODEL by using an FFT, and generating UV
  ! data on a fully sampled grid (up to a maximum radius) rather than along
  ! user specified tracks.
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: x,y
  complex, allocatable :: tf(:,:), work(:)
  integer :: nf,nx,ny,n, if, nn(2), ier,ydim1
  character(len=filename_length) :: image,name,uvmodel
  character(len=132) :: mess
  real :: freq
  logical :: error
  !
  ! Code:
  call gildas_open
  call gildas_char('IMAGE$',image)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_close
  !
  ! Image
  n = len_trim(image)
  if (n.le.0) goto 999
  name = image(1:n)
  call gildas_null(y, type = 'IMAGE')
  call gdf_read_gildas(y, name, '.vlm', error, rank=3, data=.true.)
  if (error) then
    call gagout('E-UV_MODEL,  Could not read input image')
    goto 999
  endif
  if (y%char%code(1).eq.'FREQUENCY' .or.  &
      y%char%code(1).eq.'VELOCITY'  .or.  &
      y%char%code(1).eq.'UNKNOWN') then
    nf = y%gil%dim(1)
  else
    call gagout('E-UV_MODEL,  First axis unit not FREQUENCY')
    goto 999
  endif
  nx = y%gil%dim(2)
  ny = y%gil%dim(3)
  mess = 'I-UV_TABLE,  '//trim(y%file)//' succesfully opened'
  call gagout(mess)
  ! Define mean observing frequency
  freq = y%gil%freq+y%gil%fres*(nf*0.5-y%gil%ref(1))
  if (freq.lt.0.1) then        ! 100 kHz threshold for warning
    call gagout ('W-UV_MODEL,  VERY low frequency. Please check!')
    write(6,*) 'Value is ',freq,' MHz'
    goto 999
  endif
  !
  ! Get Virtual Memory to perform the FFT
  allocate (tf(nx,ny), work(max(nx,ny)), stat=ier)
!  ip = gag_pointer(addr,memory)    ! Complex copy of the image
!  ipw = gag_pointer(addr,memory)   ! FOURT internal work space
  if (ier.ne.0) then
    mess = 'E-UV_TABLE,  Error allocating virtual memory'
    call gagout (mess)
    goto 999
  endif
  ! Create output table
  call gildas_null(x, type = 'UVT')
  ! Transfer the cube (vlm) header to the UV table header.
  ! Problem: in such a mixed case, gdf_copy_header does not behave properly.
  ! If the input VLM has only 1 channel (dim1 = 1), the UV table will also
  ! have dim1 = 1; as a consequence gdf_setuv will discard all but 1 leading
  ! column, leading to later program error ("suspicious Nlead"). Fixed by
  ! temporarily setting dim1 to the desired size, copy it, and reset it back
  ! to the original value.
  ydim1 = y%gil%dim(1)
  y%gil%dim(1) = x%gil%nlead+x%gil%natom * nf
  call gdf_copy_header (y,x, error)
  y%gil%dim(1) = ydim1  ! Unpatch
  n = len_trim(uvmodel)
  if (n.le.0) then
    mess = 'E-UV_TABLE,  Output file name is empty.'
    call gagout (mess)
    goto 999
  endif
  name = uvmodel(1:n)
  call sic_parsef(name,x%file,' ','.uvt')
  x%gil%nchan = nf
  x%gil%dim(1) = x%gil%nlead+x%gil%natom * nf 
  x%gil%dim(2) = y%gil%dim(2)*(y%gil%dim(3)/2+1)   ! Use hermiticity for a factor of two
  x%gil%dim(3) = 1                 ! space saving
  x%gil%dim(4) = 1
  x%gil%ndim = 2
  x%gil%ref(1)  = y%gil%ref(1)
  x%gil%val(1)  = y%gil%freq
  x%gil%inc(1)  = y%gil%fres
  x%char%code(1) = 'UV-DATA'
  x%char%code(2) = 'RANDOM'
  x%char%code(3) = ' '
  x%char%code(4) = ' '
  x%gil%faxi = 1
  call gdf_create_image (x, error)
  !
  if (error) then
    mess = 'E-UV_MODEL,  Cannot create output UV model '//x%file
    call gagout (mess)
    goto 999
  endif
  call gdf_allocate (x, error)
  if (error) then
    mess = 'E-UV_MODEL,  Cannot obtain memory slot for UV model '
    call gagout (mess)
    goto 999
  endif
  !
  mess = 'I-UV_TABLE,  Output table '//trim(x%file)//' succesfully opened'
  call gagout(mess)
  !
  call uv_pos (error,x%gil%dim(1),x%gil%dim(2),x%r2d,nx,ny,  &
               y%gil%convert(1,2),y%gil%convert(1,3),freq)
  if (error) then
    mess = 'E-UV_TABLE,  Error in UV_POS'
    call gagout(mess)
    goto 999
  endif
  !
  ! OK, compute the model for each channel. Working on an LMV cube would avoid
  ! the (inefficiently programmed) transposition, but would not be consistent
  ! with UV_MODEL. Let's accept the inefficiency for the time being...
  nn(1:2) = y%gil%dim(2:3)
  do if=1,nf
    tf = cmplx ( y%r3d(if,:,:), 0.0)
    call fourt(tf,nn,2,-1,1,work)
    call recent(nx,ny,tf)
    call uv_fill (x%gil%dim(1),x%gil%dim(2),if,x%r2d,nx,ny,tf)
  enddo
  call gdf_write_data (x, x%r2d, error)
  if (error) then
    mess = 'E-UV_TABLE,  Error while updating images'
    call gagout(mess)
    goto 999
  endif
  call gagout('S-UV_TABLE,  Successful completion')
  call sysexi(1)
  !
999 call sysexi(fatale)
end program uv_table
!
subroutine uv_pos(errorfl,nco,nv,visi,nx,ny,xconvert,yconvert,freq)
  use gildas_def
  !---------------------------------------------------------------------
  ! Fill the UV coordinates of the grid points
  !---------------------------------------------------------------------
  logical :: errorfl                             !
  integer(kind=index_length), intent(in) :: nco  !
  integer(kind=index_length), intent(in) :: nv   !
  real :: visi(nco,nv)                           !
  integer :: nx                                  !
  integer :: ny                                  !
  real*8 :: xconvert(3)                          !
  real*8 :: yconvert(3)                          !
  real :: freq                                   !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: clight
  parameter (clight = 299792458)
  real*8 :: lambda
  integer :: i,j,i0,j0,k,iv
  real :: u,v,stepx,stepy
  !
  if (mod(nx,2).ne.0.or.mod(ny,2).ne.0) then
    call gagout('E-UV_TABLE,  Odd image dimensions are not supported yet')
    errorfl = .true.
    return
  elseif (nv.lt.nx*(ny/2+1)) then  ! Internal logic must be wrong!
    call gagout('F-UV_TABLE, Output dimension is too small')
    errorfl = .true.
    return
  endif
  !
  i0 = nx/2+1
  j0 = ny/2+1
  lambda = clight/(freq*1e6)
  stepx = 1./(nx*xconvert(3))*lambda
  stepy = 1./(ny*yconvert(3))*lambda
  !
  iv = 0
  do j=1,j0-1
    v = (j-j0)*stepy
    do i=1,nx
      iv = iv+1
      u = (i-i0)*stepx
      visi(1,iv) = u           ! U
      visi(2,iv) = v           ! V
      visi(3,iv) = 0           ! W
      do k=8,nco,3
        visi(k,iv)   = 0
        visi(k+1,iv) = 0
        visi(k+2,iv) = 1.
      enddo
    enddo
  enddo
  ! Special handling of U axis to avoid storing conjugate data
  do j=j0,j0
    v = (j-j0)*stepy
    do i=1,i0
      iv = iv+1
      u = (i-i0)*stepx
      visi(1,iv) = u           ! U
      visi(2,iv) = v           ! V
      visi(3,iv) = 0           ! W
      do k=8,nco,3
        visi(k,iv)   = 0
        visi(k+1,iv) = 0
        visi(k+2,iv) = 1.
      enddo
    enddo
  enddo
end subroutine uv_pos
!
subroutine uv_fill (nco,nv,if,visi,nx,ny,fft)
  use gildas_def
  !---------------------------------------------------------------------
  ! Fill the visibilities for one frequency channel
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nco  !
  integer(kind=index_length), intent(in) :: nv   !
  integer :: if                                  !
  real :: visi(nco,nv)                           !
  integer :: nx                                  !
  integer :: ny                                  !
  real :: fft(2,nx,ny)                           !
  ! Local
  integer :: i,j,iv,i0,j0
  !
  i0 = nx/2+1
  j0 = ny/2+1
  !
  iv = 0
  do j=1,j0-1
    do i=1,nx
      iv = iv+1
      visi(5+3*if,iv) =  +(-1)**(i+j)*fft(1,i,j)
      visi(6+3*if,iv) =  -(-1)**(i+j)*fft(2,i,j)
    enddo
  enddo
  do j=j0,j0
    do i=1,i0
      iv = iv+1
      visi(5+3*if,iv) =  +(-1)**(i+j)*fft(1,i,j)
      visi(6+3*if,iv) =  -(-1)**(i+j)*fft(2,i,j)
    enddo
  enddo
end subroutine uv_fill
!
subroutine recent(nx,ny,z)
  !---------------------------------------------------------------------
  ! Recenters the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: z(nx,ny)               !
  ! Local
  integer :: i, j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i+nx/2,j+ny/2)
      z(i+nx/2,j+ny/2) = z(i,j)
      z(i,j) = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i,j+ny/2)
      z(i,j+ny/2) = z(i+nx/2,j)
      z(i+nx/2,j) = tmp
    enddo
  enddo
end subroutine recent

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the GREG package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine greg_pack_set(pack)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_set
  use gpack_def
  !----------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Public package definition routine.
  ! It defines package methods and dependencies to other packages.
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack ! Package info structure
  !
  pack%name='greg'
  pack%ext='.greg'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /)
  pack%init=locwrd(greg_pack_init)
  pack%clean=locwrd(greg_pack_clean)
  pack%authors="S.Bardeau, J.Pety"
  !
end subroutine greg_pack_set
!
subroutine greg_pack_init(gpack_id,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_init
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Private routine to set the GREG environment.
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  !
  ! Set libraries id's
  call gchar_message_set_id(gpack_id)
  call gcont_message_set_id(gpack_id)
  call gtv_message_set_id(gpack_id)
  call gtv_c_message_set_id(gpack_id)
  call greg_message_set_id(gpack_id)
  call gcore_c_message_set_id(gpack_id)
#ifdef GAG_USE_GTK
  call gui_c_message_set_id(gpack_id)
#endif
  !
  ! Local language
  call load_greg('INTERACTIVE')
  call load_greg('INTERACTIVE GREG3')
  !
  if (.not.gmaster_hide_gui()) then
     call gr_exec('DEVICE IMAGE WHITE')
     error = gr_error()
     if (error) return
  endif
  !
end subroutine greg_pack_init
!
subroutine greg_pack_clean(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_pack_clean
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Private routine to clean the GREG environment
  ! (e.g. Remove temporary buffers, unregister languages...)
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  call exit_greg(error)
  ! if (error)  continue
  !
  ! Clear the graphic screen
  call exit_clear
  !
end subroutine greg_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program dft
  use gkernel_interfaces
  use mapping_interfaces
  use image_def
  use phys_const
  use uvmap_def_task
  use clean_mx, only:domima
  !---------------------------------------------------------------------
  ! TASK  Compute a map from a CLIC UV Table
  !	by Direct Fourier Transform
  !---------------------------------------------------------------------
  ! Global
  type (gildas) :: uv
  type (gildas) :: beam
  type (gildas) :: lmv
  type (gildas) :: vlm
  type (par_uvmap) :: map
  ! Local
  logical :: error
  real, allocatable :: pox(:), poy(:), dw(:), uu(:), vv(:)
  real, allocatable :: dbeam(:,:)
  real, allocatable, target :: dvlm(:,:,:)
  real, pointer :: duv(:,:), dlmv(:,:,:)
  !
  integer :: n, ier
  integer :: lcol,fcol,wcol
  integer :: np,nv,nc,nx,ny
  real :: rmi, rma
  integer :: imi, ima, nd
  integer(kind=8) :: ilong
  real(kind=8) :: freq
  real :: cpu1,cpu0, wall
  character(len=80) :: uv_table, map_name, chain
  !
  !------------------------------------------------------------------------
  ! Code:
  call gag_cpu(cpu0)
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('MAP_NAME$',map_name)
  call gildas_real('UV_TAPER$',map%taper,4)
  call gildas_char('WEIGHT_MODE$',map%mode)
  call gildas_real('MAP_FIELD$',map%field,2)
  if (map%field(1).ne.0.0 .or. map%field(2).ne.0.0) then
     call gagout('W-UV_DFT, MAP_FIELD not supported in this version')
  endif
  call gildas_inte('MAP_SIZE$',map%size,2)
  call gildas_real('MAP_CELL$',map%xycell,2)
  if (map%xycell(1).eq.0.0 .or. map%xycell(2).eq.0.0) then
     call gagout('E-UV_DFT, MAP_CELL shoult be defined in this version')
     goto 999
  endif
  call gildas_real('UV_CELL$',map%uniform,2)
  call gildas_inte('WCOL$',map%channels(3),1)
  call gildas_inte('MCOL$',map%channels,2)
  call gildas_close
  !
  call get_weightmode('UV_DFT',map%mode,error)
  if (error) goto 999
  !
  if (map%mode.eq.'NATU') map%uniform(1) = -1.0
  map%xycell = map%xycell*pi/180.0/3600.0 ! in radians
  !
  ! Input file
  n = len_trim(uv_table)
  if (n.le.0) goto 999
  call gildas_null(uv, type = 'UVT')
  call gdf_read_gildas (uv, uv_table, '.uvt', error)
  if (error) then
    call gagout('F-DFT, Cannot read input UV table '   &
     &      //trim(uv%file) )
    goto 999
  endif
  !
  ier = gdf_range(map%channels,uv%gil%nchan)
  fcol = min(map%channels(1),map%channels(2))
  lcol = max(map%channels(1),map%channels(2))
  map%channels(1) = fcol
  map%channels(2) = lcol
  if (map%channels(3).eq.0) then
    map%channels(3) = (lcol+fcol)/2
  else
    map%channels(3) = max(0,min(map%channels(3),nc))
  endif
  nc = lcol-fcol+1
  wcol = map%channels(3)
  wcol = uv%gil%nlead+3*wcol  ! Weight column now
  !
  ! Prepare weights
  call gagout('I-DFT, preparing weights')
  np = uv%gil%dim(1)                ! Size of one visibility
  nv = uv%gil%dim(2)                ! number of visibility points
  duv => uv%r2d                     ! Point towards UV data values
  allocate (dw(nv),vv(nv),uu(nv),stat=ier)
  if (ier.ne.0) goto 999
  uu(:) = duv(1,:)
  vv(:) = duv(2,:)
  dw(:) = duv(wcol,:)
  !
  ! Compute weights
  call t_doweig (nv,uu,vv,dw,map%uniform(1),map%uniform(2),error)
  if (error) goto 999
  !
  ! Compute taper and normalize weights
  call dotape (np,nv,   &
     &    duv,   &             ! Visibilities
     &    1,2,   &             ! U, V pointers
     &    map%taper,   &       ! UV Taper
     &    dw)                  ! Weight
  wall = sump(nv,dw)
  dw(:) = dw/wall              ! Normalize
  wall = 1e-3/sqrt(wall)       ! Convert to noise prediction
  !
  nx = map%size(1)
  ny = map%size(2)
  !
  ! Compute observing frequency for U,V cell size (with Doppler correction)
  freq = uv%gil%val(1)+uv%gil%fres*(uv%gil%val(1)/uv%gil%freq)*(lcol+fcol)*0.5
  !
  ! Now create beam image
  call gildas_null(beam)
  call t_setbeam(uv,beam,map,2)
  call sic_parse_file(map_name,' ','.beam',beam%file)
  call gagout('I-DFT, Creating beam file '//beam%file)
  !
  allocate(dbeam(nx,ny),stat=ier)
  if (ier.ne.0) then
    call gagout('F-DFT, cannot create output beam image')
    goto 999
  endif
  !
  ! Create image (in order v l m )
  call gildas_null(vlm)
  call gildas_null(lmv)
  call t_setdirty(uv,lmv,map,wall)
  call gdf_transpose_header(lmv,vlm,'312',error)
  if (error)  goto 999
  !
  call sic_parse_file(map_name,' ','.vlm',vlm%file)
  call sic_parse_file(map_name,' ','.lmv',lmv%file)
  !
  allocate (dvlm(nc,nx,ny),stat=ier)
  !
  ! Compute distance coefficients
  allocate( pox(nx), poy(ny), stat=ier)
  call init_axis(pox,nx,vlm%gil%ref(2),vlm%gil%val(2),vlm%gil%inc(2))
  call init_axis(poy,ny,vlm%gil%ref(3),vlm%gil%val(3),vlm%gil%inc(3))
  !
  ! Compute map and beam
  call gag_cpu(cpu1)
  write(chain,'(A,1X,1PG10.3)') 'I-DFT,  Starting image ',cpu1-cpu0
  call gagout(chain)
  call do_map(np,nv,duv,dw,uv%gil%nlead,fcol,   &
     &    freq,nc,nx,ny,   &
     &    dvlm,dbeam,pox,poy)
  !
  call gdf_write_image(beam,dbeam,error)
  deallocate (dbeam,duv)
  !
  ! Transpose
  !
  call gag_cpu(cpu1)
  write(chain,'(A,1X,1PG10.3)') 'I-DFT,  Transposing ',cpu1-cpu0
  call gagout(chain)
  !
  call gagout('I-DFT, Creating map file '//lmv%file)
  if (nc.gt.1) then
     allocate (dlmv(nx,ny,nc),stat=ier)
     call trnpos (nx*ny,nc, dvlm, dlmv)
     nd = nx*ny*nc
     call domima (dlmv,rmi,rma,imi,ima,nd)
  else
     dlmv => dvlm
  endif
  !
  lmv%gil%extr_words = def_extr_words          ! extrema computed
  lmv%gil%rmax = rma
  lmv%gil%rmin = rmi
  ilong = imi
  call gdf_index_to_where (ilong,lmv%gil%ndim,lmv%gil%dim,lmv%gil%minloc)  
  ilong = ima
  call gdf_index_to_where (ilong,lmv%gil%ndim,lmv%gil%dim,lmv%gil%maxloc)  
  call gdf_write_image(lmv, dlmv, error)
  !
  write(chain,'(A,1X,1PG10.3)') 'I-DFT,  Finished ',cpu1-cpu0
  call gagout(chain)
  call sysexi(1)
  !
  999   call sysexi (fatale)
end program dft
!
subroutine do_map(np,nv,visi,we,nlead,lc,   &
     &    freq,nc,nx,ny,map,beam,mapcox,mapcoy)
  integer, intent(in) :: np         ! Size of  visibility
  integer, intent(in) :: nv         ! Number of visibilities
  real, intent(in) :: visi(np,nv)   ! Visibilities
  real, intent(in) :: we(nv)        ! Weights
  integer, intent(in) :: nlead      ! Leading information
  integer, intent(in) :: lc         ! First channel
  real(kind=8), intent(in) :: freq  ! Observatory frequency
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: nx         ! Size of map
  integer, intent(in) :: ny         ! Size of map
  real, intent(out) :: map(nc,nx,ny)! Map
  real, intent(out) :: beam(nx,ny)  ! Beam
  real, intent(in) :: mapcox(nx)    ! Coordinates in X
  real, intent(in) :: mapcoy(ny)    ! Coordinates in Y
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  real(kind=8) :: sinu, cosi
  real(kind=8) :: f_to_k                ! (2*pi/clight)*1d6
  parameter (f_to_k = 2.d0*pi/299792458.d-6)
  real(kind=8) :: z
  real(kind=8), allocatable :: kwx(:), kwy(:)
  integer :: ix, iy, ic, iic, irc, iv, ier
  !------------------------------------------------------------------------
  ! Code:
  beam = 0.
  map = 0.
  !
  allocate (kwx(nv),kwy(nv),stat=ier)
  do iv = 1, nv                 ! loop on visibility points
    kwx(iv) = freq * f_to_k * visi(1,iv)    ! Prepare exponential coefficients
    kwy(iv) = freq * f_to_k * visi(2,iv)
  enddo
  !
  ! Take into account conjugate points
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(nx,ny,nv,nc,nlead,lc) &
  !$OMP & SHARED(visi,kwy,kwx,mapcox,mapcoy,we,map,beam) &
  !$OMP & PRIVATE(ix,iy,iv,z,cosi,sinu,irc,iic,ic)
  !$OMP DO
  do iy = 1,ny              ! Loop on pixels
     do ix = 1,nx
        do iv=1,nv
           z = kwy(iv)*mapcoy(iy) + kwx(iv)*mapcox(ix) 
           cosi = cos(z)*we(iv)
           sinu = sin(z)*we(iv)
           beam(ix,iy) = beam(ix,iy)+cosi
           irc = nlead+3*(lc-1)+1
           do ic = 1, nc
              iic = irc+1
              map(ic,ix,iy) = map(ic,ix,iy)   &
     &              + visi(irc,iv)*cosi   &
     &              + visi(iic,iv)*sinu
              irc = irc+3  ! Increment 
           enddo
        enddo
     enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  deallocate(kwx, kwy)
end subroutine do_map
!
subroutine trnpos(nxy,nz,in,out)
  integer :: nxy                  !
  integer :: nz                   !
  real :: in(nz,nxy)              !
  real :: out(nxy,nz)             !
  ! Local
  integer :: i,j
  do j=1,nxy
    do i=1,nz
      out(j,i) = in(i,j)
    enddo
  enddo
end subroutine trnpos
!
subroutine init_axis(axis,n,ref,val,inc) 
  integer :: n                      !
  real :: axis(n)                   !
  real(kind=8) :: ref                     !
  real(kind=8) :: inc                     !
  real(kind=8) :: val                     !
  ! Local
  integer :: k
  do k=1, n
    axis(k) = (k-ref)*inc + val
  enddo
end subroutine init_axis

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_replace
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_messaging
  !
  public :: replace
  private
  !
  character(len=*), parameter :: keyvalues(1) = &
       ['NaN'] ! We could also add +- inf
  integer(kind=code_k), parameter :: valisreal = -1
  integer(kind=code_k), parameter :: valisnan = 1
  !
  type :: replace_comm_t
     type(option_t),      pointer :: comm
     type(cubeid_arg_t),  pointer :: incube
     type(option_t),      pointer :: value
     type(keywordlist_comm_t), pointer :: ival_arg
     type(keywordlist_comm_t), pointer :: oval_arg
     type(cube_prod_t),   pointer :: replaced
   contains
     procedure, public  :: register     => cubemain_replace_register
     procedure, private :: parse        => cubemain_replace_parse
     procedure, private :: parse_values => cubemain_replace_parse_values
     procedure, private :: main         => cubemain_replace_main
  end type replace_comm_t
  type(replace_comm_t) :: replace
  !
  type replace_user_t
     type(cubeid_user_t)   :: cubeids
     character(len=argu_l) :: ival   ! Value to be replaced 
     character(len=argu_l) :: oval   ! Value to replace with
   contains
     procedure, private :: toprog => cubemain_replace_user_toprog
  end type replace_user_t
  !
  type replace_prog_t
     type(cube_t), pointer :: incube     ! Input cube
     type(cube_t), pointer :: replaced   ! Output cube
     integer(kind=code_k)  :: ivaliskey  ! Value to replace is NaN?
     real(kind=sign_k)     :: ival       ! Value to be replaced
     real(kind=sign_k)     :: oval       ! Value to replace with
     procedure(cubemain_replace_prog_act_nan), pointer :: act => null()
   contains
     procedure, private :: header => cubemain_replace_prog_header
     procedure, private :: data   => cubemain_replace_prog_data
     procedure, private :: loop   => cubemain_replace_prog_loop
  end type replace_prog_t
  !
contains
  !
  subroutine cubemain_replace_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(replace_user_t) :: user
    character(len=*), parameter :: rname='REPLACE>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call replace%parse(line,user,error)
    if (error) return
    call replace%main(user,error)
    if (error) continue
  end subroutine cubemain_replace_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_replace_register(replace,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_comm_t), intent(inout) :: replace
    logical,               intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='REPLACE>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'REPLACE','[cubeid]',&
         'Replace a value by another one in the data',&
         'REPLACE substitutes one data value by another over the selected&
         & cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /VALUE ival oval is mandatory.'//strg_cr//&
         '- ival and oval can be numeric values or NaN.'//strg_cr//&
         '- "*" is interpreted as NaN. "=" is not accepted for either value.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> REPLACE 12co10:cube /VALUE NaN 0'//strg_cr//&
         'CUBE> REPLACE 12co10:cube /VALUE -1000 NaN',&
         cubemain_replace_command,&
         replace%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (any family/flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         replace%incube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VALUE','ival oval',&
         'Define value to be replaced and its replacement',&
         strg_emp,&
         replace%value,error)
    if (error) return
    call keyarg%register(&
         'ival',&
         'Value to be replaced',&
         strg_emp,&
         code_arg_mandatory,&
         keyvalues,&
         flexible,&
         replace%ival_arg,&
         error)
    if (error) return
    call keyarg%register(&
         'oval',&
         'Value to replace with',&
         strg_emp,&
         code_arg_mandatory,&
         keyvalues,&
         flexible,&
         replace%oval_arg,&
         error)
    if (error) return
    !
    ! Product
    call oucube%register(&
         'REPLACED',&
         'Cube with replaced values',&
         strg_emp,&
         [flag_replace],&
         replace%replaced,&
         error,&
         flagmode=keep_prod)
    if (error) return
  end subroutine cubemain_replace_register
  !
  subroutine cubemain_replace_parse(replace,line,user,error)
    !----------------------------------------------------------------------
    ! REPLACE [cubeid]
    !----------------------------------------------------------------------
    class(replace_comm_t), intent(in)    :: replace
    character(len=*),      intent(in)    :: line
    type(replace_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPLACE>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,replace%comm,user%cubeids,error)
    if (error) return
    call replace%parse_values(line,user,error)
    if (error) return
  end subroutine cubemain_replace_parse
  !
  subroutine cubemain_replace_parse_values(replace,line,user,error)
    !----------------------------------------------------------------------
    ! /VALUE ival oval
    !----------------------------------------------------------------------
    class(replace_comm_t), intent(in)    :: replace
    character(len=*),      intent(in)    :: line
    type(replace_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    logical :: present
    character(len=*), parameter :: rname='REPLACE>PARSE>VALUE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call replace%value%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,replace%value,1,user%ival,mandatory,error)
       if (error) return
       call cubetools_getarg(line,replace%value,2,user%oval,mandatory,error)
       if (error) return       
    else
       call cubemain_message(seve%e,rname,'/VALUE key is mandatory')
       error = .true.
       return
    endif
  end subroutine cubemain_replace_parse_values
  !
  subroutine cubemain_replace_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_comm_t), intent(in)    :: comm
    type(replace_user_t),  intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(replace_prog_t) :: prog
    character(len=*), parameter :: rname='REPLACE>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_replace_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_replace_user_toprog(user,comm,prog,error)
    use cubetools_unit
    use cubetools_nan
    use cubetools_user2prog
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_user_t), intent(in)    :: user
    class(replace_comm_t), intent(in)    :: comm
    type(replace_prog_t),  intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    integer(kind=code_k) :: ikey
    character(len=mess_l) :: mess
    character(len=argu_l) :: argu
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='REPLACE>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    !
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    !
    if (user%ival.eq."=") then
       call cubemain_message(seve%e,rname,'= syntax not supported for value to be replaced')
       error =  .true.
       return
    endif
    if (user%oval.eq."=") then
       call cubemain_message(seve%e,rname,'= syntax not supported for replacing value')
       error =  .true.
       return
    endif
    !
    call cubetools_keywordlist_user2prog(replace%ival_arg,user%ival,ikey,argu,error)
    if (error) return
    if (argu.eq.strg_unresolved) then
       call cubetools_user2prog_resolve_star(user%ival,nounit,gr4nan,prog%ival,error)
       if (error) return
       if (user%ival.eq.strg_star) then
          prog%ivaliskey = valisnan
       else
          prog%ivaliskey = valisreal
       endif
    else
       select case(argu)
       case('NAN')
          prog%ival = gr4nan
          prog%ivaliskey = valisnan
       case default
          call cubemain_message(seve%e,rname,"Unknown key value: "//argu)
          error =  .true.
          return
       end select
    endif
    call cubetools_keywordlist_user2prog(replace%oval_arg,user%oval,ikey,argu,error)
    if (error) return
    if (argu.eq.strg_unresolved) then
       call cubetools_user2prog_resolve_star(user%oval,nounit,gr4nan,prog%oval,error)
       if (error) return
    else
       select case(argu)
       case('NAN')
          prog%oval = gr4nan
       case default
          call cubemain_message(seve%e,rname,"Unknown key value: "//argu)
          error =  .true.
          return
       end select
    endif
    ! User feedback
    write(mess,'(2(a,1pg14.7))') 'Replacing ',prog%ival,' with ',prog%oval
    call cubemain_message(seve%i,rname,mess)
    !
    if (prog%ivaliskey.eq.valisnan) then
       prog%act => cubemain_replace_prog_act_nan
    else
       prog%act => cubemain_replace_prog_act_real
    endif
  end subroutine cubemain_replace_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_replace_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_prog_t), intent(inout) :: prog
    type(replace_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPLACE>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%replaced,prog%incube,prog%replaced,error)
    if (error) return
  end subroutine cubemain_replace_prog_header
  !
  subroutine cubemain_replace_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: itertask
    character(len=*), parameter :: rname='REPLACE>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(itertask,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(itertask)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(itertask,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(itertask)
       if (.not.error) then
          call prog%loop(itertask,error)
       endif
       !$OMP END TASK
    enddo ! itertask
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubemain_replace_prog_data
  !
  subroutine cubemain_replace_prog_loop(prog,itertask,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    ! The subcube iterator will be shared by all input and output subcubes
    !----------------------------------------------------------------------
    class(replace_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: itertask
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='REPLACE>PROG>LOOP>NAN'
    !
    do while (itertask%iterate_entry(error))
       call prog%act(itertask,error)
       if (error) return
    enddo  ! ientry
  end subroutine cubemain_replace_prog_loop
  !
  subroutine cubemain_replace_prog_act_nan(prog,itertask,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: input,replaced
    character(len=*), parameter :: rname='REPLACE>PROG>ACT>NAN'
    !
    ! Subcube2subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube2subcube to another.
    call input%associate('input',prog%incube,itertask,error)
    if (error) return
    call replaced%allocate('replaced',prog%replaced,itertask,error)
    if (error) return
    !
    call input%get(error)
    do iz=1,input%nz
       do iy=1,input%ny
          do ix=1,input%nx
             if (ieee_is_nan(input%val(ix,iy,iz))) then
                replaced%val(ix,iy,iz) = prog%oval
             else
                replaced%val(ix,iy,iz) = input%val(ix,iy,iz)
             endif
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call replaced%put(error)
    if (error) return
  end subroutine cubemain_replace_prog_act_nan
  !
  subroutine cubemain_replace_prog_act_real(prog,itertask,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(replace_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(in)    :: itertask
    logical,                  intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: input,replaced
    character(len=*), parameter :: rname='REPLACE>PROG>ACT>REAL'
    !
    ! Subcube2subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube2subcube to another.
    call input%associate('input',prog%incube,itertask,error)
    if (error) return
    call replaced%allocate('replaced',prog%replaced,itertask,error)
    if (error) return
    !
    call input%get(error)
    do iz=1,input%nz
       do iy=1,input%ny
          do ix=1,input%nx
             if (input%val(ix,iy,iz).eq.prog%ival) then
                replaced%val(ix,iy,iz) = prog%oval
             else
                replaced%val(ix,iy,iz) = input%val(ix,iy,iz)
             endif
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call replaced%put(error)
    if (error) return
  end subroutine cubemain_replace_prog_act_real
end module cubemain_replace
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_noise_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_consistency_types
  use cubetools_structure
  !
  public :: noise_t,noise_user_t,noise_cons_t,noise_opt_t
  public :: cubetools_array_noise2userstruct
  !
  public :: cubetools_noise_init,cubetools_noise_get_and_derive
  public :: cubetools_noise_final,cubetools_noise_put
  public :: cubetools_noise_list,cubetools_noise_sicdef,cubetools_noise_copy
  public :: cubetools_noise_consistency_init,cubetools_noise_consistency_final
  public :: cubetools_noise_consistency_check,cubetools_noise_consistency_list
  private
  !
  type noise_t
     real(kind=sign_k) :: sigma = 0.0
     real(kind=sign_k) :: rms  = 0.0
  end type noise_t
  !
  type noise_opt_t
     type(option_t), pointer :: opt
   contains
     procedure :: register  => cubetools_noise_register
     procedure :: parse     => cubetools_noise_parse
     procedure :: user2prog => cubetools_noise_user2prog
  end type noise_opt_t
  !
  type noise_user_t
     character(len=argu_l) :: sigma = strg_unk ! [ ] Theoretical noise
     character(len=argu_l) :: rms   = strg_unk ! [ ] Measured noise
     logical               :: do    = .false.  ! Option was present
  end type noise_user_t
  !
  type noise_cons_t
     logical                  :: check=.true.    ! Check the section
     logical                  :: prob =.false.   ! Is there a problem
     logical                  :: mess =.true.    ! Output message for this section?
     type(consistency_desc_t) :: sigma
     type(consistency_desc_t) :: rms
  end type noise_cons_t
contains
  !
  subroutine cubetools_noise_init(noise,error)
    !-------------------------------------------------------------------
    ! Just initialize the type
    !-------------------------------------------------------------------
    type(noise_t), intent(out)   :: noise
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_noise_init
  !
  subroutine cubetools_noise_get_and_derive(sigma,rms,noi,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=sign_k), intent(in)    :: sigma
    real(kind=sign_k), intent(in)    :: rms
    type(noise_t),     intent(inout) :: noi
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GENERAL>GET>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    noi%sigma = sigma
    noi%rms   = rms
  end subroutine cubetools_noise_get_and_derive
  !
  subroutine cubetools_noise_put(noi,sigma,rms,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(noise_t),     intent(in)    :: noi
    real(kind=sign_k), intent(out)   :: sigma
    real(kind=sign_k), intent(out)   :: rms
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PUT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    sigma = noi%sigma
    rms   = noi%rms
  end subroutine cubetools_noise_put
  !
  subroutine cubetools_noise_final(noise,error)
    !-------------------------------------------------------------------
    !  Just reinitialize the type
    !-------------------------------------------------------------------
    type(noise_t), intent(out)   :: noise
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_noise_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_register(noise,abstract,error)
    !----------------------------------------------------------------------
    ! Register a /NOISE option under a given name and abstract
    !----------------------------------------------------------------------
    class(noise_opt_t), intent(out)   :: noise
    character(len=*),   intent(in)    :: abstract
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    !
    character(len=*), parameter :: rname='NOISE>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'NOISE','sigma rms',&
         abstract,&
         strg_emp, &
         noise%opt,error)
    if (error) return
    call stdarg%register( &
         'SIGMA',  &
         'Theoretical noise', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, &
         error)
    if (error) return
    call stdarg%register( &
         'RMS',  &
         'Measured noise', &
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory, &
         error)
    if (error) return
  end subroutine cubetools_noise_register
  !
  subroutine cubetools_noise_parse(noise,line,user,error)
    !----------------------------------------------------------------------
    ! Parse noise
    ! /NOISE major [minor [pang [pangunit]]]
    ! ----------------------------------------------------------------------
    class(noise_opt_t), intent(in)    :: noise
    character(len=*),   intent(in)    :: line
    type(noise_user_t), intent(inout) :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    user%sigma = strg_star
    user%rms   = strg_star
    !
    call noise%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,noise%opt,1,user%sigma,mandatory,error)
       if (error) return
       call cubetools_getarg(line,noise%opt,2,user%rms,mandatory,error)
       if (error) return
    endif
  end subroutine cubetools_noise_parse
  !
  subroutine cubetools_noise_user2prog(noise,user,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    ! Resolves a noise description based on a previous one according to
    ! user inputs.
    !----------------------------------------------------------------------
    class(noise_opt_t), intent(in)    :: noise
    type(noise_user_t), intent(in)    :: user
    type(noise_t),      intent(inout) :: prog
    logical,            intent(inout) :: error
    !
    type(unit_user_t) :: userunit
    real(kind=sign_k) :: default,previous
    character(len=*), parameter :: rname='NOISE>USER2PROG'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (user%do) then
       call userunit%get_from_code(code_unit_unk,error)
       if (error) return
       !
       default = prog%sigma
       previous = prog%sigma
       call cubetools_user2prog_resolve_all(user%sigma,userunit,default,previous,prog%sigma,error)
       if (error) return
       if (prog%sigma.lt.0.) then
          call cubeheader_message(seve%e,rname,'Theoretical noise can not be negative')
          error = .true.
          return
       endif
       default = prog%rms
       previous = prog%rms
       call cubetools_user2prog_resolve_all(user%rms,userunit,default,previous,prog%rms,error)
       if (error) return
       if (prog%rms.lt.0.) then
          call cubeheader_message(seve%e,rname,'Measured noise can not be negative')
          error = .true.
          return
       endif
    else ! .not.user%do
       continue
    endif
  end subroutine cubetools_noise_user2prog
  !
  subroutine cubetools_noise_prog2user(prog,user,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(noise_t),      intent(in)    :: prog
    type(noise_user_t), intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>PROG2USER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    write(user%sigma,'(1pg14.7)') prog%sigma
    write(user%rms,  '(1pg14.7)') prog%rms
  end subroutine cubetools_noise_prog2user
  !
  subroutine cubetools_array_noise2userstruct(prog,userstruct,error)
    use cubetools_userspace
    use cubetools_userstruct
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    type(noise_t),      intent(in)    :: prog
    type(userstruct_t), intent(inout) :: userstruct
    logical,            intent(inout) :: error
    !
    type(noise_user_t) :: user
    character(len=*), parameter :: rname='ARRAY>NOISE2USERSTRUCT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_noise_prog2user(prog,user,error)
    if (error) return
    call userstruct%def(error)
    if (error) return
    call userstruct%set_member('sigma',user%sigma,error)
    if (error) return
    call userstruct%set_member('rms',user%rms,error)
    if (error) return
  end subroutine cubetools_array_noise2userstruct
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_list(noise,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(noise_t), intent(in)    :: noise
    logical,       intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='NOISE>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    mess = cubetools_format_stdkey_boldval('Sigma',noise%sigma,'f15.8',22)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('RMS',noise%rms,'f15.8',22)
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_noise_list
  !
  subroutine cubetools_noise_sicdef(name,noise,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(noise_t),    intent(in)    :: noise
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return
    call sic_def_real(trim(name)//'%sigma',noise%sigma,0,0,readonly,error)
    if (error) return
    call sic_def_real(trim(name)//'%rms',noise%rms,0,0,readonly,error)
    if (error) return
  end subroutine cubetools_noise_sicdef
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(noise_t), intent(in)    :: in
    type(noise_t), intent(out)   :: ou
    logical,       intent(inout) :: error
    !
    character(len=*), parameter :: rname='NOISE>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou = in
  end subroutine cubetools_noise_copy
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_noise_consistency_init(cons,error)
    !-------------------------------------------------------------------
    ! Init the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_init(strict,check,mess,cons%sigma,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%rms,error)
    if (error) return
    !
  end subroutine cubetools_noise_consistency_init
  !
  subroutine cubetools_noise_consistency_check(cons,noise1,noise2,error)
    !-------------------------------------------------------------------
    ! Check the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(inout) :: cons
    type(noise_t),      intent(in)    :: noise1
    type(noise_t),      intent(in)    :: noise2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    cons%prob = .false.
    call cubetools_consistency_real_check(cons%sigma,noise1%sigma,noise2%sigma,error)
    if (error) return
    call cubetools_consistency_real_check(cons%rms,noise1%rms,noise2%rms,error)
    if (error) return
    !
    cons%prob = cons%sigma%prob.or.cons%rms%prob
  end subroutine cubetools_noise_consistency_check
  !
  subroutine cubetools_noise_consistency_list(unit1,unit2,cons,noise1,noise2,error)
    !-------------------------------------------------------------------
    ! List the consistency between noise sections
    !-------------------------------------------------------------------
    character(len=*),   intent(in)    :: unit1
    character(len=*),   intent(in)    :: unit2
    type(noise_cons_t), intent(in)    :: cons
    type(noise_t),      intent(in)    :: noise1
    type(noise_t),      intent(in)    :: noise2
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check.or..not.cons%mess.or..not.cons%prob) return
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('noises',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call cubetools_consistency_real_print('Sigmas',unit1,unit2,cons%sigma,noise1%sigma,noise2%sigma,error)
       if (error) return
       call cubetools_consistency_real_print('RMS',unit1,unit2,cons%rms,noise1%rms,noise2%rms,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_noise_consistency_list
  !
  subroutine cubetools_noise_consistency_final(cons,error)
    !-------------------------------------------------------------------
    ! Final the consistency between noise sections
    !-------------------------------------------------------------------
    type(noise_cons_t), intent(out)   :: cons
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='ARRAY>NOISE>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_final(cons%sigma,error)
    if (error) return
    call cubetools_consistency_final(cons%rms,error)
    if (error) return
    !
  end subroutine cubetools_noise_consistency_final
end module cubetools_noise_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module sched30m_interfaces_private
  interface
    subroutine sched30m_load
      !---------------------------------------------------------------------
      ! @ private
      ! Define and load languages of the package.
      !---------------------------------------------------------------------
      ! Local
      ! Define commands of a new language
    end subroutine sched30m_load
  end interface
  !
  interface
    subroutine sched30m_run(line,comm,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for the language SCHED30M.
      ! This routine is able to call the routines associated to each
      ! command of the language SCHED30M
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: line   ! Command line to send to support routines
      character(len=12), intent(in)    :: comm   ! Command resolved by the SIC interpreter
      logical,           intent(inout) :: error  ! Logical error flag
    end subroutine sched30m_run
  end interface
  !
  interface
    function sched30m_error()
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for the error status of the library. Does nothing
      ! here.
      !---------------------------------------------------------------------
      logical :: sched30m_error
    end function sched30m_error
  end interface
  !
  interface
    subroutine sched30m_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine sched30m_message_set_id
  end interface
  !
  interface
    subroutine sched30m_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine sched30m_message
  end interface
  !
  interface
    subroutine sched30m_pack_set(pack)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack
    end subroutine sched30m_pack_set
  end interface
  !
  interface
    subroutine sched30m_pack_init(gpack_id,error)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4) :: gpack_id
      logical         :: error
    end subroutine sched30m_pack_init
  end interface
  !
  interface
    subroutine sched30m_pack_clean(error)
      !---------------------------------------------------------------------
      ! @ private
      ! Called at end of session. Might clean here for example global
      ! buffers allocated during the session
      !---------------------------------------------------------------------
      logical :: error
    end subroutine sched30m_pack_clean
  end interface
  !
  interface
    subroutine sched30m_schedule_command(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Support subroutine for command
      !    SCHEDULE File1 [File2]
      ! Decode the command line
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine sched30m_schedule_command
  end interface
  !
  interface
    subroutine sched30m_schedule(infour,file1,file2,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Support subroutine for command
      !    SCHEDULE File1 [File2]
      ! Do the actual work
      !---------------------------------------------------------------------
      logical,          intent(in)    :: infour
      character(len=*), intent(in)    :: file1
      character(len=*), intent(in)    :: file2
      logical,          intent(inout) :: error
    end subroutine sched30m_schedule
  end interface
  !
  interface
    subroutine sched30m_hardcopy_command(line,error)
      !---------------------------------------------------------------------
      ! @ private
      !  Support subroutine for command
      !    HARDCOPY
      ! Decode the command line
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine sched30m_hardcopy_command
  end interface
  !
  interface
    subroutine sched30m_hardcopy(error)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine sched30m_hardcopy
  end interface
  !
  interface
    subroutine parse_file_name(file,basename,wk,vers,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Decode the file version from file name. File name must have the form
      !   wk12v3.dat  (1 or more digits for the version).
      ! Return version as an integer
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: file      !
      character(len=*), intent(out)   :: basename  !
      integer(kind=4),  intent(out)   :: wk        ! Week number
      integer(kind=4),  intent(out)   :: vers      ! Version
      logical,          intent(inout) :: error     !
    end subroutine parse_file_name
  end interface
  !
end module sched30m_interfaces_private

subroutine gio_gems (ms, is, blc, trc, addr, form, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_gems
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! GIO
  !     GEt Memory Slot
  !     Generalized version to also obtain non-contiguous subsets
  !---------------------------------------------------------------------
  integer, intent(out) :: ms                         ! Memory slot
  integer, intent(in)  :: is                         ! Image slot
  integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  integer, intent(in)  :: form                       ! Image format
  logical, intent(out) :: error                      ! Flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='GIO_GEMS'
  integer(kind=address_length) :: ipi, ipo, addr_tmp
  integer :: ms_tmp, ier, ndim
  integer(kind=index_length) :: jblc(gdf_maxdims), jtrc(gdf_maxdims), dimin(gdf_maxdims), dimou(gdf_maxdims), &
       & iblc(gdf_maxdims), itrc(gdf_maxdims)
  integer(kind=size_length) :: isize,ioffs, ileng, i, j
  logical :: icont
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Requesting a zero length memory slot')
  endif
  !
  ! Do not allow to open in Read/Write old UV data files
  if (islot(is).ne.code_gio_reado) then
    if (abs(ivers(is)).eq.code_gdf_uvold) then
      call gio_message(seve%e,rname,'Old UV data files cannot be written')
      error = .true.
      return
    endif
  endif
  !
  ! Try to allocate a memory frame big enough
  if (icont) then
    call gio_gemsco (ms, is, blc, trc, addr, form, error)
    dimou(:) = itrc(:)-iblc(:)+1
  else
    if (islot(is).ne.code_gio_reado) then
      call gio_message(seve%e,rname,'Subset option not supported for '//  &
      'Write access')
      error = .true.
      return
    endif
    !
    ! Define smallest contiguous containing subset
    jblc(:) = iblc(:)
    jtrc(:) = itrc(:)
    do i=ndim,1,-1
      if (iblc(i).ne.itrc(i)) then
        do j=1,i-1
          jblc(j) = 1
          jtrc(j) = idims(j,is)
        enddo
      endif
    enddo
    dimin(:) = jtrc(:)-jblc(:)+1
    dimou(:) = itrc(:)-iblc(:)+1
    !
    ! Get virtual memory for the subset
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
      ileng = 2*isize
    elseif (form.eq.fmt_by) then
      ileng = (isize+3)/4
    else
      ileng = isize
    endif
    ileng = -ileng
    call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
    if (error) return
    mslot(ms) = is
    ier = sic_getvm (isize,addr)
    if (ier.ne.1) goto 99
    maddr(1,ms) = addr
    maddr(2,ms) = addr+4*(isize-1)
    mleng(ms) = ileng
    !
    ! Get the continuous subset
    call gio_gemsco (ms_tmp, is, jblc, jtrc, addr_tmp, form, error)
    !
    ! Extract the subset
    ipo = gag_pointer(addr,memory)
    ipi = gag_pointer(addr_tmp,memory)
    !
    ! Good code...
    do i=1,ndim
      if (dimin(i).eq.dimou(i)) iblc(i) = 1
    enddo
    !
    if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
      call gdf_sub8(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    elseif (form.eq.fmt_by) then
      call gdf_sub1(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    else
      call gdf_sub4(iblc,dimin(1),dimin(2),dimin(3),dimin(4),memory(ipi),  &
                         dimou(1),dimou(2),dimou(3),dimou(4),memory(ipo))
    endif
    !
    ! Free the temporary subset.
    ! Note that ISLOT(IS) = READO in this case
    call gio_frms (ms_tmp, error)
  endif
  ! Define memory slot format
  mform(ms) = form
  !
  ! Patch old UV data files
  if (abs(ivers(is)).eq.code_gdf_uvold) then
    call gio_message(seve%i,rname,'Patching old UV data weights')
    !
    ! If the array has been re-shaped for transposition, re-re-shape it
    if (dimou(1).eq.1 .and. dimou(3).ne.1) then
      dimou(1) = dimou(2)
      dimou(2) = dimou(3)
      dimou(3) = dimou(4)
      dimou(4) = 1
    endif
    ipo = gag_pointer(addr,memory)
    call patch_weight(ivers(is),memory(ipo),dimou(1),dimou(2),dimou(3),dimou(4))
  endif
  return
  !
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_gems
!
subroutine gio_gemsco (ms, is, blc, trc, addr, form, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_gemsco
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF
  !     GEt Memory Slot COntiguous
  !     Restricted version for contiguous subsets
  !---------------------------------------------------------------------
  integer, intent(out) :: ms                         ! Memory slot
  integer, intent(in)  :: is                         ! Image slot
  integer(kind=index_length), intent(in)  :: blc(gdf_maxdims)    ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(gdf_maxdims)    ! Top right corner
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  integer, intent(in)  :: form                       ! Image format
  logical, intent(out) :: error                      ! Flag
  ! Local
  character(len=*), parameter :: rname='GIO_GEMSCO'
  integer :: ier, ndim
  integer(kind=index_length) :: iblc(gdf_maxdims), itrc(gdf_maxdims)
  integer(kind=size_length) :: isize, ioffs, ileng, i
  logical :: icont
  !
  !!Print *,'FORM gio_gemsco ',form
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Image slot is empty')
    error = .true.
    return
  elseif (islot(is).eq.code_gio_full) then
    call gio_message(seve%e,rname,'Image is not mapped')
    error = .true.
    return
  endif
  error = .false.
  !
  call gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  if (isize.le.0) then
    call gio_message(seve%e,rname,'Requesting a zero length memory slot')
  endif
  !
  ! Try to allocate a memory frame big enough
  if (icont) then
    ioffs = 0
    do i=ndim,1,-1
      ioffs = ioffs*idims(i,is)+iblc(i)-1
    enddo
    ileng = isize
    !
    ! Disk file
    if (ichan(is).ne.0) then
      call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
      if (error) return
      mslot(ms) = is
      !
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
      endif
      !
      call gio_mmslot (ioffs,ileng,form,ms,addr,error)
      if (error)  return
      !
      ! Virtual memory
    else
      ileng = -ileng
      call gio_gmslot (ioffs,ileng,form,ms,isbig(is),istbl(is),error)
      if (error) return
      mslot(ms) = is
      !
      ! Allocate what is needed, no less, no more (to 4 byte rouding)
      if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
        ileng = 2*isize
      elseif (form.eq.fmt_by) then
        ileng = (isize+3)/4
      else
        ileng = isize
      endif
      ier = sic_getvm (ileng,addr)
      if (ier.ne.1) goto 99
      maddr(1,ms) = addr
      maddr(2,ms) = addr+4*(ileng-1)
      ! Negative value means "Virtual Memory"
      mleng(ms) = -ileng
    endif
    if (error) then
      mslot(ms) = code_gio_empty
      return
    else
      mblc(:,ms) = blc(:)
      mtrc(:,ms) = trc(:)
      msize(ms) = isize
      mcont(ms) = icont
    endif
  else
    call gio_message(seve%e,rname,'Subset option not yet supported')
    error = .true.
  endif
  ! Define memory slot format
  mform(ms) = form
  return
  !
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_gemsco
!
subroutine gdf_sub1 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (type mismatch)
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                    !
  integer(kind=index_length) :: n1                        !
  integer(kind=index_length) :: n2                        !
  integer(kind=index_length) :: n3                        !
  integer(kind=index_length) :: n4                        !
  integer(kind=1) :: in(n1,n2,n3,n4)   !
  integer(kind=index_length) :: m1                        !
  integer(kind=index_length) :: m2                        !
  integer(kind=index_length) :: m3                        !
  integer(kind=index_length) :: m4                        !
  integer(kind=1) :: out(m1,m2,m3,m4)  !
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub1
!
subroutine gdf_sub8 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (type mismatch)
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                 !
  integer(kind=index_length) :: n1                     !
  integer(kind=index_length) :: n2                     !
  integer(kind=index_length) :: n3                     !
  integer(kind=index_length) :: n4                     !
  real(8) :: in(n1,n2,n3,n4)        !
  integer(kind=index_length) :: m1                     !
  integer(kind=index_length) :: m2                     !
  integer(kind=index_length) :: m3                     !
  integer(kind=index_length) :: m4                     !
  real(8) :: out(m1,m2,m3,m4)       !
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub8
!
subroutine gdf_sub4 (blc, n1,n2,n3,n4,in, m1,m2,m3,m4,out)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=index_length) :: blc(4)                 !
  integer(kind=index_length) :: n1                     !
  integer(kind=index_length) :: n2                     !
  integer(kind=index_length) :: n3                     !
  integer(kind=index_length) :: n4                     !
  integer(4) :: in(n1,n2,n3,n4)     !
  integer(kind=index_length) :: m1                     !
  integer(kind=index_length) :: m2                     !
  integer(kind=index_length) :: m3                     !
  integer(kind=index_length) :: m4                     !
  integer(4) :: out(m1,m2,m3,m4)    !
  ! Local 
  integer(kind=index_length) :: i1,i2,i3,i4
  integer(kind=index_length) :: j1,j2,j3,j4
  !
  i4 = blc(4)
  do j4=1,m4
    i3 = blc(3)
    do j3=1,m3
      i2 = blc(2)
      do j2=1,m2
        i1 = blc(1)
        do j1=1,m1
          out(j1,j2,j3,j4) = in(i1,i2,i3,i4)
          i1 = i1+1
        enddo
        i2 = i2+1
      enddo
      i3  = i3+1
    enddo
    i4 = i4+1
  enddo
end subroutine gdf_sub4
!
subroutine gio_cont (is,ndim,blc,trc,iblc,itrc,isize,icont)
  use gio_interfaces, except_this=>gio_cont
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO
  !     Determine if a slot is contiguous in memory
  !---------------------------------------------------------------------
  integer, intent(in)  :: is                         ! Image slot
  integer, intent(out) :: ndim                       ! Number of dimensions
  integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
  integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
  integer(kind=index_length), intent(out) :: iblc(:) ! Bottom left corner
  integer(kind=index_length), intent(out) :: itrc(:) ! Top right corner
  integer(kind=size_length), intent(out) :: isize    ! Size of memory region
  logical, intent(out) :: icont                      ! Contiguous flag
  ! Local
  integer(kind=index_length) :: i, j
  !
  isize = 1
  icont = .true.
  ndim = indim(is)
  do i=1,ndim
    if (blc(i).le.0) then
      iblc(i) = 1
    else
      iblc(i) = min(blc(i),idims(i,is))
    endif
    if (trc(i).le.0) then
      itrc(i) = idims(i,is)
    else
      itrc(i) = min(trc(i),idims(i,is))
      itrc(i) = max(iblc(i),itrc(i))
    endif
    isize = isize*(itrc(i)-iblc(i)+1)
  enddo
  do i=1,ndim-1
    if (iblc(i).ne.1 .or. itrc(i).ne.idims(i,is)) then
      do j=i+1,ndim
        if (iblc(j).ne.itrc(j)) then
          icont = .false.      ! Not contiguous
        endif
      enddo
    endif
  enddo
  do i=ndim+1,gdf_maxdims
    iblc(i) = 1
    itrc(i) = 1
  enddo
end subroutine gio_cont
!
subroutine gio_gmslot (offs, size, form, ms, big, stablo, error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=> gio_gmslot
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private 
  ! GDF   Get a free memory slot.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: offs          ! Offset from start of image, in "pixel"
  integer(kind=size_length), intent(inout)  :: size       ! Required size (in pixels), and allocated size (in WOrds)
  integer, intent(in)  :: form          ! Type of image
  integer, intent(out) :: ms            ! Memory slot number
  integer, intent(in)  :: big           ! Are big blocks being used ?
  integer, intent(in)  :: stablo        ! Number of Starting Blocks
  logical, intent(out) :: error         ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GIO_GMSLOT'
  integer :: i, freems, sizbuf
  integer(kind=record_length) :: ikbfi,ikbla
  integer(kind=size_length) :: ioffs, isize
  !
  !!Print *,'FORM gdf_gmslot ',form
  !
  if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
    isize = 8*size
    ioffs = 8*offs
  elseif (form.eq.fmt_by) then
    isize = size
    ioffs = offs
  else
    isize = 4*size
    ioffs = 4*offs
  endif
  !
  ! Compute length, taking into account header, offset and block size
  if (size.gt.0) then
    size = isize/4 ! In words...
    call gio_buffs_vm(big,ioffs,size,ikbfi,ikbla,sizbuf,stablo)
  endif
  !
  ! OK, now get a free frame-ID and virtual memory
  freems = 0
  ms = 0
  do i=1,mms
    if (mslot(i).eq.code_gio_empty) then
      ! Enough space in a previously freed frame
      if (size.gt.0) then
        if (mleng(i).ge.size) then
          if (ms.ne.0) then
            if (mleng(ms).gt.mleng(i)) ms = i
          else
            ms = i
          endif
        else
          if (freems.eq.0) freems = i
        endif
      else
        if (freems.eq.0) freems = i
      endif
    endif
  enddo
  if (ms.ne.0) return
  !
  ! No free frame large enough, or virtual memory
  if (freems.eq.0) then
    call gio_message(seve%e,rname,'Too many memory frames')
    error = .true.
  else
    ms = freems
    maddr(1,ms) = 0
    maddr(2,ms) = 0
    mleng(ms) = 0
  endif
end subroutine gio_gmslot
!
subroutine gio_mmslot (offs,leng,form,ms,addr,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_mmslot
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO
  !             Map Memory SLOT
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: offs     ! Offset from start of image, in "pixel"
  integer(kind=size_length), intent(in)  :: leng     ! Required size (in Words)
  integer, intent(in)  :: form                       ! Type of image
  integer, intent(in)  :: ms                         ! Memory slot number
  integer(kind=address_length), intent(out) :: addr  ! Returned address
  logical, intent(out) :: error                      ! Logical error flag
  ! Global
  integer(kind=4) :: gdf_conv
  include 'gbl_memory.inc'
  character(len=*), parameter :: rname='GIO_MMSLOT'
  ! Local
  integer(kind=address_length) :: ip
  integer(kind=record_length) :: i,ikbfi,ikbla,lastbl
  integer(kind=size_length) :: ioffs,size
  integer :: ier, is
  integer(kind=4) :: buffer(lenbig), sizbuf
  character(len=message_length) :: mess
  !
  error = .true.
  if (form.eq.fmt_r8.or.form.eq.fmt_c4) then
    ioffs = 8*offs
  elseif (form.eq.fmt_by) then
    ioffs = offs
  else
    ioffs = 4*offs
  endif
  !
  is = mslot(ms)
  size = leng
  call gio_buffs_vm(isbig(is),ioffs,size,ikbfi,ikbla,sizbuf,istbl(is))
  !
  ! Get some virtual memory
  ier = sic_getvm (size,addr)
  if (ier.ne.1) goto 99
  !
  open(unit=iunit(is),file=cname(is),status='OLD',form='UNFORMATTED',  &
       access='DIRECT',recl=sizbuf*facunf,iostat=ier)
  !
  ! Do not read beyond written parts
  lastbl = imblock(is)/isbig(is) 
  ikbfi = max(1,min(ikbfi,lastbl)) 
  ikbla = min(ikbla,lastbl) 
  !
  maddr(1,ms) = addr
  maddr(2,ms) = addr+4*size
  mleng(ms) = size
  moffs(ms) = ioffs
  !
  ! The new offset from the first read block is
  !       MOFFS(MS) = (IKBFI-1)*4*SIZBUF
  !
  ! Read file
  ip = gag_pointer(addr,memory)
  if (iform(is).eq.form) then
    !
    ! Here, we could do a true memory mapping instead of reading
    do i=ikbfi,ikbla
      ier = gio_riox (iunit(mslot(ms)),i,memory(ip),sizbuf)
      if (ier.ne.0) then
        write(mess,*) 'READ error #1 on slot ', mslot(ms),' Block ',i
        call gio_message(seve%e,rname,mess)
        call putios(seve%e,rname,ier)
        write(mess,*) ' Range ',ikbfi,ikbla,'  End ',imblock(is),' Sizbuf ',sizbuf
        call gio_message(seve%e,rname,mess)
        return
      endif
      ip = ip+sizbuf
    enddo
  else
    !
    ! Here we must convert the data, so a read is required...
    do i=ikbfi,ikbla
      ier = gio_riox (iunit(mslot(ms)),i,buffer,sizbuf)
      if (ier.ne.0) then
        write(mess,*) 'READ error #2 on slot ', mslot(ms),' Block ',i
        call gio_message(seve%e,rname,mess)
        call putios(seve%e,rname,ier)
        write(mess,*) ' Range ',ikbfi,ikbla,'  End ',imblock(is),' Sizbuf ',sizbuf
        call gio_message(seve%e,rname,mess)
        return
      endif
      if (i.eq.1) then ! First big buffer may contain header ....
        call r4tor4 (buffer,memory(ip),istbl(is)*lenbuf)
        ier = gdf_conv(buffer(1+istbl(is)*lenbuf),memory(ip+istbl(is)*lenbuf), &
        &    sizbuf-istbl(is)*lenbuf,form,iform(is))
      else
        ier = gdf_conv (buffer,memory(ip),sizbuf,form,iform(is))
      endif
      if (ier.ne.1) goto 98
      ip = ip+sizbuf
    enddo
  endif
  close (unit=iunit(is))
  !
  ! Compute address
  ioffs = mod(ioffs,4*sizbuf)
  addr = addr+ioffs
  error = .false.
  return
  !
98 continue 
  write(mess,*) 'Unsupported conversion from ',iform(is),' to ',form
  call gio_message(seve%e,rname,mess)
  call free_vm (size,addr)
  close (unit=iunit(is))
  return
99 call gio_message(seve%e,rname,'Memory allocation failure')
  mslot(ms) = code_gio_empty
  error = .true.
end subroutine gio_mmslot
!
subroutine gio_frms (ms,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_frms
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF   FRee Memory Slot
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: ms     ! Memory slot
  logical, intent(inout) :: error  ! error flag
  ! Local
  character(len=*), parameter :: rname='GIO_FRMS'
  integer :: is
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  !
  ! Contiguous slot
  if (mcont(ms)) then
    !
    ! If virtual memory, free it
    if (mleng(ms).lt.0) then
      !!            Print *,'FREE_VM Virtual memory slot'
      call free_vm(-mleng(ms),maddr(1,ms))
    else
      !!            Print *,'Disk memory slot'
      !
      ! Write disk file
      call gio_wmslot (ms,iunit(is),error)
    endif
    !
  else
    ! Not contiguous Read-Only: just free memory if needed
    if (islot(is).lt.code_gio_write) then
      !!            Print *,'FREE_VM Read-Only  memory slot ',
      !!     $           islot(is),write
      call free_vm (mleng(ms),maddr(1,ms))
    else if (islot(is).ne.code_gio_reade) then
      ! Not contiguous, DUMPI or DUMPE : update line by line
      call gio_message(seve%e,rname,'Inconsistent state of GDF library')
      call gio_message(seve%e,rname,'Non-contiguous WRITE slot')
      error = .true.
    endif
  endif
  !
  ! In all cases, set the memory slot to empty state...
  maddr(1,ms) = 0
  maddr(2,ms) = 0
  mleng(ms) = 0
  mslot(ms) = code_gio_empty
end subroutine gio_frms
!
subroutine gio_wmslot (ms,lun,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gio_wmslot
  use gildas_def
  use gio_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Write Memory SLOT.
  ! Direct access solution, contiguous data only.
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: ms     ! Memory slot number
  integer, intent(in)    :: lun    ! Logical Unit Number
  logical, intent(inout) :: error  ! Logical error flag
  ! Global
  integer(kind=4) :: gdf_conv
  include 'gbl_memory.inc'
  character(len=*), parameter :: rname='GIO_WMSLOT'
  ! Local
  integer(kind=4) :: ier, is, buffer(lenbig), sizbuf, lasbuf, form
  integer(kind=record_length) :: i,ikbfi,ikbla
  integer(kind=size_length) :: ioffs, ileft 
  integer(kind=4) :: koffs
  integer(kind=address_length) :: ip
  !
  is = mslot(ms)
  !
  ! Do nothing for READE (External Memory, Read-Only
  if (islot(is).eq.code_gio_reade) return
  !
  ! Only Free Virtual Memory for Read-Only and Full slots
  if (islot(is).lt.code_gio_write) then
    call free_vm (mleng(ms),maddr(1,ms))
    return
  endif
  !
  form = mform(ms)
  !
  ! This should be redone in a different way, like in GDF_RMSLO, by
  !  - keeping MOFFS(MS) as the offset in Byte from the data start
  !  - Reading the header blocks
  !  - Copying the end part of the first block to the beginning of the data      (READ)
  !    or
  !    copying the beginning of the data to the end part of the first block,
  !    and writing the first block     (WRITE)
  !  - Reading the intermediate areas (READ) or Writing them (WRITE)
  !  - Reading the last block
  !  - Copying the beginning of the last block to the end of the data      (READ)
  !      or
  !    copying the end of the data to the first part of the last block,
  !    and writing the last block                                         (WRITE)
  !
  ! Let us do it only for DUMPE to debug...
  if (islot(is).eq.code_gio_dumpe) then
    !
    ! DUMPE State, i.e. a slot which is associated to a user-handled
    ! memory area. There is safeguard around...
    !
    ioffs = moffs(ms)/4+istbl(is)*lenbuf ! Offset in Word in file
    sizbuf = isbig(is) * lenbuf
    koffs = mod(ioffs,sizbuf)  ! Offset in Word from first buffer!
    ikbfi = ioffs/sizbuf + 1
    ikbla = (ioffs+mleng(ms)+sizbuf-1)/sizbuf  ! Last buffer address
    !
    open(unit=lun,file=cname(is),status='OLD',form='UNFORMATTED',  &
         access='DIRECT',recl=sizbuf*facunf,iostat=ier)
    if (ier.ne.0) then
      Print *,'Opened in DUMPE ',ier,sizbuf,lenbuf,isbig(is)
      Print *,'DUMPE -- WMSLOT Iform ',iform(is), ' MFORM ',mform(ms)
      goto 90
    endif
    ip = gag_pointer(maddr(1,ms),memory)
    !
    ! Write file
    ! Native format
    if (iform(is).eq.mform(ms)) then
      ileft = mleng(ms)
      do i=ikbfi,ikbla-1
        if (i.eq.ikbfi) then
        ! Could be simplified by if (i.eq.ikbfi .and. koffs.gt.0) then
          if (koffs.gt.0) then 
            ier = gio_riox (lun,i,buffer,sizbuf)
            if (ier.ne.0) then
              Print *,'DUMPE -- NATIVE Buffer ',i,ikbfi,ikbla,' Read IER ',ier
              goto 90
            endif
          endif
          call r4tor4 (memory(ip),buffer(1+koffs),sizbuf-koffs)
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) then
            Print *,'DUMPE -- NATIVE Buffer ',i,ikbfi,ikbla,' Write IER ',ier,sizbuf
            goto 90
          endif
          ip = ip+sizbuf-koffs
          ileft = ileft-sizbuf+koffs
        else
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) then 
            Print *,'DUMPE -- Direct write ',i,ikbfi,ikbla,' Write IER ',ier
            goto 90
          endif
          ip = ip+sizbuf
          ileft = ileft-sizbuf
        endif
        iwblock(is) = i*isbig(is)
        imblock(is) = max(iwblock(is),imblock(is))
      enddo
      !
      ! Last buffer may be incomplete
      if (ikbla.le.imblock(is)/isbig(is)) then
        ier = gio_riox(lun,ikbla,buffer,sizbuf)
        if (ier.ne.0) then
          Print *,'DUMPE - NATIVE Buffer ',i,ikbfi,ikbla,' Read IER ',ier,sizbuf
          Print *,'IMBLOCk ',imblock(is),' StartBlock ',istbl(is)
          goto 90
        endif
      endif
      if (ikbla.eq.ikbfi) then
        call r4tor4(memory(ip),buffer(koffs+1),ileft)
      else
        call r4tor4(memory(ip),buffer,ileft)
      endif
      ier = gio_wiox(lun,ikbla,buffer,sizbuf)
      if (ier.ne.0) then
        Print *,'DUMPE -- Last Buffer IKBLA ',ikbla,' Write IER ',ier
        goto 90
      endif
      iwblock(is) = i*isbig(is)
      imblock(is) = max(iwblock(is),imblock(is))
    else
      ! As above, but with format Conversion
      !!Print *,'CONVERT ',iform(is), form
      ileft = mleng(ms)
      do i=ikbfi,ikbla-1
        if (i.eq.ikbfi) then
          ier = gio_riox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ier = gdf_conv(memory(ip),buffer(1+koffs),sizbuf-koffs,form,iform(is))
          if (ier.ne.1) goto 80
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf-koffs
          ileft = ileft-sizbuf+koffs
        else
          ier = gdf_conv(memory(ip),buffer,sizbuf,form,iform(is))
          if (ier.ne.1) goto 80
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
          ileft = ileft-sizbuf
        endif
      enddo
      ier = gio_riox(lun,ikbla,buffer,sizbuf)
      if (ikbla.eq.ikbfi) then
        ier = gdf_conv(memory(ip),buffer(koffs+1),ileft,form,iform(is))
      else
        ier = gdf_conv(memory(ip),buffer,ileft,form,iform(is))
      endif
      ier = gio_wiox(lun,ikbla,buffer,sizbuf)
      if (ier.ne.0) goto 90
    endif
  else !! if (islot(is).eq.code_gio_dumpi) then
    !
    ! WRITE, DUMPI state: Write the file
    !
    ! Here, the MOFFS(MS) pointer and MLENG(MS) size take into account the
    ! rounding to an integer number of blocks.
    !
    ! So we use a different system to read and write.
    !
    sizbuf = isbig(is) * lenbuf
    if (isbig(is).ne.1) then
      ikbfi = moffs(ms)/4/sizbuf + 1
      !!          Print *,'Big ',4*LENBIG*(IKBFI-1)+512, moffs(ms)
      ikbla = ikbfi + (mleng(ms)-1)/sizbuf ! Last buffer address
    else
      ikbfi = moffs(ms)/4/sizbuf + 1 + istbl(is)   ! First buffer address
      !!          Print *,'Small ',4*LENBUF*(IKBFI-1), moffs(ms)
      ikbla = ikbfi + (mleng(ms)-1)/sizbuf ! Last buffer address
    endif
    !
    open(unit=iunit(is),file=cname(is),status='OLD',form='UNFORMATTED',  &
         access='DIRECT',recl=sizbuf*facunf,iostat=ier)
    if (ier.ne.0) then
      Print *,'Opened in DUMPI ',islot(is),code_gio_dumpi
      goto 90
    endif
    !
    ip = gag_pointer(maddr(1,ms),memory)
    !
    ! Write file (Version OK for WRITE and DUMPI)
    ! Code should now be correct even for DUMPE
    !
    ! Well, now the test differs whether it is a "big" or "small" block...
    !!Print *,'DUMPI -- WMSLOT Iform ',iform(is), ' MFORM ',mform(ms)
    !!Print *,'DUMPI -- MLENG ',mleng(ms), ' IKB ',ikbfi,ikbla
    if (iform(is).eq.mform(ms)) then
      !!Print *,'NATIVE '
      if (isbig(is).ne.1) then
        do i=ikbfi,ikbla-1
          ! Here we read the Header Buffers...
          if (i.eq.1) then
            ier = gio_riox (lun,i,buffer,lenbuf*istbl(is))  ! Just read the header blocks
            if (ier.ne.0) goto 90
            call r4tor4 (buffer,memory(ip),lenbuf*istbl(is))
          endif
          ! and write the "big" buffer
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        if (ikbla.eq.1) then
          ier = gio_riox (lun,ikbla,buffer,lenbuf*istbl(is))
          if (ier.ne.0) goto 90
          call r4tor4 (buffer,memory(ip),lenbuf*istbl(is))
        endif
        ier = gio_wiox (lun,ikbla,memory(ip),lasbuf)
!!        Print *,'Last buffer ',ier,lasbuf
!!        call r4tor4(memory(ip),buffer,lasbuf)
!!        Print *,'Last buffer ',buffer(1:lasbuf)
        if (ier.ne.0) goto 90
      else
        !
        ! Header blocks cannot be present here
        do i=ikbfi,ikbla-1
          if (ikbfi.le.istbl(is)) then
            print *,'Major programming error IKBFI ',ikbfi,  &
            & ' < istbl(is) ',istbl(is)
            STOP
          endif
          ! Write the "small" buffer
          ier = gio_wiox (lun,i,memory(ip),sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        ier = gio_wiox (lun,ikbla,memory(ip),lasbuf)
        if (ier.ne.0) goto 90
      endif
      !
    else
      ! With conversion
      Print *,'CONVERT ',iform(is), mform(ms), isbig(is)
      if (isbig(is).ne.1) then
        do i=ikbfi,ikbla-1
          ! Here we read the Header Buffer...
          if (i.eq.1) then
            ier = gio_riox (lun,i,buffer,lenbuf*istbl(is))
            if (ier.ne.0) goto 90
            ier = gdf_conv(memory(ip+lenbuf*istbl(is)), &
          &     buffer(1+lenbuf*istbl(is)),sizbuf-lenbuf*istbl(is),  &
                iform(is),mform(ms))
          else
            ier = gdf_conv(memory(ip),buffer,sizbuf,iform(is),mform(ms))
          endif
          if (ier.ne.1) goto 80
          ! and write the "big" buffer
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special: length may be shorter
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        if (ikbla.eq.1) then
          ier = gio_riox (lun,ikbla,buffer,lenbuf*istbl(is))
          if (ier.ne.0) goto 90
          ier = gdf_conv(memory(ip+lenbuf*istbl(is)), &
          &     buffer(1+lenbuf*istbl(is)),lasbuf-lenbuf*istbl(is),  &
                iform(is),mform(ms))
        else
          ier = gdf_conv(memory(ip),buffer,lasbuf,iform(is),mform(ms))
        endif
        if (ier.ne.1) goto 80
        ier = gio_wiox (lun,ikbla,buffer,lasbuf)
        if (ier.ne.0) goto 90
      else
        !
        ! Header blocks cannot be present here
        do i=ikbfi,ikbla-1
          if (ikbfi.le.istbl(is)) then
            print *,'Major programming error IKBFI ',ikbfi,  &
            & ' < istbl(is) ',istbl(is)
            STOP
          endif
          ier = gdf_conv(memory(ip),buffer,sizbuf,iform(is),mform(ms))
          if (ier.ne.1) goto 80
          ! Write the "small" buffer
          ier = gio_wiox (lun,i,buffer,sizbuf)
          if (ier.ne.0) goto 90
          ip = ip+sizbuf
        enddo
        !
        ! Last buffer is special: length may be shorter
        lasbuf = mod(mleng(ms),sizbuf)
        if (lasbuf.eq.0) lasbuf = sizbuf
        ier = gdf_conv(memory(ip),buffer,lasbuf,iform(is),mform(ms))
        if (ier.ne.1) goto 80
        ier = gio_wiox (lun,ikbla,buffer,lasbuf)
        if (ier.ne.0) goto 90
      endif
    endif
  endif                        !
  goto 100
  !
  ! Free virtual memory
80 call gio_message(seve%e,rname,'Output conversion error in data')
  Print *,iform(is),mform(ms),ier
  error = .true.
  goto 100
  !
90 call gio_message(seve%e,rname,'Write error in data')
  call putios(seve%e,rname,ier)
  Print *,'Blocks ',irblock(is),iwblock(is),imblock(is)
  Print *,'OFFSETS ',koffs,ileft
  error = .true.
  goto 100
  !
100 continue
  close (unit=iunit(is))
  !
  ! Free Virtual memory if allocated by the Image Library
  !
  !!      Print *,'Slot Status ',islot(is),write,dumpi
  if (islot(is).eq.code_gio_write) then
    !!         Print *,'FREE_VM Freeing memory '
    call free_vm (mleng(ms),maddr(1,ms))
  endif
end subroutine gio_wmslot
!
subroutine gio_buffs_vm(big,ioffs,size,ikbfi,ikbla,sizbuf,stablo)
  use gio_interfaces, except_this=>gio_buffs_vm
  use gildas_def
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: big ! Blocking factor
  integer(kind=size_length),   intent(inout) :: ioffs   ! Memory offset
  integer(kind=size_length),   intent(inout) :: size    ! Effective size in words
  integer(kind=record_length), intent(out)   :: ikbfi   ! First block
  integer(kind=record_length), intent(out)   :: ikbla   ! Last block
  integer(kind=4),             intent(out)   :: sizbuf  ! Buffer Size in words (output)
  integer(kind=4),             intent(in)    :: stablo  ! Number of Starting Blocks
  !
  if (big.ne.1) then
    ! Note that first BIG block is read
    ioffs = ioffs+4*stablo*lenbuf ! Add header small buffers
    sizbuf = lenbuf*big
    ikbfi = ioffs/4/sizbuf + 1             ! First BIG block
    ikbla = (ioffs/4+size-1)/sizbuf + 1    ! Last BIG block
    size = sizbuf*(ikbla-ikbfi+1)          ! In words
  else
    ! Note that the Header Blocks are skipped
    ikbfi = ioffs/4/lenbuf + 1 + stablo              ! First buffer address
    ikbla = (ioffs/4+size-1)/lenbuf + 1 + stablo     ! Last buffer address
    size = (ikbla-ikbfi+1)*lenbuf
    sizbuf = lenbuf
  endif
end subroutine gio_buffs_vm
!
subroutine gio_umps (ms,error)
  use gio_interfaces, except_this=>gio_umps
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   UPdate Memory Slot
  !             Write it to file if needed
  !
  ! THIS ROUTINE IS NOW OBSOLETE (Apr 2014)
  ! and the code code_gdf_dumpi  also
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms                     ! Memory slot
  logical, intent(out) :: error                  ! Error flag
  !
  character(len=*), parameter :: rname='GIO_UPMS'
  ! Local
  integer :: is,jslot
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Contiguous slot
  if (mcont(ms)) then
    !
    ! If virtual memory, free it
    if (mleng(ms).lt.0) then
      call gio_message(seve%e,rname,'Virtual Memory slot cannot be '//  &
      'updated')
      error = .true.
      return
    else
      if (mapped(is)) then
        return
      else
        !
        ! Write disk file
        jslot = islot(is)
        islot(is) = code_gio_dumpi
        call gio_wmslot (ms,iunit(is),error)
        maddr(1,ms) = 0
        maddr(2,ms) = 0
        mleng(ms) = 0
        mslot(ms) = code_gio_empty
        ! Restore slot status
        islot(is) = jslot
      endif
    endif
    !
  else
    error = .true.
    ! Not contiguous Read-Only:
    if (islot(is).lt.code_gio_write) then
      call gio_message(seve%e,rname,'Read-0nly Memory slot cannot be '//  &
      'updated')
    else
      ! Not contiguous : update line by line
      call gio_message(seve%e,rname,'Inconsistent state of GDF library')
      call gio_message(seve%e,rname,'Non-contiguous WRITE slot')
    endif
  endif
end subroutine gio_umps
!
subroutine gio_zams (ms,error)
  use gio_interfaces, except_this=>gio_zams
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF   ZAp Memory Slot
  !                     Just delete it, don't do anything else
  !---------------------------------------------------------------------
  integer, intent(in)  :: ms                     ! Memory slot
  logical, intent(out) :: error                  ! Error flag
  character(len=*), parameter :: rname='GIO_ZAMS'
  ! Local
  integer :: is
  !
  is = mslot(ms)
  if (is.eq.code_gio_empty) then
    call gio_message(seve%e,rname,'Memory slot is empty')
    error = .true.
    return
  endif
  !
  maddr(1,ms) = 0
  maddr(2,ms) = 0
  mleng(ms) = 0
  mslot(ms) = code_gio_empty
end subroutine gio_zams
!
subroutine patch_weight(icode,uv,nx,ny,nz,nt)
  use gio_interfaces
  use gio_params
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Patch UV data weights for old data
  !---------------------------------------------------------------------
  integer, intent(in) :: icode      ! Data code > 0 means UVT order, < 0 means TUV order
  integer(kind=index_length), intent(in) :: nx                     !
  integer(kind=index_length), intent(in) :: ny                     !
  integer(kind=index_length), intent(in) :: nz                     !
  integer(kind=index_length), intent(in) :: nt                     !
  real, intent(inout) :: uv(nx,ny,nz,nt)        !
  ! Local
  integer(kind=index_length) :: i,j,k,l
  !
  !!      PRINT *,'icode ',ICODE
  !!      READ(5,*) ICODE
  if (icode.gt.0) then
    do l=1,nt
      do k=1,nz
        do j=1,ny
          do i=10,nx,3
            uv(i,j,k,l) = 2.0*uv(i,j,k,l)
          enddo
        enddo
      enddo
    enddo
  elseif  (icode.lt.0) then
    do l=1,nt
      do k=1,nz
        do j=10,ny,3
          do i=1,nx
            uv(i,j,k,l) = 2.0*uv(i,j,k,l)
          enddo
        enddo
      enddo
    enddo
  endif
end subroutine patch_weight

module mrtindex_list_colnames
  !
  integer(kind=4), parameter :: ncolumns=31
  character(len=11) :: columns(ncolumns) = (/  &
    'NUMBER     ','ENTRY      ','DIRECTORY  ','FITSFILE   ','MRTFILE    ',  &  !  1- 5
    'RECORD     ','WORD       ','VERSION    ','TELESCOPE  ','PROJID     ',  &  !  6-10
    'SOURCE     ','OBSERVED   ','UT         ','LST        ','AZIMUTH    ',  &  ! 11-15
    'ELEVATION  ','POSITION   ','FRONTEND   ','SCAN       ','BACKEND    ',  &  ! 16-20
    'OBSTYPE    ','SWITCHMODE ','POLARIMETRY','COMPLETE   ','CALIBRATED ',  &  ! 21-25
    'SOLVED     ','ITIME      ','ISLAST     ','WITH       ','RESULTS    ',  &  ! 26-30
    'DEFAULT    ' /)                                                           ! 31
  !
  integer(kind=4), parameter :: col_none        = 0  ! Nullifier
  integer(kind=4), parameter :: col_number      = 1
  integer(kind=4), parameter :: col_entry       = 2
  integer(kind=4), parameter :: col_directory   = 3
  integer(kind=4), parameter :: col_fitsfile    = 4
  integer(kind=4), parameter :: col_mrtfile     = 5
  integer(kind=4), parameter :: col_record      = 6
  integer(kind=4), parameter :: col_word        = 7
  integer(kind=4), parameter :: col_version     = 8
  integer(kind=4), parameter :: col_telescope   = 9
  integer(kind=4), parameter :: col_projid      = 10
  integer(kind=4), parameter :: col_source      = 11
  integer(kind=4), parameter :: col_observed    = 12
  integer(kind=4), parameter :: col_ut          = 13
  integer(kind=4), parameter :: col_lst         = 14
  integer(kind=4), parameter :: col_azimuth     = 15
  integer(kind=4), parameter :: col_elevation   = 16
  integer(kind=4), parameter :: col_position    = 17
  integer(kind=4), parameter :: col_frontend    = 18
  integer(kind=4), parameter :: col_scan        = 19
  integer(kind=4), parameter :: col_backend     = 20
  integer(kind=4), parameter :: col_obstype     = 21
  integer(kind=4), parameter :: col_switchmode  = 22
  integer(kind=4), parameter :: col_polarimetry = 23
  integer(kind=4), parameter :: col_complete    = 24
  integer(kind=4), parameter :: col_calibrated  = 25
  integer(kind=4), parameter :: col_solved      = 26
  integer(kind=4), parameter :: col_itime       = 27
  integer(kind=4), parameter :: col_islast      = 28
  integer(kind=4), parameter :: col_with        = 29
  integer(kind=4), parameter :: col_results     = 30
  ! Aliases
  integer(kind=4), parameter :: col_default     = 31
  !
  ! Aliases translation
  integer(kind=4), parameter :: col_default_list(12) =  &
    [col_number,col_version,col_projid,col_source,col_observed,  &
     col_ut,col_scan,col_backend,col_obstype,col_switchmode,  &
     col_calibrated,col_solved]
  !
end module mrtindex_list_colnames
!
module mrtindex_toc_parameters
  !---------------------------------------------------------------------
  ! Support module for Table-Of-Contents
  !---------------------------------------------------------------------
  !
  ! Key codes
  integer(kind=4), parameter :: mrtindex_toc_key_number    = 1
  integer(kind=4), parameter :: mrtindex_toc_key_version   = 2
  integer(kind=4), parameter :: mrtindex_toc_key_telescope = 3
  integer(kind=4), parameter :: mrtindex_toc_key_projid    = 4
  integer(kind=4), parameter :: mrtindex_toc_key_source    = 5
  integer(kind=4), parameter :: mrtindex_toc_key_observed  = 6
  integer(kind=4), parameter :: mrtindex_toc_key_frontend  = 7
  integer(kind=4), parameter :: mrtindex_toc_key_scan      = 8
  integer(kind=4), parameter :: mrtindex_toc_key_backend   = 9
  integer(kind=4), parameter :: mrtindex_toc_key_obstype   = 10
  integer(kind=4), parameter :: mrtindex_toc_key_switch    = 11
  integer(kind=4), parameter :: mrtindex_toc_key_polar     = 12
  integer(kind=4), parameter :: mrtindex_toc_key_calstatus = 13
  integer(kind=4), parameter :: mrtindex_toc_key_directory = 14
  !
  ! Mrtcal types, i.e. for fields which needs special decoding (e.g. gag_date:
  ! we won't display the I*4 value, but its translation as a string)
  integer(kind=4), parameter :: mrtindex_ptype_null=0
  integer(kind=4), parameter :: mrtindex_ptype_teles=1
  integer(kind=4), parameter :: mrtindex_ptype_gagdate=2
  integer(kind=4), parameter :: mrtindex_ptype_backend=3
  integer(kind=4), parameter :: mrtindex_ptype_obstype=4
  integer(kind=4), parameter :: mrtindex_ptype_switchmode=5
  integer(kind=4), parameter :: mrtindex_ptype_polarimetry=6
  integer(kind=4), parameter :: mrtindex_ptype_calstatus=7
  integer(kind=4), parameter :: mrtindex_ptype_directory=8
  integer(kind=4), parameter :: mrtindex_ptype_frontend=9
end module mrtindex_toc_parameters
!
module mrtindex_sort_var
  use toc_types
  !---------------------------------------------------------------------
  ! Support module for Table-Of-Contents
  !---------------------------------------------------------------------
  !
  type(toc_t), target :: mtoc
  !
end module mrtindex_sort_var
!
subroutine mrtindex_list_columns(line,custom,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_columns
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command:
  !   MLIST /COLUMNS Key1 ... KeyN
  ! Get the custom list of columns identifiers
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       !
  integer(kind=4),  intent(out)   :: custom(:)  !
  logical,          intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  integer(kind=4) :: iarg,nc
  integer(kind=4) :: ukeys(size(custom))
  character(len=12) :: argum,key
  !
  custom(:) = col_none
  ukeys(:) = col_none
  !
  do iarg=1,sic_narg(3)
    if (iarg.gt.size(ukeys)) then
      call mrtindex_message(seve%w,rname,'/COLUMNS list too long, truncated')
      return
    endif
    !
    call sic_ke(line,3,iarg,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,key,ukeys(iarg),columns,ncolumns,error)
    if (error)  return
  enddo
  !
  call mrtindex_list_columns_set(ukeys,size(ukeys),custom,size(custom),error)
  if (error)  return
  !
end subroutine mrtindex_list_columns
!
subroutine mrtindex_list_columns_set(ukeys,nukeys,ckeys,nckeys,error)
  use gbl_message
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ private
  ! Translate user keys to column keys.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nukeys     !
  integer(kind=4), intent(in)    :: nckeys     !
  integer(kind=4), intent(in)    :: ukeys(nukeys)  !
  integer(kind=4), intent(out)   :: ckeys(nckeys)  !
  logical,         intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  integer(kind=4) :: ikey,iout,nnew
  integer(kind=4) :: new(size(col_default_list))
  !
  ckeys(:) = col_none
  iout = 0
  !
  do ikey=1,nukeys
    if (ukeys(ikey).eq.col_none)  exit
    !
    select case (ukeys(ikey))
    case (col_default)
      nnew = size(col_default_list)
      new(1:nnew) = col_default_list
    case default
      nnew = 1
      new(1) = ukeys(ikey)
    end select
    !
    if (iout+nnew.gt.nckeys) then
      call mrtindex_message(seve%w,rname,'/COLUMNS list too long, truncated')
      return
    endif
    ckeys(iout+1:iout+nnew) = new(1:nnew)
    iout = iout+nnew
  enddo
  !
end subroutine mrtindex_list_columns_set
!
subroutine mrtindex_list(optx,name,custom,olun,page,error)
  use gbl_message
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_interfaces, except_this=>mrtindex_list
  use mrtindex_types
  use mrtindex_list_colnames
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx       !
  character(len=*),          intent(in)    :: name       !
  integer(kind=4),           intent(in)    :: custom(:)  ! Columns to be listed
  integer(kind=4),           intent(in)    :: olun       ! Output logical unit
  logical,                   intent(in)    :: page       ! Page or Scroll mode?
  logical,                   intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='MLIST'
  logical, parameter :: rawdebug=.false.
  integer(kind=entry_length) :: ient,jent
  integer(kind=4) :: tt_lines
  logical :: defaul
  character(len=message_length) :: mess
  !
  if (optx%next.le.1) then
    call mrtindex_message(seve%w,rname,'No entry in '//trim(name)//' index')
    return
  endif
  !
  defaul = custom(1).eq.col_none
  tt_lines = sic_ttynlin()-2
  !
  ! Print header
  ient = 0  ! <=> Header
  if (rawdebug) then
    call mrtindex_list_one_raw(optx,ient,mess,error)
  elseif (defaul) then
    call mrtindex_list_one_default(optx,ient,mess,error)
  else
    call mrtindex_list_one_custom(optx,ient,custom,mess,error)
  endif
  call mrtindex_list_one_print(mess,olun)
  !
  do ient=1,optx%next-1
    jent = optx%sort(ient)
    !
    if (olun.eq.6 .and. page) then
      if (mod(ient,tt_lines).eq.0) then
        if (hlp_more().ne.0)  return
      endif
    endif
    !
    if (rawdebug) then
      call mrtindex_list_one_raw(optx,jent,mess,error)
    elseif (defaul) then
      call mrtindex_list_one_default(optx,jent,mess,error)
    else
      call mrtindex_list_one_custom(optx,jent,custom,mess,error)
    endif
    if (error)  return
    call mrtindex_list_one_print(mess,olun)
    !
  enddo
  !
end subroutine mrtindex_list
!
subroutine mrtindex_list_one_raw(optx,ient,mess,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_one_raw
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MLIST [IN|OUT] [/FILE OutputFile]
  ! Print 1 line for 1 entry (debugging output => raw values)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  character(len=*),           intent(out)   :: mess   !
  logical,                    intent(inout) :: error  !
  !
  if (ient.eq.0) then
    ! Print header and quit
    write(mess,100)
  else
    write(mess,101)            &
      optx%mnum(ient),         &
      optx%num(ient),          &
      optx%version(ient),      &
      optx%filename(ient),     &
      optx%fnum(ient),         &
      optx%bloc(ient),         &
      optx%word(ient),         &
      optx%telescope(ient),    &
      optx%projid(ient),       &
      optx%source(ient),       &
      optx%dobs(ient)
      !
    write(mess,102)            &
      trim(mess),              &
      optx%ut(ient),           &
      optx%lst(ient),          &
      optx%az(ient),           &
      optx%el(ient),           &
      optx%lon(ient),          &
      optx%lat(ient),          &
      optx%system(ient),       &
      optx%equinox(ient)
      !
    write(mess,103)            &
      trim(mess),              &
      optx%frontend(1,ient),   &
      optx%frontend(2,ient),   &
      optx%frontend(3,ient),   &
      optx%frontend(4,ient)
      !
    write(mess,104)            &
      trim(mess),              &
      optx%scan(ient),         &
      optx%backend(ient),      &
      optx%obstype(ient),      &
      optx%switchmode(ient),   &
      optx%polstatus(ient),    &
      optx%filstatus(ient),    &
      optx%calstatus(ient),    &
      optx%solstatus(ient),    &
      optx%itime(ient),        &
      optx%idir(ient),         &
      optx%islast(ient)
  endif
  !
100 format(                                                                                &
  '# N.V File                                    Ent Blo Wor Tel Pro Source      Date  ',  &
  'UT         LST       Az        El             Frontend                         ',       &
  'Sca Bac Typ Swi Pol Com Cal Sol Time              Dir Last')
  !
  !         #    Num   Ver   File   Ent   Blo   Wor   Tel   Pro    Sour  Dobs
101 format(I0,1X,I0,1X,I0,1X,A40,1X,I0,1X,I0,1X,I0,1X,I0,1X,A8,1X,A12,1X,I5)
  !        Mess UT      LST     Az      El      Lon-Lat    Syst  Equinox
102 format(A,1X,F0.8,1X,F0.8,1X,F0.8,1X,F0.8,1X,2(F0.5,1X),I0,1X,F0.2)
  !        Mess Frontend
103 format(A,1X,4(A8,1X))
  !        Mess Sca   Bac   Typ   Swi   Pol   Com   Cal   Sol   Tim   Dir   Last
104 format(A,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,I0,1X,L1)
end subroutine mrtindex_list_one_raw
!
subroutine mrtindex_list_one_default(optx,ient,mess,error)
  use phys_const
  use classic_api
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_one_default
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command
  !   MLIST [IN|OUT]
  ! Print 1 line for 1 entry (default output)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  character(len=*),           intent(out)   :: mess   !
  logical,                    intent(inout) :: error  !
  ! Local
  real(kind=8), parameter :: rad_per_tsec=pi/4.32d4  ! Radians per seconds (time)
  character(len=11) :: date,num
  character(len=13) :: ut
  integer(kind=4) :: n2,nl
  !
  if (ient.eq.0) then
    ! Print header and quit
    write(mess,100)
    return
    !
  else
    if (optx%num(ient).lt.1000) then
      write(num(1:3),'(I3)')  optx%num(ient)
      n2 = 3
    else
      write(num,'(I0)') optx%num(ient)
      n2 = len_trim(num)
    endif
    call gag_todate(optx%dobs(ient),date,error)
    if (error)  return
    if (optx%ut(ient).ne.optx%ut(ient)) then  ! NaN
      ut = ' unknown'
    else
      call sexag(ut,optx%ut(ient),24)
    endif
    !
    write(mess,101)                               &
      num(1:n2),                                  &
      optx%version(ient),                         &
      optx%projid(ient),                          &
      optx%source(ient),                          &
      date,                                       &
      ut,                                         &
      optx%scan(ient),                            &
      backends_mrtcal(optx%backend(ient)),        &
      obstypes_mrtcal(optx%obstype(ient)),        &
      switchmodes_mrtcal(optx%switchmode(ient)),  &
      mrtindex_list_calstatus(optx%calstatus(ient)),  &
      mrtindex_list_solstatus(optx%solstatus(ient)),  &
      mrtindex_list_results(optx,ient)
    !
    nl = len_trim(mess)
    if (optx%filstatus(ient).ne.complete_full) then
      mess(nl+2:) = completenesses(optx%filstatus(ient))
    endif
  endif
  !
  !        'NNN.V PPPPPPPP SSSSSSSSSSSS DDDDDDDDDDD UUUUUUUUUUU SSS BBBBB OOOOOOOOOOO SSS CCCCCC SSSSSS RRRR...
100 format('  N.V ProjId    Source         Date          UT     Scn Backe  ObsType    Swi Calibr Solved Results')
  !        N    V     proj  sourc  date   ut     scan  back  obst   swit  cali
101 format(A,'.',I0,1X,A8,1X,A12,1X,A11,1X,A11,1X,I3,1X,A5,1X,A11,1X,A3,1X,A6,1X,A6,1X,A)
end subroutine mrtindex_list_one_default
!
subroutine mrtindex_list_one_custom(optx,ient,custom,mess,error)
  use gbl_constant
  use phys_const
  use classic_api
  use imbfits_parameters
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_one_custom
  use mrtindex_types
  use mrtindex_list_colnames
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MLIST [IN|OUT]
  ! Print 1 line for 1 entry (custom output)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: optx       !
  integer(kind=entry_length), intent(in)    :: ient       !
  integer(kind=4),            intent(in)    :: custom(:)  !
  character(len=*),           intent(out)   :: mess       !
  logical,                    intent(inout) :: error      !
  ! Local
  integer(kind=4) :: icol,nc,nc2
  real(kind=8), parameter :: rad_per_tsec=pi/4.32d4  ! Radians per seconds (time)
  character(len=11) :: date
  character(len=13) :: str13
  character(len=128) :: results
  type(mrtindex_entry_t) :: entry
  !
  mess = ''
  nc = 0
  if (ient.eq.0) then
    ! Print header only
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_number)
        write(mess(nc+1:),'(A6)')   'NUMBER'
        nc = nc+7
      case (col_entry)
        write(mess(nc+1:),'(A6)')   'ENTRY'
        nc = nc+7
      case (col_directory)
        write(mess(nc+1:),'(A20)')  '-----DIRECTORY------'
        nc = nc+21
      case (col_fitsfile)
        write(mess(nc+1:),'(A40)')  '----------------FITSFILE----------------'
        nc = nc+fitsname_length+1
      case (col_mrtfile)
        write(mess(nc+1:),'(A20)')  '------MRTFILE-------'
        nc = nc+21
      case (col_record)
        write(mess(nc+1:),'(A4)')   'RECO'
        nc = nc+5
      case (col_word)
        write(mess(nc+1:),'(A4)')   'WORD'
        nc = nc+5
      case (col_version)
        write(mess(nc+1:),'(A3)')   'VER'
        nc = nc+4
      case (col_telescope)
        write(mess(nc+1:),'(A8)')   'TELESCOP'
        nc = nc+9
      case (col_projid)
        write(mess(nc+1:),'(A8)')   '-PROJID-'
        nc = nc+9
      case (col_source)
        write(mess(nc+1:),'(A12)')  '---SOURCE---'
        nc = nc+13
      case (col_observed)
        write(mess(nc+1:),'(A11)')  '-OBSERVED--'
        nc = nc+12
      case (col_ut)
        write(mess(nc+1:),'(A11)')  '----UT-----'
        nc = nc+12
      case (col_lst)
        write(mess(nc+1:),'(A11)')  '----LST----'
        nc = nc+12
      case (col_azimuth)
        write(mess(nc+1:),'(A11)')  '--AZIMUTH--'
        nc = nc+12
      case (col_elevation)
        write(mess(nc+1:),'(A11)')  '-ELEVATION-'
        nc = nc+12
      case (col_position)
        write(mess(nc+1:),'(A36)')  '--------------POSITION--------------'
        nc = nc+37
      case (col_frontend)
        write(mess(nc+1:),'(A19)')  '------FRONTEND-----'
        nc = nc+20
      case (col_scan)
        write(mess(nc+1:),'(A3)')   'SCA'
        nc = nc+4
      case (col_backend)
        write(mess(nc+1:),'(A5)')   'BACKE'
        nc = nc+6
      case (col_obstype)
        write(mess(nc+1:),'(A11)')  '--OBSTYPE--'
        nc = nc+12
      case (col_switchmode)
        write(mess(nc+1:),'(A3)')   'SWI'
        nc = nc+4
      case (col_polarimetry)
        write(mess(nc+1:),'(A3)')   'POL'
        nc = nc+4
      case (col_complete)
        write(mess(nc+1:),'(A10)')  '-COMPLETE-'
        nc = nc+11
      case (col_calibrated)
        write(mess(nc+1:),'(A6)')   'CALIBR'
        nc = nc+7
      case (col_solved)
        write(mess(nc+1:),'(A6)')   'SOLVED'
        nc = nc+7
      case (col_itime)
        write(mess(nc+1:),'(A19)')  '-------ITIME-------'
        nc = nc+20
      case (col_islast)
        write(mess(nc+1:),'(A3)')   'LAS'
        nc = nc+4
      case (col_with)
        write(mess(nc+1:),'(A28)')  '---WITH (OBS SCA BAC VER)---'
        nc = nc+29
      case (col_results)
        write(mess(nc+1:),'(A7)')  'RESULTS'
        nc = nc+8
      case default
        exit
      end select
    enddo
    !
  else
    !
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_number)
        write(mess(nc+1:),'(I6)')   optx%num(ient)
        nc = nc+7
      case (col_entry)
        write(mess(nc+1:),'(I6)')   optx%fnum(ient)
        nc = nc+7
      case (col_directory)
        write(mess(nc+1:),'(A20)')  ix_dirs(optx%idir(ient))
        nc = nc+21
      case (col_fitsfile)
        write(mess(nc+1:),'(A40)')  optx%filename(ient)
        nc = nc+fitsname_length+1
      case (col_mrtfile)
        write(mess(nc+1:),'(A20)')  ix_files(optx%idir(ient))%spec
        nc = nc+21
      case (col_record)
        write(mess(nc+1:),'(I4)')   optx%bloc(ient)
        nc = nc+5
      case (col_word)
        write(mess(nc+1:),'(I4)')   optx%word(ient)
        nc = nc+5
      case (col_version)
        write(mess(nc+1:),'(I3)')   optx%version(ient)
        nc = nc+4
      case (col_telescope)
        write(mess(nc+1:),'(A8)')   telescopes(optx%telescope(ient))
        nc = nc+9
      case (col_projid)
        write(mess(nc+1:),'(A8)')   optx%projid(ient)
        nc = nc+9
      case (col_source)
        write(mess(nc+1:),'(A12)')  optx%source(ient)
        nc = nc+13
      case (col_observed)
        call gag_todate(optx%dobs(ient),date,error)
        if (error)  return
        write(mess(nc+1:),'(A11)')  date
        nc = nc+12
      case (col_ut)
        if (optx%ut(ient).ne.optx%ut(ient)) then  ! NaN
          str13 = ' unknown'
        else
          call sexag(str13,optx%ut(ient),24)
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_lst)
        if (optx%lst(ient).ne.optx%lst(ient)) then  ! NaN
          str13 = ' unknown'
        else
          call sexag(str13,optx%lst(ient)*rad_per_tsec,24)
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_azimuth)
        if (optx%az(ient).ne.optx%az(ient)) then  ! NaN
          str13 = ' unknown'
        else
          write(str13,'(F0.8)') optx%az(ient)*deg_per_rad
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_elevation)
        if (optx%el(ient).ne.optx%el(ient)) then  ! NaN
          str13 = ' unknown'
        else
          write(str13,'(F0.8)') optx%el(ient)*deg_per_rad
        endif
        write(mess(nc+1:),'(A11)')  str13
        nc = nc+12
      case (col_position)
        if (optx%lon(ient).ne.optx%lon(ient)) then  ! NaN
          mess(nc+1:nc+12) = ' --:--:--.--'
        elseif (optx%system(ient).eq.type_eq) then
          call rad2sexa(optx%lon(ient), 24,mess(nc+1:nc+12))
        else
          call rad2sexa(optx%lon(ient),360,mess(nc+1:nc+12))
        endif
        nc = nc+13
        if (optx%lat(ient).ne.optx%lat(ient)) then  ! NaN
          mess(nc+1:nc+12) = ' ---:--:--.-'
        else
          call rad2sexa(optx%lat(ient),360,mess(nc+1:nc+12))
        endif
        nc = nc+13
        if (optx%system(ient).eq.type_eq) then
          write(mess(nc+1:),'(A3,1X,F0.1)')  'Eq.',optx%equinox(ient)
        elseif (optx%system(ient).eq.type_ga) then
          mess(nc+1:nc+3) = 'Ga.'
        else
          mess(nc+1:nc+2) = '??'
        endif
        nc = nc+11
      case (col_frontend)
        write(mess(nc+1:),'(A19)')  mrtindex_list_frontend(optx%frontend(:,ient))
        nc = nc+20
      case (col_scan)
        write(mess(nc+1:),'(I3)')   optx%scan(ient)
        nc = nc+4
      case (col_backend)
        write(mess(nc+1:),'(A5)')   backends_mrtcal(optx%backend(ient))
        nc = nc+6
      case (col_obstype)
        write(mess(nc+1:),'(A11)')  obstypes_mrtcal(optx%obstype(ient))
        nc = nc+12
      case (col_switchmode)
        write(mess(nc+1:),'(A3)')   switchmodes_mrtcal(optx%switchmode(ient))
        nc = nc+4
      case (col_polarimetry)
        write(mess(nc+1:),'(A3)')   polstatus(optx%polstatus(ient))
        nc = nc+4
      case (col_complete)
        write(mess(nc+1:),'(A10)')  completenesses(optx%filstatus(ient))
        nc = nc+11
      case (col_calibrated)
        write(mess(nc+1:),'(A6)')   calstatus(optx%calstatus(ient))
        nc = nc+7
      case (col_solved)
        write(mess(nc+1:),'(A6)')   solstatus(optx%solstatus(ient))
        nc = nc+7
      case (col_itime)
        write(mess(nc+1:),'(I19)')  optx%itime(ient)
        nc = nc+20
      case (col_islast)
        write(mess(nc+1:),'(L3)')   optx%islast(ient)
        nc = nc+4
      case (col_with)
        call mrtindex_optimize_to_entry(optx,ient,entry,error)
        if (error)  return
        call mrtindex_entry_lscience(entry%head,mess(nc+1:),nc2,error)
        if (error)  return
        nc = nc+nc2+1
      case (col_results)
        results = mrtindex_list_results(optx,ient)
        write(mess(nc+1:),'(A)')  trim(results)
        nc = nc+len_trim(results)+1
      case default
        exit
      end select
    enddo
    !
  endif
  !
  call mrtindex_entry_free(entry,error)
  if (error)  return
  !
end subroutine mrtindex_list_one_custom
!
function mrtindex_list_frontend(frontend) result(ostring)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the frontend string to be displayed by the MLIST command.
  ! Note the syntax must match the one understood by MFIND /FRONTEND
  !---------------------------------------------------------------------
  character(len=19) :: ostring ! 4 receivers * 4 chars + 3 ampersands
  character(len=*), intent(in) :: frontend(:)
  !
  integer(kind=4) :: ifront,nc,nc2
  !
  nc = 0
  do ifront=1,mrtcal_indx_mfrontend
    nc2 = len_trim(frontend(ifront))
    if (nc2.le.0)  exit
    write(ostring(nc+1:),'(A,A1)') frontend(ifront)(1:nc2),'&'
    nc = nc+nc2+1
  enddo
  if (nc.gt.0)  ostring(nc:nc) = ' '  ! Drop the last '&'
end function mrtindex_list_frontend
!
function mrtindex_list_calstatus(status)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Return the calibration status string to be displayed by the LIST
  ! command
  !---------------------------------------------------------------------
  character(len=calstatus_length) :: mrtindex_list_calstatus
  integer(kind=4), intent(in) :: status
  !
  select case (status)
  case (calstatus_none)
    mrtindex_list_calstatus = '--'
  case (calstatus_done,calstatus_failed,calstatus_empty,calstatus_skipped)
    mrtindex_list_calstatus = calstatus(status)
  case default
    mrtindex_list_calstatus = '???'
  end select
end function mrtindex_list_calstatus
!
function mrtindex_list_solstatus(status)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Return the solve status string to be displayed by the LIST command
  !---------------------------------------------------------------------
  character(len=solstatus_length) :: mrtindex_list_solstatus
  integer(kind=4), intent(in) :: status
  !
  select case (status)
  case (solstatus_none)
    mrtindex_list_solstatus = '--'
  case (solstatus_done,solstatus_failed)
    mrtindex_list_solstatus = solstatus(status)
  case default
    mrtindex_list_solstatus = '???'
  end select
end function mrtindex_list_solstatus
!
function mrtindex_list_results(optx,ient) result(string)
  use mrtindex_interfaces, except_this=>mrtindex_list_results
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! List the scan results (Tsys, pointing, etc).
  ! No error returned on purpose (LIST should not stop)
  !---------------------------------------------------------------------
  character(len=128) :: string
  type(mrtindex_optimize_t),  intent(in) :: optx
  integer(kind=entry_length), intent(in) :: ient
  ! Local
  type(mrtindex_entry_t) :: entry
  logical :: error
  !
  error = .false.
  !
  call mrtindex_optimize_to_entry(optx,ient,entry,error)
  if (error)  goto 10
  !
  if (entry%head%presec(sec_calib_id)) then
    call mrtindex_entry_lcalib(entry%head,string,error)
    if (error)  goto 10
  elseif (entry%head%presec(sec_pointing_id)) then
    call mrtindex_entry_lpointing(entry%head,string,error)
    if (error)  goto 10
  else
    string = ''
  endif
  !
  call mrtindex_entry_free(entry,error)
  if (error)  goto 10
  !
  return
10 continue
  string = '<error>'
end function mrtindex_list_results
!
subroutine mrtindex_list_one_print(message,olun)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_list_one_print
  !---------------------------------------------------------------------
  ! @ private
  !  Send the message to the given Logical Unit. Quite generic, could
  ! be used in other contexts.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: message
  integer(kind=4),  intent(in) :: olun
  ! Local
  character(len=*), parameter :: rname='MLIST'
  !
  if (olun.eq.6) then
    call mrtindex_message(seve%r,rname,message)
  else
    write(olun,'(A)') trim(message)
  endif
  !
end subroutine mrtindex_list_one_print
!
!=======================================================================
!
subroutine mrtindex_list_pointing(optx,name,olun,error)
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_list_pointing
  use mrtindex_types
  use mrtindex_table
  !---------------------------------------------------------------------
  ! @ public
  ! MRTCAL support routine for command
  !   MLIST [IN|CURRENT] /POINTING [/FILE Output]
  ! List the current with specific 'pointing' format (listing the
  ! pointing results)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx   !
  character(len=*),          intent(in)    :: name   ! Index name
  integer(kind=4),           intent(in)    :: olun   !
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MLIST>POINTING'
  integer(kind=entry_length) :: ient,jent
  type(mrtindex_entry_t) :: entry
  type(table_t) :: tab
  type(line_t) :: line
  !
  if (optx%next.le.1) then
    call mrtindex_message(seve%w,rname,'No entry in '//trim(name)//' index')
    return
  endif
  !
  ! Register columns
  call tab%register_column('Date','[gag]',6,'(i6)',error)
  if (error)  return
  call tab%register_column('Scan','',3,'(i3)',error)
  if (error)  return
  call tab%register_column('idBe','',5,'(a5)',error)
  if (error)  return
  call entry%head%poi%list_register_columns(tab,error)
  if (error)  return
  !
  ! List header
  call tab%header(olun,error)
  if (error)  return
  !
  ! List lines
  do ient=1,optx%next-1
    jent = optx%sort(ient)
    !
    call mrtindex_optimize_to_entry(optx,jent,entry,error)
    if (error)  return
    if (.not.entry%head%presec(sec_pointing_id))  cycle
    !
    call line%new_value(tab,entry%head%key%dobs,error)
    if (error)  return
    call line%new_value(tab,entry%head%key%scan,error)
    if (error)  return
    call line%new_value(tab,backends_mrtcal(entry%head%key%backend),error)
    if (error)  return
    call entry%head%poi%list(tab,line,entry%head%key%backend,olun,error)
    if (error)  return
    !
    call line%reset(error)
    if (error)  return
  enddo
  !
end subroutine mrtindex_list_pointing
!
!=======================================================================
!
subroutine mrtindex_list_toc_comm(optx,line,olun,error)
  use gildas_def
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_toc_comm
  use mrtindex_sort_var
  use mrtindex_toc_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  ! MRTCAL support routine for command
  !   MLIST [IN|CURRENT] /TOC [Key1] ... [KeyN]  [/VARIABLE VarName]
  ! Main entry point
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx   !
  character(len=*),          intent(in)    :: line   ! Input command line
  integer(kind=4),           intent(in)    :: olun   !
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4), parameter :: opttoc=1  ! /TOC
  integer(kind=4), parameter :: optvar=5  ! /VARIABLE
  integer(kind=4) :: toc_keys(13)  ! Arbitrary number of args accepted in option /TOC
  character(len=varname_length) :: tocname
  integer(kind=4) :: nc
  !
  call mrtindex_toc_init(mtoc,error)
  if (error)  return
  !
  ! Default (unchanged in no arguments)
  toc_keys(:) = toc_key_null
  toc_keys(1) = mrtindex_toc_key_observed
  toc_keys(2) = mrtindex_toc_key_scan
  call toc_getkeys(line,opttoc,mtoc,toc_keys,error)
  if (error)  return
  !
  tocname = 'MTOC'  ! Default structure name
  call sic_ch(line,optvar,1,tocname,nc,.false.,error)
  if (error)  return
  !
  call mrtindex_list_toc(optx,toc_keys,tocname,olun,error)
  if (error)  return
  !
end subroutine mrtindex_list_toc_comm
!
subroutine mrtindex_toc_init(toc,error)
  use gkernel_interfaces
  use toc_types
  use classic_api
  use mrtindex_toc_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command MLIST /TOC
  ! Initialization routine
  !---------------------------------------------------------------------
  type(toc_t), intent(inout) :: toc    !
  logical,     intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TOC/INIT'
  integer(kind=4) :: ier
  !
  if (toc%initialized)  return
  !
  toc%nkey = 14
  allocate(toc%keys(toc%nkey),stat=ier)
  if (failed_allocate(rname,'keys array',ier,error)) return
  !
  toc%keys(1)%id            = mrtindex_toc_key_number
  toc%keys(1)%keyword       = 'NUM'
  toc%keys(1)%sic_var_name  = 'num'
  toc%keys(1)%human_name    = 'NUMBER'
  toc%keys(1)%message       = 'Number of numbers......'
  toc%keys(1)%ftype         = toc_ftype_i8_1d
  toc%keys(1)%ptype         = mrtindex_ptype_null
  !
  toc%keys(2)%id            = mrtindex_toc_key_version
  toc%keys(2)%keyword       = 'VER'
  toc%keys(2)%sic_var_name  = 'ver'
  toc%keys(2)%human_name    = 'VERSION'
  toc%keys(2)%message       = 'Number of versions.....'
  toc%keys(2)%ftype         = toc_ftype_i4_1d
  toc%keys(2)%ptype         = mrtindex_ptype_null
  !
  toc%keys(3)%id            = mrtindex_toc_key_telescope
  toc%keys(3)%keyword       = 'TELE'
  toc%keys(3)%sic_var_name  = 'tele'
  toc%keys(3)%human_name    = 'TELESCOPE'
  toc%keys(3)%message       = 'Number of telescopes...'
  toc%keys(3)%ftype         = toc_ftype_i4_1d
  toc%keys(3)%ptype         = mrtindex_ptype_teles
  !
  toc%keys(4)%id            = mrtindex_toc_key_projid
  toc%keys(4)%keyword       = 'ID'
  toc%keys(4)%sic_var_name  = 'id'
  toc%keys(4)%human_name    = 'ID'
  toc%keys(4)%message       = 'Number of projects.....'
  toc%keys(4)%ftype         = toc_ftype_c8_1d
  toc%keys(4)%ptype         = mrtindex_ptype_null
  !
  toc%keys(5)%id            = mrtindex_toc_key_source
  toc%keys(5)%keyword       = 'SOUR'
  toc%keys(5)%sic_var_name  = 'sour'
  toc%keys(5)%human_name    = 'SOURCE'
  toc%keys(5)%message       = 'Number of sources......'
  toc%keys(5)%ftype         = toc_ftype_c12_1d
  toc%keys(5)%ptype         = mrtindex_ptype_null
  !
  toc%keys(6)%id            = mrtindex_toc_key_observed
  toc%keys(6)%keyword       = 'OBS'
  toc%keys(6)%sic_var_name  = 'obs'
  toc%keys(6)%human_name    = 'OBSERVED' ! Observed date
  toc%keys(6)%message       = 'Number of observation dates'
  toc%keys(6)%ftype         = toc_ftype_i4_1d
  toc%keys(6)%ptype         = mrtindex_ptype_gagdate
  !
  toc%keys(7)%id            = mrtindex_toc_key_frontend
  toc%keys(7)%keyword       = 'FRONTEND'
  toc%keys(7)%sic_var_name  = 'frontend'
  toc%keys(7)%human_name    = 'FRONTEND'
  toc%keys(7)%message       = 'Number of frontends.....'
  toc%keys(7)%ftype         = toc_ftype_c8_2d
  toc%keys(7)%ptype         = mrtindex_ptype_frontend
  !
  toc%keys(8)%id            = mrtindex_toc_key_scan
  toc%keys(8)%keyword       = 'SCAN'
  toc%keys(8)%sic_var_name  = 'scan'
  toc%keys(8)%human_name    = 'SCAN'
  toc%keys(8)%message       = 'Number of scans........'
  toc%keys(8)%ftype         = toc_ftype_i4_1d
  toc%keys(8)%ptype         = mrtindex_ptype_null
  !
  toc%keys(9)%id            = mrtindex_toc_key_backend
  toc%keys(9)%keyword       = 'BACK'
  toc%keys(9)%sic_var_name  = 'back'
  toc%keys(9)%human_name    = 'BACKEND'
  toc%keys(9)%message       = 'Number of backends.....'
  toc%keys(9)%ftype         = toc_ftype_i4_1d
  toc%keys(9)%ptype         = mrtindex_ptype_backend
  !
  toc%keys(10)%id           = mrtindex_toc_key_obstype
  toc%keys(10)%keyword      = 'TYPE'
  toc%keys(10)%sic_var_name = 'type'
  toc%keys(10)%human_name   = 'OBSTYPE'
  toc%keys(10)%message      = 'Number of obs. types...'
  toc%keys(10)%ftype        = toc_ftype_i4_1d
  toc%keys(10)%ptype        = mrtindex_ptype_obstype
  !
  toc%keys(11)%id           = mrtindex_toc_key_switch
  toc%keys(11)%keyword      = 'SWITCH'
  toc%keys(11)%sic_var_name = 'switch'
  toc%keys(11)%human_name   = 'SWITCHMODE'
  toc%keys(11)%message      = 'Number of switch modes.'
  toc%keys(11)%ftype        = toc_ftype_i4_1d
  toc%keys(11)%ptype        = mrtindex_ptype_switchmode
  !
  toc%keys(12)%id           = mrtindex_toc_key_polar
  toc%keys(12)%keyword      = 'POLAR'
  toc%keys(12)%sic_var_name = 'polarimetry'
  toc%keys(12)%human_name   = 'POLARIMETRY'
  toc%keys(12)%message      = 'Number of polar. files.'
  toc%keys(12)%ftype        = toc_ftype_i4_1d
  toc%keys(12)%ptype        = mrtindex_ptype_polarimetry
  !
  toc%keys(13)%id           = mrtindex_toc_key_calstatus
  toc%keys(13)%keyword      = 'CALIB'
  toc%keys(13)%sic_var_name = 'calibrated'
  toc%keys(13)%human_name   = 'CALIBRATED'
  toc%keys(13)%message      = 'Number of calib status.'
  toc%keys(13)%ftype        = toc_ftype_i4_1d
  toc%keys(13)%ptype        = mrtindex_ptype_calstatus
  !
  toc%keys(14)%id           = mrtindex_toc_key_directory
  toc%keys(14)%keyword      = 'DIR'
  toc%keys(14)%sic_var_name = 'directory'
  toc%keys(14)%human_name   = 'DIRECTORY'
  toc%keys(14)%message      = 'Number of directories.'
  toc%keys(14)%ftype        = toc_ftype_i4_1d
  toc%keys(14)%ptype        = mrtindex_ptype_directory
  !
  call toc_init_pointers(toc,error)
  if (error)  return
  !
  toc%initialized = .true.
  !
end subroutine mrtindex_toc_init
!
subroutine mrtindex_toc_clean(error)
  use classic_api
  use mrtindex_sort_var
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command MLIST /TOC
  ! Clean the global variable holding the TOC
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call toc_clean(mtoc,error)
  ! if (error)  continue
  !
end subroutine mrtindex_toc_clean
!
subroutine mrtindex_list_toc(optx,keywords,tocname,olun,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_list_toc
  use mrtindex_types
  use mrtindex_sort_var
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL Support routine for command
  !   MLIST /TOC
  ! Processing routine
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: optx         ! The optx whose TOC is desired
  integer(kind=4),           intent(in)    :: keywords(:)  ! Key identifiers
  character(len=*),          intent(in)    :: tocname      ! Structure name
  integer(kind=4),           intent(in)    :: olun         !
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MLIST/TOC'
  !
  call mrtindex_toc_datasetup(mtoc,optx)
  !
  call toc_main(rname,mtoc,optx%next-1,keywords,tocname,olun,mrtindex_toc_format,error)
  if (error)  return
  !
end subroutine mrtindex_list_toc
!
subroutine mrtindex_toc_datasetup(toc,idx)
  use toc_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! MRTCAL support routine for command
  !   MLIST /TOC
  ! Associate the TOC data pointers to the index whose TOC is desired
  !---------------------------------------------------------------------
  type(toc_t),               intent(inout) :: toc
  type(mrtindex_optimize_t), intent(in)    :: idx  ! The idx whose TOC is desired
  !
  toc%keys( 1)%ptr%i8%data1  => idx%num
  toc%keys( 2)%ptr%i4%data1  => idx%version
  toc%keys( 3)%ptr%i4%data1  => idx%telescope
  toc%keys( 4)%ptr%c8%data1  => idx%projid
  toc%keys( 5)%ptr%c12%data1 => idx%source
  toc%keys( 6)%ptr%i4%data1  => idx%dobs
  toc%keys( 7)%ptr%c8%data2  => idx%frontend
  toc%keys( 8)%ptr%i4%data1  => idx%scan
  toc%keys( 9)%ptr%i4%data1  => idx%backend
  toc%keys(10)%ptr%i4%data1  => idx%obstype
  toc%keys(11)%ptr%i4%data1  => idx%switchmode
  toc%keys(12)%ptr%i4%data1  => idx%polstatus
  toc%keys(13)%ptr%i4%data1  => idx%calstatus
  toc%keys(14)%ptr%i4%data1  => idx%idir
  !
end subroutine mrtindex_toc_datasetup
!
subroutine mrtindex_toc_format(key,ival,output)
  use toc_types
  use imbfits_parameters
  use mrtindex_parameters
  use mrtindex_vars
  use mrtindex_toc_parameters
  use mrtindex_interfaces, except_this=>mrtindex_toc_format
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! MRTCAL support routine for command
  !   MLIST /TOC
  ! Custom display routine (because there are custom types)
  !---------------------------------------------------------------------
  type(toc_descriptor_t),     intent(in)  :: key     !
  integer(kind=entry_length), intent(in)  :: ival    !
  character(len=*),           intent(out) :: output  !
  ! Local
  integer(kind=4) :: nc,i
  logical :: error
  !
  select case(key%ftype)
  case(toc_ftype_i4_1d) ! integer*4
    if (key%ptype.eq.mrtindex_ptype_teles) then
      output = telescopes(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_gagdate) then
      call gag_todate(key%ptr%i4%data1(ival),output,error)
    elseif (key%ptype.eq.mrtindex_ptype_backend) then
      output = backends_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_obstype) then
      output = obstypes_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_switchmode) then
      output = switchmodes_mrtcal(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_polarimetry) then
      output = polstatus(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_calstatus) then
      output = calstatus(key%ptr%i4%data1(ival))
    elseif (key%ptype.eq.mrtindex_ptype_directory) then
      output = ix_dirs(key%ptr%i4%data1(ival))
    else
      write(output,'(i12)') key%ptr%i4%data1(ival)
    endif
    !
  case(toc_ftype_i8_1d)  ! integer*8
    write(output,'(i12)') key%ptr%i8%data1(ival)
    !
  case(toc_ftype_r4_1d)  ! real*4
    write(output,'(f8.3)') key%ptr%r4%data1(ival)
    !
  case(toc_ftype_c8_1d)  ! string*8
    output = key%ptr%c8%data1(ival)
    !
  case(toc_ftype_c12_1d) ! string*12
    output = key%ptr%c12%data1(ival)
    !
  case(toc_ftype_c8_2d)  ! string*8 (2D)
    if (key%ptype.eq.mrtindex_ptype_frontend) then
      output = mrtindex_list_frontend(key%ptr%c8%data2(:,ival))
    else  ! Generic formatting (unclear)
      nc = 1
      do i=1,ubound(key%ptr%c8%data2,1)
        output(nc:) = key%ptr%c8%data2(i,ival)
        nc = len_trim(output)+2  ! Compact the names
      enddo
    endif
  end select
  !
end subroutine mrtindex_toc_format

!  Support file for Class index. The Index provides a short summary of a
! given observation.
!
subroutine index_frombuf_v1(data,indl,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_frombuf_v1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer the data(*) buffer from V1 to the last version of the
  ! index
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  type(indx_t),             intent(out)   :: indl     !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  type(indx_v1_t) :: ind1
  !
  ! Read in the indx sequence of length 'lenbi' integers
  if (conv%code.eq.0) then
    ! Native, copy the whole block (NB: might be a problem with the strings)
    call r4tor4(data(1),ind1%bloc,lind_v1)
  else
    ! Non native, conversion needed
    call conv%read%i4(data(1), ind1%bloc,   3)
    call conv%read%cc(data(4), ind1%csour,  3)
    call conv%read%cc(data(7), ind1%cline,  3)
    call conv%read%cc(data(10),ind1%ctele,  3)
    call conv%read%i4(data(13),ind1%dobs,   2)
    call conv%read%r4(data(15),ind1%off1,   2)
    call conv%read%i4(data(17),ind1%type,   4)
    call conv%read%r4(data(21),ind1%posa,   1)
    call conv%read%i4(data(22),ind1%subscan,1)
  endif
  !
  if (ind1%scan.eq.0) ind1%scan = ind1%num
  !
  ! Upper case conversion
  call sic_upper(ind1%csour)
  call sic_upper(ind1%cline)
  call sic_upper(ind1%ctele)
  !
  call index_v1tovl(ind1,indl,error)
  !
end subroutine index_frombuf_v1
!
subroutine index_v1tovl(ind1,indl,error)
  use classcore_interfaces, except_this=>index_v1tovl
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transform the index V1 into an index last version
  !---------------------------------------------------------------------
  type(indx_v1_t), intent(in)    :: ind1   !
  type(indx_t),    intent(out)   :: indl   !
  logical,         intent(inout) :: error  !
  !
  indl%bloc    = ind1%bloc  ! Record number where observation starts
  indl%word    = 1          ! In this record, the word where the observation starts
  indl%num     = ind1%num
  indl%ver     = ind1%ver
  indl%csour   = ind1%csour
  indl%cline   = ind1%cline
  indl%ctele   = ind1%ctele
  indl%dobs    = ind1%dobs
  indl%dred    = ind1%dred
  indl%off1    = ind1%off1
  indl%off2    = ind1%off2
  indl%type    = ind1%type
  indl%kind    = ind1%kind
  indl%qual    = ind1%qual
  indl%scan    = ind1%scan
  indl%posa    = ind1%posa
  indl%subscan = ind1%subscan
  indl%ut      = ut_null
  !
end subroutine index_v1tovl
!
subroutine index_frombuf_v2orv3(data,isv3,indl,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_frombuf_v2orv3
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer the data(*) buffer from V2 or V3 to the last version of
  ! the index
  !---------------------------------------------------------------------
  integer(kind=4),          intent(in)    :: data(*)  !
  logical,                  intent(in)    :: isv3     !
  type(indx_t),             intent(out)   :: indl     !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  !
  ! Read in the indx. Since the index in memory is not correctly
  ! aligned (memory padding, no SEQUENCE), we MUST read the elements
  ! one by one.
  call conv%read%i8(data(1), indl%bloc,   1)  ! bloc
  call conv%read%i4(data(3), indl%word,   1)  ! word
  call conv%read%i8(data(4), indl%num,    1)  ! num
  call conv%read%i4(data(6), indl%ver,    1)  ! ver
  call conv%read%cc(data(7), indl%csour,  3)  ! csour
  call conv%read%cc(data(10),indl%cline,  3)  ! cline
  call conv%read%cc(data(13),indl%ctele,  3)  ! ctele
  call conv%read%i4(data(16),indl%dobs,   1)  ! dobs
  call conv%read%i4(data(17),indl%dred,   1)  ! dred
  call conv%read%r4(data(18),indl%off1,   1)  ! off1
  call conv%read%r4(data(19),indl%off2,   1)  ! off2
  call conv%read%i4(data(20),indl%type,   1)  ! type
  call conv%read%i4(data(21),indl%kind,   1)  ! kind
  call conv%read%i4(data(22),indl%qual,   1)  ! qual
  call conv%read%r4(data(23),indl%posa,   1)  ! posa
  call conv%read%i8(data(24),indl%scan,   1)  ! scan
  call conv%read%i4(data(26),indl%subscan,1)  ! subscan
  if (isv3) then
    call conv%read%r8(data(27),indl%ut,   1)  ! ut
  else
    indl%ut = ut_null
  endif
  !
  if (indl%scan.eq.0) indl%scan = indl%num
  !
  ! Upper case conversion
  call sic_upper(indl%csour)
  call sic_upper(indl%cline)
  call sic_upper(indl%ctele)
  !
end subroutine index_frombuf_v2orv3
!
subroutine index_tobuf_v1(indl,data,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_tobuf_v1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer last version of the index to the data(*) buffer V1
  !---------------------------------------------------------------------
  type(indx_t),             intent(in)    :: indl     !
  integer(kind=4),          intent(out)   :: data(*)  !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  type(indx_v1_t) :: ind1
  !
  call index_vltov1(indl,ind1,error)
  !
  if (conv%code.eq.0) then
    ! Native, copy the whole block (NB: might be a problem with the strings)
    call r4tor4(ind1%bloc,data(1),lind_v1)
  else
    ! Non native, conversion needed
    call conv%writ%i4(ind1%bloc,   data(1), 3)
    call conv%writ%cc(ind1%csour,  data(4), 3)
    call conv%writ%cc(ind1%cline,  data(7), 3)
    call conv%writ%cc(ind1%ctele,  data(10),3)
    call conv%writ%i4(ind1%dobs,   data(13),2)
    call conv%writ%r4(ind1%off1,   data(15),2)
    call conv%writ%i4(ind1%type,   data(17),4)
    call conv%writ%r4(ind1%posa,   data(21),1)
    call conv%writ%i4(ind1%subscan,data(22),1)
  endif
  !
end subroutine index_tobuf_v1
!
subroutine index_vltov1(indl,ind1,error)
  use gbl_message
  use classcore_interfaces, except_this=>index_vltov1
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transform the index last version into an index V1
  !---------------------------------------------------------------------
  type(indx_t),    intent(in)    :: indl   !
  type(indx_v1_t), intent(out)   :: ind1   !
  logical,         intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='INDEX'
  !
  call i8toi4_fini(indl%bloc,ind1%bloc,1,error)
  if (error)  return
  if (indl%word.ne.1) then
    call class_message(seve%e,rname,  &
      'Internal error: Observation must start at the beginning of record for V1 file')
    error = .true.
    return
  endif
  call i8toi4_fini(indl%num,ind1%num,1,error)
  if (error)  return
  ind1%ver     = indl%ver
  ind1%csour   = indl%csour
  ind1%cline   = indl%cline
  ind1%ctele   = indl%ctele
  ind1%dobs    = indl%dobs
  ind1%dred    = indl%dred
  ind1%off1    = indl%off1
  ind1%off2    = indl%off2
  ind1%type    = indl%type
  ind1%kind    = indl%kind
  ind1%qual    = indl%qual
  call i8toi4_fini(indl%scan,ind1%scan,1,error)
  if (error)  return
  ind1%posa    = indl%posa
  ind1%subscan = indl%subscan
  !            = indl%ut  ! Not available in V1
  !
end subroutine index_vltov1
!
subroutine index_tobuf_v2orv3(indl,isv3,data,conv,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use classcore_interfaces, except_this=>index_tobuf_v2orv3
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Transfer last version of the index to the data(*) buffer V2 or V3
  !---------------------------------------------------------------------
  type(indx_t),             intent(in)    :: indl     !
  logical,                  intent(in)    :: isv3     !
  integer(kind=4),          intent(out)   :: data(*)  !
  type(classic_fileconv_t), intent(in)    :: conv     !
  logical,                  intent(inout) :: error    !
  ! Local
  !
  ! Write in the indx. Since the index in memory is not correctly
  ! aligned (memory padding, no SEQUENCE), we MUST write the elements
  ! one by one.
  call conv%writ%i8(indl%bloc,   data(1), 1)  ! bloc
  call conv%writ%i4(indl%word,   data(3), 1)  ! word
  call conv%writ%i8(indl%num,    data(4), 1)  ! num
  call conv%writ%i4(indl%ver,    data(6), 1)  ! ver
  call conv%writ%cc(indl%csour,  data(7), 3)  ! csour
  call conv%writ%cc(indl%cline,  data(10),3)  ! cline
  call conv%writ%cc(indl%ctele,  data(13),3)  ! ctele
  call conv%writ%i4(indl%dobs,   data(16),1)  ! dobs
  call conv%writ%i4(indl%dred,   data(17),1)  ! dred
  call conv%writ%r4(indl%off1,   data(18),1)  ! off1
  call conv%writ%r4(indl%off2,   data(19),1)  ! off2
  call conv%writ%i4(indl%type,   data(20),1)  ! type
  call conv%writ%i4(indl%kind,   data(21),1)  ! kind
  call conv%writ%i4(indl%qual,   data(22),1)  ! qual
  call conv%writ%r4(indl%posa,   data(23),1)  ! posa
  call conv%writ%i8(indl%scan,   data(24),1)  ! scan
  call conv%writ%i4(indl%subscan,data(26),1)  ! subscan
  if (isv3) then
    call conv%writ%r8(indl%ut,   data(27),1)  ! ut
  endif
  !
end subroutine index_tobuf_v2orv3
!
subroutine index_fromobs(head,ind,error)
  use gbl_constant
  use classcore_interfaces, except_this=>index_fromobs
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set the output Index from the input Observation Header
  !---------------------------------------------------------------------
  type(header), intent(in)    :: head   ! Observation header
  type(indx_t), intent(out)   :: ind    ! Computed Index
  logical,      intent(inout) :: error  !
  !
  ind%num     = head%gen%num
  ind%ver     = head%gen%ver
  if (head%gen%kind.eq.kind_sky) then
    ind%csour = 'SKYDIP'
    ind%cline = head%sky%line
  else
    ind%csour = head%pos%sourc
    ind%cline = head%spe%line
  endif
  ind%ctele   = head%gen%teles
  ind%dobs    = head%gen%dobs
  ind%dred    = head%gen%dred
  ind%off1    = head%pos%lamof
  ind%off2    = head%pos%betof
  ind%type    = head%pos%system
  ind%kind    = head%gen%kind
  ind%qual    = head%gen%qual
  ind%scan    = head%gen%scan
  ind%posa    = head%dri%apos
  ind%subscan = head%gen%subscan
  ind%ut      = head%gen%ut
  !
end subroutine index_fromobs
!
subroutine index_toobs(ind,head,error)
  use gbl_constant
  use classcore_interfaces, except_this=>index_toobs
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Copy the Index to the in/out Observation Header
  !---------------------------------------------------------------------
  type(indx_t), intent(in)    :: ind    ! Computed Index
  type(header), intent(inout) :: head   ! Observation header
  logical,      intent(inout) :: error  !
  !
  head%gen%num     = ind%num
  head%gen%ver     = ind%ver
  head%pos%sourc   = ind%csour
  if (head%gen%kind.eq.kind_sky) then
    head%sky%line = ind%cline
  else
    head%spe%line = ind%cline
  endif
  head%gen%teles   = ind%ctele
  head%gen%dobs    = ind%dobs
  call gag_todate(ind%dobs,head%gen%cdobs,error)
  head%gen%dred    = ind%dred
  call gag_todate(ind%dred,head%gen%cdred,error)
  head%pos%lamof   = ind%off1
  head%pos%betof   = ind%off2
  head%pos%system  = ind%type
  head%gen%kind    = ind%kind
  head%gen%qual    = ind%qual
  head%gen%scan    = ind%scan
  head%dri%apos    = ind%posa
  head%gen%subscan = ind%subscan
  head%gen%ut      = ind%ut
  !
end subroutine index_toobs
!
subroutine index_tooptimize(ind,iind,long,iopt,optx,error)
  use classic_api
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Copy the input Index to the input 'optimize' object (collection
  ! of all the Indexes of the Observations in the file). The code
  ! assumes that the arrays are correctly allocated (enough space).
  ! This is done with reallocate_optimize.
  !  'long' index: all arrays are allocated
  !  'short' index: only ind(:), bloc(:), num(:), ver(:)
  !---------------------------------------------------------------------
  type(indx_t),               intent(in)    :: ind    ! Index
  integer(kind=entry_length), intent(in)    :: iind   ! Index number
  logical,                    intent(in)    :: long   ! Long index?
  integer(kind=entry_length), intent(in)    :: iopt   ! Position in optimized index
  type(optimize),             intent(inout) :: optx   ! Optimized index of file
  logical,                    intent(inout) :: error  !
  !
  optx%ind(iopt)     = iind
  optx%bloc(iopt)    = ind%bloc
  optx%word(iopt)    = ind%word
  optx%num(iopt)     = ind%num
  optx%ver(iopt)     = ind%ver
  optx%dobs(iopt)    = ind%dobs
  optx%ut(iopt)      = ind%ut
  optx%ctele(iopt)   = ind%ctele
  optx%scan(iopt)    = ind%scan
  optx%subscan(iopt) = ind%subscan
  !
  if (long) then
    optx%csour(iopt)   = ind%csour
    optx%cline(iopt)   = ind%cline
    !                  = ind%dred ?
    optx%off1(iopt)    = ind%off1
    optx%off2(iopt)    = ind%off2
    !                  = ind%type?
    optx%kind(iopt)    = ind%kind
    optx%qual(iopt)    = ind%qual
    optx%posa(iopt)    = ind%posa
    !
  else
    ! optx%sort%number(iopt) = ???
    ! optx%sort%entry(iopt) = ???
  endif
  !
end subroutine index_tooptimize
!
subroutine index_fromoptimize(optx,i,ind,error)
  use classic_api
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Fill the given Index from the input 'optimize' object
  ! (collection of Indexes)
  !---------------------------------------------------------------------
  type(optimize),             intent(in)    :: optx   ! Optimized index of file
  integer(kind=entry_length), intent(in)    :: i      ! Index number
  type(indx_t),               intent(out)   :: ind    ! Current spectrum index
  logical,                    intent(inout) :: error  !
  !
  ind%bloc    = optx%bloc(i)
  ind%word    = optx%word(i)
  ind%num     = optx%num(i)
  ind%ver     = optx%ver(i)
  ind%csour   = optx%csour(i)
  ind%cline   = optx%cline(i)
  ind%ctele   = optx%ctele(i)
  ind%dobs    = optx%dobs(i)
  ! ind%dred  = ?
  ind%off1    = optx%off1(i)
  ind%off2    = optx%off2(i)
  ! ind%type  = ?
  ind%kind    = optx%kind(i)
  ind%qual    = optx%qual(i)
  ind%scan    = optx%scan(i)
  ind%posa    = optx%posa(i)
  ind%subscan = optx%subscan(i)
  ind%ut      = optx%ut(i)
  !
end subroutine index_fromoptimize
!
subroutine optimize_tooptimize(in,i,ou,o,long,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy 1 element of optimize'd index IN into OU
  !---------------------------------------------------------------------
  type(optimize),             intent(in)    :: in     ! Input index
  integer(kind=entry_length), intent(in)    :: i      ! Element to be copied
  type(optimize),             intent(inout) :: ou     ! Output index
  integer(kind=entry_length), intent(in)    :: o      ! Destination
  logical,                    intent(in)    :: long   ! Long index?
  logical,                    intent(inout) :: error  ! Logical error flag
  !
  ou%ind(o)     = in%ind(i)
  ou%bloc(o)    = in%bloc(i)
  ou%word(o)    = in%word(i)
  ou%num(o)     = in%num(i)
  ou%ver(o)     = in%ver(i)
  ou%ut(o)      = in%ut(i)
  ou%ctele(o)   = in%ctele(i)
  ou%scan(o)    = in%scan(i)
  ou%subscan(o) = in%subscan(i)
  !
  if (long) then
    ou%csour(o)   = in%csour(i)
    ou%cline(o)   = in%cline(i)
    ou%dobs(o)    = in%dobs(i)
    ou%off1(o)    = in%off1(i)
    ou%off2(o)    = in%off2(i)
    ou%kind(o)    = in%kind(i)
    ou%qual(o)    = in%qual(i)
    ou%posa(o)    = in%posa(i)
  else
    ! ou%number(o) = ???
    ! ou%entry(o) = ???
  endif
  !
end subroutine optimize_tooptimize
!
subroutine optimize_old_format(optx,name,error)
  use gbl_message
  use classcore_interfaces, except_this=>optimize_old_format
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Check whether the index contains old format observations, and act
  ! accordingly.
  !---------------------------------------------------------------------
  type(optimize),   intent(inout) :: optx   !
  character(len=*), intent(in)    :: name   ! Index name
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=entry_length) :: ient
  !
  optx%has_old_fmt = .false.
  do ient=1,optx%next-1
    ! Old data format can be detected in the index as entries with a
    ! null subcan number (since this information was not written in
    ! the index at that time -- it is read as 0 from file --), and an
    ! observing date before 01-JAN-2006 (the new format was
    ! implemented at the telescope in 2005).
    if (optx%subscan(ient).eq.0 .and. optx%dobs(ient).lt.dobs_v1_old) then
      ! Old format in index has 2 minor consequences:
      ! 1) raises a warning to user
      ! 2) raise the associated flag (visible in SIC variable IDX%OLDFMT in
      !    case of CX)
      call class_message(seve%w,rname,name//' index contains old format data')
      optx%has_old_fmt = .true.
      return
    endif
  enddo
end subroutine optimize_old_format
!
subroutine rix_to_ix(entry_num,error)
  use classic_api
  use classcore_interfaces, except_this=>rix_to_ix
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Entry Index for given entry in FILE IN, and store it into
  ! IX. Assume IX has already been (re)allocated to a sufficient size!
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: entry_num  !
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  type(indx_t) :: ind
  !
  call rix(entry_num,ind,error)
  if (error)  return
  !
  call index_tooptimize(ind,entry_num,.true.,entry_num,ix,error)
  if (error)  return
  !
end subroutine rix_to_ix
!
subroutine rox_to_ox(entry_num,error)
  use classic_api
  use classcore_interfaces, except_this=>rox_to_ox
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  !  Read the Entry Index for given entry in FILE OUT, and store it into
  ! OX. Assume OX has already been (re)allocated to a sufficient size!
  !---------------------------------------------------------------------
  integer(kind=entry_length), intent(in)    :: entry_num  !
  logical,                    intent(inout) :: error      ! Logical error flag
  ! Local
  type(indx_t) :: ind
  !
  call rox(entry_num,ind,error)
  if (error)  return
  !
  call index_tooptimize(ind,entry_num,.false.,entry_num,ox,error)
  if (error)  return
  !
end subroutine rox_to_ox
!
subroutine ix_update(error)
  use gbl_message
  use gbl_format
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>ix_update
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Check if input file has new entries, and save them in IX if yes
  !---------------------------------------------------------------------
  logical, intent(out) :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='UDPATE'
  integer(kind=entry_length) :: i
  !
  if (filein_isvlm) then
    call class_message(seve%w,rname,  &
      'Index update is not relevant for FILE IN VLM. Ignored.')
    return
  endif
  !
  ! Re-read the File Descriptor and check if file has new observations.
  call classic_file_fflush(filein,error)  ! Flush for reading
  if (error) then  ! e.g. file has disappearead
    call class_message(seve%e,rname,'Read error file '//filein%spec)
    return
  endif
  call classic_filedesc_read(filein,error)
  if (error) then
    call class_message(seve%e,rname,'Read error file '//filein%spec)
    return
  endif
  !
  if (ix%next.ge.filein%desc%xnext)  return  ! Nothing new
  !
  ! Resize The Input File Index to the new size
  call reallocate_optimize(ix,filein%desc%xnext-1,.true.,.true.,error)
  if (error)  return
  !
  ! Nullify the Entry Index buffer: it may contain a record which has
  ! been updated on disk. This forces re-reading.
  call classic_recordbuf_nullify(ibufbi)
  !
  ! Nullify the Observation buffer: in V2 files, there can be several
  ! (pieces of) observations sharing the same record. This forces
  ! re-reading from disk when GET will be done later.
  call classic_recordbuf_nullify(ibufobs)
  !
  ! And finally store the new entries
  do i=ix%next,filein%desc%xnext-1
    call rix_to_ix(i,error)  ! Append the IX% structure
    if (error)  return
    ix%next = ix%next+1
  enddo
  !
end subroutine ix_update

module press_f1com
  integer :: ncom
  integer, parameter :: nmax=50
  real :: pcom(nmax)
  real :: xicom(nmax)
end module press_f1com
!
function press_func (para)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>press_func
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: press_func                !
  real :: para(*)                   !
  ! Local
  logical :: error
  real(8) :: value,y
  integer :: i
  !
  ! From x to association module
  error = .false.
  do i=1,adj_n
     value = para(i)  ! Promote to R*8
     call from_internal(i,value,y)
     call sic_let_auto(adj_names(i),y,error)
  enddo
  !
  adj_ncall = adj_ncall + 1
  press_func = 0.0
  !
  call exec_subprogram (membyt(cur_exec),diff_expression,error)
  if (error) press_error = .true.
  value = 0.d0
  do i = 1,ndata
     y = dvec(i)*wvec(i)
     value = value + y*y
  enddo
  if (sic_ctrlc()) press_error = .true.
  press_func = sqrt(value)
end function press_func
!
!*************************************************************************
! The following modules are derived from the
! subroutines AMOEBA  LINMIN  MNBRAK  POWELL and the function BRENT
! as described from "Numerical Recipes" by Press et al.
!
! With a lot of modifications allowing better insertion into a generic program
! and more error control
!
!
subroutine press_amoeba(p,y,mp,np,ndim,ftol,my_func,iter)
  use sic_interfaces, except_this=>press_amoeba
  use sic_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: mp                     !
  integer :: np                     !
  real :: p(mp,np)                  !
  real :: y(mp)                     !
  integer :: ndim                   !
  real :: ftol                      !
  real, external :: my_func         !
  integer :: iter                   !
  ! Local
  integer, parameter :: nmax=26
  real, parameter :: alpha=1.0, beta=0.5, gamma=2.0
  real :: pr(nmax),prr(nmax),pbar(nmax)
  integer :: mpts,ilo,ihi,inhi,i,j
  real :: rtol,ypr,yprr
  !
  mpts=ndim+1
  iter=0
1 ilo=1
  if (y(1).gt.y(2)) then
     ihi=1
     inhi=2
  else
     ihi=2
     inhi=1
  endif
  do i=1,mpts
     if (y(i).lt.y(ilo)) ilo=i
     if (y(i).gt.y(ihi)) then
        inhi=ihi
        ihi=i
     elseif (y(i).gt.y(inhi)) then
        if (i.ne.ihi) inhi=i
     endif
  enddo
  !
  ! MB 3-Feb-1994: The original RTOL criterium did not stop the iteration
  ! when a good result was already obtained. The PAUSE command in the
  ! ITMAX condition has been replaced to avoid a global program shutdown.
  !
  rtol=2.*abs(y(ihi)-y(ilo))/(abs(y(ihi))+abs(y(ilo)))
  if ((rtol.lt.ftol) .or. (abs(y(ihi)-y(ilo)).lt.ftol)) return
  !
  if (iter.eq.press_itmax) then
     call sic_message(seve%i,'ADJUST','SIMPLEX exceeds maximum iteration.')
     return
  endif
  iter=iter+1
  do j=1,ndim
     pbar(j)=0.
  enddo
  do i=1,mpts
     if (i.ne.ihi) then
        do j=1,ndim
           pbar(j)=pbar(j)+p(i,j)
        enddo
     endif
  enddo
  do j=1,ndim
     pbar(j)=pbar(j)/ndim
     pr(j)=(1.+alpha)*pbar(j)-alpha*p(ihi,j)
  enddo
  ypr=my_func(pr)
  if (press_error) return
  !
  if (ypr.le.y(ilo)) then
     do j=1,ndim
        prr(j)=gamma*pr(j)+(1.-gamma)*pbar(j)
     enddo
     yprr=my_func(prr)
     if (press_error) return
     !
     if (yprr.lt.y(ilo)) then
        do j=1,ndim
           p(ihi,j)=prr(j)
        enddo
        y(ihi)=yprr
     else
        do j=1,ndim
           p(ihi,j)=pr(j)
        enddo
        y(ihi)=ypr
     endif
  elseif (ypr.ge.y(inhi)) then
     if (ypr.lt.y(ihi)) then
        do j=1,ndim
           p(ihi,j)=pr(j)
        enddo
        y(ihi)=ypr
     endif
     do j=1,ndim
        prr(j)=beta*p(ihi,j)+(1.-beta)*pbar(j)
     enddo
     yprr=my_func(prr)
     if (press_error) return
     !
     if (yprr.lt.y(ihi)) then
        do j=1,ndim
           p(ihi,j)=prr(j)
        enddo
        y(ihi)=yprr
     else
        do i=1,mpts
           if (i.ne.ilo) then
              do j=1,ndim
                 pr(j)=0.5*(p(i,j)+p(ilo,j))
                 p(i,j)=pr(j)
              enddo
              y(i)=my_func(pr)
              if (press_error) return
              !
           endif
        enddo
     endif
  else
     do j=1,ndim
        p(ihi,j)=pr(j)
     enddo
     y(ihi)=ypr
  endif
  goto 1
end subroutine press_amoeba
!
subroutine press_powell(p,xi,n,np,ftol,iter,fret,my_func,my_f1dim)
  use sic_interfaces, except_this=>press_powell
  use sic_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: np                     !
  real :: p(np)                     !
  real :: xi(np,np)                 !
  integer :: n                      !
  real :: ftol                      !
  integer :: iter                   !
  real :: fret                      !
  real, external :: my_func         !
  real, external :: my_f1dim        !
  ! Local
  integer, parameter :: nmax=26
  real :: pt(nmax),ptt(nmax),xit(nmax)
  integer :: j,ibig,i
  real :: del,fp,fptt,t
  !
  press_error = .false.
  fret = my_func(p)
  if (press_error) return
  !
  do j=1,n
     pt(j)=p(j)
  enddo
  iter=0
  !
1 iter=iter+1
  fp=fret
  ibig=0
  del=0.
  do i=1,n
     do j=1,n
        xit(j)=xi(j,i)
     enddo
     call press_linmin(p,xit,n,fret,ftol,my_f1dim)
     if (press_error) return
     if (abs(fp-fret).gt.del) then
        del=abs(fp-fret)
        ibig=i
     endif
  enddo
  !
  if (2.*abs(fp-fret).le.ftol*(abs(fp)+abs(fret))) return
  if (iter.eq.press_itmax) then
     call sic_message(seve%i,'ADJUST','POWELL exceeds maximum iteration.')
     return
  endif
  do j=1,n
     ptt(j)=2.*p(j)-pt(j)
     xit(j)=p(j)-pt(j)
     pt(j)=p(j)
  enddo
  !
  fptt=my_func(ptt)
  if (press_error) return
  !
  if (fptt.ge.fp) goto 1
  t=2.*(fp-2.*fret+fptt)*(fp-fret-del)**2-del*(fp-fptt)**2
  if (t.ge.0.) goto 1
  call press_linmin(p,xit,n,fret,ftol,my_f1dim)
  if (press_error) return
  do j=1,n
     xi(j,ibig)=xit(j)
  enddo
  goto 1
end subroutine press_powell
!
subroutine press_linmin(p,xi,n,fret,ftol,my_f1dim)
  use sic_interfaces, except_this=>press_linmin
  use press_f1com
  use sic_adjust ! Is it compatible ?
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: p(n)                      !
  real :: xi(n)                     !
  real :: fret                      !
  real :: ftol                      !
  real, external :: my_f1dim        !
  ! Local
  integer :: j
  real :: ax,bx,xx,fa,fx,fb,xmin
  !
  ncom=n
  do j=1,n
     pcom(j)=p(j)
     xicom(j)=xi(j)
  enddo
  ax=0.
  xx=1.
  bx=2.
  call press_mnbrak(ax,xx,bx,fa,fx,fb,my_f1dim)
  if (press_error) return
  !
  fret = press_brent(ax,xx,bx,my_f1dim,ftol,xmin)
  if (press_error) return
  !
  do j=1,n
     xi(j)=xmin*xi(j)
     p(j)=p(j)+xi(j)
  enddo
end subroutine press_linmin
!
function press_brent(ax,bx,cx,my_f1dim,tol,xmin)
  use sic_interfaces, except_this=>press_brent
  use sic_adjust
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: press_brent               !
  real :: ax                        !
  real :: bx                        !
  real :: cx                        !
  real, external :: my_f1dim        !
  real :: tol                       !
  real :: xmin                      !
  ! Local
  integer, parameter :: itmx=100
  real, parameter :: cgold=.3819660, zeps=1.0e-6
  real :: a,b,v,w,x,e,fx,fv,fw,xm,tol1,tol2,r,q,p,d,etemp,u,fu
  integer :: iter
  !
  a=min(ax,cx)
  b=max(ax,cx)
  v=bx
  w=v
  x=v
  e=0.
  fx=my_f1dim(x)
  fv=fx
  fw=fx
  do iter=1,itmx
     xm=0.5*(a+b)
     tol1=tol*abs(x)+zeps
     tol2=2.*tol1
     if (abs(x-xm).le.(tol2-.5*(b-a))) goto 3
     if (abs(e).gt.tol1) then
        r=(x-w)*(fx-fv)
        q=(x-v)*(fx-fw)
        p=(x-v)*q-(x-w)*r
        q=2.*(q-r)
        if (q.gt.0.) p=-p
        q=abs(q)
        etemp=e
        e=d
        if (abs(p).ge.abs(.5*q*etemp).or.p.le.q*(a-x).or.p.ge.q*(b-x)) goto 1
        d=p/q
        u=x+d
        if (u-a.lt.tol2 .or. b-u.lt.tol2) d=sign(tol1,xm-x)
        goto 2
     endif
1    continue
     if (x.ge.xm) then
        e=a-x
     else
        e=b-x
     endif
     d=cgold*e
2    continue
     if (abs(d).ge.tol1) then
        u=x+d
     else
        u=x+sign(tol1,d)
     endif
     fu=my_f1dim(u)
     if (fu.le.fx) then
        if (u.ge.x) then
           a=x
        else
           b=x
        endif
        v=w
        fv=fw
        w=x
        fw=fx
        x=u
        fx=fu
     else
        if (u.lt.x) then
           a=u
        else
           b=u
        endif
        if (fu.le.fw .or. w.eq.x) then
           v=w
           fv=fw
           w=u
           fw=fu
        elseif (fu.le.fv .or. v.eq.x .or. v.eq.w) then
           v=u
           fv=fu
        endif
     endif
  enddo
  call sic_message(seve%i,'ADJUST','BRENT exceeds maximum iteration.')
  press_error = .true.
  press_brent = 0.0                  ! For completeness
  return
  !
3 xmin=x
  press_brent=fx
  return
end function press_brent
!
subroutine press_mnbrak(ax,bx,cx,fa,fb,fc,my_func)
  use sic_interfaces, except_this=>press_mnbrak
  use sic_adjust
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: ax                        !
  real :: bx                        !
  real :: cx                        !
  real :: fa                        !
  real :: fb                        !
  real :: fc                        !
  real, external :: my_func         !
  ! Local
  real, parameter :: gold=1.618034, glimit=100., tiny=1.e-20
  !
  real :: dum,r,q,u,ulim,fu
  fa=my_func(ax)
  if (press_error) return
  !
  fb=my_func(bx)
  if (press_error) return
  !
  if (fb.gt.fa) then
     dum=ax
     ax=bx
     bx=dum
     dum=fb
     fb=fa
     fa=dum
  endif
  cx=bx+gold*(bx-ax)
  fc=my_func(cx)
  if (press_error) return
  !
1 continue
  if (fb.ge.fc) then
     r=(bx-ax)*(fb-fc)
     q=(bx-cx)*(fb-fa)
     u=bx-((bx-cx)*q-(bx-ax)*r)/(2.*sign(max(abs(q-r),tiny),q-r))
     ulim=bx+glimit*(cx-bx)
     if ((bx-u)*(u-cx).gt.0.) then
        fu=my_func(u)
        if (press_error) return
        if (fu.lt.fc) then
           ax=bx
           fa=fb
           bx=u
           fb=fu
           goto 1
        elseif (fu.gt.fb) then
           cx=u
           fc=fu
           goto 1
        endif
        u=cx+gold*(cx-bx)
        fu=my_func(u)
        if (press_error) return
     elseif ((cx-u)*(u-ulim).gt.0.) then
        fu=my_func(u)
        if (press_error) return
        if (fu.lt.fc) then
           bx=cx
           cx=u
           u=cx+gold*(cx-bx)
           fb=fc
           fc=fu
           fu=my_func(u)
           if (press_error) return
        endif
     elseif ((u-ulim)*(ulim-cx).ge.0.) then
        u=ulim
        fu=my_func(u)
        if (press_error) return
     else
        u=cx+gold*(cx-bx)
        fu=my_func(u)
        if (press_error) return
     endif
     ax=bx
     bx=cx
     cx=u
     fa=fb
     fb=fc
     fc=fu
     goto 1
  endif
  return
end subroutine press_mnbrak
!
function press_f1dim(x)
  use press_f1com
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: press_f1dim               !
  real :: x                         !
  ! Global
  real, external :: press_func
  ! Local
  integer :: j
  real :: xt(nmax)
  !
  do j=1,ncom
     xt(j)=pcom(j)+x*xicom(j)
  enddo
  press_f1dim = press_func(xt)
end function press_f1dim

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_shift
  use gbl_message
  !
  public :: uv_shift_comm,uv_shift_header,uv_shift_data
  public :: map_get_radecang
  private
  !
contains
  !
subroutine uv_shift_comm(line,error)
  use phys_const
  use gkernel_types
  use gkernel_interfaces
  use mapping_read, only: check_uvdata_type
  use uv_buffers
  use uvmap_buffers, only: uvmap_prog
  !-------------------------------------------------------------------
  !  MAPPING
  !   Support routine for command
  !       UV_SHIFT  [Offx Offy [Angle]]
  !
  !   Phase shift a Mosaic or Single Dish UV Table to a new
  !   common phase center and orientation
  !     Offx OffY are offsets in ArcSec 
  !               (default 0,0)
  !     Angle     is the final position angle from North in Degree
  !               (default: no change)
  !
  !   Also called implicitely (with no command line arguments, i.e.
  !   no change of Phase Center unless the UV Table is with
  !   Phase Offsets )
  !   by command UV_MAP for Mosaics
  !-------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_SHIFT'
  character(len=message_length) :: mess
  real(kind=8) :: abso(2),rela(2),freq,angnew,angold
  real(kind=4) :: cs(2), costheta, sintheta, oldoffx, oldoffy
  real(kind=8), allocatable :: rpos(:,:)
  logical, parameter :: precise=.true.
  integer(kind=4) :: nc,nu,nv,i,iv,ier,loff,moff
  character(len=14) :: cra
  character(len=15) :: cdec
  !
  if (uvmap_prog%nfields.eq.0) then
    mess = 'UV table is a single field'
  elseif (uvmap_prog%nfields.lt.0) then
    write(mess,'(A,I0,A)')  &
      'UV table is an observed mosaic of ',-uvmap_prog%nfields,' fields, phase shifting...'
  elseif (uvmap_prog%nfields.gt.0) then
    write(mess,'(A,I0,A)')  &
      'UV table is already a phase-shifted mosaic of ',uvmap_prog%nfields,' fields, recentering...'
  endif
  call map_message(seve%i,rname,mess)
  !
  call uv_shift_center(line,abso,rela,angnew,error)
  if (error)  return
  ! Feedback
  call rad2sexa(abso(1),24,cra)
  call rad2sexa(abso(2),360,cdec)
  write(mess,'(5A,2(F6.2,A))')  'New phase center ',  &
    cra,' ',cdec,' (offsets ',rela(1)*sec_per_rad,' ',rela(2)*sec_per_rad,')'
  call map_message(seve%i,rname,mess)
  !
  if (uvmap_prog%nfields.ge.0) then
    ! Single field, or mosaic already in pointing offsets
    if (huv%gil%a0.eq.abso(1) .and. huv%gil%d0.eq.abso(2) .and. angnew.eq.huv%gil%pang) then
      call map_message(seve%w,rname,  &
        'UV table has already the desired phase center, nothing done')
      return
    endif
  endif
  !
  ! Store new absolute positions
  huv%gil%a0 = abso(1)
  huv%gil%d0 = abso(2)
  if (uvmap_prog%nfields.ne.0) then
    ! For mosaics, i.e. UVT with offset columns, these offsets (pointing offsets,
    ! and phase offsets if relevant) are relative to (a0,d0). (ra,dec) is purely
    ! informative => synced with (a0,d0) for clarity
    huv%gil%ra = huv%gil%a0
    huv%gil%dec = huv%gil%d0
    ! For non-mosaics, i.e. UVT without offset columns, (a0,d0) is the phase center,
    ! (ra,dec) is the pointing position => must not change
  endif
  !
  ! Compute observing frequency, and new phase center in wavelengths
  if (precise) then
    nc = huv%gil%nchan
    allocate(rpos(2,nc),stat=ier)
    do i=1,huv%gil%nchan
      freq = gdf_uv_frequency(huv,dble(i))
      rpos(1:2,i) = - freq * f_to_k * rela(1:2)
    enddo
  else
    nc = 1
    allocate(rpos(2,1),stat=ier)
    freq = gdf_uv_frequency(huv)
    rpos(1:2,1) = - freq * f_to_k * rela(1:2)
  endif
  !
  ! Define the rotation
  angold = huv%gil%pang
  huv%gil%pang = angnew
  !
  ! The minus in cs(2) follows from the definition of the postion angle in GILDAS
  ! For the Cosine no change in signal, for the Sine the sign must be reversed.
  cs(1) =  cos(huv%gil%pang-angold)
  cs(2) = -sin(huv%gil%pang-angold)
  !
  ! Recenter all channels, Loop over line table
  ! We work in place - We do not play with UV buffers
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi
  call uv_shift_data(huv,nu,nv,duv,cs,nc,rpos)
  !
  if (uvmap_prog%nfields.eq.0) then
    ! Done if Single Field
    return
    !
  elseif (uvmap_prog%nfields.lt.0) then
    ! Phase offsets mosaics
    !
    ! Offset columns description: convert columns kind
    loff = huv%gil%column_pointer(code_uvt_loff)
    moff = huv%gil%column_pointer(code_uvt_moff)
    !
    huv%gil%column_pointer(code_uvt_xoff) = loff
    huv%gil%column_pointer(code_uvt_yoff) = moff
    huv%gil%column_size(code_uvt_xoff) = 1
    huv%gil%column_size(code_uvt_yoff) = 1
    !
    huv%gil%column_pointer(code_uvt_loff) = 0
    huv%gil%column_pointer(code_uvt_moff) = 0
    huv%gil%column_size(code_uvt_loff) = 0
    huv%gil%column_size(code_uvt_moff) = 0
    !
    ! Offset columns data:
    do iv=1,nv
      duv(loff,iv) = duv(loff,iv) - rela(1)
      duv(moff,iv) = duv(moff,iv) - rela(2)
    enddo
    !
  elseif (uvmap_prog%nfields.gt.0) then
    ! Pointing offsets mosaics
    !
    ! Offset columns description: does not change
    loff = huv%gil%column_pointer(code_uvt_xoff)
    moff = huv%gil%column_pointer(code_uvt_yoff)
    !
    ! Offset columns data: shifted to new (a0,d0)
    do iv=1,nv
      duv(loff,iv) = duv(loff,iv) - rela(1)
      duv(moff,iv) = duv(moff,iv) - rela(2)
    enddo
    !
  endif
  !
  ! The correct thing to do is a reprojection, this rotation is just an approximation.
  costheta = cs(1)
  sintheta = cs(2)
  if (abs(cs(1)-1.).gt.1e-6) then
     do iv=1,nv
        oldoffx = duv(loff,iv)
        oldoffy = duv(moff,iv)
        duv(loff,iv) = costheta*oldoffx - sintheta*oldoffy
        duv(moff,iv) = sintheta*oldoffx + costheta*oldoffy
     enddo
  endif
  !
  ! Recompute the 'uvmap_prog' structure
  call check_uvdata_type(huv,duv,uvmap_prog,error)
end subroutine uv_shift_comm
!
subroutine uv_shift_center(line,abso,rela,angle,error)
  use phys_const
  use gkernel_types
  use gkernel_interfaces
  use uv_buffers
  use uvmap_buffers, only: uvmap_prog
  !---------------------------------------------------------------------
  ! Get relative and absolute positions from user inputs
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  real(kind=8),     intent(out)   :: abso(2)  ! [rad] New absolute position
  real(kind=8),     intent(out)   :: rela(2)  ! [rad] New relative position from old absolute position
  real(kind=8),     intent(out)   :: angle    ! [rad] New angle
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='UV_SHIFT'
  character(len=24) :: argum
  integer(kind=4) :: nc
  real(kind=8) :: vars(3),mean(2)
  logical :: dorela,found(3)
  type(projection_t) :: proj
  logical, parameter :: domean=.false.
  !
  ! ZZZ why -pang??? Seems it comes from this comment:
  !  "note Position Angle convention differ in GreG and astronomy"
  call gwcs_projec(huv%gil%a0,huv%gil%d0,-huv%gil%pang,huv%gil%ptyp,proj,error)
  if (error)  return
  !
  if (uvmap_prog%nfields.eq.0) then
    ! Not a mosaic
    mean(:) = 0.d0  ! Unused
  else
    ! Mosaic
    if (domean) then
      ! Use mean of all fields
      mean(:) = sum(uvmap_prog%offxy,dim=2)/abs(uvmap_prog%nfields)
    else
      ! Use center of all fields (center of map which contains all fields)
      mean(:) = (minval(uvmap_prog%offxy,dim=2) + maxval(uvmap_prog%offxy,dim=2))/2.d0
    endif
  endif
  !
  ! Get inputs from command line
  if (sic_present(0,1)) then
    ! Rigth ascension
    call sic_ch(line,0,1,argum,nc,.true.,error)
    if (error)  return
    if (index(argum,':').ne.0) then
      ! A sexagesimal string: asbolute RA position
      call sic_decode(argum,abso(1),24,error)
      if (error)  return
      dorela = .true.
    else
      ! Assume relative offset
      call sic_math_dble(argum,nc,rela(1),error)
      if (error)  return
      rela(1) = rela(1)*rad_per_sec
      ! In case of single field or pointing offset mosaic, offsets are
      ! relative to [A0,D0] => no additional correction
      ! In case of phase offset mosaic, offsets are relative from the mean
      ! mosaic center. This makes UV_SHIFT 0 0 behaves like UV_SHIFT (without
      ! arguments) => correct them as offsets relative to [A0,D0]
      if (uvmap_prog%nfields.lt.0)  rela(1) = rela(1)+mean(1)
      dorela = .false.
    endif
    !
    ! Declination
    call sic_ch(line,0,2,argum,nc,.true.,error)
    if (error)  return
    if (index(argum,':').ne.0) then
      ! A sexagesimal string: asbolute DEC position
      call sic_decode(argum,abso(2),360,error)
      if (error)  return
    else
      ! Assume relative offset
      call sic_math_dble(argum,nc,rela(2),error)
      if (error)  return
      rela(2) = rela(2)*rad_per_sec
      ! See comments for RA offsets
      if (uvmap_prog%nfields.lt.0)  rela(2) = rela(2)+mean(2)
    endif
    !
    if (dorela) then
      call abs_to_rel(proj,abso(1),abso(2),rela(1),rela(2),1)
    else
      call rel_to_abs(proj,rela(1),rela(2),abso(1),abso(2),1)
    endif
    !
    ! Angle (optional)
    angle = huv%gil%pang*deg_per_rad
    call sic_r8(line,0,3,angle,.false.,error)
    if (error)  return
    angle = angle*rad_per_deg
    !
    return
  endif
  !
  ! Get inputs from MAP_RA, MAP_DEC, MAP_ANGLE
  call sic_get_char('MAP_RA',argum,nc,error)
  if (error)  return
  if (argum.ne.' ') then
    call map_get_radecang(rname,found,vars,error)
    if (error)  return
    if (.not.all(found)) then
      call map_message(seve%e,rname,'MAP_RA and MAP_DEC are not all defined')
      error = .true.
      return
    endif
    !
    abso(1) = vars(1)
    abso(2) = vars(2)
    angle   = vars(3)
    call abs_to_rel(proj,abso(1),abso(2),rela(1),rela(2),1)
    !
    return
  endif
  !
  ! Define automatic inputs from data
  if (uvmap_prog%nfields.eq.0) then
    call map_message(seve%w,rname,'No automatic shift for single field') 
    ! No shift nor rotation by default
    abso(1) = huv%gil%a0
    abso(2) = huv%gil%d0
    rela(1) = 0.d0
    rela(2) = 0.d0
    angle   = huv%gil%pang
    !
  elseif (uvmap_prog%nfields.gt.0) then
    ! Already a common phase center: do not change it by default
    call map_message(seve%w,rname,'Mosaic already in pointing offsets, no automatic shift applied')
    ! No shift nor rotation by default
    abso(1) = huv%gil%a0
    abso(2) = huv%gil%d0
    rela(1) = 0.d0
    rela(2) = 0.d0
    angle   = huv%gil%pang
    !
  elseif (uvmap_prog%nfields.lt.0) then
    ! Compute the mean offset as common phase center position
    call map_message(seve%w,rname,'Phase offset mosaic shifted to mean offset')
    rela(:) = mean(:)
    call rel_to_abs(proj,rela(1),rela(2),abso(1),abso(2),1)
    angle = huv%gil%pang*deg_per_rad
    !
  endif
end subroutine uv_shift_center
!
subroutine map_get_radecang(rname,found,values,error)
  use phys_const
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Decode user inputs found in the Sic variables
  !   MAP_RA    [sexagesimal hour angle]
  !   MAP_DEC   [sexagesimal degrees]
  !   MAP_ANGLE [deg]
  ! Returned values are all radians. Also return a status indicating if
  ! the values were set or not.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname      !
  logical,          intent(out)   :: found(3)   !
  real(kind=8),     intent(out)   :: values(3)  !
  logical,          intent(inout) :: error      !
  ! Local
  character(len=24) :: ra_c,dec_c
  integer(kind=4) :: n
  !
  found(:) = .false.
  values(:) = 0.d0
  !
  call sic_get_char('MAP_RA',ra_c,n,error)
  if (error)  return
  found(1) = ra_c.ne.''
  if (found(1)) then
    call sic_decode(ra_c,values(1),24,error)
    if (error) then
      call map_message(seve%e,rname,'Error evaluating MAP_RA')
      return
    endif
  endif
  !
  call sic_get_char('MAP_DEC',dec_c,n,error)
  if (error)  return
  found(2) = dec_c.ne.''
  if (found(2)) then
    call sic_decode(dec_c,values(2),360,error)
    if (error) then
      call map_message(seve%e,rname,'Error evaluating MAP_DEC')
      return
    endif
  endif
  !
  call sic_get_dble('MAP_ANGLE',values(3),error)
  if (error)  return
  found(3) = .true.
  values(3) = values(3)*rad_per_deg
end subroutine map_get_radecang
!
subroutine uv_shift_header(new,ra,dec,ang,off,doit)
  use gkernel_interfaces
  use gkernel_types
  !-------------------------------------------------
  ! Compute shift parameters
  !-------------------------------------------------
  real(kind=8), intent(inout) :: new(3)   ! New phase center and angle
  real(kind=8), intent(in) :: ra,dec,ang  ! Old center and angle
  real(kind=8), intent(out) :: off(3)     ! Required Offsets and Angle
  logical, intent(inout) :: doit          ! Do shift
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec=(pi/180d0/3600d0)
  type(projection_t) :: proj
  logical :: error
  !
  if (.not.doit) return
  !
  ! Check phase center agreement to 0.001" and angle to 1"
  ! These should be customizable in MAPPING
  !
  if ( abs(new(1)-ra).lt.1d-3*sec .and.   &
     &    abs(new(2)-dec).lt.1d-3*sec .and.   &
     &    abs(new(3)-ang).lt.sec ) then
    new(1) = ra
    new(2) = dec
    new(3) = ang
    doit  = .false.
    return
  endif
  !
  off(1) = ra
  off(2) = dec
  off(3) = -ang                ! GreG convention
  error = .false.
  call gwcs_projec(ra,dec,-ang,3,proj,error)  ! Previous projection system
  call abs_to_rel (proj,new(1),new(2),off(1),off(2),1)  ! Offsets of new center
  off(3) = new(3)-ang          ! Additional rotation required
  if (abs(off(3)).lt.sec) off(3) = 0.d0
end subroutine uv_shift_header
!
subroutine uv_shift_data(hx,nu,nv,visi,cs,nc,xy)
  use phys_const
  use image_def
  use gkernel_interfaces
  use gkernel_types
  !$ use omp_lib
  !-------------------------------------------------------------------
  ! Shift phase center and apply U,V coordinates rotation if needed
  !-------------------------------------------------------------------
  type(gildas), intent(inout) :: hx   ! Input UV header
  integer, intent(in) :: nu           ! Size of a visibility
  integer, intent(in) :: nv           ! Number of visibilities
  real, intent(inout) :: visi(nu,nv)  ! Visibilities
  real, intent(in) :: cs(2)           ! Cos/Sin of Rotation
  integer, intent(in) :: nc           ! Number of Channels
  real(8), intent(in) :: xy(2,nc)     ! Position Shift per channel
  !
  integer(kind=index_length) :: i
  integer :: ix, iu, iv, jc, loff, moff
  real(8) :: phi, sphi, cphi, freq, x, y
  real :: u, v, reel, imag
  real(8), allocatable :: lm_uv(:)
  !
  iu = hx%gil%column_pointer(code_uvt_u)
  iv = hx%gil%column_pointer(code_uvt_v)
  !
  ! If there is a Phase offset column, use it
  !  integer(kind=4), parameter :: code_uvt_loff = 10 ! Phase center Offset
  !  integer(kind=4), parameter :: code_uvt_moff = 11 ! Phase center Offset
  loff = hx%gil%column_pointer(code_uvt_loff)
  moff = hx%gil%column_pointer(code_uvt_moff)
  !
  if (loff.ne.0 .or. moff.ne.0) then
    !
    ! Shift and Rotation of a per-field phase center to a common one
    !
    allocate(lm_uv(nc))
    if (nc.eq.1) then
      freq = gdf_uv_frequency(hx)
      lm_uv(1) = freq * f_to_k
    else
      do i=1,hx%gil%nchan
        freq = gdf_uv_frequency(hx,dble(i))
        lm_uv(i) = freq * f_to_k
      enddo
    endif
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(hx,nv,nc,cs,xy,loff,moff,lm_uv,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v,x,y,phi,cphi,sphi,jc,ix,reel,imag)
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
      !
      if (nc.eq.1) then
        x = xy(1,1) + lm_uv(1) * visi(loff,i)
        y = xy(2,1) + lm_uv(1) * visi(moff,i)
        phi = x*u + y*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      !
      do jc=1,hx%gil%nchan
        ix = hx%gil%fcol+(jc-1)*hx%gil%natom
        if (nc.gt.1) then
          x = xy(1,jc) + lm_uv(jc) * visi(loff,i)
          y = xy(2,jc) + lm_uv(jc) * visi(moff,i)
          phi = x*u + y*v
          cphi = cos(phi)
          sphi = sin(phi)
        endif
        reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
        imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
        visi(ix,i) = reel
        visi(ix+1,i) = imag
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
  else if (xy(1,1).eq.0. .and. xy(2,1).eq.0.) then
    !
    ! No shift, only rotation of U,V coordinates
    !
    if (cs(1).eq.1.0) return  ! No rotation either
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(nv,cs,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v)
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else
    !
    ! Shift and rotation of a common phase center
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(hx,nv,nc,cs,xy,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v,x,y,phi,cphi,sphi,jc,ix,reel,imag)
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
      !
      if (nc.eq.1) then
        phi = xy(1,1)*u + xy(2,1)*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      !
      do jc=1,hx%gil%nchan
        ix = hx%gil%fcol+(jc-1)*hx%gil%natom
        if (nc.gt.1) then
          phi = xy(1,jc)*u + xy(2,jc)*v
          cphi = cos(phi)
          sphi = sin(phi)
        endif
        reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
        imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
        visi(ix,i) = reel
        visi(ix+1,i) = imag
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine uv_shift_data
end module uv_shift
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubefitsio_image_read
  use cfitsio_api
  use cubefitsio_header
  use cubefitsio_messaging
  !---------------------------------------------------------------------
  ! Support module to read FITS 'images' (e.g. 2D images or 3D cubes)
  !---------------------------------------------------------------------

  public :: cubefitsio_image_open,cubefitsio_image_dataread
  private

contains

  subroutine cubefitsio_image_open(hfits,filename,id,error)
    use gkernel_interfaces
    use cubetools_parameters
    !-------------------------------------------------------------------
    ! Open an old IMAGE-FITS file from disk.
    !-------------------------------------------------------------------
    type(fitsio_header_t), intent(inout) :: hfits
    character(len=*),      intent(in)    :: filename  ! Note: HDU stored in hfits%hdunum
    character(len=*),      intent(in)    :: id  ! Some identifier string
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>OPEN'
    integer(kind=4) :: status
    !
    call hfits%open(filename,id,error)
    if (error)  return
    !
    status = 0
    call ftmahd(hfits%unit,hfits%hdunum,hfits%hdutype,status)
    if (cubefitsio_error(rname,status,error))  return
  end subroutine cubefitsio_image_open
  !
#if defined(CFITSIO420)
  subroutine cubefitsio_image_dataread(hfits,data,iblc,itrc,error)
    use gkernel_interfaces
    use cubetools_parameters
    use cubetools_nan
    use cubefitsio_image_utils
    !-------------------------------------------------------------------
    ! Read a contiguous piece of data from the input file
    !-------------------------------------------------------------------
    type(fitsio_header_t),            intent(in)    :: hfits
    real(kind=4), contiguous, target, intent(out)   :: data(:,:,:)
    integer(kind=index_length),       intent(in)    :: iblc(maxdim)
    integer(kind=index_length),       intent(in)    :: itrc(maxdim)
    logical,                          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>DATAREAD'
    integer(kind=4) :: status,group
    real(kind=4) :: nullval
    logical :: anynull
    character(len=mess_l) :: mess
    real(kind=4), pointer :: data1(:)
    integer(kind=size_length) :: fpixel,nelements,ielem
    integer(kind=index_length) :: blc(maxdim),trc(maxdim)
    !
    call cubefitsio_message(fitsioseve%trace,rname,'Welcome')
    !
    call cubefitsio_image_dataoffset(hfits,iblc,itrc,blc,trc,  &
                                     fpixel,nelements,error)
    if (error)  return
    !
    ! Sanity check
    if (size(data,kind=size_length).lt.nelements) then
      ! Note that it is OK to receive a buffer which is too large. It is
      ! the responsibility of the caller to know that not all the buffer
      ! filled (thanks to blc/trc). This is the case in particular when
      ! reading by blocks: the last block is not shrinked before reading.
      write(mess,'(2(a,i0))')  'Internal error: trying to read ',nelements,  &
        ' values in a buffer of size ',size(data,kind=size_length)
      call cubefitsio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    !
    call cubefitsio_message(fitsioseve%others,rname,'Reading data with CFITSIO')
    ! nullval = 0       ! => No check for undefined values
    nullval = huge(1.)  ! => Undefined values returned with nullval
    group = 1
    status = 0
    call ftgpvell(hfits%unit,group,fpixel,nelements,nullval,  &
                  data,anynull,status)
    if (cubefitsio_error(rname,status,error))  return
    !
    ! Patch for NULL values: more computation cost, but necessary for BITPIX > 0
    if (anynull) then
      call cubefitsio_message(fitsioseve%others,rname,'Patching NULL values to NaN')
      data1(1:nelements) => data
      do ielem=1,nelements
        if (data1(ielem).eq.nullval)  data1(ielem) = gr4nan
      enddo
    endif
  end subroutine cubefitsio_image_dataread
#else /* CFITSIO420 */
  subroutine cubefitsio_image_dataread(hfits,data,iblc,itrc,error)
    use gkernel_interfaces
    use cubetools_parameters
    use cubetools_nan
    use cubefitsio_image_utils
    !-------------------------------------------------------------------
    ! OBSOLESCENT IMPLEMENTATION WITH INCORRECT USE OF BINTABLE API TO
    ! READ LARGE (>2GB) IMAGE HDUS, MEMORY GREEDY BECAUSE OF THE FLAGS
    ! ARRAY FOR BITPIX>0.
    !-------------------------------------------------------------------
    type(fitsio_header_t),            intent(in)    :: hfits
    real(kind=4), contiguous, target, intent(out)   :: data(:,:,:)
    integer(kind=index_length),       intent(in)    :: iblc(maxdim)
    integer(kind=index_length),       intent(in)    :: itrc(maxdim)
    logical,                          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMAGE>DATAREAD'
    integer(kind=4) :: status,group,ier
    ! real(kind=4) :: nullval
    logical, allocatable :: flags(:)
    logical :: anynull
    character(len=mess_l) :: mess
    real(kind=4), pointer :: data1(:)
    integer(kind=size_length) :: nelements,ielem
    integer(kind=4) :: naxis,naxes(maxdim),fpixels(maxdim),  &
                       lpixels(maxdim),incs(maxdim)
    !
    call cubefitsio_message(fitsioseve%trace,rname,'Welcome')
    !
    call cubefitsio_image_subset(hfits,iblc,itrc,  &
      naxis,naxes,fpixels,lpixels,incs,nelements,error)
    if (error)  return
    !
    ! Sanity check
    if (size(data,kind=size_length).lt.nelements) then
      ! Note that it is OK to receive a buffer which is too large. It is
      ! the responsibility of the caller to know that not all the buffer
      ! filled (thanks to blc/trc). This is the case in particular when
      ! reading by blocks: the last block is not shrinked before reading.
      write(mess,'(2(a,i0))')  'Internal error: trying to read ',nelements,  &
        ' values in a buffer of size ',size(data,kind=size_length)
      call cubefitsio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    status = 0
    group = 1
    !
    ! ---
    ! No patch for NULL values
    ! nullval = 0  ! => No check for undefined values
    ! call ftgpve(hfits%unit,group,fpixel,nelements,nullval,data,anynull,status)
    ! if (cubefitsio_error(rname,status,error))  return
    !
    ! Patch for NULL values: more memory and computation cost, but necessary
    ! for BITPIX > 0
    call cubefitsio_message(fitsioseve%others,rname,'Allocating flags array')
    allocate(flags(nelements),stat=ier)
    if (failed_allocate(rname,'FLAGS',ier,error))  return
    !
    ! ---
    ! PROBLEM: FTGPFE needs fpixel and nelements to be be I*4, i.e. limited
    ! to 2**31-1
    ! call ftgpfe(hfits%unit,group,fpixel,nelements,data,flags,anynull,status)
    ! if (cubefitsio_error(rname,status,error))  return
    !
    ! ---
    ! Use FTGSFE which is able to deal with more than 2**31 elements to
    ! read, as long as the individual dimensions are below this limit (i.e. I*4)
    call cubefitsio_message(fitsioseve%others,rname,'Reading data with CFITSIO')
    call ftgsfe(hfits%unit,group,naxis,naxes,fpixels,lpixels,incs,  &
                data,flags,anynull,status)
    if (cubefitsio_error(rname,status,error))  return
    !
    ! Patch NULL values
    call cubefitsio_message(fitsioseve%others,rname,'Patching NULL values to NaN')
    if (anynull) then
      data1(1:nelements) => data
      do ielem=1,nelements
        if (flags(ielem))  data1(ielem) = gr4nan
      enddo
    endif
    deallocate(flags)
  end subroutine cubefitsio_image_dataread
#endif /* CFITSIO420 */
end module cubefitsio_image_read

program map_sum
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compute an "integrated intensity" map
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: mapdata,mapsort
  integer(kind=4) :: nc(2), naver
  real(kind=4) :: velo(2),dv
  real(kind=8) :: xposi,yposi
  logical :: error
  type(gildas) :: x,y
  integer(kind=size_length) :: nd                 !
  integer(kind=4) :: ier
  !
  ! Code:
  call gildas_open
  call gildas_char('INPUT_MAP$',mapdata)
  call gildas_char('OUTPUT_MAP$',mapsort)
  call gildas_real('VELOCITY$',velo,2)
  call gildas_close
  !
  ! Input file
  call gildas_null(y)
  y%gil%form = fmt_r4
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapdata,'.lmv',error, data=.false.) 
  if (error) then
    call gagout('F-MAP_COMPRESS,  Cannot read input data cube')
    goto 999
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapsort,x%file,' ','.lmv')
  !
  ! Define number of channels
  nc(:) = nint((velo(:) - y%gil%val(3)) / y%gil%inc(3) + y%gil%ref(3))
  if (y%gil%inc(3).lt.0.0) then
    nc(1:2) = nc(2:1:-1)
  endif
  if (velo(1).eq.0) then
    nc(1) = 1
  else
    nc(1) = min(max(1,nc(1)),y%gil%dim(3))
  endif
  if (velo(2).eq.0) then
    nc(2) = y%gil%dim(3)
  else
    nc(2) = min(max(1,nc(2)),y%gil%dim(3))
  endif
  naver = nc(2)-nc(1)+1
  !
  ! Build a pseudo axis aligned on the input one:
  !  - Number of channels set to 1,
  !  - Increment set to the extracted range,
  !  - Value at reference unchanged (same spectroscopic axis, e.g. regarding
  !    associated Rest Freq),
  !  - Center of averaged range (old axis) is aligned on the center of the
  !    output channel #1 (new axis)
  ! This writes as:
  x%gil%dim(3) = 1
! x%gil%val(3) = unchanged
  yposi = (nc(1)+nc(2))*0.5d0
  xposi = 1.d0
  x%gil%inc(3) = y%gil%inc(3)*naver
  x%gil%ref(3) = xposi - (yposi-y%gil%ref(3))/naver
  ! Do not forget the SPECTRO section
  x%gil%vres = y%gil%vres*naver
  x%gil%fres = y%gil%fres*naver
! x%gil%voff = unchanged
! x%gil%freq = unchanged
! x%gil%fima = unchanged
  !
  x%loca%size = x%gil%dim(1)*x%gil%dim(2)
  if (y%char%code(3).eq.'VELOCITY') then
    x%char%unit = trim(y%char%unit)//'.km/s'
  elseif (y%char%code(3).eq.'FREQUENCY') then
    x%char%unit = trim(y%char%unit)//'.MHz'
  else
    x%char%unit = 'UNKNOWN'
  endif
  x%gil%extr_words = 0
  call gdf_create_image(x,error)
  if (error) goto 999
  !
  allocate(x%r2d(x%gil%dim(1),x%gil%dim(2)),  &
           y%r3d(x%gil%dim(1),y%gil%dim(2),nc(2)-nc(1)+1),  &
           stat=ier)
  if (ier.ne.0) goto 999
  !
  y%blc(3) = nc(1)
  y%trc(3) = nc(2)
  call gdf_read_data(y,y%r3d,error)
  if (error) goto 999
  !
  dv = abs(y%gil%inc(3))
  nd = x%gil%dim(1)*x%gil%dim(2)
  call compress (y%r3d,nd,x%r2d,naver,dv,y%gil%bval,y%gil%eval)
  call gdf_write_data(x,x%r2d,error)
  if (error) goto 999
  call gagout('S-MAP_SUM,  Successful completion')
  call sysexi(1)
999 call sysexi(fatale)
end program map_sum
!
subroutine compress (in,n,out,nc,dv,bval,eval)
  use gildas_def
  integer(kind=size_length), intent(in)  :: n         ! Number of pixels
  integer(kind=4),           intent(in)  :: nc        ! Number of channels
  real(kind=4),              intent(in)  :: in(n,nc)  ! Input cube
  real(kind=4),              intent(out) :: out(n)    ! Output map
  real(kind=4),              intent(in)  :: dv        ! Channel width
  real(kind=4),              intent(in)  :: bval,eval ! Blanking
  ! Local
  integer(kind=size_length) :: ii
  integer(kind=4) :: ic
  integer(kind=1) :: mask(n)  ! Automatic array
  !
  if (eval.lt.0.) then
    out(:) = in(:,1)
    do ic=2,nc
      out(:) = out(:) + in(:,ic)
    enddo
    out(:) = out(:)*dv
  else
    out(:) = 0.
    mask(:) = 1
    do ic=1,nc
      do ii=1,n
        if (abs(in(ii,ic)-bval).gt.eval) then
          out(ii) = out(ii) + in(ii,ic)
          mask(ii) = 0
        endif
      enddo
    enddo
    out(:) = out(:)*dv
    where (mask.eq.1)
      out = bval
    endwhere
  endif
  !
end subroutine compress

subroutine liste(line,error)
  use gildas_def
  use gkernel_types
  use gkernel_interfaces
  use clic_file
  use clic_title
  use clic_index 
  !---------------------------------------------------------------------
  ! CLIC 	Internal routine
  !	Liste breve,normale ou longue d'un ensemble d'observations
  !	Construit par find (LIST)
  !	Tout le fichier d'entree (LIST IN[file])
  !	Tout le fichier de sortie (LIST OU[tfile])
  !	LIST OUT supported except for LONG
  !	/OUTPUT File	Send to a file
  !	/FLAGS  (4)
  !	/SHORT	(5)
  !	/PROJECT (6)
  !       /SOURCE   (7)
  !       /VARIABLE (8) [/FORMAT (9)]
  ! Arguments :
  !	LINE	C*(*)	Command line			Input
  !	ERROR	L	Logical error flag		Output
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  integer :: p_lun
  character(len=1) :: type1
  character(len=80) :: snam,filnam
  common /ciout/ p_lun,type1,filnam
  type(title_v2_t) :: title_save
  !
  logical :: in,out,brief,long,print,flag, short, format, variable,mem
  logical :: flagged
  integer :: isave
  integer :: lchain, j, tnum, tver, lch
  integer(kind=entry_length) :: k,kmax,kk
  character(len=80) :: chaine, ch
  !
  integer :: mproje
  parameter (mproje=32)
  integer :: nproje,jproje(mproje),ifo, nch
  character(len=8) :: cproje(mproje),cprojec
  logical :: lproje
  !
  integer :: msour
  parameter (msour=1024)
  integer :: nsour, jsour(msour)
  character(len=12) :: csour(msour), csourc
  logical :: lsour
  integer :: mtele
  parameter (mtele = 32)
  integer :: ntele, jtele(mtele)  
  character(len=12) :: ctele(mtele), cteles
  logical :: ltele
  integer :: moffpos
  parameter (moffpos=256)
  integer :: noffpos, joffpos(moffpos)
  real :: off_pos(2,moffpos)
  logical :: loff
  logical :: band
  !
  integer :: nv, mv, level
  parameter (mv=100)
  character(len=64) :: arg
  character(len=12) :: form(mv)
  integer(kind=address_length) :: addr(mv), type(mv)
  type(sic_descriptor_t) :: desc
  logical :: found
  integer(kind=index_length) :: dim(4)
  !
  save nsour,csour
  save nproje,cproje
  save ntele,ctele
  save noffpos, off_pos
  !
  integer :: mg
  parameter (mg=1000)
  integer :: ng, sg(2,mg)
  common/scan_group/ng, sg
  save /scan_group/
  !
  integer :: mvoc1, nkey
  parameter (mvoc1=3)
  character(len=12) :: kw, voc1(mvoc1)
  data voc1/'IN','OUT','*'/
  !
  data nproje/0/
  data nsour/0/
  !------------------------------------------------------------------------
  !
  ! Verify if any input file
  !
  kw = '*'
  call clic_kw(line,0,1,kw,nkey,voc1,mvoc1,.false.,error,.true.)
  if (error) goto 999
  in  = kw.eq.'IN'
  out = kw.eq.'OUT'
  !
  if (.not.in .and. .not.out) then
    call check_index(error)
    if (error) goto 999
  endif
  if (in) call check_input_file(error)
  if (out) call check_output_file(error)
  if (error) goto 999
  !
  ! options:
  brief = sic_present(1,0)
  long = sic_present(2,0) .and. .not.brief
  print = sic_present(3,0)
  flag = sic_present(4,0)
  short = sic_present(5,0)
  lproje = sic_present(6,0)
  lsour = sic_present(7,0) .and. .not.lproje
  ltele = sic_present(12,0).and. .not.lproje .and. .not.lsour 
  loff = sic_present(10,0) .and. .not.lproje .and. .not.lsour .and..not.ltele
  variable = sic_present(8,0)
  format = variable .and. sic_present(9,0)
  mem = sic_present(11,0)
  band = sic_present(13,0)
  if (band) then
    call list_bandpass(error)
    return
  endif
  !
  ! no printout for /SOURCE or /PROJECT
  print = print .and. .not.lsour .and. .not.lproje
  !
  call sic_delvariable('N_GROUP',.false.,error)
  call sic_delvariable('S_GROUP',.false.,error)
  error = .false.
  ng = 0
  do j=1, mg
    sg(1,j) = 0
    sg(2,j) = 0
  enddo
  if (lproje) then
    if (brief .or. long .or. flag .or. print) then
      call message(6,3,'LISTE','Incompatible options')
      goto 999
    endif
    call sic_delvariable('N_PROJECT',.false.,error)
    call sic_delvariable('C_PROJECT',.false.,error)
    error = .false.
    nproje = 0
    do j=1,mproje
      jproje(j) = 0
    enddo
  elseif (lsour) then
    if (brief .or. long .or. flag .or. print) then
      call message(6,3,'LISTE','Incompatible options')
      goto 999
    endif
    call sic_delvariable('N_SOURCE',.false.,error)
    call sic_delvariable('C_SOURCE',.false.,error)
    error = .false.
    nsour = 0
    do j=1,msour
      jsour(j) = 0
    enddo
  elseif (ltele) then
    if (brief .or. long .or. flag .or. print) then
      call message(6,3,'LISTE','Incompatible options')
      goto 999
    endif
    call sic_delvariable('N_TELESCOPE',.false.,error)
    call sic_delvariable('C_TELESCOPE',.false.,error)
    error = .false.
    ntele = 0
    do j=1,mtele
      jtele(j) = 0
    enddo
  elseif (loff) then
    if (brief .or. long .or. flag .or. print) then
      call message(6,3,'LISTE','Incompatible options')
      goto 999
    endif
    call sic_delvariable('N_OFFPOS',.false.,error)
    call sic_delvariable('OFF_POS',.false.,error)
    error = .false.
    noffpos = 0
    do j=1,moffpos
      joffpos(j) = 0
    enddo
  endif
  !
  ! Output file
  if (print) then
    call sic_ch(line,3,1,snam,nch,.true.,error)
    if (error) goto 999
    call sic_parsef(snam,filnam,' ','.lis')
    call out0('File',0,0,error)
    if (error) return
  else
    call out0('Terminal',0,0,error)
  endif
  !
  ! Variables and associated formats
  if (variable) then
    nv = 0
    do j=1, sic_narg(8)
      call sic_ke(line,8,j,arg,nch,.true.,error)
      if (error) return
      call sic_descriptor (arg,desc,found)
      if (.not.found) then
        call message(6,2,'LISTE',arg(1:nch)//' undefined')
      elseif (nv.lt.mv) then
        nv = nv+1
        type(nv) = desc%type
        addr(nv) = desc%addr
        form(nv) = '*'
        if (j.le.sic_narg(9)) then
          call sic_ke(line,9,j,arg,nch,.true.,error)
          if (error) return
          if (arg(1:1).ne.'*') then
            form(nv) = '('//arg(1:nch)//')'
          endif
        endif
      else
        call message(6,2,'LISTE',arg(1:nch)//' ignored')
      endif
    enddo
  endif
  !
  if (in) then
    kmax = i%desc%xnext-1
    if (kmax.le.0) then
      call message(1,1,'LISTE','Input file is empty')
      return
    elseif (.not.print) then
      call message(1,1,'LISTE','Input file contains :')
    endif
  elseif (out) then
    kmax = o%desc%xnext-1
    if (kmax.le.0) then
      call message(1,1,'LISTE','Output file is empty')
      return
    elseif (.not.print) then
      call message(1,1,'LISTE','Output file contains :')
    endif
  else
    kmax = cxnext - 1
    if (kmax.le.0) then
      call message(1,1,'LISTE','Current index is empty')
      return
    elseif (.not.print .and. .not.flag) then
      call message(1,1,'LISTE','Current index :')
    endif
  endif
  !
  ! loop on index entries
  !
  title_save = title
  !
  flagged = .false.
  lchain = 1
  level = 6
  call message_level(level)
  do k = 1,kmax
    kk=k
    !
    ! Brief: all is available
    ! may be scan numbers instead ?
    if (brief) then
      if (in) then
        tnum = ix_num(k)
        tver = ix_ver(k)
      elseif (out) then
        tnum = ox_num(k)
        tver = ox_ver(k)
      else
        tnum = cx_num(k)
        tver = cx_ver(k)
      endif
      if (lchain.gt.69) then
        call outlin(chaine,lchain-1)
        lchain = 1
      endif
      tver = abs(tver)
      write(chaine(lchain:),1006) tnum,tver
1006  format(i6,';',i3)
      lchain=lchain+12
    !
    ! Long (only input file)
    elseif (long .and. .not.out) then
      if (.not.in) kk = cx_ind(k)
      call get_num(kk,error)
      if (error) goto 100
      ! Duplicate Index information for TITOUT (was missing before)
      title%num = r_num
      title%ver = r_ver
      title%dobs =r_dobs
      title%dred = r_dred
      title%typec =r_typec
      title%kind = r_kind
      title%qual = r_qual
      title%scan = r_scan
      title%recei = r_nrec
      call chtoby(r_project,title%project,8)
      call chtoby(r_teles,title%teles,12)
      call titout ('Long',error)
      write(p_lun,'(1x,a)') ' '
    !
    ! Normal or /project or  /Flag or /Source or /VARIABLE
    else
      if (in) then
        call rix(k,error)
      elseif (out) then
        call rox(k,error)
      else
        kk = cx_ind(k)
        call rix(kk,error)
      endif
      if (error) go to 100
      if (short .and. .not.variable) then
        call titout('Short',error)
      ! Flags
      elseif (flag) then
        if (.not.in) then
          kk = cx_ind(k)
        else
          kk = k
        endif
        isave = 5
        call message_level(isave)
        call get_num(kk,error)
        if (error) goto 100
        call message_level(isave)
        call list_all_flags (p_lun,flagged,mem,error)
        if (error) goto 998
      ! Project
      elseif (lproje) then
        call bytoch(title%project,cprojec,8)
        ifo = 0
        do j=1,nproje
          if (cprojec.eq.cproje(j)) then
            ifo = j
            jproje(j) = jproje(j)+1
          endif
        enddo
        if (ifo.eq.0) then
          nproje = nproje+1
          cproje(nproje) = cprojec
          jproje(nproje) = 1
        endif
      ! Source
      elseif (lsour) then
        call bytoch(title%sourc,csourc,12)
        ifo = 0
        do j=1,nsour
          if (csourc.eq.csour(j)) then
            ifo = j
            jsour(j) = jsour(j)+1
          endif
        enddo
        if (ifo.eq.0) then
          nsour = nsour+1
          csour(nsour) = csourc
          jsour(nsour) = 1
        endif
      elseif (ltele) then
        call bytoch(title%teles,cteles,12)
        ifo = 0
        do j=1,ntele
          if (cteles.eq.ctele(j)) then
            ifo = j
            jtele(j) = jtele(j)+1
          endif
        enddo
        if (ifo.eq.0) then
          ntele = ntele+1
          ctele(ntele) = cteles
          jtele(ntele) = 1
        endif
      elseif (loff) then
        ifo = 0
        do j=1,noffpos
          if (title%off1.eq.off_pos(1,j).and.title%off2.eq.off_pos(2,j))   &
            then
            ifo = j
            joffpos(j) = joffpos(j)+1
          endif
        enddo
        if (ifo.eq.0) then
          noffpos = noffpos+1
          off_pos(1,noffpos) = title%off1
          off_pos(2,noffpos) = title%off2
          joffpos(noffpos) = 1
        endif
      elseif (variable) then
        if (.not.in) kk = cx_ind(k)
        call get_num(kk,error)
        if (error) goto 100
        call vartitout(short,r_scan,   &
          nv,type,addr,form,.false.,error)
      else
        call titout('Normal',error)
      endif
      if (error) return
    endif
    if (sic_ctrlc()) then
      error = .true.
      goto 101
    endif
100 error = .false.
  enddo
  !
  ! Close
  if (lchain.gt.1) call outlin(chaine,lchain)
  if (flag .and. .not.flagged) call outlin('No flags',8)
  call message_level(level)
  !
101 continue
  if (lproje) then
    isave = 5
    call message_level(isave)
    do j=1,nproje
      write(snam,'(A,I2,4X,A,I5,A)') 'Project #',j,cproje(j),   &
        jproje(j),' Observations'
      call message(5,1,'LISTE',snam)
    enddo
    call message_level(isave)
    call sic_def_inte('N_PROJECT',nproje,0,1,.true.,error)
    call sic_def_charn('C_PROJECT',cproje,1,nproje,.true.,   &
      error)
  elseif (lsour) then
    isave = 5
    call message_level(isave)
    do j=1,nsour
      write(snam,'(A,I3,4X,A,I5,A)') 'Source #',j,csour(j),   &
        jsour(j),' Observations'
      call message(5,1,'LISTE',snam)
    enddo
    call message_level(isave)
    call sic_def_inte('N_SOURCE',nsour,0,1,.true.,error)
    call sic_def_charn('C_SOURCE',csour,1,nsour,.true.,   &
      error)
  elseif (ltele) then
    isave = 5
    call message_level(isave)
    do j=1,ntele
      write(snam,'(A,I3,4X,A,I5,A)') 'Telescope #',j,ctele(j),   &
        jtele(j),' Observations'
      call message(5,1,'LISTE',snam)
    enddo
    call message_level(isave)
    call sic_def_inte('N_TELESCOPE',ntele,0,1,.true.,error)
    call sic_def_charn('C_TELESCOPE',ctele,1,ntele,.true.,   &
      error)
  elseif (loff) then
    isave = 5
    call message_level(isave)
    do j=1,noffpos
      call offsec(off_pos(1,j),ch(1:),error)
      lch = 7
      call offsec(off_pos(2,j),ch(lch+1:),error)
      lch = lch+7
      write(snam,'(A,I3,4X,a,I5,A)') 'Offset Position #',j,   &
        ch(1:lch),   &
        joffpos(j),' Observations'
      call message(5,1,'LISTE',snam)
    enddo
    call message_level(isave)
    call sic_def_inte('N_OFFPOS',noffpos,0,1,.true.,error)
    dim(1) = 2
    dim(2) = noffpos
    call sic_def_real('OFF_POS',off_pos,2,dim,.true.,error)
  else
    if (short) then
      if (variable) then
        call vartitout(short,r_scan,nv,type,addr,form,.true.,error)
      else
        call titout('Zhort',error)
      endif
    endif
    if (error) return
    call out1(error)
    call sic_def_inte('N_GROUP',ng,0,1,.true.,error)
    dim(1) = 2
    dim(2) = ng
    call sic_def_inte('S_GROUP',sg,2,dim,.true.,error)
    if (print.and..not.error) then
      call message(2,1,'LISTE','List on file '   &
        //filnam(1:lenc(filnam)))
    endif
  endif
  !
  ! recupere le titre court
998 continue
  title = title_save
  return
  !
999 error = .true.
end subroutine liste
!
subroutine list_all_flags(lun,flagged,mem,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_index
  !---------------------------------------------------------------------
  ! List flagged data from scan in R on unit LUN
  ! set FLAGGED logical if flags were found.
  !---------------------------------------------------------------------
  integer :: lun                    !
  logical :: flagged                !
  logical :: mem                    !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: data_in, kin, ipk
  integer(kind=data_length)    :: ndata
  integer :: oldaf(mnant), oldbf(mnbas), i, ir, j
  logical :: oldsa(2*mbands,mnant), oldsb(2*mbands,mnbas)
  integer :: ir1, ir2
  logical :: dum_saflag(2*mbands,mnant),dum_sbflag(2*mbands,mnbas)
  logical :: change, f
  character(len=1024) :: out
  !------------------------------------------------------------------------
  ! Code:
  f = .false.
  dum_saflag = .false.
  dum_sbflag = .false.
  if (mem) then
    call list_flags(r_nant,r_nbas,ix_aflag(1,r_xnum),ix_bflag(1,r_xnum),&
        dum_saflag,dum_sbflag,out)
    if (out(1:2).ne.'no') then
      write(lun,'(a,i4,a,i0,a)') '--- Scan ',r_scan,' Rec ',r_nrec,&
                ' flagged ---'
      write(lun,1001,err=998) out(1:lenc(out))
      f = .true.
    endif 
    flagged = flagged .or. f
    return
  endif
  call get_data (ndata,data_in,error)
  if (error) goto 999
  kin = data_in + r_ndump*r_ldump*4
  ipk = gag_pointer(kin,memory)
  call decode_header (memory(ipk))
  call list_flags(r_nant,r_nbas,dh_aflag,dh_bflag,&
     dh_saflag,dh_sbflag,out)
  if (out(1:2).ne.'no') then
    write(lun,'(a,i4,a,i0,a)') '--- Scan ',r_scan,' Rec ',r_nrec,' flagged ---'
    write(lun,1001,err=998) out(1:lenc(out))
    f = .true.
  endif
  !
  ! Loop on records
  do ir = 1, r_ndump
    kin = data_in + (ir-1)*r_ldump*4
    ipk = gag_pointer(kin,memory)
    call decode_header (memory(ipk))
    change = .false.
    if (ir.eq.1) then
      do i=1, r_nant
        oldaf(i) = dh_aflag(i)
        do j=1, 2*mbands
          oldsa(j,i) = dh_saflag(j,i)
        enddo
      enddo
      do i=1, r_nbas
        oldbf(i) = dh_bflag(i)
        do j=1, 2*mbands
          oldsb(j,i) = dh_sbflag(j,i)
        enddo
      enddo
      ir1 = 1
    else
      do i=1, r_nant
        change = change.or.dh_aflag(i).ne.oldaf(i)
        do j=1, 2*mbands
          change = change.or.dh_saflag(j,i).neqv.oldsa(j,i)
        enddo
      enddo
      do i=1, r_nbas
        change = change.or.dh_bflag(i).ne.oldbf(i)
        do j=1, 2*mbands
          change = change.or.dh_sbflag(j,i).neqv.oldsb(j,i)
        enddo
      enddo
    endif
    if (change .or. ir.eq.r_ndump) then
      ir2 = ir-1
      if (.not.change) ir2 = ir
      call list_flags(r_nant,r_nbas,oldaf,oldbf,oldsa,oldsb,out)
      if (out(1:2).ne.'no') then
        if (.not.f) then
          write(lun,'(a,i4,a,i0,a)')   &
            '--- Scan ',r_scan,' Rec ',r_nrec,' flagged ---'
          f = .true.
        endif
        write(lun,1000,err=998) ir1, ir2, out(1:lenc(out))
      endif
      if (change.and.ir.eq.r_ndump) then
        call list_flags(r_nant,r_nbas,dh_aflag,dh_bflag, &
          dh_saflag,dh_sbflag,out)
        if (out(1:2).ne.'no') then
          if (.not.f) then
            write(lun,'(a,i4,a,i0,a)')   &
              '--- Scan ',r_scan,' Rec ',r_nrec,' flagged ---'
            f = .true.
          endif
          write(lun,1000,err=998) r_ndump, r_ndump, out(1:lenc(out))
        endif
      endif
      do i=1, r_nant
        oldaf(i) = dh_aflag(i)
        do j=1, 2*mbands
          oldsa(j,i) = dh_saflag(j,i)
        enddo
      enddo
      do i=1, r_nant
        oldbf(i) = dh_bflag(i)
        do j=1, 2*mbands
          oldsb(j,i) = dh_sbflag(j,i)
        enddo
      enddo
      ir1 = ir
    endif
  enddo
  flagged = flagged .or. f
  return
  !
998 call message(6,3,'LIST_ALL_FLAGS','Write error')
999 error = .true.
  return
1000 format(' Records ',i3,' to ',i3,' - ',a)
1001 format(' Average Record - ',a)
end subroutine list_all_flags
!
subroutine list_bandpass(error)
  use gkernel_interfaces
  use clic_file
  use clic_title
  use clic_index
  use clic_find
  !
  logical :: error
  !
  include 'clic_proc_par.inc'
  !
  type(title_v2_t) :: title_save
  integer(kind=entry_length),allocatable :: cx_num_sav(:),cx_ind_sav(:)
  integer(kind=8),allocatable ::cx_bloc_sav(:)
  integer,allocatable :: cx_word_sav(:),cx_ver_sav(:)
  integer(kind=entry_length) :: cxnext_sav,knext_sav,kk,ifind(max_rf_file)
  integer :: nnn
  integer :: ier, j, indlen
  character(len=*), parameter :: rname='LIST_BAND'
  !
  ! First save current index
  indlen = 0
  if (cxnext.gt.1) then
    indlen = cxnext-1
    allocate(cx_num_sav(indlen),cx_ind_sav(indlen),cx_bloc_sav(indlen), &
             cx_word_sav(indlen),cx_ver_sav(indlen),stat=ier)
    if (failed_allocate(rname,'Cannot allocate index',ier,error))  return
    do j=1,indlen
      cx_num_sav(j) = cx_num(j)
      cx_ind_sav(j) = cx_ind(j)
      cx_bloc_sav(j) = cx_bloc(j)
      cx_word_sav(j) = cx_word(j)
      cx_ver_sav(j) = cx_ver(j)
    enddo
    cxnext_sav = cxnext
    knext_sav = knext
  endif
  !
  ! Search for bandpass solutions
  fscan = .false.
  fexcl = .false.
  fsourc = .false.
  fproc = .true.
  xnproc = 1
  xsproc(1) = p_band
  fnum = .false.
  fline = .false.
  fitype = .false.
  fteles = .false.
  !fproject = .false.
  fdobs = .false. 
  fdred = .false.
  foff1 = .false. 
  foff2 = .false.
  fut = .false.
  fhoura= .false.
  fic = .false.
  fbpc = .false.
  fpol = .false.
  fskip = .false.
  fload = .false.
  xnscan = 1
  xscan(1) = scan_offset
  yscan(1) = 2147483647
  !
  cxnext = 1
  knext = 0
  nnn  = max_rf_file*2
  call fix(nnn,ifind(1),.true.,.false.,error)
  if (error) goto 100
  ! 
  ! Save title
  title_save = title
  !
  ! Now do the listing
  if (nnn.le.0) then
    call message(8,1,'LIST_BAND','No bandpass solution found')
  else
    call out0('Terminal',0,0,error)
     if (error) return
    do j=1,cxnext-1
      kk = cx_ind(j)
      call rix(kk,error)
      if (error) goto 100
      call titout('Normal',error)
      if (error) goto 100
    enddo
  endif
  !
  ! Restore saved title and index
  title = title_save
  if (indlen.gt.0) then
    do j=1,indlen
      cx_num(j) = cx_num_sav(j)
      cx_ind(j) = cx_ind_sav(j)
      cx_bloc(j) = cx_bloc_sav(j)
      cx_word(j) = cx_word_sav(j)
      cx_ver(j) = cx_ver_sav(j)
    enddo
    cxnext = cxnext_sav
    knext = knext_sav
  endif
100  continue
  if (allocated(cx_num_sav)) deallocate(cx_num_sav)
  if (allocated(cx_ind_sav)) deallocate(cx_ind_sav)
  if (allocated(cx_bloc_sav)) deallocate(cx_bloc_sav)
  if (allocated(cx_word_sav)) deallocate(cx_word_sav)
  if (allocated(cx_ver_sav)) deallocate(cx_ver_sav)
  return
end subroutine list_bandpass

subroutine clic_atmos(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Command ATMOS [DETECTOR|CORRELATOR]
  ! This command  quasi real time amplitude and IF passband calibration.
  ! It processes CAL, AUTO, IFPB and CWVR scans as they are encountered.
  ! Option 1 /COMPRESS time uvmax
  ! Option 2 /RESET {CAL|IFPB:AUTO:ALL}
  ! Option 3 /NOWRITE
  ! Option 4 /NOMONITOR
  ! Option 5 /CMODE  wvrmode wvrcpol
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_write, monitor
  integer :: i, ir, ia, ip, ic
  integer(kind=address_length) :: data_in, ip_data
  integer(kind=data_length) :: ndata, ldata_in
  integer :: isb, isub, nch
  character(len=7) :: done
  character(len=12) :: arg1, arg
  character(len=80) :: chain
  character(len=4) :: cproc,procname
  real :: scale(mnant,mnbb)
  integer :: mvoc1, mvoc2, mvoc3
  parameter (mvoc1=2, mvoc2=5, mvoc3=5)
  character(len=12) :: voc1(mvoc1), voc2(mvoc2), voc3(mvoc3)
  data voc1/'DETECTOR','CORRELATOR'/
  data voc2/'CAL','IFPB','AUTO','ALL','CWVR'/
  data voc3/'TR_GE','TR_GL','TRL_GC','TR_GC','NOCAL'/
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do_write = .not.sic_present(3,0)
  if (do_write) then
    call check_output_file(error)
    if (write_mode.eq.'UPDA') call check_equal_file(error)
    if (error) return
  endif
  arg1 = 'DETECTOR'
  call clic_kw(line,0,1,arg1,nch,voc1,mvoc1,.false.,error,.true.)
  if (error) return
  !
  ! Reset CAL, AUTO, ALL, and/or IFPB  : Option 2
  if (sic_present(2,0)) then
    do i=1, max(1,sic_narg(2))
      arg = 'ALL'
      call clic_kw(line,2,i,arg,nch,voc2,mvoc2,.true.,error,.true.)
      if (error) return
      if (arg.eq.'ALL') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,chop) = 0
                integ(ia,ir,ic,ip,cold) = 0
                integ(ia,ir,ic,ip,sky) = 0
              enddo
            enddo
          enddo
        enddo
        mon_scan = 0
      elseif (arg.eq.'AUTO') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,sky) = 0
              enddo
            enddo
          enddo
        enddo
      elseif (arg.eq.'CAL') then
        do ia=1,mnant
          do ir=1,mnrec
            do ic=1, mnbb
              do ip=1, m_pol_rec
                integ(ia,ir,ic,ip,chop) = 0
                integ(ia,ir,ic,ip,cold) = 0
              enddo
            enddo
          enddo
        enddo
      endif
    enddo
  endif
  !
  ! /NOMONITOR
  monitor = .not.sic_present(4,0)
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    if (r_ndump.eq.0) goto 200
    r_nrec = max(1,r_nrec)
    do isb = 1, r_nsb
      if (c_line(isb).ne.'*') then
        r_crfoff(isb) = c_freq(isb)
        r_cnam(isb) = c_line(isb)
      elseif (r_restf.gt.0) then
        r_crfoff(isb) = r_restf
        r_cnam(isb) = r_line
      else
        r_crfoff(isb) = 100000.
        r_cnam(isb) = 'DUMMY'
      endif
      do isub=1, r_lband
        if (l_line(isub,isb).ne.'*') then
          r_lrfoff(isb,isub) = l_freq(isub,isb)
          r_lnam(isb,isub) = l_line(isub,isb)
        elseif (r_restf.gt.0) then
          r_lrfoff(isb,isub) = r_restf
          r_lnam(isb,isub) = r_line
        else
          r_lrfoff(isb,isub) = 100000.
          r_lnam(isb,isub) = 'DUMMY'
        endif
      enddo
    enddo
    !
    ! Get storage and data
    call get_data (ldata_in,data_in,error)
    if (error) goto 200
    ndata = ldata_in
    !
    ! Process (with atmospheric monitor)
    ip_data = gag_pointer(data_in,memory)
    call sub_atmos (ndata,memory(ip_data),arg1,monitor,error,   &
      scale)
    !         CALL SUB_ATMOS (LDATA_IN,MEMORY(IP_DATA),ARG1,WVRMODE,WVRCPOL,
    !     $   MONITOR,ERROR)
    if (error) goto 200
    !         CALL CHECK_FLUX(LDATA_IN, MEMORY(IP_DATA), FLUXOUT, ERRFLUX,
    !     &   PHCOROK, LOWFAC, ERROR)
    error = .false.
    !
    ! Write
    call loose_data
    if (do_write) then
      call ipb_write(write_mode,.true.,error)
      if (error) goto 200
      if (write_mode.eq.'UPDA') then
        call wgen(error)       ! section generale
        if (error) return
        call wpos(error)       ! position
        if (error) return
        call winterc(error)
        if (r_presec(rfset_sec)) then
          call wrfset(error)
          if (error) return
        endif
        if (r_presec(contset_sec)) then
          call wcontset(error)
          if (error) return
        endif
        if (r_presec(lineset_sec)) then
          call wlineset(error)
          if (error) return
        endif
        if (r_presec(atparm_sec)) then
          call watparm(error)
          if (error) return
        endif
        if (r_presec(wvr_sec)) then
          call wwvr(error)
          if (error) return
        endif
      endif
      call update_header       ! Missing in this circumstances
      ndata = ldata_in
      call wdata (ndata,memory(ip_data),.false.,error)
      if (error) goto 200
      call ipb_close(error)
      if (error) goto 200
      cproc = procname(r_proc)
      write(chain,'(A4,1X,I6,A,I6,A)') cproc ,r_num,   &
        ' '//done(write_mode)//' (',r_ndump,' records)'
      call message(4,1,'CLIC_ATMOS',chain(1:50))
    endif
    !
    ! Next observation
200 if (sic_ctrlc()) then
      error = .true.
      return
    endif
    error = .false.
    call get_next(end, error)
    if (error) return
  enddo
  return
end subroutine clic_atmos
!
subroutine load_atmos
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !	Load Atmospheric Parameters
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  real :: airmas, current_el
  real*8 :: air_mass
  integer :: ia, ip
  !
  ! Setup atmospheric monitor section:
  !      CALL R4TOR4(H_MON(1,R_NREC),R_NREC_MON,MATMON)
  !
  ! Setup calibration parameters section:
  current_el = r_el
  ! just in case ...
  airmas = sngl(air_mass(current_el)-air_mass(r_el))
  do ia =1, r_nant
    do ip = 1, mnbb
      r_tsyss(ip,ia) = r_tsyss(ip,ia)*exp(r_taus(ip,ia)   &
        *airmas)
      r_tsysi(ip,ia) = r_tsysi(ip,ia)*exp(r_taui(ip,ia)   &
        *airmas)
    enddo
  enddo
end subroutine load_atmos
!
subroutine cal_levels(arg,mes)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Show total power levels
  ! Input
  !	ARG C*(*)	'Detector' or 'Correlator'
  !---------------------------------------------------------------------
  character(len=*) :: arg           !
  integer :: mes                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  ! Local
  real :: wk, tp(mnant)
  integer :: ia, ic, jc,  ip, ical
  character(len=200) :: chain
  logical :: error
  integer :: cold_scan(mnrec)
  character(len=2) :: ch(3)
  data ch/'Ch','Co','Sk'/
  save cold_scan
  data cold_scan/0,0,0,0/
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Use "Temporal" data if correlator to be used
  ! Not necessarily the best thing (narrow band on some occasions ?)
  ! Get saved values from previous measurements in same scan
  !
  if (r_nbb.eq.0) then
      print *,"CAL_LEVELS, No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! New calibration scan : reset cold measurements to zero.
  !
  if (r_scan.ne.cold_scan(r_nrec) .and. mes.ne.cold) then
    do ia=1, r_nant
      do ic = 1, mnbb
         do ip = 1, m_pol_rec
           c_lev(ia,r_nrec,ic,ip,cold) = 0
         enddo
      enddo
    enddo
  endif
  if (mes.eq.cold) then
    cold_scan(r_nrec) = r_scan
  endif
  !
  do ia = 1, r_nant
    if (new_receivers) then
      !
      ! new receivers: use Tot power as it comes from correlator anyway.
      !
      ! Sky used to actually calibrate spectra, fill only what measured
      if (mes.eq.sky) then
        do ical = 1, r_nbb
          ic = r_mapbb(ical)
          ip = r_mappol(ia,ical)
          c_lev(ia,r_nrec,ic,ip,mes) = dh_total(ic, ia)
        enddo
      else
        !
        ! Temporary: fill both pol buffers since not measured in pol case.
        do ical = 1, r_nbb
          ic = r_mapbb(ical)
          ip = r_mappol(ia,ical)
            c_lev(ia,r_nrec,ic,ip,mes) = dh_total(ic, ia)
        enddo
      endif
    else
      !
      ! old receivers: use either Correl or Detector
      if (arg.eq.'C') then
        tp(ia) = 0
        wk = 0
        do jc = 1, l_subb(k_subb(1))
          ic = max(1,min(r_nband,i_subb(jc,k_subb(1))))
          ip = r_lpolentry(ia,ic)
          if (iand(dh_aflag(ia),ishft(1,ic-1)).eq.0) then
            wk = wk + r_cfwid(ic)
            tp(ia) = tp(ia)   &
              + c_c(ic,ia,r_nrec,ip,mes)*r_cfwid(ic)
          endif
        enddo
        if (wk.ne.0) then
          tp(ia) = tp(ia) / wk
        else
          write (chain,'(A,I0)')   &
            'No calibration data for Antenna ',ia
          call message(8,4,'CAL_LEVELS',chain(1:lenc(chain)))

!! TBA          integ(ia,r_nrec,1,ip,mes) = 0    ! may be one could use the other
          return               ! antennas ... ###
        endif
      elseif (arg.eq.'D') then
        !
        !     use the dh_total...
        tp(ia) = dh_total(1, ia)
        c_lev(ia,r_nrec,1,1,mes) = tp(ia)        !!! TBA
        c_lev(ia,2,1,1,mes) = dh_test1(2,ia)     !!! TBA
      endif
    endif
  enddo
  if (new_receivers) then
    do ical = 1,  r_nbb
      ic = r_mapbb(ical)
      write(chain,1001) arg, ch(mes), ic, (r_kant(ia), c_lev(ia,  &
        r_nrec,ic,r_mappol(ia,ical),mes), ia=1,r_nant)
      call message(1,1,'CAL_LEVELS',chain(1:lenc(chain)))
    enddo
1001 format(a1,1x,a2,' Cal.Unit',i0,12(' A',i0,':',f6.3))
  else
    write(chain,1000) arg,ch(mes),r_nrec, (r_kant(ia),tp(ia),ia=1   &
      ,r_nant)
1000 format(a1,1x,a2,' Rec',i0,12(' A',i0,':',f6.1))
    call message(1,1,'CAL_LEVELS',chain(1:lenc(chain)))
  endif
  return
end subroutine cal_levels
!
subroutine check_atmos (error)
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Check that spectrum to be reduced is compatible with available
  ! calibration buffers.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: wrong
  integer :: i, ia, ip, ic, ical
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Check configuration compatibility
  wrong = .false.
  call compare_sec(r_nant,h_inter(1,r_nrec),2,wrong)
  call compare_sec(r_lband,h_line(1,r_nrec),3+5*mrlband,wrong)
  !*
  ! Check Atmospheric calibration presence
  if (new_receivers) then
    do ia=1, r_nant
      do ical = 1, r_nbb
        ic = r_mapbb(ical)
        ip = r_mappol(ia,ical)
        if (integ(ia,r_nrec,ic,ip,chop).le.0 .or. wrong) then
            tcal_u(ia,ic) = 1.
            tcal_l(ia,ic) = 1.
          call message(6,2,'CHECK_ATMOS',   &
            'No Amplitude Calibration')
          sky_flags(ia,ic) = 0
          r_qual = min(r_qual,8)
          error = .true.
        else
          return
        endif
      enddo
    enddo
  else
    if (integ(1,r_nrec,1,1,chop).le.0 .or. wrong) then !! TBA
      do ia=1, r_nant
        tcal_u(ia,r_nrec) = 1.  !!! TBA
        tcal_l(ia,r_nrec) = 1.  !!! TBA
      enddo
      call message(6,2,'CHECK_ATMOS','No Amplitude Calibration')
      do i = 1, r_nant
        sky_flags(i,r_nrec) = 0
      enddo
      r_qual = min(r_qual,8)
      error = .true.
    else
      return
    endif
  endif
end subroutine check_atmos
!
subroutine real_to_complex(rel,cmpl,n)
  !---------------------------------------------------------------------
  ! Reverse storage order from:
  !	N real parts, N imaginary parts
  ! 	to:
  !	N complex numbers
  !---------------------------------------------------------------------
  integer :: n                      !
  real*4 :: rel(n,2)                !
  complex :: cmpl(n)                !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  do i=1,n
    cmpl(i) = cmplx( rel(i,1), rel(i,2) )
  enddo
end subroutine real_to_complex
!
subroutine vel_scale
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Updates frequencies in header according to last
  !     'SET FREQUENCY' command
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! Local
  integer :: isb, sky(2), isub
  real*8 :: x,y,c
  parameter (c=299792.458d0)
  data sky/+1,-1/              ! Usb, Lsb
  !------------------------------------------------------------------------
  ! Code:
  ! Loop on sidebands
  do isb = 1, 2
    !
    ! Continuum
    x = r_flo1_ref - sky(isb)*r_isb*r_fif1   &
      - sky(isb)*(r_crfoff(isb)-r_restf)*(1.+r_doppl)
    r_crch(isb) = 5.5+ (x-350.)/50.  ! reference channel
    r_crfres(isb) = -sky(isb)*50.    ! channel width
    r_cvoff(isb) = r_veloc   ! source velocity
    r_cvres(isb) = -r_crfres(isb)/r_crfoff(isb)*c
    !
    ! Line
    do isub=1, r_lband
      x = r_fif1 + r_isb *   &             ! New reference freq (I_F)
        (r_lrfoff(isb,isub) - r_restf)*(1.+r_doppl)
      y = r_flo2(isub) +r_band2(isub)* (r_flo2bis(isub) & ! Band reference freq (I_F)
        + r_band2bis(isub) * r_lfcen(isub))
      r_lrch(isb,isub) = (r_isb * x -  sky(isb) * y)   & 
        * sky(isb) * r_band2(isub) * r_band2bis(isub) / r_lfres(isub)   &
        + r_lcench(isub)
      r_lrfres(isb,isub) = sky(isb)*r_lfres(isub)   &
        *r_band2(isub) * r_band2bis(isub)
      r_lvoff(isb,isub) = r_veloc
      r_lvres(isb,isub) = -r_lrfres(isb,isub)   &
        /r_lrfoff(isb,isub)*c
    enddo
  enddo
end subroutine vel_scale
!
function prec_water(tamb,humidity)
  !---------------------------------------------------------------------
  ! CLIC
  !	Compute the precipitable water content
  !	Assumes scale height 2km
  ! Input
  !     TAMB       REAL	Ambiant Temperature in Kelvin
  !     HUMIDITY   REAL   Humidity in %
  ! Output
  !     PREC_WATER REAL   Water vapor in mm
  !---------------------------------------------------------------------
  real :: prec_water                !
  real :: tamb                      !
  real :: humidity                  !
  !------------------------------------------------------------------------
  ! Code:
  prec_water = 26.46*humidity/tamb   &
    * exp(25.22*(tamb-273)/tamb-5.31*alog(tamb/273.))
  return
end function prec_water
!
subroutine compare_sec(n1,n2,nn,ok)
  !---------------------------------------------------------------------
  ! CLIC: compare two memory areas
  !---------------------------------------------------------------------
  integer :: nn                     !
  integer :: n1(nn)                 !
  integer :: n2(nn)                 !
  logical :: ok                     !
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  do i=1,nn
    ok = ok.and.(n1(i).eq.n2(i))
  enddo
  return
end subroutine compare_sec
!
subroutine check_flux(ndata, data, fluxout, errflux, phcorok,   &
    lowfac, error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_rdata
  !---------------------------------------------------------------------
  ! Check the flux on a phase calibrator.
  ! Assume the efficiencies in r_jykel are correct.
  ! The best of corrected and uncorrected data is used.
  !
  ! Arguments
  !     LDATA_IN      Integer Length of data array
  !     DATA(*)       (*)     Data array
  !     Fluxout       R       Measured flux if procedure is flux measurement
  !     Errflux       R       Error on flux "  "             "      "
  !     phcorOK       L(mnant) true if flux with phcor is best
  !     floss         R(mnant) degradation factor for each ant. (0 to 1)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer(kind=data_length) :: ndata                  !
  real :: data(ndata)               !
  real :: fluxout                   !
  real :: errflux                   !
  logical :: phcorok(mnant)         !
  real :: lowfac(mnant)             !
  logical :: error                  !
  ! Global
  real :: effmax
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'clic_sba.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: data_in
  real :: effm, fr, fu(mnant), fc(mnant), wfu(mnant),ec(mnant)
  real :: eu(mnant), efc, efu, ft(mnant), wfc(mnant), afc, afu, wafc
  real :: wafu, fopt
  integer :: ib, isb, kh, ia, if,if1, i
  integer :: ind(mnant), nbest 
  character(len=132) :: chain
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant), frtol
  parameter (frtol=1e3)
  ! use the two best antennas for flux determination
  parameter (nbest = 2)
  logical :: save_atm(mnant), zero
  integer(kind=address_length) :: kin, ipkh
  integer(kind=data_length) :: h_offset
  !------------------------------------------------------------------------
  data_in = locwrd(data)
  kin = gag_pointer(data_in,memory)
  error = .false.
  if (r_itype.eq.1 .and. r_proc.ne.p_flux) then
    return
  endif
  if (r_proc.ne.p_source .and. r_proc.ne.p_flux) then
    return
  endif
  fr = r_flo1+r_isb*r_fif1
  effm = effmax(fr)
  do ib=1, r_nant
    fu(ib) = 0.
    fc(ib) = 0.
  enddo
  isb = 1+(1-r_isb)/2          !              (1 usb, 2 lsb)
  !
  ! Save atm phase status
  do i=1, mnant
    save_atm(i) = do_phase_atm(i)
  enddo
  !
  if (do_spidx) then
    call set_spidx(r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, spidc, spidl, r_spidx, error)
  endif  
  !
  ! Get average record (uncorrected) in zsba(isb,ib) (weights in wsba)
  if (r_ndatl.ne.1) then
    do i=1, mnant
      do_phase_atm(i) = .false.
    enddo
    kh = 1 + h_offset(r_ndump+1)
    !         KC = 1 + C_OFFSET(R_NDUMP+1)
    ipkh = kin+h_offset(r_ndump+1)
    call decode_header (memory(ipkh))
    call set_scaling(error)
    if (error) return
    zero = .true.
    !
    ! NGRX : Not sure if this is handling both polarizations, ...
    ! may be do each one at a time ?
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
       spidc,zero,error)
    endif 
    if (error) return
    do ib = 1, r_nbas
      if (wsba(isb,ib).gt.0) then
        z(ib) = zsba(isb,ib)/wsba(isb,ib)
      else
        z(ib) = 0
      endif
      w(ib) = wsba(isb,ib)
    enddo
    call antgain (z,w,zant,want)
    do ia = 1, r_nant
      fu(ia) = 0
      wfu(ia) = 0
      if (want(ia).gt.0) then
        !               do ip = i, r_npol_rec
        !                  if (r_npol_rec.eq.1) then
        !                     ipol = r_lpolentry(1,1) ! To be patched when mixed unit
        !                  else
        !                     ipol = ip
        !                  endif
        fu(ia) = fu(ia) + abs(zant(ia)) * r_jykel(1,ia)
        if (r_jykel(1,ia).ne.0) then
          wfu(ia) = wfu(ia) + want(ia) / r_jykel(1,ia)**2
        else
          print *,"R_JYKEL ",1,ia," is ZERO"
        endif
        !              enddo
        !               if (r_npol_rec.ne.0) then
        !                  fu(ia) = fu(ia)/r_npol_rec
        !                  wfu(ia) = wfu(ia)/r_npol_rec
        !               else
        !                  print *,"R_NPOL_REC is ZERO"
        !               endif
        if (wfu(ia).ne.0) then
          eu(ia) = 1e-3 / sqrt(wfu(ia))
        else
          print *,"WFU ",ia," is ZERO"
        endif
      else
        fu(ia) = 0
        wfu(ia) = 0
        eu(ia) = -10.
      endif
    enddo
  endif
  !
  ! Get average record (corrected) in zsba(isb,ib) (weights in wsba)
  if (r_ndatl.ge.1) then
    do i=1, mnant
      do_phase_atm(i) = .true.
    enddo
    call spectral_dump(kh,0,0)
    ipkh = kin+h_offset(r_ndump+1)
    call decode_header (memory(ipkh))
    call set_scaling(error)
    if (error) return
    zero = .true.
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
       spidc,zero,error)
    endif 
    if (error) return
    do ib = 1, r_nbas
      if (wsba(isb,ib).gt.0) then
        z(ib) = zsba(isb,ib)/wsba(isb,ib)
      else
        z(ib) = 0
      endif
      w(ib) = wsba(isb,ib)
    enddo
    call antgain (z,w,zant,want)
    do ia = 1, r_nant
      if (want(ia).gt.0) then
        !               do ip = i, r_npol_rec
        !                  if (r_npol_rec.eq.1) then
        !                     ipol = r_lpolentry(1,1) ! To be patched when mixed unit
        !                  else
        !                     ipol = ip
        !                  endif
        if (r_jykel(1,ia).ne.0) then
          fc(ia) = fc(ia) + abs(zant(ia)) * r_jykel(1,ia)
          wfc(ia) = wfc(ia) + want(ia) / r_jykel(1,ia)**2
        else
          print *,"R_JYKEL ",1,ia," is ZERO"
        endif
        !               enddo
        !               if (r_npol_rec.ne.0) then
        !                  fc(ia) = fc(ia)/r_npol_rec
        !                  wfc(ia) = wfc(ia)/r_npol_rec
        !               else
        !                  print *,"R_NPOL_REC is ZERO"
        !               endif
        if (wfc(ia).ne.0) then
          ec(ia) = 1e-3 / sqrt(wfc(ia))
        else
          print *,"WFC ",ia," is ZERO"
        endif
      else
        fc(ia) = 0
        wfc(ia) = 0
        ec(ia) = -10.
      endif
    enddo
  endif
  !
  ! Restore atm phase status
  do i=1, mnant
    do_phase_atm(i) = save_atm(i)
  enddo
  !
  ! Compute FLUX
  if (r_proc.ne.p_flux) then
    ! search for flux in the table
    if = 0
    do i = 1, n_flux
      if (c_flux(i).eq.r_sourc   &
        .and. abs(freq_flux(i)-r_restf).lt.1d3   &
        .and. abs(r_dobs-date_flux(i)).lt.3) then
        if = i
      endif
    enddo
    if (if.ne.0) then
      r_flux = abs(flux(if))
      fluxout = r_flux
      write (chain,'(a,f5.1,a,f6.3,a)')   &
        'Current flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ', fluxout, ' Jy'
      call message(6,1,'CHECK_FLUX',chain(1:lenc(chain)))
    else
      fluxout = r_flux
      if (r_flux.eq.0) fluxout = 1.0
      write (chain,'(a,f5.1,a,f6.3,a)')   &
        'Default flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ', fluxout, ' Jy'
      call message(4,2,'CHECK_FLUX',chain(1:lenc(chain)))
    endif
  else
    ! Use only the two best antennas.
    !
    !     NGRX: for the time being we average polarizations (assume
    !     unpolarized source)
    !     corrected
    afc = 0
    wafc = 0
    efc  = 0
    if (r_ndatl.ge.1) then
      call r4tor4(fc,ft,r_nant)
      call gr4_trie(ft,ind,r_nant,error)
      do ia= r_nant, r_nant-nbest+1, -1
        i = ind(ia)
        afc = afc + ft(ia)*wfc(i)
        wafc = wafc + wfc(i)
      enddo
      if (wafc.gt.0) then
        afc = afc / wafc
        efc = 1e-3 / sqrt(wafc)
      endif
    endif
    !     uncorrected
    afu = 0
    wafu = 0
    efu = 0
    if (r_ndatl.ne.1) then
      call r4tor4(fu,ft,r_nant)
      call gr4_trie(ft,ind,r_nant,error)
      do ia= r_nant, r_nant-nbest+1, -1
        i = ind(ia)
        afu = afu + ft(ia)*wfu(i)
        wafu = wafu + wfu(i)
      enddo
      if (wafu.gt.0) then
        afu = afu / wafu
        efu = 1e-3 / sqrt(wafu)
      endif
    endif
    if (afc.ge.afu) then
      fluxout = afc
      errflux = efc
    else
      fluxout = afu
      errflux = efu
    endif
    if (abs(fluxout).gt.1e6 .or. abs(fluxout).lt.1e-6) then
      write (chain,'(a,1pg12.5)')   &
        'Unlikely flux for '//r_sourc//' : ',fluxout
      call message (8,3,'CHECK_FLUX',chain(1:lenc(chain)))
    else
      write (chain,'(a,f5.1,a,f6.3,a,f5.3,a)')   &
        'Estimated flux of '//r_sourc//' at ',   &
        r_restf/1d3,' GHz is ',   &
        fluxout, ' Jy (',errflux,')'
      call message(6,1,'CHECK_FLUX',chain(1:lenc(chain)))
      r_flux= fluxout
      !
      ! put in our source list
      if1 = 0
      if (n_flux.ge.1) then
        do if =1, n_flux
          if (r_sourc.eq.c_flux(if)   &
            .and. abs(r_restf-freq_flux(if)).lt.frtol) then
            flux(if) = r_flux
            freq_flux(if) = r_restf
            date_flux(if) = r_dobs
            f_flux(if) = .false.
            if1 = if
          endif
        enddo
      endif
      if (if1.le.0 .and. n_flux.lt.m_flux) then
        n_flux = n_flux+1
        f_flux(n_flux) = .false.
        flux(n_flux) = r_flux
        c_flux(n_flux) = r_sourc
        date_flux(n_flux) = r_dobs
        freq_flux(n_flux) = r_restf
      endif
    !
    endif
  endif
  !
  ! Messages
  error = .false.
  do ia = 1, r_nant
    ! optimistic flux is measured+3sigma
    phcorok(ia) = fc(ia).ge.fu(ia)
    if (phcorok(ia)) then
      fopt = fc(ia)+ec(ia)
    else
      fopt = fu(ia)+eu(ia)
    endif
    if (fluxout.gt.0 .and. fopt.gt.0) then
      lowfac(ia) = fopt / fluxout
      if (fopt.lt.0.9*fluxout) then
        if (r_ndatl.eq.0) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fu(ia), 'Jy (Unc.)'
        elseif (r_ndatl.eq.1) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fc(ia), 'Jy (Cor.)'
        elseif (r_ndatl.eq.2) then
          write (chain,1002) 'Low flux on Ant ',r_kant(ia),   &
            ' Rec ',r_nrec,' : ', fu(ia), 'Jy (Unc.) ',   &
            fc(ia),'Jy (Cor.)'
        endif
        call message(4,2,'CHECK_FLUX',chain(1:lenc(chain)))
        error = .true.
      endif
    endif
  enddo
  return
1002 format(a,i1,a,i1,a,2(f6.3,a))
end subroutine check_flux
!
real function effmax(f)
  real :: f                         !
  effmax = 60.
  if (f.lt.120000.) then
    effmax = 30.
  endif
  return
end function effmax

module cubedag_history_types
  use gkernel_interfaces
  use cubelist_types
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_link_type
  use cubedag_links_type
  use cubedag_dag_buffer
  !---------------------------------------------------------------------
  ! Support module for the history type
  !---------------------------------------------------------------------
  !
  public :: cubedag_history_t,cubedag_history_ptr
  public :: cubedag_history_list_t
  private
  !
  integer(kind=4), parameter :: command_length=16  ! ZZZ Duplicated from SIC
  !
  ! DAG data format
  character(len=*), parameter :: form_i8='(A,T13,I20)'
  character(len=*), parameter :: form_a='(A,T13,A)'  ! Scalar string
  !
  type, extends(list_object_t) :: cubedag_history_t
    integer(kind=iden_l)              :: id = 0
    character(len=command_length)     :: command = strg_unk
    character(len=commandline_length) :: line = strg_unk
    type(cubedag_hlinks_t)            :: links
  contains
    procedure, public  :: init       => cubedag_history_init
    procedure, public  :: read       => cubedag_history_read
    procedure, private :: read_head  => cubedag_history_read_head
    procedure, public  :: write      => cubedag_history_write
    procedure, private :: write_head => cubedag_history_write_head
    procedure, public  :: final      => cubedag_history_final
  end type cubedag_history_t
  !
  type, extends(list_t) :: cubedag_history_list_t
    integer(kind=4), private :: lun
  contains
    procedure, public  :: entrynum => cubedag_history_entrynum
    procedure, public  :: add      => cubedag_history_add_fromargs
    procedure, public  :: liste    => cubedag_history_list
    procedure, public  :: init     => cubedag_history_list_init
    procedure, private :: open     => cubedag_history_list_open
    procedure, public  :: read     => cubedag_history_list_read
    procedure, public  :: write    => cubedag_history_list_write
    procedure, private :: close    => cubedag_history_list_close
  end type cubedag_history_list_t
contains

  function cubedag_history_ptr(lot,error)
    !-------------------------------------------------------------------
    ! Check if the input type is a 'cubedag_history_t', and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    type(cubedag_history_t), pointer :: cubedag_history_ptr  ! Function value on return
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPENED>PTR'
    !
    select type(lot)
    type is (cubedag_history_t)
      cubedag_history_ptr => lot
    class default
      cubedag_history_ptr => null()
      call cubedag_message(seve%e,rname,'Internal error: object is not a cubedag_history_t')
      error = .true.
      return
    end select
  end function cubedag_history_ptr

  subroutine cubedag_history_init(hist,error)
    !-------------------------------------------------------------------
    ! Initialize the i-th component in the index
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(out)   :: hist
    logical,                  intent(inout) :: error
    !
    ! Done with intent(out)
  end subroutine cubedag_history_init
  !
  subroutine cubedag_history_read(hobj,lun,nshift,hshift,nomore,error)
    !-------------------------------------------------------------------
    ! Read the next history object from the DAG file (if any)
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(inout) :: hobj
    integer(kind=4),          intent(in)    :: lun
    integer(kind=iden_l),     intent(in)    :: nshift  ! Node ID shift
    integer(kind=iden_l),     intent(in)    :: hshift  ! History ID shift
    logical,                  intent(inout) :: nomore
    logical,                  intent(inout) :: error
    !
    call hobj%read_head(lun,hshift,nomore,error)
    if (error)  return
    if (nomore)  return
    call hobj%links%read(lun,nshift,error)
    if (error)  return
  end subroutine cubedag_history_read
  !
  subroutine cubedag_history_read_head(hobj,lun,hshift,nomore,error)
    class(cubedag_history_t), intent(inout) :: hobj
    integer(kind=4),          intent(in)    :: lun
    integer(kind=iden_l),     intent(in)    :: hshift  ! History ID shift
    logical,                  intent(inout) :: nomore
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='HREPOSITORY>READ'
    character(len=12) :: key
    integer(kind=iden_l) :: hid
    integer(kind=4) :: ier
    !
    read(lun,form_i8,iostat=ier) key,hid
    if (ier.lt.0) then
      ! EOF
      nomore = .true.
      return
    endif
    if (ier.gt.0) then
      call putios('E-HREPOSITORY,  ',ier)
      error = .true.
      return
    endif
    if (key.ne.'ID') then
      call cubedag_message(seve%e,rname,'Malformatted file: got '//trim(key))
      error = .true.
      return
    endif
    !
    hobj%id = hid+hshift
    read(lun,form_a) key,hobj%command
    read(lun,form_a) key,hobj%line
  end subroutine cubedag_history_read_head
  !
  subroutine cubedag_history_write(hobj,lun,error)
    !-------------------------------------------------------------------
    ! Write the next history object to the DAG file
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(in)    :: hobj
    integer(kind=4),          intent(in)    :: lun
    logical,                  intent(inout) :: error
    !
    call hobj%write_head(lun,error)
    if (error)  return
    call hobj%links%write(lun,error)
    if (error)  return
  end subroutine cubedag_history_write
  !
  subroutine cubedag_history_write_head(hobj,lun,error)
    class(cubedag_history_t), intent(in)    :: hobj
    integer(kind=4),          intent(in)    :: lun
    logical,                  intent(inout) :: error
    !
    write(lun,form_i8) 'ID',hobj%id
    write(lun,form_a)  'COMMAND',trim(hobj%command)
    write(lun,form_a)  'LINE',trim(hobj%line)
  end subroutine cubedag_history_write_head
  !
  subroutine cubedag_history_final(obj,error)
    !-------------------------------------------------------------------
    ! No implicit final because of
    ! https://gcc.gnu.org/bugzilla/show_bug.cgi?id=112459
    !-------------------------------------------------------------------
    class(cubedag_history_t), intent(inout) :: obj
    logical,                  intent(inout) :: error
    !
    ! Clean
    call obj%links%final(error)
    if (error)  continue
    !
    ! Reinitialize (after cleaning)
    call obj%init(error)
    if (error)  continue
  end subroutine cubedag_history_final

  function cubedag_history_entrynum(hx,id,error)
    !-------------------------------------------------------------------
    ! Resolve the entry number corresponding to the given ID.
    ! - If ID>0, the entry is resolved by searching in all the history
    ! index. This resolution is based on two strong assumptions:
    !  1) the identifier is UNIQUE,
    !  2) the identifier list is SORTED
    ! - If ID<=0, the ID is assumed to be a position from the end
    ! (0=last, same as CubeID).
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: cubedag_history_entrynum
    class(cubedag_history_list_t), intent(in)    :: hx
    integer(kind=iden_l),          intent(in)    :: id
    logical,                       intent(inout) :: error
    !
    integer(kind=entr_k) :: inf,mid,sup
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hist
    character(len=*), parameter :: rname='HISTORY>ENTRYNUM'
    !
    if (id.le.0) then
      ! Search by position from the end
      if (-id.gt.hx%n-1) then
        write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
        call cubedag_message(seve%e,rname,mess)
        cubedag_history_entrynum = 0
        error = .true.
        return
      endif
      cubedag_history_entrynum = hx%n+id
      return
    endif
    !
    ! Dichotomic search
    hist => cubedag_history_ptr(hx%list(1)%p,error)
    if (error)  return
    if (hist%id.eq.id) then
      cubedag_history_entrynum = 1
      return
    endif
    !
    inf = 1
    sup = hx%n
    do while (sup.gt.inf+1)
      mid = (inf+sup)/2  ! Integer division
      hist => cubedag_history_ptr(hx%list(mid)%p,error)
      if (error)  return
      if (hist%id.lt.id) then
        inf = mid
      else
        sup = mid
      endif
    enddo
    !
    hist => cubedag_history_ptr(hx%list(sup)%p,error)
    if (error)  return
    if (hist%id.eq.id) then
      cubedag_history_entrynum = sup
    else
      write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
      call cubedag_message(seve%e,rname,mess)
      cubedag_history_entrynum = 0
      error = .true.
      return
    endif
  end function cubedag_history_entrynum
  !
  subroutine cubedag_history_add_fromargs(hoptx,command,line,inputs,outputs,&
    hid,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: command
    character(len=*),              intent(in)    :: line
    type(cubedag_link_t),          intent(in)    :: inputs
    type(cubedag_link_t),          intent(in)    :: outputs
    integer(kind=list_k),          intent(out)   :: hid
    logical,                       intent(inout) :: error
    !
    type(cubedag_history_t) :: model
    class(list_object_t), pointer :: lot
    type(cubedag_history_t), pointer :: hobj
    !
    ! Add
    call hoptx%allocate(model,lot,error)
    if (error)  return
    hobj => cubedag_history_ptr(lot,error)
    if (error)  return
    !
    ! Fill the object
    hid = hoptx%n
    hobj%id = hid
    hobj%command = command
    hobj%line = line
    call inputs%copy(hobj%links%inputs,error)
    if (error)  return
    call outputs%copy(hobj%links%outputs,error)
    if (error)  return
  end subroutine cubedag_history_add_fromargs

  subroutine cubedag_history_list(hoptx,error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(in)    :: hoptx
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTORY>LIST'
    type(cubedag_history_t), pointer :: obj
    integer(kind=entr_k) :: ient
    character(len=10) :: tmpi,tmpo
    integer(kind=4) :: nd
    character(len=16) :: forma
    integer(kind=iden_l) :: maxid
    !
    if (hoptx%n.le.0) then
      call cubedag_message(seve%w,rname,'History index is empty')
      return
    endif
    !
    maxid = 0
    do ient=1,hoptx%n
      obj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      maxid = max(maxid,obj%id)
    enddo
    nd = ceiling(log10(real(maxid+1,kind=8)))
    write(forma,'(A,I0,A)') '(I',nd,',4(2X,A))'
    !
    do ient=1,hoptx%n
      obj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call obj%links%inputs%repr('i=',tmpi)
      call obj%links%outputs%repr('o=',tmpo)
      write(*,forma)  obj%id,obj%command,tmpi,tmpo,trim(obj%line)
    enddo
  end subroutine cubedag_history_list
  !
  subroutine cubedag_history_list_init(hoptx,path,error)
    !-------------------------------------------------------------------
    ! Initialize a new repository
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: path
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HISTORY>LIST>INIT'
    !
    ! Create and init new one on disk
    ! ZZZ Not yet implemented
    !
  end subroutine cubedag_history_list_init
  !
  subroutine cubedag_history_list_open(hoptx,name,read,error)
    use cubetools_system_tool
    !-------------------------------------------------------------------
    ! Open the repository file for reading or writing.
    !-------------------------------------------------------------------
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: name
    logical,                       intent(in)    :: read
    logical,                       intent(inout) :: error
    !
    character(len=3) :: mode
    integer(kind=4) :: ier
    logical :: readonly
    character(len=*), parameter :: rname='HISTORY>LIST>OPEN'
    !
    if (read) then
      mode = 'OLD'
      readonly = .true.
    else
      call cubedag_message(seve%i,rname,'Creating history repository in file '//name)
      readonly = .false.
      mode = 'NEW'
      call cubetools_directory_create_for_file(name,error)
      if (error) return
    endif
    !
    ier = sic_getlun(hoptx%lun)
    if (mod(ier,2).eq.0) then
      error = .true.
      return
    endif
    ier = sic_open(hoptx%lun,name,mode,readonly)
    if (ier.ne.0) then
      call cubedag_message(seve%e,rname,'Error opening file '//name)
      call putios('E-SIC, ',ier)
      error = .true.
      return
    endif
  end subroutine cubedag_history_list_open
  !
  subroutine cubedag_history_list_close(hoptx,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: ier
    !
    ier = sic_close(hoptx%lun)
    call sic_frelun(hoptx%lun)
  end subroutine cubedag_history_list_close
  !
  subroutine cubedag_history_list_write(hoptx,reponame,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: reponame
    logical,                       intent(inout) :: error
    !
    integer(kind=entr_k) :: ient
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hobj
    character(len=*), parameter :: rname='HISTORY>LIST>WRITE'
    !
    call hoptx%open(reponame,.false.,error)
    if (error)  return
    !
    do ient=1,hoptx%n
      hobj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call hobj%write(hoptx%lun,error)
      if (error) then
        write(mess,'(2(A,I0))')  'Error writing history entry #',ient,'/',hoptx%n
        call cubedag_message(seve%e,rname,mess)
        return
      endif
    enddo
    !
    call hoptx%close(error)
    if (error)  return
  end subroutine cubedag_history_list_write

  subroutine cubedag_history_list_read(hoptx,reponame,nshift,hshift,error)
    class(cubedag_history_list_t), intent(inout) :: hoptx
    character(len=*),              intent(in)    :: reponame
    integer(kind=iden_l),          intent(in)    :: nshift  ! Node ID shift
    integer(kind=iden_l),          intent(in)    :: hshift  ! History ID shift
    logical,                       intent(inout) :: error
    !
    character(len=mess_l) :: mess
    logical :: nomore
    integer(kind=entr_k) :: ient
    type(cubedag_history_t) :: model
    type(cubedag_history_t), pointer :: hobj
    class(list_object_t), pointer :: lot
    character(len=*), parameter :: rname='HISTORY>LIST>READ'
    !
    call hoptx%open(reponame,.true.,error)
    if (error)  return
    !
    nomore = .false.
    do
      ! Allocate a new object
      call hoptx%allocate(model,lot,error)
      if (error)  return
      hobj => cubedag_history_ptr(lot,error)
      if (error)  return
      call hobj%read(hoptx%lun,nshift,hshift,nomore,error)
      if (error)  return
      if (nomore) then
        ! The last allocated object was useless: remove
        call hoptx%pop(hoptx%n,error)
        if (error)  return
        exit
      endif
    enddo
    !
    ! Post-read: resolve all the links (from IDs to pointers) AFTER the
    ! whole DAG (IX) is reconstructed
    do ient=1,hoptx%n
      hobj => cubedag_history_ptr(hoptx%list(ient)%p,error)
      if (error)  return
      call hobj%links%resolve(ix,error)
      if (error)  return
    enddo
    !
    ! Feedback
    write(mess,'(A,I0,A)')  'Loaded an history index of ',hoptx%n,' commands'
    call cubedag_message(seve%i,rname,mess)
    !
    call hoptx%close(error)
    if (error)  return
  end subroutine cubedag_history_list_read

end module cubedag_history_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefield_rotate
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubeadm_ancillary_cube_types
  use cubefield_messaging
  ! 
  public :: rotate
  private
  !
  type :: rotate_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: fx
     type(cubeid_arg_t), pointer :: fy
     type(cube_prod_t),  pointer :: fu
     type(cube_prod_t),  pointer :: fv
     type(ancillary_cube_comm_t) :: angle
   contains
     procedure, public  :: register => cubefield_rotate_register
     procedure, private :: parse    => cubefield_rotate_parse
     procedure, private :: main     => cubefield_rotate_main
  end type rotate_comm_t
  type(rotate_comm_t) :: rotate
  !
  type rotate_user_t
     type(cubeid_user_t)         :: fx
     type(cubeid_user_t)         :: fy
     type(ancillary_cube_user_t) :: angle
   contains
     procedure, private :: toprog => cubefield_rotate_user_toprog
  end type rotate_user_t
  !
  type rotate_prog_t
     type(ancillary_cube_prog_t) :: angle
     type(cube_t), pointer       :: fx
     type(cube_t), pointer       :: fy
     type(cube_t), pointer       :: fu
     type(cube_t), pointer       :: fv
   contains
     procedure, private :: header => cubefield_rotate_prog_header
     procedure, private :: data   => cubefield_rotate_prog_data
     procedure, private :: loop   => cubefield_rotate_prog_loop
     procedure, private :: act    => cubefield_rotate_prog_act
  end type rotate_prog_t
  !
contains
  !
  subroutine cubefield_rotate_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(rotate_user_t) :: user
    character(len=*), parameter :: rname='ROTATE>COMMAND'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call rotate%parse(line,user,error)
    if (error) return
    call rotate%main(user,error)
    if (error) continue
  end subroutine cubefield_rotate_command
  !
  subroutine cubefield_rotate_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t)  :: oucube
    character(len=*), parameter :: rname='ROTATE>REGISTER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'ROTATE','[fxid fyid]',&
         'Locally rotate a vector field according to an angle field',&
         'Rotate the FX and FY vector components locally by the negative&
         & of the selected angle field and write FU and FV outputs. Use&
         & /ANGLE to select the scalar angle cube for each pixel. The&
         & current runtime expects /ANGLE to resolve to a valid angle&
         & cube even though the syntax keeps it optional.',&
         cubefield_rotate_command,&
         comm%comm,error)
    if (error) return
    call incube%register(&
         'FXID',&
         'x component of the input vector field',&
         'Use the X component of the input vector field. If omitted, use&
         & the last matching cube (*dx*) in the default index (DAG by&
         & default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_dx],&
         code_read,&
         code_access_imaset,&
         comm%fx,&
         error)
    call incube%register(&
         'FYID',&
         'y component of the input vector field',&
         'Use the Y component of the input vector field. If omitted, use&
         & the last matching cube (*dy*) in the default index (DAG by&
         & default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_dy],&
         code_read,&
         code_access_imaset,&
         comm%fy,&
         error)
    if (error) return
    call comm%angle%fully_register(&
         'ANGLE','[angleid]',&
         'Scalar field of rotation angles',strg_emp,&
         'ANGLE','Rotation angle',&
         [flag_angle],&
         code_arg_optional,&
         code_read,&
         code_access_imaset,&
         error,&
         cubehelp='Use the angle field. If omitted, use the last matching&
         & cube (*angle*) in the default index (DAG by default; see&
         & SET\INDEX).')
    if (error) return
    !
    ! Product
    call oucube%register(&
         'FU',&
         'Rotated x component of the output vector field',&
         strg_emp,&
         [flag_rotated,flag_dx],&
         comm%fu,&
         error)
    if (error) return
    call oucube%register(&
         'FV',&
         'Rotated y component of the output vector field',&
         strg_emp,&
         [flag_rotated,flag_dy],&
         comm%fv,&
         error)
    if (error) return
  end subroutine cubefield_rotate_register
  !
  subroutine cubefield_rotate_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! ROTATE fxid fyid
    !----------------------------------------------------------------------
    class(rotate_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(rotate_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ROTATE>PARSE'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%fx,error)
    if (error) return
    call cubeadm_cubeid_parse(line,comm%comm,user%fy,error)
    if (error) return
    call comm%angle%parse(line,user%angle,error)
    if (error) return
  end subroutine cubefield_rotate_parse
  !
  subroutine cubefield_rotate_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_comm_t), intent(in)    :: comm
    type(rotate_user_t),  intent(inout) :: user
    logical,              intent(inout) :: error
    !
    type(rotate_prog_t) :: prog
    character(len=*), parameter :: rname='ROTATE>MAIN'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefield_rotate_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubefield_rotate_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_user_t), intent(in)    :: user
    type(rotate_comm_t),  intent(in)    :: comm
    type(rotate_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ROTATE>USER>TOPROG'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    ! *** JP: there should be a check that the input cubes are consistent
    call cubeadm_get_header(comm%fx,user%fx,prog%fx,error)
    if (error) return
    call cubeadm_get_header(comm%fy,user%fy,prog%fy,error)
    if (error) return
    call user%angle%toprog(comm%angle,prog%angle,error)
    if (error) return
  end subroutine cubefield_rotate_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubefield_rotate_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_prog_t), intent(inout) :: prog
    type(rotate_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='ROTATE>PROG>HEADER'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%fu,prog%fx,prog%fu,error)
    if (error) return
    call cubeadm_clone_header(comm%fv,prog%fy,prog%fv,error)
    if (error) return
  end subroutine cubefield_rotate_prog_header
  !
  subroutine cubefield_rotate_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(rotate_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='ROTATE>PROG>DATA'
    !
    call cubefield_message(fieldseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefield_rotate_prog_data
  !   
  subroutine cubefield_rotate_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_prog_t),     intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: angle,fx,fy,fu,fv
    character(len=*), parameter :: rname='ROTATE>PROG>LOOP'
    !
    call angle%associate('angle',prog%angle%cube,iter,error)
    if (error) return
    call fx%associate('fx',prog%fx,iter,error)
    if (error) return
    call fy%associate('fy',prog%fy,iter,error)
    if (error) return
    call fu%allocate('fu',prog%fu,iter,error)
    if (error) return
    call fv%allocate('fv',prog%fv,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,angle,fx,fy,fu,fv,error)
      if (error) return
    enddo
  end subroutine cubefield_rotate_prog_loop
  !   
  subroutine cubefield_rotate_prog_act(prog,ie,angle,fx,fy,fu,fv,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(rotate_prog_t), intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: angle
    type(image_t),        intent(inout) :: fx
    type(image_t),        intent(inout) :: fy
    type(image_t),        intent(inout) :: fu
    type(image_t),        intent(inout) :: fv
    logical,              intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    real(kind=dble_k) :: ang,cosang,sinang
    character(len=*), parameter :: rname='ROTATE>PROG>ACT'
    !
    call angle%get(ie,error)
    if (error) return
    call fx%get(ie,error)
    if (error) return
    call fy%get(ie,error)
    if (error) return
    do iy=1,angle%ny
       do ix=1,angle%nx
          ang = -angle%val(ix,iy)
          cosang = cos(ang)
          sinang = sin(ang)
          fu%val(ix,iy) = fx%val(ix,iy)*cosang-fy%val(ix,iy)*sinang
          fv%val(ix,iy) = fx%val(ix,iy)*sinang+fy%val(ix,iy)*cosang
       enddo ! ix
    enddo ! iy
    call fu%put(ie,error)
    if (error) return
    call fv%put(ie,error)
    if (error) return
  end subroutine cubefield_rotate_prog_act
end module cubefield_rotate
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine w4tow4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 4-bytes words. In practice, use integer*4
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w4tow4
!
subroutine r4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*4. In practice, use integer*4 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*4 bit pattern during the copy,
  ! especially if value is a NaN
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor4
!
subroutine r8tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*8. In practice, use integer*8 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*8 bit pattern during the copy,
  ! especially if value is a NaN.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor8
!
subroutine r8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor4
!
subroutine r4tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor8
!
subroutine i4tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor8
!
subroutine i4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor4
!
subroutine r4toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r4toi4
!
subroutine r8toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r8toi4
!
subroutine i8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor4
!
subroutine r4toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) = 9223372036854775807_8
    endif
  enddo
end subroutine r4toi8
!
subroutine l4tol4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of logical*4. Be conservative: use integer*4 type
  ! because any bit pattern is valid in this representation. Not sure of
  ! what happens in case of invalid logical value.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine l4tol4
!
subroutine i4toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi4
!
subroutine i8toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8toi8
!
subroutine i4toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi8
!
subroutine i8toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = imoins
    elseif (in(i).gt.iplus) then
      out(i) = iplus
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4
!
subroutine i8tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor8
!
subroutine r8toi8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: in(*)   !
  integer(kind=8), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) =  9223372036854775807_8
    endif
  enddo
end subroutine r8toi8
!
subroutine c4toc4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex(kind=4), intent(in)  :: in(*)   !
  complex(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4toc4
!
subroutine c4tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex,         intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4tor4
!
subroutine r4toc4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  complex(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r4toc4
!
subroutine c8tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  double complex,  intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c8tor4
!
subroutine r4toc8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: in(*)   !
  double complex,  intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4toc8
!
subroutine i2toi4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  integer(kind=4), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2toi4
!
subroutine adtoad(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)  :: in(*)   !
  integer(kind=address_length), intent(out) :: out(*)  !
  integer(kind=4),              intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine adtoad
!
subroutine i2tor4(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  real(kind=4),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2tor4
!
subroutine i2tor8(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=2), intent(in)  :: in(*)   !
  real(kind=8),    intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i) = in(i)
  enddo
end subroutine i2tor8
!
subroutine bytoby(in,out,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=1), intent(in)  :: in(*)   !
  integer(kind=1), intent(out) :: out(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine bytoby
!
subroutine bytoch(in,ch,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Copy a Byte array into a Fortran character String
  !---------------------------------------------------------------------
  integer(kind=1),  intent(in)    :: in(*)  !
  character(len=*), intent(inout) :: ch     ! Ifort complains if intent(out)
  integer(kind=4),  intent(in)    :: n      ! [bytes]
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ich
  integer(kind=4) :: i, m
  !
  ich = bytpnt(locstr(ch),membyt)
  m = min(n,len(ch))
  do i=1,m
    membyt(ich+i-1) = in(i)
  enddo
end subroutine bytoch
!
subroutine chtoby(ch,out,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Copy a Fortran character String into a Byte array
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: ch      !
  integer(kind=1),  intent(out) :: out(*)  !
  integer(kind=4),  intent(in)  :: n       ! [bytes]
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ich
  integer(kind=4) :: i, m
  !
  ich = bytpnt(locstr(ch),membyt)
  m = min(n,len(ch))
  do i=1,m
    out(i) = membyt(ich+i-1)
  enddo
end subroutine chtoby
!
subroutine w4toch(in,ch,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Same as bytoch except number of elements is in words (not bytes).
  ! Suited for arrays multiple of 4-bytes.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: in(*)  !
  character(len=*), intent(inout) :: ch     !
  integer(kind=4),  intent(in)    :: n      ! [words]
  !
  call bytoch(in,ch,n*4)
  !
end subroutine w4toch
!
subroutine chtow4(ch,out,n)
  use gildas_def
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Same as chtoby except number of elements is in words (not bytes).
  ! Suited for arrays multiple of 4-bytes.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: ch      !
  integer(kind=4),  intent(out) :: out(*)  !
  integer(kind=4),  intent(in)  :: n       ! [words]
  !
  call chtoby(ch,out,n*4)
  !
end subroutine chtow4
!
! Below duplicate of the subroutines, but which accept number of elements
! to be copied as integers of kind=size_length.
!
subroutine w4tow4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 4-bytes words. In practice, use integer*4
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w4tow4_sl
!
subroutine w8tow8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of 'untyped' 8-bytes words. In practice, use integer*8
  ! type because any bit pattern is valid in this representation
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine w8tow8_sl
!
subroutine r4tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*4. In practice, use integer*4 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*4 bit pattern during the copy,
  ! especially if value is a NaN
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor4_sl
!
subroutine r8tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of real*8. In practice, use integer*8 type because any
  ! bit pattern is valid in this representation. Some compilers and/or
  ! architectures may change the real*8 bit pattern during the copy,
  ! especially if value is a NaN.
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor8_sl
!
subroutine r8tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r8tor4_sl
!
subroutine r4tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine r4tor8_sl
!
subroutine l4tol4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Copy a list of logical*4. Be conservative: use integer*4 type
  ! because any bit pattern is valid in this representation. Not sure of
  ! what happens in case of invalid logical value.
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine l4tol4_sl
!
subroutine i4tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor8_sl
!
subroutine i4tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4tor4_sl
!
subroutine r4toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r4toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r4toi4_sl
!
subroutine r8toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -2147483648
    elseif  (in(i).le.iplus) then
      out(i) = nint(in(i),kind=4)
    else
      out(i) = 2147483647
    endif
  enddo
end subroutine r8toi4_sl
!
subroutine i8tor4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  real(kind=4),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor4_sl
!
subroutine r4toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi4_fini instead.
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) = 9223372036854775807_8
    endif
  enddo
end subroutine r4toi8_sl
!
subroutine i4toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i4toi8_sl
!
subroutine i8toi4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  integer(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = imoins
    elseif (in(i).gt.iplus) then
      out(i) = iplus
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_sl
!
subroutine i8tor8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine i8tor8_sl
!
subroutine r8toi8_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Do not check for non-finite values (NaN, +Inf, -Inf) which might be
  ! a serious problem. Use r8toi8_fini instead.
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  integer(kind=8),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (in(i).lt.imoins) then
      out(i) = -9223372036854775808_8
    elseif (in(i).le.iplus) then
      out(i) = nint(in(i),kind=8)
    else
      out(i) =  9223372036854775807_8
    endif
  enddo
end subroutine r8toi8_sl
!
subroutine c4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  complex(kind=4),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine c4toc4_sl
!
subroutine r4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r4toc4_sl
!
subroutine r8toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine r8toc4_sl
!
subroutine i4toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine i4toc4_sl
!
subroutine i8toc4_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)  :: in(*)   !
  complex(kind=4),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    out(i) = cmplx(in(i),kind=4)
  enddo
end subroutine i8toc4_sl
!
subroutine r4toi4_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r4toi4_fini
!
subroutine r4toi8_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: in(*)   !
  integer(kind=8), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r4toi8_fini
!
subroutine r8toi4_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r8toi4_fini
!
subroutine r8toi8_fini(in,out,n,error)
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: in(*)   !
  integer(kind=8), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r8toi8_fini
!
subroutine i8toi4_fini(in,out,n,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: in(*)   !
  integer(kind=4), intent(out)   :: out(*)  !
  integer(kind=4), intent(in)    :: n       !
  logical,         intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_fini
!
subroutine r4toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r4toi4_fini_sl
!
subroutine r4toi8_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: in(*)   !
  integer(kind=8),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini4(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r4toi8_fini_sl
!
subroutine r8toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: iplus = 2147483647d0 ! 2**31-1
  real(kind=8), parameter :: imoins = -2147483648d0 ! -2**31
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*4')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=4)
    endif
  enddo
end subroutine r8toi4_fini_sl
!
subroutine r8toi8_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Check for non-finite values (NaN, +Inf, -Inf)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)    :: in(*)   !
  integer(kind=8),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  real(kind=8), parameter :: imoins = -2.0d0**63
  real(kind=8), parameter :: iplus = 2.0d0**63-1
  !
  do i=1,n
    if (.not.sic_fini8(in(i))) then
      call gsys_message(seve%e,rname,  &
        'Cannot convert non-finite value (NaN, +Inf or -Inf) to INTEGER*8')
      error = .true.
      return
    elseif (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'Float value is too large to accomodate in an INTEGER*8')
      error = .true.
      return
    else
      out(i) = nint(in(i),kind=8)
    endif
  enddo
end subroutine r8toi8_fini_sl
!
subroutine i8toi4_fini_sl(in,out,n,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=8),           intent(in)    :: in(*)   !
  integer(kind=4),           intent(out)   :: out(*)  !
  integer(kind=size_length), intent(in)    :: n       !
  logical,                   intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=size_length) :: i
  integer(kind=8), parameter :: iplus = 2147483647_8 ! 2**31-1
  integer(kind=8), parameter :: imoins = -2147483648_8 ! -2**31
  !
  do i=1,n
    if (in(i).lt.imoins) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    elseif (in(i).gt.iplus) then
      call gsys_message(seve%e,rname,  &
        'INTEGER*8 value is too large to accomodate in an INTEGER*4')
      error = .true.
      return
    else
      out(i) = in(i)
    endif
  enddo
end subroutine i8toi4_fini_sl
!
subroutine bytoby_sl(in,out,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=1),           intent(in)  :: in(*)   !
  integer(kind=1),           intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    out(i)=in(i)
  enddo
end subroutine bytoby_sl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_fullcube2fullcube
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: fullcube2fullcube
  private
  !
  type :: fullcube2fullcube_comm_t
     type(option_t), pointer :: comm  
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube
  contains
     procedure, public  :: register => cubetemplate_fullcube2fullcube_comm_register
     procedure, private :: parse    => cubetemplate_fullcube2fullcube_comm_parse
     procedure, private :: main     => cubetemplate_fullcube2fullcube_comm_main
  end type fullcube2fullcube_comm_t
  type(fullcube2fullcube_comm_t) :: fullcube2fullcube
  !
  type fullcube2fullcube_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_fullcube2fullcube_user_toprog
  end type fullcube2fullcube_user_t
  !
  type fullcube2fullcube_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
     type(cube_t), pointer   :: incube
     type(cube_t), pointer   :: oucube
   contains
     procedure, private :: header => cubetemplate_fullcube2fullcube_prog_header
     procedure, private :: data   => cubetemplate_fullcube2fullcube_prog_data
     procedure, private :: loop   => cubetemplate_fullcube2fullcube_prog_loop
     procedure, private :: act    => cubetemplate_fullcube2fullcube_prog_act
  end type fullcube2fullcube_prog_t
  !
contains
  !
  subroutine cubetemplate_fullcube2fullcube_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(fullcube2fullcube_user_t) :: user
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call fullcube2fullcube%parse(line,user,error)
    if (error) return
    call fullcube2fullcube%main(user,error)
    if (error) continue
  end subroutine cubetemplate_fullcube2fullcube_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(inout) :: comm
    logical,                         intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
!         'FULLCUBE2FULLCUBE','[cubeid]',& ! *** JP: SIC limitation?
         'FULCUBE2FULCUBE','[cubeid]',&
         'Template command for per-fullcube input and output access',&
         'Input cubes must be real and output cubes will be real.',&
         cubetemplate_fullcube2fullcube_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_fullset,&
         comm%incube,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_fullcube2fullcube_comm_register
  !
  subroutine cubetemplate_fullcube2fullcube_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! fulcube2fulcube cubeid
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(in)    :: comm
    character(len=*),                intent(in)    :: line
    type(fullcube2fullcube_user_t),  intent(out)   :: user
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_comm_parse
  !
  subroutine cubetemplate_fullcube2fullcube_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_comm_t), intent(in)    :: comm
    type(fullcube2fullcube_user_t),  intent(inout) :: user
    logical,                         intent(inout) :: error
    !
    type(fullcube2fullcube_prog_t) :: prog
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>COMM>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_fullcube2fullcube_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_user_t), intent(in)    :: user
    type(fullcube2fullcube_comm_t),  intent(in)    :: comm
    type(fullcube2fullcube_prog_t),  intent(out)   :: prog
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_fullcube2fullcube_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(fullcube2fullcube_comm_t),  intent(in)    :: comm
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%oucube,prog%incube,prog%oucube,error)
    if (error) return
    call prog%factor%header(prog%oucube,error)
    if (error) return
    call prog%region%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_fullcube2fullcube_prog_header
  !
  subroutine cubetemplate_fullcube2fullcube_prog_data(prog,error)
    use cubeadm_opened
    use cubeadm_taskloop
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    ! Structure is simplified compared to other cases because only one task
    ! can work on a full cube at a time by construction!
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    logical,                         intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    type(fullcube_t) :: infull,oufull
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! 1. Open in and out cubes
    ! 2. Prepare parallel tasking (here only one task i.e. no parallelization)
    ! 2. Define iterator of entries (here only one fullcube)
    ! 3. Command feedback
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    ! Note on full cubes association/allocation: in the current command
    ! we know there is only 1 iteration of the tasks (cubeadm_dataiterate_all)
    ! and 1 iteration of the entries (iterate_entry), so this can be done
    ! at any level without troubles. For symmetry with the others entry types,
    ! we should do it in cubetemplate_fullcube2fullcube_prog_loop. However,
    ! when using mixed accesses like in SLICE command (iterate the input cube
    ! as images, into a full cube as output), there are several iterations, so
    ! we DO want to factorize the association/allocation of the full cubes out
    ! of the loops, just here:
    ! Prepare the input cube for getting data
    call infull%associate('infull',prog%incube,error)
    if (error) return
    ! Prepare the output cube for putting data
    call oufull%allocate('oufull',prog%oucube,error)
    if (error) return
    !
    ! Loop on task => Only one task, (i.e. one iteration) => no parallelization statements
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       if (.not.error) &
         call prog%loop(iter,infull,oufull,error)
    enddo ! itask
  end subroutine cubetemplate_fullcube2fullcube_prog_data
  !
  subroutine cubetemplate_fullcube2fullcube_prog_loop(prog,iter,infull,oufull,error)
    use cubeadm_taskloop
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),        intent(inout) :: iter
    type(fullcube_t),                intent(inout) :: infull
    type(fullcube_t),                intent(inout) :: oufull
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>LOOP'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    do while (iter%iterate_entry(error))  ! Only 1 iteration in this case
      ! Get the input full cube
      call infull%get(error)
      if (error) return
      ! Do the computation
      call prog%act(infull,oufull,error)
      if (error) return
      ! Put the output full cube
      call oufull%put(error)
      if (error) return
    enddo  ! ientry
  end subroutine cubetemplate_fullcube2fullcube_prog_loop
  !
  subroutine cubetemplate_fullcube2fullcube_prog_act(prog,infull,oufull,error)
    use cubeadm_fullcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube2fullcube_prog_t), intent(inout) :: prog
    type(fullcube_t),                intent(inout) :: infull
    type(fullcube_t),                intent(inout) :: oufull
    logical,                         intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    character(len=*), parameter :: rname='FULLCUBE2FULLCUBE>PROG>ACT'
    !
    do iz=1,infull%nz
       do iy=1,infull%ny
          do ix=1,infull%nx
             oufull%val(ix,iy,iz) = prog%factor%val*infull%val(ix,iy,iz)
          enddo ! ix
       enddo ! iy
    enddo ! iz
  end subroutine cubetemplate_fullcube2fullcube_prog_act
end module cubetemplate_fullcube2fullcube
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_language
  use cubetools_parameters
  use cubetools_structure
  use cubeset_messaging
  use cubeset_axset
  use cubeset_blanking
  use cubeset_buffering
  use cubeset_colors
  use cubeset_index
  use cubeset_output
  use cubeset_panel
  use cubeset_scaling
  use cubeset_spatial
  use cubeset_spectral
  use cubeset_timing
  use cubeset_units
  !
  public :: cubeset_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubeset_register_language(error)
    !----------------------------------------------------------------------
    ! Register the SET\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'SET',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands that set global behaviors of the program',&
         'SET configures session-wide defaults used by other CUBE commands.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- INDEX selects the default cube index used for command lookup.'//strg_cr//&
         '- SPATIAL, SPECTRAL, and SCALING define default coordinate and view settings.'//strg_cr//&
         '- PANEL and COLORS tune interactive display layout and palette.'//strg_cr//&
         '- UNITS defines default user units for command inputs and outputs.'//strg_cr//&
         '- OUTPUT, BUFFERING, BLANKING, and TIMING control runtime behavior.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> SET\INDEX DAG'//strg_cr//&
         'CUBE> SET\SPATIAL /SIZE 120 120'//strg_cr//&
         'CUBE> SET\SPECTRAL /RANGE * *'//strg_cr//&
         'CUBE> GO\VIEW'//strg_bl//&
         'Note:'//strg_cr//&
         'SET values remain active for the current session until changed.',&
         'gag_doc:hlp/cube-help-set.hlp',&
         cubeset_execute_command,&
         langid,&
         error)
    if (error) return
    !
    call axset%register(error)
    if (error) return
    call blanking%register(error)
    if (error) return
    !
    ! These two commands are registered with name+comm because of
    ! buffers used by these commands that would raise name conflicts
    call bufferingcomm%register(error)
    if (error) return
    call colorcomm%register(error)
    if (error) return
    call index%register(error)
    if (error) return
    call output%register(error)
    if (error) return
    call panel%register(error)
    if (error) return
    call scaling%register(error)
    if (error) return
    call spatial%register(error)
    if (error) return
    call spectral%register(error)
    if (error) return
    call timing%register(error)
    if (error) return
    call units%register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubeset_register_language
  !
  subroutine cubeset_execute_command(line,comm,error)
    !----------------------------------------------------------------------
    ! Execute a command of the SET\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'SET?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubetools_execute_command(line,langid,comm,error)
       if (error) return
       ! There should be no call to cubeadm_finish_all here
    endif
  end subroutine cubeset_execute_command
end module cubeset_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubestatistics_percentile
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_keyval_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubestatistics_messaging
  !
  public :: percentile
  private
  !
  type :: percentile_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(keyvalunit_real_comm_t) :: percentage
     type(cubeid_arg_t), pointer :: cube
     type(cube_prod_t),  pointer :: qlow
     type(cube_prod_t),  pointer :: qhigh
   contains
     procedure, public  :: register => cubestatistics_percentile_comm_register
     procedure, private :: parse    => cubestatistics_percentile_comm_parse
     procedure, private :: main     => cubestatistics_percentile_comm_main
  end type percentile_comm_t
  type(percentile_comm_t) :: percentile  
  !
  type percentile_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
     type(keyvalunit_real_user_t) :: percentage
   contains
     procedure, private :: toprog => cubestatistics_percentile_user_toprog
  end type percentile_user_t
  !
  type percentile_prog_t
     type(cuberegion_prog_t) :: region
     real(kind=sign_k)       :: plow  = 10 ! [%] Percentage of low  percentile
     real(kind=sign_k)       :: phigh = 90 ! [%] Percentage of high percentile (100-plow)
     type(cube_t), pointer   :: cube
     type(cube_t), pointer   :: qlow
     type(cube_t), pointer   :: qhigh
   contains
     procedure, private :: header => cubestatistics_percentile_prog_header
     procedure, private :: data   => cubestatistics_percentile_prog_data
     procedure, private :: loop   => cubestatistics_percentile_prog_loop
     procedure, private :: act    => cubestatistics_percentile_prog_act
  end type percentile_prog_t
  !
contains
  !
  subroutine cubestatistics_percentile_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(percentile_user_t) :: user
    character(len=*), parameter :: rname='PERCENTILE>COMMAND'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call percentile%parse(line,user,error)
    if (error) return
    call percentile%main(user,error)
    if (error) continue
  end subroutine cubestatistics_percentile_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_percentile_comm_register(comm,error)
    use cubetools_unit
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_comm_t), intent(inout) :: comm
    logical,                  intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    type(percentile_prog_t) :: prog
    character(len=*), parameter :: rname='PERCENTILE>COMM>REGISTER'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'PERCENTILE','[cubeid]',&
         'Compute the percentile spectra over the selected spectral channels',&
         'Both the P and 100-P percentile spectra will be computed.&
         & The /SIZE and /CENTER keys are accepted for interface consistency&
         & but ignored during execution.'//strg_bl//&
         'Input/output cubes must be/will be real.',&
         cubestatistics_percentile_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Signal cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    call comm%percentage%register(&
         'AT',&
         'Define the percentile P in percent (0..100)',&
         'Default is 10% if /AT is omitted.',&
         prog%plow,&
         code_unit_unk,&
         strg_emp,&
         error)
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'LOW PERCENTILE',&
         'Low percentile min(P,100-P)%',&
         strg_emp,&
         [flag_low,flag_percentile,flag_spectrum],&
         comm%qlow,&
         error)
    if (error)  return
    call oucube%register(&
         'HIGH PERCENTILE',&
         'High percentile max(P,100-P)%',&
         strg_emp,&
         [flag_high,flag_percentile,flag_spectrum],&
         comm%qhigh,&
         error)
    if (error)  return
  end subroutine cubestatistics_percentile_comm_register
  !
  subroutine cubestatistics_percentile_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! PERCENTILE cubeid /PERCENTAGE val
    !----------------------------------------------------------------------
    class(percentile_comm_t), intent(in)    :: comm
    character(len=*),         intent(in)    :: line
    type(percentile_user_t),  intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='PERCENTILE>COMM>PARSE'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%percentage%parse(line,user%percentage,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubestatistics_percentile_comm_parse
  !
  subroutine cubestatistics_percentile_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_comm_t), intent(in)    :: comm
    type(percentile_user_t),  intent(inout) :: user
    logical,                  intent(inout) :: error
    !
    type(percentile_prog_t) :: prog
    character(len=*), parameter :: rname='PERCENTILE>MAIN'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubestatistics_percentile_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_percentile_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_user_t), intent(in)    :: user
    type(percentile_comm_t),  intent(in)    :: comm
    type(percentile_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    real(kind=sign_k) :: percentage
    character(len=*), parameter :: rname='PERCENTILE>USER>TOPROG'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%percentage%toprog(comm%percentage,percentage,error)
    if (error) return
    if ((percentage.lt.0).or.(100.lt.percentage)) then
       call cubestatistics_message(seve%e,rname,'Percentage outside the [0,100] range')
       error = .true.
       return
    endif
    if (percentage.gt.50) then
       prog%plow  = 100-percentage
       prog%phigh = percentage
    else
       prog%plow  = percentage
       prog%phigh = 100-percentage
    endif
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return
  end subroutine cubestatistics_percentile_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubestatistics_percentile_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_prog_t), intent(inout) :: prog
    type(percentile_comm_t),  intent(in)    :: comm
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='PERCENTILE>PROG>HEADER'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    call one_header(comm%qlow,prog%cube,prog%region,prog%qlow,error)
    if (error) return
    call one_header(comm%qhigh,prog%cube,prog%region,prog%qhigh,error)
    if (error) return
    !
  contains
    !
    subroutine one_header(oucomm,incube,region,oucube,error)
      use cubeadm_clone
      use cubetools_header_methods
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      type(cube_prod_t),       intent(in)    :: oucomm
      type(cube_t), pointer,   intent(in)    :: incube
      type(cuberegion_prog_t), intent(inout) :: region
      type(cube_t), pointer,   intent(inout) :: oucube
      logical,                 intent(inout) :: error
      !
      character(len=unit_l) :: unit
      integer(kind=chan_k), parameter :: one=1
      !
      call cubeadm_clone_header(oucomm,incube,oucube,error)
      if (error) return
      call region%header(oucube,error)
      if (error) return
      call cubetools_header_put_nxny(one,one,oucube%head,error)
      if (error) return
      !
      call cubetools_header_get_array_unit(incube%head,unit,error)
      if (error) return
      call cubetools_header_put_array_unit(trim(unit),oucube%head,error)
      if (error) return
    end subroutine one_header    
  end subroutine cubestatistics_percentile_prog_header
  !
  subroutine cubestatistics_percentile_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(percentile_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PERCENTILE>PROG>DATA'
    !
    call cubestatistics_message(statisticsseve%trace,rname,'Welcome')
    !
    !***JP: The iterator does not know how to handle a subregion for the input
    !***JP: and another size of the output
!    call cubeadm_datainit_all(iter,prog%region,error)
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubestatistics_percentile_prog_data
  !   
  subroutine cubestatistics_percentile_prog_loop(prog,iter,error)
    use cubetools_array_types
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image,qlow,qhigh
    type(real_1d_t) :: good
    character(len=*), parameter :: rname='PERCENTILE>PROG>LOOP'
    !
    call image%associate('cube',prog%cube,iter,error)
    if (error) return
    call good%reallocate('good',image%nx*image%ny,error)
    if (error) return
    call qlow%allocate('qlow',prog%qlow,iter,error)
    if (error) return
    call qhigh%allocate('qhigh',prog%qhigh,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,image,good,qlow,qhigh,error)
      if (error) return
    enddo ! ie
  end subroutine cubestatistics_percentile_prog_loop
  !   
  subroutine cubestatistics_percentile_prog_act(prog,ie,image,good,qlow,qhigh,error)
    use cubetools_array_types
    use cubeadm_image_types
    use cubemain_statistics_tool
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(percentile_prog_t), intent(inout) :: prog
    integer(kind=entr_k),     intent(in)    :: ie
    type(image_t),            intent(inout) :: image
    type(real_1d_t),          intent(inout) :: good
    type(image_t),            intent(inout) :: qlow
    type(image_t),            intent(inout) :: qhigh
    logical,                  intent(inout) :: error
    !
    type(real_1d_t) :: reshaped
    integer(kind=pixe_k), parameter :: one=1
    character(len=*), parameter :: rname='PERCENTILE>PROG>ACT'
    !
    call image%get(ie,error)
    if (error) return
    call reshape%from_2d_to_1d(image,reshaped,'reshaped',error)
    if (error) return
    call good%unblank(reshaped,error)
    if (error) return
    ! qlow must be computed before qhigh
    qlow%val(one,one) = statistics%percentile(good%val,good%n,prog%plow)
    call qlow%put(ie,error)
    if (error) return
    qhigh%val(one,one) = statistics%percentile(good%val,good%n,prog%phigh)
    call qhigh%put(ie,error)
    if (error) return    
  end subroutine cubestatistics_percentile_prog_act
end module cubestatistics_percentile
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gcore_interfaces_public_c
  !---------------------------------------------------------------------
  ! Fortran interfaces to C public subroutines (hand made)
  !---------------------------------------------------------------------
  !
  interface
    subroutine hsv_to_rgb(h,s,v,r,g,b)
      real(kind=4), intent(in)  :: h  !
      real(kind=4), intent(in)  :: s  !
      real(kind=4), intent(in)  :: v  !
      real(kind=4), intent(out) :: r  !
      real(kind=4), intent(out) :: g  !
      real(kind=4), intent(out) :: b  !
    end subroutine hsv_to_rgb
  end interface
  !
  interface
    subroutine rgb_to_hsv(r,g,b,h,s,v)
      real(kind=4), intent(in)  :: r  !
      real(kind=4), intent(in)  :: g  !
      real(kind=4), intent(in)  :: b  !
      real(kind=4), intent(out) :: h  !
      real(kind=4), intent(out) :: s  !
      real(kind=4), intent(out) :: v  !
    end subroutine rgb_to_hsv
  end interface
  !
end module gcore_interfaces_public_c

* DECK lsame.f
      LOGICAL          FUNCTION LSAME( CA, CB )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          CA, CB
*     ..
*
*  Purpose
*  =======
*
*  LSAME returns .TRUE. if CA is the same letter as CB regardless of
*  case.
*
*  Arguments
*  =========
*
*  CA      (input) CHARACTER*1
*  CB      (input) CHARACTER*1
*          CA and CB specify the single characters to be compared.
*
* =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          ICHAR
*     ..
*     .. Local Scalars ..
      INTEGER            INTA, INTB, ZCODE
*     ..
*     .. Executable Statements ..
*
*     Test if the characters are equal
*
      LSAME = CA.EQ.CB
      IF( LSAME )
     $   RETURN
*
*     Now test for equivalence if both characters are alphabetic.
*
      ZCODE = ICHAR( 'Z' )
*
*     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
*     machines, on which ICHAR returns a value with bit 8 set.
*     ICHAR('A') on Prime machines returns 193 which is the same as
*     ICHAR('A') on an EBCDIC machine.
*
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
*
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
*
*        ASCII is assumed - ZCODE is the ASCII code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
*
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
*
*        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.
     $       INTA.GE.145 .AND. INTA.LE.153 .OR.
     $       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.
     $       INTB.GE.145 .AND. INTB.LE.153 .OR.
     $       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
*
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
*
*        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
*        plus 128 of either lower or upper case 'Z'.
*
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA.EQ.INTB
*
*     RETURN
*
*     End of LSAME
*
      END
* DECK lsamen.f
      LOGICAL          FUNCTION LSAMEN( N, CA, CB )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    CA, CB
      INTEGER            N
*     ..
*
*  Purpose
*  =======
*
*  LSAMEN  tests if the first N letters of CA are the same as the
*  first N letters of CB, regardless of case.
*  LSAMEN returns .TRUE. if CA and CB are equivalent except for case
*  and .FALSE. otherwise.  LSAMEN also returns .FALSE. if LEN( CA )
*  or LEN( CB ) is less than N.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of characters in CA and CB to be compared.
*
*  CA      (input) CHARACTER*(*)
*  CB      (input) CHARACTER*(*)
*          CA and CB specify two character strings of length at least N.
*          Only the first N characters of each string will be accessed.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          LEN
*     ..
*     .. Executable Statements ..
*
      LSAMEN = .FALSE.
      IF( LEN( CA ).LT.N .OR. LEN( CB ).LT.N )
     $   GO TO 20
*
*     Do for each character in the two strings.
*
      DO 10 I = 1, N
*
*        Test if the characters are equal using LSAME.
*
         IF( .NOT.LSAME( CA( I: I ), CB( I: I ) ) )
     $      GO TO 20
*
   10 CONTINUE
      LSAMEN = .TRUE.
*
   20 CONTINUE
      RETURN
*
*     End of LSAMEN
*
      END

module classmap_interfaces_public
  interface
    subroutine load_map(error)
      use xymap_def
      !---------------------------------------------------------------------
      ! @ public (for libclass only)
      ! MAP initialization routine:
      ! MAP language is loaded.
      !---------------------------------------------------------------------
      logical, intent(out) :: error     ! Error status
    end subroutine load_map
  end interface
  !
end module classmap_interfaces_public

subroutine mx_uvmap (u,b,m,grid,mapu,mapv,work,sblock,cpu0,rms)
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  use mapping_interfaces
  use mx_parameters
  use uvstat_tool, only: prnoise
  !---------------------------------------------------------------------
  ! MX:
  ! UVMAP Compute a map from a CLIC UV Sorted Table
  ! by Gridding and Fast Fourier Transform, with
  ! one single beam for all channels.
  !
  ! Input : (in X)
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image (in B)
  ! a VLM cube   (in Y)
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  ! a  complex plane
  ! Save results
  ! The grid correction GRID
  ! The UV coordinates  MAPU, MAPV
  ! The UV weight array WE_ADDR
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: u,b,m    !
  real :: grid(map_size(1),map_size(2))   !
  real :: mapu(map_size(1))                         !
  real :: mapv(map_size(2))                         !
  real :: work(*)                         !
  integer(4) :: sblock                    !
  real :: cpu0                            !
  real :: rms                             !
  ! Global
  type(gildas) :: uin
  ! Local
  real, allocatable :: natural_weight(:)  !
  complex, allocatable :: ipf(:,:)        ! Local FFT work space
  real, allocatable :: ipxc(:), ipyc(:)   ! Coordinate buffers
  integer :: ier, ns, j
  !
  ! in Module... ! real(8) :: freq
  real(8), parameter :: clight=299792458d-6  ! Frequency in MHz
  integer :: nx,ny,nc,nv,ctypx,ctypy, ndim, nn(2)
  real :: cpu1
  real :: xparm(10),yparm(10),null_taper(4)
  real :: vref,voff,vinc,uvmax,uvmin,wall
  real(kind=4) :: loff,boff
  real(8) :: dcol
  logical :: error
  integer :: icol, nvs
  integer :: i,nblock,iblock,kz,istart
  character(len=80) :: name,chain
  !
  data xparm/10*0/, yparm/10*0/, null_taper/4*0.0/
  !------------------------------------------------------------------------
  ! Code:
  nx = map_size(1)
  ny = map_size(2)
  !
  ! Input file
  name = uv_table
  call gildas_null(uin, type='UVT')
  call gdf_read_gildas (uin,name,'.uvt',error, data=.false.)
  if (error) then
    call gagout('F-MX_UVMAP,  Cannot read input UV table')
    goto 999
  endif
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  nv = uin%gil%dim(2)
  nc = uin%gil%nchan
  allocate (natural_weight(nv), weight(nv), vcoor(nv), stat=ier)
  print *,'Allocate Ier ',ier
  if (ier.ne.0) goto 999
  !
  ier = gdf_range(mcol,nc)
  print *,'Gdf_range ier ',ier
  if (ier.ne.0) goto 999
  if (wcol.eq.0) then
    wcol = (mcol(1)+mcol(2))/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nc)
  nc = mcol(2)-mcol(1)+1
  !
  ! Copy UV data set to MX data set: extract the planes to be imaged ?
  call mx_uvsort (u,uin,uv_table,new,shift,uvmax,uvmin,error)
  if (error) then
    call gagout('F-MX_UVMAP,  Cannot sort input UV table')
    goto 999
  endif
  Print *,'Done mx_uvsort'
  !
  vref = u%gil%ref(1)
  voff = u%gil%voff
  vinc = u%gil%vres
  icol = u%gil%fcol-1+u%gil%natom*wcol
  !
  ! Compute observing sky frequency for U,V cell size
  dcol = (mcol(1)+mcol(2))*0.5d0
  freq = gdf_uv_frequency(u,dcol)
  !
  ! Now create Complex VLM work cube
  call gag_cpu(cpu1)
  write(chain,1001) 'I-MX_UVMAP,  Start gridding ',cpu1-cpu0
  call gagout(chain)
  !
  ! Compute gridding function
  ctypx = ctype
  ctypy = ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  Print *,'MAP_CELL ',map_cell
  Print *,'MAP_SIZE ',map_size
  uv_cell(1) = clight/freq/(map_cell(1)*map_size(1))
  uv_cell(2) = clight/freq/(map_cell(2)*map_size(2))
  support(1) = xparm(1)*uv_cell(1) ! In meters
  support(2) = yparm(1)*uv_cell(2) ! In meters
  Print *,'UV_CELL ',uv_cell,freq,clight
  !
  call docoor (nx,-uv_cell(1),mapu)
  call docoor (ny,uv_cell(2),mapv)
  !
  if (sblock.gt.0) then
    ns = min(nc,sblock) + 1
  else
    ns = nc+1
  endif
  allocate (map_tf(ns,nx,ny),stat=ier)
  if (ier.ne.0) goto 999
  !
  nvs = u%gil%dim(1)
  call dovisi (nvs,nv,   &    ! Size of visibility array
     &    u%r2d,    &     ! Visibilities
     &    vcoor ,   &     ! V values
     &    natural_weight, icol)
  wall = sump(nv,natural_weight)
  if (wall.eq.0.0) then
    write(chain,'(A,I3,A)')   &
     &      'E-MX,  Plane ',wcol,' has zero weight'
    call gagout(chain)
    call sysexi(fatale)
  endif
  !
  ! Compute weights
  call doweig (nvs,nv,   &
     &    u%r2d,  &            ! Visibilities
     &    1,2,    &            ! U, V pointers
     &    wcol,   &            ! Weight channel
     &    uniform(1),   &      ! Uniform UV cell size
     &    weight, &            ! Weight array
     &    uniform(2),   &      ! % of uniformity
     &    vcoor,  &            ! V values
     &    error)               !
  if (error)  goto 999
  !
  ! Apply taper
  call dotape (nvs,nv,   &
     &    u%r2d,   &           ! Visibilities
     &    1,2,     &           ! U, V pointers
     &    uv_taper,   &        ! Taper
     &    weight)              ! Weight array
  wall = 1e-3/sqrt(wall)
  call prnoise('MX_UVMAP','Natural',wall,rms)  ! RMS is a scaling factor
  !
  ! Re-normalize the weights and re-count the noise
  call scawei (nv,weight,natural_weight,wall)
  wall = 1e-3/sqrt(wall)
  call prnoise('MX_UVMAP','Expected',wall,rms)
  rms = wall                   ! This is the RMS in Jy/Beam
  !
  ! Compute FFT's
  if (sblock.gt.0) then
    nblock = (nc+sblock-1)/sblock
    kz = min (sblock,nc)
  else
    kz = nc
  endif
  call dofft (nvs,nv,   & ! Size of visibility array
     &    u%r2d,                 &     ! Visibilities
     &    1,2,   &             ! U, V pointers
     &    mcol(1),   &         ! First channel to map
     &    kz,nx,ny,   &        ! Cube size
     &    map_tf,        &     ! FFT cube
     &    mapu,mapv,   &       ! U and V grid coordinates
     &    support,uv_cell,null_taper,   &  ! Gridding parameters
     &    weight, vcoor,  &     ! Weight array
     &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,ctype)
  !
  ! Do not free visibilities
  call gag_cpu(cpu1)
  write(chain,1001) 'I-MX_UVMAP,  Finished gridding ',cpu1-cpu0
  call gagout(chain)
  allocate (ipf(nx,ny), stat=ier)  ! Get work space for FFTs
  if (ier.ne.0) goto 999
  !
  ! Make beam, not normalized
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  call gildas_null(b, type= 'IMAGE')
  call gdf_copy_header (u, b, error)
  b%gil%proj_words = 0
  b%gil%extr_words = 0
  b%gil%ndim = 2
  b%gil%dim(1) = nx
  b%gil%dim(2) = ny
  b%gil%dim(3) = 1
  b%gil%dim(4) = 1
  b%gil%ref(1) = nx/2+1
  b%gil%ref(2) = ny/2+1
  b%gil%val(1) = 0
  b%gil%val(2) = 0
  b%gil%inc(1) = -map_cell(1)        ! Assume EQUATORIAL system
  b%gil%inc(2) = map_cell(2)
  name  = map_name
  call sic_parsef(name,b%file,' ','.beam')
  call gagout('I-MX_UVMAP,  Creating beam file '   &
     &    //b%file(1:lenc(b%file)))
  call gdf_create_image(b, error)
  if (error) then
    call gagout('F-MX_UVMAP,  Cannot create beam image')
    goto 999
  endif
  call extrac (kz+1,nx,ny,kz+1,map_tf, ipf)
  call fourt  (ipf,nn,ndim,-1,1,work)
  allocate (b%r2d(nx,ny), stat=ier)
  call cmtore (ipf,b%r2d,nx,ny)
  !
  ! Compute grid correction,
  ! Normalization factor is applied to grid correction, for further
  ! use on channel maps. Use IPF for work space.
  !
  allocate (ipxc(nx), ipyc(ny), stat=ier)
  call grdtab (ny, conv%vbuff, conv%vbias, ipyc)
  call grdtab (nx, conv%ubuff, conv%ubias, ipxc)
  call dogrid (grid,ipxc,ipyc,nx,ny,b%r2d)
  !
  ! Normalize and Update beam
  call docorr (b%r2d,grid,nx*ny)
  call gag_cpu(cpu1)
  write(chain,1001) 'I-MX_UVMAP,  Finished beam ',cpu1-cpu0
  call gagout(chain)
  !
  ! Create image (in order l m v )
  name  = map_name
  call gildas_null(m, type= 'IMAGE')
  call gdf_copy_header (b, m, error)
  call sic_parsef(name,m%file,' ','.lmv-res')
  call gagout('I-MX_UVMAP,  Creating map file '   &
     &    //m%file(1:lenc(m%file)))
  !
  m%gil%ndim = 3
  m%gil%dim(1) = nx
  m%gil%dim(2) = ny
  m%gil%dim(3) = nc
  m%gil%dim(4) = 1
  m%gil%ref(3) = vref-mcol(1)+1
  m%gil%val(3) = voff
  m%gil%inc(3) = vinc
  ! Projection information (assume equatorial system)
  m%gil%posi_words = 12
  m%gil%proj_words = 9
  m%gil%extr_words = 0                   ! extrema not computed
  m%char%code(1) = 'RA'
  m%char%code(2) = 'DEC'
  m%char%code(3) = 'VELOCITY'
  call equ_to_gal(m%gil%ra,m%gil%dec,0.0,0.0,m%gil%epoc,  &
                  m%gil%lii,m%gil%bii,loff,boff,error)
  m%gil%ptyp = p_azimuthal                   ! Azimuthal (Sin)
  m%char%syst = 'EQUATORIAL'
  m%gil%xaxi = 1
  m%gil%yaxi = 2
  m%gil%faxi = 3
  m%char%unit = 'Jy/beam'
  !
  call gdf_create_image (m,error)
  if (error) then
    call gagout('F-MX_UVMAP,  Cannot create output LMV image')
    goto 999
  endif
  !
  allocate (m%r3d(nx,ny,nc), stat=ier)
  !
  ! Make maps with grid correction
  do i=1,kz
    call extrac (kz+1,nx,ny,i,map_tf, ipf)
    call fourt  (ipf,nn,ndim,-1,1,work)
    call cmtore (ipf,m%r3d(:,:,i),nx,ny)
    call docorr (m%r3d(:,:,i),grid,nx*ny)
  enddo
  j = kz
  !
  ! Proceed with further planes
  if (kz.lt.nc) then
    do iblock = 2,nblock
      istart = mcol(1)+(iblock-1)*sblock
      kz = min (sblock,nc-sblock*(iblock-1))
      call dofft (nvs,nv,   & ! Size of visibility array
     &        u%r2d,        & ! Visibilities
     &        1,2,   &         ! U, V pointers
     &        istart,   &      ! First channel to map
     &        kz,nx,ny,   &    ! Cube size
     &        map_tf,   & ! FFT cube
     &        mapu,mapv,   &   ! U and V grid coordinates
     &        support,uv_cell,null_taper,   &  ! Gridding parameters
     &        weight, vcoor,  &    ! Weight array
     &        conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,ctype)
      !
      do i=1,kz
        j = j+1
        call extrac (kz+1,nx,ny,i,map_tf,ipf)
        call fourt  (ipf,nn,ndim,-1,1,work)
        call cmtore (ipf,m%r3d(:,:,j),nx,ny)
        call docorr (m%r3d(:,:,j),grid,nx*ny)
      enddo
    enddo
  endif
  !
  call gag_cpu(cpu1)
  write(chain,1001) 'I-MX_UVMAP,  Finished maps CPU ',cpu1-cpu0
  call gagout(chain)
  !
  ! Delete scratch space
  return
  !
  999   call sysexi(fatale)
  1001  format(a,f11.2)
end subroutine mx_uvmap

subroutine tagout(line,error)
  use gkernel_interfaces
  use gkernel_types
  use clic_file
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! CLASS	Support routine for command
  !	TAG Quality List_of_scans
  ! Argument
  !	LINE	C*(*)	Command line
  !	ERROR	L	Error flag
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  character(len=40) :: mess
  character(len=10) :: arg,qual
  integer :: mlist, narg
  parameter (mlist=15)
  integer(kind=entry_length) :: if
  integer :: j, ic, iv, nqual, rr
  type(sic_listi4_t) :: list
  type(title_v2_t) :: title_save
  !
  call sic_ke (line,0,1,arg,narg,.true.,error)
  if (error) return
  call get_quality(arg,nqual,qual,error)
  if (error) return
  !
  if (sic_present(0,2)) then
    call check_output_file(error)
    if (error) return
    ic = index(line,' ')+1
    ic = index(line(ic:),' ')+ic
    iv = lenc(line)
    call sic_parse_listi4 ('TAG',line(ic:iv),list,mlist,error)
    if (error) return
  else
    title%qual = nqual
    r_qual = nqual
    return
  endif
  !
  title_save = title
  do j=1,list%nlist
    do 20 rr=list%i1(j),list%i2(j),list%i3(j)
      error = .false.
      do 10 if=1,o%desc%xnext-1
        if (rr.ne.ox_num(if)) goto 10
        call rox(if,error)
        title%qual = nqual
        call mox(if,error)
        goto 20
10    continue
      write(mess,100) rr
      call message(6,2,'TAG',mess)
20  continue
  enddo
  title = title_save
  return
  !
entry ignore(line,error)
  !----------------------------------------------------------------------
  ! CLASS	Support routine for command
  !	IGNORE List_of_scans
  ! Argument
  !	LINE	C*(*)	Command line
  !	ERROR	L	Error flag
  !----------------------------------------------------------------------
  ic = index(line,' ')+1
  iv = lenc(line)
  if (iv.lt.ic) return
  call sic_parse_listi4 ('TAG',line(ic:iv),list,mlist,error)
  if (error) return
  !
  title_save = title  
  do j=1,list%nlist
    do 40 rr=list%i1(j),list%i2(j),list%i3(j)
      error = .false.
      do 30 if=1,i%desc%xnext-1
        if (rr.ne.ix_num(if)) goto 30
        ix_qual(if) = 9
        if (ix_ver(if).gt.0) goto 40
30    continue
40  continue
  enddo
  title = title_save
  return
  !
100 format(1x,'Observation ',i6,' not found')
end subroutine tagout

module cubeio_block
  !---------------------------------------------------------------------
  ! Define a "monoblock" type which reflects the way the data is stored
  ! in file
  !---------------------------------------------------------------------
  use cubetools_parameters
  use cubetools_setup_types
  use cubeio_messaging

  type cubeio_block_t
    integer(kind=4)            :: order = code_null ! UVT or TUV order?
    logical                    :: iscplx = .false.  ! R*4 or C*4?
    real(kind=sign_k),    allocatable :: r4(:,:,:)  ! [nx,ny,nc] (LMV) or [nc,nx,ny] (VLM) R*4 cube slice
    complex(kind=sign_k), allocatable :: c4(:,:,:)  ! [nx,ny,nc] (LMV) or [nc,nx,ny] (VLM) C*4 cube slice
    integer(kind=index_length) :: dim1              ! First dimension (size of alloc), strict
    integer(kind=index_length) :: dim2              ! Second dimension (size of alloc), strict
    integer(kind=index_length) :: dim3              ! Third dimension (size of alloc), maximum available
    integer(kind=index_length) :: first             ! First element of last dimension mapped by the block
    integer(kind=index_length) :: last              ! Last element of last dimension mapped by the block
    logical                    :: readwrite         ! Is this block opened read-only or read-write?
  contains
    procedure, public :: reallocate123 => cubeio_block_reallocate_123
    procedure, public :: reallocatexyc => cubeio_block_reallocate_xyc
    procedure, public :: free          => cubeio_block_free
    procedure, public :: memsize       => cubeio_block_memsize
  end type cubeio_block_t

  public :: cubeio_block_t
  private

contains

  subroutine cubeio_block_reallocate_xyc(block,iscplx,nx,ny,nc,order,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_block_t
    ! Do nothing when the array sizes do not need to change.
    ! ---
    ! This version with nx ny nc as argument
    !-------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(in)    :: iscplx
    integer(kind=pixe_k),  intent(in)    :: nx
    integer(kind=pixe_k),  intent(in)    :: ny
    integer(kind=chan_k),  intent(in)    :: nc
    integer(kind=code_k),  intent(in)    :: order
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='BLOCK>REALLOCATE>XYC'
    integer(kind=data_k) :: dim1,dim2,dim3
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! Sanity checks
    if (nx.lt.0) then
      call cubeio_message(seve%e,rname,'Number of X pixels is null or negative')
      error = .true.
    endif
    if (ny.lt.0) then
      call cubeio_message(seve%e,rname,'Number of Y pixels is null or negative')
      error = .true.
    endif
    if (nc.lt.0) then
      call cubeio_message(seve%e,rname,'Number of channels is null or negative')
      error = .true.
    endif
    if (error)  return
    !
    select case (order)
    case (code_cube_imaset)
      dim1 = max(1,nx)
      dim2 = max(1,ny)
      dim3 = max(1,nc)
    case (code_cube_speset)
      dim1 = max(1,nc)
      dim2 = max(1,nx)
      dim3 = max(1,ny)
    case default
      call cubeio_message(seve%e,rname,'Unsupported data order')
      error = .true.
      return
    end select
    !
    call cubeio_block_reallocate_123(block,iscplx,dim1,dim2,dim3,order,error)
    if (error)  return
    !
  end subroutine cubeio_block_reallocate_xyc

  subroutine cubeio_block_reallocate_123(block,iscplx,dim1,dim2,dim3,order,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate a cubeio_block_t
    ! Do nothing when the array sizes do not need to change.
    ! ---
    ! This version with dim1 dim2 dim3 as argument
    !-------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(in)    :: iscplx
    integer(kind=data_k),  intent(in)    :: dim1
    integer(kind=data_k),  intent(in)    :: dim2
    integer(kind=data_k),  intent(in)    :: dim3
    integer(kind=code_k),  intent(in)    :: order
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='BLOCK>REALLOCATE>123'
    integer(kind=4) :: ier
    logical :: calloc
    !
    ! Allocation or reallocation?
    if (block%iscplx) then
      calloc = allocated(block%c4)
    else
      calloc = allocated(block%r4)
    endif
    if (calloc) then
      ! Reallocation?
      if ((block%iscplx.eqv.iscplx) .and. block%dim1.eq.dim1 .and.  &
          block%dim2.eq.dim2 .and. block%dim3.eq.dim3) then
        ! Same type and same size => Nothing to be done!
        call cubeio_message(ioseve%alloc,rname,'Block array already allocated with correct size')
        goto 100
      else  ! Different type or different size => reallocation
        call cubeio_message(ioseve%alloc,rname,'Reallocating block array')
        call block%free(error)
        if (error)  return
      endif
    else
      ! Allocation
      call cubeio_message(ioseve%alloc,rname,'Creating block array')
    endif
    !
    ! Reallocate memory of the right size
    if (iscplx) then
      allocate(block%c4(dim1,dim2,dim3),stat=ier)
    else
      allocate(block%r4(dim1,dim2,dim3),stat=ier)
    endif
    if (failed_allocate(rname,'Block array',ier,error)) return
    !
  100 continue
    ! Operation success
    block%order  = order
    block%iscplx = iscplx
    block%dim1   = dim1
    block%dim2   = dim2
    block%dim3   = dim3
    block%first  = 0
    block%last   = 0
    block%readwrite = .false.
  end subroutine cubeio_block_reallocate_123

  subroutine cubeio_block_free(block,error)
    !---------------------------------------------------------------------
    ! Free a 'cubeio_block_t' instance
    !---------------------------------------------------------------------
    class(cubeio_block_t), intent(inout) :: block
    logical,               intent(inout) :: error
    !
    block%order     = 0
    block%iscplx    = .false.
    if (allocated(block%c4))  deallocate(block%c4)
    if (allocated(block%r4))  deallocate(block%r4)
    block%dim1      = 0
    block%dim2      = 0
    block%dim3      = 0
    block%first     = 0
    block%last      = 0
    block%readwrite = .false.
  end subroutine cubeio_block_free

  function cubeio_block_memsize(block)
    !-------------------------------------------------------------------
    ! Return the memory footprint in bytes
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubeio_block_memsize
    class(cubeio_block_t), intent(in) :: block
    !
    cubeio_block_memsize = 0
    !
    if (allocated(block%r4)) &
      cubeio_block_memsize = cubeio_block_memsize + size(block%r4,kind=size_length)*4
    !
    if (allocated(block%c4)) &
      cubeio_block_memsize = cubeio_block_memsize + size(block%c4,kind=size_length)*8
    !
  end function cubeio_block_memsize

end module cubeio_block

program array_project
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Project a 2-D array onto the (X,Y,Z) coordinate system at the
  ! given longitude and latitude. An additional N/S stretching factor
  ! can be applied
  !---------------------------------------------------------------------
  ! Global
  real :: calcul_rayon_max
  ! Local
  integer :: modtyp
  integer :: nbant
  real :: diam
  !
  integer :: listconfarray, listaleaflag, maxant, k
  integer :: ier,lun,i
  real :: altitude
  !
  parameter (maxant=256)
  real :: radius
  character(len=4) :: liste_noms(maxant)
  character(len=12) :: instrume, config
  character(len=128) :: file,chain
  real :: liste_diam(maxant), liste_x(maxant), liste_y(maxant)
  real :: liste_z(maxant), ro_min, angle, totsurf
  real :: lx(maxant), ly(maxant), lz(maxant)
  real :: latitude, geopos(2), stretch
  real :: pi, array(32),  cosl, sinl
  integer :: column(3), lcol, fline
  !
  angle = 0.0
  pi = acos(-1.0)
  call gagout('I-ARRAY_PROJECT,  Version 1.2 21-Mar-2016')
  !
  call gildas_open
  call gildas_char('ARRAY$',instrume)
  call gildas_real('LONGITUDE$',geopos,1)
  call gildas_real('LATITUDE$',geopos(2),1)
  latitude = geopos(2)*pi/180.0
  call gildas_char('CONFIGURATION$',config)
  call gildas_real('DIAMETER$',diam,1)
  call gildas_char('FILE$',file)
  call gildas_inte('FIRST$',fline,1)
  call gildas_inte('COLUMNS$',column,3)
  call gildas_real('STRETCH$',stretch,1)
  call gildas_close
  !
  ier = sic_getlun(lun)
  open (unit=lun,file=file,status='old')
  do i=1,fline-1
    read (lun,*)
  enddo
  !
  lcol = max(column(1),column(2))
  lcol = max(lcol,column(3))
  nbant = 0
  do
    read(lun,'(a)',iostat=ier) chain
    if (ier.lt.0) exit ! EOF
    if (ier.gt.0) then
      call gagout('F-ARRAY_PROJECT, Error reading line')
      call sysexi(fatale)
    endif
    if (chain.eq.'') cycle ! empty line
    if (chain(1:1).eq.'#') cycle ! comment line
    read(chain,*,iostat=ier) (array(i),i=1,lcol)
    if (ier.ne.0) then 
      call gagout('F-ARRAY_PROJECT, Error decoding line:')
      call gagout(trim(chain))
      call sysexi(fatale)
    endif
    nbant = nbant+1
    liste_x(nbant) = array(column(1)) 
    liste_y(nbant) = array(column(2)) 
    if (column(3).ne.0) liste_z(nbant) = array(column(3))
  enddo
  close (unit=lun)
  call sic_frelun(lun)
  !
  ! Initial (x,y,z) (in local plane + altitude)
  !     liste_x > 0 towards North
  !     liste_y > 0 towards East
  !     liste_z == Altitude
  !
  ! Caution: CASA convention is offset east first, then offset north
  !
  ! Final (X,Y,Z)
  !     LX > 0 outwards Earth Center // Equator
  !     LY > 0 towards East
  !     LZ > 0 towards North // Earth axis
  !
  cosl = cos(latitude)
  sinl = sin(latitude)
  do k=1,nbant
    liste_x(k) = stretch*liste_x(k)    ! Change the N/S value
    lx(k)= - sinl * liste_x(k) + cosl * liste_z(k)
    ly(k)= liste_y(k)
    lz(k)= cosl * liste_x(k) + sinl * liste_z(k)
  enddo
  !
  do k=1,nbant
    write(liste_noms(k),'(I3)') k
  enddo
  totsurf=nbant*pi*diam**2/4.
  !
  ! Rayon Min ou Max ?
  ro_min=calcul_rayon_max(nbant, liste_x ,liste_y)
  !
  ier = sic_getlun(lun)
  file = instrume(1:lenc(instrume))//'-'//   &
     &    config(1:lenc(config))//'.cfg'
  call sic_lower(file)
  open (unit=lun,file=file,status='UNKNOWN',recl=128,   &
     &    form='FORMATTED')
  altitude = 5000.
  write (lun,'(A)') '! Commentaires:'
  write (lun,'(A,g14.7)') '! ALTITUDE  = ',altitude
  write (lun,'(A,g14.7)') '! LONGITUDE = ',geopos(1)
  write (lun,'(A,g14.7)') '! LATITUDE  = ',geopos(2)
  write (lun,'(A,I5)')    '! NBANT     = ',nbant
  write (lun,'("!")')
  write (lun,'("! Nom Ants, Lx, Ly, Lz, Diam Ants")')
  write (lun,'(A,F7.1)') '! RADIUS     = ',ro_min
  write (lun,'(A,F7.1)') '! ANGLE      = ',angle
  do i=1,nbant
    write (lun,*) liste_noms(i), lx(i), ly(i), lz(i),   &
     &      diam, liste_y(i), liste_x(i)
    print *,liste_noms(i), lx(i), ly(i), lz(i),   &
     &      diam, liste_y(i), liste_x(i)
  enddo
  close(lun)
  !
end program array_project
!<FF>
function calcul_rayon_max(maxant, liste_x ,liste_y)
  real :: calcul_rayon_max          !
  integer ::     maxant             !
  real ::        liste_x(maxant)    !
  real ::        liste_y(maxant)    !
  ! Local
  integer ::     i,j
  real ::        ro_max, ro_cour
  !
  ro_max=0.
  do i=1,maxant
     do j=1,maxant
        ro_cour=(liste_x(i)-liste_x(j))**2+(liste_y(i)-liste_y(j))**2
    	if (ro_cour.gt.ro_max) ro_max=ro_cour
     enddo
  enddo	
  calcul_rayon_max = sqrt(ro_max)
end

module cubelist_list
  use cubetools_parameters
  use cubelist_messaging
  use cubelist_object_class
  use cubelist_object_advanced_class
  use cubelist_list_types
  !---------------------------------------------------------------------
  ! Support module for generic list of list_t contents
  !---------------------------------------------------------------------
  !
  public :: list_column_t
  public :: cubelist_column_ptr
  public :: list_column_list_t
  private
  !
  integer(kind=4), parameter :: col_width_auto=0
  !
  ! Support for 1 column
  type, abstract, extends(list_object_t) :: list_column_t
    character(len=16), public  :: name    ! Column name (identifier)
    character(len=16), public  :: header  ! Column name in header (might be truncated)
    integer(kind=4),   private :: width = col_width_auto  ! Static or dynamic column width
  contains
    procedure(get_lrepr_interface), deferred :: get_lrepr  ! [private]
    procedure(get_repr_interface),  deferred :: get_repr   ! [private]
    procedure,                      private  :: width_auto => cubelist_column_width_auto
    procedure,                      public   :: copy       => cubelist_column_copy
  end type list_column_t
  !
  ! The collection of columns to be listed
  type, extends(list_t) :: list_column_list_t
    logical,                       public  :: doheader = .true.
    integer(kind=4),               public  :: olun = stdout
    logical,                       public  :: dopage = .false.
    character(len=:), allocatable, private :: one(:)  ! One column buffer (for 1 object)
    character(len=:), allocatable, private :: all(:)  ! All columns buffer (for 1 object)
  contains
    procedure, public  :: register  => cubelist_list_register_column
    procedure, public  :: get       => cubelist_list_get_column
    procedure, public  :: widths    => cubelist_list_widths
    generic,   public  :: line      => oneline,manylines
    procedure, private :: oneline   => cubelist_list_one_line
    procedure, private :: manylines => cubelist_list_many_lines
    procedure, public  :: act       => cubelist_list_act
  end type list_column_list_t
  !
contains
  !
  function cubelist_column_ptr(obj,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(list_column_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(list_column_t), pointer :: cubelist_column_ptr
    class(list_object_t), pointer       :: obj
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='COLUMN>PTR'
    !
    select type(obj)
    class is (list_column_t)
      cubelist_column_ptr => obj
    class default
      cubelist_column_ptr => null()
      call cubelist_message(seve%e,rname,  &
        'Internal error: object is not a list_column_t type')
      error = .true.
      return
    end select
  end function cubelist_column_ptr
  !
  subroutine get_lrepr_interface(col,obj,lrepr,error)
    class(list_column_t),          intent(in)    :: col
    class(list_object_advanced_t), intent(in)    :: obj
    integer(kind=4),               intent(out)   :: lrepr
    logical,                       intent(inout) :: error
  end subroutine get_lrepr_interface
  !
  subroutine get_repr_interface(col,obj,lrepr,repr,nline,error)
    class(list_column_t),          intent(inout) :: col
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(in)    :: lrepr
    character(len=*),              intent(out)   :: repr(:)
    integer(kind=4),               intent(out)   :: nline
    logical,                       intent(inout) :: error
  end subroutine get_repr_interface
  !
  subroutine cubelist_column_width_auto(col,list,error)
    !-------------------------------------------------------------------
    ! Compute the best width for one column supporting adaptative width,
    ! based on the index to be listed.
    !-------------------------------------------------------------------
    class(list_column_t), intent(inout) :: col   ! One column to be listed
    class(list_t),        intent(in)    :: list  ! The collection of objects (index) to be listed
    logical,              intent(inout) :: error
    !
    integer(kind=4) :: lrepr
    integer(kind=list_k) :: iobj
    class(list_object_advanced_t), pointer :: obj
    !
    col%width = 1
    do iobj=1,list%n
      obj => cubelist_object_advanced_ptr(list%list(iobj)%p,error)
      if (error)  return
      if (obj%hidden)  cycle
      call col%get_lrepr(obj,lrepr,error)
      if (error)  return
      col%width = max(col%width,lrepr)
    enddo
  end subroutine cubelist_column_width_auto
  !
  subroutine cubelist_column_copy(in,out,error)
    !-------------------------------------------------------------------
    ! Copy the known attributes of the abstract type. Nothing done on
    ! the unknown extended attributes,
    !-------------------------------------------------------------------
    class(list_column_t), intent(in)    :: in
    class(list_column_t), intent(inout) :: out
    logical,              intent(inout) :: error
    out%name = in%name
    out%header = in%header
  end subroutine cubelist_column_copy
  !
  !------------------------------------------------------------------------
  !
  subroutine cubelist_list_register_column(cols,col,name,header,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Register a column in the global column list
    !----------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols
    class(list_column_t),      intent(inout) :: col
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: header
    logical,                   intent(inout) :: error
    !
    ! Attributes
    col%name = name
    col%header = header
    !
    ! Insert in global column list
    call cols%associate(col,error)
    if (error)  return
  end subroutine cubelist_list_register_column
  !
  subroutine cubelist_list_get_column(cols,name,col,error)
    !-------------------------------------------------------------------
    ! Return a pointer to the named column
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(in)    :: cols
    character(len=*),          intent(in)    :: name
    class(list_column_t),      pointer       :: col
    logical,                   intent(inout) :: error
    !
    integer(kind=list_k) :: icol
    character(len=*), parameter :: rname='COLUMN>GET'
    !
    ! ZZZ Implement dichotomic search in sorted list!
    col => null()
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      if (col%name.eq.name)  return
    enddo
    call cubelist_message(seve%e,rname,'Column not found: '//trim(name))
    error = .true.
  end subroutine cubelist_list_get_column
  !
  subroutine cubelist_list_act(cols,list,name,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols
    class(list_t),             intent(in)    :: list
    character(len=*),          intent(in)    :: name  ! Index name
    logical,                   intent(inout) :: error
    !
    integer(kind=list_k) :: ient
    integer(kind=4) :: tt_lines,iline
    character(len=mess_l) :: mess
    class(list_object_advanced_t), pointer :: obj
    character(len=*), parameter :: rname='LIST'
    !
    if (list%n.le.0) then
      call cubelist_message(seve%w,rname,'No entry in '//trim(name)//' index')
      return
    endif
    if (cols%n.le.0) then
      call cubelist_message(seve%e,rname,'Internal error: list of colums is empty')
      error = .true.
      return
    endif
    !
    ! Pre-compute columns widths (for those which are dynamic)
    call cols%widths(list,error)
    if (error)  return
    !
    tt_lines = sic_ttynlin()-1
    iline = 0
    !
    if (cols%doheader) then
      ! Print header
      call cubelist_list_header(cols,mess,error)
      if (error)  return
      call cubelist_list_print(mess,cols%olun,iline)
    endif
    !
    do ient=1,list%n
      ! Repeat header if relevant
      if (cols%doheader) then
        if (cols%olun.eq.stdout .and. cols%dopage) then
          if (mod(iline,tt_lines).eq.0) then
            if (hlp_more().ne.0)  return  ! Exit list by user request
            call cubelist_list_header(cols,mess,error)
            if (error)  return
            call cubelist_list_print(mess,cols%olun,iline)
          endif
        endif
      endif
      ! Show line for this object
      obj => cubelist_object_advanced_ptr(list%list(ient)%p,error)
      if (error)  return
      if (obj%hidden)  cycle
      call cubelist_list_object(cols,obj,iline,error)
      if (error)  return
    enddo
    !
    if (cols%doheader) then
      if (iline.gt.tt_lines .and. .not.cols%dopage) then
        ! Long list in non-page mode: repeat header at last line
        call cubelist_list_header(cols,mess,error)
        if (error)  return
        call cubelist_list_print(mess,cols%olun,iline)
      endif
    endif
  end subroutine cubelist_list_act
  !
  subroutine cubelist_list_widths(cols,list,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Compute the best width for columns supporting adaptative width,
    ! based on the index to be listed.
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols  ! The collection of columns to be listed
    class(list_t),             intent(in)    :: list  ! The collection of objects (index) to be listed
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: maxwidth,totwidth,ier
    integer(kind=list_k) :: icol
    class(list_column_t), pointer :: col
    integer(kind=4), parameter :: mline=10
    character(len=*), parameter :: rname='LIST>WIDTHS'
    !
    maxwidth = 0
    totwidth = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      if (col%width.eq.col_width_auto) then
        call col%width_auto(list,error)
        if (error)  return
      endif
      maxwidth = max(maxwidth,col%width)
      totwidth = totwidth+col%width+1
    enddo
    !
    if (allocated(cols%one))  deallocate(cols%one)
    allocate(character(maxwidth)::cols%one(mline),stat=ier)
    if (failed_allocate(rname,'char buffer (1)',ier,error)) return
    if (allocated(cols%all))  deallocate(cols%all)
    allocate(character(totwidth)::cols%all(mline),stat=ier)
    if (failed_allocate(rname,'char buffer (2)',ier,error)) return
  end subroutine cubelist_list_widths
  !
  subroutine cubelist_list_header(cols,mess,error)
    !-------------------------------------------------------------------
    ! Build the header line
    !-------------------------------------------------------------------
    class(list_column_list_t), intent(inout) :: cols  ! The collection of columns to be listed
    character(len=*),          intent(out)   :: mess
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: nc
    integer(kind=list_k) :: icol
    class(list_column_t), pointer :: col
    !
    mess = ''
    nc = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      mess(nc+1:nc+col%width) = col%header
      nc = nc+1+col%width
    enddo
  end subroutine cubelist_list_header
  !
  subroutine cubelist_list_object(cols,obj,cntline,error)
    !-------------------------------------------------------------------
    ! Build and print the line for object 'obj' with the desired columns
    ! 'cols'.
    ! Note that some columns may spawn over several lines.
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    integer(kind=4),               intent(inout) :: cntline
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: mline,iline
    !
    cols%all(:) = ''
    call cols%line(obj,cols%all,mline,error)
    if (error)  return
    do iline=1,mline
      call cubelist_list_print(cols%all(iline),cols%olun,cntline)
    enddo
  end subroutine cubelist_list_object
  !
  subroutine cubelist_list_one_line(cols,obj,repr,error)
    !-------------------------------------------------------------------
    ! Build the line for object 'obj' with the desired columns 'cols'.
    ! Support only one line (see cubelist_list_many_lines)
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    character(len=*),              intent(inout) :: repr
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: nc,icol,nline
    class(list_column_t), pointer :: col
    character(len=*), parameter :: rname='LIST>ONE>LINE'
    !
    nc = 0
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      cols%one(:) = ''
      call col%get_repr(obj,col%width,cols%one,nline,error)
      if (error)  return
      if (nline.gt.1) then
        call cubelist_message(seve%w,rname,  &
          'Column '//trim(col%name)//' requires more than one line')
      endif
      repr(nc+1:nc+col%width) = cols%one(1)
      nc = nc+1+col%width
    enddo
  end subroutine cubelist_list_one_line
  !
  subroutine cubelist_list_many_lines(cols,obj,repr,mline,error)
    !-------------------------------------------------------------------
    ! Build the line for object 'obj' with the desired columns 'cols'.
    ! Note that some columns may spawn over several lines.
    !-------------------------------------------------------------------
    class(list_column_list_t),     intent(inout) :: cols  ! The collection of columns to be listed
    class(list_object_advanced_t), intent(inout) :: obj
    character(len=*),              intent(inout) :: repr(:)
    integer(kind=4),               intent(out)   :: mline  ! Number of lines actually filled
    logical,                       intent(inout) :: error
    !
    integer(kind=4) :: nc,icol,nline,iline
    class(list_column_t), pointer :: col
    !
    nc = 0
    mline = 1
    do icol=1,cols%n
      col => cubelist_column_ptr(cols%list(icol)%p,error)
      if (error)  return
      cols%one(:) = ''
      call col%get_repr(obj,col%width,cols%one,nline,error)
      if (error)  return
      do iline=1,nline
        repr(iline)(nc+1:nc+col%width) = cols%one(iline)
      enddo
      nc = nc+1+col%width
      mline = max(nline,mline)
    enddo
  end subroutine cubelist_list_many_lines
  !
  subroutine cubelist_list_print(message,olun,iline)
    !---------------------------------------------------------------------
    !  Send the message to the given Logical Unit. Quite generic, could
    ! be used in other contexts.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: message
    integer(kind=4),  intent(in)    :: olun
    integer(kind=4),  intent(inout) :: iline  ! Current line number
    !
    character(len=*), parameter :: rname='LIST'
    !
    iline = iline+1
    if (olun.eq.stdout) then
      call cubelist_message(seve%r,rname,message)
    else
      write(olun,'(A)') trim(message)
    endif
  end subroutine cubelist_list_print
  !
end module cubelist_list

subroutine iniloo (line,nline,error)
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>iniloo
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Support for command
  !               FOR Variable n1 TO n2 ....
  !       or      FOR Variable /IN List_Variable_1D
  !       or      FOR /WHILE Logical_Expression
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  integer(kind=4),  intent(in)  :: nline  ! Line length
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FOR'
  integer(kind=4), parameter :: optwhile=2
  integer(kind=4), parameter :: optin=1
  integer(kind=4) :: istart
  character(len=message_length) :: mess
  !
  error=.false.
  !
  if (compil) then
    ! Compilation of a new nested FOR command, increment the buffer level
    if (aloop.ge.mcloop) then
      write(mess,101) mcloop
      call sic_message(seve%e,rname,mess)
      error=.true.
      return
    endif
    lasllo(cloop) = loolen
    lasblo(cloop) = bulend
    ! Encode loop number after command line
    call insloo(line,nline,error)
    if (error) return          ! No more room for loop command.
    loobuf (bulend-1) = aloop+1
    ! Check syntax
    if (sic_present(optwhile,0)) then  ! FOR /WHILE
      ! Can not check: since this FOR /WHILE is nested in another FOR loop,
      ! its logical expression may involve variables not yet defined. No
      ! worry, the expression will be checked at execution time.
      ! call check_loop_logical(aloop+1,line,error)
    elseif (sic_present(optin,0)) then   ! FOR /IN
      if (sic_narg(optin).ne.1) then
        call sic_message(seve%e,rname,'/IN option takes exactly 1 argument')
        error = .true.
      endif
    elseif (sic_present(0,2)) then  ! FOR I 1 TO 3
      call check_loop_variable(aloop+1,line,error)
    else
      call sic_message(seve%e,rname,'No variable or list')
    endif
    if (error) then            ! GD thinks this is very wise...
      ! loobuf(bulend-1) = unreference the new loop (useless since it is desinstalled hereafter)
      call desinsloo
      return
    endif
    aloop = aloop+1            ! Number of loops
    ploop(aloop) = cloop       ! Backward pointer to current loop
    cloop = aloop              ! Current loop
    firllo(cloop) = loolen
    firblo(cloop) = bulend
    !
  elseif (mlire(nlire).lt.-1) then
    ! Execution of a FOR command, dynamical interpretation,
    ! Get loop number from loop buffer
    cloop = loobuf(nloo-1)
    kloo(cloop)=0              ! Compteur de Boucles des indices
    if_loop_level (cloop) = if_current
    if (sic_present(optwhile,0)) then
      ! FOR /WHILE
      call check_loop_logical(cloop,line,error)
      if (error) goto 89
       !
    else if (sic_present(optin,0)) then
      ! FOR Variable /IN List_Variable
      call check_loop_variable(cloop,line,error)
      if (error) goto 89
      call begin_forin(cloop,error)
      if (error) goto 89
      !
    elseif (sic_present(0,2)) then
      ! FOR I Start [TO ...]
      istart = sic_start(0,2)-1
      call sic_parse_listr8(rname,line(istart:),loop_index(cloop),mloop,error)
      if (error) goto 89
      call check_loop_variable(cloop,line,error)
      if (error) goto 89
      loop_length(cloop) = 0
    else
      call sic_message(seve%e,rname,'No variable or list')
      goto 89
    endif
    !
  else
    ! First loop of a new level, compile the command line and set COMPIL
    if (aloop.ge.mcloop) then
      write(mess,101) mcloop
      call sic_message(seve%e,rname,mess)
      error=.true.
      return
    endif
    if (nlire.ge.maxlev-1) then
      error = .true.
      call sic_message(seve%e,rname,'Input level too deep')
      return
    endif
    if (sic_present(optwhile,0)) then
      call check_loop_logical(aloop+1,line,error)
      if (error) return
    elseif (sic_present(optin,0)) then
      call check_loop_variable(aloop+1,line,error)
      if (error) return
      call begin_forin(aloop+1,error)
      if (error) return
    elseif (sic_present(0,2)) then
      istart = sic_start(0,2)-1
      call sic_parse_listr8(rname,line(istart:),loop_index(aloop+1),mloop,error)
      if (error) return
      call check_loop_variable(aloop+1,line,error)
      if (error) return
      loop_length(aloop+1) = 0
    else
      call sic_message(seve%e,rname,'No variable or list')
      goto 89
    endif
    !
    ! OK...
    ifloop(nlire+1) = aloop
    curbyt(nlire+1) = nloo     ! Save Byte pointer
    curlin(nlire+1) = jloo     ! Save Line pointer
    aloop = aloop+1            ! Number of loops
    kloo(aloop) = 0
    compil  = .true.
    ploop(aloop) = cloop       ! Backward pointer to previous level
    cloop   = aloop            ! Current loop number
    firllo(cloop) = loolen
    firblo(cloop) = bulend
  endif
  return
  !
89 error = .true.
  if (nerr(var_level).eq.e_cont) then
    nloo  = lasblo(cloop)
    jloo  = lasllo(cloop)
    error = .false.
  endif
  if (lverif) then
    write(mess,102) cloop
    call sic_message(seve%i,rname,mess)
  endif
  loop_length(cloop) = 0
  cloop = ploop(cloop)
  return
  !
101 format('Only ',i2,' levels of FOR - NEXT loops')
102 format('Loop ',i2,' has finished')
end subroutine iniloo
!
subroutine insloo (line,nline,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>insloo
  use gildas_def
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC
  !   Support for FOR command 
  !   Insert a command line into the current loop buffer
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  integer(kind=4),  intent(in)    :: nline  !
  logical,          intent(inout) :: error  !
  !
  mlen = (nline+3)/4+3
  !
  ! Loop buffer full
  if (mlen+bulend.ge.looend) then
    call sic_message(seve%e,'FOR','Loop buffer overflow')
    error = .true.
    return
  endif
  loobuf(bulend) = nline
  loobuf(bulend+1) = locwrd(loobuf(bulend+2))
  call ctodes (line,nline,loobuf(bulend+1))
  bulend = bulend + mlen
  loolen = loolen + 1
  !
end subroutine insloo
!
subroutine desinsloo
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! This if an error occurs, to be used immediately to forget erroneous
  ! line.
  !---------------------------------------------------------------------
  loolen = loolen - 1
  bulend = bulend - mlen
end subroutine desinsloo
!
subroutine exeloo (error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exeloo
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Execute a FOR - NEXT loop : activated by a NEXT command
  !---------------------------------------------------------------------
  logical, intent(out) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='FOR'
  logical :: logi
  character(len=loop_string_length) :: chain
  integer(kind=4) :: ls, lchoice, lout
  integer(kind=address_length) :: ipnt, opnt
  integer(kind=4) :: loopin, loopva, nstep
  !
  ! Retrieves next index value
  error = .false.
  !
  ! An IF level must be defined even for null loops, otherwise errors occur
  ! at close time if they contain a test.
  if_loop_level (cloop) = if_current
  loopin = loop_var(cloop)
  !!Print *,'EXELOO got loopin ',cloop,loopin
  !
  if (loopin.eq.0) then       ! No variable <==> a logical expression
    ! FOR /WHILE: evaluate the logical expression. See comment in check_loop_logical.
    call sic_shape(chain,loop_string(cloop),1,loop_length(cloop),ls,error)
    if (error)  return
    call sic_math_logi(chain,ls,logi,error)
    !
    ! Once more
    if (.not.error .and. logi) then
      nloo = firblo(cloop)     ! Reset Byte pointer
      jloo = firllo(cloop)     ! Reset Line pointer
      return
    endif
  else if (loopin.gt.0) then
    ! Simple FOR
    call list2(loop_index(cloop),kloo(cloop),indice(cloop),error)
    !
    ! Once more
    if (.not.error) then
      nloo = firblo(cloop)     ! Reset Byte pointer
      jloo = firllo(cloop)     ! Reset Line pointer
      if (lverif) then
        write(chain,101) cloop,indice(cloop)
        call sic_message(seve%i,rname,chain)
      endif
      return
    endif
  else
    ! FOR /IN List
    loop_curarg(cloop) = loop_curarg(cloop)+1
    if (loop_curarg(cloop).le.abs(loop_size(cloop))) then
      nloo = firblo(cloop)     ! Reset Byte pointer
      jloo = firllo(cloop)     ! Reset Line pointer
      !
      loopin = abs(loopin)
      loopva = abs(loop_list(cloop))
      lout = dicvar(loopin)%desc%type
      if (lout.gt.0) then
        ! Character strings
        lchoice = dicvar(loopva)%desc%type
        lout = min(lout,lchoice)  ! Probably not relevant...
        opnt = bytpnt(dicvar(loopin)%desc%addr,membyt)
        ipnt = bytpnt(dicvar(loopva)%desc%addr,membyt) &
          + (loop_curarg(cloop)-1)*lchoice
        call bytoby(membyt(ipnt),membyt(opnt),lout)
      else
        if (lout.eq.fmt_r8 .or.  &
            lout.eq.fmt_i8 .or.  &
            lout.eq.fmt_c4) then
          nstep = 2
        else
          nstep = 1
        endif
        opnt = gag_pointer(dicvar(loopin)%desc%addr,memory)
        ipnt = gag_pointer(dicvar(loopva)%desc%addr,memory) &
          + nstep*(loop_curarg(cloop)-1)
        call w4tow4(memory(ipnt),memory(opnt),nstep)
      endif
      if (lverif)  call exeloo_verif(ipnt,lout)
      return
    endif
  endif
  !
  ! End of loop
  error = .false.
  call finloo()
  !
101 format('Loop ',i0,' is running with index ',1pg24.17)
  !
contains
  subroutine exeloo_verif(ipnt,lout)
    integer(kind=address_length), intent(in) :: ipnt
    integer(kind=4),              intent(inout) :: lout
    ! Local
    character(len=loop_string_length) :: str
    integer(kind=4) :: i4val
    integer(kind=8) :: i8val
    real(kind=4) :: r4val
    real(kind=8) :: r8val
    !
    if (lout.gt.0) then
      call bytoch(membyt(ipnt),str,lout)
      lout = min(lout,loop_string_length-60) ! Avoid Format Overflow
      lout = min(lout,len_trim(str))         ! Avoid trailing spaces
      write(chain,102) cloop,str(1:lout)
    elseif (lout.eq.fmt_i8) then
      call i8toi8(memory(ipnt),i8val,1)
      write(chain,103) cloop,i8val
    else if (lout.eq.fmt_i4) then
      call i4toi4(memory(ipnt),i4val,1)
      write(chain,103) cloop,i4val
    else if (lout.eq.fmt_r8) then
      call r8tor8(memory(ipnt),r8val,1)
      write(chain,104) cloop,r8val
    else if (lout.eq.fmt_r4) then
      call r4tor4(memory(ipnt),r4val,1)
      write(chain,104) cloop,r4val
    endif
    call sic_message(seve%i,rname,chain)
102 format('Loop ',i0,' is running with argument "',A,'"')
103 format('Loop ',i0,' is running with argument [',I0,']')
104 format('Loop ',i0,' is running with argument [',1pg24.17,']')
  end subroutine exeloo_verif
  !
end subroutine exeloo
!
subroutine finloo
  use gbl_message
  use sic_interfaces, except_this=>finloo
  use sic_structures
  use sic_dictionaries
  !----------------------------------------------------------------------
  ! @ private
  ! End of a loop execution
  !----------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='FOR'
  character(len=message_length) :: mess
  integer(kind=4) :: i,lloop
  !
  ! End of a loop (QUIT or BREAK) : reset pointer
  nloo  = lasblo(cloop)
  jloo  = lasllo(cloop)
  !!Print *,'LOOP ',cloop,' Length ',loop_length(cloop),' List ',loop_list(cloop)
  if (loop_length(cloop).eq.0) then
    call delete_loop_variable(cloop)
  endif
  loop_list(cloop) = 0
  loop_size(cloop) = 0
  !
  ! Reset active IF_blocks
  do i=if_loop_level(cloop)+1,if_current
    if_active(i) = .false.
    if_elsefound(i) = .false.
    if_finished(i) = .true.
  enddo
  if_current = if_loop_level(cloop)
  if_last = if_current
  !
  indice(cloop) = 0.0
  kloo(cloop)  = 0
  if (lverif) then
    write(mess,102) cloop
    call sic_message(seve%i,rname,mess)
  endif
  loop_length(cloop) = 0
  lloop = cloop
  cloop = ploop(cloop)
  if (cloop.le.ifloop(nlire)) then
    aloop = ifloop(nlire)
    nloo = curbyt(nlire)       ! Restore Byte pointer
    jloo = curlin(nlire)       ! Save Line pointer
    bulend = firblo(lloop)
    loolen = firllo(lloop)
    nlire = nlire-1
  endif
  !
102 format('Loop ',i2,' has finished')
end subroutine finloo
!
subroutine aboloo
  use gbl_message
  use sic_interfaces, except_this=>aboloo
  use sic_structures
  !----------------------------------------------------------------------
  ! @ private
  ! Abort a loop compilation : decrease loop pointers and exit
  ! compilation mode if needed
  !----------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='FOR'
  character(len=message_length) :: mess
  integer(kind=4) :: lloop,i
  !
  write(mess,103) cloop
  call sic_message(seve%i,rname,mess)
  lloop = cloop
  do i=cloop,aloop
    if (loop_length(i).eq.0) then
      call delete_loop_variable(i)
    else
      loop_length(i) = 0
    endif
  enddo
  cloop = ploop(cloop)
  aloop = cloop
  !
  if (cloop.eq.0) then
    ! Exit compilation mode
    compil=.false.
    bulend = 1
    loolen = 0
  else
    ! Reset end of buffer pointers as for FINLOO
    loolen = firllo(lloop)
    bulend = firblo(lloop)
    if (aloop.eq.ifloop(nlire+1)) compil = .false.
  endif
  return
  !
103 format('Loop ',i2,' compilation aborted')
end subroutine aboloo
!
subroutine check_loop_variable(loop_number,line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>check_loop_variable
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !   Support for FOR command
  !   Check the non-existence of the loop variable specified in command
  ! FOR, and insert it in dictionary.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: loop_number  ! Loop number
  character(len=*), intent(in)    :: line         ! Command line
  logical,          intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='VARIABLE'
  integer, parameter :: optin=1
  type(sic_identifier_t) :: var
  type(sic_identifier_t) :: list
  integer(kind=4) :: in,jn,ier
  !
  call sic_ke (line,0,1,var%name,in,.true.,error)
  if (error) return
  var%lname = len_trim(var%name)
  !
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.eq.1) then
    call sic_message(seve%e,rname,'Variable '//trim(var%name)//  &
    ' already exists')
    error = .true.
    return
  endif
  !
  if (sic_present(optin,0)) then
    if (sic_narg(optin).ne.1) then
      call sic_message(seve%e,rname,'/IN must have one argument')
      error = .true.
      return
    endif
    call sic_ke (line,optin,1,list%name,list%lname,.true.,error)
    if (error) return
    !
    list%level = var_level
    ! FOR Var /IN List  requires an existing List variable
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,list,jn)
    if (ier.ne.1) then
      list%level = 0
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,list,jn)
    endif
    if (ier.ne.1) then
      call sic_message(seve%e,rname,  &
        'Variable '//trim(list%name)//' does not exists')
      error = .true.
      return
    endif
    if (dicvar(jn)%desc%ndim.gt.1) then
      call sic_message(seve%e,rname,  &
        'Variable '//trim(list%name)//' must be scalar or rank 1')
      error = .true.
      return
    endif
    loop_list(loop_number) = jn
    loop_size(loop_number) = desc_nelem(dicvar(jn)%desc)
    !
    ! Create the loop variable, local to current level, same type as the
    ! list array
    call sic_defvariable(dicvar(jn)%desc%type,var%name,var_level.eq.0,error)
    if (error)  return
    !
    ! Locate it
    var%level = var_level
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    loop_var(loop_number) = -in  ! Use sign to identify type of loop
    !
  else
    ! FOR Index Loop    must define its own (Real*8) variable
    ! Insert in variable dictionnary
    ier = sic_hasins(rname,maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.eq.0 .or. ier.eq.2) then
      error = .true.
      return
    endif
    !
    dicvar(in)%desc%addr = locwrd(indice(loop_number))
    dicvar(in)%desc%type = fmt_r8
    dicvar(in)%desc%readonly = .true.
    dicvar(in)%desc%ndim = 0
    dicvar(in)%desc%dims(:) = 1         ! Normally useless, but...
    dicvar(in)%desc%size = 2            ! Do not remove this one!!!
    dicvar(in)%desc%status = program_defined
    loop_var(loop_number) = in
  endif
  !
end subroutine check_loop_variable
!
subroutine delete_loop_variable(loop_number)
  use sic_interfaces, except_this=>delete_loop_variable
  use sic_dictionaries
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Delete loop variable
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: loop_number
  ! Local
  integer(kind=4) :: in,ier
  logical :: error
  !
  in = loop_var(loop_number)
  !
  if (in.gt.0) then  ! FOR I Start [TO ...]
    ! Delete loop variable from dictionary. Note that the associated
    ! memory was pointing to 'indice(loop_number)', which we never
    ! delete
    dicvar(in)%desc%status = empty_operand  ! Mandatory
    ier = sic_hasdel(maxvar,pfvar,pnvar,dicvar,dicvar(in)%id)
    !
  elseif (in.eq.0) then  ! FOR /WHILE
    ! WHILE loops do not define loop variables (nothing to delete here)
    continue
    !
  else  ! in.lt.0  FOR I /IN List
    ! Loop variable was defined with sic_defvariable, its own memory
    ! was allocated. Delete as any other standard variable, else we
    ! would miss some important cleaning (memory, var_pointer, ...)
    error = .false.
    call sic_delvariable(dicvar(-in)%id%name,user=.true.,error=error)
    if (error) return
    !
  endif
  !
  loop_var(loop_number) = 0
  !
end subroutine delete_loop_variable
!
subroutine verify_loop_variable(loop_number,line,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>verify_loop_variable
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !   Support for NEXT Variable
  !   Verify variable name match with the FOR command
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: loop_number  !
  character(len=*), intent(in)    :: line         !
  logical,          intent(inout) :: error        !
  ! Local
  character(len=*), parameter :: rname='FOR'
  integer(kind=4) :: in,nc
  character(len=varname_length) :: varname
  !
  in = abs(loop_var(loop_number))
  if (in.eq.0) then
    call sic_message(seve%e,rname,'No variable for FOR /WHILE loops')
    error = .true.
    return
  endif
  !
  call sic_ke(line,0,1,varname,nc,.true.,error)
  if (error)  return
  !
  if (dicvar(in)%id%name.ne.varname(1:nc)) then
    call sic_message(seve%e,rname,'Wrong loop variable '// &
      varname(1:nc)//' expected '//dicvar(in)%id%name)
    error = .true.
    return
  endif
  !
end subroutine verify_loop_variable
!
subroutine check_loop_logical(loop_number,line,error)
  use sic_interfaces, except_this=>check_loop_logical
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Check that the expression specified in /WHILE option of FOR command
  ! is a valid logical expression.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: loop_number  !
  character(len=*), intent(in)    :: line         !
  logical,          intent(inout) :: error        !
  ! Local
  integer(kind=4), parameter :: optwhile=2
  integer(kind=4) :: is,ls
  logical :: logi
  character(len=loop_string_length) :: chain
  !
  ! 1) Retrieve the raw logical expression. No evaluation! For example with
  !     FOR /WHILE test['j+1']
  ! 'j+1' is not translated, it will be re-evaluated at each iteration.
  ls = sic_len(optwhile,1)
  if (ls.gt.loop_string_length) then
    call sic_message(seve%e,'FOR','Logical expression is too long')
    error = .true.
    return
  endif
  loop_length(loop_number) = ls
  is = sic_start(optwhile,1)
  loop_string(loop_number) =  line(is:is+ls-1)
  !
  ! 2) Check this is a valid logical expression
  call sic_shape(chain,loop_string(loop_number),1,loop_length(loop_number),ls,error)
  if (error)  return
  call sic_math_logi(chain,ls,logi,error)
  if (error)  return
  !
end subroutine check_loop_logical
!
subroutine begin_forin(loop_number,error)
  use sic_interfaces, except_this=>begin_forin
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !     FOR Var /IN List
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: loop_number  ! Current loop number
  logical,          intent(inout) :: error        ! Error flag
  !
  ! Identify loop variable
  loop_curarg(loop_number) = 0
  !
end subroutine begin_forin

subroutine init_lut(error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>init_lut
  use gtv_protocol
  use gtv_plot
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Initialize a look-up-table for colours
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  logical :: is_default
  !
  ! Use the full dynamic allowed by the kind 'bitmap_depth':
  lut_size = bitmap_dynamic_max-1  ! Last is used for blanking
  !
  call load_lut(gbl_colormap,.false.,lut_size+1,.true.,0,error)
  if (error)  return
  !
  ! Define the SIC variables related to images LUT
  call sic_defstructure('LUT',.true.,error)
  if (error)  return
  call sic_def_inte('LUT%MODE',      lut_mode,  0,1,.false.,error)
  call sic_def_logi('LUT%STATIC',    lut_static,    .true., error)
  call sic_def_inte('LUT%SIZE',      lut_size,  0,1,.true., error)
! call sic_def_real('LUT%LUT',       gbl_colormap%hue,1,lut_size,.true., error)
  call sic_def_real('LUT%HUE',       gbl_colormap%hue,1,lut_size,.false.,error)
  call sic_def_real('LUT%SATURATION',gbl_colormap%sat,1,lut_size,.false.,error)
  call sic_def_real('LUT%VALUE',     gbl_colormap%val,1,lut_size,.false.,error)
  call sic_def_real('LUT%RED',       gbl_colormap%r,  1,lut_size,.false.,error)
  call sic_def_real('LUT%GREEN',     gbl_colormap%g,  1,lut_size,.false.,error)
  call sic_def_real('LUT%BLUE',      gbl_colormap%b,  1,lut_size,.false.,error)
  !
  ! Blanking
  call sic_defstructure('LUT%BLANK',.true.,error)
  call sic_def_real('LUT%BLANK%HUE',       gbl_colormap%hue(gbl_colormap%size),0,1,.false.,error)
  call sic_def_real('LUT%BLANK%SATURATION',gbl_colormap%sat(gbl_colormap%size),0,1,.false.,error)
  call sic_def_real('LUT%BLANK%VALUE',     gbl_colormap%val(gbl_colormap%size),0,1,.false.,error)
  call sic_def_real('LUT%BLANK%RED',       gbl_colormap%r(gbl_colormap%size),  0,1,.false.,error)
  call sic_def_real('LUT%BLANK%GREEN',     gbl_colormap%g(gbl_colormap%size),  0,1,.false.,error)
  call sic_def_real('LUT%BLANK%BLUE',      gbl_colormap%b(gbl_colormap%size),  0,1,.false.,error)
  !
  is_default = .true.
  call protocol_loadlut(cw_device,gbl_colormap,is_default)
  !
end subroutine init_lut
!
subroutine load_lut(map,reuse,map_size,color,background,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>load_lut
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Load the appropriate LUT in the input 'map' colormap.
  !---------------------------------------------------------------------
  type(gt_lut),     intent(inout) :: map         !
  logical,          intent(in)    :: reuse       ! Reuse current user's colormap?
  integer(kind=4),  intent(in)    :: map_size    !
  logical,          intent(in)    :: color       ! If not reuse, generate colors?
  integer(kind=4),  intent(in)    :: background  !
  logical,          intent(inout) :: error       !
  !
  call gt_lut_alloc(map,map_size,error)
  if (error)  return
  !
  if (reuse .and. gbl_colormap%size.gt.0 .and. map%size.eq.gbl_colormap%size) then
    map = gbl_colormap
    !
  elseif (color) then
    ! Use default color LUT
    call gt_lut_default(map,map%size-1)
    ! Blanking
    map%r(map%size) = 1.0
    map%b(map%size) = 1.0
    map%g(map%size) = 1.0
    call rgb_to_hsv(map%r(map%size),map%g(map%size),map%b(map%size),  &
                    map%hue(map%size),map%sat(map%size),map%val(map%size))
    !
  elseif (background.eq.1) then
    ! Black LUT
    call gt_lut_rgb(map,map%size-1,1.,0.,1.,0.,1.,0.)
    ! Blanking
    map%r(map%size) = 1.0
    map%b(map%size) = 1.0
    map%g(map%size) = 1.0
    call rgb_to_hsv(map%r(map%size),map%g(map%size),map%b(map%size),  &
                    map%hue(map%size),map%sat(map%size),map%val(map%size))
    !
  else
    ! White LUT
    call gt_lut_rgb(map,map%size-1,0.,1.,0.,1.,0.,1.)
    ! Blanking
    map%r(map%size) = 0.0
    map%b(map%size) = 0.0
    map%g(map%size) = 0.0
    call rgb_to_hsv(map%r(map%size),map%g(map%size),map%b(map%size),  &
                    map%hue(map%size),map%sat(map%size),map%val(map%size))
  endif
  !
end subroutine load_lut
!
subroutine gtl_lutpen(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_lutpen
  use gtv_buffers
  use gtv_protocol
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  GTVL\LUT [Argum]
  !  1        [/PEN]
  !  2        [/EDIT]
  !  3        [/REVERSE]
  !  4        [/BLANK]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  integer(kind=4), parameter :: optpen     = 1
  integer(kind=4), parameter :: optedit    = 2
  integer(kind=4), parameter :: optreverse = 3
  integer(kind=4), parameter :: optblank   = 4
  logical :: dopen,doedit,doblank
  !
  dopen = sic_present(optpen,0)
  doedit = sic_present(optedit,0)
  doblank = sic_present(optblank,0)
  !
  if (dopen) then      ! LUT /PEN
    call pen_lut(line,error)
    if (lut_static) then
      return  ! LUT STATIC => nothing to redraw
    endif
    !
  elseif (doedit) then  ! LUT /EDIT
    call edit_lut
    if (lut_static) then
      return  ! LUT STATIC => nothing to redraw
    endif
    !
  elseif (doblank) then  ! LUT /BLANK [Color]
    call gtl_lutblank(line,error)
    if (lut_static) then
      return  ! LUT STATIC => nothing to redraw
    endif
    !
  else ! LUT [Argum]
    call gtl_lut(line,error)
    if (lut_static) then
      return  ! LUT STATIC => nothing to redraw
    endif
  endif
  if (error)  return
  !
  ! If the device has a static LUT, the plot must be re-drawn with the current LUT
  if (cw_device%map_static)  &
    call gtview('Color')  ! Update Color LUT
  !
end subroutine gtl_lutpen
!
subroutine gtl_lut(line,error)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_lut
  use gbl_message
  use gtv_plot
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !   LUT [Argum]  (no option)
  ! LOADS a color table read in a file written in free format,
  !   or defined by the Hue, Saturation, Value
  !   or Red Green Blue arrays,
  ! depending upon the current representation.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LUT'
  character(len=80) :: argum,arguml
  integer :: i,nc
  logical :: is_default
  !
  arguml = 'LUT'  ! Default value
  call sic_ch (line,0,1,arguml,nc,.false.,error)
  if (error)  return
  argum=arguml
  call sic_upper(argum(1:nc))
  !
  select case (argum)
  case('DEFAULT')
    call gt_lut_default(gbl_colormap,gbl_colormap%size-1)
    !
  case('COLOR')
    call gt_lut_color(gbl_colormap,gbl_colormap%size-1)
    !
  case('BLACK')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,1.,0.,1.,0.,1.,0.)
    ! Blanking
    gbl_colormap%r(gbl_colormap%size) = 0.0
    gbl_colormap%b(gbl_colormap%size) = 0.0
    gbl_colormap%g(gbl_colormap%size) = 0.0
    !
  case('WHITE')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,1.,0.,1.,0.,1.)
    ! Blanking
    gbl_colormap%r(gbl_colormap%size) = 1.0
    gbl_colormap%b(gbl_colormap%size) = 1.0
    gbl_colormap%g(gbl_colormap%size) = 1.0
    !
  case('RED')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,1.,0.,0.,0.,0.)
    !
  case('GREEN')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,0.,0.,1.,0.,0.)
    !
  case('BLUE')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,0.,0.,0.,0.,1.)
    !
  case('YELLOW')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,1.,0.,1.,0.,0.)
    !
  case('CYAN')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,0.,0.,1.,0.,1.)
    !
  case('MAGENTA')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,1.,0.,0.,0.,1.)
    !
  case('NULL')
    call gt_lut_rgb(gbl_colormap,gbl_colormap%size-1,0.,0.,0.,0.,0.,0.)
    !
  case('BLUERED')
    call gt_lut_bluered(gbl_colormap,gbl_colormap%size-1)
    !
  case('LUT')
    ! User re-defined LUT.
    !   From level 1 to gbl_colormap%size-1: the LUT colors
    !   Level gbl_colormap%size: the blanking color
    if (lut_mode.eq.hsv_mode) then
      do i=1,gbl_colormap%size
        gbl_colormap%sat(i) = max(0.0,min(gbl_colormap%sat(i),1.0))
        gbl_colormap%val(i) = max(0.0,min(gbl_colormap%val(i),1.0))
        gbl_colormap%hue(i) = max(0.0,min(gbl_colormap%hue(i),360.0))
        call hsv_to_rgb(gbl_colormap%hue(i),gbl_colormap%sat(i),gbl_colormap%val(i),  &
                        gbl_colormap%r(i),gbl_colormap%g(i),gbl_colormap%b(i))
      enddo
    else
      do i=1,gbl_colormap%size
        gbl_colormap%r(i) = max(0.0,min(1.0,gbl_colormap%r(i)))
        gbl_colormap%g(i) = max(0.0,min(1.0,gbl_colormap%g(i)))
        gbl_colormap%b(i) = max(0.0,min(1.0,gbl_colormap%b(i)))
        call rgb_to_hsv(gbl_colormap%r(i),gbl_colormap%g(i),gbl_colormap%b(i),  &
                        gbl_colormap%hue(i),gbl_colormap%sat(i),gbl_colormap%val(i))
      enddo
    endif
    !
  case('?')
    call gt_lut_list(error)
    return  ! This was just a display, no action to perform on graphical window
    !
  case default
    ! Read from file, blanking is excluded
    call gt_lut_fromfile(arguml,gbl_colormap,gbl_colormap%size-1,error)
    if (error)  return
    !
  end select
  !
  ! /REVERSE reverts the LUT just loaded
  if (sic_present(3,0)) then
    ! BLANKING is not taken into account
    call gt_lut_revert(gbl_colormap,gbl_colormap%size-1,error)
    if (error)  return
  endif
  !
  ! Convert the (eventually modified) blank color:
  if (lut_mode.eq.hsv_mode) then
    gbl_colormap%sat(gbl_colormap%size) = max(0.0,min(gbl_colormap%sat(gbl_colormap%size),1.0))
    gbl_colormap%val(gbl_colormap%size) = max(0.0,min(gbl_colormap%val(gbl_colormap%size),1.0))
    gbl_colormap%hue(gbl_colormap%size) = max(0.0,min(gbl_colormap%hue(gbl_colormap%size),360.0))
    call hsv_to_rgb(  &
      gbl_colormap%hue(gbl_colormap%size),gbl_colormap%sat(gbl_colormap%size),gbl_colormap%val(gbl_colormap%size),  &
      gbl_colormap%r(gbl_colormap%size),gbl_colormap%g(gbl_colormap%size),gbl_colormap%b(gbl_colormap%size))
  else
    gbl_colormap%r(gbl_colormap%size) = max(0.0,min(1.0,gbl_colormap%r(gbl_colormap%size)))
    gbl_colormap%g(gbl_colormap%size) = max(0.0,min(1.0,gbl_colormap%g(gbl_colormap%size)))
    gbl_colormap%b(gbl_colormap%size) = max(0.0,min(1.0,gbl_colormap%b(gbl_colormap%size)))
    call rgb_to_hsv(  &
      gbl_colormap%r(gbl_colormap%size),gbl_colormap%g(gbl_colormap%size),gbl_colormap%b(gbl_colormap%size),  &
      gbl_colormap%hue(gbl_colormap%size),gbl_colormap%sat(gbl_colormap%size),gbl_colormap%val(gbl_colormap%size))
  endif
  !
  is_default = .true.
  call protocol_loadlut(cw_device,gbl_colormap,is_default)
  !
end subroutine gtl_lut
!
subroutine gtl_lutblank(line,error)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_lutblank
  use gbl_message
  use gtv_plot
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !   LUT /BLANK Color
  ! Customize the blanking color, independently of the current lut.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LUT'
  integer(kind=4), parameter :: optblank=4
  integer(kind=4) :: icol
  integer(kind=4) :: r,g,b
  logical :: do_neg,is_default
  !
  call gtv_pencol_arg2id(rname,line,optblank,1,icol,error)
  if (error)  return
  call gtv_pencol_id2rgb(cw_output,gbl_pen,icol,r,g,b,do_neg)
  !
  ! Convert from range [0:255] to [0:1]:
  gbl_colormap%r(gbl_colormap%size) = r/255.
  gbl_colormap%g(gbl_colormap%size) = g/255.
  gbl_colormap%b(gbl_colormap%size) = b/255.
  call rgb_to_hsv(  &
    gbl_colormap%r(gbl_colormap%size),gbl_colormap%g(gbl_colormap%size),gbl_colormap%b(gbl_colormap%size),  &
    gbl_colormap%hue(gbl_colormap%size),gbl_colormap%sat(gbl_colormap%size),gbl_colormap%val(gbl_colormap%size))
  !
  is_default = .true.
  call protocol_loadlut(cw_device,gbl_colormap,is_default)
  !
end subroutine gtl_lutblank
!
subroutine gt_lut_list(error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_list
  use gbl_message
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !  List all the LUTs available to the user.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LUT'
  integer(kind=4) :: nlut
  character(len=filename_length) :: lutdir
  character(len=132), allocatable :: lutfiles(:)
  integer(kind=4), allocatable :: buf(:)
  integer(kind=4), parameter :: mlutcode=12
  character(len=12) :: lutcodes(mlutcode)
  ! Data
  data lutcodes / 'DEFAULT','COLOR','BLUERED','BLACK','WHITE',  'RED',  &
                  'GREEN',  'BLUE', 'YELLOW', 'CYAN', 'MAGENTA','NULL' /
  !
  ! From internal code:
  call sic_ambigs_list(rname,seve%i,'LUTs available from internal code are:',lutcodes)
  !
  ! From file:
  lutdir = 'GAG_LUT:'
  call sic_resolve_log(lutdir)  ! Recursive
  call gag_directory(lutdir,'*.lut',lutfiles,nlut,error)
  if (error) return
  !
  ! Sort list for clarity:
  allocate(buf(nlut))
  call gch_trie(lutfiles,buf,nlut,132,error)
  deallocate(buf)
  if (error)  return
  !
  call sic_ambigs_list(rname,seve%i,'LUTs available from formatted files are:',lutfiles(1:nlut))
  !
  call gtv_message(seve%i,rname,  &
    'The cet-*.lut files have special features and naming convention. '// &
    'See HELP LUT CET for details.')
  !
end subroutine gt_lut_list
!
subroutine gtv_lut(error)
  use gtv_interfaces, except_this=>gtv_lut
  use gtv_tree
  use gtv_buffers
  use gtv_plot
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Save the current bitmap color Look Up Table into the METACODE
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_LUT'
  !
  call gtsegm('LUT',error)
  !
  call gt_lut_segdata(error)
  ! if (error) close the segment
  !
  call gtsegm_close(error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_lut
!
subroutine gt_lut_segdata(error)
  use gtv_interfaces, except_this=>gt_lut_segdata
  use gtv_tree
  use gtv_buffers
  use gtv_plot
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Save the current bitmap color Look Up Table into the METACODE
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_LUT'
  integer :: ier
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  co_segment_data%kind = seg_lutcol
  call gt_lut_alloc(co_segment_data%lut,gbl_colormap%size,error)
  if (error)  goto 10
  !
  ! Copy
  co_segment_data%lut = gbl_colormap
  co_segment_data%lut%xlut = 0  ! X-equivalent is not yet available
  ! Save the LUT address for later use by images
  co_segment%head%lut => co_segment_data%lut
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gt_lut_segdata
!
subroutine gti_lut(out,lut)
  use gtv_interfaces, except_this=>gti_lut
  use gtv_buffers
  use gtv_graphic
  use gtv_plot
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Read the colormap Look Up Table from the metacode and use it for the
  ! display. Starting from this point, next drawn images will use this
  ! colormap instead of the current working colormap ('gbl_colormap').
  !---------------------------------------------------------------------
  type(gt_display), intent(in)    :: out  ! Output device
  type(gt_lut),     intent(inout) :: lut  ! LUT in the metacode
  ! Local
  logical :: is_default
  !
  if (.not.awake .or. error_condition) return
  !
  if (.not.lut_static)  return  ! The image LUT known by the device remains
    ! the global one (gbl_colormap). It should be a custom one only in the
    ! LUT STATIC case.
  !
  is_default = .false.
  call protocol_loadlut(out%dev,lut,is_default)
  !
end subroutine gti_lut
!
subroutine protocol_loadlut(dev,map,is_default)
  use gtv_interfaces, except_this=>protocol_loadlut
  use gtv_plot
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Fonction d'aiguillage du chargement d'une palette en fonction du
  ! protocole
  !---------------------------------------------------------------------
  type(gt_device), intent(in)    :: dev         ! Output device
  type(gt_lut),    intent(inout) :: map         ! Colormap
  logical,         intent(in)    :: is_default  ! Is it the default/global colormap?
  !
  if (map%size.le.0) return
  !
  if (dev%protocol.eq.p_x) then
    if (map%xlut.ne.0)  call xcolormap_delete(map%xlut)
    map%xlut = xcolormap_create(map%r,map%g,map%b,map%size,is_default)
  endif
  !
  ! The other protocols directly access the colormaps and do not
  ! need their own local copy.
  !
end subroutine protocol_loadlut
!
subroutine edit_lut
  use gtv_interfaces, except_this=>edit_lut
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !   LUT /EDIT
  !---------------------------------------------------------------------
  !
  if (cw_device%protocol.ne.p_x) then
    call gtv_message(seve%e,'EDIT_LUT','Only for graphical displays, sorry')
    return
  endif
  !
  call create_edit_lut_window
  !
end subroutine edit_lut
!
subroutine gt_lut_default(lut,size)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_default
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the input LUT with the default color LUT. The blanking is not
  ! taken into account here.
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: lut   ! The LUT to be filled
  integer(kind=4), intent(in)    :: size  ! Size of LUT
  ! Local
  integer :: i,nborder,ilow,iup
  real :: hueshift
  !
  ! Rainbow from blue to violet, and min black and max white.
  hueshift = 90.
  nborder = nint(size*.12)
  ilow = nborder
  iup = size-nborder+1
  do i=1,size
    ! Hue
    lut%hue(i) = 360. * (size-i)/float(size) - hueshift
    lut%hue(i) = modulo(lut%hue(i),360.)  ! Between 0. and 360.
    ! Saturation
    if (i.gt.iup) then
      lut%sat(i) = float(size-i)/float(nborder-1)
    else
      lut%sat(i) = 1.
    endif
    ! Value
    if (i.lt.ilow) then
      lut%val(i) = float(i-1)/float(nborder-1)
    else
      lut%val(i) = 1.
    endif
    call hsv_to_rgb(lut%hue(i),lut%sat(i),lut%val(i),  &
                    lut%r(i),  lut%g(i),  lut%b(i))
  enddo
  !
end subroutine gt_lut_default
!
subroutine gt_lut_color(lut,size)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_color
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the input LUT with the "color" LUT (circular hue value, from
  ! red to red). The blanking is not taken into account here.
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: lut   ! The LUT to be filled
  integer(kind=4), intent(in)    :: size  ! Size of LUT
  ! Local
  integer :: i
  !
  ! The old default colormap, from red to red
  do i=1,size
    lut%sat(i) = 1.0
    lut%val(i) = 1.0
    lut%hue(i) = (i-1)*360./float(size-1)
    call hsv_to_rgb(lut%hue(i),lut%sat(i),lut%val(i),  &
                    lut%r(i),  lut%g(i),  lut%b(i))
  enddo
  !
end subroutine gt_lut_color
!
subroutine gt_lut_rgb(lut,size,rmin,rmax,gmin,gmax,bmin,bmax)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_rgb
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the input LUT with the R, G and B levels growing linearly from
  ! 0. to Rmax, Gmax and Bmax respectively. The blanking is not taken
  ! into account here.
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: lut        ! The LUT to be filled
  integer(kind=4), intent(in)    :: size       ! Size of LUT
  real(kind=4),    intent(in)    :: rmin,rmax  ! R extrema
  real(kind=4),    intent(in)    :: gmin,gmax  ! G extrema
  real(kind=4),    intent(in)    :: bmin,bmax  ! B extrema
  ! Local
  integer :: i
  real :: val
  !
  do i=1,size
    val = float(i-1)/float(size-1)  ! From 0. to 1.
    lut%r(i) = rmin + val * (rmax-rmin)
    lut%g(i) = gmin + val * (gmax-gmin)
    lut%b(i) = bmin + val * (bmax-bmin)
    !
    call rgb_to_hsv(lut%r(i),  lut%g(i),  lut%b(i),  &
                    lut%hue(i),lut%sat(i),lut%val(i))
  enddo
  !
end subroutine gt_lut_rgb
!
subroutine gt_lut_bluered(lut,size)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_bluered
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Program-defined BLUERED Look-Up-Table.
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: lut        ! The LUT to be filled
  integer(kind=4), intent(in)    :: size       ! Size of LUT
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: l(3),bs,re
  !
  ! Define the limits of the 4 regimes:
  l(1) = size*0.15
  l(2) = size*0.50
  l(3) = size*0.7975
  !
  ! Blue intensity at start, red intensity at end
  bs = 0.23
  re = 0.19
  !
  ! 1st regime: dark blue to light blue
  do i=1,floor(l(1))
    lut%r(i) = 0.
    lut%g(i) = 0.
    lut%b(i) = bs + (1.-bs)*(i-1)/(l(1)-1)  ! From bs to 1
  enddo
  !
  ! 2nd regime: light blue to white
  do i=ceiling(l(1)),floor(l(2))
    lut%r(i) = (i-l(1))/(l(2)-l(1))  ! From 0 to 1
    lut%g(i) = (i-l(1))/(l(2)-l(1))  ! From 0 to 1
    lut%b(i) = 1.
  enddo
  !
  ! 3rd regime: from white to light red
  do i=ceiling(l(2)),floor(l(3))
    lut%r(i) = 1.
    lut%g(i) = (l(3)-i)/(l(3)-l(2))  ! From 1 to 0
    lut%b(i) = (l(3)-i)/(l(3)-l(2))  ! From 1 to 0
  enddo
  !
  ! 4th regime
  do i=ceiling(l(3)),size
    lut%r(i) = re + (1.-re)*(size-i)/(size-l(3))  ! From 1 to re
    lut%g(i) = 0.
    lut%b(i) = 0.
  enddo
  !
  ! Also fill the HSV values from RGB
  do i=1,size
    call rgb_to_hsv(lut%r(i),  lut%g(i),  lut%b(i),  &
                    lut%hue(i),lut%sat(i),lut%val(i))
  enddo
  !
end subroutine gt_lut_bluered
!
subroutine gt_lut_fromfile(name_in,cmap,ncol,error)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_fromfile
  use gbl_message
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name_in  ! File name
  type(gt_lut),     intent(inout) :: cmap     ! Colormap to be filled
  integer(kind=4),  intent(in)    :: ncol     ! Number of colors in the colormap
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LUT'
  integer :: i,ier,lun,nf,filelen
  character(len=filename_length) :: name,file
  type(gt_lut) :: filemap
  !
  ! Get the file name with path
  name = name_in
  if (.not.sic_findfile(name,file,'LUT#DIR:','.lut')) then
    call gtv_message(seve%e,rname,'No such file '//name_in)
    error = .true.
    return
  endif
  nf = len_trim(file)
  !
  ! Open the file
  ier = sic_getlun(lun)
  if (mod(ier,2).ne.1) then
    error = .true.
    return
  endif
  !
  ier = sic_open(lun,file(1:nf),'OLD',.true.)
  if (ier.ne.0) then
    call putios('E-LUT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !
  ! 1) Get the number of lines in the file
  filelen = 0
  do
    read(lun,*,iostat=ier)
    if (ier.eq.-1) then
      ! Reached End-Of-File
      exit
    elseif (ier.ne.0) then
      call putios('E-LUT,  ',ier)
      goto 100
    endif
    filelen = filelen+1
  enddo
  !
  ! 2) Read in a colormap of correct size
  call gt_lut_alloc(filemap,filelen,error)
  if (error)  goto 100
  !
  rewind(unit=lun)
  do i=1,filelen
    read(lun,*,iostat=ier) filemap%r(i),filemap%g(i),filemap%b(i)
    if (ier.ne.0) then
      call putios('E-LUT,  ',ier)
      call gt_lut_dealloc(filemap,error)
      goto 100
    endif
  enddo
  close(unit=lun)
  call sic_frelun(lun)
  !
  ! 3) If the number of colors match, just copy one into the other. Else
  !    resample
  if (ncol.eq.filelen) then
    do i=1,ncol
      cmap%r(i) = filemap%r(i)
      cmap%g(i) = filemap%g(i)
      cmap%b(i) = filemap%b(i)
      call rgb_to_hsv(cmap%r(i),  cmap%g(i),  cmap%b(i),  &
                      cmap%hue(i),cmap%sat(i),cmap%val(i))
    enddo
  else
    call gt_lut_resample(filemap,filelen,cmap,ncol,.true.)
  endif
  !
  ! Clean
  call gt_lut_dealloc(filemap,error)
  return
  !
100 continue
  error = .true.
  close(unit=lun)
  call sic_frelun(lun)
  !
end subroutine gt_lut_fromfile
!
subroutine gt_lut_resample(cmapin,sizein,cmapout,sizeout,interpolate)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_resample
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Resample the input colormap into the output colormap such as:
  !  cmapout(1) = cmapin(1)
  !  cmapout(sizeout) = cmapin(sizein)
  ! and the intermediate values are either interpolated or nearest
  ! neighbour.
  !---------------------------------------------------------------------
  type(gt_lut),    intent(in)    :: cmapin       !
  integer(kind=4), intent(in)    :: sizein       !
  type(gt_lut),    intent(inout) :: cmapout      !
  integer(kind=4), intent(in)    :: sizeout      !
  logical,         intent(in)    :: interpolate  !
  ! Local
  character(len=*), parameter :: rname='LUT'
  character(len=message_length) :: mess
  integer :: icol,il,ir,near
  real(4) :: rind,slope
  !
  write(mess,*) 'Resampling',sizein,'levels into a',sizeout,'levels colormap'
  call gtv_message(seve%d,rname,mess)
  !
  do icol=1,sizeout
    rind = float(icol-1) * float(sizein-1)/float(sizeout-1) + 1.
    if (rind.le.1.) then
      cmapout%r(icol) = cmapin%r(1)
      cmapout%g(icol) = cmapin%g(1)
      cmapout%b(icol) = cmapin%b(1)
      !
    elseif (rind.lt.sizein) then
      if (interpolate) then
        il = floor(rind)
        ir = ceiling(rind)
        rind = rind-float(il)
        !
        slope = cmapin%r(ir)-cmapin%r(il) ! / (ir-il) == 1
        cmapout%r(icol) = cmapin%r(il) + slope*rind
        !
        slope = cmapin%g(ir)-cmapin%g(il)
        cmapout%g(icol) = cmapin%g(il) + slope*rind
        !
        slope = cmapin%b(ir)-cmapin%b(il)
        cmapout%b(icol) = cmapin%b(il) + slope*rind
      else
        ! Nearest neighbour. Useful for "staircase" color maps
        near = nint(rind)
        cmapout%r(icol) = cmapin%r(near)
        cmapout%g(icol) = cmapin%g(near)
        cmapout%b(icol) = cmapin%b(near)
      endif
      !
    else
      cmapout%r(icol) = cmapin%r(sizein)
      cmapout%g(icol) = cmapin%g(sizein)
      cmapout%b(icol) = cmapin%b(sizein)
    endif
    !
    call rgb_to_hsv(cmapout%r(icol),  cmapout%g(icol),  cmapout%b(icol),  &
                    cmapout%hue(icol),cmapout%sat(icol),cmapout%val(icol))
  enddo
  !
end subroutine gt_lut_resample
!
subroutine gt_lut_revert(cmap,ncol,error)
  use gtv_interfaces, except_this=>gt_lut_revert
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: cmap   ! The color map to revert
  integer(kind=4), intent(in)    :: ncol   ! The number of elements to revert
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  integer :: i
  type(gt_lut) :: reverted
  !
  call gt_lut_alloc(reverted,ncol,error)
  if (error)  return
  !
  do i=1,ncol
    reverted%r(i)   = cmap%r(ncol-i+1)
    reverted%g(i)   = cmap%g(ncol-i+1)
    reverted%b(i)   = cmap%b(ncol-i+1)
    reverted%hue(i) = cmap%hue(ncol-i+1)
    reverted%sat(i) = cmap%sat(ncol-i+1)
    reverted%val(i) = cmap%val(ncol-i+1)
  enddo
  !
  cmap%r(1:ncol) = reverted%r(:)
  cmap%g(1:ncol) = reverted%g(:)
  cmap%b(1:ncol) = reverted%b(:)
  cmap%hue(1:ncol) = reverted%hue(:)
  cmap%sat(1:ncol) = reverted%sat(:)
  cmap%val(1:ncol) = reverted%val(:)
  !
  ! Clean
  call gt_lut_dealloc(reverted,error)
  if (error)  return
  !
end subroutine gt_lut_revert
!
subroutine gt_lut_alloc(lut,size,error)
  use gtv_interfaces, except_this=>gt_lut_alloc
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Allocate the arrays of the input 'gt_lut' instance
  !---------------------------------------------------------------------
  type(gt_lut),    intent(inout) :: lut    !
  integer(kind=4), intent(in)    :: size   ! Requested lut size
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GT_LUT_ALLOC'
  integer :: ier
  !
  lut%size = size
  allocate(lut%r(size),lut%g(size),lut%b(size),stat=ier)
  allocate(lut%hue(size),lut%sat(size),lut%val(size),stat=ier)
  !
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error, gt_lut allocation failed')
    error = .true.
    return
  endif
  !
end subroutine gt_lut_alloc
!
subroutine gt_lut_dealloc(lut,error)
  use gtv_interfaces, except_this=>gt_lut_dealloc
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate the arrays of the input 'gt_lut' instance
  !---------------------------------------------------------------------
  type(gt_lut), intent(inout) :: lut    !
  logical,      intent(inout) :: error  ! Logical error flag
  !
  lut%size = 0
  if (allocated(lut%r)) then
    deallocate(lut%r,lut%g,lut%b)
    deallocate(lut%hue,lut%sat,lut%val)
  endif
  !
end subroutine gt_lut_dealloc
!
subroutine gt_lut_fromeditor(r,g,b,sizein,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gt_lut_fromeditor
  use gbl_message
  use gtv_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  Update the global colormap.
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)    :: r(*)    ! R values
  real(kind=4),    intent(in)    :: g(*)    ! G values
  real(kind=4),    intent(in)    :: b(*)    ! B values
  integer(kind=4), intent(in)    :: sizein  ! LUT size, without the blanking color
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  integer :: icol
  type(gt_lut), target :: inlut
  type(gt_lut), pointer :: worklut
  logical :: resample
  !
  if (sizein.eq.gbl_colormap%size-1) then
    ! Size match, direct copy to the global colormap:
    worklut => gbl_colormap
    resample = .false.
  else
    ! Size do not match, we need a temporary LUT object
    call gt_lut_alloc(inlut,sizein,error)
    if (error)  return
    worklut => inlut
    resample = .true.
  endif
  !
  do icol=1,sizein
    worklut%r(icol) = r(icol)
    worklut%g(icol) = g(icol)
    worklut%b(icol) = b(icol)
    call rgb_to_hsv(worklut%r(icol),  worklut%g(icol),  worklut%b(icol),  &
                    worklut%hue(icol),worklut%sat(icol),worklut%val(icol))
  enddo
  !
  if (resample) then
    ! Tranfer the temporary LUT to the global LUT
    call gt_lut_resample(inlut,sizein,gbl_colormap,gbl_colormap%size-1,.true.)
    call gt_lut_dealloc(inlut,error)
  endif
  !
  call protocol_loadlut(cw_device,gbl_colormap,.true.)
  !
  ! What if static LUT (i.e. one lut per image)?
  if (.not.lut_static)  &
    call gtview('Color')
  !
end subroutine gt_lut_fromeditor

      SUBROUTINE DEFINE(LINE,ERROR)
      USE GKERNEL_INTERFACES
      CHARACTER LINE*(*)
      logical error
*      
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
*
      INTEGER MVOCAB
      PARAMETER (MVOCAB=1)
      CHARACTER*12 VOCAB(MVOCAB),ARGUM,KEYWOR
      INTEGER MVOCAB_METH
      PARAMETER (MVOCAB_METH=2)
      CHARACTER*12 VOCAB_METH(MVOCAB_METH)
      CHARACTER*12 METHOD
      INTEGER NKEY
      INTEGER I,J,NC
* Data
      DATA VOCAB /'METHOD'/
      DATA VOCAB_METH /'GAUSS-JORDAN','DIAGONALISE'/
*
      CALL SIC_CH (LINE,0,1,ARGUM,NC,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_AMBIGS('DEFINE',ARGUM,KEYWOR,NKEY,
     +     VOCAB,MVOCAB,ERROR)
      IF (ERROR) RETURN
      IF (KEYWOR.EQ.'METHOD') THEN
         CALL SIC_CH (LINE,0,2,ARGUM,NC,.TRUE.,ERROR)
         IF (ERROR) RETURN
         CALL SIC_AMBIGS('DEFINE METHOD',ARGUM,METHOD,NKEY,
     +        VOCAB_METH,MVOCAB_METH,ERROR)
         IF (ERROR) RETURN
      ELSE
         ERROR = .TRUE.
      ENDIF
      RETURN
*
      END

module cubetools_string
  use gkernel_interfaces

  public :: cubetools_string_split,cubetools_string_concat
  private

contains

  subroutine cubetools_string_split(fullstring,sep,list,error)
    !-------------------------------------------------------------------
    ! Split a string into several substrings given a separator
    ! The output list is allocated to the proper size on return
    !-------------------------------------------------------------------
    character(len=*), intent(in)               :: fullstring
    character(len=*), intent(in)               :: sep   ! Can be of any length, blanks allowed
    character(len=*), intent(out), allocatable :: list(:)
    logical,          intent(inout)            :: error
    !
    character(len=*), parameter :: rname='STRING>SPLIT'
    integer(kind=4) :: lfull,lsep,icha,left,mstring,ier
    !
    lfull = len(fullstring)
    if (lfull.eq.0)  return  ! Leave list unallocated
    !
    lsep = len(sep)
    !
    ! Count number of separators
    mstring = 1
    icha = 1
    do while (icha.le.lfull-lsep+1)
      if (fullstring(icha:icha+lsep-1).eq.sep) then
        mstring = mstring+1
        icha = icha+lsep
      else
        icha = icha+1
      endif
    enddo
    !
    allocate(list(mstring),stat=ier)
    if (failed_allocate(rname,'list',ier,error)) return
    mstring = 1
    left = 1
    icha = 1
    do while (icha.le.lfull-lsep+1)
      if (fullstring(icha:icha+lsep-1).eq.sep) then
        list(mstring) = fullstring(left:icha-1)  ! Can be 0-sized => save blanks
        ! Next
        mstring = mstring+1
        icha = icha+lsep
        left = icha
      else
        icha = icha+1
      endif
    enddo
    ! Last
    list(mstring) = fullstring(left:lfull)  ! Can be 0-sized => save blanks
  end subroutine cubetools_string_split

  subroutine cubetools_string_concat(nl,list,sep,string,error)
    !-------------------------------------------------------------------
    ! From a list of strings, return them concatenated with the given
    ! separator.
    ! If the output string is too short, string is terminated with ..
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: nl
    character(len=*), intent(in)    :: list(:)
    character(len=*), intent(in)    :: sep
    character(len=*), intent(out)   :: string
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: il,nc,mc,lsep
    !
    lsep = len(sep)
    string = ''
    nc = 0
    mc = len(string)
    do il=1,nl
      if (nc.gt.0) then
        nc = nc+1
        string(nc:nc+lsep-1) = sep
        nc = nc+lsep-1
      endif
      string(nc+1:mc) = list(il)
      nc = nc+len_trim(list(il))
      if (nc.gt.mc) then
        string(mc-1:mc) = '..'
        exit
      endif
    enddo
  end subroutine cubetools_string_concat

end module cubetools_string

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_subcube_types
  use cubetools_parameters
  use cubetools_array_types
  use cubetuple_format_class
  use cubeadm_messaging
  use cubeadm_taskloop
  use cubeadm_taskloop_iteration
  !
  public :: subcube_t
  private
  !
  type, extends(real_3d_t) :: subcube_t
     class(format_t),           private, pointer :: cube => null() ! Associated cube
     type(cubeadm_iterator_t),  private, pointer :: task => null() ! Associated task iteration
     integer(kind=indx_k),      private          :: n(3)           ! Subcube dimensions
     integer(kind=indx_k),      public           :: range1(2)      ! Min-max range of 1st dimension
     integer(kind=indx_k),      public           :: range2(2)      ! Min-max range of 2nd dimension
     integer(kind=indx_k),      public           :: range3(2)      ! Min-max range of 3rd dimension
     integer(kind=indx_k),      public           :: nvalid3        ! Valid   size  of 3rd dimension
     integer(kind=indx_k),      public           :: v3shift        ! 3rd dimension is shifted?
   contains
     procedure, public  :: allocate  => cubeadm_subcube_allocate
     procedure, public  :: associate => cubeadm_subcube_associate
     procedure, private :: prepare   => cubeadm_subcube_prepare
     procedure, public  :: get       => cubeadm_subcube_get
     procedure, public  :: put       => cubeadm_subcube_put
     procedure, public  :: put_in    => cubeadm_subcube_put_in
  end type subcube_t
  !
contains
  !
  subroutine cubeadm_subcube_allocate(subcube,name,cube,iterator,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube_t),         intent(out)   :: subcube
    character(len=*),         intent(in)    :: name
    class(format_t),             intent(in)    :: cube
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE>ALLOCATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call subcube%prepare(name,cube,iterator,error)
    if (error)  return
    call subcube%reallocate(name,&
         subcube%n(1),subcube%n(2),subcube%n(3),&
         error)
    if (error) return
  end subroutine cubeadm_subcube_allocate
  !
  subroutine cubeadm_subcube_associate(subcube,name,cube,iterator,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube_t),         intent(out)   :: subcube
    character(len=*),         intent(in)    :: name
    class(format_t),          intent(in)    :: cube
    type(cubeadm_iterator_t), intent(in)    :: iterator
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE>ASSOCIATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call subcube%prepare(name,cube,iterator,error)
    if (error)  return
    call subcube%prepare_association(name,&
         subcube%n(1),subcube%n(2),subcube%n(3),&
         error)
    if (error) return
  end subroutine cubeadm_subcube_associate
  !
  subroutine cubeadm_subcube_prepare(subcube,name,cube,iterator,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(subcube_t),                 intent(out)   :: subcube
    character(len=*),                 intent(in)    :: name
    class(format_t),          target, intent(in)    :: cube
    type(cubeadm_iterator_t), target, intent(in)    :: iterator
    logical,                          intent(inout) :: error
    !
    logical, parameter :: notruncate=.false.
    integer(kind=code_k) :: access
    character(len=*), parameter :: rname='SUBCUBE>PREPARE'
    !
    if (cube%iscplx()) then
       call cubeadm_message(seve%e,rname,  &
            'Invalid attempt to get a R*4 subcube from a C*4 cube')
       error = .true.
       return
    endif
    access = cube%access()
    if (access.ne.code_access_subset .and. &
        access.ne.code_access_fullset) then
       call cubeadm_message(seve%e,rname,  &
            'Can not get a subcube from a cube with other access declared')
       error = .true.
       return
    endif
    if (.not.cube%iter%ready(rname,error)) then
       call cubeadm_message(seve%e,rname,  &
         'Failed to associate or allocate the '''//name//''' subcube on its cube')
       error = .true.
       return
    endif
    !
    subcube%cube => cube
    subcube%task => iterator
    !
    call cube%iter%subcube_region(subcube%range1,subcube%range2,error)
    if (error)  return
    ! By design the 3rd axis range is not truncated: ths is a feature of
    ! subcubes to "map" non-existing planes (to be ignored when the time
    ! comes).
    call cube%iter%range(iterator%prange,notruncate,subcube%range3,error)
    if (error)  return
    !
    call cube%iter%subcube_size(subcube%n(1),subcube%n(2),error)
    if (error)  return
    subcube%n(3) = subcube%range3(2)-subcube%range3(1)+1
  end subroutine cubeadm_subcube_prepare
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeadm_subcube_get(subcube,error)
    use cube_types
    use cubeio_subcube
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Get the subcube from the given cube (whole range being iterated).
    ! When subcube%val is an allocated pointer, we make a copy.
    ! In all other cases (associated or null), we make it point to the
    ! data.
    !---------------------------------------------------------------------
    class(subcube_t), intent(inout) :: subcube
    logical,          intent(inout) :: error
    !
    integer(kind=indx_k) :: n3,i1,i2,i3,j1,j2,j3,valid3(2)
    type(cubeio_subcube_t) :: entry
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SUBCUBE>GET'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    n3 = subcube%cube%tuple%current%desc%n3
    !
    ! Range of valid planes in the input cube referential
    valid3(1) = subcube%range3(1)
    valid3(2) = subcube%range3(2)
    subcube%v3shift = 0
    !
    ! During the iteration, . Deal with this:
    if (subcube%range3(1).gt.n3 .or. subcube%range3(2).lt.1) then
      ! The range is fully off the cube. It is valid to request planes
      ! beyond the cube (e.g. surset extraction with EXTRACT). Free the
      ! pointer and assume the caller knows it can not use it.
      call entry%free(error)
      if (error) return
      subcube%nx = subcube%n(1)
      subcube%ny = subcube%n(2)
      subcube%nz = subcube%n(3)
      subcube%nvalid3 = 0
      return
    endif
    if (valid3(1).lt.1 .and. valid3(2).ge.1) then
      ! Some left planes missing (note: can happen with right planes missing)
      subcube%v3shift = subcube%range3(1)-1
      valid3(1) = 1  ! First valid plane to read from cube
    endif
    if (valid3(1).le.n3 .and. valid3(2).gt.n3) then
      ! Some right planes missing (note: can happen with left planes missing)
      valid3(2) = n3  ! Last valid plane to read from cube
    endif
    subcube%nvalid3 = valid3(2)-valid3(1)+1
    !
    call cubetuple_get_subcube(subcube%cube%user,  &
                               subcube%cube%prog,  &
                               subcube%cube,       &
                               valid3(1),          &
                               valid3(2),          &
                               entry,error)
    if (error) return
    !
    ! Sanity check on leading dimensions
    if (subcube%range1(1).lt.1 .or. subcube%range1(2).gt.entry%n1  .or.  &
        subcube%range2(1).lt.1 .or. subcube%range2(2).gt.entry%n2) then
      write(mess,'(9(A,I0))')  &
        'Region overlaps subcube range. Region: [',  &
        subcube%range1(1),':',subcube%range1(2),',',   &
        subcube%range2(1),':',subcube%range2(2),'], subcube: [',  &
        1,':',entry%n1,',',  &
        1,':',entry%n2,']'
      call cubeadm_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    if (subcube%pointeris.eq.code_pointer_allocated) then
       do i3=1,subcube%nvalid3
         do i2=1,subcube%n(2)
           do i1=1,subcube%n(1)
             j1 = subcube%range1(1) + i1 - 1
             j2 = subcube%range2(1) + i2 - 1
             j3 = i3  ! 3rd dimension already extracted with above get. Subcube
                      ! is always filled to the left (1, 2, 3, ...) even in
                      ! case of missing leading planes, in order to remain
                      ! symetric to the pointer code_pointer_associated case.
                      ! subcube%v3shift is set accordingly
             subcube%val(i1,i2,i3) = entry%r4(j1,j2,j3)
           enddo ! i1
         enddo ! i2
       enddo ! i3
     ! do i3 = invalid planes
         ! Do not waste time blanking them here, the caller will do it if needed
     ! enddo
    else
       ! In case of missing planes, I would like to offer a syntax like
       !   subcube%val(:,:,2:3) => entry%r4(:,:,1:2)
       ! (i.e. customize the 3rd dimension numbering) but Fortran is touchy
       ! about pointer remapping. The caller has no better solution than
       ! using subcube%v3shift
       subcube%val => entry%r4(subcube%range1(1):subcube%range1(2),  &
                               subcube%range2(1):subcube%range2(2),  &
                               1:subcube%nvalid3)
       subcube%pointeris = code_pointer_associated
    endif
    subcube%nx = subcube%n(1)
    subcube%ny = subcube%n(2)
    subcube%nz = subcube%n(3)
    !
    call entry%free(error)
    if (error) return
  end subroutine cubeadm_subcube_get
  !
  subroutine cubeadm_subcube_put(subcube,error)
    !---------------------------------------------------------------------
    ! Put the subcube to the cube
    ! Only use pointers => Nothing to free
    !---------------------------------------------------------------------
    class(subcube_t), intent(inout) :: subcube
    logical,          intent(inout) :: error
    !
    call cubeadm_subcube_put_in(subcube,subcube%cube,error)
    if (error)  return
  end subroutine cubeadm_subcube_put
  !
  subroutine cubeadm_subcube_put_in(subcube,cube,error)
    use cubeio_subcube
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Put the subcube to the cube, from "first" to "last" planes
    ! Only use pointers => Nothing to free
    !
    ! This flavor, which explicitely states the output cube, should be used
    ! when the input subcube needs to be written in another cube without
    ! copy.
    !---------------------------------------------------------------------
    class(subcube_t), intent(in)    :: subcube
    class(format_t),  intent(inout) :: cube
    logical,          intent(inout) :: error
    !
    type(cubeio_subcube_t) :: entry
    character(len=*), parameter :: rname='SUBCUBE>PUT>IN'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    entry%allocated = code_pointer_associated
    entry%n1 = subcube%nx
    entry%n2 = subcube%ny
    entry%n3 = subcube%nz
    entry%r4 => subcube%val
    entry%iscplx = .false.
    !
    call cubetuple_put_subcube(cube%user,  &
                               cube%prog,  &
                               cube,       &
                               subcube%task%num,   &
                               subcube%range3(1),  &
                               subcube%range3(2),  &
                               entry,              &
                               error)
    if (error) return
  end subroutine cubeadm_subcube_put_in
end module cubeadm_subcube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_wvr(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Command WVR
  ! It processes all scans as encountered, except cwvr scans,
  ! to deduce the atmospheric parameter from the wvr.
  ! options /CMODE (1) /NOWRITE (2)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_write
  integer(kind=address_length) :: data_in, kin
  integer(kind=data_length)    :: ldata_in
  !      INTEGER IA, IC , S_SCAN
  !      CHARACTER SOURCE1*12
  integer :: mvoc3
  integer :: wvrmode,wvrcpol,wvrprev
  parameter (mvoc3=6)
  character(len=12) :: voc3(mvoc3), arg3
  data voc3/'TR_GE','LAB','TREC','DIODE','NOCAL','DUAL'/
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do_write = .not.sic_present(2,0)
  if (do_write) then
    call check_output_file(error)
    if (error) return
    call check_equal_file(error)
    if (error) return
  endif
  !
  ! wvr calibration
  !
  ! default option value
  !      WVRMODE = 4
  ! 24-feb-2004 JMW
  wvrmode = 3                  ! To use ambient load and avoid diode
  wvrcpol = 0
  wvrprev = 0
  ! /CMODE : new option value
  if (sic_present(1,0)) then
    ! read wvr calibration mode
    arg3 = 'DIODE'
    call clic_kw(line,1,1,arg3,wvrmode,voc3,mvoc3,.false.,error,.true.)
    if (error) return
    ! read degree of polynome to be removed
    call sic_i4(line,1,2,wvrcpol,.false.,error)
    if (error) return
    call sic_i4(line,1,3,wvrprev,.false.,error)
    if (error) return
  endif
  PRINT *, WVRMODE, WVRCPOL,WVRPREV
  !
  ! Loop on current index
  call get_first(.true.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    !
    ! Get storage and data
    call get_data (ldata_in,data_in,error)
    if (error) return
    kin = gag_pointer(data_in,memory)
    call sub_wvr(ldata_in,memory(kin),wvrmode,wvrcpol,wvrprev,error)
    if (error) return
    !
    if (do_write) then
      call write_scan (.false.,error)
      if (error) return
    endif
    !
    ! Next observation
    if (sic_ctrlc()) then
      error = .true.
      return
    endif
    error = .false.
    call get_next(end, error)
    if (error) return
  enddo
  !
  return
end subroutine clic_wvr
!
subroutine sub_wvr(ldata_in,data,wvrmode,wvrcpol,wvrprev,error)
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Process a WVR data
  !
  ! Arguments
  !     LDATA_IN      Integer Length of data array
  !     DATA(*)       (*)     Data array
  !
  ! oct-01, RM: add calibration of wvr
  !---------------------------------------------------------------------
  integer(kind=data_length) :: ldata_in               !
  real :: data(ldata_in)            !
  integer :: wvrmode                !
  integer :: wvrcpol                !
  integer :: wvrprev                !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer :: i, k, kin
  ! wvr variables:
  integer :: mcwvrdump            ! nombre de dump maximum pour la calibration du wvr
  ! mcwvrdump aussi defini dans wvr_cali et bev_polfit
  parameter(mcwvrdump=128)
  integer :: status, j, l
  character(len=160) :: message2
  character(len=80) :: chain
  integer :: wvrstat(mcwvrdump,mnant)
  real :: wvr(mcwvrdump,mwvrch,mnant)
  logical :: save_wvr(mnant), do_reference
  real :: saved_wvrtcal(mwvrch,mnant), saved_wvrtrec(mwvrch,mnant)
  real :: saved_wvraver(mwvrch,mnant)
  save saved_wvrtcal, saved_wvrtrec, saved_wvraver, save_wvr,   &
    do_reference
  data save_wvr/mnant*.false./, do_reference/.false./
  !------------------------------------------------------------------------
  ! Code:
  if (r_proc.eq.p_pass) return
  !
  ! wvr calibration
  do j =1, r_nant
    r_wvrmode(j) = wvrmode
  enddo
  if ( ((r_proc.eq.p_cal).or.(r_proc.eq.p_skydip))   &
    .and. (wvrmode.le.5) ) then
    do i=1, r_ndump
      ! mise en memoire (data(kin)) du data_header du dump I
      kin = (i-1)*r_ldump + 1
      call decode_header (data(kin))
      ! construction des tableaux necessaires a la routine de calibration du wvr
      do j = 1, r_nant
        if (r_wvrnch(j).eq.3) then
          wvrstat(i,j) = dh_wvrstat(j)
          do l = 1, r_wvrnch(j)
            wvr(i,l,j) = dh_wvr(l,j)
          enddo
        endif
      enddo
    enddo
    ! averaged scan
    kin = r_ldump*r_ndump + 1
    call decode_header (data(kin))
    do j = 1, r_nant
      if (r_wvrnch(j).eq.3.and.wvrstat(1,j).eq.10) then
        do k = 1, r_wvrnch(j)
          r_wvraver(k,j) = dh_wvr(k,j)
        enddo
        ! calibration du wvr
        call wvr_cali(j, wvr, wvrstat,   &
          wvrmode, wvrcpol, wvrprev, message2, status)
        if (status.gt.1) then
          call  message(8,1,'SUB_WVR',message2)
        else
          !
          ! Save trec, tcal
          do i=1, r_wvrnch(j)
            saved_wvrtcal(i,j) = r_wvrtcal(i,j)
            saved_wvrtrec(i,j) = r_wvrtrec(i,j)
          enddo
          write (chain,1000) r_kant(j),   &
            (r_wvrtcal(i,j), i=1,r_wvrnch(j))
1000      format('A',i0,' Tcal= ',3f10.2)
          call message(2,1,'SUB_WVR',chain(1:40))
          save_wvr(j) = .true.
        endif
      elseif (r_wvrnch(j).eq.3.and.wvrstat(1,j).ne.10) then
          do i=1,r_wvrnch(j)
             r_wvrtcal(i,j) = saved_wvrtcal(i,j)
             r_wvrtrec(i,j) = saved_wvrtrec(i,j)
          enddo
      endif
    enddo
    do_reference = .true.
  !
  ! Other scans ...
  else
    kin = 1+r_ndump*r_ldump
    call decode_header (data(kin))
    ! Restore  trec, tcal
    do j=1, r_nant
      if (save_wvr(j) .and. r_wvrnch(j).gt.0) then
        do i=1, r_wvrnch(j)
          r_wvrtcal(i,j) = saved_wvrtcal(i,j)
          r_wvrtrec(i,j) = saved_wvrtrec(i,j)
          ! save WVR measurement for all following scans just after a CWVR
          if (do_reference) then
            saved_wvraver(i,j) = r_wvraver(i,j)
          endif
        !                  R_WVRREF(I,J) = SAVED_WVRAVER(I,J)
        enddo
      endif
    enddo
    error = .false.
    call do_wvr (.false.,error)
    do_reference = .false.
  endif
  return
end subroutine sub_wvr
!
!
subroutine wvr_cali(iant, wvr, wvrstat, wvrmode,   &
    wvrcpol, wvrprev, message, status)
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! Author: 18-Oct 2001 Michael Bremer, IRAM
  ! Routine to calibrate the WVR data. Each calibration phase is stored
  ! individually, and the difference hot/ambient can be corrected with a
  ! polynomial of degree wvrcpol (fit with Bevington routines in real*8
  ! attached at the end of this file, independent of NAG or LAPACK).
  !
  ! INPUT: wvr       real*4   raw radiometer counts
  !        wvrstat   integer  instrumental state flag
  !        n_dumps      integer  number of subscans
  !        wvrmode      integer  calibration mode. 1=trec+gain external,
  !                                                2=trec+gain laboratory,
  !                                                3=trec lab, gain calibrated
  !                                                4=trec+gain calibrated
  !        wvrcpol      integer  degree+1 of the polynomial fitted through
  !                              the ambient load counts to improve the Hot
  !                              load counts background subtraction.
  !        wvrprev      integer  if 0: re-calculate wvrtcal, 1: don't re-calculate
  !        wvrtamb      real*4   load temperature in K
  !        wvrtpel      real*4   Peltier temperature in K
  !        wvrlab_tcal  real*4   laboratory value for wvrtcal
  !        wvrlab_trec  real*4   laboratory value for wvrtrec
  !        wvrlab_tdio  real*4   laboratory value for noise diode temperature
  !
  ! OUTPUT:  wvramb     real*4    counts on ambient load for each channel
  !          wvrtcal    real*4    gain K/counts for each channel
  !          wvrtrec    real*4    receiver temperature for each channel
  !          message    character*160   detailed accumulated errors
  !          status     integer   0=ok, 1=warning, 2=error
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer, parameter :: mcwvrdump=128
  integer :: iant                      !
  real :: wvr(mcwvrdump,mwvrch,mnant)  !
  integer :: wvrstat(mcwvrdump,mnant)  !
  integer :: wvrmode                   !
  integer :: wvrcpol                   !
  integer :: wvrprev                   !
  character(len=160) :: message        !
  integer :: status                    !
  ! Global
  include 'clic_par.inc'
  ! Local
  logical :: f_hot,f_amb,f_ambok ,f_pel, badgain, badpelt
  ! f_hot=noise tube on
  ! f_amb=ambient load on: commanded
  ! f_ambOK=ambient load on: sensor
  ! f3=Peltier Alert on
  !
  character(len=1) :: chan_id(mwvrch)
  integer :: trouble_load, i_hot, i_cold, k, k_last, ic, ix, ii
  integer :: bit_hot, bit_ambok, bit_pel
  parameter (bit_hot=z'00000004', bit_ambok=z'00000002',   &
    bit_pel=z'00000040')
  integer :: max_fp, kplus1, pfit
  parameter(max_fp = 16, pfit=0)
  integer :: num_cold(max_fp), num_hot(max_fp)
  !
  real :: wvrhot(mwvrch)
  real :: rnum1, rnum2, delta(mwvrch), ww(max_fp)
  real :: tmp
  real*8 :: xx_cold(max_fp), xx_hot(max_fp), sum_cold(max_fp,mwvrch)
  real*8 :: sum_hot(max_fp,mwvrch), a(max_fp), w(max_fp), chisqr
  real :: wvr_cts0(mwvrch,mnant)
  data chan_id /'1','2','3'/
  !
  !==========================================================================
  !
  !      print *, 'iant ',iant, ' wvrmode ',wvrmode, ' WVRCPOL ',WVRCPOL
  trouble_load = 0
  badgain = .false.
  badpelt = .false.
  i_hot  = 0
  i_cold = 0
  !
  ! safeguard against strange data:
  if (r_ndump .lt. 1 ) then
    message = 'Error: r_ndump < 1, no serious data.'
    status=2
    return
  endif
  !
  k_last = -1
  do ix = 1, r_ndump
    k  = wvrstat(ix,iant)
    ! this form is only accepted by Linux g77
    ! checked in the actual bits -- RL
    f_hot = iand(k,bit_hot)   .ne.0
    f_ambok = iand(k,bit_ambok) .ne.0
    ! la commande n'est pas dans le status -- RL.
    !          F_AMB = IAND(K,2) .EQ. 2
    f_amb = f_ambok
    f_pel = iand(k,bit_pel) .ne.0
    !
    badpelt = badpelt.or.f_pel
    !
    ! always ignore the first point after a change in operational mode flag
    !
    if (f_amb.and.f_ambok) then
      if (f_hot) then
        if (k .eq. k_last) then
          do ic = 1, mwvrch
            sum_hot(i_hot,ic)=sum_hot(i_hot,ic)+wvr(ix,ic,iant)
          enddo
          num_hot(i_hot) = num_hot(i_hot)+1
          xx_hot(i_hot) = xx_hot(i_hot) + ix
        else
          i_hot = i_hot+1
          num_hot(i_hot)  = 0
          xx_hot(i_hot)   = 0.0
          do ic = 1, mwvrch
            sum_hot(i_hot,ic)=0.0
          enddo
        endif
      else
        if (k .eq. k_last) then
          do ic = 1, mwvrch
            sum_cold(i_cold,ic)=sum_cold(i_cold,ic)+wvr(ix,ic,iant)
          enddo
          num_cold(i_cold) = num_cold(i_cold)+1
          xx_cold(i_cold) = xx_cold(i_cold) + ix
        else
          i_cold = i_cold+1
          num_cold(i_cold)  = 0
          xx_cold(i_cold)   = 0.0
          do ic = 1, mwvrch
            sum_cold(i_cold,ic)=0.0
          enddo
        endif
      endif
    else
      trouble_load = trouble_load+1
    endif
    k_last = k
  enddo
  !
  ! calculate average counts on ambient (wvramb) and hot (wvrhot) observation,
  ! wvramb is necessary for tsys estimate by another subroutine.
  !
  do ic = 1, mwvrch
    r_wvramb(ic,iant) = 0.0
    wvrhot(ic) = 0.0
  enddo
  rnum1 = 0.0
  rnum2 = 0.0
  do ix = 1, i_cold
    if (num_cold(ix) .gt. 0) then
      do ic = 1, mwvrch
        r_wvramb(ic,iant) = r_wvramb(ic,iant) + sum_cold(ix,ic)
      enddo
      rnum1 = rnum1 + num_cold(ix)
    endif
  enddo
  do ix = 1, i_hot
    if (num_hot(ix) .gt. 0) then
      do ic = 1, mwvrch
        wvrhot(ic) = wvrhot(ic) + sum_hot(ix,ic)
      enddo
      rnum2 = rnum2 + num_hot(ix)
    endif
  enddo
  do ic = 1, mwvrch
    r_wvramb(ic,iant) = r_wvramb(ic,iant)/max(1.,rnum1)
    wvrhot(ic) = wvrhot(ic)/max(1.,rnum2)
  enddo
  !      print *, (iant, ic, R_WVRAMB(IC,IANT), WVRHOT(IC), ic=1, MWVRCH)
  !
  ! If requested (and possible): polynomial fit through cold calibration
  ! phases to determine offset of hot calibration phases.
  ! Shift X axis into [-1,1] interval for higher fit precision
  ! Calculate the average calibration points
  !
  do ix = 1, i_cold
    do ic = 1, mwvrch
      sum_cold(ix,ic) = sum_cold(ix,ic)/max(1,num_cold(ix))   &
        - r_wvramb(ic,iant)
    enddo
    xx_cold(ix) = xx_cold(ix)/max(1,num_cold(ix))   &
      * 2.0 / float(r_ndump) - 1.0
  enddo
  do ix = 1, i_hot
    do ic = 1, mwvrch
      sum_hot(ix,ic) = sum_hot(ix,ic)/max(1,num_hot(ix))   &
        - r_wvramb(ic,iant)
    enddo
    xx_hot(ix) = xx_hot(ix)/max(1,num_hot(ix))   &
      * 2.0 / float(r_ndump) - 1.0
  enddo
  !
  if ((wvrcpol .ne. 0).and.(i_cold.ge.2)) then
    !
    kplus1 = max(min(wvrcpol,i_cold-1),1)
    do ix = 1, max_fp
      ww(ix) = 0.0
      if (ix .le. i_cold) ww(ix) = 1.0
    enddo
    do ic = 1, mwvrch
      do ix = 1, max_fp
        w(ix) = 1.0
      enddo
      ix = 0
      call bev_polfit (xx_cold, sum_cold(1,ic), w, i_cold,   &
        kplus1-1, ix, a, chisqr)
      delta(ic) = 0.0
      do ix = 1, i_hot
        tmp = a(kplus1)
        if (kplus1 .gt. 1) then
          do ii = kplus1-1,1,-1
            tmp = tmp * xx_hot(ix) + a(ii)
          enddo
        endif
        delta(ic) = delta(ic) + (sum_hot(ix,ic) - tmp)
      enddo
      delta(ic) = delta(ic) / float(i_hot)
    enddo
  else
    do ic = 1, mwvrch
      delta(ic) = wvrhot(ic)-r_wvramb(ic,iant)
    enddo
  !         print *, delta
  endif
  ! Philosophy: always write the gains and receiver temperatures
  !             which were actually applied into the header.
  !
  ! Wvrmode 1: DO NOTHING, trec & gains come from the calling program
  ! Wvrmode 2: apply laboratory Trec and Gains.
  ! Wvrmode 3: apply laboratory Trec and use actual calibration for Gains.
  ! Wvrmode 4: apply actual calibration for Gains and Trec.
  !
  !      BADGAIN = (RNUM1.EQ.0).OR. (RNUM2.EQ.0) no diode anymore
  badgain = (rnum1.eq.0)
  if (wvrmode .eq. 2) then
    do ic = 1, mwvrch
      r_wvrtcal(ic,iant) = r_wvrlabtcal(ic,iant)
      r_wvrtrec(ic,iant) = r_wvrlabtrec(ic,iant)
    enddo
  elseif (wvrmode .eq. 3) then
    do ic = 1, mwvrch
      badgain = badgain .or. (r_wvramb(ic,iant).lt.0.0001)
      r_wvrtrec(ic,iant) = r_wvrlabtrec(ic,iant)
      if (wvrprev .eq. 0) r_wvrtcal(ic,iant) = (r_wvrtrec(ic,iant)+r_wvrtamb(iant))   &
                       /max(r_wvramb(ic,iant),0.0001)
    enddo
  elseif (wvrmode .eq. 4) then
    do ic = 1, mwvrch
      badgain = badgain .or. (delta(ic).lt.0.0001)
      if (wvrprev .eq. 0) r_wvrtcal(ic,iant) = r_wvrlabtdio(ic,iant)   &
                          /max(delta(ic),0.0001)
    !            Y = DELTA(IC)/MAX(R_WVRAMB(IC,IANT),0.0001)
    !            R_WVRTREC(IC,IANT) = R_WVRLABTDIO(IC,IANT)/Y
    !     $      - R_WVRTAMB(IANT)
    enddo
  elseif (wvrmode .eq. 5) then
    do ic = 1, mwvrch
      wvr_cts0(ic,iant) = r_wvrtrec(ic,iant)
      if (wvrprev .eq. 0) r_wvrtcal(ic,iant) = r_wvrtamb(iant)   &
               /max((r_wvramb(ic,iant) - wvr_cts0(ic,iant)) ,0.0001)
    enddo
  elseif (wvrmode .eq. 6) then
    wvr_cts0(1,iant) = r_wvrtrec(1,iant)
    r_wvrtcal(1,iant) = 0.0
    do ic = 2, mwvrch
      wvr_cts0(ic,iant) = r_wvrtrec(ic,iant)
      if (wvrprev .eq. 0) r_wvrtcal(ic,iant) = r_wvrtamb(iant)   &
        /max((r_wvramb(ic,iant) - wvr_cts0(ic,iant)),0.0001)
    enddo
  endif
  !
  status = 0
  message = ' '
  !
  ! Reason to worry but one can continue: Ambient load movement slow
  if (trouble_load .gt. 2) then
    status = 1
    message = 'Ambient load slow.'
  endif
  !
  ! Look how far we're off relative to the lab values. If > 30%, something
  ! went wrong for sure. Take Lab values to avoid data loss.
  !
  do ic = 1, mwvrch
    tmp = abs(r_wvrtrec(ic,iant)-r_wvrlabtrec(ic,iant))   &
      /r_wvrlabtrec(ic,iant)
    !         print *, 'ic, R_WVRTREC(IC,IANT), R_WVRLABTREC(IC,IANT)'
    !         print *, ic, R_WVRTREC(IC,IANT), R_WVRLABTREC(IC,IANT)
    if (tmp.gt.0.3) then
      status=1
      message = message(1:lenc(message))//   &
        ' too large TREC deviation in Channel '//chan_id(ic)
    !     PRINT*,R_WVRTREC(IC,IANT),' <=> ',R_WVRLABTREC(IC,IANT),TMP
    !            R_WVRTREC(IC,IANT) = R_WVRLABTREC(IC,IANT)
    endif
    !         print *, 'ic, R_WVRTCAL(IC,IANT), R_WVRLABTCAL(IC,IANT)'
    !         print *, ic, R_WVRTCAL(IC,IANT), R_WVRLABTCAL(IC,IANT)
    tmp = abs(r_wvrtcal(ic,iant)-r_wvrlabtcal(ic,iant))   &
      /r_wvrlabtcal(ic,iant)
    if (tmp.gt.0.3) then
      status=1
    !            MESSAGE = MESSAGE(1:LENC(MESSAGE))//
    !     $      ' too large GAIN deviation in Channel '//CHAN_ID(IC)
    !            PRINT*,R_WVRTCAL(IC,IANT),' <=> ',R_WVRLABTCAL(IC,IANT),TMP
    !            R_WVRTCAL(IC,IANT) = R_WVRLABTCAL(IC,IANT)
    endif
  enddo
  !
  ! Reason to check instrument (and don't use this calibration):
  !   1) a calibration phase is missing, or the difference between phases
  !      is useless,
  !   2) the Peltier regulation has a serious problem,
  !   3) the load is not in front of the horn.
  !
  if (badgain) then
    status = 2
    message = message(1:lenc(message))//' Bad calibration.'
  endif
  if (badpelt) then
    status = 2
    message =  message(1:lenc(message))//' Peltier Alert.'
  endif
  if (trouble_load .eq. r_ndump) then
    status = 2
    message =  message(1:lenc(message))//' Load did not move.'
  endif
!
!      write(*,*) 'message ',message
end subroutine wvr_cali
!
subroutine do_wvr (again,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! The WVR MODEL program is called for each antenna.
  !---------------------------------------------------------------------
  logical :: again                  !
  logical :: error                  !
  ! Global
  real :: air_mass_m
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: ia, ic, ntrec
  real ::  awater
  character(len=160) :: ch
  integer :: ilevel, status
  real :: airmass, elevation
  !------------------------------------------------------------------------
  ! Code:
  ! Force input values if desired
  ilevel = 1
  ntrec = 0
  awater = 0
  !
  ! Necessary preparation calls:
  !
  call atm_atmosp(r_tamb, r_pamb, r_alti)
  !
  ! elevation in degrees
  elevation = 180.0*r_el/pi
  airmass = air_mass_m(elevation, r_alti)
  !
  do ia=1, r_nant
    if (r_wvrnch(ia).eq.3) then
      call wvr_model (ia,airmass,status)
      !            IF (.NOT.AGAIN) THEN
      write(ch,1000) r_kant(ia),r_wvrmode(ia),r_wvrh2o(ia),   &
        (r_wvrdpath(ic,ia),ic=1,r_wvrnch(ia)),   &
        (r_wvrliq(ic,ia),ic=1,r_wvrnch(ia))
      call message(ilevel,1,'DO_WVR',ch(1:lenc(ch)))
1000  format('A',i0,' M',i1,' w=',f7.3,' Dp=',3f7.0,' lq=',3f6.3)
      !     ENDIF
      if (status.ne.0) then
        call  message(8,1,'DO_WVR','Problem in ATM routine')
      endif
    endif
  enddo
  return
end subroutine do_wvr
!
subroutine wvr_model(ia,airmass, status)
  use classic_api  
  !---------------------------------------------------------------------
  ! M. Bremer, 17-Oct-2001
  ! Tested with small "frame" program using WVR test data sets.
  ! Calculates an atmospherical model for phase correction for the
  ! triple-band radiometer, assumes operational radiometers, i.e.
  ! antennas not yet equipped with WVRs must NOT call this routine.
  !
  ! LINK LIBRARY:
  !     libatm.a
  !
  ! BEFORE calling wvr_model in an antenna-specific loop:
  !        call atm_atmosp(r_tamb, r_pamb, r_alti)
  !
  ! INPUT:
  !
  !     real wvrfreq(mwvrch)  I  frequencies
  !     real wvrbw(mwvrch)    I  bandwidth
  !     real r_pamb           I  atm. press
  !     real r_tamb           I  atm. Temp
  !     real r_alti           I  observatory alititude
  !     real airmass          I  airmass
  !     real wvrfeff(mwvrch)  I  Forward efficiency for each channel
  !     real wvrtcal(mwvrch)  I  k/count channel gains
  !     real wvrtrec(mwvrch)  I  receiver temperatures (per channel)
  !     real wvraver(mwvrch)  I  average counts of current obs, which
  !                              must be on the sky
  !     real wvramb(mwvrch)   I  average counts on last ambient measurement
  !     real wvrtamb          I  last load temperature
  !
  ! OUTPUT:
  !     real wvrtatm          O  WVR central channel "clear sky"
  !                              atmospheric temperature
  !     real wvrtsys (mwvrch) O  WVR channel system temperature
  !     real wvrdpath(mwvrch) O  factors for channels for
  !                              Tsky to path conversion [microns/K]
  !     real wvrh2o           O  Precipitable amount of water vapour [mm]
  !     real wvrliq(mwvrch)   O  Tsky weight factors for each channel
  !                              for combination into cloud emission []
  !     real wvrdcloud(mwvrch)O  (experimental:) factors to convert
  !                              the cloud emission into liquid phase shifts.
  !                              Units: [microns/K]
  !     integer status        O  atm standard error codes, +10 superimposed
  !                              if iteration for water does not reproduce
  !                              t_triple to 1e-4 (relative error)
  !
  ! MEMO:
  !
  ! vapor_path =sum(ic=1,mwvrch){wvrdpath(ic)*(tsky(ic)}
  ! cloud_path =sum(ic=1,mwvrch){wvrdcloud(ic)*wvrliq(ic)*tsky(ic)}
  !
  ! where tsky(ic) = atmospheric emission in Kelvin along the line of sight
  !---------------------------------------------------------------------
  integer :: ia                     !
  real :: airmass                   !
  integer :: status                 !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ic
  real :: wvrtaut(mwvrch)
  real :: b, c1, c2, t_triple, tsky(mwvrch)
  real :: temib(mwvrch), tamb, dpdtri, tcloud
  real :: a1,a2,a3, b1,b2,b3, c, wvr_cts0(mwvrch,mnant)
  !----------------------------------------------
  !
  status = 0
  !
  ! Ambient temperature as seen by the instrument should be a
  ! combination of outside and receiver cabin temperature.
  !
  !      TAMB = R_WVRTAMB(IA) * 0.5 + R_TAMB * 0.5
  tamb = r_wvrtamb(ia)
  !
  ! Remove first order instrumental effects:
  !
  c1 = (r_wvrfreq(1,ia) / r_wvrfreq(2,ia))**2
  c2 = (r_wvrfreq(2,ia) / r_wvrfreq(3,ia))**2
  b = (1.-c1)/(1.-c2)
  !
  do ic = 1, mwvrch
    if (r_wvrtcal(ic,ia).le.0) then
      status = 1
      print *, 'No calibration for antenna ',ia
      return
    endif
    if (r_wvrmode(ia).ge.5) then
      wvr_cts0(ic,ia) = r_wvrtrec(ic,ia)
      tsky(ic)=(r_wvraver(ic,ia)-wvr_cts0(ic,ia))*   &
        r_wvrtcal(ic,ia)
    else
      tsky(ic)=(r_wvraver(ic,ia)*r_wvrtcal(ic,ia)-   &
        r_wvrtrec(ic,ia)-   &
        (1.-r_wvrfeff(ic,ia)) * tamb)/r_wvrfeff(ic,ia)
    endif
  enddo
  !
  ! Remove clouds and second order instrumental effects:
  !
  t_triple = b*(tsky(2)-tsky(3)*c2) - (tsky(1)-tsky(2)*c1)
  !      T_TRIPLE =  (TSKY(1)-TSKY(2)*C1) - B*(TSKY(2)-TSKY(3)*C2)
  if (r_wvrmode(ia).eq.6) then
     t_triple = tsky(2)-tsky(3)*c2
  endif
  !
  call atm_tri (ia,t_triple,b,c1,c2,airmass,   &
    dpdtri, temib, wvrtaut, status)
  !
  ! build the dTcoud/dTsky factors
  !
  do ic = 1, mwvrch
    r_wvrliq(ic,ia) = (1. - temib(ic)/tsky(ic))
  enddo
  !
  ! build the clear sky "dpath(microns)/dTsky(Kelvin) factors
  !
  r_wvrdpath(1,ia) = -dpdtri
  r_wvrdpath(2,ia) =  dpdtri * (c1 + b)
  r_wvrdpath(3,ia) = -dpdtri *  c2 * b

  if (r_wvrmode(ia).eq.6) then
   r_wvrdpath(1,ia) =  0.0
   r_wvrdpath(2,ia) =  dpdtri
   r_wvrdpath(3,ia) = -dpdtri *  c2
  endif
  !
  !      R_WVRDPATH(1,IA) =  DPDTRI
  !      R_WVRDPATH(2,IA) = -DPDTRI * (C1 + B)
  !      R_WVRDPATH(3,IA) =  DPDTRI *  C2 * B
  !
  if (atmmodel.eq.'1985') then
    !         print *, 'Old ATM: Fudge factor'
    !        Simulate approximately the effect of NEWATM on the delay factors
    !        Assignment of the coefficients could be pulled out of the antenna loop
    a1 = -5.81000e-03
    a2 = -5.79000e-03
    a3 = -5.77000e-03
    b1 =  1.17452
    b2 =  1.16929
    b3 =  1.16532
    c  =  1.08000
    !
    r_wvrdpath(1,ia) = (a1*r_wvrh2o(ia)+b1)*c*r_wvrdpath(1,ia)
    r_wvrdpath(2,ia) = (a2*r_wvrh2o(ia)+b2)*c*r_wvrdpath(2,ia)
    r_wvrdpath(3,ia) = (a3*r_wvrh2o(ia)+b3)*c*r_wvrdpath(3,ia)
  endif
  !
  ! WVR tsys definition after R. Lucas (1995),
  ! "Practical implementation of phase correction", IRAM Report
  !
  do ic = 1, mwvrch
    r_wvrtsys(ic,ia)=r_wvraver(ic,ia)*r_wvrtcal(ic,ia)   &
      /r_wvrfeff(ic,ia)
  enddo
  !
  ! Classical Tsys
  !
  !c       do ic = 1, mwvrch
  !c           tcal = (wvrtamb - tsky(ic))/wvrfeff(ic) *
  !c     $            exp(wvrtaut(ic) * airmass)
  !c           wvrtsys(ic) = tcal * wvraver(ic)/(wvramb(ic)-wvraver(ic))
  !c        enddo
  !
  tcloud = 278.0
  call atm_tri_cl(ia,tcloud)
!
end subroutine wvr_model
!
!------------------------------------------------------------------------
subroutine atm_tri(ia,t_triple,b,c1,c2,airmass,   &
    dpdtri, temib, wvrtaut, ier)
  use atm_interfaces_public
  use classic_api
  !---------------------------------------------------------------------
  ! Purpose: determines the amount of water vapor for the triple frequency
  !          radiometer.
  ! INPUT:  real*4 t_triple: weighted sum of the 3 monitoring bands in Kelvin
  !        wvrfreq(mwvrch) : effective central monitoring frequencies in GHz
  !          wvrbw(mwvrch) : channel band widths
  !                b,c1,c2 : weighting factors between the bands
  !                airmass : Air mass, "one" in zenith
  ! OUTPUT: real*4 wvrh2o   : precipitable amount of water vapor in mm (Zenith)
  !                dpdtri  : gradient dpath/dt_triple in microns/K
  !                wvrtatm : atmospherical temperature (center water line)
  !           temib(mwvrch): "blue sky" emission at the given elevation,
  !                          i.e. modelled monitor band signals without
  !                          clouds in Kelvin
  !                path_out: "blue sky" optical path in microns
  !         wvrtaut(mwvrch): total clear sky opacity of the wvr channels
  !         integer*4 ier  : error flag.
  !
  ! NOTE: Routine needs a previous call to  atm_atmosp(t0, p0, h0), by
  !       preference OUTSIDE the antenna specific loop.
  !
  ! Author: Michael Bremer, IRAM 10-Jun-1999
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer :: ia                     !
  real :: t_triple                  !
  real :: b                         !
  real :: c1                        !
  real :: c2                        !
  real :: airmass                   !
  real :: dpdtri                    !
  real :: temib(mwvrch)             !
  real :: wvrtaut(mwvrch)           !
  integer :: ier                    !
  ! Global
  include 'clic_par.inc'
  ! Local
  integer :: i, nval, ic, ib
  parameter (nval = 3)
  real :: f_ghz
  real :: tatm, tauox, tauw, taut, path
  real :: wa, wband(-1:1)
  real :: w(nval), temia(mwvrch)
  real :: tri(nval), patha(nval), tri_water
  real :: ave_tsky, ave_path, ave_taut, ave_tatm
  real :: tsky, hl, hr
  !
  ! The 3-point weighted sum over the passbands corresponds to the
  ! average over a polynomial of 2nd degree (Simpson formula).
  data wband /0.16666667, 0.6666666, 0.16666667/
  !--------------------------------------------------
  w(2) = 0
  !
  if (r_wvrmode(ia).ge.5) then
    if (r_wvrmode(ia).eq.6) then
      call dual_water(ia,t_triple,b,c1,c2,airmass,   &
        tri_water,ier)
      r_wvrh2o(ia) = tri_water
      w(2) = r_wvrh2o(ia)
    else
      call triple_water(ia,t_triple,b,c1,c2,airmass,   &
        tri_water,ier)
      r_wvrh2o(ia) = tri_water
      w(2) = r_wvrh2o(ia)
    endif
  else
    do i =1, r_nant
      w(2) = w(2)+r_h2omm(1,i)
    enddo
    w(2) = w(2)/r_nant
  endif
  w(1) = w(2)*0.9
  w(3) = w(2)*1.1
  !
  !      TT = ABS(T_TRIPLE)
  !
  do i = 1, nval
    do ic = 1, mwvrch
      wa =  w(i)
      ave_tsky = 0.0
      ave_path = 0.0
      do ib = -1,1
        f_ghz = 0.001*(r_wvrfreq(ic,ia) + ib*r_wvrbw(ic,ia)*0.5)
        call atm_transm(wa, airmass, f_ghz, tsky, tatm,   &
          tauox, tauw, taut, ier)
        call atm_path(wa, airmass, f_ghz, path, ier)
        ave_tsky = ave_tsky + tsky * wband(ib)
        ave_path = ave_path + path * wband(ib)
      enddo
      temia(ic) =  ave_tsky
      if (ic .eq. 2) patha(i) =  ave_path
    enddo
    tri(i)  =  b * (temia(2) - c2 * temia(3)) -   &
      (temia(1) - c1 * temia(2))
  !         TRI(I)  =  (TEMIA(1) - C1 * TEMIA(2)) -
  !     $              B * (TEMIA(2) - C2 * TEMIA(3))
  enddo
  !
  ! checked for unusual temperature and pressure values
  ! (150-500K, 300-1500 mbar in case of a meteo station problem):
  ! no problem with having different "tri" values for the water values,
  ! poly_3 won't crash.
  !
  ! calculate the actual amount of water
  !      R_WVRH2O(IA) = W(2)
  !      DPDTRI = (PATHA(3)-PATHA(1)) / (TRI(3)-TRI(1))
  ! Use second order accuracy for the derivative (JMW, Nov 24 2003)
  hl     = tri(2)-tri(1)
  hr     = tri(3)-tri(2)
  dpdtri =  -hr/(hl*(hl+hr)) * patha(1) +   &
    (hr-hl)/(hr*hl)  * patha(2) +   &
    hl/(hr*(hl+hr)) * patha(3)
  !
  ! Conversion from cm/K to microns/K
  dpdtri = dpdtri * 1e4
  !
  ! Expected blue sky contribution to the bands (incl. other
  ! components than H2O):
  !
  do ic = 1, mwvrch
    ave_tsky = 0.0
    ave_path = 0.0
    ave_taut = 0.0
    ave_tatm = 0.0
    do ib = -1,1
      f_ghz = 0.001*(r_wvrfreq(ic,ia) + ib*r_wvrbw(ic,ia)*0.5)
      !
      ! calls to libatm.a
      !
      call atm_transm(r_wvrh2o(ia), airmass, f_ghz,   &
        tsky, tatm, tauox, tauw, taut, ier)
      call atm_path(r_wvrh2o(ia), airmass, f_ghz, path, ier)
      !
      ave_tsky = ave_tsky + tsky * wband(ib)
      ave_path = ave_path + path * wband(ib)
      ave_taut = ave_taut + taut * wband(ib)
      ave_tatm = ave_tatm + tatm * wband(ib)
    enddo
    temib(ic) =  ave_tsky
    wvrtaut(ic) = ave_taut
    if (ic .eq. 2) then
      r_wvrpath(ia) = ave_path*1e4
      r_wvrtatm(ia) = ave_tatm
    endif
  enddo
!
end subroutine atm_tri
!
!------------------------------------------------------------------------
!
function air_mass_m (elevation, altitude)
  !---------------------------------------------------------------------
  ! NIC	SOLVE support routine
  !	Compute air masses
  ! 10-JUL-1995 modified by M. Bremer
  !
  ! Arguments :
  !	ELEV		R*4	elevation in degrees		Input
  !	AIR_MASS	R*4	number of airmasses		Output
  !       ALTITUDE        R*4     altitude of observatory above
  !                               sea level                       Input
  !---------------------------------------------------------------------
  real*4 ::  air_mass_m             !
  real*4 ::  elevation              !
  real*4 ::  altitude               !
  ! Local
  integer :: index
  real*4 ::  h0_al(7)
  real*8 ::  hz, h0, r0, r1, pi, r0_al
  real*8 :: elv, eps, gam
  !
  !     earth radius (in km)
  parameter (r0 = 6370.0, pi = 3.141592653589793238d0)
  !
  ! DEPENDENCY OF SCALE HEIGHT H0_AL ON ALTITUDE (BOTH IN KM)
  ! FROM ALLEN C.W. 1991, ASTROPHYSICAL QUANTITIES, THE ATHLONE PRESS, P. 122)
  !
  ! ALTITUDE OVER SEA LEVEL  0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0
  data  h0_al        / 8.4, 8.3, 8.2, 8.0, 7.8, 7.5, 7.2/
  !
  ! LINEAR INTERPOLATION BETWEEN NEAREST VALUES IN ALTITUDE FOR SCALE HEIGHT
  index = int(altitude) + 1
  h0    = h0_al(index) + (h0_al(index+1) - h0_al(index)) *   &
    (altitude - index - 1)
  !
  r0_al = r0 + altitude
  !
  elv = elevation*pi/180
  r1  = r0_al + h0
  eps = asin( r0_al / r1 * cos(elv) )
  gam = pi/2 - elv - eps
  hz  = r0_al*r0_al + r1*r1 - 2*r0_al*r1*cos(gam)
  hz  = sqrt(max(hz,h0*h0))    ! avoid less than one air mass
  !
  air_mass_m = hz/h0
  return
end function air_mass_m
!
!*************************************************************************
!
subroutine poly_3(x,y,para)
  !---------------------------------------------------------------------
  ! Calculate the 3rd degree polynomial parameters going through 4 points:
  ! y = d + x*(c + x*(b + x*a) )
  ! para(1,2,3,4) = (a,b,c,d)
  ! Caution: all x must be different from each other. No rezoning to [-1,1] is
  !          done, values of x>100 can result in dubious results, especially
  !          for "d" (the other parameters depend on differences)
  !
  !  Input: real*8 x(4), y(4)
  ! Output: real*8 para(4)
  !
  !  Speed: about 30 times faster than a Gauss-Jordan matrix inversion
  !
  ! Author: M. Bremer, 10-Jun-1999 (tested, OK)
  !---------------------------------------------------------------------
  real*4 :: x(4)                    !
  real*4 :: y(4)                    !
  real*4 :: para(4)                 !
  ! Local
  integer :: i, j
  real*4 :: dx(3),dy(3),dx2(3),dx3(3),fr1(3),fr2(3),fr3(3)
  real*4 :: a,b,c,d,df1,df2,dfr1,dfr2
  !
  ! use smallest available x for determination of "d"
  !
  j = 1
  do i = 2,4
    if ( abs(x(i)) .lt. abs(x(j)) ) j = i
  enddo
  !
  do i = 1,3
    dy (i) = y(i) - y(i+1)
    dx (i) = x(i) - x(i+1)
    dx2(i) = x(i)**2 - x(i+1)**2
    dx3(i) = x(i)**3 - x(i+1)**3
    fr1(i) = dy(i)  / dx(i)
    fr2(i) = dx2(i) / dx(i)
    fr3(i) = dx3(i) / dx(i)
  enddo
  df1 = 1./(fr2(1) - fr2(2))
  df2 = 1./(fr2(2) - fr2(3))
  !
  dfr1 = fr1(1) - fr1(2)
  dfr2 = fr1(2) - fr1(3)
  !
  a =  (dfr1*df1 - dfr2*df2)/   &
    ((fr3(1)-fr3(2))*df1 - (fr3(2)-fr3(3))*df2)
  b =  (dfr1 - a*(fr3(1)-fr3(2)) ) * df1
  c =  (dy(1)-a*dx3(1)-b*dx2(1))/dx(1)
  d = y(j) - x(j)*(c + x(j)*(b + a*x(j)) )
  para(1) = a
  para(2) = b
  para(3) = c
  para(4) = d
end subroutine poly_3
!
!*************************************************************************
subroutine atm_tri_cl(ia,tcloud)
  use classic_api  
  !---------------------------------------------------------------------
  ! MB 16-Aug-2001
  ! Simple cloud model after Staelin (1966), J. Geophys. Res. 71, 2875
  ! Take the difference between the extreme lowfreq/highfreq channels to
  ! get a good result (central channel might be contaminated by residual
  ! water vapor emission). Taking the difference should remove
  ! background fluctuations.
  ! No airmass is needed here.
  !---------------------------------------------------------------------
  integer :: ia                     !
  real :: tcloud                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: ib, ic
  real :: refrac_liquid, f_ghz, wband(-1:1)
  real :: bintegral(mwvrch), tmp, vlum2
  parameter(refrac_liquid = 5.0, vlum2 = 89875.54305)
  !
  ! The 3-point weighted sum over the passbands corresponds to the
  ! average over a polynomial of 2nd degree (Simpson formula).
  data wband /0.16666667, 0.6666666, 0.16666667/
  !
  do ic = 1, mwvrch
    tmp = 0.0
    do ib = -1,1
      f_ghz = r_wvrfreq(ic,ia) + ib*r_wvrbw(ic,ia)*0.5
      tmp = tmp + wband(ib) * (f_ghz * f_ghz) / vlum2
    enddo
    bintegral(ic) = tmp
  enddo
  !
  tmp = (refrac_liquid - 1.) /   &
    (tcloud * (bintegral(3) - bintegral(1)) *   &
    10.0**(0.0122*(291.-tcloud)-2.) )
  !
  r_wvrdcloud(1,ia) = - tmp
  r_wvrdcloud(2,ia) =   0.0
  r_wvrdcloud(3,ia) =   tmp
!
end subroutine atm_tri_cl
!=======================================================================
! SUBROUTINE BEV_POLFIT.F
!
! SOURCE
!   BEVINGTON, PAGES 140-142.
!
! PURPOSE
!   MAKE A LEAST-SQUARES FIT TO DATA WITH A POLYNOMIAL CURVE
!      Y = A(1) + A(2)*X + A(3)*X**2 + A(3)*X**3 + . . .
!
! USAGE
!   CALL POLFIT (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, CHISQR)
!
! DESCRIPTION OF PARAMETERS
!   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
!   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
!   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
!   NPTS   - NUMBER OF PAIRS OF DATA POINTS
!   NTERMS - NUMBER OF COEFFICIENTS (DEGREE OF POLYNOMIAL + 1)
!   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
!	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
!	      0 (NO WEIGHTING) WEIGHT(I) = 1.
!	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
!   A	   - ARRAY OF COEFFICIENTS OF POLYNOMIAL
!   CHISQR - REDUCED CHI SQUARE FOR FIT
!
! SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
!   DETERM (ARRAY, NORDER)
!      EVALUATES THE DETERMINANT OF A SYMETRICAL
!      TWO-DIMENSIONAL MATRIX OF ORDER NORDER
!
! COMMENTS
!   DIMENSION STATEMENT VALID FOR NTERMS UP TO 16
!
subroutine bev_polfit (x,y,sigmay,npts,nterms,mode,a,chisqr)
  integer :: npts                   !
  real*8 :: x(npts)                 !
  real*8 :: y(npts)                 !
  real*8 :: sigmay(npts)            !
  integer :: nterms                 !
  integer :: mode                   !
  real*8 :: a(*)                    !
  real*8 :: chisqr                  !
  ! Local
  real*8 :: sumx,sumy,xterm,yterm,array,bev_determ,chisq
  integer :: mcwvrdump, mcdmp2
  parameter(mcwvrdump=128, mcdmp2=2*mcwvrdump)
  dimension sumx(mcdmp2),sumy(mcdmp2),array(mcwvrdump,mcwvrdump)
  !
  integer :: n,nmax,i,j,k,l, free
  double precision xi,yi, weight, delta
  !
  ! ACCUMULATE WEIGHTED SUMS
  !
nmax=2*nterms-1
  do 13 n=1,nmax
13 sumx(n)=0.
  do 15 j=1,nterms
15 sumy(j)=0.
  chisq=0.
do 50 i=1,npts
    xi=x(i)
    yi=y(i)
if (mode) 32,37,39
32  if (yi) 35,37,33
33  weight=1./yi
    goto 41
35  weight=1./(-yi)
    goto 41
37  weight=1.
    goto 41
39  weight=1./sigmay(i)**2
41  xterm=weight
    do 44 n=1,nmax
      sumx(n)=sumx(n)+xterm
44  xterm=xterm*xi
yterm=weight*yi
    do 48 n=1,nterms
      sumy(n)=sumy(n)+yterm
48  yterm=yterm*xi
chisq=chisq+weight*yi**2
50 continue
  !
  ! CONSTRUCT MATRICES AND CALCULATE COEFFICIENTS
  !
do 54 j=1,nterms
    do 54 k=1,nterms
      n=j+k-1
54 array(j,k)=sumx(n)
  delta=bev_determ (array,nterms)
  if (delta) 61,57,61
57 chisqr=0.
  do 59 j=1,nterms
59 a(j)=0.
  goto 80
61 do 70 l=1,nterms
do 66 j=1,nterms
      do 65 k=1,nterms
        n=j+k-1
65    array(j,k)=sumx(n)
66  array(j,l)=sumy(j)
70 a(l)=bev_determ (array,nterms) /delta
  !
  ! CALCULATE CHI SQUARE
  !
do 75 j=1,nterms
    chisq=chisq-2.*a(j)*sumy(j)
    do 75 k=1,nterms
      n=j+k-1
75 chisq=chisq+a(j)*a(k)*sumx(n)
free=npts-nterms
chisqr=chisq/free
80 return
end subroutine bev_polfit
!========================================================================
! FUNCTION BEV_DETERM.F
!
! SOURCE
!   BEVINGTON, PAGE 294.
!
! PURPOSE
!   CALCULATE THE DETERMINANT OF A SQUARE MATRIX
!
! USAGE
!   DET = DETERM (ARRAY, NORDER)
!
! DESCRIPTION OF PARAMETERS
!   ARRAY  - MATRIX
!   NORDER - ORDER OF DETERMINANT (DEGREE OF MATRIX)
!
! SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
!   NONE
!
! COMMENTS
!   THIS SUBPROGRAM DESTROYS THE INPUT MATRIX ARRAY
!   DIMENSION STATEMENT VALID FOR NORDER UP TO 16
!
real*8 function bev_determ (array,norder)
  double precision array,save
  dimension array(16,16)
  integer i,j,k,k1
  !
  integer norder
  !
bev_determ=1.
do 50 k=1,norder
    !
    ! INTERCHANGE COLUMNS IF DIAGONAL ELEMENT IS ZERO
    !
    if (array(k,k)) 41,21,41
21  do 23 j=k,norder
      if (array(k,j)) 31,23,31
23  continue
    bev_determ=0.
    goto 60
31  do 34 i=k,norder
      save=array(i,j)
      array(i,j)=array(i,k)
34  array(i,k)=save
    bev_determ=-bev_determ
    !
    ! SUBTRACT ROW K FROM LOWER ROWS TO GET DIAGONAL MATRIX
    !
41  bev_determ=bev_determ*array(k,k)
    if (k-norder) 43,50,50
43  k1=k+1
    do 46 i=k1,norder
      do 46 j=k1,norder
46  array(i,j)=array(i,j)-array(i,k)*array(k,j)/array(k,k)
50 continue
60 return
end function bev_determ
!
subroutine triple_water(ia,t_triple,b,c1,c2,airmass,   &
    tri_water,ier)
  use atm_interfaces_public
  use classic_api
  !---------------------------------------------------------------------
  ! Test routine trying to derive water content from 22 GHz radiometers
  !---------------------------------------------------------------------
  integer :: ia                     !
  real :: t_triple                  !
  real :: b                         !
  real :: c1                        !
  real :: c2                        !
  real :: airmass                   !
  real :: tri_water                 !
  integer :: ier                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: i, j, k
  real :: f_ghz, tri
  real :: tatm, tauox, tauw, taut, dtri, dwa, deltawa, err
  real :: wa, wband(-1:1)
  real :: temia(mwvrch)
  real :: ave_tsky, tsky
  character(len=256) :: ch
  !
  ! The 3-point weighted sum over the passbands corresponds to the
  ! average over a polynomial of 2nd degree (Simpson formula).
  data wband /0.16666667, 0.6666666, 0.16666667/
  !
  ! use a reasonable starting value (first pol)
  wa = min(10.,max(0.5,r_h2omm(1,ia)))
  dwa  = 0.02
  err = 1e10
  k = 0
  !
  ! Loop
10 continue
  k = k + 1
  do i = 1, mwvrch
    ave_tsky = 0.0
    do j = -1,1
      f_ghz = 0.001*(r_wvrfreq(i,ia) + j*r_wvrbw(i,ia)*0.5)
      call atm_transm(wa, airmass, f_ghz, tsky, tatm,   &
        tauox, tauw, taut, ier)
      ave_tsky = ave_tsky + tsky * wband(j)
    enddo
    temia(i) =  ave_tsky
  enddo
  tri  =  b * (temia(2) - c2 * temia(3)) -   &
    (temia(1) - c1 * temia(2))
  !
  do i = 1, mwvrch
    ave_tsky = 0.0
    do j = -1,1
      f_ghz = 0.001*(r_wvrfreq(i,ia) + j*r_wvrbw(i,ia)*0.5)
      call atm_transm(wa+dwa, airmass, f_ghz, tsky, tatm,   &
        tauox, tauw, taut, ier)
      ave_tsky = ave_tsky + tsky * wband(j)
    enddo
    temia(i) =  ave_tsky
  enddo
  dtri  =  b * (temia(2) - c2 * temia(3))  -   &
    (temia(1) - c1 * temia(2)) - tri
  err = tri - t_triple
  write (ch,'(''Iteration: '',i2,'' current water: '',f5.2, ''delta: '', f8.4)')  &
    k,wa,err
!        CALL MESSAGE (2,1,'TRI_WATER',CH)  ! test - comment this message out later MB 20-Sep-2012
  if (abs(err).ge.0.001 .and. dtri.ne.0 .and. k.le.10) then
    deltawa = dwa * err / dtri
    if(abs(dwa).ge.abs(deltawa/10.)) dwa = deltawa/10.
    wa = max(0.01,min(wa - deltawa,50.0))
    goto 10
  endif
  tri_water = wa
end subroutine triple_water
!
subroutine dual_water(ia,t_triple,b,c1,c2,airmass,   &
    tri_water,ier)
  use atm_interfaces_public
  use classic_api
  !---------------------------------------------------------------------
  ! Test routine trying to derive water content from 22 GHz radiometers
  !---------------------------------------------------------------------
  integer :: ia                     !
  real :: t_triple                  !
  real :: b                         !
  real :: c1                        !
  real :: c2                        !
  real :: airmass                   !
  real :: tri_water                 !
  integer :: ier                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: i, j, k
  real :: f_ghz, tri
  real :: tatm, tauox, tauw, taut, dtri, dwa, deltawa, err
  real :: wa, wband(-1:1)
  real :: temia(mwvrch)
  real :: ave_tsky, tsky
  character(len=256) :: ch
  !
  ! The 3-point weighted sum over the passbands corresponds to the
  ! average over a polynomial of 2nd degree (Simpson formula).
  data wband /0.16666667, 0.6666666, 0.16666667/
  !
  ! use a reasonable starting value (first pol)
  wa = min(10.,max(0.5,r_h2omm(1,ia)))
  dwa  = 0.02
  err = 1e10
  k = 0
  !
  ! Loop
10 continue
  k = k + 1
  do i = 1, mwvrch
    ave_tsky = 0.0
    do j = -1,1
      f_ghz = 0.001*(r_wvrfreq(i,ia) + j*r_wvrbw(i,ia)*0.5)
      call atm_transm(wa, airmass, f_ghz, tsky, tatm,   &
        tauox, tauw, taut, ier)
      ave_tsky = ave_tsky + tsky * wband(j)
    enddo
    temia(i) =  ave_tsky
  enddo
  tri  =  (temia(2) - c2 * temia(3))
  !
  do i = 1, mwvrch
    ave_tsky = 0.0
    do j = -1,1
      f_ghz = 0.001*(r_wvrfreq(i,ia) + j*r_wvrbw(i,ia)*0.5)
      call atm_transm(wa+dwa, airmass, f_ghz, tsky, tatm,   &
        tauox, tauw, taut, ier)
      ave_tsky = ave_tsky + tsky * wband(j)
    enddo
    temia(i) =  ave_tsky
  enddo
  dtri  =  temia(2) - c2 * temia(3)  - tri
  err = tri - t_triple
  write (ch,'(''Iteration: '',i2,'' current water: '',f5.2, ''delta: '', f8.4)')  &
    k,wa,err
  !      CALL MESSAGE (2,1,'TRI_WATER',CH)
  if (abs(err).ge.0.01 .and. dtri.ne.0 .and. k.le.10) then
    deltawa = dwa * err / dtri
    if(abs(dwa).ge.abs(deltawa/10.)) dwa = deltawa/10.
    wa = max(0.01,min(wa - deltawa,50.0))
    goto 10
  endif
  tri_water = wa
end subroutine dual_water

module imbfits_interfaces_private
  interface
    subroutine reallocate_fits_logi_1d(kind,n,fitsarray,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: kind
      integer(kind=4),      intent(in)    :: n
      type(fits_logi_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine reallocate_fits_logi_1d
  end interface
  !
  interface
    subroutine reallocate_fits_inte_1d(kind,n,fitsarray,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: kind
      integer(kind=4),      intent(in)    :: n
      type(fits_inte_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine reallocate_fits_inte_1d
  end interface
  !
  interface
    subroutine reallocate_fits_real_1d(kind,n,fitsarray,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: kind
      integer(kind=4),      intent(in)    :: n
      type(fits_real_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine reallocate_fits_real_1d
  end interface
  !
  interface
    subroutine reallocate_fits_dble_1d(kind,n,fitsarray,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: kind
      integer(kind=4),      intent(in)    :: n
      type(fits_dble_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine reallocate_fits_dble_1d
  end interface
  !
  interface
    subroutine reallocate_fits_char_1d(kind,n,fitsarray,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: kind
      integer(kind=4),      intent(in)    :: n
      type(fits_char_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine reallocate_fits_char_1d
  end interface
  !
  interface
    subroutine reallocate_imbfits_data_val(nchan,npix,ntime,imbdata,error)
      use imbfits_messaging
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      ! (re)allocation routine specific for the DATA column
      !-------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: nchan
      integer(kind=4),      intent(in)    :: npix
      integer(kind=4),      intent(in)    :: ntime
      type(imbfits_data_t), intent(inout) :: imbdata
      logical,              intent(inout) :: error
    end subroutine reallocate_imbfits_data_val
  end interface
  !
  interface
    subroutine free_fits_logi_1d(fitsarray,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fits_logi_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine free_fits_logi_1d
  end interface
  !
  interface
    subroutine free_fits_inte_1d(fitsarray,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fits_inte_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine free_fits_inte_1d
  end interface
  !
  interface
    subroutine free_fits_real_1d(fitsarray,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fits_real_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine free_fits_real_1d
  end interface
  !
  interface
    subroutine free_fits_dble_1d(fitsarray,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fits_dble_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine free_fits_dble_1d
  end interface
  !
  interface
    subroutine free_fits_char_1d(fitsarray,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      !-------------------------------------------------------------------
      type(fits_char_1d_t), intent(inout) :: fitsarray
      logical,              intent(inout) :: error
    end subroutine free_fits_char_1d
  end interface
  !
  interface
    subroutine free_imbfits_data_val(imbdata,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private
      ! Free the 'val' array of the input imbfits_data_t instance.
      !-------------------------------------------------------------------
      type(imbfits_data_t), intent(inout) :: imbdata
      logical,              intent(inout) :: error
    end subroutine free_imbfits_data_val
  end interface
  !
  interface
    subroutine imbfits_obstype_equal(filename,imbf,obstype,equal,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the bare minimum as reading all the main hdus may take forever
      ! on large imbfitsfile.
      ! This could be a generic subroutine imbfits_equal. *** JP
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: filename
      type(imbfits_t),  intent(inout) :: imbf
      character(len=*), intent(in)    :: obstype
      logical,          intent(out)   :: equal
      logical,          intent(inout) :: error
    end subroutine imbfits_obstype_equal
  end interface
  !
  interface
    subroutine imbfits_check_version(version,error)
      use gbl_message
      use imbfits_parameters
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: version
      logical,      intent(inout) :: error
    end subroutine imbfits_check_version
  end interface
  !
  interface
    subroutine imbfits_check_header_primary(file,primary,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_file_t),    intent(in)    :: file
      type(imbfits_primary_t), intent(in)    :: primary
      logical,                 intent(inout) :: error
    end subroutine imbfits_check_header_primary
  end interface
  !
  interface
    subroutine imbfits_check_header_scan(primary,scan,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Check the consistency of the IMBF-scan HDU
      !---------------------------------------------------------------------
      type(imbfits_primary_t), intent(in)    :: primary
      type(imbfits_scan_t),    intent(in)    :: scan
      logical,                 intent(inout) :: error
    end subroutine imbfits_check_header_scan
  end interface
  !
  interface
    subroutine imbfits_check_header_backend(back,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Check the consistency of the IMBF-backend HDU
      ! *** JP Nothing done right now because previous test was too much
      !        restrictive. It is unclear whether this function is needed.
      !        Leave it for the time being.
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(in)    :: back
      logical,              intent(inout) :: error
    end subroutine imbfits_check_header_backend
  end interface
  !
  interface
    subroutine imbfits_dump_summary_seclass(seclass,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Loop over all the equivalence classes and give some details about
      ! them
      !---------------------------------------------------------------------
      type(eclass_char_t), intent(in)    :: seclass
      integer(kind=4),     intent(in)    :: olun     ! Output LUN
      logical,             intent(inout) :: error
    end subroutine imbfits_dump_summary_seclass
  end interface
  !
  interface
    subroutine imbfits_dump_file(file,olun,error)
      use gbl_message
      use gildas_def
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(in)    :: file
      integer(kind=4),      intent(in)    :: olun   ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_file
  end interface
  !
  interface
    subroutine imbfits_dump_subscans_list(imbf,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Loop over all the subscans and give some details about them
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      integer(kind=4), intent(in)    :: olun   ! Output LUN
      logical,         intent(inout) :: error
    end subroutine imbfits_dump_subscans_list
  end interface
  !
  interface
    subroutine imbfits_dump_scan_column(scan,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_scan_t), intent(in)    :: scan
      character(len=*),     intent(in)    :: column  ! Column name
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_scan_column
  end interface
  !
  interface
    subroutine imbfits_dump_frontend_column(front,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front
      character(len=*),      intent(in)    :: column  ! Column name
      integer(kind=4),       intent(in)    :: olun    ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_frontend_column
  end interface
  !
  interface
    subroutine imbfits_dump_backend_column(back,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(in)    :: back
      character(len=*),     intent(in)    :: column  ! Column name
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_backend_column
  end interface
  !
  interface
    subroutine imbfits_dump_antslow_column(antslow,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(in)    :: antslow
      character(len=*),        intent(in)    :: column   ! Column name
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antslow_column
  end interface
  !
  interface
    subroutine imbfits_dump_antfast_column(antfast,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_antfast_t), intent(in)    :: antfast
      character(len=*),        intent(in)    :: column   ! Column name
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antfast_column
  end interface
  !
  interface
    subroutine imbfits_dump_derot_column(derot,column,olun,error)
      use imbfits_parameters
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_derot_t), intent(in)    :: derot
      character(len=*),      intent(in)    :: column   ! Column name
      integer(kind=4),       intent(in)    :: olun     ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_derot_column
  end interface
  !
  interface
    subroutine imbfits_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine imbfits_message
  end interface
  !
  interface
    subroutine imbfits_reopen_file(filename,file,hdus,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Open, if needed, the given file. Close of needed any previous file
      ! (if different).
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: filename
      type(imbfits_file_t), intent(inout) :: file
      type(imbfits_hdus_t), intent(inout) :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_reopen_file
  end interface
  !
  interface
    subroutine imbfits_check_leadhdus(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Check the 4 first HDUs
      !---------------------------------------------------------------------
      type(imbfits_t),  intent(inout) :: imbf      !
      logical,          intent(inout) :: error     !
    end subroutine imbfits_check_leadhdus
  end interface
  !
  interface
    subroutine imbfits_read_subscan_eclass(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Run through all the subscans headers and build equivalences classes
      ! for all of them
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      logical,         intent(inout) :: error
    end subroutine imbfits_read_subscan_eclass
  end interface
  !
  interface
    subroutine imbfits_read_header_primary(file,primary,error)
      use gbl_message
      use imbfits_types
      use imbfits_key_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the Primary HDU
      !---------------------------------------------------------------------
      type(imbfits_file_t),    intent(in)    :: file
      type(imbfits_primary_t), intent(inout) :: primary
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_header_primary
  end interface
  !
  interface
    subroutine imbfits_read_header_scan(imbf,scan,error)
      use gbl_message
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the IMBF-scan HDU
      !---------------------------------------------------------------------
      type(imbfits_t),      intent(in)    :: imbf
      type(imbfits_scan_t), intent(inout) :: scan
      logical,              intent(inout) :: error
    end subroutine imbfits_read_header_scan
  end interface
  !
  interface
    subroutine imbfits_read_header_frontend(file,front,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the IMBF-frontend HDU
      !---------------------------------------------------------------------
      type(imbfits_file_t),  intent(in)    :: file
      type(imbfits_front_t), intent(inout) :: front
      logical,               intent(inout) :: error
    end subroutine imbfits_read_header_frontend
  end interface
  !
  interface
    subroutine imbfits_read_header_backend(imbf,error)
      use gbl_message
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the IMBF-backend HDU
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout), target :: imbf
      logical,         intent(inout)         :: error
    end subroutine imbfits_read_header_backend
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_patchlinename(front,back,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill the column imbf%back%table%linename
      !  from the column imbf%front%table%linename
      ! This is generic for any version of IMBFITS, although latest versions
      ! provides themselves the 2 columns
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front  !
      type(imbfits_back_t),  intent(inout) :: back   !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_patchlinename
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_patchrefchan(front,back,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Recompute correct REFCHAN.
      !  This code is generic but is needed only for a few cases.
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front  !
      type(imbfits_back_t),  intent(inout) :: back   !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_patchrefchan
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_frontend(back,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create a custom column FRONTEND. It provides the frontend name as
      ! used in the Class telescope name
      !---------------------------------------------------------------------
      type(imbfits_back_t),  intent(inout) :: back   !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_frontend
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_ifront(front,back,error)
      use gbl_message
      use imbfits_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create a custom column IFRONT. It provides a backpointer from
      ! backend RECEIVER column to frontend RECNAME column.
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front  !
      type(imbfits_back_t),  intent(inout) :: back   !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_ifront
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_dataflip(back,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create a custom column DATAFLIP. It provides a logical indicating
      ! if the data sign should be flipped or not at read time. As of today,
      ! this is used only in the context of polarimetry, but this is generic
      ! enough for other use cases if needed.
      !---------------------------------------------------------------------
      type(imbfits_back_t),  intent(inout) :: back   !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_dataflip
  end interface
  !
  interface
    subroutine imbfits_read_header_backend_ceclass(back,error)
      use gbl_message
      use gkernel_types
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Compute the Chunks Equivalence CLASSes, i.e. find all the families
      ! (each one defines a chunkset) with unique (PART,PIXEL,RECEIVER,
      ! POLAR). This is computed only once per backend table i.e. once per
      ! scan (=> low impact for the whole scan)
      !  See MRTCAL prog documentation for the choice of using PIXEL as
      ! part of the equivalence class definition.
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(inout) :: back   !
      logical,              intent(inout) :: error  !
    end subroutine imbfits_read_header_backend_ceclass
  end interface
  !
  interface
    subroutine imbfits_read_header_antslow_mjd_shift(antslow,mjd_shift,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Patch the MJD column for the given shift (positive or negative, but
      ! usually zero).
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(inout) :: antslow
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec]
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_header_antslow_mjd_shift
  end interface
  !
  interface
    subroutine imbfits_read_header_antfast(imbf,isub,antfast,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      ! Read the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf     !
      integer(kind=4),         intent(in)    :: isub     ! Subscan number
      type(imbfits_antfast_t), intent(inout) :: antfast  !
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_read_header_antfast
  end interface
  !
  interface
    subroutine imbfits_read_header_backdata(imbf,isub,goodonly,bd,error)
      use gbl_message
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the current IMBF-backendFOO HDU (header + table, except DATA
      ! column)
      !---------------------------------------------------------------------
      type(imbfits_t),          intent(in)    :: imbf      !
      integer(kind=4),          intent(in)    :: isub      ! Subscan number
      logical,                  intent(in)    :: goodonly  ! Ignore bad data?
      type(imbfits_backdata_t), intent(inout) :: bd        !
      logical,                  intent(inout) :: error     !
    end subroutine imbfits_read_header_backdata
  end interface
  !
  interface
    subroutine imbfits_compress_header_backdata(bd,goodonly,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(imbfits_backdata_t), intent(inout) :: bd        !
      logical,                  intent(in)    :: goodonly  ! Ignore bad data?
      logical,                  intent(inout) :: error     !
    end subroutine imbfits_compress_header_backdata
  end interface
  !
  interface
    subroutine imbfits_read_header_isodate2mjd(timesys,mjd_key,mjd,error)
      use gkernel_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fill a duplicate, memory only, of a ISO date string into a MJD
      ! value.
      !---------------------------------------------------------------------
      type(fits_char_0d_t), intent(in)    :: timesys  !
      character(len=*),     intent(in)    :: mjd_key  ! Key name
      type(fits_dble_0d_t), intent(inout) :: mjd      !
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine imbfits_read_header_isodate2mjd
  end interface
  !
  interface
    subroutine imbfits_read_header_fixsubscanrange(subs,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fix the subscan on-track range (DATE-OBS to DATE-END) so that it
      ! is set to the intersection with the actual MJD ranges in the tables
      ! of the subscan.
      !  Intersection with Antenna Fast is disconnected for now, as it
      ! appears that we are often missing several fast traces at the end.
      ! But we don't use those traces for now.
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_header_fixsubscanrange
  end interface
  !
  interface
    subroutine imbfits_free_header_primary(primary,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the Primary HDU in memory
      !---------------------------------------------------------------------
      type(imbfits_primary_t), intent(inout) :: primary
      logical,                 intent(inout) :: error
    end subroutine imbfits_free_header_primary
  end interface
  !
  interface
    subroutine imbfits_free_header_scan(scan,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the IMBF-scan HDU
      !---------------------------------------------------------------------
      type(imbfits_scan_t), intent(inout) :: scan
      logical,              intent(inout) :: error
    end subroutine imbfits_free_header_scan
  end interface
  !
  interface
    subroutine imbfits_free_header_frontend(front,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the IMBF-frontend HDU
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(inout) :: front
      logical,               intent(inout) :: error
    end subroutine imbfits_free_header_frontend
  end interface
  !
  interface
    subroutine imbfits_free_header_backend(back,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the IMBF-backend HDU
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(inout) :: back
      logical,              intent(inout) :: error
    end subroutine imbfits_free_header_backend
  end interface
  !
  interface
    subroutine imbfits_free_header_antfast(antfast,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_antfast_t), intent(inout) :: antfast  !
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_free_header_antfast
  end interface
  !
  interface
    subroutine imbfits_free_header_derot(derot,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Free the IMBF-xxx-derot HDU
      !---------------------------------------------------------------------
      type(imbfits_derot_t), intent(inout) :: derot  !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_free_header_derot
  end interface
  !
  interface
    subroutine imbfits_free_header_backdata(bd,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Free the IMBF-backendFOO HDU (header + table, except DATA
      ! column)
      !---------------------------------------------------------------------
      type(imbfits_backdata_t), intent(inout) :: bd     !
      logical,                  intent(inout) :: error  !
    end subroutine imbfits_free_header_backdata
  end interface
  !
  interface
    subroutine imbfits_filename_decode(ifilename,telescope,backcode,dobs,scan,error)
      use gbl_message
      use imbfits_parameters
      !---------------------------------------------------------------------
      ! @ private
      !  Decode:
      !  - telescope [code],
      !  - backend [code],
      !  - date [gag_date],
      !  - scan number
      ! from file name.
      !  Note that the date decoded from the file name is the SCAN date. It
      ! can differ from the OBSERVATION date (as found in the MJD in Primary
      ! header) by 1 if scan starts just before midnight and observation
      ! starts just after.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: ifilename  !
      integer(kind=4),  intent(out)   :: telescope  !
      integer(kind=4),  intent(out)   :: backcode   !
      integer(kind=4),  intent(out)   :: dobs       !
      integer(kind=4),  intent(out)   :: scan       !
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine imbfits_filename_decode
  end interface
  !
  interface
    subroutine imbfits_hdus(file,hdus,error)
      use gbl_message
      use imbfits_types
      use imbfits_key_types
      !---------------------------------------------------------------------
      ! @ private
      !  Set up the HDUs description which is used later on when we
      ! access the subscan HDUs.
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(in)    :: file
      type(imbfits_hdus_t), intent(out)   :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_hdus
  end interface
  !
  interface
    subroutine imbfits_hdus_preset_2_0(file,hdus,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Set up the HDUs description which is used later on when we access
      ! the subscan HDUs. The description is forced to the IMB-FITS V2.0
      ! (included) up to V2.2 (excluded)
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(in)    :: file
      type(imbfits_hdus_t), intent(out)   :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_hdus_preset_2_0
  end interface
  !
  interface
    subroutine imbfits_hdus_preset_2_21(file,nsub,hdus,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Set up the HDUs description which is used later on when we access
      ! the subscan HDUs. The description is forced to the IMB-FITS V2.21
      ! (included)
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(in)    :: file   !
      integer(kind=4),      intent(in)    :: nsub   ! Number of subscans in file
      type(imbfits_hdus_t), intent(out)   :: hdus   !
      logical,              intent(inout) :: error  !
    end subroutine imbfits_hdus_preset_2_21
  end interface
  !
  interface
    subroutine imbfits_hdus_autodetect(file,hdus,error)
      use imbfits_types
      use imbfits_key_types
      !---------------------------------------------------------------------
      ! @ private
      !  Analyse the (first) HDUs in the FITS file in order to guess:
      !   - the number of "leading" HDUs (i.e. the ones which are present
      !     only once at the beginning)
      !   - the number of HDUs per subscan
      !   - the order of the HDUs
      !  There is a slight cost because we open several HDUs.
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(in)    :: file
      type(imbfits_hdus_t), intent(out)   :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_hdus_autodetect
  end interface
  !
  interface
    subroutine imbfits_mvhdu_name(key,file,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Move to the ***first*** HDU with the given name
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: key
      type(imbfits_file_t), intent(in)    :: file
      logical,              intent(inout) :: error
    end subroutine imbfits_mvhdu_name
  end interface
  !
  interface
    subroutine imbfits_mvhdu_pos(ihdu,file,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Move to the HDU with the given absolute position
      !---------------------------------------------------------------------
      integer(kind=4),      intent(in)    :: ihdu
      type(imbfits_file_t), intent(in)    :: file
      logical,              intent(inout) :: error
    end subroutine imbfits_mvhdu_pos
  end interface
  !
  interface imbfits_compress_column
    subroutine imbfits_compress_inte_1d(inte,flag,nnew,buf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private-generic imbfits_compress_column
      ! Compress the column according to the flag array. Assume the column,
      ! the flag array, and the buffer have a consistent size.
      !---------------------------------------------------------------------
      type(fits_inte_1d_t), intent(inout) :: inte     !
      logical,              intent(in)    :: flag(:)  !
      integer(kind=4),      intent(in)    :: nnew     ! Number of .true. flag values
      integer(kind=4)                     :: buf(:)   ! Working buffer
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine imbfits_compress_inte_1d
    subroutine imbfits_compress_dble_1d(dble,flag,nnew,buf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private-generic imbfits_compress_column
      ! Compress the column according to the flag array. Assume the column,
      ! the flag array, and the buffer have a consistent size.
      !---------------------------------------------------------------------
      type(fits_dble_1d_t), intent(inout) :: dble     !
      logical,              intent(in)    :: flag(:)  !
      integer(kind=4),      intent(in)    :: nnew     ! Number of .true. flag values
      real(kind=8)                        :: buf(:)   ! Working buffer
      logical,              intent(inout) :: error    ! Logical error flag
    end subroutine imbfits_compress_dble_1d
  end interface imbfits_compress_column
  !
  interface imbfits_make_column
    subroutine imbfits_make_inte_1d(key,n,comment,inte,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private-generic imbfits_make_column
      ! Allocate and fill a column with continuous numbering.
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: key
      integer(kind=4),      intent(in)    :: n
      character(len=*),     intent(in)    :: comment
      type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_make_inte_1d
  end interface imbfits_make_column
  !
  interface imbfits_make_key
    subroutine imbfits_make_inte_0d(key,val,comment,inte,error)
      use gbl_message
      use imbfits_types
      !-------------------------------------------------------------------
      ! @ private-generic imbfits_make_key
      ! Create a key
      !-------------------------------------------------------------------
      character(len=*),     intent(in)    :: key
      integer(kind=4),      intent(in)    :: val
      character(len=*),     intent(in)    :: comment
      type(fits_inte_0d_t), intent(inout) :: inte
      logical,              intent(inout) :: error
    end subroutine imbfits_make_inte_0d
  end interface imbfits_make_key
  !
  interface
    subroutine imbfits_variable_file(struct,file,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_file_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: struct  ! Parent structure name
      type(imbfits_file_t), intent(in)    :: file    !
      logical,              intent(in)    :: ro      ! Read-Only
      logical,              intent(inout) :: error   !
    end subroutine imbfits_variable_file
  end interface
  !
  interface
    subroutine imbfits_variable_primary(struct,prim,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_primary_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: struct  ! Parent structure name
      type(imbfits_primary_t), intent(in)    :: prim    !
      logical,                 intent(in)    :: ro      ! Read-Only
      logical,                 intent(inout) :: error   !
    end subroutine imbfits_variable_primary
  end interface
  !
  interface
    subroutine imbfits_variable_scan(struct,scan,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_scan_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: struct  ! Parent structure name
      type(imbfits_scan_t), intent(in)    :: scan    !
      logical,              intent(in)    :: ro      ! Read-Only
      logical,              intent(inout) :: error   !
    end subroutine imbfits_variable_scan
  end interface
  !
  interface
    subroutine imbfits_variable_scan_header(struct,head,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_scan_header_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: struct  ! Parent structure name
      type(imbfits_scan_header_t), intent(in)    :: head    !
      logical,                     intent(in)    :: ro      ! Read-Only
      logical,                     intent(inout) :: error   !
    end subroutine imbfits_variable_scan_header
  end interface
  !
  interface
    subroutine imbfits_variable_scan_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_scan_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: struct  ! Parent structure name
      type(imbfits_scan_table_t), intent(in)    :: table   !
      logical,                    intent(in)    :: ro      ! Read-Only
      logical,                    intent(inout) :: error   !
    end subroutine imbfits_variable_scan_table
  end interface
  !
  interface
    subroutine imbfits_variable_front(struct,front,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_front_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),      intent(in)    :: struct  ! Parent structure name
      type(imbfits_front_t), intent(in)    :: front   !
      logical,               intent(in)    :: ro      ! Read-Only
      logical,               intent(inout) :: error   !
    end subroutine imbfits_variable_front
  end interface
  !
  interface
    subroutine imbfits_variable_front_header(struct,head,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_front_header_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),             intent(in)    :: struct  ! Parent structure name
      type(imbfits_front_header_t), intent(in)    :: head    !
      logical,                      intent(in)    :: ro      ! Read-Only
      logical,                      intent(inout) :: error   !
    end subroutine imbfits_variable_front_header
  end interface
  !
  interface
    subroutine imbfits_variable_front_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_front_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: struct  ! Parent structure name
      type(imbfits_front_table_t), intent(in)    :: table   !
      logical,                     intent(in)    :: ro      ! Read-Only
      logical,                     intent(inout) :: error   !
    end subroutine imbfits_variable_front_table
  end interface
  !
  interface
    subroutine imbfits_variable_back(struct,back,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_back_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: struct  ! Parent structure name
      type(imbfits_back_t), intent(in)    :: back    !
      logical,              intent(in)    :: ro      ! Read-Only
      logical,              intent(inout) :: error   !
    end subroutine imbfits_variable_back
  end interface
  !
  interface
    subroutine imbfits_variable_back_header(struct,head,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_back_header_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: struct  ! Parent structure name
      type(imbfits_back_header_t), intent(in)    :: head    !
      logical,                     intent(in)    :: ro      ! Read-Only
      logical,                     intent(inout) :: error   !
    end subroutine imbfits_variable_back_header
  end interface
  !
  interface
    subroutine imbfits_variable_back_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_back_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: struct  ! Parent structure name
      type(imbfits_back_table_t), intent(in)    :: table   !
      logical,                    intent(in)    :: ro      ! Read-Only
      logical,                    intent(inout) :: error   !
    end subroutine imbfits_variable_back_table
  end interface
  !
  interface
    subroutine imbfits_variable_antslow(struct,antslow,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_antslow_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: struct   ! Parent structure name
      type(imbfits_antslow_t), intent(in)    :: antslow  !
      logical,                 intent(in)    :: ro       ! Read-Only
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_variable_antslow
  end interface
  !
  interface
    subroutine imbfits_variable_antslow_header(struct,head,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_antslow_header_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),               intent(in)    :: struct  ! Parent structure name
      type(imbfits_antslow_header_t), intent(in)    :: head    !
      logical,                        intent(in)    :: ro      ! Read-Only
      logical,                        intent(inout) :: error   !
    end subroutine imbfits_variable_antslow_header
  end interface
  !
  interface
    subroutine imbfits_variable_antslow_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_antslow_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),              intent(in)    :: struct  ! Parent structure name
      type(imbfits_antslow_table_t), intent(in)    :: table   !
      logical,                       intent(in)    :: ro      ! Read-Only
      logical,                       intent(inout) :: error   !
    end subroutine imbfits_variable_antslow_table
  end interface
  !
  interface
    subroutine imbfits_variable_antfast(struct,antfast,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_antfast_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: struct   ! Parent structure name
      type(imbfits_antfast_t), intent(in)    :: antfast  !
      logical,                 intent(in)    :: ro       ! Read-Only
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_variable_antfast
  end interface
  !
  interface
    subroutine imbfits_variable_antfast_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_antfast_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),              intent(in)    :: struct  ! Parent structure name
      type(imbfits_antfast_table_t), intent(in)    :: table   !
      logical,                       intent(in)    :: ro      ! Read-Only
      logical,                       intent(inout) :: error   !
    end subroutine imbfits_variable_antfast_table
  end interface
  !
  interface
    subroutine imbfits_variable_derot(struct,derot,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_derot_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),      intent(in)    :: struct  ! Parent structure name
      type(imbfits_derot_t), intent(in)    :: derot   !
      logical,               intent(in)    :: ro      ! Read-Only
      logical,               intent(inout) :: error   !
    end subroutine imbfits_variable_derot
  end interface
  !
  interface
    subroutine imbfits_variable_derot_header(struct,head,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_derot_header_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),             intent(in)    :: struct  ! Parent structure name
      type(imbfits_derot_header_t), intent(in)    :: head    !
      logical,                      intent(in)    :: ro      ! Read-Only
      logical,                      intent(inout) :: error   !
    end subroutine imbfits_variable_derot_header
  end interface
  !
  interface
    subroutine imbfits_variable_derot_table(struct,table,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Create or recreate Sic variables mapping a imbfits_derot_table_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),            intent(in)    :: struct  ! Parent structure name
      type(imbfits_derot_table_t), intent(in)    :: table   !
      logical,                     intent(in)    :: ro      ! Read-Only
      logical,                     intent(inout) :: error   !
    end subroutine imbfits_variable_derot_table
  end interface
  !
end module imbfits_interfaces_private

program make_mosaic
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  !----------------------------------------------------------------------
  !   Make a mosaic cube from a set of original images.
  !
  ! The original images are assumed to have the same phase tracking center
  ! and hence the same map characterictics (pixel, size, coordinates)
  ! This program compute several images (rather n-D data sets) :
  !
  ! Ouput
  !   NX NY are the image sizes
  !   NC is the number of channels
  !   NF is the number of different frequencies
  !   NP is the number of pointing centers
  !
  ! 'NAME'.LMV  a 3-d cube containing the uniform noise
  !     combined mosaic, i.e. the sum of the product
  !     of the fields by the primary beam. (NX,NY,NC)
  ! 'NAME'.LOBE the primary beams pseudo-cube (NP,NX,NY,NB)
  ! 'NAME'.WEIGHT the sum of the square of the primary beams (NX,NY,NB)
  ! 'NAME'.BEAM a 4-d cube where each cube contains the synthesised
  !     beam for one field (NX,NY,NP,NB)
  !
  ! All images have the same X,Y sizes
  !
  ! It is assumed that the names of the original field images follow
  ! the simple sequence 'NAME'-'I'.LMV
  !----------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: version = 'Version 3.0 23-July-2015'
  character(len=*), parameter :: pname = 'MAKE_MOSAIC'
  integer :: np
  real :: bsize,bmin
  character(len=80) :: generic
  logical :: error
  !
  call gag_message(seve%i,pname,version)
  !
  call gildas_open
  call gildas_inte('FIELDS$',np,1)
  call gildas_char('NAME$',generic)
  call gildas_real('BEAM$',bsize,1)
  call gildas_real('BMIN$',bmin,1)
  call gildas_close
  !
  ! Do all the work in a subroutine...
  call sub_mosaic (trim(generic),np,bsize,bmin,error)
  if (error) call sysexi(fatale)
  call gag_message(seve%i,pname,'Successful completion')
  !
end program make_mosaic
!
subroutine sub_mosaic(generic,np,bsize_rest,bmin,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use mapping_primary
  !
  ! Build a Mosaic from an ensemble of NF initial Images
  ! with a name following the convention name-'i' i=1,nf
  !
  character(len=*), intent(in) :: generic  ! Generic name
  integer, intent(in) :: np                ! Number of pointings
  real, intent(in) :: bsize_rest           ! Primary beam size (Radian)
  real, intent(in) :: bmin                 ! Truncation level
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'MAKE_MOSAIC'
  type(gildas) :: field
  type(gildas) :: beam
  type(gildas) :: lobe
  type(gildas) :: mosaic
  type(gildas) :: tmp
  type(gildas) :: weight
  !
  real, allocatable :: dbeam(:,:,:,:) ! Dirty and Primary beam arrays
  real, allocatable :: dmosaic(:,:,:) ! Mosaic
  real, allocatable :: dprim(:,:)     ! Current primary beam
  real, allocatable :: dtmp(:,:)      ! Temporary work space
  real, allocatable :: dweight(:,:,:) ! Final weight image
  !
  character(len=filename_length) :: name
  integer :: nx,ny,nc,nb,nn,ier
  integer :: ip,ib,ic, fc,lc
  real :: thre, rmin, rmax, bsize
  real(8) :: beam_freq
  integer(kind=size_length) :: nelem, imin, imax
  character(len=64) :: chain
  !
  call gildas_null(field)
  call gildas_null(beam)
  call gildas_null(lobe)
  call gildas_null(mosaic)
  call gildas_null(weight)
  call gildas_null(tmp)
  !
  error = .false.
  nn = len_trim(generic)
  !
  name = generic
  name(nn+1:) = '-1'
  call sic_parsef (name,field%file,' ','.lmv')
  call gdf_read_header(field,error)
  if (error) then
    call gag_message(seve%e,rname,'Cannot open '//trim(field%file))
    return
  endif
  nx = field%gil%dim(1)
  ny = field%gil%dim(2)
  nc = field%gil%dim(3)
  !
  ! Test the dirty beam properties
  name = generic
  name(nn+1:) = '-1'
  call sic_parsef (name,beam%file,' ','.beam')
  call gdf_read_header(beam,error)
  if (error) then
    call gag_message(seve%e,rname,'Cannot open '//trim(beam%file))
    return
  endif
  if (nx.ne.beam%gil%dim(1) .or. ny.ne.beam%gil%dim(2)) then
    write(6,*) 'F-'//rname//',  Beam and Dirty do not match'
    return
  endif
  nb = beam%gil%dim(3)    ! Number of different beams per field
  !
  ! First pass: Produce the .BEAM Dirty Beam 4-D data set
  name = generic
  call sic_parsef (name,beam%file,' ','.beam')
  beam%gil%ndim = 4
  ! Push frequency dimension
  beam%char%code(4) = beam%char%code(3)
  beam%gil%dim(4) = nb
  beam%gil%convert(:,4) = beam%gil%convert(:,3)
  beam%gil%faxi = 4
  !
  ! Fill projection information from fields
  beam%gil%proj_words = def_proj_words
  beam%char%code(1) = 'RA'
  beam%char%code(2) = 'DEC'
  beam%gil%ptyp = field%gil%ptyp
  beam%gil%pang = field%gil%pang ! Defined in table.
  beam%gil%a0 = field%gil%a0
  beam%gil%d0 = field%gil%d0
  !
  ! Fill Field dimension
  beam%char%code(3) = 'FIELD-ID'
  beam%gil%dim(3) = np
  beam%gil%convert(:,3) = 1.d0
  beam%gil%extr_words = 0
  !
  allocate (dbeam(nx,ny,np,nb),dtmp(nx,ny),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error DBEAM')
    error = .true.
    return
  endif
  !
  ! Loop over individual synthesized beams
  call gdf_copy_header(field,tmp,error)
  do ip=1,np
    name = generic
    call append_number(name,ip)
    call sic_parsef (name,tmp%file,' ','.beam')
    call gdf_read_header (tmp,error)
    if (error) then
      call gag_message(seve%f,rname,'Cannot open '//trim(tmp%file))
      return
    endif
    if (tmp%gil%dim(1).ne.nx .or. tmp%gil%dim(2).ne.ny) then
      write(chain,'(A,I4,I6,I6)') 'Inconsistent size, field  ',ip,tmp%gil%dim(1:2)
      call gag_message(seve%f,rname,chain)
      error = .true.
      return
    endif
    do ib=1,nb
      tmp%blc(3) = ib
      tmp%trc(3) = ib
      call gdf_read_data(tmp,dtmp,error)
      dbeam(:,:,ip,ib) = dtmp(:,:)
    enddo
    call gdf_close_image(tmp,error) ! Free image after use
  enddo
  call gdf_write_image(beam,dbeam,error)
  deallocate(dbeam,stat=ier) ! Need a different shape later, so just free it
  if (error) then
    call gag_message(seve%f,rname,'Cannot open '//trim(beam%file))
    return
  endif
  !
  ! Create the primary beams  -- This is a transposed cube (NP,NX,NY,NB)
  call gdf_transpose_header(beam,lobe,'3124',error)
  if (error)  return
  name = generic
  call sic_parsef (name,lobe%file,' ','.lobe')
  !
  lobe%gil%inc(1) = bmin                ! Valeur conventionnelle
  lobe%gil%inc(5) = bsize               ! necessaire pour MRC_MOSAIC.
  allocate (dbeam(np,nx,ny,nb),dmosaic(nx,ny,nc),dprim(nx,ny), &
    & dweight(nx,ny,nb),stat=ier)  !
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error DMOSAIC & DBEAM')
    error = .true.
    return
  endif
  !
  ! Create the .LMV cube
  call gdf_copy_header(field,mosaic,error)
  !
  ! loop over the various fields.
  name = generic(1:nn)
  call sic_parsef (name,mosaic%file,' ','.lmv')
  mosaic%gil%ra = mosaic%gil%a0
  mosaic%gil%dec  = mosaic%gil%d0
  !
  dmosaic = 0
  !
  do ip=1,np
    name = generic
    call append_number(name,ip)
    call sic_parsef (name,field%file,' ','.lmv')
    call gdf_read_header (field,error)
    if (error) then
      call gag_message(seve%f,rname,'Cannot open '//trim(field%file))
      return
    endif
    !
    ! Here, loop over the NB beams at different frequencies
    do ib=1,nb
      !
      ! Figure out the frequency and corresponding Primary Beam size
      beam_freq = (ib-beam%gil%ref(4))*beam%gil%fres + beam%gil%freq
      bsize = bsize_rest * beam%gil%freq / beam_freq
      !
      ! Figure out the first and last channels in the data array
      if (nb.eq.1) then
        fc = 1
        lc = nc
      else if (beam%gil%freq.gt.0) then
        !
        if (field%gil%fres.gt.0) then
          fc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) fc = 1
          if (ib.eq.nb) lc = nc
        else
          fc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) lc = nc
          if (ib.eq.nb) fc = 1
        endif
      else
        !
        if (field%gil%fres.gt.0) then
          fc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.nb) fc = 1
          if (ib.eq.1) lc = nc
        else
          fc = int((beam_freq-beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) + 1d0)
          lc = int((beam_freq+beam%gil%fres*0.5d0-field%gil%freq)/field%gil%fres + field%gil%ref(3) )
          if (ib.eq.1) fc = 1
          if (ib.eq.nb) lc = nc
        endif
      endif
      !
      ! Compute the non truncated primary beam
      call mos_primary (field,dprim,bsize)
      dbeam(ip,:,:,ib) = dprim  ! Fill the primary beam array
      !
      ! But a truncated primary beam is used
      where (dprim.lt.bmin) dprim = 0
      !
      ! Make it Plane by Plane to save Memory
      ! A more efficient implementation would use a Blocking Factor
      do ic=fc,lc
        field%blc(3) = ic
        field%trc(3) = ic
        call gdf_read_data (field, dtmp, error)
        dmosaic(:,:,ic) = dmosaic(:,:,ic) + dtmp*dprim  ! Apply the primary beam
      enddo
    enddo
    !
    call gdf_close_image (field,error) ! Free field image after use
  enddo
  !
  ! Write the primary beams
  call gdf_write_image (lobe,dbeam,error)
  if (error) then
    call gag_message(seve%f,rname,'Cannot create '//trim(lobe%file))
    return
  endif
  !
  ! Compute the extrema of the Mosaic and write it
  nelem = nx*ny*nc
  call gr4_extrema (nelem,dmosaic,mosaic%gil%bval,mosaic%gil%eval,   &
                    rmin,rmax,imin,imax)
  call t_setextrema(mosaic,rmin,imin,rmax,imax)
  call gdf_write_image(mosaic,dmosaic,error)
  if (error) then
    call gag_message(seve%f,rname,'Cannot open '//trim(mosaic%file))
    return
  endif
  !
  ! Now the .WEIGHT file
  call gdf_copy_header(mosaic,weight,error)
  weight%gil%ndim = 3
  weight%gil%dim(3) = beam%gil%dim(4)
  weight%gil%convert(:,3) = beam%gil%convert(:,4)
  weight%gil%fres = beam%gil%fres
  weight%gil%freq = beam%gil%freq
  !
  name = generic(1:nn)
  call sic_parsef(name,weight%file,' ','.weight')
  !
  ! Use DTMP as temporary space
  thre = bmin**2
  do ib=1,nb
    dtmp = 0.0
    do ip=1,np
      dtmp(:,:) = dtmp + dbeam(ip,:,:,ib)**2
    enddo
    where (dtmp.ge.thre)
      dweight(:,:,ib) = 1.0/dtmp
    else where
      dweight(:,:,ib) = 0.0
    end where
  enddo
  !
  nelem = nx*ny*nb
  call gr4_extrema (nelem,dweight,weight%gil%bval,weight%gil%eval,   &
                    rmin,rmax,imin,imax)
  weight%gil%bval = 0
  weight%gil%eval = 0
  call t_setextrema(weight,rmin,imin,rmax,imax)
  call gdf_write_image(weight,dweight,error)
  !
  if (error) then
    call gag_message(seve%f,rname,'Cannot create '//trim(weight%file))
    return
  endif
end subroutine sub_mosaic

subroutine append_number(name,if)
  character(len=*), intent(inout) :: name
  integer, intent(in) :: if
  !
  character(len=12) :: rchain, lchain
  integer :: nn
  !
  nn = len_trim(name)
  !
  write(rchain,'(I12)') if
  lchain = adjustl(rchain)
  !
  name(nn+1:) = '-'//lchain
end subroutine append_number

subroutine cubspl (n,tau,c1,c2,c3,c4,ibcbeg,ibcend,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC Internal routine
  !
  !	Piecewise cubic spline interpolants computation; adapted from
  !	'A practical guide to SPLINES' , CARL DE BOOR ,
  !	Applied Mathematical Sciences, SPRINGER-VERLAG, VOL.27, P57-59 (1978).
  !
  ! Arguments :
  !     	N	I	Number of data points. assumed to be .ge. 2.	Input
  !	TAU	R*4(N)	Abscissae of data points, strictly monotonous	Input
  !	C1	R*4(N)	Ordinates of data points			Input
  !     	IBCBEG	I							Input
  !	IBCEND  I	Boundary condition indicators, and		Input
  !	C1	R*4(N)	First polynomial coefficient of spline	Output
  !	C2	R*4(N)	Second   --         --           --	Output/Input
  !	C3	R*4(N)	Third    --         --           --	Output
  !	C4	R*4(N)	Fourth   --         --           --	Output
  !
  ! 	C2(1), C2(N)  are boundary condition information.
  !	Specifically,
  !	IBCBEG = 0  means no boundary condition at tau(1) is given.
  !		In this case, the not-a-knot condition is used, i.e. the
  !		jump in the third derivative across TAU(2) is forced to
  !		zero, thus the first and the second cubic polynomial pieces
  !		are made to coincide.
  !        IBCBEG = 1 means that the slope at TAU(1) is made to equal
  !		C2(1), supplied by input.
  !        IBCBEG = 2 means that the second derivative at TAU(1) is
  !		made to equal C2(1), supplied by input.
  !        IBCEND = 0, 1, or 2 has analogous meaning concerning the
  !		boundary condition at TAU(N), with the additional
  !		information taken from C2(N).
  !
  !	CJ(I), J=1,...,4; I=1,...,L (= N-1) are the polynomial
  !	coefficients of the cubic interpolating spline. Precisely,
  !	in the interval    [ TAU(I), TAU(I+1) ]    the spline F
  !	is given by
  !		F(X) = C1(I)+H*(C2(I)+H*(C3(I)+H*C4(I)/3.)/2.)
  !	where H = X - TAU(I).
  !
  !	In other words, for I=1,...,N, C2(I) and C3(I) are respectively
  !	equal to the values of the first and second derivatives of
  !	the interpolating spline, and C4(I) is equal to the third
  !	derivative of the interpolating spline in the interval
  !	[ TAU(I), TAU(I+1) ]. C4(N) is meaningless and is set to 0.
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: tau(n)                    !
  real :: c1(n)                     !
  real :: c2(n)                     !
  real :: c3(n)                     !
  real :: c4(n)                     !
  integer :: ibcbeg                 !
  integer :: ibcend                 !
  logical :: error                  !
  ! Local
  real :: taum1,g,dtau,divdf1,divdf3
  integer :: i,j,l,m
  !
  ! A tridiagonal linear system for the unknown slopes S(I) of
  ! F at TAU(I), I=1,...,N, is generated and then solved by gauss
  ! elimination, with S(I) ending up in C2(I), all I.
  ! C3(.) and C4(.) are used initially for temporary storage.
  !
  ! Check if N.GE.2
  !
  if (n.lt.2) stop 'F-CUBSPL4,  Less than two pivots'
  !
  ! Check if TAU strictly monotonous
  taum1=tau(2)
  if (tau(2)-tau(1)) 101,102,103
101 if (n.eq.2) goto 200
  do 1 i=3,n
    if ((tau(i)-taum1).ge.0.) goto 102
1 taum1=tau(i)
  goto 200
102 call gagout ('E-CUBSPL4,  Variable is not strictly monotonous')
  error = .true.
  return
103 if (n.eq.2) goto 200
  do 3 i=3,n
    if ((tau(i)-taum1).le.0.) goto 102
3 taum1=tau(i)
  !
200 l = n-1
  !
  ! Compute first differences of TAU sequence and store in C3(.).
  ! Also, compute first divided difference of data and store in C4(.).
  !
  do 10 m=2,n
    c3(m) = tau(m) - tau(m-1)
10 c4(m) = (c1(m) - c1(m-1))/c3(m)
  !
  ! Construct first equation from the boundary condition, of the form
  !             C4(1)*S(1) + C3(1)*S(2) = C2(1)
  !
  if (ibcbeg-1)                     11,15,16
11 if (n .gt. 2)                     goto 12
  !
  ! No condition at left end and N = 2.
  c4(1) = 1.
  c3(1) = 1.
  c2(1) = 2.*c4(2)
  goto 25
  !
  ! Not-a-knot condition at left end and N .GT. 2.
12 c4(1) = c3(3)
  c3(1) = c3(2) + c3(3)
  c2(1) = ((c3(2)+2.*c3(1))*c4(2)*c3(3)+c3(2)**2*c4(3))/c3(1)
  goto 19
  !
  ! Slope prescribed at left end.
15 c4(1) = 1.
  c3(1) = 0.
  goto 18
  !
  ! Second derivative prescribed at left end.
16 c4(1) = 2.
  c3(1) = 1.
  c2(1) = 3.*c4(2) - c3(2)/2.*c2(1)
18 if (n .eq. 2)                      goto 25
  !
  ! If there are interior knots, generate the corresponding equations and
  ! carry out the forward pass of gauss elimination, after which the M-th
  ! equation reads    C4(M)*S(M) + C3(M)*S(M+1) = C2(M).
  !
19 do 20 m=2,l
    g = -c3(m+1)/c4(m-1)
    c2(m) = g*c2(m-1) + 3.*(c3(m)*c4(m+1)+c3(m+1)*c4(m))
20 c4(m) = g*c3(m-1) + 2.*(c3(m) + c3(m+1))
  !
  ! Construct last equation from the second boundary condition, of the form
  !           (-G*C4(N-1))*S(N-1) + C4(N)*S(N) = C2(N)
  ! If slope is prescribed at right end, one can go directly to back
  ! substitution, since C array happens to be set up just right for it
  ! at this point.
  !
  if (ibcend-1)                     21,30,24
21 if (n .eq. 3 .and. ibcbeg .eq. 0) goto 22
  !
  ! not-a-knot and N.GE.3, and either N.GT.3 or also not-a-knot at
  ! left endpoint.
  !
  g = c3(l) + c3(n)
  c2(n) = ((c3(n)+2.*g)*c4(n)*c3(l)   &
    + c3(n)**2*(c1(l)-c1(n-2))/c3(l))/g
  g = -g/c4(l)
  c4(n) = c3(l)
  goto 29
  !
  ! Either (N=3 and not-a-knot also at left) or (N=2 and not not-a-knot
  ! at left endpoint).
  !
22 c2(n) = 2.*c4(n)
  c4(n) = 1.
  goto 28
  !
  ! Second derivative prescribed at right endpoint.
24 c2(n) = 3.*c4(n) + c3(n)/2.*c2(n)
  c4(n) = 2.
  goto 28
25 if (ibcend-1)                     26,30,24
26 if (ibcbeg .gt. 0)                goto 22
  !
  ! not-a-knot at right endpoint and at left endpoint and N=2.
  c2(n) = c4(n)
  goto 30
28 g = -1./c4(l)
  !
  ! Complete forward pass of GAUSS elimination.
29 c4(n) = g*c3(l) + c4(n)
  c2(n) = (g*c2(l) + c2(n))/c4(n)
  !
  ! Carry out back substitution
30 do 40 j=l,1,-1
40 c2(j) = (c2(j) - c3(j)*c2(j+1))/c4(j)
  !
  ! Generate cubic coefficients in each interval, i.e., the derivatives
  ! at its left endpoint, from value and slope at its endpoints.
  !
  do 50 i=2,n
    dtau = c3(i)
    divdf1 = (c1(i) - c1(i-1))/dtau
    divdf3 = c2(i-1) + c2(i) - 2.*divdf1
    c3(i-1) = 2.*(divdf1 - c2(i-1) - divdf3)/dtau
50 c4(i-1) = (divdf3/dtau)*(6./dtau)
  !
  ! Compute in addition C3(N). set C4(N) to 0.
  c3(n) = c3(l) + c4(l)*dtau
  c4(n) = 0.
end subroutine cubspl
!
subroutine cubint (n,x,y,cm,ci)
  !---------------------------------------------------------------------
  ! Calculates the array of integrals required in SPLIF and SPLIFK
  !
  !     N      Number of data points (N is assumed .GE. 2).
  !     (X(I), Y(I), I=1,...,N) abcissae and ordinates of the points
  !            (X is assumed to be strictly increasing or decreasing).
  !     CM(I)  array of values of the second derivative of the spline-
  !            function at abscissae (X(I), I=1,...,N).
  !     CI(I)  array of the integrals of the cubic spline interpolation
  !            function from X(1) TO X(I).
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: ci(n)                     !
  ! Local
  integer :: i
  real :: e
  !
  ci(1)=0.d0
  do  9 i=2,n
    e=x(i)-x(i-1)
    ci(i) = ci(i-1) +   &
      ( -e**2*(cm(i)+cm(i-1))/12.d0 + (y(i)+y(i-1)) ) *e/2.d0
9 continue
  return
end subroutine cubint
!
subroutine cuberr (n,x,y,ycub,err,iw,nw)
  !---------------------------------------------------------------------
  !       Crude estimate of spline-interpolation errors
  !       N       :number of pivots
  !       X       :array of pivots
  !       Y       :array of values of the function
  !       YCUB    :array of spline second-derivatives
  !       ERR     :output array for error estimates
  !       ( ERR(K): error in the interval [X(K-1)...X(K)] for K=3...N-1,
  !         ERR(1), ERR(2) and ERR(N) are set to 0.)
  !       IW      :printing device. set iw=0 to cancel the print.
  !                the estimated interpolation errors are listed for
  !                the worst intervals.
  !       NW      :approximate number of errors printed.
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: ycub(n)                   !
  real :: err(n)                    !
  integer :: iw                     !
  integer :: nw                     !
  ! Global
  real :: splf
  ! Local
  real :: xkm1,xk,fmi,em1,ep1,barre,sup,f,xmi
  integer :: k,i,nbar
  !
  ! Formula definition
  f(k)=splf(n,x,y,ycub,xmi,k)
  !
  err(1)=0.d0
  err(2)=0.d0
  if (n.lt.3) return
  err(n)=0.d0
  if (n.eq.3) return
  xkm1=x(2)
  do 20 k=3,n-1
    xk=x(k)
    xmi=(xkm1+xk)/2.d0
    fmi=f(k)
    em1=abs(fmi-f(k-1))
    ep1=abs(fmi-f(k+1))
    if (k.eq.3.or.k.eq.(n-1)) goto 11
    goto 12
11  err(k)=max(em1,ep1)
    goto 20
12  err(k)=min(em1,ep1)
    xkm1=xk
20 continue
  !
  if (iw.le.0) return
  !
  barre=0.d0
  if (nw.gt.n-4) goto 59
  sup=0.d0
  do 30 i=3,n-1
    sup=max(sup,err(i))
30 continue
  barre=sup
  if (nw.le.1) goto 59
  do 50 nbar=1,nw-1
    sup=0.d0
    do 40 i=3,n-1
      if (err(i).lt.barre) sup=max(sup,err(i))
40  continue
    barre=sup
    if (barre.eq.0.d0) goto 59
50 continue
  !
59 do 60 i=2,n
    if (err(i).lt.barre) goto 60
    write(iw,101) x(i-1),x(i),err(i)
101 format(' [',e15.6,' ,',e15.6,' ]',e18.6)
60 continue
  return
end subroutine cuberr
!
function kspl (n,x,t,k)
  !---------------------------------------------------------------------
  !     The integer function KSPL returns the index KSPL such that the
  !     argument T lies within the interval [X(KSPL-1)...X(KSPL].
  !     In case of extrapolation, KSPL is forced to the value 2 or N.
  !
  !     N      number of data points (N is assumed .GE. 2).
  !     (X(I), I=1,...,N) abcissae of the points
  !            (X is assumed to be strictly increasing or decreasing).
  !     T      Argument for which the spline function is to be determined.
  !     K      Initial guess for KSPL.
  !---------------------------------------------------------------------
  integer :: kspl                   !
  integer :: n                      !
  real :: x(n)                      !
  real :: t                         !
  integer :: k                      !
  !
  kspl = k
  if (kspl.lt.2) kspl=2
  if (kspl.gt.n) kspl=n
  if (x(2).lt.x(1)) go to 100
  ! Case increasing
  if (t.le.x(kspl)) go to 11
10 if (kspl.eq.n) goto 20
  kspl=kspl+1
  if (t.gt.x(kspl)) go to 10
  go to 20
11 if (kspl.eq.2) goto 20
  if (t.ge.x(kspl-1)) go to 20
  kspl=kspl-1
  go to 11
  ! Case decreasing
100 if (t.ge.x(kspl)) go to 111
110 if (kspl.eq.n) goto 20
  kspl=kspl+1
  if (t.lt.x(kspl)) go to 110
  go to 20
111 if (kspl.eq.2) goto 20
  if (t.le.x(kspl-1)) go to 20
  kspl=kspl-1
  go to 111
20 return
end function kspl
!
function splf (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     *** Calculation of a cubic spline interpolation function. ***
  !     SPLF computes the value of a cubic polynomial piece within an
  !     interval given the abscissae, ordinates and second derivatives
  !     of the piece at both ends.
  !
  !     N      number of data points (N is assumed .ge. 2).
  !     (X(I), Y(I), I=1,...,N) abcissae and ordinates of the points
  !            (X is assumed to be strictly increasing or decreasing).
  !     CM(I)  array of values of the second derivative of the spline-
  !            function at abscissae (X(I), I=1,...,N).
  !     T      argument for which the spline function is to be determined.
  !     K      the user-supplied index K selects the cubic piece
  !            associated with the interval [X(K-1), X(K)]. K is assumed
  !            to be .GE. 2 and .LE. N.  The spline interpolation is
  !            obtained when T lies in this interval.
  !---------------------------------------------------------------------
  real :: splf                      !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Local
  real :: f,g,e
  !
  f = x(k) - t
  g = t - x(k-1)
  e = f + g
  splf = (-g*f*(cm(k-1)*(f+e)+cm(k)*(g+e))+6.d0*(g*y(k)+f*y(k-1)))   &
    / (6.d0*e)
  return
end function splf
!
function splf1 (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     Calculation of the first derivative of a cubic spline function.
  !     Arguments are the same as for SPLF.
  !---------------------------------------------------------------------
  real :: splf1                     !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Local
  real :: f,g,e,e2,e6
  !
  f = x(k) - t
  g = t - x(k-1)
  e = f + g
  e2= e+e
  e6= e/6.d0
  splf1=-cm(k-1)*(f**2/e2-e6)+cm(k)*(g**2/e2-e6)+(y(k)-y(k-1))/e
  return
end function splf1
!
function splf2 (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     Calculation of the second derivative of a cubic spline function.
  !     Arguments are the same as for SPLF.
  !---------------------------------------------------------------------
  real :: splf2                     !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Local
  real :: e,f,g
  !
  f = x(k) - t
  g = t - x(k-1)
  e = f + g
  splf2 = (cm(k-1)*f + cm(k)*g) / e
  return
end function splf2
!
function splfi (n,x,y,cm,ci,t,k)
  !---------------------------------------------------------------------
  !     *** calculates the integral of a cubic spline interpolation
  !         function from X(1) to X(T).
  !
  !     *** N,X,Y,CM,T,K are the same as in SPLF.
  !     *** CI(I): array of integrals of the spline function from X(1)
  !                to X(I). The array CI can be computed with CUBINT.
  !---------------------------------------------------------------------
  real :: splfi                     !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: ci(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Local
  real :: e,f,g,f2,g2,e2
  !
  f=x(k)-t
  g=t-x(k-1)
  e=f+g
  f2=f**2
  g2=g**2
  e2=2.d0*e**2
  splfi = ci(k-1) + (y(k-1)-e2*cm(k-1)/24.d0)*e/2.d0 +   &
    ( -f2*(cm(k-1)*(f2-e2)+12.d0*y(k-1))   &
    +g2*(cm(k)*(g2-e2)+12.d0*y(k))   ) / (24.d0*e)
  return
end function splfi
!
function splfk (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     *** Calculation of a cubic spline interpolation function. ***
  !     SPLFK computes the value of a cubic polynomial piece within an
  !     interval given the abscissae, ordinates and second derivatives
  !     of the piece at both ends.
  !
  !     *** The arguments are the same as those of SPLF, excepted for K.
  !     *** K:  computed as K=KSPL(N,X,T,K)
  !---------------------------------------------------------------------
  real :: splfk                     !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Global
  integer :: kspl
  real :: splf
  k     = kspl (n,x,t,k)
  splfk = splf (n,x,y,cm,t,k)
  return
end function splfk
!
function splf1k (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     Calculation of the first derivative of a cubic spline function.
  !     *** The arguments are the same as those of SPLF1, excepted for K.
  !     *** K:  computed as K=KSPL(N,X,T,K)
  !---------------------------------------------------------------------
  real :: splf1k                    !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Global
  integer :: kspl
  real :: splf1
  k      = kspl (n,x,t,k)
  splf1k = splf1 (n,x,y,cm,t,k)
  return
end function splf1k
!
function splf2k (n,x,y,cm,t,k)
  !---------------------------------------------------------------------
  !     Calculation of the second derivative of a cubic spline function.
  !     *** The arguments are the same as those of SPLF2, excepted for K.
  !     *** K:  computed as K=KSPL(N,X,T,K)
  !---------------------------------------------------------------------
  real :: splf2k                    !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Global
  integer :: kspl
  real :: splf2
  k      = kspl (n,x,t,k)
  splf2k = splf2 (n,x,y,cm,t,k)
  return
end function splf2k
!
function splfik (n,x,y,cm,ci,t,k)
  !---------------------------------------------------------------------
  !     Calculation of the integral of a cubic spline function.
  !     *** The arguments are the same as those of SPLFI, excepted for K.
  !     *** K:  computed as K=KSPL(N,X,T,K)
  !---------------------------------------------------------------------
  real :: splfik                    !
  integer :: n                      !
  real :: x(n)                      !
  real :: y(n)                      !
  real :: cm(n)                     !
  real :: ci(n)                     !
  real :: t                         !
  integer :: k                      !
  ! Global
  integer :: kspl
  real :: splfi
  k      = kspl (n,x,t,k)
  splfik = splfi (n,x,y,cm,ci,t,k)
  return
end function splfik

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_fullcube_types
  use cubetools_parameters
  use cubetools_array_types
  use cubetuple_format_class
  use cubeadm_messaging
  !
  public :: fullcube_t
  private
  !
  type, extends(real_3d_t) :: fullcube_t
     class(format_t), pointer :: cube => null() ! Associated cube
   contains
     procedure, public  :: allocate  => cubeadm_fullcube_allocate
     procedure, public  :: associate => cubeadm_fullcube_associate
     procedure, private :: prepare   => cubeadm_fullcube_prepare
     procedure, public  :: get       => cubeadm_fullcube_get
     procedure, public  :: put       => cubeadm_fullcube_put
  end type fullcube_t
  !
contains
  !
  subroutine cubeadm_fullcube_allocate(fullcube,name,cube,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube_t), intent(out)   :: fullcube
    character(len=*),  intent(in)    :: name
    class(format_t),   intent(in)    :: cube
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE>ALLOCATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call fullcube%prepare(name,cube,error)
    if (error)  return
    call fullcube%reallocate(name,&
         cube%tuple%current%desc%n1,&
         cube%tuple%current%desc%n2,&
         ! *** JP
         cube%tuple%current%desc%n3,&
         ! *** JP
         error)
    if (error) return
  end subroutine cubeadm_fullcube_allocate
  !
  subroutine cubeadm_fullcube_associate(fullcube,name,cube,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube_t), intent(out)   :: fullcube
    character(len=*),  intent(in)    :: name
    class(format_t),   intent(in)    :: cube
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE>ASSOCIATE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call fullcube%prepare(name,cube,error)
    if (error)  return
    call fullcube%prepare_association(name,&
         cube%tuple%current%desc%n1,&
         cube%tuple%current%desc%n2,&
         ! *** JP
         cube%tuple%current%desc%n3,&
         ! *** JP
         error)
    if (error) return
  end subroutine cubeadm_fullcube_associate
  !
  subroutine cubeadm_fullcube_prepare(fullcube,name,cube,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(fullcube_t),       intent(out)   :: fullcube
    character(len=*),        intent(in)    :: name
    class(format_t), target, intent(in)    :: cube
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='FULLCUBE>PREPARE'
    !
    if (cube%iscplx()) then
       call cubeadm_message(seve%e,rname,  &
            'Invalid attempt to get a R*4 fullcube from a C*4 cube')
       error = .true.
       return
    endif
    !
    fullcube%cube => cube
  end subroutine cubeadm_fullcube_prepare
  !
  !------------------------------------------------------------------------
  !
  subroutine cubeadm_fullcube_get(fullcube,error)
    use cube_types
    use cubeio_subcube
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Get the fullcube from the given cube.
    ! When fullcube%val is an allocated pointer, we make a copy.
    ! In all other cases (associated or null), we make it point to the
    ! data.
    !---------------------------------------------------------------------
    class(fullcube_t), intent(inout) :: fullcube
    logical,           intent(inout) :: error
    ! 
    type(cubeio_subcube_t) :: entry
    integer(kind=indx_k) :: iz
    integer(kind=indx_k), parameter :: one=1
    character(len=*), parameter :: rname='FULLCUBE>GET'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    fullcube%nx = fullcube%cube%tuple%current%desc%n1
    fullcube%ny = fullcube%cube%tuple%current%desc%n2
    fullcube%nz = fullcube%cube%tuple%current%desc%n3
    !
    call cubetuple_get_subcube(fullcube%cube%user,fullcube%cube%prog,&
         fullcube%cube,one,fullcube%nz,entry,error)
    if (error) return
    !
    if (fullcube%pointeris.eq.code_pointer_allocated) then
       do iz=1,fullcube%nz
          fullcube%val(:,:,iz) = entry%r4(:,:,iz)
       enddo ! iz
    else
       fullcube%val => entry%r4
       fullcube%pointeris = code_pointer_associated
    endif
    fullcube%nx = entry%n1
    fullcube%ny = entry%n2
    fullcube%nz = entry%n3
    !
    call entry%free(error)
    if (error) return
  end subroutine cubeadm_fullcube_get
  !
  subroutine cubeadm_fullcube_put(fullcube,error)
    use cubeadm_ioloop
    use cubeio_subcube
    use cubetuple_entry
    !---------------------------------------------------------------------
    ! Put the fullcube to the cube
    ! Only use pointers => Nothing to free
    !---------------------------------------------------------------------
    class(fullcube_t), intent(in)    :: fullcube
    logical,           intent(inout) :: error
    !
    type(cubeio_subcube_t) :: entry
    integer(kind=indx_k), parameter :: one=1
    character(len=*), parameter :: rname='FULLCUBE>PUT'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    entry%allocated = code_pointer_associated
    entry%n1 = fullcube%nx
    entry%n2 = fullcube%ny
    entry%n3 = fullcube%nz
    entry%r4 => fullcube%val
    entry%iscplx = .false.
    !
    call cubetuple_put_subcube(&
         fullcube%cube%user,&
         fullcube%cube%prog,&
         fullcube%cube,&
         one,&
         one,fullcube%nz,&
         entry,&
         error)
    if (error) return
  end subroutine cubeadm_fullcube_put
end module cubeadm_fullcube_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gtx_pen(output,ipen,userpens)
  use gbl_message
  use gtv_interfaces, except_this=>gtx_pen
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Set the color to be used by the forthcoming segments (lines,
  ! polygons, but not images).
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output    ! Output instance
  integer(kind=4),  intent(in)    :: ipen      !
  type(gt_lut),     intent(in)    :: userpens  ! Set of user pens (PEN /LUT)
  ! Local
  character(len=*), parameter :: rname='PEN'
  integer(kind=4) :: r,g,b
  logical :: do_neg
  !
  ! Resolve ipen to RGB:
  call gtv_pencol_id2rgb(output,userpens,ipen,r,g,b,do_neg)
  !
  select case(output%dev%protocol)
  case (p_null)
    continue
  case (p_x)
    if (do_neg) then
      call x_pen_invert(output%x%graph_env)
    else
      call x_pen_rgb(output%x%graph_env,r,g,b)
    endif
  case (p_postscript)
    call ps_pen_rgb(r,g,b)
  case (p_svg)
    call svg_pen_rgb(r,g,b)
  case (p_png)
    if (do_neg) then
      call png_pen_negative(output)
    else
      call png_pen_rgb(output,r,g,b)
    endif
  case default
    call gtv_message(seve%e,rname,'Internal error: unknown protocol')
  end select
  !
end subroutine gtx_pen
!
subroutine gtv_pencol_id2rgb(output,userpens,ipen,r,g,b,do_neg)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_pencol_id2rgb
  use gtv_colors
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Convert a pen identifier (number) into RGB values (range [0:255]).
  ! Be careful this can be context dependent (e.g. foreground/background
  ! colors).
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: output    ! Output instance
  type(gt_lut),     intent(in)  :: userpens  ! Set of user pens (PEN /LUT)
  integer(kind=4),  intent(in)  :: ipen      !
  integer(kind=4),  intent(out) :: r,g,b     !
  logical,          intent(out) :: do_neg    !
  ! Local
  character(len=*), parameter :: rname='PEN'
  integer(kind=4) :: jpen
  !
  ! In case of error:
  r = 0
  g = 0
  b = 0
  !
  do_neg = ipen.eq.pen_color_negative
  if (do_neg) then
    ! Prepare a foreground pen for devices which do not support negative
    ! colors
    jpen = pen_color_foreground
  else
    jpen = ipen
  endif
  !
  if (jpen.eq.pen_color_background) then
    if (output%background.eq.0) then  ! Black
      jpen = pen_color_black
    else
      jpen = pen_color_white
    endif
  elseif (jpen.eq.pen_color_foreground) then
    if (output%background.eq.0) then  ! Black
      jpen = pen_color_white
    else
      jpen = pen_color_black
    endif
  endif
  !
  if (jpen.gt.0) then
    ! A standard RGB color
    r = X11_rgb(1,jpen)
    g = X11_rgb(2,jpen)
    b = X11_rgb(3,jpen)
    if (.not.output%color) then
      ! User requests a Grey output. Convert the color intensities to grey,
      ! see comments in 'rgb_to_grey'
      r = nint( rgb_to_grey(real(r,kind=4),real(g,kind=4),real(b,kind=4)) )
      g = r
      b = r
    endif
    !
  elseif (jpen.le.-8 .and. jpen.ge.-23) then
    ! A user custom color
    jpen = abs(jpen)-7  ! Rescale user color from 1 to 16
    if (output%color) then
      ! Color hardcopy
      r = int(userpens%r(jpen)*255.)
      g = int(userpens%g(jpen)*255.)
      b = int(userpens%b(jpen)*255.)
    elseif (output%background.eq.0) then
      ! Grey hardcopy, black background
      ! First user color = white, last user color = black
      r = nint( (jpen-1)*255./(pen_size-1) )
      g = r
      b = r
    else
      ! Grey hardcopy, white background
      ! First user color = black, last user color = white
      r = nint( (pen_size-jpen)*255./(pen_size-1) )
      g = r
      b = r
    endif
  else
    call gtv_message(seve%e,rname,'Incorrect colour value')
    return
  endif
  !
end subroutine gtv_pencol_id2rgb
!
subroutine gtv_pencol_arg2id(rname,line,iopt,iarg,icol,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_pencol_arg2id
  use gtv_colors
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the a color argument and return the GTV internal identifier
  ! for this color. Input can be:
  !  - A color name, e.g. RED, BLUE, FOREST_GREEN,...
  !  - A Greg color number (1=RED, ..., 23=user custom color)
  !  - An integer variable providing a Greg color number
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iopt
  integer(kind=4),  intent(in)    :: iarg
  integer(kind=4),  intent(out)   :: icol
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: nc,ic,icolor
  character(len=32) :: argum
  !
  call sic_ke(line,iopt,iarg,argum,nc,.true.,error)
  if (error)  return
  !
  ! A question mark
  if (argum.eq.'?') then
    call sic_ambigs_list(rname,seve%i,'Choices are:',pen_colors)
    error = .true.  ! So that the command does not go further
    return
  endif
  !
  ! Numbers (PEN /COL 0), formula (PEN /COL j*3),...
  do ic=1,nc
    if (lge(argum(ic:ic),'A') .and. lle(argum(ic:ic),'Z'))  cycle  ! A letter
    if (argum(ic:ic).eq.'_')                                cycle  ! Underscore
    !
    ! Found a character which is not whic we can find in the
    ! pen color names. Must be something with numerics and/or
    ! formula:
    call sic_i4(line,iopt,iarg,icolor,.true.,error)
    if (error)  return
    call gtv_pencol_num2id(rname,icolor,icol,error)
    if (error)  return
    return
  enddo
  !
  ! A variable name
  if (sic_varexist(argum)) then
    call sic_i4(line,iopt,iarg,icolor,.true.,error)
    if (error)  return
    call gtv_pencol_num2id(rname,icolor,icol,error)
    if (error)  return
    return
  endif
  !
  ! A color name
  call gtv_pencol_name2id(rname,argum,icol,error)
  if (error)  return
  !
end subroutine gtv_pencol_arg2id
!
subroutine gtv_pencol_name2id(rname,colname,icol,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_pencol_name2id
  use gtv_colors
  !---------------------------------------------------------------------
  ! @ public
  ! Return the color identifier given its name. Input must be
  ! uppercased. A full name is not ambiguous. Error if not found.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  character(len=*), intent(in)    :: colname
  integer(kind=4),  intent(out)   :: icol
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: jcol
  character(len=colname_length) :: key
  !
  ! Try first exact match
  do jcol=1,pen_ncolors
    if (colname.eq.pen_colors(jcol)) then
      icol = jcol
      return
    endif
  enddo
  !
  ! Try with sic_ambigs
  icol = pen_color_foreground  ! Just for safety
  call sic_ambigs(rname,colname,key,icol,pen_colors,pen_ncolors,error)
  if (error)  return
  !
end subroutine gtv_pencol_name2id
!
subroutine gtv_pencol_num2id(rname,colnum,colid,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_pencol_num2id
  !---------------------------------------------------------------------
  ! @ public
  !  Translate Greg color number [-1:23] to GTV color identifier
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  integer(kind=4),  intent(in)    :: colnum
  integer(kind=4),  intent(out)   :: colid
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4), parameter :: mincolor=-1
  integer(kind=4), parameter :: maxcolor=7
  integer(kind=4), parameter :: minuser=8
  integer(kind=4), parameter :: maxuser=23
  ! Order matters here:
  character(len=10), parameter :: colours(mincolor:maxcolor) =  &
    (/ 'NEGATIVE  ','FOREGROUND','RED       ','GREEN     ','BLUE      ',  &
       'CYAN      ','YELLOW    ','MAGENTA   ','BACKGROUND' /)
  !
  if (colnum.ge.mincolor .and. colnum.le.maxcolor) then
    ! A standard color
    call gtv_pencol_name2id(rname,colours(colnum),colid,error)
    if (error)  return
    !
  elseif (colnum.ge.minuser .and. colnum.le.maxuser) then
    ! User color: store value <0 so that GTV knows it has to use
    ! a user color
    colid = -colnum
    !
  else
    call gtv_message(seve%e,rname,'Color number out of range')
    error = .true.
    return
  endif
  !
end subroutine gtv_pencol_num2id
!
function gtv_pencol_id2name(icol)
  use gtv_colors
  !---------------------------------------------------------------------
  ! @ public
  ! Return the color name given its identifier. No error, returns ???
  ! if not found.
  !---------------------------------------------------------------------
  character(len=colname_length) :: gtv_pencol_id2name  ! Function value on return
  integer(kind=4), intent(in) :: icol
  !
  if (icol.ge.1 .and. icol.le.pen_ncolors) then
    ! Standard colors
    gtv_pencol_id2name = pen_colors(icol)
    !
  elseif (icol.le.-8 .and. icol.ge.-23) then
    ! User color
    write(gtv_pencol_id2name,'(A,I0)')  'User ',abs(icol)
  else
    ! Unknown
    gtv_pencol_id2name = '???'
  endif
  !
end function gtv_pencol_id2name
!
subroutine gtv_pendash_arg2id(rname,line,iopt,iarg,idash,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_pendash_arg2id
  use gtv_segatt
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the dash argument and return the corresponding code
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iopt
  integer(kind=4),  intent(in)    :: iarg
  integer(kind=4),  intent(out)   :: idash
  logical,          intent(inout) :: error
  ! Local
  character(len=message_length) :: mess
  !
  call sic_i4(line,iopt,iarg,idash,.true.,error)
  if (error) return
  !
  if (idash.lt.min_dash .or. idash.gt.max_dash) then
    write(mess,'(3(a,i0))')  &
      'Dash argument ',idash,' out of range ',min_dash,':',max_dash
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
end subroutine gtv_pendash_arg2id
!
subroutine gtv_penwei_arg2val(rname,line,iopt,iarg,wei,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtv_penwei_arg2val
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the weight argument and return the width (cm) for this
  ! weight. Input can be:
  !  - A Greg weight number (1 to 5 according to 'graisse()' predefined
  !    weights) and possible formulas or variable
  !  - A value of the form "1.23mm" (mm are used for user interface)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iopt
  integer(kind=4),  intent(in)    :: iarg
  real(kind=4),     intent(out)   :: wei
  logical,          intent(inout) :: error
  ! Local
  integer(kind=4) :: nc,iwei
  character(len=32) :: argum
  !
  call sic_ch(line,iopt,iarg,argum,nc,.true.,error)
  if (error)  return
  !
  if (nc.gt.2 .and. argum(nc-1:nc).eq.'mm') then
    call sic_math_real(argum(1:nc-2),nc-2,wei,error)
    if (error)  return
    if (wei.le.0.) then
      call gtv_message(seve%e,rname,'Weight value must be positive')
      error = .true.
      return
    endif
    wei = wei/10.0  ! mm to cm
  else
    call sic_i4(line,iopt,iarg,iwei,.true.,error)
    if (error)  return
    call gtv_penwei_num2val(rname,iwei,wei,error)
    if (error)  return
  endif
  !
end subroutine gtv_penwei_arg2val
!
subroutine gtv_penwei_num2val(rname,iwei,wei,error)
  use gbl_message
  use gtv_interfaces, except_this=>gtv_penwei_num2val
  use gtv_segatt
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the Greg weight number as the actual width (cm)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  integer(kind=4),  intent(in)    :: iwei
  real(kind=4),     intent(out)   :: wei
  logical,          intent(inout) :: error
  ! Local
  character(len=message_length) :: mess
  !
  if (iwei.lt.min_weight .or. iwei.gt.max_weight) then
    write(mess,'(A,I0,A,2I2)')  &
      'Weight code ',iwei,' out of range',min_weight,max_weight
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  wei = graisse(iwei)
  !
end subroutine gtv_penwei_num2val
!
function gtv_penwei_tostr(wei)
  use gtv_segatt
  !---------------------------------------------------------------------
  ! @ public
  !  Convert the input weight value (cm) to a user friendly output (mm),
  ! e.g.
  !   "1 0.15mm" for predefined weights, or
  !   "  1.23mm" for custom weights
  !---------------------------------------------------------------------
  character(len=8) :: gtv_penwei_tostr  ! Function value on return
  real(kind=4), intent(in) :: wei  ! [cm]
  ! Local
  integer(kind=4) :: iw
  !
  if (wei.le.0.0) then
    gtv_penwei_tostr = '???'
    return
  endif
  !
  do iw=min_weight,max_weight
    if (wei.eq.graisse(iw)) then
      write(gtv_penwei_tostr,'(I1,1X,F4.2,A2)')  iw,wei*10.0,'mm'
      return
    endif
  enddo
  !
  ! Not a predefined weight
  write(gtv_penwei_tostr,'(2X,F4.2,A2)')  wei*10.0,'mm'
  !
end function gtv_penwei_tostr

!
subroutine getfits(filename,tmpbackend,stepcompress,   &
     cryoextension,derotextension,trackingcutoff,   &
     currentindex,firstifb,ncf,nfb,subscanRange,nosky,error)
!
! Reads the imbfits file (version < 2.0) into MIRA's data structures (define in
! mira_use.f90). Called by subroutine getmira. See "MIRA\help get" for possible options.
!
   !
   use mira
   use gbl_constant
   use cfitsio_status
   use telcal_interfaces
   use fit_definitions
   use pcross_definitions
   use focus_definitions
   !
   implicit none
   !
   integer            :: firstifb, ncf, nfb
   character(len=200) :: filename
   logical            :: error, keep
   integer            :: blocksize, currentindex, hdutype, i,           &
                         ibd, icol, idcol, idump, idump1, idump2,       &
                         idump3, idump4, ier, ifb, iobs, istart,        &
                         iend, j, jfb, j1, j2, k, l, lastifb,           &
                         mxchan, nbd, nchan, nxchan, ndump,             &
                         ndumpantenna, ndumpantennanew,                 &
                         ndumpantennafast, ndumpantennafastnew,         &
                         ndumpcryo, ndumpderot, nhdu, noffset, nrecords,&
                         nrecnew, ndumpfrontend, ndumpsubref, nphases,  &
                         npix, readwrite=0, status=0, tracerate, unit
   integer            :: idcol_mjd, idcol_integtim, idcol_iswitch,      &
                         idcol_data
   integer, dimension(2) :: subscanRange
   !
   real               :: nullval
   real*4             :: aux, median
   real*8             :: dumptime,stepcompress,trackingcutoff
   !
   !
   character(len=1)   :: nullstr
   character(len=6)   :: subscanstring, string
   character(len=8)   :: keystring, offsetstring
   character(len=8)   :: backend, focustranslationdirection, specsys
   character(len=20)  :: backendextension, tmpformat, dataformat,   &
                         frontend, swtchmod
   character(len=23)  :: tmpbackend
   character(len=20)  :: tmpscantype, tmpswitchmode
   character(len=23)  :: subscantime
   character(len=80)  :: comment
   logical            :: anynull, readonly
   !
   !
   integer, dimension(:), allocatable         :: intdata
   real, dimension(:), allocatable            :: realdata
   real*8, dimension(:), allocatable          :: doubledata
   integer, dimension(:), allocatable         :: subscantrace,   &
                                                 traceflag,   &
                                                 tmptraceflag
   real*8                                     :: fmax,fmin,   &
                                                 focusoffset,f1,f2,   &
                                                 substime,velosys,   &
                                                 posanghera
   logical, dimension(1)                      :: flagscalar
   logical, dimension(:), allocatable         :: flagvals,   &
                                                 traceflagdefined
   !
   type myslowdap
      integer :: subscan
      integer :: traceflag
      real*8  :: mjd
      real*8  :: lst
      real*8  :: longoff
      real*8  :: latoff
      real*8  :: baslong
      real*8  :: baslat
      real*8  :: parangle
   end type myslowdap
   !
   type myfastdap
      integer :: subscanfast
      real*8, dimension(3) :: encoder_az_el
      real*8, dimension(2) :: tracking_az_el
   end type myfastdap
   !
   type(myslowdap), dimension(:), allocatable :: slowdap
   type(myfastdap), dimension(:), allocatable :: fastdap
   !
   type(arraydata_data)                                      :: artmp
   !
   integer                                      :: allchannels,   &
                                                   nrowbackendtable
   integer                                      :: ipix,ichan,iph,   &
                                                   irow, i1, i2, i3,   &
                                                   i4, i5, i6, m,   &
                                                   nbin, ncfe,pswitch
   integer                                      :: idxantenna,   &
                                                   idxstart,   &
                                                   idxsubref,   &
                                                   idxcryo,   &
                                                   idxderot,   &
                                                   idxbackend, next
   integer, dimension(:), allocatable           :: refchan, chans,   &
                                                   dropped, used,   &
                                                   band, baseband,   &
                                                   pixel, tmpsubscan
   logical                                      :: cryoextension,   &
                                                   derotextension,   &
                                                   nosky
   logical, dimension(:), allocatable           :: bandmask,   &
                                                   compressmask,   &
                                                   foundfebe
   integer, dimension(:,:), allocatable         :: iddump
   real                                         :: imbftsve
   real*8                                       :: pmjd, pintegtim
   real, dimension(:), allocatable              :: reffreq, spacing
   character(len=12), dimension(:), allocatable :: rec1, rec2
   character(len=20), dimension(:), allocatable :: sysoff
   !
   integer                                      :: bandsave, k1, k2
   integer                                      :: nrowfrontendtable
   integer, dimension(:), allocatable           :: indx, nfeeds,   &
                                                   part, irank
   real, dimension(:), allocatable              :: beameff,etafss,   &
                                                   gainimag,tcold,   &
                                                   ifcenter,   &
                                                   frqoff1,frqoff2,   &
                                                   frqthrow
   real*8, dimension(:), allocatable            :: fx,restfreq,   &
                                                   sbsep,tcoldmon,   &
                                                   tmpfocus
   real*8                                       :: pcoldimage,   &
                                                   pcoldsignal,   &
                                                   photimage,   &
                                                   photsignal,   &
                                                   pcoldimagenew,   &
                                                   pcoldsignalnew,   &
                                                   photimagenew,   &
                                                   photsignalnew
   real*8                                       :: tmpcalib
   real*8                                       :: trec, gainimage,   &
                                                   pcoldimagemean,   &
                                                   photimagemean
   character(len=3), dimension(:), allocatable  :: sideband
   character(len=6), dimension(:), allocatable  :: widenar
   character(len=20)                            :: tmpfrontend
   character(len=20), dimension(:), allocatable :: recname, linename
   character(len=32)                            :: message
   !
   ! local variables related to polarimetry
   !
   integer                                              :: nspec
   integer, dimension(:), allocatable                   :: ifbold
   real*8                                               :: ccimag
   real*8                                               :: ccreal
   character(len=1), dimension(4), parameter            :: stokes =   &
                                                           (/'H','V','R','I'/)
   character(len=4), dimension(:), allocatable          :: polar
   character(len=10), dimension(:),allocatable          :: poltype
   character(len=12), dimension(:), allocatable         :: rec3
   logical                                              :: polmode
   logical, dimension(:,:), allocatable                 :: mask
   logical, dimension(:), allocatable                   :: calmask
   type(flag), dimension(:), allocatable                :: reducetmp
   type(febepar), dimension(:), pointer                 :: febetmp   &
                                                           => null()
   type(arraydata), dimension(:), pointer               :: arraytmp   &
                                                           => null()
   type(datapar), dimension(:), pointer                 :: datatmp   &
                                                           => null()
   type(monitor), dimension(:), pointer                 :: montmp   &
                                                           => null()
   type(calibration), dimension(:), pointer             :: gainstmp   &
                                                           => null()
   type(imbfitsantenna), dimension(:), allocatable      :: antennatmp
   type(imbfitsbackend), dimension(:), allocatable      :: backendtmp
   type(imbfitssubreflector), dimension(:), allocatable :: subreftmp
   !
   !
   error = .false.
   !
   if (firstifb.eq.1) then
      !
      if (associated(scan)) call freescan(scan%data,error)
      if (associated(sc%data%longoff)) call freescan(sc%data,error)
      !
      if (allocated(fb)) then
         do ifb = 1, size(fb)
            call freefebe(fb(ifb)%data,error)
         enddo
         deallocate(fb, stat = ier)
      endif
      !
      if (allocated(databuf)) then
         do ifb = 1, size(databuf)
            call freedata(databuf(ifb)%data,error)
         enddo
         deallocate(databuf,stat=ier)
      endif
      !
      if (allocated(arraybuf)) then
         do ifb = 1, size(array)
            do ibd = 1, size(arraybuf(ifb)%header)
               call freearray(arraybuf(ifb)%data(ibd),error)
            enddo
            deallocate(arraybuf(ifb)%header,   &
              arraybuf(ifb)%data,stat =ier)
         enddo
         deallocate(arraybuf,stat=ier)
      endif
      !
      if (allocated(monbuf)) then
         do ifb = 1, size(monbuf)
            call freemon(monbuf(ifb)%data,error)
         enddo
         deallocate(monbuf,stat=ier)
      endif
      !
      if (allocated(reduce)) deallocate(reduce,stat = ier)
      if (associated(cryo))    call freecryo(cryo,error)
      if (associated(crx%mjd)) call freecryo(crx, error)
      if (associated(derot))   call freederot(derot,error)
      if (associated(drt%mjd)) call freederot(drt,error)
      !
      if (allocated(raw)) then
         do i = 1, size(raw)
            call freeraw(raw(i), error)
         enddo
         deallocate(raw, stat = ier)
      endif
      !
      if (allocated(antdata%encoder_az_el))   &
        deallocate(antdata%encoder_az_el,stat=ier)
      if (allocated(antdata%tracking_az_el))   &
        deallocate(antdata%tracking_az_el,stat=ier)
      if (allocated(antdata%slowtrace))   &
        deallocate(antdata%slowtrace,stat=ier)
   !
   endif
   !
   call ftgiou(unit,status)
   call ftopen(unit,filename,readwrite,blocksize,status)
   !
   if (status.ne.0) then
      call gagout('E-GET: Open fits file error.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   !
   call ftmahd(unit,1,hdutype,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkys(unit,'IMBFTSVE',pr%header%mbftsver,comment,status)
   read(pr%header%mbftsver,'(f3.1)') imbftsve
   if (imbftsve.ge.2.0) then
      call ftclos(unit,status)
      call ftfiou(-1,status)
!      call gagout('E-GET: wrong IMBFITS format.')
      status = 0
      error = .true.
      return
   endif
   call ftgkyj(unit,'NAXIS   ',pr%header%naxis,comment,status)
   call ftgkyl(unit,'SIMPLE  ',pr%header%simple,comment,status)
   call ftgkyj(unit,'BITPIX  ',pr%header%bitpix,comment,status)
   call ftgkyl(unit,'EXTEND  ',pr%header%extend,comment,status)
   call ftgkys(unit,'TELESCOP',pr%header%telescop,comment,status)
   sc%header%telescop = pr%header%telescop
   call ftgkys(unit,'ORIGIN  ',pr%header%origin,comment,status)
   call ftgkys(unit,'CREATOR ',pr%header%creator,comment,status)
   call ftgkys(unit,'DATE-OBS',sc%header%date_obs,comment,status)
   call ftgkyj(unit,'N_OBSP  ',sc%header%nobs,comment,status)
   !
   if (imbftsve.ge.1.2) then
      idxstart = 4
   else
      idxstart = 3
   endif
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   call ftgkyd(unit,'SITELONG',sc%header%sitelong,comment,status)
   call ftgkyd(unit,'SITELAT ',sc%header%sitelat,comment,status)
   call ftgkye(unit,'SITEELEV',sc%header%siteelev,comment,status)
   call ftgkys(unit,'OBSID   ',sc%header%obsid,comment,status)
   call ftgkys(unit,'PROJID  ',sc%header%projid,comment,status)
   call ftgkyj(unit,'SCANNUM ',sc%header%scannum,comment,status)
   call ftgkys(unit,'OBJECT  ',sc%header%object,comment,status)
   call ftgkyd(unit,'MJD     ',sc%header%mjd,comment,status)
   call ftgkyd(unit,'LST     ',sc%header%lst,comment,status)
!  call ftgkyj(unit,'N_OBS   ',sc%header%nobs,comment,status)
!  commented out by H.W.
   call ftgkyj(unit,'NFEBE   ',sc%header%nfebe,comment,status)
   sc%header%nfebe = ncf
   sc%header%taiutc = 32d0     ! will change in future due to leap seconds
   call ftgkyd(unit,'ETUTC   ',sc%header%etutc,comment,status)
   ! sc%header%scanlen, sc%header%scanskew still to be checked in
   sc%header%scanline = sc%header%nobs
   !
   if (subscanRange(1).eq.0.and.subscanRange(2).eq.0) then
     nsubscan = sc%header%nobs
     subscanRange(1) = 1
     subscanRange(2) = nsubscan
   else if (subscanRange(2).lt.subscanRange(1).or. &
 &          subscanRange(1).le.0.or.subscanRange(2).le.0.or. &
 &          subscanRange(2).gt.sc%header%nobs) then
     call gagout('W-GET: invalid subscan range. Reading all subscans.')
     nsubscan = sc%header%nobs
     subscanRange(1) = 1
     subscanRange(2) = nsubscan
   else
     nsubscan = subscanRange(2)-subscanRange(1)+1
   endif
   !
   call ftthdu(unit,nhdu,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   if ((nhdu-idxstart)/nsubscan.lt.3) then
      call gagout('E-GET: input file ')
      call gagout('       '//trim(filename))
      call gagout('       is incomplete.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   !
   !
   if (firstifb.eq.1) then
      allocate(raw(nsubscan),stat=ier)
      do i = 1, nsubscan
         allocate(   &
           raw(i)%antenna(nfb),   &
           raw(i)%backend(nfb),   &
           raw(i)%subref(nfb),   &
           stat=ier)
      enddo
   endif
   !
   call ftgkys(unit,'CTYPE1  ',sc%header%ctype1,comment,status)
   call ftgkys(unit,'CTYPE2  ',sc%header%ctype2,comment,status)
   call ftgkys(unit,'RADESYS ',sc%header%radecsys,comment,status)
   call ftgkye(unit,'EQUINOX ',sc%header%equinox,comment,status)
!! nochmals
!!   sc%header%ctype1 = 'RA-SFL'
!!   sc%header%ctype2 = 'DEC-SFL'
   call ftgkyd(unit,'CRVAL1  ',sc%header%crval1,comment,status)
   call ftgkyd(unit,'CRVAL2  ',sc%header%crval2,comment,status)
   call ftgkyd(unit,'LONPOLE ',sc%header%lonpole,comment,status)
   call ftgkyd(unit,'LATPOLE ',sc%header%latpole,comment,status)
   call ftgkyd(unit,'LONGOBJ ',sc%header%longobj,comment,status)
   call ftgkyd(unit,'LATOBJ  ',sc%header%latobj,comment,status)
   !
   noffset = 0
   status = 0
   if (imbftsve.ge.1.2) then
      call ftgkyj(unit,'NOSWITCH',nphases,comment,status)
      call ftgkys(unit,'SWTCHMOD',swtchmod,comment,status)
      call ftgkyj(unit,'NAXIS2',noffset,comment,status)
      if (noffset.ne.0) then
         if (allocated(flagvals)) deallocate(flagvals)
         allocate(flagvals(noffset),stat=ier)
         allocate(sc%data%longoff(noffset),stat=ier)
         allocate(sc%data%latoff(noffset),stat=ier)
         allocate(sysoff(noffset),stat=ier)
         call ftgcno(unit,.false.,'SYSOFF',idcol,status)
         call ftgcvs(unit,idcol,1,1,noffset,nullstr,sysoff,anynull,   &
           status)
         call ftgcno(unit,.false.,'XOFFSET',idcol,status)
         call ftgcfd(unit,idcol,1,1,noffset,sc%data%longoff,flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'YOFFSET',idcol,status)
         call ftgcfd(unit,idcol,1,1,noffset,sc%data%latoff,flagvals,   &
           anynull,status)
         sc%data%longoff = sc%data%longoff*rad2deg
         sc%data%latoff = sc%data%latoff*rad2deg
         deallocate(flagvals)
      endif
   else
      do i = 1, nmxoff
         write(offsetstring,'(A7,I1)') 'XOFFSET', i
         call ftgkey(unit,trim(offsetstring),keystring,comment,   &
           status)
         if (len_trim(keystring).ne.1.and.status.eq.0) then
            noffset = noffset+1
         else
            status = 0
         endif
      enddo
      if (noffset.ne.0) then
         allocate(sc%data%longoff(noffset),stat=ier)
         allocate(sc%data%latoff(noffset),stat=ier)
         allocate(sysoff(noffset),stat=ier)
         do i = 1, noffset
            write(offsetstring,'(A7,I1)') 'XOFFSET', i
            call ftgkyd(unit,trim(offsetstring),sc%data%longoff(i),   &
              comment,status)
            offsetstring(1:1) = 'Y'
            call ftgkyd(unit,trim(offsetstring),sc%data%latoff(i),   &
              comment,status)
            write(offsetstring,'(A6,I1)') 'SYSOFF', i
            call ftgkys(unit,trim(offsetstring),sysoff(i),comment,   &
              status)
            call sic_upper(sysoff(i))
         enddo
         sc%data%longoff = sc%data%longoff*rad2deg
         sc%data%latoff = sc%data%latoff*rad2deg
      endif
   endif
   status = 0
   !
   !      call ftgkyl(unit,'MOVEFRAM',sc%header%movefram,comment,status)
   !      call ftgkyl(unit,'WOBUSED ',sc%header%wobused,comment,status)
   call ftgkyd(unit,'WOBTHROW',sc%header%wobthrow,comment,status)
   call ftgkye(unit,'WOBCYCLE',sc%header%wobcycle,comment,status)
   call ftgkys(unit,'WOBDIR  ',sc%header%wobdir,comment,status)
   call ftgkye(unit,'P1      ',sc%header%ia,comment,status)
   call ftgkye(unit,'P2      ',sc%header%ca,comment,status)
   call ftgkye(unit,'P7      ',sc%header%ie,comment,status)
   if (firstifb.eq.1) then
      allocate(mnt(nfb),stat=ier)
   endif
   call ftgkyd(unit,'P1COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(1),comment,status)
   call ftgkyd(unit,'P2COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(2),comment,status)
   call ftgkyd(unit,'P7COR   ',   &
     mnt(firstifb)%header%iaobs_caobs_ieobs(3),comment,status)
   mnt(firstifb)%header%iaobs_caobs_ieobs(1:3)   &
     = mnt(firstifb)%header%iaobs_caobs_ieobs(1:3)*rad2deg
   call ftgkyd(unit,'FOCUSX  ',mnt(firstifb)%header%focobs_x_y_z(1),   &
     comment,status)
   call ftgkyd(unit,'FOCUSY  ',mnt(firstifb)%header%focobs_x_y_z(2),   &
     comment,status)
   call ftgkyd(unit,'FOCUSZ  ',mnt(firstifb)%header%focobs_x_y_z(3),   &
     comment,status)
   !
   ! need here sc%header%ia, sc%header%ca, sc%header%npae, sc%header%aw,
   ! sc%header%an, sc%header%ie, sc%header%ecec, sc%header%zflx,
   ! sc%header%scandir
   !
   !
   if (firstifb.eq.1) then
      allocate(sc%data%febe(nfb),stat=ier)
      allocate(fb(nfb),stat=ier)
      allocate(ar(nfb),stat=ier)
      allocate(dt(nfb),stat=ier)
      allocate(reduce(nfb),stat=ier)
   endif
   !
   lastifb = firstifb+sc%header%nfebe-1
   if (lastifb.eq.nfb) sc%header%nfebe = nfb
   !
   if (imbftsve.ge.1.2) then
      call ftmnhd(unit,hdutype,'IMBF-backend',0,status)
   else
      call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   endif
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'NAXIS2',nrowbackendtable,comment,status)
   if (nrowbackendtable.eq.0.and.tmpbackend.ne."ABBA") then
      call gagout('E-GET: imbFits scan table is empty.')
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   else if (tmpbackend.eq."ABBA") then
      goto 11
   endif
   allocate(   &
     refchan(nrowbackendtable),chans(nrowbackendtable),   &
     dropped(nrowbackendtable),used(nrowbackendtable),   &
     band(nrowbackendtable),baseband(nrowbackendtable),   &
     pixel(nrowbackendtable),   &
     rec1(nrowbackendtable),rec2(nrowbackendtable),   &
     rec3(nrowbackendtable),   &
     polar(nrowbackendtable),reffreq(nrowbackendtable),   &
     spacing(nrowbackendtable),bandmask(nrowbackendtable),   &
     stat=ier   &
     )
   do i = 1, nrowbackendtable
      rec1(i) = '            '
      rec2(i) = '            '
      rec3(i) = '            '
   enddo
   call ftgcno(unit,.false.,'REFCHAN',idcol,status)
   if (allocated(flagvals)) deallocate(flagvals)
   allocate(flagvals(nrowbackendtable),stat=ier)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,refchan,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'CHANS',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,chans,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'DROPPED',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,dropped,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'USED',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,used,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'BAND',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,band,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'PIXEL',idcol,status)
   call ftgcfj(unit,idcol,1,1,nrowbackendtable,pixel,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'REC1',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,rec1,anynull,   &
     status)
   call ftgcno(unit,.false.,'REC2',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,rec2,anynull,   &
     status)
   polmode = count(rec1.ne.rec2).ne.0   &
     .and.index(tmpbackend,'VESPA').ne.0
   if (polmode) then
      do i = 1, nrowbackendtable
         if (index(rec1(i),'A').ne.0.and.index(rec2(i),'B').ne.0)   &
           then
            rec3(i) = rec1(i)//rec2(i)
         else if (index(rec2(i),'A').ne.0.and.index(rec1(i),'B')   &
           .ne.0) then
            rec3(i) = rec2(i)//rec1(i)
         else if (index(rec1(i),'C').ne.0.and.index(rec2(i),'D')   &
           .ne.0) then
            rec3(i) = rec1(i)//rec2(i)
         else if (index(rec2(i),'C').ne.0.and.index(rec1(i),'D')   &
           .ne.0) then
            rec3(i) = rec2(i)//rec1(i)
         else if (rec1(i).eq.rec2(i)) then
            rec3(i) = rec1(i)//rec2(i)
         endif
      enddo
   endif
   call ftgcno(unit,.false.,'POLAR',idcol,status)
   call ftgcvs(unit,idcol,1,1,nrowbackendtable,nullstr,polar,anynull,   &
     status)
   call ftgcno(unit,.false.,'REFFREQ',idcol,status)
   call ftgcfe(unit,idcol,1,1,nrowbackendtable,reffreq,flagvals,   &
     anynull,status)
   call ftgcno(unit,.false.,'SPACING',idcol,status)
   call ftgcfe(unit,idcol,1,1,nrowbackendtable,spacing,flagvals,   &
     anynull,status)
   !
   if (polmode) then
      do i = 2, nrowbackendtable
         do k = 1, i-1
            if (band(i).eq.band(k).and.(rec3(i).ne.rec3(k).or.   &
              polar(i).ne.polar(k))) then
               bandsave = band(i)
               band(i) = maxval(band)+1
               do j = i+1, nrowbackendtable
                  if (rec3(j).eq.rec3(i).and.polar(j).eq.polar(i)   &
                    .and.band(j).eq.bandsave)   &
                    band(j) = band(i)
               enddo
            endif
         enddo
      enddo
   else
      do i = 2, nrowbackendtable
         do k = 1, i-1
            if (band(i).eq.band(k).and.rec1(i).ne.rec1(k)) then
               bandsave = band(i)
               band(i) = maxval(band)+1
               do j = i+1, nrowbackendtable
                  if (rec1(j).eq.rec1(i).and.band(j).eq.bandsave)   &
                    band(j) = band(i)
               enddo
            endif
         enddo
      enddo
   endif
   !
   ncfe = maxval(band)
   k1 = ncfe
   do k = 1, ncfe
      if (count(band.eq.k).eq.0) k1 = k1-1
   enddo
   do k = 1, ncfe
      if (count(band.eq.k).eq.0) then
         do j = 1, nrowbackendtable
            if (band(j).gt.k) band(j) = band(j)-1
         enddo
      endif
   enddo
   ncfe = k1
   !
   k1 = minval(band)
   if (k1.ne.1) then
      do k = 1, nrowbackendtable
         band(k) = band(k)-k1+1
      enddo
   endif
   !
   allocate(part(ncfe),indx(ncfe),irank(ncfe),stat=ier)
   !
   do i = 1, ncfe
      backend = list(currentindex)%backend(i)
      k1 = index(backend,'/')+1
      if (k1.ne.1) then
         k2 = len_trim(backend)
         read(backend(k1:k2),'(i3)') part(i)
      else
         part(i) = i
      endif
   enddo
   call indexx(ncfe,dble(part),indx)
   call rank(ncfe,indx,irank)
   !
   where (pixel(1:nrowbackendtable).eq.0)   &
     pixel(1:nrowbackendtable) = 1
   do i = 1, ncfe
      bandmask = band(1:nrowbackendtable).eq.i.and.   &
        pixel(1:nrowbackendtable).eq.1
      ifb = firstifb+irank(i)-1
      fb(ifb)%header%febeband = count(bandmask)
      do l = 1, maxval(pixel)
         k = 0
         do j = 1, nrowbackendtable
            if (band(j).eq.i.and.pixel(j).eq.l) then
               k = k+1
               baseband(j) = k
            endif
         enddo
      enddo
   enddo
   !
11 continue
   if (tmpbackend.eq."ABBA") then
      ncfe = 1
      allocate(   &
        refchan(1),chans(1),   &
        dropped(1),used(1),   &
        band(1),baseband(1),   &
        pixel(1),   &
        rec1(1),rec2(1),   &
        rec3(1),   &
        polar(1),reffreq(1),   &
        spacing(1),bandmask(1),stat=ier   &
        )
   endif
   !
   hdutype = 2
   nullstr = ' '
   call ftmnhd(unit,hdutype,'IMBF-frontend',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'SCANNUM ',fb(firstifb)%header%scannum,comment,   &
     status)
   if (imbftsve.lt.1.2) then
      call ftgkyj(unit,'NOSWITCH',fb(firstifb)%header%nphases,   &
        comment,status)
      call ftgkys(unit,'SWTCHMOD',fb(firstifb)%header%swtchmod,   &
        comment,status)
   else
      fb(firstifb)%header%nphases = nphases
      fb(firstifb)%header%swtchmod = swtchmod
   endif
   call ftgkys(unit,'DATE-OBS',fb(firstifb)%header%date_obs,comment,   &
     status)
   call ftgkys(unit,'DEWRTMOD',fb(firstifb)%header%dewrtmod,comment,   &
     status)
   call ftgkye(unit,'DEWANG  ',fb(firstifb)%header%dewang,comment,   &
     status)
   call ftgkys(unit,'VELOCONV',fb(firstifb)%header%veloconv,comment,   &
     status)
   if (status.ne.0) then
      fb(firstifb)%header%veloconv = 'optical'
      status = 0
   endif
   fb(firstifb+1:lastifb)%header%scannum   &
     = fb(firstifb)%header%scannum
   fb(firstifb+1:lastifb)%header%nphases   &
     = fb(firstifb)%header%nphases
   fb(firstifb+1:lastifb)%header%date_obs   &
     = fb(firstifb)%header%date_obs
   fb(firstifb+1:lastifb)%header%swtchmod   &
     = fb(firstifb)%header%swtchmod
   call sic_upper(fb(firstifb)%header%veloconv)
   fb(firstifb+1:lastifb)%header%veloconv   &
     = fb(firstifb)%header%veloconv
   call sic_upper(fb(firstifb)%header%dewrtmod)
   if (index(fb(firstifb)%header%dewrtmod,'C').eq.1.or.   &
       index(fb(firstifb)%header%dewrtmod,'F').eq.1) then
      fb(firstifb)%header%dewrtmod = 'CABIN'
   else if (index(fb(firstifb)%header%dewrtmod,'S').eq.1) then
      fb(firstifb)%header%dewrtmod = 'EQUA'
   else if (index(fb(firstifb)%header%dewrtmod,'H').eq.1) then
      fb(firstifb)%header%dewrtmod = 'HORIZ'
   else
      fb(firstifb)%header%dewrtmod = 'UNDEF'
   endif
   fb(firstifb+1:lastifb)%header%dewrtmod   &
     = fb(firstifb)%header%dewrtmod
   fb(firstifb+1:lastifb)%header%dewang   &
     = fb(firstifb)%header%dewang
   !
   if (index(sc%header%telescop,'30m').ne.0) then
      fb(firstifb:lastifb)%header%dewcabin = 'NASMYTH_A'
   else
      fb(firstifb:lastifb)%header%dewcabin = 'UNDEFINED'
   endif
   !
   call ftgkyj(unit,'NAXIS2',nrowfrontendtable,comment,status)
   allocate(nfeeds(nrowfrontendtable),sideband(nrowfrontendtable),   &
     beameff(nrowfrontendtable), etafss(nrowfrontendtable),   &
     gainimag(nrowfrontendtable), tcold(nrowfrontendtable),   &
     restfreq(nrowfrontendtable),sbsep(nrowfrontendtable),   &
     widenar(nrowfrontendtable),recname(nrowfrontendtable),   &
     linename(nrowfrontendtable),poltype(nrowfrontendtable),   &
     ifcenter(nrowfrontendtable),frqoff1(nrowfrontendtable),   &
     frqoff2(nrowfrontendtable),frqthrow(nrowfrontendtable),   &
     stat=ier)
   !
   if (tmpbackend.ne."ABBA") then
      call ftgkyd(unit,'VELOSYS',velosys,comment,status)
      call ftgkys(unit,'SPECSYS',specsys,comment,status)
      call ftgcno(unit,.false.,'LINENAME',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,linename,   &
        anynull, status)
      call ftgcno(unit,.false.,'BEAMEFF',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,beameff,   &
        anynull,status)
      call ftgcno(unit,.false.,'ETAFSS',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,etafss,   &
        anynull,status)
      call ftgcno(unit,.false.,'GAINIMAG',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,gainimag,   &
        anynull,status)
      call ftgcno(unit,.false.,'SIDEBAND',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,   &
        sideband,anynull,status)
      call ftgcno(unit,.false.,'SBSEP',idcol,status)
      call ftgcvd(unit,idcol,1,1,nrowfrontendtable,nullval,sbsep,   &
        anynull,status)
      call ftgcno(unit,.false.,'WIDENAR',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,widenar,   &
        anynull,status)
      call ftgcno(unit,.false.,'TCOLD',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,tcold,   &
        anynull,status)
      call ftgcno(unit,.false.,'NOFEEDS',idcol,status)
      call ftgcvj(unit,idcol,1,1,nrowfrontendtable,nullval,nfeeds,   &
        anynull,status)
      call ftgcno(unit,.false.,'POLA',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,poltype,   &
        anynull,status)
      call ftgcno(unit,.false.,'IFCENTER',idcol,status)
      call ftgcve(unit,idcol,1,1,nrowfrontendtable,nullval,ifcenter,   &
        anynull,status)
      call ftgcno(unit,.false.,'FRQTHROW',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqthrow,anynull,status)
      call ftgcno(unit,.false.,'FRQOFF1',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqoff1,anynull,status)
      call ftgcno(unit,.false.,'FRQOFF2',idcol,status)
      if (idcol.ne.0) call ftgcve(unit,idcol,1,1,nrowfrontendtable,   &
        nullval,frqoff2,anynull,status)
      call ftgcno(unit,.false.,'RECNAME',idcol,status)
      call ftgcvs(unit,idcol,1,1,nrowfrontendtable,nullstr,recname,   &
        anynull, status)
   else
      call ftgcno(unit,.false.,'RECNAME',idcol,status)
      if (idcol.ne.0) call ftgcvs(unit,idcol,1,1,nrowfrontendtable,   &
        nullstr,rec1,anynull,status)
      call ftgkyj(unit,'NUSEFEED',nfeeds,comment,status)
      chans(1) = 1
      spacing(1) = 0.
      used(1) = 1
      dropped(1) = 0
      recname(1) = rec1(1)
      frqoff1(1) = 0.
      frqoff2(1) = 0.
      beameff(1) = 1.0
      etafss(1) = 1.0
      fb(1)%header%febeband = 1
      linename(1) = ' '
   endif
   call ftgcno(unit,.false.,'RESTFREQ',idcol,status)
   call ftgcvd(unit,idcol,1,1,nrowfrontendtable,nullval,restfreq,   &
     anynull,status)
   !
   do ifb = firstifb, lastifb
      nbd = fb(ifb)%header%febeband
      allocate(ar(ifb)%header(nbd),ar(ifb)%data(nbd),stat=ier)
   enddo
   !
   if (allocated(foundfebe)) deallocate(foundfebe,stat=ier)
   allocate(foundfebe(nfb),stat=ier)
   foundfebe(1:nfb) = .false.
   !
   if (allocated(tcoldmon)) deallocate(tcoldmon,stat=ier)
   allocate(tcoldmon(nfb),stat=ier)
   !
   do i = 1, nrowbackendtable
      if (tmpbackend.ne."ABBA") then
         k = band(i)
         ifb = firstifb+irank(k)-1
      else
         band(1) = 1
         ifb = 1
         foundfebe(1) = .false.
         fb(ifb)%header%ifcenter = 0.
      endif
      if (foundfebe(ifb)) cycle
      nbd = fb(ifb)%header%febeband
      do j = 1, nrowfrontendtable
         if (index(recname(j),rec1(i)).ne.0) then
            !
            tmpfrontend = recname(j)
            if (polmode) then
               if (index(polar(i),'REAL').ne.0) then
                  tmpfrontend(1:1) = 'R'
               else if (index(polar(i),'IMAG').ne.0) then
                  tmpfrontend(1:1) = 'I'
               else if (index(polar(i),'AXIS').ne.0) then
                  if (index(rec1(i),'A').ne.0.or.   &
                      index(rec1(i),'C').ne.0) then
                     tmpfrontend(1:1) = 'V'
                  else if (index(rec1(i),'B').ne.0.or.   &
                           index(rec1(i),'D').ne.0) then
                     tmpfrontend(1:1) = 'H'
                  endif
               endif
            endif
            !
            npix = nfeeds(j)
            if (npix.le.0) npix = 1
            allocate(fb(ifb)%data%usefeed(npix),   &
                     fb(ifb)%data%feedtype(npix),   &
                     fb(ifb)%data%feedoffx(npix),   &
                     fb(ifb)%data%feedoffy(npix),   &
                     fb(ifb)%data%polty(npix),   &
                     fb(ifb)%data%pola(npix),   &
                     fb(ifb)%data%apereff(npix,nbd),   &
                     fb(ifb)%data%bolcalfc(npix),   &
                     fb(ifb)%data%flatfiel(npix,nbd),   &
                     fb(ifb)%data%gainimag(npix,nbd),   &
                     fb(ifb)%data%beameff(npix,nbd),   &
                     fb(ifb)%data%etafss(npix,nbd),   &
                     fb(ifb)%data%hpbw(npix,nbd),   &
                     fb(ifb)%data%antgain(npix,nbd),   &
                     fb(ifb)%data%gainele1(nbd),   &
                     fb(ifb)%data%gainele2(nbd),   &
              stat=ier)
            fb(ifb)%header%febefeed = npix
            fb(ifb)%header%nusefeed = npix
            fb(ifb)%header%ifcenter = ifcenter(j)*1.d9
            fb(ifb)%header%frqoff1 = frqoff1(j)*1.e9
            fb(ifb)%header%frqoff2 = frqoff2(j)*1.e9
            fb(ifb)%header%frqthrow = frqthrow(j)*1.e9
            if (index(poltype(j),'vertical').ne.0) then
               fb(ifb)%data%polty(1:npix) = 'Y'
            else if (index(poltype(j),'horizontal').ne.0) then
               fb(ifb)%data%polty(1:npix) = 'X'
            else
               fb(ifb)%data%polty(1:npix) = 'U'
            endif
            backend = list(currentindex)%backend(band(i))
            tmpbackend = backend
            call sic_upper(tmpbackend)
            sc%data%febe(ifb) = trim(tmpfrontend)//' '//trim(backend)
            fb(ifb)%header%febe = sc%data%febe(ifb)
            ar(ifb)%header(1:nbd)%febe = sc%data%febe(ifb)
            ar(ifb)%header(1:nbd)%transiti = linename(j)
            ar(ifb)%header(1:nbd)%molecule = linename(j)
            do ibd = 1, nbd
               ar(ifb)%header(ibd)%restfreq = restfreq(j)*1.d9
               ar(ifb)%header(ibd)%restfreqO = restfreq(j)*1.d9
               ar(ifb)%header(ibd)%sbsep = sbsep(j)
            enddo
            fb(ifb)%data%beameff(1,1) = beameff(j)
            fb(ifb)%data%beameff(1:npix,1:nbd)   &
              = fb(ifb)%data%beameff(1,1)
            fb(ifb)%data%etafss(1,1) = etafss(j)
            fb(ifb)%data%etafss(1:npix,1:nbd)   &
              = fb(ifb)%data%etafss(1,1)
            fb(ifb)%data%gainimag(1,1) = gainimag(j)
            fb(ifb)%data%gainimag(1:npix,1:nbd)   &
              = fb(ifb)%data%gainimag(1,1)
            ar(ifb)%header(1:nbd)%sideband = sideband(j)
            fb(ifb)%header%widenar = widenar(j)
            if (index(sc%header%telescop,'30m').ne.0) then
               fb(ifb)%data%hpbw(1:npix,1:nbd)   &
                 = 2460.d9/ar(ifb)%header(1)%restfreq/3600.
            else
               fb(ifb)%data%hpbw(1:npix,1:nbd) = -1000.
            endif
            fb(ifb)%data%antgain(1:npix,1:nbd) = 0. ! not yet done
            tcoldmon(ifb) = dble(tcold(j))
            !
            exit
         endif
      enddo
      foundfebe(ifb) = .true.
   enddo
   !
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-antenna',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkys(unit,'OBSTYPE ',sc%header%scantype,comment,status)
   call ftgkyd(unit,'SESPES01',sc%header%scanxvel,comment,status)
   sc%header%scanxvel = sc%header%scanxvel*rad2asec
   tmpscantype = sc%header%scantype
   call sic_upper(tmpscantype)
   !
   ! check completeness of subscans
   !
   if (index(tmpscantype,'FOCUS').ne.0.or.index(tmpscantype,'TIP').ne.0) then
      if (sc%header%nobs.lt.6) then
         call gagout('E-GET: '//tmpscantype//' needs at least 6 subscans.')
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
   endif
   !
   if (polmode.and.nsubscan.gt.3.and.index(tmpscantype,'CAL').ne.0)   &
     then
      sc%header%scantype = 'calibGrid'
      tmpscantype = 'CALIBGRID'
   endif
   tmpswitchmode = fb(1)%header%swtchmod
   call sic_upper(tmpswitchmode)
   if (index(tmpscantype,'CAL').ne.0.and.firstifb.eq.1) then
      if (allocated(gn)) then
         do ifb = 1, size(gn)
            call freegains(gn(ifb),error)
         enddo
         deallocate(gn)
      endif
      if (index(tmpswitchmode,'FREQ').ne.0) then
         allocate(gn(2*nfb),stat=ier)
      else
         allocate(gn(nfb),stat=ier)
      endif
   endif
   !
   !
   ndumpantenna = 0
   ndumpantennafast = 0
   ndumpantennanew = 0
   ndumpantennafastnew = 0
   !
   cryoextension = .false.
   derotextension = .false.
   call ftmnhd(unit,hdutype,'IMBF-hera-cryot',0,status)
   if (status.eq.0) then
      cryoextension = .true.
   else
      status = 0
   endif
   call ftmnhd(unit,hdutype,'IMBF-hera-derot',0,status)
   if (status.eq.0) then
      derotextension = .true.
   else
      status = 0
   endif
   !
   if (.not.cryoextension.and..not.derotextension) then
      next       = 3
      idxantenna = 1
      idxsubref  = 2
      idxbackend = 3
   else if (.not.derotextension) then
      next       = 4
      idxantenna = 1
      idxsubref  = 2
      idxcryo    = 3
      idxbackend = 4
   else
      next       = 5
      idxantenna = 1
      idxsubref  = 2
      idxcryo    = 3
      idxderot   = 4
      idxbackend = 5
   endif
   !
   if (allocated(subscantrace)) deallocate(subscantrace,stat=ier)
   allocate(subscantrace(nsubscan),stat=ier)
   !
   ndumpcryo = 0
   ndumpderot = 0
   subscanloop1: do i = subscanRange(1), subscanRange(2)
      j = idxstart+idxantenna+(i-1)*next
      i1 = i-subscanRange(1)+1 
      call ftmahd(unit,j,hdutype,status)
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      call ftgkyj(unit,'TRACERAT',tracerate,comment,status)
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      !
      if (allocated(traceflagdefined))   &
        deallocate(traceflagdefined,stat=ier)
      if (allocated(tmptraceflag))   &
        deallocate(tmptraceflag,stat=ier)
      if (allocated(flagvals)) deallocate(flagvals,stat=ier)
      allocate(flagvals(idump),traceflagdefined(idump),   &
        tmptraceflag(idump),stat=ier)
      !
      ndumpantenna = ndumpantenna+idump
      ndumpantennafast = ndumpantennafast+idump*tracerate
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      call dateobstomjd(subscantime,   &
                        raw(i1)%antenna(firstifb)%subscanstart,   &
                        status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         call ftgkyd(unit,'SUBSTIME',substime,comment,status)
         raw(i1)%antenna(firstifb)%subscanend   &
           = raw(i1)%antenna(firstifb)%subscanstart+substime*sec2day
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%antenna(firstifb)%subscanend,status)
      endif
      call ftgkys(unit,'SYSTEMOF',raw(i1)%antenna(firstifb)%systemoff,   &
        comment,status)
      call ftgkyd(unit,'SUBSXOFF',   &
        raw(i1)%antenna(firstifb)%subscanxoff,comment,   &
        status)
      call ftgkyd(unit,'SUBSYOFF',   &
        raw(i1)%antenna(firstifb)%subscanyoff,comment,   &
        status)
      call ftgkyd(unit,'SEXSTA01',   &
        raw(i1)%antenna(firstifb)%segmentxstart,comment,   &
        status)
      call ftgkyd(unit,'SEYSTA01',   &
        raw(i1)%antenna(firstifb)%segmentystart,comment,   &
        status)
      call ftgkyd(unit,'SEXEND01',   &
        raw(i1)%antenna(firstifb)%segmentxend,comment,   &
        status)
      call ftgkyd(unit,'SEYEND01',   &
        raw(i1)%antenna(firstifb)%segmentyend,comment,   &
        status)
      call ftgkyd(unit,'DOPPLERC',   &
        raw(i1)%antenna(firstifb)%dopplercorr,comment,   &
        status)
      call ftgkyd(unit,'OBSVELRF',raw(i1)%antenna(firstifb)%obsvelrf,   &
        comment,status)
      if (status.ne.0.and.tmpbackend.ne."ABBA") then
         call gagout('W-GET: Doppler correction factor set to 1.')
         raw(i1)%antenna(firstifb)%dopplercorr = 1.0d0
         status = 0
      endif
      call ftgkys(unit,'SBCALREC',   &
        raw(i1)%antenna(firstifb)%sbcalrec,comment,   &
        status)
      if (status.ne.0) then
         raw(i1)%antenna(firstifb)%sbcalrec = 'UNKNOWN'
         status = 0
      else
         call sic_upper(raw(i1)%antenna(firstifb)%sbcalrec)
      endif
      raw(i1)%antenna(firstifb)%trackingerror = trackingcutoff
      raw(i1)%antenna(firstifb+1:lastifb) = raw(i1)%antenna(firstifb)
      call ftgcno(unit,.false.,'TRACEFLAG',idcol,status)
      call ftgcfj(unit,idcol,1,1,idump,tmptraceflag,flagvals,anynull,   &
        status)
      !
      if (idump.ne.0) then
         call medianinteger(tmptraceflag,idump,median)
         subscantrace(i) = int(median)
      else
         write(subscanstring,'(I3)') i
         call gagout('W-GET: subscan '//trim(subscanstring)//   &
                     ' contains no valid antenna data point.')
         subscantrace(i) = 2
      endif
      traceflagdefined = (tmptraceflag.ne.2.and.   &
                          subscantrace(i).eq.tmptraceflag)   &
                          .or.   &
                          index(tmpscantype,'CAL').ne.0
      if (count(traceflagdefined).eq.0) then
         write(subscanstring,'(I3)') i
         call gagout('W-GET: subscan '//trim(subscanstring)//   &
                     ' contains no valid antenna data point.')
      endif
      ndumpantennanew = ndumpantennanew+count(traceflagdefined)
      ndumpantennafastnew = ndumpantennafastnew   &
        +tracerate*count(traceflagdefined)
      !
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      call dateobstomjd(subscantime,   &
        raw(i1)%subref(firstifb)%subscanstart,status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         call ftgkyd(unit,'SUBSTIME',substime,comment,status)
         raw(i1)%subref(firstifb)%subscanend   &
           = raw(i1)%subref(firstifb)%subscanstart+substime*sec2day
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%subref(firstifb)%subscanend,status)
      endif
      call ftgkyd(unit,'SEXSTA01',   &
        raw(i1)%subref(firstifb)%segmentxstart,comment,   &
        status)
      call ftgkyd(unit,'SEYSTA01',   &
        raw(i1)%subref(firstifb)%segmentystart,comment,   &
        status)
      call ftgkyd(unit,'SEXEND01',   &
        raw(i1)%subref(firstifb)%segmentxend,comment,status)
      call ftgkyd(unit,'SEYEND01',   &
        raw(i1)%subref(firstifb)%segmentyend,comment,status)
      !
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
      !
      if (cryoextension) then
         j = idxstart+idxcryo+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         ndumpcryo = ndumpcryo+idump
      endif
      !
      if (derotextension) then
         j = idxstart+idxderot+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         ndumpderot = ndumpderot+idump
      endif
      !
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkys(unit,'DATE-OBS',subscantime,comment,status)
      do ifb = firstifb, lastifb
         do ibd = 1, nbd
            ar(ifb)%header(1)%date_obs = subscantime
            ar(ifb)%header(1)%scannum = fb(firstifb)%header%scannum
         enddo
      enddo
      !
      call dateobstomjd(subscantime,   &
        raw(i1)%backend(firstifb)%subscanstart,status)
      call ftgkys(unit,'DATE-END',subscantime,comment,status)
      if (status.ne.0) then
         status = 0
         raw(i1)%backend(firstifb)%subscanend   &
           = raw(i1)%backend(firstifb)%subscanstart
      else
         call dateobstomjd(subscantime,   &
           raw(i1)%backend(firstifb)%subscanend,status)
      endif
      raw(i1)%backend(firstifb+1:lastifb) = raw(i1)%backend(firstifb)
   !
   enddo subscanloop1
   !
   if (.not.timingCheck) then
      ndumpAntennaNew     = ndumpAntenna
      ndumpAntennaFastNew = ndumpAntennaFast
   endif
   !
   if (cryoextension.and.ndumpcryo.ge.1) then
      ! In case of empty tables allocate at least 1 (otherwise ifort crash)
      allocate(crx%mjd(ndumpcryo), crx%cr4k1(ndumpcryo),   &
               crx%cr4k2(ndumpcryo),stat=ier)
   elseif (cryoextension.and.ndumpcryo.lt.1) then
      allocate(crx%mjd(1), crx%cr4k1(1),   &
               crx%cr4k2(1),stat=ier)
      print*,'No data in cryo table'
   endif
   !
   !
   if (derotextension.and.ndumpderot.ge.1) then
      ! In case of empty tables allocate at least 1 (otherwise ifort crash)
      allocate(drt%mjd(ndumpderot), drt%actframe(ndumpderot),   &
        stat=ier)
   elseif (derotextension.and.ndumpderot.lt.1) then
      allocate(drt%mjd(1), drt%actframe(1),   &
        stat=ier)
      print*,'No data in derot table'  
   endif
   !
   !
   ndumpfrontend = 1
   !
   !
   i2 = 0
   i4 = 0
   ndumpsubref = 0
   subscanloop2: do i = subscanRange(1), subscanRange(2)
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      ndumpsubref = ndumpsubref+idump
      !
      if (cryoextension) then
         j = idxstart+idxcryo+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(idump),stat=ier)
         i1 = i2+1
         i2 = i2+idump
         call ftgcno(unit,.false.,'MJD',idcol,status)
         call ftgcfd(unit,idcol,1,1,idump,crx%mjd(i1:i2),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'cr4K',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,crx%cr4k1(i1:i2),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'cr4K2',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,crx%cr4k2(i1:i2),flagvals,   &
           anynull,status)
      endif
      !
      if (derotextension) then
         j = idxstart+idxderot+(i-1)*next
         call ftmahd(unit,j,hdutype,status)
         call ftgkyj(unit,'NAXIS2',idump,comment,status)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(idump),stat=ier)
         i3 = i4+1
         i4 = i4+idump
         call ftgcno(unit,.false.,'MJD',idcol,status)
         call ftgcfd(unit,idcol,1,1,idump,drt%mjd(i3:i4),flagvals,   &
           anynull,status)
         call ftgcno(unit,.false.,'fAct',idcol,status)
         call ftgcfe(unit,idcol,1,1,idump,drt%actframe(i3:i4),   &
           flagvals,anynull,status)
      endif
   !
   enddo subscanloop2
   !
   !
   if (firstifb.eq.1)   &
     allocate(antdata%encoder_az_el(ndumpantennafast,3),   &
              antdata%tracking_az_el(ndumpantennafast,2),  &
              antdata%slowtrace(ndumpantenna,3),           &
              stat=ier)
   do ifb = firstifb, lastifb
      allocate(mnt(ifb)%data%subscan(ndumpantennanew),   &
               mnt(ifb)%data%subscanfast(ndumpantennafastnew),   &
               mnt(ifb)%data%subscansubref(ndumpsubref),   &
               mnt(ifb)%data%mjd(ndumpantennanew),   &
               mnt(ifb)%data%lst(ndumpantennanew),   &
               mnt(ifb)%data%encoder_az_el(ndumpantennafastnew,3),   &
               mnt(ifb)%data%tracking_az_el(ndumpantennafastnew,2),   &
               mnt(ifb)%data%longoff(ndumpantennanew),   &
               mnt(ifb)%data%latoff(ndumpantennanew),   &
               mnt(ifb)%data%baslong(ndumpantennanew),   &
               mnt(ifb)%data%baslat(ndumpantennanew),   &
               mnt(ifb)%data%parangle(ndumpantennanew),   &
               mnt(ifb)%data%antenna_az_el(2),   &
               mnt(ifb)%data%tamb_p_humid(ndumpfrontend,3),   &
               mnt(ifb)%data%wind_dir_vavg_vmax(ndumpfrontend,3),   &
               mnt(ifb)%data%thotcold(ndumpfrontend,2),   &
               mnt(ifb)%data%refractio(ndumpfrontend),   &
               mnt(ifb)%data%focus_x_y_z(ndumpsubref,4),   &
               mnt(ifb)%data%dfocus_x_y_z(ndumpsubref,3),   &
               mnt(ifb)%data%dphi_x_y_z(ndumpsubref,3),   &
               mnt(ifb)%data%phi_x_y_z(ndumpsubref,3),   &
               stat = ier)
   enddo
   if (allocated(traceflag)) deallocate(traceflag,stat=ier)
   allocate(traceflag(ndumpantennanew),stat=ier)
   !
   hdutype = 2
   idump2 = 0
   subscanloop3: do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      j = idxstart+idxsubref+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkys(unit,'SUBSTYPE',   &
        raw(i1)%subref(firstifb)%subscantype,comment,status)
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
      idump1 = idump2+1
      idump2 = idump2+idump
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump),stat=ier)
      if (allocated(tmpfocus)) deallocate(tmpfocus)
      allocate(tmpfocus(idump),stat=ier)
      call ftgkys(unit,'FOTRANSL',focustranslationdirection,comment,   &
        status)
      call sic_upper(focustranslationdirection)
      raw(i1)%subref(firstifb:lastifb)%focustransl   &
        = focustranslationdirection
      call ftgkyd(unit,'FOOFFSET',focusoffset,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1)   &
           = mnt(firstifb)%header%focobs_x_y_z(1)
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2)   &
           = mnt(firstifb)%header%focobs_x_y_z(2)
         mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3)   &
           = mnt(firstifb)%header%focobs_x_y_z(3)
         if (index(focustranslationdirection,'X').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,1)+focusoffset
         else if (index(focustranslationdirection,'Y').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,2)+focusoffset
         else if (index(focustranslationdirection,'Z').ne.0) then
            mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3) =   &
              mnt(ifb)%data%dfocus_x_y_z(idump1:idump2,3)+focusoffset
         endif
      enddo

      call ftgcno(unit,.false.,'FOCUS_X',idcol,status)
      do icol = idcol, idcol+2
         call ftgcfd(unit,icol,1,1,idump,tmpfocus,flagvals,anynull,   &
           status)
         do ifb = firstifb, lastifb
            mnt(ifb)%data%focus_x_y_z(idump1:idump2,icol-idcol+1)   &
              = tmpfocus(:)
         enddo
      enddo
      call ftgcno(unit,.false.,'PHI_X',idcol,status)
      do icol = idcol, idcol+2
         call ftgcfd(unit,icol,1,1,idump,tmpfocus,flagvals,anynull,   &
           status)
         do ifb = firstifb, lastifb
            mnt(ifb)%data%phi_x_y_z(idump1:idump2,icol-idcol+1)   &
              = tmpfocus(:)
         enddo
      enddo
      call ftgcno(unit,.false.,'MJD',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,tmpfocus,flagvals,anynull,   &
        status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%focus_x_y_z(idump1:idump2,4) = tmpfocus(:)
         mnt(ifb)%data%subscansubref(idump1:idump2) = i
      enddo
      raw(i1)%subref(firstifb)%subscanstart =   &
        max(   &
            raw(i1)%subref(firstifb)%subscanstart,   &
            mnt(firstifb)%data%focus_x_y_z(idump1,4)   &
           )
      raw(i1)%subref(firstifb)%subscanend =   &
        min(   &
            raw(i1)%subref(firstifb)%subscanend,   &
            mnt(firstifb)%data%focus_x_y_z(idump2,4)   &
           )
      raw(i1)%subref(firstifb+1:lastifb) = raw(i1)%subref(firstifb)
   !
   enddo subscanloop3
   !
   idump2 = 0
   idump4 = 0
   if (allocated(fastdap)) deallocate(fastdap,stat=ier)
   if (allocated(slowdap)) deallocate(slowdap,stat=ier)
   !
   allocate(fastdap(ndumpantennafast),slowdap(ndumpantenna),   &
     stat=ier)
   !
   subscanloop4: do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      j = idxstart+idxantenna+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      !
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkys(unit,'SUBSTYPE',   &
        raw(i1)%antenna(firstifb)%subscantype,comment,   &
        status)
      idump1 = idump2+1
      idump2 = idump2+idump
      idump3 = idump4+1
      idump4 = idump4+idump*tracerate
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump),stat=ier)
      call ftgcno(unit,.false.,'MJD',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%mjd,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LST',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%lst,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LONGOFF',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%longoff,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'LATOFF',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%latoff,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'BASLONG',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%baslong,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'BASLAT',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%baslat,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'PARANGLE',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%parangle,flagvals,anynull,   &
        status)
      call ftgcno(unit,.false.,'TRACEFLAG',idcol,status)
      call ftgcfj(unit,idcol,1,1,idump,   &
        slowdap(idump1:idump2)%traceflag,flagvals,anynull,   &
        status)
      slowdap(idump1:idump2)%subscan = i
      !
      if (allocated(flagvals)) deallocate(flagvals)
      allocate(flagvals(idump*tracerate),stat=ier)
      call ftgcno(unit,.false.,'MJDFAST',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(3),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'AZIMUTH',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(1),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'TRACKING_AZ',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%tracking_az_el(1),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'ELEVATION',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%encoder_az_el(2),   &
        flagvals,anynull,status)
      call ftgcno(unit,.false.,'TRACKING_EL',idcol,status)
      call ftgcfd(unit,idcol,1,1,idump*tracerate,   &
        fastdap(idump3:idump4)%tracking_az_el(2),   &
        flagvals,anynull,status)
      fastdap(idump3:idump4)%subscanfast = i
   !
   enddo subscanloop4
   !
   if (firstifb.eq.1) then
      do m = 1, 3
         antdata%encoder_az_el(1:ndumpantennafast,m) &
 &       = fastdap(1:ndumpantennafast)%encoder_az_el(m)
      enddo
      antdata%encoder_az_el(1:ndumpantennafast,1:2) &
 &    = antdata%encoder_az_el(1:ndumpantennafast,1:2)*rad2deg
      do m = 1, 2
         antdata%tracking_az_el(1:ndumpantennafast,m) &
 &       = fastdap(1:ndumpantennafast)%tracking_az_el(m)*rad2deg
      enddo
      antdata%slowtrace(1:ndumpantenna,1)  &
 &    = slowdap(1:ndumpantenna)%longoff*rad2deg
      antdata%slowtrace(1:ndumpantenna,2)  &
 &    = slowdap(1:ndumpantenna)%latoff*rad2deg
      antdata%slowtrace(1:ndumpantenna,3) = slowdap(1:ndumpantenna)%mjd
   endif

   !
   j = 0
   i2 = 0
   i4 = 0
   do i = 1, ndumpantenna
      i1 = i2+1
      i2 = i2+tracerate
      if((slowdap(i)%traceflag.ne.2.and.                             &
          slowdap(i)%traceflag.eq.subscantrace(slowdap(i)%subscan))  &
         .or.index(tmpscantype,'CAL').ne.0.or..not.timingCheck) then
         j = j+1
         i3 = i4+1
         i4 = i4+tracerate
         do ifb = firstifb, lastifb
            mnt(ifb)%data%mjd(j) = slowdap(i)%mjd
            mnt(ifb)%data%lst(j) = slowdap(i)%lst
            mnt(ifb)%data%longoff(j) = slowdap(i)%longoff
            mnt(ifb)%data%latoff(j) = slowdap(i)%latoff
            mnt(ifb)%data%baslong(j) = slowdap(i)%baslong
            mnt(ifb)%data%baslat(j) = slowdap(i)%baslat
            mnt(ifb)%data%parangle(j) = slowdap(i)%parangle
            traceflag(j) = slowdap(i)%traceflag
            mnt(ifb)%data%subscan(j) = slowdap(i)%subscan
            do m = 1, 3
               mnt(ifb)%data%encoder_az_el(i3:i4,m)   &
                 = fastdap(i1:i2)%encoder_az_el(m)
            enddo
            do m = 1, 2
               mnt(ifb)%data%tracking_az_el(i3:i4,m)   &
                 = fastdap(i1:i2)%tracking_az_el(m)
            enddo
            mnt(ifb)%data%subscanfast(i3:i4)   &
              = fastdap(i1:i2)%subscanfast
         enddo
      endif
   enddo
   !
   ndumpantenna = ndumpantennanew
   ndumpantennafast = ndumpantennafastnew
   !
   do i = 1, nsubscan
      raw(i)%antenna(firstifb+1:lastifb) = raw(i)%antenna(firstifb)
   enddo
   !
   antennaTimingCheck: if (timingCheck) then
      do i = subscanRange(1), subscanRange(2)
         i1 = i-subscanRange(1)+1
         do j = 1, ndumpantenna
            if (mnt(firstifb)%data%subscan(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanstart   &
           = max(raw(i1)%antenna(firstifb)%subscanstart,   &
           mnt(firstifb)%data%mjd(j))
         do j = ndumpantenna, 1, -1
            if (mnt(firstifb)%data%subscan(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanend   &
           = min(raw(i1)%antenna(firstifb)%subscanend,   &
           mnt(firstifb)%data%mjd(j))
      enddo
      !
      do i = subscanRange(1), subscanRange(2)
         i1 = i-subscanRange(1)+1
         do j = 1, ndumpantennafast
            if (mnt(firstifb)%data%subscanfast(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanstart   &
           = max(raw(i1)%antenna(firstifb)%subscanstart,   &
           mnt(firstifb)%data%encoder_az_el(j,3))
         do j = ndumpantennafast, 1, -1
            if (mnt(firstifb)%data%subscanfast(j).eq.i) exit
         enddo
         raw(i1)%antenna(firstifb)%subscanend   &
           = min(raw(i1)%antenna(firstifb)%subscanend,   &
           mnt(firstifb)%data%encoder_az_el(j,3))
         raw(i1)%antenna(firstifb+1:lastifb) = raw(i1)%antenna(firstifb)
      enddo
      !
   endif antennaTimingCheck
   !
   !
   febe_loop1: do ifb = firstifb, lastifb
      !
      mnt(ifb)%data%longoff  = rad2deg*mnt(ifb)%data%longoff
      mnt(ifb)%data%latoff   = rad2deg*mnt(ifb)%data%latoff
      mnt(ifb)%data%baslong  = rad2deg*mnt(ifb)%data%baslong
      mnt(ifb)%data%baslat   = rad2deg*mnt(ifb)%data%baslat
      mnt(ifb)%data%parangle = rad2deg*mnt(ifb)%data%parangle
      mnt(ifb)%data%encoder_az_el(1:ndumpantennafast,1:2)   &
        = mnt(ifb)%data%encoder_az_el(1:ndumpantennafast,1:2)*rad2deg
      mnt(ifb)%data%tracking_az_el   &
        = mnt(ifb)%data%tracking_az_el*rad2deg
      mnt(ifb)%data%antenna_az_el(:)   &
        = mnt(ifb)%data%encoder_az_el(1,:)
      !
      !
      !
      fb(ifb)%data%usefeed(1) = 1
      fb(ifb)%data%reffeed = 1
      if (index(fb(ifb)%header%febe,'HER') /= 0 ) then
         fb(ifb)%data%reffeed = 5
         do i = 1, npix
            fb(ifb)%data%usefeed(1) = i
         enddo
         if (index(tmpfrontend,'VERTICAL').ne.0) then
            fb(ifb)%data%pola(1:npix) = 0.
         else if (index(tmpfrontend,'HORIZONTAL').ne.0) then
            fb(ifb)%data%pola(1:npix) = 90.
         endif
         !
         posanghera = fb(ifb)%header%dewang/rad2deg
         if (index(fb(ifb)%header%dewrtmod,'CABIN').ne.0) then
            fb(ifb)%data%feedoffx   &
              =  xhera(:)*cos(posanghera)-yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else if (index(fb(ifb)%header%dewrtmod,'HORIZ').ne.0) then
            fb(ifb)%data%feedoffx   &
              =  xhera(:)*cos(posanghera)-yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else if (index(fb(ifb)%header%dewrtmod,'EQUA').ne.0) then
            fb(ifb)%data%feedoffx   &
              = -xhera(:)*cos(posanghera)+yhera(:)*sin(posanghera)
            fb(ifb)%data%feedoffy   &
              =  xhera(:)*sin(posanghera)+yhera(:)*cos(posanghera)
         else
            fb(ifb)%data%feedoffx = 0.
            fb(ifb)%data%feedoffy = 0.
         endif
         fb(ifb)%data%feedoffx = fb(ifb)%data%feedoffx(:)/3.6d+3
         fb(ifb)%data%feedoffy = fb(ifb)%data%feedoffy(:)/3.6d+3
      !
      else
         if (index(tmpfrontend,'H').eq.1) then
            fb(ifb)%data%pola(1) = 90.
         else if (index(tmpfrontend,'V').eq.1) then
            fb(ifb)%data%pola(1) = 0.
         endif
         fb(ifb)%data%feedoffx(1) = 0.
         fb(ifb)%data%feedoffy(1) = 0.
      endif
   !
   enddo febe_loop1
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-scan',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyd(unit,'THOT',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%thotcold(1,1) = tmpcalib
   enddo
   call ftgkyd(unit,'REFRACTI',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%refractio(1) = tmpcalib
   enddo
   call ftgkyd(unit,'TEMPERAT',tmpcalib,comment,status)
   if (status.ne.0) then
      status = 0
      call ftgkyd(unit,'TAMBIENT',tmpcalib,comment,status)
   endif
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,1) = tmpcalib
   enddo
   call ftgkyd(unit,'PRESSURE',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,2) = tmpcalib
   enddo
   call ftgkyd(unit,'HUMIDITY',tmpcalib,comment,status)
   do ifb = firstifb, lastifb
      mnt(ifb)%data%tamb_p_humid(1,3) = tmpcalib
   enddo
   !
   !
   call ftgkyd(unit,'WINDDIR',tmpcalib,comment,status)
   if (status /= 0) then
      status = 0
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,1:3) = 0.0
      enddo
   else
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,1) = tmpcalib
      enddo
      call ftgkyd(unit,'WINDVEL',tmpcalib,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,2) = tmpcalib
      enddo
      call ftgkyd(unit,'WINDVELM',tmpcalib,comment,status)
      do ifb = firstifb, lastifb
         mnt(ifb)%data%wind_dir_vavg_vmax(1,3) = tmpcalib
      enddo
   endif
   !
   !
   hdutype = 2
   call ftmnhd(unit,hdutype,'IMBF-antenna',0,status)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      return
   endif
   call ftgkyj(unit,'SCANNUM',mnt(firstifb)%header%scannum,comment,   &
     status)
   call ftgkys(unit,'DATE-OBS',mnt(firstifb)%header%date_obs,comment,   &
     status)
   mnt(firstifb)%header%obsnum = currentindex
   !
   do ifb = firstifb+1, lastifb
      mnt(ifb)%header = mnt(firstifb)%header
   enddo
   do ifb = firstifb, lastifb
      mnt(ifb)%data%thotcold(1,2) = tcoldmon(ifb)
   enddo
   !
   nrecords = 0
   hdutype = 2
   do i = subscanRange(1), subscanRange(2) 
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      if (i.eq.1) then
         !
         call ftgkys(unit,'TFORM3',dataformat,comment,status)
         call sic_upper(dataformat)
         !
         call ftgkyj(unit,'CHANNELS',allchannels,comment,status)
         if (allocated(iddump)) deallocate(iddump,stat=ier)
         allocate(iddump(allchannels,5),stat=ier)
         if (allocated(flagvals)) deallocate(flagvals,stat=ier)
         allocate(flagvals(allchannels),stat=ier)
         if (allocated(intdata)) deallocate(intdata,stat=ier)
         if (allocated(realdata)) deallocate(realdata,stat=ier)
         if (allocated(doubledata)) deallocate(doubledata,stat=ier)
         if (index(dataformat,'J').ne.0) then
            allocate(intdata(allchannels),stat=ier)
         else if (index(dataformat,'E').ne.0) then
            allocate(realdata(allchannels),stat=ier)
         else if (index(dataformat,'D').ne.0) then
            allocate(doubledata(allchannels),stat=ier)
         endif
      endif
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      !
      if (idump.eq.0) then
         write(subscanstring,'(I3)') i
         j = index(fb(firstIfb)%header%febe,' ')
         tmpbackend(1:5) = fb(firstIfb)%header%febe(j+1:j+5)
         call gagout('W-GET: no '//tmpbackend(1:5)//          &
                     ' data in subscan '//subscanstring(1:3)//'.')
      endif
      !
      if (imbftsve.lt.1.2)   &
        call ftgkyj(unit,'NPHASES',nphases,comment,status)
      nrecords = nrecords+int(idump/nphases)
   !
   enddo
   !
   if (nrecords.eq.0) then
      status = 0
      call ftclos(unit,status)
      call ftfiou(-1,status)
      j = index(fb(firstIfb)%header%febe,' ')
      tmpbackend(1:5) = fb(firstIfb)%header%febe(j+1:j+5)
      call gagout('W-GET: no '//tmpbackend(1:5)//' data in this scan.')
      call sic_upper(tmpbackend)
      if (index(tmpbackend(1:5),'VESPA').ne.0.or.index(tmpbackend(1:5),'WILMA').ne.0) &
 &       error = .true.
      return
   endif
   !
   if (index(tmpbackend,'ABBA').eq.0) then
      !
      do i = 1, nrowbackendtable
         !
         ifb = firstifb+irank(band(i))-1
         if (index(tmpbackend,'CONT').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else if (index(tmpbackend,'BBC').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else if (index(tmpbackend,'NBC').ne.0) then
            iddump(i,1) = ifb
            iddump(i,2) = baseband(i)
            iddump(i,3) = pixel(i)
            iddump(i,4) = 1
         else
            do j = refchan(i), refchan(i)+chans(i)-1
               iddump(j,1) = ifb
               iddump(j,2) = baseband(i)
               iddump(j,3) = pixel(i)
               iddump(j,4) = j-refchan(i)+1
               if (polmode) then
                  if (index(polar(i),'IMAG').ne.0.and.   &
                      index(rec1(i),'A').ne.0.and.index(rec2(i),'B')   &
                      .ne.0) then
                     iddump(j,5) = -1
                  else if (index(polar(i),'IMAG').ne.0.and.   &
                           index(rec1(i),'C').ne.0.and.index(rec2(i),'D')   &
                           .ne.0) then
                     iddump(j,5) = -1
                  else
                     iddump(j,5) = 1
                  endif
               endif
            enddo
         endif
      !
      enddo
   !
   else if (index(tmpbackend,'ABBA').ne.0) then
      !
      iddump(1:allchannels,1) = 1
      iddump(1:allchannels,2) = 1
      do m = 1, allchannels
         iddump(m,3) = m
      enddo
      iddump(1:allchannels,4) = 1
      iddump(1:allchannels,5) = 1
   !
   endif
   !
   !
   !
   do jfb = 1, lastifb-firstifb+1
      !
      if (index(tmpbackend,'ABBA').ne.0) then
         ifb = jfb
      else
         ifb = firstifb+irank(jfb)-1
      endif
      !
      fmin = 1.d12
      fmax = 0.d0
      !
      nbd = fb(ifb)%header%febeband
      npix = fb(ifb)%header%febefeed
      nphases = fb(ifb)%header%nphases
      do ibd = 1, nbd
         do i = 1, nrowbackendtable
            if (index(tmpbackend,'CONT').ne.0.or.   &
                index(tmpbackend,'BBC').ne.0.or.   &
                index(tmpbackend,'NBC').ne.0.or.   &
                index(tmpbackend,'ABBA').ne.0) then
               j = i
            else
               j = refchan(i)
            endif
            if (iddump(j,1).eq.ifb.and.iddump(j,2).eq.ibd) exit
         enddo
         ar(ifb)%header(ibd)%channels = chans(i)
         ar(ifb)%header(ibd)%usedchan = used(i)
         ar(ifb)%header(ibd)%dropchan = dropped(i)
         ar(ifb)%header(ibd)%baseband = ibd
         ar(ifb)%header(ibd)%crvl4f_2   &
           = reffreq(i)*1.d6   &
            +ar(ifb)%header(ibd)%restfreq   &
            -fb(ifb)%header%ifcenter
         aux = spacing(i)*1.e6
         ar(ifb)%header(ibd)%cd4f_21 = aux
         ar(ifb)%header(ibd)%bandwid = abs(used(i)*aux)
         !
         if (index(tmpbackend,'4MHZ').ne.0.or.   &
             index(tmpbackend,'1MHZ').ne.0.or.   &
             index(tmpbackend,'100K').ne.0.or.   &
             index(tmpbackend,'BBC').ne.0.or.   &
             index(tmpbackend,'NBC').ne.0.or.   &
             index(tmpbackend,'CONT').ne.0) then
            ar(ifb)%header(ibd)%freqres = ar(ifb)%header(ibd)%cd4f_21
         else               ! for parabolic apodization (Welch window)
            ar(ifb)%header(ibd)%freqres   &
              = 1.59*ar(ifb)%header(ibd)%cd4f_21
         endif
         ar(ifb)%header(ibd)%cd4r_21   &
           = -ar(ifb)%header(ibd)%cd4f_21*clight   &
           /ar(ifb)%header(ibd)%restfreq
         ar(ifb)%header(ibd)%cuni4f_2 = 'Hz'
         ar(ifb)%header(ibd)%cuni4r_2 = 'km/s'
         !
         ar(ifb)%header(ibd)%vsou4r_2 = velosys
         ar(ifb)%header(ibd)%spec4r_2 = specsys
         !
         ar(ifb)%header(ibd)%crvl4r_2   &
           = -(reffreq(i)*1.d6-fb(ifb)%header%ifcenter)   &
              /ar(ifb)%header(ibd)%restfreq*clight+velosys
         ar(ifb)%header(ibd)%crpx4f_2 = 1
         ar(ifb)%header(ibd)%crpx4r_2 = 1
         !
         if (ar(ifb)%header(ibd)%cd4f_21.gt.0) then
            f1 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(1+ar(ifb)%header(ibd)%dropchan   &
                   -ar(ifb)%header(ibd)%crpx4f_2)   &
                *ar(ifb)%header(ibd)%cd4f_21
            f2 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(ar(ifb)%header(ibd)%dropchan+used(i)   &
                 -ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
         else
            f2 = ar(ifb)%header(ibd)%crvl4f_2   &
                +(1+ar(ifb)%header(ibd)%dropchan   &
                   -ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
            f1 = ar(ifb)%header(ibd)%crvl4f_2   &
                 +(ar(ifb)%header(ibd)%dropchan   &
                   +used(i)-ar(ifb)%header(ibd)%crpx4f_2)   &
                 *ar(ifb)%header(ibd)%cd4f_21
         endif
         fmin = min(fmin,f1)
         fmax = max(fmax,f2)
         !
         nchan = ar(ifb)%header(ibd)%channels
         allocate(   &
           ar(ifb)%data(ibd)%mjd(nrecords*nphases),   &
           ar(ifb)%data(ibd)%integtim(nrecords*nphases),   &
           ar(ifb)%data(ibd)%iswitch(nrecords,nphases),   &
           ar(ifb)%data(ibd)%data(npix,nchan,nrecords,nphases),   &
           stat=ier)
      !
      enddo
      !
      if (index(tmpbackend,'100K').ne.0) then
         if (ar(ifb)%header(1)%channels.eq.256) then
            dt(ifb)%header%channels = 253
         else
            dt(ifb)%header%channels = ar(ifb)%header(1)%channels
         endif
      else if (index(tmpbackend,'ABBA').ne.0) then
         dt(ifb)%header%channels = 1
      else
         dt(ifb)%header%channels   &
           = (fmax-fmin)/abs(ar(ifb)%header(1)%cd4f_21)+1
      endif
      !
      if (index(tmpscantype,'CAL') /= 0 ) then
         gn(ifb)%febe = fb(ifb)%header%febe
         mxchan = 0
         do ibd = 1, nbd
            nchan = ar(ifb)%header(ibd)%channels
            mxchan = max(mxchan,nchan)
         enddo

         call sic_get_logi('calByChannel',calbychannel,error)
         if (calbychannel) then
            call sic_get_inte('ncalchan',ncalchan,error)
            nxchan = ceiling(mxchan/float(ncalchan))
         else
            nxchan = 1
         endif

         allocate(gn(ifb)%crvl4f_2(nbd),                    &
                  gn(ifb)%channels(nbd),                    &
                  gn(ifb)%cd4f_21(nbd),                     &
                  stat=ier)
         allocate(gn(ifb)%tauzen(nbd,npix,nxchan),          &
                  gn(ifb)%tauzenimage(nbd,npix,nxchan),     &
                  gn(ifb)%tauzendry(nbd,npix,nxchan),       &
                  gn(ifb)%tauzenimagedry(nbd,npix,nxchan),  &
                  gn(ifb)%tauzenwet(nbd,npix,nxchan),       &
                  gn(ifb)%tauzenimagewet(nbd,npix,nxchan),  &
                  gn(ifb)%tatms(nbd,npix,nxchan),           &
                  gn(ifb)%tatmi(nbd,npix,nxchan),           &
                  gn(ifb)%temis(nbd,npix,nxchan),           &
                  gn(ifb)%temii(nbd,npix,nxchan),           &
                  gn(ifb)%tcal(nbd,npix,nxchan),            &
                  gn(ifb)%trx(nbd,npix,nxchan),             &
                  gn(ifb)%tsys(nbd,npix,nxchan),            &
                  gn(ifb)%h2omm(nbd,npix,nxchan),           &
                  stat=ier)
         allocate(gn(ifb)%gainarray(nbd,npix,mxchan),       &
                  gn(ifb)%gainimage(nbd,npix,mxchan),       &
                  gn(ifb)%psky(nbd,npix,mxchan),            &
                  gn(ifb)%phot(nbd,npix,mxchan),            &
                  gn(ifb)%pcold(nbd,npix,mxchan),           &
                  gn(ifb)%phasearray(nbd,npix,mxchan),      &
                  gn(ifb)%pgrid(nbd,npix,mxchan),           &
                  stat=ier)
         gn(ifb)%tsys = -1.
         gn(ifb)%trx  = -1.
         gn(ifb)%tcal = -1.
         gn(ifb)%gainimage(:,:,:)  = 0.0d0
         gn(ifb)%phasearray(:,:,:) = 0.0d0
         if (index(tmpswitchmode,'FREQ').ne.0) then
            allocate(gn(ifb+nfb)%crvl4f_2(nbd),                   &
                     gn(ifb+nfb)%channels(nbd),                   &
                     gn(ifb+nfb)%cd4f_21(nbd),                    &
                     stat=ier)
            allocate(gn(ifb+nfb)%tauzen(nbd,npix,nxchan),         &
                     gn(ifb+nfb)%tauzenimage(nbd,npix,nxchan),    &
                     gn(ifb+nfb)%tauzendry(nbd,npix,nxchan),      &
                     gn(ifb+nfb)%tauzenimagedry(nbd,npix,nxchan), &
                     gn(ifb+nfb)%tauzenwet(nbd,npix,nxchan),      &
                     gn(ifb+nfb)%tauzenimagewet(nbd,npix,nxchan), &
                     gn(ifb+nfb)%tatms(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%tatmi(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%temis(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%temii(nbd,npix,nxchan),          &
                     gn(ifb+nfb)%tcal(nbd,npix,nxchan),           &
                     gn(ifb+nfb)%trx(nbd,npix,nxchan),            &
                     gn(ifb+nfb)%tsys(nbd,npix,nxchan),           &
                     gn(ifb+nfb)%h2omm(nbd,npix,nxchan),          &
                     stat=ier)
            allocate(gn(ifb+nfb)%gainarray(nbd,npix,mxchan),      &
                     gn(ifb+nfb)%gainimage(nbd,npix,mxchan),      &
                     gn(ifb+nfb)%psky(nbd,npix,mxchan),           &
                     gn(ifb+nfb)%phot(nbd,npix,mxchan),           &
                     gn(ifb+nfb)%pcold(nbd,npix,mxchan),          &
                     gn(ifb+nfb)%phasearray(nbd,npix,mxchan),     &
                     gn(ifb+nfb)%pgrid(nbd,npix,mxchan),          &
                     stat=ier)
            gn(ifb+nfb)%tsys = -1.
            gn(ifb+nfb)%trx  = -1.
            gn(ifb+nfb)%tcal = -1.
            gn(ifb+nfb)%gainimage(:,:,:)  = 0.0d0
            gn(ifb+nfb)%phasearray(:,:,:) = 0.0d0
         endif
         !
         !
         do ibd = 1, fb(ifb)%header%febeband
            gn(ifb)%crvl4f_2(ibd) = ar(ifb)%header(ibd)%crvl4f_2
            gn(ifb)%channels(ibd) = ar(ifb)%header(ibd)%channels
            gn(ifb)%cd4f_21(ibd) = ar(ifb)%header(ibd)%cd4f_21
            if (index(tmpswitchmode,'FREQ').ne.0) then
               gn(ifb+nfb)%crvl4f_2(ibd) = ar(ifb)%header(ibd)%crvl4f_2
               gn(ifb+nfb)%channels(ibd) = ar(ifb)%header(ibd)%channels
               gn(ifb+nfb)%cd4f_21(ibd) = ar(ifb)%header(ibd)%cd4f_21
            endif
         enddo
      !
      endif
      dt(ifb)%header%scannum = sc%header%scannum
      dt(ifb)%header%obsnum = currentindex
      dt(ifb)%header%date_obs = fb(ifb)%header%date_obs
      dt(ifb)%header%lst = sc%header%lst
      !
      allocate(dt(ifb)%data%integnum(nrecords),   &
               dt(ifb)%data%subscan(nrecords),   &
               stat=ier)
   !
   enddo
   !
   !
   i1 = 0
   i2 = 0
   subscanloop: do i = subscanRange(1), subscanRange(2) 
      j = idxstart+idxbackend+(i-1)*next
      call ftmahd(unit,j,hdutype,status)
      !
      call ftgcno(unit,.false.,'MJD',idcol_mjd,status)
      if (index(tmpbackend,'ABBA').eq.0)   &
        call ftgcno(unit,.false.,'INTEGTIM',idcol_integtim,status)
      call ftgcno(unit,.false.,'ISWITCH',idcol_iswitch,status)
      call ftgcno(unit,.false.,'DATA',idcol_data,status)
      !
      if (status /= 0) then
         call cfitsio_errormsg(status)
         error = .true.
         status = 0
         call ftclos(unit,status)
         call ftfiou(-1,status)
         return
      endif
      call ftgkyj(unit,'NAXIS2',idump,comment,status)
      call ftgkyj(unit,'NPHASES',nphases,comment,status)
      fb(firstifb:lastifb)%header%nphases = nphases
      ndump = nphases*int(idump/nphases)
      dumploop: do k = 1, ndump, nphases
         i1 = i1+1
         do ifb = firstifb, lastifb
            dt(ifb)%data%integnum(i1) = i1
            dt(ifb)%data%subscan(i1) = i
         enddo
         phaseloop: do l = 1, nphases
            irow = k+l-1
            i2 = i2+1
            call ftgcfd(unit,idcol_mjd,irow,1,1,pmjd,   &
              flagscalar,anynull,status)
            !
            if (index(tmpbackend,'ABBA').eq.0)   &
              call ftgcfd(unit,idcol_integtim,irow,1,1,pintegtim,   &
                          flagscalar,anynull,status)
            call ftgcfj(unit,idcol_iswitch,irow,1,1,pswitch,   &
                        flagscalar,anynull,status)
            if (index(dataformat,'J').ne.0) then
               call ftgcfj(unit,idcol_data,irow,1,allchannels,   &
                 intdata,flagvals,anynull,status)
            else if (index(dataformat,'E').ne.0) then
               call ftgcfe(unit,idcol_data,irow,1,allchannels,   &
                 realdata,flagvals,anynull,status)
            else if (index(dataformat,'D').ne.0) then
               call ftgcfd(unit,idcol_data,irow,1,allchannels,   &
                 doubledata,flagvals,anynull,status)
            endif
            do m = 1, allchannels
               ifb = iddump(m,1)
               ibd = iddump(m,2)
               ipix = iddump(m,3)
               ichan = iddump(m,4)
               if (index(dataformat,'J').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = intdata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = intdata(m)
                  endif
               else if (index(dataformat,'E').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = realdata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = realdata(m)
                  endif
               else if (index(dataformat,'D').ne.0) then
                  if (polmode) then
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = doubledata(m)*iddump(m,5)
                  else
                     ar(ifb)%data(ibd)%data(ipix,ichan,i1,l)   &
                       = doubledata(m)
                  endif
               endif
            enddo
            do ifb = firstifb, lastifb
               do ibd = 1, fb(ifb)%header%febeband
                  ar(ifb)%data(ibd)%mjd(i2) = pmjd
                  ar(ifb)%data(ibd)%integtim(i2) = pintegtim
               enddo
            enddo
            if ((subscantrace(i).eq.1.and.nphases.gt.1)   &
              .or.   &
              index(tmpscantype,'POINT').ne.0   &
              .or.   &
              index(tmpscantype,'FOCUS').ne.0   &
              ) then
               if (index(fb(firstifb)%header%swtchmod,'beam')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'SKY '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'LOAD'
                  endif
               else if (index(fb(firstifb)%header%swtchmod,'wob')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'ON  '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'OFF '
                  endif
               endif
            else if (subscantrace(i).eq.0.and.nphases.gt.1) then
               if (index(fb(firstifb)%header%swtchmod,'beam')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'SKY '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'LOAD'
                  endif
               else if (index(fb(firstifb)%header%swtchmod,'wob')   &
                 .ne.0) then
                  if (pswitch.eq.1.or.pswitch.eq.3) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'OFF '
                  else if (pswitch.eq.2.or.pswitch.eq.4) then
                     ar(firstifb)%data(1)%iswitch(i1,l) = 'ON  '
                  endif
               endif
            endif
            if (index(fb(firstifb)%header%swtchmod,'freq').ne.0) then
               if (pswitch.eq.1) then
                  ar(firstifb)%data(1)%iswitch(i1,l) = 'FLO'
               else if (pswitch.eq.2) then
                  ar(firstifb)%data(1)%iswitch(i1,l) = 'FHI'
               endif
            endif
            do ifb = firstifb, lastifb
               do ibd = 1, fb(ifb)%header%febeband
                  ar(ifb)%data(ibd)%iswitch(i1,l)   &
                    = ar(firstifb)%data(1)%iswitch(i1,l)
               enddo
            enddo
         enddo phaseloop
      enddo dumploop
   enddo subscanloop
   !
   if (stepcompress.ne.0) then
      dumptime   &
        = sum(ar(firstifb)%data(1)%integtim(:))/(nrecords*nphases)
      nbin = int(stepcompress/dumptime)
      dumptime = dumptime*nbin
      write(string,'(f6.3)') dumptime
      if (nbin.eq.0) then
         call gagout('I-GET: compression timestep too short,'   &
                   //' nothing changed.')
         nbin = 1
      endif
      if (abs(dumptime-stepcompress).gt.0.01)   &
        call gagout('I-GET: dump time rounded to '   &
                   //string//' s.')
      nrecnew = int(nrecords/nbin)
      allocate(   &
        tmpsubscan(nrecnew),   &
        artmp%mjd(nrecnew*nphases),   &
        artmp%integtim(nrecnew*nphases),   &
        artmp%iswitch(nrecnew,nphases),   &
        artmp%data(npix,nchan,nrecnew,nphases),   &
        stat=ier   &
        )
      allocate(compressmask(nbin),stat=ier)
      fbloop: do ifb = firstifb, lastifb
         bdloop: do ibd = 1, fb(ifb)%header%febeband
            i2 = 0
            i4 = 0
            i6 = 0
            recloop: do j = 1, nrecnew
               i1 = i2+1
               i2 = i2+nbin
               if (ibd.eq.1) tmpsubscan(j) = dt(ifb)%data%subscan(i1)
               i3 = i4+1
               i4 = i4+nbin*nphases
               i5 = i6+1
               i6 = i6+nphases
               do ipix = 1, npix
                  do ichan = 1, nchan
                     do iph = 1, nphases
                        compressmask   &
                          =ar(ifb)%data(ibd)%data(ipix,ichan,i1:i2,iph)   &
                          .ne.blankingraw
                        artmp%data(ipix,ichan,j,iph)   &
                          = sum(   &
                          ar(ifb)%data(ibd)%data(ipix,ichan,i1:i2,iph),   &
                          compressmask)/count(compressmask)
                     enddo
                  enddo
               enddo
               if (ifb.eq.firstifb.and.ibd.eq.1) then
                  do k = 1, nphases
                     artmp%mjd(i5+k-1)   &
                       = ar(ifb)%data(ibd)%mjd(i4+1-k)
                     artmp%integtim(i5+k-1)   &
                       = sum(ar(ifb)%data(ibd)%integtim(i3:i4))
                  enddo
                  artmp%iswitch(j,:)= ar(ifb)%data(ibd)%iswitch(i1,:)
               endif
            enddo recloop
            deallocate(ar(ifb)%data(ibd)%mjd,   &
                       ar(ifb)%data(ibd)%integtim,   &
                       ar(ifb)%data(ibd)%iswitch,   &
                       ar(ifb)%data(ibd)%data,   &
                       stat=ier)
            allocate(   &
              ar(ifb)%data(ibd)%mjd(nrecnew*nphases),   &
              ar(ifb)%data(ibd)%integtim(nrecnew*nphases),   &
              ar(ifb)%data(ibd)%iswitch(nrecnew,nphases),   &
              ar(ifb)%data(ibd)%data(npix,nchan,nrecnew,nphases),   &
              stat=ier)
            ar(ifb)%data(ibd)%mjd = artmp%mjd(:)
            ar(ifb)%data(ibd)%integtim = artmp%integtim(:)
            ar(ifb)%data(ibd)%iswitch = artmp%iswitch(:,:)
            ar(ifb)%data(ibd)%data = artmp%data(:,:,:,:)
         enddo bdloop
         deallocate(dt(ifb)%data%integnum,dt(ifb)%data%subscan,   &
           stat=ier)
         allocate(dt(ifb)%data%integnum(nrecnew),   &
                  dt(ifb)%data%subscan(nrecnew),   &
                  stat=ier)
         dt(ifb)%data%subscan = tmpsubscan(:)
         do j = 1, nrecnew
            dt(ifb)%data%integnum(j) = j
         enddo
      enddo fbloop
      deallocate(tmpsubscan,stat=ier)
      deallocate(artmp%data,artmp%iswitch,artmp%integtim,   &
                 artmp%mjd,stat=ier)
      deallocate(compressmask,stat=ier)
      nrecords = nrecnew
   endif
   !
   do i = subscanRange(1), subscanRange(2)
      i1 = i-subscanRange(1)+1
      if (raw(i1)%backend(firstifb)%subscanend   &
        .eq.raw(i1)%backend(firstifb)%subscanstart) then
         nphases = fb(firstifb)%header%nphases
         j = maxval(dt(firstifb)%data%integnum,   &
           dt(firstifb)%data%subscan.eq.i)
         raw(i1)%backend(firstifb)%subscanend   &
           = ar(firstifb)%data(1)%mjd(j*nphases)
      endif
   enddo
   !
   do ifb = firstifb, lastifb
      !
      allocate(dt(ifb)%data%nints(nrecords),   &
               dt(ifb)%data%lst(nrecords),   &
               dt(ifb)%data%longoff(nrecords),   &
               dt(ifb)%data%latoff(nrecords),   &
               dt(ifb)%data%azimuth(nrecords),   &
               dt(ifb)%data%elevatio(nrecords),   &
               dt(ifb)%data%cbaslong(nrecords),   &
               dt(ifb)%data%cbaslat(nrecords),   &
               dt(ifb)%data%baslong(nrecords),   &
               dt(ifb)%data%baslat(nrecords),   &
               dt(ifb)%data%parangle(nrecords),   &
               dt(ifb)%data%pc_11(nrecords),   &
               dt(ifb)%data%pc_12(nrecords),   &
               dt(ifb)%data%pc_21(nrecords),   &
               dt(ifb)%data%pc_22(nrecords),   &
               dt(ifb)%data%cr4k1(nrecords),   &
               dt(ifb)%data%cr4k2(nrecords),   &
               dt(ifb)%data%mcrval1(nrecords),   &
               dt(ifb)%data%mcrval2(nrecords),   &
               dt(ifb)%data%mlonpole(nrecords),   &
               dt(ifb)%data%mlatpole(nrecords),   &
               dt(ifb)%data%mjd(nrecords),   &
               dt(ifb)%data%midtime(nrecords),   &
               dt(ifb)%data%integtim(nrecords),   &
               dt(ifb)%data%dfocus_x_y_z(nrecords,3),   &
               dt(ifb)%data%focus_x_y_z(nrecords,3),   &
               dt(ifb)%data%dphi_x_y_z(nrecords,3),   &
               dt(ifb)%data%phi_x_y_z(nrecords,3),   &
               stat=ier)
      !
      nchan = dt(ifb)%header%channels
      npix = fb(ifb)%header%febefeed
      allocate(dt(ifb)%data%otfdata(npix,nchan,nrecords),   &
               dt(ifb)%data%rdata(npix,nchan),   &
               stat=ier)
      !
      dt(ifb)%data%longoff(1:nrecords) = 0
      dt(ifb)%data%latoff(1:nrecords) = 0
      dt(ifb)%data%nints(1:nrecords) = tracerate
      dt(ifb)%header%febe = fb(ifb)%header%febe
   enddo
   !
   !
   do ifb = firstifb, lastifb
      nphases = fb(ifb)%header%nphases
      do i = 1, nrecords
         dt(ifb)%data%mjd(i)   &
           = ar(ifb)%data(1)%mjd(i*nphases)
         dt(ifb)%data%midtime(i)   &
           = 0.5*(   &
                  dt(ifb)%data%mjd(i)   &
                  +ar(ifb)%data(1)%mjd((i-1)*nphases+1)   &
                  -sec2day*ar(ifb)%data(1)%integtim((i-1)*nphases+1)   &
                 )
         dt(ifb)%data%integtim(i)   &
           = sum(   &
                 ar(ifb)%data(1)%integtim((i-1)*nphases+1:i*nphases)   &
                )
      enddo
   enddo
   !
   !
   do ifb = firstifb, lastifb
      nbd = fb(ifb)%header%febeband
      if (stepcompress.ne.0) then
         nphases = fb(ifb)%header%nphases
         dt(ifb)%data%integtim = dt(ifb)%data%integtim(:)/nphases
         do ibd = 1, nbd
            ar(ifb)%data(ibd)%integtim   &
              = ar(ifb)%data(ibd)%integtim(:)/nphases
         enddo
      endif
      if (fb(ifb)%header%nphases.eq.1.and.   &
        index(tmpscantype,'CAL').eq.0) then
         do iobs = subscanRange(1), subscanRange(2)
            i1 = iobs-subscanRange(1)+1
            do i = 1, nbd
               do j = 1, nrecords
                  if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.0) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'ON  '
                  else if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.1) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'OFF '
                  else if (dt(ifb)%data%subscan(j).eq.iobs.and.   &
                    subscantrace(i1).eq.2) then
                     ar(ifb)%data(i)%iswitch(j,1) = 'NONE'
                  endif
               enddo
            enddo
         enddo
      endif
   enddo
   !
   !
   if (index(tmpscantype,'CAL') /= 0) then
      !
      do ifb = firstifb, lastifb
         nbd = fb(ifb)%header%febeband
         do iobs = subscanRange(1), subscanRange(2)
            !
            i1 = iobs-subscanRange(1)+1
            if (index(raw(i1)%antenna(ifb)%subscantype,'Sky').ne.0)   &
              then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'S'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'S'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'SKY '
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,   &
              'Ambient').ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'H'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'H'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'HOT '
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,'Cold')   &
              .ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'C'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'C'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'COLD'
                        endif
                     endif
                  enddo
               enddo
            else if (index(raw(i1)%antenna(ifb)%subscantype,'Grid')   &
              .ne.0) then
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'G'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'G'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'GRID'
                        endif
                     endif
                  enddo
               enddo
            else
               do i = 1, nbd
                  do j = 1, nrecords
                     if (dt(ifb)%data%subscan(j).eq.iobs) then
                        if (index(fb(firstifb)%header%swtchmod,'freq')   &
                          .ne.0) then
                           ar(ifb)%data(i)%iswitch(j,1)   &
                             = 'N'//ar(ifb)%data(i)%iswitch(j,1)
                           ar(ifb)%data(i)%iswitch(j,2)   &
                             = 'N'//ar(ifb)%data(i)%iswitch(j,2)
                        else
                           ar(ifb)%data(i)%iswitch(j,1) = 'NONE'
                        endif
                     endif
                  enddo
               enddo
            endif
         enddo
      !
      enddo
   !
   endif
   !
   !
   if (lastifb.eq.nfb) then
      !
      ! check completeness of subscans
      !
      if (fb(nfb)%header%nphases.eq.1.and.                        &
          count(ar(nfb)%data(1)%iswitch(:,1).eq.'OFF ').eq.0.and. &
          index(tmpscantype,'CAL').eq.0)                          &
         call gagout('W-GET: total power data without sky reference')
      !
      prim  => pr
      scan  => sc
      febe  => fb
      if (cryoextension) then
         cryo  => crx
      else
         cryo => null()
      endif
      if (derotextension) then
         derot => drt
      else
         derot => null()
      endif
   endif
   !
   call ftclos(unit,status)
   call ftfiou(-1,status)
   !
   !
   tmpscantype = sc%header%scantype
   call sic_upper(tmpscantype)
   if (status /= 0) then
      call cfitsio_errormsg(status)
      error = .true.
      return
   else if (lastifb.eq.nfb) then
      if (allocated(newpar)) then 
         if (overrideFlag(1).or.overrideFlag(2)) then
            do ifb = 1, nfb
               if (size(mnt(ifb)%data%thotcold).eq.   &
                   size(newpar(ifb)%thotcold)) then
                  mnt(ifb)%data%thotcold = newpar(ifb)%thotcold
               else
                  call gagout('W-GET: shapes of THOTCOLD do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(6).or.overrideflag(7)) then
            do ifb = 1, nfb
               if (size(mnt(ifb)%data%tamb_p_humid).eq.   &
                   size(newpar(ifb)%tamb_p_humid)) then
                  mnt(ifb)%data%tamb_p_humid = newpar(ifb)%tamb_p_humid
               else
                  call gagout('W-GET: shapes of TAMB_P_HUMID do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(3)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%etafss).eq.   &
                   size(newpar(ifb)%etafss)) then
                  fb(ifb)%data%etafss = newpar(ifb)%etafss
               else
                  call gagout('W-GET: shapes of ETAFSS do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(4)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%beameff).eq.   &
                   size(newpar(ifb)%beameff)) then
                  fb(ifb)%data%beameff = newpar(ifb)%beameff
               else
                  call gagout('W-GET: shapes of BEAMEFF do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
         if (overrideflag(5)) then
            do ifb = 1, nfb
               if (size(fb(ifb)%data%gainimag).eq.   &
                   size(newpar(ifb)%gainimag)) then
                  fb(ifb)%data%gainimag = newpar(ifb)%gainimag
               else
                  call gagout('W-GET: shapes of GAINIMAG do not conform.')
                  call gagout('       Calibration parameters unchanged.')
               endif
            enddo
         endif
      endif 
      call sic_get_logi('timingCheck',timingcheck,error)
      call sic_get_logi('traceExtrapolation',traceExtrapolation,error)
      if (timingCheck) then
         do ifb = 1, nfb
            call syncData(ifb,nfb,subscanRange,error)
         enddo
      else
         do ifb = 1, nfb
            call syncDataNew(ifb,nfb,subscanRange,error)
         enddo
      endif
      !
      data => databuf
      array => arraybuf
      mon => monbuf
      !
      if (index(tmpscantype,'CAL') /= 0 ) gains => gn
      !
      do i = 1, size(dt)
         call freedata(dt(i)%data,error)
      enddo
      deallocate(dt,stat=ier)
      !
      do i = 1, size(ar)
         do j = 1, size(ar(i)%header)
            call freearray(ar(i)%data(j),error)
         enddo
         deallocate(ar(i)%header, ar(i)%data,stat =ier)
      enddo
      deallocate(ar,stat=ier)
      !
      do i = 1, size(mnt)
         call freemon(mnt(i)%data,error)
      enddo
      deallocate(mnt,stat=ier)
      !
      nosky = .false.
      nrecords = size(array(1)%data(1)%iswitch,1)
      call computeoffset(nfb,noffset,nrecords,sysoff,tmpscantype,   &
        tmpswitchmode,nosky,error)
      if (error) return
      !
      ! check completeness of calibration scans
      !
      if (index(tmpscantype,'CAL').ne.0) then
         if (nsubscan.eq.1.or.  &
             (nsubscan.eq.2.and..not.nosky)) then
            call gagout('E-GET: incomplete calibration')
            error = .true.
            return
         endif
      endif
      !
      !
      if (nosky.and.index(tmpscantype,'CAL').ne.0.and.   &
        .not.polmode.and.maxval(data(1)%data%subscan).eq.4) then
         scan%header%scantype = 'calibImage'
         tmpscantype = 'CALIBIMAGE'
         if (.not.allocated(igains)) then
            allocate(igains(nfb),stat=ier)
            do ifb=1, nfb
               mxchan=0
               igains(ifb)%febe = febe(ifb)%header%febe
               nbd = febe(ifb)%header%febeband
               npix = febe(ifb)%header%febefeed
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%channels
                  mxchan = max(nchan,mxchan)
               enddo
               allocate(igains(ifb)%gainimage(nbd,npix,mxchan),   &
                 stat=ier)
               igains(ifb)%gainimage = 0.d0
            enddo
         endif
         if (index(raw(1)%antenna(firstifb)%sbcalrec,'UNKNOWN').ne.0)   &
           then
            call gagout('W-GET: receiver for image gain calibration '   &
                      //'unknown.')
         else
            call gagout('I-GET: image gain calibration for '//   &
                        trim(raw(1)%antenna(firstifb)%sbcalrec)//'.')
         endif
         call gagout(' ')
         call gagout('Fe/Be          Pixel    gainImage')
         do ifb = 1, nfb
            tmpfrontend = febe(ifb)%header%febe
            call sic_upper(tmpfrontend)
            if (index(tmpfrontend,trim(raw(1)%antenna(ifb)%sbcalrec))   &
              .eq.0.and.   &
              index(raw(1)%antenna(ifb)%sbcalrec,'UNKNOWN')   &
              .eq.0) cycle
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               gainimage = 0.
               photimagemean = 0.
               pcoldimagemean = 0.
               do ibd = 1, nbd
                  pcoldimage = 0.
                  pcoldsignal = 0.
                  photimage = 0.
                  photsignal = 0.
                  do ichan = array(ifb)%header(ibd)%dropchan+1,   &
                       array(ifb)%header(ibd)%dropchan   &
                       +array(ifb)%header(ibd)%usedchan
                     !
                     pcoldsignalnew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')   &
                       /count(data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')
                     pcoldimagenew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')   &
                       /count(data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'COLD')
                     photsignalnew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')   &
                       /count(data(ifb)%data%subscan(:).le.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')
                     photimagenew = sum(   &
                       array(ifb)%data(ibd)%data(ipix,ichan,:,1),   &
                       data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')   &
                       /count(data(ifb)%data%subscan(:).gt.2.and.   &
                       array(ifb)%data(ibd)%iswitch(:,1).eq.'HOT')
                     igains(ifb)%gainimage(ibd,ipix,ichan)   &
                       = (photimagenew-pcoldimagenew)   &
                       /(photsignalnew-pcoldsignalnew)
                     !
                     ! comment the following two lines in for new backends
                     !                         if (gains(ifb)%gainimage(ibd,ipix,ichan).ne.0)
                     !     &                   calByChannel = .true.
                     photimage   = photimage+photimagenew
                     pcoldimage  = pcoldimage+pcoldimagenew
                     photsignal  = photsignal+photsignalnew
                     pcoldsignal = pcoldsignal+pcoldsignalnew
                  enddo
                  photimagemean = photimagemean+photimage   &
                    /array(ifb)%header(ibd)%usedchan
                  pcoldimagemean = pcoldimagemean+pcoldimage   &
                    /array(ifb)%header(ibd)%usedchan
                  gainimage = gainimage+(photimage-pcoldimage)   &
                    /(photsignal-pcoldsignal)   &
                    /array(ifb)%header(ibd)%usedchan
               enddo
               gainimage = gainimage/nbd
               photimagemean  = photimagemean/nbd
               pcoldimagemean = pcoldimagemean/nbd
               if (photimagemean.le.pcoldimagemean) then
                  gainimage = 0.
                  call gagout('W-GET: image/signal ratio is too '   &
                            //'small to measure and set to zero.')
               endif
               write(message,'(T1,A13,T18,I1,T24,f9.4)')   &
                 febe(ifb)%header%febe(1:13), ipix, gainimage
               call gagout(message)
               write(message,'(T1,A26)') '                          '
               call gagout(message)
               write(message,'(T1,A8,T10,A4,T15,A5,T21,F9.4)')   &
                 'RECEIVER',febe(ifb)%header%febe(1:4),'/GAIN',   &
                 gainimage
               call gagout(message)
            enddo
         enddo
         do ifb = 1, nfb
            gains(ifb)%gainimage = igains(ifb)%gainimage
         enddo
      else if (nosky.and.index(tmpscantype,'CAL').ne.0) then
         call gagout(' ')
         call gagout('Fe/Be       Pixel   Trec [K]')
         do ifb = 1 ,nfb
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               trec = 0
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%usedchan
                  i1 = array(ifb)%header(ibd)%dropchan+1
                  i2 = array(ifb)%header(ibd)%dropchan   &
                      +array(ifb)%header(ibd)%usedchan
                  if (allocated(calmask)) deallocate(calmask)
                  allocate(calmask(i2-i1+1))
                  if (calbychannel) then
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw   &
                       .and.   &
                       gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     do ichan = i1, i2
                        if (calmask(ichan)) then
                           photsignal   &
                             = gains(ifb)%phot(ibd,ipix,ichan)
                           pcoldsignal   &
                             = gains(ifb)%pcold(ibd,ipix,ichan)
                           gains(ifb)%trx(ibd,ipix,ichan)   &
                             =(photsignal*mon(ifb)%data%thotcold(1,2)   &
                             -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                             /(pcoldsignal-photsignal)
                           trec = trec+gains(ifb)%trx(ibd,ipix,ichan)   &
                             /count(calmask)
                        endif
                     enddo
                  else
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw
                     photsignal   &
                       = sum(gains(ifb)%phot(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     calmask   &
                       =gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     pcoldsignal   &
                       = sum(gains(ifb)%pcold(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     gains(ifb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                     trec = trec+gains(ifb)%trx(ibd,ipix,1)
                  endif
               enddo
               trec = trec/nbd
               j = index(febe(ifb)%header%febe,' ')
               tmpbackend = febe(ifb)%header%febe(j+1:j+8)
               write(message,'(T1,A5,T7,A5,T15,i1,T21,f7.2)')   &
                 febe(ifb)%header%febe(1:5), tmpbackend(1:5), ipix,   &
                 trec
               call gagout(message)
            enddo
         enddo
         return
      else if (index(tmpscantype,'CAL').ne.0) then
         do ifb = 1 ,nfb
            nbd = febe(ifb)%header%febeband
            npix = febe(ifb)%header%febefeed
            do ipix = 1, npix
               do ibd = 1, nbd
                  nchan = array(ifb)%header(ibd)%usedchan
                  i1 = array(ifb)%header(ibd)%dropchan+1
                  i2 = array(ifb)%header(ibd)%dropchan   &
                      +array(ifb)%header(ibd)%usedchan
                  if (allocated(calmask)) deallocate(calmask)
                  allocate(calmask(i2-i1+1))
                  if (calbychannel) then
                     calmask   &
                       =gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw   &
                       .and.   &
                       gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     do ichan =  i1, i2
                        if (calmask(ichan)) then
                           photsignal   &
                             = gains(ifb)%phot(ibd,ipix,ichan)
                           pcoldsignal   &
                             = gains(ifb)%pcold(ibd,ipix,ichan)
                           gains(ifb)%trx(ibd,ipix,ichan)   &
                             = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                             -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                             /(pcoldsignal-photsignal)
                        else
                           gains(ifb)%trx(ibd,ipix,ichan) = -1.
                        endif
                     enddo
                  else
                     calmask   &
                       = gains(ifb)%phot(ibd,ipix,i1:i2).ne.blankingraw
                     photsignal   &
                       = sum(gains(ifb)%phot(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     calmask   &
                       =gains(ifb)%pcold(ibd,ipix,i1:i2).ne.blankingraw
                     pcoldsignal   &
                       = sum(gains(ifb)%pcold(ibd,ipix,i1:i2),calmask)   &
                       /count(calmask)
                     gains(ifb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                  endif
                  if (index(tmpswitchmode,'FREQ').ne.0) then
                     calmask = gains(ifb+nfb)%phot(ibd,ipix,i1:i2)   &
                       .ne.blankingraw
                     photsignal = sum(   &
                       gains(ifb+nfb)%phot(ibd,ipix,i1:i2),calmask   &
                       )/count(calmask)
                     calmask = gains(ifb+nfb)%pcold(ibd,ipix,i1:i2)   &
                       .ne.blankingraw
                     pcoldsignal = sum(   &
                       gains(ifb+nfb)%pcold(ibd,ipix,i1:i2),calmask   &
                       )/count(calmask)
                     gains(ifb+nfb)%trx(ibd,ipix,1)   &
                       = (photsignal*mon(ifb)%data%thotcold(1,2)   &
                       -pcoldsignal*mon(ifb)%data%thotcold(1,1))   &
                       /(pcoldsignal-photsignal)
                  endif
               enddo
            enddo
         enddo
      endif
   endif
   !
   if (index(tmpscantype,'CAL').ne.0.and.tmpscantype.ne.'CALIBIMAGE'   &
     .and.lastifb.eq.nfb.and.allocated(igains)) then
      do ifb = 1, nfb
         do jfb = 1, size(igains)
            if (gains(ifb)%febe.eq.igains(jfb)%febe)   &
              gains(ifb)%gainimage = igains(jfb)%gainimage
         enddo
      enddo
   endif
   !
   if (.not.associated(zfocus%sol(1)%x)) then
      do i = firstifb, lastifb
         reduce(i)%focus_done = .false.
      enddo
   else
      do i = firstifb, lastifb
         reduce(i)%focus_done = .true.
      enddo
   endif
   !
   if (.not.associated(pcross(1)%sol%x)) then
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .false.
      enddo
   else
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .true.
      enddo
   endif
   !
   if (index(tmpscantype,'POINT').ne.0) then
      do i = firstifb, lastifb
         reduce(i)%pointing_done = .false.
      enddo
   else if (index(tmpscantype,'FOCUS').ne.0) then
      do i = firstifb, lastifb
         reduce(i)%focus_done = .false.
      enddo
   endif
   !
   do i = firstifb, lastifb
      reduce(i)%calibration_done(1:5) = .false.
      reduce(i)%base_done        = .false.
      reduce(i)%despike_done     = .false.
   enddo
   !
   ! bring polarimetry data into order H,V,R,I
   !
   if (polmode) then
      allocate(febetmp(nfb),arraytmp(nfb),datatmp(nfb),gainstmp(nfb),   &
               antennatmp(nfb),backendtmp(nfb),montmp(nfb),   &
               subreftmp(nfb),reducetmp(nfb),   &
               ifbold(nfb),stat=ier)
      nspec = (lastifb-firstifb+1)/4
      j = 0
      do i = firstifb, lastifb, 4
         i1 = index(febe(i)%header%febe,' ')
         i2 = len_trim(febe(i)%header%febe)
         j = j+1
         febetmp(j)%header%febe = febe(i)%header%febe(i1:i2)
      enddo
      do i = 1, nspec
         do j = 1, 4
            k = (i-1)*4+j
            do ifb = firstifb, lastifb
               if (febe(ifb)%header%febe(1:1).eq.stokes(j).and.   &
                   febe(ifb)%header%febe(i1:i2)   &
                   .eq.febetmp(i)%header%febe   &
                 ) then
                  ifbold(k) = ifb
                  exit
               endif
            enddo
         enddo
      enddo
      datatmp(1:nfb) = data(1:nfb)
      data(1:nfb) = datatmp(ifbold(1:nfb))
      montmp(1:nfb) = mon(1:nfb)
      mon(1:nfb) = montmp(ifbold(1:nfb))
      febetmp(1:nfb) = febe(1:nfb)
      febe(1:nfb) = febetmp(ifbold(1:nfb))
      arraytmp(1:nfb) = array(1:nfb)
      array(1:nfb) = arraytmp(ifbold(1:nfb))
      reducetmp(1:nfb) = reduce(1:nfb)
      reduce(1:nfb) = reducetmp(ifbold(1:nfb))
      do ifb = firstifb, lastifb
         scan%data%febe(ifb) = febe(ifb)%header%febe
      enddo
      if (index(tmpscantype,'GRID').ne.0) then
         gainstmp(1:nfb) = gains(1:nfb)
         gains(1:nfb) = gainstmp(ifbold(1:nfb))
         do i = 1, nspec
            i1 = 4*i
            where (gains(i1-3)%gainarray.ne.blankingraw.and.   &
                   gains(i1-2)%gainarray.ne.blankingraw)
               gains(i1)%gainarray   &
                 = sqrt(gains(i1-3)%gainarray*gains(i1-2)%gainarray)
            elsewhere
               gains(i1)%gainarray = blankingraw
            endwhere
            gains(i1-1)%gainarray = gains(i1)%gainarray
         enddo
      endif
      do i = 1, nsubscan
         antennatmp = raw(i)%antenna(:)
         raw(i)%antenna = antennatmp(ifbold(1:nfb))
         backendtmp = raw(i)%backend(:)
         raw(i)%backend = backendtmp(ifbold(1:nfb))
         subreftmp = raw(i)%subref(:)
         raw(i)%subref = subreftmp(ifbold(1:nfb))
      enddo
      deallocate(febetmp,arraytmp,datatmp,montmp,gainstmp)
      deallocate(antennatmp,backendtmp,subreftmp,reducetmp,   &
                 ifbold,stat=ier)
   endif
   !
   !
   !
10 format(t4,a51)
20 format(t4,a1,t20,i1,t29,a17,t54,a1)
   !
   return
!
end subroutine getfits
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage IMBFITS messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module imbfits_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: imbfits_message_id = gpack_global_id  ! Default value for startup message
  !
end module imbfits_message_private
!
subroutine imbfits_message_set_id(id)
  use imbfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  imbfits_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',imbfits_message_id
  call imbfits_message(seve%d,'imbfits_message_set_id',mess)
  !
end subroutine imbfits_message_set_id
!
subroutine imbfits_message(mkind,procname,message)
  use imbfits_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(imbfits_message_id,mkind,procname,message)
  !
end subroutine imbfits_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_message_debug(doalloc,alloc,doother,other,error)
  use imbfits_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Alter the imbfits specific severities. You can switch them to
  ! seve%d and seve%i only!
  !---------------------------------------------------------------------
  logical,         intent(in)    :: doalloc  !
  integer(kind=4), intent(in)    :: alloc    ! For iseve%alloc
  logical,         intent(in)    :: doother  !
  integer(kind=4), intent(in)    :: other    ! For iseve%other
  logical,         intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MESSAGE>DEBUG'
  !
  if (doalloc) then
    if (alloc.ne.seve%i .and. alloc.ne.seve%d) then
      call imbfits_message(seve%e,rname,  &
        'You can switch the ALLOCATION messages to Info or Debug only')
      error = .true.
      return
    endif
    iseve%alloc = alloc
  endif
  !
  if (doother) then
    if (other.ne.seve%i .and. other.ne.seve%d) then
      call imbfits_message(seve%e,rname,  &
        'You can switch the OTHER messages to Info or Debug only')
      error = .true.
      return
    endif
    iseve%other = other
  endif
  !
end subroutine imbfits_message_debug
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE COMPUTE_MAG(EL,NEL,MAG,SIG_MAG,DELTA_MAG,SIG_DMAG,
     +              COMPUTE_ERRORS,MAG_A,sMAG_A,MAG_B,sMAG_B,ERROR)
* Compute absolute magnitudes from apparent magnitudes and orbital elements
      INTEGER NEL
      REAL*8 EL(NEL)
      REAL MAG,SIG_MAG         ! Apparent magnitude of the pair
      REAL DELTA_MAG,SIG_DMAG  ! Magnitude difference
      REAL MAG_A,sMAG_A,MAG_B,sMAG_B ! Absolute magnitudes and probable errors
      LOGICAL COMPUTE_ERRORS,ERROR
*
      INCLUDE 'constant.inc'
*
      REAL B(MA)
      REAL Orb_Par,dOrb_Par       ! Orbital parallax and probable error
      REAL APPARENT(2),SIG2_APP(2) ! Apparent magnitudes of individual stars
      INCLUDE 'pi.inc'
      INCLUDE 'physical_constants.inc'
*
* Compute apparent magnitude of each of the two stars from their magnitude 
* difference and the apparent magnitude of the pair
*  m(A) = m +2.5 log10(1+10^(-delta_m/2.5))
*  m(B) = m +2.5 log10(1+10^(+delta_m/2.5))
*  dm(A) = dm - 2.5/Log(10)*10^(-delta_m/2.5))/[1+10^(-delta_m/2.5))] *ddelta_m
*  dm(B) = dm + 2.5/Log(10)*10^(+delta_m/2.5))/[1+10^(+delta_m/2.5))] *ddelta_m
      APPARENT(1) = MAG+2.5*LOG10(1+10**(-DELTA_MAG/2.5))
      APPARENT(2) = MAG+2.5*LOG10(1+10**(+DELTA_MAG/2.5))
!         write(6,*) (10**(-DELTA_MAG/2.5))/(1+10**(-DELTA_MAG/2.5)),
!     +        (10**(+DELTA_MAG/2.5))/(1+10**(+DELTA_MAG/2.5))
      SIG2_APP(1) = SIG_MAG**2 +
     +     (2.5/LOG(10.)*(10**(-DELTA_MAG/2.5))
     +     /(1+10**(-DELTA_MAG/2.5)))**2
     +     * (SIG_DMAG)**2
      SIG2_APP(2) = SIG_MAG**2 +
     +     (2.5/LOG(10.)*(10**(+DELTA_MAG/2.5))
     +     /(1+10**(+DELTA_MAG/2.5)))**2
     +     * (SIG_DMAG)**2
!      write(6,'(2(F6.3,F5.3))') mag,sig_mag, delta_mag, sig_dmag
!      Write(6,'(2(F6.3,F5.3))') apparent(1),sqrt(SIG2_APP(1)),
!     +     apparent(2),sqrt(SIG2_APP(2))
* SB2 with known non zero inclination: compute orbital parallax and convert 
* from apparent magnitudes to absolute ones
      IF((EL(ELINDX(IORB0)+I_K1)*EL(ELINDX(IORB0)+I_K2)).NE.0
     +     .AND.SIN(EL(ELINDX(IORB0)+I_i)/GR).NE.0) THEN  
         CALL GRAD_PARALLAX(Orb_Par,B)
         MAG_A = APPARENT(1)+5*LOG10(Orb_Par/0.1)
         MAG_B = APPARENT(2)+5*LOG10(Orb_Par/0.1)
         IF (COMPUTE_ERRORS) THEN
            CALL EVAL_ERROR(dOrb_Par,B)
* dM = dm + 5/LOG(10) dPi/Pi
            sMAG_A = SIG2_APP(1)+(5./LOG(10.)*dOrb_Par/Orb_Par)**2
            sMAG_A = SQRT(sMAG_A)
            sMAG_B = SIG2_APP(2)+(5./LOG(10.)*dOrb_Par/Orb_Par)**2
            sMAG_B = SQRT(sMAG_B)
         ENDIF
      ENDIF

      RETURN
*
! 99   ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE GRAD_MAGNITUDE(EL,PAR,B)
*---------------------------------------------------------------------------
* Orbit:
* Compute an orbital parallax and its gradient relative to the 
* elements
* CAUTION: the gradient routines must NEVER contain the element common, they
* are called with trial elements.
*---------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      REAL*8 EL(MA)
      REAL PAR,B(MA)
*
      INCLUDE 'pi.inc'
      INCLUDE 'physical_constants.inc'
*
      INTEGER I
      REAL SI,CI,CF
*
* Compute sqrt(1-e**2) and trigonometric functions of inclination, which 
* are needed everywhere
      SI=SIN(EL(I_i+ELINDX(IORB0))/GR)
      CI=COS(EL(I_i+ELINDX(IORB0))/GR)
      IF (ABS(EL(I_Ecc+ELINDX(IORB0))).GT.1) THEN
         CF = 0.
      ELSE
         CF=SQRT(1.-EL(I_Ecc+ELINDX(IORB0))**2)
      ENDIF
*
      DO I=1,MA
         B(I)=0
      ENDDO
*
* Return zero rather than NaNs or Inf whenever parameters are undefined
      IF ((EL(I_K1+ELINDX(IORB0))+EL(I_K2+ELINDX(IORB0))).EQ.0
     +     .OR.EL(I_PERIOD+ELINDX(IORB0)).EQ.0
     +     .OR.EL(I_as+ELINDX(IORB0)).EQ.0
     +     .OR.CF.EQ.0
     +     .OR.SI.EQ.0) THEN
         PAR = 0
      ELSE
* First, evaluate the logarithmic gradient
         B(I_PERIOD+ELINDX(IORB0)) = -1/EL(I_PERIOD+ELINDX(IORB0))
         B(I_Ecc+ELINDX(IORB0)) = +EL(I_Ecc+ELINDX(IORB0))/CF**2
         B(I_as+ELINDX(IORB0)) = +1/EL(I_as+ELINDX(IORB0))
         B(I_i+ELINDX(IORB0)) = CI/SI
         B(I_K1+ELINDX(IORB0)) = -1/(EL(I_K1+ELINDX(IORB0))
     +        +El(I_K2+ELINDX(IORB0)))
         B(I_K2+ELINDX(IORB0)) = -1/(EL(I_K1+ELINDX(IORB0))
     +        +El(I_K2+ELINDX(IORB0)))
* Then compute parallax value, and scale the gradient
         PAR=AU*2*PI*SI*EL(I_as+ELINDX(IORB0))
     +        /(((EL(I_K1+ELINDX(IORB0))
     +        +EL(I_K2+ELINDX(IORB0)))*KM_S)*CF*
     +        EL(I_PERIOD+ELINDX(IORB0))*DAY)
         DO I=1,MA
            B(I)=B(I)*PAR
         ENDDO
      ENDIF
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_oldload
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_access_types
  use cubedag_parameters
  use cube_types
  use cubeadm_cubeid_types
  use cubego_messaging
  !  
  public :: cubego_oldload_getcube_number
  public :: cubego_oldload_getcube_pointer
  public :: cubego_oldload_register
  public :: lastloaded,proglist,mprog
  private
  !
  type :: oldload_comm_t
     type(option_t),      pointer :: oldload
     type(cubeid_arg_t),  pointer :: cube
     type(option_t),      pointer :: in
     type(keywordlist_comm_t), pointer :: in_arg
     type(option_t),      pointer :: syntax
     type(keywordlist_comm_t), pointer :: syntax_arg
     type(order_comm_t)           :: access
  end type oldload_comm_t
  type(oldload_comm_t) :: comm
  !
  type uservar_t
     character(len=varn_l) :: name = 'AAA1'
     character(len=varn_l) :: status = 'READ' ! READonly by default
  end type uservar_t
  type progvar_t
     character(len=varn_l) :: name = 'AAA1'
     logical :: readonly = .true.
  end type progvar_t
  !
  type oldload_user_t
     type(cubeid_user_t) :: incube
     type(uservar_t)     :: var
     character(len=4)    :: syntax = 'HEAD'
     type(order_user_t)  :: access
  end type oldload_user_t
  !
  type oldload_prog_t
     integer(kind=iden_l)  :: id
     character(len=base_l) :: name
     logical               :: used=.false.
     type(progvar_t)       :: var
     type(cube_t), pointer :: cube
     logical               :: dohead=.true.
     type(order_prog_t)    :: access
  end type oldload_prog_t
  !
  type(oldload_user_t) :: user
  integer(kind=4), parameter :: mprog=16  ! Maximum number of cubes LOADed at a time
  type(oldload_prog_t), target :: proglist(mprog)
  integer(kind=4) :: lastloaded = 0
  !
contains
  !
  subroutine cubego_oldload_register(error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! Register GO\OLDLOAD command and its options
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t) :: keyarg
    !
    character(len=*), parameter :: readwrite(2) = ['READ ','WRITE']
    character(len=*), parameter :: syntaxes(2)  = ['HEAD','HGDF']
    character(len=*), parameter :: rname='OLDLOAD>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'OLDLOAD','[cubeid]',&
         'Load a cube onto a sic variable',&
         'Load a cube into a SIC variable through the legacy OLDLOAD&
         & path. By default, it creates read-only variable AAA1 with&
         & image access and the new header mapping. Use /SYNTAX HGDF&
         & only for compatibility workflows.',&
         cubego_oldload_command,&
         comm%oldload,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Identity of the cube to be loaded',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset_or_speset,&
         comm%cube,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'IN','varname status',&
         'Define the name of the SIC variable',&
         'The option can also be used to modify the read-write status&
         & of the SIC variable',&
         comm%in,error)
    if (error) return
    call stdarg%register(&
         'varname',&
         'Name of the variable onto which to load data',&
         strg_emp,&
         code_arg_mandatory,&
         error)
    if (error) return
    call keyarg%register(&
         'status',&
         'Variable access status',&
         'Default is READ',&
         code_arg_optional,&
         readwrite,&
         .not.flexible,&
         comm%in_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'SYNTAX','type',&
         'Define the type of structure of the SIC variable',&
         'HEAD (default if options is not present) means the new CUBE&
         & header, HGDF means the classic GREG header',&
         comm%syntax,error)
    if (error) return
    call keyarg%register(&
         'type',&
         'SIC structure syntax type',&
         strg_emp,&
         code_arg_mandatory,&
         syntaxes,&
         .not.flexible,&
         comm%syntax_arg,&
         error)
    if (error) return
    !
    call comm%access%register(&
         'ACCESS',&
         'Define the access type of the loaded cube',&
         'If Access is IMAGE, command GO\GET will fetch images, if&
         & access is SPECTRUM, command GO\GET will fetch spectra',&
         error)
    if (error) return
  end subroutine cubego_oldload_register
  !
  subroutine cubego_oldload_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command OLDLOAD
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: iprog
    character(len=*), parameter :: rname='OLDLOAD>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubego_oldload_sicdef(.false.,error)
    if (error) return
    call cubego_oldload_parse(line,user,error)
    if (error) return
    call cubego_oldload_getslot(user%var%name,proglist,iprog,error)
    if (error) return
    call cubego_oldload_user2prog(user,proglist(iprog),error)
    if (error) return
    call cubego_oldload_main(user,proglist(iprog),error)
    if (error) return
    call cubego_oldload_sicdef(.true.,error)
    if (error) return
    lastloaded = iprog
  end subroutine cubego_oldload_command
  !
  subroutine cubego_oldload_sicdef(loaded,error)
    use cubetools_progstruct_types
    use cubego_buffer
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(in)    :: loaded
    logical, intent(inout) :: error
    !
    type(progstruct_t) :: oldload
    character(len=*), parameter :: rname='OLDLOAD>SICDEF'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubego%recreate('oldload',oldload,error)
    if (error) return
    call sic_def_logi(trim(oldload%name)//'found',loaded,readonly,error)
    if (error) return
  end subroutine cubego_oldload_sicdef
  !
  subroutine cubego_oldload_parse(line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*),     intent(in)    :: line
    type(oldload_user_t), intent(out)   :: user
    logical,              intent(inout) :: error
    !
    type(uservar_t) :: default_var
    character(len=*), parameter :: rname='OLDLOAD>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%oldload,user%incube,error)
    if (error) return    
    call cubego_oldload_parse_variable(line,default_var,user%var,error)
    if (error) return
    call cubego_oldload_parse_syntax(line,'HEAD',user%syntax,error)
    if (error) return
    call cubego_oldload_parse_access(line,error)
    if (error) return
  end subroutine cubego_oldload_parse
  !
  subroutine cubego_oldload_parse_access(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>PARSE>ACCESS'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call comm%access%parse(line,user%access,error)
    if (error)  return
    if (user%access%do) then
       if (user%syntax.eq.'HGDF') then
          call cubego_message(seve%e,rname,'Access cannot be defined for HGDF syntax')
          error = .true.
          return
       endif
    endif
  end subroutine cubego_oldload_parse_access
  !
  subroutine cubego_oldload_parse_variable(line,def,out,error)
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),      intent(in)    :: line
    type(uservar_t),       intent(in)    :: def
    type(uservar_t),       intent(out)   :: out
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=12) :: status
    character(len=varn_l) :: name
    logical :: dovar
    integer(kind=4), parameter :: iname = 1
    integer(kind=4), parameter :: iaccess = 2
    character(len=*), parameter :: rname='OLDLOAD>PARSE>VARIABLE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call comm%in%present(line,dovar,error)
    if (error) return
    if (dovar) then
       call cubetools_getarg(line,comm%in,iname,name,mandatory,error)
       if (error) return
       call cubetools_disambiguate_toupper(name,out%name,error)
       if (error) return
       status = def%status
       call cubetools_getarg(line,comm%in,iaccess,status,.not.mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(comm%in_arg,status,ikey,out%status,error)
       if (error) return
    else
       out = def
    endif
  end subroutine cubego_oldload_parse_variable
  !
  subroutine cubego_oldload_parse_syntax(line,def,out,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: def
    character(len=*), intent(out)   :: out
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=12) :: type
    logical :: dosyntax
    character(len=*), parameter :: rname='OLDLOAD>PARSE>SYNTAX'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call comm%syntax%present(line,dosyntax,error)
    if (error) return
    if (dosyntax) then
       call cubetools_getarg(line,comm%syntax,1,type,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(comm%syntax_arg,type,ikey,out,error)
       if (error) return
    else
       out = def
    endif
  end subroutine cubego_oldload_parse_syntax
  !
  subroutine cubego_oldload_user2prog(user,prog,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(oldload_user_t), intent(in)    :: user
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    type(cubeid_prog_t) :: cubeid
    character(len=*), parameter :: rname='OLDLOAD>USER2PROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    prog%var%name = user%var%name
    prog%var%readonly = user%var%status.eq.'READ'
    prog%dohead = user%syntax.eq.'HEAD'
    call user%access%toprog(comm%access,code_access_imaset,prog%access,error)
    if (error)  return
    !
    call cubeadm_cubeid_user2prog(comm%oldload,user%incube,cubeid,error)
    if (error) return
    prog%id = cubeid%id(comm%cube%inum)
  end subroutine cubego_oldload_user2prog
  !
  subroutine cubego_oldload_getslot(varname,proglist,iprog,error)
    use sic_types
    !-------------------------------------------------------------------
    ! Return a free 'slot' to be used for loading the cube
    !-------------------------------------------------------------------
    character(len=*),  intent(in)    :: varname
    type(oldload_prog_t), intent(inout) :: proglist(:)
    integer(kind=4),   intent(out)   :: iprog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>GETSLOT'
    logical :: found
    type(sic_descriptor_t) :: desc
    !
    ! First, search if one has to be overwritten
    iprog = cubego_oldload_get_varindex(varname,proglist)
    if (iprog.gt.0) then
      ! Found one in use with the correct name. Free it and return
      ! its number for reuse
      call cubego_oldload_clean(proglist(iprog),error)
      return
    endif
    !
    ! Remove SIC variable to be overwritten (if any), take care of
    ! read-only ones (e.g. PI)
    found = .false.  ! Quiet
    call sic_descriptor(varname,desc,found)
    if (found) then
      if (desc%readonly) then
        call cubego_message(seve%e,rname,'Can not delete read-only variable '//varname)
        error = .true.
        return
      endif
      call sic_delvariable(varname,.false.,error)
      if (error) return
    endif
    !
    ! Else, just find a free slot
    do iprog=1,size(proglist)
      if (.not.proglist(iprog)%used)  return
    enddo
    !
    ! No free slot found
    call cubego_message(seve%e,rname,'Maximum number of buffers exhausted')
    error = .true.
    return
  end subroutine cubego_oldload_getslot
  !
  function cubego_oldload_get_varindex(varname,proglist) result(varindex)
    !-------------------------------------------------------------------
    ! Return the cube index for which the cube is mapped to the named
    ! variable. Return 0 if not found.
    !-------------------------------------------------------------------
    integer(kind=4)               :: varindex
    character(len=*),  intent(in) :: varname
    type(oldload_prog_t), intent(in) :: proglist(:)
    !
    integer(kind=4) :: iprog
    !
    do iprog=1,size(proglist)
      if (.not.proglist(iprog)%used)            cycle
      if (proglist(iprog)%var%name.ne.varname)  cycle
      varindex = iprog
      return
    enddo
    varindex = 0
  end function cubego_oldload_get_varindex
  !
  subroutine cubego_oldload_clean(prog,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Clean current contents of the LOAD prog structure
    !-------------------------------------------------------------------
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (.not.sic_varexist(prog%var%name))  then
      ! The variable does not exist anymore. Since it is a program-defined
      ! variable, this was not done by the user. Assume this was done
      ! by cubedag_node_remove, when the target node was destroyed. This
      ! means prog%cube is now a dangling pointer, can not use it!
      prog%used = .false.
      return
    endif
    !
    call sic_delvariable(prog%var%name,.false.,error)
    if (error) error = .false.
    call prog%cube%unset_uservar(prog%var%name,error)
    if (error) error = .false.
    prog%used = .false.
  end subroutine cubego_oldload_clean
  !
  subroutine cubego_oldload_main(user,prog,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(oldload_user_t), intent(in)    :: user
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='OLDLOAD>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (prog%dohead) then
       call cubego_oldload_main_head(user,prog,error)
    else
       call cubego_oldload_main_hgdf(prog,error)
    endif
    if (error) return
    call prog%cube%set_uservar(prog%var%name,error)
    if (error) return
    prog%used = .true.
    ! *** JP: Variable status and syntax kind still missing in this user feedback
    write(mess,'(a,i0,3a)')  &
      'Loaded ',prog%id,' into the ',trim(prog%var%name),' user variable'
    call cubego_message(seve%i,rname,mess)
  end subroutine cubego_oldload_main
  !
  subroutine cubego_oldload_write_name(prog,error)
    use cubetools_flag_types
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=128) :: strflag
    integer(kind=4) :: lstrflag
    character(len=*), parameter :: rname='OLDLOAD>MAIN>HEAD'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call prog%cube%node%flag%repr(strflag=strflag,lstrflag=lstrflag,error=error)
    if (error) return
    write(prog%name,'(i0,2x,3a)') prog%id,trim(prog%cube%node%family),":",strflag(1:lstrflag)
  end subroutine cubego_oldload_write_name
  !
  subroutine cubego_oldload_main_head(user,prog,error)
    use cubetools_header_types
    use cubeadm_get
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(oldload_user_t), intent(in)    :: user
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>MAIN>HEAD'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    call cubeadm_get_header(comm%cube,user%incube,prog%cube,error,access=prog%access%code)
    if (error) return
    call cubego_oldload_write_name(prog,error)
    if (error) return
    call cubetools_header_sicdef(prog%var%name,prog%cube%head,prog%var%readonly,error)
    if (error) return
  end subroutine cubego_oldload_main_head
  !
  subroutine cubego_oldload_main_hgdf(prog,error)
    use gkernel_interfaces
    use cubeadm_get
    use cubeio_gdf
    !-------------------------------------------------------------------
    ! Backward compatible syntax, which oldloads and maps the historical
    ! GDF header and the data.
    !-------------------------------------------------------------------
    type(oldload_prog_t), intent(inout) :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>MAIN>HGDF'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_get_cube(prog%id,code_access_imaset,code_read,prog%cube,error)
    if (error) return
    call cubego_oldload_write_name(prog,error)
    if (error) return
    ! NB: the header is forced-exported to HGDF to resync cube_header_t
    ! components to HGDF (e.g. extrema values). This uses with some private/internal
    ! libcubeio API. This is just a poor man solution for the backward compatibility.
    call cubeio_create_hgdf(prog%cube,prog%cube%tuple%current%desc,  &
      code_cube_imaset,prog%cube%tuple%current%file%hgdf,error)
    if (error) return
    ! NB: the data%r4 array below is not intended to be used out of the
    ! libcubeio. This is just a poor man solution for the backward
    ! compatibility.
    if (prog%cube%tuple%current%file%hgdf%gil%ndim.eq.1) then
      call sic_mapgildas(prog%var%name,prog%cube%tuple%current%file%hgdf,error,  &
        prog%cube%tuple%current%memo%r4(:,1,1))
    elseif (prog%cube%tuple%current%file%hgdf%gil%ndim.eq.2) then
      call sic_mapgildas(prog%var%name,prog%cube%tuple%current%file%hgdf,error,  &
        prog%cube%tuple%current%memo%r4(:,:,1))
    else
      call sic_mapgildas(prog%var%name,prog%cube%tuple%current%file%hgdf,error,  &
        prog%cube%tuple%current%memo%r4(:,:,:))
    endif
    if (error) return
    call sic_def_charn(trim(prog%var%name)//'%name',prog%name,0,0,.true.,error)
    if (error) return
  end subroutine cubego_oldload_main_hgdf
  !
  subroutine cubego_oldload_getcube_number(dovar,varname,number,error) 
    !-------------------------------------------------------------------
    ! Goes through the list of loaded cubes and returns the correct
    ! index for it in the list
    ! -------------------------------------------------------------------
    logical,          intent(in)    :: dovar
    character(len=*), intent(in)    :: varname
    integer(kind=4),  intent(out)   :: number
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: icub
    character(len=*), parameter :: rname='OLDLOAD>GETCUBE>NUMBER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (dovar) then
       number = -1
       do icub=1,mprog
          if (.not.proglist(icub)%used) cycle
          if (trim(proglist(icub)%var%name).eq.trim(varname)) then
             number = icub
             exit
          endif
       enddo
       if (number.eq.-1) then
          call cubego_message(seve%e,rname,'No cube is loaded in a variable called '//trim(varname))
          error = .true.
          return
       endif
    else
       if (lastloaded.eq.0) then
          call cubego_message(seve%e,rname,'No cube has been loaded')
          error = .true.
          return
       endif
       number = lastloaded
    endif
  end subroutine cubego_oldload_getcube_number
  !
  subroutine cubego_oldload_getcube_pointer(icub,cube,error)
    use cube_types
    use cubeadm_get
    !-------------------------------------------------------------------
    ! Returns a pointer to the cube under ID icub
    ! *** JP Not clear to me why this is needed?
    ! -------------------------------------------------------------------
    integer(kind=4),       intent(in)    :: icub
    type(cube_t), pointer, intent(out)   :: cube
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='OLDLOAD>GETCUBE>POINTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_access_header(proglist(icub)%cube,proglist(icub)%access%code,  &
      code_read,error)
    if (error) return
    cube => proglist(icub)%cube
  end subroutine cubego_oldload_getcube_pointer
end module cubego_oldload
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program histo_double
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for making a Histogram from two maps
  !
  ! Subroutines	HISTO003
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey,namez
  logical :: error
  real :: hmin,hmax,hstep
  integer, parameter :: mdim=4
  integer :: n, pmin(mdim), pmax(mdim), nh, ier
  type(gildas) :: x,y,z
  !
  call gildas_open
  call gildas_char('Z_NAME$',namez)
  call gildas_char('Y_NAME$',namey)
  call gildas_inte('Y_BLC$',pmin,mdim)
  call gildas_inte('Y_TRC$',pmax,mdim)
  call gildas_inte('X_BINS$',nh,1)
  call gildas_real('X_MIN$',hmin,1)
  call gildas_real('X_MAX$',hmax,1)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  call gildas_null(z)
  z%blc(1:mdim) = pmin
  z%trc(1:mdim) = pmax
  call gdf_read_gildas(z,namez,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! y%gil%form = fmt_r4 ! This is the default
  call gildas_null(y)
  y%blc(1:mdim) = pmin
  y%trc(1:mdim) = pmax
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  !
  ! Define output histogram
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call gildas_null(x, type= 'TABLE') 
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  x%gil%ndim = 2
  x%gil%dim(1) = nh
  x%gil%dim(2) = 4
  x%loca%size = x%gil%dim(1)*x%gil%dim(2)
  hstep = (hmax-hmin)/(nh+1)
  allocate(x%r2d(nh,4), stat=ier)
  !
  call histo003(z%r1d,y%r1d,y%loca%size,y%gil%bval,y%gil%eval,   &
     &    x%r2d,x%gil%dim(1),hmin,hstep)
  call gdf_write_image (x,x%r2d,error)
  !
  call gagout('S-HISTO_DOUBLE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi(fatale)
end program histo_double
!
subroutine histo003(z,y,n, bval,eval, x,nh,hmin,hstep)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Computes the histogram of part of an Y image, as a
  !	function of another Z. The output histogram X contains
  !	(1)	Mean value of Y image
  !	(2)	Standard deviation
  !	(3)	Number of pixels
  !	(4)	Value of input Z image
  !
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n                     !
  real, intent(in) :: z(n)           ! Array of histogram definition
  real, intent(in) :: y(n)           ! Array of values
  real, intent(in) :: bval                      ! Blanking
  real, intent(in) :: eval                      ! and tolerance
  integer(index_length), intent(in) :: nh       ! Size of histogram
  real, intent(out) :: x(nh,4)                  ! Histogram
  real, intent(in) :: hmin                      ! Minimum
  real, intent(in) :: hstep                     ! Step
  ! Local
  integer(kind=size_length) :: i, ntot,nin,nout,nblank
  integer :: nval, j
  !
  nin = 0
  nout = 0
  nblank = 0
  x = 0.0
  !
  do i=1,n
    if (abs(z(i)-bval).gt.eval) then
      nval = 1+int((z(i)-hmin)/hstep)
      if (nval.ge.1 .and. nval.le.nh) then
        if (abs(y(i)-bval).gt.eval) then
          x(nval,1) = x(nval,1)+y(i)
          x(nval,2) = x(nval,2)+y(i)**2
          x(nval,3) = x(nval,3)+1.
          nin = nin+1
        else
          nblank = nblank+1
        endif
      else
        nout= nout+1
      endif
    else
      nblank = nblank+1
    endif
  enddo
  !
  ! Now fill the histogram definition
  do j=1,nh
    x(j,4) = hmin + (n+0.5)*hstep
    if (x(j,3).ne.0.) then
      x(j,1) = x(j,1)/x(j,3)
      x(j,2) = sqrt(x(j,2)/x(j,3)-x(j,1)**2)
    endif
  enddo
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
     &    nout,float(nout)/float(ntot)*1.e2,   &
     &    nblank,float(nblank)/float(ntot)*1.e2,   &
     &    ntot
100 format(1x,'Number of points in histogram ',i8,4x,f5.1,' Z',   &
     &    /,'   "    "    "    out of  "    ',i8,4x,f5.1,' %',   &
     &    /,'   "    "    "    blanked      ',i8,4x,f5.1,' %',   &
     &    /,'                  Total      = ',i8)
end subroutine histo003

!*********************************************************************
! REAL*4 Generic External three argument function on vectors
!
subroutine do_real_loop3 (func,n,result,m1,oper1,m2,oper2,m3,oper3,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  integer(kind=size_length)                :: m2         !
  real(kind=4)                             :: oper2(m2)  !
  integer(kind=size_length)                :: m3         !
  real(kind=4)                             :: oper3(m3)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: r,a,b,c
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1 .and. m3.eq.1) then
    r = func(oper1(1),oper2(1),oper3(1))
    do i=1,n
      result(i) = r
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.1) then
    b = oper2(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),b,c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.1) then
    a = oper1(1)
    c = oper3(1)
    do i=1,n
      result(i) = func(a,oper2(i),c)
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.1) then
    c = oper3(1)
    do i=1,n
      result(i) = func(oper1(i),oper2(i),c)
    enddo
  elseif (m1.eq.1 .and. m2.eq.1 .and. m3.eq.n) then
    a = oper1(1)
    b = oper2(1)
    do i=1,n
      result(i) = func(a,b,oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.1 .and. m3.eq.n) then
    b = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),b,oper3(i))
    enddo
  elseif (m1.eq.1 .and. m2.eq.n .and. m3.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i),oper3(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n .and. m3.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i),oper3(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2,m3
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop3
!
!*********************************************************************
! REAL*4 Generic External two argument function on vectors
!
subroutine do_real_loop2 (func,n,result,m1,oper1,m2,oper2,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4),              external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  integer(kind=size_length)                :: m2         !
  real(kind=4)                             :: oper2(m2)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1 .and. m2.eq.1) then
    a = func(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = func(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = func(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = func(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop2
!
!----------------------------------------------------------------------
! REAL*4 Two operands arithmetic operations on vectors
!
function lsic_s_bplus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bplus         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bplus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BPLUS',mess)
    lsic_s_bplus = 1
  endif
end function lsic_s_bplus
!
function lsic_s_bminus (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bminus        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bminus = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)-oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)-a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a-oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)-oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BMINUS',mess)
    lsic_s_bminus = 1
  endif
end function lsic_s_bminus
!
function lsic_s_mul (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_mul           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_mul = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = oper1(1)*oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = oper1(i)*a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = a*oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = oper1(i)*oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MUL',mess)
    lsic_s_mul = 1
  endif
end function lsic_s_mul
!
function lsic_s_div (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_div           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_div = 0
  if (m1.eq.1 .and. m2.eq.1) then
    if (oper2(1).ne.0) then
      a =  oper1(1)/oper2(1)
    elseif  (oper1(1).gt.0) then
      a = s_pinf
    elseif  (oper1(1).lt.0) then
      a = s_minf
    else
      a = s_nan
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      if (a.ne.0) then
        result(i) = oper1(i)/a
      elseif  (oper1(i).gt.0) then
        result(i) = s_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = a/oper2(i)
      elseif  (a.gt.0) then
        result(i) = s_pinf
      elseif  (a.lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      if (oper2(i).ne.0) then
        result(i) = oper1(i)/oper2(i)
      elseif  (oper1(i).gt.0) then
        result(i) = s_pinf
      elseif  (oper1(i).lt.0) then
        result(i) = s_minf
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_DIV',mess)
    lsic_s_div = 1
  endif
end function lsic_s_div
!
function lsic_s_power (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_power         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer :: p
  character(len=message_length) :: mess
  !
  lsic_s_power = 0
  if (m1.eq.1 .and. m2.eq.1) then
    p = nint(oper2(1))
    if (abs(float(p)-oper2(1)).le.1.0e-7*abs(float(p))) then
      a = oper1(1)**p
    else
      a = oper1(1)**oper2(1)
    endif
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    p = nint(a)
    if (abs(float(p)-a).le.1.0e-7*abs(float(p))) then
      if (p.eq.2) then
        do i=1,n
          result(i) = oper1(i)*oper1(i)
        enddo
      else
        do i=1,n
          result(i) = oper1(i)**p
        enddo
      endif
    else
      do i=1,n
        result(i) = oper1(i)**a
      enddo
    endif
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      p = nint(oper2(i))
      if (abs(float(p)-oper2(i)).le.1.0e-7*abs(float(p))) then
        result(i) = a**p
      else
        result(i) = a**oper2(i)
      endif
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      p = nint(oper2(i))
      if (abs(float(p)-oper2(i)).le.1.0e-7*abs(float(p))) then
        result(i) = oper1(i)**p
      else
        result(i) = oper1(i)**oper2(i)
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_POWER',mess)
    lsic_s_power = 1
  endif
end function lsic_s_power
!
!----------------------------------------------------------------------
! REAL*4 Two argument functions on vectors
!
function lsic_s_min (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_min           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_min = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = min(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = min(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = min(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = min(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MIN',mess)
    lsic_s_min = 1
  endif
end function lsic_s_min
!
function lsic_s_max (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_max           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_max = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = max(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = max(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = max(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = max(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MAX',mess)
    lsic_s_max = 1
  endif
end function lsic_s_max
!
function lsic_s_atan2 (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atan2         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atan2 = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = atan2(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = atan2(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = atan2(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = atan2(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_ATAN2',mess)
    lsic_s_atan2 = 1
  endif
end function lsic_s_atan2
!
function lsic_s_dim (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_dim           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_dim = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = dim(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = dim(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = dim(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = dim(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_DIM',mess)
    lsic_s_dim = 1
  endif
end function lsic_s_dim
!
function lsic_s_sign (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sign          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sign = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = sign(oper1(1),oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = sign(oper1(i),a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = sign(a,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = sign(oper1(i),oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_SIGN',mess)
    lsic_s_sign = 1
  endif
end function lsic_s_sign
!
function lsic_s_mod (n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_mod           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_mod = 0
  if (m1.eq.1 .and. m2.eq.1) then
    a = mod(oper1(1),oper2(1))
    if (a.lt.0.0) a = a+oper2(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      result(i) = mod(oper1(i),a)
      if (result(i).lt.0.0) result(i) = result(i)+a
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    a = oper1(1)
    do i=1,n
      result(i) = mod(a,oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      result(i) = mod(oper1(i),oper2(i))
      if (result(i).lt.0.0) result(i) = result(i)+oper2(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_MOD',mess)
    lsic_s_mod = 1
  endif
end function lsic_s_mod
!
!----------------------------------------------------------------------
! REAL*4 Generic External single argument function on vector
!
subroutine do_real_loop1(func,n,result,m1,oper1,error)
  use sic_interfaces
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=4) ,             external      :: func       !
  integer(kind=size_length)                :: n          !
  real(kind=4)                             :: result(n)  !
  integer(kind=size_length)                :: m1         !
  real(kind=4)                             :: oper1(m1)  !
  logical,                   intent(inout) :: error      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  if (m1.eq.1) then
    a = func(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = func(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_FUNC',mess)
    error = .true.
  endif
end subroutine do_real_loop1
!
!----------------------------------------------------------------------
! REAL*4 Single argument functions on vectors
!
function lsic_s_abs (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_abs           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_abs = 0
  if (m1.eq.1) then
    a = abs(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = abs(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ABS',mess)
    lsic_s_abs = 1
  endif
end function lsic_s_abs
!
function lsic_s_acos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_acos          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_acos = 0
  if (m1.eq.1) then
    a = acos(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.-1.0 .and. oper1(i).le.1.0) then
        result(i) = acos(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ACOS',mess)
    lsic_s_acos = 1
  endif
end function lsic_s_acos
!
function lsic_s_asin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_asin          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_asin = 0
  if (m1.eq.1) then
    a = asin(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.-1.0 .and. oper1(i).le.1.0) then
        result(i) = asin(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ASIN',mess)
    lsic_s_asin = 1
  endif
end function lsic_s_asin
!
function lsic_s_atan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atan          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atan = 0
  if (m1.eq.1) then
    a = atan(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = atan(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ATAN',mess)
    lsic_s_atan = 1
  endif
end function lsic_s_atan
!
function lsic_s_cos (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_cos           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_cos = 0
  if (m1.eq.1) then
    a = cos(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = cos(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_COS',mess)
    lsic_s_cos = 1
  endif
end function lsic_s_cos
!
function lsic_s_atanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_atanh         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_atanh = 0
  if (m1.eq.1) then
    a = atanh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = atanh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ATANH',mess)
    lsic_s_atanh = 1
  endif
end function lsic_s_atanh
!
function lsic_s_cosh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_cosh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_cosh = 0
  if (m1.eq.1) then
    a = cosh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = cosh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_COSH',mess)
    lsic_s_cosh = 1
  endif
end function lsic_s_cosh
!
function lsic_s_exp (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_exp           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_exp = 0
  if (m1.eq.1) then
    a = exp(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = exp(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_EXP',mess)
    lsic_s_exp = 1
  endif
end function lsic_s_exp
!
function lsic_s_int (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_int           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_int = 0
  if (m1.eq.1) then
    a = aint(oper1(1))
    if (a.gt.oper1(1)) a = a-1.0
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = aint(oper1(i))
      if (result(i).gt.oper1(i)) result(i) = result(i)-1.0
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_INT',mess)
    lsic_s_int = 1
  endif
end function lsic_s_int
!
function lsic_s_log (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_log           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_log = 0
  if (m1.eq.1) then
    a = log(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = log(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_LOG',mess)
    lsic_s_log = 1
  endif
end function lsic_s_log
!
function lsic_s_log10 (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_log10         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_log10 = 0
  if (m1.eq.1) then
    a = log10(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = log10(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_LOG10',mess)
    lsic_s_log10 = 1
  endif
end function lsic_s_log10
!
function lsic_s_nint (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_nint          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_nint = 0
  if (m1.eq.1) then
    a = anint(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = anint(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_NINT',mess)
    lsic_s_nint = 1
  endif
end function lsic_s_nint
!
function lsic_s_sin (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sin           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sin = 0
  if (m1.eq.1) then
    a = sin(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = sin(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SIN',mess)
    lsic_s_sin = 1
  endif
end function lsic_s_sin
!
function lsic_s_sinh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sinh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sinh = 0
  if (m1.eq.1) then
    a = sinh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = sinh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SINH',mess)
    lsic_s_sinh = 1
  endif
end function lsic_s_sinh
!
function lsic_s_sqrt (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_sqrt          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Global
  include 'gbl_nan.inc'
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_sqrt = 0
  if (m1.eq.1) then
    a = sqrt(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      if (oper1(i).ge.0.0) then
        result(i) = sqrt(oper1(i))
      else
        result(i) = s_nan
      endif
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_SQRT',mess)
    lsic_s_sqrt = 1
  endif
end function lsic_s_sqrt
!
function lsic_s_tan (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_tan           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_tan = 0
  if (m1.eq.1) then
    a = tan(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = tan(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_TAN',mess)
    lsic_s_tan = 1
  endif
end function lsic_s_tan
!
function lsic_s_tanh (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_tanh          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_tanh = 0
  if (m1.eq.1) then
    a = tanh(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = tanh(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_TANH',mess)
    lsic_s_tanh = 1
  endif
end function lsic_s_tanh
!
function lsic_s_floor (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_floor         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_floor = 0
  if (m1.eq.1) then
    a = real(floor(oper1(1)),kind=4)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = real(floor(oper1(i)),kind=4)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_FLOOR',mess)
    lsic_s_floor = 1
  endif
end function lsic_s_floor
!
function lsic_s_ceiling (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_ceiling       !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4)  :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_ceiling = 0
  if (m1.eq.1) then
    a = real(ceiling(oper1(1)),kind=4)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = real(ceiling(oper1(i)),kind=4)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_CEILING',mess)
    lsic_s_ceiling = 1
  endif
end function lsic_s_ceiling
!
function lsic_s_uminus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_uminus        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_uminus = 0
  if (m1.eq.1) then
    a = -oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = -oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_UMINUS',mess)
    lsic_s_uminus = 1
  endif
end function lsic_s_uminus
!
function lsic_s_uplus (n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_uplus         !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_uplus = 0
  if (m1.eq.1) then
    a = oper1(1)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = oper1(i)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_PLUS',mess)
    lsic_s_uplus = 1
  endif
end function lsic_s_uplus
!
function lsic_s_pyfunc (noper,nelem,nwords,n,result)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>lsic_s_pyfunc
  !---------------------------------------------------------------------
  ! @ private
  ! REAL*4 Generic PYTHON function with variable number of arguments
  !        Called by DO_VECTOR
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_pyfunc  ! Function value on return
  integer(kind=4),              intent(in)  :: noper          ! Number of operands
  integer(kind=size_length),    intent(in)  :: nelem(noper)   ! # of elements for each operand
  integer(kind=address_length), intent(in)  :: nwords(noper)  ! Memory location for each operand
  integer(kind=size_length),    intent(in)  :: n              ! Size of result
  real(kind=4),                 intent(out) :: result(n)      ! Result
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: j
  integer(kind=size_length) :: m
  ! Note on 'ielem': it should be 'size_length', but C functions have no such
  ! equivalent: use 'address_length' (Fortran) == 'size_t' (C), with the limit
  ! that under 32 bits architectures, 'size_length' can be 8 but
  ! 'address_length' 4.
  integer(kind=address_length) :: ielem
  integer(kind=4) :: strides(noper)
  real(kind=4) :: value
  logical :: hasarray
  !
  ! Check dimensions and construct strides
  lsic_s_pyfunc = 1
#if defined(GAG_USE_PYTHON)
  hasarray = .false.
  do j=1,noper
    m = nelem(j)
    if (m.eq.1) then
      strides(j) = 0
    elseif (m.eq.n) then
      strides(j) = 1
      hasarray=.true.
    else
      call sic_message(seve%e,'S_PYFUNC','Inconsistent dimensions')
      lsic_s_pyfunc = 1
      return
    endif
  enddo
  !
  if (.not.hasarray) then
    ielem = 1
    lsic_s_pyfunc = gpy_callfuncs(noper,ielem,strides,nwords,memory,value)
    if (lsic_s_pyfunc.ne.0) return
    do ielem=1,n
      result(ielem) = value
    enddo
  else
    do ielem=1,n
      lsic_s_pyfunc = gpy_callfuncs(noper,ielem,strides,nwords,memory,value)
      if (lsic_s_pyfunc.ne.0) return
      result(ielem) = value
    enddo
  endif
#else
  call sic_message(seve%e,'PYFUNC','Python not available')
#endif
end function lsic_s_pyfunc
!
function lsic_s_erf(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erf           !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erf = 0
  if (m1.eq.1) then
    a = erf(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = erf(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERF',mess)
    lsic_s_erf = 1
  endif
end function lsic_s_erf
!
function lsic_s_erfc(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfc          !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfc = 0
  if (m1.eq.1) then
    a = erfc(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = erfc(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFC',mess)
    lsic_s_erfc = 1
  endif
end function lsic_s_erfc
!
function lsic_s_erfinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfinv        !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=8):: x
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfinv = 0
  if (m1.eq.1) then
    x = real(oper1(1),kind=8)
    a = gag_erfinv(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = real(oper1(i),kind=8)
      result(i) = gag_erfinv(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFINV',mess)
    lsic_s_erfinv = 1
  endif
end function lsic_s_erfinv
!
function lsic_s_erfcinv(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_erfcinv       !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=8) :: x
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_erfcinv = 0
  if (m1.eq.1) then
    x = real(oper1(1),kind=8)
    a = gag_erfcinv(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = real(oper1(i),kind=8)
      result(i) = gag_erfcinv(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_ERFCINV',mess)
    lsic_s_erfcinv = 1
  endif
end function lsic_s_erfcinv
!
function lsic_s_bessel_i0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_i0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bessel_i0 = 0
  if (m1.eq.1) then
    x = oper1(1)
    a = gag_bessel_i0(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = oper1(i)
      result(i) = gag_bessel_i0(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_I0',mess)
    lsic_s_bessel_i0 = 1
  endif
end function lsic_s_bessel_i0
!
function lsic_s_bessel_i1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_i1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
  lsic_s_bessel_i1 = 0
  if (m1.eq.1) then
    x = oper1(1)
    a = gag_bessel_i1(x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      x = oper1(i)
      result(i) = gag_bessel_i1(x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_I1',mess)
    lsic_s_bessel_i1 = 1
  endif
end function lsic_s_bessel_i1
!
function lsic_s_bessel_in(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_in     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  real(kind=8) :: x
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
  lsic_s_bessel_in = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    x = dble(oper2(1))
    a = gag_bessel_in(o,x)
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    x = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = gag_bessel_in(o,x)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      x = oper2(i)
      result(i) = gag_bessel_in(o,x)
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      x = oper2(i)
      result(i) = gag_bessel_in(o,x)
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_IN',mess)
    lsic_s_bessel_in = 1
  endif
end function lsic_s_bessel_in
!
function lsic_s_bessel_j0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_j0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_j0 = 0
  if (m1.eq.1) then
    a = bessel_j0(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_j0(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_J0',mess)
    lsic_s_bessel_j0 = 1
  endif
#endif
end function lsic_s_bessel_j0
!
function lsic_s_bessel_j1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_j1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_j1 = 0
  if (m1.eq.1) then
    a = bessel_j1(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_j1(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_J1',mess)
    lsic_s_bessel_j1 = 1
  endif
#endif
end function lsic_s_bessel_j1
!
function lsic_s_bessel_jn(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_jn     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_jn = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    a = bessel_jn(o,oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_jn(o,a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      result(i) = bessel_jn(o,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_jn(o,oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_JN',mess)
    lsic_s_bessel_jn = 1
  endif
#endif
end function lsic_s_bessel_jn
!
function lsic_s_bessel_y0(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_y0     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_y0 = 0
  if (m1.eq.1) then
    a = bessel_y0(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_y0(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_Y0',mess)
    lsic_s_bessel_y0 = 1
  endif
#endif
end function lsic_s_bessel_y0
!
function lsic_s_bessel_y1(n,result,m1,oper1,k,dummy)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_y1     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: k          !
  integer                   :: dummy      !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_y1 = 0
  if (m1.eq.1) then
    a = bessel_y1(oper1(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n) then
    do i=1,n
      result(i) = bessel_y1(oper1(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1
    call sic_message(seve%e,'S_BESSEL_Y1',mess)
    lsic_s_bessel_y1 = 1
  endif
#endif
end function lsic_s_bessel_y1
!
function lsic_s_bessel_yn(n,result,m1,oper1,m2,oper2)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: lsic_s_bessel_yn     !
  integer(kind=size_length) :: n          !
  real(kind=4)              :: result(n)  !
  integer(kind=size_length) :: m1         !
  real(kind=4)              :: oper1(m1)  !
  integer(kind=size_length) :: m2         !
  real(kind=4)              :: oper2(m2)  !
  ! Local
  real(kind=4) :: a
  integer(kind=size_length) :: i
  integer(kind=4) :: o
  character(len=message_length) :: mess
  !
#if defined(IFORT_VERSION) && IFORT_VERSION < 140
  call sic_message(seve%e,'S_BESSEL_J0','Not available with ifort version older than 14.0')
  lsic_s_bessel_j0 = 1
#else
  lsic_s_bessel_yn = 0
  if (m1.eq.1 .and. m2.eq.1) then
    o = nint(oper1(1))
    a = bessel_yn(o,oper2(1))
    do i=1,n
      result(i) = a
    enddo
  elseif (m1.eq.n .and. m2.eq.1) then
    a = oper2(1)
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_yn(o,a)
    enddo
  elseif (m1.eq.1 .and. m2.eq.n) then
    o = nint(oper1(1))
    do i=1,n
      result(i) = bessel_yn(o,oper2(i))
    enddo
  elseif (m1.eq.n .and. m2.eq.n) then
    do i=1,n
      o = nint(oper1(i))
      result(i) = bessel_yn(o,oper2(i))
    enddo
  else
    write(mess,*) 'Inconsistent dimensions ',n,m1,m2
    call sic_message(seve%e,'S_BESSEL_YN',mess)
    lsic_s_bessel_yn = 1
  endif
#endif
end function lsic_s_bessel_yn

subroutine sic_add_expr (line,nl,output,no,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_add_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Replace a function by its translation in command line
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: nl                     !
  character(len=*) :: output        !
  integer :: no                     !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer :: iput,iout,inxt,ipre,in,ip
  integer :: ifun,iarg,ioper,ipoi,ilas,ifir
  integer :: ista(mfunarg),iend(mfunarg)
  !
  iput = 1
  iout = 1
  inxt = 1                     ! Next character in.
  do while (iput.le.nl)
    !
    ! A parenthesis : may be a function appears before
    if (line(iput:iput).eq.'(') then
      do ifun=1,nfun
        ipre = iput-lonc(ifun)
        if (ipre.lt.1) cycle   ! IFUN
        !
        ! With New SIC, Functions are in UPPER Case, so make the comparison
        ! meaningfull
        if (.not.sic_eqchain(line(ipre:iput-1),fonc(ifun)(1:lonc(ifun))))  &
          cycle   ! IFUN
        if (ipre.gt.1 .and. .not.expr_anoper(line(ipre-1:ipre-1)))  &
          cycle    ! IFUN
        ! This function
        ! Put pending characters
        if (ipre.gt.inxt) then
          output(iout:) = line(inxt:ipre-1)
          iout = iout+ipre-inxt
        endif
        output(iout:) = '('
        iout = iout+1
        in = iput+1
        iarg = 1
        do while (iarg.le.nfunarg(ifun))
          ista(iarg) = in
          ioper = expr_oper2 (line,ip,in,nl)
          if (ioper.eq.1) then
            call sic_message(seve%e,rname,'Wrong syntax')
            error = .true.
            return
          endif
          iend(iarg) = ip
          iarg = iarg+1
        enddo
        !
        ! Last operator must be a closing parenthesis
        if (ioper.ne.-1) then
          call sic_message(seve%e,rname,'Wrong number of arguments')
          error = .true.
          return
        endif
        !
        ! All arguments have been identified. Replace
        do ipoi = 1,lptr(ifun)
          !
          ! Preceding section
          ilas = ila(ipoi,ifun)
          ifir = ifi(ipoi,ifun)
          if (ilas.ge.ifir) then
            output(iout:) = defi(ifun)(ifir:ilas)
            iout = iout+ilas-ifir+1
          endif
          !
          ! Argument if any
          iarg = iva(ipoi,ifun)
          if (iarg.ne.0) then
            output(iout:iout) = '('
            iout = iout+1
            output(iout:) = line(ista(iarg):iend(iarg))
            iout = iout+iend(iarg)-ista(iarg)+1
            output(iout:iout) = ')'
            iout = iout+1
          endif
        enddo
        iput = ip
        inxt = ip+1
        !
      enddo                    ! IFUN
    endif
    iput = iput+1
  enddo
  !
  if (inxt.le.nl) output(iout:) = line(inxt:nl)
  no = len_trim(output)
  ! Add for new SIC
  call sic_upcase(output,no)
end subroutine sic_add_expr
!
function sic_get_expr(func,nf)
  use sic_expressions
  !---------------------------------------------------------------------
  ! @ private
  !  Translate a function name to its identifier. Return 0 if no such
  ! function (not an error, up to the caller to decide)
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_get_expr  ! Function value on return
  character(len=*), intent(in) :: func  !
  integer(kind=4),  intent(in) :: nf    !
  ! Local
  integer(kind=4) :: i
  !
  do i=1,nfun
    if (func(1:nf).eq.fonc(i)(1:lonc(i))) then  ! Case-sensitive
      ! Found
      sic_get_expr = i
      return
    endif
  enddo
  !
  ! Not found
  sic_get_expr = 0
  !
end function sic_get_expr
!
subroutine sic_list_expr (func,nf,error)
  use sic_interfaces, except_this=>sic_list_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  List 1 or all user-defined functions
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: func   !
  integer(kind=4),  intent(in)    :: nf     !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: i
  !
  if (nf.eq.0) then
    ! List all functions
    if (nfun.eq.0) return
    call sic_message(seve%i,'FUNCTION','User defined functions are:')
    do i=1,nfun
      write (*,'(2A)') fonc(i),defi(i)
    enddo
  else
    ! List one function
    i = sic_get_expr(func,nf)
    if (i.eq.0) then
      call sic_message(seve%e,rname,'No such function '//func(1:nf))
      error = .true.
      return
    endif
    call sic_message(seve%i,'FUNCTION',func(1:nf)//' is a user-defined function:')
    write (*,'(2A)') fonc(i),defi(i)
  endif
  !
end subroutine sic_list_expr
!
subroutine sic_del_expr(func,nf,error)
  use sic_interfaces, except_this=>sic_del_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Delete a user function
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: func   ! Function name
  integer(kind=4),  intent(in)    :: nf     ! Length of func
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FUNCTION'
  integer(kind=4) :: i,j,jj,k
  !
  i = sic_get_expr(func,nf)
  if (i.eq.0) then
    call sic_message(seve%e,rname,'No such function '//func(1:nf))
    error = .true.
    return
  endif
  !
  do j=i+1,nfun
    jj = j-1
    nfunarg(jj) = nfunarg(j)
    lonc(jj) = lonc(j)
    lptr(jj) = lptr(j)
    do k=1,lptr(j)
      ifi(k,jj) = ifi(k,j)
      ila(k,jj) = ila(k,j)
      iva(k,jj) = iva(k,j)
    enddo
    fonc(jj) = fonc(j)
    defi(jj) = defi(j)
  enddo
  nfun = nfun-1
  !
end subroutine sic_del_expr
!
subroutine sic_def_expr (func,nf,line,nl,error)
  use sic_interfaces, except_this=>sic_def_expr
  use sic_expressions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Define a user function (DEFINE FUNCTION)
  !---------------------------------------------------------------------
  character(len=*) :: func          !
  integer :: nf                     !
  character(len=*) :: line          !
  integer :: nl                     !
  logical :: error                  !
  ! Local
  character(len=12) :: farg(mfunarg)
  integer :: iarg,i,if,ip,in,jp,ioper,ipt,ifun
  !
  if (nfun.eq.mfun) then
    call sic_message(seve%e,'FUNCTION','Too many functions')
    error = .true.
    return
  elseif (nf.gt.len(fonc(1))) then
    call sic_message(seve%e,'FUNCTION','Function name is too long')
    error = .true.
    return
  elseif (nl.gt.len(defi(1))) then
    call sic_message(seve%e,'FUNCTION','Definition is too long')
    error = .true.
    return
  endif
  !
  ! Analyse input function FUNC(Var1,Var2,VarN)
  ifun = nfun+1
  iarg = 0
  if = 0
  do i=1,nf
    if (func(i:i).eq.'(') then
      if (if.ne.0) goto 99
      fonc(ifun) = func
      lonc(ifun) = i-1
      iarg = 1
      if = i+1
    elseif (func(i:i).eq.',') then
      if (iarg.eq.mfunarg) then
        call sic_message(seve%e,'DEFINE','Too many arguments')
        error =.true.
        return
      endif
      if (if.eq.0) goto 99
      farg(iarg) = func(if:i-1)
      iarg = iarg+1
      if = i+1
    elseif (func(i:i).eq.')') then
      if (if.eq.0) goto 99
      if (i.ne.nf) goto 99
      farg(iarg) = func(if:i-1)
    endif
  enddo
  !
  ! Check if it exists
  i = sic_get_expr(fonc(ifun),lonc(ifun))  ! NB: ifun = nfun+1
  if (i.ne.0) then
    call sic_message(seve%e,'FUNCTION',  &
      'Function '//fonc(ifun)(1:lonc(ifun))//' already defined')
    error = .true.
    return
  endif
  nfunarg(ifun) = iarg
  !
  ! Analyse definition
  ip = 1
  in = 1
  jp = 1
  ipt = 1
  ifi(ipt,ifun) = 1
  iva(ipt,ifun) = 0
  do while (in.le.nl)
    !
    ! Find next operator : IP pointer towards end of previous
    ! operand, IN towards beginning of next operand.
    ! Operator is LINE(IP+1:IN-1).
    !
    ioper = expr_oper1(line,ip,in,nl)
    if (ioper.eq.0 .and. ip.ge.jp) then
      do i=1,iarg
        if (farg(i).eq.line(jp:ip)) then
          if (ipt.eq.mpoi) then
            call sic_message(seve%e,'FUNCTION','Definition is too complex')
            error = .true.
            return
          endif
          ila(ipt,ifun) = jp-1
          iva(ipt,ifun) = i
          ipt = ipt+1
          ifi(ipt,ifun) = ip+1
          iva(ipt,ifun) = 0
        endif
      enddo
    elseif (ioper.eq.-1) then
      error = .true.
      return
    endif
    jp = in
  enddo
  ila(ipt,ifun) = nl
  lptr(ifun) = ipt
  defi(ifun) = line(1:nl)
  nfun = ifun
  error = .false.
  return
  !
99 call sic_message(seve%e,'DEFINE','Syntax error')
  error = .true.
end subroutine sic_def_expr
!
function expr_oper1 (line,ip,in,nl)
  use sic_interfaces, except_this=>expr_oper1
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which could be part of
  !       an operator field.
  ! Arguments :
  !       LINE    B(N)    Character string to be formatted        Input
  !       IP      I       Index of character before operator	Output
  !	IN	I	Index of character after operator	Input/Output
  !       NL      I       Length of C                             Input
  !---------------------------------------------------------------------
  integer :: expr_oper1             !
  character(len=*) :: line          !
  integer :: ip                     !
  integer :: in                     !
  integer :: nl                     !
  ! Local
  character(len=*), parameter :: rname='MATH'
  integer :: i
  logical :: array,separ,chain
  !
  expr_oper1 = 1
  array = .false.
  separ = .false.
  chain = .false.
  do i = in,nl
    if (chain) then
      if (line(i:i).eq.'"') then
        chain = .false.
        separ = .true.
      endif
    elseif (array) then
      if (line(i:i).eq.']') then
        array = .false.
        separ = .true.
      endif
    elseif (line(i:i).eq.'[') then
      array = .true.
    elseif (line(i:i).eq.']') then
      call sic_message(seve%e,rname,'Unmatch Closing bracket')
      expr_oper1 = -1
      return
    elseif (line(i:i).eq.'"') then
      chain = .true.
      !
      ! * could also be ** : check next character
    elseif (line(i:i).eq.'*') then
      ip = i-1
      if (line(i+1:i+1).eq.'*') then
        in = i+2
      else
        in = i+1
      endif
      expr_oper1 = 0
      return
      !
      ! Should be changed on a non-ASCII machine.
      ! '(', ')', '*', '+', ',', '-', '.', or '/' are contiguous in ASCII
    elseif ( (line(i:i).ge.'('.and.line(i:i).le.'/') .or.  &
             (line(i:i).eq.'|') .or. (line(i:i).eq.'^') ) then
      ip = i-1
      in = i+1
      expr_oper1 = 0
      return
    elseif (separ) then
      call sic_message(seve%e,rname,'Missing operator after string or '//  &
      'closing bracket')
      expr_oper1 = -1
      return
    endif
  enddo
  if (chain.or.array) return
  expr_oper1 = 0
  ip = nl
  in = nl+1
end function expr_oper1
!
function expr_oper2 (line,ip,in,nl)
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which is a
  !	matching comma or closing parentheses
  ! Arguments :
  !       LINE    B(N)    Character string to be formatted        Input
  !       IP      I       Index of character before operator	Output
  !	IN	I	Index of character after operator	Input/Output
  !       NL      I       Length of C                             Input
  !---------------------------------------------------------------------
  integer :: expr_oper2             !
  character(len=*) :: line          !
  integer :: ip                     !
  integer :: in                     !
  integer :: nl                     !
  ! Local
  integer :: i,level
  logical :: array,chain
  !
  expr_oper2 = 1
  array = .false.
  chain = .false.
  level = 0
  do i = in,nl
    if (chain) then
      if (line(i:i).eq.'"') chain = .false.
    elseif (array) then
      if (line(i:i).eq.']') array = .false.
    elseif (line(i:i).eq.'[') then
      array = .true.
    elseif (line(i:i).eq.'"') then
      chain = .true.
    elseif (line(i:i).eq.'(') then
      level = level+1
    elseif (line(i:i).eq.')') then
      if (level.eq.0) then
        ip = i-1
        in = i+1
        expr_oper2 = -1
        return
      endif
      level = level-1
    elseif (line(i:i).eq.',') then
      if (level.eq.0) then
        ip = i-1
        in = i+1
        expr_oper2 = 0
        return
      endif
    endif
  enddo
  ip = nl+1
end function expr_oper2
!
function expr_anoper (line)
  !---------------------------------------------------------------------
  ! @ private
  !       Returns index of first character in line which could be part of
  !       an operator field.
  ! Arguments :
  !       LINE    C*1     Character string to be formatted        Input
  !---------------------------------------------------------------------
  logical :: expr_anoper            !
  character(len=1) :: line          !
  ! Should be changed on a non-ASCII machine.
  ! '(', ')', '*', '+', ',', '-', '.', or '/' are contiguous in ASCII
  if ( (line.ge.'('.and.line.le.'/') .or.  &
       (line.eq.'|') .or. (line.eq.'^') ) then
    expr_anoper = .true.
  else
    expr_anoper = .false.
  endif
end function expr_anoper

!  include.f90 
!
!  FUNCTIONS:
!	include      - Entry point of console application.
!
!	Example of displaying 'Hello World' at execution time.
!

!****************************************************************************
!
!  PROGRAM: include
!
!  PURPOSE:  Entry point for 'Hello World' sample console application.
!
!****************************************************************************
	program include
	use gildas_def
	use image_def
	use phys_const
	use gbl_format

	print *, 'Hello World'

	end program include

subroutine clic_popup (line,error)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! CLIC
  !     Pop-up the box pointed out by the cursor, and
  !     then call the cursor again to get "local" user coordinates.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Local
  character(len=1) :: code
  integer :: i, ib, l, jb
  real*4 :: gx1(mbox), gx2(mbox), gy1(mbox), gy2(mbox)
  real*4 :: x4, y4
  real*8 :: xu, yu
  !
  ! Get box corners
  do i=1, n_boxes
    l = lenc(c_setbox(i))
    call gr_exec  (c_setbox(i)(1:l))
    call sic_get_real ('BOX_XMIN',gx1(i),error)
    call sic_get_real ('BOX_XMAX',gx2(i),error)
    call sic_get_real ('BOX_YMIN',gy1(i),error)
    call sic_get_real ('BOX_YMAX',gy2(i),error)
  enddo
  !
  call gr_execl('CHANGE DIRECTORY')
  do while (.true.)
    error = .false.
    call gr_curs (xu, yu, x4, y4, code)
    if (code.eq.'E' .or. code.eq.'e') then
      call resetvar(error)
      return
    endif
    ib = 0
    jb = 0
    do while (ib.eq.0)
      jb = jb+1
      if (jb.gt.n_boxes) then
        ib = -1
      else
        if ((x4-gx1(jb))*(x4-gx2(jb)) .le. 0) then
          if ((y4-gy1(jb))*(y4-gy2(jb)) .le. 0) then
            ib = jb
          endif
        endif
      endif
    enddo
    !
    if (ib.lt.0) then
      write(6,*) ' Cursor (',x4,',',y4,') is not in any box'
    else
      call sub_popup(ib)
    endif
  enddo
end subroutine clic_popup
!
subroutine sub_popup(ib)
  integer :: ib                     !
  ! Local
  character(len=4) :: chain
  !
  write(chain,'(I4.4)') ib
  call gr_execl('CHANGE DIRECTORY BOX'//chain)
  call gr_execl('CREATE WINDOW')
  call gr_exec1('DRAW')
  call gr_execl('DESTROY WINDOW')
  call gr_execl('CHANGE DIRECTORY')
end subroutine sub_popup

subroutine uplot(x,y,imode)
  use plot_formula
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	User unit entry.
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = gx1 + gux * (x-gux1)
  yp = gy1 + guy * (y-guy1)
  ! Do plot
  if (imode.eq.3) then
     call grelocate(xp,yp)
  else
     call gdraw(xp,yp)
  endif
end subroutine uplot
!
subroutine cplot(x,y,imode)
  use plot_formula
  !-------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	Channel units entry
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = gx1 + gcx * (x-gcx1)
  yp = gy1 + guy * (y-guy1)
  ! Do plot
  if (imode.eq.3) then
    call grelocate(xp,yp)
  else
    call gdraw(xp,yp)
  endif
end subroutine cplot
!
subroutine vplot(x,y,imode)
  use plot_formula
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	Velocity units entry
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = gx1 + gvx * (x-gvx1)
  yp = gy1 + guy * (y-guy1)
  ! Do plot
  if (imode.eq.3) then
    call grelocate(xp,yp)
  else
    call gdraw(xp,yp)
  endif
end subroutine vplot
!
subroutine fplot(x,y,imode)
  use plot_formula
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	Frequency units entry
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = gx1 + gfx * (x-gfx1)
  yp = gy1 + guy * (y-guy1)
  ! Do plot
  if (imode.eq.3) then
    call grelocate(xp,yp)
  else
    call gdraw(xp,yp)
  endif
end subroutine fplot
!
subroutine iplot(x,y,imode)
  use plot_formula
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	Image units entry
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = gx1 + gix * (x-gix1)
  yp = gy1 + guy * (y-guy1)
  ! Do plot
  if (imode.eq.3) then
    call grelocate(xp,yp)
  else
    call gdraw(xp,yp)
  endif
end subroutine iplot
!
subroutine gplot(x,y,imode)
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  !	Draw a line from current pen position to specified (X,Y) position.
  !	Several entries are available, and correspond  to different units
  !	for the coordinates. IMODE=3 corresponds to a pen up move.
  !	Paper units entry
  !-------------------------------------------------------------------
  real(kind=4), intent(in) :: x ! X coordinate
  real(kind=4), intent(in) :: y ! Y coordinate
  integer, intent(in) :: imode  ! Pen down (#3) or up (=3) mode
  real :: xp, yp
  !
  xp = x
  yp = y
  ! Do plot
  if (imode.eq.3) then
    call grelocate(xp,yp)
  else
    call gdraw(xp,yp)
  endif
end subroutine gplot

subroutine sic_decode(chain,value,ndiv,error)
  use gsys_interfaces, except_this=>sic_decode
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Decode a sexagesimal character string into angle value in radians.
  ! Formats can be:
  !       61.5000000      or      161
  !       61:30.0000      or      161:40
  !       61:45:50.9      or      161:40:50
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  ! Character string
  real(kind=8),     intent(out)   :: value  ! Value of angle
  integer(kind=4),  intent(in)    :: ndiv   ! 360/24
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ANGLE'
  real(kind=8) :: conv,degrees,minutes,seconds
  integer(kind=4) :: ndot,nlen,nmin,nsec
  logical :: negative
  real(kind=8), parameter :: pi=3.141592653589793d0
  character(len=16) :: string
  !
  error = .true.
  !
  ! First find if any dot in Chain
  nlen = lenc(chain)
  ndot = index(chain,'.')
  if (ndot.eq.0) then
    ndot=nlen+1
  endif
  !
  ! Set CONV factor
  if (ndiv.eq.24) then
    conv = pi/12.d0
  elseif (ndiv.eq.360) then
    conv = pi/180.d0
  else
    write(string,*) ndiv
    call gsys_message(seve%e,rname,'Invalid division number '//string)
    return
  endif
  !
  ! Find sign
  negative = index(chain,'-') .ne. 0
  !
  ! Find if any Minutes Field
  nmin = index(chain,':')
  if (nmin.eq.0) then
    ! No Minutes Field
    if (nlen.eq.0) goto 99
    read(chain(1:nlen),*,err=99) degrees
    value = conv*degrees
    error = .false.
    return
  endif
  !
  ! Find if any Second field
  nsec = index(chain(nmin+1:nlen),':')
  if (nsec.eq.0) then
    ! No Seconds Field
    !         IF (NDOT.NE.NMIN+3) THEN
    if (ndot.lt.nmin+1) then
      ! Minutes Field not two characters
      goto 99
    endif
    read(chain(nmin+1:nlen),*,err=99) minutes
    if (minutes.ge.60.d0) then
      call gsys_message(seve%e,rname,'more than 60 minutes...')
      return
    endif
    read(chain(1:nmin-1),*,err=99) degrees
    if (negative) then
      value = conv*(degrees-minutes/60.d0)
    else
      value = conv*(degrees+minutes/60.d0)
    endif
  elseif (nsec.le.1) then
    ! Minutes Field not two characters
    goto 99
  else
    ! Seconds Field is present
    if (ndot.le.nmin+nsec) then
      ! Seconds Field not two characters
      goto 99
    endif
    read(chain(nmin+nsec+1:nlen),*,err=99) seconds
    if (seconds.ge.60.d0) then
      call gsys_message(seve%e,rname,'more than 60 seconds...')
      return
    endif
    read(chain(nmin+1:nmin+nsec-1),*,err=99) minutes
    if (minutes.ge.60.d0) then
      call gsys_message(seve%e,rname,'more than 60 minutes...')
      return
    endif
    read(chain(1:nmin-1),*,err=99) degrees
    if (negative) then
      value = conv*(degrees-minutes/60.d0-seconds/3600.d0)
    else
      value = conv*(degrees+minutes/60.d0+seconds/3600.d0)
    endif
  endif
  error = .false.
  return
  !
99 call gsys_message(seve%e,rname,'Invalid angle format '//chain)
end subroutine sic_decode

module imbfits_types
  use gildas_def
  use cfitsio_api
  use gkernel_types
  use eclass_types
  use imbfits_parameters
  use imbfits_file_type
  use imbfits_header_type
  use imbfits_backdata_type
  !
  ! HDUs description
  type imbfits_hdus_t
     integer(kind=4) :: n = 0  ! Number of HDUs in file (unused)
     integer(kind=4) :: nlead = 0  ! Position of first HDU of first subscan
     integer(kind=4) :: npersubscan = 0   ! Number of HDUs per subscan
     integer(kind=4) :: pos(mhdukinds)    ! Positions (abs or rel) of HDUs (per kind)
  end type imbfits_hdus_t
  !
  ! Primary
  type imbfits_primary_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_logi_0d_t) :: simple
     type(fits_inte_0d_t) :: bitpix
     type(fits_inte_0d_t) :: naxis
     type(fits_logi_0d_t) :: extend
     type(fits_char_0d_t) :: telescop
     type(fits_char_0d_t) :: origin
     type(fits_char_0d_t) :: creator
     type(fits_dble_0d_t) :: imbftsve
     type(fits_char_0d_t) :: instrume
     type(fits_char_0d_t) :: object
     type(fits_dble_0d_t) :: longobj
     type(fits_dble_0d_t) :: latobj
     type(fits_char_0d_t) :: timesys
     type(fits_dble_0d_t) :: mjd_obs
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: lst
     type(fits_char_0d_t) :: projid
     type(fits_char_0d_t) :: queue
     type(fits_dble_0d_t) :: exptime
     type(fits_inte_0d_t) :: n_obs
     type(fits_inte_0d_t) :: n_obsp
     type(fits_char_0d_t) :: obstype
     type(fits_inte_0d_t) :: nusefeed
     type(fits_inte_0d_t) :: totant
     type(fits_inte_0d_t) :: totsubr
     type(fits_inte_0d_t) :: totback
  end type imbfits_primary_t
  ! Scan header and table
  type imbfits_scan_header_t
     type(imbfits_header_t) :: desc
     ! Telescope and site
     type(fits_char_0d_t) :: telescop
     type(fits_dble_0d_t) :: telsize
     type(fits_dble_0d_t) :: sitelong
     type(fits_dble_0d_t) :: sitelat
     type(fits_dble_0d_t) :: siteelev
     ! Project
     type(fits_char_0d_t) :: projid
     type(fits_char_0d_t) :: obsid
     type(fits_char_0d_t) :: operator
     ! Scan
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: scandate  ! [GAG] Date associated to the scan (might differ from date_obs after midnight)
     ! Date and time
     type(fits_char_0d_t) :: date_obs
     type(fits_char_0d_t) :: date
     type(fits_dble_0d_t) :: mjd
     type(fits_dble_0d_t) :: lst
     type(fits_inte_0d_t) :: n_obs
     type(fits_inte_0d_t) :: exptime
     type(fits_char_0d_t) :: timesys
     type(fits_dble_0d_t) :: ut1utc
     type(fits_dble_0d_t) :: taiutc
     type(fits_dble_0d_t) :: etutc
     type(fits_dble_0d_t) :: gpstai
     ! Fixed source parameters
     type(fits_dble_0d_t) :: polex
     type(fits_dble_0d_t) :: poley
     type(fits_char_0d_t) :: object
     !type(fits_unkn_0d_t) :: sbas
     !type(fits_unkn_0d_t) :: sbasflag
     type(fits_char_0d_t) :: ctype1
     type(fits_char_0d_t) :: ctype2
     type(fits_char_0d_t) :: radesys
     type(fits_dble_0d_t) :: equinox
     type(fits_dble_0d_t) :: crval1
     type(fits_dble_0d_t) :: crval2
     type(fits_dble_0d_t) :: lonpole
     type(fits_dble_0d_t) :: latpole
     type(fits_dble_0d_t) :: longobj
     type(fits_dble_0d_t) :: latobj
     !type(fits_unkn_0d_t) :: calcode
     ! Moving source parameters
     type(fits_logi_0d_t) :: movefram
     type(fits_dble_0d_t) :: peridate
     type(fits_dble_0d_t) :: peridist
     type(fits_dble_0d_t) :: longasc
     type(fits_dble_0d_t) :: omega
     type(fits_dble_0d_t) :: inclinat
     type(fits_dble_0d_t) :: eccentr
     type(fits_dble_0d_t) :: orbepoch
     type(fits_dble_0d_t) :: orbeqnox
     type(fits_dble_0d_t) :: distance
     ! Switch mode
     type(fits_char_0d_t) :: swtchmod
     type(fits_inte_0d_t) :: noswitch
     type(fits_dble_0d_t) :: phasetim
     type(fits_dble_0d_t) :: wobthrow
     type(fits_inte_0d_t) :: wobdir ! ???
     type(fits_dble_0d_t) :: wobcycle
     type(fits_char_0d_t) :: wobmode
     !
     type(fits_inte_0d_t) :: nfebe
     ! Pointing and focus
     type(fits_dble_0d_t) :: p1
     type(fits_dble_0d_t) :: p2
     type(fits_dble_0d_t) :: p3
     type(fits_dble_0d_t) :: p4
     type(fits_dble_0d_t) :: p5
     type(fits_dble_0d_t) :: p7
     type(fits_dble_0d_t) :: p8
     type(fits_dble_0d_t) :: p9
     type(fits_dble_0d_t) :: rxhori
     type(fits_dble_0d_t) :: rxvert
     type(fits_dble_0d_t) :: third_re
     type(fits_dble_0d_t) :: zero_pol
     type(fits_dble_0d_t) :: phi_pol
     type(fits_dble_0d_t) :: eps_pol
     type(fits_dble_0d_t) :: col_sin
     type(fits_dble_0d_t) :: col_cos
     type(fits_char_0d_t) :: date_poi
     type(fits_dble_0d_t) :: p1cor
     type(fits_dble_0d_t) :: p2cor
     type(fits_dble_0d_t) :: p3cor
     type(fits_dble_0d_t) :: p4cor
     type(fits_dble_0d_t) :: p5cor
     type(fits_dble_0d_t) :: p7cor
     type(fits_dble_0d_t) :: p8cor
     type(fits_dble_0d_t) :: p9cor
     type(fits_dble_0d_t) :: rxhorico
     type(fits_dble_0d_t) :: rxvertco
     type(fits_dble_0d_t) :: focusx
     type(fits_dble_0d_t) :: focusy
     type(fits_dble_0d_t) :: focusz
     type(fits_dble_0d_t) :: p4corinc
     type(fits_dble_0d_t) :: p5corinc
     type(fits_char_0d_t) :: date_inc
     ! Weather and calibration
     type(fits_dble_0d_t) :: pressure
     type(fits_dble_0d_t) :: tambient
     type(fits_dble_0d_t) :: humidity
     type(fits_dble_0d_t) :: winddir
     type(fits_dble_0d_t) :: windvel
     type(fits_dble_0d_t) :: windvelm
     type(fits_char_0d_t) :: date_wea
     type(fits_dble_0d_t) :: refracti ! ???
     type(fits_dble_0d_t) :: thot
     type(fits_char_0d_t) :: date_hot
     type(fits_dble_0d_t) :: tiptauz
     type(fits_dble_0d_t) :: tiptaue
     type(fits_dble_0d_t) :: tiptauc
     type(fits_char_0d_t) :: date_tip
     ! ???
     type(fits_inte_0d_t) :: recon
     type(fits_inte_0d_t) :: reccntrl
  end type imbfits_scan_header_t
  type imbfits_scan_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_char_1d_t) :: sysoff
     type(fits_real_1d_t) :: xoffset
     type(fits_real_1d_t) :: yoffset
  end type imbfits_scan_table_t
  type imbfits_scan_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_scan_header_t) :: head
     type(imbfits_scan_table_t) :: table
  end type imbfits_scan_t
  ! Frontend header and scan
  type imbfits_front_header_t
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_char_0d_t) :: date_obs
     type(fits_char_0d_t) :: dewrtmod
     type(fits_dble_0d_t) :: dewang
     type(fits_inte_0d_t) :: febeband
     type(fits_inte_0d_t) :: febefeed
     type(fits_inte_0d_t) :: nusefeed
     type(fits_dble_0d_t) :: velosys
     type(fits_char_0d_t) :: specsys
     type(fits_char_0d_t) :: veloconv
     type(fits_char_0d_t) :: emirbeam
  end type imbfits_front_header_t
  type imbfits_front_table_t
     integer(kind=4) :: status = code_imbfits_init
     ! Frequency axis
     type(fits_char_1d_t) :: recname
     type(fits_char_1d_t) :: linename
     type(fits_dble_1d_t) :: restfreq
     ! Calibration
     type(fits_real_1d_t) :: beameff
     type(fits_real_1d_t) :: etafss
     type(fits_real_1d_t) :: gainimag
     type(fits_char_1d_t) :: sideband
     type(fits_dble_1d_t) :: sbsep
     type(fits_char_1d_t) :: widenar
     type(fits_real_1d_t) :: tcold
     type(fits_real_1d_t) :: thot
     ! Pixel description
     type(fits_inte_1d_t) :: ifeed
     type(fits_inte_1d_t) :: nofeeds
     type(fits_char_1d_t) :: pola
     ! Frequency axis
     type(fits_char_1d_t) :: doppler
     type(fits_real_1d_t) :: ifcenter
     type(fits_real_1d_t) :: bandwid
     type(fits_logi_1d_t) :: ifflipps ! ???
     type(fits_logi_1d_t) :: speclo   ! ???
     ! Brightness axis
     type(fits_char_1d_t) :: tscale
     ! Frequency switching
     type(fits_real_1d_t) :: frqthrow
     type(fits_real_1d_t) :: frqoff1
     type(fits_real_1d_t) :: frqoff2
  end type imbfits_front_table_t
  type imbfits_front_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_front_header_t) :: head
     type(imbfits_front_table_t) :: table
  end type imbfits_front_t
  ! Backend header and scan
  type imbfits_back_header_t
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_char_0d_t) :: date_obs
     type(fits_inte_0d_t) :: febeband
     type(fits_inte_0d_t) :: febefeed
     type(fits_inte_0d_t) :: nusefeed
     !type(fits_inte_0d_t) :: if1freqs ! ???
  end type imbfits_back_header_t
  type imbfits_back_table_t
     integer(kind=4) :: status = code_imbfits_init
     ! Channel information
     type(fits_inte_1d_t) :: part
     type(fits_inte_1d_t) :: refchan
     type(fits_inte_1d_t) :: chans
     type(fits_inte_1d_t) :: dropped
     type(fits_inte_1d_t) :: used
     ! Receiver information
     type(fits_inte_1d_t) :: pixel
     type(fits_char_1d_t) :: receiver
     type(fits_char_1d_t) :: band
     type(fits_char_1d_t) :: frontend  ! Frontend name to be used in telescope name (memory only)
     type(fits_char_1d_t) :: polar
     type(fits_logi_1d_t) :: dataflip  ! Data needs sign flip? (memory only)
     type(fits_inte_1d_t) :: ifront    ! Backpointer to frontend table (memory only)
     ! Frequency information
     type(fits_real_1d_t) :: reffreq
     type(fits_real_1d_t) :: spacing
     type(fits_char_1d_t) :: linename
  end type imbfits_back_table_t
  type imbfits_back_chunks_t
     ! Description of the chunks in the BACKEND table
     type(eclass_2inte2char_t)    :: eclass   ! Chunk equivalence classes
     integer(kind=4), allocatable :: used(:)  ! (Size Nchunks) Chunks used for those classes
     integer(kind=4), allocatable :: kind(:)  ! (Size Nset) See codes in stokesset_book_t
  end type imbfits_back_chunks_t
  type imbfits_back_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_back_header_t) :: head
     type(imbfits_back_table_t) :: table
     ! Derived data:
     logical :: polchunks  ! The table provides or not polarimetric chunks
     type(imbfits_back_chunks_t) :: chunks  ! NONE, AXIS, REAL, IMAG chunks description
  end type imbfits_back_t
  !
  ! Antenna slow traces
  type imbfits_antslow_header_t
     ! NB: this type for both antslow and antfast
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: obsnum
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: mjd_beg  ! [MJD] Duplicate of 'date_obs' (memory only)
     type(fits_char_0d_t) :: date_end
     type(fits_dble_0d_t) :: mjd_end  ! [MJD] Duplicate of 'date_end' (memory only)
     type(fits_char_0d_t) :: obstype
     type(fits_char_0d_t) :: substype
     type(fits_dble_0d_t) :: substime
     type(fits_char_0d_t) :: systemof
     type(fits_dble_0d_t) :: subsxoff
     type(fits_dble_0d_t) :: subsyoff
     ! Segment
     type(fits_char_0d_t) :: setype01
     type(fits_dble_0d_t) :: setime01
     type(fits_dble_0d_t) :: sexoff01
     type(fits_dble_0d_t) :: seyoff01
     type(fits_dble_0d_t) :: sexsta01
     type(fits_dble_0d_t) :: seysta01
     type(fits_dble_0d_t) :: sexend01
     type(fits_dble_0d_t) :: seyend01
     type(fits_dble_0d_t) :: sespes01
     type(fits_dble_0d_t) :: sespee01
     ! Doppler
     type(fits_dble_0d_t) :: dopplerc
     type(fits_dble_0d_t) :: obsvelrf
     ! Fast traces
     type(fits_inte_0d_t) :: tracerat
  end type imbfits_antslow_header_t
  type imbfits_antslow_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_dble_1d_t) :: lst
     type(fits_dble_1d_t) :: longoff
     type(fits_dble_1d_t) :: latoff
     type(fits_dble_1d_t) :: cazimuth
     type(fits_dble_1d_t) :: celevatio
     type(fits_inte_1d_t) :: traceflag
  end type imbfits_antslow_table_t
  ! Antenna fast traces
  type imbfits_antfast_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_dble_1d_t) :: azimuth
     type(fits_dble_1d_t) :: elevation
     type(fits_dble_1d_t) :: tracking_az
     type(fits_dble_1d_t) :: tracking_el
  end type imbfits_antfast_table_t
  !
  type imbfits_antslow_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_antslow_header_t) :: head
     type(imbfits_antslow_table_t)  :: table
  end type imbfits_antslow_t
  !
  type imbfits_antfast_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_antslow_header_t) :: head ! There is not yet an antfast header
     type(imbfits_antfast_table_t)  :: table
  end type imbfits_antfast_t
  !
  ! Derotator
  type imbfits_derot_header_t
     ! NB: this type for both antslow and antfast
     type(imbfits_header_t) :: desc
     !
     type(fits_inte_0d_t) :: scannum
     type(fits_inte_0d_t) :: obsnum
     type(fits_char_0d_t) :: date_obs
     type(fits_dble_0d_t) :: mjd_beg  ! [MJD] Duplicate of 'date_obs' (memory only)
     type(fits_char_0d_t) :: date_end
     type(fits_dble_0d_t) :: mjd_end  ! [MJD] Duplicate of 'date_end' (memory only)
     type(fits_dble_0d_t) :: substime
  end type imbfits_derot_header_t
  type imbfits_derot_table_t
     integer(kind=4) :: status = code_imbfits_init
     type(fits_dble_1d_t) :: mjd
     type(fits_char_1d_t) :: system
     type(fits_real_1d_t) :: fwant
     type(fits_real_1d_t) :: hwant
     type(fits_real_1d_t) :: swant
     type(fits_real_1d_t) :: fact
     type(fits_real_1d_t) :: hact
     type(fits_real_1d_t) :: sact
  end type imbfits_derot_table_t
  type imbfits_derot_t
     integer(kind=4) :: status = code_imbfits_init
     type(imbfits_derot_header_t) :: head
     type(imbfits_derot_table_t) :: table
  end type imbfits_derot_t
  !
  type imbfits_t
     type(imbfits_file_t)    :: file
     type(imbfits_hdus_t)    :: hdus
     type(imbfits_primary_t) :: primary
     type(imbfits_scan_t)    :: scan
     type(imbfits_front_t)   :: front
     type(imbfits_back_t)    :: back
     type(imbfits_derot_t)   :: derot    ! Derotator
     type(eclass_char_t)     :: seclass  ! Subscans equiv class
  end type imbfits_t
  !
  ! Type specific for the DATA column. Note that this is the only
  ! column we do not read entirely
  type imbfits_data_t
     integer(kind=4) :: ntime = 0  ! Number of 'time' rows read
     integer(kind=4) :: npix  = 0  !
     integer(kind=4) :: nchan = 0  ! Number of channels in first dimension of 'VAL'
     real(kind=4), pointer :: val(:,:,:) => null()  ! [nchan x npix x ntimes] The DATA block
     real(kind=4), pointer :: wei(:)     => null()  ! [nchan] The WEIGHT array (use the same for all channels and pixels)
  end type imbfits_data_t
  !
  type imbfits_subscan_t
     integer(kind=4) :: isub = 0           ! Subscan number
     logical         :: onsky = .false.    ! Was the subscan looking at sky?
     integer(kind=4) :: calkind = 0        ! 0: not a cal, 1: sky/hot/cold, 2: grid  ZZZ useless?
     type(imbfits_backdata_t) :: backdata  !
     type(imbfits_antslow_t)  :: antslow   ! slow traces
     type(imbfits_antfast_t)  :: antfast   ! fast traces
  end type imbfits_subscan_t
  !
  integer(kind=4), parameter :: mstokes=4
  integer(kind=4), parameter :: code_n=0
  integer(kind=4), parameter :: code_h=1
  integer(kind=4), parameter :: code_v=2
  integer(kind=4), parameter :: code_r=3
  integer(kind=4), parameter :: code_i=4
  type stokesset_book_t
    integer(kind=4) :: nstokes        ! Number of chunksets per stokeset
    integer(kind=4) :: kind(mstokes)  ! Kind of each chunkset
    integer(kind=4) :: iset(mstokes)  ! Number of each chunkset
    logical         :: found          ! Found a stokesset?
    integer(kind=4) :: next           ! Next chunkset after the stokeset
  end type stokesset_book_t
  !
end module imbfits_types
!
module imbfits_messaging
  use gbl_message
  !---------------------------------------------------------------------
  ! This module provides:
  !  - the usual seve%? severities from the Gildas kernel (no need
  !    to USE GBL_MESSAGE)
  !  - the imbfits specific severities which can be dynamically changed
  !    thanks to the appropriate command
  !---------------------------------------------------------------------
  !
  type :: imbfits_debug_message_t
    integer(kind=4) :: alloc
    integer(kind=4) :: other
  end type imbfits_debug_message_t
  !
  ! Set the default at startup:
  !  iseve%alloc = seve%d
  !  iseve%other = seve%d
  type(imbfits_debug_message_t) :: iseve = imbfits_debug_message_t(seve%d,seve%d)
  !
end module imbfits_messaging

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_subcube2subcube_template
  use cubetemplate_messaging
  use cubetemplate_one2one_template
  !
  public :: subcube2subcube_comm_t,subcube2subcube_user_t,subcube2subcube_prog_t
  private
  !
  type, extends(one2one_comm_t) :: subcube2subcube_comm_t
  end type subcube2subcube_comm_t
  !
  type, extends(one2one_user_t) :: subcube2subcube_user_t
  end type subcube2subcube_user_t
  !
  type, extends(one2one_prog_t) :: subcube2subcube_prog_t
   contains
     procedure, private :: loop   => cubetemplate_subcube2subcube_prog_loop
     procedure, private :: act    => cubetemplate_subcube2subcube_prog_act
  end type subcube2subcube_prog_t
  !
contains
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_subcube2subcube_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(inout) :: iter
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>LOOP'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter,error)
      if (error) return
    enddo
  end subroutine cubetemplate_subcube2subcube_prog_loop
  !
  subroutine cubetemplate_subcube2subcube_prog_act(prog,iter,error)
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(subcube2subcube_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),      intent(in)    :: iter
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUBCUBE2SUBCUBE>PROG>ACT'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
  end subroutine cubetemplate_subcube2subcube_prog_act
end module cubetemplate_subcube2subcube_template
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_hyperbit
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cubeadm_cubeid_types
  use cubego_messaging
  !
  public :: hyperbit
  private
  !
  type :: bit_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(switch_comm_t)         :: header
   contains
     procedure, public  :: register => cubego_bit_register
     procedure, private :: parse    => cubego_bit_parse
     procedure, private :: main     => cubego_bit_main
  end type bit_comm_t
  type(bit_comm_t) :: hyperbit
  !
  integer(kind=4), parameter :: icube = 1
  type :: bit_user_t
     type(cubeid_user_t) :: cubeids
     type(switch_user_t) :: header
   contains
     procedure, private :: toprog => cubego_bit_user_toprog
  end type bit_user_t
  !
  type bit_prog_t
     type(switch_prog_t) :: header
   contains
     procedure, private :: act => cubego_bit_prog_act
  end type bit_prog_t
  !
contains
  !
  subroutine cubego_hyperbit_command(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(bit_user_t) :: user
    character(len=*),parameter :: rname='HYPERBIT>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call hyperbit%parse(line,user,error)
    if (error) return
    call hyperbit%main(user,error)
    if (error) return
    ! Force insertion in SIC stack ! *** JP Why?
    if (sic_lire().eq.0) call sic_insert(line)
  end subroutine cubego_hyperbit_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_bit_register(bit,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(bit_comm_t), intent(inout) :: bit
    logical,           intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='BIT>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'HYPERBIT','[cubeid]',&
         'Plot channel maps of a PPV cube',&
         'This is a tentative reimplementation of the BIT command.',&
         cubego_hyperbit_command,&
         bit%comm,&
         error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Identity of the cube to be viewed',&
         'If omitted, use the last matching cube (any family/flags) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read,&                    ! Indicative: data access done by procedure
         code_access_imaset_or_speset,& ! Indicative: data access done by procedure
         bit%cube,&
         error)
    if (error) return
    !
    call bit%header%register(&
         'HEADER',&
         'the header display',&
         'ON',&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubego_bit_register
  !
  subroutine cubego_bit_parse(comm,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(bit_comm_t), intent(inout) :: comm
    character(len=*),  intent(in)    :: line
    type(bit_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='BIT>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%header%parse(line,user%header,error)
    if (error) return
  end subroutine cubego_bit_parse
  !
  subroutine cubego_bit_main(comm,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(bit_comm_t), intent(in)    :: comm
    type(bit_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(bit_prog_t) :: prog
    character(len=*), parameter :: rname='BIT>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubego_bit_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_bit_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubego_buffer
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(bit_user_t), intent(in)    :: user
    type(bit_comm_t),  intent(in)    :: comm  
    type(bit_prog_t),  intent(out)   :: prog
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='BIT>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_user2prog(comm%comm,user%cubeids,cubes,error)
    if (error) return
    call cubes%defstruct(cubego,error)
    if (error) return
    !
    call prog%header%init(comm%header,error)
    if (error) return
    call user%header%toprog(comm%header,prog%header,error)
    if (error) return
  end subroutine cubego_bit_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_bit_prog_act(prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(bit_prog_t), intent(in)    :: prog
    logical,           intent(inout) :: error
    !
    character(len=*),parameter :: rname='BIT>PROG>ACT'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    if (prog%header%act) call exec_program('@ p-header.cube')
  end subroutine cubego_bit_prog_act
end module cubego_hyperbit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_library
  use cubedag_directory_type
  use cubeadm_setup
  use cubedag_snapshot
  use cubeadm_timing
  !
  public :: cubeadm_library_init,cubeadm_library_exit
  private
  !
contains
  !
  subroutine cubeadm_library_init(error)
    use gkernel_interfaces
    use cubedag_library
    use cubeformats_engine_types
    !---------------------------------------------------------------------
    ! Initialize the ADM library
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    logical :: autoreimport
    logical, parameter :: merge=.false.
    !
    ! Initialization of Directories list buffer
    call dir%init(error)
    if (error) return
    call dir%sicdef(error)
    if (error) return
    !
    call cubedag_library_init(error)
    if (error) return
    call cubeformats_types_register(cubset,error)
    if (error) return
    !
    ! Implicit import of the previous snapshot, if any
    autoreimport = .true.
    ier = sic_getlog('CUBE_REIMPORT_AUTO',autoreimport)
    if (autoreimport) then
      call cubedag_snapshot_reimport(cubedag_snapshot_dagname(),  &
                                    cubedag_snapshot_histname(),  &
                                    merge,                        &
                                    .true.,error)
      if (error) then
        ! We should not stop the program initialization...
        error = .false.
      endif
    endif
    !
    call cubeadm_timing_variables(error)
    if (error) return
    !
  end subroutine cubeadm_library_init
  !
  subroutine cubeadm_library_exit(error)
    use cubedag_library
    !---------------------------------------------------------------------
    ! Exit the ADM library
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubedag_library_exit(error)
    if (error) continue
  end subroutine cubeadm_library_exit

end module cubeadm_library
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine stamp(set,line,error,user_function)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>stamp
  use class_index
  use class_types
  use class_popup
  use plot_formula
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! CLASS Support routine for command
  !   STAMP [NX NY] [/LABEL [SCAN|NUMBER|SOURCE|LINE]]
  ! Makes a plot of "stamp format" spectra for NX by NY data of the
  ! index.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Input command line
  logical,             intent(inout) :: error          ! Logical error flag
  logical,             external      :: user_function  ! intent(in)
  ! Local
  character(len=*), parameter :: rname='STAMP'
  type(observation) :: obs
  logical :: err_local
  integer :: nx,ny,nchar,ier,check_kind
  integer(kind=entry_length) :: nsp,isp,is
  real(kind=4) :: celx,cely,cdef0,cdef
  real(kind=plot_length) :: gx1new,gx2new,gy1new,gy2new,guynew,gx1s,gx2s,gy1s,gy2s,gxs
  character(len=80) :: ch
  !
  integer(kind=4) :: i, nc, nkey1
  integer(kind=4), parameter :: mvoc1=4
  character(len=12) :: voc1(mvoc1),arg1,key1
  logical :: doit(mvoc1)
  data voc1 /'NUMBER','SCAN','SOURCE','LINE'/
  integer(kind=4) :: inumb=1
  integer(kind=4) :: iscan=2
  integer(kind=4) :: isour=3
  integer(kind=4) :: iline=4
  !
  err_local = .false.
  check_kind = 0
  !
  ! Basic checks
  if (.not.filein_opened(rname,error))  return
  if (cx%next.le.1) then
     call class_message(seve%e,rname,'Index is empty')
     error = .true.
  endif
  if (error) return
  !
  if (set%modex.ne.'F') then
     call class_message(seve%w,rname,'Mode X is not fixed')
  endif
  if (set%modey.ne.'F') then
     call class_message(seve%w,rname,'Mode Y is not fixed')
  endif
  !
  ! Decode arguments
  nx = 0
  ny = 0
  call sic_i4(line,0,1,nx,.false.,error)
  if (error) return
  call sic_i4(line,0,2,ny,.false.,error)
  if (error) return
  !
  doit = .false.
  if (sic_present(1,0)) then
    do i=1,sic_narg(1)
      call sic_ke(line,1,i,arg1,nc,.false.,error)
      call sic_ambigs(rname,arg1,key1,nkey1,voc1,mvoc1,error)
      !
      if (error) return
      doit(nkey1) = .true.
    enddo
  endif
  !
  call gtclear
  ! get character size
  call sic_get_real('CHARACTER_SIZE',cdef,error)
  if (error) return
  cdef0 = cdef
  if (any(doit)) then
     cdef  = 0.5*cdef
     write(ch,1000) 'SET CHAR',cdef
     call gr_exec(ch(1:23))
     error = gr_error()
     if (error) return
  endif
  !
  ! First loop through headers to count records
  nsp = 0
  !
  ! First Loop to define how many Spectra
  call init_obs(obs)
  nsp = cx%next-1
  if (nx.lt.1) nx = nint(sqrt(1.*nsp))
  if (ny.lt.1) then
     ny = nsp/nx
     if (ny*nx .lt. nsp) ny=ny+1
  endif
  if (ny*nx.lt.nsp) call class_message(seve%w,rname,'More spectra in index than plotted')
  !
  ! Allocate IPOP  pointers,
  ! as well as XPOP and YPOP
  npop = min(nx*ny,nsp)
  if (allocated(ipop)) deallocate(ipop,xpop,ypop)
  allocate(ipop(npop),xpop(npop),ypop(npop),stat=ier)
  if (ier.ne.0) then
     call class_message(seve%e,rname,'Allocation error')
     error = .true.
     npop = 0
     goto 999
  endif
  !
  ! Get current GreG Box
  call get_box(gx1new,gx2new,gy1new,gy2new)
  !
  ! Define grid
  guynew=(gy2new-gy1new)/(guy2-guy1)
  !
  ! Size of a cell (cm)
  celx = (gx2new-gx1new)/nx
  cely = (gy2new-gy1new)/ny
  gx1s = gx1new
  gy1s = gy1new
  !
  ! Plot
  !
  ! Loop on spectra
  isp = 0
  do is=1,cx%next-1
     call get_it(set,obs,cx%ind(is),user_function,error)
     if (error) goto 999
     call newdat(set,obs,error)
     if (error) goto 999
     ! Abort if <^C>
     if (sic_ctrlc()) goto 999
     if (check_kind.eq.0) check_kind = obs%head%gen%kind
     if (obs%head%gen%kind.ne.check_kind) then
        write(ch,*) 'Inconsistent type of data ',obs%head%gen%kind,check_kind
        call class_message(seve%w,rname,ch)
        cycle ! Next spectrum
     endif
     !
     ! Define position of spectra
     gx2s = gx1s + celx
     gy2s = gy1s + cely
     write(ch,1000) 'SET BOX',gx1s,gx2s,gy1s,gy2s
     call gr_exec(ch)
     error = gr_error()
     if (error) goto 999
     isp = isp+1
     npop = isp
     ipop(isp) = obs%head%gen%num
     !
     ! Define plot limits
     guy  = (gy2s-gy1s)/(guy2-guy1)
     gux = (gx2s-gx1s)/(gux2-gux1)
     !
     ! Plot the 1D spectra
     call spectr1d(rname,set,obs,error)
     !
     ! Plot the grid if needed
     call gr_exec('BOX N N N')
     !
     ! Write the scan number if needed
     if (doit(inumb)) then
        write(ch,'(I0,A1,I2)') obs%head%gen%num,';',obs%head%gen%ver
        call sic_black(ch,nchar)
        call grelocate(gx1s,gy2s)
        call gr_exec ('LABEL "'//ch(1:nchar)//'" /CENTER 3')
     endif
     if (doit(iscan)) then
        write(ch,'(I0,A1,I2)') obs%head%gen%scan,'.',obs%head%gen%subscan
        call sic_black(ch,nchar)
        call grelocate(gx2s,gy2s)
        call gr_exec ('LABEL "'//ch(1:nchar)//'" /CENTER 1')
     endif
     if (doit(isour)) then
        gxs = 0.5*(gx1s+gx2s)
        call grelocate(gxs,gy2s)
        call gr_exec ('LABEL "'//obs%head%pos%sourc//'" /CENTER 2')
     endif
     if (doit(iline)) then
        gxs = 0.5*(gx1s+gx2s)
        call grelocate(gxs,gy1s)
        call gr_exec ('LABEL "'//obs%head%spe%line//'" /CENTER 8')
     endif
     ! next position
     gx1s = gx1s+celx
     if (gx1s.gt.gx2new-0.5*celx) then
        gx1s = gx1new
        gy1s = gy1s + cely
     endif
     !
     ! Exit if enough scan plotted
     if (isp.eq.nx*ny) exit
  enddo
  !
  ! Restore current values
999 continue
  !
  call free_obs(obs)
  !
  cdef = cdef0
  write(ch,1000) 'SET CHAR',cdef0
  call gr_exec(ch)
  err_local = gr_error()
  gx1s=gx1new
  gx2s=gx2new
  gy1s=gy1new
  gy2s=gy2new
  guy=guynew
  write(ch,1000) 'SET BOX',gx1s,gx2s,gy1s,gy2s
  call gr_exec(ch)
  err_local = gr_error()
  !
  ! Save for POPUP commands.
  cpop = cpop_stamp
  pgx1 = gx1s
  pgx2 = gx2s
  pgy1 = gy1s
  pgy2 = gy2s
  pux1 = 0.5
  pux2 = nx+0.5
  puy1 = 0.5
  puy2 = ny+0.5
  !
1000 format(a,4(1x,g14.7))
end subroutine stamp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_ancillary_init_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  !
  public :: ancillary_init_comm_t,ancillary_init_user_t,ancillary_init_prog_t
  private
  !
  type, extends(ancillary_cube_comm_t) :: ancillary_init_comm_t
   contains
     procedure, public :: register => cubemain_ancillary_init_comm_register
  end type ancillary_init_comm_t
  !
  type, extends(ancillary_cube_user_t) :: ancillary_init_user_t
     ! Empty for the moment
  end type ancillary_init_user_t
  !
  type, extends(ancillary_cube_prog_t) :: ancillary_init_prog_t
     ! Empty for the moment
  end type ancillary_init_prog_t
  !
contains
  !
  subroutine cubemain_ancillary_init_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Register an optional "/INIT [initid]" key
    !----------------------------------------------------------------------
    class(ancillary_init_comm_t), intent(inout) :: comm
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='ANCILLARY>INIT>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call comm%fully_register(&
         'PARAMETERS','[parameterid]',&
         'Reuse a fit-results cube as initial guesses',&
         'Use /PARAMETERS to reuse the fit-results cube produced by&
         & FIT\MINIMIZE as initial guesses. The ancillary cube must follow&
         & the FIT\MINIMIZE output layout.',&
         'PARAMETERS',&
         'Fit-results cube identifier',&
         [flag_minimize],&
         code_arg_optional,&
         code_read,&
         code_access_speset,&
         error)
    if (error) return
  end subroutine cubemain_ancillary_init_comm_register
end module cubemain_ancillary_init_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_ppv2xyv
  use cube_types 
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubemain_ancillary_weight_types
  use cubetopology_cuberegion_types
  use cubehistogram_messaging
  !
  public :: ppv2xyv
  private
  !
  type :: ppv2xyv_comm_t
     type(option_t), pointer :: comm
!     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: fromto
     type(cubeid_arg_t), pointer :: histo2d
     type(ancillary_weight_comm_t) :: ppvwei
     type(cubeid_arg_t), pointer :: ppvsig
     type(cube_prod_t),  pointer :: xyvsig
   contains
     procedure, public  :: register => cubehistogram_ppv2xyv_comm_register
     procedure, private :: parse    => cubehistogram_ppv2xyv_comm_parse
     procedure, private :: main     => cubehistogram_ppv2xyv_comm_main
  end type ppv2xyv_comm_t
  type(ppv2xyv_comm_t) :: ppv2xyv  
  !
  type ppv2xyv_user_t
     type(cubeid_user_t)           :: cubeids
     type(ancillary_weight_user_t) :: ppvwei
!     type(cuberegion_user_t)      :: region
   contains
     procedure, private :: toprog => cubehistogram_ppv2xyv_user_toprog
  end type ppv2xyv_user_t
  !
  type ppv2xyv_prog_t
!     type(cuberegion_prog_t) :: region
     type(cube_t), pointer         :: fromto
     type(cube_t), pointer         :: histo2d
     type(ancillary_weight_prog_t) :: ppvwei
     type(cube_t), pointer :: ppvsig
     type(cube_t), pointer :: xyvsig
     procedure(cubehistogram_ppv2xyv_prog_loop_with_weight), pointer :: loop => null()
   contains
     procedure, private :: header             => cubehistogram_ppv2xyv_prog_header
     procedure, private :: data               => cubehistogram_ppv2xyv_prog_data
     procedure, private :: act_without_weight => cubehistogram_ppv2xyv_prog_act_without_weight
     procedure, private :: act_with_weight    => cubehistogram_ppv2xyv_prog_act_with_weight
  end type ppv2xyv_prog_t
  !
contains
  !
  subroutine cubehistogram_ppv2xyv_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ppv2xyv_user_t) :: user
    character(len=*), parameter :: rname='PPV2XYV>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call ppv2xyv%parse(line,user,error)
    if (error) return
    call ppv2xyv%main(user,error)
    if (error) continue
  end subroutine cubehistogram_ppv2xyv_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='PPV2XYV>COMM>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'PPV2XYV','[ppvid fromtoid histo2did]',&
         'Build one stacked spectrum per 2D histogram bin',&
         'Group together the spectra of all pixels that fall in the&
         & same 2D histogram bin. The result is one stacked spectrum&
         & for each bin of the histogram.'//strg_bl//&
         'Behavior:'//strg_cr//&
         'Use PPV as the input Position-Position-Velocity cube, FROMTO&
         & as the pointer product from HISTO2D, and HISTO2D as the&
         & reference histogram layout. For each channel map, CUBE&
         & accumulates the PPV pixels that point to the same XY bin and&
         & writes their mean value into XYV.'//strg_cr//&
         'Use /WEIGHT to switch from plain to weighted averaging. The&
         & XYV spatial geometry follows HISTO2D.'//strg_bl//&
         'Notes:'//strg_cr//&
         'You may omit ppvid, fromtoid, and histo2did when the intended&
         & inputs are unambiguous. Query PPVID ?, FROMTOID ?, or&
         & HISTO2DID ? for the fallback used by each argument.'//&
         strg_cr//&
         'If FROMTO contains indices outside the HISTO2D layout, the&
         & command prints raw diagnostics and continues.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'Build the 2D histogram and keep its Pointer product, then&
         & stack the PPV cube in histogram space.'//strg_cr//&
         'CUBE> HISTOGRAM\HISTO2D xcube ycube'//strg_cr//&
         'CUBE> HISTOGRAM\PPV2XYV ppv Pointer histo2d [/WEIGHT weight]'//strg_cr//&
         'CUBE> HISTOGRAM\XY2PP ppin Pointer xyv.',&
         cubehistogram_ppv2xyv_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'PPVID',&
         'Position-Position-Velocity cube identifier',&
         'Input PPV cube to stack in XY histogram space.'//strg_cr//&
         'If ppvid is omitted, CUBE uses the standard CubeID fallback&
         & in the default index (DAG by default; see SET\INDEX) and&
         & keeps the last matching product.'//strg_cr//&
         'This fallback is intentionally broad, so give ppvid&
         & explicitly unless the input cube is obvious.',&
         code_arg_optional,&
         !         [flag_ppv,flag_cube],&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%ppvsig,&
         error)
    if (error) return
    call incube%register(&
         'FROMTOID',&
         'From PP to XY cube identifier',&
         'Index image explaining how to go from a PP image to a bin of&
         & XY HISTO2D values.'//strg_cr//&
         'If fromtoid is omitted, CUBE uses the last matching HISTO2D&
         & Pointer product in the default index (DAG by default; see&
         & SET\INDEX).',&
         code_arg_optional,&
         [flag_histo2d,flag_pointer],&
         code_read,&
         code_access_imaset,&
         comm%fromto,&
         error)
    if (error) return
    call incube%register(&
         'HISTO2DID',&
         '2D histogram identifier',&
         'Reference HISTO2D product that defines the XY layout of the&
         & output cube.'//strg_cr//&
         'If histo2did is omitted, CUBE uses the last matching HISTO2D&
         & product in the default index (DAG by default; see&
         & SET\INDEX).',&
         code_arg_optional,&
         [flag_histo2d],&
         code_read_head,&
         code_access_imaset,&
         comm%histo2d,&
         error)
    if (error) return
    call comm%ppvwei%register(&
         'Weight the XY-bin averages',&
         code_access_imaset,&
         error)
    if (error) return
!    call comm%region%register(error)
!    if (error) return
    !
    ! Products
    call oucube%register(&
         'XYV',&
         'X-Y-Velocity cube',&
         strg_emp,&
         [flag_xyv,flag_cube],&
         comm%xyvsig,&
         error)
    if (error)  return
  end subroutine cubehistogram_ppv2xyv_comm_register
  !
  subroutine cubehistogram_ppv2xyv_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! PPV2XYV ppvid fromtoid histo2did
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    type(ppv2xyv_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>COMM>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%ppvwei%parse(line,user%ppvwei,error)
    if (error) return
!!$    call comm%region%parse(line,user%region,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_comm_parse
  !
  subroutine cubehistogram_ppv2xyv_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    type(ppv2xyv_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(ppv2xyv_prog_t) :: prog
    character(len=*), parameter :: rname='PPV2XYV>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_ppv2xyv_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_user_t), intent(in)    :: user
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    type(ppv2xyv_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>USER>TOPROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%ppvsig,user%cubeids,prog%ppvsig,error)
    if (error) return
    call user%ppvwei%toprog(comm%ppvwei,prog%ppvwei,error)
    if (error) return
    call prog%ppvwei%check_consistency(prog%ppvsig,error)
    if (error) return
    call cubeadm_get_header(comm%fromto,user%cubeids,prog%fromto,error)
    if (error) return
    call cubeadm_get_header(comm%histo2d,user%cubeids,prog%histo2d,error)
    if (error) return
    if (prog%ppvwei%do) then
       prog%loop => cubehistogram_ppv2xyv_prog_loop_with_weight
    else
       prog%loop => cubehistogram_ppv2xyv_prog_loop_without_weight
    endif
!!$    call user%region%toprog(prog%fromto,prog%region,error)
!!$    if (error) return
    !
    ! User feedback about the interpretation of his command line
!!$    call prog%region%list(error)
!!$    if (error) return    
  end subroutine cubehistogram_ppv2xyv_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%xyvsig,prog%ppvsig,prog%xyvsig,error)
    if (error) return
    call cubetools_header_spatial_like(prog%histo2d%head,prog%xyvsig%head,error)
    if (error) return
!!$    call prog%region%header(prog%xyvsig,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_header
  !
  subroutine cubehistogram_ppv2xyv_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PPV2XYV>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubehistogram_ppv2xyv_prog_data
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_loop_without_weight(prog,iter,error)
    use cubeadm_taskloop
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: fromto
    type(image_t) :: ppsig,xysig
    type(dble_2d_t) :: xysum
    type(long_2d_t) :: xywei
    character(len=*), parameter :: rname='PPV2XYV>PROG>LOOP>WITHOUT>WEIGHT'
    !
    call fromto%associate('fromto',prog%fromto,iter,error)
    if (error) return
    call ppsig%associate('ppsig',prog%ppvsig,iter,error)
    if (error) return
    call xysig%allocate('xysig',prog%xyvsig,iter,error)
    if (error) return
    call xysum%reallocate('xysum',xysig%nx,xysig%ny,error)
    if (error) return
    call xywei%reallocate('xywei',xysig%nx,xysig%ny,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act_without_weight(iter%ie,fromto,ppsig,xysig,xysum,xywei,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_ppv2xyv_prog_loop_without_weight
  !
  subroutine cubehistogram_ppv2xyv_prog_act_without_weight(&
       prog,ie,fromto,ppsig,xysig,xysum,xywei,error)
    use cubetools_nan
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: fromto
    type(image_t),         intent(inout) :: ppsig
    type(image_t),         intent(inout) :: xysig
    type(dble_2d_t),       intent(inout) :: xysum
    type(long_2d_t),       intent(inout) :: xywei
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy
    integer(kind=indx_k) :: index
    integer(kind=long_k), parameter :: zero=0
    character(len=*), parameter :: rname='PPV2XYV>PROG>ACT>WITHOUT>WEIGHT'
    !
    call fromto%get(ie,error)
    if (error) return
    call ppsig%get(ie,error)
    if (error) return
    ! Initialize
    call xywei%set(zero,error)
    if (error) return
    call xysum%set(0d0,error)
    if (error) return
    ! Sum the input pixels using the fromto mask
    do iy=1,fromto%ny
       do ix=1,fromto%nx
          if (ieee_is_nan(fromto%val(ix,iy))) cycle
          index = fromto%val(ix,iy)
          if (index.eq.0) cycle
          jx = 1+mod(index-1,xysig%nx)
          jy = 1+(index-jx)/xysig%nx
          ! The user can provide an inconsistent set of fromto and histo2d images!
          if ((1.le.jx).and.(jx.le.xywei%nx).and.(1.le.jy).and.(jy.le.xywei%ny)) then
             xywei%val(jx,jy) = xywei%val(jx,jy) + 1
             xysum%val(jx,jy) = xysum%val(jx,jy) + ppsig%val(ix,iy)
          else
             ! ***JP: Some shorter feedback to user? For instance counting
             ! ***JP: the number of points outside and stating it at the end?
             print *,jx,jy,xywei%nx,xywei%ny
          endif
       enddo ! ix
    enddo ! iy
    ! Compute xy
    do iy=1,xysig%ny
       do ix=1,xysig%nx
          if (xywei%val(ix,iy).ne.zero) then
             xysig%val(ix,iy) = xysum%val(ix,iy)/xywei%val(ix,iy)
          else
             xysig%val(ix,iy) = gr4nan
          endif
       enddo ! ix
    enddo ! iy
    call xysig%put(ie,error)
    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_act_without_weight
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_loop_with_weight(prog,iter,error)
    use cubeadm_taskloop
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: fromto
    type(image_t) :: ppsig,ppwei,xysig
    type(dble_2d_t) :: xysum,xywei
    character(len=*), parameter :: rname='PPV2XYV>PROG>LOOP>WITH>WEIGHT'
    !
    call fromto%associate('fromto',prog%fromto,iter,error)
    if (error) return
    call ppsig%associate('ppsig',prog%ppvsig,iter,error)
    if (error) return
    call ppwei%associate('ppwei',prog%ppvwei%cube,iter,error)
    if (error) return
    call xysig%allocate('xysig',prog%xyvsig,iter,error)
    if (error) return
    call xysum%reallocate('xysum',xysig%nx,xysig%ny,error)
    if (error) return
    call xywei%reallocate('xywei',xysig%nx,xysig%ny,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act_with_weight(iter%ie,fromto,ppsig,ppwei,xysig,xysum,xywei,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_ppv2xyv_prog_loop_with_weight
  !
  subroutine cubehistogram_ppv2xyv_prog_act_with_weight(&
       prog,ie,fromto,ppsig,ppwei,xysig,xysum,xywei,error)
    use cubetools_nan
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: fromto
    type(image_t),         intent(inout) :: ppsig
    type(image_t),         intent(inout) :: ppwei
    type(image_t),         intent(inout) :: xysig
    type(dble_2d_t),       intent(inout) :: xysum
    type(dble_2d_t),       intent(inout) :: xywei
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy
    integer(kind=indx_k) :: index
    real(kind=dble_k), parameter :: zero=0d0
    character(len=*), parameter :: rname='PPV2XYV>PROG>ACT>WITH>WEIGHT'
    !
    call fromto%get(ie,error)
    if (error) return
    call ppsig%get(ie,error)
    if (error) return
    call ppwei%get(ie,error)
    if (error) return
    ! Initialize
    call xywei%set(zero,error)
    if (error) return
    call xysum%set(zero,error)
    if (error) return
    ! Sum the input pixels using the fromto mask
    do iy=1,fromto%ny
       do ix=1,fromto%nx
          if (ieee_is_nan(fromto%val(ix,iy))) cycle
          if (ieee_is_nan(ppsig%val(ix,iy)))  cycle
          if (ieee_is_nan(ppwei%val(ix,iy)))  cycle
          index = fromto%val(ix,iy)
          if (index.eq.0) cycle
          jx = 1+mod(index-1,xysig%nx)
          jy = 1+(index-jx)/xysig%nx
          ! The user can provide an inconsistent set of fromto and histo2d images!
          if ((1.le.jx).and.(jx.le.xywei%nx).and.(1.le.jy).and.(jy.le.xywei%ny)) then
             xywei%val(jx,jy) = xywei%val(jx,jy) + ppwei%val(ix,iy)
             xysum%val(jx,jy) = xysum%val(jx,jy) + ppwei%val(ix,iy)*ppsig%val(ix,iy)
          else
             ! ***JP: Some shorter feedback to user? For instance counting
             ! ***JP: the number of points outside and stating it at the end?
             print *,jx,jy,xywei%nx,xywei%ny
          endif
       enddo ! ix
    enddo ! iy
    ! Compute xy
    do iy=1,xysig%ny
       do ix=1,xysig%nx
          if (xywei%val(ix,iy).ne.zero) then
             xysig%val(ix,iy) = xysum%val(ix,iy)/xywei%val(ix,iy)
          else
             xysig%val(ix,iy) = gr4nan
          endif
       enddo ! ix
    enddo ! iy
    call xysig%put(ie,error)
    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_act_with_weight
end module cubehistogram_ppv2xyv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_residual
  use gbl_message
  !
  public :: uv_residual_comm,uv_residual_main
  private
  !
contains
  !
  subroutine uv_residual_comm(line,error)
    use gkernel_interfaces
    use file_buffers
    use uv_buffers
    use clean_buffers
    use uvmap_buffers, only: uvmap_prog
    !$ use omp_lib
    !------------------------------------------------------------------------
    ! Support routine for command UV_RESIDUAL
    !     Remove all Clean Components from a UV Table
    !
    ! Input :
    !     a precessed UV table
    !     a list of Clean Components, in DCCT format
    !      i.e. (x,y,v)(iplane,icomponent)
    !     this organisation is not efficient, and one may need to switch to
    !           (x,y,v,)(icomponent,iplane)
    !     which is more easily transmitted
    ! Output :
    !     a precessed, rotated, shifted UV table, sorted in V,
    !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    real, pointer :: duv_previous(:,:),duv_next(:,:)
    character(len=*), parameter :: rname='UV_RESIDUAL'
    !
    if (uvmap_prog%nfields.ne.0) then
       call map_message(seve%w,rname,'UV data is a Mosaic - UNDER TESTS !!!')
    endif
    !
    nullify(duv_previous,duv_next)
    !
    call uv_residual_main(rname,line,duv_previous,duv_next,.false.,error)
    if (error) return
    !
    ! Clean the allocated stuff here to keep only the residual...
    call uv_clean_buffers(duv_previous, duv_next,error)
    if (error) return
    !
    if (allocated(uvtb%data)) deallocate (uvtb%data)            ! UV data not plotted
    uv_plotted = .false.
    !
    ! Indicate optimization and save status
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    !
    ! Not needed here: weights are unchanged
    ! do_weig = .true.  ! Recompute weight 
    !
    ! Resize UV data and redefine SIC variables 
    huv%gil%nvisi = ubound(duv,2)
    huv%gil%dim(2) = huv%gil%nvisi
    !
    call sic_delvariable ('UV',.false.,error)
    call sic_def_real ('UV',duv,huv%gil%ndim,huv%gil%dim,.true.,error)
  end subroutine uv_residual_comm
  !
  subroutine uv_residual_main(rname,line,duv_previous,duv_next,do_clean,error)
    use phys_const, only: pi
    use image_def
    use gkernel_interfaces
    use mapping_primary
    use uvmap_tool
    use uvmosaic_tool, only: mosaic_sort
    use uv_buffers
    use uvmap_buffers
    use clean_buffers
    !$ use omp_lib
    !------------------------------------------------------------------------
    ! Remove all Clean Components from a UV Table
    !
    ! Input :
    !     a precessed UV table
    !     a list of Clean Components, in DCCT format
    !      i.e. (x,y,v)(iplane,icomponent)
    !     this organisation is not efficient, and one may need to switch to
    !           (x,y,v,)(icomponent,iplane)
    !     which is more easily transmitted
    ! Output :
    !     a precessed, rotated, shifted UV table, sorted in V,
    !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
    !------------------------------------------------------------------------
    character(len=*), intent(in)    :: rname
    character(len=*), intent(in)    :: line
    real, pointer,    intent(out)   :: duv_previous(:,:)
    real, pointer,    intent(out)   :: duv_next(:,:)
    logical,          intent(in)    :: do_clean
    logical,          intent(inout) :: error
    !
    real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
    !
    real(8) :: freq
    real :: cpu0, cpu1
    integer :: ier,nu,nv,nchan
    !
    real, pointer :: duv_in(:,:),duv_out(:,:)
    real, allocatable :: ccou(:,:,:),lduv(:,:)
    integer, allocatable :: mic(:)
    integer :: maxic,ic,lc,icmax,oic,olc,istep,iv,ichan
    integer :: othread,nthread,ithread,sblock
    logical :: fast
    real(8) :: elapsed_s,elapsed_e,elapsed
    real(4) :: rmega
    ! For mosaics
    real(4) :: beamp(3),bsize
    integer :: ifield, jfield,nfields ! Field number & Number of fields
    real, allocatable :: doff(:,:)    ! Field offsets
    integer, allocatable :: ivoff(:)  ! Input Visibility pointers
    integer, allocatable :: jvoff(:)  ! Output Visibility pointers
    integer :: mv ! Maximum number of Visibilities per field
    integer :: ivstart,ivend,kvstart,kvend
    logical :: sorted,shift
    real(8) :: new(3)
    real(4) :: uvmin,uvmax
    logical, parameter :: fromressection=.true.
    !
    character(len=message_length) :: mess
    !
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    nchan = huv%gil%nchan !! (nu-7)/3
    ic = 1
    lc = nchan
    ithread = 1
    nthread = 1
    elapsed_e = 0.
    elapsed_s = 0.
    elapsed = 0.
    error = .false.
    !
    beamp(:) = 0.
    !
    ! Subtract all Clean Components
    if (.not.associated(duv)) then
       call map_message(seve%e,rname,'DUV is NOT allocated')
       error = .true.
       return
    endif
    if (.not.allocated(cct%data)) then
       call map_message(seve%e,rname,'DCCT is NOT allocated')
       error = .true.
       return
    endif
    !
    maxic = cct%head%gil%dim(3)
    call sic_i4(line,0,1,maxic,.false.,error)
    if (error) return
    if (maxic.lt.0) maxic = cct%head%gil%dim(3)
    maxic = min(cct%head%gil%dim(3),maxic)
    if (maxic.eq.0) return ! Nothing to do then...
    !
    allocate (mic(nchan),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    !
    ! Compact the Clean components first
    cct%head%r3d => cct%data
    call uv_clean_sizes(cct%head,cct%head%r3d,mic,ic,lc)
    icmax = maxval(mic)
    !
    ! Nothing to do if not Clean component
    if (icmax.eq.0) then
       call map_message(seve%w,rname,'No valid Clean Component')
       return
    endif
    !
    fast = .true.
    call sic_get_logi('FAST',fast,error)
    error = .false.
    !
    call gag_cpu(cpu0)
    !
    if (uvmap_prog%nfields.ne.0) then
       shift = .false.
       sorted = .false.
       error = .false.
       call mosaic_sort(error,sorted,shift,new,uvmax,uvmin, &
            & huv%gil%column_pointer(code_uvt_xoff), &
            & huv%gil%column_pointer(code_uvt_yoff), &
            & nfields,doff,ivoff)
       if (error) return
       allocate(jvoff(nfields+1),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       !
       ! Compute max number of visibilities per field
       mv = 0
       do ifield=1,nfields
          mv  = max(mv,ivoff(ifield+1)-ivoff(ifield))
       enddo
       !
       ! Get primary beam size
       call get_bsize(huv,rname,' ',fromressection,bsize,error)
       !
       if (selected_fieldsize.ne.0) then
          if (.not.allocated(selected_fields)) then
             call map_message(seve%f,rname, &
                  & 'Programming error, Selected_Fields not allocated')
             error = .true.
             return
          endif
          nv = 1
          do jfield=1,selected_fieldsize
             ifield = selected_fields(jfield)
             jvoff(jfield) = nv
             nv = nv + ivoff(ifield+1)-ivoff(ifield)
             jvoff(jfield+1) = nv
          enddo
          nv = nv-1
          nfields = selected_fieldsize
       else
          jvoff = ivoff
       endif
    else
       nfields = 1
       allocate(doff(2,1),ivoff(2),jvoff(2),stat=ier)
       doff = 0.0
       bsize = 0.
       ivoff(1) = 1
       ivoff(2) = nv+1
       jvoff = ivoff
       mv = nv
    endif
    !
    ! Prepare appropriate array...
    nullify (duv_previous, duv_next)
    call uv_find_buffers(rname,nu,nv,duv_previous, duv_next,error)
    if (error) then
       call map_message(seve%e,rname,'Cannot set buffer pointers')
       return
    endif
    !
    ! Redo that by block - At this stage NFIELDS is the actual number
    ! of selected fields.
    !
    oic = ic    ! This must be 1
    olc = lc    ! This must be nchan
    !
    ! Divide in as many blocks as threads
    othread = 1
    !$  othread = omp_get_max_threads()
    nthread = min(othread,nchan)
    !
    ! Parallelism is most appropriate per plane
    if (nthread.gt.nfields .and. fast) then
       !$  call omp_set_num_threads(nthread)
       !
       ! The code here is for Mosaics
       !   - identification of the Visiblity Ranges 
       !   - Loop over all fields
       !   - Replaced loop over 1,NV  by  IvStart,IvEnd for each range    !
       !   - Multiply the CCT Table by appropriate primary beam,
       !     after squeezing of course - This is done in the
       !     uv_removes and uv_removes_clean routines, by 
       !     additional arguments (0 if no beam),
       !     as the values of CCT are used there only.
       ! 
       ! The loop is done by using Pointers
       !     DUV_IN  => DUV(:,IvStart:IvEnd)
       ! and DUV_OUT => DUV_NEXT(:,IvStart:IvEnd)
       deallocate(mic)
       !
       ! With this formula, we need as much work space as the original
       ! UV data set - That may be huge...
       istep = (nchan+nthread-1)/nthread      
       ! Here we limit to SPACE_MAPPING per thread
       ! The FFT size is not accounted for, however, in either case...
       ier = sic_ramlog('SPACE_MAPPING',rmega)
       sblock = max(int(256.0*rmega*1024.0)/(3*(nv+icmax)),1)
       istep = min(istep,sblock)
       !
       ! Allocate to Max number of visibilities...
       allocate(mic(istep),ccou(3,icmax,istep),lduv(1:7+3*istep,mv),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       !
       do jfield=1,nfields
          ifield = selected_fields(jfield)
          ivstart = ivoff(ifield)      ! Starting Visibility of field
          ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
          kvstart = jvoff(jfield)      ! Starting Visibility of field
          kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
          write(mess,'(A,I0,A)') 'Processing field # ',ifield
          call map_message(seve%i,rname,mess)
          nv = ivend-ivstart+1
          duv_in => duv(:,ivstart:ivend)
          duv_out => duv_next(:,kvstart:kvend)
          beamp(1) = bsize
          beamp(2) = doff(1,ifield)
          beamp(3) = doff(2,ifield)
          !
          !$OMP PARALLEL DEFAULT(NONE) &
          !$OMP SHARED(oic,olc,istep,nchan,nthread,fast, beamp) &
          !$OMP SHARED(nv,elapsed_s,elapsed_e,elapsed) &
          !$OMP SHARED(dirty,huv,cct,duv_next,duv) PRIVATE(ccou,lduv) &
          !$OMP PRIVATE(iv,ic,lc,ichan,icmax,mic,freq,ithread) &
          !$OMP SHARED(duv_in,duv_out,ifield) &
          !$OMP SHARED(clean,do_clean)
          !
          !$ ithread = omp_get_thread_num()+1
          !$ elapsed_s = omp_get_wtime()
          !$OMP DO SCHEDULE(DYNAMIC)
          do ic=oic,olc,istep
             lc = min(ic+istep-1,nchan)
             ichan = lc-ic+1
             call uv_clean_sizes(cct%head,cct%head%r3d,mic,ic,lc)
             icmax = maxval(mic(1:ichan))
             !
             if (icmax.ne.0) then
                call uv_squeeze_clean(ichan,cct%head%r3d,ccou, mic(1:ichan),ic,lc)
                freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
                if (.not.fast) then
                   call uv_removes_clean(huv,duv_in,lduv,lc-ic+1,mic(1:ichan), &
                        ccou,freq,ic,lc,beamp)
                else
                   call uv_removef_clean(dirty%head,duv_in,lduv,lc-ic+1,mic(1:ichan), &
                        ccou,freq,ic,lc,beamp)
                endif
                !
                ! Plunge it in the output UV data
                do iv=1,nv
                   duv_out(8+3*(ic-1):10+3*(lc-1),iv) = lduv(8:10+3*(lc-ic),iv)
                enddo
                !
                ! Compute the CLEAN image
                if (do_clean) then
                   call generate_clean(clean%head,oic,olc,ccou,mic)
                endif
             else
                do iv=1,nv
                   duv_out(8+3*(ic-1):10+3*(lc-1),iv) = duv_in(8+3*(ic-1):10+3*(lc-1),iv) 
                enddo
             endif
             !
          enddo
          !$OMP END DO
          !$OMP END PARALLEL
          !
          ! Put trailing columns if any
          if (huv%gil%lcol.lt.huv%gil%dim(1)) then
             do iv=1,nv
                ! Already done !          duv_out(1:7,iv) = duv_in(1:7,iv)
                duv_out(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
                     & duv_in(huv%gil%lcol+1:huv%gil%dim(1),iv)  
             enddo
          endif
       enddo ! Loop on fields
       !$  call omp_set_num_threads(othread)
       !$  elapsed_e = omp_get_wtime()
       !$  elapsed = elapsed_e - elapsed_s
    else
       !
       ! Simple sequential stuff - parallelism is inside the
       !   uv_remove_...  subroutines to avoid memory issues
       allocate(ccou(3,icmax,nchan),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
       endif
       call uv_squeeze_clean(nchan,cct%head%r3d,ccou, mic,ic,lc)
       freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
       !
       do jfield=1,nfields
          ifield = jfield
          if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)
          ivstart = ivoff(ifield)      ! Starting Visibility of field
          ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
          kvstart = jvoff(jfield)      ! Starting Visibility of field
          kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
          write(mess,'(A,I0,A)') 'Processing field # ',ifield
          call map_message(seve%i,rname,mess)
          nv = ivend-ivstart+1
          duv_in => duv(:,ivstart:ivend)
          duv_out => duv_next(:,kvstart:kvend)
          beamp(1) = bsize
          beamp(2) = doff(1,ifield)
          beamp(3) = doff(2,ifield)
          !
          if (.not.fast) then
             call uv_removes_clean(huv,duv_in,duv_out,lc-ic+1,mic, &
                  & ccou,freq,ic,lc,beamp)
          else
             call uv_removef_clean(dirty%head,duv_in,duv_out,lc-ic+1,mic, &
                  & ccou,freq,ic,lc,beamp)
          endif
          !
          ! Add trailing data if any
          if (huv%gil%lcol.lt.huv%gil%dim(1)) then
             do iv=1,nv
                duv_out(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
                     & duv_in(huv%gil%lcol+1:huv%gil%dim(1),iv)  
             enddo
          endif
       enddo
       !
       ! Compute the CLEAN image
       if (do_clean) then
          call generate_clean(clean%head,oic,olc,ccou,mic)
       endif
    endif
    !
    call gag_cpu(cpu1)
    if (elapsed.eq.0) then
       write(mess,102) 'Finished Residual CPU ',cpu1-cpu0
    else
       write(mess,102) 'Finished Residual Elapsed ',elapsed,'; CPU ',cpu1-cpu0
    endif
    call map_message(seve%i,rname,mess)
    !
    if (allocated(lduv)) deallocate(lduv)
    if (allocated(ccou)) deallocate(ccou)
    !
102 format(a,f9.2,a,f9.2)
  end subroutine uv_residual_main
  !
  subroutine generate_clean(hmap,first,last,ccou,mic)
    use image_def
    use clean_buffers
    use cct_types
    !------------------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------
    type(gildas), intent(inout) :: hmap
    integer,      intent(in) :: first
    integer,      intent(in) :: last
    real,         intent(in) :: ccou(:,:,:)  ! (x,y,value),Component,Plane
    integer,      intent(in) :: mic(:)       ! niter per plane
    !
    integer :: iplane,jplane,niter,miter,i,ier
    real, pointer :: p_clean(:,:)
    type (cct_par), allocatable :: p_cct(:)
    !
    logical :: error
    !
    miter = maxval(mic)
    allocate (p_cct(miter),stat=ier)
    !
    do iplane = first, last
       clean_prog%iplane = iplane
       p_clean =>  hmap%r3d(:,:,iplane)
       !
       ! Recover the component list in pixels
       jplane = iplane-first+1
       niter = mic(jplane) 
       do i=1,niter
          if (ccou(3,i,jplane).eq.0) then
             p_cct(i)%value = 0 ! Required
             niter = i-1
             exit
          else
             !
             ! The NINT is required because of rounding errors
             p_cct(i)%ix = nint( (ccou(1,i,jplane)-hmap%gil%convert(2,1)) /  &
                  &        hmap%gil%convert(3,1) + hmap%gil%convert(1,1))
             p_cct(i)%iy = nint( (ccou(2,i,jplane)-hmap%gil%convert(2,2)) /  &
                  &        hmap%gil%convert(3,2) + hmap%gil%convert(1,2))
             p_cct(i)%value = ccou(3,i,jplane)
          endif
       enddo
       ! Stupid test
       if (niter.gt.0) then
          clean_prog%n_iter = niter
          call clean_make(clean_prog,hmap,p_clean,p_cct)
       else
          p_clean = 0
       endif
    enddo
    deallocate(p_cct)
    hmap%file = 'toto.lmv-clean'
    call gdf_write_image(hmap,hmap%r3d,error)
  end subroutine generate_clean
end module uv_residual
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_statistics_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_statistics_command
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !     STATISTICS
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  character(len=*), parameter :: rname='STATISTICS/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_statistics_main(error)
  if (error) return
  !
end subroutine wifisyn_statistics_command
!
subroutine wifisyn_statistics_main(error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_statistics_main
  use wifisyn_cube_buffer
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='STATISTICS/MAIN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_statistics_wifi(wifi,error)
  if (error) return
  !
end subroutine wifisyn_statistics_main
!
subroutine wifisyn_statistics_wifi(wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_statistics_wifi
  use wifisyn_cube_types
  !----------------------------------------------------------------------
  ! @ private
  !----------------------------------------------------------------------
  type(wifi_t), intent(inout) :: wifi
  logical,      intent(inout) :: error
  !
  integer :: ic
  integer :: ix,nx
  integer :: iy,ny
  integer :: iu,nu
  integer :: iv,nv
  real(kind=8) :: variance
  complex(kind=4) :: mean,diff
  character(len=*), parameter :: rname='STATISTICS/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nx = wifi%cub%nx
  ny = wifi%cub%ny
  nu = wifi%cub%nu
  nv = wifi%cub%nv
  call wifisyn_reallocate_complex_xyuv('wifi mean',nx,ny,nu,nv,wifi%mean,error)
  if (error) return
  call wifisyn_reallocate_complex_xyuv('wifi rms',nx,ny,nu,nv,wifi%rms,error)
  if (error) return
  !
  do iv=1,nv
     do iu=1,nu
        do iy=1,ny
           do ix=1,nx
              mean = sum(wifi%cub%val(:,ix,iy,iu,iv))/wifi%cub%nc
              variance = (0.0,0.0)
              do ic=1,wifi%cub%nc
                 diff = wifi%cub%val(ic,ix,iy,iu,iv)-mean
                 variance = variance+dble(abs(diff))**2
              enddo ! ic
              variance = variance/(wifi%cub%nc-1)
              wifi%rms%val(ix,iy,iu,iv) = sqrt(variance)
              wifi%mean%val(ix,iy,iu,iv) = mean
           enddo ! ix
        enddo ! iy
     enddo ! iu
  enddo ! iv
  !
end subroutine wifisyn_statistics_wifi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine fitreal(fd,ndat,array,scale,zero,error)
  use gbl_message
  use gfits_interfaces, except_this=>fitreal
  use gfits_buf
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Write NDAT data values in FITS data area,
  ! with scaling SCALE and offset ZERO
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd           !
  integer(kind=4),     intent(in)    :: ndat         ! Number of data elements
  real(kind=4),        intent(in)    :: array(ndat)  ! Data array
  real(kind=4),        intent(in)    :: scale        ! Scaling factor
  real(kind=4),        intent(in)    :: zero         ! Zero offset
  logical,             intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITREAL'
  integer(kind=4) :: i
  real(kind=4) :: vtest
  character(len=message_length) :: mess
  !
  ! I*2
  if (fd%snbit.eq.16) then
    do i = 1, ndat
      vtest = (array(i)-zero)/scale
      if (vtest.lt.-32768.) then
        write(mess,*) 'Value ',array(i),' below range'
        call gfits_message(seve%e,rname,mess)
        vtest = -32768.
      elseif (vtest.gt.32767.) then
        write(mess,*) 'Value ',array(i),' above range'
        call gfits_message(seve%e,rname,mess)
        vtest = 32767.
      endif
      fd%nb = fd%nb+1
      i2buf(fd%nb) = vtest
      if (fd%nb.ge.1440) then
#if defined(IEEE) || defined(VAX)
        call iei2ei (buffer,buffer,1440)
#endif
        call gfits_putbuf(buffer,2880,error)
        fd%nb = 0
        if (error) return
      endif
    enddo
  elseif (fd%snbit.eq.32) then
    do i = 1, ndat
      vtest = (array(i)-zero)/scale
      if (vtest.lt.-2147483648.) then
        write(mess,*) 'Value ',array(i),' below range'
        call gfits_message(seve%e,rname,mess)
        vtest = -2147483648.
      elseif (vtest.gt.2147483647.) then
        write(mess,*) 'Value ',array(i),' above range'
        call gfits_message(seve%e,rname,mess)
        vtest = 2147483647.
      endif
      fd%nb = fd%nb+1
      i4buf(fd%nb) = vtest
      if (fd%nb.ge.720) then
#if defined(IEEE) || defined(VAX)
        call iei4ei(buffer,buffer,720)
#endif
        call gfits_putbuf(buffer,2880,error)
        fd%nb = 0
        if (error) return
      endif
    enddo
  elseif  (fd%snbit.eq.-32) then
#if defined(VAX)
    call setblnk4(bval)
#endif
    do i = 1, ndat
      vtest = (array(i)-zero)/scale
      fd%nb= fd%nb+1
#if defined(VAX)
      call var4ei(vtest,i4buf(fd%nb),1)
#endif
#if defined(IEEE)
      call ier4ei(vtest,i4buf(fd%nb),1)
#endif
#if defined(EEEI)
      i4buf(fd%nb) = vtest
#endif
      if (fd%nb.ge.720) then
        call gfits_putbuf(buffer,2880,error)
        fd%nb = 0
        if (error) return
      endif
    enddo
  else
    error = .true.
  endif
end subroutine fitreal
!
subroutine fitreal_end(fd,error)
  use gfits_interfaces, except_this=>fitreal_end
  use gfits_buf
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd     !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4) :: i
  !
  if (fd%nb.eq.0) return
  if (fd%snbit.eq.16) then
    do i = fd%nb+1,1440
      i2buf (i) = 0
    enddo
#if defined(IEEE) || defined(VAX)
    call iei2ei(buffer,buffer,1440)
#endif
  elseif (fd%snbit.eq.32) then
    do i = fd%nb+1,720
      i4buf (i) = 0
    enddo
#if defined(IEEE) || defined(VAX)
    call iei4ei(buffer,buffer,720)
#endif
  elseif (fd%snbit.eq.-32) then
    do i = fd%nb+1,720
      i4buf (i) = 0
    enddo
  else
    error = .true.
    return
  endif
  call gfits_putbuf(buffer,2880,error)
  fd%nb = 0
end subroutine fitreal_end

module plot_formula
  use class_parameter
  real(kind=plot_length) :: gx1,gx2,gy1,gy2  ! box location
  real(kind=plot_length) :: gvx, gvx1, gvx2  ! in velocity
  real(kind=plot_length) :: gcx, gcx1, gcx2  ! in channels
  real(kind=plot_length) :: gfx, gfx1, gfx2  ! in rest frequency offset
  real(kind=8)           :: gfxo             ! the rest frequency offset
  real(kind=plot_length) :: gix, gix1, gix2  ! in image offset
  real(kind=8)           :: gixo             ! the image frequency offset
  real(kind=plot_length) :: gux, gux1, gux2  ! in current units
  real(kind=plot_length) :: guy, guy1, guy2  ! on y axis
  real(kind=plot_length) :: guz, guz1, guz2  ! on y axis
end module plot_formula
!
module class_popup
  use classic_params
  use class_parameter
  !
  integer(kind=4), parameter :: cpop_none=0
  integer(kind=4), parameter :: cpop_plotindex=-2
  integer(kind=4), parameter :: cpop_stamp=-1
  integer(kind=4), parameter :: cpop_map=+1
  !
  integer(kind=obsnum_length), allocatable :: ipop(:)
  real(kind=4),                allocatable :: xpop(:)
  real(kind=4),                allocatable :: ypop(:)
  integer(kind=entry_length) :: npop
  integer(kind=4) :: cpop
  real(kind=4) :: pgx1,pgx2,pux1,pux2
  real(kind=4) :: pgy1,pgy2,puy1,puy2
  real(kind=4) :: pgz1,pgz2,puz1,puz2
end module class_popup
!
module class_common
  use image_def
  use classic_api
  use class_types
  !
  type(classic_file_t), save :: filein,fileout
  logical :: filein_isvlm,fileout_isvlm
  type(gildas), save :: filein_vlmhead
  !
  integer(kind=4) :: lun_1,lun_2  ! Support LUNs, reserved once for efficiency
  !
  type(classic_recordbuf_t) :: ibufbi   ! File In Index buffer
  type(classic_recordbuf_t) :: ibufobs  ! File In Observation buffer
  integer(kind=4) :: idatabi(lind_v1)   ! Index buffer. Use length = max(lind_v*)
  type(classic_recordbuf_t) :: obufbi   ! File Out Index buffer
  type(classic_recordbuf_t) :: obufobs  ! File Out Observation buffer
  integer(kind=4) :: odatabi(lind_v1)   ! Index buffer. Use length = max(lind_v*)
  !
  logical :: outobs_modify  ! The current observation is open for modification
  !
end module class_common
!
module output_header
  use gildas_def
  !---------------------------------------------------------------------
  ! Describe the current status of the Header or List output
  !---------------------------------------------------------------------
  integer(kind=4) :: p_lun   ! Output LUN
  real(kind=4) :: x1, y1  ! Position of text
  character(len=filename_length) :: filnam  ! Output filename
  character(len=1)   :: type1   ! Output device type
end module output_header

subroutine gr4_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*4) array.
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR4_MINMAX for a version which ignores Infinity
  !
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=4),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr4_extrema
!
subroutine gr8_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*8) array
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR8_MINMAX for a version which ignores Infinity
  !!
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=8),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr8_extrema
!
subroutine gr4_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_minmax
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=4),              intent(in)  :: z(nxy)  !
  real(kind=4),              intent(in)  :: bval    !
  real(kind=4),              intent(in)  :: eval    !
  real(kind=4),              intent(out) :: zmin    !
  real(kind=4),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini4(z(j)))then
      if(abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j+1,nxy
    if (sic_fini4(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr4_minmax
!
subroutine gr8_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_minmax
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=8),              intent(in)  :: z(nxy)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  real(kind=8),              intent(out) :: zmin    !
  real(kind=8),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini8(z(j)))then
      if (abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j,nxy
    if (sic_fini8(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    ! Debug (message is too much verbose for a daily use)
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr8_minmax
!
subroutine gr4_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       ! Number of elements to copy
  real(kind=4),              intent(in)  :: in(n)   ! Input array
  real(kind=4),              intent(out) :: out(n)  ! Output array
  real(kind=4),              intent(in)  :: bval    ! Blanking value
  real(kind=4),              intent(in)  :: eval    ! Error value for blanking
  integer(kind=size_length), intent(out) :: m       ! Number elements kept
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr4_load
!
subroutine gr8_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       !
  real(kind=8),              intent(in)  :: in(n)   !
  real(kind=8),              intent(out) :: out(n)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  integer(kind=size_length), intent(out) :: m       !
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.d0) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr8_load
!
subroutine gr4_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gmath_interfaces, except_this=>gr4_median
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=4),              intent(in)    :: data(ndata)  ! Data
  real(kind=4),              intent(in)    :: bval         ! Blanking value
  real(kind=4),              intent(in)    :: eval         ! Tolerance
  real(kind=4),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr4_median
!
subroutine gr8_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gmath_interfaces, except_this=>gr8_median
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=8),              intent(in)    :: data(ndata)  ! Data
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance
  real(kind=8),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.d0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr8_median
!
subroutine gr4_dicho(np,x,xval,ival)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: np     ! Number of input points
  real(kind=4),              intent(in)  :: x(np)  ! Input ordered Values
  real(kind=4),              intent(in)  :: xval   ! The value we search for
  integer(kind=size_length), intent(out) :: ival   ! Position in the array
  ! Local
  integer(kind=size_length) :: iinf,isup,imid
  !
  if (x(1).gt.xval) then
    ival = 0
    return
  elseif (x(1).eq.xval) then
    ival = 1
    return
  elseif (x(np).lt.xval) then
    ival = np
    return
  endif
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)
    imid = (isup + iinf)/2
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ival = isup
  !
end subroutine gr4_dicho
!
subroutine gr8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  real(kind=8),              intent(in)    :: x(np)  ! Input ordered Values
  real(kind=8),              intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,F0.8,A,F0.8,A,F0.8,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gr8_dicho
!
subroutine gi4_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=4),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=4),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
    ! If no exact match, the requested value is in between. Returned value
    ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi4_dicho
!
subroutine gi8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=8),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=8),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi8_dicho
!
subroutine gi4_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gmath_interfaces, except_this=>gi4_dicho_with_user_ltgt
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=4), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=4) :: iinf,isup,imid
  !
  if (ugt(1) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi4_dicho_with_user_ltgt
!
subroutine gi8_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gmath_interfaces, except_this=>gi8_dicho_with_user_ltgt
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=8), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=8) :: iinf,isup,imid
  !
  if (ugt(1_8) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi8_dicho_with_user_ltgt
!
subroutine gr4_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=4),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=4),              intent(in)  :: bval      ! Blanking value
  real(kind=4),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=4),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=4) :: nan,lastchanceretval
  ! We need an intermediate real*8 array to avoid precision loss
  ! in case of a very large number of values...
  real(kind=8) :: dout
  !
  if (eval.ge.0.) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  dout = 0.
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,dout) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:dout,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.) then
        dout = dout + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          dout = dout + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (nvalid.gt.0) then
    out = dout/real(nvalid)
  else
    out = lastchanceretval
  endif
  !
end subroutine gr4_mean
!
subroutine gr8_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=8),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=8),              intent(in)  :: bval      ! Blanking value
  real(kind=8),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=8),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=8) :: nan,lastchanceretval
  !
  if (eval.ge.0.d0) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  out = 0.d0
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,out) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:out,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.d0) then
        out = out + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          out = out + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (nvalid.gt.0) then
    out = out/nvalid
  else
    out = lastchanceretval
  endif
  !
end subroutine gr8_mean
!
subroutine gr4_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_quantile
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=4),               intent(in)    :: data(ndata)    ! Data
  real(kind=4),               intent(in)    :: bval           ! Blanking value
  real(kind=4),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=4),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr4_quantile
!
subroutine gr8_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_quantile
  use gmath_messaging
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=8),               intent(in)    :: data(ndata)    ! Data
  real(kind=8),               intent(in)    :: bval           ! Blanking value
  real(kind=8),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=8),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr8_quantile

subroutine find(set,line,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !    FIND [APPEND|NEW_DATA|UPDATE]
  !  1       [/ALL]
  !  2       [/LINE]
  !  3       [/NUMBER]
  !  4       [/SCAN]
  !  5       [/OFFSET]
  !  6       [/SOURCE]
  !  7       [/RANGE]
  !  8       [/QUALITY]
  !  9       [/TELESCOPE]
  ! 10       [/SUBSCAN]
  ! 11       [/ENTRY]
  ! 12       [/OBSERVED]
  ! 13       [/REDUCED]
  ! 14       [/FREQUENCY]
  ! 15       [/SECTION]
  ! 16       [/USER]
  ! 17       [/MASK]
  ! 18       [/POSITION]
  ! 19       [/SWITCHMODE]
  ! 20       [/DRIFT]
  ! 21       [/DIRECTION]
  !  Find a set of observations according to setup search rules and
  ! command options.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  logical,             intent(inout) :: error  ! Error status
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=entry_length) :: cxnext0
  character(len=80) :: mess
  character(len=14) :: argum
  logical :: new_argum,upd_argum,app_argum
  logical :: new_wanted,upd_wanted,app_wanted
  integer(kind=4), parameter :: mvocab=3
  character(len=12) :: vocab(mvocab),keywor
  integer(kind=4) :: nc,nkey,iarg,ier
  integer(kind=entry_length) :: nfound,erange(2)
  integer(kind=entry_length) :: indmin,indmax,i,j,k
  ! Data
  data vocab/'APPEND','NEW_DATA','UPDATE'/
  !
  if (.not.filein_opened(rname,error))  return
  !
  call find_setup(set,line,error)
  if (error)  return
  !
  ! APPEND|NEW_DATA|UPDATE arguments
  app_argum = .false.  ! append to previous CX
  new_argum = .false.  ! find in new entries only
  upd_argum = .false.  ! update IX before FIND
  do iarg=1,sic_narg(0)
     call sic_ke (line,0,iarg,argum,nc,.false.,error)
     if (error) return
     call sic_ambigs(rname,argum,keywor,nkey,vocab,mvocab,error)
     if (error) return
     select case (nkey)
     case(1)
        app_argum = .true.
     case(2)
        new_argum = .true.
     case(3)
        upd_argum = .true.
     end select
  enddo
  if ((app_argum.and.new_argum) .or.  &   ! Useless, this is UPDATE
      (app_argum.and.upd_argum) .or.  &   ! Useless / no-sense
      (new_argum.and.upd_argum)) then     ! Exclusive
    call class_message(seve%e,rname,  &
      'Arguments APPEND, NEW_DATA and UPDATE are exclusive')
    error = .true.
    return
  endif
  !
  app_wanted = app_argum
  new_wanted = new_argum
  upd_wanted = upd_argum.or.set%fupda
  !
  ! Update index
  if (upd_wanted) then
     call ix_update(error)
     if (error) return
  endif
  !
  ! Zeroes the current index by default, except if APPEND
  if (.not.app_wanted) then
     cx%next = 1
     knext = 0
  endif
  cxnext0 = cx%next
  !
  if (new_wanted) then
    ! Look in IX for new entries and restrict the search to this 'entry range'
    call eix_newdata(erange(1),erange(2),error)
    if (error) return
    call fix(set,ix,cx,nfound,error,erange)
    if (error)  return
  else
    ! Search in all IX entries
    call fix(set,ix,cx,nfound,error)
    if (error)  return
  endif
  if (nfound.eq.0) then
    call class_message(seve%w,rname,'Nothing found')
    goto 999
  endif
  !
  if (cxnext0.gt.1 .and. cx%next.gt.cxnext0) then
     ! There was already entries in CX and we added more: compress CX
     k = cxnext0
     do i=cxnext0, cx%next-1
        do j=1, cxnext0-1
           if (cx%ind(j).eq.cx%ind(i)) goto 100
        enddo
        call optimize_tooptimize(cx,i,cx,k,.true.,error)
        if (error)  goto 999
        k = k+1
100     continue
     enddo
     cx%next = k
     nindex = cx%next-1
  endif
  !
  ! Sort index (after compression and extraction)
  if (set%do_sort) call sort_index(set,'C',error)
  !
  ! /ENTRY option: Extract entry numbers if needed. Parsing is done here
  ! because execution is not done in FIX...
  call find_by_entry(set,line,indmin,indmax,error)
  if (error)  return
  if (flg%ind) then
     k = 1
     do i=indmin,min(indmax,cx%next-1)
        call optimize_tooptimize(cx,i,cx,k,.true.,error)
        if (error)  return
        k = k+1
     enddo
     cx%next = k
     nindex  = cx%next-1
     nfound  = nindex
  endif
  !
  if (error) return
  !
  if (nfound.eq.1) then
     call class_message(seve%i,rname,'1 observation found')
  elseif (nfound.ne.0) then
     write(mess,'(I0,A)') cx%next-1,' observations found'
     call class_message(seve%i,rname,mess)
  endif
  !
999 continue
  ! Time when index is filled
  ier = gag_time(cx%time)
  if (ier.ne.0) then
    call class_message(seve%e,rname,'Error getting current time')
    error = .true.
    return
  endif
  !
  ! Check whether current index contains old format observations
  call optimize_old_format(cx,'Current',error)
  if (error)  return
  !
  ! Reset the IDX% Sic structure
  call class_variable_index_reset(error)
  if (error) return
  !
  ! Index has changed: Reset consistency and range information
  call consistency_defaults(set,cx%cons)
  cx%ranges%done = .false.
  call index_ranges(cx,error)
  !
end subroutine find
!
subroutine find_setup(set,line,error)
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Parse the command line and setup the smin%, smax% and flg%
  ! structures for later use by subroutine FIX.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4) :: nc
  character(len=14) :: argum1,argum2,argum3
  character(len=argument_length) :: expr1,expr2
  real(kind=4) :: any
  real(kind=8) :: dummy
  integer(kind=4), parameter :: mini2=-32768
  integer(kind=4), parameter :: maxi2=32767
  integer(kind=4), parameter :: maxi4=2147483647_4
  integer(kind=8), parameter :: maxi8=9223372036854775807_8
  !
  call chtoby('ANY ',any,4)
  !
  flg%last=.not.sic_present(1,0)  ! Only last version unless specified
  flg%ver=.false.                 ! No version specified
  !
  !***************** Obs. Type (no option) **************
  if (set%kind.eq.kind_any) then
    flg%kind = .false.
  else
    flg%kind = .true.
    smin%kind = set%kind
  endif
  !
  !*********************** /LINE ***********************
  if (sic_present(2,0)) then
    smin%cline = '*'
    call sic_ch(line,2,1,smin%cline,nc,.false.,error)
    if (error) return
  else ! SET LINE
    smin%cline = set%line
  endif
  call sic_upper(smin%cline)
  flg%line = smin%cline.ne.'*'
  flg%iline = index(smin%cline,'*')
  !
  !*********************** /NUMBER ***********************
  flg%num=.false.
  smin%num=0
  smax%num=maxi8
  if (sic_present(3,0)) then
    argum1= '*'
    call sic_ke (line,3,1,argum1,nc,.false.,error)
    if (error) return
    argum2= ' '
    call sic_ke (line,3,2,argum2,nc,.false.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      smin%num=1
    else
      call sic_i8 (line,3,1,smin%num,.false.,error)
      if (error) return
      flg%num=.true.
    endif
    if (argum2(1:1).eq.' ') then
      smax%num=smin%num
    elseif (argum2.ne.'*') then
      call sic_i8 (line,3,2,smax%num,.false.,error)
      if (error) return
      flg%num=.true.
    endif
    ! SET NUMBER
  elseif (set%nume1.ne.0 .or. set%nume2.ne.maxi8) then
    flg%num=.true.
    smin%num=set%nume1
    smax%num=set%nume2
  endif
  !
  !*********************** /OBSERVED ***********************
  flg%dobs=.false.
  if (sic_present(12,0)) then
    argum1  = '*'
    call sic_ke (line,12,1,argum1,nc,.false.,error)
    if (error) return
    argum2 = '*'
    call sic_ke (line,12,2,argum2,nc,.false.,error)
    if (error) return
    smin%dobs = mini2
    call gag_fromdate(argum1,smin%dobs,error)
    if (error)  return
    smax%dobs = maxi2
    call gag_fromdate(argum2,smax%dobs,error)
    if (error) return
    if (smax%dobs.ne.maxi2.or.smin%dobs.ne.mini2) flg%dobs=.true.
  else  ! SET OBSERVED
    if (set%obse1.ne.mini2 .or. set%obse2.ne.maxi2) then
      flg%dobs=.true.
      smin%dobs=set%obse1
      smax%dobs=set%obse2
    else
      flg%dobs=.false.
      smin%dobs=mini2
      smax%dobs=maxi2
    endif
  endif
  !
  !*********************** /SCAN ***********************
  flg%scan=.false.
  smin%scan=0
  smax%scan=maxi8
  if (sic_present(4,0)) then
    argum1= '*'
    call sic_ke (line,4,1,argum1,nc,.false.,error)
    if (error) return
    argum2= ' '
    call sic_ke (line,4,2,argum2,nc,.false.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      smin%scan = 0
    else
      call sic_i8 (line,4,1,smin%scan,.false.,error)
      if (error) return
      flg%scan=.true.
    endif
    if (argum2(1:1).eq.' ') then
      smax%scan=smin%scan
    elseif (argum2.ne.'*') then
      call sic_i8 (line,4,2,smax%scan,.false.,error)
      if (error) return
      flg%scan=.true.
    endif
    ! SET SCAN
  elseif (set%scan1.ne.0 .or. set%scan2.ne.maxi8) then
    flg%scan=.true.
    smin%scan=set%scan1
    smax%scan=set%scan2
  endif
  !
  !*********************** /OFFSET ***********************
  if (sic_present(5,0)) then
    argum2 = ' '  ! Default current angle unit
    call sic_ke(line,5,3,argum2,nc,.false.,error)
    if (error)  return
    !
    expr1= '*'
    call sic_ke (line,5,1,expr1,nc,.false.,error)
    if (error) return
    if (expr1(1:1).ne.'*') then
      call coffse(set,rname,expr1,argum2,smin%off1,error)
      if (error) return
      flg%off1=.true.
      smax%off1=smin%off1+set%tole
      smin%off1=smin%off1-set%tole
    endif
    !
    expr1= '*'
    call sic_ke (line,5,2,expr1,nc,.false.,error)
    if (error) return
    if (expr1(1:1).ne.'*') then
      call coffse(set,rname,expr1,argum2,smin%off2,error)
      if (error) return
      flg%off2=.true.
      smax%off2=smin%off2+set%tole
      smin%off2=smin%off2-set%tole
    endif
  endif
  !
  !*********************** /SOURCE ***********************
  if (sic_present(6,0)) then
    smin%csour = '*'
    call sic_ch(line,6,1,smin%csour,nc,.false.,error)
    if (error) return
  else ! SET SOURCE
    smin%csour = set%sourc
  endif
  call sic_upper(smin%csour)
  flg%sourc = smin%csour.ne.'*'
  flg%isourc = index(smin%csour,'*')
  !
  !***********************  /RANGE ***********************
  if (sic_present(7,0)) then
    flg%off1=.false.
    flg%off2=.false.
    smin%off1=any
    smin%off2=any
    smax%off1=any
    smax%off2=any
    !
    argum3 = ' '  ! Default current angle unit
    call sic_ke(line,7,5,argum3,nc,.false.,error)
    if (error)  return
    !
    expr1= '*'
    call sic_ke (line,7,1,expr1,nc,.false.,error)
    if (error) return
    if (expr1(1:1).ne.'*') then
      call coffse(set,rname,expr1,argum3,smin%off1,error)
      if (error) return
      flg%off1=.true.
      smin%off1=smin%off1-set%tole
    endif
    !
    expr2= '*'
    call sic_ke (line,7,2,expr2,nc,.false.,error)
    if (error) return
    if (expr2(1:1).ne.'*') then
      call coffse(set,rname,expr2,argum3,smax%off1,error)
      if (error) return
      flg%off1=.true.
      smax%off1=smax%off1+set%tole
    endif
    !
    expr1= '*'
    call sic_ke (line,7,3,expr1,nc,.false.,error)
    if (error) return
    if (expr1(1:1).ne.'*') then
      call coffse(set,rname,expr1,argum3,smin%off2,error)
      if (error) return
      flg%off2=.true.
      smin%off2=smin%off2-set%tole
    endif
    !
    expr2= '*'
    call sic_ke (line,7,4,expr2,nc,.false.,error)
    if (error) return
    if (expr2(1:1).ne.'*') then
      call coffse(set,rname,expr2,argum3,smax%off2,error)
      if (error) return
      flg%off2=.true.
      smax%off2=smax%off2+set%tole
    endif
    !
  else ! SET OFFSET or SET RANGE
    if (.not.flg%off1 .and.  &
        (set%offs1.ne.any .or. set%offl1.ne.any)) then
      flg%off1=.true.
      smin%off1=set%offs1
      if (smin%off1.ne.any) smin%off1 = smin%off1-set%tole
      smax%off1=set%offl1
      if (smax%off1.ne.any) smax%off1 = smax%off1+set%tole
    endif
    if (.not.flg%off2.and.(set%offs2.ne.any .or. set%offl2.ne.any)) then
      flg%off2=.true.
      smin%off2=set%offs2
      if (smin%off2.ne.any) smin%off2 = smin%off2-set%tole
      smax%off2=set%offl2
      if (smax%off2.ne.any) smax%off2 = smax%off2+set%tole
    endif
  endif
  !
  !*********************** /QUALITY ***********************
  smin%qual = set%qual2
  if (sic_present(8,0)) then
    call sic_i4 (line,8,1,smin%qual,.false.,error)
    if (error) return
    if (smin%qual.lt.0 .or. smin%qual.gt.9) then
      call class_message(seve%e,rname,'Quality out of range 0-9')
      error = .true.
      return
    endif
  endif
  !
  !*********************** /REDUCED ***********************
  flg%dred=.false.
  if (sic_present(13,0)) then
    argum1  = '*'
    call sic_ke (line,13,1,argum1,nc,.false.,error)
    if (error) return
    argum2 = '*'
    call sic_ke (line,13,2,argum2,nc,.false.,error)
    if (error) return
    smin%dred = mini2
    call gag_fromdate(argum1,smin%dred,error)
    if (error) return
    smax%dred = maxi2
    call gag_fromdate(argum2,smax%dred,error)
    if (error) return
    if (smax%dred.ne.maxi2.or.smin%dred.ne.mini2) flg%dred=.true.
  else ! SET REDUCED
    if (set%redu1.ne.mini2 .or. set%redu2.ne.maxi2) then
      flg%dred=.true.
      smin%dred=set%redu1
      smax%dred=set%redu2
    else
      flg%dred=.false.
      smin%dred=mini2
      smax%dred=maxi2
    endif
  endif
  !
  !*********************** /TELESCOPE ***********************
  if (sic_present(9,0)) then
    smin%ctele= '*'
    call sic_ch(line,9,1,smin%ctele,nc,.false.,error)
    if (error) return
  else
    smin%ctele = set%teles
  endif
  call sic_upper(smin%ctele)
  flg%teles = smin%ctele.ne.'*'
  flg%iteles = index(smin%ctele,'*')
  !
  !*********************** /SUBSCAN ***********************
  flg%subscan=.false.
  smin%subscan=0
  smax%subscan=maxi4
  if (sic_present(10,0)) then
    argum1= '*'
    call sic_ke (line,10,1,argum1,nc,.false.,error)
    if (error) return
    argum2= ' '
    call sic_ke (line,10,2,argum2,nc,.false.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      smin%subscan = 0
    else
      call sic_i4  (line,10,1,smin%subscan,.false.,error)
      if (error) return
      flg%subscan=.true.
    endif
    if (argum2(1:1).eq.' ') then
      smax%subscan=smin%subscan
    elseif (argum2.ne.'*') then
      call sic_i4 (line,10,2,smax%subscan,.false.,error)
      if (error) return
      flg%subscan=.true.
    endif
    ! SET SUBSCAN
  elseif (set%sub1.ne.0 .or. set%sub2.ne.maxi4) then
    flg%subscan=.true.
    smin%subscan=set%sub1
    smax%subscan=set%sub2
  endif
  !
  !*********************** SET POSANGLE ***********************
  if (set%kind.eq.kind_cont) then
    if (set%posa1.ne.-1e7 .or. set%posa2.ne.+1e7) then
      flg%posa=.true.
      smin%posa=set%posa1
      smax%posa=set%posa2
    else
      flg%posa=.false.
    endif
  endif
  !
  !**************************** /FREQUENCY *****************************
  if (sic_present(14,0)) then
    if (set%kind.ne.kind_spec) then
      call class_message(seve%e,rname,  &
        'FIND /FREQUENCY is allowed only with spectroscopic data')
      error = .true.
      return
    endif
    !
    call setfrequency('FIND /FREQUENCY',line,14,1,flg%freqmin,flg%freqmax,  &
      flg%freqsig,error)
    if (error)  return
    !
  else  ! SET FREQUENCY
    if (set%kind.eq.kind_spec) then
      flg%freqmin = set%freqmin
      flg%freqmax = set%freqmax
      flg%freqsig = set%freqsig
    else
      ! Ignore
      flg%freqmin = -1.d0
      flg%freqmax = -1.d0
      flg%freqsig = .true.
    endif
  endif
  !
  flg%freq = flg%freqmin.gt.0.d0 .or. flg%freqmax.gt.0.d0
  !
  ! Sort here to ease later computations
  if (flg%freq) then
    ! Frequency selection is in use
    if (flg%freqmin.gt.0.d0 .and. flg%freqmax.gt.0.d0) then
      ! Both values are set
      if (flg%freqmax.lt.flg%freqmin) then
        ! Values are misordered. Swap.
        dummy = flg%freqmin
        flg%freqmin = flg%freqmax
        flg%freqmax = dummy
      endif
    endif
  endif
  !
  !************************** /SECTION **************************
  call find_setup_section(line,error)
  if (error)  return
  !
  !************************** /USER *****************************
  flg%user = sic_present(16,0)
  if (flg%user) then
    call user_sec_find(line,error)
    if (error)  return
  endif
  !
  !************************** /MASK *****************************
  call find_setup_mask(line,error)
  if (error)  return
  !
  !************************ /POSITION ***************************
  call find_setup_position(line,error)
  if (error)  return
  !
  !************************ /SWITCHING **************************
  call find_setup_switching(line,error)
  if (error)  return
  !
  !************************** /DRIFT ****************************
  call find_setup_drift(line,error)
  if (error)  return
  !
  !************************ /DIRECTION **************************
  call find_setup_direction(line,error)
  if (error)  return
  !
end subroutine find_setup
!
subroutine index_ranges(windex,error)
  use class_parameter
  use class_types
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Computes ranges of LAMBDA BETA SCAN DOBS (DRED)
  !---------------------------------------------------------------------
  type(optimize), intent(inout) :: windex  !
  logical,        intent(out)   :: error   !
  ! Local
  integer(kind=entry_length) :: i,inum
  real(kind=4) :: min_loff,max_loff,min_boff,max_boff
  integer(kind=obsnum_length) :: min_scan,max_scan
  integer(kind=4) :: min_dobs,max_dobs
  !
  ! If already done, don't do it
  if (windex%ranges%done) return
  if (windex%next.le.1) return  ! Empty index case...
  !
  ! Initialization
  error = .true.
  inum     = windex%ind(1)
  min_loff = ix%off1(inum)
  max_loff = ix%off1(inum)
  min_boff = ix%off2(inum)
  max_boff = ix%off2(inum)
  min_scan = ix%scan(inum)
  max_scan = ix%scan(inum)
  min_dobs = ix%dobs(inum)
  max_dobs = ix%dobs(inum)
  !
  ! Loop on entries
  do i=1,windex%next-1
     inum = windex%ind(i)
     min_loff = min(min_loff,ix%off1(inum))
     max_loff = max(max_loff,ix%off1(inum))
     min_boff = min(min_boff,ix%off2(inum))
     max_boff = max(max_boff,ix%off2(inum))
     min_scan = min(min_scan,ix%scan(inum))
     max_scan = max(max_scan,ix%scan(inum))
     min_dobs = min(min_dobs,ix%dobs(inum))
     max_dobs = max(max_dobs,ix%dobs(inum))
  enddo
  !
  windex%ranges%lam1  = min_loff
  windex%ranges%lam2  = max_loff
  windex%ranges%bet1  = min_boff
  windex%ranges%bet2  = max_boff
  windex%ranges%scan1 = min_scan
  windex%ranges%scan2 = max_scan
  windex%ranges%dobs1 = min_dobs
  windex%ranges%dobs2 = max_dobs
  windex%ranges%dred1 = 0
  windex%ranges%dred2 = 0
  !
  windex%ranges%done = .true.
  error = .false.
end subroutine index_ranges
!
subroutine find_by_entry(set,line,indmin,indmax,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_by_entry
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    FIND /ENTRY
  !  Parse the command line for the FIND /ENTRY arguments
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set
  character(len=*),           intent(in)    :: line
  integer(kind=entry_length), intent(out)   :: indmin
  integer(kind=entry_length), intent(out)   :: indmax
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4) :: nc
  character(len=14) :: argum1,argum2
  integer(kind=entry_length) :: indtmp
  integer(kind=8), parameter :: maxi8=9223372036854775807_8
  !
  flg%ind=.false.
  if (sic_present(11,0)) then
    !
    argum1= '*'
    call sic_ke (line,11,1,argum1,nc,.false.,error)
    if (error) return
    argum2= '*'
    call sic_ke (line,11,2,argum2,nc,.false.,error)
    if (error) return
    !
    if (argum1(1:1).eq.'*') then
      indmin = 1
    else
      call sic_i8(line,11,1,indmin,.true.,error)
      if (error) return
      flg%ind=.true.
    endif
    !
    if (argum2(1:1).eq.'*') then
      indmax = ix%mobs
    else
      call sic_i8(line,11,2,indmax,.false.,error)
      if (error) return
      flg%ind=.true.
    endif
    ! Check consistency
    if (indmin.gt.indmax) then
      call class_message(seve%i,rname,'Swap ENTRY arguments')
      indtmp = indmin
      indmin = indmax
      indmax = indtmp
    else if (indmin.le.0) then
      call class_message(seve%e,rname,'Entry number must be > 0')
      error = .true.
      return
    endif
    !
  elseif (set%entr1.ne.0 .or. set%entr2.ne.maxi8) then
    flg%ind = .true.
    indmin = set%entr1
    indmax = set%entr2
  endif
  !
end subroutine find_by_entry
!
subroutine find_setup_section(line,error)
  use gkernel_interfaces
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command FIND /SECTION FOO
  ! If required, turn on the FIND flags for a by-section search.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=32) :: argum,sname
  integer(kind=4) :: nc,sval
  integer(kind=4), parameter :: vocf=-18,vocl=0
  integer(kind=4), parameter :: nvoc=vocl-vocf+1
  character(len=12) :: vocab(nvoc)
  ! Data
  ! Use same names as SET VARIABLE
  data vocab /'ABS',      '',            'SKYDIP',     &  ! -18:-16
              '',         'CALIBRATION', 'NH3',        &  ! -15:-13
              'SHELL',    'BEAM',        'CONTINUUM',  &  ! -12:-10
              'GAUSS',    'SWITCH',      'PLOT',       &  !  -9:-7
              '',         'BASE',        'SPECTRO',    &  !  -6:-4
              'POSITION', 'GENERAL',     'COMMENT',    &  !  -3:-1
              'USER'/                                     !   0
  !
  flg%sectval = 1  ! No section has a positive identifier
  if (sic_present(15,0)) then
    call sic_ke(line,15,1,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs('FIND',argum,sname,sval,vocab,nvoc,error)
    if (error)  return
    flg%sectval = vocf+sval-1
  endif
  flg%sect = flg%sectval.le.0
  !
end subroutine find_setup_section
!
subroutine find_setup_mask(line,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup_mask
  use class_common
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command FIND /MASK Name
  ! If required, turn on the FIND flags for a mask search
  ! Name is assumed a file name
  ! We could also support variables in the future
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4), parameter :: optmask=17
  integer(kind=4) :: nc,ier
  character(len=message_length) :: mess
  logical :: error2
  !
  ! Clean previous mask
  if (flg%mask%loca%islo.ne.0) then
    error2 = .false.
    call gdf_close_image(flg%mask,error2)
    if (error2) then
      error = .true.
      return
    endif
    if (associated(flg%mask%r2d))  deallocate(flg%mask%r2d)
  endif
  !
  flg%domask = sic_present(optmask,0)
  if (.not.flg%domask)  return
  !
  call gildas_null(flg%mask)
  !
  ! Get mask file name
  if (filein_isvlm) then
    ! Default same as FILE IN VLM with extension .wei
    nc = len_trim(filein_vlmhead%file)
    flg%mask%file = filein_vlmhead%file(1:nc-4)//'.wei'
  elseif (.not.sic_present(optmask,1)) then
    call class_message(seve%e,rname,'No default file name for /MASK')
    error = .true.
    return
  endif
  call sic_ch(line,optmask,1,flg%mask%file,nc,.false.,error)
  if (error) return
  !
  ! Read only the header. The data will be read after we ensured
  ! everything is correct
  call gdf_read_header(flg%mask,error)
  if (error)  return
  !
  if (flg%mask%gil%ndim.ne.2) then
    write(mess,'(A,I0,A)')  'Mask must have 2 dimensions (got ',flg%mask%gil%ndim,')'
    call class_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  if (flg%mask%gil%xaxi*flg%mask%gil%yaxi.ne.2) then
    ! Ensure that the ref/val/inc axes are spatial i.e. they can be used
    ! with the Class lamof/betof.
    call class_message(seve%e,rname,  &
      'The mask dimensions does not appear to be spatial dimensions')
    error = .true.
    return
  endif
  !
  ! Read the data as a flat array (easier use later on)
  allocate(flg%mask%r2d(flg%mask%gil%dim(1),flg%mask%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,'mask r2d',ier,error))  return
  call gdf_read_data(flg%mask,flg%mask%r2d,error)
  if (error)  return
  !
end subroutine find_setup_mask
!
subroutine find_setup_position(line,error)
  use gbl_constant
  use gbl_message
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup_position
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    FIND /POSITION A0 D0 System [Equinox]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4), parameter :: optpos=18
  integer(kind=4) :: nc,ikey
  character(len=24) :: argum,keyw
  character(len=10), parameter :: syst(2) = (/ 'EQUATORIAL','GALACTIC  ' /)
  !
  flg%dopos = sic_present(optpos,0)
  if (.not.flg%dopos)  return
  !
  call sic_ch(line,optpos,1,argum,nc,.true.,error)
  if (error)  return
  call sic_sexa(argum,nc,flg%poslam,error)
  if (error)  return
  !
  call sic_ch(line,optpos,2,argum,nc,.true.,error)
  if (error)  return
  call sic_sexa(argum,nc,flg%posbet,error)
  if (error)  return
  !
  call sic_ke(line,optpos,3,argum,nc,.true.,error)
  if (error)  return
  call sic_ambigs(rname,argum,keyw,ikey,syst,2,error)
  if (error)  return
  if (keyw.eq.'EQUATORIAL') then
    flg%poslam = flg%poslam*rad_per_hang
    flg%posbet = flg%posbet*rad_per_deg
    flg%possys = type_eq
    call sic_r4(line,optpos,4,flg%posequ,.true.,error)
    if (error)  return
  else
    flg%poslam = flg%poslam*rad_per_deg
    flg%posbet = flg%posbet*rad_per_deg
    flg%possys = type_ga
    flg%posequ = equinox_null
  endif
  !
end subroutine find_setup_position
!
subroutine find_setup_switching(line,error)
  use gbl_constant
  use gbl_message
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup_switching
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    FIND /SWITCHING Key
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND>SWITCHING'
  integer(kind=4), parameter :: optswi=19
  integer(kind=4) :: nc,ikey
  character(len=24) :: argum,keyw
  integer(kind=4), parameter :: nmodes=7
  character(len=9), parameter :: modes(nmodes) =  &
    (/ 'POSITION ',  &
       'FREQUENCY',  &
       'FOLDED   ',  &
       'WOBBLER  ',  &
       'BEAM     ',  &
       'MIXED    ',  &
       'UNKNOWN  '   /)
  !
  flg%doswitch = sic_present(optswi,0)
  if (.not.flg%doswitch)  return
  !
  call sic_ke(line,optswi,1,argum,nc,.true.,error)
  if (error)  return
  if (argum.eq.'*') then
    flg%doswitch = .false.
    return
  endif
  call sic_ambigs(rname,argum,keyw,ikey,modes,nmodes,error)
  if (error)  return
  select case (keyw)
  case ('POSITION')
    flg%switch = mod_pos
  case ('FREQUENCY')
    flg%switch = mod_freq
  case ('FOLDED')
    flg%switch = mod_fold
  case ('WOBBLER')
    flg%switch = mod_wob
  case ('BEAM')
    flg%switch = mod_bea
  case ('MIXED')
    flg%switch = mod_mix
  case ('UNKNOWN')
    flg%switch = mod_unk
  end select
  !
end subroutine find_setup_switching
!
subroutine find_setup_drift(line,error)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup_drift
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    FIND /DRIFT Angle
  ! Find continuum drifts with position angle "Angle" module 180 degrees
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4), parameter :: optdri=20
  !
  flg%dodri = sic_present(optdri,0)
  if (.not.flg%dodri)  return
  !
  call sic_r4(line,optdri,1,flg%driang,.true.,error)
  if (error)  return
  ! Set angle in range [0,180[
  do while (flg%driang.lt.0.)  ! Strictly lower than
    flg%driang = flg%driang+180.
  enddo
  do while (flg%driang.ge.180.)  ! Greater or equal to
    flg%driang = flg%driang-180.
  enddo
  flg%driang = flg%driang*rad_per_deg ! [rad]
end subroutine find_setup_drift
!
subroutine find_setup_direction(line,error)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>find_setup_direction
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    FIND /DIRECTION Angle
  ! Find continuum drifts with position angle "Angle" module 360 degrees
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FIND'
  integer(kind=4), parameter :: optdir=21
  !
  flg%dodir = sic_present(optdir,0)
  if (.not.flg%dodir)  return
  !
  call sic_r4(line,optdir,1,flg%dirang,.true.,error)
  if (error)  return
  ! Set angle in range [0,360[
  do while (flg%dirang.lt.0.)  ! Strictly lower than
    flg%dirang = flg%dirang+360.
  enddo
  do while (flg%dirang.ge.360.)  ! Greater or equal to
    flg%dirang = flg%dirang-360.
  enddo
  flg%dirang = flg%dirang*rad_per_deg ! [rad]
end subroutine find_setup_direction
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sort_index(set,key,error)
  use classcore_interfaces, except_this=>sort_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Sort the index using the quicksort algorithm.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)  :: set    !
  character(len=1),    intent(in)  :: key    ! Index: I, O, Current (default)
  logical,             intent(out) :: error  ! Error status
  select case(key)
  case('I')
     call sort_ix(set,error)
  case('O')
     return
  case default
     call sort_cx(set,error)
  end select
end subroutine sort_index
!
subroutine sort_cx(set,error)
  use classcore_interfaces, except_this=>sort_cx
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Sort the index using the quicksort algorithm.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Error status
  ! Local
  integer(kind=entry_length) :: ix_iobs, cx_iobs
  !
  if (cx%next.le.2) return
  !
  select case (set%sort_name)
  case ('BLOC')
     call quicksort(set,cx%ind,cx%next-1,ix_bloc_gt,ix_bloc_ge,error)
  case ('NUMBER')
     call quicksort(set,cx%ind,cx%next-1,ix_num_gt,ix_num_ge,error)
  case ('VERSION')
     call quicksort(set,cx%ind,cx%next-1,ix_ver_gt,ix_ver_ge,error)
  case ('OBSERVED')
     call quicksort(set,cx%ind,cx%next-1,ix_dobs_gt,ix_dobs_ge,error)
  case ('LAMBDA')
     call quicksort(set,cx%ind,cx%next-1,ix_off1_gt,ix_off1_ge,error)
  case ('BETA')
     call quicksort(set,cx%ind,cx%next-1,ix_off2_gt,ix_off2_ge,error)
  case ('SCAN')
     call quicksort(set,cx%ind,cx%next-1,ix_scan_gt,ix_scan_ge,error)
  case ('SUBSCAN')
     call quicksort(set,cx%ind,cx%next-1,ix_subscan_gt,ix_subscan_ge,error)
  case ('KIND')
     call quicksort(set,cx%ind,cx%next-1,ix_kind_gt,ix_kind_ge,error)
  case ('QUALITY')
     call quicksort(set,cx%ind,cx%next-1,ix_qual_gt,ix_qual_ge,error)
  case ('SOURCE')
     call quicksort(set,cx%ind,cx%next-1,ix_csour_gt,ix_csour_ge,error)
  case ('LINE')
     call quicksort(set,cx%ind,cx%next-1,ix_cline_gt,ix_cline_ge,error)
  case ('TELESCOPE')
     call quicksort(set,cx%ind,cx%next-1,ix_ctele_gt,ix_ctele_ge,error)
  case ('TOC')
     call quicksort(set,cx%ind,cx%next-1,ix_toc_default_gt,ix_toc_default_ge,error)
  case ('NONE')
     return
  end select
  if (error) return
  !
  do cx_iobs=1,cx%next-1
     ix_iobs = cx%ind(cx_iobs)
     call optimize_tooptimize(ix,ix_iobs,cx,cx_iobs,.true.,error)
     if (error)  return
  enddo
end subroutine sort_cx
!
subroutine sort_ix(set,error)
  use classcore_interfaces, except_this=>sort_ix
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Sort the input file index using the quicksort algorithm.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  logical,             intent(inout) :: error  ! Error status
  ! Local
  integer(kind=entry_length) :: nobs
  !
  if (ix%next.le.2) return
  nobs = ix%next-1
  !
  select case (set%sort_name)
  case ('BLOC')
     call quicksort(set,ix%ind,nobs,ix_bloc_gt,ix_bloc_ge,error)
  case ('NUMBER')
     call quicksort(set,ix%ind,nobs,ix_num_gt,ix_num_ge,error)
  case ('VERSION')
     call quicksort(set,ix%ind,nobs,ix_ver_gt,ix_ver_ge,error)
  case ('OBSERVED')
     call quicksort(set,ix%ind,nobs,ix_dobs_gt,ix_dobs_ge,error)
  case ('LAMBDA')
     call quicksort(set,ix%ind,nobs,ix_off1_gt,ix_off1_ge,error)
  case ('BETA')
     call quicksort(set,ix%ind,nobs,ix_off2_gt,ix_off2_ge,error)
  case ('SCAN')
     call quicksort(set,ix%ind,nobs,ix_scan_gt,ix_scan_ge,error)
  case ('SUBSCAN')
     call quicksort(set,ix%ind,nobs,ix_subscan_gt,ix_subscan_ge,error)
  case ('KIND')
     call quicksort(set,ix%ind,nobs,ix_kind_gt,ix_kind_ge,error)
  case ('QUALITY')
     call quicksort(set,ix%ind,nobs,ix_qual_gt,ix_qual_ge,error)
  case ('SOURCE')
     call quicksort(set,ix%ind,nobs,ix_csour_gt,ix_csour_ge,error)
  case ('LINE')
     call quicksort(set,ix%ind,nobs,ix_cline_gt,ix_cline_ge,error)
  case ('TELESCOPE')
     call quicksort(set,ix%ind,nobs,ix_ctele_gt,ix_ctele_ge,error)
  case ('TOC')
     call quicksort(set,ix%ind,nobs,ix_toc_default_gt,ix_toc_default_ge,error)
  case ('NONE')
     return
  end select
  if (error) return
end subroutine sort_ix

subroutine store_wvr(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_rdata
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'clic_xy_code.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end, do_it
  integer(kind=address_length) :: kh, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset
  !      INTEGER LDATA_IN,  OSCAN, SPLINE(MNANT), POL(MNANT),
  !     $LENC, NC1, IA, KR, H_OFFSET
  integer :: oscan, pol(mnant)
  integer :: nc1, ia, kr, ich
  real :: xx, yy
  character(len=80) :: ch2,ch1
  character(len=12) :: typecal(2)
  data typecal /'FPATH','TCAL'/
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  call get_first(.false.,error)    ! to initialise ...
  if (error) goto 999
  call check_output_file(error)
  if (error) goto 999
  call check_equal_file(error)
  if (error) goto 999
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) goto 999
  !
  ! Check for presence of calibration curve
  do_it = .false.
  ch1 = 'No WVR calibration for '
  nc1 = lenc(ch1)+1
  do ia = 1, r_nant
    ch2 = 'Antenna '//char(ia+ichar('0'))
    if (f_polwvr(ia).gt.0) then
      pol (ia) = f_polwvr(ia)
      do_it = .true.
      call message(2,1,'STORE_WVR',ch2(1:9)//' '   &
        //typecal(pol(ia)))
    else
      pol (ia) = 0
      call message(4,2,'STORE_WVR', ch1(1:nc1)//ch2)
    endif
  enddo
  if (.not.do_it) then
    call message (8,4,'STORE_WVR','No WVR curve to store')
    goto 999
  endif
  !
  ! Loop on current index
  end = .false.
  oscan = 0
  do while (.not.end)
    !
    ! Store calibration curves
    call get_data (ldata_in,data_in,error)
    if (error) goto 999
    !
    ! Average record only
    kin = gag_pointer(data_in,memory)
    call spectral_dump(kr,0,0)
    kh = kin + h_offset(kr)
    call decode_header (memory(kh))
    if (error) return
    xx = dh_utc/3600.   &
      + (mod(dh_obs+32768,65536)-mod(dobs_0+32768,65536))*24.
    !
    do ia = 1, r_nant
      if (pol(ia).eq.1) then
        call get_wvr(ia,1,xx,yy,oscan,error)
        if (error) return
        r_wvrfpath(1,ia) = 1./yy
      elseif (pol(ia).eq.2) then
        do ich=1, mwvrch
          call get_wvr(ia,ich,xx,yy,oscan,error)
          if (error) return
          r_wvrtcal(ich,ia) = yy
        enddo
      endif
    enddo
    !
    ! Update or copy scan
    call write_scan (.false.,error)
    if (error) goto 999
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) goto 999
  enddo
  return
  !
999 error = .true.
  return
end subroutine store_wvr
!
subroutine get_wvr(ia,ich,x,y,oscan,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Returns in Y the value and derivatives of the calibration curve
  ! at time X,
  ! for baseline IB, side band ISB.
  !---------------------------------------------------------------------
  integer :: ia                     !
  integer :: ich                    !
  real :: x                         !
  real :: y                         !
  integer :: oscan                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  ! Local
  real*8 :: xx, yy(4), aa(m_pol)
  integer :: ifail, i
  character(len=80) :: ch
  !------------------------------------------------------------------------
  ! Code:
  xx = x
  error = .false.
  !
  ! Polynomials
  ifail = 1
  if (xx.lt.t_polwvr(1,ia)) then
    if (t_polwvr(1,ia)-xx .gt. 0.1) then
      if (r_scan.ne.oscan) then
        oscan = r_scan
        write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
          'Time ',xx,' below limit (',   &
          t_polwvr(1,ia),')'
        call message (5,2,'GET_WVR',ch(1:lenc(ch)))
      endif
    endif
    xx = t_polwvr(1,ia)
  elseif (xx.gt.t_polwvr(2,ia)) then
    if (xx-t_polwvr(2,ia).gt.0.1) then
      if (r_scan.ne.oscan) then
        oscan = r_scan
        write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
          'Time ',xx,' above limit (',   &
          t_polwvr(2,ia),')'
        call message (5,2,'GET_WVR',ch(1:lenc(ch)))
      endif
    endif
    xx = t_polwvr(2,ia)
  endif
  do i=1, n_polwvr(ia)
    aa(i) = c_polwvr(i,ia,ich)
  enddo
  xx = ((xx-t_polwvr(1,ia))-(t_polwvr(2,ia)-xx))   &
    /(t_polwvr(2,ia)-t_polwvr(1,ia))
  xx = max(xx,-1d0)
  xx = min(xx,1d0)
  call mth_getpol ('GET_WVR',n_polwvr(ia),aa,xx,yy,error)
  if (error) return
  y = yy(1)
end subroutine get_wvr

program histo_simple
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GDF	Main program for making a Histogram from a map
  ! Subroutines
  !	HISTO002
  !
  ! To be re-written for more efficiency: just extract the relevant
  ! part of the image first.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  real :: hmin,hmax,hstep
  integer, parameter :: mdim=4
  integer :: n, pmin(mdim), pmax(mdim), nh, ier
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('Y_BLC$',pmin,mdim)
  call gildas_inte('Y_TRC$',pmax,mdim)
  call gildas_inte('X_BINS$',nh,1)
  call gildas_real('X_MIN$',hmin,1)
  call gildas_real('X_MAX$',hmax,1)
  call gildas_close
  !
  call gildas_null(y)
  y%blc(1:mdim) = pmin
  y%trc(1:mdim) = pmax
  !
  ! y%gil%form = fmt_r4 ! This is the default
  call gdf_read_gildas(y,namey,'.gdf',error,rank=0)
  if (error) goto 100
  if (y%gil%blan_words.eq.0) then
    y%gil%eval = -1.0
    y%gil%bval = 0.0
  endif
  !
  call gildas_null(x, type = 'TABLE' )
  n = lenc(namex)
  if (n.eq.0) goto 100
  call sic_parsef(namex(1:n),x%file,' ','.tab')
  x%gil%dim(1) = nh
  x%gil%dim(2) = 2
  hstep = (hmax-hmin)/(nh-1)
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier)
  call histo002(y%r1d,y%loca%size,y%gil%bval,y%gil%eval,   &
     &    x%r2d,x%gil%dim(1),hmin,hstep)
  call gdf_write_image (x,x%r2d,error)
  call gagout('S-HISTO_SIMPLE,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program histo_simple
!
subroutine histo002(y,ydim,bval,eval, x,nh,hmin,hstep)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Computes the histogram of part of an image
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ydim     ! Input array size
  real(kind=4),               intent(in)    :: y(ydim)  ! Input array
  real(kind=4),               intent(in)    :: bval     ! Blanking
  real(kind=4),               intent(in)    :: eval     ! Tolerance
  integer(kind=index_length), intent(in)    :: nh       ! Histogram size
  real(kind=4),               intent(inout) :: x(nh,2)  ! Histogram values
  real(kind=4),               intent(in)    :: hmin     ! Min val
  real(kind=4),               intent(in)    :: hstep    ! Step
  ! Local
  integer(kind=size_length) :: i,n,ntot,nin,nout,nblank
  !
  nin = 0
  nout = 0
  nblank = 0
  x(:,1) = 0.0
  !
  if (eval.ge.0.0) then
    do i=1,ydim
      if (abs(y(i)-bval).gt.eval) then
        n = nint((y(i)-hmin)/hstep + 1.0)
        if (n.ge.1 .and. n.le.nh) then
          x(n,1) = x(n,1)+1.
          nin = nin+1
        else
          nout= nout+1
        endif
      else
        nblank = nblank+1
      endif
    enddo
  else
    do i=1,ydim
      n = nint((y(i)-hmin)/hstep + 1.0)
      if (n.ge.1 .and. n.le.nh) then
        x(n,1) = x(n,1)+1.
        nin = nin+1
      else
        nout= nout+1
      endif
    enddo
  endif  
  !
  ! Now fill the histogram definition
  do n=1,nh
    x(n,2) = hmin - hstep + n*hstep
  enddo
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
     &    nout,float(nout)/float(ntot)*1.e2,   &
     &    nblank,float(nblank)/float(ntot)*1.e2,   &
     &    ntot
100 format(1x,'Number of points in histogram ',i12,4x,f4.1,' %',   &
     &    /,'   "    "    "    out of  "    ',i12,4x,f4.1,' %',   &
     &    /,'   "    "    "    blanked      ',i12,4x,f4.1,' %',   &
     &    /,'                  Total      = ',i12)
end subroutine histo002

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_minmax
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubehistogram_messaging
  !
  public :: minmax
  private
  !
  type minmax_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(cuberegion_comm_t)     :: region
     type(cube_prod_t),  pointer :: min
     type(cube_prod_t),  pointer :: max
   contains
     procedure, public  :: register => cubehistogram_minmax_register
     procedure, private :: parse    => cubehistogram_minmax_parse
     procedure, private :: main     => cubehistogram_minmax_main
  end type minmax_comm_t
  type(minmax_comm_t) :: minmax  
  !
  type minmax_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubehistogram_minmax_user_toprog
  end type minmax_user_t
  !
  type minmax_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer :: cube
     type(cube_t), pointer :: min
     type(cube_t), pointer :: max
   contains
     procedure, private :: header => cubehistogram_minmax_prog_header
     procedure, private :: data   => cubehistogram_minmax_prog_data
     procedure, private :: loop   => cubehistogram_minmax_prog_loop
     procedure, private :: act    => cubehistogram_minmax_prog_act
  end type minmax_prog_t
  !
contains
  !
  subroutine cubehistogram_minmax_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(minmax_user_t) :: user
    character(len=*), parameter :: rname='MINMAX>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call minmax%parse(line,user,error)
    if (error) return
    call minmax%main(user,error)
    if (error) continue
  end subroutine cubehistogram_minmax_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_minmax_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(minmax_comm_t), intent(inout) :: comm
    logical,              intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='MINMAX>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'MINMAX','[cube]',&
         'Summarize a cube with minimum and maximum coordinate maps',&
         'Summarize each processed spectrum by the first and last&
         & spectral-coordinate values where the input is finite.'//strg_bl//&
         'Behavior:'//strg_cr//&
         'Use INPUT as the cube to summarize. The region options choose&
         & which part of the cube is inspected. For each processed&
         & spectrum, MIN is the lowest spectral coordinate with a&
         & finite input value and MAX is the highest one.'//strg_cr//&
         'The outputs are one-channel images in the selected spatial&
         & geometry. On a HISTO3D cube, they become lower and upper Z&
         & maps for each (X,Y) histogram bin.'//strg_bl//&
         'Notes:'//strg_cr//&
         'If no finite value is found in the selected range, both&
         & outputs are written as NaN.'//strg_cr//&
         'The command accepts any real cube, but its main histogram use&
         & is to summarize the HISTO3D product.'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'Build the 3D histogram first, then summarize the Z span&
         & stored in each (X,Y) histogram bin.'//strg_cr//&
         'CUBE> HISTOGRAM\HISTO3D xcube ycube zcube'//strg_cr//&
         'CUBE> HISTOGRAM\MINMAX histo3d.',&
         cubehistogram_minmax_command,&
         comm%comm,error)
    if (error) return
    call cubearg%register(&
         'INPUT',&
         'Input cube',&
         'Input cube to summarize.'//strg_cr//&
         'If input is omitted, CUBE uses the standard CubeID fallback&
         & in the default index (DAG by default; see SET\INDEX) and&
         & keeps the last matching product.'//strg_cr//&
         'This fallback is intentionally broad, so give input&
         & explicitly unless the intended cube is obvious.',&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%cube,&
         error)
    if (error) return
    !
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'MIN',&
         'Cube of minimum values',&
         strg_emp,&
         [flag_minimum,flag_image],&
         comm%min,&
         error)
    if (error) return
    call oucube%register(&
         'MAX',&
         'Cube of maximum values',&
         strg_emp,&
         [flag_maximum,flag_image],&
         comm%max,&
         error)
    if (error) return
  end subroutine cubehistogram_minmax_register
  !
  subroutine cubehistogram_minmax_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! MINMAX cubname
    ! /SIZE sx [sy]
    ! /CENTER xcen ycen
    ! /RANGE zfirst zlast
    ! /SPECTRUM
    ! /IMAGE
    !----------------------------------------------------------------------
    class(minmax_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(minmax_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MINMAX>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubehistogram_minmax_parse
  !
  subroutine cubehistogram_minmax_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(minmax_comm_t), intent(in)    :: comm
    type(minmax_user_t),  intent(inout) :: user
    logical,              intent(inout) :: error
    !
    type(minmax_prog_t) :: prog
    character(len=*), parameter :: rname='MINMAX>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_minmax_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_minmax_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(minmax_user_t), intent(in)    :: user
    type(minmax_comm_t),  intent(in)    :: comm
    type(minmax_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='MINMAX>USER>TOPROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    call user%region%toprog(prog%cube,prog%region,error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubehistogram_minmax_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_minmax_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(minmax_prog_t), intent(inout) :: prog
    type(minmax_comm_t),  intent(in)    :: comm
    logical,              intent(inout) :: error
    !
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MINMAX>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%min,prog%cube,prog%min,error)
    if (error) return
    call prog%region%header(prog%min,error)
    if (error) return
    call cubetools_header_put_nchan(one,prog%min%head,error)
    if (error) return
    !
    call cubeadm_clone_header(comm%max,prog%cube,prog%max,error)
    if (error) return
    call prog%region%header(prog%max,error)
    if (error) return
    call cubetools_header_put_nchan(one,prog%max%head,error)
    if (error) return
  end subroutine cubehistogram_minmax_prog_header
  !
  subroutine cubehistogram_minmax_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(minmax_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='MINMAX>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubehistogram_minmax_prog_data
  !
  subroutine cubehistogram_minmax_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(minmax_prog_t),     intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(spectrum_t) :: spe,min,max
    character(len=*), parameter :: rname='MINMAX>PROG>LOOP'
    !
    call spe%associate('cube',prog%cube,iter,error)
    if (error) return
    call spe%associate_x(error)
    if (error) return
    call min%allocate('min',prog%min,iter,error)
    if (error) return
    call max%allocate('max',prog%max,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
       call prog%act(iter%ie,spe,min,max,error)
       if (error) return
    enddo ! ie
  end subroutine cubehistogram_minmax_prog_loop
  !   
  subroutine cubehistogram_minmax_prog_act(prog,ie,spectrum,spemin,spemax,error)
    use cubetools_nan
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(minmax_prog_t), intent(inout) :: prog
    integer(kind=entr_k), intent(in)    :: ie
    type(spectrum_t),     intent(inout) :: spectrum
    type(spectrum_t),     intent(inout) :: spemin
    type(spectrum_t),     intent(inout) :: spemax
    logical,              intent(inout) :: error
    !
    real(kind=sign_k) :: xval,yval
    real(kind=sign_k) :: mymin,mymax
    integer(kind=chan_k) :: if,il,iz
    integer(kind=chan_k), parameter :: one=1
    character(len=*), parameter :: rname='MINMAX>PROG>ACT'
    !
    call spectrum%get(ie,error)
    if (error) return
    if = prog%region%iz%first
    il = prog%region%iz%last
    mymin = gr4nan
    mymax = gr4nan
    do iz=if,il
       xval = spectrum%x%val(iz)
       yval = spectrum%y%val(iz)
       if (ieee_is_finite(yval)) then
          if (ieee_is_finite(mymin)) then
             mymin = min(mymin,xval)
             mymax = max(mymax,xval)
          else
             mymin = xval
             mymax = xval
          endif
       endif
    enddo ! iz
    spemin%y%val(one) = mymin
    spemax%y%val(one) = mymax
    call spemin%put(ie,error)
    if (error) return
    call spemax%put(ie,error)
    if (error) return
  end subroutine cubehistogram_minmax_prog_act
end module cubehistogram_minmax
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module cubelist_list_types
  use cubetools_parameters
  use cubelist_messaging
  use cubelist_object_class
  use cubelist_object_pointer_types
  !---------------------------------------------------------------------
  ! Support module to support generic list of objects, including methods
  ! to reallocate them, preserving previous values.
  ! The base type is an empty shell (class). Users have to create
  ! extended types from this class.
  !---------------------------------------------------------------------
  !
  private
  public :: list_k
  public :: list_t
  !
  integer(kind=4), parameter :: list_k=8
  !
  type :: list_t
    integer(kind=list_k), private :: first = 1  ! Array index starting point (as allocated)
    integer(kind=list_k), private :: last  = 0  ! Array index end point (as allocated)
    integer(kind=list_k), public  :: n = 0      ! Useful part of the array (upper bound)
    type(list_object_p_t), allocatable, public :: list(:)
  contains
    ! Actions on the whole list
    procedure, public  :: lbound     => cubelist_set_lbound
    procedure, private :: reallocate_byubound4 => cubelist_reallocate_byubound4
    procedure, private :: reallocate_byubound8 => cubelist_reallocate_byubound8
    generic,   public  :: reallocate => reallocate_byubound4,reallocate_byubound8
    procedure, public  :: copy       => cubelist_copy
    procedure, public  :: enlarge    => cubelist_enlarge
    procedure, public  :: final      => cubelist_final  ! NB: no implicit FINAL: Fortran requires
                                                        ! the exact type as argument (does not work for extended types)
    ! Actions on 1 object in list
    procedure, public  :: allocate   => cubelist_allocate
    procedure, public  :: associate  => cubelist_associate
    procedure, public  :: pop        => cubelist_pop
    procedure, public  :: dissociate => cubelist_dissociate
  end type list_t
  !
contains
  !
  subroutine cubelist_set_lbound(arr,first,error)
    !-------------------------------------------------------------------
    ! Modify the lower-bound index of the array. Future allocations will
    ! use this value as lower-bound.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    integer(kind=list_k), intent(in)    :: first
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SET>LBOUND'
    !
    if (allocated(arr%list)) then
      call cubelist_message(seve%e,rname,  &
        'Can not modify list lower-bound as list is already allocated')
      error = .true.
      return
    endif
    arr%first = first
  end subroutine cubelist_set_lbound
  !
  recursive subroutine cubelist_reallocate_byubound4(arr,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version without the index of the first component (i.e.
    ! indices run from 1 to n).
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=4), intent(in)    :: n
    logical,         intent(inout) :: error
    !
    call cubelist_reallocate_byrange8(arr,arr%first,int(n,kind=8),error)
    if (error) return
  end subroutine cubelist_reallocate_byubound4
  !
  recursive subroutine cubelist_reallocate_byubound8(arr,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version without the index of the first component (i.e.
    ! indices run from 1 to n).
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=8), intent(in)    :: n
    logical,         intent(inout) :: error
    !
    call cubelist_reallocate_byrange8(arr,arr%first,n,error)
    if (error) return
  end subroutine cubelist_reallocate_byubound8
  !
  recursive subroutine cubelist_reallocate_byrange8(arr,first,last,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! (Re)allocate to given size.
    ! Previous values are preserved if a reallocation is actually
    ! performed.
    ! ---
    ! This version with a range of indices to allocate.
    !-------------------------------------------------------------------
    class(list_t),   intent(inout) :: arr
    integer(kind=8), intent(in)    :: first,last
    logical,         intent(inout) :: error
    !
    integer(kind=list_k), parameter :: array_minalloc=10
    integer(kind=list_k) :: ofirst,olast,nfirst,nlast
    integer(kind=4) :: ier
    type(list_t) :: tmp
    character(len=*), parameter :: rname='LIST>REALLOCATE'
    !
    if (allocated(arr%list)) then
      ofirst = lbound(arr%list,1)
      olast  = ubound(arr%list,1)
      if (ofirst.eq.first .and. olast.ge.last) then
        arr%first = ofirst  ! Should not be needed
        arr%last  = olast   ! Should not be needed
        return
      else
        call cubelist_transfer(arr,tmp,error)
        if (error) return
      endif
    else
      olast = 0
    endif
    !
    nfirst = first
    nlast = max(last,2*olast)
    nlast = max(nlast,array_minalloc)
    !
    allocate(arr%list(nfirst:nlast),stat=ier)
    if (failed_allocate(rname,'list',ier,error)) return
    arr%first = nfirst
    arr%last = nlast
    arr%n = nfirst-1
    !
    if (tmp%n.gt.0) then
      call cubelist_transfer(tmp,arr,error)
      if (error) return
    endif
  end subroutine cubelist_reallocate_byrange8
  !
  subroutine cubelist_enlarge(arr,nnew,start,error)
    !-------------------------------------------------------------------
    ! Enlarge a list_t by inserting 'nnew' elements at the
    ! desired position. Old elements are moved consistently if needed,
    ! new elements are left unallocated.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    integer(kind=list_k), intent(in)    :: nnew
    integer(kind=list_k), intent(in)    :: start
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: ntot,ielem,jelem
    !
    ! First enlarge to its full size
    ntot = arr%n+nnew
    call cubelist_reallocate_byrange8(arr,arr%first,ntot,error)
    if (error)  return
    !
    ! Move the old elements to the right, if any
    do ielem=arr%n,start,-1  ! Old position
      jelem = ielem+nnew  ! New position
      arr%list(jelem)%p            => arr%list(ielem)%p
      arr%list(jelem)%code_pointer =  arr%list(ielem)%code_pointer
      ! Keep old element as a pointer. Probably not much sense but this
      ! leaves the array in proper shape (the caller will probably do
      ! other things with this element).
      arr%list(ielem)%code_pointer = code_pointer_associated
    enddo
    !
    ! arr%n is not updated, as sometimes we kept valid pointers, but
    ! sometimes (when enlarging to the right) the pointers are just null
    ! (thus unusable). It is the reponsibility of the caller to update
    ! arr%n when relevant.
  end subroutine cubelist_enlarge
  !
  subroutine cubelist_final(arr,error)
    !-------------------------------------------------------------------
    ! Free the targets referenced by the list (if relevant) AND
    ! free the list itself.
    ! This properly works if the targets have declared a FINAL method.
    !-------------------------------------------------------------------
    class(list_t), intent(inout) :: arr
    logical,       intent(inout) :: error
    !
    integer(kind=list_k) :: iobj
    !
    ! Free the targets
    if (allocated(arr%list)) then
      do iobj=arr%first,arr%last
        call arr%list(iobj)%final(error)
        if (error)  return
      enddo
    endif
    !
    ! Free the list
    if (allocated(arr%list))  deallocate(arr%list)
    arr%first = 1
    arr%last = 0
    arr%n = 0
  end subroutine cubelist_final
  !
  subroutine cubelist_copy(arr1,arr2,error)
    !-------------------------------------------------------------------
    ! Copy one list to another, including implicit reallocation of the
    ! output instance.
    ! The target objects are saved under the association status, i.e.
    ! they do not own the allocation.
    !-------------------------------------------------------------------
    class(list_t), intent(in)    :: arr1
    class(list_t), intent(inout) :: arr2
    logical,       intent(inout) :: error
    !
    integer(kind=list_k) :: i,last
    !
    if (.not.allocated(arr1%list)) then
      call arr2%final(error)
      return
    endif
    !
    last = arr1%n  ! Transfer only the useful part
    call cubelist_reallocate_byrange8(arr2,arr1%first,last,error)
    if (error) return
    !
    do i=arr1%first,last
      arr2%list(i)%p => arr1%list(i)%p
      arr2%list(i)%code_pointer = code_pointer_associated
    enddo
    arr2%n = arr1%n
  end subroutine cubelist_copy
  !
  subroutine cubelist_transfer(arr1,arr2,error)
    !-------------------------------------------------------------------
    ! Transfer one list to another, including allocation property if
    ! relevant. Includes implicit reallocation of the output instance.
    ! The input object is freed in return.
    !-------------------------------------------------------------------
    type(list_t), intent(inout) :: arr1
    type(list_t), intent(inout) :: arr2
    logical,      intent(inout) :: error
    !
    integer(kind=list_k) :: i,last
    !
    last = arr1%n  ! Transfer only the useful part
    call cubelist_reallocate_byrange8(arr2,arr1%first,last,error)
    if (error) return
    !
    do i=arr1%first,last
      ! Steal the object
      arr2%list(i)%p => arr1%list(i)%p
      arr2%list(i)%code_pointer = arr1%list(i)%code_pointer
      ! Just keep as a pointer
      arr1%list(i)%code_pointer = code_pointer_associated
    enddo
    arr2%n = arr1%n
    !
    call arr1%final(error)
    if (error) return
  end subroutine cubelist_transfer
  !
  !---------------------------------------------------------------------
  !
  subroutine cubelist_allocate(arr,template,lot,error)
    !----------------------------------------------------------------------
    ! Allocate an extended 'list_object_t' in memory, appended at last
    ! position in the list, of type taken from the given template. Return
    ! a pointer to this object in return.
    !----------------------------------------------------------------------
    class(list_t),        intent(inout) :: arr
    class(list_object_t), intent(in)    :: template
    class(list_object_t), pointer       :: lot
    logical,              intent(inout) :: error
    !
    call arr%reallocate(arr%n+1,error)
    if (error) return
    call arr%list(arr%n+1)%allocate(template,error)
    if (error) return
    ! Success
    arr%n = arr%n+1
    lot => arr%list(arr%n)%p
  end subroutine cubelist_allocate
  !
  subroutine cubelist_associate(arr,lot,error)
    !----------------------------------------------------------------------
    ! Associate an extended 'list_object_t' in memory, appended at last
    ! position in the list.
    !----------------------------------------------------------------------
    class(list_t),        intent(inout)      :: arr
    class(list_object_t), intent(in), target :: lot
    logical,              intent(inout)      :: error
    !
    call arr%reallocate(arr%n+1,error)
    if (error) return
    call arr%list(arr%n+1)%associate(lot,error)
    if (error) return
    ! Success
    arr%n = arr%n+1
  end subroutine cubelist_associate
  !
  subroutine cubelist_pop(full,ipop,error)
    !-------------------------------------------------------------------
    ! Free the ith element and pop it out from the list (list compressed
    ! in return)
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: full
    integer(kind=list_k), intent(in)    :: ipop
    logical,              intent(inout) :: error
    !
    integer(kind=list_k) :: iobj
    !
    call full%list(ipop)%final(error)
    if (error)  return
    !
    do iobj=ipop+1,full%n
      full%list(iobj-1)%p            => full%list(iobj)%p
      full%list(iobj-1)%code_pointer =  full%list(iobj)%code_pointer
    enddo
    !
    ! Last element is now unused
    full%list(full%n)%p            => null()
    full%list(full%n)%code_pointer =  code_pointer_null
    !
    ! Update array size
    full%n = full%n-1
    !
    if (full%n.lt.full%first) then
      call full%final(error)
      if (error) return
    endif
  end subroutine cubelist_pop
  !
  subroutine cubelist_dissociate(full,object,error)
    !-------------------------------------------------------------------
    ! Dissociate (dereference) the given 'object' from the list (assume
    ! there can be one or more occurrences). The object itself is freed
    ! or not according to its code_pointer status.
    !
    ! The list is compressed in return.
    !-------------------------------------------------------------------
    class(list_t),        intent(inout) :: full
    class(list_object_t), pointer       :: object
    logical,              intent(inout) :: error
    !
    integer(kind=entr_k) :: ient,shift
    logical :: found
    !
    found = .false.
    shift = 0
    do ient=full%first,full%n
      if (associated(full%list(ient)%p,object)) then
        found = .true.
        shift = shift+1
        call full%list(ient)%final(error)
        if (error)  return
        cycle
      endif
      if (found) then
        full%list(ient-shift)%p => full%list(ient)%p
        full%list(ient-shift)%code_pointer = full%list(ient)%code_pointer
      endif
    enddo
    full%n = full%n-shift
    !
    if (full%n.lt.full%first) then
      call full%final(error)
      if (error) return
    endif
  end subroutine cubelist_dissociate
  !
end module cubelist_list_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_variable_command(line,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_variable_command
  use wifisyn_parameters
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    VARIABLE
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  character(len=*), parameter :: rname='VARIABLE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_gridding_sicdef_prog(code_request_user,error)
  if (error) return
  !
end subroutine wifisyn_variable_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine lfit(x,y,weight,ndata,a,ma,covar,ncvm,chisq,funcs,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Given a set of NDATA points X(I),Y(I) with individual weights WEIGHT(I),
  ! use Chi2 minimization to determine the MA coefficients A
  ! of a function that depends linearly on A.
  !---------------------------------------------------------------------
  integer,                    intent(in)  :: ndata   ! Size of data arrays
  real, dimension(ndata),     intent(in)  :: x       ! Abscissa of input values
  real, dimension(ndata),     intent(in)  :: y       ! Ordinates of input values
  real, dimension(ndata),     intent(in)  :: weight  ! Weights
  integer,                    intent(in)  :: ma      ! Approx. polynom number
  real, dimension(ma),        intent(out) :: a       ! Output coefficients
  integer,                    intent(in)  :: ncvm    ! Size of covariance matrix
  real, dimension(ncvm,ncvm), intent(out) :: covar   ! Covariance matrix (pivot)
  real,                       intent(out) :: chisq   ! Chi2 value
  external                                :: funcs   ! Approx. function
  logical,                    intent(out) :: error   ! Error flag
  ! Local
  integer, parameter :: mmax=50
  real :: beta(mmax),afunc(mmax)
  integer :: i,j,k
  real :: sig2i,sum,ym,wt
  !
  if (ma.gt.mmax) then
     call class_message(seve%f,'LFIT','Incoherent array dimensions')
     error = .true.
     return
  endif
  !
  do j=1,ma
     do k=1,ma
        covar(j,k)=0.
     enddo
     beta(j)=0.
  enddo
  do i=1,ndata
     call funcs(x(i),afunc,ma)
     ym=y(i)
     sig2i=weight(i)
     do j=1,ma
        wt=afunc(j)*sig2i
        do k=1,j
           covar(j,k)=covar(j,k)+wt*afunc(k)
        enddo
        beta(j)=beta(j)+ym*wt
     enddo
  enddo
  if (ma.gt.1) then
     do j=2,ma
        do k=1,j-1
           covar(k,j)=covar(j,k)
        enddo
     enddo
  endif
  call gaussj(covar,ma,ncvm,beta,1,1)
  do j=1,ma
     a(j)=beta(j)
  enddo
  chisq=0.
  do i=1,ndata
     call funcs(x(i),afunc,ma)
     sum=0.
     do j=1,ma
        sum=sum+a(j)*afunc(j)
     enddo
     chisq=chisq+((y(i)-sum)*weight(i))**2
  enddo
  return
end subroutine lfit
!
subroutine gaussj(a,n,np,b,m,mp)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Gauss Jordan elimination with full pivoting
  ! Solve A.X = B by computing inv(A) : X = inv(A).B
  !---------------------------------------------------------------------
  integer, intent(in)    ::  np        ! Size
  real,    intent(inout) ::  a(np,np)  ! On input A ; on output inv(A)
  integer, intent(in)    ::  n         ! Size of X vectors
  integer, intent(in)    ::  mp        ! Size
  real,    intent(inout) ::  b(np,mp)  ! On input, RHS ; on output, X vectors
  integer, intent(in)    ::  m         ! Number of X vectors
  ! Local
  character(len=*), parameter :: rname='GAUSSJ'
  integer, parameter :: nmax=50
  real :: big,dum,pivinv
  integer, dimension(nmax) :: ipiv,indxr,indxc
  integer :: i,j,k,l,ll,irow,icol
  !
  do j=1,n
     ipiv(j)=0
  enddo
  do i=1,n
     big=0.
     do j=1,n
        if(ipiv(j).ne.1)then
           do k=1,n
              if (ipiv(k).eq.0) then
                 if (abs(a(j,k)).ge.big)then
                    big=abs(a(j,k))
                    irow=j
                    icol=k
                 endif
              elseif  (ipiv(k).gt.1) then
                 call class_message(seve%r,rname,'Singular matrix')
                 return
              endif
           enddo
        endif
     enddo
     ipiv(icol)=ipiv(icol)+1
     if (irow.ne.icol) then
        do l=1,n
           dum=a(irow,l)
           a(irow,l)=a(icol,l)
           a(icol,l)=dum
        enddo
        do l=1,m
           dum=b(irow,l)
           b(irow,l)=b(icol,l)
           b(icol,l)=dum
        enddo
     endif
     indxr(i)=irow
     indxc(i)=icol
     if (a(icol,icol).eq.0.) then
        call class_message(seve%r,rname,'Singular matrix')
        return
     endif
     pivinv=1./a(icol,icol)
     a(icol,icol)=1.
     do l=1,n
        a(icol,l)=a(icol,l)*pivinv
     enddo
     do l=1,m
        b(icol,l)=b(icol,l)*pivinv
     enddo
     do ll=1,n
        if(ll.ne.icol)then
           dum=a(ll,icol)
           a(ll,icol)=0.
           do l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
           enddo
           do  l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
           enddo
        endif
     enddo
  enddo
  do l=n,1,-1
     if(indxr(l).ne.indxc(l))then
        do k=1,n
           dum=a(k,indxr(l))
           a(k,indxr(l))=a(k,indxc(l))
           a(k,indxc(l))=dum
        enddo
     endif
  enddo
  return
end subroutine gaussj

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_header_hcdf
  use cubetools_parameters
  use cubetools_header_interface
  use cubedag_node_class
  use cubecdf_header
  use cubeio_header_interface
  use cubeio_messaging
  !
  public :: cubeio_header_get_and_derive_fromhcdf
  public :: cubeio_header_put_tohcdf
  public :: cubeio_header_truncate_and_put_tohcdf
  private
  !
contains
  !
  subroutine cubeio_header_get_and_derive_fromhcdf(hcdf,dno,error)
    !-------------------------------------------------------------------
    ! From type(cdf_header_t) to type(cube_header_interface_t)
    !-------------------------------------------------------------------
    type(cdf_header_t),           intent(in)    :: hcdf
    class(cubedag_node_object_t), intent(inout) :: dno
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>GET>AND>DERIVE'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call cubeio_hcdf_export(hcdf,dno%node%head,error)
    if (error) return
    call dno%node%interf2head(error)
    if (error) return
  end subroutine cubeio_header_get_and_derive_fromhcdf
  !
  subroutine cubeio_header_put_tohcdf(dno,order,hcdf,error)
    !-------------------------------------------------------------------
    ! From type(cube_header_interface_t) to type(cdf_header_t) with
    ! desired order.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: order  ! code_order_*
    type(cdf_header_t),           intent(inout) :: hcdf
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PUT'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call dno%node%head2interf(error)
    if (error) return
    call cubeio_header_interface_transpose(dno%node%head,order,error)  ! Inplace
    if (error) return
    call dno%node%head%compact_dim(error)
    if (error) return
    call cubeio_hcdf_import(dno%node%head,hcdf,error)
    if (error) return
  end subroutine cubeio_header_put_tohcdf
  !
  subroutine cubeio_header_truncate_and_put_tohcdf(dno,order,dim3,hcdf,error)
    !-------------------------------------------------------------------
    ! From type(cube_header_interface_t) to type(cdf_header_t) with
    ! desired order.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: order  ! code_order_*
    integer(kind=data_k),         intent(in)    :: dim3
    type(cdf_header_t),           intent(inout) :: hcdf
    logical,                      intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>TRUNCATE>AND>PUT'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    call dno%node%head2interf(error)
    if (error) return
    call cubeio_header_interface_transpose(dno%node%head,order,error)  ! Inplace
    if (error) return
    call cubeio_header_interface_truncate(dno%node%head,dim3,error)  ! Inplace
    if (error) return
    call dno%node%head%compact_dim(error)
    if (error) return
    call cubeio_hcdf_import(dno%node%head,hcdf,error)
    if (error) return
  end subroutine cubeio_header_truncate_and_put_tohcdf
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeio_hcdf_export(hcdf,out,error)
    !-------------------------------------------------------------------
    ! From type(cdf_header_t) to type(cube_header_interface_t)
    !-------------------------------------------------------------------
    type(cdf_header_t),            intent(in)    :: hcdf
    type(cube_header_interface_t), intent(inout) :: out
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='HCDF>EXPORT'
    !
    call cubeio_message(seve%e,rname,'Not implemented')
    error = .true.
    return
  end subroutine cubeio_hcdf_export
  !
  subroutine cubeio_hcdf_import(in,hcdf,error)
    !-------------------------------------------------------------------
    ! From type(cube_header_interface_t) to type(gildas)
    !-------------------------------------------------------------------
    type(cube_header_interface_t), intent(in)    :: in
    type(cdf_header_t),            intent(inout) :: hcdf
    logical,                       intent(inout) :: error
    !
    integer(kind=ndim_k) :: ndim
    character(len=*), parameter :: rname='HGDF>IMPORT'
    !
    call cubeio_message(ioseve%trace,rname,'Welcome')
    !
    ! By design CUBE does not insert fake dimensions before exporting to
    ! CDF format (shoud they be needed). Or should we?...
    call in%sanity_dim(error)
    if (error)  return
    !
    ! Data format
    hcdf%type = in%array_type
    ! Dimension section
    if (in%axset_ndim.le.maxdim) then
       ndim = in%axset_ndim
    else
       call hcdf%message(seve%d,rname,'Larger number of dimensions than room to store it! => Truncating')
       ndim = maxdim
    endif
    hcdf%ndim = ndim
    hcdf%dim = 0
    hcdf%dim(1:ndim) = in%axset_dim(1:ndim)
  end subroutine cubeio_hcdf_import
  !
end module cubeio_header_hcdf
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeio_cdf
  use cubetools_parameters
  use cubetools_header_types
  use cubecdf_header
  use cubeio_messaging
  use cubeio_header_hcdf
  use cubeio_range

  public :: cubeio_create_hcdf,cubeio_create_and_truncate_hcdf
  public :: cubeio_cdf_read_data
  public :: cubeio_cdf_write_data
  private

  interface cubeio_cdf_read_data
    module procedure cubeio_cdf_read_data_r4
    module procedure cubeio_cdf_read_data_c4
  end interface cubeio_cdf_read_data

  interface cubeio_cdf_write_data
    module procedure cubeio_cdf_write_data_r4
    module procedure cubeio_cdf_write_data_c4
  end interface cubeio_cdf_write_data

contains
  !
  subroutine cubeio_create_hcdf(dno,oorder,hcdf,error)
    use cubedag_node_class
    !---------------------------------------------------------------------
    ! Create or recreate the hcdf by converting the header with requested
    ! order.
    !---------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: oorder
    type(cdf_header_t),           intent(inout) :: hcdf
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='CREATE>HCDF'
    !
    call cubeio_header_put_tohcdf(dno,oorder,hcdf,error)
    if (error)  return
  end subroutine cubeio_create_hcdf
  !
  subroutine cubeio_create_and_truncate_hcdf(dno,oorder,dim3,hcdf,error)
    use cubedag_node_class
    !---------------------------------------------------------------------
    ! Same as cubeio_create_hcdf, but truncate the 3rd dimension to
    ! requested size.
    !---------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: dno
    integer(kind=code_k),         intent(in)    :: oorder
    integer(kind=data_k),         intent(in)    :: dim3
    type(cdf_header_t),           intent(inout) :: hcdf
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='CREATE>AND>TRUNCATE>HCDF'
    !
    call cubeio_header_truncate_and_put_tohcdf(dno,oorder,dim3,hcdf,error)
    if (error)  return
  end subroutine cubeio_create_and_truncate_hcdf

  subroutine cubeio_cdf_read_data_r4(hcdf,data,range,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    type(cdf_header_t),   intent(in)    :: hcdf
    real(kind=4),         intent(out)   :: data(:,:,:)
    type(cubeio_range_t), intent(in)    :: range
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='CDF>READ>DATA>R4'
    !
    call cubeio_message(seve%e,rname,'Reading REAL*4 data from CDF is not implemented')
    error = .true.
    return
  end subroutine cubeio_cdf_read_data_r4

  subroutine cubeio_cdf_read_data_c4(hcdf,data,range,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    type(cdf_header_t),   intent(in)    :: hcdf
    complex(kind=4),      intent(out)   :: data(:,:,:)
    type(cubeio_range_t), intent(in)    :: range
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='CDF>READ>DATA>C4'
    !
    call cubeio_message(seve%e,rname,'Reading COMPLEX*4 data from CDF is not implemented')
    error = .true.
    return
  end subroutine cubeio_cdf_read_data_c4

  subroutine cubeio_cdf_write_data_r4(hcdf,data,range,error)
    use cubecdf_image_write
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    type(cdf_header_t),   intent(in)    :: hcdf
    real(kind=4),         intent(in)    :: data(:,:,:)
    type(cubeio_range_t), intent(in)    :: range
    logical,              intent(inout) :: error
    !
    call cubecdf_image_datawrite(hcdf,data,range%blc,range%trc,error)
    if (error)  return
  end subroutine cubeio_cdf_write_data_r4

  subroutine cubeio_cdf_write_data_c4(hcdf,data,range,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    type(cdf_header_t),   intent(in)    :: hcdf
    complex(kind=4),      intent(in)    :: data(:,:,:)
    type(cubeio_range_t), intent(in)    :: range
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='CDF>WRITE>DATA>C4'
    !
    call cubeio_message(seve%e,rname,'Exporting COMPLEX*4 data to CDF is not implemented')
    error = .true.
    return
  end subroutine cubeio_cdf_write_data_c4

end module cubeio_cdf
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! We apply an unambiguous convention to convert Frequency
! to Velocity: the "radio" definition, under which the two scales are
! linear and simply proportional.
!
! Recall the Radio velocity convention:
!     F(v) = F_0 (1-v/c) = F_0 Doppler
! so   v/c = (F_0-F)/F_0
!     dV = -dF/F_0*c
!
! What matters is the frequency scale of the frequency axis, which
! is unambiguously translated to a velocity axis when and only when
! we have a defined rest frequency.
!
! In GILDAS/CLIC, that frequency scale is defined such that the source velocity
! is at the reference channel, and that, at the source velocity
! we are at the rest frequency which has been defined.
! Our convention is to have the frequencies in the frame
! of the source, not in the LSR frame like UVFITS and CASA.
! Both coincides if and only if Vsys = 0.
!
! A "MODIFY FREQUENCY" may change the reference channel, but the
! actual frequency of any channel will not change. The channel
! width in frequency will not change. Emission will appear at a
! different apparent velocity with such a new reference, and the
! velocity resolution will change according to the new frequency reference.
!
! On the contrary, a "MODIFY VELOCITY" will change the frame, resulting
! in a different frequency scale in the source frame.
!
! On "old" tables, we ALSO have the effective frequency given at the
! reference channel, %gil%val(1)
!   and the rest frequency
! and the LSR velocity also corresponds to the reference channel.
!
! Strictly speaking, we can compute a "Doppler" factor from these
! numbers (the frequency at the reference channel and the rest frequency)
! and scale the variable "c" to get the u and v in proper frame,
! since they represent delays in the specified frame.
!
! Velocity resolution and Frequency resolution should be rescaled
! accordingly ...
!
! Now, outside, the reference channel is kind of arbitrary...
!
! The intention is now to produce a frequency axis that is unambiguously
! defined in the current (source) frame. So for "old" tables, that frequency axis
! becomes f(i) = (i-ref)*inc + restfreq
! where inc has to be corrected for Doppler shift...
!
!    The observed frequency (to which u,v are referred) is
!        F_O(j) == (1 + Doppler - V/C) (F + Df (j-I))
!    with the same (u,v)
!
!    We thus link the old and new representations by
!     UV_FREQ = REST_FREQ * (1 + DOPPLER - VELOCITY/C)
!
! fits%gil%doppler = fits%gil%val(1) / fits%gil%restfreq &
!     & + fits%gil%voff / clight -1.d0
!
! For the spectral resolution, the rule is a little ambiguous
! as resampling in the LSR frame should have been done when
! creating the UV table, so it can be
!   EITHER  (if resampling have been done)
! df_0 = fits%gil%fres
!   OR      (if resampling has not been done)
! df_0 = fits%gil%inc(1) / (1+fits%gil%doppler-fits%gil%voff/clight)
! dv_0 = -df_0 / fits%gil%restfreq*clight
!
! The old version is identified by
!   code_version_uvt_freq
! The new one by
!   code_version_uvt_dopp
!
! For CASA, in TOUVT, the problem is that u,v are defined in the
! Observatory frame, while Frequencies are in the LSR frame, and the
! Doppler factor is not known ...
!
! To recompute it, one need something like compute_doppler in Class
! which calls do_object based on Time and Observatory knowledge
!
! I have created such a routine in ASTRO in uv_doppler.f90
! It computes (and optionally applies) the Doppler effect for each
! visibility. However, one needs to supply the Observatory...
!   (for astro_observatory)
! Once the correction has been made, the u,v refer to the LSR frame,
! and the code_version_uvt is changed to code_version_uvt_syst.
!
!
function gdf_uv_frequency(huv, dchan)
  use image_def
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! GIO Library
  !   Get observing frequency at given channel
  !-----------------------------------------------------------------------
  type(gildas), intent(in) :: huv   ! UV Header
  real(8), intent(in), optional :: dchan      ! Channel number (possibly fractional)
  real(8) :: gdf_uv_frequency       ! Intent(out)
  !
  real(8) :: freq, chan
  integer :: iaxis, ichan
  real(8), parameter :: clight_kms = 299792.458d0   ! [km/s] Light velocity
  !
  if (huv%gil%type_gdf.eq.code_gdf_uvt) then
    iaxis = 1
  else
    iaxis = 2
  endif
  !
  if (present(dchan)) then
    chan = dchan
  else
    chan = (huv%gil%nchan+1)*0.5d0
  endif
  !
  !! Pre-Doppler, was bugged (no reference channel) ?
  !!  freq = huv%gil%val(iaxis)+huv%gil%fres*(huv%gil%val(iaxis)/huv%gil%freq)*chan
  !! Print *,'Frequency pre-doppler ', freq, ' Ichan ',ichan
  if (huv%gil%nfreq.eq.0) then
    ! Normal, regularly sampled Frequency axis
    freq = huv%gil%freq + huv%gil%fres*(chan-huv%gil%ref(iaxis))
  else
    ! Random sampling, use nearest channel
    ichan = nint(chan)
    freq = huv%gil%freqs(ichan)
  endif
  freq = freq * (1.d0 + huv%gil%dopp - huv%gil%voff/clight_kms)
  gdf_uv_frequency = freq
end function gdf_uv_frequency
!
subroutine gdf_modify(h,velocity,frequency,unit,error)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  !---------------------------------------------------------------------
  ! @ public
  !   Modify the reference frequency and reference velocity of an input
  ! GDF header, and optionaly the axis unit (FREQUENCY or VELOCITY)
  !---------------------------------------------------------------------
  type(gildas),     intent(inout), target :: h          ! Header to be shifted
  real(kind=4),     intent(in)            :: velocity   ! New velocity
  real(kind=8),     intent(in)            :: frequency  ! New frequency
  character(len=*), intent(in), optional  :: unit       ! New axis unit
  logical,          intent(out)           :: error      ! Error flag
  ! Local
  real(8), parameter :: clight_kms=299792.458d0   
  !
  character(len=*), parameter :: rname='GIO_FRAME'
  integer(kind=4) :: faxi
  real(kind=8) :: iref,dopple,fshift
  real(kind=8), pointer :: ref(:),val(:),inc(:)
  character(len=12) :: newunit
  real(kind=8) :: freqori, beamfac
  !
  freqori = h%gil%freq
  !
  ! Can not assume the h%gil%ref(:) and other pointers are associated.
  ! Must use h%gil%convert. Use custom pointers for better readability
  ! of the code
  ref => h%gil%convert(1,:)
  val => h%gil%convert(2,:)
  inc => h%gil%convert(3,:)
  !
  if (h%gil%spec_words.le.0) then
    call gio_message(seve%e,rname,'Gildas Header has no spectroscopic section')
    error = .true.
    return
  endif
  if (h%gil%faxi.eq.0) then
    call gio_message(seve%e,rname,"Gildas Header has no Frequency/Velocity axis")
    error = .true.
    return
  endif
  faxi = h%gil%faxi
  !
  if (present(unit)) then
    if (h%char%code(faxi).ne.'FREQUENCY' .and. h%char%code(faxi).ne.'VELOCITY')  then
      call gio_message(seve%e,rname,'Can not change '//trim(h%char%code(faxi))//' spectroscopic axis to '//unit)
      error = .true.
    endif
    if (unit.ne.'FREQUENCY' .and. unit.ne.'VELOCITY')  then
      call gio_message(seve%e,rname,'Spectroscopic axis unit can only be changed to FREQUENCY or VELOCITY')
      error = .true.
    endif
    if (error)  return
    newunit = unit
  else
    newunit = h%char%code(faxi)
  endif
  !
  ! Find the channel where Current Rest Frequency and Velocity happen
  select case (h%char%code(faxi))
  case ('VELOCITY')
    iref = ref(faxi) + (h%gil%voff-val(faxi))/h%gil%vres
  case ('FREQUENCY')
    iref = ref(faxi) + (h%gil%freq-val(faxi))/h%gil%fres
  case ('UV-DATA','UV-RAW')  ! UV-RAW is a patch for old UV Tables...
    if (h%gil%version_uv.eq.code_version_uvt_freq) then
      !
      ! In this version, the Rest Frequency always matches the
      ! Observing frequency at the reference channel -
      iref = ref(faxi)
      dopple = val(faxi)/h%gil%freq
      !! Print *,'UVT_FREQ case ',h%gil%version_uv
    else
      ! Here also, the Rest Frequency must correspond to the
      ! reference channel, by convention.
      iref = ref(faxi)
      !
      ! If not, it means something wrong, as all our code assumes so.
      !
      if (val(faxi).ne.h%gil%freq) then
        call gio_message(seve%e,rname, &
        & "Rest frequency is not matching Frequency at reference channel")
        !
        ! Check if by any chance (i.e. any previous bug...) this mismatch 
        ! is due to a confusion between the LSRK and the Source frame
        !
        fshift = h%gil%freq*(1.d0-h%gil%voff/clight_kms)
        if (abs(fshift-val(faxi)).lt.1D-3) then
          call gio_message(seve%i,rname, &
          & ' probably due to confusion between LSRK and Source frame')
          call gio_message(seve%i,rname, &
          & ' Set (headername)%convert[2,1] = (header)%RESTFRE to correct the problem')
        endif
        error = .true. 
        return
      endif
      dopple = 1.d0
    endif
  case default
    call gio_message(seve%e,rname,"Frequency/Velocity axis is neither "//  &
      &   "FREQUENCY nor VELOCITY but "//h%char%code(faxi))
    error = .true.
    return
  end select
  !
  call modify_frame_velocity(velocity,iref,h%gil%freq,h%gil%fres,h%gil%voff,h%gil%vres,error)
  if (error)  return
  call modify_rest_frequency(frequency,iref,h%gil%freq,h%gil%fima,h%gil%fres,h%gil%vres,error)
  if (error)  return
  !
  call gdf_modify_resolution(freqori,h%gil%freq,h%gil%majo,h%gil%mino,error)
  if(error) return
  !
  h%char%code(faxi) = newunit
  select case (h%char%code(faxi))
  case ('VELOCITY')
    ref(faxi) = iref
    val(faxi) = h%gil%voff
    inc(faxi) = h%gil%vres
  case ('FREQUENCY')
    ref(faxi) = iref
    val(faxi) = h%gil%freq
    inc(faxi) = h%gil%fres
  case ('UV-DATA','UV-RAW')  ! UV-RAW is a patch for old UV Tables...
    if (h%gil%version_uv.eq.code_version_uvt_freq) then
      ref(faxi) = iref
      val(faxi) = h%gil%freq*dopple
      inc(faxi) = h%gil%fres
    else
      ref(faxi) = iref
      val(faxi) = h%gil%freq
      inc(faxi) = h%gil%fres
    endif
  end select
  !
end subroutine gdf_modify
!
subroutine gdf_uv_doppler(huv,version_uv)
  use image_def
  use gbl_message
  use gio_interfaces, only : gio_message
  use gio_uv
  !------------------------------------------------------------------
  ! @ public
  !   GIO
  !     Convert a UV table Frequency information to the appropriate
  !     shape. The Frequency information model of the data is
  !     in huv%gil%version_uv, and it is converted towards model
  !     described by version_uv, which can be
  !   code_version_uvt_freq
  !     Observing frequency is in the first axis - This is the
  !     historical behaviour.
  !   code_version_uvt_dopp
  !     Observing frequency is derived from a mean Doppler correction
  !     and the rest frequency in the Spectroscopy section.
  !   code_version_uvt_syst
  !     Observing frequency is derived from a time-dependent Doppler
  !     correction stored in the code_uvt_topo column,
  !     and the rest frequency in the Spectroscopy section
  !     It falls back to the code_version_uvt_dopp behaviour if
  !     no such column is found.
  !------------------------------------------------------------------
  type(gildas), intent(inout) :: huv
  integer, intent(in) :: version_uv
  !
  character(len=*), parameter :: rname='GDF_UV_DOPPLER'
  integer :: uaxi
  real(8), parameter :: clight_kms=299792.458d0
  character(len=80) :: mess
  !
  ! Test if something needs to be done
  if (huv%gil%version_uv.eq.version_uv) return
  !
  write(mess,'(A,A,F3.1,A,F3.1,A,F3.1,A,F3.1)')  'Header version:' &
    & ,' Image V',0.1*huv%gil%version_uv &
    & ,' System V',0.1*code_version_uvt_default  &
    & ,' Current V',0.1*code_version_uvt_current &
    & ,' Goal V',0.1*version_uv
  call gio_message(seve%d,rname,mess)
  !
  ! This was a debatable decision:
  ! If Doppler tracking was done, do not change anything
  ! if (huv%gil%version_uv .ge. code_version_uvt_syst) return
  !
  ! Programming note:
  ! I use here %gil%convert(2,) instead of %gil%val() to ensure
  ! that this part of the GIO library can be called prior to
  ! pointer initialization.
  !
  if (huv%gil%type_gdf.eq.code_gdf_tuv) then
    uaxi = 2
  else
    uaxi = 1
  endif
  !
  select case (huv%gil%version_uv)
  case (code_version_uvt_freq)
    ! Destination can be code_version_uvt_dopp or code_version_uvt_syst
    !
    ! Initial version has no Doppler information, compute it
    huv%gil%dopp = huv%gil%convert(2,uaxi)/huv%gil%freq - 1.d0 &
    &   + huv%gil%voff/clight_kms
    huv%gil%convert(2,uaxi) = huv%gil%freq
    huv%gil%vres = -huv%gil%fres / huv%gil%freq * clight_kms
    !
  case (code_version_uvt_dopp)
    ! Destination can be code_version_uvt_syst or code_version_uvt_freq
    !
    if (version_uv.eq.code_version_uvt_freq) then
      !
      ! Initial version has no Frequency information, compute it
      !
      ! First, set the reference channel so that it matches
      ! the Rest Frequency
      huv%gil%convert(1,uaxi) = huv%gil%convert(1,uaxi) + &
        & (huv%gil%freq-huv%gil%convert(2,uaxi))/huv%gil%fres
      !
      ! Compute apparent observing frequency from Current Doppler
      ! and Velocity
      huv%gil%convert(2,uaxi) = huv%gil%freq * &
        & (1.d0 + huv%gil%dopp - huv%gil%voff/clight_kms   )
    endif
  case (code_version_uvt_syst)
    ! Initial version may have a Doppler tracking column
    !
    ! Do nothing if there is a Doppler column...
    if (huv%gil%column_pointer(code_uvt_topo).ne.0) then
      call gio_message(seve%e,rname, &
      & 'Table has Doppler tracking column, no change of UV version')
      return
    endif
    !
    if (version_uv.eq.code_version_uvt_freq) then
      ! First, set the reference channel so that it matches
      ! the Rest Frequency
      huv%gil%convert(1,uaxi) = huv%gil%convert(1,uaxi) + &
        & (huv%gil%freq-huv%gil%convert(2,uaxi))/huv%gil%fres
      !
      ! Compute apparent observing frequency from Current Doppler
      ! and Velocity
      huv%gil%convert(2,uaxi) = huv%gil%freq * &
        & (1.d0 + huv%gil%dopp - huv%gil%voff/clight_kms   )
    endif
  end select
  !
  huv%gil%version_uv = version_uv
end subroutine gdf_uv_doppler
!
subroutine gdf_modify_resolution(old_freq,new_freq,majo,mino,error)
  !---------------------------------------------------------------------
  ! @ private
  ! Modify the resolution according to old and new frequencies
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: old_freq  !
  real(kind=8), intent(in)    :: new_freq  !
  real(kind=4), intent(inout) :: majo      !
  real(kind=4), intent(inout) :: mino      !
  logical,      intent(inout) :: error     !
  ! Local
  real(kind=8) :: factor
  !
  if (old_freq.eq.new_freq)  return
  !
  factor = old_freq/new_freq
  majo = majo*factor
  mino = mino*factor
  !
end subroutine gdf_modify_resolution

module cfitsio_bintable
  use cfitsio_interfaces
  use cfitsio_messaging
  use cfitsio_status
  !---------------------------------------------------------------------
  ! Routines to provide enhanced API for CFITSIO binary tables
  !---------------------------------------------------------------------
  !
  public :: cfitsio_bintable_read_column_r4
  private
  !
contains
  !
  subroutine cfitsio_bintable_read_column_r4(caller,iunit,colnum,frow,felem,nelem,array,error)
    use, intrinsic :: iso_c_binding, only : c_float,c_int,c_long_long,c_ptr
    !-------------------------------------------------------------------
    ! Custom overlay to CFITSIO routine fits_read_col_flt (ffgcve)
    ! with I*8 arguments.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: caller    ! Name of calling procedure
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=8),  intent(in)    :: frow      ! First row to read
    integer(kind=8),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=8),  intent(in)    :: nelem     ! Number of elements to read
    real(kind=4),     intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,          intent(inout) :: error     ! Logical error flag
    ! Local
    type(c_ptr) :: fptr
    integer(c_int) :: colnum_c,anynul_c,status_c
    integer(c_long_long) :: felem_c,frow_c,nelem_c
    real(c_float) :: nulval_c
    character(len=message_length) :: mess
    !
    call cfitsio_file_cptr(iunit,fptr,error)
    if (error)  return
    !
    colnum_c = int(colnum,kind=c_int)
    frow_c = int(frow,kind=c_long_long)
    felem_c = int(felem,kind=c_long_long)
    nelem_c = int(nelem,kind=c_long_long)
    nulval_c = -1.0_c_float
    anynul_c = 0_c_int
    status_c = int(0_c_int)
    !
    status_c = fits_read_col_flt(fptr,colnum_c,frow_c,felem_c,nelem_c,nulval_c,  &
                                 array,anynul_c,status_c)
    !
    if (anynul_c.ne.0_c_int .or. status_c.gt.0) then
      call cfitsio_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,I0)')  &
        'Error while reading column #',colnum,', row #',frow
      call cfitsio_message(seve%e,caller,mess)
      if (anynul_c.ne.0_c_int) then
        call cfitsio_message(seve%e,caller,'Some null values found')
      else
        call cfitsio_errormsg(status_c)
        call ftrprt('STDOUT',status_c)  ! Much verbose for debugging
      endif
      error = .true.
      return
    endif
  end subroutine cfitsio_bintable_read_column_r4
end module cfitsio_bintable

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_chunkset_types
  use gildas_def
  use gkernel_interfaces
  use mrtcal_chunk_types
  use mrtcal_messaging
  !
  private
  public :: chunkset_t
  !
  type chunkset_t
    integer(kind=4)        :: n   ! Number of chunks in this set
    type(chunk_t), pointer :: chunks(:) => null() ! [ n ] The chunks
    integer(kind=4)        :: allocated=code_pointer_null ! Allocated or just associated?
  contains
    procedure, public :: reallocate  => reallocate_chunkset
    procedure, public :: reassociate => reassociate_chunkset
    procedure, public :: free        => free_chunkset
    procedure, public :: nullify     => nullify_chunkset
    procedure, public :: clone       => clone_chunkset
    procedure, public :: init_data   => chunkset_init_data
    procedure, public :: consistency => chunkset_consistency
  end type chunkset_t
  !
contains
  !
  subroutine reallocate_chunkset(chunkset,n,error)
    !-------------------------------------------------------------------
    ! (Re)allocate a chunkset so that it can store n chunks.
    !
    ! Nothing is done for the chunks in the chunkset. The caller is free
    ! to allocate them or associate them depending on its need.
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    integer(kind=4),   intent(in)    :: n
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='REALLOCATE>CHUNKSET'
    logical :: alloc
    character(len=message_length) :: mess
    integer(kind=4) :: ier
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (n.le.0) then
      write(mess,'(A,I0,A)')  'Array size can not be zero nor negative (got ',n,')'
      call mrtcal_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    alloc = .true.
    if (chunkset%allocated.eq.code_pointer_associated) then
      call mrtcal_message(seve%e,rname,  &
        'Internal error: attempt to allocate an associated pointer')
      error = .true.
      return
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
       if (.not.associated(chunkset%chunks)) then
         ! How come!?!? chunkset has code 'allocated' but its pointer is
         ! not associated? Something wrong, need fix.
         call mrtcal_message(seve%e,rname,  &
           'Internal error: CHUNKSET is expected to be associated but is not')
         error = .true.
         return
       endif
       if (chunkset%n.eq.n) then
          write(mess,'(a,i0)')  &
            'CHUNKSET already associated at the right size: ',n
          call mrtcal_message(seve%d,rname,mess)
          alloc = .false.
       else
          call mrtcal_message(seve%d,rname,  &
            'CHUNKSET pointer already associated but with a different size => Freeing it first')
          call chunkset%free(error)
          if (error)  return
       endif
    endif
    !
    if (alloc) then
       allocate(chunkset%chunks(n),stat=ier)
       if (failed_allocate(rname,'CHUNKSET',ier,error)) then
          call chunkset%free(error)
          return
       endif
       chunkset%allocated = code_pointer_allocated
       write(mess,'(a,i0)') 'Allocated CHUNKSET of size: ',n
       call mrtcal_message(seve%d,rname,mess)
    endif
    !
    ! Allocation success => Initialize
    chunkset%n = n
  end subroutine reallocate_chunkset
  !
  subroutine reassociate_chunkset(ou,in,error,ichunk)
    !---------------------------------------------------------------------
    !  Associate a chunkset onto another one.
    !  If 'ichunk' is present, associate only onto this single element
    !  (pointer to subset).
    !---------------------------------------------------------------------
    class(chunkset_t),         intent(inout) :: ou
    type(chunkset_t),          intent(in)    :: in
    logical,                   intent(inout) :: error
    integer(kind=4), optional, intent(in)    :: ichunk
    ! Local
    character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET'
    integer(kind=4) :: first,last
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (present(ichunk)) then
      if (ichunk.lt.1 .or. ichunk.gt.in%n) then
        call mrtcal_message(seve%e,rname,'Invalid chunk number')
        error = .true.
        return
      endif
      first = ichunk
      last = first
    else
      first = 1
      last = in%n
    endif
    !
    if (ou%allocated.eq.code_pointer_allocated) then
      call ou%free(error)
      if (error)  return
    endif
    !
    ou%n = last-first+1
    ou%chunks => in%chunks(first:last)
    ou%allocated = code_pointer_associated
  end subroutine reassociate_chunkset
  !
  subroutine free_chunkset(chunkset,error)
    !-------------------------------------------------------------------
    ! Free a chunkset
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FREE>CHUNKSET'
    integer(kind=4) :: ichunk
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (chunkset%allocated.eq.code_pointer_associated) then
      call chunkset%nullify(error)
      if (error)  return
      !
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
      do ichunk=1,ubound(chunkset%chunks,1)
        call chunkset%chunks(ichunk)%free(error)
        ! if (error) continue
      enddo ! ichunk
      chunkset%n = 0
      if (associated(chunkset%chunks))  deallocate(chunkset%chunks)
      chunkset%allocated = code_pointer_null
    endif
  end subroutine free_chunkset
  !
  subroutine nullify_chunkset(chunkset,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='NULLIFY>CHUNKSET'
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    if (chunkset%allocated.eq.code_pointer_associated) then
      chunkset%n = 0
      chunkset%chunks => null()
      chunkset%allocated = code_pointer_null
      !
    elseif (chunkset%allocated.eq.code_pointer_allocated) then
      call mrtcal_message(seve%e,rname,'Attempt to nullify an allocated pointer')
      error = .true.
      return
    endif
  end subroutine nullify_chunkset
  !
  subroutine chunkset_consistency(c1,caller,c2,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(chunkset_t), intent(in)    :: c1
    character(len=*),  intent(in)    :: caller  ! Calling routine name
    type(chunkset_t),  intent(in)    :: c2
    logical,           intent(inout) :: error
    ! Local
    integer(kind=4) :: ichunk
    character(len=message_length) :: mess
    !
    if (c1%n.ne.c2%n) then
      write(mess,'(A,I0,1X,I0)')  &
        'Inconsistent number of chunks per set: ',c1%n,c2%n
      call mrtcal_message(seve%e,caller,mess)
      error = .true.
      return
    endif
    !
    do ichunk=1,c1%n
      if (c1%chunks(ichunk)%ndata.ne.c2%chunks(ichunk)%ndata) then
        write(mess,'(A,I0,1X,I0)')  'Inconsistent number of channels: ', &
          c1%chunks(ichunk)%ndata,c2%chunks(ichunk)%ndata
        call mrtcal_message(seve%e,caller,mess)
        error = .true.
        return
      endif
    enddo
    !
  end subroutine chunkset_consistency
  !
  subroutine chunkset_init_data(chunkset,v,w,c,error)
    !-------------------------------------------------------------------
    ! Initialize the chunk data from the input values
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: chunkset
    real(kind=4),      intent(in)    :: v      ! Data value (duplicated to all channels)
    real(kind=4),      intent(in)    :: w      ! Weight (duplicated to all channels)
    real(kind=4),      intent(in)    :: c      ! Continuum value
    logical,           intent(inout) :: error
    ! Local
    integer(kind=4) :: ichunk
    character(len=*), parameter :: rname='CHUNKSET>INIT>DATA'
    !
    call mrtcal_message(seve%t,rname,'Welcome')
    !
    do ichunk=1,chunkset%n
      call chunkset%chunks(ichunk)%init_data(v,w,c,error)
      if (error) return
    enddo ! ichunk
  end subroutine chunkset_init_data
  !
  subroutine clone_chunkset(ou,in,doheader,error)
    !-------------------------------------------------------------------
    !  Clone a chunkset structure.
    !
    !  The chunks in the chunkset are ALLOCATED so that the full structure
    ! clones exactly the input one.
    !  Nothing is done for the data and headers (not copied, not
    ! initialized e.g. to 0).
    !-------------------------------------------------------------------
    class(chunkset_t), intent(inout) :: ou        !
    type(chunkset_t),  intent(in)    :: in        !
    logical,           intent(in)    :: doheader  ! Also clone the headers?
    logical,           intent(inout) :: error     !
    ! Local
    integer(kind=4) :: ichunk
    !
    call ou%reallocate(in%n,error)
    if (error) return
    !
    do ichunk=1,in%n
      call ou%chunks(ichunk)%clone(in%chunks(ichunk),doheader,error)
      if (error) return
    enddo
  end subroutine clone_chunkset
end module mrtcal_chunkset_types
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_colors
  use cubetools_structure
  use cubetools_consistency_colors
  use cubeset_messaging
  !
  public :: colorcomm
  private
  !
  type :: colors_comm_t
     type(option_t), pointer :: comm
     type(color_opt_t)       :: inconsistent
     type(color_opt_t)       :: consistent
     type(color_opt_t)       :: notchecked
     type(option_t), pointer :: defaults
   contains
     procedure, public  :: register => cubeset_colors_register
     procedure, public  :: parse    => cubeset_colors_parse
     procedure, public  :: main     => cubeset_colors_main
  end type colors_comm_t
  type(colors_comm_t) :: colorcomm
  !
  type :: colors_user_t
     logical :: list
     logical :: dodefaults
  end type colors_user_t
  !
contains
  !
  subroutine cubeset_colors_command(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    ! COLORS Mode
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(colors_user_t) :: user
    character(len=*), parameter :: rname='COLORS>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call colorcomm%parse(line,user,error)
    if (error) return
    call colorcomm%main(user,error)
    if (error) return
  end subroutine cubeset_colors_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_colors_register(colorcomm,error)
    use cubetools_parameters
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(colors_comm_t), intent(inout) :: colorcomm
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='COLORS>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'COLORS','[topic color]',&
         'Set colors to be used in consistency prints',&
         'List the current consistency colors when called without arguments.&
         & Use /DEFAULT to reset color settings. When /DEFAULT is&
         & combined with other keys on the same command line, reset is&
         & applied first.',&
         cubeset_colors_command,&
         colorcomm%comm,&
         error)
    if (error) return
    !
    call colorcomm%inconsistent%register('INCONSISTENT',&
         'Set color for inconsistent fields',error)
    if (error) return
    call colorcomm%consistent%register('CONSISTENT',&
         'Set color for consistent fields',error)
    if (error) return
    call colorcomm%notchecked%register('NOTCHECKED',&
         'Set color for fields that are not checked',error)
    if (error) return
    !
    call cubetools_register_option(&
         'DEFAULT','',&
         'Reset color settings',&
         'Reset color settings before applying other keys from the same&
         & command line.',&
         colorcomm%defaults,&
         error)
    if (error) return
  end subroutine cubeset_colors_register
  !
  subroutine cubeset_colors_parse(colorcomm,line,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(colors_comm_t), intent(inout) :: colorcomm
    character(len=*),     intent(in)    :: line
    type(colors_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='COLORS>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    user%list = cubetools_nopt().eq.0
    !
    if (user%list) then
       ! nothing to do
    else
       call colorcomm%inconsistent%parse(line,error)
       if (error) return
       call colorcomm%consistent%parse(line,error)
       if (error) return
       call colorcomm%notchecked%parse(line,error)
       if (error) return
       call colorcomm%defaults%present(line,user%dodefaults,error)
       if (error) return
    endif
    !
  end subroutine cubeset_colors_parse
  !
  subroutine cubeset_colors_main(colorcomm,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(colors_comm_t), intent(inout) :: colorcomm
    type(colors_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='COLORS>MAIN'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (user%list) then
       call colors%list(error)
       if (error) return
    else
       if (user%dodefaults) then
          call colors%reset_defaults(error)
          if (error) return
       endif
       !
       if (colorcomm%inconsistent%do) then
          call colors%set_inconsistent(colorcomm%inconsistent%icolor,error)
          if (error) return
       endif
       if (colorcomm%consistent%do) then
          call colors%set_consistent(colorcomm%consistent%icolor,error)
          if (error) return
       endif
       if (colorcomm%notchecked%do) then
          call colors%set_notchecked(colorcomm%notchecked%icolor,error)
          if (error) return
       endif
    endif
  end subroutine cubeset_colors_main
end module cubeset_colors
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program uv_timebase
  use gkernel_interfaces
!
! Re-order a UV table according to a Time-Baseline
! Sequence, in order to create an ensemble of
! values to be plotted per baseline as function of time
! Values = (Real, Imag) == (Amp, Phase)
!
  character*256 nami,namo
  logical error
!
  call gildas_open
  call gildas_char('INPUT$',nami)
  call gildas_char('OUTPUT$',namo)
  call gildas_close
  call sub_timebase(nami,namo,error)
  call gagout('I-UV_TIMEBASE,  Successful completion')
end program uv_timebase
!<ff>
subroutine sub_timebase(nami,namo,error)
  use image_def
  use gkernel_interfaces
  character*(*) nami,namo
  logical error
!
  type (gildas) :: hin,hout
  real, allocatable :: din(:,:),dout(:,:,:)
  integer nt,nv,nbas,ntime,ier
  real*8, allocatable :: altimes(:), intimes(:)
  character*60 chain
!
! Read Header of a sorted, UV table
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  allocate (din(hin%gil%dim(1),hin%gil%dim(2)),stat=ier)
  call gdf_read_data (hin,din,error)
  if (error) return
  nt = hin%gil%dim(1)
  nv = hin%gil%dim(2)
!
! Define the problem size
  allocate (intimes(nv),altimes(nv),stat=ier)
  call analyze_uvtable(din,nt,nv,intimes,altimes,nbas,ntime)
!
! Define the image header
  call gdf_copy_header (hin,hout,error)
  call sic_parsef (namo,hout%file,' ','.uvp')
  hout%gil%ndim = 3
  hout%gil%dim(1) = ntime
  hout%gil%dim(2) = nbas
  hout%gil%dim(3) = 4 ! real, imag, weight, time
  hout%gil%convert(:,1:3) = 1.d0
#if defined(gildas_v1)
  hout%gil%extr = 0
#else
  hout%gil%extr_words = 0
#endif

  allocate(dout(ntime,nbas,4),stat=ier)
!
! Load the sorted data
  call load_uvtable (din,nt,nv,intimes,altimes,nbas,ntime,dout)
!
  call gdf_write_image(hout,dout,error)
  if (gildas_error(hout,'timebase',error)) call sysexi(fatale)
  deallocate (intimes,altimes)
  deallocate (dout)
  call gagout('I-TIMEBASE,  Successful completion')
  return
end subroutine sub_timebase
!
subroutine analyze_uvtable(din,nt,nv,intimes,altimes,nbas,ntime)
  use gkernel_interfaces
  integer nv,nt,nbas,ntime
  real din(nt,nv)
  real*8 intimes(nv), altimes(nv)
  logical error
!
  integer, allocatable :: it(:)
  integer nd,iv,ii
  logical ok
  character*60 chain
!
  error = .false.
!
! Scan how many dates
  nd = 1
  altimes(nd) = din(4,1)
  do iv=1,nv
     intimes(iv) = 0
     do ii=1,nd
        if (din(4,iv).eq.altimes(ii)) then
           intimes(iv) = ii
        endif
     enddo
     if (intimes(iv).eq.0) then
        nd = nd+1
        altimes(nd) = din(4,iv)
        intimes(iv) = nd
     endif
  enddo
  write(chain,*) 'Found ',nd,' dates '
  call gagout(chain(2:))
!
! Time compacted value
  do iv=1,nv
     intimes(iv) = intimes(iv)-1.d0+din(5,iv)/86400d0
  enddo
!
! Find out how many times...
  altimes = 0.0
  altimes(1) = intimes(1)
  ntime = 1
  do iv=2,nv
     ok = .false.
     ii = 1
     do while (.not.ok.and.ii.le.ntime)
        if (intimes(iv).eq.altimes(ii)) then
           ok = .true.
        else
           ii = ii+1
        endif
     enddo
     if (.not.ok) then
        ntime = ntime+1
        altimes(ntime) = intimes(iv)
     endif
  enddo
!
  write(chain,*) 'I-UV,  Found ',ntime,' times '
  call gagout(chain(2:))
!
! Pending nightmare: are the times sorted ?
! Answer: of course not, let us do it now...
  allocate(it(nv))
  do ii=1,ntime
     it(ii) = ii
  enddo
  call gr8_trie(altimes,it,ntime,error)
!
! Find out how many antennas
  nd = 1
  it(nd) = din(6,1)
  do iv=1,nv
     ok = .false.
     do ii=1,nd
        if (din(6,iv).eq.it(ii)) then
           ok = .true.
        endif
     enddo
     if (.not.ok) then
        nd = nd+1
        it(nd) = din(6,iv)
     endif
  enddo
  nd = nd+1  ! Add the first antenna
  deallocate(it)
  write(chain,*) 'I-UV,  Found ',nd,' antennas '
  call gagout(chain(2:))
  nbas = nd*(nd-1)/2
  write(chain,*) 'I-UV,  Found ',nbas,' baselines'
  call gagout(chain(2:))
end subroutine analyze_uvtable
!
!<FF>
subroutine load_uvtable (din,nt,nv,intimes,altimes,nbas,ntime,dout)
  integer nv,nt,nbas,ntime
  real din(nt,nv)
  real*8 intimes(nv)
  real*8 altimes(ntime)
  real dout(ntime,nbas,4)
!
  integer iv,itime,ibas
!
! Assume things are already time-baseline sorted
! So, just scan and put at the appropriate times
!
  dout = 0.0 ! Reset all to Zero, specially the weights
!
  itime = 1
  ibas = 1
  do iv=1,nv
!
! Check next time match
     do while (altimes(itime).ne.intimes(iv))
        if (itime.eq.ntime) then
           ibas = ibas+1
           itime = 0
        endif
        itime = itime+1
     enddo
!
! Put in place
     dout(itime,ibas,1) = din(8,iv)      ! Real
     dout(itime,ibas,2) = din(9,iv)      ! Imag
     dout(itime,ibas,3) = din(10,iv)     ! Weight
     dout(itime,ibas,4) = altimes(itime) ! Time
  enddo
end subroutine load_uvtable

subroutine dpoinl(xv,a,deriv)
  !---------------------------------------------------------------------
  ! POINT
  !	Compute the derivatives of the pointing function
  !	Dimensionned for MVAR or KVAR
  ! V2.0
  !	Changed sign of excentricity corrections
  !---------------------------------------------------------------------
  ! Global
  include 'size.inc'
  !
  real*8 :: xv(3)                   !
  real*8 :: a(mvar)                 !
  real*8 :: deriv(mvar)             !
  ! Local
  real*8 :: az,el,cosel,sinel,cosaz,sinaz
  !
  az=xv(1)
  el=xv(2)
  cosel=cos(el)
  sinel=sin(el)
  cosaz=cos(az)
  sinaz=sin(az)
  if (xv(3).eq.0) then
    deriv( 1)=-cosel
    deriv( 2)= 0
    deriv( 3)=-1.0/sqrt(max(1d-37,1.0d0-(a(3)/cosel)**2))
    deriv( 4)= -cosaz*sinel
    deriv( 5)= sinaz*sinel
    deriv( 6)= sinel
    deriv( 7)= 0
    deriv( 8)= 0
    deriv( 9)= 0
    deriv(10)= 0
    deriv(11)= -sinaz*cosel
    deriv(12)= -cosaz*cosel
    if (kvar.le.12) return
    deriv(13)= sin(2.d0*az)*cosel
    deriv(14)= cos(2.d0*az)*cosel
    deriv(15)= 0
    deriv(16)= 0
  else
    deriv( 1)= 0
    deriv( 2)=-1
    deriv( 3)= -sinel*a(3)/   &
     &      sqrt(max(1d-30,1.0d0-sinel**2/(1.0d0-a(3)**2)))/   &
     &      sqrt(max(1d-30,(1.0d0-a(3)**2)**3))
    deriv( 4)=sinaz
    deriv( 5)=+cosaz
    deriv( 6)= 0
    deriv( 7)= 1.d0/tan(el)
    deriv( 8)= deriv(7)**3
    deriv( 9)= -sinel
    deriv(10)= -cosel
    deriv(11)= 0
    deriv(12)= 0
    if (kvar.le.12) return
    deriv(13)= 0
    deriv(14)= 0
    deriv(15)= sin(2.d0*el)
    deriv(16)= cos(2.d0*el)
  endif
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_sdi
  use gbl_message
  !
  public :: sdi_comm
  private
  !
contains
  !
  subroutine sdi_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_tool, only: sub_clean,clean_data
    use clean_types, only: beam_unit_conversion
    use uvmap_buffers
    use clean_buffers, only: clean_user,clean_prog
    !----------------------------------------------------------------------
    ! Implementation of Steer Dewdney Ito Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: iv,na,m_iter
    character(len=8) :: name,argum,voc1(2)
    data voc1/'CLEAN','RESIDUAL'/
    !
    ! Save default number of components
    m_iter = clean_user%m_iter
    clean_user%m_iter = dirty%head%gil%dim(1) * dirty%head%gil%dim(2)
    !
    ! Data checkup: method must be defined first ?
    clean_user%method = 'SDI'
    call clean_data (error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    clean_prog%pflux = .false.
    clean_prog%pcycle = sic_present(2,0)
    clean_prog%qcycle = sic_present(3,0)
    if (clean_prog%pcycle) then
       argum = 'RESIDUAL'
       call sic_ke (line,2,1,argum,na,.false.,error)
       if (error) return
       call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
       if (error) return
       clean_prog%pclean = iv.eq.1
    else
       clean_prog%pclean = .false.
    endif
    call sub_clean(line,error)
    ! Restore default number of components
    clean_user%m_iter = m_iter
  end subroutine sdi_comm
end module clean_sdi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine rgen(set,obs,error)
  use classcore_interfaces, except_this=>rgen
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -2 General
  !  Caution: part of the GEN section is actually copied from the
  ! index, and not read here
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_gen_id,error)
end subroutine rgen
!
subroutine rpos(set,obs,error)
  use classcore_interfaces, except_this=>rpos
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -3 Position
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_pos_id,error)
end subroutine rpos
!
subroutine rspec(set,obs,error)
  use classcore_interfaces, except_this=>rspec
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -4 Spectroscopy
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_spe_id,error)
  !
  ! Factorize here some duplicates of the spectroscopic section. It
  ! is unclear where this action should be factorized. Here is good
  ! for spectra from disk, subroutine 'abscissa' is good for a memory
  ! only spectrum, but 'abscissa' is not suited when the other data
  ! arrays are not needed (waste of time)...
  obs%cbad = obs%head%spe%bad
  obs%cnchan = obs%head%spe%nchan
  !
end subroutine rspec
!
subroutine rres(set,obs,error)
  use classcore_interfaces, except_this=>rres
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -21 Resolution description
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_res_id,error)
end subroutine rres
!
subroutine rbase(set,obs,error)
  use classcore_interfaces, except_this=>rbase
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -5 Baseline
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_bas_id,error)
end subroutine rbase
!
subroutine rorig(set,obs,error)
  use classcore_interfaces, except_this=>rorig
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -6 Origin
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_his_id,error)
end subroutine rorig
!
subroutine rplot(set,obs,error)
  use classcore_interfaces, except_this=>rplot
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -7 Plotting parameters
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_plo_id,error)
end subroutine rplot
!
subroutine rswi(set,obs,error)
  use classcore_interfaces, except_this=>rswi
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -8 Switching description
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_swi_id,error)
end subroutine rswi
!
subroutine rgaus(set,obs,error)
  use classcore_interfaces, except_this=>rgaus
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -9 Gauss fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_gau_id,error)
end subroutine rgaus
!
subroutine rcont(set,obs,error)
  use classcore_interfaces, except_this=>rcont
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -10 Drift continuum
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_dri_id,error)
  !
  obs%cnchan = obs%head%dri%npoin
  obs%cbad = obs%head%dri%bad
end subroutine rcont
!
subroutine rbeam(set,obs,error)
  use classcore_interfaces, except_this=>rbeam
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -11 Beam Switch
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_bea_id,error)
end subroutine rbeam
!
subroutine rshel(set,obs,error)
  use classcore_interfaces, except_this=>rshel
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -12 SHELL fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_she_id,error)
end subroutine rshel
!
subroutine rnh3(set,obs,error)
  use classcore_interfaces, except_this=>rnh3
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -13 NH3 fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_hfs_id,error)
end subroutine rnh3
!
subroutine rabs(set,obs,error)
  use classcore_interfaces, except_this=>rabs
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -18 ABS fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_abs_id,error)
end subroutine rabs
!
subroutine rcal(set,obs,error)
  use classcore_interfaces, except_this=>rcal
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -14 Calibration
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_cal_id,error)
end subroutine rcal
!
subroutine rpoint(set,obs,error)
  use classcore_interfaces, except_this=>rpoint
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -15 Pointing fit
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_poi_id,error)
end subroutine rpoint
!
subroutine rsky(set,obs,error)
  use classcore_interfaces, except_this=>rsky
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -16 Skydip
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_sky_id,error)
end subroutine rsky
!
subroutine rxcoo(set,obs,error)
  use classcore_interfaces, except_this=>rxcoo
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -17 X coordinates (irregularly spaced data).
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec_xcoo(set,obs,error)
end subroutine rxcoo
!
subroutine rdescr(set,obs,error)
  use classcore_interfaces, except_this=>rdescr
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -30 Data Section descriptor
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_desc_id,error)
end subroutine rdescr
!
subroutine rcom(set,obs,error)
  use classcore_interfaces, except_this=>rcom
  use class_types
  !-------------------------------------------------------------------
  ! @ private
  ! -1  Comment section
  !-------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_com_id,error)
end subroutine rcom
!
subroutine ruser(set,obs,error)
  use classcore_interfaces, except_this=>ruser
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Write the USER defined section description
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_user_id,error)
end subroutine ruser
!
subroutine rassoc(set,obs,error)
  use classcore_interfaces, except_this=>rassoc
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! -19 ASSOCiated arrays section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_assoc_id,error)
end subroutine rassoc
!
subroutine rherschel(set,obs,error)
  use classcore_interfaces, except_this=>rherschel
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! HERSCHEL section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(inout) :: obs
  logical,             intent(inout) :: error
  call crsec(set,obs,class_sec_her_id,error)
end subroutine rherschel
!
subroutine rdata(set,obs,nv4,values,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rdata
  use class_types
  use class_common
  !----------------------------------------------------------------------
  ! @ private
  ! Read the whole data section
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set          !
  type(observation),   intent(in)    :: obs          ! Observation
  integer(kind=4),     intent(inout) :: nv4          ! Number of data words
  real(kind=4),        intent(out)   :: values(nv4)  ! Data array
  logical,             intent(inout) :: error        !
  ! Local
  integer(kind=4) :: l1,i,k
  integer(kind=data_length) :: first,last,nv8
  !
  error = .false.
  !
  if (obs%head%presec(class_sec_desc_id) ) then
     ! OTF data (presumably)
     nv4 = min(nv4,obs%desc%ldata)
     nv8 = nv4
     call classic_entry_data_read(values,nv8,obs%desc,ibufobs,error)
     if (error)  return
     nv4 = nv8
     if (obs%head%des%ldump.gt.nv4 .or. obs%head%des%ndump*obs%head%des%ldump.gt.nv4) then
        call class_message(seve%f,'RDATA','Inconsistent data section')
        write(6,*) 'r_ndump, r_ldump, r_ldpar, nv'
        write(6,*)  obs%head%des%ndump, obs%head%des%ldump, obs%head%des%ldpar, nv4
        error = .true.
        return
     endif
     l1 = obs%head%des%ldump-obs%head%des%ldpar
     k = 1
     do i=1,obs%head%des%ndump
        call convert_dh (values(k),obs%head%des%ldpar,filein%conv)
        k = k+obs%head%des%ldpar
        call filein%conv%read%r4(values(k),values(k),l1)
        k = k+l1
     enddo
     !
  else
    ! Normal data
    first = 1_8
    last = nv4
    nv8 = nv4
    call rdata_sub(set,obs,first,last,nv8,values,error)
    nv4 = nv8
    if (error)  return
  endif
  !
end subroutine rdata
!
subroutine rdata_sub(set,obs,first,last,nv,values,error)
  use classic_api
  use classcore_interfaces, except_this=>rdata_sub
  use class_common
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Read a subset of the data section.
  ! No support for OTF data
  !----------------------------------------------------------------------
  type(class_setup_t),       intent(in)    :: set         !
  type(observation),         intent(in)    :: obs         ! Observation
  integer(kind=data_length), intent(in)    :: first       ! First data word to read
  integer(kind=data_length), intent(in)    :: last        ! Last data word to read
  integer(kind=data_length), intent(inout) :: nv          ! Input and actual number of values read
  real(kind=4),              intent(out)   :: values(nv)  ! Data array
  logical,                   intent(inout) :: error       ! Logical error flag
  !
  error = .false.
  !
  if (filein_isvlm) then
    call rdata_sub_vlm(obs%desc%xnum,first,last,nv,values,error)
  else
    call rdata_sub_classic(obs,first,last,nv,values,error)
  endif
  if (error)  return
  !
  ! Chase NaN
  if (set%chase_nan)  &
    call modify_blanking(values,nv,obs_bad(obs%head),obs_bad(obs%head))
  !
end subroutine rdata_sub
!
subroutine rdata_sub_classic(obs,first,last,nv,values,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>rdata_sub_classic
  use class_common
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Read a (subset of) the data array from an entry of a Classic file
  !---------------------------------------------------------------------
  type(observation),         intent(in)      :: obs         ! Observation
  integer(kind=data_length), intent(in)      :: first       ! First data word to read
  integer(kind=data_length), intent(in)      :: last        ! Last data word to read
  integer(kind=data_length), intent(inout)   :: nv          ! Input and actual number of values read
  real(kind=4),              intent(out)     :: values(nv)  ! Data array
  logical,                   intent(inout)   :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='RDATA'
  integer(kind=4) :: nv4
  !
  if (obs%head%presec(class_sec_desc_id)) then
    ! OTF data (presumably)
    call class_message(seve%e,rname,'Can not read subset of old OTF data section')
    error = .true.
    return
  endif
  !
  ! Read 'data' block
  call classic_entry_data_readsub(values,nv,first,last,obs%desc,ibufobs,error)
  if (error)  return
  nv4 = nv
  !
  if (filein%conv%code.ne.0) then
    ! Non-native, conversion needed.
    call filein%conv%read%r4(values,values,nv4)
  endif
  !
end subroutine rdata_sub_classic
!
subroutine convert_dh (iwin,nw,conv)
  use gbl_convert
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! @ private
  !  Convert data header IWIN using conversion code CONVE, assuming NW
  ! is the length of the data header.
  !---------------------------------------------------------------------
  real(kind=4),             intent(inout) :: iwin(*)  ! Array containing data header to be converted
  integer(kind=4),          intent(in)    :: nw       ! Size of IWIN
  type(classic_fileconv_t), intent(in)    :: conv     ! Conversion structure
  ! Local
  !
  if (conv%code.eq.0) return
  !
  ! Non native, conversion needed. NB: inplace modification is not
  ! Fortran standard and might not work! Should use a temporary buffer.
  ! As for now, everything is in R4 format.
  call conv%read%r4(iwin(1),iwin(1),nw)
  !
end subroutine convert_dh

subroutine clic_mark(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC	Command CLIC\MARK f1 f2 ... [/ANTENNA] [/BASELINE] [/RESET]
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_flags.inc'
  ! Local
  integer :: i, j, ak(mnant), bk(mnbas)
  logical :: sa(2*mbands,mnant), sb(2*mbands,mnbas)
  logical :: reset
  character(len=1024) :: out
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (sic_narg(0).eq.0) then
    call list_flags(mnant,mnbas,ant_kill,bas_kill,san_kill,sba_kill,out)
    call message(6,1,'CLIC_MARK','Marked '//out(1:lenc(out)))
    return
  endif
  call get_flags(line,1,1,2,3,-1,-1,ak,bk,sa,sb,reset,error)
  if (error) return
  do i=1, mnant
    if (ak(i).ne.0) then
      if (reset) then
        ant_kill(i) = iand(ant_kill(i),not(ak(i)))
      else
        ant_kill(i) = ior(ant_kill(i),ak(i))
      endif
    endif
    do j=1, 2*mbands
      if (sa(j,i)) then
        if (reset) then
          san_kill(j,i) = .false.
        else
          san_kill(j,i) = .true.
        endif
      endif
    enddo
  enddo
  do i=1, mnbas
    if (bk(i).ne.0) then
      if (reset) then
        bas_kill(i) = iand(bas_kill(i),not(bk(i)))
      else
        bas_kill(i) = ior(bas_kill(i),bk(i))
      endif
    endif
    do j=1, 2*mbands
      if (sb(j,i)) then
        if (reset) then
          sba_kill(j,i) = .true.
        else
          sba_kill(j,i) = .false.
        endif
      endif
    enddo
  enddo
  call list_flags(mnant,mnbas,ant_kill,bas_kill,san_kill,sba_kill,out)
  call message(6,1,'CLIC_MARK','Marked '//out(1:lenc(out)))
  return
end subroutine clic_mark
!
subroutine list_flags(nant,nbas,afl,bfl,saf,sbf,out)
  use gkernel_interfaces
  use gildas_def
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_flags.inc'
  integer :: nant                   !
  integer :: nbas                   !
  integer :: afl(nant)              !
  integer :: bfl(nbas)              !
  logical :: saf(2*mbands,nant)              !
  logical :: sbf(2*mbands,nbas)              !
  character(len=*) :: out           !
  ! Local
  integer :: k, n, i, j, l, nout, lout
  logical :: done
  !------------------------------------------------------------------------
  ! Code:
  lout = len(out)
  nout = 0
  out = ' '
  do i=1, nant
    if (afl(i).ne.0) then
      if (nout.gt.0) then
        if (nout+2.gt.lout) goto 99
        out(nout+1:) = ', '
        nout = nout+2
      endif
      if (nout+6.gt.lout) goto 99
      write (out(nout+1:),'(a,i0,a)') 'Ant ',i,':'
      nout = nout + 6
      do k=1, maf
        n = ishft(1,k-1)
        if (iand(afl(i),n).eq.n) then
           l = lenc(af(k))
           if (nout+l+1.gt.lout) goto 99
           out(nout+1:) = ' '//af(k)(1:l)
           nout = nout + l+1
        endif
      enddo
    endif
    done = .false.
    do j=1, 2*mbands
      if (saf(j,i)) then
        if (.not.done) then
          if (nout.gt.0) then
            if (nout+2.gt.lout) goto 99
            out(nout+1:) = ', '
            nout = nout+2
          endif
          if (nout+6.gt.lout) goto 99
          write (out(nout+1:),'(a,i0,a)') 'Ant ',i,':'
          nout = nout + 6
          done = .true.
        endif
        l = lenc(sf(j))
        if (nout+l+1.gt.lout) goto 99
        out(nout+1:) = ' '//sf(j)(1:l)
        nout = nout + l+1
      endif
    enddo
  enddo
  do i=1, nbas
    if (bfl(i).ne.0) then
      if (nout.gt.0) then
        if (nout+2.gt.lout) goto 99
        out(nout+1:) = ', '
        nout = nout+2
      endif
      if (nout+10.gt.lout) goto 99
      out(nout+1:) = 'Bas '//cbas(i)//':'
      nout = nout + 10
      do k=1, mbf
        n = ishft(1,k-1)
        if (iand(bfl(i),n).eq.n) then
          l = lenc(bf(k))
          if (nout+l+1.gt.lout) goto 99
          out(nout+1:) = ' '//bf(k)(1:l)
          nout = nout + l+1
        endif
      enddo
      if (nout+1.gt.lout) goto 99
      out(nout+1:) = ' '
      nout = nout+1
    endif
    done = .false.
    do j=1, 2*mbands
      if (sbf(j,i)) then
        if (.not.done) then
          if (nout.gt.0) then
            if (nout+2.gt.lout) goto 99
            out(nout+1:) = ', '
            nout = nout+2
          endif
          if (nout+10.gt.lout) goto 99
          out(nout+1:) = 'Bas '//cbas(i)//':'
          nout = nout + 10
          done = .true.
        endif
        l = lenc(sf(j))
        if (nout+l+1.gt.lout) goto 99
        out(nout+1:) = ' '//sf(j)(1:l)
        nout = nout + l+1
        if (nout+1.gt.lout) goto 99
        out(nout+1:) = ' '
        nout = nout+1
      endif
    enddo
  enddo
  if (nout.eq.0) out = 'no flags'
  return
99 out(lout-3:lout) = '...'
  return
end subroutine list_flags

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_rms
  use gbl_message
  !
  public :: uv_rms_comm
  private
  !
contains
  !
  subroutine uv_rms_comm(line,error)
    use gkernel_interfaces
    use image_def
    use file_buffers
    use uv_buffers
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(gildas) :: ouuvh
    real, pointer :: inuvd(:,:),ouuvd(:,:)
    integer(kind=4), parameter :: one=1
    character(len=*), parameter :: rname='UV>RMS>COMM'
    !
    ! Get information on input uv table
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    !
    ! Update the header of the output uv table
    call gildas_null(ouuvh,type='UVT')
    call gdf_copy_header(huv,ouuvh,error)
    ouuvh%gil%dim(2) = one
    ouuvh%gil%nvisi  = one
    !
    ! User feedback
    call map_message(seve%i,rname,'Computing visibility RMS spectrum')
    !
    ! Prepare appropriate array
    nullify(inuvd,ouuvd)
    call uv_find_buffers(rname,int(ouuvh%gil%dim(1),kind=4),int(ouuvh%gil%dim(2),kind=4),inuvd,ouuvd,error)
    if (error) return
    !
    ! Actually rms
    call uv_rms_data(huv,inuvd,ouuvh,ouuvd,error)
    if (error) return
    !
    ! Everything went fine => copy output header in global buffer that contains input header up to now
    call gdf_copy_header(ouuvh,huv,error)
    ! Set global UV pointer to the output data and free the input data
    call uv_clean_buffers(inuvd,ouuvd,error)
    if (error) return
    ! UV data not plotted
    if (allocated(uvtb%data)) deallocate(uvtb%data)
    uv_plotted = .false.
    ! Indicate optimization and save status
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    ! Recompute weight
    do_weig = .true.
    !
    ! Redefine SIC variables 
    call sic_delvariable('UV',.false.,error)
    call sic_mapgildas('UV',huv,error,duv) 
  end subroutine uv_rms_comm
  !
  subroutine uv_rms_data(inuvh,inuvd,ouuvh,ouuvd,error)
    use gkernel_interfaces
    use gbl_message
    use image_def
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(gildas),         intent(in)    :: inuvh
    real(kind=4), target, intent(in)    :: inuvd(:,:)
    type(gildas),         intent(in)    :: ouuvh
    real(kind=4), target, intent(inout) :: ouuvd(:,:)
    logical,              intent(inout) :: error
    !
    real(kind=4), allocatable :: mean(:,:)
    integer(kind=4) :: ier
    integer(kind=4) :: ic,nc,ncol
    integer(kind=4) :: iv,nv
    integer(kind=4), parameter :: one=1
    character(len=*), parameter :: rname='UV>RMS>DATA'
    !
    call map_message(seve%t,rname,'Welcome')
    !
    ncol = inuvh%gil%dim(1)
    nv = inuvh%gil%dim(2)
    nc = inuvh%gil%nchan
    !
    if (nv.gt.1) then
       allocate(mean(ncol,one),stat=ier)
       if (failed_allocate(rname,'mean visibility',ier,error)) return
       !
       ! Sum visilibities
       mean(:,one) = 0.0
       do iv=1,nv
          do ic=1,nc
             ! Real part
             mean(5+3*ic,one) = mean(5+3*ic,one) + inuvd(5+3*ic,iv)
             ! Imaginary part
             mean(6+3*ic,one) = mean(6+3*ic,one) + inuvd(6+3*ic,iv)
             ! Weight
             mean(7+3*ic,one) = mean(7+3*ic,one) + inuvd(7+3*ic,iv)
          enddo ! ic
       enddo ! iv
       ! Normalize the result
       do ic=1,nc
          mean(5+3*ic,one) = mean(5+3*ic,one)/nv
          mean(6+3*ic,one) = mean(6+3*ic,one)/nv
       enddo ! ic
       !
       ouuvd(:,one) = 0.0
       do iv=1,nv
          do ic=1,nc
             ! Real part
             ouuvd(5+3*ic,one) = ouuvd(5+3*ic,one) + (inuvd(5+3*ic,iv)-mean(5+3*ic,one))**2
             ! Imaginary part
             ouuvd(6+3*ic,one) = ouuvd(6+3*ic,one) + (inuvd(6+3*ic,iv)-mean(6+3*ic,one))**2
             ! Weight
             ouuvd(7+3*ic,one) = ouuvd(7+3*ic,one) + (inuvd(7+3*ic,iv)-mean(7+3*ic,one))**2
          enddo ! ic
       enddo ! iv
       ! Normalize the result
       do ic=1,nc
          ouuvd(5+3*ic,one) = sqrt(ouuvd(5+3*ic,one))/(nv-1)
          ouuvd(6+3*ic,one) = sqrt(ouuvd(6+3*ic,one))/(nv-1)
          ouuvd(7+3*ic,one) = sqrt(ouuvd(7+3*ic,one))/(nv-1)
       enddo ! ic
    else
       call map_message(seve%w,rname,'Only one visibility => RMS set to 0!')
       ouuvd(:,one) = 0
    endif
  end subroutine uv_rms_data
end module uv_rms
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_parse(line,ientuser,icaluser,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calib_or_solve_parse
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! CALIBRATE | SOLVE ient
  ! 1. /WITH ical
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: line
  integer(kind=entry_length), intent(out)   :: ientuser
  integer(kind=entry_length), intent(out)   :: icaluser
  logical,                    intent(inout) :: error
  !
  integer(kind=4), parameter :: icomm = 0
  integer(kind=4), parameter :: iwith = 1
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>PARSE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_parse_numver(rname,line,icomm,1,ix,ientuser,error)
  if (error)  return
  if (sic_present(iwith,0)) then
     call mrtcal_parse_numver(rname,line,iwith,1,ix,icaluser,error)
     if (error)  return
  else
     ! Null value that will be interpreted as search for the best 
     ! associated calibration in the ix index
     icaluser = 0
  endif
end subroutine mrtcal_calib_or_solve_parse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_ix_entry(commcode,mrtset,ix,ientuser,icaluser,filebuf,  &
     calib,science,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_ix_entry
  use mrtcal_parameters
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: commcode
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(inout) :: ientuser
  integer(kind=entry_length), intent(inout) :: icaluser
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  type(science_t),            intent(inout) :: science
  logical,                    intent(inout) :: error
  ! Local
  logical :: myerror
  integer(kind=4) :: scibackid,calbackid
  integer(kind=entry_length) :: isciprog,icalprog
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>IX>ENTRY'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ix%obstype(ientuser).eq.obstype_calibrate) then
     ! Calibration scan: easy
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        if (icaluser.ne.0) then
           call mrtcal_message(seve%e,rname,  &
                'Can not calibrate a calibration scan /WITH another scan')
           error = .true.
           return
        endif
        call mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,ientuser,filebuf,calib,error)
        if (error) return
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Can not solve a calibration scan')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select
  else
     ! Science scan: less easy
     if (icaluser.eq.0) then
        ! Search for the best associated calibration in the ix index
        myerror = error
        call mrtcal_calib_or_solve_autofind_done_cal(mrtset,ix,ientuser,icalprog,&
             filebuf,calib,myerror)
        if (myerror) then
           ! Previous matching calibration not found 
           ! => Need to set the calibration status of the current entry to
           !    FAILED
           call mrtcal_calib_or_solve_init_science(ix,ientuser,isciprog,error)
           if (error) return
           error = .true.
           return
        endif
        call mrtcal_calib_or_solve_feedback(ix,ientuser,icalprog,  &
             warnlim=mrtset%cal%winterval,error=error)
        if (error) return
     else
        ! Use user-defined calibration scan => Some additional sanity
        ! checks are required
        icalprog = icaluser
        call mrtcal_calib_or_solve_feedback(ix,ientuser,icalprog,error=error)
        if (error) return
     endif
     ! 1) Ensure 'icalprog' is the one currently buffered (reprocess if necessary)
     call mrtcal_calib_or_solve_reload(mrtset,ix,icalprog,filebuf,calib,error)
     if (error)  return
     ! 2) Initialize science scan (after calibration reprocess)
     call mrtcal_calib_or_solve_init_science(ix,ientuser,isciprog,error)
     if (error) return
     ! 3) Check calibration scan is sane for use
     call mrtcal_calib_or_solve_check_consistency(ix,ientuser,icalprog,error)
     if (error) return
     call mrtcal_calib_or_solve_check_obstype_is_cal(ix,icalprog,error)
     if (error) return
     call mrtcal_calib_or_solve_check_calstatus(ix,icalprog,error)
     if (error) return
     ! 4) Now calibrate
     call mrtcal_calib_or_solve_get_backid(ix,isciprog,scibackid,error)
     if (error) return
     call mrtcal_calib_or_solve_get_backid(ix,icalprog,calbackid,error)
     if (error) return
     call mrtcal_calib_or_solve_onebackend_science(commcode,&
          mrtset,calib%scan%val(calbackid)%last,&
          ix,isciprog,filebuf,&
          science%scan%val(scibackid),&
          error)
     if (error) return
     call mrtcal_calib_or_solve_exit_science(science%scan%val(scibackid),ix,isciprog,icalprog,error)
     if (error) return
  endif
end subroutine mrtcal_calib_or_solve_ix_entry
!
subroutine mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,icaluser,filebuf,  &
     calib,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_ix_entry_calib
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  ! Calibrate the 'icaluser' entry (calibration scan) in IX
  ! Return the new (calibrated) entry number in 'icaluser'.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(inout) :: icaluser
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: icalprog
  integer(kind=4) :: calbackid
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>IX>ENTRY>CALIB'
  !
  call mrtcal_calib_or_solve_feedback(ix,icaluser,error=error)
  if (error) return
  call mrtcal_calib_or_solve_init_calib(ix,icaluser,icalprog,error)
  if (error) return
  call mrtcal_calib_or_solve_get_backid(ix,icalprog,calbackid,error)
  if (error) return
  call mrtcal_calib_or_solve_onebackend_calibration(&
       mrtset,ix,icalprog,filebuf,&
       calib%scan%val(calbackid)%work,error)
  if (error)  return
  call mrtcal_calib_or_solve_exit_calib(calib%scan%val(calbackid),ix,icalprog,error)
  if (error) return
  ! Success: update icaluser to store the calibrated entry number.
  icaluser = icalprog
end subroutine mrtcal_calib_or_solve_ix_entry_calib
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_get_backid(idx,ient,backid,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_get_backid
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return the backend identifier for the i-th entry in the input index
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ient
  integer(kind=4),            intent(out)   :: backid
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>GET>BACKEND'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  backid = idx%backend(ient)
  if (backid.eq.backend_unknown) then
     call mrtcal_message(seve%e,rname,'Unknown backend')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_get_backid
!
subroutine mrtcal_calib_or_solve_autofind_matching_cal(idx,backward,mtole,ientuser,  &
  istart,jcalprog,error)
  use phys_const
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_autofind_matching_cal
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !   Automatic search of the previous or next matching calibration in
  ! the input index, starting from the istart entry.
  !   The returned scan will be:
  !    - a calibration (obstype)
  !    - with calibration status none or done (reject failed or empty)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  logical,                    intent(in)    :: backward  ! Backward or forward search?
  real(kind=4),               intent(in)    :: mtole     ! [min] Tolerance
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(inout) :: istart
  integer(kind=entry_length), intent(out)   :: jcalprog
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>AUTOFIND>MATCHING>CAL'
  logical :: duplicated
  integer(kind=4), parameter :: newest = 0
  integer(kind=entry_length) :: ient,jent,first,last,step
  character(len=message_length) :: mess
  real(kind=8) :: sdobsut,cdobsut,dtole
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_separator(mseve%calib%book,rname,2,error)
  if (error) return
  call mrtindex_list_one_default(idx,ientuser,mess,error)
  call mrtcal_message(mseve%calib%book,rname,'Matching '//mess)
  !
  if (backward) then
    first = istart-1
    last = 1
    step = -1
  else
    first = istart+1
    last = idx%next-1
    step = +1
  endif
  sdobsut = idx%dobs(ientuser)+idx%ut(ientuser)/2.d0/pi
  dtole = mtole/60.d0/24.d0  ! Convert minutes to days
  jcalprog = 0
  do ient=first,last,step
     ! Finding the most recent version of the previous entry in the ix index
     ! *** JP I am not sure but there should be a shortcut as we already 
     ! *** JP known ient, i.e. why searching it from idx%num(ient) again?
     call mrtindex_numver2ent(rname,idx,idx%num(ient),newest,jent,duplicated,error)
     if (error) return
     call mrtindex_list_one_default(idx,jent,mess,error)
     call mrtcal_message(mseve%calib%book,rname,'Trying   '//mess)
     ! Search for a successful calibration of the same project and same backend
     if (idx%obstype(jent).ne.obstype_calibrate) cycle
     if (idx%calstatus(jent).eq.calstatus_failed) cycle
     if (idx%calstatus(jent).eq.calstatus_empty) cycle
     if (idx%calstatus(jent).eq.calstatus_skipped) cycle
     if (idx%projid(jent).ne.idx%projid(ientuser)) cycle
     if (idx%backend(jent).ne.idx%backend(ientuser)) cycle
     cdobsut = idx%dobs(jent)+idx%ut(jent)/2.d0/pi
     if (abs(cdobsut-sdobsut).gt.dtole)  cycle  ! Or exit?
     !
     ! OK, found a matching candidate
     ! *** JP That's not enough. Tuned frequency and channel width should also match...
     jcalprog = jent
     istart = ient  ! Also reset starting point so that we start from here
                    ! if we need to resume the loop
     exit
  enddo ! ient
end subroutine mrtcal_calib_or_solve_autofind_matching_cal
!
subroutine mrtcal_calib_or_solve_autofind_done_cal(mrtset,ix,ientuser,jcalprog,filebuf,calib,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_autofind_done_cal
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Automatic search of the nearest matching calibration in the input index.
  ! Calibrate it when needed
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: jcalprog
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>AUTOFIND>DONE>CAL'
  logical :: myerror,way(2)
  integer(kind=4) :: iway
  integer(kind=entry_length) :: istart
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  way(1) = .true.   ! Backward search first
  way(2) = .false.  ! Then forward search
  !
  do iway=1,2
    istart = ientuser
    do while (.true.)
      call mrtcal_calib_or_solve_autofind_matching_cal(ix,way(iway),mrtset%cal%einterval,  &
        ientuser,istart,jcalprog,error)
      if (error) return
      if (jcalprog.eq.0)  exit  ! Nothing found, try next way
      if (ix%calstatus(jcalprog).eq.calstatus_done)  return  ! Found a calibrated one => done!
      !
      ! Found one, but it is not calibrated. Try to calibrate it:
      myerror = .false.
      call mrtcal_calib_or_solve_ix_entry_calib(mrtset,ix,jcalprog,filebuf,calib,myerror)
      if (myerror) then
        ! Calibration failure: its calibration status is marked failed in the
        ! index but it is not an error for the current subroutine. Continue
        ! to search for a valid calibration.
      else
        ! Calibration success: jcalprog is now the calibrated entry.
        return
      endif
    enddo
  enddo  ! iway
  !
  ! At this point we tried both ways but we have not return'ed from the loop
  ! => no matching calibration found
  !
  ! Give also some feedback, so that the error does not come alone and we see
  ! clearly which scan fails. The line "Calibrating ..." is also needed by the
  ! pipeline-report script.
  call mrtcal_calib_or_solve_feedback(ix,ientuser,error=error)
  if (error)  continue
  !
  ! This is an error. If you plan to relax this, think twice because having a
  ! reasonable upper limit avoids Mrtcal to pair a science scan with a
  ! calibration scan observed 2 days ago before a storm...
  write(mess,'(A,F0.1,A)')   &
    'No matching calibration in the surrounding ',mrtset%cal%einterval,' minutes'
  call mrtcal_message(seve%e,rname,mess)
  error = .true.
  return
end subroutine mrtcal_calib_or_solve_autofind_done_cal
!
subroutine mrtcal_calib_or_solve_check_consistency(idx,ient,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_consistency
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ient
  integer(kind=entry_length), intent(inout) :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CONSISTENCY'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (idx%backend(ient).ne.idx%backend(ical)) then
     call mrtcal_message(seve%e,rname,'Calibration and science backends do not match')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_check_consistency
!
subroutine mrtcal_calib_or_solve_check_obstype_is_cal(idx,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_obstype_is_cal
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(inout) :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>OBSTYPE>IS>CAL'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (idx%obstype(ical).ne.obstype_calibrate) then
     call mrtcal_message(seve%e,rname,'Entry ### is not a calibration in input index')
     error = .true.
     return
  endif
end subroutine mrtcal_calib_or_solve_check_obstype_is_cal
!
subroutine mrtcal_calib_or_solve_check_calstatus(idx,ical,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_calstatus
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ical
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CALSTATUS'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  select case(idx%calstatus(ical))
  case (calstatus_done)
    return
  case (calstatus_none)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an UNCALIBRATED status')
    error = .true.
  case (calstatus_failed)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with a FAILED status')
    error = .true.
  case (calstatus_empty)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an EMPTY status')
    error = .true.
  case (calstatus_skipped)
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an SKIPPED status')
    error = .true.
  case default
    call mrtcal_message(seve%e,rname,'Cannot use a calibration entry with an UNKNOWN status')
    error = .true.
  end select
end subroutine mrtcal_calib_or_solve_check_calstatus
!
subroutine mrtcal_calib_or_solve_check_current(idx,ical,backcal,warn,same,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_check_current
  use mrtcal_calib_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Check if the calibration scan given as argument is the ical-th
  ! entry in the index. Issue warning messages if needed.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: idx
  integer(kind=entry_length), intent(in)    :: ical
  type(calib_backend_t),      intent(in)    :: backcal
  logical,                    intent(in)    :: warn
  logical,                    intent(out)   :: same
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>CHECK>CURRENT'
  character(len=message_length) :: mess
  character(len=11) :: date1,date2
  !
  same = .true.
  !
  if (idx%dobs(ical).ne.backcal%head%key%dobs) then
    same = .false.
    if (warn) then
      call gag_todate(idx%dobs(ical),date1,error)
      if (error)  return
      call gag_todate(backcal%head%key%dobs,date2,error)
      if (error)  return
      write(mess,'(3(A,1X))') 'Inconsistent observing dates:',date1,date2
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
  !
  if (idx%scan(ical).ne.backcal%head%key%scan) then
    same = .false.
    if (warn) then
      write(mess,'(A,1X,I0,1X,I0)') 'Inconsistent scan numbers:',idx%scan(ical),backcal%head%key%scan
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
  !
  if (idx%backend(ical).ne.backcal%head%key%backend) then
    same = .false.
    if (warn) then
      write(mess,'(3(A,1X))') 'Inconsistent backends:',  &
        mrtindex_backend(idx%backend(ical)),mrtindex_backend(backcal%head%key%backend)
      call mrtcal_message(seve%w,rname,mess)
    endif
  endif
end subroutine mrtcal_calib_or_solve_check_current
!
subroutine mrtcal_calib_or_solve_reload(mrtset,idx,ient,filebuf,calib,error)
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_reload
  use mrtcal_buffer_types
  use mrtcal_calib_types
  use mrtindex_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(inout) :: idx
  integer(kind=entry_length), intent(inout) :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_t),              intent(inout) :: calib
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>RELOAD'
  logical :: same
  integer(kind=4) :: backid
  !
  call mrtcal_calib_or_solve_get_backid(idx,ient,backid,error)
  if (error) return
  call mrtcal_calib_or_solve_check_current(idx,ient,calib%scan%val(backid)%last,.true.,same,error)
  if (error)  return
  !
  if (same) then
    call mrtcal_message(seve%d,rname,'Calibration in memory is the desired one: nothing to do')
  else
    ! Recalibrate the calibration scan and load it in memory
    call mrtcal_message(seve%w,rname,  &
      'The calibration scan currently in memory is not the desired one: reprocess')
    call mrtcal_calib_or_solve_ix_entry_calib(mrtset,idx,ient,filebuf,calib,error)
    if (error)  return
    call mrtcal_message(seve%w,rname,'Calibration scan reprocessing done, resuming science scan')
    call mrtcal_separator(seve%r,rname,2,error)
    if (error) return
  endif
end subroutine mrtcal_calib_or_solve_reload
!
subroutine mrtcal_calib_or_solve_feedback(idx,ient,ical,warnlim,error)
  use phys_const
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_calib_or_solve_feedback
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)           :: idx
  integer(kind=entry_length), intent(in)           :: ient
  integer(kind=entry_length), intent(in), optional :: ical
  real(kind=4),               intent(in), optional :: warnlim
  logical,                    intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>FEEDBACK'
  character(len=message_length) :: mess
  real(kind=4) :: diff,fact
  integer(kind=4) :: sev
  character(len=8) :: befaft,tunit
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_separator(seve%r,rname,2,error)
  if (error) return
  call mrtindex_list_one_default(idx,ient,mess,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'Calibrating '//mess)
  if (.not.present(ical))  return
  !
  call mrtindex_list_one_default(idx,ical,mess,error)
  if (error) return
  call mrtcal_message(seve%r,rname,'With        '//mess)
  if (.not.present(warnlim))  return
  !
  diff = (idx%dobs(ient)+idx%ut(ient)/2.d0/pi) -  &
         (idx%dobs(ical)+idx%ut(ical)/2.d0/pi)
  diff = diff*24.d0*60.d0  ! Convert day to min
  if (diff.gt.0.) then
    befaft = ' before'
  else
    befaft = ' after'
    diff = -diff
  endif
  if (diff.lt.1.) then
    fact = 60.
    tunit = ' seconds'
  else
    fact = 1.
    tunit = ' minutes'
  endif
  write(mess,'(A,F0.1,2A)')  'Calibration observed ',diff*fact,tunit,befaft
  if (abs(diff).gt.warnlim) then
    call sic_upper(mess)
    sev = seve%w
  else
    sev = seve%i
  endif
  call mrtcal_message(sev,rname,mess)
end subroutine mrtcal_calib_or_solve_feedback
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_init_calib(ix,ientuser,ientprog,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init_calib
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Prepare a new entry for a calibration scan
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  !
  call mrtcal_calib_or_solve_init(ix,.true.,ientuser,ientprog,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init_calib
!
subroutine mrtcal_calib_or_solve_init_science(ix,ientuser,ientprog,error)
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init_science
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Prepare a new entry for a science scan
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  !
  call mrtcal_calib_or_solve_init(ix,.false.,ientuser,ientprog,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init_science
!
subroutine mrtcal_calib_or_solve_init(ix,iscalib,ientuser,ientprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_init
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Do not call directly! Call mrtcal_calib_or_solve_init_calib or
  ! mrtcal_calib_or_solve_init_science instead.
  ! ---
  ! Copy the ient entry of the input index into a new entry. Then set 
  ! in place its calstatus to calstatus_failed. This status will
  ! be replaced in place by calstatus_done in mrtcal_calib_or_solve_exit_*
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(in)    :: iscalib
  integer(kind=entry_length), intent(in)    :: ientuser
  integer(kind=entry_length), intent(out)   :: ientprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>INIT'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! *** JP We should first try to see whether the data was already
  ! *** JP already calibrated. If yes, we should return without error,
  ! *** JP but send a warning. Of course, the user could force the
  ! *** JP calibration through /FORCE option. In this case, we should
  ! *** JP upgrade the version number to last number + 1...
  !
  ! Set the new entry. Everything identical to 'ientuser'...
  call mrtindex_optimize_to_entry(ix,ientuser,entry,error)
  if (error) return
  ! ... except those:
  entry%indx%calstatus = calstatus_failed  ! Until calibration is not successful
  ! entry%indx%version = set by mrtindex_append_entry
  !
  ! --- Sections depending on obstype ----------------------------------
  ! The section pre-allocations are needed because it may happen that
  ! mrtcal_calib_or_solve_reload adds another entry after the current
  ! one, so we can not extend it anymore.
  !
  ! --- Calibration section ---
  if (iscalib) then
    ! This is calibration scan. Forget possible previous calibration results
    ! (we will overwrite it with possible new tunings)
    entry%head%presec(sec_calib_id) = .false.
  endif
  !
  ! --- Science section ---
  if (iscalib) then
    ! This is calibration scan. No Science section
    entry%head%presec(sec_science_id) = .false.
  else
    ! This is a "science" scan (in large sense, i.e. everything which
    ! is calibrated thanks to a calibration scan). Prepare room for the
    ! Science section, it will be updated (with the actual values) by
    ! mrtcal_calib_or_solve_exit_science.
    call mrtindex_entry_zscience(entry%head%sci,error)
    if (error)  return
    entry%head%presec(sec_science_id) = .true.
  endif
  !
  ! --- Pointing section ---
  ! No solution and section disabled as long as no result to be written in index.mrt
  entry%head%presec(sec_pointing_id) = .false.  ! As long as no result
  entry%indx%solstatus = solstatus_none
  if (entry%indx%obstype.eq.obstype_pointing) then
    call entry%head%poi%zero(error)
    if (error)  return
  endif
  !
  ! --- End of sections ------------------------------------------------
  !
  call mrtindex_append_entry(entry,ientuser,ientprog,ix,error)
  if (error) return
  !
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_init
!
subroutine mrtcal_calib_or_solve_exit_calib(cal,ix,ientprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_exit_calib
  use mrtindex_types
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_work_t), intent(inout) :: cal
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: ientprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>EXIT>CALIB'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_optimize_to_entry(ix,ientprog,entry,error)
  if (error) return
  !
  if (cal%work%nspec.eq.0) then
    ! 0-sized calibration: done, but not useable later on
    ! No purpose saving an empty calibration section.
    entry%indx%calstatus = calstatus_empty
  else
    ! This is a successful calibration: the 'work' calibration
    ! becomes the 'last' useable
    call cal%swap(error)
    if (error)  return
    !
    ! *** JP: For the moment use this one. But in fact, the work on presec
    !         should also be done inside this one
    !
    ! Fill and enable the calibration section
    call mrtcal_entry_chopperset2calsec(cal%last,entry%head%cal,error)
    if (error) return
    entry%head%presec(sec_calib_id) = .true.
    !
    entry%indx%calstatus = calstatus_done
  endif
  !
  call mrtindex_extend_entry(entry,ientprog,ix,error)
  if (error) return
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_exit_calib
!
subroutine mrtcal_calib_or_solve_exit_science(sci,ix,isciprog,icalprog,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_exit_science
  use mrtcal_calib_types
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t),    intent(in)    :: sci
  type(mrtindex_optimize_t),  intent(inout) :: ix
  integer(kind=entry_length), intent(in)    :: isciprog
  integer(kind=entry_length), intent(in)    :: icalprog
  logical,                    intent(inout) :: error
  ! Local
  type(mrtindex_entry_t) :: entry
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>EXIT>SCIENCE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_optimize_to_entry(ix,isciprog,entry,error)
  if (error) return
  !
  if (sci%nobs.eq.0) then
    entry%indx%calstatus = calstatus_empty
  else
    entry%indx%calstatus = calstatus_done
    !
    ! Fill and enable the science section
    entry%head%sci%caldobs = ix%dobs(icalprog)
    entry%head%sci%calscan = ix%scan(icalprog)
    entry%head%sci%calback = ix%backend(icalprog)
    entry%head%sci%calvers = ix%version(icalprog)
    entry%head%presec(sec_science_id) = .true.
    !
    ! Enable the pointing section if relevant
    if (entry%indx%obstype.eq.obstype_pointing) then
      call mrtcal_entry_sdrifts2poisec(sci,entry%head%poi,error)
      if (error) return
      entry%head%presec(sec_pointing_id) = .true.
      entry%indx%solstatus = solstatus_done
    endif
    !
  endif
  !
  call mrtindex_extend_entry(entry,isciprog,ix,error)
  if (error) return
  call mrtindex_entry_free(entry,error)
  if (error)  return
end subroutine mrtcal_calib_or_solve_exit_science
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_or_solve_onebackend_calibration(mrtset,scanidx,ient,filebuf,&
     backcal,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_onebackend_calibration
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),       intent(in)    :: mrtset
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(calib_backend_t),      intent(inout) :: backcal
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>ONEBACKEND>CALIBRATION'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,backcal%head,error)
  if (error) return
  !
  ! Keep memory of the chunks description
  call imbfits_copy_back_chunks(filebuf%imbf%back%chunks,backcal%chunksetlist,error)
  if (error)  return
  !
  call mrtcal_calib_calibration(mrtset,filebuf,backcal,error)
  if (error) return
end subroutine mrtcal_calib_or_solve_onebackend_calibration
!
subroutine mrtcal_calib_or_solve_onebackend_science(commcode,doset,backcal,&
     scanidx,ient,filebuf, backsci,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_onebackend_science
  use mrtcal_parameters
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: commcode
  type(mrtcal_setup_t),       intent(in)    :: doset    ! Setup (user choices)
  type(calib_backend_t),      intent(in)    :: backcal
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(science_backend_t),    intent(inout) :: backsci
  logical,                    intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>ONEBACKEND>SCIENCE'
  type(mrtcal_setup_t) :: doneset  ! Setup (resolved choices)
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,backsci%head,error)
  if (error) return
  !
  ! Keep memory of the chunks description
  call imbfits_copy_back_chunks(filebuf%imbf%back%chunks,backsci%chunksetlist,error)
  if (error)  return
  !
  ! Translate user choices for this scan
  call mrtcal_setup_do2done(backsci%head%key%obstype,  &
    backsci%head%key%switchmode,doset,doneset,error)
  if (error)  return
  !
  ! Build and print subscan list
  call mrtcal_init_scan_cal(backsci,filebuf%imbf,error)
  if (error) return
  !
  if (all(backsci%list%empty)) then
    call mrtcal_message(seve%w,rname,  &
      'All subscan data tables are zero-sized: scan marked as EMPTY')
    ! backsci%nspec was initialized and left to 0. mrtcal_calib_or_solve_exit_science
    ! will then mark the scan as empty.
    return
  endif
  !
  select case(backsci%head%key%obstype)
  case (obstype_tracked)
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_pos)
           call mrtcal_calib_tracked_psw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_wob)
           call mrtcal_calib_tracked_wsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_fre)
           call mrtcal_calib_tracked_fsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Unsupported observing type when solving')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_otf)
     select case(commcode)
     case (code_command_calib,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_pos)
           call mrtcal_calib_otf_psw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case (switchmode_fre)
           call mrtcal_calib_otf_fsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve)
        call mrtcal_message(seve%e,rname,'Unsupported observing type when solving')
        error = .true.
        return
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_pointing)   
     select case(commcode)
     case (code_command_calib)
        select case(backsci%head%key%switchmode)
!!$        case (switchmode_pos)
!!$           call mrtcal_calib_pointing_psw(doneset,backcal,backsci,filebuf,error)
!!$           if (error) return
        case (switchmode_bea)
           call mrtcal_calib_pointing_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select  ! backsci%head%key%switchmode
     case (code_command_solve,code_command_pipe)
        select case(backsci%head%key%switchmode)
!!$        case (switchmode_pos)
!!$           call mrtcal_solve_pointing_psw(doneset,backcal,backsci,filebuf,error)
!!$           if (error) return
        case (switchmode_bea)
           call mrtcal_solve_pointing_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case (obstype_focus)
     select case(commcode)
     case (code_command_calib)
        select case(backsci%head%key%switchmode)
        case (switchmode_bea)
           call mrtcal_calib_focus_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case (code_command_solve,code_command_pipe)
        select case(backsci%head%key%switchmode)
        case (switchmode_bea)
           call mrtcal_solve_focus_bsw(doneset,backcal,backsci,filebuf,error)
           if (error) return
        case default
           call mrtcal_message(seve%e,rname,'Unsupported switched mode '// &
                mrtindex_swmode(backsci%head%key%switchmode))
           error = .true.
           return
        end select ! backsci%head%key%switchmode
     case default
        call mrtcal_message(seve%e,rname,'Unknown command code')
        error = .true.
        return
     end select ! commcode
  case default
     call mrtcal_message(seve%e,rname,'Unsupported observing type '// &
          mrtindex_obstype(backsci%head%key%obstype))
     error = .true.
     return
  end select ! backsci%head%key%obstype
end subroutine mrtcal_calib_or_solve_onebackend_science
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP Not sure where the following code should go: in calib-utils.f90?
!
subroutine mrtcal_calib_or_solve_read_backend_header(scanidx,ient,filebuf,head,error)
  use mrtcal_messaging
  use classic_api
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_calib_or_solve_read_backend_header
  use mrtcal_buffer_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),  intent(in)    :: scanidx
  integer(kind=entry_length), intent(in)    :: ient
  type(imbfits_buffer_t),     intent(inout) :: filebuf
  type(mrtindex_header_t),    intent(inout) :: head
  logical,                    intent(inout) :: error
  ! Local
  character(len=filename_length) :: filename
  type(classic_entrydesc_t) :: edesc
  character(len=*), parameter :: rname='CALIB>OR>SOLVE>READ>BACKEND>HEADER'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtindex_entry_rheader(scanidx,ient,edesc,head,error)
  if (error) return
  call mrtindex_optimize_to_filename(scanidx,ient,filename,error)
  if (error) return
  call imbfits_read_header(filename,filebuf%imbf,error)
  if (error) return
end subroutine mrtcal_calib_or_solve_read_backend_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gvalue (qsb, qband, qant, qntch,   &
    gainc, gainl, wgainc, wgainl,   &
    iant, iband, isub, jw1, jw2, jw3, w, zz, aa, ww, ny,error)
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Get an antenna gain-like value
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QANT    INTEGER   Number of antennas
  !     QNTCH   INTEGER   Number of channels (in total per baseline)
  !     GAINC(QBAND,QSB,QANT)   COMPLEX  Antenna gains (temporal data)
  !     GAINL(QNTCH,QSB,QBAND)  COMPLEX  Antenna gains (spectral data)
  !     WGAINC(QBAND,QSB,QANT)  REAL  Weight of antenna gain
  !     WGAINL(QNTCH,QSB,QBAND) REAL  Weight of antenna gain
  !     IANT    INTEGER   Antenna number
  !     IBAND   INTEGER   Subband number
  !     ISUB    INTEGER   Sideband number
  !     NY      INTEGER   Number of Y values (output)
  !     JW1,JW2 INTEGER   Lowest and Highest channel in window subband
  !     W       REAL      Signed integration time
  !     AA(*)   REAL      Positive weights
  !     WW(*)   REAL      Total weights
  !     ZZ(*)   COMPLEX   Complex output
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qsb                     !
  integer :: qband                   !
  integer :: qant                    !
  integer :: qntch                   !
  complex :: gainc(qband,qsb,qant)   !
  complex :: gainl(qntch,qsb,qband)  !
  real :: wgainc(qband,qsb,qant)     !
  real :: wgainl(qntch,qsb,qband)    !
  integer :: iant                    !
  integer :: iband                   !
  integer :: isub                    !
  integer :: jw1                     !
  integer :: jw2                     !
  integer :: jw3                     !
  real*4 :: w                        !
  complex :: zz(*)                   !
  real*4 :: aa(*)                    !
  real*4 :: ww(*)                    !
  integer :: ny                      !
  logical :: error
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  ! INCLUDE 'clic_sba.inc'
  ! Local
  integer :: ig, im, is, ii, ii1, ii2, k, i, jok(mch)
  complex :: zzz(2), z, av(2)
  real :: www(2), fw
  !------------------------------------------------------------------------
  !
  ! Correlation scan
  if (r_isb.eq.1) then
    ig = 1
    im = 2
  else
    ig = 2
    im = 1
  endif
  do i=1, 2
    av(i) = 1.
  enddo
  !
  if (qsb.eq.1) then ! Check available sideband
    if (isub.le.mbands) then
      is = isub
    else
      is = isub-mbands
    endif
    if (r_lsband(1,is).ne.iband) then
      call message(6,3,'GVALUE','Sideband unavailable')
      error = .true.
      return
    endif
  endif
  do i=1, 2
    av(i) = 1.0
  enddo
  ! normally one should take here the antenna based side band averages
  ! to be computed in SET_PASS
  ! Use side band averages just determined in CONT_AVERAGE.
  !      DO I=1, 2
  !         IF  (WSBA(I,-IANT).NE.0) THEN
  !            AV(I) = ABS(ZSBA(I,-IANT))/ZSBA(I,-IANT)
  !         ENDIF
  !      ENDDO
  !
  if (iband.le.2) then
    ii1 = iband
    ii2 = iband
  else
    ii1 = 1
    ii2 = 2
  endif
  if (isub.le.mbands) then
    ny = 1
    is = isub
    do ii = ii1, ii2
      zzz(ii) = gainc(is,ii,iant)
      www(ii) = wgainc(is,ii,iant)
    enddo
    !c         CALL MIXBAND(IBAND,IG,IM,ZZZ,WWW,AV,Z,FW)
    call mixband(iband,r_sb(is),zzz,www,av,z,fw)
    zz(1) = zz(1) + fw * z
    if (j_average.ne.1) then
      aa(1) = aa(1) + fw * abs(z)
    endif
    if (fw.gt.0) ww(1) = ww(1) + fw
  else
    is = isub-mbands
    ny = r_lnch(is)
    k = r_lich(is)
    call jlimits(r_lnch(is),jw1,jw2,jw3,jok)
    call jmask(r_lnch(is),nmask(is,iant),cmask(:,:,is,iant),jok)
    do i = 1, ny
      k = k + 1
      do ii = ii1, ii2
        zzz(ii) = gainl(k,ii,iant)
        www(ii) = wgainl(k,ii,iant)
      enddo
      !cc            CALL MIXBAND(IBAND,IG,IM,ZZZ,WWW,AV,Z,FW)
      call mixband(iband,r_sb(is),zzz,www,av,z,fw)
      fw = fw * jok(i)
      zz(i) = zz(i) + fw * z
      if (j_average.ne.1) then
        aa(i) = aa(i) + fw * abs(z)
      endif
      if (fw.gt.0) ww(i) = ww(i) + fw
    enddo
  endif
  return
end subroutine gvalue
!
subroutine mixband(iband,isb,z,w,av,zm,wm)
  use classic_api
  !---------------------------------------------------------------------
  !     IBAND    INTEGER   Sideband code (u/l/aver/diff/ratio)
  !     Z(2)     COMPLEX   Complex antenna gain for both sidebands
  !     W(2)     REAL      Weight
  !     AV(2)    COMPLEX   Complex sideband ratio
  !     ZM       COMPLEX   Output complex gain
  !     WM       REAL      Output weight
  !---------------------------------------------------------------------
  integer :: iband                  !
  integer :: isb                    !
  complex :: z(2)                   !
  real :: w(2)                      !
  complex :: av(2)                  !
  complex :: zm                     !
  real :: wm                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: ig, im
  !------------------------------------------------------------------------
  ! Code:
  ig = (3-isb)/2
  im = (3+isb)/2
  !
  if (iband.le.2) then
    zm = z(iband)
    wm = w(iband)
  elseif (iband.eq.3) then
    zm = av(ig)*z(ig)*w(ig) + av(im)*z(im)*w(im)
    wm = w(ig) + w(im)
    if (wm.ne.0) zm = zm / wm
  elseif (iband.eq.5) then
    zm = av(ig)*z(ig) - av(im)*z(im)
    wm = w(ig) + w(im)
  elseif (iband.eq.4) then
    if (z(im).ne.0.and.z(ig).ne.0   &
      .and.w(ig).ne.0.and.w(im).ne.0) then
      zm = av(im)*z(im) / (av(ig)*z(ig))
      wm = 1/w(ig)/abs(z(ig))**2 + 1/w(im)/abs(z(im))**2
      wm = 1/wm/abs(zm)**2
    else
      zm = 0
      wm = 0.
    endif
  endif
  return
end subroutine mixband
!
subroutine gain_cont (qsb,qband,qbas,qant,   &
    data_in, passc,gainc,wgainc,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Compute the antenna gains from temporal data
  ! Arguments
  !     QSB     INTEGER   Number of sidebands (2)
  !     QBAND   INTEGER   Number of temporal data
  !     QANT    INTEGER   Number of antennas
  !     QBAS    INTEGER   Number of baselines
  !     DATC(QBAND,QSB,QBAS)   COMPLEX  Temporal data
  !     PASSC(QBAND,QSB,QBAS)  COMPLEX  PassBand of temporal data
  !     GAINC(QBAND,QSB,QANT)  COMPLEX  Antenna gains (temporal data)
  !     WGAINC(QBAND,QSB,QANT) REAL  Weight of antenna gain
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qsb                           !
  integer :: qband                         !
  integer :: qbas                          !
  integer :: qant                          !
  integer(kind=address_length) :: data_in  !
  complex :: passc(qband,qsb,qbas)         !
  complex :: gainc(qband,qsb,qant)         !
  real :: wgainc(qband,qsb,qant)           !
  logical :: error                         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, ib, ic, iant, kr, c_offset, isb1, isb2, ibnd, ibdata
  logical :: down_channel, down_baseline
  real :: tsys_b, w(mnbas), want(mnant), afac
  complex :: z(mnbas), zant(mnant)
  integer(kind=address_length) :: ipkc, kin
  !------------------------------------------------------------------------
  ! Code:
  kin = gag_pointer(data_in,memory)
  !
  !
  do ic = 1, r_nband
    ! Number of sidebands.
    if (r_lnsb.eq.1) then
      isb1 = r_lsband(1,ic)
      isb2 = isb1
      ibnd = 1
    else 
      isb1 = 1
      isb2 = 2
      ibnd = 0
    endif
    do ib = 1, r_nbas
      do isb=isb1, isb2
        if (down_baseline(ib) .or.   &
          down_channel(ib,ic)) then
          z(ib) = 0
          w(ib) = 0
        else
          if (ibnd.ne.0) then
            ibdata = ibnd
          else
            ibdata = isb
          endif
          call spectral_dump(kr,0,ib)
          ipkc = kin + c_offset(kr)
          afac = 1
          call retrieve_datac(qband,qsb,qbas,   &
            memory(ipkc),ic,ibdata,ib,z(ib))
          if (do_pass.or.do_spidx) then
            z(ib) = z(ib)*passc(ic,isb,ib)
          endif
          call scaling (ic,isb,ib,z(ib),afac,error)
          if (.not.error) then
            w(ib) = 2*dh_integ*r_cfwid(ic)/tsys_b(ic,isb,ib)   &
              /afac**2
          else
            w(ib) = 0
          endif
        endif
      enddo
      call antgain (z,w,zant,want)
      do iant = 1, r_nant
        gainc(ic,isb,iant) = zant(iant)
        wgainc(ic,isb,iant) = want(iant)
      enddo
    enddo
  enddo
  return
end subroutine gain_cont
!
subroutine gain_line (qntch,qsb,qbas,qant,   &
    data_in,passl,gainl,wgainl,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !     Compute the antenna gains from temporal data
  ! Arguments
  !     QSB     INTEGER   Number of sidebands (2)
  !     QNTCH   INTEGER   Number of spectral channels
  !     QANT    INTEGER   Number of antennas
  !     QBAS    INTEGER   Number of baselines
  !     DATL(QNTCH,QSB,QBAS)   COMPLEX  Spectral data
  !     PASSL(QNTCH,QSB,QBAS)  COMPLEX  PassBand of spectral data
  !     GAINL(QNTCH,QSB,QANT)  COMPLEX  Antenna gains (spectral data)
  !     WGAINL(QNTCH,QSB,QANT) REAL     Weight of antenna gain
  ! Call Tree
  !	...	SUB_READ_SPEC
  !---------------------------------------------------------------------
  integer :: qntch                         !
  integer :: qsb                           !
  integer :: qbas                          !
  integer :: qant                          !
  integer(kind=address_length) :: data_in  !
  complex :: passl(qntch,qsb,qbas)         !
  complex :: gainl(qntch,qsb,qant)         !
  real :: wgainl(qntch,qsb,qant)           !
  logical :: error                         !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, ib, ic, ny, k, i, iant, jok(mch), l_offset, kr
  integer :: jokant(mch,mnant)
  integer :: ia, ja
  integer :: isb1, isb2, ibnd, ibdata
  logical :: down_channel, down_baseline
  real :: tsys_b, w(mnbas), want(mnant), afac
  complex :: z(mnbas), zant(mnant)
  integer(kind=address_length) :: ipkl, kin
  !------------------------------------------------------------------------
  ! Code:
  kin = gag_pointer(data_in,memory)
  !
  !
  !
  do ic=1, r_lband
    ! Number of sidebands.
    if (r_lnsb.eq.1) then
      isb1 = r_lsband(1,ic)
      isb2 = isb1
      ibnd = 1
    else 
      isb1 = 1
      isb2 = 2
      ibnd = 0
    endif
    do isb=isb1, isb2
      ny = r_lnch(ic)
      call jlimits(ny,0,0,ngibbs,jok)
      do iant = 1, mnant
        do i = 1, ny
          jokant(i,iant) = jok(i)
        enddo
        call jmask(ny,nmask(ic,iant),cmask(:,:,ic,iant),jokant(1,iant))
      enddo
      !$OMP PARALLEL &
      !$OMP & SHARED(gainl,wgainl,ny,r_lich,ic,r_nbas,ibnd,isb,kin) &
      !$OMP & SHARED(qntch,qsb,qbas,memory,do_pass,do_spidx,passl) &
      !$OMP & SHARED(dh_integ,r_lfres,r_nant,jokant,jok,r_iant,r_jant) &
      !$OMP & PRIVATE(i,k,ib,ibdata,ipkl,kr,afac,z,w,iant,error,zant,want,ia,ja) & 
      !$OMP & DEFAULT(none)
      !
      !$OMP DO
      do i = 1, ny
        error = .false.
        k = r_lich(ic)+i
        do ib = 1, r_nbas
          if (ib.le.mnbas) then
            ia = r_iant(ib)
            ja = r_jant(ib)
          else
            ia = 1
            ja = ia
          endif
          if (down_baseline(ib) .or.   &
            down_channel(ib,ic+mbands) .or.   &
            jokant(i,ia).eq.0 .or. jokant(i,ja).eq.0) then
            z(ib) = 0
            w(ib) = 0
          else
            if (ibnd.ne.0) then
              ibdata = ibnd
            else
              ibdata = isb
            endif
            call spectral_dump(kr,0,ib)
            ipkl = kin + l_offset(kr)
            afac = 1
            call retrieve_datal(qntch,qsb,qbas,   &
              memory(ipkl),k,ibdata,ib,z(ib))
            if (do_pass.or.do_spidx) then
              z(ib) = z(ib)*passl(k,isb,ib)
            endif
            call scaling (ic,isb,ib,z(ib),afac,error)
            if (.not.error)  then
              w(ib) = 2*dh_integ*abs(r_lfres(ic))/tsys_b(ic   &
                ,isb,ib)/afac**2
            else
              w(ib) = 0
            endif
          endif
        enddo
        if (jok(i).ne.0) then
          call antgain (z,w,zant,want)
          do iant = 1, r_nant
            gainl(k,isb,iant) = zant(iant)
            wgainl(k,isb,iant) = want(iant)
          enddo
        else
          do iant = 1, r_nant
            gainl(k,isb,iant) = 0
            wgainl(k,isb,iant) = 0
          enddo
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    enddo
  enddo
  return
end subroutine gain_line
!
!
subroutine antgain(z,w,zant,want)
  use gildas_def
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  include 'clic_clic.inc'
  ! Code
  if (new_ant_gain) then
    call new_antgain(z,w,zant,want)
  else
    call old_antgain(z,w,zant,want)
  endif
end subroutine antgain
!
!
subroutine new_antgain (z,w,zant,want)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  ! Global
  include 'gbl_pi.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  real*4 :: aa, faz, wl(mnbas)
  complex :: zl(mnbas)
  integer :: ib, ia, base, iref, itry, i, nant2, nant, repl, ia1
  integer :: irepl(r_nant),nbas,nrem
  parameter (nant2=mnant**2)
  logical :: refok, error
  real*8 :: yy(mnbas), wy(mnbas), ss(mnbas)
  real*8 :: wk2(nant2), wk3(mnant)
  real*8 :: amp(mnant), wamp(mnant), pha(mnant), wpha(mnant)
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Solve for phases, using retroprojection algorithm:
  !
  nant = r_nant
  nbas = r_nbas
  repl = 0
  !
  ! Copy baseline based values into local variables
  do ib = 1, mnbas
    wl(ib) = w(ib)
    zl(ib) = z(ib)
  enddo
  !
  ! Find if there are flagged antennas
  do ia = 1, r_nant
    want(ia) = 0
    do ia1 = 1, r_nant
      if (ia1.ne.ia) then
        ib = base(ia,ia1)
        want(ia) = want(ia) + wl(ib)
      endif
    enddo
    if (want(ia).eq.0) then
      repl = repl + 1
      irepl(repl) = ia
    endif
  enddo
  !
  ! Reduce arrays accordingly
  ! Iterate on flagged antennas in decreasing logical order
  if (repl.ne.0) then
    nrem = 0
    do i = repl, 1, -1
      !
      ! If the flagged antenna I is the last, do nothing
      ! else first remove all baselines IJ with J>I
      if(irepl(i).ne.nant) then
        do ia = nant,irepl(i)+1,-1
          do ib = (ia-2)*(ia-1)/2+irepl(i),nbas
            wl(ib) = wl(ib+1)
            zl(ib) = zl(ib+1)
          enddo
          nrem = nrem + 1
        enddo
        !
        ! Then remove all baseline IJ with J<I
        ib = 1+(irepl(i)-2)*(irepl(i)-1)/2
        do ia = ib,nbas
          zl(ia) = zl(ia+irepl(i)-1)
          wl(ia) = wl(ia+irepl(i)-1)
        enddo
      endif
      !
      ! Reduce array and modify reference antenna if needed
      nant = nant - 1
      nbas = nant * (nant - 1) / 2
      if (iref.gt.irepl(i)) then
        iref =  iref - 1
      endif
    enddo
  endif
  !
  ! No baseline survived for this channel after flagging/masking.
  ! In that case there is no antenna-based solve to perform.
  if (nant.le.1 .or. nbas.le.0) then
    do ia = 1, r_nant
      zant(ia) = 1.
      want(ia) = 0.
    enddo
    return
  endif
  !
  ! Find reference antenna for phase
  refok = .false.
  error = .false.
  iref = ref_ant
  itry = 1
  do while (.not.refok .and. itry.le.r_nant)
    do ia=1, nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        refok = refok .or. wl(ib).gt.0
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        refok = refok .or. wl(ib).gt.0
      endif
    enddo
    if (.not.refok) then
      itry = itry+1
      iref = mod(iref,r_nant)+1
    endif
  enddo
  !
  ! Phases
  do ib = 1, nbas
    yy(ib) = faz(zl(ib))
    wy(ib) = wl(ib)
  enddo
  !
  ! Phases
  call gain_ant(2, nbas, r_iant, r_jant, iref,   &
    nant, yy, wy, wk2, wk3, ss, pha, wpha, error)
  !
  ! Amplitudes
  do ib = 1, nbas
    aa = abs(zl(ib))
    yy(ib) = log(aa)
    wy(ib) = wl(ib)*aa**2
  enddo
  call gain_ant(1, nbas, r_iant, r_jant, iref,   &
    nant, yy, wy, wk2, wk3, ss, amp, wamp, error)
  !
  do ia=1, r_nant
    aa = exp(2*amp(ia))
    zant(ia) = aa * exp(cmplx(0.,pha(ia)))
    want(ia) = wamp(ia)/aa**2
  enddo
  !
  ! Special case: less than 3 antennas
  if (nant.lt.3) then
    do ia = 1, nant
      do ib=1, nbas
        if (wl(ib).gt.0) then
          amp(ia) = abs(zl(ib))
          pha(ia) = faz(zl(ib))
          want(ia) = wl(ib)
        endif
      enddo
      zant(ia) = amp(ia) * exp(cmplx(0.,pha(ia)))
    enddo
  endif
  !
  ! Subsitute back flagged value
  if (repl.ne.0) then
    do i = 1,repl ,1
      do ia = nant,max(1,nant-(r_nant-irepl(i))+1),-1
        zant(ia+1) = zant(ia)
        want(ia+1) = want(ia)
      enddo
      nant = nant + 1
      zant(irepl(i))=1
      want(irepl(i))=0
    enddo
  endif
  !
  return
end subroutine new_antgain
!
!
subroutine old_antgain (z,w,zant,want)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !     Derive antenna "gains" from baseline visibilities
  ! Arguments:
  !     Z(MNBAS)    COMPLEX   Visibility
  !     W(MNBAS)    REAL      Weight
  !     ZANT(MNANT) COMPLEX   Complex antenna gain
  !     WANT(MNANT) REAL      Weight
  ! Call Tree
  !	...	GAIN_CONT
  !	...	GAIN_LINE
  !	...	ARECORD
  !	...	CONT_AVERAGE
  !	...	SUB_SOLVE_PASS
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  complex :: z(mnbas)               !
  real*4 :: w(mnbas)                !
  complex :: zant(mnant)            !
  real*4 :: want(mnant)             !
  ! Global
  include 'gbl_pi.inc'
  include 'clic_constant.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  ! Local
  real*4 :: pha(mnant), amp(mnant), aa, faz, wa, add, aji, aki, ajk
  real*4 :: pha0(mnant)
  integer :: ib, ia, j_i, k_i, j_k, ja, ka, base, iref, itry, i
  logical :: retro, refok
  parameter (retro=.false.)
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Solve for phases, using retroprojection algorithm:
  !
  refok = .false.
  iref = ref_ant
  itry = 1
  do while (.not.refok .and. itry.le.r_nant)
    do ia=1, r_nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        refok = refok .or. w(ib).gt.0
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        refok = refok .or. w(ib).gt.0
      endif
    enddo
    if (.not.refok) then
      itry = itry+1
      iref = mod(iref,r_nant)+1
    endif
  enddo
  if (.not.refok) then
    do i=1, r_nant
      pha(i) = 0
    enddo
  else
    !
    pha0(iref) = 0.
    do ia=1, r_nant
      if (ia.lt.iref) then
        ib = base(ia,iref)
        if (w(ib).gt.0) pha0(ia) = -faz(z(ib))
      elseif (ia.gt.iref) then
        ib = base(iref,ia)
        if (w(ib).gt.0) pha0(ia) = faz(z(ib))
      endif
    enddo
    do ia = 1, r_nant
      add = 0
      do ja = 1, r_nant
        if (ja.lt.ia) then
          ib = base(ja,ia)
          if (w(ib).gt.0) then
            add = add + faz(z(ib)) - pha0(ia) + pha0(ja)
          endif
        elseif (ja.gt.ia) then
          ib = base(ia,ja)
          if (w(ib).gt.0) then
            add = add - faz(z(ib)) - pha0(ia) + pha0(ja)
          endif
        endif
      enddo
      add = mod(add+31d0*pi,2d0*pi)-pi
      pha(ia) = pha0(ia)+add/r_nant
    enddo
  endif
  !
  ! solve for amplitudes, using retroprojection algorithm:
  ! (to be checked again)
  ! note:
  ! to compute this way the weights must be provided by antenna,
  ! not by baseline. (RL 2002-02-27)
  if (retro) then
    do ia = 1, r_nant
      want(ia) = 0
      amp(ia) = 0
      do ib=1, r_nbas
        if (w(ib).gt.0) then
          if (r_iant(ib).eq.ia .or. r_jant(ib).eq.ia) then
            amp(ia) = amp(ia)+log(abs(z(ib)))*wa
            want(ia) = want(ia)+wa
          else
            amp(ia) = amp(ia)-log(abs(z(ib)))*wa/(r_nant-2)
            want(ia) = want(ia)-wa/(r_nant-2)
          endif
        endif
      enddo
      if (want(ia).gt.0) then
        amp(ia) = amp(ia)/want(ia)
      else
        amp(ia) = 0.
      endif
      if (r_nant.gt.1) then
        amp(ia) = amp(ia)/(r_nant-1)
        want(ia) = want(ia)/(r_nant-1)
      endif
      zant(ia) = exp(cmplx(amp(ia),pha(ia)))
    !            if (want(ia).gt.0) WANT(IA) = EXP(WANT(IA))
    enddo
  else
    !
    ! Solve for amplitudes
    do ia = 1, r_nant
      want(ia) = 0
      amp(ia) = 0
      if (r_nant.gt.2) then
        do ja = 1, r_nant
          if (ja.ne.ia .and. ja.lt.r_nant) then
            do  ka = ja+1, r_nant
              if (ka.ne.ia) then
                j_i = base(min(ja,ia),max(ja,ia))
                k_i = base(min(ka,ia),max(ka,ia))
                j_k = base(ja,ka)
                if (z(j_k).ne.0 .and. z(j_i).ne.0 .and.   &
                  z(k_i).ne.0 .and. w(j_k).ne.0 .and.   &
                  w(j_i).ne.0 .and. w(k_i).ne.0) then
                  aji = abs(z(j_i))
                  aki = abs(z(k_i))
                  ajk = abs(z(j_k))
                  if (aji.lt.1e15 .and. aki.lt.1e15   &
                    .and. ajk.lt.1e15) then
                    aa = aji*aki/ajk
                    wa = 1./w(j_i)/abs(z(j_i))**2   &
                      +1./w(k_i)/abs(z(k_i))**2   &
                      +1./w(j_k)/abs(z(j_k))**2
                    wa = 1/aa**2/wa
                    amp(ia) = amp(ia) + aa*wa
                    want(ia) = want(ia) + wa
                  endif
                endif
              endif
            enddo
          endif
        enddo
        if (want(ia).ne.0) amp(ia) = amp(ia) / want(ia)
      endif
      !
      ! if previous algorithm did not work, take first valid baseline
      ! containing IA. This will work if there is only one operational baseline ...
      if (want(ia).le.0) then
        do ib=1, r_nbas
          if (w(ib).gt.0) then
            amp(ia) = abs(z(ib))
            want(ia) = w(ib)
          endif
        enddo
      endif
      zant(ia) = amp(ia) * exp(cmplx(0.,pha(ia)))
    !
    !            ZANT(IA) =CMPL2(AMP(IA), PHA(IA))
    !            if (amp(ia).GT.BLANK4-D_BLANK4) want(ia) = 0
    enddo
  endif
  return
end subroutine old_antgain
!
subroutine gain_ant(iy, nbas, iant, jant, iref,   &
    nant, y, w, wk2, wk3, ss, c, wc, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     gain_ant computes a weighted least-squares approximation
  !     to the antenna amplitudes or phases
  !     for an arbitrary set of baseline data points.
  ! parameters:
  !     iy             I   Input    1 for log(amplitude), 2 for phase
  !     nbas           I   Input    the number of baselines
  !     iant(nbas)     I   Input    start antenna for each baseline
  !     jant(nbas)     I   Input    end  antenna for each baseline
  !     iref           i   Input    Reference antenna for phases
  !     nant           I   Input    the number of antennas
  !     y(m,nbas)      R8  Input    the data values
  !     w(m,nbas)      R8  Input    weights
  !     wk2(nant**2)   R8  Output   work space
  !     wk3(nant)      R8  Output   work space
  !     ss(nbas)       R8  Output   rms of fit for each baseline
  !     c(nant)        R8  Output   the gains
  !     wc(nant)        R8  Output   the output weights
  !---------------------------------------------------------------------
  integer :: iy                     !
  integer :: nbas                   !
  integer :: iant(nbas)             !
  integer :: jant(nbas)             !
  integer :: iref                   !
  integer :: nant                   !
  real*8 :: y(nbas)                 !
  real*8 :: w(nbas)                 !
  real*8 :: wk2(nant,nant)          !
  real*8 :: wk3(nant)               !
  real*8 :: ss(nbas)                !
  real*8 :: c(nant)                 !
  real*8 :: wc(nant)                !
  logical :: error                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: norm, tol
  parameter (tol=1d-14)
  integer :: zant, i, ia, ib, nantm1, ja, l, iter
  real*8 ::  wi, ww, yi
  !------------------------------------------------------------------------
  ! Code
  !
  ! Check that the weights are positive.
  !
  do ib = 1, nbas
    if (w(ib).lt.0.0d0) then
      call gagout('E-GAIN_ANT, Weights not positive')
      error = .true.
      return
    endif
  enddo
  !
  ! Amplitude case is simple...
  !
  if (iy.eq.1) then
    do i=1,nant
      do l=1,nant
        wk2(l,i) = 0.0d0
      enddo
      wk3(i) = 0.0d0
    enddo
    !
    ! store the upper-triangular part of the normal equations in wk2
    ! and the right-hand side in wk3.
    do ib=1,nbas
      wi = w(ib)
      if (wi.gt.0) then
        ia = iant(ib)
        ja = jant(ib)
        wk2(ia,ia) = wk2(ia,ia)+wi
        wk2(ia,ja) = wk2(ia,ja)+wi
        wk2(ja,ia) = wk2(ja,ia)+wi
        wk2(ja,ja) = wk2(ja,ja)+wi
      endif
    enddo
    do ib=1, nbas
      ia = iant(ib)
      ja = jant(ib)
      wi = w(ib)*y(ib)
      wk3(ia) = wk3(ia) + wi
      wk3(ja) = wk3(ja) + wi
    enddo
    !
    ! Solve the system of normal equations by first computing the Cholesky
    ! factorization
    call mth_dpotrf ('GAIN_ANT','U',nant,wk2,nant,error)
    if (error) goto 999
    call mth_dpotrs ('GAIN_ANT','U',nant,1,wk2,nant,wk3,nant,error)
    if (error) goto 999
    do i=1,nant
      wc(i) = wk2(i,i)**2
      c(i) = wk3(i)
    enddo
  !
  ! Phase is more complicated ...
  elseif (iy.eq.2) then
    nantm1 = nant-1
    do i=1,nant
      c(i) = 0.0d0
      wc(i) = 0.0d0
    enddo
    !
    ! start iterating
    norm = 1e10
    iter = 0
    do while (norm.gt.tol .and. iter.lt.100)
      iter = iter + 1
      do i=1,nantm1
        do l=1,nantm1
          wk2(l,i) = 0.0d0
        enddo
        wk3(i) = 0.0d0
      enddo
      do ib=1,nbas
        wi = w(ib)
        if (wi.gt.0) then
          ia = zant(iant(ib),iref)
          ja = zant(jant(ib),iref)
          if (ia.ne.0) then
            wk2(ia,ia) = wk2(ia,ia)+wi
          endif
          if (ja.ne.0) then
            wk2(ja,ja) = wk2(ja,ja)+wi
          endif
          if (ia.ne.0 .and. ja.ne.0) then
            wk2(ja,ia) = wk2(ja,ia)-wi
            wk2(ia,ja) = wk2(ia,ja)-wi
          endif
        endif
      enddo
      do ib=1, nbas
        if (w(ib).gt.0) then
          yi = y(ib)
          ia = iant(ib)
          ja = jant(ib)
          yi = yi+(c(ia)-c(ja))
        else
          yi = 0
        endif
        yi = sin(yi)
        ia = zant(iant(ib),iref)
        ja = zant(jant(ib),iref)
        wi = w(ib)*yi
        if (ia.ne.0) then
          wk3(ia) = wk3(ia) - wi
        endif
        if (ja.ne.0) then
          wk3(ja) = wk3(ja) + wi
        endif
      enddo
      !
      ! Solve the system of normal equations by first computing the Cholesky
      ! factorization
      call mth_dpotrf('GAIN_ANT','U',nantm1,wk2,nant,error)
      if (error) goto 999
      call mth_dpotrs ('GAIN_ANT','U',nantm1,1,wk2,nant,   &
        wk3,nantm1,error)
      if (error) goto 999
      !  Add the result to c:
      norm = 0
      do ia=1,nant
        i = zant(ia,iref)
        if (i.ne.0) then
          ww = wk3(i)
          c(ia) = c(ia)+ww
          wc(ia) = wk2(i,i)**2
          norm = norm+ww**2
        endif
      enddo
    enddo
  endif
  return
  !
999 error = .true.
  return
end subroutine gain_ant
!
function cmpl2(amp, pha)
  !---------------------------------------------------------------------
  ! Returns a complex of given amplitude and phase
  ! Test blanking value BLANK4
  !---------------------------------------------------------------------
  complex :: cmpl2                  !
  real :: amp                       !
  real :: pha                       !
  ! Global
  include 'clic_parameter.inc'
  !-----------------------------------------------------------------------
  if ((pha.gt.blank4-d_blank4   &
    .and. pha.le.blank4+d_blank4)   &
    .or. (amp.gt.blank4-d_blank4   &
    .and. amp.le.blank4+d_blank4)) then
    cmpl2 = cmplx(blank4,blank4)
    return
  endif
  cmpl2 = amp * exp(cmplx(0,pha))
  return
end function cmpl2
!
subroutine retrieve_datac(qband,qsb,qbas,datac,ic,isb,ib,z)
  integer :: qband                  !
  integer :: qsb                    !
  integer :: qbas                   !
  complex :: datac(qband,qsb,qbas)  !
  integer :: ic                     !
  integer :: isb                    !
  integer :: ib                     !
  complex :: z                      !
  !-----------------------------------------------------------------------
  z = datac(ic,isb,ib)
  return
end subroutine retrieve_datac
!
subroutine retrieve_datal(qntch,qsb,qbas,datal,k,isb,ib,z)
  integer :: qntch                  !
  integer :: qsb                    !
  integer :: qbas                   !
  complex :: datal(qntch,qsb,qbas)  !
  integer :: k                      !
  integer :: isb                    !
  integer :: ib                     !
  complex :: z                      !
  !-----------------------------------------------------------------------
  z = datal(k,isb,ib)
  return
end subroutine retrieve_datal

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_pointing_create(backsci,drifts,error)
  use mrtcal_messaging
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t), intent(in)    :: backsci  !
  type(obs_list_t),        intent(inout) :: drifts   ! Output collection of drifts
  logical,                 intent(inout) :: error    !
  ! Local
  integer(kind=4) :: ipix,iset
  character(len=*), parameter :: rname='POINTING>CREATE'
  !
  ! Sanity
  if (backsci%cumulinit) then
    ! No data accumulated, or remnants from a previous accumulation
    ! which should be ignored. Can happen if tables are zero-sized
    ! (no data or no good data), but should be trapped earlier.
    call mrtcal_message(seve%e,rname,'No data accumulated to be written')
    error = .true.
    return
  endif
  if (backsci%cumul%kind.ne.ckind_onoff) then
    call mrtcal_message(seve%e,rname,'Unexpected chunkset kind')
    error = .true.
    return
  endif
  if (backsci%cumul%ntime.ne.1) then
    call mrtcal_message(seve%e,rname,'Unexpected time dimension')
    error = .true.
    return
  endif
  !
  do ipix=1,backsci%cumul%npix
    do iset=1,backsci%cumul%nset
      call mrtcal_pointing_create_from_chunkset(  &
        backsci%cumul%chunkset(iset,ipix,1),drifts,error)
      if (error)  return
    enddo
  enddo
  !
end subroutine mrtcal_pointing_create
!
subroutine mrtcal_pointing_create_from_chunkset(chunkset,drifts,error)
  use class_types
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create_from_chunkset
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: chunkset  !
  type(obs_list_t), intent(inout) :: drifts    ! Output collection of drifts
  logical,          intent(inout) :: error     !
  ! Local
  type(drift_book_t), pointer :: book  ! Unused
  type(observation), pointer :: obs
  !
  call drifts%new(book,obs,error)
  if (error)  return
  call mrtcal_chunkset_to_obs_ry(chunkset,obs,error)
  if (error)  return
end subroutine mrtcal_pointing_create_from_chunkset
!
subroutine mrtcal_solve_and_write_obslist(drifts,out,ndrift,error)
  use class_types
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_solve_and_write_obslist
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(obs_list_t),            intent(inout) :: drifts  ! Collection of drifts
  type(mrtcal_setup_output_t), intent(in)    :: out     ! Output configuration
  integer(kind=4),             intent(inout) :: ndrift  ! Cumulative sum of drifts written
  logical,                     intent(inout) :: error   !
  !
  integer(kind=list_k) :: idrift
  type(observation), pointer :: obs
  !
  do idrift=1,drifts%n
    call drifts%get(idrift,obs,error)
    if (error)  return
    call mrtcal_solve_pointing_observation(obs,error)
    if (error)  return
    call mrtcal_pointing_associate_array(obs,error)
    if (error)  return
    if (out%toclass) then
      call mrtcal_obs_to_class(obs,error)
      if (error)  return
    endif
    ndrift = ndrift+1
  enddo
end subroutine mrtcal_solve_and_write_obslist
!
subroutine mrtcal_solve_pointing_observation(obs,error)
  use phys_const
  use point_definitions
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_messaging
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_observation
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  type(pointing_t) :: point
  type(point_guess_t) :: guess
  logical, parameter :: quiet = .false.
  integer(kind=4) :: ndat
  character(len=16) :: str
  character(len=*), parameter :: rname='SOLVE>POINTING>OBSERVATION'
  !
  ndat = obs%head%dri%npoin
  call init_pointing(ndat,      &  ! Number of data points
                     ndat,      &  ! Number of solution points
                     0,         &  ! ??? Pointing coordinate system
                     ' ',       &  ! ??? Pointing direction in above system
                     'SINGLE',  &  ! i.e. GAUSSIAN+BASE
                     point,error)
  if (error)  goto 100
  !
  point%dat%x(:) = obs%datav(1:ndat)*sec_per_rad  !
  point%dat%y(:) = obs%data1(1:ndat)              ! R4 to R8
  point%dat%w(:) = obs%dataw(1:ndat)
  !
  call default_pointing_guess(guess)
  ! Override the gaussian width with the telescope beam. Note the width
  ! is also used by solve_pointing to sample the gaussian position on
  ! the X axis.
  guess%width%value = iram_30m_beam(obs%head%dri%freq/1.d3)
  !
  ! All parameters are free
  guess%area%fixed     = .false.
  guess%position%fixed = .false.
  guess%width%fixed    = .false.
  guess%offset%fixed   = .false.
  guess%slope%fixed    = .false.
  !
  point%fun%flag = 2  ! Needed so that 'solve_pointing' actually works
  call solve_pointing(point,guess,quiet,error)
  if (error)  goto 100
  !
  ! Transfer to observation
  call mrtcal_fit_to_obs_poi(point%fun,obs,error)
  if (error)  goto 100
  !
  call mrtcal_solve_pointing_debug()
  !
100 continue
  call free_pointing(point)
  !
contains
  !
  subroutine mrtcal_solve_pointing_debug()
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    integer(kind=4) :: debug,ier
    character(len=message_length) :: mess
    real(kind=4) :: vpeak,epeak
    real(kind=8) :: xmin,xmax,ymin,ymax,bval,eval,y1,y2
    integer(kind=size_length) :: ndat8,imin,imax
    logical :: altplot
    !
    debug = 0  ! Default (0=no, 1=histo, 2=points)
    ier = sic_getlog('MRTCAL_SOLVE_POINTING_DEBUG',debug)
    if (debug.le.0)  return
    !
    ! Feedback
    print *,"Values:   Area   Position    FWHM    Offset    Slope    Peak"  ! Order in fun%par(:)
    write(mess,'(a,5(1pg10.3))')  "Guesses: ",guess%area%value,      &
                                              guess%position%value,  &
                                              guess%width%value,     &
                                              guess%offset%value,    &
                                              guess%slope%value
    print *,trim(mess)
    call mrtcal_pointing_peak(obs%head%poi,vpeak,epeak,error)
    if (error)  return
    write(mess,'(a,6(1pg10.3))')  "Results: ",point%fun%par(1:5)%value,vpeak
    print *,trim(mess)
    write(mess,'(a,6(1pg10.3))')  "Errors:  ",point%fun%par(1:5)%error,epeak
    print *,trim(mess)
    write(mess,'(a,1(1pg10.3))')  "RMS:  ",point%fun%rms
    print *,trim(mess)
    !
    ! Plot
    call gr_execl('CLEAR')
    call gr_exec1('SET PLOT LANDSCAPE')
    !
    ! Limits (suited for the drift)
    ndat8 = ndat
    bval = 0.d0
    eval = -1.d0
    call gr8_minmax(ndat8,point%dat%x,bval,eval,xmin,xmax,imin,imax)
    ! Y
    bval = obs%head%dri%bad
    eval = 0.d0
    call gr8_minmax(ndat8,point%dat%y,bval,eval,ymin,ymax,imin,imax)
    !
    call mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
    !
    ! Limits (suited for the drift and the gaussian)
    altplot = .false.
    ! X: ensure we see the gaussian and its wings if outside the data range
    if      (point%fun%par(2)%value-2*point%fun%par(3)%value.lt.xmin) then
      xmin = point%fun%par(2)%value-2*point%fun%par(3)%value
      altplot = .true.
    endif
    if  (point%fun%par(2)%value+2*point%fun%par(3)%value.gt.xmax) then
      xmax = point%fun%par(2)%value+2*point%fun%par(3)%value
      altplot = .true.
    endif
    ! Y: ensure we see the baseline at both edges
    y1 = point%fun%par(4)%value+xmin*point%fun%par(5)%value
    y2 = point%fun%par(4)%value+xmax*point%fun%par(5)%value
    if (ymin.gt.min(y1,y2)) then
      ymin = min(y1,y2)
      altplot = .true.
    endif
    if (ymax.lt.max(y1,y2)) then
      ymax = max(y1,y2)
      altplot = .true.
    endif
    ! Y: Ensure we see the gaussian peak
    if (vpeak.gt.ymax) then
      ymax = vpeak
      altplot = .true.
    endif
    if (altplot) then
      if (.not.gtexist('<GAUSSFIT'))  &
        call gr_execl('CREATE DIRECTORY <GAUSSFIT')
      call gr_execl('CHANGE DIRECTORY <GAUSSFIT')
      call mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
      call gr_execl('CHANGE DIRECTORY <GREG')
    endif
    !
    call sic_wpr('Type C to continue ',str)
  end subroutine mrtcal_solve_pointing_debug
  !
  subroutine mrtcal_solve_pointing_plot(debug,xmin,xmax,ymin,ymax,vpeak)
    !-------------------------------------------------------------------
    ! Plot the drift and its fitted model in the currently selected
    ! window, with the given limits
    !-------------------------------------------------------------------
    integer(kind=4), intent(in) :: debug
    real(kind=8),    intent(in) :: xmin,xmax
    real(kind=8),    intent(in) :: ymin,ymax
    real(kind=4),    intent(in) :: vpeak
    !
    type(simple_1d) :: mysol
    integer(kind=4) :: isol
    character(len=message_length) :: mess
    real(kind=8) :: x1,x2,y1,y2
    !
    ! Apply
    write(mess,'(4(a,1pg15.7),a)') 'LIMITS ',xmin,' ',xmax,' ',ymin,' ',ymax,' /MARGIN'
    call gr_exec1(mess)
    call sic_get_dble('USER_XMIN',xmin,error)
    if (error)  return
    call sic_get_dble('USER_XMAX',xmax,error)
    if (error)  return
    call sic_get_dble('USER_YMIN',ymin,error)
    if (error)  return
    call sic_get_dble('USER_YMAX',ymax,error)
    if (error)  return
    call gr_exec1('BOX')
    !
    ! Data
    write(mess,'(a,f0.3,a)') 'SET BLANKING ',obs%head%dri%bad,' 0.0'
    call gr_exec1(mess)
    call gr8_give('X',ndat,point%dat%x)
    call gr8_give('Y',ndat,point%dat%y)
    if (debug.eq.1) then
      call gr_exec1('HISTOGRAM')
    elseif (debug.eq.2) then
      call gr_exec1('SET MARKER 4 1 0.2 45')
      call gr_exec1('POINTS')
    endif
    !
    ! Gaussian+baseline fit
    call gr_exec1('PEN /COL WEB_GREEN')
    if (.false.) then
      call gr8_give('X',point%sol%n,point%sol%x)
      call gr8_give('Y',point%sol%n,point%sol%y)
    else
      mysol%n = 512
      allocate(mysol%x(mysol%n),mysol%y(mysol%n))
      do isol=1,mysol%n
        mysol%x(isol) = xmin + (isol-1.)/(mysol%n-1)*(xmax-xmin)
      enddo
      call get_profile(point%fun,mysol)
      call gr8_give('X',mysol%n,mysol%x)
      call gr8_give('Y',mysol%n,mysol%y)
    endif
    call gr_exec1('CONNECT')
    !
    ! Some typical gaussian points
    mysol%n = 3
    mysol%x(1) = point%fun%par(2)%value-point%fun%par(3)%value/2  ! Half-maximum (left)
    mysol%x(2) = point%fun%par(2)%value                           ! Center
    mysol%x(3) = point%fun%par(2)%value+point%fun%par(3)%value/2  ! Half-maximum (right)
    call get_profile(point%fun,mysol)
    !
    ! Gaussian position (from baseline to peak)
    x1 = mysol%x(2)
    y1 = point%fun%par(4)%value+x1*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',x1,' ',y1,' /USER'
    call gr_exec1(mess)
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',x1,' ',mysol%y(2),' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Gaussian FWHM
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',mysol%x(1),' ',mysol%y(1),' /USER'
    call gr_exec1(mess)
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',mysol%x(3),' ',mysol%y(3),' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Baseline fit only
    call gr_exec1('PEN /COL BLUE')
    x1 = xmin
    y1 = point%fun%par(4)%value+x1*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW RELOCATE ',x1,' ',y1,' /USER'
    call gr_exec1(mess)
    x2 = xmax
    y2 = point%fun%par(4)%value+x2*point%fun%par(5)%value
    write(mess,'(a,1pg15.7,a,1pg15.7,a)') 'DRAW LINE ',x2,' ',y2,' /USER /CLIP'
    call gr_exec1(mess)
    !
    ! Sanity check
    call gr_exec1('PEN /COL RED')
    if (point%fun%par(2)%value.lt.min(x1,x2).or.point%fun%par(2)%value.gt.max(x1,x2)) then
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 3 "WARNING: Gaussian peak @ ',point%fun%par(2)%value,'" 5 /BOX 2'
      call gr_exec1(mess)
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 2 "(the minimization used the edge of the gaussian)" 5 /BOX 2'
      call gr_exec1(mess)
    endif
    if ((y1.gt.ymax.and.y2.gt.ymax).or.(y1.lt.ymin.and.y2.lt.ymin)) then
      write(mess,'(a,1pg0.3,a)') 'DRAW TEXT 0 1 "WARNING: baseline out of plot (',point%fun%par(4)%value,' @ x=0)" 5 /BOX 2'
      call gr_exec1(mess)
    endif
    !
    ! Legend
    call gr_exec1('PEN /COL WEB_GREEN')
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -1 "Area: ',point%fun%par(1)%value,' [K.sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -2 "Position: ',point%fun%par(2)%value,' [sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -3 "FWHM: ',point%fun%par(3)%value,' [sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -4 "Peak: ',vpeak,' [K]" 6 /CHAR 7'
    call gr_exec1(mess)
    call gr_exec1('PEN /COL BLUE')
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -5 "Offset: ',point%fun%par(4)%value,' [K]" 6 /CHAR 7'
    call gr_exec1(mess)
    write(mess,'(a,1pg10.3,a)') 'DRAW TEXT 1 -6 "Slope: ',point%fun%par(5)%value,' [K/sec]" 6 /CHAR 7'
    call gr_exec1(mess)
    call gr_exec1('PEN /COL FOREGROUND')
    write(mess,'(3a)') 'DRAW TEXT 0 0.5 ',trim(obs%head%gen%teles),' /BOX 8'
    call gr_exec1(mess)
    !
    call null_simple_1d(mysol)
  end subroutine mrtcal_solve_pointing_plot
end subroutine mrtcal_solve_pointing_observation
!
subroutine mrtcal_pointing_peak(poi,vpeak,epeak,error)
  use phys_const
  use class_types
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! @ private
  ! From a CLASS pointing section, return the peak value and its error.
  ! This information is redundant with the (area,position,fwhm) stored
  ! in the section.
  !---------------------------------------------------------------------
  type(class_pointing_t), intent(in)    :: poi
  real(kind=4),           intent(out)   :: vpeak  ! Peak value
  real(kind=4),           intent(out)   :: epeak  ! Peak error
  logical,                intent(inout) :: error
  !
  real(kind=4) :: fac
  real(kind=4) :: voffs,vslop,varea,vposi,vfwhm
  real(kind=4) :: eoffs,eslop,earea,eposi,efwhm
  !
  fac = 2*sqrt(log(2.)/pis)
  !
  voffs = poi%nfit(pointing_fit_offset)
  vslop = poi%nfit(pointing_fit_slope)
  varea = poi%nfit(pointing_fit_area1)
  vposi = poi%nfit(pointing_fit_posi1)
  vfwhm = poi%nfit(pointing_fit_fwhm1)
  vpeak = voffs+vslop*vposi + fac*varea/vfwhm
  !
  eoffs = poi%nerr(pointing_fit_offset)
  eslop = poi%nerr(pointing_fit_slope)
  earea = poi%nerr(pointing_fit_area1)
  eposi = poi%nerr(pointing_fit_posi1)
  efwhm = poi%nerr(pointing_fit_fwhm1)
  epeak = fac/vfwhm * sqrt(earea**2  + (varea*efwhm/vfwhm)**2)  ! ZZZ Missing the eoffs and eslope contribution
end subroutine mrtcal_pointing_peak
!
subroutine mrtcal_pointing_associate_array(obs,error)
  use class_types
  use mrtindex_sec_pointing
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_pointing_associate_array
  !---------------------------------------------------------------------
  ! @ private
  ! If the observation provides a pointing drift fit, it is modified so
  ! that:
  ! 1) RY provides the baselined pointing drift,
  ! 2) an associated array named XX provides the (original)
  !    non-baselined pointing drifts
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  real(kind=4), pointer :: data1(:)
  integer(kind=4) :: ichan
  real(kind=4) :: y
  !
  if (.not.obs%head%presec(class_sec_poi_id))  return
  !
  ! Declare the reserved associated array and fetch a pointer to its
  ! data
  call class_assoc_add(obs,'POINTING',data1,error)
  if (error)  return
  data1(:) = obs%data1(:)
  !
  ! Replace original RY with its baselined version
  do ichan=1,obs%head%dri%npoin
    if (obs%data1(ichan).ne.obs%head%dri%bad) then
      y = obs%head%poi%nfit(pointing_fit_offset) +  &
          obs%head%poi%nfit(pointing_fit_slope) * obs%datav(ichan)
      obs%data1(ichan) = obs%data1(ichan) - y
    endif
  enddo
end subroutine mrtcal_pointing_associate_array
!
subroutine mrtcal_pointing_classify(mrtset,idrifts,sdrifts,error)
  use phys_const
  use mrtcal_messaging
  use toc_types
  use class_toc_parameters
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_classify
  !---------------------------------------------------------------------
  ! @ private
  ! Gtaher drifts by equivalence class and solve each class.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t), intent(in)    :: mrtset   !
  type(obs_list_t),     intent(in)    :: idrifts  ! Collection of individual drifts
  type(obs_list_t),     intent(inout) :: sdrifts  ! Collection of averaged and solved drifts
  logical,              intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>AVERAGE'
  integer(kind=4) :: toc_keys(2)
  type(toc_selection_t) :: select
  integer(kind=entry_length) :: iequ
  type(drift_book_t), pointer :: book
  type(observation), pointer :: obs
  integer(kind=4) :: nkeys,ikey
  !
  select case (mrtset%sol%poimix)
  case (mixmode_entry)     ! Unique entry
                           ! i.e. no mixing
    nkeys = 1
    toc_keys(1) = class_toc_key_entry
  case (mixmode_drift)     ! Unique telescope and unique drift
                           ! i.e. mixed directions (e.g. 0+180)
    nkeys = 2
    toc_keys(1) = class_toc_key_telescope
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdrift) ! Unique frontend, unique sideband and unique drift
                           ! i.e. mixed polarizations and mixed directions
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdirec) ! Unique frontend, unique sideband and unique direction
                           ! i.e. mixed polarizations
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_direction
  case (mixmode_fedrift)   ! Unique frontend and unique drift
                           ! i.e. mixed polarizations, sidebands, and directions
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fedirec)   ! Unique frontend and unique direction
                           ! i.e. mixed polarizations and sidebands
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_direction
  case default
    call mrtcal_message(seve%e,rname,'MSET SOLVE POINTING mode not implemented')
    error = .true.
    return
  end select
  !
  call idrifts%to_selection(toc_keys(1:nkeys),select,error)
  if (error)  return
  !
  call sdrifts%final(error)
  if (error)  return
  !
  ! Fill pseudo observations (only the relevant parts needed by
  ! mrtcal_solve_pointing_observation) and perform the minimizations
  do iequ=1,select%nequ
    ! Fetch a new observation from list
    call sdrifts%new(book,obs,error)
    if (error)  return
    ! Bookkeeping for this class
    book%nkey = nkeys
    book%nobs = select%cnt(iequ)
    do ikey=1,nkeys
      book%keys(ikey)   = select%ids(ikey)
      book%values(ikey) = select%nam(iequ,ikey)
    enddo
    ! Gather this class in a single observation
    call mrtcal_solve_pointing_oneclass(idrifts,iequ,select%cnt(iequ),select%bak,obs,error)
    if (error)  return
  enddo
end subroutine mrtcal_pointing_classify
!
subroutine mrtcal_solve_pointing_oneclass(drifts,iequ,cnt,bak,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_oneclass
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Produce the drift for one equivalence class
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts  ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: iequ    ! Eq. class identifier
  integer(kind=entry_length), intent(in)    :: cnt     ! Number of elements in this eq. class
  integer(kind=entry_length), intent(in)    :: bak(:)  ! Back pointer to original elements
  type(observation),          intent(inout) :: obs     !
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>ONECLASS'
  integer(kind=entry_length) :: idrift,ilist,list(cnt)  ! Automatic array
  type(observation), pointer :: drift
  !
  ! Get the drift numbers which go in this eq. class
  ilist = 0
  do idrift=1,drifts%n
    if (bak(idrift).eq.iequ) then
      ilist = ilist+1
      list(ilist) = idrift
    endif
  enddo
  !
  if (cnt.eq.1) then
    ! Direct export (as is), i.e. leave it irregular
    call drifts%get(list(1),drift,error)
    if (error)  return
    call copy_obs(drift,obs,error)
    if (error)  return
  else
    ! Resample and average in a single regular drift
    call mrtcal_solve_pointing_gather(drifts,list,obs,error)
    if (error)  return
  endif
  !
end subroutine mrtcal_solve_pointing_oneclass
!
subroutine mrtcal_solve_pointing_gather(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts indentfies in the list and produce a single drift
  ! observation
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  logical, parameter :: doregular=.true.
  !
  if (doregular) then
    ! Resample and average the drifts
    call mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
    if (error)  return
  else
    ! Concatenate and sort the data points
    call mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
    if (error)  return
  endif
end subroutine mrtcal_solve_pointing_gather
!
subroutine mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_regular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Resample each irregular drift to a common axis and average them.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER>REGULAR'
  integer(kind=entry_length) :: ilist
  integer(kind=list_k) :: iref,idrift
  type(observation), pointer :: ref,drift
  type(resampling) :: axis
  type(observation) :: tmp
  real(kind=4) :: cbad,weight
  logical :: stele_c(12)
  logical, parameter :: contaminate=.true.
  logical, parameter :: weight_update=.true.
  !
  ! Use the first drift as reference. All drifts have a regular axis
  ! declared which is a good approximation of the irregular axis.
  iref = list(1)
  call drifts%get(iref,ref,error)
  if (error)  return
  cbad = ref%head%dri%bad
  axis%nchan = ref%head%dri%npoin
  axis%ref   = ref%head%dri%rpoin
  axis%val   = ref%head%dri%aref
  axis%inc   = ref%head%dri%ares
  axis%unit  = 'A'
  axis%shape = ''   ! Only for FFT resampling
  axis%width = 1.0  ! Only for FFT resampling
  !
  ! Initialize output sum
  ! - Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(ref%head,obs%head)
  obs%head%presec(class_sec_xcoo_id) = .false.
  stele_c(:) = .true.
  ! obs%head%dri%apos  = ref%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  ! - Data area
  call reallocate_obs(obs,axis%nchan,error)  ! Is this useful?
  if (error)  return
  obs%spectre(:) = 0.
  obs%dataw(:) = 0.
  !
  ! Initialize temporary observation
  call class_obs_init(tmp,error)
  if (error)  return
  !
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    ! --- Header update ---
    if (drift%head%gen%subscan.ne.obs%head%gen%subscan)  &
      obs%head%gen%subscan = 0
    call sumlin_header_telescope(drift%head%gen%teles,stele_c,obs%head%gen%teles)
    ! --- Data update ---
    call copy_obs(drift,tmp,error)
    if (error)  exit
    call obs_weight_time(rname,tmp,weight,error,verbose=.true.)
    if (error)  exit
    ! From irregular axis to regular: use CLASS RESAMPLE
    tmp%cbad = cbad
    tmp%datax = tmp%datav
    call class_resample_obs(tmp,axis,.false.,error)
    if (error)  exit
    ! Average in running sum
    tmp%dataw(:) = weight
    call simple_waverage(tmp%spectre,tmp%dataw,cbad,  &
                         obs%spectre,obs%dataw,cbad,  &
                         1,axis%nchan,contaminate,weight_update)
  enddo
  ! Recompute regularized X axis in DATAV (used for minimization)
  call abscissa_angl_r8(obs%head,obs%datav,1,obs%head%dri%npoin)
  !
  call class_obs_clean(tmp,error)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_regular
!
subroutine mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_irregular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts identifies in the list and produce a single drift
  ! observation. Just concatenate and sort the (X,Y) data point, leave
  ! the observation irregular.
  ! This solution is well suited for minimization of the point cloud,
  ! but can not be extensively used in CLASS. In particular, such an
  ! irregular axis does not behave well with the RESAMPLE command.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  integer(kind=entry_length) :: ilist
  type(observation), pointer :: ref,drift
  integer(kind=list_k) :: iref,idrift
  integer(kind=4) :: ndata,first,last,npoin,ier
  real(kind=4), allocatable :: buf(:)
  integer(kind=4), allocatable :: key(:)
  !
  iref = list(1)  ! Select 1st obs in its class as reference
  call drifts%get(iref,ref,error)
  if (error)  return
  !
  ! Precompute the number of points for this class
  ndata = 0
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    ndata = ndata+drift%head%dri%npoin
  enddo
  call reallocate_obs(obs,ndata,error)
  if (error)  return
  !
  ! Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(ref%head,obs%head)
  ! obs%head%gen%teles = ref%head%gen%teles  ZZZ need specific mixing function
  ! obs%head%dri%apos  = ref%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  !
  ! Collect points
  first = 1
  do ilist=1,size(list)
    idrift = list(ilist)
    call drifts%get(idrift,drift,error)
    if (error)  return
    npoin = drift%head%dri%npoin
    last = first+npoin-1
    obs%datav(first:last) = drift%datav(1:npoin)
    obs%data1(first:last) = drift%data1(1:npoin)
    obs%dataw(first:last) = drift%dataw(1:npoin)
    first = last+1
  enddo
  obs%head%dri%npoin = ndata  ! = last
  !
  ! Sort the points
  allocate(buf(ndata),key(ndata),stat=ier)
  if (failed_allocate(rname,"sorting buffers",ier,error))  return
  call gr8_trie(obs%datav,key,ndata,error)
  if (error)  return
  call gr4_sort(obs%data1,buf,key,ndata)
  if (error)  return
  call gr4_sort(obs%dataw,buf,key,ndata)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_irregular
!
!--------------------------------------------------------------------------
!
subroutine mrtcal_solve_pointing_user_feedback(backsci,setout,error)
  use mrtcal_messaging
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_solve_pointing_user_feedback
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_user_feedback_tool
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t),     intent(in)    :: backsci
  type(mrtcal_setup_output_t), intent(in)    :: setout
  logical,                     intent(inout) :: error
  !
  type(user_feedback_t) :: user
  character(len=*), parameter :: rname='SOLVE>POINTING>USER>FEEDBACK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call user_feedback_head(error)
  if (error) return
  call user%allocate_and_init(backsci%head%poi%nsol,error)
  if (error) return
  call user_feedback_perobs(backsci%head,error)
  if (error) return
  call user%sort_by_freq_direction_idfe(error)
  if (error) return
  call user%list(error)
  if (error) return
  if (setout%restable) then
     call user%tofile(backsci%head,error)
     if (error) return
  endif
  !
contains
  !
  subroutine user_feedback_perobs(head,error)
    use phys_const
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    type(mrtindex_header_t), intent(in)    :: head
    logical,                 intent(inout) :: error
    ! Local
    integer(kind=4) :: iobs,color
    real(kind=8) :: bad
    real(kind=8) :: mfreq,mangle,mhpbw
    real(kind=8) :: varea,vposi,vfwhm,voffs,vslop,vcorr ! Values
    real(kind=8) :: earea,eposi,efwhm,eoffs,eslop,ecorr ! Errors
    character(len=8) :: mfrontend,mbackend
    character(len=message_length) :: result
    !
    do iobs=1,head%poi%nsol
!!$      call calibrate_user_feedback_compute_perpixel(gr8_compute,  &
!!$           backcal,ipix,                                          &
!!$           mfrontend,mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o,error)
!!$      if (error) return
       !
       bad = head%poi%sol(iobs)%dri%bad
       !
       mfrontend = head%poi%sol(iobs)%gen%teles(4:)
       mbackend = backends_mrtcal(head%key%backend)
       mfreq = head%poi%sol(iobs)%dri%freq/1d3
       mangle = head%poi%sol(iobs)%dri%apos*deg_per_rad
       mhpbw = iram_30m_beam(mfreq)
       !
       voffs = head%poi%sol(iobs)%poi%nfit(pointing_fit_offset)*1d3            ! [mK]
       vslop = head%poi%sol(iobs)%poi%nfit(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       varea = head%poi%sol(iobs)%poi%nfit(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       vposi = head%poi%sol(iobs)%poi%nfit(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       vfwhm = head%poi%sol(iobs)%poi%nfit(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       vcorr = pointing_collimation(head%poi%sol(iobs)%dri)                    ! [rad]
       if (vcorr.ne.bad)  vcorr = vcorr*sec_per_rad+vposi                      ! [arcsec]
       !
       eoffs = head%poi%sol(iobs)%poi%nerr(pointing_fit_offset)*1d3            ! [mK]
       eslop = head%poi%sol(iobs)%poi%nerr(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       earea = head%poi%sol(iobs)%poi%nerr(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       eposi = head%poi%sol(iobs)%poi%nerr(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       efwhm = head%poi%sol(iobs)%poi%nerr(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       ecorr = eposi                                                           ! [arcsec]
       !
       vfwhm = vfwhm/mhpbw
       efwhm = efwhm/mhpbw
       call user_feedback_oneline(&
            mfrontend,&
            mbackend,&
            mfreq,&
            mangle,&
            vcorr,ecorr,&
            varea,earea,&
            vposi,eposi,&
            vfwhm,efwhm,&
            voffs,eoffs,&
            vslop,eslop,&
            bad,&
            result,color)
       call user%fill(iobs,mfrontend,mfreq,mangle,result,color)
    enddo ! iobs
  end subroutine user_feedback_perobs
  !
  subroutine user_feedback_oneline(frontend,backend,freq,angle,  &
       vcorr,ecorr,varea,earea, &
       vposi,eposi,vfwhm,efwhm, &
       voffs,eoffs,vslop,eslop,bad,oneline,color)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    character(len=*), intent(in)  :: frontend
    character(len=*), intent(in)  :: backend
    real(kind=8),     intent(in)  :: freq
    real(kind=8),     intent(in)  :: angle
    real(kind=8),     intent(in)  :: vcorr,ecorr
    real(kind=8),     intent(in)  :: varea,earea
    real(kind=8),     intent(in)  :: vposi,eposi
    real(kind=8),     intent(in)  :: vfwhm,efwhm
    real(kind=8),     intent(in)  :: voffs,eoffs
    real(kind=8),     intent(in)  :: vslop,eslop
    real(kind=8),     intent(in)  :: bad
    character(len=*), intent(out) :: oneline
    integer(kind=4),  intent(out) :: color        ! Colorization code
    !
    real(kind=8) :: snr
    !
    snr = abs(varea/earea)
    write(oneline,100)  frontend,&
                        user_feedback_format_onedouble(5,'f5.1',freq,bad),&
                        backend,&
                        user_feedback_format_onedouble(6,'f6.1',angle,bad),&
                        user_feedback_format_onedouble(6,'f6.1',vcorr,bad),&
                        user_feedback_format_onedouble(6,'f6.1',vposi,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eposi,bad),&
                        user_feedback_format_onedouble(6,'f6.2',vfwhm,bad),&
                        user_feedback_format_onedouble(6,'f6.2',efwhm,bad),&
                        nint(snr),&
                        user_feedback_format_onedouble(6,'f6.1',varea,bad),&
                        user_feedback_format_onedouble(6,'f6.1',earea,bad),&
                        nint(voffs),&
                        nint(eoffs),&
                        user_feedback_format_onedouble(6,'f6.1',vslop,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eslop,bad)
    !
    if (snr.lt.10) then
       color = code_color_red
    else if (snr.lt.20) then
       color = code_color_orange
    else
       color = code_color_green
    endif
    !
100 format(t1,a5,   &  ! Frontend
           t7,a5,   &  ! Freq
           t13,a3,  &  ! Backend
           t18,a6,  &  ! Angle
           t25,a6,  &  ! Correction
           t32,a6,  &  ! Position
           t38,a6,  &  ! Position error
           t46,a6,  &  ! FWHM
           t52,a6,  &  ! FWHM error
           t60,i4,  &  ! Area SNR
           t65,a6,  &  ! Area (+1 leading blank)
           t72,a6,  &  ! Area error (+1 leading blank)
           t80,i6,  &  ! Offset
           t87,i6,  &  ! Offset error (+1 leading blank)
           t95,a6,  &  ! Slope
           t102,a6)    ! Slope error (+1 leading blank)
  end subroutine user_feedback_oneline
  !
  subroutine user_feedback_head(error)
    use mrtcal_messaging
    logical, intent(inout) :: error
    !
    character(len=message_length) :: mess
    !
    call mrtcal_separator(seve%r,rname,1,error)
    if (error) return
    write(mess,'(t1,a4,t7,a4,t13,a4,t18,a6,t25,a6,t32,a12,t46,a12,t60,a18,t80,a12,t95,a13)') &
         'idFe','freq','idBe','Angle','Correc','  Position  ', '    FWHM    ','       Area       ','   Offset    ','    Slope    '
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t7,a5,t19,a5,t25,a6,t32,a12,t46,a12,t60,a18,t80,a13,t95,a13)') &
         '[GHz]','[deg]','[arcs]','--[arcsec]--','-[fraction]-','-[SNR]-[K.arcsec]-','----[mK]-----','-[mK/arcsec]-'
    call mrtcal_message(seve%r,rname,mess)
    mess = repeat('-',107)
    call mrtcal_message(seve%r,rname,mess)
  end subroutine user_feedback_head
end subroutine mrtcal_solve_pointing_user_feedback
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine astro_uv(line,error)
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>gr4_marker
  use gkernel_types
  use gbl_message
  use ast_astro
  use ast_constant
  use atm_params
  use astro_interfaces, except_this=>astro_uv
  !---------------------------------------------------------------------
  ! @ private
  ! ASTRO Support for command
  ! UV_TRACKS Station1_ .. StationN
  !       [/FRAME Max_U] #1
  !       [/HOUR Hmin Hmax] #2
  !       [/TABLE Name] #3
  !       [/HORIZON Elv] #4
  !       [/INTEGRATION T] #5
  !       [/STATIONS ALL|list] #6
  !       [/SIZE size1 nsize1 size2 nsize2 ...] #7
  !       [/OFFSET offset] #8
  !       [/WEIGHT mode [Jy_per_K Bandwidth]] #9
  !------------------------------------------------------------------------
  ! Notes:
  ! - RL 09-nov-1998 /SIZE must be given to antenna size.
  ! - OFFSET is the position of the fixed delay line which corresponds to the
  ! the first station. It is then necessary to insure that in the following
  ! the tables X(MSTAT) reflect the order in which the stations were entered
  ! in the command line.
  !
  ! Note about XX YY ZZ TT, the positions written in the station's file:
  ! TT is (or should be) the total length (in m) from the center of
  ! the aperture to a reference plane common to all beams (preferably the
  ! entrance plane of delay lines). For XX, YY and ZZ, these are the 3
  ! components of the vector going from the earth centre to the location of
  ! the station on the surface of the earth (local equatorial coordinates),
  ! with XX along this direction, YY in the W-E direction
  ! (positive towards EAST) and ZZ in the N direction. Given local horizontal
  ! (on earth surface) coordinates x,y,z of the station,
  ! x towards Local east, y toward N and z toward Zenith,
  ! the transformation matrix is :
  !
  ! XX      / 0,-sin(lat),  cos(lat) \   x
  ! YY =    | 1,        0,         0 | * y
  ! ZZ      \ 0, cos(lat),  sin(lat) /   z
  !
  ! Where lat is the latitude of the interferometer center
  ! Note about u,v,w:
  ! the transformation from the equatorial coordinates Bx,By,Bz
  ! of a Baseline B to u,v,w is given by the matrix:
  ! u       / sin(H)       , cos(H)       ,      0 \   Bx
  ! v  =    |-sin(D)*cos(H), sin(D)*sin(H), cos(D) | * By
  ! w       \ cos(D)*cos(H),-cos(D)*sin(H), sin(D) /   Bz
  ! where H is the hour angle and D the declination of the source
  !
  ! which give ellipses of centre (0, (B/lambda)*sin(d)*cos(D)), with semi-major
  ! axis (B/lambda)*cos(d) and semi-minor axis (B/lambda)*cos(d)*sin(D)
  !
  ! Taking into account a maximum throw for delay lines may be useful for
  ! RadioInterferometers too (some may have cable length limitations) but
  ! is not desirable by default for them. However, the geometrical delay between
  ! apertures ('aerials'? 'telescopes'?) is used deep in the program. To avoid
  ! problems, I suggest to define the throw of fake 'delay lines' for radio
  ! interferometers to 2 a.u = 3.0E11 m ,with OFFSET to 1 a.u.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_TRACK'
  !
  integer(kind=4), parameter :: iopt_frame=1
  integer(kind=4), parameter :: iopt_hour=2
  integer(kind=4), parameter :: iopt_table=3
  integer(kind=4), parameter :: iopt_ho=4
  integer(kind=4), parameter :: iopt_int=5
  integer(kind=4), parameter :: iopt_stations=6
  integer(kind=4), parameter :: iopt_size=7
  integer(kind=4), parameter :: iopt_offset=8
  integer(kind=4), parameter :: iopt_weight=9
  !
  integer(kind=4), parameter :: mstat=300,mlist=20
  integer(kind=4), parameter :: visi_size=10 ! number of column of output table
  integer(kind=4), parameter :: hori_min=3 ! minimum elevation in degrees
  real(kind=4), parameter :: def_integ_time=15 ! default integration time
  !
  !
  type(uv_track_t) :: uvt
  !
  integer(kind=4) :: nstat_in, ier, nc, ii, i1, i2,iline,muv
  integer(kind=4) :: istation(mstat), nlu, nn,nskip,nces,nsize,nfilled
  type(sic_listi4_t) :: list
  character(len=12) :: name, statn,stations_in(mstat)
  character(len=132) :: clu, oldlis, stalis, delay_mess
  real(kind=4) ::  tt
  integer(kind=4) :: flag
  real(kind=4) ::  xx, yy, zz,  h, sh, ch
  real(kind=4) :: hmin, hmax, array,hh1,hh2,poff(4)
  real(kind=4) :: uk, vk, wk,  hori, uvmin,psize,throw, latitud
  real(kind=8) :: decs, az, el,avec(3), bvec(3), amat(9)
  integer(kind=4) :: i, j, k, l, ns, nh, lun, nvis
  character(len=256) :: chain
  character(len=message_length) :: mess
  character(len=132) :: fstation
  logical :: take, found(mstat), table_ok,delay_ok
  logical :: complete(mstat)
  real(kind=4) ::  frac
  integer(kind=4) ::  iused, nused, ntake,check_nsize
  integer(kind=4), parameter :: mw=3
  character(len=8) :: weight(mw)
  real(kind=4), allocatable :: myvisi(:,:),zch(:), zsh(:)
  integer(kind=4) :: ivisi
  integer :: date(7)
  character(len=16) :: d_chain
  integer :: idate
  ! Saved variables
  type(gildas), save :: xtab  ! Probably needs to be SAVE'd
  integer(kind=4), save :: count=0 ! when several succesive calls
  logical, save :: first_call = .true.
  real(kind=4), save :: extr=300.0  ! Array size in meters
  real(kind=4) :: px !page_x from sic
  character(len=filename_length), save :: file = ' ' ! output table name 
  ! Data
  data weight /'UNIFORM','AIRMASS','FULL'/
  !
  ! Check that station files is found
  if (.not.sic_query_file('astro_stations','data#dir:','.dat',fstation)) then
    ier = sic_getlog('astro_stations',fstation)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,  &
        'Failure in translation of astro_stations logical')
      error = .true.
      return
    else
      write (mess,'(a,1x,a,1x,a)') 'Station file',trim(fstation),'not found'
      call astro_message(seve%f,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  ! backward compatibility to understand 3digit station names (E68 instead o E068)
  uvt%in%three_digit_name_compatible = .true.   
  !
  uvt%in%do_frame = sic_present(iopt_frame,0)
  uvt%in%do_hour=sic_present(iopt_hour,0)
  uvt%in%do_table=sic_present(iopt_table,0)
  uvt%in%do_ho=sic_present(iopt_ho,0)
  uvt%in%do_int=sic_present(iopt_int,0)
  uvt%in%do_stations=sic_present(iopt_stations,0)
  uvt%in%do_size=sic_present(iopt_size,0)
  uvt%in%do_offset=sic_present(iopt_offset,0)
  uvt%in%do_weight=sic_present(iopt_weight,0)
  !
  ! Option /FRAME
  uvt%in%user_array=0.
  if (uvt%in%do_frame) then
    call sic_r4 (line,iopt_frame,1,uvt%in%user_array,.false.,error)
    if (error) return
  endif
  !
  if (first_call) then
    ! do the frame whatever the option upon fist call
    uvt%in%do_frame = .true.
    first_call = .false.
  endif
  !
  ! The logic of /TABLE is VERY restrictive.
  !          /TABLE Name     should only be used with /FRAME
  !          /TABLE          without /FRAME can only be used
  !                          if a previous /FRAME /TABLE Name
  !                          has been given in the session.
  ! This means it is impossible to add some UV coverage to an
  ! existing UV Table...  It should be changed at some time.
  if (uvt%in%do_table) then
    if (uvt%in%do_frame) then
      ! 1st plot with /FRAME
      call sic_ch (line,iopt_table,1,chain,nc,.true.,error)
      if (error) return
      call sic_parsef(chain,file,' ','.uvt')
    elseif (sic_present(iopt_table,1)) then
      ! later call to inand
      if (len_trim(file).eq.0) then
        call astro_message(seve%e,rname,'No previous Table')
        error = .true.
        return
      endif
      call astro_message(seve%w,rname,'Table name ignored, using '//file)
    endif
  endif
  !
  uvt%in%do_all=.false.
  
  ! /STATIONS
  if (uvt%in%do_stations) then
    ! stations given through option /STATION
    if (sic_present(0,1)) then
      call astro_message(seve%e,rname,'With option /STATIONS UV_TRACKS should not have any argument ')
      error=.true.
      return
    endif
    call sic_ke(line,iopt_stations,1,stalis,nc,.true.,error)
    if (error) return
    if (stalis.eq.'ALL') then
      uvt%in%do_all = .true.
      nstat_in = -1
      if (sic_present(iopt_stations,2)) then
        call astro_message(seve%e,rname,'Argument ALL should be alone')
        error=.true.
        return
      endif
    else
      i1 = sic_start(iopt_stations,1)
      i2 = sic_end(iopt_stations,sic_narg(iopt_stations))
      stalis = line(i1:i2)
      call sic_parse_listi4('UV_TRACKS',stalis,list,mlist,error)
      if (error) return
      nstat_in = 0
      do i=1,list%nlist
        do ii=list%i1(i),list%i2(i),list%i3(i)
          if (nstat_in.ge.mstat) then
            call astro_message(seve%e,rname,'Too many stations')
            error=.true.
            return
          else
            nstat_in = nstat_in+1
            istation(nstat_in) = ii
            stations_in(nstat_in) = ''
          endif
        enddo
      enddo
    endif
  else
    ! Stations given through command arguments
    ! Stations. Check validity of names passed as 'character variables'.
    stalis = ' '
    nc = 0
    ns = 0
    if (sic_narg(0).gt.mstat) then
      call astro_message(seve%e,rname,'Too many stations entered')
      error=.true.
      return
    endif
    if (sic_narg(0).eq.0) then
      call astro_message(seve%e,rname,'No stations')
      error = .true.
      return
    endif
    if (sic_narg(0).eq.1) then
      call sic_ke (line,0,1,statn,l,.true.,error)
      if (statn(1:3).eq.'ALL') then
        call astro_message(seve%i,rname,'Using all stations from input file')
        uvt%in%do_all =.true.
        nstat_in = -1
      else
        call astro_message(seve%e,rname,'Only one station - no uv coverage')
        error = .true.
        return
      endif
    else
      do i=1, sic_narg(0)
        call sic_ke (line,0,i,statn,l,.true.,error)
        if (error) return
        if(lenc(statn).gt.0)then
          ns=ns+1
          call sic_blanc(statn,l)
          stations_in(ns)=statn(1:l)
          istation(ns) = -1
        endif
      enddo
      nstat_in = ns
      if (nstat_in.eq.0) then
        call astro_message(seve%e,rname,'No stations')
        error = .true.
        return
      endif
    endif
  endif
  !
  ! /SIZES size1 nsize1 size2 nsize2 ...
  ! Compute minimum valid UV spacing from dish sizes. For inhomogeneous arrays
  ! (i.e. for the VLT) this should be done for each baseline.
  uvt%in%nsize=1
  uvt%in%nant_size(1) = mstat
  uvt%in%sizes(1) = 0.   ! default set to no size
  ! Part related to limit in delay line
  throw = 2.0*au_m               ! essentially, ignore delay (radio interferometers)
  uvt%in%offset= au_m                   ! so the dl max is +- 1 au
  ! Note that OFFSET and THROW are updated
  !
  ! Defaults for some observatories we know of. Note that there is no external
  ! definition of THROW, nor different THROWS for pairs of telescopes.
  if (obsname(1:4).eq.'BURE'.or.obsname(1:4).eq.'NOEM'.or.obsname(1:4).eq.'PDBI') then
    uvt%in%sizes(1) = 15.0
  elseif (obsname(1:4).eq.'ALMA') then
    uvt%in%sizes(1) = 12.0
  elseif (obsname(1:4).eq.'ACA ') then
    uvt%in%sizes(1) = 7.0
  elseif (obsname(1:4).eq.'VLA ') then
    uvt%in%sizes(1) = 25.0
  elseif (obsname(1:3).eq.'SMA ') then
    uvt%in%sizes(1) = 6.0
  elseif (obsname(1:4).eq.'PARA'.or.obsname(1:4).eq.'VLT ') then
    ! Assume Main UT telescopes for the time being...
    uvt%in%nsize = 2
    uvt%in%nant_size(1) = 4
    uvt%in%sizes(1) = 8.0
    uvt%in%nant_size(2) = 2
    uvt%in%sizes(2) = 1.5
    throw   = 127
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'PTI ') then
    uvt%in%sizes(1) = 0.40
    throw = 76.0               ! 2 delay lines
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'GI2T') then
    uvt%in%sizes(1) = 1.50
    throw = 6.0                ! 2 delay lines
    uvt%in%offset = 0.0
  elseif  (obsname(1:4).eq.'IOTA') then
    uvt%in%sizes(1) = 0.45
    throw = 3.9                ! new iota small delay ?
    uvt%in%offset = 0.0
  endif
  ! Here one can update the default OFFSET:
  ! option /OFFSET
  ! Load the value of the fixed delay line
  if (uvt%in%do_offset) then
    call sic_r4 (line,iopt_offset,1,uvt%in%offset,.true.,error)
    if (error) then
      call astro_message(seve%e,rname,'No valid offset given')
      return
    endif
  endif
  !
  ! Size of the antennas (mostly for shadowing)
  if (uvt%in%do_size) then
    if (sic_narg(iopt_size).eq.1) then
      ! 1 size for all the antennas
      call sic_r4(line,iopt_size,1,uvt%in%sizes(1),.true.,error)
      if (error) return
      uvt%in%nant_size(1) = mstat
      nsize = 1
    else if (floor(sic_narg(iopt_size)/2.).ne.sic_narg(iopt_size)/2.) then
      call astro_message(seve%e,rname,'Option /SIZE requires an even number arguments')
      call astro_message(seve%e,rname,'/SIZE size1 number1 [size2 number2 ...]')
      error=.true.
      return
    else
      nsize = 0
      i = 1
      do while(uvt%in%nsize.lt.msize .and. i.lt.sic_narg(iopt_size))
        ! /SIZE argument SIZE and number of antennas of this size
        nsize = nsize+1
        ! Read first argument of pair: size
        call sic_r4(line,iopt_size,i,uvt%in%sizes(nsize),.true.,error)
        if (error) return
        i = i+1
        ! Read 2nd argument of pair: number of antennas with this part
        call sic_i4(line,iopt_size,i,uvt%in%nant_size(nsize),.true.,error)
        if (error) return
        i = i+1
      enddo
    endif
    check_nsize=0
    do i=1,nsize
      check_nsize=check_nsize+uvt%in%nant_size(i)
    enddo
    if (check_nsize.lt.nstat_in) then
      call astro_message(seve%e,rname,'The number of defineds sizes does not match the number of used antennas')
      return
    endif
    uvt%in%nsize=nsize
  endif
  if (uvt%in%sizes(1).eq.0) then
    call astro_message(seve%w,rname,'Antenna size unknown. No shadowing '//  &
    'warnings will be given.')
  endif
  !
  ! HORIZON option input  
  uvt%in%horizon = hori_min
  if (uvt%in%do_ho) then
    if (sic_narg(iopt_ho).gt.1) then
      call astro_message(seve%e,rname,'Too many arguments for /HORIZON option')
      error=.true.
      return
    endif
    call sic_r4  (line,iopt_ho,1,hori,.true.,error)
    if (error) return
    if (hori.gt.90) then
      call astro_message(seve%e,rname,'Sourve elevation cannot be higher than 90 degrees')
      error=.true.
      return
    endif
    if (hori.lt.hori_min) then
      uvt%in%horizon=hori_min 
      write (mess,'(a,1x,i2.0,1x,a)') 'Minimum elevation set to',hori_min,'degrees'
      call astro_message(seve%w,rname,mess)
    else
      uvt%in%horizon=hori
    endif
  endif
  !
  ! option /HOUR_ANGLE
  if (uvt%in%do_hour) then
    call sic_r4 (line,iopt_hour,1,hh1,.true.,error)
    if (error) return
    hh2=-hh1
    ! default is symetric wrt transit
    call sic_r4 (line,iopt_hour,2,hh2,.false.,error)
    if (error) return
    uvt%in%in_h1=min(hh1,hh2)
    uvt%in%in_h2=max(hh1,hh2)    
  endif
  !
  ! /INTEGRATION Option
  uvt%in%integ_time = def_integ_time
  if (uvt%in%do_int) then
    call sic_r4 (line,iopt_int,1,uvt%in%integ_time,.true.,error)
    if (error) return
    if (uvt%in%integ_time.le.0) then
      call astro_message(seve%e,rname,'integration time should be longer than 0')
      error=.true.
      return
    endif
  endif
  write(mess,'(A,1PG10.3,A)') 'Integration time ',uvt%in%integ_time,' min'
  call astro_message(seve%i,rname,mess)
  !
  ! /WEIGHT option
  uvt%in%wkey = 1
  if (uvt%in%do_weight) then
    call sic_ke (line,iopt_weight,1,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,name,uvt%in%wkey,weight,mw,error)
    if (error) return
    call astro_message(seve%i,rname,'Weighting mode is '//name)
    if (name.eq.'FULL') then
      call sic_r4 (line,iopt_weight,3,bandwidth,.true.,error)
      if (error) return
      call sic_r4 (line,iopt_weight,2,jy_per_k,.true.,error)
      if (error) return       
      ! Make sure the Frequencies are set properly by default
      if (freq.ne.freqs) then
        freqs = freq
        freqi = freq
        gim   = 0.0
      endif
    else
      if (sic_present(iopt_weight,2)) then
        call astro_message(seve%e,rname,'Too many arguments for option /WEIGHT')
        error=.true.
        return
      endif
    endif
  else
    bandwidth = 1.0
  endif
  !
  ! END OF COMMAND PARSING
  !
  ! START OF WORK
  !
  ! 1. Check that source goes above the elevation limit and that there is no problem with hour angle limits
  ! Need current source today Declination
  call sic_get_dble('DEC',decs,error)
  if (error) return
  latitud = lonlat(2)
  hmin = a_lever(sngl(decs),latitud,uvt%in%horizon)
  if (hmin.ge.0) then
    call astro_message(seve%e,rname,'Source is not visible')
    error = .true.
    return
  endif
  hmax = -hmin
  ! Default range is rise to set
  uvt%in%h1=hmin
  uvt%in%h2=hmax
  ! Limit the range if requested
  if (uvt%in%do_hour) then
    if (uvt%in%in_h1.lt.hmin) then
      write(mess,'(A,1PG10.3)') 'Source rises only at ',hmin
      call astro_message(seve%w,rname,mess)      
    endif
    uvt%in%h1=max(uvt%in%in_h1,hmin)
    if (uvt%in%in_h2.gt.hmax) then
      write(mess,'(A,1PG10.3)') 'Source sets at ',hmax
      call astro_message(seve%w,rname,mess)
    endif
    uvt%in%h2=min(uvt%in%in_h2,hmax)
  endif
  !
  !2. Compute Hour angle range (one data point every 15mn; just OK for Bure but
  ! a shorter interval is needed for long VLA configurations or the VLT).
  ! to allow any integration time
  frac = uvt%in%integ_time/60. ! in hour
  inttime = uvt%in%integ_time*60. ! needed for atm computation in /weight, full mode
  !
  ! Conservative guess size of table with hours for which we will compute the uv
  muv = ceiling((uvt%in%h2-uvt%in%h1)/frac)+2 ! +2 to avoid issues with rounding 
  allocate(zch(muv),zsh(muv),stat=ier)
  if (failed_allocate(rname,'elevation table',ier,error))  return  
  nh = 0
  h = pi*uvt%in%h1/12.0
  do while (h.le.pi*uvt%in%h2/12.0)
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  !
  !Get best coverage from header Line of station file
  call uv_get_arraysize(rname,fstation,array,nskip,poff,error)
  if (error) return
  !
  if (uvt%in%do_frame) then
  ! Frame : Reset coverage and station list
    call uv_reset_plot(rname,uvt%in,array,extr,freq,error)
    if (error) return
    count = 0
    oldlis = ' '
  else
    oldlis = stalis
  endif
  !
  ! Get and plot stations
  call sic_get_real('page_x',px,error)
  if (px.gt.21) then
     call gr_exec('SET BOX 20 30 9 19')
  else
     call gr_exec('SET BOX 3 12 18 28')
  endif
  if (gr_error()) then
    error=.true.
    return
  endif
  !
  if (uvt%in%do_frame) then
    write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-array+poff(1),array+poff(2),-array+poff(3),array+poff(4)
    ! poff depends on observatory station file format
    !
    call gr_exec1(chain)
    if (gr_error()) then
      error=.true.
      return
    endif
  endif
  ! Init found variable
  do i=1,mstat
    found(i) =.false.
  enddo
  ! Useful values for conversion/plots
  uvt%ang%sd = sin(decs)
  uvt%ang%cd = cos(decs)
  uvt%ang%sp = sin(pi*(lonlat(2))/180.0d0)
  uvt%ang%cp = cos(pi*(lonlat(2))/180.0d0)
  !
  call gr_segm('ARRAY',error)
  !
  ! Init the reading of the station file
  iline= 0
  nn = 0
  iused = 1
  nused = 0
  ier = sic_getlun (lun)
  ier = sic_open(lun,fstation,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fstation
    call astro_message(seve%e,rname,trim(mess))
    goto 998
  endif
  nfilled=0
  do while (.true.)
    read(lun,'(a)',iostat=ier) clu
    if (ier.lt.0)  exit      ! EOF
    if (ier.ne.0)  then
      call astro_message(seve%e,rname,'Troubles reading station coordinates')
      goto 998  ! Error reading line
    endif
    iline = iline+1
    if (iline.le.nskip) cycle ! ignore first line - number depends on file format
    if (clu(1:1).eq.'!')  cycle  ! ignore comments
    nlu = lenc(clu)
    if (nlu.eq.0)  cycle     ! ignore empty lines
    !
    if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA'.or.obsname.eq.'SMA') then
      ! BURE format: 4 columns
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz
      tt = 0.0
    else
      ! ALMA format: at least 5 columns (antenna size in column 5)
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz,tt
    endif
    if (ier.ne.0) then
      call astro_message(seve%w,rname,'Could not decode line: '//clu)
      cycle
    endif
    !
    take = .false.
    nn = nn+1
    if (uvt%in%do_all) then
      ntake = nn
      take = .true.
    else
      do i=1, nstat_in
        if (uvt%in%do_stations.and.nn.eq.istation(i)) then
          ! station entered by index and option station
          take=.true.
          ntake=i
          exit
        endif
        if (.not.uvt%in%do_stations) then
          ! station entered by name as command argument
          call uv_match_station(rname,uvt%in,name,stations_in(i),take,error)
          if (error) return
          if (take) then
            ntake=i
            exit
          endif
        endif
      enddo
    endif
    if (take) then
      ! Get the station coordinates
      nfilled=nfilled+1
      uvt%stations(ntake)%name = name
      uvt%stations(ntake)%x = xx
      uvt%stations(ntake)%y = yy
      uvt%stations(ntake)%z = zz
      uvt%stations(ntake)%t = tt
      uvt%stations(ntake)%found = .true.
      ! 
      ! Check size of the current antenna
      if (nused.ge.uvt%in%nant_size(iused)) then
        iused = iused+1
        nused = 0
      endif
      nused = nused+1
      uvt%stations(ntake)%asize = uvt%in%sizes(iused)
      ! Plot the station position
      call gr_set_marker (4,3,.3)
      if (uvt%in%do_size) then
        ! Compute marker size to try represent the respective size of the dish
        ! vs the size of the array:
        psize = uvt%stations(ntake)%asize*10/(2*array)  ! box is 10 cm...
        if (psize.gt.0.1) then
          call gr_set_marker (20,3,psize)
        endif
      endif
      ! Draw the marker
      call gr4_marker(1,yy,zz*uvt%ang%cp-xx*uvt%ang%sp,0.,-1.0)
    elseif (uvt%in%do_frame) then     
      ! station not selected : only a square to mark the position
      call gr_set_marker(4,0,.1)
      call gr4_marker(1,yy,zz*uvt%ang%cp-xx*uvt%ang%sp,0.,-1.0)
    endif
  enddo  ! end of loop on station file lines
  !
  close(unit=lun)
  call sic_frelun (lun)
  call gr_segm_close(error)
  !
  if (uvt%in%do_all) then
    stalis='ALL STATIONS'
    uvt%n_stations=nfilled
  else
    if (nstat_in.eq.nfilled) then
      uvt%n_stations=nstat_in
    else
      write (mess,'(a)') 'Problems with input station list'
      do i=1,nstat_in-1
        do j=i+1,nstat_in
          if (stations_in(i).eq.stations_in(j)) then
            write (mess,'(a,a,a)') 'Station ',trim(stations_in(i)),' requested several times'   
          endif
        enddo
      enddo
      call astro_message(seve%e,rname,mess)
      error=.true.
      return
    endif
  ! Build the line with all stations that were entered AND which are found in station file
    k = 0
    do i=1, uvt%n_stations
      if (uvt%stations(i)%found) then
        stalis(k+1:) = uvt%stations(i)%name//'-'
        call sic_black(stalis,k)
        if (i.eq.floor(uvt%n_stations/2.)) then
          ! get index of half antenna list place
          nces=k
        endif
      else
        call astro_message(seve%f,rname,'Station not found: '//uvt%stations(i)%name)
        error=.true.   ! for GTVIEW and other problems...
        return 
      endif
    enddo
    nc = k-1
  endif
!   endif
  !
  if (uvt%in%do_offset.and.uvt%in%offset.gt.0.0.and.uvt%in%offset.lt.au_m) then
    write (delay_mess,102) uvt%in%offset
    call sic_noir(delay_mess,nc)
  else
    delay_mess=''
  endif
  !
  !draw legend:  stations used, source declination and frequency
  call astro_uv_legend(rname,freq,decs,stalis,oldlis,delay_mess,uvt%n_stations, count,nc,nces,error)
  if (error) return
  !
  ! Plot coverage
  ! Consider setting marker size to equivalent dish size?
  ! size is a ratio
  call gr_exec('SET BOX 4 19 3 18')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-extr,extr,-extr,extr
  call gr_exec1(chain)
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_segm('UVTRACK',error)
  !
  !
  uvt%stations(1)%t=uvt%stations(1)%t+uvt%in%offset
  nvis = 0
  table_ok=uvt%in%do_table
  if (uvt%in%do_table) then
    ! Size of Output Table. Must be computed exactly, since we
    ! do not want null entries at the end. we must take into account here
    ! rejected samples due to shadowing and/or delay line THROW.
    ! First loops just to get the number of visilities
    do k = 1,nh
      ! need update for each h
      uvt%ang%zsh=zsh(k)
      uvt%ang%zch=zch(k)
      !
      ! Reset complete variable at each h
      do i=1,uvt%n_stations-1
        complete(i) = uvt%stations(i)%found
        do j=i+1,uvt%n_stations
          complete(j) = uvt%stations(j)%found
        enddo
      enddo
      !
      ! Check for shadowing
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j),complete(i),complete(j),error)
              ! complete = false means that antenna is shadowed at the present h
              if (error) return
            endif
          enddo
        endif
      enddo
      !
      ! Now, Take in account max delay of Delay lines
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              delay_ok=.false.
              call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
              if (error) return
              if (delay_ok) then
                nvis=nvis+1
              endif
            endif
          enddo
        endif
      enddo
    enddo
    !
    if (uvt%in%do_frame) then
      ! /FRAME means we restart from scratch the visibility table
      write(mess,'(A,A,A,I0,A)')  &
        'Initialising ',trim(file),' with ',nvis,' (u,v) points'
      call astro_message(seve%i,rname,mess)
      call astro_init_table(xtab,file,nvis,decs,freq,bandwidth,obsname,error)
    else
      ! No /FRAME, add visi to existig file
      write(mess,'(A,I0,A,A)')  &
        'Adding ',nvis,' (u,v) points to table ',trim(file)
      call astro_message(seve%i,rname,mess)
      call astro_extend_table(xtab,file,nvis,decs,freq,error)
    endif
    if (error) then
      call astro_message(seve%w,rname,'Cannot open output Table')
      call astro_close_table(xtab)
      table_ok = .false.
      error = .false.
    else
      allocate(myvisi(visi_size,nvis),stat=ier)
      if (ier.ne.0) then
         call astro_message(seve%w,rname,'Memory allocation failure for Table')
         call astro_close_table(xtab)
         table_ok = .false.
         error = .false.
      else
        table_ok=.true.
      endif
    endif
  endif
  !
  call jjdate(jnow_utc, date)
  call ndatec(date, d_chain, error)
  call gag_fromdate(d_chain,idate,error)
  idate = idate+count
  !
  ! OK, redo for good now!
  ivisi = 0
  do k = 1,nh
    uvt%ang%zsh=zsh(k)
    uvt%ang%zch=zch(k)
    !
    ! Check for stations
    do i=1,uvt%n_stations-1
      complete(i) = uvt%stations(i)%found
      do j=i+1,uvt%n_stations
        complete(j) = uvt%stations(j)%found
      enddo
    enddo
    !
    ! Source elevation
    !
    call amset(lonlat(2),amat)
    avec(1) = zch(k)*uvt%ang%cd
    avec(2) = zsh(k)*uvt%ang%cd
    avec(3) = uvt%ang%sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    !
    if (uvt%in%wkey.eq.3) then
      ! Full mode for wight: atm computation
      call astro_setuv_weight(el)
    endif
    !
    ! Check for shadowing
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j),complete(i),complete(j),error)
            ! complete = false means that antenna is shadowed at the present h
            if (error) return
            if (.not.(complete(i))) then
              write(mess,'(A,I0,A,I0)') 'Antenna ',i,' is shadowed by ',j
              call astro_message(seve%i,rname,mess)
            else if  (.not.(complete(j))) then
              write(mess,'(A,I0,A,I0)') 'Antenna ',j,' is shadowed by ',i
              call astro_message(seve%i,rname,mess)
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now and Plot, Take in account max delay of Delay lines
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            delay_ok=.false.
            call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
            if (error) return
            psize = sqrt(uvt%stations(i)%asize*uvt%stations(j)%asize)*15/(2*extr)
            ! Plot 'bad' points (throw unable to follow delay) only if DO_SIZE
            call uv_do_baseline(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uk,vk,wk,error)
            if (error) return
            ! Plot Considerations
            if (.not.delay_ok) then
              if (uvt%in%do_size) then
                ! Plot the excluded points in case of do_size
                call gr_set_marker (4,1,0.05)
                flag=0
              else
                flag=1         ! do not plot
              endif
            else
              flag=0
              if (psize.lt.0.0001 .or. .not.uvt%in%do_size) then
                call gr_set_marker (4,0,0.05)
              else
                call gr_set_marker (20,0,psize)
              endif
            endif
            !            
            uvmin = uvt%stations(i)%asize/2.+uvt%stations(j)%asize/2.
            if ((uk**2+vk**2).le.uvmin**2) then
              call astro_message(seve%d,rname,'---- Y A UN PROBLEME ----')
            else
              if (table_ok.and.delay_ok) then
                ivisi = ivisi+1
                call fill_table (uk,vk,wk,float(idate),(uvt%in%integ_time*60*k),i,j,  &
                myvisi(1,ivisi),el,uvt%in%wkey)
              endif
              if (flag.eq.0) then
                call gr4_marker(1,uk,vk,0.0,-1.0)
                uk = -uk
                vk = -vk
                wk = -wk
                call gr4_marker(1,uk,vk,0.0,-1.0)
              endif
              flag=0
            endif
          endif
        enddo
      endif
    enddo
    !
  enddo
  call gr_segm_close(error)
  !
  if (table_ok) then
    call gdf_write_data(xtab,myvisi,error)
    call astro_close_table (xtab)
    deallocate (myvisi, stat=ier)
  endif
  return
  !
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  return
  102   format (', DL set @ ',f12.5,' m')
end subroutine astro_uv
!
subroutine uv_do_baseline(rname,uvang,uvsta_i,uvsta_j,uk,vk,wk,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_do_baseline
  !---------------------------------------------------------------------
  ! @ private
  !
  ! compute baseline coordinates
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j ! current stations
  real(kind=4), intent(inout) :: uk,vk,wk
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz
  !
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  wk = uvang%cd*(-uvang%zch*yy+xx*uvang%zch)+zz*uvang%sd
  !
end subroutine uv_do_baseline
!
subroutine uv_check_shadow(rname,uvang,uvsta_i,uvsta_j,ok_i,ok_j,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_check_shadow
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check whether the 2 antennas on stations i,j have shadowing
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j ! current stations
  logical, intent(inout) :: ok_i,ok_j
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz,uk,vk,uvmin,test
  !
  uvmin = uvsta_i%asize/2.+uvsta_j%asize/2.
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  if ((uk**2+vk**2).le.uvmin**2) then
    ! shadowing happends, check who shadows who
    test = (xx*uvang%zch - yy*uvang%zsh)*uvang%cd + zz*uvang%sd
    if (test.gt.0.0) then
      ok_i = .false. 
    else
      ok_j = .false.
    endif
  endif
end subroutine uv_check_shadow
!
subroutine uv_check_delay(rname,uvang,uvsta_i,uvsta_j,uvsta_ref,throw,delay_ok,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_check_delay
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check whether the delay is not bigger than the limit (for observatories using fixed delay lines)
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_angles_t), intent(in) :: uvang ! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j,uvsta_ref ! current stations
  real(kind=4), intent(in) :: throw
  logical, intent(inout) :: delay_ok
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: xx,yy,zz,wkj,wki
  !
  xx = uvsta_j%x-uvsta_ref%x
  yy = uvsta_j%y-uvsta_ref%y
  zz = uvsta_j%z-uvsta_ref%z
  wkj = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_j%t
  !
  xx = uvsta_i%x-uvsta_ref%x
  yy = uvsta_i%y-uvsta_ref%y
  zz = uvsta_i%z-uvsta_ref%z
  wki = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_i%t
  !
  ! Count only visibility doable wrt delay lines
  if ((wkj.ge.0).and.(wkj.le.throw).and. (wki.ge.0).and.(wki.le.throw))  delay_ok=.true.
  ! 
end subroutine uv_check_delay
!
subroutine uv_match_station(rname,uvin,fname,istation,match,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_match_station
  !---------------------------------------------------------------------
  ! @ private
  !
  ! check if station of the current line in the file matches the requested station
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_in_t), intent(in) :: uvin
  character(len=*) :: fname ! station name as in station file
  character(len=*) :: istation ! station name as user input
  logical, intent(inout) :: match 
  logical, intent(inout) :: error 
  ! Local
  character(len=256) :: chain
  character(len=3) :: sname
  !
  if (fname.eq.istation) then
    match=.true.
  else if ((obsname.eq.'BURE'.or.obsname.eq.'NOEMA').and.uvin%three_digit_name_compatible) then
    ! 01-jul-2022. Mnemonic station names changed from [E,W,N]+2 digits to [E,W,N]+3 digits in station files
    ! The following trick has been written to ensure backward compatibility reasons
    ! Will be removed after a period of ~ 1--2 yr
    if (len_trim(fname).eq.4.and.len_trim(istation).eq.3.and.fname(2:2).eq.'0') then
      sname(1:1)=fname(1:1)
      sname(2:3)=fname(3:4)
      if (sname.eq.istation) then
        call astro_message(seve%w,rname,'The 3 characters format for NOEMA stations is obsolescent')
        write (chain,'(a,1x,a,1x,a,1x,a)') 'Station',trim(istation),'is now called',trim(fname)
        call astro_message(seve%w,rname,chain)
        match=.true.
      endif
    endif
  endif
  !
end subroutine uv_match_station
!
subroutine uv_reset_plot(rname,uvin,arr,lextr,ff,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_reset_plot
  !---------------------------------------------------------------------
  ! @ private
  !
  ! reset the plot upon /frame option
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  type(uv_track_in_t), intent(in) :: uvin
  real(kind=4), intent(in) :: arr
  real(kind=4), intent(inout) :: lextr
  real(kind=8), intent(inout) :: ff        !
  logical, intent(inout) :: error 
  ! Local
  character(len=256) :: chain
  !
  lextr = arr
  if (uvin%user_array.gt.0) then
    ! use user value
    lextr=uvin%user_array
  endif  
  call gr_exec ('CLEAR DIRECTORY')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-lextr,lextr,-lextr,lextr
  call gr_exec1(chain)
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('TICKS 0 0 0 0 ')
  if (error .or. freq.eq.0.0) then
    error = .false.
    freq = 0.0
    call gr_exec1('BOX')
  else
    call uvbox (lextr,freq)
  endif
  !
end subroutine uv_reset_plot
!
subroutine uv_get_arraysize(rname,fsta,arr,nign,off,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>uv_get_arraysize
  !---------------------------------------------------------------------
  ! @ private
  !
  ! extract useful info from station file
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  character(len=*), intent(in) :: fsta   ! station file name
  real(kind=4), intent(inout) :: arr        !
  integer(kind=4), intent(inout) :: nign
  real(kind=4), intent(inout) :: off(4) ! offset wrt to origin to plot positions of stations
  logical, intent(inout) :: error 
  ! Local
  integer(kind=4) :: ier,lun,iequal,i
  character(len=256) :: mess,clu
  !
  ier = sic_getlun (lun)
  ier = sic_open(lun,fsta,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fsta
    call astro_message(seve%e,rname,trim(mess))
    goto 998
  endif
  if (obsname.eq.'BURE'.or.obsname.eq.'NOEMA'.or.obsname.eq.'SMA') then
    read (lun,*,iostat=ier) arr
    nign=1
    off(1) = 0
    off(2) = 0
    off(3) = 0
    off(4) = 0
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
  else if (obsname.eq.'ALMA'.or.obsname.eq.'ACA') then
    ! Patch for ALMA configuration files
    ! Skip first 7 lines:
    do i=1,7
      read(lun,*,iostat=ier)
      if (ier.ne.0)  then
        write (mess,'(a,1x,a)') 'Troubles reading header part of',fsta
        call astro_message(seve%e,rname,mess)
        write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
        call astro_message(seve%e,rname,mess)
        goto 998
      endif
    enddo
    read(lun,'(a)',iostat=ier) clu
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline line in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
    iequal = index(clu,'=')
    read(clu(iequal+1:),*,iostat=ier)  arr
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call astro_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call astro_message(seve%e,rname,mess)
      goto 998
    endif
    arr = arr*1.2
    nign=9
    if (obsname.eq.'ALMA') then
      off(1) = 0
      off(2) = 0
      off(3) = -660
      off(4) = -660
    else if (obsname.eq.'ACA') then
      off(1) = -52
      off(2) = -52
      off(3) = -570
      off(4) = -570
    endif
  endif
  close(unit=lun)
  call sic_frelun (lun)
  return
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  return
  !
end subroutine uv_get_arraysize
!
subroutine astro_uv_legend(rname,lfreq,decs,stalis,oldlis,del_mess,nused, count, nc,nces,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use astro_interfaces, except_this=>astro_uv_legend
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! draw the legend (stations used, declination, frequency)
  ! at the right place according to the plot_page orientation
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   ! command name
  real(kind=8), intent(in) :: lfreq         ! Frequency
  real(kind=8), intent(in) :: decs         ! Declination [radian]
  character(len=*), intent(in) :: stalis   !list of used stations
  integer(kind=4), intent(in) :: nces     !positions to split the displayed line if needed
  character(len=*), intent(in) :: oldlis   !previous list of used stations
  character(len=*), intent(in) :: del_mess   !message about delay if present
  integer(kind=4), intent(in) :: nused     ! number of used stations
  integer(kind=4), intent(inout) :: count  !
  integer(kind=4), intent(in) :: nc        !
  logical, intent(inout) :: error 
  ! Local
  real(kind=4) :: px
  real(kind=8) :: ddec,dy,mjd
  logical :: err
  character(len=200) :: chain,stafile
  integer(kind=4) :: ier,lb,iy,im,id
  !
  call sic_get_real('page_x',px,err)
  if (px.ge.30) then !landscape
     call gr_exec('SET BOX 20 30 3 9')
  else ! portrait
     call gr_exec('SET BOX 12 20 20 26')
  endif
  call gr_exec('limits 0 10 0 10')
  if (lfreq.gt.1e3) then
     write(chain,102) clight/lfreq/1d3
  else
     write(chain,100) lfreq
  endif
  call gr_exec('set char 0.5')
  call gr_exec1(chain)
  if (source_incoord.eq."EQ") then
    lb=len(source_inbetasexa)
    call sic_sexa(source_inbetasexa,lb,ddec,error)
    write(chain,101) source_ineq,ddec !write in degrees
  else
    mjd=source_jutc-2400000.5
    call gag_mjd2gregorian(mjd,iy,im,id,error)
    dy=iy+im/12.
    write(chain,101)  dy,sngl(decs*180d0/pi) !write in degrees
  endif
  call gr_exec1(chain)
  if (len_trim(del_mess).gt.0) then
    write(chain,103) trim(del_mess)
    call gr_exec1(chain)
  endif
  call gr_exec('set char /def')
100   format ('DRAW TEXT 1 1 "Frequency ',f5.1,' GHz" 6 /user')
102   format ('DRAW TEXT 1 1 "Wavelength ',f6.3,' microns" /user')
101   format ('DRAW TEXT 1 0 "Dec EQ ',f7.1,' ',f5.1,' ^" 6 /user ')
103   format ('DRAW TEXT 1 2 "',a,' ^" 6 /user ')

  !
  ! Plot on two lines when more than 6 stations (and less than 13)
  call gr_exec('set char 0.4')
  if (oldlis.ne.stalis) then
    if (nused.gt.12.or.stalis.eq."ALL STATIONS") then !ALMA or other observatory?
      count = count+2
      if (stalis.eq."ALL STATIONS") then
        chain = 'DRAW TEXT 1 1234 "'//stalis//'"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
      else
        chain = 'DRAW TEXT 1 1234 "More than 12 antennas"   6 /user'
        write(chain(13:16),'(I4)') count
        call gr_exec1 (chain)
      endif
      count = count+1
      ier = sic_getlog('ASTRO_STATIONS',stafile)
      if (ier.ne.0) then
        call astro_message(seve%e,rname,  &
             'Failure in translation of ASTRO_STATIONS logical')
        error = .true.
        return
      endif
      chain = 'DRAW TEXT 1 1234 "'//trim(stafile)//'"   6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    else if (nused.le.6) then !PDB = 1 line
      count = count+4
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    else if (nused.le.12) then !NOEMA = 2 lines
      count = count+2
      chain = 'DRAW TEXT 1 1234 -"'//stalis(nces+1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
      count = count+1
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nces) //'" 6 /user'
      write(chain(13:16),'(I4)') count
      call gr_exec1 (chain)
    endif
  endif
  call gr_exec('set char /def')
  !
end subroutine astro_uv_legend
!
subroutine uvbox(base,freq)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: base  ! Baseline length
  real(kind=8), intent(in) :: freq  ! Frequency
  ! Global
  logical, external :: gr_error
  ! Local
  real(kind=4) :: x
  character(len=80) :: chain
  !
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) return
  x = base*freq*1d6/clight
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  chain = 'DRAW TEXT 0 2.5 "U (k'//char(92)//'gl)" 5 /CHARACTER 8'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 90.0')
  chain = 'DRAW TEXT 2.0 0 "V (k'//char(92)//'gl)" 5 /CHARACTER 6'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 0')
  call gr_exec1('AXIS XU /LABEL P')
  call gr_exec1('AXIS YR /LABEL O')
  x = base
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL')
  call gr_exec1('LABEL "U (meters)" /X')
  call gr_exec1('SET ORIENT 90.0')
  call gr_exec1('DRAW TEXT -2.0 0 "V (meters)" 5 /CHARACTER 4')
  call gr_exec1('SET ORIENT 0')
end subroutine uvbox
!
subroutine astro_close_table(x)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! To be re-written using
  !    gdf_write_image(header,array,error)
  ! AND may be also
  !    gdf_close_image(header,error)
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x  !
  ! Local
  logical :: error
  !
  error = .false.
  call gdf_close_image(x,error)
end subroutine astro_close_table
!
subroutine astro_extend_table(x,name,nvis,dec,freq,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Re-written for new Imgage I/O interface
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to add
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ASTRO_UV'
  character(len=80) :: chain
  integer(kind=index_length) :: mvis
  !
  call gildas_null(x, type='UVT')
  x%file = name
  x%loca%read = .false.
  !
  call gdf_read_gildas(x,name,'.uvt',error, data=.false.)
  if (error) return
  !! call gio_lsis(error)
  !! read(5,*) i
  call gdf_close_image(x,error)
  !
  ! Couple of checks
  if (abs(x%gil%dec-dec).gt.1d-6) then
    call astro_message(seve%e,rname,'Different declinations')
    error = .true.
  endif
  if (freq.ne.0.0 .and. (abs(freq-x%gil%freq*1d-3).gt.1d-6)) then
    call astro_message(seve%e,rname,'Different frequencies')
    error = .true.
  endif
  if (error) goto 100
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) x%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call astro_message(seve%i,rname,chain)
  !
  mvis = x%gil%dim(2)+nvis
  !
  call gdf_extend_image (x,mvis,error)
  if (error) goto 100
  !
  x%gil%nvisi = mvis  ! Update number of visibilities
  call gdf_update_header(x,error)
  !
  ! Map only new region
  x%blc(1) = 1
  x%blc(2) = x%gil%dim(2)+1-nvis
  x%trc(1) = x%gil%dim(1)
  x%trc(2) = x%gil%dim(2)
  return
  !
  100   call astro_message(seve%e,rname,'Table extension failed')
end subroutine astro_extend_table
!
subroutine astro_init_table(x,name,nvis,dec,freq,band,obs,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x      ! Image structure
  character(len=*), intent(in)    :: name   ! File name
  integer(kind=4),  intent(in)    :: nvis   ! Number of visibilities to write
  real(kind=8),     intent(in)    :: dec    ! Declination
  real(kind=8),     intent(in)    :: freq   ! Frequency
  real(kind=4),     intent(in)    :: band   ! Frequency resolution
  character(len=*), intent(in)    :: obs    ! Current observatory
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  real(kind=8) :: dummy(3)
  !
  error = .false.
  !
  ! Create new file
  call gildas_null(x, type = 'UVT')
  x%file = name
  x%gil%convert(1,1) = 1.0
  x%gil%convert(3,1) = 1.0
  x%gil%blan_words = 2
  x%gil%extr_words = 0
  x%gil%bval = -1.0
  x%gil%eval = 0.
  x%gil%dim(2) = nvis
  x%gil%dim(1) = 10  ! 7 daps + (real, imag, weight)*nchannels
  !
  x%gil%ndim = 2
  x%char%unit = 'Jy'
  x%char%syst = 'EQUATORIAL'
  x%char%name = ' '
  x%gil%ra = 0.0
  x%gil%dec = dec
  x%gil%epoc = 2000.0
  x%char%line = ' '
  x%gil%fres = band
  if (freq.ne.0d0) then
    x%gil%fima = 0.0
    x%gil%freq = freq*1d3
  else
    x%gil%fima = 102d3
    x%gil%freq = 90d3
  endif
  x%gil%convert(2,1) = x%gil%freq
  x%gil%vres = -299792.458*x%gil%fres/x%gil%freq
  x%gil%voff = 0.0
  x%gil%faxi = 1
  x%loca%size = x%gil%dim(1) * x%gil%dim(2)
  x%gil%nvisi = x%gil%dim(2)
  x%gil%nchan = 1
  !
  call gdf_addteles(x,'TELE',obs,dummy,error)
  if (error)  return
  !
  call gdf_create_image(x,error)
  x%blc = 0
  x%trc = 0
end subroutine astro_init_table
!
subroutine fill_table (u,v,w,d,t,ideb,ifin,visi,el,wkey)
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: u         ! U coordinate
  real(kind=4),    intent(in)  :: v         ! V
  real(kind=4),    intent(in)  :: w         ! W
  real(kind=4),    intent(in)  :: d         ! Date
  real(kind=4),    intent(in)  :: t         ! Time
  integer(kind=4), intent(in)  :: ideb      ! Start Antenna
  integer(kind=4), intent(in)  :: ifin      ! End Antenna
  real(kind=4),    intent(out) :: visi(10)  ! Visibility
  real(kind=8),    intent(in)  :: el        ! Elevation
  integer(kind=4), intent(in)  :: wkey      ! Code for Weights
  !
  ! 7 parameters:
  !  U, V, W, Date, Time, Ant1, Ant2
  ! 3 values:
  !  Real, Imag, Weight
  !  1.0, 0.0, 1.0
  !
  visi(1) = u
  visi(2) = v
  visi(3) = w
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = 1.0
  visi(9) = 0.0
  if (wkey.eq.1) then
     visi(10) = 1.0
  elseif (wkey.eq.2) then
     visi(10) = sin(el)**2
  elseif (wkey.eq.3) then
     visi(10) = uvweight
  endif
end subroutine fill_table
!
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: mat(3,3)  !
  real(kind=8),    intent(in)  :: a(3)      !
  real(kind=8),    intent(out) :: b(3)      !
  integer(kind=4), intent(in)  :: n         !
  ! Local
  integer(kind=4) :: i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end subroutine matmul
!
subroutine amset(obslat,amat)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !   subroutine to provide transformation matrix from hour angle - dec
  !       into azimuth - elevation.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: obslat   ! in degrees
  real(kind=8), intent(out) :: amat(9)  !
  ! Local
  real(kind=8) :: x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end subroutine amset
!
subroutine dangle(along,alat,a)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in deg_to_radrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: along  !
  real(kind=8), intent(out) :: alat   !
  real(kind=8), intent(in)  :: a(3)   !
  ! Local
  real(kind=8) :: aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along = datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end subroutine dangle
!
subroutine astro_setuv_weight(el)
  use gildas_def
  use gkernel_interfaces
  use atm_params
  use atm_interfaces_public
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! ATM - using global astro variables
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: el
  !
  real(4) :: w
  real(4) :: frequ
  integer :: ier
  !
  airmass = 1./sin(el)
  h0 = altitude
  !
  p1 = p0*2.0**(-h0/5.5)     ! Pressure at altitude H0
  call atm_atmosp(t0,p1,h0)
  !
  if (gim.ne.0) then
    frequ = freqi
    call atm_transm(water,airmass,frequ,temii,tatmi,tauox,tauw,taut,ier)
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / (1.0+gim)
    tsys = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  else
    frequ = freqs
    call atm_transm(water,airmass,frequ,temis,tatms,tauox,tauw,taut,ier)
    !
    tant = feff*temis+(1.0-feff)*t0 + trec
    tsys = exp(taut*airmass) * (feff*temis+(1.0-feff)*t0 + trec) / feff
  endif
  !
  ! Need  Integration time
  ! Need  Bandwidth
  ! Need  Antenna Jy/K conversion factor
  w = jy_per_k*tsys/sqrt(bandwidth * inttime)
  uvweight = 1./w**2
end subroutine astro_setuv_weight
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! This file contains the outimage_tool module before implementing the
! PARAMETERS command.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_outimage_tool
  use cube_types
  use cubedag_allflags
  use cubeadm_cubeprod_types
  use cubefit_messaging
  use cubefit_parameters
  !
  public :: nsig,nvari
  public :: jcol_flag,jcol_signal,jcol_noise,jcol_snr
  public :: jcol_rmsbase,jcol_rmsspec,jcol_rmsline
  public :: jcol_method,jcol_nfunc
  public :: outimage_t
  private
  !
  integer(kind=4), parameter :: nsig  = 2
  integer(kind=4), parameter :: nvari = 4
  integer(kind=4), parameter :: jcol_flag    = 1
  integer(kind=4), parameter :: jcol_signal  = 2
  integer(kind=4), parameter :: jcol_noise   = 3
  integer(kind=4), parameter :: jcol_snr     = 4
  integer(kind=4), parameter :: jcol_rmsline = +1
  integer(kind=4), parameter :: jcol_rmsbase = +2
  integer(kind=4), parameter :: jcol_rmsspec = -1 ! Fit RMS
  integer(kind=4), parameter :: jcol_method  = -2 ! Fit Method
  integer(kind=4), parameter :: jcol_nfunc   = -3 ! Fit number of components
  !
  type outimage_t
     type(cube_t), pointer :: cube
     type(cube_prod_t)     :: prod
     character(len=unit_l) :: unit
   contains
     procedure, public :: init  => cubefit_parameters_outimage_init
     procedure, public :: clone => cubefit_parameters_outimage_clone
  end type outimage_t
  !
contains
  !
  subroutine cubefit_parameters_outimage_init(out,imeth,ifunc,jcol,iout,prod,error)
    use gkernel_interfaces
    use cubefit_spectral_fit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(outimage_t), intent(inout) :: out
    integer(kind=4),   intent(in)    :: imeth
    integer(kind=4),   intent(in)    :: ifunc
    integer(kind=4),   intent(in)    :: jcol
    integer(kind=4),   intent(in)    :: iout
    type(cube_prod_t), intent(in)    :: prod  ! Output cube description (reference)
    logical,           intent(inout) :: error
    !
    type(flag_t) :: signoiflag(nvari),sigmaflags(nsig),flags(3)
    character(len=*), parameter :: rname='PARAMETERS>OUTIMAGE>INIT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    signoiflag(:) = [flag_flag,flag_signal,flag_noise,flag_snr]
    sigmaflags(:) = [flag_base,flag_line]
    !
    call prod%copy(out%prod,error)
    if (error)  return
    !
    select case(jcol)
    case(jcol_rmsspec)
      ! Pre-defined flags are fit,parameters,*,noise,*
       call cubefit_parameters_flags(imeth,1,flags(1),flags(2),flags(3),error)
       if (error) return
       call out%prod%flag_to_flag(flag_any,flags(1),error)  ! Replace 1st *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,sigmaflags(iout),error)  ! Replace 2nd *
       if (error)  return
       out%unit = strg_id ! Sigma has the same unit as the original cube 
    case(jcol_nfunc)
       ! Pre-defined flags are fit,parameters,nlines (no change needed)
       out%unit = '---' ! No unit for number of lines
    case(jcol_method)
       ! Pre-defined flags are fit,parameters,method (no change needed)
       out%unit = '---' ! No unit for method
    case default
       ! Pre-defined flags are fit,parameters,*,*,*,*
       call cubefit_parameters_flags(imeth,jcol,flags(1),flags(2),flags(3),error)
       if (error) return
       if (ifunc.ne.0) then
          call cubefit_func2flag(ifunc,flags(3),error)
          if (error) return
       endif
       call out%prod%flag_to_flag(flag_any,flags(1),error)  ! Replace 1st *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,flags(2),error)  ! Replace 2nd *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,flags(3),error)  ! Replace 3rd *
       if (error)  return
       call out%prod%flag_to_flag(flag_any,signoiflag(iout),error)  ! Replace 4th *
       if (error)  return
       if (iout.eq.2.or.iout.eq.3) then
          ! Signal and noise have the same unit as the data
          call cubefit_parameters_units(imeth,jcol,out%unit,error)
          if (error) return
       else
          ! Flag and snr have no unit
          out%unit = '---'
       endif
    end select
  end subroutine cubefit_parameters_outimage_init
  !
  subroutine cubefit_parameters_outimage_clone(ou,incube,error)
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(outimage_t),     intent(inout) :: ou
    type(cube_t), pointer, intent(in)    :: incube
    logical,               intent(inout) :: error
    !
    character(len=unit_l) :: unit
    character(len=*), parameter :: rname='PARAMETERS>OUTIMAGE>CLONE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(ou%prod,incube,ou%cube,error)
    if (error) return
    call cubetools_header_nullify_axset_c(ou%cube%head,error)
    if (error) return
    if (ou%unit.ne.strg_id) then
       if (ou%unit(1:1).eq.strg_add) then
          call cubetools_header_get_array_unit(ou%cube%head,unit,error)
          if (error) return
          unit = trim(unit)//'.'//ou%unit(2:)
          call cubetools_header_put_array_unit(unit,ou%cube%head,error)
          if (error) return
       else
          call cubetools_header_put_array_unit(ou%unit,ou%cube%head,error)
          if (error) return
       endif
    endif
  end subroutine cubefit_parameters_outimage_clone
end module cubefit_outimage_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_command_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubefit_messaging
  use cubefit_parameters
  use cubefit_selection
  use cubefit_outimage_tool
  !
  public :: parameters
  private
  !
  integer(kind=chan_k), parameter :: one   = 1
  !
  type :: parameters_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(selection_opt_t)       :: select
     type(cube_prod_t),  pointer :: method
     type(cube_prod_t),  pointer :: nfuncs
     type(cube_prod_t),  pointer :: sigmas  ! One for all, adapted at run time
     type(cube_prod_t),  pointer :: output  ! One for all, adapted at run time
   contains
     procedure, public  :: register => cubefit_parameters_register
     procedure, private :: parse    => cubefit_parameters_parse
     procedure, private :: main     => cubefit_parameters_main
  end type parameters_comm_t
  type(parameters_comm_t) :: parameters
  !
  type parameters_user_t
     type(cubeid_user_t)    :: cubeids
     type(selection_user_t) :: sele
   contains
     procedure, private :: toprog => cubefit_parameters_user_toprog
  end type parameters_user_t
  !
  type parameters_prog_t
     type(cube_t),      pointer     :: incube
     type(selection_prog_t)         :: sele
     integer(kind=4)                :: nmeth
     integer(kind=4)                :: methhash(nmeth)
     integer(kind=npar_k)           :: npara(nmeth)
     integer(kind=4),   allocatable :: parahash(:,:)
     type(outimage_t),  allocatable :: output(:,:,:)
     logical,           allocatable :: ispos(:,:)
     real(kind=coor_k), allocatable :: reso(:)
     type(outimage_t),  allocatable :: sigmas(:,:)
     type(outimage_t)               :: method
     type(outimage_t)               :: nfuncs
   contains
      procedure, private :: header  => cubefit_parameters_prog_header
      procedure, private :: data    => cubefit_parameters_prog_data
      procedure, private :: loop    => cubefit_parameters_prog_loop
      procedure, private :: act     => cubefit_parameters_prog_act
  end type parameters_prog_t
  !
contains
  !
  subroutine cubefit_parameters_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(parameters_user_t) :: user
    character(len=*), parameter :: rname='PARAMETERS>COMMAND'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call parameters%parse(line,user,error)
    if (error) return
    call parameters%main(user,error)
    if (error) return
  end subroutine cubefit_parameters_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_register(parameters,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(inout) :: parameters
    logical,                  intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='PARAMETERS>REGISTER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'PARAMETERS','[fitid]',&
         'Extract maps of fitted quantities from a fit-results cube',&
         'Turn the fit-results cube produced by FIT\MINIMIZE into maps of&
         & fitted quantities.&
         & PARAMETERS reads, for each spectrum, the stored fit family,&
         & number of components, noise estimates, and fitted parameters,&
         & then writes summary maps and parameter products that can be&
         & inspected like ordinary CUBE data.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- The exact parameter maps depend on the fit family stored in the&
         & input fit-results cube. They can represent quantities such as area,&
         & velocity, linewidth, opacity, or shell parameters.'//strg_cr//&
         '- /SELECT can keep all fitted methods and components or isolate&
         & one method and optional component. Outputs that do not match the&
         & selection are written as NaN.'//strg_cr//&
         '- SNR maps use value divided by fit error for most parameters. For&
         & frequency and velocity parameters, SNR uses spectral resolution&
         & divided by fit error.'//strg_bl//&
         'Additional output(s):'//strg_cr//&
         '- METHOD: code of the fitted profile family in each spectrum.'&
         //strg_cr//&
         '- NLINES: number of fitted components in each spectrum.'//strg_cr//&
         '- NOISE: RMS maps for the baseline or fitted-line channels of the&
         & selected family.'//strg_cr//&
         '- PARAMETER: per-method maps of flag, fitted value, formal error,&
         & and SNR for each decoded parameter.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> PARAMETERS fit'//strg_cr//&
         'CUBE> PARAMETERS fit /SELECT GAUSSIAN 1'//strg_cr//&
         'These examples reuse the same fit-results cube with different&
         & /SELECT filters.',&
         cubefit_parameters_command,&
         parameters%comm,error)
    if (error) return
    call cubearg%register(&
         'FITID',&
         'Identifier for the fit-results cube',&
         'If omitted, use the last matching cube (fit,minimize flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_fit,flag_minimize],&
         code_read,&
         ! %toprog() needs to first access the data in imaset;
         ! %data() will change it for speset iteration afterwards.
         code_access_imaset,&
         parameters%incube,&
         error)
    if (error) return
    call parameters%select%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'METHOD',&
         'The fitting method code',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_method],&
         parameters%method,&
         error)
    if (error) return
    call oucube%register(&
         'NLINES',&
         'The number of fitted lines',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_nlines],&
         parameters%nfuncs,&
         error)
    if (error) return
    call oucube%register(&
         'NOISE',&
         'The base or line noise image',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_any,flag_noise,flag_any],&
         parameters%sigmas,&
         error)
    if (error) return
    call oucube%register(&
         'PARAMETER',&
         'The fitted parameters (as many as needed)',&
         strg_emp,&
         [flag_fit,flag_parameters,flag_any,flag_any,flag_any,flag_any],&
         parameters%output,&
         error)
    if (error) return
  end subroutine cubefit_parameters_register
  !
  subroutine cubefit_parameters_parse(parameters,line,user,error)
    !----------------------------------------------------------------------
    ! PARAMETERS cubname
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(in)    :: parameters
    character(len=*),         intent(in)    :: line
    type(parameters_user_t),  intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='PARAMETERS>PARSE'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,parameters%comm,user%cubeids,error)
    if (error) return
    call parameters%select%parse(line,user%sele,error)
    if (error) return
  end subroutine cubefit_parameters_parse
  !
  subroutine cubefit_parameters_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_comm_t), intent(in)    :: comm
    type(parameters_user_t),  intent(in)    :: user
    logical,                  intent(inout) :: error
    !
    type(parameters_prog_t) :: prog
    character(len=*), parameter :: rname='PARAMETERS>MAIN'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(error)
    if (error) return    
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubefit_parameters_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_user_toprog(user,comm,prog,error)
    use gkernel_interfaces
    use cubetools_nan
    use cubetools_shape_types
    use cubetools_header_methods
    use cubedag_allflags
    use cubeadm_taskloop
    use cubeadm_opened
    use cubeadm_get
    use cubeadm_image_types
    use cubefit_spectral_fit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_user_t), intent(in)    :: user
    type(parameters_comm_t),  intent(in)    :: comm
    type(parameters_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    type(shape_t) :: n
    type(flag_t) :: methflag,funcflag,paraflag
    type(image_t) :: method,imnfuncs,status
    type(cubeadm_iterator_t) :: iter
    logical :: loop,found,meth_prob,nfunc_prob,round_prob
    integer(kind=4) :: nfuncs(nmeth),nfunc,imeth,maxpar,ier,iout,icol,jcol,ifunc,stat
    integer(kind=chan_k) :: nout,nmax
    integer(kind=pixe_k) :: ix,iy
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PARAMETERS>USER>TOPROG'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call comm%select%user2prog(user%sele,prog%sele,error)
    if (error) return
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call method%associate('method',prog%incube,iter,error)
    if (error) return
    call imnfuncs%associate('imnfuncs',prog%incube,iter,error)
    if (error) return
    call status%associate('status',prog%incube,iter,error)
    if (error) return
    !
    loop = cubeadm_dataiterate_all(iter,error)  ! ZZZ we should ensure we get
      ! planes icol_method, icol_nfunc, icol_status. Probably by iterating
      ! until they are all iterated.
    if (error)  return
    ! call cubeadm_io_iterate(icol_status,icol_nfunc,prog%incube,error)
    ! if (error) return
    call method%get(icol_method,error)
    if (error) return
    call imnfuncs%get(icol_nfunc,error)
    if (error) return
    call status%get(icol_status,error)
    if (error) return
    !
    meth_prob  = .false.
    nfunc_prob = .false.
    round_prob = .false.
    nfuncs(:) = 0
    do iy=1,method%ny
       do ix=1,method%nx
          if (ieee_is_nan(status%val(ix,iy))) cycle
          stat  = nint(status%val(ix,iy))
          if (stat.eq.code_status_diverged) cycle
          imeth = nint(method%val(ix,iy))
          nfunc = nint(imnfuncs%val(ix,iy))
          round_prob = round_prob .or.(abs(nfunc-imnfuncs%val(ix,iy)).gt.1e-6)
          round_prob = round_prob .or.(abs(imeth-method%val(ix,iy)).gt.1e-6)
          meth_prob  = meth_prob  .or. (imeth.le.0.or.imeth.gt.nmeth)
          nfunc_prob = nfunc_prob .or. (nfunc.le.0.or.nfunc.gt.mfunc)
          if (nfunc.gt.nfuncs(imeth)) then
             nfuncs(imeth) = nfunc
          endif
       enddo ! ix
    enddo ! iy
    !
    if (meth_prob) then
       call cubefit_message(seve%e,rname,'Method description contains unrecognized methods')
       error = .true.
    endif
    if (nfunc_prob) then
       call cubefit_message(seve%e,rname,'Number of lines description goes beyond bounds')
       write(mess,'(a,i0,a)') 'Number of lines goes greater than ',mfunc,' and/or less than 0'
       call cubefit_message(seve%e,rname,mess)
       error = .true.
    endif
    if (round_prob) then
       call cubefit_message(seve%e,rname,'Cube does not contain a proper description of a fit')
       error = .true.
    endif
    if (error) return
    !
    if (prog%sele%ifunc.gt.maxval(imnfuncs%val)) then
       write (mess,'(2(a,i0))') 'Line ',prog%sele%ifunc,' Goes beyond the maximum of lines found: ',&
            nint(maxval(imnfuncs%val))
       call cubefit_message(seve%w,rname,mess)
    endif
    !
    nmax = 0
    if (prog%sele%imeth.eq.code_method_all) then
       ! All Methods are to be used
       prog%nmeth     = 0
       prog%methhash(:) = 0
       prog%npara(:)     = 0 
       do imeth=1,nmeth
          if (nfuncs(imeth).gt.0) then
             prog%nmeth = prog%nmeth+1
             prog%methhash(imeth) = prog%nmeth
             call cubefit_parameters_npars_nout(imeth,nfuncs(imeth),prog%npara(imeth),nout,error)
             if (error) return
             if (nout.gt.nmax) nmax = nout
          endif
       enddo
    else
       ! A single method is to be used
       prog%nmeth = 1
       prog%methhash(:) = 0
       prog%npara(:)      = 0
       found = .false.
       do iy=1,method%ny
          do ix=1,method%nx
             if (method%val(ix,iy).eq.prog%sele%imeth) found = .true.
          enddo ! ix
       enddo ! iy
       if (.not.found) call cubefit_message(seve%w,rname,'Method '//trim(prog%sele%meth)&
            //' Not found in fit')
       prog%methhash(prog%sele%imeth) = 1
       call cubefit_parameters_npars_nout(prog%sele%imeth,nfuncs(imeth),prog%npara(prog%sele%imeth),nout,error)
       if (error) return
       if (nout.gt.nmax) nmax = nout
    endif
    maxpar = maxval(prog%npara)
    !
    call cubetools_header_get_array_shape(prog%incube%head,n,error)
    if (error) return
    if (nmax.gt.n%c) then
       call cubefit_message(&
            fitseve%trace,rname,&
            'Number of channels in cube is inferior to what is expected')
       error = .true.
       return
    endif
    !
    allocate(prog%output(prog%nmeth,maxpar,nvari),prog%sigmas(prog%nmeth,nvari),&
         prog%parahash(nmeth,maxpar),prog%ispos(prog%nmeth,maxpar),prog%reso(prog%nmeth),stat=ier)
    if (failed_allocate(rname,'Parameters cubes',ier,error)) return
    !
    prog%parahash(:,:) = 0
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       do iout=1,nsig
          call prog%sigmas(prog%methhash(imeth),iout)%init&
               (imeth,prog%sele%ifunc,jcol_rmsspec,iout,comm%sigmas,error)
          if (error) return
       enddo
       jcol = 0
       do icol=1,prog%npara(imeth)
          call cubefit_parameters_flags(imeth,icol,methflag,funcflag,paraflag,error)
          if (error) return
          if (prog%sele%ifunc.ne.0) then
             call cubefit_flag2func(funcflag,ifunc,error)
             if (error) return
             if (ifunc.eq.prog%sele%ifunc) then
                jcol = jcol+1
                prog%parahash(imeth,icol) = jcol
             endif
          else
             prog%parahash(imeth,icol) = icol
          endif
          prog%ispos(prog%methhash(imeth),prog%parahash(imeth,icol)) = &
            (paraflag.eq.flag_velocity) .or. (paraflag.eq.flag_frequency)
       enddo
       if (imeth.eq.code_method_shell) then
          prog%reso(prog%methhash(imeth)) = prog%incube%head%spe%inc%f
       else
          prog%reso(prog%methhash(imeth)) = prog%incube%head%spe%inc%v
       endif
       if (imeth.eq.code_method_absorption.and.prog%sele%ifunc.gt.1) then
          prog%parahash(imeth,1) = 1
          do icol=2,size(prog%parahash(imeth,:))
             if (prog%parahash(imeth,icol).gt.0) prog%parahash(imeth,icol) = prog%parahash(imeth,icol)+1
          enddo
       endif
       do icol=1,prog%npara(imeth)
          jcol = prog%parahash(imeth,icol)
          if (jcol.gt.0) then
             do iout=1,nvari
                call prog%output(prog%methhash(imeth),jcol,iout)%init&
                     (imeth,prog%sele%ifunc,icol,iout,comm%output,error)
                if (error) return
             enddo
          endif
       enddo
    enddo
    call prog%nfuncs%init(0,0,jcol_nfunc,0,comm%nfuncs,error)
    if (error) return
    call prog%method%init(0,0,jcol_method,0,comm%method,error)
    if (error) return
    !
    call cubeadm_access_header(prog%incube,code_access_speset,code_read,error)
    if (error) return
  end subroutine cubefit_parameters_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubefit_parameters_prog_header(prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: imeth,iout,icol
    character(len=*), parameter :: rname='PARAMETERS>PROG>HEADER'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       do iout=1,nsig
          call prog%sigmas(prog%methhash(imeth),iout)%clone(prog%incube,error)
          if (error) return
       enddo ! iout
       do icol=1,prog%npara(imeth)
          if (prog%parahash(imeth,icol).gt.0) then
             do iout=1,nvari
                call prog%output(prog%methhash(imeth),prog%parahash(imeth,icol),iout)%clone(prog%incube,error)
                if (error) return
             enddo ! iout
          endif
       enddo ! icol
    enddo
    call prog%nfuncs%clone(prog%incube,error)
    if (error) return
    call prog%method%clone(prog%incube,error)
    if (error) return
  end subroutine cubefit_parameters_prog_header
  !
  subroutine cubefit_parameters_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    logical,                  intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PARAMETERS>PROG>DATA'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubefit_parameters_prog_data
  !
  subroutine cubefit_parameters_prog_loop(prog,iter,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    integer(kind=chan_k),parameter :: one = 1
    type(spectrum_t) :: inspec,oupoint,nanpoint,sigbas,siglin
    character(len=*), parameter :: rname='PARAMETERS>PROG>LOOP'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call inspec%reassociate_and_init(prog%incube,iter,error)
    if (error) return
    call oupoint%reallocate('oupoint',one,iter,error)
    if (error) return
    call nanpoint%reallocate('nanpoint',one,iter,error)
    if (error) return
    call sigbas%reallocate('sigbas',one,iter,error)
    if (error) return
    call siglin%reallocate('siglin',one,iter,error)
    if (error) return
    !
    nanpoint%t(one) = gr4nan
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,inspec,oupoint,nanpoint,sigbas,siglin,error)
      if (error) return
    enddo ! ie
  end subroutine cubefit_parameters_prog_loop
  !
  subroutine cubefit_parameters_prog_act(prog,ie,inspec,oupoint,nanpoint,sigbas,siglin,error)
    use cubetools_nan
    use cubetools_shape_types
    use cubetools_header_methods
    use cubemain_spectrum_real
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(parameters_prog_t), intent(inout) :: prog
    integer(kind=entr_k),     intent(in)    :: ie
    type(spectrum_t),         intent(inout) :: inspec
    type(spectrum_t),         intent(inout) :: oupoint
    type(spectrum_t),         intent(in)    :: nanpoint
    type(spectrum_t),         intent(inout) :: sigbas
    type(spectrum_t),         intent(inout) :: siglin
    logical,                  intent(inout) :: error
    !
    type(shape_t) :: n
    integer(kind=4) :: imeth,icol,iout,jmeth,jcol
    integer(kind=chan_k) :: ic
    real(kind=sign_K) :: outdata(nvari)
    character(len=*), parameter :: rname='PARAMETERS>PROG>ACT'
    !
    call cubefit_message(fitseve%trace,rname,'Welcome')
    !
    call inspec%get(prog%incube,ie,error)
    if (error) return
    !
    icol = 0
    iout = 0
    ! Store method image
    oupoint%t(one) = inspec%t(icol_method)
    call oupoint%put(prog%method%cube,ie,error)
    if (error) return
    ! Store Nlines image
    oupoint%t(one) = inspec%t(icol_nfunc)
    call oupoint%put(prog%nfuncs%cube,ie,error)
    if (error) return    
    sigbas%t(one) = inspec%t(icol_rmsbase)
    siglin%t(one) = inspec%t(icol_rmsline)
    do imeth=1,nmeth
       if (prog%methhash(imeth).eq.0) cycle
       jmeth = prog%methhash(imeth)
       if (nint(inspec%t(icol_method)).eq.imeth) then
          call siglin%put(prog%sigmas(jmeth,jcol_rmsline)%cube,ie,error)
          if (error) return
          call sigbas%put(prog%sigmas(jmeth,jcol_rmsbase)%cube,ie,error)
          if (error) return          
       else
          call nanpoint%put(prog%sigmas(jmeth,jcol_rmsline)%cube,ie,error)
          if (error) return
          call nanpoint%put(prog%sigmas(jmeth,jcol_rmsbase)%cube,ie,error)
          if (error) return   
       endif
    enddo ! imeth
    call cubetools_header_get_array_shape(prog%incube%head,n,error)
    if (error) return
    do ic=ndaps+1,n%c
       select case(mod(ic-ndaps,3))
       case(1)
          ! Flags and we have reached a new parameter
          icol = icol+1
          outdata(jcol_flag) = inspec%t(ic)
       case(2)
          ! Results
          outdata(jcol_signal) = inspec%t(ic)
       case(0)
          ! Errors and then export
          outdata(jcol_noise) = inspec%t(ic)
          do imeth=1,nmeth
             jmeth = prog%methhash(imeth)
             jcol  = prog%parahash(imeth,icol)
             if (jcol.eq.0.or.jmeth.eq.0) cycle
             if (outdata(jcol_noise).eq.0) then
                outdata(jcol_snr) = gr4nan
             else
                if (prog%ispos(jmeth,jcol)) then
                   outdata(jcol_snr) = prog%reso(jmeth)/outdata(jcol_noise)
                else
                   outdata(jcol_snr) = outdata(jcol_signal)/outdata(jcol_noise)
                endif
             endif
             if (nint(inspec%t(icol_method)).eq.imeth) then
                do iout=1,nvari
                   oupoint%t(one) = outdata(iout)
                   call oupoint%put(prog%output(jmeth,jcol,iout)%cube,ie,error)
                   if (error) return
                enddo ! iout
             else
                do iout=1,nvari
                   call nanpoint%put(prog%output(jmeth,jcol,iout)%cube,ie,error)
                   if (error) return
                enddo ! iout
             endif
          enddo ! imeth
       end select
    enddo ! ic
  end subroutine cubefit_parameters_prog_act
end module cubefit_command_parameters
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gmath_quicksort_types
  use gmath_messaging
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  public :: gi4_quicksort_t,gi8_quicksort_t
  private
  !
  type, abstract :: gi4_quicksort_t
  contains
    procedure(gi4_compare_interface), public, deferred :: compare
    procedure,                        public           :: sort => gi4_quicksort_index_with_user_type
  end type gi4_quicksort_t
  !
  type, abstract :: gi8_quicksort_t
  contains
    procedure(gi8_compare_interface), public, deferred :: compare
    procedure,                        public           :: sort => gi8_quicksort_index_with_user_type
  end type gi8_quicksort_t
  !
  abstract interface
    function gi4_compare_interface(self,m,l)
      import :: gi4_quicksort_t
      !-----------------------------------------------------------------
      ! Return -1, 0, or +1 if the m-th value is lower, equal, or
      ! greater than the l-th one.
      !-----------------------------------------------------------------
      integer(kind=4) :: gi4_compare_interface
      class(gi4_quicksort_t), intent(in) :: self
      integer(kind=4),        intent(in) :: m,l
    end function gi4_compare_interface
  end interface
  !
  abstract interface
    function gi8_compare_interface(self,m,l)
      import :: gi8_quicksort_t
      !-----------------------------------------------------------------
      ! Return -1, 0, or +1 if the m-th value is lower, equal, or
      ! greater than the l-th one.
      !-----------------------------------------------------------------
      integer(kind=4) :: gi8_compare_interface
      class(gi8_quicksort_t), intent(in) :: self
      integer(kind=8),        intent(in) :: m,l
    end function gi8_compare_interface
  end interface
  !
contains
  !
  subroutine gi4_quicksort_index_with_user_type(self,x,n,error)
    !---------------------------------------------------------------------
    ! Sort an integer*4 index array according to an external comparison
    ! criteria. The index array can then be used by gi4_quicksort_array
    ! to sort an associated array.
    !---------------------------------------------------------------------
    class(gi4_quicksort_t), intent(in)    :: self   !
    integer(kind=4),        intent(in)    :: n      ! Length of index array
    integer(kind=4),        intent(inout) :: x(n)   ! Index array to be sorted
    logical,                intent(out)   :: error  ! Error status
    ! Local
    integer(kind=4), parameter :: maxstack=1000, nstop=15
    integer(kind=4) :: temp,key
    integer(kind=4) :: i,j,k,l,r,m
    integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
    !
    include 'quicksort-index-with-user-type.inc'
   end subroutine gi4_quicksort_index_with_user_type
  !
  subroutine gi8_quicksort_index_with_user_type(self,x,n,error)
    !---------------------------------------------------------------------
    ! Sort an integer*8 index array according to an external comparison
    ! criteria. The index array can then be used by gi8_quicksort_array
    ! to sort an associated array.
    !---------------------------------------------------------------------
    class(gi8_quicksort_t), intent(in)    :: self   !
    integer(kind=8),        intent(in)    :: n      ! Length of index array
    integer(kind=8),        intent(inout) :: x(n)   ! Index array to be sorted
    logical,                intent(out)   :: error  ! Error status
    ! Local
    integer(kind=4), parameter :: maxstack=1000, nstop=15
    integer(kind=8) :: temp,key
    integer(kind=8) :: i,j,k,l,r,m
    integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
    !
    include 'quicksort-index-with-user-type.inc'
   end subroutine gi8_quicksort_index_with_user_type
end module gmath_quicksort_types

module gildas_tasks_io
  !---------------------------------------------------------------------
  ! Module private to this file
  !---------------------------------------------------------------------
  integer(kind=4) :: ilun,olun
  logical :: inter_state
end module gildas_tasks_io
!
subroutine gildas_open
  use gio_dependencies_interfaces
  use gildas_tasks_io
  use gio_headers
  use gio_interfaces, only : gdf_stbl
  !---------------------------------------------------------------------
  ! @ public
  ! GILDAS
  !       I/O routines for GILDAS tasks.
  !---------------------------------------------------------------------
  ! Local
  integer :: stbl,ier
  logical :: error
  character(len=16) :: chain
  !
  ! Standard FORTRAN unit number, but possible sharing problems
  ilun = 5
  olun = 6
  inter_state = .false.
  !
  if (code_version_gdf_current.lt.code_version_gdf_v20) then
    stbl = 1
  else
    stbl = 2
  endif
  ier = sic_getlog('GILDAS_HEADERS',stbl)
  error = .false.
  call gdf_stbl(stbl,error)
  chain = ' '
  ier = sic_getlog('UVT_VERSION',chain)
  if (chain.ne.' ') call gdf_set_uvt_version(chain)
end subroutine gildas_open
!
subroutine gildas_char (name,chain)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  character(len=*), intent(out) :: chain
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,101) name
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,100,iostat=ier) chain
  if (ier.ne.0) then
    call putios ('E-GILDAS_CHAR, '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
101 format(1x,'Character ',a)
end subroutine gildas_char
!
subroutine gildas_charn (name,string,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  character(len=*), intent(out) :: string(n)
  ! Local
  character(len=16) :: key
  integer :: ier,i
  !
  if (inter_state) then
    write(olun,101) name
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  do i=1,n
    read (ilun,100,iostat=ier) string(i)
    if (ier.ne.0) then
      call putios('E-GILDAS_CHAR,  '//key,ier)
      call sysexi (fatale)
    endif
  enddo
100 format(a)
101 format(1x,'Character ',a)
end subroutine gildas_charn
!
subroutine gildas_real_0d (name,areal,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_real_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_real
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=4),     intent(out) :: areal
  ! Local
  character(len=message_length) :: mess
  real(kind=4) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_REAL',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_real_1d (name,tmp,1)
  areal = tmp(1)
  !
end subroutine gildas_real_0d
!
subroutine gildas_real_1d (name,areal,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_real_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_real
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=4),     intent(out) :: areal(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Real',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) areal
  if (ier.ne.0) then
    call putios('E-GILDAS_REAL,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_real_1d
!
subroutine gildas_inte4_0d(name,ainte,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_inte4_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for scalar I*4 argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=4),  intent(out) :: ainte
  ! Local
  character(len=message_length) :: mess
  integer(kind=4) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_INTE',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_inte4_1d(name,tmp,1)
  ainte = tmp(1)
  !
end subroutine gildas_inte4_0d
!
subroutine gildas_inte4_1d(name,ainte,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_inte4_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for a 1D I*4 variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=4),  intent(out) :: ainte(n)
  ! Local
  character(len=16) :: key
  integer(kind=4) :: ier
  !
  if (inter_state) then
    write(olun,102) 'Integer ',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) ainte
  if (ier.ne.0) then
    call putios('E-GILDAS_INTE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_inte4_1d
!
subroutine gildas_inte8_1d(name,along,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_inte8_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_inte
  ! ---
  ! This version for a 1D I*8 variable
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  integer(kind=8),  intent(out) :: along(n)
  ! Local
  character(len=16) :: key
  integer(kind=4) :: ier
  !
  if (inter_state) then
    write(olun,102) 'Long ',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) along
  if (ier.ne.0) then
    call putios('E-GILDAS_INTE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_inte8_1d
!
subroutine gildas_logi_0d (name,alogi,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_logi_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_logi
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  logical,          intent(out) :: alogi
  ! Local
  character(len=message_length) :: mess
  logical :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_LOGI',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_logi_1d (name,tmp,1)
  alogi = tmp(1)
  !
end subroutine gildas_logi_0d
!
subroutine gildas_logi_1d (name,alogi,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_logi_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_logi
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  logical,          intent(out) :: alogi(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Logical',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) alogi
  if (ier.ne.0) then
    call putios('E-GILDAS_LOGI,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_logi_1d
!
subroutine gildas_dble_0d (name,adble,n)
  use gildas_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_dble_0d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_dble
  ! ---
  ! This version for scalar argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=8),     intent(out) :: adble
  ! Local
  character(len=message_length) :: mess
  real(kind=8) :: tmp(1)
  !
  if (n.ne.1) then
    write(mess,'(3A)')  'Internal error: argument ',trim(name),  &
      ' should be array, not scalar'
    call gio_message(seve%e,'GILDAS_DBLE',mess)
    call sysexi (fatale)
  endif
  !
  call gildas_dble_1d(name,tmp,1)
  adble = tmp(1)
  !
end subroutine gildas_dble_0d
!
subroutine gildas_dble_1d (name,adble,n)
  use gio_dependencies_interfaces
  use gildas_def
  use gildas_tasks_io
  use gio_interfaces, except_this=>gildas_dble_1d
  !---------------------------------------------------------------------
  ! @ public-generic gildas_dble
  ! ---
  ! This version for 1D array as argument
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name
  integer(kind=4),  intent(in)  :: n
  real(kind=8),     intent(out) :: adble(n)
  ! Local
  character(len=16) :: key
  integer :: ier
  !
  if (inter_state) then
    write(olun,102) 'Double',name,n
  else
    read (ilun,100) key
    if (key.ne.name)  call gildas_fatale(name)
  endif
  read (ilun,*,iostat=ier) adble
  if (ier.ne.0) then
    call putios('E-GILDAS_DBLE,  '//key,ier)
    call sysexi (fatale)
  endif
100 format(a)
102 format(1x,a,1x,a,1x,i4)
end subroutine gildas_dble_1d
!
subroutine gildas_close
  use gio_dependencies_interfaces
  use gildas_tasks_io
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  if (ilun.eq.5) return
  close (unit=ilun)
  call sic_frelun (olun)
end subroutine gildas_close
!
subroutine gildas_fatale(name)
  use gio_dependencies_interfaces
  use gildas_def
  use gio_interfaces, only : gio_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name
  !
  call gio_message(seve%f,'GILDAS_OPEN','Missing parameter '//name)
  call sysexi (fatale)
end subroutine gildas_fatale

subroutine condet (ndp,xd,yd,ncp,ipc)
  !---------------------------------------------------------------------
  ! @ public
  !	This subroutine selects several data points that are closest
  !	to each of the data point.
  ! Arguments :
  !	NDP	I	Number of data points
  !	XD	R*4 (*)	Arrays containing the X coordinates
  !             		of data points.
  !	YD	R*4 (*) Array of Y coordinates
  !	NCP	I	number of data points closest to each
  !			data point.
  !	IPC	I (*)	Array of dimension NCP*NDP, where the
  !			point numbers of NCP data points closest
  !			to each of the NDP data points are to be
  !			stored.
  !----------------------------------------------------------------------
  !
  ! this subroutine arbitrarily sets a restriction that NCP must
  ! not exceed 25 without modification to the arrays DSQ0 and IPC0.
  ! Declaration statements
  !---------------------------------------------------------------------
  integer :: ndp                    !
  real :: xd(ndp)                   !
  real :: yd(ndp)                   !
  integer :: ncp                    !
  integer :: ipc(*)                 !
  ! Local
  real :: dsq0(25)
  integer :: ipc0(25)
  !
  real :: x1, y1, dsqmx, dsqi, dx12, dy12, dx13, dy13, dsqmn
  integer :: ip1, ip2, jmx, j1, ip2mn, j3, ip3, nclpt, j4
  integer :: ip3mn, j2
  !
  ! Statement function
  !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
  !
  ! Calculation
  !
  do ip1=1,ndp
    !
    ! Selects NCP points.
    !
    x1 = xd(ip1)
    y1 = yd(ip1)
    j1 = 0
    dsqmx = 0.0
    do ip2=1,ndp
      if (ip2 .eq. ip1) cycle  ! IP2
      !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
      !            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
      dsqi = (xd(ip2)-x1)**2 + (yd(ip2)-y1)**2
      j1 = j1+1
      dsq0(j1) = dsqi
      ipc0(j1) = ip2
      if (dsqi .le. dsqmx) go to  100
      dsqmx = dsqi
      jmx = j1
100   if (j1 .ge. ncp) go to  120
    enddo                      ! IP2
120 ip2mn = ip2+1
    if (ip2mn .gt. ndp) go to  150
    do ip2=ip2mn,ndp
      if (ip2 .eq. ip1) cycle  ! IP2
      !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
      !            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
      dsqi = (xd(ip2)-x1)**2 + (yd(ip2)-y1)**2
      if (dsqi .ge. dsqmx) cycle   ! IP2
      dsq0(jmx) = dsqi
      ipc0(jmx) = ip2
      dsqmx = 0.0
      do j1=1,ncp
        if (dsq0(j1) .le. dsqmx) cycle ! J1
        dsqmx = dsq0(j1)
        jmx = j1
      enddo                    ! J1
    enddo                      ! IP2
    !
    ! Checks if all the NCP+1 points are collinear.
    !
150 ip2 = ipc0(1)
    dx12 = xd(ip2)-x1
    dy12 = yd(ip2)-y1
    do j3=2,ncp
      ip3 = ipc0(j3)
      dx13 = xd(ip3)-x1
      dy13 = yd(ip3)-y1
      if ((dy13*dx12-dx13*dy12) .ne. 0.0) go to  200
    enddo                      ! J3
    !
    ! Searches for the closest noncollinear point.
    !
    nclpt = 0
    do ip3=1,ndp
      if (ip3 .eq. ip1) cycle  ! IP3
      do j4=1,ncp
        if (ip3 .eq. ipc0(j4)) go to  190
      enddo                    ! J4
      dx13 = xd(ip3)-x1
      dy13 = yd(ip3)-y1
      if ((dy13*dx12-dx13*dy12) .eq. 0.0) cycle    ! IP3
      !      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
      !            DSQI = DSQF(X1,Y1,XD(IP3),YD(IP3))
      dsqi = (xd(ip3)-x1)**2 + (yd(ip3)-y1)**2
      if (nclpt .eq. 0) go to  180
      if (dsqi .ge. dsqmn) cycle   ! IP3
180   nclpt = 1
      dsqmn = dsqi
      ip3mn = ip3
190   continue
    enddo                      ! IP3
    dsqmx = dsqmn
    ipc0(jmx) = ip3mn
    !
    ! Replaces the local array for the output array.
    !
200 j1 = (ip1-1)*ncp
    do j2=1,ncp
      j1 = j1+1
      ipc(j1) = ipc0(j2)
    enddo
  enddo                        ! IP1
end subroutine condet

!-----------------------------------------------------------------------
! Support file for the magnify lens
!-----------------------------------------------------------------------
subroutine gtl_lens(line,error)
  use gtv_interfaces, except_this=>gtl_lens
  use gbl_message
  use gtv_buffers
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command LENS
  !  Invoke the lens and suspend execution until the lens has been
  ! closed.
  ! ---
  !  Thread status: safe for reading from main thread
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LENS'
  type(gt_directory), pointer :: dir_lens
  character(len=80) :: gpname
  integer(kind=4) :: nd
  integer(kind=address_length) :: genv
  !
  ! Non-sense if protocol is other than X
  if (cw_device%protocol.ne.p_x) then
    call gtv_message(seve%e,rname,'Available only with X device')
    error = .true.
    return
  endif
  !
  call gtv_open_segments_for_reading_from_main()
  !
  ! Invoke the lens in the current active window
  if (cw_directory%x%nbwin.eq.0) then
    ! No window here, zoom in first window of grand-pere
    dir_lens => cw_directory%ancestor
    call cree_chemin_dir(dir_lens,gpname,nd)
    call gtv_message(seve%i,rname,'Lens in directory '//gpname)
    !
    if (dir_lens%x%nbwin.eq.0) then
      call gtv_message(seve%e,rname,'No window found')
      error = .true.
      goto 100
    endif
  else
    ! Zoom in first window of current working directory
    dir_lens => cw_directory
  endif
  !
  genv = dir_lens%x%genv
  !
100 continue
  !
  call gtv_close_segments_for_reading_from_main()
  !
  if (error)  return
  !
  call x_lens(genv)
  !
end subroutine gtl_lens
!
subroutine lens_register(dir,genv_main,genv_lens,ier)
  use gildas_def
  use gtv_interfaces, except_this=>lens_register
  use gtv_protocol
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Register in the GTV structures the magnify lens which has already
  ! been opened. No need to create a new genv_array, there must be
  ! one since we zoom on an existing window.
  ! ---
  !  Thread status: safe to call from graphic thread.
  !---------------------------------------------------------------------
  type(gt_directory)                        :: dir        ! Parent directory
  integer(kind=address_length), intent(in)  :: genv_main  ! Genv of the window we zoom in
  integer(kind=address_length), intent(in)  :: genv_lens  ! Genv of the lens window
  integer(kind=4),              intent(out) :: ier        ! Error flag
  ! Local
  character(len=*), parameter :: rname='LENS_REGISTER'
  type(gt_display), pointer :: main_output,lens_output
  logical :: error,found
  !
  ier = 1  ! Error set
  error = .false.
  !
  ! Retrieve the parent output
  call get_slot_output_by_genv(genv_main,main_output,.true.,found,error)
  if (error)  return
  !
  ! Set a slot for the lens
  call get_free_slot_output(lens_output,error)
  if (error)  return
  !
  lens_output%dev => main_output%dev   ! Point on the shared X-protocol instance
  lens_output%color = .true.
  lens_output%background = lens_output%dev%background
  call x_display_reset(lens_output%x)  ! Default values
  lens_output%x%graph_env = genv_lens
  lens_output%x%name = 'LENS'
  !
  call create_window(lens_output,.false.,dir,.false.,.false.,error)
  if (error) then
    call gtv_message(seve%e,rname,'Cannot register new window')
    return
  endif
  !
  ier = 0  ! No error
  !
end subroutine lens_register
!
subroutine lens_limits(genv_main,genv_lens,pixxc,pixyc,zoom,ier)
  use gildas_def
  use gbl_message
  use gtv_interfaces, except_this=>lens_limits
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Redraw the lens according to the input center position (in pixels
  ! coordinates of the parent window) and the zooming factor.
  !---------------------------------------------------------------------
  integer(kind=address_length), intent(in)  :: genv_main  ! Genv of the window we zoom in
  integer(kind=address_length), intent(in)  :: genv_lens  ! Genv of the lens window
  integer, intent(in)  :: pixxc  ! X center (pixels)
  integer, intent(in)  :: pixyc  ! Y center (pixels)
  real,    intent(in)  :: zoom   ! Zoom factor
  integer, intent(out) :: ier    ! Error flag
  ! Local
  character(len=*), parameter :: rname='LENS'
  integer :: npixx,npixy
  real*4 :: wxc,wyc,wx,wy,wxz,wyz,wx1,wx2,wy1,wy2,gsclx,gscly
  type(gt_display), pointer :: main_output,lens_output
  logical :: error,found
  character(len=message_length) :: mess
  !
  ier = 1  ! Error set
  error = .false.
  !
  ! Find the lens instance
  call get_slot_output_by_genv(genv_lens,lens_output,.true.,found,error)
  if (error)  return
  !
  ! Find the parent window instance
  call get_slot_output_by_genv(genv_main,main_output,.true.,found,error)
  if (error)  return
  !
  ! Convert coordinates (center)
  call pixel_to_world(main_output,pixxc,pixyc,wxc,wyc)
  ! Convert coordinates (size)
  npixx = lens_output%px2
  npixy = max(lens_output%py1,lens_output%py2)
  call pixel_to_world_size(main_output,npixx/2.,npixy/2.,wx,wy)
  ! Apply zoom factor
  wxz = wx/zoom
  wyz = wy/zoom
  ! Compute X and Y ranges in world units
  wx1 = wxc-wxz
  wx2 = wxc+wxz
  if (lens_output%py1.lt.lens_output%py2) then
    wy1 = wyc-wyz
    wy2 = wyc+wyz
  else
    wy1 = wyc+wyz
    wy2 = wyc-wyz
  endif
  !
  ! Set the new clipping for the lens, redraw (in particular
  ! call gti_xforceupdate)
  if (wx1.ge.wx2 .or. wy1.ge.wy2) then
    print *,''
    call gtv_message(seve%w,rname,'Zoom limit reached. Nothing done.')
    !
    write(mess,101)  &
      'Center: X: ',pixxc,' px, Y: ',pixyc,' px (main window units)'
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,102)  &
      'Center: X: ',wxc,  ' cm, Y: ',wyc,  ' cm (paper units)'
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,102)  &
      'Half-width: X: ',npixx/2.,  ' px, Y: ',npixy/2.,  ' px (main window units)'
    call gtv_message(seve%w,rname,mess)
    !
    call get_scale_awd(main_output,gsclx,gscly)
    write(mess,102)  &
      'Scale: X: ',gsclx,  ', Y: ',gscly,  ' (px/cm)'
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,102)  &
      'Half-width (before): X: ',wx,  ' cm, Y: ',wy,  ' cm (paper units)'
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,102)  &
      'Zoom factor: ',zoom
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,102)  &
      'Half-width (zoomed): X: ',wxz,  ' cm, Y: ',wyz,  ' cm (paper units)'
    call gtv_message(seve%w,rname,mess)
    !
    write(mess,103)  &
      'Ranges: X: ',wx1,wx2,  ' cm, Y: ',wy1,wy2,  ' cm (paper units)'
    call gtv_message(seve%w,rname,mess)
    !
    return
  endif
  call sp_gtwindow(lens_output,wx1,wx2,wy1,wy2)
  !
  ier = 0
  !
101 format(a,i0,      a,i0,     a)
102 format(a,1pg14.7, a,1pg14.7, a)
103 format(2(a,1pg12.7,1pg12.7), a)
  !
end subroutine lens_limits

subroutine astro_j2000(line,error)
  use gkernel_interfaces
  use gbl_message
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !	ASTRO Command :
  !	CONVERT out_catalog_name /J2000 obs_equinox ! change ref frame to J2000
  !	/PRECESS new_equinox		! precess to equinox
  !     /FLUX fmin                ! select sources larger than fmin Jy
  !     /NAME ncname iname        ! reserve ncname chars for names;
  !                               ! Put `IAU' standard name in iname^th position
  !     /INPUT POS filename pos
  !     /INPUT FLUX filename
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4), parameter :: iopt_alt=1 !
  integer(kind=4), parameter :: iopt_j2000=2 !
  integer(kind=4), parameter :: iopt_prec=3 !
  integer(kind=4), parameter :: iopt_gal=4!
  integer(kind=4), parameter :: iopt_flux=5 !
  integer(kind=4), parameter :: iopt_name=6 !
  integer(kind=4), parameter :: iopt_input=7 !
  !
  character(len=2) :: coord, fcoord    ! coordinate system ('EQ','GA','HO'...)
  character(len=2) :: vtyp             ! velocity system ('LS', 'EA', 'HE')
  real(kind=4) :: equinox, new_equinox, fequinox   ! Equinox
  real(kind=8) :: velo,redsh                       ! Velocity (km/s)
  real(kind=8) :: lambda, beta, flambda, fbeta  ! coords (rad)
  character(len=40) :: name,file
  character(len=80) :: par
  logical :: to_j2000, precess, to_galactic, do_flux, do_alt
  logical :: do_name, input, found
  integer(kind=4) :: nlu, npar, lpar, nc, lun, olun, i, icat, ier
  integer(kind=4) :: iname, nkey, ncname
  character(len=2) :: ftype
  real(kind=4) :: flux, spindex, mag(9), obs_equinox, fmin, fflux, fspindex
  real(kind=4) :: poserr, posmin
  character(len=256) :: c_line, comment, ctext
  character(len=30) :: fcomment, ftext
  real(kind=8) :: s(2), x_0(3), x_1(3), matrix(9)
  integer(kind=4) :: mvfile
  parameter(mvfile=3)
  character(len=12) :: vfile(mvfile), key, arg, aname
  character(len=7) :: rname
  ! Data
  data vfile/'ALIAS','FLUX', 'POSITION'/
  data rname /'CONVERT'/
  ! Code -------------------------------------------------------------------
  !
  if (sic_nopt().le.0) then
    call astro_message(seve%i,rname,"Command requires at least one option")
    call astro_message(seve%i,rname,"Nothing done")
    return
  endif
  !
  do_alt = sic_present(iopt_alt,0)
  do_name = sic_present(iopt_name,0)
  do_flux = sic_present(iopt_flux,0)
  to_j2000 = sic_present(iopt_j2000,0)
  precess = sic_present(iopt_prec,0)
  to_galactic = sic_present(iopt_gal,0)
  input = sic_present(iopt_input,0)
  !
  ! Some options are exclusive
  if ((to_j2000.and.precess).or.(to_j2000.and.to_galactic).or.(to_galactic.and.precess)) then
    call astro_message(seve%e,rname,"/J2000, /PRECESS, /GALACTIC options cannot be combined")
    error=.true.
    return
  endif
  !
  ! Select right catalog
  if (do_alt) then
    icat = 2
  else
    icat = 1
  endif
  if (lenc(catalog_name(icat)).eq.0) then
    call astro_message(seve%f,rname,'No catalog')
    error = .true.
    return
  endif
  !
  ! Find output file name
  if (sic_present(0,1)) then
    ! Output File given in arg
    call sic_ch (line,0,1,name,nc,.true.,error)
    if (error) return
    call sic_parsef(name,file,' ','.sou')
  else
    ! Output file automatic
    name = catalog_name(icat)
    call sic_parsef(name,file,' ','.sou')
    nc = lenc(name)
    if (to_j2000) then
      name = name(1:nc)//'-J2000'
    elseif (precess) then
      name = name(1:nc)//'-prec'
    elseif (to_galactic) then
      name = name(1:nc)//'-gal'
    endif
    if (do_flux) then
      nc = lenc(name)
      name = name(1:nc)//'-flux'
    endif
    if (do_name) then
      nc = lenc(name)
      name = name(1:nc)//'-name'
    endif
    if (input) then
      nc = lenc(name)
      name = name(1:nc)//'-new'
    endif
    call sic_parsef(name,file,' ','.sou')
  endif
  !
  ! Input file for edition
  iname = 0
  if (input) then
    ! Read argument
    call sic_ke(line,iopt_input,1,arg,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,arg,key,nkey,vfile,mvfile,error)
    if (error) return
    ! Read file name
    call sic_ch(line,iopt_input,2,name,nc,.true.,error)
    if (error) return
    call sic_parsef(name,file,' ','.dat')
    if (key.eq.'POSITION') then
      posmin = 0.0001
      call sic_r4(line,iopt_input,3,posmin,.false.,error)
      if (error) return
    elseif (key.eq.'ALIAS') then
      iname = -1
    endif
    call get_input(key,file,error)
    if (error) return
  endif
  !
  ! /NAME ncname iname
  ncname = 48
  if (do_name) then
    call sic_i4(line,iopt_name,1,ncname,.true.,error)
    if (error) return
    call sic_i4(line,iopt_name,2,iname,.false.,error)
    if (error) return
  endif
  !
  ! Case of FLUX option
  fmin = -1.
  if (do_flux) then
    call sic_r4(line,iopt_flux,1,fmin,.true.,error)
    if (error) return
  endif
  !
  !
  ! Observation equinox:
  obs_equinox = 1950.
  if (to_j2000) then
    call sic_r4 (line,iopt_j2000,1,obs_equinox,.false.,error)
    if (error) return
  endif
  ! New equinox:
  new_equinox = 2000.
  if (precess) then
    call sic_r4 (line,iopt_prec,1,new_equinox,.false.,error)
    if (error) return
  endif
  !
  ! Open input catalog
  ier = sic_getlun (lun)
  ier = sic_open(lun,catalog_name(icat),'OLD',.true.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening '// catalog_name(icat))
    call putios('E-CONVERT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !
  ! Open output catalog
  ier = sic_getlun(olun)
  ier = sic_open(olun,file,'NEW',.false.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening file:')
    call astro_message(seve%e,rname,file)
    call putios('E-CONVERT,  ',ier)
    error = .true.
    goto 210
  endif
  vtyp = 'LS'
  !
  do while (.true.)
    ! Start to read the catalog
    100      read(lun,1000,end=210,iostat=ier) c_line
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Error reading catalog')
      error = .true.
      goto 210
    endif
    nlu = lenc(c_line)
    if (nlu.eq.0) then
      ! Empty line in input
      write(olun,1000) '!'
      goto 100
    elseif (c_line(1:1).eq.'!') then    
      ! commented line in input
      write(olun,1000) c_line(1:nlu)
      goto 100
    endif
    ! Look for comment
    i = index(c_line(1:nlu),'!')
    if (i.ne.0) then
      comment = c_line(i+1:nlu)
      nc = lenc(comment)
      call sic_blanc(comment,nc)
    else
      comment = ' '
    endif
    ! Process the meaningful part of the line
    call sic_blanc(c_line,nlu)
    npar = 1
    lpar = 50
    call sic_next(c_line(1:nlu),par,lpar,npar)
    if (lpar.eq.0) goto 100
    par = par(1:lpar)
    lpar = min(lpar,48)
    ctext = par(1:lpar)
    ! Decode the line (coordinate, velocity, fluxes,...)
    call decode_line (c_line, npar, coord, equinox, lambda, beta, vtyp, velo, redsh, &
    ftype, flux, spindex, mag, error)
    ! Do the requested conversion
    if (to_j2000) then
      if (coord.eq.'EQ' .and. equinox.eq.1950. ) then
        call b1950_to_j2000(obs_equinox,lambda,beta)
        equinox = 2000.0
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not converted to J2000')
      endif
    endif
    if (precess) then
      if (coord.eq.'EQ') then
        call do_precess(equinox,new_equinox,lambda,beta)
      elseif (coord.eq.'GA') then
        s(1) = lambda
        s(2) = beta
        call rect (s, x_0)
        call chgcoo ('GA','EQ',1950.0,new_equinox,matrix)
        call matvec (x_0, matrix, x_1)
        call spher (x_1, s)
        lambda = s(1)
        beta = s(2)
        coord = 'EQ'
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not precessed')
      endif
    endif
    if (to_galactic) then
      if (coord.eq.'EQ') then
        s(1) = lambda
        s(2) = beta
        call rect (s, x_0)
        call chgcoo ('EQ','GA',equinox,1950.0,matrix)
        call matvec (x_0, matrix, x_1)
        call spher (x_1, s)
        lambda = s(1)
        beta = s(2)
        coord = 'GA'
      else
        call astro_message(seve%r,rname,par(1:lpar)//' not converted')
      endif
    endif
    ! /INPUT option: add info to the line
    if (input) then
      call find_input(ctext, key, ftext, fcoord, fequinox, flambda, fbeta,  &
      fflux, fspindex, fcomment, found)
      aname = ' '
      if (found) then
        if (key.eq.'FLUX') then
          if (fflux.gt.0) then
            flux = fflux
            if (fspindex.ne.0) spindex=fspindex
            comment = comment(1:lenc(comment))//' +' //fcomment
            print 1012, ftext, flux
            1012                 format('*** ',a12,' Flux ',f8.3,'Jy')
          endif
        elseif (key.eq.'POSITION') then
          if (coord.eq.fcoord .and. equinox.eq.fequinox) then
            poserr = sqrt((lambda-flambda)**2+(beta-fbeta)**2)   &
                     *180*3600/3.1415929d0
            if (poserr.gt.posmin) then
              print 1011, ftext, poserr
              1011 format('*** ',a12,' Position Error ',f8.3,'"')
              lambda = flambda
              beta = fbeta
            endif
            comment = comment(1:lenc(comment))//' +' //fcomment
          endif
        elseif (key.eq.'ALIAS') then
          aname  = fcomment
        endif
      endif
    endif
    if (flux.ge.fmin) then
      ! Build the output line
      call encode_line (olun, par, lpar, coord, equinox, lambda, beta, vtyp,  &
      velo, ftype, flux, spindex, comment, iname, ncname, aname, error)
    endif
  enddo
  !
  ! End
  210   close (unit=lun)
  call sic_frelun (lun)
  close (unit=olun)
  call sic_frelun (olun)
  return
  !
  1000  format(a)
end subroutine astro_j2000
!
subroutine encode_line (olun, par, lpar, coord, equinox, lambda, beta, vtypx,  &
  velo, ftype, flux, spindex, comment, iname, ncname, aname, error)
  use gkernel_interfaces
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  integer(kind=4) :: olun           !
  character(len=*):: par            !
  integer(kind=4) :: lpar           !
  character(len=2) :: coord         !
  real(kind=4) :: equinox           !
  real(kind=8) :: lambda            !
  real(kind=8) :: beta              !
  character(len=2) :: vtypx         !
  real(kind=4) :: velo              !
  character(len=2) :: ftype         !
  real(kind=4) :: flux              !
  real(kind=4) :: spindex           !
  character(len=*):: comment        !
  integer(kind=4) :: iname          !
  integer(kind=4) :: ncname         !
  character(len=12) :: aname        !
  logical :: error                  !
  ! Local
  character(len=256) :: line
  character(len=80) :: cpar, ctest
  integer(kind=4) :: nc, j, k1, k2, lca
  character(len=16) :: lcoo, bcoo
  real(kind=4) :: ss
  !------------------------------------------------------------------------
  ! Code:
  ! iname = -1: insert comment as first name (in first position)
  ! iname gt 0 : insert a standard name in position iname
  ! note: this conforms to IAU standards, I guess (RL)
  ! (leave out EC or GA for the time being)
  lca = lenc(aname)
  if (iname.gt.0) then
    if (coord.eq.'EQ') then
      if (equinox.eq.2000.) then
        line(1:1) = 'J'
      elseif (equinox.eq.1950.0) then
        line(1:1) = 'B'
      endif
      call rad2sexa(lambda,24,lcoo,4,left=.true.)
      line(2:5) = lcoo(1:2)//lcoo(4:5)
      read(lcoo(7:11),'(f5.2)') ss
      write(line(6:6),'(i1.1)') int(ss/6.0)
      call rad2sexa(beta,360,bcoo,3,left=.true.)
      if (bcoo(1:1).ne.'-') then
        bcoo = '+'//bcoo(1:15)
      endif
      line(7:11) = bcoo(1:3)//bcoo(5:6)
      nc = 12
      ! strip out standard name if already there:
      k1 = index(par(1:lpar),line(1:5))
      if (k1.ne.0 .and.(k1.eq.1.or.par(k1-1:k1-1).eq.'|')) then
        k2 = index(par(k1:lpar),'|')
        if (k2.ne.0 .and. k1.gt.1) then
          par = par(1:k1-1)//par(k2+1:lpar)
          lpar = k1-1 + lpar-k2
        elseif (k2.ne.0 .and. k1.eq.1) then
          par = par(k2+1:lpar)
          lpar = lpar-k2
        else
          if (k1.gt.1) par = par(1:k1-1)
          lpar = k1-1
        endif
      endif
      !
      ! put standard name in inameth position
      j = 1
      k1 = 1
      do while (j.lt.iname .and. k1.lt.lpar)
        k1 = index(par(k1:lpar),'|')
        if (k1.gt.0) then
          k1 = k1+1
          j = j+1
        else
          k1 = lpar+1
        endif
      enddo
      if (j.lt.iname) then
        par = par(1:lpar)//'|'//line(1:11)
      elseif (j.eq.1 .and. lpar.gt.0) then
        par = line(1:11)//'|'//par(1:lpar)
      elseif (lpar.gt.0) then
        par = par(1:k1-1)//line(1:11)//'|'//par(k1:lpar)
      else
        par = line(1:11)
        lpar = -1
      endif
      lpar = lpar+12
    endif
    ! Alias operation:
  elseif (iname.eq.-1) then
    ! (no alias provided : shortcut.
    if (lca.le.0) then
      if (coord.eq.'EQ') then
        if (equinox.eq.2000.) then
          aname(1:1) = 'J'
        elseif (equinox.eq.1950.0) then
          aname(1:1) = 'B'
        endif
        call rad2sexa(lambda,24,lcoo,4,left=.true.)
        aname(2:5) = lcoo(1:2)//lcoo(4:5)
        call rad2sexa(beta,360,bcoo,3,left=.true.)
        if (bcoo(1:1).ne.'-') then
          bcoo = '+'//bcoo(1:15)
        endif
        aname(6:8) = bcoo(1:3)
        read(bcoo(5:6),'(f2.0)') ss
        write(aname(9:9),'(i1.1)') int(ss/6.0)
        lca = 9
      endif
    endif
    cpar(1:1)  = '|'
    cpar(2:lpar+1) = par(1:lpar)
    ctest(1:1)  = '|'
    ctest(2:lca+1) = par(1:lca)
    ! K1 = INDEX('|'//PAR(1:LPAR),'|'//ANAME(1:LCA))
    k1 = index(cpar(1:lpar+1),ctest(1:lca+1))
    if (k1.ne.0 .and.(k1.eq.1.or.par(k1-1:k1-1).eq.'|')) then
      k2 = index(par(k1:lpar),'|')
      if (k2.ne.0 .and. k1.gt.1) then
        par = par(1:k1-1)//par(k2+k1:lpar)
        lpar = lpar-k2
      elseif (k2.ne.0 .and. k1.eq.1) then
        par = par(k2+1:lpar)
        lpar = lpar-k2
      else
        if (k1.gt.2) par = par(1:k1-2)
        lpar = k1-2
      endif
    endif
    if (lpar.gt.11) then
      par= aname(1:lca)//'|'//par(13:lpar)
      lpar = lca+lpar-11
    else
      par= aname(1:lca)
      lpar = lca
    endif
  endif
  !
  ! shorten to ncname, but do not truncate an alias name:
  if (lpar.gt.ncname) then
    lpar = 0
    do while (lpar.lt.ncname)
      k1 = index(par(lpar+2:ncname+1),'|')
      if (k1.gt.0) then
        lpar = lpar + k1
      else
        if (lpar.gt.0) par(lpar+1:ncname) = ' '
        lpar = ncname
      endif
    enddo
  endif
  line = par(1:lpar)//' '
  nc = ncname+2
  !
  ! finished with names, now coords.
  line(nc:) = coord//' '
  nc = nc+3
  if (coord.eq.'EQ') then
    if (equinox.eq.2000.0) then
      line(nc+1:) = '2000 '
      nc = nc+5
    else
      write(line(nc+1:),'(F8.3,1X)') equinox
      nc = nc + 9
    endif
  endif
  if (coord.eq.'EQ') then
    call rad2sexa(lambda,24,line(nc+1:),4,left=.true.)
    line(nc+16:) = ' '
    nc = nc+16
  else
    write(line(nc+1:nc+12),'(f11.6,1x)') mod(lambda*180d0/pi+360d0,360d0)
    nc=nc+12
  endif
  if (coord.eq.'EQ') then
    if (beta.gt.0) then
      line(nc+1:) = '+'
      nc = nc+1
      call rad2sexa(beta,360,line(nc+1:),3,left=.true.)
      nc = nc+15
    else
      call rad2sexa(beta,360,line(nc+1:),3,left=.true.)
      nc = nc+16
    endif
  else
    write(line(nc+1:nc+12),'(f11.6,1x)') beta*180d0/pi
    nc=nc+12
  endif
  line(nc+1:) = ' '//vtypx//' '
  nc = nc + 4
  if (vtypx.ne.'NU') then
    write(line(nc+1:),'(F8.3,1X)') velo
    nc = nc + 9
  endif
  line(nc+1:) = ' '//ftype//' '
  nc = nc+4
  write(line(nc+1:),'(F8.3,1X)') flux
  nc = nc + 9
  write(line(nc+1:),'(F8.3,1X)') spindex
  nc = nc + 9
  write(olun,'(A,a,a)',err=99) line(1:nc),' ! ', comment(1:lenc(comment))
  return
  !
  99    error = .true.
end subroutine encode_line
!
subroutine get_input(key,file,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  character(len=*):: key            !
  character(len=*):: file           !
  logical :: error                  !
  ! Local
  character(len=*):: fkey, ctext, fcomment, fcoord, ftext
  logical :: found
  !
  integer(kind=4) :: ier, lun, nlu, i, npar, lpar, ndata, mdata, k, idata
  integer(kind=4) :: ltext, l, nc, l1
  parameter (mdata=3500)
  character(len=2) :: coodata(mdata)
  character(len=12) :: comdata(mdata),cdata(mdata)
  real(kind=4) :: fdata(mdata), sdata(mdata),equdata(mdata)
  real(kind=4) :: equinox, velo, flux, spindex, mag(9), fequinox, fflux, fspindex
  real(kind=8) :: flambda, fbeta
  real(kind=8) :: lambda, beta, lamdata(mdata), betdata(mdata)
  character(len=32) :: comment
  character(len=256) :: c_line,par
  character(len=2) :: coord,vtyp,ftype
  character(len=7) :: rname
  ! Data
  data rname /'CONVERT'/
  !
  save
  !--------------------------------------------------------------------
  !
  ! Open data file
  ier = sic_getlun (lun)
  ier = sic_open (lun,file,'OLD',.true.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening file:')
    call astro_message(seve%e,rname,file)
    call putios('E-CONVERT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !     read data
  ndata = 0
  do while (.true.)
    50       read(lun,1000,end=70,iostat=ier) c_line
    1000     format(a)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Error reading file:')
      call astro_message(seve%e,rname,file)
      error = .true.
      goto 70
    endif
    nlu = lenc(c_line)
    if (nlu.eq.0) then
      goto 50
    elseif (c_line(1:1).eq.'!') then
      goto 50
    endif
    i = index(c_line(1:nlu),'!')
    if (i.ne.0) then
      comment = c_line(i+1:nlu)
      nc = lenc(comment)
      call sic_blanc(comment,nc)
    else
      comment = ' '
    endif
    call sic_blanc(c_line,nlu)
    npar = 1
    lpar = 40
    call sic_next(c_line(1:nlu),par,lpar,npar)
    if (lpar.eq.0) goto 50
    l = index(par(1:lpar), '|')
    if (ndata.ge.mdata) then
      call astro_message(seve%e,rname,'File is too big:')
      call astro_message(seve%e,rname,file)
      goto 70
    endif
    if (key.eq.'ALIAS') then
      if (l.gt.0 .and. l.lt.lpar) then
        ndata=ndata+1
        cdata(ndata) = par(1:lpar)
        l1 = index(par(l+1:lpar), '|')
        if (l1.eq.0) l1=lpar-l+1
        comdata(ndata) = par(l+1:l+l1-1)
      endif
    else
      if (l.gt.0 .and. l.le.lpar) lpar = l-1
      par = par(1:lpar)
      call decode_line (c_line, npar, coord, equinox, lambda, beta, vtyp, velo,  &
      ftype, flux, spindex, mag, error)
      if (key.eq.'FLUX') then
        if (flux.gt.0) then
          ndata=ndata+1
          cdata(ndata) = par(1:lpar)
          fdata(ndata) = flux
          sdata(ndata) = spindex
          comdata(ndata) = comment(1:lenc(comment))
        endif
      elseif (key.eq.'POSITION') then
        ndata=ndata+1
        cdata(ndata) = par(1:lpar)
        lamdata(ndata)= lambda
        betdata(ndata)= beta
        equdata(ndata)= equinox
        coodata(ndata)= coord
        comdata(ndata) = comment(1:lenc(comment))
      endif
    endif
  enddo
  70    close(unit=lun)
  call sic_frelun(lun)
  idata = 0
  return
  !
  entry find_input(ctext, fkey, ftext, fcoord, fequinox, flambda, fbeta, fflux,  &
  fspindex, fcomment, found)
  ltext = lenc(ctext)
  do k=1, ndata
    idata = mod(idata, ndata)+1
    l = lenc(cdata(idata))
    if (index(ctext(1:ltext),cdata(idata)(1:l)) .ne. 0) then
      if (fkey.eq.'FLUX') then
        fflux = fdata(idata)
        fspindex = sdata(idata)
        fcomment = comdata(idata)
      elseif (fkey.eq.'POSITION') then
        flambda = lamdata(idata)
        fbeta = betdata(idata)
        fequinox = equdata(idata)
        fcoord = coodata(idata)
        fcomment = comdata(idata)
      elseif (fkey.eq.'ALIAS') then
        fcomment = comdata(idata)
      endif
      ftext = cdata(idata)(1:l)
      found = .true.
      return
    endif
  enddo
  found = .false.
  return
end subroutine get_input

subroutine flimit
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>flimit
  use greg_image
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !
  !	This subroutine computes the limits of the Regular Grid array.
  !	It tries to handle "Astronomical Maps" as best as possible (!).
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='RGDATA'
  real*8 :: tmp,xmin,xmax,ymin,ymax
  character(len=80) :: chain
  !
  if (rg%xval.ne.0.d0 .and. xunit.ne.'UNKNOWN') then
    if (dabs(rg%xinc/rg%xval).lt.1.d-3) then
      tmp = rg%xval/15.d0
      if (xunit.eq.'(DEGREES)') tmp = 3600.d0*tmp
      if (xunit.eq.'(ARC MIN.)') tmp = 60.d0*tmp
      call deg2sexa(tmp/3600.d0,360,coffx,2,left=.true.)
      call greg_message(seve%i,rname,'Offset in X '//coffx)
      rg%xval = 0.d0
    endif
  endif
  !
  if (rg%yval.ne.0.d0 .and. yunit.ne.'UNKNOWN') then
    if (dabs(rg%yinc/rg%yval).lt.1.d-3) then
      tmp = rg%yval
      if (yunit.eq.'(DEGREES)') tmp = 3600.*tmp
      if (yunit.eq.'(ARC MIN.)') tmp = 60.*tmp
      call deg2sexa(tmp/3600.d0,360,coffy,1,left=.true.)
      call greg_message(seve%i,rname,'Offset in Y '//coffy)
      rg%yval = 0.d0
    endif
  endif
  !
  xmin = (1.d0-rg%xref)*rg%xinc + rg%xval
  xmax = (dble(rg%nx)-rg%xref)*rg%xinc + rg%xval
  ymin = (1.d0-rg%yref)*rg%yinc + rg%yval
  ymax = (dble(rg%ny)-rg%yref)*rg%yinc + rg%yval
  !
  ! Signal the limits to the user
  write(chain,'(A,4(1X,1PG12.5))') 'Limits ',xmin,xmax,ymin,ymax
  call greg_message(seve%i,rname,chain)
end subroutine flimit

!-----------------------------------------------------------------------
! Basic GDF_READ / WRIT routines
! ---
! OBSOLESCENT: DO NOT USE FOR ANY NEW CODE!
!-----------------------------------------------------------------------
subroutine gdf_read(x,islo,error)
  use gio_interfaces, only : gio_read_header 
  use gildas_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !  Can not use 'gdf_read_header' since it allocates an image slot
  ! while the caller to the present routine have done this by itself
  ! (and from time to time X image is mixed with a Y slot...)
  ! Use GIO_READ_HEADER to do this now...
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x      !
  integer,      intent(in)    :: islo   !
  logical,      intent(inout) :: error  !
  !
  call gio_read_header(x,islo,error)
end subroutine gdf_read
!
subroutine gdf_writ(x,islo,error)
  use gio_interfaces, only : gio_write_header
  use gildas_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x      !
  integer,      intent(in)    :: islo   !
  logical,      intent(inout) :: error  !
  !
  call gio_write_header(x,islo,error)
end subroutine gdf_writ
!
subroutine gdf_ch(input,output)
  use gio_interfaces, only : gio_init_gildas, gdf_copy_gil
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  ! Copy Header IN into OUT
  !---------------------------------------------------------------------
  type(gildas), target, intent(inout) :: input 
  type(gildas), target, intent(inout) :: output 
  !
  logical :: error
  ! Check %ref Pointers
  call gio_init_gildas(input, 'GDF_CH') 
  call gio_init_gildas(output, 'GDF_CH') 
  output%file = input%file
  output%char = input%char
  output%loca = input%loca
  error = .false.
  call gdf_copy_gil (input,output, error)
end subroutine gdf_ch

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_kernel
  use cubetools_parameters
  use cubemain_messaging
  !
  public :: kernel_t
  public :: cubemain_kernel_allocate,cubemain_kernel_free
  private
  !
  type kernel_t
     real(kind=coor_k) :: inc  = 0d0 ! [rad] 
     real(kind=coor_k) :: val  = 0d0 ! [rad] 
     real(kind=coor_k) :: ref  = 0d0 ! [rad] 
     real(kind=coor_k) :: zero = 0d0 ! [rad] i0 = ref - val/inc
     real(kind=coor_k) :: fac  = 0d0 ! [rad] 1/inc
     real(kind=coor_k) :: min  = 0d0 ! [rad] 
     real(kind=coor_k) :: max  = 0d0 ! [rad] 
     real(kind=sign_k),   pointer :: fn(:) => null()
     integer(kind=chan_k) :: n = 0
  end type kernel_t
  !
contains
  !
  subroutine cubemain_kernel_allocate(n,kern,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=index_length), intent(in)    :: n
    type(kernel_t),             intent(inout) :: kern
    logical,                    intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='KERNEL>ALLOCATE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Sanity check
    if (n.le.0) then
       call cubemain_message(seve%e,rname,'Negative or zero number of elements')
       error = .true.
       return
    endif
    ! Allocate
    allocate(kern%fn(n),stat=ier)
    if (failed_allocate(rname,'kernel',ier,error)) return
    ! Allocation success => kern%n may be updated
    kern%n = n
  end subroutine cubemain_kernel_allocate
  !
  subroutine cubemain_kernel_free(kern,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    type(kernel_t), intent(inout) :: kern
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='KERNEL>FREE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    kern%zero = 0
    kern%fac = 0
    kern%min = 0
    kern%max = 0
    kern%n = 0
    if (associated(kern%fn)) deallocate(kern%fn)
  end subroutine cubemain_kernel_free
end module cubemain_kernel
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK DINTP
      SUBROUTINE DINTP (X, Y, XOUT, YOUT, YPOUT, NEQN, KOLD, PHI, IVC,
     +   IV, KGI, GI, ALPHA, OG, OW, OX, OY)
C***BEGIN PROLOGUE  DINTP
C***PURPOSE  Approximate the solution at XOUT by evaluating the
C            polynomial computed in DSTEPS at XOUT.  Must be used in
C            conjunction with DSTEPS.
C***LIBRARY   SLATEC (DEPAC)
C***CATEGORY  I1A1B
C***TYPE      DOUBLE PRECISION (SINTRP-S, DINTP-D)
C***KEYWORDS  ADAMS METHOD, DEPAC, INITIAL VALUE PROBLEMS, ODE,
C             ORDINARY DIFFERENTIAL EQUATIONS, PREDICTOR-CORRECTOR,
C             SMOOTH INTERPOLANT
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   The methods in subroutine  DSTEPS  approximate the solution near  X
C   by a polynomial.  Subroutine  DINTP  approximates the solution at
C   XOUT  by evaluating the polynomial there.  Information defining this
C   polynomial is passed from  DSTEPS  so  DINTP  cannot be used alone.
C
C   Subroutine DSTEPS is completely explained and documented in the text
C   "Computer Solution of Ordinary Differential Equations, the Initial
C   Value Problem"  by L. F. Shampine and M. K. Gordon.
C
C   Input to DINTP --
C
C   The user provides storage in the calling program for the arrays in
C   the call list
C      DIMENSION Y(NEQN),YOUT(NEQN),YPOUT(NEQN),PHI(NEQN,16),OY(NEQN)
C                AND ALPHA(12),OG(13),OW(12),GI(11),IV(10)
C   and defines
C      XOUT -- point at which solution is desired.
C   The remaining parameters are defined in  DSTEPS  and passed to
C   DINTP  from that subroutine
C
C   Output from  DINTP --
C
C      YOUT(*) -- solution at  XOUT
C      YPOUT(*) -- derivative of solution at  XOUT
C   The remaining parameters are returned unaltered from their input
C   values.  Integration with  DSTEPS  may be continued.
C
C***REFERENCES  H. A. Watts, A smoother interpolant for DE/STEP, INTRP
C                 II, Report SAND84-0293, Sandia Laboratories, 1984.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   840201  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DINTP
C
      INTEGER I, IQ, IV, IVC, IW, J, JQ, KGI, KOLD, KP1, KP2,
     1        L, M, NEQN
      DOUBLE PRECISION ALP, ALPHA, C, G, GDI, GDIF, GI, GAMMA, H, HI,
     1       HMU, OG, OW, OX, OY, PHI, RMU, SIGMA, TEMP1, TEMP2, TEMP3,
     2       W, X, XI, XIM1, XIQ, XOUT, Y, YOUT, YPOUT
C
      DIMENSION Y(*),YOUT(*),YPOUT(*),PHI(NEQN,16),OY(*)
      DIMENSION G(13),C(13),W(13),OG(13),OW(12),ALPHA(12),GI(11),IV(10)
C
C***FIRST EXECUTABLE STATEMENT  DINTP
      KP1 = KOLD + 1
      KP2 = KOLD + 2
C
      HI = XOUT - OX
      H = X - OX
      XI = HI/H
      XIM1 = XI - 1.D0
C
C   INITIALIZE W(*) FOR COMPUTING G(*)
C
      XIQ = XI
      DO 10 IQ = 1,KP1
        XIQ = XI*XIQ
        TEMP1 = IQ*(IQ+1)
 10     W(IQ) = XIQ/TEMP1
C
C   COMPUTE THE DOUBLE INTEGRAL TERM GDI
C
      IF (KOLD .LE. KGI) GO TO 50
      IF (IVC .GT. 0) GO TO 20
      GDI = 1.0D0/TEMP1
      M = 2
      GO TO 30
 20   IW = IV(IVC)
      GDI = OW(IW)
      M = KOLD - IW + 3
 30   IF (M .GT. KOLD) GO TO 60
      DO 40 I = M,KOLD
 40     GDI = OW(KP2-I) - ALPHA(I)*GDI
      GO TO 60
 50   GDI = GI(KOLD)
C
C   COMPUTE G(*) AND C(*)
C
 60   G(1) = XI
      G(2) = 0.5D0*XI*XI
      C(1) = 1.0D0
      C(2) = XI
      IF (KOLD .LT. 2) GO TO 90
      DO 80 I = 2,KOLD
        ALP = ALPHA(I)
        GAMMA = 1.0D0 + XIM1*ALP
        L = KP2 - I
        DO 70 JQ = 1,L
 70       W(JQ) = GAMMA*W(JQ) - ALP*W(JQ+1)
        G(I+1) = W(1)
 80     C(I+1) = GAMMA*C(I)
C
C   DEFINE INTERPOLATION PARAMETERS
C
 90   SIGMA = (W(2) - XIM1*W(1))/GDI
      RMU = XIM1*C(KP1)/GDI
      HMU = RMU/H
C
C   INTERPOLATE FOR THE SOLUTION -- YOUT
C   AND FOR THE DERIVATIVE OF THE SOLUTION -- YPOUT
C
      DO 100 L = 1,NEQN
        YOUT(L) = 0.0D0
 100    YPOUT(L) = 0.0D0
      DO 120 J = 1,KOLD
        I = KP2 - J
        GDIF = OG(I) - OG(I-1)
        TEMP2 = (G(I) - G(I-1)) - SIGMA*GDIF
        TEMP3 = (C(I) - C(I-1)) + RMU*GDIF
        DO 110 L = 1,NEQN
          YOUT(L) = YOUT(L) + TEMP2*PHI(L,I)
 110      YPOUT(L) = YPOUT(L) + TEMP3*PHI(L,I)
 120    CONTINUE
      DO 130 L = 1,NEQN
        YOUT(L) = ((1.0D0 - SIGMA)*OY(L) + SIGMA*Y(L)) +
     1             H*(YOUT(L) + (G(1) - SIGMA*OG(1))*PHI(L,1))
 130    YPOUT(L) = HMU*(OY(L) - Y(L)) +
     1                (YPOUT(L) + (C(1) + RMU*OG(1))*PHI(L,1))
C
      RETURN
      END
*DECK DINTRV
      SUBROUTINE DINTRV (XT, LXT, X, ILO, ILEFT, MFLAG)
C***BEGIN PROLOGUE  DINTRV
C***PURPOSE  Compute the largest integer ILEFT in 1 .LE. ILEFT .LE. LXT
C            such that XT(ILEFT) .LE. X where XT(*) is a subdivision of
C            the X interval.
C***LIBRARY   SLATEC
C***CATEGORY  E3, K6
C***TYPE      DOUBLE PRECISION (INTRV-S, DINTRV-D)
C***KEYWORDS  B-SPLINE, DATA FITTING, INTERPOLATION, SPLINES
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     Written by Carl de Boor and modified by D. E. Amos
C
C     Abstract    **** a double precision routine ****
C         DINTRV is the INTERV routine of the reference.
C
C         DINTRV computes the largest integer ILEFT in 1 .LE. ILEFT .LE.
C         LXT such that XT(ILEFT) .LE. X where XT(*) is a subdivision of
C         the X interval.  Precisely,
C
C                      X .LT. XT(1)                1         -1
C         if  XT(I) .LE. X .LT. XT(I+1)  then  ILEFT=I  , MFLAG=0
C           XT(LXT) .LE. X                         LXT        1,
C
C         That is, when multiplicities are present in the break point
C         to the left of X, the largest index is taken for ILEFT.
C
C     Description of Arguments
C
C         Input      XT,X are double precision
C          XT      - XT is a knot or break point vector of length LXT
C          LXT     - length of the XT vector
C          X       - argument
C          ILO     - an initialization parameter which must be set
C                    to 1 the first time the spline array XT is
C                    processed by DINTRV.
C
C         Output
C          ILO     - ILO contains information for efficient process-
C                    ing after the initial call and ILO must not be
C                    changed by the user.  Distinct splines require
C                    distinct ILO parameters.
C          ILEFT   - largest integer satisfying XT(ILEFT) .LE. X
C          MFLAG   - signals when X lies out of bounds
C
C     Error Conditions
C         None
C
C***REFERENCES  Carl de Boor, Package for calculating with B-splines,
C                 SIAM Journal on Numerical Analysis 14, 3 (June 1977),
C                 pp. 441-472.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DINTRV
C
      INTEGER IHI, ILEFT, ILO, ISTEP, LXT, MFLAG, MIDDLE
      DOUBLE PRECISION X, XT
      DIMENSION XT(*)
C***FIRST EXECUTABLE STATEMENT  DINTRV
      IHI = ILO + 1
      IF (IHI.LT.LXT) GO TO 10
      IF (X.GE.XT(LXT)) GO TO 110
      IF (LXT.LE.1) GO TO 90
      ILO = LXT - 1
      IHI = LXT
C
   10 IF (X.GE.XT(IHI)) GO TO 40
      IF (X.GE.XT(ILO)) GO TO 100
C
C *** NOW X .LT. XT(IHI) . FIND LOWER BOUND
      ISTEP = 1
   20 IHI = ILO
      ILO = IHI - ISTEP
      IF (ILO.LE.1) GO TO 30
      IF (X.GE.XT(ILO)) GO TO 70
      ISTEP = ISTEP*2
      GO TO 20
   30 ILO = 1
      IF (X.LT.XT(1)) GO TO 90
      GO TO 70
C *** NOW X .GE. XT(ILO) . FIND UPPER BOUND
   40 ISTEP = 1
   50 ILO = IHI
      IHI = ILO + ISTEP
      IF (IHI.GE.LXT) GO TO 60
      IF (X.LT.XT(IHI)) GO TO 70
      ISTEP = ISTEP*2
      GO TO 50
   60 IF (X.GE.XT(LXT)) GO TO 110
      IHI = LXT
C
C *** NOW XT(ILO) .LE. X .LT. XT(IHI) . NARROW THE INTERVAL
   70 MIDDLE = (ILO+IHI)/2
      IF (MIDDLE.EQ.ILO) GO TO 100
C     NOTE. IT IS ASSUMED THAT MIDDLE = ILO IN CASE IHI = ILO+1
      IF (X.LT.XT(MIDDLE)) GO TO 80
      ILO = MIDDLE
      GO TO 70
   80 IHI = MIDDLE
      GO TO 70
C *** SET OUTPUT AND RETURN
   90 MFLAG = -1
      ILEFT = 1
      RETURN
  100 MFLAG = 0
      ILEFT = ILO
      RETURN
  110 MFLAG = 1
      ILEFT = LXT
      RETURN
      END
*DECK DINTYD
      SUBROUTINE DINTYD (T, K, YH, NYH, DKY, IFLAG)
C***BEGIN PROLOGUE  DINTYD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEBDF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (INTYD-S, DINTYD-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   DINTYD approximates the solution and derivatives at T by polynomial
C   interpolation. Must be used in conjunction with the integrator
C   package DDEBDF.
C ----------------------------------------------------------------------
C DINTYD computes interpolated values of the K-th derivative of the
C dependent variable vector Y, and stores it in DKY.
C This routine is called by DDEBDF with K = 0,1 and T = TOUT, but may
C also be called by the user for any K up to the current order.
C (see detailed instructions in LSODE usage documentation.)
C ----------------------------------------------------------------------
C The computed values in DKY are gotten by interpolation using the
C Nordsieck history array YH.  This array corresponds uniquely to a
C vector-valued polynomial of degree NQCUR or less, and DKY is set
C to the K-th derivative of this polynomial at T.
C The formula for DKY is..
C              Q
C  DKY(I)  =  Sum  C(J,K) * (T - TN)**(J-K) * H**(-J) * YH(I,J+1)
C             J=K
C where  C(J,K) = J*(J-1)*...*(J-K+1), Q = NQCUR, TN = TCUR, H = HCUR.
C The quantities  NQ = NQCUR, L = NQ+1, N = NEQ, TN, and H are
C communicated by common.  The above sum is done in reverse order.
C IFLAG is returned negative if either K or T is out of bounds.
C ----------------------------------------------------------------------
C
C***SEE ALSO  DDEBDF
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    DDEBD1
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DINTYD
C
      INTEGER I, IC, IER, IFLAG, IOWND, IOWNS, J, JB, JB2, JJ, JJ1,
     1      JP1, JSTART, K, KFLAG, L, MAXORD, METH, MITER, N, NFE,
     2      NJE, NQ, NQU, NST, NYH
      DOUBLE PRECISION C, DKY, EL0, H, HMIN, HMXI, HU, R, ROWND,
     1      ROWNS, S, T, TN, TP, UROUND, YH
      DIMENSION YH(NYH,*),DKY(*)
      COMMON /DDEBD1/ ROWND,ROWNS(210),EL0,H,HMIN,HMXI,HU,TN,UROUND,
     1                IOWND(14),IOWNS(6),IER,JSTART,KFLAG,L,METH,MITER,
     2                MAXORD,N,NQ,NST,NFE,NJE,NQU
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 130
C***FIRST EXECUTABLE STATEMENT  DINTYD
         IFLAG = 0
         IF (K .LT. 0 .OR. K .GT. NQ) GO TO 110
            TP = TN - HU*(1.0D0 + 100.0D0*UROUND)
            IF ((T - TP)*(T - TN) .LE. 0.0D0) GO TO 10
               IFLAG = -2
C     .........EXIT
               GO TO 130
   10       CONTINUE
C
            S = (T - TN)/H
            IC = 1
            IF (K .EQ. 0) GO TO 30
               JJ1 = L - K
               DO 20 JJ = JJ1, NQ
                  IC = IC*JJ
   20          CONTINUE
   30       CONTINUE
            C = IC
            DO 40 I = 1, N
               DKY(I) = C*YH(I,L)
   40       CONTINUE
            IF (K .EQ. NQ) GO TO 90
               JB2 = NQ - K
               DO 80 JB = 1, JB2
                  J = NQ - JB
                  JP1 = J + 1
                  IC = 1
                  IF (K .EQ. 0) GO TO 60
                     JJ1 = JP1 - K
                     DO 50 JJ = JJ1, J
                        IC = IC*JJ
   50                CONTINUE
   60             CONTINUE
                  C = IC
                  DO 70 I = 1, N
                     DKY(I) = C*YH(I,JP1) + S*DKY(I)
   70             CONTINUE
   80          CONTINUE
C     .........EXIT
               IF (K .EQ. 0) GO TO 130
   90       CONTINUE
            R = H**(-K)
            DO 100 I = 1, N
               DKY(I) = R*DKY(I)
  100       CONTINUE
         GO TO 120
  110    CONTINUE
C
            IFLAG = -1
  120    CONTINUE
  130 CONTINUE
      RETURN
C     ----------------------- END OF SUBROUTINE DINTYD
C     -----------------------
      END
*DECK DIR
      SUBROUTINE DIR (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     +   IWORK)
C***BEGIN PROLOGUE  DIR
C***PURPOSE  Preconditioned Iterative Refinement Sparse Ax = b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            iterative refinement with a matrix splitting.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SIR-S, DIR-D)
C***KEYWORDS  ITERATIVE PRECONDITION, LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     DOUBLE PRECISION B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N), DZ(N)
C     DOUBLE PRECISION RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL DIR(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE, ITOL,
C    $     TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Double Precision B(N).
C         Right-hand side vector.
C X      :INOUT    Double Precision X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Double Precision A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return, X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a double precision array
C         that can be used to pass necessary preconditioning information
C         and/or workspace to MSOLVE.  IWORK is an integer work array
C         for the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /DSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /DSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Double Precision.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Double Precision.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*D1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Double Precision R(N).
C Z      :WORK     Double Precision Z(N).
C DZ     :WORK     Double Precision DZ(N).
C         Double Precision arrays used for workspace.
C RWORK  :WORK     Double Precision RWORK(USER DEFINED).
C         Double Precision array that can be used by  MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used by  MSOLVE.
C
C *Description:
C       The basic algorithm for iterative refinement (also known as
C       iterative improvement) is:
C
C            n+1    n    -1       n
C           X    = X  + M  (B - AX  ).
C
C           -1   -1
C       If M =  A then this  is the  standard  iterative  refinement
C       algorithm and the "subtraction" in the  residual calculation
C       should be done in double precision (which it is  not in this
C       routine).
C       If M = DIAG(A), the diagonal of A, then iterative refinement
C       is  known  as  Jacobi's  method.   The  SLAP  routine  DSJAC
C       implements this iterative strategy.
C       If M = L, the lower triangle of A, then iterative refinement
C       is known as Gauss-Seidel.   The SLAP routine DSGS implements
C       this iterative strategy.
C
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines DSJAC and DSGS are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first  in each "column") and are  stored in the  double pre-
C       cision array  A. In  other  words,  for each  column  in the
C       matrix  first put  the diagonal entry in A.  Then put in the
C       other non-zero  elements going  down the column  (except the
C       diagonal)  in order.  The IA array  holds the  row index for
C       each non-zero.  The JA array  holds the offsets into the IA,
C       A  arrays  for  the  beginning  of  each  column.  That  is,
C       IA(JA(ICOL)),A(JA(ICOL)) are the first elements of the ICOL-
C       th column in IA and A, and IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)
C       are  the last elements of the ICOL-th column.   Note that we
C       always have JA(N+1)=NELT+1, where N is the number of columns
C       in the matrix  and NELT  is the number  of non-zeros  in the
C       matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Examples:
C       See the SLAP routines DSJAC, DSGS
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  DSJAC, DSGS
C***REFERENCES  1. Gene Golub and Charles Van Loan, Matrix Computations,
C                  Johns Hopkins University Press, Baltimore, Maryland,
C                  1983.
C               2. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  D1MACH, ISDIR
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed DSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C***END PROLOGUE  DIR
C     .. Scalar Arguments ..
      DOUBLE PRECISION ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), B(N), DZ(N), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      DOUBLE PRECISION BNRM, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      DOUBLE PRECISION D1MACH
      INTEGER ISDIR
      EXTERNAL D1MACH, ISDIR
C***FIRST EXECUTABLE STATEMENT  DIR
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*D1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I) = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISDIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $     ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $     IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate new iterate x, new residual r, and new
C         pseudo-residual z.
         DO 20 I = 1, N
            X(I) = X(I) + Z(I)
 20      CONTINUE
         CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
         DO 30 I = 1, N
            R(I) = B(I) - R(I)
 30      CONTINUE
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         check stopping criterion.
         IF( ISDIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $        ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $        IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF DIR FOLLOWS -------------------------------
      END

!-----------------------------------------------------------------------
! API to plot/list NOEMA/POLYFIX frequency coverage from outside ASTRO
! 3 subroutines must be called 
! The first 2 fill in the astro_noemasetup_t structure (define in astro/lib/types.f90)
!       astro_noemasetup_receiver() to transfer tuning and some source information (1 call)
!                                   (fills astro_noemareceiver_t)
!       astro_noemasetup_spw() to transfer polyfix configuration (1 call / SPW) 
!                              (fills astro_noemaspw_t)
! The last procedure can be:
! astro_noemasetup_plot() to do the plot (arguments can be used to customize the layout, see below)
! OR
! astro_noemasetup_list() to do the list ast LIST command in ASTRO
!-----------------------------------------------------------------------
!
subroutine astro_noemasetup_plot(rname,isetup,iplotmode,iupperaxis,showlines,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_noemasetup_plot
  use astro_noema_type
  !-----------------------------------------------------------------------
  ! @ public
  ! Plot a NOEMA receiver\backend setup as done in ASTRO
  !
  ! input:
  ! isetup: import structure filled in by 2 public subroutines:
  !       astro_noemasetup_receiver to transfer tuning/source information (1 call)
  !       astro_noemasetup_spw to transfer polyfix configuration (1 call / SPW)
  !
  ! Plot can be configured with:
  ! plotmode (integer*4):  pm+* defined in astro_types module
  !    pm_basebands=1= BASEBANDS = 4 boxes (H/V)LO, (H/V)LI, (H/V)UI, (H/V)UO
  !                               chunk limits are drawn
  !    pm_receiver=2= RECEIVER = 3 boxes (H/V)-USB, (H/V)-LSB, Global receiver band
  !                               chunk limits are not drawn
  ! iupperaxis (integer*4): choice for upper axis (lower axis is always REST)
  !     freqax_* defined in astro_types
  !     freqax_rest,freqax_rf, _lsr, _if1, _if2,_chunks,_imrest, _imrf, _imrf,_imlsr, _null
  !
  ! showline (logical): if .true. the catalog lines are indicated on the plot
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemasetup_t), intent(in) :: isetup    ! import structure
  integer(kind=4), intent(in) :: iplotmode     ! BASEBANDS or RECEIVER
  integer(kind=4), intent(in) :: iupperaxis
  logical, intent(in) :: showlines
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: noemamode='ONLINE'
  type(noema_t) :: lnoema
  type(plot_molecules_t) :: molecules
  type(current_boxes_t) :: cplot
  type(frequency_axis_t) :: freq_axis
  integer(kind=4) :: userns,useris,i
  real(kind=4) :: usersize
  !
  !Define receiver parameters
  call rec_define_noema(lnoema%recdesc,noemamode,error)
  if (error) return
  !Reset tuning parameters
  lnoema%cfebe%defined=.false.
  lnoema%cfebe%rectune%name = ''
  lnoema%cfebe%rectune%iband = 0
  lnoema%cfebe%rectune%flo1 = 0
  lnoema%cfebe%rectune%flotune = 0
  lnoema%cfebe%rectune%frest = 0
  lnoema%cfebe%rectune%frf = 0
  lnoema%cfebe%rectune%flsr = 0
  lnoema%cfebe%rectune%fcent = 0
  lnoema%cfebe%rectune%label = ''
  lnoema%cfebe%rectune%ongrid = .false.
  lnoema%recdesc%redshift = .false. ! does NOT takes into accound source redshift (call from the OBS)
  ! As a result the LO check must take into account the 100MHz tolerance (for doppler)
  do i=1,lnoema%recdesc%n_rbands
    lnoema%recdesc%lolim(1,i)=lnoema%recdesc%lolim(1,i)-lnoema%recdesc%lotol
    lnoema%recdesc%lolim(2,i)=lnoema%recdesc%lolim(2,i)+lnoema%recdesc%lotol
  enddo
  !
  call rec_define_noema_ifproc(lnoema%cfebe%i_f%ifproc,error)
  if (error) return
  !
  ! Tuning and source information
  call noema_external_tuning(rname,isetup%rec,lnoema,error)
  if (error) return
  !
  !SPW configuration
  call noema_external_spw(rname,isetup%spw,lnoema,error)
  if (error) return
  !
  freq_axis%main=trim(freqax_names(freqax_rest))
  if (iupperaxis.le.0.or.iupperaxis.gt.m_freqax) then
    call astro_message(seve%e,rname,'Problem with decoding frequency axis')
    error=.true.
    return
  endif
  freq_axis%second=trim(freqax_names(iupperaxis))
  molecules%doplot=showlines
  molecules%catalog='gag_data:molecules.dat'
  !
  ! Get current marker characteristiacs
  call gr_get_marker(userns,useris,usersize)
  ! Do the PLOT
  if (iplotmode.eq.pm_basebands) then
    call noema_plot_selpfx(rname,lnoema,cplot,molecules,freq_axis,error)
    if (error) return
  else if (iplotmode.eq.pm_receiver) then
    call rec_plot_sidebands(lnoema%recdesc,lnoema%source,lnoema%cfebe%rectune & 
                            ,cplot,molecules,freq_axis,error)
    if (error) return
    call noema_draw_summary(lnoema,cplot,molecules,freq_axis,error)
    if (error) return
  else
    call astro_message(seve%e,rname,'Plot mode not understood')
    error = .true.
    return
  endif
  !
  ! Set marker characteristics as they were:
  call gr_set_marker(userns,useris,usersize)
  !
end subroutine astro_noemasetup_plot
!
subroutine astro_noemasetup_list(rname,isetup,doindex,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_noemasetup_list
  use astro_noema_type
  !-----------------------------------------------------------------------
  ! @ public
  ! Plot/List a NOEMA receiver\backend setup as done in ASTRO
  !
  ! input:
  ! isetup: import structure filled in by 2 public subroutines:
  !       astro_noemasetup_receiver to transfer tuning/source information (1 call)
  !       astro_noemasetup_spw to transfer polyfix configuration (1 call / SPW)
  ! doindex .true. to list SPW according to their number in the data instead of frequency
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemasetup_t), intent(in) :: isetup    ! import structure
  logical, intent(in) :: doindex
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: noemamode='ONLINE'
  type(noema_t) :: lnoema
  type(frequency_axis_t) :: freq_axis
  logical :: doconflict
  integer(kind=4) :: is1, is2
  !
  !Define receiver parameters
  call rec_define_noema(lnoema%recdesc,noemamode,error)
  if (error) return
  !Reset tuning parameters
  lnoema%cfebe%defined=.false.
  lnoema%cfebe%rectune%name = ''
  lnoema%cfebe%rectune%iband = 0
  lnoema%cfebe%rectune%flo1 = 0
  lnoema%cfebe%rectune%flotune = 0
  lnoema%cfebe%rectune%frest = 0
  lnoema%cfebe%rectune%frf = 0
  lnoema%cfebe%rectune%flsr = 0
  lnoema%cfebe%rectune%fcent = 0
  lnoema%cfebe%rectune%label = ''
  lnoema%cfebe%rectune%ongrid = .false.
  lnoema%recdesc%redshift = .false. ! does NOT takes into accound source redshift (call from the OBS)
  !
  call rec_define_noema_ifproc(lnoema%cfebe%i_f%ifproc,error)
  if (error) return
  !
  ! Tuning and source information
  call noema_external_tuning(rname,isetup%rec,lnoema,error)
  if (error) return
  !
  !SPW configuration
  call noema_external_spw(rname,isetup%spw,lnoema,error)
  if (error) return
  !
  freq_axis%main=trim(freqax_names(freqax_rest))
  !
  ! Do the list
  doconflict=.false.
  is1=1
  is2=lnoema%cfebe%spw%out%n_spw
  call noema_list_spw(rname,lnoema%cfebe%spw%out,freq_axis%main,lnoema%source,doindex,doconflict,is1,is2,error)
  !
end subroutine astro_noemasetup_list
!
subroutine astro_noemasetup_receiver(rname,irec,flo1,fcent,sb,tuningname,sourcename,doppler,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_receiver
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public
  ! API to fill in receiver section of the ASTRO import structure
  ! irec = isetup%rec ! irec = astro_noemareceiver_t
  !        isetup = astro_noemasetup
  ! flo1 (real*8) = LO1 tuning frequency (REST frame) in MHz
  ! fcent (real*8) = IF1 center frequency in MHz
  ! sb (integer*4) = sideband code where the tuning frequency is placed (1=USB,2=LSB)
  ! tuning name (character*12) = name of the LINE command at the observatory
  ! source name (character*128) = name of the source
  ! doppler (real*8) = doppler of the observation
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemareceiver_t), intent(inout) :: irec
  real(kind=8), intent(in)  :: flo1   ! MHz, rest
  real(kind=8), intent(in)  :: fcent    !MHz, if1
  integer(kind=4), intent(in) :: sb ! sideband
  character(len=*), intent(in) :: tuningname ! tuning name
  character(len=*), intent(in) :: sourcename ! source name
  real(kind=8), intent(in)  :: doppler    ! as defined in obs/clic
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: noemamode='ONLINE'
  type(receiver_desc_t) :: rdesc
  !
  call rec_define_noema(rdesc,noemamode,error)
  if (error) return
  !
  irec%flo1=flo1
  !
  if (fcent.lt.rdesc%iflim(1).or.fcent.gt.rdesc%iflim(2)) then
    call astro_message(seve%e,rname,'Wrong IF frequency')
    error=.true.
    return
  endif
  irec%fcent=fcent
  if (sb.le.0.or.sb.gt.m_sideband) then
    call astro_message(seve%e,rname,'Problem with sideband')
    error=.true.
    return
  endif
  irec%sbcode=sb
  if (tuningname.eq.'') then
    call astro_message(seve%e,rname,'Missing tuning name')
    error=.true.
    return
  endif
  irec%tuningname=tuningname
  !
  if (sourcename.eq.'') then
    call astro_message(seve%e,rname,'Missing source name')
    error=.true.
    return
  endif
  irec%sourcename=sourcename

  !
  irec%obsdoppler=doppler
  !
end subroutine astro_noemasetup_receiver
!
subroutine astro_noemasetup_spw_bychunk(rname,ispw,ch1,ch2,resol,label,user_label,corrmode,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_spw_bychunk
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public-generic astro_noemasetup_spw
  ! API to fill in SPW section of the ASTRO import structure 
  ! 1 call per SPW: the list of SPW is incremented internally
  !
  ! Definition by chunk:
  ! For each spectral window input is:
  ! ch1 (integer*4) = 1st chunk of the SPW
  ! ch2 (integer*4) = last chunk of the SPW
  ! real (real*8) = resolution of the SPW (in MHz)
  ! label (character*3) = label to identify the baseband where the SPW is placed. Format: HLO
  ! user_label (character*32) = in case the used attached a name to the SPW
  ! corrmode (integer*4) = correlator mode used for the baseband
  !
  ! NB: When a HighResolution SPW is defined, the Low SPW of the current baseband is
  ! also defined if it does not exist yet
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemaspw_t), intent(inout) :: ispw
  integer(kind=4), intent(in) :: ch1
  integer(kind=4), intent(in) :: ch2
  real(kind=8), intent(in)  :: resol
  character(len=*), intent(in) :: label
  character(len=*), intent(in) :: user_label
  integer(kind=4), intent(in) :: corrmode
  logical, intent(inout) :: error
  !
  integer(kind=4) :: iw,chmax,it,ic2
  type(pfx_t) :: pfx
  logical :: gotres
  integer(kind=4), parameter :: lenlabel=3
  character(len=128) :: mess
  !
  ispw%n_spw=ispw%n_spw+1
  iw=ispw%n_spw
  !
  call noema_define_pfx(pfx,error)
  if (error) return
  !
  if (corrmode.le.0) then
    call astro_message(seve%e,rname,'Correlator mode undefined')
    error=.true.
    return
  endif
  ispw%corrmode(iw)=corrmode
  !
  chmax=0
  gotres=.false.
  do it=1,pfx%unit(1)%mode(corrmode)%n_types
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%df_chunks.eq.resol) gotres=.true.
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%n_chunks.le.chmax) cycle
    chmax=pfx%unit(1)%mode(corrmode)%chtype(it)%n_chunks
  enddo
  if (.not.gotres) then
    call astro_message(seve%e,rname,'Problem with SPW resolution')
    error=.true.
    return
  endif
  ispw%resol(iw)=resol
  !
  if (ch1.le.0) then
    call astro_message(seve%e,rname,'Chunk 1 undefined')
    error=.true.
    return
  endif
  ispw%chunkmin(iw)=ch1
  if (ch2.le.0) then
    call astro_message(seve%e,rname,'Chunk 2 undefined')
    error=.true.
    return
  endif
  if (ch2.gt.chmax) then
    if (ch2.gt.64) then
      ! patch to be used as long as there is a discrepancy between observed data and astro definitions
      ! (problem of the last 3 chunks)
      call astro_message(seve%e,rname,'Chunk 2 does not exist')
      error=.true.
      return
    endif
    ic2=chmax
    write (mess,'(a,i0,a,1x,i0)') 'Chunk 2 (',ch2,') sent back to',chmax
    call astro_message(seve%w,rname,mess)
  else
    ic2=ch2
  endif
  ispw%chunkmax(iw)=ic2
  if (len_trim(label).ne.lenlabel) then
    call astro_message(seve%e,rname,'Problem with label format (expect 5 characters)')
    error=.true.
    return
  endif
  ispw%label(iw)=label
  !
  ispw%user_label(iw)=user_label
  !
end subroutine astro_noemasetup_spw_bychunk
!
subroutine astro_noemasetup_spw_byfreq(rname,ispw,f1,f2,resol,label,user_label,corrmode,error)
  use gbl_message
  use astro_interfaces, except_this=>astro_noemasetup_spw_byfreq
  use astro_types
  !-----------------------------------------------------------------------
  ! @ public-generic astro_noemasetup_spw
  ! API to fill in SPW section of the ASTRO import structure 
  ! 1 call per SPW: the list of SPW is incremented internally
  !
  ! Definition by frequency:
  ! For each spectral window input is:
  ! f1 (real*8) = IF2 min of the SPW
  ! f2 (real*8) = IF2 max of the SPW
  ! real (real*8) = resolution of the SPW (in MHz)
  ! label (character*3) = label to identify the baseband where the SPW is placed. Format: HLO
  ! user_label (character*32) = in case the used attached a name to the SPW
  ! corrmode (integer*4) = correlator mode used for the baseband
  !
  ! NB: When a HighResolution SPW is defined, the Low SPW of the current baseband is
  ! also defined if it does not exist yet
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(astro_noemaspw_t), intent(inout) :: ispw
  real(kind=8), intent(in) :: f1
  real(kind=8), intent(in) :: f2
  real(kind=8), intent(in)  :: resol
  character(len=*), intent(in) :: label
  character(len=*), intent(in) :: user_label
  integer(kind=4), intent(in) :: corrmode
  logical, intent(inout) :: error
  !
  integer(kind=4) :: it,itype,ic1,ic2
  type(pfx_t) :: pfx
  logical :: gotres
  integer(kind=4), parameter :: lenlabel=3
  !
  !
  call noema_define_pfx(pfx,error)
  if (error) return
  !
  if (corrmode.le.0) then
    call astro_message(seve%e,rname,'Correlator mode undefined')
    error=.true.
    return
  endif
  gotres=.false.
  do it=1,pfx%unit(1)%mode(corrmode)%n_types
    if (pfx%unit(1)%mode(corrmode)%chtype(it)%df_chunks.eq.resol) gotres=.true.
    itype=it
  enddo
  if (.not.gotres) then
    call astro_message(seve%e,rname,'Problem with SPW resolution')
    error=.true.
    return
  endif
  !
  if (f1.lt.pfx%if2lim(1)) then
    call astro_message(seve%e,rname,'Problem with IF2 min')
    error=.true.
    return
  endif
  !
  if (f2.le.pfx%if2lim(1)) then
    call astro_message(seve%e,rname,'Problem with IF2 max')
    error=.true.
    return
  endif
  !
  ! Convert if2 into chunk number
  call if2tochunk(rname,pfx%unit(1)%mode(corrmode)%chtype(itype),f1,.true.,ic1,error)
  if (error) return
  call if2tochunk(rname,pfx%unit(1)%mode(corrmode)%chtype(itype),f2,.false.,ic2,error)
  if (error) return
  !
  call astro_noemasetup_spw_bychunk(rname,ispw,ic1,ic2,resol,label,user_label,corrmode,error)
  if (error) return
  !
end subroutine astro_noemasetup_spw_byfreq

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_calib_otf_fsw(mrtset,backcal,backsci,filebuf,error)
  use mrtcal_messaging
  use gkernel_interfaces
  use mrtcal_buffer_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this => mrtcal_calib_otf_fsw
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtcal_setup_t),    intent(in)    :: mrtset
  type(calib_backend_t),   intent(in)    :: backcal
  type(science_backend_t), intent(inout) :: backsci
  type(imbfits_buffer_t),  intent(inout) :: filebuf
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: ion,non
  character(len=*), parameter :: rname='CALIB>OTF>FSW'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call mrtcal_init_onloop(backsci,non,error)
  if (error) return
  do ion=1,non
     call mrtcal_get_nexton(backsci,error)
     if (error) return
     call mrtcal_init_dumpcycle_loop('onTheFly',mrtset,filebuf,backsci,error)
     if (error) return
     do while (backsci%switch%book%idump.lt.backsci%switch%book%ndump)
        call mrtcal_get_next_dumpcycle(mrtset,filebuf,backsci,error)
        if (error) return
        if (backsci%switch%book%found) then
           call mrtcal_on_minus_off(isotfmap,isfsw,backsci,error)
           if (error) return
           call mrtcal_tscale_computation(backcal,backsci,error)
           if (error) return
           call mrtcal_tscale_application(backsci%tscale,backsci%diff,error)
           if (error) return
           call mrtcal_write_toclass(backsci%diff,mrtset%out,backsci%nobs,error)
           if (error) return
        endif
     enddo ! switch%book%idump
     call mrtcal_switch_book_list(backsci%switch%book,error)
     if (error) return
     ! User can interrupt the pipeline
     if (sic_ctrlc_status()) then
        error = .true.
        exit
     endif
  enddo !ion
  !
end subroutine mrtcal_calib_otf_fsw
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_twosubc2onesubc
  use cubetools_structure
  use cubetemplate_two2one_template
  use cubetemplate_twosubc2onesubc_template
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: twosubc2onesubc
  private
  !
  type, extends(twosubc2onesubc_comm_t) :: ext_twosubc2onesubc_comm_t
     type(factor_comm_t)     :: factor
     type(cuberegion_comm_t) :: region
   contains
     procedure, public :: register => cubetemplate_ext_twosubc2onesubc_comm_register
     procedure, public :: parse    => cubetemplate_ext_twosubc2onesubc_comm_parse
  end type ext_twosubc2onesubc_comm_t
  type(ext_twosubc2onesubc_comm_t) :: twosubc2onesubc
  !
  type, extends(twosubc2onesubc_user_t) :: ext_twosubc2onesubc_user_t
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, public :: toprog => cubetemplate_ext_twosubc2onesubc_user_toprog
  end type ext_twosubc2onesubc_user_t
  !
  type, extends(twosubc2onesubc_prog_t) :: ext_twosubc2onesubc_prog_t
     type(cuberegion_prog_t) :: region
     type(factor_prog_t)     :: factor
   contains
     procedure, private :: act => cubetemplate_ext_twosubc2onesubc_prog_act
  end type ext_twosubc2onesubc_prog_t
  !
contains
  !
  subroutine cubetemplate_twosubc2onesubc_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ext_twosubc2onesubc_user_t) :: user
    type(ext_twosubc2onesubc_prog_t) :: prog
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call twosubc2onesubc%command(line,user,prog,error)
    if (error) return
  end subroutine cubetemplate_twosubc2onesubc_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_comm_register(comm,error)
    use cubedag_allflags
    use cubeadm_cubeid_types
    use cubeadm_cubeprod_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_comm_t), intent(inout) :: comm
    logical,                           intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: comm_abstract = 'Template command to access input/output data per subcubes'
    character(len=*), parameter :: comm_help = 'Input and output cubes are real'
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'TWOSUBC2ONESUBC','[cube1] [cube2]',&
         comm_abstract,&
         comm_help,&
         cubetemplate_twosubc2onesubc_command,&
         comm%comm,error)
    if (error) return
    call incube%register(&
         'FIRST',&
         'First cube',&
         strg_id,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube1,&
         error)
    if (error) return
    call incube%register(&
         'SECOND',&
         'Second cube',&
         strg_id,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_subset,&
         comm%incube2,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(  &
         'OUTPUT',  &
         'The result of the command',  &
         strg_id,  &
         [flag_template],  &
         comm%oucube,  &
         error)
    if (error)  return
  end subroutine cubetemplate_ext_twosubc2onesubc_comm_register
  !
  subroutine cubetemplate_ext_twosubc2onesubc_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! TWOSUBC2ONESUBC [cubeid1] [cubeid2]
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_comm_t), intent(in)    :: comm
    character(len=*),                  intent(in)    :: line
    class(two2one_user_t),             intent(out)   :: user
    logical,                           intent(inout) :: error
    !
    type(ext_twosubc2onesubc_user_t), pointer :: iuser
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    iuser => ext_twosubc2onesubc_user_ptr(user,error)
    if (error)  return
    call comm%two2one_comm_t%parse(line,iuser,error)
    if (error) return
    call comm%region%parse(line,iuser%region,error)
    if (error) return
    call comm%factor%parse(line,iuser%factor,error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_comm_parse
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_user_t), intent(in)    :: user
    class(two2one_comm_t),             intent(in)    :: comm
    class(two2one_prog_t),             intent(inout) :: prog
    logical,                           intent(inout) :: error
    !
    type(ext_twosubc2onesubc_prog_t), pointer :: iprog
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%two2one_user_t%toprog(comm,prog,error)
    if (error) return
    !
    iprog => ext_twosubc2onesubc_prog_ptr(prog,error)
    if (error)  return
    call user%factor%toprog(iprog%factor,error)
    if (error) return
    call user%region%toprog(iprog%incube1,iprog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call iprog%factor%list(error)
    if (error) return
    call iprog%region%list(error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_ext_twosubc2onesubc_prog_act(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_subcube_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ext_twosubc2onesubc_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),          intent(in)    :: iter
    logical,                           intent(inout) :: error
    !
    integer(kind=indx_k) :: ix,iy,iz
    type(subcube_t) :: insub1,insub2,ousub
    character(len=*), parameter :: rname='TWOSUBC2ONESUBC>PROG>ACT'
    !
    ! Subcubes are initialized here as their size (3rd dim) may change from
    ! from one subcube to another.
    call insub1%associate('insub1',prog%incube1,iter,error)
    if (error) return
    call insub2%associate('insub2',prog%incube2,iter,error)
    if (error) return
    call ousub%allocate('ousub',prog%oucube,iter,error)
    if (error) return
    !
    call insub1%get(error)
    if (error) return
    call insub2%get(error)
    if (error) return
    do iz=1,insub1%nz
       do iy=1,insub1%ny
          do ix=1,insub1%nx
             ousub%val(ix,iy,iz) = prog%factor%val*insub1%val(ix,iy,iz)+insub2%val(ix,iy,iz)
          enddo ! ix
       enddo ! iy
    enddo ! iz
    call ousub%put(error)
    if (error) return
  end subroutine cubetemplate_ext_twosubc2onesubc_prog_act
  !
  !----------------------------------------------------------------------
  !
  function ext_twosubc2onesubc_user_ptr(user,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_twosubc2onesubc_user_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_twosubc2onesubc_user_t), pointer       :: ext_twosubc2onesubc_user_ptr
    class(two2one_user_t),            target        :: user
    logical,                          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>USER>PTR'
    !
    select type(user)
    type is (ext_twosubc2onesubc_user_t)
      ext_twosubc2onesubc_user_ptr => user
    class default
      ext_twosubc2onesubc_user_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_twosubc2onesubc_user_t type')
      error = .true.
      return
    end select
  end function ext_twosubc2onesubc_user_ptr
  !
  function ext_twosubc2onesubc_prog_ptr(prog,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(ext_twosubc2onesubc_prog_t), and
    ! return a pointer to it if yes.
    !-------------------------------------------------------------------
    type(ext_twosubc2onesubc_prog_t), pointer       :: ext_twosubc2onesubc_prog_ptr
    class(two2one_prog_t),            target        :: prog
    logical,                          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXT>TWOSUBC2ONESUBC>PROG>PTR'
    !
    select type(prog)
    type is (ext_twosubc2onesubc_prog_t)
      ext_twosubc2onesubc_prog_ptr => prog
    class default
      ext_twosubc2onesubc_prog_ptr => null()
      call cubetemplate_message(seve%e,rname,  &
        'Internal error: object is not a ext_twosubc2onesubc_prog_t type')
      error = .true.
      return
    end select
  end function ext_twosubc2onesubc_prog_ptr
end module cubetemplate_twosubc2onesubc
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE USE_VCORR(NFIT,LIST,EL,ALPHA,BETA,
     +     CHI2,SD,ND,TIME,CODE,NP,
     +     REFPIX,REFVAL,VSTEP,SIGMA,VCORR,QUIET,ERROR)
C-------------------------------------------------------------------------
C ORBIT: update the linearised normal equation system, using constraints
C from one velocity profile.
C-------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INCLUDE 'control.inc'
      INCLUDE 'corrections.inc'
      REAL*8 REFPIX,REFVAL,VSTEP,TIME,EL(MA)
      INTEGER NP,NFIT,LIST(NFIT),CODE
      REAL ALPHA(MA,MA)
      REAL BETA(NFIT)
      REAL SIGMA,SD,CHI2
      INTEGER ND
      REAL VCORR(NP)
      LOGICAL QUIET,ERROR
*
*
      INTEGER I,J,ICOMP,NLINE,ILINE,IC
      INTEGER LINES(2,MORBIT)
      REAL DY,SIG2I
      REAL V(NCOMPONENTS),CORRECTION(MVPNTS)
      REAL B(MA),GG(MA,NCOMPONENTS) !G1(MA),G2(MA),
      REAL VALUE,FLUX
      REAL*8 PARG(3+3*NCOMPONENTS),G(3*NCOMPONENTS),XVEL,FGAUSS
      INTEGER IW(2,MORBIT),IEW(2,MORBIT)
!      real*4 x(MVPNTS),y(MVPNTS),Yc(mvpnts) ! For debugging display only
      INTEGER IORB
      REAL PROFILE_MEAN
*
* Reset everything from possible previous call with more components. Should
* not be needed, but does not cost much...
      DO I=1,3*NCOMPONENTS
         PARG(I+3) = 0
         G(I) = 0
      ENDDO
      DO I=1,NCOMPONENTS
         V(I) = 0 
      ENDDO
      DO I=1,MORBIT
         LINES(1,I) = 0
         LINES(2,I) = 0
      ENDDO
* Initialise residual from gaussian to zero
      DO I=1,NP
         CORRECTION(I) = 0
      ENDDO
* Parameters for dependent gaussians are unused here, set them to their
* default value.
      PARG(1)=1 
      PARG(2)=0 ! to their defaults
      PARG(3)=1
* Determine which parameters apply to current profile, looking first for 
* specific parameters for the current radial velocity origin, and falling 
* back to generic ones if the latter are absent. This is done on a per
* parameter basis.
      CALL SELECT_PROFILE_PARAMETERS(CODE,IEW,IW,ERROR)
      IF (ERROR) GOTO 99
*
* Prepare descriptive parameters for all relevant gaussians
      NLINE = 0
      DO IORB=1,MORBIT
* Compute gradients of velocities relative to orbital elements, and get
* the values for free. 
         DO ICOMP=1,2
            IF (EL(IEW(ICOMP,IORB)).NE.0) THEN ! Area is non-zero, fill in
               IC = (IORB-1)*10+ICOMP
               NLINE = NLINE+1
               LINES(ICOMP,IORB) = NLINE
               CALL GET_GRADVEL(TIME,IC,CODE,V(NLINE),
     +              GG(1,NLINE),ERROR)
               IF (ERROR) GOTO 99
               PARG(3*NLINE+1) = EL(IEW(ICOMP,IORB)) ! Area for star
               PARG(3*NLINE+2) = V(NLINE) ! Center for star 1
               PARG(3*NLINE+3) = EL(IW(ICOMP,IORB)) ! Width for star
* Optionally compute profile deviations from a gaussian
               IF (PROFILE_METHOD.EQ.'CORRECTED') THEN
                  CALL ACCUMULATE_PROFILE_CORRECTION(ICOMP,IORB,
     +                 V(NLINE),NP,REFPIX,REFVAL,VSTEP,
     +                 CORRECTION,ERROR)
                  IF (ERROR) GOTO 99
               ENDIF
            ENDIF
         ENDDO
      ENDDO
* Determine normalisation factor (for Andrei's unnormalised profiles at least)
* Must decide if this should be kept or not. No profile correction at this 
* step, in the hope that it has close to zero mean.
      FLUX = PROFILE_MEAN(NP,REFPIX,REFVAL,VSTEP,VCORR,NLINE,PARG)
*
      SIG2I=1/SIGMA**2
*
* Now, accumulate the contribution of each correlation profile data point
* to the least square process
      DO I=1,NP
         XVEL = REFVAL+(I-REFPIX)*VSTEP
         VALUE = 1-SNGL(FGAUSS(XVEL,NLINE,PARG))
!         x(i) = xvel
!         y(i) = vcorr(i)
!         yc(i) = vcorr(i)-correction(i)
*
         DY=VCORR(I)-CORRECTION(I)-VALUE
         SD=SD+DY*DY
*  Get gradient of the gaussian profile sum relative to its 3*NLINE 
*  descriptive parameters
         CALL DGAUSS (XVEL,NLINE,PARG,G)
* Compute profile gradient relative to the orbital elements from the partial 
* derivatives relative to central velocities, plus the gradients of 
* the velocities relative to the orbital elements.
         DO J=1,MA
            B(J) = 0
            DO ILINE=1,NLINE
               B(J) = B(J) - GG(J,ILINE)*G(3*ILINE+2)
            ENDDO 
            B(J) = FLUX*B(J)
         ENDDO
!         write(6,*) 'flux',flux
!         write(6,*) 'G',G
* Width and area are orbital elements: just copy over the corresponding 
* partial derivatives. 
         DO IORB=1,MORBIT
            DO ICOMP=1,2
               IF (LINES(ICOMP,IORB).NE.0) THEN
                  B(IEW(ICOMP,IORB)) = 
     +                 -FLUX*G(3*LINES(ICOMP,IORB)+1) ! Derivative /Area 
                  B(IW(ICOMP,IORB)) =
     +                 -FLUX*G(3*LINES(ICOMP,IORB)+3) ! Derivative /Width
               ENDIF
            ENDDO
         ENDDO
* Update the normal equations
         CALL COVSUM(NFIT,MA,ALPHA,BETA,B,LIST,DY,CHI2,SIG2I
     +        ,QUIET,ERROR)
         IF (ERROR) THEN
            IF (.NOT.QUIET) THEN
               WRITE(6,*) 
     +              'E-NORMAL, Error using velocity profile information'
            ENDIF
            RETURN
         ENDIF
      ENDDO

      ND = ND+NP
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

      FUNCTION PROFILE_MEAN(NP,REF,VAL,INC,Y,NLINE,PARG)
C----------------------------------------------------------------------------
* Determine normalisation factor (for Andrei's unnormalised profiles at least)
* Must decide if this should be kept or not. No profile correction at this 
* step, in the hope that it has close to zero mean.
C----------------------------------------------------------------------------
      REAL PROFILE_MEAN
      INTEGER NP
      REAL Y(NP)
      REAL*8 REF,VAL,INC
      INTEGER NLINE
      REAL*8 PARG(3*NLINE)
*
      INTEGER I,NF
      REAL*8 FLUX,XVEL,VALUE
      REAL*8 FGAUSS
*
      FLUX=0
      NF=0
      DO I=1,NP
         XVEL = VAL+(I-REF)*INC
         VALUE = 1-SNGL(FGAUSS(XVEL,NLINE,PARG))
         IF (VALUE.GT.0.5) THEN
            FLUX=FLUX+(Y(I)/VALUE)
            NF=NF+1
         ENDIF
      ENDDO
      IF (NF.GT.0) THEN
         PROFILE_MEAN=FLUX/NF
      ELSE
         PROFILE_MEAN=1.
      ENDIF
      END
*
*

      SUBROUTINE SELECT_PROFILE_PARAMETERS(ORIGIN,
     +     IEW,IW,ERROR)
C---------------------------------------------------------------------------
C Determine which parameters apply to current profile, looking first for 
C specific parameters for the current radial velocity origin, and falling 
C back to generic ones if the latter are absent.
C---------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INTEGER ORIGIN
      INTEGER IEW(2,MORBIT),IW(2,MORBIT)
      LOGICAL ERROR
*
      INCLUDE 'elements.inc'
      INCLUDE 'data.inc'
*
      INTEGER IORB, IORI
*
      DO IORB=1,MORBIT
*
* Check if parameter is defined for current origin
         IF (ELERR(I_EW1+(ORIGIN-1)*4+ELINDX(IORB)).GE.0) THEN
            IEW(1,IORB)  = I_EW1+(ORIGIN-1)*4+ELINDX(IORB)
         ELSE
* Otherwise look for the first origin where it is defined
            DO IORI=1,NVREF
               IF (ELERR(I_EW1+(IORI-1)*4+ELINDX(IORB)).GE.0) THEN
                  IEW(1,IORB)  = I_EW1+(IORI-1)*4+ELINDX(IORB)
                  GOTO 10
               ENDIF
            ENDDO
* As a last resort, fall back to origin 1, to ensure amongst other thing
* that barycenters of higher level binaries get attributed a proper dummy
* profile number
            IEW(1,IORB)  = I_EW1+ELINDX(IORB)
         ENDIF
 10      CONTINUE
         IF (ELERR(I_EW2+(ORIGIN-1)*4+ELINDX(IORB)).GE.0) THEN
            IEW(2,IORB)  = I_EW2+(ORIGIN-1)*4+ELINDX(IORB)
         ELSE
            DO IORI=1,NVREF
               IF (ELERR(I_EW2+(IORI-1)*4+ELINDX(IORB)).GE.0) THEN
                  IEW(2,IORB)  = I_EW2+(IORI-1)*4+ELINDX(IORB)
                  GOTO 20
               ENDIF
            ENDDO
            IEW(2,IORB)  = I_EW2+ELINDX(IORB)
         ENDIF
 20      CONTINUE
         IF (ELERR(I_W1+(ORIGIN-1)*4+ELINDX(IORB)).GE.0) THEN
            IW(1,IORB)  = I_W1+(ORIGIN-1)*4+ELINDX(IORB)
         ELSE
            DO IORI=1,NVREF
               IF (ELERR(I_W1+(IORI-1)*4+ELINDX(IORB)).GE.0) THEN
                  IW(1,IORB)  = I_W1+(IORI-1)*4+ELINDX(IORB)
                  GOTO 30
               ENDIF
            ENDDO
            IW(1,IORB)  = I_W1+ELINDX(IORB)
         ENDIF
 30      CONTINUE
         IF (ELERR(I_W2+(ORIGIN-1)*4+ELINDX(IORB)).GE.0) THEN
            IW(2,IORB)  = I_W2+(ORIGIN-1)*4+ELINDX(IORB)
         ELSE
            DO IORI=1,NVREF
               IF (ELERR(I_W2+(IORI-1)*4+ELINDX(IORB)).GE.0) THEN
                  IW(2,IORB)  = I_W2+(IORI-1)*4+ELINDX(IORB)
                  GOTO 40
               ENDIF
            ENDDO
            IW(2,IORB)  = I_W2+ELINDX(IORB)
         ENDIF
 40      CONTINUE
      ENDDO

      RETURN
      END
*
      SUBROUTINE UPDATE_PROFILE_CORRECTIONS(QUIET,ERROR)
C------------------------------------------------------------------------------
C  Updates the estimate of the residuals of the average correlation profile
C  from a gaussian. To be called before each iteration when fitting to 
C  profiles.
C
C------------------------------------------------------------------------------
      LOGICAL QUIET,ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'corrections.inc'
      INCLUDE 'data.inc'
*
      REAL GAIN 
      PARAMETER (GAIN=0.5)
      INTEGER IORB,I,IC,ICOMP
      REAL TMP(MVPNTS)
      REAL SIGMA,AREA,MAX_AREA
      REAL AMPLITUDE(2,MORBIT),MAX_AMP,FACT,FACTOR
      INTEGER IEW(2,MORBIT),IW(2,MORBIT),ORIGIN
      PARAMETER (ORIGIN=1)
      real x(mvpnts)
      CHARACTER ANSWER*1
*
*
      IF (NVCORR.LE.1) THEN
         RETURN
      ELSEIF (NVCORR.LE.4) THEN
         WRITE(6,*) 'W-CORRECT,  Number of profiles is small, ',
     +        'correction is probably unstable'
      ENDIF
      MAX_AREA = 0.0
*
      CALL SELECT_PROFILE_PARAMETERS(ORIGIN,IEW,IW,ERROR)

      IF (.NOT.QUIET) write(6,*) 'Updating corrections'
      DO IORB=1,MORBIT
         DO ICOMP=1,2
            AMPLITUDE(ICOMP,IORB) = 0.
            IC    = COMPONENTS(ICOMP,IORB)
            AREA = EL(IEW(ICOMP,IORB))
            IF (AREA.EQ.0) THEN ! Store no correction to non-detected comps
               NPNTS_CORRECTED(ICOMP,IORB) = 0
            ELSE
*     Compute the average correlation profile 
               NPNTS_CORRECTED(ICOMP,IORB) = MVPNTS
               CALL AVERAGE_CORREL_PROFILE(IC,
     +              NPNTS_CORRECTED(ICOMP,IORB),
     +              CORRECTED_REF(ICOMP,IORB),
     +              CORRECTED_VAL(ICOMP,IORB),
     +              CORRECTED_INC(ICOMP,IORB),
     +              PROFILE_CORRECTIONS(1,ICOMP,IORB),
     +              TMP,ERROR)
               IF (ERROR) GOTO 99
!!
!               DO I=1,NPNTS_CORRECTED(ICOMP,IORB)
!                  X(I) = CORRECTED_VAL(ICOMP,IORB)+
!     +                 (I-CORRECTED_REF(ICOMP,IORB))
!     +                 *CORRECTED_INC(ICOMP,IORB)
!               ENDDO
!               call DEBUG_PLOT(NPNTS_CORRECTED(ICOMP,IORB),X,
!     +              profile_corrections(1,icomp,IORB),.TRUE.)
!               write(6,*)    NPNTS_CORRECTED(ICOMP,IORB)
!               do i=1,NPNTS_CORRECTED(ICOMP,IORB)
!                  write(6,*) x(i),profile_corrections(i,icomp,IORB)
!               enddo
!               write(6,*) IORB,ICOMP,'Type return to continue'
!               read(5,*)
!
*     Compute its deviation from a gaussian
               CALL GET_MODEL_PROFILE(0,1,IC,.TRUE.,.FALSE.,
     +              NPNTS_CORRECTED(ICOMP,IORB),
     +              CORRECTED_REF(ICOMP,IORB),
     +              CORRECTED_VAL(ICOMP,IORB),
     +              CORRECTED_INC(ICOMP,IORB),
     +              TMP,ERROR)
               IF (ERROR) GOTO 99
               DO I=1,NPNTS_CORRECTED(ICOMP,IORB)
                  PROFILE_CORRECTIONS(I,ICOMP,IORB) = 
     +                 PROFILE_CORRECTIONS(I,ICOMP,IORB)-TMP(I)
               ENDDO

!               call DEBUG_PLOT(NPNTS_CORRECTED(ICOMP,IORB),X,
!     +              TMP,.TRUE.)
!     +              profile_corrections(1,icomp,IORB),.TRUE.)
!               write(6,*)    NPNTS_CORRECTED(ICOMP,IORB)
!               do i=1,NPNTS_CORRECTED(ICOMP,IORB)
!                  IF (tmp(i).ne.tmp(i).or.abs(tmp(i)).gt.1) then
!                     write(6,*) 'profile:',i,x(i),tmp(i)
!                  endif
!               enddo
!               write(6,*) IORB,ICOMP,'Type return to continue'
!               read(5,*)
* Damp down the profile corrections in the core. Avoids transfers between
* gaussian core and correction.
               SIGMA = EL(IW(ICOMP,IORB))
               SIGMA = 5*SIGMA ! Strong damping.
               DO I=1,NPNTS_CORRECTED(ICOMP,IORB)
                  X(I) = CORRECTED_VAL(ICOMP,IORB)+
     +                 (I-CORRECTED_REF(ICOMP,IORB))
     +                 *CORRECTED_INC(ICOMP,IORB)
                  FACTOR = 1-EXP(-(X(I)/SIGMA)**2)
                  PROFILE_CORRECTIONS(I,ICOMP,IORB) = 
     +                 PROFILE_CORRECTIONS(I,ICOMP,IORB)
     +                 *FACTOR
* Compute the L2 norm of the correction for each component, and determine
* the correction norm for the strongest component.
                  AMPLITUDE(ICOMP,IORB) = AMPLITUDE(ICOMP,IORB)+
     +                 PROFILE_CORRECTIONS(I,ICOMP,IORB)**2
               ENDDO
               AMPLITUDE(ICOMP,IORB) = SQRT(AMPLITUDE(ICOMP,IORB)
     +              /NPNTS_CORRECTED(ICOMP,IORB))
!               write(6,*) Icomp, iorb,  AMPLITUDE(ICOMP,IORB)
               IF (ABS(AREA).GT.MAX_AREA) THEN
                  MAX_AREA = ABS(AREA)
                  MAX_AMP  = AMPLITUDE(ICOMP,IORB)
               ENDIF
               ENDIF
            ENDDO
         ENDDO
* Normalise the amplitude of the correction to that of the strongest component,
* so as to avoid introducing noise for weak components. This assumes that the
* PSF is not significantly less gaussian for weak components than for strong
* ones. This hopefully is approximately true when their spectral types are
* not too different.
         DO IORB=1,MORBIT
            DO ICOMP=1,2
               IF (EL(IEW(ICOMP,IORB)).GT.0) THEN
                  FACT = (AMPLITUDE(ICOMP,IORB)/MAX_AMP)/
     +                 (ABS(EL(IEW(ICOMP,IORB)))/MAX_AREA)
                  IF (FACT.LT.1) FACT=1 ! Don't amplify...
                  write(6,*) iorb, icomp, fact
                  DO I=1,NPNTS_CORRECTED(ICOMP,IORB)
                     PROFILE_CORRECTIONS(I,ICOMP,IORB) =
     +                    PROFILE_CORRECTIONS(I,ICOMP,IORB)/FACT
                  ENDDO
!                  write(6,*) 'NORMALISATION: ',fact
! Check during development...
!                  CALL DEBUG_PLOT(NPNTS_CORRECTED(ICOMP,IORB),X,
!     +              profile_corrections(1,icomp,IORB),.TRUE.)
!                  CALL DEBUG_PLOT(NPNTS_CORRECTED(ICOMP,IORB),X,
!     +              TMP,.FALSE.)
!               write(6,*) 'Type return to continue'
!               read(5,*)
* In interactive mode, plot the correction
                  IF (.NOT.QUIET) THEN
                     DO I=1,NPNTS_CORRECTED(ICOMP,IORB)
                        X(I) = CORRECTED_VAL(ICOMP,IORB)+
     +                       (I-CORRECTED_REF(ICOMP,IORB))
     +                       *CORRECTED_INC(ICOMP,IORB)
                        FACTOR = 1-EXP(-(X(I)/SIGMA)**2)
                     ENDDO
                     CALL DEBUG_PLOT(NPNTS_CORRECTED(ICOMP,IORB),X,
     +                    profile_corrections(1,icomp,IORB),.TRUE.)
                     write(6,*) 
     +                    'Correction to gaussian profile'
                     write(6,*) 'Type return to continue, Q to quit'
                     ANSWER = ' '
                     read(5,'(A)') ANSWER
                     IF (ANSWER.EQ.'Q'.OR.ANSWER.EQ.'q') GOTO 99
                     write(6,*) answer
                  ENDIF
            ENDIF
         ENDDO
      ENDDO

      write(6,*) 'Corrections updated'
*
      RETURN
 99   ERROR = .TRUE.
      RETURN
      END



      SUBROUTINE DEBUG_PLOT(N,X,Y,NEW)
      INTEGER N
      REAL X(N),Y(N)
      LOGICAL NEW
*
      CHARACTER CHAIN*32
      INTEGER ICURVE
      SAVE ICURVE
*
      IF (N.EQ.0) RETURN
*
      CALL GR4_GIVE('X',N,X)
      CALL GR4_GIVE('Y',N,Y)
      IF (NEW) THEN
         CALL GR_EXEC('CLEAR PLOT')
         CALL GR_EXEC('LIMITS  ')
         CALL GR_EXEC('SET BOX LANDSCAPE')
         CALL GR_EXEC('BOX')
         CALL GR_EXEC('HISTO')
         ICURVE = 1
      ELSE
         ICURVE = ICURVE+1
         IF (ICURVE.GE.100) THEN
            WRITE(6,*) 'Too many curves'
            RETURN
         ENDIF
         WRITE(CHAIN,1010) ICURVE, ICURVE
 1010    FORMAT('PEN ',I2,' /DASH ',I2)
         CALL GR_EXEC(CHAIN)
         CALL GR_EXEC('CONNECT')
         CALL GR_EXEC('PEN /DEF')
      ENDIF
      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehelp_language
  use cubetools_parameters
  use cubetools_structure
  use cube_debug
  use cubehelp_check
  use cubehelp_collect
  use cubehelp_help
  use cubehelp_question
  !
  public :: cubehelp_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubehelp_register_language(error)
    !----------------------------------------------------------------------
    ! Register the HELP\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language('HELP',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands to get help or debug the program',&
         strg_emp,&
         'gag_doc:hlp/cube-help-help.hlp',&
         cubehelp_execute_command,langid,error)
    if (error) return
    !
    call cubehelp_question_register(error) ! This one needs to be first here
    if (error) return
    call collect%register(error)
    if (error) return
    call cubehelp_help_register(error)
    if (error) return
    call cubehelp_check_register(error)
    if (error) return
    call cube_debug_register(error)
    if (error) return
    !
    call cubetools_register_dict(error)
    if (error) return
  end subroutine cubehelp_register_language
  !
  subroutine cubehelp_execute_command(line,comm,error)
    !----------------------------------------------------------------------
    ! Execute a command of the HELP\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'HELP?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubetools_execute_command(line,langid,comm,error)
       if (error) return
    endif
  end subroutine cubehelp_execute_command
end module cubehelp_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_observatory
  use phys_const
  use cubetools_parameters
  use cubetools_structure
  use cubetools_obstel_prog_types
  use cubesyntax_keyval_types
  use cubesimulate_messaging
  !
  public :: observatory_comm_t,observatory_prog_t
  public :: observatory_comm,observatory_prog
  private
  !
  type :: observatory_comm_t
     type(option_t), pointer      :: comm
     type(keyval_strg_comm_t)     :: name
     type(keyvalunit_real_comm_t) :: horizon
   contains
     procedure, public  :: register => cubesimulate_observatory_comm_register
     procedure, private :: parse    => cubesimulate_observatory_comm_parse
     procedure, private :: main     => cubesimulate_observatory_comm_main
  end type observatory_comm_t
  type(observatory_comm_t), target :: observatory_comm
  !
  type observatory_user_t
     logical :: dolist = .false.
     type(keyval_strg_user_t) :: name
     type(keyvalunit_real_user_t) :: horizon
   contains
     procedure, private :: toprog => cubesimulate_observatory_user_toprog
  end type observatory_user_t
  !
  type :: observatory_prog_t
     character(len=tele_l) :: name = 'NOEMA'
     type(obstel_prog_t)   :: tel
     real(kind=real_k) :: horizon = 20d0*rad_per_deg ! [rad] Horizon (i.e. minimum elevation)
     real(kind=coor_k) :: matrix(9) = 0d0            ! [---] Matrix from Hr/Dec to Az/El
   contains
     procedure, public  :: list   => cubesimulate_observatory_prog_list
     procedure, private :: header => cubesimulate_observatory_prog_header
  end type observatory_prog_t
  type(observatory_prog_t), target :: observatory_prog
  !
contains
  !
  subroutine cubesimulate_observatory_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(observatory_user_t) :: user
    character(len=*), parameter :: rname='OBSERVATORY>COMMAND'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call observatory_comm%parse(line,user,error)
    if (error) return
    call observatory_comm%main(user,observatory_prog,error)
    if (error) continue
  end subroutine cubesimulate_observatory_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_comm_register(comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(inout) :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>REGISTER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'OBSERVATORY','',&
         'Set or list the observatory setup',&
         'Without options, list the current observatory name, telescope&
         & metadata, and horizon. /NAME and /HORIZON update the shared&
         & observatory setup used by simulate commands. /HORIZON must stay&
         & within [3,90] degree after unit conversion.',&
         cubesimulate_observatory_command,&
         comm%comm,&
         error)
    if (error) return
    call comm%name%register(&
         'NAME',&
         'Observatory name to load',&
         strg_emp,&
         observatory_prog%name,&
         'Observatory name. Default is NOEMA. Unknown names are&
         & accepted, but telescope coordinates can remain undefined (NaN).',&
         error)
    if (error) return
    call comm%horizon%register(&
         'HORIZON',&
         'Minimum elevation cutoff',&
         strg_emp,&
         observatory_prog%horizon,&
         code_unit_pang,&
         'Use "*" to keep the default value (20 degree). The horizon&
         & must be in [3,90] degree after unit conversion.',&
         error)
    if (error) return
  end subroutine cubesimulate_observatory_comm_register
  !
  subroutine cubesimulate_observatory_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! OBSERVATORY /NAME name
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(observatory_user_t),  intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>PARSE'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (cubetools_nopt().eq.0) then
       user%dolist = .true.
    else
       user%dolist = .false.
       call comm%name%parse(line,user%name,error)
       if (error) return
       call comm%horizon%parse(line,user%horizon,error)
       if (error) return
    endif
  end subroutine cubesimulate_observatory_comm_parse
  !
  subroutine cubesimulate_observatory_comm_main(comm,user,prog,error) 
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_comm_t), intent(in)    :: comm
    type(observatory_user_t),  intent(inout) :: user
    type(observatory_prog_t),  intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>COMM>MAIN'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    if (user%dolist) then
       call prog%header(comm,error)
       if (error) return
       call prog%list(comm,error)
       if (error) return
    else
       call user%toprog(comm,prog,error)
       if (error) return
       call prog%header(comm,error)
       if (error) return
    endif
  end subroutine cubesimulate_observatory_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_user_toprog(user,comm,prog,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(observatory_user_t), intent(in)    :: user
    type(observatory_comm_t),  intent(in)    :: comm    
    type(observatory_prog_t),  intent(out)   :: prog
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>USER>TOPROG'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call user%name%toprog(comm%name,prog%name,error)
    if (error) return
    call user%horizon%toprog(comm%horizon,prog%horizon,error)
    if (error) return
  end subroutine cubesimulate_observatory_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesimulate_observatory_prog_header(prog,comm,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(observatory_prog_t), intent(inout) :: prog
    type(observatory_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='OBSERVATORY>PROG>HEADER'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call prog%tel%create_from_name(prog%name,error)
    if (error) return
    prog%matrix = hrdec2azel_matrix(prog%tel%lat)
    call check_horizon(prog%horizon*deg_per_rad,error)
    if (error) return
    !
  contains
    !
    function hrdec2azel_matrix(latitude) result(matrix)
      !---------------------------------------------------------------------
      ! Define the matrix to translate from Hr/Dec to Az/El
      !---------------------------------------------------------------------
      real(kind=coor_k), intent(in) :: latitude
      real(kind=coor_k)             :: matrix(9)  ! intent(out)
      !
      real(kind=coor_k) :: sinlat,coslat
      !
      sinlat=dsin(latitude)
      coslat=dcos(latitude)
      matrix(1)=-sinlat
      matrix(2)=0.d0
      matrix(3)=coslat
      matrix(4)=0.d0
      matrix(5)=-1.d0
      matrix(6)=0.d0
      matrix(7)=coslat
      matrix(8)=0.d0
      matrix(9)=sinlat
    end function hrdec2azel_matrix
    !
    subroutine check_horizon(horizon,error)
      real(kind=coor_k), intent(in)    :: horizon
      logical,           intent(inout) :: error
      !
      if (horizon.lt.3d0) then
         ! Too low
         call cubesimulate_message(seve%e,rname,'Observatory horizon lower than 3 deg')
         error = .true.
         return
      else if (horizon.gt.90d0) then
         ! Too high
         call cubesimulate_message(seve%e,rname,'Observatory horizon larger than 90 deg')
         error = .true.
         return
      endif
    end subroutine check_horizon
  end subroutine cubesimulate_observatory_prog_header
  !
  subroutine cubesimulate_observatory_prog_list(prog,comm,error)
    use cubetools_unit
    use cubesyntax_keyvalunit_list_tool
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(observatory_prog_t), intent(inout) :: prog
    type(observatory_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    type(keyvalunit_real_prog_t) :: keyvalunit_real
    character(len=*), parameter :: rname='OBSERVATORY>PROG>LIST'
    !
    call cubesimulate_message(simulateseve%trace,rname,'Welcome')
    !
    call cubesimulate_message(seve%r,rname,blankstr)
    call cubesimulate_message(seve%r,rname,'Observatory')
    !
    call prog%tel%list(error)
    if (error) return
    call keyvalunit_real%list(comm%horizon,prog%horizon,error)
    if (error) return
  end subroutine cubesimulate_observatory_prog_list
end module cubesimulate_observatory
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gsys_interfaces_public
  interface
    subroutine sic_ambigs(prog,line,comm,ncom,vocab,nv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Resolves command abbreviations and check for ambiguities
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: prog       ! Message prefix
      character(len=*), intent(in)    :: line       ! Abbreviation to be analysed
      character(len=*), intent(out)   :: comm       ! Command found
      integer(kind=4),  intent(out)   :: ncom       ! Command number
      integer(kind=4),  intent(in)    :: nv         ! List of commands
      character(len=*), intent(in)    :: vocab(nv)  ! Number of command
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine sic_ambigs
  end interface
  !
  interface
    subroutine sic_ambigs_sub(prog,line,comm,ncom,vocab,nv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Still to be renamed
      ! Same as 'sic_ambigs' but:
      !  - do not recognize "?" which can be used to list all the
      !    possible values,
      !  - do not raise an error if no known keyword is found.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: prog       ! Message prefix
      character(len=*), intent(in)    :: line       ! Abbreviation to be analysed
      character(len=*), intent(out)   :: comm       ! Command found
      integer(kind=4),  intent(out)   :: ncom       ! Command number
      integer(kind=4),  intent(in)    :: nv         ! List of commands
      character(len=*), intent(in)    :: vocab(nv)  ! Number of command
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine sic_ambigs_sub
  end interface
  !
  interface
    subroutine sic_ambigs_list(caller,sever,message,vocab,ikeys,first,last)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Display an ambiguity list
      !---------------------------------------------------------------------
      character(len=*), intent(in)                   :: caller    ! Calling routine name
      integer(kind=4),  intent(in)                   :: sever     ! Severity of header message
      character(len=*), intent(in)                   :: message   ! Header message before list
      character(len=*), intent(in)                   :: vocab(:)  ! List of keywords
      integer(kind=4),  intent(in), optional, target :: ikeys(:)  ! Restrict to these keys?
      integer(kind=4),  intent(in), optional         :: first     ! Truncate start of string?
      integer(kind=4),  intent(in), optional         :: last      ! Truncate or force to this length?
    end subroutine sic_ambigs_list
  end interface
  !
  interface gag_infini
    subroutine gag_infini4(anum,string,ndg)
      !---------------------------------------------------------------------
      ! @ public-generic gag_infini
      ! Format Invalid Numbers (single precision version)
      !---------------------------------------------------------------------
      real(kind=4),     intent(in)  :: anum    ! Number
      character(len=*), intent(out) :: string  ! Representation
      integer(kind=4),  intent(out) :: ndg     ! Length of string
    end subroutine gag_infini4
    subroutine gag_infini8(anum,string,ndg)
      !---------------------------------------------------------------------
      ! @ public-generic gag_infini
      ! Format Invalid Numbers (double precision version)
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)  :: anum    ! Number
      character(len=*), intent(out) :: string  ! Representation
      integer(kind=4),  intent(out) :: ndg     ! Length of string
    end subroutine gag_infini8
  end interface gag_infini
  !
  interface gag_notanum
    subroutine gag_notanum4(notanum)
      !---------------------------------------------------------------------
      ! @ public-generic gag_notanum
      ! Return the value of NaN (R*4 version)]
      !  An IEEE signaling NaN is represented by any bit pattern
      !    between X'7F80 0001' and X'7FBF FFFF', or
      !    between X'FF80 0001' and X'FFBF FFFF'.
      !  An IEEE quiet NaN is represented by any bit pattern
      !    between X'7FC0 0000' and X'7FFF FFFF', or
      !    between X'FFC0 0000' and X'FFFF FFFF'.
      !---------------------------------------------------------------------
      real(kind=4), intent(out) :: notanum  ! NaN value
    end subroutine gag_notanum4
    subroutine gag_notanum8(notanum)
      !---------------------------------------------------------------------
      ! @ public-generic gag_notanum
      ! Return the value of NaN (R*8 version)
      !  An IEEE signaling NaN is represented by any bit pattern
      !    between X'7FF00000 00000001' and X'7FF7FFFF FFFFFFFF', or
      !    between X'FFF00000 00000001' and X'FFF7FFFF FFFFFFFF'.
      !  An IEEE quiet NaN is represented by any bit pattern
      !    between X'7FF80000 00000000' and X'7FFFFFFF FFFFFFFF', or
      !    between X'FFF80000 00000000' and X'FFFFFFFF FFFFFFFF'.
      !---------------------------------------------------------------------
      real(kind=8), intent(out) :: notanum  ! NaN value
    end subroutine gag_notanum8
  end interface gag_notanum
  !
  interface
    function sic_ctrlc()
      use gsys_variables
      !---------------------------------------------------------------------
      ! @ public
      ! Return .TRUE. if ^C has been pressed, and restore CONTROLC flag to
      ! .FALSE.
      !---------------------------------------------------------------------
      logical :: sic_ctrlc  ! Function value on return
    end function sic_ctrlc
  end interface
  !
  interface
    function sic_ctrlc_status()
      use gsys_variables
      !---------------------------------------------------------------------
      ! @ public
      ! Return .TRUE. if ^C has been pressed but do *not* restore CONTROLC
      ! flag to .FALSE.
      !---------------------------------------------------------------------
      logical :: sic_ctrlc_status  ! Function value on return
    end function sic_ctrlc_status
  end interface
  !
  interface
    subroutine gag_fromdate(date,idate,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Converts the date '01-JAN-1984' in internal code
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: date   ! String date
      integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_fromdate
  end interface
  !
  interface
    subroutine gag_todate(idate,date,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Converts the internal code to formatted date
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
      character(len=*), intent(out)   :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_todate
  end interface
  !
  interface
    subroutine gag_fromyyyymmdd(string,dobs,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Decode a string date in the format "YYYYMMDD" into a gag date
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: string  !
      integer(kind=4),  intent(out)   :: dobs    !
      logical,          intent(inout) :: error   !
    end subroutine gag_fromyyyymmdd
  end interface
  !
  interface
    subroutine gag_toyyyymmdd(dobs,string,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Encode a gag date to a string date in the format "YYYYMMDD"
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: dobs    !
      character(len=*), intent(out)   :: string  !
      logical,          intent(inout) :: error   !
    end subroutine gag_toyyyymmdd
  end interface
  !
  interface
    subroutine gag_isodate(date,idate,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Converts the ISO #8601 date '1996-10-14T10:34:55.345' in internal
      ! code.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: date   ! String date
      integer(kind=4),  intent(out)   :: idate  ! Internal coded date value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_isodate
  end interface
  !
  interface
    subroutine gag_toisodate(idate,date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts the internal code to ISO formatted date
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: idate  ! Internal coded date value
      character(len=*), intent(out)   :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_toisodate
  end interface
  !
  interface
    subroutine isodate_to_gagdate(date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine isodate_to_gagdate
  end interface
  !
  interface
    subroutine gagdate_to_isodate(date,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Converts an ISO date representation to a GAG (DD-Monthname-YY) date
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: date   ! String date
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gagdate_to_isodate
  end interface
  !
  interface
    subroutine gag_datj(id,im,iy,jour)
      !---------------------------------------------------------------------
      ! @ public
      !   Convert a date (id/im/iy) in number of days till the 01/01/1984
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: id    ! Day number
      integer(kind=4), intent(in)  :: im    ! Month number
      integer(kind=4), intent(in)  :: iy    ! Year number
      integer(kind=4), intent(out) :: jour  ! Elapsed day count
    end subroutine gag_datj
  end interface
  !
  interface
    subroutine gag_jdat(jour,id,im,iy)
      !---------------------------------------------------------------------
      ! @ public
      ! Reverse conversion
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: jour  ! Elapsed day count
      integer(kind=4), intent(out) :: id    ! Day number
      integer(kind=4), intent(out) :: im    ! Month number
      integer(kind=4), intent(out) :: iy    ! Year number
    end subroutine gag_jdat
  end interface
  !
  interface
    subroutine gag_isodate2mjd(timestring,mjd,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Convert an ISO #8601 date string of the form:
      !   2015-01-09T08:58:19.230000
      ! into a Modified Julian Date value.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: timestring
      real(kind=8),     intent(out)   :: mjd
      logical,          intent(inout) :: error
    end subroutine gag_isodate2mjd
  end interface
  !
  interface
    subroutine gag_mjd2isodate(mjd,timestring,error)
      use phys_const
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Convert a Modified Julian Date value to an ISO #8601 date string
      ! of the form:
      !   2015-01-09T08:58:19.230000
      !   123456789 123456789 123456
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)    :: mjd
      character(len=*), intent(out)   :: timestring
      logical,          intent(inout) :: error
    end subroutine gag_mjd2isodate
  end interface
  !
  interface
    subroutine gag_gagut2mjd(date,ut,mjd,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Convert a GAG_DATE + UT into a MJD date
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: date   ! [gag]
      real(kind=8),    intent(in)    :: ut     ! [rad] Day starts at 0 radians
      real(kind=8),    intent(out)   :: mjd    !
      logical,         intent(inout) :: error  !
    end subroutine gag_gagut2mjd
  end interface
  !
  interface
    subroutine gag_mjd2gagut(mjd,date,ut,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Convert a MJD date into GAG_DATE + UT
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: mjd
      integer(kind=4), intent(out)   :: date
      real(kind=8),    intent(out)   :: ut
      logical,         intent(inout) :: error
    end subroutine gag_mjd2gagut
  end interface
  !
  interface
    subroutine sic_date(datetime)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current date-time in Gildas format
      !     DD-MMM-YYYY hh:mm:ss.ss
      !     123456789 123456789 123
      ! Use 23 character strings for full date-time, or shorter strings
      ! for truncated values.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: datetime
    end subroutine sic_date
  end interface
  !
  interface
    subroutine sic_isodate(datetime)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current date-time in ISO #8601:
      !     1996-10-14T10:34:55.345
      !     123456789 123456789 123
      ! Use 23 character strings for full date-time, or shorter strings
      ! for truncated values.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: datetime
    end subroutine sic_isodate
  end interface
  !
  interface
    subroutine sic_gagdate(gagdate)
      !---------------------------------------------------------------------
      ! @ public
      !  Return the current UTC date in GAG_DATE format
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: gagdate
    end subroutine sic_gagdate
  end interface
  !
  interface
    subroutine sic_decode(chain,value,ndiv,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Decode a sexagesimal character string into angle value in radians.
      ! Formats can be:
      !       61.5000000      or      161
      !       61:30.0000      or      161:40
      !       61:45:50.9      or      161:40:50
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: chain  ! Character string
      real(kind=8),     intent(out)   :: value  ! Value of angle
      integer(kind=4),  intent(in)    :: ndiv   ! 360/24
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine sic_decode
  end interface
  !
  interface
    subroutine sic_lower(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Converts a character string to lowercase.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string
    end subroutine sic_lower
  end interface
  !
  interface
    subroutine sic_upper(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Converts a character string to uppercase.
      !  Slow if called frequently to convert a single character.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string
    end subroutine sic_upper
  end interface
  !
  interface
    function lenc(c)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the location of the last non-blank character in a string.
      !---------------------------------------------------------------------
      integer(kind=4) :: lenc  ! Function value on return
      character(len=*), intent(in) :: c  ! Character string
    end function lenc
  end interface
  !
  interface
    subroutine sic_blanc(c,n)
      !---------------------------------------------------------------------
      ! @ public
      !   Reduce the character string C to the standard SIC internal syntax.
      !   Suppress all unecessary separators.
      !   Character strings "abcd... " are not modified.
      !   Convert to upper case all characters.
      !   Ignores and destroys comments.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string to be formatted
      integer(kind=4),  intent(inout) :: n  ! Length of C
    end subroutine sic_blanc
  end interface
  !
  interface
    subroutine sic_next(line,par,lpar,npar,dotab)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the next "word" of the command line. Words are separated
      ! by blanks, but also optionally by tabulations.
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: line   ! Line to be analysed
      character(len=*),  intent(out)   :: par    ! Next word found
      integer(kind=4),   intent(out)   :: lpar   ! Length of word found
      integer(kind=4),   intent(inout) :: npar   ! Start point for analysis, updated for subsequent call
      logical, optional, intent(in)    :: dotab  ! Take also tabulations as separator?
    end subroutine sic_next
  end interface
  !
  interface
    subroutine sic_noir(cin,np)
      !---------------------------------------------------------------------
      ! @ public
      !  Reduce all separators to one.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: cin  ! Character string
      integer(kind=4),  intent(out)   :: np   ! Length of string
    end subroutine sic_noir
  end interface
  !
  interface
    subroutine sic_black(cin,np)
      !---------------------------------------------------------------------
      ! @ public
      !   Suppress all separators
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: cin  ! Character string
      integer(kind=4),  intent(out)   :: np   ! Length of string
    end subroutine sic_black
  end interface
  !
  interface
    subroutine sic_upcase(c,n)
      !---------------------------------------------------------------------
      ! @ public
      !   Reduce the character string C to the standard SIC internal syntax.
      !   Suppress all unecessary separators.
      !   Character strings "abcd... " are not modified.
      !   Convert to upper case all characters.
      !   Ignores and destroys comments.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: c  ! Character string to be formatted
      integer(kind=4),  intent(inout) :: n  ! Length of string
    end subroutine sic_upcase
  end interface
  !
  interface
    subroutine sic_separ(separ,line,par,lpar,npar)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the next "word" of the command line
      !---------------------------------------------------------------------
      character(len=1), intent(in)    :: separ  !
      character(len=*), intent(in)    :: line   !
      character(len=*), intent(out)   :: par    !
      integer(kind=4),  intent(out)   :: lpar   !
      integer(kind=4),  intent(inout) :: npar   !
    end subroutine sic_separ
  end interface
  !
  interface
    subroutine gagout (mess)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: mess  !
    end subroutine gagout
  end interface
  !
  interface
    function sic_get_arg_count()
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_get_arg_count  !  Function value on return
    end function sic_get_arg_count
  end interface
  !
  interface
    subroutine sic_get_arg(n,arg)
      !---------------------------------------------------------------------
      ! @ public
      !   This machine dependent function retrieves the Nth argument of
      ! command line.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: n    ! Argument index
      character(len=*), intent(out) :: arg  ! Argument value
    end subroutine sic_get_arg
  end interface
  !
  interface
    subroutine gmessage_init(logname,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Initialization routine for gmessage facility:
      !  - close previously opened message file (useful to change the file
      !    during a session)
      !  - open the (new) message file
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: logname
      logical,          intent(inout) :: error
    end subroutine gmessage_init
  end interface
  !
  interface
    subroutine gmessage_parse_and_set(inid,infilter,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter the message filters for input package. Inputs are:
      ! 1) The package id,
      ! 2) The alteration rule, as used in SIC command line, e.g. "s-dtu",
      !    "l=fewri", ...
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: inid      ! Package id
      character(len=*), intent(in)    :: infilter  ! Filter rule
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_parse_and_set
  end interface
  !
  interface
    subroutine gmessage_parse_and_set_all(infilter,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Updates all filters for all packages (excluding "Global" ones),
      ! given the input alteration rule
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: infilter  ! Filter rule
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_parse_and_set_all
  end interface
  !
  interface
    subroutine gmessage_print_active(sev,error)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Prints all filters for all ACTIVE packages (i.e. "Global" or "per
      ! package")
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_active
  end interface
  !
  interface
    subroutine gmessage_print_all(sev,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for all packages (excluding "Global" ones)
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_all
  end interface
  !
  interface
    subroutine gmessage_print_id(id,sev,error)
      use gpack_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for the input package. Input is the package id.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: id     ! Package id
      integer(kind=4), intent(in)    :: sev    ! Severity used to write output
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gmessage_print_id
  end interface
  !
  interface
    subroutine gmessage_print(packname,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Prints filters for the input package. Input is the package name.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: packname  ! Package name
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gmessage_print
  end interface
  !
  interface
    subroutine gmessage_translate(seve_leve,seve_code,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Translate a message severity letter into its corresponding integer
      ! code, as a call to gmessage_write needs.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: seve_leve  ! Input severity letter
      integer(kind=4),  intent(out)   :: seve_code  ! Translated code
      logical,          intent(inout) :: error      ! Error flag
    end subroutine gmessage_translate
  end interface
  !
  interface
    subroutine gmessage_log_append(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Message file will be appended if already existing. Must be called
      ! before opening the message file.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag
    end subroutine gmessage_log_append
  end interface
  !
  interface
    subroutine gmessage_close(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Closes message file and reset its logical unit for a clean handling
      ! of very last messages. Do not produce an error if no message file
      ! is opened.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error    ! Error flag
    end subroutine gmessage_close
  end interface
  !
  interface
    subroutine gmessage_write(id,mkind,procname,message)
      use gpack_def
      use gbl_message
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public
      ! Output procname and message, with severity kind "mkind", according
      ! to current messaging filters of input package.
      !  - input id is the identifier given to the package when it
      !    registered, or the one from another package if current package
      !    wants to appear as an other into the message file (e.g. 'gio'
      !    messages appear as 'sic' messages in message file).
      !  - mkind is an integer which should be set with the severity
      !    structure provided by gbl_message module.
      !  Although this routine is public, you should call it only once (with
      !  the 4 arguments) in your <packname>-message routine, and then call
      !  everywhere in your package your <packname>-message routine with
      !  3 arguments. Your package id should be known only in the
      ! <packname>-message routine.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: id        ! Package id
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gmessage_write
  end interface
  !
  interface
    subroutine gmessage_write_in_mesfile(id,mkind,procname,message)
      use gpack_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public TEMPORARY FOR CLIC ONLY (SB, 02-jun-2008)
      ! Rewrite of gmessage_write. It writes to mesfile only and ignores
      ! filters.
      !---------------------------------------------------------------------
      ! Output procname and message, with severity kind "mkind", according
      ! to current messaging filters of input package.
      !  - input id is the identifier given to the package when it
      !    registered, or the one from another package if current package
      !    wants to appear as an other into the message file (e.g. 'gio'
      !    messages appear as 'sic' messages in message file).
      !  - mkind is an integer which should be set with the severity
      !    structure provided by gbl_message module.
      !  Although this routine is public, you should call it only once (with
      !  the 4 arguments) in your <packname>-message routine, and then call
      !  everywhere in your package your <packname>-message routine with
      !  3 arguments. Your package id should be known only in the
      ! <packname>-message routine.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: id        ! Package id
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gmessage_write_in_mesfile
  end interface
  !
  interface
    subroutine gag_message(mkind,procname,message)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public (obsolete)
      ! Outputs procname and message, with severity kind "mkind", according
      ! to current GLOBAL messaging filters. mkind is an integer which
      ! should be set with the severity structure provided by gbl_message
      ! module.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gag_message
  end interface
  !
  interface
    subroutine gmessage_use_gbl_rules(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Activates or deactivates use of global messaging filters instead of
      ! local (per package) ones.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag  ! Activate if .true.
    end subroutine gmessage_use_gbl_rules
  end interface
  !
  interface
    subroutine gmessage_log_date(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Activates or deactivates printing date-time in message file.
      !---------------------------------------------------------------------
      logical, intent(in) :: flag  ! Activate if .true.
    end subroutine gmessage_log_date
  end interface
  !
  interface
    subroutine gmessage_quiet
      !---------------------------------------------------------------------
      ! @ public
      ! Ensure almost-quiet messaging mode to Screen.
      ! This is done by setting Global onscreen filter to FE------, and
      ! using Global filters.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_quiet
  end interface
  !
  interface
    subroutine gmessage_standard
      !---------------------------------------------------------------------
      ! @ public
      ! Restore normal verbosity.
      ! This is done by stopping using Global filters.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_standard
  end interface
  !
  interface
    subroutine gmessage_verbose
      !---------------------------------------------------------------------
      ! @ public
      ! Provide a maximal verbose messaging mode for Screen and Message
      ! file.
      ! This is done by turning on all the kind of messages, to both Screen
      ! and Message file.
      !---------------------------------------------------------------------
      !
    end subroutine gmessage_verbose
  end interface
  !
  interface
    subroutine gmessage_debug_swap
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Provide a maximal verbose messaging mode for Screen and Message
      ! file.
      ! This is done by turning on all the kind of messages, to both Screen
      ! and Message file.
      !---------------------------------------------------------------------
      ! Local
    end subroutine gmessage_debug_swap
  end interface
  !
  interface
    subroutine gmessage_print_colors(error)
      !---------------------------------------------------------------------
      ! @ public
      ! Show the current status of message colors
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gmessage_print_colors
  end interface
  !
  interface
    subroutine gmessage_colors_swap(flag)
      !---------------------------------------------------------------------
      ! @ public
      ! Enable or disable the message coloring
      !---------------------------------------------------------------------
      logical, intent(in) :: flag
    end subroutine gmessage_colors_swap
  end interface
  !
  interface
    subroutine gmessage_colors_parse(argum,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Parse argument for changing a message kind color
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: argum
      logical,          intent(inout) :: error
    end subroutine gmessage_colors_parse
  end interface
  !
  interface
    function gpack_get_count()
      !---------------------------------------------------------------------
      ! @ public
      ! Return number of registered packages
      !---------------------------------------------------------------------
      integer(kind=4) :: gpack_get_count
    end function gpack_get_count
  end interface
  !
  interface
    function gpack_get_info(ipack)
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Return package information structure
      !---------------------------------------------------------------------
      type(gpack_info_t) :: gpack_get_info
      integer(kind=4), intent(in) :: ipack
    end function gpack_get_info
  end interface
  !
  interface
    function gpack_get_id(gpack_name,present,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Private function to get the package id from the package name
      !---------------------------------------------------------------------
      integer(kind=4)  :: gpack_get_id ! Returned package id
      character(len=*), intent(in)    :: gpack_name   ! Package name
      logical,          intent(in)    :: present      ! Must the package be already registered?
      logical,          intent(inout) :: error        ! Error flag
    end function gpack_get_id
  end interface
  !
  interface
    subroutine gpack_resolve(packname,found,error)
      use gbl_message
      use gpack_def
      !---------------------------------------------------------------------
      ! @ public
      ! Resolve packname string ambiguities
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: packname  ! Package name
      logical,          intent(out)   :: found     ! Found package?
      logical,          intent(inout) :: error     ! Error flag
    end subroutine gpack_resolve
  end interface
  !
  interface
    function gpack_is_registered(gpack_name)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Check registration status of a package
      !---------------------------------------------------------------------
      logical                      :: gpack_is_registered  ! Package registration status
      character(len=*), intent(in) :: gpack_name           ! Package name
    end function gpack_is_registered
  end interface
  !
  interface
    function gpack_build(pack_set,already_registered,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Builds a package and its dependencies, returns package registration
      ! id
      !---------------------------------------------------------------------
      integer(kind=4) :: gpack_build
      external               :: pack_set
      logical, intent(out)   :: already_registered
      logical, intent(inout) :: error
    end function gpack_build
  end interface
  !
  interface
    subroutine gsys_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: id
    end subroutine gsys_message_set_id
  end interface
  !
  interface
    function sic_ramlog(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Decode a Sic logical as a RAM space, computed in MiB. 3 syntaxes
      ! are allowed:
      !
      ! No unit: default MiB
      !   SPACE_GILDAS  256    ! [MiB] Absolute value
      !
      ! Explicit unit:
      !   SPACE_GILDAS  256MB  ! Supported units: TB GB MB kB TiB GiB MiB kiB
      !
      ! Percent of total RAM:
      !   SPACE_GILDAS  50%    ! [  ] Relative value in fraction of the total
      !                              RAM size
      !
      ! The value can be integer or floating point. The unit or percent can
      ! be separated from the value by 0 or more blanks.
      !
      ! Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_ramlog  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=4),     intent(inout) :: trans  ! Output value
    end function sic_ramlog
  end interface
  !
  interface
    function sic_setlog(name,trans)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_setlog
      character(len=*), intent(in) :: name   !
      character(len=*), intent(in) :: trans  !
    end function sic_setlog
  end interface
  !
  interface
    function dictname(dtype,file)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! This system dependent routine returns the full names (including
      ! path) of the (internal) logical name definition files.
      ! Known dictionary types as input are 'GLOBAL', 'LOCAL', or 'USER'.
      ! Any other kind raises an error.
      !
      ! This version for Unix.
      !---------------------------------------------------------------------
      integer(kind=4) :: dictname             !
      character(len=*), intent(in)  :: dtype  ! Dictionary type
      character(len=*), intent(out) :: file   ! Associated file
    end function dictname
  end interface
  !
  interface
    subroutine gag_separ(ins,ous,dis)
      !---------------------------------------------------------------------
      ! @ public
      !     Returns the characters used as Separators in path names.
      !     This allows multi-OS support where the directory names are separated
      !     by either / (Unix), \ (Windows), or : (MAC-OS)
      !---------------------------------------------------------------------
      character(len=1), intent(out) :: ins         !
      character(len=1), intent(out) :: ous         !
      character(len=1), intent(out) :: dis         !
    end subroutine gag_separ
  end interface
  !
  interface
    subroutine gag_release(ostring)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Return a string with the release name, date, system, and branch.
      ! Read the string in GAG_VERSION symbol, and optionally replace the
      ! release date by the calling executable date if in HEAD version.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: ostring  ! Output string
    end subroutine gag_release
  end interface
  !
  interface sic_getlog
    function sic_getlog_i4(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  I*4 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_i4  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      integer(kind=4),  intent(inout) :: trans  ! Output value
    end function sic_getlog_i4
    function sic_getlog_i8(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  I*8 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_i8  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      integer(kind=8),  intent(inout) :: trans  ! Output value
    end function sic_getlog_i8
    function sic_getlog_r4(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  R*4 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_r4  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=4),     intent(inout) :: trans  ! Output value
    end function sic_getlog_r4
    function sic_getlog_r8(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  R*8 version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_r8  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      real(kind=8),     intent(inout) :: trans  ! Output value
    end function sic_getlog_r8
    function sic_getlog_l(chain,trans)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated               ('trans' modified in return)
      !    1 if not found                          ('trans' not modified in return)
      !    2 if found but error during translation ('trans' not modified in return)
      ! ---
      !  Logical (boolean) version. Supported keywords are (case-
      ! insensitive): YES, Y, NO, N
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_l  ! Function value on return
      character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
      logical,          intent(inout) :: trans  ! Output value
    end function sic_getlog_l
    function sic_getlog_ch(name,trans)
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated ('trans' modified in return)
      !    1 if not found            ('trans' not modified in return)
      ! ---
      !  C*(*) version
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_ch  ! Function value on return
      character(len=*), intent(in)    :: name   ! Logical name
      character(len=*), intent(inout) :: trans  ! Output value
    end function sic_getlog_ch
    function sic_getlog_inplace(name)
      !---------------------------------------------------------------------
      ! @ public-generic sic_getlog
      !  Translate a logical value. Function value on return is:
      !    0 if found and translated ('name' modified in return)
      !    1 if not found            ('name' not modified in return)
      !  OBSOLESCENT, USE 2 ARGUMENTS INSTEAD  !!!
      ! ---
      !  C*(*) version, obsolescent calling sequence which replaces the
      ! value in place.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlog_inplace
      character(len=*), intent(inout) :: name  ! Output value
    end function sic_getlog_inplace
  end interface sic_getlog
  !
  interface
    function gag_hasins(mdim,pf,pn,dict,name,in)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Insert a new name or replace an existing name
      !       in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASINS      0       E  Invalid name
      !                       1       S  Successfully inserted
      !                       2       E  Too many names
      !                       3       S  Successfully replaced
      !
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input/Output
      !                       PF(27) is the number of symbols
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input/Output
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasins  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(inout) :: pf(0:27)    !
      integer(kind=4),  intent(inout) :: pn(mdim)    !
      character(len=*), intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be inserted
      integer(kind=4),  intent(out)   :: in          ! Address of this name
    end function gag_hasins
  end interface
  !
  interface
    subroutine gag_hasini(mdim,pf,pn)
      !---------------------------------------------------------------------
      ! @ public
      ! SIC   Internal routine
      !  *** This version for all kind of dictionaries ***
      !       Initialise a hashing structure for a possible dictionnary.
      ! Arguments :
      !       MDIM    I       Size of dictionnary
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.
      !                       PF(27) the number of symbol
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: mdim      !
      integer(kind=4), intent(out) :: pf(0:27)  !
      integer(kind=4), intent(out) :: pn(mdim)  !
    end subroutine gag_hasini
  end interface
  !
  interface
    function gag_hasdel(mdim,pf,pn,dict,name)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Delete a name in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASDEL      1       Name deleted
      !                       3       Name does not exist
      !
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input/Output
      !                       PF(27) is the number of symbols
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input/Output
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasdel  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(inout) :: pf(0:27)    !
      integer(kind=4),  intent(inout) :: pn(mdim)    !
      character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be deleted
    end function gag_hasdel
  end interface
  !
  interface
    function gag_hasfin(mdim,pf,pn,dict,name,in)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for dictionaries as character string arrays ***
      !       Find a name in a dictionnary using a hashing structure
      !       and a list of pointers.
      !
      !       GAG_HASFIN      0       No such name
      !                       1       Name found
      !       PF      I(0:27) PF(J) Address of first name beginning
      !                       with CHAR(J-ICHAR('A')) in dictionnary.
      !                       PF(26) is the address of the first
      !                       available place.                        Input
      !       PN      I(MDIM) Address of next name with same first
      !                       letter. If PN(J)=0, no more such name.  Input
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_hasfin  ! Function value on return
      integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
      integer(kind=4),  intent(in)    :: pf(0:27)    !
      integer(kind=4),  intent(in)    :: pn(mdim)    !
      character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
      character(len=*), intent(inout) :: name        ! Name to be found
      integer(kind=4),  intent(out)   :: in          ! Address of this name
    end function gag_hasfin
  end interface
  !
  interface
    subroutine gag_haslis(mdim,pf,pn,list,leng)
      !---------------------------------------------------------------------
      ! @ public
      !  *** This version for all kind of dictionaries ***
      !
      !  List a dictionnary using a hashing structure and a list of pointers.
      ! This routine just builds the list of pointers to current entries.
      !
      ! THERE IS NO WARRANTY THE OUTPUT LIST IS SORTED ALPHABETICALLY.
      ! Actually with the current hashing method, the output list is sorted
      ! by first letter only. Use subroutine gag_hassort for a fully sorted
      ! list.
      !
      !   PF(0:27)   PF(0:25) Address of first name beginning with
      !                       CHAR(J-ICHAR('A')) in dictionnary.
      !              PF(26)   is the address of the first available place.
      !              PF(27)   the number of symbols
      !   PN(MDIM)            Address of next name with same first letter.
      !                       If PN(J)=0, no more such name.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: mdim        ! Size of dictionnary
      integer(kind=4), intent(in)  :: pf(0:27)    !
      integer(kind=4), intent(in)  :: pn(mdim)    !
      integer(kind=4), intent(out) :: list(mdim)  ! List of entries in dictionnary
      integer(kind=4), intent(out) :: leng        ! Current number of entries
    end subroutine gag_haslis
  end interface
  !
  interface
    function sic_open(unit,file,status,readonly)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function opens a formatted file, and returns an
      ! error code. This Unix version simulates version numbers by renaming
      ! any existing file to a ~appended name.
      !
      ! Possible statuses are:
      !  - NEW: rename previous version with ~ appended (GILDAS special
      !         feature) and create a new file (only write mode makes sense)
      !  - REPLACE: overwrite an OLD file (if any) and create a new file
      !         (only write mode makes sense)
      !  - APPEND: open an OLD file in read-write mode (always), ready for
      !         writing at end of file.
      !  - OLD: reopen an old file in read-only or read-write mode (as
      !         desired)
      !  - other Fortran standard keywords
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_open  ! Return value
      integer(kind=4),  intent(in) :: unit      ! Fortran logical unit
      character(len=*), intent(in) :: file      ! File name
      character(len=*), intent(in) :: status    ! File status ('NEW', or 'OLD', or...)
      logical,          intent(in) :: readonly  ! Open as write protected?
    end function sic_open
  end interface
  !
  interface
    function sic_flush(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This function flushes file buffer onto disk, and returns an error
      ! code.
      !---------------------------------------------------------------------
      integer(kind=4)             :: sic_flush  ! Flush status (0=success)
      integer(kind=4), intent(in) :: unit       ! Logical unit
    end function sic_flush
  end interface
  !
  interface
    function sic_close(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This function closes a formatted file, and returns an error code.
      ! Following the Fortran norm, default closing STATUS:
      ! - is DELETE if unit has been opened with STATUS=SCRATCH,
      ! - is KEEP if unit has been opened with any other STATUS.
      ! Use unit=0 to close all units.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_close  ! Close status (0=success)
      integer(kind=4), intent(in) :: unit  ! Logical unit to close
    end function sic_close
  end interface
  !
  interface
    subroutine sic_frelun(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function frees a Fortran logical unit obtained
      ! through a call to SIC_GETLUN. Error on close can not be retrieved,
      ! use GAG_FRELUN to do so.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: unit  ! Fortran logical unit to close
    end subroutine sic_frelun
  end interface
  !
  interface
    function sic_getlun(unit)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function returns a free Fortran logical unit in
      ! UNIT. The function value is an error code. For safe operation, all
      ! logical units used by the program should be obtained through calls to
      ! SIC_GETLUN. This portable version reserves all units between STALUN+1
      ! and STALUN+MAXLUN, which may interfere with the calling program. Safer
      ! equivalents can usually be obtained through system calls.
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_getlun  ! Function value on return
      integer(kind=4), intent(out) :: unit  ! Unit obtained on return
    end function sic_getlun
  end interface
  !
  interface
    function gag_frelun(unit)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function frees a Fortran logical unit obtained
      ! through a call to SIC_GETLUN. The function value is an error code.
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_frelun  ! Function value on return
      integer(kind=4), intent(in) :: unit  ! Logical unit to close
    end function gag_frelun
  end interface
  !
  interface
    function gag_stalun(unit)
      !---------------------------------------------------------------------
      ! @ public
      ! Stat input lun (or all if lun=0) and print out status of lun(s)
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_stalun  ! Function value on return
      integer(kind=4), intent(in) :: unit  ! Unit to stat
    end function gag_stalun
  end interface
  !
  interface
    function sic_purge(file,keep)
      !---------------------------------------------------------------------
      ! @ public
      ! This machine dependent function deletes all versions of a file except
      ! for the KEEP last ones, KEEP=0 being a supported case. The function
      ! value is an error code. This dummy version does nothing and should be
      ! replaced by an EMACS-like behaviour (using numbered backup files).
      !---------------------------------------------------------------------
      integer(kind=4) :: sic_purge  ! Return value
      character(len=*), intent(in) :: file       ! File name
      integer(kind=4),  intent(in) :: keep       ! Number of versions that should be kept
    end function sic_purge
  end interface
  !
  interface
    subroutine sic_resolve_log(chain)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Resolve logical variables recursively
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: chain  !
    end subroutine sic_resolve_log
  end interface
  !
  interface
    subroutine sic_parse_file(name,dir,ext,file)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Adds the directory DIR and extension EXT if necessary to the file
      ! name NAME to form FILE. In addition, logical name are translated to
      ! obtain the intrinsic "physical" names.
      !
      ! For UNIX purposes: (a logical name is somestring finished with ":")
      !      a) converts "\" to "/"
      !      b) converts ~ to $HOME
      !
      ! if first character is "!" or "/"
      !     1) TRANSLATES LOGICAL NAMES
      !     2) Does not add extension
      !     3) is respectful of upper/lowercases
      ! if not :
      !     1) converts to lowercase
      !     2) TRANSLATES LOGICAL NAMES
      !     3) Does add extension, in lowercase
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name  ! File name
      character(len=*), intent(in)  :: dir   ! Default directory
      character(len=*), intent(in)  :: ext   ! Default extension
      character(len=*), intent(out) :: file  ! Fully extended file name
    end subroutine sic_parse_file
  end interface
  !
  interface
    subroutine sic_parsef(name,file,dir,ext)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Same as SIC_PARSE_FILE +
      !  at return, NAME is the file named stripped from directory and
      !  extension
      ! ---
      !  Obsolete: use SIC_PARSE_FILE and/or SIC_PARSE_NAME instead
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: name  ! File name
      character(len=*), intent(out)   :: file  ! Fully extended file name
      character(len=*), intent(in)    :: dir   ! Default directory
      character(len=*), intent(in)    :: ext   ! Default extension
    end subroutine sic_parsef
  end interface
  !
  interface
    function sic_query_file (name,path,ext,file)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Same as sic_findfile but avoid modifying input 'name'
      !---------------------------------------------------------------------
      logical :: sic_query_file              ! Function value on return
      character(len=*), intent(in)  :: name  ! File name
      character(len=*), intent(in)  :: path  ! Search path
      character(len=*), intent(in)  :: ext   ! Default extension
      character(len=*), intent(out) :: file  ! Fully extended file name
    end function sic_query_file
  end interface
  !
  interface
    function sic_findfile(name,file,path,ext)
      !---------------------------------------------------------------------
      ! @ public
      !  Search on the path PATH and with extension EXT if necessary the
      ! file name NAME to find FILE. At return, NAME is the file named
      ! stripped from these extensions. In addition, logical name are
      ! translated to obtain the intrinsic "physical" names.
      !---------------------------------------------------------------------
      logical :: sic_findfile                  ! Function value on return
      character(len=*), intent(inout) :: name  ! File name
      character(len=*), intent(out)   :: file  ! Fully extended file name
      character(len=*), intent(in)    :: path  ! Search Path
      character(len=*), intent(in)    :: ext   ! Default extension
    end function sic_findfile
  end interface
  !
  interface
    subroutine sic_parse_name(iname,ofile,oext,odir)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !  Split an input file name as:
      !  - its basename (no extension),
      !  - its extension,
      !  - its dirname.
      ! Sic logicals are resolved in the the input file name before parsing
      !---------------------------------------------------------------------
      character(len=*), intent(in)            :: iname
      character(len=*), intent(out)           :: ofile
      character(len=*), intent(out), optional :: oext
      character(len=*), intent(out), optional :: odir
    end subroutine sic_parse_name
  end interface
  !
  interface
    subroutine gag_iostat (msg,ier)
      !---------------------------------------------------------------------
      ! @ public
      ! Return system message corresponding to IO error code IER
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: msg  ! Returned message
      integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
    end subroutine gag_iostat
  end interface
  !
  interface
    function failed_allocate(rname,array,ier,error)
      use gbl_message
      !-------------------------------------------------------------------
      ! @ public
      ! Check allocation status and display a message if error
      !-------------------------------------------------------------------
      logical :: failed_allocate  ! Function value on return
      character(len=*), intent(in)    :: rname  ! Calling routine name
      character(len=*), intent(in)    :: array  ! Name of allocated array
      integer(kind=4),  intent(in)    :: ier    ! Allocation status
      logical,          intent(inout) :: error  ! Logical error flag
    end function failed_allocate
  end interface
  !
  interface putios
    subroutine putios_write (name,ier)
      !---------------------------------------------------------------------
      ! @ public-generic putios
      ! Print system message corresponding to IO error code IER
      ! ---
      ! This version writes directly the message to STDOUT
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name  ! Facility name
      integer(kind=4),  intent(in) :: ier   ! 32-bit system message code
    end subroutine putios_write
    subroutine putios_message (mseve,procname,ier)
      !---------------------------------------------------------------------
      ! @ public-generic putios
      ! Print system message corresponding to IO error code IER
      ! ---
      ! This version creates a standard message
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mseve     ! Message severity
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      integer(kind=4),  intent(in) :: ier       ! 32-bit system message code
    end subroutine putios_message
  end interface putios
  !
  interface
    subroutine sexag(ch,rr8,ndiv)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public (obsolescent since 19-mar-2015, use rad2sexa instead)
      !  Writes an angle in sexagesimal notation. The number of characters
      ! updated are limited to 13.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: ch    ! Formatted string
      real(kind=8),     intent(in)  :: rr8   ! Angle in radians
      integer(kind=4),  intent(in)  :: ndiv  ! Number of divisions per turn (24/360)
    end subroutine sexag
  end interface
  !
  interface
    subroutine deg2sexa(d8,ndiv,ch,ndig,left)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Write an angle (degrees) in sexagesimal notation.
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)           :: d8    ! [Deg] Angle
      integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
      character(len=*), intent(out)          :: ch    ! [   ] Formatted string
      integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
      logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
    end subroutine deg2sexa
  end interface
  !
  interface
    subroutine rad2sexa(rr8,ndiv,ch,ndig,left)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Write an angle (radians) in sexagesimal notation.
      !  The number of digits in the fractional part is controled by 'ndig'.
      ! If absent, the string will be filled with as many digits as
      ! possible, for example if you want a 3 digits fractional part, use
      !  -DDD:MM:SS.SSS = 14 characters (360 divisions per turn)
      !  -HH:MM:SS.SSS = 13 characters (24 divisions per turn)
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)           :: rr8   ! [Rad] Angle
      integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
      character(len=*), intent(out)          :: ch    ! [   ] Formatted string
      integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
      logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
    end subroutine rad2sexa
  end interface
  !
  interface
    subroutine deg2dms(r8,d,m,s)
      !---------------------------------------------------------------------
      ! @ public
      !  Split a floating point value in degreee-minute-seconds numerical
      ! values. No assumption on the input value unit.
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)  :: r8
      integer(kind=4), intent(out) :: d
      integer(kind=4), intent(out) :: m
      real(kind=8),    intent(out) :: s
    end subroutine deg2dms
  end interface
  !
  interface
    subroutine ctodes(string,nc,addr)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Copy at address the value of 'string'. nc is the maximum length
      ! (number of bytes) of the string to copy.
      !---------------------------------------------------------------------
      character(len=*),             intent(in) :: string  !
      integer(kind=4),              intent(in) :: nc      !
      integer(kind=address_length), intent(in) :: addr    ! Address is not modified
    end subroutine ctodes
  end interface
  !
  interface
    subroutine destoc(nc,addr,string)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Copy in 'string' the value referenced at address 'addr'. nc
      ! is the maximum length (number of bytes) of the string to copy.
      !---------------------------------------------------------------------
      integer(kind=4),              intent(in)  :: nc      !
      integer(kind=address_length), intent(in)  :: addr    !
      character(len=*),             intent(out) :: string  !
    end subroutine destoc
  end interface
  !
  interface
    function match_string(string,pattern)
      !---------------------------------------------------------------------
      ! @ public
      ! Basic function for regular expression matching. Only '*' is
      ! currently recognized as a special character.
      !  * : matches 0 or more characters
      ! By construction, tolerate contiguous stars e.g. 'AB***CD'. Matching
      ! is case-sensitive.
      !---------------------------------------------------------------------
      logical                      :: match_string  ! Return value
      character(len=*), intent(in) :: string        ! String to test
      character(len=*), intent(in) :: pattern       ! Pattern to match
    end function match_string
  end interface
  !
  interface
    subroutine sic_terminal(name)
      !---------------------------------------------------------------------
      ! @ public
      !  Returns the name of the terminal.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: name  ! Terminal name
    end subroutine sic_terminal
  end interface
  !
  interface
    subroutine sysexi(code)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: code  ! Input terminating code
    end subroutine sysexi
  end interface
  !
  interface
    subroutine gag_os(os)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: os  !
    end subroutine gag_os
  end interface
  !
  interface
    subroutine gag_mkdir(dir,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: dir    !
      logical,          intent(out) :: error  !
    end subroutine gag_mkdir
  end interface
  !
  interface
    subroutine gag_directory_num(dirstring,num,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Return the number of standard files in a directory. Nice to be
      ! called before 'gag_directory' so that the filename(:) array can be
      ! allocated to an appropriate size.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: dirstring  !
      integer(kind=4),  intent(out)   :: num        ! Number of standard files
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine gag_directory_num
  end interface
  !
  interface
    subroutine gag_directory(dirstring,filestring,filename,nfile,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Return the actual files that match a given string (with *'s)
      ! inside a given directory (no *'s). Note that nothing forbids the
      ! file pattern to ask for subdirectories (e.g. */foo*.dat). The short
      ! filenames are returned (without directory path).
      !   In return, the list of files is stored in an array provided by the
      ! caller. This array MUST be allocatable. The subroutine will
      ! reallocate it to the appropriate size.
      !---------------------------------------------------------------------
      character(len=*), intent(in)               :: dirstring    ! input directory
      character(len=*), intent(in)               :: filestring   ! input file string
      character(len=*), intent(out), allocatable :: filename(:)  ! char array filled in
      integer(kind=4),  intent(out)              :: nfile        ! number of files
      logical,          intent(inout)            :: error        !
    end subroutine gag_directory
  end interface
  !
  interface
    subroutine sic_username(name)
      !---------------------------------------------------------------------
      ! @ public
      ! Return user name from:
      ! 1) $USER environment variable, else
      ! 2) $LOGNAME environment variable, else
      ! 3) use string "Gildas"
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: name  ! Output string
    end subroutine sic_username
  end interface
  !
  interface
    subroutine sic_hostname(node)
      !---------------------------------------------------------------------
      ! @ public
      ! Return host name from:
      ! 1) $HOST environment variable, else
      ! 2) $HOSTNAME environment variable, else
      ! 3) non-standard subroutine HOSTNM (standard alternative could be
      !    execute_command_line("hostname",node), else
      ! 4) blank string
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: node  ! Output string
    end subroutine sic_hostname
  end interface
  !
  interface
    subroutine sic_setdir(direc,nc,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! SIC   Machine specific routine that changes and/or returns the
      !       default directory.
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: direc  ! Name of default directory
      integer(kind=4),  intent(inout) :: nc     ! Length of directory name
      logical,          intent(inout) :: error  ! Error flag
    end subroutine sic_setdir
  end interface
  !
  interface
    subroutine gag_cpu(arg)
      !---------------------------------------------------------------------
      ! @ public
      ! All compilers are assumed to be Fortran 1995 compatible now
      !---------------------------------------------------------------------
      real(kind=4), intent(out) :: arg  !
    end subroutine gag_cpu
  end interface
  !
  interface
    subroutine gag_delete(fich)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: fich  !
    end subroutine gag_delete
  end interface
  !
  interface
    function gag_which(name,dirlist,full)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !   Find which file is invoked, given its name. Input name may
      ! include:
      !   - an absolute path,
      !   - a relative path,
      !   - only the file name, in which case it is searched in the
      !     input list of directories (might be an environment variable).
      !     This list is ignored in the 2 above cases.
      ! Output is a valid path to the file from current working directory.
      ! It is legal to search for a file which does not exist. The (or a)
      ! full path will be built, but the function value will be false on
      ! return.
      !   This function does the same as 'which' system command if input
      ! name is searched in '$PATH'
      !---------------------------------------------------------------------
      logical :: gag_which                      ! .true. on return if found
      character(len=*), intent(in)  :: name     ! File name to search
      character(len=*), intent(in)  :: dirlist  ! List of directories to search in (optional)
      character(len=*), intent(out) :: full     ! Return the path in this variable
    end function gag_which
  end interface
  !
  interface
    function gag_mtime(file,nanosec)
      !---------------------------------------------------------------------
      ! @ public
      ! Return the last modification time in nanoseconds since 01-jan-1970
      ! The file can be a regular file or a directory. If file is a symlink,
      ! evaluation is made on its target.
      ! Max value is 2**63-1 ns = (2**63-1)/1e9/86400/365 = 292 years
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_mtime  ! Function value on return (0 for success)
      character(len=*), intent(in)  :: file     ! File name
      integer(kind=8),  intent(out) :: nanosec  !
    end function gag_mtime
  end interface
  !
  interface
    function gag_time(nanosec)
      !---------------------------------------------------------------------
      ! @ public
      ! Return the current time in nanoseconds since 01-jan-1970
      ! Max value is 2**63-1 ns = (2**63-1)/1e9/86400/365 = 292 years
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_time  ! Function value on return (0 for success)
      integer(kind=8), intent(out) :: nanosec  !
    end function gag_time
  end interface
  !
  interface
    subroutine gag_filmodif(file,modif,error)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !  (re)compute the 'modified' structure and evaluate if the file
      ! was 'probably' modified since last evaluation. The file can be
      ! a regular file or a directory. If file is a symlink, evaluation is
      ! made on its target.
      !   NB: modif%modified is NOT modified if there is an ambiguity.
      ! It is up to the caller to set it to its best default according to
      ! the context.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: file   ! File name
      type(mfile_t),    intent(inout) :: modif  !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gag_filmodif
  end interface
  !
  interface
    subroutine gag_fillines(file,doblank,nlines,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Count the number of lines in a FORMATTED file. More precisely, it
      ! counts the number of carriage returns (same as Linux shell "wc -l").
      ! Be careful of missing carriage return at the end of your files.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: file     !
      logical,          intent(in)    :: doblank  ! Ignore blank lines?
      integer(kind=4),  intent(out)   :: nlines   !
      logical,          intent(inout) :: error    !
    end subroutine gag_fillines
  end interface
  !
  interface
    function gag_filsame(file1,file2)
      !---------------------------------------------------------------------
      ! @ public
      ! Check if 2 files are identical or not.
      ! This is based by comparing the devices hosting the files and the
      ! inodes on the devices.
      !---------------------------------------------------------------------
      logical :: gag_filsame
      character(len=*), intent(in) :: file1,file2
    end function gag_filsame
  end interface
  !
  interface
    function gag_memsize_format(nbytes) result(result)
      !---------------------------------------------------------------------
      ! @ public
      ! Format a memory size in a human readable form, with appropriate
      ! units.
      !---------------------------------------------------------------------
      character(len=8)            :: result
      integer(kind=8), intent(in) :: nbytes ! [Bytes]
    end function gag_memsize_format
  end interface
  !
  interface
    subroutine gag_cputime_init(time)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(cputime_t), intent(inout) :: time  !
    end subroutine gag_cputime_init
  end interface
  !
  interface
    subroutine gag_cputime_get(time)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(cputime_t), intent(inout) :: time  !
    end subroutine gag_cputime_get
  end interface
  !
  interface
    subroutine gtime_current(time)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public
      ! Display the timing statistics and projections
      !---------------------------------------------------------------------
      type(time_t), intent(inout) :: time
    end subroutine gtime_current
  end interface
  !
  interface gtime_init
    subroutine gtime_init4(time,nloop,error)
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public-generic gtime_init
      ! Init the timing structure (INTEGER*4 nloop)
      !---------------------------------------------------------------------
      type(time_t),    intent(out)   :: time
      integer(kind=4), intent(in)    :: nloop
      logical,         intent(inout) :: error
    end subroutine gtime_init4
    subroutine gtime_init8(time,nloop,error)
      use gbl_message
      use gsys_types
      !---------------------------------------------------------------------
      ! @ public-generic gtime_init
      ! Init the timing structure (INTEGER*8 nloop)
      !---------------------------------------------------------------------
      type(time_t),    intent(out)   :: time
      integer(kind=8), intent(in)    :: nloop
      logical,         intent(inout) :: error
    end subroutine gtime_init8
  end interface gtime_init
  !
end module gsys_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_free
  use cubedag_messaging
  use cubetools_structure
  !
  public :: free
  public :: free_prog_t
  private
  !
  type :: free_comm_t
    type(option_t), pointer :: comm
  contains
    procedure, public  :: register => cubedag_free_register
    procedure, private :: parse    => cubedag_free_parse
    procedure, private :: main     => cubedag_free_main
  end type free_comm_t
  type(free_comm_t) :: free
  !
  type :: free_user_t
    ! No customization yet
  contains
    procedure, private :: toprog => cubedag_free_user_toprog
  end type free_user_t
  !
  type :: free_prog_t
    ! No customization yet
  contains
    procedure, public :: do => cubedag_free_do
  end type free_prog_t
  !
contains
  !
  subroutine cubedag_free_command(line,error)
    !-------------------------------------------------------------------
    ! Support for command
    !  ADM\FREE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(free_user_t) :: user
    character(len=*), parameter :: rname='FREE>COMMAND'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call free%parse(line,user,error)
    if (error) return
    call free%main(user,error)
    if (error) return
  end subroutine cubedag_free_command
  !
  !---------------------------------------------------------------------
  !
  subroutine cubedag_free_register(free,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(free_comm_t), intent(inout) :: free
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>REGISTER'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'FREE','',&
         'Free the current DAG',&
         'Free the DAG, i.e. delete all the cube and history&
         & structures. Beware memory-only objects are lost during&
         & this operation (use command SNAPSHOT to save them for&
         & possible later reuse). In return the DAG is ready for use&
         & as if starting from scratch.',&
         cubedag_free_command,&
         free%comm,error)
    if (error) return
  end subroutine cubedag_free_register
  !
  subroutine cubedag_free_parse(free,line,user,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(free_comm_t), intent(inout) :: free
    character(len=*),   intent(in)    :: line
    type(free_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>PARSE'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
  end subroutine cubedag_free_parse
  !
  subroutine cubedag_free_main(free,user,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(free_comm_t), intent(in)    :: free
    type(free_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(free_prog_t) :: prog
    character(len=*), parameter :: rname='FREE>MAIN'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%do(error)
    if (error) return
  end subroutine cubedag_free_main
  !
  subroutine cubedag_free_user_toprog(user,prog,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(free_user_t), intent(in)    :: user
    type(free_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FREE>USER>TOPROG'
    !
    call cubedag_message(dagseve%trace,rname,'Welcome')
    !
  end subroutine cubedag_free_user_toprog
  !
  subroutine cubedag_free_do(prog,error)
    use cubedag_repositories
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(free_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    call cubedag_repositories_free(error)
    if (error) continue
    call cubedag_repositories_init(error)
    if (error) return
  end subroutine cubedag_free_do
  !
end module cubedag_free
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine maxvec (x,n,nomin,rmin,nomax,rmax)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! GILDAS:	Utility routine
  ! 	Compute position and values of Min and Max of array X
  !----------------------------------------------------------------------
  integer, intent(in) :: n             ! taille du vecteur
  real, intent(in) :: x(n)             ! Vecteur donne
  integer, intent(out) :: nomin,nomax   ! Resultat de la recherche:indices
  real, intent(out) :: rmin,rmax        ! et valeurs
  !
  integer no
  real val
  !
  no = 1
  rmax=x(no)
  nomax=no
  rmin=x(no)
  nomin=no
  do no=2,n
    val=x(no)
    if (val.gt.rmax) then
      nomax=no
      rmax=val
    elseif (val.lt.rmin) then
      nomin=no
      rmin=val
    endif
  enddo
end subroutine maxvec
!
subroutine maxmsk(ary,nx,ny,msk,box,   &
     &    amax,imax,jmax,amin,imin,jmin)
  !--------------------------------------------------------------------
  ! @ public
  !
  ! GILDAS:	Utility routine
  !	  Find max and min in specified region of real array
  !   Version with mask
  !--------------------------------------------------------------------
  integer, intent(in) :: nx, ny         ! X,Y size
  real, intent(in) :: ary(nx,ny)        ! Array of values
  logical, intent(in) ::  msk(nx,ny)    ! Search mask
  integer, intent(in) :: box(4)         ! Search box
  integer, intent(out) :: imax, jmax    ! Position of Max
  integer, intent(out) :: imin, jmin    ! Position of Min
  real, intent(out) :: amax, amin       ! Max and Min
  !
  integer i, j
  real a
  !
  amax = -1e38
  amin = 1e38
  !
  do j = box(2), box(4)
    do i = box(1), box(3)
      if (msk(i,j)) then
        a = ary(i,j)
        if (a .gt. amax) then
          amax = a
          imax = i
          jmax = j
        endif
        if (a .lt. amin) then
          amin = a
          imin = i
          jmin = j
        endif
      endif
    enddo
  enddo
end subroutine maxmsk

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_real_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_value_real_types
  use cubesyntax_messaging
  !
  public :: keyval_real_comm_t,keyval_real_user_t,keyval_real_prog_t
  private
  !
  type keyval_real_comm_t
     type(option_t), pointer :: key
     type(value_real_comm_t) :: value
   contains
     procedure, public :: register => cubesyntax_keyval_real_comm_register
     procedure, public :: parse    => cubesyntax_keyval_real_comm_parse
  end type keyval_real_comm_t
  !
  type keyval_real_user_t
     logical               :: do = .false.
     character(len=argu_l) :: val = strg_star
   contains
     procedure, public :: toprog => cubesyntax_keyval_real_user_toprog
     procedure, public :: list   => cubesyntax_keyval_real_user_list
  end type keyval_real_user_t
  !
  type keyval_real_prog_t
   contains
     procedure, public :: list   => cubesyntax_keyval_real_prog_list
  end type keyval_real_prog_t
  !
contains
  !
  subroutine cubesyntax_keyval_real_comm_register(comm,&
       keyname,keyabstract,keyhelp,valdefault,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_real_comm_t), intent(inout) :: comm
    character(len=*),          intent(in)    :: keyname
    character(len=*),          intent(in)    :: keyabstract
    character(len=*),          intent(in)    :: keyhelp
    real(kind=real_k),         intent(in)    :: valdefault
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>REAL>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         keyname,&
         'value',&
         keyabstract,&
         keyhelp,&
         comm%key,&
         error)
    if (error) return
    call comm%value%register(&
         keyname,&
         valdefault,&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubesyntax_keyval_real_comm_register
  !
  subroutine cubesyntax_keyval_real_comm_parse(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! /KEY value
    !----------------------------------------------------------------------
    class(keyval_real_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(keyval_real_user_t),  intent(out)   :: user ! => Initialized!
    logical,                   intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: ival=1
    character(len=*), parameter :: rname='KEYVAL>REAL>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,comm%key,ival,user%val,mandatory,error)
       if (error) return
    endif
  end subroutine cubesyntax_keyval_real_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_real_user_toprog(user,comm,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_real_user_t), intent(in)    :: user
    type(keyval_real_comm_t),  intent(in)    :: comm
    real(kind=real_k),         intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='KEYVAL>REAL>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! *** JP This syntax seems very strange to me because we transfer a
    ! *** JP constant object named nounit!
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%val,nounit,comm%value%default,prog,error)
    if (error) return
  end subroutine cubesyntax_keyval_real_user_toprog
  !
  subroutine cubesyntax_keyval_real_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(keyval_real_user_t), intent(in)    :: user 
    logical,                       intent(inout) :: error
    !
!    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='KEYVAL>REAL>USER>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
  end subroutine cubesyntax_keyval_real_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_real_prog_list(prog,comm,value,error)
    use cubesyntax_keyval_list_tool
    !-------------------------------------------------------------------
    ! List the information in a user friendly way
    !-------------------------------------------------------------------
    class(keyval_real_prog_t), intent(in)    :: prog
    type(keyval_real_comm_t),  intent(in)    :: comm
    real(kind=real_k),         intent(in)    :: value
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>REAL>PROG>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call keyval%list(comm%key%name,value,error)
    if (error) return
  end subroutine cubesyntax_keyval_real_prog_list
end module cubesyntax_keyval_real_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module classic_interfaces_private
  interface
    subroutine classic_message(mkind,procname,message)
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine classic_message
  end interface
  !
  interface
    subroutine classic_iostat(mkind,procname,ier)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Output system message corresponding to IO error code IER, and
      ! using the MESSAGE routine
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message severity
      character(len=*), intent(in) :: procname  ! Calling routine name
      integer,          intent(in) :: ier       ! IO error number
    end subroutine classic_iostat
  end interface
  !
  interface
    subroutine classic_code
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Set the identification codes for the current system.
      !---------------------------------------------------------------------
    end subroutine classic_code
  end interface
  !
  interface
    subroutine classic_convcod(filecode,lversion,lsingle,lpdp11,convcode,error)
      use gbl_convert
      use gbl_message
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Return the conversion code from File Data Type to System Data
      ! Type, and the extra informations which can be deduced from the File
      ! code.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: filecode  ! File code
      integer(kind=4), intent(out)   :: lversion  ! File version
      logical,         intent(out)   :: lsingle   ! Single or multiple?
      logical,         intent(out)   :: lpdp11    ! Old PDP 11 system?
      integer(kind=4), intent(out)   :: convcode  ! Conversion code
      logical,         intent(inout) :: error     ! Logical error flag
    end subroutine classic_convcod
  end interface
  !
  interface
    subroutine classic_conv(conv,error)
      use gildas_def
      use gbl_convert
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Set up the file conversion routines: read/write file-data-type
      ! to/from the system-data-type conversion routines.
      !---------------------------------------------------------------------
      type(classic_fileconv_t), intent(inout) :: conv   !
      logical,                  intent(inout) :: error  ! Logical error flag
    end subroutine classic_conv
  end interface
  !
  interface
    subroutine entrydesc_init_v1(ed,xnum,maxsec,version,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Initialize the Entry Descriptor of a new observation, suited for
      ! a version 1 file
      !---------------------------------------------------------------------
      type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
      integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
      integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
      integer(kind=4),            intent(in)    :: version  ! Observation version
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine entrydesc_init_v1
  end interface
  !
  interface
    subroutine entrydesc_init_v2(ed,xnum,maxsec,version,error)
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Initialize the Entry Descriptor of a new observation, suited for
      ! a version 2 file
      !---------------------------------------------------------------------
      type(classic_entrydesc_t),  intent(out)   :: ed       ! The new Entry Descriptor
      integer(kind=entry_length), intent(in)    :: xnum     ! The corresponding Entry number
      integer(kind=4),            intent(in)    :: maxsec   ! Maximum number of sections the ed can describe
      integer(kind=4),            intent(in)    :: version  ! Observation version
      logical,                    intent(inout) :: error    ! Logical error flag
    end subroutine entrydesc_init_v2
  end interface
  !
  interface
    subroutine entrydesc_read_v1(file,buf,edv2,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Read the Entry Descriptor, Version 1
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(inout) :: edv2   ! The Entry Descriptor read
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_read_v1
  end interface
  !
  interface
    subroutine entrydesc_v1tov2(ed1,ed2,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Convert a Version 1 Entry Descriptor to a Version 2
      !---------------------------------------------------------------------
      type(entrydesc_v1_t),      intent(in)    :: ed1    ! Version 1
      type(classic_entrydesc_t), intent(out)   :: ed2    ! Version 2
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_v1tov2
  end interface
  !
  interface
    subroutine entrydesc_read_v2(file,buf,ed,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Read the Entry Descriptor, Version 2
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor read
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_read_v2
  end interface
  !
  interface
    subroutine entrydesc_write_v1(file,buf,edv2,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Write the input Entry Descriptor, Version 1
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(in)    :: edv2   ! The Entry Descriptor to be written
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_write_v1
  end interface
  !
  interface
    subroutine entrydesc_v2tov1(ed2,ed1,error)
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Convert a Version 2 Entry Descriptor to a Version 1
      !---------------------------------------------------------------------
      type(classic_entrydesc_t), intent(in)    :: ed2    ! Version 2
      type(entrydesc_v1_t),      intent(out)   :: ed1    ! Version 1
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_v2tov1
  end interface
  !
  interface
    subroutine entrydesc_write_v2(file,buf,ed,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !   Write the input Entry Descriptor, Version 2
      !---------------------------------------------------------------------
      type(classic_file_t),      intent(in)    :: file   !
      type(classic_recordbuf_t), intent(inout) :: buf    ! Working buffer
      type(classic_entrydesc_t), intent(in)    :: ed     ! The Entry Descriptor to be written
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_write_v2
  end interface
  !
  interface
    subroutine entrydesc_section_add(ed,iden,leng,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Add a new section in the Entry Descriptor. Assume it does not
      ! exist yet
      !---------------------------------------------------------------------
      type(classic_entrydesc_t), intent(inout) :: ed     ! The Entry Descriptor
      integer(kind=4),           intent(in)    :: iden   ! The section identifier
      integer(kind=data_length), intent(in)    :: leng   ! The section length
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine entrydesc_section_add
  end interface
  !
  interface
    subroutine filedesc_init_common(fkind,vind,lind,lsingle,gex,fdesc,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Initialize the common part of File Descriptor structure in memory
      ! (i.e. V2), suited for any File Version
      !---------------------------------------------------------------------
      integer(kind=4),          intent(in)    :: fkind    ! File kind
      integer(kind=4),          intent(in)    :: vind     ! Index version
      integer(kind=4),          intent(in)    :: lind     ! Index length (words)
      logical,                  intent(in)    :: lsingle  ! Single or multiple?
      real(kind=4),             intent(in)    :: gex      ! Extension growth
      type(classic_filedesc_t), intent(inout) :: fdesc    ! File Descriptor
      logical,                  intent(inout) :: error    !
    end subroutine filedesc_init_common
  end interface
  !
  interface
    subroutine filedesc_init_v1(fdesc,error)
      use gbl_message
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !  Initialize the File Descriptor structure in memory (i.e. V2),
      ! suited for Version 1 files
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
      logical,                  intent(inout) :: error  !
    end subroutine filedesc_init_v1
  end interface
  !
  interface
    subroutine filedesc_init_v2(fdesc,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !  Initialize the File Descriptor structure in memory (i.e. V2),
      ! suited for Version 2 files
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
      logical,                  intent(inout) :: error  !
    end subroutine filedesc_init_v2
  end interface
  !
  interface
    subroutine filedesc_init_lex1(lsize,fdesc,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !   Compute the extension length. mex, gex and several parameters must
      ! have already been set.
      !---------------------------------------------------------------------
      integer(kind=entry_length), intent(in)    :: lsize  ! Max number of entries in the file
      type(classic_filedesc_t),   intent(inout) :: fdesc  ! File Descriptor
      logical,                    intent(inout) :: error  !
    end subroutine filedesc_init_lex1
  end interface
  !
  interface
    subroutine filedesc_incr(lun,fdesc,full,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      ! Increment the File Descriptor, i.e. add 1 new extension
      !---------------------------------------------------------------------
      integer(kind=4),          intent(in)    :: lun    ! File logical unit
      type(classic_filedesc_t), intent(inout) :: fdesc  ! File Descriptor
      logical,                  intent(out)   :: full   ! Is the index full?
      logical,                  intent(inout) :: error  ! Logical error flag
    end subroutine filedesc_incr
  end interface
  !
  interface
    subroutine filedesc_read_v1(file,error)
      use gildas_def
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the File Descriptor from the file, version 1 + conversion to
      ! structure in memory, version 2
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file   !
      logical,              intent(out)   :: error  ! Logical error flag
    end subroutine filedesc_read_v1
  end interface
  !
  interface
    subroutine filedesc_v1tov2(fdesc1,fdesc2,error)
      use classic_params
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(filedesc_v1_t),      intent(in)    :: fdesc1  !
      type(classic_filedesc_t), intent(inout) :: fdesc2  ! INOUT because of allocatable AEX(:)
      logical,                  intent(inout) :: error   !
    end subroutine filedesc_v1tov2
  end interface
  !
  interface
    subroutine filedesc_read_v2(file,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the File Descriptor from the file, version 2
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file   !
      logical,              intent(out)   :: error  ! Logical error flag
    end subroutine filedesc_read_v2
  end interface
  !
  interface
    subroutine filedesc_write_v1(file,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Write the File Descriptor to the file, version 1.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      logical,              intent(inout) :: error  ! Logical error flag
    end subroutine filedesc_write_v1
  end interface
  !
  interface
    subroutine filedesc_v2tov1(fdesc2,fdesc1,error)
      use gbl_message
      use classic_types
      use classic_vars
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(in)    :: fdesc2  !
      type(filedesc_v1_t),      intent(out)   :: fdesc1  !
      logical,                  intent(inout) :: error   !
    end subroutine filedesc_v2tov1
  end interface
  !
  interface
    subroutine filedesc_write_v2(file,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Write the File Descriptor to the file, version 2.
      !---------------------------------------------------------------------
      type(classic_file_t), intent(in)    :: file   !
      logical,              intent(inout) :: error  ! Logical error flag
    end subroutine filedesc_write_v2
  end interface
  !
  interface
    subroutine filedesc_update(buf,nword,fdesc,error)
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Update the file descriptor (nextrec, nextword) after a buffer has
      ! been written.
      !---------------------------------------------------------------------
      type(classic_recordbuf_t), intent(in)    :: buf    !
      integer(kind=data_length), intent(in)    :: nword  !
      type(classic_filedesc_t),  intent(inout) :: fdesc  !
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine filedesc_update
  end interface
  !
  interface
    subroutine reallocate_aex(fdesc,len,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)allocate the fdesc%aex(:) and fdesc%lexn(:) arrays
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(inout) :: fdesc  !
      integer(kind=4),          intent(in)    :: len    ! New length required
      logical,                  intent(inout) :: error  !
    end subroutine reallocate_aex
  end interface
  !
  interface
    subroutine deallocate_aex(fdesc,error)
      use gbl_message
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Deallocate (if needed) the fdesc%aex(:) and fdesc%lexn(:) arrays
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(inout) :: fdesc  !
      logical,                  intent(inout) :: error  !
    end subroutine deallocate_aex
  end interface
  !
  interface
    subroutine classic_file_loss_v1(file,unused,error)
      use gbl_message
      use gkernel_types
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Parse the input file and search for unused (lost) bytes
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file    !
      integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
      logical,              intent(inout) :: error   !
    end subroutine classic_file_loss_v1
  end interface
  !
  interface
    subroutine classic_file_loss_v2(file,unused,error)
      use gbl_message
      use gkernel_types
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Parse the input file and search for unused (lost) bytes
      !---------------------------------------------------------------------
      type(classic_file_t), intent(inout) :: file    !
      integer(kind=4),      intent(in)    :: unused  ! Number of unused bytes per Index
      logical,              intent(inout) :: error   !
    end subroutine classic_file_loss_v2
  end interface
  !
  interface
    subroutine classic_file_loss_index(fdesc,unused,nlost,ntot)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Compute the bytes lost in the File Index. This is a function of
      ! the Index growth, not of the File Version.
      !---------------------------------------------------------------------
      type(classic_filedesc_t), intent(in)    :: fdesc   ! The File Descriptor
      integer(kind=4),          intent(in)    :: unused  ! Number of unused bytes per Index
      integer(kind=8),          intent(out)   :: nlost   ! Number of bytes lost
      integer(kind=8),          intent(out)   :: ntot    ! Total number of bytes
    end subroutine classic_file_loss_index
  end interface
  !
  interface
    subroutine entryindex_new(file,entry_num,full,error)
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !   Allocate room (i.e. a new extension index), if needed, for the
      ! entry 'entry_num'.
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(inout) :: file       !
      integer(kind=entry_length), intent(in)    :: entry_num  ! Entry number
      logical,                    intent(out)   :: full       ! Index is full?
      logical,                    intent(inout) :: error      ! Logical errror flag
    end subroutine entryindex_new
  end interface
  !
  interface
    subroutine entryindex_readrec(file,entry_num,buf,error)
      use gildas_def
      use gbl_message
      use classic_params
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !   Read the record where the entry index 'entry_num' starts. Return
      ! this record in the given buffer. This subroutine has 2 goals:
      !  - from 'entry_num' find in which extension the entry is, and in
      !    which record its index is found,
      !  - set up the 'buffer' type correctly i.e. description and buffer.
      !---------------------------------------------------------------------
      type(classic_file_t),       intent(in)    :: file       !
      integer(kind=entry_length), intent(in)    :: entry_num  !
      type(classic_recordbuf_t),  intent(inout) :: buf        !
      logical,                    intent(inout) :: error      !
    end subroutine entryindex_readrec
  end interface
  !
  interface
    subroutine indexaddr_frombuf_v1(data,ind,conv,error)
      use gildas_def
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the Index previously loaded in buf%data, position k
      !  This routine is generic and do not know the details about the
      ! Index, so it reads only the first element: in File Version 1 it
      ! must be the Entry Address coded as an Integer*4 (returned in addr8)
      !---------------------------------------------------------------------
      integer(kind=4),          intent(in)    :: data(*)  !
      type(indx_basic_v2_t),    intent(out)   :: ind      !
      type(classic_fileconv_t), intent(in)    :: conv     !
      logical,                  intent(inout) :: error    !
    end subroutine indexaddr_frombuf_v1
  end interface
  !
  interface
    subroutine indexaddr_frombuf_v2(data,ind,conv,error)
      use gildas_def
      use classic_types
      !---------------------------------------------------------------------
      ! @ private
      !  Read the Index previously loaded in buf%data, position k
      !  This routine is generic and do not know the details about the
      ! Index, so it reads only the 2 first elements: in File Version 2 it
      ! must be the Entry Address (record and word)
      !---------------------------------------------------------------------
      integer(kind=4),          intent(in)    :: data(*)  !
      type(indx_basic_v2_t),    intent(out)   :: ind      !
      type(classic_fileconv_t), intent(in)    :: conv     !
      logical,                  intent(inout) :: error    !
    end subroutine indexaddr_frombuf_v2
  end interface
  !
  interface
    subroutine recordbuf_close(buf,error)
      use gbl_message
      use classic_types
      !----------------------------------------------------------------------
      ! @ private
      !   Flush the currently opened record to the appropriate record in the
      ! output file
      !----------------------------------------------------------------------
      type(classic_recordbuf_t), intent(in)    :: buf    ! Working buffer
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine recordbuf_close
  end interface
  !
  interface
    subroutine toc_select_one(rname,toc,keywords,key,dobak,p_format,error)
      use toc_types
      !---------------------------------------------------------------------
      ! @ private
      !  Compute the equivalence classes for one keyword
      !---------------------------------------------------------------------
      character(len=*),       intent(in)            :: rname        ! Calling routine name
      type(toc_t),            intent(inout), target :: toc          !
      integer(kind=4),        intent(in)            :: keywords(1)  !
      type(toc_descriptor_t), pointer               :: key          ! Associated on return
      logical,                intent(in)            :: dobak        ! Also generate the back pointers (key%select%bak)?
      interface
        subroutine p_format(key,ival,output)  ! Formatting subroutine
        use classic_params
        use toc_types
        type(toc_descriptor_t),     intent(in)  :: key
        integer(kind=entry_length), intent(in)  :: ival
        character(len=*),           intent(out) :: output
        end subroutine p_format
      end interface
      logical,                intent(inout)         :: error        ! Logical error flag
    end subroutine toc_select_one
  end interface
  !
  interface
    function toc_select_keywords(keywords,toc,selected,error)
      use gbl_message
      use toc_types
      !---------------------------------------------------------------------
      ! @ private
      !  Identify the selected keywords and set up the internal pointers
      ! accordingly
      !---------------------------------------------------------------------
      integer(kind=4) :: toc_select_keywords  ! Function value on return
      integer(kind=4), intent(in)    :: keywords(:)  ! Keyword identifiers
      type(toc_t),     intent(inout) :: toc          ! Table-Of-Content description
      integer(kind=4), intent(out)   :: selected(:)  ! Keyword numbers
      logical,         intent(inout) :: error        ! Logical error flag
    end function toc_select_keywords
  end interface
  !
  interface
    subroutine toc_select_do(rname,toc,key,num,ndata,obak,nelem,fwd,cnt,dobak,p_format,error)
      use toc_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*),           intent(in)    :: rname
      type(toc_t),                intent(in)    :: toc
      type(toc_descriptor_t),     intent(inout) :: key
      integer(kind=4),            intent(in)    :: num(key%select%nkey)  ! Key numbers for this selection
      integer(kind=entry_length), intent(in)    :: ndata        ! Size of the original data arrays
      integer(kind=entry_length), intent(in)    :: obak(ndata)  ! Old back pointer (see below)
      integer(kind=entry_length), intent(in)    :: nelem
      integer(kind=entry_length), intent(inout) :: fwd(nelem)
      integer(kind=entry_length), intent(inout) :: cnt(nelem)
      logical,                    intent(in)    :: dobak        ! Also generate the back pointers (key%select%bak)?
      interface
        subroutine p_format(key,ival,output)  ! Formatting subroutine
        use classic_params
        use toc_types
        type(toc_descriptor_t),     intent(in)  :: key
        integer(kind=entry_length), intent(in)  :: ival
        character(len=*),           intent(out) :: output
        end subroutine p_format
      end interface
      logical,                    intent(inout) :: error
    end subroutine toc_select_do
  end interface
  !
  interface
    subroutine toc_structure_parent(rname,name,error)
      use gbl_message
      use gkernel_types
      !---------------------------------------------------------------------
      ! @ private
      !  Define the Table-Of-Content Sic structure (parent structure part)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname  ! Calling routine name
      character(len=*), intent(in)    :: name   ! Structure name e.g. MYTOC
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine toc_structure_parent
  end interface
  !
  interface
    subroutine toc_structure_key(rname,sname,key,twodims,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use gkernel_types
      use toc_types
      !---------------------------------------------------------------------
      ! @ private
      !  Define the Table-Of-Content Sic structure (one key part)
      !---------------------------------------------------------------------
      character(len=*),       intent(in)    :: rname    ! Calling routine name
      character(len=*),       intent(in)    :: sname    ! Structure name e.g. MYTOC
      type(toc_descriptor_t), intent(in)    :: key      !
      logical,                intent(in)    :: twodims  ! Two dimensions for MYTOC%MSOUR?
      logical,                intent(inout) :: error    ! Logical error flag
    end subroutine toc_structure_key
  end interface
  !
end module classic_interfaces_private

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_allocate_fft_wifi(ispace,wifi,fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_allocate_fft_wifi
  use wifisyn_cube_types
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  integer,              intent(in)    :: ispace
  type(wifi_t), target, intent(in)    :: wifi
  type(fft_t),          intent(out)   :: fft
  logical,              intent(inout) :: error
  !
  integer :: nx,ny
  character(len=*), parameter :: rname='ALLOCATE/FFT/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(wifi%cub%val)) then
     call wifisyn_message(seve%t,rname,'Unallocated wifi%cub')
     error = .true.
     return
  endif
  fft%wifi => wifi%cub
  if (ispace.eq.code_space_uv) then
     nx = wifi%cub%nu
     ny = wifi%cub%nv
     fft%datakind => wifi%uvkind
  else if (ispace.eq.code_space_xy) then
     nx = wifi%cub%nx
     ny = wifi%cub%ny
     fft%datakind => wifi%xykind
  else
     call wifisyn_message(seve%e,rname,'Unknown plane')
     error = .true.
     return
  endif
  call wifisyn_allocate_complex_2d("fft plane",nx,ny,fft%plane,error)
  if (error) return
  call wifisyn_allocate_complex_1d("fft work space",max(nx,ny),fft%work,error)
  if (error) return
  !
end subroutine wifisyn_allocate_fft_wifi
!
subroutine wifisyn_allocate_fft_visi(visi,fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_allocate_fft_visi
  use wifisyn_cube_types
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(visi_t), target, intent(in)    :: visi
  type(fft_t),          intent(out)   :: fft
  logical,              intent(inout) :: error
  !
  integer :: nx,ny
  character(len=*), parameter :: rname='ALLOCATE/FFT/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(visi%cub%val)) then
     call wifisyn_message(seve%t,rname,'Unallocated visicub')
     error = .true.
     return
  endif
  fft%datakind => visi%uvkind
  fft%visi => visi%cub
  nx = visi%cub%nx
  ny = visi%cub%ny
  call wifisyn_allocate_complex_2d("fft plane",nx,ny,fft%plane,error)
  if (error) return
  call wifisyn_allocate_complex_1d("fft work space",max(nx,ny),fft%work,error)
  if (error) return
  !
end subroutine wifisyn_allocate_fft_visi
!
subroutine wifisyn_free_fft(fft,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_free_fft
  use wifisyn_transform_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(fft_t), intent(inout) :: fft
  logical,     intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE/FFT'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nullify(fft%wifi)
  nullify(fft%visi)
  call wifisyn_free_complex_2d(fft%plane,error)
  if (error) return
  call wifisyn_free_complex_1d(fft%work,error)
  if (error) return
  !
end subroutine wifisyn_free_fft
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use wifisyn_interfaces, except_this=>wifisyn_fft_command
  use wifisyn_sic_buffer
  use wifisyn_cube_buffer
  use wifisyn_transform_types
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !     FFT WIFI|VISI
  !       1 /DIRECT
  !       2 /INVERSE
  !       3 /UV
  !       4 /XY
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical,          intent(inout) :: error
  !
  type(action_t) :: do
  character(len=*), parameter :: rname='FFT/COMMAND'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_parse_transform(line,do,error)
  if (error) return
  if (do%cube.eq.code_cube_visi) then
     call wifisyn_fft_visi(do%dire,progmap%win%cur(1),visi,error)
     if (error) return
  else if (do%cube.eq.code_cube_wifi) then
     call wifisyn_fft_wifi(do%dire,do%space,progmap%win%cur(1),wifi,error)
     if (error) return
  else
     call wifisyn_message(seve%e,rname,'Unknown cube kind')
     error = .true.
     return
  endif
  !
end subroutine wifisyn_fft_command
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_wifi(idir,ispace,win,wifi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi
  use wifisyn_gridding_types
  use wifisyn_cube_types
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  integer,        intent(in)    :: ispace
  type(window_t), intent(in)    :: win
  type(wifi_t),   intent(inout) :: wifi
  logical,        intent(inout) :: error
  !
  type(fft_t) :: fft
  character(len=*), parameter :: rname='FFT/WIFI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_allocate_fft_wifi(ispace,wifi,fft,error)
  if (error) return
  if (ispace.eq.code_space_uv) then
     call wifisyn_fft_wifi_uv(idir,win,fft,error)
     if (error) return
  else if (ispace.eq.code_space_xy) then
     call wifisyn_fft_wifi_xy(idir,win,fft,error)
     if (error) return
  else
     call wifisyn_message(seve%e,rname,'Unknown plane')
     error = .true.
     return
  endif
  call wifisyn_free_fft(fft,error)
  if (error) return
  !
end subroutine wifisyn_fft_wifi
!
subroutine wifisyn_fft_wifi_xy(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi_xy
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: iu,iv,ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/WIFI/XY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'WIFI XY direct FFT')
  else
     call wifisyn_message(seve%i,rname,'WIFI XY inverse FFT')
  endif
  !
  dim = (/ fft%wifi%nx,fft%wifi%ny/)
  call gtime_init(time,fft%wifi%nv*fft%wifi%nu*win%nchan,error)
  do iv=1,fft%wifi%nv
     do iu=1,fft%wifi%nu
        do ic=win%first,win%last
           call gtime_current(time)
           call wifisyn_fft_xyuv2xy(ic,iu,iv,fft)
           call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
           call wifisyn_fft_xy2xyuv(ic,iu,iv,fft)
        enddo ! ic
     enddo ! iu
  enddo !iv
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_wifi_xy
!
subroutine wifisyn_fft_xyuv2xy(ic,iu,iv,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_xyuv2xy
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: iu
  integer,     intent(in)    :: iv
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/XYUV2XY'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! xy bottom, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy) = fft%wifi%val(ic,ix+mx,iy+my,iu,iv)
     enddo
     ! xy bottom, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy) = fft%wifi%val(ic,ix,iy+my,iu,iv)
     enddo
  enddo
  do iy=1,my
     ! xy top, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy+my) = fft%wifi%val(ic,ix+mx,iy,iu,iv)
     enddo
     ! xy top, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy+my) = fft%wifi%val(ic,ix,iy,iu,iv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xyuv2xy
!
subroutine wifisyn_fft_xy2xyuv(ic,iu,iv,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_xy2xyuv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: iu
  integer,     intent(in)    :: iv
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/XY2XYUV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! xy bottom, left quarter
     do ix=1,mx
        fft%wifi%val(ic,ix+mx,iy+my,iu,iv) = fft%plane%val(ix,iy)
     enddo
     ! xy bottom, right quarter
     do ix=1,mx
        fft%wifi%val(ic,ix,iy+my,iu,iv) = fft%plane%val(ix+mx,iy)
     enddo
  enddo
  do iy=1,my
     ! xy top, left quarter
     do ix=1,mx
        fft%wifi%val(ic,ix+mx,iy,iu,iv) = fft%plane%val(ix,iy+my)
     enddo
     ! xy top, right quarter
     do ix=1,mx
        fft%wifi%val(ic,ix,iy,iu,iv) = fft%plane%val(ix+mx,iy+my)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xy2xyuv
!
subroutine wifisyn_fft_wifi_uv(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_wifi_uv
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: ix,iy,ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/WIFI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'WIFI UV direct FFT')
  else
     call wifisyn_message(seve%i,rname,'WIFI UV inverse FFT')
  endif
  !
  dim = (/ fft%wifi%nu,fft%wifi%nv/)
  call gtime_init(time,fft%wifi%nx*fft%wifi%ny*win%nchan,error)
  do iy=1,fft%wifi%ny
     do ix=1,fft%wifi%nx
        do ic=win%first,win%last
           call gtime_current(time)
           call wifisyn_fft_xyuv2uv(ic,ix,iy,fft)
           call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
           call wifisyn_fft_uv2xyuv(ic,ix,iy,fft)
        enddo ! ic
     enddo ! ix
  enddo !iy
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_wifi_uv
!
subroutine wifisyn_fft_xyuv2uv(ic,ix,iy,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_xyuv2uv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: ix
  integer,     intent(in)    :: iy
  type(fft_t), intent(inout) :: fft
  !
  integer :: iu,mu
  integer :: iv,mv
  character(len=*), parameter :: rname='FFT/XYUV2UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mu = fft%plane%nx/2
  mv = fft%plane%ny/2
  do iv=1,mv
     ! uv bottom, left quarter
     do iu=1,mu
        fft%plane%val(iu,iv) = fft%wifi%val(ic,ix,iy,iu+mu,iv+mv)
     enddo
     ! uv bottom, right quarter
     do iu=1,mu
        fft%plane%val(iu+mu,iv) = fft%wifi%val(ic,ix,iy,iu,iv+mv)
     enddo
  enddo
  do iv=1,mv
     ! uv top, left quarter
     do iu=1,mu
        fft%plane%val(iu,iv+mv) = fft%wifi%val(ic,ix,iy,iu+mu,iv)
     enddo
     ! uv top, right quarter
     do iu=1,mu
        fft%plane%val(iu+mu,iv+mv) = fft%wifi%val(ic,ix,iy,iu,iv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_xyuv2uv
!
subroutine wifisyn_fft_uv2xyuv(ic,ix,iy,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_uv2xyuv
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  integer,     intent(in)    :: ix
  integer,     intent(in)    :: iy
  type(fft_t), intent(inout) :: fft
  !
  integer :: iu,mu
  integer :: iv,mv
  character(len=*), parameter :: rname='FFT/UV2XYUV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mu = fft%plane%nx/2
  mv = fft%plane%ny/2
  do iv=1,mv
     ! uv bottom, left quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu+mu,iv+mv) = fft%plane%val(iu,iv)
     enddo
     ! uv bottom, right quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu,iv+mv) = fft%plane%val(iu+mu,iv)
     enddo
  enddo
  do iv=1,mv
     ! uv top, left quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu+mu,iv) = fft%plane%val(iu,iv+mv)
     enddo
     ! uv top, right quarter
     do iu=1,mu
        fft%wifi%val(ic,ix,iy,iu,iv) = fft%plane%val(iu+mu,iv+mv)
     enddo
  enddo
  !
end subroutine wifisyn_fft_uv2xyuv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_fft_visi(idir,win,visi,error)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi
  use wifisyn_gridding_types
  use wifisyn_cube_types
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(visi_t),   intent(inout) :: visi
  logical,        intent(inout) :: error
  !
  type(fft_t) :: fft
  character(len=*), parameter :: rname='FFT/VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_allocate_fft_visi(visi,fft,error)
  if (error) return
  call wifisyn_fft_visi_uv(idir,win,fft,error)
  if (error) return
  call wifisyn_free_fft(fft,error)
  if (error) return
  !
end subroutine wifisyn_fft_visi
!
subroutine wifisyn_fft_visi_uv(idir,win,fft,error)
  use gbl_message
  use gkernel_interfaces, nointerface=>fourt
  use gkernel_types
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi_uv
  use wifisyn_transform_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,        intent(in)    :: idir
  type(window_t), intent(in)    :: win
  type(fft_t),    intent(inout) :: fft
  logical,        intent(inout) :: error
  !
  integer :: ic,dim(2)
  type(time_t) :: time
  character(len=*), parameter :: rname='FFT/VISI/UV'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  if (idir.eq.code_direct) then
     call wifisyn_message(seve%i,rname,'VISI direct FFT')
  else
     call wifisyn_message(seve%i,rname,'VISI inverse FFT')
  endif
  !
  dim = (/ fft%visi%nx,fft%visi%ny/)
  call gtime_init(time,win%nchan,error)
  do ic=win%first,win%last
     call gtime_current(time)
     call wifisyn_fft_visi2plane(ic,fft)
     call fourt(fft%plane%val,dim,2,idir,code_type_complex,fft%work%val)
     call wifisyn_fft_plane2visi(ic,fft)
  enddo ! ic
  fft%datakind = .not.fft%datakind
  !
end subroutine wifisyn_fft_visi_uv
!
subroutine wifisyn_fft_visi2plane(ic,fft)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_fft_visi2plane
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/VISI2PLANE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! Plane bottom, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy) = fft%visi%val(ix+mx,iy+my,ic)
     enddo
     ! Plane bottom, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy) = fft%visi%val(ix,iy+my,ic)
     enddo
  enddo
  do iy=1,my
     ! Plane top, left quarter
     do ix=1,mx
        fft%plane%val(ix,iy+my) = fft%visi%val(ix+mx,iy,ic)
     enddo
     ! Plane top, right quarter
     do ix=1,mx
        fft%plane%val(ix+mx,iy+my) = fft%visi%val(ix,iy,ic)
     enddo
  enddo
  !
end subroutine wifisyn_fft_visi2plane
!
subroutine wifisyn_fft_plane2visi(ic,fft)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_fft_plane2visi
  use wifisyn_transform_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer,     intent(in)    :: ic
  type(fft_t), intent(inout) :: fft
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='FFT/PLANE2VISI'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = fft%plane%nx/2
  my = fft%plane%ny/2
  do iy=1,my
     ! Plane bottom, left quarter
     do ix=1,mx
        fft%visi%val(ix+mx,iy+my,ic) = fft%plane%val(ix,iy)
     enddo
     ! Plane bottom, right quarter
     do ix=1,mx
        fft%visi%val(ix,iy+my,ic) = fft%plane%val(ix+mx,iy)
     enddo
  enddo
  do iy=1,my
     ! Plane top, left quarter
     do ix=1,mx
        fft%visi%val(ix+mx,iy,ic) = fft%plane%val(ix,iy+my)
     enddo
     ! Plane top, right quarter
     do ix=1,mx
        fft%visi%val(ix,iy,ic) = fft%plane%val(ix+mx,iy+my)
     enddo
  enddo
  !
end subroutine wifisyn_fft_plane2visi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_userspace
  use gkernel_interfaces
  use gkernel_types
  use cubesyntax_messaging
  use cubetools_parameters
  use cubetools_structure
  use cubelist_types
  !
  public :: userspace_opt_t,userspace_user_t,userspace_t
  public :: cubetools_userspace_array_remove,cubetools_userspace_array_update
  public :: cubetools_userspace_get,cubetools_userspace_query
  public :: overwrite_no,overwrite_user,overwrite_prog
  private
  !
  integer(kind=4), parameter  :: nforbid = 2
  character(len=*), parameter :: forbidden(2) = [strg_star,strg_equal]
  !
  ! Overwriting modes
  integer(kind=4), parameter :: overwrite_no  =100  ! Attempt to overwrite raises an error
  integer(kind=4), parameter :: overwrite_user=101  ! Overwriting a user-defined variable is allowed
  integer(kind=4), parameter :: overwrite_prog=102  ! Overwriting a user or program-defined variable is allowed
  !
  type userspace_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: scope
     type(keywordlist_comm_t), pointer :: overwrite
   contains
     procedure :: register  => cubetools_userspace_register
     procedure :: parse     => cubetools_userspace_parse
     procedure :: user2prog => cubetools_userspace_user2prog
  end type userspace_opt_t
  !
  type userspace_user_t
     logical               :: do        = .false.
     character(len=varn_l) :: name      = strg_unk
     character(len=argu_l) :: scope     = strg_unk
     character(len=argu_l) :: overwrite = strg_unk
  end type userspace_user_t
  !
  type, extends(list_object_t) :: userspace_t
     character(len=varn_l)  :: name
     logical                :: scope
     integer(kind=code_k)   :: overwrite
     type(sic_descriptor_t) :: desc ! sic descriptor
   contains
     procedure, private :: copy => cubetools_userspace_copy
     generic, public    :: assignment(=) => copy
     procedure :: delete      => cubetools_sicdef_delete
     procedure :: fetch_desc  => cubetools_sicdef_fetch_descriptor
     procedure :: has_changed => cubetools_sicdef_desc_changed
     procedure, public :: final => cubetools_userspace_final
  end type userspace_t
  !
contains
  !
  subroutine cubetools_userspace_register(opt,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(userspace_opt_t), intent(out)   :: opt
    logical,                intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: scope(2) = ['GLOBAL','LOCAL ']
    character(len=*), parameter :: yesno(2) = ['YES','NO ']
    character(len=*), parameter :: rname='USERSPACE>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'INTO','varname [scope [overwrite]]',&
         'Define the SIC variable name and its status',&
         strg_emp,&
         opt%opt,error)
    if (error) return
    call stdarg%register( &
         'varname',  &
         'Variable name', &
         strg_emp,&
         code_arg_mandatory, &
         error)
    if (error) return
    call keyarg%register( &
         'scope',  &
         'Variable is global or local', &
         'Default is global',&
         code_arg_optional, &
         scope, &
         .not.flexible, &
         opt%scope, &
         error)
    if (error) return
    call keyarg%register( &
         'overwrite',  &
         'Overwrite previous variable of same name', &
         'Default is yes',&
         code_arg_optional, &
         yesno, &
         .not.flexible, &
         opt%overwrite, &
         error)
    if (error) return
  end subroutine cubetools_userspace_register
  !
  subroutine cubetools_userspace_parse(opt,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(userspace_opt_t), intent(in)    :: opt
    character(len=*),       intent(in)    :: line
    type(userspace_user_t), intent(out)   :: user
    logical,                intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,opt%opt,1,user%name,mandatory,error)
       if (error) return
       user%scope = 'LOCAL'
       call cubetools_getarg(line,opt%opt,2,user%scope,.not.mandatory,error)
       if (error) return
       user%overwrite = 'YES'
       call cubetools_getarg(line,opt%opt,3,user%overwrite,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetools_userspace_parse
  !
  subroutine cubetools_userspace_user2prog(opt,user,prog,error)
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(userspace_opt_t), intent(in)    :: opt
    type(userspace_user_t), intent(in)    :: user
    class(userspace_t),     intent(inout) :: prog
    logical,                intent(inout) :: error
    !
    character(len=argu_l) :: scope,overwrite
    integer(kind=4) :: ikey,iforbid
    character(len=*), parameter :: rname='USERSPACE>USER2PROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    do iforbid=1,nforbid
       if (user%name.eq.forbidden(iforbid)) then
          call cubesyntax_message(seve%e,rname,'The name '//trim(user%name)//&
               ' is protected and cannot be used')
          error = .true.
          return
       endif
    enddo
    call cubetools_disambiguate_toupper(user%name,prog%name,error)
    if (error) return
    call cubetools_keywordlist_user2prog(opt%scope,user%scope,ikey,scope,error)
    if (error) return
    prog%scope = scope.eq.'GLOBAL'
    call cubetools_keywordlist_user2prog(opt%overwrite,user%overwrite,ikey,overwrite,error)
    if (error) return
    if (overwrite.eq.'YES') then
      ! NB: user has no access to overwrite_prog (avoid LOAD /INTO PI)
      prog%overwrite = overwrite_user
    else
      prog%overwrite = overwrite_no
    endif
  end subroutine cubetools_userspace_user2prog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_userspace_get(name,userspace,error)
    !----------------------------------------------------------------------
    ! Get a userspace element from a name and a type
    !----------------------------------------------------------------------
    character(len=*),   intent(in)    :: name
    class(userspace_t), intent(out)   :: userspace
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>GET'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (.not.sic_varexist(name)) then
      call cubesyntax_message(seve%e,rname,'Variable '//trim(name)//' does not exist')
      error = .true.
      return
    endif
    !
    userspace%name = name
    call userspace%fetch_desc(error)
    if (error) return
    if (userspace%desc%readonly) then
      userspace%overwrite = overwrite_no
    else
      userspace%overwrite = overwrite_user
    endif
    userspace%scope = sic_level(name).eq.0
  end subroutine cubetools_userspace_get
  !
  function cubetools_userspace_query(name)
    !----------------------------------------------------------------------
    ! Tests if a variable with name exists in userspace
    !----------------------------------------------------------------------
    logical :: cubetools_userspace_query
    character(len=*), intent(in) :: name
    !
    cubetools_userspace_query = sic_varexist(name)
  end function cubetools_userspace_query
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_sicdef_delete(userspace,error)
    !------------------------------------------------------------------------
    ! Tests if a sic object with that name exists:
    ! - if it does not, simply return
    ! - if it does and overwrite is forbidden, raise an error
    ! - if it does and overwrite is allowed, delete the variable
    !------------------------------------------------------------------------
    class(userspace_t), intent(in)    :: userspace
    logical,            intent(inout) :: error
    !
    logical :: found,user_request
    type(sic_descriptor_t) :: desc
    character(len=*), parameter :: rname='SICDEF>DELETE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    found = .false.
    call sic_descriptor(trim(userspace%name),desc,found)
    !
    if (.not.found)  return
    !
    if (userspace%overwrite.eq.overwrite_no) then
      call cubesyntax_message(seve%e,rname,'Variable '//trim(userspace%name)//' already exists')
      error = .true.
      return
    endif
    !
    ! Important: SIC variables must be deleted (sic_delvariable) with
    ! the proper 'user request' flag matching its internal status,
    ! otherwise this messes up the internal list of variables.
    if (desc%status.eq.program_defined) then
      if (userspace%overwrite.eq.overwrite_prog) then
        ! CUBE allows this program-defined variable to be deleted
        user_request = .false.
      else
        ! Any other program-defined variable is protected (e.g. PI)
        user_request = .true.
      endif
    else
      user_request = .true.
    endif
    call cubesyntax_message(syntaxseve%others,rname,trim(userspace%name)//' exists, overwriting it')
    call sic_delvariable(trim(userspace%name),user_request,error)
    if (error) return
  end subroutine cubetools_sicdef_delete
  !
  subroutine cubetools_sicdef_fetch_descriptor(userspace,error)
    !------------------------------------------------------------------------
    ! Fetch sic descriptor for the userspace item
    !------------------------------------------------------------------------
    class(userspace_t), intent(inout) :: userspace
    logical,            intent(inout) :: error
    !
    logical :: found
    character(len=*), parameter :: rname='SICDEF>FETCH>DESCRIPTOR'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    found = .false.
    call sic_descriptor(userspace%name,userspace%desc,found)
    if (.not.found) then
       call cubesyntax_message(seve%e,rname,'User space item does not exist')
       error = .true.
       return
    endif
  end subroutine cubetools_sicdef_fetch_descriptor
  !
  function cubetools_sicdef_desc_changed(userspace) result(changed)
    !------------------------------------------------------------------------
    ! Checks if descriptor for a userspace object exists, and if it
    ! has changed since created
    !------------------------------------------------------------------------
    class(userspace_t), intent(in) :: userspace
    logical                        :: changed   
    !
    logical :: found
    type(sic_descriptor_t) :: mydesc
    character(len=*), parameter :: rname='SICDEF>DESCRIPTOR>CHANGED'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call sic_descriptor(userspace%name,mydesc,found)
    if (.not.found) then
       changed = .true.
       return
    else
       changed = sic_notsamedesc(userspace%desc,mydesc)
    endif
  end function cubetools_sicdef_desc_changed
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_userspace_array_remove(arr,uspace,error)
    !-------------------------------------------------------------------
    ! Clean out from the list elements which are "identical" to the
    ! given userspace. This is intended to be used before inserting such
    ! a userspace, i.e. to avoid conflicts.
    !-------------------------------------------------------------------
    type(list_t),       intent(inout) :: arr
    class(userspace_t), intent(in)    :: uspace
    logical,            intent(inout) :: error
    ! Local
    integer(kind=list_k) :: obuf
    class(userspace_t), pointer :: lspace
    !
    obuf = 1
    do while (obuf.le.arr%n)  ! NB: arr%n is expected to change during loop execution
      lspace => cubetools_userspace_ptr(arr%list(obuf)%p,error)
      if (error) return
      if (lspace%name.eq.uspace%name .and.  &
          (lspace%scope.eqv.uspace%scope)) then
        call arr%pop(obuf,error)
        if (error) return
      else
        obuf = obuf+1
      endif
    enddo
  end subroutine cubetools_userspace_array_remove
  !
  subroutine cubetools_userspace_array_update(arr,error)
    !------------------------------------------------------------------------
    ! Update the array list, i.e. check for buffers removed by some
    ! external mean (e.g. user DELETE /VAR) and compress the list
    ! accordingly
    !------------------------------------------------------------------------
    type(list_t), intent(inout) :: arr
    logical,      intent(inout) :: error
    !
    class(userspace_t), pointer :: uspace
    integer(kind=4) :: oldn,newn,obuf
    character(len=*), parameter :: rname='USERSPACE>ARRAY>UPDATE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'welcome')
    !
    if (arr%n.le.0)  return
    !
    oldn = arr%n
    newn = 0
    do obuf=1,oldn
      uspace => cubetools_userspace_ptr(arr%list(obuf)%p,error)
      if (error) return
      if (uspace%has_changed()) then
        ! Ideally we should use arr%pop(), but I would like
        ! to avoid compressing the list several times, as several
        ! buffers migth be removed here
        if (arr%list(obuf)%code_pointer.eq.code_pointer_allocated)  &
          deallocate(uspace)
      else
        newn = newn+1
        arr%list(newn)%p => uspace
        arr%list(newn)%code_pointer = arr%list(obuf)%code_pointer
      endif
    enddo
    !
    ! There might be unused elements at the end of the list
    do obuf=newn+1,oldn
      arr%list(obuf)%p => null()
      arr%list(obuf)%code_pointer = code_pointer_null
    enddo
    !
    ! Update array size
    arr%n = newn
    !
    if (newn.eq.0) then
      call arr%final(error)
      if (error) return
    endif
  end subroutine cubetools_userspace_array_update
  !
  function cubetools_userspace_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(userspace_t), and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    class(userspace_t), pointer :: cubetools_userspace_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='USERSPACE>PTR'
    !
    select type(tot)
    class is (userspace_t)
      cubetools_userspace_ptr => tot
    class default
      cubetools_userspace_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a userspace_t class')
      error = .true.
      return
    end select
  end function cubetools_userspace_ptr
  !
  subroutine cubetools_userspace_copy(o,i)
    !-------------------------------------------------------------------
    ! Copy one userspace_t CLASS to another CLASS
    !-------------------------------------------------------------------
    class(userspace_t), intent(inout) :: o
    class(userspace_t), intent(in)    :: i
    !
   !o%list_object_t = i%list_object_t
    o%name          = i%name
    o%scope         = i%scope
    o%overwrite     = i%overwrite
    o%desc          = i%desc
  end subroutine cubetools_userspace_copy
  !
  subroutine cubetools_userspace_final(obj,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(userspace_t), intent(inout) :: obj
    logical,            intent(inout) :: error
  end subroutine cubetools_userspace_final
  !
end module cubetools_userspace
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     
! Id: modulePakoMessages.f90, v 1.2.4    2015-05-25 Hans Ungerechts
!     <-- patch from          v 1.1.15.1 2014-05-15 on hu-lenny
!         for project names with mixed/upper case, e.g., D015-14 
!         Note: pakoMessage_init may be obsolete anyhow ?
! 
! Id: modulePakoMessages.f90, v 1.2.3   2014-02-17 Hans Ungerechts
! Id: modulePakoMessages.f90, v 1.2.2.1 2014-01-23 Hans Ungerechts
! Id: modulePakoMessages.f90, v 1.2.2   2013-02-15 Hans Ungerechts
! Id: modulePakoMessages.f90, v 1.2.0   2012-02-07 Hans Ungerechts
!    
! <DOCUMENTATION name="modulePakoUtilities">
!
! Pako Utilitiy to handle I W E F "messages".
!
! </DOCUMENTATION>
!
! <DEV> 
! TBD: - more documentation
! <\DEV> 
!
Module modulePakoMessages
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  !
  ! *** Subroutines
  !
  Public :: pakoMessage
  Public :: pakoMessage_init
  Public :: pakoMessage_level
  Public :: pakoMessageSwitch
  !
  Integer :: iPstdio = 0 , iPfile = 0, iUnit = 0
  !
  Integer, Parameter :: lenLine = 256
  !
  Integer, Parameter :: lSeverityCode    = 1
  Integer, Parameter :: nDimSeverityCode = 4
  Character(len=lSeverityCode), Dimension(nDimSeverityCode) :: &
       & sC = (/ 'I','W','E','F' /)
  !
  Logical  ::  pakoMessageOn   =  .True.
  Logical  ::  pakoMessageOff  =  .False.

  Character*12  :: programName = "pako" 

!!!
!!!
Contains
!!!
!!!
  Subroutine pakoMessage (iPriority, iSeverity, package, messageText)
    !
    !   handle message 
    !
    Integer, Intent(in)          :: iPriority   ! "priority"
    Integer, Intent(in)          :: iSeverity   ! "severity" I W E F
    Character(len=*), Intent(in) :: package     ! name of sw package
    Character(len=*), Intent(in) :: messageText ! text of message
    !
    Integer, Parameter   :: lOut = 160
    Character(len=lOut)  :: messageTextOut
    !
    Integer :: iS, nl
    !
    Integer :: length
    !
    length = Len_Trim(messageText)
    !
    !D     Write (6,*) "  "
    !
    !D     Call pako_message(seve%t,programName,                                        &
    !D          &  " module Messages, v 1.2.3 2014-02-17  --> SR: pakoMessage ")        ! trace execution
    !
    !!  If (GV%doDebugMessages) Then
    !D     Write (6,*) "              iPriority:   ", iPriority
    !D     Write (6,*) "              iSeverity:   ", iSeverity
    !D     Write (6,*) "              package: -->", package(1:len_trim(package)), "<--"
    !D     Write (6,*) "              messageText(1:length): -->", messageText(1:length), "<--"
    !D     Write (6,*) "  "
    !D     Write (6,*) "              iPstdio:     ", iPstdio
    !D     Write (6,*) "              iPfile:      ", iPfile
    !!  End If
    !
    iS = Min(Max(iSeverity,1),nDimSeverityCode)
    nl = Min(Len_trim(messageText),lOut)
    !
    messageTextOut = messageText(1:nl)
    nl             = Len(messageTextOut)
    Call Sic_noir(messageTextOut,nl)
    !
    length = Len_Trim(messageTextOut)
    !
    !D     Write (6,*) "              messageTextOut(1:length): -->", messageTextOut(1:length)
    !D     Write (6,*) sC(iS),package,messageTextOut(1:nl)
    !D     Write (6,*) iPriority,sC(iS),package,messageTextOut(1:nl)
    !D     Write (6,*) "using format 101:"
    !D     Write (6,101) iPriority,sC(iS),package,messageTextOut(1:nl)
    !
    ! new 2013-02-06: support turning messages On (for 1st evalutaion)
    !                                     and Off (for 2nd evalutaion)
    If ( pakoMessageOn .And. iPstdio.Le.iPriority ) Then
       !
       !  new 2012-02-07, using general SIC scheme:
       !
       If      (iSeverity.Eq.1) Then
          Call pako_message(seve%i,package,messageTextOut(1:nl)) 
       Else If (iSeverity.Eq.2) Then
          Call pako_message(seve%w,package,messageTextOut(1:nl)) 
       Else If (iSeverity.Eq.3) Then
          Call pako_message(seve%e,package,messageTextOut(1:nl)) 
       Else If (iSeverity.Eq.4) Then
          Call pako_message(seve%f,package,messageTextOut(1:nl)) 
       End If
       !
    End If
    !
!!$    OLD, before v1.2
!!$    If (iPstdio.Le.iPriority) Then
!!$          Write (6,*)  "screen: -->",iPriority,sC(iS),package,messageTextOut(1:nl),"<--"
!!$       Write(6,100) sC(iS),package,messageTextOut(1:nl)
!!$    Endif
!!$    If (iPfile.Le.iPriority) Then
!!$          Write (6,*)  "file:   -->",iPriority,sC(iS),package,messageTextOut(1:nl),"<--"
!!$       Write(iUnit,101) iPriority,sC(iS),package,messageTextOut(1:nl)
!!$    Endif
!!$    !
!!$100 Format(a,'-',a,',  ',a)
!!$101 Format(i2,'-',a,'-',a,',  ',a)
    !
    !D     Call pako_message(seve%t,programName,                                        &
    !D          &  " module Messages,                     <-- SR: pakoMessage ")        ! trace execution    
    !
    Return
  End Subroutine pakoMessage
!!!
!!!
  Subroutine pakoMessage_level(setPstdio,setPfile)
    !
    !   set minimum "level" for messages to write to std I/O and file
    !
    Integer, Intent(in)           :: setPstdio ! set minumum priority for std. I/O
    Integer, Intent(in), Optional :: setPfile  ! set minimum priority for file
    !
    Integer :: iP
    !
!D    Write (6,*) '   --> message_level: '
    !
    iP = Min(Max(setPstdio,0),9)
    iPstdio = iP
    !
    If (Present(setPfile)) iPfile = setPfile
    !
!D    Write (6,*) '       iPstdio: ', iPstdio
!D    Write (6,*) '       iPfile:  ', iPfile
    !
  End Subroutine pakoMessage_level
!!!
!!!
  Subroutine pakoMessage_init(messageFile,iniPstdo,iniPfile)
    !
    ! OBSOLETE (?) with v1.2.0 2012-02-07
    !
    ! open file for messages
    !
    Character(len=*)   :: messageFile  !  name of message file
    Integer            :: iniPstdo     !  init minumum priority for std. I/O
    Integer            :: iniPfile     !  init minimum priority for file
    !
    Integer            :: sic_getlun
    !
    Character(len=256) :: messageFileOLD
    Integer            :: ier
    Integer            :: rename
    !
    Write (6,*)                                                                  &
         &    " module messages, 1.2.4 2015-05-25 ---> SR: pakoMessage_init "    ! trace execution
    Write (6,*)                                                                  &
         &    " --> messageFile: ->"//messageFile(1:Len_trim(messageFile))//"<-" !
    !
!!$    Call pako_message(seve%t,programName,                                        &
!!$         &    " module messages, 1.2.4 2015-05-25 ---> SR: pakoMessage_init ")   ! trace execution
!!$    Call pako_message(seve%d,programName,                                        &
!!$         &    " --> messageFile: ->"//messageFile(1:Len_trim(messageFile))//"<-")!
    !
    !!    Call sic_lower(messageFile)                                            ! !! 2014-05-14   
    !!                                                                           ! !! patch from pako on lenny
    !
    messageFileOLD = messageFile(1:Len_trim(messageFile))//"~"
    !
    ier = Rename(messageFile, messageFileOLD)
    If (ier.Eq.0) Then
!!OLD       Write (6,*)  &
!!OLD            &           'I-message, renamed previous message file: "',  &
!!OLD            &           messageFile(1:Len_trim(messageFile)), &
!!OLD            &           '"'
!!OLD       Write (6,*)  &
!!OLD            &           'I-message, to: "',  &
!!OLD            &           messageFileOLD(1:Len_trim(messageFileOLD)), &
!!OLD            &           '"'
    End If
    !
    ier = sic_getlun(iUnit)
!
!D      Write (6,*) "         unit: iunit = ", iunit
!D      Write (6,*) "         unit: ier =   ", ier
!
    If (ier.Eq.1) Then
       Open (unit=iUnit, file=messageFile,  recl=lenLine, & 
            &           status='unknown')
!D       Write (6,*) 'I-message, opened  message file "', messageFile(1:Len_trim(messageFile)), '"'
    Else
       Write (6,*) 'F-message, error opening message file "', messageFile(1:Len_trim(messageFile)), '"'
    End If
    !
    iPfile  = iniPfile
    iPstdio = iniPstdo
    !
  End Subroutine pakoMessage_init
!!!
!!!
  Subroutine pakoMessageSwitch (setOn, setOff, queryOn)
    !
    Logical, Intent(in),  optional           :: setOn    !  switch pako messages ON
    Logical, Intent(in),  optional           :: setOff   !  switch pako messages OFF
    Logical, Intent(out), optional           :: queryOn  !  query if ON
    !
    pakoMessageOn   =  .True.
    pakoMessageOff  =  .False.
!    return
    !
    !D     Write (6,*) "    --> pakoMessageSwitch "
    !
    If (Present(setOff)) Then
       if (setOff) then
          !D        Write (6,*) "         setOff: ", setOff
          pakoMessageOn   =  .False.
          pakoMessageOff  =  .True.
       end if
    End If
    If (Present(setOn)) Then
       if (setOn) then
          !D        Write (6,*) "         setOn:  ", setOn
          pakoMessageOn   =  .True.
          pakoMessageOff  =  .False.
       End If
    End If
    !
    If (Present(queryOn)) Then
       queryOn = pakoMessageOn
    End If
    !
    !D     Write (6,*) "    <-- pakoMessageSwitch "
    !D     Write (6,*) "       pakoMessageOn:  ", pakoMessageOn
    !D     Write (6,*) "       pakoMessageOff: ", pakoMessageOff
    !
    Return
    !
  End Subroutine pakoMessageSwitch
!!!
!!!
End Module modulePakoMessages

program uv_proper_motion
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! TASK  Apply specified proper motion to an input UV Table
  !
  ! input :
  ! a uv table
  ! output :
  ! a uv table
  !------------------------------------------------------------------------
  character(len=filename_length) :: input,output
  real(8) :: proper(2)
  logical error
  !
  ! Input parameters
  call gildas_open
  call gildas_char('UV_INPUT$',input)
  call gildas_char('UV_OUTPUT$', output)
  call gildas_dble('PROPER$',proper,2)
  call gildas_close
  call sub_uv_proper_motion (input, output, proper, error)
  if (error) call sysexi(fatale)
end program uv_proper_motion
!
subroutine sub_uv_proper_motion (cuvin, cuvou, proper, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !      Apply specified proper motion to an input UV Table
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin
  character(len=*), intent(in) :: cuvou
  real(8), intent(in) :: proper(2)
  logical, intent(out) :: error
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_PROPER_MOTION'
  character(len=80)  :: mess
  type (gildas) :: uvin
  type (gildas) :: uvou
  integer :: ier, nblock, ib, nvisi
  !
  ! Simple checks
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  uvou%gil%astr_words = def_astr_words ! 3
  uvou%gil%mura = proper(1)
  uvou%gil%mudec = proper(2)
  uvou%gil%parallax = 0.0
  !
  ! create the image
  call gdf_create_image(uvou,error)
  if (error) return
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  uvin%blc = 0
  uvin%trc = 0
  uvou%blc = 0
  uvou%trc = 0
  do ib = 1,uvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
    call map_message(seve%i,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    !
    ! Here do the job
    !
    nvisi = uvou%trc(2)-uvou%blc(2)+1
    !
    ! Note that we use UVIN to have the old proper motion...
    call proper_motion (proper,uvin,nvisi,uvin%r2d)
    !
    call gdf_write_data (uvou,uvin%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_close_image(uvin,error)
  call gdf_close_image(uvou,error)
  if (error) return
  !
  call map_message(seve%i,rname,'Successful completion')
  return
end subroutine sub_uv_proper_motion
!
subroutine proper_motion (mu,huv,nvisi,visi)
  use gkernel_interfaces
  use image_def
  real(8), intent(in) :: mu(2)
  type (gildas), intent(in) :: huv
  integer, intent(in) :: nvisi
  real(4), intent(inout) :: visi(huv%gil%dim(1),nvisi)
  !
  integer j2000
  real(8) :: dzero,murad(2),pos(2),freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  character(len=11) date
  integer :: i, ix, iu, iv, id
  real(4) :: reel, imag
  real(8) :: uu, vv, phi, sphi, cphi, d, dyear
  logical :: error, uv8
  !
  ! Subtract existing proper motion
  murad(1) = mu(1)-huv%gil%mura
  murad(2) = mu(2)-huv%gil%mudec
  !
  ! Get proper motion in Rad/year
  murad = murad*1d-3*pi/180D0/3600d0 ! Radians / year
  !
  ! Get J2000 in CLASS date
  !
  date = '01-JAN-2000'
  call gag_fromdate(date,j2000,error)
  !
  ! Use the Equinox of the coordinates
  dzero = dble(huv%gil%epoc)-2000.0d0
  !
  ! Get observing frequency
  freq = gdf_uv_frequency(huv)
  !
  uv8 = huv%gil%column_size(code_uvt_u).ne.1
  !
  iu = huv%gil%column_pointer(code_uvt_u)
  iv = huv%gil%column_pointer(code_uvt_v)
  id = huv%gil%column_pointer(code_uvt_date)
  if (uv8) print *,'UV8 ',uv8,iu,iv,id
  !
  do i = 1,nvisi
    if (uv8) then
      call r4tor4 (visi(iu,i),uu,2)   ! Avoid r8tor8 for alignment problems
      call r4tor4 (visi(iv,i),vv,2)
    else
      uu = visi(iu,i)                 ! Implicit Real(4) -> Real(8) conversion
      vv = visi(iv,i)
    endif
    !
    ! Get date in CLASS Days
    d = visi(id,i)
    ! Get time increment in years
    dyear = (d-j2000)/365.25d0 - dzero
    ! Position at this date
    pos = murad*dyear
    !!print *,i,d,j2000,dyear,pos
    !
    ! compute new phase center in wavelengths
    pos = - freq * f_to_k * pos
    phi = pos(1)*uu + pos(2)*vv
    cphi = cos(phi)
    sphi = sin(phi)
    do ix = huv%gil%fcol, huv%gil%lcol, huv%gil%natom
      reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
      imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
      visi(ix,i) = reel
      visi(ix+1,i) = imag
    enddo
  enddo
end subroutine proper_motion

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***JP: The cubeset_plot_tool module should probably be moved into a
!***JP: specific core/plot library that deals with the interface with
!***JP: outside plotting libraries.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_plot_tool
  use cubetools_parameters
  use cubeset_messaging
  !
  public :: pane_k
  public :: code_x,code_y
  public :: plot
  private 
  !
  integer(kind=4), parameter :: pane_k = 4
  !-------------------------------------------------------------------
  integer(kind=code_k), parameter :: code_x = 1
  integer(kind=code_k), parameter :: code_y = 2
  !-------------------------------------------------------------------
  !
  type plot_prog_t
   contains
     procedure, public :: togreg               => cubeset_plot_prog_togreg !***JP: Temporarily put it public
     procedure, public :: get_pagesize         => cubeset_plot_prog_get_pagesize
     procedure, public :: put_image_into_rg    => cubeset_plot_prog_put_image_into_rg
     procedure, public :: put_spectrum_into_xy => cubeset_plot_prog_put_spectrum_into_xy
     procedure, public :: box                  => cubeset_plot_prog_box
     procedure, public :: viewport             => cubeset_plot_prog_set_viewport
  end type plot_prog_t
  type(plot_prog_t) :: plot
  !
contains
  !
  subroutine cubeset_plot_prog_togreg(prog,commline,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Spawn a GREG command and return the error status
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    character(len=*),   intent(in)    :: commline
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PLOT>PROG>TOGREG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call gr_exec(commline)
    error = gr_error()
    if (error) then
       call cubeset_message(seve%e,rname,'Error when spawning the GREG command:')
       call cubeset_message(seve%e,rname,commline)
       return
    endif
  end subroutine cubeset_plot_prog_togreg
  !
  subroutine cubeset_plot_prog_get_pagesize(prog,size)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Get page geometry from GREG
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)  :: prog
    real(kind=pane_k),  intent(out) :: size(2)
    !
    character(len=*), parameter :: rname='PLOT>PROG>GET>PAGESIZE'
    ! 
    call gr_get_physical(size(code_x),size(code_y))
  end subroutine cubeset_plot_prog_get_pagesize
  !
  subroutine cubeset_plot_prog_put_image_into_rg(prog,head,data,error)
    use gkernel_interfaces
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_header_types
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(plot_prog_t),  intent(in)    :: prog
    type(cube_header_t), intent(in)    :: head
    real(kind=sign_k),   intent(in)    :: data(:,:)
    logical,             intent(inout) :: error
    !
    logical :: iswcs 
    integer(kind=4) :: nx,ny ! Here nx and ny are int*4 because of the interfaces with gkernel
    real(kind=coor_k) :: conv(6),proj(3)
    type(axis_t) :: axis
    character(len=*), parameter :: rname='PLOT>PROG>PUT>IMAGE>INTO>RG'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    ! Give data to RG
    call cubetools_header_get_axis_head_l(head,axis,error)
    if (error) return
    iswcs = axis%kind.eq.code_unit_fov
    nx = axis%n
    conv(1:3) = axis%conv
    call cubetools_header_get_axis_head_m(head,axis,error)
    if (error) return    
    iswcs = iswcs.and.(axis%kind.eq.code_unit_fov)
    ny = axis%n
    conv(4:6) = axis%conv
    call gr4_tgive(nx,ny,conv,data)
    !
    ! Define blanking, since now we use NaNs bval=0 and eval=-1
    call gr8_blanking(0.d0,-1.d0)
    !
    if (iswcs) then
       ! Pass coordinate System
       call gr8_system(head%spa%fra%code,error,head%spa%fra%equinox)
       ! Pass projection
       proj(1) = head%spa%pro%l0
       proj(2) = head%spa%pro%m0
       proj(3) = head%spa%pro%pa
       call greg_projec(head%spa%pro%code,proj)
    else
       continue
    endif
  end subroutine cubeset_plot_prog_put_image_into_rg
  !
  subroutine cubeset_plot_prog_put_spectrum_into_xy(prog,head,data,error)
    use cubetools_header_types
    use cubetools_header_methods
    use cubetools_axis_types
    use cubetools_userspace
    use cubetools_uservar
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(plot_prog_t),  intent(in)    :: prog
    type(cube_header_t), intent(in)    :: head
    real(kind=sign_k),   intent(in)    :: data(:)
    logical,             intent(inout) :: error
    !
    type(axis_t) :: caxis
    type(uservar_t) :: xbuff,ybuff
    logical, parameter :: global = .true.
    logical, parameter :: overwrite = .true.
    character(len=*), parameter :: rname='PLOT>PROG>PUT>SPECTRUM>INTO>XY'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_header_get_axis_head_c(head,caxis,error)
    if (error) return
    call xbuff%create('x',global,overwrite_prog,error)
    if (error) return
    call ybuff%create('y',global,overwrite_prog,error)
    if (error) return
    !
    call xbuff%set(caxis%coord,error)
    if (error) return
    call ybuff%set(data,error)
    if (error) return    
  end subroutine cubeset_plot_prog_put_spectrum_into_xy
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeset_plot_prog_box(prog,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='PLOT>PROG>BOX'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call plot%togreg('box n n n',error)
    if (error) return
  end subroutine cubeset_plot_prog_box
  !
  subroutine cubeset_plot_prog_set_viewport(prog,min,max,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(plot_prog_t), intent(in)    :: prog
    real(kind=pane_k),  intent(in)    :: min(2)
    real(kind=pane_k),  intent(in)    :: max(2)
    logical,            intent(inout) :: error
    !
    character(len=clin_l) :: commline
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='PLOT>PROG>SET>VIEWPORT'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    if (any(min.lt.0.0).or.any(max.gt.1.0)) then
       write(mess,'(a,4f5.1)') 'Desired viewport is set beyond bounds: ',&
            min(code_x),max(code_x),min(code_y),max(code_y)
       call cubeset_message(seve%e,rname,mess)
       call cubeset_message(seve%e,rname,'Limits are: 0.0 1.0 0.0 1.0')
       error = .true.
       return
    endif
    write(commline,'(A,4(1X,1PG14.7))')&
         'SET VIEWPORT',&
         min(code_x),max(code_x),&
         min(code_y),max(code_y)
    call plot%togreg(commline,error)
    if (error) return
  end subroutine cubeset_plot_prog_set_viewport
end module cubeset_plot_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeset_plot_page_tool
  use cubetools_parameters
  use cubeset_messaging
  use cubeset_plot_tool
  !
  public :: plot_page_geometry_user_t
  private
  !
  integer(kind=code_k), parameter :: code_page_landscape = 1
  integer(kind=code_k), parameter :: code_page_portrait  = 2
  !
  type plot_page_geometry_user_t
     integer(kind=code_k), public :: geo = code_page_landscape ! By default page is in landscape
     real(kind=pane_k),    public :: size(2) = 0.0             !
     real(kind=pane_k),    public :: aspect = 0.0              ! 
   contains
     procedure, public :: get_geometry => cubeset_plot_page_user_get_geometry
  end type plot_page_geometry_user_t
  !
contains
  !
  subroutine cubeset_plot_page_user_get_geometry(user,error)
    !-------------------------------------------------------------------
    ! Get page geometry
    !-------------------------------------------------------------------
    class(plot_page_geometry_user_t), intent(inout) :: user
    logical,                          intent(inout) :: error
    !
    character(len=mess_l) :: mess
    real(kind=pane_k), parameter :: ga4landscape = 1.42857146  ! GILDAS A4 landscape
    real(kind=pane_k), parameter :: ga4portrait  = 0.699999988 ! GILDAS A4 portrait
    character(len=*),  parameter :: rname='PLOT>PAGE>USER>GET>GEOMETRY'
    !
    call plot%get_pagesize(user%size)
    !
    user%aspect = user%size(code_x)/user%size(code_y)
    if (user%aspect.le.0) then
       call cubeset_message(seve%e,rname,' Page Aspect is zero or negative')
       error = .true.
       return
    else if (user%aspect.ge.1) then
       ! This case includes the square case
       user%geo = code_page_landscape
    else if (user%aspect.lt.1) then
       user%geo = code_page_portrait
    else ! user%aspect .eq. NAN +-inf
       write(mess,'(a,f8.3,a,f8.3)') 'Nonsense page size: ',user%size(code_x),'x',user%size(code_y)
       call cubeset_message(seve%e,rname,mess)
       error = .true.
       return
    endif
    !
    if (user%aspect.ne.ga4landscape.and.user%aspect.ne.ga4portrait) then
       write(mess,'(a,f8.3,a,f8.3,a)') 'Page size: ',user%size(code_x),'x',user%size(code_y),&
            ' is not 21x30 or 30x21, plots may set out of bounds'
       call cubeset_message(seve%w,rname,mess)
    endif
  end subroutine cubeset_plot_page_user_get_geometry  
end module cubeset_plot_page_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_minmax_r4_1d(rmin,rmax,a,na,rbad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values and NaN
  ! ---
  ! R*4 1D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin   ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax   ! Max value plus upper margin
  integer(kind=4), intent(in)  :: na     ! Number of values
  real(kind=4),    intent(in)  :: a(na)  ! Input array
  real(kind=4),    intent(in)  :: rbad   ! Bad channel value
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  real(kind=4) :: adiff
  integer(kind=4) :: j,jstart
  real(kind=4), parameter :: margin=0.05
  !
  rmin = 1.
  rmax = -1.
  !
  if (na.ge.1) then
    do j = 1,na
      if (a(j).eq.a(j) .and. a(j).ne.rbad) then
        rmin = a(j)
        rmax = a(j)
        exit
      endif
    enddo
    !
    jstart = j+1
    do j = jstart,na
      if (a(j).eq.a(j) .and. a(j).ne.rbad) then
        rmin = min(rmin,a(j))
        rmax = max(rmax,a(j))
      endif
    enddo
  endif
  !
  if (rmin.gt.rmax) then
    call class_message(seve%w,rname,  &
      'No valid data found in the current X range (SET MODE X). Min-Max set to 0.')
    rmin = 0.
    rmax = 0.
  endif
  !
  adiff = rmax - rmin
  if (adiff.eq.0.) adiff = max(abs(rmin),0.1)
  rmin = rmin - margin*adiff
  rmax = rmax + margin*adiff
  !
end subroutine class_minmax_r4_1d
!
subroutine class_minmax_i4_1d(rmin,rmax,a,na,ibad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values
  ! ---
  ! I*4 1D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin   ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax   ! Max value plus upper margin
  integer(kind=4), intent(in)  :: na     ! Number of values
  integer(kind=4), intent(in)  :: a(na)  ! Input array
  integer(kind=4), intent(in)  :: ibad   ! Bad channel value
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=4) :: j,jstart,imin,imax,adiff
  real(kind=4), parameter :: margin=0.05
  !
  imin = 1
  imax = -1
  !
  if (na.ge.1) then
    do j = 1,na
      if (a(j).ne.ibad) then
        imin = a(j)
        imax = a(j)
        exit
      endif
    enddo
    !
    jstart = j+1
    do j = jstart,na
      if (a(j).ne.ibad) then
        imin = min(imin,a(j))
        imax = max(imax,a(j))
      endif
    enddo
  endif
  !
  if (imin.gt.imax) then
    call class_message(seve%w,rname,  &
      'No valid data found in the current X range (SET MODE X). Min-Max set to 0')
    imin = 0
    imax = 0
  endif
  !
  adiff = imax - imin
  if (adiff.eq.0) adiff = max(abs(imin),1)
  rmin = imin - margin*adiff
  rmax = imax + margin*adiff
  !
end subroutine class_minmax_i4_1d
!
subroutine class_minmax_r4_2d(rmin,rmax,a,n1,n2,rbad)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-generic class_minmax
  ! Compute MIN and MAX from a (section of) given array taking into
  ! account blanking values and NaN
  ! ---
  ! R*4 2D version
  !---------------------------------------------------------------------
  real(kind=4),    intent(out) :: rmin      ! Min value plus lower margin
  real(kind=4),    intent(out) :: rmax      ! Max value plus upper margin
  integer(kind=4), intent(in)  :: n1,n2     ! Number of values
  real(kind=4),    intent(in)  :: a(n1,n2)  ! Input array
  real(kind=4),    intent(in)  :: rbad      ! Bad channel value
  !
  call class_minmax_r4_1d(rmin,rmax,a,n1*n2,rbad)
  !
end subroutine class_minmax_r4_2d

subroutine read_data (line,comm,error)
  use gkernel_interfaces
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  real*8 :: ftie(nmax)            ! Work array for time
  integer :: iscan(nmax)          ! Work array for scan numbers
  integer :: icode(nmax)          ! Work array for code (1 Az - 0 El)
  real*8 :: frms(nmax)
  character(len=12) :: sou(nmax)       ! Work array for sources
  integer :: i1,l1,l,n,ier,jant
  character(len=4) :: stat
  real*8 :: pi,fac,sfac,rts
  logical :: refrac, no_data, no_file
  parameter (pi=3.14159265358979323846d0)
  data no_data /.true./, no_file /.true./
  !
  if (.not.sic_varexist('nodata')) then
     call sic_def_logi ('nodata',no_data,.true.,error) 
     call sic_def_logi ('nofile',no_file,.true.,error)
  endif
  sfac = pi/180d0/3600d0
  fac  = 180d0/pi
  rts  = 1.d0/sfac
  !
  fitted = .false.
  call sic_i4 (line,0,1,jant,.true.,error)
  if (error) return
  !
  ier = sic_open (2,cfile,'OLD',.true.)
  if (ier.ne.0) then
   n = min (lenc(cfile),50)
    write(6,*) 'E-READ_DATA,  Error opening file '//cfile(1:n)
    call putios ('E-READ_DATA,  ',ier)
    goto 99
  endif
  no_file = .false.
  !
  if (ctype.eq.'O') then
    call rdata_op(azis,eles,eraz,erel,tiem,ndata,valpre,   &
     &      jant,stat,refrac)
    call set_optical (refrac)
    npt = 2*ndata
    i1 = ndata
    do l=1,ndata
      x(1,l)=azis(l)/fac
      x(2,l)=eles(l)/fac
      x(3,l)=0.
      i1=i1+1
      x(1,i1)=azis(l)/fac
      x(2,i1)=eles(l)/fac
      x(3,i1)=1.
      fobs(l)=eraz(l)*sfac
      fobs(i1)=erel(l)*sfac
      scan(l)=l
      scan(i1)=l
      source(l) = ' '
      source(i1) = ' '
      rms(l) = 0.0
      rms(i1) = 0.0
      azis(i1) = azis(l)
      eles(i1) = eles(l)
      tiem(i1) = tiem(l)
    enddo
  elseif (ctype.eq.'R' .or. ctype.eq.'I') then
    if (ctype.eq.'R') then
      call rdata_ra (azis,eles,eraz,erel,ftie,ndata,valpre,   &
     &        icode,iscan,jant,stat,sou,frms)
    else
      call rdata_in (azis,eles,eraz,erel,ftie,ndata,valpre,   &
     &        icode,iscan,jant,stat,sou,frms)
    endif
    ndata=ndata/2
    npt = 2*ndata
    call set_radio(jant)
    i1=ndata
    l1=0
    do l=1,npt
      if (icode(l).eq.1) then
        l1=l1+1
        x(1,l1)=azis(l)/fac    !radian
        x(2,l1)=eles(l)/fac    !radian
        fobs(l1)=eraz(l)*sfac  !radian
        tiem(l1)=ftie(l)
        x(3,l1)=0.
        scan(l1) = iscan(l)
        source(l1) = sou(l)
        rms(l1) = frms(l)
      else
        i1=i1+1
        x(1,i1)=azis(l)/fac
        x(2,i1)=eles(l)/fac
        x(3,i1)=1.
        fobs(i1)=erel(l)*sfac
        scan(i1)=iscan(l)
        tiem(i1)=ftie(l)
        source(i1) = sou(l)
        rms(i1) = frms(l)
      endif
    enddo
    !
    ! Reorder AZ and EL values
    do l=1,npt
      azis(l) = x(1,l)*fac
      eles(l) = x(2,l)*fac
    enddo
  endif
  do l=1,npt
    badre(l) = .false.
    badus(l) = .false.
    badti(l) = .false.
  enddo
  call flag_el(npt,elmin,elmax)
  call flag_rm(npt,rmsmax)
  close (unit=2)
  no_data = .false.
  if (ndata.eq.0) then
    write (6,*) 'E-READ,  No data in file'
    no_data = .true.
    return
  endif
  call get_good (npt,kp)
  if (jant.lt.10) then
     write (stat_ant,'(a,i1,a)') 'A',jant,' on '//stat
  else
     write (stat_ant,'(a,i2,a)') 'A',jant,' on '//stat
  endif
  return
  99    close (unit=2)
  no_file = .true.
end

module gchar_interfaces_private
  interface
    subroutine vsconv(ficode,sycode)
      use gchar_variables
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: ficode        !
      character(len=*) :: sycode        !
    end subroutine vsconv
  end interface
  !
  interface
    subroutine gchar_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gchar_message
  end interface
  !
  interface
    subroutine gsymxd(number,xygrid,nstrok,unused)
      !---------------------------------------------------------------------
      ! @ private
      ! GRPCKG (internal routine):
      !	Return the digitization coordinates of a character. Each
      !	character is built up on a grid with X and Y coordinates
      !	in the range (-49,49), with the origin (0,0) at the center
      !	of the character.  The coordinate system is right-handed,
      !	with X positive to the right, and Y positive upward.
      !	Characters are drawn with their tops upward, towards
      !	positive Y values.
      !
      ! Arguments:
      ! 	NUMBER 	I	symbol number in range (1..3000).	Input
      ! 	XYGRID 	L*1(*)	Height range, width range, and pairs	Output
      !			of (X,Y) coordinates returned.
      !			Height range = (XYGRID(1),XYGRID(3)).
      !			Width range = (XYGRID(4),XYGRID(5)).
      !			(X,Y) = (XYGRID(K),XYGRID(K+1)) (K=6,8,...).
      !	NSTROK	I	Number of strokes			Output
      ! 	UNUSED	L	Set to .TRUE. if NUMBER is an unused 	Output
      !			symbol number. A character of normal
      !			height and zero width is returned.
      !			Set to .FALSE. if NUMBER is a valid
      !			symbol number.
      !
      !	The height range consists of 3 values: (minimum Y, baseline
      !	Y, maximum Y).  The first is reached by descenders on
      !	lower-case g, p, q, and y.  The second is the bottom of
      !	upper-case letters.  The third is the top of upper-case
      !	letters.  A coordinate pair (-64,0) requests a pen raise,
      !	and a pair (-64,-64) terminates the coordinate list.  It is
      !	assumed that movement to the first coordinate position will
      !	be done with the pen raised - no raise command is
      !	explicitly included to do this.
      !
      ! (7-Mar-1983)
      !---------------------------------------------------------------------
      integer :: number                 !
      integer(kind=1) :: xygrid(400)    !
      integer :: nstrok                 !
      logical :: unused                 !
    end subroutine gsymxd
  end interface
  !
  interface
    subroutine bldfil
      !---------------------------------------------------------------------
      ! @ private
      !  (build HERSHEY font file)
      !  This program converts the character digitizations on the
      !  distribution HERSHEY font file to a series of records on a
      !  fortran unformatted (binary) file in which coordinate pairs
      !  have been packed into single integers to reduce the space
      !  requirements.  The font file contains the character
      !  digitizations in record groups, as follows:
      !
      !  first: NC,LENGTH,(XYGRID(I),I=1,5)
      !  remaining: (XYGRID(I),I=6,LENGTH)
      !
      !  the format for each record is (7(2X,2I4)).  NC is the
      !  HERSHEY character number, which at present consists of one of
      !  1611 integers in the range (1..NCLAST), with NCLAST = 4000.
      !  these character numbers must never be altered, since
      !  the entire set of routines which handle the hershey fonts
      !  use them. The first five entries in XYGRID(*) are the
      !  character extents:
      !
      !  XYGRID(1) = minimum Y value.
      !  XYGRID(2) = baseline Y value.
      !  XYGRID(3) = maximum Y value.
      !  XYGRID(4) = minimum X value.
      !  XYGRID(5) = maximum X value.
      !
      !  the minimum and maximum values do not necessarily
      !  correspond to the actual (X,Y) coordinates in the remainder
      !  of XYGRID(*), but specify the box in which characters are
      !  drawn.  The center of each character grid is at (0,0), and
      !  actual coordinates lie in the range (-49..+49).  a
      !  coordinate pair (-64,0) is a request to raise the pen
      !  before moving to the next point, and a pair (-64,-64)
      !  signals end-of-data for the current character.
      !
      !  By biasing each coordinate by +64, the coordinate range
      !  becomes (0..113), which can be represented by 7 bits.  Thus
      !  an (x,y) pair can be packed into 14 data bits.  The
      !  distribution version of <PLOT79> packs only one pair per
      !  integer word, so that the system can be installed without
      !  change on any machine with 16 or more bits/integer.  Later
      !  on, it may be desirable to increase the number of
      !  coordinate pairs stored in a single word.  On machines
      !  which permit this, it may be most convenient to define the
      !  data arrays as integer*2 or integer*3, rather than to
      !  revise the packing algorithm.
      !
      !  The entire set of fonts contains at present 105,557
      !  individual coordinate values, to which space for pointers
      !  to individual characters must be added.  If the coordinates
      !  are packed as (X,Y) pairs in 16-bit integers, then about
      !  57,000 16-bit integers are required for the coordinates and
      !  pointers. Since this is an excessive amount of storage on
      !  many machines, the character data is subdivided into
      !  smaller sections and stored as fortran unformatted (binary)
      !  records. Each such record contains the data list
      !
      !  NC1,NC2,NC3,INDEX,BUFFER
      !
      !  the data items in the record are
      !
      !  NC1......... starting character number in buffer.
      !  NC2......... last character number in buffer.
      !  NC3......... starting character number in next buffer, if there
      !               would be one.
      !  INDEX(*).... index array, locating the start of data
      !               for character K (assumed in range NC1..NC2) at
      !               BUFFER(INDEX(K+1-NC1)).
      !  BUFFER(*)... array for packed coordinates.
      !
      !  The actual size of BUFFER(*) and INDEX(*) may be adjusted
      !  to an installation's requirements, and the code in
      !  subroutine SYMXD must be appropriately modified to reflect
      !  any change in the size of these arrays.
      !
      !  This version of BLDFIL omits the indexical, triplex, and
      !  gothic fonts (Hershey numbers 1000-1999, 3000-3999). A
      !  buffer size of 27000 words and an index size of 3000 are
      !  adequate.
      !
      ! (09-aug-80)
      !---------------------------------------------------------------------
    end subroutine bldfil
  end interface
  !
  interface
    subroutine wwrite(iunit,array,block)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: iunit                  !
      integer :: array(128)             !
      integer :: block                  !
    end subroutine wwrite
  end interface
  !
  interface
    subroutine coresp(i)
      use gchar_variables
      !---------------------------------------------------------------------
      ! @ private
      ! CHAR
      !	Create the correspondance table between Hershey and Greg fonts
      !---------------------------------------------------------------------
      integer :: i(nkchar)              !
    end subroutine coresp
  end interface
  !
end module gchar_interfaces_private

subroutine solve(line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: niter,num,l,naz,nel,i
  character(len=2) :: arg
  real*8 :: eps, funpnl, sigm
  logical :: bavard
  real*8 :: pi,fac,sfac,rts
  parameter (pi=3.14159265358979323846d0)
  !
  sfac = pi/180d0/3600d0
  fac  = 180d0/pi
  rts  = 1.d0/sfac
  !
  bavard = sic_present(0,1)
  eps = 1d-2
  niter=15
  !
  call get_good (npt,kp)
  arg = ' '
  call sic_ke (line,0,1,arg,i,.false.,error)
  if (error) return
  if (arg.eq.'EL') then
    do i=1,ndata
      if (good(i)) then
        good(i) = .false.
        kp = kp-1
      endif
    enddo
  elseif (arg.eq.'AZ') then
    do i=ndata,npt
      if (good(i)) then
        good(i) = .false.
        kp = kp-1
      endif
    enddo
  endif
  write(6,'(A,I4,A,I4)') ' I-POINTING, ',kp,   &
     &    ' good points among ',npt
  if (kp.le.npf) then
    write(6,*) 'E-POINTING,  Not enough data points'
    error = .true.
    return
  endif
  !
  sigco(3) = sigco(3)*cos(coef(3))
  coef(3)  = sin(coef(3))
  valpre(3)= sin(valpre(3))
  if (npf.ne.0) then
    write(6,*) 'I-POINTING,  Calling FITPNL'
    call fitpnl(x,fobs,npt,npf,ipar,coef,niter,num,ffit,   &
     &      sigm,sigco,eps,bavard,good)
    sigma = sigm
  else
    write(6,*) 'I-POINTING,  No variable parameter'
  endif
  !
  do l=1,npt
    ffit(l)=funpnl(x(1,l),coef)
    resd(l)=fobs(l)-ffit(l)
  enddo
  !
  sigma_az = 0
  sigma_el = 0
  naz = 0
  nel = 0
  do l=1,ndata
    fitaz(l)=ffit(l)*rts
    resaz(l)=resd(l)*rts
    fitel(l)=ffit(ndata+l)*rts
    resel(l)=resd(ndata+l)*rts
    if (good(l)) then
      naz = naz+1
      sigma_az = sigma_az+resaz(l)**2
    endif
    if (good(ndata+l)) then
      sigma_el = sigma_el+resel(l)**2
      nel = nel+1
    endif
  enddo
  sigma = sigma_az+sigma_el
  sigma = sqrt(2.0*sigma/max(1,(naz+nel-npf)))
  sigma_az = sqrt(sigma_az/max(1,(naz-npf)))
  sigma_el = sqrt(sigma_el/max(1,(nel-npf)))
  write(6,'(1X,A,F8.2,A,F8.2,A,F8.2,A)')   &
     &    'I-POINTING,  Sigma ',sigma,'  ( Azimuth',sigma_az   &
     &    ,'  Elevation',sigma_el,' ) '
  fitted = .true.
  coef(3)  = asin(coef(3))
  sigco(3) = sigco(3)/cos(coef(3))
  valpre(3)= asin(valpre(3))
end
!<FF>
subroutine print (line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  integer :: lenc,sic_open
  logical :: sic_present
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  integer :: lun,l,kk,i
  character(len=80) :: ofile,name
  real*8 :: pi,fac,sfac,rts
  parameter (pi=3.14159265358979323846d0)
  character(len=42) :: par30m(mvar)
  integer :: signe(mvar),ier
  !
  data par30m/   &
     &    'P1      Zero azimuth (-IAZ or NULA)',   &
     &    'P7      Zero elevation (-IEL-COV or NULE)',   &
     &    'P2      Azimuth collimation (-COH or COL*)',   &
     &    'P4      East Inclination (-MVE)',   &
     &    'P5      North Inclination (MVN)',   &
     &    'P3      Non perpendicularity (NPE)',   &
     &    'REF1    1st order refraction',   &
     &    'REF2    2nd order refraction',   &
     &    'ELES    grav.+exc. coder ele. (sin)',   &
     &    'ELEC    grav.+exc. coder ele. (cos)',   &
     &    'AZES    excen. coder az. (sin)',   &
     &    'AZEC    excen. coder az. (cos)',   &
     &    'incl. coder az. (sin)',   &
     &    'incl. coder az. (cos)',   &
     &    'incl. coder ele. (sin)',   &
     &    'incl. coder ele. (cos)'/
  data signe/-1,-1,-1,-1,1,1,4*1,1,1,4*1/
  !
  if (.not.fitted) then
    write(6,*) 'E-PRINT,  No fit done'
    error = .true.
    return
  endif
  sfac = pi/180d0/3600d0
  fac  = 180d0/pi
  rts  = 1.d0/sfac
  !
  lun = 6
  if (sic_present(1,0)) then
    call sic_ch (line,1,1,ofile,i,.true.,error)
    if (error) return
    lun = 1
    name = ofile
    call sic_parsef(name,ofile,' ','.result')
    ier = sic_open (lun,ofile,'NEW',.false.)
  endif
  !
  if (sic_present(2,0)) then
    write(lun,100)
    do l=1,kvar
      if (free(l)) then
        write(lun,101) l,valpre(l)/sfac,nompar(l)
      else
        write(lun,102) l,valpre(l)/sfac,coef(l)/sfac,nompar(l)
      endif
    enddo
    write(lun,'(/)')
  endif
  write(lun,'(1X,A,A)') 'POINTING results for file ',   &
     &    cfile(1:lenc(cfile))
  write(lun,'(1X,A,A)') '   ',stat_ant
  write(lun,'(1X,A,I4,A,I4,A)') '  Number of points used ',kp,   &
     &    ', among ',npt,' data points'
  write(lun,103)   &
     &    '  Sigma ',sigma,'  ( Azimuth',sigma_az   &
     &    ,'  Elevation',sigma_el,' ) '
  !
  ! If no 30-m Format
  if (.not.sic_present(3,0)) then
    do l=1,npf
      kk=ipar(l)
      write(lun,104) kk,nompar(kk),coef(kk)/sfac,sigco(l)/sfac
    enddo
  else
    do l=1,npf
      kk=ipar(l)
      write(lun,104) kk,par30m(kk),signe(kk)*coef(kk)/sfac,   &
     &        sigco(l)/sfac
    enddo
  endif
  !
  if (lun.ne.6) close(unit=lun)
  !
  100   format(/,' Par.   Previous',23x,'Name')
  101   format(1x,i3,2x,f10.2,'   ** Variable **   ',3x,a,a)
  102   format(1x,i3,2x,f10.2,' Fixed at ',f10.2,3x,a,a)
  103   format(1x,a,f8.2,a,f8.2,a,f8.2,a,/)
  104   format(1x,i4,1x,a,1x,f12.2,' +/- ',f6.2)
end

module cubedag_history_buffer
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_node_class
  use cubedag_link_type
  use cubedag_history_types
  !---------------------------------------------------------------------
  ! Support module for the history buffer, and subroutines to interact
  ! with it
  !---------------------------------------------------------------------

  type(cubedag_history_list_t) :: hx  ! History index

  public :: hx

  public :: cubedag_history_get_object
  public :: cubedag_history_add_tohx
  public :: cubedag_history_list_hx
  public :: cubedag_history_entrynum_hx
  public :: cubedag_history_tostr
  public :: cubedag_history_removenode,cubedag_history_removecommand
  public :: cubedag_history_destroy
  private

contains

  subroutine cubedag_history_get_object(hid,hobj,error)
    !-------------------------------------------------------------------
    ! Given the history identifier, find the associated object in HX
    ! and return a pointer to it
    !-------------------------------------------------------------------
    integer(kind=iden_l),    intent(in)    :: hid
    type(cubedag_history_t), pointer       :: hobj
    logical,                 intent(inout) :: error
    !
    integer(kind=entr_k) :: ihist
    !
    ihist = hx%entrynum(hid,error)
    if (error)  return
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
  end subroutine cubedag_history_get_object

  subroutine cubedag_history_add_tohx(command,line,inputs,outputs,hid,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index. Return the associated
    ! history identifier.
    !-------------------------------------------------------------------
    character(len=*),     intent(in)    :: command
    character(len=*),     intent(in)    :: line
    type(cubedag_link_t), intent(in)    :: inputs
    type(cubedag_link_t), intent(in)    :: outputs
    integer(kind=entr_k), intent(out)   :: hid
    logical,              intent(inout) :: error
    !
    if (outputs%n.le.0) then
      ! The commands which do not create an output cube are not
      ! registered in history
      hid = 0
      return
    endif
    !
    call hx%add(command,line,inputs,outputs,hid,error)
    if (error)  return
  end subroutine cubedag_history_add_tohx

  subroutine cubedag_history_list_hx(error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call hx%liste(error)
    if (error)  return
  end subroutine cubedag_history_list_hx

  function cubedag_history_entrynum_hx(hid,error)
    !-------------------------------------------------------------------
    ! Return the entry number in in HX corresponding to entry ID
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: cubedag_history_entrynum_hx
    integer(kind=iden_l), intent(in)    :: hid
    logical,              intent(inout) :: error
    !
    cubedag_history_entrynum_hx = hx%entrynum(hid,error)
    if (error)  return
  end function cubedag_history_entrynum_hx

  subroutine cubedag_history_tostr(hid,str,error)
    !-------------------------------------------------------------------
    ! Translate the history identifier to the form "ID (NAME)" (e.g.
    ! "12 (NOISE)"
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid
    character(len=*),     intent(out)   :: str
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ni,nc
    integer(kind=entr_k) :: ient
    type(cubedag_history_t), pointer :: hist
    !
    if (hid.eq.code_history_notyetdefined) then
      str = '-- (NOT-YET-DEFINED)'
      return
    endif
    !
    ient = hx%entrynum(hid,error)
    if (error)  return
    hist => cubedag_history_ptr(hx%list(ient)%p,error)
    if (error)  return
    !
    write(str,'(I0)') hid
    if (ient.le.0) then
      ! Valid: root has no history
      return
    elseif (ient.le.hx%n) then
      ni = len_trim(str)
      nc = min(len_trim(hist%command),len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (',hist%command(1:nc),')'
    else
      ni = len_trim(str)
      nc = min(7,len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (','UNKNOWN',')'
    endif
    !
  end subroutine cubedag_history_tostr

  subroutine cubedag_history_removenode(id,error)
    use cubelist_types
    use cubedag_dag_buffer
    !-------------------------------------------------------------------
    ! Properly remove a DAG node from the history.
    ! This might leave some commands without inputs or without outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id  ! Node identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(list_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist
    type(cubedag_history_t), pointer :: hobj
    !
    ! Get the DAG node pointer
    call cubedag_dag_get_object(id,object,error)
    if (error)  return
    tot => object
    !
    ! Get the history node pointer
    ihist = object%node%history
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
    !
    ! Remove from command which created it
    call hobj%links%outputs%dissociate(tot,error)
    if (error)  return
    !
    ! Remove from commands which used it as input. As of today, there
    ! is no backpointer to these commands (is this really desired?).
    ! Loop inefficiently on all commands:
    do ihist=1,hx%n
      hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
      if (error)  return
      call hobj%links%inputs%dissociate(tot,error)
      if (error)  return
    enddo
    !
  end subroutine cubedag_history_removenode

  subroutine cubedag_history_removecommand(hid,error)
    use cubelist_types
    use cubedag_dag_buffer
    !-------------------------------------------------------------------
    ! Properly a command from the history.
    ! This might leave other commands without inputs and/or without
    ! outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid  ! History identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(list_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist,inode,jhist
    integer(kind=iden_l) :: nodeid
    character(len=mess_l) :: mess
    type(cubedag_history_t), pointer :: hobj,jobj
    character(len=*), parameter :: rname='HISTORY>REMOVECOMMAND'
    !
    ihist = hx%entrynum(hid,error)
    if (error)  return
    hobj => cubedag_history_ptr(hx%list(ihist)%p,error)
    if (error)  return
    write(mess,'(a,i0,3a)')  'Undo command #',ihist,' (',trim(hobj%command),')'
    call cubedag_message(seve%i,rname,mess)
    !
    do inode=1,hobj%links%outputs%n
      object => cubedag_node_ptr(hobj%links%outputs%list(inode)%p,error)
      if (error)  return
      nodeid = object%node%id
      tot => object
      !
      ! Remove from commands which used it as input. As of today, there
      ! is no backpointer to these commands (is this really desired?).
      ! Loop inefficiently on all commands:
      do jhist=1,hx%n
        jobj => cubedag_history_ptr(hx%list(jhist)%p,error)
        if (error)  return
        call jobj%links%inputs%dissociate(tot,error)
        if (error)  return
      enddo
      !
      ! Actually remove the node from DAG
      call cubedag_dag_removenode(nodeid,error)
      if (error)  return
    enddo
    !
    ! Now remove the command from history index
    call hx%pop(ihist,error)
    if (error)  return
  end subroutine cubedag_history_removecommand

  subroutine cubedag_history_destroy(error)
    !-------------------------------------------------------------------
    ! Brute-force destroy the whole HISTORY
    ! No care of the backpointer links to the cubes in the DAG
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call hx%final(error)
    if (error)  continue
  end subroutine cubedag_history_destroy

end module cubedag_history_buffer

module cubedag_walker_types
  use cubedag_messaging
  use cubedag_parameters
  use cubedag_dag_buffer
  use cubedag_link_type
  use cubedag_node_class
  !
  public :: parentwalker_t,childwalker_t
  public :: cubedag_walker_null
  private
  !
  integer(kind=1), parameter :: topomarker_null=0
  integer(kind=1), parameter :: topomarker_done=1
  !
  type, abstract :: walker_t
    integer(kind=1), allocatable :: topomarker(:)  !
    type(cubedag_link_t)         :: link           ! List of collected objects
    integer(kind=entr_k)         :: current        ! Index in iterated list
  contains
    procedure,                              public  :: reset => cubedag_walker_reset
    procedure(getlink_interface), deferred, private :: getlink
    procedure,                              public  :: next  => cubedag_walker_next
  end type walker_t
  !
  type, extends(walker_t) :: parentwalker_t
  contains
    procedure, private :: getlink => cubedag_parentwalker_getlink
  end type parentwalker_t
  !
  type, extends(walker_t) :: childwalker_t
  contains
    procedure, private :: getlink => cubedag_childwalker_getlink
  end type childwalker_t
  !
  abstract interface
    subroutine callback_interface(par,chi,error)
      import cubedag_node_object_t
      class(cubedag_node_object_t), intent(in)    :: par
      class(cubedag_node_object_t), intent(in)    :: chi
      logical,                      intent(inout) :: error
    end subroutine callback_interface
    recursive subroutine getlink_interface(walker,obj,callback,error)
      import walker_t,cubedag_node_object_t,callback_interface
      class(walker_t),              intent(inout) :: walker
      class(cubedag_node_object_t), intent(in)    :: obj
      procedure(callback_interface)               :: callback
      logical,                      intent(inout) :: error
    end subroutine getlink_interface
  end interface
  !
contains
  !
  subroutine cubedag_walker_reset(walker,start,callback,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Set the current walker in memory to start from given commit
    ! The callback is called at load time, on each parent-child pair,
    ! with the signature:
    !    call callback(pid,cid,error)
    ! If the callback raises an error, the load stops and
    ! cubedag_walker_reset returns an error
    !-------------------------------------------------------------------
    class(walker_t),              intent(inout)      :: walker
    procedure(callback_interface)                    :: callback
    class(cubedag_node_object_t), intent(in), target :: start
    logical,                      intent(inout)      :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='WALKER>RESET'
    !
    ! ZZZ Unclear if collection should be done here or at first
    !     cubedag_walker_next
    !
    ! Prepare topomarkers
    allocate(walker%topomarker(ix%n),stat=ier)
    if (failed_allocate(rname,'topomarker array',ier,error)) return
    walker%topomarker(:) = topomarker_null
    !
    ! Insert start point
    call walker%link%final(error)
    if (error)  return
    call walker%link%associate(start,error)
    if (error)  return
    !
    ! ZZZ Might implement several sorting modes (like git_revwalk_sorting)
    call walker%getlink(start,callback,error)
    if (error)  return
    !
    walker%current = 0
  end subroutine cubedag_walker_reset
  !
  recursive subroutine cubedag_childwalker_getlink(walker,obj,callback,error)
    !---------------------------------------------------------------------
    ! Recursive childwalking
    !---------------------------------------------------------------------
    class(childwalker_t),         intent(inout) :: walker
    class(cubedag_node_object_t), intent(in)    :: obj       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETCHILDREN'
    integer(kind=entr_k) :: first,last,ilist,cent
    class(cubedag_node_object_t), pointer :: chi
    !
    first = walker%link%n+1
    do ilist=1,obj%node%links%children%n
      chi => cubedag_node_ptr(obj%node%links%children%list(ilist)%p,error)
      if (error)  return
      !
      call callback(obj,chi,error)
      if (error)  return
      !
      cent = chi%node%ient
      if (walker%topomarker(cent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      call walker%link%associate(chi,error)
      if (error)  return
      walker%topomarker(cent) = topomarker_done
    enddo
    last = walker%link%n
    !
    do ilist=first,last
      chi => cubedag_node_ptr(walker%link%list(ilist)%p,error)
      if (error)  return
      call cubedag_childwalker_getlink(walker,chi,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_childwalker_getlink
  !
  recursive subroutine cubedag_parentwalker_getlink(walker,obj,callback,error)
    !---------------------------------------------------------------------
    ! Recursive parentwalking
    !---------------------------------------------------------------------
    class(parentwalker_t),        intent(inout) :: walker
    class(cubedag_node_object_t), intent(in)    :: obj       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETPARENT'
    integer(kind=entr_k) :: first,last,ilist,pent
    class(cubedag_node_object_t), pointer :: par
    !
    first = walker%link%n+1
    do ilist=1,obj%node%links%parents%n
      par => cubedag_node_ptr(obj%node%links%parents%list(ilist)%p,error)
      if (error)  return
      !
      call callback(par,obj,error)
      if (error)  return
      !
      pent = par%node%ient
      if (walker%topomarker(pent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      call walker%link%associate(par,error)
      if (error)  return
      walker%topomarker(pent) = topomarker_done
    enddo
    last = walker%link%n
    !
    do ilist=first,last
      par => cubedag_node_ptr(walker%link%list(ilist)%p,error)
      if (error)  return
      call cubedag_parentwalker_getlink(walker,par,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_parentwalker_getlink
  !
  function cubedag_walker_next(walker,next)
    !-------------------------------------------------------------------
    ! Get the next commit ID. Evaluate to .false. if all done.
    !-------------------------------------------------------------------
    logical :: cubedag_walker_next
    class(walker_t),              intent(inout) :: walker
    class(cubedag_node_object_t), pointer       :: next
    ! Local
    logical :: error
    !
    if (walker%current.ge.walker%link%n) then
      cubedag_walker_next = .false.
      next => null()
      return
    endif
    cubedag_walker_next = .true.
    walker%current = walker%current+1
    error = .false.
    next => cubedag_node_ptr(walker%link%list(walker%current)%p,error)
  end function cubedag_walker_next
  !
  subroutine cubedag_walker_null(par,obj,error)
    !-------------------------------------------------------------------
    ! Does nothing. Can be used as neutral callback function.
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par
    class(cubedag_node_object_t), intent(in)    :: obj
    logical,                      intent(inout) :: error
    !
    return
  end subroutine cubedag_walker_null
  !
end module cubedag_walker_types

program uv_ref_model
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  Self-Calibration relative to a uv model
  !	Applies "Self-Calibration" results to a CLIC UV table.
  ! Input :
  !	TABLE$	The UV table to be self-calibrated
  !	SELF$	The "gain" table, i.e. a UV table used as phase reference
  !       UVMODEL$  The UV model table
  !	DTIME$	The smoothing time constant
  !       WCOL$   The reference channel
  !	TYPE$	Type of self-cal, Ampli, Phase or Both
  !	SUBT$	Subtract point source model from data
  ! R.Moreno 17-Jun-1999
  !---------------------------------------------------------------------
  ! Local
  type(gildas) :: x,y,z
  character(len=filename_length) :: uv_table,self_name,model_name,name
  character(len=8) :: type
  real*8 :: time,stime,dtime
  integer :: wcol,itype
  !
  complex(4) :: model,  resul, self
  real(8), allocatable :: ipw(:)
  integer, allocatable :: ipi(:)
  integer :: sblock=1000
  integer :: i,nvs,nvi,kvs,kvi,nsc,nc,n,j, ier, k, wrange(2), mrange(2)
  real :: factor,rbase(2),reel,imgi,uv(2)
  real :: kilow,weight
  logical :: error
  real(8) :: freq
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 1.d0/299792458.d-6
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('SELF$',self_name)
  call gildas_char('UVMODEL$',model_name)
  call gildas_dble('DTIME$',dtime,1)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_char('TYPE$',type)
  call gildas_real('SUB$',factor,1)
  call gildas_close
  !
  self = cmplx(1.0,0.0)
  if (type.eq.'BOTH') then
    itype = 0
  elseif (type.eq.'AMPLI') then
    itype = -1
  elseif (type.eq.'PHASE') then
    itype = 1
  elseif (type.eq.'NONE') then
    itype = 2
    weight = 1.0
  endif
  dtime = 0.5d0*dtime
  mrange(1:2) = 1
  !
  ! Open continuum table
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  !
  ! Open continuum table
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  call gildas_null (y, type = 'UVT')
  call gdf_read_gildas(y, name, '.uvt', error)
  if (error) then
    call gagout('F-SELF_CAL,  Cannot read input UV table')
    goto 999
  endif
  nsc = y%gil%nchan 
  freq = y%gil%val(1)+y%gil%fres*(y%gil%val(1)/y%gil%freq)*((nsc+1)*0.5-y%gil%ref(1))
  kilow = freq*f_to_k
  wcol = max(1,wcol)
  wcol = min(wcol,nsc)
  wrange(1:2) = wcol
  !
  ! Load time variable and sort by time order
  nvs = y%gil%dim(1)
  nvi = y%gil%dim(2)
  allocate (ipw(nvi), ipi(nvi), stat=ier)
  !
  ! Open Model table : in Z slot
  n = lenc(model_name)
  if (n.le.0) goto 999
  name = model_name(1:n)
  call gildas_null (z, type = 'UVT')
  call gdf_read_gildas(z, name, '.uvt', error)
  if (error) then
    call gagout('F-SELF_CAL,  Cannot read input UV model')
    goto 999
  endif
  !
  ! Open line table
  n = lenc(uv_table)
  if (n.le.0) goto 999
  name = uv_table(1:n)
  call sic_parsef(name,x%file,' ','.uvt')
  call gildas_null(x, type = 'UVT')
  call gdf_read_gildas(x, name, '.uvt', error, data=.false.)
  if (error) then
    call gagout ('F-SELF_CAL,  Cannot read input/output UV table')
    goto 999
  endif
  nc = x%gil%nchan 
  !
  ! Sort self-cal table
  call dotime (nvs, nvi, y%r2d, ipw, ipi, stime)
  allocate (x%r2d(x%gil%dim(1), sblock), stat=ier)
  kvs = z%gil%dim(1)
  kvi = z%gil%dim(2)
  !
  ! Loop over line table
  do i=1,x%gil%dim(2),sblock
    x%blc(2) = i
    x%trc(2) = min(x%gil%dim(2),i-1+sblock)
    call gdf_read_data(x,x%r2d,error)
    k = 0
    do j=x%blc(2),x%trc(2)
      k = k+1
      call getiba (x%r2d(:,k),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (nvs,nvi,wrange,y%r2d,   &
     &        time,dtime,ipw,ipi,   &
     &        rbase,resul,uv)
      !
      ! No data: flag
      if (resul.eq.cmplx(0.,0.)) then
        call doflag (nc,x%r2d(:,k)) 
      else
        !
        ! Compute the model visibility
        call geself (kvs,kvi,mrange,z%r2d,  &
     &          time,dtime,ipw,ipi,  &
     &          rbase,model,uv)
        ! Compute self-cal correction
        if (itype.ne.2) then
          call doself  (model,resul,itype,self,weight)
        endif
        ! Compute fraction of source to remove
        reel = factor*real(model)
        imgi = factor*imag(model)
        ! Apply self-cal and remove source
        call doscal (nc,x%r2d(:,k),real(self),imag(self), &
        &       reel,imgi,weight)
      endif
    enddo
    call gdf_write_data(x, x%r2d, error)
  enddo
  ! end loop
  call gdf_close_image(x,error)
  call gdf_close_image(y,error)
  call gdf_close_image(z,error)
  call gagout('S-UV_REF_MODEL,  Successful completion')
  call sysexi(1)
  999   call sysexi(fatale)
end program uv_ref_model

subroutine store_cal(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  !	Stores a calibration curve, in the source observations,
  !	assumed to be in the current index.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'clic_proc_par.inc'
  include 'gbl_memory.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: end, store_amp, store_phase
  logical :: self, do_it
  integer(kind=address_length) :: kh, data_in, kin
  integer(kind=data_length)    :: ldata_in, h_offset
  integer :: ib, isb, iy, oscan, nch, ipola
  integer :: ibmin(2), ibmax(2)
  integer :: spline(2,2,2,-mnant:mnbas), pol(2,2,2,-mnant:mnbas)
  integer :: kslot(2,2,2,-mnant:mnbas),pola(2,2,2,-mnant:mnbas)
  integer :: iy1, iy2, ksb, kpol
  integer :: lb, jw1, jw2, i, l, nc1, nc2, irec, jsb, krec
  integer :: kr, ks
  real :: xx, yy(4), coef(0:3), ww
  real :: y2(2,2,2,-mnant:mnbas)
  real :: w2(2,2,2,-mnant:mnbas)
  real*8 :: uvm,snu
  character(len=80) :: ch2,ch1
  character(len=12) :: argum
  integer :: ic_yes, ic_int, ic_intlast, ic_ext, ic_extlast
  integer :: ic_phalast, ic_amplast
  parameter (ic_yes=1, ic_amplast=2, ic_phalast=4,   &
    ic_int=8, ic_intlast=16,   &
    ic_ext=64, ic_extlast=128)
  !
  ! vocabulary
  integer :: mvx, mvoc1,mvoc2, nkey
  parameter (mvx=2, mvoc1=6, mvoc2 = 3)
  character(len=12) :: vx(mvx), kw, voc1(mvoc1), voc2(mvoc2)
  !
  data vx /'AMPLITUDE','PHASE'/
  data voc1/'AVERAGE','DSB','LOWER','LSB','UPPER','USB'/
  data voc2/'HORIZONTAL','VERTICAL','BOTH'/
  data coef/1.,1.,0.5,0.166666667/
  save end
  !------------------------------------------------------------------------
  ! Code:
  ! Y Faut initialiser SNU a zero DANS TOUS LES CAS !!!!!!!!!!!!!
  snu = 0d0
  self = sic_present(5,0)
  lb = l_subb(1)
  jw1 = iw1(1)
  jw2 = iw2(1)
  call check_input_file(error)
  if (error) goto 999
  call check_index(error)
  if (error) goto 999
  call get_first(.false.,error)    ! to initialise ...
  if (error) goto 999
  call check_output_file(error)
  if (error) goto 999
  call check_equal_file(error)
  if (error) goto 999
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) goto 999
  call sic_ke(line,0,1,argum,nch,.false.,error)
  if (error) goto 999
  call sic_ambigs('STORE_CAL',argum,kw,nkey,vx,mvx,error)
  if (error) goto 999
  store_amp = .false.
  store_phase= .false.
  do i=1, 2
    call sic_ke(line,0,i,argum,nch,.false.,error)
    if (error) goto 999
    call sic_ambigs('STORE_CAL',argum,kw,nkey,vx,mvx,error)
    if (error) goto 999
    store_amp = store_amp .or. (kw.eq.'AMPLITUDE')
    store_phase = store_phase  .or. (kw.eq.'PHASE')
  enddo
  if (store_amp .and. store_phase) then
    call message(4,1,'STORE_CAL',   &
      'Storing amplitude and phase calibration curves')
    iy1 = 1
    iy2 = 2
  elseif (store_amp) then
    call message(4,1,'STORE_CAL',   &
      'Storing amplitude calibration curves')
    iy1 = 1
    iy2 = 1
  elseif (store_phase) then
    call message(4,1,'STORE_CAL',   &
      'Storing phase calibration curves')
    iy1 = 2
    iy2 = 2
  endif
  ! Store /receiver krec
  krec = 0
  if (sic_present(6,0)) then
    call sic_i4(line,6,1,krec,.true.,error)
    if (error) goto 999
    if (krec.gt.mnrec .or. krec.lt.1) then
      call message(8,4,'STORE_CAL','Invalid receiver')
      goto 999
    endif
    write(argum(1:2),'(i2)') krec
    call message(6,1,'STORE_CAL',   &
      'Using calibration curves from receiver '//argum(1:2))
  endif
  ! Store /polar kpolar
  kpol = 0
  if (sic_present(7,0).and..not.self) then
    call sic_ke(line,7,1,argum,nch,.true.,error)
    if (error) goto 999
    call sic_ambigs('STORE CAL /POLARISATION',argum,kw,nkey,voc2,   &
      mvoc2,error)
    if (error) goto 999
    if (kw.eq.'HORIZONTAL') then
      kpol = 1
    elseif (kw.eq.'VERTICAL') then
      kpol = 2
    elseif (kw.eq.'BOTH') then
      kpol = 3
    else
      call message(6,3,'STORE_CAL','Invalid polarisation '//argum)
      error = .true.
      return
    endif
    call message(6,1,'STORE_CAL','Using '//cpol(kpol)   &
      //' calibration curves for both polarisation')
  else
    if (new_receivers.and..not.self) then
      call message(6,1,'STORE_CAL',   &
        'Using a specific calibration curve for each polarisation')
    endif
  endif
  !
  ! Stores horizontal polarisation for old receivers
  if (.not.new_receivers) then
    call message(6,1,'STORE_CAL',   &
      'Patching data for old receivers')
    kpol = 1
  endif
  !
  ! Store /band ksb
  ksb = 0
  if (sic_present(1,0)) then
    call sic_ke(line,1,1,argum,nch,.true.,error)
    if (error) goto 999
    call sic_ambigs('STORE CAL /BAND',argum,kw,nkey,voc1,mvoc1,   &
      error)
    if (error) goto 999
    if (kw.eq.'USB' .or. kw.eq.'UPPER') then
      ksb = 1
    elseif (kw.eq.'LSB'.or. kw.eq.'LOWER') then
      ksb = 2
    elseif (kw.eq.'AVERAGE' .or. kw.eq.'DSB') then
      ksb = 3
    else
      call message(6,3,'STORE_CAL','Invalid sideband '//argum)
      error = .true.
      return
    endif
    call message(6,1,'STORE_CAL','Using '//cband(ksb)   &
      //' calibration curves for both sidebands')
  else
    call message(6,1,'STORE_CAL',   &
      'Using a specific calibration curve for each sideband')
  endif
  !
  if (do_amplitude_antenna) then
    ibmin(1) = -r_nant
    ibmax(1) = -1
  else
    ibmin(1) = 1
    ibmax(1) = r_nbas
  endif
  !
  if (do_phase_antenna) then
    ibmin(2) = -r_nant
    ibmax(2) = -1
  else
    ibmin(2) = 1
    ibmax(2) = r_nbas
  endif
  ! current (default) receiver
  irec = r_nrec
  if (krec.ne.0) irec = krec
  !
  !     Check for presence of calibration curve
  do_it = .false.
  if (.not.self) then
    do iy = iy1, iy2
      nc1 = lenc(clab(iy))
      ch1 = 'No '//clab(iy)(1:nc1)//' calibration for '
      nc1 = lenc(ch1)+1
      do ib = ibmin(iy), ibmax(iy)
        if (ib.gt.0) then
          ch2 = ', Baseline '//cbas(ib)
        else
          ch2 = ', Antenna '//char(-ib+ichar('0'))
        endif
        ! (1) one sideband, one polar
        if (ksb.ne.0) then
          if (kpol.ne.0) then
            if (f_spline(iy,ksb,kpol,ib,irec).gt.0) then
              do isb=1,2
                do ipola=1,2
                  spline(iy,isb,ipola,ib) = ksb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,ksb,kpol,ib,irec)-1
                enddo
              enddo
              do_it = .true.
            elseif (f_pol(iy,ksb,kpol,ib,irec).gt.0) then
              do isb=1,2
                do ipola=1,2
                  pol (iy,isb,ipola,ib) = ksb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,ksb,kpol,ib,irec)-1
                enddo
              enddo
              do_it = .true.
            else
              do isb=1,2
                do ipola=1,2
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  kslot(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                enddo
              enddo
              nc2 = lenc(cband(ksb))
              call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                //cband(ksb)(1:nc2)//ch2 )
            endif
          else
            ! (2) one sideband, two polars
            do ipola=1,2
              if (f_spline(iy,ksb,ipola,ib,irec).gt.0) then
                do isb=1,2
                  spline(iy,isb,ipola,ib) = ksb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,ksb,ipola,ib,irec)-1
                enddo
                do_it = .true.
              elseif (f_pol(iy,ksb,ipola,ib,irec).gt.0) then
                do isb=1,2
                  pol (iy,isb,ipola,ib) = ksb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,ksb,ipola,ib,irec)-1
                enddo
                do_it = .true.
              else
                do isb=1,2
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  kslot(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                enddo
                nc2 = lenc(cband(ksb))
                call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                  //cband(ksb)(1:nc2)//ch2 )
              endif
            enddo
          endif
        else
          ! (3) two sidebands, one polar
          if (kpol.ne.0) then
            do ipola=1,2
              do isb= 1,2
                if (f_spline(iy,isb,kpol,ib,irec).gt.0) then
                  spline(iy,isb,ipola,ib) = isb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,isb,kpol,ib,irec)-1
                  do_it = .true.
                elseif (f_pol(iy,isb,kpol,ib,irec).gt.0) then
                  pol (iy,isb,ipola,ib) = isb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = kpol
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,isb,kpol,ib,irec)-1
                  do_it = .true.
                else
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                  nc2 = lenc(cband(isb))
                  kslot(iy,isb,ipola,ib) = 0
                  call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                    //cband(isb)(1:nc2)//ch2 )
                endif
              enddo
            enddo
          else
            ! (4) two sidebands, two polars (we should not get in that mode)
            do ipola=1,2
              do isb= 1,2
                if (f_spline(iy,isb,ipola,ib,irec).gt.0) then
                  spline(iy,isb,ipola,ib) = isb
                  pol (iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_spline(iy,isb,ipola,ib,irec)-1
                  do_it = .true.
                elseif (f_pol(iy,isb,ipola,ib,irec).gt.0) then
                  pol (iy,isb,ipola,ib) = isb
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = ipola
                  kslot(iy,isb,ipola,ib) =   &
                    f_pol(iy,isb,ipola,ib,irec)-1
                  do_it = .true.
                else
                  pol (iy,isb,ipola,ib) = 0
                  spline(iy,isb,ipola,ib) = 0
                  pola (iy,isb,ipola,ib) = 0
                  nc2 = lenc(cband(isb))
                  kslot(iy,isb,ipola,ib) = 0
                  call message(4,2,'STORE_CAL',ch1(1:nc1)   &
                    //cband(isb)(1:nc2)//ch2 )
                endif
              enddo
            enddo
          endif
        endif
      enddo
    enddo
  else
    ! Self calibration
    do_it = .true.
    ch2 = ' '
    l = 1
    do i=1,l_subb(1)
      ch2 = ch2(1:l)//csub(i_subb(i,1))//' '
      l = l+4
    enddo
    l = lenc(ch2)
    call message(2,1,'STORE_CAL',   &
      'Self calibrating from '//ch2(1:l))
    save_scale = do_scale
    save_flux = do_flux
    save_amplitude = do_amplitude
    save_phase = do_phase
    if (store_amp .and. (do_amplitude .or. .not.do_scale   &
      .or. do_flux)) then
      do_scale = .true.
      do_amplitude = .false.
      do_flux = .false.
    endif
    if (store_phase .and. do_phase) then
      do_phase = .false.
    endif
  endif
  if (.not.do_it) then
    call message (8,4,'STORE_CAL','No calibration curve to store')
    print *,"KSB",ksb,"KPOL",kpol
    goto 999
  endif
  !
  ! Loop on current index
  end = .false.
  oscan = 0
  do while (.not.end)
    !
    ! Check for autocorrelation scans
    if (r_proc.eq.p_pass .or. r_proc.eq.p_skydip   &
      .or. r_proc.eq.p_sky .or. r_proc.eq.p_cal   &
      .or. r_proc.eq.p_onoff .or. r_proc.eq.p_pseudo) goto 98
    !
    ! Store calibration curves
    if (krec.ne.0 .and. krec.ne.r_nrec) then
      irec = krec
    else
      irec = r_nrec
    endif
    call set_corr(error)
    if (error) goto 999
    !
    ! Get data if data is present in file.
    ! [r_ut is not accurate in old data; is patched by COPY; therefore it is
    ! safe to assume that it is OK if COPY HEADERS was done.]
    if (.not.r_presec(file_sec)) then
      call get_data (ldata_in,data_in,error)
      if (error) goto 999
      kin = gag_pointer(data_in,memory)
      kr = r_ndump + 1
      kh = kin + h_offset(kr)
      call decode_header (memory(kh))
      xx = dh_utc/3600.   &
        +(mod(dh_obs+32768,65536)-mod(dobs_0+32768,65536))*24.
    else
      xx = (r_ut/2d0/pi   &
        +(mod(r_dobs+32768,65536)-mod(dobs_0+32768,65536)))*24.
    endif
    !
    ! Get self calibration (possibly from other receiver).
    if (self) then
      call get_self_cal(krec,iy1,iy2,ibmin,ibmax,ksb,y2,w2,error)
      if (error) goto 999
    endif
    !
    do iy = iy1, iy2
      do ib = ibmin(iy), ibmax(iy)
        do isb= 1,2
          do ipola= 1,2
            !
            ks = 0
            ! self calibration: use the first subband set as a reference
            ! works only for the same band
            if (self) then
              if (iy.eq.2) then
                if (irec.ne.r_nrec) then
                  ks = 1
                else
                  ks = 0
                endif
              else
                ks = 0
              endif
              ww = w2(iy,isb,ipola,ib)
              yy(1) = y2(iy,isb,ipola,ib)
              ! Planet Jupiter
              if (planet_model.eq.-3) then
                uvm = sqrt(dh_uvm(1,ib)**2+dh_uvm(2,ib)**2)
                call get_fluxspl(uvm,snu)
              else
                snu = 0.0
              endif
              ! End patch
              do i=2,4
                yy(i) = 0
              enddo
            ! Not Self Calibration
            else
              ww = 1.
              call get_cal(iy,irec,isb,ib,spline(iy,isb,ipola,ib)   &
                ,pol(iy,isb,ipola,ib),pola(iy,isb,ipola,ib),   &
                xx,yy,oscan,error)
              if (error) return
              if (iy.eq.2) then
                if (irec.ne.r_nrec) then
                  ks = 1
                else
                  ks = kslot(iy,isb,ipola,ib)
                endif
              else
                ks = 0
              endif
            endif
            ! baseline based:
            if (iy.eq.1 .and. .not.do_amplitude_antenna) then
              r_aic = iand(r_aic,not(ic_amplast))
              r_ic = ior(r_ic,ic_amplast)
              r_icamp(ipola,isb,ib,ks) = yy(1)*coef(0)
              ! I'm not sure why the following line was omitted, it is needed to use
              ! baseline amp  and antenna phase together.
              r_ic = ior(r_ic,ic_yes)
              r_icdeg = 3
              r_presec(ical_sec)=.true.
            elseif (iy.eq.2 .and. .not.do_phase_antenna) then
              r_aic = iand(r_aic,not(ic_phalast))
              r_ic = ior(r_ic,ic_phalast)
              r_icpha(ipola,isb,ib,ks) = yy(1)*coef(0)
              if (ks.eq.0) then
                r_ic = ior(r_ic,ic_yes+ic_int+ic_intlast)
                r_ic = iand(r_ic,not(ic_extlast))
              else
                r_ic = ior(r_ic,ic_yes+ic_ext+ic_extlast)
                r_ic = iand(r_ic,not(ic_intlast))
              endif
              r_icdeg = 3
              r_presec(ical_sec)=.true.
              !
              ! Jupiter patch
              if (snu.lt.0) then
                r_icpha(ipola,isb,ib,0) = r_icpha(ipola,   &
                  isb,ib,0)+pi
              endif
            endif
            ! Antenna  based:
            if (iy.eq.1 .and. do_amplitude_antenna   &
              .and. ww.gt.0) then
              r_ic = iand(r_ic,not(ic_amplast))
              r_aic = ior(r_aic,ic_amplast)
              ! I'm not sure why the following line was omitted, it is needed to use
              ! baseline amp  and antenna phase together.
              r_aic = ior(r_aic,ic_yes)
              r_aicamp(ipola,isb,-ib,ks) = yy(1)*coef(0)
              r_aicdeg = 3
              r_presec(aical_sec)=.true.
            elseif (iy.eq.2 .and. do_phase_antenna   &
              .and. ww.gt.0) then
              r_ic = iand(r_ic,not(ic_phalast))
              r_aic = ior(r_aic,ic_phalast)
              if (ks.eq.0) then
                r_aic = ior(r_aic,ic_yes+ic_int+ic_intlast)
                r_aic = iand(r_aic,not(ic_extlast))
              else
                r_aic = ior(r_aic,ic_yes+ic_ext+ic_extlast)
                r_aic = iand(r_aic,not(ic_intlast))
              endif
              r_aicpha(ipola,isb,-ib,ks) = yy(1)*coef(0)
              r_aicdeg = 3
              r_presec(aical_sec)=.true.
            endif
          enddo
        enddo
      ! end loop on 'baselines'
      enddo
      ! get rms: loop on TRUE baselines
      do ib = 1, r_nbas
        do isb = 1, 2
          ! forced side band
          if (ksb.ne.0) then
            jsb = ksb
          else
            jsb = isb
          endif
          do ipola = 1, 2
            if (do_amplitude_antenna .or.   &
              do_phase_antenna) then
              if (f_spline(iy,jsb,ipola,-r_iant(ib),irec)   &
                .gt.0) then
                r_aicrms(ipola,isb,ib,iy) =   &
                  rms_spline_ant(iy,jsb,ipola,ib,irec)
              elseif (f_pol(iy,jsb,ipola,-r_iant(ib),irec)   &
                .gt.0) then
                r_aicrms(ipola,isb,ib,iy) =   &
                  rms_pol_ant(iy,jsb,ipola,ib,irec)
              endif
            endif
            if (.not.do_amplitude_antenna .or.   &
              .not.do_phase_antenna) then
              if (f_spline(iy,jsb,ipola,ib,irec).gt.0) then
                r_icrms(ipola,isb,ib,iy) =   &
                  rms_spline_bas(iy,jsb,ipola,ib,irec)
              elseif (f_pol(iy,jsb,ipola,ib,irec).gt.0) then
                r_icrms(ipola,isb,ib,iy) =   &
                  rms_pol_bas(iy,jsb,ipola,ib,irec)
              endif
            endif
          enddo
        enddo
      enddo
    ! end loop on amp, phas
    enddo
    !
    ! Update  scan
    call write_scan (.false.,error)
    if (error) goto 999
    !
    ! Next observation
98  if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) goto 999
  enddo
  do_scale = save_scale
  do_flux = save_flux
  do_amplitude = save_amplitude
  do_phase = save_phase
  return
  !
999 error = .true.
  return
end subroutine store_cal
!
subroutine get_cal(iy,ir,isb,ib,ispline,ipol,pola,x,y,oscan,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  !---------------------------------------------------------------------
  ! Returns in Y the value and derivatives of the calibration curve
  ! at time X,
  ! for baseline IB, side band ISB.
  ! IX = 1 for amplitude and 2 for phase
  !---------------------------------------------------------------------
  integer :: iy                     !
  integer :: ir                     !
  integer :: isb                    !
  integer :: ib                     !
  integer :: ispline                !
  integer :: ipol                   !
  integer :: pola                   !
  real :: x                         !
  real :: y(4)                      !
  integer :: oscan                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! INCLUDE 'clic_dheader.inc'
  ! Local
  real*8 :: xx, yy(4), aa(m_pol)
  integer :: jsb, ifail, nk, i
  character(len=80) :: ch
  real :: factor_i, factor_j
  real :: phmul
  !------------------------------------------------------------------------
  ! Code:
  xx = x
  error = .false.
  !
  ! Polarisation
  if (pola.lt.1.or.pola.gt.3) then
    call message (4,3,'GET_CAL','No such polarisation curve stored in memory')
    error = .true.
    return
  endif
  !
  ! Spline
  if (ispline.ne.0) then
    jsb = ispline
  elseif (ipol.ne.0) then
    jsb = ipol
  else
    call message(8,4,'GET_CAL','No calibration for '//cband(isb))
    error = .true.
    return
  endif
  !
  ! Convert from one receiver to the other:
  ! Normally one should also correct for the varying path as a fonction of freq,
  !
  if (iy.eq.2 .and. ir.ne.r_nrec) then
    if (ph_fac(jsb,pola,ib,ir).ne.0) then
      if (jsb.eq.1) then
        phmul = (r_flo1+r_fif1)/ph_fac(jsb,pola,ib,ir)
      elseif (jsb.eq.2) then
        phmul = (r_flo1-r_fif1)/ph_fac(jsb,pola,ib,ir)
      elseif (jsb.eq.3) then
        phmul = r_flo1/ph_fac(jsb,pola,ib,ir)
      endif
    else
      write(ch,'(i1)') ir
      call message(8,4,'GET_CAL',   &
        'Please do a RF passband for receiver '//ch(1:1))
      error = .true.
      return
    endif
  else
    phmul = 1.0
  endif
  !
  ! convert from one sideband to another:
  factor_i = 0.0
  factor_j = 0.0
  if (iy.eq.2 .and. jsb.ne.0 .and. .not. do_phase_ext) then
    if (jsb.ne.isb .or. ir.ne.r_nrec) then
      ! FACTOR_I from average band to target band ISB (current target receiver):
      call band_factor(ib,isb,r_nrec,factor_i,error)
      !
      ! FACTOR_J from average band to origin band JSB (origin receiver IR)
      call band_factor(ib,jsb,ir,factor_j,error)
    endif
  endif
  !
  ! Splines
  if (ispline.ne.0) then
    ifail = 1
    nk = n_knots(iy,jsb,pola,ib,ir)
    if (xx.lt.k_spline(4,iy,jsb,pola,ib,ir)) then
      if (k_spline(4,iy,jsb,pola,ib,ir)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            k_spline(4,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_spline(4,iy,jsb,pola,ib,ir)
    elseif (xx.gt.k_spline(nk+5,iy,jsb,pola,ib,ir)) then
      if (xx-k_spline(nk+5,iy,jsb,pola,ib,ir).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            k_spline(nk+5,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = k_spline(nk+5,iy,jsb,pola,ib,ir)
    endif
    !
    ! Get spline and derivatives
    call mth_getspd('GET_CAL',nk+8, k_spline(1,iy,jsb,pola,ib,ir),   &
      c_spline(1,iy,jsb,pola,ib,ir), xx, 0, yy, error)
    if (error) return
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  !
  ! Polynomials
  elseif (ipol.ne.0) then
    ifail = 1
    if (xx.lt.t_pol(1,iy,jsb,pola,ib,ir)) then
      if (t_pol(1,iy,jsb,pola,ib,ir)-xx .gt. 0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' below limit (',   &
            t_pol(1,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_pol(1,iy,jsb,pola,ib,ir)
    elseif (xx.gt.t_pol(2,iy,jsb,pola,ib,ir)) then
      if (xx-t_pol(2,iy,jsb,pola,ib,ir).gt.0.1) then
        if (r_scan.ne.oscan) then
          oscan = r_scan
          write(ch,'(a,1pg10.3,a,1pg10.3,a)')   &
            'Time ',xx,' above limit (',   &
            t_pol(2,iy,jsb,pola,ib,ir),')'
          call message (5,2,'GET_CAL',ch(1:lenc(ch)))
        endif
      endif
      xx = t_pol(2,iy,jsb,pola,ib,ir)
    endif
    do i=1, n_pol(iy,jsb,pola,ib,ir)
      aa(i) = c_pol(i,iy,jsb,pola,ib,ir)
    enddo
    xx = ((xx-t_pol(1,iy,jsb,pola,ib,ir))   &
      -(t_pol(2,iy,jsb,pola,ib,ir)-xx))   &
      /(t_pol(2,iy,jsb,pola,ib,ir)-t_pol(1,iy,jsb,pola,ib,ir))
    xx = max(xx,-1d0)
    xx = min(xx,1d0)
    call mth_getpol ('GET_CAL',n_pol(iy,jsb,pola,ib,ir),   &
      aa,xx,yy,error)
    if (error) return
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  else
    yy(1) = 0.
    yy(2) = 0
    yy(3) = 0
    yy(4) = 0
  endif
  if (iy.eq.2) then
    yy(1) = (mod((yy(1)-factor_j)+11*pi,2*pi)-pi)*phmul   &
      + factor_i
  endif
  do i=1, 4
    y(i) = yy(i)
  enddo
end subroutine get_cal
!
subroutine band_factor(ib,isb,ir,factor,error)
  use classic_api  
  !---------------------------------------------------------------------
  ! Compute the phase conversion factor (Complex) from band ISB to
  ! Average band, for receiver IR, baseline IB (or antenna -IB)
  ! _ if IR is the current one (IR=R_NREC) then one takes the bandpass data
  !   of the observation;
  ! _ if not, then the bandpass for receiver IR must be in program memory,
  !   or an error occurs.
  !---------------------------------------------------------------------
  integer :: ib                     !
  integer :: isb                    !
  integer :: ir                     !
  real :: factor                    !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  integer :: ia, ja, i
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant)
  real :: faz
  !-----------------------------------------------------------------------
  !
  if (isb.gt.2) then
    factor = 0.0
  elseif (ir.eq.r_nrec) then
    if (ib.gt.0 .and. r_bpc.ne.0) then
      factor = faz(r_bpcsba(1,isb,ib))
    elseif (ib.gt.0 .and. r_abpc.ne.0) then
      ia = r_iant(ib)
      ja = r_jant(ib)
      factor = faz(r_abpcsba(1,isb,ja)/r_abpcsba(1,isb,ia))
    elseif (ib.lt.0 .and. r_abpc.ne.0) then
      factor = faz(r_abpcsba(1,isb,-ib))
    elseif (ib.lt.0 .and. r_bpc.ne.0) then
      do i=1,r_nbas
        z(i) = r_bpcsba(1,isb,i)
        w(i) = 1.
      enddo
      call antgain(z,w,zant,want)
      factor = faz(zant(-ib))
    !
    ! Note: we assume that if we calibrate phase with no RF done and needed,
    ! the image side band is useless.
    elseif (.not.do_pass) then
      call message(4,1,'GET_CAL','No RF Passband available')
      factor = 1.0
    else
      call message(8,3,'GET_CAL','No RF Passband available')
      error = .true.
      return
    endif
  else
    ! should be the SBA used for the phase calibration
    factor = faz(icsba(isb,ib,ir))
  endif
  return
end subroutine band_factor
!
subroutine get_self_cal(krec,iy1,iy2,ibmin,ibmax,jsb,y2,w2,   &
    error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_find
  use clic_rdata
  !---------------------------------------------------------------------
  ! Get self calibration values (from current receiver or receiver krec)
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer :: krec                   !
  integer :: iy1                    !
  integer :: iy2                    !
  integer :: ibmin(2)               !
  integer :: ibmax(2)               !
  integer :: jsb                    !
  real :: y2(2,2,2,-mnant:mnbas)    !
  real :: w2(2,2,2,-mnant:mnbas)    !
  logical :: error                  !
  ! Global
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_memory.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: kb, kif
  integer(kind=address_length) :: data_in, kin
  integer(kind=address_length) :: kh, kl, kc
  integer(kind=data_length)    :: ldata_in, h_offset, l_offset, c_offset
  integer ::  ib, isb, iy, kr, isb1, isb2
  integer ::  iv, im, nff, jw1, jw2, ix, ir, ia, ja, i, ipola
  integer ::  js, isub, jspw, spw_pol
  integer ::  lb_sel(3,2), i_subsel(mrlband,3,2)
  integer(kind=entry_length) :: iff(2),kx,kxsave
  real :: wt(4,3), vt(4,3), phmul, factor_i, factor_j
  complex :: z(mnbas), zant(mnant)
  real :: w(mnbas), want(mnant)
  character(len=80) :: ch
  real :: y1(2,3,2,-mnant:mnbas)
  real :: w1(2,3,2,-mnant:mnbas)
  logical :: zero_average
  save kxsave
  !-----------------------------------------------------------------------
  ix = xy_time
  jw1 = iw1(1)
  jw2 = iw2(1)
  y1 = 0.
  w1 = 0.
  y2 = 0.
  w2 = 0.
  lb_sel = 0
  i_subsel = 0
  !
  ! patch
  kb = 1
  kif = 1
  if (r_lnsb.eq.1) then
    ib = i_subb(1,1)
    if (ib.gt.mbands) ib = ib-mbands
    isb1 = r_lsband(1,ib)
    isb2 = isb1
  else 
    isb1 = 1
    isb2 = 3
  endif
  isb1=1
  isb2=2
  !
  ! Need to spy the other receiver?
  kxsave = r_xnum
  if (krec.ne.0 .and. krec.ne.r_nrec) then
    !
    nff = 2
    fnum = .false.
    xscan(1) = r_scan
    yscan(1) = r_scan
    xnscan = 1
    fscan = .true.
    xrecei = krec
    call fix(nff,iff,.false.,.false.,error)
    error = .false.
    if (nff.lt.1) then
      call message(4,2,'GET_SELF_CAL',   &
        'Only one receiver available')
      error = .true.
      return
    endif
    kx = iff(1)
    call get_it(kx,error)
    if (error) return
    ir = krec
  else
    ir = r_nrec
  endif
  !
  if (do_pass) then
    if (r_bpc.eq.0.and..not.do_pass_memory   &
      .and. .not.do_pass_antenna.and..not.do_pass_spectrum) then
      call message(6,2,'GET_SELF_CAL',   &
        'No Baseline RF Passband Calibration, data ignored')
      error = .true.
      return
    endif
    if (r_abpc.eq.0.and..not.do_pass_memory   &
      .and. do_pass_antenna.and..not.do_pass_spectrum) then
      call message(6,2,'GET_SELF_CAL',   &
        'No Antenna RF Passband Calibration, data ignored')
      error = .true.
      return
    endif
    call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
      r_lntch, passc, passl, error)
    if (error) return
  endif
  if (do_spidx) then
    call set_spidx(r_nsb,r_nband,r_nbas+r_ntri, &
     r_lntch,spidc,spidl,r_spidx,error)
    if (error) return
  endif
  if (do_pass) then
    if (do_spidx) then
      where (passc.ne.blankc)
        factc = passc * spidc
      else where
        factc = blankc
      end where
      where (passl.ne.blankc)
        factl = passl * spidl
      else where
        factl = blankc
      end where
    else
      factc = passc
      factl = passl
    endif
  elseif (do_spidx) then
    factc = spidc
    factl = spidl
  endif
  !
  call get_data (ldata_in,data_in,error)
  if (error) return
  !
  ! Average record only
  kin = gag_pointer(data_in,memory)
  call spectral_dump(kr,0,0)
  kh = kin + h_offset(kr)
  call decode_header (memory(kh))
  call set_scaling(error)
  if (error) return
  !
  ! Build the SPW list to use for each sideband and polarisation.
  ! The /SELF solution is still derived per record, but each call to
  ! ARECORD/BRECORD must see only the SPWs relevant to the requested
  ! sideband and polarisation.
  do js = 1, r_nbb
    jspw = js
    if (jspw.gt.mbands) jspw = jspw-mbands
    if (jspw.le.0 .or. jspw.gt.r_lband) cycle
    do ipola = 1, 2
      if (new_receivers .and. r_lpolmode(jspw).eq.1) then
        spw_pol = r_lpolentry(1,jspw)
        if (spw_pol.ge.1 .and. spw_pol.le.2) then
          if (spw_pol.ne.ipola) cycle
        endif
      endif
      lb_sel(3,ipola) = lb_sel(3,ipola) + 1
      i_subsel(lb_sel(3,ipola),3,ipola) = jspw
      isb = (3-r_sb(jspw))/2
      if (isb.ge.1 .and. isb.le.2) then
        lb_sel(isb,ipola) = lb_sel(isb,ipola) + 1
        i_subsel(lb_sel(isb,ipola),isb,ipola) = jspw
      endif
    enddo
  enddo
  if (r_lmode.eq.1) then       ! correlation only ...
    zero_average = .true.
    if (k_average.eq.1) then
      call line_average (r_lntch,r_nbas,r_lnsb,data_in,   &
        spidl,zero_average,error)
    else
      call cont_average (r_nband,r_nbas,data_in,   &
        spidc,zero_average,error)
    endif
    if (error) return
  endif
  !
  do iy = iy1, iy2
    do ib = ibmin(iy), ibmax(iy)
      if (new_receivers) then
        do ipola=1,2
          !NGRx: need the new parameters in data header (discussed with FG)
          ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
          ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
          ph_fac(3,ipola,ib,r_nrec) = r_flo1
        enddo
      else
        do ipola=1,2
          ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
          ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
          ph_fac(3,ipola,ib,r_nrec) = r_flo1
        enddo
      endif
      do isb= isb1, isb2
        do ipola=1,2
          if (lb_sel(isb,ipola).le.0) cycle
          do iv=1,4
            do im=1,3
              vt(iv,im) = 0
              wt(iv,im) = 0
            enddo
          enddo
          if (ib.lt.0) then
            call spectral_dump(kr,-ib,0)
            kl = kin + l_offset(kr)
            kc = kin + c_offset(kr)
            call arecord (   &
              r_nsb, r_nband, r_nbas, r_lntch,   &
              memory(kc), memory(kl), factc, factl,   &
              -ib,isb,ipola,kb, kif,lb_sel(isb,ipola),   &
              i_subsel(1,isb,ipola),jw1,jw2,ix,iy,   &
              vt,wt,.false.,error)
            if (error) return
            w1(iy,isb,ipola,ib) = wt(2,2)
            if (iy.eq.1) then
              if (wt(2,2).le.0) then
                y1(iy,isb,ipola,ib) = 0
              else
                y1(iy,isb,ipola,ib) = log(sqrt(vt(2,2)/wt(2,2)))
              endif
            elseif (iy.eq.2) then
              if (wt(2,2).le.0) then
                y1(iy,isb,ipola,ib) = 0
              else
                y1(iy,isb,ipola,ib) = vt(2,2)/wt(2,2)
              endif
            endif
            ! Not needed if JSB is zero (no band-to-band or rec-to-rec conversion)
            if (jsb.gt.0) then
              if (isb.gt.2) then
                icsba(isb,ib,r_nrec) = 1.0
              elseif (do_pass_memory) then
                icsba(isb,ib,r_nrec) = sba(isb,ib,r_nrec)
              elseif (r_abpc.ne.0) then
                icsba(isb,ib,r_nrec) = r_abpcsba(1,isb,-ib)
              elseif (r_bpc.ne.0) then
                do i=1,r_nbas
                  z(i) = r_bpcsba(1,isb,i)
                  w(i) = 1.
                enddo
                call antgain(z,w,zant,want)
                icsba(isb,ib,r_nrec) = zant(-ib)
              else
                call message(8,2,'GET_SELF_CAL',   &
                  'No RF Passband available')
              endif
            endif
          else
            call spectral_dump(kr,0,ib)
            kl = kin + l_offset(kr)
            kc = kin + c_offset(kr)
            call brecord (   &
              r_nsb, r_nband, r_nbas+r_ntri, r_lntch,   &
              memory(kc), memory(kl), factc, factl,   &
              ib,isb,ipola,kb,kif,lb_sel(isb,ipola),   &
              i_subsel(1,isb,ipola),jw1,jw2,ix,iy,   &
              vt,wt,error)
            if (error) return
            w1(iy,isb,ipola,ib) = wt(2,2)
            if (wt(2,2).le.0) then
              y1(iy,isb,ipola,ib) = 0
            else
              y1(iy,isb,ipola,ib) = vt(2,2)/wt(2,2)
            endif
            ! side band averages
            ! Not needed if JSB is zero (no band-to-band or rec-to-rec conversion)
            if (jsb.gt.0) then
              if (isb.gt.2) then
                icsba(isb,ib,r_nrec) = 1.0
              elseif (do_pass_memory) then
                icsba(isb,ib,r_nrec) = sba(isb,ib,r_nrec)
              elseif (r_bpc.ne.0) then
                icsba(isb,ib,r_nrec) = r_bpcsba(1,isb,ib)
              elseif (r_abpc.ne.0) then
                ia = r_iant(ib)
                ja = r_jant(ib)
                icsba(isb,ib,r_nrec) =   &
                  r_abpcsba(1,isb,ja)/r_abpcsba(1,isb,ia)
              else
                call message(8,2,'GET_SELF_CAL',   &
                  'No RF Passband available')
              endif
            endif
          endif
        enddo
      enddo
    enddo
  enddo
  !
  if (r_xnum.ne.kxsave) then
    call get_it(kxsave,error)
  endif
  !
  ! Phase (Iy=2) specifics:
  ! Convert from one receiver to the other (IR = origin receiver):
  ! Normally one should also correct for the varying path as a fonction of freq,
  !
  do iy=iy1, iy2
    if (iy.eq.1) then
      do ib = ibmin(iy), ibmax(iy)
        do isb= 1,2
          do ipola=1,2
            w2(1,isb,ipola,ib) = w1(1,isb,ipola,ib)
            y2(1,isb,ipola,ib) = y1(1,isb,ipola,ib)
          enddo
        enddo
      enddo
    else
      do ib = ibmin(iy), ibmax(iy)
        if (new_receivers) then
          do ipola=1,2
            !     Need the new parameters in data header (discussed with FG)
            ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
            ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
            ph_fac(3,ipola,ib,r_nrec) = r_flo1
          enddo
        else
          do ipola=1,2
            ph_fac(1,ipola,ib,r_nrec) = r_flo1+r_fif1
            ph_fac(2,ipola,ib,r_nrec) = r_flo1-r_fif1
            ph_fac(3,ipola,ib,r_nrec) = r_flo1
          enddo
        endif
        do isb= 1,2
          do ipola=1,2
            !
            ! in that case, JSB must not be Zero...
            if (ir.ne.r_nrec) then
              if (ph_fac(jsb,ipola,ib,ir).ne.0) then
                phmul = ph_fac(isb,ipola,ib,r_nrec)/   &
                  ph_fac(jsb,ipola,ib,ir)
              else
                write(ch,'(i1)') ir
                call message(8,4,'GET_SELF_CAL',   &
                  'Please do a RF passband for receiver '   &
                  //ch(1:1))
                error = .true.
                return
              endif
            else
              phmul = 1.0
            endif
            !
            ! convert from one sideband to another:
            factor_i = 0.0
            factor_j = 0.0
            if (jsb.ne.0 .and. .not. do_phase_ext) then
              if (jsb.ne.isb .or. ir.ne.r_nrec) then
                ! FACTOR_I from average band to target band ISB (current target receiver):
                call band_factor(ib,isb,r_nrec,factor_i,error)
                !
                ! FACTOR_J from average band to origin band JSB (origin receiver IR)
                call band_factor(ib,jsb,ir,factor_j,error)
              endif
              y2(2,isb,ipola,ib) =   &
                (mod(y1(2,jsb,ipola,ib)-factor_j+11*pi,2*pi)-pi)   &
                *phmul + factor_i
            else
              y2(2,isb,ipola,ib) = y1(2,isb,ipola,ib)
            endif
            w2(2,isb,ipola,ib) = w1(2,isb,ipola,ib)
          enddo
        enddo
      enddo
    endif
  enddo
  return
end subroutine get_self_cal

subroutine cubspl4(n,tau,c0,c1,c2,c3,ibcbeg,ibcend,error)
  use gbl_message
  use greg_interfaces, except_this=>cubspl4
  !---------------------------------------------------------------------
  ! @ public
  !  Piecewise cubic spline interpolants computation; adapted from
  !  'A practical guide to SPLINES' , CARL DE BOOR, Applied Mathematical
  !  Sciences, SPRINGER-VERLAG, VOL.27, P57-59 (1978).
  !
  !  c1(1), c1(N) are boundary condition information. Specifically:
  !
  !  IBCBEG = 0 means no boundary condition at tau(1) is given. In this
  !             case, the not-a-knot condition is used, i.e. the jump in
  !             the third derivative across TAU(2) is forced to zero,
  !             thus the first and the second cubic polynomial pieces
  !             are made to coincide.
  !  IBCBEG = 1 means that the slope at TAU(1) is made to equal c1(1),
  !             supplied by input.
  !  IBCBEG = 2 means that the second derivative at TAU(1) is made to
  !             equal c1(1), supplied by input.
  !
  !  IBCEND = 0, 1, or 2 has analogous meaning concerning the boundary
  !             condition at TAU(N), with the additional information
  !             taken from c1(N).
  !
  !  CJ(I), J=1,...,4; I=1,...,L (= N-1) are the polynomial coefficients
  !  of the cubic interpolating spline. Precisely, in the interval
  !  [ TAU(I), TAU(I+1) ]  the spline F is given by
  !         F(X) = c0(I)+H*(c1(I)+H*(c2(I)+H*c3(I)/3.)/2.)
  !  where H = X - TAU(I).
  !
  !  In other words, for I=1,...,N, c1(I) and c2(I) are respectively
  !  equal to the values of the first and second derivatives of the
  !  interpolating spline, and c3(I) is equal to the third derivative
  !  of the interpolating spline in the interval [ TAU(I), TAU(I+1) ].
  !  c3(N) is meaningless and is set to 0.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n       ! Number of data points (>1)
  real(kind=4),    intent(in)    :: tau(n)  ! Abscissae of data points, strictly monotonous
  real(kind=4),    intent(inout) :: c0(n)   ! Ordinates of data points (in) / First polynomial coefficient of spline (out)
  real(kind=4),    intent(inout) :: c1(n)   ! Boundary condition information (in) / Second polynomial coefficient of spline (out)
  real(kind=4),    intent(out)   :: c2(n)   ! Third polynomial coefficient of spline
  real(kind=4),    intent(out)   :: c3(n)   ! Fourth polynomial coefficient of spline
  integer(kind=4), intent(in)    :: ibcbeg  ! Boundary condition indicator
  integer(kind=4), intent(in)    :: ibcend  ! Boundary condition indicator
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CUBSPL4'
  real(kind=4) :: taum1,g,dtau,divdf1,divdf3
  integer(kind=4) :: i,j,l,m
  !
  ! A tridiagonal linear system for the unknown slopes S(I) of
  ! F at TAU(I), I=1,...,N, is generated and then solved by gauss
  ! elimination, with S(I) ending up in c1(I), all I.
  ! c2(.) and c3(.) are used initially for temporary storage.
  !
  if (n.lt.2) then
    call greg_message(seve%e,rname,'Less than two pivots')
    error = .true.
    return
  endif
  !
  ! Check if TAU strictly monotonous
  taum1=tau(2)
  if (tau(2).lt.tau(1)) then
    do i=3,n
      if (tau(i).ge.taum1) then
        call greg_message(seve%e,rname,'Variable is not strictly monotonous')
        error = .true.
        return
      endif
      taum1 = tau(i)
    enddo
  elseif (tau(2).gt.tau(1)) then
    do i=3,n
      if (tau(i).le.taum1) then
        call greg_message(seve%e,rname,'Variable is not strictly monotonous')
        error = .true.
        return
      endif
      taum1 = tau(i)
    enddo
  else
    call greg_message(seve%e,rname,'Variable is not strictly monotonous')
    error = .true.
    return
  endif
  !
  l = n-1
  !
  ! Compute first differences of TAU sequence and store in c2(.).
  ! Also, compute first divided difference of data and store in c3(.).
  !
  do  m=2,n
    c2(m) = tau(m) - tau(m-1)
    c3(m) = (c0(m) - c0(m-1))/c2(m)
  enddo
  !
  ! Construct first equation from the boundary condition, of the form
  !             c3(1)*S(1) + c2(1)*S(2) = c1(1)
  !
  if (ibcbeg-1)                     11,15,16
11 if (n .gt. 2)                     goto 12
  !
  ! No condition at left end and N = 2.
  c3(1) = 1.
  c2(1) = 1.
  c1(1) = 2.*c3(2)
  goto 25
  !
  ! Not-a-knot condition at left end and N .GT. 2.
12 c3(1) = c2(3)
  c2(1) = c2(2) + c2(3)
  c1(1) = ((c2(2)+2.*c2(1))*c3(2)*c2(3)+c2(2)**2*c3(3))/c2(1)
  goto 19
  !
  ! Slope prescribed at left end.
15 c3(1) = 1.
  c2(1) = 0.
  goto 18
  !
  ! Second derivative prescribed at left end.
16 c3(1) = 2.
  c2(1) = 1.
  c1(1) = 3.*c3(2) - c2(2)/2.*c1(1)
18 if (n.eq.2)  goto 25
  !
  ! If there are interior knots, generate the corresponding equations and
  ! carry out the forward pass of gauss elimination, after which the M-th
  ! equation reads    c3(M)*S(M) + c2(M)*S(M+1) = c1(M).
  !
19 continue
  do m=2,l
    g = -c2(m+1)/c3(m-1)
    c1(m) = g*c1(m-1) + 3.*(c2(m)*c3(m+1)+c2(m+1)*c3(m))
    c3(m) = g*c2(m-1) + 2.*(c2(m) + c2(m+1))
  enddo
  !
  ! Construct last equation from the second boundary condition, of the form
  !           (-G*c3(N-1))*S(N-1) + c3(N)*S(N) = c1(N)
  ! If slope is prescribed at right end, one can go directly to back
  ! substitution, since C array happens to be set up just right for it
  ! at this point.
  !
  if (ibcend-1)                     21,30,24
21 if (n .eq. 3 .and. ibcbeg .eq. 0) goto 22
  !
  ! not-a-knot and N.GE.3, and either N.GT.3 or also not-a-knot at
  ! left endpoint.
  !
  g = c2(l) + c2(n)
  c1(n) = ((c2(n)+2.*g)*c3(n)*c2(l) + c2(n)**2*(c0(l)-c0(n-2))/c2(l))/g
  g = -g/c3(l)
  c3(n) = c2(l)
  goto 29
  !
  ! Either (N=3 and not-a-knot also at left) or (N=2 and not not-a-knot
  ! at left endpoint).
  !
22 c1(n) = 2.*c3(n)
  c3(n) = 1.
  goto 28
  !
  ! Second derivative prescribed at right endpoint.
24 c1(n) = 3.*c3(n) + c2(n)/2.*c1(n)
  c3(n) = 2.
  goto 28
25 if (ibcend-1)                     26,30,24
26 if (ibcbeg .gt. 0)                goto 22
  !
  ! not-a-knot at right endpoint and at left endpoint and N=2.
  c1(n) = c3(n)
  goto 30
28 g = -1./c3(l)
  !
  ! Complete forward pass of GAUSS elimination.
29 c3(n) = g*c2(l) + c3(n)
  c1(n) = (g*c1(l) + c1(n))/c3(n)
  !
  ! Carry out back substitution
30 continue
  do j=l,1,-1
    c1(j) = (c1(j) - c2(j)*c1(j+1))/c3(j)
  enddo
  !
  ! Generate cubic coefficients in each interval, i.e., the derivatives
  ! at its left endpoint, from value and slope at its endpoints.
  !
  do i=2,n
    dtau = c2(i)
    divdf1 = (c0(i) - c0(i-1))/dtau
    divdf3 = c1(i-1) + c1(i) - 2.*divdf1
    c2(i-1) = 2.*(divdf1 - c1(i-1) - divdf3)/dtau
    c3(i-1) = (divdf3/dtau)*(6./dtau)
  enddo
  !
  ! Compute in addition c2(N). set c3(N) to 0.
  c2(n) = c2(l) + c3(l)*dtau
  c3(n) = 0.
end subroutine cubspl4
!
subroutine cubspl8(n,tau,c0,c1,c2,c3,ibcbeg,ibcend,error)
  use gbl_message
  use greg_interfaces, except_this=>cubspl8
  !---------------------------------------------------------------------
  ! @ public
  !  Piecewise cubic spline interpolants computation; adapted from
  !  'A practical guide to SPLINES' , CARL DE BOOR, Applied Mathematical
  !  Sciences, SPRINGER-VERLAG, VOL.27, P57-59 (1978).
  !
  !  c1(1), c1(N) are boundary condition information. Specifically:
  !
  !  IBCBEG = 0 means no boundary condition at tau(1) is given. In this
  !             case, the not-a-knot condition is used, i.e. the jump in
  !             the third derivative across TAU(2) is forced to zero,
  !             thus the first and the second cubic polynomial pieces
  !             are made to coincide.
  !  IBCBEG = 1 means that the slope at TAU(1) is made to equal c1(1),
  !             supplied by input.
  !  IBCBEG = 2 means that the second derivative at TAU(1) is made to
  !             equal c1(1), supplied by input.
  !
  !  IBCEND = 0, 1, or 2 has analogous meaning concerning the boundary
  !             condition at TAU(N), with the additional information
  !             taken from c1(N).
  !
  !  CJ(I), J=1,...,4; I=1,...,L (= N-1) are the polynomial coefficients
  !  of the cubic interpolating spline. Precisely, in the interval
  !  [ TAU(I), TAU(I+1) ]  the spline F is given by
  !         F(X) = c0(I)+H*(c1(I)+H*(c2(I)+H*c3(I)/3.)/2.)
  !  where H = X - TAU(I).
  !
  !  In other words, for I=1,...,N, c1(I) and c2(I) are respectively
  !  equal to the values of the first and second derivatives of the
  !  interpolating spline, and c3(I) is equal to the third derivative
  !  of the interpolating spline in the interval [ TAU(I), TAU(I+1) ].
  !  c3(N) is meaningless and is set to 0.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n       ! Number of data points (>1)
  real(kind=8),    intent(in)    :: tau(n)  ! Abscissae of data points, strictly monotonous
  real(kind=8),    intent(inout) :: c0(n)   ! Ordinates of data points (in) / First polynomial coefficient of spline (out)
  real(kind=8),    intent(inout) :: c1(n)   ! Boundary condition information (in) / Second polynomial coefficient of spline (out)
  real(kind=8),    intent(out)   :: c2(n)   ! Third polynomial coefficient of spline
  real(kind=8),    intent(out)   :: c3(n)   ! Fourth polynomial coefficient of spline
  integer(kind=4), intent(in)    :: ibcbeg  ! Boundary condition indicator
  integer(kind=4), intent(in)    :: ibcend  ! Boundary condition indicator
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='CUBSPL8'
  real(kind=8) :: taum1,g,dtau,divdf1,divdf3
  integer(kind=4) :: i,j,l,m
  !
  ! A tridiagonal linear system for the unknown slopes S(I) of
  ! F at TAU(I), I=1,...,N, is generated and then solved by gauss
  ! elimination, with S(I) ending up in c1(I), all I.
  ! c2(.) and c3(.) are used initially for temporary storage.
  !
  if (n.lt.2) then
    call greg_message(seve%e,rname,'Less than two pivots')
    error = .true.
    return
  endif
  !
  ! Check if TAU strictly monotonous
  taum1=tau(2)
  if (tau(2).lt.tau(1)) then
    do i=3,n
      if (tau(i).ge.taum1) then
        call greg_message(seve%e,rname,'Variable is not strictly monotonous')
        error = .true.
        return
      endif
      taum1 = tau(i)
    enddo
  elseif (tau(2).gt.tau(1)) then
    do i=3,n
      if (tau(i).le.taum1) then
        call greg_message(seve%e,rname,'Variable is not strictly monotonous')
        error = .true.
        return
      endif
      taum1 = tau(i)
    enddo
  else
    call greg_message(seve%e,rname,'Variable is not strictly monotonous')
    error = .true.
    return
  endif
  !
  l = n-1
  !
  ! Compute first differences of TAU sequence and store in c2(.).
  ! Also, compute first divided difference of data and store in c3(.).
  !
  do  m=2,n
    c2(m) = tau(m) - tau(m-1)
    c3(m) = (c0(m) - c0(m-1))/c2(m)
  enddo
  !
  ! Construct first equation from the boundary condition, of the form
  !             c3(1)*S(1) + c2(1)*S(2) = c1(1)
  !
  if (ibcbeg-1)                     11,15,16
11 if (n .gt. 2)                     goto 12
  !
  ! No condition at left end and N = 2.
  c3(1) = 1.d0
  c2(1) = 1.d0
  c1(1) = 2.d0*c3(2)
  goto 25
  !
  ! Not-a-knot condition at left end and N .GT. 2.
12 c3(1) = c2(3)
  c2(1) = c2(2) + c2(3)
  c1(1) = ((c2(2)+2.d0*c2(1))*c3(2)*c2(3)+c2(2)**2*c3(3))/c2(1)
  goto 19
  !
  ! Slope prescribed at left end.
15 c3(1) = 1.d0
  c2(1) = 0.d0
  goto 18
  !
  ! Second derivative prescribed at left end.
16 c3(1) = 2.d0
  c2(1) = 1.d0
  c1(1) = 3.d0*c3(2) - c2(2)/2.d0*c1(1)
18 if (n.eq.2)  goto 25
  !
  ! If there are interior knots, generate the corresponding equations and
  ! carry out the forward pass of gauss elimination, after which the M-th
  ! equation reads    c3(M)*S(M) + c2(M)*S(M+1) = c1(M).
  !
19 continue
  do m=2,l
    g = -c2(m+1)/c3(m-1)
    c1(m) = g*c1(m-1) + 3.d0*(c2(m)*c3(m+1)+c2(m+1)*c3(m))
    c3(m) = g*c2(m-1) + 2.d0*(c2(m) + c2(m+1))
  enddo
  !
  ! Construct last equation from the second boundary condition, of the form
  !           (-G*c3(N-1))*S(N-1) + c3(N)*S(N) = c1(N)
  ! If slope is prescribed at right end, one can go directly to back
  ! substitution, since C array happens to be set up just right for it
  ! at this point.
  !
  if (ibcend-1)                     21,30,24
21 if (n .eq. 3 .and. ibcbeg .eq. 0) goto 22
  !
  ! not-a-knot and N.GE.3, and either N.GT.3 or also not-a-knot at
  ! left endpoint.
  !
  g = c2(l) + c2(n)
  c1(n) = ((c2(n)+2.d0*g)*c3(n)*c2(l) + c2(n)**2*(c0(l)-c0(n-2))/c2(l))/g
  g = -g/c3(l)
  c3(n) = c2(l)
  goto 29
  !
  ! Either (N=3 and not-a-knot also at left) or (N=2 and not not-a-knot
  ! at left endpoint).
  !
22 c1(n) = 2.d0*c3(n)
  c3(n) = 1.d0
  goto 28
  !
  ! Second derivative prescribed at right endpoint.
24 c1(n) = 3.d0*c3(n) + c2(n)/2.d0*c1(n)
  c3(n) = 2.d0
  goto 28
25 if (ibcend-1)                     26,30,24
26 if (ibcbeg .gt. 0)                goto 22
  !
  ! not-a-knot at right endpoint and at left endpoint and N=2.
  c1(n) = c3(n)
  goto 30
28 g = -1.d0/c3(l)
  !
  ! Complete forward pass of GAUSS elimination.
29 c3(n) = g*c2(l) + c3(n)
  c1(n) = (g*c1(l) + c1(n))/c3(n)
  !
  ! Carry out back substitution
30 continue
  do j=l,1,-1
    c1(j) = (c1(j) - c2(j)*c1(j+1))/c3(j)
  enddo
  !
  ! Generate cubic coefficients in each interval, i.e., the derivatives
  ! at its left endpoint, from value and slope at its endpoints.
  !
  do i=2,n
    dtau = c2(i)
    divdf1 = (c0(i) - c0(i-1))/dtau
    divdf3 = c1(i-1) + c1(i) - 2.d0*divdf1
    c2(i-1) = 2.d0*(divdf1 - c1(i-1) - divdf3)/dtau
    c3(i-1) = (divdf3/dtau)*(6.d0/dtau)
  enddo
  !
  ! Compute in addition c2(N). set c3(N) to 0.
  c2(n) = c2(l) + c3(l)*dtau
  c3(n) = 0.d0
end subroutine cubspl8

subroutine syncDataNew(ifb,nfb,subscanRange,error)
!
! Called by subroutines getfits and getfitsNew.
! Interpolates antenna and subreflector data at backend timestamp
! (linear between preceeding and following antenna and subreflector dump).
! Results are written into Mira structures DATA(ifb) (where ifb is the frontend-
! backend number).
!
! Unlike subroutine syncData, does not apply any timing check.
!

  use mira
  use gildas_def

  implicit none

  integer :: ifb, nfb
  integer, dimension(2) :: subscanRange 
  logical :: error

  integer :: i, ibd, ier, ilo, isub, iup, i1, i2, i3, i4, j, k, l,          &
     &       locate, nbd, nchan, newchan, nfebe, nphases, npix 
  integer :: ndumpAntenna, ndumpAntennaNew, ndumpAntennaFast,               &
     &       ndumpAntennaFastNew, ndumpBackend, ndumpBackendNew,            &
     &       ndumpCryo, ndumpFrontend, ndumpSubref, ndumpSubrefNew
  real*4  :: meanCounts
  real*8  :: dTime1, dTime2, gainMax1, gainMax2, slope, trackingCutoff
 
  real*8, dimension(nsubscan)       :: subScanEnd, subScanStart

  integer(kind=address_length),dimension(9) :: desc
  integer, dimension(:), allocatable   :: indxFast, indxSlow, indxSubref
  character(len=20)                    :: tmpScanType, tmpSwitchMode
  character(len=32)                    :: tmpFrontend
  logical                              :: doShift, exist, scanStart, trackFlag
  logical, dimension(:,:), allocatable :: mask,tmpMask
  logical, dimension(:), allocatable   :: maskFSW,tmpMaskFSW
  logical, dimension(:), allocatable   :: subScanFastMask, subScanMask,    &
      &                                   subScanSubrefMask

!
!
!
  trackingCutoff = raw(1)%antenna(ifb)%trackingError
  ndumpBackend = size(dt(ifb)%data%mjd)
  ndumpAntenna = size(mnt(ifb)%data%lst,1)
  ndumpAntennaFast = size(mnt(ifb)%data%encoder_az_el,1)
  ndumpSubref = size(mnt(ifb)%data%focus_x_y_z,1)
  ndumpFrontend = size(mnt(ifb)%data%tamb_p_humid,1)
!
  nfebe = scan%header%nfebe
  nbd = febe(ifb)%header%febeband
  nchan = ar(ifb)%header(1)%channels 
  newchan = dt(ifb)%header%channels
  npix = febe(ifb)%header%febefeed
  nphases = febe(ifb)%header%nphases
!
!
!
  do isub = 1, nsubscan
     subScanStart(isub) = raw(isub)%antenna(ifb)%subScanStart
     subScanEnd(isub)   = raw(isub)%antenna(ifb)%subScanEnd
  enddo
!
  do i = 1, ndumpAntenna
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%mjd(i).ge.subScanStart(i1).and. &
            mnt(ifb)%data%mjd(i).le.subScanEnd(i1)) then
            mnt(ifb)%data%subScan(i) = isub
            exit
        else
            cycle
        endif
     enddo
  enddo
!
  do i = 1, ndumpAntennaFast
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%encoder_az_el(i,3).ge.subScanStart(i1).and.    &
 &          mnt(ifb)%data%encoder_az_el(i,3).le.subScanEnd(i1)) then
           mnt(ifb)%data%subScanFast(i) = isub
           exit
        else
           cycle
        endif
     enddo
  enddo
!
  do i = 1, ndumpSubref
     do isub = 1, nsubscan
        i1 = isub-subscanRange(1)+1
        if (mnt(ifb)%data%focus_x_y_z(i,4).ge.subScanStart(i1).and.    &
 &          mnt(ifb)%data%focus_x_y_z(i,4).le.subScanEnd(i1)) then
           mnt(ifb)%data%subScanSubref(i) = isub
           exit
        else
           cycle
        endif
     enddo
  enddo
!
  tmpScanType = scan%header%scantype
  call sic_upper(tmpScanType)
  dt(ifb)%data%subScan(1:ndumpBackend) = 0
  do i = 1, ndumpBackend
     do isub = subscanRange(1), subscanRange(2)
        i1 = isub-subscanRange(1)+1 
        if (dt(ifb)%data%mjd(i)-dt(ifb)%data%integtim(i)*sec2day.ge.    &
 &         subScanStart(i1).and.dt(ifb)%data%mjd(i).le.subScanEnd(i1)) then
           dt(ifb)%data%subScan(i) = isub
           if (nphases.eq.1.and.tmpscantype.eq.'ONTHEFLYMAP') then
              do j=1, nbd
                 if (raw(i1)%antenna(j)%subscantype.eq.'track') then
                    ar(ifb)%data(j)%iswitch(i,1) = 'OFF'
                 else if (raw(i1)%antenna(j)%subscantype &
 &                        .eq.'onTheFly') then
                    ar(ifb)%data(j)%iswitch(i,1) = 'ON'
                 else
                    ar(ifb)%data(j)%iswitch(i,1) = 'NONE'
                 endif
              enddo
           endif
           exit
        else
           cycle
        endif
!
! The above IF condition may have to be relaxed. Here I only accept backend
! dumps during which no subScanStart or subScanEnd timestamps occur.
!

     enddo
  enddo
  do i = 2, ndumpBackend
     if (dt(ifb)%data%mjd(i).eq.dt(ifb)%data%mjd(i-1)) &
 &      dt(ifb)%data%subscan(i) = 0
  enddo
!
  if (allocated(indxSlow)) deallocate(indxSlow,stat=ier)
  allocate(indxSlow(ndumpAntenna),stat=ier)
  call indexx(ndumpAntenna,mnt(ifb)%data%mjd,indxSlow)
!
  ndumpAntennaNew = 1 
  do i = 1, ndumpAntenna-1
     if (mnt(ifb)%data%mjd(indxSlow(i+1)).ne.                     &
 &       mnt(ifb)%data%mjd(indxSlow(i)))                          &
 &      ndumpAntennaNew = ndumpAntennaNew+1
  enddo
!
  if (allocated(indxFast)) deallocate(indxFast,stat=ier)
  allocate(indxFast(ndumpAntennaFast),stat=ier)
  call indexx(ndumpAntennaFast,mnt(ifb)%data%encoder_az_el(:,3),indxFast)
!
  ndumpAntennaFastNew = 1 
  do i = 1, ndumpAntennaFast-1
     if (mnt(ifb)%data%encoder_az_el(indxFast(i+1),3).ne.          &
         mnt(ifb)%data%encoder_az_el(indxFast(i),3))               &
 &      ndumpAntennaFastNew = ndumpAntennaFastNew+1
  enddo
!
  if (allocated(indxSubref)) deallocate(indxSubref,stat=ier)
  allocate(indxSubref(ndumpSubref),stat=ier)
  call indexx(ndumpSubref,mnt(ifb)%data%focus_x_y_z(:,4),indxSubref)
!
  ndumpSubrefNew = 1
  do i = 1, ndumpSubref-1
     if (mnt(ifb)%data%focus_x_y_z(indxSubref(i+1),4).ne.           &
 &       mnt(ifb)%data%focus_x_y_z(indxSubref(i),4))                &
 &      ndumpSubrefNew = ndumpSubrefNew+1
  enddo
!
  ndumpBackendNew = 0
  do i = 1, ndumpBackend
     if (dt(ifb)%data%subscan(i).ne.0)                   &
 &      ndumpBackendNew = ndumpBackendNew+1
  enddo
!
!
!
  if (ifb.eq.1) allocate(monBuf(nfebe))
  monBuf(ifb)%header = mnt(ifb)%header
!
  allocate(monBuf(ifb)%data%subScan(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%subScanFast(ndumpAntennaFastNew),      &
     &     monBuf(ifb)%data%subScanSubref(ndumpSubrefNew),         &
     &     monBuf(ifb)%data%mjd(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%lst(ndumpAntennaNew),                  &
     &     monBuf(ifb)%data%encoder_az_el(ndumpAntennaFastNew,3),  &
     &     monBuf(ifb)%data%tracking_az_el(ndumpAntennaFastNew,2), &
     &     monBuf(ifb)%data%longoff(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%latoff(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%baslong(ndumpAntennaNew),              &
     &     monBuf(ifb)%data%baslat(ndumpAntennaNew),               &
     &     monBuf(ifb)%data%parangle(ndumpAntennaNew),             &
     &     monBuf(ifb)%data%antenna_az_el(2),                      &
     &     monBuf(ifb)%data%tamb_p_humid(ndumpFrontend,3),         &
     &     monBuf(ifb)%data%wind_dir_vavg_vmax(ndumpFrontend,3),   &
     &     monBuf(ifb)%data%thotcold(ndumpFrontend,2),             &
     &     monBuf(ifb)%data%refractio(ndumpFrontend),              &
     &     monBuf(ifb)%data%focus_x_y_z(ndumpSubrefNew,4),         &
     &     monBuf(ifb)%data%dfocus_x_y_z(ndumpSubrefNew,3),        &
     &     monBuf(ifb)%data%phi_x_y_z(ndumpSubrefNew,3),           &
     &     monBuf(ifb)%data%dphi_x_y_z(ndumpSubrefNew,3),          &
     &     stat = ier)
  allocate(subScanSubrefMask(ndumpSubrefNew),                 &
     &     subScanMask(ndumpAntenna),                         &
     &     subScanFastMask(ndumpAntennaFastNew),stat = ier)
  monBuf(ifb)%data%antenna_az_el = mnt(ifb)%data%antenna_az_el
  monBuf(ifb)%data%tamb_p_humid = mnt(ifb)%data%tamb_p_humid
  monBuf(ifb)%data%wind_dir_vavg_vmax = mnt(ifb)%data%wind_dir_vavg_vmax
  monBuf(ifb)%data%thotcold  = mnt(ifb)%data%thotcold
!
  ilo = 1
  i1  = indxSlow(1)
  monBuf(ifb)%data%subScan(1) = mnt(ifb)%data%subScan(i1)
  monBuf(ifb)%data%mjd(1) = mnt(ifb)%data%mjd(i1)
  monBuf(ifb)%data%lst(1) = mnt(ifb)%data%lst(i1)
  monBuf(ifb)%data%longoff(1) = mnt(ifb)%data%longoff(i1)
  monBuf(ifb)%data%latoff(1) =  mnt(ifb)%data%latoff(i1)
  monBuf(ifb)%data%baslong(1) = mnt(ifb)%data%baslong(i1)
  monBuf(ifb)%data%baslat(1) = mnt(ifb)%data%baslat(i1)
  monBuf(ifb)%data%parangle(1) = mnt(ifb)%data%parangle(i1)
  do i = 1, ndumpAntenna-1
     i1 = indxSlow(i)
     i2 = indxSlow(i+1)

     if (mnt(ifb)%data%mjd(i2).ne.mnt(ifb)%data%mjd(i1)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScan(ilo) = mnt(ifb)%data%subScan(i2)
        monBuf(ifb)%data%mjd(ilo) = mnt(ifb)%data%mjd(i2)
        monBuf(ifb)%data%lst(ilo) = mnt(ifb)%data%lst(i2)
        monBuf(ifb)%data%longoff(ilo) = mnt(ifb)%data%longoff(i2)
        monBuf(ifb)%data%latoff(ilo) =  mnt(ifb)%data%latoff(i2)
        monBuf(ifb)%data%baslong(ilo) = mnt(ifb)%data%baslong(i2)
        monBuf(ifb)%data%baslat(ilo) = mnt(ifb)%data%baslat(i2)
        monBuf(ifb)%data%parangle(ilo) = mnt(ifb)%data%parangle(i2)
     endif
  enddo
!
  ilo = 1
  i1 = indxFast(1)
  monBuf(ifb)%data%subScanFast(1) = mnt(ifb)%data%subScanFast(i1)
  monBuf(ifb)%data%encoder_az_el(1,1:3) = mnt(ifb)%data%encoder_az_el(i1,1:3)
  monBuf(ifb)%data%tracking_az_el(1,1:2) = mnt(ifb)%data%tracking_az_el(i1,1:2)
  do i = 1, ndumpAntennaFast-1
     i1 = indxFast(i)
     i2 = indxFast(i+1)
     if (mnt(ifb)%data%encoder_az_el(i2,3).ne.                          &
 &       mnt(ifb)%data%encoder_az_el(i1,3)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScanFast(ilo) = mnt(ifb)%data%subScanFast(i2)
        monBuf(ifb)%data%encoder_az_el(ilo,1:3)                          &
 &      = mnt(ifb)%data%encoder_az_el(i2,1:3)
        monBuf(ifb)%data%tracking_az_el(ilo,1:2)                         &
 &      = mnt(ifb)%data%tracking_az_el(i2,1:2)
     endif
  enddo
!
  i1 = indxSubref(1)
  monBuf(ifb)%data%subScanSubref(1)   = mnt(ifb)%data%subScanSubref(i1)
  monBuf(ifb)%data%focus_x_y_z(1,1:4) = mnt(ifb)%data%focus_x_y_z(i1,1:4)
  monBuf(ifb)%data%dfocus_x_y_z(1,1:3)= mnt(ifb)%data%dfocus_x_y_z(i1,1:3)
  monBuf(ifb)%data%phi_x_y_z(1,1:3)   = mnt(ifb)%data%phi_x_y_z(i1,1:3)
  monBuf(ifb)%data%dphi_x_y_z(1,1:3)  = mnt(ifb)%data%dphi_x_y_z(i1,1:3)
  ilo = 1
  do i = 1, ndumpSubref-1
     i1 = indxSubref(i)
     i2 = indxSubref(i+1)
     if (mnt(ifb)%data%focus_x_y_z(i2,4).ne.mnt(ifb)%data%focus_x_y_z(i1,4)) then
        ilo = ilo+1
        monBuf(ifb)%data%subScanSubref(ilo)   = mnt(ifb)%data%subScanSubref(i2)
        monBuf(ifb)%data%focus_x_y_z(ilo,1:4) = mnt(ifb)%data%focus_x_y_z(i2,1:4)
        monBuf(ifb)%data%dfocus_x_y_z(ilo,1:3)= mnt(ifb)%data%dfocus_x_y_z(i2,1:3)
        monBuf(ifb)%data%phi_x_y_z(ilo,1:3)   = mnt(ifb)%data%phi_x_y_z(i2,1:3)
        monBuf(ifb)%data%dphi_x_y_z(ilo,1:3)  = mnt(ifb)%data%dphi_x_y_z(i2,1:3)
     endif
  enddo
!
  ndumpAntenna = ndumpAntennaNew
  ndumpAntennaFast = ndumpAntennaFastNew
  ndumpSubref = ndumpSubrefNew
!
!
!
  if (ifb.eq.1) allocate(dataBuf(nfebe),stat=ier)
  dataBuf(ifb)%header = dt(ifb)%header
  allocate(dataBuf(ifb)%data%subscan(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mjd(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%integnum(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%nints(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%lst(ndumpBackendNew),                    &
  &        dataBuf(ifb)%data%midtime(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%integtim(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%longoff(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%latoff(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%azimuth(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%elevatio(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslong(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%cbaslat(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslong(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%baslat(ndumpBackendNew),                 &
  &        dataBuf(ifb)%data%parangle(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%pc_11(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_12(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_21(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%pc_22(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%mcrval1(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mcrval2(ndumpBackendNew),                &
  &        dataBuf(ifb)%data%mlonpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%mlatpole(ndumpBackendNew),               &
  &        dataBuf(ifb)%data%dfocus_x_y_z(ndumpBackendNew,3),         &
  &        dataBuf(ifb)%data%focus_x_y_z(ndumpBackendNew,3),          &
  &        dataBuf(ifb)%data%dphi_x_y_z(ndumpBackendNew,3),           &
  &        dataBuf(ifb)%data%phi_x_y_z(ndumpBackendNew,3),            &
  &        dataBuf(ifb)%data%otfdata(npix,newchan,ndumpBackendNew),   &    
  &        dataBuf(ifb)%data%rdata(npix,newchan),                     &
  &        dataBuf(ifb)%data%cr4K1(ndumpBackendNew),                  &
  &        dataBuf(ifb)%data%cr4K2(ndumpBackendNew),                  &
  &        stat = ier)
  if (ifb.eq.1) allocate(arrayBuf(nfebe),stat=ier)
  allocate(arrayBuf(ifb)%data(nbd),arrayBuf(ifb)%header(nbd),stat=ier)
  arrayBuf(ifb)%header(1:nbd) = ar(ifb)%header(1:nbd)
  do i = 1, nbd
     allocate(arrayBuf(ifb)%data(i)%data(npix,nchan,ndumpBackendNew,nphases), &
  &           arrayBuf(ifb)%data(i)%iswitch(ndumpBackendNew,nphases),         &
  &           arrayBuf(ifb)%data(i)%mjd(ndumpBackendNew*nphases),             &
  &           arrayBuf(ifb)%data(i)%integtim(ndumpBackendNew*nphases),        &
  &           stat=ier)
  enddo
  !
  ilo = 0
  do i = 1, ndumpBackend
     if (dt(ifb)%data%subscan(i).ne.0) then
        ilo = ilo+1
        dataBuf(ifb)%data%subscan(ilo) = dt(ifb)%data%subscan(i)
        dataBuf(ifb)%data%mjd(ilo) = dt(ifb)%data%mjd(i)
        dataBuf(ifb)%data%integnum(ilo) = ilo
        dataBuf(ifb)%data%nints(ilo) = dt(ifb)%data%nints(i)
        dataBuf(ifb)%data%lst(ilo) = dt(ifb)%data%lst(i)
        dataBuf(ifb)%data%midtime(ilo) = dt(ifb)%data%midtime(i)
        dataBuf(ifb)%data%integtim(ilo) = dt(ifb)%data%integtim(i)
        dataBuf(ifb)%data%longoff(ilo) = dt(ifb)%data%longoff(i)
        dataBuf(ifb)%data%latoff(ilo) = dt(ifb)%data%latoff(i)
        dataBuf(ifb)%data%azimuth(ilo) = dt(ifb)%data%azimuth(i)
        dataBuf(ifb)%data%elevatio(ilo) = dt(ifb)%data%elevatio(i)
        dataBuf(ifb)%data%cbaslong(ilo) = dt(ifb)%data%cbaslong(i)
        dataBuf(ifb)%data%cbaslat(ilo) = dt(ifb)%data%cbaslat(i)
        dataBuf(ifb)%data%baslong(ilo) = dt(ifb)%data%baslong(i)
        dataBuf(ifb)%data%baslat(ilo) = dt(ifb)%data%baslat(i)
        dataBuf(ifb)%data%parangle(ilo) = dt(ifb)%data%parangle(i)
        dataBuf(ifb)%data%pc_11(ilo) = dt(ifb)%data%pc_11(i)
        dataBuf(ifb)%data%pc_12(ilo) = dt(ifb)%data%pc_12(i)
        dataBuf(ifb)%data%pc_21(ilo) = dt(ifb)%data%pc_21(i)
        dataBuf(ifb)%data%pc_22(ilo) = dt(ifb)%data%pc_22(i)
        dataBuf(ifb)%data%cr4K1(ilo) = dt(ifb)%data%cr4K1(i)
        dataBuf(ifb)%data%cr4K2(ilo) = dt(ifb)%data%cr4K2(i)
        dataBuf(ifb)%data%mcrval1(ilo) = dt(ifb)%data%mcrval1(i)
        dataBuf(ifb)%data%mcrval2(ilo) = dt(ifb)%data%mcrval2(i)
        dataBuf(ifb)%data%mlonpole(ilo) = dt(ifb)%data%mlonpole(i)
        dataBuf(ifb)%data%mlatpole(ilo) = dt(ifb)%data%mlatpole(i)
        dataBuf(ifb)%data%otfdata(npix,1:newchan,ilo)                 &
 &      = dt(ifb)%data%otfdata(npix,1:newchan,i)
        dataBuf(ifb)%data%rdata(npix,1:newchan)                       &
 &      = dt(ifb)%data%rdata(npix,1:newchan) 
        i1 = (ilo-1)*nphases+1
        i2 = ilo*nphases
        i3 = (i-1)*nphases+1
        i4 = i*nphases
        do j = 1, nbd
           arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,ilo,1:nphases)    &
 &         = ar(ifb)%data(j)%data(1:npix,1:nchan,i,1:nphases)
           arrayBuf(ifb)%data(j)%iswitch(ilo,1:nphases)     &
 &         = ar(ifb)%data(j)%iswitch(i,1:nphases)
           arrayBuf(ifb)%data(j)%mjd(i1:i2) = ar(ifb)%data(j)%mjd(i3:i4)
           arrayBuf(ifb)%data(j)%integtim(i1:i2) = ar(ifb)%data(j)%integtim(i3:i4)
        enddo
     endif
  enddo

  ndumpBackend = ndumpBackendNew
! 
! now interpolate monitor data at sampling of backend data
!
  do i = 1, ndumpBackend
     
     ilo = locate(monBuf(ifb)%data%mjd,dataBuf(ifb)%data%midtime(i),ndumpAntenna)

     extrapolateSlowTrace: if (.not.traceExtrapolation.and. &
                               (ilo.eq.0.or.ilo.eq.ndumpAntenna)) then
        dataBuf(ifb)%data%lst(i)      = 0.d0
        dataBuf(ifb)%data%longoff(i)  = 0.d0
        dataBuf(ifb)%data%latoff(i)   = 0.d0
        dataBuf(ifb)%data%baslong(i)  = 0.d0
        dataBuf(ifb)%data%baslat(i)   = 0.d0
        dataBuf(ifb)%data%parangle(i) = 0.d0
        do ibd=1,nbd
           arrayBuf(ifb)%data(ibd)%data(1:npix,1:nchan,i,1:nphases) = blankingRaw
        enddo
     else
        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpAntenna) then
           ilo = ndumpAntenna-1
        endif
        iup = ilo+1

        dTime1 = monBuf(ifb)%data%mjd(iup)-monBuf(ifb)%data%mjd(ilo)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%mjd(ilo)

        slope = (monBuf(ifb)%data%lst(iup)-monBuf(ifb)%data%lst(ilo))/dTime1 
        dataBuf(ifb)%data%lst(i) = monBuf(ifb)%data%lst(ilo)+dTime2*slope
 
        slope = (monBuf(ifb)%data%longoff(iup)-monBuf(ifb)%data%longoff(ilo))/dTime1 
        dataBuf(ifb)%data%longoff(i) = monBuf(ifb)%data%longoff(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%latoff(iup)-monBuf(ifb)%data%latoff(ilo))/dTime1 
        dataBuf(ifb)%data%latoff(i) = monBuf(ifb)%data%latoff(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%baslong(iup)-monBuf(ifb)%data%baslong(ilo))/dTime1 
        dataBuf(ifb)%data%baslong(i) = monBuf(ifb)%data%baslong(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%baslat(iup)-monBuf(ifb)%data%baslat(ilo))/dTime1 
        dataBuf(ifb)%data%baslat(i) = monBuf(ifb)%data%baslat(ilo)+dTime2*slope

        slope = (monBuf(ifb)%data%parangle(iup)-monBuf(ifb)%data%parangle(ilo))/dTime1 
        dataBuf(ifb)%data%parangle(i) = monBuf(ifb)%data%parangle(ilo)+dTime2*slope

     endif extrapolateSlowTrace

     ilo = locate(monBuf(ifb)%data%encoder_az_el(1:ndumpAntennaFast,3),          &
   &              dataBuf(ifb)%data%midtime(i),ndumpAntennaFast)

     extrapolateFastTrace: if (.not.traceExtrapolation.and. &
                               (ilo.eq.0.or.ilo.eq.ndumpAntennaFast)) then

        dataBuf(ifb)%data%azimuth(i)  = 0.d0
        dataBuf(ifb)%data%elevatio(i) = 0.d0
        do ibd=1,nbd
           arrayBuf(ifb)%data(ibd)%data(1:npix,1:nchan,i,1:nphases) = blankingRaw
        enddo

     else

        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpAntennaFast) then
           ilo = ndumpAntennaFast-1
        endif

        dTime1 = monBuf(ifb)%data%encoder_az_el(iup,3)                            &
 &               -monBuf(ifb)%data%encoder_az_el(ilo,3)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%encoder_az_el(ilo,3)

        slope = (monBuf(ifb)%data%encoder_az_el(iup,1)                            &
 &              -monBuf(ifb)%data%encoder_az_el(ilo,1))                           &
 &              /dTime1 
        dataBuf(ifb)%data%azimuth(i) = monBuf(ifb)%data%encoder_az_el(ilo,1)+dTime2*slope

        slope = (monBuf(ifb)%data%encoder_az_el(iup,2)                            &
 &               -monBuf(ifb)%data%encoder_az_el(ilo,2))                          &
 &             /dTime1 
        dataBuf(ifb)%data%elevatio(i) = monBuf(ifb)%data%encoder_az_el(ilo,2)     &
 &                                   +dTime2*slope


     endif extrapolateFastTrace

     if (associated(cryo)) then
        ndumpCryo = size(cryo%mjd)
        if (ndumpCryo.gt.1) then
           ilo = locate(                                                     &
   &                    cryo%mjd(1:ndumpCryo),dataBuf(ifb)%data%midtime(i),     &
   &                    ndumpCryo)
           if (ilo.eq.0) ilo = 1
           if (ilo.lt.ndumpCryo) then
               iup = ilo+1
           else
               iup = ilo
           endif
        else
           ilo = 1
           iup = 1
        endif
        if (ilo.eq.iup) then
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)
        else
           dTime2 = dataBuf(ifb)%data%midtime(i)-cryo%mjd(ilo)
           dTime1 = cryo%mjd(iup)-cryo%mjd(ilo)
           slope = (cryo%cr4K1(iup)-cryo%cr4K1(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K1(i) = cryo%cr4K1(ilo)+dTime2*slope
           slope = (cryo%cr4K2(iup)-cryo%cr4K2(ilo))/dTime1 
           dataBuf(ifb)%data%cr4K2(i) = cryo%cr4K2(ilo)+dTime2*slope
        endif
     endif

     trackFlag = .false.
     if (abs(monBuf(ifb)%data%antenna_az_el(1)-130.5).lt.1.0.and.                &
   &     mod(3.6d+2,monBuf(ifb)%data%antenna_az_el(2)).lt.1.0) then
        trackFlag = .false.  ! use data with crazy tracking errors if antenna in stow position
     else if (abs(monBuf(ifb)%data%tracking_az_el(ilo,1)).gt.trackingCutoff.or.  &
   &     abs(monBuf(ifb)%data%tracking_az_el(ilo,2)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,1)).gt.trackingCutoff.or.       &
   &     abs(monBuf(ifb)%data%tracking_az_el(iup,2)).gt.trackingCutoff) then
         do j = 1, nbd
            i1 = (i-1)*nphases+1
            i2 = i*nphases
            arrayBuf(ifb)%data(j)%data(1:npix,1:nchan,i1:i2,1:nphases) =blankingRaw
            trackFlag = .true.
         enddo
     endif
     if (trackFlag) call gagout('W-SYNC: Data flagged due to large tracking errors.')
     if (ndumpSubref.gt.1) then 
        ilo = locate(monBuf(ifb)%data%focus_x_y_z(1:ndumpSubref,4),              &
   &                 dataBuf(ifb)%data%midtime(i),ndumpSubref)

        if (ilo.eq.0) then
           ilo = 1
        else if (ilo.eq.ndumpSubref) then
           ilo = ndumpSubref-1
        endif

        iup = ilo+1

        if (monBuf(ifb)%data%subScanSubref(ilo)                                 &
   &        .ne.monBuf(ifb)%data%subScanSubref(iup)) then
           if (dataBuf(ifb)%data%subscan(i).eq.monBuf(ifb)%data%subScanSubref(ilo)) &
   &       then
              ilo = ilo-1
              iup = iup-1
           else
              ilo = ilo+1
              iup = iup+1
           endif
        endif

        dTime1 = monBuf(ifb)%data%focus_x_y_z(iup,4)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,4)
        dTime2 = dataBuf(ifb)%data%midtime(i)-monBuf(ifb)%data%focus_x_y_z(ilo,4)

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,1)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,1))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,1) = monBuf(ifb)%data%focus_x_y_z(ilo,1)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,2)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,2))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,2) = monBuf(ifb)%data%focus_x_y_z(ilo,2)  &
   &                                      +dTime2*slope

        slope = (monBuf(ifb)%data%focus_x_y_z(iup,3)                           &
   &             -monBuf(ifb)%data%focus_x_y_z(ilo,3))                         &
   &            /dTime1 
        dataBuf(ifb)%data%focus_x_y_z(i,3) = monBuf(ifb)%data%focus_x_y_z(ilo,3)  &
   &                                      +dTime2*slope

        dataBuf(ifb)%data%dfocus_x_y_z(i,1)=monBuf(ifb)%data%dfocus_x_y_z(ilo,1)
        dataBuf(ifb)%data%dfocus_x_y_z(i,2)=monBuf(ifb)%data%dfocus_x_y_z(ilo,2)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3)=monBuf(ifb)%data%dfocus_x_y_z(ilo,3)

        slope = (monBuf(ifb)%data%phi_x_y_z(iup,3)                            &
   &             -monBuf(ifb)%data%phi_x_y_z(ilo,3))                          &
   &            /dTime1 
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(ilo,3)     &
   &                                    +dTime2*slope
     else
        dataBuf(ifb)%data%focus_x_y_z(i,1:3)=monBuf(ifb)%data%focus_x_y_z(1,1:3)
        dataBuf(ifb)%data%dfocus_x_y_z(i,3) = monBuf(ifb)%data%dfocus_x_y_z(1,3)
        dataBuf(ifb)%data%phi_x_y_z(i,3) = monBuf(ifb)%data%phi_x_y_z(1,3)
     endif
  enddo

  tmpSwitchMode = febe(ifb)%header%swtchmod
  call sic_upper(tmpSwitchMode)

  if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').eq.0) then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw

     if (allocated(mask)) deallocate(mask,stat=ier)
     allocate(mask(ndumpBackend,nphases),stat=ier)
     if (allocated(tmpMask)) deallocate(tmpMask,stat=ier)
     allocate(tmpMask(ndumpBackend,nphases),stat=ier)

     do i = subscanRange(1), subscanRange(2)
        i1 = i-subscanRange(1)+1
        do j = 1, nphases
          mask(1:ndumpBackend,j) = dataBuf(ifb)%data%subscan.eq.i
        enddo
        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMask = mask.and.                                        &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases)&
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1:nphases),&
   &                      tmpMask)/count(tmpMask)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo

 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif

  else if (index(tmpScanType,'CAL').ne.0.and.index(tmpSwitchMode,'FREQ').ne.0) &
 &then

     gn(ifb)%psky(:,:,:) = blankingRaw
     gn(ifb)%phot(:,:,:) = blankingRaw
     gn(ifb)%pcold(:,:,:) = blankingRaw
     gn(ifb+nfb)%psky(:,:,:) = blankingRaw
     gn(ifb+nfb)%phot(:,:,:) = blankingRaw
     gn(ifb+nfb)%pcold(:,:,:) = blankingRaw

     if (allocated(maskFSW)) deallocate(maskFSW,stat=ier)
     allocate(maskFSW(ndumpBackend),stat=ier)
     if (allocated(tmpMaskFSW)) deallocate(tmpMaskFSW,stat=ier)
     allocate(tmpMaskFSW(ndumpBackend),stat=ier)

     do i = subscanRange(1), subscanRange(2)
        i1 = i-subscanRange(1)+1
        maskFSW(1:ndumpBackend) = dataBuf(ifb)%data%subscan.eq.i

        if (index(raw(i1)%antenna(ifb)%subScanType,'Sky').ne.0.or.              &
   &        index(raw(i1)%subRef(ifb)%subScanType,'Sky').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan 
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%psky(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%psky(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%psky(j,k,:))/nchan
                 where(gn(ifb)%psky(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%psky(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%psky(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%psky(j,k,:))/nchan
                 where(gn(ifb+nfb)%psky(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%psky(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%psky(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Ambient').ne.0.or.     &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Ambient').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%phot(j,k,l)                                        &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%phot(j,k,l)                                    &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%phot(j,k,:))/nchan
                 where(gn(ifb)%phot(j,k,:).lt.meanCounts/badLevel.or.          &
   &                   gn(ifb)%phot(j,k,:).gt.meanCounts*badLevel)             &
   &                   gn(ifb)%phot(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%phot(j,k,:))/nchan
                 where(gn(ifb+nfb)%phot(j,k,:).lt.meanCounts/badLevel.or.      &
   &                   gn(ifb+nfb)%phot(j,k,:).gt.meanCounts*badLevel)         &
   &                   gn(ifb+nfb)%phot(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Cold').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Cold').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pcold(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pcold(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = sum(gn(ifb)%pcold(j,k,:))/nchan
                 where(gn(ifb)%pcold(j,k,:).lt.meanCounts/badLevel.or.         &
   &                   gn(ifb)%pcold(j,k,:).gt.meanCounts*badLevel)            &
   &                   gn(ifb)%pcold(j,k,:) = blankingRaw
                 meanCounts = sum(gn(ifb+nfb)%pcold(j,k,:))/nchan
                 where(gn(ifb+nfb)%pcold(j,k,:).lt.meanCounts/badLevel.or.     &
   &                   gn(ifb+nfb)%pcold(j,k,:).gt.meanCounts*badLevel)        &
   &                   gn(ifb+nfb)%pcold(j,k,:) = blankingRaw
              enddo
           enddo

        else if (index(raw(i1)%antenna(ifb)%subScanType,'Grid').ne.0.or.        &
   &             index(raw(i1)%subRef(ifb)%subScanType,'Grid').ne.0) then
           do j = 1, nbd 
              do k = 1, npix
                 do l = 1, nchan
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1)        &
   &                   .ne.blankingRaw
                    gn(ifb)%pgrid(j,k,l)                                       &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,1),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                    tmpMaskFSW = maskFSW.and.                                  &
   &                   arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2)        &
   &                   .ne.blankingRaw
                    gn(ifb+nfb)%pgrid(j,k,l)                                   &
   &                = sum(                                                     &
   &                  arrayBuf(ifb)%data(j)%data(k,l,1:ndumpBackend,2),        &
   &                      tmpMaskFSW)/count(tmpMaskFSW)
                 enddo
                 meanCounts = abs(sum(gn(ifb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.    &
   &                   abs(gn(ifb)%pgrid(j,k,:)).gt.meanCounts*badLevel)       &
   &                   gn(ifb)%pgrid(j,k,:) = blankingRaw
                 meanCounts = abs(sum(gn(ifb+nfb)%pgrid(j,k,:))/nchan)
                 where(abs(gn(ifb+nfb)%pgrid(j,k,:)).lt.meanCounts/badLevel.or.&
   &                   abs(gn(ifb+nfb)%pgrid(j,k,:)).gt.meanCounts*badLevel)   &
   &                   gn(ifb+nfb)%pgrid(j,k,:) = blankingRaw
              enddo
           enddo

        else 
           
           call gagout('W-SYNC: Subscan type unknown. Cannot attribute '       &
   &                   //' mean calibration counts.')

        endif

     enddo
 
     tmpFrontend = febe(ifb)%header%febe
     call sic_upper(tmpFrontend)
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        where (gn(ifb)%phot.ne.blankingRaw.and.gn(ifb)%psky.ne.blankingRaw)
           gn(ifb)%gainarray = gn(ifb)%phot-gn(ifb)%psky
        else where
           gn(ifb)%gainarray = blankingRaw 
        end where
     endif
     if (tmpFrontend(ipc:ipc).NE.'R'.and.tmpFrontend(ipc:ipc).ne.'I') then 
        
        where (gn(ifb+nfb)%phot.ne.blankingRaw.and.gn(ifb+nfb)%psky.ne.       &
  &            blankingRaw)
           gn(ifb+nfb)%gainarray = gn(ifb+nfb)%phot-gn(ifb+nfb)%psky
        else where
           gn(ifb+nfb)%gainarray = blankingRaw 
        end where
     endif
    
  endif

  if (index(tmpSwitchMode,'WOB').ne.0.and.index(tmpScantype,'POINT').eq.0) then
     do i = 1, ndumpBackend
        isub = dataBuf(ifb)%data%subscan(i)
        if (raw(isub)%antenna(ifb)%subScanXOff.lt.0) then
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 +0.5*scan%header%wobthrow
        else
          dataBuf(ifb)%data%longoff(i) = dataBuf(ifb)%data%longoff(i)      &
 &                                 -0.5*scan%header%wobthrow
        endif
     enddo
  endif

  deallocate(indxSlow,indxFast,indxSubref,stat=ier)

end subroutine syncDataNew

program grid_project
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Stand alone program
  !	Resample an input CLASS grid to a different projection system
  ! Subroutines
  !	(IMAGE),(SIC)
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: pname = 'GRID_PROJECT'
  ! Local
  real(8), parameter :: pi=3.141592653589793d0
  !
  character(len=80) :: namex,namey,center_1,center_2
  logical :: error
  integer :: nkey,sys_code,ier
  integer, parameter :: mvoc=8
  character(len=16) :: vocab(mvoc),key,system,proj
  type(gildas) :: x,y
  !
  integer :: n
  real(8) :: center(2),angle,aproj(3),bproj(3)
  real(8), allocatable :: xwork(:), ywork(:)
  !
  data vocab/'NONE','GNOMONIC','ORTHOGRAPHIC','AZIMUTHAL',   &
     &    'STEREOGRAPHIC','LAMBERT','AITOFF','RADIO'/
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_char('PROJECTION$',proj)
  call gildas_char('SYSTEM$',system)
  call gildas_char('CENTER_1$',center_1)
  call gildas_char('CENTER_2$',center_2)
  call gildas_dble('ANGLE$',angle,1)
  call gildas_close
  !
   ! Input file
  call gildas_null(y)
  y%loca%read = .false.
  y%gil%form = fmt_r4
  y%gil%ndim = 2 ! This is a table in fact
  call gdf_read_gildas(y,namey,'.tab',error,data=.true.)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  ! Now define output
  call sic_parsef(namex,x%file,' ','.tab')
  if (proj.ne.'UNCHANGED') then
    call sic_upper(proj)
    n = len_trim(proj)
    if (n.ne.0) then
      call sic_ambigs('PROJECTION',proj,key,nkey,vocab,mvoc,error)
      if (error) then
        write(6,1000)  'F-'//pname//',  Invalid projection system'
        goto 100
      endif
      x%gil%ptyp = nkey-1
    endif
  endif
  !
  ! Coordinate system
  call get_conv_code(y%char%syst,system,sys_code,error)
  if (error)  goto 100
  if (sys_code.ne.0) then
    x%char%syst = system
    write(6,1000)  'E-'//pname//',  System change not yet supported'
    goto 100
  endif
  !
  if (x%char%syst.eq.'EQUATORIAL' .or. x%char%syst.eq.'ICRS') then
    call sic_decode(center_1,center(1),24,error)
  else
    call sic_decode(center_1,center(1),360,error)
  endif
  if (error) goto 101
  call sic_decode(center_2,center(2),360,error)
  if (error) goto 101
  x%gil%a0 = center(1)
  x%gil%d0 = center(2)
  if (x%gil%ptyp.eq.p_radio .and. angle.ne.0.0) then
    write(6,1000)  'F-'//pname//',  Angle ignored in Radio projection'
    goto 100
  elseif (x%gil%ptyp.eq.p_aitoff .and. angle.ne.0.0) then
    write(6,1000)  'F-'//pname//',  Angle ignored in Aitoff projection'
    goto 100
  endif
  x%gil%pang = angle*pi/180.0d0
  !
  ! Create output image
  call gdf_create_image(x,error)
  if (error) then
    write(6,1000) 'F-'//pname//',  Cannot create X file'
    write(6,1000) x%file
    goto 100
  endif
  !
  ! Get some work space for X,Y
  allocate (xwork(x%gil%dim(2)),ywork(x%gil%dim(2)), &
    & x%r2d(x%gil%dim(1), x%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 100
  !
  x%r2d = y%r2d
  aproj = [y%gil%a0,y%gil%d0,y%gil%pang]
  bproj = [x%gil%a0,x%gil%d0,x%gil%pang]
  call regrid (y%r2d,y%gil%dim(1),y%gil%dim(2),   &
     &    y%gil%ptyp,aproj,x%r2d,x%gil%ptyp,bproj,   &
     &    sys_code,xwork,ywork,1,2)
  call gdf_write_data(x,x%r2d,error)
  !
  call gagout('S-'//pname//',  Successful completion')
  call sysexi(1)
  !
101 call gagout('F-'//pname//',  Bad syntax in center coordinates')
100 call sysexi (fatale)
  !
1000 format(a,a)
end program grid_project
!
subroutine get_conv_code(oldsys,newsys,code,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: oldsys
  character(len=*), intent(inout) :: newsys
  integer(kind=4),  intent(out)   :: code
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: pname='GRID_PROJECT'
  !
  call sic_upper(newsys)
  !
  ! Unchanged
  if (newsys.eq.'UNCHANGED') then
    code = 0
    newsys = oldsys
    return
  endif
  !
  ! Same system
  if (oldsys.eq.newsys) then
    code = 0
    return
  endif
  !
  ! Supported conversions
  if (newsys.eq.'GALACTIC' .and. oldsys.eq.'EQUATORIAL') then
    code = 1
    return
  elseif (newsys.eq.'EQUATORIAL' .and. oldsys.eq.'GALACTIC') then
    code = -1
    return
  endif
  !
  ! Unsupported conversions
  code = 0
  write(6,'(6A)') 'F-',pname,',  Cannot convert from ',oldsys,' to ',newsys
  error = .true.
  !
end subroutine get_conv_code
!
subroutine regrid(a,mc,mv,atype,aproj,   &
     &    b,btype,bproj,code,xb,yb,ix,iy)
  use gkernel_interfaces
  use gkernel_types
  !---------------------------------------------------------------------
  ! GREG	Stand alone subroutine
  !	Regrid an input map in a given projection to
  !	an output map in another projection
  ! Arguments
  !	A	R*4(*)	Input GRID of dimensions MC MV
  !	MC,MV   I	Size of A
  !	ATYPE	I	Type of projection
  !	APROJ	R*8(3)	Projection constants
  !			PROJ(1) = A0,	PROJ(2)=D0,	PROJ(3)=Angle
  !	B	R*4(*)	Output map of dimensions MC MV
  !	BTYPE	I
  !	BPROJ	R*8(3)
  !	CODE	I	Galactic to Equatorial (-1)
  !			or Equatorial to Galactic (1)
  !	XB,YB	R*8	Work arrays of dimension MV
  !       IX,IY   I       Pointer to columns of X and Y
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mc                     !
  integer(kind=index_length) :: mv                     !
  real*4 :: a(mc,mv)                !
  integer :: atype                  !
  real*8 :: aproj(3)                !
  real*4 :: b(mc,mv)                !
  integer :: btype                  !
  real*8 :: bproj(3)                !
  integer :: code                   !
  real*8 :: xb(mc)                  !
  real*8 :: yb(mc)                  !
  integer :: ix                     !
  integer :: iy                     !
  ! Local
  integer :: i,ier
  type(projection_t) :: proj
  logical :: error
  real(kind=8), allocatable :: axb(:),ayb(:)
  !
  ! Setup Input projection
  error = .false.
  call gwcs_projec(aproj(1),aproj(2),aproj(3),atype,proj,error)
  allocate(axb(mv),ayb(mv),stat=ier)
  !
  ! Convert Output projection to Absolute coordinates
  do i=1,mv
    xb(i) = a(ix,i)
    yb(i) = a(iy,i)
  enddo
  call rel_to_abs(proj,xb,yb,axb,ayb,mv)
  !      do i=1,10
  !         type *,i,xb(i),yb(I)
  !      ENDDO
  !
  ! Change coordinate system - not coded...
  if (code.eq.-1) then
    ! call gal_equ (xb,yb,xb,yb,mv,error)
  elseif (code.eq.1) then
    ! call equ_gal (xb,yb,xb,yb,mv,error)
  endif
  !
  ! Setup Output projection
  call gwcs_projec(bproj(1),bproj(2),bproj(3),btype,proj,error)
  !
  ! Convert Absolute coordinates to input projection
  call abs_to_rel(proj,axb,ayb,xb,yb,mv)
  !      do i=1,10
  !         type *,i,xb(i),yb(I)
  !      ENDDO
  do i=1,mv
    b(ix,i) = xb(i)
    b(iy,i) = yb(i)
  enddo
end subroutine regrid

subroutine pdbi_plot_line(error)
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ public
  ! Main entry for plotting
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='PDBI_PLOT'
  logical :: ok
  integer(kind=4) :: i, nch
  real(kind=4) :: df, dv
  real(kind=8) :: f
  character(len=6) :: input1(4), input2(4)
  character(len=10) :: dsb
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  character(len=message_length) :: mess
  !
  if (flo1.eq.0) then
     call astro_message(seve%e,rname,'LINE command not yet executed')
     error = .true.
     return
  endif
  !
  if (plot_mode.eq.1) then
     call astro_message(seve%i,rname,'Plotting mode: LINE coverage')
     call pdbi_plot_full
  elseif ((plot_mode.eq.2).and.(narrow_def)) then
     call astro_message(seve%i,rname,'Plotting mode: NARROW correlator')
     call pdbi_plot_narrow
  elseif (plot_mode.eq.3) then
     call astro_message(seve%i,rname,'Plotting mode: WIDEX correlator')
     call pdbi_plot_widex
  else
    call astro_message(seve%e,rname,'Initilization problem')
    return
  endif
  !
  ! Spurious message on spurious lines
  ! Message is here so that it is output with PLOT command *and*
  ! with LINE/NARROW/SPECTRAL
  !
  if (do_spurious) then
     write(mess,'(A,F8.2,A)') 'Plotting possible spurious lines '// &
             ' (FLO1REF = ',flo1ref,' MHz)'
     call astro_message(seve%i,'PDBI_PLOT',trim(mess))
  endif
  !
  ! Print receiver and correlator setups
  !
  ! call astro_message(seve%i,rname,'Receiver tuning:')
  ! call astro_message(seve%r,rname,' '//label)
  !
  if (narrow_def) then
    call astro_message(seve%r,rname,'')
    call astro_message(seve%i,rname,'Current narrow-band correlator setup:')
    call astro_message(seve%r,rname,' Entry 1: '//input1(narrow_input(1)))
    call astro_message(seve%r,rname,' Entry 2: '//input2(narrow_input(2)))
    ok = .false.
    do i=1,nunit
      ok = ok.or.unit_def(i)
    enddo
    if (ok) then
      do i=1,nunit
        if (unit_def(i)) then
          !
          ! Compute Nchannel, df, dv
          !
          if (unit_band(i).eq.20) nch = 512    ! SSB mode
          if (unit_band(i).eq.40) nch = 512    ! SSB mode
          if (unit_band(i).eq.80) then
            if (unit_bmode(i).le.3) nch = 256  ! SSB mode
            if (unit_bmode(i).gt.3) nch = 512  ! DSB mode
          endif
          if (unit_band(i).eq.160) then
            if (unit_bmode(i).le.3) nch = 128  ! SSB mode
            if (unit_bmode(i).gt.3) nch = 256  ! DSB mode
          endif
          if (unit_band(i).eq.320) nch = 128   ! DSB mode
          if (unit_bmode(i).le.3) then
            dsb = '(SSB mode)'
          else
            dsb = '(DSB mode)'
          endif
          df = float(unit_band(i))/float(nch)
          call find_rffreq(i,f)  ! RF frequency at center of subband i
          dv = df/f*299792.458
          !
          ! Ouptut message
          !
          write(mess,1010) i,unit_band(i),unit_cent(i),unit_wind(i), nch,  &
            df, dv, dsb
        else
          !
          ! Unit not defined
          !
          write(mess,1020) i
        endif
        call astro_message(seve%r,rname,mess)
      enddo
    else
      call astro_message(seve%r,rname,' No spectral units defined')
    endif
    call astro_message(seve%r,rname,'')
  else
     ! call astro_message(seve%i,rname,'Narrow-band correlator setup: '// &
     !     'not yet defined')
  endif
  1010 format('  Unit ',i1,i4,f8.2,' on entry ',i1,' -- ',i3,' ch. of ',f5.3,  &
              ' MHz = ',f4.2,' km/s ',a)
  1020 format('  Unit ',i1,' OFF')
end subroutine pdbi_plot_line
!
! ------------------------------------------------------------------------
!
subroutine pdbi_plot_full
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of USB + LSB, as produced by the LINE command
  !---------------------------------------------------------------------
  real(kind=8) :: bandwidth, center
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=132) :: chain, limi
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('SET PLOT LANDSCAPE')
  !
  ! IF1 bandwidth
  !
  bandwidth = abs(userlim(2)-userlim(1))/1000.
  center = userlim(1)+(userlim(2)-userlim(1))/2.
  write(limi,1040) userlim(1), userlim(2)
  !
  ! SIGNAL plot ------------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 3 29 9 17')
  !
  ! USB or LSB?
  !
  if (sky.eq.1) then ! Signal = USB, IMAGE = LSB
     f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     f2 = f1+bandwidth
     u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     u2 = u1-bandwidth
  else               ! Signal = LSB, IMAGE = USB
     f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     f2 = f1-bandwidth
     u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     u2 = u1+bandwidth
  endif
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  if (sky.eq.1) then
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)    USB - Signal" /BOX 8')
  else
    call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)    LSB - Signal" /BOX 8')
  endif
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,200)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! Indicate requested tuning frequency
  !
  call gr_exec1('PEN 6')
  write(chain,1090) freq, 0.
  call gr_exec1(chain)
  write(chain,1100) freq, 1.5
  call gr_exec1(chain)
  call gr_exec1('PEN 0')
  !
  ! IF1 axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency IF1 (MHz)" 5 /BOX 2')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Plot correlator quarters (narrow-band and widex)
  !
  call pdbi_plot_full_corr
  !
  ! Label = LINE command
  !
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! IMAGE plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('PEN 14 /COL 14')
  call gr_exec1('SET BOX 3 29 3 6')
  !
  ! USB or LSB?
  !
  if (sky.eq.-1) then ! IMAGE = USB
     f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     f2 = f1+bandwidth
     u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     u2 = u1-bandwidth
  else                ! IMAGE = LSB
     f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
     f2 = f1-bandwidth
     u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
     u2 = u1+bandwidth
  endif
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  if (sky.eq.-1) then
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)    USB - Image" /BOX 2')
  else
    call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)    LSB - Image" /BOX 2')
  endif
  !
  ! Plot atmospheric transmission
  !
  ! if (do_atmplot) then
  !   call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  ! endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Spurious lines -- REMOVED
  !
  ! if (do_spurious) then
  !   call pdbi_line_spurious
  ! endif
  !
  ! Plot correlator quarters -- REMOVED
  !
  ! call pdbi_plot_full_corr
  !
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER')
  1090 format('DRAW RELOCATE ',f15.6,' ',f15.6,' /USER')
  1100 format('DRAW LINE ',f15.6,' ',f15.6,' /USER')
  !
end subroutine pdbi_plot_full
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_full_corr
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the correlator bands onto the DSB plot
  !---------------------------------------------------------------------
  integer(kind=4) :: i
  character(len=14) :: colortext(4)
  !
  ! Color for the four quarters
  !
  do i = 1,4
     if (narrow_def) then
        if (narrow_input(1).eq.i) then
           colortext(i) = 'PEN 1'  ! NARROW 1 in red
        elseif (narrow_input(2).eq.i) then
           colortext(i) = 'PEN 3'  ! NARROW 2 in blue
        else
           colortext(i) = 'PEN 14 /COL 14'  ! Not used
        endif
     else
        colortext(i) = 'PEN 14 /COL 14'  ! No NARROW defined yet
     endif
  enddo
  !
  ! Plot the NARROW quarters
  !
  call gr_exec1(colortext(1))
  call gr_exec1('DRAW TEXT 4700 0.7 "Q1" 5 /USER /CLIP')
  call gr_exec1(colortext(1)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 4760 0.7 /USER /CLIP')
  call gr_exec1('DRAW ARROW 5200 0.7 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 4635 0.7 /USER /CLIP')
  call gr_exec1('DRAW ARROW 4200 0.7 /USER /CLIP')
  call gr_exec1(colortext(1)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(2))
  call gr_exec1('DRAW TEXT 5500 1.1 "Q2" 5 /USER /CLIP ')
  call gr_exec1(colortext(2)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 5560 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 1.1 /USER /CLIP ')
  call gr_exec1('DRAW RELOCATE 5435 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 5000 1.1 /USER /CLIP ')
  call gr_exec1(colortext(2)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(3))
  call gr_exec1('DRAW TEXT 6500 0.7 "Q3" 5 /USER /CLIP ')
  call gr_exec1(colortext(3)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 6565 0.7 /USER /CLIP ')
  call gr_exec1('DRAW ARROW 7000 0.7 /USER /CLIP ')
  call gr_exec1('DRAW RELOCATE 6435 0.7 /USER /CLIP ')
  call gr_exec1('DRAW ARROW 6000 0.7 /USER /CLIP ')
  call gr_exec1(colortext(3)//' /WEIGHT 1')
  !
  call gr_exec1(colortext(4))
  call gr_exec1('DRAW TEXT 7300 1.1 "Q4" 5 /USER /CLIP')
  call gr_exec1(colortext(4)//' /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 7365 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 7800 1.1 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 7235 1.1 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6800 1.1 /USER /CLIP')
  call gr_exec1(colortext(4)//' /WEIGHT 1')
  !
  ! Now draw the WIDEX coverage
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  call gr_exec1('DRAW TEXT 5100 0.3 "WIDEX LOW" 5 /USER /CLIP')
  call gr_exec1('PEN 0 /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 5350 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 0.3 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 4850 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 4200 0.3 /USER /CLIP')
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  call gr_exec1('DRAW TEXT 6900 0.3 "WIDEX HIGH" 5 /USER /CLIP')
  call gr_exec1('PEN 0 /WEIGHT 5')
  call gr_exec1('DRAW RELOCATE 7165 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 7800 0.3 /USER /CLIP')
  call gr_exec1('DRAW RELOCATE 6635 0.3 /USER /CLIP')
  call gr_exec1('DRAW ARROW 6000 0.3 /USER /CLIP')
  !
  call gr_exec1('PEN 0 /WEIGHT 1')
  !
end subroutine pdbi_plot_full_corr
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_narrow
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of the NARROW-BAND correlator
  !---------------------------------------------------------------------
  ! Global
  logical :: gr_error
  ! Local
  real(kind=8) :: bandwidth, center, ifmin, ifmax, tmp
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=3) :: band
  character(len=132) :: chain, limi
  !
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  ! ------------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('PEN 0')
  !
  ! NARROW 1 ---------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = qlim(1,narrow_input(1))
  ifmax = qlim(2,narrow_input(1))
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  ! Box
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 4 29 11.5 17')
  call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  ! USB or LSB?
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  ! IF in Q2 and Q4 is flipped wrt the RF frequency
  if ((narrow_input(1).eq.2).or.(narrow_input(1).eq.4)) then
    tmp = f1
    f1 = f2
    f2 = tmp
	tmp = u1
	u1 = u2
	u2 = tmp
  endif
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz) - '//band //'" /BOX 8')
  call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz)" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis at correlator entry (100-1100 MHz)
  !
  call gr_exec1('LIMITS 100 1100 0 5')
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency at correlator '//  &
  'input (MHz)" 5 /BOX 2')
  !
  ! Label (correlator input)
  !
  call gr_exec1('PEN 1')
  call gr_exec1('DRAW TEXT -2 0 "NARROW 1 = '//input1(narrow_input(1)) //'" 5 90 '//  &
  '/BOX 4')
  write(chain,1070) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 /BOX 4')
  call gr_exec1('BOX N N N')
  !
  ! Spectral units
  !
  call pdbi_plot_spectral(1,0)
  !
  ! Spurious lines (need to switch to IF1 limits)
  !
  if (do_spurious) then
     if ((narrow_input(1).eq.1).or.(narrow_input(1).eq.3)) then
        write(limi,1040) ifmin, ifmax
        call gr_exec1(limi)
     else
        write(limi,1040) ifmax, ifmin  ! Q2 and Q4 are flipped
        call gr_exec1(limi)
     endif
     call pdbi_line_spurious
  endif
  call gr_exec1('PEN 0')
  !
  ! Label (LINE command)  -------------------------------------------------
  !
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! NARROW 2 --------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = qlim(1,narrow_input(2))
  ifmax = qlim(2,narrow_input(2))
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.

  !
  write(limi,1040) ifmin, ifmax
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 4 29 3 8.5')
  call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif

  ! IF in Q2 and Q4 is flipped wrt the RF frequency
  if ((narrow_input(2).eq.2).or.(narrow_input(2).eq.4)) then
    tmp = f1
    f1 = f2
    f2 = tmp
	tmp = u1
	u1 = u2
	u2 = tmp
  endif
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz) - '//band //'" /BOX 2')
  call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)" /BOX 2')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis at correlator entry (100-1100 MHz)
  !
  call gr_exec1('LIMITS 100 1100 0 5')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  ! call gr_exec1('DRAW TEXT 0 1.5 "Intermediate frequency at correlator '//  &
  ! 'input (MHz)" 5 /BOX 8')
  !
  ! Label (correlator input)
  !
  call gr_exec1('PEN 3')
  call gr_exec1('DRAW TEXT -2 0 "NARROW 2 = '//input2(narrow_input(2))//'" 5 90 '//  &
  '/BOX 4')
  write(chain,1070) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  call gr_exec1('BOX N N N')
  !
  ! Spectral units
  !
  call pdbi_plot_spectral(2,0)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     if ((narrow_input(2).eq.1).or.(narrow_input(2).eq.3)) then
        write(limi,1040) ifmin, ifmax
        call gr_exec1(limi)
     else
        write(limi,1040) ifmax, ifmin  ! Q2 and Q4 are flipped
        call gr_exec1(limi)
     endif
     call pdbi_line_spurious
  endif
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1070 format('IF1 = ',f3.1,' to ',f3.1,' GHz')
  !
end subroutine pdbi_plot_narrow
!
! -----------------------------------------------------------------------
!
subroutine pdbi_plot_widex
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of WIDEX
  !---------------------------------------------------------------------
  ! Global
  logical :: gr_error
  ! Local
  real(kind=8) :: bandwidth, center, ifmin, ifmax
  real(kind=8) :: f1, f2, u1, u2
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=3) :: band
  character(len=132) :: chain, limi
  integer(kind=4) :: lowband, highband
  data lowband/1/
  data highband/2/
  !
  ! ------------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('PEN 0')
  !
  ! WIDEX LOW -------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = 4200
  ifmax = 6000
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  write(limi,1040) ifmin, ifmax
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('SET BOX 4 29 11.5 17')
  call gr_exec1('PEN 0')
  ! call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz) - '//band //'" /BOX 8')
  call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz)" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF1 axis
  !
  write(chain,1040) ifmin, ifmax
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL /TICK NO')
  call gr_exec1('PEN 0 /DASH 3')
  call gr_exec1('DRAW RELOCATE 6000 0 /USER')
  call gr_exec1('DRAW LINE 6000 5 /USER')
  call gr_exec1('PEN 0 /DASH 1')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency IF1 (MHz)" 5 /BOX 2')
  !
  ! Spectral units
  !
  call pdbi_plot_narrow_widex(lowband)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Label
  !
  call gr_exec1('PEN 0')
  call gr_exec1('DRAW TEXT -2 0 "WIDEX LOW" 5 90 /BOX 4')
  write(chain,1080) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  call gr_exec1('LIMITS 100 1900 0 5')
  ! call gr_exec1('BOX N N N')
  !
  ! Label (LINE command)  -------------------------------------------------
  !
  call gr_exec1('PEN 0')
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//trim(label)//'" 5 /BOX 8')
  !
  ! WIDEX HIGH -------------------------------------------------------------
  !
  ! IF1 limits
  !
  ifmin = 6000
  ifmax = 7800
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  ! Box
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 4 29 3 8.5')
  call gr_exec1('PEN 0')
  ! call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec('PEN /DASH 1')
  ! call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz) - '//band //'" /BOX 2')
  call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)" /BOX 2')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
     call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF1 axis
  !
  write (chain,1040) ifmin, ifmax
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('AXIS YR /TICK NO')
  call gr_exec1('PEN 0 /DASH 3')
  call gr_exec1('DRAW RELOCATE 6000 0 /USER')
  call gr_exec1('DRAW LINE 6000 5 /USER')
  call gr_exec1('PEN 0 /DASH 1')
  !
  ! Narrow-band correlator
  !
  call pdbi_plot_narrow_widex(highband)
  !
  ! Spurious lines
  !
  if (do_spurious) then
     call pdbi_line_spurious
  endif
  !
  ! Label
  !
  call gr_exec1('PEN 0')
  call gr_exec1('DRAW TEXT -2 0 "WIDEX HIGH" 5 90 /BOX 4')
  write(chain,1080) ifmin/1e3, ifmax/1e3
  call gr_exec1('DRAW TEXT -1 0 "'//trim(chain)//'" 5 90 '//  &
  '/BOX 4')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1080 format('IF1 = ',f3.1,' to ',f3.1,' GHz')
  !
end subroutine pdbi_plot_widex
!
subroutine pdbi_plot_narrow_widex(wideband)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the narrow band correlator setup on the WIDEX plot
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: wideband  ! Widex Band indicator
  ! Local
  integer(kind=4) :: i, old_pen, gr_spen, xoffset(5)
  real(kind=4) :: yoffset
  logical :: doplot
  character(len=132) :: chain, iflimits
  character(len=17) :: drawtext, colortext
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  if (narrow_def) then
     !
     do i = 1,2
        !
        doplot = .false.
        !
        ! Loop on narrow band entries.
        !
        if (i.eq.1) then
           colortext = 'PEN 1'   ! narrow 1 in red
           drawtext = 'NARROW 1 = '//input1(narrow_input(1))
           yoffset = 0.7
        else
           colortext = 'PEN 3'   ! narrow 2 in blue
           drawtext = 'NARROW 2 = '//input2(narrow_input(2))
           yoffset = 1.1
        endif
        if (narrow_input(i).eq.1 .and. wideband.eq.1) then ! Q1 in WIDEX LOW
           xoffset(1) = 4200
           xoffset(2) = 4470
           xoffset(3) = 4930
           xoffset(4) = 5200
           xoffset(5) = 4700
           iflimits = 'LIMITS 100 1900 0 5' ! Q1 in WIDEX LOW
           doplot = .true.
        elseif (narrow_input(i).eq.2 .and. wideband.eq.1) then ! Q2 in WIDEX LOW
           xoffset(1) = 5000
           xoffset(2) = 5270
           xoffset(3) = 5730
           xoffset(4) = 6000
           xoffset(5) = 5500
           iflimits = 'LIMITS 1900 100 0 5' ! Q2 in WIDEX LOW
           doplot = .true.
        elseif(narrow_input(i).eq.3 .and. wideband.eq.2) then ! Q3 in WIDEX HIGH
           xoffset(1) = 6000
           xoffset(2) = 6270
           xoffset(3) = 6730
           xoffset(4) = 7000
           xoffset(5) = 6500
           iflimits = 'LIMITS 100 1900 0 5' ! Q3 in WIDEX HIGH
           doplot = .true.
        elseif (narrow_input(i).eq.4 .and. wideband.eq.2) then ! Q4 in WIDEX HIGH
           xoffset(1) = 6800
           xoffset(2) = 7070
           xoffset(3) = 7530
           xoffset(4) = 7800
           xoffset(5) = 7300
           iflimits = 'LIMITS 1900 100 0 5' ! Q4 in WIDEX HIGH
           doplot = .true.
        endif
        !
        ! Draw arrows & text
        !
        if (doplot) then
           call gr_exec1(colortext//' /WEIGHT 5')
           write(chain,1050) xoffset(3), yoffset
           call gr_exec1(chain)
           write(chain,1060) xoffset(4), yoffset
           call gr_exec1(chain)
           write(chain,1050) xoffset(2), yoffset
           call gr_exec1(chain)
           write(chain,1060) xoffset(1), yoffset
           call gr_exec1(chain)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           write(chain,1070) xoffset(5), yoffset, trim(drawtext)
           call gr_exec1(chain)
           !
           ! Plot narrow band spectral units
           !
           call gr_exec1(iflimits)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           old_pen = gr_spen(1)        ! --
           old_pen = gr_spen(old_pen)  ! select current pen
           call pdbi_plot_spectral(wideband,0)
           call gr_exec1(colortext//' /WEIGHT 1 /DASH 1')
           !
           ! Back to the IF1 limits
           !
           if (wideband.eq.1) then
              call gr_exec1('LIMITS 4200 6000 0 5')
           else
              call gr_exec1('LIMITS 6000 7800 0 5')
           endif
        endif
     enddo
  else
     call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
     !
     if (wideband.eq.1) then ! WIDEX LOW: Q1 and Q2
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 4700 0.7 "Q1" 5 /USER /CLIP')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 4760 0.7 /USER /CLIP')
        call gr_exec1('DRAW ARROW 5200 0.7 /USER /CLIP')
        call gr_exec1('DRAW RELOCATE 4635 0.7 /USER /CLIP')
        call gr_exec1('DRAW ARROW 4200 0.7 /USER /CLIP')
        !
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 5500 1.1 "Q2" 5 /USER /CLIP ')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 5560 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 6000 1.1 /USER /CLIP ')
        call gr_exec1('DRAW RELOCATE 5435 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 5000 1.1 /USER /CLIP ')
        !
     else ! WIDEX HIGH: Q3 and Q4
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
	call gr_exec1('DRAW TEXT 6500 0.7 "Q3" 5 /USER /CLIP ')
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 6565 0.7 /USER /CLIP ')
        call gr_exec1('DRAW ARROW 7000 0.7 /USER /CLIP ')
        call gr_exec1('DRAW RELOCATE 6435 0.7 /USER /CLIP ')
        call gr_exec1('DRAW ARROW 6000 0.7 /USER /CLIP ')
        !
        call gr_exec1('PEN 14 /COL 14 /WEIGHT 1')
        call gr_exec1('DRAW TEXT 7300 1.1 "Q4" 5 /USER /CLIP')
        call gr_exec1('PEN 14 /COl 14 /WEIGHT 5')
        call gr_exec1('DRAW RELOCATE 7365 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 7800 1.1 /USER /CLIP')
        call gr_exec1('DRAW RELOCATE 7235 1.1 /USER /CLIP')
        call gr_exec1('DRAW ARROW 6800 1.1 /USER /CLIP')
     endif
  endif
  1050 format('DRAW RELOCATE ',i8, f10.2,' /USER /CLIP')
  1060 format('DRAW ARROW ',i8, f10.2,' /USER /CLIP')
  1070 format('DRAW TEXT 'i8, f10.2,' "',a,'" 5 /USER /CLIP')
end subroutine pdbi_plot_narrow_widex
!
subroutine pdbi_line_molecules(fmin,fmax)
  use ast_line
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the molecular lines
  !---------------------------------------------------------------------
  real(kind=8) :: fmin              !
  real(kind=8) :: fmax              !
  ! Local
  logical :: error
  real(kind=8) :: fw
  integer(kind=4) :: i
  real(kind=4) :: afreq
  character(len=132) :: chain
  character(len=20) :: aname
  !
  fw=max(fmin,fmax)              ! Make sure Fmin<Fmax (depends on LSB
  fmin=min(fmin,fmax)            ! or USB)
  fmax=fw
  call gr_exec1 ('SET ORIEN 50')
  ! call gr_exec1 ('SET EXPAND 0.7')
  aname = ' '
  afreq = 0.0
  do i=1, nmol
     if (molfreq(i).ge.fmin .and. molfreq(i).le.fmax) then
        if (molname(i).ne.aname .or. abs(afreq-molfreq(i)).gt.40e-3) then
           write(chain,1000) 'DRAW TEXT ',molfreq(i),' 4. "' //  &
                trim(molname(i))//'" 5 /USER'
           aname = molname(i)
           afreq = molfreq(i)
           call gr_exec1(trim(chain))
        endif
        call gr_segm('LINE',error)
        if (width.eq.0) then
           call relocate (molfreq(i),3.d0)
           call draw (molfreq(i),2.0d0)
        else
           fw = width*molfreq(i)/299792.458
           call relocate (molfreq(i)-fw/2.,2.d0)
           call draw(molfreq(i),3.d0)
           call draw(molfreq(i)+fw/2.,2.d0)
        endif
        call gr_segm_close(error)
     endif
  enddo
  call gr_exec1 ('SET ORIEN 0')
  call gr_exec1 ('SET EXPAND 1')
  !
  1000 format(a,g14.7,a)
end subroutine pdbi_line_molecules
!
subroutine pdbi_line_atmos(fmin,fmax,umin,umax,wat,npoints)
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use atm_interfaces_public
  use astro_interfaces, except_this=>pdbi_line_atmos
  use atm_params
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot atmospheric transmission
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: fmin        ! Signal frequency range
  real(kind=8), intent(in) :: fmax        ! Signal frequency range
  real(kind=8), intent(in) :: umin        ! Image frequency range
  real(kind=8), intent(in) :: umax        ! Image frequency range
  real(kind=4), intent(in) :: wat         ! Water vapor content
  integer(kind=4), intent(in) :: npoints  ! Number of points in the curve
  ! Local
  character(len=*), parameter :: rname='PDBI_LINE_ATMOS'
  logical :: error
  integer(kind=4) :: i, ier, old_pen
  character(len=message_length) :: mess
  real(kind=8) :: ff(npoints), transmi(npoints), tsystem(npoints)
  real(kind=8) :: tsysmax
  type(polygon_drawing_t) :: histo
  integer(kind=size_length), parameter :: nbase=1
  real(kind=8) :: base(nbase)
  !
  water = wat      ! user defined water, 1 mm as default
!!  freqs = fmin     ! frequency
  !
  ! Why, ???... does not match Umin Umax either
!  fw=max(fmin,fmax)              ! Make sure Fmin<Fmax (depends on LSB
!  fmin=min(fmin,fmax)            ! or USB)
!  fmax=fw
  !
  ! Do the job, just like a call to ATM command (cf astro_atm.f90)
  !
  do i=1,npoints
     ff(i) = fmin + (fmax-fmin)*(i-1)/(npoints-1)
     freqs = ff(i)
     call atm_transm(water,1.0,freqs,temis,tatms,tauox,tauw,taut,ier)
     transmi(i) = 5*(1-taut) ! factor 5 to use plot Y limits = [0,5]
	 freqi = (umax-umin)*(freqs-fmin)/(fmax-fmin) + umin
     call atm_transm(water,airmass,freqi,temii,tatmi,tauox,tauw,taut,ier)
     call atm_transm(water,airmass,freqs,temis,tatms,tauox,tauw,taut,ier)
     !
     ! Compute Tsys
     !
     tsystem(i) = exp(taut*airmass) * (gim * (feff*temii+(1.0-feff)*t0 + trec) +  &
           (feff*temis+(1.0-feff)*t0 + trec) ) / feff
  enddo
  tsysmax = 1.1d0*maxval(tsystem)
  tsysmax = nint(tsysmax)
  tsystem = 5D0*tsystem/tsysmax
  !
  ! Plot atmosphere
  !
  call gr_exec('PEN 10 /COL 10')
  old_pen = gr_spen(10) ! select pen 10
  call gr_segm('ATMOSFILL',error)
  ! Set up the polygon description
  histo%contoured = .false.  ! Contour will be done with another color hereafter
  histo%hatched = .false.
  histo%filled = .true.
  base(:) = 4.98d0
  call gr8_histo_hatchfill(int(npoints,kind=size_length),ff,transmi,  &
                           nbase,base,0.d0,-1.d0,histo,error)
  call gr_segm_close(error)
  !
  call gr_exec('PEN 0 /COL 0 /DASH 3')
  old_pen = gr_spen(0) ! select pen 0
  call gr_segm('ATMOS',error)
  call gr8_connect(npoints,ff,transmi,0.0,-1.0)
  call gr_segm_close(error)
  !
  ! Plot Tsys
  !
  call gr_exec1('PEN 3 /COL 3 /DASH 1')
  i = gr_spen(3)   ! Select pen 3 (blue)
  call gr_segm('TSYS',error)
  call gr8_connect(npoints,ff,tsystem,0.0,-1.0)
  call gr_segm_close(error)
  write(mess,*) tsysmax
  call gr_exec('AXIS YL 0 '//trim(mess))
  call gr_exec('DRAW TEXT -2 0 "T\\dsys\\u (K)" 5 90 /BOX 4')
  ! call gr_exec('LABEL "T\\dsys\\u (K)" /Y')
  !
  ! Back to old pen
  !
  call gr_exec('PEN 0 /COL 0 /DASH 1')
  i = gr_spen(old_pen)
  !
end subroutine pdbi_line_atmos
!
subroutine pdbi_line_spurious
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot spurious lines. Box must be in IF1 limits.
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='PDBI_PLOT'
  character(len=132) :: chain
  ! character(len=message_length) :: mess
  !
  ! write(mess,'(A,F6.1,A)') 'Plotting possible spurious lines '// &
  !     ' (FLO1REF = ',flo1ref,' MHz)'
  ! call astro_message(seve%i,rname,mess)
  !
  call gr_exec1('PEN 2 /DASH 3')
  write(chain,1050) 3*flo1ref
  call gr_exec1(chain)
  write(chain,1060) 3*flo1ref
  call gr_exec1(chain)
  write(chain,1080) 3*flo1ref, '3*FLO1REF'
  call gr_exec1(chain)
  write(chain,1050) 4*flo1ref
  call gr_exec1(chain)
  write(chain,1060) 4*flo1ref
  call gr_exec1(chain)
  write(chain,1080) 4*flo1ref, '4*FLO1REF'
  call gr_exec1(chain)
  write(chain,1050) 6300.
  call gr_exec1(chain)
  write(chain,1060) 6300.
  call gr_exec1(chain)
  write(chain,1080) 6300., '"6300 MHz"'
  call gr_exec1(chain)
  write(chain,1050) 4500.
  call gr_exec1(chain)
  write(chain,1060) 4500.
  call gr_exec1(chain)
  write(chain,1080) 4500., '"4500 MHz"'
  call gr_exec1(chain)
  call gr_exec1('PEN 0')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER /CLIP')
  1080 format('DRAW TEXT 'f10.2,' 2.5 ',a,' 8 90 /USER /CLIP')
end subroutine pdbi_line_spurious

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! This file contains the luminosity_total_tool and luminosity_labeled_tool
! modules before implementing the LUMINOSITY command.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP: This command requires double thinking before parallelize it!
!
! *** JP: It should be ported to subcube when the question of double cube access
! *** JP: will be sorted out
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_luminosity_total_tool
  use cubetools_parameters
  use cube_types
  use cubemain_messaging
  use cubemain_windowing
  !
  public :: luminosity_total_prog_t
  private
  !
  type luminosity_total_prog_t
     type(window_array_t)  :: wind   ! Window(s) over which to compute luminosity 
     type(cube_t), pointer :: cube   ! Brightness cube
     type(cube_t), pointer :: noise  ! Noise cube
     real(kind=real_k) :: xco        ! [H2/cm^2/(K.km/s)] xco conversion factor
     real(kind=real_k) :: distance   ! [pc              ] Distance to the source
     real(kind=dble_k) :: lumi       ! [K.km/s.pc^2     ] Source Luminosity 
     real(kind=dble_k) :: dlumi      ! [K.km/s.pc^2     ] luminosity error
     real(kind=dble_k) :: tvolu      ! [km/s.pc^2       ] Total Volume
     !
   contains
     procedure, public  :: total_header => cubemain_luminosity_total_prog_header
     procedure, public  :: total_data   => cubemain_luminosity_total_prog_data
     procedure, private :: total_list   => cubemain_luminosity_total_prog_list
  end type luminosity_total_prog_t
  !
contains
  !
  subroutine cubemain_luminosity_total_prog_header(prog,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(luminosity_total_prog_t), intent(inout) :: prog
    logical,                        intent(inout) :: error
    !
    character(len=*), parameter :: rname='LUMINOSITY>TOTAL>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
  end subroutine cubemain_luminosity_total_prog_header
  !
  subroutine cubemain_luminosity_total_prog_data(prog,error)
    use cubetools_nan
    use cubeadm_opened
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(luminosity_total_prog_t), intent(inout) :: prog
    logical,                        intent(inout) :: error
    !
    integer(kind=wind_k) :: iw
    integer(kind=pixe_k) :: ix,iy
    integer(kind=long_k) :: ngood
    type(image_t) :: brightness,noise
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='LUMINOSITY>TOTAL>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    prog%tvolu = 0d0
    prog%lumi = 0d0
    prog%dlumi = 0d0
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    call brightness%associate('brightness',prog%cube,iter,error)
    if (error) return
    call noise%associate('noise',prog%noise,iter,error)
    if (error) return
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) return
       do while (iter%iterate_entry(error))
          do iw=1,prog%wind%n
             if ((prog%wind%val(iw)%o(1).le.iter%ie).and.(iter%ie.le.prog%wind%val(iw)%o(2))) then
                call brightness%get(iter%ie,error)
                if (error) return
                call noise%get(iter%ie,error)
                if (error) return
                ngood = 0
                do iy=1,brightness%ny
                   do ix=1,brightness%nx
                      if ((.not.ieee_is_nan(noise%val(ix,iy))).and.(.not.ieee_is_nan(brightness%val(ix,iy)))) then
                         ngood = ngood+1
                         prog%lumi = prog%lumi+brightness%val(ix,iy)
                         prog%dlumi = prog%dlumi+noise%val(ix,iy)
                      endif
                   enddo ! ix
                enddo ! iy
                if (ngood.ge.1) then
                   prog%tvolu = prog%tvolu+real(ngood)
                endif
             endif ! Not NaN?
          enddo ! iw
       enddo ! ie
    enddo ! iter
    !
    call prog%total_list(error)
    if (error) return
  end subroutine cubemain_luminosity_total_prog_data
  !
  subroutine cubemain_luminosity_total_prog_list(prog,error)
    use phys_const
    use cubetools_header_methods
    use cubetools_beam_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_total_prog_t), intent(inout) :: prog
    logical,                        intent(inout) :: error
    !
    integer(kind=chan_k) :: nf
    integer(kind=wind_k) :: iw
    real(kind=8) :: pixel_volume,total_surface,total_volume
    real(kind=8) :: xco_msolpspc,pc_per_sec,points_per_beam
    real(kind=8) :: luminosity,mass
    real(kind=8) :: dluminosity,dmass
    real(kind=coor_k) :: xres,yres,vres,vrange(2)
    real(kind=8), parameter :: sec_per_pc_per_dist = 206265
    type(beam_t) :: beam
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='LUMINOSITY>TOTAL>PROG>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    xres = prog%cube%head%spa%l%inc
    yres = prog%cube%head%spa%m%inc
    vres = prog%cube%head%spe%inc%v
    !
    call cubetools_header_get_spabeam(prog%cube%head,beam,error)
    if (error) return
    !
    pixel_volume = abs(xres*yres*vres)
    if (pixel_volume.eq.0d0) then
       call cubemain_message(seve%e,rname,'Pixel volume is zero valued')
       error=.true.
       return
    endif
    !
    pc_per_sec = prog%distance/sec_per_pc_per_dist ! pc
    pixel_volume = pixel_volume*(pc_per_sec*sec_per_rad)**2 ! km/s.pc^2
    !
    xco_msolpspc = prog%xco/4.6e19 ! Msol pc^-2 / (K.km/s)
    points_per_beam = abs((2*pi*beam%major*beam%minor)/(8d0*log(2d0)*xres*yres))
    !
    total_volume = prog%tvolu*pixel_volume
    luminosity = prog%lumi*pixel_volume
    dluminosity = sqrt(prog%dlumi/points_per_beam)*pixel_volume
    mass = luminosity*xco_msolpspc
    dmass = dluminosity*xco_msolpspc
    !
    write(mess,'(a,1pg12.4)')   '  Points per beam:      ',points_per_beam
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a)') '  X factor:             ',prog%xco,' (H2/cm^2) / (K.km/s)'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a)') '  X factor:             ',xco_msolpspc,' (Msol/pc^2) / (K.km/s)'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a)') '  Distance:             ',prog%distance,' pc'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a)') '  Linear size:          ',pc_per_sec,' pc/arcsec'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a,1pg12.4,a)') '  Pixel volume:         ',  &
         abs(xres)*sec_per_rad,'" x ',abs(yres)*sec_per_rad,'" x ',&
         abs(vres),'km/s'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a)') '  Pixel volume:         ',pixel_volume,' km/s.pc^2'
    call cubemain_message(seve%r,rname,mess)
    nf = 0
    do iw=1,prog%wind%n
       nf = nf+prog%wind%val(iw)%nc
       call prog%wind%val(iw)%chan2velo(vrange,error)
       if (error) return
       write(mess,'(a,i0,a,f9.2,a,f9.2,a)') '  Velocity range #',iw,':      [',vrange(1),',',vrange(2),'] km/s'
       call cubemain_message(seve%r,rname,mess)
    enddo ! iw
    total_surface = total_volume/abs(nf*vres)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Total volume:         ',total_volume,&
         ' km/s.pc^2 or ',total_volume/pixel_volume,' voxels'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Total surface:        ',total_surface,' pc^2      or ',  &
         total_surface/(pc_per_sec*60)**2,' arcmin^2'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Total luminosity:     ',luminosity,' +/- ',&
         dluminosity,' K.km/s.pc^2'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Total mass:           ',mass,' +/- ',dmass,' Msol'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Mean brightness:      ',luminosity/total_surface,' +/- ',  &
         dluminosity/total_surface,' K.km/s'
    call cubemain_message(seve%r,rname,mess)
    write(mess,'(a,1pg12.4,a,1pg12.4,a)') '  Mass surface density: ',mass/total_surface,&
         ' +/- ',dmass/total_surface,' Msol/pc^2'
    call cubemain_message(seve%r,rname,mess)
  end subroutine cubemain_luminosity_total_prog_list
end module cubemain_luminosity_total_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_luminosity_labeled_tool
  use cubetools_parameters
  use cubetools_array_types
  use cubeadm_cubeprod_types
  use cube_types
  use cubemain_messaging
  use cubeadm_ancillary_cube_types
  use cubemain_windowing
  use cubemain_luminosity_total_tool
  !
  public :: luminosity_labeled_comm_t,luminosity_labeled_user_t,luminosity_labeled_prog_t
  private
  !
  type, extends(ancillary_cube_comm_t) :: luminosity_labeled_comm_t
     type(cube_prod_t), pointer :: luminosity
   contains
     procedure, public  :: register => cubemain_luminosity_labeled_comm_register
  end type luminosity_labeled_comm_t
  !
  type, extends(ancillary_cube_user_t) :: luminosity_labeled_user_t
     ! Empty for the moment
  end type luminosity_labeled_user_t
  !
  type, extends(luminosity_total_prog_t) :: luminosity_labeled_prog_t
     type(ancillary_cube_prog_t)    :: labeled    ! Labeled cube
     type(cube_t), pointer          :: luminosity ! Luminosity per island
     type(real_1d_t),       private :: sum
   contains
     procedure, public  :: labeled_header => cubemain_luminosity_labeled_prog_header
     procedure, public  :: labeled_data   => cubemain_luminosity_labeled_prog_data
     procedure, private :: labeled_act    => cubemain_luminosity_labeled_prog_act
     procedure, private :: labeled_output => cubemain_luminosity_labeled_prog_output
  end type luminosity_labeled_prog_t
  !
contains
  !
  subroutine cubemain_luminosity_labeled_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! Register an optional "/SEGMENTS [segmentsid]" key
    !----------------------------------------------------------------------
    class(luminosity_labeled_comm_t), intent(inout) :: comm
    logical,                          intent(inout) :: error
    !
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='LUMINOSITY>LABELED>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call comm%fully_register(&
         'SEGMENTS','[segmentsid]',&
         'Compute the luminosity per SNR segment',&
         'When /SEGMENTS is present, one luminosity value is computed&
         & per segment label. If omitted, use the last matching cube&
         & (segments flag) in the default index (DAG by default; see&
         & SET\INDEX).',&
         'SEGMENTSID','Cube of segment labels',&
         [flag_segments],&
         code_arg_optional,&
         code_read,&
         code_access_imaset,&
         error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'LUMINOSITY',&
         'Luminosity cube',&
         strg_emp,&
         [flag_luminosity],&
         comm%luminosity,&
         error,&
         access=code_cube_speset)
    if (error)  return    
  end subroutine cubemain_luminosity_labeled_comm_register
  !
  !------------------------------------------------------------------------
  !
  subroutine cubemain_luminosity_labeled_prog_header(prog,comm,error)
    use cubetools_unit
    use cubetools_axis_types
    use cubetools_arrelt_types
    use cubetools_header_methods
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_labeled_prog_t), intent(inout) :: prog
    type(luminosity_labeled_comm_t),  intent(in)    :: comm
    logical,                          intent(inout) :: error
    !
    type(axis_t) :: axis
    type(arrelt_t) :: min,max
    character(len=*), parameter :: rname='LUMINOSITY>LABELED>PROG>HEADER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%luminosity,prog%labeled%cube,prog%luminosity,error)
    if (error) return
    call cubetools_header_nullify_axset_l(prog%luminosity%head,error)
    if (error) return
    call cubetools_header_nullify_axset_m(prog%luminosity%head,error)
    if (error) return
    call cubetools_header_get_array_minmax(prog%luminosity%head,min,max,error)
    if (error) return
    call cubetools_header_get_axis_head_c(prog%luminosity%head,axis,error)
    if (error) return
    axis%name = 'Label'
    axis%unit = 'Integer'
    axis%kind = code_unit_unk
    axis%genuine = .true.
    axis%regular = .true.
    axis%ref = 1.0
    axis%val = 1.0
    axis%inc = 1.0
    axis%n = max%val
    call cubetools_header_update_axset_c(axis,prog%luminosity%head,error)
    if (error) return
  end subroutine cubemain_luminosity_labeled_prog_header
  !
  subroutine cubemain_luminosity_labeled_prog_data(prog,error)
    use cubetools_shape_types
    use cubetools_header_methods
    use cubeadm_opened
    use cubeadm_image_types
    !----------------------------------------------------------------------
    ! Unclear whether this operation can be easily parallelized
    !----------------------------------------------------------------------
    class(luminosity_labeled_prog_t), intent(inout) :: prog
    logical,                          intent(inout) :: error
    !
    type(shape_t) :: n
    type(image_t) :: brightness,label
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='LUMINOSITY>LABELED>PROG>DATA'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call brightness%associate('brightness',prog%cube,iter,error)
    if (error) return
    call label%associate('label',prog%labeled%cube,iter,error)
    if (error) return
    call cubetools_header_get_array_shape(prog%luminosity%head,n,error)
    if (error) return
    call prog%sum%reallocate('sum',n%c,error)
    if (error) return
    call prog%sum%set(0.0,error)
    if (error) return
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    do while (cubeadm_dataiterate_all(iter,error))
       do while (iter%iterate_entry(error))
          call prog%labeled_act(iter%ie,brightness,label,prog%sum,error)
          if (error) return
       enddo ! ie
    enddo ! iter
    !
    call prog%labeled_output(error)
    if (error) return
  end subroutine cubemain_luminosity_labeled_prog_data
  !   
  subroutine cubemain_luminosity_labeled_prog_act(prog,ie,brightness,label,sum,error)
    use cubetools_nan
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_labeled_prog_t), intent(inout) :: prog
    integer(kind=entr_k),             intent(in)    :: ie
    type(image_t),                    intent(inout) :: brightness
    type(image_t),                    intent(inout) :: label
    type(real_1d_t),                  intent(inout) :: sum
    logical,                          intent(inout) :: error
    !
    integer(kind=indx_k) :: il,nl
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='LUMINOSITY>LABELED>PROG>ACT'
    !
    nl = sum%n
    call brightness%get(ie,error)
    if (error) return
    call label%get(ie,error)
    if (error) return
    do iy=1,brightness%ny
       do ix=1,brightness%nx
          if (.not.ieee_is_nan(brightness%val(ix,iy))) then
             il = label%val(ix,iy)
             if ((0.lt.il).and.(il.le.nl)) then
                sum%val(il) = sum%val(il)+brightness%val(ix,iy)
             else
                print *,ix,iy,il,nl
             endif ! Inside [1,nl]?
          endif ! Not NaN?
       enddo ! ix
    enddo ! iy
  end subroutine cubemain_luminosity_labeled_prog_act
  !
  subroutine cubemain_luminosity_labeled_prog_output(prog,error)
    use cubeadm_ioloop
    use cubeadm_spectrum_types
    use cubeadm_taskloop
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_labeled_prog_t), intent(inout) :: prog
    logical,                          intent(inout) :: error
    !
    type(spectrum_t) :: luminosity
    integer(kind=indx_k) :: il,nl
    integer(kind=chan_k), parameter :: one = 1
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='LUMINOSITY>LABELED>OUTPUT'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call luminosity%allocate('luminosity',prog%luminosity,iter,error)
    if (error) return
    call cubeadm_io_iterate(one,one,prog%luminosity,error)
    if (error) return
    nl = prog%sum%n
    luminosity%y%val(1) = prog%sum%val(nl)
    do il=1,nl-1
       luminosity%y%val(il+1) = luminosity%y%val(il)+prog%sum%val(nl-il)
    enddo ! il
    call luminosity%put(one,error)
    if (error) return
  end subroutine cubemain_luminosity_labeled_prog_output
end module cubemain_luminosity_labeled_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_luminosity
  use cubetools_parameters
  use cubetools_structure
  use cubetools_unit_arg
  use cubeadm_cubeid_types
  use cubemain_messaging
  use cubemain_range
  use cubemain_luminosity_labeled_tool
  !
  public :: luminosity
  private
  !
  real(kind=4), parameter :: galxco = 2e20
  !
  type :: luminosity_comm_t
     type(option_t),         pointer :: comm
     type(option_t),         pointer :: dist
     type(unit_arg_t),       pointer :: dist_unit
     type(option_t),         pointer :: xco
     type(cubeid_arg_t),     pointer :: cube
     type(cubeid_arg_t),     pointer :: noise
     type(luminosity_labeled_comm_t) :: labeled
     type(range_opt_t)               :: range
   contains
     procedure, public  :: register       => cubemain_luminosity_comm_register
     procedure, private :: parse          => cubemain_luminosity_comm_parse
     procedure, private :: parse_distance => cubemain_luminosity_comm_parse_distance
     procedure, private :: parse_xval     => cubemain_luminosity_comm_parse_xval
     procedure, private :: main           => cubemain_luminosity_comm_main
  end type luminosity_comm_t
  type(luminosity_comm_t) :: luminosity
  !
  type luminosity_user_t
     type(cubeid_user_t)             :: cubeids
     type(luminosity_labeled_user_t) :: labeled
     type(range_array_t)             :: range             ! Range(s) over which to compute luminosity 
     logical                         :: dorange = .false. ! Was option /RANGE present 
     real(kind=real_k)               :: xco = -1.         ! [---] User xco conversion factor    
     real(kind=real_k)               :: distance          ! [pc ] Distance to the source
   contains
     procedure, private :: toprog => cubemain_luminosity_user_toprog
  end type luminosity_user_t
  !
contains
  !
  subroutine cubemain_luminosity_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(luminosity_user_t) :: user
    character(len=*), parameter :: rname='LUMINOSITY>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    call luminosity%parse(line,user,error)
    if (error) return
    call luminosity%main(user,error)
    if (error) continue
  end subroutine cubemain_luminosity_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_luminosity_comm_register(comm,error)
    use cubedag_allflags
    use cubetools_unit
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_comm_t), intent(inout) :: comm
    logical,                  intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(unit_arg_t) :: unitarg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='LUMINOSITY>COMM>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'LUMINOSITY','[signalid [noiseid]]',&
         'Compute luminosity diagnostics for a signal cube',&
         'Compute the total luminosity from a signal cube over the selected&
         & spectral range(s).'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- /DISTANCE and /X control the physical scaling used for&
         & luminosity reporting.'//strg_cr//&
         '- /RANGE selects integration windows; if omitted, the full&
         & spectral axis is used.'//strg_cr//&
         '- /SEGMENTS switches from total-luminosity mode to per-segment&
         & luminosity mode.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> LUMINOSITY 12co10:cube 12co10:noise /DISTANCE 8200 pc'//strg_cr//&
         'CUBE> LUMINOSITY 12co10:cube 12co10:noise /RANGE -5 15 km/s&
         & /DISTANCE 8200 pc /X 2.3e20'//strg_cr//&
         'CUBE> LUMINOSITY 12co10:cube 12co10:noise /SEGMENTS&
         & 12co10:segments /DISTANCE 8200 pc',&
         cubemain_luminosity_command,&
         comm%comm,error)
    if (error) return
    call incube%register(&
         'SIGNALID',&
         'Signal cube identifier',&
         'If omitted, use the last matching cube (cube flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional, &
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%cube,&
         error)
    if (error) return
    call incube%register(&
         'NOISEID',&
         'Noise cube identifier',&
         'If omitted, use the last matching cube (noise flag) in&
         & the default index (DAG by default; see SET\INDEX).',&
         code_arg_optional, &
         [flag_noise],&
         code_read,&
         code_access_imaset,&
         comm%noise,&
         error)
    if (error) return
    !
    call comm%labeled%register(error)
    if (error) return
    !
    call comm%range%register('RANGE',&
         'Define the velocity range(s) over which to compute luminosity',&
         range_is_multiple,error)
    if (error) return
    !
    call cubetools_register_option(&
         'DISTANCE','dist [unit]',&
         'Define the distance to the source',&
         'This key is required. DISTANCE is converted to internal&
         & distance units before luminosity is computed.',&
         comm%dist,error)
    if (error) return
    call stdarg%register(&
         'dist', &
         'Distance to the source',&
         'Must be strictly positive.',&
         code_arg_mandatory,&
         error)
    if (error) return
    call unitarg%register(&
         'unit', &
         'Distance unit',&
         '"*" or "=" mean current distance unit is used',&
         code_arg_optional,&
         code_unit_dist,&
         comm%dist_unit,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'X','val',&
         'Define the luminosity-to-mass conversion factor',&
         'Override the CO-to-H2 Galactic default conversion factor&
         & (2e20 (H2.cm-2)/(K.km/s)).',&
         comm%xco,&
         error)
    if (error) return
    call stdarg%register(&
         'val', &
         'Luminosity-to-mass conversion factor',&
         'Must be strictly positive.',&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubemain_luminosity_comm_register
  !
  subroutine cubemain_luminosity_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! LUMINOSITY [signalid [noiseid]]
    ! [/SEGMENTS [segmentsid]]
    ! [/RANGE v11 v12 [... [vn1 vn2]] [unit]]
    ! /DISTANCE dist [unit]
    ! [/X xval]
    !----------------------------------------------------------------------
    class(luminosity_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: line
    type(luminosity_user_t),  intent(out)   :: user
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='LUMINOSITY>COMM>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%labeled%parse(line,user%labeled,error)
    if (error) return
    call comm%range%parse(line,user%dorange,user%range,error)
    if (error) return
    call comm%parse_distance(line,user,error)
    if (error) return
    call comm%parse_xval(line,user,error)
    if (error) return
  end subroutine cubemain_luminosity_comm_parse
  !
  subroutine cubemain_luminosity_comm_parse_distance(comm,line,user,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! /DISTANCE dist [unit]
    !----------------------------------------------------------------------
    class(luminosity_comm_t), intent(in)    :: comm
    character(len=*),         intent(in)    :: line
    type(luminosity_user_t),  intent(inout) :: user
    logical,                  intent(inout) :: error
    !
    character(len=argu_l) :: userunit
    type(unit_user_t) :: unit
    logical :: present
    character(len=*), parameter :: rname='LUMINOSITY>COMM>PARSE>DISTANCE'
    !
    call comm%dist%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,comm%dist,1,user%distance,mandatory,error)
       if (error) return
       if (user%distance.le.0) then
          call cubemain_message(seve%e,rname,'Distance must be positive')
          error=.true.
          return
       endif
       !
       userunit = strg_star
       call cubetools_getarg(line,comm%dist,2,userunit,.not.mandatory,error)
       if (error) return
       call unit%get_from_name_for_code(userunit,code_unit_dist,error)
       if (error) return
       user%distance = user%distance*unit%prog_per_user
    else
       call cubemain_message(seve%e,rname,'The distance source-earth must be given')
       error=.true.
       return
    endif
  end subroutine cubemain_luminosity_comm_parse_distance
  !
  subroutine cubemain_luminosity_comm_parse_xval(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /X xval
    !----------------------------------------------------------------------
    class(luminosity_comm_t), intent(in)    :: comm
    character(len=*),         intent(in)    :: line
    type(luminosity_user_t),  intent(inout) :: user
    logical,                  intent(inout) :: error
    !
    logical :: present
    character(len=*), parameter :: rname='LUMINOSITY>COMM>PARSE>XVAL'
    !
    call comm%xco%present(line,present,error)
    if (error) return
    if (present) then
       call cubetools_getarg(line,comm%xco,1,user%xco,mandatory,error)
       if (error) return
       if (user%xco.le.0) then
          call cubemain_message(seve%e,rname,'Xco must be positive')
          error=.true.
          return
       endif
    else
       call cubemain_message(seve%w,rname,'X not given => Assumes Galactic Xco factor')
       user%xco = galxco
    endif
  end subroutine cubemain_luminosity_comm_parse_xval
  !
  subroutine cubemain_luminosity_comm_main(comm,user,error)
    use cubeadm_timing
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_comm_t), intent(in)    :: comm
    type(luminosity_user_t),  intent(in)    :: user
    logical,                  intent(inout) :: error
    ! 
    type(luminosity_labeled_prog_t) :: prog
    character(len=*), parameter :: rname='LUMINOSITY>COMM>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    if (prog%labeled%do) then
       call prog%labeled_header(comm%labeled,error)
       if (error) return
       call prog%labeled_data(error)
       if (error) return
    else
       call prog%total_header(error)
       if (error) return
       call prog%total_data(error)
       if (error) return
    endif
    call cubeadm_timing_process2postpro()
  end subroutine cubemain_luminosity_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_luminosity_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(luminosity_user_t),        intent(in)    :: user
    type(luminosity_comm_t),         intent(in)    :: comm
    type(luminosity_labeled_prog_t), intent(inout) :: prog
    logical,                         intent(inout) :: error
    !
    logical :: conspb
    character(len=*), parameter :: rname='LUMINOSITY>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    conspb = .false.
    !
    call cubeadm_get_header(comm%cube,user%cubeids,prog%cube,error)
    if (error) return
    !
    call cubeadm_get_header(comm%noise,user%cubeids,prog%noise,error)
    if (error) return
    call cubetools_consistency_signal_noise(&
         'Brightness cube',prog%cube%head,&
         'Noise',prog%noise%head,&
         conspb,error)
    if (error) return
    if (cubetools_consistency_failed(rname,conspb,error)) return
    !
    call user%labeled%toprog(comm%labeled,prog%labeled,error)
    if (error) return
    if (prog%labeled%do) then
       ! User requests to use a labeled cube
       call cubetools_consistency_spatial(&
            'Brightness cube',prog%cube%head,&
            'Labeled cube',prog%labeled%cube%head,&
            conspb,error)
       if (error) return
       if (cubetools_consistency_failed(rname,conspb,error)) return
    endif
    !
    call comm%range%user2prog(prog%cube,user%range,prog%wind,error)
    if (error) return
    prog%distance = user%distance
    prog%xco = user%xco
  end subroutine cubemain_luminosity_user_toprog
end module cubemain_luminosity
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine dotape (jc,nv,visi,jx,jy,taper,we)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING  Support for UV_MAP
  !     Apply taper to the weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          ! number of values
  integer, intent(in) :: jc          ! Size of a visibility
  integer, intent(in) :: jx          ! X coord location in VISI
  integer, intent(in) :: jy          ! Y coord location in VISI
  real, intent(in) :: visi(jc,nv)    ! Visibilities
  real, intent(in) :: taper(4)       ! Taper definition
  real, intent(inout) :: we(nv)      ! Weights
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  integer iv
  real staper,etaper
  real u,v
  real cx,cy,sx,sy
  !
  if (taper(1).eq.0. .and. taper(2).eq.0.) return
  !
  staper = taper(3)*pi/180.0
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
  else
    cy = 0.0
    sx = 0.0
  endif
  if (taper(4).ne.0.) then
    etaper = taper(4)/2.0
  else
    etaper = 1
  endif
  !
  do iv=1,nv
    u = visi(jx,iv)
    v = visi(jy,iv)
    !
    staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
    if (etaper.ne.1) staper = staper**etaper
    if (staper.gt.64.0) then
      staper = 0.0
    else
      staper = exp(-staper)
    endif
    we(iv) = we(iv)*staper
  enddo
end subroutine dotape
!
subroutine doweig (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces, except_this => doweig
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! MAPPING   Support for UV_MAP
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  logical, intent(inout) :: error
  integer, intent(in), optional :: code
  !
  integer i,iw
  real umin,umax,vmin,vmax,vstep,vimin,vimax
  real vcmin, vcmax
  integer nbcv, ivmin, ivmax, icv, nbv, new, nflag
  integer ier, icode
  character(len=message_length) :: chain
  !
  real my_wm
  real, allocatable :: my_we(:)
  !
  ! Natural weight
  nflag = 0
  if (unif.le.0.0 .or. wm.le.0.0) then
    if (jw.gt.0) then
      iw =7+3*jw
      do i=1,nv
        if (visi(iw,i).gt.0.0) then
          we(i) = visi(iw,i)
        else
          nflag = nflag+1
          we(i) = 0.0
        endif
      enddo
    else
      do i=1,nv
        we(i) = 1.0
      enddo
    endif
    if (nflag.ne.0) then
      write(chain,'(I12,A)') nflag,' flagged visibilities ignored'
      call map_message(seve%i,'DOWEIG',chain)
    endif
    return
  endif
  !
  if (present(code)) then
    icode = code
  else
    icode = -1
  endif
  !
  if (icode.ge.0) then
    iw = 7+3*jw
    !
    my_wm = wm
    allocate(my_we(nv),stat=ier)
    my_we = we(:)
    call doweig_sph (jc,nv,visi,jx,jy,iw,unif,my_we,my_wm,vv,error,code)
    we = my_we(:)
  else
    !
    ! Uniform weight
    !
    ! 1) Compute VMIN, VMAX, UMIN, UMAX
    vmin = visi(jy,1)
    vmax = visi(jy,nv)
    umin = 0.0
    umax = 0.0
    do i=1,nv
      if (visi(jx,i).lt.umin) then
        umin = visi(jx,i)
      elseif  (visi(jx,i).gt.umax) then
        umax = visi(jx,i)
      endif
    enddo
    !
    ! Symmetry ?...
    if (-umin.gt.umax) then
      umax = -umin
    else
      umin = -umax
    endif
    vmin = 1.001*vmin            ! Allow small margin
    umax = 1.001*umax
    umin = 1.001*umin
    !
    ! Some speed up factor
    nbcv = 128
    vstep = -vmin/nbcv
    !
    ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
    ! than sufficient to get speed up.
    !
    if (vstep.lt.4*unif) then
      nbcv = int(-vmin/(4*unif))
!!      print *,'Vmin ',vmin,'Unif ',unif,' NBCV ',nbcv
      if (mod(nbcv,2).ne.0) nbcv = nbcv-1
      nbcv = max(1,nbcv)
      vstep = -vmin/nbcv
    endif
    !
    ! Loop on U,V cells
    nbv = 0
    ivmin = 1
    do icv = 1,nbcv
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      new = ivmax-ivmin+1
      if (icv.eq.nbcv) then
        vimin = -unif
        call findp (nv,vv,vimin,ivmin)
        new = new + (nv-ivmin+1)
      endif
      nbv = max(new,nbv)
    enddo
    !
    !!print *,'OLD before Unif ',unif,' WM ',wm
    call doweig_quick (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,nbv,   &
       &    umin,umax,vmin,vmax,nbcv)
    !!print *,'OLD after Unif ',unif,' WM ',wm
  endif
  !
end subroutine doweig
!
subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
  use gildas_def
  use gkernel_interfaces
  use mapping_interfaces, except_this => doweig_sph
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   Support for UV_MAP
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  logical, intent(inout) :: error
  integer, intent(in), optional :: code  ! Number of sub-cells per UV uniform cell size
  !
  real, allocatable :: suu(:), svv(:), sww(:), swe(:)
  real :: weight, wmin, wmax, umin, umax, vmin, vmax
  real :: sizecell
  integer :: ier, mv, nbv, i, ivmin, icode
  character(len=120) :: mess
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! For tests only
  logical :: briggs=.false.
  real :: s2
  !
  ! Find the location of -unif
  ivmin = 1
  call findp (nv,vv,-unif,ivmin)
  !
  mv = 2*nv-ivmin+1
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),stat=ier)
  !
  suu(1:nv) = visi(jx,:)
  svv(1:nv) = visi(jy,:)
  sww(1:nv) = max(visi(jw,:),0.0)    
  !
  ! Find out extrema
  vmin = svv(1)
  vmax = unif
  umin = minval(suu(1:nv))
  umax = maxval(suu(1:nv))
  !
  ! Brutally apply Hermiticity
  nbv = nv
  do i=ivmin,nv
    nbv = nbv+1
    suu(nbv) = -visi(jx,i)
    svv(nbv) = -visi(jy,i)
    sww(nbv) = max(visi(jw,i),0.0)   
  enddo
  !
  ! Sub-divide the uniform cell size into sub-cells for speed
  ! The optimal depends on the density of UV points.
  ! In principle, it would depend on umin,umax, vmin,vmax and the
  ! number of points.  Use a stupid rule-of-thumb for now.
  !
  if (present(code).and.code.gt.0) then
    icode = max(2,code)
  else
    if (mv.le.2e5) then
      icode = 3
    else if (mv.le.1e6) then
      icode = 7
    else if (mv.le.5e6) then
      icode = 15
    else
      icode = 20
    endif
  endif
  sizecell = unif/icode
  !
  write(mess,'(A,I0,F6.1,F6.1)') "Gridding for ", mv, sizecell, unif
  call map_message(seve%i,rname,mess)
  write(mess,'(A,4F8.1)') "  and UV range ", umin, umax, vmin, vmax
  call map_message(seve%i,rname,mess)
  !
  call gridless_density(mv,sizecell,unif,suu,svv,sww,swe, &
    umin,umax,vmin,vmax,error)
  if (error) return
  !
  we(:) = swe(1:nv)
  !
  weight = 0.0
  wmax = 0.0
  wmin = 1.e36
  do i=1,nv
    if (we(i).gt.0.0) then
      wmin = min(we(i),wmin)
      wmax = max(we(i),wmax)
    endif
  enddo
  weight = sqrt(wmin*wmax)
  write(mess,'(A,2(1PG11.3,1X))') 'Relative Weight range ',wmin/weight,wmax/weight
  call map_message(seve%i,rname,mess)
  !
  if (briggs) then
    !
    ! Briggs Solution
    ! s = 5*10^(-Briggs)  with (typically) -2 < Briggs < 2
    !
    ! Experimentally, not as flexible as our default solution
    s2 = 5*10**(-wm)    ! s^2
    s2 = s2*s2
    do i=1,nv
      if (visi(jw,i).gt.0) then
        we(i) = visi(jw,i)/(s2*we(i)/weight+1.0)
      else
        we(i) = 0.0
      endif
    enddo
  else
    !
    ! S.Guilloteau solution
    weight = wm*weight
    do i=1,nv
      if (visi(jw,i).gt.0.0) then
        if (we(i).gt.weight) then
          we(i) = visi(jw,i)/we(i)*weight
        else
          we(i) = visi(jw,i)
        endif
      else
        we(i) = 0.0
      endif
    enddo
  endif
  !
end subroutine doweig_sph
!
subroutine gridless_density (npts,sizecell,distmax,evex,evey,eveweight,&
  & evesumweight,xmin,xmax,ymin,ymax,error)
  use gildas_def
  use mapping_interfaces, except_this => gridless_density
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust weighting
  !
  ! Stephane Paulin   OASU CNRS / U.Bordeaux  2016
  !
  ! Algorithm to compute the weighted neighborhood of each point in a large
  ! catalog. This algorithm was described, among other sources, by Daniel Briggs in
  ! his thesis. The idea is to avoid npts**2 calculations of the distance between
  ! each pair of points (npts is the # points). For that, one defines a grid only used
  ! to speed-up computation (result is independent of the grid).
  ! Step 1: In a given cell of the grid, all events are linked and the total weight
  !   of the cell is computed and kept in memory.
  ! Step 2: a pattern is computed, that is the same all over the field, whose radius
  !   is the maximum distance. Grid boxes can have 3 states: entirely inside the
  !   maximum distance, entirely outside, or in between (boxes noted 'intermediate'
  !   or 'mixed').
  ! The idea is to compute the distances only for events in these intermediate boxes.
  ! For other events, or the total weight of the box is added (if the box is inside),
  ! or the box is ignored (if outside). Next, the main loop consists on a loop on every
  ! event. For a given event, all boxes in the pattern are checked and treated accordingly.
  ! With this algorithm, one can have CPU times prop. to factor*npts*log(npts) with
  ! factor~2 (ie. when npts is multiplied by 10, the CPU is multiplied by ~45-50)

  ! Remarks/notes:
  ! - this is a preliminary approach for testing, where symmetries are not
  !   taken into account !!! ==> a given couple of coordinates (evex,evey) corresponds
  !   to one event
  !
  !----------------------------------------------------------------------
  real, intent(in) :: sizecell                ! size of a cell.
  ! this is a control parameter that does not change the result but
  ! change the calculation time: to minimize the CPU, the larger the
  ! event density, the smaller sizecell. ex: sizecell~20 (10, 5 resp.)
  ! for a catalog of 10**5 (10**6, 3x10**7) events
  integer, intent(in) :: npts                 ! total # of events
  real, intent(in) :: distmax                 ! maximum distance
  real(kind=4), intent(in) :: evex(npts)      ! X coordinates
  real(kind=4), intent(in) :: evey(npts)      ! Y coordinates
  real(kind=4), intent(in) :: eveweight(npts) ! Weight of event
  real(kind=4), intent(out) :: evesumweight(npts) ! Sum of the weights of all
  ! the events closer nearer than the maximum distance from the current event.
  real(kind=4), intent(in) :: xmin,ymin,xmax,ymax ! Min Max
  logical, intent(out) :: error               ! Error flag
  !
  ! Local
  integer(kind=4) :: nbboxx,nbboxy,nbbox,i,j,indice1,indice2
  integer :: xbox_cur,ybox_cur,nbcellmaxx,nbcellmaxy
  integer :: nbcellx,nbcelly,nbcellquartx,nbcellquarty
  real :: distmaxsq,temp
  real(kind=4) :: llx_cur,lly_cur,urx_cur,ury_cur,ulx_cen
  real(kind=4) :: llx_cen,lly_cen,lrx_cen,lry_cen,urx_cen,ury_cen,uly_cen
  real(kind=4) :: longest,shortest
  integer :: ier
  !
  ! Dynamic variables used by the gridless algorithm:
  ! each analysis has given # of events (npts) & size of the grid (sizecell==>nbbox)
  !
  real(kind=4), allocatable :: boxx(:),boxy(:)    ! Coordinates along box axis
  real, allocatable :: boxtotweight(:,:)          ! Total weight in boxes
  integer(kind=4), allocatable :: nextevent(:)    ! Chained pointer
  integer(kind=4), allocatable :: eveindx(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: eveindy(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: last(:,:)       ! Work array
  integer(kind=4), allocatable :: firstevent(:,:) ! First pointer of box
  integer(kind=4), allocatable :: boxnbevent(:,:) ! Number of events in box
  integer(kind=4), allocatable :: statebox(:,:)   ! Box status
  !
  error = .false.
  !
  distmaxsq = distmax*distmax
  evesumweight = 0
  !
  nbboxx = ceiling( (xmax-xmin) / sizecell)
  nbboxy = ceiling( (ymax-ymin) / sizecell)
  nbbox = nbboxx * nbboxy
  !
  ! Required elements
  error = .true.
  allocate(boxx(nbboxx),boxy(nbboxy),boxtotweight(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  allocate(firstevent(nbboxx,nbboxy),nextevent(npts),stat=ier)
  if (ier.ne.0) return
  ! Potentially avoidable arrays
  allocate(eveindx(npts),eveindy(npts),boxnbevent(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  ! Work array
  allocate(last(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
  error = .false.
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! basic initialisations
  do i = 1, nbboxy
    boxy(i) = (i-0.5)*sizecell + ymin
  enddo
  do i = 1, nbboxx
    boxx(i) = (i-0.5)*sizecell + xmin
  enddo
  boxnbevent = 0
  boxtotweight = 0
  last = 0
  !
  ! chaining the events
  eveindx = INT((evex-xmin)/sizecell) + 1  ! could be optimised/avoided, 
  ! but convenient in this preliminary version
  eveindy = INT((evey-ymin)/sizecell) + 1  ! idem
  !
  do i = 1, npts
    !
    ! could be optimised/avoided, but convenient in this preliminary version
    boxnbevent(eveindx(i),eveindy(i)) = boxnbevent(eveindx(i),eveindy(i)) + 1
    if (eveweight(i).gt.0) boxtotweight(eveindx(i),eveindy(i)) &
      & = boxtotweight(eveindx(i),eveindy(i)) + eveweight(i)
    !
    if (last(eveindx(i),eveindy(i)).EQ.0) then
      firstevent(eveindx(i),eveindy(i)) = i
    else
      nextevent(last(eveindx(i),eveindy(i))) = i
    endif
    last(eveindx(i),eveindy(i)) = i
  enddo
  deallocate(last)
  !
  ! defining the pattern
  !
  ! nbcellquart is the integer # of boxes in a quadrant excluding the axes
  temp = distmax / sizecell
  nbcellquartx = ceiling(temp)
  nbcellquarty = nbcellquartx ! working assumption: symmetry ==>
  ! in this preliminary version, only euclidian distances with 
  ! x<==>y (no ellipse but this would very simple to add this feature)
  !
  !nbcellmax is the maximum distance tolerated from 0, expressed in integer # of boxes
  nbcellmaxx = nbcellquartx
  nbcellmaxy = nbcellquarty
  !
  !nbcell is the # of boxes in the pattern
  nbcellx = nbcellmaxx*2
  nbcelly = nbcellmaxy*2
  !
  ! statebox specifies the status of a box : 1 <==> good ; 2 <==> mixed ; 3 <==> bad
  allocate(statebox(nbcellmaxx,nbcellmaxy))
  statebox = 0
  statebox(1,1) = 1

  ! Assumption: symmetry. For the moment we will assume all quarters are equivalent.
  ! Historically, the distance tests are performed considering the lower-left corner
  ! (so are the coordinates llx, lly, urx, ury... of the 'cur' pixel)
  ! but in the arrays indice 1 corresponds to the center and indice max corresponds
  ! to the outside, like an upper-right corner
  !
  llx_cen = 0
  lly_cen = 0
  urx_cen = sizecell
  ury_cen = sizecell
  lrx_cen = urx_cen
  lry_cen = lly_cen
  ulx_cen = llx_cen
  uly_cen = ury_cen
  !
  do indice1=1,nbcellquartx
    do indice2=1,nbcellquarty
      if (indice1.NE.1 .OR. indice2.NE.1) then
        ! there must be 2 loops:
        ! with indice2==1 & indice1>1 and shortest computed according to lr_cen ;
        ! with indice2>1 and shortest computed according to ur_cen
        !
        ! here the central pixel is refered with the suffix 'cen' while
        ! the floating pixel is refered by 'cur'
        !update 161017 cen is the upper-right pixel touching 0
        !
        urx_cur = indice1*sizecell
        ury_cur = indice2*sizecell
        !
        longest = calcdistsq(llx_cen,urx_cur,lly_cen,ury_cur)
        !
        if (longest.LE.distmaxsq) then
          statebox(indice1,indice2) = 1 ! reminder: 1 <==> good ; 2 <==> mixed ; 3 <==> bad
        else
          llx_cur = urx_cur - sizecell
          lly_cur = ury_cur - sizecell
          if (indice2.EQ.1) then
            shortest = calcdistsq(lrx_cen,llx_cur,lry_cen,lly_cur)
          else if (indice1.EQ.1) then
            shortest = calcdistsq(ulx_cen,llx_cur,uly_cen,lly_cur)
          else
            shortest = calcdistsq(urx_cen,llx_cur,ury_cen,lly_cur)
          endif
          if (shortest.LT.distmaxsq) then
            statebox(indice1,indice2) = 2
        !2 following lines are only for debugging (useless and slowing down the process)
        !else
        !  statebox(indice1,indice2) = 3 ! useless, was used for debugging but could be
          endif
        endif
      endif
    enddo
  enddo
  !
  ! main loop
  !
  ! For OMP programming, only evesumweight is updated here, so
  ! each Thread may get a copy, and we sum them later.
  ! All the rest can be shared arrays on input, and local variables
  ! for the loop indices or dependent intermediate variables
  !
  do i = 1, nbboxx
    do j = 1, nbboxy
      if (boxnbevent(i,j).GT.0) then
        call linkidenticalbox(boxnbevent(i,j),firstevent(i,j),boxtotweight(i,j), &
        & evesumweight,nextevent)
        do indice1 = 1, nbcellmaxx
          do indice2 = 1, nbcellmaxy
            if (indice1.NE.1 .OR. indice2.NE.1) then
              xbox_cur = i-1+indice1
              ybox_cur = j-1+indice2
              if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. xbox_cur.LE.nbboxx &
              & .AND.ybox_cur.LE.nbboxy) then
                if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
                  if (statebox(indice1,indice2).EQ.1) then
                    call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                      & evesumweight,nextevent)
                  else if (statebox(indice1,indice2).EQ.2) then
                    call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & evesumweight, eveweight, evex, evey, nextevent, &
                      & distmax, distmaxsq)
                  endif
                endif
              endif
            endif
            !
            if (indice1.LT.nbcellmaxx .AND. indice2.GT.1) then
              ! warning: left side of the horizontal line is excluded
              xbox_cur = i-indice1 ! warning: symmetry broken since the pattern is not centered
              ybox_cur = j-1+indice2
              if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. &
                  xbox_cur.LE.nbboxx .AND. ybox_cur.LE.nbboxy) then
                if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
                  if (statebox(indice1+1,indice2).EQ.1) then
                    call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                      & evesumweight,nextevent)
                  else if (statebox(indice1+1,indice2).EQ.2) then
                    call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                      & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                      & evesumweight, eveweight, evex, evey, nextevent, &
                      & distmax, distmaxsq)
                  endif
                endif
              endif
            endif
          enddo
        enddo
      endif
    enddo
  enddo
  !
  deallocate(statebox)
  deallocate(boxx,boxy,boxtotweight)
  deallocate(firstevent,nextevent)
  deallocate(eveindx,eveindy,boxnbevent)
  !
end subroutine gridless_density
!
function calcdistsq(x1,x2,y1,y2)
  ! @ private
  real(kind=4) calcdistsq ! intent(out)
  real(kind=4), intent(in) :: x1,y1,x2,y2
  !
  calcdistsq = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)
end function calcdistsq
!
!
subroutine linkidenticalbox(nb, ind_init, boxtotweight, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !
  real, intent(in) :: boxtotweight                    ! Box total weight
  integer(kind=4), intent(in) :: nb                   ! Size of chain
  integer(kind=4), intent(in) :: ind_init             ! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind = ind_init
  do i = 1, nb
    evesumweight(ind) = evesumweight(ind) + boxtotweight
    ind = nextevent(ind)
  enddo
end subroutine linkidenticalbox
!
subroutine linkgoodbox(nb1, nb2, ind1_init, ind2_init, &
  & boxtotweight1, boxtotweight2, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !
  !----------------------------------------------------------------------
  real, intent(in) :: boxtotweight1, boxtotweight2    ! Total weight of each box
  integer(kind=4), intent(in) :: nb1, nb2             ! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init ! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i = 1, nb1
    evesumweight(ind1) = evesumweight(ind1) + boxtotweight2
    ind1 = nextevent(ind1)
  enddo
  do i = 1, nb2
    evesumweight(ind2) = evesumweight(ind2) + boxtotweight1
    ind2 = nextevent(ind2)
  enddo
  !
end subroutine linkgoodbox
!
subroutine linkmixedbox(nb1, nb2, ind1_init, ind2_init, evesumweight, &
  & eveweight, evex, evey, nextevent, distmax, distmaxsq)
  use gildas_def
  use mapping_interfaces, only : calcdistsq
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support routine for Robust Weighting
  !
  !   Build chain list of different types
  !
  !----------------------------------------------------------------------
  integer(kind=4), intent(in) :: nb1, nb2             ! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init ! Starting index in each box
  real, intent(in) :: distmax, distmaxsq              ! Averaging radius
  real(4), intent(in) :: eveweight(:)                 ! Initial weights
  real(4), intent(in) :: evex(:)                      ! Event X coordinates
  real(4), intent(in) :: evey(:)                      ! Event Y coordinates
  real(kind=4), intent(inout) :: evesumweight(:)      ! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         ! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i, j
  !
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i =1,nb1
    do j = 1,nb2
      if (abs(evex(ind1)-evex(ind2)).LE.distmax) then
        if (abs(evey(ind1)-evey(ind2)).LE.distmax) then
          if (calcdistsq(evex(ind1),evex(ind2),evey(ind1),evey(ind2)).LE.distmaxsq) then
            evesumweight(ind1) = evesumweight(ind1) + eveweight(ind2)
            evesumweight(ind2) = evesumweight(ind2) + eveweight(ind1)
          endif
        endif
      endif
      ind2 = nextevent(ind2)
    enddo
    ind1 = nextevent(ind1)
    ind2 = ind2_init
  enddo
  !
end subroutine linkmixedbox
!
subroutine scawei (nv,uni,ori,wall)
  !---------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Scale the weights
  !---------------------------------------------------------
  integer, intent(in) :: nv     ! Number of visibilities
  real, intent(out) :: uni(nv)  ! Re-weighted weights
  real, intent(in)  :: ori(nv)  ! Original weights
  real, intent(out) :: wall     ! Sum of weights
  !
  integer i
  real(kind=8) a, s, s2
  !
  s = 0   ! Sum of scaling factors
  s2 = 0  ! Sum of square of scaling factors
  do i=1,nv
    if (uni(i).gt.0) then
      a = uni(i)/ori(i)
      s = s+uni(i)        ! s+a
      s2 = s2+uni(i)*a    ! s2+a*a
    endif
  enddo
  !
  ! Like UV_STAT, better result
  a = s / s2
  uni(1:nv) = uni(1:nv)*a
  wall = a*s
end subroutine scawei
!
subroutine chkfft (a,nx,ny,error)
  !---------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Check if FFT is centered...
  !---------------------------------------------------------
  integer, intent(in)  ::  nx,ny   ! X,Y size
  logical, intent(out)  ::  error  ! Error flag
  real, intent(in)  ::  a(nx,ny)   ! Array
  !
  error = a(nx/2+1,ny/2+1).eq.0.0
end subroutine chkfft
!
subroutine doweig_quick (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,mv, &
     &     umin,umax,vmin,vmax,nbcv)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  integer, intent(in) ::  mv          ! Size of work arrays
  integer, intent(in) ::  nbcv        ! Buffering factor
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  real, intent(in) ::  vv(nv)         ! V values, pre-sorted
  real, intent(out) :: umin,umax,vmin,vmax
  !
  ! Automatic arrays
  integer, allocatable :: ipv(:)
  real, allocatable :: utmp(:), vtmp(:), wtmp(:), rtmp(:)
  !
  integer i,iw
  real u,v,weight,wmax,wmin
  !
  real vstep,ustep,vimin,vimax,uimin,uimax
  real ucmin, ucmax, vcmin, vcmax
  integer nbcu, ivmin, ivmax, icu, icv, nbv, isub, ier
  character(len=message_length) :: chain
  character(len=*), parameter :: rname='DOWEIG'
  !
  allocate (utmp(mv), vtmp(mv), wtmp(mv), rtmp(mv), ipv(mv), stat=ier)
  !
  we(1:nv) = -1.0
  isub = 0
  !
  ! Some speed up factor
  nbcu = 2*nbcv
  vstep = -vmin/nbcv
  ustep = (umax-umin)/nbcu
  !
  ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
  ! than sufficient to get speed up.  -- Current coding guarantees the
  ! situation below never happens in GILDAS, so allow a fatal crash
  ! in case somebody else breaks the rule...
  if (vstep.lt.4*unif) then
    write (chain,*) 'Vstep is too small',vstep,unif,vmin,nbcv
    call map_message(seve%w,rname,chain)
    if (nbcv.ne.1) call sysexi(fatale)
  endif
  !
  ! There is a weight column
  if (jw.gt.0) then
    iw = 7+3*jw
    !
    ! Loop on U,V cells
    do icv = nbcv,1,-1
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      !
      do icu = 1,nbcu
        ucmin = (icu-1)*ustep+umin
        uimin = ucmin-unif
        ucmax = icu*ustep+umin
        uimax = ucmax+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          ! Note that V stays ordered by increasing values
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.ge.vimin).and.(v.le.vimax)) then
            if ((u.ge.uimin).and.(u.le.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
        enddo
        !
        ! Compute the weights
        if (nbv.gt.0) then
          isub = isub+1
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if ( (utmp(i).gt.ucmin.and.utmp(i).le.ucmax)   &
     &              .and. (vtmp(i).gt.vcmin.and.vtmp(i).le.vcmax) )   &
     &              then
              if (ipv(i).ne.0) then
                if (we(ipv(i)).ne.-1.0) then
                  print *,'Computed ',i,ipv(i),we(ipv(i)),rtmp(i)
                endif
                we(ipv(i)) = rtmp(i)
              endif
            endif
          enddo
        endif
        !
      enddo
      if (icv.eq.nbcv) call map_message(seve%i,rname,'Done boundary cells')
    enddo
    !
    ! All weights are computed now, normalize them
    weight = 0.0
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      wmax = max(we(i),wmax)
      if (we(i).gt.0.0) wmin = min(we(i),wmin)
      weight = weight+we(i)
    enddo
    weight = weight/nv
    !!write(6,*) 'Raw Weights ',weight,wmax,wmin,sqrt(wmin*wmax)*wm
    weight = wm*sqrt(wmin*wmax)
    !!write(6,*) 'Renormalized Weights ',wmax/weight,wmin/weight
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = visi(iw,i)/we(i)*weight
      elseif (we(i).gt.0.0) then
        we(i) = visi(iw,i)
      endif
    enddo
  else
    !
    ! No weighting column
    !
    ! Loop on U,V cells
    do icv = 1,nbcv
      vimin = (icv-1)*vstep+vmin-unif
      vimax = vimin+vstep+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      call findp (nv,vv,vimax,ivmax)
      !
      do icu = 1,nbcu
        uimin = (icu-1)*ustep+umin-unif
        uimax = uimin+ustep+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.gt.vimin).and.(v.lt.vimax)) then
            if ((u.gt.uimin).and.(u.gt.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
        enddo
        !
        ! Compute the weight density
        if (nbv.gt.0) then
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if (ipv(i).ne.0) we(ipv(i)) = rtmp(i)
          enddo
        endif
        !
      enddo
    enddo
    !
    weight = 0.0
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      wmax = max(we(i),wmax)
      if (we(i).gt.0.0) wmin = min(we(i),wmin)
      weight = weight+we(i)
    enddo
    weight = weight/nv
    !!write(6,*) 'Raw Weights ',weight,wmax,wmin,sqrt(wmin*wmax)*wm
    weight = wm*sqrt(wmin*wmax)
    !!write(6,*) 'Renormalized Weights ',wmax/weight,wmin/weight
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = 1.0/we(i)
      elseif (we(i).gt.0.0) then
        we(i) = 1.0/weight
      endif
    enddo
  endif
end subroutine doweig_quick
!
subroutine doweig_sub (nv,uu,vv,ww,we,unif)
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          ! number of values
  real, intent(in) ::  uu(nv)        ! U coordinates
  real, intent(in) ::  vv(nv)        ! V coordinates
  real, intent(in) ::  ww(nv)        ! Input Weights
  real, intent(out) ::  we(nv)       ! Output weights
  real, intent(in) ::  unif          ! Cell size
  !
  integer i,j
  real u,v,weight,v_aux
  integer :: ithread, mthread
  !
  ! Uniform weights only
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !!$  print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(), mthread
  !$OMP PARALLEL &
  !$OMP &   SHARED(ww,uu,vv),  &
  !$OMP &   PRIVATE(ithread,i,j,weight,u,v,v_aux)
  !
  !$OMP DO
  do i=1,nv
    if (ww(i).le.0.0) then
      we(i) = 0.0
    else
      weight = ww(i)
      u = uu(i)
      v = vv(i)
      j = i-1
      v_aux = v-unif
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      j = i+1
      v_aux = v+unif
      do while (j.le.nv .and. vv(j).lt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j+1
      enddo
      !
      ! Close to (U,V) = (0,0), take symmetry into account
      j = nv
      v_aux = -(v+unif)
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u+uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      we(i) = weight
    endif
  enddo
  !$OMP END DO
  !$OMP FLUSH
  !$OMP END PARALLEL
end subroutine doweig_sub
!
subroutine doweig_slow (jc,nv,visi,jx,jy,jw,unif,we,wm)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          ! number of values
  integer, intent(in) ::  jc          ! Number of "visibilities"
  integer, intent(in) ::  jx          ! X coord location in VISI
  integer, intent(in) ::  jy          ! Y coord location in VISI
  integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    ! Visibilities
  real, intent(in) ::  unif           ! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      ! Weight array
  real, intent(in) ::  wm             ! on input: % of uniformity
  !
  integer i,j,iw
  real u,v,weight,wmax,wmin,v_aux
  !
  ! There is a weight column
  if (jw.gt.0) then
    iw = 7+3*jw
    !
    ! Uniform weights
    if (unif.gt.0) then
      do i=1,nv
        if (visi(iw,i).le.0.0) then
          we(i) = 0.0
        else
          weight = visi(iw,i)
          v = visi(jy,i)
          u = visi(jx,i)
          j = i-1
          v_aux = v-unif
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (v-visi(jy,j)).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          j = i+1
          v_aux = v+unif
          do while (j.le.nv .and. visi(jy,j).lt.v_aux)
            ! unoptimized
            !                  do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j+1
          enddo
          !
          ! Close to (U,V) = (0,0), take symmetry into account
          j = nv
          v_aux = -(v+unif)
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (-visi(jy,j)-v).lt.unif)
            if (abs(u+visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          we(i) = weight
        endif
      enddo
      !
      weight = 0.0
      wmax = 0.0
      wmin = 1.e36
      do i=1,nv
        wmax = max(we(i),wmax)
        if (we(i).gt.0.0) wmin = min(we(i),wmin)
        weight = weight+we(i)
      enddo
      weight = weight/nv
      write(6,*) 'Weights ',weight,wmax,wmin,   &
     &        sqrt(wmin*wmax)*wm
      weight = wm*sqrt(wmin*wmax)
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = visi(iw,i)/we(i)*weight
        elseif (we(i).gt.0.0) then
          we(i) = visi(iw,i)
        endif
      enddo
    else
      !
      ! Natural weights
      do i=1,nv
        if (visi(iw,i).gt.0.0) then
          we(i) = visi(iw,i)
        else
          we(i) = 0.0
        endif
      enddo
    endif
  else
    !
    ! No weighting column
    if (unif.ge.0) then
      !
      ! Uniform weights
      do i=1,nv
        weight = 1
        v = visi(jy,i)
        u = visi(jx,i)
        j = i-1
        do while (j.gt.0 .and. (u-visi(jy,j)).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        j = i+1
        do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j+1
        enddo
        j = nv
        do while (j.ge.1 .and. (-visi(jy,j)-v).lt.unif)
          if (abs(u+visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        we(i) = weight
      enddo
      !
      weight = 0.0
      wmax = 0.0
      wmin = 1.e36
      do i=1,nv
        wmax = max(we(i),wmax)
        if (we(i).gt.0.0) wmin = min(we(i),wmin)
        weight = weight+we(i)
      enddo
      weight = weight/nv
      write(6,*) 'Weights ',weight,wmax,wmin,   &
     &        sqrt(wmin*wmax)*wm
      weight = wm*sqrt(wmin*wmax)
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = 1.0/we(i)
        elseif (we(i).gt.0.0) then
          we(i) = 1.0/weight
        endif
      enddo
    else
      !
      ! Natural weighting
      do i=1,nv
        we(i) = 1.0
      enddo
    endif
  endif
end subroutine doweig_slow

subroutine sic_format(c,n)
  use sic_interfaces, except_this=>sic_format
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*) :: c             !
  integer :: n                      !
  ! Local
  integer :: ier
  logical :: suite
  !
  suite = .false.
  call sblanc(c,n,suite,ier)
end subroutine sic_format
!
subroutine sblanc(c,n,suite,ier)
  use sic_interfaces, except_this=>sblanc
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Reduce the character string C to the standard SIC internal syntax:
  !  - Suppress all unecessary separators.
  !  - Character strings "abcd... " are not modified.
  !  - Reject blanks in single quote expressions e.g. '1 + 2 3' (same
  !    behaviour as LET A 1 + 2 3)
  !  - Ignores and destroys comments.
  !  - Take care of continuations lines
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c      ! Character string to be formatted
  integer(kind=4),  intent(inout) :: n      ! Length of C
  logical,          intent(inout) :: suite  ! Indicates continuation
  integer(kind=4),  intent(out)   :: ier    ! Error return code
  ! Local
  character(len=*), parameter :: rname='FORME'
  logical :: lo,li,chaine,math,some,slo,more
  integer(kind=4) :: i,m,nl
  character(len=1), parameter :: quote="'"
  character(len=1) :: b,p
  save chaine,math,lo,li
  !
  data chaine/.false./, math/.false./
  !
  ier = 1
  if (n.eq.0) return
  m = len(c)
  !
  if (.not.suite) then
    lo = .true.                ! Leading blanks should be removed
    slo = lo
    chaine=.false.             ! Reset string indicator
    math  =.false.
  else
    slo = lo
  endif
  some = .false.
  nl = n
  n  = 0
  !
  i = 1
  more = i.le.nl
  do while(more)
    !
    ! Toggle character string indicator
    if (c(i:i).eq.'"') then
      if (chaine) then
        b = c(i+1:i+1)         ! End of chain
        p = ')'
      else
        b = c(n:n)             ! Last character before Start of chain
        p = '('
      endif
      ! Start/End of chain can only be preceded/followed by
      !     Double quote 
      !     Simple quote 
      !     Back quote `
      !     Dot . (in logical expressions)
      !     Comma (e.g. func("a",1))
      !     Parenthesis ( preceding, ) following (in logical expressions)
      !     Space or tab
      if (b.ne.quote   .and. b.ne.'"' .and. b.ne.'.' .and. b.ne.' ' .and.  &
          b.ne.char(9) .and. b.ne.p   .and. b.ne.'`' .and. b.ne.',') then
        n = n+1
        c(n:n) = '"'
        call sic_message(seve%e,rname,'Syntax error at or near :')
        call sic_message(seve%e,rname,c(1:n))
        ier = 0
        return
      endif
      chaine=.not.chaine
    endif
    !
    ! Skip character strings
    if (chaine) then
      n = n+1
      if (i.ne.n) c(n:n)=c(i:i)
      if (i.gt.n) c(i:i)=' '
    else
      !
      ! Suppress redondant separators
      li=.false.
      !
      ! Space separator
      if (c(i:i).eq.' ' .or. c(i:i).eq.char(9)) then
        if (math) then
          call sic_message(seve%e,rname,'Spaces not allowed in single quote expressions')
          ier = 0
          return
        else
          li=.true.
          ! First one
          if (.not.lo) then
            c(i:i) = ' '
            n = n+1
            if (i.ne.n) c(n:n)=c(i:i)
            if (i.gt.n) c(i:i)=' '
          endif
        endif
        !
        ! Skip comment area
      elseif (c(i:i).eq.'!') then
        some = .true.
        more = .false.
        !
        ! Otherwise just increment
      else
        if (c(i:i).eq.quote) then
          math = .not.math
        endif
        n=n+1
        if (i.ne.n) c(n:n)=c(i:i)
        if (i.gt.n) c(i:i)=' '
      endif
    endif
    !
    ! End of loop
    if (more) then
      lo = li
      i = i+1
      more = i.le.nl
    endif
  enddo
  !
  ! Clean up end of line
  if (n.eq.0) then             ! No significant character
    if (suite) then
      if (slo) then
        n = -1
      else
        n = 0
      endif
    elseif (some) then
      n = 1
      c(n:n) = ' '
    endif
  else
    if (.not.chaine .and. c(n:n).eq.' ') then
      n = n-1
    endif
  endif
  !
  ! Take care of continuation line
  if (n.lt.1) then
    suite = .false.
  elseif (c(n:n).ne.'-') then
    suite = .false.
  else
    suite = .true.
  endif
  if (.not.suite) then
    if (chaine) then
      call sic_message(seve%e,rname,'Unbalanced quote count')
      ier = 0
      return
    endif
  else
    c(n:n) = ' '
    n = n-1
    if (c(n:n).eq.' ') lo=.true.
  endif
  if (n.lt.m) c(n+1:) = ' '
end subroutine sblanc
!
function sic_eqchain(a,b)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: sic_eqchain            !
  character(len=*) :: a             !
  character(len=*) :: b             !
  ! Local
  character(len=1) :: ca,cb
  integer :: i,ic,la,lb
  !
  sic_eqchain = .false.
  la = len_trim(a)
  lb = len_trim(b)
  if (la.ne.lb) return
  !
  do i=1,la
    ca = a(i:i)
    cb = b(i:i)
    if (ca.ne.cb) then
      if (ca.ge.'a' .and. ca.le.'z') then
        ic=ichar(ca)+ichar('A')-ichar('a')
        ca=char(ic)
        if (ca.ne.cb) return
      elseif  (cb.ge.'a' .and. cb.le.'z') then
        ic=ichar(cb)+ichar('A')-ichar('a')
        cb=char(ic)
        if (ca.ne.cb) return
      else
        return
      endif
    endif
  enddo
  sic_eqchain = .true.
end function sic_eqchain

subroutine gconne(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gconne
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !   CONNECT/BLANKING Bval Eval
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=size_length) :: ixy
  integer(kind=4) :: form,narg
  type(sic_descriptor_t) :: xinca,yinca
  integer(kind=address_length) :: ipx,ipy
  real(kind=8) :: bval,eval
  real(kind=4) :: r4bv,r4ev
  !
  save xinca,yinca
  !
  ! /FILL option
  if (sic_present(2,0)) then
    call grfill (line,error)
    return
  endif
  !
  eval = eblank
  call sic_r8 (line,1,2,eval,.false.,error)
  if (error) return
  bval = cblank
  call sic_r8 (line,1,1,bval,.false.,error)
  if (error) return
  narg = sic_narg(0)
  if (narg.eq.0 .or. narg.eq.2) then
    form = 0
    call get_incarnation('CONNECT',line,form,ixy,xinca,yinca,error)
    if (error) return
    ipx = gag_pointer(xinca%addr,memory)
    ipy = gag_pointer(yinca%addr,memory)
    if (form.eq.fmt_r8) then
      call gr8_connect(ixy,memory(ipx),memory(ipy),bval,eval)
    else
      r4bv=bval
      r4ev=eval
      call gr4_connect(ixy,memory(ipx),memory(ipy),r4bv,r4ev)
    endif
    call sic_volatile(xinca)
    call sic_volatile(yinca)
  endif
end subroutine gconne
!
subroutine get_incarnation(command,line,form,ixy,xinca,yinca,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>get_incarnation
  use gildas_def
  use sic_types
  use greg_xyz
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GreG Internal routine
  !   Get incarnation of variables in command line, defaulting to X Y
  ! Warning: this routine may be called with more than 3 arguments on
  ! the command line (see RGDATA command).
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: command  !
  character(len=*),          intent(in)    :: line     !
  integer(kind=4),           intent(inout) :: form     !
  integer(kind=size_length), intent(out)   :: ixy      !
  type(sic_descriptor_t),    intent(out)   :: xinca    !
  type(sic_descriptor_t),    intent(out)   :: yinca    !
  logical,                   intent(inout) :: error    !
  ! Local
  character(len=80) :: var,chain
  logical :: found
  integer(kind=4) :: narg,nc
  type(sic_descriptor_t) :: xdesc,ydesc
  !
  data found/.false./
  !
  narg = sic_narg(0)
  if (narg.ge.2) then
    call sic_ch (line,0,1,var,nc,.true.,error)
    if (error) return
  else
    var = 'X'
  endif
  found = .true.
  call sic_materialize(var,xdesc,found)
  if (.not.found) then
    chain = 'Unknown variable '//var
    call greg_message(seve%e,command,chain)
    error = .true.
    return
  endif
  if (narg.ge.2) then
    call sic_ch (line,0,2,var,nc,.true.,error)
    if (error) return
  else
    var = 'Y'
  endif
  found = .true.
  call sic_materialize(var,ydesc,found)
  if (.not.found) then
    chain = 'Unknown variable '//var
    call greg_message(seve%e,command,chain)
    call sic_volatile(xdesc)   ! It may have been transposed...
    error = .true.
    return
  endif
  if (form.eq.0) then
    if (xdesc%type.eq.fmt_r4 .and. ydesc%type.eq.fmt_r4) then
      form = fmt_r4
    else
      form = fmt_r8
    endif
  endif
  call sic_incarnate(form,xdesc,xinca,error)
  if (error) then
    write(*,*) 'Error! ',var ! xdesc,xinca
    return
  endif
  call sic_incarnate(form,ydesc,yinca,error)
  if (error) then
    ! Must free both XDESC and XINCA if they are Transposed and Incarnated
    ! but they could point to the same virtual memory ...
    if (sic_notsamedesc(xdesc,xinca)) call sic_volatile(xdesc)
    call sic_volatile(xinca)
    return
  endif
  !
  if (yinca%size.ne.xinca%size) then
    call greg_message(seve%w,command,'Arrays have different sizes')
  endif
  ixy = min(xinca%size,yinca%size)
  if (form.eq.fmt_r8 .or. form.eq.fmt_i8) ixy = ixy/2
  ! Must free both XDESC and YDESC if they are Transposed
  ! but they could point to the same virtual memory as their Incarnation...
  if (sic_notsamedesc(xdesc,xinca)) call sic_volatile(xdesc)
  if (sic_notsamedesc(ydesc,yinca)) call sic_volatile(ydesc)
end subroutine get_incarnation

subroutine conmap(line,error)
  use gbl_message
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>conmap
  use greg_contours
  use greg_kernel
  use greg_pen
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !     RGMAP
  !   1     /ABSOLUTE aval
  !   2     /PERCENT  pval
  !   3     /KEEP filename [blank]
  !   4     /BLANKING bval Eval
  !   5     /GREY First nstep
  !   6     /PENS pos neg
  !   7     /ONLY Positive|Negative 
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RGMAP'
  character(len=40) :: name
  character(len=80) :: chain
  real(kind=4) :: spval,epsval,alev,plev,zmin,zmax
  real(kind=4), pointer :: sub(:,:)
  integer(kind=4), allocatable :: iwork(:)
  real(kind=4), allocatable :: swork(:)
  integer(kind=4) :: nx_old,ny_old,kx,ky,minx,maxx,miny,maxy,n1,n2
  integer(kind=4) :: ipen_old,n,nc,jlev
  logical :: subset,fastmode
  real(kind=8) :: xref_old,yref_old
  integer(kind=size_length), parameter :: nsummits=5
  real(kind=4) :: boxx(nsummits),boxy(nsummits)
  integer(kind=4) :: basecolo,colid,ier
  integer, parameter :: max_gzmin=100
  real(kind=4) :: buf_gzmin(max_gzmin)
  integer(kind=4) :: ibuf_gz
  integer(kind=4) :: kchunk,chunky,nchunk,rchunk,chumin,chumax,mychunk
  !
  integer :: my_ncl, the_ncl, klev
  real :: my_cl(maxl), the_cl(maxl)
  real :: s, sign_only
  character(len=12) :: positive='POSITIVE'
  character(len=12) :: negative='NEGATIVE' 
  character(len=12) :: fast='FAST'
  character(len=12) :: quiet='QUIET'
  ! Saved variables
  save alev,plev
  !
  ! Check if something to do
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
    return
  endif
  alev=1.0
  plev=1.0
  fastmode=.false.
  chunkpatch=.false.
  quietmode = sic_present(0,1)
  if (quietmode) then
    call sic_ke (line,0,1,name,nc,.true.,error)
    if (error) return
    nc = min(nc,12)
    fastmode=(name(1:nc).eq.fast(1:nc))
    quietmode=(name(1:nc).eq.quiet(1:nc))
  endif
  ! Grey scale and Chunks...
  mychunk=chunksize
  !
  ipen_old = cpen
  !
  ! Blanking Value ?
  if (sic_present(4,0)) then  ! /BLANKING
    call sic_r4 (line,4,1,spval,.true.,error)
    if (error) goto 999
    epsval = 0.  ! And not 'eblank' which can be negative <=> no blanking.
    call sic_r4 (line,4,2,epsval,.false.,error)
    if (error) goto 999
  else
    spval = cblank
    epsval = eblank
  endif
  if (sic_present(5,0)) then  ! /GREY
    ! Fill contours do not support BLANKING at all..
    call conblk(.false.,spval,epsval)
  elseif (epsval.ge.0.e0) then
    call conblk(.true.,spval,epsval)
    if (.not.quietmode) then
      write(chain,'(A,1PG13.6)') 'Contouring checks the blanking value ',spval
      call greg_message(seve%i,rname,chain)
    endif
  else
    call conblk(.false.,spval,epsval)
    if (.not.quietmode)  &
      call greg_message(seve%i,rname,'Contouring checks no blanking value')
  endif
  !
  ! Set contour factor
  if (sic_present(1,0)) then   ! Absolute
    if (sic_present(2,0)) then
      call greg_message(seve%e,rname,'Conflicting options : /ABSOLUTE and '//  &
      '/PERCENT')
      goto 999
    endif
    call sic_r4 (line,1,1,alev,.false.,error)
    if (error) goto 999
    qlev = alev
  elseif (sic_present(2,0)) then   ! Percent factor
    call sic_r4 (line,2,1,plev,.false.,error)
    if (error) goto 999
    call rgextr(0,zmin,zmax,rg%data,spval,epsval,.false.)
    qlev = plev*max(abs(zmin),abs(zmax))*0.01
  else                         ! No factor
    qlev = 1.
  endif
  !
  ! Select pens used for positive and negative contours
  ipen_pos = 0                 ! Default as requested by Steph...
  ipen_neg = 15
  if (sic_present(6,0)) then
    ipen_pos = cpen
    call sic_i4 (line,6,1,ipen_pos,.false.,error)
    if (error) goto 999
    ipen_neg = ipen_pos
    call sic_i4 (line,6,2,ipen_neg,.false.,error)
    if (error) goto 999
  endif
  if (.not.quietmode.and..not.sic_present(5,0)) then
    write(chain,'(A,I3,A,I3,A)') 'Pens',ipen_pos,' &',ipen_neg,  &
    ' used for positive & negative levels'
    call greg_message(seve%i,rname,chain)
  endif
  !
  ! Select levels to be processed through the /ONLY option
  sign_only = 0
  if (sic_present(7,0)) then
    call sic_ke (line,7,1,name,nc,.true.,error)
    if (name(1:nc).eq.positive(1:nc)) then
      sign_only = 1
    else if (name(1:nc).eq.negative(1:nc)) then
      sign_only = -1
    endif
  endif
  !
  if (sign_only.eq.0) then
    call conlev(qlev,cl,ncl)
    my_ncl = 0
  else 
    my_ncl = 0
    do jlev=1,ncl
      if (sign_only*cl(jlev).gt.0) then
        my_ncl = my_ncl+1
        my_cl(my_ncl) = cl(jlev)
      endif
    enddo
    if (my_ncl.eq.0) then
      call greg_message(seve%e,rname,'/ONLY: no valid level')
      goto 999
    endif
    call conlev(qlev,my_cl,my_ncl)
  endif
  !
  ! Keep contour on a formatted file ?
  if (sic_present(3,0)) then
    lout = .false.             ! Until OPEN
    if (eblank.lt.0) then
      call sic_r4 (line,3,2,blankfk,.true.,error)
      if (error) goto 999
    else
      blankfk = cblank
      call sic_r4 (line,3,2,blankfk,.false.,error)
      if (error) goto 999
    endif
    call sic_ch (line,3,1,name,nc,.true.,error)
    write(chain,'(A,1PG13.6)') '/KEEP writes the blanking value',blankfk
    call greg_message(seve%i,rname,chain)
    call sic_parsef (name,chain,' ','.dat')
    name=chain
    open(unit=jtmp,file=name,status='NEW',err=995)
    lout = .true.
  else
    lout = .false.
  endif
  !
  ! Check that map is visible, compute size of subset that can eventually been
  ! loaded:
  n1 = (gux1 - rg%xval)/rg%xinc + rg%xref
  n2 = (gux2 - rg%xval)/rg%xinc + rg%xref
  minx = min(n1,n2)-1
  maxx = max(n1,n2)+1
  if (maxx.lt.1 .or. minx.gt.rg%nx) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  n1 = (guy1 - rg%yval)/rg%yinc + rg%yref
  n2 = (guy2 - rg%yval)/rg%yinc + rg%yref
  miny = min(n1,n2)-1
  maxy = max(n1,n2)+1
  if (maxy.lt.1 .or. miny.gt.rg%ny) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  minx = max(1,minx)
  maxx = min(rg%nx,maxx)
  maxy = min(rg%ny,maxy)
  miny = max(1,miny)
  kx = maxx-minx+1
  ky = maxy-miny+1
  if (kx*ky.le.0) then
    call greg_message(seve%w,rname,'Map is not visible')
    if (lout) close(unit=jtmp,status='DELETE')
    return
  endif
  !
  if (sic_present(5,0)) then
    if (sic_present(3,0)) then
      call greg_message(seve%e,rname,'Conflicting options : /GREY and /KEEP')
      goto 999
    endif
    if (sic_present(4,0)) then
      call greg_message(seve%w,rname,'BLANKING ignored in Filled contour mode')
    endif
    lgrey = .true.
    ! Test a user-supplied Chunksize
    if (sic_present(0,1).and..not.quietmode.and..not.fastmode) then
      mychunk=chunksize
      call sic_i4(line,0,1,mychunk,.false.,error)
      error=.false.
    endif
    if (sic_present(5,1)) then
      call sic_i4 (line,5,1,ncolo,.false.,error)
      if (error) goto 999
      ncolo = max(1,min(ncolo,16))+7   ! intervalle 8-23
      if (sic_present(5,3)) then  ! RGMAP /GREY background
        call gtv_pencol_num2id(rname,ncolo,colid,error)
        if (error) goto 999
        call gr_segm('GREYBOX',error)
        call setcol(colid)
        boxx(1) = gx1
        boxy(1) = gy1
        boxx(2) = gx1
        boxy(2) = gy2
        boxx(3) = gx2
        boxy(3) = gy2
        boxx(4) = gx2
        boxy(4) = gy1
        boxx(5) = gx1
        boxy(5) = gy1
        call gr_fillpoly(nsummits,boxx,boxy)
        call gtsegm_close(error)
        ncolo=ncolo+1
        ncolo=mod((ncolo-9),16)+8
        ! ZZZ use parameters
      endif
      nstep = 1
      call sic_i4 (line,5,2,nstep,.false.,error)
      if (error) goto 999
      basecolo = ncolo
    else
      ncolo = 8
      nstep = 1
      basecolo = ncolo
    endif
  else
    lgrey = .false.
  endif
  !
  ! Test validity of "MYCHUNK" :
  ! do not perform contours on strips thinner than 4 pixels..
  if (mychunk.lt.kx*4) then
    mychunk=chunksize
    call greg_message(seve%w,rname,'Too small Chunk, using default value')
  endif
  !
  ! Optimize subset of "large" maps : load subset into work area;
  ! for grey contours, to maintain a reasonable size of the contour tree,
  ! we cut the map in chunks of CHUNKSIZE pixels and perform contour filling
  ! on these submaps. Hey, this should be done also for normal contours, as long
  ! as nobody asks for a printout. (or could be a "fast" option).
  if (.not.lgrey.and..not.fastmode) then
    subset = .false.
    sub => rg%data
    if (rg%nx*rg%ny.ge.mychunk) then
      if (1.5*kx*ky.lt.1.*rg%nx*rg%ny) then
        allocate(sub(kx,ky),stat=ier)
        if (ier.ne.0) goto 994
        subset = .true.
        ! Save old values
        nx_old = rg%nx
        ny_old = rg%ny
        rg%nx = kx
        rg%ny = ky
        xref_old = rg%xref
        yref_old = rg%yref
        rg%xref = xref_old + 1 - minx
        rg%yref = yref_old + 1 - miny
        call ext001 (rg%data,nx_old,ny_old,sub,rg%nx,rg%ny,minx,maxx,miny,maxy)
      endif
    endif
    ! Get work space for contours
994 n = max(rg%nx*rg%ny/5,1024)
    allocate(iwork(n),stat=ier)
    if (failed_allocate(rname,'iwork array',ier,error))  goto 998
    ilev = 0
    ! Contouring
    call conreg (rg%nx,rg%ny,sub,frstd,vectd,lastd,contd,iwork,n,error)
    deallocate(iwork)
    ! Reset pen and set last contoured map
    if (lout) close(unit=jtmp)
    cpen = ipen_old
    penupd = .true.
    if (subset) then
      deallocate(sub)
      rg%nx = nx_old
      rg%xref = xref_old
      rg%ny = ny_old
      rg%yref = yref_old
      subset = .false.
    endif
    return
  elseif (kx*ky.le.mychunk) then
    ! grey: subset of size =< MYCHUNK does not need to be cut in chunks.
    ! If NX*NY is =< MYCHUNK, it is even better (no subset extraction needed).
    ! Serves also for "fast" mode (which is able to contour ANY map).
    subset = .false.
    sub => rg%data
    if (rg%nx*rg%ny.gt.mychunk) then
      allocate(sub(kx,ky),stat=ier)
      if (ier.ne.0) goto 993
      subset = .true.
      ! Save old values
      nx_old = rg%nx
      ny_old = rg%ny
      rg%nx = kx
      rg%ny = ky
      xref_old = rg%xref
      yref_old = rg%yref
      rg%xref = xref_old + 1 - minx
      rg%yref = yref_old + 1 - miny
      call ext001(rg%data,nx_old,ny_old,sub,rg%nx,rg%ny,minx,maxx,miny,maxy)
    else
      !SG! PRINT *,'No truncation '
    endif
    !     Get work space for contours
993 n = max(rg%nx*rg%ny*2,1000)
    allocate(iwork(n),stat=ier)
    if (failed_allocate(rname,'iwork buffer',ier,error))  goto 998
    ilev = 0
    ! Contouring
    if (lgrey) then
      ! Remember the default Level list, because HIGHWATER
      ! assumes the list starts from 1 and is identical to that 
      ! loaded to conlev.
      the_ncl = ncl
      the_cl = cl
      if (my_ncl.ne.0) cl = my_cl
      ! Compute subset extrema to insure correct filling for adjacent patches
      ! by correct estimate of HIGHWATER. No, GZMIN is .NOT..EQ.RGMIN, and
      ! we have to recompute it (this because RGMIN is for a whole cube,
      ! or because we look only at a subset of the map).
      if (subset) then
!         This is incorrect, and overrides the current RG data extrema
!           call rgextr(0,gzmin,gzmax,sub,spval,epsval,.true.)
!         The generic code works...
        call gr4_sub_extrema(sub,rg%nx,rg%ny,spval,epsval,gzmin,gzmax, &
          & 1,rg%nx,1,rg%ny) 
      else
        call gr4_sub_extrema(sub,rg%nx,rg%ny,spval,epsval,gzmin,gzmax, &
          & minx,maxx, miny,maxy)
      endif
      call conreg(rg%nx,rg%ny,sub,frstg,vectg,lastg,contg,iwork,n,error)
      !
      ! Restore the default Level list
      cl = the_cl
      ncl = the_ncl
    else
      call conreg(rg%nx,rg%ny,sub,frstd,vectd,lastd,contd,iwork,n,error)
    endif
    deallocate(iwork)
    ! Reset pen and set last contoured map
    cpen = ipen_old
    penupd = .true.
    if (subset) then
      deallocate(sub)
      rg%nx = nx_old
      rg%xref = xref_old
      rg%ny = ny_old
      rg%yref = yref_old
      subset = .false.
    endif
    return
  else
    ! Grey: subset of size < MYCHUNK is cut in chunks (lines)
    ! compute subsets sizes:
    n = mychunk*2
    allocate(swork(mychunk),iwork(n),stat=ier)
    if (failed_allocate(rname,'swork and iwork arrays',ier,error))  goto 999
    ! Save old values
    nx_old = rg%nx
    ny_old = rg%ny
    xref_old = rg%xref
    yref_old = rg%yref
    rg%nx = kx
    chunky=mychunk/kx          !nb of lines in chunk
    nchunk=ky/chunky           !nb of submaps of KX*CHUNKY
    rchunk=ky-nchunk*chunky+nchunk-1   !1 pixel overlap
    do while (rchunk.ge.chunky)
      nchunk=nchunk+1
      rchunk=rchunk-chunky
    enddo
    rchunk=max(rchunk,0)
    if (rchunk.gt.0) nchunk=nchunk+1
    ncolo = basecolo
    chunkpatch=.true.
    !
    klev = 0
    do jlev=1,ncl     
      !
      ! Select only the requested Sign
      s = sign(1.0,cl(jlev))
      if (s*sign_only.lt.0) cycle
      if (klev.eq.0) klev = jlev  ! First level
      !
      rg%xref = xref_old+1-minx
      chumin = miny
      if (lgrey) then
        call gtv_pencol_num2id(rname,ncolo,colid,error)
        if (error) goto 999
        call gr_segm('GREY',error)
        call setcol(colid)
      else
        call gr_segm('CONTOUR',error)
        if (cl(jlev).lt.0.0) then
          call setpen(ipen_neg)
        else
          call setpen(ipen_pos)
        endif
      endif
      do kchunk=1,nchunk
        chumax=min((chumin+chunky-1),maxy)
        rg%ny =chumax-chumin+1
        rg%yref = yref_old+1-chumin
        call ext001(rg%data,nx_old,ny_old,swork,rg%nx,rg%ny,minx,maxx,  &
          chumin,chumax)
        call conlev(qlev,cl(jlev),1)
        ! Ilev is incremented by conreg
        ilev = jlev-1
        if (lgrey) then
          ! Compute subset extrema to insure correct filling for adjacent patches
          ! by correct estimate of HIGHWATER. note that here GZMIN is buffered.
          ibuf_gz = min(kchunk,max_gzmin)
          if (klev.eq.1.or.kchunk.ge.max_gzmin) then
            ! This would overwrite the RG extrema          
            !   call rgextr(0,buf_gzmin(ibuf_gz),gzmax,swork,spval,epsval,.true.)
            call gr4_sub_extrema(swork,rg%nx,rg%ny,spval,epsval,buf_gzmin(ibuf_gz),gzmax, &
              &   1,rg%nx,1,rg%ny)
          endif
! This looks incorrect and can overflow buf_gzmin
!          gzmin=buf_gzmin(kchunk)
! Use this instead
          gzmin = buf_gzmin(ibuf_gz)
          call conreg (rg%nx,rg%ny,swork,frstg,vectg,lastg,contg,iwork,n,error)
        else
          call conreg (rg%nx,rg%ny,swork,frstd,vectd,lastd,contd,iwork,n,error)
        endif
        if (error) then
          if (lgrey) then
            call greg_message(seve%i,rname,'Try a smaller ChunkSize (see HELP)')
          endif
          goto 992
        endif
        chumin = chumax
        cpen   = ipen_old
        penupd = .true.
      enddo
      if (lgrey) then
        ncolo = ncolo+nstep    ! another one
        ncolo=mod((ncolo-8),16)+8  ! pen [8-23]
      endif
      call gtsegm_close(error)
      if (error)  return
    enddo
992 continue
    !
    deallocate(iwork,swork)
    rg%nx = nx_old
    rg%xref = xref_old
    rg%ny = ny_old
    rg%yref = yref_old
    cpen = ipen_old
    penupd = .true.
    return
  endif
  !
995 call greg_message(seve%e,rname,'Cannot open the file requested by /KEEP')
  goto 999
998 continue
  if (subset) then
    deallocate(sub)
    rg%nx = nx_old
    rg%xref = xref_old
    rg%ny = ny_old
    rg%yref = yref_old
    subset = .false.
  endif
999 error=.true.
  if (lout) close(unit=jtmp,status='DELETE')
  cpen = ipen_old
  penupd = .true.
end subroutine conmap
!
subroutine ext001(a,nx,ny,b,kx,ky,minx,maxx,miny,maxy)
  use greg_interfaces, except_this=>ext001
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: nx        !
  integer(kind=4), intent(in) :: ny        !
  real(kind=4),    intent(in) :: a(nx,ny)  !
  integer(kind=4), intent(in) :: kx        !
  integer(kind=4), intent(in) :: ky        !
  real(kind=4)                :: b(kx,ky)  ! inout?
  integer(kind=4), intent(in) :: minx      !
  integer(kind=4), intent(in) :: maxx      !
  integer(kind=4), intent(in) :: miny      !
  integer(kind=4), intent(in) :: maxy      !
  ! Local
  integer(kind=4) :: ja,jb
  integer(kind=4) :: px
  !
  px = min(maxx-minx+1,kx)
  do ja = miny,min(maxy,ky+miny-1)
    jb = ja - miny + 1
    call r4tor4(a(minx,ja),b(1,jb),px)
  enddo
end subroutine ext001
!
subroutine frstd (icode,error)
  use gbl_message
  use greg_interfaces, except_this=>frstd
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. Then plots the contour line using CONNECT
  !  Take care of grey scale contouring on SECAPA.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: icode  !
  logical,         intent(inout) :: error  !
  ! Local
  real(kind=4) :: cv
  character(len=message_length) :: chain
  !
  ! Beginning of new contour operation. Reset buffer and level counter.
  !
  ldd  = 0
  if (.not.chunkpatch) then
    if (icode.eq.2) then
      call gr_segm('CONTOUR',error)
      call setpen(ipen_neg)
    else
      call gr_segm('CONTOUR',error)
      call setpen(ipen_pos)
    endif
  endif
  mxu = maxu
  ilev = ilev+1
  cv=cl(ilev)*qlev
  if (.not.quietmode) then
    write(chain,'(A,I3,1X,1PG13.6)') 'Contour ',ilev,cv
    call greg_message(seve%i,'RGMAP',chain)
  endif
  if (lout) write(jtmp,*) blankfk,blankfk,'  Start contour ',ilev,cv
  link = .false.
end subroutine frstd
!
subroutine vectd(x,y,error)
  use greg_interfaces, except_this=>vectd
  use greg_contours
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. Then plots the contour line using CONNECT
  !  Middle of contour line; Convert to user coordinates
  !  Return if still some place left in buffer
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: x      !
  real(kind=4), intent(in)    :: y      !
  logical,      intent(inout) :: error  !
  !
  ldd=ldd+1
  xu(ldd) = (x-rg%xref)*rg%xinc + rg%xval
  yu(ldd) = (y-rg%yref)*rg%yinc + rg%yval
  if (ldd.lt.mxu) return
  !
  ! Flush buffer if full or if end of contour line
  !
  link = .true.
  call lastd(error)
end subroutine vectd
!
subroutine lastd(error)
  use gildas_def
  use greg_interfaces, except_this=>lastd
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Plots the contour line using CONNECT.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer(kind=size_length) :: k
  !
  call press_ctrlc(error)
  if (error) return
  ! Simple contour drawing
  call gr4_connect(ldd,xu,yu,0.e0,-1.e0)
  if (lout) then
    do k=1,ldd
      write(jtmp,*) xu(k),yu(k)
    enddo
    if (.not.link) then
      write(jtmp,*) blankfk,blankfk,'  End of part of contour ',ilev
    endif
  endif
  !
  ! Prepare buffer if linked contours;
  if (link) then
    xu(1) = xu(ldd)
    yu(1) = yu(ldd)
    ldd = 1
    link = .false.
  else
    ldd = 0
  endif
end subroutine lastd
!
subroutine contd(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>contd
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Show it
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call press_ctrlc(error)
  if (error) return
  !
  if (.not.chunkpatch)  call gtsegm_close(error)
  !
end subroutine contd
!
subroutine frstg(icode,error)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>frstg
  use greg_contours
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !   For each contour level, puts (X,Y) Coordinates of contour into
  ! arrays XU,YU. For Grey-scale.
  !   Call INIT_TREE to reset the filling capability
  !---------------------------------------------------------------------
  integer(kind=4)                :: icode  ! Unused
  logical,         intent(inout) :: error  !
  ! Local
  character(len=60) :: chain
  real :: cv
  !
  ! Beginning of new contour operation. Reset buffer and level counter.
  !
  ldd = 0
  mxu = 0
  call init_tree(icode,noclip_gris,error)
  if (error) return
  noclip_gris = .not.noclip_gris
  if (.not.quietmode.and..not.chunkpatch) then
    write(chain,'(A,I3,1X,1PG13.6)') 'Filling Contour ',ilev,cl(ilev)*qlev
    call greg_message(seve%i,'RGMAP',chain)
  endif
  ! Highwater is used to tell whether a void contour (at some level), should be
  ! filled anyway (to the extent of the map). This because contours BELOW the
  ! threshold should appear (as pixels below threshold appear on the pixel image:
  ! this capacity is needed when contouring several planes in a cube),
  ! and because, when a map is divided in chunks, some contours may not be drawn
  ! on a certain chunk just because all the pixels in the chunk would be above
  ! that contour level.
  cv=cl(ilev)*qlev
  highwater = cv.le.gzmin   !!  and NOT cl(ilev).le.gzmin
  !
end subroutine frstg
!
subroutine vectg(x,y,error)
  use gildas_def
  use gbl_message
  use greg_interfaces, except_this=>vectg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Middle of contour line; Convert to user coordinates.
  !  We should also clip here... If clipping applies, then a pseudo-end
  ! of contour appears
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: x      !
  real(kind=4), intent(in) :: y      !
  logical                  :: error  !
  ! Local
  character(len=*), parameter :: rname='VECTG'
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  integer(kind=4), allocatable :: tmpx(:),tmpy(:)
  !
  if (mxu.eq.0) then
    mxu = maxu
    allocate(ixu(mxu),iyu(mxu),stat=ier)
    if (ier.ne.0)  goto 10
    !
  elseif (ldd.ge.mxu) then
    write(mess,'(A,I0)') 'Reallocating virtual memory to ',mxu
    call greg_message(seve%d,rname,mess)
    !
    allocate(tmpx(mxu),tmpy(mxu),stat=ier)
    if (ier.ne.0)  goto 10
    tmpx(:) = ixu(:)
    tmpy(:) = iyu(:)
    !
    deallocate(ixu,iyu,stat=ier)
    if (ier.ne.0)  goto 10
    allocate(ixu(2*mxu),iyu(2*mxu),stat=ier)
    if (ier.ne.0)  goto 10
    ixu(1:mxu) = tmpx(:)
    iyu(1:mxu) = tmpy(:)
    deallocate(tmpx,tmpy,stat=ier)
    if (ier.ne.0)  goto 10
    !
    mxu = 2*mxu
  endif
  ldd = ldd+1
  ixu(ldd) = nint(x*1e4)  ! Real centimeters to integer microns
  iyu(ldd) = nint(y*1e4)  ! Real centimeters to integer microns
  return
  !
  ! Allocation error
10 continue
  call greg_message(seve%e,rname,'Error allocating/deallocating arrays')
  error = .true.
  return
end subroutine vectg
!
subroutine lastg(error)
  use gildas_def
  use greg_interfaces, except_this=>lastg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  End of contour line; Plots the contour line using FILL_VECT (to
  ! put a vector) and FILL_CONT (to end a contour)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: c,c0,c1
  integer(kind=4) :: jx,jy,jx0,jy0,jx1,jy1,jxu,jyu,jxd,jyd
  logical :: up,down
  integer(kind=size_length) :: i,ndd
  !
  call press_ctrlc (error)
  if (error) return
  !
  ndd = ldd
  ldd = 0
  up = .true.
  down = .false.
  !
  ! Reset pen position
  jxu = ixu(1)
  jyu = iyu(1)
  !
  do i=1,ndd
    if (noclip_gris) then
      jx = ixu(i)
      jy = iyu(i)
      call fill_vect(jx,jy,error)
      if (error) return
    else
      if (up) then
        ! If down, flush previous contour
        if (down) then
          call fill_cont(error)
          if (error) return
        endif
      endif
      !
      ! Clip line jxu,jyu --> jxd,jyd
      jxd = ixu(i)
      jyd = iyu(i)
      jx0 = jxu
      jy0 = jyu
      jx1 = jxd
      jy1 = jyd
      jxu = jxd
      jyu = jyd
      !
      ! Change the end-points of the line (X0,Y0) - (X1,Y1)
      ! to clip the line at the window boundary.
      ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
      !
      call grisclip(jx0,jy0,c0)
      call grisclip(jx1,jy1,c1)
      !
      do while (c0.ne.0 .or. c1.ne.0)
        if (iand(c0,c1).ne.0)  goto 10 ! line is invisible
        !
        c = c0
        if (c.eq.0) c = c1
        if (iand(c,1).ne.0) then   ! crosses XXBOX1
          jy = jy0 + 0.5 + float(jy1-jy0)*float(xxbox1-jx0)/float(jx1-jx0)
          jx = xxbox1
        elseif (iand(c,2).ne.0) then   ! crosses XXBOX2
          jy = jy0 + 0.5 + float(jy1-jy0)*float(xxbox2-jx0)/float(jx1-jx0)
          jx = xxbox2
        elseif (iand(c,4).ne.0) then   ! crosses YYBOX1
          jx = jx0 + 0.5 + float(jx1-jx0)*float(yybox1-jy0)/float(jy1-jy0)
          jy = yybox1
        elseif (iand(c,8).ne.0) then   ! crosses YYBOX2
          jx = jx0 + 0.5 + float(jx1-jx0)*float(yybox2-jy0)/float(jy1-jy0)
          jy = yybox2
        endif
        if (c.eq.c0) then
          jx0 = jx
          jy0 = jy
          call grisclip(jx,jy,c0)
        else
          jx1 = jx
          jy1 = jy
          call grisclip(jx,jy,c1)
        endif
      enddo
      !
      if (up) then
        call fill_vect(jx0,jy0,error)
        if (error) return
        up = .false.
      endif
      call fill_vect(jx1,jy1,error)
      if (error) return
      down = .true.
      up = (jx1.ne.jxu).or.(jy1.ne.jyu)
    endif
10  continue
  enddo  ! I
  !
  call fill_cont(error)
  !
end subroutine lastg
!
subroutine contg(error)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>contg
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! End of contour line; Show it using FLUSH_TREE
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  !
  call flush_tree(error)
  if (.not.chunkpatch)  call gtsegm_close(error)
  !
  if (allocated(ixu))  deallocate(ixu)
  if (allocated(iyu))  deallocate(iyu)
  call press_ctrlc (error)
  !
end subroutine contg
!
subroutine press_ctrlc(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>press_ctrlc
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  logical :: ok
  character(len=1) :: answer
  !
  ok = sic_ctrlc()
  do while (ok)
    call sic_wpr('W-RGMAP, ^C pressed, Type C to continue, Q to QUIT',answer)
    if (answer.eq.'Q' .or. answer.eq.'q') then
      error = .true.
      return
    elseif (answer.eq.'C' .or. answer.eq.'c') then
      ok = .false.
    endif
  enddo
end subroutine press_ctrlc
!
subroutine grisclip(x,y,c)
  use greg_interfaces, except_this=>grisclip
  use greg_contours
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for the clipping algorithm ; called from DRAW and
  ! GRPOLY only. C is a 4 bit code indicating the relationship between
  ! point (X,Y) and the window boundaries ; 0 implies the point is
  ! within the window.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: x  ! Position of point
  integer(kind=4), intent(in)  :: y  ! Position of point
  integer(kind=4), intent(out) :: c  ! Code
  !
  c = 0
  if (x.lt.xxbox1) then
    c = 1
  elseif (x.gt.xxbox2) then
    c = 2
  endif
  if (y.lt.yybox1) then
    c = c+4
  elseif (y.gt.yybox2) then
    c = c+8
  endif
end subroutine grisclip

program dg_smooth
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Smooth an image using the CONJUGATE GRADIENT ALGORITHM :
  !	The smoothed image is the equilibrium state of a thin flexible plate
  !	constrained to pass near each height datum by a spring attached
  !	between it and the plate.
  !	the smoothing parameter p is the ratio :
  !	     p = ( plate stiffness) / ( springs stiffness)
  !	The convergence is obtained with about 10 iterations ...
  !---------------------------------------------------------------------
  character(len=*), parameter :: pname = 'DG_SMOOTH'
  ! Local
  character(len=filename_length) :: namex,namey,namez
  logical :: error,start
  integer(kind=4) :: i,j,kz
  real(kind=4) :: p,valbi
  type(gildas) :: x,y,z
  integer(kind=4) :: niter, ier
  !
  call gildas_open
  call gildas_logi('RESTART$',start,1)
  call gildas_real('P$',p,1)
  call gildas_inte('NITER$',niter,1)
  call gildas_char('Z_NAME$',namez)
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('GUESS$',valbi,1)
  call gildas_close
  start = .not.start
  !
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namez,'.gdf',error,data=.false.)
  if (error) then
    call gagout ('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  !
  ! Create or Read output image
  if (start) then
    call gdf_copy_header(y,x,error)
    call sic_parsef(namey,x%file,' ','.gdf')
    x%gil%extr_words = 0
    call gdf_create_image (x,error)
    if (error) then
      call gagout ('F-'//pname//',  Cannot create smoothed image')
      goto 100
    endif
  else
    x%loca%read = .false.  ! Open for write
    call gdf_read_gildas(y,namex,'.gdf',error,data=.false.)
    if (error) then
      call gagout ('F-'//pname//',  Cannot read smoothed image')
      goto 100
    endif
  endif
  !
  ! Work file, in Z
  call gildas_null(z)
  if (start) then
    call gdf_copy_header(y,z,error)
    call sic_parsef(namex,z%file,' ','.gdf')
    z%gil%ndim   = 4
    z%gil%dim(3) = 3*y%gil%dim(3)*y%gil%dim(4)
    z%gil%dim(4) = 1
    z%loca%size   = 3*y%loca%size
    call gdf_create_image (z,error)
    if (error) then
      call gagout ('F-'//pname//',  Cannot create work file')
      goto 100
    endif
  else
    z%loca%read = .false.  ! Open for write
    call gdf_read_gildas(z,namex,'.gdf',error,data=.false.)
    if (error) then
      call gagout ('F-'//pname//',  Cannot read work file')
      goto 100
    endif
  endif
  !
  if (z%loca%size.ne.3*y%loca%size) then
    call gagout('E-'//pname//',  Output and '//   &
     &      'Work Images do not match')
    goto 100
  endif
  if (y%loca%size.ne.x%loca%size) then
    call gagout('E-'//pname//',  Input and '//   &
     &      'Output Images do not match')
    goto 100
  endif
  if (y%gil%eval.ge.0) y%gil%eval = max(y%gil%eval,abs(y%gil%bval*1e-7))
  !
  !	v_addr = y%loca%addr		! oRIGINAL IMAGE
  !	w_addr = z%loca%addr		! wORK IMAGE
  !	a_addr = x%loca%addr		! sMOOTH IMAGE
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), & 
    & y%r2d(y%gil%dim(1),y%gil%dim(2)),  & 
    & z%r3d(z%gil%dim(1),z%gil%dim(2),3), stat=ier)
  if (ier.ne.0) then
    call gagout ('F-'//pname//',  Memory allocation failure')
    goto 100
  endif
  !
  kz = 1
  do j=1,y%gil%dim(4)
    do i=1,y%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      x%blc(4) = j
      x%trc(4) = j
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      z%blc(3) = kz
      z%trc(3) = kz+2
      z%blc(4) = 1
      z%trc(4) = 1
      kz = kz+3
      if (start) then
        call gdf_read_data(x,x%r2d,error)
        call gdf_read_data(z,z%r3d,error)
        call dgsm001(y%r2d,x%gil%dim(1),x%gil%dim(2),   &
     &          x%r2d,y%gil%bval,y%gil%eval,            &
     &          z%r3d(:,:,1),   &
     &          z%r3d(:,:,2),   &
     &          z%r3d(:,:,3),   &
     &          valbi)
      endif
      !
      call dgsm002(y%r2d,x%gil%dim(1),x%gil%dim(2),   &
     &          x%r2d,          &
     &          z%r3d(:,:,1),   &
     &          z%r3d(:,:,2),   &
     &          z%r3d(:,:,3),   &
     &          p,niter,y%gil%bval,y%gil%eval)
      call gdf_write_data (z,z%r3d,error)
      call gdf_write_data (x,x%r2d,error)
    enddo
  enddo
  !
  call gagout('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program dg_smooth
!
subroutine dgsm001(v,mi,mj,a,bval,eval,ap,ap2,ap3,valbi)
  use gildas_def
  !---------------------------------------------------------------------
  !	 Init
  !---------------------------------------------------------------------
  real(kind=4),               intent(in)  :: v(*)
  integer(kind=index_length), intent(in)  :: mi
  integer(kind=index_length), intent(in)  :: mj
  real(kind=4),               intent(out) :: a(*)
  real(kind=4),               intent(in)  :: bval
  real(kind=4),               intent(in)  :: eval
  real(kind=4),               intent(out) :: ap(mi*mj)
  real(kind=4),               intent(out) :: ap2(mi*mj)
  real(kind=4),               intent(out) :: ap3(mi*mj)
  real(kind=4),               intent(in)  :: valbi
  ! Local
  integer(kind=size_length) :: i,n
  !
  n = mi*mj
  ap = 0.0
  ap2 = 0.0
  ap3 = 0.0
  if (eval.lt.0.0) then
    do i=1,n
      a(i) = v(i)
    enddo
  else
    do i=1,n
      if (abs(v(i)-bval).gt.eval) then
        a(i) = v(i)
      else
        a(i) = valbi
      endif
    enddo
  endif
end subroutine dgsm001
!
subroutine dgsm002(v,mi,mj,a,desc,grad,w,p,itermax,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! D. Girard  smoothing technique
  !---------------------------------------------------------------------
  real(kind=4),               intent(in)    :: v(*)
  integer(kind=index_length), intent(in)    :: mi
  integer(kind=index_length), intent(in)    :: mj
  real(kind=4),               intent(inout) :: a(*)
  real(kind=4),               intent(out)   :: desc(*)
  real(kind=4),               intent(out)   :: grad(*)
  real(kind=4),               intent(out)   :: w(*)
  real(kind=4),               intent(in)    :: p
  integer(kind=4),            intent(in)    :: itermax
  real(kind=4),               intent(in)    :: bval
  real(kind=4),               intent(in)    :: eval
  ! Global
  real(kind=4), external :: dot
  ! Local
  ! Resolution iterative par gradient conjugue
  !
  real(kind=4) :: vij,norm2grad,norm2grad_1,beta,lambda
  integer(kind=4) :: iter
  integer(kind=size_length) :: i,n
  !
  if (itermax.le.0) return
  n = mi*mj
  !
  ! Gradient
  call prodtd(v,mi,mj,p,a,grad,bval,eval)
  do i=1,n
    vij = v(i)
    if (abs(vij-bval).gt.eval) then
      grad(i)=grad(i)-vij
    endif
  enddo
  norm2grad = dot (grad,grad,n)
  !
  call prodtd(v,mi,mj,p,grad,w,bval,eval)
  lambda = norm2grad / dot(grad,w,n)
  !
  do i=1,n
    desc(i) = - grad(i)
  enddo
  do i=1,n
    a(i) = a(i) - lambda * grad(i)
  enddo
  norm2grad_1 = norm2grad
  do i=1,n
    grad(i)= grad(i) - lambda*w(i)
  enddo
  !
  ! Iterations
  do iter = 2, itermax
    norm2grad = dot(grad,grad,n)
    beta = norm2grad/norm2grad_1
    do i=1,n
      desc(i) = -grad(i) + beta * desc(i)
    enddo
    call prodtd(v,mi,mj,p,desc,w,bval,eval)
    lambda = norm2grad / dot(desc,w,n)
    do i=1,n
      a(i) = a(i) + lambda * desc(i)
    enddo
    norm2grad_1 = norm2grad
    do i=1,n
      grad(i) = grad(i) + lambda * w(i)
    enddo
  enddo
end subroutine dgsm002
!
subroutine prodtd(v,mi,mj,p,z,s,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  !  Init
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: mi
  integer(kind=index_length), intent(in)  :: mj
  real(kind=4),               intent(in)  :: v(mi,mj)
  real(kind=4),               intent(in)  :: p
  real(kind=4),               intent(in)  :: z(mi,mj)
  real(kind=4),               intent(out) :: s(mi,mj)
  real(kind=4),               intent(in)  :: bval
  real(kind=4),               intent(in)  :: eval
  ! Local
  integer(kind=index_length) :: i,j
  real(kind=4) :: w
  !
  do j=1,mj
    do i=1,mi
      if (abs(v(i,j)-bval).gt.eval) then
        s(i,j) = z(i,j)
      else
        s(i,j) = 0.0
      endif
    enddo
  enddo
  do j=2,mj-1
    do i=2,mi-1
      w = p*(2.0*z(i,j)-z(i-1,j)-z(i+1,j))
      s(i,j)= s(i,j) +2.0*w
      s(i-1,j)=s(i-1,j) - w
      s(i+1,j) = s(i+1,j) -w
      w = p*(2.0*z(i,j)-z(i,j+1)-z(i,j-1))
      s(i,j)= s(i,j) +2.0*w
      s(i,j-1)=s(i,j-1) - w
      s(i,j+1) = s(i,j+1) -w
      w = 0.5*p*(z(i+1,j+1)+z(i-1,j-1)-z(i+1,j-1)-z(i-1,j+1))/4.0
      s(i+1,j+1)= s(i+1,j+1) +w
      s(i-1,j-1)= s(i-1,j-1) +w
      s(i+1,j-1)= s(i+1,j-1) -w
      s(i-1,j+1)= s(i-1,j+1) -w
    enddo
  enddo
end subroutine prodtd
!
function dot (z,s,n)
  use gildas_def
  real(kind=4) :: dot
  real(kind=4),              intent(in) :: z(*)
  real(kind=4),              intent(in) :: s(*)
  integer(kind=size_length), intent(in) :: n
  ! Local
  integer(kind=size_length) :: i
  dot=0.0
  do i=1,n
    dot = dot + s(i)*z(i)
  enddo
end function dot

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_obsolete_opt
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_primitive_opt
  use cubetools_structure_main
  !
  public :: obsolete_opt_t
  public :: cubetools_register_obsolete_opt
  private
  !
  type, extends(primitive_opt_t) :: obsolete_opt_t
    character(len=11) :: date  ! Obsolescence date e.g. 01-JAN-1970
  contains
    procedure :: register => cubetools_register_obsolete_opt
  end type obsolete_opt_t
  !
contains
  !
  subroutine cubetools_register_obsolete_opt(template,name,help,date,error)
    !----------------------------------------------------------------------
    ! Register an option of exact type obsolete_opt_t in the global 'pack'
    !----------------------------------------------------------------------
    class(obsolete_opt_t), intent(in)    :: template
    character(len=*),      intent(in)    :: name
    character(len=*),      intent(in)    :: help
    character(len=*),      intent(in)    :: date
    logical,               intent(inout) :: error
    !
    class(primitive_opt_t), pointer :: actualopt
    type(obsolete_opt_t), pointer :: oopt
    !
    ! Note: the pointer to the option is not returned to the caller as
    ! there is no need to use it for parsing
    call cubetools_register_primitive_opt(template,name,strg_emp,strg_emp,  &
      help,actualopt,error)
    if (error)  return
    oopt => cubetools_obsolete_opt_ptr(actualopt,error)
    if (error)  return
    !
    oopt%date           =  date
    oopt%check          => cubetools_option_check_execute
    oopt%build_syntax   => cubetools_option_build_syntax
    oopt%print_abstract => cubetools_option_print_abstract
  end subroutine cubetools_register_obsolete_opt
  !
  function cubetools_obsolete_opt_ptr(pot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(obsolete_opt_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    type(obsolete_opt_t), pointer :: cubetools_obsolete_opt_ptr  ! Function value on return
    class(primitive_opt_t), target, intent(in)    :: pot
    logical,                        intent(inout) :: error
    !
    character(len=*), parameter :: rname='OPTION>PTR'
    !
    select type(pot)
    type is (obsolete_opt_t)
      cubetools_obsolete_opt_ptr => pot
    class default
      cubetools_obsolete_opt_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a obsolete_opt_t type')
      error = .true.
      return
    end select
  end function cubetools_obsolete_opt_ptr
  !
  subroutine cubetools_option_check_execute(opt,command,line,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Obsolete option must not be present on the command line. If yes,
    ! raise an error with appropriate message.
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)   :: opt
    character(len=*),       intent(in)    :: command  ! Command name (for proper feedback)
    character(len=*),       intent(in)    :: line
    logical,                intent(inout) :: error
    !
    logical :: present
    type(obsolete_opt_t), pointer :: oopt
    character(len=*), parameter :: rname='OPTION>CHECK>EXECUTE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call opt%present(line,present,error)
    if (error) return
    if (.not.present)  return
    !
    oopt => cubetools_obsolete_opt_ptr(opt,error)
    if (error)  return
    !
    call cubesyntax_message(seve%e,rname,  &
      '/'//trim(opt%name)//' is obsolete since '//oopt%date)
    call oopt%help(error)
    if (error)  return
    !
    ! Raise error to stop parsing
    error = .true.
    return
  end subroutine cubetools_option_check_execute
  !
  subroutine cubetools_option_build_syntax(opt,syntax,lprint,lnoprint,error)
    !-------------------------------------------------------------------
    !  Return empty (=> invisible) syntax for obsolete option
    !-------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    character(len=*),       intent(out)   :: syntax
    integer(kind=4),        intent(out)   :: lprint    ! Number of printable characters
    integer(kind=4),        intent(out)   :: lnoprint  ! Number of non-printable characters
    logical,                intent(inout) :: error
    !
    syntax = ' '
    lprint = 0
    lnoprint = 0
  end subroutine cubetools_option_build_syntax
  !
  subroutine cubetools_option_print_abstract(opt,error)
    !----------------------------------------------------------------------
    !  Print nothing for an obsolete option
    !----------------------------------------------------------------------
    class(primitive_opt_t), intent(in)    :: opt
    logical,                intent(inout) :: error
    !
    return
  end subroutine cubetools_option_print_abstract
end module cubetools_obsolete_opt
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*DECK PIMACH
      FUNCTION PIMACH (DUM)
C***BEGIN PROLOGUE  PIMACH
C***SUBSIDIARY
C***PURPOSE  Subsidiary to HSTCSP, HSTSSP and HWSCSP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (PIMACH-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subprogram supplies the value of the constant PI correct to
C     machine precision where
C
C     PI=3.1415926535897932384626433832795028841971693993751058209749446
C
C***SEE ALSO  HSTCSP, HSTSSP, HWSCSP
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  PIMACH
C
C***FIRST EXECUTABLE STATEMENT  PIMACH
      PIMACH = 3.14159265358979
      RETURN
      END

function gag_hasins(mdim,pf,pn,dict,name,in)
  use gsys_interfaces, except_this=>gag_hasins
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Insert a new name or replace an existing name
  !       in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASINS      0       E  Invalid name
  !                       1       S  Successfully inserted
  !                       2       E  Too many names
  !                       3       S  Successfully replaced
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasins  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(inout) :: pf(0:27)    !
  integer(kind=4),  intent(inout) :: pn(mdim)    !
  character(len=*), intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be inserted
  integer(kind=4),  intent(out)   :: in          ! Address of this name
  ! Local
  integer(kind=4) :: j,k
  !
  in = 0
  gag_hasins = 0
  !
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Find if it exits already
  k = pf(j)
  do while(k.gt.0)
    if (name.eq.dict(k)) then
      in = k
      gag_hasins = 3
      return
    endif
    k = pn(k)
  enddo
  !
  ! Find if place left
  if (pf(26).eq.0) then
    gag_hasins = 2
  else
    !
    ! Insert NAME in place and set pointers
    k = pf(26)
    pf(26) = pn(k)
    pn(k) = pf(j)
    pf(j) = k
    dict(k) = name
    in = k
    pf(27) = pf(27)+1
    gag_hasins = 1
  endif
end function gag_hasins
!
subroutine gag_hasini(mdim,pf,pn)
  !---------------------------------------------------------------------
  ! @ public
  ! SIC   Internal routine
  !  *** This version for all kind of dictionaries ***
  !       Initialise a hashing structure for a possible dictionnary.
  ! Arguments :
  !       MDIM    I       Size of dictionnary
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.
  !                       PF(27) the number of symbol
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: mdim      !
  integer(kind=4), intent(out) :: pf(0:27)  !
  integer(kind=4), intent(out) :: pn(mdim)  !
  ! Local
  integer(kind=4) :: i
  !
  do i=0,25
    pf(i) = 0
  enddo
  pf(26) = 1
  pf(27) = 0
  do i=1,mdim-1
    pn(i) = i+1
  enddo
  pn(mdim) = 0
end subroutine gag_hasini
!
function gag_hasdel(mdim,pf,pn,dict,name)
  use gsys_interfaces, except_this=>gag_hasdel
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Delete a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASDEL      1       Name deleted
  !                       3       Name does not exist
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasdel  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(inout) :: pf(0:27)    !
  integer(kind=4),  intent(inout) :: pn(mdim)    !
  character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be deleted
  ! Local
  integer(kind=4) :: j,kl,k
  !
  gag_hasdel = 3
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine if it is a known symbol
  kl = 0
  k = pf(j)
10 if (k.eq.0) return
  if (name.ne.dict(k)) then
    kl = k
    k = pn(k)
    goto 10
  endif
  !
  ! Now delete it
  gag_hasdel = 1
  if (kl.ne.0) then
    pn(kl) = pn(k)
  else
    pf(j) = pn(k)
  endif
  pn(k) = pf(26)
  pf(26) = k
  pf(27) = pf(27)-1
end function gag_hasdel
!
function gag_hasfin(mdim,pf,pn,dict,name,in)
  use gsys_interfaces, except_this=>gag_hasfin
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for dictionaries as character string arrays ***
  !       Find a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       GAG_HASFIN      0       No such name
  !                       1       Name found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_hasfin  ! Function value on return
  integer(kind=4),  intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(in)    :: pf(0:27)    !
  integer(kind=4),  intent(in)    :: pn(mdim)    !
  character(len=*), intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  character(len=*), intent(inout) :: name        ! Name to be found
  integer(kind=4),  intent(out)   :: in          ! Address of this name
  ! Local
  integer(kind=4) :: j
  !
  ! If no symbol return
  in = 0
  gag_hasfin = 0
  if (pf(27).eq.0) return
  !
  ! Find the place in PF
  call sic_upper(name)
  j = ichar(name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
10 if (j.eq.0) return
  if (name.eq.dict(j)) then
    in = j
    gag_hasfin = 1
    return
  endif
  j = pn(j)
  goto 10
end function gag_hasfin
!
subroutine gag_haslis(mdim,pf,pn,list,leng)
  !---------------------------------------------------------------------
  ! @ public
  !  *** This version for all kind of dictionaries ***
  !
  !  List a dictionnary using a hashing structure and a list of pointers.
  ! This routine just builds the list of pointers to current entries.
  !
  ! THERE IS NO WARRANTY THE OUTPUT LIST IS SORTED ALPHABETICALLY.
  ! Actually with the current hashing method, the output list is sorted
  ! by first letter only. Use subroutine gag_hassort for a fully sorted
  ! list.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4), intent(in)  :: pf(0:27)    !
  integer(kind=4), intent(in)  :: pn(mdim)    !
  integer(kind=4), intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4), intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j
  !
  leng = 0
  if (pf(27).eq.0) return
  do i=0,25
    if (pf(i).le.0)  cycle
    j = pf(i)
    leng = leng+1
    list(leng) = j
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
  enddo
end subroutine gag_haslis

!
subroutine gio_uvwps(awps)
  use gio_fitsdef
  ! @ public
  !
  real, intent(out) :: awps
  !
  awps = wps
end subroutine gio_uvwps
!
subroutine touvt(fits,istyle,what,check,error,pcount,getsymbol)
  use gbl_message
  use phys_const
  use image_def
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>touvt
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  ! Read a UVFITS file from tape and convert it to GDF format in virtual
  ! memory.
  !---------------------------------------------------------------------
  type(gildas),    intent(inout) :: fits       !
  integer(kind=4), intent(in)    :: istyle     ! A cryptic style code, 1,2 or something else
  logical,         intent(in)    :: what       ! Prompt on unknown axis types ?
  logical,         intent(in)    :: check      ! Verbose flag
  logical,         intent(out)   :: error      ! Error flag
  integer(kind=4), intent(out)   :: pcount     ! Parameter count
  external                       :: getsymbol  ! FITS Keyword translation routine
  ! 
  ! Global
  character(len=*), parameter :: rname = 'TOUVT'
  character(len=1), parameter :: quote = ''''
  !
  ! Local
  real(kind=4) :: rmin,rmax
  integer(kind=4) :: id,iy,im,idate
  !
  real(kind=4) :: xs
  real(kind=8) :: x
  integer(kind=4) :: nr(mcount)
  integer(kind=4) :: naxis, nif
  integer(kind=4) :: i,j,narg,ind,i1,i2,k
  integer(kind=4) :: ier,ialtrpix,iaxis, iv, obs_vtyp
  real(kind=8) :: my_convert(3), altrpix, altrval, f, vv, v, dummy(3), my_voff, afreq
  logical :: have_altrval, have_velref, have_velo, have_vres, have_zsou, have_epoch, have_point
  logical :: from_casa, warn
  character(len=8) :: trans,comm
  character(len=70) :: argu
  character(len=message_length) :: mess
  character(len=80) :: chain
  integer, allocatable :: tmp_stokes(:)
  integer :: old_stokes
  !
  ! Reset
  call gio_message(seve%t,rname,'Entering...')
  !
  error = .false.
  have_altrval = .false.
  have_velref = .false.
  have_velo = .false.
  have_zsou = .false.
  have_vres = .false.
  have_epoch = .false.
  have_point = .false.
  from_casa = .false.
  obs_vtyp = vel_unk
  !
  f = 0.d0
  !
  wps = 1.0
  ialtrpix = 0
  call gildas_null(fits, type = 'UVT')
  call sic_parsef(gdfname,fits%file,' ','.uvt')
  fits%gil%version_uv = code_version_uvt_dopp   ! Will use Doppler information
  fits%gil%voff = 0.0
  fits%gil%dopp = 0.0
  !
  fd%bscal = 1.0
  fd%bzero = 0.0
  ! Use pixel units as default if increments are not defined
  call gfits_flush_data(error)
  if (error) return
  ! First line SIMPLE
  call gfits_get(comm,argu,check,error)
  if (error) return
  if (comm.ne.'SIMPLE') then
    call gio_message(seve%e,'FITS','Not a FITS file at all')
    goto 99
  endif
  narg = len(argu)
  call sic_blanc(argu,narg)
  if (argu.ne.' T' .and. argu.ne.'T') then
    call gio_message(seve%w,'FITS','Not a SIMPLE FITS file')
    goto 99
  endif
  !
  ! Second line BITPIX
  call gfits_get(comm,argu,check,error)
  if (error) return
  if (comm.ne.'BITPIX') then
    call gio_message(seve%e,'FITS','Not a standard FITS file, no BITPIX')
    goto 99
  endif
  read(argu,*,iostat=ier) x
  fd%nbit=nint(x)
  if (fd%nbit.ne.16 .and. fd%nbit.ne.32 .and.fd%nbit.ne.-32) then
    write(mess,101) 'Cannot handle ',fd%nbit,' bits'
    call gio_message(seve%e,'UVFITS',mess)
    goto 99
  endif
  !
  ! Third line NAXIS
  call gfits_get(comm,argu,check,error)
  if (error) return
  read(argu,*,iostat=ier) x
  naxis=int(x)
  if (naxis.ne.6 .and. naxis.ne.7) then
    call gio_message(seve%e,'UVFITS','No UV data in file')
    goto 99
  endif
  !
  ! Next NAXIS lines axis dimensions
  do i=1,naxis
    call gfits_get(comm,argu,check,error)
    if (error) return
    read(argu,*,iostat=ier) x
    nr(i)=nint(x)
    if (i.eq.1 .and. nr(i).ne.0) then
      call gio_message(seve%e,'UVFITS','Not a standard UVFITS file')
      goto 99
    elseif (i.gt.mcount .and. nr(i).ne.1) then
      call gio_message(seve%e,'UVFITS','Too many dimensions')
      goto 99
    endif
    if (ier.ne.0) call gio_message(seve%e,'UVFITS','Error reading '//comm//argu)
  enddo
  !
  fits%gil%ptyp = p_azimuthal    ! Azimuthal projection
  ier = 0
  !
  ! Now find the real information.
  !
20 if (ier.ne.0) call gio_message(seve%e,'UVFITS','Error reading '//comm//argu)
  ier = 0
  error = .false.
  call gfits_get(comm,argu,check,error)
  if (error) return
  call getsymbol (comm,trans,error)
  if (error) then
    error = .false.
  else
    comm = trans
  endif
  !
  select case (comm)
  case ('BSCALE')
    read(argu,*,iostat=ier) cscal
  case ('BZERO')
    read(argu,*,iostat=ier) czero
  case ('DATAMIN')
    read(argu,*,iostat=ier) rmin
  case ('DATAMAX')
    read(argu,*,iostat=ier) rmax
  case ('BUNIT')
    read(argu,1001,iostat=ier) chain
    fits%char%unit = chain(2:)
    ind = index(fits%char%unit,quote)
    if (ind.gt.0) fits%char%unit(ind:) = ' '
  case ('GROUP')
    continue
  case ('PCOUNT')
    read(argu,*,iostat=ier) x
    pcount = nint(x)
  case ('GCOUNT')
    read(argu,*,iostat=ier) x
    fits%gil%nvisi = nint(x)
  case ('EPOCH')
    read(argu,*,iostat=ier) fits%gil%epoc
    have_epoch = .true.
  case ('EQUINOX')
    read(argu,*,iostat=ier) fits%gil%epoc
  case ('OBSRA')
    read(argu,*,iostat=ier) x
    fits%gil%ra = x*pi/180.0d0
    have_point = .true.
    fits%char%syst = 'EQUATORIAL'
  case ('OBSDEC')
    read(argu,*,iostat=ier) x
    fits%gil%dec = x*pi/180.0d0
    have_point = .true.
    fits%char%syst = 'EQUATORIAL'
    !
  case ('OBJECT')
    read(argu,1001,iostat=ier) chain
    fits%char%name = chain(2:)
    ind = index(fits%char%name,quote)
    if (ind.gt.0) fits%char%name(ind:) = ' '
  case ('LINE')
    read(argu,1001,iostat=ier) chain
    fits%char%line = chain(2:)
    ind = index(fits%char%line,quote)
    if (ind.gt.0) fits%char%line(ind:) = ' '
!
! Standard Frequency / Velocity axis
  case ('RESTFREQ')
    read(argu,*,iostat=ier)  f
    fits%gil%spec_words = 12
  case ('SPECSYS')
    i1 = index(argu,quote)+1
    i2 = index(argu(i1:),quote)-2+i1
    chain = argu(i1:i2)
    if (chain.eq.'LSRK') then
      fits%gil%vtyp = vel_lsr
    else if (chain.eq.'HEL') then
      fits%gil%vtyp = vel_hel
    else if (chain.eq.'TOPOCENT') then
      fits%gil%vtyp = vel_obs
    endif
  case ('SSYSSRC')
    i1 = index(argu,quote)+1
    i2 = index(argu(i1:),quote)-2+i1
    chain = argu(i1:i2)
    if (chain.eq.'LSRK') then
      fits%gil%vtyp = vel_lsr
    else if (chain.eq.'HEL') then
      fits%gil%vtyp = vel_hel
    else if (chain.eq.'TOPOCENT') then
      fits%gil%vtyp = vel_obs
    endif
  case ('ZSOURCE')
    read(argu,*,iostat=ier)  x
    have_zsou = .true.
    fits%gil%voff = x/1d3
    fits%gil%spec_words = 12
  case ('VELOSYS')
    read(argu,*,iostat=ier)  x
    fits%gil%dopp = x/299792.458d3
    fits%gil%spec_words = 12
  case ('SSYSOBS')
    i1 = index(argu,quote)+1
    i2 = index(argu(i1:),quote)-2+i1
    chain = argu(i1:i2)
    if (chain.eq.'LSRK') then
      obs_vtyp = vel_lsr
    else if (chain.eq.'BARYCENT') then
      obs_vtyp = vel_hel
    else if (chain.eq.'TOPOCENT') then
      obs_vtyp = vel_obs
    else if (chain.eq.'GEOCENT') then
      obs_vtyp = vel_ear
    endif
!
! Old Frequency / Velocity axis
  case ('VELO-LSR','VLSR')
    read(argu,*,iostat=ier)  v
    have_velo = .true.
    fits%gil%spec_words = 12
  case ('VELREF')
    read(argu,*,iostat=ier)  vv
    have_velref = .true.
    fits%gil%spec_words = 12
  case ('ALTRVAL')
    read(argu,*,iostat=ier)  altrval
    have_altrval = .true.
    fits%gil%spec_words = 12
  case ('ALTRPIX')
    ! ALTRPIX indicate Reference pixel for Frequency / Velocity axis
    read(argu,*,iostat=ier)  altrpix
    fits%gil%spec_words = 12
  case ('DELTAV')
    read(argu,*,iostat=ier) x
    fits%gil%vres = x*1d-3
    have_vres = .true.
  case ('IMAGFREQ')
    read(argu,*,iostat=ier) x
    fits%gil%fima = x*1d-6
  !
  case ('DATE-OBS')
    i1 = index(argu,quote)+1
    i2 = index(argu(i1:),quote)-2+i1
    ! make provision for old DATE-OBS format:
    ind = index(argu(i1:i2),'/')
    if(ind.eq.0) then          ! new ISO date format
      read(argu(i1:i2),1004,iostat=ier) iy,im,id
    else
      read(argu(i1:i2),1003,iostat=ier) id,im,iy
      iy = 1900+iy
    endif
    call gag_datj(id,im,iy,idate)
    !
    ! Try to grasp the WTSCAL hidden keyword
  case ('HISTORY')
    ind = index(argu,'WTSCAL')
    if (ind.ne.0) then
      read(argu(ind+9:),*,iostat=ier) wps
    endif
    !
  case ('END')
    goto 30
    !
  case ('ORIGIN')
     call gio_message(seve%i,'FITS','Origin is ['//trim(argu)//']')
     if (argu.eq."'casacore '") from_casa = .true.
  case('TELESCOP')
    i1 = index(argu,quote)+1
    i2 = index(argu(i1:),quote)-2+i1
    call gdf_addteles(fits,'TELE',argu(i1:i2),dummy,error)
  case default
    ! Identify the named axes
    select case (comm(1:5))
    case ('CTYPE')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) chain
      ctype(iaxis) = chain
    case ('CRVAL')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) x
      crval(iaxis) = x
    case ('CRPIX')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) x
      crpix(iaxis) = x
    case ('CDELT')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) x
      cdelt(iaxis) = x
      ! and the groups
    case ('PTYPE')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) chain
      ptype(iaxis) = chain
    case ('PSCAL')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) x
      pscal(iaxis) = x
    case ('PZERO')
      read(comm(6:6),'(I1)',iostat=ier) iaxis
      read(argu,*,iostat=ier) x
      pzero(iaxis) = x
    end select
      !
  end select
  !! Print *,'Comm '//comm,fits%char%syst
  goto 20
  !
  ! Finish Header
30 continue
  !
  ! Consistency check for reference frames
  if (obs_vtyp.eq.fits%gil%vtyp) then
    if (fits%gil%dopp.ne.0) then
      call gio_message(seve%w,rname,'SPECSYS = SSYSOBS,  Doppler reset to zero')
      fits%gil%dopp =0
    endif
  else
    if (fits%gil%dopp.eq.0) call gio_message(seve%w,rname, &
      &  'Warning, no Doppler factor found, spatial resolution inaccurate')
  endif
  !
  ! Set the Rest Frequency if RESTFREQ has been given
  fits%gil%freq = f*1d-6
  !
  if (fits%gil%spec_words.ne.0) then
    !
    ! Use ALTRVAL if defined...
    if (have_altrval) then
      have_velo = .true.
      v = altrval
    endif
    !
    if (have_velo) then
      fits%gil%voff = v*1d-3
      if (have_velref) then
        if (fits%gil%vtyp.ne.vel_unk) then
          call gio_message(seve%w,rname,'Velocity type already set by SPECSYS -- VELREF keyword ignored')
        else
          iv = nint(vv)
          if (vv-iv.eq.0.0) then
            if (iv.gt.256) then
              iv = iv-256
            endif
            if (iv.gt.0 .and. iv.lt.4) then
              fits%gil%vtyp = iv
            endif
          endif
          if (fits%gil%vtyp.eq.vel_unk) then
            call gio_message(seve%w,rname,'Invalid VELREF, Referential set to Unknown')
          endif
        endif
      endif
    else
      if (have_velref) then
        call gio_message(seve%w,rname,'Obsolete use of VELREF as Velocity value (cm/s)')
        fits%gil%voff = vv*1d-5  ! Obsolete use of VELREF
        have_velo = .true.
      endif
    endif
  endif
  !
  ! Re-order the axes informations
  fits%gil%ndim = 2
  fits%gil%nchan = 1
  fits%gil%nstokes = 1
  nif = 1
  !
  fits%gil%order = 0
  !
  do i=2,naxis
    select case (ctype(i))
    case ('FREQ')
      my_convert(2) = crval(i)*1d-6
      !
      ! This is a problem:  We use  TWO frequencies for GILDAS, one
      ! for the spectral line, the other for the effective wavelength
      !
      ! FITS only uses one, in the SPECSYS system.
      !
      if (fits%gil%freq.eq.0) fits%gil%freq = my_convert(2)
      my_convert(3) = cdelt(i)*1d-6
      if (ialtrpix.eq.0) my_convert(1) = crpix(i) ! check for ALTRPIX
      fits%gil%nchan = fits%gil%nchan*nr(i)
      if (fits%gil%order.eq.0) fits%gil%order = code_chan_stok ! Stokes/Channel order
    case ('STOKES')
      write(mess,*) 'Found ',nr(i),' STOKES'
      call gio_message(seve%i,'UVFITS',mess)
      fits%gil%nstokes = fits%gil%nstokes*nr(i)
      if (fits%gil%order.eq.0) fits%gil%order = code_stok_chan ! Stokes/Channel order
      allocate (fits%gil%stokes(fits%gil%nstokes), stat=ier)
      !
      ! and recode it into the Gildas convention.
      do j=1,nr(i)
        xs = (j-crpix(i))*cdelt(i)+crval(i)
        fits%gil%stokes(j) = stokes_from_fits(xs)
      enddo
      if (fits%gil%nstokes.eq.1) then
        fits%gil%order = 0 ! By default, no Stokes, no Order
      endif
    case ('IF')
      if (nr(i).ne.1) then
        write(mess,*) 'Found ',nr(i),' IFs'
        call gio_message(seve%i,'UVFITS',mess)
        nif = nif*nr(i)
      endif
    case ('RA')
      fits%gil%a0 = pi*crval(i)/180.d0
      have_epoch = .true.
    case ('DEC')
      fits%gil%d0 = pi*crval(i)/180.d0
      have_epoch = .true.
    case ('COMPLEX')
      continue
    case default
      write(mess,*) 'Unrecognized CTYPE '//ctype(i),i
      call gio_message(seve%w,'UVFITS',mess)
    end select
  enddo
  if (fits%gil%nstokes.ne.1) then
    continue
  else if (abs(fits%gil%order).eq.abs(code_chan_stok)) then
    fits%gil%order = 0  ! By default, no Stokes so no Order
  endif
  if (nif.gt.1) then
    call gio_message(seve%w,'UVFITS','More than 1 IF value, trying...')
    fits%gil%nchan = fits%gil%nchan * nif
    !
    ! Here we should allocate a Random Frequency axis
    fits%gil%nfreq = fits%gil%nchan * fits%gil%nstokes
    allocate(fits%gil%freqs(fits%gil%nfreq),stat=ier)
  endif
  fits%gil%dim(1) = 7+3*fits%gil%nchan*fits%gil%nstokes
  !
  ! For the groups, it is more complex
  call key_order(pcount,fits%char%syst)
  !
  ! Add trailing columns if needed -
  if (lsour.ne.0) then
    !
    ! Formally, the additional column contains the Source IDs
    !
    ! It will need to be transformed into phase center columns
    ! for further processing by GILDAS, by task uv_update_fields
    fits%gil%ntrail = fits%gil%ntrail+2
    fits%gil%dim(1) = fits%gil%dim(1)+fits%gil%ntrail
    ! Strictly speaking this is the code to use
    fits%gil%column_pointer(code_uvt_id) = fits%gil%dim(1)-1
    fits%gil%column_size(code_uvt_id) = 1
    ! but it requires some protection in MAPPING and IMAGER
    ! to avoid imaging these as Single Fields
    ! and a place-holder to reserve space for in-place conversion to 
    ! phase offsets
    fits%gil%column_pointer(code_uvt_moff) = fits%gil%dim(1)
    fits%gil%column_size(code_uvt_moff) = 1
    fits%char%syst = 'EQUATORIAL'
    !
    !! Older versions used this fudge instead:
    !!fits%gil%column_pointer(code_uvt_loff) = fits%gil%dim(1)+1
    !!fits%gil%column_pointer(code_uvt_moff) = fits%gil%dim(1)+2
    !!fits%gil%column_size(code_uvt_loff) = 1
    !!fits%gil%column_size(code_uvt_moff) = 1
!
! This could be present if RAOBS and DECOBS are actually present
!    in the AIPS_SU Table.  However, it seems CASA does not do
!    that for the time being...
!
!    fits%gil%column_pointer(code_uvt_xoff) = fits%gil%dim(1)+1
!    fits%gil%column_pointer(code_uvt_yoff) = fits%gil%dim(1)+2
!    fits%gil%column_size(code_uvt_xoff) = 1
!    fits%gil%column_size(code_uvt_yoff) = 1
!
  else if (have_epoch) then
    fits%char%syst = 'EQUATORIAL'
    !
    if (.not.have_point) then
      ! Set up the pointing coordinates by default if not already done
      fits%gil%ra = fits%gil%a0
      fits%gil%dec = fits%gil%d0
    endif
  endif
  !
  fits%gil%dim(2) = fits%gil%nvisi
  fits%gil%faxi = 1 ! Frequency axis is 1
  !
  fits%gil%convert(:,1) = my_convert
  fits%gil%fres = my_convert(3) ! This is the frequency resolution
  !
  if (nif.gt.1) then 
    if (fits%gil%nstokes.eq.1) then
      ! No Stokes defined. OK, but we actually need one for Simplicity...
      if (associated(fits%gil%stokes)) then
        old_stokes = fits%gil%stokes(1)
        deallocate(fits%gil%stokes)      
      else
        old_stokes = 0
      endif
      allocate(fits%gil%stokes(fits%gil%nfreq))
      do i=1,fits%gil%nfreq
        afreq = (i-my_convert(1))*my_convert(3)+my_convert(2)
        fits%gil%freqs(i) = afreq
      enddo
      fits%gil%stokes = old_stokes ! Should be the proper code...
      ! 
      ! Small patch to avoid purely linear axis
      fits%gil%freqs(fits%gil%nfreq) = fits%gil%freqs(1)  !!Under TEST
    else
      ! The STOKES parameters must now be defined for each channel
      write(mess,'(I0,A,I0,A,I0,A,I0,A)') fits%gil%nstokes,' Stokes, ' &
        & ,nif,' IFs, ',fits%gil%nchan,' Channels, and ',fits%gil%nfreq,' Freqs.' !!Under TEST
      call gio_message(seve%w,rname,mess)
      !
      allocate(tmp_stokes(fits%gil%nstokes))
      tmp_stokes(:) = fits%gil%stokes(:)
      deallocate (fits%gil%stokes)
      allocate(fits%gil%stokes(fits%gil%nfreq),stat=ier)
      if (ier.ne.0) then
        call gio_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      ! Fill the random frequency axis with the standard formula
      !   A script will add later the proper information
      ! The filling depends on which order (Stokes vs Channel or Channel vs Stokes)
      !
      !DEBUG! Print *,'ORDER ',fits%gil%order,code_stok_chan,code_chan_stok
      if (fits%gil%order.eq.code_stok_chan) then
        !
        ! code here is for Stokes being faster, channels slower, IF latest
        !
        k = 0
        do i=1,fits%gil%nchan
          afreq = (i-my_convert(1))*my_convert(3)+my_convert(2)
          do j=1,fits%gil%nstokes
            k = k+1
            fits%gil%stokes(k) = tmp_stokes(j)
            fits%gil%freqs(k) = afreq
          enddo
        enddo
        !DO NOT RESET THIS...!  fits%gil%order = 0 ! No order, specified by the Stokes array...
      else if (fits%gil%order.eq.code_chan_stok) then
        k = 0
        do j=1,fits%gil%nstokes
          do i=1,fits%gil%nchan
            k = k+1
            afreq = (i-my_convert(1))*my_convert(3)+my_convert(2)
            fits%gil%stokes(k) = tmp_stokes(j)
            fits%gil%freqs(k) = afreq
          enddo
        enddo
      else
        call gio_message(seve%e,rname,'Invalid Stokes / Channel order ')
        Print *,'Order ',fits%gil%order,' codes ',code_stok_chan,code_chan_stok
      endif
    endif
  endif
  !
  ! Set the source velocity unless it has already been set
  my_voff = -clight_kms*(my_convert(2)-fits%gil%freq)/fits%gil%freq
  if (fits%gil%voff.eq.0.d0) then
    fits%gil%voff = my_voff
    write(mess,'(A,1PG12.5,A,0PF15.6)') 'Offset velocity set to ', &
      & fits%gil%voff,' and Rest Frequency to ',fits%gil%freq
    call gio_message(seve%w,'FITS',mess)
    fits%gil%vres = -clight_kms*fits%gil%fres/fits%gil%freq
    !
    ! Unless we are in CODE_VERSION_UVT_FREQ version (2.0), the
    ! frequency axis must be in the Source frame, whatever its velocity
    !
    if (fits%gil%version_uv.ne.code_version_uvt_freq) then
      fits%gil%convert(2,1) = fits%gil%freq
      if (my_voff.ne.0.d0) call gio_message(seve%w,'FITS','Frequency axis reset to Source frame')
    endif
  else
    if (fits%gil%voff.ne.my_voff) then
      if (have_zsou) then
        ! Used ZSOURC keyword to specify the Source frame.
        ! Every thing should be OK if My_Voff is 0
        warn = my_voff.ne.0.
      else
        warn = .true.
      endif
      if (warn) then
        write(mess,'(A,1PG12.5,A)') 'Inconsistent velocity offset ', &
        & my_voff,' from ZSOURCE, VELO-LSR or VLSR keywords '
        call gio_message(seve%w,'FITS',mess)
        write(mess,'(A,1PG12.5,A)') '   and ',fits%gil%voff, &
        & ' from Frequency axis'
        call gio_message(seve%w,'FITS',mess)
      endif
    endif
    x = -clight_kms*fits%gil%fres/fits%gil%freq
    if (have_vres) then
      if (abs(fits%gil%vres-x).gt.0.001*abs(x)) then
        call gio_message(seve%w,'FITS','Velocity resolution appears inconsistent')
      endif
    else
      fits%gil%vres = x
    endif
  endif
  !
  ! Assume Jy if no Unit specified
  if (fits%char%unit.eq.'UNCALIB') fits%char%unit='Jy'
  !
  ! Finally set the Weight correctly
  !   There is no clearly described convention in UVFITS. 
  !
  ! -) GILDAS uses a per-channel bandwidth, as internally.
  !
  ! -) From experience, weights given by CASA should be multiplied
  ! by the number of channels. It makes no sense, since if the 
  ! CASA weight were those of the aggregate bandwidth, one should
  ! instead **divide** by the number of channels, not **multiply**.
  ! So one may expect some change from CASA at some point... 
  !   Note that the number of Stokes states does not matter here,
  ! as each Stokes has its own weight.
  !
  ! -) WTSCAL should be used if present (e.g. VLA data), either directly
  ! or in the HISTORY keywords.
  !
  if (from_casa) then
    if (wps.eq.1.0) then
      wps = fits%gil%nchan 
    endif
  endif
  !
  ! the WTSCAL keyword can be overridden by the user with a SIC Symbol
  comm = 'WTSCAL'
  call getsymbol(comm,trans,error)
  if (error) then
    error = .false.
  else
    if (from_casa) call gio_message(seve%w,'FITS','CASA weight overridden by user')
    read(trans,*,iostat=ier) wps
    write(mess,*) 'Found user specified WPS ',wps
    call gio_message(seve%i,rname,mess)
  endif
  !
  ! Check header consistency
  call gio_setuv(fits%gil,error)
  !
  call gio_message(seve%t,rname,'Leaving...')
  return
  !
99 error = .true.
  call gio_message(seve%e,'FITS','Command was: '//comm//' '//argu)
  !
101 format(1x,a,i6,a)
1001 format(a)
1003 format(i2,1x,i2,1x,i2)
1004 format(i4,1x,i2,1x,i2)

!-----------------------------------------------------------------------
!              --- Velocities in UVFITS ---
!
! By convention in the WCS coordinate system handling, only
! Frequencies in the specified referential (e.g. LSRK) are given.
! A Rest Frequency is mentionned "for information only", and it
! is up to the user to perform the Frequency --> Velocity
! conversion required for his purpose.
!
! The FITS convention differs from that of GILDAS, where the axis
! is truely dual, with the Rest Frequency and Source velocity matching
! at the reference channel. Frequencies are in the SOURCE reference
! frame, which differ from the LSRK if the source velocity is non-zero.
!
! Thus to reconcile the GILDAS and UVFITS description, one must compute
! at what channel the Rest Frequency appears, and derive from this
! what source velocity would make it appear at the reference channel.
!
! Unfortunately, **some**  UVFITS files from CASA also use a keyword
! (VLSR, or VELO-LSR or VELREF) interpreted as a source velocity, for
! "information" only presumably. This must be ignored.
!
! The initial interpretation of CASA UVFITS file, which dated from our
! guesses about what CASA was actually doing (there is no description,
! we have to guess from the UVFITS definition papers, and the best
! reference seems to be AIPS memo 117), was incorrect. This led to
! incorrect velocity axes when importing such data in GILDAS.
! Since at least CASA 4.3.1, the new interpretation works.
!
! A remaining issue in the CASA-->UVFITS-->GILDAS chain is that baseline
! lengths are in the Topocentric frame, while Frequencies are in the LSR
! frame (usually). Evaluating the proper angular scale requires a
! knowledge of the Doppler effect at the time of the observations. This
! is not given in CASA UVFITS files.
!
! This Doppler effect is in general small (maximum value is less than
! 2x10^-4) so the effect is negligible in general (0.2 pixels at the
! edges of a 2048 x 2048 like map).
!
! The first order value of this is handled for GILDAS data as the "Doppler"
! factor, and implemented in UVFITS by the proper combination of the
! ZSOURCE, SSSYSRC and SSYSOBS keywords.
!
! CASA--GILDAS users should be aware of this current limitation.
!
! Ultimately, we could remove it by re-computing the Doppler effect when
! importing UVFITS files, but that requires access to the ephemeris, not
! available in kernel/lib/gio.  

! Command UV_DOPPLER in ASTRO does something similar, but is not finalized. 
! It would then be conceivable to use it in the "fits_to_uvt.map" procedure, 
! after importing ASTRO in MAPPING.  However, this also imports many 
! commands not really useful, or even with conflicting names.
! Splitting the ASTRO package in two parts
!  - "ephemeris", with only the generic ephemeris tools (TIME,
!  - "astro" itself, with all the specific Observatory tools (LINE, BACKENDS,
! could be a solution, but is time consuming, and error prone.
!
! An other alternative is a task, but it adds the overhead of a "fork",
! which can be serious on memory limited computers.
!
! A better solution is implemented in IMAGER through command UV_ADD DOPPLER.
! It is functional, but hardly ever used.
!
!-----------------------------------------------------------------------

end subroutine touvt
!
subroutine read_uvfits(fits,astoke,error,eot,pcount)
  use image_def
  use gbl_format
  use gbl_message
  use image_def
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>read_uvfits
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  !   Read all the input FITS UV table
  !---------------------------------------------------------------------
  type(gildas),    intent(inout) :: fits    !
  integer(kind=4), intent(in)    :: astoke  ! Stokes parameter
  logical,         intent(out)   :: error   ! Error flag
  logical,         intent(out)   :: eot     ! End ot Tape flag
  integer(kind=4), intent(in)    :: pcount  ! Daps count
  ! Local
  character(len=*), parameter :: rname='TOUVT'
  character(len=message_length) :: mess
  character(len=1) :: cstoke
  real(kind=4), parameter :: ps=1.0e-6 ! Because GILDAS uses MHz
  logical :: err, do_stokes
  integer(kind=4) :: jv,ib,inchan,onchan,nblock,stbl
  real(kind=4) :: ws
  real(kind=4), allocatable :: inarray(:), outarray(:,:)
  integer(kind=4), allocatable :: in_stokes(:)
  integer(kind=4) :: in_nstokes, insize, stokes_order
  real(kind=4) :: trail, mtrail, rinte, indaps(7)
  integer(kind=4) :: ier, nt, i, lc
  ! 
  integer(kind=index_length) :: ngood, nflag, nempty, kv, iblc, idim, itrc
  logical :: good, needs_good
  !
  ! Prepare reading of the visibilities
  rinte = 0       ! Integration time
  eot = .false.   ! Otherwise, error on Ifort
  err = .false.   ! Make sure it is initialized
  error = .false.
  call gfits_flush_data(error)
  if (error) return
  fd%nb = 2881
  !
  !!! call gdf_print_header(fits)
  mtrail = 0
  !
  call gdf_nitems('SPACE_GILDAS',nblock,fits%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,fits%gil%dim(2))
  !
  ! Optionally change the Stokes parameters
  in_nstokes = fits%gil%nstokes
  allocate(in_stokes(in_nstokes))
  in_stokes(:) = fits%gil%stokes(1:in_nstokes)
  !
  ! Keep all Stokes only if Astoke is 0 or all 4 Stokes present
  if (in_nstokes.eq.4) then
    if (astoke.ne.0) then
      call gio_message(seve%w,'FITS','Keeping all 4 stokes parameters')
    endif
  else if (astoke.ne.0) then
    if (in_nstokes.gt.1) then
      call gio_message(seve%i,'FITS','Treating signal as unpolarized')
    endif
    fits%gil%nstokes = 1
    fits%gil%stokes(1) =  code_stokes_none
    stokes_order = fits%gil%order
    fits%gil%order = 0                        ! No order if only 1 Stokes
  else
    if (in_nstokes.gt.1) then
      cstoke = char(in_nstokes+ichar('0'))
      call gio_message(seve%w,'FITS','Keeping all '//cstoke//' stokes parameters')
    endif
  endif
  !
  if (in_nstokes.eq.fits%gil%nstokes) then
    allocate(outarray(fits%gil%dim(1),nblock),inarray(fits%gil%dim(1)),stat=ier)
    inchan = fits%gil%nchan*fits%gil%nstokes
    onchan = inchan
  else
    ! Change a number of sizes and properly shift the Column Pointers
    ! before creating the data file
    onchan = fits%gil%nchan*fits%gil%nstokes
    inchan = fits%gil%nchan*in_nstokes
    insize = fits%gil%nlead + inchan*3 + fits%gil%ntrail
    fits%gil%dim(1) = (fits%gil%nlead + onchan*3 + fits%gil%ntrail)
    allocate(outarray(fits%gil%dim(1),nblock),inarray(insize),stat=ier)
    !
    ! Shift trailing columns
    if (fits%gil%ntrail.ne.0) then
      ! This is a generic code 
      do i=1,code_uvt_last
       if (fits%gil%column_pointer(i).gt.fits%gil%nlead) then
          fits%gil%column_pointer(i) = fits%gil%column_pointer(i) + 3*(onchan-inchan)
        endif
      enddo
    endif
  endif
  if (ier.ne.0) then
    call gio_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  lc = fits%gil%dim(1)-fits%gil%ntrail
  !
  ! Write the sections
  !
  if (fits%gil%nstokes.gt.1) then
    stbl = gdf_stbl_get()
    if (stbl.ne.2) call gdf_stbl(2,err)
  else
    stbl = 2
  endif
  !
  call gdf_create_image(fits,error)
  if (error) then
    call gio_message(seve%e,rname,'Image not created')
    if (stbl.ne.2) call gdf_stbl(stbl,err)
    return
  endif
  !
  ws = wps * ps                ! Final weight scaling factor
  !
  ! This code is NOT generic. It assumes the code_uvt_id (or equivalent)
  ! just follows the last channel, and is the only copied trailing column...
  if (fits%gil%ntrail.eq.0) then
    nt = 0
  else
    nt = 7+3*onchan+1
  endif
  fits%blc(1) = 1
  fits%trc(1) = fits%gil%dim(1)
  fits%blc(2) = 0
  fits%trc(2) = 0
  error = .false.
  !
  if (in_nstokes.eq.fits%gil%nstokes) then
    if (in_nstokes.gt.1) call gio_message(seve%w,rname,'Keeping all Stokes parameters')
    do_stokes = .false.
    needs_good = .true.   ! Test ...
  else
    call gio_message(seve%w,rname,'Extracting unpolarized signal')
    do_stokes = .true.
    needs_good = .false.  ! Test itou...
  endif
  !
  ngood = 0
  nflag = 0
  nempty = 0
  !
  ! Input sizes
  idim = fits%gil%dim(2)
  itrc = 0
  !
  do ib = 1, idim, nblock
    iblc = itrc+1
    itrc = min(idim,itrc+nblock)
    !
    kv = 0  ! Output counter
    !
    write(mess,'(A,I9,A,I9,A,I9,A,I0,A)') &
         & 'Reading ',iblc,' to ', itrc, &
         & ' / ',idim,' (',nint((100.*itrc)/idim),'%)'
    call gio_message(seve%i,rname,mess)
    do jv = 1,itrc-iblc+1 !! fits%trc(2)-fits%blc(2)+1
      good = needs_good
      call read_visi (indaps,inarray,inchan,ws,error,pcount,trail,rinte,good)
      if (error) goto 100
      !
      if (good) then
        kv = kv+1
        ! Daps
        outarray(1:7,kv) = indaps 
        ! Visibilities
        if (do_stokes) then
          call uvfits_stokes_select(inarray,inchan,outarray(8:lc,kv),onchan, &
            & in_nstokes,in_stokes,fits%gil%stokes(1),stokes_order)
        else
          outarray(8:lc,kv) = inarray
        endif
        ! Trailing column (only 1 so far, assumed to be Source ID...)
        if (nt.ne.0) then
          outarray(nt:nt,kv) = trail
          mtrail = max(mtrail,trail)
        endif
        ngood = ngood+1
      else
        nflag = nflag+1
      endif
    enddo
    !
    if (kv.ne.0) then
      fits%blc(2) = fits%trc(2)+1
      fits%trc(2) = fits%trc(2)+kv
      !! Print *,'Writing block ',fits%blc(2),fits%trc(2)
      call gdf_write_data(fits,outarray,error)
      if (error) goto 100
    else
      nempty = nempty+1
    endif
  enddo
  write(mess,'(A,I9,A)') 'Wrote   ',ngood,' visibilities'
  call gio_message(seve%i,rname,mess)
  !
  ! If some data has been ignored, say it and update visibility number
  if (nempty.gt.0) then
    write(mess,'(I0,A)') nempty ,' input blocks were empty'
    call gio_message(seve%w,rname,mess)
  endif
  if (nflag.gt.0) then
    write(mess,'(A,I9,A)') 'Ignored ',nflag,' flagged visibilities'
    call gio_message(seve%w,rname,mess)
    fits%gil%nvisi = ngood  ! This is needed but not sufficient...
    fits%gil%dim(2) = ngood ! so it is better to also change the array size 
    call gdf_update_header(fits,error)
  endif
  if (fits%gil%nstokes.gt.1)  call gio_message(seve%w,rname, &
      &   'More than 1 Stokes parameter, use STOKES command after')
!
100 continue
  if (stbl.ne.2) call gdf_stbl(stbl,err)
  !
  if (nt.ne.0) then
    !
    ! Mtrail contains the largest Source ID, i.e. the number of sources
    if (mtrail.le.1) then
      call gio_message(seve%w,rname,'Only one source found in MultiSource UVFITS file')
      ! We could (and perhaps should) set these to 0,
      ! since the information is to be ignored. But that would mean
      ! undefined trailing columns in the UV data.
      !! fits%gil%column_pointer(code_uvt_id) = fits%gil%dim(1)-1
      !! fits%gil%column_size(code_uvt_id) = 1
    endif
    !! Needed only in case we update the Pointers.
    !! call gdf_update_header(fits,error)
  endif
  call gdf_close_image(fits,err)  ! To free the allocated slot
  error = err.or.error
end subroutine read_uvfits
!
subroutine key_order(pcount,syst)
  use gio_fitsdef
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !    Define the scaling factors for each parameter
  !    and find out the ordering of the required Daps
  !---------------------------------------------------------------------
  integer, intent(in) :: pcount         ! Parameter count
  character(len=*), intent(in) :: syst  ! Coordinate system
  ! Local
  integer :: i
  real(8), parameter :: c=299792458.d0  ! Speed of light
  character(len=80) :: mess
  !
  luu = 0
  lvv = 0
  lww = 0
  ldate = 0
  ltime = 0
  lbase = 0
  lsour = 0
  lfreq = 0
  linte = 0
  !
  do i=1,pcount
    !
    ! There are things like UU--SIN
    if (ptype(i)(1:2).eq.'UU') then
      luu = i
      pscal(i) = c*pscal(i)
      pzero(i) = c*pzero(i)
    elseif (ptype(i)(1:2).eq.'VV') then
      lvv = i
      pscal(i) = c*pscal(i)
      pzero(i) = c*pzero(i)
    elseif (ptype(i)(1:2).eq.'WW') then
      lww = i
      pscal(i) = c*pscal(i)
      pzero(i) = c*pzero(i)
      !
      ! Date / Time can be in two parts
    elseif (ptype(i).eq.'DATE') then
      if (ldate.eq.0) then
        ldate = i
      else
        ltime = i
      endif
    elseif (ptype(i).eq.'TIME') then
      ltime = i
      !
      ! This is sometimes also written 'BASELINE'
    elseif (ptype(i)(1:4).eq.'BASE') then
      lbase = i
      ! Attempt to handle multi-source data
    elseif (ptype(i).eq.'SOURCE') then
      call gio_message(seve%w,'UVFITS','Possible Multi source data: support is limited')
      if (syst.ne.' ') then
        call gio_message(seve%w,'UVFITS','Pointing Center already set from OBSRA & OBSDEC')
        lsour = 0
      else
        call gio_message(seve%w,'UVFITS','Multi source data: RA and DEC may not be initialized')
        lsour = i
      endif
    elseif (ptype(i).eq.'INTTIM') then
      linte = i
    elseif (ptype(i).eq.'FREQSEL') then
      lfreq = i
    else
      write(mess,*) 'Unknown PTYPE ',ptype(i),' for column ',i
      call gio_message(seve%w,'UVFITS',mess)
    endif
  enddo
  !
  ! Use Offset between GAG_DATE and MJD
  if (ldate.ne.0) then
    pzero(ldate) = pzero(ldate) -  2460549.5d0
  endif
end subroutine key_order
!
subroutine read_visi(daps,visi,nchan,ps,error,pcount,trail,rinte,good)
  use gildas_def
  use gio_interfaces, only : gio_message
  use gio_fitsdef
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of output array re-shaping)
  !
  ! FITS  Internal routine.
  !       Read one visibility from FITS file.
  !---------------------------------------------------------------------
  real,    intent(out)   :: daps(7)        ! Data Associated Parameters
  integer, intent(in)    :: nchan          ! Number of "channels"
  real,    intent(out)   :: visi(3,nchan)  ! Visibilities
  real,    intent(in)    :: ps             ! Weight scaling factor
  logical, intent(inout) :: error          ! Error flag
  integer, intent(in)    :: pcount         ! Parameter count
  real,    intent(inout) :: trail          ! trailing array
  real,    intent(inout) :: rinte          ! integration time (if any)
  logical, intent(inout) :: good           ! Input: keep all the channels? Output: kept any good channel?
  ! Local
  integer, parameter :: mdap=20     ! Must be > 8
  real :: udaps(mdap)
  integer :: i
  integer(kind=size_length) :: vsize
  real :: dummy
  character(len=60) :: chain
  !
  ! Get daps
  vsize = 1
  do i=1,min(mdap,pcount)
    call gfits_getreal(fd,vsize,udaps(i),pscal(i),pzero(i),error)
  enddo
  !
  ! Sort them
  daps(1) = udaps(luu)
  daps(2) = udaps(lvv)
  daps(3) = udaps(lww)
  if (ltime.ne.0) then
    daps(4) = int(udaps(ldate))    ! In days
    daps(5) = (dble(udaps(ldate)-daps(4)) +  &
               dble(udaps(ltime)))*86400.d0  ! In seconds
  else
    daps(4) = int(udaps(ldate))
    daps(5) = (dble(udaps(ldate))-daps(4))*86400.d0
  endif
  daps(6) = int(udaps(lbase))/256
  daps(7) = nint(udaps(lbase)-256*daps(6))
  !
  ! Skip any other information
  vsize = 1
  do i=mdap+1,pcount
    call gfits_getreal(fd,vsize,dummy,1.0,dzero,error)  ! DUMMY READ
  enddo
  !
  ! Get data
  vsize = 3*nchan
  call gfits_getreal(fd,vsize,visi,cscal,czero,error)    ! Data & Weight
  !
  ! Scale weights
  if (good) then
    do i=1, nchan
      ! This implies writing Flagged data...
      visi(3,i) = visi(3,i)*ps  ! Weight is positive or negative ...
    enddo
  else
    do i=1, nchan
      ! Ignore Flagged data...
      if (visi(3,i).gt.0.) then
        visi(3,i) = visi(3,i)*ps  ! Weight is positive
        good = .true.
      else
        visi(1,i) = 0
        visi(2,i) = 0
      endif
    enddo
  endif
  if (error) then
    call gio_message(seve%e,'UVFITS','Error in READ_VISI')
  endif
  !
  if (lsour.ne.0) then
    trail = udaps(lsour)
  endif
  !
  if (linte.ne.0) then
    if (rinte.eq.0.0) then
      rinte = udaps(linte)
      write(chain,*) 'Integration time is ',rinte
      call gio_message(seve%i,'UVFITS',chain)
    elseif (rinte.ne.udaps(linte)) then
      rinte = udaps(linte)
      write(chain,*) 'Integration time changed to ',rinte
      call gio_message(seve%w,'UVFITS',chain)
    endif
  endif
  if (lfreq.ne.0) then
    if (udaps(lfreq).ne.1.0) then
      call gio_message(seve%e,'UVFITS','More than 1 Frequency setup - unsupported')
    endif
  endif
end subroutine read_visi
!
subroutine gio_setistbl(is,stbl)
  use gio_image
  !--------------------------------------------------------
  ! @ private
  ! Temporary routine to set the Number of Header blocks
  ! Use by FITS interface to support Ntsokes > 1.
  !--------------------------------------------------------
  integer, intent(in) :: is     ! Image slot number
  integer, intent(in) :: stbl   ! Number of header blocks
  !
  istbl(is) = stbl
end subroutine gio_setistbl
!
function stokes_from_fits(rfits)
  use image_def
  !--------------------------------------------------------
  ! @ public
  !
  ! Here we decode the Stokes convention from the FITS Header
  ! -8  -7  -6  -5  -4  -3  -2  -1   0   1   2   3   4
  ! YX  XY  YY  XX  LR  RL  LL  RR  None I   Q   U   V
  !--------------------------------------------------------
  !
  integer :: stokes_from_fits
  real, intent(in) :: rfits
  !
  integer :: jfits(-8:4)
  integer :: jgdf(-8:4)
  integer :: kfits
  !
  data jfits/-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4/
  data jgdf/code_stokes_yx,code_stokes_xy,code_stokes_yy,code_stokes_xx, &
       & code_stokes_lr,code_stokes_rl,code_stokes_ll,code_stokes_rr, &
       & code_stokes_none,code_stokes_i,code_stokes_q,code_stokes_u,code_stokes_v/
  kfits = nint(rfits)
  if (kfits.ge.-8.and.kfits.le.4) then
    stokes_from_fits = jgdf(kfits)
  else
    stokes_from_fits = code_stokes_none
  endif
end function stokes_from_fits
!
function fits_from_stokes(istoke)
  use image_def
  !--------------------------------------------------------
  ! @ public
  !
  ! Here we decode the Stokes convention from the FITS Header
  ! -8  -7  -6  -5  -4  -3  -2  -1  0    1   2   3   4
  ! YX  XY  YY  XX  LR  RL  LL  RR  None I   Q   U   V
  !--------------------------------------------------------
  !
  integer :: fits_from_stokes
  integer, intent(in) :: istoke
  !
  integer :: jfits(13)
  integer :: jgdf(13)
  integer :: i
  !
  data jfits/-8,-7,-6,-5,-4,-3,-2,-1,0,1,2,3,4/
  data jgdf/code_stokes_yx,code_stokes_xy,code_stokes_yy,code_stokes_xx, &
       & code_stokes_lr,code_stokes_rl,code_stokes_ll,code_stokes_rr, &
       & code_stokes_none,code_stokes_i,code_stokes_q,code_stokes_u,code_stokes_v/
  !
  fits_from_stokes = code_stokes_none
  do i=1,13
    if (istoke.eq.jgdf(i)) then
      fits_from_stokes=jfits(i)
      return
    endif
  enddo
end function fits_from_stokes
!
!
subroutine uvfits_stokes_select(inarray,inchan,outarray,onchan, &
  & nstokes,in_stokes,out_stokes,stokes_order)
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !   GIO   perform the appropriate Stokes conversion
  !---------------------------------------------------------------------
  integer, intent(in) :: inchan             ! Input number of channels
  real, intent(in) :: inarray(3,inchan)     ! Input visibilitiees
  integer, intent(in) :: onchan             ! Output number of channels
  real, intent(out) :: outarray(3,onchan)   ! Output visibilities
  integer, intent(in) :: nstokes            ! Number of input Stokes
  integer, intent(in) :: in_stokes(nstokes) ! Input Stokes codes
  integer, intent(in) :: out_stokes         ! Output Stokes
  integer, intent(in) :: stokes_order       ! Stokes ordering
  !
  integer :: i,j
  real :: wa, wb
  !
  ! Extract or Compute the out_stokes parameter from the 
  ! in_stokes(nstokes) input parameters.
  !
  if (nstokes.eq.2) then
    ! This assumes (but it is customary) that we have
    ! 2 stokes, either XX,YY or RR,LL or even HH,VV as input
    if (stokes_order.eq.code_stok_chan) then
      if (out_stokes.eq.code_stokes_i) then
        j = 1
        do i=1,onchan
          if (inarray(3,j).gt.0 .and. inarray(3,j+1).gt.0) then
            outarray(1:2,i) = 0.5*(inarray(1:2,j)+inarray(1:2,j+1))
            outarray(3,i) = 4*inarray(3,j)*inarray(3,j+1)/(inarray(3,j)+inarray(3,j+1))
          else
            outarray(1:3,i) = 0.
          endif
          j = j+2
        enddo
      else if (out_stokes.eq.code_stokes_none) then
        ! None: can pick any unflagged data
        j = 1
        do i=1,onchan
          wa = max(0.,inarray(3,j))
          wb = max(0.,inarray(3,j+1))
          outarray(3,i) = wa+wb
          !
          if (outarray(3,i).ne.0) then
            outarray(1:2,i) = ( inarray(1:2,j)*wa + &
              & inarray(1:2,j+1)*wb ) / outarray(3,i)
          else
            outarray(1:2,i) = inarray(1:2,j)+inarray(1:2,j+1)
          endif
          j = j+2
        enddo
      else if (out_stokes.eq.in_stokes(1)) then
        j = 1
        do i=1,onchan
          outarray(1:3,i) = inarray(1:3,j)
          j = j+2
        enddo
      else if (out_stokes.eq.in_stokes(2)) then
        j = 2
        do i=1,onchan
          outarray(1:3,i) = inarray(1:3,j)
          j = j+2
        enddo
      endif
    else if (stokes_order.eq.code_chan_stok) then
      if (out_stokes.eq.code_stokes_i) then
        do i=1,onchan
          outarray(1:3,i) = inarray(1:3,i)+inarray(1:3,i+onchan)
        enddo
      else if (out_stokes.eq.code_stokes_none) then
        do i=1,onchan
          wa = max(0.,inarray(3,i))
          wb = max(0.,inarray(3,i+onchan))
          outarray(3,i) = wa+wb
          if (outarray(3,i).ne.0) then
            outarray(1:2,i) = ( inarray(1:2,i)*wa + &
              & inarray(1:2,i+onchan)*wb ) / outarray(3,i)
          else
            outarray(1:2,i) = inarray(1:2,i)+inarray(1:2,i+onchan)
          endif
          j = j+1
        enddo
      else if (out_stokes.eq.in_stokes(1)) then
        do i=1,onchan
          outarray(1:3,i) = inarray(1:3,i)
        enddo
      else if (out_stokes.eq.in_stokes(2)) then
        do i=1,onchan
          outarray(1:3,i) = inarray(1:3,i+inchan)
        enddo
      endif
    endif
  else if (nstokes.eq.4) then
    ! It must be the I,Q,U,V   values as input,
    ! or XX, YY, XY, YX
    ! or RR, LL, RL, LR
    ! or (but this never happens) HH, VV, HV, VH
    !
    ! and STOKES_NONE as output
    if (out_stokes.eq.code_stokes_none) then
      !
      ! We might sum up the first 2 values XX + YY or LL + RR or take I or None as above.
      call gio_message(seve%e,'FITS','4 Stokes to Unpolarized not yet coded')
      call sysexi(fatale)
    else
      call gio_message(seve%e,'FITS','Dont know yet how to handle 4 Stokes - Really Sorry')
      call sysexi(fatale)
    endif
  endif
  !
end subroutine uvfits_stokes_select

program histo_table
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Main program for making a cross Histogram from two columns of a
  ! table
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='HISTO_TABLE'
  character(len=filename_length) :: namey,namex
  logical :: error
  real(kind=4) :: hzmin,hzmax,hzstep, hymin,hymax,hystep
  integer(kind=4) :: n,nhz,nhy,nco(2),ier
  real(kind=4), allocatable :: xdata(:,:), yd1(:), yd2(:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_inte('Y_COLUMNS$',nco,2)
  call gildas_inte('BINS1$',nhz,1)
  call gildas_real('MIN1$',hzmin,1)
  call gildas_real('MAX1$',hzmax,1)
  call gildas_inte('BINS2$',nhy,1)
  call gildas_real('MIN2$',hymin,1)
  call gildas_real('MAX2$',hymax,1)
  call gildas_char('X_NAME$',namex)
  call gildas_close
  !
  ! Map input table
  call gildas_null(y)
  y%gil%ndim = 2
  call sic_parse_file(namey,' ','.tab',y%file)
  call gdf_read_header(y,error)
  if (error) goto 100
  if (nco(1).lt.1 .or. nco(1).gt.y%gil%dim(2) .or.  &
      nco(2).lt.1 .or. nco(2).gt.y%gil%dim(2)) then
    write(6,*) 'Input columns out of range 1 -',y%gil%dim(2)
    goto 100
  endif
  !
  ! Define output histogram
  call gildas_null(x)
  n = len_trim(namex)
  if (n.eq.0) goto 100
  call sic_parse_file(namex(1:n),' ','.gdf',x%file)
  hzstep = (hzmax-hzmin)/(nhz-1)
  hystep = (hymax-hymin)/(nhy-1)
  !
  x%gil%ndim = 2
  x%gil%dim(1) = nhz
  x%gil%dim(2) = nhy
  x%gil%dim(3) = 1
  x%gil%dim(4) = 1
  x%gil%coor_words = 6*gdf_maxdims
  x%gil%convert(1,1) = 1.0
  x%gil%convert(2,1) = hzmin
  x%gil%convert(3,1) = hzstep
  x%gil%convert(1,2) = 1.0
  x%gil%convert(2,2) = hymin
  x%gil%convert(3,2) = hystep
  x%gil%extr_words = 0
  x%gil%spec_words = 0
  x%gil%blan_words = 2
  x%gil%desc_words = def_desc_words
  x%gil%proj_words = 0
  x%gil%bval = 0.d0
  x%gil%eval = -1.d0
  x%char%code(1) = 'UNKNOWN     '
  x%char%code(2) = 'UNKNOWN     '
  x%char%code(3) = 'UNKNOWN     '
  x%char%code(4) = 'UNKNOWN     '
  x%char%unit    = 'PIXELS      '
  !
  ! Change boundaries
  hzmin = hzmin - 0.5*hzstep
  hzmax = hzmax + 0.5*hzstep
  hymin = hymin - 0.5*hystep
  hymax = hymax + 0.5*hystep
  allocate(xdata(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,'output buffer',ier,error))  goto 100
  allocate(yd1(y%gil%dim(1)),yd2(y%gil%dim(1)),stat=ier)
  if (failed_allocate(rname,'input buffers',ier,error))  goto 100
  !
  y%blc(2) = nco(1)
  y%trc(2) = nco(1) 
  call gdf_read_data(y,yd1,error)
  if (error)  goto 100
  !
  y%blc(2) = nco(2)
  y%trc(2) = nco(2)
  call gdf_read_data(y,yd2,error)
  if (error)  goto 100
  !
  call histo004(yd1,yd2,y%gil%dim(1),0.0,-1.0,hzmin,hzstep,hzmax,hymin,  &
    hystep,hymax,x%gil%dim(1),x%gil%dim(2),xdata)
  !
  call gdf_write_image(x,xdata,error)
  if (error)  goto 100
  call gagout('S-HISTO_TABLE,  Successful completion')
  call sysexi(1)
  !
100 call sysexi(fatale)
end program histo_table
!
subroutine histo004(z,y,nl,bval,eval,pzmin,pzstep,pzmax,pymin,pystep,  &
  pymax,nhz,nhy,h)
  use gildas_def
  !---------------------------------------------------------------------
  ! Compute the crossed histogram map of two columns of a table.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nl          ! Number of lines
  real(kind=4),               intent(in)  :: z(nl)       ! First input column address
  real(kind=4),               intent(in)  :: y(nl)       ! Second input column address
  real(kind=4),               intent(in)  :: bval        ! Blanking value
  real(kind=4),               intent(in)  :: eval        ! Tolerance on blanking
  real(kind=4),               intent(in)  :: pzmin       ! Low threshold for Z input array
  real(kind=4),               intent(in)  :: pzstep      ! Histogram step for Z input array
  real(kind=4),               intent(in)  :: pzmax       !
  real(kind=4),               intent(in)  :: pymin       ! Low threshold for Y input array
  real(kind=4),               intent(in)  :: pystep      ! Histogram step for Y input array
  real(kind=4),               intent(in)  :: pymax       !
  integer(kind=index_length), intent(in)  :: nhz         ! First dimension for histogram array
  integer(kind=index_length), intent(in)  :: nhy         ! Second dimension for histogram array
  real(kind=4),               intent(out) :: h(nhz,nhy)  ! Histogram array
  ! Local
  integer(kind=index_length) :: i
  integer(kind=4) :: iz,jy,nin,nout,nblank,ntot
  !
  h = 0.0
  nin = 0
  nout = 0
  nblank = 0
  !
  if (eval.ge.0.0) then
    !
    do i=1,nl
      if (abs(z(i)-bval).gt.eval .and.   &
          abs(y(i)-bval).gt.eval) then
        if (z(i).ge.pzmin .and. z(i).lt.pzmax) then
          iz = int((z(i)-pzmin)/pzstep) + 1
          if (y(i).ge.pymin .and. y(i).lt.pymax) then
            jy = int((y(i)-pymin)/pystep) + 1
            h(iz,jy) = h(iz,jy)+1.0
            nin = nin+1
          else
            nout = nout+1
          endif
        else
          nout = nout+1
        endif
      else
        nblank = nblank+1
      endif
    enddo
    !
  else
    !
    do i=1,nl
      if (z(i).ge.pzmin .and. z(i).lt.pzmax) then
        iz = int((z(i)-pzmin)/pzstep) + 1
        if (y(i).ge.pymin .and. y(i).le.pymax) then
          jy = int((y(i)-pymin)/pystep) + 1
          h(iz,jy) = h(iz,jy)+1.0
          nin = nin+1
        else
          nout = nout+1
        endif
      else
        nout = nout+1
      endif
    enddo
    !
  endif
  !
  ntot = nin+nout+nblank
  write(6,100) nin,float(nin)/float(ntot)*1.e2,   &
               nout,float(nout)/float(ntot)*1.e2,   &
               nblank,float(nblank)/float(ntot)*1.e2,   &
               ntot
100 format(1x,'Number of points in histogram ',i12,4x,f5.1,' %',   &
            /,'  "    "    "    out of  "    ',i12,4x,f5.1,' %',  &
            /,'  "    "    "    blanked      ',i12,4x,f5.1,' %',  &
            /,'                 Total      = ',i12)
end subroutine histo004

!     
!     $Id$
!    
! <DOCUMENTATION name="modulePakoXML">
!  This module implements a simple interface to write information
!  to a VOTable XML file.  It is in particular adapted for pako
!  (the observer's user interface to the NCS). pako uses it to
!  write XML files for the Queue and Coordinator. 
!  Data processing software can use it to write results XML files
!  for pako.
! </DOCUMENTATION>
!
! <DEV> 
! TBD: - more documentation
!      - more elaborate error handling
!          - parameter "error" (error flag) should be Optional
!            in all routines
!          - general error codes per Character variable errorC
!            are foreseen, but only in a few cases implemented,
!             e.g., in pakoXMLdictionaryAdd pakoXMLpush pakoXMLpop
!      - use linked lists for lists
!      - more fundamental "abstract" routines independant
!        of VOTable XML
!      - ...
! <\DEV> 
!
Module modulePakoXML
  !     
  Use modulePakoMessages
!
  Implicit None
  Save
  Private
  !
  ! *** Subroutines
  !
  Public :: pakoXMLsetOutputUnit
  Public :: pakoXMLsetIndent
  !
  Public :: pakoXMLwriteStartXML
  Public :: pakoXMLwriteStartElement
  Public :: pakoXMLwriteEndElement
  Public :: pakoXMLwriteElement
  !
  Public :: pakoXMLcase
  Public :: pakoXMLupper
  !     
  ! *** values representing "not set":
  !
  !
  Character(len=8),  Parameter  :: cNone = 'none'
  Integer,           Parameter  :: iNone = 0
  Real,              Parameter  :: rNone = 0.0
  Real(Kind=8),      Parameter  :: dNone = 0.0D0
  !
  ! *** Variables  for XML ***
  !
  Integer :: outputUnitXML = iNone
  Integer :: levelXML      = iNone
  Integer :: indentXML     = iNone
  !
  Integer, Parameter  :: lWord    = 128
  Integer, Parameter  :: lPhrase  = 256
  Integer, Parameter  :: lLine    = 512
  Integer, Parameter  :: lLineOut = 1024
  Character(len=lWord)    :: word    = cNone
  Character(len=lPhrase)  :: phrase  = cNone
  Character(len=lLine)    :: line    = cNone
  Character(len=lLine)    :: line2   = cNone
  Character(len=lLineOut) :: lineOut = cNone
  !
  ! *** dictionary for mixedCase keyword values:
  ! TBD: turn this into a linked list
  !
  Integer, Parameter  :: lDict   = 12
  !
  Type :: pakoXMLdictionaryT
     Character(len=ldict) :: key     = cNone
     Character(len=lDict) :: value   = cNone
  End Type pakoXMLdictionaryT
  !
  Integer, Parameter  :: nDimDict = 999
  Integer             :: nDict    = iNone
  Type (pakoXMLdictionaryT), Dimension(nDimDict) :: pakoDict
  !
  ! *** working variables and constants ***
  !     standard constants
  Real,    Parameter  :: Pi=3.141592653589793
  Real,    Parameter  :: degs=Pi/180.0
  !
  ! *** "stack" of elements
  ! TBD:  in future: replace this by a linked list!
  !
  Integer, Parameter  :: lEl   =  24
  Integer, Parameter  :: lText = 256
  !
  Type :: pakoXMLelementT
     Character(len=lEl)   ::  element  = cNone
     Character(len=lEl)   ::  name     = cNone
     Character(len=lEl)   ::  comment  = cNone
     Logical              ::  doCdata  = .False.
     Character(len=lEl)   ::  space    = cNone
     Character(len=lEl)   ::  value    = cNone
     Character(len=lEl)   ::  unit     = cNone
     Character(len=lEl)   ::  dataType = cNone
     Character(len=lText) ::  text     = cNone
  End Type pakoXMLelementT
  !
  Integer, Parameter :: nDimStack = 99
  Integer            :: nStack    = iNone
  Type (pakoXMLelementT), Dimension(nDimStack) :: stack
  Type (pakoXMLelementT)                       :: elementNone
  !
  ! *** for error messages:
  !
  Integer, Parameter :: severityI = 1
  Integer, Parameter :: severityW = 2
  Integer, Parameter :: severityE = 3
  Integer, Parameter :: severityF = 4
  !
  Integer, Parameter :: priorityI = severityI*2
  Integer, Parameter :: priorityW = severityW*2
  Integer, Parameter :: priorityE = severityE*2
  Integer, Parameter :: priorityF = severityF*2
  !
Contains
!!!     
!!!
  Subroutine pakoXMLsetOutputUnit(iUnit, error)
    Integer,  Intent(IN),  Optional :: iUnit
    Logical,  Intent(OUT), Optional :: error              ! errorFlag
    ! <DOCUMENTATION name="pakoXMLsetOutputUnit">
    ! set unit number for XML output.
    ! all XML output will be written to the file attached to iUnit
    ! </DOCUMENTATION>
    !
    if (Present(error)) error = .False.
    !
    If (Present(iUnit)) Then
       outputUnitXML = iUnit
    Else
       outputUnitXML = 11
    End If
    !
  End Subroutine pakoXMLsetOutputUnit
!!!
!!!
  Subroutine pakoXMLsetIndent(iIndent, error)
    Integer, Intent(IN),  Optional :: iIndent
    Logical, Intent(OUT), Optional :: error              ! errorFlag
    ! <DOCUMENTATION name="pakoXMLsetIndent">
    ! set indent for XML output.
    ! each nesting level of the XML hierarchy 
    ! will be indented by iIndent characters
    ! </DOCUMENTATION>
    !
    if (Present(error)) error = .False.
    !
    If (Present(iIndent)) Then
       indentXML = iIndent
    Else
       indentXML = 1
    End If
    !
  End Subroutine pakoXMLsetIndent
!!!
!!!
  Subroutine pakoXMLsetLevel(iLevel)
    Integer, Intent(IN) :: iLevel
    ! <DOCUMENTATION name="pakoXMLsetLevel">
    ! internal pakoXML routine
    ! set level of XML nesting to iLevel
    ! </DOCUMENTATION>
    !
    If (iLevel.Ge.1) Then
       levelXML = iLevel
    End If
    !
  End Subroutine pakoXMLsetLevel
!!!
!!!
  Subroutine pakoXMLwriteStartXML(                                &
       &                                       xmlVersionNum,     &
       &                                       docTypeName,       &
       &                                       dtdFile,           &
       &                                       dtdVersion,        &
       &                                       comment,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Character(len=*), Intent(IN),  Optional :: xmlVersionNum      ! XML Version Number
    Character(len=*), Intent(IN)            :: docTypeName        ! document Type
    Character(len=*), Intent(IN)            :: dtdFile            ! DTD file
    Character(len=*), Intent(IN)            :: dtdVersion         ! DTD version
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteStartXML">
    ! Write start of XML file
    ! </DOCUMENTATION>
    !     
    Type (pakoXMLelementT) :: elementToStack
    !    
    error = .False.
    If(Present(errorC)) errorC="OK"
    !
    elementToStack = elementNone
    !
    Call pakoXMLdictionaryInit(error)
    Call pakoXMLsetLevel(1)
    !
    If (Present(xmlVersionNum)) Then
       line = '<?xml version="'//                                 &
            &     xmlVersionNum(1:Len_trim(xmlVersionNum))//'"?>'
    Else
       line = '<?xml version="1.0"?>'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    line = '<!DOCTYPE '//                                         &
         &     docTypeName(1:Len_trim(docTypeName))//' '//        &
         &     'SYSTEM "'//dtdFile(1:Len_trim(dtdFile))//'">'
    Call pakoXMLwriteLine(line,error)
    !
    elementToStack%element  = docTypeName(1:Len_trim(docTypeName))
    line = '<'//docTypeName(1:Len_trim(docTypeName))//' '//       &
         &   'version="'//dtdVersion(1:Len_trim(dtdVersion))//'">'
    Call pakoXMLwriteLine(line,error)
    !
    If (Present(comment)) Then
       line = '<!-- '//comment(1:Len_trim(comment))//' -->'
       Call pakoXMLwriteLine(line,error)
    End If
    !
    lineOut = ''
    Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))        
    !
    Call pakoXMLpush(elementToStack,pushError=error)
    !
    Return
    !
  End Subroutine pakoXMLwriteStartXML
!!!
!!!
  Subroutine pakoXMLwriteStartElement(                            &
       &                                       element,           &
       &                                       name,              &
       &                                       comment,           &
       &                                       doCdata,           &
       &                                       doSpace,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                             )
    !
    Character(len=*), Intent(IN)            :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Logical,          Intent(IN),  Optional :: doCdata            ! add start of CDATA
    Logical,          Intent(IN),  Optional :: doSpace            ! !obsolete!
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteStartElement">
    ! write start tag of an XML element that will have several lines
    ! of content, maybe including nested elements;
    ! information about this element is pushed on the stack.
    ! </DOCUMENTATION>
    !
    Type (pakoXMLelementT) :: elementToStack
    !    
    error  = .False.
    If(Present(errorC)) errorc="OK"
    !
    elementToStack          = elementNone
    elementToStack%element  = element
    !
    Call pakoXMLsetLevel(levelXML+1)
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       elementToStack%space = space
       Write (outputUnitXML,'(A)') ''
    End If
    !
    line = '<'//element(1:Len_trim(element))
    If (Present(name)) Then
       elementToStack%name  = name
       line = line(1:Len_trim(line))//                            &
            &      ' name="'//name   (1:Len_trim(name  ))//'"'
    End If
    line = line(1:Len_trim(line))//'>'
    If (Present(comment)) Then
       elementToStack%comment = comment
       line = line(1:Len_trim(line))//                            &
            &      ' <!-- '//comment(1:Len_trim(comment))//' -->'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    If (Present(doSpace)) Then
       if(doSpace) then
          Write (outputUnitXML,'(A)') ''
       End If
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       elementToStack%space = space
       Write (outputUnitXML,'(A)') ''
    End If
    !
    If (Present(doCdata)) Then
       if (doCdata) then
          elementToStack%doCData = doCData
          Write (outputUnitXML,*) '<![CDATA['
       End If
    End If   
    !
    Call pakoXMLpush(elementToStack,pushError=error)
    !
    Return
    !
  End Subroutine pakoXMLwriteStartElement
!!!
!!!
  Subroutine pakoXMLwriteEndElement(                              &
       &                                       element,           &
       &                                       name,              &
       &                                       doCdata,           &
       &                                       doSpace,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN),  Optional :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Logical,          Intent(IN),  Optional :: doCdata            ! add end of CDATA
    Logical,          Intent(IN),  Optional :: doSpace            ! !Obsolete!
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteEndElement">
    ! write end of an element
    !   element and name are optional and used for a consistency
    !   check against the information poped from the stack; if they 
    !   don't match, warning messages are generated; anyhow, the 
    !   information FROM THE STACK is used to write XML
    ! </DOCUMENTATION>
    !
    Character(len=128) :: errorM
    !
    Integer :: length
    !     
    Type (pakoXMLelementT) :: eFS                                 ! element From Stack
    !    
    error  = .False.
    errorM = 'OK'
    !
    eFS  = elementNone
    Call pakoXMLpop(eFS,popError=error)
    !
    If (Present(element)) Then
       If (element   (1:Len_trim(element))      .Ne.              &
            &          eFS%element(1:Len_trim(eFS%element))) Then
          error  = .True.
          errorM = 'EndElement. inconsistent element: "'          &
               &    //element(1:Len_trim(element))                &
               &    //'". I expected: "'                          &
               &    //eFS%element(1:Len_trim(eFS%element))//'"'
          Call PakoMessage(priorityE,severityE,                       &
               &                      'XMLwrite',errorM)
       End If
       If (Present(name).And.                                     &
            &           name    (1:Len_trim(name))      .Ne.      &
            &           eFS%name(1:Len_trim(eFS%name))) Then
          error  = .True.
          errorM = 'EndElement. inconsistent name: "'             &
               &    //name(1:Len_trim(name))                      &
               &    //'". I expected: "'                          & 
               &    //eFS%name(1:Len_trim(eFS%name))//'"'
          Call PakoMessage(priorityE,severityE,                       &
               &                      'XMLwrite',errorM)
       End If
    End If
    !
    If (eFS%doCdata) Then
       Write (outputUnitXML,*) ']]>'
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    line = '</'//eFS%element(1:Len_trim(eFS%element))//'>'
    If (eFS%name.Ne.elementNone%name) Then
       line = line(1:Len_trim(line))//                            &
            &      ' <!-- name="'                                 &
            & //eFS%name(1:Len_trim((eFS%name)))//'" -->'
    End If
    Call pakoXMLwriteLine(line,error)
    !
    If (index(eFS%space,'after') .Ge. 1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    Call pakoXMLsetLevel(levelXML-1)
    !
    If (Present(errorC)) Then
       length = Min(Len(errorM),Len(errorC))
       errorC(1:length) = errorM(1:length)
    End If
    !
    Return
    !
  End Subroutine pakoXMLwriteEndElement
!!!
!!!
  Subroutine pakoXMLwriteElement(                                 &
       &                                       element,           &
       &                                       name,              &
       &                                       value,             &
       &                                       unit,              &
       &                                       dataType,          &
       &                                       comment,           &
       &                                       text,              &
       &                                       content,           &
       &                                       space,             &
       &                                       error,             &
       &                                       errorC             &
       &                        )
    !
    Character(len=*), Intent(IN)            :: element            ! XML element
    Character(len=*), Intent(IN),  Optional :: name               ! attribute "name"
    Character(len=*), Intent(IN),  Optional :: value              ! attribute "value"
    Character(len=*), Intent(IN),  Optional :: unit               ! attribute "unit"
    Character(len=*), Intent(IN),  Optional :: dataType           ! attribute "dataType"
    Character(len=*), Intent(IN),  Optional :: comment            ! XML comment
    Character(len=*), Intent(IN),  Optional :: text               ! !OBSOLETE!
    Character(len=*), Intent(IN),  Optional :: content            ! content of element
    Character(len=*), Intent(IN),  Optional :: space              ! add space before or after
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLwriteElement">
    ! write an element that fits in one line
    ! </DOCUMENTATION>
    !
    Integer :: length
    !     
    error = .False.
    If(Present(errorC)) errorc="OK"
    !
    Call pakoXMLsetLevel(levelXML+1)
    !
    If (Present(space).And.                                       &
         &        index(space,'before').Ge.1) Then
       lineOut = ''
       Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))        
    End If
    !
    line = '<'//element(1:Len_trim(element))
    !
    If (Present(name)) Then
       line = line(1:Len_trim(line))//                            &
            &               ' name="'//name(1:Len_trim(name))//'"'   
    End If
    !
    If (Present(value)) Then
       word = Adjustl(value)
       line = line(1:Len_trim(line))//                            &
            &              ' value="'//word(1:Len_trim(word))//'"'   
    End If
    !
    If (Present(unit)) Then
       line = line(1:Len_trim(line))//                            &
            &              ' unit="'//unit(1:Len_trim(unit))//'"'
    End If
    !
    If (Present(dataType)) Then
       line = line(1:Len_trim(line))//                            &
            & ' datatype="'//dataType(1:Len_trim(dataType))//'"'
    End If
    !
    line = line(1:Len_trim(line))//'>'
    !
    If (Present(content)) Then
       phrase = Adjustl(content)
       line = line(1:Len_trim(line))//phrase(1:Len_trim(phrase))
    End If
    !
    If (Present(text)) Then
       phrase = Adjustl(text)
       line = line(1:Len_trim(line))//phrase(1:Len_trim(phrase))
    End If
    !
    line = line(1:Len_trim(line))//                               &
         &           '</'//element(1:Len_trim(element))//'>'
    !
    If (Present(comment)) Then
       phrase = Adjustl(comment)
       Call pakoXMLnoir(phrase,length)
       line = line(1:Len_trim(line))//                            &
            &    ' <!-- '//phrase(1:Len_trim(phrase))//' -->'
    End If
    !
    line2 = Adjustl(line)
    !
    Call pakoXMLwriteLine(line2,error)
    !
    If (Present(space).And.                                       &
         &        index(space,'after').Ge.1) Then
       Write (outputUnitXML,'(A)') ''
    End If
    !
    Call pakoXMLsetLevel(levelXML-1)
    !
    Return
    !
  End Subroutine pakoXMLwriteElement
!!!
!!!
  Subroutine pakoXMLcase(              text,                      &
       &                               error)
    !
    Character(len=*), Intent(INOUT) :: text
    Logical,          Intent(OUT)   :: error
    !
    ! <DOCUMENTATION name="pakoXMLcase">
    ! special routine to be used by paKo:
    ! convert a keyword to mixed case according to
    ! key/value pairs in the "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    Integer :: length
    Integer :: ii
    !
    error = .False.
    !
    length = Min(Len(text),Len(word))
    word   = text(1:length)
    word   = Adjustl(text)
    Call pakoXMLupper(word)
    !
    Do ii = 1, nDict, 1
       If (word.Eq.pakoDict(ii)%key) Then
          word = pakoDict(ii)%value
          text = word
       End If
    End Do
    !
    Return
    !
  End Subroutine pakoXMLcase
!!!
!!!
  Subroutine pakoXMLdictionaryInit(                               &
       &                                       error,             &
       &                                       errorC             &
       &                          )
    !
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLdictionaryInit">
    ! intitialize the "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    error = .False.
    If (Present(errorC)) errorC  = "OK"
    !
    nDict = 1
    !
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ANTENNA'    , 'antenna'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'BASIS'      , 'basis'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CALIBRATE'  , 'calibrate'   , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CIRCLE'     , 'circle'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'CONTINUUM'  , 'Continuum'   , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'DESCRIPTIVE', 'descriptive' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'DOPPLER'    , 'Doppler'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'EQUATORIAL' , 'equatorial'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'FIXED'      , 'fixed'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'FOCUS'      , 'focus'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HADEC'      , 'haDec'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HIGH'       , 'high'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HORIZON'    , 'horizontal'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'HORIZONTAL' , 'horizontal'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'LINEAR'     , 'linear'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'LOW'        , 'low'         , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NARROW'     , 'narrow'      , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NASMYTH'    , 'Nasmyth'     , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'NONE'       , 'none'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ONOFF'      , 'onOff'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'OTF'        , 'onTheFly'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'ONTHEFLY'   , 'onTheFly'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'OTFMAP'     , 'onTheFlyMap' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'POINTING'   , 'pointing'    , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'PROJECTION' , 'projection'  , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'RADIO'      , 'radio'       , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'TIP'        , 'tip'         , error)
!TBD: maybe should allow longer keywords, e.g., horizontalTrue
    If (.Not.error) Call pakoXMLdictionaryAdd( 'TRUEHORIZON', 'horizontalT' , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( 'WIDE'       , 'wide'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '1MHZ'       , '1MHz'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '4MHZ'       , '4MHz'        , error)
    If (.Not.error) Call pakoXMLdictionaryAdd( '100KHZ'     , '100kHz'      , error)
    !
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'MERCURY'    , 'Mercury'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'VENUS'      , 'Venus'       , error)
!!$    !
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'MARS'       , 'Mars'        , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'JUPITER'    , 'Jupiter'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'SATURN'     , 'Saturn'      , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'URANUS'     , 'Uranus'      , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'NEPTUNE'    , 'Neptune'     , error)
!!$    If (.Not.error) Call pakoXMLdictionaryAdd( 'PLUTO'      , 'Pluto'       , error)
    !
  End Subroutine pakoXMLdictionaryInit
!!!
!!!
  Subroutine pakoXMLdictionaryAdd(                                &
       &                                       key,               &
       &                                       value,             &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Character(len=*), Intent(IN)            :: key                ! key to add
    Character(len=*), Intent(IN)            :: value              ! value to add
    !                 
    Logical,          Intent(OUT)           :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLdictionaryAdd">
    ! add a key-value pair to "dictionary" pakoDict
    ! </DOCUMENTATION>
    !
    Integer lKey, lValue
    !
    error = .False.
    If (Present(errorC)) errorC  = "OK"
    !
    lKey   = Min(Len_trim(key),   lDict)
    lValue = Min(Len_trim(value), lDict)
    !
    If (nDict .Le. nDimDict) Then
       pakoDict(ndict) =                                          &
            &    pakoXMLdictionaryT(key(1:lKey),value(1:lValue))
       If (nDict .Lt. nDimDict) Then
          nDict = nDict+1
       End If
    Else
       error  = .True.
       If (Present(errorC)) errorC = "dictionary full"
    End If
    !
  End Subroutine pakoXMLdictionaryAdd
!!!
!!!
  Subroutine pakoXMLpush(                                         &
       &                                             element,     &
       &                                             pushError,   &
       &                                             pushErrorC   &
       &                )
    !
    Type (pakoXMLelementT), Intent(IN)            :: element      ! element to push on stack
    Logical,                Intent(OUT), Optional :: pushError    ! errorFlag
    Character(len=*),       Intent(OUT), Optional :: pushErrorC   ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLpush">
    ! push information about an element on the "stack" 
    ! </DOCUMENTATION>
    !
    pushError = .False.
    If (Present(pushErrorC)) pushErrorC  = "OK"
    !
    If (nStack.Lt.nDimStack) Then
       !
       nStack = nStack+1
       stack(nStack) = elementNone
       stack(nStack) = element
       !
    Else
       !
       pushError = .True.
       If (Present(pushErrorC)) pushErrorC  = "stack full"
       !
    End If
    !
    Return 
    !
  End Subroutine pakoXMLpush
!!!
!!!
  Subroutine pakoXMLpop(                                          &
       &                                             element,     &
       &                                             popError,    &
       &                                             popErrorC    &
       &               )
    !
    Type (pakoXMLelementT), Intent(OUT)           :: element      ! element to pop from stack
    Logical,                Intent(OUT)           :: popError     ! errorFlag
    Character(len=*),       Intent(OUT), Optional :: popErrorC    ! errorCode
    !
    ! <DOCUMENTATION name="pakoXMLpop">
    ! pop information about an element from the "stack"
    ! </DOCUMENTATION>
    !
    popError = .False.
    If (Present(popErrorC)) popErrorC  = "OK"
    !
    element = elementNone
    !
    If (nStack.Ge.1) Then
       !
       element = stack(nStack)
       nStack = nStack -1
       !
    Else
       !
       popError = .True.
       If (Present(popErrorC)) popErrorC  = "stack empty"
       !
    End If
    !
    Return 
    !
  End Subroutine pakoXMLpop
!!!
!!!
  Subroutine pakoXMLwriteLine(                 line,              &
       &                                       error)
    !
    Character(len=*), Intent(INOUT)         :: line               ! XML line to write 
    Logical,          Intent(OUT)           :: error              ! errorFlag
    !
    ! <DOCUMENTATION name="pakoXMLwriteLine">
    ! write one line with theproper indent to the XML output 
    ! </DOCUMENTATION>
    !
    Integer :: ii
    !
    error = .False.
    !
    lineOut = 'x'
    Do ii = 1, (levelXMl-1)*indentXML, 1
       lineOut = lineOut(1:Len_trim(lineOut)-1)//' x'
    End Do
    lineOut = lineOut(1:Len_trim(lineOut)-1)//line(1:lLine)
    !
    Write (outputUnitXML,'(A)') lineOut(1:Len_trim(lineOut))       
    !
    Return
    !
  End Subroutine pakoXMLwriteLine
!!!
!!!
  Subroutine pakoXMLnoir (CIN,NP)
    !
    ! <DOCUMENTATION name="pakoXMLnoir">
    ! eliminate unnecessary spaces. derivative of sic_noir
    ! </DOCUMENTATION>
    !
    Character(len=*) CIN
    Integer NP
    !
    Integer N,NI,I
    Logical LO,LI
    !
    LO = .False.
    NI = Len_trim(CIN)
    N  = 0
    Do I=1,NI
       LI=.True.
       If (CIN(I:I).Ne.' ' .And. CIN(I:I).Ne.'	') Then
          N = N+1
          CIN(N:N) = CIN(I:I)
       Else
          LI=.False.
          If (LO) Then
             N = N+1
             CIN(N:N) = ' '
          Endif
       Endif
       LO = LI
    End Do
    CIN(N+1:)=' '
    NP = N
    !
  End Subroutine pakoXMLnoir
!!!
!!!
  Subroutine pakoXMLupper(C)
    !
    ! <DOCUMENTATION name="pakoXMLupper">
    ! convert to upper case. derivative of sic_upper
    ! </DOCUMENTATION>
    !
    Character(len=*) C
    Integer I,IC
    !
    Do I=1,Len(C)
       If (C(I:I).Ge.'a' .And. C(I:I).Le.'z') Then
          IC=Ichar(C(I:I))+Ichar('A')-Ichar('a')
          C(I:I)=Char(IC)
       Endif
    Enddo
    !
  End Subroutine pakoXMLupper
!!!
!!!
End Module modulePakoXML

program uv_plugc
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  UV_PLUGC
  !       Plug a continuum table into a line table, as the first channel
  !
  ! Input :
  !	TABLE$	The line UV table
  !	SELF$	  The continuum UV table to plug in
  !	DTIME$	The smoothing time constant
  !     WCOL$   The column(s) which define the continuum data
  !	SUBT$	Subtract point source model from data
  ! S.Guilloteau 19-Jun-1991
  !---------------------------------------------------------------------
  ! Local
  type (gildas) :: huvc
  type (gildas) :: huvl
  !
  real, allocatable :: uvl(:,:)
  real, allocatable :: uvc(:,:) 
  character(len=80) :: uv_table,self_name,name
  real(8) :: time,stime,dtime
  integer :: wcol(2)
  !
  real(kind=8), allocatable :: ttime(:)
  integer, allocatable :: order(:)
  integer :: nsv,nsc,nc,n,j,ier
  real :: resul(3),factor,rbase(2),reel,imag,uv(2)
  logical :: error
  !
  call gildas_open
  call gildas_char('UV_TABLE$',uv_table)
  call gildas_char('SELF$',self_name)
  call gildas_dble('DTIME$',dtime,1)
  call gildas_inte('WCOL$',wcol,2)
  call gildas_real('SUB$',factor,1)
  call gildas_close
  !
  !
  dtime = 0.5d0*dtime
  !
  ! Open continuum table 
  n = lenc(self_name)
  if (n.le.0) goto 999
  name = self_name(1:n)
  call gildas_null(huvc,'UVT')
  call sic_parsef(name,huvc%file,' ','.uvt')
  call gdf_read_header (huvc,error)
  if (error) then
     call gagout('F-UV_PLUGC,  Cannot read input UV table')
     goto 999
  endif
  if (huvc%char%type(1:9).ne.'GILDAS_UV') then
     call gagout ('F-UV_PLUGC,  Input data is not a UV table')
     goto 999
  endif
  !
  allocate (uvc(huvc%gil%dim(1),huvc%gil%dim(2)),stat=ier)
  call gdf_read_data(huvc,uvc,error)
  !
  nsc = huvc%gil%nchan
  wcol(1) = min(max(1,wcol(1)),nsc)
  if (wcol(2).eq.0) then
    wcol(2) = nsc
  else
    wcol(2) = max(1,min(wcol(2),nsc))
  endif
  !
  ! Open line table
  n = lenc(uv_table)
  if (n.le.0) goto 999
  name = uv_table(1:n)
  call gildas_null(huvl,'UVT')
  call sic_parsef(name,huvl%file,' ','.uvt')
  call gdf_read_header (huvl,error)
  if (error) then
     call gagout('F-UV_PLUGC,  Cannot read input UV table')
     goto 999
  endif
  if (huvl%char%type(1:9).ne.'GILDAS_UV') then
     call gagout ('F-UV_PLUGC,  Input data is not a UV table')
     goto 999
  endif
  !
  allocate (uvl(huvl%gil%dim(1),huvl%gil%dim(2)),stat=ier)
  call gdf_read_data(huvl,uvl,error)
  nc = (huvl%gil%dim(1)-7)/3
  !
  ! Sort self-cal table
  ! Load time variable and sort by time order
  nsv = huvc%gil%dim(2)
  allocate (ttime(nsv),order(nsv),stat=ier)
  call dotime (huvc%gil%dim(1),huvc%gil%dim(2),uvc, &
     &    ttime,order,stime)
  !
  ! Loop over line table
  do j=1,huvl%gil%dim(2) 
      !
      ! Get time and baseline
      call getiba (uvl(1,j),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (huvc%gil%dim(1),huvc%gil%dim(2),wcol,uvc,   &
     &        time,dtime,ttime,order, &
     &        rbase,resul,uv)
      !
      ! No data: flag
      if (resul(3).eq.0) then
        call doflag (nc,uvl(1,j))
      else
        ! Compute fraction of source to remove
        reel = factor*resul(1)
        imag = factor*resul(2)
        ! Remove source
        call doplugc (nc,uvl(1,j),reel,imag,resul(3))
      endif
  enddo
  !
  call gdf_write_image(huvl,uvl,error)
  call gagout('S-UV_PLUGC,  Successful completion')
  call sysexi(1)
  999   call sysexi(fatale)
end program uv_plugc
!<FF>
subroutine doplugc (nc,visi,sreel,simag,weigh)
  !---------------------------------------------------------------------
  ! TASK	Self-Calibration
  !	Apply the self-calibration factor to the current visibility
  !	Set weight to zero if no self-cal factor
  ! Argument
  !	VISI	R*(*)	Visibility
  !	SREEL	R	Real part of source to be subtracted
  !	SIMAG	R	Imaginary part of source to be subtracted
  !---------------------------------------------------------------------
  integer :: nc                     !
  real :: visi(*)                   !
  real :: sreel                     !
  real :: simag                     !
  real :: weigh                     !
  !
  visi(5+3*nc) = sreel
  visi(6+3*nc) = simag
  visi(7+3*nc) = weigh
end
!<FF>
subroutine doflag (nc,visi)
  !---------------------------------------------------------------------
  ! TASK	Self-Calibration
  !	Apply the self-calibration factor to the current visibility
  !	Set weight to zero if no self-cal factor
  ! Argument
  !	NC	I	Number of channels
  !	VISI	R*(*)	Visibility
  !---------------------------------------------------------------------
  integer :: nc                     !
  real :: visi(*)                   !
  ! Local
  integer :: i
  !
  ! Set weight to zero if no self-cal data
  do i=10,7+3*nc,3
    visi(i) = 0.0
  enddo
end
!<FF>
subroutine getiba (visi,stime,time,base,uv)
  !---------------------------------------------------------------------
  ! TASK	Self-Calibration
  !	Get time offset and baseline from visibility
  ! Arguments
  !	VISI	R(7)	Visibility
  !	STIME	R*8	Start time
  !	TIME	R*8	Time of the visibility			Output
  !	BASE	R(2)	Start and end antenna			Output
  !---------------------------------------------------------------------
  real :: visi(7)                   !
  real*8 :: stime                   !
  real*8 :: time                    !
  real :: base(2)                   !
  real :: uv(2)                     !
  !
  time = nint(dble(visi(4))-stime)
  time = 86400.d0*time+dble(visi(5))
  base(1) = visi(6)
  base(2) = visi(7)
  uv(1) = visi(1)
  uv(2) = visi(2)
end
!<FF>
subroutine dotime (mv,nv,visi,wtime,it,stime)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! TASK	Self-Calibration
  !	Compute the observing times of the self-cal data base
  !	sort it and return sorting index
  ! Arguments
  !	MV	I	Size of a visibility
  !	NV	I	Number of visibilities
  !	VISI	R*4(*)	Visibility array
  !	WTIME	R*8(*)	Sorted observing times
  !	IT	I(*)	Sorting indexes
  !	STIME	R*8	Zero time
  !---------------------------------------------------------------------
  integer :: mv                     !
  integer :: nv                     !
  real :: visi(mv,nv)               !
  real*8 :: wtime(nv)               !
  integer :: it(nv)                 !
  real*8 :: stime                   !
  ! Local
  logical :: error
  integer :: i
  real :: tmin,tmax
  !
  tmin = visi(4,1)
  tmax = visi(4,1)
  do i=2,nv
    if (visi(4,i).lt.tmin) then
      tmin = visi(4,i)
    elseif (visi(4,i).gt.tmax) then
      tmax = visi(4,i)
    endif
  enddo
  if (tmin.eq.tmax) then
    do i=1,nv
      wtime(i) = visi(5,i)
    enddo
  else
    do i=1,nv
      wtime(i) = 86400d0*nint(visi(4,i)-tmin)   &
     &        +dble(visi(5,i))
    enddo
  endif
  stime = tmin
  !
  ! Sort
  call gr8_trie(wtime,it,nv,error)
end
!<FF>
subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,   &
     &    rbase,cvisi,uv)
  !---------------------------------------------------------------------
  ! TASK	Self-Calibration
  !	Compute the Observed Visibility of the "model source"
  ! Arguments
  !	MV	I	Size of a visibility
  !	NV	I	Number of visibilities
  !	IW	I	Self-cal channel
  !	VISI	R*4(*)	Visibility array
  !	TIME	R*8	Time at which factor must be computed
  !	FTIME	R*8	Time interval
  !	WTIME	R*8(*)	Sorted observing times
  !	IT	I(*)	Sorting indexes
  !	RBASE	R*4(2)	Baseline
  !	CVISI	R*4(3)	Complex visibility
  !     UV      R*4(2)  U and V
  !---------------------------------------------------------------------
  integer :: mv                     !
  integer :: nv                     !
  integer :: iw(2)                  !
  real :: visi(mv,nv)               !
  real*8 :: time                    !
  real*8 :: ftime                   !
  real*8 :: wtime(nv)               !
  integer :: it(nv)                 !
  real :: rbase(2)                  !
  real :: cvisi(3)                  !
  real :: uv(2)                     !
  ! Local
  integer :: i,k,l,iv,jv,kv,jr,ji,jw
  real :: reel,imag,weig
  !
  ! Locate the nearest time range by dichotomic search
  call findr (nv,wtime,time,iv)
  reel = 0.0
  imag = 0.0
  weig = 0.0
  !
  ! Now find JV and KV corresponding to +/- FTIME
  i = iv
  10    i = i-1
  if (i.gt.0 .and. (wtime(i).ge.(time-ftime)) ) goto 10
  jv = i
  i = iv
  20    i = i+1
  if (i.le.nv .and. (wtime(i).lt.(time+ftime)) ) goto 20
  kv = i
  !
  ! Everything happens between JV and KV. Load the corresponding
  ! baseline data
  do i=jv,kv
    k = it(i)
    if (abs(wtime(i)-time).le.ftime) then
      if ( (visi(6,k).eq.rbase(1) .and.   &
     &        visi(7,k).eq.rbase(2)) .or. (visi(6,k).eq.rbase(2) .and.   &
     &        visi(7,k).eq.rbase(1)) ) then
        if ( (uv(2).gt.0 .and. visi(2,k).gt.0) .or.   &
     &          (uv(2).le.0 .and. visi(2,k).le.0) ) then
          do l = iw(1),iw(2)
            jr = 5+3*l
            ji = jr+1
            jw = ji+1
            reel = reel+visi(jr,k)*visi(jw,k)
            imag = imag+visi(ji,k)*visi(jw,k)
            weig = weig + visi(jw,k)
          enddo
        else
          !
          ! Change phase by 180 degree if baseline order is reversed
          do l = iw(1),iw(2)
            jr = 5+3*l
            ji = jr+1
            jw = ji+1
            reel = reel+visi(jr,k)*visi(jw,k)
            imag = imag-visi(ji,k)*visi(jw,k)
            weig = weig + visi(jw,k)
          enddo
        endif
      endif
    endif
  enddo
  if (weig.ne.0) then
    reel = reel/weig
    imag = imag/weig
  endif
  cvisi(1) = reel
  cvisi(2) = imag
  cvisi(3) = weig
end
!<FF>
subroutine findr (np,x,xlim,nlim)
  !---------------------------------------------------------------------
  ! GILDAS	Internal routine
  !	Find NLIM such as
  !	 	X(NLIM-1) < XLIM <= X(NLIM)
  !	for input data ordered.
  !	Use a dichotomic search for that
  ! Arguments
  !	NP	I	Number of input points
  !	X	R*8(*)	Input ordered Values
  !	XLIM	R*8	Threshold
  !	NLIM	I	Position of the threshold
  !---------------------------------------------------------------------
  integer :: np                     !
  real*8 :: x(np)                   !
  real*8 :: xlim                    !
  integer :: nlim                   !
  ! Local
  integer :: ninf, nsup, nmid
  !
  ! Check that XLIM is within the range of X
  if (x(1).gt.xlim) then
    nlim = 1
    return
  endif
  ninf = 1
  nsup = np
  !
  do while(nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (x(nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE TUPLE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetuple_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: tupleseve
  public :: cubetuple_message_set_id,cubetuple_message
  public :: cubetuple_message_set_trans
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubetuple_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubetuple_messaging_debug_t
    integer(kind=code_k) :: trans = seve%d
  end type cubetuple_messaging_debug_t
  type(cubetuple_messaging_debug_t) :: tupleseve
  !
contains
  !
  subroutine cubetuple_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubetuple_message_id = id
    write (mess,'(A,I3)') 'Now use id #',cubetuple_message_id
    call cubetuple_message(seve%d,rname,mess)
  end subroutine cubetuple_message_set_id
  !
  subroutine cubetuple_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubetuple_message_id,mkind,'TUPLE>'//procname,message)
  end subroutine cubetuple_message
  !
  subroutine cubetuple_message_set_trans(on)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    logical, intent(in) :: on
    if (on) then
       tupleseve%trans = seve%i
    else
       tupleseve%trans = seve%d
    endif
  end subroutine cubetuple_message_set_trans
  !
end module cubetuple_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeformats_engine_types
  use cube_types
  use cubeformats_uv
  !---------------------------------------------------------------------
  ! Support module for registering the supported node types, and
  ! provide their identifying codes
  !---------------------------------------------------------------------
  !
  integer(kind=4), protected :: code_ftype_cube=0  ! cube_t identifier in the DAG (initialized at init)
  integer(kind=4), protected :: code_ftype_uv=0    ! uv_t identifier in the DAG (initialized at init)
  !
  public :: code_ftype_cube
  public :: code_ftype_uv
  public :: cubeformats_types_register
  private
  !
contains
  !
  subroutine cubeformats_types_register(cubset,error)
    use cubetools_setup_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(cube_setup_t), intent(in)    :: cubset
    logical,            intent(inout) :: error
    !
    call cubeformats_cube_register(cubset,code_ftype_cube,error)
    if (error)  return
    call cubeformats_uv_register(cubset,code_ftype_uv,error)
    if (error)  return
  end subroutine cubeformats_types_register
  !
end module cubeformats_engine_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine solve_pass(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  !     +	' SOLVE',	'/PLOT',	'/WEIGHT',	'/OUTPUT',
  !     +	'/RESET',	'/OFFSET',	'/COMPRESS',	'/SEARCH',
  !     +	'/BREAK',	'/POLYNOMIAL',
  !	Computes a passband based on the passband calibrator
  !	assumed to be in the current index.
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: isb, iba, lb, kb, ib, i, nd, ndeg, ipol
  integer :: ic, i1,  ndeg1, ndeg2, iy, ix, inbc, ip
  logical :: plot, reset, ok, skip(mbox),spectrum
  character(len=132) :: chain
  integer :: m_pass, old_pen
  integer(kind=address_length) :: ipx,ipy,ipz,ipw,ipp,data_pass
  integer(kind=address_length) :: iwx,iwy,iww,iwi,iwk
  integer :: ir
  real*4 :: rms_err(mbox)
  !
  data m_pass /0/
  save m_pass, data_pass
  !------------------------------------------------------------------------
  spectrum = .false.
  nd = 0
  if (sic_present(14,0)) spectrum = .true.
  call check_index(error)
  if (error) return
  call sic_delvariable ('RMS_ERR',.false.,error)
  call sic_def_real ('RMS_ERR',rms_err,1,n_boxes,.false.,error)
  !
  ! Selecting correlator input
  !
  if (.not.new_receivers) then
    inbc = 1
  else
    if (.not.bb_select.or.n_baseband.ne.1.or.l_baseband(1).ne.1) then
      call show_display('BBAND',.false.,error)
      write(chain,'(A)')   &
        'Select a single baseband using SET BBAND command'
      call message(6,3,'SOLVE_RF',chain)
      error = .true.
      return
    else
      inbc = i_baseband(1,1)
       write(chain,'(A,I1)')   &
            'Calibrating baseband ',inbc
       call message(6,1,'SOLVE_RF',chain)
    endif
  endif
  ! Code:
  ir=r_nrec
  if (sic_present(2,0) .or. sic_present(3,0) .or.   &
    sic_present(5,0) .or. sic_present(6,0) .or. sic_present(7,0) .or.   &
    sic_present(8,0) .or. sic_present(9,0)) then
    call message(6,3,'SOLVE_RF','Option invalid in this context')
    error = .true.
  endif
  if (i_base(1).gt.mnbas) then
    call message(8,4,'SOLVE_RF','Triangle mode not supported')
    error = .true.
  endif
  ! Check plot mode: loop on boxes
  ok = .false.
  do ib = 1, n_boxes
    isb = i_band(k_band(ib))
    iba = i_base(k_base(ib))
    kb = k_subb(ib)
    iy = i_y(k_y(ib))
    ix = i_x(k_x(ib))
    lb = l_subb(kb)
    if (isb.gt.2) then
      call message(4,2,'SOLVE_PASS','Band should be USB or LSB')
      skip(ib) = .true.
    elseif (iy.gt.xy_phase) then
      call message(4,2,'SOLVE_PASS',   &
        'Y axis should be Amplitude or Phase')
      skip(ib) = .true.
    elseif (ix.ne.xy_i_fre .and. do_pass_freq) then
      call message(4,2,'SOLVE_PASS',   &
        'X axis should be I_Freq. for frequency-based mode')
      skip(ib) = .true.
    elseif (ix.lt.xy_chann .or. ix.gt.xy_sky_f) then
      call message(4,2,'SOLVE_PASS',   &
        'X axis should be frequency-like for channel-based mode')
      skip(ib) = .true.
    elseif ((lb.ne.1) .and. (i_subb(1,kb).gt.mbands)   &
      .and. (.not. do_pass_freq)) then
      call message(8,4,'SOLVE_PASS',   &
        'Process line subbands separately in channel mode')
      skip(ib) = .true.
    else
      ok = .true.
      skip(ib)=.false.
    endif
    if (n_data(ib).gt.nd) nd = n_data(ib)
  enddo
if (.not.ok) then
    error = .true.
    return
  endif
  ! Reset option
  reset = sic_present(4,0)
  if (reset) then
    do ir=1, mnrec
      do iba = -mnant, mnbas
        do ip = 1,mnbb            ! Basebands 
          do isb = 1,2
            if (do_pass_freq) then
              bpf_deg(isb,ip,iba,ir) = 10
              fbp_famp(isb,ip,iba,ir) = .false.
              fbp_fpha(isb,ip,iba,ir) = .false.
              do i=1, bpf_deg(isb,ip,iba,ir)
                bp_famp(isb,ip,iba,i,ir)=0
                bp_fpha(isb,ip,iba,i,ir)=0
              enddo
            else
              bpc_band = 0
              do ic=1, mrlband
                bpc_deg(isb,ip,iba,ic,ir) = 4
                fbp_camp(isb,ip,iba,ir) = .false.
                fbp_cpha(isb,ip,iba,ir) = .false.
                fbp_lamp(isb,ip,iba,ic,ir) = .false.
                fbp_lpha(isb,ip,iba,ic,ir) = .false.
                do i=1, bpc_deg(isb,ip,iba,ic,ir)
                  bp_lamp(isb,ip,iba,ic,i,ir)=0
                  bp_lpha(isb,ip,iba,ic,i,ir)=0
                enddo
              enddo
            endif
            do ipol=1,3
              ph_fac(isb,ipol,iba,ir) = 0
            enddo
          enddo
        enddo
      enddo
    enddo
    bp_nant(:) = 0
    bp_ant(:,:) = 0
    bp_phys(:,:) = 0
    change_display = .true.
  endif
  if (do_pass) then
    call message(8,2,'SOLVE_RF','SET RF_PASSBAND reset to OFF')
    do_pass = .false.
    change_display = .true.
  endif
  !
  ! Remember antennas 
  bp_nant(inbc) = r_nant
  do i=1, r_nant
    bp_ant(i,inbc) = i
    bp_phys(i,inbc) = r_kant(i)
  enddo
  !
  ndeg1 = -1
  call sic_i4(line,0,2,ndeg1,.false.,error)
  if (error) goto 999
  if (ndeg1.gt.mbpcdeg) then
    write(chain,'(i3)') mbpcdeg
    call message(6,2,'SOLVE_RF','Degree reset to '//chain(1:3))
  endif
  ndeg1 = min(ndeg1,mbpcdeg)
  ndeg2 = ndeg1
  call sic_i4(line,0,3,ndeg2,.false.,error)
  if (error) goto 999
  if (ndeg2.gt.mbpcdeg) then
    write(chain,'(i3)') mbpcdeg
    call message(6,2,'SOLVE_RF','Degree reset to '//chain(1:3))
  endif
  ndeg2 = min(ndeg2,mbpcdeg)
  if (ndeg1.lt.0) ndeg1 = 0
  if (ndeg2.lt.0) ndeg2 = 1
  ndeg = max(ndeg1,ndeg2)
  if (change_display) then
    call read_spec('ALL',.true.,error) ! all scans in index
    plotted = .false.
    if (error) return
    change_display = .false.
  else
    plotted = .true.
  endif
  plot = sic_present(1,0)
  old_pen = -1
  if (plot) then
    clear = .true.
    if (.not. plotted) call sub_plot('A',.false.,.false.,0,error)
    if (error) return
    plotted = .true.
    old_pen = gr_spen(1)
    call gr_segm('FIT',error)
  endif
  !
  ! save the side band averages in complex array sba
  call save_averages(sba,error)
  if (error) goto 999
  !
  ! Loop on boxes
  ipx = gag_pointer(data_x,memory)
  ipy = gag_pointer(data_y,memory)
  ipz = gag_pointer(data_z,memory)
  ipw = gag_pointer(data_w,memory)
  ir=r_nrec
  if (spectrum) then
    !
    ! Get auxiliary storage
    if (nd*(2*r_nbas+3)*2.gt.m_pass) then
      if (m_pass .gt.0) then
        call free_vm(m_pass,data_pass)
      endif
      m_pass = nd*(2*r_nbas+3)*2
      error = sic_getvm(m_pass,data_pass).ne.1
      if (error) goto 999
    endif
    iwx = gag_pointer(data_pass,memory)
    iww = iwx + 2*nd
    iwy = iww + 2*nd*r_nbas
    iwk = iwy + 2*nd*r_nbas
    iwi = iwk + 2*nd           ! This one is INTEGER only ..
    !
    call solve_pass_spectrum(xy_ampli, m_data, m_boxes, &
      memory(ipx), memory(ipy), memory(ipw), &
      nd, r_nbas, r_nant, memory(iwx), memory(iwy),memory(iww), &
      memory(iwi),memory(iwk),plot,skip,error)

    if (error) goto 999
    call solve_pass_spectrum(xy_phase, m_data, m_boxes, &
      memory(ipx), memory(ipy), memory(ipw), &
      nd, r_nbas, r_nant, memory(iwx), memory(iwy),memory(iww), &
      memory(iwi),memory(iwk),plot,skip,error)
    if (error) goto 999
    isb = r_sb(inbc)
    if (isb.eq.-1) isb = 2
    call set_pass_spectrum(isb,inbc,r_nband,r_nsb,r_nbas+r_ntri,r_lntch,&
                           specc,specl,error)
  else
    do ib = 1, n_boxes
      isb = i_band(k_band(ib))
      iba = i_base(k_base(ib))
      kb = k_subb(ib)
      iy = i_y(k_y(ib))
      ix = i_x(k_x(ib))
      if (skip(ib)) goto 100
      if (sba(isb,iba,ir).eq.0 .and. iba.gt.0) then
        call message(4,2,'SOLVE_PASS',   &
          'No continuum reference for Bas '//cbas(iba)   &
          //' '//cband(isb))
        goto 100
      endif
      nd = n_data(ib)
      if (nd.eq.0) then
        call message(6,3,'SOLVE_PASS','No valid data point in reference box')
        error = .true.
        return
      endif
      i1 = i_subb(1,kb)
      lb = l_subb(kb)
      !
      ! Frequency-dependent passband:
      ! do a polynomial fit, as a function of IF frequency ...
      if (do_pass_freq) then
        if (iy.eq.xy_ampli) then
          ndeg = ndeg1
        elseif (iy.eq.xy_phase) then
          ndeg = ndeg2
        endif
        !
        ! Get auxiliary storage
        if (nd*12.gt.m_pass) then
          if (m_pass .gt.0) then
            call free_vm(m_pass,data_pass)
          endif
          m_pass = nd*12
          error = sic_getvm(m_pass,data_pass).ne.1
          if (error) goto 999
        endif
        ipp = gag_pointer(data_pass,memory)
        ! Do fit and plot
        call fit_polyc(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz),   &
          memory(ipp), memory(ipp+6*nd),   &
          memory(ipp+8*nd), memory(ipp+10*nd),   &
          memory(ipp+2*nd), plot, ndeg, rms_err(ib), error)
        if (error) goto 999
      !
      ! Channel-based Continuum :
      elseif (i1.le.mbands) then
        if (ix.ne.xy_chann) then
          call message(4,2,'SOLVE_PASS',   &
            'X axis should Channel number, for continuum subbands')
          goto 100
        endif
        call channel_cont(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz))
        rms_err(ib) = 0
      !
      ! Channel-based line : do polynomial fit
      else
        bpc_band = r_lband
        if (iy.eq.xy_ampli) then
          ndeg = ndeg1
        elseif (iy.eq.xy_phase) then
          ndeg = ndeg2
        endif
        !
        ! Get auxiliary storage
        if (nd*12.gt.m_pass) then
          if (m_pass .gt.0) then
            call free_vm(m_pass,data_pass)
          endif
          m_pass = nd*12
          error = sic_getvm(m_pass,data_pass).ne.1
          if (error) goto 999
        endif
        ipp = gag_pointer(data_pass,memory)
        ! Do fit and plot
        call fit_poly(m_data, m_boxes, ib, inbc, nd,   &
          memory(ipx), memory(ipy), memory(ipw), memory(ipz),   &
          memory(ipp), memory(ipp+6*nd),   &
          memory(ipp+8*nd),   &
          memory(ipp+10*nd), plot, ndeg, rms_err(ib), error)
        if (error) goto 999
      endif
100   continue
    enddo
  endif
998 continue
  if (old_pen.ge.0) then
    call gr_segm_close(error)
    i = gr_spen(old_pen)
  endif
  bp_source = r_sourc
  return
999 error = .true.
  goto 998
end subroutine solve_pass
!
subroutine channel_cont(md, mb, ib, inbc, nd,   &
    x_data, y_data, w_data, z_data)
  use gildas_def
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC: passband calibration.
  ! store values as channel-by channel for continuum
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md, mb)            !
  real :: y_data(md, mb)            !
  real :: w_data(md, mb)            !
  complex :: z_data(md, mb)         !
  ! Global
  real :: fillin
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, ic, iy, ix, ir
  real :: ynorm, data(mcch), faz, pha
  !------------------------------------------------------------------------
  ! Code:
  ! Just store data, normalize amplitudes and phases
  ir = r_nrec
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  !      CALL GETXVALC(IX,ISB,XR,XV,XD)
  if (iy.le.xy_phase) then
    do i=1, r_nband
      data(i) = blank4
    enddo
    do i=1, n_data(ib)
      if (y_data(i,ib).ne.blank4) then
        ic = nint(x_data(i,ib))    ! channel number
        data(ic) = y_data(i,ib)
      endif
    enddo
  endif
  if (iy.eq.xy_ampli) then
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
    do i=1, r_nband
      if (data(i).ne.blank4) then
        bp_camp(isb,inbc,iba,i,ir) = data(i)/ynorm
      else
        data(i) = fillin(data,i,1,r_nband,blank4)
        bp_camp(isb,inbc,iba,i,ir) = data(i)/ynorm
      endif
      !
      if (iba.lt.0) then
        bp_camp(isb,inbc,iba,i,ir) =   &
          sqrt(bp_camp(isb,inbc,iba,i,ir))
      endif
    !
    enddo
    do i=1, n_data(ib)
      ic = nint(x_data(i,ib))  ! channel number
      y_data(i,ib) = data(ic)
    enddo
    fbp_camp(isb,inbc,iba,ir) = sba(isb,iba,ir).ne.0
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
    do i=1, r_nband
      if (data(i).ne.blank4) then
        bp_cpha(isb,inbc,iba,i,ir) = data(i)
      else
        data(i) = fillin(data,i,1,r_nband,blank4)
        bp_cpha(isb,inbc,iba,i,ir) = data(i)
      endif
    enddo
    do i=1, n_data(ib)
      ic = nint(x_data(i,ib))  ! channel number
      y_data(i,ib) = data(ic)
    enddo
    do ic = 1, r_nband
      pha = bp_cpha(isb,inbc,iba,ic,ir)
      if (degrees) then
        pha = pha*pi/180.
      endif
      bp_cpha(isb,inbc,iba,ic,ir) = pha - ynorm
    enddo
    fbp_cpha(isb,inbc,iba,ir) = sba(isb,iba,ir).ne.0
  endif
  return
end subroutine channel_cont
!
subroutine fit_polyc (md,mb,ib,inbc,nd,x_data,y_data,w_data,   &
    z_data,work1,xx,yy,ww,ind,plot,ndeg,rss,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Fit polynomial as a function of I_F frequency
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  complex :: z_data(md,mb)          !
  real*8 :: work1(3*nd)             !
  real*8 :: xx(nd)                  !
  real*8 :: yy(nd)                  !
  real*8 :: ww(nd)                  !
  integer :: ind(nd)                !
  logical :: plot                   !
  integer :: ndeg                   !
  real :: rss                       !
  logical :: error                  !
  ! Global
  logical :: gr8_random
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, l, l1, l2, l3, iy, ix, ir
  real*8 :: a(0:mbpcdeg,0:mbpcdeg), s(0:mbpcdeg)
  real*8 :: work2(2*(mbpcdeg+1)), aa(0:mbpcdeg), x0, x1, x2
  real :: wnorm, faz, pha, ynorm
  character(len=132) :: chain
  !------------------------------------------------------------------------
  ! Code:
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  ir = r_nrec
  !
  wnorm = 0.0                  ! SG was missing...
  if (iy.eq.xy_ampli) then
    !
    ! zrsba contains the associated weights
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
  endif
  do i=1, nd
    xx(i) = x_data(i,ib)       ! Inter. freq.
    yy(i) = y_data(i,ib)
    ww(i) = w_data(i,ib)
    if (ww(i).le.0 .or. (abs(yy(i)-blank4).le.d_blank4) ) then
      ww(i) = 1d-10
      yy(i) = 0
    endif
    if (iy.eq.xy_ampli) then
      yy(i) = yy(i)/ynorm
      if (iba.lt.0) then
        yy(i) = sqrt(yy(i))
      endif
    elseif (iy.eq.xy_phase) then
      if (degrees) then
        yy(i) = pi/180.*yy(i)-ynorm
      else
        yy(i) = yy(i)-ynorm
      endif
    endif
    wnorm = wnorm + ww(i)**2
  enddo
  ! Sort if required
  if (gr8_random(xx,nd)) then
    call gr8_trie(xx,ind,nd,error)
    if (error) goto 999
    call gr8_sort(yy,work1,ind,nd)
    call gr8_sort(ww,work1,ind,nd)
  endif
  wnorm = sqrt(wnorm/nd)
  do i=1, nd
    ww(i) = ww(i)/wnorm
  enddo
  call mth_fitpol ('FIT_POLYC',nd,ndeg+1,mbpcdeg+1,xx,yy,ww,   &
    work1,work2,a,s,error)
  if (error) goto 999
  bp_flim(isb,inbc,iba,1,ir) = xx(1)
  bp_flim(isb,inbc,iba,2,ir) = xx(nd)
  if (iy.eq.xy_ampli) then
    do i = 0, ndeg
      bp_famp(isb,inbc,iba,i,ir)=a(ndeg,i)
    enddo
    if (ndeg.lt.bpf_deg(isb,inbc,iba,ir)) then
      do i=ndeg+1, bpf_deg(isb,inbc,iba,ir)
        bp_famp(isb,inbc,iba,i,ir) = 0
      enddo
    endif
    fbp_famp(isb,inbc,iba,ir) = .true.
  elseif (iy.eq.xy_phase) then
    do i=0, ndeg
      pha = a(ndeg,i)
      bp_fpha(isb,inbc,iba,i,ir) = pha
    enddo
    if (ndeg.lt.bpf_deg(isb,inbc,iba,ir)) then
      do i=ndeg+1, bpf_deg(isb,inbc,iba,ir)
        bp_fpha(isb,inbc,iba,i,ir) = 0
      enddo
    endif
    bpf_deg(isb,inbc,iba,ir) = ndeg
    fbp_fpha(isb,inbc,iba,ir) = .true.
  endif
  rss = s(ndeg)
  if (iy.eq.xy_phase .and. degrees) rss = rss*180.0/pi
  ! display results
  l = lenc(y_label(ib))
  l1 = max(3,lenc(header_1(ib)))   ! saves space on listing
  l2 = lenc(header_2(ib))
  l3 = lenc(header_3(ib))
  !
  write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),   &
    header_2(ib)(1:l2), header_3(ib)(1:l3), rss
1000 format(a,'. ',a,1x,' ',a,' ',a,' rms: ',1pg11.4)
  call message(6,1,'SOLVE_RF',chain(1:lenc(chain)))
  !
  if (plot) then
    do i=0, ndeg
      aa(i) = a(ndeg,i)
    enddo
    x0 = xx(1)
    x1 = xx(nd)
    do i=1, nd
      x2 = min(1d0,max(-1d0,(2d0*i-1d0-nd)/(nd-1d0)))
      call mth_getpol('FIT_POLYC',   &
        ndeg+1, aa, x2, yy(i), error)
      if (error) goto 999
      xx(i) = (x0*(1-x2)+x1*(1+x2))/2
      if (iy.eq.xy_ampli) then
        if (iba.lt.0) then
          yy(i) = yy(i)**2
        endif
        yy(i) = yy(i)*ynorm
      elseif (iy.eq.xy_phase) then
        yy(i) = yy(i) + ynorm
        if (degrees) then
          yy(i) = yy(i)*180./pi
        endif
      endif
    enddo
    write(chain,'(I4.4)') ib
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    call gr8_connect (nd,xx,yy,0.0d0,-1.0d0)
    call gr_execl('CHANGE DIRECTORY')
  endif
  return
999 error = .true.
  return
end subroutine fit_polyc
!
subroutine fit_poly (md,mb,ib,inbc,nd,x_data,y_data,w_data,z_data,   &
    work1,xx,yy,ww,plot,ndeg,rss,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api  
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Fit polynomial as a function frequency-like variable in an individual
  !     line subband.
  !---------------------------------------------------------------------
  integer :: md                     !
  integer :: mb                     !
  integer :: ib                     !
  integer :: inbc                   !
  integer :: nd                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  complex :: z_data(md,mb)          !
  real*8 :: work1(3*nd)             !
  real*8 :: xx(nd)                  !
  real*8 :: yy(nd)                  !
  real*8 :: ww(nd)                  !
  logical :: plot                   !
  integer :: ndeg                   !
  real :: rss                       !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_display.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  integer :: isb, iba, i, l, l1, l2, l3, ic, iy, ix, ir
  real*8 :: a(0:mbpcdeg,0:mbpcdeg), s(0:mbpcdeg)
  real*8 :: work2(2*(mbpcdeg+1)), aa(0:mbpcdeg), x0, x1, x2
  real :: wnorm, faz, pha, xr, xv, xd, ynorm
  character(len=132) :: chain
  !------------------------------------------------------------------------
  ! Code:
  isb = i_band(k_band(ib))
  iba = i_base(k_base(ib))
  ic = i_subb(1,k_subb(ib))-mbands
  iy = i_y(k_y(ib))
  ix = i_x(k_x(ib))
  ir = r_nrec
  !
  wnorm = 0.0                  ! SG was missing...
  if (iy.eq.xy_ampli) then
    !*!         YNORM = ABS(ZRSBA(ISB,IBA))
    ynorm = abs(zrsba(inbc,isb,iba)/wrsba(inbc,isb,iba))
  elseif (iy.eq.xy_phase) then
    ynorm = faz(zrsba(inbc,isb,iba))
  endif
  call getxvall(ix,isb,ic,xr,xv,xd)
  do i=1, nd
    xx(i) = nint((x_data(i,ib)-xv)/xd+xr)+r_lich(ic)   ! channel number
    yy(i) = y_data(i,ib)
    ww(i) = w_data(i,ib)
    if (i.eq.1 .or. i.gt.nd-2 .or. ww(i).le.0   &
      .or. (abs(yy(i)-blank4).le.d_blank4) ) then
      ww(i) = 1d-10
      yy(i) = 0
    endif
    wnorm = wnorm + ww(i)      !**2   (?)
    if (iy.eq.xy_ampli) then
      yy(i) = yy(i)/ynorm
      if (iba.lt.0) then
        yy(i) = sqrt(yy(i))
      endif
    elseif (iy.eq.xy_phase) then
      if (degrees) then
        yy(i) = pi/180.*yy(i)-ynorm
      else
        yy(i) = yy(i)-ynorm
      endif
    endif
  enddo
  wnorm = wnorm/nd             ! SG itou
  do i=1, nd
    ww(i) = ww(i)/wnorm        !	/sqrt(wnorm)
  enddo
  call mth_fitpol('FIT_POLY',nd,ndeg+1,mbpcdeg+1,xx,yy,ww,   &
    work1,work2,a,s,error)
  if (error) goto 999
  if (iy.eq.xy_ampli) then
    do i = 0, ndeg
      bp_lamp(isb,inbc,iba,ic,i,ir)=a(ndeg,i)
    enddo
    if (ndeg.lt.bpc_deg(isb,inbc,iba,ic,ir)) then
      do i=ndeg+1, bpc_deg(isb,inbc,iba,ic,ir)
        bp_lamp(isb,inbc,iba,ic,i,ir) = 0
      enddo
    endif
    fbp_lamp(isb,inbc,iba,ic,ir) = .true.
  elseif (iy.eq.xy_phase) then
    do i=0, ndeg
      pha = a(ndeg,i)
      bp_lpha(isb,inbc,iba,ic,i,ir) = pha
    enddo
    if (ndeg.lt.bpc_deg(isb,inbc,iba,ic,ir)) then
      do i=ndeg+1, bpc_deg(isb,inbc,iba,ic,ir)
        bp_lpha(isb,inbc,iba,ic,i,ir) = 0
      enddo
    endif
    bpc_deg(isb,inbc,iba,ic,ir) = ndeg
    fbp_lpha(isb,inbc,iba,ic,ir) = .true.
  endif
  rss = s(ndeg)
  ! display results
  l = lenc(y_label(ib))
  l1 = lenc(header_1(ib))
  l2 = lenc(header_2(ib))
  l3 = lenc(header_3(ib))
  !
  write(chain,1000) y_label(ib)(1:3), header_1(ib)(1:l1),   &
    header_2(ib)(1:l2), header_3(ib)(1:l3), rss
1000 format(a,'. ',a,1x,' ',a,' ',a,' rms: ',1pg11.4)
  call message(6,1,'SOLVE_RF',chain(1:lenc(chain)))
  !
  if (plot) then
    do i=0, ndeg
      aa(i) = a(ndeg,i)
    enddo
    x0 = xx(1)
    x1 = xx(nd)
    do i=1, nd
      x2 = ((xx(i)-x0)-(x1-xx(i)))/(x1-x0)
      call mth_getpol('FIT_POLY',   &
        ndeg+1, aa, x2, yy(i), error)
      if (error) goto 999
      xx(i) = x_data(i,ib)
      if (iy.eq.xy_ampli) then
        if (iba.lt.0) then
          yy(i) = yy(i)**2
        endif
        yy(i) = yy(i)*ynorm
      elseif (iy.eq.xy_phase) then
        yy(i) = yy(i) + ynorm
        if (degrees) then
          yy(i) = yy(i)*180./pi
        endif
      endif
    enddo
    write(chain,'(I4.4)') ib
    call gr_execl('CHANGE DIRECTORY BOX'//chain)
    error = gr_error()
    if (error) goto 999
    call gr8_connect (nd,xx,yy,0.0d0,-1.0d0)
    call gr_execl('CHANGE DIRECTORY')
  endif
  return
999 error = .true.
  return
end subroutine fit_poly
!
subroutine getxvall(ix,isb,ic,xr,xv,xd)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Return conversion formula for the X axis of type IX
  !	Valid for spectral correlator
  ! Input:
  !	IX	Integer	Type of data (Chann, Veloc, I_fre, Sky_f)
  !	ISB	Integer	Sideband
  !	IC	Integer SubBand
  ! Output:
  !	XR	Real	Reference point
  !	XV	Real	Value at reference point
  !	XD	Real	Increment per point
  !---------------------------------------------------------------------
  integer :: ix                     !
  integer :: isb                    !
  integer :: ic                     !
  real :: xr                        !
  real :: xv                        !
  real :: xd                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  !------------------------------------------------------------------------
  ! Code:
  if (ix.eq.xy_chann) then
    xr = 0
    xv = 0
    xd = 1
  elseif (ix.eq.xy_veloc) then
    xr = r_lrch(isb,ic)
    xv = r_lvoff(isb,ic)
    xd = r_lvres(isb,ic)
  elseif (ix.eq.xy_i_fre) then
    xr = r_lcench(ic)
    xv = r_lfcen(ic)
    xd = r_lfres(ic)
  elseif (ix.eq.xy_sky_f) then
    xr = r_lrch(isb,ic)
    xv = r_lrfoff(isb,ic)
    xd = r_lrfres(isb,ic)
  endif
end subroutine getxvall
!
subroutine getxvalc(ix,isb,xr,xv,xd)
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC
  !	Return conversion formula for the X axis of type IX
  !	Valid for continuum correlator (old model)
  ! Input:
  !	IX	Integer	Type of data (Chann, Veloc, I_fre, Sky_f)
  !	ISB	Integer	Sideband
  ! Output:
  !	XR	Real	Reference point
  !	XV	Real	Value at reference point
  !	XD	Real	Increment per point
  !---------------------------------------------------------------------
  integer :: ix                     !
  integer :: isb                    !
  real :: xr                        !
  real :: xv                        !
  real :: xd                        !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  !------------------------------------------------------------------------
  !
  ! Channel number
  if (ix.eq.xy_chann) then
    xr = 0
    xv = 0
    xd = 1
  ! Velocity
  elseif (ix.eq.xy_veloc) then
    xr = r_crch(isb)
    xv = r_cvoff(isb)
    xd = r_cvres(isb)
  ! IF frequency
  elseif (ix.eq.xy_i_fre) then
    xr = 0.
    xv = 75.
    xd = 50.
  ! Sky Frequency
  elseif (ix.eq.xy_sky_f) then
    xr = r_crch(isb)
    xv = r_crfoff(isb)
    xd = r_crfres(isb)
  endif
end subroutine getxvalc
!
!
function fillin(r,ival,imin,imax,bad)
  !---------------------------------------------------------------------
  ! SAS	Internal routine
  !	Interpolate bad channel (if possible)
  ! Arguments
  !	R	R*4(*)	Array to be interpolated
  !	IVAL	I	Pixel to be interpolated
  !	IMIN	I	First pixel in array
  !	IMAX	I	Last pixel in array
  !	BAD	R*4	Blanking value
  ! Created	21-Mar-1986	S.Guilloteau
  !---------------------------------------------------------------------
  real :: fillin                    !
  integer :: imax                   !
  real :: r(imax)                   !
  integer :: ival                   !
  integer :: imin                   !
  real :: bad                       !
  ! Local
  integer :: i,if,il
  !
  do i=ival-1,imin,-1
    if (r(i).ne.bad) goto 10
  enddo
  !
  ! Rien en dessous, tout au dessus
  do i=ival+1,imax-1
    if (r(i).ne.bad) goto 10
  enddo
  !
  ! Tout mauvais, sauf peut-etre
  fillin = r(imax)
  return
  !
  ! Un bon au dessus ou au dessous
10 if = i
  do i=max(if+1,ival+1),imax
    if (r(i).ne.bad) goto 20
  enddo
  ! Un seul bon
  if (if.gt.ival .or. if.eq.imin) then
    fillin = r(if)
    return
  endif
  do i=if-1,imin,-1
    if (r(i).ne.bad) goto 20
  enddo
  fillin = r(if)
  return
  !
  ! Deux bons
20 il = i
  fillin = ( (ival-if)*r(il) + (il-ival)*r(if) ) / float(il-if)
end function fillin
!
subroutine solve_pass_spectrum(ly,md,mb,x_data,y_data,w_data,   &
    nd, dbas,nant,xx,yy,ww,ind,wk,plot,skip,error)
  use gildas_def
  use gkernel_interfaces
  use clic_bpc
  !---------------------------------------------------------------------
  ! CLIC routine: Passband calibration
  !     Derive antenna gain, that will be interpolated later
  !---------------------------------------------------------------------
  integer :: ly                     !
  integer :: md                     !
  integer :: mb                     !
  real :: x_data(md,mb)             !
  real :: y_data(md,mb)             !
  real :: w_data(md,mb)             !
  integer :: nd                     !
  integer :: dbas                   !
  integer :: nant                   !
  real*8 :: xx(nd)                  !
  real*8 :: yy(dbas,nd)             !
  real*8 :: ww(dbas,nd)             !
  integer :: ind(nd)                !
  real*8 :: wk(nd)                  !
  logical :: plot
  logical :: skip(mb)
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_sba.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: my_do_rf, counting
  integer :: ib
  integer :: isb, iba, i, iy, ix, ia, ja
  integer :: j, mad, mad2, ibb, ibas, nbas, mynd
  parameter (mad=mnant*(mbpcdeg+1),mad2=mad**2)
  real*8 ::  yy1,yyy(m_data),xxx(m_data)
  integer :: iant(mnbas),jant(mnbas), ibsl(mnbas)
  !
  integer :: subtract, nhole, ifirst(mmask), ilast(mmask)
  real :: wnorm, faz, ynorm(mbox), turn
  real :: yp,ym, delta
  real*8 :: xcurs,ycurs
  character(len=132) :: chain
  !
  !------------------------------------------------------------------------
  !------------------------------------------------------------------------
  !
  ! Correlator input
  ! Selecting correlator input
  !
  if (.not.new_receivers) then
    ibb = 1
  else
    ibb = i_baseband(1,1)
  endif
  iba = 0
  !
  ! Loop on boxes to load data from plot buffers.
  wnorm = 0.0
  do ib = 1, n_boxes
    iy = i_y(k_y(ib))
    if (iy.eq.ly.and..not.skip(ib)) then
      ix = i_x(k_x(ib))
      isb = i_band(k_band(ib))
      ibas = i_base(k_base(ib))
      !
      ! Deal with ignored antennas
      ia = r_iant(ibas)
      ja = r_jant(ibas)
      if (my_do_rf(ia,ibb).and.my_do_rf(ja,ibb)) then
        iba = iba+1
        ibsl(ibas) = iba
        subtract = 0
        do i = 1, ia
          if (.not.my_do_rf(i,ibb)) subtract = subtract + 1
        enddo
        ia = ia-subtract
        subtract = 0
        do i = 1, ja
          if (.not.my_do_rf(i,ibb)) subtract = subtract + 1
        enddo
        ja = ja-subtract
        iant(iba) = ia
        jant(iba) = ja
      else
        cycle
      endif
      !
!      nd = n_data(ib)
      wnorm = 0.0
      if (zrsba(ibb,isb,ibas).ne.0) then
        if (iy.eq.xy_ampli) then
          ynorm(ib) =   &
            log(abs(zrsba(ibb,isb,ibas))/wrsba(ibb,isb,ibas))
        elseif (iy.eq.xy_phase) then
          ynorm(ib) = faz(zrsba(ibb,isb,ibas))
        endif
      else
        ynorm(ib) = -2.
      endif
      do i=1, nd
        xx(i) = x_data(i,ib)
        if (w_data(i,ib).gt.0) then
          if (iy.eq.xy_ampli.and.y_data(i,ib).gt.0) then
            yy(iba,i) = log(dble(y_data(i,ib)))
          elseif (iy.eq.xy_phase .and. degrees) then
            yy(iba,i) = y_data(i,ib)*pi/180d0
          else
            yy(iba,i) = y_data(i,ib)
          endif
          if (iy.eq.xy_ampli) then
            ww(iba,i) = w_data(i,ib)*y_data(i,ib)**2
            if (ww(iba,i).lt.2e-6) then
              ww(iba,i) = ww(iba,i)/100.
            endif
            yy(iba,i) = yy(iba,i)-ynorm(ib)
          else
            ww(iba,i) = w_data(i,ib)
            yy(iba,i) = yy(iba,i)-ynorm(ib)
          endif
          wnorm = wnorm + ww(i,iba)
        else
          ww(iba,i) = 0
          if (iy.eq.xy_ampli) then
            yy(iba,i) = blank4
          elseif (iy.eq.xy_phase) then
            yy(iba,i) = 0
          endif
        endif
      enddo
      wnorm = wnorm/nd
    endif
  enddo
  nbas = iba
  ! no amplitude or no phase
  if (wnorm.le.0) return
  ! Sort if required:
!! if needed, do it before transposition
!!  if (gr8_random(xx,nd)) then
!!    call gr8_trie(xx,ind,nd,error)
!!    if (error) goto 999
!!    do iba=1,nbas
!!      call gr8_sort(yy(1,iba),wk,ind,nd)
!!      call gr8_sort(ww(1,iba),wk,ind,nd)
!!    enddo
!!  endif
  !
  do ia =1,  nbas
    iba = ibsl(ia)
    if (ly.eq.xy_ampli) then
      do i = 1, nd
        if (yy(ia,i).eq.blank4) then
          bp_samp(isb,ibb,iba,i) = 0
        else
          bp_samp(isb,ibb,iba,i) = yy(ia,i)
        endif
      enddo
      fbp_samp(isb,ibb,iba) = .true.
    elseif (ly.eq.xy_phase) then
      do i = 1, nd
        bp_spha(isb,ibb,iba,i) = yy(ia,i)
      enddo
      fbp_spha(isb,ibb,iba) = .true.
    endif
  enddo
  ! Set number of points and frequencies
  ! Compute "holes" in spectrum and interpolate
  nhole = 0
  counting = .false.
  if (ly.eq.xy_ampli) then
    do i=1,nd
      bp_fsamp(isb,ibb,i) = xx(i)
      if (.not.counting) then
        if (bp_samp(isb,ibb,1,i).eq.0) then
          nhole = nhole + 1
          ifirst(nhole) = i
          counting  = .true.
        endif
      else
        if (bp_samp(isb,ibb,1,i).ne.0) then
          counting  = .false.
          ilast(nhole) = i-1
        endif
      endif
    enddo
    if (counting) ilast(nhole)=nd
    do i=1, nhole
      do ia =1, nbas
        iba = ibsl(ia)
        ym = 0
        yp = 0
        if (ifirst(i).gt.1) then
          ym=bp_samp(isb,ibb,iba,ifirst(i)-1)
        endif
        if (ilast(i).lt.nd) then
          yp=bp_samp(isb,ibb,iba,ilast(i)+1)
        endif
        if (ilast(i).ne.(ifirst(i)-2)) then
          delta = (yp-ym)/(ilast(i)-ifirst(i)+2)
        endif
        if (yp.ne.0.and.ym.ne.0) then
          do j=ifirst(i),ilast(i)
            if (imask.eq.1) then
              bp_samp(isb,ibb,iba,j) = bp_samp(isb,ibb,iba,ifirst(i)-1) &
                                     +(j-ifirst(i)+1)*delta
            else
              bp_samp(isb,ibb,iba,j) = blank4
            endif
          enddo
        endif
      enddo
    enddo
    !
    ! Add an extra extrapolated point
    mynd = nd+1
    bp_fsamp(isb,ibb,mynd) = 2*bp_fsamp(isb,ibb,mynd-1) &
                               -bp_fsamp(isb,ibb,mynd-2)
    do ia =1, nbas
      iba = ibsl(ia)
      if (bp_samp(isb,ibb,iba,mynd-1).ne.blank4.and. &
          bp_samp(isb,ibb,iba,mynd-2).ne.blank4) then
        bp_samp(isb,ibb,iba,mynd) = 2*bp_samp(isb,ibb,iba,mynd-1) &
                                    - bp_samp(isb,ibb,iba,mynd-2)
      else
        bp_samp(isb,ibb,iba,mynd) = blank4
      endif
    enddo
    !
    ! And set number of points
    nbp_samp(isb,ibb) = mynd
  elseif(ly.eq.xy_phase) then
    do i=1,nd
      bp_fspha(isb,ibb,i) = xx(i)
      if (.not.counting) then
        if (bp_spha(isb,ibb,1,i).eq.0) then
          nhole = nhole + 1
          ifirst(nhole) = i
          counting  = .true.
        endif
      else
        if (bp_spha(isb,ibb,1,i).ne.0) then
          counting  = .false.
          ilast(nhole) = i-1
        endif
      endif
    enddo
   if (counting) ilast(nhole)=nd
   do i=1, nhole
      do ia =1, nant
        iba = ibsl(ia)
        ym = 0
        yp = 0
        if (ifirst(i).gt.1) then
          ym=bp_spha(isb,ibb,iba,ifirst(i)-1)
        endif
        if (ilast(i).lt.nd) then
          yp=bp_spha(isb,ibb,iba,ilast(i)+1)
        endif
        if (ilast(i).ne.(ifirst(i)-2)) then
          delta = (yp-ym)/(ilast(i)-ifirst(i)+2)
        endif
        if (yp.ne.0.and.ym.ne.0) then
          do j=ifirst(i),ilast(i)
            if (imask.eq.1) then
              bp_spha(isb,ibb,iba,j) = bp_spha(isb,ibb,iba,ifirst(i)-1) &
                                     +(j-ifirst(i)+1)*delta
            else
              bp_spha(isb,ibb,iba,j) = blank4
            endif
          enddo
        endif
      enddo
    enddo
    !
    ! Add an extra extrapolated point
    mynd = nd+1
    bp_fspha(isb,ibb,mynd) = 2*bp_fspha(isb,ibb,mynd-1) &
                              -bp_fspha(isb,ibb,mynd-2)
    do ia =1, nbas
      iba = ibsl(ia)
      if (bp_spha(isb,ibb,iba,mynd-1).ne.blank4.and. &
          bp_spha(isb,ibb,iba,mynd-2).ne.blank4) then
        bp_spha(isb,ibb,iba,mynd) = 2*bp_spha(isb,ibb,iba,mynd-1) &
                                    - bp_spha(isb,ibb,iba,mynd-2)
      else
        bp_spha(isb,ibb,iba,mynd) = blank4
      endif
    enddo
    !
    ! And set number of points
    nbp_spha(isb,ibb) = mynd
  endif
  !
  if (plot) then
    do ib=1, n_boxes
      iy = i_y(k_y(ib))
      yyy = 0
      if (iy.eq.ly.and..not.skip(ib)) then
        iba = i_base(k_base(ib))
        isb = i_band(k_band(ib))
        ia = r_iant(iba)
        ja = r_jant(iba)
        if (my_do_rf(ia,ibb).and.my_do_rf(ja,ibb)) then
           do i=1, mynd
            if (ly.eq.xy_ampli) then
              yy1 = dble(bp_samp(isb,ibb,iba,i))
              if (yy1.eq.dble(blank4)) then
                yyy(i) = blank8
              else
                yyy(i) = exp(yy1+ynorm(ib))
              endif
              xxx(i) = bp_fsamp(isb,ibb,i)
            elseif (ly.eq.xy_phase) then
              yy1 = dble(bp_spha(isb,ibb,iba,i))
              if (yy1.eq.dble(blank4)) then
                yyy(i) = blank8
              else
                yyy(i) =yy1+ynorm(ib)
              endif
              if (degrees.and.yyy(i).ne.blank8) then
                yyy(i) = yyy(i)*180d0/pi
              endif
              xxx(i) = bp_fspha(isb,ibb,i)
            endif
          enddo
          write(chain,'(I4.4)') ib
          call gr_execl('CHANGE DIRECTORY BOX'//chain)
          error = gr_error()
          if (error) goto 999
          if (ly.eq.xy_phase) then
            turn = 2d0*pi
            if (degrees) turn = 360d0
            call phi_plot(gb1_y(ib),gb2_y(ib),   &
              mynd,xxx,yyy, turn)
          else
            call gr8_connect (mynd,xxx,yyy,blank8,1.0d0)
          endif
          call gr_execl('CHANGE DIRECTORY')
        else
          write(chain,'(I4.4)') ib
          call gr_execl('CHANGE DIRECTORY BOX'//chain)
          xcurs = 0.5*(gb2_x(ib)+gb1_x(ib))
          ycurs = 0.5*(gb2_y(ib)+gb1_y(ib))
          call relocate(xcurs,ycurs)
!          call putlabel(7,"IGNORED",5)
          call gr_execl('CHANGE DIRECTORY')
        endif
      endif
    enddo
  endif
  !
  bp_spectrum_memory = .false.
  return
  !
999 error = .true.
  return
end subroutine solve_pass_spectrum

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_keywordlist_types
  !----------------------------------------------------------------------
  ! Implement the parsing and resolution of keyword argument from a
  ! predefined list
  !    COMMAND Key
  !----------------------------------------------------------------------
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_primitive_arg
  use cubetools_structure_main
  !
  public :: keywordlist_comm_t,cubetools_keywordlist_user2prog
  private
  !
  type, extends(primitive_arg_t) :: keywordlist_comm_t
     integer(kind=4)               :: nkey
     character(len=:), allocatable :: keys(:)
     logical                       :: flexible
  contains
     procedure :: register => cubetools_keywordlist_comm_register
     procedure :: print_abstract => cubetools_keywordlist_comm_list  ! Overloading. ZZZ Should be renamed 'list'
  end type keywordlist_comm_t
  !
contains
  !
  subroutine cubetools_keywordlist_comm_allocate_and_init(lkey,nkey,arg,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=4),          intent(in)    :: lkey
    integer(kind=4),          intent(in)    :: nkey
    type(keywordlist_comm_t), intent(inout) :: arg
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: ier
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>ALLOCATE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if (allocated(arg%keys)) then
      call cubesyntax_message(syntaxseve%alloc,rname,'List array already allocated, deallocating')
      deallocate(arg%keys)
    endif
    !
    allocate(character(len=lkey)::arg%keys(nkey),stat=ier)
    if (failed_allocate(rname,'list array',ier,error)) return
    arg%nkey = nkey
    arg%keys(:) = strg_unk
    arg%flexible = .not.flexible
  end subroutine cubetools_keywordlist_comm_allocate_and_init
  !
  subroutine cubetools_keywordlist_comm_put(list,flexibl,arg,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*),         intent(in)    :: list(:)
    logical,                  intent(in)    :: flexibl
    type(keywordlist_comm_t), intent(inout) :: arg
    logical,                  intent(inout) :: error
    !
    integer(kind=4) :: lkey,nkey
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    lkey = len(list)
    nkey = size(list)
    call cubetools_keywordlist_comm_allocate_and_init(lkey,nkey,arg,error)
    if (error) return
    !
    arg%keys(:) = list(:)
    arg%flexible = flexibl
  end subroutine cubetools_keywordlist_comm_put
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_keywordlist_comm_register(templatearg,name,abstract,&
       help,mandat,list,flexibl,keyarg,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keywordlist_comm_t), intent(in)    :: templatearg  ! Template
    character(len=*),          intent(in)    :: name
    character(len=*),          intent(in)    :: abstract
    character(len=*),          intent(in)    :: help
    integer(kind=code_k),      intent(in)    :: mandat
    character(len=*),          intent(in)    :: list(:)
    logical,                   intent(in)    :: flexibl
    type(keywordlist_comm_t),  pointer       :: keyarg !***JP: Which intent?
    logical,                   intent(inout) :: error
    !
    class(primitive_arg_t), pointer :: actualarg
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! Register the primitive parts, and get pointer to the actual object
    ! saved in the parsing structure
    call cubetools_register_primitive_arg(templatearg,name,abstract,help,mandat,actualarg,error)
    if (error) return
    !
    ! Register the extended parts
    select type (actualarg)
    type is (keywordlist_comm_t)
      keyarg => actualarg
      call cubetools_keywordlist_comm_put(list,flexibl,keyarg,error)
      if (error) return
    class default
      call cubesyntax_message(seve%e,rname,'Internal error: argument has wrong type')
      error = .true.
      return
    end select
  end subroutine cubetools_keywordlist_comm_register
  !
  subroutine cubetools_keywordlist_comm_list(arg,iarg,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Dedicated subroutine for custom display of keywordlist_comm_t argument
    ! abstract in help (as displayed with question mark)
    !-------------------------------------------------------------------
    class(keywordlist_comm_t), intent(in)    :: arg
    integer(kind=narg_k),      intent(in)    :: iarg
    logical,                   intent(inout) :: error
    !
    character(len=mess_l) :: mess
    integer(kind=4) :: ikey
    character(len=*), parameter :: tab = '     '
    character(len=*), parameter :: comma = ','
    logical :: linehead
    character(len=*), parameter :: rname='KEYWORDLIST>COMM>LIST'
    !
    ! One line for the generic help:
    call arg%primitive_arg_t%print_abstract(iarg,error)
    if (error) return
    !
    ! One more line for the specific help:
    if (arg%flexible) then
       mess = tab//'Possible values: '//trim(arg%name)//comma
    else
       mess = tab//'Possible values: '
    endif
    do ikey=1,arg%nkey
       if (len_trim(mess)+len_trim(arg%keys(ikey)).gt.terminal%width()) then
          call cubesyntax_message(syntaxseve%help,rname,mess)
          linehead = .true.
       else
          linehead = .false.
       endif
       if (linehead) then
          write(mess,'(2a)') tab,arg%keys(ikey)
       else
          write(mess,'(A,1X,A)')  trim(mess),arg%keys(ikey)
       endif
       if (ikey.le.arg%nkey-2) write(mess,'(2a)') trim(mess),comma
       if (ikey.eq.arg%nkey-1) write(mess,'(2a)') trim(mess),' or'
    enddo
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_keywordlist_comm_list
  !
  subroutine cubetools_keywordlist_user2prog(arg,ichain,okey,ochain,error)
    use cubetools_disambiguate
    !-------------------------------------------------------------------
    ! Disambiguate a user input from the list of authorized keywords
    !-------------------------------------------------------------------
    type(keywordlist_comm_t), intent(in)    :: arg
    character(len=*),         intent(in)    :: ichain
    integer(kind=code_k),     intent(out)   :: okey
    character(len=*),         intent(out)   :: ochain
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYWORDLIST>USER2PROG'
    !
    if (arg%flexible) then
      call cubetools_disambiguate_flexible(ichain,arg%keys,okey,ochain,error)
      if (error) return
    else
      call cubetools_disambiguate_strict(ichain,arg%keys,okey,ochain,error)
      if (error) return
    endif
  end subroutine cubetools_keywordlist_user2prog
end module cubetools_keywordlist_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_language
  use cubetools_parameters
  use cubetools_structure
  use cubemain_messaging
  use cubemain_aperture
  use cubemain_averagec
  use cubemain_baseline
  use cubemain_circle
  use cubemain_compare
  use cubemain_compress
  use cubemain_consistency
  use cubemain_convert
  use cubemain_detect
  use cubemain_extract
  use cubemain_extrema
  use cubemain_feather
  use cubemain_fill
  use cubemain_header
  use cubemain_luminosity
  use cubemain_modify
  use cubemain_moments
  use cubemain_noise
  use cubemain_polar
  use cubemain_replace
  use cubemain_reproject
  use cubemain_resample
  use cubemain_rotate
  use cubemain_segment
  use cubemain_shuffle
  use cubemain_slice
  use cubemain_split
  use cubemain_smooth
  use cubemain_snr
  use cubemain_sort
  use cubemain_stack
  use cubemain_stitch
  use cubemain_window
  !
  public :: cubemain_register_language
  private
  !
  integer(kind=lang_k) :: langid
  !
contains
  !
  subroutine cubemain_register_language(error)
    !----------------------------------------------------------------------
    ! Register the CUBE\ language
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubetools_register_language(&
         'CUBE',&
         'J.Pety, S.Bardeau, V.deSouzaMagalhaes',&
         'Commands that performs various computations on cubes',&
         'CUBE groups day-to-day workflows used to prepare, inspect,&
         & and publish science-ready cubes.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Spatial transforms align image-plane structure for&
         & cross-dataset comparison (associated commands: COMPRESS,&
         & POLAR, REPROJECT, ROTATE, SMOOTH).'//strg_cr//&
         '- Spectral remap tools put spectra on a common sampling before&
         & comparison or stacking (associated commands: RESAMPLE,&
         & SHUFFLE).'//strg_cr//&
         '- Selection and slicing tools isolate scientifically relevant&
         & subsets (associated commands: EXTRACT, SLICE, SPLIT).'//strg_cr//&
         '- Detection workflow tools estimate noise/SNR and identify&
         & significant structures (associated commands: DETECT,&
         & SEGMENT, SORT, WINDOW, NOISE, SNR).'//strg_cr//&
         '- Signal estimators produce integrated or envelope diagnostics&
         & for interpretation (associated commands: BASELINE,&
         & LUMINOSITY, MOMENTS).'//strg_cr//&
         '- Data and header editing tools standardize values and metadata&
         & for downstream analysis (associated commands: CONVERT, FILL,&
         & REPLACE, EXTREMA, HEADER, MODIFY).'//strg_cr//&
         '- Stacking and merge tools combine measurements across regions,&
         & cubes, or observing setups (associated commands: APERTURE,&
         & CIRCLE, STACK, AVERAGE, STITCH).'//strg_cr//&
         '- Comparison and consistency tools quantify agreement between&
         & products and observing configurations (associated commands:&
         & COMPARE, CONSISTENCY, FEATHER).'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> CUBE\NOISE [cubid]'//strg_cr//&
         'CUBE> CUBE\SNR [signalid] [noiseid]'//strg_cr//&
         'CUBE> CUBE\SEGMENT [snrid]'//strg_cr//&
         'CUBE> CUBE\MOMENTS [cubid]'//strg_bl//&
         'Note:'//strg_cr//&
         'Some commands are enabled only in development mode.',&
         'gag_doc:hlp/cube-help-cube.hlp',&
         cubemain_execute_command,&
         langid,&
         error)
    if (error) return
    !----------------------------------------------------------------------
    !
    call aperture%register(error)
    if (error) return
    if (cube_dev_mode()) then
      call average%register(error)
      if (error) return
    endif
    call baseline%register(error)
    if (error) return    
    call circle%register(error)
    if (error) return
    call compare%register(error)
    if (error) return
    call compress%register(error)
    if (error) return
    call consistency%register(error)
    if (error) return
    call convert%register(error)
    if (error) return
    call detect%register(error)
    if (error) return
    call extract%register(error)
    if (error) return
    call extrema%register(error)
    if (error) return
    call feather%register(error)
    if (error) return
    call fill%register(error)
    if (error) return
    call header%register(error)
    if (error) return
    call luminosity%register(error)
    if (error) return
    call modify%register(error)
    if (error) return
    call moments%register(error)
    if (error) return
    call noise%register(error)
    if (error) return
    call polar%register(error)
    if (error) return
    call replace%register(error)
    if (error) return 
    call reproject%register(error)
    if (error) return
    call resample%register(error)
    if (error) return
    call rotate%register(error)
    if (error) return
    call segment%register(error)
    if (error) return
    call shuffle%register(error)
    if (error) return
    call slice%register(error)
    if (error) return
    call split%register(error)
    if (error) return
    call smooth%register(error)
    if (error) return
    call snr%register(error)
    if (error) return
    call sort%register(error)
    if (error) return
    call stack%register(error)
    if (error) return
    call stitch%register(error)
    if (error) return
    call window%register(error)
    if (error) return    
    !----------------------------------------------------------------------
    !
    ! call cubetools_register_command('BLANK',&
    !      'Blank part of a cube',&
    !      'cubname',&
    !      6,error)
    ! if (error) return
    ! call cubetools_register_option('SNR',&
    !      'To Be Completed',&
    !      'val',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('PERCENT',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('LIKE',&
    !      'To Be Completed',&
    !      'refcube',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('INSIDE',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('OUTSIDE',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('VALUE',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    !
    !----------------------------------------------------------------------
    !
    ! call cubetools_register_command('CONVOLVE',&
    !      'Convolve the LM images of a cube by an az. sym. function',&
    !      'cubname',&
    !      3,error)
    ! if (error) return
    ! call cubetools_register_option('WITH',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('REGULAR',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    ! call cubetools_register_option('NONORM',&
    !      'To Be Completed',&
    !      '',&
    !      error)
    ! if (error) return
    !
    !----------------------------------------------------------------------
    !
    call cubetools_register_dict(error)
    if (error) return
    !
  contains
    subroutine cube_lang_list(error)
      logical, intent(inout) :: error
    end subroutine cube_lang_list
  end subroutine cubemain_register_language
  !
  subroutine cubemain_execute_command(line,comm,error)
    use cubeadm_opened
    use cubeadm_timing
    !----------------------------------------------------------------------
    ! Execute a command of the CUBE\ language
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    character(len=*), intent(in)    :: comm
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='EXECUTE>COMMAND'
    !
    error = .false.
    if (comm.eq.'CUBE?') then
       call cubetools_list_language_commands(langid,error)
       if (error) return
    else
       call cubeadm_timing_init()
       call cubetools_execute_command(line,langid,comm,error)
       if (error) continue ! To ensure error recovery in the call to cubeadm_finish_all
       call cubeadm_finish_all(comm,line,error)
       if (error) continue ! To ensure error recovery in timing
       call cubeadm_timing_final(comm)
    endif
  end subroutine cubemain_execute_command
end module cubemain_language
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sub_alma_ter (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_alma_ter
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout) :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout) :: l_hclean
  type (gildas), intent(inout) :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout) :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_weight(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_weight(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_resid(:,:)
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc
  integer ier, ix, iy, jx, jy
  real l_max, c_max
  logical do_fft, ok
  character(len=message_length) :: chain
  character(len=7) :: rname = 'COMPACT'
  character(len=2) ans
  integer nker,mker
  parameter (mker=12)
  real smooth
  real, allocatable :: kernel(:,:)
  integer, allocatable :: xcoord(:), ycoord(:)
  integer, allocatable :: labelo(:,:)
  type(cct_par), allocatable :: wcl(:)
  type(cct_par) :: cct_null
  real noise,scale,fhat,long,compact, factor, thre
  real time_begin, time_end
  integer n_extended, kx, ky, kf, n_areas
  integer i, first, last
  logical do_long, more
  integer n_long, n_compact    ! Number of cycles of each type
  integer type_long, type_compact,last_type
  parameter (type_long=1)
  parameter (type_compact=2)
  !
  cct_null%value = 0.0
  cct_null%ix = 0
  cct_null%iy = 0
  !
  error = .false.
  do_fft = .true.
  factor = 0.0
  print *,'Into SUB_ALMA_TER '
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),stat=ier)
  allocate (r_work(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  allocate (w_fft(2*max(nx,ny)),stat=ier)
  allocate (w_comp(nc),stat=ier)
  !
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_weight=> l_method%weight(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d
  c_weight=> c_method%weight(:,:,1)
  !
  ! Relative noise contributions
  long = 1.0/l_hdirty%gil%noise**2
  compact = 1.0/c_hdirty%gil%noise**2
  noise = sqrt(long/compact)   ! Mean noise RATIO
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  smooth = 0.0
  if (smooth.eq.0) then
    nker = 4                   ! *** Must compute the true pixel ratio of ACA / ALMA
    nker = nint (c_hdirty%gil%convert(3,2) / l_hdirty%gil%convert(3,2))
    print *,'Nker ',nker
  elseif  (smooth.lt.4) then
    nker = 8
  else
    nker = mker
  endif
  !
  allocate(kernel(nker,nker),stat=ier)
  call init_kernel(kernel,nker,nker,smooth)
  !
  kx = mx/2
  ky = my/2
  kf = kx*ky
  allocate (labelo(kx,ky),stat=ier)
  allocate (wcl(kf),xcoord(kf),ycoord(kf),stat=ier)
  !
  do_long = c_method%n_major.gt.0
  last_type = type_long
  tcc%type = 1
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
     call gag_cpu (time_begin)
     print *,'Starting loop ',iplane
     l_method%flux = 0.0
     c_method%flux = 0.0
     l_method%n_iter= 0
     c_method%n_iter= 0
     !
     l_method%iplane = iplane
     c_method%iplane = iplane
     call beam_plane(l_method,l_hbeam,l_hdirty)
     ibeam = l_method%ibeam
     !
     ! Local aliases
     l_dirty => l_hdirty%r3d(:,:,iplane)
     l_resid => l_hresid%r3d(:,:,iplane)
     l_clean => l_hclean%r3d(:,:,iplane)
     l_beam  => l_hbeam%r3d(:,:,ibeam)
     !
     c_dirty => c_hdirty%r3d(:,:,iplane)
     c_resid => c_hresid%r3d(:,:,iplane)
     c_clean => c_hclean%r3d(:,:,iplane)
     !
     ! Initialize to Dirty map
     l_resid = l_dirty
     c_resid = c_dirty
     !
     ! Prepare beam parameters
     call get_clean (l_method, l_hbeam, l_beam, error)
     if (error) return
     call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
          &        l_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !
     call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
          &        c_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !            PRINT *,'Beam gains ',L_METHOD%BGAIN,C_METHOD%BGAIN
     !            L_METHOD%BGAIN = SQRT(L_METHOD%BGAIN*C_METHOD%BGAIN)
     l_resid = l_resid * l_weight
     c_resid = c_resid * c_weight
     !
     ! Performs decomposition into components:
     ! Only one major cycle per iteration, with a limited number
     ! of components ?
     !
     l_method%ngoal = 1000
     n_long = 0
     n_compact = 0
     !
     ! Locate the maximum of the Compact & Normal images
     l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
     c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
     ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
     do while (ok)
        !
        ! Plot for debug
        if (l_method%pcycle) then
           call mrc_clear
           call mrc_plot(c_resid,mx,my,2,'Compact')
           call mrc_plot(l_resid,nx,ny,3,'Long')
        endif
        !
        ! NOISE is the Noise RATIO (mean value over the beams)
        !
        if (l_max.gt.c_max/noise .or. do_long) then
           last_type = type_long  ! Use LONG baselines
        else
           ! May be using Compact baselines only. Check sign however
           l_max = l_resid(ix,iy)
           c_max = c_resid(jx,jy)
           thre = min(0.3,c_method%bgain)
           if (c_max*l_max .gt. 0) then
              ! Same sign, use Compact
              last_type = type_compact
           else
              ! Use higher threshold
              last_type = type_compact
              thre = max(0.7,c_method%bgain)
           endif
        endif
        !
        if (last_type.eq.type_long) then
           l_max = abs(l_max)
           print *,'Using LONG baselines ',l_max,c_max/noise
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Find components in LONG baseline image
           call one_cycle90 (l_method,l_hclean,   &   !
                &          l_clean,   &   ! Final CLEAN image
                &          l_dbeam,   &   ! Dirty beams
                &          l_resid,nx,ny,   & ! Residual and size
                &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
                &          w_comp, nc,         &    ! Component storage + Size
                &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
                &          l_method%patch(1),l_method%patch(2),   &
                &          l_method%bgain,l_method%box,   &
                &          w_fft,   &     ! Work space for FFTs
                &          tcc,   &       ! Component table
                &          l_list, l_method%nlist,   & ! Search list
                &          np,   &        ! Number of fields
                &          l_dprim,   &   ! Primary beams
                &          l_weight,   &  ! Weight
                &          l_max)
           !
           ! Define component type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           ! Remove from COMPACT baselines
           call remove_incompact(c_method,c_resid,mx,my,   &
                &          c_tfbeam, w_fft, mp,c_dprim,c_weight,   &
                &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
           ! Define number of iterations and type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           c_method%n_iter = l_method%n_iter
           c_method%flux = l_method%flux
           do_long = .false.
           n_long = n_long + 1
           ! Test SG
           factor = 0
        else
           print *,'Using COMPACT baselines ',l_max,c_max/noise
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Select extended area around this maximum
           thre = thre * c_max
           more = .true.
           do while (more)
              wcl = cct_null
              labelo = 0
              call threshold (c_resid,mx,my,   &   ! Initial image and size
                   &            c_method%blc,c_method%trc,   &   ! Image area
                   &            labelo,kx,ky,   &    ! Subset Image of area numbers
                   &            n_areas,   & ! Number of areas
                   &            xcoord,   &  ! Work space for area numbers
                   &            ycoord,kf,   &   ! Area numbers
                   &            thre,0.0,-1.0)
              !
              if ( (l_method%m_iter-l_method%n_iter).lt.   &
                   &            20*nker**2) then
                 c_method%ngoal = 10
              else
                 c_method%ngoal = min (c_method%ngoal,   &
                      &              (l_method%m_iter-l_method%n_iter)/nker**2)
              endif
              print *,'Threshold ',thre,c_method%ngoal
              call load_cct (c_resid,mx,my,   &
                   &            c_method%blc,c_method%trc,   &   ! Image area
                   &            labelo,kx,ky,   &    ! Subset Image of area numbers
                   &            n_extended,wcl,jx,jy,   &
                   &            c_method%gain,thre,c_method%ngoal)
              !
              write(chain,'(A,I6,A,1pg10.3)')   &
                   &  'Selected ',n_extended,' components above ',thre
              call map_message(seve%i,rname,chain)
              if (n_extended*nker**2+l_method%n_iter .le.   &
                   &            l_method%m_iter) then
                 more = .false.
              else
                 print *,'Stopping '
                 ok = .false.
                 more = .false.
                 do_long = .true.
              endif
           enddo
           !
           if (.not.do_long) then
              !
              ! Compute the scale factor
              if (factor.eq.0) then
                 call normal (   &
                      &              w_work,   &    ! Work space for Component TF
                      &              c_tfbeam,   &  ! Beam TF
                      &              mx,my,   & ! image size
                      &              wcl,     &    ! Selected candidate components
                      &              n_extended,   &    ! Selected Number of components
                      &              w_fft,   & ! FFT work space
                      &              factor)    ! Normalisation factor
                 factor = c_method%gain*abs(c_max)/factor
                 print *,'New factor ',factor
              endif
              !
              ! Expand the components on the fine grid.
              first = c_method%n_iter+1
              do i=1,n_extended
                 ix = wcl(i)%ix
                 iy = wcl(i)%iy
                 c_max = wcl(i)%value * factor
                 !
                 ! Define the corresponding component list AND value
                 call expand_kernel(c_method,mx,my,ix,iy,c_max,   &
                      &              tcc,first,last,nx,ny,   &
                      &              kernel, nker)
                 first = last+1
              enddo
              l_method%n_iter = last
              !
              ! Remove List in Compact Baselines
              call remove_incompact(c_method,c_resid,mx,my,   &
                   &            c_tfbeam, w_fft, mp,c_dprim,c_weight,   &
                   &            tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
              !
              ! Remove List in Long Baselines
              call remove_inlong(l_method,l_resid,nx,ny,   &
                   &            l_tfbeam, w_fft, np,l_dprim,l_weight,   &
                   &            tcc,c_method%n_iter+1,l_method%n_iter)
              !
              ! Define number of components
              c_method%n_iter = l_method%n_iter
              l_method%flux = c_method%flux
              write(chain,'(A,1PG11.4,A,I6,A)')  'Cleaned ',c_method%flux,  &
                     &  ' Jy in ',c_method%n_iter,' components'
              call map_message(seve%i,rname,chain)
              n_compact = n_compact + 1
           endif
        endif
        ! Stop if done
        l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
        c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
        ok = ok .and. (l_max.gt.l_method%ares   &
             &        .or. c_max.gt.c_method%ares)
        if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
        if (sic_ctrlc()) ok = .false.
        ! Continue with ALMA only if not enough components yet
        if (l_method%n_iter .lt. c_method%n_major)   &
             &        do_long = .true.
     enddo
     !
     ! Add clean components and residuals to produce clean map
     ! Note that the Kernel is still scaled in the same way as before
     if (l_method%n_iter.ne.0) then
        call alma_make (l_method, l_hclean, tcc)
     else
        l_clean = 0
     endif
     !
     ! Which residual should be added ?...
     ! We don't want to add noise, but to combine it properly...
     ! We may need to go to the full combined gridding business here...
     l_clean = l_clean + l_resid * l_weight * long
     c_clean = c_resid * c_weight * compact
     call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
     where (l_weight.lt.l_method%trunca)
        r_work = 0
     end where
     l_clean = l_clean + r_work
     !
     call gag_cpu (time_end)
     write(chain,*) n_long,' Long baselines cycles'
     call map_message(seve%i,'ALMA',chain)
     write(chain,*) n_compact,' Compact array cycles'
     call map_message(seve%i,'ALMA',chain)
     write(chain,*) time_end-time_begin,' CPU'
     call map_message(seve%i,'ALMA',chain)
  enddo
  !
  ! Cleanup
  deallocate (w_work,r_work,c_work)
  deallocate (w_fft,w_comp,w_resid)
  deallocate (kernel)
  deallocate (labelo,wcl,xcoord,ycoord)
end subroutine sub_alma_ter
!
subroutine load_cct (image,nx,ny,blc,trc,label,mx,my,   &
     &    nv,wcl,ix,iy,gain,tmax,ngoal)
  use clean_def
  ! @ private
  integer, intent(in) :: nx,ny,mx,my,blc(2),trc(2)
  integer, intent(out) :: nv
  integer, intent(in) :: ix,iy
  real(4), intent(in) :: image(nx,ny)
  integer, intent(inout) :: label(mx,my)
  type(cct_par), intent(inout) :: wcl(mx*my)
  integer, intent(in) :: ngoal
  real, intent(in) :: gain
  real, intent(out) :: tmax
  !
  integer i,j,ii,jj,label0, jx,jy, nc
  logical ok
  real rmax
  !
  nv = 0
  nc = 0
  jx = ix-blc(1)+1
  jy = iy-blc(2)+1
  ok = .true.
  do while (ok)
     !
     label0 = label(jx,jy)
     !
     ! First pass to find the max of the omitted values
     rmax = 0.0
     do j=1,my
        do i=1,mx
           if (label(i,j).ne.label0 .and. label(i,j).ne.0) then
              ii = blc(1)+i-1
              jj = blc(2)+j-1
              if (abs(image(ii,jj)).gt.rmax) then
                 rmax = abs(image(ii,jj))
                 jx = i
                 jy = j
              endif
           endif
        enddo
     enddo
     !
     ! Not good ...
     !         RMAX = (1.0-GAIN) * RMAX
     !
     do j=1,my
        do i=1,mx
           if (label(i,j).eq.label0) then
              ii = blc(1)+i-1
              jj = blc(2)+j-1
              if (abs(image(ii,jj)).gt.rmax) then
                 nv = nv+1
                 wcl(nv)%influx = image(ii,jj)
                 wcl(nv)%ix = ii
                 wcl(nv)%iy = jj
                 label (i,j) = 0
              endif
           endif
        enddo
     enddo
     if (rmax.eq.0) return
     tmax = rmax
     nc = nc+1
     !
     ! Selectionner au moins NGOAL, en au plus NC=10 ilots
     if (nv.lt.ngoal .and. nc.lt.10) then
        ok = .true.
     else
        ok = .false.
     endif
  enddo
end subroutine load_cct

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_index_iterator_tool
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_node_class
  use cubedag_link_type
  use cubedag_dag_buffer

  public :: code_iter_unknown,ncode_iter,iter_names,iter_abstracts
  public :: index_iterator_t
  private
  !
  ! --- Public iteration codes -----------------------------------------
  integer(kind=code_k), parameter :: code_iter_unknown     = 0
  integer(kind=code_k), parameter :: code_iter_current     = 1
  integer(kind=code_k), parameter :: code_iter_next        = 2
  integer(kind=code_k), parameter :: code_iter_previous    = 3
  integer(kind=code_k), parameter :: code_iter_first       = 4
  integer(kind=code_k), parameter :: code_iter_last        = 5
  integer(kind=code_k), parameter :: code_iter_beforefirst = 6
  integer(kind=code_k), parameter :: code_iter_afterlast   = 7
  integer(kind=code_k), parameter :: ncode_iter = code_iter_afterlast
  !
  character(len=*), parameter :: iter_names(ncode_iter) = [&
       'CURRENT    ',&
       'NEXT       ','PREVIOUS   ',&
       'FIRST      ','LAST       ',&
       'BEFOREFIRST','AFTERLAST  ']
  !
  character(len=*), parameter :: iter_abstracts(ncode_iter) = [&
       'current     ',&
       'next        ','previous    ',&
       'first       ','last        ',&
       'before first','afterlast   ']
  ! --------------------------------------------------------------------

  integer(kind=code_k), parameter :: start_noninitialized=1
  integer(kind=code_k), parameter :: start_before=2
  integer(kind=code_k), parameter :: start_current=3
  integer(kind=code_k), parameter :: start_after=4

  ! Private type which saves the iterator status
  type :: index_internal_t
    type(cubedag_link_t), pointer, private :: optx
    integer(kind=code_k),          private :: start = start_noninitialized
    integer(kind=iden_l),          private :: current_id
  contains
    procedure, private :: current_num => index_iterator_current_num
  end type index_internal_t
  ! Keep the iterator status in a private instance
  type(index_internal_t) :: gbl_iter

  ! Public methods to which interact with the internal iterator
  type :: index_iterator_t
  contains
    procedure, nopass, public :: get        => index_iterator_get
    procedure, nopass, public :: put        => index_iterator_put
    procedure, nopass, public :: is_current => index_iterator_is_current
  end type index_iterator_t

contains

  subroutine index_iterator_get(what,out,error)
    !-------------------------------------------------------------------
    ! Return the identifier suited for the given "what" code
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: what
    integer(kind=iden_l), intent(out)   :: out
    logical,              intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: entry_none=-1
    integer(kind=entr_k), parameter :: entry_first=2  ! Skip root
    integer(kind=entr_k) :: newent
    character(len=mess_l) :: mess
    class(cubedag_node_object_t), pointer :: obj
    character(len=*), parameter :: rname='GET>CURRENT'
    !
    ! call cubedag_message(dagseve%trace,rname,'Welcome')
    !
    if (.false.) then  ! ZZZ Need a way to customize the target
      gbl_iter%optx => cx
    else
      gbl_iter%optx => ix
    endif
    !
    select case (what)
    case (code_iter_beforefirst)
      gbl_iter%start = start_before
      newent = entry_none
    case (code_iter_afterlast)
      gbl_iter%start = start_after
      newent = entry_none
    case (code_iter_current)
      call gbl_iter%current_num(newent,error)
      if (error)  return
    case (code_iter_first)
      newent = entry_first
    case (code_iter_last)
      newent = gbl_iter%optx%n
    case (code_iter_next)
      if (gbl_iter%start.eq.start_noninitialized .or.  &
          gbl_iter%start.eq.start_before) then
        newent = entry_first
      else
        call gbl_iter%current_num(newent,error)
        if (error)  return
        newent = newent+1
      endif
      if (newent.gt.gbl_iter%optx%n) then  ! ZZZ Loop mode?
        call cubedag_message(seve%e,rname,'Reached end of index')
        error = .true.
        return
      endif
    case (code_iter_previous)
      if (gbl_iter%start.eq.start_noninitialized .or.  &
          gbl_iter%start.eq.start_after) then
        newent = gbl_iter%optx%n
      else
        call gbl_iter%current_num(newent,error)
        if (error)  return
        newent = newent-1
      endif
      if (newent.lt.entry_first) then  ! ZZZ Loop mode?
        call cubedag_message(seve%e,rname,'Reached start of index')
        error = .true.
        return
      endif
    case default
      call cubedag_message(seve%e,rname,'Unexpected iterator code')
      error = .true.
      return
    end select
    !
    if (newent.eq.entry_none) then
      call cubedag_message(seve%d,rname,'No entry to get here')
      out = code_null
    elseif (newent.lt.entry_first .or. newent.gt.gbl_iter%optx%n) then
      ! Should not happen
      write(mess,'(a,i0,a)')  'No entry number ',newent,' in index'
      call cubedag_message(seve%e,rname,mess)
      error = .true.
      return
    else
      write(mess,'(a,i0)')  'Getting entry number ',newent
      call cubedag_message(seve%d,rname,mess)
      obj => cubedag_node_ptr(gbl_iter%optx%list(newent)%p,error)
      if (error)  return
      out = obj%get_id()
      call index_iterator_put(out,error)
      if (error)  return
    endif
  end subroutine index_iterator_get
  !
  subroutine index_iterator_put(id,error)
    !-------------------------------------------------------------------
    ! Set the current identifier in the iterator
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id
    logical,              intent(inout) :: error
    !
    gbl_iter%current_id = id
    gbl_iter%start = start_current  ! A valid current ID is now defined
  end subroutine index_iterator_put
  !
  subroutine index_iterator_current_num(iter,num,error)
    !-------------------------------------------------------------------
    ! Dynamically get the entry number from the current ID, as the entry
    ! number in the index might change if e.g. other nodes are removed.
    ! This assumes the identifiers in the index are numerically sorted.
    !-------------------------------------------------------------------
    class(index_internal_t), intent(inout) :: iter
    integer(kind=entr_k),    intent(out)   :: num
    logical,                 intent(inout) :: error
    !
    integer(kind=iden_l) :: found_id
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='ITERATOR>CURRENT>NUM'
    !
    num = 0
    !
    if (iter%start.ne.start_current) then
      call cubedag_message(seve%e,rname,'No current entry defined')
      error = .true.
      return
    endif
    !
    call iter%optx%entrynum(iter%current_id,found_id,num,error)
    if (error)  return
    !
    if (found_id.ne.iter%current_id) then
      ! It may have disappeared e.g. after an UNDO
      write(mess,'(3(a,i0))')  &
        'Current entry id. ',iter%current_id, &
        ' not found in index, using entry id. ',found_id,' as fallback'
      call cubedag_message(seve%w,rname,mess)
    endif
  end subroutine index_iterator_current_num

  function index_iterator_is_current(id)
    !-------------------------------------------------------------------
    ! Return .true. if the passed ID matches the gbl_iter current ID.
    !-------------------------------------------------------------------
    logical :: index_iterator_is_current
    integer(kind=iden_l), intent(in) :: id
    !
    index_iterator_is_current = gbl_iter%start.eq.start_current .and. &
                                gbl_iter%current_id.eq.id
  end function index_iterator_is_current

end module cubedag_index_iterator_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE FITSIO messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefitsio_messaging
  use cfitsio_api
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: seve,fitsioseve,mess_l
  public :: cubefitsio_message_set_id,cubefitsio_message,cubefitsio_error
  public :: cubefitsio_message_set_trace,cubefitsio_message_get_trace
  public :: cubefitsio_message_set_others,cubefitsio_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubefitsio_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubefitsio_messaging_debug_t
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubefitsio_messaging_debug_t
  type(cubefitsio_messaging_debug_t) :: fitsioseve
  !
contains
  !
  subroutine cubefitsio_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubefitsio_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubefitsio_message_id
    call cubefitsio_message(seve%d,rname,mess)
  end subroutine cubefitsio_message_set_id
  !
  subroutine cubefitsio_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubefitsio_message_id,mkind,'FITSIO>'//procname,message)
  end subroutine cubefitsio_message
  !
  function cubefitsio_error(procname,status,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_error  ! Function value on return
    character(len=*), intent(in)    :: procname
    integer(kind=4),  intent(in)    :: status
    logical,          intent(inout) :: error
    ! Local
    character(len=message_length) :: mess
    !
    cubefitsio_error = status.ne.0
    if (cubefitsio_error) then
      error = .true.
      call ftgerr(status,mess)
      call cubefitsio_message(seve%e,procname,mess)
    endif
    !
  end function cubefitsio_error
  !
  subroutine cubefitsio_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitsioseve%trace = seve%i
    else
       fitsioseve%trace = seve%t
    endif
  end subroutine cubefitsio_message_set_trace
  !
  subroutine cubefitsio_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitsioseve%others = seve%i
    else
       fitsioseve%others = seve%d
    endif
  end subroutine cubefitsio_message_set_others
  !
  function cubefitsio_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_message_get_trace
    !
    cubefitsio_message_get_trace = fitsioseve%trace.eq.seve%i
    !
  end function cubefitsio_message_get_trace
  !
  function cubefitsio_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefitsio_message_get_others
    !
    cubefitsio_message_get_others = fitsioseve%others.eq.seve%i
    !
  end function cubefitsio_message_get_others
  !
end module cubefitsio_messaging
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_setup_new  ! To be renamed to 'class_setup' when the old
                        ! module is removed
  use phys_const
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Support module for the SET structure
  ! No direct access to the SET structure. Only use methods to get and
  ! set values.
  !---------------------------------------------------------------------
  !
  type class_setup_new_t
    real(kind=8) :: fangle=sec_per_rad  ! Angle conversion factor
    !
    character(len=3) :: angle='SEC'  ! Angle unit
    !
  end type class_setup_new_t
  type(class_setup_new_t) :: set
  !
  public :: class_setup_put_fangle,class_setup_get_fangle
  public :: class_setup_put_angle, class_setup_get_angle,class_setup_sicdef_angle
  private
  !
contains
  !
  subroutine class_setup_put_fangle(fangle,error)
    real(kind=8), intent(in)    :: fangle
    logical,      intent(inout) :: error
    set%fangle = fangle
  end subroutine class_setup_put_fangle
  function class_setup_get_fangle()
    real(kind=8) :: class_setup_get_fangle
    class_setup_get_fangle = set%fangle
  end function class_setup_get_fangle
  !
  subroutine class_setup_put_angle(angle,error)
    character(len=*), intent(in)    :: angle
    logical,          intent(inout) :: error
    set%angle = angle
  end subroutine class_setup_put_angle
  function class_setup_get_angle()
    character(len=3) :: class_setup_get_angle
    class_setup_get_angle = set%angle
  end function class_setup_get_angle
  subroutine class_setup_sicdef_angle(struct,error)
    character(len=*), intent(in)    :: struct
    logical,          intent(inout) :: error
    call sic_def_char(struct//'%ANGLE',set%angle,.true.,error)
  end subroutine class_setup_sicdef_angle
  !
end module class_setup_new

module imbfits_column_types
  use gbl_message
  use gkernel_types
  use cfitsio_api
  use imbfits_file_type
  !
  public :: imbfits_read_column
  public :: imbfits_dump_column
  private
  !
  interface imbfits_read_column
    module procedure imbfits_read_logi_1d
    module procedure imbfits_read_inte_1d
    module procedure imbfits_read_real_1d
    module procedure imbfits_read_dble_1d
    module procedure imbfits_read_char_1d
    module procedure imbfits_read_dble_2d_into_1d
  end interface imbfits_read_column
  !
  interface imbfits_dump_column
    module procedure imbfits_dump_inte_1d
    module procedure imbfits_dump_real_1d
    module procedure imbfits_dump_dble_1d
    module procedure imbfits_dump_char_1d
    module procedure imbfits_dump_logi_1d
  end interface imbfits_dump_column
  !
contains
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Reading routines (1D)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine imbfits_read_logi_1d(caller,file,key,n,logi,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>LOGI>1D'
    integer(kind=4) :: colnum,status
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_logi_1d(key,n,logi,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,logi%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'L' .and. tval.ne.'1L') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ''',trim(key),''' (type ',trim(tval),') in a logical*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,logi%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    call ftgcl(file%unit,colnum,1,1,n,logi%val,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
  end subroutine imbfits_read_logi_1d
  !
  subroutine imbfits_read_inte_1d(caller,file,key,n,inte,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>INTE>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_inte_1d(key,n,inte,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,inte%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'J' .and. tval.ne.'1J') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in an integer*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,inte%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcvj(file%unit,colnum,1,1,n,-1,inte%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_inte_1d
  !
  subroutine imbfits_read_real_1d(caller,file,key,n,real,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>REAL>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_real_1d(key,n,real,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,real%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'E' .and. tval.ne.'1E') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*4 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,real%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcve(file%unit,colnum,1,1,n,-1.e0,real%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_real_1d
  !
  subroutine imbfits_read_dble_1d(caller,file,key,n,dble,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: n
    type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>DBLE>1D'
    integer(kind=4) :: colnum,status
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_dble_1d(key,n,dble,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,dble%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    if (tval.ne.'D' .and. tval.ne.'1D') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,dble%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    anynull = .false.
    call ftgcvd(file%unit,colnum,1,1,n,-1.d0,dble%val,anynull,status)
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_dble_1d
  !
  subroutine imbfits_read_char_1d(caller,file,key,n,char,error,default)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)           :: caller
    type(imbfits_file_t), intent(in)           :: file
    character(len=*),     intent(in)           :: key
    integer(kind=4),      intent(in)           :: n
    type(fits_char_1d_t), intent(inout)        :: char    ! INOUT: keep allocation status
    logical,              intent(inout)        :: error
    character(len=*),     intent(in), optional :: default  ! If absent column or NULL values in column
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>CHAR>1D'
    integer(kind=4) :: colnum,status,nc
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    character(len=char1d_length) :: defstring
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_char_1d(key,n,char,error)
    if (error)  return
    !
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,char%key,colnum,status)
    if (status.gt.0) then
      ! Error, probably no such column
      if (present(default)) then
        char%val(:) = default
        char%comment = 'WARNING! Column not found in table'
        return
        else
        call imbfits_message(seve%e,caller,'Error')
        call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
        call cfitsio_errormsg(status)
        error = .true.
        return
      endif
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    nc = len_trim(tval)
    if (tval(nc:nc).ne.'A') then
      write(mess,'(A,A,A,A,A)')  &
            'Attempt to read column ',trim(key),' (type ',trim(tval),') in a character vector'
      call imbfits_message(seve%w,rname,mess)
    endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,char%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Read the column data
    if (n.eq.0)  return  ! No data, nothing more to do
    if (present(default)) then
        defstring = default
    else
        defstring = 'NULL'
    endif
    anynull = .false.
    call ftgcvs(file%unit,colnum,1,1,n,defstring,char%val,anynull,status)
    if (anynull .or. status.gt.0) then
      if (status.eq.0 .and. anynull .and. present(default)) then
        ! Caller gave a default in case of undefined values. Not an error
        continue
      else
        call imbfits_message(seve%e,caller,'Error')
        write(mess,'(A,I0,A,A,A,I0)')  &
              'Error while reading column #',colnum,' (',trim(key),'), row #',1
        call imbfits_message(seve%e,rname,mess)
        if (anynull) then
          call imbfits_message(seve%e,rname,'Some null values found')
        else
          call cfitsio_errormsg(status)
        endif
        error = .true.
        return
      endif
    endif
  end subroutine imbfits_read_char_1d
  !
  subroutine imbfits_read_dble_2d_into_1d(caller,file,key,nrow,ncol,dble,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*),     intent(in)    :: caller
    type(imbfits_file_t), intent(in)    :: file
    character(len=*),     intent(in)    :: key
    integer(kind=4),      intent(in)    :: nrow
    integer(kind=4),      intent(in)    :: ncol
    type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='IMBFITS>READ>DBLE>2D>INTO>1D'
    integer(kind=4) :: colnum,status,nelem
    logical :: anynull
    character(len=message_length) :: mess
    character(len=10) :: tkey,tval
    character(len=comment_length) :: tcomm
    !
    call imbfits_message(seve%t,rname,'Welcome')
    !
    ! *** JP Next block should be factorized
    if (file%unit.eq.0) then
      call imbfits_message(seve%e,rname,'Input file not opened')
      error = .true.
      return
    endif
    !
    ! Allocations
    call reallocate_fits_dble_1d(key,nrow*ncol,dble,error)
    if (error)  return
    !
    ! *** JP Next two blocks should be factorized
    ! Get column number
    status = 0
    call ftgcno(file%unit,.false.,dble%key,colnum,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    ! Get corresponding TFORM
    tkey = 'TFORM'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,tcomm,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    ! ZZZ Some clever check here!
    !   if (tval.ne.'E') then
    !     write(mess,'(A,A,A,A,A)')  &
    !       'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 array'
    !     call imbfits_message(seve%w,rname,mess)
    !   endif
    !
    ! Get corresponding TTYPE so that we get its comment
    tkey = 'TTYPE'
    write(tkey(6:7),'(I0)')  colnum
    call ftgkys(file%unit,tkey,tval,dble%comment,status)
    if (status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
      call cfitsio_errormsg(status)
      error = .true.
      return
    endif
    !
    nelem = nrow*ncol
    anynull = .false.
    call ftgcvd(file%unit,colnum,1,1,nelem,-1.d0,dble%val,anynull,status)
    ! *** JP Next block could be factorized
    if (anynull .or. status.gt.0) then
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
            'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_errormsg(status)
      endif
      error = .true.
      return
    endif
  end subroutine imbfits_read_dble_2d_into_1d
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Dumping routines (1D)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  subroutine imbfits_dump_inte_1d(inte,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_inte_1d_t), intent(in)    :: inte
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = inte%key
    call sic_upper(key)
    if (.not.associated(inte%val)) then
      write(olun,100)  key,trim(inte%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(inte%comment),') is an integer column of dimensions ',inte%n
      call i4_type(inte%n,inte%val)
    elseif (inte%n.ge.3) then
      write(olun,103)  key,inte%val(1),inte%val(inte%n),trim(inte%comment)
    elseif (inte%n.eq.2) then
      write(olun,102)  key,inte%val(1:2),trim(inte%comment)
    else  ! 1 value
      write(olun,101)  key,inte%val(1),trim(inte%comment)
    endif
    !
    100 format(A8,' (I4) = NO DATA ASSOCIATED!',              T64,'/ ',A)
    101 format(A8,' (I4) =',1(1X,I14),                        T64,'/ ',A)
    102 format(A8,' (I4) =',2(1X,I14),                        T64,'/ ',A)
    103 format(A8,' (I4) =',1(1X,I14),'      ...     ',1X,I14,T64,'/ ',A)
  end subroutine imbfits_dump_inte_1d
  !
  subroutine imbfits_dump_real_1d(real,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_real_1d_t), intent(in)    :: real
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = real%key
    call sic_upper(key)
    if (.not.associated(real%val)) then
      write(olun,100)  key,trim(real%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(real%comment),') is a real column of dimensions ',real%n
      call r4_type(real%n,real%val)
    elseif (real%n.ge.3) then
      write(olun,103)  key,real%val(1),real%val(real%n),trim(real%comment)
    elseif (real%n.eq.2) then
      write(olun,102)  key,real%val(1:2),trim(real%comment)
    else
      write(olun,101)  key,real%val(1),trim(real%comment)
    endif
    !
    ! Single precision floats: precision is 7.22 decimal digits
    100 format(A8,' (R4) = NO DATA ASSOCIATED!',                         T64,'/ ',A)
    101 format(A8,' (R4) =',1(1X,1PG14.7),                               T64,'/ ',A)
    102 format(A8,' (R4) =',2(1X,1PG14.7),                               T64,'/ ',A)
    103 format(A8,' (R4) =',1(1X,1PG14.7),'      ...     ',1(1X,1PG14.7),T64,'/ ',A)
  end subroutine imbfits_dump_real_1d
  !
  subroutine imbfits_dump_dble_1d(dble,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_dble_1d_t), intent(in)    :: dble
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = dble%key
    call sic_upper(key)
    if (.not.associated(dble%val)) then
      write(olun,100)  key,trim(dble%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(dble%comment),') is a double column of dimensions ',dble%n
      call r8_type(dble%n,dble%val)
    elseif (dble%n.ge.3) then
      write(olun,103)  key,dble%val(1),dble%val(dble%n),trim(dble%comment)
    elseif (dble%n.eq.2) then
      write(olun,102)  key,dble%val(1:2),trim(dble%comment)
    else
      write(olun,101)  key,dble%val(1),trim(dble%comment)
    endif
    !
    ! Double precision floats: precision is 15.95 decimal digits (using
    ! more than 15 digits can make appear roundoff problems because of
    ! precision is not exactly 16).
    100 format(A8,' (R8) = NO DATA ASSOCIATED!',                  T64,'/ ',A)
    101 format(A8,' (R8) =',1(1X,1PG22.15),                       T64,'/ ',A)
    102 format(A8,' (R8) =',2(1X,1PG22.15),                       T64,'/ ',A)
    103 format(A8,' (R8) =',1(1X,1PG22.15),' ... ',1(1X,1PG22.15),T64,'/ ',A)
  end subroutine imbfits_dump_dble_1d
  !
  subroutine imbfits_dump_char_1d(char,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_char_1d_t), intent(in)    :: char
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = char%key
    call sic_upper(key)
    if (.not.associated(char%val)) then
      write(olun,100)  key,trim(char%comment)
    elseif (dofull) then
      write(olun,'(4A,I0,A,I0)')  &
        trim(key),' (',trim(char%comment),') is a character*',len(char%val(1)),' column of dimensions ',char%n
      call ch_type(char%n,char%val,len(char%val(1)))
    elseif (char%n.ge.3) then
      write(olun,103)  key,char%val(1),char%val(char%n),trim(char%comment)
    elseif (char%n.eq.2) then
      write(olun,102)  key,char%val(1:2),trim(char%comment)
    else
      write(olun,101)  key,char%val(1),trim(char%comment)
    endif
    !
    100 format(A8,' (C)  = NO DATA ASSOCIATED!',                 T64,'/ ',A)
    101 format(A8,' (C)  =',1(1X,A14),                           T64,'/ ',A)
    102 format(A8,' (C)  =',2(1X,A14),                           T64,'/ ',A)
    103 format(A8,' (C)  =',1(1X,A14),'      ...     ',1(1X,A14),T64,'/ ',A)
  end subroutine imbfits_dump_char_1d
  !
  subroutine imbfits_dump_logi_1d(logi,olun,error,full)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(fits_logi_1d_t), intent(in)    :: logi
    integer(kind=4),      intent(in)    :: olun   ! Output LUN
    logical,              intent(inout) :: error
    logical, optional,    intent(in)    :: full   ! Full output (all values)?
    ! Local
    character(len=key_length) :: key
    logical :: dofull
    !
    if (present(full)) then
      dofull = full
    else
      dofull = .false.
    endif
    key = logi%key
    call sic_upper(key)
    if (.not.associated(logi%val)) then
      write(olun,100)  key,trim(logi%comment)
    elseif (dofull) then
      write(olun,'(4A,I0)')  &
        trim(key),' (',trim(logi%comment),') is a logical column of dimensions ',logi%n
      call l_type(logi%n,logi%val)
    elseif (logi%n.ge.3) then
      write(olun,103)  key,logi%val(1),logi%val(logi%n),trim(logi%comment)
    elseif (logi%n.eq.2) then
      write(olun,102)  key,logi%val(1:2),trim(logi%comment)
    else
      write(olun,101)  key,logi%val(1),trim(logi%comment)
    endif
    !
    100 format(A8,' (L)  = NO DATA ASSOCIATED!',         T64,'/ ',A)
    101 format(A8,' (L)  =',1(1X,L8),                    T64,'/ ',A)
    102 format(A8,' (L)  =',2(1X,L8),                    T64,'/ ',A)
    103 format(A8,' (L)  =',1(1X,L8),'   ...  ',1(1X,L8),T64,'/ ',A)
  end subroutine imbfits_dump_logi_1d
  !
end module imbfits_column_types

program uv_applyphase
  use image_def
  use gkernel_interfaces
!
! Apply a phase modification
!
  character(len=filename_length) :: nami,namo
  logical :: error, amp_correct
!
  call gildas_open
  call gildas_char('INPUT$',nami)
  call gildas_char('OUTPUT$',namo)
  call gildas_logi('AMP_CORRECT$',amp_correct,1)
  call gildas_close
  call sub_applyphase (nami,namo,amp_correct,error)
  if (error) call sysexi(fatale)
  call gagout('I-UV_APPLYPHASE,  Successful completion')
end program uv_applyphase
!<ff>
subroutine sub_applyphase (nami,namo,amp_correct,error)
  use image_def
  use gkernel_interfaces
  character(len=*) nami,namo
  logical error
!
  type (gildas) :: hin,hout
  real, allocatable :: din(:,:),dout(:,:)
  integer nt,nv,i,j,ier,ii,ir,nc
  real re,im,amp
  logical amp_correct
  character(len=*), parameter :: rname = 'APPLYPHASE'
!
! Read Header of the input UV table
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (gildas_error(hin,rname,error)) return
  allocate (din(hin%gil%dim(1),hin%gil%dim(2)),stat=ier)
  call gdf_read_data (hin,din,error)
  if (gildas_error(hin,rname,error)) return
  nt = hin%gil%dim(1)
  nv = hin%gil%dim(2)
!
! Read header of the output UV table
  call sic_parsef (namo,hout%file,' ','.uvt')
  call gdf_read_header (hout,error)
  if (gildas_error(hout,rname,error)) return
  allocate (dout(hout%gil%dim(1),hout%gil%dim(2)),stat=ier)
  call gdf_read_data (hout,dout,error)
  if (gildas_error(hout,rname,error)) return
!
  if (nv.ne.hout%gil%dim(2)) then
     call gagout('E-'//rname//',  Inconsistent sizes')
     error = .true.
     return
  endif
!
! Correct amplitude decorrelation?
!
  nc = hout%gil%nchan
  !
  if (amp_correct) then
     do i=1,nv
        amp = sqrt(din(8,i)**2+din(9,i)**2)
        if (amp.ne.0.) then
           din(8,i) = din(8,i)/amp
           din(9,i) = din(9,i)/amp
        endif
     enddo
  endif
!
! Modify table
!
  do i=1,nv
    do j=1,nc
      ir = hout%gil%fcol+3*(j-1)
      ii = ir+1
      re = din(8,i)*dout(ir,i)-din(9,i)*dout(ii,i)
      im = din(8,i)*dout(ii,i)+din(9,i)*dout(ir,i)
      dout(ir,i) = re
      dout(ii,i) = im
    enddo
  enddo
!
! Write result
!
  call gdf_write_image(hout,dout,error)
  if (gildas_error(hout,rname,error)) return
  deallocate (dout)
end subroutine sub_applyphase

subroutine imbfits_dump_summary(imbf,olun,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_summary
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command:
  !   DUMP SUMMARY
  !---------------------------------------------------------------------
  type(imbfits_t), intent(in)    :: imbf
  integer(kind=4), intent(in)    :: olun   ! Output LUN
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>SUMMARY'
  !
  write(olun,'(A)') '--- Summary ---'
  !
  write(olun,'(A,T25,A)') 'File name:',trim(imbf%file%name)
  !
  write(olun,'(A,T25,A)') 'Source name:',trim(imbf%primary%object%val)
  !
  write(olun,'(A,T25,I0)')  'Scan number:',imbf%scan%head%scannum%val
  !
  call imbfits_dump_summary_seclass(imbf%seclass,olun,error)
  if (error)  return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_summary
!
subroutine imbfits_dump_summary_seclass(seclass,olun,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_summary_seclass
  !---------------------------------------------------------------------
  ! @ private
  ! Loop over all the equivalence classes and give some details about
  ! them
  !---------------------------------------------------------------------
  type(eclass_char_t), intent(in)    :: seclass
  integer(kind=4),     intent(in)    :: olun     ! Output LUN
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>SUMMARY>SECLASS'
  integer(kind=4) :: iclass
  !
  write(olun,'(A,T25,I0)')  'Number of subscans:',seclass%nval
  write(olun,'(A,T25,I0)')  'Number of classes:', seclass%nequ
  !
  do iclass=1,seclass%nequ
    write(olun,'(2X,A,I0,A,T25,A,A,I0,A)')  &
      '#',iclass,':',                       &
      trim(seclass%val(iclass)),            &
      ' (',seclass%cnt(iclass),' subscan(s))'
  enddo
  !
end subroutine imbfits_dump_summary_seclass
!
subroutine imbfits_dump_file(file,olun,error)
  use gbl_message
  use gildas_def
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_file
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>FILE'
  !
  write(olun,'(A)') '--- File ---'
  write(olun,'(A)') 'STATUS'
  write(olun,'(A)') 'UNIT'
  write(olun,'(A)') 'BLOCK'
  write(olun,'(A)') 'NHDU'
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_file
!
subroutine imbfits_dump_subscans(imbf,olun,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_subscans
  !---------------------------------------------------------------------
  ! @ public
  ! Support routine for command:
  !   DUMP SUBSCANS
  ! The subroutine reopens the input file in its own structure to avoid
  ! messing up the global instances
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  integer(kind=4), intent(in)    :: olun   ! Output LUN
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>SUBSCANS'
  !
  call imbfits_read_leadhdus(imbf,error)
  if (error)  return
  !
  call imbfits_check_leadhdus(imbf,error)
  if (error)  return
  !
  write(olun,'(A)') '--- Subscans ---'
  !
  write(olun,'(A,T25,I0,A,I0,A)')  'Number of subscans:',  &
    imbf%primary%n_obs%val,' (',imbf%primary%n_obsp%val,' found)'
  !
  call imbfits_dump_subscans_list(imbf,olun,error)
  if (error)  return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_subscans
!
subroutine imbfits_dump_subscans_list(imbf,olun,error)
  use gildas_def
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_subscans_list
  !---------------------------------------------------------------------
  ! @ private
  ! Loop over all the subscans and give some details about them
  !---------------------------------------------------------------------
  type(imbfits_t), intent(inout) :: imbf
  integer(kind=4), intent(in)    :: olun   ! Output LUN
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>SUBSCANS>LIST'
  integer(kind=4) :: isub
  type(imbfits_subscan_t) :: subs
  !
  do isub=1,imbf%primary%n_obsp%val
    call imbfits_read_subscan_header_bynum(imbf,isub,.false.,.false.,0.d0,subs,error)
    if (error)  exit
    !
    write(olun,'(2X,A,I0,A,T25,A,A,A)')          &
      '#',subs%backdata%head%obsnum%val,':',     &
      trim(subs%antslow%head%obstype%val),', ',  &
      trim(subs%antslow%head%substype%val)
  enddo
  !
  call imbfits_free_subscan_header(subs,error)
  if (error)  return
  !
end subroutine imbfits_dump_subscans_list
!
subroutine imbfits_dump_primary(primary,short,olun,error)
  use gbl_message
  use gildas_def
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_dump_primary
  use imbfits_key_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_primary_t), intent(in)    :: primary
  logical,                 intent(in)    :: short    ! Short or verbose output?
  integer(kind=4),         intent(in)    :: olun     ! Output LUN
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>PRIMARY'
  !
  write(olun,'(A)') '--- Primary HDU ---'
  !
  if (short) then
    write(olun,'(A)')  'Header available'  ! ZZZ improve this
    write(olun,'(1X)')
    return
  endif
  !
  call imbfits_dump_key(primary%simple,olun,error)
  if (error) return
  call imbfits_dump_key(primary%bitpix,olun,error)
  if (error) return
  call imbfits_dump_key(primary%naxis,olun,error)
  if (error) return
  call imbfits_dump_key(primary%extend,olun,error)
  if (error) return
  call imbfits_dump_key(primary%telescop,olun,error)
  if (error) return
  call imbfits_dump_key(primary%origin,olun,error)
  if (error) return
  call imbfits_dump_key(primary%creator,olun,error)
  if (error) return
  call imbfits_dump_key(primary%imbftsve,olun,error)
  if (error) return
  call imbfits_dump_key(primary%instrume,olun,error)
  if (error) return
  call imbfits_dump_key(primary%object,olun,error)
  if (error) return
  call imbfits_dump_key(primary%longobj,olun,error)
  if (error) return
  call imbfits_dump_key(primary%latobj,olun,error)
  if (error) return
  call imbfits_dump_key(primary%timesys,olun,error)
  if (error) return
  call imbfits_dump_key(primary%mjd_obs,olun,error)
  if (error) return
  call imbfits_dump_key(primary%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(primary%lst,olun,error)
  if (error) return
  call imbfits_dump_key(primary%projid,olun,error)
  if (error) return
  call imbfits_dump_key(primary%queue,olun,error)
  if (error) return
  call imbfits_dump_key(primary%exptime,olun,error)
  if (error) return
  call imbfits_dump_key(primary%n_obs,olun,error)
  if (error) return
  call imbfits_dump_key(primary%n_obsp,olun,error)
  if (error) return
  call imbfits_dump_key(primary%obstype,olun,error)
  if (error) return
  call imbfits_dump_key(primary%nusefeed,olun,error)
  if (error) return
  call imbfits_dump_key(primary%totant,olun,error)
  if (error) return
  call imbfits_dump_key(primary%totsubr,olun,error)
  if (error) return
  call imbfits_dump_key(primary%totback,olun,error)
  if (error) return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_primary
!
subroutine imbfits_dump_scan(scan,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_scan
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_scan_t), intent(in)    :: scan
  character(len=*),     intent(in)    :: column  ! Optional column name
  logical,              intent(in)    :: short   ! Short or verbose output?
  integer(kind=4),      intent(in)    :: olun    ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>SCAN'
  !
  write(olun,'(A,A,A)') '--- ',trim(scan%head%desc%extname%val),' HDU ---'
  !
  if (scan%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (scan%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_scan_column(scan,column,olun,error)
    return
  endif
  !
  ! dump header
  call scan%head%desc%dump(olun,error)
  if (error) return
  ! Telescope and site
  call imbfits_dump_key(scan%head%telescop,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%telsize,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%sitelong,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%sitelat,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%siteelev,olun,error)
  if (error) return
  ! Project
  call imbfits_dump_key(scan%head%projid,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%obsid,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%operator,olun,error)
  if (error) return
  ! Scan
  call imbfits_dump_key(scan%head%scannum,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%scandate,olun,error)
  if (error) return
  ! Date and time
  call imbfits_dump_key(scan%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%date,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%mjd,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%lst,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%n_obs,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%exptime,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%timesys,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%ut1utc,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%taiutc,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%etutc,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%gpstai,olun,error)
  if (error) return
  ! Fixed source parameters
  call imbfits_dump_key(scan%head%polex,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%poley,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%object,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%ctype1,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%ctype2,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%radesys,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%equinox,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%crval1,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%crval2,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%lonpole,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%latpole,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%longobj,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%latobj,olun,error)
  if (error) return
  ! Moving source parameters
  ! TBD *** JP
  ! Switch mode
  call imbfits_dump_key(scan%head%swtchmod,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%noswitch,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%phasetim,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%wobthrow,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%wobdir,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%wobcycle,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%wobmode,olun,error)
  if (error) return
  ! Pointing and focus
  call imbfits_dump_key(scan%head%p1cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p2cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p3cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p4cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p5cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p7cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p8cor,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%p9cor,olun,error)
  if (error) return
  !
  call imbfits_dump_key(scan%head%nfebe,olun,error)
  if (error) return
  ! Weather and calibration
  call imbfits_dump_key(scan%head%pressure,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%tambient,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%humidity,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%winddir,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%windvel,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%windvelm,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%date_wea,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%refracti,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%thot,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%date_hot,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%tiptauz,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%tiptauc,olun,error)
  if (error) return
  call imbfits_dump_key(scan%head%date_tip,olun,error)
  if (error) return
  ! dump table
  call imbfits_dump_column(scan%table%sysoff,olun,error)
  if (error)  return
  call imbfits_dump_column(scan%table%xoffset,olun,error)
  if (error)  return
  call imbfits_dump_column(scan%table%yoffset,olun,error)
  if (error)  return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_scan
!
subroutine imbfits_dump_scan_column(scan,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_scan_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_scan_t), intent(in)    :: scan
  character(len=*),     intent(in)    :: column  ! Column name
  integer(kind=4),      intent(in)    :: olun    ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>SCAN>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=3
  character(len=key_length) :: columns(ncol),found
  data columns / 'SYSOFF','XOFFSET','YOFFSET' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('SYSOFF')
    call imbfits_dump_column(scan%table%sysoff,olun,error,full=.true.)
  case('XOFFSET')
    call imbfits_dump_column(scan%table%xoffset,olun,error,full=.true.)
  case('YOFFSET')
    call imbfits_dump_column(scan%table%yoffset,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_scan_column
!
subroutine imbfits_dump_frontend(front,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_frontend
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_front_t), intent(in)    :: front
  character(len=*),      intent(in)    :: column  ! Optional column name
  logical,               intent(in)    :: short   ! Short or verbose output?
  integer(kind=4),       intent(in)    :: olun    ! Output LUN
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>FRONTEND'
  !
  write(olun,'(A,A,A)') '--- ',trim(front%head%desc%extname%val),' HDU ---'
  !
  if (front%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (front%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_frontend_column(front,column,olun,error)
    return
  endif
  !
  ! Read header
  call front%head%desc%dump(olun,error)
  if (error) return
  call imbfits_dump_key(front%head%scannum,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%dewrtmod,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%dewang,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%febeband,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%febefeed,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%nusefeed,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%velosys,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%specsys,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%veloconv,olun,error)
  if (error) return
  call imbfits_dump_key(front%head%emirbeam,olun,error)
  if (error) return
  ! Read table
  ! Frequency axis
  call imbfits_dump_column(front%table%recname,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%linename,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%restfreq,olun,error)
  if (error) return
  ! Calibration
  call imbfits_dump_column(front%table%beameff,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%etafss,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%gainimag,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%sideband,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%sbsep,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%widenar,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%tcold,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%thot,olun,error)
  if (error) return
  ! Pixel description
  call imbfits_dump_column(front%table%ifeed,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%nofeeds,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%pola,olun,error)
  if (error) return
  ! Frequency axis
  call imbfits_dump_column(front%table%doppler,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%ifcenter,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%bandwid,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%ifflipps,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%speclo,olun,error)
  if (error) return
  ! Brightness axis
  call imbfits_dump_column(front%table%tscale,olun,error)
  if (error) return
  ! Frequency switching
  call imbfits_dump_column(front%table%frqthrow,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%frqoff1,olun,error)
  if (error) return
  call imbfits_dump_column(front%table%frqoff2,olun,error)
  if (error) return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_frontend
!
subroutine imbfits_dump_frontend_column(front,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_frontend_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_front_t), intent(in)    :: front
  character(len=*),      intent(in)    :: column  ! Column name
  integer(kind=4),       intent(in)    :: olun    ! Output LUN
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>FRONT>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=23
  character(len=key_length) :: columns(ncol),found
  data columns / 'RECNAME','LINENAME','RESTFREQ','BEAMEFF','ETAFSS',           &
    'GAINIMAG','SIDEBAND','SBSEP','WIDENAR','TCOLD','THOT','IFEED','NOFEEDS',  &
    'POLA','DOPPLER','IFCENTER','BANDWID','IFFLIPPS','SPECLO','TSCALE',        &
    'FRQTHROW','FRQOFF1','FRQOFF2' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('RECNAME')
    call imbfits_dump_column(front%table%recname,olun,error,full=.true.)
  case('LINENAME')
    call imbfits_dump_column(front%table%linename,olun,error,full=.true.)
  case('RESTFREQ')
    call imbfits_dump_column(front%table%restfreq,olun,error,full=.true.)
  case('BEAMEFF')
    call imbfits_dump_column(front%table%beameff,olun,error,full=.true.)
  case('ETAFSS')
    call imbfits_dump_column(front%table%etafss,olun,error,full=.true.)
  case('GAINIMAG')
    call imbfits_dump_column(front%table%gainimag,olun,error,full=.true.)
  case('SIDEBAND')
    call imbfits_dump_column(front%table%sideband,olun,error,full=.true.)
  case('SBSEP')
    call imbfits_dump_column(front%table%sbsep,olun,error,full=.true.)
  case('WIDENAR')
    call imbfits_dump_column(front%table%widenar,olun,error,full=.true.)
  case('TCOLD')
    call imbfits_dump_column(front%table%tcold,olun,error,full=.true.)
  case('THOT')
    call imbfits_dump_column(front%table%thot,olun,error,full=.true.)
  case('IFEED')
    call imbfits_dump_column(front%table%ifeed,olun,error,full=.true.)
  case('NOFEEDS')
    call imbfits_dump_column(front%table%nofeeds,olun,error,full=.true.)
  case('POLA')
    call imbfits_dump_column(front%table%pola,olun,error,full=.true.)
  case('DOPPLER')
    call imbfits_dump_column(front%table%doppler,olun,error,full=.true.)
  case('IFCENTER')
    call imbfits_dump_column(front%table%ifcenter,olun,error,full=.true.)
  case('BANDWID')
    call imbfits_dump_column(front%table%bandwid,olun,error,full=.true.)
  case('IFFLIPPS')
    call imbfits_dump_column(front%table%ifflipps,olun,error,full=.true.)
  case('SPECLO')
    call imbfits_dump_column(front%table%speclo,olun,error,full=.true.)
  case('TSCALE')
    call imbfits_dump_column(front%table%tscale,olun,error,full=.true.)
  case('FRQTHROW')
    call imbfits_dump_column(front%table%frqthrow,olun,error,full=.true.)
  case('FRQOFF1')
    call imbfits_dump_column(front%table%frqoff1,olun,error,full=.true.)
  case('FRQOFF2')
    call imbfits_dump_column(front%table%frqoff2,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_frontend_column
!
subroutine imbfits_dump_backend(back,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_backend
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_back_t), intent(in)    :: back
  character(len=*),     intent(in)    :: column  ! Optional column name
  logical,              intent(in)    :: short   ! Short or verbose output?
  integer(kind=4),      intent(in)    :: olun    ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>BACKEND'
  !
  write(olun,'(A,A,A)') '--- ',trim(back%head%desc%extname%val),' HDU ---'
  !
  if (back%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (back%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_backend_column(back,column,olun,error)
    return
  endif
  !
  call back%head%desc%dump(olun,error)
  if (error) return
  !
  call imbfits_dump_key(back%head%scannum,olun,error)
  if (error) return
  call imbfits_dump_key(back%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(back%head%febeband,olun,error)
  if (error) return
  call imbfits_dump_key(back%head%febefeed,olun,error)
  if (error) return
  call imbfits_dump_key(back%head%nusefeed,olun,error)
  if (error) return
  !
  call imbfits_dump_column(back%table%part,olun,error)
  if (error) return
  call imbfits_dump_column(back%table%refchan,olun,error)
  if (error) return
  call imbfits_dump_column(back%table%chans,olun,error)
  if (error) return
  call imbfits_dump_column(back%table%dropped,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%used,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%receiver,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%ifront,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%band,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%frontend,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%polar,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%pixel,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%reffreq,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%spacing,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%dataflip,olun,error)
  if (error)  return
  call imbfits_dump_column(back%table%linename,olun,error)
  if (error)  return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_backend
!
subroutine imbfits_dump_backend_column(back,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_backend_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_back_t), intent(in)    :: back
  character(len=*),     intent(in)    :: column  ! Column name
  integer(kind=4),      intent(in)    :: olun    ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>BACK>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=15
  character(len=key_length) :: columns(ncol),found
  data columns / 'PART','REFCHAN','CHANS','DROPPED','USED','PIXEL',     &
    'RECEIVER','IFRONT','BAND','FRONTEND','POLAR','REFFREQ','SPACING',  &
    'DATAFLIP','LINENAME' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('PART')
    call imbfits_dump_column(back%table%part,olun,error,full=.true.)
  case('REFCHAN')
    call imbfits_dump_column(back%table%refchan,olun,error,full=.true.)
  case('CHANS')
    call imbfits_dump_column(back%table%chans,olun,error,full=.true.)
  case('DROPPED')
    call imbfits_dump_column(back%table%dropped,olun,error,full=.true.)
  case('USED')
    call imbfits_dump_column(back%table%used,olun,error,full=.true.)
  case('PIXEL')
    call imbfits_dump_column(back%table%pixel,olun,error,full=.true.)
  case('RECEIVER')
    call imbfits_dump_column(back%table%receiver,olun,error,full=.true.)
  case('IFRONT')
    call imbfits_dump_column(back%table%ifront,olun,error,full=.true.)
  case('BAND')
    call imbfits_dump_column(back%table%band,olun,error,full=.true.)
  case('FRONTEND')
    call imbfits_dump_column(back%table%frontend,olun,error,full=.true.)
  case('POLAR')
    call imbfits_dump_column(back%table%polar,olun,error,full=.true.)
  case('REFFREQ')
    call imbfits_dump_column(back%table%reffreq,olun,error,full=.true.)
  case('SPACING')
    call imbfits_dump_column(back%table%spacing,olun,error,full=.true.)
  case('DATAFLIP')
    call imbfits_dump_column(back%table%dataflip,olun,error,full=.true.)
  case('LINENAME')
    call imbfits_dump_column(back%table%linename,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_backend_column
!
subroutine imbfits_dump_antslow(isub,antslow,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_antslow
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4),         intent(in)    :: isub     ! Subscan number
  type(imbfits_antslow_t), intent(in)    :: antslow
  character(len=*),        intent(in)    :: column   ! Optional column name
  logical,                 intent(in)    :: short    ! Short or verbose output?
  integer(kind=4),         intent(in)    :: olun     ! Output LUN
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>ANTSLOW'
  !
  write(olun,'(A,A,A,I0,A)') '--- ',trim(antslow%head%desc%extname%val),  &
    ' (slow) HDU, subscan #',isub,' ---'
  !
  if (antslow%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (antslow%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_antslow_column(antslow,column,olun,error)
    return
  endif
  !
  ! Header
  call antslow%head%desc%dump(olun,error)
  if (error) return
  !
  call imbfits_dump_key(antslow%head%scannum,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%obsnum,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%mjd_beg,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%date_end,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%mjd_end,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%obstype,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%substype,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%substime,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%systemof,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%subsxoff,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%subsyoff,olun,error)
  if (error) return
  !
  call imbfits_dump_key(antslow%head%setype01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%setime01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%sexoff01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%seyoff01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%sexsta01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%seysta01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%sexend01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%seyend01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%sespes01,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%sespee01,olun,error)
  if (error) return
  !
  call imbfits_dump_key(antslow%head%dopplerc,olun,error)
  if (error) return
  call imbfits_dump_key(antslow%head%obsvelrf,olun,error)
  if (error) return
  !
  ! Table
  call imbfits_dump_column(antslow%table%mjd,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%lst,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%longoff,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%latoff,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%cazimuth,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%celevatio,olun,error)
  if (error) return
  call imbfits_dump_column(antslow%table%traceflag,olun,error)
  if (error) return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_antslow
!
subroutine imbfits_dump_antslow_column(antslow,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_antslow_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_antslow_t), intent(in)    :: antslow
  character(len=*),        intent(in)    :: column   ! Column name
  integer(kind=4),         intent(in)    :: olun     ! Output LUN
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>ANTSLOW>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=7
  character(len=key_length) :: columns(ncol),found
  data columns / 'MJD','LST','LONGOFF','LATOFF','CAZIMUTH','CELEVATIO',  &
    'TRACEFLAG' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('MJD')
    call imbfits_dump_column(antslow%table%mjd,olun,error,full=.true.)
  case('LST')
    call imbfits_dump_column(antslow%table%lst,olun,error,full=.true.)
  case('LONGOFF')
    call imbfits_dump_column(antslow%table%longoff,olun,error,full=.true.)
  case('LATOFF')
    call imbfits_dump_column(antslow%table%latoff,olun,error,full=.true.)
  case('CAZIMUTH')
    call imbfits_dump_column(antslow%table%cazimuth,olun,error,full=.true.)
  case('CELEVATIO')
    call imbfits_dump_column(antslow%table%celevatio,olun,error,full=.true.)
  case('TRACEFLAG')
    call imbfits_dump_column(antslow%table%traceflag,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_antslow_column
!
subroutine imbfits_dump_antfast(isub,antfast,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_antfast
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4),         intent(in)    :: isub     ! Subscan number
  type(imbfits_antfast_t), intent(in)    :: antfast
  character(len=*),        intent(in)    :: column   ! Optional column name
  logical,                 intent(in)    :: short    ! Short or verbose output?
  integer(kind=4),         intent(in)    :: olun     ! Output LUN
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>ANTFAST'
  !
  write(olun,'(A,A,A,I0,A)') '--- ',trim(antfast%head%desc%extname%val),  &
    ' (fast) HDU, subscan #',isub,' ---'
  !
  if (antfast%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (antfast%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_antfast_column(antfast,column,olun,error)
    return
  endif
  !
  ! Header
  call antfast%head%desc%dump(olun,error)
  if (error) return
  call imbfits_dump_key(antfast%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(antfast%head%mjd_beg,olun,error)
  if (error) return
  call imbfits_dump_key(antfast%head%date_end,olun,error)
  if (error) return
  call imbfits_dump_key(antfast%head%mjd_end,olun,error)
  if (error) return
  call imbfits_dump_key(antfast%head%tracerat,olun,error)
  if (error) return
  !
  ! Table
  call imbfits_dump_column(antfast%table%mjd,olun,error)
  if (error) return
  call imbfits_dump_column(antfast%table%azimuth,olun,error)
  if (error) return
  call imbfits_dump_column(antfast%table%elevation,olun,error)
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_antfast
!
subroutine imbfits_dump_antfast_column(antfast,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_antfast_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_antfast_t), intent(in)    :: antfast
  character(len=*),        intent(in)    :: column   ! Column name
  integer(kind=4),         intent(in)    :: olun     ! Output LUN
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>ANTFAST>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=3
  character(len=key_length) :: columns(ncol),found
  data columns / 'MJDFAST','AZIMUTH','ELEVATION' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('MJDFAST')
    call imbfits_dump_column(antfast%table%mjd,olun,error,full=.true.)
  case('AZIMUTH')
    call imbfits_dump_column(antfast%table%azimuth,olun,error,full=.true.)
  case('ELEVATION')
    call imbfits_dump_column(antfast%table%elevation,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_antfast_column
!
subroutine imbfits_dump_derot(derot,column,short,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_derot
  use imbfits_key_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_derot_t), intent(in)    :: derot
  character(len=*),      intent(in)    :: column   ! Optional column name
  logical,               intent(in)    :: short    ! Short or verbose output?
  integer(kind=4),       intent(in)    :: olun     ! Output LUN
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>DEROT'
  !
  write(olun,'(A,A,A)') '--- ',trim(derot%head%desc%extname%val),' HDU ---'
  !
  if (derot%head%desc%status.eq.code_imbfits_init) then
    write(olun,'(A)')  'WARNING! Header not available'
    write(olun,'(1X)')
    return
  elseif (derot%head%desc%status.eq.code_imbfits_started) then
    write(olun,'(A)')  'WARNING! Header reading was incomplete'
  elseif (short) then
    write(olun,'(A)')  'Header available'
    write(olun,'(1X)')
    return
  elseif (column.ne.'') then
    call imbfits_dump_derot_column(derot,column,olun,error)
    return
  endif
  !
  ! Header
  call derot%head%desc%dump(olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%scannum,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%obsnum,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%date_obs,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%mjd_beg,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%date_end,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%mjd_end,olun,error)
  if (error) return
  call imbfits_dump_key(derot%head%substime,olun,error)
  if (error) return
  !
  ! Table
  call imbfits_dump_column(derot%table%mjd,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%system,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%fwant,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%hwant,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%swant,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%fact,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%hact,olun,error)
  if (error) return
  call imbfits_dump_column(derot%table%sact,olun,error)
  if (error) return
  !
  write(olun,'(1X)')
  !
end subroutine imbfits_dump_derot
!
subroutine imbfits_dump_derot_column(derot,column,olun,error)
  use imbfits_interfaces, except_this=>imbfits_dump_derot_column
  use imbfits_parameters
  use imbfits_types
  use imbfits_column_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_derot_t), intent(in)    :: derot
  character(len=*),      intent(in)    :: column   ! Column name
  integer(kind=4),       intent(in)    :: olun     ! Output LUN
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DUMP>DEROT>COLUMN'
  integer(kind=4) :: ifound
  integer(kind=4), parameter :: ncol=8
  character(len=key_length) :: columns(ncol),found
  data columns / 'MJD','SYSTEM','FWANT','HWANT','SWANT','FACT','HACT','SACT' /
  !
  call sic_ambigs(rname,column,found,ifound,columns,ncol,error)
  if (error) return
  !
  select case (found)
  case('MJD')
    call imbfits_dump_column(derot%table%mjd,olun,error,full=.true.)
  case('SYSTEM')
    call imbfits_dump_column(derot%table%system,olun,error,full=.true.)
  case('FWANT')
    call imbfits_dump_column(derot%table%fwant,olun,error,full=.true.)
  case('HWANT')
    call imbfits_dump_column(derot%table%hwant,olun,error,full=.true.)
  case('SWANT')
    call imbfits_dump_column(derot%table%swant,olun,error,full=.true.)
  case('FACT')
    call imbfits_dump_column(derot%table%fact,olun,error,full=.true.)
  case('HACT')
    call imbfits_dump_column(derot%table%hact,olun,error,full=.true.)
  case('SACT')
    call imbfits_dump_column(derot%table%sact,olun,error,full=.true.)
  end select
  !
end subroutine imbfits_dump_derot_column

program grid_extend
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! TASK  Compute a map from a Sorted Table by Gridding .
  !
  ! Input :
  !	a sorted table, ordered with Y increasing.
  ! Output :
  !	a VLM cube
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: pname = 'GRID_EXTEND'
  real :: ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  !
  ! Local
  type(gildas) :: x,y
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(8), parameter :: pi=3.14159265358979323846d0
  integer :: nx,ny,nc,np,nd,nxmore,nymore
  integer :: ctypx,ctypy, i, ier
  real(4), allocatable :: ipxc(:), ipyc(:)
  real(4), allocatable :: ipw(:), ipra(:,:,:), ipwe(:)
  integer :: xcol,ycol,mcol(2),ocol,lcol,wcol
  real(8) :: xconv(3),yconv(3)
  real :: xmin,xmax,ymin,ymax,xinc,yinc,tole,beam,smooth
  real :: xparm(10),yparm(10),support(2),cell(2),space
  real :: wmax
  logical :: error
  character(len=80) :: table, map_name, name
  character(len=2) :: weight_mode
  character(len=12) :: ctype(5)
  data ctype /'BOX','EXP','SINC','EXP*SINC','SPHEROIDAL'/
  !------------------------------------------------------------------------
  ! Code:
  xconv = 0.d0
  yconv = 0.d0
  call gildas_open
  call gildas_char('TABLE$',table)
  call gildas_char('MAP$',map_name)
  call gildas_inte('XCOL$',xcol,1)
  call gildas_inte('YCOL$',ycol,1)
  call gildas_inte('WCOL$',wcol,1)
  call gildas_inte('MCOL$',mcol,2)
  call gildas_char('WEIGHT_MODE$',weight_mode)
  call gildas_real('TOLE$',tole,1)
  call gildas_real('BEAM$',beam,1)
  call gildas_real('SPACING$',space,1)
  call gildas_close
  xconv(3) = -space
  yconv(3) =  space
  !
  ! Input file
  call gildas_null(y)
  y%loca%read = .false.
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,table,'.tab',error,rank=0,data=.true.)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 999
  endif
  if (xcol.gt.y%gil%dim(1) .or. ycol.gt.y%gil%dim(1)) then
    write(6,*) 'F-'//pname//',  X or Y column does not exist'
    goto 999
  endif
  nd = y%gil%dim(1)
  np = y%gil%dim(2)
  !
  ! Check order
  allocate (ipw(max(nd,np)), stat=ier)
  if (ier.ne.0) goto 999
  call dosor (y%r1d,nd,np,ipw,ycol)
  !
  ! Compute weights
  call dowei (y%r1d,nd,np,ipw,wcol) 
  !
  ! Compute extrema
  call finsiz (y%r1d,nd,np,xcol,ycol,ipw,   &
     &    xmin,xmax,ymin,ymax)
  !
  ! Find increment if required
  if (xconv(3).eq.0 .or. yconv(3).eq.0) then
    xinc = xmax-xmin
    yinc = ymax-ymin
    call fininc (y%r1d,nd,np,xcol,ycol,ipw,   &
     &      xinc,yinc,tole)
    if (xconv(3).eq.0) xconv(3) = -xinc
    if (yconv(3).eq.0) yconv(3) = +yinc
  endif
  !
  ! Find size
  nx = nint ( (xmax-xmin)/abs(xconv(3))) + 1
  ny = nint ( (ymax-ymin)/abs(yconv(3))) + 1
  nxmore = nint(3*beam/abs(xconv(3)))+1
  nx = nx+2*nxmore
  nymore = nint(3*beam/abs(yconv(3)))+1
  ny = ny+2*nymore
  !
  ! Extend to nearest power of two
  i = 4
  do while(2**i.lt.nx)
    i = i+1
  enddo
  nx = 2**i
  i = 4
  do while(2**i.lt.ny)
    i = i+1
  enddo
  ny = 2**i
  xconv(1) = nx/2+1-(xmin+xmax)/2/xconv(3)
  xconv(2) = 0.0
  yconv(1) = ny/2+1-(ymin+ymax)/2/yconv(3)
  yconv(2) = 0.0
  !
  write(6,*) 'Creating a cube with ',nx,' by ',ny,' pixels'
  write(6,*) 'Increment ',nint(yconv(3)*180*3600/pi)
  !
  ! Warn for big images
  if (nx.gt.4096 .or. ny.ge.4096) then
    write(6,*) 'W-'//pname//',  More than 4096 pixels in X or Y'
    goto 999
  elseif (nx.gt.512 .or. ny.gt.512) then
    write(6,*) 'W-'//pname//',  More than 512 pixels in X or Y'
  endif
  if (mcol(2).eq.0) mcol(2) = nd
  mcol(1) = max(1,min(mcol(1),nd))
  mcol(2) = max(1,min(mcol(2),nd))
  ocol = min(mcol(1),mcol(2))-1
  lcol = max(mcol(1),mcol(2))
  !
  ! Push in stack
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  nc = lcol-ocol
  write(6,*) ' Creating ',nc,' Channels from ',mcol
  !
  ! Compute gridding function
  smooth = beam/4.0
  ctypx = 2
  ctypy = 2
  support(1) = 5*smooth        ! Go far enough...
  support(2) = 5*smooth
  xparm(1) = support(1)/abs(xconv(3))
  yparm(1) = support(2)/abs(yconv(3))
  xparm(2) = smooth/(2*sqrt(log(2.0)))/abs(xconv(3))
  yparm(2) = smooth/(2*sqrt(log(2.0)))/abs(yconv(3))
  xparm(3) = 2
  yparm(3) = 2
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  cell(1) = xconv(3)
  cell(2) = yconv(3)
  !
  ! Create image (in order v l m )
  name = map_name
  call sic_parsef(name,x%file,' ','.vlm')
  write(6,*) 'I-'//pname//',  Creating map file '//trim(x%file)
  x%gil%ndim = 3
  x%gil%dim(1) = nc
  x%gil%dim(2) = nx
  x%gil%dim(3) = ny
  x%gil%dim(4) = 1
  x%gil%ref(1) = y%gil%ref(1)-ocol
  x%gil%val(1) = x%gil%voff
  x%gil%inc(1) = x%gil%vres
  x%gil%convert(:,2) = xconv
  x%gil%convert(:,3) = yconv
  x%gil%coor_words = 6*gdf_maxdims ! Not a table
  x%gil%extr_words = 0             ! extrema not computed
  x%gil%xaxi = 2                   ! Reset projected axis
  x%gil%yaxi = 3                   !
  !
  !
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-'//pname//',  Cannot create output LMV image')
    goto 999
  endif
  !
  ! Convolve or grid
  allocate (ipxc(nx), ipyc(ny), x%r3d(nc,nx,ny), stat=ier)
  if (ier.ne.0) goto 999
  call docoor (nx,x%gil%ref(2),x%gil%val(2),x%gil%inc(2),ipxc)
  call docoor (ny,x%gil%ref(3),x%gil%val(3),x%gil%inc(3),ipyc)
  !
  ! Get the workspace for intermediate smoothing
  allocate (ipra(nc,nx,ny), ipwe(nx*ny), stat=ier)
  if (ier.ne.0) goto 999
  !
  call doconv (     &
     &    nd,np,    &     ! Number of input points
     &    y%r1d,    &     ! Input Values
     &    xcol,ycol,ocol,   &  ! Pointers to special values
     &    ipw,      &     ! Weights
     &    ipwe,     &     ! Gridded weights
     &    nc,nx,ny, &     ! Cube size
     &    ipra,     &     ! RAW Cube
     &    ipxc,ipyc,&     ! Cube coordinates
     &    support,cell)
  write(6,*) 'I-'//pname//',  Finished gridding'
  !
  ! Compute smoothing function
  ctypx = 2
  ctypy = 2
  xparm(1) = 3*beam/abs(xconv(3))
  yparm(1) = 3*beam/abs(yconv(3))
  xparm(2) = beam/(2*sqrt(log(2.0)))/abs(xconv(3))
  yparm(2) = beam/(2*sqrt(log(2.0)))/abs(yconv(3))
  xparm(3) = 2
  yparm(3) = 2
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  support(1) = 3*beam
  support(2) = 3*beam
  cell(1) = xconv(3)
  cell(2) = yconv(3)
  !
  ! Free input grid and Create output map
  deallocate(y%r1d)
  !
  allocate (x%r3d(nc,nx,ny), stat=ier)
  if (ier.ne.0) goto 999
  !
  ! Smooth
  write(6,*) 'I-'//pname//',  Starting smoothing'
  call dosmoo (     &
     &    ipra,     &    ! RAW gridded Values
     &    ipwe,     &    ! Gridded weights
     &    nc,nx,ny, &        ! Cube size
     &    x%r3d,    &     ! Smoothed Cube
     &    ipxc,ipyc,&   ! Cube coordinates
     &    support,cell)
  write(6,*) 'I-'//pname//',  Finished smoothing'
  !
  ! Get maximum weight
  wmax = maxval (ipwe) 
  !
  ! Multiply by the gaussian truncation and replace by "raw" map.
  call doapod (xmin,xmax,ymin,ymax,tole,beam,   &
     &    nc,nx,ny,x%r1d,ipra,   &
     &    ipxc,ipyc,   &   ! Cube coordinates
     &    ipwe,wmax)
  write(6,*) 'I-'//pname//',  Finished apodizing'
  !
  call gdf_write_data(x,x%r3d,error)
  if (error) goto 999
  call gagout('S-'//pname//',  Successful completion')
  call sysexi(1)
  !
999 call sysexi (fatale)
end program grid_extend
!
subroutine docoor (n,xref,xval,xinc,x)
  integer :: n                      !
  real*8 :: xref                    !
  real*8 :: xval                    !
  real*8 :: xinc                    !
  real :: x(n)                      !
  ! Local
  integer :: i
  do i=1,n
    x(i) = (dble(i)-xref)*xinc+xval
  enddo
end subroutine docoor
!
subroutine doconv (nd,np,visi,jx,jy,jo,we,gwe,   &
     &    nc,nx,ny,map,mapx,mapy,sup,cell)
  integer :: nd                     ! Number of "visibilities"
  integer :: np                     ! number of values
  real :: visi(nd,np)               ! values
  integer :: jx                     ! X coord, Y coord location in VISI
  integer :: jy                     ! X coord, Y coord location in VISI
  integer :: jo                     ! offset for data in VISI
  real :: we(np)                    ! Weights
  integer :: nx                     ! map size
  integer :: ny                     ! map size
  real :: gwe(nx,ny)                ! gridded weights
  integer :: nc                     ! number of channels
  real :: map(nc,nx,ny)             ! gridded values
  real :: mapx(nx)                  ! Coordinates of grid
  real :: mapy(ny)                  ! Coordinates of grid
  real :: sup(2)                    ! Support of convolving function in User Units
  real :: cell(2)                   ! cell size in User Units
  ! Local
  integer :: ifirs,ilast          ! Range to be considered
  integer :: ix,iy,ic,i
  real :: result,weight
  real :: u,v,du,dv,um,up,vm,vp
  !
  ! Loop on Y rows
  ifirs = 1
  do iy=1,ny
    v = mapy(iy)
    vm = v-sup(2)
    vp = v+sup(2)
    !
    ! Optimized dichotomic search, taking into account the fact that
    !	MAPY is an ordered array
    !
    call findr (np,nd,jy,visi,vm,ifirs)
    ilast = ifirs
    call findr (np,nd,jy,visi,vp,ilast)
    ilast = ilast-1
    !
    ! Initialize X column
    do ix=1,nx
      do ic=1,nc
        map(ic,ix,iy) = 0.0
      enddo
    enddo
    do ix=1,nx
      gwe(ix,iy) = 0.0
    enddo
    !
    ! Loop on X cells
    if (ilast.ge.ifirs) then
      do ix=1,nx
        u = mapx(ix)
        um = u-sup(1)
        up = u+sup(1)
        weight = 0.0
        !
        ! Do while in X cell
        do i=ifirs,ilast
          if (visi(jx,i).ge.um .and. visi(jx,i).le.up) then
            du = (u-visi(jx,i))/cell(1)
            dv = (v-visi(jy,i))/cell(2)
            call convol (du,dv,result)
            if (result.ne.0.) then
              result = result*we(i)
              weight = weight + result
              do ic=1,nc
                map (ic,ix,iy) = map (ic,ix,iy) +   &
     &                  visi(ic+jo,i)*result
              enddo
            endif
          endif
        enddo
        !
        ! Normalize weight only in cells where some data exists...
        gwe(ix,iy) = weight
        if (weight.ne.0) then
          weight = 1.0/weight
          do ic=1,nc
            map (ic,ix,iy) = map(ic,ix,iy)*weight
          enddo
        endif
      enddo
    endif
  enddo
end subroutine doconv
!
subroutine dosmoo (raw,we,nc,nx,ny,map,mapx,mapy,sup,cell)
  !---------------------------------------------------------------------
  ! Smooth an input data cube in VLM along L and M by convolution
  ! by a gaussian...
  !---------------------------------------------------------------------
  integer :: nc                     ! map size
  integer :: nx                     ! map size
  integer :: ny                     ! map size
  real :: raw(nc,nx,ny)             ! Raw map
  real :: we(nx,ny)                 ! Weights
  real :: map(nc,nx,ny)             ! Smoothed map
  real :: mapx(nx)                  ! Coordinates of grid
  real :: mapy(ny)                  ! Coordinates of grid
  real :: sup(2)                    ! Support of convolving function in User Units
  real :: cell(2)                   ! cell size in User Units
  ! Local
  integer :: yfirs,ylast          ! Range to be considered
  integer :: xfirs,xlast          ! Range to be considered
  integer :: ix,iy,ic
  integer :: jx,jy                ! X coord, Y coord location in RAW
  real :: result,weight
  real :: u,v,du,dv,dx,dy
  !
  dx = abs(mapx(2)-mapx(1))
  dy = abs(mapy(2)-mapy(1))
  !
  ! Loop on Y rows
  do iy=1,ny
    v = mapy(iy)
    yfirs = max(1,nint((iy-sup(2)/dy)))
    ylast = min(ny,nint((iy+sup(2)/dy)))
    !
    ! Initialize X column
    do ix=1,nx
      do ic=1,nc
        map(ic,ix,iy) = 0.0
      enddo
    enddo
    !
    ! Loop on X cells
    if (yfirs.le.ylast) then
      do ix=1,nx
        u = mapx(ix)
        weight = 0.0
        xfirs = max(1,nint(ix-sup(1)/dx))
        xlast = min(nx,nint(ix+sup(1)/dx))
        !
        ! Do while in X cell
        if (xfirs.le.xlast) then
          do jy=yfirs,ylast
            dv = (v-mapy(jy))/cell(2)
            do jx=xfirs,xlast
              du = (u-mapx(jx))/cell(1)
              call convol (du,dv,result)
              ! No weight normalization
              !                       result = result*we(jx,jy)
              if (result.ne.0.0) then
                weight = weight + result
                do ic=1,nc
                  map (ic,ix,iy) = map (ic,ix,iy) +   &
     &                    raw(ic,jx,jy)*result
                enddo
              endif
            enddo
          enddo
          !
          ! Normalize weight only in cells where some data exists...
          if (weight.ne.0) then
            weight = 1.0/weight
            do ic=1,nc
              map (ic,ix,iy) = map(ic,ix,iy)*weight
            enddo
          endif
        endif
      enddo
    endif
  enddo
end subroutine dosmoo
!
subroutine dowei (visi,nd,np,we,iw)
  integer :: nd                     !
  integer :: np                     !
  real :: visi(nd,np)               !
  real :: we(np)                    !
  integer :: iw                     !
  ! Local
  integer :: i
  if (iw.le.0 .or. iw.gt.nd) then
    do i=1,np
      we(i) = 1.0
    enddo
  else
    do i=1,np
      we(i) = visi(iw,i)
    enddo
  endif
end subroutine dowei
!
subroutine findr (nv,nc,ic,xx,xlim,nlim)
  !---------------------------------------------------------------------
  ! GILDAS	Internal routine
  !	Find NLIM such as
  !	 	XX(IC,NLIM-1) < XLIM < XX(IC,NLIM)
  !	for input data ordered, retrieved from memory
  !	Assumes NLIM already preset so that XX(IC,NLIM-1) < XLIM
  !---------------------------------------------------------------------
  integer :: nv                     !
  integer :: nc                     !
  integer :: ic                     !
  real :: xx(nc,nv)                 !
  real :: xlim                      !
  integer :: nlim                   !
  ! Local
  integer :: ninf,nsup,nmid
  !
  if (nlim.gt.nv) return
  if (xx(ic,nlim).gt.xlim) then
    return
  elseif (xx(ic,nv).lt.xlim) then
    nlim = nv+1
    return
  endif
  !
  ninf = nlim
  nsup = nv
  do while(nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (xx(ic,nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end subroutine findr
!
subroutine convol (du,dv,resu)
  real :: du                        !
  real :: dv                        !
  real :: resu                      !
  ! Local
  real :: ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  integer :: iu,iv
  !
  iu = nint(100.0*du+ubias)
  iv = nint(100.0*dv+vbias)
  resu = ubuff(iu)*vbuff(iv)
  if (resu.lt.1e-10) resu = 0.0
end subroutine convol
!
subroutine convfn (type, parm, buffer, bias)
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! 	CONVFN computes the convolving functions and stores them in
  !   	the supplied buffer. Values are tabulated every 1/100 cell.
  ! Arguments :
  !	TYPE		I*4	Convolving function type
  ! 	PARM(10)        R*4  	Convolving function parameters.
  !				PARM(1) = radius of support in cells
  !	BUFFER(4096)	R*4  	Work buffer.
  !	BIAS		R*4	Center of convolution
  !---------------------------------------------------------------------
  integer :: type                   !
  real*4 ::  parm(10)               !
  real*4 ::  buffer(4096)           !
  real*4 ::  bias                   !
  ! Local
  integer :: lim, i, im, ialf, ier, ibias
  real*4 ::  pi, p1, p2, u, umax, absu, eta, psi
  data pi /3.1415926536/
  !
  ! Number of rows
  i = max (parm(1) , 1.0)
  i = i * 2 + 1
  lim = i * 100 + 1
  if (lim.gt.1.5*4096) then
    write(6,*) 'E-GRID,  Work buffer insufficient ',lim
    call sysexi(fatale)
  elseif (lim.gt.4096) then
    lim = 4096
    bias = 2049
  else
    bias = 50.0 * i + 1.0
  endif
  umax = parm(1)
  !                                       Check function types.
  goto (100,200,300,400,500) type
  !
  ! Type defaulted or not implemented, use Default = EXP * SINC
  type = 4
  parm(1) = 3.0
  parm(2) = 1.55
  parm(3) = 2.52
  parm(4) = 2.00
  goto 400
  !
  ! Pill box
100 continue
  do i = 1,lim
    u = (i-bias) * 0.01
    absu = abs (u)
    if (absu.lt.umax) then
      buffer(i) = 1.0
    elseif (absu.eq.umax) then
      buffer(i) = 0.5
    else
      buffer(i) = 0.0
    endif
  enddo
  return
  !
  ! Exponential function.
200 continue
  p1 = 1.0 / parm(2)
  do i = 1,lim
    u = (i-bias) * 0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    else
      buffer(i) = exp (-((p1*absu) ** parm(3)))
    endif
  enddo
  return
  !
  ! Sinc function.
300 continue
  p1 = pi / parm(2)
  do i = 1,lim
    u = (i-bias)*0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    elseif (absu.eq.0.0) then
      buffer(i) = 1.0
    else
      buffer(i) = sin (p1*absu) / (p1*absu)
    endif
  enddo
  return
  !
  ! EXP * SINC convolving function
400 continue
  p1 = pi / parm(2)
  p2 = 1.0 / parm(3)
  do i = 1,lim
    ! Cannot see why different from others ?
    !	    u = (i - lim/2 - 1) * 0.01
    u = (i-bias)*0.01
    absu = abs (u)
    if (absu.gt.umax) then
      buffer(i) = 0.0
    elseif (absu.lt.0.01) then
      buffer(i) = 1.0
    else
      buffer(i) = sin(u*p1) / (u*p1) *   &
     &        exp (-((absu * p2) ** parm(4)))
    endif
  enddo
  return
  !
500 continue
  do i = 1,lim
    buffer(i) = 0.0
  enddo
  ialf = 2.0 * parm(2) + 1.1
  im = 2.0 * parm(1) + 0.1
  ialf = max (1, min (5, ialf))
  im = max (4, min (8, im))
  lim = parm(1) * 100.0 + 0.1
  ibias = bias
  do i = 1,lim
    eta = float (i-1) / float (lim-1)
    call sphfn (ialf, im, 0, eta, psi, ier)
    buffer(ibias+i-1) = psi
  enddo
  lim = ibias-1
  do i = 1,lim
    buffer(ibias-i) = buffer(ibias+i)
  enddo
  return
  !
end subroutine convfn
!
subroutine sphfn (ialf, im, iflag, eta, psi, ier)
  !---------------------------------------------------------------------
  !     SPHFN is a subroutine to evaluate rational approximations to se-
  !  lected zero-order spheroidal functions, psi(c,eta), which are, in a
  !  sense defined in VLA Scientific Memorandum No. 132, optimal for
  !  gridding interferometer data.  The approximations are taken from
  !  VLA Computer Memorandum No. 156.  The parameter c is related to the
  !  support width, m, of the convoluting function according to c=
  !  pi*m/2.  The parameter alpha determines a weight function in the
  !  definition of the criterion by which the function is optimal.
  !  SPHFN incorporates approximations to 25 of the spheroidal func-
  !  tions, corresponding to 5 choices of m (4, 5, 6, 7, or 8 cells)
  !  and 5 choices of the weighting exponent (0, 1/2, 1, 3/2, or 2).
  !
  !  Input:
  !    IALF    I*4   Selects the weighting exponent, alpha.  IALF =
  !                  1, 2, 3, 4, and 5 correspond, respectively, to
  !                  alpha = 0, 1/2, 1, 3/2, and 2.
  !    IM      I*4   Selects the support width m, (=IM) and, correspond-
  !                  ingly, the parameter c of the spheroidal function.
  !                  Only the choices 4, 5, 6, 7, and 8 are allowed.
  !    IFLAG   I*4   Chooses whether the spheroidal function itself, or
  !                  its Fourier transform, is to be approximated.  The
  !                  latter is appropriate for gridding, and the former
  !                  for the u-v plane convolution.  The two differ on-
  !                  by a factor (1-eta**2)**alpha.  IFLAG less than or
  !                  equal to zero chooses the function appropriate for
  !                  gridding, and IFLAG positive chooses its F.T.
  !    ETA     R*4   Eta, as the argument of the spheroidal function, is
  !                  a variable which ranges from 0 at the center of the
  !                  convoluting function to 1 at its edge (also from 0
  !                  at the center of the gridding correction function
  !                  to unity at the edge of the map).
  !
  !  Output:
  !    PSI      R*4  The function value which, on entry to the subrou-
  !                  tine, was to have been computed.
  !    IER      I*4  An error flag whose meaning is as follows:
  !                     IER = 0  =>  No evident problem.
  !                           1  =>  IALF is outside the allowed range.
  !                           2  =>  IM is outside of the allowed range.
  !                           3  =>  ETA is larger than 1 in absolute
  !                                     value.
  !                          12  =>  IALF and IM are out of bounds.
  !                          13  =>  IALF and ETA are both illegal.
  !                          23  =>  IM and ETA are both illegal.
  !                         123  =>  IALF, IM, and ETA all are illegal.
  !---------------------------------------------------------------------
  integer*4 :: ialf                 !
  integer*4 :: im                   !
  integer*4 :: iflag                !
  real*4 :: eta                     !
  real*4 :: psi                     !
  integer*4 :: ier                  !
  ! Local
  integer*4 :: j
  real*4 :: alpha(5), eta2, x
  real*4 :: p4(5,5), q4(2,5), p5(7,5), q5(5), p6l(5,5), q6l(2,5)
  real*4 :: p6u(5,5), q6u(2,5), p7l(5,5), q7l(2,5), p7u(5,5)
  real*4 :: q7u(2,5), p8l(6,5), q8l(2,5), p8u(6,5), q8u(2,5)
  data alpha / 0., .5, 1., 1.5, 2. /
  data p4 /   &
     &    1.584774e-2, -1.269612e-1,  2.333851e-1, -1.636744e-1,   &
     &    5.014648e-2,  3.101855e-2, -1.641253e-1,  2.385500e-1,   &
     &    -1.417069e-1,  3.773226e-2,  5.007900e-2, -1.971357e-1,   &
     &    2.363775e-1, -1.215569e-1,  2.853104e-2,  7.201260e-2,   &
     &    -2.251580e-1,  2.293715e-1, -1.038359e-1,  2.174211e-2,   &
     &    9.585932e-2, -2.481381e-1,  2.194469e-1, -8.862132e-2,   &
     &    1.672243e-2 /
  data q4 /   &
     &    4.845581e-1,  7.457381e-2,  4.514531e-1,  6.458640e-2,   &
     &    4.228767e-1,  5.655715e-2,  3.978515e-1,  4.997164e-2,   &
     &    3.756999e-1,  4.448800e-2 /
  data p5 /   &
     &    3.722238e-3, -4.991683e-2,  1.658905e-1, -2.387240e-1,   &
     &    1.877469e-1, -8.159855e-2,  3.051959e-2,  8.182649e-3,   &
     &    -7.325459e-2,  1.945697e-1, -2.396387e-1,  1.667832e-1,   &
     &    -6.620786e-2,  2.224041e-2,  1.466325e-2, -9.858686e-2,   &
     &    2.180684e-1, -2.347118e-1,  1.464354e-1, -5.350728e-2,   &
     &    1.624782e-2,  2.314317e-2, -1.246383e-1,  2.362036e-1,   &
     &    -2.257366e-1,  1.275895e-1, -4.317874e-2,  1.193168e-2,   &
     &    3.346886e-2, -1.503778e-1,  2.492826e-1, -2.142055e-1,   &
     &    1.106482e-1, -3.486024e-2,  8.821107e-3 /
  data q5 /   &
     &    2.418820e-1,  2.291233e-1,  2.177793e-1,  2.075784e-1,   &
     &    1.983358e-1 /
  data p6l /   &
     &    5.613913e-2, -3.019847e-1,  6.256387e-1, -6.324887e-1,   &
     &    3.303194e-1,  6.843713e-2, -3.342119e-1,  6.302307e-1,   &
     &    -5.829747e-1,  2.765700e-1,  8.203343e-2, -3.644705e-1,   &
     &    6.278660e-1, -5.335581e-1,  2.312756e-1,  9.675562e-2,   &
     &    -3.922489e-1,  6.197133e-1, -4.857470e-1,  1.934013e-1,   &
     &    1.124069e-1, -4.172349e-1,  6.069622e-1, -4.405326e-1,   &
     &    1.618978e-1 /
  data q6l /   &
     &    9.077644e-1,  2.535284e-1,  8.626056e-1,  2.291400e-1,   &
     &    8.212018e-1,  2.078043e-1,  7.831755e-1,  1.890848e-1,   &
     &    7.481828e-1,  1.726085e-1 /
  data p6u /   &
     &    8.531865e-4, -1.616105e-2,  6.888533e-2, -1.109391e-1,   &
     &    7.747182e-2,  2.060760e-3, -2.558954e-2,  8.595213e-2,   &
     &    -1.170228e-1,  7.094106e-2,  4.028559e-3, -3.697768e-2,   &
     &    1.021332e-1, -1.201436e-1,  6.412774e-2,  6.887946e-3,   &
     &    -4.994202e-2,  1.168451e-1, -1.207733e-1,  5.744210e-2,   &
     &    1.071895e-2, -6.404749e-2,  1.297386e-1, -1.194208e-1,   &
     &    5.112822e-2 /
  data q6u /   &
     &    1.101270e+0,  3.858544e-1,  1.025431e+0,  3.337648e-1,   &
     &    9.599102e-1,  2.918724e-1,  9.025276e-1,  2.575336e-1,   &
     &    8.517470e-1,  2.289667e-1 /
  data p7l /   &
     &    2.460495e-2, -1.640964e-1,  4.340110e-1, -5.705516e-1,   &
     &    4.418614e-1,  3.070261e-2, -1.879546e-1,  4.565902e-1,   &
     &    -5.544891e-1,  3.892790e-1,  3.770526e-2, -2.121608e-1,   &
     &    4.746423e-1, -5.338058e-1,  3.417026e-1,  4.559398e-2,   &
     &    -2.362670e-1,  4.881998e-1, -5.098448e-1,  2.991635e-1,   &
     &    5.432500e-2, -2.598752e-1,  4.974791e-1, -4.837861e-1,   &
     &    2.614838e-1 /
  data q7l /   &
     &    1.124957e+0,  3.784976e-1,  1.075420e+0,  3.466086e-1,   &
     &    1.029374e+0,  3.181219e-1,  9.865496e-1,  2.926441e-1,   &
     &    9.466891e-1,  2.698218e-1 /
  data p7u /   &
     &    1.924318e-4, -5.044864e-3,  2.979803e-2, -6.660688e-2,   &
     &    6.792268e-2,  5.030909e-4, -8.639332e-3,  4.018472e-2,   &
     &    -7.595456e-2,  6.696215e-2,  1.059406e-3, -1.343605e-2,   &
     &    5.135360e-2, -8.386588e-2,  6.484517e-2,  1.941904e-3,   &
     &    -1.943727e-2,  6.288221e-2, -9.021607e-2,  6.193000e-2,   &
     &    3.224785e-3, -2.657664e-2,  7.438627e-2, -9.500554e-2,   &
     &    5.850884e-2 /
  data q7u /   &
     &    1.450730e+0,  6.578685e-1,  1.353872e+0,  5.724332e-1,   &
     &    1.269924e+0,  5.032139e-1,  1.196177e+0,  4.460948e-1,   &
     &    1.130719e+0,  3.982785e-1 /
  data p8l /   &
     &    1.378030e-2, -1.097846e-1,  3.625283e-1, -6.522477e-1,   &
     &    6.684458e-1, -4.703556e-1,  1.721632e-2, -1.274981e-1,   &
     &    3.917226e-1, -6.562264e-1,  6.305859e-1, -4.067119e-1,   &
     &    2.121871e-2, -1.461891e-1,  4.185427e-1, -6.543539e-1,   &
     &    5.904660e-1, -3.507098e-1,  2.580565e-2, -1.656048e-1,   &
     &    4.426283e-1, -6.473472e-1,  5.494752e-1, -3.018936e-1,   &
     &    3.098251e-2, -1.854823e-1,  4.637398e-1, -6.359482e-1,   &
     &    5.086794e-1, -2.595588e-1 /
  data q8l /   &
     &    1.076975e+0,  3.394154e-1,  1.036132e+0,  3.145673e-1,   &
     &    9.978025e-1,  2.920529e-1,  9.617584e-1,  2.715949e-1,   &
     &    9.278774e-1,  2.530051e-1 /
  data p8u /   &
     &    4.290460e-5, -1.508077e-3,  1.233763e-2, -4.091270e-2,   &
     &    6.547454e-2, -5.664203e-2,  1.201008e-4, -2.778372e-3,   &
     &    1.797999e-2, -5.055048e-2,  7.125083e-2, -5.469912e-2,   &
     &    2.698511e-4, -4.628815e-3,  2.470890e-2, -6.017759e-2,   &
     &    7.566434e-2, -5.202678e-2,  5.259595e-4, -7.144198e-3,   &
     &    3.238633e-2, -6.946769e-2,  7.873067e-2, -4.889490e-2,   &
     &    9.255826e-4, -1.038126e-2,  4.083176e-2, -7.815954e-2,   &
     &    8.054087e-2, -4.552077e-2 /
  data q8u /   &
     &    1.379457e+0,  5.786953e-1,  1.300303e+0,  5.135748e-1,   &
     &    1.230436e+0,  4.593779e-1,  1.168075e+0,  4.135871e-1,   &
     &    1.111893e+0,  3.744076e-1 /
  !
  ! Code
  ier = 0
  if (ialf.lt.1 .or. ialf.gt.5) ier = 1
  if (im.lt.4 .or. im.gt.8) ier = 2+10*ier
  if (abs(eta).gt.1.) ier = 3+10*ier
  if (ier.ne.0) then
    write(6,*) 'E-SPHEROIDAL,  Error ',ier
    return
  endif
  eta2 = eta**2
  j = ialf
  !
  ! Support width = 4 cells:
  if (im.eq.4) then
    x = eta2-1.
    psi = (p4(1,j)+x*(p4(2,j)+x*(p4(3,j)+x*(p4(4,j)+x*p4(5,j)))))   &
     &      / (1.+x*(q4(1,j)+x*q4(2,j)))
    !
    ! Support width = 5 cells:
  elseif (im.eq.5) then
    x = eta2-1.
    psi = (p5(1,j)+x*(p5(2,j)+x*(p5(3,j)+x*(p5(4,j)+x*(p5(5,j)   &
     &      +x*(p5(6,j)+x*p5(7,j)))))))   &
     &      / (1.+x*q5(j))
    !
    ! Support width = 6 cells:
  elseif (im.eq.6) then
    if (abs(eta).le..75) then
      x = eta2-.5625
      psi = (p6l(1,j)+x*(p6l(2,j)+x*(p6l(3,j)+x*(p6l(4,j)   &
     &        +x*p6l(5,j))))) / (1.+x*(q6l(1,j)+x*q6l(2,j)))
    else
      x = eta2-1.
      psi = (p6u(1,j)+x*(p6u(2,j)+x*(p6u(3,j)+x*(p6u(4,j)   &
     &        +x*p6u(5,j))))) / (1.+x*(q6u(1,j)+x*q6u(2,j)))
    endif
    !
    ! Support width = 7 cells:
  elseif (im.eq.7) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p7l(1,j)+x*(p7l(2,j)+x*(p7l(3,j)+x*(p7l(4,j)   &
     &        +x*p7l(5,j))))) / (1.+x*(q7l(1,j)+x*q7l(2,j)))
    else
      x = eta2-1.
      psi = (p7u(1,j)+x*(p7u(2,j)+x*(p7u(3,j)+x*(p7u(4,j)   &
     &        +x*p7u(5,j))))) / (1.+x*(q7u(1,j)+x*q7u(2,j)))
    endif
    !
    ! Support width = 8 cells:
  elseif (im.eq.8) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p8l(1,j)+x*(p8l(2,j)+x*(p8l(3,j)+x*(p8l(4,j)   &
     &        +x*(p8l(5,j)+x*p8l(6,j)))))) / (1.+x*(q8l(1,j)+x*q8l(2,j)))
    else
      x = eta2-1.
      psi = (p8u(1,j)+x*(p8u(2,j)+x*(p8u(3,j)+x*(p8u(4,j)   &
     &        +x*(p8u(5,j)+x*p8u(6,j)))))) / (1.+x*(q8u(1,j)+x*q8u(2,j)))
    endif
  endif
  !
  ! Normal return:
  if (iflag.gt.0 .or. ialf.eq.1 .or. eta.eq.0.) return
  if (abs(eta).eq.1.) then
    psi = 0.0
  else
    psi = (1.-eta2)**alpha(ialf)*psi
  endif
end subroutine sphfn
!
subroutine grdflt (ctypx, ctypy, xparm, yparm)
  !---------------------------------------------------------------------
  !     GRDFLT determines default parameters for the convolution functions
  !     If no convolving type is chosen, an Spheroidal is picked.
  !     Otherwise any unspecified values ( = 0.0) will be set to some
  !     value.
  ! Arguments:
  !     CTYPX,CTYPY           I  Convolution types for X and Y direction
  !                                1 = pill box
  !                                2 = exponential
  !                                3 = sinc
  !                                4 = expontntial * sinc
  !                                5 = spheroidal function
  !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
  !                                (1) = support radius (cells)
  !---------------------------------------------------------------------
  integer :: ctypx                  !
  integer :: ctypy                  !
  real*4 ::    xparm(10)            !
  real*4 ::    yparm(10)            !
  ! Local
  character(len=12) :: chtyps(5)
  integer :: numprm(5), i, k
  data numprm /1, 3, 2, 4, 2/
  data chtyps /'Pillbox','Exponential','Sin(X)/(X)',   &
     &    'Exp*Sinc','Spheroidal'/
  !
  ! Default = type 5
  if ((ctypx.le.0) .or. (ctypx.gt.5)) ctypx = 5
  goto (110,120,130,140,150) ctypx
  !
  ! Pillbox
110 continue
  if (xparm(1).le.0.0) xparm(1) = 0.5
  go to 500
  ! Exponential.
120 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.00
  if (xparm(3).le.0.0) xparm(3) = 2.00
  go to 500
  ! Sinc.
130 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.14
  go to 500
  ! Exponential * sinc
140 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.55
  if (xparm(3).le.0.0) xparm(3) = 2.52
  if (xparm(4).le.0.0) xparm(4) = 2.00
  go to 500
  ! Spheroidal function
150 continue
  if (xparm(1).le.0.0) xparm(1) = 3.0
  if (xparm(2).le.0.0) xparm(2) = 1.0
  go to 500
  !
  ! Put default cheking here for further function types
500 continue
  ! Check Y convolution defaults
  if ((ctypy.gt.0) .and. (ctypy.le.5)) go to (610,620,630,   &
     &    640,650) ctypy
  ! Use X values
  ctypy = ctypx
  do i = 1,10
    yparm(i) = xparm(i)
  enddo
  goto 900
  ! Pillbox
610 continue
  if (yparm(1).le.0.0) yparm(1) = 0.5
  go to 900
  ! Exponential
620 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.0
  if (yparm(3).le.0.0) yparm(3) = 2.0
  go to 900
  ! Sinc
630 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.14
  go to 900
  ! Exponential * sinc
640 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.55
  if (yparm(3).le.0.0) yparm(3) = 2.52
  if (yparm(4).le.0.0) yparm(4) = 2.00
  go to 900
  ! Spheroidal function
650 continue
  if (yparm(1).le.0.0) yparm(1) = 3.0
  if (yparm(2).le.0.0) yparm(2) = 1.0
  go to 900
  !
  ! Put default checking for new types here.
  ! Print parameters chosen.
900 continue
  write(6,1001) 'X',chtyps(ctypx),(xparm(k),k=1,numprm(ctypx))
  write(6,1001) 'Y',chtyps(ctypy),(yparm(k),k=1,numprm(ctypy))
1001 format(1x,a,' Convolution ',a,' Par.=',5f8.4)
end subroutine grdflt
!
subroutine finsiz (x,nd,np,ix,iy,we,xmin,xmax,ymin,ymax)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: ix                     !
  integer :: iy                     !
  real :: we(np)                    !
  real :: xmin                      !
  real :: xmax                      !
  real :: ymin                      !
  real :: ymax                      !
  ! Local
  integer :: i,j
  !
  i = 1
  do while (we(i).eq.0)
    i = i+1
  enddo
  xmin = x(ix,i)
  xmax = x(ix,i)
  ymin = x(iy,i)
  i = i+1
  do j=i,np
    if (we(j).ne.0) then
      if (x(ix,j).lt.xmin) then
        xmin = x(ix,j)
      elseif (x(ix,j).gt.xmax) then
        xmax = x(ix,j)
      endif
    endif
  enddo
  i = np
  do while (we(i).eq.0)
    i = i-1
  enddo
  ymax = x(iy,i)
end subroutine finsiz
!
subroutine finsiy (x,nd,np,iy,we,ymin,ymax)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: iy                     !
  real :: we(np)                    !
  real :: ymin                      !
  real :: ymax                      !
  ! Local
  integer :: i
  !
  i = 1
  do while (we(i).eq.0)
    i = i+1
  enddo
  ymin = x(iy,i)
  i = np
  do while (we(i).eq.0)
    i = i-1
  enddo
  ymax = x(iy,i)
end subroutine finsiy
!
subroutine fininc (x,nd,np,ix,iy,we,xinc,yinc,tole)
  integer :: nd                     !
  integer :: np                     !
  real :: x(nd,np)                  !
  integer :: ix                     !
  integer :: iy                     !
  real :: we(np)                    !
  real :: xinc                      !
  real :: yinc                      !
  real :: tole                      !
  ! Local
  integer :: i,j
  real :: dist
  !
  do i=1,np-1
    if (we(i).ne.0) then
      do j=i+1,np
        if (we(j).ne.0) then
          dist = abs(x(ix,j)-x(ix,i))
          if (dist.gt.tole .and. dist.lt.xinc) xinc = dist
          dist = x(iy,j)-x(iy,i)
          if (dist.gt.tole .and. dist.lt.yinc) yinc = dist
        endif
      enddo
    endif
  enddo
end subroutine fininc
!
subroutine dosor  (visi,nd,np,we,iy)
  use gkernel_interfaces
  use gildas_def
  integer :: nd                     !
  integer :: np                     !
  real :: visi(nd,np)               !
  real :: we(nd)                    !
  integer :: iy                     !
  ! Global
  integer :: trione
  ! Local
  integer :: i,ier
  do i=1,np-1
    if (visi(iy,i).gt.visi(iy,i+1)) then
      write(6,*) 'I-GRID,  Sorting input table'
      ier = trione (visi,nd,np,iy,we)
      if (ier.ne.1) call sysexi (fatale)
      return
    endif
  enddo
end subroutine dosor
!
function trione (x,nd,n,ix,work)
  !---------------------------------------------------------------------
  ! 	Sorting program that uses a quicksort algorithm.
  !	Sort on one row
  !	X	R*4(*)	Unsorted array				Input
  !	ND	I	First dimension of X 			Input
  !	N	I	Second dimension of X			Input
  !	IX	I	X(IX,*) is the key for sorting		Input
  !	WORK	R*4(ND)	Work space for exchange			Input
  !---------------------------------------------------------------------
  integer :: trione                 !
  integer :: nd                     !
  integer :: n                      !
  real*4 :: x(nd,n)                 !
  integer :: ix                     !
  real*4 :: work(nd)                !
  ! Local
  integer :: maxstack,nstop
  parameter (maxstack=1000,nstop=15)
  integer*4 :: i, j, k, l1, r1
  integer*4 :: l, r, m, lstack(maxstack), rstack(maxstack), sp
  real*4 :: key
  logical :: mgtl, lgtr, rgtm
  !
  trione = 1
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases (especially for nearly already sorted files)
  ! To fix this problem, I found (but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m = (l + r) / 2
  l1=(2*l+r)/3
  r1=(l+2*r)/3
  !
  mgtl = x(ix,m) .gt. x(ix,l)
  rgtm = x(ix,r) .gt. x(ix,m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !		   	MGTL	RGTM	LGTR	MGTL.EQV.LGTR	MEDIAN_KEY
  !
  !	KL < KM < KR	T	T	*	*		KM
  !	KL > KM > KR	F	F	*	*		KM
  !
  !	KL < KM > KR	T	F	F	F		KR
  !	KL < KM > KR	T	F	T	T		KL
  !
  !	KL > KM < KR	F	T	F	T		KL
  !	KL > KM < KR	F	T	T	F		KR
  !
  if (mgtl .eqv. rgtm) then
    key = x(ix,m)
  else
    lgtr = x(ix,l) .gt. x(ix,r)
    if (mgtl .eqv. lgtr) then
      key = x(ix,l)
    else
      key = x(ix,r)
    endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 if (x(ix,i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(ix,j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  call r4tor4 (x(1,i),work,nd)
  call r4tor4 (x(1,j),x(1,i),nd)
  call r4tor4 (work,x(1,j),nd)
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      trione = 0
      return
    endif
    lstack(sp) = l
    rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      trione = 0
      return
    endif
    lstack(sp) = j+1
    rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j=n-1,1,-1
    k = j
    do i = j+1,n
      if (x(ix,j).le.x(ix,i)) exit ! I
      k = i
    enddo
    if (k.eq.j) cycle          ! J
    call r4tor4 (x(1,j),work,nd)
    do i = j+1,k
      call r4tor4 (x(1,i),x(1,i-1),nd)
    enddo
    call r4tor4 (work,x(1,k),nd)
  enddo                        ! J
end function trione
!
subroutine doapod (xmin,xmax,ymin,ymax,tole,beam,   &
     &    nc,nx,ny,map,raw,mapx,mapy, weight,wmax)
  real :: xmin                      !
  real :: xmax                      !
  real :: ymin                      !
  real :: ymax                      !
  real :: tole                      !
  real :: beam                      !
  integer :: nc                     !
  integer :: nx                     !
  integer :: ny                     !
  real :: map(nc,nx,ny)             !
  real :: raw(nc,nx,ny)             !
  real :: mapx(nx)                  !
  real :: mapy(ny)                  !
  real :: weight(nx,ny)             !
  real :: wmax                      !
  ! Local
  integer :: ic,ix,iy
  real :: lobe,apod,disty,distx,pi,wmin
  wmin = 0.02 * wmax
  !
  pi = acos(-1.0)
  write(6,*) 'Min-Max ',xmin,xmax,ymin,ymax
  write(6,*) 'Beam et Inc ',beam*180*3600/pi,tole*180*3600/pi   &
     &    ,(mapx(1)-mapx(2))*180*3600/pi
  ! Use a beam size twice larger
  lobe = log(2.0)/beam**2
  do iy=1,ny
    if (mapy(iy).le.ymin-tole) then
      disty = ymin-mapy(iy)
    elseif (mapy(iy).ge.ymax+tole) then
      disty = mapy(iy)-ymax
    else
      disty = 0.0
    endif
    do ix=1,nx
      if (mapx(ix).le.xmin-tole) then
        distx = xmin-mapx(ix)
      elseif (mapx(ix).ge.xmax+tole) then
        distx = mapx(ix)-xmax
      else
        distx = 0.0
      endif
      apod = (distx**2+disty**2)*lobe
      if (apod.ne.0.0) then
        apod = exp(-apod)
        do ic=1,nc
          map(ic,ix,iy) = map(ic,ix,iy)*apod
        enddo
      else
        if (weight(ix,iy).gt.wmin) then
          do ic=1,nc
            map(ic,ix,iy) = raw(ic,ix,iy)
          enddo
        endif
      endif
    enddo
  enddo
end subroutine doapod
!
function maxvec(a,n)
  real :: maxvec                    !
  real :: a(*)                      !
  integer :: n                      !
  ! Local
  real :: r
  integer :: i
  !
  r = 0.0
  do i =1,n
    r = max(r,a(i))
  enddo
  maxvec = r
end function maxvec

function gr_error ()
  use greg_error
  !---------------------------------------------------------------------
  ! @ public
  !	Check GREG library error status
  !---------------------------------------------------------------------
  logical :: gr_error               !
  !
  gr_error = errorg
  errorg = .false.
end function gr_error
!
subroutine gr_exec(buffer)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_exec
  use greg_error
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  !	Execute a single GREG command
  ! Arguments :
  !	BUFFER	C*(*)	The command line		Input
  ! Subroutines :
  !	(SIC)
  !	RUN_GREG1, RUN_GREG2
  !---------------------------------------------------------------------
  character(len=*) :: buffer        !
  ! Local
  integer :: nl, nh
  character(len=255) :: line
  character(len=12) :: lang
  character(len=12) :: comm
  character(len=12) :: header
  character(len=1), parameter :: backslash=char(92)
  !
  save nh, nl, header, line
  !
  ! Analyse line
  header = 'G'//backslash
  nh = 2
  goto 10
  !
entry gr_exec1(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GREG1'//backslash
  nh = 6
  goto 10
  !
entry gr_exec2(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GREG2'//backslash
  nh = 6
  goto 10
  !
entry gr_execl(buffer)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  header = 'GTVL'//backslash
  nh = 5
  goto 10
  !
  ! Check error status
10 continue
  if (errorg) then
    call gagout (message)
    call gagout (line(1:nl))
    call sysexi (fatale)
  endif
  line  = header(1:nh)//buffer
  nl = 255
  !
  ! Analyse line
  call sic_blanc(line,nl)
  call sic_analyse(comm,line,nl,errorg)
  if (errorg) then
    message = 'F-GREG,  Error interpreting line'
    return
  endif
  call sic_lang(lang)
  !
  ! Execute line
  if (lang.eq.'GREG1') then
    call run_greg1(line,comm,errorg)
  elseif (lang.eq.'GREG2') then
    call run_greg2(line,comm,errorg)
  elseif (lang.eq.'GTVL') then
    call run_gtvl(line,comm,errorg)
    if (comm.eq.'CLEAR') call greset
  else
    message = 'F-GREG,  Unexpected language '//lang
    errorg = .true.
    return
  endif
  if (errorg) then
    message = 'F-GREG,  Error executing line'
    return
  endif
end subroutine gr_exec

subroutine robs(ix,error)
  use classic_api
  use clic_file 
  use clic_title
  use clic_index
  !---------------------------------------------------------------------
  ! Read entry descriptor, then title and copy title into r_ structure
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: ix                     !
  logical         :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_memory.inc'
  include 'clic_clic.inc'
  ! Local
  character(len=10) :: nombre
  !------------------------------------------------------------------------
  modify = .false.
  error = .false.
  !
  if (ix.le.0 .or. ix.ge.i%desc%xnext .or. ix.gt.m_ix) then
    error = .true.
    write(nombre,'(I10)') ix
    call message(8,3,'ROBS','Non-existant index entry '//nombre)
    return
  endif
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(i,ix_bloc(ix),ix_word(ix),ibuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(i,ibuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'ROBS','Observation version not supported ')
    call message(8,1,'ROBS','Use a more recent CLIC version')
    error = .true.
    return
  endif
  !
  ! Duplicate index information
  call rix(ix,error)
  if (error) return
  r_num   = title%num
  r_ver   = title%ver
  r_dobs  = title%dobs
  r_dred  = title%dred
  r_typec = title%typec
  r_kind  = title%kind
  if (r_kind.ge.5) then
    new_receivers = .true.
  else
    new_receivers = .false.
  endif
  r_qual  = title%qual
  r_scan  = title%scan
  r_nrec  = title%recei
  call bytoch(title%project,r_project,8)
  call bytoch(title%teles,r_teles,12)
end subroutine robs
!
subroutine xobs (error)
  use classic_api
  use clic_file
  use clic_index
  !---------------------------------------------------------------------
  !	Opens an output observation in the output file to extend it.
  !	This works only if this obs. is the last in the file
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer(kind=entry_length) :: ix,inum
  integer :: iver
  ! Code:
  if (r_ver.lt.0) then
    call message(8,3,'XOBS','Can only extend last versions')
    error = .true.
    return
  endif
  ix = o%desc%xnext-1
  inum = ox_num(ix)
  iver = ox_ver(ix)
  if (iver.lt.0 .or. inum.ne.r_num) then
    call message(4,2,'XOBS',   &
      'Observation not found or may not be extended')
    error = .true.
    return
  endif
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(o,ox_bloc(ix),ox_word(ix),obuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(o,obuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'XOBS','Observation version not supported ')
    error = .true.
    return
  endif
  ! 
  ! Observation is opened for modification
  modify = .true.
end subroutine xobs
!
subroutine mobs (error)
  use classic_api
  use clic_file
  use clic_index
  use clic_find
  !---------------------------------------------------------------------
  !	Open an observation of the output file to modify it.
  !	The length of each section modified must be smaller
  !	than the length of the corresponding section already present.
  !
  !	Find the latest version of this obs. in this file
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: nf
  integer(kind=entry_length) :: ix, ifind(10)
  !
  if (r_ver.lt.0) then
    call message(8,3,'UPDATE','Can only update last versions')
    error = .true.
    return
  endif
  !
  ! Find latest observation version
  fver =.false.
  fnum =.true.
  xnum =r_num
  ynum =r_num
  fscan = .false.
  xrecei = -1
  fut = .false.
  last =.true.
  nf = 1
  call fox(nf,ifind,error)
  if (error) return
  if (nf.eq.0) then
    error = .true.
    call message(8,4,'MOBS',   &
      'Observation to be modified was not found')
    return
  endif
  !
  ! Process last version of the observation
  ix = ifind(1)
  !
  ! Initialize Observation buffer
  call classic_recordbuf_open(o,ox_bloc(ix),ox_word(ix),obuff,error)
  if (error) return
  !
  ! Then read entry descriptor
  call classic_entrydesc_read(o,obuff,e,error)
  if (error) return
  !
  ! Check observation version
  if (e%version.lt.1.or.e%version.gt.version_last) then
    call message(8,3,'MOBS','Observation version not supported ')
    error = .true.
    return
  endif
  !
  ! Observation opened for modify
  modify = .true.
end subroutine mobs
!
subroutine cobs(ltype,error)
  use gkernel_interfaces
  use classic_api
  use clic_file
  use clic_title
  use clic_index
  use clic_find
  !---------------------------------------------------------------------
  !	Ends the writing of the output observation.
  !---------------------------------------------------------------------
  integer :: ltype                  !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: nf,hver
  integer(kind=entry_length) :: ifind(10),jx
  !
  if (obuff%lun.ne.o%lun) then
    error = .true.
    call message(8,4,'COBS',   &
      'Observation not open for write nor modify')
    return
  endif
  !
  hver = 0
  if (.not.modify) then
    if (o%lun.ne.i%lun) then         ! Write on a new file:
      r_num = o%desc%xnext           ! Guarantee increase
    endif
    fver=.false.
    fnum=.true.
    xnum=r_num
    ynum=r_num
    last=.true.
    nf = 1
    fscan = .false.
    xrecei = -1
    fut = .false.
    call fox(nf,ifind,error)
    if (error) return
    if (nf.ne.0) then
      hver = ox_ver(ifind(1))
      if (hver.ge.0) ox_ver(ifind(1)) = -hver
      call rox(ifind(1),error)
      if (error) return
      title%ver = ox_ver(ifind(1))
      call mox(ifind(1),error)
      if (hver.lt.0) hver = -hver
      if (error) return
    else
      hver = 0
    endif
  endif
  !
  title%typec = ltype
  title%off1  = r_lamof
  title%off2  = r_betof
  ! Interferometer specific
  title%proc  = r_proc
  title%itype = r_itype
  title%houra = r_houra
  title%ut    = r_ut
  title%recei = r_nrec
  call chtoby(r_project,title%project,8)
  title%bpc   = r_bpc
  if (r_ic.ne.0) then
    title%ic  = r_ic
  else
    title%ic  = 0
  endif
  !
  ! Write the index entry
  ! The version number must increase
  !
  title%bloc = obuff%rstart
  title%word = obuff%wstart
  title%num  = r_num
  
  title%kind = r_kind
  title%qual = r_qual
  r_ver      = abs(r_ver)
  title%ver  = max(r_ver,hver)+1
  if (title%ver.gt.99) title%ver=11
  title%scan = r_scan
  call chtoby (r_sourc,title%sourc,12)
  call chtoby (r_line,title%line,12)
  call chtoby (r_teles,title%teles,12)
  title%dobs = r_dobs
  call sic_date (r_cdred)
  call cdate (r_cdred,r_dred,error)
  title%dred = r_dred
  if (modify) then
    ! Caution, if error before classic_entry_write, last buffer not written
    jx = e%xnum
    call mox(jx,error)
  else
    call wox(error)
  endif
  if (error) return
  !
  ! Write the observation header
  call classic_entrydesc_write(o,obuff,e,error)
  if (error) return
  !
  ! And close the entry
  call classic_entry_close(o,obuff,error)
  !
  ! File both: nullify input file record buffer, as it may have changed on disk
  if (i%lun.eq.o%lun) then
    call classic_recordbuf_nullify(ibuff)
  endif
  !
  ! Update the file header
  call cox(error)
end subroutine cobs
!
subroutine iobs(n,ix,check,error)
  use gkernel_interfaces
  use classic_api
  use clic_file
  use clic_title
  use clic_find
  !---------------------------------------------------------------------
  ! RW	Internal routine
  !	Starts the writing of an observation.
  ! Arguments :
  !	N 	I	maximum # of sections to be written
  !			(in addition of the data section)
  !	IX 	I	returns the index number of the observation
  !			in the output file
  !      CHECK    L       .true., check that observation is not a diplicate.
  !---------------------------------------------------------------------
  integer         :: n                      !
  integer(kind=entry_length) :: ix                     !
  logical         :: check                  !
  logical         :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  logical :: err, full
  integer :: ier, nff, lch, version
  integer(kind=entry_length) :: iff(100)
  character(len=80) :: ch
  !
  if (o%lun.eq.0) then
    call message(8,4,'IOBS','No output file opened')
    error=.true.
    return
  endif
  !
  ! Check if scan was written previously (with same receiver and UT time)
  ! Nevertheless, authorize writing if same scan number and not check
  !
  if (o%desc%xnext.gt.1) then
    !
    nff = 100
    fnum = .false.
    fver = .false.
    xscan(1) = r_scan
    yscan(1) = r_scan
    xnscan = 1
    fscan = .true.
    xrecei = r_nrec
    xut = real(r_ut,kind=4) ! Patch: r_ut is kind=8, but title%ut is kind=4
    yut = real(r_ut,kind=4) ! Patch: r_ut is kind=8, but title%ut is kind=4
    fut = .true.
    call fox(nff,iff,error)
    if (nff.ge.1) then
      write (ch,'(a,i5,a,i2,a)') 'Observation ',r_scan,   &
        ' receiver ',r_nrec, ' already written'
      lch = lenc(ch)
      call message(8,2,'IOBS',ch(1:lch))
      if (check) then
        error = .true.
        return
      endif
    endif
  endif
  !
  ! Proceed
20 continue
  call classic_filedesc_read(o,err)
  if (err) then
    if (error) then
      call message(8,3,'IOBS','Read error in file descriptor')
      call messios(8,3,'IOBS',ier)
      return
    else
      error = .true.
      call sic_wait(1.0)
      goto 20
    endif
  endif
  error = .false.
  !
  ! Add index extension if required before preparing the observation
  ! And initialize entry descriptor
  modify = .false.
  ix = o%desc%xnext
  if (o%desc%version.eq.1) then     ! CLASSIC V1
    version = classic_vobs_v1       !   Observation version v1
  elseif(o%desc%version.eq.2) then  ! CLASSIC V2
    version = version_current       !   Desired version
  endif
  call classic_entry_init(o,ix,n,version,full,e,error)
  if (full) call message(8,3,'IOBS','Output index is full')
  if (error) return
  !
  ! And initialize output buffer
  call classic_recordbuf_open(o,o%desc%nextrec,o%desc%nextword,obuff,error)
  if (error) return
  !
end subroutine iobs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_speelt_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_consistency_types
  !
  public :: speelt_t, speelt_cons_t
  public :: cubetools_speelt_init,cubetools_speelt_get_and_derive
  public :: cubetools_speelt_final,cubetools_speelt_put
  public :: cubetools_speelt_list,cubetools_speelt_sicdef,cubetools_speelt_copy
  public :: cubetools_speelt_consistency_check,cubetools_speelt_consistency_list
  public :: cubetools_speelt_consistency_init,cubetools_speelt_consistency_final
  public :: cubetools_speelt_consistency_set_tol
  private
  !
  type speelt_t
     real(kind=coor_k) :: c = 0d0 ! [----] Channel
     real(kind=coor_k) :: f = 0d0 ! [ MHz] Signal frequency
     real(kind=coor_k) :: i = 0d0 ! [ MHz] Image frequency
     real(kind=coor_k) :: l = 0d0 ! [ mum] Wavelength
     real(kind=coor_k) :: v = 0d0 ! [km/s] Systemic velocity
     real(kind=coor_k) :: z = 0d0 ! [----] Systemic redshift
  end type speelt_t
  !
  type speelt_cons_t
     logical                    :: check=.true.  ! Check the section
     logical                    :: prob =.false. ! Is there a problem
     logical                    :: mess =.true.  ! Output message for this section?
     type(consistency_desc_t)   :: c  ! Channel consistency          
     type(consistency_desc_t)   :: f  ! Frequency consisntency
     type(consistency_desc_t)   :: i  ! Image frequency consistency
     type(consistency_desc_t)   :: l  ! Wavelength consistency
     type(consistency_desc_t)   :: v  ! Velocity consistency
     type(consistency_desc_t)   :: z  ! Redshift consistency
  end type speelt_cons_t
  !
contains
  !
  subroutine cubetools_speelt_init(speelt,error)
    !-------------------------------------------------------------------
    ! Just initialize the type, ie, set it intent(out)
    !-------------------------------------------------------------------
    type(speelt_t), intent(out)   :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_init
  !
  subroutine cubetools_speelt_get_and_derive(speelt,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    type(speelt_t), intent(inout) :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>GET>AND>DERIVE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
!!$    speelt%l => lval
!!$    speelt%m => mval
  end subroutine cubetools_speelt_get_and_derive
  !
  subroutine cubetools_speelt_put(speelt,error)
    !-------------------------------------------------------------------
    ! Empty method on purpose as speelt is a pointer set
    !-------------------------------------------------------------------
    type(speelt_t), intent(in)    :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>PUT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_put
  !
  subroutine cubetools_speelt_final(speelt,error)
    !-------------------------------------------------------------------
    ! Just reinitialize the type, ie, set it intent(out)
    !-------------------------------------------------------------------
    type(speelt_t), intent(out)   :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_final
  !
  !---------------------------------------------------------------------
  !
  subroutine cubetools_speelt_list(speelt,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! Empty method until there is a clear usecase
    !-------------------------------------------------------------------
    type(speelt_t), intent(in)    :: speelt
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
  end subroutine cubetools_speelt_list
  !
  subroutine cubetools_speelt_sicdef(name,elt,readonly,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    type(speelt_t),   intent(in)    :: elt
    logical,          intent(in)    :: readonly
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>SICDEF'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call sic_defstructure(name,global,error)
    if (error) return 
    call sic_def_dble(trim(name)//'%C',elt%c,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%F',elt%f,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%I',elt%i,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%L',elt%l,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%V',elt%v,0,0,readonly,error)
    if (error) return
    call sic_def_dble(trim(name)//'%Z',elt%z,0,0,readonly,error)
    if (error) return
  end subroutine cubetools_speelt_sicdef
  !
  subroutine cubetools_speelt_copy(in,ou,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    type(speelt_t), intent(in)    :: in
    type(speelt_t), intent(out)   :: ou
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>COPY'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    ou = in
  end subroutine cubetools_speelt_copy
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetools_speelt_consistency_init(cons,error)
    !----------------------------------------------------------------------
    ! Init spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>INIT'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_init(strict,check,mess,cons%c,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%f,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%i,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%l,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%v,error)
    if (error) return
    call cubetools_consistency_init(strict,check,mess,cons%z,error)
    if (error) return
  end subroutine cubetools_speelt_consistency_init
  !
  subroutine cubetools_speelt_consistency_set_tol(elttol,cons,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    real(kind=tole_k),   intent(in)    :: elttol
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>SET>TOL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    cons%c%tol = elttol
    cons%f%tol = elttol
    cons%i%tol = elttol
    cons%l%tol = elttol
    cons%v%tol = elttol
    cons%z%tol = elttol
  end subroutine cubetools_speelt_consistency_set_tol
  !
  subroutine cubetools_speelt_consistency_check(cons,inc1,ref1,inc2,ref2,error)
    !----------------------------------------------------------------------
    ! Check spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    type(speelt_t),      intent(in)    :: inc1
    type(speelt_t),      intent(in)    :: ref1
    type(speelt_t),      intent(in)    :: inc2
    type(speelt_t),      intent(in)    :: ref2
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>CHECK'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%check) return
    !
    call cubetools_consistency_real_relative_check(cons%c,inc1%c,ref1%c,inc2%c,ref2%c,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%f,inc1%f,ref1%f,inc2%f,ref2%f,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%i,inc1%i,ref1%i,inc2%i,ref2%i,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%l,inc1%l,ref1%l,inc2%l,ref2%l,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%v,inc1%v,ref1%v,inc2%v,ref2%v,error)
    if (error) return
    call cubetools_consistency_real_relative_check(cons%z,inc1%z,ref1%z,inc2%z,ref2%z,error)
    if (error) return
    !
    cons%prob = cons%c%prob.or.cons%f%prob.or.cons%i%prob.or.cons%l%prob.or.cons%v%prob.or.cons%z%prob
  end subroutine cubetools_speelt_consistency_check
  !
  subroutine cubetools_speelt_consistency_list(cons,ref1,ref2,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Print spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(in)    :: cons
    type(speelt_t),      intent(in)    :: ref1
    type(speelt_t),      intent(in)    :: ref2
    logical,             intent(inout) :: error
    !
    type(unit_user_t) :: unitfreq,unitvelo
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if (.not.cons%mess) return
    !
    call cubetools_consistency_title('spectral references',3,cons%check,cons%prob,error)
    if (error) return
    if (cons%check.and.cons%prob) then
       call unitfreq%get_from_code(code_unit_freq,error)
       if (error) return
       call unitvelo%get_from_code(code_unit_velo,error)
       if (error) return
       call cubetools_consistency_real_print('Channel',cons%c,ref1%c,ref2%c,error)
       if (error) return
       call cubetools_consistency_real_print('Rest frequency',unitfreq%name,cons%f,&
            ref1%f*unitfreq%user_per_prog,ref2%f*unitfreq%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Image frequency',unitfreq%name,cons%i,&
            ref1%i*unitfreq%user_per_prog,ref2%i*unitfreq%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Wavelength','mum',cons%l,ref1%l,ref2%l,error)
       if (error) return
       call cubetools_consistency_real_print('Velocity',unitvelo%name,cons%v,ref1%v*unitvelo%user_per_prog,&
            ref2%v*unitvelo%user_per_prog,error)
       if (error) return
       call cubetools_consistency_real_print('Redshift',cons%z,ref1%z,ref2%z,error)
       if (error) return
    endif
    call cubeheader_message(seve%r,rname,'')
  end subroutine cubetools_speelt_consistency_list
  !
  subroutine cubetools_speelt_consistency_final(cons,error)
    !----------------------------------------------------------------------
    ! Final spectral element consistency
    !----------------------------------------------------------------------
    type(speelt_cons_t), intent(inout) :: cons
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPEELT>CONSISTENCY>FINAL'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call cubetools_consistency_final(cons%c,error)
    if (error) return
    call cubetools_consistency_final(cons%f,error)
    if (error) return
    call cubetools_consistency_final(cons%i,error)
    if (error) return
    call cubetools_consistency_final(cons%l,error)
    if (error) return
    call cubetools_consistency_final(cons%v,error)
    if (error) return
    call cubetools_consistency_final(cons%z,error)
    if (error) return
  end subroutine cubetools_speelt_consistency_final
end module cubetools_speelt_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	subroutine transfer (image,nimage,points,temp,npts,blanking,
     &         tol,rms,npix1,npix2,npix3,refpix,val,inc)
	integer(kind=4), intent(in) :: nimage
	real*4 refpix(3),val(3),inc(3)
	real*4 image (nimage), points(3,nimage)
	real*4 temp(npix1,npix2,npix3)

	npts=0

	do 1 k=1,npix3
	  z=val(3)+(float(k)-refpix(3))*inc(3)
	do 1 j=1,npix2
	  y=val(2)+(float(j)-refpix(2))*inc(2)
	do 1 i=1,npix1
	  x=val(1)+(float(i)-refpix(1))*inc(1)

	  if (abs(temp(i,j,k)-blanking).le.tol) goto 1
	  npts=npts+1
	  image(npts)=temp(i,j,k)/rms
 	  points(1,npts)=x
	  points(2,npts)=y
	  points(3,npts)=z

1	continue

	return
	end

module cubeadm_timing
  use gkernel_types
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_messaging
  !---------------------------------------------------------------------
  ! Module to manage timing of commands
  ! FixME: rename cubeadm_* symbols to cubedag_* everywhere
  !---------------------------------------------------------------------
  !
  public :: cubeadm_timing_init, cubeadm_timing_prepro2process, cubeadm_timing_process2postpro
  public :: cubeadm_timing_final, cubeadm_timing_collect, cubeadm_timing_variables
  public :: gag_cputime_add
  private
  !
  type command_timing_t
    type(cputime_t) :: total    ! Total execution time
    type(cputime_t) :: prepro   !
    type(cputime_t) :: process  ! Time spent processing the data
    type(cputime_t) :: postpro  !
    type(cputime_t) :: ioread   ! Reading data from disk
    type(cputime_t) :: iowrit   ! Writing data to disk
    type(cputime_t) :: trans    ! Transpositions (from memory-or-disk to memory-or-disk)
  end type command_timing_t
  !
  type(command_timing_t) :: timing  ! Main structure
  type(cputime_t) :: diff  ! Structure holding the time diff since last call
  !
contains
  !
  subroutine cubeadm_timing_init()
    !---------------------------------------------------------------------
    ! (Re)initialize the internal timing structure.
    !---------------------------------------------------------------------
    !
    call gag_cputime_init(timing%total)
    call gag_cputime_init(timing%prepro)
    call gag_cputime_init(timing%process)
    call gag_cputime_init(timing%postpro)
    call gag_cputime_init(timing%ioread)
    call gag_cputime_init(timing%iowrit)
    call gag_cputime_init(timing%trans)
    !
    call gag_cputime_init(diff)
  end subroutine cubeadm_timing_init
  !
  subroutine cubeadm_timing_prepro2process()
    !---------------------------------------------------------------------
    ! Log the preprocessing time since last call to init
    !---------------------------------------------------------------------
    call gag_cputime_add(timing%prepro,diff)
  end subroutine cubeadm_timing_prepro2process
  !
  subroutine cubeadm_timing_process2postpro()
    !---------------------------------------------------------------------
    ! Log the processing time since last call to preprocessing
    !---------------------------------------------------------------------
    call gag_cputime_add(timing%process,diff)
  end subroutine cubeadm_timing_process2postpro
  !
  subroutine cubeadm_timing_final(caller)
    !---------------------------------------------------------------------
    ! Finalize the internal timing structure.
    !---------------------------------------------------------------------
    character(len=*), intent(in) :: caller
    !
    ! Log the postprocessing time since last call to processing
    call gag_cputime_add(timing%postpro,diff)
    !
    ! Get total time for the command
    call gag_cputime_get(timing%total)
    !
    ! Feedback
    call cubeadm_timing_feedback(caller)
  end subroutine cubeadm_timing_final
  !
  subroutine cubeadm_timing_collect(ioread,iowrit,trans)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    real(kind=8), intent(in) :: ioread,iowrit,trans
    !
    timing%ioread%curr%elapsed = timing%ioread%curr%elapsed + ioread
    timing%iowrit%curr%elapsed = timing%iowrit%curr%elapsed + iowrit
    timing%trans%curr%elapsed  = timing%trans%curr%elapsed  + trans
  end subroutine cubeadm_timing_collect
  !
  subroutine cubeadm_timing_feedback(rname)
    use cubetools_format
    use cubetools_setup_types
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in) :: rname
    ! Local
    character(len=message_length) :: mess
    type(cube_setup_api_t) :: setup
    logical :: showtiming
    !
    ! Show only if requested
    call setup%timing%command%get(showtiming)
    if (.not.showtiming)  return
    !
    print *,''
    !
    write(mess,'(A)')  '--- Total ------------------------------------------------'
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time elapsed on command '//trim(rname)//':',cubetools_format_time(timing%total%diff%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,'(A)')  '--- Subdivision per processing parts ---------------------'
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time spent in preprocessing:',cubetools_format_time(timing%prepro%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time spent processing the data:',cubetools_format_time(timing%process%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time spent in postprocessing:',cubetools_format_time(timing%postpro%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,'(A)')  '--- Subdivision per disk access --------------------------'
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time elapsed reading cube(s):',cubetools_format_time(timing%ioread%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time elapsed writing cube(s):',cubetools_format_time(timing%iowrit%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,'(A)')  '--- Transpositions ---------------------------------------'
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,10)  &
      'Time elapsed transposing cube(s):',cubetools_format_time(timing%trans%curr%elapsed)
    call cubedag_message(seve%r,rname,mess)
    !
    write(mess,'(A)')  '----------------------------------------------------------'
    call cubedag_message(seve%r,rname,mess)
    !
  10 format(A,T49,A)
  end subroutine cubeadm_timing_feedback
  !
  subroutine cubeadm_timing_variables(error)
    !-------------------------------------------------------------------
    ! (Re)create the structure TIMING%
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call sic_defstructure('TIMING%',.true.,error)
    if (error) return
    ! System times
    call sic_def_dble('TIMING%TOTAL',timing%total%diff%elapsed,0,1,.true.,error)
    call sic_def_dble('TIMING%PREPRO',timing%prepro%curr%elapsed,0,1,.true.,error)
    call sic_def_dble('TIMING%PROCESS',timing%process%curr%elapsed,0,1,.true.,error)
    call sic_def_dble('TIMING%POSTPRO',timing%postpro%curr%elapsed,0,1,.true.,error)
    call sic_def_dble('TIMING%IOREAD',timing%ioread%curr%elapsed,0,1,.true.,error)
    call sic_def_dble('TIMING%IOWRIT',timing%iowrit%curr%elapsed,0,1,.true.,error)
    if (error) return
  end subroutine cubeadm_timing_variables
  !
  subroutine gag_cputime_add(sum,last)
    !---------------------------------------------------------------------
    !   Get the times since last call for 'last', and add the times to
    ! the structure 'sum'. Note that the reference times in 'sum' have
    ! not much meaning in this context.
    ! ---
    !   This subroutine is helpful to add non-contiguous time counts,
    ! while the official cputime_t is made to count times from a reference
    ! or from last call. Should this be merged in gsys?
    !---------------------------------------------------------------------
    type(cputime_t), intent(inout) :: sum
    type(cputime_t), intent(inout) :: last
    !
    call gag_cputime_get(last)
    sum%curr%elapsed = sum%curr%elapsed + last%diff%elapsed
    sum%curr%user    = sum%curr%user    + last%diff%user
    sum%curr%system  = sum%curr%system  + last%diff%system
  end subroutine gag_cputime_add
  !
end module cubeadm_timing

subroutine sic_delete(line,error)
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>sic_delete
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Support for commands
  !	DELETE/VARIABLE and DELETE/SYMBOL and DELETE/FUNCTION
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='DELETE'
  integer :: i,nl,ndelarg
  character(len=varname_length) :: name
  !
  ! Protection against order mismatch
  if (sic_present(0,1)) then
    call sic_message(seve%e,rname,'Delete arguments must come after the '//  &
    'option')
  endif
  !
  if (sic_present(1,0)) then
    ! DELETE /SYMBOL
    if (sic_present(2,0).or.sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options')
      error = .true.
      return
    endif
    ndelarg = sic_narg(1)
    do i=1,ndelarg
      call sic_ke (line,1,i,name,nl,.true.,error)
      if (error) return
      call sic_delsymbol(name(1:nl),error)
      if (error) then
        call sic_message(seve%e,rname,'Symbol '//name(1:nl)//' not deleted')
        return
      endif
    enddo
    !
  elseif (sic_present(2,0)) then
    ! DELETE /VARIABLE
    if (sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options')
      error = .true.
      return
    endif
    ndelarg = sic_narg(2)
    do i=1,ndelarg
      call sic_ch (line,2,i,name,nl,.true.,error)
      if (error) return
      call sic_delvariable(name(1:nl),.true.,error)
      if (error) then
        call sic_message(seve%e,rname,'Variable '//name(1:nl)//' not deleted')
        return
      endif
    enddo
    !
  elseif (sic_present(3,0)) then
    ! DELETE /FUNCTION
    ndelarg = sic_narg(3)
    do i=1,ndelarg
      call sic_ke(line,3,i,name,nl,.true.,error)
      if (error) return
      call sic_del_expr(name,nl,error)
      if (error)  return
    enddo
  else
    call sic_message(seve%e,rname,'Missing option')
    error = .true.
  endif
  !
end subroutine sic_delete

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtindex_types
  use gkernel_types
  use classic_api
  use mrtindex_parameters
  use mrtindex_sec_calibration
  use mrtindex_sec_science
  use mrtindex_sec_pointing
  !
  ! Here: only elements on which we will makes searches
  integer(kind=4), parameter :: mrtindex_indx_length=51
  ! Index version:
  ! * 1 never => can not be 1 in Classic V2 files
  ! * 2 on 09-JAN-2017 (going officially online @ Pico)
  ! * 3 on 01-OCT-2024 (introduce solstatus at position 39)
  ! Note that numbers 2 to 11 were used during the development phase of
  ! Mrtcal (2013 to 2016); in particular 11 was used during all year 2016.
  integer(kind=4), parameter :: mrtcal_indx_version=3
  integer(kind=4), parameter :: mrtcal_indx_mfrontend=4  ! Warning: used in data format
  type mrtindex_indx_t
    sequence
    integer(kind=8)   :: bloc                   !  1- 2: [record] Entry address
    integer(kind=4)   :: word                   !     3: [word] Position in this record
    integer(kind=4)   :: version                !     4: [---] Entry version
    integer(kind=4)   :: telescope              !     5: [code] Telescope
    character(len=12) :: source                 !  6- 8: [---] Source name
    character(len=8)  :: projid                 !  9-10: [---] Project Id
    real(kind=8)      :: ut                     ! 11-12: [rad] Observation time
    real(kind=8)      :: lst                    ! 13-14: [sec] Local Sidereal Time
    real(kind=4)      :: az                     !    15: [rad] Azimuth
    real(kind=4)      :: el                     !    16: [rad] Elevation
    real(kind=8)      :: lon                    ! 17-18: [rad] Longitude
    real(kind=8)      :: lat                    ! 19-20: [rad] Latitude
    integer(kind=4)   :: system                 !    21: [code] System of coordinates for lon-lat
    real(kind=4)      :: equinox                !    22: [year] Equinox if system is equatorial
    character(len=8)  :: frontend(mrtcal_indx_mfrontend)  ! 23-30: [char] Receiver name(s)
    integer(kind=4)   :: dobs                   !    31: [gag_date] Observation date
    integer(kind=4)   :: scan                   !    32: [---] Scan number
    integer(kind=4)   :: backend                !    33: [code] Backend
    integer(kind=4)   :: obstype                !    34: [code] Observation type
    integer(kind=4)   :: switchmode             !    35: [code] Switching mode
    integer(kind=4)   :: polstatus              !    36: [0|1] Polarimetry?
    integer(kind=4)   :: filstatus              !    37: Can read file or not?
    integer(kind=4)   :: calstatus              !    38: [code] Calibration status
    integer(kind=4)   :: solstatus              !    39: [code] Solve status
    integer(kind=4)   :: pad                    !               Memory padding
    character(len=fitsname_length) :: filename  ! 40-49: [char] File name (no directory)
    integer(kind=8)   :: itime                  ! 50-51: [usec] Last indexing time
  end type mrtindex_indx_t
  !
  ! "Section key" (copy of index, always present)
  integer(kind=4), parameter :: sec_key_id=0  ! Not a real section in file
  type mrtindex_key_t
    integer(kind=4)                :: version      ! [     ---] Entry version
    integer(kind=4)                :: telescope    ! [    code] Telescope
    character(len=8)               :: projid       ! [     ---] Project Id
    character(len=12)              :: source       ! [     ---] Source name
    integer(kind=4)                :: dobs         ! [gag_date] Observation date
    real(kind=8)                   :: ut           ! [     rad] Observation time
    real(kind=8)                   :: lst          ! [     sec] Local Sideral Time
    real(kind=4)                   :: az           ! [     rad] Azimuth
    real(kind=4)                   :: el           ! [     rad] Elevation
    real(kind=8)                   :: lon          ! [     rad] Longitude
    real(kind=8)                   :: lat          ! [     rad] Latitude
    integer(kind=4)                :: system       ! [    code] System of coordinates for lon-lat
    real(kind=4)                   :: equinox      ! [    year] Equinox if system is equatorial
    character(len=8)  :: frontend(mrtcal_indx_mfrontend)  ! [char] Receiver name(s)
    integer(kind=4)                :: scan         ! [     ---] Scan number
    integer(kind=4)                :: backend      ! [    code] Backend
    integer(kind=4)                :: obstype      ! [    code] Observation type
    integer(kind=4)                :: switchmode   ! [    code] Switching mode
    integer(kind=4)                :: polstatus    ! [     0|1] Polarimetry?
    integer(kind=4)                :: filstatus    ! [    code] Can read file or not?
    integer(kind=4)                :: calstatus    ! [    code] Calibration status
    integer(kind=4)                :: solstatus    ! [    code] Solve status
    character(len=fitsname_length) :: filename     ! [  string] File name (no directory)
  end type mrtindex_key_t
  !
  ! Section "primary" (IMBFITS primary header)
  integer(kind=4), parameter :: sec_prim_id=1
  integer(kind=8), parameter :: sec_prim_len=1_8
  type sec_primary_t
     real(kind=4)      :: imbfvers ! 1 [---] IMBFITS version
   ! real(kind=8)      :: timegoal !   [sec] Integration time declared
   ! integer(kind=4)   :: nsubgoal !   [---] Number of subscans declared
   ! integer(kind=4)   :: nsub     !   [---] Number of subscans present
  end type sec_primary_t
  !
  ! Section Tuning: for both calibration and science scans. Save the
  ! relevant tunings which were used for calibration.
  integer(kind=4), parameter :: sec_tuning_id=5
  integer(kind=8), parameter :: sec_tuning_len=0
  ! TO BE DONE
  !
  ! Header
  integer(kind=4), parameter :: mrtcal_maxsec=4  ! Maximum number of known sections
  type mrtindex_header_t
    logical               :: presec(mrtcal_maxsec) ! Which section are presents
    type(mrtindex_key_t)  :: key                   ! ~ duplicate of index
    type(sec_primary_t)   :: pri                   !
    type(sec_calib_t)     :: cal                   !
    type(sec_science_t)   :: sci                   !
    type(sec_pointing_t)  :: poi                   !
  end type mrtindex_header_t
  !
  type mrtindex_entry_t
    type(mrtindex_indx_t)       :: indx  ! The entry indx
    type(classic_entrydesc_t) :: desc  ! The entry descriptor
    type(mrtindex_header_t)     :: head  ! The entry header
  end type mrtindex_entry_t
  !
  type mrtindex_optimize_t
    integer(kind=entry_length) :: next=1  ! Number of observations in index + 1
    integer(kind=8),                pointer :: bloc(:)        =>null()  ! Bloc numbers
    integer(kind=4),                pointer :: word(:)        =>null()  ! Position in record
    integer(kind=4),                pointer :: version(:)     =>null()  ! Entry version
    integer(kind=4),                pointer :: telescope(:)   =>null()  ! Telescope code
    character(len=8),               pointer :: projid(:)      =>null()  ! Project Id
    character(len=12),              pointer :: source(:)      =>null()  ! Source name
    integer(kind=4),                pointer :: dobs(:)        =>null()  ! Observation date
    real(kind=8),                   pointer :: ut(:)          =>null()  ! Observation time
    real(kind=8),                   pointer :: lst(:)         =>null()  ! Local Sidereal time
    real(kind=4),                   pointer :: az(:)          =>null()  ! Azimuth
    real(kind=4),                   pointer :: el(:)          =>null()  ! Elevation
    real(kind=8),                   pointer :: lon(:)         =>null()  ! Longitude
    real(kind=8),                   pointer :: lat(:)         =>null()  ! Latitude
    integer(kind=4),                pointer :: system(:)      =>null()  ! System of coordinates for lon-lat
    real(kind=4),                   pointer :: equinox(:)     =>null()  ! Equinox if system is equatorial
    character(len=8),               pointer :: frontend(:,:)  =>null()  ! Receiver name(s)
    integer(kind=4),                pointer :: scan(:)        =>null()  ! Scan number
    integer(kind=4),                pointer :: backend(:)     =>null()  ! Backend code
    integer(kind=4),                pointer :: obstype(:)     =>null()  ! Obstype code
    integer(kind=4),                pointer :: switchmode(:)  =>null()  ! Switching mode
    integer(kind=4),                pointer :: polstatus(:)   =>null()  ! Polarimetry
    integer(kind=4),                pointer :: filstatus(:)   =>null()  ! File completeness
    integer(kind=4),                pointer :: calstatus(:)   =>null()  ! Calibration status
    integer(kind=4),                pointer :: solstatus(:)   =>null()  ! Solve status
    character(len=fitsname_length), pointer :: filename(:)    =>null()  ! File name (no directory)
    integer(kind=8),                pointer :: itime(:)       =>null()  ! Last indexing time
    ! Not in data
    integer(kind=entry_length),     pointer :: num(:)         =>null()  ! "Observation" number
    integer(kind=entry_length),     pointer :: mnum(:)        =>null()  ! Entry number in IX (memory)
    integer(kind=entry_length),     pointer :: fnum(:)        =>null()  ! Entry number in file
    integer(kind=entry_length),     pointer :: sort(:)        =>null()  ! Sorting list
    integer(kind=4),                pointer :: idir(:)        =>null()  ! Host directory identifier
    logical,                        pointer :: islast(:)      =>null()  ! Is this the obs. last version?
  end type mrtindex_optimize_t
  !
  type :: mrtindex_find_t
    logical            :: llast  ! Selection of last version only enabled?
    !
    logical            :: ldate  ! Selection by date enabled?
    type(sic_listi4_t) :: idate  ! Desired scan list(s), if relevant
    !
    logical            :: lscan  ! Selection by iscan enabled?
    type(sic_listi4_t) :: iscan  ! Desired scan list(s), if relevant
    !
    logical            :: lback  ! Selection by backend enabled?
    integer(kind=4)    :: iback(nbackends_mrtcal)  ! Desired backend code(s), if relevant
    !
    logical            :: lobst  ! Selection by observation type enabled?
    integer(kind=4)    :: iobst(nobstypes_mrtcal)  ! Desired obstype code(s), if relevant
    !
    logical            :: lswit  ! Selection by switching mode enabled?
    integer(kind=4)    :: iswit(nswitchmodes)  ! Desired switchmode code(s), if relevant
    !
    logical            :: lpola  ! Selection by cpola enabled?
    integer(kind=4)    :: ipola  ! Desired polarimetry status, if relevant
    !
    logical            :: lsour  ! Selection by csour enabled?
    character(len=12)  :: csour  ! Desired source name, if relevant
    !
    logical            :: lproj  ! Selection by cproj enabled?
    character(len=8)   :: cproj  ! Desired project id, if relevant
    !
    logical            :: lfron                         ! Selection by cfron enabled?
    character(len=16)  :: cfron(mrtcal_indx_mfrontend)  ! Desired frontend(s), if relevant
    !
    logical            :: lcomp  ! Selection by file completeness enabled?
    integer(kind=4)    :: icomp  ! Desired readability, if relevant
    !
    logical            :: lcali  ! Selection by calibration status enabled?
    integer(kind=4)    :: icali(ncalstatus)  ! Desired calibration status(es), if relevant
    !
    logical            :: lsolv  ! Selection by solve status enabled?
    integer(kind=4)    :: isolv(nsolstatus)  ! Desired solve status(es), if relevant
  end type mrtindex_find_t
end module mrtindex_types
!
module mrtindex_array_types
  use mrtindex_parameters
  use mrtindex_sec_calibration
  use mrtindex_sec_science
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! This module provide array-ified headers, which can be used to load
  ! a collection of headers in memory. Typically needed by command
  ! VARIABLE /INDEX
  !---------------------------------------------------------------------

  type mrtindex_key_arr_t
    integer(kind=4),                allocatable :: version(:)
    integer(kind=4),                allocatable :: telescope(:)
    character(len=8),               allocatable :: projid(:)
    character(len=12),              allocatable :: source(:)
    integer(kind=4),                allocatable :: dobs(:)
    real(kind=8),                   allocatable :: ut(:)
    real(kind=8),                   allocatable :: lst(:)
    real(kind=4),                   allocatable :: az(:)
    real(kind=4),                   allocatable :: el(:)
    real(kind=8),                   allocatable :: lon(:)
    real(kind=8),                   allocatable :: lat(:)
    integer(kind=4),                allocatable :: system(:)
    real(kind=4),                   allocatable :: equinox(:)
    character(len=8),               allocatable :: frontend(:,:)
    integer(kind=4),                allocatable :: scan(:)
    integer(kind=4),                allocatable :: backend(:)
    integer(kind=4),                allocatable :: obstype(:)
    integer(kind=4),                allocatable :: switchmode(:)
    integer(kind=4),                allocatable :: polstatus(:)
    integer(kind=4),                allocatable :: filstatus(:)
    integer(kind=4),                allocatable :: calstatus(:)
    integer(kind=4),                allocatable :: solstatus(:)
    character(len=fitsname_length), allocatable :: filename(:)
  end type mrtindex_key_arr_t

  ! Header (array)
  type mrtindex_header_arr_t
    type(mrtindex_key_arr_t)   :: key
    type(sec_calib_array_t)    :: cal
    type(sec_science_array_t)  :: sci
    type(sec_pointing_array_t) :: poi
  end type mrtindex_header_arr_t

  ! Support variable for command "VARIABLE /INDEX"
  type(mrtindex_header_arr_t), save :: mdxhead

end module mrtindex_array_types
!
module mrtindex_parse_types
  use gildas_def
  use gkernel_types
  use mrtindex_parameters
  !
  character(len=*), parameter :: user_find_allfront='* *&*'  ! Find all single-band and all dual-band
  type user_calib_t
     ! Type used for parsing CALIBRATE or FIND options. Get arguments
     ! as character strings (because '*' is often accepted), interpret
     ! them elsewhere
     character(len=128)                 :: cscan = '*'  ! Scan number (or list)
     character(len=128)                 :: cback = '*'  ! Backend string (or list)
     character(len=128)                 :: cdate = '*'  ! Date string (or list)
     character(len=128)                 :: cobst = '*'  ! Obstype (or list)
     character(len=128)                 :: cswit = '*'  ! Switchmode (or list)
     character(len=8)                   :: cpola = '*'  ! Polarimetry
     character(len=12)                  :: csour = '*'  ! Source name
     character(len=8)                   :: cproj = '*'  ! Project name
     character(len=128)  :: cfron = user_find_allfront  ! Frontend (receiver) name (or list)
     character(len=completeness_length) :: ccomp = '*'  ! File completeness
     character(len=128)                 :: ccali = '*'  ! Calibration status (or list)
     character(len=128)                 :: csolv = '*'  ! Solve status (or list)
  end type user_calib_t
  !
  type user_find_t
     ! Support for LAS\FIND hook on Mrtcal User Section. Selection criteria
     logical :: ltypes(0:nobstypes_mrtcal)  ! Obs. Types selected
  end type user_find_t
  !
  integer(kind=4), parameter :: imbfits_pattern_length=64
  type user_pattern_t
     ! Support for INDEX /PATTERN or /DATE
     logical :: bylist
     character(len=imbfits_pattern_length) :: custom    ! By user custom pattern
     type(sic_listi4_t)                    :: datelist  ! By list of dates
  end type user_pattern_t
  !
  type backend_list_t
     integer(kind=4) :: n = 0 ! Number of backends available in current scan
     integer(kind=4),                pointer :: backcode(:) => null() ! Backend code
     character(len=filename_length), pointer :: file(:)     => null() ! Associated file name
  end type backend_list_t
end module mrtindex_parse_types
!
module mrtindex_vars
  use gildas_def
  use classic_api
  use mrtindex_types
  use mrtindex_parse_types
  !
  ! ZZZ One set of buffers per file?
  type(classic_recordbuf_t) :: obufbi
  type(classic_recordbuf_t) :: obufobs
  type(classic_recordbuf_t) :: ibufbi
  type(classic_recordbuf_t) :: ibufobs
  !
  ! IX index files
  integer(kind=4) :: ix_ndir    ! Current number of index files loaded in IX
  integer(kind=4) :: ix_opened  ! Identifier of the one which is currently Fortran-opened
  character(len=filename_length), allocatable :: ix_dirs(:)   ! Directories
  type(classic_file_t),           allocatable :: ix_files(:)  ! Index files
  integer(kind=4) :: ox_fileid=0  ! Output index file (identifier)
  !
  ! Pre-reserved logical units for index files
  integer(kind=4) :: ix_lun,ox_lun
  !
end module mrtindex_vars
!
module mrtindex_messaging
  use gbl_message
  !
  type :: mrtindex_debug_message_t
    integer(kind=4) :: alloc   ! Support for MSET DEBUG INDEX ALLOCATION
    integer(kind=4) :: others  ! Support for MSET DEBUG INDEX OTHERS
  end type mrtindex_debug_message_t
  !
  ! Set the default at startup:
  !  iseve%alloc = seve%d
  !  iseve%others = seve%d
  type(mrtindex_debug_message_t) :: iseve = mrtindex_debug_message_t(seve%d,seve%d)
  !
end module mrtindex_messaging

subroutine write_fits_data (unit, iband, cmode, nsubant, subant,   &
    ldata, data , switch, error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Write the CORRDATA  fits table.
  ! it has four columns.
  ! Assume one polarization, two sidebands.
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: iband                  !
  character(len=*) :: cmode         !
  integer :: nsubant                !
  integer :: subant(nsubant)        ! selected antennas in table
  integer :: ldata                  !
  integer :: data(1)                !
  logical :: switch                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_number.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: nch, itable
  integer :: k, mf, status, nrows, tfields, varidat, ir, h_offset
  integer :: naxis, naxes(4), nvector, krow, l_offset, ib, isb, ksb
  integer :: mdigit1, mdigit2, r_npol, r_nside, k1
  integer :: ntch, ich, k0, c_offset, nsb, kd, ia, ja, ncoldata, icol
  integer :: nsubbas, subbas(mnbas), isub, i, nswitch, jr, isw
  parameter(r_npol = 1, r_nside=2, mdigit2=13, mdigit1=8)
  real*8 :: fobs, ifval
  real :: ifinc, ifref, df, af
  parameter (mf = 5)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  character(len=1) :: ccol(2),c
  character(len=2) :: c2col(2),cc
  data ttype/     'INTEGNUM', 'STARTANT', 'ENDANT',  'DATA', 'DATA'/
  data tform/     '1J',       '1J',      '1J',       '1E',   '1E'/
  data tunit/     ' ',        ' ',       ' ',     ' ',     ' '/
  data ccol/'4','5'/, c2col/'4A','5B'/
  !---------------------------------------------------------------------
  ! nutator switch simulation (switch = .true.)
  if (switch) then
    nswitch = 2
  else
    nswitch = 1
  endif
  ! the baselines in subarray subant
  nsubbas = nsubant*(nsubant-1)/2
  do i = 1, nsubbas
    subbas(i) = basant(subant(antbas(1,i)), subant(antbas(2,i)))
  enddo
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  !
  !  Define parameters for the binary table (see the above data statements)
  !
  ! Continuum Temporal data
  if (cmode(1:2).eq.'CT') then
    !c         NROWS = R_NDUMP
    nrows = nswitch*r_ndump
    nch = 1
    ntch = r_nband
    ich = iband-1
    nsb = r_nsb
    ifref = 1d0
    ifval = r_cfcen(iband)*1e6
    ifinc = r_cfwid(iband)*1e6
    itable = 1
  ! Continuum Average data
  elseif (cmode(1:2).eq.'CA') then
    nrows = 1
    nch = 1
    ntch = r_nband
    ich = iband-1
    nsb = r_nsb
    ifref = 1d0
    ifval = r_cfcen(iband)*1e6
    ifinc = r_cfwid(iband)*1e6
    itable = 3
  ! Spectral Average data
  else
    nrows = 1                  ! r_nldump
    nch = r_lnch(iband)
    ntch = r_lntch
    ich = r_lich(iband)
    nsb = r_lnsb
    ifref = r_lcench(iband)
    ifval = r_lfcen(iband)*1e6
    ifinc = r_lfres(iband)*1e6
    itable = 2
  endif
  !      print *, 'cmode, nch ', cmode, nch
  tfields = mf
  if (r_lmode.eq.1) then
    extname = 'CORRDATA-ALMATI'
    naxes(1) = 2
    naxes(2) = nch
    naxes(3) = r_npol
    ! phase corrected / uncorrected
    if (r_ndatl.eq.2 .and. cmode(1:2).ne.'CT') then
      naxes(4) = r_ndatl
      naxis = 4
    ! only uncorrected
    else
      naxes(4) = 1
      naxis = 3
    endif
    ttype(2) = 'STARTANT'
    tform(2) = '1J'
    ttype(3) = 'ENDANT'
    tform(3) = '1J'
    ttype(4) = 'DATAUSB1'
    nvector = naxes(1) * naxes(2) * naxes(3) * naxes(4)
    ncoldata = 4
    call f_tform(tform(ncoldata),nvector,'E')
    ttype(5) = 'DATALSB1'
    nvector = naxes(1) * naxes(2) * naxes(3) * naxes(4)
    tfields = 5
    call f_tform(tform(ncoldata+1),nvector,'E')
    varidat = 0
    !
    call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
      extname,varidat,status)
    call ftptdm(unit, ncoldata, naxis, naxes, status)
    call ftptdm(unit, ncoldata+1, naxis, naxes, status)
  else
    extname = 'AUTODATA-ALMATI'
    naxes(1) = nch
    naxes(2) = r_npol
    naxis = 2
    ttype(2) = 'ANTENNA'
    tform(2) = '1J'
    ttype(3) = 'DATA'
    nvector = naxes(1) * naxes(2)
    ncoldata = 3
    tfields = 3
    call f_tform(tform(ncoldata),nvector,'E')
    varidat = 0
    !
    call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
      extname,varidat,status)
    call ftptdm(unit, ncoldata, naxis, naxes, status)
  endif
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  if (status .gt. 0) goto 99
  call write_fits_dobs(unit,error)
  if (error) return
  call ftpkyj(unit,'NO_POL',r_npol,'Number of pols.',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_SIDE',r_nside,'Number of side bands',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_LO',2,'Number of LO''s',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_PHCOR',r_ndatl,'Number of phase corr. data',   &
    status)
  call ftpkyj(unit,'CHANNELS',nch,   &
    'number of channels in baseband',status)
  call ftpkyj(unit,'BASEBAND',iband,'Baseband number',status)
  call ftpkyj(unit,'TABLEID',itable,'Baseband table number ',status)
  !
  call ftpkys(unit,'TRANSITA',r_lnam(1,iband),   &
    'Line Transition A',status)
  call ftpkyd(unit,'RESTFREA',r_lrfoff(1,iband)*1d6,mdigit2,   &
    'Rest  Freq. A (Hz) at reference channel',status)
  call ftpkys(unit,'TRANSITB',r_lnam(2,iband),   &
    'Line Transition B',status)
  call ftpkyd(unit,'RESTFREB',r_lrfoff(2,iband)*1d6,mdigit2,   &
    'Rest  Freq. B (Hz) at reference channel',status)
  !      FIMAGE = R_LRFOFF(ISB,IBAND)
  !     $+(2*ISB-3)*2/(1+R_DOPPL)
  !     $*(R_FLO2-R_LFCEN(IBAND)
  !     $-(R_LRCH(ISB,IBAND)-R_LCENCH(IBAND))*R_LFRES(IBAND))
  !      CALL FTPKYD(UNIT,'IMAGFREQ',FIMAGE*1D6,MDIGIT2,
  !     $'Image Freq. (Hz) at reference channel',STATUS)
  !      call ftpkyd(unit,'IF_REF',ifref,mdigit2,
  !     &     'Reference channel',status)
  call ftpkyd(unit,'INTERFRE',ifval,mdigit2,   &
    'Intermediate Freq. (Hz) at reference channel',status)
  !      call ftpkyd(unit,'IFINC',ifinc,mdigit2,
  !     &     'IF Value at Reference channel',status)
  call ftpkyd(unit,'FREQLO1',r_flo1*1d6,mdigit2,   &
    'Local Oscillator 1',status)
  call ftpkyj(unit,'SIDEBLO1',r_isb,   &
    'Side Band LO 1',status)
  call ftpkyd(unit,'FREQLO2',r_flo1_ref*1d6,mdigit2,   &
    'Local Oscillator 2',status)
  call ftpkyj(unit,'SIDEBLO2',-1,   &
    'Side Band LO 2',status)
  if (r_flux.ne.0) then
    call ftpkye(unit,'IFLUX',r_flux,mdigit1,'Flux in I (Jy)',   &
      status)
  endif
  if (r_lmode.eq.1) then
    ! Column 4, First data axis
    do isb=1, 2
      c = ccol(isb)
      cc = c2col(isb)
      call ftpkys(unit,'1CTYP'//c,'COMPLEX','Complex axis',status)
      call ftpkye(unit,'1CRPX'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'1CRVL'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'11CD'//c,1.0,mdigit1,' ',status)
      ! Second data axis: frequency.
      call ftpkys(unit,'2CTYP'//c,'FREQ-FRQ',   &
        'Observed Frequency axis',status)
      call ftpkye(unit,'2CRPX'//c,ifref,mdigit1,   &
        'reference pixel',status)
      ksb = 3-2*isb
      fobs = (r_flo1+ksb*(r_flo1_ref-r_lfcen(iband)))*1d6
      df = -ifinc*ksb
      call ftpkyd(unit,'2CRVL'//c,fobs,mdigit2,   &
        'Observed Freq.(Hz) at ref. pixel in Hz ',status)
      call ftpkye(unit,'22CD'//c,df,mdigit1,   &
        'Channel separation in Hz ',status)
      ! Second data axis: velocity.
      if (nch.gt.1) then
        call ftpkys(unit,'2CTYP'//cc,'VRAD-FRQ',   &
          'Velocity axis',status)
        call ftpkye(unit,'2CRPX'//cc,r_lrch(isb,iband),mdigit1,   &
          'reference pixel',status)
        call ftpkyd(unit,'2CRVL'//cc,r_lvoff(isb,iband)*1d3,   &
          mdigit2,'Velocity (m/s)  at reference channel',   &
          status)
        call ftpkye(unit,'22CD'//cc,r_lvres(isb,iband)*1e3,   &
          mdigit2,'Channel spacing in velocity (m/s)',status)
        call ftpkys(unit,'2CUNI'//cc,'m/s',   &
          'Velocity unit axis',status)
        call ftpkyd(unit,'2VSOU'//cc,r_lvoff(isb,iband)*1d3,   &
          mdigit2,'Source Velocity (m/s)',status)
        call ftpkys(unit,'2SPEC'//cc,'LSRK-TOP',   &
          'Velocity System',status)
      endif
      ! Third data axis: Stokes parameters
      call ftpkys(unit,'3CTYP'//c,'STOKES','Stokes axis',status)
      call ftpkye(unit,'3CRPX'//c,1.0,mdigit1,' ',status)
      call ftpkye(unit,'3CRVL'//c,-5.0,mdigit1,' ',status)
      call ftpkye(unit,'33CD'//c,-1.0,mdigit1,' ',status)
      ! Fourth data axis: Phase correction
      if (naxis.gt.3) then
        c = ccol(isb)
        cc = c2col(isb)
        call ftpkys(unit,'4CTYP'//c,'PHASCORR',   &
          'Phase Correction',status)
        call ftpkye(unit,'4CRPX'//c,1.0,mdigit1,' ',status)
        call ftpkye(unit,'4CRVL'//c,0.0,mdigit1,' ',status)
        call ftpkye(unit,'44CD'//c,1.0,mdigit1,' ',status)
      endif
    enddo
  else
    ! Autocorrelation ...
    ! First data axis: frequency.
    call ftpkys(unit,'1CTYP3','FREQ-FRQ',   &
      'Observed Frequency axis',status)
    call ftpkye(unit,'1CRPX3',ifref,mdigit1,   &
      'reference pixel',status)
    ksb = r_isb
    fobs = (r_flo1+ksb*(r_flo1_ref-r_lfcen(iband)))*1d6
    df = -ifinc*ksb
    call ftpkyd(unit,'1CRVL3',fobs,mdigit2,   &
      'Observed Freq.(Hz) at ref. pixel in Hz ',status)
    call ftpkye(unit,'11CD3',df,mdigit1,   &
      'Channel separation in Hz ',status)
    !  First data axis: velocity
    if (nch.gt.1) then
      isb = (3-r_isb)/2
      call ftpkys(unit,'1CTYP3A','VRAD-FRQ',   &
        'Velocity axis',status)
      call ftpkye(unit,'1CRPX3A',r_lrch(isb,iband),mdigit1,   &
        'reference pixel',status)
      call ftpkyd(unit,'1CRVL3A',r_lvoff(isb,iband)*1d3,mdigit2,   &
        'Velocity (m/s)  at reference channel',status)
      call ftpkye(unit,'11CD3A',r_lvres(isb,iband)*1e3,mdigit2,   &
        'Channel spacing in velocity (m/s)',status)
      call ftpkys(unit,'1CUNI3A','m/s',   &
        'Velocity unit axis',status)
      call ftpkyd(unit,'1VSOU3A',r_lvoff(isb,iband)*1d3,mdigit2,   &
        'Source Velocity (m/s)',status)
      call ftpkys(unit,'1SPEC3A','LSRK-TOP','Velocity System',   &
        status)
    endif
    ! Third data axis: Stokes parameters
    call ftpkys(unit,'2CTYP3','STOKES','Stokes axis',status)
    call ftpkye(unit,'2CRPX3',1.0,mdigit1,' ',status)
    call ftpkye(unit,'2CRVL3',-5.0,mdigit1,' ',status)
    call ftpkye(unit,'22CD3',-1.0,mdigit1,' ',status)
  endif
  if (status .gt. 0) goto 99
  ! loop on table rows
  krow = 0
  do ir=1, nrows
    ! when simulating switching, use the same data for ON and OFF starts
    ! of one cycle.
    if (switch) then
      jr = (ir+1)/2
      isw = ir+2-2*jr
    else
      jr = ir
      isw = 0
    endif
    k = 1+ h_offset(jr)
    !c         K = 1 + H_OFFSET(IR)
    call decode_header (data(k))
    ! Continuum Temporal data
    if (cmode(1:2).eq.'CT') then
      k0 = 1 + c_offset(jr)
    ! The average data does not reflect simulated switching (for now)
    ! Continuum Average data (opt. including corrected data)
    elseif (cmode(1:2).eq.'CA') then
      k0 = 1 + c_offset(r_ndump+1)
      if (r_ndatl.eq.2) then
        k1 = 1 + c_offset(r_ndump+2)
      endif
    ! Spectral Average data (opt. including corrected data)
    else
      k0 = 1 + l_offset(r_ndump+1)
      if (r_ndatl.eq.2) then
        k1 = 1 + l_offset(r_ndump+2)
      endif
    endif
    if (r_lmode.eq.1) then
      ! Correlation: Loop on baselines
      do isub=1, nsubbas
        ib = subbas(isub)
        !
        krow = krow+1
        !
        ! Fill in the columns:
        ! INTEGNUM
        call ftpclj(unit,1,krow,1,1,dh_dump,status)
        ia = r_iant(ib)
        ja = r_jant(ib)
        ! STARTANT
        call ftpclj(unit,2,krow,1,1,antbas(1,isub),status)
        ! ENDANTEN
        call ftpclj(unit,3,krow,1,1,antbas(2,isub),status)
        ! DATA
        ! Loop on  sidebands
        icol = ncoldata
        do isb = 1, r_nside
          if (r_lcal) then
            af = sqrt(dh_atfac(1,isb,ia)*dh_atfac(1,isb,ja))
          else
            af = 1.0
          endif
          ! phase uncorrected
          kd = k0   &
            + (ich+(isb-1+(ib-1)*nsb)*ntch)*2
          call rescale(2*nch,data(kd),af)
          call ftpcle(unit,icol,krow,1,2*nch,   &
            data(kd),status)
          ! phase corrected, for averaged data only.
          if (r_ndatl.eq.2 .and. cmode(1:2).ne.'CT') then
            kd = k1   &
              + (ich+(isb-1+(ib-1)*nsb)*ntch)*2
            call rescale(2*nch,data(kd),af)
            call ftpcle(unit,icol,krow,1+2*nch,2*nch,   &
              data(kd),status)
          endif
          icol = icol+1
        enddo
      enddo
    else
      ! AutoCorrelation Loop on antennas
      do isub=1, nsubant
        ia = subant(isub)
        krow = krow+1
        !
        ! Fill in the columns:
        ! INTEGNUM
        call ftpclj(unit,1,krow,1,1,dh_dump,status)
        ! ANTENNA
        call ftpclj(unit,2,krow,1,1,isub,status)
        ! DATA
        if (r_lcal) then
          af = dh_atfac(1,1,ia)
        else
          af = 1.0
        endif
        kd = k0 + ich+(ia-1)*ntch
        call rescale(nch,data(kd),af)
        call ftpcle(unit,ncoldata,krow,1,nch,   &
          data(kd),status)
      enddo
    endif
  enddo
  if (status .gt. 0) goto 99
  return
  ! Error return
99 call printerror('WRITE_FITS_DATA',status)
  error = .true.
end subroutine write_fits_data

subroutine alma_plot_line
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Main entry for plotting ALMA Frequency setup
  !---------------------------------------------------------------------
  character(len=*), parameter :: rname='ALMA_PLOT'
  integer(kind=4) :: j, ibb, nch
  real(kind=4) :: df, dv, tmp, rffromif, cfreq
  character(len=132) :: mess
  !
  if (plot_mode.eq.10) then
     call astro_message(seve%i,rname,'Plotting mode: ALMA FREQUENCY coverage')
     call alma_plot_dsb
  elseif (plot_mode.gt.10 .and. plot_mode.lt.15) then
     ibb = plot_mode-10
     if (.not.bb_def(ibb)) then
        call astro_message(seve%e,rname,'Baseband not defined')
        return
     endif
     write(mess,'(a,i1)') 'Plotting mode: ALMA BASEBAND ', ibb
     call astro_message(seve%i,rname,mess)
     call alma_plot_baseband(ibb)
     !
     ! List the current spectral window
     !
     if (bb_nspw(ibb).ne.0) then
        write(mess,'(a,i1)') 'Current spectral windows for baseband ',ibb
        call astro_message(seve%i,rname,mess)

        call astro_message(seve%r,rname,  &
          'Spw   Width   IFcent     RFcent           RFlimits     Npol Nchan    Resolutions')
        call astro_message(seve%r,rname,  &
          '       MHz      MHz        GHz              GHz                     kHz      km/s')
  1000 format(i2,2x,f7.2,2x,f8.2,2x,f10.5,2x,f10.5,a1,f9.5,2x,i1,2x,i4,2x,f7.3,2x,f7.3)
        do j = 1,bb_nspw(ibb)
	         cfreq = spw_cfreq(ibb,j)+bb_cfreq(ibb)
	         nch = 8192/spw_polar(ibb,j)* spw_use(ibb,j) / 100 ! 15/16 counted separately below
	         df = spw_width(ibb,j)/nch*1000.  ! freq. resolution, in kHz
           nch = nch*15/16
           dv = df/1000./flo1*299792.458  ! vel. resolution, computed with FLO1
           tmp = rffromif(cfreq,bb_sideband(ibb))/1000.
           write(mess,1000) j, spw_width(ibb,j)*(15./16.), cfreq, tmp, &
                tmp-(spw_width(ibb,j)*(15./16.)/2000.),'-',tmp+(spw_width(ibb,j)*(15./16.)/2000.), &
                spw_polar(ibb,j), nch, df, dv  ! spw_use(ibb,j)
           call astro_message(seve%r,rname,mess)
        enddo
     else
        write(mess,'(a,i1)') 'No spectral window defined for baseband ',ibb
        call astro_message(seve%i,rname,mess)
     endif
  else
    call astro_message(seve%e,rname,'Initialization problem')
    return
  endif
end subroutine alma_plot_line
!
subroutine alma_plot_dsb
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of USB + LSB, as produced by the LINE command
  !---------------------------------------------------------------------
  real(kind=8) :: bandwidth, center
  integer(kind=4) :: i, ib
  real(kind=8) :: f1, f2, u1, u2
  character(len=132) :: chain, limi
  ! --------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  !
  ! IF1 bandwidth
  !
  bandwidth = abs(userlim(2)-userlim(1))/1000.
  center = userlim(1)+(userlim(2)-userlim(1))/2.
  !
  ! LSB plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 3 29 11.5 17')
  !
  ! Frequency boudaries
  !
  f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
  f2 = f1-bandwidth
  u1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
  u2 = u1+bandwidth
  !
  ! RF axis
  !
  write(chain,1040) f2,f1
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz)    LSB" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
    ! call alma_receiver(f1,u1)
    call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
    call pdbi_line_molecules(f1,f2)
  endif
  !
  ! Indicate requested tuning frequency
  !
  if (sky.eq.-1) then
    call gr_exec1('PEN 5')
    write(chain,1090) freq, 0.0 ! Gfortran is touchy
    call gr_exec1(chain)
    write(chain,1100) freq, 1.5
    call gr_exec1(chain)
    call gr_exec1('PEN 0')
  endif
  !
  ! IF1 limtis (are FLIPPED wrt RF in the LSB)
  !
  write(limi,1040) userlim(2), userlim(1)
  !
  ! IF1 axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XL')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency IF1 (MHz)" 5 /BOX 2')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Plot basebands
  !
  call alma_plot_dsb_corr(-1)
  !
  ! Label
  !
  ib = len_trim(label)
  do i = 1,len_trim(label)
    if (label(i:i).eq.'[') ib=i-1
  enddo
  call gr_exec1('PEN 1 /WEIGHT 3')
  call gr_exec1('DRAW TEXT 0 3 "'//label(1:12)//'" 6 /BOX 7')
  call gr_exec1('PEN 0')
  call gr_exec1('DRAW TEXT 0 3 "'//label(13:ib)//'" 5 /BOX 8')
  call gr_exec1('DRAW TEXT 0 3 "'//label(ib:len_trim(label))//'" 4 /BOX 9')
  !
  ! USB plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 3 29 3 8.5')
  !
  ! Frequency boundaries
  !
  f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
  f2 = f1+bandwidth
  u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
  u2 = u1-bandwidth
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 -1 "Rest frequency (GHz)    USB" /BOX 2')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
    call pdbi_line_atmos(f1,f2,u1,u2,plotwater,100)
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
    call pdbi_line_molecules(f1,f2)
  endif
  !
  ! Indicate requested tuning frequency
  !
  if (sky.eq.1) then
    call gr_exec1('PEN 5')
    write(chain,1090) freq, 0.0
    call gr_exec1(chain)
    write(chain,1100) freq, 1.5
    call gr_exec1(chain)
    call gr_exec1('PEN 0')
  endif
  !
  ! IF1 limtis
  !
  write(limi,1040) userlim(1), userlim(2)
  !
  ! IF axis
  !
  call gr_exec1(limi)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  !
  ! Y axis (dash on user limits, then continuous on hard limits)
  !
  call gr_exec1('PEN /DASH 3')
  write (chain,1050) userlim(1)
  call gr_exec1(chain)
  write (chain,1060) userlim(1)
  call gr_exec1(chain)
  write (chain,1050) userlim(2)
  call gr_exec1(chain)
  write (chain,1060) userlim(2)
  call gr_exec1(chain)
  call gr_exec1('PEN /DASH 1')
  write (chain,1050) iflim(1)
  call gr_exec1(chain)
  write (chain,1060) iflim(1)
  call gr_exec1(chain)
  write (chain,1050) iflim(2)
  call gr_exec1(chain)
  write (chain,1060) iflim(2)
  call gr_exec1(chain)
  !
  ! Plot basebands
  !
  call alma_plot_dsb_corr(1)
  !
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1050 format('DRAW RELOCATE ',f10.2,' 0 /USER')
  1060 format('DRAW LINE ',f10.2,' 5 /USER')
  1090 format('DRAW RELOCATE ',f10.2,' ',f10.2,' /USER')
  1100 format('DRAW LINE ',f10.2,' ',f10.2,' /USER')
  !
end subroutine alma_plot_dsb
!
! ----------------------------------------------------------------------
!
subroutine alma_plot_dsb_corr(sideband)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the correlator base bands onto the DSB plot
  !---------------------------------------------------------------------
  integer(kind=4) :: sideband       !
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: yoff
  character(len=256) :: chain
  !
  ! Display four possible basebands
  !
  do i = 1,4
    yoff = 0.1+0.4*i
    if ((bb_def(i)).and.(bb_sideband(i).eq.sideband)) then
      write (chain,1003) i, 1
      if (i.eq.4) write (chain,1003) 6, 1   ! nicer color
      call gr_exec1(chain)
      if (recband.eq.9) then
        call gr_exec1('SET EXPAND 0.7')
      endif
      write(chain,1000) bb_cfreq(i), yoff, i
      call gr_exec1(chain)
      if (recband.eq.9) then
        call gr_exec1('SET EXPAND 1.0')
      endif
      write (chain,1003) i, 3
      if (i.eq.4) write (chain,1003) 6, 3
      call gr_exec1(chain)
      write(chain,1001) bb_cfreq(i)-250, yoff
      call gr_exec1(chain)
      write(chain,1002) bb_cfreq(i)-1000, yoff
      call gr_exec1(chain)
      write(chain,1001) bb_cfreq(i)+250, yoff
      call gr_exec1(chain)
      write(chain,1002) bb_cfreq(i)+1000, yoff
      call gr_exec1(chain)
      !
      ! Overlay the spectral windows
      !
      call alma_plot_spectral(i,0)
    endif
  enddo
  call gr_exec1('PEN 0')
1000 format('DRAW TEXT ',f10.2,f10.2,' "BBAND ',i1,'" /USER')
1001 format('DRAW RELOCATE ',f10.2,f10.2,' /USER')
1002 format('DRAW ARROW ',f10.2,f10.2,' /USER /CLIP')
1003 format('PEN ',i2,' /DASH 1 /WEIGHT ',i2)
end subroutine alma_plot_dsb_corr
!
! ----------------------------------------------------------------------
!
subroutine alma_plot_dsb_corr_tiny(sideband,ibb)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Plot the correlator basebands onto the DSB plot
  ! sideband = +1 if USB, -1 is LSB
  !---------------------------------------------------------------------
  integer(kind=4) :: sideband       !
  integer(kind=4) :: ibb            !
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: yoff
  character(len=256) :: chain
  !
  ! Display four possible basebands
  !
  do i = 1,4
    yoff = 0.3+0.4*i
    if ((bb_def(i)).and.(bb_sideband(i).eq.sideband)) then
      write (chain,1003) i, 1
      if (i.eq.4) write (chain,1003) 6, 1   ! nicer color
      call gr_exec1(chain)
      call gr_exec1('SET EXPAND 0.5')
      write(chain,1000) bb_cfreq(i), yoff, i
      call gr_exec1(chain)
      call gr_exec1('SET EXPAND 1')
      ! call gr_exec1('PEN 1 /WEIGHT 3')
      write(chain,1001) bb_cfreq(i)-250, yoff
      call gr_exec1(chain)
      write(chain,1002) bb_cfreq(i)-1000, yoff
      call gr_exec1(chain)
      write(chain,1001) bb_cfreq(i)+250, yoff
      call gr_exec1(chain)
      write(chain,1002) bb_cfreq(i)+1000, yoff
      call gr_exec1(chain)
      !
      ! Overlay the spectral windows
      !
      call alma_plot_spectral(i,0)
      !
      ! That baseband is plotted with PLOT BASE command
      !
      if (i.eq.ibb) then
        write (chain,1003) i, 1
        if (i.eq.4) write (chain,1003) 6, 1   ! nicer color
        call gr_exec1(chain)
        write(chain,1001) bb_cfreq(i)-1000, yoff
        call gr_exec1(chain)
        if (sideband.eq.1) then ! USB
          call gr_exec1('DRAW LINE -14 -3 /BOX 1')
        else
          call gr_exec1('DRAW LINE  14 -3 /BOX 3')
        endif
        write(chain,1001) bb_cfreq(i)+1000, yoff
        call gr_exec1(chain)
        if (sideband.eq.1) then ! USB
          call gr_exec1('DRAW LINE 0 -3 /BOX 3')
        else
          call gr_exec1('DRAW LINE 0 -3 /BOX 1')
        endif
      endif
    endif
  enddo
  call gr_exec1('PEN 0')
  1000 format('DRAW TEXT ',f10.2,f10.2,' "BBAND ',i1,'" /USER')
  1001 format('DRAW RELOCATE ',f10.2,f10.2,' /USER')
  1002 format('DRAW ARROW ',f10.2,f10.2,' /USER /CLIP')
  1003 format('PEN ',i2,' /DASH 1 /WEIGHT ',i2)
end subroutine alma_plot_dsb_corr_tiny
!
! -----------------------------------------------------------------------
!
subroutine alma_plot_dsb_tiny(ibb)
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Tiny plot of USB + LSB
  !---------------------------------------------------------------------
  integer(kind=4) :: ibb            !
  ! Local
  real(kind=8) :: bandwidth, center
  real(kind=8) :: f1, f2, u1, u2
  character(len=132) :: chain, limi
  ! --------------------------------------------------------------------
  !
  ! IF1 bandwidth
  !
  bandwidth = abs(userlim(2)-userlim(1))/1000.
  center = userlim(1)+(userlim(2)-userlim(1))/2
  !
  ! LSB plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 3 15 13 16')
  !
  ! LSB frequency boundaries
  !
  f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
  f2 = f1-bandwidth
  u1 = (flo1+center)/1000.d0/fshift+bandwidth/2.
  u2 = u1+bandwidth
  !
  ! RF axis
  !
  write(chain,1040) f2,f1
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL NO')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz) - LSB" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
	  print *,'From 3'
    call pdbi_line_atmos(f1,f2,u1,u2,plotwater,50)
  endif
  call gr_exec1('BOX N N N')
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call gr_exec1('SET EXPAND 0.5')
     call pdbi_line_molecules(f1,f2)
     call gr_exec1('SET EXPAND 1')
  endif
  !
  ! Indicate requested tuning frequency
  !
  call gr_exec1('PEN 5')
  write(chain,1090) freq, 0.0
  call gr_exec1(chain)
  write(chain,1100) freq, 1.5
  call gr_exec1(chain)
  call gr_exec1('PEN 0')
  !
  ! IF1 limtis (are FLIPPED wrt RF in the LSB)
  !
  write(limi,1040) userlim(2), userlim(1)
  !
  ! Plot basebands
  !
  call gr_exec1(limi) ! must be in IF frame
  call alma_plot_dsb_corr_tiny(-1,ibb)
  !
  ! USB plot -----------------------------------------------------------
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('PEN 0')
  call gr_exec1('SET BOX 17 29 13 16')
  !
  ! USB frequency boudaries
  !
  f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
  f2 = f1+bandwidth
  u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
  u2 = u1-bandwidth
  !
  ! RF axis
  !
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XL /TICK IN /LABEL NO')
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 1 "Rest frequency (GHz) - USB" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
	  print *,'From 4'
    call pdbi_line_atmos(f1,f2,u1,u2,plotwater,50)
  endif
  call gr_exec1('BOX N N N')
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
     call gr_exec1('SET EXPAND 0.5')
     call pdbi_line_molecules(f1,f2)
     call gr_exec1('SET EXPAND 1')
  endif
  !
  ! IF1 limtis
  !
  write(limi,1040) userlim(1), userlim(2)
  !
  ! Plot basebands
  !
  call gr_exec1(limi) ! must be in IF frame
  call alma_plot_dsb_corr_tiny(1,ibb)
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1090 format('DRAW RELOCATE ',f10.2,' ',f10.2,' /USER')
  1100 format('DRAW LINE ',f10.2,' ',f10.2,' /USER')
  !
end subroutine alma_plot_dsb_tiny
!
! -----------------------------------------------------------------------
!
subroutine alma_plot_baseband(ibb)
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! Plot of the BASEBANDs
  !---------------------------------------------------------------------
  integer(kind=4) :: ibb            !
  ! Global
  logical :: gr_error
  ! Local
  integer(kind=4) :: i, ib
  real(kind=8) :: bandwidth, center, ifmin, ifmax, tmp
  real(kind=8) :: f1, f2, u1, u2
  real(kind=4) :: rffromif
  character(len=3) :: band
  character(len=132) :: chain, limi
  !
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  ! ------------------------------------------------------------------------
  !
  call gr_exec('CLEAR DIRECTORY')
  call gr_exec1('PEN 0')
  !
  ! Plot the  full receiver frequency coverage
  !
  call alma_plot_dsb_tiny(ibb)
  !
  ! Labels
  !
  call gr_exec1('SET BOX 3 29 13 16')
  ib = len_trim(label)
  do i = 1,len_trim(label)
    if (label(i:i).eq.'[') ib=i-1
  enddo
  call gr_exec1('PEN 1 /WEIGHT 3')
  call gr_exec1('DRAW TEXT 0 4 "'//label(1:12)//'" 6 /BOX 7')
  call gr_exec1('PEN 0 /WEIGHT 1')
  call gr_exec1('DRAW TEXT 0 4 "'//label(13:ib)//'" 5 /BOX 8')
  call gr_exec1('DRAW TEXT 0 4 "'//label(ib+1:len_trim(label))//'" 4 /BOX 9')
  !
  tmp = rffromif(bb_cfreq(ibb),bb_sideband(ibb))/1000.
  if (bb_sideband(ibb).eq.1) then
    write(chain,1100) ibb, bb_cfreq(ibb), 'USB' , tmp
  else
    write(chain,1100) ibb, bb_cfreq(ibb), 'LSB' , tmp
  endif
  call gr_exec1('DRAW TEXT 0 3 "'//chain(1:len_trim(chain))//'" 6 /BOX 7')
  call gr_exec1('PEN 1 /WEIGHT 3')
  call gr_exec1('DRAW TEXT 0 3 "'//chain(1:10)//'" 6 /BOX 7')
  call gr_exec1('PEN 0')
  !
  ! IF1 limits
  !
  ifmin = bb_cfreq(ibb)-1000.
  ifmax = bb_cfreq(ibb)+1000.
  bandwidth = abs(ifmax-ifmin)/1000.
  center = bb_cfreq(ibb)
  !
  ! Box
  !
  call gr_exec1('SET ORIEN 0')
  call gr_exec1('TICK 0 0 0 0')
  call gr_exec1('SET BOX 3 29 2 10')
  call gr_exec1('BOX N N N')
  if (gr_error()) return
  !
  ! RF axis
  !
  if (bb_sideband(ibb).eq.1) then    ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
    u1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    u2 = u1-bandwidth
    band = "USB"
  else                         ! LSB
    f2 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f1 = f2-bandwidth
 !   f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
 !   f2 = f1-bandwidth
    u1 = (flo1+center)/1000.d0/fshift+bandwidth/2.
    u2 = u1+bandwidth
    band = "LSB"
  endif
  write(chain,1040) f1,f2
  call gr_exec1(chain)
  call gr_exec1('AXIS XU /TICK IN /LABEL P')
  call gr_exec1('PEN 0 /DASH 1')
  call gr_exec1('DRAW TEXT 0  1 "Rest frequency (GHz) - '//band //'" /BOX 8')
  !
  ! Plot atmospheric transmission
  !
  if (do_atmplot) then
	  print *,'From 5'
    call pdbi_line_atmos(f1,f2,u1,u2,plotwater,200)
    call gr_exec1('BOX N N N')
  endif
  !
  ! Plot molecular lines
  !
  if (nmol.ge.1) then
    call pdbi_line_molecules(f1,f2)
  endif
  !
  ! IF axis
  !
  if (bb_sideband(ibb).eq.1) then  ! USB
    write(limi,1040) ifmin, ifmax
  else  ! LSB
    write(limi,1040) ifmax, ifmin
  endif
  call gr_exec1(limi)
  call gr_exec1('AXIS XL /TICK IN /LABEL P')
  call gr_exec1('DRAW TEXT 0 -1.5 "Intermediate frequency (MHz)" 5 /BOX 2')
  !
  ! Spectral units
  !
  call gr_exec1('PEN 1 /WEIGHT 1')
  call alma_plot_spectral(ibb, 0)
  call gr_exec1('PEN 0')
  !
  ! End -------------------------------------------------------------------
  !
  1040 format('LIMITS ',1pg25.16,1x,1pg25.16,' 0 5')
  1100 format('BASEBAND ',i1,' is centered at IF1 = ',f8.2,' MHz (',a3,')   RF = ',f10.5,' GHz')
  !
end subroutine alma_plot_baseband

subroutine write_sdm_AlmaCorrelatorMode(error)
  !---------------------------------------------------------------------
  ! Write the AlmaCorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_almaCorrelatorMode
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (AlmaCorrelatorModeKey) :: acmKey
  type (AlmaCorrelatorModeRow) :: acmRow
  character sdmTable*20
  parameter (sdmTable='AlmaCorrelatorMode')
  integer ier, i
  !---------------------------------------------------------------------
  ier = 0
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much *TBD* at this stage. Think of better filling this in...
  acmRow%numBaseband = r_lband
  call  allocAlmaCorrelatorModeRow(acmRow, acmRow%numBaseband, error   &
    )
  if (error) return
  do i=1, acmRow%numBaseband
    acmRow%basebandIndex(i) = i
    acmRow%basebandConfig(i) = 0
    acmRow%axesOrderArray(i) = 0
  enddo
  acmRow%accumMode = 0
  acmRow%binMode = 0
  acmRow%quantization = .true.
  acmRow%windowFunction = 'Parabolic'
  call addAlmaCorrelatorModeRow(acmKey, acmRow, error)
  if (error) return
  !
  CorrelatorMode_Id = acmKey%almaCorrelatorModeId
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_AlmaCorrelatorMode
!---------------------------------------------------------------------
subroutine get_sdm_AlmaCorrelatorMode(error)
  !---------------------------------------------------------------------
  ! Get the AlmaCorrelatorMode SDM table.
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_almaCorrelatorMode
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error
  ! Local
  type (AlmaCorrelatorModeKey) :: acmKey
  type (AlmaCorrelatorModeRow) :: acmRow
  integer ier
  integer, parameter :: maxBaseband = 8
  character  :: sdmTable*20
  parameter (sdmTable='AlmaCorrelatorMode')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much *TBD* at this stage. Think of better filling this in...
  !$$$      print *, 'CorrelatorMode_Id ', CorrelatorMode_Id
  call  allocAlmaCorrelatorModeRow(acmRow, maxBaseband, error   &
    )
  if (error) return
  acmKey%almaCorrelatorModeId  = CorrelatorMode_Id
  call getAlmaCorrelatorModeRow(acmKey, acmRow, error)
  if (error) return
  if (acmRow%numBaseband.gt.mrlband) then
    call sdmMessageI(8,3,sdmTable   &
      ,'Wrong numBaseband',acmRow%numBaseband)
    goto 99
  endif
  !
  ! ### Note: with current PDB-NG  format, if there are two polarization products (Polarization.numCorr = 2)
  ! we have to double  double the subbands. SO we should also read the POlarization table.
  ! keep num_Baseband as a global item?
  r_lband = acmRow%numBaseband
  !
  !     baseband index ???
  !
  !     ignore accumMode, binMode, quantization, windowFunction,
  !     axesOrderArray for the time being
  !
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_AlmaCorrelatorMode
!---------------------------------------------------------------------
subroutine allocAlmaCorrelatorModeRow(row, numBaseband, error)
  !---------------------------------------------------------------------
  !$$$    integer, allocatable :: basebandIndex(:)
  !$$$    integer, allocatable :: basebandConfig(:)
  !$$$    integer, allocatable :: axesOrderArray(:)
  !---------------------------------------------------------------------
  use sdm_AlmaCorrelatorMode
  type(AlmaCorrelatorModeRow) :: row
  integer :: numBaseband, ier
  logical :: error
  character, parameter :: sdmTable*8 = 'calReduction'
  !
  ! basebandIndex
  if (allocated(row%basebandIndex)) then
    deallocate(row%basebandIndex, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%basebandIndex(numBaseband), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! basebandConfig
  if (allocated(row%basebandConfig)) then
    deallocate(row%basebandConfig, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%basebandConfig(numBaseband), stat=ier)
  if (ier.ne.0) goto 99
  !
  ! axesOrderArray (dimension???)
  if (allocated(row%axesOrderArray)) then
    deallocate(row%axesOrderArray, stat=ier)
    if (ier.ne.0) goto 98
  endif
  allocate(row%axesOrderArray(numBaseband), stat=ier)
  if (ier.ne.0) goto 99
  !
  return
  !
98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
  error = .true.
  return
  !
99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
  error = .true.
  return
end subroutine allocAlmaCorrelatorModeRow

      SUBROUTINE PERIODOGRAM(LINE,ERROR)
C----------------------------------------------------------------------
C ORBIT	Support routine for command
C	PERIODOGRAM
C	Compute a Scargle periodogram (as described in ApJ 263, 835)
C Arguments :
C	LINE	C*(*)	Command line		Input
C	ERROR	L	Logical error flag	Output
C----------------------------------------------------------------------
      CHARACTER*(*) LINE
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'pi.inc'
      INCLUDE 'data.inc'
*
      INTEGER NX
      REAL XREF,XVAL,XINC,XMIN,XMAX
      INTEGER I,J
      REAL CI,SI
      REAL CIA,SIA,CI2A,SI2A,CIB,SIB,CI2B,SI2B
      REAL PERIOD(MFREQ),POWER(MFREQ)
      REAL OM,TAU
*
      CALL SIC_R4(LINE,0,1,XMIN,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_R4(LINE,0,2,XMAX,.TRUE.,ERROR)
      IF (ERROR) RETURN
      CALL SIC_I4(LINE,0,3,NX,.TRUE.,ERROR)
      IF (ERROR) RETURN
      IF (NX.GT.MFREQ) THEN
         WRITE(6,*) 'E-PERIODOGRAM,  Too many frequency points.',
     +        'Maximum is ',MFREQ
         ERROR=.TRUE.
         RETURN
      ENDIF
      NX = MAX(NX,2)
*
      XREF = 1
      XVAL = XMIN
      XINC = (XMAX-XMIN)/(NX-1)
*
      CI = 0
      SI = 0
      DO I=1,NX
         PERIOD(I) = XVAL+(I-XREF)*XINC
         IF (PERIOD(I).LE.0) THEN
            POWER(I) = 0
         ELSE
            OM = 2*PI/PERIOD(I)
            DO J=1,NVR
               CI = CI+COS(2*OM*VR(J,I_TIME))
               SI = SI+SIN(2*OM*VR(J,I_TIME))
            ENDDO
            TAU=ATAN2(SI,CI)/(2*OM)
*     
            CIA = 0
            SIA = 0
            CI2A = 0
            SI2A = 0
            CIB = 0
            SIB = 0
            CI2B = 0
            SI2B = 0
            DO J=1,NVR
               IF (STATVR(J).EQ.'OK') THEN
                  IF (CVR(J).EQ.'1') THEN
                     CIA = CIA+VR(J,I_VR)*COS(OM*(VR(J,I_TIME)-TAU))
                     SIA = SIA+VR(J,I_VR)*SIN(OM*(VR(J,I_TIME)-TAU))
                     CI2A = CI2A+COS(OM*(VR(J,I_TIME)-TAU))**2
                     SI2A = SI2A+SIN(OM*(VR(J,I_TIME)-TAU))**2
                  ELSEIF (CVR(J).EQ.'2') THEN
                     CIB = CIB+VR(J,I_VR)*COS(OM*(VR(J,I_TIME)-TAU))
                     SIB = SIB+VR(J,I_VR)*SIN(OM*(VR(J,I_TIME)-TAU))
                     CI2B = CI2B+COS(OM*(VR(J,I_TIME)-TAU))**2
                     SI2B = SI2B+SIN(OM*(VR(J,I_TIME)-TAU))**2
                  ELSE
                     WRITE(6,*) 'E-PERIODOGRAM,  Unknown velocity',
     +                    ' type',CVR(J)
                  ENDIF
               ENDIF
            ENDDO
            POWER(I) = 0
            IF (CI2A.GT.0) POWER(I) = POWER(I)+(CIA**2/CI2A)/2
            IF (SI2A.GT.0) POWER(I) = POWER(I)+(SIA**2/SI2A)/2
            IF (CI2B.GT.0) POWER(I) = POWER(I)+(CIB**2/CI2B)/2
            IF (SI2B.GT.0) POWER(I) = POWER(I)+(SIB**2/SI2B)/2
         ENDIF
      ENDDO
* Display computed periodogram
      CALL GR_EXEC('CLEAR PLOT')
      CALL GR4_GIVE('X',NX,PERIOD)
      CALL GR4_GIVE('Y',NX,POWER)
      CALL GR_EXEC('LIMITS  ')
      CALL GR_EXEC('SET BOX LANDSCAPE')
      CALL GR_EXEC('BOX')
      CALL GR_EXEC('HISTO')
*
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

subroutine xgag_input(line,error)
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_input
  !---------------------------------------------------------------------
  ! @ private
  ! GUI\PANEL "Title" HELP_FILE [/CLOSE] [/DETACH]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  logical,          intent(out) :: error  !
  ! Local
  ! Lengths of TITLE must be equal to TITLELENGTH and
  ! HLPFILELNGTH defined in structure.h to avoid problems. JP
  character(len=256) :: title
  character(len=256) :: helptxt,helpsav
  integer(kind=4) :: nd,nt,i,ier
  integer(kind=4) :: code
  ! Code = 0: non-permanent, 1: permanent
  !
  save helpsav
  !
  error = .false.
  !
  if (sic_present(1,0)) then
    ! /CLOSE
    ! delete the last detached menu or the specified one.
    if (sic_present(0,1)) then
      call sic_ch(line,0,1,helptxt,nt,.true.,error)
      if (error) return
      call sic_parse_file(helptxt,'GAG_PROC:','.hlp',helptxt)
      nt = len_trim(helptxt)
      nt = nt+1
      helptxt(nt:nt) = char(0)
    else
      helptxt = helpsav
    endif
    call xgag_end_detach(helptxt)
  else
    call sic_ch(line,0,1,title,nd,.true.,error)
    if (error) return
    call sic_ch(line,0,2,helptxt,nt,.true.,error)
    if (error) return
    call sic_parse_file(helptxt,'GAG_PROC:','.hlp',helptxt)
    nt = len_trim(helptxt)
    nt = nt+1
    helptxt(nt:nt) = char(0)
    nd = nd+1
    title(nd:nd) = char(0)
    !
    lxwindow = .true.
    !
    if (sic_present(2,0)) then
      ! /DETACH: Create a new menubar & remember the help file name.
      call xgag_detach(title,helptxt)
      helpsav = helptxt
      x_mode = 1
    else
      !
      ! Main dialog window
      x_mode =0
      code = 0
      call xgag_open(title,helptxt,code)
      do i=x_commands,1,-1
        call free_vm(x_cmdlen/4,x_string(2,i))
        call free_vm(varname_length/4,x_variab(2,i))
      enddo
      x_commands = 0
      noptscr = 0
      ! Declare the subroutine which will build the help texts
      call xgag_set_callback_help(help_button)
      !
      ! /LOG option is used for TASK language
      if (sic_present(3,0)) then
        call sic_ch(line,3,1,helptxt,nt,.true.,error)
        if (error) return
        ier = sic_getlun(xlun)
        call sic_parse_file(helptxt,' ','.save',helptxt)
        nt = len_trim(helptxt)
        open (unit=xlun,file=helptxt(1:nt),status='UNKNOWN')
        rewind(unit=xlun)
      else
        xlun = 0
      endif
      !
      if (code.eq.-1) then
        call sic_message(seve%e,'XINPUT','Cannot launch X-Window mode')
        lxwindow = .false.
        error = .true.
      endif
    endif
  endif
end subroutine xgag_input
!
subroutine xgag_menus(line,error)
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>xgag_menus
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GUI\MENU "Title"
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: nd
  character(len=32) :: command
  !
  if (x_mode.eq.0) then
    if (.not.lxwindow) then
      call sic_message(seve%e,rname,'X-Window mode not active')
      error = .true.
      return
    endif
    if (sic_present(1,0)) then
      ! /CLOSE option
      if (x_group.eq.0) then
        call sic_message(seve%e,rname,'No current group')
        error = .true.
        return
      endif
      call xgag_end_group
      x_group = 0
    elseif (sic_present(2,0)) then
      ! /CHOICES option
      call sic_ch(line,0,1,command,nd,.true.,error)
      if (error) return
      nd = nd+1
      command(nd:nd) = char(0)
      if (x_group.eq.1) call xgag_end_group
      call xgag_begin_group(command)
      x_group = 1
    else
      call sic_message(seve%e,rname,'Command invalid in this context')
      error = .true.
      return
    endif
  elseif (sic_present(1,0)) then
    ! /CLOSE option
    if (x_mode.eq.1) return
    call xgag_endmenu
    x_mode = 1                 ! Plus de menu
  else
    call sic_ch(line,0,1,command,nd,.true.,error)
    if (error) return
    nd = nd+1
    command(nd:nd) = char(0)
    if (x_mode.eq.3) then
      call xgag_endmenu
      call xgag_menu(command)
      x_mode = 2
    elseif (x_mode.ne.2) then
      call xgag_menu(command)
      x_mode = 2               ! Menu cree
    endif
  endif
  !
end subroutine xgag_menus
!
subroutine xgag_submenu(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_submenu
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! GUI\SUBMENU "Title"
  !   1      [/CLOSE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: nd
  character(len=32) :: command
  !
  if (.not.lxwindow) then
    call sic_message(seve%e,'SIC','X-Window mode not active')
    error = .true.
    return
  endif
  !
  if (sic_present(1,0)) then
    ! /CLOSE option
    if (x_mode.eq.1) return
    call xgag_endmenu
  else
    call sic_ch(line,0,1,command,nd,.true.,error)
    if (error) return
    nd = nd+1
    nd = min(nd,len(command))  ! Avoid overflow
    command(nd:nd) = char(0)
    call xgag_menu(command)
  endif
  !
end subroutine xgag_submenu
!
subroutine xgag_uri(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_uri
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for GUI Language, URI Uri Label command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=filename_length) :: uri,trans
  character(len=64) :: label
  integer(kind=4) :: nd,nb
  !
  if (.not.lxwindow) then
    call sic_message(seve%e,'SIC','X-Window mode not active')
    error = .true.
    return
  endif
  !
  ! 1) Get the URI
  call sic_ch(line,0,1,uri,nd,.true.,error)
  if (error)  return
  call sic_parse_file(uri,"","",trans)
  nd = len_trim(trans)+1
  trans(nd:nd) = char(0)
  !
  ! 2) Get the menu label
  call sic_ch(line,0,2,label,nb,.true.,error)
  if (error)  return
  nb = nb+1
  label(nb:nb) = char(0)
  !
  ! 3) Display
  call xgag_uri_menu (label,trans)
  if (x_mode.gt.1) x_mode = 3    ! Menu non-vide
  !
end subroutine xgag_uri
!
subroutine xgag_comm(line,error)
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>xgag_comm
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GUI\BUTTON Command Bouton [Title Help_file [Option_Title]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  logical,          intent(out) :: error  !
  ! Local
  character(len=256) :: command,bouton,helptxt,texte,option
  integer(kind=4) :: nd,nb,nt,nh,no
  !
  if (.not.lxwindow) then
    call sic_message(seve%e,'SIC','X-Window mode not active')
    error = .true.
    return
  endif
  error = .false.
  !
  call sic_ch(line,0,1,command,nd,.true.,error)
  if (command.ne.'*') then
    bouton = command
    nd = nd+1
    command(nd:nd) = char(0)
  else
    command = ' '
    nd = 0
  endif
  !
  call sic_ch(line,0,2,bouton,nb,.false.,error)
  nb = len_trim(bouton)+1
  bouton(nb:nb) = char(0)
  !
  ! /DETACH mode
  if (x_mode.ne.0) then
    call xgag_command (bouton,command)
    if (x_mode.gt.1) x_mode = 3    ! Menu non-vide
    return
  endif
  !
  ! Normal mode
  if (sic_present(0,3)) then
    call sic_ch(line,0,3,texte,nt,.false.,error)
  else
    texte = char(0)
    nt = 0
  endif
  !
  if (sic_present(0,4)) then
    call sic_ch(line,0,4,helptxt,nh,.false.,error)
    if (sic_query_file(helptxt,'TASK#DIR:','.hlp',helptxt)) then
    else
      call sic_parse_file(helptxt,'GAG_PROC:','.hlp',helptxt)
    endif
    nh = len_trim(helptxt)
    nh = nh+1
    helptxt(nh:nh) = char(0)
  else
    helptxt = char(0)
  endif
  !
  if (sic_present(0,5)) then
    call sic_ch(line,0,5,option,no,.false.,error)
    no = no+1
    option(no:no) = char(0)
    noptscr = noptscr+1        ! One more optional screen
  else
    option = char(0)
    nt = 0
  endif
  !
  call xgag_button (bouton,command,texte,nt,helptxt,option)
  !
end subroutine xgag_comm
!
subroutine xgag_more(bouton,command,texte,option)
  use sic_interfaces, except_this=>xgag_more
  use sic_dependencies_interfaces
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Support for command
  !   TASK\MORE
  ! Create a sub-menu in the TASK\ Window interface
  !---------------------------------------------------------------------
  character(len=*) :: bouton        !
  character(len=*) :: command       !
  character(len=*) :: texte         !
  character(len=*) :: option        !
  ! Local
  integer :: nt
  !
  noptscr = noptscr+1
  nt = len_trim(texte)
  !
  call xgag_button (bouton,command,texte,nt,help_text_file,option)
end subroutine xgag_more
!
subroutine xgag_variable(line,nline,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_variable
  use sic_dictionaries
  use sic_interactions
  use sic_structures
  use sic_types
  use let_options
  !---------------------------------------------------------------------
  ! @ private
  ! This routine fills in the widget structure that will be exchanged
  ! between the SIC-using Program and the standalone Widget Panel. The
  ! structures are defined in sic_structures.h and constructed by the C
  ! routines of sic_xgag.c
  ! The standalone widget panels define mirror structures (their C code
  ! include sic_structures.h). They communicate with SIC by setting the
  ! SIGUSER2 signal. The structure contents are exchanged via a shared
  ! memory segment, whose address is passed by xgag_dialog. The
  ! following FORTRAN code merely allocate room for strings containing
  ! variable names, prompts, options... as read on the command line. It
  ! calls then the C function to fill the C structures. Once passed to
  ! the C code, the memory allocated by the FORTRAN can be freed.
  ! REMARKS:
  ! There should not be any "null-terminated" character chain in the
  ! following FORTRAN code. All the pointers to Strings passed to the
  ! routines in sic_xgag.c should concern well-defined character arrays,
  ! of length known by the sic_xgag routines (varname_length for
  ! VARIABLES NAMES for example). It is up to the C interface routines
  ! of sic-xgag.c (and easier, too) to convert fixed-length arrays to
  ! null-terminated strings in the widgets structure, BACK AND FORTH!
  !---------------------------------------------------------------------
  !     LET Variable [Pre_loaded_value]
  !     [/NEW Type [Attr]]                         Invalid here
  !     [/PROMPT "Prompt text"]
  !     [/WHERE Logical_Expression]                Invalid here
  !     [/RANGE Min Max]
  !     [/CHOICE C1 .. CN [*]]
  !     [/FILE Filter ]
  !     [/INDEX C1 .. CN]
  !     [/SEXAGESIMAL]                             Invalid here ?
  !     [/LOWER]
  !     [/UPPER]
  !     [/FORMAT String]                           Invalid here
  !     [/NOQUOTE]                                 For VALUES in Widget modes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  integer(kind=4),  intent(in)    :: nline  !
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: upper,lower,noquote
  integer(kind=address_length) :: addr,addr1,addr2,ipx
  type(sic_descriptor_t) :: descr
  integer(kind=index_length) :: ichoi,j
  integer(kind=4) :: ii
  logical :: found
  character(len=x_cmdlen) :: chain,argum,filter
  character(len=varname_length) :: varia,svaria
  type(sic_identifier_t) :: var
  integer(kind=4) :: ier,i,nc,nx,na,nf,nv,vtype,in
  real(kind=8) :: rmin,rmax,dbl
  logical :: reado,goon,logi,resize
  !
  ! No option ==> No X-Window mode...
  goon = sic_present(optprompt,0) .or.  &
         sic_present(optrange,0) .or.  &
         sic_present(optchoice,0) .or.  &
         sic_present(optfile,0) .or.  &
         sic_present(optindex,0)
  if (.not.goon) then
    call let_variable(line,nline,error)
    return
  elseif (x_mode.gt.0) then
    call sic_message(seve%e,'SIC','Command invalid in this context')
    error = .true.
    return
  endif
  !
  ! On pourrait re-allouer, mais pour un test...
  if (x_commands.gt.m_commands) then
    call sic_message(seve%e,'SIC','Too many commands in X-Window mode')
    error = .true.
    return
  endif
  !
  noquote = sic_present(optnoquote,0)
  upper = sic_present(optupper,0)
  lower = sic_present(optlower,0)
  resize = sic_present(optresize,0)
  !
  if (upper.and.lower .or. upper.and.noquote .or. lower.and.noquote) then
    call sic_message(seve%e,'SIC','Conflicting options')
    error = .true.
    return
  endif
  !
  ! Variable name
  chain = ' '
  call sic_ke(line,0,1,chain,nc,.true.,error)
  if (error) return
  call sic_vtype(chain(1:nc),vtype,reado,error)
  if (error) then
    call sic_message(seve%e,'LET','Variable '//chain(1:nc)//' does not exists')
    return
  elseif (reado) then
    call sic_message(seve%e,'LET','Variable '//chain(1:nc)//' cannot be '//  &
    'modified')
    error = .true.
    return
  endif
  if (vtype.lt.0 .and. (upper.or.lower)) then
    call sic_message(seve%e,'SIC','Invalid option in this context')
    error = .true.
    return
  endif
  !
  ! Remember its short name
  varia = chain
  nv = index(varia,'[')
  if (nv.ne.0) then
    svaria = varia(1:nv-1)
  else
    svaria = varia
  endif
  !
  ! Old code
  !      VARIA = SVARIA
  !
  ! Allocate a character string area to store variable name (size
  ! varname_length) and UserChain (size X_CMDLEN chars)
  ier = sic_getvm(varname_length/4,addr1)
  if (ier.ne.1) then
    call sic_message(seve%e,'LET','Memory allocation failure')
    error = .true.
    return
  endif
  ier = sic_getvm(x_cmdlen/4,addr2)
  if (ier.ne.1) then
    call sic_message(seve%e,'LET','Memory allocation failure')
    error = .true.
    return
  endif
  ! Add these to the Common describing the list of variables
  ! seen by the panel:
  x_commands = x_commands+1
  x_variab(1,x_commands) = varname_length
  x_variab(2,x_commands) = addr1
  x_string(1,x_commands) = x_cmdlen
  x_string(2,x_commands) = addr2
  x_vtypes(x_commands) = vtype
  !
  ! Set the "X-Window mode" modifier in the variable status, and
  ! add the variable number to the list of X-Window variables.
  !
  var%name = svaria
  var%lname = len_trim(svaria)
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  endif
  x_number(x_commands) = in
  !
  ! Variable name...
  nc = x_variab(1,x_commands)
  addr = x_variab(2,x_commands)
  call ctodes (chain,nc,addr)
  !
  ! Pre-loaded text
  chain = ' '
  argum = ' '
  nc = 0
  do i=2,sic_narg(0)
    call sic_ch(line,0,i,argum,na,.false.,error)
    chain(nc+1:) = argum(1:na)
    nc = nc+na+1
  enddo
  nc = x_string(1,x_commands)
  addr = x_string(2,x_commands)
  call ctodes (chain,nc,addr)
  nx = len_trim(chain)
  !
  ! User prompt (Default = variable name)
  call sic_ch(line,optprompt,1,chain,nc,.false.,error)
  nc = nc+1
  chain(nc:nc) = char(0)
  !
  ! Slider
  if (sic_present(optrange,0)) then
    call sic_r8 (line,optrange,1,rmin,.true.,error)
    call sic_r8 (line,optrange,2,rmax,.true.,error)
    ipx = gag_pointer(x_string(2,x_commands),memory)
    call sic_r8 (line,0,2,dbl,.false.,error)
    call r8tor8(dbl,memory(ipx),1)
    call xgag_slider(varia,chain(1:nc),memory(ipx),rmin,rmax,noptscr)
    x_vtypes(x_commands) = x_vtypes(x_commands)+slider_offset
    !
    ! Choice or Index
  elseif (sic_present(optchoice,0).or.sic_present(optindex,0)) then
    ! Remember if index or choice
    if (sic_present(optchoice,0)) ii=optchoice
    if (sic_present(optindex,0)) ii=optindex
    x_choices=0
    do i=1,sic_narg(ii)
      !     check keyword first; if null, drop it. SIC_ST to preserve double
      !     quotes implying this is not a character variable...
      call sic_st(line,ii,i,chain,nc,.true.,error)
      if (error)  cycle
      if (nc.le.0)  cycle  ! Can this happen?
      !
      ! Test wether this could be a character variable name, possibly
      ! of dim 1. In that case, the list of choices will be made with these
      ! character chains.
      found = .false.
      call sic_descriptor (chain,descr,found)    ! Checked
      if (.not.found) then   ! normal chain
        if (chain(1:1).eq.'"') then  ! Is this test fully correct?
          ! Chain was protected with double-quotes: retrieve it without quotes,
          ! do not modify case
          call sic_ch(line,ii,i,chain,nc,.true.,error)
        else
          ! No protecting quotes: upcase
          call sic_upper(chain)
        endif
        if (error)  cycle
        !     Allocate space for the choice list.
        ier = sic_getvm(x_cholen,addr)   !allocate integers
        if (ier.ne.1) then
          call sic_message(seve%e,'LET /CHOICE','Memory allocation failure')
          error = .true.
          return
        endif
        x_choices = x_choices+1
        x_choice(2,x_choices) = addr
        x_choice(1,x_choices) = x_cholen*4   ! size for chars.
        ! Store the string choices
        call ctodes (chain,x_cholen*4,addr)
        if (x_choices.ge.m_choices) then
          call sic_message(seve%e,'LET /CHOICE','Too Many Choices (at '//  &
          chain(1:nc)//'), truncated')
          goto 10
        endif
      else
        descr%readonly = .false.
        if (descr%type.le.0) then
          ! This is not a character variable.
          ! Use the text contained in CHAIN as the value
          !     Do not printout any warning in this case
          !                     CALL GAGOUT('W-/CHOICE, Array '//
          !     $               CHAIN(1:NC)//' must be of type CHAR to be used.')
          ier = sic_getvm(x_cholen,addr) !allocate integers
          if (ier.ne.1) then
            call sic_message(seve%e,'LET /CHOICE','Memory allocation failure')
            error = .true.
            return
          endif
          x_choices = x_choices+1
          x_choice(2,x_choices) = addr
          x_choice(1,x_choices) = x_cholen*4 ! size for chars.
          call ctodes (chain,x_cholen*4,addr)
          if (x_choices.ge.m_choices) then
            call sic_message(seve%e,'LET /CHOICE','Too Many Choices (at '//  &
            chain(1:nc)//'), truncated')
            goto 10
          endif
        else
          ! This is a character array
          ! Check dimensions (must be 0 or 1)
          if (descr%ndim.gt.1) then
            call sic_message(seve%e,'LET /CHOICE','Character Array '//  &
            chain(1:nc)//' must be of Dimension 0 or 1')
            goto 999
            !
            ! Check length
          elseif (descr%type.gt.x_cholen*4) then
            call sic_message(seve%w,'LET /CHOICE','Elements of '//  &
            chain(1:nc)//' are too long, truncated')
          endif
          !     Number of choices
          ichoi = descr%dims(1)
          if (ichoi.eq.0) ichoi=1
          do j=1,ichoi
            call destoc(descr%type,descr%addr,chain)
            nc=len_trim(chain)
            if (nc.gt.0) then
              !     Allocate space for the choice(s) only if not null
              !     do the job only for valid choices
              ier = sic_getvm(x_cholen,addr) !allocate integers
              if (ier.ne.1) then
                call sic_message(seve%e,'LET /CHOICE','Memory '//  &
                'allocation failure')
                error = .true.
                return
              endif
              x_choices = x_choices+1
              x_choice(2,x_choices) = addr
              x_choice(1,x_choices) = x_cholen*4 ! size for chars.
              call ctodes (chain,x_cholen*4,addr)
              if (x_choices.ge.m_choices) then
                call sic_message(seve%e,'LET /CHOICE','Too Many Choices '//  &
                '(at '//chain(1:nc)//'), end of list ignored')
                goto 10
              endif
            endif
            ! Point to next element of table
            descr%addr = descr%addr+descr%type
          enddo
        endif  ! descr%type < or > 0
      endif  ! found / .not.found
      !
    enddo
    !
10  continue
    if (ii.eq.optchoice) then
      !     The following for /CHOICE option
      if (x_choices.eq.0) then
        !     No choice: just a fixed string, use XGAG_CH
        call sic_ch(line,optprompt,1,chain,nc,.false.,error)
        nc = nc+1
        chain(nc:nc) = char(0)
        nx = x_cmdlen
        ipx = gag_pointer(x_string(2,x_commands),memory)
        call xgag_ch (varia, chain(1:nc),memory(ipx),nx,noptscr,0)  ! Non - Editable
      elseif (chain.eq.'*') then
        !     If last choice is '*' make choice Editable
        call sic_ch(line,optprompt,1,chain,nc,.false.,error)
        nc = nc+1
        chain(nc:nc) = char(0)
        ipx = gag_pointer(x_string(2,x_commands),memory)
        nx = x_cmdlen
        call xgag_choice(varia,chain(1:nc),memory(ipx),nx,x_choice,  &
        (x_choices-1),0,noptscr)     ! hide the "*". 0 Free choice
      else
        !     Non editable
        call sic_ch(line,optprompt,1,chain,nc,.false.,error)
        nc = nc+1
        chain(nc:nc) = char(0)
        ipx = gag_pointer(x_string(2,x_commands),memory)
        nx = x_cmdlen
        call xgag_choice(varia,chain(1:nc),memory(ipx),nx,x_choice,x_choices,  &
        -1,noptscr)    ! -1 Fixed choice
      endif
    else
      ! This for /INDEX
      ! Set String according to Pre-loaded value
      call sic_i4 (line,0,2,i,.false.,error)
      if (i.gt.0 .and. i.le.x_choices) then
        ! Copy the index of the choice in 'x_string' for current 'x_commands'
        write(chain,'(I0)') i
        chain = trim(chain)//char(0)
        nc = x_string(1,x_commands)
        addr = x_string(2,x_commands)
        call ctodes(chain,nc,addr)
      endif
      !
      ! Get the field name (e.g. "Choose in this list:")
      call sic_ch(line,optprompt,1,chain,nc,.false.,error)
      nc = nc+1
      chain(nc:nc) = char(0)
      !
      ipx = gag_pointer(x_string(2,x_commands),memory)
      nx = x_cmdlen
      call xgag_choice(varia,chain(1:nc),memory(ipx),nx,x_choice,x_choices,1,  &
      noptscr)       ! 1 Index
      !
    endif
    !
    ! File
  elseif (sic_present(optfile,0)) then
    call sic_ch(line,optprompt,1,chain,nc,.false.,error)
    nc = nc+1
    chain(nc:nc) = char(0)
    filter = ""
    nf = 0
    call sic_ch(line,optfile,1,filter,nf,.false.,error)
    nf = nf+1
    filter(nf:nf) = char(0)
    ipx = gag_pointer(x_string(2,x_commands),memory)
    nx = x_cmdlen
    call xgag_file(varia,chain(1:nc),memory(ipx),nx,filter(1:nf),noptscr)
    !
    ! Logical
  elseif (vtype.eq.fmt_l) then
    ipx = gag_pointer(x_string(2,x_commands),memory)
    call sic_l4 (line,0,2,logi,.false.,error)
    if (logi) then
      call l4tol4(1,memory(ipx),1)  !  ZZZ should copy 'logi'!
    else
      call l4tol4(0,memory(ipx),1)
    endif
    call xgag_logic (varia,chain(1:nc),memory(ipx),noptscr)
    x_vtypes(x_commands) = x_vtypes(x_commands)+slider_offset
    !
    ! Normal
  else
    ipx = gag_pointer(x_string(2,x_commands),memory)
    nx = x_cmdlen
    call xgag_ch (varia,chain(1:nc),memory(ipx),nx,noptscr,1)  ! Editable
    !
    ! Anything here about /NOQUOTE ?
    if (noquote) then
      x_vtypes(x_commands) = x_vtypes(x_commands)+quote_offset
    elseif (upper) then
      x_vtypes(x_commands) = x_vtypes(x_commands)+upper_offset
    elseif  (lower) then
      x_vtypes(x_commands) = x_vtypes(x_commands)+lower_offset
    elseif (resize) then
      x_vtypes(x_commands) = x_vtypes(x_commands)+resize_offset    
    endif
  endif
  !     If choices have been allocated, purge memory:
999 continue
  do i=x_choices,1,-1
    call free_vm(x_cholen,x_choice(2,i))
  enddo
  x_choices = 0
  !
end subroutine xgag_variable
!
subroutine xgag_go(line,error)
  use sic_interfaces, except_this=>xgag_go
  use sic_dependencies_interfaces
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for commands
  !  GUI\GO  [CommandString]
  !  TASK\GO
  ! End menus (in this case call xgag_launch that activates an xmenu
  ! detached menubar, or activates a Widget panel via the call to
  ! xgag_dialog)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: abort,nc
  character(len=256) :: command
  !
  ! /DETACH
  if (x_mode.ne.0) then
    if (x_mode.gt.1) call xgag_endmenu
    error = .false.
    call xgag_launch
    x_mode = 0
    lxwindow = .false.
    return
  endif
  !
  ! XGO already typed ?
  if (.not.lxwindow) return
  !
  lxwindow = .false.
  if (x_commands.eq.0) return
  !
  ! Retrieve the command to be executed when the user will push
  ! the GO button:
  command = ' '
  nc = 0
  call sic_ch (line,0,1,command,nc,.false.,error)
  nc = nc+1
  command(nc:nc) = char(0)
  call xgag_dialog(command,abort)
  !
end subroutine xgag_go
!
subroutine xgag_end(icode,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_end
  use gildas_def
  use sic_structures
  use sic_interactions
  use sic_dictionaries
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! We come back here after the GO or ABORT button on a xmenu panel
  ! has been pressed.
  ! We write (through unit XLUN) a temporary file to hold
  ! the original commands to re-write the .init file later.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: icode  ! 0 ABORT=DISMISS, 1 ABORT=Error
  logical,         intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=varname_length) :: var
  character(len=x_cmdlen) :: expr
  character(len=x_cmdlen+2) :: string  ! Can contain 'expr' + quotes
  character(len=256) :: par
  character(len=commandline_length) :: chain
  character(len=command_length) :: command
  integer(kind=address_length) :: ipx,addr
  integer(kind=4) :: i,ne,nv,nc,abort,n_commands,inte,lt,lpar,next
  real(kind=8) :: r8
  logical :: slider, resize
  !
  ! Read back the shared memory
  call get_user_input(abort)
  if (abort.eq.-3) then
    n_commands = 0
  else
    n_commands = x_commands
    x_commands = 0
  endif
  !
  do i=1,n_commands
    if (x_vtypes(i).eq.0)  cycle
    !
    var = ' '
    nc = x_variab(1,i)
    addr = x_variab(2,i)
    call destoc(nc,addr,var)
    nv = min(len_trim(var),varname_length)
    expr = ' '
    !
    ! Real, logical, integers, etc...
    resize = .false.
    if (x_vtypes(i).gt.(resize_offset-100)) then
      resize = .true.
      x_vtypes(i) = x_vtypes(i)-resize_offset
    endif
    ! 
    if (x_vtypes(i).gt.(slider_offset-100) .and.  &
        x_vtypes(i).lt.(quote_offset-100)) then
      slider = .true.
      x_vtypes(i) = x_vtypes(i)-slider_offset
      ipx = gag_pointer(x_string(2,i),memory)
      if (x_vtypes(i).eq.fmt_l) then
        ! Logical
        call r4tor4 (memory(ipx),inte,1)
        if (inte.eq.0) then
          expr = 'NO'
          ne = 2
        else
          expr = 'YES'
          ne = 3
        endif
      else
        ! Others
        call r8tor8(memory(ipx),r8,1)
        write(expr,'(1PG23.16)') r8
        ne = len_trim(expr)
        call sic_blanc(expr,ne)
      endif
    else
      slider = .false.
      ! Character strings
      nc = x_string(1,i)
      addr = x_string(2,i)
      call destoc(nc,addr,expr)
      ne = index(expr,char(0))-1
      if (ne.gt.0) then
        ne = min(ne,len_trim(expr(1:ne)))
      else
        ne = len_trim(expr)
      endif
    endif
    if (x_vtypes(i).gt.0 .and. expr(1:1).ne.'"') then
      if (x_vtypes(i).gt.quote_offset) then
        if (xlun.ne.0) write(xlun,'(A,A,A)') expr(1:ne)
!
! Here we have to expand all "keywords" of the pseudo-string. Do this
! by a specific parsing
        next = 1
        lt = 1
        par = ' '
        string = ' '
        error = .false.
        !
        do while (.true.)
          lpar = 0
          par = ' '
          call sic_next (expr(next:),par,lpar,next)
          r8 = 0.0
          call sic_math_dble (par,lpar,r8,error)
          if (error) goto 10
          call sic_dble_to_string(r8,par)
          !
          ! Add to argument string
          string(lt:) = par
          lt = len_trim(string)+2
          if (next.gt.ne) exit
        enddo
        chain = 'SIC'//backslash//'LET '//var(1:nv)//' '//string(1:lt)//' /NOQUOTE' !!TEST
      else if (resize) then
        !
        ! No translation for Variable dimension character arrays
        chain = 'SIC'//backslash//'LET '//var(1:nv)//' '//expr(1:ne)
        if (xlun.ne.0) write(xlun,'(A,A,A)') expr(1:ne)            
      else
        if (x_vtypes(i).gt.lower_offset) then
          call sic_lower(expr)
        elseif  (x_vtypes(i).gt.upper_offset) then
          call sic_upper(expr)
        endif
!  Il y a un probleme entre les simples et doubles quotes ici
! en raison de comportement contradictoire entre le mode GUI
! et le mode terminal.
!
!  Idealement, on voudrait que le mode GUI ne traduise rien (re-ecrit dans
!  XLUN), alors que le mode terminal traduit les variables plus ou moins
!  comme SIC.
!
! Actuellement, rien n est traduit, ce qui pose un veritable probleme
! dans le fichier .par, et interdit d utiliser des expressions SIC
! generalisees.
!
!OLD!        chain = 'SIC'//backslash//'LET '//var(1:nv)//' "'//expr(1:ne)//'"'
!OLD!        if (xlun.ne.0) write(xlun,'(A,A,A)') '"',expr(1:ne),'"'
!
! Ici, pour l interpretation, on
!    - scanne les simples quotes
!    - les fait preceder ou suivre par une double quote (selon la parite)
! et pour XLUN
!    - on englobe l expression dans une double quote
! C'est ce qui se rapproche le plus d'un comportement "attendu"
!
! Get read of any trailing Null
        expr(ne+1:) = ' '
        call xgag_quote(expr,string)
        !!Print *,'after quotes '//trim(string)
        !!Print *,'after quotes '//trim(expr)
        chain = 'SIC'//backslash//'LET '//var(1:nv)//' '//trim(string)
        if (xlun.ne.0) write(xlun,'(A,A,A)') '"',expr(1:ne),'"'
      endif
! Done
    else
      call sic_upper(expr(1:ne))
      chain = 'SIC'//backslash//'LET '//var(1:nv)//' '//expr(1:ne)
      if (xlun.ne.0) write(xlun,'(A)') expr(1:ne)
    endif
    !
    nc = len_trim(chain)
    if (resize) then
      chain(nc+1:) = ' /RESIZE'
      nc = nc+8
    endif
    ! Put quickly back the VTYPE of the widget!
    if (resize) x_vtypes(i) = x_vtypes(i)+resize_offset
    if (slider) x_vtypes(i) = x_vtypes(i)+slider_offset
    nc =  len_trim(chain)
    call sic_format(chain,nc)
    call sic_analyse (command,chain,nc,error)
    if (error) goto 10
    call let_variable(chain,nc,error)
    if (error) then
      call sic_message(seve%e,'XEND','Error executing ')
      call sic_message(seve%e,'XEND',chain(1:nc))
      goto 10
    endif
  enddo
  !
10 continue
  call xgag_finish
  call trap_ctrlc
  ! Abort code
  if (abort.eq.-3) then
    ! Delete variables
    do i=x_commands,1,-1
      call free_vm(x_cmdlen/4,x_string(2,i))
      call free_vm(varname_length/4,x_variab(2,i))
    enddo
    x_commands = 0
    !
    ! True ABORT only if required by user
    if (icode.ne.0) then
      call sic_message(seve%e,'SIC','Aborted by user')
      error = .true.
    endif
  else
    x_commands = n_commands
  endif
  !
end subroutine xgag_end
!
subroutine xgag_finish
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>xgag_finish
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  if (xlun.eq.0) return
  close(unit=xlun)
  call sic_frelun(xlun)
  xlun = 0
  !
end subroutine xgag_finish

subroutine xgag_quote(expr,chain)
  use sic_interfaces, except_this=>xgag_quote
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: expr
  character(len=*), intent(out) :: chain
  ! Local
  integer(kind=4) :: i, istart, ilast, j
  logical :: apres
  !
  chain = ' '
  if (expr(1:1).eq."'") then
    j = 2 ! Bug correction on Apr 3, 2015 (was 1 before)
    chain(1:1) = "'"
    istart = 2
    apres = .true.
  else
    chain(1:1) = '"'
    j = 2
    istart = 1
    apres = .false.
  endif
  !
  ilast = len_trim(expr)
  do i=istart,ilast
    if (expr(i:i).eq."'") then
      if (apres) then
        chain(j:j+1) = expr(i:i)//'"'
        apres = .false.
      else
        chain(j:j+1) = '"'//expr(i:i)
        apres = .true.
      endif
      j = j+2
    else
      chain(j:j) = expr(i:i)
      j = j+1
    endif
  enddo
  if (.not.apres) then
    chain(j:j) = '"'
  endif
end subroutine xgag_quote

!
subroutine f_tform(ch,i,code)
  implicit none
  character(len=*) :: ch            !
  integer :: i                      !
  character(len=1) :: code          !
  ! Local
  character(len=10) :: c10
  integer :: k
  !
  write(c10,'(i10)') i
  k = 1
  do while (index(c10(k:10),' ').ne.0)
    k = k+1
  enddo
  ch = c10(k:10)//code//char(0)
end subroutine f_tform

module yesnopi
  use gbl_format
  !---------------------------------------------------------------------
  ! Support module for SIC variables which are mapped on Fortran ones.
  !---------------------------------------------------------------------
  real(kind=8),    save :: pi=3.14159265358979323846d0
  logical,         save :: yes=.true.
  logical,         save :: no=.false.
  real(kind=4),    save :: nan
  integer(kind=4), save :: type_real=fmt_r4
  integer(kind=4), save :: type_inte=fmt_i4
  integer(kind=4), save :: type_long=fmt_i8
  integer(kind=4), save :: type_dble=fmt_r8
  integer(kind=4), save :: type_logi=fmt_l
  !
end module yesnopi
!
subroutine sic_opt(pr,log,mem)
  use sic_dependencies_interfaces
  use gpack_def
  use sic_interfaces, except_this=>sic_opt
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public (but obsolete in the context of new inits (at least since
  !   2008-04-11))
  ! Please use instead:
  !  - gprompt_set(pr): to set/modify the prompt
  !  - sic_open_log(log,error): to open the log file
  !  - no routine provided to turn ON|OFF the memory stack (default ON
  !    at startup, then user can call SIC\SIC MEMORY ON|OFF
  !---------------------------------------------------------------------
  ! SIC   External routine
  !       Modify the prompt and logfile logical name and status of stack
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: pr   ! The prompt
  character(len=*), intent(in) :: log  ! The log file name
  logical,          intent(in) :: mem  ! Status of stack editor
  ! Local
  logical :: error
  !
  error = .false.
  !
  call gprompt_set(pr)
  logbuf = mem
  !
  if (loaded) return
  !
  ! Set default message filter for packages without specific message routine
  call gmessage_parse_and_set(gpack_global_id,'s=fewriu',error)
  !
  ! Check the gag environment is present
  call sic_build_environment
  !
  call sic_open_log(log,error)
  if (error) return
  !
  ! Initialize widget library
#if defined(GAG_USE_STATICLINK)
  call init_gui
#endif
  !
  call sense_inter_state  ! Selects the state (Interactive or not)
  call sic_build
  !
end subroutine sic_opt
!
subroutine sic_open_log(logf,error)
  use sic_interfaces, except_this=>sic_open_log
  use sic_structures
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Open the LOG file
  !---------------------------------------------------------------------
  character(len=*) :: logf       ! The log file name
  logical :: error               ! Logical error flag
  ! Local
  integer :: status
  character(len=filename_length) :: logfile
  !
  if (lunlog.ne.0)  return
  !
  if (logf.eq.' ')  return
  !
  status = sic_getlun(lunlog)
  if (mod(status,2).eq.0) call sysexi(status)
  call sic_parse_file(logf,'GAG_LOG:','.LOG',logfile)
  status = sic_open (lunlog,logfile,'NEW',.false.)
  if (status.ne.0) then
    call sic_message(seve%e,'SIC_OPEN_LOG','Error opening '//logf)
    call putios('E-SIC,  ',status)
    error = .true.
    call sic_frelun(lunlog)
    lunlog = 0
  endif
  !
end subroutine sic_open_log
!
subroutine sic_flush_log(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_flush_log
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Flush the LOG file buffer onto disk
  ! Arguments :
  !       ERROR   L       Error returned
  !---------------------------------------------------------------------
  logical :: error                  ! INTENT(INOUT)
  ! Local
  integer :: status
  !
  if (lunlog.eq.0) return
  status = sic_flush(lunlog)
  if (status.ne.0) then
    error = .true.
    call sic_message(seve%e,'SIC_FLUSH_LOG','Error flushing log file '//  &
    'buffer onto disk')
  endif
end subroutine sic_flush_log
!
subroutine sic_close_log(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_close_log
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Close the LOG file and free its unit
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SIC_CLOSE_LOG'
  integer(kind=4) :: status
  !
  if (lunlog.eq.0) return
  !
  status = sic_close(lunlog)
  if (status.ne.0)  error = .true.
  !
  call sic_frelun(lunlog)
  !
  lunlog = 0
  if (error) then
    call sic_message(seve%d,rname,"ERROR")
  else
    call sic_message(seve%d,rname,"SUCCESS")
  endif
  !
end subroutine sic_close_log
!
subroutine sic_build
  use ieee_arithmetic
  use gbl_message
  use sic_dependencies_interfaces
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces
  use sic_structures
  use yesnopi
  !---------------------------------------------------------------------
  ! SIC   External routine
  !       Initialize SIC
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer :: i,code,timer,ier,stbl
  logical :: error
  character(len=12) :: command
  character(len=60) :: name
  character(len=1), parameter :: backslash=char(92)
  ! SIC language
  integer, parameter :: sic_commands=98
  character(len=12) :: sic_vocab(sic_commands)
  data sic_vocab/            &
    '-@',                    &  !  1
    ' BEGIN',                &  !  2
    ' BREAK',                &  !  3
    ' CONTINUE',             &  !  4
    ' EDIT',                 &  !  5
    ' ELSE',                 &  !  6
    ' EXIT', '/NOPROMPT',    &  !  7- 8
    ' END',                  &  !  9
    ' FOR', '/IN','/WHILE',  &  ! 10-12
    '-HELP',                 &  ! 13
    '-IF',                   &  ! 14
    ' NEXT',                 &  ! 15
    '-ON',                   &  ! 16
    ' PAUSE',                &  ! 17
    '-PYTHON',               &  ! 18
    '#QUIT',                 &  ! 19
    ' RETURN',               &  ! 20
    ' TYPE', '/OUTPUT',      &  ! 21-22=mbuilt_sic_inter (update if this changes)
    ! Beyond this point, elemental commands which can not alter the
    ! standard flow of commands in the SIC interpreter
    ' ACCEPT',   '/ARRAY','/BINARY','/COLUMN','/FORMAT','/LINE',        &  ! 23-28
    ' COMPUTE',  '/BLANKING',                                           &  ! 29-30
    ' DATETIME', '/FROM','/TO',                                         &  ! 31-33
    ' DEFINE',   '/GLOBAL','/LIKE','/TRIM',                             &  ! 34-37
    ' DELETE',   '/SYMBOL','/VARIABLE','/FUNCTION',                     &  ! 38-41
    ' DIFF',                                                            &  ! 42-
    ' EXAMINE',  '/GLOBAL','/FUNCTION','/HEADER','/ADDRESS','/ALIAS',   &  ! 43-
                 '/PAGE','/SAVE',                                       &  !   -50
    ' EXECUTE',                                                         &  ! 51
    ' IMPORT',   '/DEBUG',                                              &  ! 52-53
    ! The LET option order is alphabetic, and symbolic names are given in
    ! dedicated module 'let_options'
    ' LET',      '/CHOICE','/FILE','/FORMAT','/FORMULA','/INDEX',       &  ! 54-
                 '/LOWER','/NEW','/NOQUOTE','/PROMPT','/RANGE',         &  !
                 '/REPLACE','/RESIZE','/SEXAGESIMAL','/STATUS',         &
                 '/UPPER','/WHERE',                                     &  !   -70
    ' MESSAGE',  '/FORMAT',                                             &  ! 71-72
    ' MFIT',     '/START','/STEP','/WEIGHTS','/EPSILON','/METHOD',      &  ! 73-
                 '/ITERATIONS','/QUIET','/BOUNDS',                      &  !   -81
    ' MODIFY',   '/FREQUENCY','/VELOCITY','/SPECUNIT',                  &  ! 82-85
    '-PARSE',                                                           &  ! 86
    ' RECALL',                                                          &  ! 87
    ' SAY',      '/FORMAT','/NOADVANCE',                                &  ! 88-90
    ' SIC',      '/COLOR',                                              &  ! 91-92
    ' SORT',                                                            &  ! 93
    ' SYMBOL',   '/INQUIRE',                                            &  ! 94-95
    ' SYSTEM',                                                          &  ! 96
    ' TIMER',    '/COMMAND' /                                              ! 97-98
  ! GUI language
  integer, parameter :: ngui=15
  character(len=12) :: cgui(ngui)
  data cgui/                              &
    ' BUTTON',                            &
    ' URI',                               &
    ' END',                               &
    ' ERASE',                             &
    ' GO',                                &
    ' PANEL', '/CLOSE','/DETACH','/LOG',  &
    ' MENU', '/CLOSE','/CHOICES',         &
    ' SUBMENU', '/CLOSE',                 &
    ' WAIT'/
  !
  error = .false.
  !
  ! Loaded : return
  if (loaded) return
  loaded = .true.
  !
  ! Set environment variable $GAG_PROGRAM. It is only visible to the
  ! current process and its child processes (e.g. SYSTEM command
  ! sub-shell)
  ier = sic_setenv('GAG_PROGRAM',gprompt_master)
  !
  sicinteger = fmt_i4
  sicsystemerror = .true.  ! Error from command SIC\SYSTEM ignored or not?
  nan = ieee_value(0.,ieee_quiet_nan)
  !
  ! Initialize the stack
  call init_stack
  !
  ! Initialize the loops
  bulend = 1
  !
  ! Initialize error recovery
  nerr  (0) = e_pause
  errcom(0) = 'SIC'//backslash//'PAUSE'
  !
  ! Initialize the IF blocks
  do i=1,mcif
    if_finished(i) = .true.
    if_active(i) = .false.
    if_elsefound(i) = .false.
  enddo
  if_depth(1) = 1
  if_current = 0
  nlire = 0
  ! Initialize vocabulary and help
  nlang = 0
  klang(1) = 0
  call sic_load('SIC','GAG_HELP_SIC',sic_commands,sic_vocab,'9.3    10-Apr-2016')
  ! Take the associated name help_file in the files names dictionary
  ier = sic_getlog (languages(1)%help)
  !
  ! Action related to the inter_state mode (see sense_inter_state)
  if (edit_mode) then
    tt_edit = 'GAG_HELP_MODE'
    ier = sic_getlog (tt_edit)
    help_mode = help_page
    if (tt_edit.eq.'HTML') then
      help_mode = help_html
    elseif (tt_edit.eq.'SCROLL') then
      help_mode = help_scroll
    endif
  else
    help_mode = help_scroll
  endif
  call trap_ctrlc
  !
  ! Selects logical units for HELP and macros
  call sic_lunmac_init(error)
  if (error)  return
  sicext(1) = '.pro'
  lext(1) = 4
  do i=2,maxext
    lext(i) = 0
  enddo
  !
  ! Setup the symbol and variable tables
  call sic_inisymbol(error)
  if (error)  return
  call sic_inivariable
  call sic_inifunction
  ! Setup predefined symbols
  command = 'SIC'//backslash//'SYSTEM'
  call sic_setsymbol ('SHELL',command,error)
  command = 'SIC'//backslash//'end if'
  call sic_setsymbol ('ENDIF',command,error)
  call sic_setsymbol ('SIC'//backslash//'ENDIF',command,error)
  !
  i = 0
  cur_dir = ' '
  call sic_setdir(cur_dir,i,error)
  !
  sic_precis = 'DOUBLE'
  sicprecis = fmt_r8
  !
  ! Defines standard variables
  call sic_variables(error)
  if (error) call sic_message(seve%e,rname,'Error in variables definition')
  !
  ! Defines random functions
  call sic_def_func('GAUSSIAN1D',s_gaussian1d,d_gaussian1d,3,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('NORMAL1D',s_normal1d,d_normal1d,3,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('NOISE',s_noise,d_noise,1,error,hlpfile='GAG_HELP_FUNC_SIC')
  call sic_def_func('RANDOM',s_random,d_random,1,error,hlpfile='GAG_HELP_FUNC_SIC')
  if (error) call sic_message(seve%e,rname,'Error in function definition')
  !
  ! Define the default syntax
  name = 'FREE'
  ier = sic_getlog('GAG_SYNTAX',name)
  if (name.eq.'FIXED') then
    lsynt = 1
  else
    lsynt = 2
  endif
  !
  ! Define the default editor
  tt_edit = 'GAG_EDIT'
  ier = sic_getlog (tt_edit)
  !
  ! Activate X-Window mode if needed
  if (.not.inter_state)  sic_window = .false.
  !
  call search_clients(code)    ! Search for existing clients, launch keyboard
  if (code.eq.-1)  sic_window = .false.
  !
  ! These variables are already tested by gmaster. Just here for
  ! retrocompatibility with old programs.
  if (sic_window) then
    name = 'NONE'
    ier = sic_getlog('GAG_WIDGETS',name)
    sic_window = name.ne.'NONE'
  endif
  !
#ifndef WIN32
  if (sic_window) then
    name = ''
    ier = sic_getlog ('$DISPLAY',name)  ! sic_getenv???
    sic_window = ier.eq.0
  endif
#endif
  !
  if (sic_window) then
    ier = sic_getlog('SIC_TIMER',timer)  ! Hour units
    if (ier.eq.0)  call xgag_settimer(timer*3600)
  endif
  !
  if (edit_mode.and.inter_state .and. gmaster_get_ismaster().eq.1) then
    ! Start keyboard thread loop:
    !  - only if interactive mode (i.e. we need a prompt)
    !  - only if Gildas is master (if Gildas is slave, sic_python.c will
    !    start a keyboard by itself).
    call prompt_loop(code)
    if (code.eq.-1)  sic_window = .false.
  endif
  !
  if (sic_window) then
    call sic_message(seve%d,rname,'X-Window mode active')
    call sic_begin('GUI','GAG_HELP_GUI',-ngui,cgui,'1.2    10-Sep-2003',  &
      run_gui,err_gui)
  else
    call sic_message(seve%d,rname,'Normal keyboard mode')
  endif
  !
  call load_vector             ! Test
  call init_mfit
  call init_adjust
  !
  ! Remember the GAG_PROC: directory (to be sure to remove it, and not another one)
  ier = sic_getlog('GAG_PROC:',gag_proc)
  !
  ! Set default GILDAS Data format
  stbl = 2
  ier = sic_getlog('GILDAS_HEADERS',stbl)
  call gdf_stbl(stbl,error)
  !
end subroutine sic_build
!
subroutine make_gag_magic(gag_logical)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>make_gag_magic
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Get a Gildas logical name and:
  !  1) append a magic (unique) number
  !  2) create the resulting directory
  !  3) update the value in the dictionnary
  ! Any error raised here is FATAL.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: gag_logical
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=filename_length) :: message,file
  integer(kind=4) :: ier,ln,i,magicnum
  logical :: error
  character(len=message_length) :: mess
  !
  ! 1) Append a magic number
  call sic_parse_file(gag_logical,'','',message)
  ln = len_trim(message)+1
  if (ln.gt.len(message)-10) then
    write(mess,'(A,A,I0,A)')  &
      gag_logical,' translation longer than ',len(message),' characters'
    call sic_message(seve%f,rname,mess)
    call sysexi(fatale)
  endif
  magicnum = gag_getpid()
  write(message(ln:),'(I0)')  magicnum
  ln = len_trim(message)
  !
  ! 2) Create the directory, append a letter in case of error
  error = .false.
  call gag_mkdir(message(1:ln),error)
  i = 0
  do while (error)
    message(ln:ln) = char(i+ichar('A'))
    call gag_mkdir(message(1:ln),error)
    i = i+1
    if (i.gt.26) then
      call sic_message(seve%f,rname,'Cannot create '//gag_logical//' after 26 attempts')
      call sysexi(fatale)
    endif
  enddo
  !
  ! 3) Update the dictionnary value
  ln = ln+1
  message(ln:ln) = '/'
  ier = sic_setlog(gag_logical,message(1:ln))
  file = gag_logical
  ier = sic_getlog(file)
  !
end subroutine make_gag_magic
!
subroutine make_gag(logdir)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>make_gag
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Creates input directory if it does not exist. Input must be a
  !       symbolic name.
  ! Arguments :
  !       LOGDIR     C*(*)       Symbolic name      Input
  !---------------------------------------------------------------------
  character(len=*) :: logdir        !
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=1), parameter :: backslash=char(92)
  character(len=filename_length) :: dir
  integer :: nl,nd
  logical :: exist,error
  !
  ! First, check if input in a symbolic name for a path (i.e. it ends
  ! with a ":")
  nl = len_trim(logdir)
  if (logdir(nl:nl).ne.':') then
    call sic_message(seve%e,rname,'"'//logdir(1:nl)//'" is not a symbolic '//  &
    'name')
    goto 100
  endif
  !
  ! Parse symbolic name
  call sic_parse_file(logdir,'','',dir)
  nd = len_trim(dir)
  if (dir(nd:nd).eq.'/'.or.dir(nd:nd).eq.backslash) nd=nd-1   ! Strip last slash as inquire does not like it!
  !
  ! Check if symbolic name was successfully parsed
  if (logdir(nl:nl).eq.dir(nd:nd)) then
    call sic_message(seve%e,rname,'Could not parse "'//logdir(1:nl)//'"')
    goto 100
  endif
  !
  ! Check if translation is empty
  if (dir(1:nd).eq.'') then
    call sic_message(seve%e,rname,'"'//logdir(1:nl)//'" is defined but provides empty translation')
    goto 100
  endif
  !
  ! Check if directory already exists
  inquire(file=dir(1:nd),exist=exist)
  if (.not.exist) then
    error = .false.
    call gag_mkpath(dir(1:nd),error)
    if (error) then
      call sic_message(seve%e,rname,'Cannot create directory "'//dir(1:nd)//'"')
      goto 100
    endif
  endif
  !
  ! Success
  return
  !
  ! Fatal error
100 call sic_message(seve%f,rname,'Cannot create "'//logdir(1:nl)//  &
        '" directory')
  call sysexi(fatale)
  !
end subroutine make_gag
!
subroutine sic_build_environment
  use sic_interfaces, except_this=>sic_build_environment
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Set the log file
  !---------------------------------------------------------------------
  call make_gag("gag_gag:")
  call make_gag("gag_log:")
  call make_gag("gag_scratch:")
  call make_gag("gag_init:")
  call make_gag("gag_tmp:")
  call make_gag("gag_proc:")
  !
  ! Magic ones (unique per session)
  call make_gag_magic('GAG_SCRATCH:')
  call make_gag_magic('GAG_PROC:')
  !
end subroutine sic_build_environment
!
subroutine sic_variables(error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use sic_define_status
  use sic_interactions
  use sic_python
  use sic_structures
  use yesnopi
  !---------------------------------------------------------------------
  ! @ no-interface (problem with private module sic_define_status)
  !  Define SIC variables (i.e. Sic variables owned by the SIC package)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=12), save :: prognam
  !
  call sic_def_dble ('PI',pi,0,0,.true.,error)
  call sic_def_logi ('YES',yes,.true.,error)
  call sic_def_logi ('NO',no,.true.,error)
  call sic_def_real ('NAN',nan,0,0,.true.,error)
  call sic_def_inte ('TYPE_INTE',type_inte,0,0,.true.,error)
  call sic_def_inte ('TYPE_LONG',type_long,0,0,.true.,error)
  call sic_def_inte ('TYPE_REAL',type_real,0,0,.true.,error)
  call sic_def_inte ('TYPE_DBLE',type_dble,0,0,.true.,error)
  call sic_def_inte ('TYPE_LOGI',type_logi,0,0,.true.,error)
  !
  call sic_defstructure('SIC',.true.,error)
  call sic_def_logi ('SIC%VERIFY',lverif,.false.,error)
  call sic_def_logi ('SIC%EXIST',lexist,.true.,error)
  call sic_def_logi ('SIC%INTERACTIVE',inter_state,.true.,error)
  call sic_def_inte ('SIC%CHECK_MACRO',sic_stepin,0,0,.false.,error)
  call sic_def_logi ('SIC%DEFINE_STRICT',strict_define,.false.,error)
  call sic_def_char ('SIC%EDITOR',tt_edit,.true.,error)
  call sic_def_char ('SIC%DIRECTORY',cur_dir,.true.,error)
  call sic_def_char ('SIC%PRECISION',sic_precis,.true.,error)
  call sic_def_logi ('SIC%INITWINDOW',sic_initwindow,.false.,error)
  call sic_def_logi ('SIC%ERROR',sicvar_error,.true.,error)
  call sic_def_logi ('SIC%SYSTEMERROR',sicsystemerror,.false.,error)
  !
  ! Program name
  prognam = gprompt_master
  call sic_lower (prognam)
  call sic_def_char ('SIC%PROGRAM',prognam,.true.,error)
  !
  ! Define SIC%WINDOW in a protected mode if it could not be activated
  ! automatically. Allow the User to change the mode otherwise.
  if (sic_window) then
    call sic_def_logi ('SIC%WINDOW',sic_window,.false.,error)
  else
    call sic_def_logi ('SIC%WINDOW',sic_window,.true.,error)
  endif
  !
  call sic_variables_system(error)
  if (error)  return
  call sic_variables_openmp(error)
  if (error)  return
  call sic_variables_python(error)
  if (error)  return
  call sic_variables_codes('SIC',error)
  if (error)  return
  call sic_ansi_termcodes(error)
  if (error)  return
end subroutine sic_variables
!
subroutine sic_variables_system(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_variables_system
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Define system-related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=index_length) :: dims(sic_maxdims)
  integer(kind=4) :: ib
  ! Support variables
  character(len=20), save :: architecture
  character(len=36), save :: system
  character(len=12), save :: revision_name
  character(len=12), save :: revision_commit
  character(len=25), save :: revision_date
  character(len=8),  save :: compiler_kind
  character(len=12), save :: compiler_name
  integer(kind=4),   save :: compiler_version
  character(len=8),  save :: os_kind
  character(len=8),  save :: os_name
  character(len=8),  save :: os_version
  character(len=20), save :: version
  character(len=20), save :: usernam
  character(len=20), save :: hostnam
  !
  architecture = ARCH  ! Replaced by CPP
  call sic_def_char ('SIC%ARCHITECTURE',architecture,.true.,error)
  if (error)  return
  system = SYSTEM  ! Replaced by CPP
  call sic_def_char ('SIC%SYSTEM',system,.true.,error)
  if (error)  return
  !
  ! GILDAS version
  call sic_defstructure('SIC%REVISION',.true.,error)
  if (error)  return
  revision_commit = REV_COMMIT  ! Replaced by CPP
  revision_name = REV_NAME  ! Replaced by CPP
  ib = index(revision_name,' ')
  if (ib.gt.0)  revision_name(ib:) = ' '  ! Drop refined date, if any
  revision_date = REV_DATE  ! Replaced by CPP
  call sic_def_char ('SIC%REVISION%COMMIT',revision_commit,.true.,error)
  if (error)  return
  call sic_def_char ('SIC%REVISION%NAME',revision_name,.true.,error)
  if (error)  return
  call sic_def_char ('SIC%REVISION%DATE',revision_date,.true.,error)
  if (error)  return
  !
  ! Compiler description
  call sic_defstructure('SIC%COMPILER',.true.,error)
  if (error)  return
  compiler_name = COMP_NAME  ! Replaced by CPP
#if defined(GFORTRAN)
  ! compiler_name = executable name e.g. gfortran132
  compiler_kind = 'gfortran'
  compiler_version = GFORTRAN_VERSION  ! Replaced by CPP
#elif defined(IFORT)
  ! compiler_name = executable name
  compiler_kind = 'ifort'
  compiler_version = IFORT_VERSION  ! Replaced by CPP
#endif
  call sic_def_char('SIC%COMPILER%KIND',compiler_kind,.true.,error)
  if (error)  return
  call sic_def_char('SIC%COMPILER%NAME',compiler_name,.true.,error)
  if (error)  return
  call sic_def_inte('SIC%COMPILER%VERSION',compiler_version,0,0,.true.,error)
  if (error)  return
  !
  ! OS description
  call sic_defstructure('SIC%OS',.true.,error)
  if (error)  return
  os_kind = OS_KIND  ! Replaced by CPP
  os_name = OS_NAME  ! Replaced by CPP
  os_version = OS_VERSION  ! Replaced by CPP
  call sic_def_char('SIC%OS%KIND',os_kind,.true.,error)
  if (error)  return
  call sic_def_char('SIC%OS%NAME',os_name,.true.,error)
  if (error)  return
  call sic_def_char('SIC%OS%VERSION',os_version,.true.,error)
  if (error)  return
  !
#if defined(WIN32)
  version = 'MS-Windows'
#else
  version = 'Generic-Unix'
#endif
  call sic_def_char ('SIC%VERSION',version,.true.,error)
  if (error)  return
  !
  call sic_username(usernam)
  call sic_def_char ('SIC%USER',usernam,.true.,error)
  if (error)  return
  call sic_hostname(hostnam)
  call sic_def_char ('SIC%HOST',hostnam,.true.,error)
  if (error)  return
  !
  ! Total RAM size (MB)
  call gag_ramsize(sic_ramsize)
  call sic_def_long ('SIC%RAMSIZE',sic_ramsize,0,0,.true.,error)
  if (error)  return
  !
  ! CPU caches size (kiB)
  dims(:) = 0
  dims(1) = 4
  call gag_cachesize(sic_cachel(1),sic_cachel(2),sic_cachel(3),sic_cachel(4))
  call sic_def_long ('SIC%CACHEL',sic_cachel,1,dims,.true.,error)
  if (error)  return
  !
end subroutine sic_variables_system
!
subroutine sic_variables_openmp(error)
  !$ use omp_lib
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_variables_openmp
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Define OpenMP-related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: ier,nt,ns
  !
  call sic_defstructure('SIC%OPENMP',.true.,error)
  if (error) return
  sic_omp_compiled = .false.
  !$ sic_omp_compiled = .true.
  call sic_def_logi ('SIC%OPENMP%ACTIVE',sic_omp_compiled,.true.,error)
  if (error)  return
  sic_omp_ncores = 1
  call sic_def_inte ('SIC%OPENMP%NCORES',sic_omp_ncores,0,0,.true.,error)
  if (error)  return
  sic_omp_mthreads = 1
  call sic_def_inte ('SIC%OPENMP%MTHREADS',sic_omp_mthreads,0,0,.true.,error)
  if (error)  return
  sic_omp_nthreads = 1
  call sic_def_inte ('SIC%OPENMP%NTHREADS',sic_omp_nthreads,0,0,.true.,error)
  if (error)  return
  !
  !$ sic_omp_ncores = omp_get_num_procs()       ! Logical Cores in general
  !$ nt = 0
  !$ ier = sic_getlog('$OMP_NUM_THREADS',nt)
  !$ if (nt.ne.0) then
  !$    sic_omp_mthreads = min(nt,sic_omp_ncores)  ! Maximum reasonable number...
  !$ else
  !$    sic_omp_mthreads = sic_omp_ncores          ! Maximum 1 per logical core
  !$ endif
  !$ sic_omp_ncores = sic_omp_ncores/2             ! Assume Hyper Threading
  !$ ns = 0
  !$ ier = sic_getlog('$SLURM_CPUS_PER_TASK',ns)
  !$ if (ns.ne.0) sic_omp_mthreads = min(ns,sic_omp_mthreads)
  !$
  !$ sic_omp_nthreads = sic_omp_ncores             ! Default 1 per physical core
  !$ call omp_set_num_threads(sic_omp_nthreads)
  !
end subroutine sic_variables_openmp
!
subroutine sic_variables_python(error)
  use sic_interfaces, except_this=>sic_variables_python
  use sic_interactions
  use sic_python
  !---------------------------------------------------------------------
  ! @ private
  ! Define Gildas-Python related variables in the SIC% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  logical,          save :: python_active   ! Support for SIC%PYTHON%ACTIVE
  character(len=8), save :: python_version  ! Support for SIC%PYTHON%VERSION
  logical,          save :: python_master   ! Support for SIC%PYTHON%MASTER
  !
  call sic_defstructure('SIC%PYTHON',.true.,error)
  if (error) return
  !
#if defined(GAG_USE_PYTHON)
  python_active = .true.
  python_version = PYTHON_VERSION  ! Replaced by CPP
  python_master = .not.gildas_ismaster
#else
  python_active = .false.
  python_version = ''
  python_master = .false.
#endif
  call sic_def_logi('SIC%PYTHON%ACTIVE',python_active,.true.,error)
  if (error)  return
  call sic_def_char('SIC%PYTHON%VERSION',python_version,.true.,error)
  if (error)  return
  call sic_def_logi('SIC%PYTHON%MASTER',python_master,.true.,error)
  if (error)  return
  !
  ! Old parameter for GILDAS-master
  call sic_def_logi ('SIC%MASTER',gildas_ismaster,.true.,error)
  if (error)  return
end subroutine sic_variables_python
!
subroutine sic_variables_codes(parent,error)
  use gbl_constant
  use sic_interfaces, except_this=>sic_variables_codes
  !---------------------------------------------------------------------
  ! @ private
  !  Define SIC variables providing various codes
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: parent  ! Parent structure name
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=32) :: str
  ! PROJECTION
  integer(kind=4), save :: sic_p_none=p_none
  integer(kind=4), save :: sic_p_gnomonic=p_gnomonic
  integer(kind=4), save :: sic_p_ortho=p_ortho
  integer(kind=4), save :: sic_p_azimuthal=p_azimuthal
  integer(kind=4), save :: sic_p_stereo=p_stereo
  integer(kind=4), save :: sic_p_lambert=p_lambert
  integer(kind=4), save :: sic_p_aitoff=p_aitoff
  integer(kind=4), save :: sic_p_radio=p_radio
  integer(kind=4), save :: sic_p_sfl=p_sfl
  integer(kind=4), save :: sic_p_mollweide=p_mollweide
  integer(kind=4), save :: sic_p_ncp=p_ncp
  integer(kind=4), save :: sic_p_cartesian=p_cartesian
  ! COORDINATES
  integer(kind=4), save :: sic_coord_un=type_un
  integer(kind=4), save :: sic_coord_eq=type_eq
  integer(kind=4), save :: sic_coord_ga=type_ga
  integer(kind=4), save :: sic_coord_ho=type_ho
  integer(kind=4), save :: sic_coord_ic=type_ic
  ! VELOCITY TYPES
  integer(kind=4), save :: sic_vel_unk=vel_unk
  integer(kind=4), save :: sic_vel_lsr=vel_lsr
  integer(kind=4), save :: sic_vel_hel=vel_hel
  integer(kind=4), save :: sic_vel_obs=vel_obs
  integer(kind=4), save :: sic_vel_ear=vel_ear
  integer(kind=4), save :: sic_vel_aut=vel_aut
  ! VELOCITY CONVENTIONS
  integer(kind=4), save :: sic_vconv_unk=vconv_unk
  integer(kind=4), save :: sic_vconv_rad=vconv_rad
  integer(kind=4), save :: sic_vconv_opt=vconv_opt
  integer(kind=4), save :: sic_vconv_30m=vconv_30m
  ! DATA KIND
  integer(kind=4), save :: sic_kind_spec=kind_spec
  integer(kind=4), save :: sic_kind_cont=kind_cont
  integer(kind=4), save :: sic_kind_sky=kind_sky
  integer(kind=4), save :: sic_kind_onoff=kind_onoff
  integer(kind=4), save :: sic_kind_focus=kind_focus
  ! X UNIT
  integer(kind=4), save :: sic_a_velo=a_velo
  integer(kind=4), save :: sic_a_freq=a_freq
  integer(kind=4), save :: sic_a_wave=a_wave
  ! SWITCH
  integer(kind=4), save :: sic_mod_unkn=mod_unk
  integer(kind=4), save :: sic_mod_freq=mod_freq
  integer(kind=4), save :: sic_mod_posi=mod_pos
  integer(kind=4), save :: sic_mod_fold=mod_fold
  integer(kind=4), save :: sic_mod_wobb=mod_wob
  integer(kind=4), save :: sic_mod_mixe=mod_mix
  !
  str = trim(parent)//'%CODE'
  call sic_defstructure(str,.true.,error)
  if (error) return
  !
  ! PROJECTION
  call sic_defstructure(trim(str)//'%PROJ',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%PROJ%NONE',     sic_p_none,     0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%GNOMONIC', sic_p_gnomonic, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%ORTHO',    sic_p_ortho,    0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%AZIMUTHAL',sic_p_azimuthal,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%STEREO',   sic_p_stereo,   0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%LAMBERT',  sic_p_lambert,  0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%AITOFF',   sic_p_aitoff,   0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%RADIO',    sic_p_radio,    0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%SFL',      sic_p_sfl,      0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%MOLLWEIDE',sic_p_mollweide,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%NCP',      sic_p_ncp,      0,0,.true.,error)
  call sic_def_inte(trim(str)//'%PROJ%CARTESIAN',sic_p_cartesian,0,0,.true.,error)
  if (error)  return
  !
  ! COORDINATES
  call sic_defstructure(trim(str)//'%COORD',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%COORD%UNK', sic_coord_un,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%EQU', sic_coord_eq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%GAL', sic_coord_ga,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%HOR', sic_coord_ho,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%COORD%ICRS',sic_coord_ic,0,0,.true.,error)
  if (error)  return
  !
  ! VELOCITY TYPES
  call sic_defstructure(trim(str)//'%VELO',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%VELO%UNK',  sic_vel_unk,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%LSR',  sic_vel_lsr,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%HELIO',sic_vel_hel,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%OBS',  sic_vel_obs,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%EARTH',sic_vel_ear,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%VELO%AUTO', sic_vel_aut,0,0,.true.,error)
  if (error)  return
  !
  ! VELOCITY CONVENTION
  call sic_defstructure(trim(str)//'%CONV',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%CONV%UNK',sic_vconv_unk,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%RAD',sic_vconv_rad,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%OPT',sic_vconv_opt,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%CONV%30M',sic_vconv_30m,0,0,.true.,error)
  !
  ! DATA KIND
  call sic_defstructure(trim(str)//'%KIND',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%KIND%SPEC', sic_kind_spec, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%CONT', sic_kind_cont, 0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%SKY',  sic_kind_sky,  0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%ONOFF',sic_kind_onoff,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%KIND%FOCUS',sic_kind_focus,0,0,.true.,error)
  if (error)  return
  !
  ! X UNIT
  call sic_defstructure(trim(str)//'%XUNIT',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%XUNIT%VELO',sic_a_velo,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%XUNIT%FREQ',sic_a_freq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%XUNIT%WAVE',sic_a_wave,0,0,.true.,error)
  if (error)  return
  !
  ! SWITCH
  call sic_defstructure(trim(str)//'%SWITCH',.true.,error)
  if (error) return
  call sic_def_inte(trim(str)//'%SWITCH%UNKNOWN',sic_mod_unkn,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%FREQ',   sic_mod_freq,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%POSI',   sic_mod_posi,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%FOLD',   sic_mod_fold,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%WOBBLER',sic_mod_wobb,0,0,.true.,error)
  call sic_def_inte(trim(str)//'%SWITCH%MIXED',  sic_mod_mixe,0,0,.true.,error)
  if (error)  return
  !
end subroutine sic_variables_codes
!
subroutine sic_ansi_termcodes(error)
  use sic_interfaces, except_this=>sic_ansi_termcodes
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ private
  ! Define and populate the ANSI% structure
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Support variables for the ANSI% variables
  character(len=5), save :: sic_ansi_black=c_black
  character(len=5), save :: sic_ansi_red=c_red
  character(len=5), save :: sic_ansi_green=c_green
  character(len=5), save :: sic_ansi_yellow=c_yellow
  character(len=11), save :: sic_ansi_orange=c_orange
  character(len=5), save :: sic_ansi_blue=c_blue
  character(len=5), save :: sic_ansi_magenta=c_magenta
  character(len=5), save :: sic_ansi_cyan=c_cyan
  character(len=5), save :: sic_ansi_white=c_white
  character(len=4), save :: sic_ansi_clear=c_clear
  character(len=4), save :: sic_ansi_bold=c_bold
  character(len=4), save :: sic_ansi_under=c_under
  character(len=4), save :: sic_ansi_reverse=c_reverse
  character(len=4), save :: sic_ansi_blink=c_blink
  !
  call sic_defstructure('ANSI',.true.,error)
  if (error)  return
  call sic_def_char('ANSI%RED',sic_ansi_red,.true.,error)
  call sic_def_char('ANSI%GREEN',sic_ansi_green,.true.,error)
  call sic_def_char('ANSI%YELLOW',sic_ansi_yellow,.true.,error)
  call sic_def_char('ANSI%ORANGE',sic_ansi_orange,.true.,error)
  call sic_def_char('ANSI%BLUE',sic_ansi_blue,.true.,error)
  call sic_def_char('ANSI%MAGENTA',sic_ansi_magenta,.true.,error)
  call sic_def_char('ANSI%CYAN',sic_ansi_cyan,.true.,error)
  call sic_def_char('ANSI%WHITE',sic_ansi_white,.true.,error)
  call sic_def_char('ANSI%BLACK',sic_ansi_black,.true.,error)
  call sic_def_char('ANSI%NONE',sic_ansi_clear,.true.,error)
  call sic_def_char('ANSI%BOLD',sic_ansi_bold,.true.,error)
  call sic_def_char('ANSI%UNDERLINE',sic_ansi_under,.true.,error)
  call sic_def_char('ANSI%REVERSE',sic_ansi_reverse,.true.,error)
  call sic_def_char('ANSI%BLINK',sic_ansi_blink,.true.,error)
  ! Clear is duplicated under %ZERO so that it comes last when
  ! typing EXA ANSI. This leaves the terminal in default mode.
  call sic_def_char('ANSI%ZERO',sic_ansi_clear,.true.,error)
  if (error)  return
  !
end subroutine sic_ansi_termcodes

!
subroutine convert_dh (iwin,nw,conve,nant,nbas,nband,npol)
  use gbl_convert
  use classic_api
  !---------------------------------------------------------------------
  !	Convert data header IWIN using conversion code CONVE,
  !	assuming NW is the length of the data header.
  ! Arguments
  !	IWIN	I(*)	Array containing data header to be converted
  !	NW	I	Size of IWIN
  !	CONVE	I	Conversion code
  !	NANT	I	Number of antennas
  !	NBAS	I	Number of baselines
  !---------------------------------------------------------------------
  integer :: iwin(*)                !
  integer(kind=data_length) :: nw                     !
  integer :: conve                  !
  integer :: nant                   !
  integer :: nbas                   !
  integer :: nband                  !
  integer :: npol                   !
  ! Global
  external :: r4tor4,r8tor8
  external :: ier4va,eir4va,eir4ie,ier4ei,var4ie,var4ei
  external :: ier8va,eir8va,eir8ie,ier8ei,var8ie,var8ei
  external ::        eii4va,eii4ie,iei4ei       ,vai4ei
  include 'clic_parameter.inc'
  !
  !------------------------------------------------------------------------
  ! Code:
  ! test the conversion works
  if (conve.eq.0) then
    return
  ! test it works ...
  !$$$         CALL CONVERT_DHSUB (IWIN,NW,NANT,NBAS,NBAND,NPOL,
  !$$$     &   R4TOR4,R8TOR8,R4TOR4,R4TOR4)
  elseif (conve.eq.vax_to_ieee .or. conve.eq.vax_fr_ieee) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      var4ie,var8ie,r4tor4,r4tor4)
  elseif (conve.eq.ieee_to_vax .or. conve.eq.ieee_fr_vax) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      ier4va,ier8va,r4tor4,r4tor4)
  elseif (conve.eq.vax_to_eeei .or. conve.eq.vax_fr_eeei) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      var4ei,var8ei,vai4ei,r4tor4)
  elseif (conve.eq.ieee_to_eeei .or. conve.eq.ieee_fr_eeei) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      ier4ei,ier8ei,iei4ei,r4tor4)
  elseif (conve.eq.eeei_to_vax .or. conve.eq.eeei_fr_vax) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      eir4va,eir8va,eii4va,r4tor4)
  elseif (conve.eq.eeei_to_ieee .or. conve.eq.eeei_fr_ieee) then
    call convert_dhsub (iwin,nw,nant,nbas,nband,npol,   &
      eir4ie,eir8ie,eii4ie,r4tor4)
  endif
end subroutine convert_dh
!
subroutine convert_dhsub(iwin,nw,nant,nbas,nband,npol,r4,r8,i4,cc)
  use classic_api
  use clic_file
  !---------------------------------------------------------------------
  !	Convert data header IWIN using conversion code CONVE,
  !	assuming NW is the length of the data header.
  ! Arguments
  !	IWIN	I(*)	Array containing data header to be converted
  !	NW	I	Size of IWIN
  !	CONVE	I	Conversion code
  !	NANT	I	Number of antennas
  !	NBAS	I	Number of baselines
  !---------------------------------------------------------------------
  integer :: iwin(*)                !
  integer(kind=data_length) :: nw                     !
  integer :: nant                   !
  integer :: nbas                   !
  integer :: nband                  !
  integer :: npol                   !
  external :: r4                    !
  external :: r8                    !
  external :: i4                    !
  external :: cc                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: k, temp_dim, natfac
  real*8 ::  rtmp(8)
  !------------------------------------------------------------------------
  ! Code:
  !$$$      print *, 'CONVERT_DHSUB , NW,NANT,NBAS,NBAND,NPOL'
  !$$$      print *, NW,NANT,NBAS,NBAND,NPOL
  call i4 (iwin(1),iwin(1),2)  ! Dump + obs MJ date
  call r4 (iwin(3),iwin(3),1)  ! Integ
  !
  !      CALL R8 (IWIN(4),IWIN(4),8) ! UTC + Svec(3)
  call r4tor4(iwin(4),rtmp,16) ! Alignment problems
  call r8 (rtmp,rtmp,8)
  call r4tor4(rtmp,iwin(4),8)
  !
  if (de%version.le.2) then
    call r4 (iwin(12),iwin(12),10)   ! Test0
    k = 22
  else
    call r4 (iwin(12),iwin(12),10)   ! Test0
    k = 32
  endif
  call i4 (iwin(22),iwin(22),nant) ! A Flag
  k = k+nant
  if (new_receivers) then
    if (r_dobs.lt.(-6406)) then    ! changed the 13/02/2007
      temp_dim = npol
    else
      temp_dim = 2
    endif
    call r4 (iwin(k),iwin(k), temp_dim*nant)   ! Total
    k = k+npol*nant
  else
    call r4 (iwin(k),iwin(k),nant) ! Total
    k = k+nant
  endif
  if (new_receivers) then
    natfac = max(npol,nband)
    call r4 (iwin(k),iwin(k),2*natfac*nant)    ! atfac
    k = k+2*natfac*nant
  else
    call r4 (iwin(k),iwin(k),2*nant)   ! atfac
    k = k+2*nant
  endif
  call r4 (iwin(k),iwin(k),2*nant) ! rmspe 
  k = k+2*nant
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),nant) !  delcon
    k = k+nant
  endif
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),npol*nant)    ! dellin
    k = k+npol*nant
  else
    call r4 (iwin(k),iwin(k),nant) ! dellin
    k = k+nant
  endif
  call r4 (iwin(k),iwin(k),nant)   ! delayc
  k = k+nant
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),npol*nant)    ! delay
    k = k+npol*nant
  else
    !ccc         CALL R4 (IWIN(K),IWIN(K),NPOL*NANT) ! delay
    call r4 (iwin(k),iwin(k),nant) ! delay
    k = k+nant
  endif
  call r4 (iwin(k),iwin(k),4*nant) ! phasec to cable
  k = k+4*nant
  if (de%version.le.2) then
    call i4 (iwin(k),iwin(k),nant)   ! Gamme
    k = k + nant
  endif
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),5*nant) ! Test1
    k = k + 5*nant
  else
    call r4 (iwin(k),iwin(k),20*nant) ! Test1
    k = k + 20*nant
  endif
  if (new_receivers) then
    call r4 (iwin(k),iwin(k),4*npol*nbas)  ! RMS Amp & Pha
    k = k + 4*npol*nbas
  else
    call r4 (iwin(k),iwin(k),4*nbas)   ! RMS Amp & Pha
    k = k + 4*nbas
  endif
  call r4 (iwin(k),iwin(k),3*nant) ! Offsets (Foc,Lam,Bet)
  k = k + 3*nant
  call i4 (iwin(k),iwin(k),nbas)   ! B Flag
  k = k + nbas
  call r4 (iwin(k),iwin(k),2*nbas) ! UV 
  k = k + 2*nbas
  if (de%version.le.2) then
    call r4 (iwin(k),iwin(k),4*nbas) ! Infac
    k = k + 4*nbas
  endif
  if (k.lt.nw) then
    call r4 (iwin(k),iwin(k),mwvrch*nant)  ! DH_wvr
    k = k + mwvrch*nant
    call i4 (iwin(k),iwin(k),nant) ! DH_wvrstat
    k = k + nant
  endif
  if (k.lt.nw) then
    call r4 (iwin(k),iwin(k),npol*nant*nband)  ! DH_ACTP
    k = k + 2*nant*nband
    call r4 (iwin(k),iwin(k),2*nant)   ! DH_ANTP
    k = k + 2*nant
  endif
  if (r_nband_widex.ne.0) then
    call r4 (iwin(k),iwin(k),nant)     ! dh_sflag
    k = k + nant
    call r4 (iwin(k),iwin(k),nbas)     ! dh_sbflag
    k = k + nbas
  endif
  if (de%version.ge.3) then
    call r4 (iwin(k),iwin(k),nant)     ! dh_cable_alternate
    k = k + nant
    call r4 (iwin(k),iwin(k),1)        ! dh_ntime
    dh_ntime = iwin(k)
    k = k + 1
    if (dh_ntime.gt.0) then
      call r4 (iwin(k),iwin(k),dh_ntime)     ! dh_time
      k = k + dh_ntime
    endif
    call r4 (iwin(k),iwin(k),3*nant)     ! incli, incli_temp
    k = k + 3* nant
    call r4 (iwin(k),iwin(k),5*nant)     ! tilfoc,offfoc
    k = k + 5* nant
  endif
  ! trick to get the size (for data fillers).
  if (nw .gt. 999999) then
    nw = k-1
  !
  elseif (k.gt.nw+1) then      ! R_LDPAR is actually more (142) ...
    write(6,*) 'CONVERT_DHSUB: Wrong data record K,NANT,NBAS,NW'
    write(6,*) k,nant,nbas,nw
  endif
end subroutine convert_dhsub
!
subroutine convert_data (ndata,data,jconve)
  use gbl_convert
  integer :: ndata                  !
  integer :: data(*)                !
  integer :: jconve                 !
  ! Global
  !
  if (jconve.eq.0) then
    return
  elseif (jconve.eq.vax_to_ieee .or. jconve.eq.vax_fr_ieee) then
    call var4ie (data,data,ndata)
  elseif (jconve.eq.ieee_to_vax .or. jconve.eq.ieee_fr_vax) then
    call ier4va (data,data,ndata)
  elseif (jconve.eq.vax_to_eeei .or. jconve.eq.vax_fr_eeei) then
    call var4ei (data,data,ndata)
  elseif (jconve.eq.ieee_to_eeei .or. jconve.eq.ieee_fr_eeei) then
    call ier4ei (data,data,ndata)
  elseif (jconve.eq.eeei_to_vax .or. jconve.eq.eeei_fr_vax) then
    call eir4va (data,data,ndata)
  elseif (jconve.eq.eeei_to_ieee .or. jconve.eq.eeei_fr_ieee) then
    call eir4ie (data,data,ndata)
  else
    return
  endif
end subroutine convert_data

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBESIMULATE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesimulate_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: simulateseve
  public :: cubesimulate_message_set_id,cubesimulate_message,cubesyntax_message
  public :: cubesimulate_message_set_alloc,cubesimulate_message_get_alloc
  public :: cubesimulate_message_set_trace,cubesimulate_message_get_trace
  public :: cubesimulate_message_set_others,cubesimulate_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubesimulate_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubesimulate_messaging_debug_t
     integer(kind=code_k) :: alloc = seve%d
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubesimulate_messaging_debug_t
  !
  type(cubesimulate_messaging_debug_t) :: simulateseve
  !
contains
  !
  subroutine cubesimulate_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubesimulate_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubesimulate_message_id
    call cubesimulate_message(seve%d,rname,mess)
  end subroutine cubesimulate_message_set_id
  !
  subroutine cubesimulate_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubesimulate_message_id,mkind,'IMA>'//procname,message)
  end subroutine cubesimulate_message
  !
  subroutine cubesyntax_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    !***JP: Provisoire!
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubesimulate_message_id,mkind,'IMA>'//procname,message)
  end subroutine cubesyntax_message
  !
  subroutine cubesimulate_message_set_alloc(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       simulateseve%alloc = seve%i
    else
       simulateseve%alloc = seve%d
    endif
  end subroutine cubesimulate_message_set_alloc
  !
  subroutine cubesimulate_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       simulateseve%trace = seve%i
    else
       simulateseve%trace = seve%t
    endif
  end subroutine cubesimulate_message_set_trace
  !
  subroutine cubesimulate_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       simulateseve%others = seve%i
    else
       simulateseve%others = seve%d
    endif
  end subroutine cubesimulate_message_set_others
  !
  function cubesimulate_message_get_alloc()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubesimulate_message_get_alloc
    !
    cubesimulate_message_get_alloc = simulateseve%alloc.eq.seve%i
    !
  end function cubesimulate_message_get_alloc
  !
  function cubesimulate_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubesimulate_message_get_trace
    !
    cubesimulate_message_get_trace = simulateseve%trace.eq.seve%i
    !
  end function cubesimulate_message_get_trace
  !
  function cubesimulate_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubesimulate_message_get_others
    !
    cubesimulate_message_get_others = simulateseve%others.eq.seve%i
    !
  end function cubesimulate_message_get_others
end module cubesimulate_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_header
  use cubetools_parameters
  use cubetools_structure
  use cubeio_dataformat_types
  use cubetuple_format_class
  use cubeadm_cubeid_types
  use cubemain_messaging
  !
  public :: header
  private
  !
  type :: header_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(dataformat_opt_t)      :: format
     type(datadescr_opt_t)       :: descr
     type(option_t),     pointer :: history
   contains
     procedure, public  :: register => cubemain_header_register
     procedure, private :: parse    => cubemain_header_parse
     procedure, private :: main     => cubemain_header_main
  end type header_comm_t
  type(header_comm_t) :: header
  !
  type header_user_t
     type(cubeid_user_t)  :: cubeids
     integer(kind=code_k) :: format = code_dataformat_cube
     integer(kind=code_k) :: descr  = code_dataformat_none
     logical              :: dohistory = .false.
   contains
     procedure, private :: toprog => cubemain_header_user_toprog
  end type header_user_t
  !
  type header_prog_t
     class(format_t), pointer :: cube
     integer(kind=code_k) :: format
     integer(kind=code_k) :: descr
     logical              :: dohistory = .false.
   contains
     procedure, private :: list => cubemain_header_prog_list
  end type header_prog_t
  !
contains
  !
  subroutine cubemain_header_command(line,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(header_user_t) :: user
    character(len=*), parameter :: rname='HEADER>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call header%parse(line,user,error)
    if (error) return
    call header%main(user,error)
    if (error) return
  end subroutine cubemain_header_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_register(header,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(header_comm_t), intent(inout) :: header
    logical,              intent(inout) :: error
    !
    !
    type(cubeid_arg_t) :: cubearg
    character(len=*), parameter :: rname='HEADER>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'HEADER','[cubeid]',&
         'List the cube header',&
         'The header can be shown in different formats by using&
         & option /FORMAT',&
         cubemain_header_command,&
         header%comm,error)
    if (error) return
    call cubearg%register(&
         'CUBEID',&
         'Input cube identifier',&
         'If omitted, use the last matching cube (any family/flags) in the&
         & default index (DAG by default; see SET\INDEX).',&
         code_arg_optional,&
         [flag_any],&
         code_read_head,&
         code_access_any,&
         header%cube,&
         error)
    if (error) return
    call header%format%register(error)
    if (error) return
    call header%descr%register(error)
    if (error) return
    call cubetools_register_option(&
         'HISTORY','',&
         'Also display the cube ancestors in addition to the header',&
         strg_emp,&
         header%history,&
         error)
    if (error) return
  end subroutine cubemain_header_register
  !
  subroutine cubemain_header_parse(header,line,user,error)
    !-------------------------------------------------------------------
    ! Parsing facility for command
    !   HEADER [cube]
    !   /FORMAT format
    !   /DESCR format
    !   /HISTORY
    !-------------------------------------------------------------------
    class(header_comm_t), intent(in)    :: header
    character(len=*),     intent(in)    :: line
    type(header_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,header%comm,user%cubeids,error)
    if (error) return
    !
    call header%format%parse(line,user%format,error)
    if (error) return
    call header%descr%parse(line,user%descr,error)
    if (error) return
    call header%history%present(line,user%dohistory,error)
    if (error) return
  end subroutine cubemain_header_parse
  !
  subroutine cubemain_header_main(header,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(header_comm_t), intent(in)    :: header
    type(header_user_t),  intent(in)    :: user
    logical,              intent(inout) :: error
    !
    type(header_prog_t) :: prog
    character(len=*), parameter :: rname='HEADER>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%list(error)
    if (error) return
  end subroutine cubemain_header_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_user_toprog(user,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(header_user_t), intent(in)    :: user
    type(header_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>USER>TOPROG'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    prog%format = user%format
    prog%descr = user%descr
    prog%dohistory = user%dohistory
    !
    if (prog%descr.eq.code_dataformat_none) then
      ! /DESCR was omitted => /FORMAT invoked or implicit => need a cube header
      call cubeadm_get_fheader(header%cube,user%cubeids,prog%cube,error)
      if (error) return
    endif
  end subroutine cubemain_header_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_header_prog_list(prog,error)
    use cubetools_header_vo
    use cubedag_history, only: cubedag_history_docube
    use cubedag_tuple
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(header_prog_t), intent(inout) :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='HEADER>PROG>LIST'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    if (prog%descr.ne.code_dataformat_none) then
      ! /DESCR invoked
      select case (prog%descr)
      case (code_dataformat_vo)
        call cubetools_header_vodesc_list(error)
        if (error)  return
      case default
        call cubemain_message(seve%w,rname,'Description is not available for this format')
      end select
      return  ! Always
    endif
    !
    if (prog%format.ne.code_dataformat_vo) then
      call prog%cube%node%tuple%list(prog%cube%node%id,prog%cube%node%family,&
          prog%cube%node%flag,error)
      if (error) return
    endif
    call prog%cube%list(prog%format,error)
    if (error) return
    if (prog%dohistory) then
      call cubemain_message(seve%r,rname,blankstr)
      call cubedag_history_docube(prog%cube%get_id(),error)
      if (error) return
    endif
  end subroutine cubemain_header_prog_list
  !
end module cubemain_header
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clic_set (line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  use clic_index
  use clic_find
  use clic_file,except=>i
  use clic_virtual
  use gio_params
  !---------------------------------------------------------------------
  ! CLIC Support routine for command
  !      SET Something [value1, value2, ...]
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  !	ERROR	L	Logical error flag	Output
  !----------------------------------------------------------------------
  !
  ! Options:
  !   1 	/LIMITS
  !   2 	/WINDOW
  !   3 	/ANTENNA
  !   4 	/DEFAULT
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_constant.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: ante_data,base_data
  logical :: ante_switched, base_switched, fr_ok, d_ok, more
  common /switched/ ante_switched, base_switched
  real*8 :: test, ff
  real :: f1, f2, ftry(2,mwin_out)
  real :: rarg, freq
  integer :: iant, iarg, if, ic, iv, lch
  integer :: l_savb(mbox),i_savb(mbands,mbox), n_savb, i1, nn, l
  integer :: iso(mbands), ier, ia(mnant), na, phys_log(mnant)
  integer :: k, n_save, i_save(mbox), isb, isbb, narg
  integer :: i, j, nkey, nl, nla, nch, dayf
  logical :: and, to, reset, old_degrees
  logical :: default, bad, angle_data
  logical :: first,second
  integer :: first_quarter, second_quarter, factor, lc
  character(len=80) :: ch, fich
  character(len=12) :: argum,argum1,argum2,argum3,kw,keywor,keywor2
  character(len=12) :: nombre
  real :: frtol, frmhz
  parameter (frtol=1e3)        ! 1 GHz ...
  character(len=10) :: qw
  integer :: q, old_do_polar, n, old_narrow_input
  type(sic_listi4_t) :: list
  integer, save :: prio_save
  !
  ! Vocabularies:
  integer :: mvocab, mvband, mvsub, mvsub2
  integer :: mvoc1, mvoc2, mvoc3, mvoc4, mvoc5, mvoc6, mvoc7, mvoc8
  integer :: mvoc9, mvoc10, mvoc11, mvoc12, mvoc13, mvoc14, mvoc15
  integer :: mvoc16, mvoc17, mvoc18,mvoc19, mvoc20,mvoc21,mvoc22,mvoc23
  integer :: mvoc24
  integer :: mamp, mpha, mrf
  parameter (mvocab=81, mvband=5, mvsub=6, mvsub2=15,   &
    mvoc1=4, mvoc2=2, mvoc3=3, mvoc4=2, mvoc5=4, mvoc6=2,   &
    mvoc7=6, mvoc8=2, mvoc9=8, mvoc10=4, mvoc11=10, mvoc12=22,   &
    mvoc13=5, mvoc14=2, mvoc15=2, mvoc16=3, mvoc17=3, mvoc18=2,  &
    mvoc19=2,mvoc20=5,mvoc21=2,mvoc22=2,mvoc23=3,mvoc24=5,       &
    mamp=13, mpha=20, mrf=11)
  character*12 vamp(mamp), vpha(mpha), vrf(mrf), vocab(mvocab),   &
    vband(mvband), vsub(mvsub), vsub2(mvsub2),   &
    voc1(mvoc1), voc2(mvoc2), voc3(mvoc3),   &
    voc4(mvoc4), voc5(mvoc5), voc6(mvoc6), voc7(mvoc7),   &
    voc8(mvoc8), voc9(mvoc9), voc10(mvoc10), voc11(mvoc11),   &
    voc12(mvoc12), voc13(mvoc13), voc14(mvoc14), voc15(mvoc15),   &
    voc16(mvoc16), voc17(mvoc17), voc18(mvoc18), voc19(mvoc19),   &
    voc20(mvoc20), voc21(mvoc21), voc22(mvoc22), voc23(mvoc23),   &
    voc24(mvoc24)
  !
  ! Datas
  data voc1/'DEGREE','MINUTE','SECOND','RADIAN'/
  data voc2/'YES','NO'/
  data voc3/'PHYSICAL','LOGICAL','ALL'/
  data voc4/'ATMOSPHERE','NOISE'/
  data voc5/'OBJECT','PHASE','RF_PASSBAND','*'/
  data voc6/'EXACT','AUTO'/
  data voc7/'NONE','SCAN','TIME','METHOD','CONT','LINE'/
  data voc8/'VECTOR','SCALAR'/
  data voc9/'LINE','POINTS','HISTOGRAMS','BARS','PHYSICAL','LOGICAL', &
     'HEADER','IPB'/
  data voc10/'TIME','SPECTRAL','LOWRES','FULL'/
  data voc11/'AUTO','MANUAL','TREC','FILE',   &
    'OLD','NEW','1985','2003','2009','INTERPOLATE'/
  data voc12/'CORRELATION','AUTOCORR','GAIN','DELAY','FOCUS',   &
    'POINTING','CALIBRATE','IFPB','ONOFF','HOLOGRAPHY',   &
    'FIVE_POINT','PSEUDO_CONT','FLUX','STABILITY','CWVR',   &
    'VLBI','VLBG','OTF','BANDPASS','MONITORING','SKYDIP','*'/
  data voc13/'TSYS','INSTRUMENTAL','CALIBRATION','BANDPASS','BASELINE'/
  data voc14/'ON','OFF'/
  data voc15/'UPDATE','NOUPDATE'/
  data voc16/'*','PRIMARY','FILE'/
  data voc17/'RECEIVER','SCAN','NUM'/
  data voc18/'DATA','NODATA'/
  data voc19/'OLD','NEW'/
  data voc20/'OFF','HORIZONTAL','VERTICAL','BOTH','EACH'/
  data voc21/'RAW','PHYSICAL'/
  data voc22/'STANDARD','PROTOTYPE'/
  data voc23/'NATIVE','LEAKAGE','CORRECTED'/
  data voc24/'SOURCE','POINTING','PHASE','EPOCH','SCAN'/
  !
  ! SET X|Y keywords --> moved to clic_xy_code.inc
  !
  ! SET SUBBANDS
  data vsub/'TO','AND','ALL','EACH','LINE','CONTINUUM'   &
    /
  data vsub2/'ALL','TO','AND','LINE','CONTINUUM','FREQUENCY',   &
    'UPPER','USB','LOWER','LSB','AVERAGE','DSB','AUTO','SSB','WIDEX'/
  data vband /'UPPER','LOWER','AVERAG','RATIO','DIFFER'/
  !
  ! SET AMPLITUDE|PHASE|RF
  data vamp/'ABSOLUTE','RELATIVE','SCALED','UNSCALED',   &
    'KELVIN','JANSKY','ANTENNA','BASELINE','RAW',        &
    'SIZED','UNSIZED','SPIDX','NOSPIDX'/
  data vpha/'ABSOLUTE','RELATIVE','ANTENNA','BASELINE',   &
    'DEGREES','RADIANS','JUMPY','CONTINUOUS',   &
    'ATMOSPHERE','NOATMOSPHERE', 'EXTERNAL','INTERNAL',   &
    'FILE','NOFILE','WVR','NOWVR','MODEL','EMPIRICAL',   &
    'TOTAL_POWER','NOTOTAL_POWE'/
  data  vrf/'ANTENNA','BASELINE','CHANNEL','FREQUENCY',   &
    'FILE','MEMORY','OFF','ON','SPECTRUM','DOPPLER','NODOPPLER'/
  !
  ! List of SET keywords
  data vocab /   &
    'PROJECT',   &             !1  H
    'ANGLE',   &               !2  H
    'APC',   &                 !3  H obsolete
    'IC',   &                  !4  H
    'PC',   &                  !5  H
    'TRIANGLE',   &            !6  H
    'ERRORS',   &              !7  H
    'DEFAULT',   &             !8  H
    'EXTENSION',   &           !9  H
    'FORMAT',   &              !10 H
    'HOUR_ANGLE',   &          !11 H
    'LEVEL',   &               !12 H
    'LINE',   &                !13 H
    'CORRECTION',   &          !14 no help (will not get one)
    'NUMBER',   &              !15 H
    'OBSERVED',   &            !16 H
    'OFFSET',   &              !17 H
    'RANGE',   &               !18 H
    'REDUCED',   &             !19 H
    'SOURCE',   &              !20 H
    'TELESCOPE',   &           !21 H
    'TYPE',   &                !22 H
    'QUALITY',   &             !23 H
    'SCAN',   &                !24 H
    'BASELINES',   &           !25 H
    'BANDS',   &               !26 H
    'SUBBANDS',   &            !27 H
    'X',   &                   !28 H
    'Y',   &                   !29 H
    'ASPECT_RATIO',   &        !30 H
    'AVERAGING',   &           !31 H
    'PLOT',   &                !32 H
    'STEP',   &                !33 H
    'PHASE',   &               !34 H
    'MODE',   &                !35 H obsolete
    'ATMOSPHERE',   &          !36 H
    'REFERENCE',   &           !37 H
    'FREQUENCY',   &           !38 H
    'PROCEDURE',   &           !39 H
    'CLOSURE',   &             !40 H obsolete
    'AMPLITUDE',   &           !41 H
    'RF_PASSBAND',   &         !42 H
    'FLUX',   &                !43 H
    'WATER',   &               !44 H
    'TREC',   &                !45 H
    'VIRTUAL',   &             !46 obsolete
    'SELECTION',   &           !47 H
    'ANTENNAS',   &            !48 H
    'SPECTRUM',   &            !49 obsolete
    'BINNING',   &             !50 H
    'WEIGHTS',   &             !51 H
    'DATA',   &                !52 H
    'RECORD',   &              !53 H
    'CRITERIA',   &            !54 H
    'GAIN_IMAGE',   &          !55 H
    'DROP_FRACTIO',   &        !56 H
    'GIBBS',   &               !57 H
    'FIND',   &                !58 no help
    'PLANET',   &              !59 H
    'RECEIVER',   &            !60 H
    'UV_RANGE',   &            !61 H
    'TIME_ORIGIN',   &         !62 H
    'SORT',   &                !63 H
    'COPY',   &                !64 no help
    'GAIN_METHOD',   &         !65 H 
    'POLARIZATION',   &        !66 H
    'FAKE',   &                !67 no help (will not get one)
    'TOTAL_POWER',   &         !68 H
    'NARROW_INPUT',  &         !69 H
    'WIDEX_UNIT',    &         !70 H
    'BBAND',         &         !71 no help
    'IF',            &         !72
    'SPW',           &         !73
    'SKIP',          &         !74
    'EXCLUDE',       &         !75
    'SPIDX',         &         !76
    'VERSION',       &         !77
    'STOKES',        &         !78
    'TABLE',         &         !79
    'FINDPOL',       &         !80
    'NOCHECK'/                 !81
  !
  !------------------------------------------------------------------------
  !
  ! Code:
  reset = .false.
  default = sic_present(4,0)
  if (default .and. .not.sic_present(0,1)) then
    call setdef(line,error)
    goto 90
  endif
  call sic_ke(line,0,1,argum,nch,.true.,error)
  if (error) return
  error = .false.
  call sic_ambigs('SET',argum,keywor,nkey,vocab,mvocab,error)
  if (error) return
  narg = sic_narg(0)
  !
  ! SET PROJECT
  if (nkey.eq.1) then
    sproject = '*'
    call sic_ke(line,0,2,sproject,nch,.true.,error)
    if (error) return
    !
    ! Reset RF Pass Band also...
    do_pass = .false.
    find_needed = .true.
    change_display = .true.
    call show_criteria('PROJECT',.false.,error)
    call show_general('RF_PASSBAND',.false.,line,error)
  !
  ! SET ANGLE
  elseif (nkey.eq.2) then
    argum1='SECOND'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ANGLE',argum1,kw,nkey,voc1,mvoc1,error)
    if (error) return
    sangle=kw(1:1)
    if (sangle.eq.'R') then
      fangle = 1
    elseif (sangle.eq.'D') then
      fangle = 180.d0/pi
    elseif (sangle.eq.'M') then
      fangle = 180.d0*60.d0/pi
    elseif (sangle.eq.'S') then
      fangle = 180.d0*60.d0*60.d0/pi
    endif
  !
  ! SET APC **OBSOLETE**
  elseif (nkey.eq.3) then
    sapc = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET APC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      sapc = 1
    elseif (kw.eq.'NO') then
      sapc = 0
    endif
    find_needed = .true.
    call show_criteria('APC',.false.,error)
  !
  ! SET IC
  elseif (nkey.eq.4) then
    setic = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET IC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      setic = 1
    elseif (kw.eq.'NO') then
      setic = 0
    endif
    call show_criteria('IC',.false.,error)
    find_needed = .true.
  !
  ! SET BPC
  elseif (nkey.eq.5) then
    sbpc = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET BPC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      sbpc = 1
    elseif (kw.eq.'NO') then
      sbpc = 0
    endif
    call show_criteria('BPC',.false.,error)
    find_needed = .true.
  !
  ! SET TRIANGLE				! internally coded as mnbas+1, ..
  elseif (nkey.eq.6) then
    if (narg.le.1) goto 90
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 69
    call sic_ambigs('SET TRIANGLE',argum1,kw,nkey,voc3,mvoc3,error)
!    if (error) goto 69
    if (kw.eq.'PHYSICAL') then
      phys_base = .true.
      i1 = 3
    elseif (kw.eq.'LOGICAL') then
      phys_base = .false.
      i1 = 3
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 69
    n_base = 0
    do i = i1, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 69
      call sic_ambigs('SET',argum1,kw,nkey,ctri,mntri,error)
      if (error) goto 69
      n_base = n_base+1
      i_base(n_base) = mnbas + nkey
    enddo
    if (n_base.gt.0) call set_display(error)
69  continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      call show_display('TRIANGLE',.false.,error)
      change_display = .true.
    endif
  !
  ! SET ERRORS
  elseif (nkey.eq.7) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ERRORS',argum1,kw,nkey,voc4,mvoc4,error)
    if (error) return
    if (kw.eq.'A') then
      do_bar_atm = .true.
    else
      do_bar_atm = .false.
    endif
  !
  ! SET DEFAULT
  elseif (nkey.eq.8) then
    call setdef(line,error)
    find_needed = .true.
  !
  ! SET EXTENSION e1 e2 ...
  elseif (nkey.eq.9) then
    ndefext = 0
    do i=2, sic_narg(0)
      argum1 = '.hpb'
      call sic_ch(line,0,i,argum1,nch,.false.,error)
      if (error) return
      if (argum1(1:1).ne.'.') argum1 = '.'//argum1
      call check_extension (argum1, lenc(argum1), error)
      if (error) return
      ndefext = ndefext+1
      defext(ndefext) = argum1
    enddo
    write(ch,*) 'Default file extensions set to ',   &
      (defext(i),i=1,ndefext)
    lch = lenc(ch)
    call message(2,1,'SET',ch(1:lch))
  !
  ! SET FORMAT
  elseif (nkey.eq.10) then
    call setfor(line,error)
  !
  ! SET HOUR_ANGLE
  elseif (nkey.eq.11) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    if (argum1(1:1).ne.'*') then
      call sic_sexa(argum1,lenc(argum1),test,error)
      if (error) return
      if (test.gt.12. .or. test.lt.-12.) then
        call message(6,3,'SET HOUR','Invalid Hour Angle')
        error = .true.
        return
      endif
      shoura1 = pi / 12. * test
    else
      shoura1 = -pi
    endif
    argum2  = '*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    if (argum1.ne.'*') then
      call sic_sexa(argum2,lenc(argum2),test,error)
      if (error) return
      if (test.gt.12. .or. test.lt.-12.) then
        call message(6,3,'SET HOUR','Invalid Hour Angle')
        error = .true.
        return
      endif
      shoura2 = pi / 12. * test
    else
      shoura2 = pi
    endif
    call show_criteria('HOUR',.false.,error)
    find_needed = .true.
  !
  ! SET LEVEL
  elseif (nkey.eq.12) then
    i = 2
    call sic_i4(line,0,2,i,.false.,error)
    if (error) return
    if (i.lt.0) then
      i = prio_save
    else
      i = min(8,i)
      i = max(0,i)
    endif
    write(nombre,'(I12)') i
    call message_level(i)
    prio_save = i
    call message(4,1,'SET','Message display level set to '//nombre)
  !
  ! SET LINE
  elseif (nkey.eq.13) then
    sline = '*'
    !         CALL SIC_CH(LINE,0,2,SLINE,NCH,.FALSE.,ERROR)
    call sic_ke(line,0,2,sline,nch,.false.,error)
    if (error) return
    call show_criteria('LINE',.false.,error)
    find_needed = .true.
  !
  ! SET CORRECTION
  elseif (nkey.eq.14) then
    phase_corr(1,1) = 50.
    do i=1, mnant
      phase_corr(1,i) = phase_corr(1,1)
      call sic_r4(line,0,1+i,phase_corr(1,i),.false.,error)
      phase_corr(2,i) = phase_corr(1,i)
    enddo
    call show_general('CORRECTION',.false.,line,error)
  !
  ! SET NUMBER
  elseif (nkey.eq.15) then
    argum1='*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      snume1=0
    else
      call sic_i4(line,0,2,snume1,.false.,error)
      if (error) return
    endif
    argum2='*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    if (argum2(1:1).eq.'*') then
      snume2=2147483647
    else
      call sic_i4(line,0,3,snume2,.false.,error)
      if (error) return
    endif
    call show_criteria('NUMBER',.false.,error)
    find_needed = .true.
  !
  ! SET OBSERVED_DATE
  elseif (nkey.eq.16) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = argum1
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    read(argum1,'(i6)',iostat=ier) sobse1
    if (abs(sobse1).gt.32768 .or. ier.ne.0) then
      sobse1 = -32768
      call cdate(argum1,sobse1,error)
    endif
    read(argum2,'(i6)',iostat=ier) sobse2
    if (abs(sobse2).gt.32768 .or. ier.ne.0) then
      sobse2 = 32767
      call cdate(argum2,sobse2,error)
    endif
    call show_criteria('OBSERVED',.false.,error)
    find_needed = .true.
  !
  ! SET OFFSET
  elseif (nkey.eq.17) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = '*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    soffs1 = 4.0*pi
    call coffse(argum1,soffs1,error)
    soffl1  = soffs1
    soffs2 = 4.0*pi
    call coffse(argum2,soffs2,error)
    soffl2  = soffs2
    call show_criteria('OFFSETS',.false.,error)
    find_needed = .true.
  !
  ! SET RANGE
  elseif (nkey.eq.18) then
    argum1='*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    soffs1= 4.0*pi
    call coffse(argum1,soffs1,error)
    argum2='*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    soffl1= 4.0*pi
    call coffse(argum2,soffl1,error)
    argum1='*'
    call sic_ke(line,0,4,argum1,nch,.false.,error)
    if (error) return
    soffs2= 4.0*pi
    call coffse(argum1,soffs2,error)
    argum2='*'
    call sic_ke(line,0,5,argum2,nch,.false.,error)
    if (error) return
    soffl2= 4.0*pi
    call coffse(argum2,soffl2,error)
    call show_criteria('RANGE',.false.,error)
    find_needed = .true.
  !
  ! SET REDUCED_DATE
  elseif (nkey.eq.19) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = argum1
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    sredu1 = -32768
    call cdate(argum1,sredu1,error)
    sredu2 = 32767
    call cdate(argum2,sredu2,error)
    call show_criteria('REDUCED',.false.,error)
    find_needed = .true.
  !
  ! SET SOURCE
  elseif (nkey.eq.20) then
    nsour = narg-1
    find_needed = .true.
    if (nsour.gt.10) then
      call message(6,2,'SET SOURCES','Only 10 sources retained')
      nsour = 10
    endif
    do i=1,nsour
      !            CALL SIC_CH(LINE,0,I+1,ARGUM1,NCH,.TRUE.,ERROR)
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      j = index(argum1,'*')
      if (j.eq.0) then
        sisour(i) = 12
      elseif (j.ne.1) then
        sisour(i) = j-1
      else
        nsour = 0
        goto 90
      endif
      sssour(i) = argum1
    enddo
    call show_criteria('SOURCE',.false.,error)
  !
  ! SET TELESCOPE
  elseif (nkey.eq.21) then
    steles = '*'
    call sic_ke(line,0,2,steles,nch,.false.,error)
    if (error) return
    call show_criteria('TELESCOPE',.false.,error)
    find_needed = .true.
  !
  ! SET TYPE Source|Phase|RF_Passband
  elseif (nkey.eq.22) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET TYPE',argum1,kw,nkey,voc5,mvoc5,error)
    if (error) return
    if (kw.eq.'OBJECT') then
      sitype = 1
    elseif (kw.eq.'PHASE') then
      sitype = 2
    elseif (kw.eq.'RF_PASSBAND') then
      sitype = 3
    elseif (kw.eq.'*') then
      sitype = -1
    endif
    call show_criteria('TYPE',.false.,error)
    find_needed = .true.
  !
  ! SET QUALITY
  elseif (nkey.eq.23) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call get_quality(argum1,squal,qw,error)
    if (error) return
    call show_criteria('QUALITY',.false.,error)
    find_needed = .true.
  !
  ! SET SCAN
  elseif (nkey.eq.24) then
    argum1='*'
    snscan = 0
    do i=2, sic_narg(0)-1, 2
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      argum2='*'
      call sic_ke(line,0,i+1,argum2,nch,.false.,error)
      if (error) return
      snscan = snscan+1
      if (argum1(1:1).eq.'*') then
        sscan1(snscan)=0
      else
        call sic_i4(line,0,i,sscan1(snscan),.false.,error)
        if (error) return
      endif
      if (argum2(1:1).eq.'*') then
        sscan2(snscan)=2147483647
      else
        call sic_i4(line,0,i+1,sscan2(snscan),.false.,error)
        if (error) return
      endif
    enddo
    call show_criteria('SCAN',.false.,error)
    find_needed = .true.
  !
  ! SET BASELINES
  elseif (nkey.eq.25) then
    if (narg.le.1) then
      call switch_baseline
      change_display = .true.
      call set_display(error)
      goto 90
    endif
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 259
    all_base = .false.
    nch = ichar(argum1(1:1))
    if (nch.gt.ichar('9')) then
      call sic_ambigs('SET BASELINE',argum1,kw,nkey,voc3,mvoc3,   &
        error)
      if (error) goto 259
      if (kw.eq.'PHYSICAL') then
        phys_base = .true.
        if ((narg.ge.3).and.(r_nant.eq.0)) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'NO DATA READ')
          error=.true.
          goto 259
        endif
        do i=1,mnant
          phys_log(i) = mnant+1
        enddo
        do i=1,r_nant
          phys_log(r_kant(i)) = i
        enddo
        i1 = 3
      elseif (kw.eq.'LOGICAL') then
        phys_base = .false.
        i1 = 3
      elseif (kw.eq.'ALL') then
        all_base = .true.
        i_base(1) = 1
        call set_all_baselines
        i1 = 3
      endif
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 259
    n_base = 0
    error = .true.
    do i = i1, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 259
      if (phys_base) then
        ! Decode physical baseline label into a logical baseline index.
        ! Accept either "12" (when MNANT<10) or "01-02"/"1-2"/"1 2".
        argum2 = argum1
        ier = 0
        if (index(argum2,'-').gt.0 .or. index(argum2,',').gt.0) then
          do j=1, len(argum2)
            if (argum2(j:j).eq.'-'.or.argum2(j:j).eq.',') argum2(j:j) = ' '
          enddo
          read(argum2,*,iostat=ier) k, j
        elseif (len_trim(argum2).eq.2   &
          .and. argum2(1:1).ge.'0' .and. argum2(1:1).le.'9'   &
          .and. argum2(2:2).ge.'0' .and. argum2(2:2).le.'9') then
          k = iachar(argum2(1:1)) - iachar('0')
          j = iachar(argum2(2:2)) - iachar('0')
        else
          read(argum2,*,iostat=ier) k, j
        endif
        if (ier.ne.0) goto 259
        if (k.le.0 .or. j.le.0 .or. k.gt.mnant .or. j.gt.mnant .or. k.eq.j) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'Invalid physical baseline')
          error = .true.
          goto 259
        endif
        if (phys_log(k).gt.r_nant .or. phys_log(j).gt.r_nant) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'Invalid physical baseline')
          error = .true.
          goto 259
        endif
        if (mnant.le.9) then
          write(argum2,'(2i1)') min(phys_log(k),phys_log(j)),   &
            max(phys_log(k),phys_log(j))
        else
          write(argum2,'(i2.2,1h-,i2.2)') min(phys_log(k),phys_log(j)),   &
            max(phys_log(k),phys_log(j))
        endif
        call sic_ambigs('SET',argum2,kw,nkey,cbas,mnbas,error)
      else
        call sic_ambigs('SET',argum1,kw,nkey,cbas,mnbas,error)
      endif
      if (error) goto 259
      n_base = n_base+1
      i_base(n_base) = nkey
    enddo
    error = .false.
    if (n_base.gt.0) call set_display(error)
259 continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      call show_display('BASELINES',.false.,error)
      change_display = .true.
    endif
  !
  ! SET BANDS
  elseif (nkey.eq.26) then
    if (narg.le.1) goto 90
    bad = .true.
    n_save = n_band
    do i=1, n_save
      i_save(i) = i_band(i)
    enddo
    n_band = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 269
      if (argum1(1:2).eq.'US') then
        argum1 = 'UPPER'
      elseif (argum1(1:2).eq.'LS') then
        argum1 = 'LOWER'
      elseif (argum1(1:2).eq.'DS') then
        argum1 = 'AVER'
      endif
      call sic_ambigs('SET',argum1,kw,nkey,vband,mvband,error)
      if (error) goto 269
      n_band = n_band+1
      i_band(n_band) = nkey
    enddo
    error = .false.
    if (n_band.gt.0) call set_display(error)
    bad = error
269 continue
    if (bad) then
      n_band = n_save
      do i=1, n_save
        i_band(i) = i_save(i)
      enddo
    else
      change_display = .true.
      call show_display('BAND',.false.,error)
    endif
  !
  ! SET SUBBANDS
  elseif (nkey.eq.27) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_subb
    do i=1, n_savb
      l_savb(i) = l_subb(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_subb(j,i)
      enddo
    enddo
    n_subb = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 279
      call sic_ambigs(' ',argum1,kw,nkey,csub,mcsub,more)
      if (more) call sic_ambigs('SET SUBBANDS',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        n_subb = n_savb
        all_subb = .true.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_all_subbands
      elseif (kw.eq.'EACH') then
        n_subb = n_savb
        all_subb = .false.
        each_subb = .true.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_each_subband
      elseif (kw.eq.'LINE') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).le.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)+mbands
            enddo
          endif
        enddo
      elseif (kw.eq.'CONTINUUM') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).gt.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)-mbands
            enddo
          endif
        enddo
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 279
          endif
          do j = k+1, nkey
            l_subb(n_subb) = l_subb(n_subb) + 1
            i_subb(l_subb(n_subb),n_subb) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 279
          endif
          l_subb(n_subb) = l_subb(n_subb) + 1
          i_subb(l_subb(n_subb),n_subb) = nkey
          k = nkey
          and = .false.
        else
          n_subb = n_subb+1
          k = nkey
          i_subb(1,n_subb) = nkey
          l_subb(n_subb) = 1
        endif
        !
        if (sic_present(2,0)) then
          argum1 = sw1(n_subb)
          call sic_ke(line,2,2*n_subb-1,argum1,nch,.true.,error)
          if (error) goto 279
          if (argum1.eq.'*') then
            sw1(n_subb) = '*'
            iw1(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb-1,iw1(n_subb),.true.,   &
              error)
            if (error) goto 279
            sw1(n_subb) = 'F'
          endif
          argum1 = sw2(n_subb)
          call sic_ke(line,2,2*n_subb,argum1,nch,.true.,error)
          if (error) goto 279
          if (argum1.eq.'*') then
            sw2(n_subb) = '*'
            iw2(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb, iw2(n_subb),.true.,   &
              error)
            if (error) goto 279
            sw2(n_subb) = 'F'
          endif
        else
          sw1(n_subb) = '*'
          iw1(n_subb) = 0
          sw2(n_subb) = '*'
          iw2(n_subb) = 0
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_subb
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    ! Now check/switch narrow band correlator input
    !
    if ((new_receivers).and.(narrow_input.ne.0)) then
      old_narrow_input = narrow_input
      call check_nbc_subbands(error)
      if (narrow_input.ne.old_narrow_input) then
        write (ch, '(A,I1)')   &
          'Switching to narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      else
        write (ch, '(A,I1)')   &
          'Narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      endif
    endif
    !
    call set_display(error)
    bad = error
279 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('SUBBAND',.false.,error)
    endif
  !
  ! SET X
  elseif (nkey.eq.28) then
    if (narg.le.1) goto 90
    bad = .true.
    n_save = n_x
    do i=1, n_save
      i_save(i) = i_x(i)
    enddo
    n_x = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 289
      call sic_ambigs('SET',argum1,kw,nkey,vxy,mxy,error)
      if (error) goto 289
      n_x = n_x+1
      i_x(n_x) = nkey
      if (.not.new_receivers.and.nkey.eq.xy_i_fre3) then
        print *,"E-SET THERE IS NO IF3 IN OLD RECEIVERS"
        error = .false.
        goto 289
      endif
    enddo
    if (n_x.le.0) goto 289
    do i=1, n_x
      if (sic_present(1,2*i-1)) then
        call sic_ke(line,1,2*i-1,argum1,nch,.true.,error)
        if (error) goto 289
        if (argum1.eq.'*') then
          sm_x1(i) = '*'
        elseif (argum1.eq.'=') then
          sm_x1(i) = '='
        else
          call sic_r4(line,1,2*i-1,gu1_x(i),.true.,error)
          if (error) goto 289
          sm_x1(i) = 'F'
        endif
      elseif (i_x(i).eq.1) then
        sm_x1(i) = 'F'
        gu1_x(i) = 0.
      elseif (angle_data(i_x(i)) .and. .not.continuous) then
        sm_x1(i) = 'F'
        if (degrees) then
          gu1_x(i) = -180.
        else
          gu1_x(i) = -pi
        endif
      elseif (i_x(i).eq.xy_i_fre) then
        sm_x1(i) = '='         ! LIMITS DEFAULT TO = FOR IF.
      else
        sm_x1(i) = '*'
      endif
      if (sic_present(1,2*i)) then
        call sic_ke(line,1,2*i,argum1,nch,.true.,error)
        if (error) goto 289
        if (argum1.eq.'*') then
          sm_x2(i) = '*'
        elseif (argum1.eq.'=') then
          sm_x2(i) = '='
        else
          call sic_r4(line,1,2*i,gu2_x(i),.true.,error)
          if (error) goto 289
          sm_x2(i) = 'F'
        endif
      elseif (angle_data(i_x(i)) .and. .not.continuous) then
        sm_x2(i) = 'F'
        if (degrees) then
          gu2_x(i) = +180.
        else
          gu2_x(i) = +pi
        endif
      elseif (i_x(i).eq.xy_i_fre) then
        sm_x2(i) = '='         ! LIMITS DEFAULT TO = FOR IF.
      else
        sm_x2(i) = '*'
      endif
    enddo
    error = .false.
    call set_display(error)
    bad = error
289 continue
    if (bad) then
      n_x = n_save
      do i=1, n_save
        i_x(i) = i_save(i)
      enddo
    else
      change_display = change_display.or.n_save.ne.n_x
      if (.not.change_display) then
        do i=1, n_save
          change_display = change_display   &
            .or. i_x(i).ne.i_save(i)
        enddo
      endif
      call show_display('X   ',.false.,error)
      if (do_bin .and. i_x(1).ne.i_save(1)) then
        do_bin = .false.
        call message(4,1,'CLIC_SET','BINNING IS OFF')
      endif
    endif
  !
  ! SET Y
  elseif (nkey.eq.29) then
if (narg.le.1) goto 90
    bad = .true.
    n_save = n_y
    do i=1, n_save
      i_save(i) = i_y(i)
    enddo
    n_y = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 299
      call sic_ambigs('SET',argum1,kw,nkey,vxy,mxy,error)
      if (error) goto 299
      n_y = n_y+1
      i_y(n_y) = nkey
    enddo
    if (n_y.le.0) goto 299
    do i=1, n_y
      if (sic_present(1,2*i-1)) then
        call sic_ke(line,1,2*i-1,argum1,nch,.true.,error)
        if (error) goto 299
        if (argum1.eq.'*') then
          sm_y1(i) = '*'
        elseif (argum1.eq.'=') then
          sm_y1(i) = '='
        else
          call sic_r4(line,1,2*i-1,gu1_y(i),.true.,error)
          if (error) goto 299
          sm_y1(i) = 'F'
        endif
      elseif (i_y(i).eq.1) then
        sm_y1(i) = 'F'
        gu1_y(i) = 0.
      elseif (angle_data(i_y(i)) .and. .not.continuous) then
        sm_y1(i) = 'F'
        if (degrees) then
          gu1_y(i) = -180.
        else
          gu1_y(i) = -pi
        endif
      else
        sm_y1(i) = '*'
      endif
      if (sic_present(1,2*i)) then
        call sic_ke(line,1,2*i,argum1,nch,.true.,error)
        if (error) goto 299
        if (argum1.eq.'*') then
          sm_y2(i) = '*'
        elseif (argum1.eq.'=') then
          sm_y2(i) = '='
        else
          call sic_r4(line,1,2*i,gu2_y(i),.true.,error)
          if (error) goto 299
          sm_y2(i) = 'F'
        endif
      elseif (angle_data(i_y(i)) .and. .not.continuous) then
        sm_y2(i) = 'F'
        if (degrees) then
          gu2_y(i) = +180.
        else
          gu2_y(i) = +pi
        endif
      else
        sm_y2(i) = '*'
      endif
    enddo
    i = i_y(1)
    if (ante_data(i)) then
      call switch_antenna
    !            ANTE_SWITCHED = .TRUE.
    !         ELSEIF (ANTE_SWITCHED) THEN
    !            CALL SWITCH_BASELINE
    !            ANTE_SWITCHED = .FALSE.
    endif
    if (base_data(i)) then
      call switch_baseline
    !           BASE_SWITCHED = .TRUE.
    !         ELSEIF (BASE_SWITCHED) THEN
    !            CALL SWITCH_ANTENNA
    !            BASE_SWITCHED = .FALSE.
    endif
    error = .false.
    call set_display(error)
    bad = error
299 continue
    if (bad) then
      n_y = n_save
      do i=1, n_save
        i_y(i)  = i_save(i)
      enddo
    else
      change_display = change_display.or.n_save.ne.n_y
      if (.not.change_display) then
        do i=1, n_save
          change_display = change_display   &
            .or. i_y(i).ne.i_save(i)
        enddo
      endif
      call show_display('Y    ',.false.,error)
    endif
  !
  ! SET ASPECT_RATIO
  elseif (nkey.eq.30) then
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg .le.0) then
      call message(6,3,'CLIC_SET','INVALID ASPECT RATIO')
      error = .true.
      return
    endif
    argum1 = 'EXACT'
    call sic_ke(line,0,3,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ASPECT_RATIO',argum1,kw,nkey,voc6,mvoc6,   &
      error)
    if (error) return
    if (kw.eq.'AUTO') then
      aratio = - rarg
    else
      aratio = rarg
    endif
    call set_display(error)
    call show_display('ASPECT_RATIO',.false.,error)
  !
  ! SET AVERAGING
  elseif (nkey.eq.31) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET AVERAGING',argum1,kw,nkey,voc7,mvoc7,   &
      error)
    if (error) return
    if (kw.eq.'NONE') then
      i_average = 0
      s_average = 0
    elseif (kw.eq.'SCAN') then
      i_average = 1
      s_average = 0
      if (sic_narg(0).gt.2) then
        call sic_i4(line,0,3,iarg,.false.,error)
        if (iarg.gt.0) s_average = iarg
      endif
    elseif (kw.eq.'TIME') then
      i_average = 2
      s_average = 0
      call sic_r4(line,0,3,rarg,.true.,error)
      if (error) return
      if (rarg.lt.0) then
        call message(6,3,'CLIC_SET','INVALID AVERAGING TIME')
        error = .true.
        return
      endif
      t_average = rarg
    elseif (kw.eq.'METHOD') then
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET AVERAGING METHOD',argum2,kw,nkey,   &
        voc8,mvoc8, error)
      if (error) return
      if (kw.eq.'VECTOR') then
        j_average = 1
      elseif (kw.eq.'SCALAR') then
        j_average = 0
      else
        call message(6,3,'CLIC_SET',   &
          'INVALID AVERAGING METHOD '//argum2)
      endif
    elseif (kw.eq.'CONT') then
      k_average = 0
    elseif (kw.eq.'LINE') then
      k_average = 1  
    else
      call message(6,3,'CLIC_SET',   &
        'INVALID AVERAGING MODE '//argum1)
      error = .true.
      return
    endif
    call show_display('AVERAGE',.false.,error)
    change_display = .true.
  !
  ! SET PLOT
  elseif (nkey.eq.32) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET PLOT',argum1,kw,nkey,voc9,mvoc9,error)
    if (error) return
    if (kw.eq.'PHYSICAL') then
      do_physical = .true.
    elseif(kw.eq.'LOGICAL') then
      do_physical = .false.
    elseif(kw.eq.'HEADER') then
      skip_flag = .true.
    elseif(kw.eq.'IPB') then
      skip_flag = .false.
    else
      plot_type = kw(1:4)
    endif
    call show_display('PLOT',.false.,error)
  !
  ! SET STEP
  elseif (nkey.eq.33) then
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg .le.0) then
      call message(6,3,'CLIC_SET','INVALID TIME STEP')
      error = .true.
      return
    endif
    t_step = rarg
    call show_display('STEP',.false.,error)
  !
  ! SET PHASE RELATIVE|ABSOLUTE ANTENNA|BASELINE DEGREE|RADIAN JUMPY|CONT N
  ! SET PHASE INTERNAL|EXTERNAL
  ! SET PHASE ATM|NOATM /ANTENNA ALL|{1 3 ...}
  ! SET PHASE WVR|NOWVR [MODEL|EMPIRICAL] /ANTENNA ALL|{1 3 ...}
  ! SET PHASE TOTAL|NOTOTAL /ANTENNA ALL|{1 3 ...}
  elseif (nkey.eq.34) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      if (ichar(argum1(1:1)).ge.ichar('0')   &
        .and. ichar(argum1(1:1)).le.ichar('9')   &
        .and. continuous) then
        read(argum1(1:lenc(argum1)),*) n_cont
        n_cont = max(0,n_cont)
        n_cont = min(n_cont,30)
        reset = .true.
      else
        old_degrees = degrees
        call sic_ambigs('SET',argum1,keywor2,nkey,vpha,mpha,   &
          error)
        if (error) return
        ! ABSOLUTE
        if (nkey.eq.1) then
          do_phase = .false.
          change_display = .true.
        ! RELATIVE
        elseif (nkey.eq.2) then
          do_phase = .true.
          change_display = .true.
        ! ATMOSPHERE|NOATMOPSHERE
        elseif (nkey.eq.9) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_atm(ia(j)) = .true.
          enddo
          if (i_average.ne.1) then
            i_average = 1
            call message(6,1,'CLIC_SET',   &
              'SWITCHING ON SET AVERAGE SCAN METHOD')
          endif
        elseif (nkey.eq.10) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_atm(ia(j)) = .false.
          enddo
        !
        ! CAUTION: IT IS POSSIBLE TO HAVE CORRECTION BASED ON WVR FOR SOME
        ! ANTENNAS, AND ON 1.3 MM TOTAL POWER MONITOR FOR OTHERS
        !
        ! WVR
        elseif (nkey.eq.15) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            if (r_wvrnch(ia(j)).eq.3) then
              do_phase_wvr(ia(j)) = .true.
              do_phase_mon(ia(j)) = .false.
            else
              do_phase_wvr(ia(j)) = .false.
            endif
          enddo
        elseif (nkey.eq.16) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr(ia(j)) = .false.
          enddo
        elseif (nkey.eq.17) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr_e(ia(j)) = .false.
          enddo
        elseif (nkey.eq.18) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr_e(ia(j)) = .true.
          enddo
        ! TOTAL POWER MONITOR
        elseif (nkey.eq.19) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_mon(ia(j)) = .true.
            do_phase_wvr(ia(j)) = .false.
          enddo
        elseif (nkey.eq.20) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_mon(ia(j)) = .false.
          enddo
        ! EXTERNAL/INTERNAL
        elseif (nkey.eq.11) then
          do_phase_ext = .true.
        elseif (nkey.eq.12) then
          do_phase_ext = .false.
        ! FILE/NOFILE
        elseif (nkey.eq.13) then
          do_phase_nofile = .false.
        elseif (nkey.eq.14) then
          do_phase_nofile = .true.
        ! ANTENNA
        elseif (nkey.eq.3) then
          do_phase_antenna = .true.
        ! BASELINE
        elseif (nkey.eq.4) then
          do_phase_antenna = .false.
        ! DEGREES
        elseif (nkey.eq.5) then
          reset = .not.degrees
          degrees = .true.
          do k=1, n_x
            if (i_x(k).eq.xy_phase .and. reset) then
              if (sm_x1(k).eq.'F') then
                gu1_x(k) = 180./pi*gu1_x(k)
                gu2_x(k) = 180./pi*gu2_x(k)
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. reset) then
              if (sm_y1(k).eq.'F') then
                gu1_y(k) = 180./pi*gu1_y(k)
                gu2_y(k) = 180./pi*gu2_y(k)
              endif
            endif
          enddo
        ! RADIANS
        elseif (nkey.eq.6) then
          reset = degrees
          degrees = .false.
          do k=1, n_x
            if (i_x(k).eq.xy_phase .and. reset) then
              if (sm_x1(k).eq.'F') then
                gu1_x(k) = pi/180.*gu1_x(k)
                gu2_x(k) = pi/180.*gu2_x(k)
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. reset) then
              if (sm_y1(k).eq.'F') then
                gu1_y(k) = pi/180.*gu1_y(k)
                gu2_y(k) = pi/180.*gu2_y(k)
              endif
            endif
          enddo
        ! CONTINUOUS
        elseif (argum1(1:1).eq.'C') then
          reset = .not.continuous
          do k = 1, n_x
            if (i_x(k).eq.xy_phase .and. .not.continuous) then
              sm_x1(k) = '*'
              sm_x2(k) = '*'
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. .not.continuous) then
              sm_y1(k) = '*'
              sm_y2(k) = '*'
            endif
          enddo
          continuous = .true.
        ! JUMPY
        elseif (nkey.eq.7) then
          reset = continuous
          do k=1, n_x
            if (i_x(k).eq.2 .and. continuous) then
              sm_x1(k) = 'F'
              sm_x2(k) = 'F'
              if (degrees) then
                gu1_x(k) = -180.
                gu2_x(k) = +180.
              else
                gu1_x(k) = -pi
                gu2_x(k) = +pi
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. .not.continuous) then
              sm_y1(k) = 'F'
              sm_y2(k) = 'F'
              if (degrees) then
                gu1_y(k) = -180.
                gu2_y(k) = +180.
              else
                gu1_y(k) = -pi
                gu2_y(k) = +pi
              endif
            endif
          enddo
          continuous = .false.
        endif
      endif
    enddo
    call set_display(error)
    call show_display('PHASES',.false.,error)
    call show_general('PHASE',.false.,line,error)
    change_display = .true.
    if (reset) call reset_phases
  !
  ! SET MODE
  elseif (nkey.eq.35) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET MODE',argum1,kw,nkey,voc10,mvoc10,error)
    if (error) return
    if (kw.eq.'LOWRES') then
      lowres = .true.
      call loose_data
      call free_memory
      bp_spectrum_memory = .false.
      bp_spectrum_memory_pol = .false.
    elseif (kw.eq.'FULL') then
      lowres = .false.
      call loose_data
      call free_memory
      bp_spectrum_memory = .false.
      bp_spectrum_memory_pol = .false.
    else
      if (kw.eq.'TIME') then
        call message (8,3,'CLIC_SET','This command is obsolete')
      elseif (kw.eq.'SPECTRAL') then
        call message (8,3,'CLIC_SET','This command is obsolete')
      endif
    endif
  !
  ! SET ATMOSPHERE
  elseif (nkey.eq.36) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET ATM',argum1,kw,nkey,voc11,mvoc11,error)
    if (error) return
    !
    ! ANTENNA INDEPENDENT ATM MODE (MODEL VERSION):
    if (kw.eq.'1985' .or. kw.eq.'2003' .or.kw.eq.'2009' .or.  &
        kw.eq.'OLD'  .or. kw.eq.'NEW') then
      if (atmmodel.ne.kw) then
        call atm_setup(kw,error)
        if (.not.error) then
          atmmodel = kw
          atm_interpolate = .false.
        endif
      endif
    endif
    !
    ! USE TABLE
    if (kw.eq.'INTERPOLATE') then
       call atm_read_table(error)
       if (error) then
         call message(6,3,'CLIC_SET','Cannot find atmospheric model table')
         atm_interpolate = .false.
         return
       else
         atm_interpolate = .true.
       endif
    endif
    !
    ! ANTENNA DEPENDENT ATM MODE:
    if (kw.eq.'AUTO' .or. kw.eq.'TREC') then
      call get_antennas(line,3,na,ia,.true.,error)
      if (error) return
      do j=1, na
        atm_mode(ia(j)) = kw(1:4)
      enddo
      if (kw.eq.'AUTO') then
        call sic_r4(line,0,3,atm_water,.false.,error)
        if (error) return
      elseif (kw.eq.'TREC') then
        call sic_r4(line,0,3,rarg,.false.,error)
        if (error) return
        do j=1, na
          atm_trec(ia(j)) = rarg
        enddo
      endif
    endif
    call show_general('ATMOSPHERE',.false.,line,error)
  !
  ! SET REFERENCE
  elseif (nkey.eq.37) then
    call sic_i4(line,0,2,iant,.true.,error)
    if (error) return
    if (iant.lt.1 .or. iant.gt.mnant) then
      call message(6,3,'CLIC_SET','INVALID ANTENNA NUMBER')
      error = .true.
      return
    endif
    ref_ant = iant
    call show_general('REFERENCE',.false.,line,error)
  !
  ! SET FREQUENCY {C|L01..} {U|L} NAME FREQ
  elseif (nkey.eq.38) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'C') then
      call message(6,4,'CLIC_SET','Operation not allowed')
      error =  .true.
      return
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2(1:1).eq.'U') then
        isb = 1
      elseif (argum2(1:1).eq.'L') then
        isb = 2
      else
        call message(6,3,'CLIC_SET','INVALID SIDEBAND')
        error = .true.
        return
      endif
      call sic_ch(line,0,4,c_line(isb),nch,.true.,error)
      call sic_r8(line,0,5,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      c_freq(isb) = ff
    elseif (argum1(1:1).eq.'L') then
      call message(6,4,'CLIC_SET','Operation not allowed')
      error =  .true.
      return
      read (argum1(2:3),'(I2)',err=98) isbb
      if (isbb.le.0 .or. isbb.gt.mrlband) then
        call message(6,3,'CLIC_SET','INVALID SIDEBAND//ARGUM1')
        error = .true.
        return
      endif
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2(1:1).eq.'U') then
        isb = 1
      elseif (argum2(1:1).eq.'L') then
        isb = 2
      else
        call message(6,3,'CLIC_SET','INVALID SIDEBAND')
        error = .true.
        return
      endif
      call sic_ch(line,0,4,l_line(isbb,isb),nch,.true.,error)
      call sic_r8(line,0,5,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      l_freq(isbb,isb) = ff
    elseif (argum1(1:3).eq.'ALL') then
      call sic_ch(line,0,3,argum2,nch,.true.,error)
      call sic_r8(line,0,4,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      do isb = 1, 2
        c_line(isb) = argum2
        c_freq(isb) = ff
        do isbb = 1, mrlband
          l_freq(isbb,isb) = ff
          l_line(isbb, isb) = argum2
        enddo
      enddo
    else
      call message(6,3,'CLIC_SET','INVALID ARGUMENT'//argum1)
      error = .true.
      return
    endif
    call show_general('FREQUENCY',.false.,line,error)
  !
  ! SET PROCEDURE
  elseif (nkey.eq.39) then
    nproc = narg-1
    if (nproc.gt.10) then
      call message(6,2,'SET PROCEDURE',   &
        'ONLY 10 PROCEDURES RETAINED')
      nproc = min(nproc,10)
    endif
    do i=1,nproc
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET MODE',argum1,kw,nkey,voc12,mvoc12,   &
        error)
      if (error) then
        nproc = 0
        return
      endif
      if (nkey.le.mvoc12-2) then
        ssproc(i) = nkey+10
      elseif (kw.eq.'SKYDIP') then
        ssproc(i) = 6
      elseif (kw.eq.'*') then
        nproc = 0
      endif
    enddo
    call show_criteria('PROCEDURE',.false.,error)
    find_needed = .true.
  !
  ! SET CLOSURE B1 W1 ... **OBSOLETE**
  elseif (nkey.eq.40) then
    do i = 2, narg,2
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 98
      call sic_ambigs('SET',argum1,kw,nkey,cbas,mnbas,error)
      if (error) return
      call sic_r4(line,0,i+1,w_c(nkey),.true.,error)
      if (error) return
      w_c(nkey) = abs(w_c(nkey))
    enddo
  !
  ! SET AMPLITUDE ABS:REL SCALED|UNSCALED  KELVIN|KANSKY|RAW ANTENNA|BASELINE
  elseif (nkey.eq.41) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET ',argum1,keywor2,nkey,vamp,mamp,error)
      if (error) return
      ! ABSOLUTE
      if (nkey.eq.1) then
        do_amplitude = .false.
        do_scale = .false.
        do_flux = .false.      ! DEFAULT
        do_raw = .false.
        change_display = .true.
      ! RELATIVE
      elseif (nkey.eq.2) then  ! RELATIVE AMPLITUDE CAL.
        do_amplitude = .true.
        do_flux = .true.       ! DEFAULT
        do_raw = .false.
        change_display = .true.
      ! SCALED
      elseif (nkey.eq.3) then
        do_scale = .true.
        do_raw = .false.
        change_display = .true.
      ! UN SCALED
      elseif (nkey.eq.4) then
        do_scale = .false.
        do_raw = .false.
        change_display = .true.
      ! KELVIN
      elseif (nkey.eq.5) then
        do_flux = .false.
        do_raw = .false.
        change_display = .true.
      ! JANSKY
      elseif (nkey.eq.6) then
        do_flux = .true.
        do_raw = .false.
        change_display = .true.
      ! ANTENNA
      elseif (nkey.eq.7) then
        do_amplitude_antenna = .true.
      ! BASELINE
      elseif (nkey.eq.8) then
        do_amplitude_antenna = .false.
      ! RAW
      elseif (nkey.eq.9) then
        do_raw = .true.
        do_scale = .false.
        do_flux = .false.
        do_amplitude = .false.
      ! SIZED
      elseif (nkey.eq.10) then
        do_size = .true.
        do_scale = .false.
        change_display = .true.
      ! UNSIZED
      elseif (nkey.eq.11) then
        do_size = .false.
        change_display = .true.
      ! SPIDX
      elseif (nkey.eq.12) then
        do_spidx = .true.
        change_display = .true.
      ! NOSPIDX
      elseif (nkey.eq.13) then
        do_spidx = .false.
        change_display = .true.
      endif
    enddo
    call set_display(error)
    change_display = .true.
    call show_general('AMPLITUDE',.false.,line,error)
  !
  ! SET RF_PASSBAND ON|OFF|FREQ|CHANNEL|MEMORY|FILE|ANTENNA|BASELINE
  elseif (nkey.eq.42) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs(' ',argum1,keywor2,nkey,vrf,mrf,more)
      if (more) then
         call sic_i4(line,0,i,bp_file_id,.true.,error)
         if (error) return
         nkey = 0
         bp_spectrum_memory = .false.
      endif
      ! OFF
      if (nkey.eq.11) then
        do_pass_doppler = .false.
      elseif (nkey.eq.10) then
        do_pass_doppler = .true.
      elseif (nkey.eq.9) then
        do_pass_spectrum = .true.
      elseif (nkey.eq.7) then
        do_pass = .false.
      ! ON
      elseif (nkey.eq.8) then
        do_pass = .true.
      ! CHANNEL
      elseif (nkey.eq.3) then
        do_pass_spectrum = .false.
        do_pass_freq = .false.
      ! FREQUENCY
      elseif (nkey.eq.4) then
        do_pass_spectrum = .false.
        do_pass_freq = .true.
      ! FILE
      elseif (nkey.eq.5) then
        do_pass_memory = .false.
      ! MEMORY
      elseif (nkey.eq.6) then
        do_pass_memory = .true.
        if (do_pass_spectrum) bp_spectrum_memory = .false.
      ! BASELINE
      elseif (nkey.eq.2) then
        do_pass_antenna = .false.
      ! ANTENNA
      elseif (nkey.eq.1) then
        do_pass_antenna = .true.
      elseif (nkey.eq.0) then
      else
        goto 98
      endif
    enddo
    if (bp_file_id.ne.0.and.(.not.do_pass_spectrum.or.do_pass_memory)) then
      call message(8,1,'CLIC_SET',&
                   'Not in SPECTRUM file mode. Resetting solution number')
      bp_file_id = 0
    endif
    change_display = .true.
    call show_general('RF_PASSBAND',.false.,line,error)
  !
  ! SET FLUX NAME [VALUE] [FREQUENCY] ([DATE]?) [/RESET]
  elseif (nkey.eq.43) then
    if (sic_present(5,0)) then
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      ! WITH /RESET THE 3RD AND 4TH  ARGUMENTS ARE OPTIONALLY FREQUENCY AND DATE
      freq = -1e6
      call sic_r4(line,0,3,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,4,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if ((argum1.eq.'ALL').or.(argum1.eq.'all')) then
        n_flux = 0
      else
        do i=1, n_flux
          if (argum1.eq.c_flux(i)) then
            fr_ok = (frmhz.le.0)   &
              .or. (abs(frmhz-freq_flux(i)).lt.frtol)
            d_ok = (dayf.lt.-100000)   &
              .or. (abs(date_flux(i)-dayf).le.1)
            if (fr_ok .and. d_ok) c_flux(i) = '~'
          endif
        enddo
      endif
    else
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2.eq.'*') then
        rarg = 0
      else
        call sic_r4(line,0,3,rarg,.true.,error)
        if (error) return
      endif
      freq = -1e6
      call sic_r4(line,0,4,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,5,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if = 0
      do i=1, n_flux
        if (argum1.eq.c_flux(i)) then
          ! WAS FIXED:
          if (f_flux(i).and.(rarg.le.0)) then
            c_flux(i) = '~'
            if = -1
          elseif (rarg.le.0) then
            if = -1
          else
            fr_ok = (freq_flux(i).le.0)   &
              .or. (abs(frmhz-freq_flux(i)).lt.frtol)
            d_ok = (date_flux(i).lt.-100000)   &
              .or. (abs(date_flux(i)-dayf).le.1)
            if (fr_ok .and. d_ok) then
              if (if.eq.0) then
                if = i
              else
                c_flux(i) = '~'
              endif
            endif
          endif
        endif
      enddo
      ! NEW ONE
      if (if.eq.0) then
        if (n_flux.lt.m_flux) then
          n_flux = n_flux+1
          c_flux(n_flux) = argum1
          f_flux(n_flux) = rarg.ne.0
          freq_flux(n_flux) = frmhz
          date_flux(n_flux) = dayf ! THE OBSERVATION DATE
          flux(n_flux) = rarg
        else
          call message(8,3,'CLIC_SET','TOO MANY FLUXES')
          error = .true.
        endif
      elseif (rarg.ne.0) then
        f_flux(if) = rarg.ne.0
        date_flux(if) = dayf   ! THE OBSERVATION DATE
        freq_flux(if) = max(freq_flux(if),frmhz)
        if (rarg.ne.0) flux(if) = rarg
      endif
    endif
    call sort_fluxes(error)
  !
  ! SET WATER *|VALUE
  elseif (nkey.eq.44) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      atm_water = -100.
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        atm_water = rarg
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET TREC *|VALUE /ANTENNA I|ALL
  elseif (nkey.eq.45) then
    argum1 = '*'
    call get_antennas(line,3,na,ia,.true.,error)
    if (error) return
    iant = ia(1)
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      do j=1, na
        atm_trec(ia(j)) = -100.
      enddo
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        do j=1, na
          atm_trec(ia(j)) = rarg
        enddo
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET VIRTUAL **OBSOLETE**
  elseif (nkey.eq.46) then
    call message (8,2,'CLIC_SET',   &
      'CLIC\SET VIRTUAL IS NOW OBSOLETE')
  !
  ! SET SELECTION CO|LI  UP|LO|AV|AU SUBBAND-CODE FR FREQ /WINDOW
  elseif (nkey.eq.47) then
    i = 2
    k = 0
    to = .false.
    and = .false.
    l = 0
    widex_select = .false.
    do while (i.le.narg)
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 479
      call sic_ambigs(' ',argum1,kw,nkey,vsub2, mvsub2, more)
      if (more) then
        lc = len_trim(argum1)  ! ou la sortie de sic_ch
        if (lc.le.1) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (argum1(1:1).eq."C") then
          factor = 0
        elseif (argum1(1:1).eq."L") then
          factor = 1
        else
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (lc.gt.4) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        read(argum1(2:lc),'(I3)',iostat=ier) nkey
        if (ier.ne.0)  then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (nkey.lt.1 .or. nkey.gt.mbands) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif  
        nkey = nkey + factor * mbands
      endif
      i = i+1
      if (kw.eq.'CONTINUUM') then
        cont_select = .true.
      elseif (kw.eq.'LINE') then
        cont_select = .false.
      elseif (kw.eq.'UPPER' .or. kw.eq.'USB') then
        isideb_out = 1
      elseif (kw.eq.'LOWER' .or. kw.eq.'LSB') then
        isideb_out = 2
      elseif (kw.eq.'AVERAGE' .or. kw.eq.'DSB') then
        isideb_out = 3
        if (.not. cont_select) then
          call message(6,2,'CLIC_SET',   &
            'AUTOMATIC SIDEBAND SELECTION IN LINE  MODE')
        endif
      elseif (kw.eq.'WIDEX') then
        widex_select = .true.
      elseif (kw.eq.'AUTO') then
        isideb_out = 4
      elseif (kw.eq.'SSB') then
        isideb_out = 5
      elseif (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      elseif (kw.eq.'ALL') then
        all_select = .true.
      elseif (kw.eq.'FREQUENCY') then
        call sic_r4(line,0,i,freq_out,.true.,error)
        if (error) goto 98
        i = i+1
      else
        all_select = .false.
        if (to) then
          if (k.le.0 .or. nkey.le.k .or. nkey.gt.2*mbands) then
            call message(6,3,'CLIC_SET',   &
              'INVALID SUBBAND RANGE')
            error = .true.
            return
          endif
          do j = k+1, nkey
            l = l + 1
            iso(l) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'INVALID SUBBAND RANGE')
            goto 479
          endif
          l = l  + 1
          iso(l) = nkey
          k = nkey
          and = .false.
        elseif (k.eq.0) then
          l = 1
          k = nkey
          iso(1) =  nkey
        endif
      endif
    enddo
    if (l.ne.0) then
      if (widex_select.and..not.all_select) then
         call message(8,3,'SELECT','SET SELECTION WIDEX can only be &
                      used with SET SELECTION ALL')
         error = .true.
         return
      endif
      lsubb_out = l
      do i=1, l
          isubb_out(i) = iso(i)
      enddo
      if (widex_select.and..not.all_select) then
         call message(8,3,'SELECT','SET SELECTION WIDEX can only be &
                      used with SET SELECTION ALL')
         error = .true.
         return
      endif
    endif
    !
    if (sic_present(2,0)) then
      nn = sic_narg(2)
      if (nn.lt.2) go to 478
      if (nn/2 .gt. mwin_out) then
        call message(6,3,'CLIC_SET','TOO MANY WINDOWS')
        error = .true.
        return
      endif
      do i=1, nn/2
        argum1 = '*'
        call sic_ke(line,2,2*i-1,argum1,nch,.true.,error)
        if (error) goto 478
        if (argum1.eq.'*') then
          f1  = 0.0
        else
          call sic_r4(line,2,2*i-1,f1,.true.,error)
          if (error) goto 478
        endif
        argum1 = '*'
        call sic_ke(line,2,2*i,argum1,nch,.true.,error)
        if (error) goto 478
        if (argum1.eq.'*') then
          f2  = 1e30
        else
          call sic_r4(line,2,2*i,f2,.true.,error)
          if (error) goto 478
        endif
        if (f1.lt.f2) then
          ftry (1,i) = f1
          ftry (2,i) = f2
        else
          goto 478
        endif
      enddo
      nwin_out = nn/2
      do i=1, nwin_out
        window_out(1,i) = ftry(1,i)
        window_out(2,i) = ftry(2,i)
      enddo
    endif
    call show_general('SELECTION',.false.,line,error)
    goto 90
478 call message(6,3,'CLIC_SET','INVALID SELECTION WINDOW')
    error = .true.
    return
479 call message(6,3,'CLIC_SET','INVALID SELECTION '//argum1)
    error = .true.
    return
  !
  ! SET ANTENNAS [P..] A1 A2 A3
  elseif (nkey.eq.48) then
    if (narg.le.1) then
      call switch_antenna
      change_display = .true.
      call set_display(error)
      goto 90
    endif
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 489
    all_base = .false.
    phys_base = .false.
    nch = ichar(argum1(1:1))
    if (nch.gt.ichar('9')) then
      call sic_ambigs('SET ANTENNAS',argum1,kw,nkey,voc3,mvoc3,   &
        error)
      if (kw.eq.'PHYSICAL') then
        i1 = 3
        if ((narg.ge.i1).and.(r_nant.eq.0)) then
          call message(6,3,'SET ANTENNA PHYSICAL',   &
            'NO DATA READ')
          error=.true.
          goto 489
        endif
        phys_base = .true.
        do i=1,mnant
          phys_log(i) = mnant+1
        enddo
        do i=1,r_nant
          phys_log(r_kant(i)) = i
        enddo
      elseif (kw.eq.'LOGICAL') then
        i1 = 3
      elseif (kw.eq.'ALL') then
        all_base = .true.
        i_base(1) = -1
        call set_all_baselines
        i1 = 3
        if (skip_flag) then
          do i=1, mnant
            i_ant(i) = i
          enddo
          n_base = mnant
        endif
      endif
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 489
    error = .true.
    n_base = 0
    do i = i1, narg
      call sic_i4(line,0,i,iarg,.false.,error)
      if (iarg.gt.mnant .or. iarg.le.0) error = .true.
      if (error) goto 489
      if(phys_base) then
        n_base = n_base+1
        if (phys_log(iarg).le.r_nant) then
          i_base(n_base) = -phys_log(iarg)
        else
          ! IF PHYSICAL ANTENNA IS NOT IN THE
          ! ARRAY, THEN USE FAKE LOGICAL ANTENNA
          ! = PHYSICAL + 10 (TO BE DECODED BY
          ! SHOW COMMAND)
          i_base(n_base) = -(iarg+mnant)
        endif
      else
        n_base = n_base+1
        i_base(n_base) = -iarg
      endif
      i_ant(n_base) = iarg
    enddo
    error = .false.
    if (n_base.gt.0) call set_display(error)
489 continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      if (n_base.gt.0) then
        call show_display('ANTENNAS',.false.,error)
        change_display = .true.
      endif
    endif
  !
  ! SET SPECTRUM ON|OFF
  elseif (nkey.eq.49) then
    call message (8,2,'CLIC_SET',   &
      'CLIC\SET SPECTRUM ON|OFF IS NOW OBSOLETE')
  !
  ! SET BINNING OFF:SISE [POS]
  elseif (nkey.eq.50) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:3).eq.'OFF') then
      do_bin = .false.
      call message(4,1,'CLIC_SET','BINNING IS OFF')
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      bin_pos = 0.
      call sic_r4(line,0,3,bin_pos,.false.,error)
      if (error) return
      if (rarg.gt.0.) then
        do_bin = .true.
        bin_size = rarg
        write(ch,'(A,2(1X,1PG11.4))')   &
          'SIZE AND POSITION OF BINS ',bin_size, bin_pos
        call message(4,1,'CLIC_SET',ch(1:lenc(ch)))
      else
        call message(6,3,'CLIC_SET','INVALID BIN SIZE')
      endif
    endif
    change_display = .true.
  !
  ! SET WEIGHTS ON|OFF
  elseif (nkey.eq.51) then
    i = 2
    do while (sic_present(0,i))
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET WEIGHTS',argum1,kw,nkey,   &
        voc13,mvoc13,error)
      if (error) return
      if (kw.eq.'TSYS') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS TSYS',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_tsys =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY 1/TSYS**2 APPLIED IN TABLE')
        else
          weight_tsys = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY 1/TSYS**2 NOT APPLIED IN TABLE')
        endif
      elseif (kw.eq.'INSTRUMENTAL' .or. kw.eq.'CALIBRATION') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS CALIBRATION',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_cal =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY CALIBRATION FUNCTION APPLIED IN TABLE')
        else
          weight_cal = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY CALIBRATION FUNCTION '//   &
            'NOT APPLIED IN TABLE')
        endif
      elseif (kw.eq.'BANDPASS') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS BANDPASS',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_pass =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY BANDPASS FUNCTION APPLIED IN TABLE')
        else
          weight_pass = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY BANDPASS FUNCTION '//   &
            'NOT APPLIED IN TABLE')
        endif
      elseif (kw.eq.'BASELINE') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS BASELINE',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          call sic_r4(line,0,i+2,weight_base_power,.true.,error) 
          if (error) return
          i = i +1
          weight_base =  .true.
        else
          weight_base = .false.
        endif
      endif
      i = i + 2
    enddo
  !
  ! SET DATA NP NB
  elseif (nkey.eq.52) then
    call sic_i4(line,0,2,i,.true.,error)
    if (error) return
    i = max(2,i)
    j = m_boxes
    call sic_i4(line,0,3,j,.false.,error)
    if (error) return
    j = max(1,min(j,mbox))
    call set_data(i,j)
    call set_display(error)
  !
  ! SET RECORD LIST
  elseif (nkey.eq.53) then
    ic = sic_start(0,2)
    if (line(ic:ic).eq.'*') then
      n_loop = 1
      rec_1(1) = 1
      rec_2(1) = 1000000
      rec_3(1) = 1
      goto 90
    endif
    iv = sic_end(0,narg)
    call sic_parse_listi4('CLIC_SET',line(ic:iv),list,m_loop,error)
    if (error) return
    n_loop = list%nlist
    rec_1(:) = list%i1(:)
    rec_2(:) = list%i2(:)
    rec_3(:) = list%i3(:)
  !
  ! SET CRITERIA /DEFAULT
  elseif (nkey.eq.54) then
    if (default) then
      call setdef(line, error)
    else
      argum1 = 'CRITERIA'
      goto 98
    endif
  !
  ! SET GAIN_IMAGE
  elseif (nkey.eq.55) then
    argum1 = '*'
    call get_antennas(line,3,na,ia,.true.,error)
    if (error) return
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      do j=1, na
        atm_gim(ia(j)) = -1.
      enddo
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        do j=1, na
          atm_gim(ia(j)) = rarg
        enddo
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET DROP_FRACTION
  elseif (nkey.eq.56) then
    rarg = fdrop(1)
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg.ge.0. .and. rarg.le.0.5) then
      fdrop(1) = rarg
    else
      call message(6,3,'CLIC_SET','INVALID BANDWIDTH FRACTION')
      error = .true.
      return
    endif
    rarg = fdrop(2)
    call sic_r4(line,0,3,rarg,.true.,error)
    if (error) return
    if (rarg.ge.0. .and. rarg.le.0.5) then
      fdrop(2) = rarg
    else
      call message(6,3,'CLIC_SET','INVALID BANDWIDTH FRACTION')
      error = .true.
      return
    endif
  !
  ! SET GIBBS
  elseif (nkey.eq.57) then
    iarg = ngibbs
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    ngibbs = min(32,max(0,iarg))
  !
  ! SET FIND
  elseif (nkey.eq.58) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET FIND',argum1,kw,nkey,voc15,mvoc15,error)
    if (error) return
    if (kw.eq.'UPDATE') then
      find_update = .true.
    else
      find_update = .false.
    endif
  !
  ! SET PLANET
  elseif (nkey.eq.59) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET PLANET',argum1,kw,nkey,   &
      voc16,mvoc16,error)
    if (error) return
    if (kw.eq.'*') then
      planet_model = -1        ! DEFAULT ELLIPTIC FORMULA
      call message(6,2,'SET PLANET','DEFAULT BEHAVIOUR RESET')
    elseif (kw.eq.'PRIMARY') then
      planet_model = -2        ! CIRCULAR DISK + PRIMARY BEAM ATT.
    elseif (kw.eq.'FILE') then
      call sic_ch(line,0,3,ch,nch,.true.,error)
      if (error) return
      fich = ch
      call sic_parsef(ch,fich,' ','.SPL')
      call set_fluxspl(fich,planet_model)
    endif
  !
  ! SET RECEIVER
  elseif (nkey.eq.60) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      srecei = -1
    else
      call sic_i4(line,0,2,l,.true.,error)
      if (error) return
      srecei = l
    endif
  !
  ! SET UV_RANGE
  elseif (nkey.eq.61) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      uv_range(1) = 0
    else
      call sic_r4(line,0,2,uv_range(1),.true.,error)
      if (error) return
      uv_range(1) = max(uv_range(1),0.)
    endif
    call sic_ke(line,0,3,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      uv_range(2) = 1000.
    else
      call sic_r4(line,0,3,uv_range(2),.true.,error)
      if (error) return
      uv_range(2) = max(uv_range(1),uv_range(2))
    endif
    call show_display('UV_RANGE',.false.,error)
  !
  ! SET TIME_ORIGIN
  elseif (nkey.eq.62) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    call reset_time
    if (argum1.ne.'*') then
      call cdate(argum1,i,error)
      if (.not.error) dobs_0 = i
    endif
    if (dobs_0.eq.0) then
      call message(6,1,'SET','TIME ORIGIN IS AUTOMATIC')
    else
      call datec(i,argum1,error)
      call message(6,1,'SET','TIME ORIGIN IS '//argum1(1:12))
    endif
  !
  ! SET SORT RECEIVER|SCAN
  elseif (nkey.eq.63) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET SORT',argum1,kw,nkey,voc17,mvoc17,error)
    if (error) return
    if (kw.eq.'RECEIVER') then
      do_sort_receiver = .true.
      do_sort_num      = .false.
    elseif (kw.eq.'SCAN') then
      do_sort_receiver = .false.
      do_sort_num      = .false.
    elseif (kw.eq.'NUM') then
      do_sort_receiver = .false.
      do_sort_num      = .true.
    endif
  !
  ! SET COPY DATA|NODATA
  elseif (nkey.eq.64) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET WRITE',argum1,kw,nkey,voc18,mvoc18,error)
    if (error) return
    if (kw.eq.'DATA') then
      do_write_data = .true.
    elseif (kw.eq.'NODATA') then
      do_write_data = .false.
    endif
  !
  ! SET GAIN_METHOD OLD|NEW
  elseif (nkey.eq.65) then
    argum1 = 'OLD'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET GAIN_METHOD',argum1,kw,nkey,voc19,   &
      mvoc19,error)
    if (error) return
    if (kw.eq.'OLD') then
      call message(6,1,'SET','OLD GAIN METHOD')
      new_ant_gain = .false.
    elseif (kw.eq.'NEW') then
      call message(6,1,'SET','NEW GAIN METHOD')
      new_ant_gain = .true.
    endif
  !
  ! SET POLARIZATION NO|HOR|VER|BOTH|EACH
  elseif (nkey.eq.66) then
    do_polar = 0
    argum1 = 'OFF'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET POLARIZATION',argum1,kw,nkey,voc20,   &
      mvoc20,error)
    if (error) return
    each_subb = .false.
    quar_subb = 0
    nbc_subb = 0
    widex_subb = 0
    narrow_input = 0
    widex_unit = 0
    each_polar = .false.
    if (kw.eq.'OFF') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: OFF')
      do_polar = 0
      all_subb = .true.
      pol_subb = 0
      call set_all_subbands
    elseif (kw.eq.'HORIZONTAL') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: HORIZONTAL')
      do_polar = 1
      all_subb = .false.
      pol_subb = 1
      call set_pol_subbands(error)
      if (error) return
    elseif (kw.eq.'VERTICAL') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: VERTICAL')
      do_polar = 2
      all_subb = .false.
      pol_subb = 2
      call set_pol_subbands(error)
      if (error) return
    elseif (kw.eq.'BOTH') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: BOTH')
      do_polar = 3
      all_subb =.true.
      pol_subb = 0
      call set_all_subbands
    elseif (kw.eq.'EACH') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: EACH')
      do_polar = 0
      all_subb =.false.
      each_polar =.true.
      pol_subb = 0
      call set_each_pol_subbands
    endif
    call select_pol
    call set_display(error)
    change_display = .true.
    call show_display('POLARIZATION',.false.,error)
  !
  ! SET FAKE OFF | (1|2|3|4)*8
  elseif (nkey.eq.67) then
    print *,'W-CLIC_SET, Highly experimental command, go away!'
    argum1='OFF'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (argum1.eq.'OFF') then
      print *,'I-CLIC_SET, SET FAKE OFF'
      fake_ngrx = .false.
      new_receivers = .false.
    else
      fake_fif1 = 6500
      first = .true.
      second = .false.
      do i=1,8
        fake_lpolmode(i) = 1
        call sic_i4(line,0,i+1,q,.true.,error)
        if (first) then
          first_quarter = q
          first = .false.
          print *,'I-CLIC_SET FIRST QUARTER: ',first_quarter
        else
          if (q.ne.first_quarter) then
            if (.not.second) then
              second_quarter = q
              second = .true.
              print *,'I-CLIC_SET SECOND QUARTER:',second_quarter
            else
              if (q.ne.second_quarter) then
                print *,'E-CLIC_SET, SELECT ONLY 2 QUARTERS'
                return
              endif
            endif
          endif
        endif
        if (q.eq.1) then
          fake_flo2(i) = 8100
          fake_flo2bis(i) = 4000
          fake_band2bis(i) = -1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          endif
        elseif (q.eq.2) then
          fake_flo2(i) = 8100
          fake_flo2bis(i) = 2000
          fake_band2bis(i) = 1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          endif
        elseif (q.eq.3) then
          fake_flo2(i) = 9900
          fake_flo2bis(i) = 4000
          fake_band2bis(i) = -1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          endif
        elseif (q.eq.4) then
          fake_flo2(i) = 9900
          fake_flo2bis(i) = 2000
          fake_band2bis(i) = 1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          endif
        else
          print *,'E-CLIC_SET, quarter must be 1-2-3-4'
          error = .true.
          return
        endif
      enddo
      print *,'FAKE_ENTRY',fake_lpolentry
      fake_ngrx = .true.
      new_receivers = .true.
      print *,'I-CLIC_SET, SET FAKE ON'
      do i=1,8
        write(*,'(A,I3,F6.0,F6.0)') '   Unit, FLO2, FLO2bis ',   &
          i, fake_flo2(i), fake_flo2bis(i)
      enddo
    endif
  !
  ! SET TOTAL_POWER RAW|PHYSICAL
  elseif (nkey.eq.68) then
    argum1 = 'PHYSICAL'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET TOTAL_POWER',argum1,kw,nkey,voc21,   &
      mvoc21,error)
    if (error) return
    if (kw.eq.'RAW') then
      call message(6,1,'SET','Raw total power scale')
      physical_power = .false.
    elseif (kw.eq.'PHYSICAL') then
      call message(6,1,'SET','Physical total power scale')
      physical_power = .true.
    endif
  !
  ! SET NARROW_INPUT 0|1|2
  elseif (nkey.eq.69) then
    call sic_delvariable('NARROW',.false.,error)
    error = .false.
    narrow_input = 0
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if ((iarg.lt.0).or.(iarg.gt.2)) then
      call message(6,3,'SET','Invalid narrow-band corr. input')
      error = .true.
      return
    endif
    narrow_input = iarg
    call sic_def_inte('NARROW',narrow_input,0,0,.false.,error)
    write (ch,'(A,I1)')   &
      'Selecting narrow-band correlator input ',narrow_input
    call message(6,1,'CLIC_SET',ch)
    each_subb = .false.
    pol_subb = 0
    quar_subb = 0
    widex_subb = 0
    each_polar = .false.
    if (narrow_input.ne.0) then
      nbc_subb = narrow_input
      all_subb = .false.
      call set_nbc_subbands(error)
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = narrow_input
      bb_select = .true.
    else
      nbc_subb = 0
      all_subb = .true.
      bb_select = .false.
      call set_all_subbands
    endif
    if (error) return
    !
    ! Update polarization mode
    !         IF (NEW_RECEIVERS) THEN
    !            OLD_DO_POLAR = DO_POLAR
    !            CALL CHECK_POL_SUBBANDS(ERROR)
    !            KW = VOC20(DO_POLAR+1)
    !            N = LENC(KW)
    !            IF (DO_POLAR.NE.OLD_DO_POLAR) THEN
    !               CALL MESSAGE(6,1,'CLIC_SET',
    !     &         'Switching to polarization mode: '//KW(1:N))
    !            ELSE
    !               CALL MESSAGE(6,1,'CLIC_SET',
    !     &         'Polarization mode: '//KW(1:N))
    !            ENDIF
    !         ENDIF
    do_polar = 0
    widex_unit = 0
    call set_display(error)
    change_display = .true.
  !
  ! End
  elseif (nkey.eq.70) then
    call sic_delvariable('WIDEX',.false.,error)
    error = .false.
    widex_unit = 0
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if ((iarg.lt.0).or.(iarg.gt.4)) then
      call message(6,3,'SET','Invalid widex unit selection')
      error = .true.
      return
    endif
    widex_unit = iarg
    call sic_def_inte('WIDEX',widex_unit,0,0,.false.,error)
    write (ch,'(A,I1)')   &
      'Selecting widex unit number ',widex_unit
    n_baseband = 1
    l_baseband(1) = 1
    i_baseband(1,1) = 2+widex_unit
    bb_select = .true.
    call message(6,1,'CLIC_SET',ch)
    each_subb = .false.
    pol_subb = 0
    quar_subb = 0
    nbc_subb =0
    widex_subb = widex_unit
    all_subb = .false.
    call set_widex_subbands(error)
    if (error) return
    do_polar = 0
    narrow_input = 0
    each_polar = .false.
    call set_display(error)
    change_display = .true.
  !
  ! SET BBAND
  elseif (nkey.eq.71) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_baseband
    do i=1, n_savb
      l_savb(i) = l_baseband(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_baseband(j,i)
      enddo
    enddo
    n_baseband = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      call sic_ambigs_sub('SET BBAND',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (nkey.eq.0) then
          call sic_i4(line,0,i,nkey,.true.,error)
          kw = 'NUMBER'
      endif
!      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        all_bband = .true.
        call set_all_bbands
      elseif (kw.eq.'EACH') then
        print *,"Work needed here"
        all_bband = .false.
      else
        all_bband = .false.
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          do j = k+1, nkey
            l_baseband(n_baseband) = l_baseband(n_baseband) + 1
            i_baseband(l_baseband(n_baseband),n_baseband) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          l_baseband(n_baseband) = l_baseband(n_baseband) + 1
          i_baseband(l_baseband(n_baseband),n_baseband) = nkey
          k = nkey
          and = .false.
        else
          n_baseband = n_baseband+1
          k = nkey
          i_baseband(1,n_baseband) = nkey
          l_baseband(n_baseband) = 1
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_bb
    call set_bb_subbands(error)
    call set_subbands_if(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    call set_display(error)
    bad = error
!279 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('BBAND',.false.,error)
    endif
  !
  ! SET IF
  elseif (nkey.eq.72) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_if
    do i=1, n_savb
      l_savb(i) = l_if(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_if(j,i)
      enddo
    enddo
    n_if = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      call sic_ambigs_sub('SET BBAND',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (nkey.eq.0) then
          call sic_i4(line,0,i,nkey,.true.,error)
          kw = 'NUMBER'
      endif
!      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        print *,"Work needed here"
!        n_subb = n_savb
!        all_subb = .true.
!        each_subb = .false.
!        pol_subb = 0
!        quar_subb = 0
!        nbc_subb = 0
!        widex_subb = 0
!        call set_all_subbands
      elseif (kw.eq.'EACH') then
        print *,"Work needed here"
!        n_subb = n_savb
!        all_subb = .false.
!        each_subb = .true.
!        pol_subb = 0
!        quar_subb = 0
!        nbc_subb = 0
!        widex_subb = 0
!        call set_each_subband
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          do j = k+1, nkey
            l_if(n_if) = l_if(n_if) + 1
            i_if(l_if(n_if),n_if) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          l_if(n_if) = l_if(n_if) + 1
          i_if(l_if(n_if),n_if) = nkey
          k = nkey
          and = .false.
        else
          n_if = n_if+1
          k = nkey
          i_if(1,n_if) = nkey
          l_if(n_if) = 1
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_if
    call set_if_subbands(error)
    call set_subbands_bb(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    call set_display(error)
    bad = error
!279 continue
    if (bad) then
      n_if = n_savb
      do i=1, n_if
        l_if(i) = l_savb(i)
        do j=1, l_savb(i)
          i_if(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('BBAND',.false.,error)
    endif
  !
  ! SET SPW
  elseif (nkey.eq.73) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_subb
    do i=1, n_savb
      l_savb(i) = l_subb(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_subb(j,i)
      enddo
    enddo
    n_subb = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 280
      call sic_ambigs(' ',argum1,kw,nkey,vsub, mvsub, more)
      if (more) then
        lc = len_trim(argum1)  ! ou la sortie de sic_ch
        if (lc.le.1) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (argum1(1:1).eq."C") then
          factor = 0
        elseif (argum1(1:1).eq."L") then
          factor = 1
        else
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (lc.gt.4) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        read(argum1(2:lc),'(I3)',iostat=ier) nkey
        if (ier.ne.0)  then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (nkey.lt.1 .or. nkey.gt.mbands) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif  
        nkey = nkey + factor * mbands
      endif
      if (error) goto 280
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        n_subb = n_savb
        all_subb = .true.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_all_subbands
      elseif (kw.eq.'LINE') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).le.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)+mbands
            enddo
          endif
        enddo
      elseif (kw.eq.'CONTINUUM') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).gt.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)-mbands
            enddo
          endif
        enddo
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 280
          endif
          do j = k+1, nkey
            l_subb(n_subb) = l_subb(n_subb) + 1
            i_subb(l_subb(n_subb),n_subb) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 280
          endif
          l_subb(n_subb) = l_subb(n_subb) + 1
          i_subb(l_subb(n_subb),n_subb) = nkey
          k = nkey
          and = .false.
        else
          n_subb = n_subb+1
          k = nkey
          i_subb(1,n_subb) = nkey
          l_subb(n_subb) = 1
        endif
        !
        if (sic_present(2,0)) then
          argum1 = sw1(n_subb)
          call sic_ke(line,2,2*n_subb-1,argum1,nch,.true.,error)
          if (error) goto 280
          if (argum1.eq.'*') then
            sw1(n_subb) = '*'
            iw1(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb-1,iw1(n_subb),.true.,   &
              error)
            if (error) goto 280
            sw1(n_subb) = 'F'
          endif
          argum1 = sw2(n_subb)
          call sic_ke(line,2,2*n_subb,argum1,nch,.true.,error)
          if (error) goto 280
          if (argum1.eq.'*') then
            sw2(n_subb) = '*'
            iw2(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb, iw2(n_subb),.true.,   &
              error)
            if (error) goto 280
            sw2(n_subb) = 'F'
          endif
        else
          sw1(n_subb) = '*'
          iw1(n_subb) = 0
          sw2(n_subb) = '*'
          iw2(n_subb) = 0
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_subb
    call set_subbands_bb(error)
    call set_subbands_if(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    ! Now check/switch narrow band correlator input
    !
    if ((new_receivers).and.(narrow_input.ne.0)) then
      old_narrow_input = narrow_input
      call check_nbc_subbands(error)
      if (narrow_input.ne.old_narrow_input) then
        write (ch, '(A,I1)')   &
          'Switching to narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      else
        write (ch, '(A,I1)')   &
          'Narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      endif
    endif
    !
    call set_display(error)
    bad = error
280 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('SUBBAND',.false.,error)
    endif
  !
  ! SET SKIP YES|NO
  elseif (nkey.eq.74) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET SPIDX',argum1,kw,nkey,voc2,    &
      mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      iskip = 1
    elseif(kw.eq.'NO') then
      iskip = 0
    endif
  !
  ! SET EXCLUDE
  elseif (nkey.eq.75) then
    nexcl = narg-1
    if (nexcl.gt.10) then
      call message(6,2,'SET EXCLUDE',   &
        'ONLY 10 PROCEDURES RETAINED')
      nexcl = min(nexcl,10)
    endif
    do i=1,nexcl
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET EXCL',argum1,kw,nkey,voc12,mvoc12,   &
        error)
      if (error) then
        nexcl = 0
        return
      endif
      if (nkey.le.mvoc12-2) then
        ssexcl(i) = nkey+10
      elseif (kw.eq.'SKYDIP') then
        ssexcl(i) = 6
      elseif (kw.eq.'*') then
        nexcl = 0
      endif
    enddo
    find_needed = .true.
    call show_criteria('EXCLUDE',.false.,error)
  !
  ! SET SPIDX NAME [VALUE] [FREQUENCY] ([DATE]?) [/RESET]
  elseif (nkey.eq.76) then
    if (sic_present(5,0)) then
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      ! WITH /RESET THE 3RD AND 4TH  ARGUMENTS ARE OPTIONALLY FREQUENCY AND DATE
      freq = -1e6
      call sic_r4(line,0,3,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,4,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if ((argum1.eq.'ALL').or.(argum1.eq.'all')) then
        n_spidx = 0
      else
        do i=1, n_spidx
          if (argum1.eq.c_spidx(i)) then
            fr_ok = (frmhz.le.0)   &
              .or. (abs(frmhz-freq_spidx(i)).lt.frtol)
            d_ok = (dayf.lt.-100000)   &
              .or. (abs(date_spidx(i)-dayf).le.1)
            if (fr_ok .and. d_ok) c_spidx(i) = '~'
          endif
        enddo
      endif
    else
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2.eq.'*') then
        rarg = 0
      else
        call sic_r4(line,0,3,rarg,.true.,error)
        if (error) return
      endif
      freq = -1e6
      call sic_r4(line,0,4,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,5,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if = 0
      do i=1, n_spidx
        if (argum1.eq.c_spidx(i)) then
          ! WAS FIXED:
          if (f_spidx(i).and.(rarg.le.0)) then
            c_spidx(i) = '~'
            if = -1
          elseif (rarg.le.0) then
            if = -1
          else
            fr_ok = (freq_spidx(i).le.0)   &
              .or. (abs(frmhz-freq_spidx(i)).lt.frtol)
            d_ok = (date_spidx(i).lt.-100000)   &
              .or. (abs(date_spidx(i)-dayf).le.1)
            if (fr_ok .and. d_ok) then
              if (if.eq.0) then
                if = i
              else
                c_spidx(i) = '~'
              endif
            endif
          endif
        endif
      enddo
      ! NEW ONE
      if (if.eq.0) then
        if (n_spidx.lt.m_spidx) then
          n_spidx = n_spidx+1
          c_spidx(n_spidx) = argum1
          f_spidx(n_spidx) = rarg.lt.100
          freq_spidx(n_spidx) = frmhz
          date_spidx(n_spidx) = dayf ! THE OBSERVATION DATE
          spidx(n_spidx) = rarg
        else
          call message(8,3,'CLIC_SET','TOO MANY SPIDX')
          error = .true.
        endif
      elseif (rarg.ne.0) then
        f_spidx(if) = rarg.ne.0
        date_spidx(if) = dayf   ! THE OBSERVATION DATE
        freq_spidx(if) = max(freq_spidx(if),frmhz)
        if (rarg.ne.0) spidx(if) = rarg
      endif
    endif
    call sort_spidx(error)
  !
  ! SET VERSION 
  elseif (nkey.eq.77) then
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if (iarg.ge.2.and.iarg.le.version_last) then
      write (ch, '(A,I0)')   &
       'Setting observation version to ',iarg
      call message(6,1,'CLIC_SET',ch)
      write (ch, '(A,I0,A)')   &
       'Caution: use only if you know what you are doing'
      call message(6,2,'CLIC_SET',ch)
      version_current = iarg
    else
      write (ch, '(A,I0,A)')   &
       'Observation version ',iarg,' is not supported'
      call message(6,3,'CLIC_SET',ch)
      write (ch, '(A,I0)')   &
       'Latest supported version is ',version_last
      call message(6,3,'CLIC_SET',ch)
      error = .true.
      return
    endif
  !
  ! SET STOKES 
  elseif (nkey.eq.78) then
    if (narg.lt.2) return
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      if (argum1.eq.'RATIO') then
        nkey = code_stokes_ratio
      else
        call sic_ambigs_sub('SET STOKES',argum1,kw,nkey,voc23,   &
          mvoc23,error)
        if (nkey.ne.0) then
          if (kw.eq.'NATIVE') then
            do_leakage = .false.
            do_corrected = .false.
          elseif (kw.eq.'LEAKAGE') then
            do_leakage = .true.
            do_corrected = .false.
          elseif (kw.eq.'CORRECTED') then
            do_leakage = .false.
            do_corrected = .true.
          else
          endif
          return
        endif
        n_stokes = 0
        call sic_ambigs('SET STOKES',argum1,kw,nkey,gio_stokes_names,    &
          21,error)
        nkey = nkey-17
        if (nkey.eq.code_stokes_hh) do_polar = 1
        if (nkey.eq.code_stokes_vv) do_polar = 2
      endif
      n_stokes = n_stokes+1
      i_stokes(n_stokes) = nkey
    enddo
    if (error) return
    call show_display('STOKES',.false.,error)
  !
  ! SET TABLE
  elseif (nkey.eq.79) then
    argum1 = 'STANDARD'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET TABLE',argum1,kw,nkey,voc22,   &
      mvoc22,error)
    if (error) return
    if (kw.eq.'STANDARD') then
      call message(6,1,'SET','Standard TABLE command')
      table_prototype = .false.
    elseif (kw.eq.'PROTOTYPE') then
      call message(6,1,'SET','Prototype TABLE commad')
      table_prototype = .true.
    endif
  !
  ! SET FINDPOL
  elseif (nkey.eq.80) then
    argum1='*'
    snpol = 0
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      snpol = snpol+1
      if (argum1(1:1).eq.'*') then 
        snpol = 0
        call show_criteria('FINDPOL',.false.,error)
        find_needed = .true.
        return
      else
        call sic_i4(line,0,i,spol(snpol),.false.,error)
        if (spol(snpol).lt.-1.or.spol(snpol).gt.mnpolscan) then
          call message(6,3,'FIND','Invalid polarisation subscan')
          error = .true.
          return
        endif
        if (spol(snpol).eq.-1) then
          snpol = 16
          do j=1,snpol
            spol(j)=j
          enddo
        endif
      endif
    enddo
    call show_criteria('FINDPOL',.false.,error)
    find_needed = .true.
  !
  ! SET NOCHECK
  elseif (nkey.eq.81) then
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      call sic_ambigs('SET NOCHECK',argum1,kw,nkey,voc24,   &
            mvoc24,error)
      if (nkey.gt.0.and.nkey.le.mcheck) table_check(nkey) = .false.
    enddo
    call show_general('NOCHECK',.false.,line,error)
  else
    call message(6,3,'SET',keywor//' not implemented')
    error = .true.
    return
  endif
  !
90 nl = index(line,' ')+1
  nla = nl+lenc(argum)
  line(nl:) = keywor(1:lenc(keywor))//line(nla:)
  return
  !
98 call message(6,3,'CLIC_SET','Error decoding '//argum1)
  error = .true.
  return
end subroutine clic_set
!
subroutine get_antennas(line,iopt,nant,iant,needed,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Get list of antennas from /ANTENNA option
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  integer :: nant                   !
  integer :: iant(*)                !
  logical :: needed                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  ! Local
  character(len=4) :: arg
  integer :: i, nch
  !-----------------------------------------------------------------------
  do i=1, mnant
    iant(i) = 0
  enddo
  ! error in needed and /ANTENNA option not present
  if (.not.sic_present(iopt,1)) then
    if (needed) then
      call message(6,3,'GET_ANTENNAS','Give /ANTENNA i, please')
      error = .true.
      return
    endif
  endif
  ! All antennas (default if not needed)
  arg = 'ALL'
  call sic_ke(line,iopt,1,arg,nch,needed,error)
  if (arg.eq.'ALL') then
    nant = mnant
    do i=1, mnant
      iant(i) = i
    enddo
    return
  endif
  ! Get antenna list
  nant = sic_narg(iopt)
  do i=1, nant
    call sic_i4(line,iopt,i,iant(i),.true.,error)
    if (iant(i).gt.mnant .or. iant(i).le.0) then
      call message(6,3,'GET_ANTENNAS','Invalid antenna number')
    endif
  enddo
  return
end subroutine get_antennas

module gauss_parameter
  integer(kind=4), parameter :: mxpar=4  ! 3 for Gauss, 4 for HFS/NH3
  integer(kind=4), parameter :: mxline=10
  !
  ! Initial values and Dependency codes
  real(kind=4)    :: spar(mxpar*mxline)
  real(kind=4)    :: deltav
  integer(kind=4) :: kt0,kt(mxline)
  integer(kind=4) :: kv0,kv(mxline)
  integer(kind=4) :: kd0,kd(mxline)
  integer(kind=4) :: ko0,ko(mxline)
  integer(kind=4) :: kh0,kh(mxline)
  integer(kind=4) :: nline
  !
  ! Weights for minimization
  integer(kind=4) :: mxcan
  integer(kind=4), allocatable :: wfit(:)
  !
  ! Common containing results and errors
  integer(kind=4) :: ngline               ! Number of lines
  real(kind=4)    :: par(4*mxline)   ! Parameters
  real(kind=4)    :: err(4*mxline)   ! Errors
  real(kind=4)    :: sigbas          ! rms on baseline
  real(kind=4)    :: sigrai          ! rms on line
end module gauss_parameter
!
module hyperfine_structure
  ! HFS and NH3 line fitting
  integer(kind=4), parameter    :: mhyp=40
  integer(kind=4)               :: nhyp
  real(kind=4), dimension(mhyp) :: rhfs
  real(kind=4), dimension(mhyp) :: vhfs
  real(kind=4), save            :: hfs_tau_min=0.1
  real(kind=4), save            :: hfs_tau_max=100.0
end module hyperfine_structure
!
module pointing_fit
  real(kind=4) :: width
  real(kind=4) :: aratio
  real(kind=4) :: wratio
end module pointing_fit

module imbfits_interfaces_public
  interface
    subroutine imbfits_dump_summary(imbf,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support routine for command:
      !   DUMP SUMMARY
      !---------------------------------------------------------------------
      type(imbfits_t), intent(in)    :: imbf
      integer(kind=4), intent(in)    :: olun   ! Output LUN
      logical,         intent(inout) :: error
    end subroutine imbfits_dump_summary
  end interface
  !
  interface
    subroutine imbfits_dump_subscans(imbf,olun,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Support routine for command:
      !   DUMP SUBSCANS
      ! The subroutine reopens the input file in its own structure to avoid
      ! messing up the global instances
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      integer(kind=4), intent(in)    :: olun   ! Output LUN
      logical,         intent(inout) :: error
    end subroutine imbfits_dump_subscans
  end interface
  !
  interface
    subroutine imbfits_dump_primary(primary,short,olun,error)
      use gbl_message
      use gildas_def
      use imbfits_types
      use imbfits_key_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_primary_t), intent(in)    :: primary
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_primary
  end interface
  !
  interface
    subroutine imbfits_dump_scan(scan,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_scan_t), intent(in)    :: scan
      character(len=*),     intent(in)    :: column  ! Optional column name
      logical,              intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_scan
  end interface
  !
  interface
    subroutine imbfits_dump_frontend(front,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_front_t), intent(in)    :: front
      character(len=*),      intent(in)    :: column  ! Optional column name
      logical,               intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),       intent(in)    :: olun    ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_frontend
  end interface
  !
  interface
    subroutine imbfits_dump_backend(back,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_t), intent(in)    :: back
      character(len=*),     intent(in)    :: column  ! Optional column name
      logical,              intent(in)    :: short   ! Short or verbose output?
      integer(kind=4),      intent(in)    :: olun    ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_backend
  end interface
  !
  interface
    subroutine imbfits_dump_antslow(isub,antslow,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: isub     ! Subscan number
      type(imbfits_antslow_t), intent(in)    :: antslow
      character(len=*),        intent(in)    :: column   ! Optional column name
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antslow
  end interface
  !
  interface
    subroutine imbfits_dump_antfast(isub,antfast,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4),         intent(in)    :: isub     ! Subscan number
      type(imbfits_antfast_t), intent(in)    :: antfast
      character(len=*),        intent(in)    :: column   ! Optional column name
      logical,                 intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),         intent(in)    :: olun     ! Output LUN
      logical,                 intent(inout) :: error
    end subroutine imbfits_dump_antfast
  end interface
  !
  interface
    subroutine imbfits_dump_derot(derot,column,short,olun,error)
      use imbfits_types
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_derot_t), intent(in)    :: derot
      character(len=*),      intent(in)    :: column   ! Optional column name
      logical,               intent(in)    :: short    ! Short or verbose output?
      integer(kind=4),       intent(in)    :: olun     ! Output LUN
      logical,               intent(inout) :: error
    end subroutine imbfits_dump_derot
  end interface
  !
  interface
    subroutine imbfits_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine imbfits_message_set_id
  end interface
  !
  interface
    subroutine imbfits_message_debug(doalloc,alloc,doother,other,error)
      use imbfits_messaging
      !---------------------------------------------------------------------
      ! @ public
      !  Alter the imbfits specific severities. You can switch them to
      ! seve%d and seve%i only!
      !---------------------------------------------------------------------
      logical,         intent(in)    :: doalloc  !
      integer(kind=4), intent(in)    :: alloc    ! For iseve%alloc
      logical,         intent(in)    :: doother  !
      integer(kind=4), intent(in)    :: other    ! For iseve%other
      logical,         intent(inout) :: error    ! Logical error flag
    end subroutine imbfits_message_debug
  end interface
  !
  interface
    subroutine imbfits_read_header(filename,imbf,error)
      use gildas_def
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Open the file, read the leading HDUs, and build the list
      ! (equivalence classes) of subscans.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: filename
      type(imbfits_t),  intent(inout) :: imbf
      logical,          intent(inout) :: error
    end subroutine imbfits_read_header
  end interface
  !
  interface
    subroutine imbfits_open_file(filename,file,hdus,error)
      use gbl_message
      use gildas_def
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: filename
      type(imbfits_file_t), intent(out)   :: file
      type(imbfits_hdus_t), intent(out)   :: hdus
      logical,              intent(inout) :: error
    end subroutine imbfits_open_file
  end interface
  !
  interface
    subroutine imbfits_read_leadhdus(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the 4 first leading HDUs
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf
      logical,         intent(inout) :: error
    end subroutine imbfits_read_leadhdus
  end interface
  !
  interface
    subroutine imbfits_close_file(file,error)
      use gbl_message
      use gildas_def
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_file_t), intent(inout) :: file
      logical,              intent(inout) :: error
    end subroutine imbfits_close_file
  end interface
  !
  interface
    subroutine imbfits_free_leadhdus(imbf,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free the leading HDUs. Can be called in an error recovery context
      ! i.e. with error .true. as input.
      !---------------------------------------------------------------------
      type(imbfits_t), intent(inout) :: imbf      !
      logical,         intent(inout) :: error     !
    end subroutine imbfits_free_leadhdus
  end interface
  !
  interface
    subroutine imbfits_read_header_antslow(imbf,isub,mjd_shift,antslow,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf       !
      integer(kind=4),         intent(in)    :: isub       ! Subscan number
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec]
      type(imbfits_antslow_t), intent(inout) :: antslow    !
      logical,                 intent(inout) :: error      !
    end subroutine imbfits_read_header_antslow
  end interface
  !
  interface
    subroutine imbfits_read_header_derot(imbf,derot,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-derot HDU
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf   !
      type(imbfits_derot_t), intent(inout) :: derot  !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_derot
  end interface
  !
  interface
    subroutine imbfits_read_header_derot_onehdu(imbf,derot,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      use imbfits_key_types
      use imbfits_column_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read the IMBF-derot HDU
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf   !
      type(imbfits_derot_t), intent(inout) :: derot  !
      logical,               intent(inout) :: error  !
    end subroutine imbfits_read_header_derot_onehdu
  end interface
  !
  interface
    subroutine imbfits_read_header_derot_allinone(imbf,allderot,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      use imbfits_parameters
      !---------------------------------------------------------------------
      ! @ public
      !   Read all the IMBF-derot HDUs (for all subscans) concatenated as a
      ! single pseudo HDU. This subroutine makes sense only for pre-v2
      ! IMB-FITS.
      !   Note that this code assumes:
      !  1) that the subscans are ordered by time, and
      !  2) that the derotator tables are ordered by time.
      ! Possible overlap of the individual tables is correctly accounted
      ! for (duplicates are discarded).
      !---------------------------------------------------------------------
      type(imbfits_t),       intent(in)    :: imbf      !
      type(imbfits_derot_t), intent(inout) :: allderot  !
      logical,               intent(inout) :: error     !
    end subroutine imbfits_read_header_derot_allinone
  end interface
  !
  interface
    function imbfits_subscan_exists(imbf,sname,iclass)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Return .true. if the subscan class 'sname' exists. Optionally
      ! return the equivalence class number.
      !---------------------------------------------------------------------
      logical :: imbfits_subscan_exists
      type(imbfits_t),            intent(in)  :: imbf    !
      character(len=*),           intent(in)  :: sname   ! Subscan eclass name
      integer(kind=4),  optional, intent(out) :: iclass  ! Subscan eclass number
    end function imbfits_subscan_exists
  end interface
  !
  interface
    subroutine imbfits_read_subscan_header(imbf,sname,snum,goodonly,mjdinter,  &
      mjd_shift,subs,error)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Given a subscan name and relative number, move to the HDU and read
      ! the subscan headers from file.
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf
      character(len=*),        intent(in)    :: sname      ! Subscan name
      integer(kind=4),         intent(in)    :: snum       ! Subscan number
      logical,                 intent(in)    :: goodonly   ! Ignore bad data?
      logical,                 intent(in)    :: mjdinter   ! Compute MJD intersection?
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec]
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_subscan_header
  end interface
  !
  interface
    subroutine imbfits_read_subscan_header_bynum(imbf,isub,goodonly,mjdinter,  &
      mjd_shift,subs,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Given a subscan absolute number, move the HDU and read the subscan
      ! headers from file. On return let the CFITSIO pointer to the
      ! IMBF-backdataXXX HDU, such as its DATA column can be read right
      ! after.
      !---------------------------------------------------------------------
      type(imbfits_t),         intent(in)    :: imbf
      integer(kind=4),         intent(in)    :: isub
      logical,                 intent(in)    :: goodonly   ! Ignore bad data?
      logical,                 intent(in)    :: mjdinter   ! Compute MJD intersection?
      real(kind=8),            intent(in)    :: mjd_shift  ! [sec] Antslow MJD shift
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_read_subscan_header_bynum
  end interface
  !
  interface
    subroutine imbfits_free_header_antslow(antslow,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free the IMBF-antenna HDU
      !---------------------------------------------------------------------
      type(imbfits_antslow_t), intent(inout) :: antslow  !
      logical,                 intent(inout) :: error    !
    end subroutine imbfits_free_header_antslow
  end interface
  !
  interface
    subroutine imbfits_free_subscan_header(subs,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Free subscan data (except DATA column)
      !---------------------------------------------------------------------
      type(imbfits_subscan_t), intent(inout) :: subs
      logical,                 intent(inout) :: error
    end subroutine imbfits_free_subscan_header
  end interface
  !
  interface
    subroutine imbfits_read_data(caller,file,nchan,npix,ftime,ntime,  &
      imbdata,error)
      use gbl_message
      use cfitsio_api
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Reading subroutine specific to the 'DATA' column
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: caller   ! Name of calling subroutine
      type(imbfits_file_t), intent(in)    :: file     !
      integer(kind=4),      intent(in)    :: nchan    !
      integer(kind=4),      intent(in)    :: npix     !
      integer(kind=4),      intent(in)    :: ftime    ! First 'time' row read
      integer(kind=4),      intent(in)    :: ntime    ! Number of 'time' rows read
      type(imbfits_data_t), intent(inout) :: imbdata  !
      logical,              intent(inout) :: error    !
    end subroutine imbfits_read_data
  end interface
  !
  interface
    subroutine imbfits_free_data(imbdata,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Freeing subroutine specific to the 'DATA' column
      !---------------------------------------------------------------------
      type(imbfits_data_t), intent(inout) :: imbdata  !
      logical,              intent(inout) :: error    !
    end subroutine imbfits_free_data
  end interface
  !
  interface
    subroutine imbfits_dump_imbfdata(imbf,olun,error)
      use gbl_message
      use imbfits_types
      use ram_sizes
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_data_t), intent(in)    :: imbf
      integer(kind=4),      intent(in)    :: olun   ! Output LUN
      logical,              intent(inout) :: error
    end subroutine imbfits_dump_imbfdata
  end interface
  !
  interface
    subroutine imbfits_mvhdu_subscan(isub,hduid,imbf,error)
      use imbfits_messaging
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Move to appropriate HDU for the isub-th subscan
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: isub   ! Subscan number
      integer(kind=4), intent(in)    :: hduid  ! HDU identifier
      type(imbfits_t), intent(in)    :: imbf   !
      logical,         intent(inout) :: error  !
    end subroutine imbfits_mvhdu_subscan
  end interface
  !
  interface
    subroutine imbfits_copy_back_chunks(ichunks,ochunks,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: ichunks
      type(imbfits_back_chunks_t), intent(inout) :: ochunks
      logical,                     intent(inout) :: error
    end subroutine imbfits_copy_back_chunks
  end interface
  !
  interface
    subroutine imbfits_free_back_chunks(chunks,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(inout) :: chunks
      logical,                     intent(inout) :: error
    end subroutine imbfits_free_back_chunks
  end interface
  !
  interface
    subroutine imbfits_init_stokesloop(book,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Initialize the stokesset_book_t for later use by
      ! imbfits_get_next_stokesset
      !---------------------------------------------------------------------
      type(stokesset_book_t), intent(inout) :: book
      logical,                intent(inout) :: error
    end subroutine imbfits_init_stokesloop
  end interface
  !
  interface
    subroutine imbfits_get_next_stokesset(cdesc,book,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Get the next stokeset. As of today a stokeset can be:
      !  - A unique NONE chunkset (no polarimetry)
      !  - A collection AXISH+AXISV+REAL+IMAG (polarimetric chunksets)
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
      type(stokesset_book_t),      intent(inout) :: book   !
      logical,                     intent(inout) :: error  !
    end subroutine imbfits_get_next_stokesset
  end interface
  !
  interface
    subroutine imbfits_count_polar_stokesset(cdesc,nset,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Count the number POLARIMETRIC stokesets that would be found when
      ! iterating with imbfits_get_next_stokesset
      !---------------------------------------------------------------------
      type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
      integer(kind=4),             intent(out)   :: nset   ! Number of stokesset
      logical,                     intent(inout) :: error  ! Logical error flag
    end subroutine imbfits_count_polar_stokesset
  end interface
  !
  interface
    subroutine imbfits_upcase_column(char,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(fits_char_1d_t), intent(inout) :: char
      logical,              intent(inout) :: error
    end subroutine imbfits_upcase_column
  end interface
  !
  interface imbfits_free_column
    subroutine imbfits_free_logi_1d(logi,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_logi_1d
    subroutine imbfits_free_inte_1d(inte,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_inte_1d
    subroutine imbfits_free_real_1d(real,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_real_1d
    subroutine imbfits_free_dble_1d(dble,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_dble_1d
    subroutine imbfits_free_char_1d(char,error)
      use gbl_message
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public-generic imbfits_free_column
      !---------------------------------------------------------------------
      type(fits_char_1d_t), intent(inout) :: char    ! INOUT: keep allocation status
      logical,              intent(inout) :: error
    end subroutine imbfits_free_char_1d
  end interface imbfits_free_column
  !
  interface
    subroutine imbfits_variable_imbfits(struct,imbf,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: struct  ! Parent structure name
      type(imbfits_t),  intent(in)    :: imbf    !
      logical,          intent(in)    :: ro      ! Read-Only
      logical,          intent(inout) :: error   !
    end subroutine imbfits_variable_imbfits
  end interface
  !
  interface
    subroutine imbfits_variable_subscan(struct,subs,ro,error)
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_subscan_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: struct  ! Parent structure name
      type(imbfits_subscan_t), intent(in)    :: subs    !
      logical,                 intent(in)    :: ro      ! Read-Only
      logical,                 intent(inout) :: error   !
    end subroutine imbfits_variable_subscan
  end interface
  !
  interface
    subroutine imbfits_variable_imbfdata(struct,imbf,ro,error)
      use gildas_def
      use imbfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Create or recreate Sic variables mapping a imbfits_data_t
      ! structure.
      !---------------------------------------------------------------------
      character(len=*),     intent(in)    :: struct  ! Parent structure name
      type(imbfits_data_t), intent(in)    :: imbf    !
      logical,              intent(in)    :: ro      ! Read-Only
      logical,              intent(inout) :: error   !
    end subroutine imbfits_variable_imbfdata
  end interface
  !
end module imbfits_interfaces_public

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! In this file, the following modules are present in this order:
!    cubetools_spectral_systemic_types
!    cubetools_spectral_v_or_z_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_spectral_systemic_types
  !------------------------------------------------------------------------
  ! Systemic velocity or redshift information
  !------------------------------------------------------------------------
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_structure
  use cubetools_unit_arg
  use cubetools_keywordlist_types
  use cubetools_header_interface
  !
  public :: spectral_systemic_comm_t,spectral_systemic_user_t,spectral_systemic_prog_t
  private
  !
  type spectral_systemic_comm_t
     type(option_t),           pointer :: comm
     type(unit_arg_t),         pointer :: unit
     type(keywordlist_comm_t), pointer :: conv
   contains
     procedure, public :: register => cubetools_spectral_systemic_comm_register
     procedure, public :: parse    => cubetools_spectral_systemic_comm_parse
  end type spectral_systemic_comm_t
  !
  type spectral_systemic_user_t
     logical               :: present = .false.  ! Is the key present?
     character(len=argu_l) :: value   = strg_unk ! Value at reference pixel
     character(len=argu_l) :: unit    = strg_unk ! unit
     character(len=argu_l) :: conv    = strg_unk ! Convention (Optical|Radio)
   contains
     procedure, public :: list => cubetools_spectral_systemic_user_list
  end type spectral_systemic_user_t
  !
  type spectral_systemic_prog_t
     integer(kind=code_k)  :: code = code_systemic_unknown ! [--------] Systemic description: velocity or redshift
     integer(kind=code_k)  :: conv = code_speconv_unknown  ! [--------] Convention for velocity or redshift
     real(kind=coor_k)     :: value = 0d0                  ! [km/s|Red] Systemic value
   contains
     procedure, public :: list => cubetools_spectral_systemic_prog_list
     procedure, public :: from => cubetools_spectral_systemic_prog_from_headinter
     procedure, public :: to   => cubetools_spectral_systemic_prog_to_headinter
  end type spectral_systemic_prog_t
  !
contains
  !
  subroutine cubetools_spectral_systemic_comm_register(comm,name,abstract,help,unit,error)
    !----------------------------------------------------------------------
    ! Register a /VELOCITY|REDSHIFT key
    !----------------------------------------------------------------------
    class(spectral_systemic_comm_t), intent(inout) :: comm
    character(len=*),                intent(in)    :: name
    character(len=*),                intent(in)    :: abstract
    character(len=*),                intent(in)    :: help
    integer(kind=code_k),            intent(in)    :: unit
    logical,                         intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(unit_arg_t) :: unitarg
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>COMM>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    if ((name.ne.'VELOCITY').and.(name.ne.'REDSHIFT')) then
       call cubeheader_message(seve%e,rname,"Can only register a VELOCITY or REDSHIFT key")
       error = .true.
       return
    endif
    !
    call cubetools_register_option(&
         name,'value [unit [convention]]',&
         abstract,&
         help,&
         comm%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'VALUE',&
         'Value at reference pixel',&
         '"*" or "=" mean previous value is kept',&
         code_arg_mandatory,&
         error)
    if (error) return   
    call unitarg%register(&
         'UNIT',&
         'Unit',&
         '"=" or "*" mean current user unit',&
         code_arg_optional,&
         unit,&
         comm%unit,&
         error)
    if (error) return
    call keyarg%register(&
         'CONVENTION',&
         'Convention type',&
         '"=" mean previous value is kept, * means RADIO',&
         code_arg_optional,&
         speconvnames,&
         .not.flexible,&
         comm%conv,&
         error)
    if (error) return
  end subroutine cubetools_spectral_systemic_comm_register
  !
  subroutine cubetools_spectral_systemic_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! Parse /VELOCITY|REDSHIFT value [unit [convention]}
    !----------------------------------------------------------------------
    class(spectral_systemic_comm_t), intent(in)    :: comm
    character(len=*),                intent(in)    :: line
    class(spectral_systemic_user_t), intent(inout) :: user
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>COMM>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    user%value = strg_star
    user%unit  = strg_equal ! Unit should not be changed if user has not given a value
    user%conv  = strg_equal ! Convention should not be changed if user has not given a value
    call comm%comm%present(line,user%present,error)
    if (error) return
    if (user%present) then
       call cubetools_getarg(line,comm%comm,1,user%value,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%comm,2,user%unit,optional,error)
       if (error) return
       call cubetools_getarg(line,comm%comm,3,user%conv,optional,error)
       if (error) return
    endif
  end subroutine cubetools_spectral_systemic_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_spectral_systemic_user_list(user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectral_systemic_user_t), intent(in)    :: user
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>USER>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    print *,'Present:    ',user%present
    print *,'Value:      ',user%value
    print *,'Unit:       ',user%unit
    print *,'Convention: ',user%conv
  end subroutine cubetools_spectral_systemic_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetools_spectral_systemic_prog_list(prog,error)
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectral_systemic_prog_t), intent(in)    :: prog
    logical,                         intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>PROG>LIST'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    mess = cubetools_format_stdkey_boldval('SYSTEMICKIND',prog%code,'i3',17)
    mess = trim(mess)//' '//cubetools_format_stdkey_boldval('VAL',prog%value,fdouble,ndouble+3)
    mess = trim(mess)//' '//cubetools_format_stdkey_boldval('CONVENTION',prog%conv,'i3',17)
    call cubeheader_message(seve%r,rname,mess)
  end subroutine cubetools_spectral_systemic_prog_list
  !
  subroutine cubetools_spectral_systemic_prog_from_headinter(prog,head,error)
    use cubetools_header_interface
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectral_systemic_prog_t), intent(inout) :: prog
    type(cube_header_interface_t),   intent(in)    :: head
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>PROG>FROM>HEADINTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    prog%code  = head%spectral_systemic_code
    prog%value = head%spectral_systemic_value
    prog%conv  = head%spectral_convention
  end subroutine cubetools_spectral_systemic_prog_from_headinter
  !
  subroutine cubetools_spectral_systemic_prog_to_headinter(prog,head,error)
    use cubetools_header_interface
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spectral_systemic_prog_t), intent(in)    :: prog
    type(cube_header_interface_t),   intent(inout) :: head
    logical,                         intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>SYSTEMIC>PROG>TO>HEADINTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    head%spectral_systemic_code  = prog%code
    head%spectral_systemic_value = prog%value
    head%spectral_convention     = prog%conv
  end subroutine cubetools_spectral_systemic_prog_to_headinter
end module cubetools_spectral_systemic_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_spectral_v_or_z_types
  use cubetools_parameters
  use cubeheader_messaging
  use cubetools_spectral_systemic_types
  !
  public :: spectral_v_or_z_comm_t,spectral_v_or_z_user_t
  private
  !
  type spectral_v_or_z_comm_t
     type(spectral_systemic_comm_t) :: velo
     type(spectral_systemic_comm_t) :: reds
   contains
     procedure, public :: register => cubetools_spectral_v_or_z_comm_register
     procedure, public :: parse    => cubetools_spectral_v_or_z_comm_parse
  end type spectral_v_or_z_comm_t
  !
  type spectral_v_or_z_user_t
     type(spectral_systemic_user_t) :: velo
     type(spectral_systemic_user_t) :: reds
   contains
     procedure, public :: toprog => cubetools_spectral_v_or_z_user_toprog
  end type spectral_v_or_z_user_t
  !
contains
  !
  subroutine cubetools_spectral_v_or_z_comm_register(comm,error)
    use cubetools_unit
    !----------------------------------------------------------------------
    ! Register the /VELOCITY and /REDSHIFT keys
    !----------------------------------------------------------------------
    class(spectral_v_or_z_comm_t), intent(inout) :: comm
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>V>OR>Z>COMM>REGISTER'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call comm%velo%register(&
         'VELOCITY',&
         'Edit the systemic velocity',&
         'Systemic velocity updated based on user value in current user unit',&
         code_unit_velo,&
         error)
    if (error) return
    call comm%reds%register(&
         'REDSHIFT',&
         'Edit the systemic redshift',&
         'Systemic redshift updated based on user value. The unit is meaningless in this case.',&
         code_unit_unk,& !***JP: should be code_unit_none!
         error)
    if (error) return
  end subroutine cubetools_spectral_v_or_z_comm_register
  !
  subroutine cubetools_spectral_v_or_z_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! Parse the /VELOCITY and /REDSHIFT keys
    !----------------------------------------------------------------------
    class(spectral_v_or_z_comm_t), intent(in)    :: comm
    character(len=*),              intent(in)    :: line
    type(spectral_v_or_z_user_t),  intent(inout) :: user
    logical,                       intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPECTRAL>V>OR>Z>COMM>PARSE'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
    call comm%velo%parse(line,user%velo,error)
    if (error) return
    call comm%reds%parse(line,user%reds,error)
    if (error) return
  end subroutine cubetools_spectral_v_or_z_comm_parse
  !
  subroutine cubetools_spectral_v_or_z_user_toprog(user,comm,proghead,error)
    use cubetools_unit
    use cubetools_header_interface
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(spectral_v_or_z_user_t), intent(in)    :: user
    class(spectral_v_or_z_comm_t), intent(in)    :: comm
    type(cube_header_interface_t), intent(inout) :: proghead
    logical,                       intent(inout) :: error
    !
    type(spectral_systemic_prog_t) :: progsyst
    character(len=*), parameter :: rname='SPECTRAL>V>OR>Z>USER>TOPROG'
    !
    call cubeheader_message(headseve%trace,rname,'Welcome')
    !
!!$    call user%velo%list(error)
!!$    if (error) return
!!$    call user%reds%list(error)
!!$    if (error) return
    !
    if (user%velo%present.and.user%reds%present) then
       call cubeheader_message(seve%e,rname,'The /VELOCITY and /REDSHIFT keys are exclusive from each other')
       error = .true.
       return
    else if (user%velo%present.or.user%reds%present) then
       call progsyst%from(proghead,error)
       if (error) return
       if (user%velo%present) then
          call user2prog(code_systemic_velocity,code_unit_velo,&
               comm%velo,user%velo,progsyst,error)
          if (error) return
       else if (user%reds%present) then
          call user2prog(code_systemic_redshift,code_unit_unk,&
               comm%reds,user%reds,progsyst,error)
          if (error) return
       endif
       call progsyst%to(proghead,error)
       if (error) return
    else
       ! Does nothing!
    endif
    !
!!$    call progsyst%list(error)
!!$    if (error) return
    !
  contains
    !
    subroutine user2prog(code_syst,code_unit,comm,user,prog,error)
      !----------------------------------------------------------------------
      !----------------------------------------------------------------------
      integer(kind=code_k),           intent(in)    :: code_syst
      integer(kind=code_k),           intent(in)    :: code_unit
      type(spectral_systemic_comm_t), intent(in)    :: comm
      type(spectral_systemic_user_t), intent(in)    :: user
      type(spectral_systemic_prog_t), intent(inout) :: prog
      logical,                        intent(inout) :: error
      !
      type(unit_user_t) :: unit
      !
      call update_systemic_code(prog%code,code_syst)
      call unit%get_from_name_for_code(user%unit,code_unit,error)
      if (error) return
      call resolve_value(unit,user%value,prog%value,error)
      if (error) return
      call resolve_conv(comm%conv,user%conv,prog%conv,error)
      if (error) return
    end subroutine user2prog
    !
    subroutine update_systemic_code(prog,code)
      !----------------------------------------------------------------------
      !----------------------------------------------------------------------
      integer(kind=code_k) :: prog
      integer(kind=code_k) :: code
      !
      if (prog.ne.code) then
         call cubeheader_message(seve%w,rname,'You are trying to change the systemic kind')
         call cubeheader_message(seve%w,rname,'Using * or = may lead to unexpected results')
      endif
      prog = code      
    end subroutine update_systemic_code
    !
    subroutine resolve_value(unit,user,prog,error)
      use cubetools_user2prog
      !----------------------------------------------------------------------
      !----------------------------------------------------------------------
      type(unit_user_t), intent(in)    :: unit
      character(len=*),  intent(in)    :: user
      real(kind=coor_k), intent(inout) :: prog
      logical,           intent(inout) :: error
      !
      real(kind=coor_k) :: default,previous
      !
      default = prog
      previous = prog
      call cubetools_user2prog_resolve_all(user,unit,default,previous,prog,error)
      if (error) return      
    end subroutine resolve_value
    !
    subroutine resolve_conv(comm,user,prog,error)
      use cubetools_user2prog
      use cubetools_keywordlist_types
      !----------------------------------------------------------------------
      !----------------------------------------------------------------------
      type(keywordlist_comm_t), intent(in)    :: comm
      character(len=*),         intent(in)    :: user
      integer(kind=code_k),     intent(inout) :: prog
      logical,                  intent(inout) :: error
      !
      integer(kind=code_k) :: default,previous
      !
      default = prog
      previous = prog
      call cubetools_user2prog_resolve_code(comm,user,default,previous,prog,error)
      if (error) return      
    end subroutine resolve_conv
  end subroutine cubetools_spectral_v_or_z_user_toprog
end module cubetools_spectral_v_or_z_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program uv_pointing
  use gildas_def
  use image_def
  use gkernel_interfaces, no_interface=>fourt
  !---------------------------------------------------------------------
  ! Pointing Error Simulation
  !
  !     Fast pointing error simulation based on  gridded interpolation
  !     from the Fourier Transform of an image
  !
  !     H.Wiesemeyer S.Guilloteau
  !
  !----------------------------------------------------------------------
  !
  ! Expression of A
  !     A(x,y) = exp[-2ln(2)/Theta(i)^2 ((x-Dx(i))^2+(y-Dy(i))^2)]
  !            * exp[-2ln(2)/Theta(j)^2 ((x-Dx(j))^2+(y-Dy(j))^2)]
  !
  ! Expression of ThetB
  !     1/ThetB^2 = 1/2 (1/Theta(i)^2+1/Theta(j)^2)
  !
  ! Expression of FT(A)
  !
  !     FT(u,v) = pi ThetB^2 /(4 ln(2)) exp {-pi^2 ThetB^2 / (4 ln(2)) (u^2+v^2) }
  !       * exp{ -2 ln(2) [(Dx1^2_Dy1^2)/Theta1^2 + (Dx2^2_Dy2^2)/Theta2^2] }
  !       * exp{ ThetB^2 ln(2) [(Dx1/Theta1^2 + Dx2/Theta2^2)^2
  !                           + (Dy1/Theta1^2 + Dy2/Theta2^2)^2 ] }
  !       * exp{ -i pi ThetB^2 [(u Dx1 + v Dy1)/Theta1^2 + (u Dx2 + v Dy2)/Theta2^2 ] }
  !
  !
  ! Simplification in the case of identical antennas
  !
  !     FT(u,v) = pi Thet^2 /(4 ln(2)) exp {-pi^2 Thet^2 / (4 ln(2)) (u^2+v^2) }
  !       * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
  !       * exp{ -i pi [(u Dx1 + v Dy1) + (u Dx2 + v Dy2)] }
  !
  !
  ! Evaluation of disturbed visibility
  !      V(u_0,v_0) = FT(u-u_0,v-v_0,Dx(Iant),Dy(Iant) ** FTSKY(u,v)
  !
  ! Replaced by a simple sum of the nearest neighbours
  !     V(u_0,v_0) = SiSj
  !                FT(ui-u_0,vj-v_0,Dx(Iant),Dy(Iant) * FTSKY(ui,vj)
  !                Weight(ui-u_0,vj-v_0) * Du Dv
  !
  ! Note that this CONVOLUTION in Fourier Plane by a Weight(u,v) function
  ! is equivalent to a MULTIPLICATION in Image Plane by its Fourier Transform.
  !
  ! One could (in theory) correct for this gridding effect later.
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  type(gildas) :: x,y,z
  real :: su,sv,suv,uvr,eps,frequency
  real*8 :: freq
  integer :: nx,ny,mx,my,nw,nv,ntt,na
  integer :: n,nn(2),ndim
  integer :: ier
  complex, allocatable :: ipft(:,:), wfft(:)
  integer, allocatable :: time_visi(:), visi_time(:), order(:)
  real(8), allocatable :: dt(:)
  real, allocatable :: perr(:,:,:)
!  integer(kind=address_length) :: addr,addr2
!  integer(kind=address_length) :: ipft, ipz, ipv
!  integer(kind=address_length) :: ipitt, ipord, ip1, ip2, iperr, ipw
  character(len=256) :: name, image, uvdata, uvmodel, pfile
  logical :: error, mosaic
  real :: sigma(2)
  real :: theta, pixel_area, lambda, factor
  integer :: icode, mtt, ma
  !
  ! Code:
  call gagout('I-UV_POINTING,  Version 1.1 20-Dec-2000')
  call gildas_open
  call gildas_char('UVSAMPLE$',uvdata)
  call gildas_char('IMAGE$',image)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_real('FREQUENCY$',frequency,1)
  call gildas_logi('MOSAIC$',mosaic,1)
  call gildas_inte('CODE$',icode,1)
  call gildas_char('POINTING$',pfile)
  call gildas_real('ERRORS$',sigma,2)
  call gildas_real('PRIMARY$',theta,1)
  call gildas_close
  !
  ! Get the model image
  n = lenc(image)
  if (n.le.0) goto 999
  name = image(1:n)
  call gildas_null(z)
  z%gil%ndim = 2
  call gdf_read_gildas(z, name, '.lmv', error)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot read input image')
    goto 999
  endif
  pixel_area = abs(z%gil%inc(1)*z%gil%inc(2))  ! in radian
  !
  ! Need to oversample in the UV plane, i.e. extend initial image,
  ! to avoid large gridding errors
  !
  nx = z%gil%dim(1)
  ny = z%gil%dim(2)
  mx = 8*nx
  my = 8*ny
  if (mx.gt.5000.or.my.gt.5000) then
    mx = 4*nx
    my = 4*ny
  endif
  !
  allocate (ipft(mx,my), stat=ier)
  call plunge_real (z%r2d,nx,ny,ipft,mx,my)
  !
  ! Original image no longer needed...
  deallocate (z%r2d)
  !
  ! Template UV data set
  n = lenc(uvdata)
  if (n.le.0) goto 999
  name = uvdata(1:n)
  call gildas_null (x, type = 'UVT')
  call gdf_read_gildas (x, name, '.uvt', error, data=.false.)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot read input table')
    goto 999
  endif
  !
  ! Create the model UV table (Y from X)
  call gildas_null (y, type = 'UVT')
  call gdf_copy_header (x,y,error)
  freq = z%gil%freq
  if (frequency.ne.0) then
    freq = frequency*1e3
  endif
  y%gil%freq = freq
  !
  print *,'freq ',y%gil%freq,freq
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  factor = 2*1.38e3/lambda**2*pixel_area
  print *,'Factor ',factor,pixel_area
  if (factor.eq.0.0) factor = 1.0
  !
  n = lenc(uvmodel)
  if (n.le.0) goto 999
  name = uvmodel(1:n)
  call sic_parsef(name,y%file,' ','.uvt')
  call gdf_create_image (y, error)
  if (error) then
    call gagout ('F-UV_POINTING,  Cannot create output UV model')
    goto 999
  endif
  !
  call gdf_allocate(y,error)
  call gdf_read_data (x, y%r2d, error)
  nw = y%gil%dim(1)
  nv = y%gil%dim(2)
  !
  ! Template UV data set no longer needed
  call gdf_close_image(x, error)
  !
  ! Get the number of time samples
  allocate (visi_time(nv), dt(nv), time_visi(nv), stat=ier)
  call do_timelist (   &
     &    y%r2d,   &
     &    nw,nv,   &
     &    visi_time, &   ! Visibility --> Time
     &    dt,   &     ! Date + Time
     &    time_visi,   &     ! Time --> Visi
     &    ntt,na)
  !
  ! Get the index order...
  allocate (order(ntt), stat=ier)
  call gi4_trie(visi_time,order,ntt,error)
  deallocate (dt, time_visi, stat=ier)   !  call free_vm (3*nv,addr)
  !
  ! Pointing errors
  if ((icode.gt.5).or.(icode.lt.1)) then
    call gagout('F-UV_POINTING,  Pointing mode is 1..5')
    goto 999
  endif
  !
  ! Pointing error file: gdf table
  if (mosaic.or.(icode.eq.5)) then
    call gagout('I-UV_POINTING, Reading an external table')
    n = lenc(pfile)
    if (n.le.0) goto 999
    name = pfile(1:n)
    call gildas_null(x)
    call gdf_read_gildas (x, name, '.tab', error)
    if (error) then
      call gagout ('F-UV_POINTING, Cannot read error table')
      goto 999
    endif
    !
    ! Check dimension are ok
    ! We need dim(1) = number of visibilitiy dumps (NTT)
    !         dim(2) = number of antennas (NA)
    !         dim(3) = 2
    ! Table can be larger (the end won't be read)
    if ((x%gil%dim(1).lt.ntt).or.(x%gil%dim(2).lt.na).or.   &
     &      (x%gil%dim(3).ne.2)) then
      call gagout('W-UV_POINTING, Pointing error file too small')
      goto 999
    endif
    mtt = x%gil%dim(1)
    ma = x%gil%dim(2)
  endif
  !
  ! Now compute or read the errors
  sigma(1) = sigma(1)*pi/3600/180
  sigma(2) = sigma(2)*pi/3600/180
  print *,'Sigma ',sigma
  allocate (perr(2,ntt,na), stat=ier)
  call do_pointerr (   &
     &    order,    &   ! Ordering of times
     &    ntt,na,   &
     &    perr,     &   ! Pointing errors
     &    sigma,    &   ! For each direction
     &    mosaic,   &   ! Mosaic mode
     &    x%r3d,    &   ! Pointing error table (icode=5)
     &    mtt,ma,icode,error)
  if (error) call sysexi(fatale)
  !
  ! Free files
  if (mosaic.or.(icode.eq.5)) then
    deallocate (x%r3d, stat=ier)
    call gdf_close_image(x, error)
  endif
  !
  ! Get the model image Fourier Transform
  allocate (wfft(mx+my), stat=ier)
  nn(1) = mx
  nn(2) = my
  ndim = 2
  call fourt(ipft,nn,ndim,1,0,wfft) 
  ! Recenter it
  call recent(mx,my,ipft) 
  !
  su = 1.0/(mx*z%gil%inc(1))
  sv = 1.0/(my*z%gil%inc(2))
  theta = theta*pi/180.0/3600.0    ! In radians
  suv = max(-su,sv)
  eps = 1e-8
  uvr = suv * nint(2.*sqrt(-log(2.)*log(eps))/(pi*theta)/suv)
  print *,'UV cells ',uvr/suv,uvr,suv
  !
  ! Now to the job
  call do_model (   &
     &    y%r2d,    &
     &    nw,nv,    &
     &    visi_time,&
     &    na,ntt,   &
     &    perr,     &
     &    freq,     &
     &    ipft,     &    ! Fourier transform of sky brightness
     &    mx,my,    &
     &    wfft, wfft(mx+1),   &  ! Use for U,V coordinates of grid
     &    su,sv,theta,uvr,factor)
  !
  call gdf_write_data(y, y%r2d, error)
  call gdf_close_image(y, error)
  call sysexi(1)
  !
  999   call sysexi(fatale)
end program uv_pointing
!
!<FF>
subroutine plunge_real (r,nx,ny,c,mx,my)
  !---------------------------------------------------------------------
  !     Plunge a Real array into a larger Complex array
  !---------------------------------------------------------------------
  integer :: nx                     ! Size of input array
  integer :: ny                     ! Size of input array
  real :: r(nx,ny)                  ! Input real array
  integer :: mx                     ! Size of output array
  integer :: my                     ! Size of output array
  real :: c(2,mx,my)                ! Output complex array
  ! Local
  integer :: kx,ky,lx,ly
  integer :: i,j
  !
  kx = nx/2+1
  lx = mx/2+1
  ky = ny/2+1
  ly = my/2+1
  !
  do j=1,my
    do i=1,mx
      c(1,i,j) = 0.0
      c(2,i,j) = 0.0
    enddo
  enddo
  !
  do j=1,ny
    do i=1,nx
      c(1,i-kx+lx,j-ky+ly) = r(i,j)
    enddo
  enddo
end
!<FF>
subroutine do_timelist (visi,nw,nv,itt,dtt,vtt,ntt,na)
  !---------------------------------------------------------------------
  !     Build a list of times from the input visibilities
  !---------------------------------------------------------------------
  integer :: nw                     !
  integer :: nv                     !
  real :: visi(nw,nv)               ! Visibilities
  integer :: itt(nv)                ! Pointer from visibility to time
  real*8 :: dtt(nv)                 ! Date & Time of each time sample
  integer :: vtt(nv)                ! Pointer from time to visibility
  integer :: ntt                    !
  integer :: na                     !
  ! Local
  integer :: iv,jv,it,i,la
  real :: date,time
  logical :: goon
  !
  itt(1) = 1
  vtt(1) = 1
  ntt = 1
  date = visi(4,1)
  time = visi(5,1)
  dtt(ntt) = dble(date)*dble(24*3600)+dble(time)
  print *,'Found new time at visi ',1,dtt(ntt)
  na = max(visi(6,1),visi(7,1))
  !
  do iv=2,nv
    date = visi(4,iv)
    time = visi(5,iv)
    la = max(visi(6,iv),visi(7,iv))
    na = max(na,la)
    it = ntt
    goon = .true.
    do while (goon)
      jv = vtt(it)
      if (date.eq.visi(4,jv).and.   &
     &        time.eq.visi(5,jv)) then
        itt(iv) = it
        goon = .false.
      elseif  (it.eq.1) then
        ntt = ntt+1
        itt(iv) = ntt
        vtt(ntt) = iv
        dtt(ntt) = dble(date)*dble(24*3600)+dble(time)
        print *,'Found new time at visi ',iv,dtt(ntt)
        goon = .false.
      else
        it = it-1
      endif
    enddo
  enddo
  print *,'Found ',na,' different antennas'
  print *,'Found ',ntt,' different times'
  print *,'Times ',(dtt(i),i=1,ntt)
end
!<FF>
subroutine do_pointerr (order,ntt,na,err,sigma,mosaic,   &
     &    poinerr,mtt,ma,icode,error)
  !---------------------------------------------------------------------
  !     Generate the pointing errors
  !     5 Cases
  !     ICODE = 1       No error
  !     ICODE = 2       Fixed error (identical for all antennas)
  !     ICODE = 3       Purely random error
  !     ICODE = 4       Random per antenna, fixed in time
  !     ICODE = 5       Table driven error, gdf table
  !         Table dimension: NTT,NA,2
  !
  !     If MOSAIC is true, then read table (icode=5) and add errors
  !     (icode = 1 to 4)
  !---------------------------------------------------------------------
  integer :: ntt                    !
  integer :: order(ntt)             !
  integer :: na                     !
  real :: err(2,na,ntt)             !
  real :: sigma(2)                  !
  logical :: mosaic                 !
  integer :: mtt                    !
  integer :: ma                     !
  real :: poinerr(mtt,ma,2)         !
  integer :: icode                  !
  logical :: error                  !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real :: rangau
  real*8 :: sec
  integer :: ia,it,jt,kt
  !
  error = .false.
  !
  ! No error
  do it=1,ntt
    do ia=1,na
      err(1,ia,it) = 0.0
      err(2,ia,it) = 0.0
    enddo
  enddo
  ! Purely fixed
  if (icode.eq.2) then
    do it=1,ntt
      do ia=1,na
        err(1,ia,it) = sigma(1)
        err(2,ia,it) = sigma(2)
      enddo
    enddo
    ! Purely random
  elseif (icode.eq.3) then
    do it=1,ntt
      do ia=1,na
        err(1,ia,it) = rangau(sigma(1))
        err(2,ia,it) = rangau(sigma(2))
      enddo
    enddo
    ! Random for each antenna, but fixed in time
  elseif (icode.eq.4) then
    do ia=1,na
      err(1,ia,1) = rangau(sigma(1))
      err(2,ia,1) = rangau(sigma(2))
    enddo
    do it=2,ntt
      do ia=1,na
        err(1,ia,it) = err(1,ia,1)
        err(2,ia,it) = err(2,ia,1)
      enddo
    enddo
  endif
  !
  ! For a Mosaic add the Mosaic centers, from the external file
  if (mosaic.or.(icode.eq.5)) then
    ! External description: gdf file
    sec = pi/3600./180.
    do it=1,ntt
      jt = order(it)
      do ia=1,na
        err(1,ia,jt) = err(1,ia,jt)+poinerr(it,ia,1)*sec
        err(2,ia,jt) = err(2,ia,jt)+poinerr(it,ia,2)*sec
      enddo
    enddo
  endif
end
!<FF>
subroutine do_model (visi,nw,nv,itt,na,nt,err,freq,   &
     &    ftsky,mx,my,uval,vval,su,sv,thet,uvr,factor)
  integer :: nw                     !
  integer :: nv                     !
  real :: visi(nw,nv)               ! Visibilities
  integer :: itt(nv)                ! Pointer to times
  integer :: na                     ! Number of antennas
  integer :: nt                     ! Number of different times
  real :: err(2,na,nt)              ! Pointing error for each antenna / time
  real*8 :: freq                    ! Observing frequency
  integer :: mx                     !
  integer :: my                     !
  complex :: ftsky(mx,my)           ! Fourier Transform
  real :: uval(mx)                  ! u,v Values
  real :: vval(my)                  ! u,v Values
  real :: su                        ! Step of Fourier Transform
  real :: sv                        ! Step of Fourier Transform
  real :: thet                      ! Beam size (in radian)
  real :: uvr                       ! UV radius for convolution
  real :: factor                    ! Input map scaling factor
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: u,v,lambda,uu,vv
  real*8 :: us,vs
  real*8 :: dxi,dyi,dxj,dyj
  real*8 :: pithet,uvthet,lnthet
  complex*16 :: avis,tvis,cmp
  complex*8 :: svis
  real*8 :: arg,carg,sarg
  integer :: ia,ja,it
  integer :: lx,ly,ilo,iup,jlo,jup
  integer :: i,iv,ii,jj
  !
  lambda = 299792.458d3/(freq*1d6)
  pithet = pi**2*thet**2/(4.0*log(2.))
  uvthet = -pithet/pi*su*sv * factor
  lnthet = log(2d0)/thet**2
  lx = mx/2+1
  ly = my/2+1
  us = 1.0/su
  vs = 1.0/sv
  do i=1,mx
    uval(i) = (i-lx)*su
  enddo
  do i=1,my
    vval(i) = (i-ly)*sv
  enddo
  !
  do iv = 1,nv
    u = visi(1,iv)/lambda
    v = visi(2,iv)/lambda
    ia = visi(6,iv)
    ja = visi(7,iv)
    it = itt(iv)
    dxi = err(1,ia,it)
    dyi = err(2,ia,it)
    dxj = err(1,ja,it)
    dyj = err(2,ja,it)
    !
    !     FT(u,v) = pi Thet^2 /(4 ln(2)) exp {-pi^2 Thet^2 / (4 ln(2)) (u^2+v^2) }
    !       * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
    !       * exp{ -i pi [(u Dx1 + v Dy1) + (u Dx2 + v Dy2)] }
    !
    !  FT(u,v) = pi Thet^2 /(4 ln(2))                       ! Scale
    !  * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2 + (Dy1-Dy2)^2] } ! Cross-pointing error
    !  * exp {-pi^2 Thet^2 / (4 ln(2)) u^2}                 ! U attenuation term
    !  * exp { -i pi [u Dx1) + u Dx2] }                     ! U phase term
    !  * exp {-pi^2 Thet^2 / (4 ln(2)) v^2 }                ! V attenuation term
    !  * exp{ -i pi [v Dy1 + v Dy2] }                       ! V phase term
    !
    ilo = nint((u+uvr)*us) + lx
    iup = nint((u-uvr)*us) + lx
    jlo = nint((v-uvr)*vs) + ly
    jup = nint((v+uvr)*vs) + ly
    ilo = max(1,ilo)
    iup = min(mx,iup)
    jlo = max(1,jlo)
    jup = min(my,jup)
    !
    avis = (0.,0.)
    do jj = jlo,jup
      tvis = (0.,0.)
      do ii = ilo,iup
        uu = uval(ii) - u
        arg = -pi*uu*(dxi+dxj)
        carg = cos(arg)
        sarg = sin(arg)
        cmp = cmplx(carg,sarg)
        arg = exp(-pithet*uu**2)
        tvis = tvis+cmp*ftsky(ii,jj)*arg
      enddo
      vv = vval(jj) - v
      arg = -pi*vv*(dyi+dyj)
      carg = cos(arg)
      sarg = sin(arg)
      cmp = cmplx(carg,sarg)
      arg = exp(-pithet*vv**2)
      avis = avis+cmp*tvis*arg
    enddo
    !
    ! FT(u,v) = pi Thet^2 /(4 ln(2))
    !   * exp{ -ln(2) / Thet^2 [(Dx1-Dx2)^2^ + (Dy1-Dy2)^2] }
    !   * su * sv
    !
    arg = uvthet*exp(-lnthet*((dxi-dxj)**2+(dyi-dyj)**2))
    avis = avis*arg
    !
    ! Done
    svis = avis
    visi(8,iv) =  real(svis)
    visi(9,iv) = aimag(svis)
  enddo
end
!<FF>
subroutine recent(nx,ny,z)
  !---------------------------------------------------------------------
  ! Recenters the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: z(nx,ny)               !
  ! Local
  integer :: i, j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i+nx/2,j+ny/2)
      z(i+nx/2,j+ny/2) = z(i,j)
      z(i,j) = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i,j+ny/2)
      z(i,j+ny/2) = z(i+nx/2,j)
      z(i+nx/2,j) = tmp
    enddo
  enddo
  !
  do i=1,nx
    do j =1,ny
      if (mod(i+j,2).ne.0) then
        z(i,j) = -z(i,j)
      endif
    enddo
  enddo
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! R. Lucas 2009-02-04
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
program grav_def
  use gildas_def
  use gkernel_interfaces
  include 'gbl_pi.inc'
  include 'clic_panels.inc'
  integer :: np, numPol, i, k, ii, jj, j, lenc, ier, l, ir, ip, iscr, is, &
       ix, iy, iz, lpar, lc, icol, next, idr, idz, np0, ielev, idn
  !integer, allocatable :: mPol(:), nPol(:)
  real, allocatable :: x(:), y(:), z(:), dz(:), dr(:), dp(:), dn(:,:), w(:), &
       pars(:), tp(:), dnn(:)
  integer, allocatable :: iring(:), ipanel(:), iscrew(:)
  real :: xx, yy, rr, aa, ff, sigmaz, sigmay, dydz, h0, h1, h2, &
       sigma1, sigma2, phi, &
       bz, by, dh, dmin, d, h, r, t, value, se, se2, sw, t2, sig(2)
  real :: cols(20)
  integer, parameter :: npar=6 
  character :: infile(2)*256, outfile*256, a*256, antennaType*256, par*20

  real :: taper, radius, sigma, elevation(2)
  logical :: def(mring, mpan, mm)
  !
  elevation(1) = 0.
  elevation(2) = 90.
  taper = 12.
  call gildas_open
  call gildas_char('INFILE_0$',infile(1))
  call gildas_char('INFILE_90$',infile(2))
  call gildas_char('ANTENNA_TYPE$',antennaType)
  call gildas_char('OUTFILE$',outfile)
  call gildas_close
  !
  ix = 2
  iy = 3
  idr = 4
  idz = 5
  idn = 6
  if (antennaType(1:13).eq.'MITSUBISHI_12') then
    call set_panels(type_melco12m)
  elseif (antennaType(1:9).eq.'VERTEX_12') then
    call set_panels(type_vx12m)
  endif
  !
  do ielev = 1, 2
    open (1, file=infile(ielev)(1:lenc(infile(ielev))))
    np = 0
    def = .false.
    do while (.true.)
      read (1,*, end=10) a
      if (a(1:1).ne.'!') np = np+1
    enddo
10  if (np.le.0) then
      call gagout('E-Grav_def,  No input data. ')
      goto 999
    endif
    print *, 'number of points : ',np
    if (ielev.eq.2) then
      if (np0.ne.np) then
        call gagout('E-Grav_def,  Wrong number of data points. ')
        goto 999
      endif
    else
      np0 = np
      allocate(x(np), y(np), z(np), w(np), dr(np), dz(np), dp(np), dn(np,2), &
           pars(npar), iring(np), ipanel(np), iscrew(np), tp(np), dnn(np), stat = ier)
      if (ier.ne.0) then
        call gagout('E-Grav_def,  Allocation error. ')
        goto 999
      endif
    endif
        

    rewind(1)
    k = 0
    sw = 0
    do while (.true.)
      read (1,'(a)', end=20) a
      if (a(1:1).ne.'!' .and. a(1:1).ne.'"') then
        k = k+1
        lc = lenc(a)
        call sic_blanc(a,lc)
        next = 1
        icol = 0
        !!print*, lc, a(1:lc)
        do while (next.le.lc)
          call sic_next(a(next:), par, lpar, next)
          if (lpar.gt.0) then
            read (par(1:lpar), *, iostat = ier) value
            !!print *, lar, par(1:lpar), next, value
            icol = icol+1
            ! clic works with y up, x to the right as seen from the back.
            ! the alma coord sys has y down.
            ! 
            if (icol.eq.ix) then
              x(k) = value
            elseif (icol.eq.iy) then
              y(k) = -value
            elseif (icol.eq.idz) then
              dz(k) = value/1e6
            elseif (icol.eq.idr) then
              dr(k) = value/1e6
            elseif (icol.eq.idn) then
              dnn(k) = value/1e6
            endif
          endif
        enddo
        if (ier.ne.0) then
          call gagout('E-Grav_def, Error reading data: ')
          call gagout(a)
          goto 999
        endif
        call xypanel(x(k),y(k),ir,ip,xx,yy)
        dmin = 1e10
        iscr = 0
        do is = 1, nscr(ir)
          ! x,y are local panel-centered coordinates
          d = sqrt((xscr(is,ir)-xx)**2+(yscr(is,ir)-yy)**2)
          if (d.lt.dmin) then
            dmin = d
            iscr = is
          endif
        enddo
        ! weight (area only)
        w(k) = pi*(ray(ir)+ray(ir-1))/nscr(ir)/npan(ir)/(ray(ir)-ray(ir-1))
        r = sqrt(x(k)**2+y(k)**2)
        t = r/2/focus
        ! normal deformation
        !dn = (dz(k) - t*dr(k)) / sqrt(1+t**2)
        ! correct for increasing path on the edges: 
        ! 1/2 path is dn*cos (alpha)
        !dp(k) = dn /  sqrt(1+t**2)
        ! result: 
        dp(k) = (dz(k) - t*dr(k)) / (1+t**2)
        radius = diameter/2
        
        ! weight (tapered)
        tp(k) = 1.-(1.-10**(-0.05*taper))*(r/radius)**2
        w(k) = w(k)*tp(k)
        w(k) = 1
        sw = sw + w(k)

        if (dmin.gt.0.01) then
          print 1000, '** ',x(k), y(k), xx, yy, xscr(iscr,ir), yscr(iscr,ir), dmin, ir, ip, iscr
1000      format(a, 7f10.4, 3i6)
        endif
        iring(k) = ir
        ipanel(k) = ip
        iscrew(k) = iscr
        def (ir, ip, iscr) = .true.
      endif
    enddo
    !
20  close(1)
    ! check
    do ir = 1, nring
      !print *, ir, npan(ir), nscr(ir)
      do ip = 1, npan(ir)
        do is = 1, nscr(ir)
          !print *, ir, is, ip, def(ir,ip,is)
          if (.not.def(ir,ip,is)) then
            print *, '** data missing for ring ', ir, ' panel ', ip, ' screw ', is
          endif
        enddo
      enddo
    enddo
    ! normalize weights
    do i=1, np
      w(i) = w(i) / sw
    enddo
    ! fit a parabola
    ! dp = 1. + 2.*x + 3 * y + 4. * (x**2+y**2)/6*2. + 5*(x**3*y)/6**4 + 6*(x*y**3)/6**4 ! test
    !print *, (dp(i), i=1, 20)
    !print *, (w(i), i=1, 20)

    call fit_grav(np, dp, w, x, y, focus, radius, npar, pars, sigma)
    !print *, (dp(i), i=1, 20)
    ! sigma is the raw rms. ...
    do i=4,6
      pars(i) = pars(i)*1e3
    enddo
    sig(ielev) = sigma*1e6
    
    ! save the normal deformation
    do i=1, np
      r = sqrt(x(i)**2+y(i)**2)
      t = r/2/focus
      dn(i, ielev) = dp(i) *  sqrt(1+t**2)
    enddo
    !print *,  sqrt(se2-se**2)/sw, sqrt(se2/sw-(se/sw)**2)*1e6
    !print *, pars
    print *, 'elevation, sigma, X, Y, Z'
    print 1001, elevation(ielev), sig(ielev), (pars(i), i=4, npar) 
1001 format (1x, f6.2, f6.2, 3(1x, f10.3))
  enddo
  ! 
  ! compute normal residuals: 
  ! output file format is number, X, Y, dN90, dn0 ...
  open (2, file=outfile(1:lenc(outfile)), status='unknown')
  write (2,2001) "! Antenna ", antennaType(1:10), " Elevations 0 and 90 "
2001 format(1x,a,a,a)
  write (2,*) "! ring, panel, screw, x(m), y(m), deformations(mum) "
  do i=1, np
!    write(2,2000) iring(i), ipanel(i), iscrew(i), x(i), y(i), &
!         dn(i,1)*1e6, dn(i,2)*1e6, w(i), tp(i), dnn(i)*1e6, dr(i), dz(i)
!2000 format(1x, 3i4, f10.6, f10.6, 2f10.1, 2f10.6, 3f13.6) 
    write(2,2000) iring(i), ipanel(i), iscrew(i), x(i), y(i), &
         dn(i,1)*1e6, dn(i,2)*1e6
2000 format(1x, 3i4, f10.6, f10.6, 2f10.1) 
  enddo
  close(2)
  ! compute best rigging angle
  ! where sig(2)^2*(sin(90)-sin(h))^2 + sig(1)^2*(cos(90)-sin(h))^2
  ! == sig(2)^2*(sin(0)-sin(h))^2 + sig(1)^2*(cos(0)-sin(h))^2
  print *, sig
  phi = atan((sig(2)/sig(1))**2)
  
  h0 = acos((cos(phi)-sin(phi))/2)-phi
  print *, 'Best rigging angle h0: ', h0*180./pi, ' degrees.'
  print *, 'Max. rms with h0 setting: ',&
       sqrt(sig(2)**2*(sin(h0))**2+sig(1)**2*(1-cos(h0))**2)
  h1 = 20.*pi/180.
  h2 = 90.*pi/180.
  print *, 'Max. rms with [20.,90.] setting: ', &
       sqrt(sig(2)**2*((sin(h1)-sin(h2))/2)**2 + &
       sig(1)**2*((cos(h1)-cos(h2))/2)**2) 
  !
  call gagout('F-Grav_def: Done.') 
  !
  !
  stop
  !
999 call gagout('F-Grav_def:  Failed.')

  !
end program grav_def
!------------------------------------------------------------------------- 
subroutine fit_grav(np, dp, w, x, y, focus, radius, npar, par,  sigma)
  use gildas_def
  integer :: np, npar 
  real focus, sigma, par(npar), radius
  real dp(np), w(np), x(np), y(np)
  real*8, allocatable :: a(:,:), b(:)               !
  real*8 :: sig, x2, y2, r2, sw, sp, sp2, t2
  integer k, i, nd, j, l
  ! Global
  include 'gbl_pi.inc'
  ! Local
  !
  !
  k = 0
  allocate (a(np,npar), b(np))
  do i=1, np 
    if (w(i).gt.0) then
      k = k+1
      x2 = x(i)*x(i)
      y2 = y(i)*y(i)
      r2 = x2+y2
      a(k,1) = 1.d0
      a(k,2) = x(i)/radius
      a(k,3) = y(i)/radius
!      a(k,4) = 1-(1-r2/4/focus**2)/sqrt(r2/focus**2+(1.-r2/4/focus**2)**2)
!      a(k,5) = x(i)/focus*(1.-1./sqrt(r2/focus**2+(1.-r2/4/focus**2)**2))
!      a(k,6) = y(i)/focus*(1.-1./sqrt(r2/focus**2+(1.-r2/4/focus**2)**2))
      t2 = r2/4/focus**2
      a(k,4) = 2*t2/(1+t2)
      a(k,5) = x(i)/focus*t2/(1+t2)
      a(k,6) = y(i)/focus*t2/(1+t2)
      b(k) = dp(i)
      !do j=1, npar
      !  a(k,j) = a(k,j)*w(i)
      !enddo
      !b(k) = dp(i)*w(i)
        
      !print 1000, k, (a(k,j),j=1,npar)
!1000  format (i3, 6(1pg11.3))
    endif
  enddo
  nd = k
  !
  ! Solve linear system
  call mth_fitlin ('fit_grav',nd,npar,a,b,np,sig)
  do l=1, npar
    par(l) = b(l)
  enddo
  sigma = sig
  ! return the residuals 
  k = 0
  sw = 0
  sp = 0
  sp2 = 0
  do i=1, np 
    if (w(i).gt.0) then
      k = k+1
      x2 = x(i)*x(i)
      y2 = y(i)*y(i)
      r2 = x2+y2
      a(k,1) = 1.d0
      a(k,2) = x(i)/radius
      a(k,3) = y(i)/radius
      !a(k,4) = 1-(1-r2/4/focus**2)/sqrt(r2/focus**2+(1.-r2/4/focus**2)**2)
      !a(k,5) = x(i)/focus*(1.-1./sqrt(r2/focus**2+(1.-r2/4/focus**2)**2))
      !a(k,6) = y(i)/focus*(1.-1./sqrt(r2/focus**2+(1.-r2/4/focus**2)**2))
      t2 = r2/4/focus**2
      a(k,4) = 2*t2/(1+t2)
      a(k,5) = x(i)/focus*t2/(1+t2)
      a(k,6) = y(i)/focus*t2/(1+t2)
      do l=1, 6
        dp(i) = dp(i)-a(k,l)*par(l) 
      enddo
      ! test rms of dn
      sw = sw + w(i)
      sp = sp + w(i)*dp(i)
      sp2 = sp2 + w(i)*dp(i)**2
    endif
  enddo
  sp = sp / sw
  sp2 = sp2 /sw
  sig = sqrt(sp2-sp**2)
  
  !print *, 'sw, sp, sp2, sqrt(sp2-sp**2), sig'
  !print *, sw, sp, sp2, sqrt(sp2-sp**2), sig
  
end subroutine fit_grav

subroutine compress(nx,ny,large,wl,mx,my,small,ws,wfft)
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  !	@ public
  ! 
  ! MAPPING
  !   Compress an image through FT truncation
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny,mx,my
  real, intent(in) :: large(nx,ny)
  complex, intent(inout) :: wl(nx,ny)
  real, intent(out) :: small(mx,my)
  complex, intent(inout) :: ws(mx,my)
  real, intent(inout) :: wfft(*)
  !
  integer :: j,ndim,dim(2)
  real fact
  !
  wl(:,:) = cmplx(large,0.0)
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(wl,dim,ndim,-1,0,wfft)
  !
  ! Keep inner quarter
  do j=1,my/2
    ws(1:mx/2,j) = wl(1:mx/2,j)   
    ws(mx/2+1:mx,j) = wl(nx-mx/2+1:nx,j) 
  enddo
  do j=my/2+1,my
    ws(1:mx/2,j) = wl(1:mx/2,j+ny-my) 
    ws(mx/2+1:mx,j) = wl(nx-mx/2+1:nx,j+ny-my) 
  enddo
  dim(1) = mx
  dim(2) = my
  call fourt (ws,dim,ndim,1,1,wfft)
  fact = 1.0/(nx*ny)
  small(:,:) = fact*real(ws)
end subroutine compress

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_copy
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubesyntax_key_types
  use cubeadm_ancillary_cube_types
  use cubeedit_messaging
  !
  public :: copy
  private
  !
  type :: copy_comm_t
     type(option_t), pointer :: comm
     type(key_comm_t) :: all
     type(key_comm_t) :: head
     type(key_comm_t) :: data
     type(ancillary_cube_comm_t) :: from
   contains
     procedure, public  :: register => cubeedit_copy_comm_register
     procedure, private :: parse    => cubeedit_copy_comm_parse
     procedure, private :: main     => cubeedit_copy_comm_main
  end type copy_comm_t
  type(copy_comm_t) :: copy  
  !
  type copy_user_t
     character(len=argu_l)  :: id
     type(key_user_t) :: all
     type(key_user_t) :: head
     type(key_user_t) :: data
     type(ancillary_cube_user_t) :: from
   contains
     procedure, private :: toprog => cubeedit_copy_user_toprog
  end type copy_user_t
  !
  type copy_prog_t
     type(cube_t), pointer :: edited
     type(key_prog_t) :: all
     type(key_prog_t) :: head
     type(key_prog_t) :: data
     type(ancillary_cube_prog_t) :: from
   contains
     procedure, private :: header => cubeedit_copy_prog_header
  end type copy_prog_t
  !
contains
  !
  subroutine cubeedit_copy_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(copy_user_t) :: user
    character(len=*), parameter :: rname='COPY>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call copy%parse(line,user,error)
    if (error) return
    call copy%main(user,error)
    if (error) continue
  end subroutine cubeedit_copy_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(inout) :: comm
    logical,            intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='COPY>COMM>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'COPY','[bufferid]',&
         'Copy part of a cube header or data',&
         'Copy selected parts of a reference cube into an opened edited buffer.&
         & COPY is additive: nothing is copied unless at least one copy&
         & key is enabled.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- COPY resolves the edited buffer from bufferid (or the current&
         & edited buffer identifier) and uses /FROM INPUT as reference&
         & source.'//strg_cr//&
         '- COPY applies requested transfers to the edited buffer.&
         & The edited buffer is registered in the DAG only after CLOSE.'&
         //strg_cr//&
         '- Current implementation transfers header metadata only.&
         & Data-value transfer is not implemented yet.'//strg_bl//&
         'Notes:'//strg_cr//&
         '- If no copy key is enabled, COPY performs no transfer.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /ALL'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /HEADER'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /DATA'//strg_bl//&
         'Typical workflow:'//strg_cr//&
         'CUBE> OPEN myedit /LIKE ref_cube'//strg_cr//&
         'CUBE> COPY myedit /FROM ref_cube /HEADER'//strg_cr//&
         'CUBE> CLOSE myedit'//strg_bl//&
         'The edited buffer is registered in the DAG only after CLOSE.',&
         cubeedit_copy_command,&
         comm%comm,&
         error)
    if (error) return
    call stdarg%register(&
         'BUFFERID',&
         'Edited buffer identifier',&
         strg_emp,&
         code_arg_optional,&
         error)
    if (error) return    
    ! Action
    call comm%all%register(&
         'ALL',&
         'Request header and data copy',&
         'Enable both /HEADER and /DATA copy requests in one command.&
         & With current implementation, this yields header copy only&
         & because data-value transfer is not implemented.',&
         error)
    if (error) return
    call comm%head%register(&
         'HEADER',&
         'Request header copy',&
         'Copy header metadata from the /FROM reference cube into the&
         & opened edited buffer.',&
         error)
    if (error) return
    call comm%data%register(&
         'DATA',&
         'Request data copy',&
         'Request data-value copy from the /FROM reference cube. The key&
         & is accepted but current implementation does not transfer data&
         & values.',&
         error)
    if (error) return
    ! Input cube
    call comm%from%fully_register(&
         'FROM','[referenceid]',&
         'Select the reference cube to copy from',&
         strg_emp,&
         'INPUT',&
         'Reference cube id used as COPY source',&
         [flag_any],&
         code_arg_mandatory,&
         code_read,&
         code_access_any,& !***JP: For data it's not so simple!
         error)
    if (error) return
  end subroutine cubeedit_copy_comm_register
  !
  subroutine cubeedit_copy_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! COPY /HEADER /DATA
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(in)    :: comm
    character(len=*),   intent(in)    :: line
    type(copy_user_t),  intent(out)   :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='COPY>COMM>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    user%id = strg_star
    call cubetools_getarg(line,comm%comm,1,user%id,.not.mandatory,error)
    if (error) return
    !
    call comm%all%parse(line,user%all,error)
    if (error) return
    call comm%head%parse(line,user%head,error)
    if (error) return
    call comm%data%parse(line,user%data,error)
    if (error) return
    call comm%from%parse(line,user%from,error)
    if (error) return
  end subroutine cubeedit_copy_comm_parse
  !
  subroutine cubeedit_copy_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_comm_t), intent(in)    :: comm
    type(copy_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    type(copy_prog_t) :: prog
    character(len=*), parameter :: rname='COPY>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
  end subroutine cubeedit_copy_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_user_toprog(user,comm,prog,error)
    use cubeedit_opened_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(copy_user_t), intent(in)    :: user
    type(copy_comm_t),  intent(in)    :: comm
    type(copy_prog_t),  intent(out)   :: prog
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='COPY>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call opened%get_cube_pointer(user%id,prog%edited,error)
    if (error) return
    !
    call user%from%toprog(comm%from,prog%from,error)
    if (error) return
    call user%all%toprog(comm%all,prog%all,error)
    if (error) return
    call user%head%toprog(comm%head,prog%head,error)
    if (error) return
    call user%data%toprog(comm%data,prog%data,error)
    if (error) return
    ! Analyse user input
    if (prog%all%act) then
       prog%head%act = .true.
       prog%data%act = .true.
    endif
    ! User feedback about the interpretation of his command line
    if (prog%head%act) call cubeedit_message(seve%r,rname,'Copying header')
    if (prog%data%act) call cubeedit_message(seve%r,rname,'Copying data')
  end subroutine cubeedit_copy_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_copy_prog_header(prog,comm,error)
    use cubetools_header_types
    use cubetools_header_interface
    use cubetools_observatory_types
    !----------------------------------------------------------------------
    ! The array section of the header is only copied when the data is
    ! copied!
    !----------------------------------------------------------------------
    class(copy_prog_t), intent(inout) :: prog
    type(copy_comm_t),  intent(in)    :: comm
    logical,            intent(inout) :: error
    !
    type(cube_header_interface_t) :: inhead,ouhead
    character(len=*), parameter :: rname='COPY>PROG>HEADER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (prog%head%act) then
       call cubetools_header_export(prog%from%cube%head,inhead,error)
       if (error) return
       call cubetools_header_export(prog%edited%head,ouhead,error)
       if (error) return
       call inhead%axset_copyto(ouhead,error)
       if (error) return
       call inhead%spatial_copyto(ouhead,error)
       if (error) return
       call inhead%spectral_copyto(ouhead,error)
       if (error) return
       call cubetools_observatory_copy(inhead%obs,ouhead%obs,error)
       if (error) return
       call cubetools_header_import_and_derive(ouhead,prog%edited%head,error)
       if (error) return
    endif
  end subroutine cubeedit_copy_prog_header
end module cubeedit_copy
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_interfaces_private
  interface
    subroutine cube_functions(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Define cube-building functions
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine cube_functions
  end interface
  !
  interface
    function s_tdv(v1,v2)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_tdv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function s_tdv
  end interface
  !
  interface
    function d_tdv(v1,v2)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_tdv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function d_tdv
  end interface
  !
  interface
    function s_tpeakv(v1,v2)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_tpeakv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function s_tpeakv
  end interface
  !
  interface
    function d_tpeakv(v1,v2)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_tpeakv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function d_tpeakv
  end interface
  !
  interface
    function s_vpeakv(v1,v2)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_vpeakv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function s_vpeakv
  end interface
  !
  interface
    function d_vpeakv(v1,v2)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_vpeakv  !
      real(kind=8), intent(in) :: v1,v2  !
    end function d_vpeakv
  end interface
  !
  interface
    function s_stdv(dummy)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_stdv  !
      real(kind=8), intent(in) :: dummy  !
    end function s_stdv
  end interface
  !
  interface
    function d_stdv(dummy)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_stdv  !
      real(kind=8), intent(in) :: dummy  !
    end function d_stdv
  end interface
  !
  interface
    function s_tpeak(dummy)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_tpeak  !
      real(kind=8), intent(in) :: dummy  !
    end function s_tpeak
  end interface
  !
  interface
    function d_tpeak(dummy)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_tpeak  !
      real(kind=8), intent(in) :: dummy  !
    end function d_tpeak
  end interface
  !
  interface
    function s_vpeak(dummy)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !---------------------------------------------------------------------
      real(kind=4) :: s_vpeak  !
      real(kind=8), intent(in) :: dummy  !
    end function s_vpeak
  end interface
  !
  interface
    function d_vpeak(dummy)
      use class_rt
      !-------------------------------------------------------------------
      ! @ private
      ! CLASS internal routine
      !-------------------------------------------------------------------
      real(kind=8) :: d_vpeak  !
      real(kind=8), intent(in) :: dummy  !
    end function d_vpeak
  end interface
  !
  interface
    subroutine class_greg(set,line,r,error,user_function)
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS Support routine for command
      !    GREG Name
      ! 1   [/FORMATTED [Format]]
      ! 2   [/READ [X n] [Y m]]
      !---------------------------------------------------------------------
      type(class_setup_t), intent(inout) :: set            !
      character(len=*),    intent(in)    :: line           ! Input command line
      type(observation),   intent(inout) :: r              !
      logical,             intent(inout) :: error          ! Logical flag
      logical,             external      :: user_function  !
    end subroutine class_greg
  end interface
  !
  interface
    subroutine class_greg_write(set,line,r,fnc,nfit,fit_sec,error)
      use gildas_def
      use gbl_message
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      ! Writes a table or a formatted file
      !---------------------------------------------------------------------
      type(class_setup_t), intent(in)    :: set      !
      character(len=*),    intent(in)    :: line     ! Input command line
      type(observation),   intent(in)    :: r        !
      real(kind=4),        external      :: fnc      ! Fitting function
      integer(kind=4),     intent(in)    :: nfit     ! Number of lines fitted
      integer(kind=4),     intent(in)    :: fit_sec  ! Fit section (eg class_sec_gau_id)
      logical,             intent(inout) :: error    ! Logical flag
    end subroutine class_greg_write
  end interface
  !
  interface
    subroutine class_greg_write_gdf(r,chain,fnc,nfit,error)
      use gbl_message
      use image_def
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(observation), intent(in)    :: r      !
      character(len=*),  intent(in)    :: chain  ! File name
      real(kind=4),      external      :: fnc    ! Fitting function
      integer(kind=4),   intent(in)    :: nfit   ! Number of lines fitted
      logical,           intent(inout) :: error  ! Logical error flag
    end subroutine class_greg_write_gdf
  end interface
  !
  interface
    subroutine class_greg_write_formatted(set,r,chain,fnc,nfit,fit_sec,informa,error)
      use gildas_def
      use gbl_message
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(class_setup_t), intent(in)    :: set      !
      type(observation),   intent(in)    :: r        !
      character(len=*),    intent(in)    :: chain    ! File name
      real(kind=4),        external      :: fnc      ! Fitting function
      integer(kind=4),     intent(in)    :: nfit     ! Number of lines fitted
      integer(kind=4),     intent(in)    :: fit_sec  ! Fit section (eg class_sec_gau_id)
      character(len=*),    intent(in)    :: informa  ! Input format ('' = auto)
      logical,             intent(inout) :: error    ! Logical error flag
    end subroutine class_greg_write_formatted
  end interface
  !
  interface
    subroutine sgildas(obs,x,nlines,ncols,fnc)
      use gildas_def
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      !  Fills a table at the GILDAS format from the current scan and its
      ! fit results.
      !---------------------------------------------------------------------
      type(observation), intent(in)  :: obs              ! Input spectrum
      integer(kind=4),   intent(in)  :: nlines           ! Number of lines in table
      integer(kind=4),   intent(in)  :: ncols            ! Number of columns in table
      real(kind=4),      intent(out) :: x(nlines,ncols)  ! Table to be filled
      real(kind=4), external         :: fnc              ! Fitting function
    end subroutine sgildas
  end interface
  !
  interface
    subroutine class_greg_read_formatted(set,line,r,error,user_function)
      use gildas_def
      use gbl_constant
      use phys_const
      use gbl_message
      use class_types
      !---------------------------------------------------------------------
      ! @ private
      ! CLASS Internal routine
      ! Read a formatted file
      !---------------------------------------------------------------------
      type(class_setup_t), intent(inout) :: set            !
      character(len=*),    intent(in)    :: line           ! Input command line
      type(observation),   intent(inout) :: r              !
      logical,             intent(inout) :: error          ! Logical flag
      logical,             external      :: user_function  !
    end subroutine class_greg_read_formatted
  end interface
  !
  interface
    subroutine allocate_class(error)
      !---------------------------------------------------------------------
      ! @ private
      ! Allocate all Class buffers
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine allocate_class
  end interface
  !
  interface
    subroutine allocate_RT(error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! Allocate R and T buffers
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine allocate_RT
  end interface
  !
  interface
    subroutine deallocate_class(error)
      !---------------------------------------------------------------------
      ! @ private
      ! Deallocate all Class buffers
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine deallocate_class
  end interface
  !
  interface
    subroutine deallocate_RT(error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      ! Deallocate R and T buffers
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine deallocate_RT
  end interface
  !
  interface
    subroutine class_exit(error)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine class_exit
  end interface
  !
  interface
    subroutine class_pack_init(gpack_id,error)
      use gbl_message
      use sic_def
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ private-mandatory
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: gpack_id
      logical,         intent(inout) :: error
    end subroutine class_pack_init
  end interface
  !
  interface
    subroutine class_pack_clean(error)
      !---------------------------------------------------------------------
      ! @ private-mandatory
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine class_pack_clean
  end interface
  !
  interface
    subroutine pyclass_rx_val(ival,iunitin,oval,ounitin,error)
      use gbl_message
      use class_rt
      !---------------------------------------------------------------------
      ! @ private
      !
      ! ---
      ! Entry point which can be called from Python. In particular the
      ! 'observation' is shared through a module.
      !---------------------------------------------------------------------
      real(kind=8),     intent(in)  :: ival     ! Input value
      character(len=*), intent(in)  :: iunitin  ! Input unit
      real(kind=8),     intent(out) :: oval     ! Output value
      character(len=*), intent(in)  :: ounitin  ! Output unit
      logical,          intent(out) :: error    ! Logical error flag
    end subroutine pyclass_rx_val
  end interface
  !
  interface
    subroutine pyclass_rx_minmax(unitin,mini,maxi,error)
      use gbl_message
      use class_rt
      use class_setup
      !---------------------------------------------------------------------
      ! @ private
      !
      ! ---
      ! Entry point which can be called from Python. In particular the
      ! 'observation' is shared through a module.
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
      real(kind=8),     intent(out) :: mini    !
      real(kind=8),     intent(out) :: maxi    !
      logical,          intent(out) :: error   ! Logical error flag
    end subroutine pyclass_rx_minmax
  end interface
  !
  interface
    subroutine pyclass_px_minmax(unitin,mini,maxi,error)
      use class_setup
      !---------------------------------------------------------------------
      ! @ private
      ! Return the X range of the plot
      ! NB: the subroutine returns actually the SET MODE X range, not
      ! the effective PLOT range (they are the same AFTER the command PLOT).
      ! But the command ANA\DRAW has the same bug-feature, and since the
      ! cursor is used by Weeds to identify lines, we are consistent...
      ! ---
      ! Entry point which can be called from Python. In particular the
      ! 'class_setup_t' is shared through a module.
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: unitin  ! Unit for returning values. Blank means current unit
      real(kind=8),     intent(out) :: mini    !
      real(kind=8),     intent(out) :: maxi    !
      logical,          intent(out) :: error   ! Logical error flag
    end subroutine pyclass_px_minmax
  end interface
  !
  interface
    subroutine class_languages(user_function)
      !---------------------------------------------------------------------
      ! @ private
      ! LAS initialization routine
      ! SIC is loaded with LAS and ANALYSE languages, plot library is
      ! initialized, and SIC variables are defined.
      !---------------------------------------------------------------------
      logical, external :: user_function
    end subroutine class_languages
  end interface
  !
  interface
    function class_error()
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for the error status of the library. Does nothing
      ! here.
      !---------------------------------------------------------------------
      logical :: class_error  ! Function value on return
    end function class_error
  end interface
  !
  interface
    subroutine run_sas(line,comm,error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for LAS\ language
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      character(len=*), intent(in)  :: comm   ! Command name
      logical,          intent(out) :: error  ! Error status
    end subroutine run_sas
  end interface
  !
  interface
    subroutine run_ana(line,comm,error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for ANALYSE\ language
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: line   ! Command line
      character(len=*), intent(in)    :: comm   ! Command name
      logical,          intent(out)   :: error  ! Error status
    end subroutine run_ana
  end interface
  !
  interface
    subroutine run_fit(line,comm,error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for FIT\ language
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      character(len=*), intent(in)  :: comm   ! Command name
      logical,          intent(out) :: error  ! Error status
    end subroutine run_fit
  end interface
  !
  interface
    subroutine run_dec(line,comm,error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for DSB2SSB\ language
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      character(len=*), intent(in)  :: comm   ! Command name
      logical,          intent(out) :: error  ! Error status
    end subroutine run_dec
  end interface
  !
  interface
    subroutine run_exp(line,comm,error)
      use class_rt
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Support routine for EXPERIMENTAL\ language
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      character(len=*), intent(in)  :: comm   ! Command name
      logical,          intent(out) :: error  ! Error status
    end subroutine run_exp
  end interface
  !
  interface
    subroutine class_swap(line,error,user_function)
      !----------------------------------------------------------------------
      ! @ private
      !  Exchange R and T memories
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
      logical,          external      :: user_function
    end subroutine class_swap
  end interface
  !
  interface
    subroutine swaprt(rname,error,user_function)
      use gbl_message
      use class_rt
      use class_setup
      !----------------------------------------------------------------------
      ! @ private
      !  Exchange R and T memories
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: rname
      logical,          intent(inout) :: error
      logical,          external      :: user_function
    end subroutine swaprt
  end interface
  !
  interface
    subroutine copyrt(user_function,key)
      use class_rt
      !----------------------------------------------------------------------
      ! @ private
      ! Copy R memory to T memory
      !----------------------------------------------------------------------
      logical,          external   :: user_function  !
      character(len=*), intent(in) :: key            !
    end subroutine copyrt
  end interface
  !
  interface
    subroutine copy2r(obs,error)
      use class_rt
      use class_setup
      !-------------------------------------------------------------------
      ! @ private
      ! Copy the observation into R memory
      !-------------------------------------------------------------------
      type(observation), intent(in)  :: obs    ! Current observation
      logical,           intent(out) :: error  ! Error flag
    end subroutine copy2r
  end interface
  !
end module class_interfaces_private

subroutine fits2gdf(name,error)
  use gbl_message
  use gio_params
  use gio_dependencies_interfaces
  use gio_interfaces, only: fits_gildas_sub, gio_message, fits2gdf_wpr
  !---------------------------------------------------------------------
  ! @ private
  ! Automatic FITS to GDF converion
  !---------------------------------------------------------------------
  character(len=*), intent(inout)  :: name       ! File name (modified)
  logical, intent(out) :: error                  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS2GDF'
  character(len=filename_length) :: iname,oname
  integer(kind=index_length) :: blc(gdf_maxdims),trc(gdf_maxdims)
  logical, parameter :: overwrite=.false.
  !
  call gio_message(seve%i,rname,'FITS-to-GDF automatic conversion, Version 1.1')
  !
  error=.false.
  blc = 0
  trc = 0
  !
  iname = name
  oname = trim(name)//'.gdf'
  name = oname
  !
  call fits_gildas_sub(iname,oname,' ',blc,trc,1,.false.,overwrite,error,  &
   gfits_getnosymbol,fits2gdf_wpr)
  if (error) then
    call gio_message(seve%e,rname,'Conversion failed')
    error=.true.
  else
    call gio_message(seve%i,rname,'Successful completion')
  endif
  !
end subroutine fits2gdf
!
subroutine fits2gdf_wpr(chain,answer)
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  character(len=*) :: chain         !
  character(len=*) :: answer        !
  call gio_message(seve%e,'FITS2GDF','Invalid call to SIC_WPR')
  call sysexi(fatale)
end subroutine fits2gdf_wpr
!
subroutine fitscube2gdf_header(file,ihdu,fd,ghead,getsymbol,error)
  use image_def
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_header
  !---------------------------------------------------------------------
  ! @ public
  ! Load the header of the extension currently opened in gfits and
  ! translate it as a GDF header. Suited for N-dimensional cubes only.
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: file       ! FITS file name
  integer(kind=4),     intent(in)    :: ihdu       ! HDU we are reading (1=Primary)
  type(gfits_hdesc_t), intent(inout) :: fd         !
  type(gildas),        intent(inout) :: ghead      ! Gildas header
  external                           :: getsymbol  ! Symbol translation routine
  logical,             intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: fmt
  type(gfits_hdict_t) :: fhdict
  real(kind=8) :: rota(gdf_maxdims)
  logical :: found
  character(len=12) :: unit(gdf_maxdims)
  !
  ! Try to load everything, no interpretation yet
  call gfits_load_header(fhdict,.false.,getsymbol,error)
  if (error)  return
  !
  ! Get (and check) cards with precise order and values expected
  ! SIMPLE
  if (ihdu.le.0) then
    call gio_message(seve%e,rname,'Invalid HDU number')
    error = .true.
    return
  elseif (ihdu.eq.1) then
    ! We are reading the Primary HDU
    call gfits_check_simple(fhdict%card(1),error)
    if (error)  return
  else
    ! We are reading an Xtension
    call gfits_check_xtension(fhdict%card(1),error,'IMAGE')
    if (error)  return
  endif
  ! BITPIX
  call gfits_check_format(fhdict%card(2),fd%nbit,fmt,error)
  if (error)  return
  ! NAXIS*
  call fitscube2gdf_check_naxis(fhdict,ihdu,ghead%gil%ndim,ghead%gil%dim,error)
  if (error)  return
  !
  ! More general elements
  ! Axes description
  call fitscube2gdf_check_convert(fhdict,ghead%gil%convert,rota,unit,error)
  if (error)  return
  ! CD Matrix ZZZ merge with fitscube2gdf_check_convert?
  call fitscube2gdf_check_cdmatrix(fhdict,ghead%gil%convert,rota,error)
  if (error)  return
  ! Extrema
  call fitscube2gdf_check_minmax(fhdict,ghead%gil%extr_words,ghead%gil%rmin,ghead%gil%rmax,error)
  if (error)  return
  ! Array description
  call fitscube2gdf_check_array(fhdict,fd,ghead,error)
  if (error)  return
  ! Coordinate system
  call fitscube2gdf_check_system(fhdict,rota,ghead,error)
  if (error)  return
  ! Spectroscopic axis
  call fitscube2gdf_check_spec(fhdict,unit,ghead,error)
  if (error)  return
  ! Resolution section
  call fitscube2gdf_check_resolution(fhdict,ghead,error)
  if (error)  return
  ! Telescope section
  call fitscube2gdf_check_telescope(fhdict,ghead,error)
  if (error)  return
  !
  ! Miscellaneous:
  ghead%file = file
  ! ZZZ to be merged in the related section!
  call gfits_get_value(fhdict,'OBJECT',found,ghead%char%name,error)
  if (error)  return
  call gfits_get_value(fhdict,'LINE',found,ghead%char%line,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'LINENAME',found,ghead%char%line,error)
    if (error)  return
  endif
  !
end subroutine fitscube2gdf_header
!
subroutine fitscube2gdf_check_naxis(fhdict,ihdu,ndim,dims,error)
  use gildas_def
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_naxis
  !---------------------------------------------------------------------
  ! @ private
  ! Read and check the NAXIS* values
  !---------------------------------------------------------------------
  type(gfits_hdict_t),        intent(in)    :: fhdict   !
  integer(kind=4),            intent(in)    :: ihdu     !
  integer(kind=4),            intent(out)   :: ndim     !
  integer(kind=index_length), intent(out)   :: dims(:)  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=20) :: what
  !
  if (ihdu.eq.1) then
    what = 'Primary HDU'
  else
    write(what,'(A,I0)') 'HDU #',ihdu
  endif
  !
  ! NAXIS: always the 3rd card
  call gfits_check_naxis(fhdict%card(3),ndim,error)
  if (error)  return
  if (ndim.le.0) then
    call gio_message(seve%e,rname,'No image in '//what)
    error = .true.
    return
  endif
  !
  ! NAXISi
  call gfits_check_naxisi(fhdict,dims,error)
  if (error)  return
  if (any(dims(1:ndim).eq.0)) then
    call gio_message(seve%e,rname,'One or more dimensions are zero-sized in '//what)
    error = .true.
    return
  endif
  !
end subroutine fitscube2gdf_check_naxis
!
subroutine fitscube2gdf_check_convert(fhdict,convert,rota,unit,error)
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_convert
  !---------------------------------------------------------------------
  ! @ private
  ! Translate all the CRVALi, CRPIXi, CDELTi, CTYPEi, CROTAi
  !---------------------------------------------------------------------
  type(gfits_hdict_t),  intent(in)    :: fhdict        !
  real(kind=8),         intent(out)   :: convert(:,:)  !
  real(kind=8),         intent(out)   :: rota(:)       !
  character(len=*),     intent(out)   :: unit(:)       !
  logical,              intent(inout) :: error         !
  ! Local
  integer(kind=4) :: iaxis
  character(len=6) :: key
  logical :: found
  !
  ! Defaults
  convert(1,:) = 0.d0  ! Ref
  convert(2,:) = 0.d0  ! Val
  convert(3,:) = 1.d0  ! Inc
  rota(:) = 0.d0
  unit(:) = ''
  !
  do iaxis=1,gdf_maxdims
    write(key,'(A5,I1)')  'CRPIX',iaxis
    call gfits_get_value(fhdict,key,found,convert(1,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CRVAL',iaxis
    call gfits_get_value(fhdict,key,found,convert(2,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CDELT',iaxis
    call gfits_get_value(fhdict,key,found,convert(3,iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CROTA',iaxis
    call gfits_get_value(fhdict,key,found,rota(iaxis),error)
    if (error)  return
    !
    write(key,'(A5,I1)')  'CUNIT',iaxis
    call gfits_get_value(fhdict,key,found,unit(iaxis),error)
    if (error)  return
  enddo
  !
end subroutine fitscube2gdf_check_convert
!
subroutine fitscube2gdf_check_cdmatrix(fhdict,convert,rota,error)
  use phys_const
  use gbl_message
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_cdmatrix
  !---------------------------------------------------------------------
  ! @ private
  ! Apply the CD or PC matrix to the convert/rota arrays
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict        !
  real(kind=8),        intent(inout) :: convert(:,:)  !
  real(kind=8),        intent(inout) :: rota(:)       !
  logical,             intent(inout) :: error         !
  ! Local
  character(len=*), parameter :: rname='FITS'
  real(kind=8) :: cd(2,2),pc(2,2),mat(2,2)
  character(len=2) :: matname
  integer(kind=4) :: numcd,numpc,num,pcstatus,cdstatus
  logical :: swapfirst,swapsecond
  real(kind=8) :: angle1,angle2
  integer(kind=4), parameter :: matrix_is_notdefined=1
  integer(kind=4), parameter :: matrix_is_reflection=2
  integer(kind=4), parameter :: matrix_is_rotation=3
  integer(kind=4), parameter :: matrix_is_skewed=4
  !
  ! Read CD and PC matrices (defaults as per Greisen & Calabretta paper I, section 2.1.2)
  cd(:,:) = 0.d0
  pc(1,1) = 1.d0  ! PC1_1
  pc(1,2) = 0.d0  ! PC1_2
  pc(2,1) = 0.d0  ! PC2_1
  pc(2,2) = 1.d0  ! PC2_2
  call read_matrix('CD',cd,numcd,error)
  if (error)  return
  call read_matrix('PC',pc,numpc,error)
  if (error)  return
  !
  if (numcd.gt.0 .and. numpc.gt.0) then
    ! Invalid as per the above named paper
    call gio_message(seve%w,rname,'Invalid mixture of CD and PC matrix')
    error = .true.
    return
  elseif (numcd.gt.0) then
    matname = 'CD'
    mat = cd
    num = numcd
    pcstatus = matrix_is_notdefined
  elseif (numpc.gt.0) then
    matname = 'PC'
    mat = pc
    num = numpc
    pcstatus = matrix_status(pc)
    ! Convert PC matrix to a CD matrix (i.e. also convey the increments).
    ! See Calabretta & Greisen Paper II, Eq. 1. This is important to take
    ! into account the CDELTi sign to compute the right angle (atan2 below),
    ! as the sign can be either stored in CDELTi or in the PC matrix
    ! coefficients.
    mat(1,1) = mat(1,1)*convert(3,1)  ! [FITS unit] CD1_1 = PC1_1 * CDELT1
    mat(1,2) = mat(1,2)*convert(3,1)  ! [FITS unit] CD1_2 = PC1_2 * CDELT1
    mat(2,1) = mat(2,1)*convert(3,2)  ! [FITS unit] CD2_1 = PC2_1 * CDELT2
    mat(2,2) = mat(2,2)*convert(3,2)  ! [FITS unit] CD2_2 = PC2_2 * CDELT2
  else ! Both are null: nothing to do
    return
  endif
  !
  ! CD matrix status
  cdstatus = matrix_status(mat)
  if (cdstatus.eq.matrix_is_skewed) then
    call gio_message(seve%e,rname,matname//'i_j matrix is skewed')
    error = .true.
    return
  endif
  if (num.eq.4) then
    call gio_message(seve%i,rname,'Using '//matname//' matrix')
  else
    call gio_message(seve%w,rname,'Using incomplete '//matname//' matrix')
  endif
  !
  ! CD matrix encodes both the increments and the rotation angle:
  ! reconstruct them
  !
  ! Guess axes orientation
  swapfirst = .false.
  swapsecond = .false.
  if (cdstatus.eq.matrix_is_reflection) then
    ! Reflections are not supported in GILDAS data format, but it can be
    ! converted to a rotation matrix by swapping one of the 2 axes:
    if (pcstatus.eq.matrix_is_rotation) then
      ! The PC matrix was defining a rotation, but CD is a reflection:
      ! swap one according to the original CDELTi
      swapfirst  = convert(3,1).lt.0.d0
      swapsecond = convert(3,2).lt.0.d0
    else
      ! In the other cases, there is an ambiguity. Assume the first axis
      ! is to be swapped (usually in astronomy, East is displayed to the
      ! left thanks to negative X axis)
      swapfirst = .true.
    endif
  else
    ! CD matrix is a rotation
    if (pcstatus.eq.matrix_is_rotation) then
      ! Swap 0 or 2 axes
      swapfirst  = convert(3,1).lt.0.d0
      swapsecond = convert(3,2).lt.0.d0
    endif
  endif
  !
  ! Reconstruct increments (absolute values)
  convert(3,1) = sqrt(mat(1,1)**2+mat(2,1)**2)
  convert(3,2) = sqrt(mat(1,2)**2+mat(2,2)**2)
  !
  ! Reconstruct increments (signs)
  if (swapfirst) then
    ! Swap the first axis and its coefficients
    mat(1,1) = -mat(1,1)
    mat(2,1) = -mat(2,1)
    convert(3,1) = -convert(3,1)
  endif
  if (swapsecond) then
    ! Swap the second axis and its coefficients
    mat(1,2) = -mat(1,2)
    mat(2,2) = -mat(2,2)
    convert(3,2) = -convert(3,2)
  endif
  !
  ! Reconstruct rotation angle
  angle1 = atan2(+mat(2,1),mat(1,1))
  angle2 = atan2(-mat(1,2),mat(2,2))
  rota(1) = angle1*180.0d0/pi
  rota(2) = angle2*180.0d0/pi  ! Must be in degree
  !
contains
  !
  function matrix_status(mat)
    !-------------------------------------------------------------------
    ! Return the matrix status according to its determinant:
    !  +1: rotation
    !  -1: reflection
    ! otherwise skewed. Note that the matrix coefficients can also
    ! contains an additional scaling factor (increments)
    !-------------------------------------------------------------------
    integer(kind=4) :: matrix_status
    real(kind=8), intent(in) :: mat(2,2)
    ! Local
    real(kind=4) :: ratio1,ratio2
    !
    ratio1 = mat(1,1)/mat(2,2)  ! Problem if mat(2,2) ~ 0 ?
    ratio2 = sqrt(mat(1,1)**2+mat(2,1)**2) / sqrt(mat(1,2)**2+mat(2,2)**2)
    if (.not.nearly_equal(abs(ratio1),ratio2,1e-4)) then
      ! This is not a rotation nor reflection, but a more complex matrix
      matrix_status = matrix_is_skewed
    elseif (ratio1.lt.0) then
      ! mat(1,1) and mat(2,2) are opposite sign: since the matrix is not
      ! skewed, this is a reflection matrix.
      matrix_status = matrix_is_reflection
    else
      matrix_status = matrix_is_rotation
    endif
!     det = pc(1,1)*pc(2,2)-pc(1,2)*pc(2,1)
!     if (nearly_equal(det,1d0,1d-4)) then
!       matrix_status = matrix_is_rotation
!     elseif (nearly_equal(det,-1d0,1d-4)) then
!       matrix_status = matrix_is_reflection
!     else
!       matrix_status = matrix_is_skewed
!     endif
  end function matrix_status
  !
  subroutine read_matrix(name,mat,num,error)
    !-------------------------------------------------------------------
    ! Read the named matrix in the mat(2,2) variable. For readability
    ! we store XXi_j into mat(i,j). The global matrix is:
    !           ( XX1_1  XX1_2 )
    !           ( XX2_1  XX2_2 )
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    real(kind=8),     intent(inout) :: mat(2,2)
    integer(kind=4),  intent(out)   :: num
    logical,          intent(inout) :: error
    !
    logical :: found
    !
    num = 0
    call gfits_get_value(fhdict,name//'1_1',found,mat(1,1),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'1_2',found,mat(1,2),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'2_1',found,mat(2,1),error)
    if (error)  return
    if (found)  num = num+1
    call gfits_get_value(fhdict,name//'2_2',found,mat(2,2),error)
    if (error)  return
    if (found)  num = num+1
  end subroutine read_matrix
  !
end subroutine fitscube2gdf_check_cdmatrix
!
subroutine fitscube2gdf_check_array(fhdict,fd,ghead,error)
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_array
  !---------------------------------------------------------------------
  ! @ private
  ! Get the binary array description
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict   !
  type(gfits_hdesc_t), intent(inout) :: fd       !
  type(gildas),        intent(inout) :: ghead    !
  logical,             intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  character(len=32) :: chblank
  integer(kind=8) :: i8blank
  real(kind=8) :: r8blank
  logical, parameter :: doblank=.true.  ! Should be customizable
  character(len=message_length) :: mess
  real(kind=4) :: newbval
  character(len=12) :: tempscale
  real(kind=4), parameter :: defbval=-1000.  ! Default blanking value
  !
  call gfits_get_value(fhdict,'BUNIT',found,ghead%char%unit,error)
  if (error)  return
  !
  ghead%gil%noise = defbval
  call gfits_get_value(fhdict,'NOISETHE',found,ghead%gil%noise,error)
  if (error)  return
  ghead%gil%rms = defbval
  call gfits_get_value(fhdict,'NOISEMEA',found,ghead%gil%rms,error)
  if (error)  return
  if (ghead%gil%noise.ne.defbval .or. ghead%gil%rms.ne.defbval)  &
    ghead%gil%nois_words = 1  ! Activate the GDF section
  !
  tempscale = ''
  call gfits_get_value(fhdict,'TEMPSCAL',found,tempscale,error)
  if (error)  return
  if (tempscale.ne.'') then
    ! Try to format to the usual Gildas encoding e.g. "K (TA*)"
    ghead%char%unit = trim(ghead%char%unit)//' ('//trim(tempscale)//')'
  endif
  !
  fd%bscal = 1.0  ! Fallback if not found
  call gfits_get_value(fhdict,'BSCALE',found,fd%bscal,error)
  if (error)  return
  !
  fd%bzero = 0.0  ! Fallback if not found
  call gfits_get_value(fhdict,'BZERO',found,fd%bzero,error)
  if (error)  return
  !
  call gfits_get_value(fhdict,'BLANK',found,chblank,error)
  if (error)  return
  !
  if (found) then
    ! BLANK is defined
    if (fd%nbit.ge.0) then  ! Indexed values
      call gfits_get_value(fhdict,'BLANK',found,i8blank,error)
      if (error)  return
      ! Note that the blanking value can be surrounded by valid values
      ghead%gil%bval = i8blank*fd%bscal + fd%bzero
      ghead%gil%eval = 0.5*fd%bscal
      ghead%gil%blan_words = 2
    else  ! Floating point values
      ! Scaling is poor style for floats, but not strictly forbidden...
      call gfits_get_value(fhdict,'BLANK',found,r8blank,error)
      if (error)  return
      ghead%gil%bval = r8blank*fd%bscal + fd%bzero
      ghead%gil%eval = 0.
      ghead%gil%blan_words = 2
    endif
    fd%bval0 = ghead%gil%bval  ! Actual blanking value used by the data
  else
    ! BLANK is not defined
    if (fd%nbit.ge.0) then  ! Indexed values
      ghead%gil%blan_words = 0  ! No blanking in header => no blanking in data
      fd%bval0 = 0.  ! Unused
      return  ! Leave section disabled
    else  ! Floating point values
      ghead%gil%blan_words = 0  ! No blanking value, but maybe NaN to be patched
      call gag_notanum(fd%bval0)  ! Actual blanking value used by the data
    endif
  endif
  !
  if (.not.doblank)  return  ! Leave blank values in data "as is"
  !
  ! Try to define a cleverer blanking value.
  if (ghead%gil%rmin.lt.ghead%gil%rmax) then
    ! OK: DATAMIN and DATAMAX were defined. Select a round blanking value
    ! below DATAMIN
    if (ghead%gil%rmin.gt.defbval) then
      newbval = defbval
    else
      newbval = -10**ceiling(log10(-ghead%gil%rmin))
    endif
    write(mess,'(A,1X,F0.1)')  'Removing NaN with blanking value',newbval
    call gio_message(seve%w,rname,mess)
  else
    ! We should design the blanking value according to data min value, but
    ! this requires searching for the latter in first loop, and then patching
    ! NaN in a second loop. Cost is too large...
    call gio_message(seve%w,rname,'Removing NaN with default blanking value -1000.0')
    newbval = defbval
  endif
  !
  ! Define or update the blanking section
  ghead%gil%blan_words = 2
  ghead%gil%bval = newbval
  ghead%gil%eval = 0.
  !
  ! Noise values (if blank)
  if (ghead%gil%noise.eq.defbval)  ghead%gil%noise = newbval
  if (ghead%gil%rms.eq.defbval)    ghead%gil%rms = newbval
  !
end subroutine fitscube2gdf_check_array
!
subroutine fitscube2gdf_check_minmax(fhdict,nwords,datamin,datamax,error)
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_minmax
  !---------------------------------------------------------------------
  ! @ private
  ! Get the binary array description
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  integer(kind=4),     intent(out)   :: nwords    !
  real(kind=4),        intent(out)   :: datamin   !
  real(kind=4),        intent(out)   :: datamax   !
  logical,             intent(inout) :: error     !
  ! Local
  logical :: found
  !
  nwords = 0
  !
  call gfits_get_value(fhdict,'DATAMIN',found,datamin,error)
  if (error)  return
  if (found)  nwords = nwords+1
  !
  call gfits_get_value(fhdict,'DATAMAX',found,datamax,error)
  if (error)  return
  if (found)  nwords = nwords+1
  !
end subroutine fitscube2gdf_check_minmax
!
subroutine fitscube2gdf_check_system(fhdict,rota,ghead,error)
  use phys_const
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_system
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  real(kind=8),        intent(in)    :: rota(:)   !
  type(gildas),        intent(inout) :: ghead     !
  logical,             intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: iaxis,minus,ier
  character(len=6) :: key
  logical :: found
  character(len=12) :: rccode,suffix,pname
  character(len=80) :: value
  real(kind=4) :: xoff,yoff
  character(len=message_length) :: mess
  !
  ! Default equinox (NB: FITS says RADESYS defaults to FK5 is absent, i.e.
  ! there is a valid default system and equinox...)
  ghead%char%syst = ''
  ghead%gil%epoc = equinox_null
  !
  ! System and optionally equinox
  call gfits_get_value(fhdict,'RADESYS',found,value,error)
  if (error)  return
  if (.not.found) then  ! Try deprecated RADECSYS
    call gfits_get_value(fhdict,'RADECSYS',found,value,error)
    if (error)  return
  endif
  if (found) then
    ! From RADESYS
    if (value(1:8).eq.'FK4-NO-E') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 1950.0
    elseif (value(1:3).eq.'FK4') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 1950.0
    elseif (value(1:3).eq.'FK5') then
      ghead%char%syst = 'EQUATORIAL'
      ghead%gil%epoc = 2000.0
    elseif (value(1:4).eq.'ICRS') then
      ghead%char%syst = 'ICRS'
      ghead%gil%epoc = equinox_null  ! Irrelevant for ICRS
    endif
  endif
  !
  ! EQUINOX (or EPOCH)
  call gfits_get_value(fhdict,'EQUINOX',found,value,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'EPOCH',found,value,error)
    if (error)  return
  endif
  if (found) then
    read(value,*,iostat=ier) ghead%gil%epoc
    if (ier.ne.0) then
      if (value(1:1).eq.'J') then
        read(value(2:),*,iostat=ier) ghead%gil%epoc
      elseif (value(1:1).eq.'B') then
        read(value(2:),*,iostat=ier) ghead%gil%epoc
      endif
      if (ier.ne.0) then
        call gio_message(seve%e,rname,'Undecipherable Equinox '//value)
        ghead%gil%epoc = equinox_null
      endif
    endif
  endif
  !
  ! System description
  pname = ' '
  ghead%gil%xaxi = 0
  ghead%gil%yaxi = 0
  do iaxis=1,ghead%gil%ndim
    !
    write(key,'(A5,I1)')  'CTYPE',iaxis
    call gfits_get_value(fhdict,key,found,rccode,error)
    if (error)  return
    if (.not.found) then
      write(mess,'(A,I0,3A)')  'File has ',ghead%gil%ndim,' dimensions but ',  &
        trim(key),' is not defined'
      call gio_message(seve%w,rname,mess)
      cycle
    endif
    !
    ! Split system and projection
    minus = index(rccode,'-',back=.true.)
    if (minus.eq.0) then
      suffix = ' '
    else
      suffix = rccode(minus+1:)
      minus = index(rccode,'-',back=.false.)
      rccode = rccode(:minus-1)
    endif
    !
    ! System
    select case (rccode)
    case ('RA')
      if (ghead%char%syst.eq.'') then
        ! RA is ambiguously used for EQUATORIAL or ICRS
        call gio_message(seve%w,rname,'Coordinate system assumed EQUATORIAL')
        ghead%char%syst      = 'EQUATORIAL'
      endif
      ghead%gil%xaxi         = iaxis
      ghead%char%code(iaxis) = 'RA'
      ghead%gil%ra           = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%a0           = ghead%gil%ra
      pname = suffix
    case ('DEC')
      if (ghead%char%syst.eq.'') then
        ! DEC is ambiguously used for EQUATORIAL or ICRS
        call gio_message(seve%w,rname,'Coordinate system assumed EQUATORIAL')
        ghead%char%syst      = 'EQUATORIAL'
      endif
      ghead%gil%yaxi         = iaxis
      ghead%char%code(iaxis) = 'DEC'
      ghead%gil%dec          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%d0           = ghead%gil%dec
      pname = suffix
    case ('LON','GLON')
      ghead%char%syst        = 'GALACTIC'
      ghead%gil%xaxi         = iaxis
      ghead%char%code(iaxis) = 'LII'
      ghead%gil%lii          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%a0           = ghead%gil%lii
      pname = suffix
    case ('LAT','GLAT')
      ghead%char%syst        = 'GALACTIC'
      ghead%gil%yaxi         = iaxis
      ghead%char%code(iaxis) = 'BII'
      ghead%gil%bii          = ghead%gil%convert(2,iaxis)*rad_per_deg
      ghead%gil%d0           = ghead%gil%bii
      pname = suffix
    case default
      cycle
    end select
    !
    ! Factorized for all of the 4 cases:
    ghead%gil%convert(2,iaxis) = 0.d0
    ghead%gil%convert(3,iaxis) = ghead%gil%convert(3,iaxis)*rad_per_deg
    ghead%gil%desc_words       = 1
    !
  enddo
  !
  ! Projection type
  select case (pname)
  case ('')
    ! Projection is not defined.
    if (ghead%gil%xaxi.ne.0 .or. ghead%gil%yaxi.ne.0) then
      ! Spatial axes are defined but not their projection. Quoting Greisen
      ! & Calabretta 2002: "CTYPEi values that are not in "4–3" form
      ! should be interpreted as linear axes."
      call gio_message(seve%w,rname,'Projection assumed CARTESIAN')
      ghead%gil%ptyp = p_cartesian
    else
      ! No spatial axes defined => no projection
      ghead%gil%ptyp = p_none
    endif
  case ('TAN')
    ghead%gil%ptyp = p_gnomonic
  case ('ATF','AIT')  ! Aitoff
    ghead%gil%ptyp = p_aitoff
    if (ghead%gil%d0.ne.0.d0) then
      ! GILDAS equations for Aitoff projection implement only reference
      ! on the Equator.
      call gio_message(seve%w,rname,  &
        'AITOFF with non-zero declination is not supported: expect incorrect coordinates')
    endif
  case ('SIN')
    ! Note that Gildas does not support extended SIN (Slant orthographic).
    ! See Calabretta & Greisen 2002, sections 5.1.5 and 6.1.1. We should
    ! reject the cases when PVi_j are defined and non-zero.
    ghead%gil%ptyp = p_ortho  ! Orthographic or Dixon
  case ('ARC')
    ghead%gil%ptyp = p_azimuthal  ! Schmidt or Azimuthal
  case ('STG')  ! Stereographic
    ghead%gil%ptyp = p_stereo
  case ('GLS')
    ghead%gil%ptyp = p_radio
  case ('CAR')  ! Cartesian
    ghead%gil%ptyp = p_cartesian
  case ('SFL')
    ghead%gil%ptyp = p_sfl
  case ('NCP')  ! North Celestial Pole
    ! Gildas offers native support. Note that according to Calabretta
    ! & Greisen 2002, NCP is obsolete and should be translated to
    ! (see section 6.1.2):
    !     SIN with PV2_1 = 0 and PV2_2 = 1/tan(d0)
    ! This defines an "extented" SIN projection (Slant orthographic, see
    ! section 5.1.5). However, Gildas supports only the (non-extended)
    ! orthographic projection with SIN with PV2_1 = PV2_2 = 0 (see section
    ! 6.1.1).
    ghead%gil%ptyp = p_ncp
  case default
    call gio_message(seve%w,rname,'Unrecognized projection '//pname)
    ghead%gil%ptyp = p_none
  end select
  ! Projection angle. Can be defined in CROTA2 but not CROTA1.
  if (ghead%gil%xaxi.ne.0 .and. rota(ghead%gil%xaxi).ne.0.d0) then
    ghead%gil%pang = rota(ghead%gil%xaxi)*rad_per_deg  ! From deg to internal rad
  elseif (ghead%gil%yaxi.ne.0 .and. rota(ghead%gil%yaxi).ne.0.d0) then
    ghead%gil%pang = rota(ghead%gil%yaxi)*rad_per_deg  ! From deg to internal rad
  else
    ghead%gil%pang = 0.d0
  endif
  !
  call fitscube2gdf_import_sfl_as_radio(fhdict,ghead,error)
  if (error)  return
  !
  ! Set the alternate system
  xoff = 0.
  yoff = 0.
  if (ghead%char%syst.eq.'EQUATORIAL') then
    if (ghead%gil%epoc.ne.equinox_null)  &
    call equ_to_gal(ghead%gil%ra,ghead%gil%dec,xoff,yoff,ghead%gil%epoc,  &
                    ghead%gil%lii,ghead%gil%bii,xoff,yoff,error)
  elseif (ghead%char%syst.eq.'GALACTIC') then
    if (ghead%gil%epoc.eq.equinox_null)  ghead%gil%epoc = 2000.0
    call gal_to_equ(ghead%gil%lii,ghead%gil%bii,xoff,yoff,  &
                    ghead%gil%ra,ghead%gil%dec,xoff,yoff,ghead%gil%epoc,error)
  elseif (ghead%char%syst.eq.'ICRS') then
    ! Converting from ICRS is not yet implemented
    ghead%gil%lii = 0.d0
    ghead%gil%bii = 0.d0
  endif
  !
end subroutine fitscube2gdf_check_system
!
subroutine fitscube2gdf_check_spec(fhdict,unit,ghead,error)
  use phys_const
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_spec
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict    !
  character(len=*),    intent(in)    :: unit(:)   !
  type(gildas),        intent(inout) :: ghead     !
  logical,             intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: iaxis,velref,minus
  character(len=6) :: key
  logical :: found
  character(len=12) :: value
  real(kind=8) :: altrpix,factor
  integer(kind=4), parameter :: iref=1,ival=2,iinc=3
  !
  ! Velocity type
  ! ghead%gil%vtyp = default set by gildas_null
  call gfits_get_value(fhdict,'SPECSYS',found,value,error)
  if (error)  return
  if (found) then
    select case (value)
    case ('LSRK')
      ghead%gil%vtyp = vel_lsr
    case ('HEL')
      ghead%gil%vtyp = vel_hel
    case ('TOPOCENT')
      ghead%gil%vtyp = vel_obs
    case default
      call gio_message(seve%w,rname,'SPECSYS '//trim(value)//' not understood')
    end select
  else
    ! VELREF: >256 RADIO, 1 LSR 2 HEL 3 OBS
    call gfits_get_value(fhdict,'VELREF',found,velref,error)
    if (error)  return
    if (found) then
      if (velref.gt.256)  velref = velref-256
      select case (velref)
      case (1)
        ghead%gil%vtyp = vel_lsr
      case (2)
        ghead%gil%vtyp = vel_hel
      case (3)
        ghead%gil%vtyp = vel_obs
      case default
        call gio_message(seve%w,rname,'Invalid VELREF, velocity type set to default')
      end select
    endif
  endif
  !
  ! System description
  ghead%gil%spec_words = 0
  ghead%gil%faxi = 0
  do iaxis=1,ghead%gil%ndim
    !
    write(key,'(A5,I1)')  'CTYPE',iaxis
    call gfits_get_value(fhdict,key,found,value,error)
    if (error)  return
    minus = index(value,'-')
    if (minus.ne.0)  value = value(1:minus-1)  ! e.g. VELO-LSR => VELO
    !
    select case (value)
    case ('VELOCITY','VELO','VRAD')
      ghead%char%code(iaxis) = 'VELOCITY'
      ghead%gil%faxi = iaxis
      ! Get scaling factor from 'unit' to m/s
      call unit_prefix_scale(unit(iaxis),'m/s',factor,error)
      if (error)  return
      ! Get scaling factor from m/s to Gildas internal unit (km/s)
      factor = factor*1.0d-3
      ghead%gil%convert(ival,iaxis) = ghead%gil%convert(ival,iaxis)*factor
      ghead%gil%convert(iinc,iaxis) = ghead%gil%convert(iinc,iaxis)*factor
      ghead%gil%vres = ghead%gil%convert(iinc,iaxis)
      ghead%gil%spec_words = 12
    case ('FREQUENCY','FREQ')
      ghead%char%code(iaxis) = 'FREQUENCY'
      ghead%gil%faxi = iaxis
      ! Get scaling factor from 'unit' to Hz
      call unit_prefix_scale(unit(iaxis),'Hz',factor,error)
      if (error)  return
      ! Get scaling factor from Hz to Gildas internal unit (MHz)
      factor = factor*1.0d-6
      ghead%gil%convert(ival,iaxis) = ghead%gil%convert(ival,iaxis)*factor
      ghead%gil%convert(iinc,iaxis) = ghead%gil%convert(iinc,iaxis)*factor
      ghead%gil%fres = ghead%gil%convert(iinc,iaxis)
      ghead%gil%spec_words = 12
      !
      ! Prepare the Freq value
      ghead%gil%freq = ghead%gil%convert(ival,iaxis)*1d6 ! In Hz, for further use below
    case ('LAMBDA')
      ghead%char%code(iaxis) = 'LAMBDA'
      ghead%gil%faxi = iaxis
      ghead%gil%spec_words = 12
    case ('STOKES')
      ghead%char%code(iaxis) = 'STOKES'
    end select
    !
  enddo
  !
  if (ghead%gil%spec_words.eq.0)  return
  !
  ! Velocity offset
  call gfits_get_value(fhdict,'VELO-LSR',found,ghead%gil%voff,error)
  if (error)  return
  if (found) then
    ! Up to now VELO-LSR has no known unit => assume m/s, convert to km/s
    ghead%gil%voff = ghead%gil%voff*1e-3
  else
    ! No VELO-LSR keyword
    if (ghead%char%code(ghead%gil%faxi).eq.'VELOCITY') then
      ghead%gil%voff = ghead%gil%convert(ival,ghead%gil%faxi)  ! Already in Gildas internal unit
    else
      ! No velocity axis nor velocity offset...
      call gio_message(seve%w,rname,'Missing velocity description')
    endif
  endif
  !
  ! Rest frequency
  call gfits_get_value(fhdict,'RESTFREQ',found,ghead%gil%freq,error)
  if (error)  return
  if (.not.found) then
    call gfits_get_value(fhdict,'RESTFRQ',found,ghead%gil%freq,error)
    if (error)  return
  endif
  if (.not.found .and. ghead%char%code(ghead%gil%faxi).eq.'VELOCITY') then
    ! Rest frequency not yet found, try to derive from ALTRVAL/ALTRPIX.
    ! Note: if RESTFREQ is already known (usual case), we should check the
    ! consistency between RESTFREQ, convert[*,faxi], and ALTRVAL/ALTRPIX
    call gio_message(seve%w,rname,'Deriving rest frequency from ALTRVAL/ALTRPIX')
    call gfits_get_value(fhdict,'ALTRVAL',found,ghead%gil%freq,error)
    if (error)  return
    call gfits_get_value(fhdict,'ALTRPIX',found,altrpix,error)
    if (error)  return
    if (found) then
      ! Frequency at ref. channel (in case it is different from ALTRPIX)
      ghead%gil%freq = ghead%gil%freq -  &
                       (altrpix-ghead%gil%convert(iref,ghead%gil%faxi)) *  &
                       ghead%gil%convert(iinc,ghead%gil%faxi) * ghead%gil%freq / clight_kms
      ! Rest frequency corresponds to velocity = 0 (LSR frame)
      ghead%gil%freq = ghead%gil%freq -  &
                       ghead%gil%convert(ival,ghead%gil%faxi) *  &
                       ghead%gil%convert(iinc,ghead%gil%faxi) * ghead%gil%freq / clight_kms
    endif
  endif
  ! Up to now RESTFREQ has no known unit => assume Hz, convert to MHz
  ghead%gil%freq = ghead%gil%freq*1d-6
  !
  ! Image frequency
  call gfits_get_value(fhdict,'IMAGFREQ',found,ghead%gil%fima,error)
  if (error)  return
  ghead%gil%fima = ghead%gil%fima*1d-6  ! Assume Hz, convert to MHz
  !
  ! Resolutions
  if (ghead%gil%vres.eq.0.)  ghead%gil%vres = - clight_kms * ghead%gil%fres / ghead%gil%freq
  if (ghead%gil%fres.eq.0.)  ghead%gil%fres = - ghead%gil%freq * ghead%gil%vres / clight_kms
  !
end subroutine fitscube2gdf_check_spec
!
subroutine fitscube2gdf_check_resolution(fhdict,ghead,error)
  use phys_const
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_resolution
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict  !
  type(gildas),        intent(inout) :: ghead   !
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  !
  ghead%gil%majo = 0.
  call gfits_get_value(fhdict,'BMAJ',found,ghead%gil%majo,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%majo = ghead%gil%majo*rad_per_deg
  endif
  !
  ghead%gil%mino = 0.
  call gfits_get_value(fhdict,'BMIN',found,ghead%gil%mino,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%mino = ghead%gil%mino*rad_per_deg
  endif
  !
  ghead%gil%posa = 0.
  call gfits_get_value(fhdict,'BPA', found,ghead%gil%posa,error)
  if (error)  return
  if (found) then
    ghead%gil%reso_words = 3
    ghead%gil%posa = ghead%gil%posa*rad_per_deg
  endif
  !
end subroutine fitscube2gdf_check_resolution
!
subroutine fitscube2gdf_check_telescope(fhdict,ghead,error)
  use phys_const
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_check_telescope
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict  !
  type(gildas),        intent(inout) :: ghead   !
  logical,             intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='FITS'
  logical :: found
  character(len=12) :: telescope
  real(kind=8) :: dummy(3)
  !
  call gfits_get_value(fhdict,'TELESCOP',found,telescope,error)
  if (error)  return
  if (found) then
    call gdf_addteles(ghead,'TELE',telescope,dummy,error)
    if (error)  error = .false.  ! Most likely the telescope name was not found
  endif
  !
end subroutine fitscube2gdf_check_telescope
!
subroutine fitscube2gdf_patch_bval(fd,ghead,data,ndata,nblank,error)
  use gildas_def
  use image_def
  use gio_interfaces, except_this=>fitscube2gdf_patch_bval
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Patch blanking values to a better value in input data array
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd           !
  type(gildas),              intent(in)    :: ghead        !
  integer(kind=size_length), intent(in)    :: ndata        !
  real(kind=4),              intent(inout) :: data(ndata)  !
  integer(kind=size_length), intent(inout) :: nblank       ! Updated in return
  logical,                   intent(inout) :: error        !
  ! Local
  integer(kind=size_length) :: i
  !
  ! If no blanking value was (re)defined in the header, there is nothing
  ! we can patch in the data:
  if (ghead%gil%blan_words.eq.0)  return
  !
  ! Patch the data
  if (fd%bval0.ne.fd%bval0) then
    ! Actual blanking value is NaN
    do i=1,ndata
      if (data(i).ne.data(i)) then
        nblank = nblank+1
        data(i) = ghead%gil%bval
      endif
    enddo
  elseif (fd%bval0.ne.ghead%gil%bval) then
    ! Actual blanking value is standard float
    do i=1,ndata
      if (data(i).eq.fd%bval0) then
        nblank = nblank+1
        data(i) = ghead%gil%bval
      endif
    enddo
  endif
  !
end subroutine fitscube2gdf_patch_bval
!
subroutine fits2gdf_guess_style(style,error)
  use gbl_message
  use gio_params
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fits2gdf_guess_style
  use gio_fitsdef
  !---------------------------------------------------------------------
  ! @ private
  !  Guess the style of the extension currently opened in GFITS
  !---------------------------------------------------------------------
  integer(kind=4), intent(out)   :: style
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS'
  type(gfits_hdict_t) :: fhdict
  logical :: groups,found
  !
  ! Load the whole header for simplicity. No symbol translation as
  ! there is no purpose user overrides the checks on NAXIS* in this
  ! subroutine.
  call gfits_load_header(fhdict,.false.,gfits_getnosymbol,error)
  if (error)  return
  !
  ! Minimum sanity checks: they will be the responsibility of the full filler
  groups = .false.
  call gfits_get_value(fhdict,'GROUPS',found,groups,error)
  if (error)  return
  !
  if (groups) then
    ! Rely on the GROUPS keyword. Checking if NAXIS1 is 0 is not 100%
    ! reliable as it can be 0 for exotic (but valid) data in other
    ! styles (e.g. zero-sized columns in a BINTABLE).
    call gio_message(seve%i,rname,'FITS file may be UVFITS, trying...')
    style = code_fits_uvfits
  else
    style = code_fits_standard
    call gio_message(seve%i,rname,'FITS file may be IMAGE, trying...')
  endif
  !
  ! Rewind position to start of current extension, so that the filler
  ! can read the header as it wants
  call gfits_rewind_hdu(error)
  if (error)  return
  !
end subroutine fits2gdf_guess_style
!
subroutine unit_prefix_scale(prefix,unit,scale,error)
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>unit_prefix_scale
  !---------------------------------------------------------------------
  ! @ public
  ! Find the scaling factor to go from 'unit' (e.g. 'Hz') to prefix
  ! (e.g. 'MHz').
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: prefix  ! Prefixed unit
  character(len=*), intent(in)    :: unit    ! Natural unit
  real(kind=8),     intent(out)   :: scale   ! Scaling factor
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: kunit
  character(len=12) :: u_unit
  character(len=24) :: u_prefix
  !
  scale = 1.d0
  !
  if (prefix.eq.' ') return  ! Empty assumes natural unit
  !
  u_prefix = prefix
  call sic_upper(u_prefix)
  u_unit = unit
  call sic_upper(u_unit)
  kunit = index(u_prefix,u_unit)
  !
  if (kunit.eq.0) then
    ! Unit recognized at all...
    call gio_message(seve%w,rname,'Non-supported unit '//prefix)
    return
  else if (kunit.eq.1) then
    ! No prefix multiplier
    return
  else if (u_prefix(kunit:).ne.u_unit) then
    ! Not a prefix multiplier
    return
  else if (kunit.gt.3)  then
    ! Prefix multiplier can only have 1 or 2 letters
    call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    return
  else if (kunit.eq.3) then
    ! The only Prefix multiplier with 2 letters is "da" for "deca"
    if (prefix(1:2).eq.'da') then
      scale = 10.d0
    else
      call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    endif
    return
  endif
  !
  ! NB: tests are done on non-upcased prefix
  select case (prefix(1:1))
  case ('d')
    scale = 1.d-1
  case ('c')
    scale = 1.d-2
  case ('m')
    scale = 1.d-3
  case ('u')
    scale = 1.d-6
  case ('n')
    scale = 1.d-9
  case ('p')
    scale = 1.d-12
  case ('f')
    scale = 1.d-15
  case ('a')
    scale = 1.d-18
  case ('z')
    scale = 1.d-21
  case ('y')
    scale = 1.d-24
  case ('h')
    scale = 1.d2
  case ('k')
    scale = 1.d3
  case ('M')
    scale = 1.d6
  case ('G')
    scale = 1.d9
  case ('T')
    scale = 1.d12
  case ('P')
    scale = 1.d15
  case ('E')
    scale = 1.d18
  case ('Z')
    scale = 1.d21
  case ('Y')
    scale = 1.d24
  case default
    call gio_message(seve%w,rname,'Non-supported prefix in unit '//prefix)
    scale = 1.d0
  end select
  !
end subroutine unit_prefix_scale
!
subroutine fitscube2gdf_import_sfl_as_radio(fhdict,ghead,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>fitscube2gdf_import_sfl_as_radio
  !---------------------------------------------------------------------
  ! @ private
  ! If possible, convert back the SFL projection to the usual radio
  ! projection. This patch is symetric to what is done at export time,
  ! but the export patch puts the reference on the Equator, which is a
  ! bit annoying.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fhdict
  type(gildas),        intent(inout) :: ghead
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FITS'
  real(kind=8) :: dec
  logical :: found
  !
  if (ghead%gil%ptyp.ne.p_sfl)  return
  if (ghead%gil%yaxi.eq.0)      return
  if (ghead%gil%d0.ne.0.d0)     return
  !
  ! Get the source declination
  dec = 0.d0
  call gfits_get_value(fhdict,'DEC',found,dec,error)
  if (error)  return
  if (dec.eq.0.d0)  return
  dec = dec*rad_per_deg
  !
  ! Bring back reference point to the source declination
  call gio_message(seve%w,rname,'Projection kind converted from SFL to radio')
  ghead%gil%ptyp = p_radio
  ghead%gil%d0 = dec
  ghead%gil%dec = dec
  ghead%gil%ref(ghead%gil%yaxi) = ghead%gil%ref(ghead%gil%yaxi) + &
                                  dec/ghead%gil%inc(ghead%gil%yaxi)
  !
end subroutine fitscube2gdf_import_sfl_as_radio

program uv_fast_ccmodel
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  ! Compute a UV data set from an image model
  ! Input : a UV table, created for example by ASTRO
  ! Input : an image, LMV-like
  ! Output: the UV table, where the visibilities have been computed.
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !---------------------------------------------------------------------
  character(len=256) :: uvdata,image,uvmodel
  real :: frequency
  logical :: large
  integer :: nclean
  logical :: error
  !
  ! Code:
  call gildas_open
  call gildas_char('UVSAMPLE$',uvdata)
  call gildas_char('IMAGE$',image)
  call gildas_char('UVMODEL$',uvmodel)
  call gildas_real('FREQUENCY$',frequency,1)
  call gildas_logi('LARGE$',large,1)
  call gildas_inte('CLEAN$',nclean,1)
  call gildas_close
  !
  call uv_auto_model(uvdata,image,uvmodel,frequency,large,nclean,error)
  if (error) call sysexi(fatale)

contains
!<FF>
subroutine uv_auto_model (uvdata,image,uvmodel,frequency,large,nclean,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  ! Compute a UV data set from a  Clean Components table
  ! Input : a UV table, created for example by ASTRO
  ! Input : a CCT table, both ways accepted
  ! Output: the UV table, where the visibilities have been computed.
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !
  ! Intermediate FFT is a "large" version, i.e. 4 times the nearest power
  ! of 2 of the initial image, or a maximum of 4096 x 4096.
  !---------------------------------------------------------------------
  !
  character(len=*), intent(inout) :: uvdata        ! Sample UV table
  character(len=*), intent(inout) :: image         ! Clean Component Table
  character(len=*), intent(inout) :: uvmodel       ! Output UV table
  real, intent(in) :: frequency                    ! Observing frequency
  logical, intent(in) :: large                     ! Precision
  integer, intent(in) :: nclean                    ! Retained clean components
  logical, intent(out) :: error
  ! Global
  type (gildas) :: huvd
  type (gildas) :: hima
  type (gildas) :: huvm
  !
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: uvd(:,:)
  real, allocatable :: ima(:,:,:)
  real, allocatable :: map(:,:,:)
  real, allocatable :: uvm(:,:)
  real, allocatable :: work(:)
  !
  ! Local
  integer :: nf,nx,ny,mx,my,kx,ky,nt,nv,mt, ier
  real :: cpu0, cpu1
  real :: rx, ry, fres, factor
  real(8) :: xinc, yinc, freq
  !
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input file
  call gildas_null(huvd, type= 'UVT')
  call sic_parsef(uvdata,huvd%file,' ','.uvt')
  call gdf_read_header (huvd,error)
  if (error) then
     call gagout ('F-UV_MODEL,  Cannot read input table')
     goto 999
  endif
  if (huvd%char%type(1:9).ne.'GILDAS_UV') then
     call gagout ('W-UV_MODEL,  Input data is not a UV table')
     goto 999
  endif
  !
  allocate (uvd(huvd%gil%dim(1),huvd%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
     call gagout ('F-UV_MODEL,  UVD Allocation error')
     error = .true.
     goto 999
  endif
  call gdf_read_data(huvd,uvd,error)
  !
  ! CCT
  call gildas_null(hima)
  call sic_parsef(image,hima%file,' ','.cct')
  call gdf_read_header (hima,error)
  if (error) then
     call gagout ('F-UV_MODEL,  Cannot read Clean Component table')
     goto 999
  endif
  if (hima%char%type.ne.'GILDAS_IMAGE') then
     call gagout ('W-UV_MODEL,  Input model is not an image' )
     goto 999
  endif
  !
  mx = hima%gil%dim(1)
  my = hima%gil%dim(2)
  nf = hima%gil%dim(3)
  allocate (ima(mx,my,nf),stat=ier)
  if (ier.ne.0) then
     call gagout ('F-UV_MODEL,  IMA Allocation error')
     error = .true.
     goto 999
  endif
  call gdf_read_data(hima,ima,error)
  !
  ! Compact it into an image
  ! This depends on the CCT type, and is done in a subroutine
  !    First, defined the sampling and image size
  call cct_def_image (hima,mx,my,nf,freq,xinc,yinc,error)
  if (error) return
  !    Then do the job
  allocate (map(mx,my,nf),stat=ier)
  if (ier.ne.0) then
     call gagout ('F-UV_MODEL,  MAP Allocation error')
     error = .true.
     goto 999
  endif
  call cct_set_image (hima,ima,mx,my,nclean,xinc,yinc,nf,map,error)
  !
  !! pixel_area = abs(xinc*yinc)   ! in radian
  !
  !
  ! Define the image size
  !
  if (large) then
     rx = log(float(mx))/log(2.0)
     kx = nint(rx)
     if (kx.lt.rx) kx = kx+1
     nx = 2**kx
     ry = log(float(my))/log(2.0)
     ky = nint(ry)
     if (ky.lt.ry) ky = ky+1
     ny = 2**ky
     kx = max(nx,ny)
     kx = min(4*kx,4096)
     kx = max(mx,kx)
     kx = max(my,kx)
     nx = kx
     ny = kx
     call gag_cpu(cpu1)
  else
     nx = mx
     ny = my
  endif
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nf),stat=ier)
  if (ier.ne.0) then
     call gagout('E-UV_FCCT,  FFT space allocation error')
     goto 999
  endif
  !
  if (nx.eq.mx .and. ny.eq.my) then
     fft(:,:,:) = cmplx(map,0.0)
  else
     call plunge_real (map,mx,my,fft,nx,ny,nf)
  endif
  ! Free map
  deallocate (map,stat=ier)
  allocate (work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
     call gagout('E-UV_FCCT,  FFT work allocation error')
     goto 999
  endif
  !
  ! Compute the FFT
  call do_fft(nx,ny,nf,fft,work)
  call gag_cpu(cpu1)
  !
  call gildas_null(huvm, type = 'UVT')
  call gdf_copy_header(huvd,huvm,error)
  fres = hima%gil%fres
  if (freq.eq.0.0) then
     freq = 1d5                 ! 100 GHz
     fres = 1d3
  endif
  if (frequency.ne.0) freq = frequency !! All in MHz
  !
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  !! lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  !! factor = 2*1.38e3/lambda**2*pixel_area
  !! print *,'Factor ',factor,pixel_area
  !! if (factor.eq.0.0) factor = 1.0
  !
  ! We are in Jy, so this is simple
  factor = 1.0
  !
  call sic_parsef(uvmodel,huvm%file,' ','.uvt')
  huvm%gil%dim(1) = 7+3*nf
  huvm%gil%ref(1)  = 1.0
  huvm%gil%val(1)  = freq
  huvm%gil%inc(1)  = fres
  huvm%gil%freq  = freq
  !
  allocate (uvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  nt = huvm%gil%dim(1)
  nv = huvm%gil%dim(2)
  mt = huvd%gil%dim(1)
  call copyuv (nt,nv,uvm,mt,uvd)
  deallocate (uvd)
  !
  ! OK, compute the model
  call do_model(uvm, nt, nv,   &
       &    fft,nx,ny,nf,freq,xinc,yinc,factor)
  !
  call gdf_write_image(huvm,uvm,error)
  call gagout('S-UV_FCCT,  Successful completion')
  call gag_cpu(cpu1)
  error = .false.
  return
  !
999 error = .true.
  return
end subroutine uv_auto_model
!<FF>
subroutine do_model (visi,nc,nv,a,nx,ny,nf,   &
     &    freq,xinc,yinc,factor)
  integer, intent(in) :: nc                     !
  integer, intent(in) :: nv                     !
  real, intent(inout) :: visi(nc,nv)            !
  integer, intent(in) :: nx                     !
  integer, intent(in) :: ny                     !
  integer, intent(in) :: nf                     !
  complex, intent(in) :: a(nx,ny,nf)            !
  real(8), intent(in) :: freq                   !
  real(8), intent(in) :: xinc                   !
  real(8), intent(in) :: yinc                   !
  real, intent(in) :: factor                    !
  ! Local
  real(kind=8), parameter :: clight=299792458d0
  real(kind=8) :: kwx,kwy,stepx,stepy,lambda,bfin(2),xr,yr
  complex(kind=8) :: aplus,amoin,azero,afin
  integer :: i,if,ia,ja
  logical :: inside
  equivalence (afin,bfin)
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  do i = 1, nv
     kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
     kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
     ia = int(kwx)
     ja = int(kwy)
     inside = (ia.gt.1 .and. ia.lt.nx) .and.   &
          &      (ja.gt.1 .and. ja.lt.ny)
     if (inside) then
        xr = kwx - ia
        yr = kwy - ja
        do if=1,nf
           !
           ! Interpolate (X or Y first, does not matter in this case)
           aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
                &          - 2.d0*a(ia,ja+1,if) )*xr   &
                &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
                &          + a(ia,ja+1,if)
           azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
                &          - 2.d0*a(ia,ja,if) )*xr   &
                &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
                &          + a(ia,ja,if)
           amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
                &          - 2.d0*a(ia,ja-1,if) )*xr   &
                &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
                &          + a(ia,ja-1,if)
           ! Then Y (or X)
           afin = ( (aplus+amoin-2.d0*azero)   &
                &          *yr + aplus-amoin )*yr*0.5d0 + azero
           !
           visi(5+3*if,i) =  bfin(1)*factor
           ! There was a - sign in the precedent version
           visi(6+3*if,i) =  bfin(2)*factor
        enddo
     else
        print *,'Error Visi ',i,ia,nx,ja,ny
     endif
  enddo
end subroutine do_model
!<FF>
subroutine do_fft (nx,ny,nf,fft,work)
  integer, intent(in)  :: nx                     !
  integer, intent(in)  :: ny                     !
  integer, intent(in)  :: nf                     !
  complex, intent(inout) :: fft(nx,ny,nf)
  real, intent(inout)  :: work(2*max(nx,ny))
  ! Local
  integer :: if,dim(2)
  !
  ! Loop on channels
  dim(1) = nx
  dim(2) = ny
  do if = 1, nf
     call fourt(fft(:,:,if),dim,2,1,1,work)
     call recent(nx,ny,fft(:,:,if))
  enddo
end subroutine do_fft
!<FF>
subroutine copyuv (nco,nv,out,nci,in)
  integer, intent(in)  :: nco                    !
  integer, intent(in)  :: nv                     !
  real, intent(out)  :: out(nco,nv)              !
  integer, intent(in) :: nci                     !
  real, intent(in)  :: in(nci,nv)                !
  ! Local
  integer :: i,j
  do i=1,nv
     do j=1,7
        out(j,i) = in(j,i)
     enddo
     do j=8,nco,3
        out(j,i) = 0
        out(j+1,i) = 0
        out(j+2,i) = in(10,i)
     enddo
  enddo
end subroutine copyuv
!<FF>
subroutine recent(nx,ny,z)
  !---------------------------------------------------------------------
  ! Recenters the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer, intent(in)  :: nx                     !
  integer, intent(in)  :: ny                     !
  complex, intent(inout)  :: z(nx,ny)               !
  ! Local
  integer :: i, j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i+nx/2,j+ny/2)
      z(i+nx/2,j+ny/2) = z(i,j)
      z(i,j) = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp = z(i,j+ny/2)
      z(i,j+ny/2) = z(i+nx/2,j)
      z(i+nx/2,j) = tmp
    enddo
  enddo
  !
  do j=1,ny
    do i=1,nx
      if (mod(i+j,2).ne.0) then
         z(i,j) = -z(i,j)
      endif
    enddo
  enddo
end subroutine recent
!<FF>
subroutine plunge_real (r,nx,ny,c,mx,my,nf)
  !---------------------------------------------------------------------
  !     Plunge a Real array into a Complex array
  !---------------------------------------------------------------------
  integer, intent(in)  :: nx                     ! Size of input array
  integer, intent(in)  :: ny                     ! Size of input array
  integer, intent(in)  :: nf                     !
  real, intent(in)  :: r(nx,ny,nf)               ! Input real array
  integer, intent(in)  :: mx                     ! Size of output array
  integer, intent(in)  :: my                     ! Size of output array
  complex, intent(inout)  :: c(mx,my,nf)         ! Output complex array
  ! Local
  integer :: kx,ky,lx,ly
  integer :: i,j,k
  !
  kx = nx/2+1
  lx = mx/2+1
  ky = ny/2+1
  ly = my/2+1
  !
  do k=1,nf
     do j=1,my
        do i=1,mx
           c(i,j,k) = 0.0
        enddo
     enddo
     do j=1,ny
        do i=1,nx
           c(i-kx+lx,j-ky+ly,k) = cmplx(r(i,j,k),0.0)
        enddo
     enddo
  enddo
end subroutine plunge_real
!
subroutine cct_def_image (hima,mx,my,nf,freq,xinc,yinc,error)
  use image_def
  type (gildas) :: hima
  integer, intent(out) :: mx,my,nf
  real(8), intent(out) :: freq
  real(8), intent(out) :: xinc,yinc
  logical, intent(out) :: error
  !
  error = .false.
  if (hima%char%code(3).eq.'COMPONENT') then
     call gagout('I-UV_FCCT,  Clean Components from MAPPING')
     nf = hima%gil%dim(2)  ! Number of channels
     mx = (hima%gil%ref(1)-1)*2
     xinc = hima%gil%inc(1)
     my = (hima%gil%ref(3)-1)*2
     yinc = hima%gil%inc(3)
     ! Define observing frequency
     freq = hima%gil%freq + hima%gil%fres*((nf+1)*0.5-hima%gil%ref(2))
  else
     call gagout('I-UV_FCCT,  Clean Components from Task CLEAN')
     nf = hima%gil%dim(3)
     mx = (hima%gil%ref(1)-1)*2
     xinc = hima%gil%inc(1)
     my = (hima%gil%ref(2)-1)*2
     yinc = hima%gil%inc(2)
     freq = hima%gil%freq + hima%gil%fres*((nf+1)*0.5-hima%gil%ref(3))
  endif
end subroutine cct_def_image
!
subroutine cct_set_image (hima,clean,mx,my,mc,xinc,yinc,nf,image,error)
  use image_def
  type (gildas) :: hima
  real clean(hima%gil%dim(1),hima%gil%dim(2),hima%gil%dim(3))
  integer, intent(in) :: mx,my,nf
  integer, intent(in) :: mc
  real(8), intent(in) :: xinc,yinc
  real, intent(out) :: image(mx,my,nf)
  logical, intent(out) :: error
  !
  integer lc,nc,kc
  integer ic,jf
  integer ix,iy
  !
  image = 0
  if (hima%char%code(3).eq.'COMPONENT') then
    lc = hima%gil%dim(1)
    nc = hima%gil%dim(2)  ! Number of channels
    if (nc.ne.nf) then
      Print *,'Channel mismatch ',nc,nf
      error = .true.
      return
    endif
    if (mc.eq.0) then
      kc = hima%gil%dim(3)  ! Number of components
    else
      kc = min(mc,hima%gil%dim(3))
    endif
    !
    do jf = 1,nf
      do ic = 1,kc
        if (clean(3,jf,ic).ne.0) then
          ix = nint(clean(1,jf,ic)/xinc)+mx/2+1
          iy = nint(clean(2,jf,ic)/yinc)+my/2+1
          image(ix,iy,jf) = image(ix,iy,jf) + clean(3,jf,ic)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  else
    lc = hima%gil%dim(1)
    if (mc.eq.0) then
      kc = hima%gil%dim(2)  ! Number of components
    else
      kc = min(mc,hima%gil%dim(2))
    endif
    nc = hima%gil%dim(3)
    if (nc.ne.nf) then
      Print *,'Channel mismatch ',nc,nf
      error = .true.
      return
    endif
    do jf = 1,nf
      do ic = 1,kc
        if (clean(1,ic,jf).ne.0) then
          ix = nint(clean(2,ic,jf))
          iy = nint(clean(3,ic,jf))
          image(ix,iy,jf) = image(ix,iy,jf) + clean(1,ic,jf)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  endif
end subroutine cct_set_image
!
end program uv_fast_ccmodel

!-----------------------------------------------------------------------
! General remark on several routines in that file:
!  - I do not understand why calls to GTX_PEN have been suppressed.
!    It may explain the problems mentionned elsewhere with the "Current
!    Pen" (S.Guilloteau 15-Oct-1992)
!-----------------------------------------------------------------------
subroutine gt_polyl(out,poly)
  use gtv_interfaces, except_this=>gt_polyl
  use gtv_protocol
  use gtv_graphic
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Generic routine: draw the input polyline in the display 'out',
  ! whereever this polyline comes from.
  !---------------------------------------------------------------------
  type(gt_display),  intent(inout) :: out   ! Input gt_display
  type(gt_polyline), intent(in)    :: poly  ! The polyline instance
  ! Local
  integer :: k,c0,c1,c,cold
  real :: x,y,x0,y0,x1,y1
  real*4 :: gx1,gx2,gy1,gy2
  ! Petite modif pour examiner avec dbx le contenu des tableaux
  logical :: up
  !
  if (.not.awake .or. error_condition) return
  ! call gtx_pen(out,ipenx_i)
  !
  ! No device selected
  if (out%dev%protocol.eq.p_null)  return
  !
  if (associated(poly%penlut)) then
    ! LUT STATIC:
    ! Load the appropriate pen into the device
    call gtx_pen(out,out%icolou,poly%penlut)
  endif
  !
  gx1 = out%gx1
  gx2 = out%gx2
  gy1 = out%gy1
  gy2 = out%gy2
  !
  ! End-points of line are (X0,Y0), (X1,Y1)
  x0 = poly%x(1)
  y0 = poly%y(1)
  call gtx_clip(out,x0,y0,c0)
  up = .true.
  !
  ! Loop on points
  ! Change the end-points of the line (X0,Y0) - (X1,Y1)
  ! to clip the line at the window boundary.
  ! The algorithm is that of Cohen and Sutherland (ref: Newman & Sproull)
  !
  do k=2,poly%n
    x1 = poly%x(k)
    y1 = poly%y(k)
    call gtx_clip(out,x1,y1,c1)
    cold = c1
    !
    do while (ior(c0,c1).ne.0)
      if (iand(c0,c1).ne.0) goto 100   ! line is invisible
      if (c0.eq.0) then
        c = c1
      else
        c = c0
      endif
      if (iand(c,1).ne.0) then ! crosses GX1
        y = y0 + (y1-y0)*(gx1-x0)/(x1-x0)
        x = gx1
      elseif (iand(c,2).ne.0) then ! crosses GX2
        y = y0 + (y1-y0)*(gx2-x0)/(x1-x0)
        x = gx2
      elseif (iand(c,4).ne.0) then ! crosses GY1
        x = x0 + (x1-x0)*(gy1-y0)/(y1-y0)
        y = gy1
      elseif (iand(c,8).ne.0) then ! crosses GY2
        x = x0 + (x1-x0)*(gy2-y0)/(y1-y0)
        y = gy2
      endif
      if (c.eq.c0) then
        x0 = x
        y0 = y
        call gtx_clip(out,x,y,c0)
      else
        x1 = x
        y1 = y
        call gtx_clip(out,x,y,c1)
      endif
    enddo
    !
    ! Selon les protocoles, le travail est different.
    ! Il y a les protocoles intelligent capables de faire du dash et des
    ! largeurs de trait et les autres. Pour les premiers, les parametres
    ! de dash et largeur ont deja ete fixe au moment du set_attributs(...)
    ! une ligne simple suffira dans tous les cas.
    !
    ! Plot the line : Pen up to X0,Y0 then pen down to X1,Y1
    !
    if (user_hardw_line .and.  &
      out%dev%hardw_line_weig .and. out%dev%hardw_line_dash) then
      ! No chopper needed, device knows how to produce width and dash
      if (up) then
        call gtx_plot(out,x0,y0,3)
        call gtx_plot(out,x1,y1,2)
      else
        call gtx_plot(out,x1,y1,2)
      endif
    else
      ! Simulate thickness and/or dash with several lines
      call gtx_chopper(out,x0,y0,x1,y1,up)
    endif
    !
    ! End of loop
100 c0 = cold
    x0 = poly%x(k)                 ! and not X1
    y0 = poly%y(k)                 ! and not Y1
    up = cold.ne.0
  enddo
  !
end subroutine gt_polyl
!
subroutine gtx_clip(out,x,y,c)
  use gtv_interfaces, except_this=>gtx_clip
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Routine for the clipping algorithm; called from GTI_CLIP only. C
  ! is a 4 bit code indicating the relationship between point (X,Y) and
  ! the window boundaries; 0 implies the point is within the window.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: out  ! Input gt_display
  real*4,           intent(in)  :: x    !
  real*4,           intent(in)  :: y    !
  integer,          intent(out) :: c    !
  !
  c = 0
  if (x.lt.out%gx1) then
    c = 1
  elseif (x.gt.out%gx2) then
    c = 2
  endif
  if (y.lt.out%gy1) then
    c = c+4
  elseif (y.gt.out%gy2) then
    c = c+8
  endif
  !
end subroutine gtx_clip

subroutine pdbi_spectral(line,error)
  use gkernel_interfaces
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine, support for command
  !	SPECTRAL iunit bandwidth frequency /NARROW i
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  logical :: bad, update
  integer(kind=4) :: iunit, iband, ii, bandmode, nc, nk
  real(kind=4) :: flo3, x4, y4, rf
  real(kind=8) :: xu, yu
  character(len=1) :: code
  character(len=13) :: rname
  data rname /'PDBI_SPECTRAL'/
  character(len=3) :: bmode(4), arg, arg2
  data bmode /'LSB','USB','SSB','DSB'/
  ! ---------------------------------------------------------------------------
  !
  ! NARROW entries must have been defined
  !
  if (.not.narrow_def) then
     call astro_message(seve%e,rname,'NARROW entries not defined')
     error = .true.
     return
  endif
  !
  ! Unit
  !
  call sic_i4 (line,0,1,iunit,.true.,error)
  if (error) return
  if (iunit.lt.1 .or. iunit.gt.8) then
    call astro_message(seve%e,rname,'Invalid correlator unit number ')
    error = .true.
    return
  endif
  !
  ! SPECTRAL i OFF
  !
  if (sic_present(0,2)) then
     call sic_ke(line,0,2,arg,nc,.true.,error)
     if ((arg.eq.'OFF').or.(arg.eq.'off')) then
        unit_def(iunit) = .false.
        call pdbi_plot_line(error)
        return
     endif
  endif
  !
  ! Defaults
  !
  if (unit_def(iunit)) then
     iband = unit_band(iunit)
     flo3 = unit_cent(iunit)
     ii = unit_wind(iunit)
  else
     iband = 80
  endif
  !
  ! Bandwidth
  !
  if (sic_present(0,2)) then
     call sic_i4(line,0,2,iband,.true.,error)
     if (error) return
     if (iband.ne.20 .and. iband.ne.40 .and. iband.ne.80 .and. iband.ne.160   &
          .and. iband.ne.320) then
        call astro_message(seve%e,rname,'Invalid bandwidth ')
        error = .true.
        return
     endif
  endif
  !
  ! Center frequency & narrow entry
  !
  if (sic_present(0,3)) then
     !
     ! From the command line
     !
     if (sic_present(1,0)) then
	!
	! option /NARROW
	!
     	call sic_r4(line,0,3,flo3,.true.,error)
     	if (error) return
       	if (flo3.lt.100 .or. flo3.gt.1100) then
           call astro_message(seve%e,rname,'Invalid center frequency ')
           error = .true.
           return
        endif
        !      IF (FLO3.LT.(IFLIM(1)+IBAND/2) .OR.
        !     &     FLO3.GT.(IFLIM(2)-IBAND(2))) THEN
        !         CALL GAGOUT('W-LINE/SPECTRAL,  Center freq. too close
        !     &        from edge of receiver band')
        !      ENDIF
        flo3 = 0.625*nint(flo3/0.625)
        !
        ! Correlator entry
        !
        call sic_i4(line,1,1,ii,.true.,error)
        if (error) return
        if ((ii.ne.1).and.(ii.ne.2)) then
           call astro_message(seve%e,'SPECTRAL','Unknown correlator entry')
           error = .true.
           return
        endif
	!
     elseif (sic_present(4,0)) then
	!
	! Option /RF
	!
     	call sic_r4(line,0,3,rf,.true.,error)
	call if3fromrf(flo3,ii,rf,error)
	if (error) then
	   call astro_message(seve%e,'SPECTRAL','RF frequency not observed')
	   return
        endif
	!
     else
	!
	! Need /NARROW or /RF
	!
        call astro_message(seve%e,rname,'/NARROW or /RF options mandatory')
        error = .true.
        return
     endif
     !
  else
     !
     ! Interactive definition with the cursor
     !
     ! plot_mode must be 2
     !
     if (plot_mode.ne.2) then
        plot_mode = 2
        call pdbi_plot_def(error)
        if (error) return
        call pdbi_plot_line(error)
     endif
     call gr_exec1('LIMITS 100 1100 0 5')  !  force IF3 limits
     !
     ! Update spectral plot, to have selected unit in dash
     !
     call gt_clear_segment('SPECTRAL',.false.,error)
     call pdbi_plot_spectral(1,iunit)
     call pdbi_plot_spectral(2,iunit)
     call gr_exec1('PEN 0')
     !
     ! Loop on cursor output
     !
     code = ' '
     call astro_message(seve%i,rname,'Interactive definition of the spectral unit')
     call astro_message(seve%r,rname,'    Left click to define position / narrow input')
     call astro_message(seve%r,rname,'    + to increase bandwidth')
     call astro_message(seve%r,rname,'    - to decrease bandwidth')
     call astro_message(seve%r,rname,'    > to shift position by 5 MHz (increase IF)')
     call astro_message(seve%r,rname,'    < to shift position by 5 MHz (decrease IF)')
     call astro_message(seve%r,rname,'    E to exit')
     !
     do while (code.ne.'E')
        !
        update = .false.
        call gr_curs (xu, yu, x4, y4, code)
        !
        if (code.eq.'^') then
           !
           ! Left click : define central frequency & narrow entry
           !
           update = .true.
           if ((xu.gt.(100+iband/2)).and.(xu.lt.(1100-iband/2))) then
              flo3 = xu
           else
              call astro_message(seve%e,rname,'Spectral window must fit in the IF band')
              update = .false.
           endif
           !
           ! Narrow entry
           !
           if ((yu.ge.0).and.(yu.le.5)) then
              ii = 2
           elseif ((yu.ge.7.75).and.(yu.le.12.75)) then
              ii = 1
           else
              call astro_message(seve%e,rname,'Please select one of the NARROW entries')
              update = .false.
           endif
        else
	   !
	   ! Too lazy to use SHIFT
           !
	   if (code.eq.'=') code = '+'
	   if (code.eq.',') code = '<'
	   if (code.eq.'.') code = '>'
           !
           ! Move/expand unit
           !
           if ((code.eq.'+').and.(iband.ne.320)) iband = iband*2
           if ((code.eq.'-').and.(iband.ne.20)) iband = iband/2
           if (code.eq.'<') flo3 = flo3-5
           if (code.eq.'>') flo3 = flo3+5
           update = .true.
           if ((code.ne.'+').and.(code.ne.'-').and.(code.ne.'<') &
                .and.(code.ne.'>')) update = .false.
        endif
        !
        ! Update plot
        !
        if (update) then
           plot_mode = 2
           unit_def(iunit) = .true.
           unit_band(iunit) = iband     ! width
           unit_cent(iunit) = flo3      ! center IF
           unit_wind(iunit) = ii        ! correlator input
           !
	   call gt_clear_segment('SPECTRAL',.false.,error)
           call pdbi_plot_spectral(1,iunit)
           call pdbi_plot_spectral(2,iunit)
           call gr_exec1('PEN 0')
        endif
     enddo
  endif
  !
  ! /BAND option
  !
  bandmode = 1                 ! Default is LSB
  if (iband.eq.320) bandmode = 4   ! DSB for 320 MHz bands
  if (sic_present(2,0)) then
    call sic_ke(line,2,1,arg,nc,.true.,error)
    call sic_ambigs(rname,arg,arg2,nk,bmode,4,error)
    if (error) then
      call astro_message(seve%e,'SPECTRAL', 'Unknown /BAND mode')
      return
    endif
    bad = .false.
    bad = ((iband.eq.20).or.(iband.eq.40)).and.(nk.gt.3)
    bad = bad.or.((iband.eq.320).and.(nk.lt.4))
    if (bad) then
      call astro_message(seve%e,'SPECTRAL','Incompatible unit width and '//  &
      'SSB/DSB mode')
      error = .true.
      return
    endif
    bandmode = nk
  endif
  !
  ! Store values
  !
  unit_def(iunit) = .true.
  unit_band(iunit) = iband     ! width
  unit_cent(iunit) = flo3      ! center IF
  unit_wind(iunit) = ii        ! correlator input
  unit_bmode(iunit) = bandmode ! ssb/dsb mode
  !
  ! Now do the plot
  !
  plot_mode = 2
  call pdbi_plot_line(error)
  !
  1010 format('  Unit ',i1,i4,f8.2,' on entry ',i1)
  1020 format('  Unit ',i1,' OFF')
end subroutine pdbi_spectral
!
! -------------------------------------------------------------------------
!
subroutine pdbi_plot_spectral(window,specialunit)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4) :: window         !
  integer(kind=4) :: specialunit    !
  ! Local
  integer(kind=4) :: i, j, iband
  real(kind=4) :: x(8),y(8), flo3, z(8), edge
  logical :: error
  data z/0.0,2.0,2.0,0.0,2.5,2.0,2.0,0.0/
  !
  if (window.eq.1) then
     call gr_exec1('PEN 1 /DASH 1')
     call gr_exec1('SET BOX 4 29 11.5 17')
  else
     call gr_exec1('PEN 3 /DASH 1')
     call gr_exec1('SET BOX 4 29 3 8.5')
  endif
  !
  do i=1,nunit
    !
    ! Spectral band must have been defined AND connected to
    ! the correct correlator input = 'window'
    !
    if (unit_def(i).and.(window.eq.unit_wind(i))) then
      !
      iband = unit_band(i)
      flo3 =  unit_cent(i)
      !
      ! Box size depends on unit
      !
      do j=1,8
        y(j) = (1.0+0.05*(i-1))*z(j)
      enddo
      !
      ! Special unit in dash
      !
      if (i.eq.specialunit) then
         call gr_exec1('PEN /DASH 3')
      endif
      call gr_segm('SPECTRAL',error)
      !
      ! Consider a 5% loss at the filter's edge
      ! Draw a vertical line at the band center (Gibbs) if necessary, ie if
      ! the unit is in DSB mode (only possible on 80, 160, 320 MHz units)
      !
      edge = iband*0.05
      if (unit_bmode(i).eq.4) then
        x(1) = flo3+0.5*iband
        x(2) = flo3+0.5*iband-1.0*edge
        x(3) = flo3
        x(4) = flo3
        x(5) = flo3
        x(6) = flo3
        x(7) = flo3-0.5*iband+1.0*edge
        x(8) = flo3-0.5*iband
        call gr4_connect(8,x,y,0.0,-1.0)
        ! write(chain,100) x(5),y(5)+0.5,i
        ! call gr_exec1(chain)
      else
        x(1) = flo3+0.5*iband
        x(2) = flo3+0.5*iband-1.0*edge
        x(3) = flo3-0.5*iband+1.0*edge
        x(4) = flo3-0.5*iband
        call gr4_connect(4,x,y,0.0,-1.0)
      endif
      call gr_segm_close(error)
      call gr_exec1('PEN /DASH 1')
    endif
  enddo
  !
  100 format('DRAW TEXT ',f10.2, f10.2, i2, ' /USER')
end subroutine pdbi_plot_spectral
!
! ---------------------------------------------------------------------------
!
subroutine find_rffreq(i,f)
  use gbl_message
  use ast_line
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine
  !       Find sky frequency associated to the center of subband i
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: i  !
  real(kind=8), intent(out) :: f    !
  ! Local
  real(kind=8) :: bandwidth, center, ifmin, ifmax, tmp
  integer(kind=4) :: inp
  real(kind=8) :: f1, f2
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  ! ---------------------------------------------------------------------------
  !
  ! Narrow input
  !
  inp = unit_wind(i)
  !
  ! First IF limits
  !
  ifmin = qlim(1,narrow_input(inp))
  ifmax = qlim(2,narrow_input(inp))
  bandwidth = abs(ifmax-ifmin)/1000.
  center = ifmin+(ifmax-ifmin)/2.
  !
  ! RF axis
  !
  if (sky.eq.1) then           ! USB
    f1 = (flo1+center)/1000.d0/fshift-bandwidth/2.
    f2 = f1+bandwidth
  else                         ! LSB
    f1 = (flo1-center)/1000.d0/fshift+bandwidth/2.
    f2 = f1-bandwidth
  endif
  ! IF in Q2 and Q4 is flipped wrt the RF frequency
  if ((narrow_input(inp).eq.2).or.(narrow_input(inp).eq.4)) then
    tmp = f1
    f1 = f2
    f2 = tmp
  endif
  !
  ! Compute rest frequency at center of subband i
  ! F1 corresponds to IF=100, F2 to IF=1100. But depending on LSB/USB
  ! tuning and on selected quarter, F1 can be > or < F2.
  !
  if (f1.lt.f2) then
    f = f1*1000 + (unit_cent(i) - 100)
  else
    f = f1*1000 - (unit_cent(i) - 100)
  endif
  !
end subroutine find_rffreq
!
subroutine if3fromrf(if3,narrow,rf,error)
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! Compute IF3 from RF
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: if3        !
  integer(kind=4), intent(out) :: narrow  !
  real(kind=4), intent(in) :: rf          !
  logical, intent(out) :: error           !
  ! Local
  real(kind=4) :: if1
  integer(kind=4) :: quarter, i, goodquarter
  logical :: foundentry
  real(kind=4) :: qlim(2,4)
  data qlim/4200,5200,5000,6000,6000,7000,6800,7800/
  !
  ! First IF (in MHz)
  if1 = (rf*1000.-flo1)/sky
  !
  ! Find good quarter
  do i = 1,4
    if (if1.gt.qlim(1,i) .and. if1.lt.qlim(2,i)) goodquarter = i
  enddo
  !
  ! Special case for the Q1/Q2 and Q3/Q$ overlap
  if (if1.gt.5000 .and. if1.lt.5200 .and. (narrow_input(1)*narrow_input(2)).eq.2) then
     if (if1.lt.5100) goodquarter = 1
     if (if1.ge.5100) goodquarter = 2
  endif
  if (if1.gt.6800 .and. if1.lt.7000 .and. (narrow_input(1)*narrow_input(2)).eq.12) then
     if (if1.le.6800) goodquarter = 3
     if (if1.gt.6800) goodquarter = 4
  endif
  !
  ! Correlator entry?
  foundentry = .false.
  do i = 1,2 ! loop on correlator entries
     if (narrow_input(i).eq.goodquarter) then
	!
	narrow = i 		   ! corr entry 1-2
	quarter = narrow_input(i)  ! quarter 1-4
	!
	! Compute IF3
	if (quarter.eq.2 .or. quarter.eq.4) then
     	   if3 = 1100 - (if1-qlim(1,quarter))
        else
           if3 = 100 + (if1-qlim(1,quarter))
        endif
	!
	foundentry = .true.
     endif
  enddo
  !
  error = .not.foundentry
end subroutine if3fromrf

!
! The Whole "fast" way has been re-written in Block Mode like 
! the one_beam.f90 code,  in command-uv-map.f90.
!
! As written below here, it uses vast amounts of memory and
! induces paging for large number of channels, but is used as a 
! reference for development
!
subroutine uv_restore(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_restore
  use clean_def
  use clean_arrays
  use clean_types
  use mapping_default_types
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for routine UV_RESTORE
  !     Restore a Clean map from a CLIC UV Table and a list of Clean
  !     Components, by Gridding and Fast Fourier Transform, using adequate
  !     scratch space for optimisation. Will work for
  !     up to 128x128x128 cube data size, may be more...
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     (optionally) a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !     a beam image or cube
  !     a LMV-CLEAN cube
  !     a LMV-RES cube
  !
  ! To work, it would require
  !  1) to have the Pixel definition stored with the TCC Clean Component
  !     structure
  !  2) to re-use this pixel definition for the Images to be created
  !     Images may be different, but this would create some inconsistencies,
  !     which are perhaps not dramatic since the subtraction is in the UV
  !     plane.
  !
  ! Here, for the time being, I assume that the pixel of the TCC are
  ! the same as defined by the current imaging characteristics.
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  character(len=*), parameter :: task='UV_RESTORE'
  !
  type (gildas) :: mybeam
  real, allocatable, target :: mybeamdata(:,:,:)
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  real(8) :: new(3), freq
  real(4) rmega,uvmax,uvmin
  integer wcol,mcol(2),nfft,sblock
  integer n,ier
  logical one, sorted, shift
  character(len=24) ra_c,dec_c
  character(len=message_length) :: chain
  character(len=12) save_method
  real cpu0, cpu1
  real uvma
  real, allocatable :: fft(:)
  real, allocatable :: ouv(:,:)
  type (cct_par), allocatable :: p_cct(:)
  real, pointer :: p_resid(:,:), p_clean(:,:)
  integer iplane, i, niter
  integer nx,ny,nu,nv,nc,nb
  !
  type(gildas) :: occt
  real, pointer :: ccou(:,:,:)
  integer mic, maxic
  logical comp,fast
  !
  ! Still to be done
  !1) What happens if no DIRTY image is there (only a CCT and UV ?)
  !   This can't be for now, as we cannot reload a CCT, but beware...
  !
  !
  if (method%method.ne.'CLARK' &
       & .and. method%method.ne.'HOGBOM' &
       & .and. method%method.ne.'SDI'    &
       & .and. method%method.ne.'MULTI'  &
       & .and. method%method.ne.'MX' ) then
    Call map_message(seve%e,task,'Unsupported Clean Method '//method%method)
    error = .true.
    return
  endif
  !
  call map_prepare(task,themap,error)
  if (error) return
  !
  one = .true.
  call sic_get_inte('WCOL',wcol,error)
  call sic_get_inte('MCOL[1]',mcol(1),error)
  call sic_get_inte('MCOL[2]',mcol(2),error)
  !
  call sic_get_logi('UV_SHIFT',shift,error)
  if (shift) then
    call sic_get_char('MAP_RA',ra_c,n,error)
    call sic_get_char('MAP_DEC',dec_c,n,error)
    call sic_get_dble('MAP_ANGLE',new(3),error)
  endif
  !
  ! First sort the input UV Table, leaving UV Table in UV_*
  if (shift) then
    call sic_decode(ra_c,new(1),24,error)
    if (error) then
      call map_message(seve%e,task,'Input conversion error on phase center')
      return
    endif
    call sic_decode(dec_c,new(2),360,error)
    if (error) then
      call map_message(seve%e,task,'Input conversion error on phase center')
      return
    endif
    new(3) = new(3)*pi/180.0d0
  endif
  call gag_cpu(cpu0)
  call uv_sort (error,sorted,shift,new,uvmax,uvmin)
  if (error) return
  call gag_cpu(cpu1)
  write(chain,102) 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Set default according to DIRTY image
  if (themap%size(1).eq.0) themap%size(1) = hdirty%gil%dim(1)
  if (themap%size(2).eq.0) themap%size(2) = hdirty%gil%dim(2)
  if (themap%xycell(1).eq.0) themap%xycell(1) = abs(hdirty%gil%convert(3,1))*180*3600/pi
  if (themap%xycell(2).eq.0) themap%xycell(2) = abs(hdirty%gil%convert(3,2))*180*3600/pi
  !
  ! Fill other defaults
  call map_parameters(task,themap,freq,uvmax,uvmin,error) ! huv%gil%majo)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  ! Check if any beam change
  ! CAUTION: this precludes re-using imported CCT, Beam and Dirty images
  !   to restore the Clean image later...
  ! If we want to instate this possibility, a warning should be given then.
  ! Also, the beam fit should be redone in this case.
  !
  if (map_version.lt.0) then
    if (do_weig) then
      call map_message(seve%e,task, &
            & 'Weighting scheme has changed, re-image and clean first')
      error = .true.
      return
    endif
  endif
  !
  ! Redefine some parameters
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  !
  nx = themap%size(1)
  ny = themap%size(2)
  !
  ! Now compare with "dirty" image
  if (nx.ne.hdirty%gil%dim(1).or.ny.ne.hdirty%gil%dim(2).or. &
     &  abs(themap%xycell(1)-abs(hdirty%gil%convert(3,1)))/themap%xycell(1).gt.1e-5 .or. &
     &  abs(themap%xycell(2)-abs(hdirty%gil%convert(3,2)))/themap%xycell(2).gt.1e-5) then
    call map_message(seve%e,task, &
        & 'Mismatch between Dirty image and Restored image')
    error = .true.
    return
  endif
  !
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  nc = huv%gil%nchan !! (nu-7)/3
  !
  if (do_weig) then
    if (allocated(g_weight)) deallocate(g_weight)
    if (allocated(g_v)) deallocate(g_v)
    allocate(g_weight(nv),g_v(nv),stat=ier)
    if (ier.ne.0) goto 98
  endif
  !
  rmega = 8.0
  ier = sic_ramlog('SPACE_MAPPING',rmega)
  sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  !
  !
  ! New residual image
  hresid = hdirty
  !
  ! Subtract all Clean Components
  if (.not.associated(duv)) then
    call map_message(seve%e,task,'UV data DUV is not allocated')
    error = .true.
    return
  endif
  if (.not.allocated(dcct)) then
    call map_message(seve%e,task,'Clean component table DCCT is not allocated')
    error = .true.
    return
  endif
  !
  maxic = hcct%gil%dim(3)
  call sic_i4(line,0,1,maxic,.false.,error)
  if (error) return
  if (maxic.lt.0) maxic = hcct%gil%dim(3)
  maxic = min(hcct%gil%dim(3),maxic)
  !
  comp = .true.
  call sic_get_logi('COMPACT',comp,error)
  call gildas_null (occt)
  call gdf_copy_header(hcct,occt, error) ! Copy headers
  if (comp) then
    call uv_clean_size(hcct,dcct,mic)
    if (mic.eq.0) then
      call map_message(seve%w,task,'No valid Clean Component')
      error = .true.
      return
    endif
    mic = min(mic,maxic)
    occt%gil%dim(3) = mic
    allocate(ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3)),stat=ier)
    if (ier.ne.0) call map_message(seve%i,task,'Component Allocation error')
    if (ier.ne.0) goto 98
    call uv_compact_clean(hcct,dcct,occt,ccou, mic)
    !!print *,'MIC ',mic
    call gag_cpu(cpu1)
    write(chain,102) 'Finished compacting Clean ',cpu1-cpu0
    call map_message(seve%i,task,chain)
  else
    occt%gil%dim(3) = maxic
    ccou => dcct
  endif
  !
  !
  allocate (ouv(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%i,task,'UV Allocation error')
    goto 98
  endif
  fast = .true.
  call sic_get_logi('FAST',fast,error)
  !
  ! Define observing frequency (in MHz)
  ier = gdf_range(mcol,huv%gil%nchan)
  freq = gdf_uv_frequency(huv,0.5d0*(mcol(1)+mcol(2)))
  if (fast) then
    print *,'Fast subtract '
    call uv_subtfast_clean(huv,duv,ouv,occt,ccou,hdirty,freq,cpu0)
  else
    print *,'Slow subtract '
    call uv_subtract_clean(huv,duv,ouv,occt,ccou,freq)
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished Subtract Clean ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Prepare the Dirty(=Residual) image
  if (allocated(dclean)) deallocate(dclean)
  call sic_delvariable ('CLEAN',.false.,error)
  hclean%loca%size = 0
  !
  if (allocated(dresid)) deallocate(dresid)
  call sic_delvariable ('RESIDUAL',.false.,error)
  hresid%loca%size = 0
  ! Reset RESIDUAL and CLEAN, BUT NOT CCT
  !
  allocate(dresid(nx,ny,nc),stat=ier)
  if (ier.ne.0) then
     print *,'Error allocating DRESID ',ier
  endif
  dresid = 0
  call sic_mapgildas('RESIDUAL',hresid,error,dresid)
  hresid%r3d => dresid
  hresid%loca%size = nx*ny*nc
  !
  allocate(dclean(nx,ny,nc),stat=ier)
  if (ier.ne.0) then
     call map_message(seve%i,task,'Clean image Allocation error')
     goto 98
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished allocating Clean ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Find out how many beams are required
  call map_beams(task,themap%beam,huv,nx,ny,nb,nc)
  !
  ! Process sorted UV Table according to the number of beams produced
  if (map_version.lt.0) then
    ! New Beam place
    call gildas_null (mybeam, type = 'IMAGE')
    call map_message(seve%i,task,'Producing a single beam for all channels')
    nfft = 2*max(nx,ny)
    allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),fft(nfft),mybeamdata(nx,ny,1),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%i,task,'Beam Allocation error')
      goto 98
    endif
    mybeam%r3d => mybeamdata
    mybeam%gil%ndim = 2
    mybeam%gil%dim(1:3)=(/nx,ny,1/)
    !
    call one_beam (task,themap,   &
       &    huv, mybeam, hresid,   &
       &    nx,ny,nu,nv,     ouv,   &
       &    w_mapu, w_mapv, w_grid, g_weight, g_v, do_weig,  &
       &    wcol,mcol,fft,   &
       &    sblock,cpu0,error,uvma)
  else
    !
    call gildas_null (mybeam, type = 'IMAGE')
    !
    mybeam%gil%ndim = 3
    allocate(mybeamdata(nx,ny,nc),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%i,task,'Beam Allocation error')
      goto 98
    endif
    mybeam%r3d => mybeamdata
    mybeam%gil%ndim = 3
    mybeam%gil%dim(1:3)=(/nx,ny,nc/)
    !
    call many_beams_para (task,themap,   &
       &    huv, mybeam, hresid,   &
       &    nx,ny,nu,nv,    ouv,   &
       &    g_weight, g_v, do_weig,  &
       &    wcol,mcol,sblock,cpu0,error,uvma,0)
  endif
  if (error) then
    call map_message(seve%e,task,'Could not image residual')
    return
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished imaging residuals ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  !call map_message(seve%i,task,'Successful completion')
  !
  call gdf_copy_header(hresid,hclean,error)
  hclean%r3d => dclean
  hclean%loca%size = nx*ny*nc
  call sic_mapgildas('CLEAN',hclean,error,dclean)
  !
  save_data(code_save_beam) = .true.
  save_data(code_save_dirty) = .true.
  !
  !
  ! The dirty is the residual. Create the Clean Map now
  allocate (p_cct(occt%gil%dim(3)),stat=ier)
  !
  save_method = method%method
  method%method = 'RESTORE' ! Generic
  niter = 0
  !
  nullify(p_clean)
  nullify(p_resid)
  !
  do iplane = method%first, method%last
    method%iplane = iplane
    p_resid =>  hresid%r3d(:,:,iplane)
    p_clean =>  hclean%r3d(:,:,iplane)
    !
    ! Recover the component list in pixels
    niter = occt%gil%dim(3)
    !!print *,'Plane ',iplane,' cct size ',niter
    do i=1,occt%gil%dim(3)
      !!print *,'component ',i,ccou(1:3,iplane,i)
      if (ccou(3,iplane,i).eq.0) then
        p_cct(i)%value = 0 ! Required
        niter = i-1
        exit
      else
        !
        ! The NINT is required because of rounding errors
        p_cct(i)%ix = nint( (ccou(1,iplane,i)-hdirty%gil%convert(2,1)) /  &
            &        hdirty%gil%convert(3,1) + hdirty%gil%convert(1,1))
        p_cct(i)%iy = nint( (ccou(2,iplane,i)-hdirty%gil%convert(2,2)) /  &
            &        hdirty%gil%convert(3,2) + hdirty%gil%convert(1,2))
        p_cct(i)%value = ccou(3,iplane,i)
        !!           if (p_cct(i)%ix.gt.nx .or. p_cct(i)%iy.gt.ny .OR. &
        !!               & p_cct(i)%ix.LT.1 .or. p_cct(i)%iy.LT.1) then
        !!              print *,'Out of bound at ',i,p_cct(i)%ix,p_cct(i)%iy,p_cct(i)%value
        !!           endif
      endif
    enddo
    ! Stupid test
    if (niter.gt.0) then
      !!print *,'Restoring ',niter,' component '
      method%n_iter = niter
      call clean_make90(method,hclean,p_clean,p_cct)
      p_clean = p_clean+p_resid
    else
      p_clean = p_resid
    endif
  enddo
  method%method = save_method
  deallocate(p_cct)
  !
  ! Specify clean beam parameters
  hclean%gil%reso_words = 3
  hclean%gil%majo = method%major
  hclean%gil%mino = method%minor
  hclean%gil%posa = pi*method%angle/180.0
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished restoring Clean ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Stupid test also
  !
  IF (SIC_PRESENT(0,2)) DUV(:,:) = OUV(:,:)
  !! DUV = OUV ! This is to test what the residual look like...
  ! in production code, it should NOT be done, since a READ UV is
  ! then required to repeat the job. However, this can be used to
  ! "iterate" a previous clean...
  !
  if (allocated(mybeamdata)) deallocate(mybeamdata)
  deallocate(ouv)
  !
  if (associated(ccou,dcct)) then
    nullify(ccou)
  else if (associated(ccou)) then
    deallocate(ccou)
  endif
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  if (allocated(fft)) deallocate(fft)
  save_data(code_save_clean) = .true.
  hresid%gil%extr_words = 0
  hclean%gil%extr_words = 0
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
  !
102 format(a,f9.2)
end subroutine uv_restore
!
subroutine uv_subtract_clean(huv,duv,ouv,hcct,dcct,freq)
  use image_def
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  !   This version is for CCT tables from MAPPING
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: huv   ! header of UV data set
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: duv(huv%gil%dim(1),huv%gil%dim(2))
  real, intent(out) :: ouv(huv%gil%dim(1),huv%gil%dim(2))
  real, intent(in) :: dcct(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  real(8), intent(in) :: freq       ! Apparent observing frequency
  !
  real(8) :: pidsur            ! 2*pi*D/Lambda
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
  real(8) :: phase
  real(4) :: rvis, ivis
  integer ii, ir
  integer ic,iv,jc
  !
  integer :: nv    ! Number of visibilities
  integer :: mc    ! Number of Clean Components
  integer :: nc    ! Number of Channels
  real(8) :: elapsed_s, elapsed_e, elapsed
  character(80) :: chain
  !
  pidsur = f_to_k * freq
  !
  nv = huv%gil%dim(2)  ! Number of Visibilities
  nc = hcct%gil%dim(2) ! Number of channels
  mc = hcct%gil%dim(3) ! Number of Clean Components
  !
  ! Remove clean component from UV data set
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP    & PRIVATE(iv,jc,ic,ir,ii,phase,rvis,ivis) &
!$OMP    & PRIVATE(elapsed_s,elapsed_e,elapsed,chain)
!
!$ elapsed_s = omp_get_wtime()
!$OMP DO
  do iv=1,nv
    ouv(:,iv) = duv(:,iv)
    ir = 7+1
    ii = 7+2
    do jc = 1,nc
      do ic = 1,mc
        if (dcct(3,jc,ic).ne.0) then
          phase = (ouv(1,iv)*dcct(1,jc,ic) + ouv(2,iv)*dcct(2,jc,ic))*pidsur
          rvis = dcct(3,jc,ic)*cos(phase)
          ivis = dcct(3,jc,ic)*sin(phase)
          ouv(ir,iv) = ouv(ir,iv) - rvis   ! Subtract
          ouv(ii,iv) = ouv(ii,iv) - ivis
        else
          exit ! End of work, jump to next channel
        endif
      enddo
      ir = ir+3
      ii = ii+3
    enddo
  enddo
!$OMP END DO
  !$  elapsed_e = omp_get_wtime()
  elapsed = elapsed_e - elapsed_s
  write(chain,'(a,f9.2,a)') ' Finished Subtract Clean ',elapsed
  call gag_message(seve%i,'SUBTRACT',chain)
!$OMP END PARALLEL
end subroutine uv_subtract_clean
!
subroutine uv_clean_size(hcct,ccin, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compute the actual number of components
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  integer, intent(out) :: mic
  integer :: nc
  integer :: ni, ki, mi
  integer :: i,ic
  !
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mi = 0
  do ic=1,nc
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        ki = i-1
        exit
      endif
    enddo
    !!print *,'Channel ',ic,ki
    if (ki.ne.0) then
      mi = max(mi,ki)
    endif
  enddo
  if (mi.eq.0) mi = ni
  mic = mi
  !!print *,'MIC ',mic
end subroutine uv_clean_size
!
subroutine uv_compact_clean(hcct,ccin,occt,ccou, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compact the component list by summing up all values at the
  !   same position
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  type(gildas), intent(in) :: occt  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  real, intent(out) :: ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3))
  integer, intent(inout) :: mic
  !
  integer nc
  integer ni
  integer :: ii,jj,ic
  integer :: ki, mi ! Number of different components per channel
  logical doit
  !
  nc = hcct%gil%dim(2)
  ni = mic ! no longer !!! hcct%gil%dim(3)
  !
  mi = 0
  ccou = 0
  !
  do ic=1,nc
    ki = 0
    do ii=1,ni
      if (ccin(3,ic,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,ic,jj).eq.ccin(1,ic,ii)) then
            if (ccou(2,ic,jj).eq.ccin(2,ic,ii)) then
              doit = .false.
              !!print *,'Component ',ii,' relocated at ',jj
              ccou(3,ic,jj) = ccou(3,ic,jj) + ccin(3,ic,ii)
              exit
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          !!print *,'Component ',ii,' new at ',ki
          ccou(1:3,ic,ki) = ccin(1:3,ic,ii)
        endif
      endif
    enddo
    if (ki.ne.0) mi = max(mi,ki)
  enddo
  !
  mic = mi
end subroutine uv_compact_clean
!
subroutine uv_subtfast_clean(huv,duv,ouv,hcct,dcct,hdirty,freq,cpu0)
  use image_def
  use gbl_message
  use mapping_interfaces, except_this=>uv_subtfast_clean
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  ! This version is for CCT tables from MAPPING
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: huv   ! header of UV data set
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  type(gildas), intent(in) :: hdirty ! header of DIRTY data set
  real, intent(in) :: duv(huv%gil%dim(1),huv%gil%dim(2))
  real, intent(out) :: ouv(huv%gil%dim(1),huv%gil%dim(2))
  real, intent(in) :: dcct(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  real(8), intent(in) :: freq       ! Observing frequency in MHz
  real, intent(in) :: cpu0
  !
  integer :: nv    ! Number of visibilities
  integer :: mc    ! Number of Clean Components
  integer :: nc    ! Number of Channels
  integer :: mv    ! Size of a visibility
  integer :: nx,ny
  integer :: mx,my
  integer :: kx,ky
  real :: rx,ry
  real :: value
  complex, allocatable :: cfft(:,:,:)
  real, allocatable :: comp(:,:,:)
  integer iplane,ic,ix,iy,ier
  logical :: error
  real :: cpu1
  real(8) :: elapsed_s, elapsed_e, elapsed
  character(80) :: chain
  !
  !
  mv = huv%gil%dim(1)
  nv = huv%gil%dim(2)  ! Number of Visibilities
  nc = hcct%gil%dim(2) ! Number of channels
  mc = hcct%gil%dim(3) ! Number of Clean Components
  !
  ! Compute the Component Map (no residual)
  mx = hdirty%gil%dim(1)
  my = hdirty%gil%dim(2)
  allocate(comp(mx,my,nc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%i,'SUBFAST','Component allocation error')
    error = .true.
    return
  endif
  comp = 0
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP    & PRIVATE(iplane,ic,ix,iy,value) &
!$OMP    & SHARED(elapsed_s,elapsed_e)
!
!$ elapsed_s = omp_get_wtime()
!
!$OMP DO
  do iplane=1,nc
    do ic=1,mc
      if (dcct(3,iplane,ic).eq.0) exit
      !
      ! The NINT is required because of rounding errors
      ix = nint( (dcct(1,iplane,ic)-hdirty%gil%convert(2,1)) /  &
           &        hdirty%gil%convert(3,1) + hdirty%gil%convert(1,1))
      iy = nint( (dcct(2,iplane,ic)-hdirty%gil%convert(2,2)) /  &
           &        hdirty%gil%convert(3,2) + hdirty%gil%convert(1,2))
      value = dcct(3,iplane,ic)
      comp(ix,iy,iplane) = comp(ix,iy,iplane) + value
    enddo
  enddo
!$OMP END DO
!$  elapsed_e = omp_get_wtime()
!$OMP END PARALLEL
  elapsed = elapsed_e - elapsed_s
  write(chain,'(a,f9.2,a)') 'Finished building Clean, Elapsed: ',elapsed
  call map_message(seve%i,'UV_RESTORE',chain)
  !
  ! Define the image size
  rx = log(float(mx))/log(2.0)
  kx = nint(rx)
  if (kx.lt.rx) kx = kx+1
  nx = 2**kx
  ry = log(float(my))/log(2.0)
  ky = nint(ry)
  if (ky.lt.ry) ky = ky+1
  ny = 2**ky
  kx = max(nx,ny)
  kx = min(4*kx,4096)
  !
  ! If the image is already fine enough, use it "as is"
  ! even if it is not a power of two...
  nx = max(kx,mx)  ! max(kx,nx) for power of two
  ny = max(kx,my)  ! max(kx,ny) for power of two
  !
  ! Get Virtual Memory & compute the FFT
  allocate(cfft(nx,ny,nc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%i,'SUBFAST','Fine Component allocation error')
    error = .true.
    return
  endif
!  call plunge_real (comp,mx,my,cfft,nx,ny,nc)
  !
  ! Compute the FFT
  call doallffts(mx,my,comp,nx,ny,nc,cfft,elapsed)
  call gag_cpu(cpu1)
  write(chain,'(a,f9.2,a,f9.2)') 'Finished FFTs CPU: ',cpu1-cpu0, &
    & ', Elapsed: ',elapsed
  call map_message(seve%i,'UV_RESTORE',chain)
  !
  ouv = duv
  call do_fmodel(ouv,mv,nv,cfft,nx,ny,nc, &
  & freq,hdirty%gil%convert(3,1),hdirty%gil%convert(3,2),1.0,elapsed)
  write(chain,'(a,f9.2,a)') 'Finished Model, Elapsed: ',elapsed
  call map_message(seve%i,'UV_RESTORE',chain)
  !
  deallocate(comp,cfft)
end subroutine uv_subtfast_clean
!
subroutine do_fmodel (visi,nc,nv,a,nx,ny,nf,   &
     &    freq,xinc,yinc,factor,elapsed)
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !     Remove model visibilities from UV data set.
  !     "Fast" Model from an image: Use an intermediate FFT
  !-----------------------------------------------------------------
  integer, intent(in) :: nc ! Visibility size
  integer, intent(in) :: nv ! Number of visibilities
  integer, intent(in) :: nx ! X size
  integer, intent(in) :: ny ! Y size
  integer, intent(in) :: nf ! Number of frequencies
  real, intent(inout) :: visi(nc,nv)  ! Computed visibilities
  real(8), intent(in) :: freq           ! Effective frequency
  real, intent(in)  :: factor         ! Flux factor
  complex, intent(in) ::  a(nx,ny,nf) ! FFT
  real(8), intent(in) :: xinc,yinc    ! Pixel sizes
  real(8), intent(out) :: elapsed
  !
  real(8), parameter :: clight=299792458d0
  real(8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
  complex(8) :: aplus,amoin,azero,afin
  integer i,if,ia,ja
  logical inside
  real(8) :: elapsed_s, elapsed_e
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP    & SHARED(nv,nx,ny,nf,stepx,stepy,factor) &
  !$OMP    & SHARED(visi,a) &
  !$OMP    & PRIVATE(i,kwx,kwy,ia,ja,if,inside,xr,yr,aplus,azero,amoin,afin) &
  !$OMP    & SHARED(elapsed_s,elapsed_e)
  !$ elapsed_s = omp_get_wtime()
  !
  !$OMP DO
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ia = int(kwx)
    ja = int(kwy)
    inside = (ia.gt.1 .and. ia.lt.nx) .and.   &
     &      (ja.gt.1 .and. ja.lt.ny)
    if (inside) then
      xr = kwx - ia
      yr = kwy - ja
      do if=1,nf
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
     &          - 2.d0*a(ia,ja+1,if) )*xr   &
     &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
     &          + a(ia,ja+1,if)
        azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
     &          - 2.d0*a(ia,ja,if) )*xr   &
     &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
     &          + a(ia,ja,if)
        amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
     &          - 2.d0*a(ia,ja-1,if) )*xr   &
     &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
     &          + a(ia,ja-1,if)
        ! Then Y (or X)
        afin = ( (aplus+amoin-2.d0*azero)   &
     &          *yr + aplus-amoin )*yr*0.5d0 + azero
        !
        visi(5+3*if,i) =  visi(5+3*if,i) - real(afin)*factor
        visi(6+3*if,i) =  visi(6+3*if,i) - imag(afin)*factor
      enddo
    !!else
    !!  print *,'Visi ',i,ia,nx,ja,ny,visi(1,i),visi(2,i)
    endif
  enddo
!$OMP END DO
!$  elapsed_e = omp_get_wtime()
!$OMP END PARALLEL
  elapsed = elapsed_e - elapsed_s
end subroutine do_fmodel
!
subroutine doallffts (mx,my,comp,nx,ny,nf,fft,elapsed)
  use gkernel_interfaces, only : fourt, fourt_plan
  use mapping_interfaces, only: plunge_real
  !$ use omp_lib
  !------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE and others
  !   Could be optimized with Fourt_Plan and intermediate
  !   array
  !------------------------------------------------------
  integer, intent(in) :: mx
  integer, intent(in) :: my
  real, intent(in) :: comp(mx,my,nf)
  integer, intent(in) :: nx ! X size
  integer, intent(in) :: ny ! Y size
  integer, intent(in) :: nf ! Number of frequencies
  complex, intent(inout) :: fft(nx,ny,nf)
  real(8), intent(out) :: elapsed
  !
  integer :: if,dim(2),ndim,ier
  real :: work(2*max(nx,ny)) ! This will be on the stack
  complex, allocatable :: ftbeam(:,:)
  real(8) :: elapsed_s, elapsed_e
  !
  ! Loop on channels
  dim(1) = nx
  dim(2) = ny
  ndim = 2
  allocate(ftbeam(nx,ny),stat=ier)
  call fourt_plan(ftbeam,dim,ndim,1,1)
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP PRIVATE(if,ftbeam,work) &  ! loop & arrays
  !$OMP SHARED(comp,mx,my,fft,nx,ny,dim,nf) &
  !$OMP SHARED(elapsed_s,elapsed_e)
  !$ elapsed_s = omp_get_wtime()
  !$OMP DO
  do if = 1, nf
    call plunge_real (comp(:,:,if),mx,my,ftbeam,nx,ny)
    call fourt(ftbeam,dim,2,1,1,work)
    call recent(nx,ny,ftbeam)
    fft(:,:,if) = ftbeam
  enddo
  !$OMP ENDDO
  !$  elapsed_e = omp_get_wtime()
  !$OMP END PARALLEL
  elapsed = elapsed_e - elapsed_s
  !
end subroutine doallffts

subroutine class_print(set,line,error)
  use gildas_def
  use image_def
  use gbl_format
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_print
  use class_setup_new
  use class_types
  use class_common
  use class_index
  !----------------------------------------------------------------------
  ! @ public
  ! ANALYSE Support routine for command
  !	ANALYSE\PRINT   FIT   [/OUTPUT filename]
  !			AREA    [V1 [V2 [V3 [...]]]]
  !			MOMENT  [V1 V2 [V3 V4 [...]]]
  !			CHANNEL Liste
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  logical,             intent(inout) :: error  ! Output error flag
  ! Local
  character(len=*), parameter :: proc='PRINT'
  type(gildas) :: tbl
  real(kind=4), allocatable :: dtbl(:,:)
  logical :: table,file
  integer(kind=4), parameter :: maxarg=20
  integer(kind=entry_length) :: kx,kn,ksave
  integer(kind=4) :: i,jtmp,ido,ic,iv,nv,ndata
  real(kind=4) :: kanal(maxarg),rchan1,rchan2,frac1,frac2
  integer(kind=4) :: cl(maxarg),ier,nc,tbl_dim2,ichan1,ichan2,istart,iend
  character(len=message_length) ::  mess
  character(len=filename_length) :: fich,name,tempo
  real(kind=4) :: off1,off2,aa
  real(kind=4), allocatable :: value(:)
  real(kind=4) :: area(maxarg),vites(maxarg),s0(maxarg),s1(maxarg),s2(maxarg)
  character(len=9) :: what,argum
  type(observation) :: obs
  ! Actions
  integer(kind=4), parameter :: mact=6
  character(len=8) :: action(mact)
  data action/'FIT','AREA','CHANNEL','MOMENT','POINTING','FLUX'/
  integer(kind=4), parameter :: dofit=1
  integer(kind=4), parameter :: doarea=2  ! PRINT AREA V1 V2 ...
  integer(kind=4), parameter :: doareabase=-2  ! PRINT AREA (no arg)
  integer(kind=4), parameter :: dochannel=3
  integer(kind=4), parameter :: domoment=4
  integer(kind=4), parameter :: dopointing=5
  integer(kind=4), parameter :: doflux=6
  !
  ! Verify if any input file
  if (.not.filein_opened(proc,error))  return
  !
  ! What is to be printed ?
  !
  table = sic_present(2,0)
  file = sic_present(1,0)
  if (table.and.file) then
     call class_message(seve%e,proc,'Conflicting option /FILE and /TABLE')
     error = .true.
     return
  endif
  !
  argum = 'FIT'
  call sic_ke (line,0,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs('PRINT',argum,what,ido,action,mact,error)
  if (error) return
  !
  if (ido.eq.dofit .or. ido.ge.dopointing .or. ido.eq.doflux) then
     ! PRINT FIT|POINTING|FLUX
     if (table) then
        call class_message(seve%e,proc,  &
          'Option /TABLE is not available for PRINT '//action(ido))
        error = .true.
        return
     endif
  elseif (ido.eq.doarea) then
     ! PRINT AREA
     if (sic_narg(0).eq.1) then
        ! Baseline area
        ido = doareabase
        tbl_dim2 = 5
     elseif (sic_narg(0).eq.2) then
        call class_message(seve%e,proc,'At least 2 velocities needed (1 range)')
        error = .true.
        return
     else
        ! Decode area velocity list
        istart = sic_start(0,2)
        iend = sic_end(0,sic_narg(0))
        call sic_build_listr4(vites,nv,maxarg,line(istart:iend),proc,error)
        if (error) return
        tbl_dim2 = 3+nv-1  ! num + x + y + (nv-1) ranges
     endif
  elseif (ido.eq.dochannel) then
     ! PRINT CHANNEL: decode channel list
     if (sic_narg(0).le.1) then
        call class_message(seve%e,proc,'Missing channel list')
        error = .true.
        return
     endif
     istart = sic_start(0,2)
     iend = sic_end(0,sic_narg(0))
     call sic_build_listi4(cl,nv,maxarg,line(istart:iend),proc,error)
     if (error) return
     tbl_dim2 = 3+nv
  elseif (ido.eq.domoment) then
     ! PRINT MOMENT: decode moment velocity list
     if (sic_narg(0).le.2) then
        call class_message(seve%e,proc,'At least 2 velocities needed (1 range)')
        error = .true.
        return
     endif
     istart = sic_start(0,2)
     iend = sic_end(0,sic_narg(0))
     call sic_build_listr4(vites,nv,maxarg,line(istart:iend),proc,error)
     if (error) return
     nv = nv/2  ! Nv values => Nv pairs
     tbl_dim2 = 3+3*nv
  endif
  !
  ! Open output file if needed
  if (file) then
     call sic_ch (line,1,1,name,nc,.true.,error)
     if (error) return
     ier = sic_getlun(jtmp)
     if (ier.ne.1) then
        call class_message(seve%e,proc,'No logical unit left')
        error = .true.
        return
     endif
     call sic_parse_file(name,' ','.dat',fich)
     ier = sic_open(jtmp,fich,'NEW',.false.)
     if (ier.ne.0) then
        call class_message(seve%e,proc,'Unable to open file '//name)
        call putios ('          ',ier)
        error = .true.
        call sic_frelun(jtmp)
        return
     endif
     tempo = ' '
     call sic_date(tempo)
     write (jtmp,'("!",/,"! ",A)') trim(tempo)
     inquire (unit=filein%lun,name=tempo)
     write (jtmp,'("! Input file  : ",a)') trim(tempo)
     write (jtmp,'("! Input command: ",a,/,"!")') trim(line)
     !
  elseif (table) then
     ! TABLE output
     call sic_ch (line,2,1,name,nc,.true.,error)
     if (error) return
     mess = 'Creating Table '//name
     call class_message(seve%i,proc,mess)
     call gildas_null(tbl)
     tbl%file = name
     tbl%gil%dim(1) = cx%next-1
     tbl%gil%dim(2) = tbl_dim2
     tbl%gil%coor_words = 0
     tbl%gil%ndim = 2
     allocate(dtbl(tbl%gil%dim(1),tbl%gil%dim(2)),stat=ier)
  else
     ! STDOUT
     jtmp = 6
  endif
  !
  call init_obs(obs)
  !
  ! Call appropriate routine according to what to do
  if (ido.eq.dofit) then  ! PRINT FIT
     if (set%method.eq.'CONTINUUM' .or. set%method.eq.'BASECONT') then
        call pricont(set,jtmp)
     elseif (set%method.eq.'GAUSS') then
        call prigauss(set,jtmp)
     elseif (set%method.eq.'NH3'.or.set%method.eq.'HFS') then
        call prinh3(set,jtmp)
     elseif (set%method.eq.'ABSORPTION') then
        call priabs(set,jtmp)
     elseif (set%method.eq.'SHELL') then
        call prishell(set,jtmp)
     endif
  elseif (ido.eq.dopointing) then  ! PRINT POINTING
     call pripoint(set,jtmp)
  elseif (ido.eq.doflux) then  ! PRINT FLUX
     call priflux(set,jtmp)
  else
     !
     ksave = knext
     !
     do kn=1,cx%next-1
        kx = cx%ind(kn)
        !
        ! Read the observation into obs
        call robs(obs,kx,error)        ! read obs header
        if (sic_ctrlc() .and. jtmp.eq.6) exit
        if (error) exit
        call rgen(set,obs,error)           ! general informations
        error = .false.
        if (ido.eq.doareabase) then
           if (.not.obs%head%presec(class_sec_bas_id)) then
             write(mess,'(3(A,I0))')  'Observation ',obs%head%gen%num,';',  &
               obs%head%gen%ver,' has no BASE section. Skipping.'
             call class_message(seve%w,proc,mess)
             cycle
           endif
           call rbase(set,obs,error)
           if (error) then
              write(mess,1002) kx,obs%head%gen%num,obs%head%gen%ver
              call class_message(seve%w,proc,mess)
           elseif (table) then
              ! call cido00 (obs%head%gen%num,head%pos%lamof,head%pos%betof,  &
              !              obs%head%bas%aire,obs%head%bas%sigfi,              &
              !              kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              dtbl(kn,4) = obs%head%bas%aire
              dtbl(kn,5) = obs%head%bas%sigfi
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1003) obs%head%gen%num,off1,off2,obs%head%bas%aire,obs%head%bas%sigfi
           endif
           !
           ! List of channels
        elseif (ido.eq.dochannel) then
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           if (error)  return
           allocate(value(ndata))  ! Not very efficient, but Ndata can vary for
                                   ! each observation in the index
           do i=1,nv
              if (cl(i).ge.1 .and. cl(i).le.ndata) then
                 value(i) = obs%spectre( cl(i) )
              else
                 value(i) = obs%head%spe%bad
              endif
           enddo
           if (table) then
              ! call cido03 (obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !              nv,value,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv
                 dtbl(kn,3+iv) = value(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2,(value(i),i=1,nv)
           endif
           deallocate(value)
           !
        elseif (ido.eq.domoment) then
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           do iv = 1, nv
              call getmom(obs,vites(2*iv-1),vites(2*iv),s0(iv),s1(iv),s2(iv))
           enddo
           if (table) then
              ! call cido04(obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !             nv,s0,s1,s2,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv
                 dtbl(kn,3+iv) = s0(iv)
                 dtbl(kn,3+nv+iv) = s1(iv)
                 dtbl(kn,3+2*nv+iv) = s2(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2, &
                   &          (s0(iv),s1(iv),s2(iv),iv=1,nv)
           endif
           !
           ! Area by velocity range
        elseif (ido.eq.doarea) then
           !
           ! Compute the boundary channels
           call rspec(set,obs,error)
           ndata = obs%head%spe%nchan
           call reallocate_obs(obs,ndata,error)
           if (error)  return
           call rdata(set,obs,ndata,obs%spectre,error)
           do iv=1,nv
             call abscissa_velo2chan(obs%head,vites(iv),kanal(iv))
           enddo
           !
           ! Compute the area
           do iv = 1,nv-1
              ! Channels (real values)
              if (kanal(iv).lt.kanal(iv+1)) then
                rchan1 = kanal(iv)
                rchan2 = kanal(iv+1)
              else
                rchan1 = kanal(iv+1)
                rchan2 = kanal(iv)
              endif
              !
              ! Protections
              if (rchan2.lt..5 .or. rchan1.gt.(ndata+.5)) then
                write(mess,*) 'Velocity range ',vites(iv),vites(iv+1),  &
                  ' is out of spectrum boundaries'
                call class_message(seve%e,proc,mess)
                error = .true.
                goto 10
              endif
              !
              ! Channels (integer values)
              ichan1 = nint(rchan1)  ! because e.g. channel #2 goes from 1.5 to 2.5
              ichan2 = nint(rchan2)
              !
              ! Protections
              if (rchan1.lt..5 .or. rchan2.gt.(ndata+.5)) then
                write(mess,*) 'Velocity range ',vites(iv),vites(iv+1),  &
                  ' intersects spectrum boundaries'
                call class_message(seve%w,proc,mess)
                if (rchan1.lt..5)  then
                  rchan1 = .5
                  ichan1 = 1
                endif
                if (rchan2.gt.(ndata+.5))  then
                  rchan2 = ndata+.5
                  ichan2 = ndata
                endif
              endif
              !
              ! Boundary channel fractions
              if (ichan1.eq.ichan2) then
                frac1 = rchan2-rchan1
                frac2 = 0.
              else
                frac1 = (real(ichan1)+.5)-rchan1
                frac2 = rchan2-(real(ichan2)-.5)
              endif
              !
              ! Integrate
              aa = frac1*obs_good(obs,ichan1)
              do ic=ichan1+1,ichan2-1
                aa = aa + obs_good(obs,ic)  ! 'obs_good' interpolates bad channels if any
              enddo
              aa = aa + frac2*obs_good(obs,ichan2)
              !
              area(iv) = aa*abs(obs%head%spe%vres)
           enddo
           !
           if (table) then
              ! call cido03(obs%head%gen%num,obs%head%pos%lamof,obs%head%pos%betof,  &
              !             nv,area,kn,dtbl,tbl%gil%dim(1),tbl%gil%dim(2))
              dtbl(kn,1) = obs%head%gen%num
              dtbl(kn,2) = obs%head%pos%lamof
              dtbl(kn,3) = obs%head%pos%betof
              do iv=1,nv-1
                 dtbl(kn,3+iv) = area(iv)
              enddo
           else
              off1 = obs%head%pos%lamof*class_setup_get_fangle()
              off2 = obs%head%pos%betof*class_setup_get_fangle()
              write (jtmp,1005) obs%head%gen%num,off1,off2,(area(i),i=1,nv-1)
           endif
        endif
        error = .false.
        !
        ! Loop over index
     enddo
     !
     knext = ksave
  endif
  !
  if (table)  call gdf_write_image(tbl,dtbl,error)
  !
10 continue  ! You can jump here in case of error
  !
  call free_obs(obs)
  if (table) then
     deallocate(dtbl,stat=ier)
  elseif (jtmp.ne.6) then
     close (jtmp)
     call sic_frelun(jtmp)
  endif
  return
  !
1002 format('At entry ',i0,' Scan ',i0,';',i0)
1003 format(1x,i0,2(2x,f9.3),2x,(f9.3,1x,f6.3))
! 1004 format(1x,i0,11(2x,f9.3))
1005 format(1x,i0,2(2x,f9.3),15(1x,1pg12.5))
end subroutine class_print
!
subroutine getmom(obs,v1,v2,aire,vit,del)
  use gildas_def
  use gbl_constant
  use classcore_interfaces, except_this=>getmom
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  ! Computes moment of the data between V1 and V2
  ! Caution: V1 and V2 are rounded to the nearest channel
  !----------------------------------------------------------------------
  type(observation), intent(in)  :: obs   !
  real(kind=4),      intent(in)  :: v1    ! Lower bound
  real(kind=4),      intent(in)  :: v2    ! Upper bound
  real(kind=4),      intent(out) :: aire  ! Integrated area
  real(kind=4),      intent(out) :: vit   ! Central velocity
  real(kind=4),      intent(out) :: del   ! Line width
  ! Local
  real(kind=4) :: s0, s1, s2, value, s12, r1, r2
  integer(kind=4) :: i1, i2, nc, imin, imax, i
  !
  ! Compute the moment(s)
  if (obs%head%gen%kind.eq.kind_spec) then
    call abscissa_velo2chan(obs%head,v1,r1)
    call abscissa_velo2chan(obs%head,v2,r2)
    i1 = nint(r1)
    i2 = nint(r2)
    nc = obs%head%spe%nchan
  else
    call abscissa_angl2chan(obs%head,v1,r1)
    call abscissa_angl2chan(obs%head,v2,r2)
    i1 = nint(r1)
    i2 = nint(r2)
    nc = obs%head%dri%npoin
  endif
  imin = max(min(i1,i2),1)
  imax = min(max(i1,i2),nc)
  !
  s0 = 0.
  s1 = 0.
  s2 = 0.
  aire = 0.
  vit = 0.
  del = 0.
  do i=imin,imax
    value = obs_good(obs,i)
    s0 = s0+value
    s1 = s1+value*i
    s2 = s2+i*value*i
  enddo
  !
  ! Type out result according to Kind
  if (obs%head%gen%kind.eq.kind_spec) then
    if (s0.ne.0) then
      s1 = s1 / s0
      call abscissa_chan2velo(obs%head,s1,vit)
      s2 = s2 / s0
      s12 = s1**2
      if (s2.gt.s12)  del = abs(obs%head%spe%vres) * sqrt((s2-s12)*8.*log(2.))
    endif
    aire = s0 * abs(obs%head%spe%vres)
  else
    if (s0.ne.0) then
      s1 = s1 / s0
      call abscissa_chan2angl(obs%head,s1,vit)
      s2 = s2 / s0
      s12 = s1**2
      if (s2.gt.s12)  del = abs(obs%head%dri%ares) * sqrt((s2-s12)*8.*log(2.))
    endif
    aire = s0 * abs (obs%head%dri%ares)
  endif
end subroutine getmom
!
subroutine prigauss(set,jtmp)
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prigauss
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical unit number
  ! Local
  integer(kind=4) :: k,i
  integer(kind=entry_length) :: ksave,kn
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  ksave = knext
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rgaus(set,obs,error)
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     !
     ! Write the information if present
     if (obs%head%gau%sigba.ne.0.0.and..not.error) then
        k=1
        if (obs%head%gen%kind.eq.kind_cont) then
           do i=1,max(obs%head%gau%nline,1)
              write (jtmp,1000)  &
                max(obs%head%gau%nline,1),obs%head%gen%num,  &
                off1,off2,                                   &
                obs%head%gau%nfit(k)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k+1)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k+1)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k+2)*class_setup_get_fangle(),  &
                obs%head%gau%nerr(k+2)*class_setup_get_fangle(),  &
                obs%head%gau%nfit(k)/obs%head%gau%nfit(k+2)/1.064467,  &
                obs%head%gau%sigba,obs%head%gau%sigra
              k=k+3
           enddo
        else
           do i=1,max(obs%head%gau%nline,1)
              write (jtmp,1000) max(obs%head%gau%nline,1),             &
                obs%head%gen%num,off1,off2,                            &
                obs%head%gau%nfit(k),  obs%head%gau%nerr(k),           &
                obs%head%gau%nfit(k+1),obs%head%gau%nerr(k+1),         &
                obs%head%gau%nfit(k+2),obs%head%gau%nerr(k+2),         &
                obs%head%gau%nfit(k)/obs%head%gau%nfit(k+2)/1.064467,  &
                obs%head%gau%sigba,obs%head%gau%sigra
              k=k+3
           enddo
        endif
     else
        write(jtmp,1002) 0,obs%head%gen%num,off1,off2
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(1x,g10.3),2x,   &
       &    3(1pg12.4,' ',1pg11.3,'   '),1pg11.3,2x,2(1pg11.3,2x))
! 1001 format(35x,   &
!        &    3(1pg12.4,' ',1pg11.3,'   '),1pg11.3,2x,2(1pg11.3,2x))
1002 format(1x,i1,1x,i0,2(2x,f8.3),2x,'/   No Fit ...')
end subroutine prigauss
!
subroutine priabs(set,jtmp)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>priabs
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Print the ABS fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp
  ! Local
  integer(kind=4) :: k,i
  integer(kind=entry_length) :: ksave,kn
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_abs_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rabs(set,obs,error)
        k=2
        do i=1,max(obs%head%abs%nline,1)
           write (jtmp,1000)                                 &
             max(obs%head%abs%nline,1),obs%head%gen%num,     &
             off1,off2,                                      &
             obs%head%abs%nfit(k),  obs%head%abs%nerr(k),    &
             obs%head%abs%nfit(k+1),obs%head%abs%nerr(k+1),  &
             obs%head%abs%nfit(k+2),obs%head%abs%nerr(k+2),  &
             obs%head%abs%sigba,    obs%head%abs%sigra
           k=k+3
        enddo
        error = .false.
     endif
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(2x,f8.3),2x,  &
            3(f8.3,' ',f7.3,'   '),2x,2(f6.3,2x))
1003 format('! Absorption fitting . . . . . . . . . .',  &
            'Opacity           Vlsr            Width ')
end subroutine priabs
!
subroutine prishell(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prishell
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the SHELL fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical Unit number for message
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,i
  real(kind=4) :: off1,off2, d, ed
  real(kind=8) :: f ,fi
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_she_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rshel(set,obs,error)
        error=.false.
        call rspec(set,obs,error)
        k=1
        f = obs%head%she%nfit(k+1)+obs%head%spe%restf
        fi=-obs%head%she%nfit(k+1)+obs%head%spe%image
        d = obs%head%she%nfit(k+2)*clight_kms/obs%head%spe%restf
        ed= obs%head%she%nerr(k+2)*clight_kms/obs%head%spe%restf
        ! T = 1.5*obs%head%she%nfit(K)/obs%head%she%nfit(K+2)/(3.0+obs%head%she%nfit(K+3))
        write (jtmp,1000)  &
          max(obs%head%she%nline,1),obs%head%gen%num,off1,off2,            &
          obs%head%she%nfit(k), obs%head%she%nerr(k), f, fi,               &
          obs%head%she%nerr(k+1), d, ed,  obs%head%she%nfit(k+3),          &
          obs%head%she%nerr(k+3), obs%head%she%sigba, obs%head%she%sigra,  &
          obs%head%pos%sourc
        !
        ! Write the information if present
        do i=2,max(obs%head%she%nline,1)
           k=k+4
           f = obs%head%she%nfit(k+1)+obs%head%spe%restf
           fi=-obs%head%she%nfit(k+1)+obs%head%spe%image
           d = obs%head%she%nfit(k+2)*clight_kms/obs%head%spe%restf
           ed= obs%head%she%nerr(k+2)*clight_kms/obs%head%spe%restf
           write (jtmp,1001)  &
             obs%head%she%nfit(k),obs%head%she%nerr(k),  &
             f,fi,obs%head%she%nerr(k+1),                &
             d,ed,obs%head%she%nfit(k+3),obs%head%she%nerr(k+3)
        enddo
        error = .false.
     else
        write(jtmp,1002) 0,obs%head%gen%num,off1,off2,obs%head%pos%sourc
     endif
     !
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1003 format('! Shell Scan   Off1     Off2     Area     Da      ',   &
            'Freq.Sig.    Freq.Ima.    Df    Exp.Vel.   De  Horn/Center ',   &
            'DH/C  Sig.B.  Sig.R.')
1000 format (1x,i1,1x,i0,2(1x,f8.3),1x,   &
            f8.3,1x,f7.3,1x,2(f12.3,1x),f7.3,1x,   &
            2(f8.2,1x,f6.2,1x),2(f7.3,1x),'/',a)
1001 format (30x,   &
            f8.3,1x,f7.3,1x,2(f12.3,1x),f7.3,1x,   &
            2(f8.2,1x,f6.2,1x))
1002 format (1x,i1,1x,i0,2(2x,f8.3),2x,'/ ',a,' No Fit ...')
end subroutine prishell
!
subroutine prinh3(set,jtmp)
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>prinh3
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Print the NH3 fit results in a format suitable for GREG
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,i
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write (jtmp,1003)
  ksave=knext
  !
  ! Loop over index entries
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     off1 = obs%head%pos%lamof*class_setup_get_fangle()
     off2 = obs%head%pos%betof*class_setup_get_fangle()
     if (obs%head%presec(class_sec_hfs_id)) then
        call rgen(set,obs,error)
        error=.false.
        call rnh3(set,obs,error)
        k=1
        do i=1,max(obs%head%hfs%nline,1)
           write (jtmp,1000)  &
             max(obs%head%hfs%nline,1),obs%head%gen%num,     &
             off1,off2,                                      &
             obs%head%hfs%nfit(k),  obs%head%hfs%nerr(k),    &
             obs%head%hfs%nfit(k+1),obs%head%hfs%nerr(k+1),  &
             obs%head%hfs%nfit(k+2),obs%head%hfs%nerr(k+2),  &
             obs%head%hfs%nfit(k+3),obs%head%hfs%nerr(k+3),  &
             obs%head%hfs%sigba,obs%head%hfs%sigra
           k=k+4
        enddo
        error = .false.
     endif
  enddo
  knext=ksave
  !
  call free_obs(obs)
  return
  !
1000 format(1x,i1,1x,i0,2(2x,f8.3),2x,  &
            4(f8.3,' ',f7.3,'   '),2x,2(f6.3,2x))
1003 format('! NH3 Hyperfine structure fitting . . . . . . . . . .',  &
            'Area           Vlsr            Width          Opacity')
end subroutine prinh3
!
subroutine pricont(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pricont
  use class_setup_new
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for continuum data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set   !
  integer(kind=4),     intent(in) :: jtmp  ! Logical unit number
  ! Local
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k
  real(kind=4) :: off1,off2
  logical :: error
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     if (sic_ctrlc().and.(jtmp.eq.6)) exit
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rpoint(set,obs,error)
     off1 = obs%head%gen%az*180.0d0/pi
     off2 = obs%head%gen%el*180.0d0/pi
     !
     ! Write the information if present
     if (obs%head%poi%sigba.ne.0.0 .and. .not.error) then
        k = 3
        write (jtmp,1000)                                   &
          obs%head%gen%num,                                 &
          off1,off2,                                        &
          obs%head%poi%nfit(k)*class_setup_get_fangle(),    &
          obs%head%poi%nerr(k)*class_setup_get_fangle(),    &
          obs%head%poi%nfit(k+1)*class_setup_get_fangle(),  &
          obs%head%poi%nerr(k+1)*class_setup_get_fangle(),  &
          obs%head%poi%nfit(k+2)*class_setup_get_fangle(),  &
          obs%head%poi%nerr(k+2)*class_setup_get_fangle(),  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,  &
          obs%head%poi%sigba,obs%head%poi%sigra,                 &
          obs%head%pos%sourc
     else
        write (jtmp,1002) obs%head%gen%num,off1,off2,obs%head%pos%sourc
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Azimuth   Elevation   Area     ..',   &
            '            Position  ..           Width     ..          Intensity',  &
            '         Sigmas ..     Source')
1000 format(1x,i10,2(2x,g9.3),2x,   &
            3(g9.3,' ',g9.3,'   '),g9.3,4x,2(g9.3,2x),'''',a,'''')
1002 format(1x,i10,2(2x,g9.3),2x,'/   No Fit ... for ',a)
end subroutine pricont
!
subroutine pripoint(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>pripoint
  use class_types
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for pointing data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp   ! Logical unit number
  ! Local
  real(kind=8) :: kangle
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,iflag,iant,ista
  real(kind=4) :: az,el,time,offset
  logical :: error
  character(len=12) :: cteles
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  kangle = 3600d0*180d0/pi
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rcont(set,obs,error)
     error = .false.
     call rpoint(set,obs,error)
     az  = obs%head%gen%az*180.0d0/pi
     el = obs%head%gen%el*180.0d0/pi
     time = obs%head%gen%st*12.d0/pi
     !
     cteles = obs%head%gen%teles
     if (cteles(1:3).eq.'BUR') then
        read(cteles(4:4),'(I1)') iant
        read(cteles(7:8),'(I2)') ista
        if (cteles(6:6).eq.'E') then
           ista = 300+ista
        elseif (cteles(6:6).eq.'W') then
           ista = 200+ista
        elseif (cteles(6:6).eq.'N') then
           ista = 100+ista
        endif
     else
        iant = 0
        ista = 0
     endif
     !
     ! Write the information if present
     if (obs%head%poi%sigba.ne.0.0.and..not.error) then
        k = 3
        if (mod(abs(obs%head%dri%apos+pis),pis).le.1e-3 .or.   &
            mod(abs(obs%head%dri%apos),pis).le.1e-3) then
           iflag = 0                ! 0 or PI: along elevation
           offset = obs%head%dri%colle+obs%head%poi%nfit(k+1)+obs%head%pos%betof
        elseif (abs(mod(obs%head%dri%apos,pis)-0.5*pis).le.1e-3 .or.  &
                abs(mod(obs%head%dri%apos,pis)+0.5*pis).le.1e-3) then
           iflag = 1                ! -PI/2 or +PI/2: along azimuth
           offset = obs%head%dri%colla+obs%head%poi%nfit(k+1)+obs%head%pos%lamof
        else
           iflag = -1               ! Unknown
           offset = obs%head%poi%nfit(k+1)
        endif
        write (jtmp,1000)                                               &
          obs%head%gen%num,obs%head%gen%scan,iflag,az,el,time,          &
          offset*kangle,obs%head%poi%nerr(k+1)*kangle,iant,ista,        &
          obs%head%poi%nfit(k+2)*kangle,obs%head%poi%nerr(k+2)*kangle,  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,         &
          obs%head%poi%sigra,                                           &
          obs%head%pos%sourc
     else
        write (jtmp,1002) obs%head%gen%num,obs%head%gen%scan,-1,az,el,  &
          time,obs%head%pos%sourc
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Scan Code Azimuth   Elevation   Time  ',  &
            '     Position  ..  A# Station   Width      ..     Intensity',  &
            '     Sigma    Source')
1000 format(1x,i8,1x,i8,i4,3(2x,f8.3),1x,  &
            f9.2,1x,f8.2,1x,i2,i4,1x,f9.2,1x,f8.2,1x,  &
            1pg10.3,2x,1pg10.3,2x,'''',a,'''')
1002 format(1x,i8,1x,i8,i4,3(2x,f8.3),2x,'/   No Fit ... for ',a)
end subroutine pripoint
!
subroutine priflux(set,jtmp)
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>priflux
  use class_index
  use class_types
  !----------------------------------------------------------------------
  ! @ private
  !  Print the results of gaussfit to a listing file, for FLUX data
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in) :: set
  integer(kind=4),     intent(in) :: jtmp   ! Logical unit number
  ! Local
  real(kind=8) :: kangle
  integer(kind=entry_length) :: kn,ksave
  integer(kind=4) :: k,iflag,iant,ista
  real(kind=4) :: az,el,time,offset
  logical :: error
  character(len=12) :: cteles,ch
  type(observation) :: obs
  !
  call init_obs(obs)
  !
  write(jtmp,1001)
  ksave = knext
  kangle = 3600d0*180d0/pi
  !
  ! Loop over index
  do kn=1,cx%next-1
     ! Read the observation into obs
     call robs(obs,cx%ind(kn),error)
     error=.false.
     call rgen(set,obs,error)
     error=.false.
     call rcont(set,obs,error)
     error = .false.
     call rcal(set,obs,error)
     error = .false.
     call rpoint(set,obs,error)
     error = .false.
     az  = obs%head%gen%az*180.0d0/pi
     el = obs%head%gen%el*180.0d0/pi
     time = obs%head%gen%st*12.d0/pi
     !
     cteles = obs%head%gen%teles
     if (cteles(1:3).eq.'BUR') then
        read(cteles(4:4),'(I1)') iant
     else
        iant = 0
        ista = 0
     endif
     !
     ! Write the information if present
     call gag_todate(obs%head%gen%dobs,ch,error)
     if (obs%head%poi%sigba.ne.0.0.and..not.error) then
        k = 3
        if (mod(abs(obs%head%dri%apos+pis),pis).le.1e-3 .or.   &
            mod(abs(obs%head%dri%apos),pis).le.1e-3) then
           iflag = 0                ! Elevation
           offset = obs%head%poi%nfit(k+1)+obs%head%pos%betof
        elseif (mod(abs(obs%head%dri%apos+0.5*pis),pis).le.1e-3) then
           iflag = 1                ! Azimuth
           offset = obs%head%poi%nfit(k+1)+obs%head%pos%lamof
        else
           iflag = -1               ! Unknown
           offset = obs%head%poi%nfit(k+1)
        endif
        write (jtmp,1000)                                               &
          obs%head%gen%num,obs%head%gen%scan,iflag,az,el,time,          &
          offset*kangle,obs%head%poi%nerr(k+1)*kangle,iant,             &
          obs%head%poi%nfit(k+2)*kangle,obs%head%poi%nerr(k+2)*kangle,  &
          obs%head%poi%nfit(k)/obs%head%poi%nfit(k+2)/1.064467,         &
          obs%head%poi%sigra,obs%head%cal%gaini,                        &
          obs%head%dri%freq*1e-3,obs%head%dri%cimag*1e-3,               &
          obs%head%pos%sourc,ch
     else
        write (jtmp,1000)  &
          obs%head%gen%num,obs%head%gen%scan,-1,az,el,time,obs%head%pos%sourc,ch
     endif
     error = .false.
  enddo
  knext = ksave
  !
  call free_obs(obs)
  return
  !
1001 format('!   Obs.#     Scan Code Azimuth   Elevation  Time  ',  &
            '     Position  ..  A#     Width      ..     Intensity',  &
            '     ..  Gain   Fsignal  Fimage Source  Date')
1000 format(1x,i8,1x,i8,i3,3(1x,f8.3),1x,  &
            f9.2,1x,f8.2,1x,i2,1x,f9.2,1x,f8.2,1x,  &
            1pg10.3,1x,1pg10.3,1x,0pf6.2,2(1x,f8.3),1x,'''',a,'''',  &
            1x,'''',a,'''')
end subroutine priflux
!
subroutine cido00 (num,off1,off2,aire,sigma,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer, intent(in) :: num
  integer, intent(in) :: n
  integer, intent(in) :: nl
  integer, intent(in) :: nc
  real,    intent(in) :: off1
  real,    intent(in) :: off2
  real,    intent(in) :: aire
  real,    intent(in) :: sigma
  real,    intent(inout) :: tab(nl,nc)
  !
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  tab(n,4) = aire
  tab(n,5) = sigma
end subroutine cido00
!
subroutine cido03 (num,off1,off2,nv,value,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer num,n,nl,nc,nv,i
  real off1,off2,value(nv),tab(nl,nc)
  !
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  do i=1,nv
     tab(n,3+i) = value(i)
  enddo
end subroutine cido03
!
subroutine cido04 (num,off1,off2,nv,val1,val2,val3,n,tab,nl,nc)
  !----------------------------------------------------------------------
  ! @ private
  ! CLASS Internal routine
  ! obsolete
  !----------------------------------------------------------------------
  integer num,n,nl,nc,nv,i
  real off1,off2,val1(nv),val2(nv),val3(nv),tab(nl,nc)
  if (n.gt.nl) return
  tab(n,1) = num
  tab(n,2) = off1
  tab(n,3) = off2
  do i=1,nv
     tab(n,3+i) = val1(i)
     tab(n,3+nv+i) = val2(i)
     tab(n,3+2*nv+i) = val3(i)
  enddo
end subroutine cido04

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***JP: This one is a tentative code that did not converge. I leave it here
!***JP: for the moment. To be deleted on 2024-09-01 if nothing happened!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_correlation
  use cube_types
  use cubetools_parameters
  use cubetools_structure
  use cubetopology_cuberegion_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubecompute_messaging
  use cubecompute_correlate_spectrum_tool
  !
  public :: correlation
  private
  !
  type :: correlation_comm_t
     type(option_t), pointer :: comm
     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: cube1
     type(cubeid_arg_t), pointer :: cube2
     type(cube_prod_t),  pointer :: correlated
   contains
     procedure, public  :: register => cubecompute_correlation_comm_register
     procedure, private :: parse    => cubecompute_correlation_comm_parse
     procedure, private :: main     => cubecompute_correlation_comm_main
  end type correlation_comm_t
  type(correlation_comm_t) :: correlation
  !
  type correlation_user_t
     type(cubeid_user_t)     :: cubeids
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubecompute_correlation_user_toprog
  end type correlation_user_t
  !
  type correlation_prog_t
     type(cuberegion_prog_t) :: region
     type(cube_t), pointer   :: cube1
     type(cube_t), pointer   :: cube2
     type(cube_t), pointer   :: correlated
     type(correlate_spectrum_prog_t) :: correl
   contains
     procedure, private :: header => cubecompute_correlation_prog_header
     procedure, private :: data   => cubecompute_correlation_prog_data
     procedure, private :: loop   => cubecompute_correlation_prog_loop
     procedure, private :: act    => cubecompute_correlation_prog_act
  end type correlation_prog_t
  !
contains
  !
  subroutine cubecompute_correlation_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(correlation_user_t) :: user
    character(len=*), parameter :: rname='CORRELATION>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call correlation%parse(line,user,error)
    if (error) return
    call correlation%main(user,error)
    if (error) continue
  end subroutine cubecompute_correlation_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(inout) :: comm
    logical,                   intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: correlated
    character(len=*), parameter :: rname='CORRELATION>COMM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
        'CORRELATION','[cubeid1] [cubeid2]',&
         'Template to access input/output data per spectrum',&
         'Input and output cubes are real',&
         cubecompute_correlation_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'CUBE1',&
         'First cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%cube1,&
         error)
    call incube%register(&
         'CUBE2',&
         'Second cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_speset,&
         comm%cube2,&
         error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call correlated%register(&
         'CORRELATION',&
         'Correlated cube',&
         strg_emp,&
         [flag_correlation],&
         comm%correlated,&
         error)
    if (error)  return
  end subroutine cubecompute_correlation_comm_register
  !
  subroutine cubecompute_correlation_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(correlation_user_t),  intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>COMM>PARSE'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
  end subroutine cubecompute_correlation_comm_parse
  !
  subroutine cubecompute_correlation_comm_main(comm,user,error) 
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_comm_t), intent(in)    :: comm
    type(correlation_user_t),  intent(inout) :: user
    logical,                   intent(inout) :: error
    !
    type(correlation_prog_t) :: prog
    character(len=*), parameter :: rname='CORRELATION>COMM>MAIN'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubecompute_correlation_comm_main
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_user_toprog(user,comm,prog,error)
    use cubetools_consistency_methods
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_user_t), intent(in)    :: user
    type(correlation_comm_t),  intent(in)    :: comm    
    type(correlation_prog_t),  intent(out)   :: prog
    logical,                   intent(inout) :: error
    !
    logical :: conspb
    character(len=*), parameter :: rname='CORRELATION>USER>TOPROG'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%cube1,user%cubeids,prog%cube1,error)
    if (error) return
    call cubeadm_get_header(comm%cube2,user%cubeids,prog%cube2,error)
    if (error) return
    !
    ! ***JP: unclear whether the program should accept the case where the
    ! ***JP: subregions of two cubes are consistent
    conspb = .false.
    call cubetools_consistency_shape(&
         'Input cube #1',prog%cube1%head,&
         'Input cube #2',prog%cube2%head,&
         conspb,error)
    if (error) return
    if (cubetools_consistency_failed(rname,conspb,error)) return
    !    
    call user%region%toprog(prog%cube1,prog%region,error)
    if (error) return
    call user%region%toprog(prog%cube2,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%region%list(error)
    if (error) return
  end subroutine cubecompute_correlation_user_toprog
  !
  !------------------------------------------------------------------------
  !
  subroutine cubecompute_correlation_prog_header(prog,comm,error)
    use cubeadm_clone
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    type(correlation_comm_t),  intent(in)    :: comm
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>PROG>HEADER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%correlated,prog%cube1,prog%correlated,error)
    if (error) return
    call prog%region%header(prog%correlated,error)
    if (error) return
  end subroutine cubecompute_correlation_prog_header
  !
  subroutine cubecompute_correlation_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='CORRELATION>PROG>DATA'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo ! iter
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubecompute_correlation_prog_data
  !   
  subroutine cubecompute_correlation_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),  intent(inout) :: iter
    logical,                   intent(inout) :: error
    !
    type(spectrum_t) :: spe1,spe2,correlated
    character(len=*), parameter :: rname='CORRELATION>PROG>LOOP'
    !
    call spe1%associate('spectrum #1',prog%cube1,iter,error)
    if (error) return
    call spe2%associate('spectrum #2',prog%cube2,iter,error)
    if (error) return
    call correlated%allocate('correlated spectrum',prog%correlated,iter,error)
    if (error) return
    call prog%correl%init(spe1,spe2,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,spe1,spe2,correlated,error)
      if (error) return
    enddo ! ie
  end subroutine cubecompute_correlation_prog_loop
  !   
  subroutine cubecompute_correlation_prog_act(prog,ie,spe1,spe2,correlated,error)
    use cubeadm_spectrum_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(correlation_prog_t), intent(inout) :: prog
    integer(kind=entr_k),      intent(in)    :: ie
    type(spectrum_t),          intent(inout) :: spe1
    type(spectrum_t),          intent(inout) :: spe2
    type(spectrum_t),          intent(inout) :: correlated
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='CORRELATION>PROG>ACT'
    !
    call spe1%get(ie,error)
    if (error) return
    call spe2%get(ie,error)
    if (error) return
    call prog%correl%spectrum(spe1,spe2,correlated,error)
    if (error) return
    call correlated%put(ie,error)
    if (error) return
  end subroutine cubecompute_correlation_prog_act
end module cubecompute_correlation
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program spectrum_sum
  use gkernel_interfaces
  use gildas_def
  use image_def
  use phys_const
  ! Local
  character(len=filename_length) :: mapdata,mapsort,polygon,polyfile,name
  integer :: i, ier, ngon, mgon
  real(8), allocatable :: gons(:,:)
  real(4), allocatable :: s1(:)                    !
  integer(4), allocatable :: s0(:)                 !
  integer(size_length) :: n
  real :: scale
  real(8) :: bound(5)
  logical :: error
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('IN$',mapdata)
  call gildas_char('OUT$',mapsort)
  call gildas_char('POLY$',polygon)
  call gildas_close
  !
  ! Input file
  if (len_trim(mapdata).eq.0) goto 100
  if (mapsort.eq.' ') goto 100
  !
  call gildas_null(x)
  x%gil%ndim = 3
  call gdf_read_gildas(x, mapdata,'.lmv',error)
  name = mapdata
  if (error) then
    write(6,*) 'F-SPECTRUM_SUM,  Cannot read input cube'
    goto 100
  endif
  !
  ! Read Polygon File
  call sic_parsef(polygon,polyfile,' ','.pol')
  open (unit=1,file=polyfile,status='OLD', iostat=ier)
  if (ier.ne.0) then
    call gagout('F-SPECTRUM_SUM,  Cannot read polygon file ')
    call putios('E-SPECTRUM_SUM,  ',ier)
    goto 100
  endif
  i = 0
  do while (.true.)
    read (1,*,end=10)
    i = i+1
  enddo
10 rewind(1)
  ngon = i
  !
  ! Define the polygon
  mgon = ngon+1
  allocate (gons(mgon,4),s0(x%gil%dim(3)),s1(x%gil%dim(3)), stat=ier)
  if (ier.ne.0) goto 100
  call define_poly(x,ngon,gons,bound)
  !
  ! Compute the integrated spectrum
  call spectre(ngon,s1,s0,bound,gons,x%r3d,x%gil%bval,x%gil%eval)
  ! Compute the scale
  scale = abs(x%gil%inc(1)*x%gil%inc(2))   ! Pixel area
  if (x%gil%majo.ne.0) then
    scale = scale/pi/x%gil%majo/x%gil%mino*4.0*log(2.0)
  endif
  !
  ! Output file
  call gildas_null(y,type = 'TABLE')
  call sic_parsef(mapsort,y%file,' ','.tab')
  if (error) goto 100
  !
  y%gil%dim(1) = x%gil%dim(3)
  y%gil%dim(2) = 2
  allocate (y%r2d(y%gil%dim(1),2), stat=ier)
  if (ier.ne.0) goto 100
  !
  ! Compute values
  do n=1,y%gil%dim(1) 
    y%r2d(n,1) = (dble(n)-x%gil%ref(3))*x%gil%inc(3)+x%gil%val(3)
  enddo
  !
  ! Intensity values
  y%r2d(:,2) = s1 * scale
  !
  ! Write data
  call gdf_write_image(y,y%r2d,error)
  if (error) goto 100
  call gagout('S-SPECTRUM_SUM,  Successful completion')
  call sysexi(1)  ! Success
  !
100 call sysexi(fatale)  ! Error
!
contains
!
subroutine spectre(np,s1,s0,bound,gons,map,bb,eb)
  use gkernel_interfaces
  integer(kind=4), intent(in)  :: np          !
  real(kind=4),    intent(out) :: s1(:)       !
  integer(kind=4), intent(out) :: s0(:)       !
  real(kind=8),    intent(in)  :: bound(5)    !
  real(kind=8),    intent(in)  :: gons(:,:)   !
  real(kind=4),    intent(in)  :: map(:,:,:)  !
  real(kind=4),    intent(in)  :: bb          !
  real(kind=4),    intent(in)  :: eb          !
  ! Local
  integer(kind=size_length) :: i,j,imin,imax,jmin,jmax,nk
  real(kind=8) :: x,y
  !
  s0(:) = 0.
  s1(:) = 0.
  nk = 0
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  imin = max (1, int(bound(2)) )
  imax = min (ubound(map,1),int(bound(3))+1 )
  jmin = max (1, int(bound(4)) )
  jmax = min (ubound(map,2),int(bound(5))+1 )
  !
  ! Now explore a reasonable part of the map
  if (eb.lt.0.0) then
    do j=jmin,jmax
      do i=imin,imax
        x = dble(i)
        y = dble(j)
        if (gr8_in(x,y,np,gons,bound)) then
          s0 = s0 + 1
          s1 = s1 + map(i,j,:)
        endif
      enddo
    enddo
  else
    do j=jmin,jmax
      do i=imin,imax
        x = dble(i)
        y = dble(j)
        if (gr8_in(x,y,np,gons,bound)) then
          nk = nk+1
          where (abs(map(i,j,:)-bb).gt.eb)
            s0 = s0 + 1
            s1 = s1 + map(i,j,:)
          end where
        endif
      enddo
    enddo
    !
    ! Renormalize to mean in this case:
    !  - s1(ichan) is the sum of all the non-blanked pixels (in the polygon)
    !              for this channel,
    !  - s0(ichan) is the number of non-blanked pixels (in the polygon) for
    !              this channel; it can be different from one channel to
    !              another.
    !  - nk        is the total number of pixels (in the polygon), identical
    !              for all channels (obviously)
    ! We rescale the sum with factor nk/s0 so that the sum is corrected for
    ! the blanked pixels.
    where (s0.ne.0) s1 = nk*s1/s0
  endif
end subroutine spectre
!
subroutine define_poly(x,np,gons,bound)
  use gildas_def
  use image_def
  type(gildas),    intent(in)  :: x          !
  integer(kind=4), intent(in)  :: np         !
  real(kind=8),    intent(out) :: gons(:,:)  !
  real(kind=8),    intent(out) :: bound(5)   !
  ! Local
  integer(kind=4) :: i,ngon
  real(kind=8) :: xgon1,xgon2,ygon1,ygon2,a
  !
  ! Setup the polygon data structure
  ngon = np
  do i=1,ngon
    read(1,*) gons(i,1),gons(i,2)  ! not yet absolute
    ! Convert User coordinates to Pixels
    gons(i,1) = (gons(i,1) - x%gil%val(1))/x%gil%inc(1) + x%gil%ref(1)
    gons(i,2) = (gons(i,2) - x%gil%val(2))/x%gil%inc(2) + x%gil%ref(2)
    a = nint(gons(i,1))
    if (abs(gons(i,1)-a).lt.1e-3) gons(i,1) = a
    a = nint(gons(i,2))
    if (abs(gons(i,2)-a).lt.1e-3) gons(i,2) = a
  enddo
  !
  gons(ngon+1,1) = gons(1,1)
  gons(ngon+1,2) = gons(1,2)
  xgon1 = gons(1,1)
  xgon2 = gons(1,1)
  ygon1 = gons(1,2)
  ygon2 = gons(1,2)
  do i=1,ngon
    gons(i,3) = gons(i+1,1)-gons(i,1)
    if (gons(i+1,1).lt.xgon1) then
      xgon1 = gons(i+1,1)
    elseif (gons(i+1,1).gt.xgon2) then
      xgon2 = gons(i+1,1)
    endif
    gons(i,4) = gons(i+1,2)-gons(i,2)
    if (gons(i+1,2).lt.ygon1) then
      ygon1 = gons(i+1,2)
    elseif (gons(i+1,2).gt.ygon2) then
      ygon2 = gons(i+1,2)
    endif
  enddo
  bound(1) = xgon1-0.01*(xgon2-xgon1)
  bound(2) = xgon1
  bound(3) = xgon2
  bound(4) = ygon1
  bound(5) = ygon2
end subroutine define_poly
!
end program spectrum_sum

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_truncate
  use gbl_message
  !
  public :: uv_truncate_comm
  private
  !
contains
  !
  subroutine uv_truncate_comm(line,error)
    use image_def
    use gkernel_interfaces
    use file_buffers
    use uv_buffers
    !---------------------------------------------------------------------
    ! Truncate a UV Table, by removing baselines out of
    ! a given range (Min and Max)
    !
    ! UV_TRUNCATE Max [Min]
    !
    ! Works on the "current" UV data set: Uses UVS or UVR as needed.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    real(4) :: mymax, mymin, rmin, rmax, length
    integer :: iv, kv, ier
    integer :: nu, nv
    type (gildas) :: hcuv
    real, pointer :: duv_previous(:,:), duv_next(:,:)
    integer, allocatable :: point(:)
    character(len=80) :: mess
    character(len=*), parameter :: rname='UV_TRUNCATE'
    !
    call sic_r4(line,0,1,mymax,.true.,error)
    if (error) return
    !
    mymin = 0.
    call sic_r4(line,0,2,mymin,.false.,error)
    if (error) return
    !
    ! The UV table is available in HUV%
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,rname,'No UV data loaded')
       error = .true.
       return
    endif
    nu = huv%gil%dim(1)
    nv = huv%gil%dim(2)
    !
    ! Read the Baseline length information
    allocate (point(nv), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Memory allocation error')
       error = .true.
       return
    endif
    !
    rmin = mymin**2
    rmax = mymax**2
    !
    kv = 0
    do iv = 1, nv
       length = duv(1,iv)**2 + duv(2,iv)**2
       if (length.ge.rmin .and. length.le.rmax) then
          kv = kv+1
          point(kv) = iv
       endif
    enddo
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    hcuv%gil%dim(2) = kv
    hcuv%gil%nvisi = kv
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
    if (error) return
    !
    ! Now do the job
    do iv = 1,kv
       duv_next(:,iv) = duv(:,point(iv))
    enddo
    !
    ! Finalize the UV Table
    write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
         & huv%gil%nvisi,' before)'
    call map_message(seve%i,rname,mess)
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    !
    ! Copy back to UV data set
    call gdf_copy_header(hcuv,huv,error)
    !
    ! Indicate Weights have changed, optimization and save status
    do_weig = .true.
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
    ! Redefine SIC variables (mandatory)
    call sic_delvariable ('UV',.false.,error)
    call sic_mapgildas ('UV',huv,error,duv)
  end subroutine uv_truncate_comm
end module uv_truncate
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module class_sort_types
  use gmath_dicho_types
  use class_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  ! Type for sorting an index by date, time, and telescope
  type, extends(gi8_dicho_t) :: class_sort_dtt_t
    type(optimize), pointer :: optx
    integer(kind=8) :: searched_entry = 0
  contains
    procedure, public :: compare       => class_sort_compare_dtt
    procedure, public :: compare_value => class_sort_compare_dtt_value
  end type class_sort_dtt_t
  !
contains
  !
  function class_sort_compare_dtt(self,m,l)
    !-------------------------------------------------------------------
    ! Compare first by DOBS, then by UT, then by TELES
    !-------------------------------------------------------------------
    integer(kind=4) :: class_sort_compare_dtt
    class(class_sort_dtt_t), intent(in) :: self
    integer(kind=8),         intent(in) :: m,l
    if (self%optx%dobs(m).ne.self%optx%dobs(l)) then
      if (self%optx%dobs(m).gt.self%optx%dobs(l)) then
        class_sort_compare_dtt = 1
      else
        class_sort_compare_dtt = -1
      endif
      return
    endif
    if (self%optx%ut(m).ne.self%optx%ut(l)) then
      if (self%optx%ut(m).gt.self%optx%ut(l)) then
        class_sort_compare_dtt = 1
      else
        class_sort_compare_dtt = -1
      endif
      return
    endif
    if (self%optx%ctele(m).eq.self%optx%ctele(l)) then
      class_sort_compare_dtt = 0
    elseif (lgt(self%optx%ctele(m),self%optx%ctele(l))) then
      class_sort_compare_dtt = 1
    else
      class_sort_compare_dtt = -1
    endif
  end function class_sort_compare_dtt
  !
  function class_sort_compare_dtt_value(self,m)
    !-------------------------------------------------------------------
    ! Compare the m-th entry to the searched entry
    !-------------------------------------------------------------------
    integer(kind=4) :: class_sort_compare_dtt_value
    class(class_sort_dtt_t), intent(in) :: self
    integer(kind=8),         intent(in) :: m
    class_sort_compare_dtt_value = self%compare(m,self%searched_entry)
  end function class_sort_compare_dtt_value
end module class_sort_types
!
subroutine fix(set,idx,lx,nfound,error,erange,more)
  use phys_const
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Search in the input index for entries matching the parameters in
  ! flg% and smin%/smax%. Selected entries are appended to the output
  ! index (it is the responsibility of the caller to check for
  ! duplicates between old and new entries).
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)           :: set        !
  type(optimize),             intent(in)           :: idx        ! The index to search in
  type(optimize),             intent(inout)        :: lx         ! The optimize'd index to be updated
  integer(kind=entry_length), intent(out)          :: nfound     ! Number of observations actually found
  logical,                    intent(inout)        :: error      ! Error status
  integer(kind=entry_length), intent(in), optional :: erange(2)  ! Entry range to search in (default all)
  integer(kind=entry_length), intent(in), optional :: more       ! Size of allocation extension
  ! Local
  character(len=*), parameter :: rname='FIX'
  logical :: lire
  integer(kind=4) :: tver
  integer(kind=entry_length) :: iobs,inew,jnew,k,ient,extend
  real(kind=4) :: r,any
  type(observation) :: obs
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  logical :: readobs,readhead,found
  type(indx_t) :: ind
  type(time_t) :: time
  !
  ! Set the range of entries to search in
  if (present(erange)) then
    inew = erange(1)
    jnew = erange(2)
  else
    inew = 1
    jnew = idx%next-1
  endif
  !
  if (jnew.lt.inew) then
    ! Input index is empty (or erange has null size): nothing can be found.
    ! lx%next unmodified (caller could be working in append mode)
    nfound = 0
    return
  endif
  !
  ! Set the size of allocation extension.
  if (present(more)) then
    ! Caller thinks he knows how many entries will be found here
    extend = more
  else
    ! Default is to enlarge lx so that is can store all the range of
    ! entries
    extend = jnew-inew+1
  endif
  ! Enlarge lx size so that it can append all the found entries
  call reallocate_optimize(lx,lx%next-1+extend,.true.,.true.,error)
  if (error) return
  !
  call chtoby('ANY ',any,4)
  !
  k = 0
  lire = flg%dobs.or.flg%dred.or.flg%posa
! lire = flg%line.or.flg%sourc.or.flg%teles.or.flg%dobs.or.flg%dred   &
!    .or.flg%off1.or.flg%off2.or.flg%scan.or.flg%subscan.or.flg%posa
  !
  ! readhead: need to read the entry descriptor and header
  readhead = flg%freq .or. flg%user .or. flg%dopos .or.  &
             flg%doswitch .or. flg%dodri .or. flg%dodir
  ! readobs: need to read the entry descriptor
  readobs  = flg%sect .or. readhead
  if (readobs) then
    call init_obs(obs)
    if (readhead) then
      readsec(:) = .false.  ! Read none...
      readsec(class_sec_spe_id)  = flg%freq                  ! except spectroscopic section
      readsec(class_sec_pos_id)  = flg%dopos                 ! and position section
      readsec(class_sec_swi_id)  = flg%doswitch              ! and switching section
      readsec(class_sec_dri_id)  = flg%dodri .or. flg%dodir  ! and drift section
      readsec(class_sec_user_id) = flg%user                  ! and user section (if any)
    endif
  endif
  !
  ! Loop on entries
  call gtime_init(time,jnew-inew+1,error)
  if (error)  return
  do iobs = inew,jnew
     ient = idx%ind(iobs)
     if (sic_ctrlc()) then
       call class_message(seve%w,rname,'Aborted by ^C, index may be incomplete')
       exit
     endif
     if (lire .or. readobs) then
        ! In these cases the informations are not in the input index in memory
        ! * lire = information is the input index on disk (was not saved in
        !          memory),
        ! * readobs = information is in the entry descriptor or in the entry on
        !             disk.
        ! This takes much more time, let's give feedback.
        call gtime_current(time)
     endif
     !
     ! General search in memory
     call index_fromoptimize(idx,iobs,ind,error)
     if (error)  return
     !
     if (flg%kind) then
       if (ind%kind.ne.smin%kind) cycle
     endif
     if (ind%qual.gt.smin%qual) cycle
     if (flg%last) then
        if (ind%ver.lt.0) cycle
     endif
     if (flg%num) then
        if (ind%num.lt.smin%num .or. ind%num.gt.smax%num) cycle
     endif
     if (flg%ver) then
        tver = abs(ind%ver)
        if (tver.lt.smin%ver .or. tver.gt.smax%ver) cycle
     endif
     if (flg%sourc) then
        if (flg%isourc.ge.1) then  ! There is a '*' in the source name
           if (.not.match_string(ind%csour,smin%csour)) cycle
        else
           if (ind%csour.ne.smin%csour) cycle
        endif
     endif
     if (flg%line) then
        if (flg%iline.ge.1) then  ! There is a '*' in the line name
           if (.not.match_string(ind%cline,smin%cline)) cycle
        else
           if (ind%cline.ne.smin%cline) cycle
        endif
     endif
     if (flg%teles) then
        if (flg%iteles.ge.1) then  ! There is a '*' in the telescope name
           if (.not.match_string(ind%ctele,smin%ctele)) cycle
        else
           if (ind%ctele.ne.smin%ctele) cycle
        endif
     endif
     if (flg%off1) then
        if (ind%off1.lt.smin%off1 .and. smin%off1.ne.any) cycle
        if (ind%off1.gt.smax%off1 .and. smax%off1.ne.any) cycle
     endif
     if (flg%off2) then
        if (ind%off2.lt.smin%off2 .and. smin%off2.ne.any) cycle
        if (ind%off2.gt.smax%off2 .and. smax%off2.ne.any) cycle
     endif
     if (flg%scan) then
        if (ind%scan.lt.smin%scan .or. ind%scan.gt.smax%scan) cycle
     endif
     if (flg%subscan) then
        if (ind%subscan.lt.smin%subscan .or. ind%subscan.gt.smax%subscan) cycle
     endif
     if (flg%dobs) then
        if (ind%dobs.lt.smin%dobs .or. ind%dobs.gt.smax%dobs) cycle
     endif
     if (flg%domask) then
        if (.not.fix_by_mask(ind%off1,ind%off2,flg%mask))  cycle
     endif
     ! The next tests need to read more data in the observation header
     if (readobs) then
        call robs(obs,ient,error)
        if (error)  return
        if (readhead) then
          call rheader_sub(set,obs,readsec,error)
          if (error)  return
        endif
     endif
     if (flg%sect) then
       if (.not.obs%head%presec(flg%sectval))  cycle
     endif
     if (flg%freq) then
        if (.not.fix_by_freq(obs,flg%freqmin,flg%freqmax,flg%freqsig)) cycle
     endif
     if (flg%doswitch) then
        if (.not.fix_by_switch(obs,flg%switch)) cycle
     endif
     if (flg%dodri) then
        if (.not.fix_by_drift(obs,flg%driang,pis)) cycle
     endif
     if (flg%dodir) then
        if (.not.fix_by_drift(obs,flg%dirang,2.*pis)) cycle
     endif
     if (flg%dopos) then
        if (.not.fix_by_posi(obs,flg%poslam,flg%posbet,flg%possys,flg%posequ,set%tole)) cycle
     endif
     if (flg%user) then
        call user_sec_fix(obs,found,error)
        if (error)  return
        if (.not.found)  cycle
     endif
     !
     ! More restrictive search
     if (lire) then
        call rix(ient,ind,error)
        if (error) return
        if (flg%dred) then
           if (ind%dred.lt.smin%dred .or. ind%dred.gt.smax%dred) cycle
        endif
        if (flg%posa) then
           r = mod(ind%posa,pis)
           if (r.lt.smin%posa .or. r.gt.smax%posa) cycle
        endif
     endif
     k = k+1
     !
     ! Update the input index
     if (lx%next.gt.lx%mobs) then
        call class_message(seve%e,rname,'Current Index is full')
        error = .true.
        return
     endif
     call index_tooptimize(ind,ient,.true.,lx%next,lx,error)
     if (error)  return
     lx%next = lx%next + 1
  enddo
  !
  nfound = k
  !
  ! Reset search flags
  flg%last = .true.
  flg%num = .false.
  flg%ver = .false.
  flg%line = .false.
  flg%sourc = .false.
  flg%teles = .false.
  flg%dobs = .false.
  flg%dred = .false.
  flg%off1 = .false.
  flg%off2 = .false.
  flg%freq = .false.
  flg%dopos = .false.
  flg%sect = .false.
  flg%domask = .false.
  flg%doswitch = .false.
  !
end subroutine fix
!
function fix_by_freq(obs,fmin,fmax,fsig)
  use classcore_interfaces, except_this=>fix_by_freq
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the input range intersects the frequency range
  ! of the input observation.
  !---------------------------------------------------------------------
  logical                       :: fix_by_freq  ! Function value on return
  type(observation), intent(in) :: obs          ! Input observation
  real(kind=8),      intent(in) :: fmin         ! Frequency range (min)
  real(kind=8),      intent(in) :: fmax         ! Frequency range (max)
  logical,           intent(in) :: fsig         ! Signal or image frequencies?
  ! Local
  real(kind=8) :: freqmin,freqmax
  !
  if (fsig) then
    ! Signal frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      ! Left side of spectrum:
      call abscissa_sigabs_left(obs%head,freqmin)
      ! Right side of spectrum
      call abscissa_sigabs_right(obs%head,freqmax)
    else
      call abscissa_sigabs_right(obs%head,freqmin)
      call abscissa_sigabs_left(obs%head,freqmax)
    endif
  else
    ! Image frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      call abscissa_imaabs_right(obs%head,freqmin)
      call abscissa_imaabs_left(obs%head,freqmax)
    else
      call abscissa_imaabs_left(obs%head,freqmin)
      call abscissa_imaabs_right(obs%head,freqmax)
    endif
  endif
  !
  if (fmax.lt.0.d0) then
    ! Select from fmin to infinite
    fix_by_freq = freqmax.ge.fmin
  elseif (fmin.lt.0.d0) then
    ! Select from 0 to fmax
    fix_by_freq = freqmin.le.fmax
  else
    ! Select from fmin to fmax (which may be equal)
    fix_by_freq = freqmin.le.fmax .and. freqmax.ge.fmin
  endif
  !
end function fix_by_freq
!
function fix_by_switch(obs,swmode)
  use classcore_interfaces, except_this=>fix_by_switch
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation matches the given switching mode
  !---------------------------------------------------------------------
  logical                       :: fix_by_switch ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  integer(kind=4),   intent(in) :: swmode        ! Switching mode code
  !
  if (obs%head%presec(class_sec_swi_id)) then
    fix_by_switch = obs%head%swi%swmod.eq.swmode
  else
    fix_by_switch = swmode.eq.mod_unk
  endif
end function fix_by_switch
!
function fix_by_drift(obs,driang,modu)
  use phys_const
  use classcore_interfaces, except_this=>fix_by_drift
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the drift matches the required angle modulo some
  ! angle
  !---------------------------------------------------------------------
  logical                       :: fix_by_drift  ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  real(kind=4),      intent(in) :: driang        ! [rad] Drift angle
  real(kind=4),      intent(in) :: modu          ! [rad] Modulo angle
  !
  real(kind=4) :: thisang
  real(kind=4), parameter :: tolerance=1.0*rad_per_min  ! [rad] 1 minute tolerance
  !
  if (obs%head%presec(class_sec_dri_id)) then
    thisang = obs%head%dri%apos
    ! Set angle in range [0,modu[
    do while (thisang.lt.0.)  ! Strictly lower than
      thisang = thisang+modu
    enddo
    do while (thisang.ge.modu)  ! Greater or equal to
      thisang = thisang-modu
    enddo
    fix_by_drift = abs(thisang-driang).le.tolerance
  else
    fix_by_drift = .false.
  endif
end function fix_by_drift
!
function fix_by_posi(obs,reflam,refbet,refsys,refequ,tole)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix_by_posi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the observation position matches the reference
  ! position with the given tolerance
  !---------------------------------------------------------------------
  logical                          :: fix_by_posi  ! Function value on return
  type(observation), intent(inout) :: obs          ! Input observation
  real(kind=8),      intent(in)    :: reflam       ! [rad]  Reference lambda position
  real(kind=8),      intent(in)    :: refbet       ! [rad]  Reference beta position
  integer(kind=4),   intent(in)    :: refsys       ! [code] Reference system of coordinates
  real(kind=4),      intent(in)    :: refequ       ! [year] Reference equinox (if relevant)
  real(kind=4),      intent(in)    :: tole         ! [rad]  Tolerance
  ! Local
  character(len=*), parameter :: rname='FIND'
  type(projection_t) :: proj
  real(kind=8) :: rlam,rbet,rxoff,ryoff
  real(kind=4) :: rlamof,rbetof
  logical :: error
  !
  error = .false.
  fix_by_posi = .false.
  !
  ! 1) Convert reference position system to current observation system of
  ! coordinates. NB: conversion routines translate the old absolute reference
  ! to the new absolute reference, and the old offsets (from old reference) to
  ! new offsets (from new reference). If old offsets were 0 (i.e. considering
  ! only the reference position), they are also 0 in the new system! Which is
  ! our case here as we convert the reference position.
  select case (refsys)
  case (type_eq)
    if (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.eq.refequ) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.ne.refequ) then
      call equ_to_equ(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ga) then
      call equ_to_gal(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ga)
    if (obs%head%pos%system.eq.type_ga) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq) then
      call gal_to_equ(reflam,refbet,0.0,   0.0,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ic)
    if (obs%head%pos%system.eq.type_ic) then  ! Same system
      rlam = reflam
      rbet = refbet
    else
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and other system not implemented')
      error = .true.
    endif
  case default
    call class_message(seve%e,rname,'Coordinate system not supported')
    error = .true.
  end select
  if (error)  return
  !
  ! 2) Convert absolute reference position to relative position in current
  !    observation projection system
  call gwcs_projec(obs%head%pos%lam,obs%head%pos%bet,obs%head%pos%projang,  &
    obs%head%pos%proj,proj,error)
  if (error)  return
  call abs_to_rel(proj,rlam,rbet,rxoff,ryoff,1)
  !
  ! 3) Compare using tolerance. Same selection as FIND /OFFSET, i.e. selection
  ! in a square, not a circle.
  fix_by_posi = obs%head%pos%lamof.ge.rxoff-tole .and.  &
                obs%head%pos%lamof.le.rxoff+tole .and.  &
                obs%head%pos%betof.ge.ryoff-tole .and.  &
                obs%head%pos%betof.le.ryoff+tole
  !
end function fix_by_posi
!
function fix_by_mask(lamof,betof,mask)
  use image_def
  use classcore_interfaces, except_this=>fix_by_mask
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation is selected by the input
  ! position-position mask.
  !  Note there is no consistency checking with the center of
  ! projection, kind of projection, and projection angle. This is the
  ! same feature as FIND /RANGE
  !---------------------------------------------------------------------
  logical :: fix_by_mask  ! Function value on return
  real(kind=4), intent(in) :: lamof,betof  ! Offsets
  type(gildas), intent(in) :: mask         ! The GDF 2D mask
  ! Local
  integer(kind=index_length) :: xc,yc
  integer(kind=4) :: xaxi,yaxi
  !
  xaxi = mask%gil%xaxi
  yaxi = mask%gil%yaxi
  !
  xc = nint((lamof-mask%gil%val(xaxi))/mask%gil%inc(xaxi)+mask%gil%ref(xaxi),kind=8)
  yc = nint((betof-mask%gil%val(yaxi))/mask%gil%inc(yaxi)+mask%gil%ref(yaxi),kind=8)
  !
  ! Out of area = not selected
  ! Negative or null value = not selected
  ! Blank value = not selected
  fix_by_mask = xc.ge.1                   .and.  &
                xc.le.mask%gil%dim(xaxi)  .and.  &
                yc.ge.1                   .and.  &
                yc.le.mask%gil%dim(yaxi)  .and.  &
                mask%r2d(xc,yc).gt.0.     .and.  &
                abs(mask%r2d(xc,yc)-mask%gil%bval).gt.mask%gil%eval
  !
end function fix_by_mask
!
!-----------------------------------------------------------------------
! Tools for fast search in Output File
!-----------------------------------------------------------------------
!
subroutine ox_sort_reset(set,error)
  use classcore_interfaces, except_this=>ox_sort_reset
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Recompute the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  logical,             intent(inout) :: error
  !
  call fox_reset
  if (set%uniqueness) then
    call optimize_sort_set_dtt(ox,error)
    if (error)  return
  endif
  !
end subroutine ox_sort_reset
!
subroutine ox_sort_add(set,obs,dupl,error)
  use gbl_message
  use classcore_interfaces, except_this=>ox_sort_add
  use class_common
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation in the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: obs
  logical,             intent(out)   :: dupl
  logical,             intent(inout) :: error
  !
  dupl = .false.
  if (set%uniqueness) then
    if (fileout%desc%vind.ne.3) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (index version in output file must be 3)')
      return
    elseif (.not.fileout%desc%single) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (output file must be single)')
      return
    endif
    call optimize_sort_add_dtt(ox,obs,dupl,error)
    if (error)  return
  endif
  !
  ! Do it last so that this sorting array remains correct in case of
  ! error above
  call fox_add(obs%head%gen%num,fileout%desc%xnext-1)
  !
end subroutine ox_sort_add
!
subroutine fox(anum,ifound)
  use gbl_message
  use classcore_interfaces, except_this=>fox
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Search for observation number Anum (last version) in the sorted
  ! index.
  !----------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in)  :: anum    ! Obs number being searched for
  integer(kind=entry_length),  intent(out) :: ifound  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: jprev,jnext
  !
  ifound = 0
  if (ox%sort%nsort.eq.0) return
  call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
  !
  ! Not found
  if (ox%sort%number(jprev).eq.anum) then
    ifound = ox%sort%entry(jprev)
  else if (ox%sort%number(jnext).eq.anum) then
    ifound = ox%sort%entry(jnext)
  endif
  ! print *,'ox%sort%nsort ',ox%sort%nsort,jprev,jnext
end subroutine fox
!
subroutine fox_reset
  use gbl_message
  use classic_api
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Build up the Sorted Entry/Number list when opening an output file
  ! The Sorted list will then be kept up-to-date at each writing.
  !----------------------------------------------------------------------
  ! Local
  integer(kind=entry_length) :: iobs,j,ifound,jprev,jnext
  integer(kind=obsnum_length) :: anum
  !
  ox%sort%nsort = 0
  do iobs=1,ox%next-1
    if (ox%ver(iobs).lt.0) cycle ! Ignore "old" versions
    if (ox%sort%nsort.eq.0) then
      ox%sort%nsort = 1
      ox%sort%number(1) = ox%num(iobs)
      ox%sort%entry(1) = iobs
    else
      anum = ox%num(iobs)
      if (anum.gt.ox%sort%number(ox%sort%nsort)) then
        ox%sort%nsort = ox%sort%nsort+1
        ox%sort%number(ox%sort%nsort) = anum
        ox%sort%entry(ox%sort%nsort) = iobs
      else if (anum.lt.ox%sort%number(1)) then
        do j=ox%sort%nsort,1,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(1) = anum
        ox%sort%entry(1) = iobs
        ox%sort%nsort = ox%sort%nsort+1
      else
        call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
        if (ox%sort%number(jprev).eq.anum) then
          ifound = ox%sort%entry(jprev)
        else if (ox%sort%number(jnext).eq.anum) then
          ifound = ox%sort%entry(jnext)
        else
          ! Insert between jprev and jnext
          do j=ox%sort%nsort,jnext,-1
            ox%sort%number(j+1) = ox%sort%number(j)
            ox%sort%entry(j+1) = ox%sort%entry(j)
          enddo
          ox%sort%number(jnext) = anum
          ox%sort%entry(jnext) = iobs
          ox%sort%nsort = ox%sort%nsort+1
        endif
      endif
    endif
  enddo
end subroutine fox_reset
!
subroutine fox_next(anum)
  use gbl_message
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Returns next available ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(out) :: anum  !
  !
  if (ox%sort%nsort.eq.0) then
     anum = 1
  else
     anum = ox%sort%number(ox%sort%nsort)+1
  endif
end subroutine fox_next
!
subroutine fox_add (anum, entry)
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>fox_add
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Search for ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in) :: anum   ! Obs number being searched for
  integer(kind=entry_length),  intent(in) :: entry  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: j,jprev,jnext
  !
  if (ox%sort%nsort.eq.0) then
    ox%sort%nsort = 1
    ox%sort%number(1) = anum
    ox%sort%entry(1) = entry
  else
    if (anum.gt.ox%sort%number(ox%sort%nsort)) then
      ox%sort%nsort = ox%sort%nsort+1
      ox%sort%number(ox%sort%nsort) = anum
      ox%sort%entry(ox%sort%nsort) = entry
    else if (anum.lt.ox%sort%number(1)) then
      do j=ox%sort%nsort,1,-1
        ox%sort%number(j+1) = ox%sort%number(j)
        ox%sort%entry(j+1) = ox%sort%entry(j)
      enddo
      ox%sort%number(1) = anum
      ox%sort%entry(1) = entry
      ox%sort%nsort = ox%sort%nsort+1
    else
      call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
      if (ox%sort%number(jprev).eq.anum) then
        ox%sort%entry(jprev) = entry
      else if (ox%sort%number(jnext).eq.anum) then
        ox%sort%entry(jnext) = entry
      else
        ! Insert between jprev and jnext
        do j=ox%sort%nsort,jnext,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(jnext) = anum
        ox%sort%entry(jnext) = entry
        ox%sort%nsort = ox%sort%nsort+1
      endif
    endif
  endif
end subroutine fox_add
!
subroutine locplus (x,np,xlim,nlim,mlim)
  use classic_api
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Find NLIM and MLIM such as
  !      X(NLIM) < XLIM < X(MLIM)
  !  for input data ordered increasingly
  !  Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer(kind=entry_length),  intent(in)  :: np     !
  integer(kind=obsnum_length), intent(in)  :: x(np)  !
  integer(kind=obsnum_length), intent(in)  :: xlim   !
  integer(kind=entry_length),  intent(out) :: nlim   !
  integer(kind=entry_length),  intent(out) :: mlim   !
  ! Local
  integer(kind=entry_length) :: ninf,nsup,nmid
  !
  if (x(1).gt.xlim) then
     nlim = 1
     mlim = 1
     return
  elseif (x(np).lt.xlim) then
     nlim = np
     mlim = np
     return
  endif
  ninf = 1
  nsup = np
  !
  do while(nsup.gt.ninf+1)
     nmid = (nsup + ninf)/2
     if (x(nmid).lt.xlim) then
        ninf = nmid
     else
        nsup = nmid
     endif
  enddo
  nlim = ninf
  mlim = nsup
end subroutine locplus
!
subroutine optimize_sort_set_dtt(in,error)
  use gbl_message
  use class_sort_types
  use classcore_dependencies_interfaces
  use classic_api
  use classcore_interfaces, except_this=>optimize_sort_set_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the date-time-telescope sorting list of the given index
  !---------------------------------------------------------------------
  type(optimize), target, intent(inout) :: in     !
  logical,                intent(inout) :: error  !
  ! Local
  integer(kind=entry_length) :: nelem,ielem
  type(class_sort_dtt_t) :: sortdtt
  !
  nelem = in%next-1
  !
  do ielem=1,nelem
    in%sort%dtt(ielem) = ielem
  enddo
  !
  sortdtt%optx => in
  call sortdtt%sort(in%sort%dtt,nelem,error)
  if (error)  return
end subroutine optimize_sort_set_dtt
!
subroutine optimize_sort_add_dtt(optx,obs,dupl,error)
  use gbl_message
  use class_sort_types
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>optimize_sort_add_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation to the Date-Time-Telescope sorting list.
  ! Raise an error if this new observation is duplicate of a previous
  ! one.
  !---------------------------------------------------------------------
  type(optimize), target, intent(inout) :: optx   ! Index to search in
  type(observation),      intent(in)    :: obs    ! Observation to be added
  logical,                intent(out)   :: dupl   ! Observation is a duplicate?
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=entry_length) :: nelem,jent,kent
  integer(kind=entry_length), parameter :: first=1
  character(len=message_length) :: mess
  type(class_sort_dtt_t) :: sortdtt
  !
  dupl = .false.
  nelem = optx%next-2  ! Observation is already at last position in the index: skip last one
  sortdtt%optx => optx
  sortdtt%searched_entry = optx%next-1  ! Observation is at last position in the index
  !
  if (nelem.le.0) then
    optx%sort%dtt(1) = 1
    return
  elseif (sortdtt%compare_value(optx%sort%dtt(nelem)).lt.0) then
    optx%sort%dtt(nelem+1) = nelem+1
    return
  elseif (sortdtt%compare_value(optx%sort%dtt(first)).gt.0) then
    jent = 1
  else
    call sortdtt%dicho(optx%sort%dtt,nelem,.true.,jent)
  endif
  ! In return jent is the element lower or equal to the request
  ! in the sorting array (optx%sort%dtt)
  !
  ! Check uniqueness
  kent = optx%sort%dtt(jent)
  if (optx%dobs(kent).eq.obs%head%gen%dobs .and.  &
      optx%ut(kent).eq.obs%head%gen%ut     .and.  &
      optx%ctele(kent).eq.obs%head%gen%teles) then
    dupl = .true.
    write(mess,'(A,I0,A,I0,A,F0.8,A,A)')  &
      'Duplicate observation #',obs%head%gen%num,': DOBS=',  &
      obs%head%gen%dobs,', UT=',obs%head%gen%ut,', TELES=',obs%head%gen%teles
    call class_message(seve%e,'UNIQUENESS',mess)
    error = .true.
    return
  endif
  !
  ! Fine, insert the observation at position jent in the sorting array
  do kent=nelem,jent,-1
    optx%sort%dtt(kent+1) = optx%sort%dtt(kent)
  enddo
  optx%sort%dtt(jent) = optx%next-1
end subroutine optimize_sort_add_dtt

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_stitch
  use cubetools_structure
  use cubemain_messaging
  use cubemain_merging
  !
  type :: stitch_comm_t
     type(option_t), pointer :: comm
     type(merging_comm_t)    :: merge
   contains
     procedure, public  :: register => cubemain_stitch_register
     procedure, public  :: parse    => cubemain_stitch_parse
     procedure, public  :: main     => cubemain_stitch_main
  end type stitch_comm_t
  type(stitch_comm_t) :: stitch
  !
contains
  !
  subroutine cubemain_stitch_command(line,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(merging_user_t) :: user
    character(len=*), parameter :: rname='STITCH>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call stitch%parse(line,user,error)
    if (error) return
    !
    call stitch%main(user,error)
    if (error) return
  end subroutine cubemain_stitch_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_stitch_register(stitch,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stitch_comm_t), intent(inout) :: stitch
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='STITCH>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'STITCH','',&
         'Stitch cubes from the current index',&
         'STITCH merges cubes from the current index into one stitched&
         & output cube.'//strg_bl//&
         'Behavior:'//strg_cr//&
         '- Input cubes come from the current default index.'//strg_cr//&
         '- Spectral alignment and output-header controls are provided by&
         & /ALIGN and merge options (/LIKE, /LAXIS, /MAXIS, /FAXIS,&
         & /VAXIS, /PTYPE, /PCENTER, /PANGLE, /FREQUENCY).'//strg_cr//&
         '- Without explicit axis/projection options, output axes are&
         & expanded to cover data from all indexed cubes.'//strg_cr//&
         '- Output family defaults to the first cube family in the index.&
         & /FAMILY overrides it.'//strg_bl//&
         'Examples:'//strg_cr//&
         'CUBE> STITCH'//strg_cr//&
         'CUBE> STITCH /ALIGN VELOCITY'//strg_cr//&
         'CUBE> STITCH /LIKE refcube /FAMILY stitched',&
         cubemain_stitch_command,&
         stitch%comm,&
         error)
    if (error) return
    !
    call stitch%merge%register('stitched',flag_stitch,error)
    if (error) return
  end subroutine cubemain_stitch_register
  !
  subroutine cubemain_stitch_parse(stitch,line,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(stitch_comm_t),  intent(in)    :: stitch
    character(len=*),      intent(in)    :: line
    class(merging_user_t), intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='STITCH>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call stitch%merge%parse(line,user,error)
    if (error) return
  end subroutine cubemain_stitch_parse
  !
  subroutine cubemain_stitch_main(stitch,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(stitch_comm_t),  intent(in)    :: stitch
    class(merging_user_t), intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(merging_prog_t) :: prog
    character(len=*), parameter :: rname='STITCH>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(stitch%merge,prog,error)
    if (error) return
    call prog%main(stitch%merge,error)
    if (error) return
  end subroutine cubemain_stitch_main
end module cubemain_stitch
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine class_noise(set,line,r,error,user_function)
  use gildas_def
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>class_noise
  use class_types
  !----------------------------------------------------------------------
  ! @ public
  ! CLASS ANALYSE Support routine for command
  !   NOISE [Sigma [New]]
  ! Compute a spectrum with a gaussian random noise of specified sigma.
  ! The spectrum is immediately plotted, or loaded into R memory.
  !----------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set             !
  character(len=*),    intent(in)    :: line            ! Input command line
  type(observation),   intent(inout) :: r               !
  logical,             external      :: user_function   !
  logical,             intent(inout) :: error           ! Error flag
  ! Local
  character(len=*), parameter :: rname='NOISE'
  real, allocatable :: ynoise(:)
  real :: sigma
  integer :: n,i,ier
  !
  if (sic_present(0,1)) then
    ! Get RMS from command line
    call sic_r4(line,0,1,sigma,.false.,error)
    if (error) return
    !
  elseif (r%head%xnum.ne.0) then
    ! Guess from header parameters
    call class_noise_guess(rname,r,sigma,error)
    !
  else
    ! Can not guess
    call class_message(seve%e,rname,'No spectrum in memory')
    error = .true.
  endif
  if (error) return
  !
  if (sic_present(0,2)) then  ! NEW
     ! New data
     do i=1,r%cnchan
        r%spectre(i) = rangau(sigma)
     enddo
     ! New baseline section
     r%head%presec(class_sec_bas_id) = .true.
     r%head%bas%deg      = 0
     r%head%bas%sigfi    = sigma
     r%head%bas%aire     = 0.
     r%head%bas%nwind    = 0
     r%head%bas%w1(:)    = 0.
     r%head%bas%w2(:)    = 0.
     r%head%bas%sinus(:) = 0.
     ! New R buffer
     call newdat(set,r,error)
     if (error)  return
     !
  else
     call gr_segm('NOISE',error)
     allocate (ynoise(r%cnchan),stat=ier)
     do i=1,r%cnchan
        ynoise(i) = rangau(sigma)
     enddo
     n = r%cnchan
     if (set%plot.eq.'N') then
        call conne2(1.,1.,1.,ynoise,n,cplot)
     else
        call histo2(1.,1.,1.,ynoise,n,cplot)
     endif
     deallocate(ynoise)
     call gr_segm_close(error)
  endif
  !
end subroutine class_noise
!
subroutine class_noise_guess(rname,obs,sigma,error)
  use gbl_message
  use gbl_constant
  use classcore_interfaces, except_this=>class_noise_guess
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Try to guess the noise (RMS) value from header values
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: rname  ! Calling routine name
  type(observation), intent(in)    :: obs    !
  real(kind=4),      intent(out)   :: sigma  ! Computed RMS
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=8) :: res
  character(len=message_length) :: mess
  !
  if (obs%head%gen%kind.eq.kind_spec) then
    res = obs%head%spe%fres*1.d6  ! MHz
  else
    res = obs%head%dri%width*1.e6  ! MHz
  endif
  !
  if (obs%head%presec(class_sec_bas_id) .and. obs%head%bas%sigfi.gt.0.) then
    sigma = obs%head%bas%sigfi
    write(mess,'(a,1pg10.3,a)') 'RMS value: ',sigma,' (from baseline informations)'
    call class_message(seve%i,rname,mess)
    !
  elseif (obs%head%gen%tsys.gt.0. .and. res.ne.0.d0 .and. obs%head%gen%time.gt.0.) then
    sigma = obs%head%gen%tsys/sqrt(abs(res*obs%head%gen%time))
    write(mess,'(a,1pg10.3,a)') 'RMS value: ',sigma,' (from general informations)'
    call class_message(seve%i,rname,mess)
    !
  else 
    ! This can happen for simulated data e.g. from command MODEL
    call class_message(seve%e,rname,  &
      'Can not guess a noise RMS from header: parameters missing or null')
    error = .true.
    return
  endif
  !
end subroutine class_noise_guess

subroutine mira_list(line,error)
!
! Called by MIRA subroutine run_mira (source code in mira/lib/run.f90), command LIST,
! and SUBROUTINE FINDMIRA (see source code in find.f90).
! See interactive HELP or user's guide for options.
!
! Input: command line from interactive Mira session
! Output: error flag.
!
   use mira
   use pcross_definitions
   use gkernel_interfaces
   !
   implicit none
   !
   character(len = *)             :: line
   logical                        :: error
   !
   integer                        :: flagFebe, nFlagSubscan
   integer, dimension(16)         :: flagSubscan
   integer                        :: i,iday, ier, ih, im, imon, it,    &
                                     iyear, j, j1, j2, k, k1, k2, l,   &
                                     lc, lun, nbd, nchan, npix, nxchan
   real*8                         :: freq, jd, sec, utc, tau, tsys,    &
                                     tsys1, tsys2, trec, trec1, trec2, &
                                     pwv, fluxCorr
   logical                        :: ex,polmode,doflux,    &
                                     doflag,doproject,doreduce,newscan
   logical, dimension(:,:,:), allocatable :: calmask
   character(len=5)               :: receiver
   character(len=4), parameter    :: stokes = 'HVRI'
   character(len=8)               :: backend,tmpbackend, tmpfrontend, tmpproc
   character(len=12)              :: date
   character(len=14)              :: format
   character(len=23)              :: tmpdate, tmpdate0
   character(len=30)              :: user
   character(len=80)              :: backendList, command, output
   character(len=256)             :: ch, file, string
   character(len=3),dimension(12) :: month = (/'jan','feb','mar',   &
                                               'apr','may','jun',   &
                                               'jul','aug','sep',   &
                                               'oct','nov','dec'/)
   !
   integer, dimension(:), allocatable :: indx, part
   !
   if (.not.associated(list)) then
      call gagout('E-LIST, current index list is empty.')
      error = .true.
      return
   endif
   !
   doproject = sic_present(3,0)
   doreduce  = sic_present(4,0)
   doflux    = sic_present(5,0)
   format    = 'shortByScan'
   !
   if (doflux.and.sic_present(6,1)) then
      call sic_ch(line,6,1,format,lc,.false.,error)
      call sic_upper(format)
      if (index(format,'SHORT').eq.0.and.index(format,'LONG').eq.0   &
        .and.index(format,'SCAN').eq.0.and.index(format,'SUB')   &
        .eq.0) then
         call gagout('W-LIST: invalid output format, reset to '//   &
           'shortByScan')
         format = 'SHORTBYSCAN'
      else if (index(format,'LONG').ne.0) then
         call gagout('W-LIST: long output format not yet'//   &
                     ' supported, reset to shortByScan')
         format = 'SHORTBYSCAN'
      endif
   endif
   ! 
   doflag =  doflux.and.sic_present(7,0).and.sic_present(7,1).and.sic_present(7,2)
   if (sic_present(7,0).and.(.not.sic_present(7,1).or..not.sic_present(7,2))) then
      call gagout('W-LIST: please specify a frontend/backend unit and a subscan to be flagged.')
   else if (doflag) then
      call sic_i4(line,7,1,flagFeBe,.true.,error)
      if (error) then
         call gagout('E-LIST: invalid input.')
         return
      endif
      nFlagSubscan = sic_narg(7)-1
      if (nFlagSubscan.eq.0) then
         call gagout('E-LIST: invalid input.')
         error=.true.
         return
      endif
      do i = 1, nFlagSubscan
         call sic_i4(line,7,i+1,flagSubscan(i),.true.,error)
      enddo
   endif
   !
   if (size(list).eq.0) then
      call gagout('I-LIST: index list is empty.')
      error = .true.
      return
   endif
   !
   if (sic_present(1,1)) then
      call sic_ch(line,1,1,output,lc,.false.,error)
      ier = sic_getlun(lun)
      if (index(output,'.')==0) output = trim(output)//'.lis'
      open(lun,file=output,form='formatted',status='unknown')
      !
      do i = 1, size(list)
         if (sic_present(2,0)) then
            !
            if (allocated(part)) deallocate(part,stat=ier)
            allocate(part(list(i)%ncfe),stat=ier)
            if (allocated(indx)) deallocate(indx,stat=ier)
            allocate(indx(list(i)%ncfe),stat=ier)
            do j = 1, list(i)%ncfe
               tmpbackend = adjustl(list(i)%backend(j))
               k1 = index(tmpbackend,'/')+1
               if (k1.eq.1) then
                  part(j) = j
               else
                  k2 = len_trim(tmpbackend)
                  read(tmpbackend(k1:k2),'(i3)') part(j)
               endif
               tmpfrontend = list(i)%frontend(j)
               call sic_upper(tmpfrontend)
               if (index(tmpfrontend,'I').eq.ipc) polmode = .true.
            enddo
            if (polmode) then
               part = 10*part(:)
               do j = 1, list(i)%ncfe
                  tmpfrontend = list(i)%frontend(j)
                  call sic_upper(tmpfrontend)
                  part(j) = part(j)+index(stokes,tmpfrontend(ipc:ipc))
               enddo
            endif
            call indexx(list(i)%ncfe,dble(part),indx)
            !
            k = indx(1)
            it = index(list(i)%dateobs,'T')
            tmpdate = list(i)%dateobs
            write(lun,100) list(i)%scan,   &
                           adjustl(list(i)%object),   &
                           adjustl(list(i)%transition(k)),   &
                           adjustl(list(i)%procedure),   &
                           adjustl(list(i)%switchmode),   &
                           adjustl(list(i)%frontend(k)),   &
                           adjustl(list(i)%backend(k)),   &
                           tmpdate(it-10:it-1),   &
                           i
            do j = 2, list(i)%ncfe
               k = indx(j)
               write(lun,200)   &
                 adjustl(list(i)%transition(k)),   &
                 adjustl(list(i)%frontend(k)),   &
                 adjustl(list(i)%backend(k))
            enddo
         else
            j = index(list(i)%backend(1),'/')
            tmpbackend = adjustl(list(i)%backend(1))
            it = index(list(i)%dateobs,'T')
            tmpdate = list(i)%dateobs
            if (j.eq.0) j = len_trim(tmpbackend)+1
            if (doproject) then
               write(lun,301) list(i)%scan,   &
                              adjustl(list(i)%object),   &
                              adjustl(list(i)%procedure),   &
                              adjustl(list(i)%switchmode),   &
                              tmpbackend(1:j-1),   &
                              tmpdate(it-10:it-1),   &
                              list(i)%project,   &
                              i
            else
               write(lun,300) list(i)%scan,   &
                              adjustl(list(i)%object),   &
                              adjustl(list(i)%procedure),   &
                              adjustl(list(i)%switchmode),   &
                              tmpbackend(1:j-1),   &
                              tmpdate(it-10:it-1),   &
                              i
            endif
         endif
      enddo
      close(lun)
      ier = gag_frelun(lun)
   else if (doreduce) then
      if (sic_present(4,1)) then
         call sic_ch(line,4,1,output,lc,.false.,error)
         ier = sic_getlun(lun)
         if (index(output,'.')==0) output = trim(output)//'.mira'
      else
         ier = sic_getlun(lun)
         output = 'reduce.mira'
      endif
      open(lun,file=output,form='formatted',status='unknown')
      file = 'INPUT_FILE:'
      call sic_parsef(file,ch,' ',' ')
      write(lun,*) 'ON ERROR PAUSE'
      write(lun,*) 'FILE IN "'//trim(ch)//'"'
      if (sic_present(4,2)) then
         call sic_ch(line,4,2,output,lc,.false.,error)
         inquire(file=output,exist=ex)
         if (index(output,'.')==0) output = trim(output)//'.30m'
         if (ex) then
            string = 'FILE OUT '//trim(output)
         else
            string = 'FILE OUT '//trim(output)//' NEW'
         endif
      else
         inquire(file='mira.30m',exist=ex)
         if (ex) then
            string = 'FILE OUT mira.30m'
         else
            string = 'FILE OUT mira.30m NEW'
         endif
      endif
      write(lun,*) trim(string)
      write(lun,*)'!---------------------------------------'//   &
                   '---------------------------------------'
      if (allocated(choice%backend).and.size(choice%backend).ne.0) then
         backendList = " /BACKEND"
         do j = 1, size(choice%backend)
            backendList = trim(backendList)//" "//choice%backend(j)
         enddo
      else
         backendList = ""
      endif
      do i = 1, size(list)
         newscan = .false.
         if (i.gt.1) then
            tmpdate0 = list(i-1)%dateobs
            tmpdate = list(i)%dateobs
            it = index(tmpdate,'T')
         endif
         if (i.eq.1) then
            write(lun,*) 'FIND /OBSERVED '//list(i)%dateobs(1:10)//backendList
            write(lun,*)'!---------------------------------------'//   &
                         '---------------------------------------'
            newscan = .true.
         else if (tmpdate0(it-10:it-1).ne.tmpdate(it-10:it-1)) then
            write(lun,*)'!---------------------------------------'//   &
                         '---------------------------------------'
            write(lun,*) 'FIND /OBSERVED '//tmpdate(it-10:it-1)//backendList
            write(lun,*)'!---------------------------------------'//   &
                         '---------------------------------------'
            newscan = .true.
         else if (list(i-1)%scan.ne.list(i)%scan) then
            newscan = .true.
         endif
         if (newscan) then
            write(string,'(A5,I0)') 'SCAN ',list(i)%scan
            write(string(20:30),'(A11)') ' ! '//list(i)%procedure
            write(string(31:39),'(A9)')  '   '//list(i)%project
            write(lun,*) trim(string)
            tmpproc = adjustl(list(i)%procedure)
            call sic_upper(tmpproc)
            if (.not.sic_present(2,0)) then
               polmode = .false.
               do k = 1, list(i)%ncfe
                  tmpfrontend = list(i)%frontend(k)
                  call sic_upper(tmpfrontend)
                  if (index(tmpfrontend,"I").eq.ipc) then
                     polmode = .true.
                     exit
                  endif
               enddo
            endif
            if ((index(tmpproc,'CAL').eq.0.and.index(tmpproc,'FOC').eq.0.)   &
                .or.(index(tmpproc,'CAL').ne.0.and.polmode)) then
               write(lun,*) 'CAL all'
               write(lun,*) 'WRITE /FEBE all /PIXEL all'
            endif
         endif
      enddo
      close(lun)
      ier = gag_frelun(lun)

   else if (doflux) then

      command = trim(line)
      call sic_get_logi('doPause',dopause,error)
      ier = sic_getlun(lun)
      read(list(1)%dateobs(1:4),'(I4)')    iyear
      read(list(1)%dateobs(6:7),'(I2.2)')  imon
      read(list(1)%dateobs(9:10),'(I2.2)') iday
      read(list(1)%dateobs(12:13),'(I2.2)') ih
      read(list(1)%dateobs(15:16),'(I2.2)') im
      read(list(1)%dateobs(18:23),'(F6.3)') sec
      if (.not.sic_present(5,1)) then
         write(output(1:21),'(A21)') 'point_'//list(1)%dateobs(9:10)//   &
                                     '-'//month(imon)//   &
                                     '-'//list(1)%dateobs(1:4)//'.dat'
         open(lun,file=output,status='unknown')
      else
         call sic_ch(line,5,1,backend,lc,.false.,error)
         call sic_lower(backend)
         if (index(backend(1:2),'1m').ne.0) then
            write(output(1:19),'(A19)') '1mhz-'//list(1)%dateobs(1:4)//'-' &
                                               //list(1)%dateobs(6:7)//'-' &
                                               //list(1)%dateobs(9:10)     &
                                               //'.dat'
            open(lun,file=output,status='unknown')
            call sic_date(date)
            call sic_lower(date)
            write(lun,'(A1)')  '!'
            write(lun,'(A11,A19)') '! $Header: ', output(1:19)
            call sic_user(user)
            write(lun,'(A60)') '! Written on '//date//' by: '//user
            write(lun,'(A12)') '! MIRA '//miraVersion
         else if (index(backend(1:2),'4m').ne.0) then
            write(output(1:19),'(A19)') '4mhz-'//list(1)%dateobs(1:4)//'-'  &
                                               //list(1)%dateobs(6:7)//'-'  &
                                               //list(1)%dateobs(9:10)//'-' &
                                               //'.dat'
            open(lun,file=output,status='unknown')
            call sic_date(date)
            call sic_lower(date)
            write(lun,'(A1)')  '!'
            write(lun,'(A11,A19)') '! $Header: ', output(1:19)
            call sic_user(user)
            write(lun,'(A70)') '! Written on '//date//' by: '//user
            write(lun,'(A12)') '! MIRA '//miraVersion
         else if (index(backend(1:2),'ve').ne.0) then
            write(output(1:20),'(A20)') 'vespa-'//list(1)%dateobs(1:4)//'-' &
                                                //list(1)%dateobs(6:7)//'-' &
                                                //list(1)%dateobs(9:10)     &
                                                //'.dat'
            open(lun,file=output,status='unknown')
            call sic_date(date)
            call sic_lower(date)
            write(lun,'(A1)')  '!'
            write(lun,'(A11,A20)') '! $Header: ', output(1:20)
            call sic_user(user)
            write(lun,'(A60)') '! Written on '//date//' by: '//user
            write(lun,'(A12)') '! MIRA '//miraVersion
         else if (index(backend(1:2),'wi').ne.0) then
            write(output(1:20),'(A20)') 'wilma-'//list(1)%dateobs(1:4)//'-' &
                                                //list(1)%dateobs(6:7)//'-' &
                                                //list(1)%dateobs(9:10)     &
                                                //'.dat'
            open(lun,file=output,status='unknown')
            call sic_date(date)
            call sic_lower(date)
            write(lun,'(A1)')  '!'
            write(lun,'(A11,A20)') '! $Header: ', output(1:20)
            call sic_user(user)
            write(lun,'(A60)') '! Written on '//date//' by: '//user
            write(lun,'(A12)') '! MIRA '//miraVersion
         endif
      endif

      if (.not.sic_present(5,1)) then
         write(lun,'(A1)')  '!'
         write(lun,400)     '!', 'YYYY', 'MM', 'DD', 'UT[h]',   &
                            'JD -0.5 days', 'Scan', 'Frequ.', 'Elv.',   &
                            'Area', '+/-', 'Pos.', '+/-', 'Width',   &
                            '+/-', 'Peak', '+/-', 'Date', 'Dir.',   &
                            'Source','Receiver','LST','Azm.','parAngle',   &
                            'tau','Tsys','Trec','Tamb','pAmb','R.H.','corr','quality'
         write(lun,401)     '!', '____', '__', '__', '_____',   &
                            '____________', '____', '_______','____',   &
                            '______________','____________',   &
                            '___________','____________',   &
                            '_____________','______','__________',   &
                            '________','________','_____','________',   &
                            '____','_____','_____','____','____','____','_____','_______'
         write(lun,'(A1)') '!'
      else
         write(lun,'(A1)')  '!'
         write(lun,500)     '!', 'YYYY', 'MM', 'DD', 'UT[h]',           &
                            'JD -0.5 days', 'Scan', 'Frequ.', 'Elv.',   &
                            'Flux [K]', '+/-', 'Date', 'Source',        &
                            'Fend/Bend', 'LST','Azm.','parAngle', 'tau', &
                            'Tsys', 'Trec','Tamb','pAmb','R.H.','pwv',  &
                            'tInt[s]','nsub','quality'                
         write(lun,'(A204)') '!_____________________________'//         &
                             '______________________________'//         &
                             '______________________________'//         &
                             '______________________________'//         &
                             '______________________________'//         &
                             '______________________________'//         &
                             '________________________'
         write(lun,'(A1)')   '!'
      endif


      do i = 1, size(list)
         write(string,'(A5,I4)') 'scan ',list(i)%scan
         call exec_program(string)
         tmpproc = list(i)%procedure
         call sic_upper(tmpproc)
         if (index(tmpproc,'POINT').ne.0.and.doflux.and.doflag) then
            write(string,'(A5,I2,A10)') 'flag ',flagFebe,' /subscan '
            do l = 1, nFlagSubscan
               j1 = 19+(l-1)*3
               j2 = j1+1
               write(string(j1:j2),'(I2)') flagSubscan(l) 
            enddo
            call exec_program(string)
         endif
         tmpBackend = adjustl(list(i)%backend(1))
         call sic_lower(tmpBackend)
         if (index(scan%header%scantype,'calibGrid').ne.0.and.     &
             tmpBackend(1:2).eq.backend(1:2)) then
            write(string,'(A7)') 'cal all'
            call exec_program(string)
         endif
         if (index(tmpproc,'ONOFF').ne.0.and.tmpBackend(1:2).eq.backend(1:2)) &
         then
            write(string,'(A7)') 'cal all'
            call exec_program(string)
            if (i.gt.1) then
               if (list(i-1)%scan.eq.list(i)%scan) then
                  j1 = j2+1
                  j2 = j1+list(i)%ncfe
               else
                  j1 = 1 
                  j2 = list(1)%ncfe
               endif
            else
               j1 = 1 
               j2 = list(1)%ncfe
            endif
            do j = j1, j2 
               nbd = febe(j)%header%febeband
               nxchan = size(gains(j)%tauzen,3)
               npix = febe(j)%header%febefeed
               allocate(calmask(nbd,npix,nxchan),stat=ier)
               calmask = gains(j)%tsys.ne.-1.
               freq = nint(array(j)%header(1)%restfreq*1.d-6)/1000.
               tau  = sum(gains(j)%tauzen,calmask)/count(calmask)
               tau  = nint(100*tau)/100.
               pwv  = sum(gains(j)%h2omm,calmask)/count(calmask)
               pwv  = nint(100*pwv)/100.
               if (index(backend,'ve').ne.0.and.j.gt.j1+1) then
                  calmask = gains(j1)%tsys.ne.-1.
                  tsys1 = sum(gains(j1)%tsys,calmask)/count(calmask)
                  trec1 = sum(gains(j1)%trx,calmask)/count(calmask)
                  calmask = gains(j1+1)%tsys.ne.-1.
                  tsys2 = sum(gains(j1+1)%tsys,calmask)/count(calmask)
                  trec2 = sum(gains(j1+1)%trx,calmask)/count(calmask)
                  tsys = nint(10*sqrt(tsys1*tsys2))/10.
                  trec = nint(10*sqrt(trec1*trec2))/10.
                  fluxCorr = sum(gains(j1+1)%phasearray)     &                          
                             /size(gains(j1+1)%phasearray)
               else
                  calmask = gains(j)%tsys.ne.-1.
                  tsys = sum(gains(j)%tsys,calmask)/count(calmask) 
                  tsys = nint(10*tsys)/10.
                  trec = sum(gains(j)%trx,calmask)/count(calmask) 
                  trec = nint(10*trec)/10.
                  fluxCorr = 1.0
               endif
               deallocate(calmask)
               nchan = data(j)%header%channels
               call fluxBackend(lun,freq,iyear,imon,iday,month(imon),   &
                                j,nbd,nchan,tau,pwv,tsys,trec,fluxCorr)
               if (dopause) then
                  call gagout('type c to continue, q to quit')
                  read(*,*) string
                  call sic_upper(string)
                  if (string(1:1).eq.'Q') then
                     close(lun)
                     ier = gag_frelun(lun)
                     call sic_insert(command)
                     return
                  endif
               endif
            enddo
            write(lun,'(A1)') '!'
         else if (index(tmpproc,'POINT').ne.0.) then
            write(string,'(A7)') 'cal all'
            call exec_program(string)
            do j = 1, list(i)%ncfe
               freq = nint(array(j)%header(1)%restfreq*1.d-6)/1000.
               tau  = nint(100*gains(j)%tauzen(1,1,1))/100.
               tsys = nint(10*gains(j)%tsys(1,1,1))/10.
               trec = nint(10*gains(j)%trx(1,1,1))/10.
               receiver = scan%data%febe(j)
               write(string,'(A6,I2)') 'solve ',j
               call exec_program(string)
               call fluxfill(lun,freq,iyear,imon,iday,month(imon),format,receiver, &
                             tau,tsys,trec,j,doflag,flagFebe,flagSubscan,nFlagSubscan)
               if (dopause) then
                  call gagout('type c to continue, q to quit')
                  read(*,*) string
                  call sic_upper(string)
                  if (string(1:1).eq.'Q') then
                     close(lun)
                     ier = gag_frelun(lun)
                     call sic_insert(command)
                     return
                  endif
               endif
            enddo
            write(lun,'(A1)') '!'
         endif
      enddo
      close(lun)
      ier = gag_frelun(lun)
      call sic_insert(command)
   else
      do i = 1, size(list)
         if (sic_present(2,0)) then
            !
            if (allocated(part)) deallocate(part,stat=ier)
            allocate(part(list(i)%ncfe),stat=ier)
            if (allocated(indx)) deallocate(indx,stat=ier)
            allocate(indx(list(i)%ncfe),stat=ier)
            polmode = .false.
            do j = 1, list(i)%ncfe
               tmpbackend = adjustl(list(i)%backend(j))
               k1 = index(tmpbackend,'/')+1
               if (k1.eq.1) then
                  part(j) = j
               else
                  k2 = len_trim(tmpbackend)
                  read(tmpbackend(k1:k2),'(i3)') part(j)
               endif
               tmpfrontend = list(i)%frontend(j)
               call sic_upper(tmpfrontend)
               if (index(tmpfrontend,'I').eq.ipc) polmode = .true.
            enddo
            if (polmode) then
               part = 10*part(:)
               do j = 1, list(i)%ncfe
                  tmpfrontend = list(i)%frontend(j)
                  call sic_upper(tmpfrontend)
                  part(j) = part(j)+index(stokes,tmpfrontend(ipc:ipc))
               enddo
            endif
            call indexx(list(i)%ncfe,dble(part),indx)
            !
            k = indx(1)
            it = index(list(i)%dateobs,'T')
            tmpdate = list(i)%dateobs
            write(*,100) list(i)%scan,   &
                         adjustl(list(i)%object),   &
                         adjustl(list(i)%transition(k)),   &
                         adjustl(list(i)%procedure),   &
                         adjustl(list(i)%switchmode),   &
                         adjustl(list(i)%frontend(k)),   &
                         adjustl(list(i)%backend(k)),   &
                         tmpdate(it-10:it-1),   &
                         i
            do j = 2, list(i)%ncfe
               k = indx(j)
               write(*,200)   &
                 adjustl(list(i)%transition(k)),   &
                 adjustl(list(i)%frontend(k)),   &
                 adjustl(list(i)%backend(k))
            enddo
         else
            tmpbackend = adjustl(list(i)%backend(1))
            k = index(tmpbackend,'/')
            if (k.eq.0) k = len_trim(tmpbackend)+1
            it = index(list(i)%dateobs,'T')
            tmpdate = list(i)%dateobs
            if (doproject) then
               write(*,301) list(i)%scan,   &
                            adjustl(list(i)%object),   &
                            adjustl(list(i)%procedure),   &
                            adjustl(list(i)%switchmode),   &
                            tmpbackend(1:k-1),   &
                            tmpdate(it-10:it-1),   &
                            list(i)%project,   &
                            i
            else
               write(*,300) list(i)%scan,   &
                            adjustl(list(i)%object),   &
                            adjustl(list(i)%procedure),   &
                            adjustl(list(i)%switchmode),   &
                            tmpbackend(1:k-1),   &
                            tmpdate(it-10:it-1),   &
                            i
            endif
         endif
      enddo
   endif
   !
100 format(t1,i4,t6,a10,t17,a10,t27,a8,t36,a14,   &
           t51,a5,t57,a8,t66,a10,t76,i4)
200 format(t17,a10,t51,a5,t57,a8)
300 format(t1,i4,t6,a10,t17,a8,t31,a16,t50,a5,t58,a10,t70,i4)
301 format(t1,i4,t6,a10,t17,a8,t31,a16,t50,a5,t58,a10,t70,a6,t77,i4)
400 format(t1,a1,t5,a4,t10,a2,t13,a2,t16,a5,t22,a12,t37,a4,t43,a6,t52,     &
           a4,t60,a5,t69,a3,t75,a4,t83,a3,t90,a5,t97,a3,t104,a4,t111,      &
           a3,t118,a4,t133,a4,t141,a6,t152,a8,t161,a3,t171,a4,t177,        &
           a8,t186,a3,t191,a4,t197,a4,t203,a4,t208,a4,t213,a4,t218,a4,t224,a7)
401 format(t1,a1,t5,a4,t10,a2,t13,a2,t16,a5,t22,a12,t37,a4,t43,a7,t52,     &
           a4,t60,a14,t76,a12,t90,a11,t104,a12,t118,a13,t133,a6,t141,      &
           a10,t152,a8,t161,a8,t171,a5,t177,a8,t186,a4,t191,a5,t197,       &
           a5,t203,a4,t208,a4,t213,a4,t218,a4,t224,a7)
500 format(t1,a1,t5,a4,t10,a2,t13,a2,t16,a5,t22,a12,t37,a4,t43,a6,t52,a4,  &
           t60,a8,t76,a3,t88,a4,t102,a6,t113,a9,t123,a3,t132,a4,t138,      &
           a8,t147,a3,t152,a4,t159,a4,t165,a4,t170,a4,t176,a4,t181,a3,     &
           t185,a7,t193,a4,t198,a7)
   !
   return
!
end subroutine mira_list
!
!
!
subroutine fluxfill(lun,freq,iyear,imon,iday,month,   &
     format,receiver,tau,tsys,trec,ifb,doflag,flagFebe,flagSubscan,nFlagSubscan)
!
! Called by mira_list. Creates an output ASCII file with flux densities from
! monitoring sessions.
!
   use mira
   use pcross_definitions
   implicit none
   integer            :: ifb, iyear, imon, iday, lsth, lstm, lsts,   &
                         lun, flagFebe, nFlagSubscan
   integer, dimension(16) :: flagSubscan
   real*8             :: freq, tau, tsys, trec
   character(len=  3) :: month
   character(len=  5) :: receiver
   character(len=  6) :: dir
   character(len= 10) :: source
   character(len= 13) :: date
   character(len= 14) :: format
   integer            :: ipix, iqual, k, l
   real*8             :: area, azm, corr, diff, earea, epeak, epos, ewidth,  &
                         elv, jd, pamb, parangle, peak, pos, rh, tamb,       &
                         utc, width
   logical            :: doflag, error, flagit
   date(1:1) = "'"
   date(13:13) = "'"
   date(4:4) = "-"
   date(8:8) = "-"
   write(date(2:3),'(I2)') iday
   write(date(5:7),'(A3)') month
   write(date(9:12),'(I4)') iyear
   dir(1:5) = "'AZI'"
   source = "'"//scan%header%object(1:8)//"'"
   tamb = nint(mon(1)%data%tamb_p_humid(1,1)+273.15)
   pamb = nint(mon(1)%data%tamb_p_humid(1,2))
   rh   = nint(mon(1)%data%tamb_p_humid(1,3))
   if (index(format,'SUB').ne.0) then
      do k = 1, scan%header%nobs
         if (index(pcross(k)%dir,'+LAM').ne.0) then
            dir = "'"//"AZI+"
         else if (index(pcross(k)%dir,'-LAM').ne.0) then
            dir = "'"//"AZI-"
         else if (index(pcross(k)%dir,'+BET').ne.0) then
            dir = "'"//"ELV+"
         else if (index(pcross(k)%dir,'-BET').ne.0) then
            dir = "'"//"ELV-"
         endif
         do l = 1, size(data(1)%data%subscan)
            if (data(1)%data%subscan(l).eq.k) then
               lsth = int(data(1)%data%lst(l)/3600.)
               lstm = int((data(1)%data%lst(l)-3600.*lsth)/60.)
               lsts = nint(data(1)%data%lst(l)-3600.*lsth-60.*lstm)
               exit
            endif
         enddo
         do l = 1, size(mon(1)%data%subscan)
            if (mon(1)%data%subscan(l).eq.k) then
               azm = nint(mon(1)%data%encoder_az_el(l,1)*10.)/10.
               elv = nint(mon(1)%data%encoder_az_el(l,2)*10.)/10.
               parangle = nint(mon(1)%data%parangle(l)*10.)/10.
               exit
            endif
         enddo
         utc = raw(k)%antenna(1)%subscanstart
         utc = nint((utc-int(utc))*2400)/100.
         jd=nint(raw(k)%antenna(1)%subscanstart*1.d4)/1.d4+2.4d6
         area   = pcross(k)%fun%par(1)%value
         pos    = pcross(k)%fun%par(2)%value
         if (index(dir,'AZI').ne.0) then
            corr  = nint((mon(ifb)%header%iaobs_caobs_ieobs(2)*3.6d+3   &
                    +pcross(k)%fun%par(2)%value)*10)/10.
         else if (index(dir,'ELV').ne.0) then
            corr  = nint((mon(ifb)%header%iaobs_caobs_ieobs(3)*3.6d+3   &
                    +pcross(k)%fun%par(2)%value)*10)/10.
         endif
         width  = pcross(k)%fun%par(3)%value
         earea  = pcross(k)%fun%par(1)%error
         epos   = pcross(k)%fun%par(2)%error
         ewidth = pcross(k)%fun%par(3)%error
         peak = area/width/sqrt(pi/(4.*log(2.d0)))
         epeak = 1./(width*width*sqrt(pi/(4.*log(2.d0))))   &
                 *sqrt((width*earea)**2+(area*ewidth)**2)
         area   = nint(100.*area)/100.
         pos    = nint(100.*pos)/100.
         width  = nint(100.*width)/100.
         peak   = nint(1000.*peak)/1000.
         earea  = nint(100.*earea)/100.
         epos   = nint(100.*epos)/100.
         ewidth = nint(100.*ewidth)/100.
         epeak  = nint(1000.*epeak)/1000.
         flagit = .false.
         if (doflag.and.flagFebe.eq.ifb) then
            do l = 1, scan%header%nobs
               if (k.eq.flagSubscan(l)) flagit = .true.
            enddo
         endif
         if (doflag.and.flagFebe.eq.ifb.and.flagit) then
            peak = -1000.
            area  = -1000.
            write(lun,99) '!', iyear, imon, iday , utc, jd,   &
                           scan%header%scannum, freq, elv, area, earea,   &
                           pos, epos, width, ewidth, peak, epeak, date,   &
                           dir, source, receiver, lsth, ":", lstm, ":",   &
                           lsts, azm, parangle, tau, tsys, trec, tamb,   &
                           pamb, rh, corr
         else
            write(lun,100) iyear, imon, iday , utc, jd,   &
                           scan%header%scannum, freq, elv, area, earea,   &
                           pos, epos, width, ewidth, peak, epeak, date,   &
                           dir, source, receiver, lsth, ":", lstm, ":",   &
                           lsts, azm, parangle, tau, tsys, trec, tamb,   &
                           pamb, rh, corr
         endif
      enddo
   else
      azm = nint(mon(1)%data%encoder_az_el(1,1)*10.)/10.
      elv = nint(mon(1)%data%encoder_az_el(1,2)*10.)/10.
      parangle = nint(mon(1)%data%parangle(1)*10.)/10.
      lsth = int(data(1)%data%lst(1)/3600.)
      lstm = int((data(1)%data%lst(1)-3600.*lsth)/60.)
      lsts = nint(data(1)%data%lst(1)-3600.*lsth-60.*lstm)
      utc = raw(1)%antenna(1)%subscanstart
      utc = nint((utc-int(utc))*2400)/100.
      jd = nint(raw(1)%antenna(1)%subscanstart*1.d4)/1.d4+2.4d6
      call sic_get_dble('PNT%AZM%FIT%AREA',area,error)
      call sic_get_dble('PNT%AZM%FIT%POSITION',pos,error)
      call sic_get_dble('PNT%AZM%FIT%WIDTH',width,error)
      call sic_get_dble('PNT%AZM%ERROR%AREA',earea,error)
      call sic_get_dble('PNT%AZM%ERROR%POSITION',epos,error)
      call sic_get_dble('PNT%AZM%ERROR%WIDTH',ewidth,error)
      peak = area/width/sqrt(pi/(4.*log(2.d0)))
      epeak = 1./(width*width*sqrt(pi/(4.*log(2.d0))))   &
              *sqrt((width*earea)**2+(area*ewidth)**2)
      area  = nint(100.*area)/100.
      pos   = nint(100.*pos)/100.
      corr  = nint((mon(ifb)%header%iaobs_caobs_ieobs(2)*3.6d+3+pos)*10)/10.
      width = nint(100.*width)/100.
      peak  = nint(1000.*peak)/1000.
      earea  = nint(100.*earea)/100.
      epos   = nint(100.*epos)/100.
      ewidth = nint(100.*ewidth)/100.
      epeak  = nint(1000.*epeak)/1000.
!
      if (index(receiver,'HERA').ne.0) then
         ipix = 5
         call gagout('W-LIST, defaults to central pixel.')
      else
         ipix = 1
      endif
!
      iqual = 0
      diff = 0.
      l = 0
      do k = 2, scan%header%nobs
         if (index(pcross(k-1)%dir,'LAM').ne.0                     &
             .and.index(pcross(k)%dir,'LAM').ne.0.                 &
             .and.pcross(k-1)%dir.ne.pcross(k)%dir) then
             l = l+1
             diff = diff+abs(pcross(k)%fun%par(2)%value            &
                             -pcross(k-1)%fun%par(2)%value)        &
                         /(febe(ifb)%data%hpbw(ipix,1)*3.6d+3)
         endif
      enddo
      diff = diff/l
      if (diff.gt.0.1) iqual = 1
!
      write(lun,101) iyear, imon, iday , utc, jd,   &
                     scan%header%scannum, freq, elv, area, earea,   &
                     pos, epos, width, ewidth, peak, epeak, date,   &
                     dir, source, receiver, lsth, ":", lstm, ":",   &
                     lsts, azm, parangle, tau, tsys, trec, tamb,   &
                     pamb, rh, corr, iqual
      call sic_get_dble('PNT%ELV%FIT%AREA',area,error)
      call sic_get_dble('PNT%ELV%FIT%POSITION',pos,error)
      call sic_get_dble('PNT%ELV%FIT%WIDTH',width,error)
      call sic_get_dble('PNT%ELV%ERROR%AREA',earea,error)
      call sic_get_dble('PNT%ELV%ERROR%POSITION',epos,error)
      call sic_get_dble('PNT%ELV%ERROR%WIDTH',ewidth,error)
      peak = area/width/sqrt(pi/(4.*log(2.d0)))
      epeak = 1./(width*width*sqrt(pi/(4.*log(2.d0))))   &
              *sqrt((width*earea)**2+(area*ewidth)**2)
      area  = nint(100.*area)/100.
      pos   = nint(100.*pos)/100.
      corr  = nint((mon(ifb)%header%iaobs_caobs_ieobs(3)*3.6d+3+pos)*10)/10.
      width = nint(100.*width)/100.
      peak   = nint(1000.*peak)/1000.
      earea  = nint(100.*earea)/100.
      epos   = nint(100.*epos)/100.
      ewidth = nint(100.*ewidth)/100.
      epeak  = nint(1000.*epeak)/1000.
!
      iqual = 0
      diff = 0.
      l = 0
      do k = 2, scan%header%nobs
         if (index(pcross(k-1)%dir,'BET').ne.0                            &
             .and.index(pcross(k)%dir,'BET').ne.0.   &
             .and.pcross(k-1)%dir.ne.pcross(k)%dir) then
             l = l+1
             diff = diff+abs(pcross(k)%fun%par(2)%value                   &
                             -pcross(k-1)%fun%par(2)%value)               &
                         /(febe(ifb)%data%hpbw(ipix,1)*3.6d+3)
         endif
      enddo
      diff = diff/l
      if (diff.gt.0.1) iqual = 1
      dir(1:5) = "'ELV'"
      write(lun,101) iyear, imon, iday , utc, jd,   &
                     scan%header%scannum, freq, elv, area, earea,   &
                     pos, epos, width, ewidth, peak, epeak, date,   &
                     dir, source, receiver, lsth, ":", lstm, ":",   &
                     lsts, azm, parangle, tau, tsys, trec, tamb,   &
                     pamb, rh, corr, iqual
   endif
   return
99  format(t1,a1,t5,i4,t10,i2,t13,i2,t16,f5.2,t22,f12.4,t37,i4,t43,f7.3,   &
           t52,f4.1,t60,f6.2,t68,f6.2,t75,f6.2,t83,f5.2,t90,f5.2,t97,   &
           f4.2,t104,f6.3,t111,f5.3,t118,a13,t133,a6,t141,a10,   &
           t154,a5,t161,i2.2,a1,i2.2,a1,i2.2,t171,f5.1,t179,f6.1,t186,   &
           f4.2,t191,f5.1,t197,f5.1,t203,f4.0,t208,f4.0,t213,f4.0,t218,f5.1,t224,a7)
100 format(t5,i4,t10,i2,t13,i2,t16,f5.2,t22,f12.4,t37,i4,t43,f7.3,   &
           t52,f4.1,t60,f6.2,t68,f6.2,t75,f6.2,t83,f5.2,t90,f5.2,t97,   &
           f4.2,t104,f6.3,t111,f5.3,t118,a13,t133,a6,t141,a10,   &
           t154,a5,t161,i2.2,a1,i2.2,a1,i2.2,t171,f5.1,t179,f6.1,t186,   &
           f4.2,t191,f5.1,t197,f5.1,t203,f4.0,t208,f4.0,t213,f4.0,t218,f5.1,t224,a7)
101 format(t5,i4,t10,i2,t13,i2,t16,f5.2,t22,f12.4,t37,i4,t43,f7.3,   &
           t52,f4.1,t59,f7.2,t68,f6.2,t75,f6.2,t83,f5.2,t90,f5.2,t97,   &
           f4.2,t103,f7.3,t111,f5.3,t118,a13,t133,a5,t141,a10,   &
           t154,a5,t161,i2.2,a1,i2.2,a1,i2.2,t171,f5.1,t179,f6.1,t186,   &
           f4.2,t191,f5.1,t197,f5.1,t203,f4.0,t208,f4.0,t213,f4.0,t218,f5.1,t224,i1)
end subroutine fluxfill

subroutine fluxBackend(lun,freq,iyear,imon,iday,month,ifb,nbd,nchan, &
                       tau,pwv,tsys,trec,fluxCorr)
!
! Same as fluxfill but for on-offs of continuum souces observed with a
! spectrometer and wobbler switch mode. Needs to be debugged ?
!

   use mira
   use pcross_definitions
   implicit none
   integer            :: i, ifb, iyear, imon, iday, i1, i2, j, lsth, lstm, lsts,   &
                         lun, nbd, nc, nchan, ncpb, nrec
   real*8             :: fluxCorr, freq, pwv, tau, tsys, trec
   character(len=  2) :: beFlag
   character(len=  3) :: month
   character(len=  9) :: receiver
   character(len= 10) :: source
   character(len= 13) :: date
   integer            :: iqual, ipix, k, l
   integer, dimension(3)     :: flagArray
   real*4             :: imbftsve, tint
   real*8             :: azm, bbflux, elv, eflux, flux, jd, pamb, parangle, &
                         rh, tamb, utc, var
   real*8, dimension(nchan)  :: aux
   real*8, dimension(nbd)    :: bbmean
   logical, dimension(nchan) :: mask
   logical                   :: error

   date(1:1) = "'"
   date(13:13) = "'"
   date(4:4) = "-"
   date(8:8) = "-"
   write(date(2:3),'(I2)') iday
   write(date(5:7),'(A3)') month
   write(date(9:12),'(I4)') iyear
   receiver = febe(ifb)%header%febe(1:5)
   nc = len_trim(febe(ifb)%header%febe)
   if (febe(ifb)%header%febe(nc-1:nc-1).eq.'/') then
      read(febe(ifb)%header%febe(nc:nc),'(i1)') i1
   else
      i1 = 1
   endif
   call sic_upper(receiver)
   if (index(receiver,'HERA').ne.0) then
      ipix = 5
      call gagout('W-LIST, defaults to central pixel.')
   else
      ipix = 1
   endif
   read(pr%header%mbftsver,'(f3.1)') imbftsve
   if (imbftsve.ge.2.0) then
      beFlag  = febe(ifb)%header%febe(7:7)//'0'
      if (beFlag(1:1).eq.'4') beFlag ='4M'
      receiver = receiver(1:5)//"-"//beFlag
      write(receiver(9:9),'(i1)') i1
   else
      beFlag(1:) = receiver(1:1)
      if (receiver(1:1).eq.'V') then
         if (receiver(2:4).eq.'100'.or.receiver(2:4).eq.'230') then
            receiver(1:1) = 'A'
         else if (receiver(2:4).eq.'150'.or.receiver(2:4).eq.'270') then
            receiver(1:1) = 'C'
         endif
      else if (receiver(1:1).eq.'H'.and.index(receiver,'HERA').eq.0) then
         if (receiver(2:4).eq.'100'.or.receiver(2:4).eq.'230') then
            receiver(1:1) = 'B'
         else if (receiver(2:4).eq.'150'.or.receiver(2:4).eq.'270') then
            receiver(1:1) = 'D'
         endif
      else if (receiver(1:1).eq.'R'.or.receiver(1:1).eq.'I') then
         receiver(1:1) = 'X'
      endif
      receiver(5:6) = beFlag(1:1)//'-'
      beFlag  = febe(ifb)%header%febe(6:6)//'0'
      if (beFlag(1:1).eq.'4') beFlag ='4M'
      receiver(7:8) = beFlag
      write(receiver(9:9),'(i1)') i1
   endif
   source = "'"//scan%header%object(1:8)//"'"
   tamb = nint(mon(ifb)%data%tamb_p_humid(1,1)+273.15)
   pamb = nint(mon(ifb)%data%tamb_p_humid(1,2))
   rh   = nint(mon(ifb)%data%tamb_p_humid(1,3))
   azm = nint(mon(ifb)%data%encoder_az_el(1,1)*10.)/10.
   elv = nint(mon(ifb)%data%encoder_az_el(1,2)*10.)/10.
   parangle = nint(mon(ifb)%data%parangle(1)*10.)/10.
   lsth = int(data(ifb)%data%lst(1)/3600.)
   lstm = int((data(ifb)%data%lst(1)-3600.*lsth)/60.)
   lsts = nint(data(ifb)%data%lst(1)-3600.*lsth-60.*lstm)
   utc = raw(1)%antenna(ifb)%subscanstart
   utc = nint((utc-int(utc))*2400)/100.
   jd = nint(raw(1)%antenna(ifb)%subscanstart*1.d4)/1.d4+2.4d6
   mask = data(ifb)%data%rdata(ipix,1:nchan).ne.blankingRed
   flux = sum(data(ifb)%data%rdata(ipix,1:nchan),mask)/count(mask)
   tint = sum(data(ifb)%data%integtim,mask)

   where (mask)
      aux = (data(ifb)%data%rdata(ipix,1:nchan)-flux)**2
   else where
      aux = blankingRed
   end where
   if (count(mask).gt.1) then
      eflux = sqrt(sum(aux,mask)/(count(mask)-1.))
   else
      eflux = blankingRed
   endif

   flagArray(1:3) = 0
   if (tsys.gt.300) flagArray(1) = 1
   do i = 1, febe(ifb)%header%febeband
      nrec = size(array(ifb)%data(i)%iswitch(:,1))
      i1 = array(ifb)%header(i)%dropchan+1
      ncpb = array(ifb)%header(i)%usedchan
      i2 = array(ifb)%header(i)%dropchan+ncpb
      mask(1:ncpb) = array(ifb)%data(i)%data(ipix,i1:i2,1,1).ne.blankingRed
      bbmean(i) = 0.
      do j = 1, nrec
         bbmean(i) = bbmean(i)       &
 &                   +abs(sum(array(ifb)%data(i)%data(ipix,i1:i2,j,1),mask(1:ncpb))  & 
 &                        -sum(array(ifb)%data(i)%data(ipix,i1:i2,j,2),mask(1:ncpb)) &
 &                    )/count(mask(1:ncpb))
      enddo
      bbmean(i) = bbmean(i)/float(nrec)
   enddo
   var = 0.
   if (febe(ifb)%header%febeband.gt.1) then
      bbflux = sum(bbmean)/febe(ifb)%header%febeband
      do i = 1, febe(ifb)%header%febeband
         var = var+(bbmean(i)-bbflux)*(bbmean(i)-bbflux)
      enddo
      var = var/(febe(ifb)%header%febeband-1)
      if (sqrt(var)/bbflux.gt.0.1) flagArray(2) = 1
   else if (eflux.eq.blankingRed.or.eflux/flux.gt.0.1) then
      flagArray(2) = 1 
   endif
   if (fluxCorr.ge.2) flagArray(3) = 1
   iqual = 100*flagArray(1)+10*flagArray(2)+flagArray(3)

   write(lun,100) iyear, imon, iday , utc, jd,   &
                  scan%header%scannum, freq, elv, flux, eflux,   &
                  date,source, receiver, lsth, ":", lstm, ":",   &
                  lsts, azm, parangle, tau, tsys, trec, tamb,   &
                  pamb, rh, pwv, tint, nsubscan, iqual 
   return
100 format(t5,i4,t10,i2,t13,i2,t16,f5.2,t22,f12.4,t37,i4,t43,f7.3,   &
           t52,f4.1,t60,f7.3,t76,f7.3,t88,a13,t102,a10,t113,a9,      &
           t123,i2.2,a1,i2.2,a1,i2.2,t132,f5.1,t138,f6.1,t147,       &
           f4.2,t152,f6.1,t159,f5.1,t165,f4.0,t170,f5.0,t176,f4.0,   &
           t181,f3.1,t185,f6.1,t193,i3,t198,i3.3)
end subroutine fluxBackend

subroutine line_auto(line,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: ier, sky, lck, harm, mult, i1, i2, ic, mline, nline
  integer(kind=4) :: ncont, lch, nc, i, mrec, isb, iend, isky(2), nb(2), j, nok, irec
  integer(kind=4) :: mspec, nspec, k, if1, if2, k1, k2, j1, j2, score, mcont
  integer(kind=4) :: scoremax, ibf, ibf2, band(5)
  parameter (mline=20, mcont=2, mrec=2, mspec=6)
  integer(kind=4) :: ncfr(mcont), itun(mrec), isb1(mrec), isb2(mrec)
  integer(kind=4) :: iband(mspec), krec(mspec)
  integer(kind=4) :: jsky(mrec), jharm(mrec), jmult(mrec), wifl(1000,5,mrec)
  integer(kind=4) :: jm, jmin(mrec), jmax(mrec), jrec
  logical :: first, bf10_done, filled, ok
  character(len=80) :: ch, linename(mline), linevelo, cline(mrec)
  character(len=80) :: contname(mline), contbands
  character(len=3) :: csb(-1:1), ctun(mrec), csky(mrec)
  real(kind=8) :: linefreq(mline), linevres(mline), linevmin(mline), linevmax(mline)
  real(kind=8) :: ftmin(2), ftmax(2), flo2(mrec), flo1, best, ft, clight
  real(kind=8) :: eps, fiend(2), ftunemin(2,2), ftunemax(2,2), f1, f2, ftrymin(2)
  real(kind=8) :: ftrymax(2), ftune(mrec), contfr(20,mcont), fif3, df, deltaf
  real(kind=8) :: flo3(mspec), ifstep, cent, bf, ftumin(mrec), ftumax(mrec), vc,velocity
  parameter (best=1875., clight=299792.458, ifstep=0.625)
  !!      PARAMETER (BEST=1875., CLIGHT=299792.458, IFSTEP=1.00)
  parameter (eps=(100d0+50d0/512d0))   !	MHz
  character*9 rname
  !
  data isky/1,-1/
  data fiend/100d0, 600d0/
  data csb /'LSB','DSB','USB'/
  data cent/350./
  data first /.true./
  data lck / -1/
  data band /160,80,40,20,10/
  data rname /'LINE_AUTO'/
  !
  ! resulting parameters accessed as variables:
  save cline, ftune, jsky, jharm, ctun, csky
  save nspec, krec, flo3, iband
  save first
  !-----------------------------------------------------------------------
  ! Get parameters from variables defined in project.pro
  call sic_get_inte('N_LINE',nline,error)
  call sic_get_inte('N_CONT',ncont,error)
  call sic_get_dble('VLSR_1',velocity,error)
  if (error) then
    call astro_message(seve%e,rname,'Variables not defined')
    return
  endif
  if (nline.gt.mline) then
    call astro_message(seve%f,rname,'Too many line tables')
    error = .true.
    return
  endif
  do irec=1, 2
    nb(irec) = 1
    do isb = 1, 2
      ftunemin(isb,irec) = 0
      ftunemax(isb,irec) = 1000000.
    enddo
    cline(irec)= '*'
    jmult(irec) = 1
    if (irec.eq.2) jmult(irec) = 3
    ftune(irec) = -1.
    ftumin(irec) = 0.
    ftumax(irec) = 100000000.
  enddo
  !
  ! Get parameters, and find out about USB or LSB or DSB:
  ! Line tables first:
  if (nline.gt.0) then
    do i=1, nline
      call name_it('LINENAME',i,ch,lch)
      call sic_get_char(ch(1:lch),linename(i),nc,error)
      call name_it('LINEVELO',i,ch,lch)
      call sic_get_char(ch(1:lch),linevelo,nc,error)
      read (linevelo(1:nc),*,err=900) linevmin(i), linevmax(i)
      call name_it('LINEFREQ',i,ch,lch)
      call sic_get_dble(ch(1:lch),linefreq(i),error)
      linefreq(i) = min(300.d3,max(70.d3,linefreq(i)))
      call name_it('LINEVRES',i,ch,lch)
      call sic_get_dble(ch(1:lch),linevres(i),error)
      if (error) return
      irec = nint(linefreq(i)/135000d0)
      ftumin(irec) = min(ftumin(irec),linefreq(i))
      ftumax(irec) = max(ftumax(irec),linefreq(i))
      if (cline(irec).eq.'*') then
        cline(irec) = linename(i)
        ftune(irec) = linefreq(i)
      endif
    enddo
  else
    call astro_message(seve%i,rname,'Continuum only')
  endif
  !
  ! Then continuum tables:
  if (ncont.gt.0) then
    do i=1, ncont
      call name_it('CONTTABLE',i,ch,lch)
      call sic_get_char(ch(1:lch),contname(i),nc,error)
      call name_it('CONTBANDS',i,ch,lch)
      call sic_get_char(ch(1:lch),contbands,nc,error)
      do j=1, 20
        contfr(j,i) = 0
      enddo
      read (contbands,*,iostat=ier) (contfr(k,i),k=1,20)
      ncfr(i) = 0
      do j=1, 20, 2
        if (contfr(j,i).gt.0) ncfr(i) = ncfr(i)+2
      enddo
      ! print *, 'i, NCFR(I), (CONTFR(J,I), j=1, NCFR(I))'
      ! print *, i, NCFR(I), (CONTFR(J,I), j=1, NCFR(I))
      ft = (contfr(1,i)+contfr(ncfr(i),i))/2.
      irec = nint(ft/135000d0)
      ftumin(irec) = min(ftumin(irec),contfr(1,i))
      ftumax(irec) = max(ftumax(irec),contfr(ncfr(i),i))
      if (cline(irec).eq.'*') then
        cline(irec) = contname(i)
        ftune(irec) = ft
      endif
      ! print *, 'irec, CLINE(IREC), FTUNE(IREC), FTUMIN(IREC), FTUMAX(IREC)'
      ! print *, irec, CLINE(IREC), FTUNE(IREC), FTUMIN(IREC), FTUMAX(IREC)
    enddo
  else
    call astro_message(seve%i,rname,'No Continuum')
  endif
  !
  ! Rec 1 must be tuned USB or LSB depending on line frequency:
  if (ftune(1).gt.112d3) then
    itun(1) = 1
    isb1(1) = 1
  else
    itun(1) = -1
    isb1(1) = 2
  endif
  jsky(1) = itun(1)
  isb2(1) = isb1(1)
  !
  ! Rec 2 is tuned DSB by default (we try line LSB or USB)
  itun(2) = 0
  if (ftumax(2)-ftumin(2).lt.fiend(2)-fiend(1)) then
    jsky(2) = -1
    isb1(2) = 2
    isb2(2) = 2
  elseif ((ftune(2)-ftumin(2)) .gt. (ftumax(2)-ftune(2))) then
    jsky(2) = -1
    isb1(2) = 1
    isb2(2) = 2
  else
    jsky(2) = 1
    isb1(2) = 1
    isb2(2) = 2
  endif
  !
  ! Now find the exact frequencies:
  call astro_message(seve%i,rname,'Getting line setup ...')
  if (nline.gt.0) then
    do i=1, nline
      irec = nint(linefreq(i)/135000d0)
      sky = jsky(irec)
      mult = jmult(irec)
      lck = -1
      ! PRINT *, 'i, irec, sky, mult, lck'
      ! PRINT *, I, IREC, SKY, MULT, LCK
      do isb = isb1(irec), isb2(irec)
        ftmin(isb) = 1e10
        ftmax(isb) = -1e10
        f2 = best
        do iend= 1, 2
          ft = linefreq(i)-isky(isb)*(f2-fiend(iend)) +sky*(f2-cent)
          harm =nint(((ft+lck*eps*mult+sky*cent)/best-sky)/mult)
          f2 = (ft + lck*eps*mult+sky*cent)/(mult*harm+sky)
          ft = linefreq(i)-isky(isb)*(f2-fiend(iend)) +sky*(f2-cent)
          ftmin(isb)=min(ftmin(isb), ft*(1.-(linevmin(i)-velocity)/clight))
          ftmax(isb)=max(ftmax(isb), ft*(1.-(linevmax(i)-velocity)/clight))
        enddo
      enddo
      nok = 0
      do j=1, nb(irec)
        ! PRINT *, 'FTUNEMIN(J,IREC), FTUNEMAX(J,IREC)'
        ! PRINT *, FTUNEMIN(J,IREC), FTUNEMAX(J,IREC)
        do isb = 1, 2
          f1 = max(ftunemin(j,irec),ftmin(isb))
          f2 = min(ftunemax(j,irec),ftmax(isb))
          if (f1.le.f2) then
            nok = nok+1
            ftrymin(nok) = f1
            ftrymax(nok) = f2
          endif
        enddo
      enddo
      if (nok.gt.0) then
        do j=1, nok
          ftunemin(j,irec) = ftrymin(j)
          ftunemax(j,irec) = ftrymax(j)
          nb(irec) = nok
        enddo
      else
        error = .true.
        call astro_message(seve%f,rname,linename(i)(1:nc)//' cannot be '//  &
        'observed.')
        return
      endif
    enddo
    !
    do irec=1, 2
      ! print *, 'irec, ftune(irec)'
      ! print *, irec, ftune(irec)
      ok = .false.
      do j=1, nb(irec)
        if (ftunemin(j,irec) .gt. 0) then
          if ( ftune(irec).ge.ftunemin(j,irec) .and.  &
               ftune(irec).le.ftunemax(j,irec) ) then
            ok = .true.
          else
            f1 = (ftunemin(j,irec)+ftunemax(j,irec))/2.
          endif
        endif
      enddo
      if (.not.ok)  ftune(irec)= f1
    enddo
  endif
  !
  ! If continuum only:
  if (ncont.gt.0) then
    do i=1, ncont
      ft = (contfr(1,i)+contfr(ncfr(i),i))/2.
      irec = nint(ft/135000d0)
      if (ftune(irec).lt.0.) then
        ftune(irec) = ft
      endif
    enddo
  endif
  !
  ! Print line setup
  do irec=1, 2
    ! print *, 'irec, ftune(irec)'
    ! print *, irec, ftune(irec)
    if (ftune(irec) .gt. 0) then
      sky = jsky(irec)
      mult = jmult(irec)
      ft = ftune(irec)
      ! print *, 'sky, mult, ft, lck, eps, best'
      ! print *, sky, mult, ft, lck, eps, best
      harm =nint(((ft+lck*eps*mult+sky*cent)/best-sky)/mult)
      f2 = (ft + lck*eps*mult+sky*cent)/(mult*harm+sky)
      jharm(irec) = harm
      flo2(irec) = f2
      csky(irec) = csb(jsky(irec))
      ctun(irec) = csb(itun(irec))
      print 1000, cline(irec), ft/1000., csky(irec), jharm(irec), irec
      1000 format(' LINE ',a12,' ',f13.6,' ',a3,' LOW 350 ',i5,' /RECEIVER ',i1)
    else
      ctun(irec) = 'UND'
      csky(irec) = 'UND'
    endif
  enddo
  !
  ! Get Spectral setup.
  ! attribute subbands to lines first:
  call astro_message(seve%i,rname,'Getting spectral setup ...')
  nspec = 0
  bf10_done = .false.
  j1 = nint(fiend(1)/ifstep)
  j2 = nint(fiend(2)/ifstep)
  do k= j1, j2
    do ibf=1, 5
      do irec=1, 2
        wifl(k,ibf, irec) = 0
      enddo
    enddo
  enddo
  if (nline.gt.0) then
    call astro_message(seve%i,rname,'Covering line tables ...')
    do i=1, nline
      irec = nint(linefreq(i)/135000d0)
      flo1 = ftune(irec)-jsky(irec)*(flo2(irec)-cent)
      vc = (linevmax(i)+linevmin(i))/2-velocity
      f1 = linefreq(i)*(1.-vc/clight)
      fif3 = flo2(irec)-abs(f1-flo1)
      df = linefreq(i) * linevres(i) / clight
      if (df.gt.2.4) then
        ibf = 1
      elseif (df.gt.0.62) then
        ibf = 2
      elseif (df.gt.0.155) then
        ibf = 3
      elseif (df.gt.0.077) then
        ibf = 4
      elseif (df.gt.0.037 .and. .not.bf10_done) then
        ibf = 5
        bf10_done = .true.
      else
        error = .true.
        call astro_message(seve%f,rname,'Resolution too high')
        return
      endif
      deltaf  = linefreq(i) * (linevmax(i)-linevmin(i)) / clight
      k1 = nint((fif3-deltaf/2)/ifstep)
      k2 = nint((fif3+deltaf/2)/ifstep)
      do k=k1, k2
        !               WIFL(K,IBF,IREC) = WIFL(K,IBF,IREC)+1000
        wifl(k,ibf,irec) = 1000
      enddo
      ! print *, 'i, irec, ibf, ifstep, k1, k2'
      ! print *, i, irec, ibf, ifstep, k1, k2
    enddo
  endif
  !
  ! Continuum
  i1 = nint(fiend(1)/ifstep)
  i2 = nint(fiend(2)/ifstep)
  ic = nint(cent/ifstep)
  do irec=1, 2
    do i= j1, j2
      wifl(i,1,irec) = wifl(i,1,irec)+abs(i2-i1)-abs(ic-i)
    enddo
  enddo
  if (ncont.gt.0) then
    call astro_message(seve%i,rname,'Covering continuum tables ...')
    do i=1, ncont
      irec = nint(contfr(1,i)/135000d0)
      flo1 = ftune(irec)-jsky(irec)*(flo2(irec)-cent)
      do j=1, ncfr(i), 2
        ! print *,'i, j, flo1, FLO2(IREC), CONTFR(J,I), CONTFR(J+1,I) '
        ! print *, i, j, flo1, FLO2(IREC), CONTFR(J,I), CONTFR(J+1,I)
        if (contfr(j,i).lt.flo1 .and. contfr(j+1,i).gt.flo1) then
          f2 = flo2(irec)
          f1 = max(0.d0, flo2(irec) -max(flo1-contfr(j,i),contfr(j+1,i)-flo1))
        else
          f1 = max(0.d0,flo2(irec) - abs(contfr(j,i)-flo1))
          f2 = max(0.d0,flo2(irec) - abs(contfr(j+1,i)-flo1))
        endif
        ! print *, 'cont i, irec, j, f1, f2 ', i, irec, j, f1, f2
        if1 = nint(f1/ifstep)
        if2 = nint(f2/ifstep)
        k1 = max(j1,min(if1,if2))
        k2 = min(j2,max(if1,if2))
        ! print *, 'cont i ,irec, k1, k2 ',  i ,irec, k1, k2
        do k= k1, k2
          !                  WIFL(K,1,IREC) = max(1000,WIFL(K,1,IREC)+1000)
          wifl(k,1,irec) = wifl(k,1,irec)+ 1000
        enddo
      enddo
    enddo
  endif
  !
  ! Now assign correlator units, dropping 10 % of bandwidths,
  ! starting from highest resolution.
  do ibf = 5, 1, -1
    bf = band(ibf)*0.90
    filled = .false.
    do while (.not.filled)
      scoremax = -1e8
      filled = .true.
      do irec=1, 2
        jmax(irec) = j1
        jmin(irec) = j2
        do j = j1, j2
          if (wifl(j,ibf,irec).gt.0) then
            jmax(irec)  = max(j,jmax(irec) )
            jmin(irec)  = min(j,jmin(irec) )
          endif
        enddo
        ! print *, ibf, irec, JMIN(irec), jmax(irec)
        ! in that case irec needs more units;
        if (jmin(irec).le.jmax(irec)) then
          filled = .false.
          do j = jmin(irec), jmax(irec)
            k1 = max(j1,j-nint(0.5*bf/ifstep))
            k2 = min(j2,j+nint(0.5*bf/ifstep))
            score = 0
            do k=k1, k2
              score=score+wifl(k,ibf,irec)
            enddo
            ! print *, 'j, score ', j, score
            if (score.gt.scoremax) then
              scoremax=score
              jm = j
              jrec = irec
            endif
          enddo
        endif
      enddo
      ! add one unit to receiver JREC at position JM if needed:
      if (.not.filled) then
        if (nspec.lt.mspec) then
          nspec = nspec+1
          iband(nspec) = band(ibf)
          flo3(nspec) = 0.625*nint(jm*ifstep/0.625)
          krec(nspec) = jrec
          k1 = max(j1,jm-nint(0.5*bf/ifstep))
          k2 = min(j2,jm+nint(0.5*bf/ifstep))
          do ibf2 = 1, 5
            do k=k1, k2
              wifl(k,ibf2,jrec) = 0    ! -10000
            enddo
          enddo
          print 1001, ' SPECTRAL ',nspec,iband(nspec),flo3(nspec),krec(nspec)
          1001 format(a10,i2,i4,f8.3,' /RECEIVER ',i2)
          ! we stop if no more units, with a warning.
        else
          call astro_message(seve%w,rname,'Not enough corr. units !')
          filled = .true.
        endif
      endif
    enddo
  enddo
  !
  ! 10 MHz check
  do i=1, mspec
    if (iband(i).eq.10 .and. i.ne.5) then
      k = iband(5)
      iband(5) = iband(i)
      iband(i) = k
      f1 = flo3(5)
      flo3(5) = flo3(i)
      flo3(i) = f1
      k = krec(5)
      krec(5) = krec(i)
      krec(i) = k
    endif
  enddo
  !
  if (first) then
    call sic_def_charn('LINE_C',cline,1,2,.false.,error)
    call sic_def_dble('LINE_F',ftune,1,2,.false.,error)
    call sic_def_charn('LINE_SB',csky,1,2,.false.,error)
    call sic_def_charn('LINE_TUN',ctun,1,2,.false.,error)
    call sic_def_inte('LINE_H',jharm,1,2,.false.,error)
    call sic_def_inte('SPEC_N',nspec,1,1,.false.,error)
    call sic_def_inte('SPEC_R',krec,1,mspec,.false.,error)
    call sic_def_inte('SPEC_B',iband,1,mspec,.false.,error)
    call sic_def_dble('SPEC_F',flo3,1,mspec,.false.,error)
    first = .false.
  endif
  return
  900   error = .true.
  call astro_message(seve%f,rname,'error reading frequencies')
  return
end subroutine line_auto
!
subroutine name_it(name,i,ch,lch)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*):: name           !
  integer(kind=4) :: i              !
  character(len=*):: ch             !
  integer(kind=4) :: lch            !
  ! Global
  integer(kind=4) :: lenc
  !
  lch = lenc(name)
  ch = name(1:lch)//'_'
  if (i.lt.10) then
    write(ch(lch+2:),'(i1)') i
  elseif (i.lt.100) then
    write(ch(lch+2:),'(i2)') i
  elseif (i.lt.1000) then
    write(ch(lch+2:),'(i3)') i
  endif
  lch = lenc(ch)
  return
end subroutine name_it

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_types
  ! Types
  public :: clean_par
  ! Variables
  public :: clean_converge
  public :: major_sec,minor_sec
  ! Methods
  public :: beam_unit_conversion
  private
  !
  real :: major_sec
  real :: minor_sec
  integer :: clean_converge = 10 ! Cleaning convergence criterium
  !
  type clean_par
!     sequence !***JP: Why?
     integer(kind=4) :: first           ! First plane
     integer(kind=4) :: last            ! Last plane
     integer(kind=4) :: nlist           ! List size
     integer(kind=4) :: iplane          ! Current image plane
     integer(kind=4) :: ibeam           ! Current beam plane
     integer(kind=4) :: imask           ! Current mask plane 
     !
     real(kind=4) :: thresh             ! Threshold for beam fit
     real(kind=4) :: gain = 0.2         ! Loop gain
     real(kind=4) :: fres = 0.0         ! Fractional residual
     real(kind=4) :: ares = 0.0         ! Absolute residual
     real(kind=4) :: phat               ! Prussian hat
     real(kind=4) :: flux               ! Cleaned Flux
     !
     ! Mosaic
     real(kind=4) :: search = 0.2       ! Threshold for searching
     real(kind=4) :: restor = 0.2       ! Threshold for restoration
     real(kind=4) :: trunca             ! Beam truncation value
     !
     ! Clark
     real(kind=4) :: spexp = 1.0        ! Speed up factor
     !
     ! MRC
     real(kind=4) :: ratio = 0.0        ! Smoothing ratio
     !
     ! Multi-scale
     real(kind=4) :: smooth = sqrt(3.0)    ! Smoothing factor
     real(kind=4) :: worry                 ! Worry factor
     integer(kind=4) :: nker(3) = [1,7,11] ! Kernel
     real(kind=4) :: gains(3)              ! Clean gains
     integer(kind=4) :: ninflate = 20      ! Component "inflation" factor
                                           ! 20 is a decent value, sometimes too short
     !
     integer(kind=4) :: ngoal = 10000   ! Maximum number of minor cycle components
     logical :: keep = .true.           ! Convergence criterium 
     integer(kind=4) :: m_iter = 500    ! Maximum number of iterations
     integer(kind=4) :: n_iter = 0      ! Current number of iterations
     integer(kind=4) :: p_iter = 0      ! Positive number of iterations
     integer(kind=4) :: n_major = 50    ! Maximum number of major cycle
     !
     real(kind=4) :: major = 0.0        ! Major axis
     real(kind=4) :: minor = 0.0        ! Minor axis
     real(kind=4) :: angle = 0.0        ! Clean beam angle
     real(kind=4) :: beam_min           ! Beam minimum
     real(kind=4) :: beam_max           ! Beam maximum
     real(kind=4) :: bgain              ! Outer sidelobe
     !
     integer(kind=4) :: blc(2) = 0      ! Bottom Left Corner
     integer(kind=4) :: trc(2) = 0      ! Top Right Corner
     integer(kind=4) :: box(4)          ! Cleaning Box
     integer(kind=4) :: beam0(2)        ! Beam center X,Y
     integer(kind=4) :: patch(2) = 0    ! Beam patch sizes
     integer(kind=4) :: bzone(4)        ! Beam patch
     integer(kind=4) :: bshift(3)       ! Beam shift
     !
     logical :: mosaic = .false.        ! Mosaic flag
     logical :: pflux = .false.         ! Flux display
     logical :: pcycle = .false.        ! Residual display in cycle
     logical :: pmrc                    ! MRC display in cycle
     logical :: qcycle                  ! Query mode
     logical :: pclean                  ! Clean display in cycle
     logical :: do_mask = .true.        ! Re-compute the mask ?
     logical :: verbose = .false.       ! Lots of printout ?
     !
     character(len=12) :: method = 'HOGBOM' ! METHOD
     real(kind=4), pointer :: weight(:,:,:) ! Mosaic weights (as function of freq)
     !
     ! integer, pointer :: list(:)    ! List of selected pixels
     ! logical, pointer :: mask(:,:)  ! Selection mask
   contains
     procedure, public :: init     => clean_par_init
     procedure, public :: copyto   => clean_par_copyto
     procedure, public :: sicdef   => clean_par_sicdef
     procedure, public :: list     => clean_par_list
     procedure, public :: fit_beam => clean_par_fit_beam
  end type clean_par
  !
contains
  !
  subroutine clean_par_init(prog,error)
    !-----------------------------------------------------------------------
    ! Initialize by setting the intent to out
    !-----------------------------------------------------------------------
    class(clean_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    if (error) return
  end subroutine clean_par_init
  !
  subroutine clean_par_copyto(in,out)
    !----------------------------------------------------------------------
    ! Copy method
    !----------------------------------------------------------------------
    class(clean_par), intent(in)    ::  in
    type(clean_par),  intent(inout) ::  out
    !
    out%method = in%method
    out%verbose = in%verbose
    !
    out%gain = in%gain
    out%fres = in%fres
    out%ares = in%ares
    out%major = in%major
    out%minor = in%minor
    out%angle = in%angle
    out%ratio = in%ratio
    out%spexp = in%spexp
    out%phat = in%phat
    out%smooth = in%smooth
    out%keep = in%keep
    out%mosaic = in%mosaic
    out%search = in%search
    out%restor = in%restor
    out%trunca = in%trunca
    out%m_iter = in%m_iter
    out%p_iter = in%p_iter
    out%ngoal = in%ngoal
    out%n_major = in%n_major
    out%nker = in%nker
    out%ninflate = in%ninflate
    out%blc = in%blc
    out%trc = in%trc
    out%patch = in%patch
    out%do_mask = in%do_mask
    ! 
    ! Pointer issue
    out%weight => in%weight
    ! Consequences
    !     box, beam0, bzone, n_iter, bshift, beam_min, beam_max, bgain, flux
    ! Variables
    !     Major, Minor, Angle
    ! Temporary
    !     Pflux, Pcycle, Qcycle, Pmrc, Pclean,
    ! Return
    !     Do_beam, Do_mask
  end subroutine clean_par_copyto
  !
  subroutine clean_par_sicdef(prog,error)
    use gkernel_interfaces
    !-----------------------------------------------------------------------
    ! 
    !-----------------------------------------------------------------------
    class(clean_par), intent(out)   :: prog
    logical,          intent(inout) :: error
    !
    logical :: warning ! To avoid raising errors when deleting GREG variables
    integer(kind=index_length) :: dim(4) = 0
    !
    call sic_def_inte('NITER',prog%m_iter,0,0,.false.,error)
    if (error) return
    dim(1) = 2
    call sic_def_inte('BEAM_PATCH',prog%patch,1,dim,.false.,error)
    if (error) return
    dim(1) = 2
    call sic_def_inte('BLC',prog%blc,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('TRC',prog%trc,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('POSITIVE',prog%p_iter,0,0,.false.,error)
    if (error) return
    call sic_def_inte('NMAJOR',prog%n_major,0,0,.false.,error)
    if (error) return
    call sic_def_real('GAIN',prog%gain,0,0,.false.,error)
    if (error) return
    call sic_def_real('FRES',prog%fres,0,0,.false.,error)
    if (error) return
    call sic_def_real('ARES',prog%ares,0,0,.false.,error)
    if (error) return
    !
    call sic_def_real('MAJOR',major_sec,0,0,.false.,error)
    if (error) return
    call sic_def_real('MINOR',minor_sec,0,0,.false.,error)
    if (error) return
    ! Delete the ANGLE variable defined by define.greg and recreate it
    ! such as it maps 'prog%angle'
    call sic_delvariable('ANGLE',.true.,warning)
    call sic_def_real('ANGLE',prog%angle,0,0,.false.,error)
    if (error) return
    call sic_def_logi('KEEP',prog%keep,.false.,error)
    if (error) return
    call sic_def_real('SPEED',prog%spexp,0,0,.false.,error)
    if (error) return
    call sic_def_inte('NGOAL',prog%ngoal,0,0,.false.,error)
    if (error) return
    !
    ! MultiScale
    dim(1) = 3
    call sic_def_inte('KERNEL',prog%nker,1,dim,.false.,error)
    if (error) return
    call sic_def_inte('INFLATE',prog%ninflate,0,0,.false.,error)
    if (error) return
    call sic_def_real('SMOOTH',prog%smooth,0,0,.false.,error)
    if (error) return
    !
    ! MRC
    call sic_def_real('RATIO',prog%ratio,0,0,.false.,error)
    if (error) return
    !
    ! Mosaic mode
    ! Delete the MOSAIC variable defined by define.greg and recreate it
    ! such as it maps 'prog%mosaic'
    call sic_delvariable('MOSAIC',.true.,warning)
    if (error) return
    call sic_def_logi('MOSAIC',prog%mosaic,.false.,error)
    if (error) return
    call sic_def_real('SEARCH_W',prog%search,0,0,.false.,error)
    if (error) return
    call sic_def_real('RESTORE_W',prog%restor,0,0,.false.,error)
    if (error) return
    !
    call sic_def_logi('METHOD_DOMASK',prog%do_mask,.false.,error)
    if (error) return
    call sic_def_logi('VERBOSE',prog%verbose,.false.,error)
    if (error) return
    !
    call sic_def_inte('CLEAN_CONVERGE',clean_converge,0,0,.false.,error)
    if (error) return
  end subroutine clean_par_sicdef
  !
  subroutine clean_par_list(clean)
    !--------------------------------------------------------------------
    !
    !--------------------------------------------------------------------
    class(clean_par) :: clean
    !
    write(6,*) clean%gain,clean%fres,clean%ares,' Loop gain,Fres,Ares'
    write(6,*) clean%major,clean%minor,clean%angle,' Major/Minor/Angle axis'
    write(6,*) clean%beam_min,clean%beam_max,clean%bgain,' Beam Min/Max Sidelobe'
    write(6,*) clean%ratio,clean%spexp,clean%phat,clean%smooth,' MRC ratio,Speed,Phat,Multi ratio'
    write(6,*) clean%flux,clean%keep,' Cleaned Flux,Keep'
    write(6,*) clean%search,clean%restor,clean%trunca,' Threshold Search/Restore/Truncate'
    write(6,*) clean%blc,clean%trc,' BLC,TRC '
    write(6,*) clean%box,' Cleaning Box'
    write(6,*) clean%beam0,clean%patch,' Beam center X,Y,Patch size'
    write(6,*) clean%bzone,' Beam patch Zone'
    write(6,*) clean%m_iter,clean%p_iter,clean%n_iter,' Iterations Max/Pos/Actual'
    write(6,*) clean%ngoal,clean%n_major,' Max select,Max cycle'
    write(6,*) clean%bshift,' Beam shift'
    write(6,*) clean%nker,' Kernel for Multi-Scale clean'
    write(6,*) 'Mos. Flux,Cycle,Query,Mrc,Clean,Beam/Mask'
    write(6,*) clean%mosaic,clean%pflux,clean%pcycle ,clean%qcycle,clean%pmrc,clean%pclean,clean%do_mask
    write(6,*) clean%first,clean%last,clean%iplane,clean%ibeam,clean%nlist,' First/Last/Current  Beam List'
    write(6,*) clean%method,' METHOD'
  end subroutine clean_par_list
  !
  subroutine clean_par_fit_beam(method,hbeam,dbeam,error)
    use image_def
    use fit_beam_tool
    !----------------------------------------------------------------------
    ! Fit clean beam parameters
    !----------------------------------------------------------------------
    class(clean_par), intent(inout) :: method
    type(gildas),     intent(in)    :: hbeam
    real,             intent(in)    :: dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2))
    logical,          intent(inout) :: error
    !
    integer :: nx,ny
    !
    ! Use beam patch to search for maximum
    error = .false.
    nx =  hbeam%gil%dim(1)
    ny =  hbeam%gil%dim(2)
    call fibeam('CLEAN',dbeam,nx,ny,&
         method%patch(1),method%patch(2),method%thresh,&
         method%major,method%minor,method%angle,&
         hbeam%gil%convert,error)
  end subroutine clean_par_fit_beam
  !
  subroutine beam_unit_conversion(prog)
    use phys_const
    !----------------------------------------------------------------------
    ! Major and minor SIC variables are in seconds but the method structure
    ! assumes that its major and minor fields are in radian. So we need
    ! a conversion...
    !----------------------------------------------------------------------
    type(clean_par) :: prog
    !
    prog%major = major_sec*rad_per_sec
    prog%minor = minor_sec*rad_per_sec
  end subroutine beam_unit_conversion
end module clean_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine modify_frame_velocity(new_velo,rchan,freq,fres,old_velo,vres,error)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Change Frame Velocity
  ! All updated values are intent(inout) because they are not modified
  ! if there is nothing to be done.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: new_velo  ! Desired velocity
  real(kind=8), intent(inout) :: rchan     ! Reference channel
  real(kind=8), intent(in)    :: freq      ! Frequency at ref. channel
  real(kind=8), intent(inout) :: fres      ! Frequency resolution
  real(kind=4), intent(inout) :: old_velo  ! Velocity at ref. channel
  real(kind=4), intent(inout) :: vres      ! Velocity resolution
  logical,      intent(inout) :: error     ! Logical error flag
  !
  if (new_velo.eq.old_velo)  return
  !
  !      i_B = i_A + F / Df_L (V_A-V_B) / c
  !  The old resolution in frame A is Df_A = Df_L / (1-V_A/c), so
  !    i_B = i_A + F / Df_A * (1-V_A/c) * (V_A - V_B) / c
  !  which is equal to
  !    i_B = i_A + F / Df_B * (1-V_B/c) * (V_A - V_B) / c
  !  showing the reversibility of the computation.
  !
  rchan = rchan + freq/fres * (1.d0 - dble(old_velo)/clight_kms) * &
         dble(old_velo - new_velo)/clight_kms
  !
  fres = fres * (1.d0 - dble(old_velo)/clight_kms) /  &
                (1.d0 - dble(new_velo)/clight_kms)
  !
  vres = -clight_kms*fres/freq
  !
  old_velo = new_velo
  !
end subroutine modify_frame_velocity
!
subroutine modify_rest_frequency(new_freq,rchan,old_freq,image,fres,vres,error)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Change Rest Frequency
  ! All updated values are intent(inout) because they are not modified
  ! if there is nothing to be done.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: new_freq  ! Desired frequency
  real(kind=8), intent(inout) :: rchan     ! Reference channel
  real(kind=8), intent(inout) :: old_freq  ! Frequency at ref. channel
  real(kind=8), intent(inout) :: image     ! Image frequency at ref. channel
  real(kind=8), intent(inout) :: fres      ! Frequency resolution
  real(kind=4), intent(inout) :: vres      ! Velocity resolution
  logical,      intent(inout) :: error     ! Logical error flag
  ! Local
  real(kind=8), parameter :: fimage_null=0.d0  ! This parameter should be shared with the type(gildas)!!!
  real(kind=8) :: fshift
  !
  if (new_freq.eq.old_freq)  return
  !
  !    i_B = i_A + (F_B-F_A)/Df_L*(1-V/c)    (Radio)
  !
  !  The frequency resolution is still Df = (1+V/c) Df_L (Optical) or
  !  Df = (1-V/c) Df_L (radio), and remains unchanged, like V. So the
  !  above equation is just simply
  !    i_B = i_A + (F_B-F_A)/Df
  !
  !  Note that Dv is also changed into
  !    Dv_B = - c Df / F_B
  !  Again, the computation is fully reversible.
  !
  fshift = new_freq-old_freq
  !
  rchan = rchan + fshift / fres
  !
  vres = -clight_kms*fres/new_freq
  !
  if (image.ne.fimage_null)  image = image-fshift
  !
  old_freq = new_freq
  !
end subroutine modify_rest_frequency

      SUBROUTINE MONTE_CARLO_ELEMENTS(NSAMPLE,ELEMENTS,ERROR)
C----------------------------------------------------------------------
C ORBIT 
C       Generate requested number of montecarlo orbital elements 
C Arguments :
C       NSAMPLE  I       Number of requested element sets      Input
C       ELEMENTS R*8(*)  Montecarlo orbital elements           Output
C       ERROR    L       Logical error flag                    Output
C-----------------------------------------------------------------------------
      INCLUDE 'constant.inc'
      INTEGER NSAMPLE
      REAL*8 ELEMENTS(MA,NSAMPLE)
      LOGICAL ERROR
*
      INCLUDE 'elements.inc'
      INCLUDE 'data.inc'
*
      REAL*8  EL_SAVE(MA)      ! Fitted values of elements
      INTEGER I,J,MITER
      LOGICAL QUIET,UPDATE,WARNING
      LOGICAL SIC_CTRLC
*
      QUIET  = .TRUE.
      UPDATE = .FALSE.
      MITER = 20
      CALL SAVE_DATA
      DO I=1,MA
         EL_SAVE(I) = EL(I)
      ENDDO
*
      DO J=1,NSAMPLE
         IF (SIC_CTRLC()) GOTO 99
* Refresh the internal set of orbital elements and generate montecarlo data
         CALL INIT_KEPLER(EL_SAVE,.FALSE.)
         CALL GENERATE_DATA(1,NVR,1,NVCORR,1,NN,1,NPARA,ERROR)
         IF (ERROR) GOTO 99
* Fit the new data
         DO I=1,MA
            ELEMENTS(I,J) = EL_SAVE(I)
         ENDDO
         CALL DO_FIT(MITER,ELEMENTS(1,J),UPDATE,QUIET,WARNING,ERROR)
         IF (ERROR) ERROR = .FALSE.  ! Some samplings may fail to converge
         IF (MOD(J,50).EQ.0)
     +        WRITE(6,*) J,' montecarlo samples generated'
      ENDDO
      CALL RESTORE_DATA
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

      SUBROUTINE SAVE_DATA
C-------------------------------------------------------------------------
C ORBIT: Copy all data to an auxiliary array, so that the main data
C array can be used during the montecarlo error estimation
C-------------------------------------------------------------------------
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER I,J
* Radial velocities
      DO J=1,5
         DO I=1,NVR
            VR_SAVE(I,J) = VR(I,J)
         ENDDO
      ENDDO
* Visual orbit
      DO J=1,7
         DO I=1,NN
            OBS_SAVE(I,J) = OBS(I,J)
         ENDDO
      ENDDO
* Correlation profile
      DO J=1,MVCORR
         DO I=1,NVPNTS(J)
            VCORR_SAVE(I,J) = VCORR(I,J)
         ENDDO
      ENDDO
* Parallaxes
      DO I=1,NPARA
         PAR_SAVE(I) = PARALLAX(I)
      ENDDO
      RETURN
      END

      SUBROUTINE RESTORE_DATA
C-------------------------------------------------------------------------
C ORBIT: Restore all data from auxiliary arrays, after the main data
C array have been overwritten during the montecarlo error estimation
C-------------------------------------------------------------------------
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
*
      INTEGER I,J
* Radial velocities
      DO J=1,5
         DO I=1,NVR
            VR(I,J) = VR_SAVE(I,J) 
         ENDDO
      ENDDO
* Visual orbit
      DO J=1,7
         DO I=1,NN
            OBS(I,J) = OBS_SAVE(I,J) 
         ENDDO
      ENDDO
* Correlation profile
      DO J=1,MVCORR
         DO I=1,NVPNTS(J)
            VCORR(I,J) = VCORR_SAVE(I,J) 
         ENDDO
      ENDDO
* Parallaxes
      DO I=1,NPARA
         PARALLAX(I) = PAR_SAVE(I) 
      ENDDO
      RETURN
      END

      SUBROUTINE GENERATE_DATA(FIRST_VR,N_VR,FIRST_VCORR,
     +     N_VCORR,FIRST_VIS,N_VIS,FIRST_PARA,N_PARA,ERROR)
C-------------------------------------------------------------------------
C ORBIT: Generate trial data for one montecarlo step
C-------------------------------------------------------------------------
      INTEGER FIRST_VR,N_VR,FIRST_VCORR,N_VCORR,FIRST_VIS,
     +     N_VIS,FIRST_PARA,N_PARA
      LOGICAL ERROR
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'pi.inc'
*
      INTEGER I
      REAL B(MA),V,PHASE,RHO,THETA,XX,YY,POS,CPOS,SPOS
      REAL PAR
      REAL RANGAU
*
* Radial velocity data
      DO I=FIRST_VR,FIRST_VR+N_VR-1
         CALL SET_TIME(1,IORB0,VR(I,I_TIME),PHASE)
         IF (CVR(I).EQ.'2') THEN
            CALL GRAD_V2(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'1') THEN
            CALL GRAD_V1(VREFCODE(I),V,B)
            IF (V.NE.V) THEN
               write(6,*) 'Estimated Velocity ',V
            ENDIF
         ELSEIF (CVR(I).EQ.'11') THEN
            CALL GRAD_V11(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'12') THEN
            CALL GRAD_V12(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'21') THEN
            CALL GRAD_V21(VREFCODE(I),V,B)
         ELSEIF (CVR(I).EQ.'22') THEN
            CALL GRAD_V22(VREFCODE(I),V,B)
         ELSE
            WRITE(6,*) 'Unknown velocity type: ',CVR(I)
         ENDIF
         VR(I,I_VR) = V+SIG*RANGAU(SNGL(VR(I,I_S_VR)))
      ENDDO
* 
      DO I=FIRST_VCORR,FIRST_VCORR+N_VCORR-1
         CALL GENERATE_VCORR(I,ERROR)
         IF (ERROR) GOTO 99 
      ENDDO

      DO I=FIRST_VIS,FIRST_VIS+N_VIS-1
         CALL SET_TIME(1,IORB0,OBS(I,I_TIME),PHASE)
         IF (COBS(I).EQ.'rho-theta') THEN ! Rho+Theta pair
            CALL KEPLER_RHOTHETA(RHO,THETA)
            OBS(I,I_RHO)   = RHO+SIG*RANGAU(SNGL(OBS(I,I_S_RHO)))
            OBS(I,I_THETA) = THETA+SIG*RANGAU(SNGL(OBS(I,I_S_THETA)))
         ELSEIF (COBS(I).EQ.'PROJ') THEN ! Projected separation
            CALL KEPLER_XY(XX,YY)
            POS = (90-OBS(I,I_POSANG))/GR! Astro PA to trigonometric convention
            CPOS=COS(POS)
            SPOS=SIN(POS)
            OBS(I,I_PROJ) = XX*CPOS+YY*SPOS+
     +           SIG*RANGAU(SNGL(OBS(I,I_S_PROJ)))
         ELSEIF (COBS(I).EQ.'XY')  THEN ! X+Y pairs
            CALL KEPLER_XY(XX,YY)
            OBS(I,I_X) = XX+SIG*RANGAU(SNGL(OBS(I,I_S_X)))
            OBS(I,I_Y) = YY+SIG*RANGAU(SNGL(OBS(I,I_S_Y)))
         ELSEIF (COBS(I).EQ.'ZT') THEN
            CALL KEPLER_XY(XX,YY)
            OBS(I,I_Z) = (XX+YY)/SQRT(2.)+SIG*RANGAU(SNGL(OBS(I,I_S_Z)))
            OBS(I,I_T) = (YY-XX)/SQRT(2.)+SIG*RANGAU(SNGL(OBS(I,I_S_T)))
         ENDIF
      ENDDO
*
      DO I=FIRST_PARA,FIRST_PARA+N_PARA-1
         CALL GRAD_PARALLAX(PAR,B)
         PARALLAX(I) = PAR+SIG*RANGAU(PARERR(I))
      ENDDO

      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END


      SUBROUTINE GENERATE_VCORR(ICOR,ERROR)
      INTEGER ICOR
      LOGICAL ERROR
*
      INCLUDE 'constant.inc'
      INCLUDE 'data.inc'
      INCLUDE 'elements.inc'
      INCLUDE 'control.inc'
*
      REAL RANGAU
      INTEGER J
*
* Request the model profile on observing date date of true profile ICOR, 
* with all components in,
* 
      CALL GET_MODEL_PROFILE(ICOR,1,0,.TRUE.,
     +     PROFILE_METHOD.EQ.'CORRECTED',
     +     NVPNTS(ICOR),
     +     COR_REFPIX(ICOR),COR_REFVAL(ICOR),COR_VSTEP(ICOR),
     +     VCORR(1,ICOR),ERROR)
* Add gaussian noise
      DO J=1,NVPNTS(ICOR)
         VCORR(J,ICOR) = VCORR(J,ICOR)+SIG*RANGAU(COR_SIGM(ICOR))
      ENDDO
      RETURN
      END

subroutine input_file (line,comm,error)
  use gkernel_interfaces
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  include 'setup.inc'
  include 'size.inc'
  include 'data.inc'
  ! Local
  character(len=4) :: stat
  character(len=60) :: extension,name
  integer :: ier,n
  !
  call sic_ke (line,0,2,ctype,n,.true.,error)
  if (error) return
  call sic_ch (line,0,1,cfile,n,.true.,error)
  if (error) return
  if (ctype.eq.'O') then
    extension = '.opt'
  elseif (ctype.eq.'R') then
    extension = '.rad'
  elseif (ctype.eq.'I') then
    extension = '.int'
  else
    write(6,*) 'E-FILE,  Unknown type '//ctype
    error = .true.
    return
  endif
  !
  npt = 0
  ndata = 0
  fitted  = .false.
  !
  name= cfile
  call sic_parsef(name,cfile,' ',extension)
  open (unit=2,file=cfile,status='OLD',iostat=ier)
  if (ier.ne.0) then
    n = min (lenc(cfile),50)
    write(6,*) 'E-FILE, Error opening file '//cfile(1:n)
    call putios ('E-FILE,  ',ier)
    error = .true.
    return
  endif
  inquire (unit=2,name=cfile)
  !
  if (ctype.eq.'O') then
    call header_op (stat)
  elseif (ctype.eq.'R') then
    call header_ra
  elseif (ctype.eq.'I') then
    call header_in
  endif
  close (unit=2)
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_identifier
  use cubetools_parameters
  use cubetools_flag_types
  use cubetools_structure
  use cubeadm_messaging
  !
  public :: identifier_opt_t, identifier_user_t, identifier_prog_t
  public :: changeflags
  private
  !
  logical, parameter :: changeflags = .true.
  !
  type identifier_opt_t
     logical                 :: doflags
     type(option_t), pointer :: opt
   contains
     procedure, public :: register => cubeadm_identifier_register
     procedure, public :: parse    => cubeadm_identifier_parse
  end type identifier_opt_t
  !
  type identifier_user_t
     logical               :: doflags
     logical               :: do
     character(len=base_l) :: identifier
   contains
     procedure, public :: toprog => cubeadm_identifier_user_toprog
  end type identifier_user_t
  !
  type identifier_prog_t
     logical                   :: doflags
     character(len=base_l)     :: family
     type(flag_t), allocatable :: flags(:)
   contains
     procedure, public :: apply => cubeadm_identifier_prog_apply
  end type identifier_prog_t
  !
contains
  !
  subroutine cubeadm_identifier_register(option,abstract,doflags,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_opt_t), intent(inout) :: option
    character(len=*),        intent(in)    :: abstract
    logical,                 intent(in)    :: doflags
    logical,                 intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='IDENTIFIER>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    option%doflags = doflags
    if (option%doflags) then
       call cubetools_register_option(&
            'AS','family[:flag1,...,flagn]',&
            abstract,&
            'Set the family name and optionally the flags of the output&
            & cube. To consult the list of all available flags consult&
            & ADM\FLAGLIST',&
            option%opt,error)
       if (error) return
    else
       call cubetools_register_option(&
            'FAMILY','name',&
            abstract,&
            strg_emp,&
            option%opt,error)
       if (error) return
    endif
    call stdarg%register(&
         'identifier', &
         'New identifier', &
         strg_emp,&
         code_arg_mandatory, error)
    if (error) return
  end subroutine cubeadm_identifier_register
  !
  subroutine cubeadm_identifier_parse(option,line,user,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_opt_t), intent(in)    :: option
    character(len=*),        intent(in)    :: line
    type(identifier_user_t), intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>PARSE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    user%doflags = option%doflags
    call option%opt%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,option%opt,1,user%identifier,mandatory,error)
       if (error) return
    endif
  end subroutine cubeadm_identifier_parse
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeadm_identifier_user_toprog(user,cube,prog,error)
    use cubetuple_format_class
    use cubetools_cubeid_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_user_t), intent(in)    :: user
    class(format_t),          intent(in)    :: cube
    type(identifier_prog_t),  intent(out)   :: prog
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>USER>TOPROG'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    prog%doflags = user%doflags
    if (user%do) then
       call cubetools_cubeid_string2familyflags(user%identifier,prog%family,prog%flags,error)
       if (error) return
       if (allocated(prog%flags).and..not.user%doflags) &
            call cubeadm_message(seve%w,rname,'Changing flags not allowed in this context, flags ignored')
    else
       prog%family = cube%node%family
    endif
  end subroutine cubeadm_identifier_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeadm_identifier_prog_apply(prog,cube,error)
    use cubetuple_format_class
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(identifier_prog_t), intent(in)    :: prog
    class(format_t),          intent(inout) :: cube
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='IDENTIFIER>PROG>APPLY'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cube%set_value('FAMILY',prog%family,error)
    if (error) return
    if (allocated(prog%flags).and.prog%doflags) then
       call cube%set_flags(prog%flags,error)
       if (error) return
    else
       ! Do nothing
    endif
  end subroutine cubeadm_identifier_prog_apply
end module cubeadm_identifier
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine uv_spectral_frequency_sel(frequency, width, unit, channels, error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_spectral_frequency_sel
  use gbl_message
  use uv_buffers
  !--------------------------------------------------------
  ! @ private
  !
  ! Mapping
  ! returns spectral channels based on a frequency and width given as input
  !--------------------------------------------------------
  real(kind=8), intent(in)      :: frequency
  real(kind=4), intent(in)      :: width
  character(len=10), intent(in) :: unit
  integer(kind=4), intent(out)  :: channels(2)
  logical, intent(inout)        :: error
  !
  real(kind=4)                  :: locwidth ! Local variable to manipulate width
  !
  select case(unit)
  case ('CHANNEL')
     locwidth = 0.5*width*abs(huv%gil%fres)
  case ('VELOCITY')
     locwidth = 0.5*width*abs(huv%gil%fres/huv%gil%vres)
  case ('FREQUENCY')
     locwidth = 0.5*width ! Otherwise locwidth is non initialized
  end select
  if (huv%gil%fres.gt.0) then
     ! +1 to assure the correct number of output channels.
     channels(1) = (frequency-huv%gil%freq-locwidth)/huv%gil%fres + huv%gil%ref(1)+1
     channels(2) = (frequency-huv%gil%freq+locwidth)/huv%gil%fres + huv%gil%ref(1)
  else
     channels(1) = (frequency-huv%gil%freq+locwidth)/huv%gil%fres + huv%gil%ref(1)+1
     channels(2) = (frequency-huv%gil%freq-locwidth)/huv%gil%fres + huv%gil%ref(1)
  endif
end subroutine uv_spectral_frequency_sel
!
subroutine uv_spectral_velocity_sel(velocity, width, unit, channels, error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_spectral_velocity_sel
  use gbl_message
  use uv_buffers
  !--------------------------------------------------------
  ! @ private
  !
  ! Mapping
  ! returns spectral channels based on a velocity and width given as input
  !--------------------------------------------------------
  real(kind=8), intent(in)      :: velocity
  real(kind=4), intent(in)      :: width
  character(len=10), intent(in) :: unit
  integer(kind=4), intent(out)  :: channels(2)
  logical, intent(inout)        :: error
  !
  real(kind=4)                  :: locwidth ! Local variable to manipulate width
  !
  locwidth = 0.5*width ! This makes sure we don't need a case for velocity
  select case(unit)
  case ('CHANNEL')
     locwidth = locwidth*abs(huv%gil%vres)
  case ('FREQUENCY')
     locwidth = width*abs(huv%gil%vres/huv%gil%fres)
  end select
  if (huv%gil%vres.gt.0) then
     ! +1 to assure the correct number of output channels.
     channels(1) = (velocity-huv%gil%voff-locwidth)/huv%gil%vres + huv%gil%ref(1)+1
     channels(2) = (velocity-huv%gil%voff+locwidth)/huv%gil%vres + huv%gil%ref(1)
  else
     channels(1) = (velocity-huv%gil%voff+locwidth)/huv%gil%vres + huv%gil%ref(1)+1
     channels(2) = (velocity-huv%gil%voff-locwidth)/huv%gil%vres + huv%gil%ref(1)
  endif
end subroutine uv_spectral_velocity_sel
!
subroutine uv_spectral_range_sel(range,unit,channels, error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_spectral_range_sel
  use gbl_message
  use uv_buffers
  !--------------------------------------------------------
  ! @ private
  !
  ! Mapping
  ! returns spectral channels based on a range at a known unit
  !--------------------------------------------------------
  real(kind=4), intent(in)      :: range(2)
  character(len=10), intent(in) :: unit
  integer(kind=4), intent(out)  :: channels(2)
  logical, intent(inout)        :: error
  !
  integer           :: dummy            ! dummy integer for one off operations
  !
  select case(unit)
  case ('CHANNEL')
     channels = nint(range)
  case ('VELOCITY')
     channels = (range - huv%gil%voff) / huv%gil%vres + huv%gil%ref(huv%gil%faxi)
  case ('FREQUENCY')
     channels = (range - huv%gil%freq) / huv%gil%fres + huv%gil%ref(huv%gil%faxi)
  end select
  if (channels(1).gt.channels(2)) then
     dummy = channels(2)
     channels(2) = channels(1)
     channels(1) = dummy
  endif
end subroutine uv_spectral_range_sel
!
subroutine uv_spectral_getcols(channel,columns)
  use image_def, only: index_length
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_getcols
  !--------------------------------------------------------
  ! @ private
  !
  ! Mapping
  ! returns real, imaginary and weight columns for a given channel
  ! Returns -1 for all columns if channel outside table
  !--------------------------------------------------------
  integer(kind=index_length),intent(in)  :: channel
  integer(kind=index_length),intent(out) :: columns(3)
  !
  if (channel.gt.huv%gil%nchan.or.channel.lt.1) then
     columns = -1
     return
  endif
  columns(1) = huv%gil%nlead+(channel-1)*huv%gil%natom+1
  columns(2) = columns(1)+1
  columns(3) = columns(1)+2
end subroutine uv_spectral_getcols
!
subroutine uv_spectral_flag(channel,error)
  use image_def, only: index_length,size_length
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_flag
  !--------------------------------------------------------
  ! @ private
  !
  ! Mapping
  ! Flags a UV channel i.e. makes its weight negative.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length),intent(in)  :: channel
  logical,intent(inout)                  :: error
  !
  integer(kind=index_length) :: cols(3)        ! UV Columns for channel
  integer(kind=index_length) :: ivisi
  integer(kind=index_length) :: weicol         ! weight column
  !
  ! Verify That we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  !
  ! Actual work
  weicol = cols(3)
  do ivisi=1,huv%gil%nvisi
     duv(weicol,ivisi) = sign(duv(weicol,ivisi),-1.0)
  enddo
end subroutine uv_spectral_flag
!
subroutine uv_spectral_flag_by_antenna(channel,antlist,nantlist,error)
  use image_def
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_flag_by_antenna
  !--------------------------------------------------------
  ! @ private
  ! Flags a UV channel for the given list of antennnas.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length), intent(in)    :: channel
  integer(kind=4),            intent(in)    :: antlist(:)
  integer(kind=4),            intent(in)    :: nantlist
  logical,                    intent(inout) :: error
  !
  integer(kind=index_length) :: cols(3)  ! UV Columns for channel
  integer(kind=index_length) :: ivisi,kant,weicol
  integer(kind=index_length) :: col_anti,col_antj
  integer(kind=4) :: iant,jant
  !
  ! Verify that we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  weicol = cols(3)
  col_anti = huv%gil%column_pointer(code_uvt_anti)
  col_antj = huv%gil%column_pointer(code_uvt_antj)
  !
  ! Work
  do ivisi=1,huv%gil%nvisi
     iant = duv(col_anti,ivisi)
     jant = duv(col_antj,ivisi)
     do kant=1,nantlist
         if (antlist(kant).eq.iant .or. antlist(kant).eq.jant) then
            duv(weicol,ivisi) = sign(duv(weicol,ivisi),-1.0)
            exit
         endif
     enddo
  enddo
end subroutine uv_spectral_flag_by_antenna
!
subroutine uv_spectral_flag_by_baseline(channel,baselist,nbaselist,error)
  use image_def
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_flag_by_baseline
  !--------------------------------------------------------
  ! @ private
  ! Flags a UV channel for the given list of baselines.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length), intent(in)    :: channel
  integer(kind=4),            intent(in)    :: baselist(:,:)
  integer(kind=4),            intent(in)    :: nbaselist
  logical,                    intent(inout) :: error
  !
  integer(kind=index_length) :: cols(3)  ! UV Columns for channel
  integer(kind=index_length) :: ivisi,ibase,weicol
  integer(kind=index_length) :: col_anti,col_antj
  integer(kind=4) :: iant,jant
  !
  ! Verify that we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  weicol = cols(3)
  col_anti = huv%gil%column_pointer(code_uvt_anti)
  col_antj = huv%gil%column_pointer(code_uvt_antj)
  !
  ! Work
  do ivisi=1,huv%gil%nvisi
     iant = duv(col_anti,ivisi)
     jant = duv(col_antj,ivisi)
     do ibase=1,nbaselist
        if ((baselist(1,ibase).eq.iant .and. baselist(2,ibase).eq.jant) .or.  &
            (baselist(1,ibase).eq.jant .and. baselist(2,ibase).eq.iant)) then
           duv(weicol,ivisi) = sign(duv(weicol,ivisi),-1.0)
           exit
        endif
     enddo
  enddo
end subroutine uv_spectral_flag_by_baseline
!
subroutine uv_spectral_zero(channel,error)
  use image_def, only: index_length
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_zero
  !--------------------------------------------------------
  ! @ private
  ! Zeroes a UV channel.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length), intent(in)    :: channel
  logical,                    intent(inout) :: error
  !
  integer(kind=index_length) :: cols(3)  ! UV Columns for channel
  integer(kind=index_length) :: ivisi,icol
  !
  ! Verify that we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  !
  ! Work
  do ivisi=1,huv%gil%nvisi
     do icol=cols(1),cols(3)
        duv(icol,ivisi) = 0.0
     enddo
  enddo
end subroutine uv_spectral_zero
!
subroutine uv_spectral_zero_by_antenna(channel,antlist,nantlist,error)
  use image_def
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_zero_by_antenna
  !--------------------------------------------------------
  ! @ private
  ! Zeroes a UV channel for the given list of antennnas.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length), intent(in)    :: channel
  integer(kind=4),            intent(in)    :: antlist(:)
  integer(kind=4),            intent(in)    :: nantlist
  logical,                    intent(inout) :: error
  !
  integer(kind=index_length) :: cols(3)  ! UV Columns for channel
  integer(kind=index_length) :: ivisi,kant,icol
  integer(kind=index_length) :: col_anti,col_antj
  integer(kind=4) :: iant,jant
  !
  ! Verify that we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  col_anti = huv%gil%column_pointer(code_uvt_anti)
  col_antj = huv%gil%column_pointer(code_uvt_antj)
  !
  ! Work
  do ivisi=1,huv%gil%nvisi
     iant = duv(col_anti,ivisi)
     jant = duv(col_antj,ivisi)
     do kant=1,nantlist
         if (antlist(kant).eq.iant .or. antlist(kant).eq.jant) then
            do icol=cols(1),cols(3)
               duv(icol,ivisi) = 0.0
            enddo
            exit
         endif
     enddo
  enddo
end subroutine uv_spectral_zero_by_antenna
!
subroutine uv_spectral_zero_by_baseline(channel,baselist,nbaselist,error)
  use image_def
  use uv_buffers
  use mapping_interfaces, except_this=>uv_spectral_zero_by_baseline
  !--------------------------------------------------------
  ! @ private
  ! Zeroes a UV channel for the given list of baselines.
  ! Returns error if channel is outside UV table range.
  !--------------------------------------------------------
  integer(kind=index_length), intent(in)    :: channel
  integer(kind=4),            intent(in)    :: baselist(:,:)
  integer(kind=4),            intent(in)    :: nbaselist
  logical,                    intent(inout) :: error
  !
  integer(kind=index_length) :: cols(3)  ! UV Columns for channel
  integer(kind=index_length) :: ivisi,ibase,icol
  integer(kind=index_length) :: col_anti,col_antj
  integer(kind=4) :: iant,jant
  !
  ! Verify that we are inside the table
  call uv_spectral_getcols(channel,cols)
  if (cols(1).eq.-1) then
     error = .true.
     return
  endif
  col_anti = huv%gil%column_pointer(code_uvt_anti)
  col_antj = huv%gil%column_pointer(code_uvt_antj)
  !
  ! Work
  do ivisi=1,huv%gil%nvisi
     iant = duv(col_anti,ivisi)
     jant = duv(col_antj,ivisi)
     do ibase=1,nbaselist
        if ((baselist(1,ibase).eq.iant .and. baselist(2,ibase).eq.jant) .or.  &
            (baselist(1,ibase).eq.jant .and. baselist(2,ibase).eq.iant)) then
           do icol=cols(1),cols(3)
              duv(icol,ivisi) = 0.0
           enddo
           exit
        endif
     enddo
  enddo
end subroutine uv_spectral_zero_by_baseline

subroutine gfits_getreal(fd,ndat,array,scal,zero,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_getreal
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Read NDAT data values from FITS data area, with scaling SCALE and
  ! offset ZERO
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd           !
  integer(kind=size_length), intent(in)    :: ndat         ! Number of desired data values
  real(kind=4),              intent(inout) :: array(ndat)  ! Data values
  real(kind=4),              intent(in)    :: scal         ! Scale factor
  real(kind=4),              intent(in)    :: zero         ! Offset
  logical,                   intent(inout) :: error        ! Error flag
  ! Local
  integer(kind=size_length) :: nsize,nfill,nbyt
  integer(kind=4) :: ier
  integer(kind=size_length), save :: mbyt=0
  integer(kind=1), allocatable, save :: mybuf(:)
  character(len=60) :: mess
  !
  select case (fd%nbit)
  case (8)
    nbyt = ndat
  case (16)
    nbyt = 2_8*ndat
  case (32,-32)
    nbyt = 4_8*ndat
  case (-64)
    nbyt = 8_8*ndat
  case default
    write(mess,*) 'BITPIX = ',fd%nbit,' not yet supported'
    call gfits_message(seve%e,'GETREAL',mess)
    error = .true.
    return
  end select
  !
  if (nbyt.gt.mbyt) then
    if (mbyt.ne.0) deallocate(mybuf)
    allocate (mybuf(nbyt),stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Allocation error ',ier,mbyt
      call gfits_message(seve%e,'GETREAL',mess)
      error = .true.
      return 
    endif
    mbyt = nbyt
  endif
  !
  call gfits_getbuf(mybuf,nbyt,error)
  if (error) return
  !
  nfill = 0
  nsize = ndat
  !
  select case (fd%nbit)
    case (8)
      call byte_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (16)
      call int2_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (32)
      call int4_to_real(mybuf,ndat,array,nsize,nfill,scal,zero)
    case (-32)
      call ieee32_to_real(mybuf,ndat,array,nsize,nfill,scal,zero,fd%bval0)
    case (-64)
      call ieee64_to_real(mybuf,ndat,array,nsize,nfill,scal,zero,fd%bval0)
  end select
end subroutine gfits_getreal
!
subroutine gfits_putbuf(int1,nr,error)
  use gfits_interfaces, except_this=>gfits_putbuf
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Write one row of a binary table to a FITS logical record
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nr        ! Length of buffer
  integer(kind=1), intent(in)    :: int1(nr)  ! Buffer
  logical,         intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=4) :: j, kb
  !
  if ((nr+ib).lt.2880) then
    ! fits into current buffer
    call bytoby(int1,buffer(ib+1),nr)
    ib = ib+nr
  else
    ! Would overflow buffer: will have to write to disk or tape
    ! Fill in previous buffer, and dump it to physical medium
    if (ib.ne.0) then
      call bytoby(int1,buffer(ib+1),2880-ib)
      call gfits_putrec(buffer,error)
      kb = 2880-ib
    else
      call gfits_putrec(int1,error)
      kb = 2880
    endif
    if (error) return
    kb = kb+1
    ! Now dump full buffers (double buffering is useless here)
    do j = 2880-ib+1, nr-2880+1, 2880
      call gfits_putrec(int1(kb),error)
      if (error) return
      kb = kb + 2880
    enddo
    ! Store leftover bits
    ib = nr-kb+1
    if (ib.gt.0) call bytoby(int1(kb),buffer(1),ib)
  endif
end subroutine gfits_putbuf
!
subroutine gfits_getbuf(int1,nr,error)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_getbuf
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public-mandatory
  ! Get one row of a binary table from a FITS logical record
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nr        ! Length of buffer
  integer(kind=1),           intent(inout) :: int1(nr)  ! Buffer
  logical,                   intent(inout) :: error     ! Error flag
  ! Local
  integer(kind=size_length) :: j,kb
  !
  if (nr+ib.le.2880) then
    ! Already in prefetch buffer
    call bytoby_sl(buffer(ib+1),int1,nr)
    ib = ib+nr
  else
    ! Will need to read from disk
    ! Empty previous buffer
    if (ib.lt.2880) then 
      call bytoby(buffer(ib+1),int1,2880-ib)
      kb = 2880-ib+1
    else
      kb = 1
    endif
    ! Now read full buffers from physical medium
    do j = 2880-ib+1, nr-2880, 2880
      call gfits_getrec(int1(kb:kb+2880-1),error)
      if (error) return
      kb = kb+2880
    enddo
    ! Read one more buffer, and move part of it.
    call gfits_getrec(buffer,error)
    if (error) return
    ib = nr-kb+1
    if (ib.gt.0) call bytoby(buffer(1),int1(kb),ib)
  endif
end subroutine gfits_getbuf
!
subroutine gfits_skibuf(nb,error)
  use gildas_def
  use gfits_interfaces, except_this=>gfits_skibuf
  use gfits_buf
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Skip NB bytes on input file
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nb     ! Bytes to skip
  logical,                   intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=record_length) :: nrec
  character(len=message_length) :: mess
  !
  if (nb+ib.le.2880) then
    ! Remains within current buffer
    ib = ib+nb
  else 
    ! Need to skip records on input medium
    nrec = ((nb+ib)/2880)-1
    ! Make sure we can read the last record here
    if (nrec*2880.ge.nb) nrec = nrec-1 ! In case IB = 2880 at start
    call gfits_skirec(nrec,error)
    if (error) return
    ! Read last record, and set pointer
    call gfits_getrec(buffer,error)
    if (error) return
    ib = nb+ib-(nrec+1)*2880
    if (ib.lt.1.or.ib.gt.2880) then
      write(mess,*) 'Internal logic error. ',ib,nrec
      call gfits_message(seve%e,'FSKIBUF',mess)
    endif
  endif
end subroutine gfits_skibuf
!
subroutine gfits_skidat(fd,ndat,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_skidat
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  !  Skip NDAT data values from FITS data area,
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd     !
  integer(kind=size_length), intent(in)    :: ndat   ! Number of desired data values
  logical,                   intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=size_length) :: nbyt
  character(len=60) :: mess
  !
  select case (fd%nbit)
    case (8)
      nbyt = ndat
    case (16)
      nbyt = 2*ndat
    case (32,-32)
      nbyt = 4*ndat
    case (-64)
      nbyt = 8*ndat
    case default
      write(mess,*) 'BITPIX = ',fd%nbit,' not yet supported'
      call gfits_message(seve%e,'FSKIDAT',mess)
      error = .true.
      return
  end select
  !
  call gfits_skibuf(nbyt,error)
end subroutine gfits_skidat
!
subroutine gfits_skip_hdu(fd,ihdu,list,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_skip_hdu
  use gfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Skip entirely the current HDU. Optionaly list its contents.
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd     !
  integer(kind=4),     intent(in)    :: ihdu   ! HDU we are skipping (1=Primary)
  logical,             intent(in)    :: list   !
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  type(gfits_hdict_t) :: fhdict
  integer(kind=size_length) :: ndat
  integer(kind=4) :: ndim,pcount,gcount
  integer(kind=index_length) :: dims(10)  ! Arbitrary number of dimensions
  character(len=message_length) :: mess
  logical :: groups
  !
  ! 1) Skip the header. As we need to get the data description, reading
  !    the entire header is the easiest
  call gfits_load_header(fhdict,.false.,gfits_getnosymbol,error)
  if (error)  return
  call gfits_flush_header(error)
  if (error)  return
  !
  ! 2) Compute the data size. Trickiest part...
  call gfits_compute_ndat(ndat,error)
  if (error)  return
  !
  ! 3) Skip the data
  call gfits_skidat(fd,ndat,error)
  if (error)  return
  call gfits_flush_data(error)
  if (error)  return
  !
  if (list) then
    call gfits_list_hdu(error)
    if (error)  return
  else
    ! Just some debugging
    write(mess,'(A,I0,A)')  'Skipped HDU of size ',ndat,' elements'
    call gfits_message(seve%d,rname,mess)
  endif
  !
contains
  subroutine gfits_compute_ndat(ndat,error)
    !-------------------------------------------------------------------
    ! Compute the data size in current HDU
    !-------------------------------------------------------------------
    integer(kind=size_length), intent(out)   :: ndat
    logical,                   intent(inout) :: error
    ! Local
    integer(kind=4) :: fmt
    logical :: found
    !
    if (ihdu.eq.1) then  ! We are skipping the Primary HDU
      call gfits_check_simple(fhdict%card(1),error)
      if (error)  return
    else    ! We are skipping an Xtension
      call gfits_check_xtension(fhdict%card(1),error)
      if (error)  return
    endif
    call gfits_check_format(fhdict%card(2),fd%nbit,fmt,error)
    if (error)  return
    call gfits_check_naxis(fhdict%card(3),ndim,error)
    if (error)  return
    call gfits_check_naxisi(fhdict,dims(:),error)
    if (error)  return
    !
    groups = .false.
    call gfits_get_value(fhdict,'GROUPS',found,groups,error)
    if (error)  return
    !
    if (groups) then
      ! Minimalist test. UVFITS readers should perform exhaustive tests.
      call gfits_get_value(fhdict,'GCOUNT',found,gcount,error)
      if (error)  return
      if (.not.found) then
        call gfits_message(seve%e,rname,'Missing keyword GCOUNT for Random Groups')
        error = .true.
        return
      endif
      call gfits_get_value(fhdict,'PCOUNT',found,pcount,error)
      if (error)  return
      if (.not.found) then
        call gfits_message(seve%e,rname,'Missing keyword PCOUNT for Random Groups')
        error = .true.
        return
      endif
      ndat = gcount * (pcount + product(dims(2:ndim)))
    elseif (ndim.eq.0) then
      ndat = 0
    else
      ndat = product(dims(1:ndim))
    endif
    !
  end subroutine gfits_compute_ndat
  !
  subroutine gfits_list_hdu(error)
    !-------------------------------------------------------------------
    ! Display a one-line description of the current HDU
    !-------------------------------------------------------------------
    logical, intent(inout) :: error  !
    ! Local
    character(len=16) :: extkind
    character(len=20) :: extname
    character(len=64) :: extdims
    integer(kind=4) :: tfields,nc,idime
    logical :: found,tfields_defined
    !
    tfields = 0
    call gfits_get_value(fhdict,'TFIELDS',tfields_defined,tfields,error)
    if (error)  return
    !
    if (ihdu.eq.1) then
      ! Primary HDU have no explicit kind. Have to guess what it is.
      if (groups) then  ! Already read by gfits_compute_ndat
        extkind = 'RANDOM GROUPS'
      elseif (tfields_defined) then
        extkind = 'BINTABLE'
      else
        extkind = 'IMAGE'
      endif
    else
      ! Rely on the XTENSION declaration
      extkind = '(UNKNOWN)'
      call gfits_get_value(fhdict,'XTENSION',found,extkind,error)
      if (error)  return
    endif
    !
    if (ihdu.eq.1) then
      extname = 'Primary'
    else
      extname = '(UNNAMED)'
      call gfits_get_value(fhdict,'EXTNAME',found,extname,error)
      if (error)  return
    endif
    !
    if (ndim.eq.0) then
      extdims = '0'
      !
    elseif (extkind.eq.'BINTABLE') then
      write(extdims,'(I0,A)')  tfields,' cols'
      do idime=2,ndim
        nc = len_trim(extdims)+2
        if (idime.eq.2) then
          write(extdims(nc:),'(A,I0,A)')  'x ',dims(idime),' rows'
        else
          write(extdims(nc:),'(A,I0)')    'x ',dims(idime)  ! More than 2 dims? Should not happen
        endif
      enddo
      !
    elseif (extkind.eq.'RANDOM GROUPS') then
      write(extdims,'(A,I0,A,I0)')  '(',pcount,' + ',dims(2)
      do idime=3,ndim
        nc = len_trim(extdims)+1
        write(extdims(nc:),'(A,I0)')  'x',dims(idime)
      enddo
      nc = len_trim(extdims)+1
      write(extdims(nc:),'(A,I0,A)')  ') x ',gcount,' visibilities'
      !
    else  ! Fallback for all others kinds (including IMAGE)
      write(extdims,'(I0)')  dims(1)
      do idime=2,ndim
        nc = len_trim(extdims)+2
        write(extdims(nc:),'(A,I0)')  'x ',dims(idime)
      enddo
    endif
    !
    write(mess,'(A,I0,T9,A,A,A)')  'HDU #',ihdu,extkind,extname,extdims
    call gfits_message(seve%r,rname,mess)
  end subroutine gfits_list_hdu
  !
end subroutine gfits_skip_hdu
!
subroutine gfits_goto_hdu(fd,khdu,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces, except_this=>gfits_goto_hdu
  use gfits_types
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Go to the requested HDU
  !---------------------------------------------------------------------
  type(gfits_hdesc_t), intent(inout) :: fd     !
  integer(kind=4),     intent(in)    :: khdu   ! Requested HDU (1=Primary)
  logical,             intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: ihdu
  character(len=message_length) :: mess
  !
  if (khdu.le.0) then
    write(mess,'(A,I0)')  'Invalid HDU number ',khdu
    call gfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Rewind to start of file
  call gfits_rewind_file(error)
  if (error)  return
  !
  ! Skip undesired HDUs
  do ihdu=1,khdu-1
    call gfits_skip_hdu(fd,ihdu,.false.,error)
    if (error)  return
    if (gfits_iseof()) then
      write(mess,'(A,I0,A)') 'FITS file has only ',ihdu,' HDUs'
      call gfits_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  ! Set the starting record of current HDU
  hdurec = irec
  !
end subroutine gfits_goto_hdu
!
subroutine gfits_list_hdus(name,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_list_hdus
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Go to the requested HDU
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! File name
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: ihdu
  type(gfits_hdesc_t) :: fd
  !
  call gfits_open(name,'IN',error)
  if (error)  return
  !
  ! Loop over HDUs
  ihdu = 0
  do
    ihdu = ihdu+1
    call gfits_skip_hdu(fd,ihdu,.true.,error)
    if (error)  exit  ! Need to close the file
    if (gfits_iseof())  exit  ! No more HDUs
  enddo
  !
  call gfits_close(error)
  !
end subroutine gfits_list_hdus

!-----------------------------------------------------------------------
! Common interfaces for the two ATM versions available:
!   ATM_1985  for the "Old" code
!   ATM_2009  for the latest code used starting from March 2009
!-----------------------------------------------------------------------
module atm_version
  !---------------------------------------------------------------------
  ! ATM parameters which are mapped on SIC variables.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !---------------------------------------------------------------------
  character(len=4), save :: version='2009'  ! Default at startup
  !
  character(len=20), save :: ctype ! Atmosphere type as a string
  real(4), save :: humidity,wvsh,tlr,top,p_step,p_step_factor
  !
end module atm_version
!
subroutine atm_sicvariables(error)
  use gkernel_interfaces
  use atm_interfaces, except_this=>atm_sicvariables
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Instantiate SIC variables
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_defstructure ('ATM',.true.,error)
  if (error) return
  call sic_defstructure ('ATM%MODEL',.true.,error)
  if (error) return
  call sic_defstructure ('ATM%MODEL%PROFILE',.true.,error)
  if (error) return
  !
  ! ATM internal values
  call sic_def_char ('ATM%MODEL%VERSION',version,.true.,error)
  if (error) return
  !
  ! Get internal default values of ATM library
  call atm_atmosp_variables_get(error)
  if (error) return
  call sic_def_char ('ATM%MODEL%PROFILE%TYPE',ctype,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%HUMIDITY',humidity,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%WVSH',wvsh,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%TLR',tlr,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%TOP',top,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%DP',p_step,0,1,.false.,error)
  if (error) return
  call sic_def_real ('ATM%MODEL%PROFILE%DP_FACTOR',p_step_factor,0,1,.false.,error)
  if (error) return
  !
end subroutine atm_sicvariables
!
subroutine atm_print(error)
  use gbl_message
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Displays the values of ATM parameters
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  !
  write(mess,100) 'ATM%VERSION',version,'','Current version in use'
  call gagout(mess)
  !
  if (version.ne.'2009' .and. version.ne.'2016') return  ! Parameters below are used only in ATM 2009 or 2016
  !
  write(mess,100) 'ATM%PROFILE%TYPE',ctype,'','Atmospheric type'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%HUMIDITY',humidity,'[%]','Ground relative humidity (indication)'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%WVSH',wvsh,'[km]','Water vapor scale height'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%TLR',tlr,'[K/km]','Tropospheric lapse rate'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%TOP',top,'[km]','Upper atm. boundary for calculations'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%DP',p_step,'[hPa]','Primary pressure step'
  call gagout(mess)
  !
  write(mess,101) 'ATM%PROFILE%DP_FACTOR',p_step_factor,'[]','Pressure step ratio between two consecutive layers'
  call gagout(mess)
  !
100 format(A,T23,A12,  T36,A6,T43,A)
101 format(A,T23,F12.3,T36,A6,T43,A)
  !
end subroutine atm_print
!
subroutine atm_setup(inversion,error)
  use atm_version
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ public
  ! Set the ATM version to be used. Supported versions are 1985 and
  ! 2009. 'OLD' (resp. 'NEW') is an alias for 1985 (resp. 2009).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: inversion  ! User input version
  logical,          intent(inout) :: error      ! Error flag
  ! Local
  character(len=4) :: versions(5)
  integer(kind=4) :: mversion,ikey
  character(len=5) :: key
  !
  mversion = 1
  versions(mversion) = 'OLD'
#if defined(ATM2009)
  mversion = mversion+1
  versions(mversion) = 'NEW'
#endif
  mversion = mversion+1
  versions(mversion) = '1985'
#if defined(ATM2009)
  mversion = mversion+1
  versions(mversion) = '2009'
#endif
#if defined(ATM2016)
  mversion = mversion+1
  versions(mversion) = '2016'
#endif
  !
  call sic_ambigs('ATM',inversion,key,ikey,versions,mversion,error)
  if (error)  return
  !
  if (key.eq.'OLD') then
    version = '1985'
  elseif (key.eq.'NEW') then
    version = '2009'
  else
    version = key
  endif
  !
end subroutine atm_setup
!
function atm_get_version()
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! get atm version
  !---------------------------------------------------------------------
  character(len=4) :: atm_get_version
  atm_get_version=version
end function atm_get_version
!
subroutine atm_atmosp(t0,p0,h0)
  use atm_interfaces, except_this=>atm_atmosp
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Setup the atmospheric structure
  !---------------------------------------------------------------------
  real, intent(in) :: t0  ! Ground temperature [K]
  real, intent(in) :: p0  ! Ground pressure [hPa]
  real, intent(in) :: h0  ! Altitude of the site [km]
  ! Local
  logical :: error
  !
  ! Update with (possibly) new values always before calling 'atm_atmosp'
  error = .false.
  call atm_atmosp_variables_set(error)
  if (error) return
  !
  select case (version)
  case('1985')
     call atm_1985_atmosp(t0,p0,h0)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_atmosp(t0,p0,h0)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_atmosp(t0,p0,h0)
#endif
  !
  case default
     call gagout('E-ATM_ATMOSP,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_atmosp
!
subroutine atm_transm_0d(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  use atm_interfaces, except_this=>atm_transm_0d
  use atm_version
  !---------------------------------------------------------------------
  ! @ public-generic atm_transm
  ! Return the atmospheric temperatures and opacities given the amount
  ! of water and the frequency, for current atmosphere previously set
  ! with 'atm_atmosp()'
  !---
  ! This version for scalar frequency as input
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: water    ! [mm]    Precipitable water vapo
  real(kind=4),    intent(in)  :: airmass  ! []      Number of air masses
  real(kind=4),    intent(in)  :: freq     ! [GHz]   Frequency
  real(kind=4),    intent(out) :: temi     ! [K]     Atmospheric emission
  real(kind=4),    intent(out) :: tatm     ! [K]     Mean temperature
  real(kind=4),    intent(out) :: tauox    ! [neper] Opacity (dry component)
  real(kind=4),    intent(out) :: tauw     ! [neper] Opacity (wet component)
  real(kind=4),    intent(out) :: taut     ! [neper] Total opacity
  integer(kind=4), intent(out) :: ier      ! []      Error status
  !
  select case (version)
  case('1985')
     call atm_1985_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_transm(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
#endif
  !
  case default
     call gagout('E-ATM_TRANSM,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_transm_0d
!
subroutine atm_transm_1d(water,airmass,freq,temi,tatm,tauox,tauw,taut,ier)
  use atm_interfaces, except_this=>atm_transm_1d
  use atm_version
  !---------------------------------------------------------------------
  ! @ public-generic atm_transm
  ! Return the atmospheric temperatures and opacities given the amount
  ! of water and the frequency, for current atmosphere previously set
  ! with 'atm_atmosp()'
  !---
  ! This version for vector frequency as input, and vector outputs
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: water     ! [mm]    Precipitable water vapor
  real(kind=4),    intent(in)  :: airmass   ! []      Number of air masses
  real(kind=4),    intent(in)  :: freq(:)   ! [GHz]   Frequency
  real(kind=4),    intent(out) :: temi(:)   ! [K]     Atmospheric emission
  real(kind=4),    intent(out) :: tatm(:)   ! [K]     Mean temperature
  real(kind=4),    intent(out) :: tauox(:)  ! [neper] Opacity (dry component)
  real(kind=4),    intent(out) :: tauw(:)   ! [neper] Opacity (wet component)
  real(kind=4),    intent(out) :: taut(:)   ! [neper] Total opacity
  integer(kind=4), intent(out) :: ier(:)    ! []      Error status
  ! Local
  integer(kind=4) :: ifreq,nfreq
  logical :: match
  !
  ! Sanity checks
  nfreq = size(freq)
  match = size(temi).eq.nfreq .and.  &
          size(tatm).eq.nfreq .and.  &
          size(tauox).eq.nfreq .and.  &
          size(tauw).eq.nfreq .and.  &
          size(taut).eq.nfreq .and.  &
          size(ier).eq.nfreq
  if (.not.match) then
    call gagout('E-ATM_TRANSM_1D,  Frequency array and output arrays do not match')
    ier(:) = 1  ! Not sure which output code should be used
    return
  endif
  !
  !*********************************************************************
  ! BEWARE! If you plan to parallelize this loop, beware there are
  ! global variables SAVE'd in atm_1985_transm. Have to check the other
  ! ATM versions too.
  !*********************************************************************
  !
  select case (version)
  case('1985')
    do ifreq=1,nfreq
      call atm_1985_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
  !
#if defined(ATM2009)
  case('2009')
    do ifreq=1,nfreq
      call atm_2009_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
#endif
  !
#if defined(ATM2016)
  case('2016')
    do ifreq=1,nfreq
      call atm_2016_transm(water,airmass,freq(ifreq),  &
        temi(ifreq),tatm(ifreq),tauox(ifreq),tauw(ifreq),taut(ifreq),ier(ifreq))
    enddo
#endif
  !
  case default
     call gagout('E-ATM_TRANSM,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_transm_1d
!
subroutine atm_path(water,airmass,freq,path,ier)
  use atm_interfaces, except_this=>atm_path
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Integrated optical length of current atmosphere
  !---------------------------------------------------------------------
  real,    intent(in)  :: water    ! Precipitable water vapor [mm]
  real,    intent(in)  :: airmass  ! Number of air masses []
  real,    intent(in)  :: freq     ! Frequency [GHz]
  real,    intent(out) :: path     ! Optical length [cm]
  integer, intent(out) :: ier      ! Error status
  !
  ier = 0
  !
  select case (version)
  case('1985')
     call atm_1985_path(water,airmass,freq,path,ier)
  !
#if defined(ATM2009)
  case('2009')
     call atm_2009_path(water,airmass,freq,path,ier)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_2016_path(water,airmass,freq,path,ier)
#endif
  !
  case default
     call gagout('E-ATM_PATH,  '//trim(version)//' version not available on this system')
  end select
  !
end subroutine atm_path
!
subroutine atm_atmosp_get(ctype_out,humidity_out,wvsh_out,tlr_out,top_out,  &
  p_step_out,p_step_factor_out,error)
  use atm_interfaces, except_this=>atm_atmosp_get
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Public entry point to:
  !  1) get the C++ global variables into the Fortran-SIC ones,
  !  2) return these latter ones.
  ! Warning: these variables make sense only with ATM 2009 or 2016.
  ! Return ATM 2009 or 2016 values even if it is not currently used (not
  ! an error).
  !---------------------------------------------------------------------
  character(len=*), intent(out)    :: ctype_out          ! Atmospheric type (as a string)
  real(4),          intent(out)    :: humidity_out       ! [%]    Ground Relative Humidity (indication)
  real(4),          intent(out)    :: wvsh_out           ! [km]   Water vapor scale height
  real(4),          intent(out)    :: tlr_out            ! [K/km] Tropospheric lapse rate
  real(4),          intent(out)    :: top_out            ! [km]   Upper atm. boundary for calculations
  real(4),          intent(out)    :: p_step_out         ! [mb]   Primary pressure step
  real(4),          intent(out)    :: p_step_factor_out  ! []     Pressure step ratio between two consecutive layers
  logical,          intent(inout)  :: error              ! Logical error flag
  !
  ! 1) Get the C++ variables in the Fortran-SIC ones
  call atm_atmosp_variables_get(error)
  if (error)  return
  !
  ! 2) Return these values
  ctype_out         = ctype
  humidity_out      = humidity
  wvsh_out          = wvsh
  tlr_out           = tlr
  top_out           = top
  p_step_out        = p_step
  p_step_factor_out = p_step_factor
  !
end subroutine atm_atmosp_get
!
subroutine atm_atmosp_set(ctype_in,humidity_in,wvsh_in,tlr_in,top_in,  &
  p_step_in,p_step_factor_in,error)
  use atm_interfaces, except_this=>atm_atmosp_set
  use atm_version
  !---------------------------------------------------------------------
  ! @ public
  ! Public entry point to:
  !  1) set the Fortran-SIC global variables values,
  !  2) set the C++ global variables from these values.
  ! Warning: these variables make sense only with ATM 2009 or 2016.
  ! Nothing will be done if ATM 2009 or 2016 is not the version in use
  ! (not an error). NB: 'ctype_in' is not case-sensitive, and can be
  ! shorten as long as it is not ambiguous.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: ctype_in          ! Atmospheric type (as a string)
  real(4),          intent(in)    :: humidity_in       ! [%]    Ground Relative Humidity (indication)
  real(4),          intent(in)    :: wvsh_in           ! [km]   Water vapor scale height
  real(4),          intent(in)    :: tlr_in            ! [K/km] Tropospheric lapse rate
  real(4),          intent(in)    :: top_in            ! [km]   Upper atm. boundary for calculations
  real(4),          intent(in)    :: p_step_in         ! [mb]   Primary pressure step
  real(4),          intent(in)    :: p_step_factor_in  ! []     Pressure step ratio between two consecutive layers
  logical,          intent(inout) :: error             ! Logical error flag
  !
  ! 1) Set the Fortran global values
  ctype         = ctype_in
  humidity      = humidity_in
  wvsh          = wvsh_in
  tlr           = tlr_in
  top           = top_in
  p_step        = p_step_in
  p_step_factor = p_step_factor_in
  !
  ! 2) Set the C++ global variables from the Fortran-SIC ones:
  call atm_atmosp_variables_set(error)
  if (error)  return
  !
end subroutine atm_atmosp_set
!
subroutine atm_atmosp_variables_get(error)
  use atm_interfaces, except_this=>atm_atmosp_variables_get
  use atm_version
  !---------------------------------------------------------------------
  ! @ private
  ! Get the atmospheric parameters currently in use in ATM, i.e. copy
  ! the C++ global variables in the Fortran-SIC global ones.
  ! Always get from 2009 to avoid mixing several set of parameters for
  ! each ATM version.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error         ! Logical error flag
  ! Local
  integer :: itype
  !
#if defined(ATM2009)
  call atm_2009_atmosp_get(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
  call atm_20XX_atmosp_type(itype,ctype,.true.,error)
  if (error) return
#endif
  !
#if defined(ATM2016)
  call atm_2016_atmosp_get(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
  call atm_20XX_atmosp_type(itype,ctype,.true.,error)
  if (error) return
#endif
  !
end subroutine atm_atmosp_variables_get
!
subroutine atm_atmosp_variables_set(error)
  use atm_interfaces, except_this=>atm_atmosp_variables_set
  use atm_version
  !---------------------------------------------------------------------
  ! @ private
  ! Set the atmospheric parameters to be used in ATM, i.e. copy the
  ! Fortran-SIC global variables in the C++ ones.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error         ! Logical error flag
  ! Local
  integer :: itype
  !
  select case (version)
  case('1985')
     continue
  !
#if defined(ATM2009)
  case('2009')
     call atm_20XX_atmosp_type(itype,ctype,.false.,error)
     if (error) return
     call atm_2009_atmosp_set(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
#endif
  !
#if defined(ATM2016)
  case('2016')
     call atm_20XX_atmosp_type(itype,ctype,.false.,error)
     if (error) return
     call atm_2016_atmosp_set(itype,humidity,wvsh,tlr,top,p_step,p_step_factor)
#endif
  !
  case default
     call gagout('E-ATM_ATMOSP_VARIABLES_SET,  '//trim(version)//' version not available on this system')
     ! error = .true.
  end select
  !
end subroutine atm_atmosp_variables_set
!
subroutine atm_20XX_atmosp_type(itype,ctype,int2str,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Translate the atmosphere type either from integer to string or from
  ! string to integer.
  !---------------------------------------------------------------------
  integer,          intent(inout) :: itype   ! Type as integer
  character(len=*), intent(inout) :: ctype   ! Type as string
  logical,          intent(in)    :: int2str ! Convert integer to string or vice-versa?
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ATM_ATMOSP'
  character(len=*), parameter :: echain='E-'//rname//',  '
  integer, parameter :: ntypes=5
  character(len=16), save :: ctypes(ntypes)
  data ctypes /'TROPICAL','MIDLATSUMMER','MIDLATWINTER','SUBARCTICSUMMER','SUBARCTICWINTER' /
  character(len=20) :: ctype_u,cfound
  character(len=message_length) :: mess
  !
  if (int2str) then
    ! Convert 'itype' into 'ctype'
    if (itype.le.0 .or. itype.gt.ntypes) then
      write(mess,'(A,I0)')  &
        echain//'Unrecognized atmosphere type ',itype
      call gagout(mess)
      error = .true.
      return
    endif
    ctype=ctypes(itype)
  !
  else
    ! Convert 'ctype' into 'itype'
    itype = 0
    ctype_u = ctype
    call sic_upper(ctype_u)
    call sic_ambigs(rname,ctype_u,cfound,itype,ctypes,ntypes,error)
    if (error)  call gagout(echain//  &
      'Unrecognized atmosphere type "'//trim(ctype)//'"')
  endif
  !
end subroutine atm_20XX_atmosp_type

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_primitive_prod
  use cubetools_parameters
  use cubelist_types
  use cubesyntax_messaging
  use cubetools_terminal_tool
  !
  public :: primitive_prod_t,prod_k
  public :: cubetools_primitive_prod_ptr
  private
  !
  integer(kind=4), parameter :: prod_k = 4
  integer(kind=4), parameter :: abst_l = 80
  !
  type, extends(list_object_t) :: primitive_prod_t
     integer(kind=prod_k)          :: inum = code_abs       ! Product number in command
     character(len=argu_l)         :: name = strg_unk
     character(len=abst_l)         :: abstract = strg_emp   ! One-line abstract help
     character(len=:), allocatable :: help_strg             ! Long/multiline help
   contains
     ! General
     procedure :: init  => cubetools_primitive_prod_init
     procedure :: final => cubetools_primitive_prod_final
     !
     ! Registering
     procedure :: put   => cubetools_primitive_prod_put
     !
     ! Printing and Help
     procedure :: print_abstract => cubetools_primitive_prod_abstract
     procedure :: summary        => cubetools_primitive_prod_summary
     procedure :: help           => cubetools_primitive_prod_help
  end type primitive_prod_t
  !
contains
  !
  !---General------------------------------------------------------------
  !
  subroutine cubetools_primitive_prod_init(prod,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(out)   :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>INIT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_prod_init
  !
  subroutine cubetools_primitive_prod_final(obj,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(inout) :: obj
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>FINAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
  end subroutine cubetools_primitive_prod_final
  !
  function cubetools_primitive_prod_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of class(primitive_prod_t), and return
    ! a pointer to it if relevant.
    !-------------------------------------------------------------------
    class(primitive_prod_t), pointer :: cubetools_primitive_prod_ptr  ! Function value on return
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>PTR'
    !
    select type(tot)
    class is (primitive_prod_t)
      cubetools_primitive_prod_ptr => tot
    class default
      cubetools_primitive_prod_ptr => null()
      call cubesyntax_message(seve%e,rname,  &
        'Internal error: object is not a primitive_prod_t class')
      error = .true.
      return
    end select
  end function cubetools_primitive_prod_ptr
  !
  !---Registering----------------------------------------------------------
  !
  subroutine cubetools_primitive_prod_put(prod,inum,name,abstract,help,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(inout) :: prod
    integer(kind=prod_k),    intent(in)    :: inum
    character(len=*),        intent(in)    :: name
    character(len=*),        intent(in)    :: abstract
    character(len=*),        intent(in)    :: help
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>PUT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_primitive_prod_final(prod,error)
    if (error) return
    call cubetools_primitive_prod_init(prod,error)
    if (error) return
    prod%inum      = inum
    prod%name      = name
    prod%abstract  = abstract
    prod%help_strg = help
  end subroutine cubetools_primitive_prod_put
  !
  !---Printing-and-Help--------------------------------------------------
  !
  subroutine cubetools_primitive_prod_abstract(prod,iprod,error)
    use gkernel_interfaces
    use cubetools_format
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    integer(kind=prod_k),    intent(in)    :: iprod
    logical,                 intent(inout) :: error
    !
    character(len=mess_l) :: name,mess
    character(len=*), parameter :: rname='PRODUCT>ABSTRACT'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    if ((iprod.lt.1).or.(9.lt.iprod)) then
       ! ZZZ Does this makes sense for products?
       call cubesyntax_message(seve%e,rname,'Product number out of authorized range: [1-9]')
       error = .true.
       return
    endif
    name = prod%name
    call sic_upper(name)
    write(mess,'(a1,i1,1x,a)') '#',iprod,trim(name)
    mess = '  '//cubetools_format_stdkey_boldval(mess,prod%abstract,terminal%width())
    call cubesyntax_message(syntaxseve%help,rname,mess)
  end subroutine cubetools_primitive_prod_abstract
  !
  subroutine cubetools_primitive_prod_help(prod,error)
    use cubetools_terminal_tool
    !-------------------------------------------------------------------
    ! Print option help from prod%help_strg
    !-------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>HELP'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    if (.not.allocated(prod%help_strg)) return
    if (len_trim(prod%help_strg).le.0) return
    if (prod%help_strg.eq.strg_emp) return
    !
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
    call terminal%print_strg(syntaxseve%help,prod%help_strg)
  end subroutine cubetools_primitive_prod_help
  !
  subroutine cubetools_primitive_prod_summary(prod,error)
    !-------------------------------------------------------------------
    ! Short option summary
    !-------------------------------------------------------------------
    class(primitive_prod_t), intent(in)    :: prod
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PRODUCT>SUMMARY'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubesyntax_message(syntaxseve%help,rname,terminal%dash_strg())
    call prod%print_abstract(prod%inum,error)
    if (error) return
    call prod%help(error)
    if (error) return
    call cubesyntax_message(syntaxseve%help,rname,blankstr)
  end subroutine cubetools_primitive_prod_summary
end module cubetools_primitive_prod
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module greg_work
  use gildas_def
  !--------------------------------------------------------------------
  ! Working buffers.
  !--------------------------------------------------------------------
  real(kind=4), allocatable :: xwork(:), ywork(:)  ! Buffers for polyline...
  real(kind=4), allocatable :: xworu(:), yworu(:)  ! Buffers after clipping
end module greg_work
!
subroutine grfill(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>grfill
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command FILL X Y
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='CONNECT'
  integer(kind=size_length) :: ixy
  integer(kind=4) :: form,narg,ncolo
  type(sic_descriptor_t) :: xinca,yinca
  integer(kind=address_length) :: ipx,ipy
  !
  save xinca,yinca
  !
  if (sic_present(2,1)) then
    ! ZZZ documenter
    call gtv_pencol_arg2id(rname,line,2,1,ncolo,error)
    if (error)  return
    call setcol(ncolo)
  endif
  !
  narg = sic_narg(0)
  if (narg.eq.0 .or. narg.eq.2) then
    form = 0
    call get_incarnation('FILL',line,form,ixy,xinca,yinca,error)
    if (error) return
    ipx = gag_pointer(xinca%addr,memory)
    ipy = gag_pointer(yinca%addr,memory)
    if (form.eq.fmt_r8) then
      call gr8_ufill(ixy,memory(ipx),memory(ipy))
    else
      call gr4_ufill(ixy,memory(ipx),memory(ipy))
    endif
    call sic_volatile(xinca)
    call sic_volatile(yinca)
  endif
end subroutine grfill
!
subroutine gr4_ufill(nxy,x,y)
  use gildas_def
  use greg_interfaces
  use greg_work
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! GREG Library routine
  !  Connect a Filled polyline (No BLANKING...)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy     ! Number of data points
  real(kind=4),              intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=4),              intent(in) :: y(nxy)  ! Array of Y coordinates
  ! Local
  integer(kind=size_length) :: np
  logical :: error
  !
  if (nxy.lt.2) return
  !
  error = .false.
  call reallocate_poly_buffers(nxy,error)
  if (error)  return
  !
  call us4_to_int(x,y,xwork,ywork,nxy)
  np = nxy+1
  xwork(np) = xwork(1)
  ywork(np) = ywork(1)
  call clip_poly(np,xwork,ywork,xworu,yworu)
  call gr_fillpoly(np,xworu,yworu)
end subroutine gr4_ufill
!
subroutine gr8_ufill(nxy,x,y)
  use gildas_def
  use greg_interfaces
  use greg_work
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! GREG Library routine
  !  Connect a Filled polyline (No BLANKING...)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy     ! Number of data points
  real(kind=8),              intent(in) :: x(nxy)  ! Array of X coordinates
  real(kind=8),              intent(in) :: y(nxy)  ! Array of Y coordinates
  ! Local
  integer(kind=size_length) :: np
  logical :: error
  !
  if (nxy.lt.2) return
  !
  error = .false.
  call reallocate_poly_buffers(nxy,error)
  if (error)  return
  !
  call us8_to_int(x,y,xwork,ywork,nxy)
  np = nxy+1
  xwork(np) = xwork(1)
  ywork(np) = ywork(1)
  call clip_poly(np,xwork,ywork,xworu,yworu)
  call gr_fillpoly(np,xworu,yworu)
end subroutine gr8_ufill
!
subroutine gr_fillpoly(n,x,y)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_fillpoly
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n     !
  real(kind=4),              intent(in) :: x(*)  !
  real(kind=4),              intent(in) :: y(*)  !
  ! Local
  integer(kind=4) :: n4
  logical :: error
  !
  n4 = int(n,kind=4)
  error = .false.
  call gtv_fillpoly(n4,x,y,.false.,error)
end subroutine gr_fillpoly
!
subroutine parse_polygon_drawing(rname,line,optfill,opthatch,drawing,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>parse_polygon_drawing
  use greg_types
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  ! Parse the following options in the command line:
  !   /FILL [Icolor]
  !   /HATCH [Ipen] [Angle] [Separ] [Phase]
  ! Defaults for the arguments are defined here.
  !---------------------------------------------------------------------
  character(len=*),        intent(in)    :: rname     !
  character(len=*),        intent(in)    :: line      !
  integer(kind=4),         intent(in)    :: optfill   ! Number of option /FILL
  integer(kind=4),         intent(in)    :: opthatch  ! Number of option /HATCH
  type(polygon_drawing_t), intent(out)   :: drawing   !
  logical,                 intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=message_length) :: mess
  !
  ! Contour (not parsed here)
  drawing%contoured = .false.
  call inqpen(drawing%cpen)  ! Default, even if not used
  !
  ! /FILL
  drawing%filled = sic_present(optfill,0)
  if (drawing%filled) then
    if (sic_present(optfill,1)) then
      call gtv_pencol_arg2id(rname,line,optfill,1,drawing%fcolor,error)
      if (error) return
    else
      call inqcol(drawing%fcolor)
    endif
  endif
  !
  ! /HATCH
  drawing%hatched = sic_present(opthatch,0)
  if (drawing%hatched) then
    call inqpen(drawing%hpen)
    call sic_i4(line,opthatch,1,drawing%hpen,.false.,error)
    if (error) return
    if (drawing%hpen.lt.0 .or. drawing%hpen.gt.maxpen) then
      write(mess,'(A,I0,A,I0)')  'Pen number ',drawing%hpen,' out of range 0-',maxpen
      call greg_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    drawing%hangle = 45.  ! Degrees
    call sic_r4(line,opthatch,2,drawing%hangle,.false.,error)
    if (error) return
    drawing%hangle = drawing%hangle*rad_per_deg  ! Radians
    !
    drawing%hsepar = .25  ! Physical units (cm)
    call sic_r4(line,opthatch,3,drawing%hsepar,.false.,error)
    if (error) return
    !
    drawing%hphase = .0  ! 0. to 1.
    call sic_r4(line,opthatch,4,drawing%hphase,.false.,error)
    if (error) return
    drawing%hphase = modulo(drawing%hphase,1.)  ! Between 0. to 1.
  endif
  !
end subroutine parse_polygon_drawing
!
subroutine reallocate_poly_buffers(npts,error)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_work
  !---------------------------------------------------------------------
  ! @ private
  ! 'npts' is the number of points of the input polygon
  ! This subroutine will allocate:
  ! - npts+1 values (so that the caller can close the polygon) for the
  !   unclipped buffer.
  ! - clipping buffer: npts*3/2+1, because clipping may add more
  !   summits, and this is the worst case.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: npts
  logical,                   intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  !
  alloc = .not.allocated(xwork)  ! Allocate if not yet allocated
  if (.not.alloc) then
    alloc = npts.gt.size(xwork)  ! Allocate of not large enough
    if (alloc)  deallocate(xwork,ywork,xworu,yworu)
  endif
  if (.not.alloc)  return  ! Nothing to do if large enough
  !
  allocate(xwork(npts+1),    ywork(npts+1),  &
           xworu(npts*3/2+1),yworu(npts*3/2+1),stat=ier)
  if (failed_allocate('POLY','buffers',ier,error))  return
  !
end subroutine reallocate_poly_buffers

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
program fourier
  use image_def
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Make the complex fourier transform of a real spectra cube
  ! Return (real,imag) if direct fourier transform
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname="FOURIER"
  character(len=filename_length) :: name_in,name_out
  character(len=80) :: message
  logical :: error,do_reorder
  integer(kind=4) :: ndim,iaxis,iplane,n,sign,ier
  integer(kind=4) :: dim1,dim2,dim3,maxdims,dims(2)
  type(gildas) :: head_in                              ! Input  GILDAS cube
  type(gildas) :: head_out                             ! Output GILDAS cube
  real(kind=4), dimension(:,:,:,:), allocatable :: data_in  ! Input  data
  real(kind=4), dimension(:,:,:,:), allocatable :: data_out ! Output data
  real(kind=4), dimension(:)      , allocatable :: wfft     ! Working space for FFT
  complex(kind=4), dimension(:,:),  allocatable :: work     ! Working complex array
  !
  ! Read input parameters
  call gildas_open
  call gildas_char('NAME_IN$',name_in)
  call gildas_char('NAME_OUT$',name_out)
  call gildas_inte('SIGN$',sign,1)
  call gildas_logi('REORDER$',do_reorder,1)
  call gildas_close
  if (abs(sign).ne.1) then
    call gagout('F-'//rname//',  Sign must be: +/- 1 (direct or inverse)')
    call sysexi(fatale)
  endif
  !
  ! Check input file
  call gildas_null(head_in)
  call sic_parse_file(name_in,' ','.gdf',head_in%file)
  n = lenc(head_in%file)
  if (n.eq.0) call sysexi(fatale)
  ier = gag_inquire(head_in%file(1:n),n)
  if (ier.ne.0) then
    message = 'Input cube '//' '//head_in%file(1:n)//' not found'
    call gagout('F-'//rname//',  '//message)
    call sysexi(fatale)
  endif
  !
  ! Read input file HEADER
  call gdf_read_header(head_in,error)
  if (head_in%gil%ndim.le.1) then
    message = 'Input cube is not an image (at least 2 dimensions)'
    call gagout('F-'//rname//',  '//message)
    call sysexi(fatale)
  endif
  !
  ! Initialize output header
  call gildas_null(head_out)
  call gdf_copy_header(head_in,head_out,error)
  if (error) call sysexi(fatale)
  call sic_parse_file(name_out,' ','.gdf',head_out%file)
  n = lenc(head_out%file)
  if (n.eq.0) call sysexi(fatale)
  !
  ! Set output header according to sign
  if (sign.gt.0) then
    ! Direct transform
    if (head_in%char%code(1).eq.'FFT') then
      call gagout('F-'//rname//',  First axis must not be of FFT type')
      call sysexi(fatale)
    endif
    if (head_in%gil%ndim.gt.3) then
      message = 'Input cube has more than 3 dimensions'
      call gagout('F-'//rname//',  '//message)
      call sysexi(fatale)
    endif
    ! Dimensions
    dim1 = head_in%gil%dim(1)
    dim2 = head_in%gil%dim(2)
    dim3 = head_in%gil%dim(3)
    head_out%gil%dim(1:4) = (/2,dim1,dim2,dim3/)
    where(head_out%gil%dim(1:4).eq.0) head_out%gil%dim(1:4)=1
    if (head_in%gil%ndim.lt.5) head_out%gil%ndim = head_in%gil%ndim+1
    ! Shift transformation formula
    head_out%gil%ref(1) = 1
    head_out%gil%val(1) = 0
    head_out%gil%inc(1) = 1
    do iaxis=2,4
      head_out%gil%ref(iaxis) = head_in%gil%ref(iaxis-1)
      head_out%gil%val(iaxis) = head_in%gil%val(iaxis-1)
      head_out%gil%inc(iaxis) = head_in%gil%inc(iaxis-1)
    enddo ! iaxis
    ! Axis content
    head_out%char%code(1) = 'FFT'
    head_out%char%code(2:4) = head_in%char%code(1:3)
  else
    ! Inverse transform
    if (head_in%char%code(1).ne.'FFT') then
      call gagout('F-'//rname//',  First axis must be of FFT type')
      call sysexi(fatale)
    endif
    if (head_in%gil%ndim.gt.4) then
      message = 'Input cube has more than 4 dimensions'
      call gagout('F-'//rname//',  '//message)
      call sysexi(fatale)
    endif
    ! Dimensions
    dim1 = head_in%gil%dim(2)
    dim2 = head_in%gil%dim(3)
    dim3 = head_in%gil%dim(4)
    head_out%gil%dim(1:4) = (/dim1,dim2,dim3,1/)
    where(head_out%gil%dim(1:4).eq.0) head_out%gil%dim(1:4)=1
    head_out%gil%ndim = head_in%gil%ndim-1
    ! Shift transformation formula
    do iaxis=1,3
      head_out%gil%ref(iaxis) = head_in%gil%ref(iaxis+1)
      head_out%gil%val(iaxis) = head_in%gil%val(iaxis+1)
      head_out%gil%inc(iaxis) = head_in%gil%inc(iaxis+1)
    enddo ! iaxis
    head_out%gil%ref(4) = 1
    head_out%gil%val(4) = 0
    head_out%gil%inc(4) = 1
    ! Axis content
    head_out%char%code(4) = 'UNKNOWN'
    head_out%char%code(1:3) = head_in%char%code(2:4)
  endif
  ndim = 2
  !
  ! Allocate memory
  ! Work space for FFT
  maxdims = 2*max(dim1,dim2)
  allocate( &
    data_in(head_in%gil%dim(1),head_in%gil%dim(2),head_in%gil%dim(3),head_in%gil%dim(4)), &
    data_out(head_out%gil%dim(1),head_out%gil%dim(2),head_out%gil%dim(3),head_out%gil%dim(4)), &
    work(dim1,dim2),wfft(maxdims),stat=ier)
  if (ier.ne.0) then
    call gagout('F-'//rname//',  Could not allocate memory')
    call sysexi(fatale)
  endif
  !
  ! Read input data
  call gdf_read_data(head_in,data_in,error)
  if (error) call sysexi(fatale)
  !
  ! Perform the Fourier transform
  if (sign.eq.1) then
    ! Direct transform
    dims = head_out%gil%dim(2:3)
    call fourt_plan(work,dims,ndim,1,1)
    ! Initialize output data
    data_out = 0.
    ! Do the Fourier transform plane by plane
    do iplane=1,dim3
      work(:,:) = cmplx(data_in(:,:,iplane,1),0.,kind(0.))
      call fourt(work,dims,ndim,1,1,wfft)
      if (do_reorder) call reorder(dim1,dim2,work)
      ! Fill in Gildas data array
      data_out(1,:,:,iplane) = real(work)
      data_out(2,:,:,iplane) = aimag(work)
    enddo
  else
    ! Inverse transform
    dims = head_out%gil%dim(1:2)
    call fourt_plan(work,dims,ndim,-1,1)
    ! Initialize output data
    data_out = 0.
    ! Do the Fourier transform plane by plane
    do iplane=1,dim3
      work(:,:) = cmplx(data_in(1,:,:,iplane),data_in(2,:,:,iplane),kind(0.))
      if (do_reorder) call reorder(dim1,dim2,work)
      call fourt(work,dims,ndim,-1,1,wfft)
      ! Normalize
      work(:,:) = work/real(dim1*dim2)
      ! Fill in Gildas data array
      data_out(:,:,iplane,1) = real(work)
    enddo
  endif
  !
  ! Fill in data of output Gildas cube
  call gdf_write_image(head_out,data_out,error)
  if (error) then
    call gagout('F-'//rname//',  Could not write output image')
    call sysexi(fatale)
  endif
  !
  ! Deallocate memory
  deallocate(data_in,data_out,wfft,work,stat=ier)
  if (ier.ne.0) then
    call gagout('F-'//rname//',  Deallocation error')
    call sysexi(fatale)
  endif
  ! Normal output
  call gagout('I-'//rname//',  Successful completion')
  !
end program fourier
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reorder(nx,ny,data)
  !---------------------------------------------------------------------
  ! Reorders the Fourier Transform, for easier display. The present version
  ! will only work for even dimensions.
  !---------------------------------------------------------------------
  integer, intent(in)    :: nx           ! 1st Dimension
  integer, intent(in)    :: ny           ! 2nd Dimension
  complex, intent(inout) :: data(nx,ny)  ! Array to reorder
  ! Local
  integer :: i,j
  complex :: tmp
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp                 = data(i+nx/2,j+ny/2)
      data(i+nx/2,j+ny/2) = data(i,j)
      data(i,j)           = tmp
    enddo
  enddo
  !
  do j=1,ny/2
    do i=1,nx/2
      tmp            = data(i,j+ny/2)
      data(i,j+ny/2) = data(i+nx/2,j)
      data(i+nx/2,j) = tmp
    enddo
  enddo
  !
end subroutine reorder
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine pdbi_print(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>pdbi_print
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine, support for command PRINT
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: i, ier, lun,nc
  character(len=80) :: name, file, chain
  character(len=10) :: rname
  character(len=6) :: input1(4), input2(4), tmp1, tmp2
  character(len=3) :: bmode(4)
  ! Data
  data rname /'PDBI_PRINT'/
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  data bmode/'LSB','USB','SSB','DSB'/
  ! ---------------------------------------------------------------------------
  !
  ! Sanity check (should be more elaborated)
  !
  if (.not.narrow_def) then
    call astro_message(seve%e,rname, 'LINE and NARROW not defined')
    error=.true.
    return
  endif
  !
  ! Open ouput file
  !
  name = 'setup'
  call sic_ch(line,0,1,name,nc,.false.,error)
  if (error)  return
  call sic_parsef(name,file,'','.obs')
  ier = sic_getlun(lun)
  ier = sic_open(lun,file,'NEW',.false.)
  if (ier.ne.0) then
    call astro_message(seve%e,rname,'Error opening file '//file)
    close (unit=lun)
    call sic_frelun (lun)
    error=.true.
    return
  endif
  rewind(lun)
  !
  ! Current date-time
  call sic_date(chain)
  !
  ! Print receiver & backend setup
  !
  write(lun,1000) '!'
  write(lun,1000) '! Plateau de Bure receiver and backend setup'
  write(lun,1000) '! Written by ASTRO command PRINT on '//chain(1:11)  ! Date only
! write(lun,1000) '! '//chain(1:lenc(chain))
  write(lun,1000) '!'
  !
  write(lun,1000) '! ----- Receiver -----'
  write(lun,1000) '!'
  write(lun,1010) recband
  chain = linecomm
  write(lun,1020) chain(1:lenc(chain)),recband
  write(lun,1000) '!'
  !
  write(lun,1000) '! ----- IF processor -----'
  tmp1=input1(narrow_input(1))
  tmp2=input2(narrow_input(2))
  write(lun,1000) '! Selected quarters are '//tmp1//' and '//tmp2
  write(lun,1000) '!'
  write(lun,1030) tmp1(1:2),tmp2(1:2),recband
  write(lun,1000) '!'
  !
  write(lun,1000) '! ----- Narrow-band correlator -----'
  write(lun,1000) '!'
  do i=1,nunit
    if (unit_def(i)) then
      write(lun,1040) i,unit_band(i),unit_cent(i),unit_wind(i),  &
      bmode(unit_bmode(i)), recband
    else
      write(lun,1050) i
    endif
  enddo
  !
  ! Close file
  !
  close (unit=lun)
  call sic_frelun (lun)
  !
1000 format(a)
1010 format('LET RECEIVER',i2)
1020 format(a,' /RECEIVER',i2)
1030 format('NARROW ',a,1x,a,' /RECEIVER',i2)
1040 format('SPECTRAL ',i1,i4,f8.2,' /NARROW',i2,' /BAND ',a,' /RECEIVER',i2)
1050 format('SPECTRAL ',i1,' OFF')
end subroutine pdbi_print

!
subroutine newuvt_close (xima)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Closes the output table.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima
  ! Local
  logical :: error
  !-----------------------------------------------------------------------
  if (xima%loca%islo.eq.0) return
  call gdf_close_image(xima,error)
end subroutine newuvt_close
!
subroutine newuvt_init (xima,name,nvis,scan,positions,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Creates the output table header in X (the significant header parameters
  ! have already been defned in clic_table)
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(in) :: scan           ! Use SCAN number
  logical, intent(in) :: positions      ! Add position information
  logical, intent(out) :: error         ! Error flag
  ! Local
  integer :: i, last
  ! for the Telescope section -- Assumes CLIC only handles NOEMA data here
  ! if not, the telescope name should be passed as an argument to newuvt_init
  character(len=8), parameter :: cteles='NOEMA   '
  real(8) :: value(3)
  ! Add section Telescope
  call gdf_addteles(xima,'TELE',cteles,value,error)
  !
  ! Do not nullify X header here: it has already been partly computed before.
  !
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = 6
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis              ! +1 ! = add the dummy uv = 7.5 m point
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                ! needed to avoid crash in GRAPHIC
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  xima%gil%form = fmt_r4
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  xima%gil%fcol = 8
  last = xima%gil%fcol + xima%gil%natom * xima%gil%nchan - 1
!
! For the time being (1-Feb-2012), force SCAN information in place of W column
  if (scan) then
    xima%gil%column_pointer(code_uvt_w) = 0
    xima%gil%column_pointer(code_uvt_scan) = 3
! Normal code should use an extra column as below
!    last = last+1
!    xima%gil%column_pointer(code_uvt_scan) = last
  endif
!
  if (positions) then
    last = last+1
    xima%gil%column_pointer(code_uvt_loff) = last
    last = last+1
    xima%gil%column_pointer(code_uvt_moff) = last
  endif
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  ! CLIC is working in this version of the header
  ! Header will be updated at newuvt_cut stage.
  xima%gil%version_uv = code_version_uvt_freq
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  !!print *, 'Into newuvt_init ',xima%gil%nvisi, xima%gil%nchan, xima%gil%dim(1:2)
  !!print *, 'Into newuvt_init UVDA_WORDS', xima%gil%uvda_words
  call gdf_create_image (xima,error)
  !!print *, 'Done newuvt_init '
end subroutine newuvt_init
!
subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Open a Table to extend it.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  ! UV data file
  character(len=*), intent(in) :: name  ! desired file name
  integer, intent(in) :: nvis           ! Number of visibilities
  logical, intent(out) :: error         ! Error flag
  integer, intent(in) :: nn             !
  integer, intent(in) :: ndobs(nn)      !
  integer, intent(in) :: ndscan(nn)     !
  logical, intent(in) :: lc             ! Check table before
  ! Local
  integer(kind=size_length) :: mvis
  integer :: ier
  character(len=60) :: chain
  real, allocatable :: old(:,:)
  !-----------------------------------------------------------------------
  !
  if (name.ne.xima%file) then
    call message(6,2,'EXTEND_TABLE', 'Unexpected file change')
    error = .true.
    return
  endif
  error = .false.
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) xima%gil%nvisi,nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call message(6,1,'TABLE',chain)
  !
  mvis = xima%gil%nvisi+nvis
  !
  !!print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  call gdf_extend_image (xima,mvis,error)
  !!print *,'Lead Trail ',xima%gil%nlead, xima%gil%ntrail
  if (error) then
    call message(8,4,'EXTEND_TABLE','Table extension failed')
    return
  endif
  !
  ! Check old region
  xima%blc(1) = 1
  xima%blc(2) = 1
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%nvisi
  !
  if (xima%gil%version_gdf.lt.code_version_gdf_v20) then
  xima%gil%column_pointer(code_uvt_w) = 0
  xima%gil%column_pointer(code_uvt_scan) = 3
  xima%gil%column_size(code_uvt_w) = 0
  xima%gil%column_size(code_uvt_scan) = 1
  endif
  !
  if (lc.and.xima%gil%nvisi.gt.0) then
    allocate (old(xima%gil%dim(1),xima%trc(2)), stat=ier)
    error = ier.ne.0
    if (error) return
    call gdf_read_data(xima,old,error)
    !!Print *,'Done GDF_READ_DATA ', error
    if (.not.error) then
      !!Print *,'Doing CHECK_TABLE ', error
      call check_table(xima%gil%dim(1),xima%trc(2), old, nn,ndobs,ndscan,error)
    endif
    deallocate (old)
    if (error) return
  endif
  !
  ! Map only new region
  xima%blc(1) = 1
  xima%blc(2) = xima%gil%nvisi+1
  xima%trc(1) = xima%gil%dim(1)
  xima%trc(2) = xima%gil%dim(2)
  !!print *, 'Done newuvt_extend '
end subroutine newuvt_extend
!
subroutine newuvt_cut (xima,nvis,uv_version,error)
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Update the number of visibilities
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima !
  integer, intent(in) :: nvis         ! True number of visibilities
  integer, intent(in) :: uv_version   ! Target image version 
  logical :: error                    !
  !
  ! Local
  character(len=80) :: chain
  !----------------------------------------------------------------------
  !
  write(chain,1001) xima%gil%dim(2), nvis
  call message(6,1,'TABLE',chain)
  xima%gil%dim(2) = nvis
  if (nvis.eq.0) xima%gil%dim(2) = 1
  xima%gil%nvisi = nvis
  !
  !! print *, 'Doing newuvt_cut ',xima%gil%nchan,xima%gil%nvisi , xima%gil%dim
  call gdf_uv_doppler(xima,uv_version)
  call gdf_update_header(xima,error)
  !! print *, 'Done newuvt_cut ',xima%gil%nchan
  !
1001 format('Old size ',i8,' New ',i8)
end subroutine newuvt_cut

subroutine newuvt_open (xima,name,uv_version,error)
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! Open an existing table, to get the header information
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: xima  ! Image header
  character(len=*), intent(in) :: name !
  integer,intent(out)          :: uv_version ! Image version 
  logical, intent(out) :: error        !
  ! Global
  !-----------------------------------------------------------------------
  !
  xima%file = name
  xima%loca%read = .false.
  !
  call gdf_read_gildas(xima,name,'.uvt',error, data=.false.)
  uv_version =  xima%gil%version_uv
  ! CLIC is working in this version of the header
  call gdf_uv_doppler(xima,code_version_uvt_freq)
  if (error) return
  !!print *, 'Done newuvt_open ',xima%gil%nchan
end subroutine newuvt_open
!
subroutine newuvt_addvisi (xima,visi,qsb,qband,qbas,qntch,qnchan,   &
    ibase,isb,inbc,frout,fres,datac,datal,passc,passl,   &
    ndrop, good, scan, width, shape, resample, fft, &
    positions, error)
  use image_def
  use phys_const
  use gkernel_interfaces
  use classic_api
  !---------------------------------------------------------------------
  ! Called by CLIC_TABLE
  ! creates one visibility point (i.e. one baseline and one band for a
  ! given scan), but many channels if in line mode.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: xima  !
  real, intent(out) :: visi(*)      ! Current visibility
  integer :: qsb                    !
  integer :: qband                  !
  integer :: qbas                   !
  integer :: qntch                  !
  integer :: qnchan                 !
  integer :: ibase                  !
  integer :: isb                    !
  integer :: inbc                   !
  real*8 :: frout                   !
  real*4 :: fres
  complex :: datac(qband,qsb,qbas)  !
  complex :: datal(qntch,qsb,qbas)  !
  complex :: passc(qband,qsb,qbas)  !
  complex :: passl(qntch,qsb,qbas)  !
!  real*4 :: daps(7)                 !
!  real*4 :: visi(3, qnchan)         !
!  real*4 :: offsets(2)              !
  integer :: ndrop(2)               !
  logical :: good                   !
  logical :: scan                   !
  real*4 :: width                   !
  character(len=*) :: shape         !
  logical :: resample               !
  logical :: fft                    !
  logical :: positions              !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  complex :: z, zz,  zscale
  complex, allocatable :: zin(:), zout(:)
  real, allocatable :: wout(:)
  real :: w, ww, tsys(2), ri, afac, factor, fr, save_res, rchan, fresf
  integer :: is, i, j, nw, k, ni, js, i1, i2, nd1, nd2, nch, iw
  integer :: ifirst, ilast, l, nchan, ipola, ia, ja
  integer, allocatable :: first_polar(:),second_polar(:)
  integer, allocatable :: first_tsys(:),second_tsys(:)
  integer, allocatable :: nfirst(:),nsecond(:)
  integer :: ier
  integer :: ibdata
  logical :: down_channel, ok
  real(8) :: f1, fn, fo1, fon, ff
  character(len=128) :: chain
  !
  integer ki
  !------------------------------------------------------------------------
  ! Code:
  is = isubb_out(1)
  if (is.gt.mbands) is = is-mbands
  if (qsb.eq.1) then ! Check available sideband
    if (r_sband(1,is).ne.isb) then
      call message(6,3,'TABLE','Sideband unavailable')
      error = .true.
      return
    endif
    ibdata = 1
  else
    ibdata = isb
  endif
  !
  rchan = xima%gil%ref(1)
  nchan = xima%gil%nchan
  !
  ! NGRX: This needs more work, if we have here polarizations with different tsys
  ! as a quick workaround, I use only tsys of the first polar.
  !
  ia = r_iant(ibase)
  ja = r_jant(ibase)
  if (weight_tsys) then
    if (inbc.le.r_mapbb(r_nbb)) then
      if (r_sb(is).eq.1) then
        tsys(1) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
          /dh_integ
        tsys(2) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
          /dh_integ
      else
        tsys(2) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja)   &
          /dh_integ
        tsys(1) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja)   &
          /dh_integ
      endif
    else
      call message(2,3,'SUB_TABLE',   &
        'Unknown correlator entry')
      error = .true.
      return
    endif
  else
    tsys(1) = 0
    tsys(2) = 0
  endif
  !
  allocate (first_polar(mrlband*mch),second_polar(mrlband*mch), &
    & first_tsys(mrlband*mch),second_tsys(mrlband*mch), & 
    & nfirst(mrlband*mch),nsecond(mrlband*mch),stat=ier)
  if (ier.ne.0) then
    call message(2,3,'SUB_TABLE',   &
      'Temporary arrays allocation failure')
    error = .true.
    return
  endif
  !
  allocate (zin(mlch),zout(mlch),wout(mlch),stat=ier)
  if (ier.ne.0) then
    call message(2,3,'SUB_TABLE',   &
      'Temporary arrays allocation failure')
    error = .true.
    return
  endif
  !
  !
  do i = 1, 2*mch
    first_polar(i) = 0
    second_polar(i) = 0
    nfirst(i) = 0
    nsecond(i) = 0
  enddo
  if (tsys(1).eq.0) then
    tsys(1) = 300.**2/dh_integ
  endif
  if (tsys(2).eq.0) then
    tsys(2) = 300.**2/dh_integ
  endif
  !
  if (dobs_0 .eq.0) then
    dobs_0 = mod(dh_obs+32768,65536)-32768
  endif
  ! In CONT mode, correct u and v in each sideband
  ! to the same frequency frout
  if (cont_select) then
    if (isb.eq.1) then
      factor = (r_flo1 + r_fif1)/frout
    elseif (isb.eq.2) then
      factor = (r_flo1 - r_fif1)/frout
    endif
  else
    factor = 1.0
  endif
  visi(xima%gil%column_pointer(code_uvt_u)) = dh_uvm(1,ibase)*factor
  visi(xima%gil%column_pointer(code_uvt_v)) = dh_uvm(2,ibase)*factor
!!  visi(xima%gil%column_pointer(code_uvt_w)) = 0
  if (xima%gil%column_pointer(code_uvt_scan).ne.0) visi(xima%gil%column_pointer(code_uvt_scan)) = r_scan
  visi(xima%gil%column_pointer(code_uvt_date)) = dh_obs
  visi(xima%gil%column_pointer(code_uvt_time)) = dh_utc
  if (phys_base) then
    visi(xima%gil%column_pointer(code_uvt_anti)) = r_kant(r_iant(ibase))
    visi(xima%gil%column_pointer(code_uvt_antj)) = r_kant(r_jant(ibase))
  else
    visi(xima%gil%column_pointer(code_uvt_anti)) = r_iant(ibase)
    visi(xima%gil%column_pointer(code_uvt_antj)) = r_jant(ibase)
  endif
  !
  if (positions) then
!
! There is an ambiguity in CLIC between Pointing and Phase center
! What happens in a MODIFY POSITION ?...
!
! But here, GILDAS assumes this is both the Pointing AND the Phase center
! Further uv_shift will modify the phase center to a common value.
!
! The following code handles both the OTF and the mosaic case.
! In case of pointed observations, dh_offlam is equal to r_lamof.
! For pointed positions NOEMA always uses the pointing center 
! as tracking center.
    if (xima%gil%column_pointer(code_uvt_loff).ne.0) visi(xima%gil%column_pointer(code_uvt_loff)) = dh_offlam(1)*rad_per_sec + &
              (r_lam-xima%gil%a0)
    if (xima%gil%column_pointer(code_uvt_moff).ne.0) visi(xima%gil%column_pointer(code_uvt_moff)) = dh_offbet(1)*rad_per_sec + &
              (r_bet-xima%gil%d0)
    if (xima%gil%column_pointer(code_uvt_xoff).ne.0) visi(xima%gil%column_pointer(code_uvt_xoff)) = dh_offlam(1)*rad_per_sec + &
              (r_lam-xima%gil%ra)
    if (xima%gil%column_pointer(code_uvt_yoff).ne.0) visi(xima%gil%column_pointer(code_uvt_yoff)) = dh_offbet(1)*rad_per_sec + &
              (r_bet-xima%gil%dec)
  endif
  !
  ! Other extra columns could be added here...
  !
  visi(xima%gil%fcol:xima%gil%lcol) = 0.0
  good = .false.
  !
  ! Continuum out
  if (cont_select) then
    zz = 0
    ww = 0
    !
    do js = 1, lsubb_out
      is = isubb_out(js)
      if (.not.down_channel(ibase,is)) then
        !
        ! Spectrum from continuum backend:
        if (is.le.r_nband) then
          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          z = datac(is,ibdata,ibase)
          w = 2./tsys(isb)*abs(r_cfwid(is))
          if (do_pass) then
            z = z*passc(is,isb,ibase)
          endif
          z = z * zscale
          if (weight_cal) then
            w = w/afac**2
          endif
          !
          zz = zz + z*w
          ww = ww + w
        !
        ! Continuum  from line  backend:
        elseif (is.gt.mbands .and. is.le.r_lband+mbands) then
          is = is - mbands
          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          nch = r_lnch(is)
          nd1 = max(ndrop(1),nint(fdrop(1)*nch))+1
          nd2 = nch-max(ndrop(2),nint(fdrop(2)*nch))
          !
          ! Avoid Gibbs-affected channels:
          if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
            i1 = nch/2-ngibbs
            i2 = nch/2+ngibbs+1
          else
            i1 = nch/2
            i2 = i1+1
          endif
          do i = nd1, nd2
            fr = r_lrfoff(isb,is)   &
              +(i-r_lrch(isb,is))*r_lrfres(isb,is)
            if (nwin_out.gt.0) then
              ok = .false.
              do iw = 1, nwin_out
                ok = ok .or. (fr.gt.window_out(1,iw).and.   &
                  fr.le.window_out(2,iw))
              enddo
            else
              ok = .true.
            endif
            ok = ok .and. (i.le.i1 .or. i.ge.i2)
            if (ok) then
              j = i+r_lich(is)
              z = datal(j,ibdata,ibase)  * zscale
              if (do_pass)then
                if (passl(j,isb,ibase).ne.blankc) then
                  z = z*passl(j,isb,ibase)
                else
                  z =0
                endif
              endif
              w = 2./tsys(isb)*abs(r_lfres(is))
              if (weight_cal) then
                w = w/afac**2
              endif
              zz = zz + z*w
              ww = ww + w
            endif
          enddo
        endif
      endif
    enddo
    ! Put the correct weights now
    if (new_receivers) then
      if (weight_cal) then
        w = 2./tsys(isb)/abs(zscale)**2 * abs(fres)
      else
        w = 2./tsys(isb) * abs(fres)
      endif
    else
       w = ww
    endif
    !
    if (ww.gt.0) then
      zz = zz / ww
      visi(xima%gil%fcol) = real(zz)
      visi(xima%gil%fcol+1) = aimag(zz)
      visi(xima%gil%fcol+2) = w
      good = .true.
    endif
  !
  ! Spectrum out
  else
    nw = 0
    !
    ! Spectrum from Continuum backend
    if (isubb_out(1).le.mbands) then
      !
      k = xima%gil%fcol
      do j = 1, lsubb_out
        i = isubb_out(j)
        afac = 1.
        zscale = 1.
        call scaling (i,isb,ibase,zscale,afac,   &
          error)
        if (.not.down_channel(ibase,i) .and.   &
          i.le.r_nband) then
          z = datac(i,ibdata,ibase) * zscale
          if (do_pass) then
            z = z * passc(i,isb,ibase)
          endif
          visi(k) = real(z)
          visi(k+1) = aimag(z)
          visi(k+2) = w
          good = .true.
        endif
        k = k + 3
      enddo
    !
    ! Spectrum from Line backend
    else
      save_res = xima%gil%fres
      do js = 1, lsubb_out
        is = isubb_out(js)-mbands
        ipola = r_lpolentry(1,is)
        inbc = r_bb(is)
        if (is.le.r_lband .and.   &
          .not.down_channel(ibase,is+mbands)) then

          afac = 1.
          zscale = 1.
          call scaling (is,isb,ibase,zscale,afac,   &
            error)
          fresf = r_lrfres(isb,is)/(1+r_doppl)
          nch = r_lnch(is)
          ! Drop edge channels and unnecessary channels.
          nd1 = max(ndrop(1),nint(fdrop(1)*nch))
          nd2 = max(ndrop(2),nint(fdrop(2)*nch))
          ff = r_lrfoff(isb,is)-xima%gil%freq   &
            -(r_lvoff(isb,is)-xima%gil%voff)/299792.d0*xima%gil%freq
          f1 = ff+(nd1+0.5-r_lrch(isb,is))*fresf
          fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*fresf
          if (fft) then
            if (fresf*xima%gil%fres.gt.0) then
              ifirst = nint(f1/xima%gil%fres+rchan+1)
              ilast  = nint(fn/xima%gil%fres+rchan-1)
            else
              ilast = nint(f1/xima%gil%fres+rchan-1)
              ifirst  = nint(fn/xima%gil%fres+rchan+1)
            endif
            if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
              write(chain,2000) csub(is+mbands), ifirst, ilast
              l = lenc(chain)
              call message(6,3,'FILL_VISI',chain(1:l))
              goto 98
            endif
            ifirst = max(ifirst,1)
            ilast = min(ilast,nchan)
            fo1 = 1d-3*nint(1d3*   &
              (ifirst-0.5-rchan)*xima%gil%fres)
            fon = 1d-3*nint(1d3*   &
              (ilast+0.5-rchan)*xima%gil%fres)
            do while ((f1-fo1)*(f1-fon).gt.0 .and. nd1.lt.nch)
              f1 = f1+fresf
              nd1 = nd1 +1
            enddo
            ni = nint((ilast-ifirst+1)   &
              *abs(xima%gil%fres/fresf))
          else
            if (fresf*xima%gil%fres.gt.0) then
              ifirst = nint(f1/xima%gil%fres+rchan)
              ilast  = nint(fn/xima%gil%fres+rchan)
            else
              ilast = nint(f1/xima%gil%fres+rchan)
              ifirst  = nint(fn/xima%gil%fres+rchan)
            endif
            if ((ilast.lt.1) .or. (ifirst.gt.nchan)) then
              write(chain,2000) csub(is+mbands), ifirst, ilast
              l = lenc(chain)
              call message(6,3,'FILL_VISI',chain(1:l))
              goto 98
            endif
            ni = nch-nd1-nd2
            ifirst = max(ifirst,1)
            ilast = min(ilast,nchan)
            ilast = min(ilast,ifirst+ni-1)
          endif
          ri = r_lrch(isb,is)-nd1
          do i=1, ni
            j = i+r_lich(is)+nd1
            zin(i) = datal(j,ibdata,ibase)  * zscale
            if (do_pass) then
              if (passl(j,isb,ibase).eq.blankc) then
                zin(i) = 0
              else
                zin(i) = zin(i)*passl(j,isb,ibase)
              endif
            endif
          enddo
          !
          ! Interpolate Gibbs-affected channels:
          if (ngibbs.gt.0 .and. abs(r_lfres(is)).gt.0.1) then
            i1 = nch/2-ngibbs -nd1
            i2 = nch/2+ngibbs+1 -nd1
            do i=i1+1,i2-1
              zin(i) = (zin(i1)*(i2-i)+zin(i2)*(i-i1))/(i2-i1)
            enddo
          endif
          !
          ! Interpolate masked channels:
          if (nmask(is,ia).gt.0) then
            do i=1, nmask(is,ia)
              i1 = cmask(1,i,is,ia)
              i2 = cmask(2,i,is,ia)
              do j=i1,i2
                if (imask.eq.1) then
                  zin(j) = (zin(i1-1)*(i2+1-j)+zin(i2+1)*(j-i1+1))/(i2-i1+2)  
                else
                  zin(j) = 0.0
                endif
              enddo
            enddo
          endif
          if (nmask(is,ja).gt.0) then
            do i=1, nmask(is,ja)
              i1 = cmask(1,i,is,ja)
              i2 = cmask(2,i,is,ja)
              do j=i1,i2
                if (imask.eq.1) then
                  zin(j) = (zin(i1-1)*(i2+1-j)+zin(i2+1)*(j-i1+1))/(i2-i1+2)  
                else
                  zin(j) = 0.0
                endif
              enddo
            enddo
          endif
          !
          if (resample) then
            ff = (r_lvoff(isb,is)-xima%gil%voff)/299792.d0*xima%gil%freq
            if (ifirst.le.ilast-4 .and. fft) then
              call fft_interpolate (zout(ifirst),   &
                ilast-ifirst+1, xima%gil%fres,   &
                rchan-ifirst+1, xima%gil%freq+ff,   &
                width, shape,   &
                wout(ifirst), zin, ni, fresf,   &
                ri, r_lrfoff(isb,is),   &
                1., 'TPAR', error)
              if (error) goto 98
            else
              call interpolate_2 (zout(ifirst),   &
                ilast-ifirst+1, xima%gil%fres,   &
                rchan-ifirst+1, xima%gil%freq+ff,   &
                wout(ifirst), zin, ni, fresf,   &
                ri, r_lrfoff(isb,is))
            endif
          endif
          xima%gil%vres = -xima%gil%fres*299792.458/xima%gil%freq
          !
          if (resample) then
            do i=ifirst, ilast
              ki = xima%gil%fcol + xima%gil%natom*(i-1)
              if (zout(i).eq.(0.0,0.0)) wout(i) = 0.0
              visi(ki) =  visi(ki)+real(zout(i))*wout(i)
              visi(ki+1) = visi(ki+1)+aimag(zout(i))*wout(i)
              visi(ki+2) = visi(ki+2)+wout(i)
              if (first_polar(i).eq.0) then
                 first_polar(i) = ipola
                 if (isb.eq.(3-r_sb(is))/2) then
                    first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                 else
                    first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                 endif
                 nfirst(i) = 1
              elseif(ipola.eq.first_polar(i)) then
                 if (isb.eq.(3-r_sb(is))/2) then
                    first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                 else
                    first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                 endif
                 nfirst(i) = nfirst(i)+1
              elseif(second_polar(i).eq.0) then
                 second_polar(i) = ipola
                 if (isb.eq.(3-r_sb(is))/2) then
                    second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                 else
                    second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                 endif
                 nsecond(i) = 1
              elseif(ipola.eq.second_polar(i)) then
                 if (isb.eq.(3-r_sb(is))/2) then
                    second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                 else
                    second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                 endif
                 nsecond(i) = nsecond(i)+1
              endif
            enddo
          else
            k = 1
            if (fresf*xima%gil%fres.gt.0) then
              do i=ifirst, ilast
                w = 1.0
                ki = xima%gil%fcol + xima%gil%natom*(i-1)
                if (zin(k).eq.(0.0,0.0)) w = 0.0
                visi(ki) =  visi(ki)+real(zin(k))*w
                visi(ki+1) = visi(ki+1)+aimag(zin(k))*w
                visi(ki+2) = visi(ki+2)+w
                if (first_polar(i).eq.0) then
                   first_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nfirst(i) = 1
                elseif(ipola.eq.first_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nfirst(i) = nfirst(i)+1
                elseif(second_polar(i).eq.0) then
                   second_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nsecond(i) = 1
                elseif(ipola.eq.second_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nsecond(i) = nsecond(i)+1
                endif
                k = k+1
              enddo
            else
              do i= ilast, ifirst, -1
                ki = xima%gil%fcol + xima%gil%natom*(i-1)
                visi(ki) =  visi(ki)+real(zin(k))*w
                visi(ki+1) = visi(ki+1)+aimag(zin(k))*w
                visi(ki+2) = visi(ki+2)+w
                k = k+1
                if (first_polar(i).eq.0) then
                   first_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      first_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nfirst(i) = 1
                elseif(ipola.eq.first_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      first_tsys(i) = first_tsys(i)                     &
     &                      +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nfirst(i) = nfirst(i)+1
                elseif(second_polar(i).eq.0) then
                   second_polar(i) = ipola
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) = r_tsyss(inbc,ia)*r_tsyss(inbc,ja) &
     &                   /dh_integ
                   else
                      second_tsys(i) = r_tsysi(inbc,ia)*r_tsysi(inbc,ja) &
     &                   /dh_integ
                   endif
                   nsecond(i) = 1
                elseif(ipola.eq.second_polar(i)) then
                   if (isb.eq.(3-r_sb(is))/2) then
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsyss(inbc,ia)*r_tsyss(inbc,ja)/dh_integ
                   else
                      second_tsys(i) =second_tsys(i)                     &
     &                   +r_tsysi(inbc,ia)*r_tsysi(inbc,ja)/dh_integ
                   endif
                   nsecond(i) = nsecond(i)+1
                endif
              enddo
            endif
          endif
98        error = .false.
          continue
        endif
      enddo
      !
      ! Set the proper channel width now
      if (weight_cal) then
        w = 2./abs(zscale)**2 * abs(xima%gil%fres)
      else
        w = 2. * abs(xima%gil%fres)
      endif
      do i=1, nchan
        ki = xima%gil%fcol + xima%gil%natom*(i-1)
        if (visi(ki+2).ne.0) then
          visi(ki) = visi(ki)/visi(ki+2)
          visi(ki+1) = visi(ki+1)/visi(ki+2)
          if (nfirst(i).ne.0) then
             first_tsys(i) = first_tsys(i)/nfirst(i)
             ww = w / first_tsys(i)
          endif
          if (nsecond(i).ne.0) then
             second_tsys(i) = second_tsys(i)/nsecond(i)
             ww = ww+ w / second_tsys(i)
          endif
          if (ww.ne.0) then
             visi(ki+2) = ww
          endif
          good = .true.
        endif
      enddo
      if (abs((save_res-xima%gil%fres)/xima%gil%fres).gt.1e-4) then
        write(chain,'(a,1pg13.6)')   &
          'Channel separation rounded to ',xima%gil%fres
        call message(4,1,'FILL_VISI',chain(1:lenc(chain)))
      endif
    endif
  endif
  return
2000 format('Subband ',a,' maps to output channels ',i9,' to ',i9)
end subroutine newuvt_addvisi

#!/bin/bash

### Pre-processing #####################################################

# 'raw' measurements file:
inputfile=wind-plot.dat

# Parsed file:
tmpdir=tmp
mkdir -p $tmpdir
tmpfile=${tmpdir}/wind-plot.dat

# Generate file suited for Astro procedure
# NB: should protect against missing input file, which seems to appear
#     when it is downloaded from Bure
grep weather-logger $inputfile | tail -n 1000 | sed -e 's/.*weather-logger://' | grep -v -e repeated > $tmpfile

# PNG directory
pngdir=png
mkdir -p $pngdir

### Processing #########################################################

# Define input file and output directory for astro procedure
export GAG_WINDPLOT_INPUT=$tmpfile
export GAG_WINDPLOT_OUTPUT=$pngdir
export GAG_WINDPLOT_EXPERIMENTAL=yes  # Overplot the string "EXPERIMENTAL"

# astro -nl: No Log files will be added in $HOME/.gag/logs, even in case
#            of error or normal exit
# NB: if you want to avoid all logs, you can also consider redirecting STDOUT
#     to /dev/null...
nohup astro -nw -nl < wind-plot.astro > wind-plot.log 2>&1


### Post-processing ####################################################

rm -rf $tmpdir

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "go.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gaggo() {
    #
    # Variable and function definitions
    #
    GO_AUTHOR='J. Pety <pety@iram.fr>'
    GO_PROJECT='GILDAS <http://www.iram.fr/IRAMFR/GILDAS>'
    GO_PROGNAME='go.sh'
    #
    go_usage() {
	cat <<EOF 1>&2

Enable easy browsing through GILDAS sources, integration branch, or
executables by providing shortcuts. When browsing the sources, verify
whether others are already editing the target directory. The default
browsed GILDAS trees are defined by the \$gagsrcdir, \$gagintdir, and
\$gagexedir environment variables. The default behavior (ie neither
-e, -i or -s is set) is to browse the source tree as this facility is
intended first for developers.

  usage: source $GO_PROGNAME [options] [subdirectory-name]

options:
  -e          Browse executable  tree
  -i          Browse integration tree
  -s          Browse source      tree
  -h          Show this help page
  -v          Show version information

Examples:

  source $GO_PROGNAME home        -> Go to \$gaghome if this variable is set
  source $GO_PROGNAME gadm        -> Go to \$gaghome/gildas-admin if this directory exists
  source $GO_PROGNAME logs        -> Go to \$gaghome/logs if this directory exists
  source $GO_PROGNAME back or $GO_PROGNAME -  -> Go to the before last directory visited with the go command

  source $GO_PROGNAME -s          -> Go to \$gagsrcdir
  source $GO_PROGNAME -s packages -> Go to \$gagsrcdir/packages
  source $GO_PROGNAME -s greg     -> Go to \$gagsrcdir/kernel/lib/greg (ie the greg library)

  source $GO_PROGNAME -i          -> Go to \$gagintdir
  source $GO_PROGNAME -i pro      -> Go to \$gagintdir/pro
  source $GO_PROGNAME -i lib      -> Go to \$gagintdir/MACHINE-OS-COMPILER/lib
  source $GO_PROGNAME -i system   -> Go to \$gagintdir/MACHINE-OS-COMPILER

  source $GO_PROGNAME -e          -> Go to \$gagexedir
  source $GO_PROGNAME -e pro      -> Go to \$gagexedir/pro
  source $GO_PROGNAME -e lib      -> Go to \$gagexedir/MACHINE-OS-COMPILER/lib
  source $GO_PROGNAME -e system   -> Go to \$gagexedir/MACHINE-OS-COMPILER

EOF
	go_clean
    }
    #
    go_showversion() {
	echo "$GO_PROGNAME by $GO_AUTHOR"
	echo "Project: $GO_PROJECT"
	go_clean
    }
    #
    go_message() {
	echo "$1"
    }
    #
    go_error() {
	go_message "$GO_PROGNAME error: $1" 1>&2
    }
    #
    go_clean() {
	unset GO_PACKAGE GO_SUBDIR GO_DIR
	unset GO_AUTHOR GO_PROJECT GO_PROGNAME
	unset go_usage go_showversion go_message go_error go_clean
	unset tree
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    tree=1  # source tree = 1 (default), integration tree = 2, executable tree = 3
    temp=`getopt "hveis" "$@"`
    if [ $? -ne 0 ]; then go_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-e) tree=3 ;;
	-i) tree=2 ;;
	-s) tree=1 ;;
	-h) go_usage; set --; return 0 ;;
	-v) go_showversion; set --; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) GO_SUBDIR="" ;; # Default subdirectory (see below)!
	1) GO_SUBDIR=$1 ;;
	*) go_usage; set --; return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # Verifies whether the $gagexedir, $gagintdir, or $gagsrcdir directory exists.
    #
    if [ $tree -eq 2 ]; then
	if [ "$gagintdir" = "" ]; then
	    go_error "\$gagintdir is not set"
	    go_error "Please define it by hand"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagintdir ]; then
	    go_error "$gagintdir tree does not exist"
	    go_error "Please (re)define \$gagintdir by hand"
	    go_clean
	    return 1
	fi
    elif [ $tree -eq 3 ]; then
	if [ "$gagexedir" = "" ]; then
	    go_error "\$gagexedir is not set"
	    go_error "Please define it by hand or through the source-gag.sh script with -me options"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagexedir ]; then
	    go_error "$gagexedir tree does not exist"
	    go_error "Please (re)define \$gagexedir by hand or through the source-gag.sh script with -me options"
	    go_clean
	    return 1
	fi
    else
	if [ "$gagsrcdir" = "" ]; then
	    go_error "\$gagsrcdir is not set"
	    go_error "Please define it by hand or through the source-gag.sh script with -ms options"
	    go_clean
	    return 1
	fi
	if [ ! -d $gagsrcdir ]; then
	    go_error "$gagsrcdir tree does not exist"
	    go_error "Please (re)define \$gagsrcdir by hand or through the source-gag.sh script with -ms options"
	    go_clean
	    return 1
	fi
    fi
    #
    #######################################################################
    #
    # Define full directory path from alias
    #
    if [ "$GO_SUBDIR" = "home" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome ]; then
	    go_error "\$gaghome=$gaghome directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome
	fi
    elif [ "$GO_SUBDIR" = "gadm" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome/gildas-admin ]; then
	    go_error "$gaghome/gildas-admin directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome/gildas-admin
	fi
    elif [ "$GO_SUBDIR" = "logs" ]; then
	if [ -z "$gaghome" ]; then
	    go_error "\$gaghome is not set"
	    go_clean
	    return 1
	elif [ ! -d $gaghome/logs ]; then
	    go_error "$gaghome/logs directory does not exist"
	    go_clean
	    return 1
	else
	    GO_DIR=$gaghome/logs
	fi
    elif [ $tree -eq 2 ] || [ $tree -eq 3 ]; then
	if [ $tree -eq 2 ]; then GO_TREE=$gagintdir; fi
	if [ $tree -eq 3 ]; then GO_TREE=$gagexedir; fi
	case $GO_SUBDIR in
	    demo|doc|etc|pro)
		GO_DIR=$GO_TREE/$GO_SUBDIR ;;
	    hlp|html|pdf)
	        GO_DIR=$GO_TREE/doc/$GO_SUBDIR ;;
	    bin|data|include|lib|python|tasks)
		GO_DIR=$GO_TREE/$GAG_EXEC_SYSTEM/$GO_SUBDIR ;;
	    system)
		GO_DIR=$GO_TREE/$GAG_EXEC_SYSTEM ;;
	    back|-)
		GO_DIR=$GO_OLDDIR ;;
	    *)
		GO_DIR=$GO_TREE/$GO_SUBDIR
	esac
    else
	GO_PACKAGE=`pwd | \sed "s%$gagsrcdir/packages/%%;s%/.*%%"`
	if [ "$GO_PACKAGE" = "" ]; then
	   GO_PACKAGE="kernel"
	else
	   GO_PACKAGE="packages/$GO_PACKAGE"
	fi
	case $GO_SUBDIR in
	    demo|doc|etc|lib|main|pro|tasks*)
		GO_DIR=$gagsrcdir/$GO_PACKAGE/$GO_SUBDIR ;;
	    blas|lapack|slatec|cfitsio)
		GO_DIR=$gagsrcdir/legacy/$GO_SUBDIR ;;
	    30m|gildas|pdbi)
		GO_DIR=$gagsrcdir/cookbooks/$GO_SUBDIR ;;
	    astro*|atm*|classic*|class*|mira*|clic*|cube*|flux*|gtemplate*|map*|mis*|mrtcal*|mrtholo*|nic*|obs*|pako*|point*|telcal*|wifisyn*|mywifisyn*|mymis*)
		GO_DIR=$gagsrcdir/packages/$GO_SUBDIR ;;
	    include|python)
		GO_DIR=$gagsrcdir/kernel/$GO_SUBDIR ;;
	    gchar|gcont|gcore|ggtk|ggui|gfits|gio|gmath|greg|gsys|gtv|gwcs|gwidget|gwindows|gx11|sic|gkernel|cfitsio)
		GO_DIR=$gagsrcdir/kernel/lib/$GO_SUBDIR ;;
	    binding*|linedb*)
		GO_DIR=$gagsrcdir/kernel/python/$GO_SUBDIR ;;
	    lut-desc|term-desc)
		GO_DIR=$gagsrcdir/kernel/setup/$GO_SUBDIR ;;
	    weeds*|imager*)
		GO_DIR=$gagsrcdir/contrib/$GO_SUBDIR ;;
	    imbfits)
	        GO_DIR=$gagsrcdir/packages/mrtcal/lib-imbfits ;;
	    back|-)
		GO_DIR=$GO_OLDDIR ;;
	    *)
		GO_DIR=$gagsrcdir/$GO_SUBDIR
	esac
    fi
    #
    #######################################################################
    #
    # Try to go there (and to see whether someone else is doing something
    # in this subdirectory when browsing the source tree)
    #
    if [ -d $GO_DIR ]; then
	echo
	go_message "Going to $GO_DIR"
	GO_OLDDIR=`pwd`
	export GO_OLDDIR
	cd $GO_DIR || return $?
	echo
	if [ $tree -eq 1 ]; then
	    if git rev-parse --git-dir > /dev/null 2>&1; then
		# These are GIT sources
		git status --short --branch .
	    fi
	fi
    else
	if [ $tree -eq 2 ]; then
	    go_error "$GO_SUBDIR directory does not exist in $gagintdir tree"
	elif [ $tree -eq 3 ]; then
	    go_error "$GO_SUBDIR directory does not exist in $gagexedir tree"
	else
	    go_error "$GO_SUBDIR directory does not exist in $gagsrcdir tree"
	fi
	go_clean
	return 1
    fi
    #
    #######################################################################
    #
    # Clean up
    #
    go_clean
}
#
###########################################################################
#
gaggo "$@"
set abc; shift # This line to avoid remanence effect in a portable way
#
###########################################################################

###########################################################################
#
# This file defines useful bash functions, environment variables and
# shortcuts for GILDAS/DEVELOPERS interaction.
#
###########################################################################
#
# This function loads your local GILDAS environment.
# It is compatible with the gagiram script.
# Type "gag -h" for more details.
# Make "dev" the default version (i.e. when gag is called without arguments)
#
function gag() {
     export GAG_COMM_TRACE=$HOME/.gag/logs/gag.log
     export gaghome=$HOME/gildas
     source $gaghome/gildas-admin/source-gag.sh -d dev "$@"
}
#
# This function enables easy browsing of the GILDAS source or executable 
# tree. $gagsrcdir and $gagexedir must be defined. You can use 
# "gag -ms" or "gag -me" to define them without changing the PATHs. 
# Type "go -h" for more details.
#
function go() {
     if [ -z "$gagadmdir" ]; then
         echo 'Please select first a GILDAS version using gag' 1>&2
     else
         source $gagadmdir/go.sh "$@"
     fi
}
#
export -f gag go
#
# Shortcuts
alias gags="gag -s"
alias gage="gag -e"
alias gos="go -s"
alias goi="go -i"
alias goe="go -e"
#
# The next command automatically loads the environment variables
# needed for the default GILDAS version (in this case your local version).
# Uncomment next line if this is really what you want. In any case, this
# is not recommended.
#
#gag > /dev/null 2>&1
#
###########################################################################

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "source-gag.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagsou() {
    #
    # Variable and function definitions
    #
    GAGSOU_AUTHOR='J. Pety <pety@iram.fr>'
    GAGSOU_VERSION=`echo '$Revision$' | cut -d' ' -f2`
    GAGSOU_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    GAGSOU_PROGNAME="gagsou"
    #
    gagsou_usage() {
	cat <<EOF 1>&2

Source the GILDAS environment of either the source tree (defined by
\$gagsrcdir) or the executable tree (defined by \$gagexedir). When the
\$gaghome enviroment variable exists, $GAGSOU_PROGNAME first defines the
\$gagsrcdir or the \$gagexedir using standard conventions (see build
script). Else $GAGSOU_PROGNAME assumes that \$gagsrcdir or \$gagexedir have
been defined elsewhere by the user. The default behavior (ie neither -e or
-s is set) is to source the executable tree as this facility is intended
first for users.

usage: $GAGSOU_PROGNAME [options] [version]

options:
  -h          Show this help page
  -v          Show version information
  -c compiler Replace default compiler by this one
  -o config   Add config to the config list
  -n config   Remove config from the default config list
  -u use-dir  Set gildas directory to use as a complement of local Gildas.
  -d version  On-the-fly selection of a default version. Useful in aliases.
  -e          Load executable tree environment
  -s          Load source     tree environment
  -m          Do not load environment (just define \$gagsrcdir and
		  \$gagexedir if needed)
  -l          List the available systems for the current version, and
              the available versions for the current \$GAG_EXEC_SYSTEM.

EOF
	gagsou_clean
    }
    #
    gagsou_showversion() {
	echo
	echo "$GAGSOU_PROGNAME version $GAGSOU_VERSION, by $GAGSOU_AUTHOR"
	echo "Project: $GAGSOU_PROJECT"
	echo
	gagsou_clean
    }
    #
    gagsou_message() {
	echo "$1"
    }
    #
    gagsou_error() {
	echo  1>&2
	echo "Error: $1" 1>&2
	echo  1>&2
	gagsou_clean
	return 1
    }
    #
    gagsou_exe_env_nohome() {
        if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
            if [ $dosource -eq 1 ]; then
                GAGRC=$gagexedir/etc/bash_profile
                if [ -e "$GAGRC" ]; then
                    source $GAGRC
                else
                    gagsou_error "Configuration file $GAGRC does not exist" || return $?
                fi
            fi
        else
            gagsou_error "No GILDAS version: $GAG_EXEC_SYSTEM in $gagexedir" || return $?
        fi
    }
    #
    gagsou_src_env_nohome() {
        if [ -d "$gagsrcdir" ]; then
            if [ $dosource -eq 1 ]; then
                source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
            fi
        else
            gagsou_error "No GILDAS version in $gagsrcdir" || return $?
        fi
    }
    #
    gagsou_exe_env() {
        ogagexedir=$gagexedir
        if [ -h "$EXEDIR" ] && [ -e "$EXEDIR" ]; then
            gagexedir=`\dirname $EXEDIR`/`\readlink $EXEDIR`  # Translate e.g. gildas-exe-last symlink
        else
            gagexedir=$EXEDIR
        fi
        if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
            GAG_ROOT_DIR=$gagexedir
            if [ $dosource -eq 1 ]; then
                GAGRC=$gagexedir/etc/bash_profile
                if [ -e "$GAGRC" ]; then
                    source $GAGRC
                else
                    gagsou_error "Configuration file $GAGRC does not exist" || return $?
                fi
            fi
        else
            gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
        fi
    }
    #
    gagsou_src_env() {
        ogagsrcdir=$gagsrcdir
        if [ -h "$SRCDIR" ] && [ -e "$SRCDIR" ]; then
            gagsrcdir=`\dirname $SRCDIR`/`\readlink $SRCDIR`  # Translate e.g. gildas-src-last symlink
        else
            gagsrcdir=$SRCDIR
        fi
        if [ -d "$gagsrcdir" ]; then
            if [ $dosource -eq 1 ]; then
                source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
            fi
        else
            gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
        fi
        export ogagsrcdir gagsrcdir
    }
    #
    gagsou_exe_list() {
        gagsou_system_list "$gaghome/gildas-exe-$GAG_VERS" || return $?
        gagsou_version_list "$gaghome/gildas-exe-*" "$GAG_EXEC_SYSTEM" || return $?
    }
    #
    gagsou_src_list() {
        gagsou_system_list "$gaghome/gildas-src-$GAG_VERS/integ" || return $?
        gagsou_version_list "$gaghome/gildas-src-*" "integ/$GAG_EXEC_SYSTEM" || return $?
    }
    #
    gagsou_system_list() {
        # $1: pattern for main directory
        found=0
        # List, ordered by time, newest first
        for x in `\ls -d $1/* 2> /dev/null`; do
            if [ ! -d "$x/bin" ]; then
              continue  # cycle loop
            fi
            if [ $found -eq 0 ]; then
                found=1
                gagsou_message "Available systems for $GAG_VERS version in $gaghome:"
            fi
            echo "    "`basename $x`
        done
        if [ $found -eq 0 ]; then
            gagsou_message "No available systems for $GAG_VERS in $gaghome"
        fi
    }
    #
    gagsou_version_list() {
        # $1: pattern for main directory
        # $2: subdirectory searched in matching directories
        found=0
        # List, ordered by time, newest first
        for x in `\ls -dt $1 2> /dev/null`; do
            if [ ! -d "$x/$2" ]; then
              continue  # cycle loop
            fi
            if [ $found -eq 0 ]; then
                found=1
                gagsou_message "Available versions for $GAG_EXEC_SYSTEM in $gaghome:"
            fi
            # Check if $x is a symlink to another version:
            y=`readlink $x`
            # Keep only the version name:
            x=`echo $x | perl -pe "s?$gaghome/gildas-\w+-(\w+).*?\1?"`
            # Feedback, with symlink translation if relevant
            if [ -z "$y" ]; then
                echo "    $x"
            else
                y=`echo $y | perl -pe "s?gildas-\w+-(\w+).*?\1?"`
                echo "    $x -> $y"
            fi
        done
        if [ $found -eq 0 ]; then
            gagsou_message "No GILDAS version for $GAG_EXEC_SYSTEM in $gaghome"
        fi
    }
    #
    gagsou_clean() {
	unset IN_COMPILER IN_CONFIG IN_USE IN_VERSION DEF_VERSION
	unset GAGSOU_AUTHOR GAGSOU_PROJECT GAGSOU_PROGNAME
	unset gagsou_usage gagsou_showversion gagsou_message gagsou_error
	unset gagsou_exe_env_nohome gagsou_src_env_nohome
	unset gagsou_exe_env        gagsou_src_env
	unset gagsou_exe_list       gagsou_src_list
	unset gagsou_system_list    gagsou_version_list
	unset dolist dosource executable
	unset gagsou_clean
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    IN_COMPILER="default" # Default compiler will be setup by gagdefsys
    IN_CONFIG=            # Default config will be setup by gagdefsys
    IN_USE="default"      # Default use-dir is empty
    DEF_VERSION="default" # Default version will be setup by gagdefver
    dolist=0              # Default is not to list the versions
    dosource=1            # Default is to source environment
    executable=1          # Default is to select the executable tree.
    temp=`getopt "hveslmc:o:n:u:d:" "$@"`
    if [ $? -ne 0 ]; then gagsou_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-c) IN_COMPILER=$2; shift ;;
	-o) IN_CONFIG="$IN_CONFIG -o $2"; shift;;
	-n) IN_CONFIG="$IN_CONFIG -n $2"; shift;;
	-u) IN_USE=$2; shift ;;
	-d) DEF_VERSION=$2; shift ;;
	-e) executable=1 ;;
	-s) executable=0 ;;
	-m) dosource=0 ;;
	-l) dolist=1 ;;
	-v) gagsou_showversion; return 0 ;;
	-h) gagsou_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) IN_VERSION=$DEF_VERSION ;;
	1) IN_VERSION=$1 ;;
	*) gagsou_usage; return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # Define gagadmdir
    #
    if [ -d "$gaghome/gildas-admin" ]; then
	gagadmdir=$gaghome/gildas-admin
    elif [ -d "$gagsrcdir/admin" ]; then
	gagadmdir=$gagsrcdir/admin
    else
	gagsou_error "Failed to define \$gagadmdir. Please define it by hand." || return $?
    fi
    export gagadmdir
    #
    # Define system in all cases
    #
    . $gagadmdir/define-system.sh                      # Load gagdefsys function
    if [ $executable -eq 1 ]; then
        gagdefsys -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
    else
        gagdefsys -s -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
    fi
    unset gagdefsys                                    # Remove gagdefsys function
    #
    # Define gagsrcdir, gagexedir and GAG_ROOT_DIR only when gaghome exists.
    # In all cases, try to source the environment.
    #
    if [ -z "$gaghome" ]; then
        #
        # No version definition: assume $gagsrcdir or $gagexedir are already set
	#
	# Setup environment or list
	#
	if [ $dolist -eq 1 ]; then
            gagsou_error "\$gaghome is unset: can not list versions" || return $?
	elif [ $executable -eq 1 ]; then
            gagsou_exe_env_nohome || return $?
	else
            gagsou_src_env_nohome || return $?
	fi
    else
	#
        # Setup environment or list
        #
        . $gagadmdir/define-version.sh  # Load gagdefver function
        gagdefver $IN_VERSION -n || return 1
        unset gagdefver
	if [ $dolist -eq 1 ]; then
            if [ $executable -eq 1 ]; then
                gagsou_exe_list || return 1
            else
                gagsou_src_list || return 1
            fi
	else
            if [ $executable -eq 1 ]; then
                gagsou_exe_env || return $?
            else
                gagsou_src_env || return $?
            fi
        fi
    fi
    #
    #######################################################################
    #
    # Cleaning
    #
    gagsou_clean
}
#
###########################################################################
#
gagsou $@
set abc; shift # This line to avoid remanence effect in a portable way
#
###########################################################################

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "define-version.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagdefver() {
    #
    # Variable and function definitions
    #
    DEFVER_AUTHOR='J. Pety <pety@iram.fr>'
    DEFVER_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    DEFVER_PROGNAME='gagdefver'
    DEFVER_REPOSITORY="git@git.iram.fr:scsf/gildas.git"
    DEFVER_MODULE=gildas
    #
    defver_usage() {
	cat <<EOF 1>&2

Define standard directory name conventions used by the "build" and
"source-gag.sh" scripts to enable easy coexistence of different GILDAS
version. To do this, define the following environment variables: 
   GAG_VERS: the Gildas version to be used, e.g. last, month, 31oct,
             nov18, etc...
   GAG_TAG:  the corresponding Git branch or tag, e.g. r18-nov
   SRCDIR:   the corresponding source directory
   EXEDIR:   the corresponding installation directory
   LOGDIR:   the corresponding log directory

usage: source $DEFVER_PROGNAME [version]

options:
  -d     Refine GAG_VERS with tag date if possible
  -n     Do not translate 'day' or 'month' to current day or month, but
         assume that directories (or symlinks to) exist with the input
         version name.
  -h     Show this help page
  -v     Show version information

EOF
	defver_clean
    }
    #
    defver_showversion() {
	echo "$DEFVER_PROGNAME, by $DEFVER_AUTHOR"
	echo "Project: $DEFVER_PROJECT"
	defver_clean
    }
    #
    defver_message() {
	echo "$DEFVER_PROGNAME: $1"
    }
    #
    defver_error() {
	echo 1>&2
	echo "$DEFVER_PROGNAME error: $1" 1>&2
	echo 1>&2
	defver_clean
    }
    #
    defver_clean() {
	unset defver_usage defver_showversion defver_message 
	unset defver_error defver_clean defver_clone
	unset defver_tagdate defver_date
	unset DEFVER_AUTHOR DEFVER_PROGNAME DEFVER_PROJECT
	unset DEFVER_INVERS DEFVER_OUTVERS  DEFVER_OUTTAG
	unset DEFVER_MODULE DEFVER_REPOSITORY
    }
    #
    defver_clone() {
        #
        # * Clone the repository in a temporary directory (env var $tmpdir
        #   is set in return). It is the responsibility of the caller to
        #   destroy this directory when it's done.
        # * Clone the branch named as argument. We perform here a
        #   MINIMALISTIC clone (as we are interested only in the latest
        #   change in a given branch):
        #     - only a bare repo (no need to checkout the files),
        #     - only single branch,
        #     - only last commit in this branch.
        #     - discard tags.
        # * In return the current working directory is the root of the
        #   cloned sources.
        #
        tmpdir=/tmp/$DEFVER_MODULE-$$
        mkdir -p $tmpdir
        \cd $tmpdir
        #
        git clone \
          --bare \
          --branch $1 --single-branch \
          --depth 1 \
          --no-tags \
          $DEFVER_REPOSITORY $DEFVER_MODULE 2> /dev/null || \
          defver_error "cloning branch '$1' from GIT"
        \cd $DEFVER_MODULE
        #
        export tmpdir
        #
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    temp=`getopt "dnhv" "$@"`
    if [ $? -ne 0 ]; then defver_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-d) defver_date=1 ;;
	-n) defver_not=1 ;;
	-v) defver_showversion; return 0 ;;
	-h) defver_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) DEFVER_INVERS="default";; # Default version defined below!
	1) DEFVER_INVERS=$1;;
	*) defver_usage;  return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # 'day' is an alias for the current day. $GAG_VERS has the form 'ddmmm'
    #
    # 'month' is an alias for the current month. $GAG_VERS has the form
    # 'mmmyy', $GAG_TAG has the form 'ryy-mmm'.
    #
    # 'dev' is equivalent to main trunk.
    #
    case $DEFVER_INVERS in
	day)     if [ "$defver_not" ]; then
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                 else
                      DEFVER_OUTVERS=`date '+%d%b' | tr '[:upper:]' '[:lower:]'`;
                 fi;
                 DEFVER_OUTTAG=$DEFVER_INVERS ;;

	month)   if [ "$defver_not" ]; then
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                 else
                      DEFVER_OUTVERS=`date '+%b%y' | tr '[:upper:]' '[:lower:]'`;
                 fi;
                 DEFVER_OUTTAG=`date '+r%y-%b' | tr '[:upper:]' '[:lower:]'` ;;

        dev)     DEFVER_OUTVERS="dev";
                 DEFVER_OUTTAG="master" ;;

        default) DEFVER_OUTVERS="last";
                 DEFVER_OUTTAG="last" ;;

        *)       if echo $DEFVER_INVERS | grep -q '^[a-z][a-z][a-z][0-9][0-9]$' ; then
                      # Parse e.g. "nov19" as "r19-nov": this adds support for
                      # monthly releases other than current month one.
                      myyear=`echo $DEFVER_INVERS | sed 's/[a-z][a-z][a-z]//'`;
                      mymonth=`echo $DEFVER_INVERS | sed 's/[0-9][0-9]//'`;
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                      DEFVER_OUTTAG="r$myyear-$mymonth";
                      unset myyear mymonth
                 else
                      DEFVER_OUTVERS=$DEFVER_INVERS;
                      DEFVER_OUTTAG=$DEFVER_INVERS;
                 fi
    esac
    #
    #######################################################################
    #
    # Define $GAG_TAG.
    #
    export GAG_TAG=$DEFVER_OUTTAG
    #
    #######################################################################
    #
    # Define $GAG_VERS. Refine GAG_VERS with tag date when asked and
    # possible.
    #
    GAG_VERS=$DEFVER_OUTVERS
    if [ "$defver_date" ]; then
	# Can refine date only if branch already exists!
	if git ls-remote --heads --exit-code $DEFVER_REPOSITORY $GAG_TAG > /dev/null; then
	    curdir="$PWD"
	    defver_clone $GAG_TAG
	    defver_tagdate=`git log -1 --format=%ct $GAG_TAG`  # UNIX timestamp
	    # date -d is not portable: try GNU syntax, else BSD syntax
	    defver_date=$(date -d "@$defver_tagdate" "+%d%b%y %H:%M %Z" 2> /dev/null) || \
	    defver_date=$(date -j -f "%s" $defver_tagdate "+%d%b%y %H:%M %Z" )
	    defver_date=`echo $defver_date | tr '[:upper:]' '[:lower:]'`
	    GAG_VERS="${GAG_VERS} (${defver_date})"
	    \cd $curdir
	    \rm -rf $tmpdir
	    unset tmpdir
	fi
    fi
    export GAG_VERS
    #
    #######################################################################
    #
    if [ -z "$gaghome" ]; then
	gaghome=$HOME/gildas
    fi
    export gaghome
    #
    #######################################################################
    #
    SRCDIR=$gaghome/gildas-src-$DEFVER_OUTVERS
    EXEDIR=$gaghome/gildas-exe-$DEFVER_OUTVERS
    LOGDIR=$gaghome/logs/$DEFVER_OUTVERS
    export SRCDIR EXEDIR LOGDIR
    #
    #######################################################################
    #
    defver_clean
}
#
###########################################################################

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "gildas-env.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagenv() {
    #
    # Variable and function definitions
    #
    GAGENV_AUTHOR='J. Pety <pety@iram.fr>'
    GAGENV_VERSION=`echo '$Revision$' | cut -d' ' -f2`
    GAGENV_PROJECT='GILDAS <http://www.iram.fr/IRAMFR/GILDAS>'
    GAGENV_PROGNAME="gildas-env.sh"
    #
    gagenv_usage() {
        cat <<EOF 1>&2

Define the environment needed for compilation, test and installation
GILDAS. It take the following steps:

  1. Definition of:
           * gagadmdir       (administrative directory);
           * gagsrcdir       (root directory of the source tree);
           * gagintdir       (root directory of the integration tree);
           * gagexedir       (root directory of the executable tree);
           * GAG_ROOT_DIR    (root directory of the currently used tree);
           * GAG_GAG         (location of init, scratch, and log directories)
           * GAG_PATH        (location of dictionaries);
           * GAG_VERS        (current gildas version);
           * GAG_EXEC_SYSTEM (MACHINE-OS-COMPILER(-CONFIG));
           * GAG_OBSERVATORY (default observatory at ASTRO startup);
           * GAG_PAPER_SIZE  (default paper size in PostScript files).

     By default, GAG_OBSERVATORY is set to NOEMA. If you want to
     change this default, just "export GAG_OBSERVATORY=YOUR-OBS-NAME"
     before sourcing gildas-env.sh. By default, GAG_PAPER_SIZE is set
     to A4. If you want to change this default to US_LETTER, just
     export "GAG_PAPER_SIZE=US_LETTER" before sourcing gildas-env.sh.

  2. Search for the binaries and associated headers of important
     libraries (GTK+, ...). Search first in standard places, then in a
     path that user can pass either through the GAG_SEARCH_PATH
     environment variable or through the -s switch. A warning is
     output when the search fails. GILDAS by default uses its own
     versions of the FFT library. If the user wants to use its own
     copies (e.g. FFTW v3), he has to pass the directory where those
     libraries are installed in the search path (i.e. through
     GAG_SEARCH_PATH or through the -s switch).

  3. Search for useful, but non-essential GILDAS dependencies (ie
     CFITSIO,PNG) in the path passed either through GAG_SEARCH_PATH or
     through the -s switch. Default to sensible solution when not
     found.

  4. (Re)define needed paths for full use of the source tree in place
     (ie before installation). Some of the (re)defined paths are also
     useful at compile time.

usage: $GAGENV_PROGNAME [options]

options:
  -b ccompiler  Replace default C compiler by this one
  -c fcompiler  Replace default Fortran compiler by this one
  -d cxxcompil  Replace default C++ compiler by this one
  -o <config>   Add config to the config list.
  -u use-dir    Set gildas directory to use as a complement of local Gildas.
  -s path       Additional search path for libraries GILDAS depends
                upon. This path is searched after default standard
                locations and will thus override them.
  -p            Compile prototypes in addition of stables GILDAS parts
                Setting the GAG_PROTO environment variable to "yes" will
                have the same effect.
  -n <feature>  Disable input feature. Keyword(s) can be:
                  python  : disable Python binding
                or any other config as set with -o option.
  -t target     Define the system target compiled under current
                build environment.
  -x            Also detect X11. X11 is not directly a Gildas dependency,
                but it might be needed for other software built against
                Gildas.
  -h            Show this help page
  -v            Show version information

EOF
        gagenv_clean
    }
    #
    gagenv_showversion() {
        echo
        echo "$GAGENV_PROGNAME version $GAGENV_VERSION, by $GAGENV_AUTHOR"
        echo "Project: $GAGENV_PROJECT"
        echo
        gagenv_clean
    }
    #
    gagenv_message() {
        echo "$1"
    }
    #
    gagenv_error() {
        echo "$GAGENV_PROGNAME error: $1" 1>&2
    }
    #
    gagenv_remove_config() {
        if [ "$GAGENV_CONFIG" != "default" ]; then
            GAGENV_CONFIG=`echo $GAGENV_CONFIG|tr '-' '\n'|egrep -v "^$1\$"|tr '\n' '-' | \sed 's/-$//'`
            if [ "$GAGENV_CONFIG" = "" ]; then
                GAGENV_CONFIG="default"
            fi
        fi
    }
    #
    gagenv_add_config() {
        #if [ $1 =~ "^no_" ]; then # works with recent bash
        if [ `echo $1 | grep '^no_'` ]; then
            # remove yes config
            NO_CONFIG=`echo $1 | \sed 's/no_//'`
            gagenv_remove_config $NO_CONFIG
            gagenv_disable $NO_CONFIG "yes"
        else
            # remove no config
            gagenv_remove_config no_$1
            gagenv_disable $1 "no"
        fi;
        if [ "$GAGENV_CONFIG" = "default" ]; then
            GAGENV_CONFIG=$1;
        else
            GAGENV_CONFIG=$GAGENV_CONFIG-$1;
        fi;
    }
    #
    gagenv_disable() {
        # Disable or reenable input feature. Variables DISABLE_* are local to
        # this file, and ensure detection or not of the desired feature.
        # If input feature name in unknown: no matter. This means that it has
        # no effect in this file.
        # $1: feature name
        # $2: "yes" or "no"
        if [ "$1" = "python" ]; then
            DISABLE_PYTHON=$2
        elif [ "$1" = "staticlink" ]; then
            if [ "$2" = "no" ]; then
        	DISABLE_PYTHON="yes"
            fi
        elif [ "$1" = "profile" ]; then
            # Config "-o profile" turns on static linking: must disable Python
            if [ "$2" = "no" ]; then
        	DISABLE_PYTHON="yes"
            fi
        fi
    }
    #
    gagenv_clean() {
        unset GAGENV_AUTHOR GAGENV_PROJECT GAGENV_PROGNAME
        unset GAGENV_CCOMPILER GAGENV_FCOMPILER GAGENV_CXXCOMPILER GAGENV_CONFIG
        unset GAG_INT_BIN_DIR GAG_INT_INC_DIR GAG_INT_LIB_DIR GAG_INT_PYTHON_DIR GAG_INT_ROOT_DIR GAG_INT_TASKTEX_DIR
        unset gagenv_errors gagenv_warnings
        unset gagenv_usage gagenv_showversion gagenv_message gagenv_error gagenv_clean
        unset DISABLE_PYTHON
        unset DIR DIRLIST NO_CONFIG occurences gagenv_option_x11
    }
    #
    # file_present "FILE" "DIR": Is file FILE present in DIR directory?
    file_present() {
        # Find any extension (e.g. so, a, dll, ...) which does NOT contain a
        # dot (e.g. so.3 is not counted), because e.g. /usr/lib64/liblapack.so.3
        # is useless and can not be found by the linker on command lines like
        # "-L/usr/lib -llapack"
        occurences=`\ls ${2}/${1}* 2> /dev/null | \grep -v "${2}/${1}.*\." | \wc -l`
        if [ ${occurences} -ge 1 ]; then
            \return 0
        else
            \return 1
        fi
    }
    #
    # file_absent "FILE" "DIR": Is file FILE absent in DIR directory?
    file_absent() {
        if file_present ${1} ${2}; then
            \return 1
        else
            \return 0
        fi
    }
    #
    # Portable functions for version strings comparison, based on sort -V.
    verle() {
        # Return 0 if first argument is "lower or equal" the second argument
        # NB: the line return in echo below is more portable than echo -e "\n"
        [  "$1" = "`echo "$1
$2" | sort -V | head -n1`" ]
    }
    verlt() {
        # Return 0 if first argument is "lower than" second argument
        [ "$1" = "$2" ] && return 1 || verle $1 $2
    }
    #
    gagenv_detect_x11() {
	#
	X11_INC=no
	X11_LIB=no
	OLDIFS=$IFS
	IFS=:
	for DIR in $INC_PATH; do
	    if file_present "X.h" "${DIR}/X11"; then
		X11_INC=yes
		X11_INC_DIR=$DIR
	    fi
	done
	for DIR in $LIB_PATH; do
	    if file_present "libX11." "${DIR}"; then
		X11_LIB=yes
		X11_LIB_DIR=$DIR
	    fi
	done
	IFS=$OLDIFS
	#
	if [ "$X11_INC" = "yes" ]; then
	    gagenv_message "Found X11 header  in $X11_INC_DIR"
	    GAG_INC_DEP_PATH=$GAG_INC_DEP_PATH:$X11_INC_DIR
	else
	    gagenv_message "WARNING: X11 header file not found"
	    gagenv_message "This is only needed for the PdBI utilities"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	if [ "$X11_LIB" = "yes" ]; then
	    gagenv_message "Found X11 library in $X11_LIB_DIR"
	    GAG_LIB_DEP_PATH=$GAG_LIB_DEP_PATH:$X11_LIB_DIR
	else
	    gagenv_message "WARNING: X11 binary file not found"
	    gagenv_message "This is probably not needed on your system"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	#
	# Clean local variables
	unset X11_INC X11_LIB X11_INC_DIR X11_LIB_DIR
    }
    #
    gagenv_detect_legacy() {
	#
	# Explore GAGENV_SEARCH_PATH
	#
	FFTW3_PRESENT=no
	FFTW3F_PRESENT=no
	#
	OLDIFS=$IFS
	IFS=:
	for DIR in $GAGENV_SEARCH_PATH; do
	    # Note: libfftw3 and libfftw3f must be in the same directory
	    if file_present "libfftw3." "${DIR}"; then
		FFTW3_PRESENT=yes
		FFTW3_LIB_DIR=$DIR
		if file_present "libfftw3f." "${DIR}"; then
		    FFTW3F_PRESENT=yes
		fi
	    fi
	done
	IFS=$OLDIFS
	#
	if [ "$GAG_CONFIG" != -no_openmp ]; then
	    gagenv_message "FFTW v3 are not supported in OpenMP mode. Default to GILDAS FFT."
	    FFTW3_PRESENT=no
	    FFTW3F_PRESENT=no
	elif [ "$FFTW3F_PRESENT" = "yes" ]; then
	    gagenv_message "Found FFTW v3 libraries in $FFTW3_LIB_DIR"
	    GAG_LIB_DEP_PATH=$GAG_LIB_DEP_PATH:$FFTW3_LIB_DIR
	elif [ "$FFTW3_PRESENT" = "yes" ]; then
	    gagenv_message "Found FFTW v3 library in $FFTW3_LIB_DIR"
	    GAG_LIB_DEP_PATH=$GAG_LIB_DEP_PATH:$FFTW3_LIB_DIR
	else
	    gagenv_message "FFTW3 not found. Default to GILDAS FFT."
	fi
	#
	# Clean local variables
	unset FFTW3_LIB_DIR
    }
    #
    gagenv_detect_openmp() {
        #
        if [ "$GAG_CONFIG" = -no_openmp ]; then
            gagenv_message "Parallelization with OpenMP is DISABLED."
        else
            gagenv_message "Parallelization with OpenMP is enabled."
        fi
    }
    #
    gagenv_detect_atm() {
	#
	if [ -n "$GAG_COMPILER_CXXEXE" ]; then
	    ATM2009_PRESENT=yes  # Default is to activate this one
	    ATM2016_PRESENT=no
	else
	    gagenv_message "No C++ compiler found in your \$PATH"
	    gagenv_message "This means that ATM will not be available"
	    ATM2009_PRESENT=no
	    ATM2016_PRESENT=no
	fi
	#
	if [ "$ATM2009_PRESENT" = "yes" ] || [ "$ATM2016_PRESENT" = "yes" ]; then
	    gagenv_message "Found $GAG_COMPILER_CXXEXE compiler in your \$PATH"
	    gagenv_message "You will have the possibility to use ATM 2009/2016 in ASTRO"
	    gagenv_message 'Just type "ASTRO> set atm 2009|2016"'
	else
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
    }
    #
    gagenv_detect_png() {
        #
	if \which libpng-config > /dev/null 2>&1; then
	    PNG_VERSION=`libpng-config --version`
	    gagenv_message "Found PNG $PNG_VERSION development tools"
	    PNG_PRESENT=yes
	else
	    gagenv_message "WARNING: PNG development tools not found"
	    gagenv_message "You won't be able to produce PNG hardcopies"
	    PNG_PRESENT=no
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	#
	# Clean local variables
	unset PNG_VERSION
    }
    #
    gagenv_detect_gtk2() {
	#
	GTK2_PRESENT=no
	if ! \which pkg-config > /dev/null 2>&1; then
	    gagenv_message "ERROR: pkg-config not found on your system"
	    gagenv_message "Some dependencies can not be detected without it"
	    gagenv_errors=$((gagenv_errors+1))
	elif pkg-config --exists gtk+-2.0; then
	    GTK2_VERSION=`pkg-config --modversion gtk+-2.0`
	    gagenv_message "Found GTK+ $GTK2_VERSION"
	    GTK2_VERSION_MAJOR=`echo $GTK2_VERSION | \sed "s%\([0-9][0-9]*\)\.[0-9][0-9]*.*%\1%"`
	    GTK2_VERSION_MINOR=`echo $GTK2_VERSION | \sed "s%[0-9][0-9]*\.\([0-9][0-9]*\).*%\1%"`
	    if [ "$GTK2_VERSION_MAJOR" -lt "2" ]; then
		gagenv_message "ERROR: this version is too old, support starts at 2.6"
		GTK2_PRESENT=no
		gagenv_errors=$((gagenv_errors+1))
	    elif [ "$GTK2_VERSION_MINOR" -lt "6" ]; then
		gagenv_message "ERROR: this version is too old, support starts at 2.6"
		GTK2_PRESENT=no
		gagenv_errors=$((gagenv_errors+1))
	    else
		GTK2_PRESENT=yes
	    fi
	fi
	#
	# Clean local variables
	unset GTK2_VERSION GTK2_VERSION_MAJOR GTK2_VERSION_MINOR
    }
    #
    gagenv_detect_gtk3() {
	#
	GTK3_PRESENT=no
	if ! \which pkg-config > /dev/null 2>&1; then
	    gagenv_message "ERROR: pkg-config not found on your system"
	    gagenv_message "Some dependencies can not be detected without it"
	    gagenv_errors=$((gagenv_errors+1))
	elif pkg-config --exists gtk+-3.0; then
	    GTK3_VERSION=`pkg-config --modversion gtk+-3.0`
	    gagenv_message "Found GTK+ $GTK3_VERSION"
	    GTK3_VERSION_MAJOR=`echo $GTK3_VERSION | \sed "s%\([0-9][0-9]*\)\.[0-9][0-9]*.*%\1%"`
	    GTK3_VERSION_MINOR=`echo $GTK3_VERSION | \sed "s%[0-9][0-9]*\.\([0-9][0-9]*\).*%\1%"`
	    if [ "$GTK3_VERSION_MAJOR" -lt "3" ]; then
            gagenv_message "WARNING: this version is too old, support starts at 3.24"
            GTK3_PRESENT=no
            #gagenv_errors=$((gagenv_errors+1))
	    elif [ "$GTK3_VERSION_MINOR" -lt "24" ]; then
            gagenv_message "WARNING: this version is too old, support starts at 3.24"
            GTK3_PRESENT=no
            #gagenv_errors=$((gagenv_errors+1))
	    else
            GTK3_PRESENT=yes
	    fi
	fi
	#
	# Clean local variables
	unset GTK3_VERSION GTK3_VERSION_MAJOR GTK3_VERSION_MINOR
    }
    #
    gagenv_detect_gtk() {
        gagenv_detect_gtk3
        if [ "$GTK3_PRESENT" = "yes" ]; then
            gagenv_message "You will have access to the GTK+ 3.x interface of GILDAS"
        else
            gagenv_detect_gtk2
            if [ "$GTK2_PRESENT" = "yes" ]; then
                gagenv_message "You will have access to the GTK+ 2.x interface of GILDAS"
            else
                gagenv_message "ERROR: GTK+ 2.x or GTK+ 3.x not found on your system"
                gagenv_message "You have to install the GTK+ 2.x or GTK+ 3.x development package"
                gagenv_errors=$((gagenv_errors+1))
            fi
        fi
    }
    #
    gagenv_detect_openssl() {
	#
	OPENSSL_PRESENT=no
	if \which pkg-config > /dev/null 2>&1; then
	    # Already raised a warning if pkg-config is not available
	    if pkg-config --exists openssl; then
		OPENSSL_PRESENT=yes;
	    fi
	fi
	#
	if [ "$OPENSSL_PRESENT" = "yes" ]; then
	    gagenv_message "Found OPENSSL version "`pkg-config --modversion openssl`" in "`pkg-config --variable=libdir openssl`
	else
	    gagenv_message "WARNING: OPENSSL not found using pkg-config"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
    }
    #
    gagenv_detect_cfitsio() {
	#
	CFITSIO_PRESENT=no
	if \which pkg-config > /dev/null 2>&1; then
	    # Already raised a warning if pkg-config is not available
	    #
	    # For backward compatibility, search first in $GAG_SEARCH_PATH paths
	    OLD_PKG_CONFIG_PATH=$PKG_CONFIG_PATH
	    OLDIFS=$IFS
	    IFS=:
	    for DIR in $GAG_SEARCH_PATH; do
		export PKG_CONFIG_PATH="${DIR}/pkgconfig${OLD_PKG_CONFIG_PATH:+:$OLD_PKG_CONFIG_PATH}"
		if pkg-config --exists cfitsio; then
		    CFITSIO_PRESENT=yes
		    break
		else
		  PKG_CONFIG_PATH=$OLD_PKG_CONFIG_PATH
		fi
	    done
	    IFS=$OLDIFS
	    #
	    # Not found in $GAG_SEARCH_PATH? Try user's custom PKG_CONFIG_PATH or default
	    # system location
	    if [ "$CFITSIO_PRESENT" != "yes" ]; then
		if pkg-config --exists cfitsio; then
		    CFITSIO_PRESENT=yes;
		fi
	    fi
	fi
	#
	if [ "$CFITSIO_PRESENT" = "yes" ]; then
	    gagenv_message "Found CFITSIO version "`pkg-config --modversion cfitsio`" in "`pkg-config --variable=libdir cfitsio`
	    gagenv_message "You will have support for on-line 30m calibration (inside MIRA or MRTCAL)"
	    gagenv_message "You will have access to the CUBE and MAPPING reduction software"
	else
	    gagenv_message "WARNING: CFITSIO not found using pkg-config and looking in \$PKG_CONFIG_PATH"
	    gagenv_message "This means impossible calibration of data from 30m/NCS inside MIRA or MRTCAL"
	    gagenv_message "The CUBE and MAPPING reduction software will not be available"
	    gagenv_message "The FITS <-> Gildas internal converters will still be available"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	#
	# Clean local variables
	unset OLD_PKG_CONFIG_PATH
    }
    #
    gagenv_detect_python() {
	#
	# Detection
	if [ "$DISABLE_PYTHON" = "no" ]; then
	    PYTHON_VERS=none
	    PYTHON_INC=no
	    PYTHON_LIB=no
	    NUMPY_PRESENT=no
	    SQLITE3_PRESENT=no
	    SETUPTOOLS_PRESENT=no
	    PYTHONCONFIG_PRESENT=no
	    if [ -n "$GAG_PYTHON_EXE" ]; then
                PYTHON_VERS=`echo $GAG_PYTHON_VERSION | \sed "s%\([0-9]\.[0-9][0-9]*\).*%\1%"`
                # Search for Python header and library. kernel/python/binding/setup.py
                # does exactly the same, so this should be consistent
                PYTHON_INC_DIR=`$GAG_PYTHON_EXE -c "import sysconfig; print(sysconfig.get_config_var('INCLUDEPY'))"`
                if [ -e "$PYTHON_INC_DIR/Python.h" ]; then PYTHON_INC=yes; else PYTHON_INC=no; fi
                PYTHON_LIB_DIR=`$GAG_PYTHON_EXE -c "import sysconfig; print(sysconfig.get_config_var('LIBDIR'))"`
                PYTHON_LIB=yes  # libpython name on the various supported systems is just
                                # unpredictible. Can not check in advance if the linker will
                                # find it or not. See also our script python-config-ldflags.py
                #
                # Now search for Numpy
                if $GAG_PYTHON_EXE -c "import numpy" > /dev/null 2>&1; then
                    NUMPY_PRESENT=yes
                    # Note: with numpy>=2.0.0, this can be achieved with numpy-config or
                    # pkg-config --cflags numpy
                    NUMPY_INC_DIR=`$GAG_PYTHON_EXE -c "import numpy; print(numpy.get_include())"`
                    if [ -e "$NUMPY_INC_DIR/numpy/arrayobject.h" ]; then
                        NUMPY_INC_PRESENT=yes
                    else
                        NUMPY_INC_PRESENT=no
                    fi
                fi
                # Search for sqlite3
                if $GAG_PYTHON_EXE -c "import sqlite3" > /dev/null 2>&1; then
                    SQLITE3_PRESENT=yes
                fi
                # Search for setuptools
                if $GAG_PYTHON_EXE -c "import setuptools" > /dev/null 2>&1; then
                    SETUPTOOLS_PRESENT=yes
                fi
                # Search for python-config
                if \which $GAG_PYTHON_EXE-config > /dev/null 2>&1; then
                    PYTHONCONFIG_PRESENT=yes
                fi
	    else
		gagenv_message "Python not found in your \$PATH"
	    fi
	fi
	#
	# Feedback
	PYTHON_SUPPORTED="3.6"  # Minimum Python version supported
	if [ "$DISABLE_PYTHON" = "yes" ]; then
	    gagenv_message "You have disabled Python binding"
	elif [ "$PYTHON_VERS" = "none" ]; then
	    gagenv_message "Problem executing Python"
	    PYTHON_PRESENT=no
	elif verlt "$PYTHON_VERS" "$PYTHON_SUPPORTED"; then
	    gagenv_message "Python $PYTHON_VERS not supported (support available from $PYTHON_SUPPORTED)"
	    PYTHON_PRESENT=no
	elif [ "$SETUPTOOLS_PRESENT" = "no" ]; then
	    gagenv_message "Python module setuptools not found"
	    PYTHON_PRESENT=no
	elif [ "$PYTHONCONFIG_PRESENT" = "no" ]; then
	    gagenv_message "$GAG_PYTHON_EXE-config utility not found"
	    PYTHON_PRESENT=no
	elif [ "$GAG_TARGET_KIND" = "linux" ] || [ "$GAG_TARGET_KIND" = "darwin" ] || [ "$GAG_TARGET_KIND" = "cygwin" ]; then
	    # Detect the libraries and add them to paths ONLY if system is supported
	    if [ "$PYTHON_INC" = "yes" -a "$PYTHON_LIB" = "yes" ]; then
		gagenv_message "Found python $GAG_PYTHON_VERSION header  in $PYTHON_INC_DIR"
		gagenv_message "Found python $GAG_PYTHON_VERSION library in $PYTHON_LIB_DIR"
		if [ "$NUMPY_PRESENT" = "yes" ]; then
		    GAG_LIB_DEP_PATH=$GAG_LIB_DEP_PATH:$PYTHON_LIB_DIR
		    GAG_INC_DEP_PATH=$GAG_INC_DEP_PATH:$PYTHON_INC_DIR
		    if [ "$NUMPY_PRESENT" = "yes" ]; then
			gagenv_message "Found Numpy python package"
			if [ "$NUMPY_INC_PRESENT" = "yes" ]; then
			    gagenv_message "Found Numpy header file in $NUMPY_INC_DIR"
			    PYTHON_PRESENT=yes
			else
			    gagenv_message "Numpy header file not found"
			    PYTHON_PRESENT=no
			fi
		    fi
		    if [ "$PYTHON_PRESENT" = "no" ]; then
			# We already found a condition not satisfied
			:  # Do nothing
		    elif [ "$GAG_TARGET_KIND" = "linux" ]; then
			if [ -z "$GAG_COMPILER_FLIBS" ];  then
			    PYTHON_PRESENT=no
			    gagenv_message "Undefined library associated to $GAG_COMPILER_FEXE"
			else
			    PYTHON_PRESENT=yes
			fi
		    fi
		else
		    PYTHON_PRESENT=no
		    gagenv_message "Numpy python package not found"
		fi
	    else
		if [ "$PYTHON_INC" = "no" -a "$PYTHON_LIB" = "no" ]; then
		    gagenv_message "PYTHON $GAG_PYTHON_VERSION library and header files not found"
		elif [ "$PYTHON_INC" = "no" ]; then
		    gagenv_message "PYTHON $GAG_PYTHON_VERSION header file not found"
		else
		    gagenv_message "PYTHON $GAG_PYTHON_VERSION library file not found"
		fi
		gagenv_message "Missing Python Development package for your system?"
		PYTHON_PRESENT=no
	    fi
            gagenv_message "You will have access to the Python port of GILDAS"
	else
	    PYTHON_PRESENT=no
	    gagenv_message "Python not supported on $GAG_TARGET_KIND"
	fi
	if [ "$DISABLE_PYTHON" = "yes" -o "$PYTHON_PRESENT" = "no" ]; then
	    gagenv_message "WARNING: GILDAS Python binding will *not* be available"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	#
	# Clean local variables
	unset  PYTHON_VERS    PYTHON_SUPPORTED
	unset  PYTHON_INC     PYTHON_LIB
	unset  PYTHON_INC_DIR PYTHON_LIB_DIR
	unset  NUMPY_INC_DIR  NUMPY_INC_PRESENT
	unset  SETUPTOOLS_PRESENT PYTHONCONFIG_PRESENT
    }
    #
    gagenv_detect_weeds() {
	# Check if Weeds can be enabled or not
	#
	# Detection
	if [ "$PYTHON_PRESENT" = "no" ]; then
	    WEEDS_PRESENT=no
	elif [ "$SQLITE3_PRESENT" = "no" ]; then
	    gagenv_message "sqlite3 Python module not found (required by Weeds)"
	    WEEDS_PRESENT=no
	else
	    WEEDS_PRESENT=yes
	fi
	#
	# Feedback
	if [ "$WEEDS_PRESENT" = "yes" ]; then
	    gagenv_message "You will have access to the Weeds extension of Class"
	else
	    gagenv_message "WARNING: You will not have access to the Weeds extension of Class"
	    gagenv_warnings=$((gagenv_warnings+1))
	fi
	#
	unset SQLITE3_PRESENT  # Not needed anymore
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    GAGENV_SEARCH_PATH=$GAG_SEARCH_PATH
    GAGENV_CCOMPILER="default" # Default C compiler will be setup by gagdefsys
    GAGENV_FCOMPILER="default" # Default Fortran compiler will be setup by gagdefsys
    GAGENV_CXXCOMPILER="default" # Default C++ compiler will be setup by gagdefsys
    GAGENV_CONFIG="default"
    GAGENV_TARGET="default"
    DISABLE_PYTHON=no
    gagusedir=
    gagenv_option_x11="no"
    temp=`getopt "hvpb:c:d:n:o:u:s:t:x" "$@"`
    if [ $? -ne 0 ]; then gagenv_usage; \return 1; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
        case $1 in
        -p) GAG_PROTO="yes" ;;
        -b) GAGENV_CCOMPILER=$2; shift ;;
        -c) GAGENV_FCOMPILER=$2; shift ;;
        -d) GAGENV_CXXCOMPILER=$2; shift ;;
        -n) gagenv_add_config no_$2; shift ;;
        -o) gagenv_add_config $2; shift ;;
        -u) if [ $2 != "default" ]; then gagusedir=$2; fi; shift ;;
        -s) GAGENV_SEARCH_PATH=$2; shift ;;
        -t) GAGENV_TARGET=$2; shift ;;
        -x) gagenv_option_x11="yes" ;;
        -v) gagenv_showversion; \return 0 ;;
        -h) gagenv_usage; \return 0 ;;
        esac
        shift # Next flag
    done
    shift # Skip double dash
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    # And go on
    #
    export gagusedir
    #
    echo
    #
    #######################################################################
    #
    # Definition of gagsrcdir, gagadmdir, gagintdir, gagexedir,
    # GAG_ROOT_DIR, GAG_VERS, GAG_EXEC_SYSTEM, GAG_PROTO
    #
    if [ -z "$gagsrcdir" ]; then
        gagsrcdir=`pwd`
    elif [ ! -d "$gagsrcdir" ]; then
        gagenv_error "\$gagsrcdir=$gagsrcdir does not exist"
        gagenv_clean
        echo
        \return 1
    fi
    if [ -z "$ogagsrcdir" ]; then
        ogagsrcdir=$gagsrcdir
    fi
    export gagsrcdir ogagsrcdir
    #
    if [ -d "$gaghome/gildas-admin" ]; then
        gagadmdir=$gaghome/gildas-admin
    elif [ -d "$gagsrcdir/admin" ]; then
        gagadmdir=$gagsrcdir/admin
    else
        gagenv_error "Failed to define \$gagadmdir."
        gagenv_error "Please define \$gagsrcdir by hand and load $GAGENV_PROGNAME again."
        gagenv_clean
        echo
        \return 1
    fi
    export gagadmdir
    #
    if [ `echo $gagsrcdir | grep -c "gildas-src"` -ne 0 ]; then
        gagexedir=`echo $gagsrcdir | \sed -e "s&gildas-src&gildas-exe&g"`
        if [ `basename $gagexedir | grep -c "gildas-exe"` -eq 0 ]; then
            gagexedir=`dirname $gagexedir`
        fi
    else
        gagexedir=`dirname $gagsrcdir`/gildas-exe
    fi
    export gagexedir
    #
    if [ -z $gagusedir ]; then
        GAG_VERS=`cat $gagsrcdir/VERSION`
    else
        GAG_VERS=`cat $gagusedir/etc/VERSION`
    fi
    export GAG_VERS
    #
    . $gagadmdir/define-system.sh                                 # Load gagdefsys function
    gagdefsys -s -b $GAGENV_CCOMPILER -c $GAGENV_FCOMPILER  -d $GAGENV_CXXCOMPILER \
      -o $GAGENV_CONFIG -t $GAGENV_TARGET || \return $?  # Use it
    unset gagdefsys                                               # Remove gagdefsys function
    #
    gagintdir=$gagsrcdir/integ
    export gagintdir
    #
    GAG_ROOT_DIR=$gagintdir
    export GAG_ROOT_DIR
    #
    if [ -z "$GAG_PROTO" ]; then
        GAG_PROTO="no"
    fi
    export GAG_PROTO
    #
    gagenv_message "Selecting GILDAS version: $GAG_VERS, source tree, $GAG_EXEC_SYSTEM"
    gagenv_message ""
    if [ "$GAG_PROTO" = "yes" ]; then
        gagenv_message "Prototypes will also be compiled"
        gagenv_message ""
    fi
    if [ ! -z "$gaghome" ]; then
        gagenv_message "gaghome  :  $gaghome"
    fi
    gagenv_message "gagadmdir:  $gagadmdir"
    gagenv_message "gagsrcdir:  $gagsrcdir"
    gagenv_message "gagexedir:  $gagexedir"
    gagenv_message "gagintdir:  $gagintdir"
    if [ ! -z $gagusedir ]; then
        gagenv_message "gagusedir:  $gagusedir"
    fi
    gagenv_message ""
    #
    #######################################################################
    #
    # PRINT command
    #
    gagenv_errors=0
    gagenv_warnings=0
    #
    if \which lpr > /dev/null 2>&1; then
        GAG_LPR=`\which lpr`" -P"
    elif \which lp > /dev/null 2>&1; then
        GAG_LPR=`\which lp`" -c -d"
    else
        gagenv_message "WARNING: No printing command found (lpr,lp)"
        gagenv_message ""
        gagenv_warnings=$((gagenv_warnings+1))
        GAG_LPR="echo \"Error: Printing command not found for printer \""
    fi
    export GAG_LPR
    #
    #######################################################################
    #
    # GILDAS dependencies
    #
    unset CFITSIO_PRESENT ATM2009_PRESENT ATM2016_PRESENT OPENSSL_PRESENT
    unset FFTW3_PRESENT FFTW3F_PRESENT
    unset PNG_PRESENT GTK2_PRESENT GTK3_PRESENT
    if [ "$DISABLE_PYTHON" = "no" ]; then
        unset PYTHON_PRESENT NUMPY_PRESENT SQLITE3_PRESENT WEEDS_PRESENT
    fi
    #
    # Default library locations
    if [ "${GAG_TARGET_KIND}" = "mingw" ]; then
        # Mingw: no libraries to be detected. Compiler searches implicitly
        # in /usr/x86_64-w64-mingw32/sys-root/mingw/lib when needed.
        LIB_PATH=
    else
        # Linux or Cygwin (32 or 64 bits: no general rule)
        LIB_PATH=/usr/lib:/usr/local/lib
        if [ $gagenv_option_x11 = "yes" ]; then
            LIB_PATH=$LIB_PATH:/usr/X11R6/lib:/usr/X11/lib
        fi
    fi
    #
    # Header locations under 32/64 bits linux. Add user's $GAG_SEARCH_PATH.
    INC_PATH=`echo $LIB_PATH:$GAGENV_SEARCH_PATH | \sed -e "s&lib&include&g"`
    #
    if [ "$GAG_MACHINE" = "x86_64" ] && [ -d "/usr/lib64" ]; then
        # Machine is 64 bits and libraries are in "lib64" directories
        LIB_PATH=`echo $LIB_PATH | \sed -e "s&lib&lib64&g"`
    elif [ "$GAG_MACHINE" = "pc" ] && [ -d "/usr/lib32" ]; then
        # Machine is 32 bits and libraries are in "lib32" directories
        LIB_PATH=`echo $LIB_PATH | \sed -e "s&lib&lib32&g"`
    fi
    # Add user's $GAG_SEARCH_PATH, but only after converting lib into lib64.
    LIB_PATH=$LIB_PATH:$GAGENV_SEARCH_PATH
    #
    # Check availability of various dependencies, and fill corresponding
    # environment variables:
    #
    unset GAG_LIB_DEP_PATH GAG_INC_DEP_PATH  # Incremented by detection functions
    #
    gagenv_detect_openmp
    gagenv_message ""
    gagenv_detect_atm
    gagenv_message ""
    gagenv_detect_python
    gagenv_detect_weeds  # Must appear after Python detection
    gagenv_message ""
    gagenv_detect_openssl
    gagenv_message ""
    gagenv_detect_cfitsio
    gagenv_message ""
    if [ $gagenv_option_x11 = "yes" ]; then
        gagenv_detect_x11    # Comes after customizable dependencies (Python and CFITSIO)
        gagenv_message ""
    fi
    gagenv_detect_gtk
    gagenv_message ""
    gagenv_detect_png
    gagenv_message ""
    # Below, the dependencies for which we only need the runtime libraries
    # (i.e. no include). This ensures that the previous dependencies have
    # their LIB_PATH and INC_PATH set symmetricaly in the corresponding
    # $GAG_LIB_*_PATH
    gagenv_detect_legacy
    gagenv_message ""
    #
    # Discard /usr/lib, /usr/lib32, and /usr/lib64 paths from $GAG_LIB_DEP_PATH
    # They are found implicitly at compilation time, and we should avoid adding
    # or move them in user's $LD_LIBRARY_PATH at execution time as this tends to
    # break user environment.
    # Note 1: do not use redefine-path which has difficulties to remove a path
    #         (or to replace it with nothing).
    # Note 2: the first trailing column below eases removal of "/usr/lib" and
    #         only "/usr/lib" (not /usr/lib/foo replaced by /foo).
    # Note 3: actually we should automatize the list of implicit paths to be
    #         removed by looking at /etc/ld.so.conf and/or use e.g. ldconfig -v
    GAG_LIB_DEP_PATH=`echo $GAG_LIB_DEP_PATH: | sed -e "s%/usr/lib:%:%g"`
    GAG_LIB_DEP_PATH=`echo $GAG_LIB_DEP_PATH  | sed -e "s%/usr/lib[36][24]:%:%g"`
    GAG_LIB_DEP_PATH=`echo $GAG_LIB_DEP_PATH  | sed -e "s%/usr/lib/x86_64-linux-gnu:%:%g"`
    #
    # Filter out directories appearing twice or more
    GAG_LIB_DEP_PATH=`${gagadmdir}/redefine-path ":" "${GAG_LIB_DEP_PATH}"`
    GAG_INC_DEP_PATH=`${gagadmdir}/redefine-path ":" "${GAG_INC_DEP_PATH}"`
    #
    export CFITSIO_PRESENT ATM2009_PRESENT ATM2016_PRESENT OPENSSL_PRESENT
    export FFTW3_PRESENT FFTW3F_PRESENT
    export PNG_PRESENT GTK2_PRESENT GTK3_PRESENT
    if [ "$DISABLE_PYTHON" = "no" ]; then
        export PYTHON_PRESENT NUMPY_PRESENT WEEDS_PRESENT
    fi
    if [ "$GAG_TARGET_KIND" = "darwin" ] && [ "$GTK3_PRESENT" = "yes" ]; then
        # Avoid a bug in the GTK3 backend of XQuartz on MacOS. For the
        # execution branch, this is set by the bash_profile.src/login.src
        # scripts.
        export GDK_RENDERING="image"
    fi
    #
    #######################################################################
    #
    # Warnings
    #
    if [ "$GAG_MACHINE" = "pc" ]; then
        gagenv_message "You will build 32 bits binaries. THIS IS OBSOLESCENT."
        gagenv_message "CLIC (the NOEMA calibration software) will *not* be available."
        gagenv_message ""
        gagenv_warnings=$((gagenv_warnings+1))
    fi
    #
    if \which anaconda > /dev/null 2>&1; then
        # Anaconda is installed in user's $PATH
        if [ `which anaconda | grep -c "$HOME"` -eq "1" ]; then
            # This seems to be a local installation => breaks 3rd party software
            gagenv_message "WARNING: Found an anaconda installation under your user account"
            gagenv_message "This is likely to break Gildas compilation and/or execution"
            gagenv_message "See www.iram.fr/~gildas/dist/gildas.README > Troubleshooting for details"
            gagenv_message ""
            gagenv_warnings=$((gagenv_warnings+1))
        fi
    fi
    #
    #######################################################################
    #
    # Defaults
    #
    if [ "$GTK2_PRESENT" = "yes" ] || [ "$GTK3_PRESENT" = "yes" ]; then
        GAG_WIDGETS="GTK"
    else
        GAG_WIDGETS="NONE"
    fi
    gagenv_message "Default widget library used: $GAG_WIDGETS"
    if [ "$GAG_WIDGETS" = "NONE" ]; then
        gagenv_message "*** THIS MEANS NO WIDGET SUPPORT ***"
    fi
    gagenv_message ""
    export GAG_WIDGETS
    #
    #
    if [ -z "$GAG_OBSERVATORY" ]; then
        GAG_OBSERVATORY="NOEMA"
    fi
    export GAG_OBSERVATORY
    gagenv_message "Default observatory used: $GAG_OBSERVATORY"
    gagenv_message ""
    #
    #
    if [ -z "$GAG_PAPER_SIZE" ]; then
        GAG_PAPER_SIZE="A4"
    fi
    export GAG_PAPER_SIZE
    gagenv_message "Default paper size: $GAG_PAPER_SIZE"
    gagenv_message ""
    #
    #######################################################################
    #
    # Create integration tree (existing directories needed by redefine-path)
    #
    GAG_INT_ROOT_DIR=$gagintdir/$GAG_EXEC_SYSTEM
    GAG_INT_INC_DIR=$GAG_INT_ROOT_DIR/include
    mkdir -p $GAG_INT_INC_DIR
    GAG_INT_LIB_DIR=$GAG_INT_ROOT_DIR/lib
    mkdir -p $GAG_INT_LIB_DIR
    GAG_INT_BIN_DIR=$GAG_INT_ROOT_DIR/bin
    mkdir -p $GAG_INT_BIN_DIR
    GAG_INT_PYTHON_DIR=$GAG_INT_ROOT_DIR/python
    mkdir -p $GAG_INT_PYTHON_DIR
    GAG_INT_TASKTEX_DIR=$gagintdir/doc/tasks
    mkdir -p $GAG_INT_TASKTEX_DIR
    if [ ! -z "$gagusedir" ]; then
        GAG_USE_ROOT_DIR=$gagusedir
        GAG_USE_INT_ROOT_DIR=$GAG_USE_ROOT_DIR/$GAG_EXEC_SYSTEM
        GAG_USE_LIB_DIR=$GAG_USE_INT_ROOT_DIR/lib
        # define GAG_LOCAL_ROOT_DIR
        GAG_LOCAL_ROOT_DIR=$GAG_ROOT_DIR
        export GAG_LOCAL_ROOT_DIR
        # redefine GAG_ROOT_DIR
        GAG_ROOT_DIR=$GAG_USE_ROOT_DIR
    else
        unset GAG_USE_ROOT_DIR
        unset GAG_USE_INT_ROOT_DIR
        unset GAG_USE_LIB_DIR
        unset GAG_LOCAL_ROOT_DIR
    fi
    #
    #######################################################################
    #
    # (Re)define paths
    #
    # First export standard paths to avoid surprises with redefine-path
    export LD_LIBRARY_PATH PATH PYTHONPATH TEXINPUTS
    #
    gagenv_message "(Re)definition of GAG_GAG and GAG_PATH"
    GAG_GAG=$HOME/.gag
    GAG_PATH=$gagintdir/etc
    if [ "${GAG_ENV_KIND}-${GAG_TARGET_KIND}" = "cygwin-mingw" ]; then
        GAG_GAG=`cygpath.exe -w $GAG_GAG`
        GAG_PATH=`cygpath.exe -w $GAG_PATH`
    fi
    #
    # LD_LIBRARY_PATH  is used at run time
    # GAG_LIB_DEP_PATH is used to produce kernel/admin/bash_profile
    # GAG_LIB_PATH     is used to find dependencies of targets by the makefile system
    # GAG_LIB_FLAGS    is used by the link commands of the makefiles
    gagenv_message "(Re)definition of GAG_LIB_FLAGS and LD_LIBRARY_PATH"
    if [ ! -z "$GAG_USE_LIB_DIR" ]; then
        DIRLIST=$GAG_LIB_DEP_PATH:$GAG_USE_LIB_DIR:$GAG_INT_LIB_DIR # Order is important here!
    else
        DIRLIST=$GAG_LIB_DEP_PATH:$GAG_INT_LIB_DIR # Order is important here!
    fi
    LD_LIBRARY_PATH=`${gagadmdir}/redefine-path -o "${ogagsrcdir}" -n "${gagsrcdir}" -k LD_LIBRARY_PATH "${DIRLIST}"`
    GAG_LIB_PATH=`${gagadmdir}/redefine-path -o "${ogagsrcdir}" -n "${gagsrcdir}" ":" "${DIRLIST}"`
    GAG_LIB_FLAGS=`echo ${GAG_LIB_PATH} | \sed -e "s&:& -L&g" -e "s&^&-L&"`
    #
    gagenv_message "(Re)definition of GAG_INC_PATH, GAG_INC_FLAGS"
    GAG_INC_PATH=`${gagadmdir}/redefine-path ":" "${GAG_INC_DEP_PATH}"`
    GAG_INC_FLAGS=`echo ${GAG_INC_PATH} | \sed -e 's&:& -I&g' -e 's&^\(.\)&-I\1&'`
    #
    gagenv_message "(Re)definition of PATH"
    DIRLIST="admin:utilities:${GAG_INT_BIN_DIR}"
    if [ "${GAG_TARGET_KIND}" = "mingw" ] || [ "${GAG_TARGET_KIND}" = "cygwin" ]; then
        # Under MS Windows (both cygwin and mingw builds), need to put dll paths in
        # $PATH so that hershey and vsop87 (mingw) or any program (cygwin) can be
        # executed at make time.
        DIRLIST="${DIRLIST}:${GAG_INT_LIB_DIR}"
    fi
    if [ ! -z "$GAG_USE_INT_ROOT_DIR" ]; then
        DIRLIST="${GAG_USE_INT_ROOT_DIR}/bin:${DIRLIST}"
    fi
    PATH=`${gagadmdir}/redefine-path -o "${ogagsrcdir}" -n "${gagsrcdir}" -k PATH "${DIRLIST}"`
    #
    gagenv_message "(Re)definition of TEXINPUTS and BSTINPUTS"
    TEXINPUTS=":"`${gagadmdir}/redefine-path -n "${gagintdir}" -k TEXINPUTS  "etc//:$GAG_INT_TASKTEX_DIR//"`
    if [ ! -z $gagusedir ]; then
        TEXINPUTS="${TEXINPUTS}:${gagusedir}/etc//"
    fi
    BSTINPUTS=":"`${gagadmdir}/redefine-path -o "${ogagsrcdir}" -n "${gagsrcdir}" -k BSTINPUTS  "utilities//"`
    #
    if [ "$DISABLE_PYTHON" = "no" -a "$PYTHON_PRESENT" = "yes" ]; then
        gagenv_message "(Re)definition of PYTHONPATH"
        PYTHONPATH=`${gagadmdir}/redefine-path -o "${ogagsrcdir}" -n "${gagsrcdir}" -k PYTHONPATH "${GAG_INT_PYTHON_DIR}"`
        # Need to add $LD_LIBRARY_PATH to $PYTHON_LIB_DEP_PATH, because:
        # - we need $GAG_LIB_PATH (added above in $LD_LIBRARY_PATH)
        PYTHON_LIB_DEP_PATH=$LD_LIBRARY_PATH
        export PYTHONPATH PYTHON_LIB_DEP_PATH
    fi
    #
    # Error and warnings summary
    gagenv_ocode=0
    gagenv_message ""
    gagenv_message "$gagenv_errors error(s) and $gagenv_warnings warning(s) detected"
    if [ $gagenv_errors -ne 0 ]; then
        gagenv_ocode=1
        gagenv_message "GILDAS will not compile"
    elif [ $gagenv_warnings -ne 0 ]; then
        gagenv_message "GILDAS will compile with some optional features disabled"
    else
        gagenv_message "You are ready to compile GILDAS"
    fi
    #
    unset  GAG_INC_DEP_PATH
    export GAG_LIB_DEP_PATH GAG_GAG GAG_PATH
    export GAG_LIB_PATH GAG_LIB_FLAGS
    export GAG_INC_PATH GAG_INC_FLAGS
    export PATH LD_LIBRARY_PATH TEXINPUTS BSTINPUTS
    #
    #######################################################################
    #
    # Cleaning
    #
    echo
    gagenv_clean
    \return $gagenv_ocode
}
#
###########################################################################
#
gagenv $@
ocode=$?
set abc; shift # This line to avoid remanence effect in a portable way
\return $ocode
#
###########################################################################

# Installation Guidelines

## Table of contents

- [I - RELEASE NOTES](#i---release-notes)
- [II - DOWNLOAD](#ii---download)
  - [1 - Sources from homepage](#1---sources-from-gildas-homepage)
  - [2 - Sources from GIT repository](#2---sources-from-git-repository)
  - [3 - Documentation from homepage](#3---documentation-from-gildas-homepage)
- [III - REQUIREMENTS](#iii---requirements)
  - [1 - Supported systems](#1---supported-systems)
  - [2 - Material](#2---material)
  - [3 - Tools to build executables](#3---needed-tools-to-build-executables-from-sources)
  - [4 - Tools to build documentation](#4---needed-tools-to-build-the-documentation)
- [IV - INSTALL UNDER MACOS](#iv---install-under-macos)
  - [1 - Prerequisites](#1---prerequisites)
  - [2 - MacPorts package](#2---macports-package)
  - [3 - Installation from sources](#3---installation-from-sources)
  - [4 - Troubleshooting](#4---troubleshooting)
- [V - INSTALL UNDER LINUX](#v---install-under-linux)
  - [1 - Dependencies](#1---dependencies)
  - [2 - Compile and install (binaries)](#2---compile-and-install-binaries)
  - [3 - Post-installation (binaries)](#3---post-installation-binaries)
  - [4 - Compile/install documentation](#4---compile-andor-install-documentation)
  - [5 - Troubleshooting](#5---troubleshooting)
- [VI - INSTALL UNDER MS WINDOWS](#vi---install-under-ms-windows)
- [VII - UNINSTALL](#vii---uninstall)
  - [1 - Under Linux](#1---under-linux)
  - [2 - Under MacPorts](#2---under-macports)

---

## I - RELEASE NOTES

Release notes are available in NEWS.md

## II - DOWNLOAD

### 1 - Sources from GILDAS homepage

Linux/OSX versions of GILDAS are distributed only as sources because
binaries are not portable (due to the many different possible
combinations of processors, operating system and compilers). Fetch
the sources from the [download area](https://www.iram.fr/~gildas/dist/).
You have to pick a tarball named `gildas-src-mmmyyv.tar.xz`. Some
hints:

- **VERSION**: the basic rule to pick up a release is to download and
  install the latest monthly release available in this area. Daily
  releases are there just as a convenience for beta testers. We
  strongly discourage standard users to get them.
- **LABELLING**: the suffix `a`, `b`, `c` and so on indicates that an
  important bug fix or feature has been added during the month and
  this could not wait for the new release at the beginning of next
  month. Such new releases include only these modifications, and not
  all the on-going developments. Check the NEWS section for details on
  the augmented release.
- **STABILITY**: Developers usually stabilize (if needed) Gildas before
  each release. Nevertheless, some developments take time and in such a
  case monthly releases may be skipped. From time to time some releases
  are suffixed `beta`: this indicates that important developments were
  done and this version is a candidate for a stable release. It is
  "stable as far as we know", but not tested enough.
- **REFERENCE VERSION**: Finally, the may25 release (May 2025) is a
  particular version used at the telescopes. If a newer version is
  available, standard users should not install the may25 one, unless
  they have been told to. There are bug fixes, improvements, and
  features which have been added in the latest releases, but which
  won't be in the may25 release because they do not affect the
  operations at the telescopes.

### 2 - Sources from GIT repository

Get the last monthly version from the
[public GIT repository](https://git.iram.fr/gildas/gildas):

```
git clone \
  -b ryy-mmm https://git.iram.fr/gildas/gildas.git gildas-src-mmmyy
```

This command creates the sources of GILDAS in a new
`gildas-src-mmmyy` directory. The `-b ryy-mmm` switch enables you to
choose the monthly release you need. Be careful, you here need only the
3 first letters of the current month and the last two digits of the
current year. No letter is required: you will automatically end up with
the last bug fix of this monthly release.

In practice, if you want to fetch the December 2022 sources, just
type:

```
git clone \
  -b r22-dec https://git.iram.fr/gildas/gildas.git gildas-src-dec22
```

It is also possible to update this clone at any moment:

```
cd gildas-src-dec22
git pull  # Fetch the last commits in the current branch
```

If new monthly versions have been released, you should be able to check
them out after `git pull`, e.g.

```
git checkout r23-jan  # Fetch January 2023 release
```

Do not forget to completely clean and rebuild GILDAS after an update
(`make distclean && make`).

### 3 - Documentation from GILDAS homepage

Compiled documentation are also distributed as tarballs in the
[download area](https://www.iram.fr/~gildas/dist/). You have to
pick a tarball named `gildas-doc-mmmyy.tar.xz`.

## III - REQUIREMENTS

### 1 - Supported systems

GILDAS compiles successfully and is (at least minimally) tested on:

| Processor             | Operating system | Environment |
| --------------------- | ---------------- | ----------- |
| x86_64                | Linux            | Native      |
| x86_64 (Intel)        | macOS            | Native      |
| x86_64 (Intel)        | macOS            | MacPorts    |
| arm64 (Apple Silicon) | macOS            | Native      |
| arm64 (Apple Silicon) | macOS            | MacPorts    |

The reference system at IRAM is Debian 12 (x86_64) with Intel Fortran
2021 and gfortran 12.2.0.

### 2 - Material

- Building the GILDAS binaries under Linux or Mac OSX requires about
  300 MB of temporary disk space (compilation) and 100 MB of permanent
  disk space (installation).
- The gfortran compiler might require up to 5-6 GB of RAM when compiling
  GILDAS sources. At run time, GILDAS executables require about 1 MB at
  startup, but then consume as much memory as data created or loaded in
  memory.

### 3 - Needed tools to build executables from sources

Successful building of GILDAS binaries on a UNIX/Linux/OSX system
minimally requires:

- Bourne compatible shell (sh, ksh, bash, etc...) for build purpose
  only. The end-users can then use the GILDAS programs from csh-like or
  Bourne-like shells.
- NROFF for on-line help building.
- Perl for automatic interface extraction during compilation process.
- A C compiler (either GCC or the native C compiler).
- GNU make:
  The current building system is using the GNU make facility which has
  some desirable but non-portable features (i.e. including makefiles,
  conditions). This does not seem a strong limitation as it is easy to
  install GNU make for your system. In fact, GNU make is the default
  for linux boxes. For others OS, just try to type `gmake` instead of
  `make`: it is probably already installed.
- A FORTRAN 90/95/2003/2008/2013 compiler:
  Latest GNU Fortran (gfortran >= 9.0) and Intel Fortran Compiler
  (ifort > 11.1) are supported.
- GTK >= 3.24 development tools for graphic and widget support. GTK2
  support is obsolescent.
- Python >= 3.6 and its array module Numpy if you plan to use the
  Gildas-Python binding, including the Weeds package in CLASS.
- CFITSIO if you plan to use MRTCAL or CUBE.

### 4 - Needed tools to build the documentation

Successful building of PDF/HTML documentation minimally requires recent
versions of:

- ps2epsi
- epstopdf
- latex (version 2e with makeidx, graphicx and html package)
- latex2html
- pdflatex

For your convenience, we distribute compiled PDF/HTML documentation in
case you do not have those tools. See the distribution section of the
GILDAS web page:

`https://www.iram.fr/~gildas/dist/`

## IV - INSTALL UNDER MACOS

Gildas and its dependencies can be installed as a
[MacPorts](https://ports.macports.org/port/gildas/) package.

### 1 - Prerequisites

Both installation methods 2 and 3 below require the installation of:

- Xcode, needed by MacPorts. Get it from
  https://developer.apple.com/xcode/ with an Apple identifier (more
  than 1 GB to be downloaded from the app store). See e.g. the Xcode
  installation guidelines suited for MacPorts at
  www.macports.org/install.php
- Xquartz, needed for Gildas plots (www.xquartz.org). XQuartz is
  successfully installed if the command `xclock` is available and opens
  a clock in a small graphical window. If not, start Xquartz from
  Applications > Utilities > XQuartz.
- [MacPorts](https://www.macports.org), a package manager, is needed to
  retrieve and install transparently Gildas and its dependencies.
  Follow MacPorts
  [installation guidelines](https://www.macports.org/install.php).
  MacPorts is successfully installed when e.g. the command `port help`
  is available.

### 2 - MacPorts package

Gildas is available as a standard package in the MacPorts distribution.
Unless you are an advanced user (see below: Installation from sources),
this is the recommended way to install Gildas under Mac OS. Once
MacPorts and XQuartz are installed, Gildas installation is
straightforward. Type:

```
sudo port install gildas
```

The parallelization is enabled by default. The Gildas programs are
ready to use right after (type e.g. `greg` in a terminal prompt).
Usually the package is updated a few days after a source release (every
month), so that the latest enhancements or bug fixes in Gildas are
quickly available to Mac users. Updating to the newest release is done
with the command:

```
sudo port upgrade gildas
```

You might need to update MacPorts itself first:

```
sudo port selfupdate
```

### 3 - Installation from sources

As an alternate solution, it is possible to compile Gildas by yourself.
You have to use MacPorts to install first the Gildas dependencies.

- Installing the dependencies:

```
sudo port install gcc14
sudo port select gcc # show available arguments
sudo port select gcc mp-gcc14  # Choose the desired one
sudo port install gtk3
sudo port install pkgconfig
sudo port install groff
```

- CFITSIO is needed for CUBE (position-position-velocity cube analysis)
  and MRTCAL (the 30m calibration software). Have a look at:

```
sudo port variants cfitsio
```

Then install the correct "variant" e.g.

```
sudo port install cfitsio +gcc14
```

- Finally you can follow the standard Linux steps to compile Gildas
  from the sources (see below).

### 4 - Troubleshooting

- If you have problem with rsync when running `sudo port selfupdate`,
  you can modify the file
  `/opt/local/etc/macports/sources.conf` by replacing the line:

```
rsync://rsync.macports.org/release/ports/ [default]
```

with:

```
#rsync://rsync.macports.org/release/ports/ [default]
https://www.macports.org/files/ports.tar.gz [default]
```

and run `sudo port sync` instead of `sudo port selfupdate`.

```
sudo port install gcc14
sudo port install gtk3
sudo port select gcc # show available arguments
sudo port select gcc mp-gcc14
```

- Mac OSX 10.7 (Lion) users: if possible, try to avoid to install
  Python from MacPorts. If installed, you might experience this bug
  when the Gildas-Python binding is started at runtime. If so, you
  should configure your system to prefer the Apple-Python rather than
  the MacPorts-Python:

```
port select python python27-apple
```

However, note that this may break other Python-related applications
installed with MacPorts.

- If the Gildas installation fails and the log file shows the
  following error:

```
:info:build FATAL:/opt/local/bin/../libexec/as/x86_64/as:
I don't understand 'm' flag!
```

This problem is described here:
https://trac.macports.org/ticket/56919
In short, the assembler program (`as`) which is used is not the correct
one. Type:

```
sudo port install cctools +xcode
```

to switch to the correct version. Then you can resume the Gildas
installation.

- If the Gildas installation fails and the log file shows the
  following error:

```
:info:build ld: unexpected token: !tapi-tbd-v3 file
'/System/Library/Frameworks//CoreFoundation.framework/CoreFoundation.tbd'
for architecture x86_64
```

This problem is described here:
http://mac-os-forge.2317878.n4.nabble.com/linker-errors-ld-unexpected-token-tapi-tbd-v3-file-td363061.html#a363073
In short, you should type:

```
sudo port install ld64 +ld64_xcode
```

Then you should retry Gildas installation. You should clean the
previous attempt first:

```
sudo port clean gildas
```

Then proceed:

```
sudo port install gildas + any option if needed
```

- If the program won't open any graphical window and shows this
  warning instead:

```
Gtk-WARNING **: xx:xx:xx.xxx: cannot open display
```

check that XQuartz server is installed and running (see Prerequisites
section above).

- If you observe this message when opening a Gildas program, please
  see the same TROUBLESHOOTING section for Linux:

```
Gtk-WARNING **: Locale not supported by C library.
                Using the fallback 'C' locale.
```

- GREG hardcopies to PDF are ensured through system utilities ps2pdf
  and epstopdf. They can be installed thanks to the following ports:

```
sudo port install texlive-basic      # provides ps2pdf
sudo port install texlive-fontutils  # provides epstopdf
```

## V - INSTALL UNDER LINUX

### 1 - Dependencies

Linux version of GILDAS are distributed only as sources because binaries
are not portable (due to the many different possible combinations of
processors, operating system and compilers). We thus tried to ease
building as much as possible.

In addition to the standard developer tools (make, gcc, nroff, etc),
the following dependencies must be installed. Root privileges are
required here.

- Fedora 42 (or redhat-like distributions):
  - Required: `dnf install gcc-gfortran gcc-c++ gtk3-devel`
  - Recommended:
    `dnf install python-devel python-setuptools numpy \
                 libpng-devel cfitsio-devel openssl-devel \
                 texlive-epstopdf`
  - Optional: `dnf install fftw-devel`
  - Install: follow installation steps at paragraph 2

- Ubuntu 24.04 (or debian-like distributions):
  - Required: `sudo apt install gfortran g++ libgtk3.0-dev`
  - Recommended:
    `sudo apt install python3-dev python3-numpy python3-setuptools \
                     libcfitsio-dev libssl-dev texlive-font-utils`
    If you choose to install the package `python-is-python3` for your
    convenience, you have to install `python-dev-is-python3` for
    consistency.
  - Optional: `sudo apt install libfftw3-dev`
  - Install: follow installation steps at paragraph 2

### 2 - Compile and install (binaries)

Building the binaries should just need the following sequence of
commands. Gildas itself does not need root privileges for installation
and execution: it can be unzipped anywhere and installed by any user
for its own needs.

```
unxz gildas-src-mmmyya.tar.xz
tar -xf gildas-src-mmmyya.tar
```

or even simpler, let tar uncompress the archive by itself (automatic
detection from the file extension):

```
tar -xf gildas-src-mmmyya.tar.xz
cd gildas-src-mmmyya
```

At this stage, if you are not under a sh-compatible shell, you have to
switch to e.g. bash. Then load the compilation environment:

```
source admin/gildas-env.sh
```

You can optionally add the compiler to be used with the option `-c`
(e.g. `source admin/gildas-env.sh -c gfortran`). Read carefully the
messages and warnings returned by the command. If everything seem
correct, then compile and install Gildas:

```
make
make install
```

Finally, follow the instructions at the end of the `make install`
process. Installation is successful if you can start the programs
`greg` or `class` from a new terminal.

### 3 - Post-installation (binaries)

After the installation is successful, you can optionally remove the
sources and compilation directory (`gildas-src-mmmyy`). This is useful
only to save disk space. On the other hand, this means that in case of
update (e.g. for GIT-based downloads) you will have to recompile
everything again from scratch.

### 4 - Compile and/or install (documentation)

- From the tarball archive (easiest):

```
mv gildas-doc-mmmyya.tar.xz gildas-exe-mmmyya/
cd gildas-exe-mmmyya/
tar -xf gildas-doc-mmmyya.tar.xz
```

- Directly from the sources:
  Compilation of documentation is not done by default when compiling
  executables because: i) it requires special tools (see requirements)
  and ii) it takes time.
  To compile and install the PDF documentation, type:

```
make doc
make install-doc
```

To compile and install the HTML documentation, please type:

```
make html
make install-html
```

### 5 - Troubleshooting

- This message can be displayed when starting a Gildas program:

```
Gtk-WARNING **: Locale not supported by C library.
                Using the fallback 'C' locale
```

This is not a GILDAS issue. This means that your locale settings (type
`locale` in a terminal) indicate one or more locales that are not
installed on your system (type `locale -a` in a terminal for the full
list). You should fix your environment variables in order to use an
installed locale (e.g. `export LANG=en_US.utf8`, beware this may change
your programs behavior regarding language), or install the missing
locale(s).

- Conflict with Anaconda: when installed from the downloadable
  installer, Anaconda comes with a lot of development tools and
  libraries which override the default system ones, but not in a
  consistent way. This is proved to break software compilation and/or
  execution (Gildas and others). For example:

```
astro: /home/user/anaconda/lib/libstdc++.so.6: version
       `GLIBCXX_3.4.21' not found (required by /home/user/
       gildas-exe-jan17a/x86_64-ubuntu16.04-gfortran/lib/libatm.so)
```

This happens because Anaconda gives precedence to its own binaries and
include files (duplicate but different versions of system ones) in the
user's environment. There are several ways out of this issue:
  - a) Install Anaconda from your OS repositories (instead of custom
       installation in the user account). This way, there should be a
       correct integration of Anaconda within the OS.
  - b) Keep Anaconda in the user account, but "hide" it during Gildas
       installation and execution. In other words, you have to ensure
       that there is no reference to Anaconda installation paths in the
       environment variables `$PATH` and `$LD_LIBRARY_PATH`. You most
       likely have to edit your `~/.bashrc`. Once this is done recompile,
       install, and try executing Gildas. If it runs fine, a permanent
       solution could be to use a shell function which loads Anaconda
       environment only when needed, e.g.

```
function anaconda() {
    export PATH=...
    export LD_LIBRARY_PATH=...
    anaconda
}
```

  - c) The next time you install Anaconda, you should answer "No" to the
       question: "Do you wish the installer to prepend the
       Anaconda<2 or 3>install location to PATH...?". Then use a function
       like the above example to get it working
       ([reference](https://www.anaconda.com/docs/getting-started/working-with-conda/reference/faq#should-i-add-anaconda-to-the-macos-or-linux-path)).

## VI - INSTALL UNDER MS WINDOWS

MS Windows binaries are not available. If you need to run GILDAS under
a MS Windows computer, you can install a Linux virtual machine and
follow the installation instructions as explained in the previous
section.

## VII - UNINSTALL

### 1 - Under Linux

- Except if you want to save disk space, you have no need to uninstall
  any previous Gildas installation. Each version goes into its own
  `gildas-src-XXX` and `gildas-exe-XXX` directories. The default
  version used is ruled by the environment variable `$GAG_ROOT_DIR`
  that is set in user's `~/.bash_profile`. You can modify it as you
  want to point to the desired version.
- Remember to start a new terminal each time you modify your
  `~/.bash_profile`.
- For a complete uninstall of Gildas, just remove the directories
  `gildas-src-XXX` and `gildas-exe-XXX`, and suppress the lines related
  to Gildas in your `~/.bash_profile`.

### 2 - Under MacPorts

- MacPorts keeps older Gildas versions when you install a new one. At
  some point you might want to clean all the useless versions. You can
  check for all installed version with:

```
sudo port installed gildas
```

You will see a list of versions with a `@` name, e.g.

```
gildas @201808b_0+gcc7
gildas @201808b_0+gcc7+openmp
gildas @201809a_0+gcc7+openmp (active)
```

Uninstalling a single version can be done with e.g.

```
sudo port uninstall gildas @201808b_0+gcc7
```

Uninstalling several versions can be done with:

```
sudo port uninstall gildas
```

Answer at the prompt which versions are to be uninstalled.

- If you wish to completely uninstall MacPorts and Gildas, check
  [the MacPorts recommendations](https://guide.macports.org/chunked/installing.macports.uninstalling.html).

# Credits

## Institutes

GILDAS was initiated in 1983 at the Observatoire de Grenoble. It developed
as a collaboration between IPAG/Grenoble and IRAM. Some contributions were
developed by additional partners (LAB/Bordeaux and Obs. de Paris). Today,
the developments and maintenance is ensured by IRAM. ATM is developed and
maintained by IFF-CSIC.

Contributions from, and discussions with all GILDAS users are gratefully
acknowledged.

## Acknowledgment in publications

The GILDAS team welcomes an acknowledgment in publications using GILDAS
software to reduce and/or analyze data. Please use the
`https://www.iram.fr/IRAMFR/GILDAS/` and `https://ascl.net/1305.010`
references.

## Developers

- Infrastructure (building, distribution):
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: E. Reynier (IRAM)

- Kernel (SIC and GREG):
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: F. Badia, D. Broguière, G. Buisson, G. Duvert,
                            T. Forveille, R. Gras, S. Guilloteau, R. Lucas,
                            G. Mella, E. Reynier, P. Valiron

- CUBE:
  - In charge:              J. Pety (IRAM/Obs. de Paris), S. Bardeau (IRAM)
  - Main past contributors: V.deSouzaMagalhaes

- ASTRO:
  - In charge:              J. Boissier (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: G. Duvert, F. Gueth, S. Guilloteau, R. Lucas,
                            J.-M. Winters

- TELCAL:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM)
  - Main past contributors: S. Guilloteau (LAB), H. Wiesemeyer (IRAM)

- MRTCAL:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM), A. Sievers (IRAM)

- CLASS:
  - In charge:              S. Bardeau (IRAM)
  - Active developers:      J. Pety (IRAM/Obs. de Paris)
  - Main past contributors: B. Delforge, T. Forveille, S. Guilloteau
                            P. Hily-Blant, R. Lucas

- PIIC:
  - In charge:              S. Berta (IRAM)
  - Main past contributors: R. Zylka

- CLIC:
  - In charge:              V. Piétu (IRAM)
  - Main past contributors: F. Gueth, R. Lucas, R. Moreno, J.-M. Winters

- NOEMA science pipeline:
  - In charge:              A. Castro-Carrizo (IRAM)
  - Active developers:      R. Neri (IRAM), F. Alves (IRAM)
  - Main past contributors: S. Martin, V. Arumugam

- MAPPING:
  - In charge:              J. Pety (IRAM/Obs. de Paris)
  - Active developers:      S. Bardeau (IRAM)
  - Main past contributors: K. Bouyoucef, L. Desbats, F. Gueth, S. Guilloteau,
                            R. Lucas, N. Rodriguez-Fernandez, V.deSouzaMagalhaes

- MIRA:
  - In charge:              A. Sievers (IRAM)
  - Main past contributors: H. Wiesemeyer

# GILDAS graphic interface

## Structure

```sh  
ggtk
├── gtk-dialog.c        # Gathers methods used to create, manipulate and destroy windows and dialogs. (nothing related to the drawing part, only windows, popups, buttons, expanders...)
├── gtk-dialog.h        # Exposes the run_dialog method launched by gtk-main
├── gtk-graph.c         # List of methods manipulating the _ggtk_env structure. Exposed APIs are listed in the s_ggtk_graph_api object.
├── gtk-graph.h         # List of methods shared with other files of the ggtk module.
├── gtk-local.h         # Contains the definition of the _ggtk_env and of the _ggtk_toolbar_args structures.
├── gtk-main.c          # Entry point file starting the gtk code
├── gtk-menu.c          # Contains all the code responsible of the small window gathering additional commands (called "greg GUI" for greg tool for example)
├── gtk-menu.h          # Exposes the run_gtk_menu and kill_gtk_menu method used by gtk-main
├── gtk-toolbar.c       # Contains the run_gtk_main_loop launching the gtk main loop and additional methods used to create the main graphical window with all available commands (Pencil, Marker etc...)
├── gtk-toolbar.h       # Exposes methods used by other ggtk module files
├── magnify-tool.c      # Contains methods used to create the immersive magnify popup 
├── magnify-tool.h      # Exposes a method used to ceate the magnifying tool
├── message-c.c         # /
├── message-c.h         # /
├── zoom-tool.c         # Contains methods used to draw the zoom cursor and to create a sub window with a zoomed portion of the main window
├── zoom-tool.h         # Exposes the ggtk_activate_zoom called after launching the zoom tool
├── Makefile            # /
└── win-ggtk.def        # /
```

## Main concepts

The graphic interface is handled by C code files located under ggtk2 or ggtk3 directories.

The ggtk library exposes a list of methods which can be called by the main code principally written in fortran.  

The fortran code, run in the main thread, calls methods exposed by the ggtk library if this library is built.

The ggtk code is run in a dedicated thread.

When graphic elements are created (polylines, surfaces etc...) the main thread calls specific methods implemented by the ggtk library to draw those elements in a gtk drawing area (if any)

## Legacy graphic interface using GTK2

The ggtk library based on GTK2 is located in ggtk2 folder (next to the ggtk folder) and works as follow:
- Creation of the new thread
- Initialization of the GTK windows to build
- Call of the gkt main loop function which displays the different windows
- When a graphical component (like a polyline) is created by the main thread, a specific API is called on ggtk side to draw this element inside the active drawing area (the environment in which the graphical element needs to be displayed is passed as an argument to the draw method)

Note here that the rendering operations are synchronously executed when the main thread code calls the dedicated ggtk draw APIs.

GTK2 library is deprecated and should not be used anymore.
To build the GILDAS graphical interface using GTK2, source your environment as follow:

```sh
. admin/gildas-env.sh -o gtk2
```

## Current graphic interface based on GTK3

The ggtk library based on GTK3 works almost similarly as GTK2 for the panel creation and for the main loop process. The way elements are rendered is changed and works now with Cairo:
- Creation of the new thread
- Initialization of the GTK windows to build
- Call of the gkt main loop function which displays the different windows
- When a graphical component (like a polyline) is created by the main thread, a specific API is called on ggtk side to store this element in a buffer attached to the current graphical environment (main drawing area or the magnifying tool basically). GTK uses a draw event which basically asks to render the entire drawing area in one shot. This process, based on events, is asynchronous. When the draw callback is executed, the internal graphical element stores are used to render the view.

Note here that the rendering operations are executed asynchronously. GTK manages his own way to redraw the drawing area.
In the code we can ask for a redraw but this operation is not synchronous. It just warns GTK that a refresh of the drawing area is required.

To build the GILDAS graphical interface using GTK3, source your environment as follow:

```sh
. admin/gildas-env.sh
```

The GTK3 version of ggtk works natively on Linux (X11 / Wayland) and MacOs (X11 / XQuartz) for Intel chips only.
To make this work on MacOS computers with Arm chips (M1, M2 etc...) you also need to export the following variable before launching the application:

```sh
export GDK_RENDERING=image
```

The XQuartz + Arm chip + MacOS issue is tracked by the following ticket: https://trac.macports.org/ticket/65892?cversion=1&cnum_hist=17

### Drawing areas

GTK3 uses Cairo to draw graphical primitives such as polylines or surfaces.
All primitives are stored inside the _ggtk_env structure defined in the gtk-local.h file.
Multiple methods are declared and used to manipulate the content of those graphical primitive stores in "gtk-graph" files (polyline_init, polystore_free, etc...)

Some specific attributes of the _ggtk_env such (line_width, line_is_dashed, red, blue, green, invert, cap_style, join_style and antialiasing) are used to change the graphical properties of the next graphical elements to store in the different sub stores.

The flow is as follow:
- the ggtk_pen_rgb method is called by the main thread to set color1 (changes the red, blue and green attributes of the _ggtk_env)
- the ggtk_flush_points method is called by the main thread and adds a new polyline in the internal store of the _ggtk_env. This new polyline is saved with color1 in the _ggtk_env.
- the ggtk_pen_rgb method is called by the main thread with another: color2
- the ggtk_flush_points method is called by the main thread and adds a new polyline in the internal store of the _ggtk_env. This new polyline is saved with color2 in the _ggtk_env.

When a draw event is catched (event managed by GTK) the **draw_scene_from_genv** of the gtk-graph file is called and checks all internal graphical element stores to draw the scene.

Note that the antialiasing can be changed from the code and depends on the _ggtk_env.
For the moment no antialiasing is applied on the main window and the 'CAIRO_ANTIALIAS_BEST' antialiasing is applied for magnifying windows.

### Rendering performance model

The two latest performance commits on master changed the rendering model:
- commit `2367605c34`: offscreen scene cache + incremental chunked draw
- commit `b00edc792c`: Cairo style state cache for polylines

#### Offscreen scene cache and chunked refresh

`draw_scene_from_genv` does not redraw the full scene on each draw callback
anymore. The scene is now rendered into an offscreen Cairo surface stored in
`_ggtk_env`, then painted on screen.

Important fields in `gtk-local.h`:
- `scene_surface`, `scene_surface_width`, `scene_surface_height`
- `scene_background`
- `rendered_primitive_count`, `rendered_poly_count`, `rendered_image_count`
- `draw_pending`

Important flow in `gtk-graph.c`:
- `_ggtk_prepare_scene_surface` ensures the cache size matches the widget.
- `draw_scene_from_genv` renders only a chunk of pending primitives on each
  callback and re-queues a draw if needed.
- `_ggtk_queue_draw` prevents multiple redundant draw requests for the same
  frame.

The chunk size is controlled by `GGTK_DRAW_CHUNK` in `gtk-graph.c`.

#### Cairo style-state caching for polylines

Polyline rendering now avoids repeated Cairo state changes when style is
unchanged across consecutive polylines.

Key helpers in `gtk-graph.c`:
- `PolylineStyleState`
- `_polyline_style_matches`
- `_apply_polyline_style`

`internal_draw_polyline_or_polygon` now calls `_apply_polyline_style` before
drawing the path.

If you add a new polyline style attribute, update:
- the `Polyline` structure (if needed),
- `PolylineStyleState`,
- `_polyline_style_matches`,
- `_apply_polyline_style`.

## Next steps: GTK4

GTK4 is the latest 'LTS' version of GTK.
This last version is deeply different compared to the previous one. 
One of the key change is the fact that this library is no longer 'thread safe'.
It means that the GTK application cannot be launched in a separated thread.

The entire application management needs to be changed in order to create the main application in the main thread and handle the keyboard and the calculations in a separated thread.
